//$Id$

var ZRCloudUpload = new function()
{
	this.doUpload = function(element)
	{
		var view = ZDBClientUI.getViewObj(element,"view");      //No I18N
        if(!(ZDBClientUI.checkAskImgSave(view,"export",this)))
        {
          return;
        }
        var viewType = ZDBExport.getExportViewType(view.type);
        var viewId = view.objId;
        var exportDIV = $("ZSheetExportDIV");
        if(exportDIV == null)
        {
           AjaxAPI.sendRequest({URL:"/ZRZSheetExport.cc?OBJID="+viewId+"&VIEWTYPE="+viewType+view.viewCtx.getAdditionalParams(),
        	   ONSUCCESSFUNC:ZRCloudUpload.handleDlgFetchResp,ONFAILUREFUNC:ZRCloudUpload.handleDlgFetchFailure,
        	   "ELEMENT":element,"VIEWTYPE":viewType,"VIEWID":viewId,OPSTATUSID:"ZDBMainLoader",METHOD:"GET"}); //No I18N
           return;
        }
	}
	
	this.handleDlgFetchResp = function(response,requestOptions)
	{
		var div = document.createElement("div");
	    div.innerHTML = response.responseText;
	    document.body.appendChild(div);
		var element = requestOptions["ELEMENT"];
		var viewType = requestOptions["VIEWTYPE"];
		var viewObj = ZDBClientUI.getViewObj(element,"view");      //No I18N
		var dialogDIV = document.createElement("div");
		var exportDIV = $("ZSheetExportDIV");
	    exportDIV.style.display = "block";

	    dialogDIV.appendChild(exportDIV);
	    
	    var exportViewName = viewObj.title ? viewObj.title : viewObj.displayName;

	    var digTitle = ZDBI18NMap.g("zrpt.export.zsheet.js.dlgTtl");

	    ZDBInlineDialog.showDialog(dialogDIV,{TITLECLASS:'export',"VIEW":viewObj, TITLE:digTitle, ONENTER: ZDBExport.hackedOnEnterMethod}); //No I18N
	    
	    $("ZRZSheetExportName").value = exportViewName;
	    if(viewType == "sheet" || viewType == "report")
	    {
	      ZDBMVExportUtil.checkRUnCheckPDFSelectAll('COLUMNLIST','EXPORTALL','COLNAME'); //No I18N
	    }
	    if(!(viewType == "sheet" || viewType == "report"))
	    	{
	    		$("HIDDENROW").style.display = 'none';
	    	}
	}
	
	this.upload = function(element)
	{
		var view = ZDBClientUI.getViewObj(element,"view");      //No I18N
        var expViewType = ZDBExport.getExportViewType(view.type);
        //OUTFILE, DBID, OBJID
        var outFile = ZDBGlobal.zuID + "_" + view.objId + "_" + Math.floor(Math.random() * 10000);
        var sheetName = $("ZRZSheetExportName").value;
        if(sheetName.trim() == "")
        {
            showCustomMessage(ZDBI18NMap.g('zrpt.common.pdfexport.zdbalertmsg.js.fileNameErr'),$("ZRZSheetExportName"));
            return;
        }
        var params = ZDBExport.getExportParams(element, expViewType, "ZSHEET", false,outFile);	//No I18N
        params += ("&FILENAME=" + encodeURIComponent(sheetName));	//No I18N
        if(view.totalRecords)
        	{
        		params += "&ROWCOUNT=" + view.totalRecords;	//No I18N
        	}
		var url = ZDBGlobal.CTX + "/zrcloudupload?ZDBACTION=UPLOAD&"+params; //No I18N
		AjaxAPI.sendRequest({URL:url,
			ONSUCCESSFUNC:ZRCloudUpload.onsuccess,
			ONFAILUREFUNC:ZRCloudUpload.onfailure,
			OPSTATUSID:"ZRZSheetLoading"});	//No I18N
	}
	
	this.getExportOptions = function(viewType)
	{
		var exportOptions = "";
		exportOptions += "&HEADER=" + $("HEADER").value; //No I18N
		// Column Selection List need to be included
		if(viewType == "sheet" || viewType == "report")
	       {
		       var listTbl = $("COLUMNLIST");
		       var selectedCols = ZDBExport.getColsListForExport(listTbl);
		       if(selectedCols=="")
		        {
		            return "NO_COL_SELECTED"; //No I18N
		        }
		      exportOptions+= "&SELECTCOL=" + selectedCols;	//No I18N
	       }
		return exportOptions;
	}
	
	this.onsuccess = function(response,requestOptions)
	{
		var respText = response.responseText;
		var respObj = JSON.parse(respText);
		var status = respObj.status;
		if(status == "failure" || (respObj.error_code || respObj.error_message))
		{
	        ZDBAlertAPI.showMsg(respObj.error_message);
	        return;
		}
		ZRCloudUpload.showSuccessResult(respObj);
	}
	
	this.showSuccessResult = function(respObj)
	{
		$("ZRZSheet1").style.display = 'none';
		$("ZRZSheet2").style.display = '';
		var anchorEl = $("zsheetlink");
		anchorEl.href = respObj.sheeturl;
		anchorEl.innerHTML = respObj.sheeturl;
		$('EXPORTDATA').style.display = 'none';
		$('ZDBExportCancelBtn').value = ZDBI18NMap.g("zrpt.diabloginfo.js.close");
	}
	
	this.onfailure = function(response,requestOptions)
	{
		var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        ZDBAlertAPI.showMsg(errMsg);
	}
}
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRCloudUpload.doUpload"] = ZRCloudUpload.doUpload;
