//$Id$
var ZRConnector = new function()
{
	this.isExpanded = false;
	this.connJson = null;
	this.curConnector = null;
	this.isDlgOpened = false;

	this.hideMsgBox = function()
	{
		jQuery($("ZRConnectorMsgBox")).slideUp('slow');  //No I18N
	}
    this.keyHelp = function (el) {
        window.open(el.attributes.getNamedItem('keyurl').value, "_blank"); // No I18N
    }
	this.handleReinitSuccess = function()
	{
		ZDBDialogUtil.closeDialog();
		var el = $("ZRConnectorMsgNote");
		if(el)
		{
			var connectorName = el.getAttribute('connectorName');
			el.innerHTML = connectorName + " " + ZDBI18NMap.g("zrpt.connector.js.init_fetch_prg");
			el.style.color = "green";
			$("ZRConnectorMsgBox").className = "zpmsgbox zpmsgboxsucc";
		}
	};

	this.retryInit = function()
	{
		var connector = $("ZRConnectorMsgNote").getAttribute('connector');
		var url = "/ConnectorAction.ma?ZDBACTION=DBREINIT&DBID=" + ZDBClientUI.dbId + "&CONNECTORID=" + connector; //No I18N
		AjaxAPI.sendRequest({URL:url, ONSUCCESSFUNC:ZRConnector.handleReinitSuccess});
	};
	
	this.userCleanupAlert = function()
	{
		var connectorId_conndbInfoid = ZRConnector.curConnector;
		var connId = connectorId_conndbInfoid.split("_")[0];
		var conndbInfoid = connectorId_conndbInfoid.split("_")[1];		
		ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.conn.js.cleanupconfirmmsg"),"ZDBYESNO",//No I18N
				{ONCLICK:ZRConnector.userCleanup,CONNDBINFOID:conndbInfoid,CONNECTORID:connId},ZDBI18NMap.g("zrpt.conn.js.cleanupconfirmtitle"));    //No I18N
	}

	this.userCleanup = function(clickType,requestOptions)
	{
		if(clickType != "YES")
		{
			return;
		}
		var url = "/ConnectorAction.ma?ZDBACTION=CLEANUPFROMUSER&DBID=" + ZDBClientUI.dbId +"&CONNDBINFOID=" + requestOptions["CONNDBINFOID"] + "&CONNECTORID=" + requestOptions["CONNECTORID"]; //No I18N
		AjaxAPI.sendRequest({URL:url, ONSUCCESSFUNC:ZRConnector.handleCleanupFromUserSuccess,CONNECTORID:requestOptions["CONNECTORID"]});
	}
	
	this.handleCleanupFromUserSuccess = function(response, requestOptions) 
	{
		var params = response.getResponseParams();
		ZDBDialogUtil.closeDialog();
		ZDBMsgBox.showSuccess(ZDBI18NMap.f("zrpt.conn.js.reinit_started")); // No I18N
        $("connCleanNow").className = "ZRSLink alpha";
        $("connCleanNow").onclick = null;
		location.reload();
	}

	this.getSelectedColStr = function(mod,fieldArr)
	{
		var isFirst = true;
		var usrStr = "";
		if(fieldArr == undefined || fieldArr.length == 0)
		{
			usrStr = "";
		}
		else if(fieldArr.length == undefined)
		{
			usrStr = fieldArr.value;
		}
		else
		{
			for (var i=0; i<fieldArr.length; i++)
			{
				if (fieldArr[i].checked === true)
				{
					if(isFirst)
					{
						isFirst = false;
					}
					else
					{
						usrStr += ",";
					}
					usrStr += "\"" +  fieldArr[i].value + "\"";
				}
			}
		}
		return "\"" + mod  + "\":[" + usrStr + "]";
	};

	this.getSelectedCols = function(form, div)
	{
		var selCols="{";
		jQuery('div#' + div + ' input[type=checkbox]').each(function() {//NO I18N
			if ($(this).checked)
			{
				selCols += ZRConnector.getSelectedColStr(jQuery(this).attr('modId'),form[jQuery(this).attr('value')]) + "," ;//NO I18N
			}
		});
		selCols = selCols.substring(0, selCols.length - 1);
		selCols += "}";
		return selCols;
	};

  this.getSelectedModulesAlone = function(form, div)
  {
	  var selMods = [];
      jQuery('div#' + div + ' input[type=checkbox]').each(function() {//NO I18N
          if ($(this).checked) {
        	  selMods.push(jQuery(this).attr('value'));  //NO I18N
          }
       });
      return JSON.stringify(selMods);
  }
  

	//Schedule:

	this.toggleScheduleDiv = function(optValue)
	{
		$("ZCSchTimeDiv").style.display ="none";
		$("ZCNotScheduledHelp").style.display ="none";
		$("ZCPeriodicSchHelp").style.display = "none";
		$("ZCInstantSchHelp").style.display = "none";
		if(optValue === "none")
		{
			$("ZCNotScheduledHelp").style.display ="block";
		}
		else if(optValue === "daily")
		{
			$("ZCSchTimeDiv").style.display = "";
		}
		else if(optValue === "instant")
		{
			$("ZCInstantSchHelp").style.display = "block";
		}
		else
		{
			$("ZCPeriodicSchHelp").style.display = "block";
		}
	};

	this.setSchDetails = function()
	{
		var schType = $("ZCPRESCHTYPE").value;
		var schRepeat = $("repeatinterval");

		if(schType === "none")
		{
			schRepeat.value = "none"; //No I18N
			ZRConnector.toggleScheduleDiv(schRepeat.value);
			return;
		}
		schRepeat.value = "daily"; //No I18N
		$("ZCSchTimeDiv").style.display ="";
		var schTypeArr = schType.split("_");

		if(schTypeArr[1] != "daily")
		{
			ZDBUtil.setNamedChildEls(schRepeat, schRepeat, 'value');
			if(schRepeat[schType] == null || schRepeat[schType] == undefined)
			{
				var date = new Date();
				ZRConnector.toggleScheduleDiv("daily"); // No I18N
				$("ZCDailyHourInt").value = date.getHours();
				$("ZCDailyMinsInt").value = parseInt(date.getMinutes() / 5) * 5;
				delete schRepeat.valueSet;
				return;
			}
			schRepeat.value = schType; //No I18N
			ZRConnector.toggleScheduleDiv(schRepeat.value);
			return;
		}

		var calTime = schTypeArr[0];
		var hr = Math.floor(calTime / 60);
		var min = calTime % 60;
		$("ZCDailyHourInt").value = hr;
		$("ZCDailyMinsInt").value = min;
	};

	this.getSchTime = function()
	{
		if($("repeatinterval").value != "daily")
		{
			return $("repeatinterval").value;
		}
		var hourVal = $("ZCDailyHourInt").value;
		var minVal = $("ZCDailyMinsInt").value;
		var timeInMin = parseInt( hourVal * 60) + parseInt(minVal) ;
		return timeInMin + "_daily"; //No I18N
	};

    this.syncNow =function (el)
    {
    	var dbId = ZDBClientUI.dbId;
        var connDBInfoId=el.getAttribute("conndbinfoid");
        var connectorId = el.getAttribute("connectorid");
        var fetchCount=el.getAttribute("fetchcount");
        AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?&ZDBACTION=SYNCNOW&CONNDBINFOID="+connDBInfoId+"&CONNECTORID="+connectorId+"&DBID="+dbId, METHOD:"POST", 
            FETCHCOUNT:fetchCount,
            ONSUCCESSFUNC:ZRConnector.handleSyncNowSucc
              });
    };
    
    this.handleSyncNowSucc = function (response,requestOptions)
    {
        var respDiv = jQuery("#ConnSyncDetsDlg").find("[elname='respDiv']");    // No I18N
        respDiv.html(ZDBI18NMap.g("zrpt.conn.js.syncnow.success"));
        jQuery(respDiv).show("slow");   // No I18N
        $("ConnSyncNow").className = "ZRSLink alpha";
        $("ConnSyncNow").onclick = null;
        var prevFetchCount =parseInt(requestOptions.FETCHCOUNT);
        var newFetchCount = prevFetchCount + 1;
        $("ConnFetchcount").innerHTML = newFetchCount;
        $("ConnSchStatus").innerHTML = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
        $("ConnSchStatus").style.color = "#0096FF";
        setTimeout(function(){respDiv.hide("slow");},5000);
    };
    
    this.showDataSourcesDlg = function(response,requestOptions)
    {
    	if(ZRConnector.isDlgOpened)
    	{
    		return;
    	}
    	ZRConnector.isDlgOpened = true;
        var params = "&DBID=" + ZDBClientUI.dbId; // No I18N
        AjaxAPI.sendRequest({
                URL:"/ZRDataSources.cc?ZDBACTION=FETCHDATASOURCES", // No I18N
    			METHOD:"GET", //No I18N
                PARAMETERS:params,
                ONSUCCESSFUNC:ZRConnector.successDataSourcesDlg,
                OPSTATUSID:"ZDBMainLoader" // No I18N
            });
    };


    this.refreshDataSourcesDlg = function(el)
    {
        ZRConnector.refreshId = ZRConnector.curConnector;
    	ZRConnector.isDlgOpened = true;
        var params = "&DBID=" + ZDBClientUI.dbId; // No I18N
        AjaxAPI.sendRequest({
                URL:"/ZRDataSources.cc?ZDBACTION=FETCHDATASOURCES", // No I18N
    			METHOD:"GET", //No I18N
                PARAMETERS:params,
                ONSUCCESSFUNC:ZRConnector.successDataSourcesDlgRefresh,
                OPSTATUSID:"ZDBMainLoader", // No I18N
                ELEMENT:el
            });
    };
    this.successDataSourcesDlgRefresh = function(response,requestOptions)
    {
        ZDBInlineDialog.closeDialogByType(requestOptions['ELEMENT']);
        ZRConnector.successDataSourcesDlg(response,requestOptions);
        ZRConnector.changeClass($(ZRConnector.refreshId), null, 'switch');//No I18N
    }
    this.successDataSourcesDlg = function(response,requestOptions)
    {
    	var div = document.createElement("div");
        div.innerHTML = response.responseText;

        ZDBInlineDialog.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true,ONCLOSE:ZRConnector.handleDlgClose,ONRESIZE:ZRConnector.resizeConnDlg,
		TITLE:ZDBI18NMap.g('Data Sources')});
		ZRConnector.loadConnJson(true);
		ZRConnector.resizeConnDlg();

		var objKeys = Object.keys(ZRConnector.connJson);
		if(objKeys.length === 1)
		{
			ZRConnector.changeClass($(objKeys[0]), null, 'switch');//No I18N
		}

                if(!ZDBGlobal.ISNEWLAYOUT) {
                    $("ZDBTABTPL").className = "ExplorerObj inlineTabSelected";
                }
	};
	//--ZROP Changes--
	this.hideSyncOptions=function(){
		$("connSchType").innerHTML = ZDBI18NMap.g("zrpt.dialoginfo.backup.js.notscheduled"); //No I18N
		$("connNextSchTime").innerHTML = ZDBI18NMap.g("zrpt.importutil.js.sch.notapplicable"); //No I18N
		$("connSyncNow").style.display="none";
		$("syncSettings").style.display="none";
		var x=document.getElementsByClassName("modIcons"); //No I18N
		for(var i=0;i<x.length;i++){
			if(x[i].childNodes[0]!=null)
				x[i].childNodes[0].className="modSync alpha"; //No I18N
		}
	}
	//--ZROP Changes--
	this.multiConnRetryInit = function(el, event, isExp)
	{
		ZDBUtil.stopEventBubble(event);
		var parEl = isExp ? ZRConnector.curConnector : ZDBUtil.getParentWithAttributeValue(el, "isparent", "true").id;		//No I18N
		var connectorId = parEl.split("_")[0];
		if(!ZRConnector.connJson[parEl].isretryinitavbl)//No Retry initial fetch for CRM
		{
			return;
		}
		var connDBInfoId = parEl.split("_")[1];
		var url = "/ConnectorAction.ma?ZDBACTION=DBREINIT&DBID=" + ZDBClientUI.dbId + "&CONNECTORID=" + connectorId + "&CONNDBINFOID=" + connDBInfoId; //No I18N
		    AjaxAPI.sendRequest({URL:url, ONSUCCESSFUNC:ZRConnector.multiConnRetryInitSucc, ELEMENTID:parEl});
	}

	this.multiConnRetryInitSucc = function(response,requestOptions)
	{
		var elId = requestOptions.ELEMENTID;
		$(elId+"_connRetryNow").style.display = "none";
		var status = ZDBI18NMap.g("zrpt.conn.js.initfetch_in_progress");
		$(elId+"_syncstatus").innerHTML = status;
		$(elId+"_syncstatus").className = 'inProgressTxt';//No I18N
		var obj = ZRConnector.connJson[elId];
		obj.status = 0;
		obj.statusstr = status;
		$("connExpRetryNow").style.display = "none";
		$("connSyncStatus").innerHTML = status;
		$("connSyncStatus").className = 'inProgressTxt';//No I18N
		ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.conn.js.reinitsuccess"));//No I18N
	}

	this.multiConnSyncNow = function(el, event)
	{
		var tr = ZDBUtil.getParentWithAttributeValue(el, "isparent", "true");		//No I18N
		ZRConnector.multiConnSyncNowProcess(el, event, tr.id);
	}

	this.multiConnSyncNowFromExp = function(el, event)
	{
		ZRConnector.multiConnSyncNowProcess(el, event, ZRConnector.curConnector);
	}

	this.multiConnSyncNowProcess = function(el, event, parEl)
	{
		ZDBUtil.stopEventBubble(event);
		ZRConnector.loadConnJson();
		var connDets = parEl.split("_");
		var dbId = ZDBClientUI.dbId;
		var connDBInfoId= connDets[1];
		var connectorId = connDets[0];
		var fetchCount=el.getAttribute("fetchcount");
		AjaxAPI.sendRequest({URL:ZRConnector.getSyncNowActionURL(connectorId, dbId, connDBInfoId),
			METHOD:"POST", //No I18N
			FETCHCOUNT:fetchCount,
			ELEMENTID:parEl,
			ONSUCCESSFUNC:ZRConnector.handleMultiSyncNowSucc,
			OPSTATUSID:"ZDBMainLoader"//No I18N
		});
	};

	this.getSyncNowActionURL = function(connectorId, dbId, connDBInfoId)
	{
		if(connectorId == -1)
		{
			return "/ZDBCRMSyncSettings.ve?ZDBACTION=SYNCNOW&DBID="+dbId;//No I18N
		}
		else if(connectorId == -11)
                {
                return "/ZRCloudDBAction.ma?ZDBACTION=SYNCNOW&CONNECTIONID="+connDBInfoId+"&DBID="+dbId; //No I18N
                }
                else if(connectorId == -12)
                {
                    return "/ZRODataAction.ma?ZDBACTION=SYNCNOWODATA&CONNECTIONID="+connDBInfoId+"&DBID="+dbId; //No I18N
                }
		else if(connectorId == 1005)
                {
                    return "/ZDBImportAction.ma?ZDBACTION=SYNCNOW&WORKBOOKID="+connDBInfoId+"&DBID="+dbId; //No I18N
                }
		else
		{
			return "/ConnectorAction.ma?&ZDBACTION=SYNCNOW&CONNDBINFOID="+connDBInfoId+"&CONNECTORID="+connectorId+"&DBID="+dbId;//No I18N
		}
	};

	this.handleMultiSyncNowSucc = function (response,requestOptions)
	{
		var elId = requestOptions.ELEMENTID;
		$(elId+"_syncnow").className = "ZRSLink alpha";
		$(elId+"_syncnow").onclick = null;
		//var prevFetchCount =parseInt(requestOptions.FETCHCOUNT);
		//var newFetchCount = prevFetchCount + 1;
		//$("ConnFetchcount").innerHTML = newFetchCount;
		$(elId+"_syncstatus").innerHTML = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
		$(elId+"_syncstatus").className = 'inProgressTxt';//No I18N
		var obj = ZRConnector.connJson[elId];
		obj.status = 5;
		if(obj.isCloudDBSrc || obj.isODataSrc)
                {
                    obj.status = 4;
                }
		obj.statusstr = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");

		obj.syncnowcount = obj.syncnowcount + 1;

		$("connSyncStatus").innerHTML = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
		$("connSyncStatus").className = 'inProgressTxt';//No I18N
		$("connSyncNowCnt").innerHTML = obj.syncnowcount;
		$("connSyncNow").className = "ZRSLink alpha";
		jQuery("#connSyncNow").unbind('click'); //No I18N

		ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.conn.js.syncnow.success"));//No I18N
		if(obj.isCloudDBSrc || obj.isODataSrc)
                {
                    ZRConnector.refreshDataSourcesDlg($("DatasourceBack"));
                }
        };

	this.showEditSetupFromMenu = function(el,event)
	{
		var parId = el.getAttribute("parId");		//No I18N
		var connectorId = parId.split("_")[0];
		var conndbinfoid = parId.split("_")[1];
		ZRConnector.showEditSetupBasedOnConn(connectorId, conndbinfoid);
	};

	this.showEditSetup = function(el)
	{
		var connectorId = ZRConnector.curConnector.split("_")[0];
		var conndbinfoid = ZRConnector.curConnector.split("_")[1];
		ZRConnector.showEditSetupBasedOnConn(connectorId, conndbinfoid,el);
	};

	this.showEditSetupBasedOnConn = function(connectorId, conndbinfoid,el)
	{
		if(connectorId == 6)
		{
			ZRCreatorInteg.showEditSetupDlg(conndbinfoid);
		}
		else if(connectorId == 5)
		{
			ZRZendeskInteg.showEditSchDlg(conndbinfoid);
		}
		else if(connectorId == 25)
		{
			ZRSFDeskInteg.showEditSchDlg(conndbinfoid);
		}
		else if(connectorId == 28)
		{
			ZRTWDeskInteg.showEditSchDlg(conndbinfoid);
		}
		else if(connectorId == 0)
		{
			ZRSFIntegration.showEditFieldsDlg(conndbinfoid);
		}
		else if(connectorId == 1 || connectorId == 4)
		{
            ZDBZProjectsInteg.showEditSetup(connectorId, "ZDBMainLoader",conndbinfoid);//No I18N
		}
		else if(connectorId == -1)
		{
			ZDBCRMInteg.showEditSetupDlg();
		}
		else if(connectorId == 3)
		{
			ZRGAnalInteg.checkGAnalyticsAuthToken(conndbinfoid);
		}
		else if(connectorId == 7)
		{
			ZRFBIntegration.showEditFieldsDlg(conndbinfoid);
		}
		else if(connectorId == 2) // Adwords
		{
			ZRGADInteg.fetchSetupDetails(conndbinfoid);
		}
		else if(connectorId == 8)
		{
			ZRQBooksInteg.editSetup(conndbinfoid);
		}
		else if(connectorId == 10)
		{
			ZRRecruitIntegration.showEditFieldsDlg(conndbinfoid);
		}
		else if(connectorId == 11)
		{
			ZRZBooksInteg.showEditFieldsDlg(conndbinfoid);
		}
		else if(connectorId == 12)
		{
			ZRMChimpIntegration.showEditFieldsDlg(conndbinfoid);
		}
		else if(connectorId == 13){
			ZRXeroInteg.editSetup(conndbinfoid);
		}
		else if(connectorId == 14){
			ZRMSCRMIntegration.showEditFieldsDlg(conndbinfoid);
		}
		else if(connectorId == 15){
			OPMInteg.showSetupDlg(conndbinfoid);
		}
		else if(connectorId == 16)
		{
			APMInteg.showSetupDlg(conndbinfoid);
        }
        else if(connectorId == 17)
        {
            ZDBCRMInteg.showEditFieldsDlg(conndbinfoid);
        }
        else if(connectorId == 18)
        {
            ZRSMInteg.showEditSchDlg(conndbinfoid);
        }
        else if(connectorId == 19)
    	{
    		ZRContactIntegration.showEditFieldsDlg(conndbinfoid);
    	}
        else if(connectorId == 20)
		{
    		ZRTWInteg.fetchEditTables(conndbinfoid);
		}
        else if(connectorId == -11)
        {
            CloudDBPage.editSetup(conndbinfoid,el);
        }
        else if(connectorId == -12)
        {
            ODataPage.editSetup(conndbinfoid,el);
        }
        else if(connectorId == 22)
    	{
    		ZRZDeskInteg.showEditSetupDlg(conndbinfoid);
    	}
        else if(connectorId == 23)
    	{
    		ZRZCampaignsIntegration.showEditFieldsDlg(conndbinfoid);
    	}
    	else if(connectorId == 24)
    	{
        	ZRQBDesktopInteg.editSetup(conndbinfoid);
    	}
    	else if(connectorId == 25)
		{
			ZRSFDeskInteg.showEditSchDlg(conndbinfoid);
		}
    	else if(connectorId == 26)
    	{
        	ZRSurveyInteg.showEditSchDlg(conndbinfoid);
    	}
    	else if(connectorId == 27)
		{
			ZRStripeConnector.editSetup(conndbinfoid);
		}
		else if(connectorId == 29)
		{
    		ZRHubSpotInteg.editSetup(conndbinfoid);
    	}
    	else if(connectorId == 30)
    	{
        	ZPeopleInteg.showEditSetupDlg(conndbinfoid);
    	}
    	else if(connectorId == 33)
		{
    		ZRSurveyGizmoInteg.showEditSchDlg(conndbinfoid);
    	}
    	else if(connectorId == 34)
    	{
        	ZRGoogleAnalyticsIntegration.showEditFieldsDlg(conndbinfoid);
    	}
    	else if(connectorId == 36) 
		{
    		ZRTwitterInteg.showEditSchDlg(conndbinfoid);
    	}
        else if(connectorId == 1005)
		{
                        if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImportSchedule.js","APPENDTODOC",ZRConnector.showEditSetupBasedOnConn,[connectorId, conndbinfoid,el]))
                        {
                                return;
                        }
                        if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC",ZRConnector.showEditSetupBasedOnConn,[connectorId, conndbinfoid,el])){
        	  	return;
                        }
			ZDBImportSchedule.showEditMultiTableSettings(conndbinfoid);
		}
                else if(connectorId = 1001 || connectorId == 1003 || conectorId == 1004)
                {
                    if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImportSchedule.js","APPENDTODOC",ZRConnector.showEditSetupBasedOnConn,[connectorId, conndbinfoid,el]))
                        {
                                return;
                        }
                        if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC",ZRConnector.showEditSetupBasedOnConn,[connectorId, conndbinfoid,el])){
        	  	return;
                        }
                    ZDBImportSchedule.showSchdeuleDialogFromDataSourcePage(conndbinfoid);
                }
    };

    this.showEditSyncDlg = function()
    {
    	var conndbinfoid = ZRConnector.curConnector.split("_")[1];
    	CloudDBPage.showSyncEdit(conndbinfoid);
    };

    this.showEditSyncODataDlg = function()
    {
    	var conndbinfoid = ZRConnector.curConnector.split("_")[1];
    	ODataPage.showSyncEdit(conndbinfoid);
    };

    this.showEditSyncDlgFromMenu = function(el, event)
    {
        var parId = el.getAttribute("parId");		//No I18N
    	var connectorId = parId.split("_")[0];
    	var conndbinfoid = parId.split("_")[1];
        if(connectorId == -11)
        {
            CloudDBPage.showSyncEdit(conndbinfoid);
        }
        else if(connectorId == -12)
        {
            ODataPage.showSyncEdit(conndbinfoid);
        }
    };

	this.showAuthDlg = function()
	{
		var connectorId = ZRConnector.curConnector.split("_")[0];
		var conndbinfoid = ZRConnector.curConnector.split("_")[1];
		ZRConnector.showAuthDlgBasedOnConn(connectorId, conndbinfoid);
	};

	this.showDisconnectDlg = function()
	{
		var connectorId = ZRConnector.curConnector.split("_")[0];
		var conndbinfoid = ZRConnector.curConnector.split("_")[1];
		ZRConnector.showDisconnectDlgBasedOnConn(connectorId, conndbinfoid);
	};

    this.showDownloadQWCDlg = function()
	{
		var connectorId = ZRConnector.curConnector.split("_")[0];
		var conndbinfoid = ZRConnector.curConnector.split("_")[1];
		if(connectorId == 24)
		{
			ZRQBDesktopInteg.downloadQWCFileFromDataSources('QWCForm');  //No I18N
		}
	}

	this.showAuthDlgFromMenu = function(el, event)
	{
		var parId = el.getAttribute("parId");		//No I18N
		var connectorId = parId.split("_")[0];
		var conndbinfoid = parId.split("_")[1];
		ZRConnector.showAuthDlgBasedOnConn(connectorId, conndbinfoid);
	};

	this.showAuthDlgBasedOnConn = function(connectorId, conndbinfoid)
	{
		if(connectorId == 5)
		{
			ZRZendeskInteg.showEditLoginDlg(conndbinfoid);
		}
		else if(connectorId == 25)
		{
			ZRSFDeskInteg.showEditAuthDlg(conndbinfoid);
		}
		else if(connectorId == 28)
		{
			ZRTWDeskInteg.showEditAuthDlg(conndbinfoid);
		}
		else if(connectorId == 0)
		{
			ZRSFIntegration.showEditLoginDlg(conndbinfoid);
		}
		else if(connectorId == 3)
		{
			ZRGAnalInteg.showReAuthDlg(conndbinfoid);
		}
		else if(connectorId == 7)
		{
			ZRFBIntegration.showEditLoginDlg(conndbinfoid);
		}
		else if(connectorId == 8)
		{
			ZRQBooksInteg.showReAuthDialog(conndbinfoid);
		}
		else if(connectorId == 2)
		{
			ZRGADInteg.showReAuthDlg(conndbinfoid);
		}
		else if(connectorId == 12)
		{
			ZRMChimpIntegration.showReAuthDlg(conndbinfoid);
		}
		else if(connectorId == 13)
		{
			ZRXeroInteg.showReAuthDialog(conndbinfoid);
		}
		else if(connectorId == 19)
		{
			ZRContactIntegration.showReAuthDlg(conndbinfoid);
		}
		else if (connectorId == 14)
		{
			ZRMSCRMIntegration.showReAuthDialog(conndbinfoid)
		}
		else if(connectorId == 27)
		{
			ZRStripeConnector.showReAuthDialog(conndbinfoid);
		}
		else if(connectorId == 29)
		{
			ZRHubSpotInteg.showReAuthDialog(conndbinfoid);
		}
		else if(connectorId == 33)
		{
			ZRSurveyGizmoInteg.showEditAuthDlg(conndbinfoid);
		}
		else if(connectorId == 34)
		{
			ZRGoogleAnalyticsIntegration.showReAuthDlg(conndbinfoid);
		}
		else if(connectorId == 18)
        {
            ZRSMInteg.showEditLoginDlg(conndbinfoid);
        }
		else if(connectorId == 20)
		{
    		ZRTWInteg.showReAuth(conndbinfoid);
		}
		else if(connectorId == 23 || connectorId == 10 || connectorId == 11 || connectorId == 26 || connectorId == 30 || connectorId == 1 || connectorId == 4 || connectorId == 22 || connectorId == 6 || connectorId == 17)
    	{
    		ZRConnector.internalReAuth(conndbinfoid, connectorId);
    	}
    	else if(connectorId == 36) 
		{
    		ZRTwitterInteg.showEditLoginDlg(conndbinfoid);
    	}
		else
		{
			console.log("No proper ConnectorId for ReAuthentication "+connectorId);
		}
	};

	this.internalReAuth = function(conndbinfoid, connectorId)
	{
		parameters = "&DBID="+ZDBClientUI.dbId + "&CONNDBINFOID=" + conndbinfoid + "&CONNECTORID=" + connectorId;  //NO I18N
        AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?ZDBACTION=INTERNALREAUTHENTICATE"+parameters, METHOD:"POST",
            ONSUCCESSFUNC:ZRConnector.successReAuth,OPSTATUSID:"ZDBMainLoader"}); //No I18N
	}

	this.successReAuth = function(response, responseText)
	{
		ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.conn.js.reauth.success"));//No I18N
	}

	this.showDisconnectDlgBasedOnConn = function(connectorId, conndbinfoid)
	{
		if(connectorId == 8)
		{
			ZRQBooksInteg.showDisconnectDlg(conndbinfoid);
		}
	};

	this.showSyncNowMsg = function(el,event)
	{
		var syncMsg = $("connSyncNowMsg").innerHTML;
		el.setAttribute("tip",syncMsg);
		el.setAttribute("isError",false);
		ZDBToolTip.show(el,event,'RIGHT',false,false);		//No I18N
	}

	this.deleteConnector = function(el, event)
	{
		var parId = el.getAttribute("parId");		//No I18N
		var connectorId = parId.split("_")[0];
		var conndbinfoid = parId.split("_")[1];

		ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.conn.js.delconfirmmsg"),"ZDBYESNO",//No I18N
		{ONCLICK:ZRConnector.confirmConnDeletion,CONNDBINFOID:conndbinfoid,CONNECTORID:connectorId,PARENTID:parId},ZDBI18NMap.g("zrpt.conn.js.connremconfirm"));    //No I18N
	};

	this.confirmConnDeletion = function (clickType,requestOptions)
	{
		if(clickType != "YES")
		{
			return;
		}
		var params = "&DBID=" + ZDBClientUI.dbId+"&CONNDBINFOID="+requestOptions["CONNDBINFOID"]+"&CONNECTORID="+requestOptions["CONNECTORID"];//No I18N
                if(requestOptions["CONNECTORID"] == -11)
                {
                    CloudDBPage.deleteConnector(requestOptions["CONNDBINFOID"],requestOptions["PARENTID"]);
                }
                else if(requestOptions["CONNECTORID"] == -12)
                {
                    ODataPage.deleteConnector(requestOptions["CONNDBINFOID"],requestOptions["PARENTID"]);
                }
                else
                {
                    AjaxAPI.sendRequest({
			URL:"/ConnectorAction.ma?ZDBACTION=DELETECONNECTOR", // No I18N
			PARAMETERS:params,
			ELEMENTID:requestOptions["PARENTID"],
			ONSUCCESSFUNC:ZRConnector.showRespMsg,
			OPSTATUSID:"ZDBMainLoader" // No I18N
		});
                }
        };

    this.showRespMsg = function(response, requestOptions)
    {
    	var parEl = $(requestOptions["ELEMENTID"]);
    	if(ZRConnector.isExpanded)
    	{
    		if(!ZRConnector.showNextConn(null,parEl))
    		{
    			if(!ZRConnector.showPrevConn(null,parEl))
    			{
    				ZRConnector.showEmptyDlg();
    			}
    		}
    	}
    	parEl.parentNode.removeChild(parEl);
		ZDBNavigation.fetchObjectsListForDB(ZDBNavigation.navSelect.value,true);//Refreshing objects for the DB
		ZDBMsgBox.showSuccess(response.responseText);
	};

	this.showEmptyDlg = function()
	{
		$("ConnTableBody").innerHTML = ZDBI18NMap.g("zrpt.conn.js.nodatasource");
		$("ConnTableBody").className = "connEmptyMsgTxt";
	};

	this.searchConnector = function()
	{
		var searchFieldElem = $("ZRConnSearch");
		var containerDivId = searchFieldElem.getAttribute("searchDivId");
		var attr = "searchval"; //No I18N
		var basedOnTag = "div[name=searchDiv]"; //No I18N
		ZDBClientUtil.searchAndDisplay(containerDivId,basedOnTag,attr,searchFieldElem,$("ConnEmptyMsg"));
	};

	this.changeClass = function(el ,event, context, direction)
	{
		ZRSMenu.closeAllMenu();
		ZDBUtil.stopEventBubble(event);
		if(el.id === ZRConnector.curConnector)
		{
			return;
		}
		var tBody = $("ConnTableBody");

		ZRConnector.loadConnJson();
		ZRConnector.setEmptyConn();

		var setPos = !ZRConnector.isExpanded;

		if(context === "close" || !ZRConnector.isExpanded)
		{

			if(ZRConnector.isExpanded) {
				ZRConnector.isExpanded = false;
				$('ConnTableBodyStatus').style.display = 'none';
				//$('connSearchBox').style.display = "block";
				tBody.setAttribute('class','connList');

			} else {
				ZRConnector.isExpanded = true;
				tBody.setAttribute('class','toShowSel');
				//$('connSearchBox').style.display = "none";
				jQuery("#ConnTableBodyStatus").fadeIn(400, function() {this.style.display='block'});
			}

		}
		ZRConnector.resizeConnDlg();
		if(context === "switch")
		{
			$(el.id+"_ch").className = 'moduleTabSelected';
			ZRConnector.curConnector = el.id;
			ZRConnector.loadConnInfo(el);
		}
		var mainEl = ZDBUtil.getParentWithAttributeValue(tBody, "inlinediv", "mainDialogDiv");//No I18N
		jQuery(mainEl).animate({ scrollTop: 0 }, 300);
		if(direction) {
			var height = $('ConnTableBodyChild').offsetHeight - el.offsetHeight;
			var scroll = $('ConnTableBodyChild').scrollTop;
			var scrHgt = $('ConnTableBodyChild').scrollHeight;
			var toAdd = el.offsetTop - (height + scroll);
			$('ConnTableBodyChild').scrollTop = scroll + toAdd;//(scroll + toAdd < 0)?scroll: scroll + toAdd;
			if(direction == -1) {
				toAdd = (scroll + el.offsetTop + 2*el.offsetHeight) - height - 10;
				$('ConnTableBodyChild').scrollTop = (toAdd < 0)?scroll + toAdd: scroll;
			}
		} else if(setPos) {
			var height = $('ConnTableBodyChild').offsetHeight;
			var top = el.offsetTop + el.offsetHeight;
			$('ConnTableBodyChild').scrollTop = top - height;
		}
		//--ZROP Changes--
		if(ZDBGlobal.IS_ONPREMISE_BUILD&&ZDBGlobal.IS_FREE_EDITION){
			ZRConnector.hideSyncOptions();
		}
		//--ZROP Changes--
	};

	this.resizeConnDlg = function() {
		var tBody = $("ConnTableBody");
		var width = (tBody.clientWidth - 277) + 'px';//No I18N
		$('ConnTableBodyStatus').style.left = '210px';

		$("connHeader").style.width = tBody.clientWidth + 'px';
		$("connDlgHeader").style.width = tBody.clientWidth + 'px';
	};

	this.loadConnJson = function(loadAgain)
	{
		if(!ZRConnector.connJson || loadAgain)
		{
			ZRConnector.connJson = JSON.parse($("CONN_JSON").value);
		}
	};

	this.setEmptyConn = function()
	{
		if(ZRConnector.curConnector)
		{
			$(ZRConnector.curConnector+"_ch").className = '';
			ZRConnector.curConnector = null;
		}
	};

	this.loadConnInfo = function(el)
	{
		var obj = ZRConnector.connJson[el.id];
		var isNotCloudDBORIntegConnector = obj.isNotCloudDBIntegConnector;
		if(! isNotCloudDBORIntegConnector) // cloudDB, other Integration connector
		{
			$("connName").innerHTML = obj.connname;
			$("connTimeZone").innerHTML = obj.timezone;
			var isDisconnected = ZRConnector.isDisconnected==undefined?obj.isDisconnected:ZRConnector.isDisconnected;
			$("connSyncStatus").innerHTML = isDisconnected?ZDBI18NMap.g("zrpt.conn.js.disconnected"): obj.statusstr;
			$("connlftime").innerHTML = obj.lastfetchtime;
                        if(obj.issyncnowavbl)
                        {
			$("connSyncNowCnt").innerHTML = obj.syncnowcount;
                        }
			$("storedConnName").innerHTML = ZDBEscapeUtil.encodeForHtml(obj.storedconnname);
                        if(obj.storedconnnametip)
                        {
                        $("storedConnName").setAttribute("tip",ZDBEscapeUtil.encodeForHtml(obj.storedconnnametip));
                        }
                        else
                        {
                            $("storedConnName").setAttribute("tip","");
                        }
			$("connSchType").innerHTML = obj.schtype;
			$("connNextSchTime").innerHTML = obj.nextschtime;
			var status = obj.status;
			$("connExpRetryNow").style.display = (status == 2 && obj.isretryinitavbl && obj.issuperadmin) ? "" : "none";//No retry initial fetch for CRM
			jQuery("#connSyncNow").unbind('click'); //No I18N
			jQuery("#connCleanNow").unbind('click'); //No I18N
			jQuery("#connAuth").unbind('click');//No I18N
			jQuery("#connEditSetup").unbind('click');//No I18N
                        jQuery("#connRefetchNow").unbind('click');//No I18N
			if(obj.fileType)
		            {
		            $("connFileTypeRow").style.display ="";
		            $("storedFileType").innerHTML = obj.fileType;
		            }
		            else
		            {
		            $("connFileTypeRow").style.display ="none";
		            }
		            if(obj.isAuthenticatedSource == true)
		            {
		            $("connAuthTypeeRow").style.display ="";
		            $("storedAuthType").innerHTML = obj.authType;
		            }
		            else
		            {
		            $("connAuthTypeeRow").style.display ="none";
		            }
			$("connSyncNowRow").style.display = (obj.issyncnowavbl) ? "" : "none";
        	        $("connCleanupRow").style.display = (obj.isconncleanupallowed) ? "" : "none";
			$("connTimeZoneRow").style.display = (obj.istimezonereq) ? "" : "none";
			$("connNameRow").style.display = (obj.issubnameavbl) ? "" : "none";

			if($("connNameMsg"))
			{
			$("connNameMsg").innerHTML = obj.connnamemsg;
		}
		$("connHelp").style.display = (obj.isCloudDBSrc) ? "none" : "";//No I18N
		$("connHelp").setAttribute('href', obj.helplink);
		if(isDisconnected)
		{
			$("connSyncStatus").className = 'faileText';
			$("connSyncNow").className = "ZRSLink alpha";
			$("connCleanNow").className = "ZRSLink alpha"
		}
		else
		{
			if(status === 1 || status === 8)//DB in use status or partially fetched status
			{
				$("connSyncStatus").className = 'succesText';
				$("connSyncNow").className = "ZRSLink";
				$("connCleanNow").className = "ZRSLink";
				jQuery("#connSyncNow").click(function(){ZRConnector.multiConnSyncNowFromExp(this,this.event);}); //No I18N
				jQuery("#connCleanNow").click(function(){ZRConnector.userCleanupAlert();}); //No I18N
			}
			else if(status === 2 || status === 3)//Initial Failure and Sync Failure
			{
				$("connSyncStatus").className = 'faileText';
				$("connSyncNow").className = "ZRSLink alpha";
				$("connCleanNow").className = "ZRSLink alpha";
				if(status == 3)
				{
					$("connSyncNow").className = "ZRSLink";
					jQuery("#connSyncNow").click(function(){ ZRConnector.multiConnSyncNowFromExp(this,this.event);}); //No I18N
					$("connCleanNow").className = "ZRSLink";
					jQuery("#connCleanNow").click(function(){ZRConnector.userCleanupAlert();}); //No I18N
				}
			}
			else
			{
				$("connSyncStatus").className = 'inProgressTxt';
				$("connSyncNow").className = "ZRSLink alpha";
				$("connCleanNow").className = "ZRSLink alpha";
			}
			if(obj.isSyncNowAllowed!= null && obj.isSyncNowAllowed == true) //for cloud db retry not available only during sync in progress
            {
                $("connSyncNow").className = "ZRSLink";
                if(status == 2)
                {
                    jQuery("#connSyncNow").click(function(){ ZRConnector.multiConnSyncNowFromExp(this,this.event);}); //No I18N
                }
            }
		}

		if(!obj.issyncnowavbl)
		{
			$("connSyncNow").className = "";
			jQuery("#connSyncNow").unbind('click'); //No I18N
		}

		if(!obj.iscleanupavbl)
		{
			$("connCleanNow").className = "ZRSLink alpha";
			jQuery("#connCleanNow").unbind('click'); //No I18N
		}

		if((obj.issyncnowavbl && obj.syncnowcount >= obj.maxsyncnowcount) || ZDBClientUI.readOnlyMode)
		{
			$("connSyncNow").className = "ZRSLink alpha";
			jQuery("#connSyncNow").unbind('click'); //No I18N
		}

		$("connSyncNowMsg").innerHTML = obj.isdailysch ? ZDBI18NMap.f("zrpt.conn.js.daily.maxsynccnt.info", obj.maxsyncnowcount) : ZDBI18NMap.f("zrpt.conn.js.periodic.maxsynccnt.info", obj.maxsyncnowcount);

		if(obj.issuperadmin  && !ZDBClientUI.readOnlyMode)
		{
                if(obj.isCloudDBSrc)
		{
			$("connEditSetup").style.display = "none";
			$("editConn").style.display = "";
			jQuery("#editConn").unbind('click');//No I18N
			jQuery("#editConn").click(function(){ ZRConnector.showEditSetup();}); //No I18N
			$("syncSettings").style.display = "";
			jQuery("#syncSettings").unbind('click');//No I18N
			jQuery("#syncSettings").click(function(){ZRConnector.showEditSyncDlg();});//No I18N
			$("connAuth").style.display = "none";
			$("connRefetchNow").style.display = "none";
			jQuery("connAuth").unbind('click');//No I18N
			$("connDisconnect").style.display = "none";
			jQuery("#connDisconnect").unbind('click');//No I18N
			jQuery("#connRefetchNow").unbind('click');//No I18N
			$("lastimpstatus").style.display = "none";
			}
			else if(obj.isODataSrc)
			{
			$("connEditSetup").style.display = "none";
			$("editConn").style.display = "";
			jQuery("#editConn").unbind('click');//No I18N
			jQuery("#editConn").click(function(){ ZRConnector.showEditSetup();}); //No I18N
			$("syncSettings").style.display = "";
			jQuery("#syncSettings").unbind('click');//No I18N
			jQuery("#syncSettings").click(function(){ZRConnector.showEditSyncODataDlg();});//No I18N
			$("connAuth").style.display = "none";
			jQuery("connAuth").unbind('click');//No I18N
			$("connDisconnect").style.display = "none";
			jQuery("#connDisconnect").unbind('click');//No I18N
			}
			else
			{
			$("editConn").style.display = "none";
			jQuery("#editConn").unbind('click');//No I18N
			$("syncSettings").style.display = "none";
			jQuery("#syncSettings").unbind('click');//No I18N
			$("connEditSetup").style.display = obj.iseditsyncavailable==true?"":"none";
			$("connRefetchNow").style.display = obj.isRefetchDataAvailable==true?"":"none";
			$("lastimpstatus").style.display = obj.isRefetchDataAvailable ==true && obj.hideLastImpDetails !=true?"":"none";
			jQuery("#connEditSetup").click(function(){ ZRConnector.showEditSetup();}); //No I18N
			jQuery("#connRefetchNow").click(function(){ ZRConnector.modSync(this);}); //No I18N
			jQuery("#connRefetchNow").attr("objid",ZRConnector.curConnector.split("_")[1]);//No I18N
			if(obj.isauthreq)
			{
			$("connAuth").style.display = "";
			jQuery("#connAuth").click(function(){ ZRConnector.showAuthDlg();}); //No I18N
			}
			else
			{
			$("connAuth").style.display = "none";
			}
			if(!isDisconnected && obj.canShowDisconnected)
			{
			$("connDisconnect").style.display = "";
			jQuery("#connDisconnect").click(function(){ ZRConnector.showDisconnectDlg();}); //No I18N
			}
			else
			{
			$("connDisconnect").style.display = "none";
			}
			if(obj.showQWCDownload)
			{
			$("downloadQWCFile").style.display = "";
			jQuery("#downloadQWCFile").click(function(){ ZRConnector.showDownloadQWCDlg();}); //No I18N
			}
                        }
			}
                        else
                        {
                        $("connEditSetup").style.display = obj.iseditsyncavailable==true?"":"none";
			$("connRefetchNow").style.display = obj.isRefetchDataAvailable==true?"":"none";
			$("lastimpstatus").style.display = obj.isRefetchDataAvailable ==true && obj.hideLastImpDetails !=true?"":"none";
                        jQuery("#connEditSetup").click(function(){ ZRConnector.showEditSetup();}); //No I18N
			jQuery("#connRefetchNow").click(function(){ ZRConnector.modSync(this);}); //No I18N
			jQuery("#connRefetchNow").attr("objid",ZRConnector.curConnector.split("_")[1]);//No I18N
                        }
			$("connectorDetailsDiv").style.display = "block";
		}
		else
		{
			 $("editConn").style.display = "none";
			 jQuery("#editConn").unbind('click');//No I18N
                          $("connEditSetup").style.display = "none";
                          $("connAuth").style.display = "none";
                    $("connRefetchNow").style.display = "none";
                    jQuery("#connRefetchNow").unbind('click');//No I18N
	         $("syncSettings").style.display = "none";
	         jQuery("#syncSettings").unbind('click');//No I18N
			 $("connectorDetailsDiv").style.display = "none";
                         $("connHelp").style.display = (obj.isCloudDBSrc) ? "none" : "";//No I18N
		$("connHelp").setAttribute('href', obj.helplink);

		}
		$("connName").innerHTML = obj.connname;
		$("connTimeZone").innerHTML = obj.timezone;
		$("connSyncNowRow").style.display = (obj.issyncnowavbl) ? "" : "none";
		$("connCleanupRow").style.display = (obj.isconncleanupallowed) ? "" : "none";
		$("connTimeZoneRow").style.display = (obj.istimezonereq) ? "" : "none";
		$("connNameRow").style.display = (obj.issubnameavbl) ? "" : "none";

		ZRConnector.createModDetsTableIfReq(obj);
	};
	this.createModDetsTableIfReq = function(obj)
	{
		if(obj.ismodstatusreq === true)
		{
			$("modDetsHeader").style.display = "";
			$("modDetsTable").style.display = "";
			$("modDetsTable").innerHTML = "";
			var modArr = obj.modarr;
			var tbl     = document.createElement("table");
			tbl.className = "connModDetailsTbl";
			var tblHeader = document.createElement("thead");
			var tblBody = document.createElement("tbody");

			var headerObj;
if(obj.isCloudDBSrc || obj.isODataSrc)
        {
            headerObj = {"tn" : ZDBI18NMap.g("zrpt.conn.js.tablename"),"stn":ZDBI18NMap.g("zrpt.databasedata.table.js.name"),"lft" : ZDBI18NMap.g("zrpt.conn.js.lastfetchedtime"), "st" : ZDBI18NMap.g("zrpt.conn.js.syncstatus")};//No I18N
            tblBody.style.height="200px";//No I18N
            ZRConnector.createModDetsRowForCloudDB(tblHeader, headerObj, "header");//No I18N
            for (var j = 0; j < modArr.length; j++)
            {
        	var modObj = modArr[j];
        	ZRConnector.createModDetsRowForCloudDB(tblBody, modObj, "data");//No I18N
            }
        }
        else if(obj.isNotCloudDBIntegConnector || obj.isMultiTable)
		{
			if(obj.moduleSubNameNeeded)
			{
				 headerObj = {"tn" : ZDBI18NMap.g("zrpt.conn.js.tablename"),"stn":ZDBI18NMap.g("zrpt.conn.js.moduleSubName"),"lft" : ZDBI18NMap.g("zrpt.conn.js.lastfetchedtime"), "st" : ZDBI18NMap.g("zrpt.conn.js.lastimportstatus")};//No I18N

			}
			else
			{
				headerObj = {"tn" : ZDBI18NMap.g("zrpt.conn.js.tablename"),"stn":ZDBI18NMap.g("zrpt.conn.js.moduleSubFileName"),"lft" : ZDBI18NMap.g("zrpt.conn.js.lastfetchedtime"), "st" : ZDBI18NMap.g("zrpt.conn.js.lastimportstatus")};//No I18N
			}

//			 tblBody.style.height="500px";//No I18N
             ZRConnector.createModDetsRowForOtherThanCloudDBNIntegConnector(tblHeader, headerObj, "header");//No I18N
             for (var j = 0; j < modArr.length; j++)
             {
            	 var modObj = modArr[j];
            	 ZRConnector.createModDetsRowForOtherThanCloudDBNIntegConnector(tblBody, modObj, "data");//No I18N
             }
		}
        else
        {
			headerObj = {"tn" : obj.tablenamestring, "lft" : obj.lastfetchtimestring, "st" : ZDBI18NMap.g("zrpt.conn.js.status")};//No I18N
			ZRConnector.createModDetsRow(tblHeader, headerObj, "header");//No I18N

			for (var j = 0; j < modArr.length; j++)
			{
				var modObj = modArr[j];
				ZRConnector.createModDetsRow(tblBody, modObj, "data");//No I18N
			}
        }
			tblHeader.className = "connDispBlock";
			tblBody.className = "modStatusTBody";
			tbl.appendChild(tblHeader);
			tbl.appendChild(tblBody);
			$("modDetsTable").appendChild(tbl);
		}
		else
		{
			$("modDetsHeader").style.display = "none";
			$("modDetsTable").style.display = "none";
		}
	}

	//cannot depend on order of json objects, they are unordered, so use keys to get desired order -- Alan
	this.createModDetsRow = function(tblBody, modObj, className)
	{
		var row = document.createElement("tr");
		row.className = className;
		if(className == "header"){
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['tn']));
			row.appendChild(cell);
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['st']));
			row.appendChild(cell);
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['lft']));
			row.appendChild(cell);
			tblBody.appendChild(row);
		}
	else if(className == "data"){
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['modname']));
			row.appendChild(cell);
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['modstatus']));
			row.appendChild(cell);
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['modlftime']));
			row.appendChild(cell);
			tblBody.appendChild(row);
		}
	else{
                        for (var key in modObj)
                        {
                            var cell = document.createElement("td");
                            var cellText = document.createTextNode(modObj[key]);
                            cell.appendChild(cellText);
                            row.appendChild(cell);
                        }
                        tblBody.appendChild(row);
		}

    }

    this.createModDetsRowForCloudDB = function(tblBody, modObj, className)
    {
        var row = document.createElement("tr");
        row.className = className;
        if(className == "header"){
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['tn']));
			row.appendChild(cell);
                        var cell = document.createElement("td");
                        cell.appendChild(document.createTextNode(modObj['stn']));
                        row.appendChild(cell);
                        var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['lft']));
			row.appendChild(cell);
			tblBody.appendChild(row);
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['st']));
			row.appendChild(cell);
		}
        else if(className == "data"){
                        row.setAttribute("id",modObj["objId"]);
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['modname']));
			row.appendChild(cell);
			var textToSet = (modObj['modschname'] && modObj['modschname']!="null")?(modObj['modschname']+'.'+modObj['modsrcname']):modObj['modsrcname']; //No I18N
                        var cell = document.createElement("td");
                        cell.appendChild(document.createTextNode(textToSet));
                        row.appendChild(cell);
			var cell = document.createElement("td");
			cell.appendChild(document.createTextNode(modObj['modlftime']));
			row.appendChild(cell);
			var cell = document.createElement("td");
                        var txtNode = document.createTextNode(modObj['modstatus']);
                        if(ZDBI18NMap.f("zrpt.conn.js.modstatus.inprogress") === modObj['modstatus'])
                        {
                            cell.className = 'inProgressTxt';
                        }
                        cell.appendChild(txtNode);
                        ZRConnector.constructModIconsForCloudDB(cell,modObj);
			row.appendChild(cell);
			tblBody.appendChild(row);
		}
    }

     this.createModDetsRowForOtherThanCloudDBNIntegConnector = function(tblBody, modObj, className)
    {
    	var connector = ZRConnector.curConnector;
    	var connectorId = connector.split("_")[1];
    	 var row = document.createElement("tr");
         row.className = className;
         if(className == "header"){
 			var cell = document.createElement("td");
 			cell.appendChild(document.createTextNode(modObj['tn']));
 			row.appendChild(cell);
                        if(modObj['stn']!=null)
                        {
                        var cell = document.createElement("td");
 			cell.appendChild(document.createTextNode(modObj['stn']));
 			row.appendChild(cell);
                        }
			var cell = document.createElement("td");
 			cell.appendChild(document.createTextNode(modObj['lft']));
 			row.appendChild(cell);
 			tblBody.appendChild(row);
 			var cell = document.createElement("td");
 			cell.appendChild(document.createTextNode(modObj['st']));
 			row.appendChild(cell);

 		}
         else if(className == "data")
         {
        	 console.log(modObj);
	             row.setAttribute("id",modObj["objId"]);
	             var cell = document.createElement("td");
	             cell.appendChild(document.createTextNode(modObj['modname']));
	             row.appendChild(cell);
	             if(modObj['moduleSubName']!=null)
	            {
	            	 var cell = document.createElement("td");
		             cell.appendChild(document.createTextNode(modObj['moduleSubName']));
		             row.appendChild(cell);
	            }
	             var cell = document.createElement("td");
	             cell.appendChild(document.createTextNode(modObj['modlftime']));
	             row.appendChild(cell);
	             var cell = document.createElement("td");
                 var txtNode = document.createTextNode(modObj['modstatus']);
                 cell.appendChild(txtNode);
                 ZRConnector.constructModIconsForOtherThanCloudDBNIntegConnector(cell,modObj);
                 row.appendChild(cell);
                 tblBody.appendChild(row);
       }
    }

    this.constructModIconsForCloudDB = function(cell,modObj)
    {
        var val = cell.innerHTML;
        cell.innerHTML = "";
        var text = document.createElement("span");
        text.innerHTML = val;
        if(cell.className && cell.className!="" )
        {
            text.className = cell.className;
            cell.className="";
        }
        cell.appendChild(text);
        var icons = document.createElement("div");
        icons.className = "modIcons";
        var modsyncimg = document.getElementsByClassName("modSync")[0].cloneNode(true);
        jQuery(modsyncimg).bind('click'); //No I18N
        if(modObj['modstatus'] === ZDBI18NMap.g("zrpt.conn.js.modstatus.inprogress"))
        {
            modsyncimg.className = "modSync alpha";
            jQuery(modsyncimg).unbind('click'); //No I18N
            modsyncimg.onclick = null;
        }
        icons.appendChild(modsyncimg);
        var modeditimg = document.getElementsByClassName("modEdit")[0].cloneNode(true);
        jQuery(modeditimg).bind('click'); //No I18N
        icons.appendChild(modeditimg);
        var modSummaryImg = document.getElementsByClassName("modSummary")[0].cloneNode(true);
        if(modObj['modlftime'] === "-")
        {
            modSummaryImg.className = "modSummary alpha"
            jQuery(modSummaryImg).unbind('click'); //No I18N
            modSummaryImg.onclick = null;
        }
        else
        {
            jQuery(modSummaryImg).bind('click'); //No I18N
        }
        jQuery(modSummaryImg).attr("hasSyncDetails",true);//No I18N
        icons.appendChild(modSummaryImg);
        cell.appendChild(icons);
    }

    this.constructModIconsForOtherThanCloudDBNIntegConnector = function(cell,modObj)
    {
    	var connector = ZRConnector.curConnector;
        var connectorId = connector.split("_")[1];
    	var val = cell.innerHTML;
        cell.innerHTML = "";
        var text = document.createElement("span");
        text.innerHTML = val;
        if(cell.className && cell.className!="" )
        {
            text.className = cell.className;
            cell.className="";
        }
        cell.appendChild(text);
        var icons = document.createElement("div");
        icons.className = "modIcons";
        if(connectorId != 1002 && ZRConnector.isSchedulable(modObj['location']))
        {
	        var modsyncimg = document.getElementsByClassName("modSync")[0].cloneNode(true);
	        jQuery(modsyncimg).bind('click'); //No I18N
	        if(modObj['isauthenticatedImport']==true)
	        {
	        	if(modObj['location']=='FTP')
	        	{
	        		jQuery(modsyncimg).attr("FTPUSERNAME",modObj['ftpusername']);//No I18N
	    	        jQuery(modsyncimg).attr("FTPPASSWORD",modObj['ftppassword']);//No I18N
	        	}
	        	else
	        	{
	        		jQuery(modsyncimg).attr("USERNAME",modObj['username']);//No I18N
	        		jQuery(modsyncimg).attr("PASSWORD",modObj['password']);//No I18N
	        	}
	        }
	        jQuery(modsyncimg).attr("LOCATION",modObj['location']);//No I18N
	        if(modObj['modstatus'] === ZDBI18NMap.g("zrpt.conn.js.modstatus.inprogress"))
	        {
	            modsyncimg.className = "modSync alpha";
	            jQuery(modsyncimg).unbind('click'); //No I18N
	            modsyncimg.onclick = null;
	        }
	        icons.appendChild(modsyncimg);
	        var modeditimg = document.getElementsByClassName("modEdit")[0].cloneNode(true);
	        jQuery(modeditimg).bind('click'); //No I18N
	        jQuery(modeditimg).attr("OBJID",modObj['objId']); //No I18N
	        //jQuery(modeditimg).attr("LOCATION",modObj['location']); //No I18N
	        //jQuery(modeditimg).attr("FILETYPE",modObj['filetype']); //No I18N
	        //jQuery(modeditimg).attr("isGSheet",modObj['isGSheet']); //No I18N
	        //jQuery(modeditimg).attr("isZDocs",modObj['isZDocs']); //No I18N
	        //jQuery(modeditimg).attr("isExtDrive",modObj['isExtDrive']); //No I18N
	        //jQuery(modeditimg).attr("FILESUBTYPE",modObj['subfiletype']); //No I18N
	        //jQuery(modeditimg).attr("allow_schedule_interval_in_minutes",modObj['ALLOW_SCHEDULE_INTERVAL_IN_MINUTES']); //No I18N
	        //jQuery(modeditimg).attr("isOnPremiseDB",false); //No I18N
	    	//jQuery(modeditimg).attr("zdbhidesheetlist",modObj['zdbhidesheetlist']);	 //No I18N
	        //if(modObj['zdbhidesheetlist']==false)
	        //{
	        //	jQuery(modeditimg).attr("zdbsheetlist",modObj['zdbsheetlist']); //No I18N
	        //	jQuery(modeditimg).attr("gdrive_format",modObj['gdrive_format']);	 //No I18N
	        //	jQuery(modeditimg).attr("isfromgdrive",modObj['ISFROMGDRIVE']);  //No I18N
	        //	jQuery(modeditimg).attr("localfile",modObj['localfile']); 	 //No I18N
	        //	jQuery(modeditimg).attr("ISCSVMODEGSHEET",modObj['ISCSVMODEGSHEET']); 	 //No I18N
	        //}
	        icons.appendChild(modeditimg);
        }
        var modSummaryImg = document.getElementsByClassName("modSummary")[0].cloneNode(true);
        if(modObj['modlftime'] === ZDBI18NMap.g("zrpt.importutil.js.sch.notapplicable"))
        {
            modSummaryImg.className = "modSummary alpha"
            jQuery(modSummaryImg).unbind('click'); //No I18N
            modSummaryImg.onclick = null;
        }
        else
        {
            jQuery(modSummaryImg).bind('click'); //No I18N
        }
     /*   if(connectorId != 13)
        {
        	jQuery(modSummaryImg).attr("hasSyncDetails",true);
        }*/
        icons.appendChild(modSummaryImg);
        cell.appendChild(icons);
    }

    this.modInfo = function(el)
    {
        var connector = ZRConnector.curConnector;
        var connectorId = connector.split("_")[0];
        var obj = ZRConnector.connJson[connector];
        if(connectorId == -11 || connectorId == -12 || connectorId==1005 || obj.isNotCloudDBIntegConnector || connectorId == 1001 || connectorId ==1003 || connectorId == 1004)
        {
            if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImportSchedule.js,import/js/ZDBImport.js","APPENDTODOC",ZRConnector.modInfo,[el]))
            {
                return;
            }
            if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", ZRConnector.modInfo,[el])){
        	  	return;
        	}
            var objid = jQuery(el).closest('tr').attr('id'); //No I18N
            if(connectorId == 1001 || connectorId ==1003 || connectorId == 1004)
            {
                objid = connector.split("_")[1];
            }
            ZDBImportSchedule.showImportReport(el,objid);
        }
    };
    this.isSchedulable=function(location)
    {
        if(location == "LOCALDRIVE")
        {
            return false;
        }
        return true;
    }

    this.modEdit = function(el)
    {
        var connector = ZRConnector.curConnector;
        var connectorId = connector.split("_")[0];
        var obj = ZRConnector.connJson[connector];
        if(connectorId == -11 || connectorId == 1005)
        {
            if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/clouddbjs/CloudDBPage.js","APPENDTODOC",ZRConnector.modEdit,[el]))
            {
                return;
            }
            var objid = jQuery(el).closest('tr').attr('id'); //No I18N
            CloudDBPage.showModEdit(objid,connectorId == -11);
        }
        else if(connectorId == -12)
        {
            if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/odatajs/ODataPage.js","APPENDTODOC",ZRConnector.modEdit,[el]))
            {
                return;
            }
            var objid = jQuery(el).closest('tr').attr('id'); //No I18N
            ODataPage.showModEdit(objid);
        }
	else if(obj.isNotCloudDBIntegConnector)
        {
        	if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", ZRConnector.modEdit,[el])){
        	  	return;
        	}
        	if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImportSchedule.js","APPENDTODOC",ZRConnector.modEdit,[el]))
            {
                return;
            }
        	ZRConnector.modEditForOtherThanCloudNInteg(el,"onclick");//No I18N
        }
        else if(connectorId == 1001 || connectorId == 1003 || conectorId == 1004)
        {
                if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", ZRConnector.modEdit,[el])){
        	  	return;
        	}
                var objId = connector.split("_")[1];
                ZDBImportSchedule.showSchdeuleDialogFromDataSourcePage(objId);
        }
    };

    this.modEditForOtherThanCloudNInteg = function(el,event)
    {
    	var arg = ZDBCreateDB.isInHomePage()? "DONT_FETCH_SHEET":null;//To avoid url change.    //No I18N
    	var objId = el.getAttribute("OBJID");
    	var dbId = ZDBClientUI.dbId;
    	var userName = el.getAttribute("USERNAME");
        var password = el.getAttribute("PASSWORD");
        var loc = el.getAttribute("LOCATION");
    	ZDBImportSchedule.showSettingDialog(el,event,arg,objId,dbId,true,null,userName,password);
    };

    this.modSync = function(el)
    {
        var connector = ZRConnector.curConnector;
        var connectorId = connector.split("_")[0];
        var conndbinfoid = connector.split("_")[1];
        var objid = jQuery(el).closest('tr').attr('id'); //No I18N
        var obj = ZRConnector.connJson[connector];
        if(connectorId == -11)
        {
            if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/clouddbjs/CloudDBPage.js","APPENDTODOC",ZRConnector.modSync,[el]))
            {
                return;
            }
            var objid = jQuery(el).closest('tr').attr('id'); //No I18N
            CloudDBPage.refreshCloudDBTbl(el,conndbinfoid,objid,true);
        }
        else if(connectorId == -12)
        {
            if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/odatajs/ODataPage.js","APPENDTODOC",ZRConnector.modSync,[el]))
            {
                return;
            }
            var objid = jQuery(el).closest('tr').attr('id'); //No I18N
            ODataPage.refreshODataTbl(el,conndbinfoid,objid,true);
        }
	else if(obj.isNotCloudDBIntegConnector || connectorId==1005 || connectorId == 1001 || connectorId == 1003 || connectorId ==1004)
        {
        	if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImportSchedule.js","APPENDTODOC",ZRConnector.modSync,[el]))
            {
                return;
            }
            if(!(connectorId == 1001 || connectorId == 1003 || connectorId ==1004))
            {
        	var textNode = jQuery(el).parent().siblings()[0];
        	textNode.innerHTML = ZDBI18NMap.g("zrpt.conn.js.modstatus.inprogress");
        	textNode.className = 'inProgressTxt'
            el.className = "modSync alpha";
            jQuery(el).unbind('click'); //No I18N
            //el.onclick = null;
            }
            else
            {
                objid = jQuery(el).attr('objid'); //No I18N
                var status = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
		$("connSyncStatus").innerHTML = status;
		$("connSyncStatus").className = 'inProgressTxt';//No I18Ns
            }
        	ZDBImportSchedule.refetchDataFromDataSourceDlg(el,objid,connector);
        }
    };

    this.handleModEditResp = function(response, requestOptions)
    {
        ZDBInlineDialog.closeDialogByType(requestOptions["ELEMENT"]);
        ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.setting_saved"));//No I18N
    }
    this.handleClouddbModSyncResp = function(response, requestOptions)
    {
        var el = requestOptions["ELEMENT"];
        var elId ="-11_"+ requestOptions["CONNECTIONID"]; //No I18N
        var obj = ZRConnector.connJson[elId];
        var modArr = obj.modarr;
        for (var j = 0; j < modArr.length; j++)
        {
        	var modObj = modArr[j];
                if(modObj["objId"] == requestOptions["OBJID"])
                {
                    modObj["modstatus"] = ZDBI18NMap.g("zrpt.conn.js.modstatus.inprogress"); //No I18N
                    modObj["isModSyncAllowed"] = false;
                }
        }
        var textNode = jQuery(el).parent().siblings()[0];
        textNode.innerHTML = ZDBI18NMap.g("zrpt.conn.js.modstatus.inprogress");
        textNode.className = 'inProgressTxt'
        el.className = "modSync alpha";
        jQuery(el).unbind('click'); //No I18N
        el.onclick = null;
        $(elId+"_syncnow").className = "ZRSLink alpha";
        $(elId+"_syncnow").onclick = null;
        $(elId+"_syncstatus").innerHTML = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
        $(elId+"_syncstatus").className = 'inProgressTxt';//No I18N

        if(obj.isCloudDBSrc)
        {
            obj.status = 4;
            obj.isSyncNowAllowed = false;
        }
        obj.statusstr = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
    	$("connSyncStatus").innerHTML = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
    	$("connSyncStatus").className = 'inProgressTxt';//No I18N
    	$("connSyncNow").className = "ZRSLink alpha";
    	jQuery("#connSyncNow").unbind('click'); //No I18N
    };

    this.handleODataModSyncResp = function(response, requestOptions)
    {
        var el = requestOptions["ELEMENT"];
        var elId ="-12_"+ requestOptions["CONNECTIONID"]; //No I18N
        var obj = ZRConnector.connJson[elId];
        var modArr = obj.modarr;
        for (var j = 0; j < modArr.length; j++)
        {
        	var modObj = modArr[j];
                if(modObj["objId"] == requestOptions["OBJID"])
                {
                    modObj["modstatus"] = ZDBI18NMap.g("zrpt.conn.js.modstatus.inprogress"); //No I18N
                    modObj["isModSyncAllowed"] = false;
                }
        }
        var textNode = jQuery(el).parent().siblings()[0];
        textNode.innerHTML = ZDBI18NMap.g("zrpt.conn.js.modstatus.inprogress");
        textNode.className = 'inProgressTxt'
        el.className = "modSync alpha";
        jQuery(el).unbind('click'); //No I18N
        el.onclick = null;
        $(elId+"_syncnow").className = "ZRSLink alpha";
        $(elId+"_syncnow").onclick = null;
        $(elId+"_syncstatus").innerHTML = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
        $(elId+"_syncstatus").className = 'inProgressTxt';//No I18N

        if(obj.isODataSrc)
        {
            obj.status = 4;
            obj.isSyncNowAllowed = false;
        }
        obj.statusstr = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
    	$("connSyncStatus").innerHTML = ZDBI18NMap.g("zrpt.conn.js.sync_in_progress");
    	$("connSyncStatus").className = 'inProgressTxt';//No I18N
    	$("connSyncNow").className = "ZRSLink alpha";
    	jQuery("#connSyncNow").unbind('click'); //No I18N
    };
    this.handleDataSrcModSyncResp =  function(response, requestOptions)
    {
    	var el = requestOptions["ELEMENT"];
    	var connector = requestOptions["CONNECTOR"];
    	var obj = ZRConnector.connJson[connector];
    	var textNode = $("connSyncStatus");
    	textNode.innerHTML = ZDBI18NMap.g("zrpt.conn.js.modstatus.success");
    	textNode.className = 'succesText';
        ZRConnector.refreshDataSourcesDlg($("DatasourceBack"));

        }
this.handleDataSrcModSyncRespOnFailure=  function(response, requestOptions)
    {
    	var el = requestOptions["ELEMENT"];
    	var connector = requestOptions["CONNECTOR"];
    	var obj = ZRConnector.connJson[connector];
    	var textNode = $("connSyncStatus");
    	textNode.innerHTML = ZDBI18NMap.g("zrpt.conn.js.modstatus.failed");
    	textNode.className = 'faileText';
        ZRConnector.refreshDataSourcesDlg($("DatasourceBack"));

        }

    this.showNextConn = function(event, parEl)
    {
    	var curRow = (parEl) ? parEl : $(ZRConnector.curConnector);
    	var nextRow = curRow.nextElementSibling;
    	if(!nextRow || !nextRow.getAttribute("isparent") || nextRow.style.display == "none")
    	{
    		return false;
    	}
    	ZRConnector.changeClass(nextRow, event, 'switch',1);//No I18N
    	return true;
    }

    this.showPrevConn = function(event, parEl)
    {
    	var curRow = (parEl) ? parEl : $(ZRConnector.curConnector);
    	var prevRow = curRow.previousElementSibling;
    	if(!prevRow || !prevRow.getAttribute("isparent") || prevRow.style.display == "none")
    	{
    		return false;
    	}
    	ZRConnector.changeClass(prevRow, event, 'switch',-1);//No I18N
    	return true;
    }

    this.handleDlgClose = function()
    {
    	ZRConnector.curConnector = null;
    	ZRConnector.isExpanded = false;
    	ZRConnector.isDlgOpened = false;
    	return true;
    }

    this.updateSchTypeNTime = function(response, requestOptions)
    {
		var params = response.getResponseParams();
		var id = params["ID"];
		var obj = ZRConnector.connJson[id];
		obj.nextschtime = params["SCH_NEXT"];
		obj.schtype = params["SCH_TYPE"];
		if(params["SCH_LAST"])
		{
			obj.lastfetchtime = params["SCH_LAST"];
		}
		$(id+"_connSchTime").innerHTML = obj.nextschtime;
		$(id+"_connLFTime").innerHTML = obj.lastfetchtime;
		if(ZRConnector.curConnector == id)
		{
			$("connSchType").innerHTML = obj.schtype;
			$("connNextSchTime").innerHTML = obj.nextschtime;
			$("connlftime").innerHTML = obj.lastfetchtime;
		}
	}
	this.alertIfNeeded = function(response, requestOptions)
	{
		var params = response.getResponseParams();
		var delInfo = params["TO_DELETE_VIEWS"];
		if(delInfo != null)
		{
			var data = jQuery.parseJSON(delInfo);
			jQuery("#ZRConnectorResetDeleteViews").html("");//NO I18N
			var $template = jQuery('.cloneHeader');//NO I18N
			var $template1 = jQuery('.cloneObj');//NO I18N
			jQuery(data).each(function()
			{
				var $element = $template.clone().removeClass("cloneHeader").appendTo('#ZRConnectorResetDeleteViews');//NO I18N
				$element.attr('id', this.name);//NO I18N
				var txt = $element.html();
				txt = txt.replace("{MATCHTYPE}",this.type);
				txt = txt.replace("{MATCHVIEW}",this.name);
				$element.html(txt);

				jQuery(this.objects).each(function()
				{
					var $element1 = $template1.clone().removeClass("cloneObj").appendTo('#ZRConnectorResetDeleteViews');//NO I18N
					$element1.attr('id', this.name);//NO I18N
					var txt=$element1.html();
					txt =txt.replace("{MATCHTYPE}",this.type);
					txt =txt.replace("{MATCHVIEW}",this.name)
					$element1.html(txt);
				});
			});
			var delDiv = jQuery("#ZRConnectorDeleteViews").parent().html();//NO I18N
			var div = document.createElement("div");
			div.innerHTML = delDiv;
			ZDBDialogUtil.showDialog(div,{TITLE:ZDBI18NMap.g("zrpt.connector.js.deletefields"), ADDFRAME:true,MODAL:true,DONTREMOVE:false,PARAMS:requestOptions.PARAMS,POSTBODY:requestOptions.POSTBODY});
		}
		else
		{
			ZDBDialogUtil.closeDialog();
			ZDBMsgBox.showSuccess(response.responseText);
		}
	}
	this.submitConnYESButton = function(el)
	{
		var params  = ZDBDialogUtil.dialogs[1].params["PARAMS"];
		params = params.replace("CONFIRMED=false", "CONFIRMED=true");
		var connNum = ZRConnector.curConnector.split("_")[0];
		if(connNum == -1)
		{
			AjaxAPI.sendRequest({URL:"/ZDBCRMAction.ma?&ZDBACTION=CRMEDITFIELDS",
			ONSUCCESSFUNC:ZDBCRMInteg.handleSubmitFieldDetSucc,OPSTATUSID:"ZDBMainLoader",PARAMETERS:params}); //No I18N
		}
		else if(connNum == 0)
		{
			AjaxAPI.sendRequest({URL:"/ZDBSFAction.ma?&ZDBACTION=SFCHANGESCH", METHOD:"POST",PARAMETERS:params,
			ONSUCCESSFUNC:ZRSFIntegration.handleSubmitFieldDetSucc,OPSTATUSID:"ZDBMainLoader",PARAMS:params}); //No I18N
		}
		else
		{
			AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?&ZDBACTION=SAVEEDITSETTINGS",
			ONSUCCESSFUNC:ZRSFIntegration.handleSubmitFieldDetSucc,OPSTATUSID:"ZDBMainLoader",PARAMETERS:params}); //No I18N
		}
		ZDBDialogUtil.closeDialog();
	}

	this.updateCRMDBStatus = function(response, requestOptions)
	{
		var params = response.getResponseParams();
		var id = params["ID"];
		var obj = ZRConnector.connJson[id];
		obj.nextschtime = params["SCH_NEXT"];
		obj.schtype = params["SCH_TYPE"];
		obj.status = params["STATUS"];
		obj.statusstr = params["STATUS_STR"];
		$(id+"_connSchTime").innerHTML = obj.nextschtime;
		if(ZRConnector.curConnector == id)
		{
			ZRConnector.handleDlgClose();
			ZRConnector.changeClass($(id), null, 'switch');//No I18N
		}
	};

	this.selectModule = function(elem, mod)
	{
		jQuery("#"+mod+" :checkbox").prop("checked",true); //NO I18N
	}

	this.showSetupDets = function(el)
	{
		if(el.value === "dummy")
		{
			$("setupDetsListing").innerHTML = "";
			return;
		}
		AjaxAPI.sendRequest({
			URL:"/ConnectorAction.ma?ZDBACTION=CONNSETUPDETS&CONNECTORID="+el.value,//No I18N
			ONSUCCESSFUNC:ZRConnector.showSetuDpDetsSucc
		});
	}

	this.showSetuDpDetsSucc = function(response, requestOptions)
	{
		var jsonResp = JSON.parse(response.responseText);

		$("setupDetsListing").innerHTML = "";
		var tbl     = document.createElement("table");
		tbl.className = "connModDetailsTbl";
		var tblHeader = document.createElement("thead");
		var tblBody = document.createElement("tbody");

		for (var key in jsonResp)
		{
			var row = document.createElement("tr");
			var keyCell = document.createElement("td");
			var valueCell = document.createElement("td");
			var input = document.createElement("textarea");
			input.setAttribute('type','text');
			input.setAttribute('id',key);
			input.setAttribute('name',key);
			input.innerHTML =  jsonResp[key];
			input.style.width = "300px";
			input.style.maxWidth = "300px";//No I18N
			input.style.height = "30px";
			var cellText = document.createTextNode(key+":");

			keyCell.appendChild(cellText);
			valueCell.appendChild(input);
			row.appendChild(keyCell);
			row.appendChild(valueCell);
			tblBody.appendChild(row);
		}

		tbl.appendChild(tblHeader);
		tbl.appendChild(tblBody);
		$("setupDetsListing").appendChild(tbl);
	}

	this.getConnSetupParamAsJSON = function()
	{
		var selCols="{";
		jQuery('textarea').each(function() {//NO I18N
			selCols += "\"" + (jQuery(this).attr('id')) + "\":\"" + (jQuery(this).attr('value')) +  "\"," ;//NO I18N
		});
		selCols = selCols.substring(0, selCols.length - 1);
		selCols += "}";
		return selCols;
	};

	this.getSchTimeZone = function()
	{
		return encodeURIComponent($("ZDB_DLY_TIMEZONE_SEARCH_ZRTimezoneList").getAttribute("selectedTimezone"));
	};

	this.removeTimeZoneComponent = function()
	{
		var tzComp = $('ZDB_DLY_TIMEZONE_SEARCH_ZRScheduleTimeZoneComponent');
		if(tzComp) {
			tzComp.parentNode.removeChild(tzComp);
		}
		return true;
	};

	this.getCleanupMonths = function()
	{
		var cleanup = $("CLEANUPSELECT");
		return cleanup.options[cleanup.selectedIndex].value;
	}

	this.setCleanupMonths = function()
	{
		var cleanupOptions = $("CLEANUPSELECT")
		for (var i = 0; i < cleanupOptions.options.length; i++)
		{
			if (cleanupOptions.options[i].value === $("CLEANUPMONTHS").value)
			{
				cleanupOptions.options[i].selected = true;
				return;
			}
		}
	}

	this.selectAll = function(el, container)
	{
		var menu = jQuery($(container));
		var inputList = menu.find("input:checkbox:not(:disabled)");
		for(var i=0;i<inputList.length; i++)
		{
			var val = inputList[i].getAttribute("value");
			inputList[i].checked=el.checked;
		}
	};

	this.checkIfAllSelOrDesel = function(el, id, container)
	{
		if(el && !el.checked)
		{
			$(id).checked=false;
		}
		var menu = $(container);
		var inputList = menu.getElementsByTagName("input");
		for(var i = 0;i < inputList.length;i++)
		{
			if(!inputList[i].checked)
			{
				$(id).checked=false;
				return;
			}
		}
		$(id).checked=true;
	};

	this.changeSchTimeToCurrentTime = function()
	{
		var curTime = new Date();
		var mins = parseInt(curTime.getMinutes() / 5) * 5;
		var hours = curTime.getHours();
		$("ZCDailyMinsInt").value = mins;
		$("ZCDailyHourInt").value = hours;
	};
	//--ZROP Changes--Client Keys in DB--
	this.updateOAuthDetails = function(connDBInfoId,clientIdKey,clientSecretKey)
    {
        if(document.getElementById("CLIENTID").disabled||document.getElementById("CLIENTSECRETKEY").disabled){
            document.getElementById("CLIENTID").disabled=false;
            document.getElementById("CLIENTSECRETKEY").disabled=false;
            document.getElementById("keysEditBtn").value="Save"; //No I18N
        }
        else{
            var clientIdVal=document.getElementById("CLIENTID").value;;
            var clientSecretVal=document.getElementById("CLIENTSECRETKEY").value;
            AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?ZDBACTION=UPDATEKEYSINDB&CONNDBINFOID="+connDBInfoId+"&CLIENTIDKEY="+clientIdKey+"&CLIENTIDVAL="+clientIdVal+"&CLIENTSECRETKEY="+clientSecretKey+"&CLIENTSECRETVAL="+clientSecretVal, METHOD:"POST",
            ONSUCCESSFUNC:ZRConnector.updateOAuthSuccess,ONFAILUREFUNC:ZRConnector.updateOAuthFail,OPSTATUSID:"ZDBMainLoader"}); //No I18N
        }
    };
    this.updateOAuthSuccess = function(){
        document.getElementById("CLIENTID").disabled=true;
        document.getElementById("CLIENTSECRETKEY").disabled=true;
        document.getElementById("keysEditBtn").value="Edit"; //No I18N
        alert("Successfully updated the OAuth Keys."); //No I18N
    };
    this.updateOAuthFail = function(){
        alert("Failed to update OAuth Keys."); //No I18N
    };
    //--ZROP Changes--Client Keys in DB--

	this.prepareSelectedLookups = function(div)
	{

		var selAll = $("selAllRelations");
		if(selAll.checked)
		{

		}
		  var selMods = [];
	      jQuery('div#' + div + ' input[type=checkbox]').each(function() {//NO I18N
	          if ($(this).checked) {
	        	  selMods.push(jQuery(this).attr('joinInfo'));  //NO I18N
	          }
	       });
	     // return JSON.stringify(selMods);
	      showprevform();
	}



	this.showRelations = function(jsonObj)
	{
	    if($("ZDBImportFileWithRelation") !=null)
        {
            $("ZDBImportFileWithRelation").parentNode.removeChild($("ZDBImportFileWithRelation"));
        }
	    var div = document.createElement("div");
	    div.id = "ZDBImportFileWithRelation";
	    div.style.left="34%";
	    div.style.top=parseInt(jQuery("#ZDBMAINEL").position().top)+parseInt(jQuery("#ZDBTABTPL").height())+parseInt(1)+"px";
	    div.style.width="63%";
	    div.style.marginRight="25px";//No I18N
	    div.style.float="left";//No I18N
	    div.style.tabindex = "-1";
	    ev.addEscHandle(ZDBCreateDB.showprevformonEsc);
	    jQuery(div).append($("IM_JOIN_TABLES").innerHTML);
	    var enclosingdiv = document.createElement("div");
	    enclosingdiv.setAttribute("id","EnclosingDiv");
	    enclosingdiv.style.float="left";//No I18N
	    jQuery(div).append(enclosingdiv);
	    var impHelp = $("HELPTEXT").cloneNode(true);
	    impHelp.setAttribute("id","HELPTEXTV");
	    jQuery(jQuery(impHelp).find("#ZRSVideoDemoHelp")).css("display","none");// No I18N
	    jQuery(jQuery(impHelp).find("#ZRSSnapShotTour")).css("display","none");  // No I18N
	    impHelp.style.display="block";
	    var clone = ZDBUtil.getCachedRef(ZDBImport,"RELATION").cloneNode(true);
	    clone.style.display="block";
	    clone.querySelectorAll("#createMultiConnLookup")[0].setAttribute("id","ZDBImportTableCreateWithLookupLink");//No I18N
	    clone.querySelectorAll("#LOADINGDIV")[0].setAttribute("id","ZDBIMPORTWITHLOOKUPOPSTATUS");//No I18N
	    clone.querySelectorAll("#LOADINGDIVLABEL")[0].setAttribute("id","ZDBIMPORTWITHLOOKUPOPSTATUSLABEL");//No I18N
	    jQuery(div).append(clone);
	    var freezelayer = jQuery(document.createElement("div"));
	    var joindialog = jQuery(div);
	    joindialog.attr("class","relatetabledialog");//No I18N
	    freezelayer.attr("class","freezeLayer");//No I18N
	    freezelayer.attr("ID","IMPORTFREEZE");//No I18N
	    freezelayer.css("top",parseInt(jQuery("#ZDBMAINEL").position().top)+parseInt(1)+"px");//No I18N
	    freezelayer.css("z-index",jQuery(div).attr("z-index"));//No I18N
	    jQuery(document.body).append(freezelayer);
	    jQuery(document.body).append(div);
	    var template = ZDBUtil.getCachedRef(ZDBImport,"JoinTemplate").cloneNode(true);
	    template.setAttribute("id","JoinTemplateDIV")
	    jQuery(div.querySelectorAll("div#COLUMNLISTDROPDOWN1")[0]).attr("id","COLUMNLISTDROPDOWN");//No I18N
	    jQuery(div.querySelectorAll("div#COLtemplate")[0]).append(jsonObj.data[0]);
	    jQuery(div.querySelectorAll("div#FKCOLDROPDOWN1")[0]).attr("id","FKCOLDROPDOWN");//No I18N
	    jQuery(div.querySelectorAll("div#FKtemplate")[0]).html(jsonObj.data[0]);
	    jQuery(div).append(template);
	    var lookupData = jsonObj.data;
	    if(lookupData)
	    {
          for(var i=0;i<lookupData.length;i++)
          {
        	 var conn = lookupData[i];
        	 var joins = conn.joins;
        	 for(var j=0;j<joins.length;j++)
    		 {
        		 var clone = template.cloneNode(true);
	             clone.setAttribute("id","JOINLIST");
	             clone.setAttribute("joinInfo",JSON.stringify(joins[j]));
	             clone.setAttribute("conndbid",conn.conndbinfoid);
	             clone.style.display="block";
	             jQuery(clone.querySelectorAll("div#FKtemplate")[0]).html(joins[j].existConnFieldDispName);
	             clone.querySelectorAll("#leftCol")[0].innerHTML = joins[j].newConnModDispName + "." + joins[j].newConnFieldDispName;
	             clone.querySelectorAll("#rightCol")[0].innerHTML = conn.connname.bold() + " --> " + joins[j].existConnModDispName + "." + joins[j].existConnFieldDispName;
	             clone.querySelectorAll("#leftCol")[0].setAttribute("value",joins[j].existConnFieldDispName);
		         clone.querySelectorAll("#rightCol")[0].setAttribute("value",joins[j]);
		         ZDBUtil.getCachedRef(ZDBImport,"EnclosingDiv").appendChild(clone);
	             jQuery("#EnclosingDiv").append(clone); //No I18N

	             if(joins[j].parent == "left")
	             {
	            	 jQuery("#JOINDIV").className="leftJoinIconNew";
	             }
	             else
                 {
	            	 jQuery("#JOINDIV").className="rightJoinIconNew";
                 }

          }
	    }

	    $("EnclosingDiv").style.width="97%";
	    $("EnclosingDiv").style.height="55%";
	    $("EnclosingDiv").style.overflow="auto";
	    $("EnclosingDiv").style.marginBottom="30px";//No I18N

	    if(jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0] !=undefined)
        {
            jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0].innerHTML = ZDBI18NMap.g('zrpt.home.import.js.joinTablesDesc');//No I18N
        }
        var w =document.body.offsetWidth-parseInt($("ZDBImportFileWithRelation").offsetWidth);
        joindialog.animate({left: w+'px'}).show().focus();//No I18N
        window.joinFrm = $("EnclosingDiv").cloneNode(true);
		}
	}

	this.gotoExplorerView = function(dialog)
	{
		var params = dialog.params["REQPARAMS"];
		window.url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID="+ params["DBID"]; // No I18N
		setTimeout(function(){window.location.href = window.url}, 0);
	}

	this.toggleAllCheckBoxes = function(parentDivId,enable)
	{
	    var checks = document.querySelectorAll('#' + parentDivId + ' input[type="checkbox"]');	//NO I18N
	    for(var i =0; i< checks.length;i++)
	    {
	        var check = checks[i];

	        if(!check.disabled)
	        {
	            check.checked = enable;
	        }
	    }
	};
    
	this.connSetupFailure = function(response, requestOptions)
    {
        var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        errCode = trimAll(errCode);
        if (errCode != null)
        {
            AjaxAPI.onFailureFunc(response, requestOptions);
        }
    }
	
}


ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.hideMsgBox"] = ZRConnector.hideMsgBox;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.retryInit"] = ZRConnector.retryInit;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.showDataSourcesDlg"] = ZRConnector.showDataSourcesDlg;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.showEditSetupFromMenu"] = ZRConnector.showEditSetupFromMenu;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.showAuthDlgFromMenu"] = ZRConnector.showAuthDlgFromMenu;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.deleteConnector"] = ZRConnector.deleteConnector;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.syncNow"] = ZRConnector.syncNow;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.getCleanupMonths"] = ZRConnector.getCleanupMonths;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.setCleanupMonths"] = ZRConnector.setCleanupMonths;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.showEditSyncDlg"] = ZRConnector.showEditSyncDlg;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRConnector.showEditSyncDlgFromMenu"] = ZRConnector.showEditSyncDlgFromMenu;

