//$Id$
var ZDBContentCache = new function()
{
  this.parsedInfo={};
  this.contents={};
  this.userInfo = {};
  this.contentCache = function(localeInfo)
  {
	  var path = ZDBGlobal.CONTENTPATH + "/" + encodeURIComponent(localeInfo);
		  path += ((ZDBClientUI.standAlone) ? "/ViewModeContentNew.txt" : "/FullModeContent.txt"); //No I18N
      ZDBLazyLoadUtil.addVersion([path]);
      AjaxAPI.sendRequest({URL:path,METHOD:"GET",NOSUBREQPARAM:true,MODULENAME:"GridMenu",ONSUCCESSFUNC:ZDBContentCache.storeContent}); //No I18N
  }
    
  this.storeContent = function(response,requestOptions)
  {
    ZDBContentCache.contents[requestOptions["MODULENAME"]] = response.responseText;
    ZDBContentCache.updateUserInfo();
    ZDBContentCache.dummyDiv = document.createElement("div");
  }
  
  this.appendAndGet = function(contentName,moduleName,parElToAppend)
  {
    var contentEl = this.getContent(contentName,moduleName);
    if(contentEl == null){ return null;}
    if((parElToAppend != null) && (contentEl.parentNode != parElToAppend))
    {
      parElToAppend.appendChild(contentEl);
    }
    return contentEl;
  }
  
  this.getContent = function(contentName,moduleName)
  {
    var content = ZDBContentCache.contents[moduleName];
    if(content == null)
    {
      return null;
    }
    var contentEl = this.parsedInfo[contentName];
    if(contentEl != null)
    {
      return contentEl;
    }
    var startIdx = content.indexOf("<!--"+ contentName +"_Start-->");
    if(startIdx < 0)
    {
      throw new Error(contentName + " start is not present"); //No I18N
    }
    var endIdx = content.indexOf("<!--"+ contentName +"_End-->",startIdx);
    if(endIdx <0)
    { 
      throw new Error(contentName + " end is not present"); //No I18N
    }
    var snippet = content.substring(startIdx,endIdx);
    snippet = this.disableElInSnippet(snippet);
    ZDBContentCache.dummyDiv.innerHTML = snippet;
    var childNodes = ZDBContentCache.dummyDiv.childNodes;
    for(var i=0,len = childNodes.length;i< len;i++)
    {
      if(childNodes[i].getAttribute)
      {
        contentEl = childNodes[i];
        contentEl.parentNode.removeChild(contentEl);
        break;
      }
    }
    if(contentEl == null)
    {
      throw new Error(contentName + " has no elements");  //No I18N
    }
    this.parsedInfo[contentName] = contentEl;
    return contentEl;
  }


  this.disableElInSnippet = function(snippet) 
  {
    var startIdx = snippet.indexOf("{{{");
    var endIdx = -3;
    var strArr = [];
    while(startIdx > -1)
    {
      strArr.push(snippet.substring(endIdx + 3,startIdx));
      endIdx = snippet.indexOf("}}}",startIdx + 3);
      if(endIdx < 0)
      {
        endIdx = startIdx -3;
        break;
      }      
      var repVal = snippet.substring(startIdx + 3, endIdx);
      var replaceWith = ZDBContentCache.userInfo[repVal];
      strArr.push(replaceWith);
      startIdx = snippet.indexOf("{{{",endIdx + 3);
    }
    strArr.push(snippet.substring(endIdx + 3,snippet.length));
    return strArr.join("");
  }

  
  this.updateUserInfo = function()
  {
    this.userInfo['hideOnStandAlone'] = (ZDBClientUI.hideOnStandAlone)? "style='display:none;' " : "";  //No I18N
    this.userInfo['hideOnNotDBOwnerAndNotGroupUser'] = (ZDBClientUI.hideOnNotDBOwnerAndNotGroupUser)?"style='display:none;' " : ""; //No I18N
    this.userInfo['isBetaCustomer'] = (ZDBClientUI.isBetaCustomer) ? "" : "style='display:none;'";  //No I18N
    this.userInfo['hideIfRemoteDB'] = (ZDBClientUI.isRemoteDB) ? "style='display:none;'" : "";  //No I18N
    this.userInfo['hideIfNotRemoteDB'] = (ZDBClientUI.isRemoteDB) ? "" : "style='display:none;'";  //No I18N
    this.userInfo['enabledyndrillComp'] = ((ZDBGlobal.isDynDrillEnabled)===true) ? ZDBI18NMap.g("zrpt.common.js.drilldowndyndrillJS"): ZDBI18NMap.g("zrpt.common.js.drilldown"); 
    this.userInfo['enabledefdrilldisp']=(ZDBGlobal.isDynDrillEnabled)===true ?  ZDBI18NMap.g("zrpt.common.js.defdrilldowndyndrillJS") :""; 
    this.userInfo['dyndrillpadding']=(ZDBGlobal.isDynDrillEnabled)===true ? "padding:0 5px" :"padding:0 13px"; // NO I18N
    this.userInfo['showZia'] = (ZDBGlobal.enableZIA)===true ? '': 'style="display:none"';//NO I18N
    this.userInfo['enableZSheet']=(ZDBGlobal.isZSheetEnabled)===true ? "" : "style='display:none;'";	//No I18N
  }
  
  this.appendAndGetEl = function(elementId,parElToAppend)
  {
    var el = $(elementId);
    if(parElToAppend != null && el.parentNode != parElToAppend)
    {
      parElToAppend.appendChild(el);
    }
    return el;
  }
}