//$Id$
phantom.onError = function(msg, trace) {
    var msgStack = ['PHANTOM ERROR: ' + msg]; //No I18N
    if (trace && trace.length) {
        msgStack.push('TRACE:'); //No I18N
        trace.forEach(function(t) {
            msgStack.push(' -> ' + (t.file || t.sourceURL) + ': ' + t.line + (t.function ? ' (in function ' + t.function+')' : ''));//No I18N
        });
    }
    console.log(msgStack.join('\n')); //No I18N
    //phantom.exit(1);
};

var injectJS,
    config,
    pick;
var SVG_DOCTYPE = '<?xml version=\"1.0" standalone=\"no\"?><!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\" \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\">';//No I18N

var fs = require('fs');//No I18N

injectJS = function(obj, path) {
    //var path ="/home/likewise-open/ZOHOCORP/ankit-2213/eclipse/ZIDE/deployment/ZCExport/AdventNet/ZohoDB/bin/"+path;
    var wasSuccessful = obj.injectJs(path);
    if (wasSuccessful) {
        console.log("Javascript injection succeeded in " + obj + ":" + path);//No I18N
    } else {
        throw new Error("Javascript injection failed in " + obj + ":" + path);//No I18N
    }
};

pick = function() {
    var args = arguments,
        i, arg, length = args.length;
    for (i = 0; i < length; i += 1) {
        arg = args[i];
        if (arg !== undefined && arg !== null && arg !== 'null' && arg != '0') { //No I18N
            return arg;
        }
    }
};

startServer = function(port) {
    var server = require('webserver').create();//No I18N
    var service = server.listen(port, function(request, response) {
        var jsonStr = request.post.jsondata,
            params,
            msg;
        try {
            var errorHandlerFunction = function(result) {
                msg = config.HANDLEABLE_ERROR_TOKEN+"Failed exporting: \n" + result;//No I18N
                response.statusCode = (result === "Invalid Data") ? 400 : 500; //No I18N
                response.setHeader('Content-Type', 'text/plain');//No I18N
                response.setHeader('Content-Length', msg.length);//No I18N
                response.write(msg);
                response.close();
            };

            var resultHTML = function(result) {
                response.statusCode = 200;
                response.setHeader('Content-Type', 'text/html');//No I18N
                response.setHeader('Content-Length', result.length);//No I18N
                response.write(result);
                response.close();
            };
            var resultFILE = function(result) {
                response.statusCode = 200;
                response.setHeader('Content-Type', 'text/plain');//No I18N
                response.setHeader('Content-Length', result.length);//No I18N
                response.write(config.RESULT_IS_FILE+result);
                response.close();
            };
            var resultBASE64 = function(result) {
                response.statusCode = 200;
                response.setHeader('Content-Type', 'text/plain');//No I18N
                response.setHeader('Content-Length', result.length);//No I18N
                response.write(result);
                response.close();
            };
            console.log("\nJSONString: "+jsonStr+"\n");
            params = JSON.parse(jsonStr);
            if (params.status) {
                response.statusCode = 200;
                response.setHeader('Content-Type', 'text/plain');//No I18N
                response.write('OK');//No I18N
                response.close();
            } 
            else
            {
                var fileext = params["filename"] && params["filename"].split('.').pop(); //No I18N
                var outType = pick(params["outType"], fileext, "png");//No I18N
                params["outType"] = outType;//No I18N
                var callback;
                if (outType == "html") {//No I18N
                    callback = resultHTML;
                } 
                else
                {
                    if (params["isBase64"]) {//No I18N
                        callback = resultBASE64;
                    } else {
                        callback = resultFILE;
                    }
                }
                exportTask(params, callback, errorHandlerFunction);
            }
        }
        catch (e)
        {
            msg = config.HANDLEABLE_ERROR_TOKEN+"Failed rendering: \n" + e;//No I18N
            response.statusCode = 500;
            response.setHeader('Content-Type', 'text/plain');//No I18N
            response.setHeader('Content-Length', msg.length);//No I18N
            response.write(msg);
            response.close();
        }
    }); // end server.listen

    // switch to serverMode
    if (service) {
        serverMode = true;
        console.log("OK, PhantomJS is ready.");//No I18N
        injectJS(phantom, "waitfor.js");//No I18N
    } else {
        console.log("Unable to create Server");//No I18N
        phantom.exit(1);
    }
};
var system = require('system');//No I18N
var mapCLArguments = function() {
    var map = {},
        i,
        key;
    if (system.args.length < 7) {
        console.log('Commandline Usage: ExportLib.js -port PORT -libpath LIBPATH -modulepath MODULEPATH');//No I18N
        phantom.exit(1);
    }
    for (i = 0; i < system.args.length; i += 1) {
        if (system.args[i].charAt(0) === '-') {//No I18N
            key = system.args[i].substr(1);
            map[key] = system.args[i + 1];
        }
    }
    return map;
};
config = mapCLArguments();
phantom.libraryPath = config.libpath;
config.pagelibraryPath = config.libpath;
config.HANDLEABLE_ERROR_TOKEN="";//$&!%HANDLEABLE_ERROR&^%$";//No I18N
config.RESULT_IS_FILE = "$&!%RESULT_IS_FILE&^%$";//No I18N
startServer(config.port);


var exportTask = function(params, exitCallback, errorHandlerFunction) {
    var maxWaitForAllResourcesToLoad = params["maxWaitForAllResourcesToLoad"],
        minWaitToCheckResourceRequest = 200,
        count = 0,
        resourcesLoaded = false,
        resourceRequested = false;
    var page = require('webpage').create(); //No I18N
    if(params["pageSettings"])
    {
        var pageSettings = params["pageSettings"];
        for(var i in pageSettings)
        {
            page.settings[i] = pageSettings[i];
        }
    }
    var resourceLoadedTimeout, waitForOtherResourceRequest = 300;
    var externalJsCounter = 0,
        externalJSLoaded = false;
    var viewPortWidth = 1280;
    if(params['viewPortWidth'])
    {
         viewPortWidth = parseInt(params['viewPortWidth']);
    }
    page.viewportSize = {
            width:viewPortWidth,
            height: 1024
    };
    page.onConsoleMessage = function(msg) {
        console.log(msg);
    };

    page.onError = function(msg, trace) {
        var msgStack = ['PAGE ERROR: ' + msg];//No I18N
        if (trace && trace.length) {
            msgStack.push('TRACE:');//No I18N
            trace.forEach(function(t) {
                msgStack.push(' -> ' + t.file + ': ' + t.line + (t.function ? ' (in function "' + t.function+'")' : ''));//No I18N
            });
        }
        console.log(msgStack.join('\n'));//No I18N
        //exit("Error in webpage:" + msgStack.join('\n'), true); //No I18N
    };

    page.onResourceRequested = function(req) {
        resourceRequested = true;
        count += 1;
        console.log('> ' + req.id + ' - ' + req.url);//No I18N
        clearTimeout(resourceLoadedTimeout);
    };

    page.onResourceReceived = function(res) {
        if (!res.stage || res.stage === 'end') {//No I18N
            count -= 1;
            if(resourcesLoaded==true)
            {
            console.log("Resource received after maxWaitForAllResourcesToLoad: "+res.id + ' ' + res.status + ' - ' + res.url);//No I18N    
            }
            else
            {
            console.log(res.id + ' ' + res.status + ' - ' + res.url);//No I18N
            }
            if (count === 0) {
                resourceLoadedTimeout = setTimeout(function() {
                    resourcesLoaded = true;
                }, waitForOtherResourceRequest);
            }
        }
    };

    page.onResourceFailure = function(res) {
        if (!res.stage || res.stage === 'end') {//No I18N
            count -= 1;
            if(resourcesLoaded==true)
            {
            console.log("Resource failed to load after maxWaitForAllResourcesToLoad: "+res.id + ' ' + res.status + ' - ' + res.url);//No I18N    
            }
            else
            {
            console.log(res.id + ' ' + res.status + ' - ' + res.url);//No I18N
            }
            if (count === 0) {
                resourceLoadedTimeout = setTimeout(function() {
                    resourcesLoaded = true;
                }, waitForOtherResourceRequest);
            }
        }
    };

    var waitForResourcesToLoad = function(method) {
        console.log("Current Stage: waitForResourcesToLoad");
        setTimeout(function() {
            if (!resourceRequested) {
                console.log("No resource is present for loading");//No I18N
                method();
            } else {
                console.log("maxWaitForAllResourcesToLoad: "+maxWaitForAllResourcesToLoad);
                waitFor(function() {
                    return resourcesLoaded;
                }, method, maxWaitForAllResourcesToLoad);
            }
        }, minWaitToCheckResourceRequest);
    };

    var pageSetup = function() {
        if (params['URLSOURCE']) {//No I18N
            var address = params['URLSOURCE'];//No I18N
            page.open(address, function(status) {
                if (status == "success") {//No I18N
                    waitForResourcesToLoad(loadJSSetup);
                } else {
                    exit("Unable to open the page: Please check the URL input", true);//No I18N
                }
            });
        } else if (params['HTMLSOURCE']) {//No I18N
            page.content = params['HTMLSOURCE'];//No I18N
            waitForResourcesToLoad(loadJSSetup);
        } else if (params['LOADMODULE']) {//No I18N
            var modulename = params["LOADMODULE"]["NAME"];//No I18N
            var pageaddress = params["LOADMODULE"]["PAGE"];//No I18N
            page.open(config.modulepath + modulename + "/" + pageaddress, function(status) {
                if (status == "success") {//No I18N
                    waitForResourcesToLoad(loadJSSetup);
                } else {
                    exit("exit unable to load the module", true);//No I18N
                }
            });
        } else {
            exit("Please provide a source parameter from one of these HTMLSOURCE, URLSOURCE, or LOADMODULE", true);//No I18N
        }
    };

    var decrementExternalJSCounter = function() {
        externalJsCounter -= 1;
        if (externalJsCounter < 1) {
            externalJSLoaded = true;
        }
    };

    var loadLocalJS = function(localJsFilesList) {
        if (config.pagelibraryPath) {
            page.libraryPath = config.pagelibraryPath;
        }
        for (var i = 0, n = localJsFilesList.length; i < n; i++) {
            //jsCounter will change for this case;
            if (page.injectJs(localJsFilesList[i])) {
                console.log(localJsFilesList[i] + "  loading succeeded");//No I18N
            } else {
                exit("not able load local js " + localJsFilesList[i], true);
            }
        }
        startProcess();
    };

    var resetBrowserDefaultStyle = function() {
        page.evaluate(function(params) {
            document.body.style.margin = '0px';//No I18N
            if (params["outType"] == "jpg" || params["outType"] == "jpeg") {//No I18N
                document.body.style.background = "white";//No I18N
            }
        }, params);
     };
    
    var checkIfBodyIsPresent = function()
    {
        if(document.body)
        {
            return true;
        }
        else
        {
            return false;
        }
    };

    var setEnvironment = function(){
        /*
          'BROWSER_PHANTOMJS' key in window helps user to detect the phantomjs environment
          during runtime 
        */
        window.BROWSER_PHANTOMJS = true;
    };

    var startProcess = function() {
        console.log("Current Stage: startProcess");
        page.evaluate(setEnvironment);
        if(page.evaluate(checkIfBodyIsPresent)) //If the url is a resource url (eg. image url) then there will not be any body
        {    
            resetBrowserDefaultStyle();
            executeUserProvidedJavascript();
            waitForConditionSetup(startSelectorProcess);
        }
        else //URL is a resource url
        {
            var renderElementObject;
            renderElementObject = {};
            renderElementObject.clipRectObject = page.evaluate(function(){
              return document.documentElement.getBoundingClientRect();  
            });
            renderElementObject.htmlContent = page.content;
            startRenderingProcess(renderElementObject);
        }
    };

    var startSelectorProcess = function() {
        console.log("Current Stage: startSelectorProcess");
        var renderElementObject;
            renderElementObject = page.evaluate(getElementToRender, params);     
            if (renderElementObject["ERROR"]) {//No I18N
                exit(renderElementObject["ERROR"], true);//No I18N
            }
            startRenderingProcess(renderElementObject);
    };

    var startRenderingProcess = function(renderElementObject)
    {
        console.log("Current Stage: startRenderingProcess");
        if (params["outType"] == "html") {//No I18N
                //console.log(")))))))))))))))))))"+renderElementObject.htmlContent);
                returnHTML(renderElementObject);
        } else {
                returnFile(renderElementObject);
        }
    };

    var waitForConditionSetup = function(sucessFunction) {
        var waitForWithException = function(testFx, onReady, timeOutMillis) {
            var maxtimeOutMillis = timeOutMillis ? timeOutMillis : 3000, //< Default Max Timout is 3s
                start = new Date().getTime(),
                condition = false,
                interval = setInterval(function() {
                    if ( (new Date().getTime() - start < maxtimeOutMillis) && !condition ) {
                        // If not time-out yet and condition not yet fulfilled
                        condition = (typeof(testFx) === "string" ? eval(testFx) : testFx()); //< defensive code  //No I18N
                    } else {
                        if(!condition) {
                            // If condition still not fulfilled (timeout but condition is 'false')
                            console.log("'waitFor()' timeout");//No I18N
                            exit("Invalid Data", true); //No I18N
                            clearInterval(interval);
                        } else {
                            // Condition fulfilled (timeout and/or condition is 'true')
                            console.log("'waitFor()' finished in " + (new Date().getTime() - start) + "ms.");//No I18N
                            //typeof(onReady) === "string" ? eval(onReady) : onReady(); //< Do what it's supposed to do once the condition is fulfilled  //No I18N
                            waitForResourcesToLoad(onReady);
                            clearInterval(interval); //< Stop this interval
                        }
                    }
                }, 50); //< repeat check every 50ms
          };


        var maxWaitingTimeForCondition = params['maxWaitingTimeForCondition'];
        var waitForCondition = params["waitFor"];//No I18N
        if (waitForCondition) {
            console.log("Current Stage: waitForConditionSetup");
            console.log("maxWaitingTimeForCondition "+maxWaitingTimeForCondition);
            page.evaluate(function(condition) {
                var scriptElement = document.createElement("script");//No I18N
                //check whether the same checkWaitForCondition already exist
                scriptElement.innerHTML = "function checkWaitForCondition(){if(" + condition + "){return true;}else{return false;}}";//No I18N
                document.body.appendChild(scriptElement);
            }, waitForCondition);
            var waitingForConditionFunction = function() {
                // Check in the page if a specific element is now visible
                return page.evaluate(function() {
                    return checkWaitForCondition();
                });
            };
            waitForWithException(waitingForConditionFunction, sucessFunction, maxWaitingTimeForCondition);
        } else {
            sucessFunction();
        }
    };

    var exit = function(result, isError) {
        if (serverMode) {
            page.close();
        };
        if (isError) {
            errorHandlerFunction(result);
            if(result !== "Invalid Data") {
                phantom.exit(1);
            }
        } else {
            exitCallback(result);
        }
        //console.log(result);
    };

    var returnFile = function(resultObj) {
        console.log("current stage: returnFile");
        if(params['clipRectObject'])
        {
            page.clipRect = params['clipRectObject'];
        }
        else if(resultObj.clipRectObject!=null)
        {
           page.clipRect = resultObj.clipRectObject; 
        }
        var filename = params["filename"];//No I18N
        var outType = params["outType"];//No I18N
        if (outType == 'pdf') {//No I18N
                //page.paperSize
                    //var uniqueFileName = Math.random().toString(36).slice(2);
                    //var renderedFileLocation = config.outpath + uniqueFileName
                    var pageSizeMap = {
                        "A3": //No I18N
                        {
                          "width" : 297/25.4,//No I18N
                          "height" : 420/25.4//No I18N
                        },
                        "A4"://No I18N
                        {
                            "width":210/25.4,//No I18N
                            "height":297/25.4//No I18N
                        },
                        "A5"://No I18N
                        {
                            "width":148/25.4,//No I18N
                            "height":210/25.4//No I18N
                        },
                        "Legal"://No I18N
                        {
                           "width": 8.5,//No I18N
                           "height":14//No I18N
                        },
                        "Letter"://No I18N
                        {
                            "width":8.5,//No I18N
                            "height":11//No I18N
                        },
                        "Tabloid": //No I18N
                        {
                           "width": 11,//No I18N
                           "height":17//No I18N
                        }
                    }; //inches
                    var defaultMargin = {
                        top:"0in",//No I18N
                        bottom:"0in",//No I18N
                        right:"0in",//No I18N
                        left:"0in"//No I18N
                    };
                    var pdfParams = params["pdfConfig"]; //No I18N
                    var dpi = pdfParams && pdfParams["dpi"],//No I18N
                    paperOrientation = pdfParams && pdfParams["orientation"] || "portrait",//No I18N 
                    margin = pdfParams && pdfParams["margin"] || defaultMargin,//inches //No I18N
                    headerHeight = pdfParams && pdfParams["headerHeight"] || "0in", //inches //No I18N
                    footerHeight = pdfParams && pdfParams["footerHeight"] || "0in", //inches //No I18N
                    headerFunctionContent =  pdfParams && pdfParams["headerFunctionContent"] || "", //No I18N
                    footerFunctionContent = pdfParams && pdfParams["footerFunctionContent"] || ""; //No I18N
                    var headerFunc = new Function("pageNum","numPages",headerFunctionContent);
                    var footerFunc = new Function("pageNum","numPages",footerFunctionContent);                  
                    var pageSize;
                    if(pdfParams && pdfParams["pageSize"])
                    {
                    pageSize = pdfParams["pageSize"];
                    }
                    else
                    {
                    var paperType = pdfParams && pdfParams["paperType"] || "A4";//NO I18N
                    pageSize =  pageSizeMap[paperType];   
                    }
                    var paperWidth;
                    if(paperOrientation==="landscape")
                    {
                        paperWidth  = pageSize.height;
                        var temp = pageSize.height;
                        pageSize.height = pageSize.width;
                        pageSize.width = temp;
                    }
                    else
                    {
                        paperWidth = pageSize.width;
                    };
                    if (config.pagelibraryPath) {
                       page.libraryPath = config.pagelibraryPath;
                    }
                    if(page.injectJs('jquery-1.10.1.min.js'))
                    {
                        console.log("jquery-1.10.1.min.js injection succeeded");
                    }
                    else
                    {
                        console.log("Failed to inject jquery-1.10.1.min.js ")
                    };
                    var width = page.evaluate(function(){
                        return $(document).width();
                    });
                    page.zoomFactor = (paperWidth - parseFloat(margin.right) - parseFloat(margin.left)  - parseFloat(headerHeight) - parseFloat(footerHeight)) * dpi / width;
                    page.paperSize = {
                        height:pageSize.height+"in",//No I18N
                        width : pageSize.width+"in", //No I18N
                        border: margin,
                        header: {
                             height: headerHeight,
                            contents: phantom.callback(headerFunc)
                        },
                        footer : {
                            height: footerHeight,
                            contents: phantom.callback(footerFunc)
                        }
                    };
                    page.render(params['filename']);
                    console.log("Current Stage: PDF Rendered Successfully");                    
                    exit(params['filename']);      
        } else if (outType == 'svg') {//No I18N
            var svgHtml = resultObj.htmlContent; //.replace(/<svg /, '<svg xmlns:xlink="http://www.w3.org/1999/xlink" ').replace(/ href=/g, ' xlink:href=').replace(/<\/svg>.*?$/, '</svg>');
            var content = SVG_DOCTYPE + svgHtml;
            if (params["isBase64"]) {//No I18N
                var base64 = window.btoa(unescape(encodeURIComponent(content)));
                exit(base64);
            } else {
                fs.write(params["filename"], content, 'w');//No I18N
                console.log("Current Stage: SVG Rendered Successfully");
                exit(params["filename"]);
            }
        } else {
            if (params["isBase64"]) {//No I18N
                var base64 = page.renderBase64(params['outType']);//No I18N
                exit(base64)
            } else {
                   // var uniqueFileName = Math.random().toString(36).slice(2);
                   // var renderedFileLocation = config.outpath + uniqueFileName
                    page.render(params['filename'], {
                        format: params['outType'],//No I18N
                        quality: params['quality'] || '100'//No I18N
                    });
                    console.log("Current Stage: Rendered Successfully");
                    exit(params['filename']);
            }
        }
    };

    var returnHTML = function(resultObj) {
        waitForConditionSetup(function() {
                    exit(resultObj.htmlContent);
                });    
    };

    var getElementToRender = function(params) {
        var getOuterHTML, resultObj, htmlElement;
        getOuterHTML = function(element) //check whether its really needed; if it is possible using outerhtml
        {
            var parent = element.parentElement;
            var childrens = parent.children;
            for (var i = 0, n = childrens.length; i < n; i++) {
                if (childrens[i] === element) {
                    break;
                }
            }
            var nextSibling = childrens[i].nextElementSibling;
            var elcontainer = document.createElement("div");//No I18N
            elcontainer.appendChild(element);
            var outerhtml = elcontainer.innerHTML;
            if (nextSibling) {
                parent.insertBefore(element, nextSibling);
            } else {
                parent.appendChild(element);
            }
            return outerhtml;
        };

        if (params["outType"] == "svg") {//No I18N
            var svgSelector = params["selector"] || "svg"; //No I18N //check what if params["selector"] is " " //No I18N 
            htmlElement = document.querySelector(svgSelector);
            if (htmlElement && htmlElement.tagName.toLowerCase() != "svg") {//No I18N
                return {
                    "ERROR": "Unable to get any svg element in resulted html"//No I18N
                };
            }
        } else if (params["selector"]) {//No I18N
            htmlElement = document.querySelector(params["selector"]);//No I18N
        } else {
            htmlElement = document.documentElement;
            var body = document.body,html = document.documentElement;
            var height = Math.max( body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight );
            var width = htmlElement.getBoundingClientRect().width;
            var wholeDocumentSize = {
                'width':width, //No I18N
                'height':height //No I18N
            };
        }

        if (htmlElement == null) {
            return {
                "ERROR": "Unable to get any htmlElement for rendering based on the selector"//No I18N
            };
        }
        resultObj = {
            htmlContent: htmlElement.outerHTML || getOuterHTML(htmlElement),
            clipRectObject: wholeDocumentSize || htmlElement.getBoundingClientRect()
        };
        return resultObj;
    };

    var executeUserProvidedJavascript = function() {
        if (params["jsexecution"]) {
            var customfunctionBody = params["jsexecution"]["functionbody"];//No I18N
            var customFunction = new Function(customfunctionBody);
            var exceptionCatch = function(userFunc){
                try{
                    userFunc();
                }
                catch(e){
                    console.log("ERROR MESSAGE : ", e.message);
                    console.log("STACK : ", e.stack);
                    console.log("END OF STACK");
                }
            };
            resourcesLoaded = false;
            resourceRequested = false;
            page.evaluate(exceptionCatch, customFunction);
        }
    };

    var loadJSSetup = function() {
        console.log("Current Stage: loadJSSetup");
        if (params["jsexecution"]) {//No I18N
            var interval, timer;
            var maxWaitForAllExteralJsFilesToLoad = params['maxWaitForAllExteralJsFilesToLoad'];
            console.log("maxWaitForAllExteralJsFilesToLoad "+maxWaitForAllExteralJsFilesToLoad);
            var jsExecutionOptions = params["jsexecution"];//No I18N
            var jsFiles = jsExecutionOptions["jsfiles"];//No I18N
            if (jsFiles && jsFiles.length > 0) {
                var externalJsFilesList = [],
                    localJsFilesList = [];
                for (var i = 0, n = jsFiles.length; i < n; i++) {
                    if (jsFiles[i].indexOf("http://") == 0 || jsFiles[i].indexOf("https://") == 0) //alternate of startsWith//No I18N//No I18N
                    {
                        externalJsFilesList.push(jsFiles[i]);
                    } else if (jsFiles[i].indexOf(".js", jsFiles[i].length - 3) != -1) {//No I18N
                        //jsCounter will change for this case;
                        localJsFilesList.push(jsFiles[i]);
                    } else {
                        exit("Invalid name of the js files provided under jsFiles parameter", true);//No I18N
                    }
                }
                //load external js files first
                externalJsCounter = externalJsFilesList.length;
                if (externalJsFilesList.length == 0) {
                    externalJSLoaded = true;
                    //externalJsCounter = 0;
                } else {//No need of else here
                    for (var i = 0, n = externalJsFilesList.length; i < n; i++) {
                        page.includeJs(externalJsFilesList[i], function() {
                            decrementExternalJSCounter(); //In case of failure to load the scirpt the decrementJSCounter will not be called
                        });
                    }
                }
                if (!externalJSLoaded) {
                    interval = window.setInterval(function() {
                        if (externalJSLoaded) {
                            clearTimeout(timer);
                            clearInterval(interval);
                            console.log("Current Stage: External JS files are loaded successfully");
                            loadLocalJS(localJsFilesList);
                        }
                    }, 50);

                    // we have a 5 second timeframe..
                    timer = window.setTimeout(function() {
                        clearInterval(interval);
                        exit('All the external js files are not loading within the specified time', true);//No I18N
                    }, maxWaitForAllExteralJsFilesToLoad);
                } else // In case if js is already loaded
                {
                    loadLocalJS(localJsFilesList);
                }
            } else {
                startProcess();
            }
        } else {
            startProcess();
        }
    };
    pageSetup();
}