//$Id$
var DashUtils = new function () {

    this.showVUD = function (el, event) {
    	var menu = DOMUtils.getParentWithAttr(el, 'isMenu');
        ZDBToolTip.hide();
        var dashChild = menu.dashChild;
        ZDBVUDataAPI.viewUD(dashChild.ctx.view);
    };

    this.openViewInTab = function (el, event) {
        ZDBToolTip.hide();
        var dashChild = DOMUtils.getParentWithAttr(el, 'objId');
        var view = dashChild.ctx.view;
        var objId = view.objId;
        var tab = ZDBClientUI.getExistingTab(objId);
        if (tab)
        {
            ZDBClientUI.selectTab(tab);
            return;
        }
        var type = view.type;
        var tab = ZDBClientUI.createUpdateDummyTab(objId, view.displayName, type, tab);
        ZDBClientUI.typeDefns[type].fetchView(objId, tab.viewCtx);
    };

    this.initOptionsMenu = function (el) {
        ZDBToolTip.hide();
        ZRSMenu.closeAllMenu();
        this.srcEl = el;
        var dashChild = DOMUtils.getParentWithAttr(el, 'objId');
        el.view = dashChild.ctx.view;
        ZDBUtil.addClass(dashChild,"showdashviewoptions");
        //dashChild.setAttribute('class', 'dashChild showdashviewoptions');
        el.setAttribute('selected', 'true');
    };
    
    this.initOptionsMenu_new = function(el, dashChild, view){
    	ZDBToolTip.hide();
        ZRSMenu.closeAllMenu();
        this.srcEl = el;
        el.view = view;
        ZDBUtil.addClass(dashChild,"showdashviewoptions");
        el.setAttribute('selected', 'true');
    }

    this.exportView = function (el, event) {
    	if(!ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare","APPENDTODOC",DashUtils.exportView,[el,event]))
  	  	{
  	  		return;
  	  	}
    	var menu = DOMUtils.getParentWithAttr(el, 'isMenu'); 
    	el.view = menu.view;
    	el.dashChild = menu.dashChild;
        menu.expMenu = ZDBMenu.showDashOptsMenu(el, event, 'Single_View_Export_Menu', 'GridMenu', null, 3);//NO I18N
    };
    
    this.closeExportMenu = function(el, event){
    	var menu = DOMUtils.getParentWithAttr(el, 'isMenu');
    	ZRSMenu.closeLastMenu(jQuery(menu.expMenu));
    };

    this.showChartTypes = function (el, event) {
        DashUtils.initOptionsMenu(el);
        ZDBAnalysisUtil.showChartDlg(el);
    };
    
    this.showChartTypes_new = function(el, dashChild, view){
    	DashUtils.initOptionsMenu_new(el, dashChild, view);
        ZDBAnalysisUtil.showChartDlg(el);
    }
    
    this._showMoreOptions = function(el, event, view, dashChild){
    	if((view.exportPerm || view.permissions.exportPerm) && !ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare","APPENDTODOC",DashUtils._showMoreOptions,[el, event, view])){
  	  		return;
    	}
		
        var menu = ZDBMenu.showDashOptsMenu(el, event, 'Dash_ViewMode_MoreOpts', 'GridMenu', DashUtils.hideOptionsMenu, 2);//NO I18N
        var _className = "ZRSMenu shadowAdded dashVM_moreOpts";//No I18N
		var isVUD = el.getAttribute("isVUD");
		_className += isVUD != "true" ? " noVUD" : "";//No I18N
		var isExp = el.getAttribute("isExp");
		_className += isExp != "true" ? " noExp" : "";//No I18N
		menu.className = _className;
        menu.dashChild = dashChild || DOMUtils.getParentWithAttr(el, 'objId');
        this.moreMenu = menu;
    }
    
    this.showMoreOptions = function(el, event){
    	DashUtils.initOptionsMenu(el);
    	var view = el.view;
    	DashUtils._showMoreOptions(el, event, view);
    };
    
    this.showMoreOptions_new = function(el, event, dashChild, view){
    	DashUtils.initOptionsMenu_new(el, dashChild, view);
    	DashUtils._showMoreOptions(el, event, view, dashChild);
    }
    
    this.closeMoreMenu = function(){
    	ZRSMenu.closeAllMenu();
    };

    this.hideOptionsMenu = function (srcEl) {
        /*$#Dash#$ Comment for New Layout*/
    	var el = srcEl || this.srcEl;
        var dashChild = DOMUtils.getParentWithAttr(el, 'objId');
        if(ZDBUtil.hasClass(dashChild,"showdashviewoptions")){//dashChild.className === "dashChild showdashviewoptions"){
            ZDBUtil.removeClass(dashChild,"showdashviewoptions");
        	//dashChild.className = "dashChild";
        }
        el.removeAttribute('selected');
        /*$#Dash#$ Comment for New Layout*/
    };

    this.hideOptionsOnMouseOut = function (dashChild) {
        dashChild.dashViewOptions.style.display = 'none';
        clearTimeout(dashChild.dashViewOptions.mouseEnter);
    };

    this.showOptionsOnMouseEnter = function (dashChild) {
    	if(dashChild && dashChild.dashViewOptions){
//    		  dashChild.dashViewOptions.style.display = '';
//            dashChild.dashViewOptions.mouseEnter = setTimeout(function () {
//                DashUtils.hideOptionsOnMouseOut(dashChild)
//            }, 5000);
    	}
    };

    this.resize = function (dashView, sizeDiff, doResize) {
        var dashRows = dashView.dashDiv.dashRows;
        if (!dashRows || sizeDiff === 1 && !doResize) {
            return;
        }
        if(BROWSER.IS_MOBILE_PHONE) {
            ZRSIphone.resizeViews(dashView);
            return;
        }
        var innerPadding = (dashView.editMode) ? 2 * 0.0066 * dashView.dashDiv.clientWidth : 0.0099 * dashView.dashDiv.clientWidth;
        var themeMargin = parseInt(dashView.theme.get('child.margin.left') || 0) + parseInt(dashView.theme.get('child.margin.right') || 0);
        var themeBorder = parseInt(dashView.theme.get('child.border.width.left') || 0) + parseInt(dashView.theme.get('child.border.width.right') || 0);
        var height = 0;
        for (var i = 0; i < dashRows.length; i++) {
            var dashRow = dashRows[i];
            var colDets = this.getColDetails(dashView, dashRow, sizeDiff);
            var colHeight = 0;
            for (var det in colDets) {
                var colDet = colDets[det];
                this.resizeInnerViews(dashView, colDet.col, colDet.width, sizeDiff, innerPadding, themeMargin, themeBorder, dashRow);
                colHeight = (colHeight < colDet.col.offsetHeight) ? colDet.col.offsetHeight : colHeight;
            }
            height += colHeight;
        }
        if (dashView.editMode)
        {
            ZDBEditModeSelect.hideResizeDivs();
            ZDBEditModeSelect.hideOptsMenu();
            ZDBDashEdit.updateDashDim();
        }
    };

    this.getColDetails = function (dashView, dashRow, sizeDiff) {
        var colDet = {};
        var totalWidth = dashView.dashDiv.clientWidth;
        var firstCol = DOMUtils.getFirstMatchingChild(dashRow, '*', 'elname', 'firstSeg');
        var isExpanded = firstCol.getAttribute('isexpanded') === 'true';
        var firstColWidth = (isExpanded) ? totalWidth : parseInt(firstCol.style.width) * sizeDiff;
        colDet.firstCol = {'col': firstCol, 'isExpanded': isExpanded, 'width': firstColWidth};//NO I18N
        if (!isExpanded) {
            var secondCol = DOMUtils.getFirstMatchingChild(dashRow, '*', 'elname', 'secondSeg');
            colDet.secondCol = {'col': secondCol, 'isExpanded': isExpanded, 'width': totalWidth - firstColWidth};//NO I18N
        }
        return colDet;
    };

    this.resizeInnerViews = function (dashView, column, colWidth, sizeDiff, innerPadding, themeMargin, themeBorder, dashRow) {
        if (!column || column.isUFEL || BROWSER.IS_MOBILE_PHONE) {
            return;
        }
        column.style.width = colWidth + 'px';
        var rowWidth = dashRow.clientWidth;
        var nodes = column.childNodes;
        var currentTotalWidth = Math.ceil(innerPadding);
        var widgetMargin = parseInt(0.0066 * rowWidth);
        var widgetPairStartIndex = 0;
        var adjustFlag = false;
        var remainingWidth;
        for (var i = 0; i < nodes.length; i++) {
            var width = colWidth - ((dashView.editMode)?2:0);
            var node = nodes[i];
            var padding = (column.getAttribute('isexpanded') === 'false') ? innerPadding : 2 * 0.0066 * dashView.dashDiv.clientWidth;
            if (node.getAttribute('viewtype') === 'WIDGET') {
                var prevThemeMargin = parseInt(node.getAttribute('themeMargin') || 0);
                var widgetWidth = parseInt(node.style.width) + prevThemeMargin;
                width = Math.ceil(widgetWidth * sizeDiff);
                currentTotalWidth = currentTotalWidth > (Math.abs(column.offsetLeft - node.offsetLeft) + Math.ceil(innerPadding / 2)) ? currentTotalWidth : Math.abs(column.offsetLeft - node.offsetLeft) + Math.ceil(innerPadding / 2);
                if ((colWidth - 30) > (widgetMargin + width + currentTotalWidth) && (i + 1 !== nodes.length)) {
                		node.style.marginRight = widgetMargin + 'px'; // No I18N
                		currentTotalWidth += widgetMargin + width;
        			}
        			else {
        				currentTotalWidth += width;
        				adjustFlag = true;
        			}
                remainingWidth = colWidth - currentTotalWidth - 2;
                if (!adjustFlag && Math.abs(remainingWidth) < 0.0125 * rowWidth) {
                		adjustFlag = true;
                	}
                node.setAttribute('themeMargin', themeMargin);
                padding = 0;
            }
            padding = padding + themeMargin;
            node.style.width = (width - padding) + 'px';
            updateNodeDlgBody(node, width, padding, themeBorder);
            updateNodeModalDiv(node, width, padding);
            updateScrollFreezeLayer(node, width, padding);
            if (adjustFlag) {
            		adjustFlag = false;
            		node.style.marginRight = '';
            		if (Math.abs(remainingWidth) < (0.0125 * rowWidth)) {
            			var noOfWidgets = i - widgetPairStartIndex + 1;
            			var widthForEachWidget = remainingWidth / noOfWidgets;
            			for (var widgetIndex = widgetPairStartIndex; widgetIndex <= i; widgetIndex++) {
            				var initialColumnHeight = column.offsetHeight;
            				var widgetInitialWidth = parseInt(nodes[widgetIndex].style.width);
            				var widgetCorrectedWidth = widgetInitialWidth + widthForEachWidget;
            				nodes[widgetIndex].style.width = widgetCorrectedWidth + "px";
            				if (column.offsetHeight > initialColumnHeight + 2) {
            					nodes[widgetIndex].style.width = widgetInitialWidth + "px";
            					continue;
            				}
            				updateNodeDlgBody(nodes[widgetIndex], widgetCorrectedWidth, padding, themeBorder, true);
            				updateNodeModalDiv(nodes[widgetIndex], widgetCorrectedWidth, padding);
            				updateScrollFreezeLayer(nodes[widgetIndex], widgetCorrectedWidth, padding);
            			}
            		}
            		currentTotalWidth = Math.ceil(innerPadding);
            		widgetPairStartIndex = i + 1;
            }
            if (sizeDiff !== 1 || sizeDiff === -1) {
                dashView.resizeInnerViews(node);
            }
        }
        function updateNodeDlgBody(node, width, padding, themeBorder, doNotAlterHeight) {
        	if (node.dlgBody) {
                var isView = node.getAttribute('eltype') === 'VIEW';//NO I18N
                var dlgBodyMargin = (isView)? 20: 0;
                var oldWidth = parseFloat(node.dlgBody.offsetWidth);
                node.dlgBody.style.width = (width - (padding + dlgBodyMargin + themeBorder)) + 'px';
                if (isView && !doNotAlterHeight)
                {
                    var oldHeight = parseFloat(node.dlgBody.offsetHeight); 
                    var newWidth = oldWidth * sizeDiff;
                    var heightPerc = oldHeight / oldWidth;
                    var height = newWidth * heightPerc;
                    node.dlgBody.style.height = height + 'px';
                    node.style.height = "";
                    node.style.height = node.offsetHeight + 'px';
                }
            }
        }
        function updateNodeModalDiv(node, width, padding) {
        	if (node.modalDiv)
            {
                var modalDivWidth = width - padding;
                node.modalDiv.style.width = modalDivWidth + 'px';
                if (node.getAttribute('eltype') === 'VIEW')
                {
                    node.modalDiv.style.height = node.offsetHeight + 'px';
                }
            }
        }
        function updateScrollFreezeLayer(node, width, padding) {
        	var scrollFreezeLayer = node.getElementsByClassName("scrollFreeze"); // No I18N
            if(scrollFreezeLayer.length)
            {
                scrollFreezeLayer[0].style.width = (width - padding) + 'px';
                scrollFreezeLayer[0].style.height = node.offsetHeight + 'px';
            }
        }
    };

    this.updateChildsBottomPadding = function (dashView) {
        var margin = (0.0066 * dashView.dashDiv.offsetWidth + parseInt(dashView.theme.get('child.margin.bottom') || 0)) + 'px';//NO I18N
        var els = DOMUtils.filterElements(dashView.dashChilds, null, 'isdashboarddiv', 'true');//NO I18N
        for (var i = 0; i < els.length; i++) {
            this.setChildBottomPadding(els[i], dashView, margin);
        }
    };

    this.setChildBottomPadding = function (el, dashView, marginBottom) {
        if (dashView.editMode || !this.isLastInnerRow(el)) {
            el.style.marginBottom = marginBottom;
        } else {
            el.style.marginBottom = '0';
        }
    };

    this.isLastInnerRow = function (el) {
        var nextElement = el.nextElementSibling;
        if (!nextElement) {
            return true;
        }
        if (nextElement.offsetTop === el.offsetTop) {
            return this.isLastInnerRow(nextElement);
        }
        return false;
    };

    this.showOrHideVMFilterChild = function (dashView) {
        var vmfArea = DOMUtils.getSelfOrParentWithAttrValue(dashView.VMFilterDropArea, 'isdashboardrowdiv', 'true');//NO I18N
        if (dashView.editMode || dashView.VMFiltersList.length > 0 || dashView.timeLineCompEnabled) {
            vmfArea.style.display = '';
        } else {
            vmfArea.style.display = 'none';
        }
    };
    
    this.dashChildAutoHeight = function(dashChild){
    	if(!dashChild.$autoHeight){
    		dashChild.dlgBody.style.height = dashChild.layer.dom.container.scrollHeight + 20 + "px";
    		//dashChild.style.height = "auto";
    		//dashChild.layer.dom.container.style.height = "auto";
    		dashChild.layer.autoHeight = true;
    		dashChild.layer.$fixHeight();
    		dashChild.layer.autoHeight = false;
    		//dashChild.style.height = "";
    		//dashChild.layer.dom.container.style.height = "";
    		Object.defineProperty(dashChild, "$autoHeight" , {value : true} );//No i18N
    	}
    }
    
    this.refreshViews = function(el){
    	var dashView = ZDBClientUI.getViewObj(el, "view");//NO I18N
        dashView.maxCacheTime = null;

    	if(dashView._$type != undefined){
    		switch(dashView._$type){
    			case 0 :
    		    	ZDBDashboardAPI.refreshViews(el);
    		    	break;
    			case 1 :
    		    	ZRDashboardAPI.refreshViews(el);
    		    	break;
    		}
    		return;
    	}
    	ZDBDashboardAPI.refreshViews(el);
    }
    
    function stopScrollEvent(event){
    	event.stopImmediatePropagation();
	}
    
    function getScrollFreezeDiv(dashChild, gArea){
    	if(!dashChild.gridScrollFreeze){
    		var scrollFreeze = document.createElement("div");
            scrollFreeze.setAttribute("class","scrollFreeze");
            dashChild.gridScrollFreeze = gArea.appendChild(scrollFreeze);
    	}
    	else{
    		var scrollFreeze = gArea.appendChild(dashChild.gridScrollFreeze);
    		scrollFreeze.removeEventListener("click", scrollFreeze.clickEvent, true);
    	}
    	return dashChild.gridScrollFreeze;
    }
    
    function isMenuEnabled(){
    	var check = true;
    	var moreOptions = document.getElementById("ZRSVMoreOptions");
    	check = (!moreOptions || moreOptions.style.display !== "block"); //No i18N
    	if(!check){
    		return check;
    	}
    	var pivotSort = document.getElementById("ZDBPivotSortMenu");
    	check = (!pivotSort || pivotSort.style.display !== "block"); //No i18N
    	if(!check){
    		return check;
    	}
    	var pivotSortSub = document.getElementById("ZDBPivotSortSubMenu");
    	check =  (!pivotSortSub || pivotSortSub.style.display !== "block"); //No i18N
    	if(!check){
    		return check;
    	}
    	var colHead = document.getElementById("ZDBTColHeadMenu");
    	check = (!colHead || colHead.style.display !== "block"); //No i18N
    	if(!check){
    		return check;
    	}
    	var sortSub = document.getElementById("ZDBSortSubMenu");
    	check = (!sortSub || sortSub.style.display !== "block"); //No i18N
    	return check;    	
    }
    
    this.scrollFreezeLayer = function(gridObj, dashView){
    	var isScroll = (ZDBClientUI.standAlone && document.body.scrollHeight == document.body.clientHeight && document.documentElement.clientHeight != document.body.clientHeight);
    	isScroll = (!dashView.editMode && (isScroll || dashView.dashDiv.scrollHeight > dashView.dashDiv.clientHeight));
    	if(isScroll){
    		var gridEl = gridObj.gArea, dashScrollFreeze = gridObj.dashScroll;
    		var dashChild = gridObj.viewCtx.dashChildDiv;
    		var freezeDiv = getScrollFreezeDiv(dashChild, dashScrollFreeze);
    		function showScrollFreeze(event){
    			if(BROWSER.SAFARI){
    				var dashChildPos = this.getBoundingClientRect();
                    var pointerXPosCheck = (event.clientX > dashChildPos.right || event.clientX < dashChildPos.left);
                    var pointerYPosCheck = (event.clientY > dashChildPos.bottom || event.clientY < dashChildPos.top);
                    if(!pointerXPosCheck && !pointerYPosCheck){
                    	return;
                    }
    			}
    			if(isMenuEnabled() && (event.keyCode == 27 || event.type == "mouseleave")){
    				freezeDiv.style.display = "block";
    				dashView.dashDiv.style.overflowY = "scroll"; //No i18N
    				ZDBGridScroll.showHideMinMaxRowCountComp(gridEl, event);
    				if(!BROWSER.CHROME){
    					dashView.dashDiv.style.paddingRight = "0px"; //No I18N
    				}
    				gridEl.removeEventListener('mouseover',ZDBEvents.onGridMouseOver);
    				gridEl.removeEventListener('click',ZDBEvents.onGridMouseClickCapture);
    				dashScrollFreeze.removeEventListener("mouseleave", showScrollFreeze);
                    document.removeEventListener("keydown", showScrollFreeze);
    			}
    			dashView.dashDiv.style.overflowY= "";
    			dashChild.dlgBody.addEventListener("mousewheel",stopScrollEvent, true);
    			dashChild.dlgBody.addEventListener("DOMMouseScroll",stopScrollEvent, true);
    			delete gridObj.viewCtx.isClicked;
    		}
    		
    		freezeDiv.clickEvent = function(event){
    			freezeDiv.style.display = "none";
                ZDBGridScroll.showHideMinMaxRowCountComp(gridEl, event);
                if(!BROWSER.CHROME){
                	dashView.dashDiv.style.paddingRight = ZDBGlobal.scrollThick + "px"; //No I18N
                }
                dashView.dashDiv.style.overflowY= "hidden"; //No i18N
//                event.stopImmediatePropagation();
                document.addEventListener("keydown", showScrollFreeze);
                dashScrollFreeze.addEventListener("mouseleave", showScrollFreeze);
                dashChild.dlgBody.removeEventListener("mousewheel", stopScrollEvent,true);
                dashChild.dlgBody.removeEventListener("DOMMouseScroll", stopScrollEvent,true);
                gridObj.viewCtx.isClicked = true;
    		}
    		if(gridObj.viewCtx.isClicked){
    			freezeDiv.style.display = "none";
    			dashScrollFreeze.addEventListener("mouseleave", showScrollFreeze);
    			dashChild.dlgBody.removeEventListener("mousewheel", stopScrollEvent,true);
    			dashChild.dlgBody.removeEventListener("DOMMouseScroll", stopScrollEvent,true);
		}
    		else{
    			freezeDiv.style.display = "";
    		}
		freezeDiv.addEventListener("click", freezeDiv.clickEvent, true);
    		dashChild.dlgBody.addEventListener("mousewheel", stopScrollEvent,true);
            dashChild.dlgBody.addEventListener("DOMMouseScroll", stopScrollEvent,true);
//            freezeDiv.style.width = gridObj.gLeftArea.offsetWidth + gridObj.gRightArea.offsetWidth + "px";
//            console.log(gridObj.rhHeight + gridObj.tcHeight, gridObj.gLeftArea.offsetHeight);
//            freezeDiv.style.height = gridObj.rhHeight + gridObj.tcHeight + "px";
    	}
    	
    	
    }
};

ZDBLazyLoadFuncMap.lazyLoadFuncMap.DashboardViewModeExport = DashUtils.exportView;
