//$Id$
function ZDBDashboard(viewComp, dashDiv)
{
  this.showShiftHelpVMFilter = true;
    this.viewComp = viewComp;
    viewComp.id = "";
  this.dashDiv = dashDiv;
    dashDiv.id = "";
   this.viewDropAreas = null;
  this.type = "Dashboard";
  this.VMFiltersList = new Array();
    ZDBClientViewAPI.initFromDiv(this, viewComp);
  this.editMode = ZDBUtil.isNewView(this);
  this.vmFilterListCatch = new Array();
    ZDBDashboard.AllViewsRefreshed = false;
  this.modified = 0;
  this.animatingViewWaiting = 0;
  // Delay dashBoard save until all new widgets receive their first response.
  Object.defineProperty(this, 'newWidgetsWaiting', { //No I18N
	  	get: function () {
	  		return this.newWidgetsWaitingPrivateProperty; // Private property used to maintain widgets waiting for first response. Don't use it outside
	  	},
	    set: function (value) {
	        this.newWidgetsWaitingPrivateProperty = value;
	        if (this.newWidgetsWaitingPrivateProperty == 0 && this.saveTriggered) {
				this.newName = this.newNameCopy;
				this.newDesc = this.newDescCopy;
	            this.saveCurrentConfig(this.saveCurrentConfigOptions.requestOptions, this.saveCurrentConfigOptions.saveAs, this.saveCurrentConfigOptions.oldObjId);
	            delete this.saveCurrentConfigOptions;
				delete this.newNameCopy;
	  			delete this.newDescCopy;
	  			delete this.newName;
	  			delete this.newDesc;
	            delete this.saveTriggered;
	        }
	    }
  });
  this.newWidgetsWaiting = 0;
  this.initialize();
  this.widgetIdMap = {};
  this.isSaveAs = false;
  this.trashWidget = new Array();
  this.refreshCounter = 0;
  var themeString = viewComp.getAttribute('theme');
  themeString = (themeString == '{}' && BROWSER.IS_MOBILE_PHONE) ? '{"child.shadow":"false","type":"2"}' : themeString; //applying by default border theme for Mobile phone
  this.theme = DashTheme(JSON.parse(themeString));
    this.qLimit = parseInt(viewComp.getAttribute('qLimit'));
    this.bgQLimit = parseInt(viewComp.getAttribute('bgQLimit'));
    this.views;
    this.dashQ;
    if (viewComp.getAttribute('objid') < 0)
  {
	  this.modified = 1;
  }
    this.OldDashDivSize = {width: 0, height: 0};
    this.curSize = {width: 0, height: 0};
  this.timeLineCompEnabled = false;
}

ZDBDashboard.prototype.decreaseAnimatingViewCount = function()
{
	this.animatingViewWaiting--;
}
ZDBDashboard.prototype.incrementNewWidgetsWaitingForFirstResponse = function() {
	this.newWidgetsWaiting++;
}
ZDBDashboard.prototype.decrementNewWidgetsWaitingForFirstResponse = function() {
	this.newWidgetsWaiting--;
}
ZDBDashboard.prototype.initialize = function()
{
  if(this.initialized)
  {
    return;
  }
  this.dropAreas = new Object();//column droppable areas
  this.viewDropAreas = new Object();
  ZDBUtil.setNamedChildEls(this.viewComp,this);
  var viewTypeName = this.VMFilterDropArea.getAttribute("VIEWTYPE");
  this.dropAreas[viewTypeName] = this.VMFilterDropArea;//VM Filter Droppable Area. Note: View Drop Area is different from dropArea.
  ZDBUtil.setNamedChildEls(this.viewComp,this.viewDropAreas,"VIEWTYPE");
  this.initialized = true;
}

ZDBDashboard.prototype.isVisibleViewsLoaded = function()
{
	  var dashView = this;
	  var dashChilds = dashView.dashChilds;
	  var mainContent = dashView.mainContent;
	  var mainContainerDimInfo = ZDBClientUtil.getDimInfo(mainContent);
	  var isWithin = null;
	  var dashChildDimInfo = null;

	  for(var i =0, len = dashChilds.length; i < len; i++)
	    {
	      if(dashChilds[i].isDashChild)
	      {
	    	  dashChildDimInfo = ZDBClientUtil.getDimInfo(dashChilds[i]);
	    	  isWithin = ZDBClientUtil.isWithin(mainContainerDimInfo,dashChildDimInfo,mainContent,true);
		        if(isWithin && dashChilds[i].fetched && dashChilds[i].ctx.view)
	            {
		        	if(dashChilds[i].ctx.view.loaded!=true){
		        		return false;
		        	}

	            }
	     }
	    }
	  return true;
}

ZDBDashboard.prototype.updateRespStatus = function (view)
{
	if(view && view.type != "WIDGET"){
		var dashChild = view.viewCtx.dashChildDiv;
		this.appendPermissionsForView(view, dashChild);
	}
    this.dashQ.dequeue();
    if (this.dashQ.onsuccess()) {
        ZDBDashboardAPI.stopLoadingViews(this);
        ZDBUtil.ShowHideForceRefresh(this,(this.switchFrom == "editMode")); //No I18N
    } else {
        ZDBDashboardAPI.startLoadingViews(this);
    }
};

ZDBDashboard.prototype.appendPermissionsForView = function (view, dashChild){
	var isPermSet = dashChild.hasAttribute("isPermSet"); //NO I18N
	
	if(!isPermSet && !BROWSER.IS_MOBILE_PHONE){
		var perm = view.permissions;
		var type = view.type; 
		var vud = (type != "Table" && type != "Report" && type != "QueryTable") ? perm.vud : 0;//NO I18N
		var expPerm = perm.exportPerm || view.exportPerm;
		var _className = "dashChildTitleArea"; //NO I18N
		var titleEl = dashChild[_className];
		_className += view.type === "AnalysisView" ? " chart" : "";
		_className += perm.read ? " openInTab" : ""; //NO I18N
		_className += (vud || expPerm) ? " moreOption" : " noMoreOption"; //NO I18N
		titleEl.className = _className;
		dashChild.dashVM_moreOptions.setAttribute("isVUD", vud ? "true" : "false");
		dashChild.dashVM_moreOptions.setAttribute("isExp", expPerm ? "true" : "false");
		dashChild.setAttribute("isPermSet","1");
	}
}
    
ZDBDashboard.prototype.setHidden = function()
{
  ZDBDashboardAPI.modeHelper.viewHidden(this);
}


ZDBDashboard.prototype.setVisible = function()
{
  this.resize();
  ZDBDashboardAPI.modeHelper.viewVisible(this);
}




ZDBDashboard.prototype.save = function(requestOptions)
{
  if(ZDBUtil.isNewView(this))
  {
    if(!ZDBCreateViewAPI.getNameForNewView(this,requestOptions))
    {
      return;
    }
  }

  this.deleteWidgetsInDashboard(requestOptions);

}

ZDBDashboard.prototype.deleteWidgetsInDashboard = function(requestOptions)
{
	 var widgetIds = this.trashWidget;
	 var curObjId = widgetIds.pop();
	 if(!curObjId)
		 {
		 	this.saveCurrentConfig(requestOptions,false);
		 	return;
		 }
	 WidgetFetcher.sendWidgetRequest(3,null,{'OBJID':curObjId,'DASHVIEW':this,'REQOPTS':requestOptions});//NO I18N
};

ZDBDashboard.prototype.getViewParams =  function(saveAs,oldObjId)
{

  var params = (saveAs) ? "&ZDBACTION=SAVEAS&OLDOBJID="+oldObjId : "&ZDBACTION=SAVE";   //No I18N
  if(this.objId > -1)
  {
    params += "&OBJID=" + this.objId; //No I18N
  }
  else
  {
    params += "&DBID=" + this.dbId; //No I18N
    params += ZDBCreateViewAPI.getNewNameInfoAsParams(this);
  }
   params += this.viewCtx.getAdditionalParams();
  return params;

}

ZDBDashboard.prototype.saveCurrentConfig = function(requestOptions,saveAs,oldObjId)
{
	if (this.newWidgetsWaiting) {
		this.newNameCopy = this.newName;
		this.newDescCopy = this.newDesc;
		this.saveCurrentConfigOptions = {
				requestOptions: requestOptions,
				saveAs: saveAs,
				oldObjId: oldObjId
		}
		this.saveTriggered = true;
		return;
	}
  var url = "/ZDBDashboardDesignEditor.ve?"+this.getViewParams(saveAs,oldObjId);  //No I18N
  var xml = ZDBDStructure.getDashBoardCurrentConfig(this,false,true);
  if(xml == null)
  {
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.dashboard.js.nocontent"));
    return;
  }
  AjaxAPI.sendRequest({URL:url,POSTBODY:xml,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                             ISNEWVIEW:ZDBUtil.isNewView(this),
                                         VIEW:this,
                                         ONSUCCESSFUNC:ZDBCreateViewAPI.handleViewSave,
                                         ONFAILUREFUNC:ZDBCreateViewAPI.handleViewSaveFailure,
                                         ORIGREQOPTIONS:requestOptions,
                                         OPSTATUSID:this.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.loadingdiv.js.saving"))});  //No I18N
  
  if(this._$type != undefined){
	  this._saveSent = true;
  }
}

ZDBDashboard.prototype.removeField = function(field,updateGraphArea)
{
    ZAVMFilter.removeComponent(field);
}

ZDBDashboard.prototype.setScrollPosition = function(set){
    if(set)
    {
    	this.dashDiv.scrollPos = this.dashDiv.scrollTop;
    }
    else
    {
    	this.dashDiv.scrollTop = (this.dashDiv.scrollPos) ? this.dashDiv.scrollPos : "0";
    }
  }

ZDBDashboard.prototype.getDashDivSize = function()
{
  if(this.dashDiv==null){return {width:0,height:0};}
  return {width:this.dashDiv.clientWidth,height:this.dashDiv.clientHeight};
  //return {width:ZDBClientUtil.getInnerWidth(this.dashDiv),height:ZDBClientUtil.getInnerHeight(this.dashDiv)};
}

ZDBDashboard.prototype.resize = function (force)
{
    /*
     * Code flow of Dashboard Resize
     * First the ZDBPlaceHolder get resized in the ZDBClientUI.resizePlaceHolder method.
     * Based on ZDBPlaceHolder size, the dashView.viewComp and dashView.dashDiv are resized.
     * All the views are children of dashDiv. Hence we also need to check if the dashDiv width is changed.
     * dashDiv will be changed when the scroll state is visible or hidden. Hence we calculate the diff every time.
     * */
	ZDBReportDashUtil.removeAllInView(this);
    var curSize = this.curSize;
    var OldDashDivSize = this.OldDashDivSize;
    var sizeDiff = 1;
    var dashView = this;
    var parSize = this.viewCtx.getSize();

    //CASE ZDBPLACEHOLDER SIZE CHANGES
//    var sizeChanged = false;
    if (curSize.width != parSize.width)
    {
        this.viewComp.style.width = parSize.width + "px";
        this.dashDiv.style.width = this.viewComp.clientWidth + "px";
        sizeDiff = parSize.width / curSize.width;
        curSize.width = parSize.width;
    }
    
    if (curSize.height != parSize.height)
    {
        this.viewComp.style.height = (parSize.height + "px");
        this.dashDiv.style.height = (parSize.height + "px");
        curSize.height = parSize.height;
    }
    if(!this.editMode)
    {
        ZAVMFilter.showMoreLessOption(this,true);
    }
    //CASE WHEN SCROLL APPEARS OR DISAPPEARS TO DAHSDIV
    //OBVIOUSLY EVEN WHEN THE ZDBPLACEHOLDER SIZE CHANGES
    var dashDivSize = this.getDashDivSize();
    if (dashDivSize.width != OldDashDivSize.width && OldDashDivSize.width != 0 && Math.abs(dashDivSize.width -  OldDashDivSize.width) >= ZDBGlobal.scrollThick) {
        sizeDiff = (dashDivSize.width) / OldDashDivSize.width;
        this.OldDashDivSize.width = dashDivSize.width;
    }
    DashUtils.resize(this, sizeDiff, force);
//    this.resizeAllAddedViews(sizeChanged, sizeDiff);
    if (dashView.viewCtx.isStandAlone())
    {
        dashView.enableBodyScroll();
    }
    ZDBReportDashUtil.appendToDOM(this.gridRender,true);
};

ZDBDashboard.prototype.resizeInnerViews = function(dashChild)
{

	if((dashChild.ctx != null)
	         && (dashChild.ctx.view != null))
	      {
			if(dashChild.ctx.view.type == "WIDGET"){
				dashChild.ctx.view.renderer.resize(dashChild.dlgBody);
				return;
			}
	        dashChild.ctx.view.resize();
	      }

}
ZDBDashboard.prototype.setBodyHeight = function(height)
{
	jQuery(document).css("height",height);//No I18N
	jQuery(document.body).css("height",height);//No I18N
}

ZDBDashboard.prototype.enableBodyScroll = function()
{
	if(!this.viewCtx.isStandAlone()){return;}

  //Devices that are currently enabled body scroll in dashboard embed
  //iPhone, iPad, Android Tablet
  if((!(BROWSER.IS_MOBILE))){return;}
  this.viewComp.style.height = "";
  this.dashDiv.style.height = "";
  $("ZDBPLACEHOLDER").style.height = "";
  var poweredByEl = $("ZDBPoweredByEl");
  var poweredByHeight = (poweredByEl!=null)?jQuery(poweredByEl).height():0;
  var height = jQuery("#ZDBPLACEHOLDER").height()+poweredByHeight+20;//No I18N
  $("ZDBMainBox").style.height = "";
  if(ZDBGlobal.IS_APP || !BROWSER.ANDROID_PHONE)
  {
	  this.setBodyHeight(height);
  }
  document.body.style.overflow = "";
  document.body.style.overflowX = "hidden";//No I18N
  document.body.style.overflowY = "auto"; //No I18N
  $("ZDBMainLoader").style.display = "none";
}



function ZDBDashboardCtx(dashView,dashChildDiv,parComp)
{
  this.base = ZDBDefViewCtx;
  this.base();
  this.dashView = dashView;
  this.parComp = parComp;
  this.dashChildDiv = dashChildDiv;
  dashChildDiv.ctx = this;
  this.menuItems = false;
  this.isReadOnly = true;
  this.loadIndicator = dashChildDiv.loadingDiv;
  if(this.loadIndicator)
  {
    ZDBUtil.setNamedChildEls(this.loadIndicator,this.loadIndicator);
  }
  this.baseGetAddParams = ZDBDefViewCtx.prototype.getAdditionalParams;
}

ZDBDashboardCtx.prototype = new ZDBDefViewCtx;

ZDBDashboardCtx.prototype.getNavigPlHolder = function(view)
{
		return {isNavig: false, el: null};
}

ZDBDashboardCtx.prototype.canGrabFocus = function(key, value)
{
  return false;
}

ZDBDashboardCtx.prototype.getSize = function()
{

	return {width:this.parComp.clientWidth,height:this.parComp.clientHeight};
	  //return {width:ZDBClientUtil.getInnerWidth(this.parComp),height:ZDBClientUtil.getInnerHeight(this.parComp)};
}

ZDBDashboardCtx.prototype.getAdditionalParams = function()
{
  var baseParams = this.baseGetAddParams();
  var sendCompleteInfo = (this.dashView.permissions.designModify == 1&& ZDBUtil.isViewModified(this.dashView))
  if(sendCompleteInfo)
  {
    baseParams += "&DASHUFSENT="+true; //NO I18N
  }
  baseParams += "&CONOBJID=" + encodeURIComponent(this.dashView.objId); //No I18N
  baseParams +="&FROMDASHBOARD=true"; //NO I18N
  if(this.dashView.dashLayout){
	  baseParams +="&FROMNEWDASHBOARD=true"; //NO I18N
  }
  baseParams+="&DASHEDITMODE="+this.dashView.editMode; //NO I18N
  baseParams += "&CONFIGID=" + this.dashChildDiv.getAttribute("configid");//NO I18N
  baseParams += "&SHOWVMFILTERS=" + this.dashChildDiv.getAttribute("showvmfilter");//NO I18N
  baseParams +="&EXCLUDEDASHBOARDUF=" + this.dashChildDiv.getAttribute("excludedashglobalfilters");//NO I18N
  return  baseParams;
}

ZDBDashboardCtx.prototype.getConfig = function(key,defaultValue)
{
	if(this.dashView.dashLayout){
		if(key == "LP"){
			return this.dashChildDiv.$node.properties.legendPosition;
		}
		else if(key == "showVMfilter")
		{
			return this.dashChildDiv.$node.properties.showUF == "1" ? "true" : "false"; 
		}
	}
	else{
		if(key == "LP")
		{
			return this.dashChildDiv.getAttribute("lp");
		}
		else if(key == "showVMfilter")
		{
			return this.dashChildDiv.getAttribute("showVMfilter");
		}
	}
  return defaultValue;
}



var ZDBDashboardAPI = new function()
{
  this.lazyLoadMap = {};
  this.lazyLoadedModules = {};
    
  this.createView = function(viewCtx,type,dbId,parentViewId,parDispName,dummyObjId)
  {
	if (!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList", "ZAVMFilterList", "ZAAnalysisFields", "ZRDashboardView"], "APPENDTODOC", ZDBDashboardAPI.createView, [viewCtx, type, dbId, parentViewId, parDispName, dummyObjId]))
	{
      return;
	}
    if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES","CSSLIST_DASHBOARDSTYLES", "CSSLIST_VMFILTERSTYLES"], this, ZDBDashboardAPI.createView,[viewCtx,type,dbId,parentViewId,parDispName,dummyObjId]))
    {
        return;
    }
    var url = "/ZDBDashEditUI.cc?"; //NO I18N
    url+= "DBID=" + dbId; //No I18N
    if(!ZDBLazyLoadUtil.loadSnippet("ZDBDashEditUI",url,this,"APPENDTODOC",
    								["ZDBAnalysisEditList", "ZDBDashEdit"],null,null,  //No I18N
                                    viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.dashboard.loadingdiv.js.loadingDBDesigner")))) //No I18N
    {
      return;
    }
    ZDBDashboardAPI.checkNLoadVMFEditUI();
    var mainDiv = $("ZDBNewDashMainEl").cloneNode(true);
    mainDiv.setAttribute("objId","" + dummyObjId);
    mainDiv.setAttribute("dbId","" + dbId);
    mainDiv.setAttribute("permLevel","" +ZDBClientUI.typeDefns.Dashboard.permLevel);
    ZDBUtil.setNamedChildEls(mainDiv,mainDiv);//Should be fine as there will be less els.
    var dashDiv = mainDiv.dashDiv;
    var dashView = new ZDBDashboard(mainDiv,dashDiv);
    dashView.views = {};
    dashView.dashQ = ZDBDashQ(dashView);
    ZDBDashboardAPI.createDashInstance(viewCtx,mainDiv,dashView);
    ZDBDashboardAPI.initTextEditor();
    ZAVMFilter.placeVMFilterDefinition(dashView); // to show the text in dash UF
    dashView.viewFullyLoaded = 1;
    ZDBMenu.updateToolbar(dashView);
    dashView.theme = ZDBDThemes.getDefThemeInst(2);
    ZDBDThemes.apply(dashView);
    ZDBClientUI.resizePlaceHolder();
    ZDBClientUI.selectedTab.view.resize(true);
  };


  this.fetchView = function(objId,viewCtx,fromExpEdit)
  {
    if(!ZDBLazyLoadUtil.loadJsAlone(["ZAVMFilterList","ZRDashboardView"],"APPENDTODOC",ZDBDashboardAPI.fetchView,[objId,viewCtx]))
    {
       return;
    }
    if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_DASHBOARDSTYLES", "CSSLIST_VMFILTERSTYLES"], "APPENDTODOC", ZDBDashboardAPI.fetchView,[objId,viewCtx]))
    {
        return;
    }
    
    if(viewCtx.dashView!=null && viewCtx.dashView.dashDiv!=null){
    	var holderWidth =  viewCtx.dashView.dashDiv.clientWidth;
    	
    }else{
    	var holderWidth =  viewCtx.parComp.clientWidth;
    }
    var params = "&OBJID="+objId+"&HOLDERWIDTH="+holderWidth   //No I18N
    + viewCtx.getAdditionalParams() + "&STANDALONE="+ZDBClientUI.standAlone;//NO I18N

    if(ZDBClientUI.isChartViewed)
    {
      params += "&isViewed="+ZDBClientUI.isChartViewed;//NO I18N        
    }
    var loadingMsg = (fromExpEdit) ? "zrpt.common.dashboard.loadingdiv.js.loadingDBDesigner" : "zrpt.common.dashboard.loadingdiv.js.loadingDashboard";		//No I18N
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBDashboardDesignEditor.cc?&CHANGESLIDERBOUNDS="+true,  //No I18N
                               PARAMETERS:params,
                               ONSUCCESSFUNC:ZDBDashboardAPI.handleDashboardEditorResp,
                               VIEWCTX:viewCtx,OBJID:objId,
                               OLDWIDTH:holderWidth,FROMEXPEDIT:fromExpEdit,
                               OPSTATUSID:viewCtx.getLoadIndicator(ZDBI18NMap.g(loadingMsg))}); //No I18N
  }
  
  this.handleDashboardEditorResp = function(response,requestOptions)
  {
    var viewCtx = requestOptions["VIEWCTX"];
    var fromExpEdit = requestOptions["FROMEXPEDIT"];
    var div = document.createElement("div");
    div.innerHTML = response.responseText;
    if(BROWSER.IS_MOBILE_PHONE)
    {
    	var dashboardMainContent = DOMUtils.getFirstMatchingChild(div,"*","elname","mainContent");
    	var imgEls = dashboardMainContent.getElementsByTagName("img");
    	for(var i=0;i<imgEls.length;i++)
    	{
    		var imgEl = imgEls[i];
    		imgEl.onload = function(event){
    			var dashView = ZDBClientUI.selectedTab.view;
    			dashView.enableBodyScroll();
    			dashView.resetGridScroll = true;
    		}
    	}
    }
    
    $("ZDBAjaxResponseStore").innerHTML = div.innerHTML;
    var mainDiv = $("ZDBDashboardEditorEl");
    var dashDiv = $("ZDBDashboardMainDIV");
    var dashView = new ZDBDashboard(mainDiv,dashDiv);
    dashView.curSize = viewCtx.getSize();
    dashView.OldDashDivSize = dashView.getDashDivSize();
    viewCtx.parComp.oldWidth = requestOptions["HOLDERWIDTH"];

    dashView.views = JSON.parse($(dashView.objId+"_Views").getAttribute('views'));

    ZDBReportDashUtil.maintainReportCount(dashView);
    dashView.maxCacheTime = null;
    dashView.switchFrom = null;
    dashView.dashQ = ZDBDashQ(dashView);
    ZDBDashboardAPI.createDashInstance(viewCtx,mainDiv,dashView);
    ZAVMFilter.checkAndUpdateDefaultValue(dashView);
    dashView.OldDashDivSize.width = requestOptions["OLDWIDTH"];
    ZDBDThemes.apply(dashView);
    if (dashView.dashQ.isEmpty()) {
        ZDBDashboardAPI.stopLoadingViews(dashView);
    } else {
        ZDBDashboardAPI.startLoadingViews(dashView);
        dashView.dashQ.load();
        ZAVMFilter.preLoadVMFilterIfNeeded(dashView);
    }
    //alert("Before Resize " + viewCtx.parComp.clientWidth +" vs "+ dashView.dashDiv.clientWidth); //$$DASHLAYOUT$$
    dashView.resize();//Just to make the individual view size perfect. No worries... The function is not costly. It executes only when there is a size diff.
    //alert(viewCtx.parComp.clientWidth +" vs "+ dashView.dashDiv.clientWidth);//$$DASHLAYOUT$$
     
    typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.addRecord(ZRCRMPlusHomePage.RECENTITEMS, dashView);//NO I18N
    if(fromExpEdit)
    {
    	ZDBDashboardAPI.switchMode(mainDiv,"editMode");		//No I18N
    }
    return dashView;
  }
  
    this.fetchMobileLayout = function (objId, viewCtx)
    {
        if (!ZDBLazyLoadUtil.loadJsAlone(["ZAVMFilterList", "ZRDashboardView"], "APPENDTODOC", ZDBDashboardAPI.fetchMobileLayout, [objId, viewCtx])) 
        {
            return;
        }
        if (!ZDBLazyLoadUtil.loadJsAlone(['mobile/iphone/ZRSIphone.js','dashboard/js/ZDBDashboardMobile.js'], 'APPENDTODOC', ZDBDashboardAPI.fetchMobileLayout, [objId, viewCtx]))
        {
            return;
        }
        if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_DASHBOARDSTYLES", "CSSLIST_VMFILTERSTYLES"], "APPENDTODOC", 
        ZDBDashboardAPI.fetchMobileLayout,[objId,viewCtx])){
            return;
        }
        ZDBDashboardMobile.init (objId, viewCtx);
    };
  
    this.showPanel = function(view)
    {
        if(view.editMode)
        {
             ZAVMFilter.showOrHideVMFilterPanel(view);
             ZAVMFilter.placeVMFilterDefinition(view); // To show the test in dash UF (when dashboard with no UF is edited)
        }
        else
        {
             ZAVMFilter.showOrHideVMFilterPanel(view,true);
        }
        ZDBDashboardAPI.activateAddUFBtnIfNeeded(view);
    }

  this.createDashInstance = function(viewCtx,mainDiv,dashView)
  {
      if(viewCtx.isStandAlone())
      {
        mainDiv.style.border = "none";
      }
      ZAVMFilter.placeVMFilterCriteria(dashView);
      ZDBDashboardAPI.showPanel(dashView);
      viewCtx.handle(dashView);
      ZAVMFilter.showMoreLessOption(dashView, !(dashView.editMode));
      dashView.changeSliderBoundaries = true;
      var sliderBounds = ZDBUtil.getElWithTagNAttrWithVal(mainDiv, "id", "sliderBounds", "div");  //NO I18N
      if(sliderBounds)
	  {
    	  sliderBounds = JSON.parse(ZDBEscapeUtil.decodeForHtml(sliderBounds.innerHTML));
          ZASliderComp.sliderRangesForGridView(sliderBounds,dashView); //NO I18N
	  }
      ZDBDStructure.updateStructInfo(dashView, null, null, !dashView.editMode);
      ZDBDashboardAPI.updateModeProperties(dashView);
      DashUtils.showOrHideVMFilterChild(dashView);
      DashUtils.updateChildsBottomPadding(dashView);
  }
    this.fetchAnalysisViewDetails = function (dashView) {
        if (dashView.editMode) {
            return false;
  }
        var initGrpArea = (window.ZDBAnalysisView && window.ZDBAnalysisView.initialized) ? false : true;
        var params = "&ZDBACTION=ANALYSISVIEWDETS_OLD" + dashView.viewCtx.getAdditionalParams();//NO I18N
        params += "&DBID=" + dashView.dbId;//NO I18N
        params += "&OBJID=" + dashView.objId;//NO I18N
        params += "&INCLUDEGRAPHAREA=" + encodeURIComponent(initGrpArea);//NO I18N
        AjaxAPI.sendRequest({URL: ZDBGlobal.CTX + "/ZDBDAnalysisViews.cc",
            PARAMETERS: params,
            ONSUCCESSFUNC: ZDBDashboardAPI.handleAnalysisViewDetailsResp,
            VIEW: dashView,
            OPSTATUSID: dashView.viewCtx.getLoadIndicator()});//NO I18N
        return true;
    };

  this.handleAnalysisViewDetailsResp = function(response,requestOptions) {
	  var lazyLoadList = ["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList","ZAAnalysisFields"];//NO I18N
	  if(!ZDBLazyLoadUtil.loadJsAlone(lazyLoadList, "APPENDTODOC",ZDBDashboardAPI.handleAnalysisViewDetailsResp, [response, requestOptions]))
	  {// here analysisView loading is required for chart/pivot/summary/widget view
		  return;
	  }
      if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBDashboardAPI.handleAnalysisViewDetailsResp, [response, requestOptions]))
      {
          return;
      }
      if (!ZDBLazyLoadUtil.loadSnippet('AnalysisFunMenu', '/AnalysisFunMenu.cc', this, 'APPENDTODOC', null, ZDBDashboardAPI.handleAnalysisViewDetailsResp, [response,requestOptions]))
        {
            return;
        }
      var dashView = requestOptions.VIEW;
      ZDBDashboardAPI.startLoadingViews(dashView);
      dashView.ajaxResponseText.innerHTML = response.responseText;
      
      ZDBAnalysisView.initialize(); 
      dashView.dashQ.enableAnalysisReq();
  };

    this.lazyLoadViewTypeModules = function (viewType, dashView, isCallBack) {
    	// other than this, we can get the dependent js list first and load all necessary js list
    	// this will avoid the individual status check cases
        if(ZDBDashboardAPI.lazyLoadedModules[viewType] 
                || !isCallBack && ZDBDashboardAPI.lazyLoadMap[viewType] || viewType < 0) {
            return;
        }
        switch (viewType) {
            case 0://can be replaced with Constants
            case 1:
            case 3:
            case 4:
            case 6:
                if (!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList", "APPENDTODOC", ZDBDashboardAPI.lazyLoadViewTypeModules, [viewType, dashView, true]))
                {
                    dashView.dashQ.suspendQ();
                    ZDBDashboardAPI.lazyLoadMap[0] = true;
                    ZDBDashboardAPI.lazyLoadMap[1] = true;
                    ZDBDashboardAPI.lazyLoadMap[3] = true;
                    ZDBDashboardAPI.lazyLoadMap[4] = true;
                    ZDBDashboardAPI.lazyLoadMap[6] = true;
                    return;
                }

                ZDBDashboardAPI.lazyLoadedModules[0] = true;
                ZDBDashboardAPI.lazyLoadedModules[1] = true;
                ZDBDashboardAPI.lazyLoadedModules[3] = true;
                ZDBDashboardAPI.lazyLoadedModules[4] = true;
                ZDBDashboardAPI.lazyLoadedModules[6] = true;
                break;
            case 2:
                var lazyLoadList = ["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList","ZAAnalysisFields"];//NO I18N
                if (!ZDBLazyLoadUtil.loadJsAlone(lazyLoadList, "APPENDTODOC", ZDBDashboardAPI.lazyLoadViewTypeModules, [viewType, dashView, true]))
                {
                    dashView.dashQ.suspendQ();
                    ZDBDashboardAPI.lazyLoadMap[viewType] = true;
                    return;
                }
                if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBDashboardAPI.lazyLoadViewTypeModules, [viewType, dashView, true]))
                {
                    return;
                }
                ZDBDashboardAPI.lazyLoadedModules[viewType] = true;
                break;
            case 8:
                if (!ZDBLazyLoadUtil.loadSnippet('WidgetLayouts', '/WidgetLayouts.cc', this, 'APPENDTODOC', null, ZDBDashboardAPI.lazyLoadViewTypeModules, [viewType, dashView, isCallBack]))
                {
                    dashView.dashQ.suspendQ();
                    return;
                }
                var lazyLoadList = ["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList", "WidgetViewList","ZAAnalysisFields"];//NO I18N
                if (!ZDBLazyLoadUtil.loadJsAlone(lazyLoadList, 'APPENDTODOC', ZDBDashboardAPI.lazyLoadViewTypeModules, [viewType, dashView, true]))
                {
                    dashView.dashQ.suspendQ();
                    ZDBDashboardAPI.lazyLoadMap[viewType] = true;
                    return;
                }
                if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBDashboardAPI.lazyLoadViewTypeModules, [viewType, dashView, true]))
                {
                    return;
                }
                ZDBDashboardAPI.lazyLoadedModules[viewType] = true;
                break;
        }
        var view = ZDBClientUI.selectedTab.view;
        dashView = (view instanceof ZDBDashboard) ? view : dashView;
        dashView.dashQ.resumeQ();
    };


  this.updateModeProperties = function(dashView)
  {
    if(dashView.editMode)
    {
      ZDBDashboardAPI.modeHelper.activate(dashView);
    }
    else
    {
      ZDBDashboardAPI.modeHelper.deActivate(dashView);
    }
    var dashDiv = dashView.dashDiv;
    var parSize = dashView.viewCtx.getSize();
    dashDiv.style.height = (dashView.viewCtx.isStandAlone() && (BROWSER.IS_MOBILE))?"":(parSize.height+"px");
  }



  this.switchMode = function(el,mode, dontRefresh)
  {
	if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_DASHBOARDSTYLES", this, ZDBDashboardAPI.switchMode,[el,mode])){
    	return;
    }
    var hideScrollFreeze = document.getElementsByClassName("scrollFreeze"); //No I18N
    if(hideScrollFreeze)
    {
      for (var i = 0; i < hideScrollFreeze.length ; i++) 
      {
        hideScrollFreeze[i].style.display = (mode == "editMode") ? "none" : "block";   //No I18N  
      }
    }
    var dashView = ZDBClientUI.getViewObj(el,"view");   //No I18N
    dashView.showShiftHelpVMFilter = true;
    var url = "/ZDBDashEditUI.cc?"; //NO I18N
    if(dashView.objId > -1)
    {
      url+= "OBJID=" + dashView.objId; //No I18N
    }
    else
    {
      url+= "DBID=" + dashView.dbId; //No I18N
    }
    if(mode == "editMode")
    {
      if(!ZDBLazyLoadUtil.loadSnippet("ZDBDashEditUI",url,this,"APPENDTODOC",
                                      ["ZDBAnalysisEditList", "ZDBDashEdit"],null,null,  //No I18N
                                      dashView.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.dashboard.loadingdiv.js.loadingDBDesigner"))))  //No I18N
      {
        return;
      }
      ZAVMFilter.clearAll(null,dashView,false);
      dashView.switchFrom = "viewMode"; //No I18N
    }
    else
    {
    	jQuery(dashView.VMFilterArea).addClass("doNotHighLight");
      dashView.switchFrom = "editMode"; //No I18N
    }
//    ZDBDashboardAPI.checkNLoadVMFEditUI();
    if(!ZDBLazyLoadUtil.loadSnippet("VMFilterEdit","/ZAVMFilterEdit.cc?",this,"APPENDTODOC",["zdbjs/vmfilter/ZAVMFilterEdit.js","zdbjs/vmfilter/ZAVMFilterEditUI.js","zdbjs/analysisedit/ZDBAnalysisFilter.js"],ZDBDashboardAPI.switchMode,[el,mode]))
     {
      return;
     }
    dashView.editMode = (mode=="editMode"); //No I18N
    dashView.OldDashDivSize.width = dashView.dashDiv.clientWidth;
    ZDBDashboardAPI.showPanel(dashView);
    DashUtils.showOrHideVMFilterChild(dashView);
    ZAVMFilter.showMoreLessOption(dashView, !(dashView.editMode));
    if(dashView.editMode) {
        DashUtils.updateChildsBottomPadding(dashView);
    } else {
        if(dashView.highLightedVMFilter){jQuery(dashView.highLightedVMFilter).removeClass("highLight");}
    }
    ZDBDashboardAPI.updateModeProperties(dashView);
    ZDBMenu.updateToolbar(dashView);
    ZDBDashboardAPI.initTextEditor();
    ZDBDashboardAPI.activateAddUFBtnIfNeeded(dashView);
    ZDBNavigation.showOrHideNavIcon(dashView);
    if(ZDBGlobal.ISNEWLAYOUT)
    {
        var srchSpace = ZDBClientUI.Objects_TBODY.nextElementSibling;
        var clearSrch = $("ZDBObjSearchClearFld");
        ZDBNavigation.dashClearSrch(srchSpace, clearSrch);
    	ZDBExpViewHandler.isDashEditMode = dashView.editMode;
        ZDBClientUI.resizePlaceHolder(); // resizing place holder after showing navigation bar.
    }
    dashView.resize(true);
    if(!dashView.editMode && !dontRefresh) {
        ZDBDashboardAPI.refreshViews(el);
    }
    ZDBDashboardAPI.showInstructionIfNeeded(dashView);
  }

    this.editTheme = function (el, event) {
        if (!ZDBLazyLoadUtil.loadSnippet('DASHBOARD_THEME_EDITOR', '/DashboardTheme.cc', this, 'APPENDTODOC', ['dashboard/theme/js/ZDBDThemeEditor.js'], ZDBDashboardAPI.editTheme, [el, event]))
        {
            return;
        }
        if (!ZDBLazyLoadUtil.loadJsAlone('ZDBChartSetting', 'APPENDTODOC'))
        {
            return;
        }
        ZDBDThemeEditor.open(el, event);
    };

    this.fetchWidget = function (objId, viewCtx) {
        if (!ZDBLazyLoadUtil.loadSnippet('WidgetLayouts', '/WidgetLayouts.cc', this, 'APPENDTODOC', null, ZDBDashboardAPI.fetchWidget, [objId, viewCtx]))
        {
            return;
        }
        if (!ZDBLazyLoadUtil.loadJsAlone(['WidgetViewList','ChartTPVendors', 'ZRJSChartsList'], 'APPENDTODOC', ZDBDashboardAPI.fetchWidget, [objId, viewCtx]))
        {
            return;
        }
        WidgetUtils.fetchView(objId, viewCtx);
        ZDBClientUI.typeDefns.WIDGET.fetchView = WidgetUtils.fetchView;
    };

  this.activateAddUFBtnIfNeeded = function(dashView)
  {
    if(dashView.editMode!=true)
    {
    	return
    }
    var dashChilds = dashView.dashChilds;
    var dashChild = null;
    var count = 0;
    var len;
    if(dashChilds==null){this.handleBtnState(dashView,0);return;}
    for(var i =0,len = dashChilds.length; i < len; i++)
    {
      dashChild = dashChilds[i];
      if(dashChild.isDashChild && dashChild.getAttribute("eltype").toLowerCase()=="view")
      {
       count++;
       break;
      }
    }
    this.handleBtnState(dashView,count);
  }

  this.handleBtnState = function(dashView,count)
  {
    var disabledState = (count>0)?false:true;
    //var VMFilterDropArea = dashView.addUFBtn;
    var addUFBtn = dashView.addUFBtn;
    var className = addUFBtn.className;
    className = ZDBUtil.replaceStr(className, "alpha", "");//No I18N
    addUFBtn.className = className+((count>0)?"":" alpha");
    addUFBtn.disabled = disabledState;
    ZAVMFilter.placeVMFilterDefinition(dashView);
  }

  this.checkNLoadVMFEditUI = function()
  {
     if(!ZDBLazyLoadUtil.loadSnippet("VMFilterEdit","/ZAVMFilterEdit.cc?",this,"APPENDTODOC",["zdbjs/vmfilter/ZAVMFilterEdit.js","zdbjs/vmfilter/ZAVMFilterEditUI.js","zdbjs/analysisedit/ZDBAnalysisFilter.js"],ZDBDashboardAPI.checkNLoadVMFEditUI))
     {
      return;
     }
  }

  this.initTextEditor = function()
  {
      if(ZDBDashboardAPI.textEditorInitialized){return;}
      ZE_Init.init();
      ZDBDashboardAPI.textEditorInitialized = true;
  }

  this.refreshViews = function (el, isDashGlobalFiltersApplied, resetQueueAndRefresh)
  {
        var dashView = ZDBClientUI.getViewObj(el, "view");//NO I18N
        dashView.maxCacheTime = null;
        if (!dashView.dashQ.onsuccess() && !resetQueueAndRefresh) {
                    return;
      }
        ZDBDStructure.updateStructInfo(dashView, null, null, true, isDashGlobalFiltersApplied);
      dashView.refreshCounter++;
      DashUtils.updateChildsBottomPadding(dashView);
        if(dashView.dashQ.isEmpty()) {
        	return;
        }
        ZAVMFilter.checkAndUpdateDefaultValue(dashView);
        ZDBDashboardAPI.startLoadingViews(dashView);
        dashView.dashQ.load();
        if (!dashView.changeSliderBoundaries && dashView.changedCol != null)
      {
          var component = dashView.lastAppliedEl;
          var labelName = component.getAttribute("label");
          var action = "FORMATSLIDERVALUE"; //NO I18N
          var viewParams = ""
            if (dashView.objId > -1)
          {
            viewParams += "&OBJID=" + dashView.objId; //No I18N
          }
          else
          {
            viewParams += "&DBID=" + dashView.dbId; //No I18N
          }
            viewParams += dashView.viewCtx.getAdditionalParams();
            var doXML = ZDBDStructure.getDashBoardCurrentConfig(dashView, false);
            viewParams += "&PARENTVIEWID=" + component.getAttribute("PARENT_OBJ_ID");//NO I18N
            var url = "/DashUFAction.ma?VMFILTERLBLNAME=" + encodeURIComponent(labelName) + viewParams; //NO I18N
            url += "&CHANGESLIDERBOUNDS=" + dashView.changeSliderBoundaries + "&CHANGEDCOLDETAILS=" + encodeURIComponent(dashView.changedCol); //NO I18N
            url += "&ZDBACTION=" + action; //NO I18N
            AjaxAPI.sendRequest({URL: url, POSTBODY: doXML,
                REQUESTHEADERS: {"Content-type": "text/xml;charset=utf-8"}, //NO I18N
                VIEW: dashView, COMP: component, ACTION: action, ONSUCCESSFUNC: ZDBDashboardAPI.hndldashUFActionResp});
	}
    };
    this.fetchCurChildView = function (dashChild, dashView) {
        if (ZDBClientUI.selectedTab && ZDBClientUI.selectedTab.view.type === 'Dashboard' && !ZDBTabSwitchHandler.isRelevendTab2Exec(dashView, dashView.dashQ.resumeQ)) {
            dashView.dashQ.suspendQ();
            return false;
        }
        if (dashChild && ((dashChild.ctx && dashChild.ctx.view) || dashChild.view)) {
            var childView = dashChild.view || dashChild.ctx.view;
            if(childView.drillDet && window.ZRSDrillDown) {
            ZRSDrillDown.clearDrillDet(childView);
            }
            childView.refreshView();
            if (!(childView.permissions.exportPerm || childView.exportPerm) && dashChild.dashViewOptions && dashChild.dashViewOptions.export) {
                dashChild.dashViewOptions.export.parentNode.removeChild(dashChild.dashViewOptions.export);
                delete dashChild.dashViewOptions.export;
            }
            return true;
        }
        ZDBDashboardAPI.fetchCurElView(dashChild, dashView);
        return true;
    };

  this.hndldashUFActionResp = function(response,requestOptions)
  {

      var view = requestOptions["VIEW"];
      var action = requestOptions["ACTION"];
      if(action=="FORMATSLIDERVALUE")
      {
          ZDBDashboardAPI.hndlSliderBoundsResp(response,requestOptions);
      }
      else if(action=="DASHBOARDUFVALIDATION")
      {
        ZDBDashboardAPI.handleUFValidation(response,requestOptions);
      }
      ZDBDashboardAPI.activateAddUFBtnIfNeeded(view);
  }
  this.hndlSliderBoundsResp = function(response,requestOptions)
  {
      var view = requestOptions["VIEW"];
      var comp = requestOptions["COMP"];
      view.sliderBounds = JSON.parse(response.responseText);
      ZASliderComp.setSliderRanges(view); //NO I18N
      comp.boundsExtended = false;
  }

this.markInvalidUserFilters = function(view)
{
   var vmfList = view.VMFiltersList;
   var showreset = (view.timeLineCompEnabled) ? true : false;
   for(var i=0;i<vmfList.length;i++)
    {
      var comp = vmfList[i];
      var isValid = comp.getAttribute("IS_VALID_COL");
      var isAuthorised=comp.getAttribute("IS_AUTHORISED_COL");
      if(!showreset && isValid.toString()==="true" && isAuthorised.toString()==="true")
      {
        showreset = true;
      }
      ZDBDashboardAPI.markUserFilterIfRestricted(view,comp);
    }
}

this.markUserFilterIfRestricted = function(view,comp)
{
      ZDBUtil.setNamedChildEls(comp,comp);
      var isAuthorised = comp.getAttribute("IS_AUTHORISED_COL");
      if(isAuthorised == "false" || isAuthorised== false){
          var highLighEl = jQuery(view.dropArea).find('[class="VMFilterCompDrgEl highLight"]')[0];
          comp.className = (highLighEl && (comp == highLighEl) && view.editMode) ? "VMFilterCompDrgEl highLight" : "VMFilterCompDrgEl" ;
      }
      else if(isAuthorised=="true" || isAuthorised == true)
      {
          if(comp.restrictedAuthorisedSymbol)
          {
            comp.restrictedAuthorisedSymbol.parentNode.removeChild(comp.restrictedAuthorisedSymbol);
            comp.restrictedAuthorisedSymbol=null;
          }
      }
        var isValid = comp.getAttribute("IS_VALID_COL");
        if((isValid=="true" || isValid==true))
        {
          var highLighEl = jQuery(view.dropArea).find('[class="VMFilterCompDrgEl highLight"]')[0];
          comp.className = (highLighEl && (comp == highLighEl) && view.editMode) ? "VMFilterCompDrgEl highLight" : "VMFilterCompDrgEl" ;
          if(comp.restrictedSymbol)
          {
              comp.restrictedSymbol.parentNode.removeChild(comp.restrictedSymbol);
              comp.restrictedSymbol = null;
          }
        }
        else if(isValid=="false" || isValid==false)
        {
          if(comp.restrictedSymbol){return;}
          comp.className = "VMFilterCompDrgElRestricted";
          var restrictedSymbol = ZDBUtil.getCloned(view.restrictedSymbol);
          comp.contentHolder.appendChild(restrictedSymbol);
          comp.restrictedSymbol = restrictedSymbol;
        }
}
  this.handleUFValidation = function(response,requestOptions)
  {
    var view = requestOptions["VIEW"];
    var valdMapEl = JSON.parse(response.responseText);
    var vmfList = view.VMFiltersList;
    var showreset = false;
    for(var i=0;i<vmfList.length;i++)
    {
      var comp = vmfList[i];
      var label = comp.getAttribute("LABEL");
      var isValid = valdMapEl[label]["IS_VALID_COL"];
      var isAuthorised=valdMapEl[label]["IS_AUTHORISED_COL"];
      if(!showreset && isValid && isValid.toString()==="true" && isAuthorised.toString()==="true")
      {
        showreset = true;
      //  break;
      }
      comp.setAttribute("IS_VALID_COL",isValid);
      comp.setAttribute("IS_AUTHORISED_COL",isAuthorised);
      ZDBDashboardAPI.markUserFilterIfRestricted(view,comp);
    }
    ZDBDashboardAPI.handleTimeLineValidation(view);
  }
  
  this.handleTimeLineValidation = function(view)
  {
    var dashViews = ZDBDashboardAPI.viewsInDashboard(view);
    if(view.timelineComp)
    {
	    if(dashViews.length ==0)
	    {
	    	view.timelineComp.setAttribute("IS_VALID_COL","false");
	    }
	    else
	    {
	    	view.timelineComp.setAttribute("IS_VALID_COL","true");
	    }
	    ZDBDashboardAPI.markUserFilterIfRestricted(view,view.timelineComp);
    }
  }
  this.refreshChild = function(dashChild)
  {//$$ Issue Here we don't call/remove the old child!!. Should have been handled.
	  if(dashChild.ctx){
		  this.fetchCurElView(dashChild,dashChild.ctx.dashView);
	  }
  }

  this.setEditorHeight = function(dashChild)
{
  var maxHeight = 120;
  var titleEl= DOMUtils.getFirstMatchingChild(dashChild,"div","elname", "dlgBody"); //NO I18N
  if(titleEl && titleEl.offsetHeight>120)
  {
    titleEl.style.height = 120+"px";
  }
}

  this.fetchCurElView = function(curEl,dashView)
  {
    var eltype = curEl.getAttribute("eltype");
    var isValidFilterCriteria = curEl.getAttribute("isValidFilterCriteria");
    var isViewSharedForSharedUser = curEl.getAttribute("isViewShared");
    if(dashView)
    var newView = ZDBUtil.isNewView(dashView);
    if(eltype == "VIEW")
    {
      ZDBUtil.setNamedChildEls(curEl,curEl);
    }
    else
    {//Otherwise setNamedChildEls becomes too slow due to large size of html.
      var dlgBody = DOMUtils.getFirstMatchingChild(curEl, null, "elname", "dlgBody");   //No I18N
      curEl.dlgBody = dlgBody;
      curEl.elnameSet = true;
    }
    var parDiv = curEl.dlgBody;
    ZDBDashboardAPI.setIfVMFilterApplicable(curEl);
    if(parDiv==null){return;}
    parDiv.innerViewCtx = new ZDBDashboardCtx(dashView,curEl,parDiv);

    if(eltype == "VIEW" && isValidFilterCriteria != "false" && isViewSharedForSharedUser != "false")
    {
      var objId =  curEl.getAttribute("objId");
      var viewType = curEl.getAttribute("viewType"); 
      if(curEl.dashViewOptions) {
          curEl.dashViewOptions.setAttribute('class','dashviewoptions '+curEl.getAttribute('viewtype').toLowerCase());
          ZDBUtil.setNamedChildEls(curEl.dashViewOptions, curEl.dashViewOptions, "action");
      }
      ZDBDashboardAPI.fetchViewByType(objId,viewType,parDiv.innerViewCtx,newView);
    }
    curEl.fetched = true;
  }

   this.setIfVMFilterApplicable = function(dashChild)
   {
       dashChild.autoVMFilter = ZDBDashboard.isDragFromViewList;
   }

  this.fetchViewByType = function(objId,type,viewCtx,newView)
  {
    ZDBClientUI.typeDefns[type].fetchView(objId,viewCtx);
  }

  this.refreshCurView = function(el)
  {
    var dashBoardDiv =  DOMUtils.getParentWithAttr(el,"isDashBoardDiv");    //No I18N
    dashBoardDiv.dlgBody.view.refreshView();
  }

  this.viewUDCurView = function(el)
  {
    var dashBoardDiv =  DOMUtils.getParentWithAttr(el,"isDashBoardDiv");  //No I18N
    var view = dashBoardDiv.dlgBody.view;
    ZDBVUDataAPI.viewUD(view);
  }

  this.searchInTable = function(el,event)
  {
    var dashBoardDiv =  DOMUtils.getParentWithAttr(el,"isDashBoardDiv");  //No I18N
    var view = dashBoardDiv.dlgBody.view;
    ZDBSearchUtil.searchInTable(el,event,view);
  }
  
  this.clearSearch = function(el,event)
  {
    var dashBoardDiv =  DOMUtils.getParentWithAttr(el,"isDashBoardDiv");  //No I18N
    var view = dashBoardDiv.dlgBody.view;
    ZDBSearchUtil.searchValue(el,view);
  }

  this.searchOnClick = function(el,view)
  {
      var dashBoardDiv =  DOMUtils.getParentWithAttr(el,"isDashBoardDiv");  //No I18N
      view = dashBoardDiv.dlgBody.view;
      ZDBSearchUtil.searchOnClick(el,view);
  }

  this.navigateEl = function(el,navType,event)
  {
    var dashBoardDiv =  DOMUtils.getParentWithAttr(el,"isDashBoardDiv");  //No I18N
    var gridObj = dashBoardDiv.dlgBody.view;
    ZDBGridScroll.navigateEl(navType,gridObj);
  }


  this.showViewModeOptions = function(currentView)
  {
    var eltype = currentView.getAttribute("eltype");
    if(eltype=="HTML"){return;}
    if(currentView.dlgViewModeOptions != null)
    {
      currentView.dlgViewModeOptions.style.display="";
    }
  }

  this.showInstructionIfNeeded = function(dashView,forceHide)
  {
	if(!dashView){return;}
	var container = dashView.dashDiv;
	var dashboardDivs = jQuery(container).find("[isdashboarddiv='true']");
	var instructionDiv = $("ZDBDashInstruction");
	var editMode = dashView.editMode;
	if((instructionDiv && dashView.dashboardVMFArea.parentNode!=null) && (instructionDiv.parentNode != dashView.dashboardVMFArea.parentNode))
		{
			dashView.dashboardVMFArea.parentNode.appendChild(instructionDiv);
		}
  	if(instructionDiv)
  		{
  			instructionDiv.style.display = ((dashboardDivs.length<=1 && editMode && (forceHide!=true)))?"":"none";
  		}
  }
  
  this.isDashboardEmpty = function(dashView)
  {
	  if(!dashView || !dashView.dashChilds)
		  {
		  	return true;
		  }
	  var rows = DOMUtils.filterElements(dashView.dashChilds,null,'isdashboardrowdiv','true'); //No I18N
	  return rows.length <= 1;
  }
  
  this.viewsInDashboard = function(dashView)
  {
	  var views = new Array();
	  if(!dashView || !dashView.dashChilds)
	  {
	  	return views;
	  }
	  views = DOMUtils.filterElements(dashView.dashChilds,null,'eltype','VIEW'); //No I18N
	  return views;
  }

    this.startLoadingViews = function (dashView) {
        dashView.tab.tabIcon.className = "tabIcon mcLoading";//No I18N
    };
    
    this.stopLoadingViews = function (dashView) {
        dashView.tab.tabIcon.className = "tabIcon mcLoaded"; //No I18N
        dashView.OldDashDivSize.width = dashView.dashDiv.clientWidth;
        var func = function () {
            ZDBMenu.updateToolbar(dashView);
        };
        if (!ZDBTabSwitchHandler.isRelevendTab2Exec(dashView, func))
        {
            return;
        }
        ZDBMenu.updateToolbar(dashView);
    };
    
    this.updateDashChilds = function (dashView) {
        var toUpdate = dashView.toUpdate;
        for (var i = 0; i < toUpdate.length; i++) {
            var dashChild = toUpdate[i];
            ZDBDashboardAPI.updateDashChild(dashChild, dashView);
        }
    };

    this.updateDashChild = function (dashChild, dashView) {//Check y this
        var dlgBody = DOMUtils.getFirstMatchingChild(dashChild, null, "elname", "dlgBody");   //No I18N
        dashChild.dlgBody = dlgBody;
        dashChild.elnameSet = true;
        var parDiv = dashChild.dlgBody;
        if (parDiv === null) {
            return;
        }
        parDiv.innerViewCtx = new ZDBDashboardCtx(dashView, dashChild, parDiv);
    };
    
            }
    
ZDBDashboardAPI.resizeInnerView = function(dashChildDiv)
{
  var eltype = dashChildDiv.getAttribute("eltype");
  var isShared =(dashChildDiv.getAttribute("isviewshared")=="true");//No I18N
  if(eltype=="HTML" || !isShared){return;}
  if(dashChildDiv.ctx.view != null)
  {
	if(dashChildDiv.ctx.view.type == "WIDGET"){
		dashChildDiv.ctx.view.renderer.resize(dashChildDiv.dlgBody);
		return;
	}
    dashChildDiv.ctx.view.resize();
  }
}

ZDBDashboardAPI.startDrag = function(el,event)
{
  ZDBDashboardAPI.modeHelper.startDrag(el,event);
}

ZDBDashboardAPI.showVerticalResizer = function (el, event) {
	var dashView = ZDBClientUI.selectedTab && ZDBClientUI.selectedTab.view;
    if (dashView && !dashView.editMode) {
        return;
    }
    ZDBEditModeSelect.showVerticalResizer(el, event);
}

var ZDBDashViewMode ={
  activate: ZDBUtil.dummyFunc,
  deActivate:ZDBUtil.dummyFunc,
  viewVisible:ZDBUtil.dummyFunc,
  viewHidden:ZDBUtil.dummyFunc,
  structureChanged:ZDBUtil.dummyFunc,
  setSwipeBarClass:ZDBUtil.dummyFunc,
  startDrag:ZDBUtil.dummyFunc
};

ZDBDashViewMode.isInNavigDragMode = function(){return false;}


ZDBDashboardAPI.modeHelper = ZDBDashViewMode;


ZDBClientUI.typeDefns["Dashboard"] = {fetchView:((BROWSER.IS_MOBILE_PHONE)?ZDBDashboardAPI.fetchMobileLayout:ZDBDashboardAPI.fetchView),
                                      createView:ZDBDashboardAPI.createView,
                                      newName:"zrpt.common.js.newDashboard",  //No I18N
                                      dummyView:((BROWSER.IS_MOBILE_PHONE)?"iPhoneBlankView":"blankView"), //No i18N
                                      };


ZDBClientUI.typeDefns.WIDGET = {fetchView: ZDBDashboardAPI.fetchWidget,
                                newName: "zrpt.common.js.newWidget", //No I18N
                                dummyView: "blankView"}; //No I18N


var ZDBReportDashUtil = new Object();
ZDBReportDashUtil.checkAndRemoveFromDOM = function(dashBoardObj,parent,child,dontShowGrid)
{
	//dontShowGrid is not used now. It will be taken for future reference when taking this model to resizing too
	if(dashBoardObj.editMode)
		{
		return;
		}
	if(!dashBoardObj.gridRender)
		{
		dashBoardObj.gridRender = new Object();
		}
	if(!dashBoardObj.gridRender.renderedReports)
		{
		dashBoardObj.gridRender.renderedReports = [];
		}

	if(!parent)
		{
		return;
		}
	dashBoardObj.gridRender.renderedReports.push(ZDBReportDashUtil.removeFromDOM(dashBoardObj,parent,child));
	if(!dontShowGrid)
		{
	ZDBReportDashUtil.showReportInViewAndRemoveOther(dashBoardObj);
		}

}

ZDBReportDashUtil.maintainReportCount = function(dashBoardObj,noOfGrids)
{
	if(!dashBoardObj.gridRender)
	{
	dashBoardObj.gridRender = new Object();
	dashBoardObj.gridRender.renderedReports = [];
	}

	if(!isNaN(noOfGrids) && noOfGrids >= 0)
		{
		dashBoardObj.gridRender.reportRespCount = noOfGrids;
		return;
		}
	var totalReportCount = 0;
	if(dashBoardObj.views["0"])
	{
		totalReportCount+=JSON.parse(dashBoardObj.views["0"]).length;
	}
	if(dashBoardObj.views["1"])
	{
		totalReportCount+=JSON.parse(dashBoardObj.views["1"]).length;
	}
	if(dashBoardObj.views["3"])
	{
		totalReportCount+=JSON.parse(dashBoardObj.views["3"]).length;
	}
	if(dashBoardObj.views["4"])
	{
		totalReportCount+=JSON.parse(dashBoardObj.views["4"]).length;
	}
	if(dashBoardObj.views["5"])
	{
		totalReportCount+=JSON.parse(dashBoardObj.views["5"]).length;
	}
	if(dashBoardObj.views["6"])
	{
		totalReportCount+=JSON.parse(dashBoardObj.views["6"]).length;
	}

	dashBoardObj.gridRender.reportRespCount = totalReportCount;
}

ZDBReportDashUtil.removeFromDOM = function(dashBoardObj,parent,child)
{
	var newObject = new Object();
	newObject.parentArea = parent;
	newObject.grid = child;
	newObject.nextChildren=child.nextElementSibling;
	newObject.top = child.gridObj.viewCtx.dashChildDiv.offsetTop
	if(ZDBReportDashUtil.isViewWithinViewPort(child,dashBoardObj.gridRender) || dashBoardObj.gridRender.renderedReports.length === dashBoardObj.gridRender.reportRespCount-1) 
	{
	    child.style.visibility = "visible";

	    newObject.isInView = true;
	}
	else
		{
	if(!parent || !child.parentNode)
		{
			return;
		}
	child.gridObj.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.analysis.js.generate_rpt")).className = "zdbLoading";//No I18N
	child.parentNode.removeChild(child);
	newObject.isInView = false;
	ZDBUtil.setTimeout(function(){if(dashBoardObj.gridRender.renderedReports && dashBoardObj.gridRender.renderedReports.length >= dashBoardObj.gridRender.reportRespCount){child.gridObj.viewCtx.loadIndicator.className = "zdbLoaded";return;}child.gridObj.viewCtx.loadIndicator.className = "zdbLoading";}, 0);
		}

	return newObject;
}

ZDBReportDashUtil.removeAllInView = function(dashBoardObj)
{
	var gridRender = dashBoardObj.gridRender;
	if(gridRender && gridRender.renderedReports)
		{
			for(var i=0; i< gridRender.renderedReports.length;i++)
				{
					if(gridRender.renderedReports[i].isInView)
						{
							if(gridRender.renderedReports[i].grid.parentNode)
								{
								gridRender.renderedReports[i].grid.parentNode.removeChild(gridRender.renderedReports[i].grid);
								}
							gridRender.renderedReports[i].isInView = false;
							gridRender.renderedReports[i].alreadyInView = true;
						}
				}
		}
}


ZDBReportDashUtil.checkAndAppendToDOM = function(dashBoardObj)
{
	if(dashBoardObj.gridRender.reportRespCount <= dashBoardObj.gridRender.renderedReports.length)
	{
		ZDBReportDashUtil.appendToDOM(dashBoardObj.gridRender);
	}

}
ZDBReportDashUtil.appendToDOM = function(gridRenderObj,toCheckAlreadyInView)
{
	if (!gridRenderObj) {
		return;
	}
	var renderedReports = gridRenderObj.renderedReports;
	if(!renderedReports || renderedReports.length <= 0 )
		{
		return;
		}
	for(var i=renderedReports.length-1;i>=0;i--)
		{
		if((toCheckAlreadyInView && renderedReports[i].alreadyInView) || (!toCheckAlreadyInView && !renderedReports[i].isInView))
			{
		ZDBReportDashUtil.appendGridToDOM(renderedReports[i]);
			}
		renderedReports[i].grid.gridObj.viewCtx.getLoadIndicator().className = "zdbLoaded";//No I18N
		renderedReports[i].grid.gridObj.gArea.style.visibility = "visible";//No I18N
		}
}

ZDBReportDashUtil.appendGridToDOM = function(renderedReport)
{
	if(renderedReport.nextChildren)
	{
		if(ZDBUtil.getElsWithTagNAttrWithVal(renderedReport.nextChildren.parentNode,"elname","gArea","div").length === 0)
		{
			renderedReport.nextChildren.parentNode.insertBefore(renderedReport.grid,renderedReport.nextChildren);
		}
	}
	else
	{
		if(ZDBUtil.getElsWithTagNAttrWithVal(renderedReport.parentArea,"elname","gArea","div").length === 0)
		{
			renderedReport.parentArea.appendChild(renderedReport.grid);	
		}
	}
	renderedReport.isInView = true;
}
ZDBReportDashUtil.isViewWithinViewPort = function(gArea,gridRender)
{
    var gridTop = ZDBUtil.getObjTop(gArea.gridObj.viewCtx.dashChildDiv, false, gArea.gridObj.viewCtx.dashView.dashDiv);
    var dashScrollTop;
    gridRender.mainContentHeight = gArea.gridObj.viewCtx.dashView.dashDiv.offsetHeight;
    dashScrollTop = gArea.gridObj.viewCtx.dashView.dashDiv.scrollTop;
   /* if(gArea.gridObj.viewCtx.dashView.mainContent)
    	{//while creating new dashboard, maincontent will not be there   
    dashScrollTop = gArea.gridObj.viewCtx.dashView.mainContent.scrollTop;
    	}
    else
    	{
    	dashScrollTop = 0;
    	}*/
    var dashViewHeight = gridRender.mainContentHeight;//gArea.gridObj.viewCtx.dashView.mainContent.offsetHeight;
    var gridHeight = gArea.gridObj.gHeight;
    if(gridTop+gridHeight >= dashScrollTop-30 && gridTop+30 <=(dashScrollTop+dashViewHeight))
    {
        return true;
    }
    return false;
}

ZDBReportDashUtil.showReportInViewAndRemoveOther = function(dashBoardObj)
{
	var renderedReports = dashBoardObj.gridRender.renderedReports;
	if(!renderedReports || renderedReports.length == 0)
		{
		return;
		}
	for(var i=0;i<renderedReports.length;i++)
		{
		if(ZDBReportDashUtil.isViewWithinViewPort(renderedReports[i].grid,dashBoardObj.gridRender))
			{
			if(!renderedReports[i].isInView)
				{
			ZDBReportDashUtil.appendGridToDOM(renderedReports[i]);
			renderedReports[i].grid.style.visibility = "visible";
			renderedReports[i].grid.style.opacity = "1";
			renderedReports[i].grid.gridObj.viewCtx.getLoadIndicator().className = "zdbLoaded";//No I18N
			renderedReports[i].isInView = true;
				}
			}
		else
			{
			if(renderedReports[i].isInView)
				{
				ZDBReportDashUtil.removeFromDOM(dashBoardObj,renderedReports[i].parentArea,renderedReports[i].grid);
				renderedReports[i].grid.gridObj.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.analysis.js.generate_rpt")).className = "zdbLoading";//No I18N
				}
			renderedReports[i].isInView = false;
			}
		}
	
}
