//$Id$
var ZRDashboardAPI = (function(){
	var _classList = window.DOMTokenList ? window.DOMTokenList.prototype : false;
	var UFTemplate = null, lazyLoadedModules = {}, imgDoc = null, loadingEl = null,
	Util = {
		addClass : function(element){
			if(_classList){
				var cList = element.classList;
				for(var i=1; i<arguments.length; i++){
					try{
						_classList.add.call(cList,arguments[i]);
					}
					catch(e){};
				}
        	}
			else{
	        	var className = element.className;
	        	var changes = false;
	        	for(var i=1; i<arguments.length; i++){
	        		var cArg = arguments[i];
	        		var cStr = "";
	        		cStr = cArg + "";
	        		if(cStr !== ""){
	        			className = " "+className+" ";
	        			cStr = " "+cStr+" ";
	        			var rExp = new RegExp(cStr);
	        			if(!rExp.test(className)){
	        				className = className.trim() + " " + cStr.trim();
	        				changes = true;
	        			}
	        		}
	        	}
	        	if(changes){
	        		element.className = className;
	        	}
        	}
  		},
  		removeClass : function(element){
  			if(_classList){
  				var cList = element.classList;
  				for(var i=1; i<arguments.length; i++){
  					_classList.remove.call(cList,arguments[i]);
  				}
  			}
	        else{
	        	var className = element.className;
	        	var changes = false;
	        	for(var i=1; i<arguments.length; i++){
	        		var cArg = arguments[i];
	        		var cStr = "";
	        		if(!util.isObj(cArg)){
	        			cStr = cArg + "";
	        		}
	        		if(cStr !== ""){
	        			className = " "+className+" ";
	        			cStr = " "+cStr+" ";
	        			var rExp = new RegExp(cStr);
	        			if(rExp.test(className)){
	        				className = className.replace(cStr," ").trim();
	        				changes = true;
	        			}
	        		}
	        	}
	        	if(changes){
	        		element.className = className;
	        	}
        	}
      	}
	};
	
	function setUFtemplate(doc){
		UFTemplate = doc.getElementById("ZDBDashVMEl");
		UFTemplate.id = "";
	}

	function needUFTempalate(){
		return ufTemplate === null;
	}
	
	function getNewViewComponent(dbId, objectID, displayName, description){
		var viewComp = document.createElement("div");
		//viewComp.className = "";
		viewComp.setAttribute("dbid", dbId);
		viewComp.setAttribute("objid", objectID);
		viewComp.setAttribute("displayName", displayName);
		viewComp.setAttribute("description", description);
		return viewComp;
	}

	/* Dashboard Instance related functions START */
	// returns new ZRDashboard();
	function createDashInstance(viewContext, dbID, objectID, permLevel, displayName, description){
		var viewComp = getNewViewComponent(dbID, objectID, displayName, description);
		var dashboard = new ZRDashboard.VLayout(viewComp);
		dashboard.type = "Dashboard";
		dashboard.viewComp = viewComp;
		ZDBClientViewAPI.initFromDiv(dashboard, dashboard.viewComp);
		viewContext.handle(dashboard);
		ZDBMenu.updateToolbar(dashboard);
		if(permLevel != undefined){
			dashboard.viewComp.setAttribute("permlevel", permLevel);
			constructDashboard(dashboard);
		}
		return dashboard;
	}

	function constructDashboard(dashboard, json){
		dashboard.initialize(json);
		dashboard.$build(json.layout);
	}

	function getSaveAjaxObject(dashboard, viewParams, requestOptions){
		return {
			URL : ZDBGlobal.CTX + ZRDashConstants.saveURL + viewParams,
			POSTBODY : dashboard.getCurrentConfig(false, true),
			ISNEWVIEW : ZDBUtil.isNewView(dashboard),
			VIEW : dashboard,
			ONSUCCESSFUNC : ZDBCreateViewAPI.handleViewSave,
			ONFAILUREFUNC : ZDBCreateViewAPI.handleSaveFailure,
			ORIGREQOPTIONS : requestOptions,
			OPSTATUSID : dashboard.viewCtx.getLoadIndicator(ZDBI18NMap.g(ZRDashConstants.savingDashboard))
		}
	}

	function getWidgetData(dashboard){
		var xmlContents = "", xmlBuff = new ZDBStrBuf();;
		dashboard.structure.forEach(function(item){
			if(item.viewType == "WIDGET"){
				var view = item.view;
				xmlContents += WidgetUtils.getConfig(view.objId, view);
			}
		});
		if(xmlContents != ""){
			xmlBuff.sTag("ZDBWidget").a(xmlContents).eNTag("ZDBWidget"); //No i18N
		}
		return xmlBuff.toString();
	}

	function dataToXML(tag, saveData){
		var xmlBuff = new ZDBStrBuf();
		xmlBuff.sTag(tag);
		for(var attrName in saveData.attr){
			xmlBuff.attr(attrName, saveData.attr[attrName]);
		}
		xmlBuff.eTag(true);
		if(saveData.data){
			xmlBuff.a(saveData.data)
		}
		xmlBuff.eNTag(tag);
		return xmlBuff.toString();
	}

	function getXMLData(data, sendCompleteConf){
		return dataToXML(ZRDashConstants.xmlDoc, {
			data : data,
			attr : {
				viewConf : sendCompleteConf,
				csrftoken : ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) //No i18N
			}
		});
	}

	function getXMLLayout(structure){
		return dataToXML(ZRDashConstants.xmlLayout, {attr : {layout : JSON.stringify(structure)}});
	}

	function getXMLDashTheme(themeJSON){
		return dataToXML(ZRDashConstants.xmlTheme, {attr : {theme : JSON.stringify(themeJSON)}});
	}

	function getSaveData(dashboard){
		if(!dashboard.hasContents()){
			return "";
		}
		return getXMLLayout(dashboard.structure) + getXMLDashTheme(dashboard.theme.toJSON());
	}
	
	function setInitialConfigurations(){
		var configurations = {
				spcaing : 0,
				mode : "viewMode" //No i18N
		};
	};
	
	function initViewProperties($node){
		var properties = $node.properties = {};
		switch($node.viewType){
			case "AnalysisView" : { //No i18N
				properties.showTitle = 1;
				break;
			}
		}
	}
	
	function initViewHeader($node){
		var titleDescArea = document.createElement("div");
		titleDescArea.className = "dashChildTitleDesc";
		
        var wrapper = document.createElement("div");
        wrapper.className = "dashChildTitleArea";
        
        var dlgTitle = document.createElement("div");
        dlgTitle.className = "dashboardTitleFont";
        
        var dlgDescription = document.createElement("div");
        dlgDescription.className = "dashboardDescFont";
        
        wrapper.appendChild(dlgTitle);
        wrapper.appendChild(dlgDescription);
        titleDescArea.appendChild(wrapper);
        $node.dashChild.appendChild(titleDescArea);
        
        Object.defineProperties($node.dashChild, {
            dlgTitle : {
                value : dlgTitle
            },
            dlgDesc : {
                value : dlgDescription
            },
            titleDescArea : {
                value : titleDescArea
            }
        });
        
        if($node.properties === undefined){
    		initViewProperties($node);
        }
        
        if($node.properties.showTitle === "0"){
        	$node.dashChild.setAttribute("showtitle","false", true);
        }
        else{
        	$node.dashChild.setAttribute("showtitle","true", true);
        }
        
        if($node.properties.showDesc === "1"){
        	$node.dashChild.setAttribute("desc","true", true);
        	$node.dashChild.setAttribute("descLength","true", true);
        }
        else{
        	$node.dashChild.setAttribute("desc","false", true);
        }
        
        
	}
	
	// fetches dashboardView from Server for Mobile (structure)
	function fetchMobileLayout(){
		
	}
	
	//  set individual height for mobile
	function setEditorHeight(){
		
	}
	
	// if there exists analysisView - then their details fetched
	function sendAnalysisViewDetailsRequest(){
		
	}
	
	// response handler for analysisView Details
	function handleAnalysisViewDetails(){
		
	}
	
	//Navigation panel - show if hidden (NEW UI LAYOUT)
	function showPanel(){
		
	}
	
	//switch mode for dashboard (Edit || View)
	function switchMode(){
		
	}
	
	// update dashboard properties according to mode
	function updateModeProperties(){
		
	}
	
	// refresh all views inside dashboard
	function refreshViews(el, isDashGlobalFiltersApplied, resetQueueAndRefresh){
		var dashboard = ZDBClientUI.getViewObj(el, "view");
		dashboard.maxCacheTime = null;
    	dashboard.isViewRendering = false;
		if(!dashboard.dashQ.onsuccess() && !resetQueueAndRefresh){
			return;
		}
		// get all views and add to Q
//		for(var key in dashboard.layout){
//			var $node = dashboard.layout[key];
//			if($node.type === "VIEW" && ($node.properties.excludeDashUF != "1" || !isDashGlobalFiltersApplied)){
//				$node.addToDashQ(dashboard);
//			}
//		}
		dashboard.structure.forEach(function($node){
			if($node.type === "VIEW" && ($node.properties.excludeDashUF != "1" || !isDashGlobalFiltersApplied)){
				if($node.canLoad()){
					$node.addToDashQ(dashboard);
				}
			}
		});
		if(dashboard.gridRender){
			dashboard.gridRender.renderedReports = [];			
		}
		if(dashboard.dashQ.isEmpty()) {
            return;
        }
		dashboard.dashQ.load();
		if(!dashboard.changeSliderBoundaries && dashboard.changedCol != null){
			var component = dashboard.lastAppliedEl;
			var labelName = component.getAttribute("label");
			var action = "FORMATSLIDERVALUE"; //No i18N
			var viewParams = ""; 
		
			if(dashboard.objId > -1){
				viewParams += "&OBJID=" + dashboard.objId; //No i18N
			}
			else{
				viewParams = "&DBID=" + dashboard.dbId;//No i18N
			}
			viewParams += dashboard.viewCtx.getAdditionalParams();
			var doXML = dashboard.getCurrentConfig(dashboard, false);
			viewParams += "&PARENTVIEWID=" + component.getAttribute("PARENT_OBJ_ID"); //No i18N
			
			var url = "/DashUFAction.ma?VMFILTERLBLNAME=" + encodeURIComponent(labelName) + viewParams;//No i18N
			
			url += "&CHANGESLIDERBOUNDS=" + dashboard.changeSliderBoundaries + "&CHANGEDCOLDETAILS=" + encodeURIComponent(dashboard.changedCol); //No i18N
			url += "&ZDBACTION=" + action;//No i18N
			
			AjaxAPI.sendRequest({
				URL : url,
				POSTBODY : doXML,
				REQUESTHEADERS : {
					"Content-type" : "text/xml; cjarset=utf-8"//No i18N
				},
				VIEW : dashboard,
				COMP : component,
				ACTION : action,
				ONSUCCESSFUNC : hndldashUFActionResp
			});
		}
	};
	
	// update all views inside dashboard
	function updateDashChilds(){
		
	}
	
	// resize all views inside dashboard
	function resizeInnerViews(){
		
	}
	
	// set loading state for all views
	function startLoadingViews(){
		
	}
	
	//stop loading state for all views
	function stopLoadingViews(){
		
	}
	
	//get views present in dashboard
	function viewsInDashboard(){
		
	}
	
	//checks empty dashboard
	function isDashboardEmpty(){
		
	}
	/* Dashboard Instance related functions END 16 */

	
	/* Dashboard Individual Views related functions START */
	//refresh the current view (inner view)
	function refreshCurView(){
		
	}
	
	//updates the current view (inner view)
	function updateDashChild(){
		
	}
	
	function fetchLayerFromQ($node, dashboard){
		var dashChild = $node.dashChild;
		if (ZDBClientUI.selectedTab && ZDBClientUI.selectedTab.view.type === 'Dashboard' && !ZDBTabSwitchHandler.isRelevendTab2Exec(dashboard, dashboard.dashQ.resumeQ)) {
            dashboard.dashQ.suspendQ();
            return false;
        }
        if (dashChild && ((dashChild.ctx && dashChild.ctx.view) || dashChild.view)) {
            var childView = dashChild.view || dashChild.ctx.view;
            if(childView.drillDet && window.ZRSDrillDown) {
                ZRSDrillDown.clearDrillDet(childView);
            }
            childView.refreshView();
            if (!(childView.permissions.exportPerm || childView.exportPerm) && dashChild.dashViewOptions.export) {
                dashChild.dashViewOptions.export.parentNode.removeChild(dashChild.dashViewOptions.export);
                delete dashChild.dashViewOptions.export;
            }
            return true;
        }
        fetchCurrentLayer($node, dashboard);
        return true;
	}
	
	function createLayerDOM($node, dashboard){
		var dashChild = $node.dashChild;
        var parentEl = document.createElement("div"); //No i18N
        Util.addClass(parentEl, "zd-parDiv", "dashChildPar");
        dashChild.dlgBody =  parentEl;
        dashChild.loadingDiv = getLoadingEl()
        dashChild.appendChild(dashChild.loadingDiv);
        dashChild.appendChild(parentEl);
        dashChild.ctx = parentEl.innerViewCtx = new ZDBDashboardCtx(dashboard, dashChild, parentEl);
        Object.defineProperty($node, "parentEl", {value : parentEl, writable : true}); //No i18N
        
        //widget case - on refresh (issue)
//        if($node.parentEl){
//        	dashChild.removeChild($node.parentEl);
//        }

        $node.dom.container.appendChild(dashChild);
	}
	
	function setNoPermission($node){
		var respSpan = document.createElement("span");
    	respSpan.className ="font14";
    	respSpan.style.cssText="background-color:white;color:blue;font-weight:BOLD;"; //No i18N
    	respSpan.innerText = $node.properties.respContent;
    	$node.parentEl.appendChild(respSpan);
	}
	
	function fetchCurrentLayer($node, dashboard){
		if($node.viewType !== "WIDGET"){
        	createOptionsHolder($node);
        }else{
        	$node.dashChild.setAttribute("viewtype","WIDGET", true);
        }
    	fetchViewByType($node.viewId, $node.viewType, $node.parentEl.innerViewCtx);
    }

    function fetchViewByType(objId, type, viewCtx){
        ZDBClientUI.typeDefns[type].fetchView(objId, viewCtx);
    }
    
    function fetchAnalysisViewDetails(dashboard){
		var initGrpArea = (window.ZDBAnalysisView && window.ZDBAnalysisView.initialized) ? false : true;
        var params = "&ZDBACTION=ANALYSISVIEWDETS" + dashboard.viewCtx.getAdditionalParams();//NO I18N
        params += "&DBID=" + dashboard.dbId;//NO I18N
        params += "&OBJID=" + dashboard.objId;//NO I18N
        params += "&INCLUDEGRAPHAREA=" + encodeURIComponent(initGrpArea);//NO I18N
        //console.log(params);
        AjaxAPI.sendRequest({
            URL: ZDBGlobal.CTX + "/ZDBDAnalysisViews.cc", //NO I18N
            PARAMETERS : params,
            ONSUCCESSFUNC : handleAnalysisViewsResponse,
            VIEW : dashboard,
            OPSTATUSID : dashboard.viewCtx.getLoadIndicator()});
        return true;
	}
	
	function handleAnalysisViewsResponse(response, request){
	var lazyLoadList = ["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList"];//NO I18N
        if(!ZDBLazyLoadUtil.loadJsAlone(lazyLoadList, "APPENDTODOC", handleAnalysisViewsResponse, [response, request])){
            // here analysisView loading is required for chart/pivot/summary/widget view
            return;
        }
        if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, handleAnalysisViewsResponse, [response, request]))
        {
            return;
        }
        if (!ZDBLazyLoadUtil.loadSnippet('AnalysisFunMenu', '/AnalysisFunMenu.cc', this, 'APPENDTODOC', null, handleAnalysisViewsResponse, [response,request]))
          {
              return;
          }
        var dashboard = request.VIEW;
        dashboard.ajaxResponseText.innerHTML = response.responseText;
        ZDBAnalysisView.initialize();
        dashboard.dashQ.enableAnalysisReq();
	}
	
	function showViewModeOptions(){
		
	}

	/* Dashboard Individual Views related functions END */
	
	/* Search related operations for table START */
	function searchInTable(){
		
	}
	
	function clearSearch(){
		
	}
	
	function searchOnClick(){
		
	}
	/* Search related operations for table END*/
	
	/* Dashboard USER FILTER related functions START */
	// marks the invalid user filter present in dashboard
	function markInvalidUserFilters(){
		// markUserFilterIfRestricted - CSS changes
	}
	
	function activateAddUFBtnIfNeeded(){
		
	}
	
	function checkNLoadVMFEditUI(){
		
	}
	
	function hndldashUFActionResp(response,requestOptions){
		var view = requestOptions["VIEW"];
		var action = requestOptions["ACTION"];
		if(action=="FORMATSLIDERVALUE")
		{
			  ZDBDashboardAPI.hndlSliderBoundsResp(response,requestOptions);
		}
		else if(action=="DASHBOARDUFVALIDATION")
		{
			  ZDBDashboardAPI.handleUFValidation(response,requestOptions);
		}
		ZDBDashboardAPI.activateAddUFBtnIfNeeded(view);
	}
	
	function hndlSliderBoundsResp(){
		
	}
	
	function handleUFValidation(){
		
	}
	
	function handleTimelineValidation(){
		
	}
	
	function setIfVMFilterApplicable(){
		
	}
	
	/*Dashboard USER FILTER related functions END*/
	
	function fetchWidget(){
		
	}
	
	function editTheme(){
		
	}

	function initTextEditor(){
		
	}
	
	function showInstruction(){
		
	}
	
	var viewModeIcons = false;
    var viewModeOrder = ["_changeChartType","_openInNewTab","_moreOpts"]; //No i18N
    
    function getViewModeOptsContainer(className, iconClassName){
    	var optCell = document.createElement("div");
    	optCell.className = className;
    	var icon = document.createElement("div");
    	icon.className ="dashioicon "+iconClassName;
    	optCell.appendChild(icon);
    	return optCell;
    }
    
    function initViewModeIcons(){
    	if(viewModeIcons === false){
    		// initialize
    		var chartTypeIcon = getViewModeOptsContainer("dashviewoptionsct", "changecharttypeicon"); //No i18N
    		var openNewTabIcon = getViewModeOptsContainer("dashviewoptionscell", "openinnewtabicon");//No i18N
    		var moreOptionsIcon = getViewModeOptsContainer("dashviewoptionscell moreOptions", "dashviewmoreoptions");//No i18N
    		
    		viewModeIcons = {
				_changeChartType : chartTypeIcon,
				_openInNewTab : openNewTabIcon,
				_moreOpts : moreOptionsIcon
    		};
    	}
    }
    
    function getViewModeOptions($node){
    	if($node.type === "VIEW" && $node.viewType !== "WIDGET"){
    		var options = {};
    		if($node.properties.canRead){
    			options._openInNewTab = true;
    		}
    		switch ($node.viewType){
    			case "AnalysisView" : //No i18N
    				options._changeChartType = true;
    			default :
    				if($node.properties.canExport || $node.properties.canShowVUD){
    					options._moreOpts = true;
    				}
			}
    		return options;
    	}
    	return null;
    }
	
	function setTrigger(node, $node, opt){
    	if(opt === "_moreOpts"){
    		if($node.properties.canShowVUD){
    			node.setAttribute("isVUD", "true");
    		}
    		if($node.properties.canExport){
    			node.setAttribute("isExp", "true");
    		}
    	}
    	node.onclick = function(event){
    		$node[opt](node, event);
    	}
    }
   
    function createOptionsHolder($node, editMode){
    	initViewModeIcons();
    	var className = "zd-options zd-viewModeOptions dashviewoptions "+$node.viewType.toLowerCase(); //No i18N
    	var order = viewModeOrder;
    	var icons = viewModeIcons;
		var options = getViewModeOptions($node);
    	if(options){
    		var holder = document.createElement("div");
    		holder.className = className;
    		var rowHolder = document.createElement("div");
    		rowHolder.className = "dashviewoptionsrow";
    		
    		for(var i=0, j=order.length; i<j; i++){
        		var opt = order[i];
        		if(options[opt]){
        			var node = icons[opt].cloneNode(true);
        			setTrigger(node, $node, opt);
        			rowHolder.appendChild(node);
        		}
        	}
    		holder.appendChild(rowHolder);
        	$node.dashChild.appendChild(holder);
    	}
    }
	
	function lazyLoadViewTypeModules(viewType, dashboard, isCallBack){
		// other than this, we can get the dependent js list first and load all necessary js list
        // this will avoid the individual status check cases
        if(lazyLoadedModules[viewType] || !isCallBack && lazyLoadMap[viewType] || viewType < 0) {
            return;
        }
        switch (viewType) {
            case 0://can be replaced with Constants
            case 1:
            case 3:
            case 4:
            case 6:
                if (!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList", "APPENDTODOC", lazyLoadViewTypeModules, [viewType, dashboard, true])){
                    dashboard.dashQ.suspendQ();
                    lazyLoadMap[0] = true;
                    lazyLoadMap[1] = true;
                    lazyLoadMap[3] = true;
                    lazyLoadMap[4] = true;
                    lazyLoadMap[6] = true;
                    return;
                }
                lazyLoadedModules[0] = true;
                lazyLoadedModules[1] = true;
                lazyLoadedModules[3] = true;
                lazyLoadedModules[4] = true;
                lazyLoadedModules[6] = true;
                break;
            case 2:
                var lazyLoadList = ["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList"];//NO I18N
                if (!ZDBLazyLoadUtil.loadJsAlone(lazyLoadList, "APPENDTODOC", lazyLoadViewTypeModules, [viewType, dashboard, true])){
                    dashboard.dashQ.suspendQ();
                    lazyLoadMap[viewType] = true;
                    return;
                }
                lazyLoadedModules[viewType] = true;
                break;
            case 8:
                if (!ZDBLazyLoadUtil.loadSnippet('WidgetLayouts', '/WidgetLayouts.cc', this, 'APPENDTODOC', null, lazyLoadViewTypeModules, [viewType, dashboard, true])){
                    dashboard.dashQ.suspendQ();
                    return;
                }
                var lazyLoadList = ["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList", "WidgetViewList"];//NO I18N
                if (!ZDBLazyLoadUtil.loadJsAlone(lazyLoadList, 'APPENDTODOC', lazyLoadViewTypeModules, [viewType, dashboard, true])){
                    dashboard.dashQ.suspendQ();
                    lazyLoadMap[viewType] = true;
                    return;
                }
                lazyLoadedModules[viewType] = true;
                break;
        }
        var view = ZDBClientUI.selectedTab.view;
        dashboard = (view instanceof ZRDashboard) ? view : dashboard;
        dashboard.dashQ.resumeQ();
	}
	
	function addImgLoadCallback(img,$node){
		img.onload = function(evt){
			if(evt.srcElement && evt.srcElement.offsetParent){
				setTimeout(function() { $node.$autoHeight();},0);
			}
		}
	}
	
	function getImageDocument(){
		if(imgDoc == null){
			imgDoc = document.implementation.createHTMLDocument(true);
		}
		return imgDoc;
	}
	
	function imageWrapper($node){
		var imgDocument = getImageDocument();
		var imageWrapperEl = imgDocument.createElement("div");
		imageWrapperEl.innerHTML = $node.content;
		var imageEls = imageWrapperEl.getElementsByTagName("img");
		for(var index=0; index<imageEls.length; index++){
			addImgLoadCallback(imageEls[index], $node);
		}
		return imageWrapperEl;
	}

	function initializeModes(){
		var modes = {
			viewMode : {},
			editMode : {}
		}
		for(var mode in modes){
			//LayoutManager.add(mode, modes[mode]);
		}
	}
        
    function getLoadingEl(){
        if(!loadingEl){
            loadingEl = document.createElement("div");
            loadingEl.className ="zdbLoading";
            loadingEl.setAttribute("classprefix","zdb");
            loadingEl.setAttribute("elname","loadingDiv");
            loadingEl.style.cssText = "top: 50%; left: 50%; height: auto; transform: translateX(-50%) translateY(-50%);";//NO I18N
            var textEl = document.createElement("div");
            textEl.className="loadingImage";
            textEl.style.cssText="padding: 10px 40px; vertical-align: middle; background-position: 10px 5px;white-space: nowrap";//No i18N
            textEl.setAttribute("elname","textEl");
            textEl.innerText = ZDBI18NMap.g("zrpt.common.loadingdiv.js.loading")+"...";
            loadingEl.appendChild(textEl);
        }
        return loadingEl.cloneNode(true);
    }
    
    function removeDOMIfGrid($node, viewType){
    	if(viewType ==  ZDBClientViewAPI.TYPE_PIVOT || viewType == ZDBClientViewAPI.TYPE_SUMMARY || viewType == ZDBClientViewAPI.TYPE_TABLE || viewType == ZDBClientViewAPI.TYPE_QUERYTABLE || viewType == ZDBClientViewAPI.TYPE_REPORT)
    	{
    		var view = $node.dashChild.view || $node.dashChild.ctx.view;
    		if(view){
    			var gridObj = (viewType === ZDBClientViewAPI.TYPE_TABLE) ? view : view.gridObj;
    			if(gridObj.gArea && gridObj.gArea.parentNode){
    				gridObj.gArea.gridObj.viewCtx.getLoadIndicator().className = "zdbLoading";//No I18N
    				gridObj.gArea.parentNode.removeChild(gridObj.gArea);
    			}
    		}
    		
    	}
    }
	
	function initializeNodeTypes(){
		var VIEW = {
	        type : "VIEW", //No i18N
			minHeight : 10,
			height : 20,
			minWidth : 10,
			width : 40,
	        onAdd : function(){
	            var $node = this;
	            var dashboard = $node.Layout;
	            
				var totalMultiColors = ZDBDThemes.getMultiColorCount(dashboard.theme);

	            var dashChildEl = document.createElement("div");
	            dashChildEl.setAttribute("isdashboarddiv",true);
	            dashChildEl.setAttribute("thememulticolortype",dashboard.themeChildCount % totalMultiColors);
	            dashChildEl.className = "zd-dashChild dashChild";

	            Object.defineProperty($node, "dashChild",{ //No i18N
	                value : dashChildEl
	            });
	            
	            $node.dashChild.$node = $node;
	            $node.dashChild.setAttribute("configid", $node.configId);
	            $node.dashChild.setAttribute("showvmfilter", $node.properties.showUF==="0" ? "false" : "true");
	            $node.dashChild.setAttribute("excludedashglobalfilters", $node.properties.excludeDashUF==="0" ? "false" : "true");
                    	            
	            if($node.viewType !== "WIDGET"){
	            	if($node.canLoad()){
	            		initViewHeader($node);
	            	}
	            		
	            }else{
	            	Util.addClass($node.dom.container, "zr-widgetChild");
	            	//$node.dom.container.className += "zr-widgetChild"; //No i18N
	            	dashChildEl.setAttribute("viewtype","WIDGET");
	            }
	            createLayerDOM($node, dashboard);
	            if(!$node.canLoad()){
	            	setNoPermission($node);
	            }
	            else if(dashboard.editMode === false){
	            	$node.addToDashQ(dashboard);
	            }
	            else{
	                fetchCurrentLayer($node, dashboard)
	            }
	            
	            dashboard.themeChildCount++;

	        },
	        canLoad : function(){
	        	return this.properties.isViewShared && this.properties.isValidFilterCriteria;
	        },
	        onResize : function(){
	        	if(this.viewType !== "WIDGET"){
	        		this.parentEl.view.resize();
	        	}
	        },
	        showEditModeOptions : function(){},
	        showViewtModeOptions : function(){},
	        addToDashQ : function(dashboard){
	            var $node = this;
	            var viewType = ZDBClientViewAPI.TYPES_VALUE_MAP[$node.viewType];
	            removeDOMIfGrid($node, viewType);
	            dashboard.dashQ.push({
	                func : fetchLayerFromQ,
	                args : [$node, dashboard],
	                viewType : viewType
	            });
	        },
	        _refresh : function(icon, event){
	        	var view = this.parentEl.view;
	        	if(view.type === "WIDGET"){
	        		view.fetched = false;
	        	}
	        	fetchCurrentLayer(this, this.Layout);
	        },
	        _settings : function(){},
	        _edit : function(){
	            var $node = this;
	            switch($node.viewType){
	                case "WIDGET" :  //No i18N
	                    break;
	                
	            }
	        },
	        _delete : function(){
	        	this.$remove();
	        },
	        _toggleTitle : function(){
	            var $node = this;
	            if($node.properties.showTitle){
	                // hide
	            	$node.properties.showTitle = false;
	            }
	            else{
	                // show
	            	$node.properties.showTitle = true;
	            }
	        },
	        _toggleDescription : function(){
	            var $node = this;
	            if($node.properties.showDescription){
	                // hide
	            	$node.properties.showDescription = false;
	            }
	            else{
	                // show
	            	$node.properties.showDescription = true;
	            }
	        },
	        _toggleUserFilter : function(){
	            var $node = this;
	            if($node.properties.UserFilter){
	                // hide
	            	$node.properties.UserFilter = false;
	            }
	            else{
	                // show
	            	$node.properties.UserFilter = true;
	            }
	        },
	        _changeChartType : function(icon){
	        	DashUtils.showChartTypes_new(icon, this.dashChild, this.parentEl.view);
	        },
	        _viewUnderlyingData : function(){
	        	var view = this.parentEl.view;
	        	ZDBVUDataAPI.viewUD(view);
	        },
	        _export : function(icon, event){
	        	if(!ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare",this,this._export,[icon, event])){
	      	  		return;
	      	  	}
	        	icon.view = this.parentEl.view;
	        	ZDBMenu.showDashOptsMenu(icon, event, "Single_View_Export_Menu", "GridMenu"); //No i18N
	        },
	        _openInNewTab : function(icon, event){
	        	var view = this.parentEl.view;
	        	var tab = ZDBClientUI.getExistingTab(view.objId);
	        	if(tab){
	        		ZDBClientUI.selectTab(tab);
	                return;
	        	}
	        	 var tab = ZDBClientUI.createUpdateDummyTab(view.objId, view.displayName, view.type, tab);
	             ZDBClientUI.typeDefns[view.type].fetchView(view.objId, tab.viewCtx);
	        },
	        _moreOpts : function(icon, event){
	        	DashUtils.showMoreOptions_new(icon, event, this.dashChild, this.parentEl.view);
	        }
		};
		
		var USERFILTERS = {
			type : "USERFILTERS", //No i18N
	        minWidth : 20,
	        width : 80,
			autoHeight : true,
	        onAdd : function(){
	            var ufLayer = this;
	            var dashboard = this.Layout;
	            dashboard.ufLayer = ufLayer;
	            //Util.addClass(ufLayer.dom.container, "zr-ufLayer");
	            ufLayer.dom.container.className += " zr-ufLayer";//No i18N
	            ufLayer.dom.container.id = "dashboardVMFArea";
	            var UFArea = document.createElement("div");
	            UFArea.$node = ufLayer;
	            //Util.addClass(UFArea, "ZR-DashboardUFContainer");
	            UFArea.className = "ZR-DashboardUFContainer";
	            UFArea.appendChild(UFTemplate.cloneNode(true));
	            ZDBUtil.setNamedChildEls(UFArea, dashboard, "elname");
	            dashboard.dropAreas = {};
	            ufLayer.dom.container.appendChild(UFArea);
	            ZAVMFilter.placeVMFilterCriteria(dashboard);
	            ZAVMFilter.checkAndUpdateDefaultValue(dashboard);
	            ZDBDashboardAPI.showPanel(dashboard);
	            ZAVMFilter.showMoreLessOption(dashboard,true);
	        }
		};
		var SPACER = {
	    	type : "SPACER",//No i18N
	    	height : 1
	    };
		var HTML = {
			type : "HTML", //No i18N
			height : 40,
			minWidth : 10,
			width : 30,
			autoHeight : true,
	        onAdd : function(){
	        	var $node = this;
	        	var dashboard = this.Layout;
	            var dashChildEl = document.createElement("div");
	            dashChildEl.className = "zd-dashChild dashChild zr-textChild";
	            dashChildEl.setAttribute("elType","HTML");
	            Object.defineProperty($node, "dashChild",{ //No i18N
	                value : dashChildEl
	            });
	            $node.textId = dashboard.textId++;
	            // append text from JSON
	            // dashChildEl.innerHTML = $node.content;
	            var imWrapper = imageWrapper($node)
	            dashChildEl.appendChild(imWrapper);
	            dashChildEl.imWrapper = imWrapper;
	            
	            $node.content = ZDBEscapeUtil.encodeForHtml(imWrapper.innerHTML);
	            
	            $node.dom.container.appendChild(dashChildEl);
	        }
		};
		var DELETED = {
			type : "DELETED", //No i18N
			onAdd : function(){
				var dashChildEl = document.createElement("div");
				dashChildEl.className = "zd-dashChild dashChild";
				var deletedHolder = dashChildEl.cloneNode();
				deletedHolder.className = "dashChildViewDeleted";
				var deletedImg = dashChildEl.cloneNode();
				deletedImg.className = "dashChildViewDeletedImg";
				var deletedText = dashChildEl.cloneNode();
				deletedText.className = "dashChildViewDeletedText";
				deletedText.innerText = this.properties.respContent;
				deletedHolder.appendChild(deletedImg);
				deletedHolder.appendChild(deletedText);
				dashChildEl.appendChild(deletedHolder);
	            this.dom.container.appendChild(dashChildEl);
			}
		}
		var $nodeTypes = [VIEW, USERFILTERS, SPACER, HTML, DELETED];
		$nodeTypes.forEach(function($nodeType){
			ZRDashboard.addNodeType(ZRDashboard.VLayout, $nodeType.type, $nodeType);
		});
	}

	function initializeVMF(dashboard){
		dashboard.showShiftHelpVMFilter = true;
		dashboard.VMFiltersList = new Array();
		dashboard.vmFilterListCatch = {};
	}

	function initDashTheme(dashboard, theme){
		dashboard.theme = (theme != null) ? DashTheme(theme) : ZDBDThemes.getDefThemeInst(1);
		ZDBDThemes.apply(dashboard);
	}

	function initializeQParams(dashboard, json){
		if(json){
			dashboard.qLimit = json.qLimit;
			dashboard.bgQLimit = json.preloadQLimit;
			dashboard.analysisViewCount = json.analysisViewCount;
		}
		dashboard.dashQ = ZDBDashQ(dashboard);
	}
	
	function initializeDashboardViewPrototype(){
		var prototype = {
			type : "Dashboard", //No i18N
			dashLayout : true,
			themeChildCount : 0,
			modified : 0,
			editMode  : false,
			initialize : function(responseJson){
				if(this.initialized){
					return;
				}
				
				initializeVMF(this);
				initializeQParams(this, responseJson);
				initDashTheme(this, responseJson.themes ? responseJson.themes : null);
				if(responseJson != undefined){
					this.viewComp.setAttribute("permlevel", responseJson.permLevel);
					this.modified = 0;	
				}
				//handle naivation - edit Mode
				Object.defineProperty(this,"initialized",{value : true}); //No i18N
				//temp 
				this.viewComp.className += " zdbdviewmode"; //No i18N
				//ajax ResponseStore - ZDBDAnalysisViewDetails
				this.ajaxResponseText = document.createElement("div");
                this.viewComp.appendChild(this.ajaxResponseText);
                this.viewComp.setAttribute("displayName", responseJson.displayName);
                this.viewComp.setAttribute("description", responseJson.description ? responseJson.description : "");
                ZDBClientViewAPI.initFromDiv(this, this.viewComp);
                this.dashDiv = this.container;
                ZDBMenu.updateToolbar(this);
			},
			setVisible : function(){
				this.resize();
				//handleNavigation panel
			},
			setHidden : function(){
				//handleNavigation panel
			},
			hasContents : function(){
				return this.structure.length > 1;
			},
			save : function(requestOptions){
				if(ZDBUtil.isNewView(this)){
					if(!ZDBCreateViewAPI.getNameForNewView(this, requestOptions)){
						return;
					}
				}
				this.saveCurrentConfig(requestOptions);
			},
			getCurrentConfig : function(sendDynamicFilterConf, sendCompleteConf){
				sendCompleteConf = (sendCompleteConf == null || sendCompleteConf == undefined) ? false : sendCompleteConf;
				sendCompleteConf = sendCompleteConf || (this.permissions.designModify == 1 && ZDBUtil.isViewModified(this));
				var data = sendCompleteConf ? getSaveData(dashboard) : "";
				data += ZDBDashboardUF.getDashBoardDynFltrConfig(this, sendCompleteConf, sendDynamicFilterConf);
				data += getWidgetData(this);
				return data == "" ? null : getXMLData(data, sendCompleteConf);
			},
			saveCurrentConfig : function(requestOptions, saveAs, currentObjectId){
				if(!this.hasContents()){
					ZDBAlertAPI.showMsg(ZDBI18NMap.g(ZRDashConstants.noContent));
					return;
				}
				var viewParams = this.getViewParams((saveAs ? ZRDashConstants.SAVEAS : ZRDashConstants.SAVE), currentObjectId);
				AjaxAPI.sendRequest(getSaveAjaxObject(this, viewParams, requestOptions));
			},
			getViewParams : function(action, currentObjectId){
				var params = "" 
				if(action){
					params += "&ZDBACTION=" +action+ (currentObjectId != undefined ? "&OLDOBJID=" +currentObjectId : ""); //No i18N
				} 
				params += (this.objId > -1) ? "&OBJID=" + this.objId : ("&DBID=" + this.dbId + ZDBCreateViewAPI.getNameInfoAsParams(this)); //No i18N
				params += this.viewCtx.getAdditionalParams();
				return params;
			},
			updateRespStatus : function(view){
				this.dashQ.dequeue();
//			    if (this.dashQ.onsuccess()) {
//			        ZDBDashboardAPI.stopLoadingViews(this);
//			    } else {
//			        ZDBDashboardAPI.startLoadingViews(this);
//			    }
			},
			getSpacing : function(){
				return Math.floor(this.container.offsetWidth * 0.006);
			},
			resize : function(){
				ZDBReportDashUtil.removeAllInView(this);
				this.$resize();
                ZDBReportDashUtil.appendToDOM(this.gridRender,true);
			},
			appendPermissionsForView : function(){
				return;
			}
		}
		for(var key in prototype){
			ZRDashboard.VLayout.prototype[key] = prototype[key];
		}
		
		function getRandomColor() {
	        var letters = '0123456789ABCDEF';//No i18N
	        var color = '#';
	        for (var i = 0; i < 6; i++) {
	          color += letters[Math.floor(Math.random() * 16)];
	        }
	        return color;
	    }
		
		ZRDashboard.addEventListener("onAdd", function($node){
			if($node.type === "USERFILTERS"){
	            $node.dom.container.style.height = "";
            }
			if($node.onAdd) {
	        	$node.onAdd();
	        }
			return;
	    }, true);
		
		function resizeInnerView(dashChild){
			if((dashChild.ctx != null) && (dashChild.ctx.view != null)){
				if(dashChild.ctx.view.type == "WIDGET"){
					if(dashChild.ctx.view.renderer){
						dashChild.ctx.view.renderer.resize(dashChild.dlgBody, true);
					}
					return;
				}
		        dashChild.ctx.view.resize();
			}
		}
		
		ZRDashboard.addEventListener("onResize", function($node){
			switch($node.type){
				case "VIEW" : { //No i18N
					resizeInnerView($node.dashChild);
					break;
				}
			}
			return;
	    }, true);
		
	};
	var initialized = false;
	function initialize(){
		if(initialized){
			return;
		}
		initializeModes();
		initializeNodeTypes();
		initializeDashboardViewPrototype();
//		initializeUFComponent();
		initialized = true;
	}

	// creates a new dashboard
	function createDashboardView(viewContext, type, dbId, parentViewId, parentDisplayName, objectId){
		//Lazy Load URL's
		var args = Array.prototype.slice.call(arguments);
		if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList", "ZAVMFilterList", "ZAAnalysisFields", "ZRDashboardViewNEW"], "APPENDTODOC", createDashboardView, args)){
			return;
		}
		if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES","CSSLIST_DASHBOARDSTYLES", "CSSLIST_VMFILTERSTYLES", "CSSLIST_DASHBOARDLAYOUTSTYLES"], this, createDashboardView, args)){
			return;
		}
		//Load UI templates
		var url = "ZRDashboardEditUI.cc"; //No i18N
		if(!ZDBLazyLoadUtil.loadSnippet("ZRDashEditUI", url, this, "APPENDTODOC", ["ZDBAnalysisEditList","ZRDashEdit"], null, null, viewContext.getLoadIndicator(ZDBI18NMap.g(ZRDashConstants.loadingDesigner)))){
			return;
		}
		initialize();
		var dashboard = createDashInstance(viewContext, dbId, objectId, ZDBClientUI.typeDefns.Dashboard.permLevel);
		dashboard.dashQ = ZDBDashQ(dashboard);
		//ZRDashboardLayoutAPI.createView.apply(ZRDashboardLayoutAPI, Array.prototype.slice.call(arguments));
	}

	function getFetchParams(objectID, viewContext){
		var params = "&OBJID=" + objectID; //No i18N
		params += viewContext.getAdditionalParams();
		params += "&STANDALONE=" + ZDBClientUI.standAlone; //No i18N
		params += "&UFTEMPLATE=" + needUFTempalate(); //No i18N
		return params;
	}

	function getFetchAjaxObject(objectID, viewContext, message){
		return {
			URL : ZDBGlobal.CTX + ZRDashConstants.fetchURL,
			PARAMETERS : getFetchParams(objectID, viewContext),
			ONSUCCESSFUNC : handleFetchResponse,
			viewContext : viewContext,
			objectID : objectID,
			needUFTempalate : needUFTempalate(),
			dashboard : createDashInstance(viewContext, ZDBClientUI.dbId, objectID),
			OPSTATUSID : viewContext.getLoadIndicator(ZDBI18NMap.g(message))
		}
	}

	// fetches dashboardView from server (structure)
	function fetchDashboardView(objectID, viewContext, fromExpEdit){
		if (!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList", "ZAVMFilterList", "ZAAnalysisFields", "ZRDashboardViewNEW"], "APPENDTODOC", fetchDashboardView, [objectID, viewContext])){
            return;
        }
        if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES","CSSLIST_DASHBOARDSTYLES", "CSSLIST_VMFILTERSTYLES", "CSSLIST_DASHBOARDLAYOUTSTYLES"], this, fetchDashboardView, [objectID, viewContext])){
            return;
        }
		initialize();
		var message = fromExpEdit ? ZRDashConstants.loadingDesigner : ZRDashConstants.loadingDashboard;
		AjaxAPI.sendRequest(getFetchAjaxObject(objectID, viewContext, message));
		//ZRDashboardLayoutAPI.fetchView.apply(ZRDashboardLayoutAPI, Array.prototype.slice.call(arguments));
	}

	// handles response for fetched view
	function handleFetchResponse(response, request){
		var viewContext = request.VIEWCTX, objectID = request.OBJID, dbId = ZDBClientUI.dbId;
		var responseJson = JSON.parse(response.responseText);
		var dashboard = request.dashboard || createDashInstance(request.VIEWCTX, ZDBClientUI.dbId, request.OBJID, null, responseJson.displayName, responseJson.description);
		constructDashboard(dashboard, responseJson);
		if(!dashboard.dashQ.isEmpty()){
            ZDBReportDashUtil.maintainReportCount(dashboard,responseJson.gridViewCount);
            dashboard.dashQ.load();
            dashboard.canPreLoad = responseJson.canPreLoad;
            dashboard.sliderBounds = responseJson.sliderBounds;
            dashboard.changeSliderBoundaries = true;
        	ZASliderComp.sliderRangesForGridView(dashboard.sliderBounds,dashboard);
            ZAVMFilter.preLoadVMFilterIfNeeded(dashboard);
		}
		return dashboard;
	}
	
	var docResponseHolder = document.createElement("div");
	document.body.appendChild(docResponseHolder);

	function appendUFElementsToDoc(doc, objId){
		
		var el = doc.getElementById("ZAVMFilterDiv_"+objId);
		if(el){
			//var responseStore = $("ZDBAjaxResponseStore");
			docResponseHolder.innerHTML = "";
			docResponseHolder.appendChild(el);
		}
	}

	function handleHTMLResponse(response, request){
		var doc = document.implementation.createHTMLDocument(true);
		var span = doc.createElement("span");
		doc.body.appendChild(span);
		span.innerHTML = response.responseText;
		var dashJson = doc.getElementById("dashJson");
		if(dashJson == null){
			return null;
		}
		dashJson.parentElement.removeChild(dashJson);
		var json = dashJson.getAttribute("dashJson");
		response = Object.create(response);
		response.responseText = json;
		if(request.needUFTempalate || true){
			setUFtemplate(doc);
		}
		appendUFElementsToDoc(doc, request.OBJID)
		return handleFetchResponse(response, request);
	}

//	ZDBClientUI.typeDefns.Dashboard = {
//		fetchView : fetchDashboardView,
//		createView : createDashboardView,
//		permLevel : ZDBClientUI.typeDefns.Dashboard.permLevel,
//		newName : ZDBClientUI.typeDefns.Dashboard.newName
//	};
	
	return {
		fetchView : fetchDashboardView,
		createView : createDashboardView,
		lazyLoadedModules : lazyLoadedModules,
		lazyLoadViewTypeModules : lazyLoadViewTypeModules,
		appendUFElementsToDoc : appendUFElementsToDoc,
		handleHTMLResponse : handleHTMLResponse,
		initialize : initialize,
		refreshViews : refreshViews,
		fetchAnalysisViewDetails : fetchAnalysisViewDetails
	};
	
})();
