//$Id$

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var WidgetEditUtils = function (editor) {

    var chartConstants = window.WidgetChartConstants || {};
    var layout;
    var showValCache = {};
    //config setters
    var setColumnConfig;
    var setShowValueConfig;
    var setPrimaryShowValue;
    var setSecondaryShowValue;
    var setTertiaryShowValue;
    var setKPIShowValue;
    var setKPIShowValueConfig;
    var setKeyValueMapConfig;
    var setSettingsConfig;
    var setSecondarySettings;
    var setTertiarySettings;
    var deleteKPIShowValConfig;
    var deleteKPISettings;

    //config getters
//    var getCinfo;
    var getColumnConfig;
    var getDataColText;
    var getGroupColConfig;
    var getGroupColText;
    var getYAxisColConfig;
    var getMaxRangeColText;
    var getLegendColText;
    var getLegendConstantText;
    var getMaxRangeConstantText;
    var getTargetColText;
    var getTargetConstantText;
    var getKeyValueMapConfig;
    var getShowValueConfig;
    var getKPIShowValue;
    var getKPIShowValueConfig;
    var getPrimaryShowValText;
    var getSecondaryShowValText;
    var getTertiaryShowValText;
    var getCompareWithLHSText;
    var getCompareWithRHSText;
    var getCompareWithConstantText;
    var getSettingsConfig;
    var getKPISettingsConfig;
    var getPrimarySettingsLabelText;
    var getPrimarySettingsValueText;
    var getSecondarySettingsLabelText;
    var getTertiarySettingsLabelText;
    var getChartTitleLabelText;
    //div updaters
    var updateDataColText;
    var updateGroupColText;
    var updateLegendColText;
    var updateMaxRangeText;
    var updateTargetText;
    var updatePrimaryShowValText;
    var updateSecondaryShowValText;
    var updateTertiaryShowValText;
    var updateCompareWithLHSText;
    var updateCompareWithRHSText;
    var updateCompareWithConstantText;
    var updatePrimarySettingsLabelText;
    var updatePrimarySettingsValueText;
    var updatePrimaryStyleLabelText;
    var updatePrimaryStyleValueText;
    var updateSecondarySettingsLabelText;
    var updateSecondaryStyleLabelText;
    var updateTertiarySettingsLabelText;
    var updateTertiaryStyleLabelText;
    var updateChartTitleStyleLabelText;
    var updateLegendPercText;
    var updateTextaxisPercText;
    var updateThresholdPercText;
    var updateLegendConstantText;
    var updateMaxRangeConstantText;
    var updateTargetConstantText;
    var updateKPISymbolToggleSettings;
    var updateKPIValueToggleSettings;
    var updateKPISettingsPositiveComboText;
    var updateKPISettingsNegativeComboText;
    var updateKPIPositiveValueColorSettings;
    var updateKPINegativeValueColorSettings;
    var updateUnknownLabelText;
    var updateUnknownValueText;
    /* Widget Charts Start*/
    var updateChartTitleLabelText;
    var updateHOrientation;
    var updateVOrientation;
    var updateShowDataLabel;
    var updateShowMinMaxLabel;
    var updateShowTargetMarkerLabel;
    var updateLegendColor;
    var updateMaxRangeColor;
    var updateLegendBandWidth;
    var updateMaxRangeBandWidth;
    var updateChartRangesToggle;
    var updateTargetMarkerType;
    var updateTargetMarkerSize;
    var updateTargetMarkerColor;
    var updateTargetStyleCombo;
    var updateNeedleType;
    var updateNeedleWidth;
    var updateNeedleColor;
    var updateNeedleStyleCombo;
    var modifiedInputs = {};
    /* Widget Charts End */
    //read-only

    var groupLabelVariable, groupValueVariable, yaxisLabelVariable,
            groupLabelDispVariable, groupValueDispVariable, yaxisLabelDispVariable;

    var setConfig = function (object, key, value) {
        if (!object || !key) {
            return;
        }
        if (value == undefined) {
            delete object[key];
            return;
        }
        object[key] = value;
    };
    var getConfig = function (object, key) {
        if (!object || !key || object[key] == undefined) {
            return null;
        }
        return object[key];
    };
    var isValidConfig = function (isCreate) {
        var isValid = true;
        switch (layout) {
            case 6:
            case 5:
            case 4:
                isValid = isValid && isDateYAxis();
            case 3:
            case 2:
                isValid = isValid && getColumnConfig('YAXIS');//NO I18N
            case 1:
            case 7:
            case 8:
                isValid = isValid && getColumnConfig('GROUP');//NO I18N
                if (isCreate && isZCLayout()) {
                    isValid = isValid && checkZCDataTabInputElsVal('LEGEND') && checkZCDataTabInputElsVal('THRESHOLD') && checkZCDataTabInputElsVal('TEXTAXIS');//NO I18N
                    isValid = isValid && checkZCSettingsTabRangeVals();
                }
            default:
                if (isValid && isCreate && isKPILayout() && !editor.settings.radioKPISymbol.checked && !editor.settings.radioKPIValue.checked) {
                    editor.settings.setAttribute('class', 'widgetsettings floatLeft wcopiconmax');//NO I18N
                    editor.tabHolder.setAttribute('class', 'widgetsettingstabsel');
                    if (editor.view.curTab != 2) {
                    	editor.view.curTab = 2;
                    	constructSettingsTab();
                    }
                    hideCustomMessage();
                    showCustomMessage(ZDBI18NMap.g("zrpt.dashboard.widget.js.selectonecheckboxerror"), editor.kpiSettingsHolder); //NO I18N
                    ZDBUtil.attachEvent(document, 'click', hideCustomMessage, true);
                    isValid = false;
                }
        }
        return isValid;
    };
    var checkZCDataTabInputElsVal = function (position) {
        if (getShowValueConfig(position) && getShowValueConfig(position).OPERATION === 'CONSTANT') {
            var constantVal = getShowValueConfig(position).CONSTANT;
            if (constantVal && isNaN(constantVal)) {
                WidgetEditor.hideFilterFields(editor);
                editor.tabHolder.setAttribute('class', 'widgetdatatabsel');
                editor.view.curTab = 0;
                hideCustomMessage();
                showCustomMessage(ZDBI18NMap.g("zrpt.dashboard.widget.js.invalidnumbererror"), editor.data[position]);
                return false;
            }
        }
        return true;
    };
    var showNumberErrorMessage = function(value, element, expandMore){
    	if(isNaN(value)){
    		WidgetEditor.hideFilterFields(editor);
        	editor.view.curTab = 2;
        	if(expandMore){
        		editor.settings.setAttribute('class', 'widgetsettings floatLeft wcopiconmax');//NO I18N
                editor.tabHolder.setAttribute('class', 'widgetsettingstabsel');
        	}
        	element.scrollIntoView(true);
        	setTimeout(function(){
        		hideCustomMessage();
                showCustomMessage(ZDBI18NMap.g("zrpt.dashboard.widget.js.invalidnumbererror"), element);//NO I18N
        	},0)
        	return true;
    	}
    	return false;
    }
    var checkZCSettingsTabRangeVals = function () {
    	var _return = false;
    	var legendBandWidth =  getKeyValueMapConfig(chartConstants.LEGEND_BANDWIDTH);
    	_return = showNumberErrorMessage(legendBandWidth, editor.wcharts.legendBandWidth);
    	if(_return){
    		return false;
    	}
    	var maxRangeBandWidth =  getKeyValueMapConfig(chartConstants.LEVER_MARKER_BANDWIDTH);
    	_return = showNumberErrorMessage(maxRangeBandWidth, editor.wcharts.maxRangeBandWidth, true);
    	if(_return){
    		return false;
    	}
        var rangesEnabled = getKeyValueMapConfig(chartConstants.RANGES_ENABLE) !== 'false';
        for (var i = 0, j = chartConstants.RANGES_KEYS.length; i < j && rangesEnabled; i++) {
            var rangeKey = chartConstants.RANGES_KEYS[i];
            var rangeVal = getKeyValueMapConfig(rangeKey);
            _return = showNumberErrorMessage(rangeVal, editor.wcharts["range" + (i + 1)], true);
            if(_return){
            	return false;
            }
        }
        return true;
    };
    var canCustomizeShowVals = function (position) {
        return getShowValueConfig(position) !== null;
    };
    var canPopulateShowVals = function () {
        return hasGroupAxis() && (layout === 1 || hasYAxis()) && !isZCLayout();//NO I18N
    };
    var canCustomizeChartUnits = function (viewType) {
        return getColumnConfig(viewType) === null;
    };
    var canCustomizeKPISettings = function () {
        return getKPIShowValueConfig('SHOWKPI') !== 'false';//NO I18N
    };
    var canCustomizeKPIValueColor = function () {
        return getConfig(getShowValueConfig('opr1'), 'POSITIVE') !== null;//NO I18N
    };
    var isDateYAxis = function () {
        return getColumnConfig('YAXIS') && getYAxisColConfig('ADDONTYPE') === 'ABSDATECATEGORICAL';//NO I18N
    };
    var hasYAxis = function () {
        return getColumnConfig('YAXIS') !== null;//NO I18N
    };
    var hasGroupAxis = function () {
        return getColumnConfig('GROUP') !== null;//NO I18N
    };
    var isKPILayout = function () {
        return !isNonKPILayout() && !isZCLayout();
    };
    var isNonKPILayout = function () {
        return layout < 4;
    };
    var isZCLayout = function () {
        return layout > 6;
    };
    var showValsCount = function () {
        return (layout > 3) ? layout - 3 : layout;
    };
    var dataFetched = function () {
        return getConfig(editor.cinfo, 'DATA') !== null;//NO I18N
    };
    var noData = function () {
        return !dataFetched() || (getConfig(editor.cinfo.DATA, 'NODATA') !== null);//NO I18N
    };
    var getDataColumnText = function () {
        return getDataColText();
    };

    var validateConfig = function () {
        switch (layout) {
            case 1:
            case 4:
                setSecondaryShowValue();
                setSecondarySettings();
                //falls through
            case 2:
            case 5:
                setTertiaryShowValue();
                setTertiarySettings();
                //falls through
            case 3:
            case 6:
            default:
                if (isNonKPILayout()) {
                    deleteKPIShowValConfig();
                    deleteKPISettings();
                } else {
                    if (isDateYAxis()) {
                        setKPIShowValue(getKPIShowValue() || WidgetUtils.clone(WidgetConstants.KPI));
                        bindKPIShowValConfig();
                        constructDataTabKPI();
                    } else {
                        deleteColumnConfig('YAXIS');//NO I18N
                        resetShowValueConfig();
                    }
                }
                resetZCConfig();
//                resetKeyValueConfig();
                break;
            case 8:
            case 7:
                bindKeyValConfig();
                resetNonZCShowValueConfig();
                populateChartShowVals();
                copyKeyValConfig(WidgetChartConstants.DEFAULT_RANGES);
                setKeyValueMapConfig(chartConstants.RANGES_ENABLE, 'true');
                resetZCKeyValueConfig();
                bindZCColumnConfig();
                bindZCRangeConfig();
                constructZCDataTabMetrics();
        }
    };
    var updateLayout = function (template) {
        var nonChartLayout = !isZCLayout();
        var nonKPILayout = isNonKPILayout();
        layout = parseInt(template);
        editor.layout = layout;
        editor.cinfo.LAYOUT = layout;
        if (nonKPILayout && isKPILayout() || nonChartLayout && isZCLayout() || !nonChartLayout && !isZCLayout()) {
            resetData();
        }
    };
    var updateColumnConfig = function (el, colNode, viewType) {
        if (!colNode) {
            deleteColumnConfig(viewType);
        } else {
            if (viewType === 'GROUP')
            {
                resetColumnConfig();
                editor.currentList = new Array();
                editor.parentViewId = colNode.getAttribute('parent_obj_id');
            } else {
                deleteColumnConfig(viewType, true);
            }
            var dType = colNode.getAttribute('addontype');
            var colName = colNode.getAttribute('colname');
            var colId = colNode.getAttribute('colid');
            var fieldType = colNode.getAttribute('field_col_type');
            var operation = getColOperation(editor[viewType], el, dType);
            var instKey = editor.view.getInstKey(viewType);
            setColumnConfig(viewType, {'INSTKEY': instKey, 'COLUMN_ID': colId, 'COLUMN_NAME': colName, 'ADDONTYPE': dType, 'OPERATION': operation, 'FIELD_COL_TYPE': fieldType});//NO I18N
            var displayText = getColDisplayText(editor.cinfo.COLUMNS[viewType]);
            updateComboText(editor[viewType], displayText);
            colNode.setAttribute('operation', operation);
            colNode.setAttribute('viewtype', viewType);
            colNode.setAttribute('instkey', instKey);
            editor.currentList.push(colNode);
        }
        resetData();
        bindColumnConfig();
        if(viewType != "THRESHOLD" && viewType != "TEXTAXIS"){
        	updateEditor();
                checkIfMultiTable();
        }
        else{
        	updateEditorCSS();
        }
        
    };
//check if multitable and show join icon
    var checkIfMultiTable = function(){
        var relId = ZDBClientUtil.getJsonRelModelIdForObjId(editor.parentViewId);
        if(relId == null)
        {
          ZDBDashboardUF.sendGetDBDetailsRequest(ZDBClientUI.dbId,editor.parentViewId,showOrHideJoinIcon,editor);
          return;
        }
        else
        {
            var json = ZDBAnalysisCaching.tblColInfo.data[relId];
           toggleJoinIcon(Object.keys(json.tableDet).length > 1);
        }
    };
    
    var showOrHideJoinIcon = function(response,requestOptions){
        var jsonResp = JSON.parse(response.responseText);
        var editorView = requestOptions["VIEW"];
        var parentViewId = editorView.parentViewId;
        ZDBDashboardUF.updateJSONTableInfo(jsonResp);

        var jsonData = ZDBAnalysisCaching.tblColInfo.data;
          var relId = ZDBClientUtil.getJsonRelModelIdForObjId(parentViewId);
        var json = ZDBAnalysisCaching.tblColInfo.data[relId];
           toggleJoinIcon(Object.keys(json.tableDet).length > 1);
    };
    
    var toggleJoinIcon = function (showOrHide) {
        editor.getElementsByClassName('jointypediv')[0].style.display=(showOrHide)?"block":"none";
        editor.getElementsByClassName('wholejoindiv')[0].style.pointerEvents=(showOrHide)?"auto":"none";//NO I18N
    };
    var deleteColumnConfig = function (viewType, setShowVal) {
        setColumnConfig(viewType);
        var showValObj = {};
        if(getShowValueConfig(viewType) && getShowValueConfig(viewType).PERCENTAGE){
        	showValObj.PERCENTAGE = getShowValueConfig(viewType).PERCENTAGE;
        }
        setShowValueConfig(viewType, setShowVal ? showValObj : null);
        bindZCRangeConfig();
        removeColumn(viewType);
        if (viewType === 'YAXIS') {
            resetShowValueConfig();
        }
    };
    var updateColumnRangeConfig = function (viewType) {
        setColumnConfig(viewType);
        removeColumn(viewType);
        if (!getShowValueConfig(viewType)) {
            setShowValueConfig(viewType, {'OPERATION': 'CONSTANT'});//NO I18N
        } else {
            getShowValueConfig(viewType).OPERATION = 'CONSTANT';//NO I18N
        }
        updateInputSelectionRange(editor.data[viewType+"_CONST"]);
        updateComboText(editor[viewType], WidgetConstants.OPRTOSHOWVALDISP.CONSTANT);
        resetData();
        updateEditorCSS();
    };
    var updateZCColumnConfigNone = function (viewType) {
        resetData();
        deleteColumnConfig(viewType);
        setShowValueConfig(viewType, {'OPERATION': 'NONE'});//NO I18N 
        updateEditorCSS();
    };
    var populateShowVals = function () {
        updateShowValConfigCache();
        var combinationIdx = (isKPILayout() && isDateYAxis()) ? 4 : WidgetConstants.OPERATION_TO_COMBINATIONIDX[getGroupColConfig('OPERATION')];
        var combination = WidgetConstants.SHOWVALCOMBINATIONS[layout - 1][combinationIdx];
        var showValLimit = showValsCount();
        var posIdx = 0, oprIdx = 0;
        while (posIdx < showValLimit) {
            var position = WidgetConstants.SHOWVALPOSITIONS[posIdx];
            var showValDet = getShowValueConfig(position);
            if (showValDet && showValDet.MODIFIED) {
                posIdx++;
                continue;
            }
            var operation = WidgetConstants.SHOWVALOPERATIONS[combination[oprIdx]];
            if (showValCache[operation]) {
                oprIdx++;
                continue;
            }
            var positionDet = getShowValDets(position, operation);
            setShowValueConfig(position, positionDet);
            updateComboText(editor[WidgetConstants.WIDGETDATA_TO_POSITIONS[posIdx]], WidgetConstants.OPRTOSHOWVALDISP[operation]);
            posIdx++;
            oprIdx++;
        }
    };
    var populateChartShowVals = function () {
        if (!hasYAxis()) {
            if (hasGroupAxis()) {
                var legendOpr = getGroupColInfo('OPERATION');//NO I18N
                var legendDet = getShowValueConfig('LEGEND');//NO I18N
                if (!legendDet || legendOpr !== legendDet.OPERATION) {
                    var legendDet = {'OPERATION': legendOpr};//NO I18N
                    updateShowValLabel('LEGEND', legendOpr, legendDet);//NO I18N
                    setShowValueConfig('LEGEND', legendDet);//NO I18N
                }
                if (!getColumnConfig('TEXTAXIS')) {
                    if (!getShowValueConfig('TEXTAXIS')) {//NO I18N
                        setShowValueConfig('TEXTAXIS', {'OPERATION': 'CONSTANT', 'UNIT' : '1', 'CONSTANT': chartConstants.DEFAULT_MAXIMUM_RANGE_PERCENT});//NO I18N 
                        resetData();
                    } else {
                        getShowValueConfig('TEXTAXIS').OPERATION = 'CONSTANT';//NO I18N
                    }
                }
                if (!getColumnConfig('THRESHOLD')) {
                    if (!getShowValueConfig('THRESHOLD')) {//NO I18N
                        setShowValueConfig('THRESHOLD', {'OPERATION': 'CONSTANT', 'UNIT' : '1', 'CONSTANT': chartConstants.DEFAULT_TARGET_PERCENT});//NO I18N
                        resetData();
                    } else {
                        getShowValueConfig('THRESHOLD').OPERATION = 'CONSTANT';//NO I18N
                    }
                }
            }
            return;
        }
        deleteColumnConfig('TEXTAXIS');//NO I18N
        deleteColumnConfig('THRESHOLD');//NO I18N
        var combinationIdx = (isDateYAxis()) ? 4 : WidgetConstants.OPERATION_TO_COMBINATIONIDX[getGroupColConfig('OPERATION')];
        var combination = WidgetConstants.SHOWVALCOMBINATIONS[layout - 1][combinationIdx];
        var keysLen = chartConstants.DATA_OPERATION_KEYS.length;
        for (var i = 0; i < keysLen; i++) {
            var operation = WidgetConstants.SHOWVALOPERATIONS[combination[i]];
            var position = chartConstants.DATA_OPERATIONS_EL_KEYS[i];
            var showValDet = {'OPERATION': operation};//NO I18N
            if (operation === 'CONSTANT') {
                showValDet.CONSTANT = (position === 'THRESHOLD') ? chartConstants.DEFAULT_TARGET_PERCENT : chartConstants.DEFAULT_MAXIMUM_RANGE_PERCENT;//NO I18N
                //set default as value
                showValDet.UNIT = "1"; //NO I18N
            }
            if (position === 'LEGEND') {
                updateShowValLabel(position, operation, showValDet);
            }
            setShowValueConfig(position, showValDet);
            updateComboText(editor[position], WidgetConstants.OPRTOSHOWVALDISP[operation]);
        }
    };
    var copyKeyValConfig = function (toCopy) {
        for (var key in toCopy) {
            setKeyValueMapConfig(key, toCopy[key]);
        }
    };
    var updateShowValConfig = function (holder, operation) {
        if (layout > 6) {
            var key = holder.getAttribute('WidgetData');
            var positionDet = getShowValueConfig(key)
            positionDet.OPERATION = operation;
        	updateShowValLabel(key, operation != "CONSTANT" ? operation : undefined , positionDet);
        } else {
            var position = holder.getAttribute('position');
            var positionKey = holder.getAttribute('positionKey');
            var positionDet = getShowValueConfig(position);
            positionDet.MODIFIED = true;
            positionDet[positionKey] = operation;
            if (position !== 'kpi') {
                updateShowValLabel(position, operation, positionDet);
            }
            setShowValueConfig(position, positionDet);
            populateShowVals();
        }
        updateComboText(holder, WidgetConstants.OPRTOSHOWVALDISP[operation]);
        resetData();
        updateEditorCSS();
        if (operation === 'CONSTANT') {
            WidgetEditor.editor.dataRight.scrollTop = WidgetEditor.editor.dataRight.scrollHeight;
            updateInputSelectionRange(editor.data[holder.getAttribute('WidgetData')+"_CONST"]); //No I18N
        }
    };
    var removeUnitsMap = function(positionKey){
    	return getConfig(WidgetConstants.UNITKEYMAP,positionKey);
    }
    var updateUnitsShowValConfig = function(position, positionKey, value){
		setConfig(getShowValueConfig(position), removeUnitsMap(positionKey));
    }
    var updateChartShowValConfig = function (holder, value) {
        var position = holder.getAttribute('position');
        var positionKey = holder.getAttribute('positionKey');
        var showValObj = getShowValueConfig(position);
        if(!showValObj){
        	showValObj = {}
        	setShowValueConfig(position,showValObj);
        }
        showValObj[positionKey] = value;
        updateUnitsShowValConfig(position, positionKey);
        resetData();
        updateEditorCSS();
    };
    var updateShowValConfigCache = function () {
        showValCache = {};
        for (var i = 0; i < WidgetConstants.SHOWVALPOSITIONS.length; i++) {
            var position = WidgetConstants.SHOWVALPOSITIONS[i];
            var config = getShowValueConfig(position);
            if (!config) {
                return;
            }
            if (!isDateYAxis() && WidgetConstants.DATEOPERATIONS.indexOf(config.OPERATION) !== -1) {
                delete config.MODIFIED;
            }
            var operation = config.OPERATION;
            showValCache[operation] = config.MODIFIED;
        }
    };
    var getShowValDets = function (position, operation, showValDet)
    {
        showValDet = showValDet || {};
        showValDet.OPERATION = operation;
        updateShowValLabel(position, operation, showValDet);
        return showValDet;
    };
    var updateShowValLabel = function (position, operation, showValDet) {
        var pattern = WidgetConstants.LABELPATTERNS[operation];
        var labelPattern = replaceColsInPatterns(pattern);
        if (position === 'opr1' || position === 'LEGEND') {
            showValDet.VALUE = WidgetConstants.GROUPVALUE.replace('GROUP', getGroupColConfig('COLUMN_ID'));
        } else {
            labelPattern = labelPattern + ': ' + WidgetConstants.GROUPVALUE.replace('GROUP', getGroupColConfig('COLUMN_ID'));
        }
        showValDet.LABEL = labelPattern;
    };
    var replaceColsInPatterns = function (pattern) {
        if (pattern && getColumnConfig('YAXIS')) {
            pattern = pattern.replace('YAXIS', getYAxisColConfig('COLUMN_ID'));
            pattern = pattern.replace('GROUP', getGroupColConfig('COLUMN_ID'));
        } else {
            pattern = WidgetConstants.GROUPLABEL.replace('GROUP', getGroupColConfig('COLUMN_ID'));
        }
        return pattern;
    };
    var updateStyleConfig = function (el) {
        var holder = DOMUtils.getParentWithAttr(el, 'position'); //No I18N
        var position = holder.getAttribute('position');
        var positionKey = holder.getAttribute('positionKey');
        var defStyleObj = WidgetConstants.DEFAULTSTYLE[positionKey + position];
        if (!getSettingsConfig(position)) {
            setSettingsConfig(position, {});
        }
        var styleObj = getConfig(getSettingsConfig(position), positionKey) ? getConfig(getSettingsConfig(position), positionKey) : WidgetUtils.clone(defStyleObj);
        styleObj[el.getAttribute('propertyName')] = el.value;
        _updateStyleCombo(holder, styleObj);
        setConfig(getSettingsConfig(position), positionKey, styleObj);
        showPreview();
    };
    var updateLabelText = function (el) {
        var value = (el.value === '') ? null : getVariable(el.value);
        if (value && value.length > 100) {
            showCustomMessage(ZDBI18NMap.g('zrpt.common.VMFilterEditMode.zdbalertmsg.js.exeededLabel'), el);//NO I18N
            return;
        }
        var position = el.getAttribute('position');
        var positionKey = el.getAttribute('positionKey');
        var showValConfig = getShowValueConfig(position);
        setConfig(showValConfig, positionKey, value);
//        updateInputText(el, getLabelDisplayText(showValConfig, positionKey)); //Commented for Chrome && Safari insertion point auto movement to end - Fix
        showPreview();
    };
    var resetLabel = function (el) {
        var position = el.getAttribute('position');
        var positionKey = el.getAttribute('positionKey');
        var showValDet = getShowValueConfig(position);
        updateShowValLabel(position, showValDet.OPERATION, showValDet);
        updateInputText(el, getLabelDisplayText(showValDet, positionKey));
        el.focus();
        showPreview();
    };
    var updateKeyValueConfig = function (el) {
        var val = el.value;
        if (val.length > 100)
        {
            showCustomMessage(ZDBI18NMap.g('zrpt.common.VMFilterEditMode.zdbalertmsg.js.exeededLabel'), el); //NO I18N
            return;
        }
        var key = el.getAttribute('key');
        setKeyValueMapConfig(key, val);
        showPreview();
    };
    var updateKPIShowValueConfig = function (el) {
        var parent = DOMUtils.getSelfOrParentWithAttr(el, 'position'); //NO I18N
        var positionKey = parent.getAttribute('positionKey');
        var comboBox = DOMUtils.getFirstMatchingChild(parent, "div", "comboBox", "true"); //No I18N
        ZDBUtil.setNamedChildEls(comboBox, comboBox); //dont call this often
        updateStyleDisplayNodeText(comboBox.fontDisp, el.options[el.selectedIndex].text);
        setKPIShowValueConfig(positionKey, el.options[el.selectedIndex].value);
        showPreview();
    };
    var updateKPIShowValueConstant = function (el) {//re-work here
        var value = el.value;
        var isNegative = value.indexOf('-');
        value = value.replace(/[^\d.]/g, '').replace(/\.$/, '');
        if (isNaN(value) && value) {
            var lastIndex = value.lastIndexOf('.');
            value = (lastIndex > -1) ? (value.substr(0, lastIndex) + '#' + value.substr(lastIndex, value.length)) : value;
            value = value.replace(/\./g, '').replace('#', '.');
        }
        value = (isNegative > -1) ? ('-' + value) : value;
        value = (!value) ? '0' : value;
        setKPIShowValueConfig('CONSTANT', value);//NO I18N
    };
    
    var DOTKEY = 190, DECIMALKEY = 110, MINUSKEY = 109, HIPENKEY = 189, ZERO = 48, NINE = 57, BACKSPACE = 8, DELETE = 46, LEFTARW = 37, RIGHTARW = 39, ESCKEY = 27, TABKEY = 9;

    function isCombined(event){
        return event.altKey || event.ctrlKey;
    }

    function isShiftKey(event){
        return event.shiftKey && !event.metaKey && !isDefaultKeys(event.keyCode, event);
    }

    function isPossibleNumericKey(keyCode, event){
        return isDefaultKeys(keyCode, event) || isDot(keyCode) || isMinus(keyCode) || (keyCode >= ZERO && keyCode <= NINE);
    }

    function isDot(keyCode){
        return keyCode == DOTKEY || keyCode == DECIMALKEY;
    }

    function isMinus(keyCode){
        return keyCode == MINUSKEY || keyCode == HIPENKEY
    }

    function isDefaultKeys(keyCode, event){
        return isCombined(event) || event.metaKey || keyCode === BACKSPACE || keyCode === DELETE || keyCode === LEFTARW || keyCode === RIGHTARW || keyCode === ESCKEY || keyCode === TABKEY;
    }

    function hasMinus(value){
        return value.indexOf("-") === 0;
    }

    function hasDot(value){
        return value.indexOf(".") >=0;
    }

    function checkNumericValueInput(event, element){
        // alert(event.metaKey);
        var prevent = false;
        var value = element.value;
        var caret = element.selectionStart;
        if(isShiftKey(event) || !isPossibleNumericKey(event.keyCode, event)){
            prevent = true;
        }
        else if(!isDefaultKeys(event.keyCode, event)){
            if(isMinus(event.keyCode)){
                if(!hasMinus(value)){
                    element.value = "-" + value;
                    element.selectionStart = element.selectionEnd = caret + 1;
                }
                prevent = true;
            }
            else if(isDot(event.keyCode) && hasDot(value)){
                prevent = true;
            }
            else if(hasMinus(value) && caret === 0){
                element.selectionStart = element.selectionEnd = 1;
            }
        }
        if(prevent){
            event.preventDefault();
        }
    }
    
    
    var updateKPISettingsStyleConfig = function (el) {
        var parent = DOMUtils.getSelfOrParentWithAttr(el, 'position'); //NO I18N
        var positionKey = parent.getAttribute('positionKey');
        var colorCode = "#" + el.getAttribute("value");
        var kpiConfig = getConfig(getSettingsConfig('kpi'), positionKey) || WidgetUtils.clone(WidgetConstants.DEFAULTSTYLE[positionKey]);
        var comboBox = DOMUtils.getFirstMatchingChild(parent, "div", "comboBox", "true"); //No I18N
        ZDBUtil.setNamedChildEls(comboBox, comboBox); //dont call this often
        updateStyleDisplayColor(comboBox.fontClrDisp, colorCode);
        if(!canCustomizeKPIValueColor()){
            updateStyleDisplayColor(editor.settings["kpiValue"+positionKey], colorCode);
            var primaryConf = getConfig(editor.cinfo.SETTINGS.opr1,positionKey);
            if(primaryConf){
            	primaryConf.COLOR = colorCode;
            }
        }
        setConfig(kpiConfig, 'COLOR', colorCode);//NO I18N
        if (!getSettingsConfig('kpi')) {
            setSettingsConfig('kpi', {});//NO I18N
        }
        setConfig(editor.cinfo.SETTINGS.kpi, positionKey, kpiConfig);
        showPreview();
    };
    var updateKPISettingsValueStyleConfig = function (el) {
        var positionKey = el.getAttribute('positionKey');
        var colorCode = CSSFactory.adjustToInt(el.getAttribute('value'));
        setPrimaryShowValue(positionKey, colorCode);
        var kpiValueStyle = getConfig(getSettingsConfig('opr1'), positionKey);//NO I18N
        setConfig(kpiValueStyle, 'COLOR', '#' + CSSFactory.adjustToHex(parseInt(colorCode)));//NO I18N
        showPreview();
    };
    var toggleKPISymbolConfig = function (el) {
        setKPIShowValueConfig('SHOWKPI', el.checked + '');//NO I18N
        updateEditorCSS();
        showPreview();
    };
    
    var setValueColor = function(type, constantColor, node){
    	var _primarySettingsConfig = getConfig(editor.cinfo.SETTINGS.opr1,type);
    	if(!_primarySettingsConfig){
    		var colorCode = getKPISettingsConfig(type);
    		colorCode = colorCode ? CSSFactory.adjustToInt(colorCode.COLOR.replace('#', '')) : constantColor;
    		setPrimaryShowValue(type, colorCode);
    		_primarySettingsConfig = WidgetUtils.clone(getConfig(getSettingsConfig('opr1'), 'OPERATION')) || WidgetUtils.clone(WidgetConstants.DEFAULTSTYLE.OPERATIONopr1);//NO I18N
    		if (!getSettingsConfig('opr1')) {
                setSettingsConfig('opr1', {});//NO I18N
            }
    		colorCode = '#' + CSSFactory.adjustToHex(parseInt(colorCode));
            setConfig(_primarySettingsConfig, 'COLOR', colorCode);//NO I18N
            updateStyleDisplayColor(node, colorCode);
            setConfig(editor.cinfo.SETTINGS.opr1, type, _primarySettingsConfig);
    	}
    	else{
    		setPrimaryShowValue(type, CSSFactory.adjustToInt(_primarySettingsConfig.COLOR.replace('#', '')));
    	}
    }
    
    var toggleKPIValueConfig = function (el) {
        var enableValue = el.checked;
        if (enableValue) {
        	setValueColor('POSITIVE', WidgetConstants.KPIPOSITIVECOLOR, editor.settings.kpiValuePOSITIVE); //No I18N
        	setValueColor('NEGATIVE', WidgetConstants.KPINEGATIVECOLOR, editor.settings.kpiValueNEGATIVE); //No I18N
        } else {
            setPrimaryShowValue('POSITIVE');//NO I18N
            setPrimaryShowValue('NEGATIVE');//NO I18N
        }
        updateEditorCSS();
        showPreview();
    };
    var removeColumn = function (viewtype)
    {
        var currentList = editor.currentList;
        for (var i = 0; i < currentList.length; i++)
        {
            if (viewtype === currentList[i].getAttribute('viewtype'))
            {
                currentList.splice(i, 1);
                return;
            }
        }
    };
    var getColOperation = function (holderDiv, el, dType) {
        if (el.getAttribute('colId')) {
            return holderDiv.getAttribute('default' + dType);
        }
        else {
            return el.getAttribute('operation');
        }
    };
    var getColDisplayText = function (colObj) {
        if (!colObj) {
            return '';
        }
        var oprDispVal = WidgetConstants.COLOPRTODISPVAL[colObj.OPERATION];
        var displayName = colObj.COLUMN_NAME + oprDispVal;
        if (colObj.FIELD_COL_TYPE === '0')
        {
            displayName = colObj.COLUMN_NAME + ' (Actual)'; //NO I18N
        }
        return displayName;
    };
    var getShowValueDisplayText = function (showValObj, key) {
        var operation = getConfig(showValObj, key);
        return (operation) ? WidgetConstants.OPRTOSHOWVALDISP[operation] : '';
    };
    var getLabelDisplayText = function (showValObj, key) {
        var label = getConfig(showValObj, key);
        if (noData()) {
            label = WidgetUtils.searchNreplace(label, getGroupColConfig('COLUMN_ID'), getGroupColConfig('COLUMN_NAME'));//NO I18N 
        } else {
//            var dataLabelFormat = '${' + getGroupColConfig('COLUMN_ID') + '}.LABEL';
//            label = WidgetUtils.searchNreplace(label, dataLabelFormat, WidgetEditor.editor.cinfo.DATA.FORMATUTILS.GROUP);
            label = WidgetUtils.searchNreplace(label, getGroupColConfig('COLUMN_ID'), getGroupColConfig('COLUMN_NAME'));//NO I18N
        }
        label = WidgetUtils.searchNreplace(label, getYAxisColConfig('COLUMN_ID'), getYAxisColConfig('COLUMN_NAME'));//NO I18N
        label = WidgetUtils.searchNreplace(label, '${OPERATION}', getShowValueDisplayText(showValObj, 'OPERATION'));//NO I18N
        return (label) ? label : '';
    };
    var getStyleDisplayText = function (styleObj) {
        if (!styleObj || !styleObj['FONT-FAMILY']) {
            return 'Default';//NO I18N
        }

        var text = styleObj['FONT-FAMILY']; //NO I18N
        if (text.length > 10)
        {
            text = text.substr(0, 9) + "...";
        }
        text += ', ' + styleObj['FONT-SIZE'] + ', ' + styleObj['FONT-WEIGHT']; //No I18N
        return text;
    };
    var updateComboText = function (node, innerHTML, noEncode) {
        if (!node || !innerHTML) {
            return;
        }
        if (node.getAttribute('holder') !== 'true')
        {
            node = DOMUtils.getSelfOrParentWithAttrValue(node, 'holder', 'true'); //No I18N
        }
        var displayNode = DOMUtils.getFirstMatchingChild(node, 'span', 'comboInfo', 'displayNode'); //No I18N
        displayNode.innerHTML = (noEncode) ? innerHTML : escHTML(innerHTML);
    };
    var updateDisplaySettingsInputText = function (input, value) {
        if (value == null) {
            return;
        }
        updateInputText(input, value);
    };
    var updateKPIToggleSettings = function (radio, checked) {
        updateCheckedProps(radio, checked);
    };
    var updateInputText = function (input, value) {
        input.value = value;//escHTML(value);
    };
    var updateInputSelectionRange = function (input) {
        input.focus();
        input.setSelectionRange(0, BROWSER.EDGE ? 0 : input.value.length);
    };
    var updateCheckedProps = function (el, value) {
        el.checked = value;
    };
    var updateStyleKPIDisplayText = function (node, showValObject, settingsObject, key) {//$$REVISIT
        ZDBUtil.setNamedChildEls(node, node);
        var optionIndex = parseInt(getConfig(showValObject, key)) - 1;
        updateStyleDisplayNodeText(node.fontDisp, editor.kpiCompOptions[optionIndex].text);
        if (getConfig(settingsObject, key)) {
            updateStyleDisplayColor(node.fontClrDisp, getConfig(settingsObject[key], 'COLOR'));
        }
    };
    var updateStyleDisplayText = function (node, obj, key) {
        var styleObj = getConfig(obj, key);
        _updateStyleDisplayText(node, styleObj);
    };
    var _updateStyleDisplayText = function (node, styleObj) {
        ZDBUtil.setNamedChildEls(node, node);
        updateStyleDisplayNodeText(node.fontDisp, getStyleDisplayText(styleObj));
        updateStyleDisplayColor(node.fontClrDisp, getConfig(styleObj, 'COLOR'));//NO I18N
    };
    var updateStyleDisplayNodeText = function (node, innerHTML) {
        node.innerHTML = innerHTML;
    };
    var updateStyleDisplayColor = function (node, colorCode) {
        colorCode = (colorCode && !isNaN(colorCode)) ? CSSFactory.adjustToHex(parseInt(colorCode)) : colorCode;
        node.style.display = (colorCode) ? '' : 'none';
        colorCode = colorCode + '';
        node.style.backgroundColor = (colorCode && colorCode.indexOf('#') === 0) ? colorCode : '#' + colorCode;
        node.setAttribute('value', colorCode.replace('#', ''));
    };
    var updateStyleCombo = function (holder) {
        var position = holder.getAttribute('position');
        var positionKey = holder.getAttribute('positionKey');
        _updateStyleCombo(holder, getConfig(getSettingsConfig(position), positionKey));
    };
    var _updateStyleCombo = function (holder, styleObj) {
        var fontPropComp = DOMUtils.getFirstMatchingChild(holder, 'div', 'WidgetHolder', 'styleCombo'); //No I18N
        var comboBox = DOMUtils.getFirstMatchingChild(holder, 'div', 'combobox', 'true'); //No I18N
        fontPropComp.defaultFontSet.className = 'fontpropcompenabled';
        fontPropComp.color.className = 'inlineClrEl';
        _updateStyleDisplayText(comboBox, styleObj);
        var position = holder.getAttribute('position');
        var positionKey = holder.getAttribute('positionKey');
        if (!styleObj)
        {
            styleObj = WidgetConstants.DEFAULTSTYLE[positionKey + position];
        }
        styleObj['TEXTALIGN'] = styleObj['TEXTALIGN'] || WidgetConstants.DEFAULTSTYLE[positionKey + position]['TEXTALIGN'];
        if (!styleObj['TEXTALIGN']) {
        	delete styleObj['TEXTALIGN'];
        }
        WidgetEditor.selectFromCombo(fontPropComp.fontName, styleObj['FONT-FAMILY']); //NO I18N
        WidgetEditor.selectFromCombo(fontPropComp.fontSize, styleObj['FONT-SIZE']); //NO I18N
        WidgetEditor.selectFromCombo(fontPropComp.fontWeight, styleObj['FONT-WEIGHT']); //NO I18N
        if ((positionKey + position) !== 'OPERATIONopr1') {
        	WidgetEditor.setTextAlignStyle(fontPropComp.textAlign, styleObj['TEXTALIGN']); //NO I18N
        }
        fontPropComp.color.style.backgroundColor = styleObj.COLOR;
        fontPropComp.color.setAttribute('value', styleObj.COLOR.replace('#', ''));
    };
    var updateKPIStyleCombo = function (holder) {
        var positionKey = holder.getAttribute('positionKey');
        WidgetEditor.selectFromCombo(editor.kpiCompOptions, getKPIShowValueConfig(positionKey)); //NO I18N
        var colorCode = getConfig(getSettingsConfig('kpi'), positionKey); //No I18N
        colorCode = colorCode ? colorCode['COLOR'] : getConfig(WidgetConstants.DEFAULTSTYLE[positionKey], 'COLOR');//NO I18N
        updateStyleDisplayColor(editor.kpiCompColor, colorCode);
    };
    var updateVariables = function () {
        var variables = [];
        var varHolder = editor.variables;
        ZDBUtil.setNamedChildEls(varHolder, varHolder, 'divKey');
        groupLabelVariable = WidgetConstants.GROUPLABEL.replace('GROUP', getGroupColConfig('COLUMN_ID'));
        groupValueVariable = WidgetConstants.GROUPVALUE.replace('GROUP', getGroupColConfig('COLUMN_ID'));
        groupLabelDispVariable = WidgetConstants.GROUPLABEL.replace('GROUP', getGroupColConfig('COLUMN_NAME'));
        varHolder.columnGROUPLABEL.innerHTML = escHTML(groupLabelDispVariable);
        varHolder.columnGROUPLABEL.setAttribute('value', groupLabelDispVariable);
        groupValueDispVariable = WidgetConstants.GROUPVALUE.replace('GROUP', getGroupColConfig('COLUMN_NAME'));
        varHolder.columnGROUPVALUE.innerHTML = escHTML(groupValueDispVariable);
        varHolder.columnGROUPVALUE.setAttribute('value', groupValueDispVariable);
        if (getYAxisColConfig('COLUMN_NAME')) {
            yaxisLabelDispVariable = WidgetConstants.YAXISLABEL.replace('YAXIS', getYAxisColConfig('COLUMN_NAME'));
            varHolder.columnYAXISLABEL.innerHTML = escHTML(yaxisLabelDispVariable);
            varHolder.columnYAXISLABEL.setAttribute('value', yaxisLabelDispVariable);
            varHolder.columnYAXISLABEL.style.display = '';
            yaxisLabelVariable = WidgetConstants.YAXISLABEL.replace('YAXIS', getYAxisColConfig('COLUMN_ID'));
            variables.push(varHolder.columnYAXISLABEL);
        } else {
            yaxisLabelDispVariable = yaxisLabelVariable = null;
            varHolder.columnYAXISLABEL.style.display = 'none';
        }
        variables.push(varHolder.columnGROUPLABEL);
        variables.push(varHolder.columnGROUPVALUE);
        variables.push(varHolder.OPERATION);
        varHolder.variables = variables;
    };
    var getVariable = function (value) {
        value = WidgetUtils.searchNreplace(value, groupLabelDispVariable, groupLabelVariable);
        value = WidgetUtils.searchNreplace(value, groupValueDispVariable, groupValueVariable);
        value = WidgetUtils.searchNreplace(value, yaxisLabelDispVariable, yaxisLabelVariable);
        return value;
    };
    var getCSS = function () {
        var css = ['layout' + layout];
        if (!hasGroupAxis()) {
            css.push('nocols');//NO I18N
        }
        css = css.concat(Object.keys(editor.cinfo.COLUMNS));
        if (isZCLayout()) {
            css.push('wcThresholdUnits' + (getConfig(getShowValueInfo('THRESHOLD'), 'UNIT') || 0));//NO I18N
            css.push('wcMaxRangeUnits' + (getConfig(getShowValueInfo('TEXTAXIS'), 'UNIT') || 0));//NO I18N
            css.push('wcLegendUnits' + (getConfig(getShowValueInfo('LEGEND'), 'UNIT') || 0));//NO I18N
            css.push('wcLMRangeUnits' + (getKeyValueMapConfig(chartConstants.RANGES_UNITS) || 0));//NO I18N
            css.push((getKeyValueMapConfig(chartConstants.RANGES_ENABLE) === "false") ? 'nowcranges' : '');//NO I18N
            css.push(getKeyValueMapConfig(chartConstants.RANGE_ONE) ? 'wcrange1' : '');//NO I18N
            css.push(getKeyValueMapConfig(chartConstants.RANGE_TWO) ? 'wcrange2' : '');//NO I18N
            css.push(getKeyValueMapConfig(chartConstants.RANGE_THREE) ? 'wcrange3' : '');//NO I18N
            css.push(getKeyValueMapConfig(chartConstants.RANGE_FOUR) ? 'wcrange4' : '');//NO I18N
            css.push(getKeyValueMapConfig(chartConstants.RANGE_FIVE) ? 'wcrange5' : '');//NO I18N
            css.push('wcLOpr' + (getShowValueConfig("LEGEND") ? getShowValueConfig("LEGEND").OPERATION : ''));//NO I18N
            css.push('wcMROpr' + (getShowValueConfig("TEXTAXIS") ? getShowValueConfig("TEXTAXIS").OPERATION : ''));//NO I18N
            css.push('wcTOpr' + (getShowValueConfig("THRESHOLD") ? getShowValueConfig("THRESHOLD").OPERATION : ''));//NO I18N
            if (!hasYAxis()) {
                css.push('noYAxis');//NO I18N
            }
        } else {
            css = css.concat(Object.keys(editor.cinfo.SHOWVALUEAS));
        }
        css.push(getYAxisOperation());
        if (isValidConfig() && isKPILayout()) {
            css.push(getKPIShowValueConfig('RHS'));//NO I18N
            if (!canCustomizeKPISettings()) {
                css.push('disablekpisymbol');//NO I18N
            }
            if (!canCustomizeKPIValueColor()) {
                css.push('disablekpivalue');//NO I18N
            }
        }
        return css.join(' ');
    };
    var updateEditorCSS = function () {
        editor.css.setAttribute('class', getCSS());
    };
    var updateEditor = function () {
        if (canPopulateShowVals()) {
            populateShowVals();
            bindShowValConfig();
        }
        validateConfig();
        updateEditorCSS();
    };
    var getYAxisOperation = function()
    {
    	var cinfo = WidgetEditor.editor.cinfo;
    	return cinfo.COLUMNS.YAXIS ? WidgetEditor.dateOperations.indexOf(cinfo.COLUMNS.YAXIS.OPERATION) == -1 || cinfo.LAYOUT < 4 ? "yAxisNoDate" : "yAxisDateFmt" : ""; //No I18n
    }
    var getPreviewConfig = function () {
        return WidgetUtils.getZADataConfig(editor.objId, editor, false, true);
    };
    var showPreview = function () {
        if (!dataFetched()) {
            return;
        }
        var previewHolder = editor.preview;
        while (previewHolder.hasChildNodes()) {
            previewHolder.removeChild(previewHolder.firstChild);
        }
        if (editor.renderer) {
            editor.renderer.update(editor.renderer.setData, [editor.cinfo.DATA], true);
        } else {
            editor.renderer = WidgetUtils.getRenderer(editor.layout, editor.cinfo);
        }
//        editor.renderer.setDimensions(250, 130);
        WidgetUtils.getChildNode(editor, previewHolder, true);
    };
    var resetData = function () {
        setConfig(editor.cinfo, 'DATA');//NO I18N
    };
    var resetColumnConfig = function () {
        setConfig(editor.cinfo, 'COLUMNS', {});//NO I18N
        setConfig(editor.cinfo, 'SHOWVALUEAS', {});//NO I18N
//        setConfig(editor.cinfo, 'SETTINGS', {});//NO I18N
        initConfig();
    };
    var resetZCConfig = function () {
        deleteColumnConfig('LEGEND');//NO I18N
        deleteColumnConfig('THRESHOLD');//NO I18N
        deleteColumnConfig('TEXTAXIS');//NO I18N
    };
    var resetShowValueConfig = function () {
        setConfig(editor.cinfo, 'SHOWVALUEAS', {});//NO I18N
        initShowValueConfig();
    };
    var resetNonZCShowValueConfig = function () {
        setShowValueConfig('opr1');//NO I18N
        setShowValueConfig('opr2');//NO I18N
        setShowValueConfig('opr3');//NO I18N
    };
    var resetKeyValueConfig = function () {
        setConfig(editor.cinfo, 'KEYVALMAP', {});//NO I18N
    };
    var resetZCKeyValueConfig = function () {
        switch (layout) {
            case 7:
                setKeyValueMapConfig(chartConstants.NEEDLE_TYPE);
                setKeyValueMapConfig(chartConstants.NEEDLE_STROKE_COLOR);
                setKeyValueMapConfig(chartConstants.NEEDLE_FILL_COLOR);
                setKeyValueMapConfig(chartConstants.NEEDLE_WIDTH);
                setKeyValueMapConfig(chartConstants.MIN_MAX_LABEL);
                break;
            case 8:
                setKeyValueMapConfig(chartConstants.LEGEND_BANDWIDTH);
                setKeyValueMapConfig(chartConstants.TARGET_MARKER_DASH_STYLE);
                setKeyValueMapConfig(chartConstants.TARGET_MARKER_COLOR);
                setKeyValueMapConfig(chartConstants.MIN_MAX_LABEL);
                setKeyValueMapConfig(chartConstants.LEVER_MARKER_BANDWIDTH);
                break;
        }
    };
    var getGroupColInfo = function (key) {
        return getGroupColConfig(key);
    };
    var getYAxisColInfo = function (key) {
        return getYAxisColConfig(key);
    };
    var getShowValueInfo = function (key) {
        return getShowValueConfig(key);
    };

    /* Widget Charts Start */
    var updateChartKeyValue = function (key, value, callBackValue) {
        setKeyValueMapConfig(key, value+'');
        WidgetUtils.setRendererProp(editor.renderer, key, (callBackValue != null) ? callBackValue : value, true);
    };
    var updateChartSettingsColorConfig = function (el) {
        var key = el.getAttribute('key');
        var value = el.getAttribute('value');
        var colorCode = CSSFactory.adjustToInt(value);
        updateChartKeyValue(key, colorCode, '#' + value);
        if(key == WidgetChartConstants.NEEDLE_FILL_COLOR || key == WidgetChartConstants.TARGET_MARKER_COLOR){
        	// update color box in combo
        	updateChartStyleCombos(el, 'colorProp');
        }
    };
    var updateChartInputVals = function (el, defaultValue) {
        var key = el.getAttribute('key');
        var value = el.value || defaultValue;
        updateChartKeyValue(key, value);
    };
    var updateChartStyleCombos = function(el, elName, suffix, skipUpdate){
    	var type = el.getAttribute('segmentType');
    	var comboHolder = editor.wcharts[type+"StyleCombo"];
    	ZDBUtil.setNamedChildEls(comboHolder, comboHolder);
    	if(elName == "colorProp"){
    		var value = "#" + el.getAttribute('value');
    		comboHolder.colorProp.style.backgroundColor = value;
    	}
    	else{
    		if(!skipUpdate){
    			updateChartInputVals(el);
    		}
    		var value = el.value + suffix;
    		comboHolder[elName].innerText = value; 
    	}
		
    };
    var updateChartToggleVals = function (el) {
        var key = el.getAttribute('key');
        var value = el.getAttribute('value') === 'true';
        value = (el.checked) ? value : !value;
        updateChartKeyValue(key, value, value);
        updateEditorCSS();
    };
    var updateChartRangeList = function (idx, toAdd) {
        idx = (toAdd) ? idx : idx + 1;
        var divKey = 'range' + idx;//NO I18N
        var colorDiv = editor.wcharts[divKey + 'Color'];
        var valDiv = editor.wcharts[divKey + 'Val'];
        if (toAdd) {
            updateChartInputVals(valDiv, 0);
            updateChartSettingsColorConfig(colorDiv);
            setKeyValueMapConfig(colorDiv.getAttribute('key'), CSSFactory.adjustToInt(colorDiv.getAttribute('value')));
        } else {
            setKeyValueMapConfig(colorDiv.getAttribute('key'));
            setKeyValueMapConfig(valDiv.getAttribute('key'));
            WidgetUtils.setRendererProp(editor.renderer, valDiv.getAttribute('key'), null, true);
        }
        updateChartSettingsColorConfig(editor.wcharts.maxRangeColor);
        updateEditorCSS();
    };
    var updateChartUnits = function (el, holder) {
        var key = holder.getAttribute('key');
        var value = el.getAttribute('unitsIdx');
        setKeyValueMapConfig(key, value);
        WidgetUtils.setRendererProp(editor.renderer, key, value, true);
        updateEditorCSS();
    };
    var updateLegendOperation = function (el, holder) {
        var position = holder.getAttribute('WidgetData');
        getShowValueConfig(position).OPERATION = (el.getAttribute('custom') === 'true') ? getGroupColInfo('OPERATION') : 'CONSTANT';//NO I18N
        constructZCDataTabMetrics();
        updateEditorCSS();
    };
    var updateChartRangeCombo = function (idx) {
        var colorCode = getKeyValueMapConfig(chartConstants.RANGES_COLOR_FORMAT.replace('$', idx));//NO I18N
        var value = getKeyValueMapConfig(chartConstants.RANGES_VALUE_FORMAT.replace('$', idx));//NO I18N
        var divKey = 'range' + idx;//NO I18N
        var colorDiv = editor.wcharts[divKey + 'Color'];
        var valDiv = editor.wcharts[divKey + 'Val'];
        var parentDiv = editor.wcharts[divKey];
        updateInputText(valDiv, value || parentDiv.getAttribute('defValue'));
        updateStyleDisplayColor(colorDiv, colorCode || parentDiv.getAttribute('defColor'));
        if (colorCode || value) {
            editor.wcharts.rangeList.setAttribute('size', idx);
        }
    };
    var updateChartRangeCombos = function () {
//        if (getKeyValueMapConfig(chartConstants.RANGES_ENABLE) === 'false') {
//            return;
//        }
        editor.wcharts.rangeList.setAttribute('size', '0');
        updateChartRangeCombo(1);
        updateChartRangeCombo(2);
        updateChartRangeCombo(3);
        updateChartRangeCombo(4);
        updateChartRangeCombo(5);
    };
    var _updateChartStyleCombo = function(type, size, color){
    	updateChartStyleCombos(type, "typeProp", ", ", true);
    	updateChartStyleCombos(size, "sizeProp", "px, ", true);
    	updateChartStyleCombos(color, "colorProp", true);
    }
    
    
    var updateAutoComputedValue = function(proceed, value, inputEl, textNode , label){
    	if(proceed){
    		inputEl.value = value;
    		updateChartShowValConfig(inputEl, value);
    		textNode.innerHTML = label;
    		textNode.style.cssText = "display : inline-block; opacity : 1";//NO I18N
    		jQuery(textNode).stop().fadeOut(5000);
    	}
    };
    
    var handleAutoComputeSuccess = function(response, requestOptions){
    	var jsonData = JSON.parse(response.responseText);
    	var threshold = !modifiedInputs.THRESHOLD;
    	var maxRange = !modifiedInputs.MAXRANGE;
    	var compareTh = 0;
    	if(!jsonData.NODATA){
	    	var label = jQuery.find(".combodisplayval",WidgetEditor.editor.labelNode)[0].innerHTML;
	    	var thresholdLabel = jQuery.find(".combodisplayval",WidgetEditor.editor.thresholdNode)[0].innerHTML;
    		var value = jsonData.DATA[1];
    		var thresholdValue = jsonData.DATA[3];
    		var thresholdObj = editor.cinfo.SHOWVALUEAS.THRESHOLD || editor.cinfo.COLUMNS.THRESHOLD;
    		if(threshold && thresholdObj.OPERATION === "CONSTANT"){
    			thresholdValue = Math.round(value * 1.2);
    			updateAutoComputedValue(threshold, thresholdValue, editor.thresholdConstant, editor.thresholdHelperText, "120% of "+ label);//NO I18N
    		}
    		else if(thresholdObj.OPERATION !== "NONE"){
    			if(!threshold && thresholdObj.OPERATION === "CONSTANT"){
    				thresholdLabel = "Target";
    			}
    			compareTh = 1;
    		}
    		var textaxisObj = editor.cinfo.SHOWVALUEAS.TEXTAXIS || editor.cinfo.COLUMNS.TEXTAXIS;
    		if(textaxisObj.OPERATION === "CONSTANT"){
    			var maxValue = Math.round(value * 1.5);
    			var label = "150% of " + label;//NO I18N
    			if(compareTh && thresholdValue > maxValue){
    				maxValue = Math.round(thresholdValue * 1.3);
    				label = "130% of " + thresholdLabel; //NO I18N
    			}
    			updateAutoComputedValue(maxRange, maxValue, editor.maxConstant, editor.maxHelperText, label);
    		}
    	}
    	else{
    		editor.maxConstant.value = editor.thresholdConstant.value = 0;
    	}
    	// to check progress of auto compute in QA automation;
    	if(window.WidgetQa){
			editor.setAttribute("qaAutoCompute","true");
			editor.setAttribute("qaAutoComputeState","true");
		}
    };
    
    var handleAutoComputeFailure = function(){
    	// to check progress of auto compute in QA automation;
    	if(window.WidgetQa){
			editor.setAttribute("qaAutoCompute","true");
			editor.setAttribute("qaAutoComputeState","false");
		}
    	return;
    };
    
    var autoComputeDataDefaults = function(proceed){
    	if(proceed){
    		delete modifiedInputs.THRESHOLD;
    		delete modifiedInputs.MAXRANGE;
    	}
    	
    	var threshold = !modifiedInputs.THRESHOLD;
    	var maxRange = !modifiedInputs.MAXRANGE;
    	
    	if((threshold || maxRange) && editor.layout > 6){
    		// to check progress of auto compute in QA automation;
    		if(window.WidgetQa){
    			editor.setAttribute("qaAutoCompute","false");
    			editor.setAttribute("qaAutoComputeState","false");
    		}
    		WidgetFetcher.requestPreviewData(editor, handleAutoComputeSuccess, handleAutoComputeFailure); //No I18N
    	}
    };
    
    var setModifiedInput = function(key){
    	modifiedInputs[key] = true;
    }

    /* Widget Charts Start */

    /* Initialization Start */
    var init = function () {
        layout = parseInt(editor.cinfo.LAYOUT);
        initConfig();
        initDivs();
    };
    var initConfig = function () {
        setColumnConfig = setConfig.bind(this, editor.cinfo.COLUMNS);
        getColumnConfig = getConfig.bind(this, editor.cinfo.COLUMNS);
        initShowValueConfig();
    };
    var initShowValueConfig = function () {
        setShowValueConfig = setConfig.bind(this, editor.cinfo.SHOWVALUEAS);
        getShowValueConfig = getConfig.bind(this, editor.cinfo.SHOWVALUEAS);
        setSettingsConfig = setConfig.bind(this, editor.cinfo.SETTINGS);
        getSettingsConfig = getConfig.bind(this, editor.cinfo.SETTINGS);
        deleteKPIShowValConfig = setShowValueConfig.bind(this, 'kpi');
        deleteKPISettings = setSettingsConfig.bind(this, 'kpi', null);
        setSecondaryShowValue = setShowValueConfig.bind(this, 'opr2');
        setSecondarySettings = setSettingsConfig.bind(this, 'opr2');
        setTertiaryShowValue = setShowValueConfig.bind(this, 'opr3');
        setTertiarySettings = setSettingsConfig.bind(this, 'opr3');
        setKPIShowValue = setShowValueConfig.bind(this, 'kpi');
        getKPIShowValue = getShowValueConfig.bind(this, 'kpi');
    };
    var initDivs = function () {
        updateDataColText = updateComboText.bind(this, editor.GROUP);
        updateGroupColText = updateComboText.bind(this, editor.YAXIS);
        updateLegendColText = updateComboText.bind(this, editor.LEGEND);
        updateMaxRangeText = updateComboText.bind(this, editor.TEXTAXIS);
        updateTargetText = updateComboText.bind(this, editor.THRESHOLD);
        updatePrimaryShowValText = updateComboText.bind(this, editor.PRIMARY);
        updatePrimarySettingsLabelText = updateInputText.bind(this, editor.settings.inputOpr1LABEL);
        updatePrimarySettingsValueText = updateInputText.bind(this, editor.settings.inputOpr1VALUE);
        updateSecondaryShowValText = updateComboText.bind(this, editor.SECONDARY);
        updateSecondarySettingsLabelText = updateInputText.bind(this, editor.settings.inputOpr2LABEL);
        updateTertiaryShowValText = updateComboText.bind(this, editor.TERTIARY);
        updateTertiarySettingsLabelText = updateInputText.bind(this, editor.settings.inputOpr3LABEL);
        updateLegendPercText = updateInputText.bind(this, editor.data.LEGEND_PERC);
        updateThresholdPercText = updateInputText.bind(this, editor.data.THRESHOLD_PERC);
        updateTextaxisPercText = updateInputText.bind(this, editor.data.TEXTAXIS_PERC);
        updateLegendConstantText = updateInputText.bind(this, editor.data.LEGEND_CONST);
        updateMaxRangeConstantText = updateInputText.bind(this, editor.data.TEXTAXIS_CONST);
        updateTargetConstantText = updateInputText.bind(this, editor.data.THRESHOLD_CONST);
        updateCompareWithLHSText = updateComboText.bind(this, editor.COMPAREWITHLHS);
        updateCompareWithRHSText = updateComboText.bind(this, editor.COMPAREWITHRHS);
        updateCompareWithConstantText = updateInputText.bind(this, editor.KPICONSTANT);
    };
    /* Initialization End */
    /* Binding Start */
    var bindDataTabConfig = function () {
        bindColumnConfig();
        bindShowValConfig();
        if (isKPILayout()) {
            bindKPIShowValConfig();
        }
        if (isZCLayout()) {
            bindKeyValConfig();
            bindZCRangeConfig();
        }
    };
    var bindColumnConfig = function () {
        getGroupColConfig = getConfig.bind(this, editor.cinfo.COLUMNS.GROUP);
        getYAxisColConfig = getConfig.bind(this, editor.cinfo.COLUMNS.YAXIS);
        getDataColText = getColDisplayText.bind(this, editor.cinfo.COLUMNS.GROUP);
        getGroupColText = getColDisplayText.bind(this, editor.cinfo.COLUMNS.YAXIS);
        if (isZCLayout()) {
            bindZCColumnConfig();
        }
    };
    var bindZCColumnConfig = function () {
        if (getColumnConfig('THRESHOLD')) {
            getTargetColText = getColDisplayText.bind(this, editor.cinfo.COLUMNS.THRESHOLD);
        } else {
            getTargetColText = getShowValueDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.THRESHOLD, 'OPERATION');
        }
        if (getColumnConfig('TEXTAXIS')) {
            getMaxRangeColText = getColDisplayText.bind(this, editor.cinfo.COLUMNS.TEXTAXIS);
        } else {
            getMaxRangeColText = getShowValueDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.TEXTAXIS, 'OPERATION');
        }
        if (hasYAxis() || getShowValueConfig('LEGEND') && getShowValueConfig('LEGEND').OPERATION === 'CONSTANT') {
            getLegendColText = getShowValueDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.LEGEND, 'OPERATION');
        } else {
            getLegendColText = getDataColText;
        }
    };
    var bindShowValConfig = function () {
        setPrimaryShowValue = setConfig.bind(this, editor.cinfo.SHOWVALUEAS.opr1);
        getPrimaryShowValText = getShowValueDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.opr1, 'OPERATION');
        getPrimarySettingsLabelText = getLabelDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.opr1, 'LABEL');
        getPrimarySettingsValueText = getLabelDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.opr1, 'VALUE');
        getSecondaryShowValText = getShowValueDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.opr2, 'OPERATION');
        getSecondarySettingsLabelText = getLabelDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.opr2, 'LABEL');
        getTertiaryShowValText = getShowValueDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.opr3, 'OPERATION');
        getTertiarySettingsLabelText = getLabelDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.opr3, 'LABEL');
    };
    var bindKeyValConfig = function () {
        getKeyValueMapConfig = getConfig.bind(this, editor.cinfo.KEYVALMAP);
        setKeyValueMapConfig = setConfig.bind(this, editor.cinfo.KEYVALMAP);
    };
    var bindZCRangeConfig = function () {
    	getLegendPercText = getConfig.bind(this, getShowValueInfo('LEGEND'),'PERCENTAGE');
    	getThresholdPercText = getConfig.bind(this, getShowValueInfo('THRESHOLD'),'PERCENTAGE');
    	getTextaxisPercText = getConfig.bind(this, getShowValueInfo('TEXTAXIS'),'PERCENTAGE');
        getLegendConstantText = getConfig.bind(this, getShowValueInfo('LEGEND'), 'CONSTANT');
        getMaxRangeConstantText = getConfig.bind(this, getShowValueInfo('TEXTAXIS'), 'CONSTANT');
        getTargetConstantText = getConfig.bind(this, getShowValueInfo('THRESHOLD'), 'CONSTANT');
    };
    var bindKPIShowValConfig = function () {
        setKPIShowValueConfig = setConfig.bind(this, editor.cinfo.SHOWVALUEAS.kpi);
        getKPIShowValueConfig = getConfig.bind(this, editor.cinfo.SHOWVALUEAS.kpi);
        getCompareWithLHSText = getShowValueDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.kpi, 'LHS');
        getCompareWithRHSText = getShowValueDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.kpi, 'RHS');
        getCompareWithConstantText = getKPIShowValueConfig.bind(this, 'CONSTANT');
    };
    var bindSettingsConfig = function () {
        bindKeyValConfig();
        if (isZCLayout()) {
            updateChartTitleLabelText = updateInputText.bind(this, editor.wcharts.chartTitle);
            getChartTitleLabelText = getLabelDisplayText.bind(this, editor.cinfo.SHOWVALUEAS.LEGEND, 'LABEL');
            updateHOrientation = updateCheckedProps.bind(this, editor.wcharts.horizontal);
            updateVOrientation = updateCheckedProps.bind(this, editor.wcharts.vertical);
            updateShowDataLabel = updateCheckedProps.bind(this, editor.wcharts.showDataLabel);
            updateShowMinMaxLabel = updateCheckedProps.bind(this, editor.wcharts.showMinMaxLabel);
            updateLegendColor = updateStyleDisplayColor.bind(this, editor.wcharts.legendColor);
            updateMaxRangeColor = updateStyleDisplayColor.bind(this, editor.wcharts.maxRangeColor);
            updateLegendBandWidth = updateInputText.bind(this, editor.wcharts.legendBandWidth);
            updateMaxRangeBandWidth = updateInputText.bind(this, editor.wcharts.maxRangeBandWidth);
            updateChartRangesToggle = updateCheckedProps.bind(this, editor.wcharts.chartRanges);
            // For Target Marker
            updateShowTargetMarkerLabel = updateCheckedProps.bind(this, editor.wcharts.showTargetMarkerLabel);
            updateTargetMarkerType = updateInputText.bind(this, editor.markerType);
            updateTargetMarkerSize = updateInputText.bind(this, editor.markerSize);
            updateTargetMarkerColor = updateStyleDisplayColor.bind(this, editor.targetMarkerColor);
            updateTargetStyleCombo = _updateChartStyleCombo.bind(this, editor.markerType, editor.markerSize, editor.targetMarkerColor);
            //getTargetMarkerDashStyleText = getChartSettingsMenuText.bind(this, editor.strokeStyleMenu, chartConstants.TARGET_MARKER_DASH_STYLE);
            // For Needle
            updateNeedleType = updateInputText.bind(this, editor.needleType);
            updateNeedleWidth = updateInputText.bind(this, editor.needleWidth);
            updateNeedleColor = updateStyleDisplayColor.bind(this, editor.needleColor);
            updateNeedleStyleCombo = _updateChartStyleCombo.bind(this, editor.needleType, editor.needleWidth, editor.needleColor);
            //getNeedleTypeText = getChartSettingsMenuText.bind(this, editor.needleTypeMenu, chartConstants.NEEDLE_TYPE);
            updateChartTitleStyleLabelText = updateStyleDisplayText.bind(this, editor.settings.LEGENDLABEL, editor.cinfo.SETTINGS.LEGEND, 'LABEL');
        } else {
            updatePrimaryStyleLabelText = updateStyleDisplayText.bind(this, editor.settings.opr1LABEL, editor.cinfo.SETTINGS.opr1, 'LABEL');
            updatePrimaryStyleValueText = updateStyleDisplayText.bind(this, editor.settings.opr1VALUE, editor.cinfo.SETTINGS.opr1, 'OPERATION');
            updateSecondaryStyleLabelText = updateStyleDisplayText.bind(this, editor.settings.opr2LABEL, editor.cinfo.SETTINGS.opr2, 'LABEL');
            updateTertiaryStyleLabelText = updateStyleDisplayText.bind(this, editor.settings.opr3LABEL, editor.cinfo.SETTINGS.opr3, 'LABEL');
            if (isKPILayout()) {
                getKPISettingsConfig = getConfig.bind(this, editor.cinfo.SETTINGS.kpi);
                updateKPISettingsPositiveComboText = updateStyleKPIDisplayText.bind(this, editor.settings.kpiPOSITIVE, editor.cinfo.SHOWVALUEAS.kpi, editor.cinfo.SETTINGS.kpi, 'POSITIVE');
                updateKPISettingsNegativeComboText = updateStyleKPIDisplayText.bind(this, editor.settings.kpiNEGATIVE, editor.cinfo.SHOWVALUEAS.kpi, editor.cinfo.SETTINGS.kpi, 'NEGATIVE');
                updateKPISymbolToggleSettings = updateKPIToggleSettings.bind(this, editor.settings.radioKPISymbol, (getConfig(editor.cinfo.SHOWVALUEAS.kpi, 'SHOWKPI') !== 'false'));
                updateKPIValueToggleSettings = updateKPIToggleSettings.bind(this, editor.settings.radioKPIValue, getConfig(editor.cinfo.SHOWVALUEAS.opr1, 'POSITIVE') !== null);
                updateKPIPositiveValueColorSettings = updateStyleDisplayColor.bind(this, editor.settings.kpiValuePOSITIVE, getConfig(getConfig(editor.cinfo.SETTINGS.opr1, 'POSITIVE'), 'COLOR') || (getConfig(editor.cinfo.SETTINGS.kpi, 'POSITIVE') ? CSSFactory.adjustToInt(editor.cinfo.SETTINGS.kpi.POSITIVE.COLOR.replace('#', '')) : null) || WidgetConstants.KPIPOSITIVECOLOR);
                updateKPINegativeValueColorSettings = updateStyleDisplayColor.bind(this, editor.settings.kpiValueNEGATIVE, getConfig(getConfig(editor.cinfo.SETTINGS.opr1, 'NEGATIVE'), 'COLOR') || (getConfig(editor.cinfo.SETTINGS.kpi, 'NEGATIVE') ? CSSFactory.adjustToInt(editor.cinfo.SETTINGS.kpi.NEGATIVE.COLOR.replace('#', '')) : null) || WidgetConstants.KPINEGATIVECOLOR);
            }
        }
        updateUnknownLabelText = updateDisplaySettingsInputText.bind(this, editor.settings.inputNullLabel);
        updateUnknownValueText = updateDisplaySettingsInputText.bind(this, editor.settings.inputNullValue);
    };
    /* Binding End */
    /* Tab Constructing Start */
    var constructDataTab = function () {
        bindDataTabConfig();
        updateDataColText(getDataColText());
        checkIfMultiTable();
        updateGroupColText(getGroupColText());
        if (isZCLayout()) {
            _constructZCDataTabCombos();
            constructZCDataTabInputEls();
            editor.dataLeftPane.scrollTop = 90;
        } else {
            if (isKPILayout()) {
                constructDataTabKPI();
            }
            updatePrimaryShowValText(getPrimaryShowValText());
            updateSecondaryShowValText(getSecondaryShowValText());
            updateTertiaryShowValText(getTertiaryShowValText());
            editor.dataLeftPane.scrollTop = 0;
        }
        updateEditorCSS();
    };
    var constructZCDataTabMetrics = function () {
        if (!isZCLayout() || !hasGroupAxis()) {
            return;
        }
        _constructZCDataTabCombos();
        constructZCDataTabInputEls();
    };
    var _constructZCDataTabCombos = function () {
        updateLegendColText(getLegendColText());
        updateMaxRangeText(getMaxRangeColText());
        updateTargetText(getTargetColText());
    };
    var constructZCDataTabInputEls = function () {
    	updateLegendPercText(getLegendPercText() || chartConstants.DEFAULT_VALUE_PERCENT);
		WidgetEditor.hidePercentageInput('legend');
    	if(getLegendPercText() && getLegendPercText() !== chartConstants.DEFAULT_VALUE_PERCENT){
    		WidgetEditor.showPercentageInput('legend');
    	}
    	updateThresholdPercText(getThresholdPercText() || chartConstants.DEFAULT_VALUE_PERCENT);
    	WidgetEditor.hidePercentageInput('threshold');
    	if(getThresholdPercText() && getThresholdPercText() !== chartConstants.DEFAULT_VALUE_PERCENT){
    		WidgetEditor.showPercentageInput('threshold');
    	}
    	updateTextaxisPercText(getTextaxisPercText() || chartConstants.DEFAULT_VALUE_PERCENT);
    	WidgetEditor.hidePercentageInput('textaxis');
    	if(getTextaxisPercText() && getTextaxisPercText() !== chartConstants.DEFAULT_VALUE_PERCENT){
    		WidgetEditor.showPercentageInput('textaxis');
    	}
        updateLegendConstantText(getLegendConstantText() || chartConstants.DEFAULT_VALUE_PERCENT);
        updateMaxRangeConstantText(getMaxRangeConstantText() || chartConstants.DEFAULT_MAXIMUM_RANGE_PERCENT);
        updateTargetConstantText(getTargetConstantText() || chartConstants.DEFAULT_TARGET_PERCENT);
    };
    var constructDataTabKPI = function () {
        updateCompareWithLHSText(getCompareWithLHSText() || 'Latest');//NO I18N
        updateCompareWithRHSText(getCompareWithRHSText() || 'Previous');//NO I18N
        updateCompareWithConstantText(getCompareWithConstantText() || '0');//NO I18N
    };
    var constructFiltersTab = function () {
//                view.updateAddedFields();
//        view.insertAddedFields(view);
    };
    var constructSettingsTab = function () {
        bindSettingsConfig();
        if (isZCLayout()) {
        	var isDial = editor.layout === 8;
        	var default_data_bw = isDial ? chartConstants.DEFAULT_DATA_BANDWIDTH_DIAL : chartConstants.DEFAULT_DATA_BANDWIDTH_BULLET;
        	var default_level_bw = isDial ? chartConstants.DEFAULT_LEVEL_MARKER_BANDWIDTH_DIAL : chartConstants.DEFAULT_LEVEL_MARKER_BANDWIDTH_BULLET;
            updateHOrientation(getKeyValueMapConfig(chartConstants.ORIENTATION) !== 'false');
            updateVOrientation(getKeyValueMapConfig(chartConstants.ORIENTATION) === 'false');
            updateShowDataLabel(getKeyValueMapConfig(chartConstants.DATA_LABEL) !== 'false');
            updateShowMinMaxLabel(getKeyValueMapConfig(chartConstants.MIN_MAX_LABEL) === 'true');
            updateLegendColor(getKeyValueMapConfig(chartConstants.LEGEND_COLORS) || chartConstants.DEFAULT_DATA_COLOR);
            updateMaxRangeColor(getKeyValueMapConfig(chartConstants.MAXIMUM_RANGE_COLOR) || chartConstants.DEFAULT_MAX_RANGE_COLOR);
            updateLegendBandWidth(getKeyValueMapConfig(chartConstants.LEGEND_BANDWIDTH) || default_data_bw);
            updateMaxRangeBandWidth(getKeyValueMapConfig(chartConstants.LEVER_MARKER_BANDWIDTH) || default_level_bw);
            updateChartRangesToggle(getKeyValueMapConfig(chartConstants.RANGES_ENABLE) === 'true');
            // For Target Marker
            updateShowTargetMarkerLabel(getKeyValueMapConfig(chartConstants.TARGET_MARKER_LABEL_ENABLE) === 'true');
            updateTargetMarkerType(getKeyValueMapConfig(chartConstants.TARGET_MARKER_DASH_STYLE) || chartConstants.DEFAULT_TARGET_MARKER_DASHSTYLE);
            updateTargetMarkerSize(getKeyValueMapConfig(chartConstants.TARGET_MARKER_SIZE) || chartConstants.DEFAULT_TARGET_MARKER_SIZE);
            updateTargetMarkerColor(getKeyValueMapConfig(chartConstants.TARGET_MARKER_COLOR) || chartConstants.DEFAULT_TARGET_MARKER_COLOR);
            updateTargetStyleCombo();
            //updateTargetMarkerDashStyleText(getTargetMarkerDashStyleText());
            //For Needle
            updateNeedleType(getKeyValueMapConfig(chartConstants.NEEDLE_TYPE) || chartConstants.DEFAULT_NEEDLE_TYPE);
            updateNeedleWidth(getKeyValueMapConfig(chartConstants.NEEDLE_WIDTH) || chartConstants.DEFAULT_NEEDLE_WIDTH);
            updateNeedleColor(getKeyValueMapConfig(chartConstants.NEEDLE_FILL_COLOR) || chartConstants.DEFAULT_NEEDLE_FILLCOLOR);
            updateNeedleStyleCombo();
            //updateNeedleTypeText(getNeedleTypeText());
            
            updateChartRangeCombos();
            updateChartTitleStyleLabelText();
            editor.wcharts.chartTitle.focus();
        } else {
            updatePrimaryStyleLabelText();
            updatePrimaryStyleValueText();
            updateSecondaryStyleLabelText();
            updateTertiaryStyleLabelText();
            editor.settings.inputOpr1LABEL.focus();
        }
        updateUnknownLabelText(getKeyValueMapConfig('data.label.null') || 'Unknown');//NO I18N
        updateUnknownValueText(getKeyValueMapConfig('data.value.null') || '-');//NO I18N
        if (isKPILayout()) {
            updateKPISymbolToggleSettings();
            updateKPIValueToggleSettings();
            updateKPISettingsPositiveComboText();
            updateKPISettingsNegativeComboText();
            updateKPIPositiveValueColorSettings();
            updateKPINegativeValueColorSettings();
        }
        constructSettingsTabInputs();
        updateVariables();
        showPreview();
    };

    var constructSettingsTabInputs = function () {
        if (isZCLayout()) {
            updateChartTitleLabelText(getChartTitleLabelText());
            return;
        }
        updatePrimarySettingsLabelText(getPrimarySettingsLabelText());
        updatePrimarySettingsValueText(getPrimarySettingsValueText());
        updateSecondarySettingsLabelText(getSecondarySettingsLabelText());
        updateTertiarySettingsLabelText(getTertiarySettingsLabelText());
    };

    var escHTML = function (value) {
        if (!value) {
            return '';
        }
        return ZDBEscapeUtil.replaceChar(value, ZDBEscapeUtil.SPECIALCHARS_XML, ZDBEscapeUtil.REPL_SPECIALCHARS_XML)
    };
    /* Tab Constructing End */

    init();

    return {
        isValidConfig: isValidConfig,
        canCustomizeShowVals: canCustomizeShowVals,
        canSwitchTabs: isValidConfig,
        canCustomizeKPISettings: canCustomizeKPISettings,
        canCustomizeKPIValueColor: canCustomizeKPIValueColor,
        canCustomizeChartUnits: canCustomizeChartUnits,
        getGroupColConfig: getGroupColInfo,
        getYAxisColConfig: getYAxisColInfo,
        getShowValueConfig: getShowValueInfo,
        updateLayout: updateLayout,
        updateColumnConfig: updateColumnConfig,
        updateColumnRangeConfig: updateColumnRangeConfig,
        updateZCColumnConfigNone: updateZCColumnConfigNone,
        updateShowValConfig: updateShowValConfig,
        updateChartShowValConfig: updateChartShowValConfig,
        updateKPIShowValueConfig: updateKPIShowValueConfig,
        updateKPIShowValueConstant: updateKPIShowValueConstant,
        toggleKPIValueConfig: toggleKPIValueConfig,
        toggleKPISymbolConfig: toggleKPISymbolConfig,
        updateStyleConfig: updateStyleConfig,
        updateLabelText: updateLabelText,
        resetLabel: resetLabel,
        updateKPISettingsStyleConfig: updateKPISettingsStyleConfig,
        updateKPISettingsValueStyleConfig: updateKPISettingsValueStyleConfig,
        updateKeyValueConfig: updateKeyValueConfig,
        updateStyleCombo: updateStyleCombo,
        updateKPIStyleCombo: updateKPIStyleCombo,
        updateChartSettingsColorConfig: updateChartSettingsColorConfig,
        //updateChartSettingsMenuItem: updateChartSettingsMenuItem,
        autoComputeDataDefaults:autoComputeDataDefaults,
        setModifiedInput : setModifiedInput,
        updateChartInputVals: updateChartInputVals,
        checkNumericValueInput : checkNumericValueInput,
        updateChartStyleCombos : updateChartStyleCombos,
        updateChartToggleVals: updateChartToggleVals,
        updateChartRangeList: updateChartRangeList,
        updateChartUnits: updateChartUnits,
        updateLegendOperation: updateLegendOperation,
        updateEditor: updateEditor,
        constructDataTab: constructDataTab,
        constructFiltersTab: constructFiltersTab,
        constructSettingsTab: constructSettingsTab,
        getPreviewConfig: getPreviewConfig,
        getDataColumnText: getDataColumnText,
        showPreview: showPreview,
        resetData: resetData,
        dataFetched: dataFetched,
        toggleJoinIcon: toggleJoinIcon
    };
};
