//$Id$

var WidgetEditor = new function ()
{

    this.editor = null;
    
    //WidgetEditorHolder
    this.initialize = function ()
    {
        if(!ZDBAnalysisView.joinInfoDIV)
        {
            ZDBAnalysisView.joinInfoDIV=   rem$("ZDBJoinInfoDlg");
            ZDBUtil.setNamedChildEls(ZDBAnalysisView.joinInfoDIV , ZDBAnalysisView.joinInfoDIV);
        }
        WidgetEditor.widgetEditorHolder = $("ZDBWigetEditor");
        ZDBAnalysisView.filterFieldTpl = (ZDBAnalysisView.filterFieldTpl) ? ZDBAnalysisView.filterFieldTpl : rem$("ZDBFilterFieldTpl");
        ZDBAnalysisView.funcMenuBox = (ZDBAnalysisView.funcMenuBox) ? ZDBAnalysisView.funcMenuBox : rem$("ZDBFuncMenuBox");
        ZDBAnalysisFuncMenu.funcMenuBox = ZDBAnalysisView.funcMenuBox;
    };

 //change in jointype will be made in duplicate view until apply button in editor is clicked
   this.joinTypeChange =function(element, event)
    {
        ZRJoinView.showJoinInfo(element, event, WidgetEditor.editor);
    };
    
    //display Widget Editor
    this.newWidget = function ()
    {
        var widgetEditor = WidgetEditor.getWidgetEditor();
        var view = WidgetEditor.constructView(widgetEditor);
        WidgetEditor.initEditor(widgetEditor, view);
        WidgetEditor.displayEditor(widgetEditor, view);
    };

    //reconstruct Widget Editor
    this.reConstructWidget = function (view) {
        view.editMode = true;
        var widgetEditor = WidgetEditor.getWidgetEditor();
        widgetEditor.view = view;
        view.initialize(widgetEditor);
        WidgetEditor.initEditor(widgetEditor, view);
        WidgetEditor.displayEditor(widgetEditor, view);
        WidgetEditor.setInstKeyToFormat()
        var clonedCurrentList = new Array();
        for(var i = 0; i < view.currentList.length; i++)
        {
        	var newObj = ZDBUtil.cloneObject(view.currentList[i]);
        	ZDBUtil.setNamedChildEls(newObj, newObj);
        	clonedCurrentList.push(newObj);
        }
        view.clonedCurrentList = clonedCurrentList;
        widgetEditor.functions.constructDataTab();
    };
    
    this.trackChangesForInput = function(el, key, callback){
    	var editor = WidgetEditor.editor;
    	editor.functions.setModifiedInput(key);
    	this[callback](el);
    };
    
    this.validateNumericInput = function(event, el){
    	WidgetEditor.editor.functions.checkNumericValueInput(event, el);
    };

    //clones holder and returns editor
    this.getWidgetEditor = function ()
    {
        var editor = WidgetEditor.widgetEditorHolder.cloneNode(true);
        editor.id = "WidgetWizard";
        editor.style.display = "";
        document.onkeyup = WidgetEditor.listenForKeyPress;
        editor.focus();
        return editor;
    };

    this.initEditor = function (editor, view) {
        ZDBUtil.setNamedChildEls(editor, editor, "WidgetData");//No I18N
        ZDBUtil.setNamedChildEls(editor, editor, "WidgetHolder");//No I18N
        ZDBUtil.setNamedChildEls(editor, editor, "formatInstKey");//No I18N
        ZDBUtil.setNamedChildEls(editor.data, editor.data, "divKey");//No I18N
        ZDBUtil.setNamedChildEls(editor.settings, editor.settings, "divKey");//No I18N
        ZDBUtil.setNamedChildEls(editor.templates, editor.templates, "chart");//No I18N
        ZDBUtil.setNamedChildEls(editor.wcharts, editor.wcharts, "wcharts");//No I18N
        this.editor = editor;
        view.curTab = 0;
        editor.view = view;
        editor.parentViewId = view.parentViewId;
        editor.type="WIDGET";
        editor.joinType=view.joinType;
        editor.changedJoinType=editor.joinType;
        editor.currentList = view.currentList;
        editor.zacf = view.zacf;
        editor.cinfo = WidgetUtils.clone(view.cinfo);
        editor.layout = parseInt(view.layout);
        editor.functions = WidgetEditUtils(editor);
        view.zacf.setPreview();
    };


    //constructs WidgetView
    this.constructView = function (viewComp)
    {
        var dashView = ZDBClientUI.selectedTab.view;
        return new WidgetView(ZDBClientUI.curDummyViewId--, dashView.editMode, dashView, viewComp);
    };

    //display the dialog util with holder
    this.displayEditor = function (el, view)
    {
        var tabHolder = ZDBGlobal.ISNEWLAYOUT ? $("ZRSTabHolder") : $("ZDBTabHolder");
        var top = tabHolder.offsetTop + tabHolder.offsetHeight;
        ZDBDialogUtil.showDialog(el, {
            TITLE: "KPI Widget Editor", //No I18N
            DONTREMOVE: false,
            ADDFRAME: true,
            MODAL: true,
            NOESC: true,
            TOP: top,
            ONCLOSE: WidgetEditor.closeEditor,
            view: view
        });
    };

    //before closeDialog invoked
    this.closeEditor = function (el, event)
    {
    	var editor = WidgetEditor.editor;
    	if (editor) {
    		editor.view.currentList = editor.view.clonedCurrentList;
    		editor.view.clonedCurrentList = null;
    		WidgetEditor.editor = null;
    	}
        document.onkeyup = null;
        var dialog = DOMUtils.getSelfOrParentWithAttrValue(el, "isdialog", "true");//NO I18N
        dialog.params.ONCLOSE = null;
        ZDBDialogUtil.closeDialog();
        ZDBDashEdit.getCurEditState().curDash.ondblclick = ZDBTxtIndicator.insertTxt;//$#Dash#$ Comment for New Layout
        WidgetEditor.closeList(event, false);
    };
    
    this.dateOperations = ["ABSQUARTER","ABSMONTH", "QUARTER", "MONTH", "WEEKDAY", "WEEK", "HOUR", "ABSWEEK", "DATE", "TIMESTAMP"]; // No I18N

    //Esc Key Hierarchy
    this.listenForKeyPress = function (event)
    {
        if (event.keyCode != 27)
        {
            return;
        }
        if (WidgetEditor.curList && event.keyCode == 27)
        {
            var comboBox = DOMUtils.getFirstMatchingChild(WidgetEditor.curList, "div", "comboBox", "true");//No I18N
            WidgetEditor.closeWidgetColList(WidgetEditor.curList, false);
            if (comboBox) //WIDGET#HACK#
            {
                comboBox.className = "inlinePropCombo widgetExtension";
            }
            return;
        }
        WidgetEditor.closeEditor(ZDBDialogUtil.focusDialog, event);
    };

    //switchtabs
    this.switchTab = function (el, event)
    {
        var editor = WidgetEditor.editor;
        var srcEl = ZDBUtil.getSourceElement(event);
        var className = srcEl.getAttribute('className');
        var tab = parseInt(srcEl.getAttribute('idx'));
        if (!className || isNaN(tab) || editor.view.curTab === tab || !WidgetEditor.editor.functions.canSwitchTabs())
        {
            return;
        }
        editor.view.curTab = tab;
        editor.tabHolder.setAttribute('class', className);
        switch (tab) {
            case 0:
                WidgetEditor.hideFilterFields(editor);
                WidgetEditor.editor.dataRight.scrollTop = WidgetEditor.editor.dataRight.scrollHeight;
                editor.functions.constructDataTab();
                break;
            case 1:
                WidgetEditor.fetchFilterFields(editor);
                editor.view.filterFields.style.display = '';
                break;
            case 2:
                WidgetEditor.hideFilterFields(editor);
                if (!editor.functions.isValidConfig(true)) {
                    ZDBUtil.stopEventBubble(event);
                    return;
                }
                editor.settings.setAttribute('class', 'widgetsettings floatLeft wcopiconmin');
                delete editor.showMoreOptions;
                if (editor.zacf.isModified()) {
                    editor.functions.resetData();
                }
                editor.functions.constructSettingsTab();
                if (!editor.functions.dataFetched()) {
                    WidgetFetcher.requestPreviewData(editor);
                }
                break;
        }
    };

    //re-construct Filters Tab
    this.constructFiltersTab = function ()
    {
        var view = WidgetEditor.editor.view;
        view.updateAddedFields();
        view.insertAddedFields(view);
    };

    //hide filter fields
    this.hideFilterFields = function (view)
    {
        var filterHolder = view.filterHolder;
        jQuery(filterHolder).animate({"left": "0px"}, 600);//NO I18N
        setTimeout(function () {
            WidgetEditor.killFilterFields(filterHolder);
        }, 250);
    };

    //remove filter fields from DOM
    this.killFilterFields = function (filterHolder)
    {
        var analysisel = DOMUtils.getFirstMatchingChild(filterHolder, "div", "analysisel", "attachedFieldsListEl"); //No I18N
        if (analysisel)
        {
            if (ZDBDialogUtil.focusDialog)
            {
                ZDBDialogUtil.focusDialog.dlgTitle.style.visibility = "";
            }
            filterHolder.removeChild(analysisel);
            filterHolder.setAttribute('class', 'displayNone');
        }
    };

    //fetch Filter Fields
    this.fetchFilterFields = function (view)//$$FIX
    {
        var dashFields = view.filterHolder;
        var analysisel = DOMUtils.getFirstMatchingChild(dashFields, "div", "analysisel", "attachedFieldsListEl");//No I18N
        if (analysisel)
        {
            return;
        }
        if (ZDBAnalysisCaching.isFieldsListCached["WIDGET"])
        {
            WidgetFetcher.constructFilterFields(view);
        }
        else
        {
            WidgetFetcher.sendWidgetRequest(1, view);
        }
    };

    //update filter drop area with dropped fields
    this.addFieldInFilter = function (element, event)
    {
        var field = element;
        if (field.getAttribute("column_id") === null)
        {
            field = DOMUtils.getParentWithAttr(field, "column_id");//No I18N
        }
        var view = ZDBClientUI.getViewObj(element, "view");//No I18N
        view.viewModified();
        var matchedFieldsInList = WidgetEditor.checkDuplicates(field, view);
        if (matchedFieldsInList !== false)
        {
            var fieldEl = matchedFieldsInList[0];
            var dropAreaTd = DOMUtils.getSelfOrParentWithAttrValue(fieldEl, "dropAreaTd", "true");//NO I18N
            ZDBAnalysisView.expandDropField(dropAreaTd);
            ZDBAnalysisView.removeFieldEl(fieldEl);
            element.className = "ZDBDNDFieldUncheck";
        }
        else
        {
            view.parentViewId = field.getAttribute("parent_obj_id");
            ZDBAnalysisView.enableDropFieldsExp(view);
            var grpField = ZDBAnalysisView.getGraphField(view, field, "FILTERAXIS", field.getAttribute("displayname"), false); //No I18N
            ZDBAnalysisFilter.setBestFilterFunction(grpField, view);
            view.addFieldToArea(grpField, view.dropAreas.FILTERAXIS);
            ZDBAnalysisFilter.selectFilterField(view, grpField);
            element.className = "ZDBDNDFieldChecked";
        }
    };

    //check Duplicate FILTER field in current list 
    this.checkDuplicates = function (el)
    {
        var field = el;
        var fieldCount = 0;
        var matchedFieldsInList = new Array();
        var editor = WidgetEditor.editor;
        var currentList = editor.currentList;
        var no_droppedFields = currentList.length;
        for (var i = 0; i < no_droppedFields; i++)
        {
            if (currentList[i].getAttribute("viewType") === "GROUP" || currentList[i].getAttribute("viewType") === "YAXIS") {
                continue;
            }
            var fieldExist = (field.getAttribute("column_id") === currentList[i].getAttribute("column_id"));
            if (fieldExist === true)
            {
                matchedFieldsInList[fieldCount] = currentList[i];
                fieldCount++;
            }
        }
        return (fieldCount > 0) ? matchedFieldsInList : false;
    };


    //Fetch Widget Columns List (GROUP AND YXIS)
    this.fetchFieldsFactory = function (el, event)
    {
        var view = ZDBClientUI.getViewObj(el, "view");//No I18N
        var srcEl = ZDBUtil.getSourceElement(event);
        var viewType = el.getAttribute("viewtype");
        hideCustomMessage();
        if (viewType !== 'GROUP' && WidgetEditor.showErrorDialog(view))
        {
            return;
        }
        do
        {
            if (!view.fetchedFields)
            {
                WidgetFetcher.sendWidgetRequest(0, view, el);
                break;
            }
            var widgetColList = DOMUtils.getSelfOrParentWithAttrValue(srcEl, "elName", "widgetColList");//NO I18N
            if (widgetColList)
            {
                var func = widgetColList.getAttribute("func");
                WidgetEditor[func](srcEl, event, viewType);
                break;
            }
            WidgetEditor.showWidgetFields(el, view);
        } while (false);
    };

    this.showChartFields = function (el, event) {
        var editor = WidgetEditor.editor;
        if (editor.functions.getYAxisColConfig('COLUMN_ID')) {
            WidgetEditor.showOperationList(el, event);
            return;
        }
        WidgetEditor.fetchFieldsFactory(el, event);
    };

    this.showLegendChartFields = function (el, event) {
        var editor = WidgetEditor.editor;
        if (!editor.functions.getYAxisColConfig('COLUMN_ID')) {
            WidgetEditor.showLegendConstantFields(el, event);
            return;
        }
        WidgetEditor.showOperationList(el, event);
    };
    
    this.togglePercentageInput = function(type){
    	var editor = WidgetEditor.editor;
    	var expandState = type + "expand";
    	var elName = type + "Perc";
    	var element = editor[elName]; 
    	if(editor[expandState]){
    		element.className = elName + " closed";
    		delete editor[expandState];
    		return;
    	}
    	element.className = elName + " expanded";
    	editor[expandState] = true;
    }
    
    this.hidePercentageInput = function(type, editor){
    	editor = editor ? editor : WidgetEditor.editor;
    	var expandState = type + "expand";
    	var elName = type + "Perc";
    	var element = editor[elName]; 
    	if(editor[expandState]){
    		element.className = elName + " closed";
    		delete editor[expandState];
    	}
    }
    
    this.showPercentageInput = function(type, editor){
    	editor = editor ? editor : WidgetEditor.editor;
    	var expandState = type + "expand";
    	var elName = type + "Perc";
    	var element = editor[elName]; 
    	if(!editor[expandState]){
    		element.className = elName + " expanded";
        	editor[expandState] = true;
    	}
    }
    
    

    this.showLegendConstantFields = function (el, event) {
        var editor = WidgetEditor.editor;
        var comboBox = DOMUtils.getFirstMatchingChild(el, "div", "comboBox", "true");//No I18N
        comboBox.className = "inlinePropComboSel widgetExtension";
        var menu = editor.operationMenu;
        ZDBUtil.setNamedChildEls(menu, menu, "OPERATION", false);//No I18N
        var prevSelected = menu.OPERATION;
        if (menu[prevSelected])
        {
            var classExtension = prevSelected + 'Opr';//NO I18N
            menu[prevSelected].setAttribute("class", "RefFilterList " + classExtension);
        }
        menu.CUSTOM.setAttribute("class", "RefFilterList");
        if (WidgetEditor.curList)
        {
            var curEl = WidgetEditor.curList;
            comboBox = DOMUtils.getFirstMatchingChild(WidgetEditor.curList, "div", "comboBox", "true");// No I18N
            WidgetEditor.closeWidgetColList(WidgetEditor.curList, false);
            comboBox.className = "inlinePropCombo widgetExtension";
            if (curEl === el)
            {
                return;
            }
        }
        var selectedOperation = editor.functions.getShowValueConfig('LEGEND').OPERATION;//NO I18N
        menu.CUSTOM.innerHTML = editor.functions.getDataColumnText();
        if (selectedOperation !== 'CONSTANT') {
            menu.CUSTOM.setAttribute("class", "RefFilterListSelected");
        } else {
            menu.CONSTANT.setAttribute("class", "RefFilterListSelected");
        }
        menu.OPERATION = selectedOperation;
        WidgetEditor.curList = el;
        WidgetEditor.curList.fieldsList = editor.operationMenu;
        menu.style.display = "block";
        editor.operationMenu.scrollTop = 0;
        menu.style.height = '';
        el.appendChild(menu);
        WidgetEditor.setOperationListPos(el, menu);
        ZDBUtil.attachEvent(document, "click", WidgetEditor.closeList, false);
    };

    //display Widget Columns List;
    this.showWidgetFields = function (el, view, byPass)
    {
        ComboFunctions.clearSearch(view.fieldsList);//$WORKHERE
        WidgetEditor.hideSubFuncList();
        var comboBox = null;
        if (WidgetEditor.curList && !byPass)
        {
            var curEl = WidgetEditor.curList;
            comboBox = DOMUtils.getFirstMatchingChild(WidgetEditor.curList, "div", "comboBox", "true");//No I18N
            WidgetEditor.closeWidgetColList(WidgetEditor.curList, false);
            comboBox.className = "inlinePropCombo widgetExtension";
            if (curEl === el)
            {
                return;
            }
        }
        comboBox = DOMUtils.getFirstMatchingChild(el, "div", "comboBox", "true");//No I18N
        comboBox.className = "inlinePropComboSel widgetExtension";
        var fieldsList = view.fieldsList;
        el.fieldsList = fieldsList;
        fieldsList.style.display = "block";
        WidgetEditor.filterTablesAndColums(view, el);
        var cinfo = WidgetEditor.editor.cinfo;
        var viewType = el.getAttribute("viewtype");
        var selectedCol = (cinfo.COLUMNS[viewType]) ? cinfo.COLUMNS[viewType].COLUMN_ID : '';
        var showValOperation = cinfo.SHOWVALUEAS[viewType] ? cinfo.SHOWVALUEAS[viewType].OPERATION : '';
        fieldsList.none.setAttribute('class', 'RefFilterList');
        fieldsList.constant.setAttribute('class', 'RefFilterList');
        if (selectedCol != '') {
            fieldsList.COLUMNIDS[selectedCol].setAttribute('class', 'RefFilterListSelected');
        } else if ((viewType === 'TEXTAXIS' || viewType === 'THRESHOLD') && showValOperation !== 'NONE') {//NO I18N
            fieldsList.constant.setAttribute('class', 'RefFilterListSelected');
        } else {
            fieldsList.none.setAttribute('class', 'RefFilterListSelected');
        }
//        fieldsList.none.style.display = 'none';
//        var layout = WidgetEditor.editor.layout;
//        if ((layout == 1 || layout > 6) && viewType === 'YAXIS')
//        {
//            fieldsList.none.style.display = '';
//        }
        fieldsList.scrollTop = 0;
        WidgetEditor.setOperationListPos(el, fieldsList);
        el.appendChild(fieldsList);
        WidgetEditor.curList = el;
        ZDBUtil.attachEvent(document, 'click', WidgetEditor.closeList, true);
    };

    this.tableExpandContract = function (tableList, srcTable, searchStr)
    {
        var toExpand = srcTable.getAttribute("expand") === "true";
        var tableToHide = DOMUtils.getFirstMatchingElement(tableList, null, "expand", "true");//No I18N
        WidgetEditor.ExpandOrContract(srcTable, !toExpand, true);
        if (!tableToHide || searchStr || tableToHide === srcTable)
        {
            return;
        }
        WidgetEditor.ExpandOrContract(tableToHide, false, true);
    };

    this.ExpandOrContract = function (table, toExpand)
    {
        table.style.display = '';
        var funcMenuBox = DOMUtils.getFirstMatchingChild(table, "ul");//No I18N
        var display = (toExpand) ? "block" : "none";//No I18N
        var css = (toExpand) ? "RefFilterTbl refListExpand" : "RefFilterTbl";//No I18N
        funcMenuBox.style.display = display;
        table.setAttribute('class', css);
        table.setAttribute("expand", toExpand);
    };

    //contract or expand tables
    this.listExpandContract = function (list, toggleSelection)
    {

        for (var i = 0; i < list.length && list[i]; i++)
        {
            var table = list[i];
            table.style.display = "";
            var expandProp = table.getAttribute("expand") === "true";
            var funcMenuBox = DOMUtils.getFirstMatchingChild(table, "ul");//No I18N
            expandProp = (toggleSelection) ? !expandProp : expandProp;
            var display = (expandProp) ? "block" : "none";//No I18N
            var css = (expandProp) ? "RefFilterTbl refListExpand" : "RefFilterTbl";//No I18N
            funcMenuBox.style.display = display;
            table.setAttribute('class', css);
            table.setAttribute("expand", expandProp);

        }
    };

    //show only parent and related tables
    this.filterTablesAndColums = function (view, holderDiv, searchStr)
    {
        var editor = WidgetEditor.editor;
        var tableList = view.fieldsList.tableList;
        var viewType = holderDiv.getAttribute("viewtype");
        var makeAllTrue = viewType === "GROUP";//NO I18N
        var isZCViewType = (viewType !== "GROUP" && viewType !== "YAXIS");//NO I18N
        var dateAlone = editor.layout > 3 && editor.layout < 7;
        var includeNone = true;
        if (view.fieldsList.none && !makeAllTrue && editor.layout == 1)
        {
            includeNone = false;
            view.fieldsList.none.style.display = 'block';
            if ('none'.indexOf(searchStr) == -1)
            {
                view.fieldsList.none.style.display = 'none';
                includeNone = true;
            }
        }
        return WidgetEditor.filterFieldsTable(tableList, WidgetEditor.editor.parentViewId, dateAlone, makeAllTrue, searchStr, isZCViewType) && includeNone;
    };


    //filter only parent and related tables
    this.filterFieldsTable = function (list, value, dateAlone, makeAllTrue, searchStr, isZCViewType)
    {
        var listCount = 0;
        var listLength = list.length;
        var relTblsId = '[ ]';
        var currentMatched;
        var toExpand;
        var firstMatch;
        for (var i = 0; i < listLength; i++)
        {
            var tableId = list[i].getAttribute('tableId');
            var parentTbl = tableId === value;
            if (parentTbl)
            {
                relTblsId = list[i].getAttribute("relTblsId")
                break;
            }
        }
        for (var i = 0; i < listLength; i++)
        {
            var tableId = list[i].getAttribute('tableId');
            currentMatched = false;
            if (relTblsId.indexOf(tableId) > -1 || makeAllTrue || tableId === value)
            {
            	if (WidgetEditor.filterTableList(list[i], searchStr, makeAllTrue)) {
            		toExpand = (tableId === value || listLength == 1) ? true : false;                    
                    currentMatched = true;
            	}
            	else if ((!WidgetEditor.filterSubList(list[i], dateAlone, makeAllTrue || isZCViewType, searchStr)))
            	{
                    toExpand = (searchStr || tableId === value || listLength == 1) ? true : false;
                    currentMatched = true;
                }
            }
            if (currentMatched) {
            	WidgetEditor.ExpandOrContract(list[i], toExpand, searchStr);
            	listCount++;
            	if (!firstMatch) {
            		firstMatch = list[i];
            	}
            } else {
            	list[i].style.display = "none";
            }
        }
        if (listCount == 1) {
        	WidgetEditor.ExpandOrContract(firstMatch, true, searchStr);
        }
        return listCount == 0;
    };
    
    this.filterTableList = function (funcMenuBox, searchStr, makeAllTrue)
    {
    	var tableName = funcMenuBox.firstElementChild.getAttribute("value").toLowerCase();
    	var strcmp = (!searchStr && makeAllTrue) || tableName.indexOf(searchStr) != -1;
    	if (strcmp) {
    		var lis = funcMenuBox.getElementsByTagName("li");
    	    for (var i = 0; i < lis.length; i++)
            {
    	    	lis[i].style.display = "";
    	    	var cssName = (searchStr) ? lis[i].getAttribute('class') : 'RefFilterList';//NO I18N
    	    	lis[i].setAttribute('class', cssName);
            }
    		return true;
    	} else {
    		return false;
    	}
    }


    //filter tablelist columns based on YAXIS, ABSDATECATEGORICAL, AGG_FORMULA, NUMBER etc
    this.filterSubList = function (funcMenuBox, dateAlone, makeAllTrue, searchStr)
    {
        var lis = funcMenuBox.getElementsByTagName("li");
        var allNone = true;
        for (var i = 0; i < lis.length; i++)
        {
            var colName = lis[i].getAttribute('colname').toLowerCase();//No I18N
            var strcmp = !searchStr || colName.indexOf(searchStr) != -1;
            var yAxisLimit = (!dateAlone && lis[i].getAttribute("addontype") !== "NUMBER" || dateAlone && lis[i].getAttribute("addontype") === "ABSDATECATEGORICAL");//No I18N
            if (!strcmp)
            {
                lis[i].style.display = "none";
            }
            else if (makeAllTrue || yAxisLimit)
            {
                lis[i].style.display = "";
                var cssName = (searchStr) ? lis[i].getAttribute('class') : 'RefFilterList';//NO I18N
                lis[i].setAttribute('class', cssName);
                allNone = false;
            }
            else
            {
                lis[i].style.display = "none";
            }
        }
        return allNone;
    };

    //closes any dispalyed combo box
    this.closeList = function (event, iskeypress)
    {
        if (!iskeypress)
        {
            var tarEl = event ? ZDBUtil.getSourceElement(event) : null;
            var tblExpEl = tarEl ? DOMUtils.getSelfOrParentWithAttrValue(tarEl, "dontClose", "true") : null;//NO I18N
            if (tblExpEl !== null)
            {
                return;
            }
        }
        if (ZDBColorPalette.isOpen)
        {
            return;
        }
        var curList = WidgetEditor.curList;
        if (curList)
        {
            var comboBox = DOMUtils.getFirstMatchingChild(curList, "div", "comboBox", "true");//No I18N
            if (curList.fieldsList)
            {
                WidgetEditor.clearWidgetColList(curList.fieldsList);
                var className = (curList.kill) ? "inlinePropCombo" : "inlinePropCombo widgetExtension";//No I18N
                WidgetEditor.closeWidgetColList(curList, curList.kill);
                if (comboBox)
                {
                    comboBox.className = className;
                }
            }
        }
        WidgetEditor.hideSubFuncList();
        hideCustomMessage();
        ZDBUtil.detachEvent(document, 'click', WidgetEditor.closeList, true);
        ZDBUtil.detachEvent(document, 'click', WidgetEditor.closeList, false);
    };

    //clear Widget Columns List Input boxes   
    this.clearWidgetColList = function (widgetColList)
    {
        var searchBox = DOMUtils.getFirstMatchingChild(widgetColList, "input", "id", "rankingsearchFormTxtFld");//No I18N 
        if (!searchBox)
        {
            return;
        }
        var searchForm = DOMUtils.getFirstMatchingChild(widgetColList, "div", "id", "rankingsearchForm_clone");//No I18N 
        var jQsearchForm = jQuery(searchForm);
        var searchInput = jQsearchForm.find('input');
        searchInput.val("");
        searchInput.attr('tipshown', 'false');//NO I18N
        ZDBSearchUtil.handleBlur(searchBox);
    };

    // closes or removes Widget Columns list
    this.closeWidgetColList = function (el, remEl)
    {
        var fieldsList = el.fieldsList;
        fieldsList.style.display = "none";
        if (remEl)
        {
            fieldsList.parentNode.removeChild(fieldsList);
        }
        WidgetEditor.curList = null;
    };

    //displays KPI select Icon Combo settings tab
    this.showKPIDialog = function (el)
    {
        var editor = WidgetEditor.editor;
        if (!editor.functions.canCustomizeKPISettings()) {
            return;
        }
        var holder = DOMUtils.getParentWithAttrValue(el, "holder", "true");//NO I18N
        var kpiComp = editor.kpiComp;
        el.className = "inlinePropComboSel";
        if (WidgetEditor.curList)
        {
            var curEl = WidgetEditor.curList;
            el = DOMUtils.getFirstMatchingChild(curEl, "div", "comboBox", "true");// No I18N
            WidgetEditor.closeWidgetColList(curEl, false);
            el.className = "inlinePropCombo";
            if (curEl === holder)
            {
                return;
            }
        }
        holder.appendChild(kpiComp);
        WidgetEditor.editor.functions.updateKPIStyleCombo(holder);
        WidgetEditor.curList = holder;
        WidgetEditor.curList.fieldsList = kpiComp;
        kpiComp.style.display = "block";
        kpiComp.scrollTop = 0;
        WidgetEditor.setOperationListPos(holder, kpiComp);
        ZDBUtil.attachEvent(document, "click", WidgetEditor.closeList, false);
    };

    this.updateKPIShowValue = function (el)
    {
        WidgetEditor.editor.functions.updateKPIShowValueConfig(el);
    };

    //displays show value as combo box data tab
    this.showOperationList = function (el, event)
    {
        var editor = WidgetEditor.editor;
        var position = el.getAttribute("position");
        if (!editor.functions.canCustomizeShowVals(position))
        {
            return;
        }
        var comboBox = DOMUtils.getFirstMatchingChild(el, "div", "comboBox", "true");//No I18N
        comboBox.className = "inlinePropComboSel widgetExtension";
        var menu = editor.operationMenu;
        ZDBUtil.setNamedChildEls(menu, menu, "OPERATION", false);//No I18N
        var prevSelected = menu.OPERATION;
        if (menu[prevSelected])
        {
            var classExtension = prevSelected + 'Opr';//NO I18N
            menu[prevSelected].setAttribute("class", "RefFilterList " + classExtension);
        }
        if (WidgetEditor.curList)
        {
            var curEl = WidgetEditor.curList;
            comboBox = DOMUtils.getFirstMatchingChild(WidgetEditor.curList, "div", "comboBox", "true");// No I18N
            WidgetEditor.closeWidgetColList(WidgetEditor.curList, false);
            comboBox.className = "inlinePropCombo widgetExtension";
            if (curEl === el)
            {
                return;
            }
        }
        var baseOperation = editor.functions.getGroupColConfig('OPERATION');//NO I18N
        var selAddOnType = editor.functions.getYAxisColConfig('ADDONTYPE');//NO I18N
        var viewType = el.getAttribute("WidgetData");
        var cssName = 'widgetColList widgetBox enable' + selAddOnType + 'Menu ' + 'disable' + baseOperation + 'Opr ' + viewType; //No I18N
        menu.setAttribute('class', cssName);
        var positionKey = el.getAttribute("positionKey");
        var posInfo = editor.functions.getShowValueConfig(position);
        var selectedOperation = (posInfo) ? posInfo[positionKey] : (editor.layout > 6) ? 'CONSTANT' : 'None';// No I18N
        if (menu[selectedOperation])
        {
            menu[selectedOperation].setAttribute("class", "RefFilterListSelected");
        }
        menu.OPERATION = selectedOperation;
        WidgetEditor.curList = el;
        WidgetEditor.curList.fieldsList = editor.operationMenu;
        menu.style.display = "block";
        editor.operationMenu.scrollTop = 0;
        menu.style.height = '';
        el.appendChild(menu);
        WidgetEditor.setOperationListPos(el, menu);
        ZDBUtil.attachEvent(document, "click", WidgetEditor.closeList, false);
    };

    this.showChartsUnitsMenu = function (el) {//$$CLEAN-UPS$$
        var editor = WidgetEditor.editor;
        var position = el.getAttribute("position");
        if (!editor.functions.canCustomizeChartUnits(position)) {
            return;
        }
        var comboBox = DOMUtils.getFirstMatchingChild(el, "div", "comboBox", "true");//No I18N
        comboBox.className = "inlinePropComboSel widgetExtension";
        var menu = editor.operationMenu;
        ZDBUtil.setNamedChildEls(menu, menu, "unitsIdx", false);//No I18N
        var prevSelected = menu.OPERATION;
        if (menu[prevSelected])
        {
            var classExtension = prevSelected + 'Opr';//NO I18N
            menu[prevSelected].setAttribute("class", "RefFilterList " + classExtension);
        }
        if (WidgetEditor.curList)
        {
            var curEl = WidgetEditor.curList;
            comboBox = DOMUtils.getFirstMatchingChild(WidgetEditor.curList, "div", "comboBox", "true");// No I18N
            WidgetEditor.closeWidgetColList(WidgetEditor.curList, false);
            comboBox.className = "inlinePropCombo widgetExtension";
            if (curEl === el)
            {
                return;
            }
        }
        var key = el.getAttribute('key');
        var unitsIdx = (key ? editor.cinfo.KEYVALMAP[key] : editor.functions.getShowValueConfig(position).UNIT) || '0';
        menu[unitsIdx].setAttribute("class", "RefFilterListSelected");
        menu.OPERATION = unitsIdx;
        WidgetEditor.curList = el;
        WidgetEditor.curList.fieldsList = editor.operationMenu;
        menu.style.display = "block";
        editor.operationMenu.scrollTop = 0;
        menu.style.height = '';
        el.appendChild(menu);
        WidgetEditor.setOperationListPos(el, menu);
        ZDBUtil.attachEvent(document, "click", WidgetEditor.closeList, false);
    };

    this.setChartUnits = function (event) {
        var srcEl = ZDBUtil.getSourceElement(event);
        var holder = DOMUtils.getSelfOrParentWithAttrValue(srcEl, 'holder', 'true');//NO I18N
        if (holder.getAttribute('key')) {
            WidgetEditor.editor.functions.updateChartUnits(srcEl, holder);
        } else {
            var value = srcEl.getAttribute('unitsIdx');
            WidgetEditor.editor.functions.updateChartShowValConfig(holder, value);
        }
        WidgetEditor.closeList(event, true);
        ZDBUtil.stopEventBubble(event);
    };

    this.setLegendOperation = function (event) {
        var srcEl = ZDBUtil.getSourceElement(event);
        var holder = DOMUtils.getSelfOrParentWithAttrValue(srcEl, 'holder', 'true');//NO I18N
        WidgetEditor.editor.functions.updateLegendOperation(srcEl, holder);
        WidgetEditor.closeList(event, true);
        ZDBUtil.stopEventBubble(event);
    };

    this.showTargetStyleMenu = function (el) {//$$CLEAN-UPS$$
        var editor = WidgetEditor.editor;
        var comboBox = DOMUtils.getFirstMatchingChild(el, "div", "comboBox", "true");//No I18N
        comboBox.className = "inlinePropComboSel widgetExtension";
        var menu = editor.targetStyleMenu;
        if (WidgetEditor.curList)
        {
            var curEl = WidgetEditor.curList;
            comboBox = DOMUtils.getFirstMatchingChild(WidgetEditor.curList, "div", "comboBox", "true");// No I18N
            WidgetEditor.closeWidgetColList(WidgetEditor.curList, false);
            comboBox.className = "inlinePropCombo widgetExtension";
            if (curEl === el)
            {
                return;
            }
        }
        WidgetEditor.curList = el;
        WidgetEditor.curList.fieldsList = menu;
        menu.style.display = "block";
        editor.operationMenu.scrollTop = 0;
        menu.style.height = '';
        el.appendChild(menu);
        WidgetEditor.setOperationListPos(el, menu);
        ZDBUtil.attachEvent(document, "click", WidgetEditor.closeList, false);
    };

    this.showNeedleStyleMenu = function (el) {//$$CLEAN-UPS$$
        var editor = WidgetEditor.editor;
        var comboBox = DOMUtils.getFirstMatchingChild(el, "div", "comboBox", "true");//No I18N
        comboBox.className = "inlinePropComboSel widgetExtension";
        var menu = editor.needleStyleMenu;
        if (WidgetEditor.curList)
        {
            var curEl = WidgetEditor.curList;
            comboBox = DOMUtils.getFirstMatchingChild(WidgetEditor.curList, "div", "comboBox", "true");// No I18N
            WidgetEditor.closeWidgetColList(WidgetEditor.curList, false);
            comboBox.className = "inlinePropCombo widgetExtension";
            if (curEl === el)
            {
                return;
            }
        }
        WidgetEditor.curList = el;
        WidgetEditor.curList.fieldsList = menu;
        menu.style.display = "block";
        editor.operationMenu.scrollTop = 0;
        menu.style.height = '';
        el.appendChild(menu);
        WidgetEditor.setOperationListPos(el, menu);
        ZDBUtil.attachEvent(document, "click", WidgetEditor.closeList, false);
    };

    this.setChartSettingsMenuItem = function (el, event) {
        var holder = DOMUtils.getSelfOrParentWithAttrValue(el, 'holder', 'true');//NO I18N
        var srcEl = ZDBUtil.getSourceElement(event);
//        var valueDiv = DOMUtils.getSelfOrParentWithAttr(srcEl, 'value');//NO I18N
//        WidgetEditor.editor.functions.updateChartSettingsMenuItem(srcEl, holder);
    };

    this.setOperationListPos = function (holderDiv, menu)
    {
        var comboDiv = DOMUtils.getFirstMatchingChild(holderDiv, '*', 'combobox', 'true');
        var comboDivPos = ZDBUtil.getElementAbsolutePos(comboDiv);
        var absolutePosition = comboDivPos.y - ZDBUtil.getElementAbsolutePos(ZDBDialogUtil.focusDialog.dlgBody).y;
        var childTop = absolutePosition + comboDiv.offsetHeight;
        var menuHeight = menu.offsetHeight;
        var heightDiff = WidgetEditor.calcHeightDiff(comboDivPos.y + comboDiv.offsetHeight, menu.offsetHeight, 0);
        if (heightDiff > 0) {
            childTop = absolutePosition - menuHeight;
            menu.style.borderTopWidth = '1px';//No I18N
            menu.style.borderBottomWidth = '0px';//No I18N
        } else {
            menu.style.borderTopWidth = '0px';//No I18N
            menu.style.borderBottomWidth = '1px';//No I18N
        }
        menu.style.top = childTop + 'px';//No I18N
    };

    //onclick to select showvalueas combo 
    this.operationSelect = function (el, event)//revisit
    {
        var srcEl = ZDBUtil.getSourceElement(event);
        var operation = srcEl.getAttribute('OPERATION') || DOMUtils.getParentWithAttrValue(srcEl, "selection", "true").getAttribute('OPERATION');//NO I18N
        var holderDiv = DOMUtils.getParentWithAttrValue(srcEl, "holder", "true");//No I18N
        WidgetEditor.editor.functions.updateShowValConfig(holderDiv, operation);
        if(WidgetEditor.editor.cinfo.COLUMNS.GROUP && operation !== "CONSTANT" ){//No I18N
        	WidgetEditor.editor.functions.autoComputeDataDefaults();
        }
    };
    
    this.setInstKeyToFormat = function(instKey)
    {
    	if(instKey == null)
    	{
	    	if(WidgetEditor.editor.cinfo.COLUMNS.YAXIS != null)
	    	{
	    		instKey = WidgetEditor.editor.cinfo.COLUMNS.YAXIS.INSTKEY;    		
	    	}
	    	else
	    	{
	    		return;
	    	}
	    }
    	WidgetEditor.editor.yAxisInst.setAttribute("instKey", instKey);
    }

    this.updateKPIConstantVal = function (el)
    {
        WidgetEditor.editor.functions.updateKPIShowValueConstant(el);
    };

    this.showSubFunMenu = function (el, event)//$$HACK_LINE->4
    {
        var funcMenuBox = ZDBAnalysisView.funcMenuBox;
        var holderDiv = DOMUtils.getParentWithAttrValue(el, "holder", "true");//No I18N
        var viewType = holderDiv.getAttribute("viewtype");
        var menuViewType = (viewType !== 'YAXIS') ? 'GROUP' : viewType;//NO I18N
        var dType = el.getAttribute("addontype");
        var fieldType = el.getAttribute("FIELD_COL_TYPE");
        var allowedOperations = holderDiv.getAttribute(dType);
        if (funcMenuBox.prevEl)
        {
            jQuery(funcMenuBox.prevEl).removeClass('RefFilterList_hover');
        }
        funcMenuBox.prevEl = el;
        if (viewType === 'YAXIS' && dType !== "ABSDATECATEGORICAL" || fieldType === '0')
        {
            WidgetEditor.hideSubFuncList();
            return;
        }
        var view = ZDBClientUI.getViewObj(el, "view");//No I18N
        if (menuViewType == "GROUP" && dType == "ABSDATECATEGORICAL")
        {
            dType = "SUMMARY_ABSDATECATEGORICAL"; // NO I18N
        }
        ZDBUtil.setNamedChildEls(funcMenuBox, funcMenuBox);
        var tds = funcMenuBox.menuTable.getElementsByTagName("a");
        jQuery(el).addClass('RefFilterList_hover');
        var curColDet = WidgetEditor.editor.cinfo.COLUMNS[viewType];
        var selectedCol = !curColDet || el.getAttribute("COLID") === curColDet.COLUMN_ID;
        var currentOperation = (curColDet) ? curColDet.OPERATION : null;
        for (var i = 0, j = tds.length; i < j; i++)
        {
            var allowedAxis = (tds[i].getAttribute("ALLOWEDAXIS"));
            var showFunction = (tds[i].getAttribute("ADDONTYPE") == dType)
                    && ((allowedOperations == null) || (allowedOperations.indexOf(tds[i].getAttribute("OPERATION")) != -1))
                    && ((allowedAxis == null) || (allowedAxis.indexOf(menuViewType) != -1));
            tds[i].parentNode.style.display = showFunction ? ZDBUtil.visibleTrStyle : "none";
            var operation = tds[i].getAttribute("OPERATION")
            tds[i].removeAttribute("SHOWSUBMENU");
            var ticker = jQuery(tds[i]).siblings("span[elname='ZRSTicker']")[0];
            if (selectedCol && currentOperation && showFunction && operation === currentOperation)
            {
                ticker.className = "ZRSTicker";
            }
            else
            {
                ticker.className = "";
            }
            ZDBUtil.setNamedChildEls(tds[i], tds[i]);
            var funcDiv = tds[i].funcDiv;
            if (funcDiv != null)
            {
                funcDiv.className = '';
            }
        }
        funcMenuBox.view = view;
        jQuery(funcMenuBox).find('a').not("[OPERATION='DUMMY'],[ISONLYFORCHART='true']").css("padding-left", "25px");//NO I18N
        WidgetEditor.positionFuncMenu(el, holderDiv, funcMenuBox, view);
        funcMenuBox.positioned = true;
        if (!event)
        {
            event = new MouseEvent("mousemove");//NO I18N
        }
        ZRSMenu.showMenu(event, el, funcMenuBox, 3);
    };

    this.positionFuncMenu = function (el, holderDiv, funcMenuBox, view)
    {
        document.body.appendChild(funcMenuBox);
        funcMenuBox.style.display = "block";
        var absolutePosition = ZDBUtil.getElementAbsolutePos(el);
        var top = absolutePosition.y - WidgetEditor.calcHeightDiff(absolutePosition.y, funcMenuBox.offsetHeight, 5);
        var left = absolutePosition.x + el.offsetWidth;
        funcMenuBox.style.left = left + 'px';
        funcMenuBox.style.top = top + 'px';
        funcMenuBox.style.display = "none";
    };

    this.calcHeightDiff = function (top, height, force)
    {
        var heightDiff = 0;
        if (window.innerHeight < top + height)
        {
            heightDiff = top + height - window.innerHeight + force;
        }
        return heightDiff;
    };

    this.hideSubFuncList = function ()
    {
        var funcMenuBox = ZDBAnalysisView.funcMenuBox;
        if (!funcMenuBox)
        {
            return;
        }
        jQuery(funcMenuBox.prevEl).removeClass('RefFilterList_hover');
        funcMenuBox.style.display = "none";
    };

    this.validateCinfo = function (el, viewType)
    {
        var editor = WidgetEditor.editor;
        var functions = editor.functions;
        var funcMenuBox = ZDBAnalysisView.funcMenuBox;
        funcMenuBox.style.display = "none";
        var srcEl = DOMUtils.getSelfOrParentWithAttr(el, "colid") || DOMUtils.getSelfOrParentWithAttr(el, "operation");  //NO I18N
        if (!viewType) {
            var holderDiv = DOMUtils.getSelfOrParentWithAttrValue(funcMenuBox.prevEl, "holder", "true");//NO I18N
            viewType = holderDiv.getAttribute("viewtype");
        }
        if (!srcEl)
        {
            srcEl = DOMUtils.getSelfOrParentWithAttr(el, 'value');//NO I18N
            if (srcEl && srcEl.getAttribute('value') === 'NONE')
            {
                functions.updateColumnConfig(srcEl, null, viewType);
                if((viewType === "THRESHOLD" || viewType === "TEXTAXIS") ? WidgetEditor.editor.cinfo.COLUMNS[viewType] : true){
                	editor.functions.autoComputeDataDefaults(true);
                }
                return true;
            }
            return false;
        }
        var colNode = funcMenuBox.prevEl.cloneNode(true);
        functions.updateColumnConfig(srcEl, colNode, viewType);
    	if((viewType === "THRESHOLD" || viewType === "TEXTAXIS") ? WidgetEditor.editor.cinfo.COLUMNS[viewType] : true){
    		editor.functions.autoComputeDataDefaults(true);
        }
        return true;
    };

    this.setColFunDet = function (el, event, viewType)
    {
        var editor = WidgetEditor.editor;
        var view = editor.view;
        if (WidgetEditor.validateCinfo(el, viewType))
        {
            if (viewType === 'GROUP' || viewType === 'YAXIS') {
                view.zacf.reset();
            }
            view.setModified();
            WidgetEditor.closeList(event, true);
            ZDBUtil.stopEventBubble(event);
        }
    };

    this.setColumnRangeConfig = function (el, event) {
        var holderDiv = DOMUtils.getSelfOrParentWithAttrValue(el, "holder", "true");//NO I18N
        WidgetEditor.editor.functions.updateColumnRangeConfig(holderDiv.getAttribute('viewType'));
        WidgetEditor.closeList(event, true);
        ZDBUtil.stopEventBubble(event);
    };

    this.setColumnConfigNone = function (el, event) {
        var holderDiv = DOMUtils.getSelfOrParentWithAttrValue(el, 'holder', 'true');//NO I18N
        var viewType = holderDiv.getAttribute('viewType');
        if (viewType === 'GROUP' || viewType === 'YAXIS' || el.getAttribute('value') !== 'NONE') {
            return;
        }
        ZDBUtil.stopEventBubble(event);
        WidgetEditor.closeList(event, true);
        WidgetEditor.editor.functions.updateZCColumnConfigNone(viewType);
    };

    this.constructWidget = function ()
    {
        var editor = WidgetEditor.editor;
        if (!editor.functions.isValidConfig(true)) {
            ZDBUtil.stopEventBubble();
            return;
        }
        editor.view.clonedCurrentList = null;
        this.editor = null;
        var i = 0;
        var currentList = editor.currentList;
        while (i < currentList.length)
        {
        	if (currentList[i].getAttribute('viewtype') === 'FILTERAXIS' && currentList[i].getAttribute('criteria') === "")
        	{
        		currentList.splice(i, 1);
        	}
        	else
        	{
        		i++;
        	}
        }
        var view = editor.view;
        view.currentList = editor.currentList;
        view.cinfo = editor.cinfo;
        view.parentViewId = editor.parentViewId;
        view.joinType=editor.joinType;
        view.layout = parseInt(editor.cinfo.LAYOUT);
        view.renderer = editor.renderer;
        view.zacf.unSetPreview();
        var curEl = WidgetEditor.getWidgetDashChild(view);
        view.setModified();
        WidgetUtils.fetchView(view.objId, curEl.ctx);
        delete editor.renderer;
        ZDBDialogUtil.closeDialog(null);
    };
    
    this.constructWidget_new = function (el, event)
    {
        var view = ZDBClientUI.getViewObj(el, "view");//No I18N
        var isValidKPIConfig = (view.KPISYMBOLINPUT.checked || view.KPIVALUEINPUT.checked)
        if (!view.cinfo.COLUMNS.GROUP || view.layout !== 1 && !view.cinfo.COLUMNS.YAXIS) {
            return;
        } else if(view.layout > 3 && !isValidKPIConfig) {
            view.widgetClassHolder.setAttribute('class', 'widgetsettingstabselected floatRight');
            hideCustomMessage();
            showCustomMessage('Select Atleast one checkbox', view.SETTINGS.kpi); //NO I18N
            return;
        }
        view.applyoldcinfo = true;
        var curEl = WidgetEditor.getWidgetDashLayoutChild(view);
        WidgetUtils.fetchView(view.objId, curEl.ctx);
        ZDBDialogUtil.closeDialog(null);
    };
    
    this.getWidgetDashLayoutChild = function(view){
    	if (view.viewCtx && view.viewCtx.dashChildDiv)
        {
            return view.viewCtx.dashChildDiv;
        }
    	var dashboard = view.dashView;
    	var widgetLayer = ZRDashboardLayoutAPI.getWidgetLayer(dashboard);
    	widgetLayer.dashChild.view = view;
    	widgetLayer.parentEl.view = view;
    	widgetLayer.viewId = view.objId;
    	widgetLayer.pvId = view.parentViewId;
    	var viewCtx = new ZDBDashboardCtx(dashboard, widgetLayer.dashChild, widgetLayer.parentEl);
    	widgetLayer.parentEl.innerViewCtx = viewCtx;
    	view.viewCtx = viewCtx;
    	view.layer = widgetLayer;
    	return widgetLayer.dashChild;
    }

    this.getWidgetDashChild = function (view, width, height, selectedEl)
    {
        if (view.viewCtx && view.viewCtx.dashChildDiv)
        {
            return view.viewCtx.dashChildDiv;
        }
        var curEl = ZDBDPlacer.createDummyChild(false);
        var parDiv = curEl.dlgBody;
        parDiv.style.height = '40px';
        curEl.view = view;
        parDiv.view = view;
        var viewCtx = new ZDBDashboardCtx(view.dashView, curEl, parDiv);
        parDiv.innerViewCtx = viewCtx;
        view.viewCtx = viewCtx;
        WidgetEditor.updateCurEditState(curEl, selectedEl);
        ZDBDPlacer.addNewChild(curEl);
        var totalWidth = view.dashView.dashDiv.clientWidth;
        ZDBDPlacer.resizeParentNode(curEl, totalWidth, false);
        ZDBDPlacer.resizeContentArea(curEl, true, totalWidth / 2);
        if(!selectedEl){
        	view.dashView.dashDiv.scrollTop = 0;	
        }
        
        curEl.isNewView = true;
        view.dashView.incrementNewWidgetsWaitingForFirstResponse();
        
//        if (view.layout > 6) {
            ZDBUtil.setNamedChildEls(curEl, curEl);
            curEl.dlgBody.style.width = width ? (width + "px") : "150px";
//            switch(view.layout){
//            	case 7 :
//            		curEl.dlgBody.style.height = "120px";
//            		break;
//            	case 8:
//            		curEl.dlgBody.style.height = "120px";
//            		break;
//            }
            curEl.dlgBody.style.height = height ? (height + "px") :"120px";
//        }
        return curEl;
    };

    this.updateCurEditState = function (curEl, selectedEl)//understand y
    {
        var cur = ZDBDashEdit.getCurEditState();
        cur.isExpanded = false;
        cur.curObjEl = curEl;
        cur.selColIdx = 0;
        cur.curSelEl = selectedEl || cur.view.dashChilds[0];
        cur.insertAbove = selectedEl ? false : !(cur.curSelEl && cur.curSelEl.getAttribute('eltype') === 'USERFILTERS');//NO I18N
        return cur;
    };

    this.showFontDialog = function (el, event)
    {
        if (WidgetEditor.curList)
        {
            var curEl = WidgetEditor.curList;
            WidgetEditor.closeList(event, true);
            if (curEl === el.parentNode)
            {
                return;
            }
        }
        ZDBUtil.setNamedChildEls(el, el);
        WidgetEditor.openList = true;
        el.className = "inlinePropComboSel";
        var parentNode = DOMUtils.getParentWithAttr(el, "position");//No I18N
        var fontPropComp = ZDBUtil.getCloneNode(WidgetEditor.editor.styleCombo);
        ZDBUtil.setNamedChildEls(fontPropComp, fontPropComp);
        var position = parentNode.getAttribute('position');
        var positionKey = parentNode.getAttribute('positionKey');
        if ((positionKey + position) === 'OPERATIONopr1') {
        	var textAlignUIEl = DOMUtils.getParentWithTagName(fontPropComp.textAlign, 'tr'); //NO I18N
        	textAlignUIEl.parentNode.removeChild(textAlignUIEl);
        }
        WidgetEditor.curList = el.parentNode;
        WidgetEditor.curList.fieldsList = fontPropComp;
        WidgetEditor.curList.kill = true;
        fontPropComp.style.display = "";
        parentNode.appendChild(fontPropComp);
        WidgetEditor.setOperationListPos(parentNode, fontPropComp);
        ZDBUtil.attachEvent(document, 'click', WidgetEditor.closeList, true);
        WidgetEditor.editor.functions.updateStyleCombo(parentNode);
    };

    this.selectFromCombo = function (selectEl, value)
    {
        var childEls = selectEl.getElementsByTagName("option");
        var i = 0;
        for (var j = childEls.length; i < j; i++)
        {
            var child = childEls[i];
            if (child.getAttribute("value") === "" + value)
            {
                break;
            }
        }
        selectEl.selectedIndex = i;
        return selectEl;
    };
    
    this.setTextAlignStyle = function(parentEl, value) {
    	DOMUtils.removeCSSClass(parentEl.children, "inlineToggleElSelected"); //NO I18N
    	DOMUtils.addCSSClass(parentEl.children, "inlineToggleEl"); //NO I18N
    	//Only one element will be present but it will return an array
    	var elArray = DOMUtils.getChildElsWithAttr(parentEl, "value", value); //NO I18N
    	elArray[0].className = "inlineToggleElSelected";
    }
    
    this.updateTextAlignStyle = function (el) {
    	var parentEl = el.parentNode;
    	parentEl.value = el.getAttribute("value");
    	this.updateStyle(parentEl);
    }

    this.selectLayout = function (el)
    {
        var editor = WidgetEditor.editor;
        var layout = parseInt(el.getAttribute('template'));
        if (editor.layout === layout) {
            return;
        }
        delete editor.renderer;
        editor.functions.updateLayout(layout);
        editor.functions.updateEditor();
        if(WidgetEditor.editor.cinfo.COLUMNS.GROUP){
        	editor.functions.autoComputeDataDefaults(true);
        }
    };

    this.hideSample = function (el)
    {
        var templatePar = WidgetEditor.editor.templates;
        var prevEl = templatePar.curLayout;
        if (!prevEl || el === prevEl)
        {
            return;
        }
        prevEl.setAttribute('class', 'layoutalign');
        prevEl.toggle.innerHTML = prevEl.toggle.getAttribute('showsample');
    };

    this.showSample = function (el, event)
    {
        var layoutEl = DOMUtils.getSelfOrParentWithAttrValue(el, "togglesample", "true");//NO I18N
        var templatePar = WidgetEditor.editor.templates;
        var css = layoutEl.getAttribute('class');
        ZDBUtil.stopEventBubble(event);
        if (css.indexOf('enablewidgetlayoutsample') != -1)
        {

            layoutEl.setAttribute('class', 'layoutalign');
            el.innerHTML = el.getAttribute('showsample');
            el.style.fontSize = '11px';//NO I18N
            el.style.paddingTop = '5px';//NO I18N
            templatePar.curLayout = null;
            return;
        }
        el.innerHTML = el.getAttribute('hidesample');
        layoutEl.toggle = el;
        templatePar.curLayout = layoutEl;
        layoutEl.setAttribute('class', 'layoutalign enablewidgetlayoutsample');
    };

    this.showErrorDialog = function (view)
    {
        hideCustomMessage();
        if (WidgetEditor.editor.cinfo.COLUMNS.GROUP)
        {
            return false;
        }
        showCustomMessage('Select Data Column', WidgetEditor.editor.GROUP); //NO I18N
        return true;
    };

    this.hightLightItem = function (el)
    {
        WidgetEditor.editor.data.setAttribute('class', 'widgetdata sel' + el.getAttribute('position'));
    };

    this.revertHightLightItem = function ()
    {
        WidgetEditor.editor.data.setAttribute('class', 'widgetdata');
    };

    this.getZACF = function (el, event)
    {
        var view = WidgetEditor.editor.view;
        var instKey = el.getAttribute('instKey');
        if (view.fetched && view.zacf.get(instKey)) {
            view.zacf.setKey(instKey);
            ZACF.showCustomFormatDlg(el, event);
            return;
        }
        WidgetFetcher.requestPreviewData(WidgetEditor.editor, 'WidgetFetcher.updateZACF', null, el);//NO I18N
    };

    this.getInstKey = function (el) {
        var key = el.getAttribute('instKey');
        if(this.editor.cinfo.COLUMNS[key]){
        	return this.editor.cinfo.COLUMNS[key].INSTKEY + '';
        }
        return key;
    };

    this.setFormatType = function (instKey)//clean ups
    {
        var view = this.editor.view;
        var formats = view.zacf.get();
        var positions = view.zacf.getAvlblPositions();
        var formatObj = formats[positions[0]];
        var showValueAs = this.editor.cinfo.SHOWVALUEAS[instKey];
        var operation;
        if (showValueAs) {
        	operation = showValueAs.OPERATION;
        }
        if(!operation){
        	showValueAs = this.editor.cinfo.COLUMNS[instKey];
        	if(!showValueAs)
        	{
        		var keys = Object.keys(this.editor.cinfo.COLUMNS);
        		for(var i = 0; i < keys.length; i++)
        		{
        			if(this.editor.cinfo.COLUMNS[keys[i]].INSTKEY == instKey)
        			{
        				showValueAs = this.editor.cinfo.COLUMNS[keys[i]];
        				break;
        			}
        		}
        	}
        	operation = showValueAs.OPERATION;
        }
        if (operation === 'PERCENTOFPREV') {
            formatObj.type = 'PERCENT';
        } else if (operation === 'AVG' || operation === 'DIFFOFPREV' || this.editor.cinfo.COLUMNS.GROUP.OPERATION === 'AVG') {//NO I18N
            formatObj.type = (formatObj.type === 'CURRENCY' || formatObj.type === 'PERCENT') ? formatObj.type : 'DECIMAL_NUMBER';
        }
    };

    this.updateLabel = function (el, event)
    {
    	WidgetEditor.showVariablesList(el, event);
        WidgetEditor.editor.functions.updateLabelText(el);
    };

    this.showVariablesList = function (el, event) {
        this.setShowVariablesDet(el, event);
        this.appendVariablesList(el, event);
    };

    this.setShowVariablesDet = function (el, event) {
        if (el.isSet) {
            return;
        }
        el.pos = el.selectionStart - 1;
        el.isSet = true;
        el.val = el.value;
    };

    this.appendVariablesList = function (el, event) {
        var value = el.value.toUpperCase();
        var variables = WidgetEditor.editor.variables;
        var searchStr = value.substr(el.pos, el.selectionStart - el.pos);
        if (!searchStr || searchStr.charAt(0) !== '$' || event.keyCode === 13 || event.keyCode === 32 || event.keyCode === 38 || event.keyCode === 40) {
            switch (event.keyCode) {
                case 13:
                    this.insertVaraible(variables, null, variables[variables.getAttribute('idx')]);
                    WidgetEditor.closeList();
                    break;
                case 38:
                    this.hightLightVariable(variables, -1);
                    break;
                case 40:
                    this.hightLightVariable(variables, 1);
                    break;
                default:
                    variables.style.display = 'none';
                    el.isSet = false;
            }
            ZDBUtil.stopEventBubble(event);
            return;
        }
        variables.indexes = [0];
        this.deHighLightVariable();
        variables.setAttribute('search', searchStr.toUpperCase());
        variables.variables.forEach(this.filterVariableList, variables);
        variables.style.display = '';
        variables.inputEl = el;
        WidgetEditor.curList = variables;
        WidgetEditor.curList.fieldsList = variables;
        delete variables.idxSet;
        ZDBUtil.setNamedChildEls(variables, variables, "idx");//No I18N
        el.parentNode.appendChild(variables);
        ZDBUtil.attachEvent(document, 'click', WidgetEditor.closeList, true);
    };

    this.filterVariableList = function (value, index, array) { //belongs only to appendVariablesList, not generic
        if (value.innerHTML.toUpperCase().indexOf(this.getAttribute('search')) === -1) {
            value.style.display = 'none';
        } else {
            this.indexes.push(parseInt(value.getAttribute('idx')));
            value.style.display = '';
        }
    };

    this.insertVaraible = function (el, event, srcEl) {
        srcEl = srcEl || ZDBUtil.getSourceElement(event);
        var variable = srcEl.getAttribute('value') || srcEl.innerHTML;
        var inputEl = el.inputEl;
        var str = inputEl.val;
        str = (str) ? str.substr(0, inputEl.pos) + variable + str.substr(inputEl.pos + 1, str.length - inputEl.pos) : "";
        inputEl.value = str;
        inputEl.focus();
        inputEl.setSelectionRange(inputEl.value.length, inputEl.value.length);
        WidgetEditor.editor.functions.updateLabelText(inputEl);
        inputEl.isSet = false;
    };

    this.resetLabel = function (el, event) {
        var editor = WidgetEditor.editor;
        WidgetEditor.editor.functions.resetLabel(editor.variables.inputEl);
        ZDBUtil.stopEventBubble(event);
    };

    this.hightLightVariable = function (list, deter) {
        var indexes = list.indexes;
        var idx = (parseInt(list.getAttribute('curIdx')) + deter) || 0;
        if (idx > indexes.length - 1) {
            idx = 0;
        } else if (idx < 0) {
            idx = indexes.length - 1;
        }
        list.setAttribute('idx', indexes[idx]);
        list.setAttribute('curIdx', idx);
    };

    this.deHighLightVariable = function () {
        var variables = WidgetEditor.editor.variables;
        variables.removeAttribute('curIdx');
        variables.removeAttribute('idx');
    };

    this.showFontColorPalette = function (el, type) {//IE9 Fix
        var parentNode = DOMUtils.getParentWithAttr(el, "position");//No I18N
        var position = parentNode.getAttribute("position");
        WidgetEditor.showColorPalette(el, type);
    };

    this.showKPIValueColorPalette = function (el, type) {
        if (!WidgetEditor.editor.functions.canCustomizeKPIValueColor()) {
            return;
        }
        WidgetEditor.showColorPalette(el, type);
    };

    this.showColorPalette = function (el, type)
    {
        var currClr = "#" + el.getAttribute("value");
        var paletteTitle = ZDBI18NMap.g("zrpt.dashboard.settings.js.chooseFontClr");
        ZDBColorPalette.showClrPalette(el, currClr, paletteTitle);
        ZDBColorPalette.widgetEventExist = true;
        ZDBColorPalette.widgetEventType = type;
    };

    this.handleClrPaletteEvents = function (colorDiv, type) {
        switch (type) {
            case 1:
                WidgetEditor.editor.functions.updateStyleConfig(colorDiv);
                break;
            case 2:
                WidgetEditor.editor.functions.updateKPISettingsStyleConfig(colorDiv);
                break;
            case 3:
                WidgetEditor.editor.functions.updateKPISettingsValueStyleConfig(colorDiv);
                break;
            case 4:
                WidgetEditor.editor.functions.updateChartSettingsColorConfig(colorDiv);
                break;
        }
        ZDBColorPalette.widgetEventExist = false;
    };

    this.showHideKPISymbol = function (el) {
        WidgetEditor.editor.functions.toggleKPISymbolConfig(el);
    };

    this.showHideValueKPI = function (el) {
        WidgetEditor.editor.functions.toggleKPIValueConfig(el);
    };

    this.updateNullReplaceText = function (el) {
        WidgetEditor.editor.functions.updateKeyValueConfig(el);
    };

    this.updateChartInputVals = function (el) {
        WidgetEditor.editor.functions.updateChartInputVals(el);
    };
    
    this.updateChartStyleVals = function(el, elName, suffix){
    	WidgetEditor.editor.functions.updateChartStyleCombos(el, elName, suffix);
    }

    this.updateChartRangeVal = function (el) {
        WidgetEditor.editor.functions.updateChartInputVals(el, 0);
        WidgetEditor.editor.view.setModified();
    };

    this.updateChartToggleVals = function (el) {
        WidgetEditor.editor.functions.updateChartToggleVals(el);
    };

    this.updateStyle = function (el) {
        WidgetEditor.editor.functions.updateStyleConfig(el);
    };

    this.updateChartShowValConstants = function (el) {
        WidgetEditor.editor.functions.updateChartShowValConfig(el, el.value);
    };

    this.modifyRangeList = function (factor) {
        var editor = WidgetEditor.editor;
        var rangeList = editor.wcharts.rangeList;
        var count = parseInt(rangeList.getAttribute('size'));
        var size = count + factor;
        if (size > 5 || size === -1) {
            //disable ranges
            return;
        }
        rangeList.setAttribute('size', size);
        WidgetEditor.editor.functions.updateChartRangeList(size, factor === 1);
    };

    this.showMoreOptions = function (el) {
        var editor = WidgetEditor.editor;
        var isMax = editor.showMoreOptions;
        var toggleCSS = isMax ? 'wcopiconmin' : 'wcopiconmax';//NO I18N
        WidgetEditor.editor.settings.setAttribute('class', 'widgetsettings floatLeft ' + toggleCSS);
        editor.showMoreOptions = !isMax;
    };
    
    this.fadeOutHelper = function(el){
    	
    }

};

ZDBLazyLoadFuncMap.lazyLoadFuncMap['getZACFForWidget'] = WidgetEditor.getZACF;
WidgetEditor.initialize();
