//$Id$;

var WidgetFetcher = new function ()
{
    this.handleReqResp = [
        ['requestWidgetFields', 'handleWidgetFields'], //NO I18N
        ['requestFilterFields', 'handleFilterFields'], //NO I18N
        ['requestWidgetData', 'handleWidgetData'], //NO I18N
        ['requestTrashView', 'handleTrashView']//NO I18N
    ];

    this.waitQueue = new Array();

    this.sendWidgetRequest = function (requestCode, view, param)
    {
        var fetchDetails = this.handleReqResp[requestCode];
        this[fetchDetails[0]](view, param);
    };


    this.requestWidgetFields = function (view, el)
    {
        var params = "DBID=" + view.dbId; //No I18N
        AjaxAPI.sendRequest({
            URL: ZDBGlobal.CTX + "/WidgetColList.cc", //No I18N
            PARAMETERS: params,
            METHOD: "POST", //check why //No I18N
            VIEW: view,
            FIELDEL: el,
            ONSUCCESSFUNC: WidgetFetcher.handleWidgetFields,
            OPSTATUSID: "ZDBMainLoader"//NO I18N
        });
    };

    this.handleWidgetFields = function (response, requestOptions)
    {
        var view = requestOptions.VIEW;
        var el = requestOptions.FIELDEL;
        var div = document.createElement("div");
        div.innerHTML = response.getOnlyHtml();
        var fieldsList = DOMUtils.getFirstMatchingChild(div, "div", "elName", "widgetColList");  //NO I18N
        ZDBUtil.setNamedChildEls(fieldsList, fieldsList, null, true);
        view.fetchedFields = true;
        view.fieldsList = fieldsList;
        view.fieldsList.tableList = DOMUtils.getChildElsWithAttr(fieldsList.refColUi, "tableli", "true"); //No I18N
        view.fieldsList.none = DOMUtils.getFirstMatchingChild(fieldsList.refColUi, null, "value", "NONE"); //No I18N
        view.fieldsList.constant = DOMUtils.getFirstMatchingChild(fieldsList.refColUi, null, "value", "CONSTANT"); //No I18N
        fieldsList.COLUMNIDS = {};
        fieldsList.TABLEIDS = {};
        ZDBUtil.setNamedChildEls(fieldsList, fieldsList.COLUMNIDS, 'colid');
        ZDBUtil.setNamedChildEls(fieldsList, fieldsList.TABLEIDS, 'tableid');
        WidgetEditor.showWidgetFields(el, view);
        ComboFunctions.updateListEvents(fieldsList, true);
    };

    this.requestFilterFields = function (editor)
    {
        var params = "ZDBACTION=FIELDS";//No I18N
        params += "&PARENTVIEWID=" + editor.parentViewId; //No I18N
        params += "&DBID=" + editor.view.dbId; //No I18N
        params += "&OBJID=" + editor.view.objId; //No I18N
        params += "&OBJTYPE=WIDGET"; //No I18N
        var xml = editor.functions.getPreviewConfig();
        AjaxAPI.sendRequest({
            URL: ZDBGlobal.CTX + "/ZRAnalysisFields.cc?" + params, //No I18N
            REQUESTHEADERS: {
                "Content-type": "text/xml;charset=utf-8"//No I18N
            }, //No I18N
            POSTBODY: xml,
            ONSUCCESSFUNC: WidgetFetcher.handleFilterFields,
            VIEW: editor,
            OPSTATUSID: "ZDBMainLoader"//NO I18N
        });
    };


    this.handleFilterFields = function (response, requestOptions)//rewrite
    {
        var view = requestOptions.VIEW; //No I18N
        var div = document.createElement("div");
        div.innerHTML = response.getOnlyHtml();
        document.body.appendChild(div);
        WidgetFetcher.constructFilterFields(view);
    };

    this.constructFilterFields = function (editor)
    {
        var filter = editor.filterHolder;
        var dialog = ZDBDialogUtil.focusDialog;
        dialog.appendChild(filter);
        var dialogStyle = dialog.getAttribute('class');
        dialog.setAttribute('class', dialogStyle + ' customstyle');//NO I18N
        filter.setAttribute('class', 'widgetfilterfieldsholder widgetfiltershadow');
        var fieldDiv = DOMUtils.getFirstMatchingChild(editor, "div", "id", "ZDBAnalysisFieldHolder");//$("ZDBAnalysisFieldHolder");//No I18N
        fieldDiv.innerHTML = "";
        var fieldsCached;
        var fieldsList;

        if (!ZDBAnalysisCaching.isFieldsListCached.WIDGET)
        {
            fieldsCached = ZDBAnalysisCaching.cacheNavPanel('WIDGET');//NO I18N
        }
        else
        {
            fieldsCached = ZDBAnalysisCaching.getCachedNavPanel('WIDGET');//NO I18N
        }
        fieldsList = fieldsCached[0].cloneNode(true);
        fieldDiv.appendChild(fieldsList);
        var dashFields = DOMUtils.getFirstMatchingChild(editor, null, "analysisel", "fieldsListEl");//$("WidgetAnalysisFields");//NO I18N
        var analysisel = DOMUtils.getFirstMatchingChild(dashFields, "div", "analysisel", "attachedFieldsListEl").cloneNode(true);//verify it  //No I18N
        analysisel.style.margin = '6px';//NO I18N
        analysisel.style.display = 'block';
        filter.appendChild(analysisel);
        var fieldsHolder = DOMUtils.getFirstMatchingChild(analysisel, "div", "zaFieldsScroll", "true"); //No I18N
        editor.analysisFieldHolder = DOMUtils.getFirstMatchingChild(analysisel, "div", "analysisel", "analysisFieldHolder"); //No I18N
        var filterHeight = 367;
        editor.analysisFieldHolder.style.height = '395px';//NO I18N
        var difference = (DOMUtils.getFirstMatchingChild(fieldDiv, "div", "id", "ZRFieldsActionDIV")) ? 0 : 23;//NO I18N
        fieldsHolder.style.height = "";
        fieldsHolder.style.maxHeight = (filterHeight + difference) + 'px';//NO I18N
        jQuery(filter).animate({"left": "-210px"}, 250);//NO I18N
        fieldDiv.innerHTML = "";
        dialog.dlgTitle.style.visibility = "hidden";
        WidgetEditor.constructFiltersTab();
        WidgetFetcher.checkNSendJSONDataReq(editor);
    }

    this.checkNSendJSONDataReq = function (editor) {
        var view = editor.view;
        var dbId = view.dbId;
        var parentViewId = editor.parentViewId;

        var relModelId;
        relModelId = ZDBClientUtil.getJsonRelModelIdForObjId(parentViewId);
        if (relModelId != null)
        {
            var jsonData = ZDBAnalysisCaching.tblColInfo.data[relModelId];
            WidgetFetcher.designClientViewFromJSON(editor, jsonData);
            return;
        }
        var ZDBFieldsIterationTable = $("ZDBFieldsIterationTable");
        var navFieldLoader = DOMUtils.getFirstMatchingChild(ZDBFieldsIterationTable, "div", "elname", "filterLoading");//NO I18N
        AjaxAPI.sendRequest({URL: ZDBGlobal.CTX + "/ZDBGetDBDetAsJSON.ma?DBID=" + dbId + "&PARENTVIEWID=" + parentViewId + "&ZDBACTION=" + "GETDBDETAILSASJSON",
            ONSUCCESSFUNC: WidgetFetcher.handleJSONDataResp,
            VIEW: editor,
            OPSTATUSID: navFieldLoader});
    }

    this.handleJSONDataResp = function (response, requestOptions)
    {
        if (!ZDBLazyLoadUtil.loadJsAlone(["ZAAnalysisFields"], "APPENDTODOC", WidgetFetcher.handleJSONDataResp, [response, requestOptions]))
        {
            return;
        }
        var editor = requestOptions["VIEW"];
        var view = editor.view;
        var jsonResp = JSON.parse(response.responseText)[editor.parentViewId];
        WidgetFetcher.designClientViewFromJSON(editor, jsonResp);
        var parentViewId = editor.parentViewId;
        var relCount = ZDBAnalysisCaching.tblColInfo.relCount;
        var jsonData = ZDBAnalysisCaching.tblColInfo.data;
        var relKey = "r" + relCount;//NO I18N
        ZDBClientUtil.deleteJsonForObjId(parentViewId);
        ZDBAnalysisCaching.tblColInfo.data[relKey] = jsonResp;
        ZDBAnalysisCaching.tblColInfo.relModelInfo[relKey] = view.fieldsController.model.relTables;
        WidgetFetcher.updateDateMinMaxRange(parentViewId, editor, relKey);
        ZDBAnalysisCaching.tblColInfo.relCount = ++relCount;
    }

    this.designClientViewFromJSON = function (editor, jsonData)
    {
        var clientModel = new ZAFieldsAdapterModel(jsonData, editor.view);//NO I18N
        var clientView = new ZAFieldsView(clientModel);
        var clientController = new ZAFieldsController(clientModel, clientView);
        clientController.updateBaseTable(editor.parentViewId);
    }

    this.updateDateMinMaxRange = function (parentViewId, editor, relKey)
    {
        var jsonData = ZDBAnalysisCaching.tblColInfo.data[relKey];
        var dateMinMaxCalc = jsonData.dateMinMaxCalc;
        if (!dateMinMaxCalc)
        {
            WidgetFetcher.sendDateMinMaxRangeReq(parentViewId, editor, relKey);
        }
    }

    this.sendDateMinMaxRangeReq = function (parentViewId, editor, relKey)
    {
        var dbId = editor.view.dbId;
        AjaxAPI.sendRequest({URL: ZDBGlobal.CTX + "/ZDBGetDateMinMaxRange.ma?DBID=" + dbId + "&PARENTVIEWID=" + parentViewId + "&ZDBACTION=" + "GETDATEMINMAXRANGE",
            ONFAILUREFUNC: WidgetFetcher.handleDateMinMaxReqFailure,
            ONSUCCESSFUNC: WidgetFetcher.handleDateMinMaxRangeResp,
            VIEW: editor,
            RELMODELKEY: relKey});
    }

    this.handleDateMinMaxReqFailure = function (response, requestOptions)
    {
        return;
    }

    this.handleDateMinMaxRangeResp = function (response, requestOptions)
    {
        var editor = requestOptions["VIEW"];
        var relKey = requestOptions["RELMODELKEY"];
        var jsonResp = JSON.parse(response.responseText);
        var jsonData = ZDBAnalysisCaching.tblColInfo.data[relKey];
        var key;
        jsonData.dateMinMaxCalc = true;
        for (key in jsonResp)
        {
            for (var colKey in jsonResp[key])
            {
                jsonData.colDet[key][colKey].OPERATION = jsonResp[key][colKey].OPERATION;
                jsonData.colDet[key][colKey].FILTER_OPERATION = jsonResp[key][colKey].FILTER_OPERATION;
                jsonData.colDet[key][colKey].FILTER_TYPE = jsonResp[key][colKey].FILTER_TYPE;
            }
        }
        WidgetFetcher.designClientViewFromJSON(editor, jsonData);
    }


    this.requestWidgetData = function (view, ONSUCCESSFUNC, el)
    {
    	var func = function() {
    		WidgetFetcher.requestWidgetData(view, ONSUCCESSFUNC, el);
    	}
    	if (!ZDBTabSwitchHandler.isRelevendTab2Exec(view.viewCtx.dashView,func)) {
    		return;
    	}
        ONSUCCESSFUNC = ONSUCCESSFUNC || 'WidgetFetcher.handleWidgetData';//NO I18N
        var objId = view.objId;
        var configDIV = $("ZDBAnalysisConfig_" + objId);
        if (!ZDBUtil.isViewModified(view) && configDIV != null)
        {
            view.currentList.length = 0;
            view.handleConfig(configDIV);
            configDIV.parentNode.removeChild(configDIV);
        }
        var xml = WidgetUtils.getConfig(objId, view, true);
        var params = view.getParams("");
        var condn = (ZDBUtil.isViewModified(view) || view.dashView.IsVMFilterApplied);
        params += condn ? "&VMOD=" + condn : ""; //No I18N
        if(view.cacheTime)
        {
            params += "&FORCEREFRESH=" + true; //No I18N
        }
        AjaxAPI.sendRequest({
            URL: ZDBGlobal.CTX + "/WidgetView.ve?WIDGETACTION=WIDGETVIEW&OBJTYPE=WIDGET&" + params + "&" + view.viewCtx.getAdditionalParams(), //No I18N
            REQUESTHEADERS: {
                "Content-type": "text/xml;charset=utf-8"//No I18N
            }, //No I18N
            POSTBODY: xml,
            ONSUCCESSFUNC: ONSUCCESSFUNC,
            ONFAILUREFUNC: WidgetFetcher.handleWidgetDataFailure,
            VIEW: view,
            OPSTATUSID: view.viewCtx.getLoadIndicator(), //NO I18N
            EL: el
        });
    };

    this.handleWidgetData = function (response, requestOptions)
    {
        var view = requestOptions.VIEW;
        var func = function() {
    		WidgetFetcher.handleWidgetData(response, requestOptions);
    	}
    	if (!ZDBTabSwitchHandler.isRelevendTab2Exec(view.viewCtx.dashView,func)) {
    		return;
    	}
        view.fetched = true;
        var responseText = response.responseText;
        var rawData = JSON.parse(responseText);
        ZDBUtil.setCacheTime(view,rawData.oldCacheTime);
        if(rawData.oldCacheTime)
        {
            view.dashView.maxCacheTime = ZDBUtil.maxTime(rawData.oldCacheTime,view.dashView.maxCacheTime);
        }
        view.cinfo.ZAF = rawData.ZAF;
        view.cinfo.DATA = rawData;
        view.zacf.setData(rawData.ZAF || {});
        var dashChild = WidgetUtils.updateDashChild(view);
        var dashView = view.dashView;
        dashView.updateRespStatus();
        //$#Dash#$ dashView.updateRespStatus(view);
        var validateDashUf = (dashView.permissions.designModify == 1 && ZDBUtil.isViewModified(dashView))
        if (validateDashUf && window.ZDBEditModeSelect)
        {
            ZDBEditModeSelect.validateDashUf(dashChild, dashView);//$#Dash#$ Comment for New Layout
        }
        if (BROWSER.IS_MOBILE_PHONE)
        {
            dashView.enableBodyScroll();
        }
	view.loaded = true;
    };

    this.handleWidgetDataFailure = function (response, requestOptions) {
        var view = requestOptions.VIEW;
        var dashView = view.dashView;
        WidgetUtils.setVisibilityOfLayout(view, "visible"); //NO I18N
        dashView.updateRespStatus();
        AjaxAPI.onFailureFunc(response, requestOptions);
    };

    this.requestPreviewData = function (editor, onsuccess, onfailure, el) {
        onsuccess = onsuccess || 'WidgetFetcher.showPreview';//NO I18N
        onfailure = onfailure || 'WidgetFetcher.handleShowPreviewFailure';//NO I18N
        var xml = editor.functions.getPreviewConfig();
        var params = "";
        params += "OBJID=" + editor.view.objId; //NO I18N
        params += "&PARENTVIEWID=" + editor.parentViewId; //NO I18N
        params += "&DBID=" + editor.view.dbId; //NO I18N
        params += "&DASHEDITMODE=true";
        AjaxAPI.sendRequest({
            URL: ZDBGlobal.CTX + "/WidgetView.ve?WIDGETACTION=WIDGETVIEW&OBJTYPE=WIDGET&" + params, //No I18N
            REQUESTHEADERS: {
                "Content-type": "text/xml;charset=utf-8"//No I18N
            }, //No I18N
            POSTBODY: xml,
            ONSUCCESSFUNC: onsuccess,
            ONFAILUREFUNC: onfailure,
            EDITOR: editor,
            SRCEL: el,
             OPSTATUSID:"ZDBMainLoader" //No I18N
        });
    };
    
    this.handleDataTabPreview = function(response, requestOptions){
    	var _thPercent = 1.2;
    	var _maxPercent = 1.5;
    	var maxPercentLabel = "150%";
    	var editor = requestOptions.EDITOR;
    	var jsondata = JSON.parse(response.responseText);
    	if(!jsondata.NODATA){
    		var val = jsondata.DATA[1];
	    	var thVal = jsondata.DATA[3];
	    	var label = jQuery.find(".combodisplayval",WidgetEditor.editor.labelNode)[0].innerHTML;
	    	var threshold = editor.cinfo.SHOWVALUEAS.THRESHOLD;
	    	var chooseMax = 0;
	    	if(threshold && threshold.OPERATION === "CONSTANT"){
	    		editor.thresholdConstant.value = Math.round(val * _thPercent);
	        	editor.functions.updateChartShowValConfig(editor.thresholdConstant, editor.thresholdConstant.value);
	        	editor.thresholdHelperText.innerHTML = "120% of " + label; //NO I18N
	        	editor.thresholdHelperText.style.cssText = "display : inline; opacity : 1"; //NO I18N
	        	jQuery(editor.thresholdHelperText).stop().fadeOut(5000);
	    	}
	    	else{
	    		chooseMax = 1;
	    	}
	    	var textaxis = editor.cinfo.SHOWVALUEAS.TEXTAXIS;
	    	if(textaxis && textaxis.OPERATION === "CONSTANT"){
	    		var maxValue = Math.round(val * _maxPercent);
	    		if(chooseMax && thVal > maxValue){
	    			maxValue = Math.round(thVal * 1.3);
	    			maxPercentLabel = "130%";
	    			label = jQuery.find(".combodisplayval",WidgetEditor.editor.thresholdNode)[0].innerHTML;
	    		}
	    		editor.maxConstant.value = maxValue;
	        	editor.functions.updateChartShowValConfig(editor.maxConstant, editor.maxConstant.value);
	        	editor.maxHelperText.innerHTML = maxPercentLabel + " of " + label;//NO I18N
	        	editor.maxHelperText.style.cssText = "display : inline; opacity : 1";//NO I18N
	        	jQuery(editor.maxHelperText).stop().fadeOut(5000);
	    	}
    	}
    	else{
    		editor.thresholdConstant.value = 0;
    		editor.maxConstant.value = 0;
    	}
    	
    }
    
    this.handleDataTabPreviewFailure = function(response, requestOptions){
		return;
    }

    this.showPreview = function (response, requestOptions)
    {
        var editor = requestOptions.EDITOR;
        var responseText = response.responseText;
        var rawData = JSON.parse(responseText);
        editor.cinfo.DATA = rawData;
        editor.cinfo.ZAF = rawData.ZAF;
        editor.functions.constructSettingsTab();
    };

    this.handleShowPreviewFailure = function (response, requestOptions) {
        var editor = requestOptions.EDITOR;
        editor.functions.constructSettingsTab();
        AjaxAPI.onFailureFunc(response, requestOptions);
    };

    this.updateZACF = function (response, requestOptions) {
        var editor = requestOptions.EDITOR;
        var el = requestOptions.SRCEL;
        var responseText = response.responseText;
        var rawData = JSON.parse(responseText);
        editor.zacf.setData(rawData.ZAF);
        var instKey = WidgetEditor.getInstKey(el);
        editor.zacf.setKey(instKey);
        ZACF.showCustomFormatDlg(el);
    };


    this.requestTrashView = function (viewIsNull, param)
    {
        AjaxAPI.sendRequest({
            URL: ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=MOVEOBJECTTOTRASH", //No I18N
            PARAMETERS: "OBJID=" + param.OBJID + "&CHECKVIEWDEP=true", //No I18N
            ONSUCCESSFUNC: WidgetFetcher.handleTrashView, //No I18N
            OBJID: param.OBJID, //No I18N
            OBJNAME: "WIDGET", //No I18N
            OBJTYPE: "WIDGET", //No I18N
            REQOPT: param.REQOPTS,
            DASHVIEW: param.DASHVIEW, //No I18N
            OPSTATUSID: "ZDBMainLoader"//NO I18N
        });
    };


    this.handleTrashView = function (response, requestOptions)
    {
        var dashView = requestOptions.DASHVIEW; //No I18N
        var reqOpts = requestOptions.REQOPT; //No I18N
        dashView.deleteWidgetsInDashboard(reqOpts);
    };

};
