//$Id$;

function WidgetView(objId, editMode, dashView, viewComp)
{
    this.editMode = editMode;
    this.modified = 0;
    this.fetched = false;
    this.type = 'WIDGET';
    this.typeValue = ZDBClientViewAPI.TYPE_WIDGET;
    this.objId = objId;
    this.parentViewId = null;
    this.dbId = dashView.dbId;
    this.currentList = new Array();
    this.clonedCurrentList = null;
    this.permissions = dashView.permissions;
    this.VMFiltersList = dashView.VMFiltersList;
    this.dashboardId = dashView.objId;
    this.dashView = dashView;
    this.viewCtx = dashView.viewCtx;
    this.layout = 1;
    this.cinfo = {'SHOWVALUEAS': {}, 'COLUMNS': {}, 'SETTINGS': {}, 'LAYOUT': '1', 'KEYVALMAP': {}};//No I18N
     var configDiv = $("ZDBAnalysisConfig_"+objId);
     if(configDiv!=null)
     {  
        this.joinType = configDiv.getAttribute("joinType")  == null? 1 :configDiv.getAttribute("joinType");
     }
     else
     {
         this.joinType = 1;
     }
    this.zacf = ZACF.getZACFInst();
    this.curTab = 0;
    if (editMode && viewComp)
    {
        this.initialize(viewComp);
    }
}

WidgetView.prototype.copyWidget = function(){
	var domAttrs = ["excludedashglobalfilters", "tlcolumnmapping", "style"];
	var newWidget = new WidgetView(ZDBClientUI.curDummyViewId--, true, this.dashView);
	newWidget.parentViewId = this.parentViewId;
                  newWidget.joinType =this.joinType;
	newWidget.cinfo = JSON.parse(JSON.stringify(this.cinfo));
	for(var i=0; i<this.currentList.length; i++){
		newWidget.currentList[i] = this.currentList[i].cloneNode(true);
		ZDBUtil.setNamedChildEls(newWidget.currentList[i], newWidget.currentList[i]);
	}
	newWidget.layout = parseInt(newWidget.cinfo.LAYOUT);
    newWidget.renderer = WidgetUtils.getRenderer(newWidget.layout, newWidget.cinfo);
    var dashChild = this.viewCtx.dashChildDiv;
    var dlgBody = dashChild.dlgBody;
	var curEl = WidgetEditor.getWidgetDashChild(newWidget, dlgBody.offsetWidth, dlgBody.offsetHeight, dashChild);
	curEl.isCopied = true;
	ZDBDashScroll.glowDashChild(curEl);
	newWidget.zacf.setData(newWidget.cinfo.ZAF);
	for(var atr=0; atr<domAttrs.length; atr++){
		var atrName = domAttrs[atr];
		var atrValue = this.viewCtx.dashChildDiv.getAttribute(atrName);
		if(atrValue != null)
			newWidget.viewCtx.dashChildDiv.setAttribute(atrName, atrValue);
	}
	
	WidgetUtils.fetchView(newWidget.objId, curEl.ctx);
	return newWidget;
}


WidgetView.prototype.initializeConfigs = function ()
{
    this.userGrpSel = 'TABLE_CHART';//NO I18N
    this.subGraphType = 'DEF';//No I18N
    this.userSubGrpSel = 'DEF';//No I18N
    this.title = '';//No I18N
    this.legendPos = 'RIGHT';//No I18N
    this.legendTitle = '';//No I18N
    this.merge = false;
    this.legendTitleModified = false;
    this.legendFilterEnable = true;
    this.rowGrandSummary = true;
    this.colGrandSummary = true;
    this.rowSubTotal = true;
    this.colSubTotal = true;
};

WidgetView.prototype.initialize = function (viewComp)
{
    this.viewComp = viewComp;
    this.analysisFieldHolder = $('ZDBAnalysisFieldHolder');
    this.dropAreas = {};
    this.fetchedFields = false;
    this.fieldsList = null;
    delete this.elnameSet;
    ZDBUtil.setNamedChildEls(viewComp, this, 'elname');//No I18N
    ZDBUtil.setNamedChildEls(viewComp, this.dropAreas, 'VIEWTYPE');//No I18N
    this.remElnameSet();
    this.multipleColPanels = {
        WIDGET: ['FILTERAXIS'] //NO I18N
    };
    this.initializeConfigs();
};


WidgetView.prototype.remElnameSet = function ()
{
    delete this.dropAreas.THRESHOLD;
    delete this.dropAreas.TEXTAXIS;
    delete this.dropAreas.VIEWTYPESet;
    delete this.dropAreas.GROUP;
    delete this.dropAreas.YAXIS;
};

WidgetView.prototype.viewModified = function ()
{
    if (!this.dashView.editMode) {
        return;
    }
    var dashView = this.dashView;
    this.modified = 1;
    this.viewCtx.updateModified();
    dashView.modified = 1;
    dashView.viewCtx.updateModified();
};

WidgetView.prototype.setModified = function ()
{
    if (!this.permissions.designModify || !this.dashView.editMode) {
        return;
    }
    if (typeof WidgetEditor != 'undefined') {
    	var editor = WidgetEditor.editor; 
    }
    if (editor && editor.functions && editor.functions.resetData) {
        editor.functions.resetData();
    }
    this.fetched = false;
    this.modified = 1;
    this.viewCtx.updateModified();
    var dashView = this.dashView;
    dashView.modified = 1;
    dashView.viewCtx.updateModified();
};

WidgetView.prototype.refreshView = function () {
	this.fetched = false;
    WidgetUtils.fetchView(this.objId, this.viewCtx);
};

WidgetView.prototype.getParams = function (params)
{
    params += 'OBJID=' + this.objId; //NO I18N
    params += '&PARENTVIEWID=' + this.parentViewId; //NO I18N
    params += '&DBID=' + this.dbId; //NO I18N
    return params;

};

//needs revist start
WidgetView.prototype.addFieldToArea = function (field, parentArea, savedConfig)
{
    var dropAreaTd = DOMUtils.getSelfOrParentWithAttrValue(parentArea, 'dropAreaTd', 'true');//NO I18N
    parentArea.dropAreaTd = dropAreaTd;
    var view = ZDBClientUI.getViewObj(parentArea, 'view');//No I18N
    if (!parentArea.elTrimmed)
    {
        ZDBUtil.removeNonElements(parentArea);
    }
    ZDBUtil.removeNonElements(parentArea);
    ZDBAnalysisView.addFieldInDropArea(parentArea, field);
    ZDBScroller.setScrollerTop(parentArea.parentNode);
    if (!savedConfig)
    {
        field.style.position = 'relative';
        ZDBAnalysisView.expandDropField(parentArea);
        ZDBAnalysisView.setListHeight(view, parentArea, true, 50);
        parentArea.dropAreaTd.dropArea.scrollTop = field.offsetTop / 2;
    }
    field.style.position = 'relative';
    field.style.left = 0;
    field.style.top = 0;
    var vType = parentArea.getAttribute('VIEWTYPE');
    if (vType)
    {
        field.setAttribute('VIEWTYPE', vType);
    }
    this.orderCurrentList(field, parentArea, savedConfig);
    if (this.editMode)
    {
        this.updateAddedFields();
        ZDBAnalysisView.highlightElement(view, field);
        ZDBAnalysisView.enableDropFieldExp(parentArea);
    }
    if (!field.getAttribute('INSTKEY'))
    {
        field.setAttribute('INSTKEY', WidgetEditor.editor.currentList.length + 1);
    }

    return true;
};

WidgetView.prototype.orderCurrentList = function (field, curDropArea, savedConfig)
{
    var viewType = curDropArea.getAttribute('viewtype');
    var currentList = WidgetEditor.editor.currentList;
    var i = 0;
    while (i < currentList.length) {
        if (currentList[i].getAttribute('viewtype') === viewType)
        {
            currentList.splice(i, 1);
            i = i - 1;
        }
        i++;
    }
    var droppedEls = ZDBUtil.getElsWithAttrName(curDropArea, 'column_id');//NO I18N
    for (i = 0; i < droppedEls.length; i++) {
        currentList.push(droppedEls[i]);
    }
};

WidgetView.prototype.updateAddedFields = function ()//Left panel list status will be updated.
{
    var fieldHolder = WidgetEditor.editor.analysisFieldHolder;
    var fieldList = fieldHolder.getElementsByTagName('DIV');
    var no_droppedFields = WidgetEditor.editor.currentList.length;
    var no_fields = fieldList.length;
    var className = '';
    DROPLISTFOR: for (var i = 0; i < no_fields; i++)
    {
        var curFieldListEl = fieldList[i];
        if (curFieldListEl.getAttribute('column_id') === null) {
            continue;
        }
        className = 'ZDBDNDFieldUncheck'; //No I18N
        ZDBUtil.setNamedChildEls(curFieldListEl, curFieldListEl);
        for (var j = 0; j < no_droppedFields; j++)
        {
            var field = WidgetEditor.editor.currentList[j];
            if ((curFieldListEl.getAttribute('column_id') === field.getAttribute('column_id')) && field.getAttribute('viewtype') === 'FILTERAXIS')  //No I18N
            {
                className = 'ZDBDNDFieldChecked'; //No I18N
                continue;
            }
        }
        if (curFieldListEl.fieldTitle)
        {
            curFieldListEl.fieldTitle.style.fontWeight = (className === 'ZDBDNDFieldChecked') ? 'bold' : 'normal'; //No I18N
        }
        curFieldListEl.checkMark.className = className;
    }
};

WidgetView.prototype.insertAddedFields = function ()
{
    var dropArea = this.dropAreas.FILTERAXIS;
    ZDBUtil.removeNonElements(dropArea);
    var list = this.getDroppedFields('FILTERAXIS');//No I18N
    for (var i = 0; i < list.length; i++)
    {
        this.addFieldToArea(list[i], dropArea);
    }
    if (list.length == 0)
    {
        dropArea.innerHTML = '';
    }
    ZDBAnalysisFilter.selectFilterField(this, list[0]);
};

WidgetView.prototype.getDroppedFields = function (dropArea)
{
    var currentList = WidgetEditor.editor.currentList;//TEMP_TO_BE_CHANGED
    var no_droppedFields = currentList.length;
    var count = 0;
    var fields = new Array();
    for (var i = 0; i < no_droppedFields; i++)
    {
        var viewType = currentList[i].getAttribute('viewtype');
        if (viewType === dropArea)
        {
            fields[count] = currentList[i];
            count++;
        }
    }
    return fields;
};

WidgetView.prototype.removeField = function (field, updateGraphArea)
{
    if (!this.editMode)
    {
        return;
    }
    ZDBUtil.removeFromSet(WidgetEditor.editor.currentList, field);
    if (field.parentNode !== null)
    {
        field.parentNode.removeChild(field);
        this.updateAddedFields();

    }
    var viewType = field.getAttribute('VIEWTYPE');
    if (viewType)
    {
        var dropArea = this.dropAreas[viewType];
        ZDBAnalysisView.expandDropField(dropArea);
        ZDBAnalysisView.setListHeight(null, dropArea, true, 0);
        ZDBAnalysisView.enableDropFieldExp(dropArea);
    }
};

WidgetView.prototype.updateCurrentMatchRow = function (curSettings, curCount)
{
    var currentList = WidgetEditor.editor.currentList;
    for (var i = 0; i < currentList.length; i++)
    {
        var viewType = currentList[i].getAttribute('VIEWTYPE');
        curSettings[viewType] = currentList[i];
        var count = curCount[viewType];
        if (count === null) {
            count = 0;
        }
        curCount[viewType] = ++count;
    }
};

WidgetView.prototype.getInstKey = function (viewType)
{
	switch (viewType) {
	case WidgetChartConstants.VIEWTYPE_GROUP_VALUE:
		return WidgetChartConstants.VIEWTYPE_GROUP_INSTKEY + '';
	case WidgetChartConstants.VIEWTYPE_THRESHOLD_VALUE:
		return WidgetChartConstants.VIEWTYPE_THRESHOLD_INSTKEY + '';
	case WidgetChartConstants.VIEWTYPE_TEXTAXIS_VALUE:
		return WidgetChartConstants.VIEWTYPE_TEXTAXIS_INSTKEY + '';
	case WidgetChartConstants.VIEWTYPE_YAXIS_VALUE:
		return WidgetChartConstants.VIEWTYPE_YAXIS_INSTKEY + '';
	default:
		return (this.currentList.length + 1) + '';
	}
}

WidgetView.prototype.handleConfig = function (configDiv)//revisit
{
    var childEls = configDiv.getElementsByTagName('div');
    for (var i = 0, j = childEls.length; i < j; i++)
    {
        var childEl = childEls[i];
        if (childEl.getAttribute('VIEWTYPE') !== null)
        {
            var viewType = childEl.getAttribute('VIEWTYPE');
            var instKey = this.getInstKey(viewType);
            if (viewType === 'FILTERAXIS')
            {
                var grpField = ZDBAnalysisView.getGraphField(this, childEls[i], viewType, childEl.getAttribute('DISPLAY_NAME'), false);
                grpField.setAttribute('XMLTAGNAME', 'zac');
                grpField.setAttribute('INSTKEY', instKey);
                this.currentList.push(grpField);
            }
            else
            {
                childEl.setAttribute('XMLTAGNAME', 'zavci');
                childEl.setAttribute('INSTKEY', instKey);
                if (viewType === 'GROUP')
                {
                    this.parentViewId = childEl.getAttribute('parent_obj_id');
                }
                this.currentList.push(childEl);
                var dType = childEl.getAttribute('addontype');
                var colName = childEl.getAttribute('display_name');
                var colId = childEl.getAttribute('column_id');
                var fieldType = childEl.getAttribute('field_col_type');
                var operation = childEl.getAttribute('operation');
                this.cinfo.COLUMNS[viewType] = {'INSTKEY': instKey, 'COLUMN_ID': colId, 'COLUMN_NAME': colName, 'ADDONTYPE': dType, 'OPERATION': operation, 'FIELD_COL_TYPE': fieldType};//NO I18N
            }
        }
    }
    this.handleCInfo(DOMUtils.getFirstMatchingChild(configDiv, 'div', 'configtype', 'ZAWidgetConfig'));//NO I18N
};

WidgetView.prototype.handleCInfo = function (configDiv) {
    var showVals = DOMUtils.getChildElsWithAttr(configDiv, 'cinfokey', 'SHOWVALUEAS');//NO I18N
    for (var i = 0; i < showVals.length; i++) {
        var showVal = showVals[i];
        var position = showVal.getAttribute('position');
        var positionKey = showVal.getAttribute('positionkey');
        var value = showVal.getAttribute('value');
        this.cinfo.SHOWVALUEAS[position] = this.cinfo.SHOWVALUEAS[position] || {};
        this.cinfo.SHOWVALUEAS[position][positionKey] = value;
        var settingsDiv = DOMUtils.getFirstMatchingChild(showVal, 'div', 'cinfokey', 'SETTINGS');//NO I18N
        if (settingsDiv) {
            this.cinfo.SETTINGS[position] = this.cinfo.SETTINGS[position] || {};
            var styleObj = {};
            styleObj['FONT-FAMILY'] = settingsDiv.getAttribute('fontname');//NO I18N
            styleObj.FONTSIZE = settingsDiv.getAttribute('fontsize');
            styleObj['FONT-SIZE'] = styleObj.FONTSIZE + 'px';//NO I18N
            styleObj['LINE-HEIGHT'] = styleObj['FONT-SIZE'];//NO I18N
            styleObj['FONT-WEIGHT'] = settingsDiv.getAttribute('fontstyle');//NO I18N
            styleObj['FONT-STYLE'] = styleObj['FONT-WEIGHT'];//NO I18N
            styleObj['TEXTALIGN'] = settingsDiv.getAttribute('textalign'); //NO I18N
            styleObj.COLOR = '#' + CSSFactory.adjustToHex(parseInt(settingsDiv.getAttribute('color')));
            this.cinfo.SETTINGS[position][positionKey] = styleObj;
        }
    }
    var keyVals = DOMUtils.getChildElsWithAttr(configDiv, 'cinfokey', 'KEYVALMAP');//NO I18N
    for (var i = 0; i < keyVals.length; i++) {
        var keyValDiv = keyVals[i];
        this.cinfo.KEYVALMAP[keyValDiv.getAttribute('key')] = keyValDiv.getAttribute('val');
    }
    var layoutDiv = DOMUtils.getFirstMatchingChild(configDiv, 'div', 'cinfokey', 'ROOT');//NO I18N
    this.cinfo.LAYOUT = parseInt(layoutDiv.getAttribute('layout'));
    this.layout = this.cinfo.LAYOUT;
};

WidgetView.prototype.getCriteriaAsXMLForGrid = function (type)
{
    var xmlBuf = new ZDBStrBuf();
    var dashDynFltrConfig = ZDBDashboardUF.getDashDynFltrConfig(this.viewCtx);
    xmlBuf.a(dashDynFltrConfig);
    var xml = "<crXml OBJID='" + this.objId + "' ZAGRIDTYPE='" + type + "'>\n" + xmlBuf + "</crXml>"; //NO I18N
    return xml;
};
