//$Id$
function DomainMap(map)
{
	this._dmMap = map;
	
	this.getDomainMap = function(){
		return this._dmMap;
	};
	
	this.get = function(key){
		var val = this._dmMap[key] || "";
		return val;
	};

  this.set = function(key,val)
  {
    this._dmMap[key] = val;
  }
}

var DMCache = new function()
{//Caching some common informations
	this.getDomains = function()
	{
		return this.domains || [];
	};
	
	this.getDomainMap = function()
	{
		return this.domainMap || "";
	};

	this.TABS = {
			setCurStatus : function(curTabName, curTabEl)
			{
				this[curTabName] = curTabEl;
				this["curTab"] = curTabName;
			},
			curTab : ""
	};

  this.removeTabsEl = function()
  {
    var obj = this.TABS;
    for(var i in obj)
    {
      if(typeof obj[i] == "object")
      {
        delete obj[i];
      }
    }
  };
};

var DMAdminAction = new function()
{
	this.init = function()
	{
		this.cacheDomains();
		this.handleDMNameBox();
		this.fetchDomain();
		this.addListenerOnTabs();
		var outputEl = $("outputel");
		outputEl.style.height = (window.innerHeight - document.querySelector(".header").clientHeight)+"px";
		outputEl.style.width = window.innerWidth+"px";
	};
	
	this.fetchDomainInfoByEmailIdorZuId = function()
	{//Fetching domain informations by email Id or ZUID assuming that one email Id has only one Domain!
		var select_id= document.getElementById("ID_SELECTION");//No I18N
		var options=select_id.options[select_id.selectedIndex].value;
		var values = document.querySelector("input[name=ID_VALUE]").value; //No I18N
		values = encodeURIComponent(values);
		if(options=="1")
		{
			params = "ZDBACTION=FETCHDMPROPS&EMAILID="+values;						//No I18N	
		}
		else if(options=="2")
		{
			params = "ZDBACTION=FETCHDMPROPS&ZUID="+values;                           //No I18N
		}
		AjaxAPI.sendRequest({
			URL : "/ZDBDomainAction.ma",		//No I18N
			METHOD : "POST",						//No I18N
			PARAMETERS : params,
			ONSUCCESSFUNC : DMAdminAction.handleResponse,
			NOSUBREQPARAM : true
		});
	};
	
	
	this.fetchDomain = function()
	{
		var dmNameBox = document.querySelector("input[list=domains]");				//No I18N
		this.fetchDomainInfo(dmNameBox.value);
	};
	
	this.fetchDomainInfo = function(dmName)
	{//Fetchin domain informations
		if(!dmName) return;
		var dms = DMCache.getDomains();
		if(dms.indexOf(dmName) == -1)
		{
			alert(dmName+" is not found in this server!");			//No I18N
			return;
		}
		params = "ZDBACTION=FETCHDMPROPS&DMNAME="+dmName;						//No I18N
		AjaxAPI.sendRequest({
			URL : "/ZDBDomainAction.ma",		//No I18N
			METHOD : "POST",						//No I18N
			PARAMETERS : params,
			ONSUCCESSFUNC : DMAdminAction.handleResponse,
			NOSUBREQPARAM : true
		});
	};
	
	this.addListenerOnTabs = function()
	{
		var tabEls = document.querySelectorAll(".tabsUl a");		//No I18N
		for(var i=0; i<tabEls.length; i++)
		{
			var el = tabEls[i];
			el.onclick = DMAdminAction.openTab;
		}
	};
	
	this.openTab = function(ev)
	{
		var dmMap = DMCache.getDomainMap();
		if(!dmMap)
		{
			return;
		}
		DMAdminAction.tabHandler(this);
	};
	
	this.tabHandler = function(el,isDMFileTab)
	{
		var tabName = el.getAttribute("elname");
		var curTabName = DMCache.TABS.curTab || "";
		if((tabName == curTabName && !isDMFileTab) || ( DMCache.domainMap.get("DMTYPE")!==2 && tabName==="configsamltab"  ) )
		{
			return;
		}
		else
		{
			var curTabEl = DMCache.TABS[curTabName];
			if(curTabEl)
			{
				curTabEl.style.display = "none";
			}
                        if(DMCache.domainMap.get("DMTYPE")!==2)
                        {
                            $('configsamltabId').setAttribute("style","background-color: #f7f7f7;color: darkgrey;border: 1px solid;border-bottom-color: black;");
                        }
                        else 
                        {
                          $('configsamltabId').setAttribute("style","");  
                        }
		}
		/*var shEl = DMCache.TABS[tabName];
		if(shEl && tabName!="dmfilestab" && !isDMFileTab)
		{
			shEl.style.display = "";
			DMCache.TABS.setCurStatus(tabName,shEl);
			return;
		}*/
		DMAdminAction.enableTab(el);
		var map = DMCache.getDomainMap();
		new GenTab(map).showOutput(tabName);
	};
	
	this.handleResponse = function(response, reqOpt)
	{
    var resp = JSON.parse(response.responseText);
    var result = resp.result;
    if(result == "failure")
    {
      alert(resp.message);
      return;
    }
		DMCache.domainMap = new DomainMap(resp);
		var genTab = document.querySelector(".tabsUl a[elname=generaltab]");		//No I18N
		DMAdminAction.tabHandler(genTab,true);
	};
	
	this.handleDMNameBox = function()
	{
		var dmNameBox = document.querySelector("input[list=domains]");		//No I18N
		DMCache.domainNameBox = dmNameBox;
		dmNameBox.focus();
	};
	
	this.cacheDomains = function(dmName)
	{
		var dmEls = document.querySelectorAll("#domains option");		//No I18N
		var dms = [];
		for(var i=0; i<dmEls.length; i++)
		{
			dms.push(dmEls[i].value);
		}
		DMCache.domains = dms;
	};
	
	this.enableTab = function(tabEl)
	{
		var oldTabEl = DMCache.tabEl;
		if(oldTabEl)
		{
			oldTabEl.style.borderBottom = "";
		}
		tabEl.style.borderBottom = "1px solid #FFF";			//No I18N
		DMCache.tabEl = tabEl;
	};
	
	/*		Upload File */
	
	this.submitFileUploadForm = function(frm)
	{
		var dm = DMCache.getDomainMap();
		var dmId = dm.getDomainMap()["DMID"];
    if(!dmId) return;
		frm.action = "/ZDBDomainAction.ma?&ZDBACTION=UPLOADFILE&DMID="+dmId;		//No I18N
		AjaxAPI.submit(frm);
	};
	
	this.handleUploadFormSubmit = function(resp, reqOpt)
	{
		var jsonObj = JSON.parse(resp.responseText.replace(/<.*?>/g,''));
		if(jsonObj.result == "failure")
		{
			alert(jsonObj.message);
			return;
		}
    document.querySelector("#uploadfile input[type=file]").value = "";       //No I18N
		var tab = document.querySelector(".tabsUl a[elname=dmfilestab]");	//No I18N
		DMAdminAction.tabHandler(tab,true);
	};
	
	this.failureUpload = function()
	{
		alert("File uploaded failured!");			//No I18N
	};
};

function GenTab(map)
{
	var GT = this;
	this.dmMap = map;
	var DMTYPE = { 	WHITELABEL : 0 ,SSO : 1,SAML :2};
	this.showOutput = function(showingTab)
	{
		showingTab = showingTab || "generaltab";			//No I18N
		var isSkip = false;
		switch(showingTab)
		{
			case "generaltab":			//No I18N
				Output.prototype = new GenProps(this.dmMap);
				break;
			case "dmpropstab":			//No I18N
				Output.prototype = new DMProps(this.dmMap);
				break;
			case "dmfilestab":				//No I18N
				new DMFiles(this.dmMap).fetchAndUpdateFiles(showingTab);
				isSkip = true;
				break;
                        case "configsamltab" ://No I18N
                                Output.prototype = new DMPropsSaml(this.dmMap);
                                break;
                            
			default:
				console.info("Not permit this operation!");			//No I18N
		}
		new Output().display(showingTab,isSkip);
	};
	
	this.toggleInputMode = function(els, excludeItems, isEnable)
	{
		if(isEnable)
		{
			for(var i=0; i<els.length; i++)
			{
				var el = els[i];
				if(excludeItems.indexOf(el.name) != -1) continue;
				el.className = "enableInput";
				el.removeAttribute("readonly");
			}
		}
		else
		{
			for(var i=0; i<els.length; i++)
			{
				var el = els[i];
				el.className = "";
				el.setAttribute("readonly","true");
			}
		}
	};
	
	this.handleResp = function(resp, reqOpt)
	{
		alert(resp.responseText);
	};
	
	this.handleFailure = function(resp,reqOpts)
	{
    var resp = resp.responseText;
		alert(resp);			//No I18N
	};
	
	function Output()
	{
		this.display = function(tabName,isSkip)
		{
			if(isSkip)
			{//Domain files tab - return this block. dmfiles handle differently
				return;
			}
			
			var outEl = $("outputel");
			var dispEl = this.getShowingEl();
			remId$(dispEl);
			dispEl.name = tabName;
			DMCache.TABS.setCurStatus(tabName, dispEl);
			outEl.appendChild(dispEl);
			this.addListeners();
		};
	}
	
	function GenProps(dmMap)
	{
		/* General Tab Handling */
		var curObj = this;
		this.EXCLUDE = ["CREATEDTIME","LASTMODIFIEDTIME"];	//No I18N
		this.getShowingEl = function()
		{
      this.removeOldEls();
			var dmInfo = ZDBUtil.cloneObject($("domaininfo"));
			return this.loadDataIntoTable(dmInfo);
		};

    this.removeOldEls = function()
    {
      var el = document.querySelector(".domaininfo[style]");
      if(el)
      {
        el.parentNode.removeChild(el);
      }
    }
		
		this.addListeners = function()
		{
			var outputel = $("outputel");
			var dmInfoEls = outputel.querySelector(".domaininfo #actionbtns");			//No I18N
			ZDBUtil.setNamedChildEls(dmInfoEls,dmInfoEls,"elname");
			var inputEls = outputel.querySelectorAll(".domaininfo td input");		//No I18N

			dmInfoEls.editbtn.onclick = function()
			{
				GT.toggleInputMode(inputEls, curObj.EXCLUDE, true);
			};
			
			dmInfoEls.savebtn.onclick = function()
			{
				var els = inputEls;
				var map = dmMap.getDomainMap();
				var params = "";
				for(var i=0; i<els.length; i++)
				{
					var el = els[i];
					var val = el.value.trim();
					if(el.name == "DMTYPE")	{	val = DMTYPE[val];	}
					if(curObj.EXCLUDE.indexOf(el.name) != -1 || String(map[el.name]) == val) continue;
					
					params += el.name+"="+encodeURIComponent(val)+"&";
				}
				GT.toggleInputMode(inputEls);
				
				if(params == "") return;	
				params = params+"&ZDBACTION=UPDATEDMINFO&DMID="+map["DMID"];		//No I18N
				
				AjaxAPI.sendRequest({
					URL : "/ZDBDomainAction.ma",					//No I18N
					METHOD : "POST",								//No I18N
					PARAMETERS : params,
					ONSUCCESSFUNC : function(){alert("Successfully updated");},         //No I18N
					ONFAILUREFUNC : function(resp,reqOpt){alert(resp.responseText);},
					NOSUBREQPARAM : true
				});
			};
			
			dmInfoEls.cancelbtn.onclick = function(){
				var infoTbl = outputel.querySelector(".domaininfo");		//No I18N
				curObj.loadDataIntoTable(infoTbl);
				GT.toggleInputMode(inputEls);
			};
			
			dmInfoEls.createclientportalbtn.onclick = function(){
				var dmName = dmMap.getDomainMap()["DMNAME"];
				var params = "ZDBACTION=CREATECLIENTPORTAL&DMNAME="+dmName;//No I18N
				AjaxAPI.sendRequest({
					URL : "/ZDBDomainAction.ma",					//No I18N
					METHOD : "POST",								//No I18N
					PARAMETERS : params,
					ONSUCCESSFUNC : function(resp,reqOpt){alert(resp.responseText);},         
					ONFAILUREFUNC : function(resp,reqOpt){alert(resp.responseText);},
					NOSUBREQPARAM : true
				});
			};
			
		};

		this.loadDataIntoTable = function(dmInfo)
		{
			var els = dmInfo.querySelectorAll("td input");		//No I18N
			var dm = dmMap.getDomainMap();
			for(var i=0; i<els.length; i++)
			{
				var el = els[i];
				var name = el.name;
				var val = dm[name];
				var outVal;
				switch(name)
				{
					case "DMTYPE":			//No I18N
						outVal = (val == DMTYPE.SSO) ? "SSO" : (val ==DMTYPE.WHITELABEL) ? "WHITELABEL" : "SAML";			//No I18N
						break;
					case "CREATEDTIME":			//No I18N
					case "LASTMODIFIEDTIME":		//No I18N
						outVal = Date(val);
						break;
					default:
						outVal = val;
				}
				el.value = outVal;
				el.setAttribute("readonly",true);
			}
			return dmInfo;
		};
	}
	
	function DMProps(dmMap)
	{
		/*	Domain Propeties Handling 	*/	
		var curObj = this;
		
		this.EXCLUDEPROPS = ["PDF_LOGO_ID", "LOGO_ID","PWD_BY_LOGO_ID","INTERNAL_SERVICENAME","ADMIN_ZUID","ADMIN_EMAILID",		//No I18N
		                     "HEADER_FILE_ID","DMTYPE","SIGNUP_SUFFIX_FILE_ID","LOGIN_FILE_ID","DMID","LASTMODIFIEDTIME",		//No I18N
		                     "SIGNUP_PREFIX_FILE_ID","FAVICON_FILE_ID", "CREATEDTIME","APIKEY","HEADER_LINKS_WHTNEW_COM","DMNAME",  //No I18N
                         "HEADER_FILE_TXT","LOGIN_FILE_TXT","API_KEY","DFSFILES","SIGNUP_FILE_TXT","SIGNUP_FILE_ID"];		//No I18N
		
		this.getShowingEl = function()
		{
      this.removeOldEls();
			var cloneEl = ZDBUtil.cloneObject($("domainprops"));
			cloneEl.style.display = "";
			this.loadPropsTable(cloneEl);
			return cloneEl;
		};
		
		this.loadPropsTable = function(clnEl)
		{
			var tbl = clnEl.querySelector("table");			//No I18N
			var tmpTr = clnEl.querySelector("tr");			//No I18N
			ZDBUtil.removeAllChildren(tbl);
			var tBody = document.createElement("tbody");
			var dm = dmMap.getDomainMap();
			for(var key in dm)
			{
				if(this.EXCLUDEPROPS.indexOf(key) != -1 || key.indexOf("_COM") != -1)
				{
					continue;
				}
				var clnTr = ZDBUtil.cloneObject(tmpTr);
				ZDBUtil.setNamedChildEls(clnTr,clnTr);
				clnTr.propkey.innerHTML = key;
				clnTr.propval.value = dm[key];
				clnTr.propval.name = key;
				tBody.appendChild(clnTr);
			}
			tbl.appendChild(tBody);
		};
		
		var inputEls = function () { 
			var outputel = $("outputel");
			return outputel.querySelectorAll(".domainprops input"); 	//No I18N
		};

    this.removeOldEls = function()
    {
      var el = document.querySelector(".domainprops[style]");
      if(el)
      {
        el.parentNode.removeChild(el);
      }
    }
		
		this.addListeners = function()
		{
			var outputel = $("outputel");
			var dmInfoEls = outputel.querySelector(".domainprops #actionbtns");	//No I18N
			ZDBUtil.setNamedChildEls(dmInfoEls,dmInfoEls,"elname");
			dmInfoEls.removeChild($('configuresamlbutton'));
			dmInfoEls.editbtn.onclick = function()
			{
				GT.toggleInputMode(inputEls(), curObj.EXCLUDEPROPS, true);
			};
			
			dmInfoEls.cancelbtn.onclick = function(){
				var infoTbl = outputel.querySelector(".domainprops");	//No I18N
				curObj.loadPropsTable(infoTbl);
				GT.toggleInputMode(inputEls());
			};
			
			dmInfoEls.savebtn.onclick = function()
			{
				var els = inputEls();
				var map = dmMap.getDomainMap();
				var params = "";
				for(var i=0; i<els.length; i++)
				{
					var el = els[i];
					var val = el.value.trim();
					var oldVal = map[el.name];
					if(val == String(oldVal)) continue;
					params += el.name+"_MOD="+encodeURIComponent(val)+"&";		//No I18N
				}
				
				
				GT.toggleInputMode(els);
				
				if(params == "") return;
				params = params+"&ZDBACTION=UPDATEDMPROPS&DMID="+map["DMID"];		//No I18N
				
				AjaxAPI.sendRequest({
					URL : "/ZDBDomainAction.ma",					//No I18N
					METHOD : "POST",								//No I18N
					PARAMETERS : params,
					ONSUCCESSFUNC : GT.handleResp,
					ONFAILUREFUNC : GT.handleFailure,
					NOSUBREQPARAM : true
				});
			};
			
			
		};
	}
        function DMPropsSaml(dmMap)
	{
		/*	Domain Propeties Handling for saml	*/	
		var curObj = this;
		
		this.INCLUDEPROPS = ["SAML_PUBLICKEY", "SAML_ALGORITHM","CUSTOMIZED_CHANGEPASSWORDURL","CUSTOMIZED_LOGOUTURL","CUSTOMIZED_LOGINURL"];		//No I18N
		this.EXCLUDEPROPS=[];
		this.getShowingEl = function()
		{
                        this.removeOldEls();
			var cloneEl = ZDBUtil.cloneObject($("domainprops"));
			cloneEl.style.display = "";
			this.loadPropsTable(cloneEl);
			return cloneEl;
		};
		
		this.loadPropsTable = function(clnEl)
		{
			var tbl = clnEl.querySelector("table");			//No I18N
			var tmpTr = clnEl.querySelector("tr");			//No I18N
			ZDBUtil.removeAllChildren(tbl);
			var tBody = document.createElement("tbody");
			var dm = dmMap.getDomainMap();
			for(var key in dm)
			{
				if(this.INCLUDEPROPS.indexOf(key) != -1)
				{
                                var clnTr = ZDBUtil.cloneObject(tmpTr);
				ZDBUtil.setNamedChildEls(clnTr,clnTr);
				clnTr.propkey.innerHTML = key;
				clnTr.propval.value = dm[key];
				clnTr.propval.name = key;
				tBody.appendChild(clnTr);
				}
				
			}
			tbl.appendChild(tBody);
		};
		var inputEls = function () { 
			var outputel = $("outputel");
			return outputel.querySelectorAll(".domainprops input"); 	//No I18N
		};

    this.removeOldEls = function()
    {
      var el = document.querySelector(".domainprops[style]");
      if(el)
      {
        el.parentNode.removeChild(el);
      }
    }
		
		this.addListeners = function()
		{
			var outputel = $("outputel");
			var dmInfoEls = outputel.querySelector(".domainprops #actionbtns");	//No I18N
			ZDBUtil.setNamedChildEls(dmInfoEls,dmInfoEls,"elname");		
			dmInfoEls.editbtn.onclick = function()
			{
				GT.toggleInputMode(inputEls(), curObj.EXCLUDEPROPS, true);
			};
			
			dmInfoEls.cancelbtn.onclick = function(){
				var infoTbl = outputel.querySelector(".domainprops");	//No I18N
				curObj.loadPropsTable(infoTbl);
				GT.toggleInputMode(inputEls());
			};
			
                        dmInfoEls.configuresamlbutton.onclick=function(){
                            var dmName = dmMap.getDomainMap()["DMNAME"];
                 		var params = "ZDBACTION=UPDATESAMLCONFIG&DMNAME="+dmName;		//No I18N
                                
                                //UPDATESAMLCONFIG
                                AjaxAPI.sendRequest({
					URL : "/ZDBDomainAction.ma",					//No I18N
					METHOD : "POST",								//No I18N
					PARAMETERS : params,
					ONSUCCESSFUNC : GT.handleResp,
					ONFAILUREFUNC : GT.handleFailure,
					NOSUBREQPARAM : true
				});
                        };
			dmInfoEls.savebtn.onclick = function()
			{
				var els = inputEls();
				var map = dmMap.getDomainMap();
				var params = "";
				for(var i=0; i<els.length; i++)
				{
					var el = els[i];
					var val = el.value.trim();
					var oldVal = map[el.name];
					if(val == String(oldVal)) continue;
					params += el.name+"_MOD="+encodeURIComponent(val)+"&";		//No I18N
				}
				GT.toggleInputMode(els);
				if(params == "") return;
				params = params+"&ZDBACTION=UPDATEDMPROPS&DMID="+map["DMID"];		//No I18N
				AjaxAPI.sendRequest({
					URL : "/ZDBDomainAction.ma",					//No I18N
					METHOD : "POST",								//No I18N
					PARAMETERS : params,
					ONSUCCESSFUNC : GT.handleResp,
					ONFAILUREFUNC : GT.handleFailure,
					NOSUBREQPARAM : true
				});
			};
			
			
		};
	}
  
	function DMFiles(dmMap)
	{
		var curObj = this;
		this.fetchAndUpdateFiles = function(tabName) 
		{
			this.tabName = tabName;
			var params = "&ZDBACTION=FETCHDMFILE&DMNAME="+dmMap.getDomainMap()["DMNAME"];		//No I18N
			AjaxAPI.sendRequest({
				URL : "/ZDBDomainAction.ma",					//No I18N
				METHOD : "POST",								//No I18N
				PARAMETERS : params,
				ONSUCCESSFUNC : curObj.handleResp,
				ONFAILUREFUNC : curObj.handleFailure,
				NOSUBREQPARAM : true
			});
		};
		
		this.handleResp = function(resp, reqOpt)
		{
			var jsonObj = JSON.parse(resp.responseText);
			DMCache.dmFiles = jsonObj;
			
			curObj.updateFileManager();
			curObj.addListeners();
		};
		
		this.updateFileManager = function()
		{
			var el = ZDBUtil.cloneObject($("dmfiles"));
			el.style.display = "";
			remId$(el);
			var outEl = $("outputel");
			var oldEl = outEl.querySelector(".dmfiles");			//No I18N
			if(oldEl)
			{
				outEl.removeChild(oldEl);
			}
			var dispEl = this.loadDMFiles(el);
			outEl.appendChild(dispEl);
			DMCache.TABS.setCurStatus(curObj.tabName,dispEl);
		};
		
		this.loadDMFiles = function(el)
		{
			var filesTabl = el.querySelector("#dmfilestable");			//No I18N
			var tblEl = filesTabl.querySelector("table");				//No I18N
			var tmpTrEl = tblEl.querySelector("tr");					//No I18N
			ZDBUtil.removeAllChildren(tblEl);
			var tBody = document.createElement("tbody");
			var dmFiles = DMCache.dmFiles;
      var dmMap = DMCache.getDomainMap();
			if(!dmFiles)
			{
				return;
			}
			for(var key in dmFiles)
			{
				var trEl = ZDBUtil.cloneObject(tmpTrEl);
				ZDBUtil.setNamedChildEls(trEl,trEl);
        var id = dmFiles[key];
				trEl.filename.innerHTML = key;
				trEl.filename.setAttribute("fileid",id);
        trEl.filename.href = ZDBGlobal.REPORTS_CONTEXT_NAME + "/dmfiles?ZDBDMFILEID="+id+"&DMID="+dmMap.getDomainMap()["DMID"];
				tBody.appendChild(trEl);
			}
			tblEl.appendChild(tBody);
			filesTabl.appendChild(tblEl);
			el.appendChild(filesTabl);
			return el;
		};
		
		this.addListeners = function()
		{
			var trEls = document.querySelectorAll("#outputel #dmfilestable tr");		//No I18N
			
			for(var i=0; i<trEls.length; i++)
			{
				var tr = trEls[i];
				ZDBUtil.setNamedChildEls(tr,tr);
				tr.editicon.onclick = this.renameFile;
				tr.deleteicon.onclick = this.deleteFile;
			}
		};
		
		this.renameFile = function()
		{
			var curMeth = this;
			var tr = ZDBUtil.getParentWithTagName(this, "tr");		//No I18N
			ZDBUtil.setNamedChildEls(tr,tr);
			this.curFile = tr.filename;
			var oldVal = tr.filename.innerHTML;
			var fileId = tr.filename.getAttribute("fileid");
			this.newfileName = prompt("Enter the new file name.",oldVal);		//No I18N
			if(!this.newfileName || oldVal == this.newfileName)
			{
				return;
			}
			this.newfileName = this.newfileName.trim(); 
							
			var params = "&ZDBACTION=RENAMEFILE&FILENAME="+this.newfileName+"&DFSID="+fileId+	//No I18N
        "&DMID="+DMCache.getDomainMap().get("DMID");	//No I18N
			AjaxAPI.sendRequest({
				URL : "/ZDBDomainAction.ma",					//No I18N
				METHOD : "POST",								//No I18N
				PARAMETERS : params,
				ONSUCCESSFUNC : function(){
					curMeth.curFile.innerHTML = curMeth.newfileName;
				},
				ONFAILUREFUNC : GT.handleFailure,
				NOSUBREQPARAM : true
			});
			 
		};
		
		this.deleteFile = function()
		{
			var curMeth = this;
			this.tr = ZDBUtil.getParentWithTagName(this, "tr");	//No I18N
			var prpt = confirm("Do you want to delete this file? " +	//No I18N
					"Kindly note that once removed the file cannot retrive.");	//No I18N
			if(prpt == false)
			{
				return;
			}
			var fileId = this.tr.filename.getAttribute("fileid");
			var params = "&ZDBACTION=DELETEFILE&DFSID="+fileId+"&DMID="+DMCache.getDomainMap().get("DMID");	//No I18N
			AjaxAPI.sendRequest({
				URL : "/ZDBDomainAction.ma",					//No I18N
				METHOD : "POST",								//No I18N
				PARAMETERS : params,
				ONSUCCESSFUNC : function(){
					var row = curMeth.tr;
					row.parentNode.removeChild(row);
				},
				ONFAILUREFUNC : GT.handleFailure,
				NOSUBREQPARAM : true
			});
		};
	}
	return this;
}
