 //$Id$

var ZDBSheetFormat = new function()
{  
  this.decimalSeparator = function(displayValue,cellObj)
  { 
    var deciSep = ZDBConst.DECISEPSYMBOL[cellObj.colObj.decimalSeparator];
    if(deciSep != ZDBConst.DEFAULT_DECISEPSYMBOL)
    {
      displayValue = ZDBFunctions.replace(displayValue,ZDBConst.DEFAULT_DECISEPSYMBOL,deciSep);
    }
    return displayValue;
  }
  
  this.decimalPalces = function(displayValue,cellObj)
  {
    var decimalPlaces = cellObj.colObj.decimalPlaces;
    if(decimalPlaces && decimalPlaces != -1)
    {
      var deci = Math.pow(10,decimalPlaces);
      displayValue = Math.round(displayValue * deci) / deci;
      displayValue = displayValue+'';
      var deciVal = displayValue.split('.');
      if(deciVal.length == 1)
      {
        deciVal[1] = "";
      }
      if(deciVal[1].length < decimalPlaces)
      {
        var size = decimalPlaces - deciVal[1].length;
        for(var i = 0; i < size; i++)
        {
          deciVal[1] = deciVal[1] + "0";
        } 
      }
      displayValue = deciVal[0]+'.'+deciVal[1];
    }
    
    else if(decimalPlaces == 0)
    {
      displayValue = Math.round(displayValue);
    }
    return this.decimalSeparator(displayValue,cellObj);
  }
   
  this.showSymbol = function(menu, event)
  {
    var showSymbol = $("ZDBShow"+menu).checked;
    var gridObj = ZDBUtil.getPropertyFromEl(menu, 'gridObj','object');  //No I18N
    var colHead = gridObj.getSelectedColHead();
    if(colHead.showSymbol == showSymbol)
    {
      return;
    }  
    colHead.showSymbol = showSymbol;
  }
  
  this.setDateFormatEnable = function(event,noEvent)
  {
    var srcEl = noEvent ? event : ZDBUtil.getSourceElement(event);     
    if(srcEl && srcEl.tagName != "INPUT")
    {
        var formatTD = DOMUtils.getElOrParentWithAttr(srcEl,"ISDATE");  //No I18N
        if(formatTD)
        {
            if(ZDBSheetFormat.prevDateTD)
            {
                ZDBSheetFormat.prevDateTD.className = "optionnotselected";
            }    
            var formatInfo = formatTD.getElementsByTagName("SPAN");
            formatTD.className = "optionselected";
            var parDlg = jQuery(formatTD).parents("#ZDBDateTable").get(0); //No I18N
            jQuery(parDlg).find("#cusDateSample").val(formatInfo[0].innerHTML.trim());//No I18N
            jQuery(parDlg).find("#cusDateFormat").val(formatInfo[1].innerHTML.trim());//No I18N
            ZDBSheetFormat.prevDateTD = formatTD;
            formatTD.removeAttribute("oldClass");      
        }
    }  
  }
  
  this.setSampleDate = function()
  {
    var curFormat = $("cusDateFormat").value;
    var sampleEl = $("cusDateSample");
    sampleEl.value = ZDBImport.getSampleDate(curFormat);
    return curFormat;  
  } 
  
  this.dateFormat = function(displayValue, cellObj)
  {
    var dateFormat = (cellObj.colObj && cellObj.colObj.dateFormat) ? cellObj.colObj.dateFormat : ZDBConst.DEFAULT_DATE_FORMAT;
    if(dateFormat.toUpperCase().indexOf("MILLI") != -1)
    {
      var date = Date.parse(displayValue);
      if(isNaN(date))
          {
            displayValue  = displayValue.replace(/[.\-]/g, "/");//reset this line and change the below line accordingly
            displayValue = displayValue.replace(/\/\d{6}/g,"");
            displayValue = displayValue.replace(/\/\d{3}\b/g,"");
            date = Date.parse(displayValue);
          }
          return date;
    }
    else
    {
    	var format = ZDBUtil.calendarDateFormat(dateFormat);
        var date;
        if(!isNaN(displayValue))
        {
        	date = new Date(parseInt(displayValue));
        	if(ZDBGlobal.useUTC)
        	{
        		date = new Date(date.getUTCFullYear(),date.getUTCMonth(),date.getUTCDate(),date.getUTCHours(),date.getUTCMinutes(),date.getUTCSeconds(),date.getUTCMilliseconds());
        	}
        }
        else
        {
      	  date = Date.parseDate(displayValue,"%d %b, %Y %H:%M:%S.%f");   //No I18N      
        }
        return date.print(format);
    }
  }
  
  this.showNegativeSign = function(displayValue,cellObj)
  {
    var negativeSign = cellObj.colObj.showNegativeSign;
    var value = displayValue;
    if(!negativeSign)
    {
      if(value.search("-") != -1)
      {
        value = value.replace("-","");
        value = "(" + value + ")";      
      }
    }
    return value;
  }
  
  this.showDateFormats = function(dateFormat,dateList)
  {
    var matchTd = ZDBSheetFormat.getDateStrTD(dateFormat);
     if(matchTd) 
    {
        ZDBSheetFormat.setDateFormatEnable(matchTd,true); 
    }
    else
    { //Setting Default Val
        var defDateList = jQuery("#ZDBDATEFORMATS").find("div[DEFAULTDATEGROUP='true']");//No I18N
        jQuery("#ZRSDateListHolder").html(defDateList.clone().show());//No I18N
    }
  }
  
  this.setAllDateGroupVisible = function(dateList)
  {
    var trs = dateList.getElementsByTagName("TR");
    var trLen = trs.length;
    for(var i=0; i<trLen; ++i)
    {
        if(trs[i].getAttribute("DATEGROUP"))
        {
            trs[i].isVisible = false;
            ZDBImport.setDateGroupVisible(trs[i]);
        }
    }
  }
  
  this.getDateStrTD = function(formatStr)
  {
      var dateFormatDIV = ZDBUtil.getCachedRef(this, "ZDBDateForList"); //No I18N
      var tds = dateFormatDIV.getElementsByTagName("TD");
      var len = tds.length;
      for(var i=0;i<tds.length;++i)
      {
          var curTd = tds[i];
          if(ZDBUtil.getAttribute(curTd,"ISDATE"))
          {
              var spans = curTd.getElementsByTagName("span"); 
              var curFormat = spans[1].innerHTML.trim();
              if(curFormat == formatStr)
              {
                  return curTd;            
              }
          }          
      }
      return null;
  }
  
  this.showDateFormatDlg = function(element,event)
  {
	if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js,format/js/ZDBSheetFormatExtn.js",this,ZDBSheetFormat.showDateFormatDlg,[element,event]))
	{
		return;
	}
    var gridObj = ZDBUtil.getPropertyFromEl(element, 'gridObj','object');       //No I18N
    var el = ZDBUtil.getCachedRef(this, "ZDBCDTDateFormat");    //No I18N
    el.style.display = "block";
    title=ZDBI18NMap.g("zrpt.common.dateformat.js.dlgTtl",el);
    var element = ZDBUtil.getCachedRef(this, "ZDBDateFormatList");  //No I18N
    var dateFormatTbl = element.cloneNode(true);
    var dateList = $("ZDBCDTDateForList");
    dateList.innerHTML="";
    dateList.appendChild(dateFormatTbl);
    ZDBSheetFormatExtn.removeMiscOption(dateList);
    ZDBSheetFormatExtn.showOrHideDateLists(dateList);
    var dateFormat = $("ZDBCDTDateFrmtBox").value;
    ZDBSheetFormat.setAllDateGroupVisible(dateList);
    hideCustomMessage();
    ZDBDialogUtil.showDialog(el,{TITLE:title,ADDFRAME:true,MODAL:true,DONTREMOVE:true});    
    $("CDTcusDateFormat").value = dateFormat;
    $("CDTcusDateSample").value = ZDBImport.getSampleDate(dateFormat);
  }
  
  this.setDateFormatValue = function(event,noEvent)
  {
    var srcEl = noEvent ? event : ZDBUtil.getSourceElement(event);     
    if(srcEl && srcEl.tagName != "INPUT")
    {
        var formatTD = DOMUtils.getElOrParentWithAttr(srcEl,"ISDATE");  //No I18N
        if(formatTD)
        {
            if(ZDBSheetFormat.prevDateTD)
            {
                ZDBSheetFormat.prevDateTD.className = "optionnotselected";
            }    
            var formatInfo = formatTD.getElementsByTagName("SPAN");
            formatTD.className = "optionselected";
            $("CDTcusDateSample").value = formatInfo[0].innerHTML.trim();
            $("CDTcusDateFormat").value = formatInfo[1].innerHTML.trim();
            ZDBSheetFormat.prevDateTD = formatTD;
            formatTD.removeAttribute("oldClass");      
        }
    }  
  }  
  
  this.validateDateFormat = function(form, event)
  {
    var dateFormatTxtBox = $("CDTcusDateFormat"); 
    var dateFormat = dateFormatTxtBox.value;
    if(dateFormat.trim())
    {
        var url = "/ZDBImportData.ve?ZDBACTION=DATEFORMATVALIDATE&DATEFORMAT=" + encodeURIComponent(dateFormat); //No I18N
        AjaxAPI.sendRequest({URL:url,ONSUCCESSFUNC:"ZDBSheetFormat.setDateFormatInTxt",OPSTATUSID:"ZDBCDTDATEFORMATOPTSTATUS"});    //No I18N
    }
      
  }

  this.setDateFormatInTxt = function(response,requestOptions)
  {
    if(response.responseText == "false")
    {
        var dfEl = $("CDTcusDateFormat"); 
        showCustomMessage(ZDBI18NMap.g("zrpt.common.sheetformat.custommsg.js.invalidDateFormatStr"), dfEl);
    }
    else
    {
      var dateFormat = $("CDTcusDateFormat").value;
      ZDBDialogUtil.closeDialog();
      $("ZDBCDTDateFrmtBox").value = dateFormat;
      $("ZDBCDTDateFrmtSample").value = "(" + dateFormat + ")";
      $("ZDBCDTSampleDateFrmt").value = ZDBImport.getSampleDate(dateFormat);
    }
  }  
  
  this.setSampleDateValue = function()
  {
    var dateFormat = $("CDTcusDateFormat").value;
    $("CDTcusDateSample").value = ZDBImport.getSampleDate(dateFormat);
    return dateFormat;  
  }
  
  this.constructFormatOptsAsParams = function(colHead)
  {
	var params = "";
	var dataType = colHead.typeNo;
	var dataTypeFormatType = ZDBUtil.datatypeVsFormatType[ZDBUtil.dataTypeNumVsSubtypeDisp[dataType]];
	
	params += "&ALIGNLIST=" + colHead.alignment;	//No I18N
	
	if(dataType == ZDBConst.URL)
	{
	  var altTextInp = colHead.altText;
	  params += (altTextInp && altTextInp != "") ? "&ALTTEXT=" + altTextInp : "";
	}
	
	if(dataType == ZDBConst.DATE || dataType == ZDBConst.DATE_AS_DATE)
	{
	  params += "&CusDateFormat=" + colHead.dateFormat;	//No I18N
	}
	
	if(dataTypeFormatType != "Text" && dataTypeFormatType != "Date")
	{
	  params += "&LOCALE=" + colHead.userLocale;		//No I18N
	  params += "&THOUSEPARATOR=" + colHead.thousandSeparator;		//No I18N
	}
	
	if(dataType != ZDBConst.PERCENT && dataTypeFormatType != "Text")
	{
	  var units = colHead.unitsSymbol;
	  params += "&UnitsList=" + units;	//No I18N  
	}
	
	if((((dataType == ZDBConst.NUMBER || dataType == ZDBConst.POSITIVE_NUMBER) && units!="None") || dataType == ZDBConst.DECIMAL_NUMBER || dataType == ZDBConst.CURRENCY || dataType == ZDBConst.PERCENT))
	{
	  params += "&DECIPLACES=" + colHead.decimalPlaces;		//No I18N
	  params += "&DECISEPARATOR=" + colHead.decimalSeparator;		//No I18N
	}
	
	if(dataType == ZDBConst.CURRENCY)
	{
	  params += "&CountryNameList=" + colHead.currencyFormat.split(":")[0];		//No I18N
	  params += "&Negative=" + ((colHead.showNegativeSign) ? "true" : "false");		//No I18N
	}
	
	if(dataType == ZDBConst.PERCENT)
	{
	  params += "&ShowPercent=" + colHead.showSymbol;		//No I18N
	}
	return params;
  }
}


