//$Id$
MCEffect.CONFIG.INTERVAL = 2;

StatusMsgAPI.showMsg = function(message,isSuccess,fadeout,msgDivId)
{
  if(isSuccess)
  {
    ZDBMsgBox.showSuccess(message);
  }
  else
  {
    ZDBAlertAPI.showMsg(message,"ZDBERROR")
  }
}


StatusMsgAPI.showErrorMsg = function(message)
{
  ZDBAlertAPI.showErrorMsg(message);
}

AjaxAPI.ONFAILUREFUNCHANDLED= true;

AjaxAPI.onFailureFunc = function(response,requestOptions)
{
  var msg = response.getResponsePart("STATUS_MESSAGE");
  var errorCode = response.getResponsePart("ERRORCODE");
  if(errorCode == ""){ errorCode = null;}
  if(msg == null)
  {
    var respStatus = response.getResponseStatus();
    var respStatusText = response.getResponseStatusText();
    if((respStatusText != null) && (respStatusText != "Unknown"))
    {
      msg = respStatusText;
    }
    else if((respStatus >= 400) && (respStatus < 500))
    {
      msg = "Bad Http Request";
    }
    else if((respStatus >= 500) && (respStatus < 600))
    {
      msg = "Internal Server Error.";
    }
    else
    {
      msg = AjaxAPI.getErrorMsgFromCode(respStatus);
    }

    if(msg == null)
    {
      msg = "Error Occurred.";
    }
    var msgPrefix = requestOptions["ERRORPREFIX"];
    if(msgPrefix == null){msgPrefix = "Unable to process the request.<br> Reason : "}
    msg = msgPrefix + msg  + "<br>(Code : " + respStatus + ")";
  }

  //$$ Temporary hack for message for disabling specific feature
  if(errorCode != null &&
     errorCode.trim() == 'FEATURE_DISABLED')
  {
    var arr = msg.split(';');
    arr[1] = '<B>' + new Date(arr[1]).toLocaleString() + '</B>'; //start date
    arr[3] = '<B>' + new Date(arr[3]).toLocaleString() + '</B>'; //end date
    msg = arr.join("");
  }

  var dataSizeLargeErrors=['DATA_SIZE_LARGE_SCHEDULE_ERROR','DATA_SIZE_LARGE_SESSION_ERROR','DATA_FETCH_SESSION_TIMEOUT_ERROR']; // No I18N
  
  var featureViolationErrors = ['EXCEEDING_USR_PLN_ROWCOUNT', 'EXCEEDING_USR_PLN_DBCOUNT', 'EXCEEDING_USR_PLN_QTCOUNT', 'EXCEEDING_USR_PLN_USRCOUNT', 'ROWCNT_VIOLATION_CREATE_TBL', 'TRIAL_NOT_ALLOWED','ROWCNT_VIOLATION_COPY_DB', 'MULTIPLE_DBOWNERS_NOT_ALLOWED', 'QTCNT_VIOLATION_COPY_DB', 'SCH_IMPORT_NOT_ALLOWED', 'USRCOUNT_VIOLATION_USRACTIVATE', 'HACKING_MANAGE_QUERYTABLE_TAB', 'REBRAND_NOT_ALLOWED', 'BACKUP_NOT_ALLOWED', 'NO_EXTRA_USERS_FOR_FREE_PLAN', 'DEACTIVATED_QRY_TABLE', 'EXCEEDING_USR_PLN_REPORTCOUNT', 'REPORTCNT_VIOLATION_COPY_DB', 'REGENERATE_VIOLATION', 'PUBLISHCNT_VIOLATION', 'SHARING_TO_DBGROUP_VIOLATION', 'CREATE_DBGROUP_VIOLATION', 'EXCEEDING_USR_PLN_SCHMAILCOUNT', 'SCHMAIL_NOTSUPPORTED', 'MAIL_NOTSUPPORTED', 'PUBLIC_DB_LISTING_REMOVAL_NOT_ALLOWED','ZOHO_PROJECTS_INTEG_NOT_ALLOWED','GANALYTICS_MULTI_CLIENT_NOT_ALLOWED','SLIDESHOW_NOT_ALLOWED','NO_USER_ADDITION_ALLOWED_IN_FREE_EDITION','LIVECHAT_NOT_ALLOWED']; //No I18N

  var planChangeErrors = ['INVALID_PLANID', 'INVALID_USERID', 'PLAN_CHANGE_FAILED', 'TRIAL_REQUEST_FAILED', 'TRIAL_DOWNGRADE_FAILED', 'PLAN_CHANGE_PAYMENT_FAILED']; // No I18N

  if(AjaxAPI.isPricingErrorCode(featureViolationErrors, errorCode))
  {
    var arr = msg.split(';');
    if(arr[1] != null)
    {
    	var upgradeTabLink = ZDBGlobal.upgradeLink;

    	if(ZDBGlobal.IS_ONPREMISE_BUILD + "" == "true")
    	{
    		if(ZDBGlobal.IS_FREE_EDITION)
    		{
    			var compareTabLink=ZDBI18NMap.g("zrop.license.compare.js.editions");
    			arr[1]='<a href="'+compareTabLink+ '" target="_blank"">'+arr[1]+'</a>';
    		}
    		else
    		{
    			arr[1]='<a href=ZROPSettings.cc#licencetab>'+arr[1]+'</a>';
    		}
    	}
    	else
    	{
    		var target = typeof CrmPlusImpl !== 'undefined' && CrmPlusImpl.isLoadedInCrmplus() ? "_blank" : "_self";//No I18N
    		arr[1] = '<a href="'+upgradeTabLink+'" target="'+target+'">' + arr[1] + '</a>';
    	}
    	msg = arr.join("");
    }
  }
  else if (errorCode != null && (errorCode.trim() == 'USER_NOT_EXISTS_IN_CRMPLUS' || errorCode.trim() == 'USER_NOT_EXISTS_IN_ZOHOONEORG'))
  {
    var arr = msg.split(';');
    if(arr[1] != null)
    {
    	if(ZDBGlobal.isZohoBundleOrgObjPresent){
    		arr[1] = '<a href="javascript:ZRCRMPlus.manageUser();">' + arr[1] + '</a>';
    	}
    	else{
    		arr[1] = '<a href="' + ZDBGlobal.zohoSuiteManageUsersLink + '" target="_blank">' + arr[1] + '</a>';
    	}
    }
    msg = arr.join("");
  }
  else if (errorCode != null && errorCode.trim() == 'SHARE_TO_DEACTIVATED_USR')
  {
    var arr = msg.split(';');
    if(arr[1] != null)
    {
    	if(ZDBGlobal.IS_ONPREMISE_BUILD+""=="true")
    	{
    		arr[1]='<a href=ZROPSettings.cc#usertab>'+arr[1]+'</a>';

    	}
    	else if(ZDBGlobal.canRedirectZohoOneOrgPage)
    	{
    		if(ZDBGlobal.isZohoBundleOrgObjPresent){
    			arr[1] = '<a href="javascript:ZRCRMPlus.manageUser();">' + arr[1] + '</a>';
    		}
    		else{
    			arr[1] = '<a href="' + ZDBGlobal.zohoSuiteManageUsersLink + '" target="_blank">' + arr[1] + '</a>';
    		}
    	}
    	else
    	{
    		var aHref = ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBPricing.cc?SHOWPAGE=ManageUsers&STRUCT=true&ZDBACTION=MANAGEUSERS"; //NO I18N
    		arr[1] = '<a href="'+aHref+'">' + arr[1] + '</a>';
    	}

    }
    msg = arr.join("");
  }
  else if (errorCode != null && errorCode.trim() == 'ZROP_MAILCONFIG_MUST_TOSHARE_USERS')
  {
      var arr = msg.split(';');
      if(arr[1] != null)
      {
        arr[1]='<a href=ZROPSettings.cc#mailtab>'+arr[1]+'</a>';
      }
      msg = arr.join("");
  }
  else if (errorCode != null && errorCode.trim() == 'ZROP_SHARE_TO_DEACTIVATEDUSER_FOR_ADMIN')
  {
      var arr = msg.split(';');
      if(arr[1] != null)
      {
        arr[1]='<a href=ZROPSettings.cc#usertab>'+arr[1]+'</a>';
      }
      msg = arr.join("");
  }
  else if (errorCode != null && errorCode.trim() == 'ZROP_SHARE_TO_REVOKED_ACCESS_USER')
  {
      var arr = msg.split(';');
      if(arr[1] != null)
      {
        arr[1]='<a href=ZROPSettings.cc#manageusertab>'+arr[1]+'</a>';
      }
      msg = arr.join("");
  }
  else if(AjaxAPI.isPricingErrorCode(planChangeErrors, errorCode))
  {
    var arr = msg.split(':');
    arr[1] = '<a href="mailto:' + arr[1] +'">' + arr[1] + '</a>';
    msg = arr.join("");
  }
  else if(AjaxAPI.isPricingErrorCode(dataSizeLargeErrors, errorCode) && ZDBGlobal.IS_ONPREMISE_BUILD + "" == "true")
	    {
	  	var arr = msg.split(';');
	    if(arr[1] != null)
		    {
		  	  var link=ZDBI18NMap.g("zrpt.databasedataerr.js.link");
	          arr[1]='<a href="'+link+ '" target="_blank"">'+arr[1]+'</a>';
	        }
	    msg = arr.join("");
	    }
  else if('DB_CONN_ERR_SOCK_ERROR' == trimAll(errorCode)){
	var arr = msg.split(';;;');
        var cloudDBIPHelpDocLink = ZDBGlobal.IP_HELP_DOC;
        if(arr.length == 9){
                arr[1] =  "<b>"+arr[1]+"</b>";
                arr[3] =  "<b>"+arr[3]+"</b>";
                arr[5] =  "<a href='"+cloudDBIPHelpDocLink+"' target='_blank'>"+arr[5]+"</a>";
                arr[7] =  "<a href='"+cloudDBIPHelpDocLink+"' target='_blank'>"+arr[7]+"</a>";
                msg = arr.join('');
        }
        else{
                console.log("Malformed CloudDB ErrorMegssage: "+msg);
        }
  }
  else if('DB_CONN_ERR_LOGIN' == trimAll(errorCode) || 'DB_CONN_ERR_DB_NOT_PRESENT' == trimAll(errorCode)){
	  var arr = msg.split(';;;');
	  if(arr.length == 3){
		  arr[1] = "<b>"+arr[1]+"</b>";
		  msg = arr.join('');
	  }
	  else{
		  console.log("Malformed CloudDB ErrorMegssage: "+msg);
	  }
  } 	
  

  ZDBAlertAPI.showErrorMsg(msg,null,errorCode);

  if(requestOptions["ONFAILURECLEANUPFUNC"])
  {
    requestOptions.fn("ONFAILURECLEANUPFUNC")(response,requestOptions);
  }
}

AjaxAPI.isPricingErrorCode = function(pricingErrorCodes, errorCode)
{
  if(errorCode == null)
  {
    return false;
  }
  for (var i = 0; i < pricingErrorCodes.length; i++)
  {
    var pricingErrorCode = pricingErrorCodes[i];
    if (errorCode.trim() == pricingErrorCode)
    {
      return true;
    }
  }
  return false;
}

AjaxAPI.getErrorMsgFromCode = function(errorCode)
{
  var err  = ZDB_ERROR_CODES["XHRERR_" + errorCode];
  return (err != null)? err[1]: null;
}


//client side error logging - start
function getErrorType(stackStr){
	var bracIndex = stackStr.indexOf(" (http");
	bracIndex = (bracIndex == -1)?(stackStr.indexOf("http")):bracIndex;
	if(bracIndex != -1){
		return stackStr.substring(0, bracIndex);
	}
	else{
		return "";
	}
}

function globalErrorHandler(errorMsg, url, lineNumber, columnNumber, errorObj, count)
{
  if ((errorMsg.indexOf('Script error.') > -1)) {
        return;
    }
  if(ZDBGlobal.isClientErrorLoggingEnabled && !ZDBClientUI.readOnlyMode)
  {
    if(!count)
    {
      count = 0;
    }
    try
    {
      var errorObjName = null;
      var errorObjStack = null;
      var errorType = null;
      if(errorObj)
      {
        errorObjName = errorObj.name;
        errorObjStack = errorObj.stack;
        errorType = getErrorType(errorObjStack).replace(/([-+.^:,&#?^%<>@*!'\"])/g, "_");
        errorObjStack = errorObjStack.replace(/([-+.^:,&#?^%<>@*!'\"])/g, "_");
      }
      else
      {
        errorObjName = "UNSUPPORTED_BROWSER"; //NO I18N
        if(globalErrorHandler.caller)
        {
          errorObjStack = globalErrorHandler.caller.toString().substr(0,300);
          errorType = "";
          errorObjStack = errorObjStack.replace(/([-+.^:,&#?^%<>@*!'\"])/g, "_");//NO I18N
        }
        else
        {
          return;
        }
      }
	  url = url.replace(/([-+.^:,&#?^%<>@*!'\"])/g, "_").replace(/\r?\n|\r/g, "_");
      errorMsg = errorMsg.replace(/([-+.^:,&#?^%<>@*!'\"])/g, "_");      
      var jsErrorPresent = ZDBUtil.getValueFromLocal("jserrors");//NO I18N
      if(jsErrorPresent)
      {
        var jsErrors = JSON.parse(ZDBUtil.getValueFromLocal("jserrors"));//NO I18N
        var jsKeys = Object.keys(jsErrors);
        var jsErrArr = [];
        for(var i=0; i<jsKeys.length; i++)
        {
          jsErrArr = jsErrors[jsKeys[i]];
          if((jsErrArr[0] == ZDBGlobal.zuID) && (jsErrArr[1] == errorMsg) && (jsErrArr[5] == lineNumber) && (jsErrArr[6] = columnNumber))
          {
            jsErrArr[8] += 1;
            jsErrors[jsKeys[i]] = jsErrArr;
            ZDBUtil.setValueToLocal("jserrors", JSON.stringify(jsErrors));//NO I18N
            return;
          }
        }
      }
      var errorCount = 1;   
      var time = new Date();
      time = time.getTime();
      var errorID = "jserror_"+Math.random().toString(36).substring(2);//NO I18N
      var error = [ZDBGlobal.zuID, errorMsg, url, errorObjStack, errorObjName, lineNumber, columnNumber, time, errorCount, ZDBGlobal.emailID, BROWSER.browserNdVersion, errorType];
      if(jsErrorPresent)
      {
        var jsErrors = JSON.parse(ZDBUtil.getValueFromLocal("jserrors"));//NO I18N
        ZDBUtil.deleteValueFromLocal("jserrors");//NO I18N
        jsErrors[errorID] = error;
        ZDBUtil.setValueToLocal("jserrors", JSON.stringify(jsErrors));//NO I18N
      }
      else
      {
        var jsErrors = {};
        jsErrors[errorID] = error;
        ZDBUtil.setValueToLocal("jserrors", JSON.stringify(jsErrors));//NO I18N
      }
    }
    catch(exception)
    {
      if(count < 2)
      {
        saveJSErrorsToServer();
        window.onerror(errorMsg, url, lineNumber, columnNumber, errorObj, ++count);
      }
    }
  }
  else
  {
    ZDBUtil.deleteValueFromLocal("jserrors");//NO I18N
  }
}
window.onerror = globalErrorHandler;

function saveJSErrorsToServer()
{
  if(ZDBGlobal.isClientErrorLoggingEnabled && ZDBUtil.getValueFromLocal("jserrors") && !ZDBClientUI.readOnlyMode)
  {
    var params = "JSONSTRING=" + ZDBUtil.getValueFromLocal("jserrors");//No I18N
      var url = "/ZDBClientErrorLog.ma?ZDBACTION=CLIENTERRORLOG";//No I18N 
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
              ONSUCCESSFUNC:onSuccessFuncJSErrorHand,//NO I18N
              ONFAILUREFUNC:function(){ZDBUtil.deleteValueFromLocal("jserrors");}//NO I18N
              });
  }
  else
  {
    ZDBUtil.deleteValueFromLocal("jserrors");//NO I18N
  }
}

function onSuccessFuncJSErrorHand(response, requestOptions){
  var boolStr = response.getResponseParams().CLIENTERRORLOGGINGENABLED;
  if(boolStr === "true"){
    ZDBGlobal.isClientErrorLoggingEnabled = true;
  }
  else{
    ZDBGlobal.isClientErrorLoggingEnabled = false;
  }
  ZDBUtil.deleteValueFromLocal("jserrors");//NO I18N
}
setInterval(this.saveJSErrorsToServer, 300000);

//client side error logging - end



AjaxUtils.extractFromResponse = function(responseText,responsePart)
{
  
  var index = (responseText.length > 1000)? (responseText.length - 1000):0;
  index = responseText.indexOf(responsePart + "_START",index);
  if(index  == -1)
  {//No Error - Check on the top.
    index = (responseText.length > 1000)? 1000:responseText.length;
    index = responseText.lastIndexOf(responsePart + "_START",index);
  }
  
  if(index == -1)
  {
    return null;
  }
  index = index +responsePart.length + "_START".length;
  var endIndex = responseText.indexOf(responsePart + "_END",index);
  if(index == -1)
  {
    return null;
  }
  return responseText.substring(index,endIndex);
}

AjaxUtils.handleReLogin = function(response,requestOptions)
{
  ZDBAlertAPI.showErrorMsg("You seem to have signed out. Please refresh the page to login again.");
}

AjaxAPI.checkAttrForInvokeScript=true;

AjaxAPI.statusSearchIndex=200;

if(window.findPosX == null)
{//Fix for sheet- They don't want it to be overridden.
findPosX = ZDBUtil.getObjLeft;
findPosY = ZDBUtil.getObjTop;
getCursorPos = ZDBUtil.getCursorPos;
}


var MCFrame = new function(){

  this.getMCFrame = function(){
    return null;
  }

}

function showCustomMessage(message, curId, cssName){
_FRM_CURRENT_ERROR_FIELD = curId;
var obj = document.getElementById("customAlertMessage");
var ifrmObj = document.getElementById("_CUSTOMALERTFRAME");
if (ifrmObj == null) {
var newObj = document.createElement("iframe");
if(browser_ie){
newObj.id="_CUSTOMALERTFRAME";
newObj.style.position="absolute";
newObj.style.cursor="default";
newObj.style.display = "none";
newObj.style.border = "0px solid";
newObj.frameBorder = "0";
newObj.scrolling = "no";
if(window["CONTEXT_PATH"] != null)
{
newObj.src= ZDBGlobal.REPORTS_CONTEXT_NAME + CONTEXT_PATH + "/framework/html/blank.html";
}
}
else if (browser_nn4 || browser_nn6){
newObj.setAttribute("id","_CUSTOMALERTFRAME");
newObj.setAttribute("frameBorder","0");
newObj.setAttribute("style","position: absolute; cursor: default; display:none;");
}
document.body.appendChild(newObj);
ifrmObj = newObj;
}
if(obj == null){
var newObj = document.createElement("DIV");
if(browser_ie){
newObj.id="customAlertMessage";
newObj.style.position="absolute";
newObj.style.cursor="default";
newObj.style.display = "none";
}
else if (browser_nn4 || browser_nn6){
newObj.setAttribute("id","customAlertMessage");
newObj.setAttribute("style","position: absolute; cursor: default; display:none;");
}
document.body.appendChild(newObj);
obj = newObj;
}
obj.custMsg = message;

var code = getCustomAlert(cssName);
code = code.replace("$MESSAGE", message);
obj.innerHTML = code;
obj.style.left = ZDBUtil.getObjLeft(curId,true)+"px";
obj.style.top = ZDBUtil.getElementAbsoluteTop(curId) + curId.offsetHeight+"px";
obj.style.width = curId.parentNode.offsetWidth + "px";
obj.style.zIndex = 200000;
ifrmObj.style.left = ZDBUtil.getObjLeft(curId,true)+"px";
ifrmObj.style.top = findPosY(curId,true) + curId.offsetHeight+"px";
ifrmObj.style.width = curId.parentNode.offsetWidth - 5 + "px";

ifrmObj.style.zIndex = obj.style.zIndex - 1;
ifrmObj.style.display = 'block';
obj.style.display = "block";

ifrmObj.style.height = obj.offsetHeight+"px";
ifrmObj.className = "alpha0";
}
function hideCustomMessage(){
if(typeof(_FRM_CURRENT_ERROR_FIELD) != "undefined" && _FRM_CURRENT_ERROR_FIELD != null){
document.getElementById("_CUSTOMALERTFRAME").style.display = "none";
document.getElementById("customAlertMessage").style.display = "none";
if(_FRM_SET_FAILED_FOCUS && _FRM_CURRENT_ERROR_FIELD.focus){
_FRM_CURRENT_ERROR_FIELD.focus();
}
_FRM_CURRENT_ERROR_FIELD = null;
}
ZDBUtil.detachEvent(document, 'click', hideCustomMessage, true);
}


//Hopefully be called only during error!!
//function showDialog(html,params)
//{
//  ZDBAlertAPI.showErrorMsg(html);  
//}
