//$Id$
//Edited
/*Import Methods*/

var ZDBImport = new function(){}

ZDBImport["dateSampleList"] = [  
    {yyyy: '2014'},
    {yy: '14'},
    {MMMM: 'November'}, //No I18N
    {MMM: 'Nov'},   //No I18N
    {MM: '11'},
    {dd: '24'},
    {EEEE: 'Friday'},   //No I18N
    {EEE: 'Fri'},   //No I18N
    {' a': ' AM'},  //No I18N
    {HH:'22'},
    {kk: '23'},
    {KK: '10'},
    {hh: '02'},
    {mm: '47'},
    {ss: '59'},
    {SSS:'123'},
    {z: 'GMT+05:30'},   //No I18N
  {Z: '+0530'},
    {MILLI: '1353492452'},
    {qqqq: 'Quarter4'}, //No I18n
    {qq: 'Q4'} // No I18n
    
]


ZDBImport.showDateFormats = function(srcEl)
{
	if(!ZDBLazyLoadUtil.loadJsAlone("format/js/ZDBSheetFormatExtn.js","APPENDTODOC",ZDBImport.showDateFormats,[srcEl]))//NO I18N
    {
		return;
    }
    ZDBToolTip.hideTip();
    ZDBImport.curForm = ZDBUtil.getParentWithTagName(srcEl, "FORM");    //No I18N
    var dateDlg = ZDBUtil.getCachedRef(ZDBImport, "ZDBDATEFORMATS");    //No I18N
    ZDBUtil.getCachedRef(ZDBImport, "CUSTDATEFRM"); //No I18N
    ZDBImport.resetDateDlg(dateDlg);
    dateDlg.style.display="";
    ZDBDialogUtil.showDialog(dateDlg,{TITLE:ZDBI18NMap.g('zrpt.common.import.dateformat.js.chooseDlg'),ADDFRAME:true,MODAL:true,DONTREMOVE:true,ONENTER:ZDBImport.submitUserDate, CALLOUT:true,SRCEL:srcEl});
    var format = ZDBImport.curForm["DATEFORMAT"].value;
    ZDBImport["CUSTDATEFRM"].customDateFormat.value = format;
    ZDBImport["CUSTDATEFRM"].customDateSample.value = ZDBImport.getSampleDate(format);
    var matchTd = ZDBImport.getDateStrTD(format);
    var showHideTr = null;
    if(matchTd)
    {
        ZDBImport.setDateFormatEnable(matchTd,true);
        var dateHeader = jQuery(matchTd).closest('div.ZRSDateListHolder').siblings('.ZRSDateHeader'); //No I18N
        showHideTr = dateHeader.get(0);
    }
    var dateHeaders = jQuery(dateDlg).find('.ZRSDateHeader.selDtHeader').get();
    var len = dateHeaders.length;
    for(var i=0; i<len; i++){
    	ZDBImport.setDateGroupVisible(dateHeaders[i]);
    }
    if(showHideTr){
    	ZDBImport.setDateGroupVisible(showHideTr);
    }
    ZDBSheetFormatExtn.showOrHideDateLists();
    hideCustomMessage();
}



ZDBImport.submitUserDate = function(event)
{
  var dateFormat = ZDBImport["CUSTDATEFRM"].customDateFormat.value;
  if(dateFormat.trim())
  {
    var url = ZDBImport.curForm.getAttribute("action");
    url += "?ZDBACTION=DATEFORMATVALIDATE" + "&DATEFORMAT=" + encodeURIComponent(dateFormat);   //No I18N
    $("ZDBIMPORTDATESTATUS").style.display = "none";
    AjaxAPI.sendRequest({URL:url,ONSUCCESSFUNC:"ZDBImport.handleImportDateValidate",OPSTATUSID:"ZDBIMPORTDATESTATUS"}); //No I18N
    return;
  }
  else
  {
    ZDBImport.updateDateFormat();
  }
}

ZDBImport.handleMilliSecond = function(srcEl)
{
    if(srcEl.getAttribute("name") == "DATEFORMAT" && srcEl.value.toUpperCase() == "MILLI")
    {
        srcEl.value = "MILLI";  //No I18N
    }
}


ZDBImport.setRefreshPending = function(srcEl)
{
    if(srcEl.previousValue == srcEl.value)
    {
        return true;
    }
    ZDBImport.handleMilliSecond(srcEl);
    ZDBImport.isRefreshPending = true;
    ZDBImport.refreshElement = srcEl;
    return true;
}



ZDBImport.importFormElementFocus = function(event, hintMsg)
{
    var srcEl = ZDBUtil.getSourceElement(event);
    var impName = srcEl.getAttribute("IMPNAME");
    var hintEl = $("impSettingsHintEl");
    if(hintEl != null && hintEl != undefined && hintMsg != null)
    {
        hintEl.innerHTML = ZDBI18NMap.g(hintMsg);
    }
    if(ZDBImport.isRefreshPending)
    {
        refreshSampleForm(ZDBImport.refreshElement);
        ZDBImport.isRefreshPending = false;
    }                      
    return true;              
}

ZDBImport.importCreateClick = function(srcEl, isExist)
{
    if(ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBHome" && ZRTour.tourCalled == 3)
    {
       ZRTour.endTour(true);
    }
    
    if(ZDBImport.isRefreshPending)
    {
        ZDBImport.isCreatePending = true;
        refreshSampleForm(ZDBImport.refreshElement);
        ZDBImport.isRefreshPending = false;
    }                                    
    else if(ZDBImport.canProceed)
    {
        ZDBImport.importTable(isExist);   
    }
}


ZDBImport.updateDateFormat = function()
{
    var dateFormatEl = ZDBImport.curForm["DATEFORMAT"];
    var customFormatEl = ZDBImport["CUSTDATEFRM"].customDateFormat;
    var customSampleEl = ZDBImport["CUSTDATEFRM"].customDateSample;
    dateFormatEl.value = customFormatEl.value;
    ZDBImport.setOnDateDiv(customSampleEl.value,dateFormatEl.value); 
    ZDBDialogUtil.closeDialog();
    refreshSampleForm(ZDBImport.curForm["DATEFORMAT"]);
}


ZDBImport.getDefaultDateGroupTR = function()
{
    return jQuery("#ZDBDateFormatList").find("[DEFAULTDATEGROUP='true']").get(0);//No I18N    
}

ZDBImport.getDateStrTD = function(formatStr)
{
    var dateFormatDIV = ZDBUtil.getCachedRef(ZDBImport, "ZDBDATEFORMATS");  //No I18N
    var tds = dateFormatDIV.getElementsByTagName("TD");
    var len = tds.length;
    for(var i=0;i<tds.length;++i)
    {
        var curTd = tds[i];
        if(ZDBUtil.getAttribute(curTd,"DEFAULTDATEGROUP"))
        {
          ZDBImport["DEFAULTDATEGROUP"] = curTd.parentNode;  
        }
        if(ZDBUtil.getAttribute(curTd,"ISDATE"))
        {
            var spans = curTd.getElementsByTagName("span"); 
            var curFormat = spans[1].innerHTML.trim();
            if(curFormat == formatStr)
            {
                return curTd;            
            }
        }
        
    }
    return null;
}

ZDBImport.getSampleDateStr = function(formatStr)
{
    var dateTd = ZDBImport.getDateStrTD(formatStr);
    if(dateTd)
    {
      var spans = dateTd.getElementsByTagName("span"); 
      var curFormat = spans[1].innerHTML.trim();
      if(curFormat == formatStr)
      {
          return spans[0].innerHTML;            
      }
    }
    return "";
}

ZDBImport.setOnDateDiv = function (sampleStr, formatStr)
{
    if(!sampleStr || sampleStr.toLowerCase() == 'null')
    {
        sampleStr = ZDBImport.getSampleDateStr(formatStr);
    }
    var dateFormatEl = ZDBImport.curForm["DATEFORMAT"];
    var dateDiv = ZDBUtil.getParentWithTagName(dateFormatEl, "DIV");    //No I18N
    var spans = dateDiv.getElementsByTagName("span");
    spans[0].innerHTML = sampleStr;

    var formatStr1= "";
    if(formatStr && formatStr != "NODATE")
    {
        spans[1].innerHTML = "(" + formatStr + ")";
        formatStr1 = formatStr;
    }
    else
    {
        spans[1].innerHTML = "";
    }
    dateDiv.tipInfo = {title:'Date Format', tipHTML: 'Sample: ' + (sampleStr ? sampleStr : 'None') + '<BR>' + 'Format: ' + (formatStr1 ? formatStr1 : 'None')}; //No I18N
}

ZDBImport.setToolTip = function(event, isSet)
{
  var srcEl = ZDBUtil.getSourceElement(event);
  var dateDiv = ZDBUtil.getParentWithTagName(srcEl, "DIV");     //No I18N
  isSet ? ZDBToolTip.showTip(event, dateDiv.tipInfo) : ZDBToolTip.hideTip();
}

ZDBImport.onDateKeyDown = function(event)
{
    if(ZDBImport.prevDateTD)
    {
        ZDBImport.prevDateTD.className = "optionnotselected";
        ZDBImport.prevDateTD = null;
    }
}

ZDBImport.setDateGroupVisible = function(selEl)
{
    var actPar = jQuery(selEl).parents(".ZRSDateHeaderPar")[0]; //No I18N
    var dateHeader = jQuery(actPar).children(".ZRSDateHeader").get(0);//No I18N
    var groupDIV = jQuery(actPar).children(".ZRSDateListHolder").get(0); //No I18N
    jQuery(groupDIV).toggle();
    var icon = jQuery(actPar).find("#ZRSOpenRColIcon");
    icon.toggleClass("rotate45 bottomAlign arrowRotate45fix");//No I18N
    jQuery(dateHeader).toggleClass("selDtHeader"); //No I18N
}

ZDBImport.getSampleDate = function(formatStr)
{
  var dateSampleList = ZDBImport.dateSampleList;
  var dateSampleLen = dateSampleList.length;
  var curFormat = formatStr;
  var dateValidChars = ", -:/";
  for(var i=0;i<dateSampleLen;++i)
  {
    var curObj = dateSampleList[i]; ///PK: Can't write a stupid code like this! Must do it correctly.
    for(x in curObj)
    {
        if(curFormat.indexOf(x) >=0)
        {
            curFormat = ZDBUtil.replaceStr(curFormat, x,curObj[x]);
        }
    }
  }
  return curFormat;
}


ZDBImport.setSampleDate = function()
{
  var frm = ZDBImport["CUSTDATEFRM"];
  var curFormat = frm.customDateFormat.value;
  var sampleEl = frm.customDateSample;
  sampleEl.value = ZDBImport.getSampleDate(curFormat);
  return curFormat;
}

ZDBImport.setDateFormatEnable = function(event, noEvent)
{ 
    var srcEl = noEvent ? event : ZDBUtil.getSourceElement(event); 
    
    if(srcEl.tagName != "INPUT")
    {
        var frm = ZDBImport["CUSTDATEFRM"];
        var dfEl = frm.customDateFormat;
        var dsEl = frm.customDateSample;
        var formatTD = DOMUtils.getElOrParentWithAttr(srcEl,"ISDATE");  //No I18N
        if(formatTD)
        {
            if(ZDBImport.prevDateTD)
            {
                ZDBImport.prevDateTD.className = "optionnotselected";
            }    
            var formatInfo = formatTD.getElementsByTagName("SPAN");
            formatTD.className = "optionselected";
            dsEl.value = formatInfo[0].innerHTML.trim();
            dfEl.value = formatInfo[1].innerHTML.trim();
            ZDBImport.prevDateTD = formatTD;
            formatTD.removeAttribute("oldClass");      
        }
    }
}

ZDBImport.handleImportDateValidate = function(response, requestOptions)
{
    if(response.responseText == "true")
    {
        ZDBImport.updateDateFormat();
    }
    else
    {
        var frm = ZDBImport["CUSTDATEFRM"];
        var dfEl = frm.customDateFormat; 
        showCustomMessage(ZDBI18NMap.g('zrpt.common.import.custommsg.js.wrongDtFmt'), dfEl);
    }
    
}

ZDBImport.importTableForLocalDatabase = function(isExist, frm, canOverRide)
{
  var frmOptions = AjaxAPI.getFormAttrsAsOptions(frm);
  if(frmOptions["VALIDATEFUNC"])
  {
    if(!frmOptions.fn("VALIDATEFUNC")(frm))
    {
      return false;
    }
  }
  if(sampleTableGrid == null)
  {
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.parsingErr"));
    return;
  }

  var params = ZRSerialize(frm);
  
  //var frm = document.forms[isExist?"ImportLocalDatabaseForm": "ImportLocalDatabaseForm"];    //No I18N  

  var fieldXML = "<Fields ";    //No I18N
  var typeXML = "<FieldType ";  //No I18N
  var countryXML = "<FieldCountry ";    //No I18N
  var jsonNodeXML = "<JSONNodePath ";    //No I18N
  var fieldNullableXML = "<FIELDNULLABLE "; //No I18N
  var fieldstXML = "<FIELDSUBTYPES "; //No I18N
  var colHeaders = sampleTableGrid.colHeaders;
  var colLen = colHeaders.length;
  var countries = sampleTableGrid.currencyCountries;
  var isSelColExist = false;
  var checked;
  var dataType;
  var curHead;
  var index = 0;
  var fieldst= "";
  var row = getDataTypeRow(isExist);
  if(!isANCTypeUnique(colHeaders))
  {
    return false;
  }


  for(var i =0; i < colLen; i++)
  {
    curHead = colHeaders[i];
    if(curHead.objType !== ZDBConst.COLHEAD)
    {
      continue;
    }
    checked = curHead["importNode"].getAttribute("checked");    //No I18N
    if(!isSelColExist && checked =="true")
    {
        isSelColExist = true;
    }
    
    var selOpt = curHead.dataType[curHead.dataType.selectedIndex];
    dataType = (checked == "true") ? selOpt.value : -2; ///PK: Skip column

    if(curHead.status == ZDBConst.CLEAR)
    {
      var colName = curHead.displayName;
      if(checked=="false" && curHead.displayName.length>100)
          {
              colName = curHead.displayName.substring(0,100);
          }
      fieldXML += "F" + index + "=\"" + ZDBEscapeUtil.encodeForXML(colName) + "\" ";    //No I18N
      typeXML += "F" + index + "=\"" +  dataType + "\" ";   //No I18N
      countryXML += "FC" + index + "=\"" + countries[index] + "\" ";    //No I18N
      fieldNullableXML += "F" + index + "=\"" + ZDBEscapeUtil.encodeForXML(curHead.isNullable) + "\" ";    //No I18N
      if(dataType == ZDBConst.GEO || dataType == ZDBConst.GEO_NUM)
      {
        var geoDet = "";
        var geoR = selOpt.getAttribute("georole");
        if(geoR != null)
        {
            geoDet +="GEOR"+":"+geoR;  //NO I18N
        }

        if(geoDet.trim()!="")
        {
            fieldst += "F" + index + "=\""+ geoR+"\" ";//No I18N
        }        
      }
      ++index;
    }
  }

  fieldXML +="/>";
  typeXML  += "/>";
  countryXML += "/>";
  jsonNodeXML += "/>";
  fieldNullableXML += "/>";
  fieldstXML=fieldstXML+fieldst+"/>";
  if(!isSelColExist)
  {
    ///ZDBAlertAPI.showMsg("You must select at least a column to import");
    alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.selCol2ProceedImport"));
    return false;
  }
  
  //$("IMPORTACTION").value = "IMPORTDBDATA"; //No I18N
  var tablename=$("ITABLENAME").value;
  if(tablename == undefined)
{
	  tablename=$("ITABLENAME").innerHTML; 
}
  var tabConfig = "<data>\n" + fieldXML + "\n" + typeXML + "\n" + countryXML + "\n" + fieldNullableXML +"\n"+ fieldstXML +"\n"; //No I18N
  tabConfig += "</data>";    //No I18N
  var ZDBACTION = isExist ? "EXISTIMPORTDBDATA" : "IMPORTDBDATA";// No I18N
  params = params +"&LOCALDBNAME="+$("ImportLocalDatabaseForm").getAttribute("localDBName")//No I18N
  			+"&CONNECTIONID="+$("ImportLocalDatabaseForm").getAttribute("connectionId")//No I18N
  			+"&SERVICENAME="+$("ImportLocalDatabaseForm").getAttribute("serviceName")//No I18N
  			+"&DBTYPE="+$("ImportLocalDatabaseForm").getAttribute("dbtype")//No I18N
  			+"&HOSTNAME="+$("ImportLocalDatabaseForm").getAttribute("hostName")//No I18N
  			+"&INSTANCENAME="+$("ImportLocalDatabaseForm").getAttribute("instanceName")//No I18N
  			+"&PORT="+$("ImportLocalDatabaseForm").getAttribute("port")//No I18N
  			+"&DBUSERNAME="+$("ImportLocalDatabaseForm").getAttribute("dbUserName")//No I18N
  			+"&DBPASSWORD="+$("ImportLocalDatabaseForm").getAttribute("dbPassword")//No I18N
  			+"&SID="+$("ImportLocalDatabaseForm").getAttribute("sid")//No I18N
  			+"&USESSHTUNNELING="+$("ImportLocalDatabaseForm").getAttribute("usessh")//No I18N
  			+"&SSHHOSTNAME="+$("ImportLocalDatabaseForm").getAttribute("sshHostName")//No I18N
  			+"&SSHPORT="+$("ImportLocalDatabaseForm").getAttribute("sshPort")//No I18N
  			+"&SSHUSERNAME="+$("ImportLocalDatabaseForm").getAttribute("sshUserName")//No I18N
  			+"&SSHAUTHENTICATIONTYPE="+$("ImportLocalDatabaseForm").getAttribute("sshAuthType")//No I18N
  			+"&SSHPASSWORD="+$("ImportLocalDatabaseForm").getAttribute("sshPassword")//No I18N
  			+"&USESSL="+$("ImportLocalDatabaseForm").getAttribute("usessl")//No I18N
  			+"&ONPREMISEQUERYTYPE=" +$("ImportLocalDatabaseForm").getAttribute("OnPremiseQueryType")//No I18N
  			+"&ONPREMISEDBNAME=" + $("ImportLocalDatabaseForm").getAttribute("OnPremiseDBName")//No I18N
  			+"&ONPREMISECUSTOMQUERY=" + encodeURIComponent($("ImportLocalDatabaseForm").getAttribute("OnPremiseCustomQuery"))//No I18N
  			+"&ONPREMISETBNAME=" +$("ImportLocalDatabaseForm").getAttribute("OnPremsieTBName")//No I18N
  			+"&TABLENAME="+tablename//No I18N
  			+"&TABLECONFIG=" + tabConfig //No I18N
  			+"&FILETYPE=DATABASE"//No I18N
  			+"&LOCATION=LOCALDATABASE"//No I18N
  			+"&ZDBFILENAME=ONPREMISEDATABASEDATA&FIRSTROWISFIELDS=true&ZOHO_DELIMITER=0&ZOHO_QUOTED=2&ZOHO_SKIPTOP=0&ZOHO_THOUSAND_SEP=0&ZOHO_DECIMAL_SEP=0";//No I18N
  AjaxAPI.sendRequest({URL:"/ZDBOnPremiseDatabase.ve?ZDBACTION=" + ZDBACTION,METHOD:"POST",PARAMETERS:params,OPSTATUSID:"ZDBCREATEDBOPTSTATUS",ONSUCCESSFUNC:importReport});     //No I18N
}

ZDBImport.importTable = function(isExist, canOverRide,createWithLookup)
{
  if(sampleTableGrid == null)
  {
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.parsingErr"));
    return;
  }

  var frm = document.forms[isExist?"ExistImportForm": "ImportForm"];    //No I18N

  var thousandSep = frm["THOUSANDSEP"].value;
  var decimalSep = frm["DECIMALSEP"].value;
  if( (thousandSep == 1 && decimalSep == 1 ) || (thousandSep == 2 && decimalSep == 0 ) )
  {
     var msg = ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.separatorsAreSame");
     showCustomMessage(msg, $("THOUSANDSEP"));
     return false;
  }

  if(!isTopCommentValid(frm))
  {
    return false;
  }



  var fieldXML = "<Fields ";    //No I18N
  var typeXML = "<FieldType ";  //No I18N
  var countryXML = "<FieldCountry ";    //No I18N
  var jsonNodeXML = "<JSONNodePath ";    //No I18N
  var fieldNullableXML = "<FIELDNULLABLE "; //No I18N
  var fieldstXML = "<FIELDSUBTYPES "; //No I18N
  var colHeaders = sampleTableGrid.colHeaders;
  var colLen = colHeaders.length;
  var countries = sampleTableGrid.currencyCountries;
  var isSelColExist = false;
  var checked;
  var dataType;
  var curHead;
  var index = 0;
  var fieldst= "";
  var row = getDataTypeRow(isExist);
  if(!isDateFieldOK(row, frm))
  {
    return false;
  }
  if(!isANCTypeUnique(colHeaders))
  {
    return false;
  }


  for(var i =0; i < colLen; i++)
  {
    curHead = colHeaders[i];
    if(curHead.objType !== ZDBConst.COLHEAD)
    {
      continue;
    }
    checked = curHead["importNode"].getAttribute("checked");    //No I18N
    if(!isSelColExist && checked =="true")
    {
        isSelColExist = true;
    }
    var selOpt = curHead.dataType[curHead.dataType.selectedIndex];
    dataType = (checked == "true") ? selOpt.value : -2; ///PK: Skip column
    if(curHead.status == ZDBConst.CLEAR)
    {
      var colName = curHead.displayName;
      if(checked=="false" && curHead.displayName.length>100)
          {
              colName = curHead.displayName.substring(0,100);
          }
      fieldXML += "F" + index + "=\"" + ZDBEscapeUtil.encodeForXML(colName) + "\" ";    //No I18N
      typeXML += "F" + index + "=\"" +  dataType + "\" ";   //No I18N
      countryXML += "FC" + index + "=\"" + countries[index] + "\" ";    //No I18N
      fieldNullableXML += "F" + index + "=\"" + ZDBEscapeUtil.encodeForXML(curHead.isNullable) + "\" ";    //No I18N
      var colInfo = curHead.colInfo;
      if(dataType == ZDBConst.GEO || dataType == ZDBConst.GEO_NUM)
      {
        var geoDet = "";
        var geoR = selOpt.getAttribute("georole");
        if(geoR != null)
        {
            geoDet +="GEOR"+":"+geoR;  //NO I18N
        }

        if(geoDet.trim()!="")
        {
            fieldst += "F" + index + "=\""+ geoR+"\" ";//No I18N
        }        
      }
//      fieldInfoXML += "\" "
      if(sampleTableGrid.isJSONOrXMLImp)
      {
        jsonNodeXML += "JN" + index + "=\"" + ZDBEscapeUtil.encodeForXML(curHead.jsonNodePath) + "\" ";    //No I18N
      }
      ++index;
    }
  }

  fieldXML +="/>";
  typeXML  += "/>";
  countryXML += "/>";
  jsonNodeXML += "/>";
  fieldNullableXML += "/>";
  fieldstXML=fieldstXML+fieldst+"/>";

  if(!isSelColExist)
  {
    ///ZDBAlertAPI.showMsg("You must select at least a column to import");
    alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.selCol2ProceedImport"));
    return false;
  }
  
  $("IMPORTACTION").value = isExist ? "EXISTIMPORTDATA" : "IMPORTDATA"; //No I18N
  var tabConfig = "<data>\n" + fieldXML + "\n" + typeXML + "\n" + countryXML + "\n" + fieldNullableXML +"\n"+ fieldstXML + "\n"; //NO I18N
  
  if(sampleTableGrid.isJSONOrXMLImp)
  {
    tabConfig += jsonNodeXML + "\n";  //No I18N
  }
  tabConfig += "</data>";    //No I18N

  $("TABLECONFIG").value = tabConfig;
  $("ZOHO_CANOVERRIDE").value = (canOverRide==true)?true:false;
  frm.setAttribute("onsuccessfunc","importReport");
            frm.setAttribute("opstatusid",isExist? "ZDBEXIMPORTFILEOPSTATUS":"ZDBIMPORTFILEOPSTATUS");
          
  AjaxAPI.submit(frm);
}
ZDBImport.defineRelationship=function()
{
    if($("JOINSLIST").value!="" || jQuery("#ZDBImportFileWithRelation").length>0)
        {
            var freezelayer = jQuery(document.createElement("div"));
            freezelayer.attr("class","freezeLayer"); //No I18N
            freezelayer.attr("ID","IMPORTFREEZE"); //No I18N
            freezelayer.css("top",parseInt(jQuery("#ZDBMAINEL").position().top)+parseInt(1)+"px");//No I18N
            //freezelayer.css("top",parseInt(jQuery("#ZDBMAINEL").position().top)+parseInt(1)+"px");//No I18N
            //freezelayer.css("left","251px");//No I18N
            //freezelayer.css("opacity",'0.45');//No I18N
            jQuery(document.body).append(freezelayer);
            jQuery("#ZDBImportFileWithRelation").show();//No I18N
            var w = document.body.offsetWidth-parseInt($("ZDBImportFileWithRelation").offsetWidth);
            jQuery("#ZDBImportFileWithRelation").animate({left: w+'px'}).show().focus();//No I18N
                {
                    $("EnclosingDiv").innerHTML = window.joinFrm.innerHTML;
                }
            ev.addEscHandle(ZDBCreateDB.showprevformonEsc);
            return;
        }
  var fieldXML = "<Fields ";    //No I18N
  var typeXML = "<FieldType ";  //No I18N
  var colHeaders = sampleTableGrid.colHeaders;
  var colLen = colHeaders.length;
  var isSelColExist = false;
  var checked;
  var dataType;
  var curHead;
  var index = 0;
  for(var i =0; i < colLen; i++)
  {
    curHead = colHeaders[i];
    if(curHead.objType !== ZDBConst.COLHEAD)
    {
      continue;
    }
    checked = curHead["importNode"].getAttribute("checked");    //No I18N
    if(!isSelColExist && checked =="true")
    {
        isSelColExist = true;
    }
    
    dataType = (checked == "true") ? curHead.dataType[curHead.dataType.selectedIndex].value : -2; ///PK: Skip column

    if(curHead.status == ZDBConst.CLEAR)
    {
      var colName = curHead.displayName;
      if(checked=="false" && curHead.displayName.length>100)
          {
              colName = curHead.displayName.substring(0,100);
          }
      fieldXML += "F" + index + "=\"" + encodeURIComponent(ZDBEscapeUtil.encodeForXML(colName)) + "\" ";    //No I18N
      typeXML += "F" + index + "=\"" +  dataType + "\" ";   //No I18N
      ++index;
    }
  }

  fieldXML +="/>";
  typeXML  += "/>";
  if(!isSelColExist)
  {
    alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.selCol2ProceedImport"));
    return false;
  }
    var tabConfig = "<data>\n" + fieldXML + "\n" + typeXML + "\n" + "</data>"; //No I18N
    var params = "TABLECONFIG=" + tabConfig +"&DBID="+ZDBClientUI.dbId;//No I18N
    AjaxAPI.sendRequest({URL:"/ZDBImportData.ve?ZDBACTION=SUGGESTRELATIONSHIP",  //No I18N
            ONSUCCESSFUNC:showRelations,PARAMETERS:params
            });
}
ZDBImport.findpossibleJoinsCount=function()
{
    if(ZDBClientUI.dbId == undefined)
        {
            return;
        }
     var fieldXML = "<Fields ";    //No I18N
  var typeXML = "<FieldType ";  //No I18N
  var colHeaders = sampleTableGrid.colHeaders;
  var colLen = colHeaders.length;
  var isSelColExist = false;
  var checked;
  var dataType;
  var curHead;
  var index = 0;
  for(var i =0; i < colLen; i++)
  {
    curHead = colHeaders[i];
    if(curHead.objType !== ZDBConst.COLHEAD)
    {
      continue;
    }
    checked = curHead["importNode"].getAttribute("checked");    //No I18N
    if(!isSelColExist && checked =="true")
    {
        isSelColExist = true;
    }
    
    dataType = (checked == "true") ? curHead.dataType[curHead.dataType.selectedIndex].value : -2; ///PK: Skip column
    
    if(curHead.status == ZDBConst.CLEAR)
    {
      var colName = curHead.displayName;
      if(checked=="false" && curHead.displayName.length>100)
          {
              colName = curHead.displayName.substring(0,100);
          }
      fieldXML += "F" + index + "=\"" + encodeURIComponent(ZDBEscapeUtil.encodeForXML(colName)) + "\" ";    //No I18N
      typeXML += "F" + index + "=\"" +  dataType + "\" ";   //No I18N
      ++index;
    }
  }

  fieldXML +="/>";
  typeXML  += "/>";
  if(!isSelColExist)
  {
    alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.selCol2ProceedImport"));
    return false;
  }
    var tabConfig = "<data>\n" + fieldXML + "\n" + typeXML + "\n" + "</data>"; //No I18N
    var params = "TABLECONFIG=" + tabConfig +"&DBID="+ZDBClientUI.dbId;//No I18N
    AjaxAPI.sendRequest({URL:"/ZDBImportData.ve?ZDBACTION=REFRESHRELATIONSHIPCOUNT",  //No I18N
            ONSUCCESSFUNC:refreshJoinCount,PARAMETERS:params
            });
}

ZDBImport.checkForANColumnType = function(selObj)
{
  var dataType = selObj[selObj.selectedIndex].value;
  var isSelColExist = false;
  if(dataType == ZDBDesignGridConst.AUTO_NUMBER)
  {
    var colHeaders = sampleTableGrid.colHeaders;
    var colLen = colHeaders.length;

    for(var i =0; i < colLen; i++)
    {
      curHead = colHeaders[i];
      if(curHead.objType != ZDBConst.COLHEAD || curHead.dataType == selObj)
      {
        continue; 
      }
      checked = curHead["importNode"].getAttribute("checked");    //No I18N
      if(!isSelColExist && checked =="true")
      {
        isSelColExist = true;
      }
      if(isSelColExist && dataType == curHead.dataType[curHead.dataType.selectedIndex].value)
      {
        alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.onlyAutoNumColPerTbl"));
        selObj.selectedIndex = selObj.previousIndex;
        return false;       
      }
    }
  }
  return true;
}

ZDBImport.showLessMore = function(moreEl)
{
    var fileType = moreEl.getAttribute("fileType");
    var isGDriveCSV = moreEl.getAttribute("isGDriveCSV");
    var gDrive_Format = moreEl.getAttribute("gDriveFormat");
    var isFromGDrive = moreEl.getAttribute("isFromGDrive");
    var fileSubtype=moreEl.getAttribute("fileSubtype");
      var isExternalDriveFile=ZDBImport.isExternalFile(fileType);
    var fileTypeStr ="";
    if(fileType == "CSV" || isGDriveCSV == "true" ||((fileType=="ZDOCS"||isExternalDriveFile) && fileSubtype=="CSV"))
    {
       fileTypeStr += ZDBI18NMap.g("zrpt.common.import.moreorless.js.csv");
    }
    else
    {
       fileTypeStr += ZDBI18NMap.g("zrpt.common.import.moreorless.js.json");
    }
      
    var more = moreEl.getAttribute("more"); 
    if(more == "false")
    {
            jQuery(moreEl).find("[elname='moreRLessTxt']").html(ZDBI18NMap.g("zrpt.common.import.moreorless.js.Less")+" "+fileTypeStr+" "+ZDBI18NMap.g("zrpt.common.import.moreorless.js.Settings"));
            jQuery(moreEl).find("[elname='moreRLessIcon']").removeClass("ZRSMoreIcon").addClass("ZRSLessIcon");//No I18N
            jQuery("#ZDBMORE").slideDown(500, function(){//No I18N
                if(fileType == "CSV"  || ((fileType=="ZDOCS"||isExternalDriveFile) && fileSubtype=="CSV"))
                {
                 $("DELIMITER").focus();
                }
                else if(fileType == "JSON" || ((fileType=="ZDOCS"||isExternalDriveFile) && fileSubtype=="JSON") || (fileType === "XML") || ((fileType=="ZDOCS"||isExternalDriveFile) && fileSubtype=="XML"))
                {
                 $("RETAIN_COLNAMES").focus();
                }
                else
                {
                 $("THOUSANDSEP").focus();
                }
            });
        moreEl.setAttribute("more","true");
    }
    else
    {
        jQuery(moreEl).find("[elname='moreRLessTxt']").html(ZDBI18NMap.g("zrpt.common.import.moreorless.js.More")+" "+fileTypeStr+" "+ZDBI18NMap.g("zrpt.common.import.moreorless.js.Settings"));
        jQuery(moreEl).find("[elname='moreRLessIcon']").removeClass("ZRSLessIcon").addClass("ZRSMoreIcon"); //No I18N
        jQuery("#ZDBMORE").slideUp(500);//No I18N
        moreEl.setAttribute("more","false");
    }
}

ZDBImport.submitExistImportForm = function(frm, event, enableAlert)
{
  hideCustomMessage();
  var actionURL = frm.getAttribute("actionurl");
  var location;
  if(enableAlert == false)
  {
      $("CHECKFORALERT").value = "false";
  }
  var opt =$("ZDBEXOPTIONINP").value;
  var importType = $("ZDBEXFILETYPE").value;
  if(opt == "import")
  {
    frm.setAttribute("useiframe","true");
    
    var isWeb = $("ZDBEXWEBOPT").checked;
    if(isWeb)
        {
            showHideUrlParamDiv(false);
        }
    var isPaste = $("ZDBEXPASTEOPT").checked;
    var isFile = $("ZDBEXFILEOPT").checked;
    var isFTP =($("ZDBEXFTPOPT"))? $("ZDBEXFTPOPT").checked:false;
    location = (isFile)?"file":location; //No I18N
    location = (isPaste)?"paste":location; //No I18N
    var importTypes = ["CSV","XLS","HTML","JSON","XML"]; //No I18N
    var isImpTypeMatched = importTypes.indexOf(importType) > -1;
     
    if(isPaste && isImpTypeMatched)
    {
      location = "paste";	//No I18N
      frm.ZDBFILENAME.value = " the data you have pasted";  //No I18N
    }
    else if(isFile && isImpTypeMatched)
    {
    	if(isFileUploadSample()){
    		frm.ZDBFILENAME.value = "Sample Data"; //No I18N
    	}
    	else{
    		frm.ZDBFILENAME.value = frm.FILENAME.value;
    		//frm.setAttribute("useiframe","true");
    		if(!ZDBImport.isValidFileExtension(frm.FILENAME.value))
    		{
    			alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.unSupImportFileType"));
    			isPaste = true;
    			locationSelected('PASTEDATA','existImport');    //No I18N
    			return false;
    		}
    	}
    }
    else if (isWeb && isImpTypeMatched )
    {
      location = "web"; //No I18N
      frm.ZDBFILENAME.value = frm.URL.value;
    }
    else if(isFTP && isImpTypeMatched ){
    	location = "ftp"; //No I18N
        var ftpProtocol = frm.FTPPROTOCOL.value;
        if(ftpProtocol!="ftp" && ftpProtocol!="sftp"){
      	  ftpProtocol = "ftps"; //No I18N
        }
        frm.ZDBFILENAME.value = ftpProtocol + "://"+frm.FTPHOST.value+ ':'+frm.FTPPORT.value+ ( (frm.FTPPATH.value.substring(0,1)=='/')?'':'/' )+frm.FTPPATH.value;
    }
        
    frm.reloadCount = 0;//$$ Test this!!.- Add this to test cases.
    ZDBImport.setEncoding(frm, "existImport");   // No I18N
  }
  else if(opt == "cloud")
  {
	location = "cloud";	//No I18N
    if (importType == "ZDOCS")
    {
      frm.DOCNAME.value = frm.ZDBExtIntInput.value ;
      importStepValUpdate("existImport");//No I18N

    }
    else if(importType == "GSHEET")
    {
      frm.ZDBGSHEETNAME.value = frm.ZDBExtIntInput.value;
      importStepValUpdate("existImport"); //No I18N
    }
    else if (ZDBImport.isExternalFile(importType))
    {
      frm.DOCNAME.value = frm.ZDBExtIntInput.value ;
      importStepValUpdate("existImport");//No I18N
    }
    frm.encoding =  "application/x-www-form-urlencoded"; // No I18N
  }
  else
  {                                         
    frm.setAttribute("useiframe","false");
    frm.removeAttribute("enctype");
    ZDBImport.setEncoding(frm, "existImport");    // No I18N 
  }
  frm.action = actionURL;
  
  var fileOpts = getFileOptsForImport(location,frm);
  AjaxAPI.submit(frm); 
  enableFileUpload();
  return true;
}


ZDBImport.isValidFileExtension = function(fileName)
{
      var invalidFileExt = [".bmp",".class",".exe", ".gif",".jpg",".mdb", ".png"];     //No I18N
      var len = invalidFileExt.length;
      var fileLen = fileName.length;
      for(var i=0;i<len;++i)
      {
          var curExt = invalidFileExt[i];
          var pos = fileLen - curExt.length;
          if(pos >= 0 && fileName.toLowerCase().lastIndexOf(curExt.toLowerCase()) == pos)
          {
            return false
          }      
      }
      return true;
}

ZDBImport.getFileExtension = function(fileName)
{
    if(fileName == null || fileName == "")
    {
        return "";
    }
    else
    {
        var index = fileName.toLowerCase().lastIndexOf(".");
        var fileExtn = fileName.substring(index+1);
        return fileExtn;
    }
}

ZDBImport.setEncoding = function(frm, forWhat)
{
    var ex = (forWhat.toLowerCase() == 'existimport') ? "EX" : "";  //No I18N
       ///PK: Hack - Fix it later
    try
    {
      if($("ZDB" + ex +"FILEOPT").checked)
      {
          frm.encoding = "multipart/form-data";     //No I18N
      }
      else if($("ZDB" + ex + "PASTEOPT").checked)
      {
          frm.encoding = "application/x-www-form-urlencoded";   //No I18N
      }
      else if($("ZDB" + ex + "WEBOPT").checked)
      {
        frm.encoding =  "application/x-www-form-urlencoded";    //No I18N
      }
      else if($("ZDBFTPOPT")!=null){
        if($("ZDB" + ex + "FTPOPT").checked){
          frm.encoding =  "application/x-www-form-urlencoded";    //No I18N 
        }
      }
    }
    catch(e)
    {
      ///PK: Are you happy? 
      ///PK: Analyse and rewrite
    }
}

ZDBImport.setExistColumnList = function(gridObj,el)
  {
      var colHeads = gridObj.colHeaders;
      var colLen = colHeads.length;
      var innerText;
      var existColDiv;
      if(!el)
      {
        innerText = $("EXISTCOLROW_TEM").getElementsByTagName("tbody")[0].innerHTML;
        existColDiv = $("EXISTCOLLISTDIV");
      }
      else
      {
          ZDBUtil.setNamedChildEls(el,el,"id");
          innerText = el.EXISTCOLROW_TEM.getElementsByTagName("tbody")[0].innerHTML;
          existColDiv = el.EXISTCOLLISTDIV;
      }
      var splitList = innerText.split(/\$\$/);
      var str="";
      for(var i=0;i<colLen;++i)
      {
        var curHead = colHeads[i];
        if(curHead.objType != ZDBConst.COLHEAD || !curHead.tobeListed)
        {
          continue;
        }
        if(!curHead.formula)
        {
          var displayName =  ZDBEscapeUtil.encodeForHtml(curHead.displayName);
          var rowArray = LangUtils.cloneArray(splitList);
          for(var k=1,l=rowArray.length;k < l;k+=2)
          {
            rowArray[k] = displayName;
          }
          str = str.concat(rowArray.join(""));
        }
      }
      var tempDiv = document.createElement("div");
      existColDiv.innerHTML = "<table width='100%' cellspacing='0' cellpadding='0' border='0'>" + str + "</table>";
  }

ZDBImport.setCheckListColumn = function(gridObj,matchColList,el)
{
    var colHeads = gridObj.colHeaders;
    var colLen = colHeads.length;
    var colList = matchColList;
    var existColDiv;
    if(!el)
    {
        existColDiv = $("EXISTCOLLISTDIV");
    }
    else
    {
        ZDBUtil.setNamedChildEls(el,el,"id");
        existColDiv = el.EXISTCOLLISTDIV;
    }
    for(var i=0;i<colList.length;i++)
    {
        var colId = colList[i];
        for(var j=0;j<colLen;j++)
        {
            var curHead = colHeads[j];
            var colmnId = ZDBEscapeUtil.encodeForHtml(curHead.colId);
            if(colId == colmnId)
            {
                var elt = existColDiv.getElementsByTagName("input");
                for(var k=0;k <elt.length ; k++)
                {
                    if(elt[k].value == ZDBEscapeUtil.encodeForHtml(curHead.displayName))
                    {
                        elt[k].checked = true;
                        break;
                    }
                }
                break;
            }
        }
    }
}

ZDBImport.getSelectTables = function()
 {
    // Get the Number for the Selected Table
    var tblNo=0;
    while($("scraptbl_"+tblNo))
    {
       if($("scraptbl_"+tblNo).checked)
       {
            break;
       }
       tblNo++;
    }
    $("ZDBTABLENO").value = tblNo;
    return true;
 }

ZDBImport.resetImportForm = function()
{
  try
    { //IE 6 issue
        if(ZDBImport.curForm["DATEFORMAT"])
        {
            ZDBImport.curForm["DATEFORMAT"].value = ""; //No I18N
        }
        
        var impFrm = document.forms["CreateDBFrm"];
        var exImpFrm = document.forms["ExCreateDBFrm"];
        var resetFields = ["TABLENAME", "DESCRIPTION", "tags", "PASTEDATA", "ZDBInputURL", "ZDBPASTEDATA", "ZDBEXInputURL"];    //No I18N
        var fLen = resetFields.length;
        for(var i=0;i<fLen;++i)
        {
            try
            {
                if(impFrm && impFrm[resetFields[i]] !== undefined)
                {
                    impFrm[resetFields[i]].value = "";
                }
                if(exImpFrm && exImpFrm[resetFields[i]] !== undefined)
                {
                    exImpFrm[resetFields[i]].value = "";
                }
            }
            catch(e)
            {
                //PK: OK, continue
            }
        }
        var  ftpDiv = (window.divData["FTPINP"])?window.divData["FTPINP"]:window.divData["EXFTPINP"];
    	ftpDiv = jQuery(ftpDiv);
    	if(ftpDiv){
        	var ftpFields = ["FTPPATH","FTPHOST","FTPPORT","FTPPROTOCOL","FTPUSERNAME","FTPPASSWORD"]; //No I18N
        	var defValues = ["","",21,"ftp","",""]; //NO I18N
            var fLen = ftpFields.length;
            try
            {
            	for(var i=0;i<fLen;++i)
                {
            		var el = ftpDiv.find('[name='+ftpFields[i]+"]");
                    if(el)
                    {
                    	el.val(defValues[i]);
                    }
                }
                ftpDiv.find('[name="SFTPAUTHTYPE"]').eq(0).prop("checked",true); //No I18N
                authTypeSelected("PASSWORD"); //NO I18N
            }
            catch(e)
            {
                    //PK: OK, continue
            }    		
    	}
        
        if(impFrm && impFrm["ITABLENAME"] !== undefined)
        {
            impFrm["ITABLENAME"].value = ZDBI18NMap.g("zrpt.home.import.step1.js.newtbl");  //No I18N
        }
    }
    catch(e)
    { 
        //PK: Not so critical, but careful you may miss things that can be handled
    }
   
}

/* $$$NEWUI - REMOVE IN NEWUI */ 
ZDBImport.setHighLight = function(event, isSet)
{
    var srcEl = ZDBUtil.getSourceElement(event);
    var srcTd = ZDBUtil.getParentWithTagName(srcEl,"TD");   //No I18N
    if(!srcTd || !srcTd.tagName)
    {
        return;
    }
    var isDate = ZDBUtil.getAttribute(srcTd,"ISDATE");
    if(!isDate)
    {
        return;
    }
    if(isSet)
    {
        var oldClass = ZDBUtil.getAttribute(srcTd,"class","className");
        srcTd.setAttribute("oldClass", oldClass);
        srcTd.setAttribute("class", "optionselected");
        srcTd.className = "optionselected";
    }
    else
    {
         if(srcTd.getAttribute("oldClass"))
         {
            srcTd.setAttribute("class", srcTd.getAttribute("oldClass"));
            srcTd.className = srcTd.getAttribute("oldClass");                 
         }
    }
}

ZDBImport.resetDateDlg = function(dlg)
{

    var tds = dlg.getElementsByTagName("TD");
    var tdLen = tds.length;
    
    for(var i=0;i<tdLen;++i)
    {
         var curTd = tds[i];
         if(ZDBUtil.getAttribute(curTd,"ISDATE"))
         {
            ZDBUtil.setAttribute(curTd, "optionnotselected","class","className");
         }
    }
    
    ZDBImport["CUSTDATEFRM"].customDateFormat.value = "";   //No I18N
    ZDBImport["CUSTDATEFRM"].customDateSample.value = "";   //No I18N
}


ZDBImport.onDataTypeChange = function(event)
{
    var list = ZDBUtil.getSourceElement(event);
    var selIndex = list.selectedIndex;
    var dObj = list.cellObj;
    var colObj = dObj.colObj;
    var selVal = -1;
    if(selIndex > -1)
    {
        var selVal = list[selIndex].value;
    }
    if(selVal == 9 || selVal == 22) ///PK: get these values defined -> ex: selVal = ZDBTYPE.DATE
    {
        var dateEl = document.getElementById("DATEFORMAT");
        if(dateEl && !dateEl.value)
        {
            showCustomMessage(ZDBI18NMap.g('zrpt.common.import.custommsg.js.wrongDtFmtSel'), ZDBUtil.getParentWithTagName(dateEl,"div")); //No I18N
        }
    }
//    if(selVal == ZDBConst.GEO)
//    {
//      var georole = list[selIndex].getAttribute("georole");
//      colObj.colInfo["GEOR"]=georole;
//    }
    //Need I18n
    if(list[selIndex].getAttribute("zdbDisabled") == "true")
    {
      var dataType = list[selIndex].getAttribute("defaultvaltype");
      if(dataType == 'REFCOL' || dataType == 'RELCOL')
      {
        ZDBMsgBox.showHintMsg("Sorry, currently you cannot choose the type of a new column as 'LookUp Column'");    //No I18N
      }
      else if(dataType == 'AUTO_NUMBER')
      {
        ZDBMsgBox.showHintMsg("Sorry, currently you cannot choose the type of a new column as 'Auto Number'");  //No I18N
      }

      list.selectedIndex = dObj.colObj.previousIndex; 
      return false;
    }
    dObj.originalValue = list[list.selectedIndex].value;
    ZDBImport.findpossibleJoinsCount();
    return true;
}

ZDBImport.changeFileLocation = function(elem,id,forWhat)
{
  var fileTypeCombo = $(id);
  if(ZDBImport.isValidFile(elem.value,".csv") || ZDBImport.isValidFile(elem.value,".tsv"))
  {
    fileTypeCombo.value = "CSV";    //No I18N
  }
  else if(ZDBImport.isValidFile(elem.value,".xls") || ZDBImport.isValidFile(elem.value,".xlsx"))
  {
    fileTypeCombo.value = "XLS";    //No I18N
  }
  else if(ZDBImport.isValidFile(elem.value,".html"))
  {
    fileTypeCombo.value = "HTML";   //No I18N
  }
  else if(ZDBImport.isValidFile(elem.value,".json"))
  {
     fileTypeCombo.value = "JSON";   //No I18N
  }
  else if(ZDBImport.isValidFile(elem.value,".xml"))
  {
     fileTypeCombo.value = "XML";   //No I18N
  }
  enableOption(fileTypeCombo,forWhat);
}

ZDBImport.isValidFile = function(fileName,fileExtension)
{
  var fileLen = fileName.length;
  var pos = fileLen - fileExtension.length;
  if(pos >= 0 && fileName.toLowerCase().lastIndexOf(fileExtension.toLowerCase()) == pos)
  {
    return true;
  }            
  return false;
}

var ZDBXLSImport = new function(){}

ZDBXLSImport.sheetSelected = function(sheetNo)
{
  //$("ZDBWorkSheet_" + sheetNo).checked = "true";
}

ZDBXLSImport.getSelectSheet = function()
{
  // Get the Number for the Selected Table
  var tblNo=0;
  while($("ZDBWorkSheet_"+tblNo))
  {
     if($("ZDBWorkSheet_"+tblNo).checked)
     {
          break;
     }
     tblNo++;
  }
  $("ZDBTABLENO").value = tblNo;
  return true;
}


ZDBImport.newImportedTable = function(element, event)
{
  if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", ZDBImport.newImportedTable,[element, event])){
  	return;
  }
  if(!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/db/ImportSample.js"],this,ZDBImport.newImportedTable,[element, event]))
  {
 	return;
  }
  var impOpts = "import";  // No I18N
  if(element.id == "ZDBImportFrmCldInExistDBImg" || element.id == "ZDBImportFrmCldInExistDB")
  {
    impOpts = 'cloud'; // No I18N
  }
  window.curStep = 1;
  window.totStep = 2;
  ZDBUtil.setIfGAppsUser();
  var location  = "PASTEDATA";  // No I18N
  if(impOpts == "cloud")
  {
    location = "GSHEET";   // No I18N
  }
  
  if(window.divData && window.divData.isNew && window.divData.location != "inhousedb")
  {
    showTableDialog(location, impOpts);    // No I18N
    ZDBImport.resetImportForm();
    ZDBImport.customizeImportOptions(impOpts);
    ZDBUtil.setFocus('TABLENAME');  //No I18N
  }
  else
  {
    ZDBImport.removeElIfPresent("ZDBIMPORTTBODY");      //No I18N
    ZDBImport.removeElIfPresent("ZDBCreateFrm");//$$ Very very bad fix. COSMIC CRICUITS FIX //No I18N
    ZDBImport.removeElIfPresent("ZDBCreateDBCntTd");    //No I18N
    ZDBImport.removeElIfPresent("ZDBCREATEDIALOG");     //No I18N
    window.divData = null;//$$ We should be able to cache the UI!!
    ZDBLazyLoadUtil.loadedSnippets["EXIST_IMPORT_DLG"] = false;
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBCreateTableViaImport.cc?DBID="+ ZDBClientUI.dbId+"&&OPT="+impOpts,ONSUCCESSFUNC:ZDBImport.placeImport,INVOKESCRIPTS:true,OPSTATUSID:"ZDBMainLoader", IMPOPTS : impOpts,METHOD:"GET"}); //No I18N
  }
}

ZDBImport.newCloudTableImport = function()
{
  window.curStep = 1;
  window.totStep = 2;
  AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBCreateTableViaCloud.cc?DBID=" + ZDBClientUI.dbId, ONSUCCESSFUNC:ZDBImport.showCloudDialog});
}

ZDBImport.showCloudDialog = function(response,requestOptions)
{
  var dlg = document.createElement("div");
  dlg.innerHTML = response.getOnlyHtml();
  dlg.setAttribute("isDialog", "true");
  ZDBUtil.setFocus("TABLENAME", true);  //No I18N
  ZDBDialogUtil.showDialog(dlg,{MODAL:true});
    ZDBMenu.addIframe(dlg); //Shibu
    enableCloudOption("ZDOCS"); // No I18N
}

ZDBImport.existImportTable = function(element, event, tableName, isNewRequest)
{
//  if(!ZDBLazyLoadUtil.loadCssOnly("ProgressBar.css", "APPENDTODOC", ZDBImport.existImportTable,[element, event, tableName, isNewRequest])){
//	 return;
//  }
  if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/db/ImportSample.js",this,ZDBImport.existImportTable,[element, event, tableName, isNewRequest]))
  {
	 return;
  }	
  var gridObj = ZDBClientUI.selectedTab.view;
  var impOpts = "import";  // No I18N
  if(element.id == "ZDBImportFrmCldInExistDBImg" || element.id == "ZDBImportFrmCldInExistDB")
  {
    impOpts = 'cloud'; // No I18N
  }
  ZDBLazyLoadUtil.loadedSnippets["EXIST_IMPORT_DLG"] = false;
  window.divData = null;
  AjaxAPI.sendRequest({
    URL:"/ZDBImportAction.ma?ZDBACTION=IMPORTSETTINGS&OBJID="+gridObj.objId, //NO I18N
    ONSUCCESSFUNC:ZDBImport.loadSettings,
    ELEMENT:element,
    EVENT:event,
    TABLENAME:tableName,
    ISNEWREQUEST:isNewRequest,
    IMPOPTS : impOpts
  });
}

ZDBImport.showExistImpTable = function(element)
{
    var view = ZDBClientUI.getViewObj(element,"view");  
    if(view.connectionId != null || view.connectionId != undefined)
    {
	if(view.isCloudDBTbl)
	{
        	if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/clouddbjs/CloudDBPage.js","APPENDTODOC", ZDBImport.showExistImpTable, [element])){
				return;
        	}
        	CloudDBPage.showExistImpDialog(view.connectionId);
	}
	else if(view.isODataTbl)
	{
		if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/odatajs/ODataPage.js","APPENDTODOC", ZDBImport.showExistImpTable, [element])){
			return;
        	}
        	ODataPage.showExistImpDialog(view.connectionId);
	}
    }
    else
    {    
        ZDBImport.cntExistImportShowDialog(element);
    }
}

ZDBImport.cntExistImportShowDialog = function(element)
{
  if(!ZDBLazyLoadUtil.loadSnippet("IMPORT_INTO_THIS_TABLE","/ZDBImpIntoThisTbl.cc?OBJID="+ZDBClientUI.selectedTab.view.objId,this,"APPENDTODOC"))
    {
      return;
  }
  var exImportDiv = ZDBClientUI.$('ZDBIMPINTOTHISTBL');
  var gridObj = ZDBClientUI.selectedTab.view;
  exImportDiv.gridObj = gridObj;
  var view = ZDBClientUI.getViewObj(element,"view");
  if(!ZDBClientUI.checkAskSaveView(gridObj,ZDBI18NMap.g("zrpt.common.js.import"),
            gridObj))
  {
    return;
  }
  ZDBInlineDialog.showDialog(exImportDiv,{MODAL:true,TITLE:"Import into this table"});// No I18N
  var importFromMail=document.getElementById('ImportFromEmailInExsitImp');
  importFromMail.style.display=(importFromMail && view.canShowImpFromEmail == true)?ZDBUtil.visibleTrStyle:"none";
}

ZDBImport.loadSettings = function(response,requestOptions)
{
  if(!ZDBLazyLoadUtil.loadSnippet("EXIST_IMPORT_DLG","/ZDBExistImport.cc",this,"APPENDTODOC"))
  {
    return;
  }  
  var settingsList = (response.responseText != null) ? jQuery.parseJSON(response.responseText) : {}; //For ENTERDATARIGHTAWAY response is nill
  var element=requestOptions["ELEMENT"];
  var tableName = requestOptions["TABLENAME"];
  var isNewRequest = requestOptions["ISNEWREQUEST"];
  var event = requestOptions["EVENT"];

  var view = ZDBClientUI.selectedTab.view;
  
  var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');    //No I18N
  dbId  = ZDBClientUI.dbId;
  objId = gridObj.objId;
  displayName = (tableName != undefined ) ? tableName : gridObj.displayName;
  ZDBImport.customizeImportOptions(requestOptions.IMPOPTS, "EX");// No I18N
  storeAllReferences("existImport");    //No I18N
  var exImportDiv = window.divData.EXCREATEDIALOG.cloneNode(true);
  exImportDiv.removeAttribute("id");
  exImportDiv.style.display = "block";
  window.curStep = 1;
  window.totStep = 2;
  
  exImportDiv.gridObj = gridObj;
  ZDBInlineDialog.closeDialog();
  ZDBInlineDialog.showDialog(exImportDiv,{MODAL:true});
  $("importNote").style.display = "";
  if(requestOptions.IMPOPTS == "cloud")
  {
    if($("ZRSHelplink"))
          {
            $("ZRSHelplink").setAttribute("href", ZDBI18NMap.g('zrpt.links.js.cldimphelp')); //No I18N
          }
          if($("ZRSVideoDemoHelp"))
          {
            $("ZRSVideoDemoHelp").style.display = 'none'; // No I18N
          }
          if($("ZRSSnapShotTour"))
          { 
            $("ZRSSnapShotTour").style.display = 'none';  // No I18N
          }
  }
  $("importExTableName").innerHTML = ZDBEscapeUtil.encodeForHtml(displayName);
  ZDBImport.resetImportForm();
  $("ZDBTABLEDISPLAYNAME").value = displayName;
  $("ZDBOBJID").value = objId;
  $("ZDBTABLENAME").value = displayName;
  ZDBImport.setExistColumnList(gridObj);

  var permLevel = view.permLevel;
  var perms = permLevel.split("$");
  var impOptionSelect = $("ZDBEXACTION");
  impOptionSelect = ZDBImport.setImportOption(impOptionSelect, perms);
  
  if(Object.keys(settingsList).length > 0)
  {
    var importType = settingsList["IMPORTTYPE"];
    var fileType = settingsList["FILETYPE"];
    fileType = (fileType==="XLSX")?"XLS":fileType; //No I18N
    var fileLocation = settingsList["FILELOCATION"];
    var matchColumns = settingsList["MATCHCOLS"];
    var URL = settingsList["URL"];
    var host,port,protocol,path,sftpAuthType;
    if("FTP"==fileLocation){
      if($("ZDBEXFTPOPT")!=null){
        $("ZDBEXFTPOPT").checked = "true";
        var frm =  $("ZDBEXCreateFrm");
        locationSelected('FTP','existImport'); //No I18N
        host = settingsList["FTPHOST"];
        port = settingsList["FTPPORT"];
        protocol = settingsList["FTPPROTOCOL"];
        path = settingsList["FTPPATH"];
      
        if(host!=null && host!=undefined){
          frm.FTPHOST.value = host;
        }
        if(port!=null && port!=undefined){
          frm.FTPPORT.value = port;
        }
        if(path!=null && path!=undefined){
          frm.FTPPATH.value = path;
        }
        if(protocol!=null && protocol!=undefined){
          frm.FTPPROTOCOL.value = protocol;
        }
      }
    	if($("ZDBEXFTPOPT")){
    		$("ZDBEXFTPOPT").checked = "true";
    		var frm =  $("ZDBEXCreateFrm");
    		locationSelected('FTP','existImport'); //No I18N
    		host = settingsList["FTPHOST"];
    		port = settingsList["FTPPORT"];
    		protocol = settingsList["FTPPROTOCOL"];
    		path = settingsList["FTPPATH"];
    		sftpAuthType = settingsList["SFTPAUTHTYPE"];
    		if(host){
    			frm.FTPHOST.value = host;
    		}
    		if(path){
    			frm.FTPPATH.value = path;
    		}
    		if(protocol){
    			frm.FTPPROTOCOL.value = protocol;
    			protocolSelected(frm.FTPPROTOCOL);
    			if("sftp"==protocol){
    				if("PASSWORD"==sftpAuthType){
    					authTypeSelected("PASSWORD"); //NO I18N
    					jQuery("#SFTPPASSWORDAUTH").prop('checked',true); //NO I18N
    				}
    				else{
    					authTypeSelected("KEY"); //NO I18N
    					jQuery("#SFTPKEYAUTH").prop('checked',true); //NO I18N
    				}
    			}
    		}
    		if(port){
    			frm.FTPPORT.value = port;
    		}
    	}
    }
    ZDBImport.selectFileTypeElement("ZDBEXFILETYPE",fileType); //No I18N
    if(requestOptions.IMPOPTS == "cloud")
    {
      ZDBImport.locationAndFileTypeSelect(fileType, fileLocation);
    }
    if(requestOptions.IMPOPTS == "import")
    {
      if(fileType == "DATABASE" || fileType == "GSHEET" || fileType == "ZDOCS" || ZDBImport.isExternalFile(fileType))
        {
          fileLocation = "PASTEDATA";// No I18N
        }
      locationSelected(fileLocation, "existImport");   //No I18N
      if(fileLocation == "WEB")
        {
          hideURLTip($("ZDBEXInputURL"));
        $("ZDBEXInputURL").value=URL;
        }
      else if(fileLocation == "PASTEDATA")
        {
            ZDBUtil.setFocus("ZDBPASTEDATA");     //No I18N
            $("ZDBPASTEDATA").value ="";
        }
    }
      
    
    if(matchColumns!=null)
    {
      var matchColList = matchColumns.split(",");
      ZDBImport.setCheckListColumn(gridObj,matchColList);

    }
    var fileElt = document.getElementById("ZDBEXFILETYPE");
    enableOption(fileElt,"existImport");  //No I18N
    ZDBImport.selectImportType(impOptionSelect,importType);
    var paramNameList = (settingsList["URLPARAMNAMES"] != null) ? settingsList["URLPARAMNAMES"] : {}; 
    var paramValueList = (settingsList["URLPARAMVALUES"] != null) ? settingsList["URLPARAMVALUES"] : {}; 
    var paramTypeList = (settingsList["URLPARAMTYPES"] != null) ? settingsList["URLPARAMTYPES"] : {}; 
    var urlMethod = (settingsList["URLMETHOD"] != null) ? settingsList["URLMETHOD"] : null;
    if(fileLocation == "WEB")//No I18N
        {
            jQuery($("URLPARAMS")).empty();
            changeParamCount();
        }
    if(paramNameList.length>0)
        {
            var paramnames = JSON.parse(paramNameList);
            var paramvalues = JSON.parse(paramValueList);
            var paramtypes = JSON.parse(paramTypeList);
            $("ZRURLMETHOD").value=urlMethod;
            showHideUrlParamDiv(false);
            //jQuery($("URLPARAMS")).empty();
            addUrlParamDiv();
            for(var i=0;i<paramnames.length;i++)
            {
                if(i>0)
                {
                    var clone = $("PARAMS").cloneNode(true);
                    clone.style.display="block";
                    clone.querySelectorAll('[id="ZRURLPARAMNAME"]')[0].value = paramnames[i];
                    clone.querySelectorAll('[id="ZRURLPARAMVALUE"]')[0].value = paramvalues[i];
                    clone.querySelectorAll('[id="ZRURLPARAMTYPE"]')[0].value=paramtypes[i];
                    clone.querySelectorAll('[id="ZRURLPARAMNAME"]')[0].name = "URLPARAMNAME";
                    clone.querySelectorAll('[id="ZRURLPARAMVALUE"]')[0].name = "URLPARAMVALUE";
                    clone.querySelectorAll('[id="ZRURLPARAMTYPE"]')[0].name = "URLPARAMTYPE";
                    $("URLPARAMS").appendChild(clone);
                    clone.style.display="block";                       
                }
                else
                {
                    var clone = jQuery($("URLPARAMS")).find("#PARAMS");
                    clone.find("#ZRURLPARAMNAME").val(paramnames[i]);
                    clone.find("#ZRURLPARAMVALUE").val(paramvalues[i]);
                    clone.find("#ZRURLPARAMTYPE").val(paramtypes[i]);
                    clone.find("#ZRURLPARAMNAME").name = "URLPARAMNAME";
                    clone.find("#ZRURLPARAMVALUE").name = "URLPARAMVALUE";
                    clone.find("#ZRURLPARAMTYPE").name = "URLPARAMTYPE";
                }
        
            }
            changeParamCount();
        }
        
  }
  else
  {
    if(requestOptions.IMPOPTS == "cloud")
    {//Assuming isNewRequest variable value is always true
      $("ZDBEXWEBOPT").checked =true;
      locationSelected("GSHEET", "existImport");   // No I18N
    }
    else
    {
      if(isNewRequest)
          {
              locationSelected("PASTEDATA", "existImport");   //No I18N
              if($("ZDBPASTEDATA"))
              {
                  $("ZDBPASTEDATA").value = "";
              }
          }
          else
          {
              locationSelected(window.divData["importVia"], "existImport");   //No I18N
          }
          ZDBUtil.setFocus("ZDBPASTEDATA");     //No I18N  
    }
  }
  if(impOptionSelect.value == "UPDATEADD" || impOptionSelect.value == "DELETEUPDATEADD")
  {
      setColListVisible(true);
  }
}

ZDBImport.locationAndFileTypeSelect = function(fileType, fileLocation)
{
  if(fileType== "GSHEET")
  {
    $("ZDBEXWEBOPT").checked =true;
    locationSelected("GSHEET", "existImport");   //No I18N
  }
  else if(fileType== "ZDOCS")
  {
    $("ZDBEXWEBOPT").checked =true;
    locationSelected("ZDOCS", "existImport");   //No I18N
  }
  else if(fileType== "DROPBOX")
  {
    $("ZDBEXWEBOPT").checked =true;
    locationSelected("DROPBOX", "existImport");   //No I18N
  }
  else if(fileType== "BOX")
  {
    $("ZDBEXWEBOPT").checked =true;
    locationSelected("BOX", "existImport");   //No I18N
  }
  else if(fileType === "ONEDRIVE")
  {
    $("ZDBEXWEBOPT").checked =true;
    locationSelected("ONEDRIVE", "existImport");   //No I18N
  }
  else
  {
    $("ZDBEXWEBOPT").checked =true;
    locationSelected("GSHEET", "existImport");   // No I18N
  }
}

ZDBImport.setImportOption = function(impOptionSelect, perms)
{
  var appendImportPerm = perms[7];
  var updateImportPerm = perms[8];
  var truncateImportPerm = perms[9];
  var deleteUpdateAddPerm = perms[10];
  if(appendImportPerm == 1)
  {
      var impOpt = document.createElement("OPTION");
      impOpt.text = ZDBI18NMap.g('zrpt.table.existimport.step1.js.importOpt1');
      impOpt.value = "APPEND";    //No I18N
      impOptionSelect.options.add(impOpt);
  }
  if(truncateImportPerm == 1)
  {
      var impOpt = document.createElement("OPTION");
      impOpt.text = ZDBI18NMap.g('zrpt.table.existimport.step1.js.importOpt2');   //No I18N
      impOpt.value = "TRUNCATEADD";   //No I18N
      impOptionSelect.options.add(impOpt);
  }
  if(updateImportPerm == 1)
  {
      var impOpt = document.createElement("OPTION");
      impOpt.text = ZDBI18NMap.g('zrpt.table.existimport.step1.js.importOpt3');
      impOpt.value = "UPDATEADD"; //No I18N
      impOptionSelect.options.add(impOpt);
  }
  if(deleteUpdateAddPerm == 1)
  {
      var impOpt = document.createElement("OPTION");
      impOpt.text = ZDBI18NMap.g('zrpt.table.existimport.step1.js.importOpt4');
      impOpt.value = "DELETEUPDATEADD";     //No I18N
      impOptionSelect.options.add(impOpt);
  }
  return impOptionSelect;
}

ZDBImport.selectImportType = function(element,value)
{
    var importTypes = element.getElementsByTagName("option");
    for(var i=0;i<importTypes.length;i++)
    {
        var curOption = importTypes[i];
        if(curOption.value == value)
        {
            curOption.selected = true;
            if(value =="UPDATEADD" || value == "DELETEUPDATEADD")
            {
                setColListVisible(true);
            }
            break;
        }
    }
}

ZDBImport.selectFileTypeElement = function(fileTypeElt,value)
{
    var element = $(fileTypeElt);
    for(var i=0;i<element.length;i++)
      {
        if(element.options[i].value===value)
          {
          element.options[i].selected=true;
          break;
          }
      }
   
}

ZDBImport.setUserComboSettings = function(element,value)
{
    var elt= document.getElementById(element);
    elt.options[value].selected = true;
}

ZDBImport.setUserIPtSettings = function(element,value)
{
    var elt = document.getElementById(element);
    elt.value = value;
}

ZDBImport.setUserDateSettings = function(element,preDateFormat)
{
    var dateFormatElt = $(element);
    var newDateFormat = dg.extImpDF;
    var dateFormat = preDateFormat;
    
    if(newDateFormat)
    {
        if(newDateFormat != preDateFormat) //Is this check necessary??
        {
            dateFormat = newDateFormat;
        }
    }
    dateFormatElt.value = dateFormat;
    if(dateFormat)
    {
        ZDBImport.setOnDateDiv(ZDBImport.getSampleDate(dateFormat),dateFormat);
    }
    else
    {
        ZDBImport.setOnDateDiv(ZDBI18NMap.g('zrpt.common.import.step2.js.noDtCol'), "NODATE"); //No I18N
    }
}
ZDBImport.setFirstIsField = function(element,value)
{
    var elt = $(element);
    if(value == "true")
    {
        elt.options[0].selected = true;
    }
    else
    {
        elt.options[1].selected = true;
    }
}

ZDBImport.placeImport = function(response,requestOptions)
{ 
  $("ZDBCREATEDIALOGSTORE").innerHTML =  response.getOnlyHtml();
  ZDBUtil.setFocus("TABLENAME", true);  //No I18N
  ZDBImport.resetImportForm();
  ZDBImport.customizeImportOptions(requestOptions.IMPOPTS);
}

ZDBImport.setFileType = function(cldType, type)
{
  var importType = "";
  if(type != null)
  {
    importType = "EX";  // No I18N
  }

  var j;
  var extList =["DROPBOX", "BOX", "ONEDRIVE"]; // No I18N
  var extListI18N = ["zrpt.ext.js.dropbox", "zrpt.ext.js.box", "zrpt.ext.js.skydrive"];  // No I18N
  var fileList = ["CSV", "XLS", "HTML", "JSON", "XML"];   // No I18N
  var fileListI18N = ["zrpt.newtable.import.js.csvformat", "zrpt.newtable.import.js.excelformat", "zrpt.newtable.import.js.htmlformat", "zrpt.newtable.import.js.jsonformat", "zrpt.newtable.import.js.xmlformat"]; // No I18N
  if(ZDBGlobal.isODataEnabled && importType != "EX")
  {
      fileList.push("ODATA");
      fileListI18N.push("zrpt.newtable.import.js.odataformat");
  }
  $("ZDB" + importType + "FILETYPE").innerHTML = '';
  if(cldType == "import")
  {
    for(j=0;j<fileList.length;j++)
    {
      jQuery("#ZDB" + importType + "FILETYPE").append('<option value='+ fileList[j] + '>' + ZDBI18NMap.g(fileListI18N[j])+ '</option>');
    }
  }
  if(cldType == "cloud")
  {
    if(!ZDBClientUI.isCustomDomain)
    {
      if(ZDBClientUI.showDocs && ZDBClientUI.showGDrive)
      {
        jQuery("#ZDB" + importType + "FILETYPE").append('<option value=ZDOCS>' + ZDBI18NMap.g('zrpt.ext.js.zdocs')+ '</option>');
      }
      if(ZDBClientUI.showGDrive)
      {
        jQuery("#ZDB" + importType + "FILETYPE").append('<option value=GSHEET>' + ZDBI18NMap.g('zrpt.newtable.import.js.gsheetformat')+ '</option>');
      }
    }
    if(!ZDBClientUI.isCustomDomain && ZDBClientUI.showExt && ZDBClientUI.showGDrive)
    {
      for(j=0;j<extList.length;j++)
      {
        jQuery("#ZDB" + importType + "FILETYPE").append('<option value='+ extList[j] + '>' + ZDBI18NMap.g(extListI18N[j])+ '</option>');
      }
    }
    
    
    var fileTypeList = $("ZDB" + importType + "FILETYPE").options;
    for(j=0; j<fileTypeList.length; j++)
    {
      if(fileTypeList[j].value == "GSHEET") // No I18N
      {
        fileTypeList[j].setAttribute("selected", "selected");
      }
    }
  }
}

ZDBImport.customizeImportOptions = function(cldType, type)
{
  var importType = "";
  if(type != null)
  {
    importType = "EX";  // No I18N
  }
  
    ZDBImport.setFileType(cldType, type);
  
  if(cldType == "import")
  {
    $("ZDB" + importType + "DataLocation").style.display="";
    $("ZDB" + importType + "PASTEINP").style.display="";
    $("ZDB" + importType + "PASTEOPT").setAttribute("checked", "checked");
    $("ZDBFILETYPELBL").innerHTML = ZDBI18NMap.f("zrpt.newtable.import.js.filetype");
  }
  if(cldType == "cloud")
  {
    $("ZDBFILETYPELBL").innerHTML = ZDBI18NMap.f("zrpt.newtable.import.js.cloudtype");
    $("ZDB" + importType + "DataLocation").style.display="none";
    $("ZDB" + importType + "WEBOPT").removeAttribute("checked");
  }
  $("ZDB" + importType + "OPTIONINP").value = cldType;
}


ZDBImport.removeElIfPresent = function(elId)//$$ Very very bad fix. COSMIC CRICUITS FIX
{
  var el = $(elId);
  if((el != null) && (el.parentNode != null))
  {
    el.parentNode.removeChild(el);
  }
}

  
ZDBImport.showImportPopup = function(el,event)
 {
   if(ZDBMenu.warnIfNotLoggedIn())
   {
     return;
   }
   var view = ZDBClientUI.getViewObj(el,"view");    //No I18N
   if(ZDBGlobal.ISNEWLAYOUT) {
       ZDBMenu.showModuleMenu(el,event,"Import_Menu","GridMenu",true,view); //No I18N
   }
   else {
       ZDBMenu.showModuleMenuRight(el,event,"Import_Menu","GridMenu",true,view); //No I18N
   }
   
   var menu = $("ZDBImportPopupMenu");
   var schMI = $("ZDB_IMP_SCHEDULE_MENUITEM");
   var impDetailsMI = $("ZDB_LATEST_IMP_DETAILS");
   var syncDetailsMI = $("ZDB_SYNC_DETAILS");
   var manageDataSource = $("ZDB_MANAGE_DATASOURCE");
   var importFromMail=$("ZDB_IMPORT_FROM_MAIL");
   impDetailsMI.style.display = (view.lastImportStatus == 1)? ZDBUtil.visibleTrStyle:"none";
   jQuery(impDetailsMI).attr("hasSyncDetails",(view.syncDet == 1)?"true":"false");//No I18N
   syncDetailsMI.style.display = "none";//(view.syncDet == 1)? ZDBUtil.visibleTrStyle:"none";
   importFromMail.style.display=(view.canShowImpFromEmail===true && view.canDoImpFromEmail === true)?ZDBUtil.visibleTrStyle:"none";
   manageDataSource.style.display=(view.isCloudDBTbl == true || view.ISMULTITABLE == true)||(view.isODataTbl == true)?ZDBUtil.visibleTrStyle:"none";
   if(view.isOnPremiseDB)
   {
     AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBOnPremiseDatabase.ve?ZDBACTION=CANSHOWSCHEDULEOPT&OBJID=" + view.objId,METHOD:"POST",ONSUCCESSFUNC:ZDBImport.canShowScheduleOpt}); //No I18N
   }
   else
   {
     schMI.style.display = (view.schImportStatus == 2)? ZDBUtil.visibleTrStyle:"none";
   }
 }
 
ZDBImport.canShowScheduleOpt = function(response, requestOptions)
{
  var respStr = (response.responseText != null) ? jQuery.parseJSON(response.responseText) : null;
  var canShowSchOption = respStr != null ? respStr["CAN_SHOW_SCHEDULE_OPTION"] : "FALSE"; //No I18N
  if(canShowSchOption == "TRUE")
  {
    $("ZDB_IMP_SCHEDULE_MENUITEM").style.display =  ZDBUtil.visibleTrStyle;
  }
  else
  {
    $("ZDB_IMP_SCHEDULE_MENUITEM").style.display = "none";
  }
}

 ZDBImport.isMatchColSelected = function(frm)
 {
    var matchingColsList = frm.ZOHO_MATCHING_COLUMNS;
    var matchingColSelected = false;
    for(var i=0; i <matchingColsList.length && (matchingColSelected == false); i++)
    {
      var inputEl = matchingColsList[i];
      matchingColSelected = inputEl.checked;
    }
    if(matchingColSelected == false)
    {
      showCustomMessage(ZDBI18NMap.f("zrpt.common.url.errmsg"),$("EXISTCOLLISTDIV"),$("EXISTCOLLISTDIV"));
      return false;
    }
    return true;
 }
  
ZDBImport.isExternalFile = function (filetype)
{
    if(filetype === "DROPBOX" ||filetype === "BOX" || filetype === "ONEDRIVE" )
    {
        return true;
    }
    else if(filetype === "ZDOCS" || filetype === "GSHEET")
    {
      return true;
    }
    return false;
        
}

ZDBImport.showOnPremiseDBSettingDlgFrmEdit = function()
{
	 // var viewObj = ZDBDialogUtil.focusDialog.view;
	 // AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBCreateTableViaLocalDB.cc?DBID=" + ZDBClientUI.dbId + "&OBJID=" + viewObj.objId + "&EXISTIMPORT=false&ISSCHEDULEDIMPORT=true",METHOD:"POST",ONSUCCESSFUNC:ZDBImportSchedule.showDBConnecPropInlineDialogResp,VIEW:viewObj,OBJID:viewObj.objId,DBID:viewObj.dbId,INVOKESCRIPTS:false,CONNECTIONID:connId}); //No I18N
	  var param = "ZDBACTION=EDITSCHEDULE";//No I18N
		if(ZDBClientUI && ZDBClientUI.dbId)
		{
			param = param + "&DBID=" + ZDBClientUI.dbId;//No I18N
		}
		param = param + "&OBJID=" + ZDBClientUI.selectedTab.view.objId+"&ISSCHEDULEDIMPORT=true&EXISTIMPORT=false"; //No I18N
		AjaxAPI.sendRequest({URL:"/ZDBEditSchedule.cc?" + param,METHOD:"POST",ONSUCCESSFUNC:ZDBImport.showDBConnecPropInlineDialogResp,ISSCHEDULEDIMPORT:"true",EXISTIMPORT:"false"});
}

ZDBImport.showDBConnecPropInlineDialogResp = function(response, requestOptions)
{
	  if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/dbconnectivity/ZDBDBConnection.js",this,ZDBImport.showDBConnecPropInlineDialogResp,[response,requestOptions]))
	  {
	 	return;
	  }
	  ZDBDialogUtil.closeDialog();
	  var div = document.createElement("div");
	  div.innerHTML =  response.getOnlyHtml();
	  document.body.appendChild(div);
	  ZDBInlineDialog.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true, TITLE:ZDBI18NMap.g('zrpt.schsettings.js.dlgTitle'),OBJID:requestOptions["OBJID"],DBID:requestOptions["DBID"],VIEW:requestOptions["VIEW"]}); //No I18N
	 // var connId = requestOptions["CONNECTIONID"];
	 // ZDBDBConnection.fetchConnectionPropList(connId, "true", "false");
}

ZDBImport.getImportDetails = function(dbId)
{   
    var params = "DBID="+dbId;//No I18N
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBatchImportAction.ma?ZDBACTION=GETDBIMPORTDETAILS",METHOD:"GET", ONSUCCESSFUNC:ZDBImport.handleSyncDetails,PARAMETERS:params,PARAMS:params}); //No I18N
}
ZDBImport.deleteImport = function(instanceID,dbId,isFromAdmin)
{
   var params = "INSTANCEID="+instanceID;//No I18N
   params +="&DBID="+dbId;//No I18N
   if(isFromAdmin == false)
       {
           AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBatchImportAction.ma?ZDBACTION=DELETEIMPORT",METHOD:"POST", ONSUCCESSFUNC:ZDBImport.handleSyncDetails,PARAMETERS:params,PARAMS:params}); //No I18N
       }
       else
           {
               AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBatchImportAction.ma?ZDBACTION=DELETEIMPORT",METHOD:"POST", ONSUCCESSFUNC:ZDBImport.adminhandleSyncDetails,PARAMETERS:params,PARAMS:params}); //No I18N
           }
}
ZDBImport.stopImport = function(instanceID,dbID,isFromAdmin)
{
   var params = "INSTANCEID="+instanceID;//No I18N
   params +="&DBID="+dbID;//No I18N
    if(isFromAdmin == false)
       {
            ZDBImportSchedule.showImportDetails(false);
            ZDBImportSchedule.showSyncDetailsDlg(false);
            ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.toolbar.import.js.confirmpauseimport'),"ZDBYESNO",  //No I18N
									{ONCLICK:ZDBImport.confirmPauseImport,CALLOUT:false,INSTANCEID:instanceID,DBID:dbID});
       }
       else
           {
                AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBatchImportAction.ma?ZDBACTION=STOPIMPORT",METHOD:"POST", ONSUCCESSFUNC:ZDBImport.adminhandleSyncDetails,PARAMETERS:params,PARAMS:params}); //No I18N
           }
}
ZDBImport.retryImport = function(instanceID,dbID,isFromAdmin)
{
   var params = "INSTANCEID="+instanceID;//No I18N
   params +="&DBID="+dbID;//No I18N
   if(isFromAdmin == false)
       {
           ZDBImportSchedule.showImportDetails(false);
           ZDBImportSchedule.showSyncDetailsDlg(false);
           ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.toolbar.import.js.confirmretryimport'),"ZDBYESNO",  //No I18N
									{ONCLICK:ZDBImport.confirmretryImport,CALLOUT:false,INSTANCEID:instanceID,DBID:dbID});
       }
       else
           {
               AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBatchImportAction.ma?ZDBACTION=RETRYIMPORT",METHOD:"POST", ONSUCCESSFUNC:ZDBImport.adminhandleSyncDetails,PARAMETERS:params,PARAMS:params}); //No I18N
           }

}
ZDBImport.confirmPauseImport = function(clickType,requestOpt)
{
    if(clickType === "NO")
	{
		return;
	}
   var instanceID = requestOpt.INSTANCEID;
   var dbId = requestOpt.DBID;
   var params = "INSTANCEID="+instanceID;//No I18N
   params +="&DBID="+dbId;//No I18N
   AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBatchImportAction.ma?ZDBACTION=STOPIMPORT",METHOD:"POST", ONSUCCESSFUNC:ZDBImport.handleSyncDetails,PARAMETERS:params,PARAMS:params}); //No I18N
}
ZDBImport.confirmretryImport = function(clickType,requestOpt)
{
    if(clickType === "NO")
	{
		return;
	}
   var instanceID = requestOpt.INSTANCEID;
   var dbId = requestOpt.DBID;
   var params = "INSTANCEID="+instanceID;//No I18N
   params +="&DBID="+dbId;//No I18N
   AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBatchImportAction.ma?ZDBACTION=RETRYIMPORT",METHOD:"POST", ONSUCCESSFUNC:ZDBImport.handleSyncDetails,PARAMETERS:params,PARAMS:params}); //No I18N       
}
ZDBImport.adminRetry = function(instanceID)
{ 
    var params = "INSTANCEID="+instanceID;//No I18N
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBatchImportAction.ma?ZDBACTION=RETRYIMPORT",METHOD:"POST", ONSUCCESSFUNC:ZDBImport.adminhandleSyncDetails,PARAMETERS:params,PARAMS:params}); //No I18N
            
}

ZDBImport.updateSyncStatusasResumed = function(response, requestOptions)
{
    ZDBImportSchedule.showImportDetails();
    
}
ZDBImport.handleSyncDetails = function(response, requestOptions)
{
   ZDBDialogUtil.closeDialog();
   var result = jQuery.parseJSON(response.responseText);
   ZDBMsgBox.showInfo(result.MESSAGE);
}
ZDBImport.adminhandleSyncDetails = function(response)
{
   var result = jQuery.parseJSON(response.responseText);
   var instanceId = result.INSTANCEID;
   var dbID = result.DBID;
   window.location = ZDBGlobal.CTX + "/import/ZRViewImportStatus.jsp?INSTANCEID="+instanceId+"&DBID="+dbID;//No I18N
   
}

