//$Id$
var ZDBColorUtil = new function()
{
    this.getShades = function(color, percent)
    {
				var rgb = "";
        var colorCode = color;
        if(colorCode.length<6){
            return;
        }
				
        var rgb =ZDBColorUtil.getRGB(colorCode);
        return ZDBColorUtil.getHex(ZDBColorUtil.shade(rgb,percent));
    }
		
		this.getRGB = function(colorCode)
		{
				var clr = colorCode.toLowerCase();
				return[parseInt(clr.slice(0,2),16),parseInt(clr.slice(2,4),16),parseInt(clr.slice(4),16)];
		}

        this.getRGBValues = function(clrValue)
        {
            var rgb,clr;
            if(clrValue.charAt(0)=="#")
            {
                clr = clrValue.slice(1,7);
                rgb = ZDBColorUtil.getRGB(clr);
            }
            else
            {
                rgb = clrValue.split(",");
                var len = rgb[0].length;
                var plc = rgb[0].indexOf("(");
                rgb[0] = rgb[0].slice(plc+1,len);
                rgb[1] = rgb[1].replace(" ","");
                rgb[2] = rgb[2].replace(")","");
                rgb[2] = rgb[2].replace(" ","");
            }
            return rgb;
        }

        this.getNewShade = function(rgb, percent)
        {
			var shade=[],i;
			for(var i=0;i<3;i++)
			{
                if(rgb[i]==0)
                {
                    rgb[i] = (255 * percent) - 255;
                }

				shade[i] = Math.round(rgb[i]*percent);
				if(shade[i]>255)
                {
                    shade[i]=255;
                }

                if(shade[i]<0)
                {
                    shade[i]=0;
                }
			}
			return shade;
        }

		this.shade = function(rgb,percent)
		{
			var shade=[],i;
			for(var i=0;i<3;i++)
			{
				shade[i] = Math.round(rgb[i]*percent);
				if(shade[i]>255){shade[i]=255;}
				if(shade[i]<0){shade[i]=0;}
			}
			return shade;
		}
		
		this.getHex = function(shade)
		{
			return ZDBColorUtil.numToHex(shade[0])+ZDBColorUtil.numToHex(shade[1])+ZDBColorUtil.numToHex(shade[2]);
		}
		
		this.numToHex = function(n)
		{
			return('0'+n.toString(16)).slice(-2);
		}
		
}
ZDBColorUtil.getConvertedColor = function(x,luminanceChange,isDynamicGeneration,checkForThreshold,threshold){
	
	//isDynamicGeneration and checkForThreshold are boolean variables
	//if none of the variables are defined color is calculated with luminanceChange as value of "l"
	//if isDynamicGeneration is true , Dynamic calculation will take place
	//if isDynamicGeneration is false, Static calculation will take place  i.e., l (+/-) luminanceChange
	//if checkForThreshold is true ( if value of "l" is  < 75 it will return "FFF" else it will color is calcualted with luminanceChange as value of "l"
	//if Both checkForThreshhold and isDynamicGeneration is true, the case is to check for color derived from default "e2e2e2" dynamically,
	//derived colour should not be so light, note: This case is handled only for grey shades;
	var rgb = ZDBColorUtil.getRGB(x);
	var r = rgb[0];
	var g = rgb[1];
	var b = rgb[2];
	var hsl = ZDBColorUtil.rgbToHsl(r,g,b);
	var h = hsl[0];
	var s = hsl[1];
	var l = hsl[2];
	if( l == 100 )
		{
		h = 0;
		s = 0;
		}
	if(isDynamicGeneration === true)
		{
		l = ZDBColorUtil.calculateLuminanceDynamically(l,luminanceChange);
		if(!ZDBColorUtil.isNotGreyShade(x))
			{
		if(checkForThreshold === true)
			{
			if(l > threshold)
				{
					l = threshold;
				}
			}
		else if(l > 96)
			{
				l = 96;
			}
			}
		}
	else if(isDynamicGeneration ===  false && !checkForThreshold)
		{
		l = ZDBColorUtil.calculateLuminanceStatically(l,luminanceChange);
		}
	else if(checkForThreshold)
		{
		if(l < threshold)
			{
	       if(h > 45 && h < 195 && ((s  > 80 && s <= 90 &&  l > 50) || (s >90 && l > 45)))
	    	   {
	    	   l = luminanceChange;
	    	   }
	       else
	    	   {
	    	   return "fff"; //No I18N
	    	   
	    	   }
			}

		else
			{
			l = luminanceChange;
			}
		}
	else
		{
		l=luminanceChange;
		}

	return ZDBColorUtil.hslToHex(h,s,l);
	}

ZDBColorUtil.calculateLuminanceDynamically = function(currentLuminance,dynamicPercentage)
{// this calculate luminance dynamically based on the below formula and return the luminacne
	//(((100 - chosen Color Luminance)/100) *  required luminance )+chosen Color Luminance
	var tempL = 100 - currentLuminance;
	tempL = tempL/100;
	var derivedLuminance = (dynamicPercentage * tempL)+currentLuminance;
	derivedLuminance = Math.round(derivedLuminance);
	return derivedLuminance;
	
}

ZDBColorUtil.calculateLuminanceStatically = function(currentLuminance, staticPercentage)
{	 // this method add/subtract the staticPercentage from currentLuminace and return the luminance
	var derivedLuminance =  currentLuminance + staticPercentage;
	derivedLuminance = derivedLuminance > 100 ? 100 :derivedLuminance;
	derivedLuminance = derivedLuminance < 0 ? 0 : derivedLuminance;
	return derivedLuminance;
}
	ZDBColorUtil.rgbToHsl = function(red, green, blue, opacity){
	    red = parseFloat(red) / 255,
	    green = parseFloat(green) / 255,
	    blue = parseFloat(blue) / 255;

	    var max = Math.max(red,green,blue), min = Math.min(red,green,blue);
	    var chrome = max - min, lum = (max + min) * 0.5;

	    var hue = max === min ? 0 : red === max ? (60 * (green - blue) / chrome + 360) % 360 : green === max ? 60 * (blue - red) / chrome + 120 : 60 * (red - green) / chrome + 240;

	    sat = lum === 0 ? 0 : lum === 1 ? 1 : lum <= .5 ? chrome / (max+min) : chrome / (2 - (max+min));

	    hue = Math.round(hue),
	    sat = Math.round(sat * 100),
	    lum = Math.round(lum * 100),
	    opacity = (opacity != null)?opacity:1;
	    return [hue, sat, lum, opacity];
	}
	ZDBColorUtil.hslToRgb = function(hue, saturation, luminence, opacity){
		function hueToRGB(p, q, t){
	        if(t < 0) t += 1;
	        if(t > 1) t -= 1;
	        if(t < 1/6) return p + (q - p) * 6 * t;
	        if(t < 1/2) return q;
	        if(t < 2/3) return p + (q - p) * (2/3 - t) * 6;
	        return p;
	    }
	    hue = hue / 360;
	    saturation = saturation / 100;
	    luminence = luminence / 100;
	    var chrome = (luminence < 0.5)?luminence * (1 + saturation):
	        luminence + saturation - luminence * saturation;
	    var matchingComp = 2 * luminence - chrome;
	    var redComp = hue + 1 / 3;
	    var greenComp = hue;
	    var blueComp = hue - 1 / 3;
	    var red = Math.round(hueToRGB(matchingComp, chrome, redComp) * 255);
	    var green = Math.round(hueToRGB(matchingComp, chrome, greenComp) * 255);
	    var blue = Math.round(hueToRGB(matchingComp, chrome, blueComp) * 255);
	    opacity = (opacity != null)?opacity:1;
	    return [red, green, blue, opacity];
	} 
	
	ZDBColorUtil.hslToHex = function(h,s,l)
	{
		return ZDBColorUtil.getHex(ZDBColorUtil.hslToRgb(h,s,l));
	}
	
	ZDBColorUtil.isNotGreyShade = function(color)
	{
		var rgb = ZDBColorUtil.getRGB(color);
		var averageValue  = rgb[0] + rgb [1] + rgb [2];
		averageValue = parseInt(averageValue/3);
		var flag = false;
		for(var i=0;i<rgb.length;i++)
			{
			var check = averageValue - rgb[i];
			if(check > -10 && check < 10)
				{
				continue;
				}
			else
				{
				flag = true;
				break;
				}
			}
		return flag;
	}
	
	ZDBColorUtil.getPatternColor = function(color, retHex)
	{
		var clr;
		if(color.charAt(0)=="#")
		{
			clr = color.slice(1,7);
			var rgb = ZDBColorUtil.getRGB(clr);
			if((rgb[0] + rgb[1] + rgb[2]) > 500)
			{
				clr = retHex ? "#000000" : "rgb(0,0,0)";	//NO I18N
			}
			else
			{
				clr = retHex ? "#ffffff" : "rgb(255,255,255)";	//NO I18N
			}
		}
		else
		{
			var rgb = color.split(",");
			var len = rgb[0].length;
			var plc = rgb[0].indexOf("(");
			rgb[0] = rgb[0].slice(plc+1,len);
			rgb[1] = rgb[1].replace(" ","");
			rgb[2] = rgb[2].replace(")","");
			rgb[2] = rgb[2].replace(" ","");

			if((parseInt(rgb[0]) + parseInt(rgb[1]) + parseInt(rgb[2])) > 500)
			{
				clr = retHex ? "#000000" : "rgb(0,0,0)";	//NO I18N
			}
			else
			{
				clr = retHex ? "#ffffff" : "rgb(255,255,255)";	//NO I18N
			}
		}

		return clr;
	}