//$Id$
var ZDBExpViewHandler = new function()
{
    var relViewInfo ={};
    var foldInfo ={};
    var typeViewInfo ={};
    var childArr =[];
    var viewListArray, folderListArray;
    var viewListResp = {};
    var foldListResp = {};
    var isBatched = "isBatched"; //No i18N
    var unbatched = [];
    var filters = [];
    var selViewsAlone = false;
  
  // #API INTEGRATION
  // #VIEW KEYLIST
  this.VIEW_ID = 0;
  this.VIEW_NAME = 1;
  this.VIEW_TYPE = 2;
  this.PARENT_ID = 3;
  this.VIEW_DESC = 4;
  this.FOLD_ID = 5;
  this.VIEW_CREATE_TIME = 6;
  this.VIEWOWNER=7;
  this.CREATED_BY = 8;
  this.SHARED_BY = 9;
  this.PUBLICPERMLEVEL = 10;
  this.LAST_DATA_MODIFY = 11;
  this.LAST_DATA_MODIFY_BY = 12;
  this.LAST_DESIGN_MODIFY = 13;
  this.LAST_DESIGN_MODIFY_BY = 14;
  this.OWNER_ZUID = 15;
  this.VIEW_LAST_MODIFIED = 16;
  this.IS_FAVOURITE = 18;
  
  // #FOLDER KEYLIST
  this.FOLDER_ID = 0;
  this.FOLD_NAME = 1;
  this.FOLD_DESC = 2;
  this.FOLD_INDEX = 3;
  this.ISDEFAULT = 4;
  this.viewTypes =["Table", "QueryTable", "AnalysisView", "Pivot",  "SummaryView", "Report", "Dashboard"]; //No i18N
    this.getViewResp = function(){
        var temp = ZDBUtil.duplicateObject({temp:viewListArray});
        return temp.temp;
    }
    this.valueFetch = function(dbId, navigType)
    {
//        var url = "/reports/reportsapi/db/"+ZDBClientUI.dbId+"/VIEWLIST?ZOHO_FOLDERLIST=true" +"&NOCACHE="+new Date().getTime();  //No I18N
//        AjaxAPI.sendRequest({URL:url,METHOD:"GET",ONSUCCESSFUNC:ZDBExpViewHandler.JSONResponseReconstruction, NAVIGTYPE:navigType, OPSTATUSID: "ZDBMainLoader"});

        ZRSAjax.get('/reportsapi/db/'+ZDBClientUI.dbId+'/VIEWLIST', 
            {
                ZOHO_FOLDERLIST: true,
                NOCACHE: new Date().getTime()
            },
            {
                successHandler: {
                    func: ZDBExpViewHandler.JSONResponseReconstruction,
                    ctx: ZDBExpViewHandler
                },
                NAVIGTYPE:navigType
            }
        );
    }
    
    this.JSONResponseReconstruction = function(resp,requestOptions)
    {
        var navigType = requestOptions["NAVIGTYPE"];
        viewListArray = resp["viewListValues"];
        folderListArray = resp["folderListValues"];
        viewListResp = {};
        foldListResp = {};
        for(var i = 0; i < viewListArray.length; i++)
        {
            viewListResp[viewListArray[i][0]] = viewListArray[i];
        }
        ZDBExpViewHandler.defaultFolderId = "";
        for(var i = 0; i < folderListArray.length; i++)
        {
            var foldArr = folderListArray[i];
            foldListResp[foldArr[0]] = foldArr;
            if(!ZDBExpViewHandler.defaultFolderId){
            	ZDBExpViewHandler.defaultFolderId = (foldArr[ZDBExpViewHandler.ISDEFAULT]) ? foldArr[0] : "";
	    	}
        }
        var userPref = resp["userPreference"];
        ZDBExpViewHandler.sortedColumnName = userPref["sorted_Column_Name"];
        ZDBExpViewHandler.sortedOrder = userPref["sorted_Order"];
        ZDBClientUI.ISCARDLAYOUT = (userPref["LAYOUT"] === 1);  //No I18N
        ZDBExpViewHandler.explorerLayoutSwitch(navigType);
        ZDBNavigation.autoGenerationTag();
        typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.onloadChanges('{"VIEWLIST":true}');//NO I18N
        ZDBExpViewHandler.handleOnHover();
        ZDBNavEvtDelegation.toolbarEvtHandler();
        ZDBNavEvtDelegation.expMenuItemEvtHandler();
        ZDBNavigation.initializeNavTiles();
        ZDBNavigation.showNavTilesBasedOnViews();
        var searchData = {
            srchCallBack: this.searchViews,
            clearCallBack: this.showAllViews
        };
            
        if($("ZRNewLayoutSearch") && !$("ZRNewLayoutSearch").querySelector(".srchHolder")) {
            var srchComp = ZRSSearchComponent.standardSearchComp(searchData);
            $("ZRNewLayoutSearch").insertBefore(srchComp, $("ZRNewLayoutSearch").firstChild);
            var searchOptions = $("ZRNewLayoutSearch").querySelector(".navSearchOptions");
            srchComp.addEventListener("focus", function() { searchOptions.style.display = "block"; }, true);
            document.addEventListener("click", function(event) {
                var el = DOMUtils.getSelfOrParentWithAttrValue(event.target, "id", "ZRNewLayoutSearch"); //No I18N
                if(!el) {
                    searchOptions.style.display = "none";
                }
            }, true);
        }
    }
    
    this.searchViews = function()
    {
        var input = ZDBUtil.getElWithTagNAttrWithVal($("ZRNewLayoutSearch"), "elname", "srchInput", "input").value.toLowerCase(); //No I18N
        if(input == "" && !filters.length)
        {
            ZDBExpViewHandler.showAllViews();
            return;
        }
        
        var temp = (ZDBClientUI.ISCARDLAYOUT) ? "_cardViewTemp" : "_ListViewTemp"; //No i18N
        var ul = document.createElement("ul");
        ul.className =  (ZDBClientUI.ISCARDLAYOUT) ? "cardLayoutHolder" : "expNewLayout"; //No i18N
        ul.style.height = ZDBNavigation.viewListBody.children[0].style.height;
        var searchListItem = ZDBUtil.templateCreator(temp);
        
        for(var key in viewListResp) {
            var viewData = viewListResp[key];
            var viewName = viewData[ZDBExpViewHandler.VIEW_NAME].toLowerCase();
            var viewType = viewData[ZDBExpViewHandler.VIEW_TYPE];
            var condition = (!filters.length || filters.indexOf(viewType) > -1);
            if(input != "") {
                condition = condition && (viewName.indexOf(input) > -1);
            }
            if(condition) {
                var selectView = (ZDBExpViewHandler.selectedViewIds.indexOf(key) != -1);
                ZDBExpViewHandler.viewCreation(searchListItem, key, viewType, "childFold", selectView);
                ul.appendChild(searchListItem.cloneNode(true));
            }
        }
        
        var expSpace = $("explorerFilterSpace");
        expSpace.innerHTML = "";
        ZDBUtil.removeClass(expSpace, "inSelectMode");
        
        if(ul.childElementCount) {
            expSpace.appendChild(ul);
        }
        else {
            if(!expSpace.querySelector(".emptySearchSpace")) {
                var div = document.createElement("div");
                div.className = "emptySearchSpace";
                var innerTxt = document.createTextNode(ZDBI18NMap.g("zrpt.common.toolbar.table.findnreplace.zdbalertmsg.js.findNReplaceFailedErr"));
                div.appendChild(innerTxt);
                expSpace.appendChild(div);
            }
        }
        $("ZDBEXPVIEW").style.display = "none";
        expSpace.style.display = "block";
    }
    
    this.filterViews = function(el, filterType)
    {
        ZDBUtil.swapClass(el, "selectedViewType", "deselectedViewType"); //No I18N
        if(ZDBUtil.hasClass(el, "selectedViewType")) {
            filters.push(filterType);
        }
        else {
            filters.splice(filters.indexOf(filterType), 1);
        }
        ZDBExpViewHandler.searchViews();
    }
    
    this.clearSearchFilter = function()
    {
        filters = [];
        var filterOptions = $("ZRNewLayoutSearch").querySelectorAll(".selectedViewType");
        for(var i=0; i<filterOptions.length; i++)
        {
            ZDBUtil.swapClass(filterOptions[i], "deselectedViewType", "selectedViewType"); //No I18N
        }
    }
    
    this.showAllViews = function(el)
    {
        if(el && el.tagName == "INPUT" && filters.length) {
            ZDBExpViewHandler.searchViews();
            return;
        }
        
        $("ZDBEXPVIEW").style.display = "block";
        ZDBUtil.removeAllChildren($("explorerFilterSpace"));
        var searchfield = ZDBUtil.getElWithTagNAttrWithVal($("ZRNewLayoutSearch"), "elname", "srchInput", "input"); //No I18N
        searchfield.value = "";
        ZDBExpViewHandler.clearSearchFilter();
    }
    
    this.explorerLayoutSwitch = function(navigType){
        //Layouts - card layout, List (New layout) and old Layout
        var expNewHeader = document.getElementsByClassName("newExpHeader")[0];
        if($("ZDBEXPTBODY")) {
            var el = $("ZDBEXPTBODY").querySelectorAll(".enableActionOnSelected");
            for(var i=0; i<el.length; i++) {
                ZDBUtil.removeClass(el[i], "enableActionOnSelected");
            }
        }
        
        var foldTempId = "_folderListTemp"; //No I18N
         for(var key in ZDBNavigation.isRefreshReq) {
             ZDBNavigation.isRefreshReq[key] = true;
         }
        if(ZDBClientUI.ISCARDLAYOUT) {
            var viewTempId = "_cardViewTemp"; //No I18N
            ZDBExpViewHandler.viewHolderClass = "cardLayoutHolder";  //No I18N
            ZDBUtil.addClass($("ZDBMAINEL"), "cardLayout");   
        }
        else {
            var viewTempId = "_ListViewTemp"; //No I18N
            ZDBExpViewHandler.viewHolderClass = "expNewLayout";  //No I18N
            ZDBUtil.removeClass($("ZDBMAINEL"), "cardLayout");
            if(ZDBClientUI.selectedTab == ZDBNavigation.explorerTab) {
                var orderClassName = (this.sortedOrder == "ASC") ? "sortByASCIcon" : "sortByDESCIcon"  //No i18N
                if (ZDBExpViewHandler.sortedColumnName == "viewName") {//No i18N
                    sortCount = 0; }
                else if (ZDBExpViewHandler.sortedColumnName == "desc") {//No i18N
                    sortCount = 1; }
                else {
                    sortCount = 2; 
                }
                var ExpHeader = expNewHeader.getElementsByClassName("sortIcon")[sortCount];
                ZDBUtil.addClass(ExpHeader, orderClassName);
            }
        }
        var elname = (ZDBClientUI.ISCARDLAYOUT) ? "gridIcon" : "listIcon"; //No I18N
        var selectedStyle = ZDBUtil.getElWithTagNAttrWithVal(document, "elname", elname, "a"); //No I18N
//        if(selectedStyle) {     
//            selectedStyle.style.display = "none";
//        }
        ZDBUtil.addClass(selectedStyle, "viewStyleSelected");
    	var foldTempOb = ZDBUtil.templateCreator(foldTempId);
        var viewListOb = ZDBUtil.templateCreator(viewTempId);
        var viewSepOb = document.createElement("li");
        viewSepOb.className = "viewSeparator";
    	var expViewUl = document.createElement("ul");
        expViewUl.className = ZDBExpViewHandler.viewHolderClass;
        expViewUl.setAttribute("elname", "viewHolder");
        ZDBExpViewHandler.handleNavigStructure(navigType, foldTempOb, viewListOb, viewSepOb, expViewUl);
		ZRSCardPreviewHandler.addCardPreviewEvntsNInitialize();
    }
    
    this.handleNavigStructure = function(navigType, foldTempOb, viewListOb, viewSepOb, expViewUl)
    {
        ZDBClientUI.Objects_TBODY.setAttribute("navigType",navigType);//No i18N
        ZDBNavigation.navSelect.value = navigType;
        ZDBExpViewHandler.selectedViewIds = [];
        ZDBExpViewHandler.clearExpView(); 
        var newFoldOpt = ZDBUtil.getElsWithTagNAttrWithVal(document, "elname", "newFoldOpt", "a"); //No I18N
        var newFoldOptDisp, holder;
        ZDBNavigation.manageFolderState();
        switch (navigType) {
            case "Folder": //No i18N
            {// hiding viewslist - for folder open close state handling
                newFoldOptDisp = "block"; //No I18N
                ZDBExpViewHandler.folderViewJSONFetch();
                unbatched = Object.keys(foldInfo);
                holder = ZDBExpViewHandler.folderView(foldTempOb, viewListOb, viewSepOb);
                break;
            }
            case "Related": //No i18N
            {
                newFoldOptDisp = "none"; //No I18N
                ZDBExpViewHandler.relatedViewJSONFetch();
                unbatched = Object.keys(relViewInfo);
                holder = ZDBExpViewHandler.relatedView(viewListOb, viewSepOb);
                break;
            }
            case "All": //No i18N
            {
                newFoldOptDisp = "none"; //No I18N
                ZDBExpViewHandler.typeViewJSONFetch();
                unbatched = Object.keys(typeViewInfo);
                holder = ZDBExpViewHandler.typeView(foldTempOb, viewListOb, viewSepOb);
            }
        }
        for(var i = 0; i < newFoldOpt.length; i++) {
            newFoldOpt[i].style.display = newFoldOptDisp;
        }
        expViewUl.innerHTML = expViewUl.innerHTML + holder.innerHTML;
        var isViewListEmpty = ZDBExpViewHandler.isViewListEmpty();
        var navBar = $("ZDBNavigationBarTD");
        this.isDashEditMode = ZDBUtil.hasClass(navBar, "ZRDashboardEdit"); //No i18N
        if(!this.isDashEditMode) {
        	if(isViewListEmpty && ZDBClientUI.isDBOwner)
        	{
        		var expHeader = document.getElementsByClassName("newExpHeader")[0]; //No I18N
                ZDBUtil.hide(expHeader);
        		ZDBNavigation.showCreateOpts();
        	}
        	else {
        		ZDBNavigation.createViewsFromLeftSide(expViewUl);                
                expViewUl.addEventListener("scroll",ZDBExpViewHandler.batchViewsOnScroll, false);
        	}
        }
        else {
            if(isViewListEmpty && ZDBClientUI.isDBOwner)
            {
                ZDBNavigation.showCreateOpts();
            }
            else{
                ZDBNavigation.createViewsFromLeftSide(expViewUl);
                var leftUl = ZDBNavigation.getExpViewsCloneCopy();
                ZDBClientUI.Objects_TBODY.appendChild(leftUl);
                ZDBClientUI.Objects_TBODY.style.display = "block";
                var searchArea = ZDBUtil.getElWithTagNAttrWithVal(ZDBClientUI.swipeArea, "id", "dashEditDesignSrchSpace", "div");  //No I18N
                searchArea.style.display = "none";
                expViewUl.addEventListener("scroll",ZDBExpViewHandler.batchViewsOnScroll, false);
                ZDBExpViewHandler.showOrHideEmptyFold();
        	}
            
        }
        if(navigType == "Related") {
        	ZDBUtil.addClass(expViewUl, "childPaddingReq");
        } else {
            ZDBUtil.removeClass(expViewUl, "childPaddingReq");
        }      
        if(ZDBClientUI.selectedTab == ZDBNavigation.explorerTab) {  
            var expColDisplay = (navigType == "Folder" || navigType == "All") ? "block" : "none"; //No i18N
            $("ZDBExpAllIcon").style.display = expColDisplay;
            ZDBNavigation.handleExpandCollapseIconState();
        }
        ZDBExpViewHandler.maintainViewCountByType();
        ZDBNavigation.updateDBObjectList();
        ZDBUtil.removeClass(ZDBNavigation.favFilterIcon,"ZRSFav");
        
    }
    this.folderView = function(foldTempOb, viewListOb, viewSepOb)
    {
        var holder = document.createElement("ul");
        var batchCount = Math.floor(ZDBClientUI.placeHolderHeight / 30); // 30 is each lists height
        var i=0, toSelectBatchedView;
        var indexIterator = 2;
        var tableView = 0;  // 0 - index for table data not present, 1 - present
        var foldersOpened = ZDBNavigation.getNavigState("Folder"); //No i18N
        foldTempOb.removeAttribute("type");
        foldTempOb.folderType.className = "viewTypeIcon expNewFoldIcon";//No i18N
        var selIds = ZDBExpViewHandler.selectedViewIds;
        while(unbatched.length && batchCount > 0)
        {
            var key = unbatched[0];
            if(ZDBGlobal.IS_ONPREMISE_BUILD) {
                for(var index in foldListResp)
        	{
        		if((foldListResp[index][3] == 1)&&(tableView == 0))
                {
                    indexIterator=1;
                    tableView = 1;
                }
        		if(indexIterator == foldListResp[index][3])
        		{
        			indexIterator++;
        			key = index;
        			break;
        		}
        	}
            }
            var isFoldOpen = (foldersOpened && foldersOpened.indexOf(key) != -1);
            ZDBExpViewHandler.folderListCreation(foldTempOb, key, isFoldOpen);
            var foldTemp = foldTempOb.cloneNode(true);
            if(key == ZDBExpViewHandler.defaultFolderId) {
                ZDBUtil.addClass(foldTemp, "isDefault");
                var defIcon = ZDBUtil.createSVGTemplate("#ZR-defaultFolder");//No i18N
                var defIconHolder = foldTemp.getElementsByClassName("defaultFolder")[0];
                defIconHolder.appendChild(defIcon);
            }
            holder.appendChild(foldTemp);
            foldInfo[key][isBatched] = false;
            batchCount--;
            unbatched.shift();
            if(isFoldOpen) {
                for(var j=i; j<i+foldInfo[key].length; j++)
                {
                    var id = foldInfo[key][j-i];
                    toSelectBatchedView = (selIds.indexOf(id) != -1);
                    var viewType = viewListResp[id][ZDBExpViewHandler.VIEW_TYPE];
                    ZDBExpViewHandler.viewCreation(viewListOb, id, viewType, "childFold", toSelectBatchedView);
                    holder.appendChild(viewListOb.cloneNode(true));
                    batchCount--;
                }
                foldInfo[key][isBatched] = true;
                i= foldInfo[key].length+i;
            }
            	//if(!ZDBClientUI.ISCARDLAYOUT)holder.appendChild(viewSepOb.cloneNode(true));
        }
        return holder;
    }

    this.relatedView = function(viewListOb, viewSepOb)
    {
        var holder = document.createElement("ul");
        var batchCount = Math.floor(ZDBClientUI.placeHolderHeight / 30); // 30 is each lists height
        var i=0, toSelectBatchedView;
        var selIds = ZDBExpViewHandler.selectedViewIds;
        while(unbatched.length && batchCount > 0)
        {
            var key = unbatched[0];
            if(key != "Dashboard") {
                var relClass = viewListResp[key][ZDBExpViewHandler.VIEW_TYPE];
                ZDBExpViewHandler.viewCreation(viewListOb, key, relClass, "parentFold");//No i18N
                holder.appendChild(viewListOb.cloneNode(true));
            }
            relViewInfo[key][isBatched] = false;
            batchCount--;
            unbatched.shift();
            for(var j=0; j<relViewInfo[key].length; j++){
                var id = relViewInfo[key][j];
                toSelectBatchedView = (selIds.indexOf(id) != -1);
                var relChildClass = viewListResp[id][ZDBExpViewHandler.VIEW_TYPE];
                var parOrChild = (key == "Dashboard") ? "parentFold" : "childFold"; //No I18N
                ZDBExpViewHandler.viewCreation(viewListOb, id, relChildClass, parOrChild, toSelectBatchedView);
                holder.appendChild(viewListOb.cloneNode(true));
                batchCount--;
            }
            //holder.appendChild(viewSepOb.cloneNode(true));
            relViewInfo[key][isBatched] = true;
            i= relViewInfo[key].length+(i+1);
        }
        return holder;
    }

    this.typeView = function(foldTempOb, viewListOb, viewSepOb)
    {
        var holder = document.createElement("ul");
        var batchCount = Math.floor(ZDBClientUI.placeHolderHeight / 30); // 30 is each lists height
        var i=0, toSelectBatchedView;
        var foldersOpened = ZDBNavigation.getNavigState("All"); //No i18N
        var selIds = ZDBExpViewHandler.selectedViewIds;
        foldTempOb.removeAttribute("foldId");
        while(unbatched.length && batchCount > 0)
        {
            var key = unbatched[0];
            typeViewInfo[key][isBatched] = false;
            if(typeViewInfo[key].length == 0){
                unbatched.shift();
                continue;
            }
            var isFoldOpen = (foldersOpened && foldersOpened.indexOf(key) != -1);
            ZDBExpViewHandler.typeFoldCreation(foldTempOb, key, isFoldOpen);
            var foldTemp = foldTempOb.cloneNode(true)
            ZDBUtil.removeElementsByClassName(foldTemp, "ViewDesc"); //No i18N
            ZDBUtil.removeElementsByClassName(foldTemp, "expOptionMenu"); //No i18N
            ZDBUtil.removeElementsByClassName(foldTemp, "defaultFolder"); //No i18N
            holder.appendChild(foldTemp);
            batchCount--;
            unbatched.shift();
            if(isFoldOpen) {
                for(var j=i; j<i+typeViewInfo[key].length; j++)
                {
                    var id = typeViewInfo[key][j-i];
                    toSelectBatchedView = (selIds.indexOf(id) != -1);
                    var viewType = (ZDBClientUI.ISCARDLAYOUT) ? viewListResp[id][ZDBExpViewHandler.VIEW_TYPE] : "navigIcon";
                    ZDBExpViewHandler.viewCreation(viewListOb, id,viewType , "childFold", toSelectBatchedView);//No i18N
                    var viewTypeEl = viewListOb.cloneNode(true);
                    if(key == "Dashboard"){
                        ZDBUtil.addClass(viewTypeEl, "dashBoardView");
                    }
                    holder.appendChild(viewTypeEl);
                     batchCount--;
                }
                typeViewInfo[key][isBatched] = true;
                i= typeViewInfo[key].length+i; 
            }
            //if(!ZDBClientUI.ISCARDLAYOUT)holder.appendChild(viewSepOb.cloneNode(true));
        }
        return holder;
   }
        
    this.relatedViewJSONFetch = function()
    {

        if(ZDBUtil.isEmptyObject(relViewInfo)){
            var isDashAvail = false;
            for(var key in viewListResp)
            {
                var parId = viewListResp[key][ZDBExpViewHandler.PARENT_ID];
                var isDashBoard = viewListResp[key][ZDBExpViewHandler.VIEW_TYPE] == "Dashboard";
                if(!isDashAvail) {isDashAvail = isDashBoard};
                if(!isDashBoard && (parId == null || !viewListResp[parId]))
                {
                    relViewInfo[key] =[];
                }
                else
                {
                    childArr.push(key);
                }    
            }
            if(isDashAvail) {relViewInfo["Dashboard"] = [];}
            if(ZDBUtil.isEmptyObject(relViewInfo))
            {
                return;
            }
            for(var i=0; i<childArr.length; i++)
            {
                var parId = viewListResp[childArr[i]][ZDBExpViewHandler.PARENT_ID];
                parId = (parId) ? parId : "Dashboard"; //No i18N
                relViewInfo[parId].push(childArr[i]);
            }
        }
    }
    this.folderViewJSONFetch = function()
    {
        if(ZDBUtil.isEmptyObject(foldInfo)){
            for(var key in foldListResp)
            {
                foldInfo[key]=[];
            }
            for(var key in viewListResp)
            {
            	var foldId = viewListResp[key][ZDBExpViewHandler.FOLD_ID];
            	// #reference temporary fix for shared user and dbowners, if dbOwner My reports folder will not be created
            	if(!foldInfo[foldId] && (foldId == "-2")){ // #reference - for shared case My Reports Folder 
            		if(ZDBClientUI.isDBOwner){
            			foldId = ZDBExpViewHandler.defaultFolderId;
            			viewListResp[key][ZDBExpViewHandler.FOLD_ID] = ZDBExpViewHandler.defaultFolderId;
            		}
            		else{
            			foldId = "-2";
                		foldInfo[foldId] = [];
            		}
            	}
                foldInfo[foldId].push(key);
            }
        }        
    }
    this.typeViewJSONFetch = function()
    {
        if(ZDBUtil.isEmptyObject(typeViewInfo)){
            for(var i=0;i<ZDBExpViewHandler.viewTypes.length; i++)
            {
                typeViewInfo[ZDBExpViewHandler.viewTypes[i]]=[];
            }
            for(var key in viewListResp)
            {
                typeViewInfo[viewListResp[key][ZDBExpViewHandler.VIEW_TYPE]].push(key);
            }
        }
    }
    this.viewCreation = function(updateEl,elObjId, iconClass, foldClass, toSelect) {
        var viewObj = viewListResp[elObjId];
        var isfav = viewObj[ZDBExpViewHandler.IS_FAVOURITE];
        if(isfav)
        {
            ZDBUtil.addClass(updateEl.favTag,"ZRSFav");
            ZDBUtil.animateFavIcon(updateEl.favTag,"FavFill",0);
        }
        else
        {
            ZDBUtil.removeClass(updateEl.favTag,"ZRSFav");
            ZDBUtil.animateFavIcon(updateEl.favTag,"",0);
        }
        if(ZDBClientUI.ISCARDLAYOUT) {
            ZDBExpViewHandler.thumbNailViewDataUpdate(updateEl,elObjId, iconClass, foldClass, toSelect);
        }
        else {
            ZDBExpViewHandler.FoldViewListCreation(updateEl,elObjId, iconClass, foldClass, toSelect);
        }
    }
    this.FoldViewListCreation = function(updateEl,elObjId, iconClass, foldClass, toSelect)
    {
        var viewObj = viewListResp[elObjId];
        updateEl.setAttribute("objId", elObjId);
        updateEl.setAttribute("viewType", viewObj[ZDBExpViewHandler.VIEW_TYPE]);
        var constClass = "ZDBViewListEl " + foldClass; //No I18N
        var className = (iconClass == "Dashboard") ? (constClass + " dashBoardView") : constClass; //No I18N
        updateEl.className = className;
        var isAllowed = viewObj[ZDBExpViewHandler.VIEWOWNER];
        var className = (!isAllowed) ? "ZRSCheckgrp ZRSCheckbox ZRSCheckboxDisabled" : "ZRSCheckgrp ZRSCheckbox" + ((toSelect) ? " ZRSChecked" : ""); //No i18N
        updateEl.checkbox.className = className;
        updateEl.viewFilterBy.innerText = viewObj[ZDBExpViewHandler.VIEW_LAST_MODIFIED];
        if(isAllowed && toSelect) {
            ZDBUtil.addClass(updateEl, "viewSelect");
        } else {
            ZDBUtil.removeClass(updateEl, "viewSelect");
        }
        updateEl.viewType.className = "viewTypeIcon " + iconClass; //No i18N
        var hrefLink = ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + ZDBClientUI.dbId + "&OBJID=" + elObjId; //No i18N
        updateEl.dataLink.setAttribute("href", hrefLink); //No i18N
        updateEl.dataLink.innerText = viewObj[ZDBExpViewHandler.VIEW_NAME];
        var desc = viewObj[ZDBExpViewHandler.VIEW_DESC];
        desc = (desc) ? desc : "-";
        updateEl.viewDesc.innerHTML = ZDBEscapeUtil.encodeForHtml(desc);
        ZDBUtil.show(updateEl.viewDesc);
    }
    
    this.thumbNailViewDataUpdate = function(cardViewEl, viewId, iconClass, foldClass, toSelect) {
        var viewObj = viewListResp[viewId];
        cardViewEl.setAttribute("objId", viewId);
        cardViewEl.setAttribute("viewType", viewObj[ZDBExpViewHandler.VIEW_TYPE]);
        var constClass = "viewCard " + foldClass; //No I18N
        var className = (iconClass == "Dashboard") ? (constClass + " dashBoardView") : constClass; //No I18N
        cardViewEl.className = className;
        var isAllowed = viewObj[ZDBExpViewHandler.VIEWOWNER];
        var className = (!isAllowed) ? "ZRSCheckgrp ZRSCheckbox ZRSCheckboxDisabled" : "ZRSCheckgrp ZRSCheckbox" + ((toSelect) ? " ZRSChecked" : ""); //No i18N
        var svgEl = ZDBUtil.createSVGTemplate("#ZR-" + iconClass); //No i18N
        cardViewEl.moreOpt.style.display= (isAllowed) ? "block" : "none";
        cardViewEl.viewSnap.innerHTML = "";
        cardViewEl.viewSnap.appendChild(svgEl);
        cardViewEl.checkbox.className = className;
        cardViewEl.cardTitle.innerText = viewObj[ZDBExpViewHandler.VIEW_NAME];
        cardViewEl.viewCreatedDet.innerText = ZDBI18NMap.g("zrpt.explorer.js.last_modified") + " " + viewObj[ZDBExpViewHandler.VIEW_LAST_MODIFIED];
    }
    
    this.folderListCreation = function(foldEl, foldId, foldIcon)
    {
        foldEl.setAttribute("foldId", foldId);
        var foldClass = "foldNavIcon " + ((foldIcon) ? "foldOpenIcon" : "foldCloseIcon"); //No i18N
        var attrVal = (foldIcon) ? "#ZR-folderClose" : "#ZR-folderOpen"; //No i18N
        foldEl.foldOpenClose.className = foldClass;
        var useEl = foldEl.foldOpenClose.getElementsByTagName("use")[0];
        useEl.setAttributeNS(ZDBConst.XLINKNAMESPACE, "xlink:href", attrVal);//No i18N
        if (foldId == "-2") {
            foldEl.folderData.innerText = ZDBI18NMap.g("zrpt.explorer.js.myRpt");
            foldEl.folderDesc.innerText = "";
        }
        else {
            foldEl.folderData.innerText = foldListResp[foldId][1];
            foldEl.folderDesc.innerHTML = ZDBEscapeUtil.encodeForHtml(foldListResp[foldId][2]);
        }

    }
    this.typeFoldCreation = function(foldTemp, viewType, foldIcon)
    {
        var viewTypeVals = {
            "Table": "zrpt.databasedata.connname.js.tablecols", //No i18N
            "AnalysisView": "zrpt.metadata.constant.js.chart", //No i18N
            "Pivot": "zrpt.metadata.constant.js.pivots", //No i18N
            "SummaryView": "zrpt.metadata.constant.js.summary_views", //No i18N
            "Dashboard": "zrpt.metadata.constant.js.dashboards", //No i18N
            "QueryTable": "zrpt.metadata.constant.js.qry_tbl", //No i18N
            "Report": "zrpt.metadata.constant.js.tabular_reports" //No i18N
        }
        foldTemp.setAttribute("type", viewType);
        var foldClass = "foldNavIcon " + ((foldIcon) ? "foldOpenIcon" : "foldCloseIcon"); //No i18N
        var attrVal = (foldIcon) ? "#ZR-folderClose" : "#ZR-folderOpen"; // open close icon reversed as the icon represents the next action  //No i18N
        foldTemp.foldOpenClose.className = foldClass;
        var useEl = foldTemp.foldOpenClose.getElementsByTagName("use")[0];
        useEl.setAttributeNS(ZDBConst.XLINKNAMESPACE, "xlink:href", attrVal);//No i18N
        foldTemp.folderType.setAttribute("class", "viewTypeIcon " + viewType); //No i18N
        foldTemp.folderData.innerText = ZDBI18NMap.g(viewTypeVals[viewType]);
    } 

    this.getDependentChild = function(objId)
    {
        ZDBExpViewHandler.relatedViewJSONFetch();
        return relViewInfo[objId];
    }
    this.getfolderChild = function(foldKey)
    {
        return foldInfo[foldKey];
    }
    this.getTypeViewList = function(type)
    {
        return typeViewInfo[type];
    }
    this.getViewListForGivenTypes = function(types)
    {
        var viewsList = new Array();
        for(var i = 0; i < types.length; i++)
        {
           viewsList=viewsList.concat(typeViewInfo[types[i]]);
        }
        return viewsList;
    }
    this.fetchViewListInfo = function(objId)
    {
        return viewListResp[objId];
    }
    this.getviewListData =  function(objId, index)
    {
        return viewListResp[objId][index];
    }
    this.getViewListDataMap = function(objArray, index) {
        var dataMap = {};
        for(var key in viewListResp) {
            if(objArray.indexOf(key) != -1) {
                dataMap[key] = viewListResp[key][index];
            }
        }
        return dataMap;
    }
    this.getFoldListData = function(foldId, index)
    {
        return foldListResp[foldId][index];
    }
    this.updateviewListData = function(viewId, loc, updateVal)
    {
        viewListResp[viewId][loc] = updateVal;
    }
    this.updateFoldListData = function(foldId, loc, updateVal)
    {
        foldListResp[foldId][loc] = updateVal;
    }
    this.getFoldIds = function(){
    	var folderCount = Object.keys(foldListResp);
    	return folderCount;
    }

    this.makeFolderDefaultUpdate = function(foldId)
    {
        var defFold = new Array();
        var initDefFolder = ZDBExpViewHandler.defaultFolderId;
        ZDBExpViewHandler.defaultFolderId = foldId;
        foldListResp[initDefFolder][ZDBExpViewHandler.ISDEFAULT] = false;
        foldListResp[ZDBExpViewHandler.defaultFolderId][ZDBExpViewHandler.ISDEFAULT] = true;
        ZDBNavigation.openFolderWithFolderId(foldId);
        var tBody = ZDBNavigation.tBody;
        var foldIds = [initDefFolder, ZDBExpViewHandler.defaultFolderId];
        for (var key in tBody)
        {
            var els = ZDBUtil.getElsWithTagNAttrWithVals(tBody[key], "foldId", foldIds, "li");  //No i18N
            defFold = defFold.concat(els);
        }
        for (var i = 0; i < defFold.length; i++) {
            var defEl = defFold[i];
            var defFoldId =  defEl.getAttribute("foldId");
            var defIconHolder = defEl.getElementsByClassName("defaultFolder")[0];
            if (defFoldId == initDefFolder) {
                ZDBUtil.removeClass(defEl, "isDefault");
                while(defIconHolder.firstChild) {
                    defIconHolder.removeChild(defIconHolder.firstChild); 
                }
            }
            else {
                ZDBUtil.addClass(defFold[i], "isDefault");
                var defIcon = ZDBUtil.createSVGTemplate("#ZR-defaultFolder");  //No i18N
                defIconHolder.appendChild(defIcon);
            }
        }
    }
    this.moveViewListToFolder = function(foldId, objId)
    {
        var curFoldId = viewListResp[objId][ZDBExpViewHandler.FOLD_ID];
        viewListResp[objId][ZDBExpViewHandler.FOLD_ID] = foldId;
        var indexOfObj = foldInfo[curFoldId].indexOf(objId);
        if(indexOfObj>=0)
        {
            foldInfo[curFoldId].splice(indexOfObj, 1);
        }
        foldInfo[foldId].push(objId);
    }
    
    this.isBatched = function(id, isType ) {
        if(!isType) {
            return foldInfo[id][isBatched];
        }
        else {
            return typeViewInfo[id][isBatched];
        }
    }
    
    this.appendChildEls = function (id, type, viewTempId) {
        var parent = (type) ? typeViewInfo[id] : foldInfo[id];
        var viewEls = [];
        var viewListOb = ZDBUtil.templateCreator(viewTempId);
        for(var j=0; j < parent.length; j++)
        {
            var viewType = (!ZDBClientUI.ISCARDLAYOUT && type) ? "navigIcon" : viewListResp[parent[j]][ZDBExpViewHandler.VIEW_TYPE];
            ZDBExpViewHandler.viewCreation(viewListOb, parent[j], viewType, "childFold");
            viewEls.push(viewListOb.cloneNode(true));
        }
        parent[isBatched] = true;
        return viewEls;
    }
    this.isViewListEmpty = function()
    {
        return ZDBUtil.isEmptyObject(viewListResp);
    }
    this.getAllFoldIdsRViewTypes = function(attrValue)
    {
    	var ids = [];
    	if(attrValue == "foldId"){
        	for(var key in foldListResp){
        		ids.push(key);
        	}
    	}
    	else{
            ZDBExpViewHandler.typeViewJSONFetch();
            for(var key in typeViewInfo) {
                if(typeViewInfo[key].length) {
                    ids.push(key);
                }
            }
    	}
        return ids;
    }
    this.clrExpViewHandlerVar = function()
   {
       relViewInfo ={};
       foldInfo = {};
       childArr = [];
       typeViewInfo ={};
    }
    this.clearExpView = function ()
    {
        var txtFld = $("ZDBObjSearchTxtFld");
        if (txtFld.value) {
            txtFld.value = "";
            txtFld.setAttribute("tipShown", false);
            ZDBSearchUtil.showTipString(txtFld);
            var searchFld = $("ZDBObjSearchClearFld");
            var searchResults = $("ZDBSearchResults");
            ZDBUtil.hide(searchFld);
            ZDBUtil.hide(searchResults);
            ZDBUtil.removeClass(ZDBClientUI.Objects_TBODY, "inSearchMode");
            ZDBNavigation.viewListBody.removeAttribute("class");
        }
        ZDBUtil.removeAllChildren(ZDBClientUI.Objects_TBODY);
        ZDBUtil.removeAllChildren(ZDBNavigation.viewListBody);
    }
this.animateDeletingViews = function (parentEl, attrName, attrVals, tagName, foldElToDel)    // for Multiple attrVals ex: attrVal = [foldId1, foldId2, foldId3]
{
    if (parentEl == null) 
    {
        return
    }
    var nodes = parentEl.getElementsByTagName(tagName);
    var els = new Array();
    for (var i = 0; i < nodes.length; i++)
    {
        var curEl = nodes[i];
        var name = curEl.getAttribute(attrName);
        if (name != null )
        {
            var elAttrVal = ("" + name).toUpperCase();
            for(var j = 0; j < attrVals.length; j++)
            {
                var val = (attrVals[j] + "").toUpperCase();
                if(elAttrVal == val)
                {
                    ZDBUtil.fadeOutAnimation(curEl,false);
                    els.push(curEl);
                }
            }
        }
    }
    if(foldElToDel != null)
    {
        for (var i = 0; i < foldElToDel.length; i++) {
        var delEl = foldElToDel[i];
        var viewSep = delEl.nextSibling;
        if(ZDBUtil.hasClass(viewSep, "viewSeparator"))
        {
        ZDBUtil.fadeOutAnimation(viewSep,false);
        }
            ZDBUtil.fadeOutAnimation(delEl,true);
        }
    }
    return els;
}


    this.removeElFromExpView = function (elIds)
    {
        var elsToDel = ZDBExpViewHandler.animateDeletingViews(ZDBNavigation.viewListBody, "objId", elIds, "li"); //No i18N
        setTimeout(function(){
            for (var i = 0, j = elsToDel.length; i < j; i++) {
                if (ZDBNavigation.navSelect.value == "Related" && ZDBUtil.hasClass(elsToDel[i], "parentFold"))
                {
                    var el = ZDBUtil.nextMatchedSibling(elsToDel[i], "viewSeparator"); //No i18N
                    elsToDel[i].parentElement.removeChild(el);
                }
                elsToDel[i].parentElement.removeChild(elsToDel[i]);
            }
            for (var i = 0, j = elIds.length; i < j; i++) {
                ZDBExpViewHandler.clientDataRemovalUpdation(elIds[i], true);
            }
            ZDBNavigation.isRefreshReq[".ZDBNavData"] = true;
            ZDBNavigation.isRefreshReq[".ZDBNavReports"] = true;
            ZDBNavigation.isRefreshReq[".ZDBNavDashboards"] = true;
            ZDBExpViewHandler.removeTypeFoldIfNoViews();
            var diffArray = [];
            ZDBExpViewHandler.selectedViewIds.filter(function(id) {
                if(elIds.indexOf(id) == -1) {
                    diffArray.push(id); 
                }
            } ) ;
            ZDBExpViewHandler.selectedViewIds = diffArray;
            ZDBNavigation.enableDisableTbOnSelSwitch();
            var isViewListEmpty = ZDBExpViewHandler.isViewListEmpty();
            if (isViewListEmpty && ZDBClientUI.isDBOwner)
            {
                var expHeader = document.getElementsByClassName("newExpHeader")[0]; //No i18N
                ZDBUtil.hide(expHeader);
                ZDBNavigation.showCreateOpts();
            }
        },750);
    }
    
    this.removeTypeFoldIfNoViews = function()
    {
        if(ZDBNavigation.navSelect.value != "All")
        {
            return;
        }
        for(var i = 0; i < ZDBExpViewHandler.viewTypes.length; i++)
        {
            if (typeViewInfo[ZDBExpViewHandler.viewTypes[i]].length == 0)
            {
                var viewTypeEl = ZDBNavigation.getElsFromtBody("attrAndVal", "type", ZDBExpViewHandler.viewTypes[i], "li"); //No i18N
                for (var j = 0; j < viewTypeEl.length; j++) {
                    var typeEl = viewTypeEl[j];
                    var viewSep = ZDBUtil.nextMatchedSibling(typeEl, "viewSeparator"); //No i18N
                    viewSep.parentElement.removeChild(viewSep);
                    typeEl.parentElement.removeChild(typeEl);
                }
            }
        }
    }
    this.removeFoldRelViews = function(foldId, ObjsToDel)
    {
        var foldToDel = ZDBNavigation.getElsFromtBody("attrAndVal", "foldId", foldId, "li"); //No i18N
        var elsToDel = ZDBExpViewHandler.animateDeletingViews(ZDBNavigation.viewListBody, "objId", ObjsToDel, "li",foldToDel); //No i18N
        var par = foldToDel[0].parentElement;
        setTimeout(function(){
            ZDBUtil.removeAllElsAttrWithVal(ZDBNavigation.viewListBody, "objId", ObjsToDel, "li");//No i18N
            for (var i = 0; i < foldToDel.length; i++) {
                var delEl = foldToDel[i];
                var viewSep = delEl.nextSibling;
                if(ZDBUtil.hasClass(viewSep, "viewSeparator"))
                {
                     viewSep.parentElement.removeChild(viewSep);
                }
             delEl.parentElement.removeChild(delEl);
            }
            for(var i = 0, j = ObjsToDel.length; i < j; i++)
            {
                ZDBExpViewHandler.clientDataRemovalUpdation(ObjsToDel[i], true, true);
            }
            ZDBExpViewHandler.clientDataRemovalUpdation(foldId, false, false);
            for(var key in ZDBNavigation.isRefreshReq) {
                ZDBNavigation.isRefreshReq[key] = true;
            }
            if(par.scrollHeight == par.offsetHeight) {
                ZDBExpViewHandler.batchViewsOnScroll(null, par);
            }
        },750);
    }

    this.createElInExpView = function (foldDetails)
    {
        var holder = ZDBNavigation.viewListBody.getElementsByClassName(ZDBExpViewHandler.viewHolderClass)[0];
        if (ZDBNavigation.navSelect.value === "Folder" && !unbatched.length)
        {
            var foldTempOb = ZDBUtil.templateCreator("_folderListTemp"); //No i18N
            var viewSepOb = document.createElement("li");
            viewSepOb.className = "viewSeparator";
            var foldTemp = foldTempOb.cloneNode(true);
            ZDBExpViewHandler.folderListCreation(foldTemp, foldDetails["FOLDERID"]);//No i18N
            holder.appendChild(foldTemp);
            if(!ZDBClientUI.ISCARDLAYOUT) {
                 holder.appendChild(viewSepOb);
            }
            var viewDesc = ZDBUtil.find(foldTemp, "class", null, "ViewDesc", null)[0];
            ZDBUtil.show(viewDesc);
        }
        else {
            ZDBNavigation.setNavigationType('Folder');//No i18N
        }
        if (foldDetails["ISDEFAULT"])
        {
            ZDBExpViewHandler.makeFolderDefaultUpdate(foldDetails["FOLDERID"]);
        }
        if(holder) {
            holder.scrollTop = holder.scrollHeight - holder.offsetHeight;
        }
    }
    this.clientDataCreateUpdation = function(foldDetails)
    {
        var foldId = foldDetails["FOLDERID"];
        foldListResp[foldId]=[foldId,foldDetails["FOLDERNAME"],foldDetails["FOLDERDESC"], foldDetails["FOLDERINDEX"],foldDetails["ISDEFAULT"]];
        if(!ZDBUtil.isEmptyObject(foldInfo)){
            foldInfo[foldId]=[];
            unbatched.push(foldId);
        }
    }
    this.clientDataRemovalUpdation = function(liElId, isList)
    {
        if(isList)
        {
            ZDBExpViewHandler.removeDataFromNavigMap(liElId);
            delete viewListResp[liElId];      
        }
        else
        {
            delete foldListResp[liElId];
            delete foldInfo[liElId];
        }
    }
    
    this.removeDataFromNavigMap = function(objId) {
        var index;
        if(!viewListResp[objId]) {
            return;
        }
        var foldId = viewListResp[objId][ZDBExpViewHandler.FOLD_ID];
        var parId = viewListResp[objId][ZDBExpViewHandler.PARENT_ID];
        var type = viewListResp[objId][ZDBExpViewHandler.VIEW_TYPE];
        index = (foldInfo[foldId]) ? foldInfo[foldId].indexOf(objId) : -1;
        if(index >= 0 ) foldInfo[foldId].splice(index, 1);
        index = (relViewInfo[parId]) ? relViewInfo[parId].indexOf(objId) : -1;
        if(index >= 0 ) relViewInfo[parId].splice(index, 1);
        index = (typeViewInfo[type] ) ? typeViewInfo[type].indexOf(objId) : -1;
        if(index >= 0 ) typeViewInfo[type].splice(index, 1);
    }
    this.maintainViewCountByType = function()
    {
        ZDBExpViewHandler.typeViewJSONFetch();
        for(var i=0; i<ZDBExpViewHandler.viewTypes.length; i++){
            ZDBNavigation.viewsCountByType[i] = typeViewInfo[ZDBExpViewHandler.viewTypes[i]].length; 
        }
    }
    
    this.showOrHideEmptyFold = function () {
        var idsToShowOrHide = [];
        var foldContainDash = {};
        for (var key in viewListResp) {
            if (viewListResp[key][this.VIEW_TYPE] == "Dashboard") {
                var foldId = viewListResp[key][this.FOLD_ID];
                foldContainDash[foldId] = (!foldContainDash.hasOwnProperty(foldId)) ? 1 : foldContainDash[foldId] + 1;
            }
        }
        for (var key in foldInfo) {
            var foldChildCount = foldInfo[key].length;
            if (foldContainDash.hasOwnProperty(key) && foldContainDash[key] == foldChildCount || !foldInfo[key].length) {
                idsToShowOrHide.push(key);
            }
        }
        var leftPanel = ZDBNavigation.tBody["leftPanel"];
        if (leftPanel) {
            var foldEls = leftPanel.getElementsByClassName("ZDBfolderEl"); //No i18N
            for (var i = 0; i < foldEls.length; i++)
            {
                var foldId = foldEls[i].getAttribute("foldId");
                if (idsToShowOrHide.indexOf(foldId) > -1) {
                    ZDBUtil.addClass(foldEls[i], "dashBoardView");
                }
                else {
                    ZDBUtil.removeClass(foldEls[i], "dashBoardView");
                }
            }
        }
        if(ZDBExpViewHandler.isDashEditMode) {    
            var viewHolder = ZDBUtil.getElWithTagNAttrWithVal(ZDBNavigation.viewListBody, "elname", "viewHolder", "ul"); //No i18N
            ZDBExpViewHandler.batchViewsOnScroll(null, viewHolder);
        }
    }

  this.favouriteFilter = function(el,event)
  {
    var favouriteFilterEnable = (ZDBUtil.hasClass(el,"ZRSFav")) ? false : true; //No I18N
    var filterSpace = document.getElementById("explorerFilterSpace");
    var favViewCount = 0;
    if(favouriteFilterEnable)
    {
        ZDBUtil.addClass(filterSpace,"inFavouriteMode");
        ZDBUtil.addClass(el,"ZRSFav");
        ZDBUtil.animateFavIcon(el,"FavFill",0);
    }
    else
    {
        ZDBUtil.removeClass(filterSpace,"inFavouriteMode");
        ZDBUtil.animateFavIcon(el,"FavEmpt",0);
        setTimeout(function(){ZDBUtil.removeClass(el,"ZRSFav");},500);
        filterSpace.innerHTML = "";
        filterSpace.style.display = "none";
        ZDBNavigation.viewListBody.style.display = "block";
        ZDBNavigation.updateSelectStatusOnSrch();
        return;
    }
    var layout = (ZDBClientUI.ISCARDLAYOUT) ? "_cardViewTemp" : "_ListViewTemp"; //No I18N
    var viewTemplate = ZDBUtil.templateCreator(layout);
    var ul = document.createElement("ul");
    var viewHolder = ZDBNavigation.viewListBody.querySelector("[elname=viewHolder]"); //No I18N
    ul.className =  (ZDBClientUI.ISCARDLAYOUT) ? "cardLayoutHolder" : "expNewLayout"; //No I18N
    ul.style.height = viewHolder.style.height;
    for(var key in viewListResp)
    {
        var viewData = viewListResp[key];
        var viewType = viewData[ZDBExpViewHandler.VIEW_TYPE];
        if(viewData[ZDBExpViewHandler.IS_FAVOURITE])
        {
            favViewCount++;
            var selectView = (ZDBExpViewHandler.selectedViewIds.indexOf(key) != -1);
            ZDBExpViewHandler.viewCreation(viewTemplate, key, viewType, "childFold",selectView);
            ul.appendChild(viewTemplate.cloneNode(true));
        }
    }
    if(favViewCount == 0)
    {
        var noFavDiv = ZDBExpViewHandler.noFavDiv();
        ul.appendChild(noFavDiv); 
    }
    ZDBNavigation.viewListBody.style.display = "none";
    filterSpace.innerHTML = "";
    filterSpace.style.display = "block";
    ZDBUtil.removeClass(filterSpace, "inSelectMode");
    filterSpace.appendChild(ul);
  }  
  this.noFavDiv = function()
  {
    var div = document.createElement("div");
    div.setAttribute("ID","noFavDiv");
    var text = document.createTextNode(ZDBI18NMap.g("zrpt.explorer.js.no_favourite_views"));
    div.appendChild(text);
    return div;
  }
    
  this.expGblSrch = function(value)
  {
      var temp = (ZDBClientUI.ISCARDLAYOUT) ? "_cardViewTemp" : "_ListViewTemp"; //No i18N
      var ul = document.createElement("ul");
      ul.className =  (ZDBClientUI.ISCARDLAYOUT) ? "cardLayoutHolder" : "expNewLayout"; //No i18N
      ul.style.height = ZDBNavigation.viewListBody.children[0].style.height;
      value = value.toLowerCase();
      var searchListItem = ZDBUtil.templateCreator(temp);
      for(var key in viewListResp) {
        var viewData = viewListResp[key];
        var viewName = viewData[ZDBExpViewHandler.VIEW_NAME].toLowerCase();
        var viewType = viewData[ZDBExpViewHandler.VIEW_TYPE];
        if(viewName.indexOf(value) > -1 && (ZDBNavigation.searchType == "All" || ZDBNavigation.searchType == viewType)) {
            var selectView = (ZDBExpViewHandler.selectedViewIds.indexOf(key) != -1);
            ZDBExpViewHandler.viewCreation(searchListItem, key, viewType, "childFold", selectView);
            ul.appendChild(searchListItem.cloneNode(true));
        }
      }
      var expSpace = $("explorerFilterSpace");
      expSpace.innerHTML = "";
      ZDBUtil.removeClass(expSpace, "inSelectMode");
      if(ul.childElementCount) {
        expSpace.appendChild(ul);
      }
      else {
          var div = document.createElement("div");
          div.className = "emptySearchSpace";
          var innerTxt = document.createTextNode(ZDBI18NMap.g("zrpt.common.toolbar.table.findnreplace.zdbalertmsg.js.findNReplaceFailedErr"));
          div.appendChild(innerTxt);
          expSpace.appendChild(div);
      }
  }
  
    this.dashEditModeSrch = function(value)
  {
      var viewList = ZDBClientUI.Objects_TBODY;
      var temp = (ZDBClientUI.ISCARDLAYOUT) ? "_cardViewTemp" : "_ListViewTemp"; //No i18N
      var ul = document.createElement("ul");
      ul.style.height = viewList.children[0].style.height;
      value = value.toLowerCase();
      var searchListItem = ZDBUtil.templateCreator(temp);
      for(var key in viewListResp) {
        var viewData = viewListResp[key];
        var viewName = viewData[ZDBExpViewHandler.VIEW_NAME].toLowerCase();
        var viewType = viewData[ZDBExpViewHandler.VIEW_TYPE];
        if(viewType != "Dashboard" && viewName.indexOf(value) > -1 && (ZDBNavigation.searchType == "All" || ZDBNavigation.searchType == viewType)) {
            ZDBExpViewHandler.viewCreation(searchListItem, key, viewType, "childFold");
            ul.appendChild(searchListItem.cloneNode(true));
        }
      }
      var expSpace = $("dashEditDesignSrchSpace");
      expSpace.innerHTML = "";
      ZDBUtil.removeClass(expSpace, "inSelectMode");
      if(ul.childElementCount) {
          expSpace.appendChild(ul);
      } else {
          var div = document.createElement("div");
          div.className = "emptySearchSpace";
          var innerTxt = document.createTextNode(ZDBI18NMap.g("zrpt.common.toolbar.table.findnreplace.zdbalertmsg.js.findNReplaceFailedErr"));
          div.appendChild(innerTxt);
          expSpace.appendChild(div);
      }
      
      expSpace.style.display = "block";
      viewList.style.display = "none";
      ZDBUtil.addClass(viewList, "inSearchMode");
  }
  
  this.filterSelectedViews = function(el) {
      
      var viewListBody = ZDBNavigation.viewListBody;
      var expSpace = $("explorerFilterSpace");
      
      if(selViewsAlone) {
          expSpace.style.display = "none";
          viewListBody.style.display = "block";
          selViewsAlone = false;
          el.previousElementSibling.style.display = "";
          el.innerText = ZDBI18NMap.g("zrpt.common.js.viewsSelected");
          return;
      }
      
      var temp = (ZDBClientUI.ISCARDLAYOUT) ? "_cardViewTemp" : "_ListViewTemp"; //No i18N
      var ul = document.createElement("ul");
      ul.className =  (ZDBClientUI.ISCARDLAYOUT) ? "cardLayoutHolder" : "expNewLayout"; //No i18N
      ul.style.height = viewListBody.children[0].style.height;
      ZDBUtil.addClass(viewListBody, "inSearchMode");
      ZDBUtil.removeClass(ZDBNavigation.favFilterIcon,"ZRSFav");
      var selIds = ZDBExpViewHandler.selectedViewIds;
      var viewTemp = ZDBUtil.templateCreator(temp);
      for(var i = 0, j = selIds.length; i < j; i++) {
          var key = selIds[i];
          var viewType = viewListResp[key][ZDBExpViewHandler.VIEW_TYPE]
          ZDBExpViewHandler.viewCreation(viewTemp, key, viewType, "childFold", true);
          var clonedEl = viewTemp.cloneNode(true);
          ZDBUtil.addClass(clonedEl, "viewSelect");
          ul.appendChild(clonedEl);
      }
      var selectAll = ZDBUtil.getElWithTagNAttrWithVal(ZDBClientUI.viewList, "id", "ZRSelectAllNew", "div"); //No i18N
      selectAll.className = "all ZRSCheckbox ZRSChecked";
      expSpace.innerHTML = "";
      expSpace.appendChild(ul);
      expSpace.style.display = "block";
      ZDBUtil.addClass(expSpace, "inSelectMode");
      ZDBUtil.removeClass(expSpace,"inFavouriteMode");
      viewListBody.style.display = "none";
      selViewsAlone = true;
      el.previousElementSibling.style.display = "none";
      el.innerText = ZDBI18NMap.g("zrpt.common.js.showAll");
  }
  this.clearFilteredSelViews = function() {
      var selectAll = ZDBUtil.getElWithTagNAttrWithVal(ZDBClientUI.viewList, "id", "ZRSelectAllNew", "div"); //No i18N
      selectAll.className = "all ZRSCheckbox";
      ZDBNavigation.isSelectAllChecked = false;
      ZDBExpViewHandler.updateSelectedViewIds(selectAll, true);
      ZDBNavigation.enableDisableTbOnSelSwitch();
      ZDBUtil.removeClass(ZDBNavigation.favFilterIcon,"ZRSFav");
      ZDBNavigation.clearSearchState($("explorerFilterSpace"));
  }
    
    /* auto generated reports - To open the first dashboard from generated Reports */
    
    this.opnFrstGenView = function(firstFoldId) {
        ZDBNavigation.openFolderWithFolderId(firstFoldId);
        ZDBExpViewHandler.folderViewJSONFetch();
        var frstDashId = foldInfo[firstFoldId][0];
        var dbId = ZDBClientUI.dbId;
        var viewInfo = ZDBExpViewHandler.fetchViewListInfo(frstDashId);
        if(ZDBClientUI.selectedTab.view.objId > 0)  //To check whether the auto analysis is done from table tab or create new tab
            ZDBClientUI.fetchView(frstDashId,dbId,viewInfo[ZDBExpViewHandler.VIEW_NAME],viewInfo[ZDBExpViewHandler.VIEW_TYPE],null);    //For Tabel Tab
        else
            ZDBClientUI.fetchView(frstDashId,dbId,viewInfo[ZDBExpViewHandler.VIEW_NAME],viewInfo[ZDBExpViewHandler.VIEW_TYPE],ZDBClientUI.selectedTab);     //For Create New Tab
    }
   
    this.handleOnHover = function()
    {
        ZDBNavigation.viewListBody.addEventListener("mouseover",ZDBExpViewHandler.trigerHighLightFn, false);
        ZDBNavigation.viewListBody.addEventListener("click",ZDBExpViewHandler.trigerFoldOpenCloseFn, false);
        ZDBNavigation.viewListBody.addEventListener("mouseout",ZDBExpViewHandler.trigerDeHighLightFn, false);
        ZDBClientUI.Objects_TBODY.addEventListener("mouseover",ZDBExpViewHandler.dashEditEvntHandler, false);
        ZDBClientUI.Objects_TBODY.addEventListener("mouseout",ZDBExpViewHandler.dashEditEvntHandler, false);
        ZDBClientUI.Objects_TBODY.addEventListener("mousedown",ZDBExpViewHandler.dashbrdDragEventHanlder, false);
        ZDBClientUI.swipeArea.addEventListener("scroll",ZDBExpViewHandler.batchViewsOnScroll, false);
        
    }
    
    this.trigerHighLightFn = function(e)
    {
        var el= e.target;
    	var targetLi;
        if(!el || el.tagName.toLowerCase() == "ul"){
            return;
        }
        var elname = el.getAttribute("elname");
        if(elname && (elname.indexOf("fullName") > -1 || elname.indexOf("folderNameEl") > -1)) {
            if(el.tagName == "a") { el = el.parentElement; }
            ZDBToolTip.checkLengthAndShow(el, event, "BOTTOM");  //No I18N
        }
        if(el.className == "tIconbg defaultFolder" || el.className == "expOptionMenu") {
        	ZDBToolTip.show(e.target,e);
        }
        targetLi = DOMUtils.getSelfOrParentWithTagName(el, "li"); //No i18N
        if(targetLi) {
            ZDBNavigation.highlightListItem(targetLi);
        } 
    }
    this.trigerDeHighLightFn = function (e)
    {
        var targetLi;
        var tarEl = e.target;
        if (!tarEl || tarEl.tagName.toLowerCase() == "ul") {
            return;
        }
        targetLi = DOMUtils.getSelfOrParentWithTagName(tarEl, "li"); //No i18N
        var elname = tarEl.getAttribute("elname");
        if(elname && (elname.indexOf("fullName") > -1 || elname.indexOf("folderNameEl") > -1)) {
            ZDBToolTip.hide();
        }
        else if (ZDBUtil.hasClass(tarEl, "defaultFolder") || ZDBUtil.hasClass(tarEl, "expOptionMenu"))
        {
            ZDBToolTip.hide(tarEl, e);
        } else if (ZDBUtil.hasClass(tarEl, "helpDet")) //No i18N
        {
            ZDBToolTip.hideTooltip('ZDBViewDet'); //No i18N
        }
        if (targetLi) {
            ZDBNavigation.deHighlightListItem(targetLi);
        }
    }
    this.trigerFoldOpenCloseFn = function(e)
    {
        var folderEl, viewEl;
        folderEl = (ZDBNavigation.navSelect.value == "Folder") ? DOMUtils.getSelfOrParentWithAttr(e.target, "foldId") : DOMUtils.getSelfOrParentWithAttr(e.target, "type"); //No i18N
        viewEl = DOMUtils.getSelfOrParentWithAttr(e.target, "objId"); //No i18N
        var elClassName = e.target.className;
        if(viewEl && (elClassName == "ZDBExpData" || e.target.tagName == "A" || elClassName == "viewSnap" || elClassName == "cardTitle" || elClassName === 'cardImage')) {
        	ZDBNavigation.openView(e.target,e, viewEl);
        	return false;
        }
       	if(elClassName == "tIconbg defaultFolder" || e.target.tagName == "INPUT") {
        	e.stopPropagation();
        }
        if(elClassName.indexOf("favTag") >=0)
        {
            ZDBNavigation.setFavourite(e,viewEl);
            return false;
        }
        if(ZDBUtil.hasClass(e.target,"ZRSCheckgrp")){
            ZDBNavigation.toggleSelection_new(e, ZDBClientUI.viewList);
            e.stopPropagation();
        }
       	else if(folderEl){
       		ZDBNavigation.folderOpenClose(folderEl, true);
       	}
        ZRSCardPreviewHandler.addCardPreviewEvntsNInitialize();
    }
    this.batchViewsOnScroll = function (e, targetEl) {
        ZRSMenu.closeAllMenu();
        targetEl = (targetEl) ? targetEl : e.target;
        if((targetEl.scrollHeight == targetEl.scrollTop + targetEl.offsetHeight) && unbatched.length) {
            var viewTempId = (ZDBClientUI.ISCARDLAYOUT) ? "_cardViewTemp" : "_ListViewTemp"; //No i18N
            var navigType = ZDBNavigation.navSelect.value;
            var foldTempOb = ZDBUtil.templateCreator("_folderListTemp"); //No i18N
            var viewListOb = ZDBUtil.templateCreator(viewTempId);
            var viewSepOb = document.createElement("li");
            viewSepOb.className = "viewSeparator";
            switch(navigType) {
                case "Folder": //No i18N
                {
                    holder = ZDBExpViewHandler.folderView(foldTempOb, viewListOb, viewSepOb);
                    break;
                }
                case "Related": //No i18N
                {
                    holder = ZDBExpViewHandler.relatedView(viewListOb, viewSepOb);
                    break;
                }
                case "All": //No i18N
                {
                    holder = ZDBExpViewHandler.typeView(foldTempOb, viewListOb, viewSepOb);
                }
            }
            var viewHolders = ZDBNavigation.getElsFromtBody("attrAndVal", "elname", "viewHolder", "ul"); //No i18N
            for(var i = 0,viewLen = viewHolders.length; i < viewLen; i++) {
                var appender = (viewHolders.length > 1) ? holder.cloneNode(true) : holder;
                while(appender.firstChild) {
                    viewHolders[i].appendChild(appender.firstChild);
                }
            }
        }
    }
    this.dashEditEvntHandler = function(e) {
        var el = event.target;
        var elname = el.getAttribute("elname");
        if(event.type == "mouseover") {
            if(elname && (elname.indexOf("fullName") > -1 || elname.indexOf("folderNameEl") > -1)) {
                if(el.tagName == "a") { el = el.parentElement; }
                ZDBToolTip.checkLengthAndShow(el, event, "NAVIG");  //No I18N
            } 
        }
        else if (event.type == "mouseout" ) {
            ZDBToolTip.hide();
        }
    }
    this.dashbrdDragEventHanlder = function(e)
    {
    	var dashboardState = ZDBGlobal.dashboardState || 0;
    	var targetLi = DOMUtils.getSelfOrParentWithAttr(e.target, "objId"); //No i18N
    	switch(dashboardState){
			case 0 : 
			case 1 : {
		    	if(targetLi) {
		    		ZDBDashboardAPI.startDrag(targetLi,e);
		    	}
		    	break;
			}
			case 2 : {
				var view = ZDBClientUI.selectedTab.view;
				if(view.dashLayout && view.editMode){
	    			var objectId = targetLi.getAttribute("objid");
	    			viewInfo = ZDBExpViewHandler.fetchViewListInfo(objectId);
	    			var object = {
	    				type : "VIEW", //No i18N
	    				viewId : objectId,
	    				viewType : viewInfo[ZDBExpViewHandler.VIEW_TYPE]
	    			};
	    			if(object.viewType === "Dashboard"){
	    				return;
	    			}
	    			var proto = new ZRDashboardLayout.DropAdd(JSON.stringify(object),targetLi);
					proto.handleEvent(e);
				}
			}
		}
    }
    this.onViewSelect = function(e, parGrp)
    {
    	var parentEl, targetEl;
        targetEl = e.target;
        parentEl = DOMUtils.getSelfOrParentWithAttr(targetEl, "objId"); //No i18N
        var objId = parentEl.getAttribute("objId");
        if(ZDBUtil.hasClass(targetEl,"ZRSChecked")){
        	ZDBUtil.addClass(parentEl, "viewSelect");
        }
        else{
        	ZDBUtil.removeClass(parentEl, "viewSelect");
        }
        ZDBExpViewHandler.updateSelectedViewIds(targetEl, false, objId);	        
    }
    this.getObjIdFromViewName = function(viewName){
    	var viewData = viewListResp;
    	for(var key in viewData){
    		if(viewData[key][ZDBExpViewHandler.VIEW_NAME] == viewName){
    			return key;
    		}
    	}
    }
    this.getFoldIdFromFoldName = function(foldName, timeOut){
        var FoldData = foldListResp;
        for(var key in FoldData){
    		if(FoldData[key][ZDBExpViewHandler.FOLD_NAME] == foldName){
    			return key;
    		}
    	}
    }
    this.getFoldAndViewListMap = function() {
        return foldInfo;
    }
    /* -------- Sort feature for new layout --------------- */
    
    this.sortNavigList = function(obj, sortBycolumn)
    {
    	var sortOrder = (ZDBExpViewHandler.sortedColumnName == sortBycolumn &&  ZDBExpViewHandler.sortedOrder == "ASC" ) ? 1 : 0; //No i18N
    	var params = "DBID=" + ZDBClientUI.dbId + "&SORTBYCOLUMN=" + sortBycolumn + "&SORTORDER=" + sortOrder; //No i18N
    	var url = "/ZDBDatabaseActionMI.ma?ZDBACTION=UPDATENAVSORTORDER";//No I18N 
    	var loadingDiv = ZDBNavigation.explorerTab.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.loadingdiv.js.loading")); //No i18N
    	   AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
                                 ONSUCCESSFUNC:ZDBExpViewHandler.navigSortOnRefresh,
                                 DBID:ZDBClientUI.dbId,
                                 OPSTATUSID:loadingDiv,
                                 SORTORDER: sortOrder,
                                 SORTBYCOLUMN: sortBycolumn,
                                 OBJ: obj});
    }
    this.navigSortOnRefresh = function(response,requestOptions)
    {
        var sortIcon = $("ZDBExplorerHeader").getElementsByClassName("sortIcon");
        for(var i = 0; i < sortIcon.length; i++) {
            sortIcon[i].className = "sortIcon";
        }
        ZDBNavigation.refreshExplorer();
    }
    this.updateSelectedViewIds = function(el, isSelectAllEl, objId) {
        var isSelected = ZDBUtil.hasClass(el,"ZRSChecked"); //No i18N
        if(isSelectAllEl && ZDBClientUI.isDBOwner) {
            ZDBExpViewHandler.selectedViewIds = (isSelected) ? Object.keys(viewListResp) : [] ;
        } else if (isSelectAllEl && !ZDBClientUI.isDBOwner) {
            if(isSelected ) {
                for(var key in viewListResp) {
                    if(viewListResp[key][ZDBExpViewHandler.VIEWOWNER]) {
                        ZDBExpViewHandler.selectedViewIds.push(key);
                    }
                }
            } else {
                ZDBExpViewHandler.selectedViewIds = [];
            }
            
        }
        else {
            var length = ZDBExpViewHandler.selectedViewIds.length;
            var index = ZDBExpViewHandler.selectedViewIds.indexOf(objId);
            if(!(isSelected ^ index == -1)) {  // XNOR operation
                (isSelected) ? ZDBExpViewHandler.selectedViewIds.splice(length, 0, objId) : ZDBExpViewHandler.selectedViewIds.splice(index, 1);
            }
        }
    }

}
