//$Id$

var ZRTour = new function()
{
    /*  
     *  t1 - allImport
     *  t2 - fileStep1
     *  t3 - fileStep2
     */
    
    this.tourCalled = 0;
    this.tourDetails = {};
    this.noActionPerformed = true;
    
    this.startTour = function() {
        ZRTour.noActionPerformed = false; 
        document.removeEventListener("click", ZRTour.startTour, false);
    }
    
    this.endTour = function()
    {
        ZRTour.tourCalled = 0;
        ZRTour.currenttour._endTour();
        jQuery(document).bind("click", function()
        {
            ZRSMenu.closeAllMenu();
        });
    }
    
    this.setFooterWithProgressAlone = function(el)
    {
        el.getElementsByClassName("zprogress")[0].style.width = "86%";
        var footer = el.getElementsByClassName("zpopover__footer")[0];
        footer.getElementsByClassName("zbutton")[0].style.display = "none";
        el.style.height = el.offsetHeight - 10 + "px";
    }
  
    this.setProgressBar = function(popover)
    {
        popover.style.height = popover.offsetHeight - 10 + "px"; //No I18N
    }
    
    this.autofill = function()
    {
    	$("autofill-holder").style.visibility = "visible";
        ZDBUtil.addClass($("autofill-holder").getElementsByClassName("autofill-loader")[0], "autofill-loader-active");
    }
    
    this.showHideTourSlideout = function()
    {
        var tourSlideout = document.querySelector(".tour-slideout");//No I18N 
        if(ZDBUtil.hasClass(tourSlideout, "tour-slideout-active")) {
            ZDBUtil.removeChildrenWithClass(document.body, "freezeLayer");//No I18N 
            ZDBUtil.removeClass(tourSlideout, "tour-slideout-active");
        }
        else {
            var div = document.createElement("div");
            div.className = "freezeLayer";
            div.style.zIndex = 1;
            document.body.appendChild(div);
            ZDBUtil.addClass(tourSlideout, "tour-slideout-active");
        }
    }
    
    this.allImportTour_old = function() //All import options
    {
        ZRTour.tourCalled = 1;
        
        var allImportSteps = [
        {
            title: "<html><body>Import your Data</body></html>", //NO I18N
            content: "<html><body>Import your data from a wide variety of data sources</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 180,
            width: 320,
            highlightStep: false,
            aftershow: function()
            {
                var popover = $("undefined_zpopover");
                var btn = popover.querySelectorAll(".zbutton"); //No I18N
                
                btn[0].className = "zbutton zclosebtn";
                btn[0].style.display = "inline-block";
                btn[0].children[0].innerText = "Got it!"; //No I18N
                btn[0].addEventListener("click", ZRTour.endTour);
                btn[1].children[0].innerText = "Show me how"; //No I18N
                
                popover.querySelector(".zpopover__action").addEventListener("click", ZRTour.endTour); //No I18N
            }
        },
        
        {
            target: "#FileImport", //NO I18N
            title: "<html><body>Import from Files and Feeds</body></html>", //NO I18N
            content: "<html><body>Let us show you how to import from Files and Feeds</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 140,
            width: 350,
            highlightStep: true,
            position: "right", //No I18N
            aftershow: function()
            {
                var popover = $("FileImport_zpopover");
                popover.removeChild(popover.getElementsByClassName("zpopover__footer")[0]);
            }
        }
        
        ];
        
        var allImportInit = {
            slides: allImportSteps,
            id: "allImport", //NO I18N
            firstSlideAsStart: true,
            multiPageTour: false,
            type: "navigation", //NO I18N
            navigation: { type: "text", required: "next"}, //NO I18N
            buttons: "close", //No I18N
            progressBar: false,
            skipIfNoElement: true
        };

        t1 = new ZTour(allImportInit);
        t1.init({"id": "allImport"}); //No I18N
        t1.start(); 
        this.currenttour = t1;
    }
    
    this.allImportTour = function() //All import options
    {
        ZRTour.tourCalled = 1;
        
        var allImportSteps = [
        {
            target: "#FileImport", //NO I18N
            title: "<html><body>Import from Files and Feeds</body></html>", //NO I18N
            content: "<html><body>Let us show you how to import from Files and Feeds</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 150,
            width: 350,
            highlightStep: true,
            position: "right", //No I18N
            aftershow: function()
            {
                var popover = $("FileImport_zpopover");
                popover.removeChild(popover.getElementsByClassName("zpopover__footer")[0]);
            }
        }
        
        ];
        
        var allImportInit = {
            slides: allImportSteps,
            id: "allImport", //NO I18N
            firstSlideAsStart: true,
            multiPageTour: false,
            type: "navigation", //NO I18N
            navigation: { type: "text", required: "next"}, //NO I18N
            buttons: "close", //No I18N
            progressBar: false,
            skipIfNoElement: true
        };

        t1 = new ZTour(allImportInit);
        t1.init({"id": "allImport"}); //No I18N
        t1.start(); 
        this.currenttour = t1;
    }
    
    this.fileStep1Tour = function() //Step 1 of import from files and feeds
    {
        ZRTour.tourCalled = 2;
        
        var fileStep1Steps = [
        {
            target: "#IDBNAME1", //NO I18N
            title: "<html><body>Enter your Database Name</body></html>", //NO I18N
            content: "<html><body>What do you want to name your Database? (You can always change this later) <div id='autofill-holder' style='visibility: hidden'><div class='autofill-text'>Autofilling database name...</div> <div class='autofill-loader'></div></div> </body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 200,
            width: 350,
            position: "right", //No I18N
            highlightStep: true,
            highlightTargetSpacing: {x: 1, y: 1},
            aftershow: function()
            {
                ZRTour.setProgressBar($("IDBNAME1_zpopover"));
            },
            onnext: function()
            {
            	if(!ZDBValidator.checkLength($("IDBNAME1").value, $("IDBNAME1")))
                {
                    ZRTour.autofill();                   
                    ZRSHomeHandler.autoDatabaseName("ZDBIMPORTTBODY"); //No I18N
                    setTimeout(function() { t2.next(); }, 2000);                    
                    return false;
                }
            }
        },
        
        {
            target: "#ZDBFILETYPE", //NO I18N
            title: "<html><body>Choose file type</body></html>", //NO I18N
            content: "<html><body>Choose file type</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 180,
            width: 350,
            position: "right", //No I18N
            highlightStep: true,
            highlightTargetSpacing: {x: 1, y: 1},
            aftershow: function()
            {
                ZRTour.setProgressBar($("ZDBFILETYPE_zpopover"));
            }
        },
        
        {
            target: "#ZDBDataLocation", //NO I18N
            title: "<html><body>Choose Data Location</body></html>", //NO I18N
            content: "<html><body>Choose Data Location</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 180,
            width: 350,
            position: "right", //No I18N
            highlightStep: true,
            highlightTargetSpacing: {x: 1, y: 2},
            aftershow: function()
            {
                ZRTour.setProgressBar($("ZDBDataLocation_zpopover"));
            },
            onnext: function()
            {
            	if($("ZDBWEBOPT").checked) {
            		t2.options.slides[t2._currentStep.next].target = "#ZDBURLINP";
            	}
            	else if($("ZDBPASTEOPT").checked) {
            		t2.options.slides[t2._currentStep.next].target = "#ZDBPASTEINP";
            	}
            	else if($("ZDBFTPOPT") && $("ZDBFTPOPT").checked) {
            		t2.options.slides[t2._currentStep.next].target = "#ZDBFTPINP";
            	}
            }
        },
        
        {
            target: "#ZDBFILEINP", //NO I18N
            title: "<html><body>Choose file</body></html>", //NO I18N
            content: "<html><body>Choose file or try our sample file by clicking on 'Try Sample' <div id='autofill-holder' style='visibility: hidden;'><div class='autofill-text'>Uploading sample file...</div> <div class='autofill-loader'></div></div> </body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 200,
            width: 350,
            position: "right", //No I18N
            highlightStep: false,
            highlightTargetSpacing: {x: 1, y: 1},
            aftershow: function()
            {
            	var target = this.target.replace("#","")+"_zpopover";
                ZRTour.setProgressBar($(target));
            },
            onnext: function() 
            {
            	if($("ZDBFILEOPT").checked && $("ZRFILESELECTORFILENAME").value == "No file Selected") {
                    ZRTour.autofill();
                    fileSamleSelected("Sales Data"); //No I18N 
                    setTimeout(function() { t2.next(); }, 2000);                    
                    return false;
            	}
                else if($("ZDBWEBOPT").checked && $("ZDBInputURL").value == "Type your URL") {
                    ZRTour.autofill();
                    clickSampleURL();
                    setTimeout(function() { t2.next(); }, 2000);                    
                    return false;
            	}
            	else if($("ZDBPASTEOPT").checked && $("ZDBPASTEDDATA").value == "") {
                    ZRTour.autofill();
                    pasteDataSample();
                    setTimeout(function() { t2.next(); }, 2000);                    
                    return false;
            	}
            	else if($("ZDBFTPOPT") && $("ZDBFTPOPT").checked) {
                    ZRTour.autofill();
                    setTimeout(function() { t2.next(); }, 2000);                    
                    return false;
                    //pending
            	}
            	
            }
        },
        
        {
            target: "#ZDBNextDBBtn", //NO I18N
            title: "<html><body>Click Next</body></html>", //NO I18N
            content: "<html><body>Click here to proceed to the next step</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 150,
            width: 350,
            position: "right", //No I18N
            highlightStep: true,
            highlightTargetSpacing: {x: 1, y: 1},
            aftershow: function()
            {
                ZRTour.setFooterWithProgressAlone($("ZDBNextDBBtn_zpopover"));
            }
        }
        ];
        
        var fileStep1Init = {
            slides: fileStep1Steps,
            id: "tour2", //NO I18N
            firstSlideAsStart: false,
            multiPageTour: false,
            type: "navigation", //NO I18N
            navigation: { type: "text", required: "next"}, //NO I18N
            buttons: "close", //No I18N
            progressBar: true,
            skipIfNoElement: true
        };

        t2 = new ZTour(fileStep1Init);
        t2.init({"id": "tour2"}); //No I18N
        t2.start(); 
        this.currenttour = t2;
        jQuery(document).unbind("click"); //No I18N
    }
    
    this.fileStep2Tour = function() //Create step of import from files and feeds
    {
        ZRTour.tourCalled = 3;
        
        var fileStep2Steps = [
        {
            target: "#TABLENAME", //NO I18N
            title: "<html><body>Enter Table name</body></html>", //NO I18N
            content: "<html><body>Give unique name for your table</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 180,
            width: 350,
            position: "right", //No I18N
            highlightStep: true,
            highlightTargetSpacing: {x: 1, y: 1},
            aftershow: function()
            {
                ZRTour.setProgressBar($("TABLENAME_zpopover"));
            }
        },
        
        {
            target: "#SampleTableHolder", //NO I18N
            title: "<html><body>Edit table structure</body></html>", //NO I18N
            content: "<html><body>Edit table structure</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 180,
            width: 350,
            position: "bottom", //No I18N
            highlightStep: true,
            highlightTargetSpacing: {x: 1, y: 1},
            aftershow: function()
            {
                ZRTour.setProgressBar($("SampleTableHolder_zpopover"));
            }
        },
        
        {
            target: "#ZDBImportTableCreateLink", //NO I18N
            title: "<html><body>Click Create</body></html>", //NO I18N
            content: "<html><body>Click to import data</body></html>", //NO I18N
            htmlSafe: true,
            slideHeight: 150,
            width: 350,
            position: "right", //No I18N
            highlightStep: true,
            highlightTargetSpacing: {x: 1, y: 1},
            aftershow: function()
            {
                ZRTour.setFooterWithProgressAlone($("ZDBImportTableCreateLink_zpopover"));
            }
        }
        ];
        
        var fileStep2Init = {
            slides: fileStep2Steps,
            id: "tour3", //NO I18N
            firstSlideAsStart: false,
            multiPageTour: false,
            type: "navigation", //NO I18N
            navigation: { type: "text", required: "next"}, //NO I18N
            buttons: "close", //No I18N
            progressBar: true,
            skipIfNoElement: true
        };
        
        t3 = new ZTour(fileStep2Init);
        t3.init({"id": "tour3"}); //No I18N
        t3.start(); 
        this.currenttour = t3;
        jQuery(document).unbind("click"); //No I18N
    }
    
    this.callContextTour = function(tour, el)
    {
        switch(tour)
        {
            case "import": //No I18N
                if(ZDBUtil.getParentWithAttributeValue(el, "name", "CreateDBFrm"))
                {
                    ZRTour.fileStep1Tour();
                }
                else if(ZDBUtil.getParentWithAttributeValue(el, "name", "ImportForm"))
                {
                    ZRTour.fileStep2Tour();
                }
                break;
        }       
    }

};
