#!/bin/bash

#use it like sh md5_script.sh . 10 ttf|png for selective compiling
#Dont remove the commented methods. They can be used in future during development phase.
HASH=0
PREVIOUS_MD5=0
FILEPATH=$1
FILESTOHASH=${3:-js|css|jpg|jpeg|png|ico|svg|gif}
INTERVAL=${2:-1}
ISIMAGEPROCESSING=${4:-false}
SEC="s"
FINDINTERVAL="$INTERVAL$SEC"
SHOULDLOOP=${4:-false}
if [[ `uname` == 'Linux' ]] ; then
    ISLINUX=true
else
    ISLINUX=false
fi

echo "*****************************************"
echo "HASHING LOCATION: $FILEPATH"
echo "FILESTOHASH: $FILESTOHASH"
echo "WATCH INTERVAL: $INTERVAL"
echo "FIND INTERVAL: $FINDINTERVAL"
echo "*****************************************"

#updateMD5()
#{
#    HASH=`ls -lR . | md5`
#}

updateAllHash()
{
    TEMP=`ls -lR . | md5`
    HASH=$TEMP
    PREVIOUS_MD5=$TEMP
}

init_build()
{
    echo "{" > tempHashes
    cat tempHashes > hashes.json
    if [[ $ISLINUX = true ]] ; then
    files=(`find . -regextype posix-extended -regex ".*\.($FILESTOHASH)"`)
    else
    files=(`find -E $FILEPATH -iregex ".*\.($FILESTOHASH)"`)
    fi
    FILESLENGTH=${#files[@]}
    echo "***************************"
    echo "FILES TO HASH: $FILESLENGTH"
    echo "***************************"
    for (( i=0; i<$FILESLENGTH; i++))
    do
        CURRENTFILE=${files[$i]#./}
        CURRENTFILEEXT=${CURRENTFILE##*.}
        CURRENTFILENAME=${CURRENTFILE%.*}
        if [[ $CURRENTFILENAME = *"favicon"* ]] ; then
        continue
        fi
        if [[ $ISLINUX = true ]] ; then
        CHECKSUM=`md5sum $CURRENTFILE | awk '{print $1}'`
        else
        CHECKSUM=`md5 -q $CURRENTFILE`
        fi
        if [[ -z $CHECKSUM ]] ; then
        echo "File not found for $CURRENTFILENAME "
        exit 1;
        fi
        NEWFILENAME="$CURRENTFILENAME"".""$CHECKSUM"".""$CURRENTFILEEXT"
        JSON="\"$CURRENTFILE\":\"$NEWFILENAME\""
        if [[ $ISIMAGEPROCESSING = false ]] ; then
            cp $CURRENTFILE $NEWFILENAME
            if [[ $CURRENTFILE != "customExport/"* ]] && [[ $CURRENTFILE != "ze/"* ]]; then
                rm $CURRENTFILE
            fi
        fi
        echo $JSON
        echo $JSON > tempHashes
        cat tempHashes >> hashes.json
        if [ "$((i + 1))" != "$FILESLENGTH" ] 
        then
            echo "," > tempHashes
            cat tempHashes >> hashes.json
        fi
    done
    echo "}" > tempHashes
    cat tempHashes >> hashes.json
    rm -r ./clienthashing
    mkdir clienthashing
    cp hashes.json clienthashing/hashes.json
    echo "*****************************************"
    echo "*****************************************"
    echo "*****************************************"
    cat clienthashing/hashes.json
    echo "*****************************************"
    echo "*****************************************"
    echo "*****************************************"
    if [[ $ISIMAGEPROCESSING = true ]] ; then
        replaceImageUrls
    fi
    checkStatus
    if [[ $SHOULDLOOP = false ]] ; then
        #to remove whitespaces
        cp clienthashing/hashes.json clienthashing/hashes1.json
        rm clienthashing/hashes.json
        cat clienthashing/hashes1.json | tr -d ' \t\n\r\f' > clienthashing/hashes.json
    fi
    rm hashes.json
    rm tempHashes
#    updateAllHash
}

replaceImageUrls()
{
    #for ZRAllImagesDef.scss
    # for i in common
    # do
        echo "Replacing Image URL's in " common " theme Directory"
        # for j in f2
        # do 
            curpath=./themes/common/styles/f2
            grep -F "url(" $curpath/ZRSAllImagesDef.css | while read k; do
                k=${k#*url(}
                k=${k%)*}
                k=${k//\"/}
                k=${k//\'/}
                k=${k#/}
                echo "Getting hash for file "$k
                if [[ ${k#..} == $k ]] ; then
                    resultantK=$k
                else
                    curDir=`pwd`
                    filePath=themes/common/styles/f2/$k
                    fileDir=${filePath%*/*}
                    cd $fileDir
                    fileDir=`pwd`
                    cd $curDir
                    fileDir=${fileDir#$curDir}
                    fileDir=${fileDir#/}
                    resultantK=$fileDir/${filePath##*/}
                fi
                match=`grep -F "$resultantK" clienthashing/hashes.json`
                if [[ $? -eq 0 ]] ; then
                    match=${match//\"}
                    match=${match//\,}
                    match=${match//\'}
                    match=${match//\ }
                    hashURL=${match##$resultantK:}
                    hashURL=${hashURL//\"}
                    resultantK=${resultantK////\\/}
                    echo "Hashed URL for file "$resultantK" is "$hashURL
                    if [[ ${k#..} == $k ]] ; then
                        hashURL=${hashURL////\\/}
                        perl -pi -e "s/$resultantK/$hashURL/gi" $curpath/ZRSAllImagesDef.css
                    else
                        hashedFileName=${hashURL##*/}
                        actualFileName=${k##*/}
                        hashURL=${k%%$actualFileName}$hashedFileName
                        hashURL=${hashURL////\\/}
                        k=${k////\\/}
                        perl -pi -e "s/$k/$hashURL/gi" $curpath/ZRSAllImagesDef.css
                    fi
                else
                    echo 'No match for file '$k' in generated hashes.json file please look into your code'
                    exit 1
                fi
            done
            if [[ "$?" != "0" ]] ; then
                exit 1
            fi
        # done
    # done

    #for ZRSSampleDBImages.scss
    # for i in common
    # do
        echo "Replacing Image URL's in " common " theme Directory"
        # for j in f2
        # do 
            curpath=./themes/common/styles/f2
            grep -F "url(" $curpath/ZRSSampleDBImages.css | while read k; do
                k=${k#*url(}
                k=${k%)*}
                k=${k//\"/}
                k=${k//\'/}
                k=${k#/}
                echo "Getting hash for file "$k
                if [[ ${k#..} == $k ]] ; then
                    resultantK=$k
                else
                    curDir=`pwd`
                    filePath=themes/common/styles/f2/$k
                    fileDir=${filePath%*/*}
                    cd $fileDir
                    fileDir=`pwd`
                    cd $curDir
                    fileDir=${fileDir#$curDir}
                    fileDir=${fileDir#/}
                    resultantK=$fileDir/${filePath##*/}
                fi
                match=`grep -F "$resultantK" clienthashing/hashes.json`
                if [[ $? -eq 0 ]] ; then
                    match=${match//\"}
                    match=${match//\,}
                    match=${match//\'}
                    match=${match//\ }
                    hashURL=${match##$resultantK:}
                    hashURL=${hashURL//\"}
                    resultantK=${resultantK////\\/}
                    echo "Hashed URL for file "$resultantK" is "$hashURL
                    if [[ ${k#..} == $k ]] ; then
                        hashURL=${hashURL////\\/}
                        perl -pi -e "s/$resultantK/$hashURL/gi" $curpath/ZRSSampleDBImages.css
                    else
                        hashedFileName=${hashURL##*/}
                        actualFileName=${k##*/}
                        hashURL=${k%%$actualFileName}$hashedFileName
                        hashURL=${hashURL////\\/}
                        k=${k////\\/}
                        perl -pi -e "s/$k/$hashURL/gi" $curpath/ZRSSampleDBImages.css
                    fi
                else
                    echo 'No match for file '$k' in generated hashes.json file please look into your code'
                    exit 1
                fi
            done
            if [[ "$?" != "0" ]] ; then
                exit 1
            fi
        # done
    # done
}


#changed()
#{
#    echo "Files have been changed"
#    echo "***************BUILDING******************"
#    change_build
#    updateAllHash
#    echo "**************DONE BUILDING**************"
#}

#compare()
#{
#    updateMD5
#    if [[ $HASH != $PREVIOUS_MD5 ]] ; then
#        changed
#    fi
#}

#change_build(){
#    FILES=(`find $FILEPATH -mtime -$FINDINTERVAL`)
#    CHANGEFILESLENGTH=${#FILES[@]}
#    for (( i=0; i<$CHANGEFILESLENGTH; i++))
#    do
#        CURRENTFILE=${FILES[$i]#./}
#        CURRENTFILEEXT=${CURRENTFILE##*.}
#        CURRENTFILENAME=${CURRENTFILE%.*}
#        CHECKSUM=`md5 -q $CURRENTFILE`
#        NEWFILENAME="$CURRENTFILENAME"".""$CHECKSUM"".""$CURRENTFILEEXT"
#        JSON="$CURRENTFILE\":\"$NEWFILENAME\""
#        cp $CURRENTFILE $NEWFILENAME
#        echo $JSON
#        JSON=${JSON////\\/}
#        SEARCHSTR="$CURRENTFILE"".*"
#        SEARCHSTR=${SEARCHSTR////\\/}
#        perl -pi -e "s/$SEARCHSTR/$JSON/gi" hashes.json
#    done
#}

run(){
    init_build
    checkStatus
#    if [[ $SHOULDLOOP = true ]] ; then
#        while [[ true ]]; do
#            compare
#            sleep $INTERVAL
#        done
#    fi
}

checkStatus()
{
    if [ "$?" != "0" ]
    then
        exit 1
    fi
}


run