//$Id$ 
var ZROrg = new function() {

    var self = this;
    var orglistloaded = false;
    var currentUsersOrgName;
    var defaultServiceOrg;
    var defaultServiceOrgName;
    var ownOrgDesc;
    var highlightZsoid;
    var cloneOrgList = [];
    
    this.handleLoadOrgDetails = function(response)
    {
        var resp = response.orgdetails;
        ZDBGlobal.adminZsoId = resp.adminOrg.zsoid;
        currentUsersOrgName = resp.adminOrg.orgName;
        defaultServiceOrg = resp.defaultOrg.zsoid;
        defaultServiceOrgName = resp.defaultOrg.orgName || ZDBI18NMap.g("zr.org.js.all");
        ZRSHomepageListing.isAdmin = (ZDBGlobal.adminZsoId == defaultServiceOrg) || (defaultServiceOrg == -1);
    }

    this.loadOrgList = function()
    {
//        AjaxAPI.sendRequest({
//           URL: "/reportsapi/GETORGLIST",//No I18N
//           ONSUCCESSFUNC: ZROrg.handleLoadOrgList,
//           OPSTATUSID: "ZROrgLoader" //No I18N
//        });
        ZRSAjax.get('/reportsapi/GETORGLIST', null, {
            successHandler: {
                func: ZROrg.handleLoadOrgList,
                ctx: ZROrg
            },
            loader: 'ZROrgLoader'//NO I18N
        });
    }

    this.handleLoadOrgList = function(resp)
    {
        var orglist = resp.orglist.values;
        cloneOrgList = orglist;
        var noOfOrgs = orglist.length;

        if(ZDBGlobal.canShowCreateSchemaOpt)
        {
            $("ZRCreateSchemaCont").style.display = "inline-block";
        }

        document.getElementsByClassName("shortcutSortSettingsNew")[0].style.display = (noOfOrgs >= 5) ? "inline-block" : "none";
        $("searchOrgCont").style.display = (noOfOrgs >= 5) ? "inline-block" : "none"; //No I18N
        $("ZRCreateOrgButton").setAttribute("onclick", (ZDBGlobal.canShowCreateSchemaOpt) ? "ZROrg.createOrg();" : "ZROrg.renameOrg();"); //No I18N

        var allorg = $("allOrgLi");
        allorg.getElementsByClassName("zr-org")[0].innerText = ZDBI18NMap.g("zr.org.js.all"); //No I18N
        allorg.getElementsByClassName("defaultDBIcon")[0].setAttribute("tip",ZDBI18NMap.g('zr.org.js.makedefault.title')); //No I18N
        allorg.style.display = (noOfOrgs >= 2) ? "block" : "none"; //No I18N

        var org = ZDBUtil.templateCreator("_orgListContainer"); //No I18N
        for(var i=0; i<orglist.length; i++)
        {
            var list = orglist[i];
            var cloneOrg = org.cloneNode(true);
            ZDBUtil.addClass(cloneOrg, "org-"+list[3]);

            var nodeList = cloneOrg.querySelectorAll(".zr-org, .own-org, .defaultDBIcon, .renameDBIcon, .dbInfoIcon, .ownerText, .sharedByEmail"); //No I18N

            var superAdminInfo = [ZDBI18NMap.g("zr.org.js.org.info.database"), list[6], ZDBI18NMap.g("zr.org.js.org.info.sharedUsers"), list[8],
                                ZDBI18NMap.g("zr.org.js.info.role"), ZDBI18NMap.g("zrpt.common.js.admin"), ZDBI18NMap.g("zr.org.js.info.subs"), list[9]+" "+ZDBI18NMap.g("zrpt.pricing.js.plan.plan")];

            var sharedUserInfo = [ZDBI18NMap.g("zr.org.js.info.sharedDB"), list[7], ZDBI18NMap.g("zr.org.js.info.role"), ZDBI18NMap.g("zrpt.common.js.user"),
                                ZDBI18NMap.g("zr.org.js.info.subs"), list[9]+" "+ZDBI18NMap.g("zrpt.pricing.js.plan.plan")];

            var owner, info = [];
            nodeList[0].innerText = list[0];
            nodeList[0].setAttribute("tip",list[0]);
            nodeList[2].setAttribute("tip",ZDBI18NMap.g('zr.org.js.makedefault.title'));
            nodeList[5].innerText = ZDBI18NMap.g("zr.org.js.owner")+": ";

            if(list[4])
            {
                nodeList[1].innerText = ZDBI18NMap.g("zr.org.js.owner");
                owner = ZDBI18NMap.g("zr.org.js.me");
                nodeList[3].setAttribute("tip",ZDBI18NMap.g('zr.org.js.rename_org'));
                info = superAdminInfo;
                ownOrgDesc = list[1];
            }
            else
            {
                cloneOrg.removeChild(nodeList[1]);
                cloneOrg.removeChild(nodeList[3]);
                owner = list[2];
                info = sharedUserInfo;
            }
            nodeList[6].innerText = owner;

            if(list[5])
            {
                ZDBUtil.addClass(nodeList[2],"defaultDBIconSelected");
                nodeList[2].setAttribute("tip",ZDBI18NMap.g('zr.org.js.removedefault.title'));
            }

            nodeList[4].getElementsByTagName("span")[0].innerText = ZDBI18NMap.g("zr.org.js.summary");

            var liNode = nodeList[4].getElementsByTagName("li")[1];
            var ulNode = nodeList[4].getElementsByTagName("ul")[0];
            ulNode.removeChild(liNode);

            for(var j=0; j<info.length; j=j+2)
            {
                var tempLi = liNode.cloneNode(true);
                tempLi.getElementsByClassName("createdUserStyle")[0].innerText = info[j];
                tempLi.getElementsByClassName("createdUserOption")[0].innerText = info[j+1];
                ulNode.appendChild(tempLi);
            }

            $("ZROrgList").appendChild(cloneOrg);
        }

        if($("ZROrgList").getElementsByClassName("defaultDBIconSelected").length == 0)
        {
            ZROrg.markDefault();
        }

        if(ZDBGlobal.LANDINGPAGE != "ZDBHome")
        {
            highlightZsoid = ZDBGlobal.currentZsoId;
        }
        ZROrg.markSelectedOg(highlightZsoid,false);

        var orgUl = $("ZROrgList");
        orgUl.addEventListener("click", ZROrg.onClickList, false);
        orgUl.addEventListener("mouseover", ZROrg.onMouseOverList, false);
        orgUl.addEventListener("mouseout", ZROrg.onMouseOutList, false);
    }

    this.onClickList = function(e)
    {
        var el = e.target;
        if(!el || el.tagName.toLowerCase() == "ul"){
            return;
        }
        if(ZDBUtil.hasClass(el, "defaultDBIcon"))
        {
            ZROrg.setDefaultOrg(el);
            e.stopPropagation();
            return;
        }
        if(ZDBUtil.hasClass(el, "renameDBIcon"))
        {
            ZROrg.renameBox(el);
            e.stopPropagation();
            return;
        }

        var list = DOMUtils.getSelfOrParentWithTagName(el, "li"); //No i18N
        if(list) {
            var zsoid, orgname, orgemail;
            if(list.id == "allOrgLi")
            {
                zsoid = -1;
                orgname = ZDBI18NMap.g("zr.org.js.all");
                orgemail = "";
            }
            else
            {
                var orginfo = ZROrg.getOrgDetailsForEl(list, [3, 0, 2]);
                zsoid = orginfo[0];
                orgname = orginfo[1];
                orgemail = orginfo[2];
            }
            ZROrg.loadDatabases(zsoid, orgname, orgemail);
        }
    }

    this.onMouseOverList = function(e)
    {
        var el = e.target;
        if(!el || el.tagName.toLowerCase() == "ul"){
            return;
        }
        if(ZDBUtil.hasClass(el, "zr-org"))
        {
            ZDBToolTip.checkLengthAndShow(el);
        }
        if(ZDBUtil.hasClass(el, "dbInfoIcon"))
        {
            ZROrg.showOrgInfo(el);
            e.stopPropagation();
        }

        var list = DOMUtils.getSelfOrParentWithTagName(el, "li"); //No i18N
        if(list) {
            ZROrg.showOptions(list);
        }
    }

    this.onMouseOutList = function(e)
    {
        var el = e.target;
        if(!el || el.tagName.toLowerCase() == "ul"){
            return;
        }
        if(ZDBUtil.hasAnyOneClass(el, ["defaultDBIcon", "renameDBIcon", "zr-org"]))
        {
            ZDBToolTip.hide();
        }
        if(ZDBUtil.hasClass(el, "dbInfoIcon"))
        {
            ZROrg.hideOrgInfo(el);
        }

        var list = DOMUtils.getSelfOrParentWithTagName(el, "li"); //No i18N
        if(list) {
            ZROrg.hideOptions(list);
        }
    }

    this.showProfileInfo = function() {
        if(!orglistloaded)
        {
            if(ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBDataSheetView" && $("ZRAccountOptions").querySelector(".options-holder")) {
                var par = $("ZRAccountOptions").querySelector(".options-holder");
                par.children[1].style.display = "inline-block";
                var themeEl = $("ZRAccountOptions").querySelector("."+ZDBGlobal.currentTheme);
                ZDBUtil.addClass(themeEl, "theme-selected");
            }
            orglistloaded = true;
            ZROrg.loadOrgList();
        }
        ZDBUtil.addClass($('accountOptionsCont'),'is-visible'); // No I18N
        ev.addEscHandle(ZROrg.closeProfileInfo);
        self.adjustOrgContHeight();
    };

    this.showProfileInfo_NEW = function() {
      ZDBUtil.addClass($('accountOptionsCont'),'is-visible'); // No I18N
      ev.addEscHandle(ZROrg.closeProfileInfo_NEW);
    };

    this.closeProfileInfo = function() {
        self.resetSearch();
        ZROrg.closeSearch($('ZRSearchOrg'));
        ZDBUtil.removeClass($('accountOptionsCont'),'is-visible'); // No I18N
    };

    this.closeProfileInfo_NEW = function() {
      ZDBUtil.removeClass($('accountOptionsCont'),'is-visible'); // No I18N
    };
    this.adjustOrgContHeight = function () {
        var computedHeight = document.body.clientHeight - 108 - $('ZRAccountOptions').offsetHeight;
        $('ZROrgList').style.height = computedHeight + 'px';
    };

    this.markDefault = function () {
        var allOrg = $("allOrgLi").getElementsByClassName("defaultDBIcon")[0];
        ZDBUtil.addClass(allOrg,"defaultDBIconSelected");
        allOrg.setAttribute("tip",ZDBI18NMap.g('zr.org.js.removedefault.title'));
    };

    this.resetSearch = function () {
        $('ZRSearchOrg').value = ''; // No I18N
        self.search($('ZRSearchOrg'), 'ZROrgList'); // No I18N
    };

    this.clearSearch = function (el) {
        if($('ZRSearchOrg').value != '') {
            setTimeout(function(){
                self.resetSearch();
                $('ZRSearchOrg').focus();
            }, 100);
        }
    };

    this.getOrgDetailsForEl = function(el, arr)
    {
        for(var i=0; i<cloneOrgList.length; i++)
        {
            if(el.className.indexOf(cloneOrgList[i][3]) > -1)
            {
                var resultarr = [];
                for(var j=0; j<arr.length; j++)
                {
                    resultarr.push(cloneOrgList[i][arr[j]]);
                }
                return resultarr;
            }
        }
    }

    this.loadDatabases = function(zsoid, orgname, orgemail) {

        if(ZDBGlobal.LANDINGPAGE != 'ZDBHome') {
            setCookie("org-selected", zsoid); //No I18N
            setCookie("orgname", orgname); //No I18N
            setCookie("orgemail", orgemail); //No I18N
            ZROrg.closeProfileInfo();
            window.location.href = "/ZDBHome.cc?home=true";
            return;
        }
        defaultServiceOrg = zsoid;
        highlightZsoid = zsoid;
        if(orglistloaded)
        {
            ZROrg.markSelectedOg(highlightZsoid,true);
        }
        ZRSHomepageListing.renderDBListing(true);
        ZROrg.setAttribForSubsAndSettings(orgname);
        ZROrg.closeProfileInfo();
        var orgmsg = $("ZDBHEADER").querySelector(".org-msg-cont.is-visible");
        ZDBUtil.removeClass(orgmsg,'is-visible'); // No I18N

        ZDBMsgBox.showSuccess(ZDBI18NMap.f("zr.org.js.switchorg_msg",orgname));
    }

    this.subNSettingDlg = function(option)
    {
        var header = $("selectOrgForSubNSettingCont").querySelector("span");
        header.innerText = ZDBI18NMap.f("zr.org.js.subnsetting.not_permitted",option);
        $("subNSetting-txt").innerText = ZDBI18NMap.f("zr.org.js.subnsetting.txt",option);
        $("subNSetting-txt-all").innerText = ZDBI18NMap.f("zr.org.js.subnsetting.txt_all",option);
        $("subNSetting_manage_own").innerText = ZDBI18NMap.g("zr.org.js."+option.toLowerCase()+".manage_own"); //No I18N

        if(option == "Settings")
        {
            ZDBUtil.addClass($("selectOrgForSubNSettingCont"),"settings-box");
        }
        else
        {
            ZDBUtil.removeClass($("selectOrgForSubNSettingCont"),"settings-box");
        }
    }

    this.setAttribForSubsAndSettings = function(orgName)
    {
	if(!ZDBGlobal.IS_ONPREMISE_BUILD){
		if( orgName == 'All Organizations')
			{
				orgName = "";
				$("subNSetting-txt").style.display = "none"; //No I18N
				$("subNSetting-contact-admnistrator").style.display = "none"; //No I18N
				$("subNSetting-txt-all").style.display = ""; //No I18N
			}
			else
			{
				$("subNSetting-txt-all").style.display = "none"; //No I18N
				$("subNSetting-txt").style.display = ""; //No I18N
				$("subNSetting-contact-admnistrator").style.display = ""; //No I18N
			}

			$("selectedOrgForManageSubNSetting").innerText = orgName;
		}

	}

    this.getDefaultOrg = function(canShowCreateSchemaOpt) {
        
        var defaultzsoid = (getCookie("org-selected") == null || getCookie("org-selected") == "undefined") ? defaultServiceOrg : getCookie("org-selected"); //No I18N
        var defaultorgname = (getCookie("orgname") == null || getCookie("orgname") == "undefined") ? defaultServiceOrgName : getCookie("orgname"); //No I18N
        var isAdmin = defaultzsoid == ZDBGlobal.adminZsoId || defaultzsoid == -1;
        if(canShowCreateSchemaOpt || isAdmin)
        {
            setCookie("org-selected",undefined); //No I18N
            setCookie("orgname",undefined); //No I18N
        }
        ZRSHomepageListing.isAdmin = isAdmin;
        highlightZsoid = defaultzsoid;
        if(orglistloaded)
        {
            ZROrg.markSelectedOg(highlightZsoid,true);
        }
        ZROrg.setAttribForSubsAndSettings(defaultorgname);
        return [defaultzsoid, isAdmin];
    }

    this.markSelectedOg = function(zsoId, listLoaded) {
        
        if(listLoaded)
        {
            var highlightedEl = $("ZROrgList").getElementsByClassName("highlighted")[0];
            ZDBUtil.removeClass(highlightedEl,'highlighted');
        }
        
        var selectedEl = (zsoId == -1) ? $("allOrgLi") : $("ZROrgList").getElementsByClassName("org-"+zsoId)[0];
        ZDBUtil.addClass(selectedEl,'highlighted');
        highlightZsoid = zsoId;
    }

    // makes the contains search by the specified attribute 'searchattr'
    this.search = function(el, target) {
        var orgList = $(target).querySelectorAll('li.org-list');
        for(var i=1; i<orgList.length; i++)
        {
            orgList[i].style.display = "none";
        }
        
        $("noMatchOrg").style.display = "none";
        var searchString = el.value.toLowerCase().trim();

        if (searchString == "") {
            for (var i = 1; i < orgList.length; i++) {
                orgList[i].style.display = "block";
            }
            return;
        }

        var matchlist = [];
        var j=0;
        for (var i = 1; i < orgList.length; i++) {
            var orgName = orgList[i].getElementsByClassName("zr-org")[0].innerText.toLowerCase(); // No I18n
            var ownerEmail = orgList[i].getElementsByClassName("sharedByEmail")[0].innerText.toLowerCase();// No I18n
            if (orgName.indexOf(searchString) != -1 || ownerEmail.indexOf(searchString) != -1) {
                matchlist[j++]=i;
            }
        }
        
        for(var i=0; i<matchlist.length; i++)
        {
            orgList[matchlist[i]].style.display = "block";
        }

        if (!matchlist.length) {
            $("noMatchOrg").style.display = "block";
        }

    };

    // clears the search field on escape key
    this.clearOnEscKey = function(el, target, event) {
        if (event.keyCode == 27) { // escape key
            if (el.value.trim() == '') {
                el.value.blur();
            }
            el.value = '';
            ZROrg.search(el, target);
            event.stopPropagation();
        }
    };

    this.showOrgInfo = function(el) {
        var infotooltip = el.getElementsByTagName('ul')[0];
        infotooltip.style.display = "block";
        if((infotooltip.getBoundingClientRect().top + infotooltip.offsetHeight) >= document.body.offsetHeight)
        {
            infotooltip.style.top = infotooltip.offsetTop - infotooltip.offsetHeight - 25 + "px";
        }
        if((infotooltip.offsetLeft + infotooltip.offsetWidth + 50) >= $("ZDBSignoutLinksMenu").offsetWidth)
        {
            infotooltip.style.left = $("ZDBSignoutLinksMenu").offsetWidth - infotooltip.offsetLeft - infotooltip.offsetWidth - 50 + "px";
        }
        ZDBUtil.addClass(el,'ZRSDBHighLight');
    }

    this.hideOrgInfo = function(el) {
        var infotooltip = el.getElementsByTagName('ul')[0];
        infotooltip.style.display = "none";
        infotooltip.style.top = "";
        infotooltip.style.left = "";
        ZDBUtil.removeClass(el,'ZRSDBHighLight');
    }

    this.showCreateSchemaDlg = function(el) {
        ZDBDialogUtil.closeDialog();
        var dlg = $('ZRCreateSchemaDlg');
        ZROrg.resetFields(dlg);
        dlg.style.display = '';
        ZDBDialogUtil.showDialog(dlg, {
            MODAL: true,
            ADDFRAME: true,
            TITLE: ZDBI18NMap.g('zr.org.js.create_org'),
            HELPDOC: ZDBI18NMap.g("zr.org.js.help_link"),
            SHADOW: true,
            DONTREMOVE: true,
            SRCEL: el
        });
        ZROrg.closeProfileInfo();
        var orgmsg = $("ZDBHEADER").querySelector(".org-msg-cont.is-visible");
        ZDBUtil.removeClass(orgmsg,'is-visible'); // No I18N
    };

    this.resetFields = function (dlg) {
        $('Org-Name').value = "";
        $('OrgDescription').value = "";
    };

    this.closeSchemaDlg = function() {
        var dlg = jQuery('#ZRCreateSchemaDlg'); //No I18N
        var freezeLayer = jQuery('#create-schema-freeze'); //No I18N
        dlg.animate({
            right: '-420px',
            opacity: 0
        }, "slow"); //No I18N
        freezeLayer.fadeOut(400, function() {
            freezeLayer.remove();
        });
    }
    
    this.createOrg = function() {
        var orgName = $("Org-Name").value;
        var orgDesc = $('OrgDescription').value; // No I18N
        AjaxAPI.sendRequest({URL:"/ZDBHome.ve?ZDBACTION=CREATEORG&ORG_NAME=" + encodeURIComponent(orgName) + "&ORG_DESC=" + encodeURIComponent(orgDesc), //No I18N
                                ONSUCCESSFUNC:ZROrg.onSuccess}); //No I18N
        
        var freeze = document.createElement("div");
        freeze.id = "createSchemaFreeze";
        freeze.className = "freezeLayer";
        freeze.setAttribute("style","background: #fff; opacity: 0.9; z-index: 99999;display: flex;align-items: center;justify-content: center;");
        freeze.setAttribute("onclick","ZROrg.closeProfileInfo();");
        
        var info = document.createElement("div");
        var span1 = document.createElement("span");
        span1.className = "mcLoading";
        var span2 = document.createElement("span");
        span2.innerHTML = ZDBI18NMap.g('zr.org.js.creating_msg');
        info.appendChild(span1);
        info.appendChild(span2);
        
        freeze.appendChild(info);
        document.body.appendChild(freeze);
    };

    this.onSuccess = function(response, requestOptions) {
        window.location.href = "/ZDBHome.cc?home=true";
    }

    this.showOptions = function(el) {
        ZDBUtil.addClass(el,'ZRSDBHighlight');
    };

    this.hideOptions = function(el) {
        ZDBUtil.removeClass(el,'ZRSDBHighlight');
    };
    
    this.renameBox = function(el)
    {
        var srcel = el.parentNode;
        var renameDlg = $('ZRCreateSchemaDlg');
        renameDlg.style.display = '';
        $('Org-Name').value = srcel.getElementsByClassName("zr-org")[0].innerText; //No I18N 
        $('OrgDescription').value = ownOrgDesc;//No I18N
        ZDBDialogUtil.showDialog(renameDlg, { 
            MODAL:true, 
            ADDFRAME:true, 
            CALLOUT:true,
            SRCEL:srcel,
            MANUALPOS:'LEFT50', // No I18N
            TITLE: ZDBI18NMap.g('zr.org.js.rename_org'),  // No I18N
            HELPDOC: ZDBI18NMap.g("zr.org.js.help_link"), // No I18N
            SHADOW:true, 
            DONTREMOVE:true
        });
    };

    this.renameOrg = function() {
        var el = ZDBDialogUtil.focusDialog.params.SRCEL;
        var newOrgName = $("Org-Name").value;
        var newOrgDesc = $("OrgDescription").value;
        var zsoid = (ZDBGlobal.LANDINGPAGE == "ZDBHome") ? ZDBGlobal.adminZsoId : ZDBGlobal.currentZsoId; //No I18N
        var params = '&ZDBACTION=RENAMEORGNAME&ZSOID=' + zsoid + '&NEWORGNAME=' + encodeURIComponent(newOrgName) + '&NEWORGDESC=' + encodeURIComponent(newOrgDesc); // No I18N
        AjaxAPI.sendRequest({
            URL: "/ZDBHome.ve", //No I18N
            PARAMETERS: params,
            ONSUCCESSFUNC: ZROrg.renameOrgOnSuccess,
            OPSTATUSID: "ZDBDBRENAMEOPTSTATUS",//No I18N
            ELEMENT: el,
            NEWORGNAME: newOrgName,
            NEWORGDESC: newOrgDesc
        }); //No I18N
    };

    this.renameOrgOnSuccess = function(response, request) {
        var parEl = request.ELEMENT;
        var orgNameEl = parEl.querySelector('.zr-org');//No I18N
        orgNameEl.innerText = request.NEWORGNAME;
        orgNameEl.setAttribute('tip', request.NEWORGNAME); // No I18N
        ZDBDialogUtil.closeDialog();
        ZDBMsgBox.showHintMsg(ZDBI18NMap.g('zr.org.js.updated'), 'success'); // No I18N
        currentUsersOrgName = request.NEWORGNAME;
        cloneOrgList[0][0] = request.NEWORGNAME;   
    };

    this.toggleSearch = function(event) {
        ZDBUtil.toggleClass($("searchOrgCont"),'is-active'); // No I18N
        $("ZRSearchOrg").focus();
    };
    
    this.closeSearch = function(el)
    {
        if(el.value == '') {
            ZDBUtil.removeClass($("searchOrgCont"),'is-active'); // No I18N
        }
    };

    this.setDefaultOrg = function(el) {
        
        var existingDefault = $("ZROrgList").querySelector("li .defaultDBIconSelected");
        ZDBUtil.hasClass(el,"defaultDBIconSelected") ? ZROrg.markDefault() : ZDBUtil.addClass(el,"defaultDBIconSelected"); //No I18N
        el.setAttribute("tip",ZDBI18NMap.g('zr.org.js.removedefault.title'));
        ZDBUtil.removeClass(existingDefault,"defaultDBIconSelected");
        existingDefault.setAttribute("tip",ZDBI18NMap.g('zr.org.js.makedefault.title'));
        
        var zsoid = (el.parentNode.id == "allOrgLi") ? -1 : ZROrg.getOrgDetailsForEl(el.parentNode, [3]);
        AjaxAPI.sendRequest({
            URL: "/ZDBHome.ve", //No I18N
            PARAMETERS: '&ZDBACTION=SETDEFAULTORG&ZSOID=' + zsoid, //No I18N
            ONSUCCESSFUNC: ZROrg.setDefaultOrgOnSuccess,
            OPSTATUSID: "",
            ICONEL:el
        }); //No I18N
    }

    this.setDefaultOrgOnSuccess = function(response, request) {
        
        var el = request.ICONEL;
        if(ZDBUtil.hasClass(el,"defaultDBIconSelected")) {
            ZDBMsgBox.showHintMsg(ZDBI18NMap.g('zr.org.js.set_default'), "success"); // No I18N
        } else {
            ZDBMsgBox.showHintMsg(ZDBI18NMap.g('zr.org.js.unset_default'), "success"); // No I18N
        }
    };

    this.showSortMenu = function (el, event) {
        if(ZRSMenu.visibleMenu.length == 1) {
            ZRSMenu.closeMenu();
        } else {
            var menu = $('ZROrgSortMenu'); // No I18N
            menu.positioned = true;
            ZRSMenu.showMenu(event, el, menu, 5);
        }
    };

    this.sort = function(el, sortOrder)
    {
        var alphaOrderMap = {};
        for(var i=0; i<(cloneOrgList.length-1); i++)
        {
            for(var j=i+1; j<cloneOrgList.length; j++)
            {
                if(cloneOrgList[i][0].localeCompare(cloneOrgList[j][0])==1)
                {
                    var t = cloneOrgList[i];
                    cloneOrgList[i] = cloneOrgList[j];
                    cloneOrgList[j] = t;
                }
            }
            alphaOrderMap[cloneOrgList[i][3]] = i;
        }
        alphaOrderMap[cloneOrgList[cloneOrgList.length-1][3]] = cloneOrgList.length-1;
        
        var ul = $("ZROrgList").querySelectorAll("li.org-list");
        var sortedUl = [];
        
        for(var i=1; i<ul.length; i++)
        {
            var zsoid = ZROrg.getOrgDetailsForEl(ul[i],[3]);
            sortedUl[alphaOrderMap[zsoid]] = ul[i];
            $("ZROrgList").removeChild(ul[i]);
        }
        
        if(sortOrder == "ascend")
        {
            for(var i=0; i<sortedUl.length; i++)
            {
                $("ZROrgList").appendChild(sortedUl[i]);
            }
        }
        else
        {
            for(var i=(sortedUl.length-1); i>=0; i--)
            {
                $("ZROrgList").appendChild(sortedUl[i]);
            }
        }
        
        ZRSMenu.closeMenu();
        
        var menu = $("ZROrgSortMenu").getElementsByClassName("selected-sort-menu")[0]; // No I18N
        ZDBUtil.removeClass(menu,"selected-sort-menu"); // No I18N
        ZDBUtil.addClass(el.getElementsByClassName("icon-space")[0], "selected-sort-menu"); // No I18N
    }

    this.loadProfileImage = function () {
        if($('ZDBProfilePicCont')) {
            var photoURL = ZDBGlobal.CONTACTSSERVERURL + '/file?t=user&height=80&width=80&exp=360000&ID=' + ZDBGlobal.zuID + '&nps=404'; // No I18N
            var nameFirstLetter = $('ZDBProfilePicCont').getAttribute('data-first-letter'); // No I18N
            ZROrg.setProfileImage($('ZDBProfileThumbCont'), photoURL, nameFirstLetter); // No I18N
            ZROrg.setProfileImage($('ZDBProfilePicCont'), photoURL, nameFirstLetter); // No I18N
        }
    };

    this.setProfileImage = function (element, photoURL, nameFirstLetter) {
        var image = element.getElementsByTagName('img')[0]; // No I18N
        if(ZDBGlobal.isUserPhotoPresent)
        {
            image.src = photoURL;
        }
        else
        {
            image.style.display = "none";
            var noImageEl = element.getElementsByClassName('no-image')[0]; // No I18N
            noImageEl.innerText = nameFirstLetter;
            noImageEl.style.display = "";
        }
    };
    
    this.showOrgSubNSettings = function(option)
    {    
        var redirectLink = (option == "Subscription") ? ZDBGlobal.upgradeLink : ZDBGlobal.REPORTS_CONTEXT_NAME + ZDBGlobal.CONTEXTPATH +'/ZDBPricing.cc?SHOWPAGE=CurrentPlanDetails&STRUCT=true&ZDBACTION=USERPLANDETAILS'; // NO I18N

        if(!ZDBGlobal.canShowCreateSchemaOpt)
        {
            window.location.href = redirectLink;
            return;
        }

        ZROrg.subNSettingDlg(option);
        
        $("createYourOrgToManageSubNSetting").style.display = ZDBGlobal.canShowCreateSchemaOpt ? "" : "none";
        ZDBUtil.toggleClass($('selectOrgForSubNSettingCont'),'is-visible');// No I18N
    }
    
};
