//$Id$
function __ZRSlideClass(){
    this.jsonData = null;
    this.views = [];
    this.viewTypeMapping = {
        0 : "Table",
        1 : "Report",
        2 : "AnalysisView",
        3 : "Pivot",
        4 : "SummaryView",
        6 : "QueryTable",
        7 : "Dashboard"
    };
    this.dbId = null;
    this.titleEl = null;
    this.descEl = null;
    this.minInterval = null;
    this.controller = null;
    this.mouseMovedTime = null;
    this.autoPlaytimer = null;
    this.currentView = null;
    this.previousView = null;
    this.cycleInfo = 0;
}

__ZRSlideClass.prototype.startSlideshow = function(){
    var firstSlide = this.views[0];
    var slideInfo = this.jsonData.VIEWSINFO[firstSlide];
    ZDBClientUI.setUpDBView(null,this.dbId, firstSlide, null, this.viewTypeMapping[slideInfo[3]], this.jsonData.ISDBOWNER,
                            this.jsonData.ISDBOWNERNOTDBADMIN, null, this.jsonData.NOTLOGGEDIN,
                            true, null, null, null, null, null, null, null,null, null,
                            false, null, null, this.jsonData.USERLOCALE, null, null,
                            false, null, null, null, null, null,null, null, null, null, null, null, null);
    this.currentView = firstSlide;
    this.setDocumentTitle(slideInfo[1]);
    this.updateControllerDisplay();
};

__ZRSlideClass.prototype.openView = function(slideInfo){
    ZDBClientUI.fetchView(slideInfo[0], this.dbId, slideInfo[1], this.viewTypeMapping[slideInfo[3]]);
    this.currentView = slideInfo[0];
    this.updateControllerDisplay();
};

__ZRSlideClass.prototype.updateControllerDisplay = function(){
    var currentView = this.currentView;
    var slideInfo = this.jsonData.VIEWSINFO[currentView];
    this.controller.slideNumber.textContent = (this.views.indexOf(currentView) + 1) + ". " + slideInfo[1];
    var indexOfCurrentView = this.views.indexOf(currentView);
    this.controller.prevSlideBtn.className = (indexOfCurrentView === 0)? "zdbPrevSlideDisabled" : "zdbPrevSlide";
    this.controller.nextSlideBtn.className = (indexOfCurrentView === this.views.length - 1)? "zdbNextSlideDisabled" : "zdbNextSlide";
    this.controller.playNPauseBtn.className = (this.jsonData.AUTOPLAY)?"zdbPauseButton":"zdbPlayButton";
};

__ZRSlideClass.prototype.setDocumentTitle = function(viewName){
    document.title = viewName;
};

__ZRSlideClass.prototype.initiSlideShow = function(jsonString){
    this.jsonData = JSON.parse(jsonString);
    this.dbId = this.jsonData.DBID;
    var views = Object.keys(this.jsonData.VIEWSINFO);
    views.forEach(function(view){
            this.views.push(view);
    }.bind(this));
    this.titleEl = document.getElementById("ZRSlideName");
    this.descEl = document.getElementById("ZRSlideDesc");
    this.minInterval = this.jsonData.MININTERVAL;
    ZDBGlobal.REPORTS_CONTEXT_NAME = this.jsonData.REPORTS_CONTEXT_NAME;
    ZDBGlobal.CONTENTPATH = this.jsonData.CONTENTPATH;
    ZDBGlobal.EXPBROWSERTXT = this.jsonData.BROWSERTITLE;
    ZDBGlobal.IS_SLIDESHOW = true;
    ZDBGlobal.SLIDESHOW_KEY = this.jsonData.SLIDEKEY;
    ZDBGlobal.SLIDESHOW_ID = this.jsonData.SLIDEID;
    ZDBGlobal.isMapChart = this.jsonData.ISMAPCHART;
    ZDBGlobal.isMapBubble = ZDBGlobal.isMapChart;
    ZDBGlobal.isMapBoxEnabled = this.jsonData.ISMAPBOX;
    ZDBEmbed.viewTitle = this.jsonData.INCLUDETITLE;
    ZDBEmbed.viewDesc = this.jsonData.INCLUDEDESC;

    ZDBClientUI.pasteArea = document.getElementById("ZDBPasteArea")
    this.controller = this.getSlideShowController(this.views);
    this.attachEventHandlersToController();
    document.body.appendChild(this.controller);
    this.resetMouseInfo();
    setInterval(function(){this.setControllerVisibility()}.bind(this),1000);
    this.startSlideshow();
    this.playNPauseSlideShow()
};

__ZRSlideClass.prototype.handleSlideKeyup = function(event){
    var keyCode = event.keyCode;
    if(keyCode === KEY.RIGHTARROW || keyCode === KEY.DOWNARROW){
        this.handleNextSlideMovement();
    }
    else if(keyCode === KEY.LEFTARROW || keyCode === KEY.UPARROW){
        this.handlePreviousSlideMovement();
    }
}

__ZRSlideClass.prototype.resetMouseInfo = function(){
    this.mouseMovedTime = (new Date()).getTime();
    this.showController();
};

__ZRSlideClass.prototype.setControllerVisibility = function(){
    var curTime = (new Date()).getTime();
    if(curTime - this.mouseMovedTime > 5000){
            this.hideController()
    }
};

__ZRSlideClass.prototype.hideController = function(){
    this.controller.style.display = "none";
};

__ZRSlideClass.prototype.showController = function(){
    this.controller.style.display = "";
};

__ZRSlideClass.prototype.resetAutoPlayInterval = function(){
    clearInterval(this.autoPlaytimer);
    if(this.jsonData.AUTOPLAY)
        this.autoPlaytimer = setInterval(function(){this.playSlide()}.bind(this), this.jsonData.INTERVAL * 1000);
};

__ZRSlideClass.prototype.getSlideURL = function(){
    var url = window.location.protocol + "//" + window.location.host + this.jsonData.REPORTS_CONTEXT_NAME + "/ZDBSlideshow.cc?SLIDEID=" + this.jsonData.SLIDEID;
    url += "&SLIDEKEY=" + this.jsonData.SLIDEKEY + "&INTERVAL=" + this.jsonData.INTERVAL;//NO I18N
    url += "&AUTOPLAY=" + this.jsonData.AUTOPLAY + "&INCLUDETITLE=" + this.jsonData.INCLUDETITLE;//NO I18N
    url += "&INCLUDEDESC=" + this.jsonData.INCLUDEDESC;//NO I18N
    return url;
}

__ZRSlideClass.prototype.playSlide = function(){
    if(this.jsonData.AUTOPLAY){
        var currentView = this.currentView;
        var currentViewIndex = this.views.indexOf(currentView);
        var anime = "right";
        if(currentViewIndex + 1 >= this.views.length){
            if(this.cycleInfo >= 5){
                window.location.href = this.getSlideURL();
                return;
            }
            this.cycleInfo += 1;
            currentViewIndex = -1;
            anime = "left"
        }
        var nextSlideInfo = this.jsonData.VIEWSINFO[this.views[currentViewIndex + 1]];
        this.changeToView(nextSlideInfo, anime, false);
    }
};

__ZRSlideClass.prototype.playNPauseSlideShow = function(){
    if(this.jsonData.AUTOPLAY){
        //start timer
        this.resetAutoPlayInterval();
    }
    else{
        //remove timer
        clearInterval(this.autoPlaytimer);
    }
};

__ZRSlideClass.prototype.toggleSlidePlay = function(){
    this.jsonData.AUTOPLAY = !this.jsonData.AUTOPLAY;
    this.playNPauseSlideShow();
    this.updateControllerDisplay();
};

__ZRSlideClass.prototype.toggleSlideInterval = function(event, manDisplay){
    ZDBToolTip.hide(null, true);
    var display = this.controller.slideIntervalInput.style.display;
    this.controller.slideIntervalInput.style.display = manDisplay ? manDisplay : (display) ? "" : "none";
};

__ZRSlideClass.prototype.handlePreviousSlideMovement = function(){
    var currentView = this.currentView;
    var currentViewIndex = this.views.indexOf(currentView);
    if(currentViewIndex - 1 < 0)
            return;
    this.previousView = ZDBClientUI.selectedTab;
    var slideInfo = this.jsonData.VIEWSINFO[this.views[currentViewIndex - 1]];
    this.resetMouseInfo();
    this.changeToView(slideInfo, "left", true);
};

__ZRSlideClass.prototype.animatePlaceHolder = function(way){
    var placeholder = DOMUtils.getParentWithTagName(document.getElementById("ZDBPLACEHOLDER"), "td");
    ZDBUtil.addClass(placeholder, "ZRSlideAnime " + way);
    setTimeout(function(){
        var placeholder = DOMUtils.getParentWithTagName(document.getElementById("ZDBPLACEHOLDER"), "td");
        ZDBUtil.addClass(placeholder, way+"A");
    }, 0);
    setTimeout(function(){
        var placeholder = DOMUtils.getParentWithTagName(document.getElementById("ZDBPLACEHOLDER"), "td");
        ZDBUtil.removeClass(placeholder, "ZRSlideAnime left leftA right rightA");
    }, 600);
};

__ZRSlideClass.prototype.handleNextSlideMovement = function(){
    var currentView = this.currentView;
    var currentViewIndex = this.views.indexOf(currentView);
    if(currentViewIndex + 1 >= this.views.length)
            return;
    this.previousView = ZDBClientUI.selectedTab;
    var slideInfo = this.jsonData.VIEWSINFO[this.views[currentViewIndex + 1]];
    this.resetMouseInfo();
    this.changeToView(slideInfo, "right", true);
};

__ZRSlideClass.prototype.toggleSlideViewList = function(event, manDisplay){
    var display = this.controller.slideInfoBox.style.display;
    this.controller.slideInfoBox.style.display = manDisplay ? manDisplay : (display) ? "" : "none";
    this.resetMouseInfo();
};

__ZRSlideClass.prototype.handleIntervalChange = function(event){
    if((event.type == "keyup" && event.keyCode === KEY.ENTER) || event.type === "blur"){
        var newInterval = parseInt(event.target.value);
        if(isNaN(newInterval)){
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidInput"));
            return;
        }
        if(newInterval > 300 || newInterval < 10){
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.intervalsetfail"));
            event.target.value = 25;
            this.jsonData.INTERVAL = 25;
            this.resetAutoPlayInterval();
            return;
        }
        this.jsonData.INTERVAL = newInterval;
        this.resetAutoPlayInterval();
        ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.intervalset"));
    }
};

__ZRSlideClass.prototype.toggleFullScreen = function(){
    if(!document.fullscreenElement && !document.mozFullScreenElement && !document.webkitFullscreenElement && !document.msFullscreenElement ){
        if(document.documentElement.requestFullscreen){
            document.body.requestFullscreen();
        }else if (document.documentElement.msRequestFullscreen) {
            document.body.msRequestFullscreen();
        }else if (document.documentElement.mozRequestFullScreen) {
            document.body.mozRequestFullScreen();
        }else if (document.documentElement.webkitRequestFullscreen) {
            document.body.webkitRequestFullscreen();
        }
        else {
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.js.unsupportedbrowser"));
        }
    }else{
        if(document.exitFullscreen){
            document.exitFullscreen();
        }else if(document.msExitFullscreen){
            document.msExitFullscreen();
        }else if(document.mozCancelFullScreen){
            document.mozCancelFullScreen();
        }else if(document.webkitExitFullscreen){
            document.webkitExitFullscreen();
        }
        else {
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.js.unsupportedbrowser"));
        }
    }
};

__ZRSlideClass.prototype.gotoView = function(el){
    var objId = el.getAttribute("objID");
    var selViewIndex = this.views.indexOf(objId);
    var curViewIndex = this.views.indexOf(this.currentView);
    if(curViewIndex == selViewIndex){
            return;
    }
    var anime = curViewIndex > selViewIndex ? "left" : "right";
    var slideInfo = this.jsonData.VIEWSINFO[objId];
    this.changeToView(slideInfo, anime, true);
};

__ZRSlideClass.prototype.changeToView = function(slideInfo, anime, resetTimer){
    this.previousView = ZDBClientUI.selectedTab;
    this.animatePlaceHolder(anime);
    this.toggleSlideViewList(null, 'none');//NO I18N
    setTimeout(function(){
        this.openView(slideInfo);
        ZDBTabHandler.removeSelectedTab(this.previousView);
    }.bind(this), 500);
    if(resetTimer)
        this.resetAutoPlayInterval();
    var i = 0;//iteration for backup.
    while(ZDBDialogUtil.dialogs.length > 0 && i < 50){
        ZDBDialogUtil.closeDialog();
        i++;
    }
};

__ZRSlideClass.prototype.hideIntervalNViewList = function(event){
    var target = event.target;
    var parent = DOMUtils.getParentWithAttrValueWithLimit(target, "id", "ZDBSlideshowToolbar", 5);//NO I18N
    if(!parent){
        this.toggleSlideInterval(event, 'none');//NO I18N
        this.toggleSlideViewList(event, 'none');//NO I18N
    }
}

__ZRSlideClass.prototype.attachEventHandlersToController = function(){
    var controller = this.controller;
    controller.playNPauseBtn.addEventListener("click", function(event){this.toggleSlidePlay(event)}.bind(this));
    controller.slideIntervalBtn.addEventListener("click", function(event){this.toggleSlideViewList(event,'none');this.toggleSlideInterval(event)}.bind(this));
    controller.enterFullScreenBtn.addEventListener("click", function(event){this.toggleFullScreen(event)}.bind(this));
    controller.prevSlideBtn.addEventListener("click", function(event){this.handlePreviousSlideMovement(event)}.bind(this));
    controller.nextSlideBtn.addEventListener("click", function(event){this.handleNextSlideMovement(event)}.bind(this));
    controller.slideViewsHolder.addEventListener("click", function(event){this.toggleSlideInterval(event,'none');this.toggleSlideViewList(event)}.bind(this));
    controller.slideIntervalInputGetter.addEventListener("keyup", function(event){this.handleIntervalChange(event)}.bind(this));
    controller.slideIntervalInputGetter.addEventListener("blur", function(event){this.handleIntervalChange(event)}.bind(this));
    document.body.addEventListener("mousemove", function(){this.resetMouseInfo()}.bind(this));
    document.body.addEventListener("keyup", function(event){this.handleSlideKeyup(event)}.bind(this));
    document.body.addEventListener("click", function(event){this.hideIntervalNViewList(event)}.bind(this));
    var slideViewLIs = this.controller.listUL.querySelectorAll("li");
    for(var i=0,len=slideViewLIs.length; i<len; i++){
        slideViewLIs[i].addEventListener("click", function(event){this.gotoView(event.target)}.bind(this));
    }
    this.addToolTipEvents([controller.playNPauseBtn, controller.slideIntervalBtn, controller.enterFullScreenBtn, controller.prevSlideBtn, controller.nextSlideBtn]);
};

__ZRSlideClass.prototype.addToolTipEvents = function(el){
    if(el instanceof Array){
        for(var i=0, len=el.length; i<len; i++){
            el[i].addEventListener("mouseenter", function(event){ZDBToolTip.show(event.target,event);});
            el[i].addEventListener("mouseleave", function(event){ZDBToolTip.hide(event, true);});
        }
    }
    else{
        el.addEventListener("mouseenter", function(event){ZDBToolTip.show(event.target,event);});
        el.addEventListener("mouseleave", function(event){ZDBToolTip.hide(event, true);});
    }
};

__ZRSlideClass.prototype.getSlideShowController = function(slideViews){
    //ignorei18n_start
    var domCreator = new ZRDOMManipulator();
    var baseHolder = domCreator.getDivWithGivenOptions({id:"ZDBSlideshowToolbar", style:{display:"none"}});
    var btnArea = domCreator.getDivWithGivenOptions({class:"zdbButtonArea zdbSlideshowBtn"});
    var separator = domCreator.getDivWithGivenOptions({class:"zdbSeparator"});
    var playNPauseBtnOuterDiv = btnArea.cloneNode(false);
    var playNPauseBtn = domCreator.getDivWithGivenOptions({class:"zdbPlayButton", tip:ZDBI18NMap.g("zrpt.publish.slideshow.js.play_pause")});
    playNPauseBtnOuterDiv.appendChild(playNPauseBtn);
    baseHolder.appendChild(playNPauseBtnOuterDiv);
    baseHolder.appendChild(separator.cloneNode(false));
    baseHolder.playNPauseBtn = playNPauseBtn;
    var slideIntervalOuterDiv = btnArea.cloneNode(false);
    var slideIntervalBtn = domCreator.getDivWithGivenOptions({class:"zdbIntervalButton", tip:ZDBI18NMap.g("zrpt.publish.slideshow.js.slideinterval")});
    var slideIntervalInput = domCreator.getDivWithGivenOptions({style:{display:"none"}, id:"ZDBIntervalContainer"});
    var slideIntervalInputChild1 = domCreator.getDiv();
    var slideIntervalTitle = domCreator.getSpan();
    slideIntervalTitle.textContent = ZDBI18NMap.g("zrpt.publish.slideshow.js.interval");
    var slideIntervalInputGetter = domCreator.getInputWithGivenOptions({style:{width:"48px"}, type:"number", min:this.minInterval, max:300, value:this.jsonData.INTERVAL, placeholder:''});
    slideIntervalInputChild1.appendChild(slideIntervalTitle);
    slideIntervalInputChild1.appendChild(slideIntervalInputGetter);
    var pointers1 = domCreator.getSpanWithGivenOptions({class:"ZRPointerBottomBefore", style:{left: "36px", top:"56px"}});
    var pointers2 = domCreator.getSpanWithGivenOptions({class:"ZRPointerBottomAfter", style:{left: "36px", top:"56px"}});
    slideIntervalInput.appendChild(slideIntervalInputChild1);
    slideIntervalInput.appendChild(pointers1);
    slideIntervalInput.appendChild(pointers2);
    slideIntervalOuterDiv.appendChild(slideIntervalBtn);
    slideIntervalOuterDiv.appendChild(slideIntervalInput);
    baseHolder.appendChild(slideIntervalOuterDiv);
    baseHolder.appendChild(separator.cloneNode(false));
    baseHolder.slideIntervalBtn = slideIntervalBtn;
    baseHolder.slideIntervalInputGetter = slideIntervalInputGetter;
    baseHolder.slideIntervalInput = slideIntervalInput;
    var enterFullScreenOuterDiv = btnArea.cloneNode(false);
    var enterFullScreenBtn = domCreator.getDivWithGivenOptions({class:"zdbFullscreen", tip:ZDBI18NMap.g("zrpt.publish.slideshow.js.enter_leave_fullscreen")});
    enterFullScreenOuterDiv.appendChild(enterFullScreenBtn);
    baseHolder.appendChild(enterFullScreenOuterDiv);
    baseHolder.appendChild(separator.cloneNode(false));
    baseHolder.enterFullScreenBtn = enterFullScreenBtn;
    var prevSlideOuterDiv = btnArea.cloneNode(false);
    var prevSlideBtn = domCreator.getDivWithGivenOptions({class:"zdbPrevSlide", tip:ZDBI18NMap.g("zrpt.publish.slideshow.js.prev_view")});
    prevSlideOuterDiv.appendChild(prevSlideBtn);
    baseHolder.appendChild(prevSlideOuterDiv);
    baseHolder.appendChild(separator.cloneNode(false));
    baseHolder.prevSlideBtn = prevSlideBtn;
    var slideViewsHolder = domCreator.getDivWithGivenOptions({class:"zdbButtonArea zdbSlideshowBtn highLightOnHover", style:{width: "170px"}});
    var slideNumber = domCreator.getDivWithGivenOptions({style:{width:"88%", marginTop:"2px", cursor:"pointer"}, class:"ellipsis"});
    var downArrow = domCreator.getDivWithGivenOptions({class:"zdbDownArrow", style:{position:"absolute", bottom: "11px", right: "45px"}});
    // var slideInfoBox = domCreator.getDivWithGivenOptions({style:{display:"none"}, class:""});
    var slideInfoInnerDiv = domCreator.getDivWithGivenOptions({class:"zdbSlideInfoBox", style:{display:"none"}});
    var listUL = domCreator.getUL();
    for(var i=0, len=slideViews.length; i<len; i++)
    {
        var curView = this.jsonData.VIEWSINFO[slideViews[i]];
        var dName = (i + 1) + ". " + curView[1];
        var li = domCreator.getLIWithGivenOptions({displayName:curView[1], objID:curView[0]});
        li.textContent = dName;
        listUL.appendChild(li);
    }
    var pointers3 = domCreator.getSpanWithGivenOptions({class:"ZRPointerBottomBefore", style:{left: "120px"}});
    var pointers4 = domCreator.getSpanWithGivenOptions({class:"ZRPointerBottomAfter", style:{left: "120px"}});
    slideInfoInnerDiv.appendChild(listUL);
    slideInfoInnerDiv.appendChild(pointers3);
    slideInfoInnerDiv.appendChild(pointers4);
    
    slideViewsHolder.appendChild(slideNumber);
    slideViewsHolder.appendChild(downArrow);
    // slideViewsHolder.appendChild(slideInfoBox);
    baseHolder.appendChild(slideViewsHolder);
    baseHolder.appendChild(slideInfoInnerDiv);
    baseHolder.appendChild(separator.cloneNode(false));
    baseHolder.listUL = listUL;
    baseHolder.slideNumber = slideNumber;
    baseHolder.slideInfoBox = slideInfoInnerDiv;
    baseHolder.slideViewsHolder = slideViewsHolder;
    var nextSlideOuterDiv = btnArea.cloneNode(false);
    var nextSlideBtn = domCreator.getDivWithGivenOptions({class:"zdbNextSlide", tip:ZDBI18NMap.g("zrpt.publish.slideshow.js.next_view")});
    nextSlideOuterDiv.appendChild(nextSlideBtn);
    baseHolder.appendChild(nextSlideOuterDiv);
    baseHolder.nextSlideBtn = nextSlideBtn;
    return baseHolder;
    //ignorei18n_end
};

var ZDBSlideshow = new __ZRSlideClass();
