/* $Id$ */
jQuery(function($){
	// _lastVisited = undefined;
	_lastVisitedMenu = undefined;
	_lastVisitedPopover = undefined;
	$.ZContextMenu = function(ele){
		bindEvents($(ele));
		initScrollWidth();
	}
	var components = {
		zcolorpicker:{
			events:'zcolorpickercolorpanmouseover zcolorpickercolorpanmouseout zcolorpickerbeforeopen zcolorpickeropen zcolorpickerbeforeclose zcolorpickerbeforeotherusedcoloradd zcolorpickerotherusedcoloradd zcolorpickerbeforefocus zcolorpickerfocus zcolorpickerblur zcolorpickerclose', //No I18N
			selectEvent: 'zcolorpickerchange' //No I18N
		}
	}
	$.ZContextMenu.hidingMenu = true;
	bindEvents = function(jele) {
		jele.on("click.zcontextmenu", function(ev, data){ // No I18N
			var tar = $(ev.target);
			if(tar.closest(".zmenu").length || tar.closest(".zpopover__content").length){	// No I18N
				return;
			}
			$.ZContextMenu.isColorpaletteShowing = false;
			$.ZContextMenu.hidingMenu = true;
			setTarget(ev);
			mouseClicked(ev, data);
		});
		jele.on("contextmenu.zcontextmenu", function(ev, data){ // No I18N
			setTarget(ev);
			rightClicked(ev, data);
		});
		$(".zdialog").on("zdialogdragstart.zcontextmenu", function(ev){	// No I18N
			mouseClicked(ev);
		});
		ZComponents.$document.on("zbuttonsetselectionchange", function(e, ui){ // No I18N
			if(canAssociationHappen(ui)){
				handleAssociatedObjects($(e.target), ui);
			}
		}).on("zmenuitemclick", function(e, ui){ //No I18N
			if(canAssociationHappen(ui)){
				handleAssociatedObjects(ui.menuitem);
			}
		}).on("tabselect", function(e, ui){ //No I18N
			if(canAssociationHappen(ui)){
				handleAssociatedObjects(ui.tab);
			}
		}).on("zselectboxitemclick", function(e, ui){ //No I18N
			// select box item click is binded separately since menu item click event will be prevented from select box component.
			if(canAssociationHappen(ui)){
				handleAssociatedObjects(ui.menuitem);
			}
		});
	}
	setTarget = function(ev){
		if(ev.target.correspondingElement) { // If the target is SVGElementInstance object.
			ev.target = ev.target.correspondingElement;	
		}
	}
	function initScrollWidth(){
		var scrollEle = $("<div>").css({"width": "100px", "height": "100px","overflow": "scroll"}).appendTo("body"); 
		var scrollWidth = scrollEle.width()-scrollEle[0].scrollWidth;
		scrollEle.remove();
		$.ZContextMenu.scrollWidth = scrollWidth;
	}
	function canAssociationHappen(data){
		return !data.fromDataBinding;
	}
	function mouseClicked(ev, data){
		if(!data){
			data = {};
		}
		if(ev.button && ev.button != 0){
			return;
		}
		var ele = _getClickedElement(ev);
		if(ele.is("input[type=file]")){	//No I18N
			return;
		}
	    
		if(canAssociationHappen(data)){
			handleAssociatedObjects(ele);
		}
		var res = performMenuAction(ev, "data-menu-id");	// No I18N
		if(!res){ // got a popup...
			return res;
		}
		else{
			var res = performMenuAction(ev, "data-popover-id");	// No I18N
			if(!res){// got a popup...
				return res;
			}
			res = performMenuAction(ev, "toolbar"); // No I18N
			if(!res){
				return res;	
			}
		}
		if( $.ZContextMenu.colorpaletteRegistered ){
			return performMenuAction(ev, "colorpalette"); // No I18N
		}
		return performMenuAction(ev, "data-colorpicker-id"); // No I18N
	}
	function rightClicked(ev, data){
		ev.data = data;
		if(data && data.target){
			ev.target = data.target;
		}
		$(".zmenu").length && $(".zmenu").zmenu("hide");
		return performMenuAction(ev, "data-context",undefined, true); //No i18n
	}
	function _getButtonIfClickedInsideButton(ele){
		if(ele.parent().is("button")){
			return ele.parent();
		}
		return ele;
	}
	function _isObjInArray(processedArray, ele){
		var isInArray = false;
		$.each(processedArray, function(i, pele){
			if(pele == ele[0]){
				isInArray = true;
				return false;
			}
		});
		return isInArray;
	}
	function handleAssociatedObjects(ele, data, processedArray){
		setTimeout(function(){
			_handleAssociatedObjects(ele, data, processedArray);
		}, 10);
	}
	function _handleAssociatedObjects(ele, data, processedArray){
		var click = !data? true: false;
		data = data? data: {};
		var associationAttr = "data-association"; // No I18N
		var selector = "["+associationAttr+"]"; // No I18N

		ele = ele.is(selector)? ele: $(ele.parents(selector).get(0));
		// returning back if disabled for click
		if(!ele.length || ((data && data.disabled == undefined) || ele.is(':disabled'))){ // No I18N
			return;
		}
		if(processedArray){
			if(_isObjInArray(processedArray, ele)){
				return;
			}
		}else{
			processedArray = [];
		}

		processedArray.push(ele[0]);

		var associatedSelectors = ele.attr(associationAttr);
		var associatedObjs = $(associatedSelectors);
		associatedObjs.each(function(i, obj){
			if(obj == ele[0]){// Same Element...
				return;
			}
			if(_isObjInArray(processedArray, $(obj))){
				return;
			}
			obj = $(obj);
			var edata = {"fromDataBinding": true}; // No I18N
			if(typeof data.visible !== undefined){ 
				if(obj.is("input, button") && obj.zbutton("getElement").hasClass("zbutton")){
					obj = obj.parent().hasClass('zbutton--split')? obj.parent(): obj.zbutton('getElement'); // No I18N
					obj[data.visible? 'show': 'hide']();  // No I18N
				}else{
					var menu = obj.closest('.zmenu'); // No I18N
					if(menu.length){
						menu.zmenu("updateMenuItems",['#'+obj.attr('id')],"hidden",(data.visible ? true: false)); // No I18N
					}else{
						obj[data.visible ? 'show': 'hide'](); // No I18N
					}
				}
			}
			if(typeof data.disabled !== undefined){
				if(obj.is('input, button') && obj.zbutton('getElement').hasClass('zbutton')){
					obj.zbutton("option","disabled",data.disabled ? true : false); // No I18N
				}else{
					var menu = obj.closest('.zmenu'); // No I18N
					if(menu.length){
						menu.zmenu("updateMenuItems",['#'+obj.attr('id')],"disabled",(data.disabled ? true: false)); // No I18N
					}else{
						obj[data.disabled? 'disable': 'enable'](false, true, edata); // No I18N
					}
				}
			}
			if(typeof data.checked !== undefined){
				//assuming its a button getElement
				if(ele.is('[checked]') || ele.is('input[type=checkbox]') || ele.is('input[type=radio]')){
					//Extra check to ensure consistant states
					var isChecked = ele.is(':checked'); // No I18N
					if(obj.is('.zmenu__item')){
						obj.data('checked', isChecked); // No I18N
						var menu = obj.closest('.zmenu'); // No I18N
						menu.zmenu("updateMenuItems",[obj],"checked",isChecked); // No I18N
					}else{
						obj.attr('checked', isChecked); // No I18N
					}
				}
				if(obj.is('input, button')){
					if(obj.data('zbuttonset')){	// No I18N
						obj.buttonset('destroy'); // No I18N
						obj.buttonset();
					}
					else if(obj.data('zbutton')) {	// No I18N
						obj.button('destroy');	// No I18N
						obj.button();
					}
				}
			}
			if(click){
				obj.trigger('click', edata); // No I18N
			}

			handleAssociatedObjects(obj, data, processedArray);
		});
	}
	function _getClickedElement(ev){
		var ele = (ev.data && ev.data.target)? ev.data.target: ev.srcElement;
		if(!ele){
			ele = $(ev.target);
		}else{
			var cele = ele.correspondingElement;
			if(cele){
				ele = $(cele);
			}
		}
		return $(ele);
	}
	function stopEvent(ev){
			ev.stopPropagation();
			ev.preventDefault();
	}
	function isDisabled(ele){
		if(ele.is('input,button,textarea,select')){
			return ele.is(':disabled')  // No I18N
		}else{
			return ele.hasClass('is-disabled'); // No I18N
		}
	}
	function performMenuAction(ev, attr, pos, isRightClick){
		var lastMenu = $.ZContextMenu.currentMenu, lastPopover = $.ZContextMenu.currentPopover;
		if(!$.ZContextMenu.hideMenu(ev)){
			return false;
		}
		var ele = _getClickedElement(ev);
		ele = _getButtonIfClickedInsideButton($(ele));
		var obj = traverseAndGetContextElement(ele, attr);
		/* hide opened colorpalette */
		if($.ZContextMenu.colorpaletteRegistered && attr != "colorpalette"){	//No I18N
			$.ZContextMenu.colorpalette.zcolorpalette('hide');	//No I18N
		}
		// {'element' : targetElement, 'attr' :  menu/colorpallette/popover}
		var cmenu = obj.attr;
		ele = obj.element;
		
		if(isDisabled(ele)){	// If the target element is disabled, Do nothing - continue with the next work (return true).
			return true;
		}
		/*Display colorpalette*/
		if(cmenu && attr === 'colorpalette'){	// No I18N
			if(ele.length){
				$.ZContextMenu.displayColorPalette(ele, true);
			}
			return;
		}
		if(cmenu && attr === 'data-colorpicker-id'){	// No I18N
			if( ele.length ){
				$.ZContextMenu.toggleColorPicker( ele );
			}
			return;
		}

		$.ZContextMenu.closePopover(ev);
		if(cmenu){
			var menu = $("#"+cmenu); 
			if(attr === 'toolbar' && !menu.length){ // No I18N
				var toolbar = $(ele.parent().metadata().relatedTabPane);
				if(toolbar.hasClass('ui-ztoolbar-panel')){ 
					menu = toolbar.ztoolbar('getToolbarAsMenu'); // No I18N
					menu.attr('relativeto', 'parent'); // No I18N
					$(ele).attr('data-menu-id', $(ele).attr('toolbar')).removeAttr('toolbar'); // No I18N
				}
			}

			if(lastMenu && lastMenu[0] == menu[0] && this._lastVisitedMenu[0] === ele[0]){	// (Same Menu for Same Button && Same Menu for Different Button)
				if(menu.data("toggle")){
					stopEvent(ev);
					return false;
				}
			}
			this._lastVisitedMenu = ele;
		
			if(attr == 'data-popover-id'){	//No I18N
				menu.off("zpopoverclose.zeventhandler").on("zpopoverclose.zeventhandler", function(orgEvent){  //No I18N
					var target;
					orgEvent = orgEvent.originalEvent;
					if(orgEvent && (target = orgEvent.target)){
						if(target !== $.ZContextMenu._lastVisitedPopover[0]){
							$.ZContextMenu._lastVisitedPopover = undefined;
						}
					}					
				});
				if(lastPopover && lastPopover[0] == menu[0] && $.ZContextMenu._lastVisitedPopover && $.ZContextMenu._lastVisitedPopover[0] === ele[0] ){	// (Same Menu for Same Button && Same Menu for Different Button)
					$.ZContextMenu._lastVisitedPopover = undefined;
					stopEvent(ev);
					return false;
				}
				options = $.extend({}, ZComponents.getOptions(menu));
				if($.ZContextMenu._lastVisitedPopover){
					if($("#"+ $.ZContextMenu._lastVisitedPopover.attr('data-popover-id')).is(":visible")){ // No I18N
						$("#"+ $.ZContextMenu._lastVisitedPopover.attr('data-popover-id')).zpopover( 'close' ); // No I18N
					}
				}
				if($.ZContextMenu._lastVisitedPopover === undefined || $.ZContextMenu._lastVisitedPopover && $.ZContextMenu._lastVisitedPopover[0] !== ele[0]){
					if(!menu.data('zpopover')){	//No I18N
						if(options.forElement === '' || options.forElement === undefined ){	//No I18N
							options.forElement = ele;
						}
						options.content = menu;
						options.popOn = "none"; // No I18N
						menu.zpopover( options );
					}
					menu.zpopover("setAttribute","forElement",ele); // No I18N
					menu.zpopover('open');	//No I18N
					$.ZContextMenu.currentPopover = menu;
					$.ZContextMenu._lastVisitedPopover = ele; 					
				}
			}
			else{
				$.ZContextMenu.showMenu(menu, ele, pos, ev, isRightClick);
				$.ZContextMenu._lastVisitedPopover = undefined;
			}
			stopEvent(ev);
			return false;	// Do not go further, there is a menu/colorpallete/popover to be opened.
		}
		return true; // Nothing found - continue with your job
	}


	function getRelatedMenu(ele, attr){
		var cmenu = ele.metadata();
		cmenu = cmenu[attr];
		cmenu = (cmenu)? cmenu: ele.attr(attr);
		return cmenu;
	}
	function traverseAndGetContextElement(ele, attr){
		var selector = "["+attr+"]";
		ele = ele.is(selector)? ele: $(ele.parents(selector).get(0));
		return {"element": ele, "attr": ele.attr(attr)}; //No i18n
	}
	function getRelativeToEle(menu, targetElement){
		var relativeTo = menu.attr("relativeto"); // No I18N
		if(relativeTo){
			var route = relativeTo.split(".");
			var base = targetElement;
			for(var i=0; i<route.length; i++){
				try{
					var _base = base[route[i]]();
					if(!_base || !_base.length){
						break;
					}
				}catch(e){
					break;
				}
				base = _base;
			}
			if(base){
				targetElement = base;
			}
		}
		return targetElement;
	}
    $.ZContextMenu.highlightItem = function(tar, remove){
    	var meta = ZComponents.getOptions(tar);
		if(tar.is('.zcolorchooser') || (meta.highlightOnMenuShow === false)){
			return;
		}
		var fn = remove? 'removeClass': 'addClass'; // No I18N
		var classNm = meta.activeClass ? meta.activeClass : 'ui-state-highlight';	// No I18N
		var classOp = 'ui-state-open';	// No I18N
		tar[fn](classNm);
		var targetParent = tar.parent();
		if(targetParent){
			targetParent[fn](classOp);
			if(targetParent.is('.zbutton--split')){	// No I18N
				targetParent[fn](classNm);
			}
		}
	}
	$.ZContextMenu.showMenu =  function(cmenu, ele, pos, ev, isRightClick){
		if(!cmenu || !cmenu.length || $(ele).data("zmenubutton")){  // No I18N
			return false;
		}

		var options = {};
		var _data = ZComponents.getOptions(cmenu);
		if(_data){
			options = _data;
		}
		if(!isRightClick){
			cmenu.one("zmenushow.zcontext", function(e, ui){ // No I18N
				if(!ui.skipHighlightTarget){
					$.ZContextMenu.highlightItem($(ui.forElement));
				}
			});
			cmenu.one("zmenuhide.zcontext",function(e,ui){ // No I18N
				if(!ui.skipHighlightTarget){
					$.ZContextMenu.highlightItem($(ui.forElement), true);
				}
			});
		}else{
			options.direction = "after-pointer"; // No I18N
		}

		cmenu.zmenu(options);
		$.ZContextMenu.currentMenu = cmenu;
		cmenu.zmenu("show", { // No I18N
			'currentTarget': ev.target, // No I18N
			'forElement': ele, // No I18N
			'event': ev, // No I18N
            'isRightClick': isRightClick // No I18N
		});

		$.ZContextMenu._isMenuShowing = true;
		$.ZContextMenu.hidingMenu = false;

		cmenu.one("zmenuhide.zcontext", function(e, ui){ // No I18N
			var tar = $(ui.currentTarget).closest('.zbutton').length? $(ui.currentTarget).closest('.zbutton'): $(ui.forElement); // No I18N
			$.ZContextMenu.highlightItem(tar, true);

			$.ZContextMenu.currentMenu = undefined;
			$.ZContextMenu._isMenuShowing = false;
		});
		return true;
	}
	$.ZContextMenu.hideMenu = function(ev){
		if(($.ZContextMenu.currentMenu && $.ZContextMenu._isMenuShowing) || ($.ZContextMenu.colorpalette && $.ZContextMenu.colorpalette.is(':visible')) || ($.ZContextMenu.colorpicker && $.ZContextMenu.colorpicker.is(':visible'))){
			if($.ZContextMenu.currentMenu && $.ZContextMenu.currentMenu.hasClass('zmenu')){
				$.ZContextMenu.currentMenu.zmenu("hide"); // No I18N
			}else{
				$.ZContextMenu.isColorpaletteShowing=true;
			}
			$.ZContextMenu._isMenuShowing = false;
			$.ZContextMenu.currentMenu = undefined;
			if(ev && $.ZContextMenu.consumeEventOnMenuHide){
				ev.stopPropagation();
				ev.preventDefault();
				return false;
			}
		}
		return true;
	}
	
	$.ZContextMenu.currentMenu = undefined;
	$.ZContextMenu._colorpaletteHoveredMenuItem = undefined;
	$.ZContextMenu._isMenuShowing = false;
	$.ZContextMenu.colorpalette = undefined;
	$.ZContextMenu.colorpicker = undefined;
	$.ZContextMenu.windowElement = $(window);
	$.ZContextMenu._documentElement = $(document);
	$.ZContextMenu.windowWidth = $.ZContextMenu.windowElement.width();
	$.ZContextMenu.windowHeight = $.ZContextMenu.windowElement.height();
	$.ZContextMenu.colorpaletteRegistered = false;

	$.ZContextMenu.displayMenuComponents = function(event, ui){
		if($.ZContextMenu._colorpaletteHoveredMenuItem){
			$.ZContextMenu.displayColorPalette(undefined, undefined, false);
			$.ZContextMenu._colorpaletteHoveredMenuItem = undefined;
		}
		var itemData = ui.menuitem.metadata();
		if(itemData.colorpalette){
			var itemObj = $(ui.menuitem);
			var targetEle = $(itemData.relatedButton);
			targetEle = targetEle.data('menuButton') ? targetEle.data('menuButton') : targetEle;	// No I18N
			itemObj.addClass("on-hover");	// No I18N
			var _options = (itemData.colorpaletteOptions)? itemData.colorpaletteOptions: {};
			var selectedColor = $.data($(targetEle)[0], 'selectedColor');	// No I18N
			selectedColor = (selectedColor && selectedColor != 'transparent')? selectedColor: false;	// No I18N
			var colorpalette = $.ZContextMenu.colorpalette;
			(_options.relativeto)? colorpalette.attr('relativeto',_options.relativeto): colorpalette.removeAttr('relativeto');	//No I18N
			options = $.extend({}, _options, {'relativeToEle': targetEle, 'selectedColor': selectedColor});	// No I18N
			$.ZContextMenu.colorpalette.one('colorpaletteshow', function(e, ui){	// No I18N
				var position = $.ZContextMenu.adjustElementPosition({bufferWidth: (itemObj.width() + colorpalette.width()), bufferHeight: (colorpalette.height() - itemObj.outerHeight()), top: itemObj.offset().top, left: (itemObj.offset().left + itemObj.width()), width : colorpalette.width(), height : colorpalette.height()});
				$.ZContextMenu.colorpalette.addClass('ui-zcolorpalette-menu-popover');	// No I18N
				$.ZContextMenu.colorpalette.css({ top: position.top, left: position.left});
			});
			$.ZContextMenu._colorpaletteHoveredMenuItem = itemObj;
			$.ZContextMenu.colorpalette.one('mouseenter', function(e, ui){	// No I18N
				if($.ZContextMenu._colorpaletteHoveredMenuItem){
					$.ZContextMenu._colorpaletteHoveredMenuItem.addClass('ui-state-hover');	// No I18N
				}
			});
			itemObj.one('mouseleave', function(e, ui){	// No I18N
				if(colorpalette.is(":visible") && $.ZContextMenu._colorpaletteHoveredMenuItem){
					$.ZContextMenu._colorpaletteHoveredMenuItem.addClass('ui-state-hover');	// No I18N
				}
			});
			colorpalette.zcolorpalette('show', targetEle, options);	// No I18N
		}
	}
	$.ZContextMenu.adjustElementPosition = function(eleOffet){
        if(($.ZContextMenu.windowWidth - (eleOffet.left + eleOffet.width + $.ZContextMenu.scrollWidth)) < 5){
            eleOffet.left = eleOffet.left - eleOffet.bufferWidth;
        }
        if(($.ZContextMenu.windowHeight - (eleOffet.top + eleOffet.height + $.ZContextMenu.scrollWidth)) < 5){
            eleOffet.top = eleOffet.top - eleOffet.bufferHeight;
            if(eleOffet.top < 0){

            	eleOffet.top = ($.ZContextMenu.windowHeight - eleOffet.height) - 5;
            }
        }
        return eleOffet;
	}
	$.ZContextMenu.toggleColorPicker = function( target, colorpicker, options ){
		var colorpicker = $('#'+target.attr('data-colorpicker-id')); //No I18N
		var events = components.zcolorpicker.events.replace(/  +/g, ' ').split(' ').join('.zcolorfield '); //No I18N
		var selectEvent = components.zcolorpicker.selectEvent+'.zcolorfield'; //No I18N
		colorpicker.off('.zcolorfield'); //No I18N
		if( colorpicker.is(':visible') && target.is( $.ZContextMenu.lastPickerTarget ) ){ //No I18N
			colorpicker.zcolorpicker('close'); //No I18N
		}else{
			target = $(target);
			options = ZComponents.getOptions( target ).colorpickerOptions || {};
			$.ZContextMenu.lastPickerTarget = options.forElement = target;
			options.value = target.data('selectedColor') || $.zcolorpicker.prototype.options.defaultValue; //No I18N
			colorpicker.zcolorpicker('setAttributes', options); //No I18N
			colorpicker.zcolorpicker( 'open' ); //No I18N
			colorpicker.on( selectEvent,function(origEvent, customData){
							target.trigger( origEvent.type, customData );
							target.data( 'selectedColor', customData.color );	// No I18N
						}).on( events,function(origEvent, customData){
							target.trigger( origEvent.type, customData);
						}).on('zcolorpickerclose.zcolorfield', function(){ //No I18N
							colorpicker.off('.zcolorfield'); //No I18N
						});
		}
	},
	$.ZContextMenu.registerColorpalette = function(options){
		if(!$.ZContextMenu.colorpalette){
			options = options || {};
			options.closeOnBodyClick = false;
			$.ZContextMenu.colorpalette = $("<div>").css('display','none').appendTo('body')
										.zcolorpalette( options ) 
										.on('zcolorpalettecolorselected',function(origEvent, customData){ // No I18N
											$.ZContextMenu.lastPaletteTarget.trigger( 'zcolorpalettecolorselected', customData ).data( 'selectedColor', customData.color );	// No I18N
										}).on('zcolorpalettehover zcolorpaletteshow',function(origEvent, customData){	// No I18N
											$.ZContextMenu.lastPaletteTarget.trigger( origEvent.type, customData);
										}).on('zcolorpalettehide', function(origEvent, customData){
											$.ZContextMenu.lastPaletteTarget.trigger( origEvent.type, customData);
											if( origEvent.originalEvent && $( origEvent.originalEvent.currentTarget ).closest( $.ZContextMenu.colorpalette  ).length ){
												$.ZContextMenu.lastPaletteTarget && $.ZContextMenu.lastPaletteTarget.focus();
											}
										});
			$.ZContextMenu.defaultPaletteOptions = $.ZContextMenu.colorpalette.zcolorpalette('options');//No I18N
			$.ZContextMenu.colorpaletteRegistered = true;
		}
	}
	$.ZContextMenu.destroyColorPalette = function(){
		if( $.ZContextMenu.colorpalette ){
			$.ZContextMenu.colorpalette.zcolorpalette('destroy');	//No I18N
			$.ZContextMenu.colorpalette = $.ZContextMenu.colorpaletteRegistered = null;
		}
	}
	$.ZContextMenu.hideColorPalette = function(){
		clearTimeout( $.ZContextMenu.colorpaletteHideTimer );
		// $.ZContextMenu.colorpalette && $.ZContextMenu.colorpalette.zcolorpalette('close', true);	//No I18N
		$.ZContextMenu.colorpalette && $.ZContextMenu.colorpalette.zcolorpalette('hide', true);	//No I18N
		// this._lastVisited = undefined;
	}	
	$.ZContextMenu.displayColorPalette = function(target, options){
		clearTimeout( $.ZContextMenu.colorpaletteHideTimer );
		target = $(target);
		var colorpalette = $.ZContextMenu.colorpalette;
		if( colorpalette && target.length ){
			var initElement = target.hasClass('ui-zcolorchooser')? target.prev(): target;	//No I18N
			$.ZContextMenu.lastPaletteTarget = target;
	 		var options = ZComponents.getOptions( $(initElement) );
	 		options = options.colorpaletteOptions || {};
			var selectedColor = target.data('selectedColor');//No I18N
			options.selectedColor = selectedColor!== 'transparent' && selectedColor? selectedColor : false; //No I18N
	 		options.relativeToEle = $(target);
	 		var display = true;
			if($.ZContextMenu.isColorpaletteShowing){
				if(this._lastVisited && this._lastVisited[0] === target[0] ){
					display=false;
				}
			}
			this._lastVisited=target;
			colorpalette.zcolorpalette(display? 'show': 'hide', $(target), options ); // No I18N
		}
	},
	$.ZContextMenu.closePopover = function (ev){
		var target = $(ev.target);
		if($.ZContextMenu.currentPopover && target.closest(".zpopover").length === 0){  // No I18N
			var metadata = $.ZContextMenu.currentPopover.data().zpopover, bodyClick = metadata.options.closeOnBodyClick,
				forElement = metadata._forElement;
			if(bodyClick  || target.closest(forElement).length){
				//$.ZContextMenu._isPopoverClosed = true;
				$.ZContextMenu.currentPopover.zpopover( 'close' );	// No I18N

				if(target.closest($.ZContextMenu._lastVisitedPopover).length === 0){
					$.ZContextMenu.currentPopover = $.ZContextMenu._lastVisitedPopover = undefined;
				}

			}
		}
	}
	$.fn.zcontextmenu = function(){
		$.ZContextMenu(this);
		ZComponents.$window.on('resize.zcontextmenu', function(ev){ // No I18N
			window.setTimeout(function(){
				$.ZContextMenu.hideMenu();
				$.ZContextMenu.closePopover(ev);	
			},300);
		});
    }
	$(document).zcontextmenu();
});
