/* $Id$ */
var ZShortCut = (function($, $Z){
	var broswerObj = $Z.Browser,
		allowedModifiers = ["ctrl","cmd","shift","alt"],	 // No I18N
		isMac = broswerObj.isMac(),
		isWindows = broswerObj.isWindows(),
		allKeys = {},
		keyMap = {},
		options = {},
		isShortcutEnabled = true,
		keyUpBinded = false,
		spCharArr= {
			"<F1>": "112",	// No I18N
			"<F2>": "113",	// No I18N
			"<F3>": "114", 	// No I18N
			"<F4>": "115", 	// No I18N
			"<F5>": "116", 	// No I18N
			"<F6>": "117", 	// No I18N
			"<F7>": "118", 	// No I18N
			"<F8>": "119", 	// No I18N
			"<F9>": "120",	// No I18N
			"<F10>": "121", // No I18N	
			"<F11>": "122", // No I18N
			"<F12>": "123",	// No I18N
			"PRINTSCREEN": "44", // No I18N
			"NUMLOCK": "144", // No I18N
			"PAUSE": "19", // No I18N
			"INSERT": "45", // No I18N
			"HOME": "36", // No I18N
			"PAGEUP": "33",	// No I18N
			"PAGEDOWN": "34", // No I18N
			"DELETE": "46", // No I18N
			"END": "35",// No I18N
			"TAB": "9", 	// No I18N
			"CAPSLOCK": "20", // No I18N
			"WINDOWS": "91",// No I18N
			"ARROW_UP": "38", // No I18N
			"ARROW_DOWN": "40", // No I18N
			"ARROW_LEFT": "37", // No I18N
			"ARROW_RIGHT": "39", // No I18N
			"ENTER": "13", // No I18N
			"BACKSPACE": "8", // No I18N
			'SPACE': "32", // No I18N
			"ESCAPE": "27",// No I18N
			"DOT": "190", //key - .  Dot, Delete  keys have the same keycode. '.'.charCodeAt(0) = 46, keyCode for delete = 46. In this case we have to consider dot as a special char like TAB, SPACE, DELETE ....    // No I18N
			".": "190", // User can register either (.) or (dot/DOT).
			"Ã‚": "226", //To handle (<)&(>) keys in same button in GERMAN keyboard.	//No I18N			
			"91": "219", //Key - \  // No I18N
			"92": "220", //key - ] // No I18N
			"93": "221", //Key - [ // No I18N
			"61": "187", //key - = // No I18N
			"45": "189", //key - - // No I18N
			"96": "192", //key - ` // No I18N
			"44": "188" ,//key - , // No I18N
			"47": "191", //key - / // No I18N
			"39": "222", //key - ' // No I18N
			"59": "186",  //key - ; // No I18N
			"123": "219", //key - |	 // No I18N
			"124": "220", //Key - }	 // No I18N
			"125": "221", //Key - {   // No I18N
			"43": "187", //Key - +    // No I18N
			"95": "189", //Key - _    // No I18N
			"126": "192", //Key - ~   // No I18N
			"60": "188" ,//Key - <    // No I18N
			"62": "190", //Key - >    // No I18N
			"63": "191", //Key - ?   // No I18N
			"34": "222", //Key - "   // No I18N
			"58": "186",//Key - :     // No I18N
			"33" : "49",  //Key - !  // No I18N
			"64" : "50", //key - @    // No I18N
			"35" : "51", //key - #   // No I18N
			"36" : "52", //key - $   // No I18N
			"37" : "53", //key - %    // No I18N
			"94" : "54", //key - ^    // No I18N
			"38" : "55", //key - &   // No I18N
			"42" : "56", //key - *    // No I18N
			"40" : "57", //key - (  // No I18N
			"41" : "48" //key - )    // No I18N
	};
	var tagNames = ["BUTTON","INPUT","TEXTAREA","OPTION","SELECT","TEXTAREA","OPTGROUP","FIELDSET"];	// No I18N
	$Z.$document.on("keydown.shortcut", function(orgEvent){	 // No I18N
		triggerShortcut(orgEvent, true);
	});
	function triggerShortcut(eventObj, isKeyDown){
		if(isShortcutEnabled && isInputElement(eventObj)){
			var keyCode = eventObj.keyCode, key ="";	// No I18N
			if(eventObj.ctrlKey){
				key = "ctrl+";	 // No I18N
			}
			if(broswerObj.isMac() && eventObj.metaKey){
				key += "cmd+";	 // No I18N
			}
			if(eventObj.shiftKey){
				key += "shift+";	 // No I18N
			}
			if(eventObj.altKey){
				key += "alt+";	 // No I18N
			}
			var charCode = String.fromCharCode(keyCode);
			if(keyCode >= 65 && keyCode <= 90){
				keyCode = charCode.charCodeAt();
			}
			var tempKey = key;
			key+=keyCode;
			var eventObject = allKeys[key];
			if(!eventObject){
				for(var i in spCharArr){
					if(spCharArr[i] === keyCode.toString()){
						key = tempKey+(i.toLowerCase());
						eventObject = allKeys[key];
						if(eventObject){
							break;
						}
					}
				}
			}
			if(eventObject){
				var shortcutKey = key,
					keyInfo = (eventObject.keyInfo || {}),
					element = (eventObject.element || ""),	// No I18N
					handleOn = eventObject.handleOn,
					isDirectInit = eventObject.isDirectInit;
					element = $(element);
				if((isDirectInit && keyInfo.disabled !== true) || 
					(element && ((isKeyDown && handleOn !== "keyup") ||	(!isKeyDown && handleOn === "keyup"))))// No I18N
				{
					if(isDirectInit){
						var elementId = keyInfo.elementIds;
						elementId = (elementId && elementId[0]);
						element = $("#"+elementId);
					}
					var isSupportDisabledAttr = element && (tagNames.indexOf(element[0].tagName) !== -1 );
					if( (isDirectInit && !element.length) ||
						(!element.is(":disabled") && isSupportDisabledAttr) || // No I18N
						(!isSupportDisabledAttr && !element.is("[disabled]"))	// No I18N
					){
						var triggerData = {
							ele: element,
							shortcutKey: eventObject.shortcutKey,
							fromShortCut: true
						};
						if(isDirectInit){
							executionFunction(keyInfo.action, element, eventObj, keyInfo.params)
						}
						else{
							if(element.is(":checkbox") && eventObject.event === "click"){	 // No I18N
								element.each(function(){
									triggerData.ele = $(this);
									$(this).triggerHandler(eventObject.event, triggerData);
								})
							}else{
								element.trigger(eventObject.event, triggerData);
							}
						}
					}
					eventObj.stopPropagation();
					eventObj.preventDefault();
				}
			}
		}
	}
	function executionFunction(callback, element, eventObj, data){
		var value = undefined;
		if(callback && typeof callback === "string"){ // No I18N
		    var executableFnc = _getAsFunction(callback);
			value = executableFnc.callable(data);
		}else{
			value = $.isFunction(callback) ? callback.apply(element, data) : undefined;
		}
		return value !== undefined ? value : !eventObj.isDefaultPrevented();
	}
	function _getAsFunction(strValue){
	    if (!strValue) { return; }

	    var _action = strValue.split("."), fn = window, base = "", methodIdx;
	    $(_action).each(function(i, action){
	        methodIdx = action.indexOf('()');
	        fn = methodIdx>0?fn[action.substring(0, methodIdx)]():fn[action];
	        if (i == _action.length-2) { base = fn; }
	    });
	    //closure issue with callable needs to be addressed
	    return {'fn': fn, 'base': base, 'callable': function(){ fn && fn.call(base,arguments[0]); }}; //No I18N
	}
	function getKey(element, keyInfo){
		keyInfo = keyInfo || $Z.getOptions(element);
		var shortcut = keyInfo.shortcutkey || keyInfo.shortcutKey || keyInfo.key;
		if(shortcut){
			var keys= (typeof shortcut === 'object' && $.isArray(shortcut)) ? shortcut : [shortcut];	 // No I18N
			for(var i=0;i<keys.length;i++){
				var key = keys[i];
				if(typeof keys[i] === 'object'){	 // No I18N
					key = !isMac ? keys[i].key : (keys[i].macKey ? keys[i].macKey : keys[i].key);
					if(!keys[i].key && !isMac){
						return false;
					}
				}
				if(key && !key.macKey && isMac){
					key = key.replace(/ctrl/i, keyInfo.skipShortcutFormat ? "Cmd": 'cmd');	 // No I18N
				}
				if(!keyInfo.skipShortcutFormat){
					key = key.toString().toLowerCase();
				}
				keys[i] = key;
			}
			return keys;
		}
	}
	function isInputElement(orgEvent){
		if(ZShortCut.discardInputElement){
			var element = $(orgEvent.srcElement);
			if(element.length === 0){
				element = $(orgEvent.target);
			}
			if(element.is("input") || element.is("textarea")){
				return false;
			}
		}
		return true;
	}
	function sortKeyCombination(key){
		var splittedKeys = key.split("+"),	 // No I18N
			arrangedKeys = "",splittedKey;	// No I18N
			key = "";	// No I18N	
		for(var i=0;i<allowedModifiers.length;i++){
			for(var j=0;j<splittedKeys.length;j++){
				splittedKey = splittedKeys[j].trim();
				if(allowedModifiers[i] === splittedKey){
					arrangedKeys += splittedKey+"+";	 // No I18N
				}else if($.inArray(splittedKey, allowedModifiers) === -1){
					key = splittedKey;
				}
				if(splittedKey === ''){	 // No I18N
					key = "+";	 // No I18N
				}
			}
		}
		if(!spCharArr[key.toUpperCase()]){
			key = key.toUpperCase().charCodeAt(0);
		}
		return (arrangedKeys += key);
	}
	function registerKey(element, key, orgEvent, handleOn, isDirectInit, keyInfo){
		var arrangedKeys = sortKeyCombination(key);
		if(arrangedKeys){
			var registerObj = {element: element, event: orgEvent, handleOn: handleOn };
			if(isDirectInit){
				registerObj.isDirectInit = true;
				registerObj.keyInfo = keyInfo;
			}
			allKeys[arrangedKeys] = registerObj;
		}
	}
	function getFormattedKey(key){
		var splitKeys = key.split("+"),	 // No I18N
			dkey = "",
			base = this;
		for(var i=0;i<splitKeys.length;i++){
			if(splitKeys[i].charAt(0) == splitKeys[i].charAt(0).toUpperCase()){
				splitKeys[i] = splitKeys[i].toUpperCase();
			}else{
				splitKeys[i] = splitKeys[i].charAt(0).toUpperCase()+splitKeys[i].substring(1, splitKeys[i].length);
			}
			if(splitKeys.length - 1 !== i){
				splitKeys[i]+="+";	 // No I18N
			}
			dkey+=splitKeys[i]
		}
		return dkey;
	}
	function bindKeyUpEvent(){
		keyUpBinded = true;
		$Z.$document.on("keyup.shortcut", function(orgEvent){	 // No I18N
			triggerShortcut(orgEvent, false);
		});
	}
	function deregisterKey(key){
		var arrangedKeys = sortKeyCombination(key);
		arrangedKeys && delete(allKeys[arrangedKeys]);
	}
	function _handleRegister(keyInfo, element, isDirectInit){
		var eventName = keyInfo.eventName || "click",	// No I18N
			handleOn = keyInfo.handleOn,
			keys = getKey(null, keyInfo);
		if(!isWindows && !keyUpBinded && handleOn === "keyup"){	// No I18N
			bindKeyUpEvent();
		}
		if(keys){
			var skipRegister =  keyInfo.skipshortcutregister || keyInfo.skipRegistration;
			for(var i=0;i<keys.length;i++){
				if(!skipRegister){
					registerKey(element, keys[i], eventName, handleOn, isDirectInit, keyInfo);
				}
				if(!keyInfo.skipShortcutFormat){
					keys[i] = getFormattedKey(keys[i]);
				}
			}
		}
		return keys ? keys : false;
	};
	return {
		discardInputElement: true,
		disableAction: function(actionName){
			var keyInfo = keyMap[actionName];
			if(keyInfo){
				keyInfo.disabled = true
			}
		},
		enableAction: function(actionName){
			var keyInfo = keyMap[actionName];
			if(keyInfo){
				keyInfo.disabled = false;
			}
		},
		addShortcuts: function(keysList){
			var keysList = (keysList instanceof Array)? keysList : [keysList],keyInfo;
			for(var i=0;i<keysList.length;i++){
				keyInfo = keysList[i];
				var newKey = _handleRegister(keyInfo, keyInfo.elements, true);
				keyMap[keyInfo.actionName] = keyInfo;
				keyMap[keyInfo.actionName].shortcutKey = newKey[0];
			}
		},
		register: function(element){
			var keyInfo = $Z.getOptions(element),
				shortcut = keyInfo.shortcutkey || keyInfo.shortcutKey;
				keyInfo.eventName = shortcut && shortcut.event ? shortcut.event : "click";	// No I18N
			return _handleRegister(keyInfo, element);
		},
		getShortcutKey: function(element){
			var keys = getKey(element);
			if(keys){
				for(var i=0;i<keys.length;i++){
					keys[i] = getFormattedKey(keys[i])
				}
				return keys;
			}
			return false;
		},
		getInfo: function(actionName, element, registerElement){
			if(actionName){
				var keyInfo = keyMap[actionName] || {};
				return keyInfo.shortcutKey || keyInfo.key || "";	// No I18N
			}
			else if(registerElement !== false && element){
				return this.register(element);
			}
			else if(element){
				return this.getShortcutKey(element);
			}
		},
		enable: function(){
			isShortcutEnabled = true;
		},
		disable: function(){
			isShortcutEnabled = false;
		},
		deregister: function(element){
			var keys = getKey(element);
			for(var i=0;i<keys.length;i++){
				deregisterKey(keys[i]);
			}
		}
	}
})(jQuery, ZComponents);
/*
	{
	action: "bold",	// No I18N
	disabled: true,
	hidden: false,
	checked: true,
	group: "",	// No I18N
	key: ""	// No I18N
	eventName: "keyup|keydown|click"	// No I18N
	handleOn: "keyup|keydown"	// No I18N
	elements:[]
}
*/
