/*$Id$*/

var DynamicThreshold = new function()
{
    this.CONSTANT_THOLD = "0";
    
    // display threshold info in settings page
    this.showTholdValues = function(propSetUtil, propName, thresInst, instId)
    {
        DynamicThreshold.setValues(thresInst.scopeEl, DynamicThreshold.getPropVal(propSetUtil,
                            propName + PropSettings.CHART_THRESHOLD_SCOPE, instId), thresInst.tScope);
        thresInst.tSelect.value = instId;
        var func = DynamicThreshold.setFuncProp(propSetUtil, propName, thresInst, instId);
        var otherColInfo = propSetUtil.getPropValue(propName, instId, PropSettings.THOLD_PROPTYPE);
        if(otherColInfo)
        {
            var colId = otherColInfo.COLID;
            if(!colId)
            {
                colId = otherColInfo.FMLCOLID;
                otherColInfo.COLID = "";
            }
            else
            {
                otherColInfo.FMLCOLID = "";
            }
            var colName = DynamicThreshold.getColName(colId);
            DynamicThreshold.setTholdEl(thresInst.parDiv, otherColInfo, colName);
        }
        
        DynamicThreshold.setValues(thresInst.formatEl, DynamicThreshold.getPropVal(propSetUtil,
                                propName + PropSettings.CHART_THRESHOLD_STYLE, instId), thresInst.tStyle);
        if(func === DynamicThreshold.CONSTANT_THOLD) {
            thresInst.tValue.value = DynamicThreshold.getPropVal(propSetUtil, propName, instId);
        }
        else {
            DynamicThreshold.onChangeFunction(thresInst.tFunc);
        }
    };
    
    this.setValues = function(selectBox, val, tdEl)
    {
        var scopeVal = parseInt(val);
        jQuery(selectBox).zselectbox("setAttribute", "selectedIndex", scopeVal); //No I18N
        tdEl.setAttribute("propvalue", val);
        tdEl.value = val;
    };
    
    this.getPropVal = function(propSetUtil, propName, instId)
    {
        var val = propSetUtil.getPropValue(propName, instId, PropSettings.DOUBLE_PROPTYPE);
        if(!val) {
            val = "0";
        }
        return val;
    };
    
    this.setFuncProp = function(propSetUtil, propName, thresInst, instId)
    {
        var func = DynamicThreshold.getPropVal(propSetUtil, propName +
                                    PropSettings.CHART_THRESHOLD_FUNCTION, instId);
        var thProp = propSetUtil.propSetForm.thresholdProp;
        ZDBUtil.setNamedChildEls(thProp, thProp);
        var funcVal = parseInt(func);
        var funcElArr = [thProp.func0, thProp.func1, thProp.func2, thProp.func3, thProp.func4];
        var funcEl = funcElArr[funcVal];
        thProp.funcDiv.innerHTML = funcEl.innerHTML;
        DynamicThreshold.setFuncEl(thresInst.tFunc, "func"+funcVal); //No I18N
        thresInst.tFunc.value = func;
        return func;
    };
    
    // on selecting constant, show input box else hide it
    this.onChangeFunction = function(el)
    {
        var tholdEl = ZDBUtil.getParentWithTagName(el, "tr"); //No I18N
        ZDBUtil.setNamedChildEls(tholdEl, tholdEl, "elname", false);
        if(el.value === '0')
        {
            tholdEl.tValue.style.display = '';
            tholdEl.funcDivPar.style.width = "80px";
        }
        else
        {
            tholdEl.tValue.style.display = 'none';
            tholdEl.funcDivPar.style.width = "196px";
        }
        var tholdBody = ZDBUtil.getParentWithTagName(el, "tbody"); //No I18N
        ZDBUtil.setNamedChildEls(tholdBody, tholdBody, "elname", false);
    };
    
    this.setFuncEl = function(funcEl, propValue)
    {
        DynamicThreshold.showTholdFunc(funcEl.getElementsByTagName("div")[0]);
        funcEl.elnameSet = false;
        ZDBUtil.setNamedChildEls(funcEl, funcEl);
        DynamicThreshold.setFunc(funcEl[propValue]);
    };
    
    this.setTholdEl = function(parDiv, otherColInfo, colName)
    {
        jQuery(parDiv).attr({"colid":otherColInfo.COLID, "fmlcolid":otherColInfo.FMLCOLID, //No I18N
                        "operation" : otherColInfo.OPERATION, "aot" : otherColInfo.AOT}); //No I18N
        var parNode = ZDBUtil.getParentWithAttributeValue(parDiv, "propType", PropSettings.DOUBLE_PROPTYPE); //No I18N
        ZDBUtil.setNamedChildEls(parNode, parNode);
        var dispVal;
        if(otherColInfo.FMLCOLID)
        {
            dispVal = colName;
        }
        else
        {
            dispVal = parNode.funcDiv.innerHTML + "(" + colName + ")";
        }
        var encodedDispVal = ZDBEscapeUtil.encodeForHtml(dispVal);
        jQuery(parNode.funcDiv).attr("tip", dispVal).html(encodedDispVal); //No I18N
    };
    
    // send dynamic thold prop from settings to server
    this.setThresholdProp = function(propSetUtil, tholdEl, thresName, instId)
    {
        propSetUtil.setPropMap(tholdEl.tScope, "0", true);
        propSetUtil.setPropMap(tholdEl.tFunc, DynamicThreshold.CONSTANT_THOLD, true);
        var initVal = new ZDBTholdObject();
        initVal["COLID"] = null;
        initVal["FMLCOLID"] = null;
        initVal["OPERATION"] = null;
        initVal["AOT"] = null;

        propSetUtil.setPropMap(tholdEl.parDiv, initVal, true);
        propSetUtil.setPropMap(tholdEl.tStyle, "0", true);
        var funcVal = tholdEl.tFunc.value;
        if(!funcVal || funcVal === DynamicThreshold.CONSTANT_THOLD) {
            propSetUtil.setPropMap(tholdEl.tValue, propSetUtil.getPropValue(thresName, instId,
                                            (tholdEl.tValue).getAttribute("propType")));
        }
        else {
            propSetUtil.deleteFromPropEl(tholdEl.tValue);
        }
    };
    
    this.showFuncList = function(funcEl, event)
    {
        funcEl.style.backgroundColor = "#e6e6e6";
        var propSetUtil = ZDBClientUI.getViewObj(funcEl, "propSetUtil");
        if(propSetUtil.thresholdObj.relTbl) {
            DynamicThreshold.showTholdFunc(funcEl, event);
        }
        else {
            DynamicThreshold.fetchRelatedTables(propSetUtil.view, funcEl, event);
        }
    };
    
    this.fetchRelatedTables = function(view, funcEl, event)
    {
        if(!ZDBLazyLoadUtil.loadJsAlone(['zdbjs/threshold/TholdRelTables.js'], "APPENDTODOC",
                        DynamicThreshold.fetchRelatedTables, [view, funcEl, event]))
        {
            return;
        }
        TholdRelTables.getRelatedTableIds(view, funcEl, event);
    };
    
    this.hoverFuncBox = function(el)
    {
        var tdEl = ZDBUtil.getParentWithTagName(el, "td"); //No I18N
        var listbox = jQuery(tdEl).find("div[elname='thFunc']");
        var isListOpened = (listbox && listbox[0]);
        if(!isListOpened) {
            el.style.backgroundColor = "#f2f2f2";
        }
    };
    
    this.mouseoutFuncBox = function(el)
    {
        var tdEl = ZDBUtil.getParentWithTagName(el, "td"); //No I18N
        var listbox = jQuery(tdEl).find("div[elname='thFunc']");
        var isListOpened = (listbox && listbox[0]);
        if(!isListOpened) {
            el.style.backgroundColor = "white";
        }
    };

    // display value dropdown on clicking value input div
    this.showTholdFunc = function(funcEl, event)
    {
        var propSetUtil = ZDBClientUI.getViewObj(funcEl, "propSetUtil");
        var tholdProp = propSetUtil.propSetForm.thresholdProp;
        var topParentNode = ZDBUtil.getParentWithTagName(funcEl, "td"); //No I18N
        if(PropSettings.inlineComboOpt)
        {
            var currentParNode = ZDBUtil.getParentWithTagName(PropSettings.inlineComboOpt, "td"); //No I18N
            ZDBAxisProp.hideComboOptDialog();
            if(currentParNode == topParentNode)
            {
                currentParNode.selected = false;
                return;
            }
        }
        funcEl = ZDBUtil.getParentWithAttributeValue(funcEl, "elname", "parDiv");
        funcEl.className = "tholdContainer";
        topParentNode.selected = true;
        ZDBUtil.setNamedChildEls(tholdProp, tholdProp);
        var thFunc = ZDBUtil.getCloneNode(tholdProp.thFunc);
        thFunc.style.display = "";
        var view = propSetUtil.view;
        var jsonData = ZDBAnalysisCaching.tblColInfo.data;
        if(!jsonData || jQuery.isEmptyObject(jsonData))
        {
            ZDBDashboardUF.checkNSendDashFieldsRequest(view, view.parentViewId, false, false, this);
        }
        DynamicThreshold.addAggColumns(thFunc, view);
        PropSettings.inlineComboOpt = thFunc;
        DynamicThreshold.setTickMark(topParentNode, thFunc, funcEl);
        topParentNode.appendChild(thFunc);
        ZDBAxisProp.attachComboOptEvent(event);
    };
    
    this.setTickMark = function(parNode, thFunc, funcEl)
    {
        var colId = funcEl.getAttribute("colid");
        var fColId = funcEl.getAttribute("fmlcolid");
        if(colId || fColId)
        {
            var selector = fColId ? "div[fmlcolid='"+fColId+"']" : "div[colid='"+colId+"']"; //No I18N
            var el = jQuery(thFunc).find(selector)[0];
            el.parentNode.className = "tholdFuncList RefFilterListSelected";
        }
        else
        {
            var val = parNode.getAttribute("propvalue");
            if(!val) {
                val = 0;
            }
            var elVal = "func"+val; //No I18N
            var el = jQuery(thFunc).find("div[elname='"+elVal+"']")[0];
            el.className = "tholdFuncList RefFilterListSelected";
        }
    };
    
    this.getColName = function(columnId)
    {
        var jsonData = ZDBAnalysisCaching.tblColInfo.data;
        for(var relModelId in jsonData)
        {
            var jsonObj = ZDBAnalysisCaching.tblColInfo.data[relModelId];
            var colDet = jsonObj.colDet;
            var tblDet = jsonObj.tableDet;
            for(var tblId in tblDet)
            {
                var colObj = colDet[tblId];
                for(var colId in colObj)
                {
                    var columnDetails = colObj[colId];
                    if(columnDetails.COLUMN_ID == columnId) {
                        return columnDetails.COLUMN_NAME;
                    }
                }
            }
        }
        return null;
    };
    
    this.handleTholdValues = function()
    {
        ZDBThresholdProp.handleTholdValues();
    };
    
    this.addTableName = function(tblName, child)
    {
        var tableNameEl = jQuery("<div>", {"class" : "tholdTableName"}).css("cursor", "pointer")
                                        .height("20px").html(ZDBEscapeUtil.encodeForHtml(tblName)); //No I18N
        jQuery(tableNameEl).hover(function() {
            DynamicThreshold.hideSubMenu(this);
        });
        jQuery(tableNameEl).click(function() {
            var ulEl = jQuery(this.parentNode).find("ul")[0];
            var disp = ulEl.style.display;
            if(disp === "")
            {
                ulEl.style.display = "none";
                this.style.backgroundPosition = "0 -1005px"; //No I18N
            }
            else
            {
                ulEl.style.display = "";
                this.style.backgroundPosition = "0 -202px"; //No I18N
            }
        });
        jQuery(child).append(tableNameEl);
    };
    
    this.addAggColumns = function(funcDiv, view)
    {
        var holder = funcDiv.getElementsByTagName("div")[0];
        var parViewId = view.parentViewId;
        var tholdObj = view.propSetUtil.thresholdObj;
        var isRelTbl = tholdObj && tholdObj.relTbl;
        var relModelId = ZDBClientUtil.getJsonRelModelIdForObjId(parViewId);
        var jsonObj = ZDBAnalysisCaching.tblColInfo.data[relModelId];
        var colDet = jsonObj.colDet;
        var tblDet = jsonObj.tableDet;
        for(var tblId in tblDet)
        {
            if(isRelTbl && tholdObj.relTbl.indexOf(tblId) === -1) {
                continue;
            }
            var tblName = tblDet[tblId].displayName;
            var parentDiv = document.createElement("div");
            holder.appendChild(parentDiv);
            DynamicThreshold.addTableName(tblName, parentDiv);
            var ulEl = document.createElement("ul");
            parentDiv.appendChild(ulEl);
            var colObj = colDet[tblId];
            for(var colId in colObj)
            {
                var columnDetails = colObj[colId];
                if(columnDetails.ADDONTYPE === "NUMBER")
                {
                    var liEl;
                    if(columnDetails.FORMULA)
                    {
                        liEl = jQuery("<li>", {"class" : "tholdFuncList"}).attr("submenu", "false")
                                .click(function() {
                                    DynamicThreshold.setFunc(this);
                                }).mouseenter(function() {
                                    DynamicThreshold.hideSubMenu(this);
                                });
                    }
                    else
                    {
                        liEl = jQuery("<li>", {"class" : "tholdFuncList"}).attr("submenu", "true")
                                .click(function() {
                                    DynamicThreshold.setFunc(this);
                                }).mouseenter(function() {
                                    DynamicThreshold.showSubMenu(this);
                                });
                    }

                    var divEl = jQuery("<div>").css("float", "left")
                            .attr("colname", columnDetails.COLUMN_NAME)     //No I18N
                            .html(ZDBEscapeUtil.encodeForHtml(columnDetails.DISP_NAME)); 
                    divEl.attr(columnDetails.FORMULA ? "fmlcolid" : "colId", colId); //No I18N
                    liEl.append(divEl);
                    if(!columnDetails.FORMULA)
                    {
                        liEl.append(jQuery("<div>", {"class" : "subFunctionSelection"}));
                    }
                    jQuery(ulEl).append(liEl);
                }
            }
        }
    };
    
    this.showSubMenu = function(el, event)
    {
        var parNode = ZDBUtil.getParentWithAttributeValue(el, "elname", "thFunc"); //No I18N
        jQuery(parNode).find("li[submenu='true']").removeClass("tholdFuncList_hover");
        jQuery(el).addClass("tholdFuncList_hover");
        var tholdEl = el.childNodes[0];
        var cno = tholdEl.getAttribute("colid");
        var fcno = tholdEl.getAttribute("fmlcolid");
        if(fcno) {
            DynamicThreshold.currTholdFCol = fcno;
            DynamicThreshold.currTholdCol = null;
        }
        else {
            DynamicThreshold.currTholdCol = cno;
            DynamicThreshold.currTholdFCol = null;
        }
        DynamicThreshold.currTholdColName = tholdEl.getAttribute("colname");
        var topParentNode = ZDBUtil.getParentWithTagName(el, "td"); //No I18N
        var subFnLst = $("tholdFunc");
        var jSubFnLst = jQuery(subFnLst);
        DynamicThreshold.positionSubFunList(el, subFnLst);
        var funcEl = el.children[0];
        DynamicThreshold.setTickMarkInSubMenu(topParentNode, funcEl, subFnLst);
        MenuUtil.slideDown(jSubFnLst, 150);
    };
    
    this.hideSubMenu = function(el)
    {
        var parNode = ZDBUtil.getParentWithAttributeValue(el, "elname", "thFunc"); //No I18N
        jQuery(parNode).find("li[submenu='true']").removeClass("tholdFuncList_hover");
        if(el.children.length > 0)
        {
            var tholdEl = el.childNodes[0];
            var fcno = tholdEl.getAttribute("fmlcolid");
            if(fcno)
            {
                DynamicThreshold.currTholdFCol = fcno;
                DynamicThreshold.currTholdCol = null;
                DynamicThreshold.currTholdColName = tholdEl.getAttribute("colname");
            }
        }
        var subFnLst = $("tholdFunc");
        var jsubFnLst = jQuery(subFnLst);
        if(jsubFnLst.is(":visible")) {
            MenuUtil.slideUp(jsubFnLst, 150);
        }
    };
    
    this.positionSubFunList = function(el, subFnLst)
    {
        jQuery(subFnLst).css({"display":"block", "visibility":"hidden"}); //No I18N
        var menuEl = jQuery(el).closest("div[class='RefColfuncMenuInnerBox shadowAdded']")[0];
        var x = menuEl.offsetWidth;
        var y = ZDBUtil.getObjTop(el, false, menuEl) - jQuery(menuEl).scrollTop();
        jQuery(subFnLst).css({"left":x+"px", "top":y+"px", "display":"none", "visibility":""}); //No I18N
    };
    
    this.setTickMarkInSubMenu = function(parNode, funcEl, subFnLst)
    {
        var parDiv = parNode.parDiv;
        if(parDiv)
        {
            var colId = parDiv.getAttribute("colid");
            var fColId = parDiv.getAttribute("fmlcolid");
            if(colId || fColId)
            {
                var val = parNode.getAttribute("propvalue");
                if(!val) {
                    val = 0;
                }
                var elVal = "func"+val; //No I18N
                var el = jQuery(subFnLst).find("div[elname='"+elVal+"']")[0];
                if((colId && colId === funcEl.getAttribute("colid")) || 
                        (fColId && fColId === funcEl.getAttribute("fmlcolid")))
                {
                    el.className = "tholdFuncList RefFilterListSelected";
                }
                else
                {
                    el.className = "tholdFuncList";
                }
            }
        }
    };
    
    // on selecting from the func drop drown box
    this.setFunc = function(el, func)
    {
        var parNode = ZDBUtil.getParentWithAttributeValue(el, "propType", PropSettings.DOUBLE_PROPTYPE); //No I18N
        ZDBUtil.setNamedChildEls(parNode, parNode);
        var funcDiv = parNode.funcDiv;
        var elName = el.getAttribute("elname");
        var elWidth = (elName && elName === "func0") ? 65 : 160; //No I18N
        funcDiv.style.width = elWidth + "px";
        var tholdEl = ZDBUtil.getParentWithTagName(el, "tr"); //No I18N
        ZDBUtil.setNamedChildEls(tholdEl, tholdEl, "elname", false);
        var dispVal = el.innerHTML;
        if(func)
        {
            if(DynamicThreshold.currTholdFCol)
            {
                parNode.parDiv.setAttribute("FMLCOLID", DynamicThreshold.currTholdFCol);
                parNode.parDiv.removeAttribute("COLID");
            }
            else
            {
                parNode.parDiv.setAttribute("COLID", DynamicThreshold.currTholdCol);
                parNode.parDiv.removeAttribute("FMLCOLID");
            }
            var oper = "MAX"; //No I18N
            if(func === "1") {
                oper = "AVG";
            }
            else if(func === "2") {
                oper = "SUM";
            }
            else if(func === "3") {
                oper = "MIN";
            }
            parNode.parDiv.setAttribute("OPERATION", oper);
            parNode.parDiv.setAttribute("AOT", "NUMBER");
            dispVal += "(" + DynamicThreshold.currTholdColName + ")";
        }
        else
        {
            if(el.getAttribute("elname"))
            {
                jQuery(parNode.parDiv).removeAttr("OPERATION AOT FMLCOLID COLID"); //No I18N
            }
            else
            {
                if(DynamicThreshold.currTholdFCol)
                {
                    parNode.parDiv.removeAttribute("COLID");
                    parNode.parDiv.setAttribute("FMLCOLID", DynamicThreshold.currTholdFCol);
                    dispVal = DynamicThreshold.currTholdColName;
                }
                else
                {
                    parNode.parDiv.removeAttribute("FMLCOLID");
                    parNode.parDiv.setAttribute("COLID", DynamicThreshold.currTholdCol);
                    dispVal = "Average(" + DynamicThreshold.currTholdColName + ")"; //No I18N
                }
                parNode.parDiv.setAttribute("OPERATION", "AVG");
                parNode.parDiv.setAttribute("AOT", "NUMBER");
            }
        }
        funcDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(dispVal);
        funcDiv.setAttribute("tip", dispVal);
        var thFunc = el.getAttribute("elname");
        var funcVal = 1;
        var disp = "none", width = "196px"; //No I18N
        if(thFunc)
        {
            if(thFunc === "func0")
            {
                disp = '';
                width = "80px"; //No I18N
            }
            funcVal = thFunc.substring(4);
        }
        tholdEl.tValue.style.display = disp;
        if(disp === '') {
            tholdEl.tValue.focus();
        }
        tholdEl.funcDivPar.style.width = width;
        parNode.value = funcVal;
        parNode.setAttribute("propValue", funcVal);
        var tholdBody = ZDBUtil.getParentWithTagName(el, "tbody"); //No I18N
        ZDBUtil.setNamedChildEls(tholdBody, tholdBody, "elname", false);
    };
};
