//$Id$ 
 
function ZAFunnelProp(propSetUtil)
{
    var funnelProp = propSetUtil.propSetForm.generalProp;
    var propSetUtil = propSetUtil;
    
    // based on the saved values, set proper values in the settings dialog
	this.setFunnelProperties = function()
	{
	    this.showPercentOptions();
	    this.setFunnelConversionVal();
	    this.setFunnelConversionRate();
	    this.setConvRateLabel();
	    this.setConversionFontDlg();
	    this.setFunnelDesignVal();
	}
	
	// display UI elements of data label for funnel chart
	this.showPercentOptions = function()
	{
        var parentDiv = propSetUtil.propSetForm.pieItemLabel;
	    ZDBUtil.setNamedChildEls(parentDiv, parentDiv);
	    var propValue = propSetUtil.getPropValue(PropSettings.CHART_DEFAULT_ITEMLABEL_PROP,
	                                    PropSettings.STATIC_PROP, PropSettings.DOUBLE_PROPTYPE);
	    if(!propValue) 
        {
            propValue=1;
        } //can be used as a STATIC VARIABLE
	    if(propValue == 1 || propValue == 3) 
        {
	        parentDiv.conversionOpt.style.display = "";
	        parentDiv.ZAPercLbl.innerHTML = ZDBI18NMap.g("zrpt.home.import.step2.js.percent") + ":";
	    }
	    else 
	    {
	        parentDiv.conversionOpt.style.display = "none";
	    }
	}
	
	// show proper funnel conversion value when opening settings UI
	this.setFunnelConversionVal = function()
	{
        var conversionOpt = propSetUtil.propSetForm.conversionOpt;
	    var propValue = propSetUtil.getPropValue(PropSettings.FUNNEL_CONVERSION_PROP,
	                                        PropSettings.STATIC_PROP, PropSettings.DOUBLE_PROPTYPE);
	    ZDBUtil.setNamedChildEls(conversionOpt, conversionOpt);
	    if(!propValue)
	    {
	        ZAFunnelProp.setConversionProp(conversionOpt, "1", 0);
	    }
	    else
	    {
	        propValue = parseInt(propValue);
	        switch(propValue)
	        {
	            case 1:
	                ZAFunnelProp.setConversionProp(conversionOpt, "1", 0);
	                break;
	            case 2:
	                ZAFunnelProp.setConversionProp(conversionOpt, "2", 1);
	                break;
	            case 3:
	                ZAFunnelProp.setConversionProp(conversionOpt, "3", 2);
	        }
	    }
	}
	
	//show proper funnel conversion rate when opening settings UI
	this.setFunnelConversionRate = function()
	{
        var propValue = propSetUtil.getPropValue(PropSettings.CONVERSION_RATE_EXISTS,
	                                PropSettings.STATIC_PROP, PropSettings.STRING_PROPTYPE);
	    var convRateChkBox = propSetUtil.propSetForm.convRate;
	    convRateChkBox.checked = false;
	    if(propValue)
	    {
	        convRateChkBox.checked = true;
	        convRateChkBox.setAttribute("propValue", propValue + "");
	    }
	    else
	    {
	    	this.disableConversionRate(true); // why it is set as true
	    }
	}
	
	this.setConvRateLabel = function()
	{
        var convRateLbl = propSetUtil.propSetForm.funnelLbl;
	    var propValue = propSetUtil.getPropValue(PropSettings.FUNNEL_LABEL_PROP,
	                                        PropSettings.STATIC_PROP, PropSettings.STRING_PROPTYPE);
	    if(propValue == null)
	    {
	        convRateLbl.value = PropSettings.DEFAULT_CONV_LABEL;
	        convRateLbl.setAttribute("propValue", PropSettings.DEFAULT_CONV_LABEL);
	    }
	    else
	    {
	        convRateLbl.value = propValue;
	        convRateLbl.setAttribute("propValue", propValue);
	    }
	}
	
	//remove the layer above the conversion rate options
	this.enableConversionRate = function()
	{
	    var convDiv = propSetUtil.propSetForm.funnelConvDiv;
	    var childEls = DOMUtils.getChildElsWithAttr(convDiv, "remove", "y"); //No I18N
	    if(childEls.length > 0) 
        {
	        convDiv.removeChild(childEls[0]);
	    }
	}
	
	// add a layer above the conversion rate options
	this.disableConversionRate = function(hideInput)
	{
	    var convDiv = propSetUtil.propSetForm.funnelConvDiv;
	    var childEls = DOMUtils.getChildElsWithAttr(convDiv, "remove", "y"); //No I18N
	    if(childEls.length == 0)
	    {
	        var divEl = document.createElement("div");
	        divEl.className = "dataLblCover";
	        if(hideInput)
	        {
	            ZDBUtil.setNamedChildEls(convDiv, convDiv);
	            divEl.style.margin = "-68px 0 0 190px"; //No I18N
	            divEl.style.width = 375 + "px";
	        }
	        else
	        {
	            divEl.style.margin = "-65px 0 0 0px"; //No I18N
	            divEl.style.width = 600 + "px";
	        }
	        divEl.style.height = 75 + "px";
	        divEl.innerHTML = "&nbsp;"; //No I18N
	        divEl.setAttribute("remove", "y");
	        convDiv.appendChild(divEl);
	    }
	}
	
	//set proper funnel design value when opening settings UI
	this.setFunnelDesignVal = function()
	{
        var funnelDesign = propSetUtil.propSetForm.funnelDesign;
        var propValue = propSetUtil.getPropValue(PropSettings.FUNNEL_DESIGN,
		PropSettings.STATIC_PROP, PropSettings.DOUBLE_PROPTYPE);
        var conversionDiv = propSetUtil.propSetForm.funnelConvDiv;
        var fontDlg = propSetUtil.propSetForm.DLFontDlg;
    	fontDlg.style.display = "";
        conversionDiv.style.display = "";
        funnelDesign.style.display = "";
        ZDBUtil.setNamedChildEls(funnelDesign, funnelDesign);
        this.resetFunnelToggle(funnelDesign.dynHeight);
        if(!propValue)
        {
            funnelDesign.setAttribute("propValue", "1");
            ZAFunnelProp.setFunnelClass(funnelDesign.dynHeight, PropSettings.funnelSpanHLStyles[0]);
        }
        else
        {
            propValue = parseInt(propValue);
            switch(propValue)
            {
                case 1:
                    funnelDesign.setAttribute("propValue", "1");
                    ZAFunnelProp.setFunnelClass(funnelDesign.dynHeight, PropSettings.funnelSpanHLStyles[0]);
                    break;
                case 2:
                    funnelDesign.setAttribute("propValue", "2");
                    ZAFunnelProp.setFunnelClass(funnelDesign.uniHeight, PropSettings.funnelSpanHLStyles[1]);
                    break;
                case 3:
                    funnelDesign.setAttribute("propValue", "3");
                    ZAFunnelProp.setFunnelClass(funnelDesign.dynWidth, PropSettings.funnelSpanHLStyles[2]);
            }
        }
	}
	
	//reset the funnel design div and span styles
	this.resetFunnelToggle = function(el)
	{
        var toggleEls = (el.parentNode).getElementsByTagName("div");
        for(var i=0, j=toggleEls.length; i<j; i++)
        {
            toggleEls[i].className = "inlineToggleEl funnelDesignDiv";
            var spanEls = toggleEls[i].getElementsByTagName("span");
            spanEls[0].className = "funnelDesign " + PropSettings.funnelSpanStyles[i];
        }
	}
	
	//clone and add font dialog
	this.setConversionFontDlg = function()
	{
        var view = propSetUtil.view;
        if(view.graphSelected === "PIE" && view.subGraphType === "FUNNEL")
        {
        	propSetUtil.fontPropObj = new ZDBFontProp(funnelProp, propSetUtil);
            propSetUtil.fontPropObj.initFontProp();
        }
	}
	
	//set the user input in settings page to the prop map to reflect in chart
	this.setFunnelPropMap = function()
	{
        propSetUtil.setPropMap(propSetUtil.propSetForm.conversionOpt, "1", true);
        propSetUtil.setPropMap(propSetUtil.propSetForm.convRate, "false", true);
        propSetUtil.propSetForm.funnelLbl.setAttribute("propValue", propSetUtil.propSetForm.funnelLbl.value);
        propSetUtil.setPropMap(propSetUtil.propSetForm.funnelLbl, PropSettings.DEFAULT_CONV_LABEL, true);
        propSetUtil.setPropMap(propSetUtil.propSetForm.convFont, new ZDBFontObject("Default", '' , '', 0), true); //No I18N
        propSetUtil.setPropMap(propSetUtil.propSetForm.funnelDesign, "1", true);
	}
	return this;
	
}


// set conversion type value and tool tip in the select box
ZAFunnelProp.setConversionProp = function(el, value, idx)
{
    el.setAttribute("propValue", value);
    el.convSelect.options[idx].selected = true;
    el.convSelect.title = el.convSelect.options[idx].text;
}

// set the conversion type based on selection in settings page
// also set selected value in tooltip and enable data label based on conversion type
ZAFunnelProp.setConversionType = function(el)
{
    var value = el.options[el.selectedIndex].value;
    var conversionOpt = ZDBUtil.getParentWithAttributeValue(el, "elname", "conversionOpt"); //No I18N
    conversionOpt.setAttribute("propValue", value);
    el.title = el.options[el.selectedIndex].text;
}

// set property for showing conversion rate based on user input in settings dialog
ZAFunnelProp.setConversionRate = function(checkBox)
{
    var propSetUtil = ZDBClientUI.getViewObj(checkBox, "propSetUtil");
    var funnelObj = propSetUtil.funnelObj;
    if(checkBox.checked)
    {
    	funnelObj.enableConversionRate();
        checkBox.setAttribute("propValue", "true");
        ZDBUtil.setFocus(propSetUtil.propSetForm.funnelLbl, true); //No I18N
    }
    else
    {
    	funnelObj.disableConversionRate(true); // why it is set as true
        checkBox.setAttribute("propValue", "false");
    }
}

// based on selection in settings page, set the funnel design
ZAFunnelProp.setFunnelDesign = function(el)
{
    var value = el.getAttribute("value");
    var propSetUtil = ZDBClientUI.getViewObj(el, "propSetUtil");
    var funnelObj = propSetUtil.funnelObj;
    funnelObj.resetFunnelToggle(el);
    ZAFunnelProp.setFunnelClass(el, PropSettings.funnelSpanHLStyles[parseInt(value) - 1]);
    var funnelDesign = ZDBUtil.getParentWithAttributeValue(el, "elname", "funnelDesign"); //No I18N
    funnelDesign.setAttribute("propValue", value);
}

//set proper style for funnel design divs
ZAFunnelProp.setFunnelClass = function(el, spanStyle)
{
    el.className = "inlineToggleElSelected funnelDesignDiv";
    var spanEls = el.getElementsByTagName("span");
    spanEls[0].className = "funnelDesign " + spanStyle;
}

ZAFunnelProp.keyPressEvent = function(el, event)
{	
    switch(event.keyCode)
    {
        case KEY.ENTER:
        case KEY.DOWNARROW:
        case KEY.SPACE:
        	ZDBFontProp.showFontDialog(el, event);
            ZDBUtil.doNothing(event);
            break;
        case KEY.ESC:
        case KEY.UPARROW:
            ZDBAxisProp.hideComboOptComp();
            ZDBAxisProp.removeComboOptEvent(event);
            break;
    }
}


