//$Id$
var ZDBAnalysisDateFilter = new function()
{

	this.validateDate = function(dateField)
	{
		var dateValue = dateField.value;
		var parsedData = ZDBColumnType['DATE'].dispFn(dateValue);
		dateField.value = parsedData.replace(","," ");

	}
}

var ZDBCalender = new function()
{
	this.suffix = 1;
	this.modifyElID = function(buttonClicked, fieldToChange)
	{
		this.buttonClicked = buttonClicked+"_"+ZDBCalender.suffix;
		this.fieldToChange = fieldToChange+"_"+ZDBCalender.suffix;
		var btn = $(buttonClicked);
		var field = $(fieldToChange);
		btn.removeAttribute("id");
		field.removeAttribute("id");

		btn.setAttribute("id",ZDBCalender.buttonClicked);
		field.setAttribute("id",ZDBCalender.fieldToChange);
		ZDBCalender.suffix++;
	}

	this.showCalender =  function(buttonClicked, fieldToChange,showTime)
	{
          ZDBCalender.modifyElID(buttonClicked, fieldToChange);
           var format = (showTime)?  "%d %b %Y %H:%M:%S":"%d %b %Y ";//NO I18N
          this.inputField = ZDBCalender.fieldToChange;
          this.triggerButton = ZDBCalender.buttonClicked;

          Calendar.setup(
          {
           	  inputField     :    ZDBCalender.inputField,      // id of the input field
              ifFormat       :   format,       // format of the input field
              showsTime      :    showTime,            // will display a time selector
              button         :    ZDBCalender.triggerButton,   // trigger for the calendar (button ID)
              singleClick    :    true,           // double-click mode
           	  weekNumbers    :   	false,
						  range       	 :    [1000,9999],
              step           :    1,                // show all years in drop-down boxes (instead of every other year as default)
              onClose        :    function(){this.hide();this.destroy();}
              }
          );
	}
}

ZDBAnalysisView.prototype.getDroppedFields = function(dropArea)
{
	var no_droppedFields = this.currentList.length;
	var count=0;
	var fields=new Array();
	for(i=0; i<no_droppedFields; i++)
		{
			var viewType = this.currentList[i].getAttribute("viewtype");
			if(viewType == dropArea)
			{
				fields[count]=this.currentList[i];
				count++;
			}
		}
	return fields;
}

ZDBAnalysisView.removeFieldEl = function(field,event)
{
  var view = ZDBClientUI.getViewObj(field,"view");
  var viewType = field.getAttribute("VIEWTYPE");
  if(viewType == null)
  {
    field = DOMUtils.getParentWithAttr(field,"VIEWTYPE");
    viewType = field.getAttribute("VIEWTYPE");
  }
	if(ZDBAnalysisFuncMenu.isDependent(field,view)){return;}
  if(viewType== "FILTERAXIS")
  {
    ZDBUtil.removeNonElements(field.parentNode);
	var dropAreaFields = view.getDroppedFields(viewType);
    if(dropAreaFields.length >0)
    {
			var fieldToShow = (field.nextSibling)?field.nextSibling:field.previousSibling;
      ZDBAnalysisFilter.selectFilterField(view,fieldToShow);
    }
    else
    {
      var fieldToShow = null;
      ZDBAnalysisFilter.selectFilterField(view,fieldToShow);
    }
  }
  else
  {
      if(view.typeValue == ZDBClientViewAPI.TYPE_ANALYSISVIEW)
      {
    	  if(viewType == "COLORAXIS" && view.graphSelected == "COMBO")
		  {
    		  view.graphSelected = "BEST"; //No I18N
    		  view.userGrpSel = "BEST"; //No I18N
    		  view.userSubGrpSel = "DEF";  //No I18N
    		  view.subGraphType = "DEF";  //No I18N
    		  var legModel = view.chartObj.getLegendModel();
    		  legModel.setDefComboValOnFieldChange(true,view);
		  }
          if(field.getAttribute("sorttype")!=null && field.getAttribute("sorttype")!="")
          {
            view.resetSortInfo();
          }
      }
      else if(view.typeValue == ZDBClientViewAPI.TYPE_SUMMARY)
      {
            var currentList = view.currentList;
            var yAxisList = ZDBUtil.getElementsWithAttribute(currentList, "viewType","YAXIS");//No I18N
            var groupAxisList = ZDBUtil.getElementsWithAttribute(currentList, "viewType","GROUP");//No I18N
            for(var i=0, j = groupAxisList.length, k =yAxisList.length-1; i<j && field == yAxisList[k]; i++)
            {
                groupAxisList[i].removeAttribute("SORTTYPE");
            }
      }

  }
  	view.setModified();
  view.removeField(field,true);
  ZDBUtil.stopEventBubble(event);
}

ZDBAnalysisView.checkPanelNDrop = function(el,view,isAutoAdded)
{
  var field = el;
  if(field.getAttribute("column_id") == null)
  {
    field = DOMUtils.getParentWithAttr(field,"column_id");
  }
  view = ZDBClientUI.getViewObj(el,"view");
  var matchedFieldsInList = ZDBAnalysisView.matchedFieldsInList(field,view);
  if(matchedFieldsInList!=false)
  {
    var fieldCount = matchedFieldsInList.length;
    if(fieldCount>1)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.duplicateFieldEntry",fieldCount));
      el.className = "ZDBDNDFieldChecked";
      return;
    }
    var fieldEl = matchedFieldsInList[0];
    var dropAreaTd = DOMUtils.getSelfOrParentWithAttrValue(fieldEl,"dropAreaTd","true");//NO I18N
    ZDBAnalysisEditViewMode.selectTab("graph",null,view);//No I18N
    ZDBAnalysisView.expandDropField(dropAreaTd);
    ZDBAnalysisView.removeFieldEl(fieldEl); //removes only when one field is matched
    el.className = "ZDBDNDFieldUncheck";
  }
  else
  {
    //view.addFieldToFilter(el);
    ZDBAnalysisView.identifyAndAddFieldToGraph(el,view,isAutoAdded);
    el.className = "ZDBDNDFieldChecked";
  }
}

ZDBAnalysisView.excludeLegend = function(exclude)
{
    var parEl = ZDBLegendTools.parLegendEl;
    var axisType = parEl.viewType
    ZDBAnalysisView.addToFilter(parEl,axisType,parEl.filterValue,parEl.value,exclude);
    ZDBLegendTools.parLegendEl = null;
}

ZDBAnalysisView.addToFilter = function(el,axisType,criteria,dispCriteria,exclude)
{
  var view = ZDBClientUI.getViewObj(el,"view")
  var axisDetails = view.axisDetails;

  var grpField = null;
  for(var i=0;i< axisDetails.length;i++)
  {
    if((!axisDetails[i]) || !(axisDetails[i].VIEWTYPE == axisType))
    {
      continue;
    }

    var no_droppedFields = view.currentList.length;
    var columnMatched = null;
    for(j=0; j<no_droppedFields; j++)
    {
    	if(view.currentList[j].getAttribute("viewType")!="FILTERAXIS"){continue;}
    	if(ZDBLegendTools.parLegendEl && (ZDBAnalysisView.isMeasure(axisDetails[i])))
    	{
        	axisDetails[i]["SUBTYPE"] = 2;
        }
        columnMatched = (axisDetails[i].COLUMN_ID == view.currentList[j].getAttribute("column_id")) &&
                          (axisDetails[i].FILTER_OPERATION == view.currentList[j].getAttribute("operation")) &&
                          (axisDetails[i].SUBTYPE == view.currentList[j].getAttribute("subtype")) &&
                          (view.currentList[j].getAttribute("exclude") == exclude);
	   	if(columnMatched == true)
		{
	          ZDBAnalysisEditViewMode.selectTab("filter",null,view);//No I18N
	          grpField = view.currentList[j];
	          ZDBAnalysisFilter.selectFilterField(view,grpField);
	          var itemList = $("itemList");
	          var items = null;
	          if(itemList)
	          {
	            items = itemList.getElementsByTagName("div");
	          }
	          var oldCriteria = grpField.getAttribute("criteria").split(",");
	          var match = false;
	          var filter = "";
	          var displayCriteria="";
	          var newCriteria = "";
	          if(grpField.getAttribute("criteria") != "")
	          {
	            filter = grpField.getAttribute("criteria");
	            displayCriteria =grpField.getAttribute("displaycriteria");
	            newCriteria = grpField.getAttribute("criteria");
	          }
	          for(var p=0,q=oldCriteria.length;p<q;p++)
	          {
	              if(oldCriteria[p] == criteria)
	              {
	                  match = true;
	              }
	          }
	          newCriteria = ((match != true)&&(oldCriteria.length != 0)) ? (newCriteria+","+criteria) : criteria;
	          var criteriaArr = newCriteria.split(",");
	          if(items != null)
	          {
	              var newRange = null;
	              for(var m=0,n=criteriaArr.length;m<n;m++)
	              {
	                  newRange = criteriaArr[m];
	                  for(var k=0,l=items.length;k<l;k++)
	                  {
	                    if((items[k].getAttribute("filterValue") == criteriaArr[m]) && items[k].getAttribute("sel") != "yes")
	                    {
	                        filter += items[k].getAttribute("filtervalue") + ",";
	                        displayCriteria += items[k].getAttribute("displayfiltervalue") + ",";
	                        ZDBAnalysisFilter.filterChanged(items[k]);
	                        newRange = null;
	                        break;
	                    }
	                  }
	              }
	              if(newRange != null)
	              {
	                 if(ZDBAnalysisView.isMeasure(axisDetails[i]))
	                 {
	                     grpField.setAttribute("NR",grpField.getAttribute("NR")+","+newRange+",");
	                     ZDBAnalysisFilter.addAsNewRange(newRange,view);
	                     filter += newRange+",";
	                     displayCriteria += ZDBAnalysisFilter.retDisplayFilterValue(newRange) + ",";
	                 }
	              }
	          }
	          grpField.setAttribute("CRITERIA",filter);
	          grpField.setAttribute("DISPLAYCRITERIA",displayCriteria);
	          grpField.setAttribute("EXCLUDE",exclude);
	          ZDBAnalysisView.showRefreshDiv(view);
		  break;
		}
    }
    if(columnMatched != true)
    {
        grpField = ZDBAnalysisView.getGraphField(view,axisDetails[i],"FILTERAXIS",axisDetails[i].DISPLAY_NAME,false);
        if(criteria)
        {
           grpField.setAttribute("CRITERIA",criteria+",");
           grpField.setAttribute("DISPLAYCRITERIA",dispCriteria+",");
           grpField.setAttribute("EXCLUDE",exclude);
           grpField.setAttribute("NR",criteria+",")
           if(ZDBAnalysisView.isMeasure(axisDetails[i]))
           {
              grpField.setAttribute("subtype","2");
           }
           ZDBAnalysisView.showRefreshDiv(view);
        }
        ZDBAnalysisEditViewMode.selectTab("filter",null,view);//No I18N
        view.addFieldToArea(grpField,view.dropAreas["FILTERAXIS"]);
	ZDBAnalysisFilter.selectFilterField(view,grpField);
    }
  }
}

ZDBAnalysisView.prototype.addFieldToFilter = function(field)
 {
	if(field.getAttribute("column_id") == null)
	{
		field = DOMUtils.getParentWithAttr(field,"column_id");
	}
	var grpField = null;
	var no_droppedFields = this.currentList.length;
	var columnMatched = null;
	for(i=0; i<no_droppedFields; i++)
	{
		if(this.currentList[i].getAttribute("viewType")!="FILTERAXIS"){continue;}
		columnMatched = (field.getAttribute("column_id")==this.currentList[i].getAttribute("column_id"));
		if(columnMatched==true)
		{
			ZDBAnalysisEditViewMode.selectTab("filter",null,this);//No I18N
			grpField = this.currentList[i];
			ZDBAnalysisFilter.selectFilterField(this,grpField);
			break;
		}
	}

	if(columnMatched!=true)
	{
		ZDBAnalysisEditViewMode.selectTab("filter",null,this);//No I18N
		grpField = ZDBAnalysisView.getGraphField(this,field,"FILTERAXIS", //No I18N
				field.getAttribute("displayname"),false);

		ZDBAnalysisFilter.setBestFilterFunction(grpField,this);


		this.addFieldToArea(grpField,this.dropAreas["FILTERAXIS"]);
		ZDBAnalysisFilter.selectFilterField(this,grpField);
	}

 }

ZDBAnalysisView.matchedFieldsInList = function(el,view)//return false else return fieldexist count in the view (Note: Filter fields not include)
{
	var field = el;
	var fieldCount = 0;
	var matchedFieldsInList = new Array();
	view = ZDBClientUI.getViewObj(el,"view");
	if(field.getAttribute("column_id") == null)
	  {
		field = DOMUtils.getParentWithAttr(field,"column_id");
	  }
	var no_droppedFields = view.currentList.length;

	if(no_droppedFields<1)
	{
		return false;
	}

	for(i=0; i<no_droppedFields; i++)
	{
	var fieldExist = (field.getAttribute("column_id")==view.currentList[i].getAttribute("column_id"));
		if(fieldExist==true && !(view.currentList[i].getAttribute("VIEWTYPE")=="FILTERAXIS"))
			{
				matchedFieldsInList[fieldCount] = view.currentList[i];
				fieldCount++
			}
	}

	return (fieldCount>0)?matchedFieldsInList:false;
}

ZDBAnalysisView.identifyAndAddFieldToGraph = function(el,view,isAutoAdded)
{
    var field = (el.getAttribute("ADDONTYPE")!=null)?el:DOMUtils.getParentWithAttr(el,"dType");
    var rule = ZDBAnalysisView.getRuleToApply(field,view);
    if(rule == null)
    {
        return;
    }
    var fieldTitle = field.getAttribute("displayName");//childNodes[0].data;//$$Wrong way of access
    //field = field.cloneNode(true);
    var addType = field.getAttribute("ADDONTYPE");
    var op = field.getAttribute("OPERATION");
    var vt = rule[7];
    if(addType != "ABSDATECATEGORICAL" && op != "GEO")
    {
      field.setAttribute("OPERATION",rule[8]);
    }
    var el = ZDBAnalysisView.getGraphField(view,field,vt,fieldTitle,false);
    if(el == null){return;}
    if(view.dropAreas[vt] == null){return;}
    ZDBAnalysisEditViewMode.selectTab("graph",null,view);//No I18N
    view.addFieldToArea(el,view.dropAreas[vt]);

    if(rule[6] == 3)
    {
      ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.chart.showinfo.js.pivotSuggestion"));
    }
    else if(rule[6] == 2)
    {
      var list = view.currentList;
      for(var i=0; i < list.length;i++)
      {
        if(list[i].getAttribute("VIEWTYPE") == rule[9])
        {
          ZDBAnalysisView.setOperationOnField(list[i],rule[8],rule[9],null,view);
        }
      }
    }
    else if(rule[6] == 4)
    {
        var list = view.currentList;
        for(var i=0; i < list.length;i++)
        {
          if(list[i].getAttribute("VIEWTYPE") == rule[10] || list[i].getAttribute("VIEWTYPE") == rule[11])
          {
            ZDBAnalysisView.setOperationOnField(list[i],rule[9],null,null,view);
          }
        }
    }
    if(!isAutoAdded && view.type=="AnalysisView")
    {
        ZDBAnalysisView.checkNAddDependentColumns(field,vt,view);
    }
    
    ZDBAnalysisView.setModAndShowRefresh(view);
}

ZDBAnalysisView.updateAxisIfNeeded = function(view,curSettings,field)
{
    if(view.type!="AnalysisView")
    {
        return;
    }
    var geoYCols =jQuery(view.dropAreas.YAXIS).find("div[operation='GEO']");
    if(geoYCols.length>0 && field.getAttribute("origdatatype")=="GEO_NUM") // when input field is geo 
    {
      curSettings["YAXIS"]=geoYCols[0];
    }
}
ZDBAnalysisView.getViewDepAddOnType = function(existField,curAddType,view)
{
//    if(view.type!="AnalysisView")
//    {
//        return curAddType;
//    }
    if(existField && (existField.getAttribute("origdatatype")=="GEO_NUM" ||existField.getAttribute("operation")=="GEO"))
    {
        var georole = existField.getAttribute("georole");
        return (georole==ZDBUtil.geoNameVsRole.LATITUDE || georole==ZDBUtil.geoNameVsRole.LONGITUDE)? ZDBUtil.georoleVSName[georole]  : curAddType;
    }
    return curAddType;
}
ZDBAnalysisView.getRuleToApply = function(el,view)
{
  var field = (el.getAttribute("ADDONTYPE")!=null)?el:DOMUtils.getParentWithAttr(el,"dType");
  var type = field.getAttribute("ADDONTYPE");
  var dbcolname = field.getAttribute("dbcolname");
  var curSettings = new Object();
  var curCount = new Object();
  view.updateCurrentMatchRow(curSettings,curCount);
  curSettings["INPUT"] = field;
  var rule = null;
  var rules = ZDBAnalysisView[view.type + "Rules"];
  ZDBAnalysisView.updateAxisIfNeeded(view,curSettings,field)
  BIGFOR : for(var i =1; i < rules.length ; i++)
  {
    var curRule = rules[i];
    for(var j =0; j < rules[0].length; j++)
    {
      var existField = curSettings[rules[0][j]];
      var existCount = curCount[rules[0][j]];
      var addType = null;
      if(existField != null){addType =  existField.getAttribute("ADDONTYPE");}
      var type = curRule[j];
      if(addType == "ABSDATECATEGORICAL")      
      {
        addType = "CATEGORICAL";//NO I18N
      }
      addType = ZDBAnalysisView.getViewDepAddOnType(existField,addType,view);
      if((dbcolname == "C_DUMMY") && (type == "AGGRFORMULACOL"))
      {
        break;
      }
      var count = null;
      if(type !=null)
      {
        var idx = type.indexOf(":");
        if(idx > -1)
        {
          count = type.substring(idx+1);
          type = type.substring(0,idx);
        }
      }
      if((type == "*" && count==null) || (type == "*" && count==existCount) || ((type == addType) && ((count ==null)||(count == existCount)))
         || ((type == "?") && (addType != null)))
      {
        continue;
      }
      continue BIGFOR;
    }
    rule = curRule;
    break;
  }
  return rule;
}

ZDBAnalysisView.prototype.updateCurrentMatchRow = function(curSettings,curCount)
{
  for(var i =0; i < this.currentList.length; i++)
  {
    var viewType = this.currentList[i].getAttribute("VIEWTYPE");
    curSettings[viewType] = this.currentList[i];
    var count = curCount[viewType];
    if(count == null){count = 0};
    curCount[viewType] = ++count;
  }
}
 ZDBAnalysisView.highlightElement = function(view,dragEl)
  {
     
     if(dragEl.getAttribute("VIEWTYPE") ==null || dragEl.getAttribute("VIEWTYPE")=="VMFILTERCRITERIA"){return;}
     if(view.highLigtedColumn){view.highLigtedColumn.className = "zdbdragfield";}
     view.highLigtedColumn = dragEl;
     var siblings = dragEl.parentNode.childNodes;
     if(siblings!=null)
     {
        for(var i=0; i< siblings.length; i++)
        {
                siblings[i].className = (siblings[i]==dragEl)? "zdbdragfield sel":"zdbdragfield";
        }
      }
  }

ZDBAnalysisView.enableDropFieldsExp = function(view)
{
  var dropAreas = view.dropAreas;
 for(var i in dropAreas)
 {
   var curDropArea = dropAreas[i];
   var dropAreaTd = DOMUtils.getSelfOrParentWithAttrValue(curDropArea ,"dropAreaTd","true");//NO I18N
   curDropArea.dropAreaTd = dropAreaTd;
   dropAreaTd.curDropArea = curDropArea;
//   ZDBUtil.setNamedChildEls(dropAreaTd,dropAreaTd);
  ZDBAnalysisView.enableDropFieldExp(curDropArea);

 }
}

ZDBAnalysisView.enableDropFieldExp = function(curDropArea)
{
  var dropAreaTd = curDropArea.dropAreaTd;
  if(!dropAreaTd)
  {
      dropAreaTd = DOMUtils.getSelfOrParentWithAttrValue(curDropArea,"dropAreaTd","true"); //NO I18N
      curDropArea.dropAreaTd = dropAreaTd;
      dropAreaTd.curDropArea = curDropArea;
      ZDBUtil.setNamedChildEls(dropAreaTd,dropAreaTd);
  }
    ZDBUtil.setNamedChildEls(dropAreaTd,dropAreaTd);
    var holderDiv =  DOMUtils.getFirstMatchingChild(dropAreaTd,"div","holder","true");//NO I18N
   var view = ZDBClientUI.getViewObj(curDropArea,"view");//NO I18N
  var allowedHolders = view.multipleColPanels[view.type];
   var holderType =holderDiv.getAttribute("VIEWTYPE");// NO I18N
  var posInArr = jQuery.inArray(holderType, allowedHolders)
  if(posInArr<0){return;}
//   ZDBUtil.setNamedChildEls(dropAreaTd,dropAreaTd);

    var fieldsHolder =  dropAreaTd.fieldsholder; 
    //DOMUtils.getFirstMatchingChild(dropAreaTd,"div","elname","fieldsholder");
    if(!dropAreaTd.fieldLstExp || !fieldsHolder){return;}
//    alert("fieldHolder"+fieldsHolder.offsetHeight);
//      alert("holder"+holderDiv.offsetHeight);
    if(fieldsHolder.offsetHeight < holderDiv.offsetHeight)
      {
        dropAreaTd.fieldLstExp.className = "fieldsExpEnable";
        dropAreaTd.fieldLstExp.setAttribute("enable","true");
      }
      else
      {
        dropAreaTd.fieldLstExp.className = "fieldsExpDisable";
        dropAreaTd.fieldLstExp.setAttribute("enable","false");
      }
}
ZDBAnalysisView.contractPrevList = function(dropArea)
{
    var prevDropArea = ZDBAnalysisView.expDropArea;
   //close prev list if open
   if(prevDropArea && prevDropArea!=dropArea && prevDropArea.expanded)
   {
      ZDBAnalysisView.contractList(prevDropArea);
   }
}

ZDBAnalysisView.expandDropField = function(el,event,transitionTime)
{
   transitionTime = (!transitionTime) ? 300 : transitionTime;
   var view = ZDBClientUI.getViewObj(el,"view");//NO I18N
   if(view.type=="Dashboard"){return;}
   var dropAreaTd = DOMUtils.getSelfOrParentWithAttrValue(el,"dropAreaTd","true");//NO I18N
      var holderDiv =  DOMUtils.getFirstMatchingChild(dropAreaTd,"div","holder","true");//NO I18N

   var holderType =holderDiv.getAttribute("VIEWTYPE");// NO I18N
   var curDropArea = view.dropAreas[holderType];
   ZDBUtil.setNamedChildEls(dropAreaTd,dropAreaTd);
   if(!dropAreaTd){return;}
   var fieldLstExp = dropAreaTd.fieldLstExp;//DOMUtils.getFirstMatchingChild(dropAreaTd,"div","elname","fieldLstExp");//NO I18N
   var dropArea =   dropAreaTd.dropField;//DOMUtils.getFirstMatchingChild(dropAreaTd,"div","dropArea","true");//NO I18N
   //   var highlightTd =  DOMUtils.getFirstMatchingChild(dropAreaTd,"div","highlighttd","true");//NO I18N
   var dropField  = dropAreaTd.dropArea;
   //DOMUtils.getFirstMatchingChild(dropAreaTd,"div","elname","dropArea");

   var allowedHolders = view.multipleColPanels[view.type];
   
   var posInArr = jQuery.inArray(holderType, allowedHolders)
   ZDBAnalysisView.contractPrevList(dropArea);
   if(posInArr<0)
   {
     return;
   }
   ZDBAnalysisView.enableDropFieldExp(dropArea);
   if(!fieldLstExp || fieldLstExp.getAttribute("enable")!="true"){return;}
  // should not move this to front. Since previous drop field list should be closed on focusing to the other drop area.
    if(dropArea.expanded)
   {
//     ZDBAnalysisView.setListHeight(view, curDropArea,true);
     return;
   }
   ZDBUtil.setNamedChildEls(dropArea,dropArea);
   ZDBAnalysisView.expDropArea = dropArea;
//   dropArea.fieldsholder.className = "graphfieldsheightY expand";
//dropField.style.height = "auto";
// jQuery(dropField).animate({height:holderDiv}, transitionTime);
   	ZDBAnalysisView.setListHeight(view, curDropArea,true,300);
   dropArea.expanded = true;
   ZDBUtil.attachEvent(document,'click',ZDBAnalysisView.checkNcontractList,true);
    ZDBUtil.stopEventBubble(event);
}

ZDBAnalysisView.setListHeight = function(view,curDropArea,expandList,animatespeed)
{
	if(!view)
    {
      view = ZDBClientUI.getViewObj(curDropArea,"view");//NO I18N
    }
	if(!curDropArea.dropAreaTd)
	{
		ZDBAnalysisView.enableDropFieldsExp(view);
	}
    var holderDiv =  DOMUtils.getFirstMatchingChild(curDropArea.dropAreaTd,"div","holder","true");//NO I18N
    var allowedHolders = view.multipleColPanels[view.type];
    var holderType =holderDiv.getAttribute("VIEWTYPE");// NO I18N
    var posInArr = jQuery.inArray(holderType, allowedHolders)
    if(posInArr<0)
    {
      return;
    }
    var viewArea = view.viewComp;
    var dropField = curDropArea.dropAreaTd.dropArea;
    var maxDivHgt = ZDBClientUtil.getInnerHeightAnyway(viewArea)*0.60;
    var extraVal = 3;
    var divHgt = ZDBClientUtil.getInnerHeightAnyway(holderDiv) + extraVal;
    var listHeight = divHgt>maxDivHgt ? maxDivHgt+'px' : divHgt+'px'; //NO I18N
    var dropFieldMinHgt=parseInt(dropField.getAttribute('minheight'),10);
    var holderDivMinHgt=parseInt(holderDiv.style.minHeight,10);
  	if(expandList || (holderDiv.offsetHeight<=holderDivMinHgt))
  		{
  			jQuery(dropField).animate({height:listHeight}, animatespeed);
  			curDropArea.dropAreaTd.fieldLstExp.style.display='none';
      			if(holderDiv.offsetHeight>holderDivMinHgt)
      				{
      			    	jQuery(curDropArea.dropAreaTd.dropArea).addClass("DropAreaOverFlow");
      			    	holderDiv.style.width=jQuery(holderDiv).width()+"px";
      				}
      			else
      				{
      					jQuery(curDropArea.dropAreaTd.dropArea).removeClass("DropAreaOverFlow");
      					holderDiv.style.width="";
      				}
  		}
  	else
  		{
  		var height=curDropArea.dropAreaTd.fieldsholder.offsetHeight - 5+'px'; //NO I18N
  		jQuery(dropField).animate({height:height},animatespeed);
  		dropField.style.height = '';
  		if(holderDiv.offsetHeight>holderDivMinHgt)
  			{
  				curDropArea.dropAreaTd.fieldLstExp.style.display='';
  			}
  		}
}

ZDBAnalysisView.contractList = function(dropArea,event)
{
//    dropArea.fieldsholder.className = "graphfieldsheightY";
//   var highlightTd = DOMUtils.getFirstMatchingChild(dropArea,"div","highlighttd","true");//NO I18N
        var dropAreaTd = DOMUtils.getSelfOrParentWithAttrValue(dropArea,"dropAreaTd","true"); //NO I18N
        ZDBMenuUtil.closeMenu(event);
//    var dropAreaTd = dropArea.dropAreaTd;
//    if(!dropAreaTd)
//    {
//        dropArea.dropAreaTd = dropAreaTd;
//        ZDBUtil.setNamedChildEls(dropAreaTd,dropAreaTd);
//    }
//   var dropField  = dropAreaTd.dropArea;//DOMUtils.getFirstMatchingChild(dropArea,"div","elname","dropArea");
//   dropField.style.height = dropArea.fieldsholder.offsetHeight-5+'px';
//   var height = dropArea.fieldsholder.offsetHeight-5+'px';
//   jQuery(dropField).animate({height:height}, 300);
//   var holderDiv =  DOMUtils.getFirstMatchingChild(dropArea,"div","holder","true");//NO I18N
     var view = ZDBClientUI.getViewObj(dropArea,"view");//NO I18N
    ZDBAnalysisView.setListHeight(view, dropAreaTd.curDropArea,false,300);
    dropArea.expanded = false;
    ZDBUtil.detachEvent(document,'click',ZDBAnalysisView.checkNcontractList,true);
}

ZDBAnalysisView.checkNcontractList = function(event,isKeypress)
{
  if(!ZDBAnalysisView.expDropArea){return;}
   if(!isKeypress)
    {
        var tarEl = event ? ZDBUtil.getSourceElement(event): null;
        var dropArea = ZDBAnalysisView.expDropArea;
        var compEl = ZDBUtil.getParentWithAttributeValue(tarEl,"elName",dropArea.getAttribute("elName"));//No I18N
        var fnEl = ZDBUtil.getParentWithAttributeValue(tarEl,"id","ZDBFuncMenuBox");//No I18N
        var checkMark = tarEl.getAttribute ? tarEl.getAttribute("elname"):""; //NO I18N
        if(!compEl && !fnEl && checkMark!="checkMark")
        {
          ZDBAnalysisView.contractList(dropArea,event);
        }
    }
}
