//$Id$

var ZDBAnalysisFilter = new function()
{
  this.blinkCounter=0;
  this.curFieldFunctionDisplay = "";
  this.intervalID=null;
    this.sendFilterFieldInfo = function(field, replaceEl, isReplace, filterNav)
    {
        var viewType = field.getAttribute("VIEWTYPE");
        var colId = field.getAttribute("COLUMN_ID");
        var view = ZDBClientUI.getViewObj(field, "view");//NO I18N
        var isDashBoard = view.type == "Dashboard"; // NO I18N
        var isRelVMFilter = filterNav && filterNav.getAttribute("relVMFilterNav") == "true" ? (viewType == "VMFILTERCRITERIA") : false; //NO I18N
        var extraParams = isRelVMFilter ? ZDBAnalysisFilter.getExtraParamsForRelDt(field) : ZDBAnalysisFilter.getExtraParams(field);
        extraParams += "' ft='" + field.getAttribute("FIELD_COL_TYPE").trim() + "' "; //NO I18N
        var colParViewId = field.getAttribute("PARENT_OBJ_ID") != null ? field.getAttribute("PARENT_OBJ_ID").trim() : view.parentViewId ;
        if (field.getAttribute("PARENT_OBJ_ID") != null)
        {
            extraParams += " po='" + field.getAttribute("PARENT_OBJ_ID").trim() + "' "; //NO I18N
        }
        if (isDashBoard)
        {
            extraParams += " LABEL='" + ZDBEscapeUtil.encodeForXML(field.getAttribute("LABEL").trim()) + "' "; //NO I18N
        }

        var paramsXML = "<DBSVParams  COLID='" + colId + "' ADDONTYPE='" +//NO I18N
                field.getAttribute("ADDONTYPE") + "' ZAGRIDTYPE='" + view.type //NO I18N
                + "' EXCLUDE='" + (field.getAttribute("EXCLUDE") == "true") + "' "//NO I18N
                + extraParams + " ></DBSVParams>"; //NO I18N
        var doXML = "";
        var parentId =  view.parentViewId;
        if (isDashBoard)
        {
            doXML = ZDBDStructure.getDashBoardCurrentConfig(view, false);
            //$#Dash#$ doXML = ZRDashboardLayoutAPI.getCurrentConfig(view, false);
            parentId = field.getAttribute("PARENT_OBJ_ID");
        }
        else
        {
            if (view.type === "WIDGET")
            {
                doXML = WidgetEditor.editor.functions.getPreviewConfig();
                parentId = WidgetEditor.editor.parentViewId;
            }
            else
            {
                doXML = ZDBAnalysisConfig.getCurrentConfig(view, false);
            }

        }
        var xml = "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n" + paramsXML + "\n" + doXML + "</DBSVRequest>";//NO I18N
        //$$ URL Size would become bigger.
        var toSendURL = "/ZAFilterUI.cc?PARENTVIEWID=" + parentId + "&COLPARENTVIEWID=" + colParViewId + "&ISINTEGRATED=" + ZDBGlobal.integrated + view.viewCtx.getAdditionalParams(); //NO I18N

        if (!ZDBUtil.isNewView(view))
        {
            toSendURL += "&OBJID=" + view.objId;//NO I18N
        }
        else
        {
            if (isDashBoard)
            {
                toSendURL += "&DBID=" + view.dbId; // NO I18N
            }
        }
        var compType = field.getAttribute("COMPTYPE");
        var includeTime = field.getAttribute("INCLUDETIME");
        var dlg = ZDBDialogUtil.focusDialog;
        if(dlg && viewType == "VMFILTERCRITERIA")
        {
            compType = dlg.modifyProps.comptype;
            includeTime = dlg.modifyProps.includetime;
        }
        var onlyRange = (compType == "dr" || compType == "slider") ? true : false;//NO I18N
        toSendURL += "&ISONLYRANGE=" + onlyRange; //NO I18N
        var includeTime = (includeTime == null || includeTime == "true") ? true : false;
        toSendURL += "&INCLUDETIME=" + includeTime; //NO I18N
        toSendURL += "&VMOD=true" + "&VMFILTER=" + (viewType == "VMFILTERCRITERIA"); //No I18N
        toSendURL += "&RELVMFILTER=" + isRelVMFilter; //No I18N
        toSendURL += "&ISDASHBOARD=" + (view.type == "Dashboard");
        if (view.type === "WIDGET")
        {

            toSendURL += "&ISWIDGET=" + (view.type === "WIDGET");
        }
        field.isReplace = isReplace;
        var filterLoading;
        if (compType == "slider")
        {
            filterLoading = DOMUtils.getChildElsWithAttr(field, "elname", "sliderLoading")[0]; //NO I18N
        }
        else
        {
        	filterLoading = (viewType == "VMFILTERCRITERIA") ? filterNav.filterLoading : view.filterLoading;//No I18N
        }
        
 /*       if(onlyRange && ZDBClientUI.isNewRequest)
        {
           toSendURL = "/VMFilterDataFetch.cc?VMFILTERLBLNAME="+encodeURIComponent(field.getAttribute("LABEL").trim())+"&VMFILTERACTION=RANGEFETCH";// NO I18N 
           toSendURL+="&PARENTVIEWID="+field.getAttribute("PARENT_OBJ_ID").trim();// NO I18N
           xml=doXML; 
        }*/
        AjaxAPI.sendRequest({URL: toSendURL, REQUESTHEADERS: {"Content-type": "text/xml;charset=utf-8"},
            POSTBODY: xml,
            ONSUCCESSFUNC: ZDBAnalysisFilter.updateNavPanel,
            OPSTATUSID: filterLoading,
            FIELDEL: field, REPLACEEL: replaceEl, FILTERNAV: filterNav, COMPTYPE: compType, VIEW: view});
    }



  this.updateNavPanel = function(response,requestOptions)
  {
    var compType =   requestOptions["COMPTYPE"];
    if(compType=="slider")
    {
        ZAVMFilterEdit.updateSliderRanges(response,requestOptions);
        return;
    }
    var div = document.createElement("DIV");
    var view = requestOptions["VIEW"];
    div.innerHTML = response.getOnlyHtml();
    div.fieldEl = requestOptions["FIELDEL"];
    var filterNav = requestOptions["FILTERNAV"];
    div.fieldEl.filterEl = div;
    filterNav.filterEl = div;
    div.setAttribute("FILTEREL","true");
    ZDBUtil.setNamedChildEls(div,div);
    var viewtype = div.fieldEl.getAttribute("viewtype");
    var subtype = div.fieldEl.getAttribute(ZDBAnalysisFilter.getSubType(filterNav));
    if(compType !="dr" && compType !="slider" && viewtype == "VMFILTERCRITERIA"){
        ZDBAnalysisFilter.resetNCountHolderVisible(div,true);
        subtype = ZDBDialogUtil.focusDialog.modifyProps[ZDBAnalysisFilter.getSubType(filterNav).toLowerCase()];
    }
    var subOperation = "subOperation"+subtype //NO I18N
     if(div[subOperation]!=null)
    {
      ZDBAnalysisUtil.setElementSelected(div[subOperation], null, "defAnchor deselectedLink", "selectedLink"); //No I18N
    }
    ZDBAnalysisFilter.placenReplaceFilterEl(view, div.fieldEl, filterNav, viewtype);
//    if(compType == "numCombo")
//    {
//        ZDBAnalysisFilter.handleCascadeListCombo(div.fieldEl);
//    }
    ZDBRankingRefFilter.updateRefColDet(div.fieldEl);
    if(viewtype=="VMFILTERCRITERIA" && !(filterNav.getAttribute("relVMFilterNav")=="true") && compType!="slider" )
    {
        ZAVMFilterEdit.handleSlcValOnly();
        div.scrollInitialized = false;
        ZDBAnalysisFilter.initScroller(div);
    }
    
  }

  this.getExtraParamsForRelDt = function(field)
    {
        var extraParams = "";
        var criteria = field.getAttribute("REL_CRITERIA");
        var displCriteria = field.getAttribute("REL_DISPCRITERIA");
        var type = field.getAttribute("REL_SUBTYPE");
        var nr = field.getAttribute("REL_NR");
        var viewType = field.getAttribute("VIEWTYPE");
        var dlg = ZDBDialogUtil.focusDialog;
        if(viewType == "VMFILTERCRITERIA" && dlg)
        {
            criteria = dlg.modifyProps.rel_criteria;
            displCriteria = dlg.modifyProps.rel_dispcriteria;
            
            type = dlg.modifyProps.rel_subtype;
            nr = dlg.modifyProps.rel_nr;
        }
        if(nr)
        {
            extraParams += " NR='"+ZDBEscapeUtil.encodeForXML(nr)+"' "; //NO I18N
        }
        type = (type) ? type : "100";
          extraParams += " SUBTYPE='"+type+"' " + " OPERATION='"+"PF";//NO I18N
         if(criteria && criteria != "")
        {
            criteria = "' CRITERIA='" + ZDBEscapeUtil.encodeForXML(criteria)+ //NO I18N
            "' DISPLAYCRITERIA='" + ZDBEscapeUtil.encodeForXML(displCriteria);//NO I18N
        }
        else
        {
          criteria = "";
        }
        extraParams += criteria;
        return extraParams;
    }

  this.getExtraParams = function(field)
  {
        var extraParams = "";   
        var criteria = field.getAttribute("CRITERIA");
        var displCriteria = field.getAttribute("DISPLAYCRITERIA")
        var type = field.getAttribute("SUBTYPE");
        var nr = field.getAttribute("NR");
        var operation = field.getAttribute("OPERATION");
        var viewType = field.getAttribute("VIEWTYPE");
        var dlg = ZDBDialogUtil.focusDialog;
        if(viewType == "VMFILTERCRITERIA" && dlg)
        {
            criteria = dlg.modifyProps.criteria;
            displCriteria = dlg.modifyProps.displaycriteria;
            type = dlg.modifyProps.subtype;
            nr = dlg.modifyProps.nr;
            operation = dlg.modifyProps.operation;
        }
        if(nr)
        {
            extraParams += " NR='"+ZDBEscapeUtil.encodeForXML(nr)+"' "; //NO I18N
        }
  //      var type = type;//parseInt(view.field.getAttribute("SUBTYPE"));//ZAVMFilterEdit.getSubType(form,compType)//field.getAttribute("SUBTYPE");
        type = (type)? type: "1";
        extraParams += " SUBTYPE='"+type+"' " + " OPERATION='"+ operation.trim();//NO I18N
        if(criteria && criteria != "")
        {
            criteria = "' CRITERIA='" + ZDBEscapeUtil.encodeForXML(criteria)+ //NO I18N
            "' DISPLAYCRITERIA='" + ZDBEscapeUtil.encodeForXML(displCriteria);//NO I18N
        }
          else
        {
          criteria = "";
        }
        extraParams += criteria;
        return extraParams;
  }
    this.handleCascadeListCombo = function(fieldEl)
    {
        var subType = fieldEl.getAttribute("SUBTYPE");
        if(fieldEl.getAttribute("VIEWTYPE") == "VMFILTERCRITERIA")
        {
            subType = ZDBDialogUtil.focusDialog.modifyProps.subtype;
        }
        var relaventOpt = DOMUtils.getChildElsWithAttr(ZDBDialogUtil.focusDialog,"elName","true")[0]; //No I18N
        ZAVMFilterEdit.updateSelItem(ZDBDialogUtil.focusDialog.cascadeList,"false","cascadelist");//No I18N
        if(relaventOpt)
        {
            if((subType==3||subType==4 || subType==2))
            {
                relaventOpt.style.display="none";//No I18N
            }
           else if(subType==1)
           {
               relaventOpt.style.display="block";//No I18N
           }
        }
    }
  this.setBestFilterFunction = function(field,view)
  {
   if(field==null)
   {
     return null;
   }
   var addontype = field.getAttribute("addontype").toUpperCase();

   if(addontype==null || addontype=="CATEGORICAL")
   {
     return null;
   }


    var no_droppedFields = view.currentList.length;


  var sameColumn = false;
  var sameColumnType = false;
  var origDt= field.getAttribute("origdatatype");
        var isGeoFilter  = origDt=="GEO" || origDt=="GEO_NUM"; // NO I18N
  var functionApplied = null;
  var subtype = field.getAttribute("subtype");
  var functionToBeApplied = null;
   //Scanning the Axis Columns and Setting the Variables
   for(i=0; i<no_droppedFields; i++)
    {
      if(view.currentList[i].getAttribute("viewType")=="FILTERAXIS"){continue;}

    var columnMatched = (field.getAttribute("column_id")==view.currentList[i].getAttribute("column_id"));

      if(columnMatched==true)
      {
      var sameColumn = true;
      var sameColumnType = true;
      var functionApplied = view.currentList[i].getAttribute("operation");
      var functionApplied = (functionApplied!="GEO" && functionApplied!="DISCRETE" && functionApplied!="CONTINUOUS" && functionApplied!="MEACATEGORY" && addontype=="NUMBER")?"SUMMARY":functionApplied;//NO I18N

      if(functionApplied=="SUMMARY")
      {
          functionToBeApplied=view.currentList[i].getAttribute("operation");
      }
      else if(functionApplied=="GEO")
      {
          functionToBeApplied = "CONTINUOUS";//NO I18N
      }
      if(view.typeValue!=ZDBClientViewAPI.TYPE_WIDGET && ZDBLegendTools.parLegendEl != null)
      {
          var graphType = ZDBLegendTools.parLegendEl.getAttribute("graphtype");
          if(graphType == "8" && functionApplied == "SUMMARY")
          {
              functionToBeApplied = "CONTINUOUS";//NO I18N
          }
      }
      break;
      }
            if((view.currentList[i].getAttribute("addontype")==addontype) && (sameColumnType==false))//ONLY FIRST MATCHES
      {
      var sameColumnType = true;
      var functionApplied = view.currentList[i].getAttribute("operation");
      var functionApplied = (functionApplied!="DISCRETE" && functionApplied!="CONTINUOUS")?"SUMMARY":functionApplied;//NO I18N

      if(functionApplied=="SUMMARY"){
        functionToBeApplied=view.currentList[i].getAttribute("operation");
        }
      continue;
      }

      if((view.currentList[i].getAttribute("addontype")!=addontype) && (sameColumnType==false)
                        && (view.currentList[i].getAttribute("operation")=="COUNT") && !isGeoFilter) // NO I18N
      {
         var functionApplied = "COUNT";//NO I18N
      }
    }

   //Matching Rules
   if(addontype!=null || addontype!="CATEGORICAL")
   {
            var rules = ZDBAnalysisView[addontype.toLowerCase()+"FilterRules"];
   }
   var ruleRowLength = rules.length;

   for(var i =0; i < ruleRowLength  ; i++)
     {
    var currentRule =   rules[i] ;


    var ruleMathched = ( (rules[i][0] == sameColumn) && (rules[i][1] == sameColumnType) && (rules[i][2] == functionApplied) );

    if(ruleMathched)
    {
      if(rules[i][4]=="SAME")
      {
        currentRule = rules[i].slice();
        currentRule[3] = subtype;
        currentRule[4] = functionToBeApplied;
      }

      if(rules[i][4]!="SAME" && rules[i][3]=="DEF")
      {
        currentRule = rules[i].slice();
        currentRule[3] = subtype;
        ZDBUtil.setNamedChildEls(field,field);
        ZDBAnalysisFilter.blinkCounter=0;
        if(field.functionDisplay){
            field.functionDisplay.setAttribute("afs","" + ZDBAnalysisFilter.counter++);
        }
        ZDBAnalysisFilter.curFieldFunctionDisplay = field.functionDisplay;
                                var dbColName = field.getAttribute('dbcolName');
                                if(dbColName != ZDBConst.DYNAMIC_COL_NAME)
                                {
                                  ZDBAnalysisFilter.intervalID = setTimeout(ZDBAnalysisFilter.hightlightFunctionChanged,200);
                                }
        //field.functionDisplay.style.background = "#FFF000";
      }


      break;
    }
    currentRule = null;
   }

   var rule = currentRule
   if(rule !=null)
     {
       ZDBAnalysisView.setOperationOnField(field,rule[4],"FILTERAXIS",rule[3],view);
     }
     else
     {
       return null;
     }
  }

  this.counter=0;
  this.hightlightFunctionChanged = function()
  {
    var el = ZDBAnalysisFilter.curFieldFunctionDisplay;
    if(!el){return;}
    if(ZDBAnalysisFilter.blinkCounter<5)
    {
      if((ZDBAnalysisFilter.blinkCounter%2)!=0)
      {
        el.className = "dragElFuncBg";
      }
      else
      {
        el.className="dragElFuncBgHighlight";
      }
      ZDBAnalysisFilter.blinkCounter++;
      setTimeout(ZDBAnalysisFilter.hightlightFunctionChanged,200);
    }
    else
    {
      el.className="dragElFuncBg";
    }
  }

  this.OpenSelectedFilterField = function(field,event)
  {
    ZDBAnalysisView.expandDropField(field);
    ZDBAnalysisFilter.selectFilterField(null,field);
    //ZDBAnalysisFilter.constructFilterSummary(field);
  }
  this.selectFilterField = function(view,field,replaceEl,filterNav, filterEl)
  {
    ZDBAnalysisFilter.selectnReplaceFilterField(view, field, replaceEl,true ,filterNav, filterEl);
  }
  this.selectnReplaceFilterField = function(view,field,replaceEl,isReplace,filterNav, filterEl)
    {
    if(field)
    {
        if(!field.getAttribute("viewtype"))
        {
            field = null;
        }
    }
    if(view==null)
    {
            var view = ZDBClientUI.getViewObj(field,"view");
    }
    replaceEl = (replaceEl == null) ? view.defaultNav : replaceEl;
    if(!filterNav)
    {
        filterNav = ZDBAnalysisFilter.getFilterNav(view,filterEl);
    }
    filterNav.selectedField = field;
    
    if(field != null)
    {
      ZDBUtil.removeNonElements(field.parentNode);
        var viewType = field.getAttribute("VIEWTYPE");
        var siblings = field.parentNode.childNodes;
        if(siblings!=null)
        {
            if(field.getAttribute("viewtype")!="VMFILTERCRITERIA")
            {
                for(var i=0; i< siblings.length; i++)
                {
                    siblings[i].className = (siblings[i]==field)? "zdbdragfield sel":"zdbdragfield";
                }
            }
        }
        var fetcheEl = viewType == "VMFILTERCRITERIA" ? filterNav : field;//NO I18N
        if(fetcheEl.filterEl != null)
        {  
          var dlg = ZDBDialogUtil.focusDialog;
          var replaceEl = fetcheEl.filterEl;
          if(viewType == "VMFILTERCRITERIA" && !(filterNav.getAttribute("relVMFilterNav") == "true") && dlg && dlg.modifyProps.comptype!="slider")
          {
              ZAVMFilterEdit.handleSlcValOnly();
          }
        }
        else
        {
          ZDBAnalysisFilter.sendFilterFieldInfo(field,replaceEl,isReplace,filterNav);
          this.selectedFilterField=field;
          return;
        }
    }
    
    this.placenReplaceFilterEl(view, field, filterNav, viewType, replaceEl);
//  
  }


   this.placenReplaceFilterEl = function(view, field, filterNav, viewtype,replaceEl)
   {
        if(!replaceEl)
        {
            replaceEl = filterNav.filterEl ? filterNav.filterEl : filterNav.firstElementChild;
        }
        replaceEl.style.height="100%";
        var dlg = ZDBDialogUtil.focusDialog;
        ZDBUtil.removeNonElements(filterNav);
        var isNotRelEl = filterNav.getAttribute("elname") == "relVMFilterNav" ? false : true; //No I18N
        var filterEl_old = DOMUtils.getChildElsWithAttr(filterNav,"filterel","true")[0]; //No I18N
        (viewtype == "VMFILTERCRITERIA" && !(filterEl_old) && isNotRelEl) ?  dlg.VMFilterNavDiv.style.display="none" : null;
        var compValueEl = ZDBUtil.getParentWithAttributeValue(filterNav,"elname","componentValues");//No I18N
        (compValueEl) ? compValueEl.removeAttribute("tobefetched"):null;//for qa.
        if((filterNav.firstChild) && (filterNav.firstChild != replaceEl))
        {
          filterNav.replaceChild(replaceEl,filterNav.firstChild);
        }
        else
        {
          filterNav.appendChild(replaceEl);
        }
        ZDBAnalysisFilter.initScroller(replaceEl);
        if(viewtype == "VMFILTERCRITERIA")
        {
            var compType = dlg.modifyProps.comptype;
            if($("itemList") && compType != "dr" && isNotRelEl && !(filterEl_old))
            {
               ZAVMFilterEdit.setIncludeOthers(view);
            }
            if(field && field.filterEl != null && compType =="dr") // field.filterEl != null && //this is only for VM Filter
            {
                ZAVMFilterEdit.checkNInitCalender(view,replaceEl,field);
            }
        }   
   }

  this.constructFilterSummary = function(field,view)
  {
    if(field==null)
      {
      field = ZDBAnalysisFilter.selectedFilterField;
        if(!field.getAttribute("viewtype"))
        {
          field = null;
          return "";
        }
      }
      if(view==null)
      {
              var view = ZDBClientUI.getViewObj(field,"view");
      }

      var fieldName = field.getAttribute("title");
      var operation = field.getAttribute("operation");
      var dtype = field.getAttribute("dtype");
      var addontype = field.getAttribute("addontype");
      var include = (field.getAttribute("exclude")==="false" || field.getAttribute("exclude")==="");
      var comparisonOperator = (include==true)?" IN ":" NOT IN ";// NO I18N
      var equivalentOperation = ZDBAnalysisFilter.getEquivalentOperation(field,dtype,addontype,operation);

      var displaycriteria = field.getAttribute("displaycriteria");
      displaycriteria = displaycriteria.substring(0, displaycriteria.length - 1);
      displaycriteria = ZDBUtil.replaceAll(displaycriteria,'--C--',',');// NO I18N

      var grammar = equivalentOperation + "("+fieldName+")"+((displaycriteria=="" || displaycriteria==null)?"":(comparisonOperator+displaycriteria));
      $("ZAFilterColumnTitle").innerHTML =  ZDBEscapeUtil.encodeForHtml(grammar);
      $("ZAFilterColumnTitle").setAttribute("title",grammar);
  }

  this.getEquivalentOperation = function(field, dtype,addontype,operation)
  {
    if(!dtype || !addontype || !operation){return "";}
    var subOperation = field.getAttribute("subtype");

        var equivalentOperation = {
            DIMENSIONAL: 
                    {
                        CATEGORICAL: {GROUPBY: "Actual Values", COUNT: "Count", DC: "Distinct Count",GEO:"Geo location"}, // NO I18N                        
                        ABSDATECATEGORICAL: {ABS: "Actual " + ZDBAnalysisFilter.getSubOperationName(subOperation, 0), // NO I18N
                    REL: "Seasonal " + ZDBAnalysisFilter.getSubOperationName(subOperation, 1), // NO I18N
                    PF: "Relative " + ZDBAnalysisFilter.getSubOperationName(subOperation, 2)// NO I18N
                }
            },
            MEASURE: {
                NUMBER: {SUM: "Sum", MAX: "Max", MIN: "Min", AVG: "Average", STD: "Standard Deviation", VAR: "Variance", COUNT: "Count", DC: "Distinct Count", CONTINUOUS: "Actual Values"}// NO I18N
            }
        }


    return equivalentOperation[dtype][addontype][operation];
  }

  this.getSubOperationName = function(subOperation,operationIndex)
  {
    if(subOperation==null){return "";}
    var operationCode = "SUB"+subOperation;// NO I18N
    var subOperationName = [
                         // ACTUAL SUB FUNCTION
                            {SUB100:"Year", SUB108:"Quarter", SUB101:"Month", SUB109:"Week", SUB105:"Date", SUB106:"Date & Time", SUB107:"Range"},// NO I18N
                         // SEASONAL SUB FUNCTIONS
                            {SUB108:"Quarter",SUB101:"Month", SUB109:"Week", SUB102:"Week Day", SUB103:"Day of Month", SUB104:"Hour"},// NO I18N
                         // RELATIVE SUB FUNCTIONS
                  {SUB100:"", SUB110:"Year", SUB108:"Quarter", SUB101:"Month",SUB102:"Week", SUB103:"Day", SUB104:"Hour"}// NO I18N
                  ];
    return subOperationName[operationIndex][operationCode];
  }

  this.getFilterNav = function(view,srcel)
  {
       var dlg = ZDBDialogUtil.focusDialog;
       var relVMFilterNav = srcel!=null ? ZDBUtil.getParentWithAttributeValue(srcel,"elname","relVMFilterNav") : null; //NO I18N
       if(relVMFilterNav !=null)
       {
           return relVMFilterNav;
       }
      if(dlg && dlg.field)//vmfilter
      {
            return dlg.field.filterNav;
      }
    return view.filterNav;
  }

//  this.getFilterLoading = function(filterNav)
//  {
////    if(view.field!=null)
////    {
////      if(view.field.getAttribute("viewtype")=="VMFILTERCRITERIA")
////      {
////        var filterLoading = (view.field.filterNav.filterLoading);
////      }
////    }
////    else{
////      var filterLoading = view.field.filterLoading;
////    }
//    return filterNav.filterLoading;
////    return filterLoading;
//  }


  this.initScroller = function(replaceEl)
  {
    if(replaceEl.scrollInitialized){return;}
    ZDBUtil.setNamedChildEls(replaceEl,replaceEl,"scrollel");//NO I18N
    if(replaceEl.left && replaceEl.right){
    ZDBScroller.checkNSetButtonStyle(replaceEl);
    replaceEl.scrollInitialized = true;
    }
  }
  this.checkRefColNUpdate= function(filterEl)
  {
    if(filterEl.selItemHolder && filterEl.selItemHolder.childNodes)
    {
      var refColId = filterEl.fieldEl.getAttribute("REFERREDCOLUMNID");
      return refColId!="" && refColId != null;
    }
      return false;
  }

  this.filterChanged = function(selField,event)
  {
      var filterEl = DOMUtils.getParentWithAttr(selField,"FILTEREL");
      var view = ZDBClientUI.getViewObj(selField,"view");
      var fieldEl = filterEl.fieldEl;
      var viewType = fieldEl.getAttribute("viewType");
      var catnavarea = DOMUtils.getParentWithAttrValue(selField,"catnavarea","true");//NO I18N
      var funDiv = DOMUtils.getFirstMatchingChild(catnavarea,"a","noeffect","true");//NO I18N
      var subType = fieldEl.getAttribute("SUBTYPE");
      if(viewType == "VMFILTERCRITERIA") 
      {
          subType = ZAVMFilterEdit.modifyProps.subtype;
      }
      var prevEl = DOMUtils.getFirstMatchingChild(filterEl.itemList,"div","prevEl","true");//No I18N
      var isRangeType = DOMUtils.getFirstMatchingChild(filterEl.itemList,"*","id","ADDNEWRANGE");//No I18N
      if(!isRangeType)      
        {
          var scrollElHolder = DOMUtils.getParentWithAttrValue(selField,"scrollel","holder");//No I18N
          var shiftSelHelpHolder = DOMUtils.getFirstMatchingChild(scrollElHolder,"div","elname","shiftSelHelpHolder");//No I18N
          var showShiftHelp = (viewType == "FILTERAXIS") ? view.showShiftHelpFilter : view.showShiftHelpVMFilter;//No I18N
          var isWidget = view.typeValue === ZDBClientViewAPI.TYPE_WIDGET;
          if(shiftSelHelpHolder && showShiftHelp && !isWidget)
      {
            var shiftSelHelp = DOMUtils.getFirstMatchingChild(shiftSelHelpHolder,"*","elname","shiftSelHelp");//No I18N
            shiftSelHelpHolder.style.display = "inline-block";  
            var shiftSelHelpOffWidth = shiftSelHelp.offsetWidth;
            var dropAreaPanel = DOMUtils.getParentWithAttrValue(shiftSelHelpHolder,"elname","dropAreaPanel");//No I18N
            var scrollElHolderAbsLeft = 0;
            if(dropAreaPanel)
              {
                scrollElHolderAbsLeft = ZDBUtil.getObjLeft(scrollElHolder,null,dropAreaPanel);
                jQuery(shiftSelHelpHolder).addClass("shiftSelHelpFilterPosition");
              }
            else
              {
               shiftSelHelpOffWidth =  shiftSelHelpOffWidth;//for vmfilter selected value dialogue.
                jQuery(shiftSelHelpHolder).addClass("shiftSelHelpVMFilterPosition");
              }
            shiftSelHelpHolder.style.left = ( scrollElHolderAbsLeft + ((scrollElHolder.offsetWidth -  shiftSelHelpOffWidth) / 2) )+"px"; 
            (viewType == "FILTERAXIS") ? view.showShiftHelpFilter = false : view.showShiftHelpVMFilter =false;// No I18N
            jQuery(shiftSelHelpHolder).fadeTo(1500,1);
        setTimeout(function(){ jQuery(shiftSelHelpHolder).fadeTo(1500,0); }, 7000);
        setTimeout(function(){ shiftSelHelpHolder.style.display=""; }, 8500);
      } 
          if(prevEl)
            {
              if(event && event.shiftKey)
                {
                  var startEl = prevEl;
                  var endEl = selField;
                  var prevElParentOffLeft = prevEl.parentNode.offsetLeft;
                  var selFieldParentOffLeft = selField.parentNode.offsetLeft;
                  var changeSelTo = (selField.getAttribute("sel") == "no") ? "yes" : "no";//No I18N
                  if((prevElParentOffLeft > selFieldParentOffLeft) || 
                      ((prevElParentOffLeft == selFieldParentOffLeft) && (prevEl.offsetTop > selField.offsetTop)))
                    {
                      startEl = selField;
                      endEl = prevEl;
                    }
                  this.updateElsInRange(startEl,endEl,changeSelTo);
                  prevEl.removeAttribute("prevEl");
                      selField.setAttribute("prevEl","true");//No I18N
                  return;
                }
              prevEl.removeAttribute("prevEl");
            }
          selField.setAttribute("prevEl","true");//No I18N
        }
        ZDBAnalysisFilter.updateFilterChange(selField); 
      ZDBAnalysisView.setModAndShowRefresh(view);
      //ZDBAnalysisFilter.selectFilterField(null,fieldEl);
      ZDBScroller.setScrollerTop(filterEl.selItemHolder.parentNode);
      //ZDBAnalysisFilter.constructFilterSummary(fieldEl); Commented because issue in this. Will be taken as a separate feature.
      if(subType == "3")
      {
        ZDBRankingRefFilter.updateRefColDet(fieldEl);
      }
  }

   this.hideShiftSelHelp = function(el)
  {
     jQuery(el).fadeTo(1500,0);
     setTimeout(function(){ el.style.display=""; }, 1500);
  }
   this.updateElsInRange = function(startEl,endEl,changeSelTo)
  {
      var curEl = startEl;
      var filterEl = DOMUtils.getParentWithAttr(curEl,"FILTEREL");
      var fieldEl = filterEl.fieldEl;
      var view = ZDBClientUI.getViewObj(curEl,"view");
      ZDBUtil.deepRemoveNonElements(filterEl.itemList,"td");//No I18N
      while(curEl!=endEl)
        {
          ZDBAnalysisFilter.updateFilterChange(curEl,changeSelTo);
          curEl = curEl.nextSibling || curEl.parentNode.nextSibling.firstChild ||
                         curEl.parentNode.nextSibling.nextSibling.firstChild;
        }
      ZDBAnalysisFilter.updateFilterChange(endEl,changeSelTo);
      ZDBAnalysisView.setModAndShowRefresh(view);
//      ZDBAnalysisFilter.selectFilterField(view,fieldEl);
      ZDBScroller.setScrollerTop(filterEl.selItemHolder.parentNode);
      //ZDBAnalysisFilter.constructFilterSummary(fieldEl);
  }
   
  this.updateFilterChange = function(selField,changeSelTo,clear)
  {
    var view = ZDBClientUI.getViewObj(selField,"view");
    var filterEl = DOMUtils.getParentWithAttr(selField,"FILTEREL");
    var selAttrib = selField.getAttribute("sel");
    var selected = (selAttrib=="no");//No I18N
    if(selAttrib == changeSelTo)
    {
      return;
    }
    if(selected)
    {
      if(ZDBRankingRefFilter.checkNThrowRangeExceed(filterEl.fieldEl,selField.getAttribute("filtervalue"), filterEl.fieldEl.getAttribute("referredcolumnid")))
      {
        return;
      }
    }
    ZDBAnalysisFilter.changeSelection(selField,selected);
    if(filterEl.selItemHolder)
    {
        ZDBUtil.removeNonElements(filterEl.selItemHolder);
        var cloneSelField;
        if(selected)
        {
          cloneSelField = selField.cloneNode(true);
          cloneSelField.style.display="block";//NO I18N
          cloneSelField.className="filterFieldRemoveSel";//NO I18N
          cloneSelField.setAttribute("cloned","true");//NO I18N
          cloneSelField.style.height = "";
          cloneSelField.style.paddingBottom = "";
          filterEl.selItemHolder.appendChild(cloneSelField);
          if(cloneSelField.getAttribute("value"))
          {
            cloneSelField.innerHTML = ZDBEscapeUtil.encodeForHtml(cloneSelField.getAttribute("value"));
          }
        }
        else
        {
        cloneSelField = (selField.getAttribute("cloned") == "true")? selField:
        DOMUtils.getFirstMatchingElement(filterEl.selItemHolder.childNodes,null,
                                         "filtervalue",selField.getAttribute("filtervalue"));//NO I18N
        cloneSelField.parentNode.removeChild(cloneSelField);
        selField = (selField.getAttribute("cloned") != "true")?selField:
        DOMUtils.getFirstMatchingElement(filterEl.itemList.getElementsByTagName("div"),null
                                         ,"filtervalue",selField.getAttribute("filtervalue"));//NO I18N

        if(selField != null)
        {
          ZDBAnalysisFilter.changeSelection(selField,selected);
        }

        }
        if(filterEl.fieldEl.getAttribute("viewtype") == "VMFILTERCRITERIA" && !(clear)){
            ZDBAnalysisFilter.resetNCountHolderVisible(filterEl);
        }
        var fieldElHeader = ZDBUtil.getParentWithAttributeValue(selField,"FieldElHeader","true");//NO I18N
        if(fieldElHeader)
        {
          ZDBUtil.setNamedChildEls(fieldElHeader,fieldElHeader,"RefElName");
            fieldElHeader.setAttribute("isSelected",selected);
        var dispColName = ZDBRankingRefFilter.getDispName(filterEl.fieldEl, filterEl);
        if(ZDBAnalysisFilter.checkRefColNUpdate(filterEl))
            {
              var reset = true;
              if(selected)
              {
                ZDBRankingRefFilter.updateRefColDetOfEl(fieldElHeader,selected, dispColName, filterEl);
                reset = false;
              }
              else if(filterEl.selItemHolder.childNodes.length >0)
              {
                reset = false;
              }
            }
            else
            {
              var refColDisp = fieldElHeader.refColDisp;
              refColDisp.innerHTML = dispColName;
              refColDisp.setAttribute("value",dispColName);
            }
            ZDBRankingRefFilter.resetNHideRefCol(fieldElHeader,selected,reset);
        }
    }
    
    var viewType = filterEl.fieldEl.getAttribute("VIEWTYPE");
    var dlg = ZDBDialogUtil.focusDialog;
    var fieldEl = filterEl.fieldEl;
    var selList = (filterEl.selItemHolder !=null)? filterEl.selItemHolder.childNodes:DOMUtils.getChildElsWithAttr(filterEl,"sel","yes");//NO I18N
    var filter = "";
    var dispFilter = "";
    for(var i=0,j = selList.length; i < j ; i++)
    {
      if(selList[i].getAttribute)
      {
        filter +=selList[i].getAttribute("filtervalue") + ",";
        dispFilter +=selList[i].getAttribute("displayfiltervalue") + ",";
      }
    }
    var relFilterEl = ZDBUtil.getParentWithAttributeValue(filterEl,"elname","relVMFilterNav");//NO I18N
    if(relFilterEl)
    {
      if(viewType == "VMFILTERCRITERIA")
      {
    	ZAVMFilterEdit.modifyProps.rel_criteria = filter;
        ZAVMFilterEdit.modifyProps.rel_dispcriteria = dispFilter;
         
      }
      else
      { 
        fieldEl.setAttribute("REL_CRITERIA",filter);
        fieldEl.setAttribute("REL_DISPCRITERIA",dispFilter);
      }
    }
    else
    {
      if(viewType == "VMFILTERCRITERIA")
      {
    	  ZAVMFilterEdit.modifyProps.criteria = filter;
    	  ZAVMFilterEdit.modifyProps.displaycriteria = dispFilter;  
      }
      else
      {
        fieldEl.setAttribute("CRITERIA",filter);
        fieldEl.setAttribute("DISPLAYCRITERIA",dispFilter);
      }
    }
  }

  this.changeSelection = function(filterField,selected)
  {
    filterField.className= (selected)? "filterFieldSel":"filterField";
    var fieldHeader = DOMUtils.getSelfOrParentWithAttrValue(filterField ,"FieldElHeader","true"); // No I18N
    if(fieldHeader && fieldHeader.className){fieldHeader.className= (selected)? "filterHeaderSel" :"filterHeader";}
    filterField.setAttribute("sel",(selected)? "yes":"no");
  }


  this.fetchNext = function(filterEl,freshRequest)
  {
    var view = ZDBClientUI.getViewObj(filterEl,"view");
    if(filterEl.getAttribute("FILTEREL") == null)
    {
      filterEl = DOMUtils.getParentWithAttr(filterEl,"FILTEREL");
    }
    var next = filterEl.itemList.getAttribute("NEXT1");
    if((!freshRequest) && (next == "-1"))
    {
      return;
    }
    if(filterEl.sent || (filterEl.search==null))
    {
      return;
    }
    filterEl.sent = true;
    var search = filterEl.search.searchValue;
    if(search != null && search != "" )
    {
        //search = " SEARCH='" + encodeURIComponent(search)+"' ";
        search = " SEARCH='" + ZDBEscapeUtil.encodeForXML(search)+"' ";//NO I18N
    }
    else
    {
        search = "";
    }
    start = (!freshRequest)? " START='" + next+"' ":"";//NO I18N


    var fieldEl= filterEl.fieldEl;
    var filterNav = ZDBAnalysisFilter.getFilterNav(view,filterEl);
    var viewType = fieldEl.getAttribute("VIEWTYPE");
    var fieldType = fieldEl.getAttribute("FIELD_COL_TYPE");
    var parentObjId= fieldEl.getAttribute("PARENT_OBJ_ID");
    var colId = fieldEl.getAttribute("column_id");
    var isDashBoard = view.typeValue ==ZDBClientViewAPI.TYPE_DASHBOARD;
    var isWidget = view.typeValue ==ZDBClientViewAPI.TYPE_WIDGET;
    var type = fieldEl.getAttribute("SUBTYPE");
    var operation = fieldEl.getAttribute("OPERATION");
    var nr = fieldEl.getAttribute("NR");
    if(viewType == "VMFILTERCRITERIA")
    {
        var dlg = ZDBDialogUtil.focusDialog;
        operation = dlg.modifyProps.operation;
        type = dlg.modifyProps.subtype;
        nr = dlg.modifyProps.nr;
    }

     if(isDashBoard)
      {
        extraParams+=" LABEL='"+fieldEl.getAttribute("LABEL").trim()+"' "; //NO I18N
      }
     var doXML = "";
     var parentId;
    if(isDashBoard)
    {
        doXML  = ZDBDStructure.getDashBoardCurrentConfig(view,false);
        parentId = fieldEl.getAttribute("PARENT_OBJ_ID");
    }
    else if(isWidget)
    {
       var isNew = ZDBUtil.isNewView(view);
       if(isNew)
       {
         editor = view.viewComp;
         doXML = WidgetUtils.getZADataConfig(editor.objId, editor, false, true);
         parentId = editor.parentViewId ;
       }
       else
       {
         doXML = WidgetUtils.getConfig(view.objId, view, !isNew);
         parentId = view.parentViewId ;
       }
    }
    else
    {
        doXML = ZDBAnalysisConfig.getCurrentConfig(view,false);
        parentId = view.parentViewId ;
    }

    var extraParams = "";
    if(nr != null && nr != "")
    {
        extraParams += " NR='"+ZDBEscapeUtil.encodeForXML(nr)+"' "; //No I18N
    }
    if(type != null && type != "")
    {
        extraParams += " SUBTYPE='"+type+"' ";//NO I18N
    }

    var paramsXML = "<DBSVParams  COLID='" + colId + "' ADDONTYPE='"//NO I18N
                               + fieldEl.getAttribute("ADDONTYPE")
                               + "' OPERATION='" + operation//NO I18N
                               + "' ZAGRIDTYPE='"+view.type//NO I18N
                               + "' ft='"+fieldType //No I18N
                               + "' po='"+parentObjId //No I18N
                               + "' NEXTPAGE='true'"//NO I18N
                               + search
                               + start+ extraParams + " />";
    var xml = "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n"+paramsXML+"\n"+doXML+"</DBSVRequest>";//NO I18N

    var colParViewId = fieldEl.getAttribute("PARENT_OBJ_ID") != null ? fieldEl.getAttribute("PARENT_OBJ_ID").trim() : view.parentViewId ;

    var params = "PARENTVIEWID="+parentId +  "&COLPARENTVIEWID=" + colParViewId + view.viewCtx.getAdditionalParams(); //NO I18N
    if(!ZDBUtil.isNewView(view))
    {
      params += "&OBJID=" + view.objId;//NO I18N
    }
    else
    {
      if(isDashBoard)
      {
        params += "&DBID=" +view.dbId; // NO I18N
      }
    }
     params +="&ISDASHBOARD="+(view.type == "Dashboard");
     params +="&VMFILTER="+(viewType==="VMFILTERCRITERIA"); //No I18N
   var filterLoading = filterNav.filterLoading;//ZDBAnalysisFilter.getFilterLoading(filterNav);
    AjaxAPI.sendRequest({URL:"/ZAFilterUI.cc?" + params,
                               REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},//NO I18N
                               POSTBODY:xml,
                                          ONSUCCESSFUNC:ZDBAnalysisFilter.appendItems,
                                          FRESHREQUEST:freshRequest,
                                          FILTEREL:filterEl,OPSTATUSID:filterLoading});
    return false;
  }

  this.appendItems = function(response,requestOptions)
  {
    var filterEl = requestOptions["FILTEREL"];
    var div = document.createElement("DIV");
    div.innerHTML = response.getOnlyHtml();
    var tr = div.getElementsByTagName("tr")[0];
    var itemList = filterEl.itemList;
    if(!requestOptions["FRESHREQUEST"])
    {
      var newItems = tr.getElementsByTagName("td");
      newItems = LangUtils.cloneArray(newItems);
      ZDBUtil.removeNonElements(itemList);
      if(itemList.lastChild.getAttribute("loadingTd") == "true")
      {
        itemList.removeChild(itemList.lastChild);
      }
      for(var i= 0, j = newItems.length; i < j; i++)
      {

        var newItem = newItems[i];
        itemList.appendChild(newItem);
        prevItem = newItem;
      }
      itemList.setAttribute("NEXT1",tr.getAttribute("NEXT1"));
      if(itemList.getAttribute("NEXT1") == -1)
      {
        itemList.removeChild(itemList.lastChild);
      }
    }
    else
    {
      itemList.parentNode.replaceChild(tr,itemList);
      filterEl.itemList = tr;
      DOMUtils.getParentWithAttr(tr,"scrollel").style.marginLeft="0px";//No I18N

    }
    ZDBAnalysisFilter.selectSelectedFilterItems(filterEl);
    ZDBScroller.checkNSetButtonStyle(filterEl);
    filterEl.sent = false;
  }

  this.selectSelectedFilterItems = function(filterEl)
  {
    var valContainer = filterEl.itemList;
    var viewType = filterEl.fieldEl.getAttribute("VIEWTYPE");
    var curFilter = viewType == "VMFILTERCRITERIA" ? ZDBDialogUtil.focusDialog.modifyProps.criteria : filterEl.fieldEl.getAttribute("CRITERIA");//NO I18N
//    var curFilter = ","+this.getFilterCriteria(filterEl)[0];//filterEl.fieldEl.getAttribute("CRITERIA");
    if((curFilter != null) && (curFilter != ""))
    {
      var childNodes = valContainer.getElementsByTagName("div");
      for(var i=0; i < childNodes.length; i++)
      {
        var value = childNodes[i].getAttribute("filtervalue");
        if((value != null) && (curFilter.indexOf(","+value +",") > -1))
        {
          ZDBAnalysisFilter.changeSelection(childNodes[i],true);
        }
      }
    }
  }


  this.checkKeyAndSearch = function(el,ev)

  {
    if(!ev){ev = window.event}
    if(ev.keyCode == 13)
    {
      el.searchValue = el.value;
      ZDBAnalysisFilter.fetchNext(el,true);
      return false;
    }
    return true;
  }

  this.clearSearch=function(el,ev)
  {
      var filterEl = DOMUtils.getParentWithAttr(el,"FILTEREL");
      filterEl.search.searchValue="";
      ZDBAnalysisFilter.fetchNext(el,true);
  }

  this.confirmAndResetFilters = function(el)
  {
    var view = ZDBClientUI.getViewObj(el,"view");
    ZDBUtil.removeNonElements(view.filterAxis);
    var filteredEls=view.filterAxis.childNodes;

    if(filteredEls.length>0)
    {
        ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.analysis.js.clearFilterConfirm"),"ZDBYESNO",{ONCLICK:ZDBAnalysisFilter.clearAllFilter,VIEW:view});//NO I18N
    }

  }

  this.clearAllFilter = function(clickType,event,view)
  {
    if(clickType == "NO"){return;}
    /*var holderParent = DOMUtils.getParentWithAttr(linkClicked,"holderParent");
    ZDBUtil.setNamedChildEls(holderParent,holderParent);*/
    if(view == null)
    {
      view= ZDBDialogUtil.currentViewObj;
    }
    ZDBUtil.removeNonElements(view.filterAxis);
    var filteredEls=view.filterAxis.childNodes;
    while(filteredEls.length>0)
    {
      view.removeField(filteredEls[0],true);//Assuming that the spacer will come last
    }
    var fieldToShow = null;
    ZDBAnalysisFilter.selectFilterField(view,fieldToShow);
    ZDBAnalysisView.showRefreshDiv(view);
  }

  this.clearSelected = function(el)
  {
     var filterel  = ZDBUtil.getParentWithAttributeValue(el,"filterel","true");//NO I18N
      this.clearAllSelected(filterel,el);

  }
  this.clearAllSelected = function(filterEl,el)
  {
    if(filterEl==null)
    {
       filterEl = DOMUtils.getFirstMatchingChild(el,"div","filterel","true");//NO I18N
    }
    var itemSelectedContent= filterEl.selItemHolder;
    if(itemSelectedContent==null)
    {
            return;
    }
    ZDBUtil.removeNonElements(itemSelectedContent);
    var itemSelected= itemSelectedContent.childNodes;
    var view = ZDBClientUI.getViewObj(itemSelectedContent,"view");
    var fieldEl = filterEl.fieldEl;
    var prevEl = DOMUtils.getFirstMatchingChild(filterEl.itemList,"div","prevEl","true");//No I18N
    if(prevEl)
      prevEl.removeAttribute("prevEl");
    while(itemSelected.length>0)
    {
      this.updateFilterChange(itemSelected[0],null,true);
    }
    if(fieldEl.getAttribute("viewtype") == "VMFILTERCRITERIA")
    {
        ZDBAnalysisFilter.resetNCountHolderVisible(filterEl);
    }
    ZDBAnalysisView.setModAndShowRefresh(view);
    ZDBAnalysisFilter.selectFilterField(null,fieldEl,null,null,filterEl);
    //ZDBAnalysisFilter.constructFilterSummary(fieldEl);
    var subType = fieldEl.getAttribute("subType");
    if(fieldEl.getAttribute("viewtype") == "VMFILTERCRITERIA")
    {
        subType = ZDBDialogUtil.focusDialog.modifyProps.subtype;
    }
    if(subType=="3")
    {
          ZDBRankingRefFilter.updateRefColDet(fieldEl);
    }
    if(fieldEl.getAttribute("viewtype") != "VMFILTERCRITERIA")
    {
        ZDBRankingRefFilter.resetRefColIfNeeded(filterEl);
    }
  }
  

  this.selectAll = function()
  {
    this.clearAllSelected();

    var itemList = $("itemList");
    var div = itemList.getElementsByTagName("div");
    var totalItems = div.length;
    while(totalItems>0)
    {
      totalItems = totalItems -1;
      this.filterChanged(div[totalItems]);
    }
  }


  this.changeExcludeOpt = function(el)
  {
  var el = $("ZDBExcludeOption");
  var view = ZDBClientUI.getViewObj(el,"view");
  var filterEl = DOMUtils.getParentWithAttr(el,"FILTEREL");
  ZDBUtil.setNamedChildEls(filterEl,filterEl);
  var curSettings = el.getAttribute("selectedValue");
  var newSettings = (curSettings=="includedOpt")? "false":"true";//NO I18N
  if(curSettings=="includedOpt")
  {
    filterEl.selectOpt.setAttribute("selectedValue","includedOpt");
  }
  else
  {
    filterEl.selectOpt.setAttribute("selectedValue","excludedOpt");
  }
    filterEl.fieldEl.setAttribute("EXCLUDE",newSettings);

    var itemSelectedContent= $("itemSelectedContent");
    ZDBUtil.removeNonElements(itemSelectedContent);
    var itemSelected= itemSelectedContent.childNodes;
    //ZDBAnalysisFilter.constructFilterSummary(filterEl.fieldEl);
    if(itemSelected.length>0)
    {
      ZDBAnalysisView.setModAndShowRefresh(view);
    }
  }



this.showRangeDlg = function(el, showDIV,event)
{
    if(!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList","APPENDTODOC",ZDBAnalysisFilter.showRangeDlg,[el,showDIV,event]))
    {
      return;
    }
    if(!event)
    {
      event = window.event;
    }
    var view = ZDBClientUI.getViewObj(el,"view");
    var filterNav = ZDBAnalysisFilter.getFilterNav(view,el);
    var rangeDiv =  DOMUtils.getFirstMatchingChild(filterNav,"div","id", showDIV);//$(showDIV); // NO I18N
    if(rangeDiv!=null && (filterNav.selectedField.rangeDivID!=showDIV))
    {
        filterNav.selectedField.rangeDiv = rangeDiv;
        filterNav.selectedField.rangeDivID = showDIV;
        filterNav.selectedField.rangeDiv.id="";
        filterNav.selectedField.rangeDiv.style.display="";

        var addontype = filterNav.selectedField.getAttribute("addontype").toUpperCase();
        if(addontype=="ABSDATECATEGORICAL")
        {
            if(filterNav.selectedField.rangeDiv.getAttribute("dateRanges")!=null)
            {
                ZDBCalender.showCalender('minDtCal', 'minDate',true);//NO I18N
                ZDBCalender.showCalender('maxDtCal', 'maxDate',true);//NO I18N
            }
        }
        rangeDiv.selField = null;
    }
    if(filterNav.selectedField.rangeDiv)
    {
      filterNav.selectedField.rangeDiv.filterNav = filterNav;
      view.currentDlg = filterNav.selectedField.rangeDiv;
      ZDBDialogUtil.showDialog(filterNav.selectedField.rangeDiv,{TITLE:ZDBI18NMap.g('zrpt.common.analysis.filter.addrange.js.dlgTtl'),DONTREMOVE:true, ADDFRAME:true,MODAL:true,VIEW:view});
    }
}

this.retDisplayFilterValue = function(filtervalue)
{
    var prefix = filtervalue.substring(0,2).trim();
    //var displayfiltervalue = filtervalue;
    if(prefix == "I")
    {
        var val = filtervalue.substring(2,filtervalue.length).trim();
        return val+" and below";//NO I18N
    }
    else if(prefix == "B")
    {
        var value = filtervalue.substring(2,filtervalue.length).trim();
        var valList = value.split(":");
        return valList[0]+" to "+valList[1];
    }
    else if(prefix == "G")
    {
        var disp = filtervalue.substring(2,filtervalue.length).trim();
        return "above "+disp;//NO I18N
    }
    return filtervalue;
}

this.addAsNewRange = function(filtervalue,view)
{
    var displayfiltervalue = ZDBAnalysisFilter.retDisplayFilterValue(filtervalue);
    ZDBAnalysisFilter.addNewRange(displayfiltervalue, filtervalue,view);
}

this.updateRange = function(el,event)
{
  if(!event)
    {
      event = window.event;
    }
  var view = ZDBDialogUtil.currentViewObj;
  var rangeDiv = view.currentDlg;//filterNav.selectedField.rangeDiv;
  var filterNav = rangeDiv.filterNav;
  var field = filterNav.selectedField;
  var addontype = field.getAttribute("addontype");
  var viewtype = field.getAttribute("VIEWTYPE");
  var type = ZDBAnalysisFilter.getSubType(filterNav);
  type = parseInt(viewtype == "VMFILTERCRITERIA" ? ZAVMFilterEdit.modifyProps[type.toLowerCase()] : field.getAttribute(type));
    var operation = field.getAttribute(ZDBAnalysisFilter.getOperation(filterNav));
    ZDBUtil.setNamedChildEls(rangeDiv,rangeDiv);

  if(ZDBAnalysisView.isMeasure(field))
  {
            switch(type)
            {
            case 2 :{
                var optionList = rangeDiv.optionList.value;
                switch(optionList)
                {
                case "above":   {//NO I18N
                    var rangeValue = rangeDiv.rangeValue.value;
                    if(ZDBValidator.isDecimal(rangeValue,false))
                    {
                        var prefix = "U ";//NO I18N
                        var displayfiltervalue = ZDBI18NMap.f("zrpt.common.customrange.js.and_above",rangeValue);
                        var filtervalue = prefix+rangeValue;
                    }
                    else
                    {
                        showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidInput")+'"', rangeDiv.rangeValue)
                            rangeDiv.rangeValue.select();
                        return;
                    }
                    break;
                }

                case "below":   {//NO I18N
                    var rangeValue = rangeDiv.rangeValue.value;
                    if(ZDBValidator.isDecimal(rangeValue,false))
                    {
                        var prefix = "L ";//NO I18N
                        var displayprefix = ZDBI18NMap.f("zrpt.common.customrange.js.below"," ");
                        var displayfiltervalue = displayprefix+ rangeValue;
                        var filtervalue = prefix+rangeValue;
                    }
                    else
                    {
                        showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidInput")+'"', rangeDiv.rangeValue)
                            rangeDiv.rangeValue.select();
                        return;
                    }
                    break;
                }

        case "between": {//NO I18N
            var fromValue = rangeDiv.fromValue.value;
            var toValue = rangeDiv.toValue.value;

            if(ZDBValidator.isDecimal(fromValue,false) && ZDBValidator.isDecimal(toValue,false))
              {

              if(parseFloat(fromValue)>parseFloat(toValue))
              {
                showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.ToValGreaterThanFromErr")+'"', rangeDiv.fromValue);
                return;
              }
              var prefix = "B ";//NO I18N
              var displayprefix = "Above";//NO I18N
              var displayfiltervalue = ZDBI18NMap.f("zrpt.common.customrange.js.between",fromValue,toValue);
            var filtervalue = prefix+fromValue+":"+toValue;
              }
              else
              {
              var invalidInput = (ZDBValidator.isDecimal(fromValue,false))?
                            rangeDiv.toValue:rangeDiv.fromValue;
              showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidInput")+'"', invalidInput);
              rangeDiv.rangeValue.select();
              return;
              }
            break;
            }
                }


                break;
            }

            case 3 :{
                var optionList = rangeDiv.optionList.value;
                var rangeValue = rangeDiv.rangeValue.value.trim();
                if(ZDBValidator.isDecimal(rangeValue,false))
                {
                    if(!ZDBValidator.isNumber(rangeValue,false))
                    {
                        showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidNumber"), rangeDiv.rangeValue);
                        return;
                    }
                    var prefix = (optionList=="top")?"CT ":"CB ";//NO I18N
                    var displayfiltervalue = (optionList=="top")?ZDBI18NMap.f("zrpt.common.customrange.js.top",rangeValue):ZDBI18NMap.f("zrpt.common.customrange.js.bottom",rangeValue); //No I18N
                    var filtervalue = prefix+rangeValue;
                    if(ZDBAnalysisFilter.checkTopBottomRange(field,rangeDiv))
                    {
                      return;
                    }
                    else
                    {
                      var refColEl = rangeDiv.selField;
                      if(refColEl)
                        {
                          var refColList = field.refColList;
                          var func = refColEl.getAttribute("valFunc");
                          ZDBRankingRefFilter[func](refColList,refColEl,event);
                        }
                    }
                }
                else
                {
                    showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidInput")+'"', rangeDiv.rangeValue);
                    rangeDiv.rangeValue.select();
                    return;
                }
                break;
            }

            case 4 :{
                var optionList = rangeDiv.optionList.value;
                var rangeValue = rangeDiv.rangeValue.value;
                if(ZDBValidator.isDecimal(rangeValue,false))
                {

                    var prefix = (optionList=="top")?"PT ":"PB ";//NO I18N
                    var displayprefix = (optionList=="top")?ZDBI18NMap.f("zrpt.common.customrange.js.top",""):ZDBI18NMap.f("zrpt.common.customrange.js.bottom",""); //No I18N
                    var displayfiltervalue = displayprefix+ rangeValue+"%";
                    var filtervalue = prefix+rangeValue;
                }
                else
                {
                    showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidInput")+'"', rangeDiv.rangeValue);
                    rangeDiv.rangeValue.select();
                    return;
                }
                break;
            }
            }

  }
  else if(addontype=="ABSDATECATEGORICAL")
  {
    if(rangeDiv.getAttribute("dateRanges")!=null)
    {
      var minDate = rangeDiv.fromValue.value;
      var maxDate = rangeDiv.toValue.value;
            var optionList = rangeDiv.optionList.value;
                switch(optionList)
                {
                  case "From": //NO I18N
                  {
                    if(!ZDBValidator.isDate(minDate))
                    {
                        showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidDate")+'"', rangeDiv.fromValue);
                        return;
                    }
                    else
                    {
                        var prefix = "U "; //NO I18N
                        var displaySuffix = " "+ZDBI18NMap.f("zrpt.common.customrange.js.from"," ");
                        var displayfiltervalue = displaySuffix + minDate;
                        var filtervalue = prefix+minDate;
                    }

                    break;
                }
                case "To": //NO I18N
                  {
                    if(!ZDBValidator.isDate(maxDate))
                    {
                        showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidDate")+'"', rangeDiv.toValue);
                        return;
                    }
                    else
                    {
                        var prefix = "L "; //NO I18N
                        var displayprefix = ZDBI18NMap.f("zrpt.common.customrange.js.to"," ");
                        var displayfiltervalue = displayprefix+ maxDate;
                        var filtervalue = prefix+maxDate;
                    }

                    break;
                }

        case "between": { //NO I18N

                      if(!ZDBValidator.isDate(minDate))
                      {
                          showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidDate")+'"', rangeDiv.fromValue);
                          return;
                      }
                      if(!ZDBValidator.isDate(maxDate))
                      {
                          showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidDate")+'"', rangeDiv.toValue);
                          return;
                      }

            var displayfiltervalue = ZDBI18NMap.f("zrpt.common.customrange.js.between",minDate,maxDate);
            var filtervalue ="B "+minDate+"-"+maxDate;//NO I18N
              break;
            }
        }
    }
    else
    {
      var optionList = rangeDiv.optionList.value;
      var displayPrefix = (rangeDiv.optionList.value=="R L_")?"Last":((rangeDiv.optionList.value=="R P_") ? "Previous"  : "Next");//NO I18N
      var rangeValueEL = rangeDiv.rangeValue;
      var rangeValue = rangeValueEL.value.trim();
      if((ZDBValidator.isDecimal(rangeValue,false)))
      {
        if(!ZDBValidator.isPositive1(rangeValue,false))
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.negativeNumber"), rangeDiv.rangeValue);
            return;
        }
        if(rangeValue>99999)
        {
            showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.maxFiveDigitRange")+'"', rangeDiv.rangeValue);
                    rangeDiv.rangeValue.select();
                    return;
        }
        var ctype = rangeValueEL.getAttribute("criteria");
        var displayvalue = "zrpt.common.analysis.filter.custommsg.js."+displayPrefix+"_"+rangeValueEL.getAttribute("displayRangeCriteria"); //NO I18N
                displayfiltervalue  = ZDBI18NMap.f(displayvalue,rangeValue);
        var filtervalue = optionList+rangeValue+"_"+ctype;
      }
      else
      {
        showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidInput")+'"', rangeDiv.rangeValue);
        return;
      }

    }
  }
  if(ZDBAnalysisFilter.duplicateCheck(filtervalue,filterNav))
  {
    ZDBAnalysisFilter.addNewRange(displayfiltervalue, filtervalue,view,filterNav);
  }
  else
  {
      showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.duplicateInput")+'"', rangeDiv.rangeValue);
      return;
  }
    view.currentDlg = null;
  ZDBDialogUtil.closeDialog();
}


this.duplicateCheck=function(filterValue,filterNav)
    {
        var selectedList=filterNav.getElementsByClassName("filterFieldSel");//NO I18N
        var unSelectedList=filterNav.getElementsByClassName("filterField");//NO I18N
        for(var i=0;i<selectedList.length;i++)
        {
            if(selectedList[i].getAttribute("filtervalue")===filterValue)
            {
                return false;
            }
        }
        for(var i=0;i<unSelectedList.length;i++)
        {
            if(unSelectedList[i].getAttribute("filtervalue")===filterValue)
            {
                return false;
            }
        }
        return true;
    }

this.checkTopBottomRange= function(field,rangeDiv)
{
  var refCol = rangeDiv.selField ? rangeDiv.selField.getAttribute("colid") :field.getAttribute("referredcolumnid");
  var subType = field.getAttribute("SUBTYPE");
  if(field.getAttribute("VIEWTYPE") == "VMFILTERCRITERIA")
  {
      ZAVMFilterEdit.modifyProps.subtype;
  }
  if(subType != "3"){return false;}
  var rangeValue = rangeDiv.rangeValue.value.trim();
  if(rangeValue > 25 && (refCol!="" && refCol !=null))
  {
    showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.rankingLimitExceed"), rangeDiv.rangeValue);
     $("customAlertMessage").style.width = "auto";
            $("_CUSTOMALERTFRAME").style.width = "auto";
    return true;
  }
  else if (refCol!="" && refCol != null)
  {
    if(ZDBRankingRefFilter.checkNThrowRangeExceed(field,field.getAttribute("criteria"),refCol,rangeDiv))
    {
      return true;
    }
  }
  return false;
}

//this.getAddRangeDiv = function(view)
//{
////    var filterNav = null;
////    if(view.field.getAttribute("viewtype")=="VMFILTERCRITERIA")
////    {
////        filterNav = view.field.filterNav;
////    }
////    else
////    {
//       var filterNav = field.filterNav;
////       var addRangeDiv = null;
////    }
//    var addRangeDiv = DOMUtils.getFirstMatchingChild(filterNav,"div","id", "ADDNEWRANGE"); //NO I18N
//    return addRangeDiv;
//}

this.addNewRange = function(displayfiltervalue, filterValue, view,filterNav)
  {
      if(filterNav==null)
        {
          filterNav = ZDBAnalysisFilter.getFilterNav(view);
        }
      var field = filterNav.selectedField;
      var subType = ZDBAnalysisFilter.getSubType(filterNav);
      var type = parseInt(field.getAttribute("VIEWTYPE") == "VMFILTERCRITERIA" ? ZAVMFilterEdit.modifyProps[subType.toLowerCase()] : field.getAttribute(subType));//No I18N
      var isTopBot = (ZDBAnalysisView.isMeasure(field) && type == 3);
      if(isTopBot)
        {
         ZDBAnalysisFilter.addNewRangeTopEl(displayfiltervalue, filterValue, view,filterNav);
        }
        else
        {
          ZDBAnalysisFilter.addNewRangeEl(displayfiltervalue, filterValue, view,filterNav);
        }
  }

  this.addNewRangeEl = function(displayfiltervalue, filterValue, view,filterNav)
  {
        var newRangeDIV = null;
        var newRangeHiddenDIV =DOMUtils.getFirstMatchingChild(filterNav,"div","id", "newRangeHiddenDIV"); //NO I18N
        var viewType = filterNav.selectedField.getAttribute("VIEWTYPE");
        if(newRangeHiddenDIV!= null)
        {
          newRangeDIV = newRangeHiddenDIV.cloneNode(true);
        }
        else
        {
          newRangeDIV = document.createElement("div");
          newRangeDIV.className = "filterField";
          newRangeDIV.style.display = "none";
          newRangeDIV.setAttribute("sel","no");
          newRangeDIV.setAttribute("onclick","ZDBAnalysisFilter.filterChanged(this);");
          newRangeDIV.setAttribute("onmouseover","ToolTip.show(event, this);");
        }
        var addNew = DOMUtils.getFirstMatchingChild(filterNav,"div","id", "ADDNEWRANGE"); //ZDBAnalysisFilter.getAddRangeDiv(view); //NO I18N

    var appendNewRange_TD = addNew.parentNode;
    var appendAddNew_TD = ZDBAnalysisFilter.addToWhichCell(addNew);
    var mainTable = DOMUtils.getParentWithAttr(addNew,"holderParent");
    ZDBUtil.setNamedChildEls(mainTable,mainTable,"scrollel");
    //var contentTable = mainTable.content;
    newRangeDIV.setAttribute("filtervalue",filterValue);
    newRangeDIV.setAttribute("displayfiltervalue",displayfiltervalue);
    newRangeDIV.setAttribute("value",displayfiltervalue);
    var nr = ZDBAnalysisFilter.getNRVal(filterNav);
    var existingNewRanges = filterNav.selectedField.getAttribute(nr);

    if(existingNewRanges!=null && existingNewRanges!="")
      {
      var newRange = existingNewRanges+","+filterValue;
          }
          else
          {
                          newRange = filterValue;
          }
    var subType = filterNav.selectedField.getAttribute("subType");
    if(viewType == "VMFILTERCRITERIA")
    {
        ZAVMFilterEdit.modifyProps[nr.toLowerCase()] = newRange
        subType = ZAVMFilterEdit.modifyProps.subtype;
    }
    else
    {
        filterNav.selectedField.setAttribute(nr,newRange);
    }
    var trimSize = 15;
    if(subType == "107")
      {
        addNew.style.width = jQuery(addNew).width()+"px";
        trimSize = 50;
      }
    newRangeDIV.innerHTML = ZDBEscapeUtil.encodeForHtml(ZDBUtil.getTrimmedString(displayfiltervalue,trimSize , "..."));

    newRangeDIV.id="";
    appendNewRange_TD.appendChild(newRangeDIV);
    newRangeDIV.style.display="";
    ZDBAnalysisFilter.filterChanged(newRangeDIV);
    appendAddNew_TD.appendChild(addNew);
//    contentTable.style.left = -(parseInt(contentTable.style.left)+50)+"px";
  }

  this.addNewRangeTopEl = function(displayfiltervalue, filterValue, view,filterNav)
  {
    var newRangeDIV = null;
    var el = null;
    var viewType = filterNav.selectedField.getAttribute("VIEWTYPE");
    var newTopRangeHiddenDIV =DOMUtils.getFirstMatchingChild(filterNav,"div","id", "newTopRangeHiddenDIV"); //NO I18N
    if(newTopRangeHiddenDIV!= null)
    {
      el = newTopRangeHiddenDIV.cloneNode(true);
    }
    else
    {
       ZDBAnalysisFilter.addNewRangeEl(displayfiltervalue, filterValue, view,filterNav);
       return;
    }
    if(el != null)
    {
      newRangeDIV = DOMUtils.getFirstChild(el,"RefElName","selField");//NO I18N
    }

    var addNew = DOMUtils.getFirstMatchingChild(filterNav,"div","id", "ADDNEWRANGE"); //ZDBAnalysisFilter.getAddRangeDiv(view); //NO I18N
    var appendNewRange_TD = addNew.parentNode;
    var appendAddNew_TD = ZDBAnalysisFilter.addToWhichCell(addNew,true);
    var mainTable = DOMUtils.getParentWithAttr(addNew,"holderParent");
    ZDBUtil.setNamedChildEls(mainTable,mainTable,"scrollel");
    newRangeDIV.setAttribute("filtervalue",filterValue);
    newRangeDIV.setAttribute("displayfiltervalue",displayfiltervalue);
    newRangeDIV.setAttribute("value",displayfiltervalue);
    var existingNewRanges = viewType == "VMFILTERCRITERIA" ? ZAVMFilterEdit.modifyProps.nr : filterNav.selectedField.getAttribute("NR");//NO I18N

    if(existingNewRanges!=null && existingNewRanges!="")
    {
      var newRange = existingNewRanges+","+filterValue;
    }
    else
    {
      newRange = filterValue;
    }
    viewType == "VMFILTERCRITERIA" ? ZAVMFilterEdit.modifyProps.nr = newRange : filterNav.selectedField.setAttribute("NR",newRange);//NO I18N
    newRangeDIV.innerHTML = ZDBEscapeUtil.encodeForHtml(ZDBUtil.getTrimmedString(displayfiltervalue, 15, "..."));

    el.id="";
    appendNewRange_TD.appendChild(el);
    //      newRangeDIV.style.display="";
    el.style.display="";
    ZDBAnalysisFilter.filterChanged(newRangeDIV);
    appendAddNew_TD.appendChild(addNew);
    var filterEl = DOMUtils.getFirstChild(filterNav, "FILTEREL", "true"); //NO I18N
    ZDBScroller.checkNSetButtonStyle(filterEl);
  }


this.addToWhichCell = function(addNewRangeDiv,isRankngEl)
{
  var currentTD = addNewRangeDiv.parentNode;
  var divsInLastTD = isRankngEl ? DOMUtils.getChildElsWithAttr(currentTD, "FieldElHeader", "true"):currentTD.getElementsByTagName("div");//NO I18N
    var elsLength = isRankngEl ? divsInLastTD.length+1 : divsInLastTD.length; // add new range div count is not added when it is ranking column format
    if(elsLength < 4)
    {
        return currentTD;
    }
    else
    {
        var mainTable = DOMUtils.getParentWithAttr(addNewRangeDiv,"holderParent");
        ZDBUtil.setNamedChildEls(mainTable,mainTable,"scrollel");
        var contentTable = mainTable.content;
        var items = DOMUtils.getChildElsWithAttr(mainTable, "elname", "itemList")[0]; //NO I18N
        ZDBUtil.removeNonElements(items);
        var nextcellIndex = items.childNodes.length-1; // Taking the last previous TD's index
        var newCell = items.insertCell(nextcellIndex);
        newCell.style.verticalAlign = "top";//NO I18N
        newCell.setAttribute("valign","top");
        return newCell;
    }
}


this.showDateOption = function(optionList)
{
    var view = ZDBDialogUtil.currentViewObj;
  var filterNav = ZDBAnalysisFilter.getFilterNav(view);
  var rangeDiv = filterNav.selectedField.rangeDiv;
    ZDBUtil.setNamedChildEls(rangeDiv,rangeDiv);
  var optionSelected = optionList.value;
    var minDateEl = rangeDiv.minDateEl;
      var maxDateEl = rangeDiv.maxDateEl;
    if(optionSelected=="between")
  {
    minDateEl.style.display = "";
    maxDateEl.style.display = "";
  }
  else if(optionSelected == "From")
    {
      maxDateEl.style.display = "none";
      minDateEl.style.display = "";
    }
  else if(optionSelected == "To")
  {
      maxDateEl.style.display = "";
      minDateEl.style.display = "none";
  }
}

this.showOption = function(optionList)
{
  var view = ZDBDialogUtil.currentViewObj;
  var rangeDiv = view.currentDlg;//filterNav.selectedField.rangeDiv;
//  var filterNav = rangeDiv.filterNav;
//  var filterNav = ZDBAnalysisFilter.getFilterNav(view);
//  var rangeDiv = filterNav.selectedField.rangeDiv;
//  var addontype = filterNav.selectedField.getAttribute("addontype");
    ZDBUtil.setNamedChildEls(rangeDiv,rangeDiv);
  var optionSelected = optionList.value;

  if(optionSelected=="between")
  {
    rangeDiv.betweenRangesTD.style.display = "";
    rangeDiv.otherRangesTD.style.display = "none";
  }
  else
  {
    rangeDiv.betweenRangesTD.style.display = "none";
    rangeDiv.otherRangesTD.style.display = "";
  }
}

this.subOperation = function(el)
{
    var view = ZDBClientUI.getViewObj(el,"view"); 
    var filterNav = ZDBAnalysisFilter.getFilterNav(view,el);
    var dlg = ZDBDialogUtil.focusDialog;
    var field = filterNav.selectedField ? filterNav.selectedField : dlg.field;
    var viewType = field.getAttribute("VIEWTYPE"); 
    var type = el.getAttribute("SUBTYPE"); 
    var subType = ZDBAnalysisFilter.getSubType(filterNav);
    var oldType = field.getAttribute(subType);//filterNav.selectedField.getAttribute("functionChanged");
   if(viewType == "VMFILTERCRITERIA")
   {
       oldType = dlg.modifyProps[subType.toLowerCase()];
       dlg.modifyProps[subType.toLowerCase()] = type;
   }
   else
   {
       field.setAttribute(ZDBAnalysisFilter.getSubType(filterNav),type);
   }
//    var oldFunctionSelected = filterNav.selectedField.functionSelected;
//    filterNav.selectedField.functionSelected =  filterNav.selectedField.getAttribute(ZDBAnalysisFilter.getOperation(filterNav));
  functionChanged = oldType == type ? "false" : "true";//No I18n
    if(field.operationtype!=null)
    {
      if(field.operationtype==type && functionChanged=="false")
    {
              field.setAttribute("functionChanged","false");
      return;
    }
  }
  field.setAttribute("functionChanged","false");
  ZDBAnalysisFilter.clearAllSelIfNeeded(view,filterNav);
 
  var oldOper = field.operationtype;
  field.operationtype = type;
  var curEl = field.filterEl;
  var newEl = field[type+field.getAttribute(ZDBAnalysisFilter.getOperation(filterNav))+"_EL"];
 
  field.filterEl = newEl;
  filterNav.filterEl = newEl;
 
  //filterNav.selectedField[oldOper+oldFunctionSelected+"_EL"] = curEl;
  ZDBAnalysisFilter.selectFilterField(view,field,curEl,filterNav);
}


  this.clearAllSelIfNeeded = function(view,filterNav)
  {
      var field = filterNav.selectedField;
      if(field.getAttribute("VIEWTYPE") == "VMFILTERCRITERIA")
      {
        var operation = ZDBDialogUtil.focusDialog.modifyProps[ZDBAnalysisFilter.getOperation(filterNav).toLowerCase()];
        if(operation.toLowerCase() =="pf")
        {
            return;
        }
    }
      var filterel  = DOMUtils.getFirstMatchingChild(filterNav,"*","filterel","true"); 
      this.clearSelected(filterel,view);
  }
  this.getOperation = function(filterNav)
  {
    return (filterNav && filterNav.getAttribute("relVMFilterNav") == "true") ?  "REL_OPERATION" : "OPERATION"; //NO I18N
  }

  this.getSubType = function(filterNav)
  {
    return (filterNav && filterNav.getAttribute("relVMFilterNav") == "true") ?  "REL_SUBTYPE" : "SUBTYPE"; //NO I18N
  }

  this.getNRVal = function(filterNav)
  {
    return (filterNav && filterNav.getAttribute("relVMFilterNav") == "true") ?  "REL_NR" : "NR"; //NO I18N
  }
  
  this.showSclItemsHolder = function(el,firstTime)
  {      
    var tblEl = ZDBUtil.getParentWithAttributeValue(el,"catnavarea","true"); //No I18N
    ZDBUtil.setNamedChildEls(tblEl,tblEl);
    if(firstTime)
    {
        tblEl.zdbFilterListBox.style.width = "379px";//No I18N
        tblEl.slctedItems.style.width = "168px";//No I18N
        tblEl.slctedItems.style.display="block";//No I18N
    }
    else
    {
        jQuery(tblEl.zdbFilterListBox).animate({width: '379px'});//No I18N
        jQuery(tblEl.slctedItems).animate({width: '168px'}); //No I18N
    }
    tblEl.slctedItems.style.display="block";//No I18N
    
    
  }
  
  this.hideSclItemsHolder = function(el,firstTime){
    var tbEl = ZDBUtil.getParentWithAttributeValue(el,"catnavarea","true"); //No I18N
    ZDBUtil.setNamedChildEls(tbEl,tbEl);
    if(firstTime){
        tbEl.zdbFilterListBox.style.width = "553px";//No I18N
        tbEl.slctedItems.style.width = "0px";//No I18N
        tbEl.slctedItems.style.display="none";//No I18N
    }
    else{
        jQuery(tbEl.zdbFilterListBox).animate({width: '553px'}); //No I18N
        jQuery(tbEl.slctedItems).animate({width: '0px'},function(){//No I18N
            tbEl.slctedItems.style.display="none";//No I18N
        }); 
    }
  }
   
   this.resetNCountHolderVisible = function(filterEl,firstTime){//firsttime = for (if selected values is empty, stoping width animation)
       var sclItemsCount =  filterEl.selItemHolder.childElementCount;
       if(filterEl.selItemHolder){
            if((sclItemsCount > 0) && (!filterEl.resetFilter.visible)){ 
                filterEl.resetCountHolder.style.visibility="visible";
                filterEl.resetFilter.visible = true;
            }
            else if(sclItemsCount == 0){
                this.hideSclItemsHolder(filterEl.selItemHolder,firstTime);
                filterEl.resetCountHolder.style.visibility="hidden";
                filterEl.resetFilter.visible = false;
             }
        }
        ZAVMFilterEdit.updateSlcCount(filterEl);
    }    
}

ZDBAnalysisFilter.functionMap = {"ZDBAnalysisFilter.changeExcludeOpt":ZDBAnalysisFilter.changeExcludeOpt};  //No I18N