/*$Id$*/

function ZDBAxisProp(propSetUtil)
{
    var axisProp = propSetUtil.propSetForm.axisProp;
    var propSetUtil = propSetUtil;
    var xRangeIntTabIndex = 48;
    var RangeIntTabIndex = 138;
    
    this.setAxisPropValues = function()
    {
        this.resetAxisProp();
        this.setAxisLabels();
        // Currently, fontPropObj is either for Axis or for Funnel
        // Later, we can extend this as an array - depending upon the component
        propSetUtil.fontPropObj = new ZDBFontProp(axisProp, propSetUtil);
        propSetUtil.fontPropObj.initFontProp();
        this.setTextDirEl(axisProp.xTextDirection);
        this.setDataLabelEl(axisProp.dataLabelEl);
        this.setStackedLabel(axisProp.stackLabelDiv, axisProp.stackedDL)
    	this.setShowAxis(axisProp.showXaxis);
    	this.setShowAxis(axisProp.showYaxis);
        axisProp.weekYearFormat.style.display = "none";
        if(settings.viewContainsAbsWeek(propSetUtil.view))
        {
            ZDBAxisProp.setWeekYearFormatEl(axisProp.weekYearFormat,propSetUtil);
        }
    }

    this.resetAxisProp = function()
    {
        // initialising for Axis Labels
        ZDBUtil.setNamedChildEls(axisProp, axisProp);
        var multiYLabel = axisProp.multiYLabel;
        var parentEl = multiYLabel.parentNode;
        while(multiYLabel.nextSibling != axisProp.yLabelFont)
        {
            parentEl.removeChild(multiYLabel.nextSibling);
        }
        axisProp.labelElSet = new Array();
        axisProp.rangeIntElSet = new Array();
    }
    
    this.isAxisDataLabelEnabled = function()
    {
    	var view = propSetUtil.view;
    	if(view.chartSelectedEl.isMultiY && view.metaInfo.MERGE)
    	{
    		return axisProp.dataLabelEl.checked;
    	}
    	return axisProp.dataLabelEl.checked || axisProp.stackedDL.checked;
    }

    this.setAxisLabels = function()
    {
        var view = propSetUtil.view;
        var graphSelected = view.graphSelected ;
        var isMultiY = view.chartSelectedEl.isMultiY;
        var labelEls = view.labelDiv;
        var rangeTitle = true;
        if(graphSelected != "TABLE_CHART" && labelEls)
        {
        	var propSetForm = propSetUtil.propSetForm;
        	var xLabelEl = ZDBAxisProp.getAxisTypeEl(labelEls, "XAXIS");//No I18N
            ZDBAxisProp.setXAxisLabel(propSetUtil, axisProp, xLabelEl);
            var xRangeSupported = (xLabelEl.RANGE_SUPPORTED === true);//No I18N
            if(xRangeSupported)
            {
                var xAxisProp = propSetForm.XAXIS;
                xAxisProp.compNameSet = false;
                ZDBUtil.setNamedChildEls(propSetForm.XAXIS, xAxisProp, "compName", false);//No I18N

                if(xAxisProp.rangeIntComp)
                {
                    (propSetForm.XAXIS).removeChild(xAxisProp.rangeIntComp);
                }
                var axisRangeInt = new AxisRangeInt(propSetUtil, xLabelEl, "XAXIS", rangeTitle); //No I18N
                axisRangeInt.setRangeIntProp();
            }
            var yLabelEls = ZDBAxisProp.getAxisTypeEls(labelEls, "YAXIS");//No I18N
            var yLbllen = yLabelEls.length;
            var yAxisProp = propSetForm.YAXIS;
            var yRangeEls = ZDBUtil.getElsWithTagNAttrWithVal(yAxisProp, "compName", "rangeIntComp", "div");//No I18N
            
            for(var i = 0, j = yRangeEls.length; i < j;i++)
            {
                (propSetForm.YAXIS).removeChild(yRangeEls[i]);
            }    

            var curListLen = (view.currentList).length;  // no of axis dropped 
     
            for(var i = 0 ; i<yLbllen; i++)
            {
                var yLabelEl = yLabelEls[i];
                ZDBAxisProp.setYAxisLabel(propSetUtil, axisProp, yLabelEl, i);
                var rangeSupported = (yLabelEl.RANGE_SUPPORTED === true);//No I18N
                if(rangeSupported)
                {
                    var axisRangeInt = new AxisRangeInt(propSetUtil, yLabelEl, "YAXIS", rangeTitle, i);//No I18N
                    axisRangeInt.setRangeIntProp();
                    rangeTitle = false;
                }
            }
        }   
    }
    
    this.setDataLabelEl = function(el)
    {
        el.checked = false;
        if(propSetUtil.getPropValue(PropSettings.CHART_DATALABEL_EXISTS,  PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE))
        {
            el.checked = true;
            ZDBAxisProp.setPropValOnCheck(el);
        }
    }
    
    this.setStackedLabel = function(cont, el)
    {
    	el.checked = false;
    	var view = propSetUtil.view;
    	var chartSelected = view.chartSelectedEl;
    	var curList = view.currentList;
    	var isHorizontal = view.chartObj.isHorizontalChart();
    	var axisType = isHorizontal ? "XAXIS" : "YAXIS";//NO I18n
    	var isHundredPercentGroup = false;
    	for(var i = 0; i<curList.length; i++)
    	{
    		var curEl = curList[i];
    		if(curEl.getAttribute("VIEWTYPE") == axisType)
    		{
    			var showValAs = curEl.getAttribute("showvalueas");
    			var baseField = curEl.getAttribute("basefieldpos");
    			isHundredPercentGroup = showValAs == "9" && baseField == "COLORAXIS"; // 100 % group showValueAs value is 9
    			break;
    		}
    	}
    	if((chartSelected.selectedGraph == "SBR" && !isHundredPercentGroup) || (chartSelected.selectedGraph == "COMBO" && chartSelected.subGraphType == "SBR"))
    	{
    		cont.style.display = "block";
    		if(propSetUtil.getPropValue(PropSettings.CHART_DATALABEL_STACKED,  PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE))
            {
                el.checked = true;
                ZDBAxisProp.setPropValOnCheck(el);
            }
    	}
    }
    
    this.setShowAxis = function(el)
    {
        el.checked = true; //default value for show Axis
        var propName = el.getAttribute("propName");
        if(propSetUtil.getPropValue(propName,  PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE))
        {
     	   el.checked = false;
           ZDBAxisProp.setPropValOnCheck(el);
        }
    }
    this.disableAxisEl = function(el)
    {
    	var propSetUtil = ZDBClientUI.getViewObj(el,"propSetUtil");//No I18N
    	var propSetForm=propSetUtil.propSetForm;
    	var propName = el.getAttribute("propName");
    	if(propName == "chart.xAxis.show")
    	{
    		(propSetForm.showXaxis).type="hidden";
   		}
    	else if(propName == "chart.yAxis.show")
   		{
    		(propSetForm.showYaxis).type="hidden";
   		} 
    	
    	
    }
    this.setTextDirEl = function(xTextDirectionEl)
    {
        var propValue = propSetUtil.getPropValue(PropSettings.CHART_X_TICKLABEL_DIRECTION,PropSettings.STATIC_PROP,PropSettings.STRING_PROPTYPE);//No I18N
        var textDirEls = xTextDirectionEl.getElementsByTagName("div");
        var textDirEl = this.getTextDirEl(textDirEls, propValue);
        ZDBAxisProp.setTextDir(textDirEl);
    }

    this.getTextDirEl = function(textDirEls, value)
    {
        return (value != null) ? textDirEls[parseInt(value)] : textDirEls[0];
    }
    
    this.checkRangeIntValues = function()
    {
        var rangeIntEls = axisProp.rangeIntElSet;
        var rangeIntLen = rangeIntEls.length;
        for(var i=0; i < rangeIntLen ; i++)
        {
        	var rangeIntEl = rangeIntEls[i];
            if(!rangeIntEl.validateRangeRow())
            {
                return false;
            }
            else
            {
                if(!rangeIntEl.validateIntervalRow())
                {
                    return false;
                }
            }
        }
        return true;
    }
    

    this.checkAxisLabelValues = function()
    {
    	var labelEls = axisProp.labelElSet;
        var labelLen = labelEls.length;
        for(var i=0; i< labelLen; i++)
        {
            var dispVal = labelEls[i].getAttribute("displayName");
            var lblValue = labelEls[i].value;
            var axisLblLength = lblValue.length;
            if(axisLblLength > ZDBConst.DESCRIPTION_MAX_LENGTH)
        	{
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, labelEls[i], ZDBI18NMap.f("zrpt.common.analysis.settings.js.axisLblLenExceedErr",ZDBConst.DESCRIPTION_MAX_LENGTH), true); //No I18N
        	}
            propSetUtil.setPropMap(labelEls[i], dispVal);
        }
        return true;
    }
    
    this.setAxisPropMap = function()
    {
    	ZDBUtil.setNamedChildEls(axisProp, axisProp);
        propSetUtil.setPropMap(axisProp.xTextDirection, "0", true);
        propSetUtil.setPropMap(axisProp.dataLabelEl, "false", true); 
        propSetUtil.setPropMap(axisProp.stackedDL, "false", true); 
        propSetUtil.setPropMap(axisProp.weekYearFormat, "false", true);
        propSetUtil.setPropMap(axisProp.showXaxis, "true", true);
        propSetUtil.setPropMap(axisProp.showYaxis, "true", true);
    }
    
    return this;
    
}

function AxisRangeInt(propSetUtil, labelEl, axisType, rangeTitle, multiYCount)
{
	var rangeIntEl = ZDBUtil.getCloneNode(propSetUtil.propSetForm.rangeIntComp);
	var chartObj = propSetUtil.view.chartObj;
	
	this.setRangeIntProp = function()
	{
		var propSetForm = propSetUtil.propSetForm;
	    var axisProp = propSetForm.axisProp;
	    rangeIntEl.style.display = "";
	    ZDBUtil.setNamedChildEls(rangeIntEl, rangeIntEl);
	    if(rangeTitle === false)
	    {
	        rangeIntEl.RangeIntervalLabel.innerHTML = "";
	    }
	    var view = propSetUtil.view;
	    var instId = labelEl.KEY;
	    var newInstId = view.instMap && view.instMap[instId] && view.isViewRefreshed == 1 ? view.instMap[instId] : instId;
	    instId = ZDBAnalysisView.replaceInstKey(propSetUtil.view, labelEl.KEY);
	    if(parseInt(instId) > 0) 
	    {
	        rangeIntEl.axisLabel.removeAttribute('colspan');
	        rangeIntEl.ZACFDlgLinkTd.style.display = '';
	        rangeIntEl.ZACFDlgLink.setAttribute('instKey',newInstId);
	        rangeIntEl.ZACFDlgLink.addEventListener('click', function() 
			{
	        	propSetUtil.view.zacf.setKey(newInstId);
	            ZDBPopUpMenu.gridOper(this);
	        });
	    }
	    
	    this.setAxisRangeValues(instId);
	    this.setAxisIntervalValues(instId);
	    axisProp.rangeIntElSet.push(this);
	    if(axisType == "XAXIS")
	    {
	        ZDBAxisProp.setTabIndex(rangeIntEl, this.xRangeIntTabIndex);
	        propSetForm.XAXIS.appendChild(rangeIntEl);
	    }
	    else if(axisType == "YAXIS")
	    {
	        ZDBAxisProp.setTabIndex(rangeIntEl, this.yRangeIntTabIndex);
	        propSetForm.YAXIS.appendChild(rangeIntEl);
	    }
	}
	
	this.setAxisRangeValues = function(instId)
	{
	    rangeIntEl.customRangeEl.name = instId + "Range";
	    var labelVal = labelEl.VALUE || ZDBI18NMap.g("zrpt.chartview.setting.js.mergAxis"); //No I18n
	    rangeIntEl.axisLabel.innerHTML = ZDBEscapeUtil.encodeForHtml(labelVal);
	    var minValModified = propSetUtil.getPropValue(PropSettings.CHART_AXIS_MIN_VALUE, instId ,PropSettings.DOUBLE_PROPTYPE);
	    var maxValModified = propSetUtil.getPropValue(PropSettings.CHART_AXIS_MAX_VALUE, instId ,PropSettings.DOUBLE_PROPTYPE);
	    var valuesNotModified = minValModified == null && maxValModified == null;
	    var axisInfo = chartObj ? chartObj.getAxisInfo(labelEl.AXIS === "XAXIS", multiYCount) : null; //No I18N
	    rangeIntEl.minValue.value = valuesNotModified ? axisInfo[0] : labelEl.MINVAL != null ? labelEl.MINVAL : "";
	    rangeIntEl.maxValue.value = valuesNotModified ? axisInfo[1] : labelEl.MAXVAL != null ? labelEl.MAXVAL : "";
	    rangeIntEl.minValue.setAttribute("instid",instId);
	    rangeIntEl.maxValue.setAttribute("instid",instId);
	    var isAuto = (labelEl.AUTO === true);
	    if(isAuto)
	    {
	        rangeIntEl.customRangeEl.checked=false;
	        ZDBAxisProp.enaDisCusRangeEls(rangeIntEl.customRangeEl, rangeIntEl);
	    }
	    else
	    {
	        rangeIntEl.customRangeEl.checked=true;
	        ZDBAxisProp.enaDisCusRangeEls(rangeIntEl.customRangeEl, rangeIntEl);
	    }
	}
	
	this.setAxisIntervalValues = function(instId)
	{
	    var intVal = labelEl.INTERVAL;
	    var tickNum = labelEl.TICKNUMBER;
	    rangeIntEl.intervalValue.setAttribute("instid",instId);
	    var isIntervalAuto = (labelEl.INTERVAL_AUTO === true);
	    if(isIntervalAuto)
	    {
	        rangeIntEl.customIntervalEl.checked=false;
	        ZDBAxisProp.enaDisCusIntervalEls(rangeIntEl.customIntervalEl, rangeIntEl);
	    }
	    else if(intVal != "")
	    {
	        rangeIntEl.customIntervalEl.checked=true;
	        ZDBAxisProp.enaDisCusIntervalEls(rangeIntEl.customIntervalEl, rangeIntEl);
	        rangeIntEl.intervalValue.value = intVal;
	        ZDBAxisProp.setAxisInterval(rangeIntEl.customIntervalValEl);
	    }
	    else if(tickNum != "")
	    {
	        rangeIntEl.customIntervalEl.checked=true;
	        ZDBAxisProp.enaDisCusIntervalEls(rangeIntEl.customIntervalEl, rangeIntEl);
	        rangeIntEl.intervalValue.value = parseInt(tickNum);
	        ZDBAxisProp.setAxisInterval(rangeIntEl.customIntervalTickEl);
	    }
	}
	
	this.validateRangeRow = function()// Validating Range Element
    {
        var minValEl = rangeIntEl.minValue;
        var maxValEl = rangeIntEl.maxValue;
        if(!minValEl.disabled && !maxValEl.disabled)//checking for Auto or Custom
        {
            if(ZDBValidator.isBlank(minValEl.value) && ZDBValidator.isBlank(maxValEl.value))//either max or min value can be empty
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, minValEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.noMinValErr"), true); //No I18N
            }
            if(ZDBValidator.isBlank(maxValEl.value) && ZDBValidator.isBlank(minValEl.value))//max Value cannot be empty
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, maxValEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.noMaxValErr"), true); //No I18N
            }
            if(!ZDBValidator.isDecimal(minValEl.value, true, false) && ZDBValidator.isDecimal(maxValEl.value, false, false))
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, minValEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.minValNANErr"), true); //No I18N
            }
            if(!ZDBValidator.isDecimal(maxValEl.value, true, false) && ZDBValidator.isDecimal(minValEl.value, false, false))
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, maxValEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.maxValNANErr"), true); //No I18N
            }
            if(parseFloat(minValEl.value) >= parseFloat(maxValEl.value))
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, maxValEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.maxValShouldBeGreater"), true); //No I18N
            }
            var instId = minValEl.getAttribute("instId");
            if(!ZDBValidator.isBlank(minValEl.value))
            {
            	propSetUtil.setPropMap(minValEl);
            }
            else
            {
            	propSetUtil.deleteFromPropMap(PropSettings.CHART_AXIS_MIN_VALUE ,instId);
            }
            if(!ZDBValidator.isBlank(maxValEl.value))
            {
            	propSetUtil.setPropMap(maxValEl);
            }
            else
            {
            	propSetUtil.deleteFromPropMap(PropSettings.CHART_AXIS_MAX_VALUE ,instId);
            }
        }
        else
        {
            var instId = minValEl.getAttribute("instId");
            propSetUtil.deleteFromPropMap(PropSettings.CHART_AXIS_MIN_VALUE ,instId);
            propSetUtil.deleteFromPropMap(PropSettings.CHART_AXIS_MAX_VALUE ,instId);
        }
        return true;
    }
	
    this.validateIntervalRow = function()
    {
        var propEl = rangeIntEl.intervalValue;
        var propName = propEl.getAttribute("propName");
        if(!propEl.disabled)
        {
            if(ZDBValidator.isBlank(propEl.value))//min Value cannot be empty
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, propEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.noIntervalErr"), true); //No I18N
            }
            if((!ZDBValidator.isPositive1(parseFloat(propEl.value), false, true)) && !(parseFloat(propEl.value) > 0))// to check it is decimal and positive
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, propEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.intervalNANErr"), true); //No I18N
            }
            else if(propName == PropSettings.CHART_AXIS_TICK_NUMBERS && parseInt(propEl.value) > 50)
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, propEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.intervalTickErr"), true); //No I18N
            }
            else if(propName == PropSettings.CHART_AXIS_TICK_NUMBERS && parseInt(propEl.value) != propEl.value)
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.axisPropNav, propEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.intervalTickDecimalErr"), true); //No I18N
            }
            propSetUtil.setPropMap(propEl);
        }
        else
        {
            var instId = propEl.getAttribute("instId");
            propSetUtil.deleteFromPropMap(PropSettings.CHART_AXIS_INTERVAL_VALUE, instId, PropSettings.DOUBLE_PROPTYPE);
            propSetUtil.deleteFromPropMap(PropSettings.CHART_AXIS_TICK_NUMBERS, instId, PropSettings.DOUBLE_PROPTYPE);
        }
        return true;
    }
    
    return this;
    
}


ZDBAxisProp.setAxisInterval = function(el, parNode)
{
    var value = parseInt(el.getAttribute("value"));
    parNode = (parNode != null) ? parNode : (ZDBUtil.getParentWithAttributeValue(el, "compName", "rangeIntComp")) ; //No I18N
    if(!parNode.customIntervalEl.checked)
    {
        return;
    }
    var intervalValue = parNode.intervalValue;
    if(value)
    {

        ZDBAxisProp.setToggleEl(el);
        var desc, propName, delPropName;
        var instId = intervalValue.getAttribute("instid");
        if(value == 1)
        {
            desc = ZDBI18NMap.g("zrpt.common.analysis.settings.js.intervalTicksDesc");
            propName = PropSettings.CHART_AXIS_TICK_NUMBERS;
            delPropName = PropSettings.CHART_AXIS_INTERVAL_VALUE ;
        }
        else
        {
            desc = ZDBI18NMap.g("zrpt.common.analysis.settings.js.intervalValDesc");
            propName = PropSettings.CHART_AXIS_INTERVAL_VALUE ;
            delPropName = PropSettings.CHART_AXIS_TICK_NUMBERS;
        }
        ZDBUtil.setFocus(intervalValue, true);
        intervalValue.setAttribute("propName", propName);
        var propSetUtil = ZDBClientUI.getViewObj(el, "propSetUtil");
        if(propSetUtil)
        {
            propSetUtil.deleteFromPropMap(delPropName, instId);
        }
        parNode.intervalDesc.innerHTML = desc;
        parNode.intervalDesc.style.visibility = "visible";
    }

}

ZDBAxisProp.enaDisCusRangeEls = function(el, parNode)
{
	var value = el.checked;
    parNode = (parNode != null) ? parNode : (ZDBUtil.getParentWithAttributeValue(el, "compName", "rangeIntComp")) ; //No I18N
    if(value)
    {
        parNode.minValue.disabled = false;
        parNode.maxValue.disabled = false;
        ZDBUtil.setFocus(parNode.minValue, true);
        parNode.enableRangeEl.className = "";
    }
    else
    {
        parNode.minValue.disabled = true;
        parNode.maxValue.disabled = true;
        parNode.enableRangeEl.className = "alpha";
    }
}

ZDBAxisProp.enaDisCusIntervalEls = function(el, parNode)
{
	var checked = el.checked;
    parNode = (parNode != null) ? parNode : (ZDBUtil.getParentWithAttributeValue(el, "compName", "rangeIntComp")) ; //No I18N
    var intervalValue = parNode.intervalValue;
    if(checked)
    {
        intervalValue.value = "";
        intervalValue.disabled = false;
        parNode.enableIntervalEl.className = "";
        ZDBAxisProp.setAxisInterval(parNode.customIntervalValEl, parNode);
    }
    else
    {
        intervalValue.value = "";
        intervalValue.disabled = true;
        parNode.enableIntervalEl.className = "alpha";
        ZDBAxisProp.removeToggleElStyle(parNode.customIntervalValEl);
        parNode.intervalDesc.style.visibility="hidden";

    }
}


ZDBAxisProp.setTabIndex = function(rangeIntEl, baseIndex)
{
    (rangeIntEl.customRangeEl).setAttribute("tabIndex", baseIndex++);
    (rangeIntEl.minValue).setAttribute("tabIndex", baseIndex++);
    (rangeIntEl.maxValue).setAttribute("tabIndex", baseIndex++);
    (rangeIntEl.customIntervalEl).setAttribute("tabIndex", baseIndex++);
    (rangeIntEl.intervalValue).setAttribute("tabIndex", baseIndex++);
}

ZDBAxisProp.setXAxisLabel = function(propSetUtil, axisProp, labelEl)
{
    var xAxisLabelEl = axisProp.xAxisLabel;
    xAxisLabelEl.value = labelEl.VALUE;
    xAxisLabelEl.setAttribute("instId",ZDBAnalysisView.replaceInstKey(propSetUtil.view, labelEl.KEY));
    xAxisLabelEl.setAttribute("displayName", labelEl.VALUE);
    axisProp.labelElSet.push(xAxisLabelEl);
}

ZDBAxisProp.setYAxisLabel = function(propSetUtil, axisProp, labelEl, multiYCount)
{
    if(!multiYCount)
    {
        var yAxisLabelEl = axisProp.yAxisLabel;
        yAxisLabelEl.value = labelEl.VALUE;
        yAxisLabelEl.setAttribute("instId",ZDBAnalysisView.replaceInstKey(propSetUtil.view, labelEl.KEY));
        yAxisLabelEl.setAttribute("displayName", labelEl.VALUE);
        axisProp.labelElSet.push(yAxisLabelEl);
    }
    else
    {
        var multiYLabelEl = ZDBUtil.getCloneNode(axisProp.multiYLabel);
        var labelComp = multiYLabelEl.getElementsByTagName("td");
        labelComp[0].innerHTML = "";
        var axisLabelEl = labelComp[1].childNodes[0];
        axisLabelEl.value = labelEl.VALUE;
        var nextSib = axisProp.multiYLabel.nextSibling;
        var parentEl = axisProp.multiYLabel.parentNode;
        for(var i=0; i < multiYCount-1; i++)
        {
            nextSib = nextSib.nextSibling;
        }
        parentEl.insertBefore(multiYLabelEl,nextSib);
        axisLabelEl.setAttribute("instId",ZDBAnalysisView.replaceInstKey(propSetUtil.view, labelEl.KEY));
        axisLabelEl.setAttribute("displayName", labelEl.DISPLAY);
        axisProp.labelElSet.push(axisLabelEl);
    }
}

ZDBAxisProp.hideComboOptDialog= function(event)
{
    if(event && event.target && event.target.className === "tholdTableName")
    {
        return;
    }
    if(event && event.type == "keydown")
    {
        if(ZDBUtil.getKeyCode(event) == KEY.ESC)
        {
            ZDBAxisProp.hideComboOptComp();
            ZDBAxisProp.removeComboOptEvent(event);
        }
    }
    else if(event && event.type == "click")
    {
        ZDBAxisProp.hideComboOptComp();
        ZDBAxisProp.removeComboOptEvent(event);
    }
    else
    {
        ZDBAxisProp.hideComboOptComp();
    }
}

ZDBAxisProp.hideComboOptComp = function()
{
    if(ZDBColorPalette.isOpen)
    {
        ZDBUtil.doNothing();
        return;
    }
    var inlineComboOpt = PropSettings.inlineComboOpt;
    if(inlineComboOpt)
    {
        var parentNode = inlineComboOpt.parentNode;
        ZDBUtil.setNamedChildEls(parentNode, parentNode, "elname", false);
        if(parentNode.funcDivPar && parentNode.thFunc) {
            parentNode.funcDivPar.style.backgroundColor = "white";
        }
        parentNode.removeChild(inlineComboOpt);
        var currentEl = parentNode.getElementsByTagName("div");
        if(currentEl[0].className == "inlinePropComboSel")
        {
            currentEl[0].className = "inlinePropCombo";
        }
        ZDBUtil.setFocus(currentEl[0]);
        PropSettings.inlineComboOpt = null;
    }
}

ZDBAxisProp.attachComboOptEvent = function(event)
{
    if(PropSettings.inlineComboOpt)
    {
        if(event)
        {
            ZDBUtil.stopEventBubble(event);
        }
        ZDBUtil.attachEvent(document, "click", ZDBAxisProp.hideComboOptDialog, false);
        ZDBUtil.attachEvent(document, "keydown", ZDBAxisProp.hideComboOptDialog, false);
    }
}

ZDBAxisProp.removeComboOptEvent = function(event)
{
    if(PropSettings.inlineComboOpt)
    {
        if(event)
        {
            ZDBUtil.stopEventBubble(event);
        }
        ZDBUtil.detachEvent(document, "click", ZDBAxisProp.hideComboOptDialog, false);
        ZDBUtil.detachEvent(document, "keydown", ZDBAxisProp.hideComboOptDialog, false);
    }
}

ZDBAxisProp.setTextDir = function(el)
{
    var parentNode = ZDBUtil.getParentWithAttributeValue(el, "propType", PropSettings.STRING_PROPTYPE);//No I18N
    ZDBAxisProp.setToggleEl(el);
    parentNode.setAttribute("propValue",el.getAttribute("value"));
}

ZDBAxisProp.getAxisTypeEl = function(labelEls, axisType)
{
	for(var labelEl in labelEls)
	{
		if(labelEls[labelEl].AXIS == axisType)
		{
			return labelEls[labelEl];
		}
	}
}

ZDBAxisProp.getAxisTypeEls = function(labelEls, axisType)
{
	var els = new Array();
	for(var labelEl in labelEls)
	{
		if(labelEls[labelEl].AXIS == axisType)
		{
			els.push(labelEls[labelEl]);
		}
	}
	return els;
}

ZDBAxisProp.setPropValOnCheck = function(el)
{
    var propValue = el.checked;
    el.setAttribute("propValue" , propValue+ "");
    this.showOrHideAxis(el);
    ZDBInlineDialog.resizeDlgHeight();
}
ZDBAxisProp.showOrHideAxis= function(el)
{
	var propSetUtil = ZDBClientUI.getViewObj(el,"propSetUtil");//No I18N
	var propSetForm=propSetUtil.propSetForm;
	var propName = el.getAttribute("propName");
    if(!el.checked)
    {
    	if(propName == "chart.xAxis.show")
    	{
    		(propSetForm.XAXIS).style.display="none";
   		}
    	else if(propName == "chart.yAxis.show")
   		{
   			(propSetForm.YAXIS).style.display="none"
   		} 	   
    }
    else
    {
    	if(propName == "chart.xAxis.show")
		{
    		(propSetForm.XAXIS).style.display="inline";
		}
    	else if(propName == "chart.yAxis.show")
		{
    		(propSetForm.YAXIS).style.display="inline";
		}
    }

}
ZDBAxisProp.setToggleEl = function(el)
{
    this.removeToggleElStyle(el);
    el.className = "inlineToggleElSelected";
}

ZDBAxisProp.removeToggleElStyle = function(el)
{
    var toggleEls = (el.parentNode).getElementsByTagName("div");
    for(var i=0, j= toggleEls.length; i< j ; i++)
    {
        toggleEls[i].className = "inlineToggleEl";
    }
}

ZDBAxisProp.setWeekYearFormatEl = function(weekYearFormat,propSetUtil)
    {
        weekYearFormat.style.display = "";
        ZDBUtil.setNamedChildEls(weekYearFormat, weekYearFormat);
        switch(propSetUtil.getPropValue(PropSettings.CHART_WEEKYR_FORMAT,  PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE))
        {
            case '1':
                ZDBAxisProp.setWeekYearFormat(weekYearFormat.mediumWYFormat, weekYearFormat);
                break;
            case '2':
                ZDBAxisProp.setWeekYearFormat(weekYearFormat.longWYFormat, weekYearFormat);
                break;
            default:
                ZDBAxisProp.setWeekYearFormat(weekYearFormat.shortWYFormat, weekYearFormat);    
        }
    }

ZDBAxisProp.setWeekYearFormat = function(el, weekYearFormat)
{
	var format = new Array();
    format[0] = "zrpt.common.analysis.axis.settings.js.wkyrshortfmt";
    format[1] = "zrpt.common.analysis.axis.settings.js.wkyrmediumfmt";
    format[2] = "zrpt.common.analysis.axis.settings.js.wkyrlongfmt";
        
    if(!weekYearFormat)
    {
        weekYearFormat = ZDBClientUI.getViewObj(el,"weekYearFormat");
    }
        
    ZDBAxisProp.setToggleEl(el);
    var value = parseInt(el.getAttribute("value"));
    ZDBUtil.setNamedChildEls(weekYearFormat, weekYearFormat);
    weekYearFormat.setAttribute("propValue", value);
    weekYearFormat.weekYearDisplay.innerHTML = ZDBI18NMap.g(format[value]);
    var vmfilterList = ZDBClientUI.selectedTab.view.VMFiltersList;
    for(var i = 0;i<vmfilterList.length;i++)
    {
        var vmEl = ZDBClientUI.selectedTab.view.VMFiltersList[i]
        if(vmEl.getAttribute("addonType") == 'ABSDATECATEGORICAL' && vmEl.getAttribute("subtype") == '109')
        {
            vmEl.setAttribute('vmfilterfetchstatus','0');
        }
    }
}
