//$Id$

var ZDBPreviewProp = new function()
{
    this.showPreviewGraph = function(el, isReset)
    {
        var propSetUtil = ZDBClientUI.getViewObj(el,"propSetUtil");
        ZDBPreviewProp.hidePreview(propSetUtil);
        var view = propSetUtil.view;
        if(isReset)
        {
            view.refreshGraph(ZDBPreviewProp.previewGraph);
            return;
        }
        var showPreview = ZDBPropValidator.checkValuesinPropSet(propSetUtil, false);
        if(!ZDBGlobal.integrated && propSetUtil.clrPltObj)
        {
        	PropSettings.setLegendChartClrPltInfo(propSetUtil.clrPltObj.props.jsonInfo,view);
        }
        PropSettings.previewZACF(view);
        if(showPreview)
        {
            view.chartHeight = 325;
            view.chartWidth = 600;
            propSetUtil.prevClass = propSetUtil.propSetForm.className;
            view.refreshGraph(ZDBPreviewProp.previewGraph);
        }
    }

    this.previewGraph = function(response,requestOptions)
    {
    	var view = requestOptions["VIEW"];
    	var propSetUtil = view.propSetUtil;
    	var previewDiv = document.createElement("div");
        previewDiv.style.width = "600px";
		previewDiv.style.height = "325px";
        propSetUtil.propSetForm.preview_chart.style.display = "";
        
        ZDBInlineDialog.changeTab(propSetUtil.propSetForm.preview_chart, propSetUtil.propSetForm);
        var prevChart = propSetUtil.propSetForm.pre_chart_placer;
        prevChart.innerHTML = ""; // just to show the current previewed chart - if chart preview clicked multiple times
        prevChart.appendChild(previewDiv);
    	var respJSON = JSON.parse(response.responseText);
        var previewData = respJSON.chartJSON;
        var chartObj = view.chartObj;
        chartObj.setPreviewData(previewData);
        chartObj.setPreviewContainer(previewDiv);
        chartObj.showPreview();
        
        if(propSetUtil.canReset)
        {
            var propResetLink = propSetUtil.propSetForm.propResetLink;
            propResetLink.style.display = "inline"; //No I18N
            PropSettings.restoreBackUpProp(view);
        }

    }

    this.hidePreview = function(propSetUtil)
    {
    	propSetUtil.propSetForm.preview_chart.style.display = "none";
    	propSetUtil.propSetForm.pre_chart_placer.innerHTML ='';
        ZDBInlineDialog.resizeDlgHeight();
    }

    this.changeTab = function(el)
    {
    	var propSetUtil = ZDBClientUI.getViewObj(el, "propSetUtil");
    	propSetUtil.propSetForm.className = propSetUtil.prevClass;
        ZDBPreviewProp.hidePreview(propSetUtil);
    }

    this.resetPreview = function(el)
    {
        var propSetUtil = ZDBClientUI.getViewObj(el, "propSetUtil");
        var propResetLink = propSetUtil.propSetForm.propResetLink;
        propResetLink.style.display = 'none';
        propSetUtil.canReset = false;
        if(propSetUtil.fontPropObj)
        {
            var fontEls= (propSetUtil.fontPropObj).getFontEls();
            for(var i in fontEls)
            {
                PropSettings.removeUnwantedChilds(fontEls[i]);
            }
        }
        ZAChartDrillView.resetDrillInfo(propSetUtil);
        ReactDOM.unmountComponentAtNode(propSetUtil.propSetForm.clrPalette);
        PropSettings.processPossibleOpt(propSetUtil);
        propSetUtil.view.zacf.reset();
        ZDBPreviewProp.showPreviewGraph(el, true);
    }

}
