/*$Id$*/

var ZDBPropValidator = new function()
{

    this.showErrorMsg = function(propSetForm, propForm, errorEl, errorMsg, scrollTop)
    {
        ZDBInlineDialog.changeTab(propForm, propSetForm);//No I18N
        if(scrollTop)
        {
            var dlgEl = ZDBUtil.getParentWithAttributeValue(errorEl, "inlinediv", "mainDialogDiv");//No I18N
            dlgEl.scrollTop = ZDBUtil.getObjTop(errorEl) - 50 ;
        }
        ZDBUtil.setFocus(errorEl,true);
        showCustomMessage(errorMsg,errorEl);//No I18N
        return false;
    }

    this.checkValuesinPropSet = function(propSetUtil, closeDialog)
    {
    	var view = propSetUtil.view;
    	PropSettings.takeBackUpProp(propSetUtil, view);
        var chartObj = view.chartObj;
        var generalObj = propSetUtil.generalObj;
        if(!generalObj.checkGeneralProp())
        {
            return false;
        }
        if(view.graphSelected != "TABLE_CHART")
        {
            if(!generalObj.checkNullValueProp())
            {
                    return false;
            }
    	}
    	if(view.graphSelected === "PIE" && view.subGraphType === "FUNNEL")
    	{
            propSetUtil.propSetForm.funnelLbl.value = propSetUtil.propSetForm.funnelLbl.value.trim();
            if(propSetUtil.propSetForm.funnelLbl.value.length > PropSettings.CONV_LBL_LENGTH)
            {
                return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.genPropNav, propSetUtil.propSetForm.funnelLbl,
                    ZDBI18NMap.f("zrpt.common.analysis.settings.js.convLblLenExceedErr", PropSettings.CONV_LBL_LENGTH));
            }
        }
        generalObj.setGeneralPropMap();
        if(propSetUtil.isAxisProp)
        {
        	var axisObj = propSetUtil.axisObj;
            if(!axisObj.checkRangeIntValues())
            {
                return false;
            }
            if(!axisObj.checkAxisLabelValues())
            {
            	return false;
            }
            axisObj.setAxisPropMap();
            (propSetUtil.fontPropObj).setFontPropMap();
            (propSetUtil.backgroundObj).setBackgroundProp();
        }
        if(propSetUtil.isMapProp)
        {             
            propSetUtil.mapPropObj.setMapPropMap(propSetUtil);
            (propSetUtil.fontPropObj).setFontPropMap();
        }
        if(propSetUtil.isLegend && !chartObj)
        {
        	//---LegChange needed
            if(!ZALegendConfig.setLegendProp(propSetUtil))
            {
                return false;
            }
            if(!ZALegendConfig.setLegendNameAndClr(propSetUtil))
            {
            	return false;
            }
            if(propSetUtil.isComboProp)
            {
                ZAComboChart.setComboProp(propSetUtil, null);
            }
          
        }
        else if(propSetUtil.isLegend && chartObj)
    	{
        	if(!chartObj.getLegendModel().setLegendComboProps())
    		{
        		return false;
    		}
        	if(ZDBGlobal.isClrPltEnabled() && propSetUtil.clrPltObj)
        	{
        		ZALegendConfig.setClrInfoToPropMap(propSetUtil);
//        		ZALegendConfig.setTransInPropMap(propSetUtil);
        		ReactDOM.unmountComponentAtNode(propSetUtil.propSetForm.clrPalette);
        	}
    	}
        if(propSetUtil.isThreshold)
        {
        	var thresholdObj = propSetUtil.thresholdObj;
            if(!thresholdObj.checkThresholdValues())
            {
                return false;
            }
        }
        if(propSetUtil.isDrillDown)
        {
            DrilldownConfig.setDrilldownProp(propSetUtil);
        }
        if(view.graphSelected != "TABLE_CHART") 
        {
            if(!ZDBPropValidator.checkToolTipInputVal(propSetUtil)) 
            {
                return false;
            }
        }
        if(propSetUtil.modified)//if any property is modified
        {
        	propSetUtil.setPropSet(view, closeDialog);//make change to view
            propSetUtil.canReset = true; //for preview
            propSetUtil.resetModified();
        }
        return true;
    }

    // can be written in the Tooltip section
    this.checkToolTipInputVal = function(propSetUtil) 
    {
        var parNode = propSetUtil.propSetForm.ZACFDiv;
        var inputEls = parNode.getElementsByTagName('input');
        for(var i = 0, j = inputEls.length; i < j; i++) 
        {
        	var tooltipVal = inputEls[i].value.trim();
        	var length = tooltipVal.length;
        	var isMergeAxis = inputEls[i].getAttribute("isMergeAxis") == "true" ? true : false;
            var errorMsg ='zrpt.common.showinfo.js.ColumnNameMaxLengthExceed';//No I18N
            var param = ZDBConst.COLNAME_MAX_LENGTH;
            if (length === 0 && !isMergeAxis)
            {
                errorMsg = 'zrpt.common.showinfo.js.ColumnName';//No I18N
                param = '';
            } 
            else if(length <= ZDBConst.COLNAME_MAX_LENGTH || isMergeAxis) 
            {
                continue;
            }
            return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.formatNav, inputEls[i], ZDBI18NMap.f(errorMsg, param), true);
        }
        return true;
    }
}
