/*$Id$*/

function ZDBThresholdProp(propSetUtil)
{
    var thresholdBody = propSetUtil.propSetForm.thresholdBody;
    var propSetUtil = propSetUtil;
    var tholdAxisDivEls;
    var tholdLabelSize;
    
    this.addReferenceAxis = function(el)
    {
        ZDBUtil.removeAllChildren(el);
        var dummyOpt = document.createElement("option");
        var dummy = ZDBUtil.getCloneNode(dummyOpt);
        dummy.value='0';
        dummy.innerHTML = "None"; //No I18N
        dummy.selected="true";
        el.appendChild(dummy);
        for(var i=0; i < tholdLabelSize ; i++)
        {
            var tholdEl = tholdAxisDivEls[i];
            dummy = ZDBUtil.getCloneNode(dummyOpt);
            dummy.setAttribute("value",ZDBAnalysisView.replaceInstKey(propSetUtil.view, tholdEl.key));
            dummy.innerHTML = ZDBEscapeUtil.encodeForHtml(tholdEl.label);
            el.appendChild(dummy);
        }
    };
    
    // to send information from threshold settings dialog to server
    this.setThresholdPropMap = function(thresholdEl, thresIndex)
    {
        var thresName = PropSettings.CHART_THRESHOLD_NAME + thresIndex;
        var scope = thresName + PropSettings.CHART_THRESHOLD_SCOPE;
        var func = thresName + PropSettings.CHART_THRESHOLD_FUNCTION;
        var style = thresName + PropSettings.CHART_THRESHOLD_STYLE;
        var instId = (thresholdEl.tName).getAttribute("instId");
        var propMap = propSetUtil.propMap;
        for(var existInstId in propMap[thresName])
        {
            if(existInstId != instId)
            {
                propSetUtil.deleteFromPropMap(thresName, existInstId);
                propSetUtil.deleteFromPropMap(scope, existInstId);
                propSetUtil.deleteFromPropMap(func, existInstId);
                propSetUtil.deleteFromPropMap(style, existInstId);
            }
        }
        propSetUtil.setPropMap(thresholdEl.tName, propSetUtil.getPropValue(thresName, instId, (thresholdEl.tName).getAttribute("propType")));
        propSetUtil.setPropMap(thresholdEl.tColor, propSetUtil.getPropValue(thresName, instId, (thresholdEl.tColor).getAttribute("propType")));
        DynamicThreshold.setThresholdProp(propSetUtil, thresholdEl, thresName, instId);
    };

    this.initializeThresholdEl = function()
    {
        var view = propSetUtil.view;
        var tholdInfo = view.thInfo;
        var tholdClrs = tholdInfo.THOLD_CLRS;
        var colorArr = new Array();
        colorArr = tholdClrs.split(",");
        var thresholdEl = propSetUtil.propSetForm.thresholdEl;
        var dummyEl = ZDBUtil.getCloneNode(thresholdEl);
        dummyEl.removeAttribute("elname");
        ZDBUtil.setNamedChildEls(dummyEl, dummyEl,"elname", false);
        dummyEl.style.display="";
        dummyEl.tColor.setAttribute("value",colorArr[propSetUtil.thresholdCount]);
        dummyEl.tColor.style.backgroundColor= "#" + colorArr[propSetUtil.thresholdCount];
        propSetUtil.thresholdCount++;
        if(propSetUtil.thresholdCount >= propSetUtil.tholdMax)
        {
            propSetUtil.propSetForm.addThresholdLink.className = "inlineLinkDisabled";
        }
        else
        {
            propSetUtil.propSetForm.addThresholdLink.className = "inlineLinkStyle";
        }
        thresholdBody.appendChild(dummyEl);
        TholdComponents.initComponents(propSetUtil, dummyEl, tholdAxisDivEls, tholdLabelSize);
        return dummyEl;
    };

    // to show threshold in settings page from server info
    this.setThresholdPropValues = function()
    {
        var view = propSetUtil.view;
        var parViewId = view.parentViewId;
        var relModelId = ZDBClientUtil.getJsonRelModelIdForObjId(parViewId);
        if(!relModelId)
        {
            ZDBDashboardUF.checkNSendDashFieldsRequest(view, view.parentViewId, false, false, this);
        }
        else
        {
            this.handleTholdValues();
        }
    };
    
    this.handleTholdValues = function()
    {
        var view = propSetUtil.view;
        var tholdInfo = view.thInfo;
        propSetUtil.tholdMax = tholdInfo.THOLD_COUNT;
        PropSettings.removeUnwantedChilds(thresholdBody, 2);
        propSetUtil.thresholdCount = 0;
        tholdAxisDivEls = view.tholdAxisDiv;
        tholdLabelSize = tholdAxisDivEls.length;
        for(var i=1; i<=propSetUtil.tholdMax; i++)
        {
            var propName = PropSettings.CHART_THRESHOLD_NAME + i;
            if(propSetUtil.propMap[propName] && propSetUtil.thresholdCount < propSetUtil.tholdMax)
            {
                var thresInst = this.initializeThresholdEl();
                var instId = null;
                for(var key in propSetUtil.propMap[propName])
                {
                   instId = key;
                }
                if(instId == null)
                {
                    break;
                }
                var color = PropSettings.adjustToHex(propSetUtil.getPropValue(propName, instId, PropSettings.COLOR_PROPTYPE)["STARTCOLOR"]);//No I18N
                var label = propSetUtil.getPropValue(propName, instId, PropSettings.STRING_PROPTYPE);
                var propVal = 0;
                var options = jQuery(thresInst.refAxisEl).find("option");
                for(var j=0; j< options.length; j++)
                {
                    var metadata =ZComponents.getOptions(options[j]);
                    if(metadata.customData === instId) {
                        jQuery(thresInst.refAxisEl).zselectbox("setAttribute", "selectedIndex", metadata.value); //No I18N
                        propVal = metadata.value;
                    }
                }
                var tdEl = ZDBUtil.getParentWithTagName(thresInst.refAxisEl, "td"); //No I18N
                tdEl.setAttribute("propvalue", propVal);
                if(i === 1) {
                    propSetUtil.propSetForm.tholdPropNav.focusEl = thresInst.tName;
                }
                thresInst.tName.value = label;
                thresInst.tColor.setAttribute("value", color);
                thresInst.tColor.style.backgroundColor= "#" + color;
                DynamicThreshold.showTholdValues(propSetUtil, propName, thresInst, instId);
            }
            else
            {
                break;
            }
        }
        if(propSetUtil.thresholdCount == 0)
        {
            ZDBThresholdProp.removeAllNonThresholdEl(thresholdBody);
            this.initializeThresholdEl();
            ZDBUtil.setNamedChildEls(thresholdBody, thresholdBody);
            propSetUtil.propSetForm.tholdPropNav.focusEl = thresholdBody.tName;
        }
    };
    
    this.checkThresholdValues = function()
    {
        var thresholdEls = thresholdBody.getElementsByTagName("tr");
        var dummyThresEls = ZDBUtil.getElsWithTagNAttrWithVal(thresholdBody, "elname", "thresholdEl", "tr");//No I18N
        var size = thresholdEls.length - dummyThresEls.length;
        var THOLDPROPNAME = PropSettings.CHART_THRESHOLD_NAME;//No I18N
        var tholdMax = propSetUtil.tholdMax;
        for(var i=1;i<size; )
        {
            var thresholdEl = thresholdEls[i];
            ZDBUtil.setNamedChildEls(thresholdEl, thresholdEl);
            if(ZDBThresholdProp.isTholdAdded(thresholdEl))
            {
                if(!ZDBThresholdProp.validateThresholdRow(propSetUtil, thresholdEl))
                {
                    return false;
                }
                ZDBThresholdProp.initializeThdColor(thresholdEl);
                ZDBThresholdProp.setPropNameforThold(thresholdEl, i);
                ZDBThresholdProp.setInstIdForThold(thresholdEl, thresholdEl.tSelect.value);
                this.setThresholdPropMap(thresholdEl, i++);
            }
            else
            {
                size--;
                ZDBThresholdProp.removeThreshold(thresholdEl.tSelect);
            }
        }
        for(var actual=i; actual<=tholdMax ; actual++)
        {
            var tholdProp = THOLDPROPNAME + actual;
            propSetUtil.deleteFromPropMap(tholdProp);
            propSetUtil.deleteFromPropMap(tholdProp + PropSettings.CHART_THRESHOLD_SCOPE);
            propSetUtil.deleteFromPropMap(tholdProp + PropSettings.CHART_THRESHOLD_FUNCTION);
            propSetUtil.deleteFromPropMap(tholdProp + PropSettings.CHART_THRESHOLD_STYLE);
        }
        return true;
    };
    return this;
}

ZDBThresholdProp.isTholdAdded = function(thresholdEl)
{
    var scope = thresholdEl.tScope.getAttribute("propvalue");
    var func = thresholdEl.tFunc.getAttribute("propvalue");
    var tholdName = thresholdEl.tName.value;
    var format = thresholdEl.tStyle.getAttribute("propvalue");
    if((scope && scope != 0) || (func && func != '0') || tholdName || (format && format != '0') ||
            ((!func || func == '0') && thresholdEl.tValue.value)) {
        return true;
    }
    return false;
};

ZDBThresholdProp.removeAllNonThresholdEl = function(thresholdBody)
{
    var thresholdEls = thresholdBody.getElementsByTagName("tr");
    var size = thresholdEls.length;
    while(size != 1)
    {
        thresholdBody.removeChild(thresholdEls[1]);
        size--;
    }
};

ZDBThresholdProp.addThreshold = function(el)
{
    var propSetUtil = ZDBClientUI.getViewObj(el,"propSetUtil");
    var thresoldObj = propSetUtil.thresholdObj;
    var tholdMax = propSetUtil.tholdMax;
    if(propSetUtil.thresholdCount < tholdMax)
    {
        thresoldObj.initializeThresholdEl();
    }
    ZDBInlineDialog.resizeDlgHeight();
};

ZDBThresholdProp.removeThreshold = function(el)
{
    var propSetUtil = ZDBClientUI.getViewObj(el,"propSetUtil");
    var view = propSetUtil.view;
    var tholdMax = propSetUtil.tholdMax;
    var thresholdEl = ZDBUtil.getParentWithTagName(el, "tr");//No I18N
    var thresholdBody = propSetUtil.propSetForm.thresholdBody;
    thresholdBody.removeChild(thresholdEl);
    propSetUtil.thresholdCount--;
    var thresholdObj = propSetUtil.thresholdObj;
    if(propSetUtil.thresholdCount == 0)
    {
        ZDBThresholdProp.removeAllNonThresholdEl(thresholdBody);
        thresholdObj.initializeThresholdEl(view);
    }
    if(propSetUtil.thresholdCount < tholdMax)
    {
        propSetUtil.propSetForm.addThresholdLink.className = "inlineLinkStyle";
    }
    var firstThold = thresholdBody.getElementsByTagName("tr")[1];
    propSetUtil.propSetForm.tholdPropNav.focusEl = firstThold.tName;
    ZDBInlineDialog.resizeDlgHeight();
};

ZDBThresholdProp.setPropNameforThold = function(thresholdEl, count)
{
    ZDBUtil.setNamedChildEls(thresholdEl,thresholdEl);
    var tholdProp = PropSettings.CHART_THRESHOLD_NAME + count;
    thresholdEl.tName.setAttribute("propname", tholdProp);
    thresholdEl.tValue.setAttribute("propname", tholdProp);
    thresholdEl.tColor.setAttribute("propname", tholdProp);
    thresholdEl.tScope.setAttribute("propname", tholdProp + PropSettings.CHART_THRESHOLD_SCOPE);
    thresholdEl.tFunc.setAttribute("propname", tholdProp + PropSettings.CHART_THRESHOLD_FUNCTION);
    thresholdEl.parDiv.setAttribute("propname", tholdProp);
    thresholdEl.tStyle.setAttribute("propname", tholdProp + PropSettings.CHART_THRESHOLD_STYLE);
};

ZDBThresholdProp.setInstIdForThold = function(thresholdEl, value)
{
    thresholdEl.tName.setAttribute("instid", value);
    thresholdEl.tValue.setAttribute("instid", value);
    thresholdEl.tColor.setAttribute("instid", value);
    thresholdEl.tScope.setAttribute("instid", value);
    thresholdEl.tFunc.setAttribute("instid", value);
    thresholdEl.parDiv.setAttribute("instid", value);
    thresholdEl.tStyle.setAttribute("instid", value);
    ZDBThresholdProp.initializeThdColor(thresholdEl);
};

ZDBThresholdProp.initializeThdColor = function(thresholdEl)
{
    thresholdEl.tColor.setAttribute("type","normal");
    thresholdEl.tColor.setAttribute("endcolor",parseInt("0x"+thresholdEl.tColor.getAttribute("value")));
    thresholdEl.tColor.setAttribute("startcolor",parseInt("0x"+thresholdEl.tColor.getAttribute("value")));
};

ZDBThresholdProp.selectReferenceAxis = function(parent, key)
{
    var childEls = parent.getElementsByTagName("option");
    var len = childEls.length;
    for(var i=0; i<len; i++)
    {
        var child = childEls[i];
        if(child.getAttribute("value") == key)
        {
            child.selected = true;
            return;
        }
    }
};

ZDBThresholdProp.setCustomColor = function(el)
{
    var clrVal = el.value.substring(1);
    el.setAttribute("clr", clrVal);
    DynamicThreshold.setTholdColor(el);
};

ZDBThresholdProp.validateThresholdRow = function(propSetUtil, thresholdEl, noShowErrMsg)//checking for Threshold Row
{
	var propSetForm = propSetUtil.propSetForm;
	var el = null;
	var errMsg = null;
    if(ZDBValidator.isBlank(thresholdEl.tName.value))//Threshold Name cannot be empty
    {
    	el = thresholdEl.tName;
    	errMsg = ZDBI18NMap.g("zrpt.common.analysis.threshold.settings.js.noNameErr"); //No I18N
    }
    var tName = thresholdEl.tName.value;
    if(tName.length > 100)//Threshold Name cannot be empty
    {
    	el = thresholdEl.tName;
    	errMsg = ZDBI18NMap.g("zrpt.common.analysis.threshold.settings.js.noNameLen"); //No I18N
    }
    if((thresholdEl.tFunc.value === undefined))
    {
        thresholdEl.tValue.value = thresholdEl.tValue.value.trim();
        if(ZDBValidator.isBlank(thresholdEl.tValue.value))//Threshold Value cannot be empty
        {
        	el = thresholdEl.tValue;
        	errMsg = ZDBI18NMap.g("zrpt.common.analysis.threshold.settings.js.noValErr"); //No I18N
        }
        else if(!ZDBValidator.isDecimal(thresholdEl.tValue.value, false, true))// Threshold value must be a number
        {
        	el = thresholdEl.tValue;
        	errMsg = ZDBI18NMap.g("zrpt.common.analysis.threshold.settings.js.valNANErr"); //No I18N
        }
    }
    if(el != null && errMsg != null)
    {
    	if(noShowErrMsg)
    	{
    		return false;
    	}
    	return ZDBPropValidator.showErrorMsg(propSetForm, propSetForm.tholdPropNav, el, errMsg);
    }
    return true;
};
	
	ZDBThresholdProp.isThresholdAvlbl = function(view, instId)// To check whether any threshold is created with the given instId as reference axis
	{
		var propSetUtil = view.propSetUtil;
		var thresholdBody = propSetUtil.propSetForm.thresholdBody;  
		var thresholdEls = thresholdBody.getElementsByTagName("tr");
		var dummyThresEls = ZDBUtil.getElsWithTagNAttrWithVal(thresholdBody, "elname", "thresholdEl", "tr");//No I18N
		var size = thresholdEls.length - dummyThresEls.length;
		var tholdMax = view.propSetUtil.tholdMax;
		for(var i=1;i<size; i++)
		{
		    var thresholdEl = thresholdEls[i];
		    ZDBUtil.setNamedChildEls(thresholdEl, thresholdEl);
		    if(ZDBThresholdProp.isTholdAdded(thresholdEl))
		     {
		        if(ZDBThresholdProp.validateThresholdRow(propSetUtil, thresholdEl, true) == true)
		        {
//		        	var value = thresholdEl.refAxisEl.getAttribute("selectedIndex");
		            var select = thresholdEl.tSelect;
		            var value = select.getAttribute("propvalue");
		            var options = select.getElementsByTagName("option");
		            if(ZDBGlobal.enableDynThold)
		            {
			            for(var j =0; j<options.length;j++)
		            	{
			            	if(options[j].getAttribute("value") == value)
			            	{
			            		var metadata = ZComponents.getMetadata(options[j]);
		                        if(metadata.customData === instId) 
		                        {
		                        	return true;
		                        }
			            	}
		            	}
		            }
		            else
		            {
		            	return select.value == instId;
		            }
		        }
		    }
		}
		return false;
	}