//$Id$

/****************************TO-DO List*****************************************
 *   1. appendZACFOptions should be called only once                           *
 *      Existing - called when Format tab is clicked                           *
 *   2. showCustomFormatDlg remove if check and change logic to set format type*
 ******************************************************************************/



var ZACF = new function() {
      
	var xAxis = "XAXIS"; //No I18N
	var yAxis = "YAXIS"; //No I18N
	var clrAxis = "COLORAXIS"; //No I18N
	var txtAxis = "TEXTAXIS"; //No I18N
	var sizeAxis = "SIZEAXIS"; //No I18N
	var grpAxis = "GROUP"; //No I18N
	
    this.getZACFInst = function() {
        return new ZACFInst();
    };
    
    this.isPie = function(view)
    {
    	return view.type && view.type == "AnalysisView" && view.chartObj && view.chartObj.getChartType() == ZCHARTCONST.get("PIE"); //No I18n  
    }
    
    this.getXMLFromInst = function(view, instKey) {
    	instKey = view.instMap && view.instMap[instKey] && view.isViewRefreshed == 1 ? view.instMap[instKey] : instKey;
    	var zacfInst = view.zacf;
        if(!zacfInst.isZACF(instKey)) {
            return '';
        }
        var zaf = zacfInst.get(instKey);
        var positions = Object.keys(zaf);
        var xmlBuffer = new ZDBStrBuf();
        for(var i = 0; i< positions.length; i++)
        {
        	var pos = positions[i];
        	if(ZACFConstants.ALL_POSITIONS.indexOf(pos) == -1)
        	{
        		continue;
        	}
	        var xmlBuf = new ZDBStrBuf();
	        xmlBuf.sTag('zacf');//NO I18N
	        var zacf = zaf[pos];
	        if(pos == "DEFAULT" && ZACF.getFormatInfo(view, "FORMAT_IN_TABLE", instKey) && view.zacf.equals(zacf, ZACF.getFormatInfo(view, "FORMAT_IN_TABLE", instKey)))
	        {
	        	continue;
	        }
	        for(var key in zacf) {
	            var xmlKey = ZACFConstants.XMLPARAMS[key];
	            if(!xmlKey) {
	                continue;
	        }
	            xmlBuf.attr(xmlKey, zacf[key]);
	        }
	        xmlBuf.attr('type',ZACFConstants.TYPE[zacf.type]);
	        xmlBuf.attr('instkey',instKey);//NO I18N
	        var isApplyToAll = zaf["APPLYTOALL"];
	        var isChart = view.type == "AnalysisView";
	        var isPie = isChart && view.chartObj && view.chartObj.getChartType() == ZCHARTCONST.get("PIE"); //No I18n
	        var isMultiY = isChart && view.chartSelectedEl.isMultiY;
	        if(isApplyToAll || (!isChart && i == 0) || (isPie && isMultiY && instKey.split(',').length == 1) || (isChart && !isPie && isMultiY && view.metaInfo.MERGE && instKey.split(',').length > 1))
	        {
	        	xmlBuf.attr('pos', null); //NO I18N
	        }
	        else
	        {
	        	xmlBuf.attr('pos', pos); //NO I18N
	        }
	        xmlBuf.attr('all', isApplyToAll); //NO I18N
	        xmlBuf.a('>\n').eNTag('zacf');//NO I18N
	        xmlBuffer.a(xmlBuf);
        }
        return xmlBuffer.toString();
    };
    
    /* Do Clean UP*/
    this.appendZACFOptions = function(view, formatDiv, isChart) {
        ZDBUtil.setNamedChildEls(formatDiv,formatDiv,'node');
        var colsHolder = formatDiv.ZACFColsHolder;
    	var row = formatDiv.ZACFRow;
    	var table = formatDiv.ZACustomFormatTable.cloneNode(true);
        var currentList = view.currentList;
        var xAxisBuf = [], yAxisBuf = [], clrAxisBuf = [], txtAxisBuf = [], sizeAxisBuf = [], grpAxisBuf = [];
        var rowsBuffer = {
        		xAxis:xAxisBuf,
        		yAxis:yAxisBuf,
        		clrAxis:clrAxisBuf,
        		txtAxis:txtAxisBuf,
        		sizeAxis:sizeAxisBuf,
        		grpAxis:grpAxisBuf        		
        }
    	ZDBUtil.setNamedChildEls(table,table,'node');
    	var header = table.ZACFHeader;
    	var j = 0;
    	for(var i = 0; i < header.childNodes.length; i++)
    	{
    		var curHead = header.childNodes[i];
    		if(curHead.nodeName.toUpperCase() == "TH")
    		{
	    		if(isChart)
	    		{
	    			curHead.style.width = "20%";
	    			if(j == 0)
	    			{
	    				curHead.style.display = "";
	    			}
	    			if(j == 3)
	    			{
	    				curHead.style.width = "30%";
	    			}
	    			if(j == 2)
	    			{
	    				curHead.innerHTML = ZDBI18NMap.g("zrpt.chartview.setting.js.toolTipLabel"); //No I18n
	    			}
	    		}
	    		else
	    		{
	    			curHead.style.width = "33%";
	    		}
	    		j++;
    		}
    	}
    	
    	var instKeys = view.zaf.INST_KEYS;
    	var i = 1, j = 0;
        while(instKeys[i])
        {
            var instKey =  instKeys[i++];
    		if(isNaN(Number(instKey)) || Number(instKey) < 1)
    		{
    			continue;
    		}
    		var chartType = view.type;
            var curZACF = view.zacf.get(instKey);
            if(!curZACF)
            {
            	continue;
            }
            var viewType = curZACF.AXISTYPE;
        	var positions = curZACF.positions || view.zaf.zacf[instKey].positions;
        	curZACF = curZACF[positions[0]] || ZACF.getFormatInfo(view, positions[0]);
        	var oldInstKey = view.revInstMap && view.revInstMap[instKey] ? view.revInstMap[instKey] : instKey;
    		var displayLabel = view.curListProp[oldInstKey] && view.curListProp[oldInstKey]["PVTCOLUMNNAME"] ? view.curListProp[oldInstKey]["PVTCOLUMNNAME"] : curZACF.displayLabel;
    		var colName = curZACF.displayName;
    		var curRow = row.cloneNode(true);
    		ZDBUtil.setNamedChildEls(curRow,curRow,'node');
    		if(isChart)
    		{
    			curRow.ZACFAxis.style.display = "";
    			curRow.ZACFAxis.innerHTML = ZDBEscapeUtil.encodeForHtml(ZACF.getAxisDispName(viewType));
    			curRow.ZACFColName.style.width = "20%";
    			curRow.ZACFLabel.style.width = "20%";
    			curRow.ZACFLinkNode.style.width = "30%";
    		}
    		curRow.ZACFColName.innerHTML = ZDBEscapeUtil.encodeForHtml(colName);
                curRow.ZACFDlgLink.setAttribute('instKey',instKey);
                curRow.ZACFDlgLink.setAttribute('idx',j);
    		curRow.ZACFRename.value = displayLabel;
                curRow.ZACFRename.setAttribute('idx',j++);
                curRow.ZACFDlgLink.addEventListener('click', function() {
                    view.zacf.setKey(this.getAttribute('instKey'));
                    ZDBPopUpMenu.gridOper(this);
                });
                curRow.ZACFRename.addEventListener('change', function() {
                    hideCustomMessage();
                    if(ZDBAnalysisEditViewMode.validateInputField(this)) {
                        var idx = this.getAttribute('idx');
                        view.colsModifiedIdx[idx] = this.value;
                    }
                });
                switch(viewType)
                {
                case "XAXIS": //No I18N
            		xAxisBuf.push(curRow);
            		break;
            	case "YAXIS": //No I18N
            		yAxisBuf.push(curRow);
            		break;
            	case "COLORAXIS": //No I18N
            		clrAxisBuf.push(curRow);
            		break;
            	case "TEXTAXIS": //No I18N
            		txtAxisBuf.push(curRow);
            		break;
            	case "SIZEAXIS": //No I18N
            		sizeAxisBuf.push(curRow);
            		break;
            	case "GROUP": //No I18N
            		grpAxisBuf.push(curRow);
                }
    		curRow.style.display='';
    	}
    	if(isChart && view.chartSelectedEl.isMultiY && view.metaInfo.MERGE && !ZACF.isPie(view))
    	{
    		var labelEls = view.labelDiv;
    		var mergedAxis;
    		for(var i = 0; i < labelEls.length; i++)
    		{
    			var labelEl = labelEls[i];
    			var instKey = labelEl.KEY;
    			if(instKey.split(',').length > 1)
    			{
    				mergedAxis = labelEl;
    				break;
    			}
    		}
    		if(mergedAxis != null)
    		{
    			var curRow = row.cloneNode(true);
    			ZDBUtil.setNamedChildEls(curRow,curRow,'node');
    			curRow.ZACFAxis.style.display = "";
    			curRow.ZACFAxis.innerHTML = ZDBI18NMap.g("zrpt.chartview.setting.js.mergYAxis"); //No I18n
        		curRow.ZACFColName.innerHTML = mergedAxis.VALUE || ZDBI18NMap.g("zrpt.chartview.setting.js.mergAxis"); //No I18n
        		curRow.ZACFRename.value = mergedAxis.VALUE || "---"; //No I18n;
        		curRow.ZACFRename.disabled = true;
        		curRow.ZACFRename.setAttribute("isMergeAxis", "true");
                curRow.ZACFDlgLink.setAttribute('instKey',instKey);
                    curRow.ZACFDlgLink.addEventListener('click', function() {
                        view.zacf.setKey(this.getAttribute('instKey'));
                        ZDBPopUpMenu.gridOper(this);
                    });
	             curRow.style.display='';
	             yAxisBuf.unshift(curRow);
    		}
    	}
    	ZACF.appendRows(rowsBuffer, table);
    	colsHolder.innerHTML = '';
    	table.style.display = '';
    	view.curZAFormatOptions = table;
    	colsHolder.appendChild(table);
        view.zacf.reset();
        view.colsModifiedIdx = {};
    };
     /* Do Clean UP*/
    
    this.appendRows = function(rowsBuffer, table)
    {
    	var parentDiv = document.createElement("div");
    	var axesKeys = Object.keys(rowsBuffer);
    	for(var i = 0; i<axesKeys.length; i++)
    	{
    		var rows = rowsBuffer[axesKeys[i]];
    		for(var j = 0; j < rows.length; j++)
    		{
    			table.ZACFTbody.appendChild(rows[j]);
    		}
    	}
    }
    
    this.getAxisDispName = function(axisName)
    {
    	switch(axisName)
    	{
    	case xAxis:
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.xAxis"); //No I18N
    		break;
    	case yAxis:
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.yAxis"); //No I18N
    		break;
    	case clrAxis:
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.colorAxis"); //No I18N
    		break;
    	case txtAxis:
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.textAxis"); //No I18N
    		break;
    	case sizeAxis:
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.sizeAxis"); //No I18N
    		break;
    	case grpAxis:
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.toolTip"); //No I18N
    	}
    }
    
    this.showCustomFormatDlg = function (el, event)
    {
    	if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js","APPENDTODOC",ZACF.showCustomFormatDlg,[el, event]))
    	{
    		return;
    	}
        var view = ZDBClientUI.getViewObj(el, "view");//No I18N
        var instKey = el.getAttribute('instKey');
        var oldInstKey = ZDBAnalysisView.replaceInstKey(view, instKey);
        if(view.typeValue === ZDBClientViewAPI.TYPE_WIDGET) {
            WidgetEditor.setFormatType(instKey);
        } else if(!(view.merge) || DOMUtils.filterElements(view.currentList,'DIV','viewtype','YAXIS').length === 1){//NO I18N
            var idx = parseInt(el.getAttribute('idx'));
            var curNode = (idx)?view.currentList[idx]:DOMUtils.getFirstMatchingElement(view.currentList,'DIV','instkey',oldInstKey);//NO I18N
            ZACF.setAnalysisFormatType(view, curNode);
        }
        var colFormats = view.zacf.get();
        var isApplyToAll = colFormats.APPLYTOALL;
        view.zacf.setTempFmt();
        if(isApplyToAll && !ZACF.isPie(view))
        {
        	var colFormat = colFormats["DEFAULT"];
        }
        else
        {
        	var avlblPos = view.zacf.getAvlblPositions();
        	var positions = ZACF.getValidPositions(view, instKey, avlblPos);
            var colFormat = colFormats[positions[0]] || colFormats[avlblPos[0]] || ZACF.getFormatInfo(view, "DEFAULT");
        }
        
//        var colFormat = ZACF.getCorrespondingFmt(colFormats);
        ZDBSheetFormatExtn.dataType = ZDBUtil.dataTypeVsdataTypeNum[colFormat.type];
        var editFrmtColOpts = new ZDBEditColumnFormat(view.objId, ZDBEditColumnFormat.EDIT_CUSTOM_FORMAT, view);
        ZDBSheetFormatExtn.editFrmtColOpts = editFrmtColOpts;
        ZDBSheetFormatExtn.showFormatDlg(view,colFormat,null,editFrmtColOpts,el);
        var operation = ZACF.getCorresOperation(view.zacf.getCurrKey(), view, "operation"); //No I18n
        var enabledOpts = ZDBSheetFormatExtn.enableDisableColumnFormatOpts(ZDBSheetFormatExtn.dataType,view.type, operation);
        ZACF.checkForHundredPercentChart(view, instKey, enabledOpts);
        view.zacf.setEnabledOpts(enabledOpts);
        ZDBSheetFormatExtn.setValuesInFormatDlg(view, colFormat, null, editFrmtColOpts, operation);
        ZDBSheetFormatExtn.showOrHideTabs(colFormats, view, el, ZDBSheetFormatExtn.dataType);
        ZDBDialogUtil.closeDialog();
        ZDBSheetFormatExtn.showFormatDlg(view,colFormat,null,editFrmtColOpts,el);
    };
    
    this.getFormatInfo = function(view, position, instKey)
    {
    	return view.zacf.getFrmZAF(instKey)[position];
    }
    
    this.getCorresOperation = function(instKey, view, attributeName)
    {
    	var nodes = view.type == "WIDGET" ? WidgetEditor.editor.currentList : view.currentList;
    	var oldInstKey = ZDBAnalysisView.replaceInstKey(view, instKey);
    	for(var i = 0; i < nodes.length; i++)
    	{
    		var node = nodes[i];
    		if(node.getAttribute("instKey") == oldInstKey)
    		{
    			return node.getAttribute(attributeName);
    		}
    	}
    }
    
    this.checkForHundredPercentChart = function(view, instKey, enabledOpts)
    {
    	if(view.type && view.type == "AnalysisView")
    	{
	    	var showValAs = ZACF.getCorresOperation(instKey, view, "showvalueas");
	    	var baseFieldPos = ZACF.getCorresOperation(instKey, view, "basefieldpos");
	    	var isHundredPercentChart = showValAs == "9" && baseFieldPos == "COLORAXIS" ? true : false;
	    	if(isHundredPercentChart)
	    	{
		    	var percentCheck = $("ZRPercentCheck");
		    	percentCheck.style.display = "none";
		    	var idx = enabledOpts.indexOf("ShowPercent");
		    	enabledOpts.splice(idx, 1);
	    	}
    	}
    }
    
    this.updateZACFInst = function(view) {
        var formNodes = {}, zacf = view.zacf.get(), zaf = view.type == "WIDGET" ? view.cinfo.ZAF : view.zaf;
        var instKey = view.zacf.getCurrKey();
        var tempFmt = view.zacf.tempFmt;
        var isApplyToAll = tempFmt["APPLYTOALL"];
        var positions = Object.keys(tempFmt);
        var prevFormat;
        for(var idx = 0; idx < positions.length; idx++)
        {
        	if(ZACFConstants.ALL_POSITIONS.indexOf(positions[idx]) != -1)
        	{
        		var toCompare;
        		if(positions[idx] == "DEFAULT" || ZACF.isPie(view))
        		{
    				toCompare = ZACF.getFormatInfo(view, "FORMAT_IN_TABLE");//zacf[positions[idx]]
    				prevFormat = zacf["DEFAULT"];
        		}
        		else
        		{
        			toCompare = tempFmt["DEFAULT"] || ZACF.getFormatInfo(view, "DEFAULT");//No I18n
        			prevFormat = zacf[positions[idx]];
        		}
        		var isUpdated = view.zacf.update(tempFmt[positions[idx]], toCompare, positions[idx], isApplyToAll);
        		if(!isUpdated && prevFormat != null)
        		{
        			var isUpdated = view.zacf.update(tempFmt[positions[idx]], prevFormat, positions[idx], isApplyToAll);
        		}
        		view.zacf.setValInZacf(instKey, "AXISTYPE", tempFmt.AXISTYPE); //No I18n
        		if(isApplyToAll )//&& (view.type == "WIDGET" || (view.type == "AnalysisView" && view.chartObj.getChartType() != ZCHARTCONST.get("PIE")))) //NO I18N
        		{
        			break;
        		}
        	}        	
        }
        
//        ZDBUtil.setNamedChildEls($('ZDBAddFormatTable'),formNodes,'name');
//        delete formNodes.nameSet;
//        var type = (zaf.type === "REFCOL") ? zaf.refColType:(zaf.type === "RELCOL")?zaf.relColType : zaf.type; //No I18N
//        var formatType = ZDBUtil.datatypeVsFormatType[type].toUpperCase();
//        for(var nodeKey in formNodes) {
//            var node = formNodes[nodeKey];
//            var zacfKey =  ZACFConstants[nodeKey.toUpperCase().replace(formatType,'')] || ZACFConstants[nodeKey.toUpperCase()];
//            zacf[zacfKey] = DOMUtils.getValueFromEl(node);
//        }
//        view.zacf.update(zacf);
        ZDBDialogUtil.closeDialog();
    };
    
    this.updateTempFmt = function(view, prevTab, updateDefault) // needs code clean up. Need to make common function based on this and updateZACFInst	
    {
    	var formNodes = {};
    	ZDBUtil.setNamedChildEls($('ZDBAddFormatTable'),formNodes,'name');
    	delete formNodes.nameSet;
    	var viewType = view.type;
    	var tempFmt = view.zacf.tempFmt;
    	var instKey = view.zacf.getCurrKey();
//    	var positions = view.zacf.get()["positions"] ? view.zacf.get()["positions"] : viewType == "WIDGET" ? // NO I18N /* view.zacf.get() doesn't contain positions object when the format is modified */ 
//    			WidgetEditor.editor.cinfo.ZAF.zacf[instKey].positions : view.zaf.zacf[instKey].positions;
    	var positions = view.zacf.getAvlblPositions(); // || viewType == "WIDGET" ? WidgetEditor.editor.cinfo.ZAF.zacf[instKey].positions : view.zaf.zacf[instKey].positions;
//    	positions = view.type == "AnalysisView" && view.chartObj.getChartType() == ZCHARTCONST.get("PIE") && view.chartSelectedEl.isMultiY ? positions : ZACF.getValidPositions(view, instKey, positions);
    	if(positions.length == 1)
    	{
    		if(ZACF.isPie(view) && view.chartSelectedEl.isMultiY)
    		{
    			if(instKey.split(",").length == 1)
    			{
    				var zacf = tempFmt["Datalabel"];
    			}
    			else
    			{
    				var zacf = tempFmt["Pie_Perc"];
    			}
    		}
    		else if(ZACF.isPie(view))
    		{
    			var zacf = tempFmt[positions[0]];
    		}
    		else
    		{
    			var zacf = tempFmt["DEFAULT"];
    		}
    		
    	}
    	else if($(posTabSel).style.display != "none")
    	{
    		var posValue;
	    	if(prevTab == null)
	    	{
	    		var tabPar = $("tabPar");
	    		var applyToAll = $("applyToAll");
	    		var attrName, toCompare;
	    		if(applyToAll.checked == true || updateDefault)
	    		{
	    			posValue = "DEFAULT"; //No I18n
//	    			attrName = "value"; //NO I18N
//	    			toCompare = positions[0];
//	    			tempFmt["APPLYTOALL"] = true;
	    		}
	    		else
	    		{
	    			attrName = "isSelected"; //NO I18N
	    			toCompare = "true"; //NO I18N
	    			tempFmt["APPLYTOALL"] = false;
	    			for(var i = 0; i < tabPar.childNodes.length; i++)
		    		{
		    			var el = tabPar.childNodes[i];
						if(el.getAttribute(attrName) == toCompare)
						{
							prevTab = el;
							break;
						}
		    	  	}
	    		}
	    	}
	    	posValue = prevTab != null ? prevTab.getAttribute("value") : posValue;
			if(tempFmt[posValue] == null)
	    	{
	    		tempFmt[posValue] = ZDBUtil.cloneObject(tempFmt[positions[0]] || ZACF.getFormatInfo(view, "DEFAULT")); // Index is 0 since the default value will be at this index
	    		if(view.type == "AnalysisView" && view.chartObj.getChartType() == ZCHARTCONST.get("PIE"))
	    		{
	    			tempFmt[posValue] = view.zacf.getFrmZAF()[posValue];
	    		}
	    	}
	    	var zacf = tempFmt[posValue];
	    	var type = zacf.type;
    	}
    	else
    	{
    		var zacf = tempFmt[positions[0]] || tempFmt["DEFAULT"];
    	}
    	var opr = ZACF.getCorresOperation(instKey, view, "operation");
		var type = (zacf.type === "REFCOL") ? zacf.refColType:(zacf.type === "RELCOL")?zacf.relColType : zacf.type; //No I18N
    	var formatType = ZDBUtil.datatypeVsFormatType[type].toUpperCase();
    	var enabledOptions = view.zacf.getEnabledOpts();
    	for(var nodeKey in formNodes) 
    	{
    		if(enabledOptions.indexOf(nodeKey) == -1)
    		{
    			continue;
    		}
            var node = formNodes[nodeKey];
            var zacfKey =  ZACFConstants[nodeKey.toUpperCase().replace(formatType,'')] || ZACFConstants[nodeKey.toUpperCase()];
            var value = DOMUtils.getValueFromEl(node);
            if(value != null && zacfKey)
            {
        		zacf[zacfKey] = ZACF.getValueOfCorresType(value);
            }
        }
    	if(ZDBSheetFormatExtn.dataType == ZDBConst.CURRENCY)
    	{
	    	zacf[ZACFConstants.SHOWPERCENT] = zacf[ZACFConstants.COUNTRYNAMELIST] == "None" ? false : true;
	    	var format = ZACF.getFormatInfo(view, positions[0]);
	    	zacf[ZACFConstants.COUNTRYNAMELIST] = format[ZACFConstants.COUNTRYNAMELIST]; // Since currency format is same as that in Table and it cannot be modified in the report
    	}
    	if(ZACF.isPie(view) && posValue == "Pie_Perc" && opr != "YEAR" && opr != "DAY")
    	{
    		zacf.type = "PERCENT"; // Percent Type for Pie chart datalabel
    	}
    }
    
    this.getValueOfCorresType = function(value)
    {
    	var type = typeof value;
    	switch(type)
    	{
    	case "boolean": //NO I18N
    	case "number": //NO I18N
    		return value;
    	case "string": //NO I18N
    		{
    			value = value == "true" ? true : value == "false" ? false : value;
    			if(typeof value == "boolean")
    			{
    				return value;
    			}
    			value = isNaN(Number(value)) ? value : Number(value);
    			return value;
    		}
    		default:
    			return value;
    	}
    }
    
    this.setAnalysisFormatType = function(view, node) {
        var formatObj = view.zacf.get() || view.zacf.get(node.getAttribute('instKey'));
        var operation = node != null ? node.getAttribute('operation') : this.getAxisDetails(view, "OPERATION", view.zacf.getCurrKey()); //NO I18N /*node will be null for single axis pie chart and by default we give*/
        var addOnType = node != null ? node.getAttribute('addontype') : this.getAxisDetails(view, "ADDONTYPE", view.zacf.getCurrKey()); //NO I18N /*Count operation for the column involved*/
        var showValueAs = node != null ? parseInt(node.getAttribute('showvalueas')) : "0";
        if(addOnType === 'ABSDATECATEGORICAL' && operation !== 'TIMESTAMP' && operation !== 'MX_DATE' && operation !== 'MI_DATE' && operation != "DATE") {
            formatObj.type = 'PLAIN';
            return;
        }
        if(operation === 'COUNT' || operation === 'DC') {
            formatObj.type = 'POSITIVE_NUMBER';
        } else if((operation === 'AVG' || operation === 'SD' || operation === 'VAR') && (formatObj.type !== 'CURRENCY')) { //NO I18N
            formatObj.type = 'DECIMAL_NUMBER';
        }
        if(showValueAs > 0 && showValueAs !== 4 &&  showValueAs !== 5 && formatObj.type !== 'CURRENCY') {
            formatObj.type = 'PERCENT';
        }
    };
    
    this.setPieInstKey = function(view) 
    {
    	var propSetForm = view.propSetUtil.propSetForm;
    	var zacfLink = propSetForm.formatpie;
    	var currentList = view.currentList;
    	var instKey, isY, isX, xIdx, yIdx, idx;
    	var legType = view.legendType.legendType;
        for(var i = 0; i < currentList.length; i++) 
        {
            var node = currentList[i];
            if(node.getAttribute('viewtype') === 'YAXIS')
            {
            	isY = true;
            	yIdx = i;
            }
            else if(node.getAttribute('viewtype') === 'XAXIS')
            {
            	isX = true;
            	xIdx = i;
            }
        }
        if(view.chartSelectedEl.isMultiY)
        {
        	var zacf = view.zaf.zacf;
        	var keys = Object.keys(zacf);
        	for(var i= 0; i<keys.length; i++)
        	{
        		if(keys[i].split(",").length > 1)
        		{
        			instKey = keys[i];
        		}
        	}
        }
        else if(isX && isY)
        {
        	idx = legType == "YAXIS" ? xIdx : yIdx; //NO I18N
        }
        else if(isX || isY)
        {
        	zacfLink.style.display = "none";
        	idx = legType == "YAXIS" ? yIdx : xIdx; //NO I18N
        }
        instKey = instKey != null ? instKey : view.currentList[idx].getAttribute("instkey");
        instKey = view.instMap && view.instMap[instKey] && view.isViewRefreshed == 1 ? view.instMap[instKey] : instKey;
        zacfLink.setAttribute('instKey',instKey);
        zacfLink.addEventListener('click', function() {
        			zacfLink.className = "inlineLinkStyle";        			
        			view.zacf.setKey(this.getAttribute('instKey'));
        			ZDBPopUpMenu.gridOper(this);
            });
            return;
    }
    
    this.showOrHideTabsForPie = function(view, srcEl, tabParent, tab, positions)
    {
    	if(ZACF.isPie(view))
    	{
    		if(!ZDBGlobal.enablePosFormatting)
    		{
    			var tempFmt = view.zacf.tempFmt;
    			var pos = view.zacf.getAvlblPositions();
    			var instKey = srcEl.getAttribute("instKey");
        		var colFormat = tempFmt[pos[0]] || view.zaf.zacf[instKey][pos[0]];
        		ZDBSheetFormatExtn.dataType = ZACF.getDataTypeForPie(pos[0], view, tempFmt);
				var operation = ZACF.getCorresOperation(instKey, view, "operation"); //No I18n
				var enabledOpts = ZDBSheetFormatExtn.enableDisableColumnFormatOpts(ZDBSheetFormatExtn.dataType, view.type, operation);
				view.zacf.setEnabledOpts(enabledOpts);
    			ZDBSheetFormatExtn.setValuesInFormatDlg(null,colFormat,null,ZDBSheetFormatExtn.editFrmtColOpts,null);
    			return false;
    		}
	    	var propSetForm = view.propSetUtil.propSetForm;
	    	var instKey = srcEl.getAttribute("instKey");
	    	var viewType = this.getCorresOperation(instKey, view, "VIEWTYPE"); //NO I18n
	    	if(!(viewType == "XAXIS" || viewType == "YAXIS") && !view.chartSelectedEl.isMultiY)
	    	{
	    		return true;
	    	}
	    	var tempFmt = view.zacf.tempFmt;
	    	var selectedTab = null, selectedTabVal = null;
    		if(view.chartSelectedEl.isMultiY)
    		{
    			if(instKey.split(",").length > 1)
    			{
    				selectedTabVal = "Pie_Perc"; //No I18n
    			}
    			else
    			{
    				selectedTabVal = "Datalabel"; //No I18n
    			}
    		}
    		else
    		{
    			var aot = this.getCorresOperation(instKey, view, "ADDONTYPE"); //No I18n
				if(positions.length == 1 && positions[0] == "Legend")// && ZACF.hasBothXAndYAxis(view))// For charts with both x and y axes with Number or Date Column in X Axis
				{// uncomment the last condition after single col chart fix -- nandha
					selectedTabVal = positions[0];
					var tabSelector = $("posTabSel");
					tabSelector.style.display = "none";
				}
				else
    			{
	    			var borderDiv = document.createElement("div");
	    	  		borderDiv.className = "borderTab";
	    	  		tabParent.appendChild(borderDiv.cloneNode());
		    		for(var i =0; i<positions.length; i++)
		    		{
		    			var newTab = tab.cloneNode();
		    			newTab.setAttribute("type","positionTab");
		    			newTab.className = "posTab";
						newTab.addEventListener("click", function(){ZACF.changePosTabForPie(this, srcEl, view);});
						ZACF.addListeners(newTab);
				  		newTab.innerText = ZACF.getDisplayValue(view, positions[i], instKey);
				  		newTab.setAttribute("value", positions[i]);
				  		tabParent.appendChild(newTab);
						if(positions[i] == "Pie_Perc")
						{
							newTab.className += " posTabSelected"; //NO I18N
							newTab.setAttribute("isSelected", true); //NO I18N
							selectedTab = newTab;
							selectedTabVal = positions[i];
						}
						else
						{
							newTab.setAttribute("isSelected", false); // NO I18N
						}
		    		}
    			}
    		}
    		var applyToAllDiv = $("isApplyToAll");
    		applyToAllDiv.style.display = "none";
    		var applyToAll = $("applyToAll");
    		applyToAll.checked = false;
       		ZDBSheetFormatExtn.dataType = ZACF.getDataTypeForPie(selectedTabVal, view, tempFmt);
    		var operation = ZACF.getCorresOperation(instKey, view, "operation"); //No I18n
    		var enabledOpts = ZDBSheetFormatExtn.enableDisableColumnFormatOpts(ZDBSheetFormatExtn.dataType, view.type, operation);
    		view.zacf.setEnabledOpts(enabledOpts);
    		var pos = view.zacf.getAvlblPositions();
    		var colFormat = tempFmt[selectedTabVal] || view.zaf.zacf[instKey][pos[0]];
    		if(view.chartSelectedEl.isMultiY)
    		{
    			if(selectedTabVal == "Pie_Perc")
    			{
	    			colFormat.type = "PERCENT";
	    			colFormat.displayName = "Percentage";//No I18n
    			}
    		}
    		ZDBSheetFormatExtn.setValuesInFormatDlg(null,colFormat,null,ZDBSheetFormatExtn.editFrmtColOpts,null);
    		return false;
    	}
    	return true;
    }
    
    this.addListeners = function(el)
    {
    	el.addEventListener("mouseover", function(event)
  				{
  					var el = event.target;
  					if(el.getAttribute("isSelected") == "false")
  					{
  						el.style.backgroundColor = "#efefef";
  					}
  				});
    	el.addEventListener("mouseout", function(event)
  				{
  					var el = event.target;
  					if(el.getAttribute("isSelected") == "false")
  					{
  						el.style.backgroundColor = "white";
  					}
  					if(el.getAttribute("isSelected") == "true")
  					{
  						el.style.backgroundColor = "";
  					}
  				});
    }
    
    this.hasBothXAndYAxis = function(view)
    {
    	var curList = view.currentList,isX = false,isY = false;
    	for(var i = 0; i<curList.length; i++)
    	{
    		var curNode = curList[i];
    		if(curNode.getAttribute("viewType") == "XAXIS")
    		{
    			isX = true;
    		}
    		else if(curNode.getAttribute("viewType") == "YAXIS")
    		{
    			isY = true;
    		}
    	}
    	return isX && isY;
    }
    
    this.changePosTabForPie = function(el, srcEl, view)
    {
    	if(el.getAttribute("isSelected") == "true" || $("applyToAll").checked == true)
	  	{
	  		return;
	  	}
    	var propSetForm = view.propSetUtil.propSetForm;
    	var value = el.getAttribute("value");
//    	ZACF.updateTempFmt(view, null);
//    	var tempFmt = ZDBUtil.cloneObject(view.zacf.tempFmt);
    	var tempFmt = view.zacf.tempFmt;
		var dataType = ZACF.getDataTypeForPie(value, view, tempFmt);
		if(dataType != null)
		{
			ZDBSheetFormatExtn.changePosTab(el, srcEl);
			ZDBSheetFormatExtn.dataType = dataType;
		}
		else
		{
			return;
		}
		
		var instKey = srcEl.getAttribute("instKey");
		var operation = ZACF.getCorresOperation(srcEl.getAttribute("instKey"), view, "operation"); //No I18n
		var enabledOpts = ZDBSheetFormatExtn.enableDisableColumnFormatOpts(ZDBSheetFormatExtn.dataType, view.type, operation);
		view.zacf.setEnabledOpts(enabledOpts);
		var positions = view.zacf.getAvlblPositions();
		var colFormat = tempFmt[value] || view.zaf.zacf[instKey][positions[0]];
		ZDBSheetFormatExtn.setValuesInFormatDlg(null,colFormat,null,ZDBSheetFormatExtn.editFrmtColOpts,null);
    }
    
    this.getDataTypeForPie = function(value, view, tempFmt)
    {
    	var propSetForm = view.propSetUtil.propSetForm;
    	var defFormat = view.zacf.getFrmZAF();
    	var colFormat;
    	if(value == "Datalabel")// && (propSetForm.dataLblVal.checked || view.chartSelectedEl.isMultiY))
		{
    		colFormat = tempFmt["Datalabel"] || defFormat["Datalabel"];
			return ZDBUtil.dataTypeVsdataTypeNum[colFormat.type];
		}
		else if(value == "Pie_Perc")// && (propSetForm.dataLblPercent.checked || view.chartSelectedEl.isMultiY))
		{
			return ZDBConst.PERCENT;
		}
		else if(value == "Legend")
		{
			colFormat = tempFmt["Legend"] || defFormat["Legend"];
			return ZDBUtil.dataTypeVsdataTypeNum[colFormat.type];
		}
		else
		{
			return null;
		}
    }
    
    this.getValidPositions = function(view, instKey, positions)
    {
    	if(view.type == "AnalysisView")
    	{
	    	var chartType = view.chartObj.getChartType();
	    	var curEl, axisType, opr, oldInstId, hasX = false, hasY = false;
	    	for(var i = 0; i<view.currentList.length; i++)
    		{
    			var currEl = view.currentList[i];
    			var viewType = currEl.getAttribute("viewtype");
    			var fieldInstKey = currEl.getAttribute("instKey");
    			var oldInstKey = ZDBAnalysisView.replaceInstKey(view, instKey);
    			if(oldInstKey == fieldInstKey)
    			{
    				curEl = currEl;
    				axisType = viewType;
    				var addOnType = currEl.getAttribute("addOnType");
    				opr = currEl.getAttribute("operation");
    				oldInstId = oldInstKey;
    			}
    			if(viewType == "XAXIS")
    			{
    				hasX = true;
    			}
    			if(viewType == "YAXIS")
    			{
    				hasY = true;
    			}
    		}
	    	if(chartType == ZCHARTCONST.get("PIE"))
			{
	    		if(axisType == "XAXIS" || axisType == "YAXIS")
	    		{
		    		if(view.chartSelectedEl.isMultiY || !ZDBGlobal.enablePosFormatting)
		    		{
		    			return positions;
		    		}
		    		if((hasX && !hasY) || (hasY && !hasX))
		    		{
		    			if(addOnType == "NUMBER" || (addOnType == "ABSDATECATEGORICAL" && opr != "YEAR" && opr != "DAY"))
		    			{// For Single column [Numeric] in Y axis or X Axis
	//	    				return ["Pie_Perc","Legend"]; //NO I18N //uncomment this after single col chart fix --nandha
		    				return ["Legend"]; //NO I18N 
		    			}
		    			else
		    			{// For Single Column [Dimensional] in Y axis or X Axis
	//	    				return ["Pie_Perc"]; //NO I18N //uncomment this after single col chart fix --nandha
		    				return ["Datalabel"]; //No I18N
		    			}
		    		}
	
					if(axisType == view.legendType.legendType)
					{//For group by column in xy axes pie chart 
						if(addOnType == "NUMBER" || (addOnType == "ABSDATECATEGORICAL" && opr != "YEAR" && opr != "DAY"))
						{
							return ["Legend"];
						}
						return ["Datalabel"]; // No I18n
					}
		    		//For xy axes pie chart and multiY Pie
		    		return ["Pie_Perc","Datalabel"]; //NO I18N
	    		}
	    		else if(axisType == "TEXTAXIS")
	    		{
	    			return ["Datalabel", "Tooltip"]; //NO I18N
	    		}
	    		else
	    		{
	    			return ["Datalabel"]; //No I18N
	    		}
			}
	    	
	    	if(!ZACF.isPie(view) && (axisType == "XAXIS" || axisType == "YAXIS"))
	    	{
//	    		if(view.chartSelectedEl.isMultiY && view.metaInfo.MERGE) //nandha
//	    		{
//	    			positions = ["Tooltip","Datalabel","Threshold"]; //NO I18N
//	    		}
		    	var isTholdEnabled = ZDBThresholdProp.isThresholdAvlbl(view, oldInstId);
		    	var isDataLabel = view.propSetUtil.axisObj ? (view.propSetUtil.axisObj.isAxisDataLabelEnabled(instKey, view) && axisType == "YAXIS" && ZACF.checkForTextAxis(view)) : ZACF.checkDataLabelForPckdBbl(view) ? true : false;//No I18n
		    	var isAxisAvailable = ZACF.checkForAxis(view);
		    	
		    	ZACF.removePosition(positions, "Axis", !isAxisAvailable);
		    	ZACF.removePosition(positions, "Threshold", !isTholdEnabled);
		    	ZACF.removePosition(positions, "Datalabel", !isDataLabel);
		    }
	    	ZACF.removePosition(positions, "DEFAULT", positions.length != 1);
    	}
		ZACF.removePosition(positions, "DEFAULT", (view.type == "WIDGET" && positions.length > 1));
    	return positions;
    }
    
    this.removePosition = function(positions, position, removePosition)
    {
    	if(removePosition)
    	{
	    	var idx = positions.indexOf(position);
			if(idx != -1)
			{
				positions.splice(idx,1);
			}
    	}
    }
    
    this.checkForAxis = function(view)
    {
    	var chartSelected = view.chartSelectedEl.selectedGraph;
    	var subGraphType = view.chartSelectedEl.subGraphType;
    	if((chartSelected == "BUBBLE" && subGraphType == "PACKEDBUBBLE") || (chartSelected == "WEB") 
    			|| (chartSelected == "MAPSCATTER" || chartSelected == "MAPBUBBLE" || chartSelected == "MAPAREA" || chartSelected == "MAPPIE" || chartSelected == "MAPPIEBUBBLE")) //NO I18n
    	{
    		return false;
    	}
    	return true;
    }
    
    this.checkForTextAxis = function(view)
    {
    	var textDivAvlbl = false;
		var curList = view.currentList;
		for(var i = 0; i < curList.length; i++)
		{
			if(curList[i].getAttribute("viewType") == "TEXTAXIS")
			{
				textDivAvlbl = true;
			}
		}
		return !textDivAvlbl;
    }
    
    this.checkDataLabelForPckdBbl = function(view)
    {
		var textAxisCheck = ZACF.checkForTextAxis(view);
		if(view.graphSelected == "BUBBLE" && view.chartSelectedEl.subGraphType == "PACKEDBUBBLE")
    	{
			return view.propSetUtil.propSetForm.packLblVal.checked && textAxisCheck;
    	}
		return textAxisCheck;
    }
    
    this.getDisplayValue = function(view, position, instKey)
    {
    	if(view.type == "AnalysisView")
    	{
	    	if(ZACF.isPie(view))
			{
	    		var viewType = ZACF.getCorresOperation(instKey, view, "VIEWTYPE"); //NO I18N
	    		switch(position)
	    		{
	    		case "Legend": //No I18n
	    			return ZDBI18NMap.g("zrpt.chartview.setting.js.legend"); //No I18n
	    		case "Datalabel": //NO I18N
	    			if(viewType == "XAXIS" || viewType == "YAXIS")
	    			{
	    				return ZDBI18NMap.g("zrpt.dbsettings.variables.js.value"); //NO I18N
	    			}
	    			else
	    			{
	    				return ZDBI18NMap.g("zrpt.chartview.setting.js.datalabel"); //NO I18N
	    			}
	    		case "Pie_Perc": //NO I18N
	    			return ZDBI18NMap.g("zrpt.home.import.step2.js.percent"); //NO I18N
	    		}
			}
    	}
    	switch(position)
    	{
    	case "Axis":  //NO I18N
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.axis"); //NO I18N
    	case "Tooltip": //NO I18N
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.toolTip"); //NO I18N
    	case "Datalabel": //NO I18N
    	case "TargetLabel": //NO I18N
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.datalabel"); //NO I18N
    	case "Legend": //NO I18N
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.legend"); //NO I18N
    	case "Threshold": //NO I18N
    		return ZDBI18NMap.g("zrpt.chartview.setting.js.threshold"); //NO I18N
    	}
    }
    
    this.validateMonthNQtrFmt = function(instKey, view)
	{
		var opr = this.getCorresOperation(instKey, view, "operation");
		if(opr == "ABSQUARTER" || opr == "ABSMONTH")
		{
			var dlgEl = ZDBDialogUtil.focusDialog.bodyContent;
	        var dateFormatEl = jQuery(dlgEl).find("#cusDateFormat")[0];
	        var dateFormat = dateFormatEl.value;
	        dateFormat = dateFormat.trim();
	        var len = dateFormat.length;
	        if(len > 10 || len == 0)
	        {
	        	showCustomMessage(ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.invalidFmtLength"), dateFormatEl); //No I18n
	        	return false;
	        }
	        var regExQtr = new RegExp("^(qqqq|qq)[', -]{1,3}(yyyy|yy)$");
	        var regExMon = new RegExp("^(MMMM|MMM)[', -]{1,3}(yyyy|yy)$"); // No I18n
	        if(!(regExQtr.test(dateFormat) || regExMon.test(dateFormat) ))
	        {
	        	showCustomMessage(ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.invalidFmt"), dateFormatEl); //No I18n
	        	return false;
	        }
		}
		return true;
	}
    
    this.getAxisDetails = function(view, attribute, order)
    {
    	var axisDetails = view.axisDetails ? view.axisDetails : [];
    	for(var i = 0; i< axisDetails.length; i++)
    	{
    		var axis = axisDetails[i];
    		if(axis["ORDER"] == order)
    		{
    			return axis[attribute];
    		}
    	}
    }
};
    
        
var ZACFConstants = new function () {
    
    this.LOCALE = "userLocale";//NO I18N
    this.ALIGNLIST = "alignment";//NO I18N
    this.THOUSEPARATOR = "thousandSeparator";//NO I18N
    this.DECISEPARATOR = "decimalSeparator";//NO I18N
    this.COUNTRYNAMELIST = "currencyFormat";//NO I18N
    this.NEGATIVE = "showNegativeSign";//NO I18N
    this.DECIPLACES = "decimalPlaces";//NO I18N
    this.SHOWPERCENT = "showSymbol";//NO I18N
    this.UNITSLIST = "unitsList";//NO I18N
    this.NUMDECIPLACES = "decimalPlaces";//NO I18N
    this.CUSDATEFORMAT = "dateFormat";//NO I18N
    this.MONTHFMT = "dateFormat"; // NO I18N
    this.QUARTERFMT = "dateFormat";// NO I18N
    this.WEEKDAYFMT = "dateFormat"; // No I18n
    this.WEEKFMT= "dateFormat"; // No I18n
    this.HOURFMT = "dateFormat"; // No I18n
    this.WEEKNYEARFMT = "dateFormat"; //No I18n
    
    this.XMLPARAMS = {
        "userLocale": "ul", //NO I18N
        "alignment": "al", //NO I18N
        "thousandSeparator": "ts", //NO I18N
        "decimalSeparator": "ds", //NO I18N
        "currencyFormat": "cs", //NO I18N
        "showNegativeSign": "ns", //NO I18N
        "decimalPlaces": "dp",//NO I18N
        "showSymbol":"ss",//NO I18N
        "unitsList":"us",//NO I18N
        "dateFormat":"dt"//NO I18N
    }
    
    this.TYPE = {"PLAIN": "0", //No I18N
        "MULTI_LINE": "0", //No I18N
        "EMAIL": "0", //No I18N
        "URL": "0", //No I18N
        "BOOLEAN": "0", //No I18N
        "GEO": "0", //No I18N
        "NUMBER": "1", //No I18N
        "POSITIVE_NUMBER": "1", //No I18N
        "AUTO_NUMBER": "1", //No I18N
        "DECIMAL_NUMBER": "2", //No I18N
        "GEO_NUM": "2", //No I18N
        "PERCENT": "3", //No I18N
        "CURRENCY": "4", //No I18N
        "DATE": "5", //No I18N
        "DATE_AS_DATE": "5"} //No I18N
    
    this.ALL_POSITIONS = ["Axis", "Tooltip", "Datalabel", "Threshold", "Legend", "Pie_Perc", "DEFAULT", "TargetLabel", "Pivot", "SummaryView", "Widget"]; //No I18n
};

var ZACFInst = function(initial, modifiedKeys) {
    
    var zaf; //Table Formats Map
    var zacf;//Custom Formats Map
    var curKey;//Current Key to be updated
    var modified;
    var zacfKeys;
    var mergeAxisKey;
    var enabledOpts
    this.tempFmt = {};
    
    var setData = function(data) {
        initiate(data.zacf, data.zacfKeys);
    };
    
    var update = function(format, toCompare, position, isApplyToAll) {
        if(toCompare == null || !equals(format, toCompare)) {
            var toUpdate = copy(toCompare,{});
            copy(format, toUpdate);
            set(toUpdate, position, isApplyToAll);
            modified = true;
            return true;
        }
        return false;
    };
    
    var revert = function(key) {
        key = key || curKey;
        delete zacfKeys[key];
    };
    
    var copy = function(src, dest) {
        for(var attr in src) {
            dest[attr] = src[attr];
        }
        return dest;
    };
    
    var get = function(key) {
         key = key || curKey;
         return zacf[key] || zaf[key];
    };
    
    var getFrmZAF = function(key) {
    	key = key || curKey;
    	return zaf[key];
    }
    
    var getCurrKey = function(){
    	return curKey;
    }
    
    var set = function(format, position, isApplyToAll) {
    	if(zacf[curKey] == null)
    	{
    		zacf[curKey] = {};
    	}
        zacf[curKey][position] = format;
        zacf[curKey]["APPLYTOALL"] = isApplyToAll;
    };
    
    var setValInZacf = function(key, attr, value)
    {
    	key = key || curKey;
    	if(zacf[key])
    	{
    		zacf[key][attr] = value;
    	}
    }
    
    var setKey = function(key) {
        curKey = key;
        if(key.split(',').length > 1) {
            mergeAxisKey = key;
        }
    };
    
    var initiate = function (initial, modifiedKeys) {
        zaf = initial || {};
        zacfKeys = modifiedKeys || {};
        for (var key in modifiedKeys) {
            if (key.split(',').length > 1) {
                mergeAxisKey = key;
                break;
            }
        }
        reset();
    };
    
    var persist = function() {
        for(var key in zacf) {
            zaf[key] = zacf[key];
            zacfKeys[key] = true;
        }
        reset();
    };
    
    var reset = function() {
        zacf = {};
        tempFmt = {};
        modified = false;
    };
    
    var equals = function(zacf, zaf) {
        for(var key in zacf) {
            if(zacf[key] != zaf[key]) {
                return false;
            }
        }
        return true;
    };
    
    var isModified = function() {
        return modified;
    };
    
    var isZACF = function(key) {
        return zacfKeys[key];
    };
        
    var isZACFPreview = function(key) {
        return zacfKeys[key] || zacf[key];
    };
        
    var getMergeAxisKey = function() {
        return mergeAxisKey;
    };
        
    var setPreview = function() {
        this.persist = dummyFunction;
        this.isZACF = isZACFPreview;
    };
    
    var unSetPreview = function() {
        this.persist = persist;
        this.isZACF = isZACF;
    };
        
    var dummyFunction = function() {
        
    };
    
    var getCurKey = function(format)
    {
    	if(curKey != null)
    	{
    		return curKey;
    	}
    }
    
    var setTempFmt = function()
    {
    	this.tempFmt = ZDBUtil.cloneObject(get());
    }
    
    var getAvlblPositions = function(key)
    {
    	key = key || curKey;
        return zaf[key]["positions"].slice(0);
    }
    
    var setEnabledOpts = function(opts)
    {
    	enabledOpts = opts;
    }
    
    var getEnabledOpts = function(opts)
    {
    	return enabledOpts;
    }
    
    initiate(initial, modifiedKeys);
    
    return {
        setKey : setKey,
        update : update,
        get    : get,
        getFrmZAF:getFrmZAF,
        getCurrKey: getCurrKey,
        persist:persist,
        isModified:isModified,
        isZACF:isZACF,
        getMergeAxisKey:getMergeAxisKey,
        reset : reset,
        equals:equals,
        setPreview:setPreview,
        unSetPreview:unSetPreview,
        revert:revert,
        setData:setData,
        setValInZacf:setValInZacf,
        setTempFmt: setTempFmt,
        getAvlblPositions: getAvlblPositions,
        setEnabledOpts: setEnabledOpts,
        getEnabledOpts: getEnabledOpts
    };
    
};

ZDBLazyLoadFuncMap.lazyLoadFuncMap['ZACF.showCustomFormatDlg']=ZACF.showCustomFormatDlg;
