//$Id $
function ZCColorLegendModel(chartObj)
{
	var legendModel = new ZCLegendModel();
	var propName, propType, instId, propSetUtil, lineSplineVal;
	var isComboSplineSelected = false;
	var setDefCombo = false;
	
	this.getLegendEls = legendModel.getLegendEls;
	this.showLegendNames = legendModel.showLegendNames;
	this.displayLegendValues = legendModel.displayLegendValues;
	this.setComboChartOpt = legendModel.setComboChartOpt;
	this.getLegElPosWithAttrNValue = legendModel.getLegElPosWithAttrNValue;
	this.alterComboChartType = legendModel.alterComboChartType;
	
	this.init = function()
	{
		var view = chartObj.getViewObj();
		var graphSelected = view.chartSelectedEl.selectedGraph;
		var chartData = chartObj.getChartData();
		var data = chartObj.getData();
		var curData = data.metadata.columns[data.metadata.axes.clr[0]];
		var datatype = curData["datatype"];
		var formatConf = curData[datatype];
		var clrVCIInst = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType", "COLORAXIS")[0];//No I18N
		var actDataType = clrVCIInst.getAttribute("operation");
		instId = clrVCIInst.getAttribute("instkey");
		var viewType = clrVCIInst.getAttribute("viewType");
		var subFuncType = ZDBVUDataAPI.getSubFuncType(curData, graphSelected, actDataType);
		
		if(chartData && chartData.length > 0)
		{
                    var len = chartData.length;
                    var clrArray = data.legend.colors;
                    var userClrArr = data.legend.userColors;
                    var legEls = new Array();
                    var legendCritInfo = view.legendCritInfo;
                    for(var i=0; i<len; i++)
                    {
                        if(chartData[i].tholdLabel) {
                            continue;
                        }
                        var legObj = new Object();
                        legObj["value"] = $ZC.getFormattedValue(formatConf,chartData[i].seriesname,datatype);
                        legObj["color"] = clrArray[i];
                        legObj["clrMod"] = userClrArr[i] != null;
                        legObj["instId"] = instId;
                        legObj["origValue"] = chartData[i].seriesname != null ? ZDBVUDataAPI.getCriteriaVal(subFuncType, chartData[i].seriesname, curData[datatype], curData) : null;
                        legObj["filterValue"] = chartData[i].filterValue;
                        legObj["comboType"] = chartData[i].type == 11;
                        legObj["index"] = i;
                        legObj["viewType"] = viewType;
                        var chcklegObj = {"legId": legObj["instId"], "value": legObj["filterValue"]} //NO I18N
                        if(legendCritInfo)
                        {
                            for(var j=0;j< legendCritInfo.length;j++ )
                            {
                                var legCritObj = legendCritInfo[j];
                                if(legCritObj["legId"] === chcklegObj["legId"] &&  legCritObj["value"] === chcklegObj["value"] )
                                {
                                   legObj["filtered"] = true;
                                   break;
                                }
                            }
                        }
                        legEls.push(legObj);
                    }
                    legendModel.setLegendEls(legEls);
                    this.updateComboInfoToLeg();
                    this.updatePropNameNType();
                    legendModel.setLegendTitle(chartObj.getViewObj(), data.legend.title.text);
		}
	};
	
	this.setLegendComboProps = function()
	{
		propSetUtil = chartObj.getViewObj().propSetUtil;
		if(!legendModel.setLegendAttributes(propSetUtil))
		{
			return false;
		}
		legendModel.setLegendColors(propSetUtil);
		if(propSetUtil.isComboProp)
		{
			this.setComboProps();
		}
		return true;
	};
	
    this.setDefComboOpt = function()
    {
        var propValue = [];
        var origValue = legendModel.getLegendEls()[0]["origValue"];
        var seriesName =  origValue == null ? legendModel.getLegendEls()[0]["value"] : origValue;
        propValue[propValue.length] = seriesName;
        propSetUtil.setMultiValProp(propName, instId, propValue, propType);
        propSetUtil.createPropSetDiv(chartObj.getViewObj());
        setDefComboVal(false);
    };
    
    this.modifyComboPropVal = function()
    {
    	this.setLineSpline();
    	var actComboSpline = this.isComboSpline() != null;
    	if(actComboSpline !== isComboSplineSelected)
		{
    		var prevPropName = (isComboSplineSelected) ? PropSettings.CHART_COMBO_LINE : PropSettings.CHART_COMBO_SPLINE; //before changing status
        	propName = (isComboSplineSelected) ? PropSettings.CHART_COMBO_SPLINE :PropSettings.CHART_COMBO_LINE;
        	//modifying the comboType in curListProp
        	var propValue = propSetUtil.getPropValue(prevPropName, instId, propType);// get it from CurrentList
        	if(propValue != null && propValue.length > 0)
    		{
        		delete propSetUtil.deleteFromPropMap(prevPropName);
        		propSetUtil.setMultiValProp(propName, instId, propValue, propType);
    		}
        	if(propSetUtil.modified)
    		{
        		propSetUtil.createPropSetDiv(chartObj.getViewObj());
    		}
		}
    };
	
    this.makeChangesForComboChart = function()
    {
        propSetUtil = chartObj.getViewObj().propSetUtil;
        this.updatePropNameNType();
        if(setDefCombo)
        {
            this.setDefComboOpt();
        }
        else
        {
            this.modifyComboPropVal();
        }
        this.updateComboInfoToLeg();
        var chartData = chartObj.getChartData();
        var propValue = propSetUtil.getPropValue(propName, instId, propType);// get it from CurrentList
        if(propValue != null)
        {
            for(var series = 0; series < chartData.length; series++)
            {
                if(chartData[series].tholdLabel) {
                    continue;
                }
                var origValue = getLegendNameforCombo(series);
                var isComboLine = propValue.indexOf(origValue) !== -1;
                chartData[series].type = this.alterComboChartType(isComboLine, chartObj.getViewObj().subGraphType);
            }
            legendModel.updateSplineSelectionInfo(chartObj.getData(), lineSplineVal);
            chartObj.setModified(true);		
        }
    };
	
    this.getComboSplineVal = function(el)
	{
		if(el.getAttribute("value") != PropSettings.BAR_COMBOTYPE)
        {
            return isComboSplineSelected ? PropSettings.SPLINE_COMBOTYPE : PropSettings.LINE_COMBOTYPE;
        }
        return PropSettings.BAR_COMBOTYPE;
	};
    
	this.updateComboInfoToLeg = function()
	{
		var view = chartObj.getViewObj();
		if(view.graphSelected == "COMBO")
		{
			this.updateIsComboSplineSelected();
			this.setLineSpline();
		}
		else
		{
			this.updateDefComboSelected();
		}
	};
	
	this.updatePropNameNType = function()
	{
		propName = (isComboSplineSelected) ? PropSettings.CHART_COMBO_SPLINE :PropSettings.CHART_COMBO_LINE;
		propType = PropSettings.MULTIVAL_PROPTYPE;
	}
	
	this.setLineSpline = function()
	{
		lineSplineVal = (isComboSplineSelected) ? PropSettings.SPLINE_COMBOTYPE : PropSettings.LINE_COMBOTYPE;
		legendModel.setLineSpline(lineSplineVal);
	};
	
	this.setComboProps = function()
	{
		var comboProp = propSetUtil.propSetForm.comboProp;
        var view = propSetUtil.view;
        var propEls = ZDBUtil.getElsWithTagNAttr(comboProp, "instId", "div");//No I18N
        var chartComboLineArray = new Array();
        chartComboLineArray = this.getComboLineValList();
        for(var i=0, j=propEls.length; i<j; i++)
        {
            var propEl = propEls[i];
            var propValue = propEl.getAttribute("propValue");
            var legVal = getLegendNameforCombo(i);
            chartComboLineArray = this.comboValUpdate(chartComboLineArray, propValue, legVal);
        }
        this.updateComboToView(chartComboLineArray);
	};
	
	this.updateComboToView = function(chartComboLineArray)
	{
		//convert that array into Map list
        setComboLineInPropMap(chartComboLineArray);
        if(!propSetUtil.propMap[PropSettings.CHART_COMBO_LINE] && !propSetUtil.propMap[PropSettings.CHART_COMBO_SPLINE])
        {
            legendModel.changeToBarGraphType(propSetUtil.view);
            setDefComboVal(true);
        }
	}
    
    this.updateIsComboSplineSelected = function()
    {
        if(legendModel.isLegendEls() && this.isComboSpline())
    	{
        	isComboSplineSelected = true;
    	}
        else
    	{
        	isComboSplineSelected = false;
    	}
    };
    
    this.updateComboSplineSelected = function(isComboSpline)
    {
    	isComboSplineSelected = isComboSpline;
    };
     
    this.updateDefComboSelected = function()
    {
    	if(legendModel.isLegendEls() && !(this.isComboSpline() || this.isComboLine())) //whether Spline/Line default set 
    	{
    		setDefComboVal(true);
    	}
    };
    
    var setDefComboVal = function(isDefCombo)
    {
    	setDefCombo = isDefCombo;
    }
    
    this.setDefComboValOnFieldChange = function(isDefCombo,view)
    {
    	setDefComboVal(isDefCombo);
		view.setDefCombo = true;
    }
    
    this.isComboSpline = function()
    {
    	var view = chartObj.getViewObj();
    	return view.propSet["SPLINE"] && view.propSet["SPLINE"][instId];
    };
    
    this.isComboLine = function()
    {
    	var view = chartObj.getViewObj();
    	return view.propSet["LINE"] && view.propSet["LINE"][instId];
    };
    
    this.getComboLineValList = function()
    {
        var view = chartObj.getViewObj();
        if(!propSetUtil)
    	{
        	propSetUtil = view.propSetUtil;
    	}
        var arr = new Array();
        var propMap = propSetUtil.propMap;
        if(propMap && propMap[propName])
        {
            for(var instKey in propMap[propName])
            {
                var propValue = propMap[propName][instKey][PropSettings.MULTIVAL_PROPTYPE];
                if(propValue != null && instKey != instId)
                {
                    propSetUtil.deleteFromPropMap(propName, instKey, PropSettings.MULTIVAL_PROPTYPE);
                    continue;
                }
                var linePropEls = propValue;
                for(var i = 0, j= linePropEls.length ; i<j ; i++)
                {
                    var alreadyExists = arr.indexOf(linePropEls[i]);
                    if(alreadyExists == -1)
                    {// to remove duplications
                        arr.push(linePropEls[i]);
                    }
                }
            }
        }
        return arr;
    };
    
    this.comboValUpdate = function(chartComboLineArray, comboVal, legVal)
    {
    	if(comboVal != null && comboVal !== '0')
        {
            return addInComboLineArray(chartComboLineArray, legVal);
        }
        else if((comboVal === '0' || comboVal == null))
        {
            return removeFromComboLineArray(chartComboLineArray, legVal);
        }
    };
    
    var getLegendNameforCombo = function(series)
    {
    	return chartObj.getChartData()[series].seriesname != null ? legendModel.getLegendEls()[series]["origValue"] : legendModel.getLegendEls()[series]["value"];
    };

    var addInComboLineArray = function(chartComboLineArray, legVal)
    {
        var alreadyExists = chartComboLineArray.indexOf(legVal);
        if(alreadyExists == -1)
        {// added if it is not existed
            chartComboLineArray.push(legVal);
            propSetUtil.setModified();
        }
        return chartComboLineArray;
    };

    var removeFromComboLineArray = function(chartComboLineArray, legVal)
    {
        var alreadyExists = chartComboLineArray.indexOf(legVal);
        if(alreadyExists != -1)
        {// removed if only exists already
            var len = chartComboLineArray.length;
            var preEl = chartComboLineArray.slice(0,alreadyExists);
            var postEl = chartComboLineArray.slice(alreadyExists+1,len);
            chartComboLineArray=preEl.concat(postEl);
            propSetUtil.setModified();
        }
        return chartComboLineArray;
    };

    var setComboLineInPropMap = function(chartComboLineArray)
    {
        if(chartComboLineArray.length == 0)
        {// nothing in combo selection
            propSetUtil.deleteFromPropMap(propName);
            return;
        }
        propSetUtil.setMultiValProp(propName, instId, chartComboLineArray, propType);
        if(propSetUtil.modified)
		{
    		propSetUtil.createPropSetDiv(chartObj.getViewObj());
		}
    };
	
    return this;
}
