//$Id $
function ZCLegendModel()
{
	var legend = [];
	var lineSplineVal;
	var comboChartType = null;
	
	this.getLegendEls = function()
	{
		return legend;
	};
	
	this.setLegendEls = function(legEls)
	{
		legend = legEls;
	};
	
	this.setLineSpline = function(value)
	{
		lineSplineVal = value;
	};
	
	this.setLegendTitle = function(view, legTitle)
	{
		view.legendTitleValue = legTitle ? legTitle : "";
	};
	
	this.showLegendNames = function(propSetUtil)
	{
		var legendBody = propSetUtil.propSetForm.legendValBody;
		PropSettings.removeUnwantedChilds(legendBody);
        var clrOrder = propSetUtil.el.getAttribute("clrOrder");
        var isMultiY = propSetUtil.view.chartSelectedEl.isMultiY;
        this.displayLegendValues(propSetUtil, !isMultiY, clrOrder);
        if(ZDBLegendTools && ZDBLegendTools.parLegendEl)
    	{
        	ZDBLegendTools.parLegendEl = null;
    	}
	};
	
	this.updateSplineSelectionInfo = function(data, lineSplineVal)
	{
		if(PropSettings.SPLINE_COMBOTYPE === lineSplineVal)
		{
			data["chart"]["plot"]["plotoptions"]["line"] = {}
			data["chart"]["plot"]["plotoptions"]["line"]["mode"] = "cardinal"; //No I18N
		}
		else
		{
			delete data["chart"]["plot"]["plotoptions"]["line"];
		}
	};
	
    this.displayLegendValues = function(propSetUtil, disable, clrOrder)
    {
        var propSetForm = propSetUtil.propSetForm;
        propSetForm.legendLblTitle.innerHTML = ZDBI18NMap.g("zrpt.common.analysis.legend.settings.js.legLabel"); //No I18N
        propSetForm.legendLblProp.style.height = "210px";
        propSetForm.legendLabelProp.style.clear = "both";
        propSetForm.legendLabelProp.style.width = "520px";
        propSetForm.legendValText.style.width = "273px";
        propSetForm.legendTitle.style.width = "273px";
        
        if(disable)
        {
            propSetForm.legendLblTitle.innerHTML = ZDBI18NMap.g("zrpt.common.analysis.legend.settings.js.legColor"); //No I18N
        }
        var view = propSetUtil.view;
        var legendBody = propSetUtil.propSetForm.legendValBody;
        var legendTr = propSetUtil.propSetForm.legendValTr;
        var inputEls = new Array();
        var legModCount = 0;
        var showReset;
        var clrBand = view.chartObj.getData().clrBndCorrection;
        for(var i=0, idx=0; i<legend.length; i++)
        {
            var curLegend = legend[i];
            var legPropEl = ZDBUtil.getCloneNode(legendTr);
            ZDBUtil.setNamedChildEls(legPropEl, legPropEl);
            var dispValue = curLegend["value"];
            var instId = curLegend["instId"];
            var origValue = curLegend["origValue"];
            legPropEl.legendValText.value = clrBand ? origValue : dispValue;
            legPropEl.legendValText.disabled = disable;
            legendBody.appendChild(legPropEl);
            legPropEl.setAttribute("index", idx++);
            legPropEl.setAttribute("dispValue", dispValue);
            inputEls.push(legPropEl.legendValText);
            legPropEl.legendValSpan.setAttribute("dispVal", dispValue);
            if(curLegend.filterValue === undefined && (curLegend.value === "DY_TH" || 
                    curLegend.value.indexOf("NaN") !== -1))
            {
                legPropEl.legendColor.onclick = null;
                continue;
            }

            var legClr = curLegend["color"];
            legClr = ZRColorModelUtil.convertToHexIfRGB(legClr);
            legPropEl.legendColor.style.backgroundColor = legClr;
            var clrVal = ZDBUtil.replaceStr(legClr.toUpperCase(), "#", "");
            legPropEl.legendColor.setAttribute("value", clrVal);
            legPropEl.setAttribute("legendClr", clrVal);
            legPropEl.setAttribute("instId", instId);
            legPropEl.legendColor.onclick = function(){ZALegendSettings.displayLegendClrDlg(this, 9);}
            if(disable) 
            {
                legPropEl.legendColor.setAttribute("filtervalue", curLegend["filterValue"]);
            }
            if(curLegend["origValue"] == null)
            {
            	continue;
            }
            legPropEl.setAttribute("origVal", origValue);
            if(curLegend["clrMod"])
            {
                showReset = true;
                legModCount++;
            }
            curLegend.isPltClr = !curLegend["clrMod"];
        }
        if(legModCount === legend.length)
        {
            propSetForm.legClrsWarnIcon.style.display = "none";//removing the icon
        }
        else
        {
            propSetForm.legClrsWarnIcon.style.display = "none";
        }
        if(!disable && clrOrder!=null) {
            propSetUtil.focusEl = inputEls[parseInt(clrOrder)];
        }
        if(showReset && ZDBGlobal.isClrPltEnabled())
        {
            propSetForm.resetKey.style.display = "inline-block";
        	propSetUtil.showCreateClrPltKey(view.chartObj.getCurrentChartPltType(),propSetUtil);
       	}
        else
        {
            propSetForm.resetKey.style.display = "none";
            propSetForm.createClrPltKey.style.display = "none";
        }
    };
    
    this.setComboChartOpt = function(propSetUtil)
    {
        var comboBdy = propSetUtil.propSetForm.comboUtils;
        PropSettings.removeUnwantedChilds(comboBdy);
        var view = propSetUtil.view;
        var propLen = 0;
        var propEls =null;
        var defClrProp = true;
        for(var i=0; i < legend.length; i++)
        {
            var curLegend = legend[i];
            var legPropEl = ZDBUtil.getCloneNode(propSetUtil.propSetForm.legPropEl);
            ZDBUtil.setNamedChildEls(legPropEl, legPropEl);
            var comboSel = legPropEl.comboSelection;
            var legName = curLegend["value"];
            var origValue = curLegend["origValue"];
            (legPropEl.legName).setAttribute("origvalue", origValue);
            legPropEl.legName.innerHTML = legName;
            var instId = curLegend["instId"];
            comboSel.setAttribute("instId", instId);
            comboBdy.appendChild(legPropEl);
            legPropEl.style.display = "block";
            var comboSel = legPropEl.comboSelection;
            if(curLegend["comboType"])
            {
                ZDBAxisProp.setToggleEl(legPropEl.line);
                comboSel.setAttribute("propValue", lineSplineVal);
            }
            else
            {
                ZDBAxisProp.setToggleEl(legPropEl.bar);
                comboSel.setAttribute("propValue", PropSettings.BAR_COMBOTYPE);
            }
        }
    };
    
    this.setLegendAttributes = function(propSetUtil)
    {
    	var view = propSetUtil.view;
        var legendTitle = (propSetUtil.propSetForm.legendTitle).value;
        var legendFilterEnable = (propSetUtil.propSetForm.legendFilterBoxes).checked;
        var legendPos = (propSetUtil.propSetForm.zdbLegendCombo).value;
        if((propSetUtil.propSetForm.legendTitleCBox).checked != true)
        {
            view.legendTitleValue = legendTitle;
            legendTitle = "";
        }
        else if(legendPos !="NONE" && (legendTitle.length <= 0 || legendTitle.length > ZDBConst.COLNAME_MAX_LENGTH))
        {
            ZDBInlineDialog.changeTab(propSetUtil.propSetForm.legPropNav, propSetUtil.propSetForm);//No I18N
            showCustomMessage(ZDBI18NMap.f("zrpt.common.analysis.settings.js.legTtlLenErr",ZDBConst.COLNAME_MAX_LENGTH),(propSetUtil.propSetForm.legendTitle));//No I18N
            (propSetUtil.propSetForm.legendTitle).select();
            return false;
        }

        var legendTitleModified = (view.legendTitleValue != null) && (view.legendTitleValue != legendTitle);
        var clrDisplayName = view.legendType["clrdisplayname"];
        if(clrDisplayName)
    	{
        	view.legendTitleModified = (clrDisplayName == legendTitle) ? false : true;
    	}
        else
    	{
        	view.legendTitleModified = legendTitle == "Legend" ? false : true; //No I18N
    	}
        var isMultiY = propSetUtil.view.chartSelectedEl.isMultiY;
        var instId;
        if(legendTitleModified && !isMultiY)
        {
        	var legTitleEl = propSetUtil.propSetForm.legendTitle;
        	var clrVCIInst = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType", "COLORAXIS")[0];//No I18N
        	if(clrVCIInst)
        	{
        		instId = clrVCIInst.getAttribute("instkey");
        	}
        	else
        	{
        		instId = view.currentList[0].getAttribute("INSTKEY");
        	}
    	    legTitleEl.setAttribute("instId",instId);
        	legTitleEl.setAttribute("propValue",legendTitle);
        	propSetUtil.setPropMap(legTitleEl,view.legendTitleValue);
        }
        
    	var modified = (legendTitleModified ||
                (view.legendFilterEnable != legendFilterEnable) ||
                (view.legendPos != legendPos));
    	// getting modified status first and then setting to view
    	
        view.legendTitleValue = view.legendTitleModified || legendPos == "NONE" ? legendTitle : null; // No I18N
        view.legendFilterEnable = legendFilterEnable;
        view.legendPos = legendPos;
            
        if(modified)
    	{
        	propSetUtil.setModified();
    	}
        return true;
    };
    
    this.setLegendColors = function(propSetUtil)
	{ // Common for Pie and Color Axis Legends
		var legendBody = propSetUtil.propSetForm.legendValBody;
        
        var legPropEls = legendBody.getElementsByTagName("tr");
        for(var i=0; i<legPropEls.length && legPropEls.length === legend.length; i++)
        {
        	var legPropEl = legPropEls[i];
        	var legObj = legend[i];
        	var isMultiY = legObj["viewType"] == "multiy";
            //matching LegendColor
        	if(!isMultiY)
        	{
                var isClrModified = this.setEachLegendColor(legObj, legPropEl, "KEYVALUE", legObj["origValue"], propSetUtil.view.legDetInfo); //No I18N
        	}
        	else
        	{
                var isClrModified = this.setEachLegendColor(legObj, legPropEl, "INSTID", legObj["instId"], propSetUtil.view.legDetInfo); //No I18N
        	}
            if(isClrModified)
        	{
            	propSetUtil.setModified();
        	}
        }
	};
    
    this.setEachLegendColor = function(legObj, legPropEl, attrKey, attrVal, legDetInfo)
    {
        if((legObj.value === "DY_TH" ||
            (legObj.origValue !== null && legObj.origValue.indexOf("NaN") !== -1)) && legObj.color === undefined) {
            return false;
        }
    	var legClr = legPropEl.getAttribute("legendclr");
    	var newLegClr = legPropEl.legendColor.style.backgroundColor;
        ZDBEscapeUtil.encodeForHtml(ZDBUtil.replaceStr(newLegClr, "#", ""));
        var rgbVal = ZDBColorUtil.getNewShade(ZDBColorUtil.getRGBValues(newLegClr), 1);
        var hexVal = ZDBColorUtil.getHex(rgbVal).toUpperCase();
        
        if(legClr != hexVal)
        { // if color doesn't matches with existing one
        	var legMatchEl = getMatchingLegEl(legDetInfo, attrKey, attrVal); //No I18N
            if(!legMatchEl)
            {
            	legMatchEl = {}; // creating new, else updating in oldProp
                legDetInfo[legDetInfo.length] = legMatchEl;
            }
            
            var keyValue = legObj["origValue"];
            keyValue = ZDBUtil.replaceStr(keyValue,"--C--",",");  //No I18N
            
            legMatchEl["INSTID"] = legObj["instId"];
            legMatchEl["KEYVALUE"] = keyValue;
            legMatchEl["COLOR"] = hexVal;
            legMatchEl["SAVECOLOR"] = true;
            return true;
        }
        else if(legObj.isPltClr)
    	{
        	var legMatchEl = getMatchingLegEl(legDetInfo, attrKey, attrVal); //No I18N
        	var containsComma = attrVal != null ? attrVal.search("--C--") : -1;  //No I18N
        	if(!legMatchEl && containsComma != -1)
    		{
        		attrVal = ZDBUtil.replaceStr(attrVal,"--C--",",");  //No I18N
        		legMatchEl = getMatchingLegEl(legDetInfo, attrKey, attrVal);
    		}
        	if(legMatchEl)
    		{// removing the set Color alone from the LegDetInfo
        		var legDetIdx = legDetInfo.indexOf(legMatchEl);
        		legDetInfo.splice(legDetIdx, 1);
        		return true;
    		}
    	}
        return false;
    };
    
    var getMatchingLegEl = function(legDetInfo, attr, val)
    {
    	for(var i=0; i <legDetInfo.length; i++)
		{
    		if(legDetInfo[i][attr] === val)
			{
    			return legDetInfo[i];
			}
		}
    	return null;
    };
    
    this.isLegendEls = function()
    {
    	if(!legend || legend.length <= 0)
		{
    		return false;
		}
    	return true;
    };
    
    this.getLegElPosWithAttrNValue = function(attr, value)
    {
    	for(var i = 0 ; i < legend.length; i++)
		{
    		if(legend[i][attr] == value)
			{
    			return i; // returning position
			}
		}
    };
    
    this.getAttribute = function(index, attr)
    {
    	return legend[index][attr];
    };
    
    this.changeToBarGraphType = function(view)
    {
    	view.chartSelectedEl.selectedGraph = "BAR"; //No I18N
    	view.chartSelectedEl.subGraphType = "DEF"; //No I18N
    	view.userGrpSel = "BAR"; //No I18N
        view.userSubGrpSel = "DEF"; //No I18N
        view.setDefCombo = true;
        ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.common.analysis.js.comboChart'));
        ZDBAnalysisView.selectOrEnableGraphTypes(view);
    };
    
    this.alterComboChartType = function(isComboLine, subGraphType)
    {
    	if(isComboLine)
		{
    		return ZCHARTCONST.get("LINE");
		}
    	else
		{
    		return subGraphType.indexOf("SBR") >= 0 ? ZCHARTCONST.get("SBR") : ZCHARTCONST.get("BAR");
		}
    }
    
    return this;
}
