//$Id $

function ZCMultiYLegendModel(chartObj)
{
	var chartObj = chartObj;
	var legendModel = new ZCLegendModel();
	var lineSplineVal;
    var yCurrentList;
    var isComboSplineSelected = false;
    var prevComboSpline = false;
	var setDefCombo = false;
	var propSetUtil;
	
	this.getLegendEls = legendModel.getLegendEls;
    this.showLegendNames = legendModel.showLegendNames;
    this.displayLegendValues = legendModel.displayLegendValues;
    this.setComboChartOpt = legendModel.setComboChartOpt;
    this.getLegElPosWithAttrNValue = legendModel.getLegElPosWithAttrNValue;
    this.alterComboChartType = legendModel.alterComboChartType;
    this.MAX_LEGEND_LENGTH = 100;
    
	this.init = function()
	{
		var view = chartObj.getViewObj();
		var chartData = chartObj.getChartData();
		var data = chartObj.getData();
		
		yCurrentList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","YAXIS");//No I18N
		if(chartData && chartData.length > 1) //strict for MultiY
		{
			var length = chartData.length;
			var legEls = new Array();
			var palette = ZCHARTCONST.get(data.canvas.theme);
	        var clrArray = data.legend.colors;
	        var userClrArr = data.legend.userColors;
	        var legendCritInfo = view.legendCritInfo;
	        for(var i=0; i<length; i++)
			{
				var legObj = new Object();
				var instKey = yCurrentList[i].getAttribute("INSTKEY");
				legObj["value"] = chartData[i].seriesname;
				legObj["color"] = clrArray[i];
				legObj["clrMod"] = userClrArr[i] != null;
				legObj["origValue"] = chartData[i].seriesname;
				legObj["filterValue"] = instKey;
				legObj["comboType"] = view.curListProp[instKey]["COMBOTYPE"];
				legObj["instId"] = instKey;
				legObj["index"] = i;
				legObj["viewType"] = "multiy"; //No I18N
                                var chcklegObj = {"legId": legObj["index"], "value": legObj["filterValue"]} //NO I18N
				if(legendCritInfo)
                                {
                                    for(var j=0;j< legendCritInfo.length;j++ )
                                    {
                                      var legCritObj = legendCritInfo[j];
                                      if(legCritObj["legId"] === chcklegObj["legId"] &&  legCritObj["value"] === chcklegObj["value"] )
                                       {
                                         legObj["filtered"] = true;
                                         break;
                                       }
                                    }
                                }
				legEls.push(legObj);
			}
	        legendModel.setLegendEls(legEls);
	        this.updateComboInfoToLeg();
	        legendModel.setLegendTitle(chartObj.getViewObj(), data.legend.title.text);
		}
	};
	
	this.setLegendComboProps = function()
	{
		propSetUtil = chartObj.getViewObj().propSetUtil;
		if(!this.isLegendValid()) 
        {
            return false;
        }
		if(!legendModel.setLegendAttributes(propSetUtil))
		{
			return false;
		}
		setLegendNamesNColors();
		if(propSetUtil.isComboProp)
		{
			this.setComboProps();
		}
		return true;
	};
	
	this.isLegendValid = function()
    {
        var legendEls = propSetUtil.propSetForm.legendValBody.getElementsByTagName("Input");
        for(var i=0; i<legendEls.length; i++)
        {
            var legVal = legendEls[i].value.trim();
            if(ZDBValidator.isBlank(legVal))
            {
                ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.legPropNav, legendEls[i],
                    ZDBI18NMap.g("zrpt.common.analysis.legend.settings.js.noNameErr"), true); //No I18N
                return false;
            }
            else if(legVal.length > this.MAX_LEGEND_LENGTH)
            {
                ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.legPropNav, legendEls[i],
                    ZDBI18NMap.f("zrpt.common.analysis.legend.settings.js.nameLen", this.MAX_LEGEND_LENGTH), true); //No I18N
                return false;
            }
        }
        return true;
    };
    
    this.setDefComboOpt = function()
    {
		var legEls = legendModel.getLegendEls();
		var instKey = legEls[0]["instId"];
		var curListProp = chartObj.getViewObj().curListProp;
		curListProp[instKey]["COMBOTYPE"] = lineSplineVal;
		setDefComboVal(false);
    };
    
    this.modifyComboPropVal = function(status)
    {
    	this.setLineSpline();
    	//modifying the comboType in curListProp
    	var legEls = legendModel.getLegendEls();
    	var curListProp = chartObj.getViewObj().curListProp;
    	for(var i =0; i< legEls.length; i++)
		{
    		var instKey = legEls[i]["instId"];
    		if(curListProp[instKey]["COMBOTYPE"])
			{
    			curListProp[instKey]["COMBOTYPE"] = lineSplineVal; //modified the comboType Value
			}
		}
    };
	
	this.makeChangesForComboChart = function()
	{
		if(setDefCombo)
		{
			this.setDefComboOpt();
		}
		else
		{
			this.modifyComboPropVal();
		}
		this.updateComboInfoToLeg();
		var view = chartObj.getViewObj();
		var chartData = chartObj.getChartData();
		var curListProp = view.curListProp;
		var legEls = legendModel.getLegendEls();
		for(var i=0; i < legEls.length; i++)
    	{
        	var instKey = legEls[i]["instId"];
        	chartData[i].type = this.alterComboChartType(curListProp[instKey]["COMBOTYPE"], view.subGraphType);
    	}
		
		legendModel.updateSplineSelectionInfo(chartObj.getData(), lineSplineVal);
		chartObj.setModified(true);
	};
	
    this.getComboSplineVal = function(el)
	{
		if(el.getAttribute("value") != PropSettings.BAR_COMBOTYPE)
        {
            return isComboSplineSelected ? PropSettings.SPLINE_COMBOTYPE : PropSettings.LINE_COMBOTYPE;
        }
        return PropSettings.BAR_COMBOTYPE;
	};
	
	this.updateComboInfoToLeg = function()
	{
		var view = chartObj.getViewObj();
		this.updateIsComboSplineSelected();
		this.setLineSpline();
		this.updateDefComboSelected();
	};
	
	this.setLineSpline = function()
	{
		lineSplineVal = (isComboSplineSelected) ? PropSettings.SPLINE_COMBOTYPE : PropSettings.LINE_COMBOTYPE;
		legendModel.setLineSpline(lineSplineVal);
	}
	
	var setLegendNamesNColors = function()
	{
		var legendBody = propSetUtil.propSetForm.legendValBody;
        var view = propSetUtil.view;
        var yList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType", "YAXIS"); //No I18N
        var curListProp = view.curListProp;
        
        var legPropEls = legendBody.getElementsByTagName("tr");
        var legEls = legendModel.getLegendEls();
        for(var i=0; i<legPropEls.length && legPropEls.length === legEls.length; i++)
        {
        	var legPropEl = legPropEls[i];
        	var legObj = legEls[i];
        	// matching LegName
            var curLegValue = legPropEl.legendValText.value.trim();
            var dispValue = legObj["value"];
            if(dispValue != curLegValue)
            {
                var instKey = legObj["instId"];
                var prevLegVal = curListProp[instKey]["PVTCOLUMNNAME"];
                if(prevLegVal != curLegValue)
            	{
                	curListProp[instKey]["PVTCOLUMNNAME"] = curLegValue;
                	propSetUtil.setModified();
            	}
            }
            //matching LegendColor
            var isClrModified = legendModel.setEachLegendColor(legObj, legPropEl, "INSTID", legObj["instId"], propSetUtil.view.legDetInfo); //No I18N
            if(isClrModified)
        	{
            	propSetUtil.setModified();
        	}
        }
	};
	
	this.setComboProps = function()
	{
		var comboProp = propSetUtil.propSetForm.comboProp;
        var view = propSetUtil.view;
        var propEls = ZDBUtil.getElsWithTagNAttr(comboProp, "instId", "div");//No I18N
        var currentList = view.currentList;
        var curListProp = view.curListProp;
//        yCurrentList = ZDBUtil.getElementsWithAttribute(currentList, "viewType","YAXIS");//No I18N
        
        for(var i=0, j=propEls.length; i<j; i++)
        {
            var propValue = propEls[i].getAttribute("propValue");
            var instKey = yCurrentList[i].getAttribute("INSTKEY");
            curListProp = this.comboValUpdate(curListProp, propValue, instKey);
        }
        this.updateComboToView(curListProp);
	};
	
	this.updateComboToView = function(curListProp)
	{
		var isMultiYLine = true;
		//checking for any multi Y instances
        for(var i1=0, j1= yCurrentList.length; i1< j1; i1++)// it is to be changed for currentList
        {
        	var instKey = yCurrentList[i1].getAttribute("INSTKEY");
            if(curListProp[instKey]["COMBOTYPE"] == lineSplineVal)
            {
                isMultiYLine = false;
                break;
            }
        }
        if(isMultiYLine)
        {
            legendModel.changeToBarGraphType(chartObj.getViewObj());
            setDefComboVal(true);
        }
	}
	
	this.comboValUpdate = function(curListProp, comboVal, instKey)
	{
		if(!propSetUtil)
		{
			propSetUtil = chartObj.getViewObj().propSetUtil;
		}
		if(comboVal && comboVal == PropSettings.BAR_COMBOTYPE && curListProp[instKey]["COMBOTYPE"])
        {
        	delete curListProp[instKey]["COMBOTYPE"];
            propSetUtil.setModified();
        }
        else if(comboVal && comboVal != PropSettings.BAR_COMBOTYPE && (curListProp[instKey]["COMBOTYPE"] != lineSplineVal))
        {
        	curListProp[instKey]["COMBOTYPE"] = lineSplineVal;
            propSetUtil.setModified();
        }
		return curListProp;
	}
    
    this.updateIsComboSplineSelected = function()
    {
    	isComboSplineSelected = this.isComboSpline() ? true : false;
    };
    
    this.updateComboSplineSelected = function(isComboSpline)
    {
    	isComboSplineSelected = isComboSpline;
    };
     
    this.updateDefComboSelected = function()
    {
    	if(!(this.isComboSpline() || this.isComboLine()))
    	{
    		setDefComboVal(true);
    	}
    };
    
    var setDefComboVal = function(isDefCombo)
    {
    	setDefCombo = true;
    }
    
    this.setDefComboValOnFieldChange = function(isDefCombo,view)
    {
    	setDefComboVal(isDefCombo);
		view.setDefCombo = true;
    }
    
    this.isComboSpline = function()
    {
    	var view = chartObj.getViewObj();
    	return ZDBAnalysisUtil.isPropInCurPropList(view.curListProp, "COMBOTYPE", PropSettings.SPLINE_COMBOTYPE);//No I18N
    };
    
    this.isComboLine = function()
    {
    	var view = chartObj.getViewObj();
    	return ZDBAnalysisUtil.isPropInCurPropList(view.curListProp, "COMBOTYPE", PropSettings.LINE_COMBOTYPE);;//No I18N
    };
    
    return this;

}

