//$Id $
function ZCPieLegendModel(chartObj)
{
	var data = chartObj.getData();
	var chartData = chartObj.getChartData();
	var legendModel = new ZCLegendModel();
	var legColorMap = undefined;
	var propSetUtil;
	var filterIdxArr = [];
	var percentIdx = -1;
    var valIdx = -1;
	
	this.getLegendEls = legendModel.getLegendEls;
	this.showLegendNames = legendModel.showLegendNames;
	this.displayLegendValues = legendModel.displayLegendValues;
	this.getLegElPosWithAttrNValue = legendModel.getLegElPosWithAttrNValue;
	
    this.init = function()
    {
        if(chartData && chartData.length === 1 && chartData[0].data.length > 0) //double check
        {
            var dataArr = chartData[0].data[0] && chartData[0].data[0][0] instanceof Array ? chartData[0].data[0] : (chartData[0].data[0].length == 0 ? [] : chartData[0].data);
            var len = dataArr.length;
            var metaData = data.metadata;
            var perColIdx = metaData.axes.percent[0];
            var curData = metaData.columns[perColIdx];
            percentIdx = curData.dataindex;
            var colIdx = metaData.axes.y[0];
            curData = metaData.columns[colIdx];
            valIdx = curData.dataindex;
            colIdx = metaData.axes.x[0];
            curData = metaData.columns[colIdx];
            var view = chartObj.getViewObj();
            var catVCInst = view.currentList[colIdx];
            var actDataType = catVCInst.getAttribute("operation");
            var catIdx = curData.dataindex;
            var datatype = curData["datatype"];
            var formatConf = curData[datatype];
            var colors = data.legend.colors;
            var clrArray;
            if(colors.length === len)
            {
                clrArray = colors;
            }
            else
            {
                colors = null;
                clrArray = [];
                this.createLegendColors();
            }
            var clrArray = data.legend.colors;
            var userClrArr = data.legend.userColors;
            var filterValue = data.legend.filterValue;
	        var legEls = new Array();
	        var legendCritInfo = view.legendCritInfo;
	        var isMultiY = view.chartSelectedEl.isMultiY;
	        for(var i=0; i<len; i++)
	        {
	        	var legObj = new Object();
				legObj["value"] = $ZC.getFormattedValue(formatConf,dataArr[i][catIdx],datatype);
				if(typeof legObj.value == "function")
				{
					legObj["value"] = legObj.value();
				}
				if(!colors)
				{
					if(dataArr[i][catIdx] == null)
					{
						clrArray[i] = "#737373"; //for Null Color //it is needed during Chart type changes
						data.legend.nullSeriesIdx = i;
					}
					else
					{
						clrArray[i] = legColorMap[legObj["value"]];
					}
				}
				if(isMultiY)
				{
					legObj["instId"] = view.currentList[i].getAttribute("INSTKEY");
					legObj["viewType"] = "multiy"; //No I18N
					legObj["filterValue"] = legObj["instId"]; 
					legObj["origValue"] = legObj["value"]; 
				}
				else
				{
					var subFuncType = ZDBVUDataAPI.getSubFuncType(curData, view.selectedGraph, actDataType);
					legObj["origValue"] = dataArr[i][catIdx] != null ? ZDBVUDataAPI.getCriteriaVal(subFuncType, dataArr[i][catIdx], curData[datatype], curData) : null;
					legObj["instId"] = catVCInst.getAttribute("INSTKEY"); //No I18N
					legObj["viewType"] = catVCInst.getAttribute("viewType");//No I18N
					legObj["filterValue"] = filterValue[i];
				}
				legObj["color"] = clrArray[i];
				legObj["clrMod"] = userClrArr[i] != null;
				legObj["index"] = i;
                                var chcklegObj = {"legId": legObj["instId"], "value": legObj["filterValue"]} //NO I18N
				if(legendCritInfo)
                                {
                                    for(var j=0;j< legendCritInfo.length;j++ )
                                    {
                                      var legCritObj = legendCritInfo[j];
                                      if(legCritObj["legId"] === chcklegObj["legId"] &&  legCritObj["value"] === chcklegObj["value"] )
                                       {
                                         legObj["filtered"] = true;
                                         break;
                                       }
                                    }
                                }
				legEls.push(legObj);
	        }
	        if(!colors)
        	{
                    data.legend.colors = clrArray;
                    ZCFormatUtil.setLegendColor(data);
                    ZCFormatUtil.setLegendFilter(data);
                    for(var i=0; i < clrArray.length; i++)
                    {
                        legEls[i]["color"] = clrArray[i];
                    }
        	}
	        legendModel.setLegendEls(legEls);
	        legendModel.setLegendTitle(chartObj.getViewObj(), data.legend.title.text);
        }
	};
	
	this.createLegendColors = function()
	{
		if(legColorMap === undefined)
		{
			legColorMap = {};
		}
		else
		{
			return;
		}
		var legDetInfo = chartObj.getViewObj().legDetInfo;
		var legendParams = ZDBAnalysisConfig.LEGENDCOLORPARAMS;
		for(var i=0 ; i < legDetInfo.length; i++)
		{
			var legEl = legDetInfo[i];
			legColorMap[legEl[legendParams[1]]] = "#" + legEl[legendParams[2]];
		}
	};
	
	this.setLegendComboProps = function()
	{
        propSetUtil = chartObj.getViewObj().propSetUtil;
        if(!legendModel.setLegendAttributes(propSetUtil))
		{
			return false;
		}
        legendModel.setLegendColors(propSetUtil);
        if(propSetUtil.view.chartSelectedEl.isMultiY)
        {
            var curListProp = propSetUtil.view.curListProp;
            var legPropEls = propSetUtil.propSetForm.legendValBody.getElementsByTagName("tr");
            var legEls = legendModel.getLegendEls();
            for(var i=0; i<legPropEls.length && legPropEls.length === legEls.length; i++)
            {
                var legObj = legEls[i];
                var curLegValue = legPropEls[i].legendValText.value.trim();
                if(legObj["value"] != curLegValue)
                {
                    var instKey = legObj["instId"];
                    if(curListProp[instKey]["PVTCOLUMNNAME"] != curLegValue)
                    {
                        curListProp[instKey]["PVTCOLUMNNAME"] = curLegValue;
                        propSetUtil.setModified();
                    }
                }
            }
        }
        return true;
	};
	
    this.setFilterIdx = function(idx)
    {
        var eleIdx = filterIdxArr.indexOf(idx);
        if(eleIdx === -1)
        {
            filterIdxArr[filterIdxArr.length] = idx;
        }
        else
        {
            filterIdxArr.splice(eleIdx, 1);
        }
    };
    
    // update percentage value in data as well as conversion text for SelectAll
    this.updatePercentValueSelectAll = function(selected)
    {
    	var view = chartObj.getViewObj();
    	var dataArr = chartData[0].data[0] && chartData[0].data[0][0] instanceof Array ? chartData[0].data[0] : (chartData[0].data[0].length == 0 ? [] : chartData[0].data);
    	var len = dataArr.length;
    	var total = 0;
    	var displayIdxs = [];
    	if(selected)
		{
    		filterIdxArr.length = 0;
    		if(view.legendCritInfo && view.legendCritInfo instanceof Array)
			{
    			view.legendCritInfo.length = 0;
			}
		}
    	for(var i=0; i<len; i++)
    	{
    		if(!selected)
			{
    			this.setFilterIdx(i);
			}
    		if(jQuery.inArray(i, filterIdxArr) === -1)
    		{
    			displayIdxs.push(i);
    			total = total + dataArr[i][valIdx];
    		}
    	}
    	dataArr = this.modifyPercentValue(dataArr, displayIdxs, valIdx, total);
    	this.modifyConversionValue(dataArr, displayIdxs, valIdx);
    };
    
    // update percentage value in data as well as conversion text
    this.updatePercentValue = function(idx)
    {
    	var dataArr = chartData[0].data[0] && chartData[0].data[0][0] instanceof Array ? chartData[0].data[0] : (chartData[0].data[0].length == 0 ? [] : chartData[0].data);
        var len = dataArr.length;
        if(len - filterIdxArr.length === 1 && jQuery.inArray(idx, filterIdxArr) === -1) {
            return;
        }
        var total = 0;
        this.setFilterIdx(idx);
        var displayIdxs = [];
        for(var i=0; i<len; i++)
        {
            if(jQuery.inArray(i, filterIdxArr) === -1)
            {
                displayIdxs.push(i);
                total = total + dataArr[i][valIdx];
            }
        }
        dataArr = this.modifyPercentValue(dataArr, displayIdxs, valIdx, total);
        this.modifyConversionValue(dataArr, displayIdxs, valIdx);
    };

    this.modifyConversionValue = function(dataArr, displayIdxs, valIdx)
    {
        var view = chartObj.getViewObj();
        var convRateProp = view.propSetUtil.getPropValue(PropSettings.CONVERSION_RATE_EXISTS,
                        PropSettings.STATIC_PROP, PropSettings.STRING_PROPTYPE);
        var notes = data.notes;
        if(convRateProp && notes)
        {
            var len = displayIdxs.length;
            var convVal = notes.blockValues[0].htmlEl;
            var convText = convVal.substring(0, convVal.lastIndexOf(" ") + 1);
            var firstVal = dataArr[displayIdxs[0]][valIdx];
            var lastVal = dataArr[displayIdxs[len-1]][valIdx];
            var percentVal = this.getPercentValue(lastVal, firstVal);
            percentVal = Math.round(percentVal * 10) / 10;
            notes.blockValues[0].htmlEl = convText + percentVal + "%";
            var convElId = notes.blockValues[0].id; //This id info is dependent from Zoho Charts
            $(convElId).innerHTML = notes.blockValues[0].htmlEl;
        }
    };

    this.modifyPercentValue = function(dataArr, displayIdxs, valIdx, total)
    {
        var view = chartObj.getViewObj();
        var itemLblProp = view.propSetUtil.getPropValue(PropSettings.CHART_DEFAULT_ITEMLABEL_PROP,
                                    PropSettings.STATIC_PROP, PropSettings.DOUBLE_PROPTYPE);
        if(!itemLblProp) {
            itemLblProp = 1;
        }
        itemLblProp = parseInt(itemLblProp);
        var percentProp = view.propSetUtil.getPropValue(PropSettings.FUNNEL_CONVERSION_PROP,
                        PropSettings.STATIC_PROP, PropSettings.DOUBLE_PROPTYPE);
        if(view.subGraphType !== "FUNNEL" || !percentProp || itemLblProp === 0 || itemLblProp === 2) {
            percentProp = 0;
        }
        var len = displayIdxs.length;
        percentProp = parseInt(percentProp);
        if(percentProp > 0)
        {
            dataArr[displayIdxs[0]][percentIdx] = "100%";
            var prevVal = dataArr[displayIdxs[0]][valIdx];
            for(var i=1; i<len; i++)
            {
                var currVal = dataArr[displayIdxs[i]][valIdx];
                dataArr[displayIdxs[i]][percentIdx] = this.getPercentValue(currVal, prevVal);
                if(percentProp === 2) {
                    prevVal = currVal;
                }
            }
        }
        else
        {
            for(var i=0; i<len; i++)
            {
                var currVal = dataArr[displayIdxs[i]][valIdx];
                dataArr[displayIdxs[i]][percentIdx] = this.getPercentValue(currVal, total);
            }
        }
        return dataArr;
    };

    this.getPercentValue = function(topVal, bottomVal)
    {
        var percentVal = ((topVal / bottomVal) * 100).toString();
        var dotPos = percentVal.indexOf(".");
        if(percentVal.substring(dotPos+1, percentVal.length) === "0") {
            percentVal = percentVal.substring(0, dotPos);
        }
        return percentVal;
    };
        
	return this;
}
