//$Id$ 

ZDBAnalysisView.prototype.addFieldToArea = function(field,parentArea,savedConfig)
{
  var index = ZDBUtil.indexOf(this.currentList,field);
  if(index == -1)
  {
      if(!this.validateYCount(field , parentArea , savedConfig))
      {
          return false;
      }
  }
       if(!parentArea.elTrimmed)
  {
	ZDBUtil.removeNonElements(parentArea);
  }
  
  var childNodes = parentArea.childNodes;
  if((childNodes.length > 0)  && (parentArea.getAttribute("single") == "true"))
  {
    this.removeField(childNodes[0],false);
    parentArea.innerHTML="";
  }

  if(parentArea.getAttribute("single")=="false")
  {
    ZDBUtil.removeNonElements(parentArea);
    var noChilds = parentArea.childNodes.length;
    //var space = parentArea.childNodes[noChilds-1];
    //parentArea.removeChild(space);
    
    ZDBAnalysisView.addFieldInDropArea(parentArea,field);
    var filterFields = DOMUtils.getParentWithAttrValue(parentArea,"elname","filterFields");//No I18N
    if(filterFields)
    	{
    		var clearAllFilters = DOMUtils.getFirstMatchingChild(filterFields,"div","elname","clearAllFilters");//No I18N
    		if(clearAllFilters)
				{
					clearAllFilters.style.display="";
				}
    	}
    //parentArea.appendChild(space);
    ZDBScroller.setScrollerTop(parentArea.parentNode);
    if(!savedConfig)
    {
        field.style.position = "relative";
      ZDBAnalysisView.expandDropField(parentArea);      
      ZDBAnalysisView.setListHeight(view, parentArea,true,50);
      parentArea.dropAreaTd.dropArea.scrollTop = field.offsetTop/2;     
    }
  }
  else
  {
    ZDBAnalysisView.addFieldInDropArea(parentArea,field);
  }
  if(!savedConfig)
  {
        
      if(this.graphSelected=="BEST")
      {
        this.subGraphType="DEF"; //No I18N
      }
  }
  field.style.position="relative";
  field.style.left=0;
  field.style.top=0;
  var vType = parentArea.getAttribute("VIEWTYPE");
  if(vType)
  {
    field.setAttribute("VIEWTYPE",vType);
  }
	this.orderCurrentList(field,parentArea,savedConfig);
        
  if(this.editMode)
  {
    this.updateAddedFields();
    var view = ZDBClientUI.getViewObj(field,"view");//NO I18N
  ZDBAnalysisView.highlightElement(view,field);
  ZDBAnalysisView.enableDropFieldExp(parentArea);
	  if(vType == "COLORAXIS" && view.graphSelected == "COMBO")
	  {
		  view.graphSelected = "BEST"; //No I18N
		  view.userGrpSel = "BEST"; //No I18N
		  view.userSubGrpSel = "DEF";  //No I18N
		  view.subGraphType = "DEF";  //No I18N
		  var legModel = view.chartObj.getLegendModel();
		  legModel.setDefComboValOnFieldChange(true,view);
	  }
  }
  if(!field.getAttribute("INSTKEY"))
  {
    field.setAttribute("INSTKEY", ++this.currentListLen);
  }
  if(this.curListProp) // initialization for new CurListProp
  {
	  if(!this.curListProp[this.currentListLen])
	  {
		  this.curListProp[this.currentListLen] = {};
	  }
  }
      
  return true;
}

ZDBAnalysisView.prototype.orderCurrentList = function(field,curDropArea,savedConfig)
{
	 var viewType = curDropArea.getAttribute("viewtype");
	 var currentList = this.currentList;
	 var i = 0;
	 while(i<currentList.length){
		 if(currentList[i].getAttribute("viewtype")==viewType)
		 {
		 currentList.splice(i,1);
		 i = i-1;
		 }
		 i++;
	 }
	 var droppedEls = ZDBUtil.getElsWithAttrName(curDropArea,"column_id");//NO I18N
	 for(i=0; i<droppedEls.length; i++){
		 currentList.push(droppedEls[i]);
	 }
}

ZDBAnalysisView.prototype.validateYCount = function(field,parentArea,savedConfig)
{

    if(!savedConfig && this.type == 'AnalysisView' && parentArea != null)
    {
        viewtype = parentArea.getAttribute("VIEWTYPE");
        if(viewtype == 'YAXIS')
        {
            if(this.getDroppedFieldsLength(viewtype) > 14)
            {
              ZDBAnalysisView.appendDropSpaceToBody();
                ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.chartview.zdbalertmsg.js.yAxisColLimitExceedErr")); //No I18N
                return false;
            }
        }
    }
    return true;
}

ZDBAnalysisView.getAttributeElorObj = function(el, attr)
{
	return el.getAttribute ? el.getAttribute(attr) : el[attr];
}

ZDBAnalysisView.getGraphField = function(view,field,viewType,fieldTitle,drgNDrp)
{
    var el = (viewType == "FILTERAXIS")? ZDBAnalysisView.filterFieldTpl.cloneNode(true) :ZDBAnalysisView.graphFieldTpl.cloneNode(true); //No I18N
    ZDBUtil.setNamedChildEls(el,el);
    el.fieldName.innerHTML = ZDBEscapeUtil.encodeForHtml(fieldTitle);
//    el.title=fieldTitle;
    el.title = ZDBAnalysisView.getAttributeElorObj(field, "COLUMNNAME"); //No I18N
    var parentDispName =  ZDBAnalysisView.getAttributeElorObj(field, "PARENT_DISPNAME");//No I18N
    if(el.title === '' || el.title == null || el.title == "null")
    {
        if(parentDispName)
        {
        	el.title = parentDispName +"."+ fieldTitle;
        }
        else
        {
        	el.title = fieldTitle;
        }
    }
    el.style.visibility="visible";
    var params = ZDBAnalysisConfig.PARAMSTOTRANSFER;
    for(var i =0,j = params.length;i < j ; i++)
    {
      if( ZDBAnalysisView.getAttributeElorObj(field, params[i]) != null)
      {
        el.setAttribute(params[i], ZDBAnalysisView.getAttributeElorObj(field, params[i]));
      }
      else
      {
        el.setAttribute(params[i],"");
      }
    }
    var elViewType = el.getAttribute("VIEWTYPE");
    if(elViewType == "YAXIS" || elViewType == "GROUP")
    {
        params = ZDBAnalysisConfig.ANALGRIDPARAMS;
        for(var i =0,j = params.length;i < j ; i++)
        {
          if(ZDBAnalysisView.getAttributeElorObj(field, params[i]) != null)
          {
            el.setAttribute(params[i], ZDBAnalysisView.getAttributeElorObj(field, params[i]));
          }
          else
          {
            el.setAttribute(params[i],"");
          }
        }
    }

    //$$SS DON'T CHANGE THIS LOGIC UNLESS IT IS CHANGED IN SERVER SIDE.
    if(el.getAttribute("FILTER_OPERATION")!="" && el.getAttribute("FILTER_OPERATION")!=null && viewType == "FILTERAXIS")
    {
      el.setAttribute("OPERATION",el.getAttribute("FILTER_OPERATION"))
      el.removeAttribute("FILTER_OPERATION");
    }
    //$$SS DON'T CHANGE THIS LOGIC UNLESS IT IS CHANGED IN SERVER SIDE.

    var addontype = el.getAttribute("addontype");
    var operation = el.getAttribute("OPERATION");
    if(drgNDrp==true)
    {
        var defoper = view.dropAreas[viewType].getAttribute("DEFAULT"+addontype);
      if(defoper != null)
      {
        operation = defoper;
        el.setAttribute("OPERATION",operation);
      }
    }
    if(view.dropAreas) // for widget drop areas will not be available
    {
        // this has to be originaldata type, otherwise operationwill be overriden for other types
        var defOp = ZDBAnalysisView.getPropeOpByType(el,view.dropAreas[viewType],view);
        operation = defOp!=null ? defOp : operation;
    }
    el.setAttribute("OPERATION",operation);
    if(!ZDBAnalysisView.setOperationOnField(el,el.getAttribute("OPERATION"),viewType,null,view))
    {
      //$$ Hack since field name(display name of the dropped field area) is not available
      if(viewType == "TEXTAXIS")
      {
        viewType = "Data"; //No I18N
      }
      if(addontype == "ABSDATECATEGORICAL") //No I18N
      {
        addontype = "DATE"; //No I18N
      }
      var errMsg = ZDBI18NMap.f("zrpt.chartview.zdbalertmsg.js.dropColErr", addontype, viewType);
      ZDBAlertAPI.showMsg(errMsg);
      return null;
    }
    return el;
  }

ZDBAnalysisView.getPropeOpByType = function(field,dropArea,view,defOpr)
{
    var odt = field.getAttribute("origdatatype");
    if(odt == "GEO" || odt == "GEO_NUM" || field.getAttribute("operation")=="GEO")
    {
        var addontype = field.getAttribute("addontype");
        var viewType = dropArea.getAttribute("VIEWTYPE");
        var defoper = field.getAttribute("OPERATION");
        defoper = defoper==null ? dropArea.getAttribute("DEFAULTGEO"+addontype) : defoper;
        if((viewType=="YAXIS" || viewType=="XAXIS") && (view.type == "AnalysisView"))
        {
             defoper=  defoper=="GEO"&&!ZDBAnalysisView.isGeoOpAllowedFortheField(odt,viewType,view) ? dropArea.getAttribute("DEFAULTALTGEO"+addontype)  : defoper; //NO I18N
        }
        else
        {
           defoper= dropArea.getAttribute("DEFAULTGEO"+addontype);
        }
        return defoper;
    }
    // when moved a text with geo to another pannel
//    if(defOpr==null && field.getAttribute("operation")=="GEO")
//    {
//        var addontype = field.getAttribute("addontype");
//        dropArea.getAttribute("DEFAULTGEO"+addontype);
//        defoper = dropArea.getAttribute("DEFAULTGEO"+addontype);
//        return defoper;
//    }
    return null;
}
ZDBAnalysisView.setOperationOnField = function(field,operation,viewType,subtype,view)
{
    field.setAttribute("OPERATION",operation);
    if(ZDBAnalysisView.isDateSysOperation(operation))
    {
        operation="YDC" //NO I18N
    }

  if(subtype!=null)
  {
  field.setAttribute("SUBTYPE",subtype)
  }
  var opEl = null;
  if(!ZDBAnalysisFuncMenu.funcMenuBox)
  {
      ZDBAnalysisFuncMenu.funcMenuBox = ZDBAnalysisView.funcMenuBox;
  }

  var els = ZDBAnalysisFuncMenu.funcMenuBox.getElementsByTagName("a");
  var dbColName=field.getAttribute('dbcolname')== ZDBConst.DYNAMIC_COL_NAME;
        if(dbColName)
        {
            operation="AGG_FORMULA"; //No I18N
            field.setAttribute("OPERATION",operation);
            var showValueAs=field.getAttribute('showvalueas');
            
            if(showValueAs==undefined || showValueAs==null || showValueAs=="")
                {
                    showValueAs=0;
                }
           
            for(var i = 0,j = els.length; i < j;i++)
            {
                var curEl = els[i];
                var oper = curEl.getAttribute("OPERATION");
                var curShowVal=curEl.getAttribute("SHOWVALUEAS");
                if((oper == operation) && showValueAs==curShowVal)
                {
                    opEl = curEl;
                    break;
                }
            } 
        }
        else
        {
            for(var i = 0,j = els.length; i < j;i++)
            {
                var curEl = els[i];
                var alAxis = curEl.getAttribute("ALLOWEDAXIS");
                var oper = curEl.getAttribute("OPERATION");
                if((oper == operation) && ((alAxis == null) || (alAxis.indexOf(viewType) > -1)))
                {
                    opEl = curEl;
                    break;
                }
            }
        }

  if(opEl!=null)
  {
    if(field.getAttribute("SUBTYPE")==null || field.getAttribute("SUBTYPE")=="")
    {
      if(opEl.getAttribute("DEFOPERATIONTYPE") != null)
      {
        field.setAttribute("SUBTYPE",opEl.getAttribute("DEFOPERATIONTYPE"));
      }
    }
    if(field.operation)
    {
                if(dbColName)// == ZDBConst.DYNAMIC_COL_NAME)
                {
                   field.operation.innerHTML =opEl.getAttribute('abbrev');
                    if(viewType=="FILTERAXIS")
                    {
                       field.dropDownIcon.className = ''
                    }
                    else
                    {
                       field.dropDownIcon.className = 'dropDownMenuImg'; 
                    }
        
                }
      else
      {
    	var dispVal = ZDBAnalysisView.getDateAggDispValue(operation);
    	field.operation.innerHTML =dispVal ? dispVal : opEl.getAttribute('abbrev');
        field.dropDownIcon.className = 'dropDownMenuImg'; //No I18N
      }
    //field.operation.innerHTML = ZDBEscapeUtil.encodeForHtml(opEl.getAttribute("abbrev"));
    }
    
    var opElDtype = opEl.getAttribute("DTYPE");
    if(opElDtype!=null)
        {
            field.setAttribute("DTYPE",opElDtype);
        }
    return true;
  }
}


ZDBAnalysisView.prototype.getDroppedFields = function(dropArea)
{
  var no_droppedFields = this.currentList.length;
  var count=0;
  var fields=new Array();
  for(i=0; i<no_droppedFields; i++)
  {
    var viewType = this.currentList[i].getAttribute("viewtype");
    if(viewType == dropArea)
    {
      fields[count]=this.currentList[i];
      count++;
    }
  }
  return fields;
}


ZDBAnalysisView.prototype.getDroppedFieldsLength = function(dropArea)
{
  var no_droppedFields = this.currentList.length;
  var count=0;
  var fields=new Array();
  for(i=0; i<no_droppedFields; i++)
  {
    var viewType = this.currentList[i].getAttribute("viewtype");
    if(viewType == dropArea)
    {
      count++;
    }
  }
  return count;
}


ZDBAnalysisView.prototype.removeField = function(field,updateGraphArea)
{
  if(!this.editMode)
  {
    return;
  }
  ZDBUtil.removeFromSet(this.currentList,field);
 
  if(field.parentNode != null)
  {
    field.parentNode.removeChild(field);
   this.updateAddedFields();
  }
  var instKey = field.getAttribute("INSTKEY");
  if(this.curListProp[instKey])
  {
	  delete this.curListProp[instKey];
  }
  if(this.propSet)
  {
    var strIdx = 1;
    for(var i=1; i<5; i++)
    {
        var propName = PropSettings.CHART_THRESHOLD_NAME+strIdx;
        var tholdObj = this.propSet[propName];
        if(tholdObj)
        {
            for(var instId in tholdObj)
            {
                if(instId === instKey) {
                    EditThreshold.deleteProp(this, propName);
                }
                else {
                    strIdx++;
                }
            }
        }
        else
        {
            break;
        }
    }
  }
  if(updateGraphArea == true)
  {
    ZDBAnalysisView.showRefreshDiv(this);
  }
  var viewType = field.getAttribute("VIEWTYPE");
  if(viewType)
  {
    var dropArea = this.dropAreas[viewType];
    var childElCount = jQuery(dropArea).children().length;
    if(childElCount == 0)
    {
    	var dropAreaEl = DOMUtils.getSelfOrParentWithAttrValue(dropArea,"elname","dropArea");//NO I18N
    	var dropAreaHintTxt = DOMUtils.getFirstMatchingChild(dropAreaEl,"div","elname","dropAreaHintTxt");//NO I18N
    	var filterFields = DOMUtils.getParentWithAttrValue(dropArea,"elname","filterFields");//NO I18N
    	if(filterFields)
    		{
    			var clearAllFilters = DOMUtils.getFirstMatchingChild(filterFields,"div","elname","clearAllFilters");//No I18N
    			if(clearAllFilters)
					{
						clearAllFilters.style.display="none";
					}
    		}
    	if(dropAreaHintTxt)
    		{
    			dropAreaHintTxt.style.display="";
    		}
    }
    ZDBAnalysisView.expandDropField(dropArea);
     ZDBAnalysisView.setListHeight(null, dropArea,true,0);
    ZDBAnalysisView.enableDropFieldExp(dropArea);
    if(dropArea.offsetHeight==parseInt(dropArea.style.minHeight,10)&&(ZDBAnalysisView.expDropArea))
    	{
    		ZDBAnalysisView.expDropArea.expanded=false;
    	}
  }
}

ZDBAnalysisView.prototype.updateAddedFields = function()//Left panel list status will be updated.
{
	var fieldHolder = this.analysisFieldHolder;
	var fieldList = fieldHolder.getElementsByTagName("DIV");
	var no_droppedFields = this.currentList.length;
	var no_fields = fieldList.length;
	var className = "";
	DROPLISTFOR: for(i=0; i<no_fields; i++)
	{
		var curFieldListEl = fieldList[i];
    if(curFieldListEl.getAttribute("column_id") == null){continue;}
		className = "ZDBDNDFieldUncheck"; //No I18N
		ZDBUtil.setNamedChildEls(curFieldListEl,curFieldListEl);
		for(j=0; j<no_droppedFields; j++)
		{
			if((curFieldListEl.getAttribute("column_id")==this.currentList[j].getAttribute("column_id"))  //No I18N
                            && !(this.currentList[j].getAttribute("VIEWTYPE")=="FILTERAXIS"))//No I18N
			{
				className="ZDBDNDFieldChecked"; //No I18N
				continue;
			}
		}
		if(curFieldListEl.fieldTitle)
    {
      curFieldListEl.fieldTitle.style.fontWeight = (className=="ZDBDNDFieldChecked")?"bold":"normal"; //No I18N
    }
		curFieldListEl.checkMark.className = className;
	}

}

ZDBAnalysisView.showGeoOpList = function(fieldEl,view)
{
    var viewType = fieldEl.getAttribute("VIEWTYPE");
    var odt = fieldEl.getAttribute("origdatatype");
//    var op = fieldEl.getAttribute("OPERATION");
    var isGeo = odt === "GEO" || odt === "GEO_NUM"; //NO I18N
    if(!isGeo)
    {
        if(odt!="PLAIN"&&odt!="DECIMAL_NUMBER") //NO I18N
        {
            return false;
        }
    }
    if(viewType=="YAXIS")
    {
        var geoSiblings = jQuery(fieldEl).siblings("div[operation='GEO']").length; //NO I18N
        return jQuery(view.dropAreas.XAXIS).find("div[operation='GEO'][addontype='CATEGORICAL']").length < 1 
                && geoSiblings < 1;
    }
    else if(viewType=="XAXIS")
    {
//        return odt=="GEO" ?  jQuery(view.dropAreas.YAXIS).find("div[operation='GEO']").length< 1 : true ;//NO I18N
        return (odt=="GEO_NUM"|| odt=="DECIMAL_NUMBER") ? jQuery(view.dropAreas.YAXIS).find("div[operation='GEO']").length<=1 //NO I18N
                            : jQuery(view.dropAreas.YAXIS).find("div[operation='GEO']").length<1;//NO I18N
    }
    else
    {
        return false;
    }
}
ZDBAnalysisView.isGeoOpAllowedFortheField = function(odt,viewType,view)
{
    if(viewType=="YAXIS")
    {
        return jQuery(view.dropAreas.XAXIS).find("div[operation='GEO'][addontype='CATEGORICAL']").length < 1 
                            && jQuery(view.dropAreas.YAXIS).find("div[operation='GEO']").length < 1;
    }
    else if(viewType=="XAXIS")
    {
        return odt=="GEO" ? jQuery(view.dropAreas.YAXIS).find("div[operation='GEO']").length<1 : true; //NO I18N
    }
    else
    {
      return false;
    }
}
