//$Id$

function ZDBAnalysisView(configDiv,viewCtx,editMode,fieldsCacheable)
{
  this.showShiftHelpFilter = true;
  this.showShiftHelpVMFilter = true;
  this.fieldsCacheable = fieldsCacheable;
  this.haveAllInvolvedTablesReadPermission = configDiv.getAttribute("haveAllInvolvedTablesReadPermission") || false;
  this.modified = 0;
  this.sendCounter = 0;
  this.logCounter = 0;
  this[ZATaskConstants.LAZYLOAD_TASK_KEY] = new Array();

  this.eModeHelper = (!viewCtx.isStandAlone())? window.ZDBAnalysisEditViewMode:window.ZADummyEditMode;

  ZDBClientViewAPI.initFromDiv(this,configDiv);
  this.merge= configDiv.getAttribute("MERGE") || false;
  this.oldConfig = "";
  this.receivedCounter = 0;
  this.dropSpace = ZDBGlobal.getDropSpace();

  this.currentList = new Array();
  this.curListProp = {};
  this.legDetInfo = [];
  this.currentListLen = 0;
  this.VMFiltersList = new Array();
  this.dropAreas = null;
  this.graphSelected= configDiv.getAttribute("graphType");
  this.enableSumSubTot= ("true" === configDiv.getAttribute("enableSumSubTot"));
  this.isERDGEnable= ("true" === configDiv.getAttribute("isERDGEnable"));
  this.dbNullVal = (configDiv.getAttribute("dbNullVal") != null) ? configDiv.getAttribute("dbNullVal") : null;
  this.userGrpSel = configDiv.getAttribute("userGrpSel") ? configDiv.getAttribute("userGrpSel")  : "BEST" ;//No I18N
  this.userSubGrpSel = configDiv.getAttribute("userSubGrpSel") ? configDiv.getAttribute("userSubGrpSel")  : "DEF" ;//No I18N
  this.subGraphType = configDiv.getAttribute("subGraphType")== null?"DEF":configDiv.getAttribute("subGraphType");//No I18N
  this.joinType = configDiv.getAttribute("joinType")  == null? 1 :configDiv.getAttribute("joinType");
  this.changedJoinType=this.joinType

  this.editMode=editMode;
  this.legend= (this.type=="AnalysisView");
  this.VMFilterCritValDiv = document.createElement("div");
  this.requestAllowed = true; // will be used for Pivot & Summary
  this.frmTitle = null;
  this.frmDescription = null;
  this.chartWidth=null;
  this.chartHeight=null;
  this.firstTime=true;
  this.isNoLegendSelected = false;
  this.defautViewStatus = false;
  this.changeSliderBoundaries = true;
  this.rowGrandSummary = ("true" == configDiv.getAttribute("rowGrandSummary"));
  this.colGrandSummary = ("true" == configDiv.getAttribute("colGrandSummary"));
  this.colSubTotal = ("true" === configDiv.getAttribute("colSubTotal"));
  this.rowSubTotal = ("true" == configDiv.getAttribute("rowSubTotal"));//Row Sub Total Logic
  this.sortVal = 0; // 0-asc, 1-desc
  this.sortAxis="NONE"; //NO I18N
  this.customBaseId=null;
  this.customSort=false;
  this.legendCustomSortId=null;
  this.legendCustomSort=false;
  this.initialize();
  this.graphFields.style.display="block";
  this.legendPos = viewCtx.getConfig("LP") || configDiv.getAttribute("legendPos");//No I18N
  this.VMFilter = viewCtx.getConfig("showVMfilter"); //NO I18N
  this.legendFilterEnable = ("true" ==  configDiv.getAttribute("legendFilter"));
  this.legendTitleModified = ("true" == configDiv.getAttribute("legendTitleModified"));
  this.legendTitleValue = (this.legendTitleModified) ? configDiv.getAttribute("legendTitle") : null;
  this.isVMFilterApplied = false;
  this.vmFilterListCatch = new Array();
  this.columnInfo = null;
  this.drillDet = {};
  this.zacf = ZACF.getZACFInst();
  this.oldGraphSelected = null;
  this.colsModifiedIdx = {};
  this.multipleColPanels = {AnalysisView:["YAXIS","GROUP","FILTERAXIS"],//NO I18N
                               Pivot :["XAXIS","YAXIS","TEXTAXIS","FILTERAXIS"],//NO I18N
                               SummaryView:["YAXIS","GROUP","FILTERAXIS"]}; //NO I18N

  this.handleConfig(configDiv);

  this.objKey = configDiv.getAttribute("objKey");
  if(this.objId < 0 && !(this.objKey != null))
  {
    this.modified = 1;
  }

  if(viewCtx.isStandAlone())
  {
    this.analysisArea.className = "ZDBAVWkParentStandalone";
  }
}

ZDBAnalysisView.prototype.setSubTotalFunc = function()
{
	var view = this;
	jQuery(".zdbdragfield").each(function()//NO I18N
	{
		if(jQuery(this).attr("showtotalasfunc"))
		{
			view.showTotalAs = view.showTotalAs == null ? new Array() : view.showTotalAs;
			var instKey = jQuery(this).attr("instkey");//NO I18N
			var type    = jQuery(this).attr("showtotalasfunc"); //NO I18N
			view.showTotalAs[instKey] = type;
		}
	});
}

ZDBAnalysisView.prototype.isUnpersistedView = function()
{
    return this.objKey != null;
}

ZDBAnalysisView.prototype.handleStaticPropSet = function(propSetUtil)
{
	if(this.typeValue == ZDBClientViewAPI.TYPE_ANALYSISVIEW && propSetUtil)
    {
        this.title = propSetUtil.getPropValue(PropSettings.CHART_TITLE,PropSettings.STATIC_PROP,PropSettings.STRING_PROPTYPE);
        var desc = propSetUtil.getPropValue(PropSettings.CHART_DESCRIPTION,PropSettings.STATIC_PROP,PropSettings.STRING_PROPTYPE);
        if(desc != null)
        {
            this.description = desc;
        }
    }
    var dashBoardDiv = this.viewCtx.dashChildDiv;
    var title = ZDBEscapeUtil.encodeForHtml((this.title) ? this.title : this.displayName);
    var desc = ZDBEscapeUtil.encodeForHtml((this.description) ? this.description : "");
    if(dashBoardDiv != null)
    {
        dashBoardDiv.dlgTitle.innerHTML = title;
        dashBoardDiv.dlgTitle.setAttribute("tip", title);
        dashBoardDiv.dlgTitle.setAttribute("onmouseover", "ZDBToolTip.checkLengthAndShow(this, event);");
        dashBoardDiv.dlgTitle.setAttribute("onmouseout", "ZDBToolTip.hide();");

        dashBoardDiv.dlgDesc.innerHTML = desc;
        dashBoardDiv.setAttribute("descLength", desc.length != 0 ? 'true' : 'false');
        dashBoardDiv.dlgDesc.setAttribute("tip", desc);
        dashBoardDiv.dlgDesc.setAttribute("onmouseover", "ZDBToolTip.checkLengthAndShow(this, event);");
        dashBoardDiv.dlgDesc.setAttribute("onmouseout", "ZDBToolTip.hide();");
    }
    else if(this.toolbar)
    {
      ZDBMenu.updateViewTitleNDesc(this);
    }
}

ZDBAnalysisView.prototype.removeView = function()
{
//    delete this;
}

ZDBAnalysisView.prototype.setModified = function()
{
  if(!this.permissions.designModify || ZDBClientUI.standAlone){return;}
  this.modified = 1;
  this.viewCtx.updateModified();
}

ZDBAnalysisView.defaultView = function(view)
{
  view.eModeHelper.chartActionToolbar("disable",view);//No I18N
  if(view.defautViewStatus==true)
  {
    ZDBAnalysisView.showRefreshDiv(view);
    view.refreshDiv.style.display="none";
    view.chartArea.className ="AnalysisChartArea";
    return;
  }
  view.chartArea.innerHTML="";
  var defaultView = ZDBAnalysisView["default"+view.type].cloneNode(true);
  defaultView.style.display="block";

  ZDBAnalysisView.showRefreshDiv(view);
  view.chartArea.appendChild(defaultView);
  view.refreshDiv.style.display = "none";
  view.chartArea.className ="AnalysisChartArea"
  view.defautViewStatus=true;
}


ZDBAnalysisView.initialize = function()
{

  if(!this.defaultAnalysisView)
  {
    //open a dashboard and drop an analysis view, below els will not be loaded and ref is null. Then create a new analysis view, js error throws becoz of the ref is null.
    this.defaultAnalysisView = rem$("defaultAnalysisView");
    this.defaultPivot = rem$("defaultPivot");
    this.defaultSummaryView = rem$("defaultSummaryView");
  }

  if(this.initialized)
  {
     return;
  }

  this.analysisRefreshDiv = rem$("ZDBAnalysisRefresh");
  this.joinInfoDIV=   rem$("ZDBJoinInfoDlg");
  if(this.joinInfoDIV){
    ZDBUtil.setNamedChildEls(this.joinInfoDIV , this.joinInfoDIV);
  }

  ZDBVUDataAPI.viewUDDiv = rem$("ZDBViewUDDlg");
  this.analysisViewTpl = rem$("ZDBAnalysisViewTpl");
  ZDBAnalysisConfig.propTypes = JSON.parse(this.analysisViewTpl.getAttribute("propTypes"));

  this.graphFieldTpl=rem$("ZDBGraphFieldTpl");
  this.graphFieldTpl.id="";
  ZDBUtil.removeNonElements(this.graphFieldTpl);

  this.chartViewHolder=rem$("ChartViewHolder");
  this.chartViewHolder.id="";
  ZDBUtil.removeNonElements(this.chartViewHolder);

  this.VMFilterFieldTpl = rem$("ZAVMFilterFieldTpl");
  this.VMFilterFieldTpl.id="";
  ZDBUtil.removeNonElements(this.VMFilterFieldTpl);

  ZDBAnalysisView.filterFieldTpl=rem$("ZDBFilterFieldTpl");
  ZDBUtil.removeNonElements(ZDBAnalysisView.filterFieldTpl);

  this.newViewDlg = rem$("ZDBNewAnalysis");
//  ZDBAnalysisFuncMenu.funcMenuBox=rem$("ZDBFuncMenuBox");
  this.funcMenuBox=rem$("ZDBFuncMenuBox");
  ZDBAnalysisFuncMenu.numSubFuncMenuBox = rem$("ZDBNumSubFunc");
  ZDBAnalysisFuncMenu.numSubFuncChartMenuBox = rem$("ZDBNumSubFuncChart");
  ZDBAnalysisFuncMenu.numSubFuncChartMenuBoxWithDisableMenu = rem$("ZDBNumSubFuncChartWithDisableMenu");
  ZDBAnalysisFuncMenu.dateSubFuncMenuBox = rem$("ZDBDateSubFunc");
  ZDBAnalysisFuncMenu.rangeSubFuncMenuBox = rem$("ZARangeSubFunc");
  ZDBAnalysisFuncMenu.dataFieldSelectBox = $("ZDBDataFields");
  ZDBAnalysisFuncMenu.minMaxDateSubFuncMenuBox = rem$("ZDBMinMaxDateSubFunc");
  ZDBAnalysisFuncMenu.geoSubFuncChartMenuBox = rem$("ZDBGeoSubFunc");
  ZDBAnalysisFuncMenu.geoNumSubFuncChartMenuBox = rem$("ZDBGeoNumSubFunc");

 // Moving Calculation Related Fields
  ZDBAnalysisFuncMenu.basedOnSelectBox = $("ZDBBasedOnFields");
  ZDBAnalysisFuncMenu.previous=$("ps");
  ZDBAnalysisFuncMenu.next=$("nt");
  ZDBAnalysisFuncMenu.nullchk=$("nullvalue");
  ZDBAnalysisFuncMenu.centerchk=$("currentvalue");
  ZDBAnalysisFuncMenu.TypeOfCalculation=$("ZDBTypeOfCalc");
  ZDBAnalysisFuncMenu.movingCalcDlg = rem$("ZDBMovingCalcDialog");

  ZDBAnalysisFuncMenu.dataFieldSelectDlg = rem$("ZDBDataFieldsDlg");

  this.graphBtnName = {AnalysisView:ZDBI18NMap.g("zrpt.common.analysis.refresh.js.graph"),//No I18N
                       Pivot:ZDBI18NMap.g("zrpt.common.analysis.refresh.js.pivot"),//No I18N
                       SummaryView:ZDBI18NMap.g("zrpt.common.analysis.refresh.js.summary")};//No I18N
  ZDBAnalysisView.initZohoCharts();
  this.initialized = true;
}

ZDBAnalysisView.prototype.initialize = function()
{
  if(this.initialized)
  {
    return;
  }
  this.chartHighlighterObj = new Object();
  this.dropAreas = new Object();
  this.drawnSVGObj = new Object();
  this.analysisArea = ZDBAnalysisView.analysisViewTpl.cloneNode(true);
  this.analysisArea.view = this;
  this.viewComp = this.analysisArea;//New view model
  ZDBUtil.setNamedChildEls(this.analysisArea,this);
  var parNode = this.generalAnalysisFields.parentNode;
  parNode.removeChild(this.generalAnalysisFields);
  parNode.removeChild(this.pivotFields);
  if(this.summaryViewFields)
  {
    parNode.removeChild(this.summaryViewFields);
  }

  this.chartHighlighterObj.svgContainer = $("ZDBSVGCONTAINER").cloneNode(true);
  this.chartHighlighterObj.svgContainer.removeAttribute("id");
  this.filterTabSelected = false;
  this.subGraphTypes = {PIE:"DEF", BAR:"DEF", SBR:"DEF", WEB:"DEF", SCATTER:"DEF",  //No I18N
                             MAPSCATTER:"DEF",MAPAREA:"DEF",MAPBUBBLE:"DEF",MAPPIEBUBBLE:"DEF" ,MAPPIE:"DEF" , LINE:"DEF", AREA:"DEF", TABLE_CHART:"DEF", COMBO:"BAR"}; //No I18N
  if(this.type == "Pivot")
  {
    this.chartProp = {};
    this.graphFields =  this.pivotFields;
  }
  else if(this.type == "SummaryView")
  {
    this.chartProp = {};
    this.graphFields =  this.summaryViewFields;
  }
  else
  {
    this.graphFields = this.generalAnalysisFields;
  }

  this.refreshDiv = ZDBAnalysisView.analysisRefreshDiv.cloneNode(true);
  this.refreshDiv.className = "showGraphRefresh";

  parNode.appendChild(this.graphFields);
  ZDBUtil.setNamedChildEls(this.analysisArea,this.dropAreas,"VIEWTYPE");
  delete this.dropAreas["VIEWTYPESet"];
  ZDBUtil.removeNonElements(this.filterNav);
  this.eModeHelper.updateFieldsList(this);
  this.initialized = true;
}




ZDBAnalysisView.prototype.updatePVCritColSettings = function(criteria , value)
{
    var modified = false;
    var view = this;
    if(view.type=="Pivot")
    {
        var pvCritPropInfo = view.pvCritPropInfo;
        for(var i=0, j = pvCritPropInfo.length; i < j; i++)
        {
            var criteriaVal = pvCritPropInfo[i]["CRITERIA"];
            if(criteriaVal && criteriaVal == criteria)
            {
                if(pvCritPropInfo[i]["COLSIZE"] != value)
                {
                    modified = true;
                    pvCritPropInfo[i]["COLSIZE"] = value;
                }
                return modified;
            }
        }
        if(!modified && value != 150)
        {
          var newVal = {};
          newVal["CRITERIA"] = criteria;
          newVal["COLSIZE"] = value;
          pvCritPropInfo[pvCritPropInfo.length] = newVal;
            modified = true;
        }
    }
    return modified;
}

ZDBAnalysisView.prototype.setInstMap = function(instMap)
{
    var newInstMap = new Object();
    for(var i=0, j=instMap.length; i<j; i++)
    {
        newInstMap[instMap[i][0]] = instMap[i][1];
    }
    this.instMap = newInstMap;
}


ZDBAnalysisView.prototype.setRevInstMap = function(revInstMap)
{
    var newrevInstMap = new Object();
    for(var i=0, j=revInstMap.length; i<j; i++)
    {
        newrevInstMap[revInstMap[i][0]] = revInstMap[i][1];
    }
    this.revInstMap = newrevInstMap;
}

ZDBAnalysisView.prototype.setMissValCol = function(isShowMissingValueAllowed,allowedMissValColInXAxis,allowedMissValColInYAxis,duplicateAllowedColMapInXAxis,duplicateAllowedColMapInYAxis,errMsg)
{
  this.isShowMissingValueAllowed    = isShowMissingValueAllowed;
  this.allowedMissValColInXAxis     = allowedMissValColInXAxis;
  this.allowedMissValColInYAxis     = allowedMissValColInYAxis;
  this.duplicateAllowedColMapInXAxis  = duplicateAllowedColMapInXAxis;
  this.duplicateAllowedColMapInYAxis  = duplicateAllowedColMapInYAxis;
  if(errMsg)
  {
    ZDBMsgBox.showInfo(errMsg);
  }
}

ZDBAnalysisView.prototype.setZAVCIProp = function(vciVals)
{
    var view = this;
    if(view.type=="Pivot" && view.modified)
    {
        var vciMap = new Object();
        for(var i=0, j= vciVals.length; i<j; i++)
        {
            vciMap[vciVals[i][0]] = vciVals[i][1];
        }
        var currentList = this.currentList;
        for(var i1 = 0, j1 = currentList.length; i1<j1; i1++)
        {
            var sc = currentList[i1].getAttribute("SORTCRITERIA");
            if(vciMap[sc])
            {
                currentList[i1].setAttribute("SORTCRITERIA", vciMap[sc]);
            }
        }
    }
}

ZDBAnalysisView.prototype.setPVCritProp = function(pvpVals)
{
    var view = this;
    if(view.type=="Pivot" && view.modified)
    {
        view.pvCritPropInfo  = [];
        var len = pvpVals.length;
        for(var i=0; i< len; i++)
        {
            var childEl = {};
            childEl["CRITERIA"] = pvpVals[i][0];
            childEl["COLSIZE"] = pvpVals[i][1];
            view.pvCritPropInfo[view.pvCritPropInfo.length] = childEl;
        }
    }
}

ZDBAnalysisView.prototype.removePVCritColSettings = function(criteria)
{
    var pvCritPropInfo = this.pvCritPropInfo;
    if(pvCritPropInfo && pvCritPropInfo.length >  0)
    {
      for( var i = 0; i < pvCritPropInfo.length; i++)
    {
        var curNode = pvCritPropInfo[i];
        if(curNode)
      {
          var criteriaVal = curNode["CRITERIA"];
                if(criteriaVal)
                {
                    for(var k = 0, l = criteria.length; k < l; k++)
                    {
                        if(criteria[k] != null && criteriaVal.indexOf(criteria[k]) > -1)
                        {
                            delete curNode;
                            break;
                        }
                    }
                }
      }
    }
    }

    var list = this.currentList;
    for(var i=0, j = list.length; i < j; i++)
    {
        if(list[i] != null && list[i].getAttribute("SORTCRITERIA") != null)
        {
            for(var k=0, l = criteria.length; k < l; k++)
            {
                 if(criteria[k] != null && list[i].getAttribute("SORTCRITERIA").indexOf(criteria[k]) >  -1)
                 {
                     list[i].removeAttribute("SORTTYPE");
                     list[i].removeAttribute("SORTCRITERIA");
                     break;
                 }
            }
        }
    }
}

ZDBAnalysisView.prototype.setGridObj = function(gridObj)
{
  if(this.gridObj != null)
  {
    ZDBDataGrid.removeInstance(this.gridObj.ID);
  }

  this.gridObj = gridObj;
  if(gridObj != null)
  {
    gridObj.viewObj = this;
  }

}

ZDBAnalysisView.prototype.setChartDimensions = function()
{
  var workArea = this.workArea;
  workArea.style.visibility = "hidden";
  workArea.style.display = "";
  var graphFieldHolder = this.graphFieldHolder;
  var grphAddOnHolder = this.grphAddOnHolder;
  this.drillDownFlow.style.display = "";
  if(!(this.zrsDrillObj && (this.zrsDrillObj.drillLevel != "0"))) {
    this.drillDownFlow.style.display = "none";
  }
//    this.drillDownFlow.style.visibility = "hidden";
  var viewCtx = this.viewCtx;


  var navig = viewCtx.getNavigPlHolder(this);
  var attSwipeArea = this.attachedSwipeArea;
  var parNode = workArea.parentNode;
  parNode.style.visibility = "hidden";
  parNode.style.display = "";
  var title = ZDBEscapeUtil.encodeForHtml((this.title) ? this.title : this.displayName);
  var desc = ZDBEscapeUtil.encodeForHtml((this.description) ? this.description : "");
  var dashBoardDiv = this.viewCtx.dashChildDiv;
  if(dashBoardDiv != null){
	  dashBoardDiv.dlgTitle.innerHTML = title;
      dashBoardDiv.dlgDesc.innerHTML = desc;
      if(this.viewCtx.dashView.dashLayout){
//    	  dashBoardDiv.dlgBody.style.height = "calc(100% - "+dashBoardDiv.titleDescArea.offsetHeight+"px)";
    	  dashBoardDiv.dlgBody.style.height = "100%";
//    	  DashUtils.dashChildAutoHeight(dashBoardDiv);
    	  dashBoardDiv.dlgBody.style.height = "calc(100% - "+dashBoardDiv.titleDescArea.offsetHeight+"px)";
      }
  }
  else if(this.toolbar)
  {
    ZDBMenu.updateViewTitleNDesc(this);
  }
//  var width = (viewCtx.dashView)?(parseInt(viewCtx.dashChildDiv.dlgBody.style.width)):parNode.parentNode.clientWidth;
//  //
  ZAVMFilter.showMoreLessOption(this, !(this.editMode));
//  var height = (viewCtx.dashView)?(parseInt(viewCtx.dashChildDiv.dlgBody.style.height)):parNode.parentNode.clientHeight;
  //$#Dash#$ 
  var width = (viewCtx.dashView) ? parNode.clientWidth : parNode.parentNode.clientWidth;
  //$#Dash#$ 
  var height = (viewCtx.dashView) ? parNode.clientHeight : parNode.parentNode.clientHeight
  var offset = 0;
  var insets = (viewCtx.dashView) ? ((this.type == "AnalysisView") ? 5: 9 ) : 5;
  var wMargin = (this.type == "AnalysisView") ? 0: 5 ;
  if((ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState) && this.editMode == true)
  {
    var aStyle = attSwipeArea.style;
    aStyle.height=height + "px";
    aStyle.display = "";
    offset = parseInt(aStyle.width);
  }
  else
  {
    attSwipeArea.style.display = "none";
  }

  var cWidth = width - offset;
  graphFieldHolder.style.width =  cWidth + "px" ;
  graphFieldHolder.style.left=offset + "px";
    var navigHeight = 0 ;
    if(navig && navig.isNavig)
    {
        var navigEl = navig.el;
        navigEl.style.top = graphFieldHolder.offsetHeight+parseInt(jQuery(this.dropAreaPanel).css("top"))+grphAddOnHolder.offsetHeight - 5 + "px";
        navigHeight = (ZDBGlobal.IS_MOBILE) ? 0 : ((this.gridObj && !this.gridObj.showHideNavToolBar) ? 0 : 20);
        //In a dashboard in Ipad, to align a table with pivot navig comp navigheight is used
        //Not needed in IOS case.
    }
    parNode.style.width = "100%";
  parNode.style.height = "100%";
  var parHeight = parNode.parentNode.clientHeight;
  var parWidth = (viewCtx.dashView)?width:parNode.parentNode.clientWidth;
  parNode.style.width = parWidth+"px";
  parNode.style.height = parHeight+"px";
  if(!this.editMode)
  {
    ZAVMFilter.showMoreLessOption(this,true);
  }

  var wTop = graphFieldHolder.offsetHeight+parseInt(jQuery(this.dropAreaPanel).css("top"))+grphAddOnHolder.scrollHeight + 5 + navigHeight;//NO I18N
  var wHeight = (height - wTop);
  var wWidth = (viewCtx.dashView)? width : (cWidth - insets);
  wWidth += (viewCtx.dashView)? 0 : 5;
  var wStyle = workArea.style;
  wStyle.height = wHeight + "px";
  wStyle.width = wWidth + "px";
  if(this.editMode)
  {
    wStyle.top= wTop + "px";
    wHeight = wHeight - 5;
  }
  else
  {
    wStyle.top= wTop - 8 + "px";//aligning at top in dashboard for pivot and summary
  }
  wStyle.left = offset + "px";
  wStyle.visibility = "visible"
  parNode.style.visibility = "visible";
  this.chartWidth = (width < 250)? 250:parseInt(wWidth);
  var cHeight = height;
  if("IGOOGLE" == viewCtx.getConfig("PSRC"))
  {
    cHeight = parseInt(0.8 * this.chartWidth);
  }
  cHeight = (cHeight < 150)? 150:wHeight;//minimum Graph Height
  var chartIMG = this.chartArea.chartIMG;
  if(chartIMG)
  {
    chartIMG.setAttribute("usemap","");
  }
  parNode.style.width = "100%";
  parNode.style.height = "100%";
  var parHeight = parNode.parentNode.clientHeight;
  //$#Dash#$ commented for New Layout
//  var parWidth = (viewCtx.dashView)?width:parNode.parentNode.clientWidth;
//  parNode.style.width = parWidth +"px";
//  parNode.style.height = parHeight -20 +"px";
  //$#Dash#$ commented for New Layout
  this.chartHeight = parseInt(cHeight);
}

ZDBAnalysisView.prototype.save = function(requestOptions)
{
  var canSave = this.eModeHelper.validateView(this);
  if(canSave==false)
  {
    return;
  }
  if(!ZDBUtil.isViewModified(this))
  {
    ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.resaveInfo"));
    return;
  }
  if(ZDBUtil.isNewView(this))
  {
    if(!this.newName && !ZDBCreateViewAPI.getNameForNewView(this,requestOptions))
    {
      return;
    }
    this.displayName= this.newName;
    this.description= this.newDesc;
    this.folderId = this.folderId;
  }
  this.saveCurrentConfig(requestOptions);
}

ZDBAnalysisView.prototype.getViewParams = function()
{
   var params = "";
   if(ZDBUtil.isNewView(this))
   {
      params += "&PARENTVIEWID=" + this.parentViewId;//No I18N
      if(this.isUnpersistedView())
      {
    	  params += "&OBJKEY=" + this.objKey;		//NO I18N
      }
   }
   else
   {
      params += "&OBJID=" + this.objId;//No I18N
   }
   params += this.viewCtx.getAdditionalParams();
   return params;
}

ZDBAnalysisView.prototype.saveCurrentConfig=function(requestOptions)
{
   if((!this.permissions.designModify==1) && (!this.permissions.createChildReports==1)){return;}
   if(ThemeComponent.isThemesDialogueOpen)
	   {
	   ThemeComponent.pivotThemeDialogue.updateCurrentConfigToThemeProp();
	   }
   var xml = ZDBAnalysisConfig.getConfig(this,true);
   AjaxAPI.sendRequest({URL:"/ZDBVisualAnalysisAction.ma?ZDBACTION=SAVEANALYSIS&VMOD=true&OBJTYPE=" + this.type +  // NO I18N
                             this.getViewParams(),
                              REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},//No I18N
                              POSTBODY:xml,
                              OPSTATUSID:this.viewCtx.isZia ? 'ZDBMainLoader' : ZDBClientUI.selectedTab.tabIcon,//NO I18N
                              VIEW:this,
                              ONSUCCESSFUNC:ZDBAnalysisView.handleSave,
                              ONFAILUREFUNC:ZDBCreateViewAPI.handleViewSaveFailure,
                              ISNEWVIEW:(ZDBUtil.isNewView(this)),
                              ORIGREQOPTIONS:requestOptions});
}



ZDBAnalysisView.handleSave = function(response,requestOptions)
{
  var view = requestOptions["VIEW"];
  if(view.viewCtx.isZia){
	  ZRSZia.handleSaveSuccess(response, requestOptions);
	  return;
  }
  ZDBCreateViewAPI.handleViewSave(response,requestOptions);
  
  var folderId = view.folderId;
  ZDBNavigation.openFolderWithFolderId(folderId);
  if(!ZDBGlobal.intergrated && !ZDBClientUI.standAlone && !requestOptions["ISNEWVIEW"])
  {
    ZDBNavigation.renameObj(view.displayName,view.objId,view.description);
  }
  if(requestOptions["ISNEWVIEW"])
  {
    view.permissions.designModify = 1;
    view.chartDescEl.innerHTML=ZDBEscapeUtil.encodeForHtml(view.description);
    if(view.gridObj)
    {
      view.gridObj.objId = view.objId;
      view.gridObj.parentViewId = view.parentViewId;
    }
  }
  if(view.fieldsController && view.fieldsController.model.baseTable != view.parentViewId)
  {
    view.checkNSendTblColInfoReq();
  }
}


ZDBAnalysisView.prototype.checkListNContinue = function()
{
  if(this.currentList.length == 0 && this.VMFiltersList.length==0 && !ZAFilterMenu.checkIfStringCriteriaPresent() )
  {
    ZDBAnalysisView.defaultView(this);
    return false;
  }
  else
  {
      var enable ='enable';//NO I18N
	  if(this.modified && this.isViewRefreshed == 0){
        enable = 'disable';//NO I18N
    }
    this.eModeHelper.chartActionToolbar(enable,this);
    return true;
  }
}

ZDBAnalysisView.prototype.refreshView = function()
{
  this.setChartDimensions();
  if(this.editMode != true && this.isNoLegendSelected)
  {
      return;
  }
  if(ThemeComponent.isThemesDialogueOpen)
  {
	  ThemeComponent.pivotThemeDialogue.updateCurrentConfigToThemeProp();
  }
  this.loaded = false;
  var checkListNotEmpty = this.checkListNContinue();
  if(checkListNotEmpty==false)
  {
    return false;
  }
   if(this.eModeHelper.validateView(this)==false)
  {
      return false;
  }
  this.chartArea.className ="AnalysisChartArea";
  ZDBAnalysisView.closeRefreshDiv(this);
  ZAVMFilter.checkAndUpdateDefaultValue(this);
  if(this.typeValue == ZDBClientViewAPI.TYPE_ANALYSISVIEW)
  {
    this.drawnSVGObj = new Object();
    if(this.graphSelected!="TABLE_CHART")
    {
      this.refreshGraph();
    }
    else
    {
      ZDBAnalysisView.tableChart(this);
    }
  }
  else if(this.typeValue == ZDBClientViewAPI.TYPE_PIVOT)
  {
    this.pivotView();
    ZDBAnalysisView.disableShowHideSubTotal(this);
    ZDBAnalysisView.disableSortButton(this, $("ZAPvtSort"));
  }
  else if(this.typeValue == ZDBClientViewAPI.TYPE_SUMMARY)
  {
    this.summaryView();
    ZDBAnalysisView.disableShowHideSubTotal(this);
  }
  this.defautViewStatus = false;
}

ZDBAnalysisView.disableSortButton = function(view, sortBtn)
{
  if(!sortBtn){
    return;
  }
  if(view.viewCtx.isStandAlone() || !view.permissions.designModify)
  {
    return;
  }
  var xAxisList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","XAXIS");//No I18N
  var yAxisList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","YAXIS");//No I18N
  if(xAxisList.length==0 && yAxisList.length==0){
    sortBtn.style.display = "none";
  }
  else{
     sortBtn.style.display = "";
  }
}

ZDBAnalysisView.disableShowHideSubTotal = function(view)
{
  if(view.viewCtx.isStandAlone() || !view.permissions.designModify)
  {
    return;
  }
    var isPivot = (view.type === "Pivot");
  if(isPivot || view.type==="SummaryView")
  {
    var currentList=view.currentList;
    var dataAxis =  isPivot ? "TEXTAXIS" : "GROUP";//No I18N
    var textAxisList = ZDBUtil.getElementsWithAttribute(currentList, "viewType",dataAxis);//No I18N
    var showHideToolMenu;
    if(isPivot)
    {
        showHideToolMenu = $("PivotShowhideSubTotal");
    }
    else
    {
        showHideToolMenu = $("SummaryShowhideSubTotal");
        showHideToolMenu.style.display = view.enableSumSubTot ? "" : "none";
    }
    if(textAxisList.length == 0)
    {
      showHideToolMenu.setAttribute("enabled","false");
      DOMUtils.addCSSClass([showHideToolMenu],"notpermitted");
      if(showHideToolMenu.onclick != null)
        {
          showHideToolMenu.onclickorig = showHideToolMenu.onclick;
        }
        showHideToolMenu.onclick = null;
    }
    else if(textAxisList.length > 0)
    {
      showHideToolMenu.setAttribute("enabled","true");
      DOMUtils.removeCSSClass([showHideToolMenu],"notpermitted");
      if(showHideToolMenu.onclick == null && showHideToolMenu.onclickorig != null)
      {
        showHideToolMenu.onclick = showHideToolMenu.onclickorig;
      }
    }
  }
}

ZDBAnalysisView.setModifyAndRefreshView = function(view)
{
        view.setModified();
        view.refreshView();
 }

ZDBAnalysisView.getAggregateAxis = function(view)
{
    var aggAxis = "Y"; //No I18N
    var chartObj = view.chartObj;
    var isMapChart= view.graphSelected.match(/^(MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE|MAPPIEBUBBLE)$/);
    if(chartObj) {
        aggAxis = (chartObj.isHorizontalChart() && !isMapChart) ? 'X' : 'Y'; //No I18N
    }
    else if(view.chartSelectedEl) {
        aggAxis = view.chartSelectedEl.aggAxis;
    }
    return aggAxis;
}

ZDBAnalysisView.sendAggregateAxis = function(view)
{
    if(view.graphSelected === "BUBBLE")
    {
        var isMultiY = false;
        var list = view.currentList;
        var count = 0;
        for(var i=0; i<list.length; i++)
        {
            var type = list[i].getAttribute("viewtype");
            if(type === "YAXIS") {
                count++;
            }
            if(count > 1)
            {
                isMultiY = true;
                break;
            }
        }
        return isMultiY ? false : true;
    }
    return false;
}

ZDBAnalysisView.prototype.refreshGraph = function(onSuccess)//for handling chart preview in Setting Inline Tab
{
    var viewModified = ZDBUtil.isViewModified(this);
  if((!viewModified) && ((this.legendCritInfo && this.legendCritInfo.length > 0) || this.confModified))
  {
    viewModified = true;
  }

  var viewCtx = this.viewCtx;
  ZDBAnalysisView.closeRefreshDiv(this);
//  ZAVMFilter.checkAndUpdateDefaultValue(this);
  var xml = ZDBAnalysisConfig.getCurrentConfig(this,true);
  var standAlone = viewCtx.isStandAlone();
  var aggAxis = "";
  if(standAlone && !ZDBAnalysisConfig.sendCompleteInfo(this) && (ZDBAnalysisView.sendAggregateAxis(this)
		  || (this.graphSelected === "BUBBLE" && this.oldGraphSelected !== "BUBBLE" //NO I18N
          || this.graphSelected === "MAPBUBBLE" && this.oldGraphSelected !== "MAPBUBBLE" //NO I18N
          || this.graphSelected === "MAPPIEBUBBLE" && this.oldGraphSelected !== "MAPPIEBUBBLE" //NO I18N
          ))) {
      aggAxis = "&AGGAXIS=" + ZDBAnalysisView.getAggregateAxis(this); //No I18N
  }
  var publishSrc = viewCtx.getConfig("PSRC");//No I18N
  var viewParams = this.getViewParams();
  var wmsCheck = (ZDBGlobal.wmsJSURL && !ZDBGlobal.IS_APP_REQ) ? "&WMS=true" : ""; //No I18N
  var height = (this.chartHeight < 40) ? 40 : this.chartHeight;
  var oLap = this.overlap ? "&OVERLAP=true" : ""; //No I18N
  oLap = ""; // handle overlap in next milestone
  var daoKey = this["DaoKey"];
  var url = "/ZAChartView.ve?CHARTVIEWACTION=CHARTVIEW&height="+ height + "&width=" + this.chartWidth  //No I18N
                             +"&legend="+this.legend + viewParams   //No I18N
                             +"&STANDALONE="+standAlone  //No I18N
                             +"&EDITMODE=" + (this.editMode == true)  //No I18N
                             + aggAxis + wmsCheck
                             +"&LP=" + this.legendPos+"&CHANGESLIDERBOUNDS="+this.changeSliderBoundaries + oLap; //No I18N
 if(ZDBGlobal.isQAEnabled && ZDBClientUI.disableTiles)
 {
     url +="&DISABLE_TILES="+ZDBClientUI.disableTiles; //NO I18N
 }
  if(publishSrc)
  {
    url += "&PSRC=" + publishSrc;//No I18N
  }
  if(!this.changeSliderBoundaries && this.changedCol!=null)
  {
    url += "&CHANGEDCOLDETAILS="+encodeURIComponent(this.changedCol); //NO I18N
  }
  var condn = (viewModified || this.IsVMFilterApplied);
  url += condn ? "&VMOD=" + condn : ""; //No I18N
  url += daoKey ? "&DAOKEY="+ daoKey : "";//NO I18N
  if(!onSuccess) //for handling chart preview in Setting Inline Tab
  {
      onSuccess = ZDBAnalysisView.placeChart;
  }
  if(this.cacheTime) //this.forceRefresh
  {
    url += "&FORCEREFRESH=" + true; //No I18N
  }
  var view = this;
  this.graphRequestID = setTimeout(function(){
                                    view.sendGraphViewRequest(url,xml,onSuccess)
                                    },0);

  this.eModeHelper.chartActionToolbar("enable",this);//No I18N
  this.eModeHelper.updateFilterInfo(this);
  if(this.zrsDrillObj && this.zrsDrillObj.drillLevel > 0) {
      ZRSDrillDown.disableSettings(this);
  }
}

ZDBAnalysisView.prototype.sendGraphViewRequest = function(url,xml,onSuccess)
{
    AjaxAPI.sendRequest({URL:url,POSTBODY:xml,
    REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},//No I18N
    ONFAILUREFUNC:ZDBAnalysisView.handleFailure,
    VIEW:this,
    VIEWMODSTAT:this.modified,
    SENDCOUNTER:++this.sendCounter,
    ONSUCCESSFUNC:onSuccess,
    OPSTATUSID:this.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.analysis.js.generate_rpt"))//No I18N
    });
    if(this.graphRequestID){
        clearTimeout(this.graphRequestID);
     }
}

ZDBAnalysisView.prototype.resizeView = function()
{
   if(this.gridObj != null)
   {
     this.gridObj.resizeGrid(this.chartArea.offsetWidth,this.chartArea.offsetHeight);
     if(this.typeValue === ZDBClientViewAPI.TYPE_ANALYSISVIEW && !this.viewCtx.isZia)
     {
         this.handleStaticPropSet();
     }
   }
   else if(this.chartObj && !this.chartObj.sendReq && !this.overlap)
   { // for js chart - no need for refreshing
       if(this.chartObj.drillSelected)
       {
           this.refreshView();
           this.chartObj.drillSelected = false;
       }
       else
       {
//    	   ZDBAnalysisView.removeTickLabelNLegendForZia(this);
    	   this.chartObj.redrawZohoCharts();
       }
   }
   else if(this.typeValue === ZDBClientViewAPI.TYPE_ANALYSISVIEW)
   {//Should be a chart view!!.
       if(!this.overlap || (this.overlap && this.chartObj.isSizeModified()))
       {
        this.refreshView();
     }
  }
};

//ZDBAnalysisView.removeTickLabelNLegendForZia = function(view, data){
//	if(view.viewCtx.isZia){
//		data = data ? data : view.chartObj.getData();
//		if(view.viewCtx.removeTickLabel && data.chart.axes){
//			if(data.chart.axes.xaxis){
//				ZDBAnalysisView.processTickLabels(data.chart.axes.xaxis, true);
//			}
//			if(data.chart.axes.yaxis){
//				data.chart.axes.yaxis.forEach(function(yaxisObj){
//					ZDBAnalysisView.processTickLabels(yaxisObj, true);
//				});
//			}
//			if(data.legend){
//				data.legend.enabled = false;
//			}
//		}
//		else if(!view.viewCtx.removeTickLabel && data.chart.axes){
//			if(data.chart.axes.xaxis){
//				ZDBAnalysisView.processTickLabels(data.chart.axes.xaxis, false);
//			}
//			if(data.chart.axes.yaxis){
//				data.chart.axes.yaxis.forEach(function(yaxisObj){
//					ZDBAnalysisView.processTickLabels(yaxisObj, false);
//				});
//			}
//			if(data.legend){
//				data.legend.enabled = true;
//			}
//		}
//	}
//}

ZDBAnalysisView.processTickLabels = function(axis, remove){
	axis.ticklabel = axis.ticklabel ? axis.ticklabel : {};
	axis.ticklabel.fontSize = remove ? 0 : 12;
	axis.tickmark = axis.tickmark ? axis.tickmark : {};
	axis.tickmark.strokeWidth = remove ? 0 : 1;
}

ZDBAnalysisView.handleSheetFailure = function(response,requestOptions)
{
	var view = requestOptions["VIEW"];
	if(view.viewCtx.dashView)
	  {
	    var dashView = view.viewCtx.dashView;
	    if(dashView.gridRender && dashView.gridRender.reportRespCount && !dashView.editMode)
	    	{
	    dashView.gridRender.reportRespCount--;
	    ZDBReportDashUtil.checkAndAppendToDOM(dashView);
	    	}
	  }
	ZDBAnalysisView.handleFailure(response,requestOptions);
}

ZDBAnalysisView.handleFailure = function(response,requestOptions)
{
   var view = requestOptions["VIEW"];
   if(view.viewCtx.isZia){
       ZRSZia.handleViewLoadingFailure(response,requestOptions);
       return;
   }
   PropSettings.restoreBackUpProp(view);
   if(view.viewCtx.dashView)
  {
    var dashView = view.viewCtx.dashView;
    dashView.updateRespStatus(view);
  }
  ZDBAnalysisView.closeRefreshDiv(view);
  if(view.drillDownFlow && view.zrsDrillObj)
  {
      view.zrsDrillObj.criteria = "";
      var drillLevel = parseInt(view.zrsDrillObj.drillLevel);
      if(drillLevel > 0) {
          view.zrsDrillObj.drillLevel = drillLevel - 1;
      }
      if(drillLevel == 1)
      {
        var drillDownFlow = view.drillDownFlow;
        ZDBUtil.setNamedChildEls(drillDownFlow, drillDownFlow, "drillEl");
          ZDBUtil.removeAllUnwanted(drillDownFlow.bcArea, "span"); //No I18N
        jQuery(drillDownFlow).hide();
          drillDownFlow.style.display = "none";
      }
  }
  AjaxAPI.onFailureFunc(response,requestOptions);
}

ZDBAnalysisView.createProperties = function(view)
{
  if((view.typeValue == ZDBClientViewAPI.TYPE_ANALYSISVIEW || view.typeValue == ZDBClientViewAPI.TYPE_PIVOT) && view.propSet && !view.viewCtx.isZia)
    {
      var propSetUtil = new ZDBPropSetUtil(view);
      view.handleStaticPropSet(propSetUtil);
    }
}

ZDBAnalysisView.isViewRendering = false;

ZDBAnalysisView.placeChart = function(response,requestOptions)
{
//  ZDBContentCache.appendAndGet("Filter_List_User","GridMenu",document.body);
  var view = requestOptions["VIEW"];
  if(view.chartObj)
	  {
	  	var graphType = view.chartObj.getChartType();
	    var isGeoChart = (graphType === ZCHARTCONST.get("MAPSCATTER") || graphType === ZCHARTCONST.get("MAPBUBBLE")|| graphType === ZCHARTCONST.get("MAPAREA") || graphType === ZCHARTCONST.get("MAPPIE") || graphType === ZCHARTCONST.get("MAPPIEBUBBLE") );
	  	if(!isGeoChart)
	  	{
	  		view.chartObj.destroy();
	  	}
	  }
  view.chartArea.innerHTML = "";
	view.isViewRefreshed = parseInt(requestOptions.VIEWMODSTAT) + 1;
  PropSettings.removePropSet(view);
  var tabView = (view.viewCtx.dashView)?view.viewCtx.dashView:view;
  var func = function(){ZDBAnalysisView.placeChart(response, requestOptions);};
  if(!ZDBTabSwitchHandler.isRelevendTab2Exec(tabView,func))
  {
    return;
  }
  var respJSON = JSON.parse(response.responseText);
  if(view.viewCtx.dashView)
  {
    var dashView = view.viewCtx.dashView;
    ZDBDashboard.viewLoaded = true;
    if(respJSON.oldCacheTime)
    {
      dashView.maxCacheTime = ZDBUtil.maxTime(respJSON.oldCacheTime,dashView.maxCacheTime);
    }
    dashView.updateRespStatus(view);
  }
  ZDBUtil.setCacheTime(view,respJSON.oldCacheTime);
  if(!view.viewCtx.dashView)
  {
    ZDBUtil.ShowHideForceRefresh(view);
  }
  view.chartHighlighterObj.positioned = null;
  var receivedView = requestOptions["SENDCOUNTER"];
  if(receivedView <= view.receivedCounter)
  {
    return;
  }
  if(view.viewCtx.dashView)
  {
    view.viewCtx.dashView.animatingViewWaiting++;
  }
  view.setGridObj(null);
  view.receivedCounter  = receivedView;
  var chartViewHolder = ZDBUtil.getCloneNode(ZDBAnalysisView.chartViewHolder);
  chartViewHolder.style.display = "";
  view.chartArea.appendChild(chartViewHolder);
  ZDBUtil.setNamedChildEls(chartViewHolder, chartViewHolder);
  view.chartViewHolder = chartViewHolder;
  if(respJSON.chartMetaInfo != null)
  {
    for(var val in respJSON.chartMetaInfo)
        {
            if(respJSON.chartMetaInfo.hasOwnProperty(val))
            {
                view[val] = respJSON.chartMetaInfo[val];
            }
        }
  }

  if (respJSON["DaoKey"] != null) {
		view["DaoKey"] =respJSON["DaoKey"];
	}
    var seqKey = respJSON[ZATaskConstants.SEQ_KEY];
    if(seqKey)
    {
        view[ZATaskConstants.SEQ_KEY] = seqKey;
        view[ZATaskConstants.LAZYLOAD_TASK_KEY] = respJSON[ZATaskConstants.LAZYLOAD_TASK_KEY];
    }
	view["lblDrillarr"]=null;
	view["clrDrillarr"]=null;
	if(respJSON["lblDrillarr"] != null)
	{
		view["lblDrillarr"] = respJSON["lblDrillarr"];
	}
	if(respJSON["clrDrillarr"] != null)
	{
		view["clrDrillarr"] = respJSON["clrDrillarr"];
	}
	view["lbldefdrillCol"]= respJSON["lbldefdrillCol"];
	view["clrdefdrillCol"]= respJSON["clrdefdrillCol"];


//  ZDBAnalysisView.removeTickLabelNLegendForZia(view, data);
  ZDBAnalysisView.chartPlaced(view);
  view.csvExpView=(!view.metaInfo)? false : view.metaInfo.CSVEXPVIEW;
  ZASliderComp.sliderRangesForGridView(view.sliderComp,view);

  if(!view.isShowMissingValueAllowed)
  {
    view.isShowMissingValueAllowed = false;
  }

  if(view.propSet)
  {
    ZDBAnalysisView.createProperties(view);
  }

  if(view.DrillPath)
  {
    DrilldownConfig.updateChartDrillDet(view);
  }
  if(view.receivedCounter == view.sendCounter)
  {
    if(view.dataMsg != null)
    {
      var dataMsg = view.dataMsg;
      ZDBMsgBox.showInfo(dataMsg);
      view.dataMsg = null;
    }
  }
  ZDBAnalysisView.displayMsg(view);
  view.chartHighlighterObj.positioned = false;
  ZAVMFilter.addVMFilterToDashIfNeeded(view);
  view.zacf.setData(view.zaf);
  ZRSDrillDown.updateViewDrillDet(view);
  view.viewJSON = respJSON.chartJSON;
  if(ZALazyLoadData.getTaskCount(view) === 0) {
    ZDBAnalysisView.generateChart(view);
  }
  else {
    ZALazyLoadData.taskCheck(view, ZATaskConstants.TASK_CHECK_COUNTER, requestOptions["OPSTATUSID"]);
  }
};

// generate chart once all the data (including lazy load data) is received
ZDBAnalysisView.generateChart = function(view)
{
    var chartObj = new ZohoCharts(view, view.chartViewHolder.chartHolder, view.viewJSON);
    chartObj.initialize();
    view.chartObj = chartObj;
    chartObj.createChart();
    if(!view.chartObj.getLegendModel()) {
        view.legendCritInfo = null ;
    }
    view.loaded = true;
};

ZDBAnalysisView.displayMsg = function(view)
{
  if(view.fromVW)
  {
    ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.FromVW"));
  }
  if(view.aggInParMsg && view.editMode)
  {
    ZDBMsgBox.showInfo(view.aggInParMsg);
  }
  if(view.missedValFails)
  {
    ZDBMsgBox.showInfo(view.missedValFails);
  }
};

ZDBAnalysisView.initZohoCharts = function()
{
	window.showDrillMenuJS = ZDBContextMenu.showDrillMenuJS;
	window.lblClickJS = ZDBAnalysisView.lblClickJS;
	window.drillDownJS=ZDBAnalysisView.drillDownJS;
	window.dynamicDrillDownJS = ZADynamicDrillList.dynamicDrillDownJS;
};

ZDBAnalysisView.tableChart = function(view)
{
  var canContinue = view.eModeHelper.validateView(view);
  if(canContinue==false)
  {
    return;
  }
  view.sheetView("AnalysisSheet");//No I18N
}

// on clicking tick label, drill down to show next level chart
ZDBAnalysisView.lblClickJS = function(event, params) {
	var selectedEl = ZDBUtil.getSourceElement(event);
	var view = ZDBClientUI.getViewObj(selectedEl, "view");
	if (view === null) {
		return;
	}
	var criteria = ZDBVUDataAPI.getCriteria(event, params, null, true);
	view.lblcriteria = criteria ;
	var drilldisablecheck = ((ZDBGlobal.isDynDrillEnabled && !view.drillDet.isXYDynDrillable )||( !ZDBGlobal.isDynDrillEnabled  && !view.drillDet.isXYDrillable));
	if(view.editMode ||(!view.permissions.drilldown) || !view.drillDet.isChartDrillable ||  drilldisablecheck)
	{
	  ZDBAnalysisView.lblVUDClick(event);
	  return;
	}
	ZDBContextMenu.showChartDrillMenu(selectedEl,view,event,true);
};
ZDBAnalysisView.drillDownJS = function(event, params) {
	var selectedEl = ZDBUtil.getSourceElement(event);
	var view = ZDBClientUI.getViewObj(selectedEl, "view");
	if (view === null || view.editMode) {
		return;
	}
	var criteria = view.lblcriteria;
	if(criteria==null)
    {
	criteria =  ZDBVUDataAPI.getCriteria(event, params, null, true);
    }
	if(!view.drillDet.isXYDrillable)
	{
		ZDBUtil.stopEventBubble(event);
		return ;
	}
	var dispVal = criteria;
	ZDBAnalysisView.setBreadCrumb(view, dispVal);
    new ZRSDrillDown(criteria, view, "LABELDRILL", dispVal); // NO I18N
	view.refreshView();
	ZRSDrillDown.disableSettings(view);
};
ZDBAnalysisView.drillDownEl = function(selectedEl) {
	ZDBAnalysisView.drillDown(null, selectedEl);
}

ZDBAnalysisView.drillDown = function(event,selectedEl)
{
  if(!selectedEl)
  {
    if(event === null){event = window.event;}
    selectedEl = ZDBUtil.getSourceElement(event);
  }

  var view = ZDBClientUI.getViewObj(selectedEl,"view") ;
  var labelDrillEl = DOMUtils.getSelfOrParentWithAttrValue(selectedEl,"entityType","drillarea");//NO I18N
  var axisEl= selectedEl.getAttribute("axistype")!=null;
  if(ZDBGlobal.IS_MOBILE && view.svgElement)
  {
      selectedEl = view.svgElement;
      view.svgElement = null;
  }

  if(view === null || view.editMode || axisEl)
  {
    if(labelDrillEl)
    {
      return;
    }
    ZDBAnalysisView.chartClickVUD(selectedEl);
    return;
  }
  if(!view.drillDet.isClrDrillable && ZDBGlobal.isDynDrillEnabled)
  {
	  ZDBUtil.stopEventBubble(event);
	  return ;
  }
  if(!view.drillDet.isNextDrillAllowed && !labelDrillEl)
  {
    ZDBAnalysisView.chartClickVUD(selectedEl);
    return;
  }
  var extraParams = null;
  if(view.chartObj)
  {
    extraParams = view.clrCriteria;
  }
  else
  {
    var selectedCrEl = DOMUtils.getSelfOrParentWithAttr(selectedEl, "criteria"); //NO I18N
    if(!selectedCrEl && view.graphSelected == "PIE" && view.pieCriteria)
    {
        extraParams = view.pieCriteria;
    }
    else
    {
        var ns = (selectedCrEl.getAttribute("criteria")!==null)&&(selectedCrEl.getAttribute("criteria").match("^(NS|XL|XH|YL|YH)")!==null);
        var overlapPoints = selectedCrEl.getAttribute("overlap");
        if(ns || overlapPoints)
        {
            ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.toolbar.pivot.zdbalertmsg.js.drillnotsupported"));
            return;
        }
        extraParams = selectedCrEl.getAttribute("criteria");
    }
  }
  if(extraParams=== null)
  {
    return;
  }

  var dispVal = extraParams;

  // temp append string to breadcrumb to calculate height
  ZDBAnalysisView.setBreadCrumb(view, dispVal);

  var clickType = labelDrillEl ? "LABELDRILL" : "CHARTCLICK"; //NO I18N
  new ZRSDrillDown(extraParams, view,clickType,dispVal);
  view.refreshView();
  ZRSDrillDown.disableSettings(view);
};


ZDBAnalysisView.setBreadCrumb = function(view, dispVal)
{
    var drillDownFlow = view.drillDownFlow;
    ZDBUtil.setNamedChildEls(drillDownFlow, drillDownFlow, "drillEl");
    var jBreadCrumArea = jQuery(drillDownFlow.bcArea);
    if(jBreadCrumArea.children("span").length > 0)
    {
        var span = jBreadCrumArea.children("span").show().filter(":first-child")[0].cloneNode(true); //NO I18N
        dispVal = dispVal.length > 25 ? dispVal.toString().substr(0, 25) + "....." : dispVal;
        span.innerHTML = ZDBEscapeUtil.encodeForHtml(dispVal);
        span.removeAttribute("elname");
        span.removeAttribute("keeptext");
        span.style.visibility = "hidden";
        drillDownFlow.bcClose.style.visibility="hidden";
    }
    jQuery(span).addClass("rightArrow");
    drillDownFlow.bcArea.appendChild(span);
};
ZDBAnalysisView.lblVUDClick= function(event, selectedEl)
{
	if (!selectedEl) {
	   if (event == null) {
		event = window.event;
	   }
	selectedEl = ZDBUtil.getSourceElement(event);
   }
   var view = ZDBClientUI.getViewObj(selectedEl, "view");
   // if(view == null || view.chartArea.blured === true)
   if (view == null || !view.permissions.vud || view.chartArea.blured === true) {
	return;
   }
	if (view.chartObj) {
		extraParams = view.lblcriteria;
	}
	if (extraParams == null) {
		return;
	}
	ZDBVUDataAPI.viewUD(view, extraParams);

	}



ZDBAnalysisView.chartClickVUD = function(selectedEl)
{
  ZDBAnalysisView.chartClick(null, selectedEl);
}
ZDBAnalysisView.chartClick = function(event,selectedEl)
{
  if(!selectedEl)
  {
    if(event == null){event = window.event;}
    selectedEl = ZDBUtil.getSourceElement(event);
  }
  var view = ZDBClientUI.getViewObj(selectedEl,"view");
  //if(view == null || view.chartArea.blured === true)
  if(view == null || !view.permissions.vud  || view.chartArea.blured === true)
  {
    return;
  }
  if(ZDBGlobal.IS_MOBILE && view.svgElement)
  {
      selectedEl = view.svgElement;
      view.svgElement = null;
  }
  if(selectedEl.getAttribute("criteria")== null)
  {
    var selEl = selectedEl;
    selectedEl=selectedEl.parentNode;//assumption only.
    var grpSel = view.graphSelected;
    var subGrp = view.subGraphType;
    var tagName = (selEl.tagName).toLowerCase();
    if((((grpSel=="BAR" || grpSel=="SBR") && subGrp=="3D") ||
        (grpSel=="COMBO" && (subGrp=="BAR3D" || subGrp=="SBR3D"))) && tagName == "polygon" //No I18N
        && selectedEl.getAttribute("criteria")== null) // for 3D charts, move up 1 more level
    {
        selectedEl=selectedEl.parentNode;
    }
  }
  if((selectedEl.getAttribute("criteria")!=null)&&(selectedEl.getAttribute("criteria").match("^NS") != null))
  {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.toolbar.pivot.zdbalertmsg.js.vudnotsupported"));
      return;
  }
  var labelDrillEl = DOMUtils.getSelfOrParentWithAttrValue(selectedEl, "entityType","drillarea"); //NO I18N
  if(selectedEl.getAttribute("axistype")!=null || labelDrillEl)
  {
    selectedEl.style.cursor="default";
    return;
  }
  var extraParams = selectedEl.getAttribute("criteria");
  if(view.chartObj)
  {
      extraParams = view.clrCriteria;
  }
  if(extraParams== null)
  {
    return;
  }
  ZDBVUDataAPI.viewUD(view, extraParams);
}

ZDBAnalysisView.prototype.summaryView = function()
{
  this.sheetView("SummarySheet");//No I18N
}

ZDBAnalysisView.prototype.pivotView = function()
{
  this.sheetView("PivotSheet"); // NO I18N
}

ZDBAnalysisView.prototype.sheetView = function(type)
{
  var viewModified = ZDBUtil.isViewModified(this);
  if(!viewModified)
  {
    viewModified = this.confModified;
  }
  var configInfo = this.getConfigInfo(type,null);
  var url = configInfo["REQURL"] +"&EDITMODE=" + (this.editMode == true);//No I18N
  var condn = (viewModified || this.IsVMFilterApplied);
  url += condn ? "&VMOD=" + condn : ""; //No I18N
  if(this.cacheTime)
  {
    url += "&FORCEREFRESH=" + true; //No I18N
  }
  var view = this;
  var dashRefreshCount = (view.viewCtx && view.viewCtx.dashView) ? view.viewCtx.dashView.refreshCounter : -1;
  this.sheetViewRequestID = setTimeout(function(){
                                    view.sendSheetRequest(url,configInfo,type,dashRefreshCount)
                                    },0);
}

ZDBAnalysisView.prototype.sendSheetRequest = function(url,configInfo,type,dashRefreshCount)
{
	if(this.viewCtx.dashView && this.viewCtx.dashView.refreshCounter != dashRefreshCount)
	{
		return;
	}
  AjaxAPI.sendRequest({URL: url,POSTBODY:configInfo["REQBODY"],
  REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},//No I18N
  ONSUCCESSFUNC:ZDBAnalysisView.handleSheetViewResponse ,
        ONFAILUREFUNC:ZDBAnalysisView.handleSheetFailure,
  VIEW:this,
        VIEWMODSTAT:this.modified,
  TYPESENT:type,
  SENDCOUNTER:++this.sendCounter,
  DASHREFCOUNTER:dashRefreshCount,
  OPSTATUSID:this.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.analysis.js.generate_rpt")),  //No I18N
  CONFIGINFO:configInfo});

  if(this.sheetViewRequestID){clearTimeout(this.sheetViewRequestID);}
}


ZDBAnalysisView.prototype.getConfigInfo = function(gridType,extraParams)
{
    var paramsAttr = " PARENT_VIEW_TYPE='" + this.type//No I18N
    + "' ZAGRIDTYPE='" + gridType+ "' ";//No I18N
    if(extraParams != null)
    {
        paramsAttr += extraParams;
    }
    var vudTLParam = " ";
    if(this.vudTblObjId != null)
    {
        vudTLParam =" VUDTBLOBJID='"+this.vudTblObjId+"' ";  //No I18N
    }
    var filterXML = "";
    var gridObj = this.gridObj;
    if(gridObj && gridObj.isFilterApplied)
    {
      filterXML = gridObj.getSimpleFilter(true);
    }
    var doxml = ZDBAnalysisConfig.getCurrentConfig(this,true);
    var paramsXML = "<DBSVParams " + paramsAttr + vudTLParam+" />"; //No I18N
    var xml =  "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n"//No I18N
                 +doxml+paramsXML+filterXML+"</DBSVRequest>";
    var params = this.getViewParams();

    var url = "/ZDBTableDataAction.ma?ZDBACTION=DATAVIEW&CONFIGASXML=true&OBJTYPE=AnalysisGrid"+ params+"&CHANGESLIDERBOUNDS="+this.changeSliderBoundaries; //NO I18N
    if(!this.changeSliderBoundaries && this.changedCol!=null)
    {
      url += "&CHANGEDCOLDETAILS="+encodeURIComponent(this.changedCol);  //NO I18N
    }
    var drillParams = ZRSDrillDown.getDrillParams(this);
    var configInfo = {DOXML:doxml,FILTERXML:filterXML,PARAMSATTR:paramsAttr,REQURL:url,
                      REQBODY:xml,DRILLPARAMS:drillParams};
    return configInfo;
}

ZDBAnalysisView.prototype.handleConfig = function(configDiv)
{
  var childEls = configDiv.getElementsByTagName("div");
  for(var i=0,j = childEls.length;i < j;i++)
  {
    var childEl = childEls[i];
    var elType = childEl.getAttribute("configType");
    if(elType == "ZAChartConfig")
    {//defPropSet, chartProp, pvCritPropInfo, legDetInfo
      var chartConfig = ZDBEscapeUtil.decodeForHtml(childEl.innerHTML);
      chartConfig = JSON.parse(chartConfig);
      for(var val in chartConfig)
        {
            if(chartConfig.hasOwnProperty(val))
            {
              this[val] = chartConfig[val];
            }
        }
    }
    else if(childEl.getAttribute("VIEWTYPE") != null)
    {
      var viewType = childEl.getAttribute("VIEWTYPE");
      var grpField = ZDBAnalysisView.getGraphField(this,childEls[i],viewType,
                                                 childEl.getAttribute("DISPLAY_NAME"),false);
      this.addFieldToArea(grpField,this.dropAreas[viewType],true);

      if(this.type == "AnalysisView")
      {
            this.setChartSortVal(childEl);
      }
      else
      {
          this.setSortDetails(childEl);
      }
    }
    else if(elType == "ZAVMFilter")
    {
        this.VMFilterCriteriaDiv = childEl;
    }
  }
  if(this.defPropSet)
  {
    PropSettings.createDefPropMap(this);
  }
  ZAVMFilter.placeVMFilterCriteria(this);
  ZDBAnalysisView.setSortValInList(this);
}

ZDBAnalysisView.setSortValInList = function(view)
{
  if(view.sortAxis!="NONE")
  {
      ZDBChartSort.setSortInfo(view);
  }
}

ZDBAnalysisView.refreshView = function(element, event)
{
  var view = ZDBClientUI.getViewObj(element,"view");
  if(view.drillDet && view.drillDet.drillLevel == 0) {
      ZRSDrillDown.clearDrillDet(view);
  }
  view.refreshView();
}


ZDBAnalysisView.showRefreshDiv = function(view)
{
  var viewType = view.type;
  if(viewType=="Dashboard" || viewType==="WIDGET")
  {
    view.setModified();
    return;
  }
  var chartIMG = view.chartArea.chartIMG;
  view.eModeHelper.chartActionToolbar("disable",view);//No I18N
//  view.workArea.className = "";
//  view.chartArea.className="alpha";

  view.chartArea.blured = true;
  if(chartIMG!=null)
  {
    chartIMG.setAttribute("usemap","");
  }
  var generateText = "";
  switch(viewType)
  {
   case "AnalysisView" :generateText = ZDBI18NMap.g("zrpt.common.analysis.refresh.js.graph");  //No I18N
         var gt=view.graphSelected;
        var ugt=view.userGrpSel;

       if(gt=="TABLE_CHART" || ugt=="TABLECHART") //RESET TABLE CHART
        {
            view.graphSelected="BEST";  //No I18N
           view.userGrpSel="BEST";  //No I18N
           view.userSubGrpSel="DEF";  //No I18N
            view.subGraphType="DEF";  //No I18N
        }
        break;

  case "Pivot" :generateText = ZDBI18NMap.g("zrpt.common.analysis.refresh.js.pivot");break;          //No I18N
  case "SummaryView" :generateText = ZDBI18NMap.g("zrpt.common.analysis.refresh.js.summary");break;  //No I18N
  }

  jQuery(view.refreshDiv).find(".refreshLabel").get(0).innerHTML = "<span class='graphRefresh'>&nbsp;"+ZDBI18NMap.f("zrpt.common.analysis.refresh.js.click2Generate",generateText)+"</span>";
  view.disableChartArea.style.display=(view.currentList && view.currentList.length == 0) ? "none" :"";
  view.refreshDiv.style.display="";
  view.isViewRefreshed = 0;
  view.dropAreaPanel.appendChild(view.refreshDiv);
  view.refreshDiv.style.display="";
  view.eModeHelper.updateFilterInfo(view);
  view.setModified();
}

ZDBAnalysisView.setModAndShowRefresh = function(view)
{

    view.setModified();
    ZDBAnalysisView.showRefreshDiv(view);
}

ZDBAnalysisView.closeRefreshDiv = function(view)
{
  view.chartArea.blured = false;
  view.disableChartArea.style.display="none";
  view.refreshDiv.style.display="none";
//  view.workArea.className = "zdbChartLoaderImg";
}

ZDBAnalysisView.prototype.updateView = function()
{
  this.checkListNContinue();
  // enabling Allowed Graph and icon pressed for graph Selected
  if(!ZDBClientUI.standAlone)
  {  
      ZDBAnalysisView.selectOrEnableGraphTypes(this);
      ZDBAnalysisView.mergeSplitButton(this);
  }
}

ZDBAnalysisView.prototype.getDrillDet = function()
{
  return ZRSDrillDown.getDrillParams(this);
}


ZDBAnalysisView.prototype.getConfigAsXMLForGrid = function(type)
{
    var paramsXML = "<DBSVParams  DBID='" + this.dbId + "' PARENT_VIEW_TYPE='"+this.type+"'  PARENTVIEWID='" + this.parentViewId + "'  OBJID='" + this.objId + "' ZAGRIDTYPE='"+type+"'"; //NO I18N
    paramsXML+=" />";
    var doxml = ZDBAnalysisConfig.getCurrentConfig(this,true);
    var xml = "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n"+doxml+paramsXML+"</DBSVRequest>";//No I18N
    return xml;
}
ZDBAnalysisView.prototype.getConfigAsXMLForQa= function(includeCr)
{
    var doxml = ZDBAnalysisConfig.getCurrentConfig(this,includeCr);
    var xml = "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n"+doxml+"</DBSVRequest>"; //NO I18N
    return xml;
}

ZDBAnalysisView.prototype.getCriteriaAsXMLForGrid = function(type)
{
    var xmlBuf = new ZDBStrBuf();
   ZDBAnalysisConfig.getLegendNVMFCr(this,xmlBuf);
   ZAVMFilter.getAllVMFilterCriteria(this,xmlBuf);
    var xml = "<crXml OBJID='" + this.objId + "' ZAGRIDTYPE='"+type+"'>\n"+xmlBuf+"</crXml>"; //NO I18N
    return xml;
}


ZDBAnalysisView.prototype.addOnlyChartArea = function()
{

}

ZDBAnalysisView.handleSheetViewResponse = function(response, reqOptions)
{
//  ZDBContentCache.appendAndGet("Filter_List_User","GridMenu",document.body);
  if(!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList","APPENDTODOC",ZDBAnalysisView.handleSheetViewResponse,[response,reqOptions]))
  {
    return;
  }
  var view = reqOptions["VIEW"];
  var tabView = (view.viewCtx.dashView)?view.viewCtx.dashView:view;
  var func = function(){ZDBAnalysisView.handleSheetViewResponse(response, reqOptions);}
  if(!ZDBTabSwitchHandler.isRelevendTab2Exec(tabView,func))
  {
      return;
  }
  var respText = response.responseText;
  var jsonObj = JSON.parse(respText);
  if(view.viewCtx.dashView)
  {
    var dashView = view.viewCtx.dashView;
    ZDBDashboard.viewLoaded = true;
    view.isForDash = true;
    if(!response.alreadyUpdated)
    {
      if(jsonObj.oldCacheTime)
      {
        dashView.maxCacheTime = ZDBUtil.maxTime(jsonObj.oldCacheTime,dashView.maxCacheTime);
      }
    	dashView.updateRespStatus(view);
    }

    if(reqOptions["DASHREFCOUNTER"] < dashView.refreshCounter)
   	{
    	return;
  	}
    if(dashView.isViewRendering || dashView.animatingViewWaiting > 0)
    {
    	response.alreadyUpdated = true;
    	setTimeout(func,0);
    	return;
    }
  }
  ZDBUtil.setCacheTime(view,jsonObj.oldCacheTime);
  if(!view.viewCtx.dashView)
  {
    ZDBUtil.ShowHideForceRefresh(view);
  }

 view.receivedCounter = reqOptions["SENDCOUNTER"];//Not handling it in sheet views. Used for QA.

  ZASliderComp.sliderRangesForGridView(jsonObj.sliderComp,view);
  var plHolder = view.chartArea;
  view.setChartDimensions();
  delete view.chartObj;
  view.zaf = jsonObj.zaf;
  var propSetUtil = new ZDBPropSetUtil(view);
  var zaProp = jsonObj.zaProp;
  if(zaProp)
  {
        if(zaProp.chartSelectedEl)
        {   //only selected property alone updated.
            // This is for Table chart info
            view.chartSelectedEl = zaProp.chartSelectedEl;
        }
        if(zaProp.propSet)
        {// in-order to maintain properties in Table Chart
            view.propSet = zaProp.propSet;
            ZDBAnalysisView.createProperties(view);
        }
  }
  else if(!view.viewCtx.isZia)
  {
    view.handleStaticPropSet();
  }
  var gridObj = ZDBDataGrid.parseGridResponse(null, respText, view);
  gridObj.configInfo = reqOptions["CONFIGINFO"];
  view.setGridObj(gridObj);
  if(gridObj.fromVW)
      {
          ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.FromVW"));
      }
  plHolder.gridObj = gridObj;
  if(plHolder.firstChild != gridObj.gArea)
  {
    plHolder.innerHTML = "";
  }
  view.isViewRefreshed = parseInt(reqOptions.VIEWMODSTAT) + 1;
  var size = {width:view.chartWidth,height:view.chartHeight};
  plHolder.appendChild(gridObj.gArea);
  gridObj.parNode = plHolder;
  gridObj.viewCtx = view.viewCtx;
  if(gridObj.type == "AnalysisSheet")
	  {
	  gridObj.maintainWidthArray(gridObj.colHead);
	  }
  else if(gridObj.viewCtx && gridObj.viewCtx.dashView && !gridObj.viewCtx.dashView.editMode && !gridObj.viewCtx.dashView.dashLayout)
	  {
	  gridObj.gArea.style.visibility = "hidden";//No I18N
	  }

  gridObj.showTable();
  if(gridObj.type === "PivotSheet" || gridObj.type === "SummarySheet")
  {
	  gridObj.adjustInViewPivotRowsHeight();
  }
  else
	  {
	  gridObj.adjustInViewRowsHeight();
	  }
  ZDBTableGrid.updateNavigComp(gridObj,view,view.viewCtx);
  view.eModeHelper.chartActionToolbar("enable",view);//NO I18N
  if(view.gridObj.type=="AnalysisSheet")
  {
    ZDBAnalysisView.selectOrEnableGraphTypes(view);
    ZDBAnalysisView.enableSettingBtn(view);
  }
  ZAVMFilter.addVMFilterToDashIfNeeded(view);

  var aggInParMsg = (view.editMode) ? jsonObj.viewAggParComp : null;
  if(aggInParMsg!=null)
  {
     ZDBMsgBox.showInfo(aggInParMsg);
  }
  view.loaded = true;


//if(gridObj.type == "SummarySheet"  && gridObj.totalGroupedCol > 0)
//  {
//  gridObj.chTable.children[0].children[gridObj.totalGroupedCol - 1].className += " groupRightEnd";
//  }

  if(gridObj.type != "PivotSheet" && gridObj.type != "SummarySheet")
  {
	  gridObj.adjustRowFill();
	  view.resize();
  }
  else
  {
	  if (gridObj.rhWidthArray.length > 1) {
		  gridObj.freeze = true;
	  }

	  gridObj.adjustDimension();
    gridObj.checkAndInsertHeaderAlignCssIE();
  }
  if(BROWSER.SAFARI == 1) //  to fix safari issue , safari current version only computes table layout fixed after this
  {
	  ZDBUtil.removeAndInsertJsObj(gridObj);
  }
  if(gridObj.viewCtx && gridObj.viewCtx.dashView && !gridObj.viewCtx.dashView.editMode && gridObj.type != "AnalysisSheet" && !gridObj.viewCtx.dashView.dashLayout)
  {
		  ZDBReportDashUtil.checkAndRemoveFromDOM(gridObj.viewCtx.dashView,gridObj.gArea.parentNode,gridObj.gArea);
		  ZDBReportDashUtil.checkAndAppendToDOM(gridObj.viewCtx.dashView);
  }
   if(gridObj.type == "PivotSheet")
  {
	  view.setSubTotalFunc();
  }
  if(!ThemeComponent.dbProps)
  {
    if(ZDBClientUI.fs == "ZC" || ZDBClientUI.fs == "ZP")
	  {//for integrations need to create a dummy db Props as there will be no db props
		  ThemeComponent.dbProps = new Object();
		  ThemeComponent.dbProps.PIVOT = new Object();
		  ThemeComponent.dbProps.SUMMARY = new Object();
		  ThemeComponent.dbProps.TABULAR = new Object();
	  }
	  else if(view.permissions.designModify == 1)
	  {
//		  AjaxAPI.sendRequest({ URL: "/reportsapi/db/" + ZDBClientUI.dbId + "/GETDBGRIDTHEME",PARAMETERS: "DBID=" + ZDBClientUI.dbId, ONSUCCESSFUNC: ThemeComponent.setDBProps,
//			  LAZYLOADREQ: true});
                  ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETDBGRIDTHEME', 'DBID='+ ZDBClientUI.dbId, {
                      successHandler: {
                          func: ThemeComponent.setDBProps,
                          ctx: ThemeComponent
                      },
                      LAZYLOADREQ: true
                  });
	  }
  }
}

ZDBAnalysisView.showFields = function(element , event , objId , parentViewId,level)
{

    var parDiv =  DOMUtils.getParentWithAttr(element , "analysisfieldpar"); //No I18N
    //console.log(parDiv);
    return ZDBFieldsView.refreshFields(parDiv , level);
}

ZDBAnalysisView.createChartCall = function(chartObj)
{
  chartObj.createChart();
}

ZDBAnalysisView.handleFields = function(response,requestOptions)
{

  var view = requestOptions["VIEW"];
  var fieldDiv = view.analysisFieldHolder;//requestOptions["FIELDDIV"];
  //fieldDiv.innerHTML = "";
  fieldDiv.innerHTML = response.getOnlyHtml();
  //ZDBClientUI.responseHolder.innerHTML = $("ZDBAnalysisFields").cloneNode();
  ZDBClientUI.responseHolder.appendChild($("ZDBAnalysisFields").cloneNode(true));
  fieldDiv.innerHTML = "";
  ZDBAnalysisCaching.cachedFields[view.parentViewId] = null;
  ZDBAnalysisEditViewMode.getSelectedFields(view);

   //view.analysisFieldHolder = $("ZDBAnalysisFieldHolder");
  //ZDBAnalysisEditViewMode.setFieldsDimension(view);
}

ZDBAnalysisView.prototype.resize = function(width,height)
{
  this.setChartDimensions();
  this.eModeHelper.setFieldsDimension(this);
  this.resizeView();
}

ZDBAnalysisView.prototype.setVisible = function()
{
  this.updateView();
  if(this.gridObj != null)
  {
    this.resize();
    ZDBTableGrid.updateNavigComp(this.gridObj,this,this.viewCtx);
  }
  else if(this.chartObj)
  { // for js chart - no need for refreshing
    this.resize();
  }
  if(this.fieldsTab && this.editMode)
  {
    this.eModeHelper.showFields(true,this.fieldsTab);
  }

}

ZDBAnalysisView.prototype.supportsLegend = function()
{//Should handle NONE option; for JS chart only
  return this.chartObj && this.chartObj.getLegendModel() != null;
}

ZDBAnalysisView.showPanel=function(view)
{
    ZDBUtil.stopEventBubble();
    if(view.editMode)
    {
        view.dropAreaPanel.style.display="block";
        view.graphButton.innerHTML = ZDBAnalysisView.graphBtnName[view.type];
        if(view.type == "AnalysisView")
        {
        var drillDownDemo = $("drillDownDemo");
        if(drillDownDemo)
        {
        drillDownDemo.style.display = "";
        }
        }
        ZAVMFilter.showOrHideVMFilterPanel(view);
        ZDBAnalysisView.enableDropFieldsExp(view);
        jQuery(view.analysisArea).addClass("chartEditMode");
    }
    else
    {
        view.dropAreaPanel.style.display="none";
        ZAVMFilter.showOrHideVMFilterPanel(view,true);
        jQuery(view.analysisArea).removeClass("chartEditMode");
    }
    view.setChartDimensions();
    ZDBAnalysisEditViewMode.setFieldsDimension(view);
    view.requestAllowed=true; // will be used for Pivot & Summary
    if(view.firstTime===true && view.isViewRefreshed)
    {
        view.resizeView();
    }
    else
    {
        view.refreshView();
    }
}

ZDBAnalysisView.prototype.checkNSendTblColInfoReq = function()
{
  var dbId = this.dbId;
  var parentViewId = this.parentViewId;
  var relModelId;
  relModelId = ZDBClientUtil.getJsonRelModelIdForObjId(parentViewId);
  if(relModelId != null)
  {
    var jsonData = ZDBAnalysisCaching.tblColInfo.data[relModelId];
    this.designClientViewFromJSON(this, jsonData);
    if(!jsonData.dateMinMaxCalc)
    {
      this.updateDateMinMaxRange(parentViewId,relModelId);
    }
  }
  else
  {
    ZDBAnalysisView.sendTblColInfoReq(null , this,true);
  }
}

ZDBAnalysisView.sendTblColInfoReq = function(event, view,toUpdateNavFields)
{
  if(!view)
  {
    var srcEl = ZDBUtil.getSourceElement(event);
    view = ZDBClientUI.getViewObj(srcEl, "view");
  }
  var dbId = view.dbId;
  var parentViewId = view.parentViewId;
  var params = view.viewCtx.getAdditionalParams();
  if(ZDBGlobal.integrated && (view.objId > 0))
  {
    params = params + "&OBJID="+view.objId;//NO I18N
  }
  var ZDBFieldsIterationTable = $("ZDBFieldsIterationTable");
  if(!ZDBFieldsIterationTable){
    return;
  }
  var navFieldLoader = DOMUtils.getFirstMatchingChild(ZDBFieldsIterationTable, "div", "elname","filterLoading");//NO I18N
  AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBGetDBDetAsJSON.ma?DBID="+dbId+"&PARENTVIEWID="+parentViewId+"&ZDBACTION="+"GETDBDETAILSASJSON"+params,
        ONSUCCESSFUNC:ZDBAnalysisView.handleTblColInfoResp,
        VIEW:view,
        OPSTATUSID:navFieldLoader,
        TOUDPATENAVFIELDS:toUpdateNavFields
        });
}

ZDBAnalysisView.handleTblColInfoResp = function(response, requestOptions)
{
  if(!ZDBLazyLoadUtil.loadJsAlone(["ZAAnalysisFields"],"APPENDTODOC",ZDBAnalysisView.handleTblColInfoResp,[response,requestOptions]))
    {
      return;
    }
  var view = requestOptions["VIEW"];
  var jsonResp = JSON.parse(response.responseText)[view.parentViewId];
  var ZDBFieldsIterationTable = $("ZDBFieldsIterationTable");
  var curView = ZDBClientUI.getViewObj(ZDBFieldsIterationTable, "view");
  if(view != curView)
  {
    return;
  }
  view.designClientViewFromJSON(view, jsonResp);
  var parentViewId = view.parentViewId;
  var relCount = ZDBAnalysisCaching.tblColInfo.relCount;
  var jsonData = ZDBAnalysisCaching.tblColInfo.data;
  var relKey = "r"+relCount;//NO I18N
  ZDBClientUtil.deleteJsonForObjId(parentViewId);
  ZDBAnalysisCaching.tblColInfo.data[relKey] = jsonResp;
  ZDBAnalysisCaching.tblColInfo.relModelInfo[relKey] = view.fieldsController.model.relTables;
  view.updateDateMinMaxRange(parentViewId,relKey);
  ZDBAnalysisCaching.tblColInfo.relCount = ++relCount;
}

ZDBAnalysisView.prototype.designClientViewFromJSON = function(view, jsonData)
{
  var clientModel = new ZAFieldsAdapterModel(jsonData, view);
  var clientView = new ZAFieldsView(clientModel);
  if(!clientView){
    return;
  }
  var clientController = new  ZAFieldsController(clientModel, clientView);
  clientController.updateBaseTable(view.parentViewId);
  var ZDBFieldsIterationTable = $("ZDBFieldsIterationTable");
  if(!ZDBFieldsIterationTable){return;}
    var attachedFieldsListEl = DOMUtils.getParentWithAttrValue(ZDBFieldsIterationTable,"analysisel","attachedFieldsListEl");//NO I18N
    var searchBox = DOMUtils.getFirstMatchingChild(attachedFieldsListEl,"*","elname","ZRSSearchInput");
    var clearSearchIcon = DOMUtils.getFirstMatchingChild(attachedFieldsListEl,"*","elname","ZRSSearchIcon");
    var showMoreLessIcon = DOMUtils.getFirstMatchingChild(ZDBFieldsIterationTable,"*","showmore","*");
    if(showMoreLessIcon)
    {
      showMoreLessIcon.setAttribute("showMore","false");
        showMoreLessIcon.innerHTML = ZDBI18NMap.g('zrpt.common.js.showmoretables');
    }
    searchBox.value = "";
  searchBox.setAttribute("searchStr","");
  searchBox.setAttribute("tipShown","false");
  clearSearchIcon.setAttribute("class","ZRSSearchIcon");
  ZDBSearchUtil.showTipString(searchBox);
}


ZDBAnalysisView.prototype.updateDateMinMaxRange = function(parentViewId, relKey)
{
  var jsonData = ZDBAnalysisCaching.tblColInfo.data[relKey];
  var dateMinMaxCalc = jsonData.dateMinMaxCalc;
  if(!dateMinMaxCalc)
  {
    this.sendDateMinMaxRangeReq(parentViewId, this, relKey);
  }
}

ZDBAnalysisView.prototype.sendDateMinMaxRangeReq = function(parentViewId, view, relKey)
{
  var dbId = this.dbId;
  var params = view.viewCtx.getAdditionalParams();
  if(ZDBGlobal.integrated && (view.objId > 0))
  {
    params = params + "&OBJID="+view.objId;//NO I18N
  }
  AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBGetDateMinMaxRange.ma?DBID="+dbId+"&PARENTVIEWID="+parentViewId+"&ZDBACTION="+"GETDATEMINMAXRANGE"+params,
    ONFAILUREFUNC:ZDBAnalysisView.handleDateMinMaxReqFailure,
    ONSUCCESSFUNC:ZDBAnalysisView.handleDateMinMaxRangeResp,
        VIEW:this,
        RELMODELKEY : relKey});
}

ZDBAnalysisView.handleDateMinMaxReqFailure = function(response,  requestOptions)
{
  var relModelId = requestOptions["RELMODELKEY"];
  ZDBAnalysisCaching.tblColInfo.data[relModelId].dateMinMaxCalc = true;
  return;
}

ZDBAnalysisView.handleDateMinMaxRangeResp = function(response, requestOptions)
{
  var view = requestOptions["VIEW"];
  var relKey = requestOptions["RELMODELKEY"];
  var jsonResp = JSON.parse(response.responseText);
  var jsonData = ZDBAnalysisCaching.tblColInfo.data[relKey];
  var key;
  jsonData.dateMinMaxCalc = true;
  for(key in jsonResp)
  {
    for(var colKey in jsonResp[key])
    {
      jsonData.colDet[key][colKey].OPERATION = jsonResp[key][colKey].OPERATION;
      jsonData.colDet[key][colKey].FILTER_OPERATION = jsonResp[key][colKey].FILTER_OPERATION;
      jsonData.colDet[key][colKey].FILTER_TYPE = jsonResp[key][colKey].FILTER_TYPE;
    }
  }
  view.designClientViewFromJSON(view,jsonData);
}

ZDBAnalysisView.prototype.setHidden = function()
{
  this.eModeHelper.hideFields(this);
}

ZDBAnalysisView.prototype.layoutModeChanged = function()
{
  this.eModeHelper.showFieldsIfNeeded(this);
}

ZDBAnalysisView.grphOptionSelected = function(sel, event)
{
  if(sel.getAttribute("enabled")=="false")
  {
    return false
  }

  var view = ZDBClientUI.getViewObj(sel,"view");
  view.oldGraphSelected = view.graphSelected;
  view.graphSelected =sel.getAttribute("grphType");// need to remove
  view.userGrpSel = sel.getAttribute("grphType");
  view.userSubGrpSel = sel.getAttribute("sgt");
  view.subGraphType = sel.getAttribute("sgt");
  view.isNoLegendSelected = false;
  if(view.drillDet && view.drillDet.drillLevel == 0) {
      ZRSDrillDown.clearDrillDet(view);
  }
  ZDBAnalysisUtil.displaySizeMessage(view);
  ZDBAnalysisView.checkAndRefresh(view);
};

ZDBAnalysisView.checkAndRefresh = function(view)
{
    if(view.chartObj && view.graphSelected === "COMBO")
    {
    	view.chartObj.getLegendModel().makeChangesForComboChart();
        if(view.chartObj.isModified())
        {
        	view.changeViewRConfMod(true);
        }
        return;
    }
    if(view.chartObj && view.chartObj.redrawPossible())
    {
    	var chartObj = view.chartObj;
		chartObj.changeChartType();
    	if(chartObj.isModified())
        {
            view.setModified();
		}
    }
    else
    {
    	ZDBAnalysisView.setModifyAndRefreshView(view);
    }
};

ZDBAnalysisView.enableSettingBtn = function(view)
{
  if(ZDBGlobal.integrated)
  {
   var settingBtn = $("ZDBANAL_SETTING_TIP");
   if(settingBtn)
   {
	   if(view.graphSelected == "TABLE_CHART")
	    {
	      settingBtn.className = "iconitem chartsettings alpha";
	      settingBtn.setAttribute("enabled","false");
	    }
	    else if(view.graphSelected == "WEB" && view.legendType)
	    {
	      settingBtn.className = "iconitem chartsettings alpha";
	      settingBtn.setAttribute("enabled","false");
	    }
   }
  }
}

ZDBAnalysisView.selectOrEnableGraphTypes = function(view)
{
  var chartSelectedEl=view.chartSelectedEl;
  if(chartSelectedEl != null)
  {
    var ZDBChartActionToolBar = $("ZDBChartActionToolBar");
    ZDBUtil.setNamedChildEls(ZDBChartActionToolBar,ZDBChartActionToolBar);
    var grphToolBar=jQuery(ZDBChartActionToolBar.graphToolBar);
    var allowedGraphs=chartSelectedEl.allowedGraphs.split(",");;
//    var sgts = chartSelectedEl.allowedSubGraphs ? chartSelectedEl.allowedSubGraphs : "";
//    var allowedSubGrpTypes = jQuery.isEmptyObject(sgts) ? null : JSON.parse(sgts);
    view.graphSelected = chartSelectedEl.selectedGraph;
    view.subGraphType = chartSelectedEl.subGraphType == null?"DEF":chartSelectedEl.subGraphType; //NO I18N
    var graphTypesList = grphToolBar.find('li a[grphType]');
    graphTypesList.each(function()
    {
        var el = jQuery(this);
        var grphType = el.attr('grphType'); //NO I18N
        var allowed = allowedGraphs.indexOf(grphType)>-1;
//        var show = true;
//        if(allowedSubGrpTypes && allowedSubGrpTypes[grphType])
//        {
//            var sgt=el.attr('sgt'); //NO I18N
//            allowed = show = allowedSubGrpTypes[grphType].indexOf(sgt)>-1;
//            if(show)
//            {
//                el.show();
//            }
//            else
//            {
//                el.hide();
//            }
//        }
        if(allowed)
        {
          	el.removeClass('alpha selected disabledIcon');//NO I18N
      		jQuery(el[0].children[0]).removeClass('alpha');
	        el.attr("enabled","true"); //NO I18N
       	    el.attr("onClick","ZDBAnalysisView.grphOptionSelected(this, event)"); //NO I18N
	        el.css("background-image",""); //NO I18N
        }
        else
        {
        	 el.removeClass('alpha selected').addClass('disabledIcon');//NO I18N
      		 jQuery(el[0].children[0]).addClass('alpha');
             el.attr("enabled","false"); //NO I18N
             el.attr("onClick"); //NO I18N
        }
    });
    if(view.subGraphType != "FUNNEL")
    {
      graphTypesList.filter('[grphType="'+view.graphSelected+'"]').css("background-image","none").addClass('selected'); //NO I18N
    }
  }
	if (view.type === "AnalysisView" && chartSelectedEl !== null)
    {
        ZDBChartSort.setSortMenuProp(view);
    }
}


ZDBAnalysisView.chartPlaced = function(view)
{
    if(!view.viewCtx.dashView && view.toolbar) {
        ZDBAnalysisView.selectOrEnableGraphTypes(view);
        ZDBAnalysisView.mergeSplitButton(view); 
    } else {
          var chartSelectedEl=view.chartSelectedEl;
          if(chartSelectedEl != null)
          {
                view.graphSelected = chartSelectedEl.selectedGraph;
                view.subGraphType = chartSelectedEl.subGraphType == null?"DEF":chartSelectedEl.subGraphType; //NO I18N
                if (view.type === "AnalysisView")
                {
                    ZDBChartSort.setSortMenuProp(view);
                }
          }
          if(view.metaInfo && view.metaInfo.MERGEALLOWED) {
              view.merge = view.metaInfo.MERGE;
          }
    }
    ZDBAnalysisView.showOrHideShortCuts(view.chartArea, view);
    ZDBAnalysisView.enableSettingBtn(view);
    ZDBChartSort.setProperSortAxis(view);
    ZDBChartSort.setSortDetails(view);
}

ZDBAnalysisView.showOrHideShortCuts = function(chartArea, view)
{// chartArea can be view.chartArea / previewDiv
    var nonAxisCharts = /^(PIE|WEB|MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE|MAPPIEBUBBLE)$/;
    var showSortCuts = (view.editMode && view.graphSelected.match(nonAxisCharts) === null
                                        && view.subGraphType !== "PACKEDBUBBLE"); //No I18N
    ZDBAnalysisView.showorHideSCIcons(chartArea, showSortCuts, view.sortAllowedAxis);
}

ZDBAnalysisView.showorHideSCIcons = function(chartArea, showSortCuts, sortAllowedAxis)
{
  var shortCut = {};
  ZDBUtil.setNamedChildEls(chartArea, shortCut, "shortCut");
  var childEls = chartArea.getElementsByTagName("*");
  if(childEls && childEls.length != 0)
  {//Creator UI issue fix
    ZDBAnalysisView.showOrHideShortCutIcons(shortCut, showSortCuts, sortAllowedAxis);
    if(chartArea.childNodes[0].chartHolder)
	{
    	chartArea.childNodes[0].chartHolder.style.marginLeft = showSortCuts ? shortCut.yaxis.offsetWidth + "px" : "0px"; // No I18N
	}
  }
}

ZDBAnalysisView.showOrHideShortCutIcons = function(shortCut, showSortCuts, sortAllowedAxis)
{
	if (showSortCuts)
	{
		shortCut.yaxis.style.display = "";
		shortCut.xaxis.style.display = "";
		if (sortAllowedAxis == "XAXIS")
		{
			ZDBAnalysisView.hideEditIcons(shortCut.ZDBSortingLeft);
		}
		else if (sortAllowedAxis == "YAXIS")
		{
			ZDBAnalysisView.hideEditIcons(shortCut.ZDBSortingBottom);
		}
		else
		{
			ZDBAnalysisView.hideEditIcons(shortCut.ZDBSortingLeft);
			ZDBAnalysisView.hideEditIcons(shortCut.ZDBSortingBottom);
		}
	}
	else
	{
		ZDBAnalysisView.hideEditIcons(shortCut.yaxis);
		ZDBAnalysisView.hideEditIcons(shortCut.xaxis);
	}
}

ZDBAnalysisView.hideEditIcons = function(el)
{
  if(el)
  {
    el.style.display = "none";
  }
}

ZDBAnalysisView.mergeSplitButton = function(view)
{
    var metaInfo = view.metaInfo;
    if(metaInfo==null){return;}
    var standAlone = (view.viewCtx) ? view.viewCtx.isStandAlone() : false;
    var mergeAllowed = metaInfo.MERGEALLOWED;
    var isMerged = metaInfo.MERGE;    
    if(standAlone || ZDBClientUI.notLoggedIn){
        if(!ZDBEmbed.removeToolbar) {
            var axisButton = $("splitOrMerge");
            if(axisButton.nextSibling) {axisButton.nextSibling.style.display = (mergeAllowed) ? "" : "none";}
            axisButton.style.display = (mergeAllowed) ? "" : "none";
            if(mergeAllowed) {
                var axis = (isMerged) ? "zrpt.chartview.js.splitaxis" : "zrpt.chartview.js.mergeaxis"; //No I18N
                axisButton.getElementsByTagName("span")[0].innerText = ZDBI18NMap.g(axis);
            }
        }
        ZDBMenu.resizeTitleNDesc(view.toolbar);
    }
    else {
        var mergeYAxis =  $("mergeYAxis");
        var splitYAxis = $("splitYAxis");
        if(mergeAllowed)
        {
            if(isMerged)
            {
                mergeYAxis.style.display="none";
                splitYAxis.style.display="";
            }
            else
            {
                mergeYAxis.style.display="";
                splitYAxis.style.display="none";
            }
            if(metaInfo.BETTER_SPLIT && (isMerged) && (view.editMode==true))
            {
              ZDBAnalysisEditViewMode.startHighlighting();
            }
        }
        else
        {
            mergeYAxis.style.display="none";
            splitYAxis.style.display="none";
        }
    }
    view.merge = isMerged;
}

ZDBAnalysisView.addFieldInDropArea = function(curDropArea,field)
{
    var dropSpace = ZDBGlobal.getDropSpace();
    var view = ZDBClientUI.getViewObj(curDropArea,"view");
  if(dropSpace.parentNode==curDropArea)
    {
        curDropArea.insertBefore(field, dropSpace);
    }
    else
    {
        curDropArea.appendChild(field);
    }
  var tempDropArea = DOMUtils.getSelfOrParentWithAttrValue(curDropArea,"elname","dropArea");//NO I18N
    var dropAreaHintTxt = DOMUtils.getFirstMatchingChild(tempDropArea,"div","elname","dropAreaHintTxt");//NO I18N
    if(dropAreaHintTxt)
      {
        dropAreaHintTxt.style.display="none";
      }
    ZDBAnalysisView.appendDropSpaceToBody();
    if(curDropArea.getAttribute("viewtype") == "VMFILTERCRITERIA")
    {
      var highLighEl = jQuery(curDropArea).find('[class="VMFilterCompDrgEl highLight"]')
      if(highLighEl.length >0){highLighEl.removeClass("highLight");}
      jQuery(view.VMFilterArea).removeClass("doNotHighLight");
        jQuery(field).addClass("highLight");
    }
}


ZDBAnalysisView.checkNAddDependentColumns = function(field,viewType,view)
{
    var georole = field.getAttribute("georole");
    var op = field.getAttribute("operation");
    var depColId = field.getAttribute("depgeocolid");
    if(!depColId ||  !((op=="GEO") &&(georole==ZDBUtil.geoNameVsRole.LATITUDE || georole==ZDBUtil.geoNameVsRole.LONGITUDE) && (viewType=="XAXIS" || viewType=="YAXIS")))
    {
        return;
    }

    var depField = jQuery(view.analysisFieldHolder).find("div[column_id='"+depColId+"']");
    var el = depField.find("td[elname='checkMark']")[0];
//    if the column is dropped in Xaxis, the dep will drop in Yaxis and viceversa. If the depcol is not meant to be geocolumn, then it need not to be autoadded
    var depVT = viewType=="XAXIS" ? "YAXIS" : "XAXIS";  //NO I18N
    if(!ZDBAnalysisView.isGeoOpAllowedFortheField(depField.attr("origdatatype"),depVT,view))
    {
        return;
    }
    var rule = ZDBAnalysisView.getRuleToApply(el,view);
    // if auto dropping col is not geo col then no need to add
    // if already the dependent column is dropped, no need to check dependent column
    if(rule[7]==null || (rule[7]!="XAXIS" && rule[7]!="YAXIS") || rule[8]!="GEO" || ZDBAnalysisView.matchedFieldsInList(el,view).length>0)
    {
        return;
    }
    ZDBAnalysisView.checkPanelNDrop(el,view,true);
}

ZDBAnalysisView.appendDropSpaceToBody = function()
{
    var dropSpace = ZDBGlobal.getDropSpace();
    dropSpace.style.display="";
    if(dropSpace.parentNode!=document.body){
  document.body.appendChild(dropSpace);
  }
}

ZDBAnalysisView.isMeasure = function(field)
{
    var operation = field.getAttribute ? field.getAttribute("operation").toUpperCase() : field.OPERATION; //No I18N
    var measures = {SUM:true,AVG:true,MAX:true,MIN:true,COUNT:true,STD:true,MEDIAN:true,STATS_MODE:true,CONTINUOUS:true,AGG_FORMULA:true};
    return ((measures[operation]!=null)?true:false || ZDBAnalysisView.isSysOperation(operation));
}

ZDBAnalysisView.isSysOperation = function(operation)
{
    var sysFormulaOperations = {DC:true,SD:true,VAR:true,YDC:true,QYDC:true,MYDC:true,WYDC:true,DDC:true,DTDC:true,QDC:true,MDC:true,WDC:true,WDDC:true,DMDC:true,HDC:true,MI_DATE: true,MX_DATE:true};
    return (sysFormulaOperations[operation]!=null)?true:false;
}

ZDBAnalysisView.isDateSysOperation = function(operation)
{
    var dateSysFormulaOperations = {YDC:true,QYDC:true,MYDC:true,WYDC:true,DDC:true,DTDC:true,QDC:true,MDC:true,WDC:true,WDDC:true,DMDC:true,HDC:true};
    return (dateSysFormulaOperations[operation]!=null)?true:false;
}
ZDBAnalysisView.isDateAggOperation = function(operation)
{
  var dateAggFormulaOperations ={MX_DATE:true,MI_DATE:true};
  return (dateAggFormulaOperations[operation]!=null)?true:false;
}
ZDBAnalysisView.getDateAggDispValue = function(operation)
{
  var dateAggOpVsDispValMap = {MX_DATE:ZDBI18NMap.g("zrpt.common.js.maxdate"),MI_DATE:ZDBI18NMap.g("zrpt.common.js.mindate")};
  return dateAggOpVsDispValMap[operation];
}

ZDBAnalysisView.replaceInstKey = function(view, str, isVUD)
{
    var hasVal = false;
    if(str.indexOf("-V-") != -1)
    {
        hasVal = true;
        str = str.substr("-V-".length, str.length); //No I18N
    }
    if(isVUD)
    {
        if(view.modified === 0 && view.isViewRefreshed === 2)
        {
            if(view.instMap && view.instMap[str])
            {
                str = view.instMap[str];
            }
        }
        else if(view.modified === 1 && view.isViewRefreshed === 1)
        {
            if(view.revInstMap && view.revInstMap[str])
            {
                str = view.revInstMap[str];
            }
        }
    }
    else
    {
        if(view.revInstMap && view.revInstMap[str] && (view.isViewRefreshed  != 2))	//view.modified === 1 &&
        {
        	str = view.revInstMap[str];
        }
    }
    return (hasVal ? ("-V-"+str) : str);//No I18N
}
var ZADummyEditMode = new function()
{
  this.chartActionToolbar = ZDBUtil.dummyFunc;
  this.updateFieldsList = ZDBUtil.dummyFunc;
  this.validateView = function(){return true;}
  this.showFields = ZDBUtil.dummyFunc;
  this.hideFields = ZDBUtil.dummyFunc;
  this.showFieldsIfNeeded = ZDBUtil.dummyFunc;
  this.updateFilterInfo = ZDBUtil.dummyFunc;
  this.setFieldsDimension =  ZDBUtil.dummyFunc;
}

ZDBAnalysisView.prototype.changeViewRConfMod = function(isRefresh)
{
    if(this.permissions.designModify && !ZDBClientUI.standAlone)
    {
        this.setModified();
    }
    else  // if(view.permissions.read == 1) for shared/PermaLink/iGoogle/Embed
    {
      this.confModified = true;
    }
    if(isRefresh)
    {
      this.refreshView();
    }
}
