//$Id$

var ZDBAnalysisViewAPI = new function()
{

    this.fetchView = function(objId,viewCtx,fromExpEdit)
    {
      if(viewCtx.isStandAlone())
      {
        var configDIV = $("ZDBAnalysisConfig_"+objId);
        if(configDIV != null)
        {
        	if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList","ZAVMFilterList","ZAAnalysisFields"],"APPENDTODOC",ZDBAnalysisViewAPI.fetchView,[objId,viewCtx]))
            {
                return;
            }
            urls = ["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_VMFILTERSTYLES"];//NO I18N
            if(!ZDBLazyLoadUtil.loadCssOnly(urls, "APPENDTODOC", ZDBAnalysisViewAPI.fetchView,[objId,viewCtx]))
            {
                return;
            }
            if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBAnalysisViewAPI.fetchView,[objId,viewCtx]))
            {
                return;
            }
            if (!ZDBLazyLoadUtil.loadSnippet('AnalysisFunMenu', '/AnalysisFunMenu.cc', this, 'APPENDTODOC', null, ZDBAnalysisViewAPI.fetchView, [objId,viewCtx]))
            {
                return;
            }
            ZDBLazyLoadUtil.loadExternalSVG("themes/common/svgimages/chartchooser.svg");//NO I18N
          ZDBAnalysisView.initialize();
          configDIV.id = "";
          var view = new ZDBAnalysisView(configDIV,viewCtx,false);
          viewCtx.handle(view);
          ZDBAnalysisView.showPanel(view);
          if((viewCtx.dashView==undefined || viewCtx.dashView ==null || !viewCtx.dashView.editMode)&& (view.VMFilter == "true"))
          {
            ZAVMFilter.preLoadVMFilterIfNeeded(view);
            return;
          }
          typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.addRecord(ZRCRMPlusHomePage.RECENTITEMS,view);//NO I18N
          return;
        }
      }
      var editMode = (fromExpEdit) ? true : false;
      ZDBAnalysisViewAPI.sendAnalysisViewReq(viewCtx,objId,"OBJID=" + objId,editMode,fromExpEdit);//No I18N
    }

    this.createView = function(viewCtx,type,dbId,parentViewId,parDispName,dummyObjId)
    {
      var params="&PARENTDISPNAME=" + encodeURIComponent(parDispName)  + "&PARENTVIEWID=" + parentViewId//No I18N
      + "&OBJTYPE="+type + "&OBJID=" + dummyObjId;//No I18N
      params += "&INCLUDEFIELDSLIST=" + (!ZDBAnalysisCaching.isFieldsListCached["AnalysisView"]);//No I18N
      var editMode = true;
      ZDBAnalysisViewAPI.sendAnalysisViewReq(viewCtx,dummyObjId,params,editMode);
    }

    this.sendAnalysisViewReq = function(viewCtx,objId,params,editMode,fromExpEdit)
    {
      var initGrpArea = (window.ZDBAnalysisView && window.ZDBAnalysisView.initialized && ZDBAnalysisView.defaultAnalysisView)? false:true;
      params += "&INCLUDEGRAPHAREA=" + initGrpArea; //No I18N
      if(fromExpEdit)
      {
    	  params += "&INCLUDEFIELDSLIST=" + (!ZDBAnalysisCaching.isFieldsListCached["AnalysisView"]);//No I18N
      }
      if(ZDBGlobal.integrated)
      {
        params += "&INTEGRATIONMODE=true";//No I18N
      }
      var viewCtxStandAlone = viewCtx.isStandAlone();
      if(viewCtxStandAlone)
      {
        params +="&STANDALONE=true";//No I18N
      }
    //ZRAnalysisFields.cc
      params += viewCtx.getAdditionalParams();
      if(!viewCtx.dashView && viewCtx.tab.view.objKey != null)
      {
    	  viewCtx.objKey = viewCtx.tab.view.objKey;
    	  params += params.indexOf('OBJKEY') < 0 ? "&OBJKEY="+viewCtx.tab.view.objKey : '';  //NO I18N
    	  params += params.indexOf('PARENTVIEWID') < 0 ? "&PARENTVIEWID="+viewCtx.tab.view.parentViewId : '';  //NO I18N
    	  params += params.indexOf('OBJTYPE') < 0 ? "&OBJTYPE="+viewCtx.tab.view.type : ''; //NO I18N
      }
      if(ZDBClientUI.isChartViewed)
      {
        params += "&isViewed="+ZDBClientUI.isChartViewed;//NO I18N        
      }
      
      var loadingMsg = (editMode) ? "zrpt.common.loadingdiv.js.loading" : "zrpt.common.analysis.refresh.js.loadingReport";	//No I18N
      AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBAnalysisView.cc",
                                 PARAMETERS:params,
                                 ONSUCCESSFUNC:ZDBAnalysisViewAPI.handleAnalysisResp,
                                 VIEWCTX:viewCtx,
                                 EDITMODE:editMode,
                                 INITGRPAREA:initGrpArea,
                                 OBJID:objId,
                                 FROMEXPEDIT:fromExpEdit,
                                 OPSTATUSID:viewCtx.getLoadIndicator(ZDBI18NMap.g(loadingMsg))});//No I18N
    }


    this.handleAnalysisResp = function(response,requestOptions)
    {
        if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList","ZAVMFilterList","ZAAnalysisFields"],"APPENDTODOC",ZDBAnalysisViewAPI.handleAnalysisResp,[response,requestOptions]))
        {
            return;
        }
        urls = ["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_VMFILTERSTYLES"];//NO I18N
        if(!ZDBLazyLoadUtil.loadCssOnly(urls, "APPENDTODOC", ZDBAnalysisViewAPI.handleAnalysisResp,[response,requestOptions]))
        {
            return;
        }
        var fontFamilyArr = ["'Proxima Nova'"];
        if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBAnalysisViewAPI.handleAnalysisResp,[response,requestOptions]))
        {
            return;
        }
        ZDBLazyLoadUtil.loadExternalSVG("themes/common/svgimages/chartchooser.svg");//NO I18N
        if(ZDBGlobal.integrated && ZDBGlobal.CSSURL && ZDBGlobal.CSSURL != "null")
        {
            ZDBLazyLoadUtil.loadCssOnly(ZDBGlobal.CSSURL, "APPENDTODOC", lazyLoadJSAndCssFiles, null, 'ZDBMainLoader', true); //NO I18N
        }
        if (!ZDBLazyLoadUtil.loadSnippet('AnalysisFunMenu', '/AnalysisFunMenu.cc', this, 'APPENDTODOC', null, ZDBAnalysisViewAPI.handleAnalysisResp, [response,requestOptions]))
    {
        return;
    }
      var viewCtx = requestOptions["VIEWCTX"];
      var editMode = requestOptions["EDITMODE"];
      var objId = requestOptions["OBJID"];
      var fromExpEdit = requestOptions["FROMEXPEDIT"];
      if(!viewCtx.checkIfRespValid(response,requestOptions))
      {
              return;
      }
      ZDBClientUI.responseHolder.innerHTML = response.getOnlyHtml();
      var fieldsCacheable = ZDBAnalysisCaching.isFieldsListCached["AnalysisView"];

      
      ZDBAnalysisView.initialize();
      var configDIV = $("ZDBAnalysisConfig_"+objId);
      configDIV.id = "";

      var view = new ZDBAnalysisView(configDIV,viewCtx,editMode,fieldsCacheable);
      
      //   if(viewCtx.dashView)
//	  {
//	  view.DashUFConfig = ZDBDashboardUF.getDashDynFltrConfig(viewCtx.dashView);
//	  }
      viewCtx.handle(view);
      if(editMode && viewCtx.objKey && parseFloat(viewCtx.tab.view.objId) < 0){
    	  viewCtx.tab.view.setModified();
      }
      if(ZDBGlobal.integrated)
      {
              if(!editMode)
              {
                      ZDBAnalysisEditViewMode.hideOrShow(view,"show");//NO I18N
              }
              else
              {
                      ZDBAnalysisView.showPanel(view,fromExpEdit);
              }
              ZDBIntegration.init();
      }
      else
      {
              ZDBAnalysisView.showPanel(view,fromExpEdit);
      }
      if(viewCtx.dashView == undefined)
      {
              ZAVMFilter.preLoadVMFilterIfNeeded(view);
      }
      else if(!viewCtx.dashView.editMode && view.VMFilter=="true")
      {
              ZAVMFilter.preLoadVMFilterIfNeeded(view);
      }
      typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.addRecord(ZRCRMPlusHomePage.RECENTITEMS,view);//NO I18N
    }
    
    this.isAnalysisView =  function(view)
    {
        return (view && (view.type == "AnalysisView" ||  view.type == "Pivot" || view.type == "SummaryView"));
    }
}

ZDBClientUI.typeDefns["AnalysisView"] = {fetchView:ZDBAnalysisViewAPI.fetchView,
                                         createView:ZDBAnalysisViewAPI.createView,
                                         newName:"zrpt.common.js.newChart",//No I18N
                                         dummyView:"dummyGraph"};//No I18N
ZDBClientUI.typeDefns["Pivot"] = {fetchView:ZDBAnalysisViewAPI.fetchView,
                                  createView:ZDBAnalysisViewAPI.createView,
                                  newName:"zrpt.common.js.newPivot",//No I18N
                                  dummyView:"dummyGraph"};//No I18N

ZDBClientUI.typeDefns["SummaryView"] = {fetchView:ZDBAnalysisViewAPI.fetchView,
                                        createView:ZDBAnalysisViewAPI.createView,
                                        newName:"zrpt.common.js.newSummary",//No I18N
                                        dummyView:"dummyGraph"};//No I18N


