//$Id$

var ZDBAnalysisEditViewMode = new function()
{
	
  this.attachTipToFields = function()
  {
	  if(jQuery("#ZDBFieldsIterationTable")[0])
	  {
		    jQuery("#ZDBFieldsIterationTable").find("div[elname='TableHeaderName']").on("mousemove", function(){ZDBToolTip.checkLengthAndShow(this);}).on("mouseout",function(){ ZDBToolTip.hide()});//NO I18N
	    	jQuery("#ZDBFieldsIterationTable").find("div[elname='FieldNameHolder']").on("mousemove", function(){ZDBToolTip.checkLengthAndShow(this);}).on("mouseout",function(){ ZDBToolTip.hide()});//NO I18N
	  }
  }
  this.hideOrShowEl = function(buttonClicked,event)
  {
    var view = ZDBClientUI.getViewObj(buttonClicked,"view");
    var viewType = view.type;
    var action = buttonClicked.getAttribute("action");
    switch(viewType) {
        case "Table": {//NO I18N
            if(!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/tabledesign/ZDBDesignGrid.js"],"APPENDTODOC",ZDBAnalysisEditViewMode.hideOrShowEl,[buttonClicked,event],"ZDBMainLoader")){
                return;
            }
            ZDBDesignGrid.showDesignView(buttonClicked,false);
            return;
        }
        case "QueryTable": {//NO I18N
            if(action == "show") {
                ZDBSQLTable.showDesign(buttonClicked, false);
            } else if(action == "hide") {//NO I18N
                ZDBSQLTable.showView(buttonClicked, event);
            }
            return;
        }
        case "Dashboard": {//NO I18N
            var mode = (action == "show") ? "editMode" : "viewMode";//NO I18N
            ZDBDashboardAPI.switchMode(buttonClicked, mode);
            return;
        }
    }
    if((action == "hide") && (!view.eModeHelper.validateView(view)))
    {
      return;
    }
    this.hideOrShow(view,action);
    if((view.editMode) && ZDBAnalysisCaching.isFieldsListCached["AnalysisView"] && (viewType == "AnalysisView" || viewType == "Pivot" || viewType == "SummaryView") && !ZDBAnalysisCaching.tblColInfo.data.tableDet)
    {
    	view.checkNSendTblColInfoReq();
    }
    else if(!view.editMode)
    {
    	jQuery(view.VMFilterArea).addClass("doNotHighLight");
    }
  }

  this.hideOrShow = function(view,action)
  {
    if(action=="show" && view.requestAllowed==true)
    {
        if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ZDBAnalysisEditList","ChartTPVendors","ZRJSChartsList","ZAVMFilterList","ZAAnalysisFields"],"APPENDTODOC",ZDBAnalysisEditViewMode.hideOrShow,[view,action]))
        {
                return;
        }
        urls = ["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_VMFILTERSTYLES"];//NO I18N
        if(!ZDBLazyLoadUtil.loadCssOnly(urls, "APPENDTODOC", ZDBAnalysisEditViewMode.hideOrShow,[view,action]))
        {
            return;
        }
        if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBAnalysisEditViewMode.hideOrShow,[view,action]))
        {
            return;
        }
      view.requestAllowed=false; // will be used for Pivot & Summary
      view.editMode = true;
      ZDBEmbed.remLegendFilterField(view,false);
      var chartObj = view.chartObj;
      if(view.legendCritInfo)
      {
          view.legendCritInfo.length = 0;
          chartObj.sendReq = true;
      }
      if(chartObj && view.drillDet && !chartObj.sendReq)
      {
          var drillLevel = view.drillDet.drillLevel;
          if(drillLevel > 0) {
              chartObj.sendReq = true;
          }
      }
      ZAVMFilter.clearAll(null,view,false);
      ZRSDrillDown.clearDrillDet(view);
      if((!view.fieldsCacheable && view.attachedFieldsListEl == null) || (view.fieldsCacheable && !ZDBAnalysisCaching.isFieldsListCached["AnalysisView"]))
      {
          ZDBAnalysisEditViewMode.sendFieldsRequest(view,"PARENTVIEWID=" +view.parentViewId+"&OBJID="+ view.objId +"&OBJTYPE="+view.type+"&INCLUDEFIELDSLIST=true",true);//No I18N
          return;
      }
      else if(view.attachedFieldsListEl == null)
      {
          ZDBAnalysisEditViewMode.getSelectedFields(view);
      }
      ZDBAnalysisView.showPanel(view);
    }
    else if(action =="hide" && view.requestAllowed==true)
    {
      view.requestAllowed=false; // will be used for Pivot & Summary
      view.editMode = false;
      view.showShiftHelpFilter = true;
      view.showShiftHelpVMFilter = true;
      if(view.VMFilterOptions)
      {
          view.modalDiv.className = "VMFilterModalDiv alpha";
          view.VMFilterOptions.style.display = "none";
      }
      ZDBAnalysisView.showPanel(view);
    }
    
    ZRSMenu.closeAllMenu();
    ZDBMenu.updateToolbar(view);

    if(view.editMode)
    {
      view.changeSliderBoundaries = true;
      this.lastAppliedEl = null;
      ZDBAnalysisEditViewMode.showFields(true,view);
      ZDBAnalysisEditViewMode.attachTipToFields();
      var fieldsPanel = view.fieldsListEl;
      if(fieldsPanel.style.display == "none" && (ZDBClientUI.layoutMode != "max" && !ZDBGlobal.integrated))
      {
        view.fieldsTab.style.display="";
        view.navigationBtn.style.display="none";
      }
    }
    else
    {
      ZDBAnalysisEditViewMode.showFields(false,view);
      view.fieldsTab.style.display="none";
      jQuery(view.chartDescEl).show();
      if(view.chartDescEl)
      {
      	if(!(view.description == null || view.description == "" || view.description == "null"))
      	{
            jQuery(view.vertLineEl).css('height','36px'); //No I18N
      	}
      }      
    }
    ZDBNavigation.showOrHideNavIcon(view);
    ZDBAnalysisEditViewMode.setFieldsDimension(view);
    if(view.typeValue === ZDBClientViewAPI.TYPE_ANALYSISVIEW && view.graphSelected != "TABLE_CHART")
    {
    	ZDBAnalysisView.showOrHideShortCuts(view.chartArea, view);
    }
    ZDBAnalysisView.disableShowHideSubTotal(view);
    if(ZDBGlobal.ISNEWLAYOUT){
        ZDBClientUI.resizeTabHolder(true);
    }
  }

  this.disableFields = function(isDisable, view)
  {
        var parNode = view.attachedFieldsListEl.origParent;
        var disableFields = DOMUtils.getFirstMatchingChild(parNode, "div", "id", "AnalysisFieldsDisable");//No I18N
        var fieldsList = view.fieldsListEl;
        if(fieldsList.style.display == "none")
        {
            return;
        }
        disableFields.style.width = (isDisable ? (fieldsList.offsetWidth - 10) : 0) +"px";
        disableFields.style.height = (isDisable ? (fieldsList.offsetHeight) : 0) +"px";
  }

  this.showFields = function(show,viewOrChildEl)
  {
    var view = viewOrChildEl;
    if(viewOrChildEl.getAttribute)//This is an el.
    {
      view = ZDBUtil.getParentWithProperty(viewOrChildEl,"view").view;//No I18N
    }
    ftIte = DOMUtils.getFirstMatchingChild(view.analysisFieldHolder , "*","id","ZDBFieldsIterationTable"); //No I18N
    if(ftIte != null && view.joinLinkDiv)
    {
        if(ftIte.getAttribute("isMultiTable") == "true") //No I18N
        {
            view.joinLinkDiv.style.display=""; //No I18N
        }
        else
        {
            view.joinLinkDiv.style.display="none"; //No I18N
        }
    }


    if(show)
    {
       if((ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState))
        {
                view.fieldsListEl.style.display = "none";
                var parent = view.attachedSwipeArea;
                parent.appendChild(view.fieldsListEl);
                view.fieldsListEl.style.display = "";
                if(view.navigationBtn!=null){view.navigationBtn.style.display = "none";}
                view.fieldsListEl.style.top= 0+"px";
                parent.style.display="";
        }
        else
        {
        if(view.attachedFieldsListEl.origParent != view.attachedFieldsListEl.parentNode)
        {
          view.attachedFieldsListEl.origParent.appendChild(view.attachedFieldsListEl);
        }        
        if(!ZDBNavigation.popOut)
        {
            if(view.navigationBtn!=null){view.navigationBtn.style.display = "none";}
            ZDBAnalysisEditViewMode.showFieldsNHideNav(view);
            ZDBClientUI.resizeTabHolder();
        }
        view.attachedSwipeArea.style.display="none";
      }
       // $$Bala
      if(ZDBNavigation.navSelect)
      {
        ZDBNavigation.navSelect.style.visibility="hidden";
      }
      view.fieldsTab.style.display="none";
      ZDBClientUI.positionWorkArea();
    }
    else
    {
      if(ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState)
      {
        view.attachedSwipeArea.style.display="none";
      }
      view.navigationBtn.style.display="none";
      if(ZDBNavigation.isNavHiddenForEditDesign && !ZDBNavigation.popOut)
        {
                      var el=$("ZR_UnHideNavPanel");
                      el.className ="navHideOpt";
                      jQuery(el).parent().attr("class","navShown");//No I18N
                      jQuery("#ZDBNavigationBarTD").stop(true,true).css({"position":"","z-index":"","box-shadow":""}).show(); //No I18N
                      jQuery("#ZRFieldListTD").hide(); //No I18N
                       jQuery("#showNavPermanent").hide();//No I18N
                      ZDBMenu.updateToolbar(view);
        }
        
        else if(ZDBNavigation.hiddenState && ZDBClientUI.layoutMode!="max")
            {
                      var icon=$("ZR_UnHideNavPanel");
                      jQuery(icon).parent().attr("class","navHidden");//No I18N
                      icon.className ="navUnHideOpt"; //No I18N
            }
      if(view.fieldsListEl.parentNode)
      {
        view.fieldsListEl.parentNode.removeChild(view.fieldsListEl);
        jQuery("#ZRFieldListTD").hide(); //No I18N
      }
       // $$Bala
      if(ZDBNavigation.navSelect)
      {
        ZDBNavigation.navSelect.style.visibility="visible";
      }
      view.fieldsTab.style.display=(view.editMode && !ZDBGlobal.integrated)? "":"none";
    }
      if(ZDBGlobal.ISNEWLAYOUT) {ZDBClientUI.resizeTabHolder();}
      ZDBAnalysisEditViewMode.setFieldsDimension(view);
  }

  this.showFieldsNHideNav=function(view,animate)
  {
       jQuery("#ZRFieldListTD").append(view.fieldsListEl).show(); //No I18N
       ZDBNavigation.isNavHiddenForEditDesign=true;
       if(animate)
       {
          jQuery("#ZDBNavigationBarTD").stop(true,true).css({"left":"0px"}).animate({left:'-256px'},'fast'); //No I18N
       }
       else
       {
          jQuery("#ZDBNavigationBarTD").css({"position":"absolute","z-index":"10000","box-shadow":"0px 4px 10px #666666","left":"-256px"});//No I18N
       }
       jQuery("#ZR_UnHideNavPanel").removeClass().addClass("navUnHideOptForEditMode");//.unbind("mouseenter").bind("mouseenter",function(){ZDBNavigation.popOutNavigation(this)}).show(); //No I18N
       ZDBAnalysisEditViewMode.setFieldsDimension(view);
  }

  this.showFieldsIfNeeded = function(view)
  {
    if((view.fieldsListEl != null)
       && view.editMode)
    {
      ZDBAnalysisEditViewMode.showFields(true,view);
    }
  }

  this.hideFields = function(view)
  {
    if(view && view.fieldsListEl)
    {
      this.showFields(false,view);
    }
  }

  this.updateFieldsList = function(view)
  {
      if(view.editMode)
      {
          ZDBAnalysisCaching.updateNavPanel(view);
          this.setFieldsDimension(view);
      }
  }

 this.updateFilterInfo = function(view)
 {
	if(!view.editMode)
    {
        return;
    }
    var filterAxis = 0;
	var fieldHolder = view.analysisFieldHolder;
	var fieldList = fieldHolder.getElementsByTagName("DIV");
	var no_fields = fieldList.length;

	var no_droppedFields = view.currentList.length;
	for(i=0; i<no_fields; i++)
	{
		if(fieldList[i].getAttribute("column_id") == null){continue;}
		ZDBUtil.setNamedChildEls(fieldList[i],fieldList[i]);
		var className  = "ZDBDNDFilterInfoIco alpha"; //No I18N
		var bgClassName = "ZDBDNDFieldRightEmboss";//No I18N
		for(j=0; j<no_droppedFields; j++)
		{
			var viewType = view.currentList[j].getAttribute("viewtype");
			if(viewType =="FILTERAXIS" && view.currentList[j].getAttribute("criteria")!="")
			{
				if(fieldList[i].getAttribute("column_id")==view.currentList[j].getAttribute("column_id"))
				{
					className="ZDBDNDFilterInfoIco"; //No I18N
					bgClassName = "ZDBDNDFieldRightPressed";//No I18N
				}
			}
		}
		if(fieldList[i].filterIco.className != className)
		{
                  if(className=="ZDBDNDFilterInfoIco"){fieldList[i].filterIco.setAttribute("filtered","true");}else{fieldList[i].filterIco.setAttribute("filtered","false");}
                  fieldList[i].rightBg.className = bgClassName
                    fieldList[i].filterIco.className= className;

		}
	}
	for(j=0; j<no_droppedFields; j++)
	{
		var viewType = view.currentList[j].getAttribute("viewtype");
		if(viewType =="FILTERAXIS" && view.currentList[j].getAttribute("criteria")!="")
		{
			filterAxis++;
		}
	}
  	view.filterInfo.innerHTML = filterAxis;
  ZAFilterMenu.updateStringFilterInfo(view);
 }

this.setFieldsDimension = function(view)
{
     if(!view.editMode || view.analysisFieldHolder==null)
     {
        return;
     }
     
     var zaFldScrollDiv = DOMUtils.getFirstMatchingChild(view.analysisFieldHolder , "DIV","zaFieldsScroll","true"); //No I18N
     if(zaFldScrollDiv==null){return;}
     view.analysisFieldHolder.style.height = "";
     zaFldScrollDiv.style.height = "";
     
     var $holder = jQuery(view.analysisFieldHolder);
     var holderBorderHeight = $holder.outerHeight(true)- $holder.height();
     
     // Hiding the field holder will help to get the remaining height
     view.analysisFieldHolder.style.display = "none";
     view.fieldsListEl.style.display = "none";
     var maxMode = (ZDBClientUI.layoutMode=="max"); //No I18N
     var parentHeight = (maxMode==true || ZDBNavigation.hiddenState)?view.attachedSwipeArea.offsetHeight:($("ZRFieldListTD").offsetHeight); // Parent Node changes based on the maxMode
     var remainingHeight =(jQuery(view.fieldsListEl).outerHeight(true) + holderBorderHeight);
     var height = parentHeight - remainingHeight;
     view.analysisFieldHolder.style.display = "";
     view.fieldsListEl.style.display = "";
     
     if(height > 0)
     {
         view.analysisFieldHolder.style.height = height+"px";
         if(zaFldScrollDiv)
         {
             var fieldsActionDiv = $("ZRFieldsActionDIV");
             var fieldsActionDivHeight = (fieldsActionDiv && fieldsActionDiv.style.display!="none")?20:0;//No I18N
             var fieldsSearchCountDiv = jQuery("#ZDBFieldsIterationTable #ZDBFieldsSearchResults")[0];
             var fieldsSearchCountDivHeight = (fieldsSearchCountDiv && fieldsSearchCountDiv.style.display!="none")?(jQuery(fieldsSearchCountDiv).outerHeight(true)):0;//No I18N
             zaFldScrollDiv.style.maxHeight= (height)-(fieldsActionDivHeight+fieldsSearchCountDivHeight)+"px";//NO I18N
         }
     }
}


  this.chartActionToolbar = function(action,view)
  {
    var isDrill = false;
    var dummyActionToolbar,actionToolbar,settings;
    switch(view.type)
    {
      case "Pivot": //No I18N 
        dummyActionToolbar = $("ZDBDummyPivotActionToolBar");
        actionToolbar = $("ZDBPivotActionToolBar");
        settings = $("ZRSPivotSettings");
        break;
      case "AnalysisView": //No I18N
        dummyActionToolbar = $("ZDBDummyChartActionToolBar");
        actionToolbar = $("ZDBChartActionToolBar");
        settings = $("ZDBANAL_SETTING_TIP");
        if(view.zrsDrillObj && view.zrsDrillObj.drillLevel > 0) {
            isDrill = true;
        }
        break;
      case "SummaryView": //No I18N
        dummyActionToolbar = $("ZDBDummySummaryActionToolBar");
        actionToolbar = $("ZDBSummaryActionToolBar");
        settings = $("ZRSSummarySettings");
        
        break;
    }
    
    if(dummyActionToolbar)
    {
      var isEnable = (action == "enable"); //No I18N
	  dummyActionToolbar.style.display = isEnable ? "none" : "";
	  actionToolbar.style.display = isEnable ? "" : "none";
      if(isEnable && !view.enableSumSubTot) // it is to be removed, once the property is removed
      {
          ZDBAnalysisView.disableShowHideSubTotal(view);
          ZDBAnalysisView.disableSortButton(view,$("ZAPvtSort"));
      }
      if(isDrill) {
          isEnable = false;
      }
	  ZDBMenu.editCSSClass(settings,"disabledonnotsaved",isEnable); //No I18N
    }
  }

  this.toggleUniColWidthOpt = function(el)
  {
	  var view = ZDBClientUI.getViewObj(el,"view"); //NO I18N
      var settingsEl = view.settingsObj.getSettingsEl();
      var defColWidthEl = settingsEl.defColWidthEl;
      if(el.checked)
      {
          defColWidthEl.removeAttribute("disabled");
          ZDBUtil.setFocus(defColWidthEl, true);
          defColWidthEl.className = "scratchsearchfield";
          $("allColWidResize").style.display= "";
      }
      else
      {
          defColWidthEl.setAttribute("disabled", "true");
          defColWidthEl.value = ZDBGlobal.stdCellWidth;
          defColWidthEl.className = "scratchsearchfield alpha";
          $("allColWidResize").style.display= "none";
      }
  }

  this.updateSettings = function(element, event)
  {
    var view = settings.currentViewObj;
    var settingsEl = view.settingsObj.getSettingsEl();
    var frmTitle = settingsEl.frmTitle, frmDescription = settingsEl.frmDescription;
    var defColWidthEl = settingsEl.defColWidthEl;
    var nullValDefEl = settingsEl.nullValDefEl;
    var nullVal = nullValDefEl.value;
    var title = frmTitle.value;
    ZDBUtil.setNamedChildEls(settingsEl,settingsEl);
       ZDBInlineDialog.changeTab(settingsEl.ZDBGenProp, settingsEl.settingsHolder);
    if(title.length > ZDBConst.TITLE_MAX_LENGTH)
    {
      showCustomMessage(ZDBI18NMap.f("zrpt.common.analysis.settings.js.titleMaxLenExceedErr",ZDBConst.TITLE_MAX_LENGTH),frmTitle);//No I18N
      frmTitle.select();
      return;
    }
    var desc =frmDescription.value;
    if(desc.length > ZDBConst.DESCRIPTION_MAX_LENGTH)
    {
      showCustomMessage(ZDBI18NMap.f("zrpt.common.analysis.settings.js.descMaxLenExceedErr",ZDBConst.DESCRIPTION_MAX_LENGTH),frmDescription); //No I18N
      frmDescription.select();
      return;
    }
    if(nullVal.length > ZDBConst.TITLE_MAX_LENGTH)
    {
    	showCustomMessage(ZDBI18NMap.f("zrpt.common.analysis.settings.js.nullValMaxLenExceedErr",ZDBConst.TITLE_MAX_LENGTH),nullValDefEl); //No I18N
    	nullValDefEl.select();
    	return;
    }
    var defColWidth = defColWidthEl.value;
    if(!ZDBValidator.isPositive1(defColWidth, false, true))
    {
        if(defColWidth !== '')
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.settings.js.defColWidthErr"),defColWidthEl); //No I18N
            defColWidthEl.select();
            return;
        }
        else
        {
            defColWidth = ZDBGlobal.stdCellWidth;
        }
    }
       ZDBInlineDialog.changeTab(settingsEl.ZACustomFormat, settingsEl.settingsHolder);
       if(!ZDBAnalysisEditViewMode.validateInputFields(settingsEl.ZACFDiv, settingsEl.ZACustomFormatTab)) {
         return;
     }
    var gridObj = view.gridObj;
    var prevTitle = (view.title==null || view.title=="")? view.displayName : view.title ;
    var prevDesc = view.description;
    var prevHideRhId = gridObj.hideRhId;
    var prevDefColWid = gridObj.defColWidth !== -1 ? gridObj.defColWidth : ZDBGlobal.stdCellWidth;
    var prevGrpLblRpt = view.chartProp.zr_show_grpLblRpt != null ? true : false;
//    var prevZRTheme = view.chartProp.zr_Theme != null ? view.chartProp.zr_Theme : "default"; //No I18N
    var defNullVal = view.typeValue === ZDBClientViewAPI.TYPE_PIVOT ? "-No Value-" : ""; //No I18N
    var prevNullVal  = (view.chartProp && view.chartProp.zr_null_value) ? view.chartProp.zr_null_value : (view.dbNullVal ? view.dbNullVal : defNullVal);
    var prevWrapColHead = (view.chartProp && view.chartProp.zr_wrap_colHead) ? view.chartProp.zr_wrap_colHead : false;
    var showRid = settingsEl.hideRId.checked;
    var wrapColHead = settingsEl.wrapColHead.checked;
    var grpLblRpt = settingsEl.grpLblRpt.checked;
    var smvMod = false;
//    var zrTheme = $("zrTheme").value;
    defColWidth = parseInt(defColWidth);
    if(view.typeValue != ZDBClientViewAPI.TYPE_ANALYSISVIEW)
    {
        view.title = title;
        view.description = desc;
        if(nullVal !== prevNullVal)
    	{
        	if((nullVal === defNullVal || nullVal === view.dbNullVal) && view.chartProp.zr_null_value)
    		{
            	delete view.chartProp.zr_null_value;
    		}
        	else
    		{
                view.chartProp["zr_null_value"] = nullVal; //No I18N
    		}
    	}
        
        smvMod = ZDBAnalysisEditViewMode.showMissingValuePivot(view,settingsEl);
        ZDBAnalysisEditViewMode.showHideRId(showRid, gridObj, view);
        ZDBAnalysisEditViewMode.setDefColWidth(defColWidth, gridObj, view,settingsEl.colWidId.checked);
        ZDBAnalysisEditViewMode.showHideGrpLbl(grpLblRpt, view);
        ZDBAnalysisEditViewMode.wrapColHeaders(wrapColHead, view);
//        this.setZRTheme(zrTheme, view);
        view.chartTitleEl = view.toolbar.viewTitleEl;
        view.chartDescEl = view.toolbar.viewDescEl;
        view.chartTitleEl.innerHTML=ZDBEscapeUtil.encodeForHtml((view.title==null || view.title=="")?view.displayName:view.title);
        view.chartDescEl.innerHTML=ZDBEscapeUtil.encodeForHtml((view.description==null || view.description=="")?"":view.description);
    }
    
    ZDBInlineDialog.changeTab(settingsEl.ZACondFormatMainTab, settingsEl.settingsHolder);
    var isCondFormatModified = view.condFormat.isCondFormatModified(view, settingsEl.ZACondFormat.rightContainer);
    if(isCondFormatModified == ZDBConst.CLEAR)	//Stop execution as Validation Failed
	{
		return false;
	}
    var isCondFormSetModified = isCondFormatModified == ZACondFormUtil.isSetModified ? true : false;
    ZDBInlineDialog.closeDialog();
    var grpLblMod = (prevGrpLblRpt != grpLblRpt);
    var wrapColHeadMod = (prevWrapColHead != wrapColHead);
    var rhIdStat = prevHideRhId !== gridObj.hideRhId;
    var nullValMod = nullVal !== prevNullVal;
    var colWidthModStat = prevDefColWid !== defColWidth;
    var isColsRenamed = ZDBAnalysisEditViewMode.updateRenamedColumns(view);
//    var themeMod = prevZRTheme != zrTheme;
    
    var oldProp = view.propSetUtil.getPropValue(PropSettings.CHART_WEEKYR_FORMAT,  PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE);
    var newProp = settingsEl.weekYearFormat.getAttribute("propvalue");
    var isPvtWkYrFtModified = oldProp != newProp;
    view.propSetUtil.setPropMap(settingsEl.weekYearFormat, "false", true);
    view.propSetUtil.setPropSet(view, true);
    
    var zacf = view.zacf;
    var isZACFModified = zacf.isModified();
    var modified = prevTitle !== view.title || prevDesc !== view.description || rhIdStat || colWidthModStat || grpLblMod || nullValMod || isZACFModified || isColsRenamed || isCondFormatModified || wrapColHeadMod || isPvtWkYrFtModified;// || themeMod;
    zacf.persist();
    if(settingsEl.resizeColWidId.checked)
    {
        ZDBAnalysisEditViewMode.resetAllColumnWidth();
    }
    if(modified)
    {
        view.setModified();
        if(rhIdStat)
        {
            var curRHeadWid = gridObj.colHeaders[0].width;
            var widthChange = gridObj.hideRhId ? -1 * curRHeadWid : 30;
            var resizeObj = gridObj.colHeaders[0];
            gridObj.resizeGridArea(resizeObj, widthChange);
            gridObj.generateHiddenRhIdBorderCss();//if not hidden need to generate the left border to cell next to rowHead
        }
        if(colWidthModStat)
        {
            this.resizeGridCols(gridObj, defColWidth, prevDefColWid);
        }
        /*if(themeMod)
    	{
        	gridObj.gArea.className = (zrTheme != "default") ? ("PivotSheet" + zrTheme) : "PivotSheet";
    	}*/
      }
    if(grpLblMod || nullValMod || isZACFModified || isColsRenamed || (!isCondFormSetModified && isCondFormatModified) || wrapColHeadMod || smvMod ||isPvtWkYrFtModified)
    {
    	view.refreshView();
    }
  }

  this.resizeGridCols = function(gridObj, defColWidth, prevDefColWid)
  {
    var colHeads = gridObj.colHeaders;
    for(var i=0, j= colHeads.length; i<j; i++)
    {
        var colObj = colHeads[i];
        switch(colObj.objType)
        {
            case ZDBConst.ROWHEAD:
            case ZDBConst.DUMMY:
            case ZDBConst.FILLER:
                break;
            default:
                var calColWid = ZDBDataGrid.calculateColWidth(colObj);
                var prevColWid = (calColWid === colObj.width && calColWid !== prevDefColWid) ? calColWid : prevDefColWid;
                var colWidthChange = defColWidth - prevColWid;
                if(colObj.width === prevColWid)
                {
                	gridObj.changeColumnWidth(colObj,i,defColWidth);
                }
         }
     }
    gridObj.adjustPivotDimension();
  }
  
  this.showMissingValuePivot = function(view,settingsEl)
  {
	  var smvMod = false;
	  var isModified = false;
	  if(settingsEl.pvtShowMissingValueForXAxis.style.display == "")
	  {
		  isModified = ZDBAnalysisEditViewMode.setMissingValue(view,settingsEl.missValPivotModelForCols,true,PropSettings.PVT_MISSING_VALUE_HIERARCHICAL_MODEL_XAXIS);
		  smvMod= smvMod || isModified;
		  view.propSetUtil.setPropMap(settingsEl.missValPivotModelForCols, "false", true);
		  isModified = ZDBAnalysisEditViewMode.pivotShowMissingValueCols(view,settingsEl.missValColInputForCols);
		  smvMod= smvMod || isModified;
	  }
	  if(settingsEl.pvtShowMissingValueForYAxis.style.display == "")
	  {
		  isModified = ZDBAnalysisEditViewMode.setMissingValue(view,settingsEl.missValPivotModelForRows,true,PropSettings.PVT_MISSING_VALUE_HIERARCHICAL_MODEL_YAXIS);
		  smvMod= smvMod || isModified;
		  view.propSetUtil.setPropMap(settingsEl.missValPivotModelForRows, "false", true);
		  isModified = ZDBAnalysisEditViewMode.pivotShowMissingValueCols(view,settingsEl.missValColInputForRows);
		  smvMod= smvMod || isModified;
	  }
	  if(view.propSetUtil && view.propSetUtil.modified)
      {
      	view.propSetUtil.setPropSet(view, true);
      }
	  return smvMod;
  }
  
  this.pivotShowMissingValueCols = function(view,missingValColumns)
  {
	  var smvMod = false;
//	  missingValColumns = !missingValColumns ? $("missValColInput") : missingValColumns;
	  var inputTags = missingValColumns.getElementsByTagName("input");
	  for(var i=0;i<inputTags.length; i++)
	  {
		  var missValEl = inputTags[i];
		  var isModified = ZDBAnalysisEditViewMode.setMissingValue(view,missValEl,false,null);
		  smvMod = smvMod || isModified;
		  view.propSetUtil.setPropMap(missValEl, "false", true);
	  }
      return smvMod;
  }
  
  this.setMissingValue = function(view,el,isModelEl,modelName)
  {
	  var propValue = el.checked;
	  el.setAttribute("propValue" , propValue+ "");
	  if(!isModelEl)
	  {
		  return (propValue != (view.propSetUtil.getPropValue(PropSettings.CHART_MISSING_VALUE ,el.getAttribute("instid") ,PropSettings.STRING_PROPTYPE) == "true"));
	  }
	  else
	  {
		  return (propValue != (view.propSetUtil.getPropValue(modelName ,PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE) == "true"));
	  }
  }

  this.showHideRId = function(showRid, gridObj, view)
  {
      if(showRid)
      {
          gridObj.hideRhId = true;
          view.chartProp["zr_hide_row_id"] = showRid; //No I18N
      }
      else if(view.chartProp.zr_hide_row_id)
      {
          gridObj.hideRhId = false;
          delete view.chartProp.zr_hide_row_id;
      }
  }

  this.showHideGrpLbl = function(grpLblRpt, view)
  {
      if(grpLblRpt)
      {
          view.chartProp["zr_show_grpLblRpt"] = grpLblRpt; //No I18N
      }
      else if(view.chartProp.zr_show_grpLblRpt)
      {
          delete view.chartProp.zr_show_grpLblRpt;
      }
  }
  
  this.wrapColHeaders = function(wrapColHead, view)
  {
	  if(wrapColHead)
      {
          view.chartProp["zr_wrap_colHead"] = wrapColHead; //No I18N
      }
      else if(view.chartProp.zr_wrap_colHead)
      {
          delete view.chartProp.zr_wrap_colHead;
      }
  }
  
  this.setZRTheme = function(zrTheme, view)
  {
      if(zrTheme != "default")//No I18N
      {
          view.chartProp["zr_Theme"] = zrTheme; //No I18N
      }
      else if(view.chartProp.zr_Theme)
      {
    	  delete view.chartProp.zr_Theme;
      }
  }

  this.setDefColWidth = function(defColWidth, gridObj, view,isDefColWidthSet)
  {
      if(isDefColWidthSet)
      {
          gridObj.defColWidth = defColWidth;
          view.chartProp["zr_uni_col_width"] = ZDBAnalysisGrid.getNormalizedWidth(gridObj,defColWidth); //No I18N
      }
      else
      {
          gridObj.defColWidth = -1;
          delete view.chartProp.zr_uni_col_width;
      }
  }

  this.chekOrUnchekOthers = function(clickType,reqOpts)
  {
    var el = reqOpts.ELEMENT;
    if(clickType==="NO")
    {
        el.checked = (el.checked)?false:true;
    }
  }

  this.confirmAndUnCheck=function(el)
  {
    if(el.checked)
    {
        var view = ZDBClientUI.getViewObj(el,"view"); //NO I18N
        var settingsEl = view.settingsObj.getSettingsEl();
        var val = settingsEl.defColWidthEl.value;
        var msg = ZDBI18NMap.f("zrpt.common.analysis.settings.js.confResizeAllColWid",val); //No I18N
        ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK: ZDBAnalysisEditViewMode.chekOrUnchekOthers,ELEMENT:el},null,null,null,view);//NO I18N
    }
  }

  this.resetAllColumnWidth = function()
  {
      var view = settings.currentViewObj;
      var modified = false;
      var pvCritPropInfo = view.pvCritPropInfo;
      if(!pvCritPropInfo)
	  {
	  pvCritPropInfo = [];
	  }
      if(pvCritPropInfo.length > 0)
      {
          view.pvCritPropInfo = [];
          modified = true;
      }
      var currentList = view.currentList;
      for(var i=0, j= currentList.length; i<j; i++)
      {
          var colSize = currentList[i].getAttribute("COLSIZE");
          if(colSize)
          {
              currentList[i].removeAttribute("COLSIZE");
              modified = true;
          }
      }
      if(modified)
      {
          var gridObj = view.gridObj;
          var colHeads = gridObj.colHeaders;
          var defColWidth = gridObj.defColWidth !== -1 ? gridObj.defColWidth : ZDBGlobal.stdCellWidth;
          for(var i=0, j= colHeads.length; i<j; i++)
          {
                var colObj = colHeads[i];
                switch(colObj.objType)
                {
                    case ZDBConst.ROWHEAD:
                    case ZDBConst.DUMMY:
                    case ZDBConst.FILLER:
                        break;
                    default:
                    	gridObj.changeColumnWidth(colObj,i,defColWidth);
             }
      }
          gridObj.adjustPivotDimension();
      view.setModified();
      }
  }

  this.selectTab = function(tabName,el,view)
  {
	if(view==null && el!=null)
    {
      view = ZDBClientUI.getViewObj(el,"view");
    }

		var selectedButton = (el!=null)?(el.getAttribute("buttonName")!=null)?el.getAttribute("buttonName"):tabName:tabName;
                if(view.filterFields.getAttribute("ISVISIBLE") === "true" )
                {
                    view.filterFields.style.display= (selectedButton=="filter")?"":"none";
                }
                if(view.stringFilterFields.getAttribute("ISVISIBLE") === "true" )
                {
                    view.stringFilterFields.style.display= (selectedButton=="filter")?"":"none";
                    if(selectedButton == "filter")
                    {
                        ZDBAnalysisEditViewMode.disableFields(true, view);
                    }
                }
                
    view.graphFields.style.display= (selectedButton=="graph")?"":"none";
		view.VMFilterFields.style.display= (selectedButton=="VMFilter")?"":"none";
	ZDBAnalysisEditViewMode.setButtonSelected(view[selectedButton+"Button"]);
    if(selectedButton=="filter")
    {
      var filterDropArea = view.dropAreas["FILTERAXIS"];
      view.field = view.filterNav.selectedField;
      if(view.stringFilterCriteria && view.stringFilterCriteria.trim() != "")
      {
          if(filterDropArea.getElementsByTagName("div").length == 0)
          {
              view.filterFields.style.display= "none";
              view.stringFilterFields.style.display= (selectedButton=="filter")?"":"none";
              ZAFilterMenu.showStringFilterContents(this);
          }
      }

      
      if((view.filterNav.selectedField == null)
         && (filterDropArea.getElementsByTagName("div").length > 0))
      {
        ZDBAnalysisFilter.selectFilterField(view,filterDropArea.getElementsByTagName("div")[0]);
      }
       ZDBAnalysisView.enableDropFieldExp(filterDropArea); // since filter drop area height returns 0, it will not be enabled while switching to Edit mode
    }
		if(selectedButton=="VMFilter")
		{
			ZAVMFilter.placeVMFilterDefinition(view);
		}

  }

  this.resetAnalysis = function(clickType, element, event,view)
  {
    if(clickType == "NO")
    {
      return;
    }
    if(view == null)
    {
      view = ZDBDialogUtil.currentViewObj;
    }
    if(view.currentList.length > 0)
    {
      while(view.currentList.length>0)
      {
        view.removeField(view.currentList[0],true);
      }
      while(view.VMFiltersList.length>0)
      {
        ZAVMFilter.removeComponent(view.VMFiltersList[0]);
      }
      view.setModified();
      if(view.typeValue !== ZDBClientViewAPI.TYPE_ANALYSISVIEW)
      {
        view.chartProp={};
      }
      else
      {
          PropSettings.removePropSet(view);
      }
    }
    ZDBAnalysisFilter.clearAllFilter("YES",event,view);//No I18N
    ZAFilterMenu.resetStringFilter();
    view.legendPos = "RIGHT"; //No I18N
    view.legendTitleModified = false;
    view.legendTitleValue = null;
    view.graphSelected = "BEST"; //No I18N
    view.userGrpSel = "BEST"; //No I18N
    view.userSubGrpSel = "DEF";  //No I18N
    view.subGraphType = "DEF";  //No I18N
    view.refreshView();
    
  }

  this.confirmAndReset = function(el)
  {
    var view = ZDBClientUI.getViewObj(el,"view");
    if(view.currentList.length>0 || ZAFilterMenu.checkIfStringCriteriaPresent()){
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.analysis.js.resetViewConfirm"),"ZDBYESNO",{ONCLICK:ZDBAnalysisEditViewMode.resetAnalysis,VIEW:view},null,null,null,view);//No I18N
    }
  }

  this.blinkCounter=0;
  
  this.highlightItem = function()
  {
    var el = ZDBAnalysisEditViewMode.el;
    if(ZDBAnalysisEditViewMode.blinkCounter<7)
    {
      el.toggleClass("highLight"); //No I18N
      ZDBAnalysisEditViewMode.blinkCounter++;
      setTimeout(ZDBAnalysisEditViewMode.highlightItem,400);
    }
    else
    {
      el.removeClass("highLight"); //No I18N
    }
  }

  this.startHighlighting = function(el)
  {
    ZDBAnalysisEditViewMode.el = el ? el : jQuery("#splitYAxis"); //No I18N
    ZDBAnalysisEditViewMode.blinkCounter = 0;
    ZDBAnalysisFilter.intervalID = setTimeout(ZDBAnalysisEditViewMode.highlightItem,400);
  }


  this.mergeOrSplit = function(element, event)
  {
    var view = ZDBClientUI.getViewObj(element,"view");
    view.merge = !view.merge;
    view.drillView = new ZRSDrillDown(null, view);
    ZDBAnalysisView.setModifyAndRefreshView(view);
    if(view.viewCtx.isStandAlone()) {
        var axis = (view.merge) ? "zrpt.chartview.js.splitaxis" : "zrpt.chartview.js.mergeaxis"; //No I18N
        element.getElementsByTagName("span")[0].innerText = ZDBI18NMap.g(axis);
    }
  }

  this.switchView = function(buttonClicked)
  {
    var view = ZDBClientUI.getViewObj(buttonClicked,"view");
		ZDBAnalysisEditViewMode.setButtonSelected(buttonClicked);
    var selectFilterTab = (buttonClicked == view.filterButton)?"filter":"graph"; //No I18N
    ZDBAnalysisEditViewMode.disableFields(false, view);
    ZDBAnalysisEditViewMode.selectTab(selectFilterTab,buttonClicked,view);
  }
	this.setButtonSelected = function(buttonClicked)
	{
                if(buttonClicked.id === "FilterMenu1")
                {
                    return;
                }               
		var currSelectedTab = $("ZADesignerBtnSelected");
		currSelectedTab.removeAttribute("id");
		currSelectedTab.className = "zaDesignerBtn";
		buttonClicked.id = "ZADesignerBtnSelected";
	}


  this.validateView = function(view)
  {
    if((view.type =="AnalysisView" || view.type =="Pivot" || view.type =="SummaryView"))
    {
      var curListlen = view.currentList.length;
      var VMFilterListlen = view.VMFiltersList.length;
      if(curListlen == 0 && VMFilterListlen==0 && !ZAFilterMenu.checkIfStringCriteriaPresent())
      {
        ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.analysis.custommsg.js.dropCol2PerformRefresh"));
        return false;
      }
      else
      {
        ZDBUtil.removeNonElements(view.filterAxis);
        var filteredEls=view.filterAxis.childNodes;
        var filtersDropped = filteredEls.length - 1; //excluding empty space for dropping.

        if(curListlen==filtersDropped)
        {
          ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.analysis.custommsg.js.dropCol2PerformRefresh"));
          return false;
        }

      }
    }
    return true;
  }

    this.validateViewCheck = function(view)
  {
    if((view.type =="AnalysisView" || view.type =="Pivot" || view.type =="SummaryView"))
    {
      if(view.currentList.length == 0)
      {
        return false;
      }
      else
      {
        ZDBUtil.removeNonElements(view.filterAxis);
        var filteredEls=view.filterAxis.childNodes;
        var filtersDropped = filteredEls.length - 1 //excluding empty space for dropping.
        if(view.currentList.length==filtersDropped)
        {
          return false;
        }
      }
    }
    return true;
  }


    
    this.getSelectedFields = function(view,dntSetFldDimention)
    {
        ZDBAnalysisCaching.updateNavPanel(view);
        view.updateAddedFields();
				view.eModeHelper.updateFilterInfo(view);
        if(!dntSetFldDimention)   
        {
            this.setFieldsDimension(view);
        }
    }

        this.sendFieldsRequest = function(view,params,editMode)
        {
        
            params += view.viewCtx.getAdditionalParams();
            AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBAnalysisView.cc",
                                         PARAMETERS:params,
                                         ONSUCCESSFUNC:this.handleFieldsResp,
                                         VIEW:view,
                                         EDITMODE:editMode,
                                         OPSTATUSID:view.viewCtx.getLoadIndicator()});
        }

        this.handleFieldsResp = function(response,requestOptions)
        {
//            ZDBContentCache.appendAndGet("Filter_List_User","GridMenu",document.body);
            var view = requestOptions["VIEW"];
            if(!view.viewCtx.checkIfRespValid(response,requestOptions))
            {
                return;
            }
            var tempDiv = document.createElement("div");
            tempDiv.innerHTML = response.responseText;
            ZDBClientUI.responseHolder.appendChild(tempDiv);
            ZDBAnalysisEditViewMode.getSelectedFields(view);
            view.requestAllowed = true; // will be used for Pivot & Summary
            ZDBAnalysisEditViewMode.hideOrShow(view,"show"); //No I18N
            view.checkNSendTblColInfoReq();
        }


  this.showFilterNFormulaMenu = function(element,event)
  {
    var menu = ZDBContentCache.appendAndGet("ZA_FORMULA_MENU","GridMenu",document.body); //No I18N
    menu.parEl = element;
    menu.fieldDiv = DOMUtils.getParentWithAttr(element,"filter_operation");
    var view = ZDBClientUI.getViewObj(element,"view");
    menu.view = view;
    var editFormulaMenuItem = $("ZAEditFormulaColumn");
    if(editFormulaMenuItem)
    {
      var dbColName = menu.fieldDiv.getAttribute('dbcolname');
      var displayType = (dbColName == ZDBConst.DYNAMIC_COL_NAME) ? '' : 'none'; //No I18N
      editFormulaMenuItem.style.display = displayType;
      $('ZADeleteFormulaColumn').style.display = displayType;
    }
    ZRSMenu.showMenu(event,null,menu,1);
  }

  this.addFieldInFilter = function(element)
  {
    var menu = DOMUtils.getParentWithAttr(element,"filtermenu");
    var field = menu.fieldDiv;
    var view = menu.view;    
    ZDBAnalysisEditViewMode.selectTab("filter",null,view);//No I18N
    var grpField = ZDBAnalysisView.getGraphField(view,field,"FILTERAXIS",field.getAttribute("displayname"),false); //No I18N
    ZDBAnalysisFilter.setBestFilterFunction(grpField,view);
    view.addFieldToArea(grpField,view.dropAreas["FILTERAXIS"]);
    ZDBAnalysisFilter.selectFilterField(view,grpField);
  }

  this.addFieldInUserFilter = function(element)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("VMFilterEdit","/ZAVMFilterEdit.cc?",this,"APPENDTODOC",["zdbjs/vmfilter/ZAVMFilterEdit.js","zdbjs/vmfilter/ZAVMFilterEditUI.js"],ZDBAnalysisEditViewMode.addFieldInUserFilter,[element]))
    {
      return;
    }
    var menu = DOMUtils.getParentWithAttr(element,"filtermenu");
    var field = menu.fieldDiv;
    var view = menu.view;
    ZDBAnalysisEditViewMode.selectTab("VMFilter",null,view); //No I18N
    ZAVMFilterEdit.dropField(field,view.dropAreas['VMFILTERCRITERIA']);
  }
  
    this.updateRenamedColumns = function (view) {
        var toBeModifed = view.colsModifiedIdx;
        var isModified = false;
        for (var idx in toBeModifed) {
            var value = toBeModifed[idx];
            var curNode = view.currentList[idx];
            var instKey = curNode.getAttribute('instKey');
            var newInstKey = view.instMap && view.instMap[instKey]? view.instMap[instKey] : instKey;
            var curZACF = view.zacf.get(newInstKey);
            var positions = view.zacf.getAvlblPositions(newInstKey);
            var zacf = curZACF[positions[0]];
            if (value === zacf.displayLabel) {
                value = '';
            }
            view.curListProp[instKey]['PVTCOLUMNNAME'] = value;
            isModified = true;
        }
        return isModified;
    }
    
    this.isColumnsRenamed = function(view) {
        var toBeModifed = view.colsModifiedIdx;
        for (var idx in toBeModifed) {
            return true;
        }
        return false;
    };

    this.validateInputFields = function (parNode, scrollEl) {
        var inputEls = parNode.getElementsByTagName("input");
        for (var i = 0, j = inputEls.length; i < j; i++) {
            if(!ZDBAnalysisEditViewMode.validateInputField(inputEls[i], scrollEl)) {
                return false;
            }
        }
        return true;
    }
    
    this.validateInputField = function(inputEl, scrollEl) {         
            var length = inputEl.value.length;
            var errorMsg ='zrpt.common.showinfo.js.ColumnNameMaxLengthExceed';//No I18N
            var param = ZDBConst.COLNAME_MAX_LENGTH;
            if (length === 0)
            {
                errorMsg = 'zrpt.common.showinfo.js.ColumnName';//No I18N
                param = '';
            } else if(length < ZDBConst.COLNAME_MAX_LENGTH) {
                return true;
            }
            if(scrollEl) {
                scrollEl.scrollTop = ZDBUtil.getObjTop(inputEl) - 50 ;
            }
            inputEl.focus();
            showCustomMessage(ZDBI18NMap.f(errorMsg, param), inputEl);
            return false;
    }
}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBAnalysisEditViewMode.switchView"]=ZDBAnalysisEditViewMode.switchView;
