//$Id$
var ZDBChartOptions = new function(){
    this.disablePrevious = function(){
        var prev = this.prevSelected;
        var chartDialog = ZDBAnalysisView.chartTypeDlg;
        var subTypeCharts = chartDialog.querySelector(".subTypeCharts");//NO I18N
        var type = chartDialog.querySelector(".types").querySelector("span[elname="+prev+"]");//NO I18N
        
        this.disableOrEnable(prev);
    }
    this.disableOrEnable = function(elname,isEnabled){
        var chartDialog = ZDBAnalysisView.chartTypeDlg;
        var subTypeCharts = chartDialog.querySelector(".subTypeCharts");//NO I18N
        var isMapChart = elname.match(/^(MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE|MAPPIEBUBBLE)$/);
        elname =  isMapChart ? "MAP_CHART" : elname; //NO I18N
        var type = chartDialog.querySelector(".types").querySelector("span[elname="+elname+"]");//NO I18N
        var element = subTypeCharts.querySelector("#" + elname);//NO I18N
        var types = chartDialog.querySelector(".types").querySelectorAll("span[elname]");//NO I18N
        if(isEnabled){
            element.style.display = "";
            this.prevSelected = elname;
            type.className = type.className + " hover";//NO I18N
        }
        else{
            element.style.display = "none";
            type.className = type.className.substring(0, type.className.indexOf(" hover"));
        }        
        return element;
    }
    this.mouseEnterHandler = function(event){
        var target =event.target || event.srcElement;
        target = DOMUtils.getElOrParentWithAttr(target,"elname");//NO I18N
        if(target.className.indexOf("alpha") > -1){
            return;
        }
        ZDBChartOptions.disablePrevious();
        var elname = DOMUtils.getElOrParentWithAttr(target,"elname").getAttribute("elname");//NO I18N
        ZDBChartOptions.disableOrEnable(elname,true);
    }
    this.checkComboSplineNdUpdate = function(view,graphType){
        var isSplineSel = false;
        if(graphType == "COMBO"){
            
            var legendModel = view.chartObj.getLegendModel();
            isSplineSel = legendModel.isComboSpline();
//            }
//            else
//            {
//                var isMultiY = view["isMultiY"];
//                if (isMultiY)
//                {
//                    isSplineSel = ZDBAnalysisUtil.isPropInCurPropList(view.curListProp,
//                     "COMBOTYPE", PropSettings.SPLINE_COMBOTYPE); //No I18N
//                }
//                else
//                {
//                    var legList = view.chartArea.legendList;
//                    var firstLegEl = legList.getElementsByTagName("div")[0];
//                    var instId = firstLegEl.getAttribute("instId");
//                    if(view.propSet["SPLINE"] && view.propSet["SPLINE"][instId])
//                    {
//                        isSplineSel = true;
//                    }
//                }
//                view.isComboSplineSelected = isSplineSel;
//            }
        }
        return isSplineSel
    }
    this.chooseSubType = function(view,subGraphCont){
        var graphType = view.graphSelected;
        var subType = view.subGraphType;
        var selectedContType = subGraphCont.getAttribute("id");
        var isSplineSel = ZDBChartOptions.checkComboSplineNdUpdate(view,graphType);
        var isMapChart = graphType.match(/^(MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE|MAPPIEBUBBLE)$/);
        if(graphType == selectedContType || (graphType == "PIE" && subType == "FUNNEL") || isMapChart){
            var subTypeEl;
            var selector;
            if(isMapChart)
            {
                 selector = "div[gt='"+graphType+"']";//NO I18N
            }
            else
            {
                selector = "div" +((graphType == "COMBO" && isSplineSel)?"[isSpline]":"")+ "[sgt='"+subType+"']";//NO I18N
            }
            subTypeEl = subGraphCont.querySelector(selector);   
            if(this.previousSelectedSubType){
                this.previousSelectedSubType.className = this.previousSelectedSubType.className.substring(0,
                    this.previousSelectedSubType.className.indexOf(" selected"));
            }
            subTypeEl.className += " selected";//NO I18N
            this.previousSelectedSubType = subTypeEl; 
        }
    }
    this.refreshView = function(event){
        ZDBToolTip.hide(null,true);
        var target =event.target || event.srcElement;
        var element = DOMUtils.getElOrParentWithAttr(target,"sgt");//NO I18N
        var isMiniChart = !(ZDBDialogUtil.focusDialog && ZDBAnalysisView.chartTypeDlg && ZDBDialogUtil.focusDialog == ZDBAnalysisView.chartTypeDlg);
        var view = (isMiniChart)?ZDBAnalysisView.miniChartTypeDlg.view:ZDBAnalysisView.chartTypeDlg.view;
        var graphType = (isMiniChart)?element.getAttribute("gt"):element.parentNode.getAttribute("id");
        if(graphType=="MAP_CHART" && element.getAttribute("isDisabled")=="true")
        {
              return;
        }
        if(graphType != "TABLE_CHART") // To Hide scrollFreeze Layer When Chart Type is Changed 
        {
            var dashChild = ZDBUtil.getParentWithAttributeValue(view.analysisArea,"elname","dlgmain"); //NO I18N
            if(dashChild != null)
            {   
                var scrollFreezeEl = dashChild.querySelector("[class='scrollFreeze']");//No I18N
                if(scrollFreezeEl != null)
                    scrollFreezeEl.style.display = "none";
            }
        }        
        graphType = (graphType == "FUNNEL")?"PIE":((graphType == "MAP_CHART") ? element.getAttribute("gt") :  graphType);//NO I18N
        var subGraphType = element.getAttribute("sgt");
        view.graphSelected = graphType;
        view.userGrpSel = graphType;
        view.userSubGrpSel = subGraphType;
        view.subGraphType = subGraphType;
        if(view.graphSelected == "COMBO")
        {
            var isSpline = element.getAttribute("isSpline");
            var curSplineSel = (isSpline == "true")?true:false;
        	if(view.chartObj)
    		{
        		var legendModel = view.chartObj.getLegendModel();
                legendModel.updateComboSplineSelected(curSplineSel);
    		}
//            }
//            else
//            {
//                view.isComboSplineSelected = curSplineSel;
//            }
            view.userSubGrpSel += curSplineSel ? "_SPLINE" : "_LINE"; //No I18N
        }
        ZDBAnalysisUtil.applyChanges(element,event);
        if(isMiniChart)
            ZDBAnalysisUtil.closeChartChooser(event);
        try{
            DashUtils.hideOptionsMenu();
        }
        catch(e){
            //NO dashboard opened
        }
        ZDBToolTip.hide();
    }
    this.initialize = function(currentlyEnabledChart,view){
        if(currentlyEnabledChart == "PIE" && view.subGraphType == "FUNNEL"){
            this.prevSelected = "FUNNEL";//NO I18N
        }
        else if(currentlyEnabledChart == "PIE"){
            this.prevSelected = "PIE";//NO I18N
        }
        
        else if(currentlyEnabledChart.match(/^(MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE|MAPPIEBUBBLE)$/)){
            this.prevSelected = "MAP_CHART";//NO I18N
        }
        else{
            this.prevSelected = currentlyEnabledChart;
        }
        var typesDiv = ZDBAnalysisView.chartTypeDlg.querySelector(".types");
        var types = typesDiv.querySelectorAll("span[elname]");//NO I18N
        var filter = Array.prototype.filter;
        var filteredTypes = types;
//        filteredTypes = filter.call(types,function(node)
//            {
//                var bool = node.hasAttribute("forjsch"); //NO I18N
//                if(bool)
//                {
//                    var attrVal = node.getAttribute("forjsch");
//                    if(!ZDBGlobal[attrVal])
//                    {
//                        node.style.display = "none";
//                        return false;
//                    }
//                }
//                return true;
//            }   )
        var containerWidth = 37 * filteredTypes.length;
        typesDiv.style.width = containerWidth + "px";
        for(var i=0; i<filteredTypes.length; i++){
            if(filteredTypes[i].className.indexOf(" hover") != -1)
            filteredTypes[i].className = filteredTypes[i].className.substring(0, filteredTypes[i].className.indexOf(" hover"));
            else if(filteredTypes[i].className.indexOf(" alpha") != -1)
            filteredTypes[i].className = filteredTypes[i].className.substring(0, filteredTypes[i].className.indexOf(" alpha"));
        }
        if(containerWidth > 407){
            var forwardArrow = ZDBAnalysisView.chartTypeDlg.querySelector(".ar.arA");//NO I18N
            forwardArrow.style.display = "block";
            var eventAttached = forwardArrow.getAttribute("eventAttached");
            if(!eventAttached){
                ZDBUtil.attachEvent(forwardArrow,"click",ZDBChartOptions.scrollGraphTypes);
                forwardArrow.setAttribute("eventAttached", true);
            }
            
        }
        var currentSelGraphTypeIndex = Array.prototype.indexOf.call(typesDiv.children, typesDiv.querySelector("span[elname='" + this.prevSelected + "']"));
        if(currentSelGraphTypeIndex >= 11){
            setTimeout(function(){ZDBChartOptions.scrollGraphTypes({target:ZDBAnalysisView.chartTypeDlg.querySelector("div[scrollDir]")})}, 0);
        }
        var subGraphTypesCont = this.disableOrEnable(this.prevSelected,true);        
        this.chooseSubType(view,subGraphTypesCont);
        this.enableDisableChartTypes(view,false);
        return this;
    }
    this.scrollGraphTypes = function(event){
        var target =event.target || event.srcElement;
        var src = DOMUtils.getElOrParentWithAttr(target,"scrollDir");//NO I18N
        var scrollDir = src.getAttribute("scrollDir");//NO I18N
        var container = ZDBAnalysisView.chartTypeDlg.querySelector(".types");//NO I18N
        var marginLeft;
        if(scrollDir == "forward"){
            var graphTypesLength = jQuery(container).children("span[elname]:visible").length;
            var additionalGraphTypes = graphTypesLength % 11;
            var previousMarginLeft = parseInt(container.style.marginLeft);
//            marginLeft = (previousMarginLeft < 0)?0:additionalGraphTypes * 37;
            
            if(previousMarginLeft < 0){
                marginLeft = 0;
                src.children[0].className = "ra";
            }
            else{
                marginLeft = additionalGraphTypes * 37;
                src.children[0].className = "la";
            }
        }
        else{
            marginLeft = 0;
        }
        jQuery(container).animate({marginLeft:-marginLeft},500,"easeInOutSine");//NO I18N
    }
    
    this.enableDisableSubChartTypes = function(view, allowedGraphs)
    {        
        this.enableMapSubTypes(view,allowedGraphs);
        this.enableBubbleSubTypes(view);
    }
    this.enableMapSubTypes = function(view,allowedGraphs)
    {
        var subGraphCont = ZDBAnalysisView.chartTypeDlg.querySelector(".subTypeCharts").querySelector("#" + "MAP_CHART");//NO I18N
        var sgts = subGraphCont.querySelectorAll("div[sgt]");
        for(var i=0;i<sgts.length;i++)
        {
            var el = jQuery(sgts[i]);
            var gt = el.attr("gt"); //NO I18N
            if(allowedGraphs.indexOf(gt) === -1)
            {
                el.addClass("alpha");
                el.attr("isDisabled","true"); //NO I18N
            }
            else 
            {
                el.removeClass("alpha");
                el.removeAttr("isDisabled");//NO I18N
            }
        }
    }
    // enable or disable bubble sub types in other charts dialog
    this.enableBubbleSubTypes = function(view)
    {
        var bubbleDiv = ZDBAnalysisView.chartTypeDlg.querySelector(".subTypeCharts").querySelector("#BUBBLE"); //No I18N
        var packBubbleDiv = bubbleDiv.querySelectorAll("div[sgt=\"PACKEDBUBBLE\"]")[0]; //No I18N
        var enable = view.chartSelectedEl.packBubbleAllowed;
        this.enableBubbleIcon(packBubbleDiv, enable);
            
        var bubbleIconDiv = bubbleDiv.querySelectorAll("div[sgt=\"DEF\"]")[0]; //No I18N
        enable = true;
        if(view.chartSelectedEl.isMultiY) {
            enable = (view.dropAreas.SIZEAXIS && view.dropAreas.SIZEAXIS.childElementCount === 1);
        }
        this.enableBubbleIcon(bubbleIconDiv, enable);
    }
    
    this.enableBubbleIcon = function(div, enable)
    {
        var el = jQuery(div);
        if(enable)
        {
            el.removeClass("alpha");
            ZDBUtil.attachEvent(div, "click", ZDBChartOptions.refreshView, false);
        }
        else
        {
            el.addClass("alpha");
            ZDBUtil.detachEvent(div, "click", ZDBChartOptions.refreshView, false);
        }
    }
    
    this.enableDisableChartTypes = function(view,forMiniChart){
        var allowedGraphs = view.chartSelectedEl.allowedGraphs.split(",");
        var containsMapTypes = new RegExp("MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE,MAPPIEBUBBLE").test(allowedGraphs);
        if(forMiniChart){
            var divs = ZDBAnalysisView.miniChartTypeDlg.querySelectorAll("div"),i,len;//NO I18N
            for(i=0,len=divs.length; i<len; i++){
                var div = divs[i];
                var graphType = div.getAttribute("gt");
                var subGraphType = div.getAttribute("sgt");
                if(allowedGraphs.indexOf(graphType) == -1 && !(graphType === "FUNNEL" && allowedGraphs.indexOf("PIE") != -1) &&
                    !(graphType === "MAP_CHART" && (containsMapTypes))){//NO I18N
                    div.style.display = "none";
                }
                if(graphType === "BUBBLE" && allowedGraphs.indexOf(graphType) > -1 && ((subGraphType === "PACKEDBUBBLE" && !view.chartSelectedEl.packBubbleAllowed) ||
                    (subGraphType === "DEF" && (view.chartSelectedEl.isMultiY && (!view.dropAreas.SIZEAXIS || view.dropAreas.SIZEAXIS.childElementCount !== 1))))){
                    div.style.display = "none";
                }
            }
        }
        else{
            var types = ZDBAnalysisView.chartTypeDlg.querySelector(".types").querySelectorAll("span[elname]");//NO I18N
            for(var i=0; i<types.length; i++){
                var thisType = types[i].getAttribute("elname");
                if(allowedGraphs.indexOf(thisType) == -1 &&
                    !(thisType == "FUNNEL" && allowedGraphs.indexOf("PIE") != -1) //NO I18N
                    && !(thisType === "MAP_CHART" && (containsMapTypes))//NO I18N
                    )
                {
                    types[i].className += " alpha";//NO I18N
                }
            }        
            this.enableDisableSubChartTypes(view,allowedGraphs);
        }
    }
    
    this.miniChartChooser = function(element,view, positioned){
        ZDBToolTip.hide(null,true);
        if(!ZDBAnalysisView.miniChartTypeDlg){
            ZDBContentCache.appendAndGet("Mini_Chart_Options_Dlg","GridMenu",document.body);
            ZDBAnalysisView.miniChartTypeDlg = $("ZDBMiniChartTypeDlg");
            var divs = ZDBAnalysisView.miniChartTypeDlg.querySelectorAll("div"),i,len;//NO I18N
            for(i=0,len=divs.length;i<len;i++){
                var div = divs[i];
                div.setAttribute("elname","holder");//NO I18N
                var is3D = div.getAttribute("is3D");
                if(is3D == "true")
                {
                    div.parentNode.removeChild(div);
                    continue;
                }
                ZDBUtil.attachEvent(div, "click", ZDBChartOptions.refreshView,false);
                ZDBUtil.attachEvent(div, "mouseenter", function(event){ZDBUtil.addClass(event.target, "hov")},false);
                ZDBUtil.attachEvent(div, "mouseleave", function(event){ZDBUtil.removeClass(event.target, "hov")},false);
            }
        }

        ZDBAnalysisView.miniChartTypeDlg.view = view;
        ZDBAnalysisView.miniChartTypeDlg.style.display = "";
        //ADD filtering of allowable chart types
        var divs = ZDBAnalysisView.miniChartTypeDlg.querySelectorAll("div"),i,len;//NO I18N
        for(i=0,len=divs.length; i<len; i++){
            var curDiv = divs[i];
            curDiv.style.display = "";
            ZDBUtil.removeClass(curDiv, 'selected');
        }
        this.enableDisableChartTypes(view,true);
        //ADD positioning of dlg
        var parent = ZDBUtil.getParentWithAttributeValue(element, "isdashboarddiv", "true"), titleBG = '';
        if(parent && parent.querySelector(".dashChildTitleDesc"))
            titleBG = getComputedStyle(parent.querySelector(".dashChildTitleDesc")).backgroundColor;
        //transparent used since firefox and IE returns transparent and not rgba
        if(!(element instanceof SVGElement)){
        	if(!titleBG ||  (titleBG && (titleBG == "rgba(0, 0, 0, 0)" || titleBG == 'transparent'))){
                ZDBUtil.addClass(element,"ZRMiniChartSrc WTTheme");
                ZDBAnalysisView.miniChartTypeDlg.style.borderRightColor = "#BDBDBD";//NO I18N
            }
            else{
                ZDBUtil.addClass(element,"ZRMiniChartSrc WTheme");
                ZDBAnalysisView.miniChartTypeDlg.style.borderRightColor = "#FFF";//NO I18N
            }
        }
        var isSpline = ZDBChartOptions.checkComboSplineNdUpdate(view, view.graphSelected);
        var itemToSelect = isSpline ? ZDBAnalysisView.miniChartTypeDlg.querySelector("div[gt='"+view.graphSelected+"'][sgt='"+view.subGraphType+"'][isspline='true']")//NO I18N
        		: ZDBAnalysisView.miniChartTypeDlg.querySelector("div[gt='"+view.graphSelected+"'][sgt='"+view.subGraphType+"']");//NO I18N
        itemToSelect && ZDBUtil.addClass(itemToSelect,"selected");
        if(!positioned){
        	var bounds = element.getBoundingClientRect();
            ZDBAnalysisView.miniChartTypeDlg.style.top = ((ZDBClientUI.standAlone && ZDBGlobal.IS_MOBILE) ? ZDBUtil.getObjTop(element,true) : bounds.top)+ bounds.height - 4 +"px";
            ZDBAnalysisView.miniChartTypeDlg.style.left = bounds.left + bounds.width - ZDBAnalysisView.miniChartTypeDlg.offsetWidth + "px";
        }
        ZDBAnalysisView.miniChartTypeDlg.src = element;
        
        ZDBUtil.attachEvent(document,"mouseup",ZDBAnalysisUtil.hideChartSelector,false);
        ZDBUtil.attachEvent(document,"keyup",ZDBAnalysisUtil.hideChartSelector,false);
    }
}
