 //$Id$

var ZDBVUDataAPI = new function()
{
  this.dlgId = 0;
  this.viewUDDiv=null;//will be initialized in ZDBAnalysisView stuff.
  this.vudTable = null;
  this.viewUDEl = function(element,event,extraParams)
  {
    var view = ZDBClientUI.getViewObj(element,"view");
    ZDBVUDataAPI.viewUD(view,extraParams);
  }
  
    this.getCriteria = function(event, params, prefix)
    {
        var selEl = ZDBUtil.getSourceElement(event);
        var view = ZDBClientUI.getViewObj(selEl,"view");
        if(view == null || view.chartArea.blured === true)
        {
            return;
        }
        var currentList = view.currentList;
        var graphSelected = view.chartSelectedEl.selectedGraph;
        var zavciList = new Array();
        for(var i1 =0; i1<currentList.length; i1++)
        {
            if(currentList[i1].getAttribute("xmlTagName") === "zavci")
            {
                zavciList.push(currentList[i1]);
            }
        }
        var data = params["data"];
        var yAxisList = ZDBVUDataAPI.getCurrentYAxisList(view);
        var criteria = "";
        if(!prefix)
        {
        	if(view.chartSelectedEl.isMultiY && data.length > 1)
    		{
        		prefix = "SG "; //No I18N
    		}
        	else
    		{
        		prefix = "GC "; //No I18N
    		}
        }
        var pieClr = false, axisData;
        if(graphSelected === "PIE" && view.chartObj.getColorIdx() !== null)
        {
            pieClr = true;
        }
        for(var i=0; i< data.length; i++)
        {
            var curData = data[i];
            var instId = curData["columnindex"];
            if(!zavciList[instId])
            {
                continue;
            }
		  
            var actDataType = curData["operation"];
            if(actDataType == "SUM" || actDataType == "MAX" || actDataType == "DC" || actDataType =="STD" ||//No I18N
                            actDataType == "MIN" || actDataType =="AVG" || actDataType =="COUNT" || actDataType == "STATS_MODE" ||actDataType == "MEDIAN" || actDataType == "AGG_FORMULA" ||//No I18N
                            actDataType == null || (actDataType.length >= 2 && actDataType.substring(actDataType.length - 2) == "DC"))//No I18N
            {	// this null check is spcific for multiY Pie chart case
            	if(view.chartSelectedEl.isMultiY)
        		{
            		var yIndex = yAxisList.indexOf(zavciList[instId])
            		if(yIndex != -1)
        			{
            			prefix += yIndex + ","; // For multiY - will be useful in Agg. Formula Column
        			}
        		}
            	continue;
            }
            else if(actDataType == "CONTINUOUS" && !view.chartSelectedEl.isMultiY)
            {
                var contVal = (curData["value"] + ""); //No I18N
                if(contVal.indexOf("to") >= 0 ||
                            contVal.indexOf("below") >= 0 ||
                            contVal.indexOf("above") >= 0 )
                    {
                    continue;
                    }
            }
            else if(yAxisList.indexOf(zavciList[instId]) != -1 && data.length > 1)
        	{
            	prefix = "GC "; //No I18N
        	}
            if(axisData) {
                curData = axisData;
            }
            var chartData = view.chartObj.getData();
            actDataType = chartData.metadata.columns[instId].operation;
            var subFuncType = this.getSubFuncType(curData, graphSelected, actDataType);
            var datatype = curData["datatype"];
            criteria +=  instId + " " + this.getCriteriaVal(subFuncType, curData["value"], curData[datatype], curData);
            criteria += ",";
            if(pieClr) {
                axisData = curData;
            }
        }
        if(prefix)
    	{
        	criteria = prefix + criteria;
    	}
        if(criteria == "")
        {
        	return null;
        }
        return criteria;
    };
    
    this.getCurrentYAxisList = function(view)
    {
    	var currentList = view.currentList;
    	var arr = [];
    	for(var i=0; i<currentList.length; i++)
    	{
    		var viewType = currentList[i].getAttribute("viewType");
    		if(viewType == "YAXIS")
			{
    			if(view.chartSelectedEl.isMultiY)
				{
    				arr.push(currentList[i]);
				}
			}
    	}
    	return arr;
    }
  
    this.getSubFuncType = function(curData, graphSel, actDataType)
    {
        var datatype = curData["datatype"];
        var subfunctype = curData[datatype]["subfunction"];
        subfunctype = (curData[datatype]["format"] && curData[datatype]["format"]["customFormat"]) // if CustomFormat is there, use CustomFormat
		? curData[datatype]["format"]["customFormat"] : subfunctype;
        if(!subfunctype || subfunctype == "FORMAT_DATE_TYPE")
        {
            subfunctype = datatype; // if there is no subfunction - check for datatype
            if(datatype == "ordinal" && jQuery.inArray(actDataType, ["MONTH", "QUARTER", "WEEK", "WEEKDAY"]) !== -1)
            {
                subfunctype = actDataType;
            }
        }
        return subfunctype;
    }
  
  this.getCriteriaVal = function(subFuncType, value, formatConf, curData)
  {
	  if(value == null)
	  {
		  return "--NULL--"; //No I18N
	  }
	  var criteriaVal = "";
	  var formatFun = formatConf["useUTC"] ? d3.time.format.utc : d3.time.format;
	  switch(subFuncType)
	  {
		  case "YEAR" : criteriaVal += formatFun("%Y")(new Date(Number(value))); //No I18N
			  break;
		  case "FISCALYEAR" : criteriaVal += ZCFormatUtil.getFiscalYearFormat(Number(formatFun("%Y")(new Date(Number(value)))), formatConf["fyFormat"], formatConf["fyPrefix"], true);; //No I18N
		  	  break;
		  case "ABSQUARTERFMT" : //No I18N
			  var date = new Date(Number(value));
			  var dataType = curData["datatype"];
			  if(curData[dataType]["FISCAL_QUARTER"] == true)
			  {
				  var startMonth = formatConf["startMonth"];
				  if(startMonth == null)
				  {
					  startMonth = 0;
				  }
				  var quarter = ZCFormatUtil.calculateFiscalQuarter(date, startMonth, formatConf);
				  var fyYear = ZCFormatUtil.getFormattedFiscalYear(date, startMonth, formatConf, true);
				  criteriaVal += fyYear + "" + quarter;
			  }
			  else
			  {
				  var month = formatConf["useUTC"] ? date.getUTCMonth() : date.getMonth();
				  var quarter = Math.floor(month/3) + 1;
				  criteriaVal = criteriaVal + formatFun("%Y")(date) + quarter;//No I18N
			  }
			  break;
		  case "ABSMONTH" : criteriaVal += formatFun("%Y%m")(new Date(Number(value))); //No I18N
		  	  break;
		  case "ABSWEEK"://No I18N
		  case "ABSWEEKSHORTEXT" : //No I18N
		  case "ABSWEEKMEDIUMEXT" : //No I18N
			  value = Number(value);
			  var weekNumber = ZCFormatUtil.getWeek(value, formatConf);
			  criteriaVal += ZCFormatUtil.getWeekYear(value, formatConf, true) + "" + weekNumber; //No I18N
		  	  break;
		  case "ABSWEEKLONGEXT": //No I18N
			  value = Number(value);

			  var weekNumber = ZCFormatUtil.getWeek(value,formatConf);
			  criteriaVal += ZCFormatUtil.getWeekYear(value, formatConf, 1)+""+weekNumber;

			  break;
		  case "MONTH"://No I18N
			  var monthArr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];//No I18N
			  var index = parseInt(monthArr.indexOf(value)) + 1;
                          var startMonth = formatConf["startMonth"];
                          if(startMonth)
                          {
                              index = (index - startMonth + 12);
                              if(index > 12) {
                                  index %= 12;
                              }
                          }
			  criteriaVal += index;
			  break;
		  case "QUARTER"://No I18N
			  var index = value.substring(1, 2);
			  criteriaVal += index;
			  break;
		  case "WEEK"://No I18N
			  var index = value.substring(4);
			  criteriaVal += index.trim();
			  break;
		  case "WEEKDAY"://No I18N
			  var weekDayArr = ["Sun", "Mon", "Tue","Wed","Thu","Fri", "Sat"];//No I18N
                          var index = weekDayArr.indexOf(value);
                          var startWeekday = formatConf["startWeekDay"];
                          if(startWeekday)
                          {
                              index -= startWeekday;
                              if(index < 0) {
                                  index = (index + 7) % 7;
                              }
                          }
			  criteriaVal += index;
			  break;
		  default : criteriaVal += ZDBUtil.replaceStr(value, ",", "--C--"); 
			  break;
	  }
	  return criteriaVal;
  }

  this.viewUD = function(view, extraParams)
  {
    var dashView = view.viewCtx.dashChildDiv;
    var iOS = ZDBGlobal.IS_IOS;
    var isAndroid = ZDBGlobal.IS_ANDROID;
    var width = jQuery(window).width();
    var height = jQuery(window).height();
    var iOSDisplay = false;
    var vInEmbed = (ZDBClientUI.standAlone==true);
    if(isAndroid || (iOS && vInEmbed && width > 750 && height > 600)) {
        iOSDisplay = true;
    }
    if(!vInEmbed || iOSDisplay)
    {
      if(!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList","APPENDTODOC",ZDBVUDataAPI.viewUD,[view, extraParams]))
      {
        return;
      }
    }
    if(!view.permissions.vud)
    {
      return;
    }
//    ZDBChartUtil.hide(null,view);
    var canContinue = view.eModeHelper.validateView(view);
    if(canContinue==false)
    {
      return;
    }
    
    if(ZDBVUDataAPI.UDopened == true)
    {
      return;
    }
    
    var viewUDDiv = ZDBVUDataAPI.viewUDDiv.cloneNode(true);
    ZDBUtil.setNamedChildEls(viewUDDiv,viewUDDiv);
    var gridHolder = viewUDDiv.gridHolder;
    if(extraParams)
    {
      var vudCriteria=ZDBEscapeUtil.encodeForXML(extraParams);
      extraParams ="CRITERIA='"+vudCriteria+"'";  //No I18N    
    }
    var configInfo = view.getConfigInfo("VUDSheet",extraParams);  //No I18N
    if(!iOSDisplay && !BROWSER.IPHONE)
    {
        if(vInEmbed)
        {
          window.self.embedConfigInfo = configInfo;
          window.self.embedConfigInfo["PLHOLDER"] = gridHolder;
          var heightNWidth = "width=750,height=412"; //No I18n
          var params = view.getViewParams();
          var viewUDWindow = window.open (ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?VIEWACTION=VUD" + params,"viewUDWindow","location=no,resizable=yes," + heightNWidth + ",top="+(window.screen.availWidth*0.20)+",left="+(window.screen.availHeight*0.30));
          return;
        }
    } 
    
    viewUDDiv.style.display="block";
    gridHolder.id =  "VUD_" + ZDBVUDataAPI.dlgId++;
    document.body.appendChild(viewUDDiv);
    ZDBMenu.enableDisableMenuItems(view,jQuery(viewUDDiv).find("li a"),true);
    var reSize = ZDBGlobal.IS_MOBILE ? false : true ;
    var onclosefn = function(){
    	if(ZDBGlobal.IS_MOBILE && !(BROWSER.IS_MOBILE_PHONE && view.viewCtx.dashView)) 
        {
        window.removeEventListener("orientationchange" ,orientfn);
        }
        return true ;		  
       }
    var mainDlg = ZDBDialogUtil.showDialog(viewUDDiv,{TITLE:ZDBI18NMap.g('zrpt.common.vud.js.dlgTtl'),
                                                      ADDFRAME:true,DLGBODY:"dlgBody noPadding", //No I18n
                                                      MODAL:true,
                                                      ONCLOSE:ZDBVUDataAPI.viewUDDlgClosed,
                                                      VIEW: view, 
                                                      RESIZE:reSize,
                                                      IOS:iOSDisplay,
                                                      NOFOCUS:true,
                                                      PLHOLDER:gridHolder,
                                                       });
    mainDlg.onclosefn = onclosefn;
    mainDlg.orientfn = orientfn ;
    if((!isAndroid && iOSDisplay) && dashView) {   // for iPad display the VUD above the chart clicked
        mainDlg.style.top = dashView.offsetTop + "px"; // adjust Y-POS alone
    }
    
    //setting appropriate size for VUD by using inner function 
    function dlgresize()
    {
      var docHeight = document.body.offsetHeight;
      var docWidth = document.body.offsetWidth;
      var vudHeight = gridHolder.offsetHeight;
      var vudWidth = gridHolder.offsetWidth;
      
      if(ZDBGlobal.IS_MOBILE)
      {
    	if(docHeight > window.innerHeight + 1)
		{
    		docHeight = window.innerHeight;
		}
    	if(docWidth > window.innerWidth + 1)
		{
    		docWidth = window.innerWidth;
		}
      }
      
      var dlgHeight = mainDlg.offsetHeight;
      var heightDiff = dlgHeight - vudHeight;
      var newHeight = 0, newWidth = 0;
    
      if(docHeight <= dlgHeight && !BROWSER.IS_MOBILE_PHONE)
	  {
    	var modHeight = docHeight * .80;
    	newHeight =  (modHeight - heightDiff);
    	gridHolder.style.height = (newHeight > 150 ? newHeight : 150) + "px";
    	//Hope that the screen size is not less than 250 px
	  }
      if(docWidth <= vudWidth && !BROWSER.IS_MOBILE_PHONE)
	  {
    	newWidth = docWidth * .80;
    	gridHolder.style.width = (newWidth > 300 ? newWidth : 300) + "px";
        //Hope that the screen size is not less than 300 px
	  }
    if(BROWSER.IS_MOBILE_PHONE) //Fixing VUD height for mobile app and browser
    {
      newHeight = docHeight * .65;
      gridHolder.style.height = newHeight + "px";
      newWidth = docWidth;
      gridHolder.style.width = newWidth + "px";
    }
    ZDBDialogUtil.positionCenter(mainDlg);
    return docHeight;
    }
    
    dlgresize();
    function orientfn()
    { 
        setTimeout(function()
        { 
            var docHeight = dlgresize();
            if(BROWSER.IS_MOBILE_PHONE)
            {
            var vudDiv = ZDBDialogUtil.focusDialog;
            var deviceWidth = document.body.offsetWidth;
            var nHeight = docHeight * .80;
            vudDiv.action = "RESIZEALL"; //No I18N
            ZDBDialogUtil.initContants();
            ZDBDialogUtil.resizeVUDGrid(vudDiv,nHeight,deviceWidth);
            ZDBDialogUtil.positionCenter(vudDiv);
            }
        }, 200);
    }
    if(ZDBGlobal.IS_MOBILE && !(BROWSER.IS_MOBILE_PHONE && view.viewCtx.dashView)) 
    {
    	window.addEventListener("orientationchange",orientfn , false);
    }
    ZDBVUDataAPI.UDopened = true;

    var viewCtx = new ZDBVUDCtx(gridHolder,view.viewCtx);
    AjaxAPI.sendRequest({URL:configInfo["REQURL"],
                               POSTBODY:configInfo["REQBODY"],
                               REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},//No I18N
                               ONABORTFUNC:ZDBVUDataAPI.abortResponse,
                               ONSUCCESSFUNC:ZDBVUDataAPI.handleVUDResponse,
                                               PLHOLDER:gridHolder,
                                               EMBEDWINDOWMODE:false,
                                               CONFIGINFO:configInfo,
                                               DIALOGDIV:viewUDDiv,
                                               VIEWCTX:viewCtx,
                                               VIEW:view,
                                               OPSTATUSID:viewCtx.getLoadIndicator(),
                                               DIALOG:mainDlg,
                                               VUDTABLESCOMBO:viewUDDiv.vudTablesCombo,
                                               VUDTABLESDIV:viewUDDiv.vudTablesDIV});
  }


 this.changeTable = function(gridObj)
  {

      var viewUDDiv = gridObj.vudDlgDiv;
      
      if(gridObj.filterVisible)
      {
          gridObj.hideFilter('none'); //No I18n
      }
      var postBody = gridObj.getConfigAsXML(null , true);

      var viewCtx = gridObj.viewCtx;//new ZDBVUDCtx(viewUDDiv.gridHolder,view.viewCtx);
      var plHolder = (viewUDDiv != null) ? viewUDDiv.gridHolder : gridObj.configInfo["PLHOLDER"];
      AjaxAPI.sendRequest({URL:gridObj.configInfo["REQURL"], //No I18n
                                   POSTBODY:postBody,
                                   REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18n
                                   ONSUCCESSFUNC:ZDBVUDataAPI.handleVUDResponse,
                                                     PLHOLDER:plHolder,
                                                     EMBEDWINDOWMODE:gridObj.winMode,
                                                     DIALOGDIV:viewUDDiv,
                                                     VIEWCTX:viewCtx,
                                                     VIEW:gridObj,
                                                     OPSTATUSID:viewCtx.getLoadIndicator(),
                                                     DIALOG:gridObj.vudMainDlg,
                                                     VUDTABLESCOMBO:gridObj.vudTablesCombo,
                                                     VUDTABLESDIV:gridObj.vudTablesDIV,
                                                     CONFIGINFO:gridObj.configInfo});
  }
  
  this.abortResponse = function(response,reqOptions)
  {
    var vudDlg = $("ZDBViewUDDlg");
    if(vudDlg)
    {
      if(vudDlg.style.display == "none")
      {
        return true;
      }
    }
    else
    {
      return true;
    }
    return false;
  }



  this.sendVUDRequestInWindow = function(objId)
  {
    if(!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList","APPENDTODOC",ZDBVUDataAPI.sendVUDRequestInWindow,[objId]))
    {
      return;
    }    
    var tab = ZDBClientUI.createDummyTab(objId,ZDBI18NMap.g('zrpt.common.vud.js.dlgTtl'),ZDBClientUI.dummyGrid,"VUDSheet");//No I18N
    AjaxAPI.sendRequest({URL:window.opener.embedConfigInfo["REQURL"],
                               POSTBODY:window.opener.embedConfigInfo["REQBODY"],
                               PLHOLDER:window.opener.embedConfigInfo["PLHOLDER"],
                               CONFIGINFO:window.opener.embedConfigInfo,
                               REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},//No I18N
                               EMBEDWINDOWMODE:true,
                                                 ONSUCCESSFUNC:ZDBVUDataAPI.handleVUDResponse,
                                                 OPSTATUSID:tab.viewCtx.getLoadIndicator(),
                                                 VIEWCTX:tab.viewCtx,
                                                 VIEW:tab.view,
                                                 PARVIEW:tab});
  }

this.handleVUDResponse = function(response, reqOptions)
{
	if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBGridList","ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList","ZRDashboardView","ZAAnalysisFields"],"APPENDTODOC",ZDBVUDataAPI.handleVUDResponse,[response, reqOptions]))
    {
      return;
    }
	if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", ZDBVUDataAPI.handleVUDResponse,[response, reqOptions])){
    	return;
    }
    if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBVUDataAPI.handleVUDResponse,[response, reqOptions]))
    {
        return;
    }
    var respText = response.responseText;
    var winMode = reqOptions["EMBEDWINDOWMODE"];
    var viewCtx = reqOptions["VIEWCTX"];
    var view = reqOptions["VIEW"];
    var vudTblsCombo = reqOptions["VUDTABLESCOMBO"];
    var vudTblsDiv = reqOptions["VUDTABLESDIV"];
    var gridObj = ZDBDataGrid.parseGridResponse(null, respText);
    var title = gridObj.zaTitle;
    gridObj.winMode = winMode;
    if(title != null)
    {
      gridObj.displayName = title;
    }
    if(!winMode)
    {//dlgChild will null for embeded - window mode.
      var dlgChild = reqOptions["DIALOGDIV"]; //No I18N
      dlgChild.gridObj = gridObj;
//      ZDBChartUtil.hide(null,view);
      dlgChild["view"] = gridObj;
      if(title != null)
      {
        var dlg = reqOptions["DIALOG"]; //No I18N
        dlg.dlgTitle.innerHTML = ZDBEscapeUtil.encodeForHtml(title);
      }
    }
    else
    {
        vudTblsDiv = $("vudTabSelDIV");
        vudTblsCombo = $("vudTs");
    }

    gridObj.showHide.setAttribute("tip",ZDBI18NMap.g('zrpt.common.reorder.js.vud'));
    var grTables = gridObj.vudTables;
    var comboHTML = "";
    if(ZDBGlobal.IS_MOBILE && grTables != null)
      document.getElementById("VUDToolbar").style.display = "block";  
    gridObj.parView = reqOptions["VIEW"]; //No I18N
    if(vudTblsCombo!= null)
    {
        vudTblsCombo.innerHTML="";
        if(grTables != null && grTables.length > 0)
        {
            vudTblsDiv.style.display="block";                        
            for (i=0; i<grTables.length; i++)
            {
                //var selected = gridObj.parView.vudTableObjId != null && grTables[i][0] == gridObj.parView.vudTableObjId ? " selected='true' " : ""; //No I18N
                //var selected = gridObj.vudTblObjId != null && grTables[i][0] == gridObj.vudTblObjId ? " selected='true' " : ""; //No I18N
                //comboHTML +="<option "+selected+"value='"+grTables[i][0]+"'>"+grTables[i][1]+"</option>"; //No I18N
                var selected = gridObj.vudTblObjId != null && grTables[i][0] == gridObj.vudTblObjId ? 1 : 0;
                var option = document.createElement("option");
                option.setAttribute("value",grTables[i][0]);
                option.innerHTML=ZDBEscapeUtil.encodeForHtml(grTables[i][1]);
                if(selected == 1)
                {
                  option.setAttribute("selected",'true');
                }
                vudTblsCombo.appendChild(option);
            }
            if(!ZDBGlobal.IS_MOBILE){reqOptions["PLHOLDER"].style.width = "800px";}
            if(!winMode)
            {                
                var VUDDlg = ZDBDialogUtil.focusDialog;                
                ZDBUtil.setNamedChildEls(VUDDlg,VUDDlg,"elname");
                VUDDlg.resizeTB.style.width = "780px";
                ZDBMenu.resizeIframe(VUDDlg);                
            }
        }
        else
        {
            vudTblsDiv.style.display="none";
            vudTblsCombo.innerHTML = "";
        }
    }    
    
    if(reqOptions["CONFIGINFO"] != null)
    {
        gridObj.configInfo = reqOptions["CONFIGINFO"]; //No I18N
    }

    if(gridObj.configInfo != null && reqOptions["POSTBODY"] != null)
    {
        gridObj.configInfo["REQBODY"] = reqOptions["POSTBODY"];
    }
    gridObj.vudDlgDiv =reqOptions["DIALOGDIV"]; //No I18N
    gridObj.vudMainDlg =reqOptions["DIALOG"]; //No I18N
    gridObj.vudTablesCombo = vudTblsCombo;
    gridObj.vudTablesDIV = vudTblsDiv;
    viewCtx.handle(gridObj);
    if(BROWSER.SAFARI == 1) //  to fix safari issue , safari current version only computes table layout fixed after this
	  {
    	ZDBUtil.removeAndInsertJsObj(gridObj);
	  }
    gridObj.maintainWidthArray(gridObj.colHead);// to maintainwidth array for VUD as same as that of table
    if(gridObj.totalRecords == gridObj.dTable.children.length-1)
    	{
    	gridObj.setFillerHeight();
    	}
    else
    	{
    gridObj.adjustInViewRowsHeight(); 
    	}
  }

  this.exportVUD = function(el,exportType)
  { 
    var dlg = ZDBDialogUtil.focusDialog ? ZDBDialogUtil.focusDialog.dlgBodyDIV:null;
    ZDBExport.exportAs(el,exportType,"vud",el.getAttribute("isEmail"),el.getAttribute("ISNORMALDBEXP")); //No I18N
  }


  this.viewUDDlgClosed = function(viewUDDlg, event)
  {          
    var parAnalView = viewUDDlg.params["VIEW"];
    var gridObj = viewUDDlg.params["PLHOLDER"].view;
    if(gridObj)
    {
        parAnalView.vudTblObjId = gridObj.vudTblObjId;
    }
    ZDBVUDataAPI.UDopened = false;
    viewUDDlg.onclosefn();
    return true;
  }
  
  this.showExportMenu = function(el,event,contentName,moduleName)
  {
    if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBExportNShare"],"APPENDTODOC",ZDBVUDataAPI.showExportMenu,[el,event,contentName,moduleName]))
    {
        return;
    }
    urls = ["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES"];//NO I18N
    if(!ZDBLazyLoadUtil.loadCssOnly(urls, "APPENDTODOC", 
            ZDBVUDataAPI.showExportMenu,[el,event,contentName,moduleName])){
        return;
    }
    var attachEl = (!ZDBClientUI.standAlone) ? $("VUDToolbar") : document.body;
    var menu = ZDBContentCache.appendAndGet(contentName,moduleName,attachEl);
    var view = ZDBClientUI.getViewObj(el,"view"); //No I18N
    ZDBMenu.showMenu(el,event,menu,true,view);
    if(!ZDBClientUI.standAlone)
  	{
      ZDBVUDataAPI.menuPosition(menu, el);
  	}
  }
  
this.showTables =function(el)
{
    var view = ZDBClientUI.getViewObj(el,"view"); //No I18N

}

this.setVUDTableAndRefresh=function(event , el)
{
 var gridObj = ZDBClientUI.getViewObj(el,"view"); //No I18N
 if(this.setVUDTable(event , el , gridObj))
 {
     this.changeTable(gridObj);
 }
}

this.setVUDTable =function(event , el , gridObj)
{
if(event == null){event = window.event;}
  var selectedEl = ZDBUtil.getSourceElement(event);
var view = gridObj == null ? ZDBClientUI.getViewObj(selectedEl,"view") : gridObj; //No internationalization
var srcEl = ZDBUtil.getSourceElement(event);
if(view.vudTblObjId == null || view.vudTblObjId != srcEl.value)
{
    view.vudTblObjId = srcEl.value;
    return true;
}
else
{
    return false;
}
  
    //var view = ZDBClientUI.getViewObj(el,"view"); //No I18N
    //console.log(view);    
    //console.log(selectedEl);    
}

this.getConfigXmlAsParam = function(viewObj,type)
  {
    if(viewObj.type == "VUDSheet")
    {
      var conf = viewObj.getConfigAsXML();
      return "&ZADO=" + encodeURIComponent(conf); //No I18N
    }
    else
    {
      return "&ZADO=" + encodeURIComponent(viewObj.getConfigAsXMLForGrid(type));    //No I18N
    }
  }
}




function ZDBVUDCtx(parComp,parCtx)
{
   this.parComp = parComp;
	 this.parCtx = parCtx;
}


ZDBVUDCtx.prototype = new ZDBDefViewCtx;

ZDBVUDCtx.prototype.getAdditionalParams = function()
{
	return this.parCtx.getAdditionalParams();
}

ZDBVUDataAPI.sortIconClicked = function(gridObj, sortType)
{
    if(gridObj == null){return;}
    var colHeads = gridObj.colHeaders;
    var colLen = colHeads.length; 
    var sortIndex = -1;
    for(var i=0; i < colLen; i++)
    {
      var colObj = colHeads[i];
      if(!colObj.grouped)
      {
        colObj.sortOrder = 0;
        colObj.setClass();
      }
      else
      {
        sortIndex++;
      }
      var index = ZDBUtil.indexOf(gridObj.selectedCols, colObj);
      if(index != -1)
      {
        colObj.sortOrder = sortType;
        colObj.sortIndex = ++sortIndex;
        var setallColhead = function(elmt){
          if(elmt[ZDBGlobal.columnId] == colObj.colName){
          elmt[ZDBGlobal.columnSortOrder] = colObj.sortOrder;
        elmt[ZDBGlobal.columnSortIndex] = colObj.sortIndex;
          }
          else{
          elmt[ZDBGlobal.columnSortOrder] = 0;
          elmt[ZDBGlobal.columnSortIndex] = -1;
          }
        }
        gridObj.allColHead.forEach(setallColhead);
        colObj.setClass();
      }
    }
}

ZDBVUDataAPI.sortColumn = function(el,event, sortType)
{
    var gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
    if(gridObj == null){return;}
    if(gridObj.selectedCols.length ==0) 
    { 
      var curCell = ZDBDataGrid.getLastFocusCell(gridObj);
      if(curCell == null)
      {
        ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selCol2SortErr"));
        return;
      }
      var curColObj = curCell.colObj;
      if(!curColObj)
      {
          ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selColsErr"));
          return; 
      }
      gridObj.addSelectedCol(curColObj);
    }
    var colHeads = gridObj.colHeaders; 
    var colLen = colHeads.length; 
    if(sortType == ZDBSorting.NONE)
    {
      var isSortPresent = false;
    	var curHead;
      for(var i=0;i<colLen;++i)
      {
        curHead = colHeads[i];
        if(curHead.objType != ZDBConst.COLHEAD)
        {
          continue;
        }
        if(colHeads[i].sortOrder != 0)
        {
            isSortPresent = true;
            break;    
        }
      }
      if(!isSortPresent)
      {
        ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.remSortingErr"));
        return; 
      }
    }
    ZDBVUDataAPI.sortIconClicked(gridObj,sortType);
    ZDBTableGrid.refreshDataForView(gridObj,ZDBI18NMap.g("zrpt.common.js.sorting"));    
    return true;
}

ZDBVUDataAPI.showSortMenu = function(el,event,menuContentName,moduleName)
{
	var attachEl = (!ZDBClientUI.standAlone) ? $("VUDToolbar") : document.body;
	var menu = ZDBContentCache.appendAndGet(menuContentName,moduleName,attachEl);
  ZDBPopUpMenu.showHideVUDMenuItems(false);
  ZDBMenu.showMenuEl(el,event,menu,true);
  if(!ZDBClientUI.standAlone)
  {
	ZDBVUDataAPI.menuPosition(menu, el);
  }
  
}

  ZDBVUDataAPI.menuPosition = function(menu, srcEl)
  {
	var el = jQuery(srcEl);
	var pos = el.position();
	var top = pos.top + el.outerHeight() - 1;
	jQuery(menu).css({left:pos.left,top: top});
  }


ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBVUDataAPI.exportVUD"]=ZDBVUDataAPI.exportVUD;
