//$Id$

function ZRMap() {
    var map,
            mapControl,
            mapSearchControl,
            mapSearchBox,
            marker,
            controls,
            hideSearch,
            baseGeoRole,
            timerControl,
            timerToggle,
            canEditUnknown,
            unknownLocDet;
           
    var zrmapUI = L.Control.extend({
        options: {
            position: 'topleft', //No I18N
        },
        initialize: function (options) {
            L.setOptions(this, options);
            this._controls = [];
        },
        onAdd: function (map) {
            this._container = L.DomUtil.create('div', 'zrmap-control-container');  //No I18N
            L.DomEvent.on(this._container, 'dblclick', L.DomEvent.stopPropagation);   //No I18N
            this._render();
            return this._container;
        },
        addOption: function (name,tip, html, eventName,eventHandler, expandable, expandElement) {
            var newControl = {
                name: name,
                tip: tip,
                html: html,
                eventName: eventName,
                eventHandler:eventHandler,
                expandable: expandable ? expandable : this.options.expandable,
                expanded: false
            };
            expandable ? newControl["expandElement"] = expandElement : null;
            this._controls.push(newControl);
        },
        _render: function () {
            if (!this._container) {
                return;
            } else {
                this._flushContainer(this._container);
                var context = this;
                this._controls.forEach(function (control) {
                    var containerElement = L.DomUtil.create('div', "zrmap-control")    //No I18N
                    var mainElement = L.DomUtil.create('div', 'zrmap-control-main');   //No I18N
                    containerElement.appendChild(mainElement);
                    mainElement.setAttribute("tip",control.tip);
                    mainElement.innerHTML = control.html;
                    control.mainElement = mainElement;
                    control.containerElement = containerElement;
                    containerElement.control = control;
                    mainElement.control = control;
                    var handler=control.eventName;
                    if(handler == 'mouse')
                    {    
                        L.DomEvent
                            .on(containerElement, 'mouseenter', function (event) {   //No I18N  
					controls.forEach(function (control){
                            control.showToggle();
                           });
                                        clearTimeout(timerToggle); 
                                        clearTimeout(timerControl);                                     
                            drillMenu = document.querySelectorAll("[drillmenu='true']")[0];
                            if(control.expandable && !control.expanded && (drillMenu ? drillMenu.getAttribute("style").indexOf("display: none") == -1 ? false : true : true))
                            {
                                ZRMap.expandControl(control);
                            }
                                        
                            })
                              .on(containerElement, 'mouseleave', function (event) { 
                                        if(!jQuery(event.currentTarget).find("[elname='searchinputEl']")[0].value)
                                        {
                                        timerControl=setTimeout(function(){
                                            ZRMap.collapseControl(control);   
                                        },500); 
                                        }
                            }) 
                         .on(containerElement, 'click', function (event) {   //No I18N       
                                    jQuery(control.expandContainer).find("[elname='searchinputEl']").focus();
                            })    
                    }
                    else if(handler == 'click')
                    {
                        L.DomEvent
                                .on(containerElement, 'click', function (event) {   //No I18N                         
                                    ZRMap.expandControl(control); 
                            })
                                .on(containerElement, 'click', function(event){    //NO I18N                                
                               drillMenu = document.querySelectorAll("[drillmenu='true']")[0];
                                    if(drillMenu ? drillMenu.getAttribute("style").indexOf("display: none") == -1 ? false : true : true)
                                control.eventHandler(event);
                            }) ;
                    }
                          L.DomEvent
                               
                            .on(containerElement, 'click', L.DomEvent.stopPropagation)      //No I18N
                            .on(mainElement,'mouseover',function(event){ZDBToolTip.show(this,event);}) //No I18N
                            .on(mainElement,'mouseout',function(event){ZDBToolTip.hide(this,event);})//No I18N
                            .on(containerElement, 'mouseover', L.DomEvent.stopPropagation);  //No I18N                    
                    if (control.expandable) {                             
                        if(control.name == 'search')
                        {
                            var expandContainer = L.DomUtil.create('div', 'zrmap-control-expand');   //No I18N
                        }   
                        if(control.name == 'unknown_data')
                           var expandContainer = L.DomUtil.create('div', 'zrmap-control-unknown-expand');   //No I18N
                        expandContainer.appendChild(control.expandElement);
                        control.expandContainer = expandContainer;
                        L.DomEvent
                                .on(expandContainer, 'click', L.DomEvent.stopPropagation)         //No I18N
                                .on(expandContainer, 'dblclick', L.DomEvent.stopPropagation)        //No I18N
                                .on(expandContainer, 'mousewheel', L.DomEvent.stopPropagation); //No I18N
                        containerElement.insertBefore(expandContainer, containerElement.children[0]);
                    }
                    jQuery(mainElement).addClass((control.name=="unknown_data" ? "zrmap_unknown_data" : (control.name=="reset" ? "zrmap_home_main" : "")))
                            .css("overflow",control.name=="search"? "auto":"");
                        
                    control["htmlElement"] = containerElement;
                    context._container.appendChild(containerElement);
                });
            }
        },
        _flushContainer: function (container) {
            while (container.lastChild) {
                container.removeChild(container.lastChild);
            }
        },
        collapseAll: function (curControl) {
            this._controls.forEach(function (control) {
                if(curControl == control)
                {
                    return;
                }
                ZRMap.collapseControl(control);
            });
        },
        getContainer: function () {
            return this._container ? this._container : null;
        },
        showToggle: function () {
             d3.select(this._container).attr("class","zrmap-control-container_show leaflet-control");// NO I18N
        },
        hideToggle: function () {
           d3.select(this._container).attr("class","zrmap-control-container leaflet-control");// NO I18N
            this.collapseAll();
        }
    });

ZRMap.collapseControl =function(control)
        {          
            if (control.expanded) {
                    control.expanded = false;
                    if(control.expandElement.clear)
                    {
                        control.expandElement.clear(); // to clear search on hiding/closing
                    }                    
                   if(control.name == 'unknown_data')
                    {
                        if(jQuery(control.expandContainer).is(':visible')){  
                            jQuery(control.expandContainer).slideUp('medium');//No I18N
                    }   
                    }
                    jQuery(control.expandContainer).find("[elname='searchinputEl']").blur();
                    jQuery(control.expandContainer).find('[elname="searchinputEl"]').removeAttr("placeholder","Search");  //No I18N
                    L.DomUtil.removeClass(control.containerElement, 'zrmap-control-clicked');  //No I18N
                    L.DomEvent.off(document,'keydown',function(event){});  //No I18N
                }
                else if(control.active)
                {
                    selectToZoom.toggle(control);
                }
        }
ZRMap.expandControl = function(control)
{
    controls.forEach(function (control){
        control.collapseAll(control);
    });
    if (control.expandable && !control.expanded) {
        L.DomUtil.addClass(control.containerElement, 'zrmap-control-clicked');  //No I18N 
//        setTimeout(function(){  
        jQuery(control.expandContainer).find("input:visible:first").focus();     
        jQuery(control.expandContainer).find('[elname="searchinputEl"]').attr("placeholder","Search"); //No I18N
//        },300);
        L.DomEvent.on(document,'keydown',function(event){
            if(event.keyCode == KEY.ESC)
            {
                ZRMap.collapseControl(control);
            }   
        });
         if(control.expandElement.clear)
         {
             control.expandElement.clear(); // to clear search on hiding/closing
         }
        if(control.name=="unknown_data")
        {            
            var container = map._container;                        
            var maxDivHgt = ZDBClientUtil.getInnerHeight(container)*0.35;
            d3.select(control.expandElement).selectAll('ul').style('max-height',maxDivHgt+'px'); // NO I18N
            var y = ZDBUtil.getObjTop(control.mainElement,false,container);
            var isRevHgt = y+control.expandContainer.offsetHeight >= container.offsetHeight;
            control.expandElement.style.top = isRevHgt ? -maxDivHgt+'px' : 0+'px';            
        }
            control.expanded = true;
            
    } else if (control.expandable && control.expanded){ 
            ZRMap.collapseControl(control);
        }                                                        
}

    var UnknowndataHandler = function (array) 
    {		
        var div = d3.select(document.createElement('div')).attr("elname","unknownLocList").attr('class', 'ZRMap-unknowndata-container');//No I18N
        div.append('div').attr('class', 'ZRMap-unknowndata-label').text("Unresolved Locations");//No I18N
        var li = div.append('ul').selectAll('li').data(array);//No I18N		
        li.text(function (d) {return d;});
        li.enter().append('li').attr('class', 'ZRMap-unknowndata-element').text(function (d) {//No I18N
                                                                                    return d;});		
        li.exit().remove();
        return div.node();
    }
    
    var selectToZoom = (function () {
        var div,
                innerDiv,
                control,
                container,
                shown = false,
                startPos;


        function getDimension(event, initial) {
            var divDimension = div.getBoundingClientRect();
            return {
                x: initial && initial.x ? event.clientX - divDimension.left - initial.x : event.clientX - divDimension.left,
                y: initial && initial.y ? event.clientY - divDimension.top - initial.y : event.clientY - divDimension.top
            };
        }

        function mousedown(event) {
            event.originalEvent.stopPropagation();
            var dim = getDimension(event);
            startPos = dim;
            d3.select(innerDiv).style({
                "left": dim.x + "px",                                                   //No I18N
                "top": dim.y + "px",                                                    //No I18N
                "width": "0px",                                                         //No I18N
                "height": "0px",                                                         //No I18N
                "visibility": "visible"                                                         //No I18N
            });
            jQuery('[elname=chartHolder] .ZRMap-zoomarea-container-div').on('mousemove', mousemove);         //No I18N

        }

        function mouseup(event) {
            event.originalEvent.stopPropagation();
            jQuery('.ZRMap-zoomarea-container-div').off('mousemove', mousemove);        //No I18N
            var endPos = getDimension(event);
            var startLatLng = map.containerPointToLatLng(L.point(startPos.x, startPos.y));
            var endLatLng = map.containerPointToLatLng(L.point(endPos.x, endPos.y));
            if (startLatLng && !startLatLng.equals(endLatLng)) {
                // max bounds should be based on user selection not on georole - so this case we should not consider georole,so passed as null
                ZRMap.fitBounds(map,[startLatLng, endLatLng]);
            }
            returnObj.toggle(control);
        }

        function mousemove(event) {
            event.originalEvent.stopPropagation();
            var dim = getDimension(event, startPos);
            var divDim = div.getBoundingClientRect();
            if(dim.x < 0){
                d3.select(innerDiv).style({
                    "left" : "",                                            //No I18N
                    "right" : divDim.width - startPos.x+"px"                //No I18N
                });
            } else {
                d3.select(innerDiv).style({
                    "right" : "",                                           //No I18N
                    "left" : startPos.x+"px"                                //No I18N
                });
            }
            if(dim.y < 0){
                d3.select(innerDiv).style({
                    "top" : "",                                             //No I18N
                    "bottom" : divDim.height - startPos.y+"px"              //No I18N
                });
            } else {
                d3.select(innerDiv).style({
                    "bottom" : "",                                          //No I18N
                    "top" : startPos.y+"px"                                 //No I18N
                });
            }
            
            d3.select(innerDiv).style({
                "width": Math.abs(dim.x) + "px",                                                      //No I18N
                "height": Math.abs(dim.y) + "px"                                                      //No I18N
            });
        }

        function handleKeyDown(event) {
            if(event.keyCode==KEY.ESC)
            {
                returnObj.hide();
            }
        }
        var returnObj = {
            toggle: function (dragcontrol) {
                control = dragcontrol;
                var iconElement = control.mainElement.querySelector('.ZRMap-zoomarea-icon');               //No I18N
                container ? null : container = iconElement;
                if (shown) {
                    this.hide();
                    control.active = false;
                } else {
                    this.show();
                    control.active= true;
                }
            },
            show: function () {
                L.DomUtil.addClass(container, 'ZRMap-zoomarea-icon-active');            //No I18N
                shown = true;
                div = L.DomUtil.create('div', 'ZRMap-zoomarea-container-div', map.getContainer());          //No I18N
                innerDiv = L.DomUtil.create('div', 'ZRMap-zoomarea-div', map.getContainer());                              //No I18N
                map.dragging.disable();
                jQuery(document).on('keydown', handleKeyDown); //No I18N
                jQuery('[elname=chartHolder] .ZRMap-zoomarea-container-div').on('mousedown', mousedown);                     //No I18N
                jQuery('[elname=chartHolder] .ZRMap-zoomarea-container-div').on('mouseup', mouseup);                     //No I18N
            },
            hide: function () {
                L.DomUtil.removeClass(container, 'ZRMap-zoomarea-icon-active');         //No I18N
                shown = false;
                d3.select(innerDiv).remove();
                d3.select(div).remove();
                map.dragging.enable();
                jQuery(document).off('keydown', handleKeyDown);                                    //No I18N
                jQuery('[elname=chartHolder] .ZRMap-zoomarea-container-div').off('mousedown', mousedown);                //No I18N
                jQuery('[elname=chartHolder] .ZRMap-zoomarea-container-div').off('mouseup', mouseup);                            //No I18N
            }
        }
        return returnObj;

    })();



    this.initMapUI = function (chart) {
        map =chart.mapObj.map;
        baseGeoRole = chart.dataObject ? chart.dataObject.data.geo.geoRole : 0;
        hideSearch = baseGeoRole==ZDBUtil.geoNameVsRole.LATITUDE || baseGeoRole==ZDBUtil.geoNameVsRole.LONGITUDE;
        canEditUnknown =chart.dataObject ? chart.dataObject.data.geo.canEditUnknown : false;
        unknownLocDet = chart.dataObject ? chart.dataObject.data.geo.unknownLocDet : null;
//        map.attributionControl.remove();
        map.zoomControl.remove();
        controls = [];
        
        if(!hideSearch)
        {
            mapSearchControl = new zrmapUI();
            mapSearchControl.addTo(map)
            controls.push(mapSearchControl);
        }
        mapControl = new zrmapUI();
        mapControl.addTo(map); 
        controls.push(mapControl);
        mapControl._container.setAttribute("style","z-index:1");
        map.on('click', function () {
            controls.forEach(function (control) {
                control.collapseAll();
            });
        })
        if(!ZDBGlobal.isQAEnabled)
        {
            map.on('mouseover', function () { 
               clearTimeout(timerToggle);
               controls.forEach(function (control) {
                   control.showToggle();
               });
           });
           map.on('mouseout', function (event) {
               if(event.layerPoint.x < 0 || event.layerPoint.y<0)
               {
               controls.forEach(function (control) {
                   control.collapseAll();
               });
                   timerToggle=setTimeout(function(){
               controls.forEach(function (control) {
                   control.hideToggle();
               });
               },750); 
               }
           });      
       }
       else
       {
           // for qa automation
           controls.forEach(function (control) {
                   control.showToggle();
               });
       }
        var CustomHtmlIcon = L.HtmlIcon.extend({
            options : { html : "<div elname='highlightEl' class='gps_ring'></div>"
                      }});
        // initially created and starting position and repositioned later by search for mapscatter and mapbubble, but not filled
        if(chart.chartTypes[0].value != 25)
        {
            var markerLocation = new L.LatLng(85, -180);
    	    var customHtmlIcon = new CustomHtmlIcon(); 
            marker = new L.Marker(markerLocation, {icon: customHtmlIcon});        
            map.addLayer(marker);
        }
    };
            
    this.addUIOptions = function (chart) {        
        var timer;
        if(!hideSearch)
        {
        this.mapSearchBox = mapSearchBox = new SearchBox(chart.mapObj.plotted_data, function (result) {
            var pos;
            var svg = chart.mapObj.map_util.getSVG();
            if(!(result.v.feature))
            {
                pos = result.v.latLng;
            ZRMap.fitBounds(map,[pos],baseGeoRole);
                var markerLocation = new L.LatLng(pos[0],pos[1]);
                var highlightEle = svg.select("g.leaflet-zoom-hide.highlight-group").append("g").attr("class","highlight");// NO I18N
                // set style for highlighter when it is bubble - start
                var size = result.v.size==0 ? 8 : result.v.size; // when it is map scatter,size is not be available, so it is map scatter
                if(result.v.size == 0)
                {
                var hgt = 10+size; // bubble size + border radious of 5px on bothside=10px
                var topv = -((hgt+10)/2)+'px' // to center the bubble, half of (hgt+5px of border radius on bothside=10px) //NO I18N
                jQuery(marker._icon).find("div[elname='highlightEl']").css({
                        'border-color':"#57A9FB",// NO I18N
                    'height':hgt+'px',//NO I18N
                    'width':hgt+'px',//NO I18N
                    'top':topv,//NO I18N
                    'left':topv//NO I18N
                });
                jQuery(marker._icon).find("div[elname='highlightEl']").css('display','block');// NO I18N
                    // set style for highlighter when it is bubble - end
                marker.setLatLng(markerLocation);
                }
                else
                {
                    var scale = chart.mapObj.map_util.getScale();
                    var color = "#57A9FB" ; //result.v.size ? "#8c8c8c" : result.v.color; // NO I18N
                    var hoverOptions = {
                        "innerFillOpacity" : 0.3,// NO I18N
                        "innerStrokeOpacity":1// NO I18N
                    }
                    var hoverSize = result.v.color ? result.v.size + 8 : result.v.size == 35 ? result.v.size + 10 : scale(chart.mapObj.plotted_data[result.d].size) + 10;
                    
                    hoverOptions.size = (hoverSize)/10;
                    
                    var ele = highlightMarker(highlightEle,hoverOptions,color);
                    
                    var layerPoint = map.latLngToLayerPoint(result.v.latLng);
                    
                    highlightEle.style('visibility', 'visible').attr("transform", 'translate(' + layerPoint.x + ',' + layerPoint.y + ')');// NO I18N
                    
                    svg.select("g.highlight").select("path")// NO I18N
                            .transition()
                            .duration(1000)
                            .each("start",repeat);// NO I18N
                    
                    function repeat()
                    {
                        d3.select(this).transition()
                                        .style("stroke-opacity","1")// NO I18N
                                        .transition()
                                        .duration(500)
                                        .ease("linear")// NO I18N
                                        .style("stroke-opacity","0.6")// NO I18N
                                        .transition()
                                        .duration(500)
                                        .ease("linear")// NO I18N
                                        .style("stroke-opacity","0.3")// NO I18N
                                        .transition()
                                        .duration(500)
                                        .ease("linear")// NO I18N
                                        .style("stroke-opacity","0")// NO I18N
                                        .delay(500)
                                        .each("end",repeat);// NO I18N
                                        
                    }
                    
                }
                
                timer = 5000;
            }
            else
            {
                
                var highlightLayer = new L.LayerGroup();
                var geoJson = L.geoJSON(result.v.feature,{style :style});
                pos = geoJson._layers[geoJson._leaflet_id - 1]._bounds;
                
                ZRMap.fitBounds(map,[pos],baseGeoRole);
                
                function style(feature) {
                return {
                            color:"#727070",
                            weight:3.5,
                            fillColor:"white", //NO I18N
                            fillOpacity:0
                        };
                }
                geoJson.addTo(highlightLayer);
                map.addLayer(highlightLayer);
                timer = 1750;
            }
        setTimeout(function(){
                if(marker)
                {
		var markerLocation = new L.LatLng(85, -180);
                    marker.setLatLng(markerLocation);
                   jQuery(marker._icon).find("div[elname='highlightEl']").css('display','none');// NO I18N   
                   var highlightEle = svg.select("g.leaflet-zoom-hide.highlight-group").select("g.highlight").remove(); // NO I18N
                   
                }
                else
                {
                    map.removeLayer(highlightLayer);
                }
            },timer); 
        },null,this);        
          var searchtip = ZDBI18NMap.f("zrpt.common.js.search");
        mapSearchControl.addOption("search",searchtip, "<a class='iconbg ZRMap-icon ZRMap-searchIcon' href='#'></a>", 'mouse',function(event){},true, mapSearchBox);   //No I18N
    }        
    var resettip = ZDBI18NMap.f("zrpt.common.js.reset");
        mapControl.addOption("reset",resettip, "<a class='iconbg ZRMap-icon ZRMap-home-icon' href='#'></a>",'click',function (event) {   //No I18N
            var latLngArray = [];
            var layerBounds = [];
            if(Object.keys(chart.mapObj.plotted_layer).length > 0)//Check for Filled Map inorder to fetch the layer bounds for fitBounds
            {
                for (var key in chart.mapObj.plotted_layer) {
                       layerBounds.push(chart.mapObj.plotted_layer[key].layer.getBounds());
                 }
                 ZRMap.fitBounds(map,layerBounds);
            }
            else
            {
            for (var key in chart.mapObj.plotted_data) {
                latLngArray.push(chart.mapObj.plotted_data[key].latLng);
            }
            ZRMap.fitBounds(map,latLngArray,baseGeoRole);
            } 
        });
        var grapareatip = ZDBI18NMap.f("zrpt.common.js.grabarea");
        mapControl.addOption("grab_Area",grapareatip, "<a class='iconbg ZRMap-icon ZRMap-zoomarea-icon' href='#'></a>", 'click',function (event) {          //No I18N
            L.DomEvent.stopPropagation(event);
            selectToZoom.toggle(this);
        });
        var zoomintip = ZDBI18NMap.f("zrpt.common.js.zoomin");
        mapControl.addOption("zoomin",zoomintip, "<a class='iconbg ZRMap-icon ZRMap-zoomin' href='#'></a>", 'click',function (event) {   //No I18N
            map.zoomIn();
        });
        var zoomouttip = ZDBI18NMap.f("zrpt.common.js.zoomout");
        mapControl.addOption("zoomout",zoomouttip, "<a class='iconbg ZRMap-icon ZRMap-zoomout' href='#'></a>",'click',function (event) {   //No I18N
            map.zoomOut();
        });
        var unknownData = unknownLocDet && unknownLocDet.UNKNOWNLIST;
        var resolvedLst = unknownLocDet && unknownLocDet.RESOLVEDLIST;
        if ((unknownData || resolvedLst) && (unknownData.length > 0 || Object.keys(resolvedLst).length>0)) {
            var unresolvedtip = ZDBI18NMap.f("zrpt.common.js.unresolvedloc");
            if(canEditUnknown)
            {
                mapControl.addOption("unknown_data",unresolvedtip, "<a class='iconbg ZRMap-icon ZRMap-unknowndata-icon-active' href='#' lzjs='ZRCustomGeocodeList' lzcss='ZRCustomGeocoding.css' lzname='GeoSettings' lzurl='/ZDBGeocoding.cc' elname='editLocations' func='ZRChartCustomGeocoder.openCustomGeoSettingsDlg' lzoper='APPENDTODOC' checkSave='true' lazyload='true' onclick='ZDBLoadJsAlone.loadSnippet(this)'><sub elname='unknowncountEl' class='unknowndata'>"+unknownData.length+"</sub></a>");
            }
            else
            {
                var unknowndataDiv = new UnknowndataHandler(unknownData);
                mapControl.addOption("unknown_data",unresolvedtip, "<a class='iconbg ZRMap-icon ZRMap-unknowndata-icon-active' href='#' elname='unknownListEl'><sub elname='unknowncountEl' class='unknowndata'>"+unknownData.length+"</sub></a>", 'click',function (event) {  //No I18N
                                    if (jQuery(this.expandContainer).is(':hidden'))
                                    {
                                        jQuery(this.expandContainer).slideDown('medium');//No I18N
                                    }
                                    L.DomEvent.stopPropagation(event);  
                                  }, true, unknowndataDiv);
            }
        } else {
            mapControl.addOption("unknown_data",unresolvedtip, "<a class='iconbg ZRMap-icon ZRMap-unknowndata-icon-inactive' href='#'></a>",'click',function (event) {}); //No I18N
        }
        controls.forEach(function (control) {
            control._render();
        });
        var legendToggleEl = chart.mapObj.container.select("div.zcmap-legend-toggle").node();// NO I18N
        if(legendToggleEl)
        {
            L.DomEvent.on(legendToggleEl,'mouseover',function(event){ZDBToolTip.show(this,event);}) //No I18N
                    .on(legendToggleEl,'mouseout',function(event){ZDBToolTip.hide(this,event);})//No I18N        
                    .on(legendToggleEl,'click',function(event){ZDBToolTip.hide(this,event);})//No I18N        
        }
    };
    function repeat()
    {
        d3.select(this).transition()
                        .style("stroke-opacity","1")// NO I18N
                        .transition()
                        .duration(500)
                        .ease("linear")// NO I18N
                        .style("stroke-opacity","0.6")// NO I18N
                        .transition()
                        .duration(500)
                        .ease("linear")// NO I18N
                        .style("stroke-opacity","0.3")// NO I18N
                        .transition()
                        .duration(500)
                        .ease("linear")// NO I18N
                        .style("stroke-opacity","0")// NO I18N
                        .delay(500)
                        .each("end",repeat);// NO I18N

}
    L.HtmlIcon = L.Icon.extend({	
	initialize: function (options) {
		L.Util.setOptions(this, options);
	},

	createIcon: function () {
		var div = document.createElement('div');
		div.innerHTML = this.options.html;
            return div;
	}	
});
}

ZRMap.fitBounds = function (map,ltlngarr,georole) {        
        var options;
        if(georole)
        {
            var maxzoom = GEOROLEBASED_MAXZOOMLEVELS.getMaxZoom(georole);
            options = {maxZoom: maxzoom};
        }
        if(ltlngarr.length>0)
        {
            map.fitBounds(ltlngarr, options);
        }
    };
    
var GEOROLEBASED_MAXZOOMLEVELS = (function () {

var zoomlevelByRole = {
    0:1,
    1:4,
    2:6,
    3:7,
    4:7,
    5:9,
    6:9,
    7:9
};
return {
  getMaxZoom:function(georole) {return zoomlevelByRole[georole];}
};

})();

function highlightMarker(element,hoveringOptions,color)
{
    var DIM = 10;
    var size = hoveringOptions.size * DIM;
    var path = element.append("path");// NO I18N
        path
            .attr({
                "d" : "M" + (-size / 2) + " 0 A" + (size / 2) + " " + (size / 2) + " 0 0 1 " + (size / 2) + " 0 A" + (size / 2) + " " + (size / 2) + " 0 0 1 " + (-size / 2) + " 0", // NO I18N
            })
            .style({
                "fill":"transparent",// NO I18N
                "fill-opacity" : hoveringOptions.innerFillOpacity,// NO I18N
                "stroke":color,// NO I18N
                "stroke-opacity": hoveringOptions.innerStrokeOpacity,// NO I18N
                "stroke-width":"4"// NO I18N
            });
            
    return element;
}

