//$Id$
var ZALazyLoadData = new function()
{
    this.wmsDataQ = new Object();
    
    // response from wms is handled here
    // if view is present then data will be updated in the view otherwise it is stored in queue
    this.handleLazyLoadEvent = function(jsonData)
    {
        var wmsKey = jsonData.data.WMSKEY;
        var idx = wmsKey.indexOf('-');
        var seqKey = wmsKey.substring(idx);
        var view = ZDBClientUI.getViewObj(ZDBClientUI.ZDBViewEl, "view");
        if(view && view.SEQKEY && view.SEQKEY === seqKey)
        {
            var taskKey = wmsKey.substring(0, idx);
            if(view.LAZYLOADTASK && view.LAZYLOADTASK.indexOf(taskKey) !== -1) {
                ZALazyLoadData.taskAction(view, taskKey, jsonData.data);
            }
        }
        else // if wms data received not in the intended view then store in queue
        {
            ZALazyLoadData.wmsDataQ[wmsKey] = new Array();
            ZALazyLoadData.wmsDataQ[wmsKey].push(jsonData.data);
        }
    };
    
    // based on task key update the data in the view
    // if all the data is updated in view then generate the chart
    this.taskAction = function(view, taskKey, jsonData)
    {
        switch(taskKey)
        {
            case ZATaskConstants.THRESHOLD_TASK_KEY:
                ZAThresholdAction.addThresholdInView(view, jsonData);
                break;
        }
        ZALazyLoadData.removeLazyLoadKey(view, taskKey);
        if(ZALazyLoadData.getTaskCount(view) === 0) {
            ZDBAnalysisView.generateChart(view);
        }
    };
    
    // if lazy load data present in queue then get the data from queue
    this.addFromWMSQueue = function(view)
    {
        if(view.LAZYLOADTASK && ZALazyLoadData.getTaskCount(view) > 0)
        {
            var lazyLoadTask = view.LAZYLOADTASK;
            for(var i=0; i < lazyLoadTask.length; i++)
            {
                var taskKey = lazyLoadTask[i];
                var wmsKey = taskKey+view.SEQKEY;
                if(ZALazyLoadData.wmsDataQ[wmsKey])
                {
                    var jsonData = ZALazyLoadData.wmsDataQ[wmsKey][0];
                    ZALazyLoadData.taskAction(view, taskKey, jsonData);
                    delete ZALazyLoadData.wmsDataQ[wmsKey];
                }
            }
        }
    };
    
    // once the data is loaded remove the lazy load task key
    this.removeLazyLoadKey = function(view, key)
    {
        if(view.LAZYLOADTASK)
        {
            var lazyLoadTask = view.LAZYLOADTASK;
            var taskIdx = lazyLoadTask.indexOf(key);
            if(taskIdx !== -1) {
                lazyLoadTask.splice(taskIdx, 1);
            }
            view.LAZYLOADTASK = (lazyLoadTask.length > 0) ? lazyLoadTask : null;
        }
    };
    
    this.getTaskCount = function(view)
    {
        var lazyLoadTasks = view[ZATaskConstants.LAZYLOAD_TASK_KEY];
        return (lazyLoadTasks ? lazyLoadTasks.length : 0);
    };

    // Repeatedly check (ctr times) if the lazy load data is received.
    // If not received (till ctr times) then send ajax request to fetch the lazyload data
    this.taskCheck = function(view, ctr, loaderDiv)
    {
        var tabView = view.viewCtx.dashView ? view.viewCtx.dashView : view;
        var classPrefix = loaderDiv.getAttribute("classPrefix");
        var func = function(){ZALazyLoadData.taskCheck(view, ctr, loaderDiv);};
        if(!ZDBTabSwitchHandler.isRelevendTab2Exec(tabView, func))
        {
            DOMUtils.replaceCSSClass(loaderDiv, classPrefix + 'Loaded', classPrefix + 'Loading'); //No I18N
            return;
        }
        var taskCount = ZALazyLoadData.getTaskCount(view);
        if(taskCount === 0)
        {
            DOMUtils.replaceCSSClass(loaderDiv, classPrefix + 'Loaded', classPrefix + 'Loading'); //No I18N
            return;
        }
        else if(ctr === 0)
        {
            var lazyLoadTask = view.LAZYLOADTASK;
            for(var i=0; i < taskCount; i++) {
                ZAFailSafeAction.handleFailSafe(view, lazyLoadTask[i]);
            }
            return;
        }
        if(ctr>0)
        {
            DOMUtils.replaceCSSClass(loaderDiv, classPrefix + 'Loading', classPrefix +'Loaded'); //No I18N
            setTimeout(function() {
                ZALazyLoadData.addFromWMSQueue(view);
                ZALazyLoadData.taskCheck(view, --ctr, loaderDiv);
            }, ZATaskConstants.TASK_CHECK_TIMER);
        }
    };
    
    this.deleteWMSQueueInView = function(view)
    {
        var seqKey = view.SEQKEY;
        if(seqKey)
        {
            var taskCount = ZATaskConstants.LAZYLOAD_TASKS.length;
            for(var i=0; i<taskCount; i++)
            {
                var wmsKey = seqKey+ZATaskConstants.LAZYLOAD_TASKS[i];
                delete ZALazyLoadData.wmsDataQ[wmsKey];
            }
        }
    };
};