//$Id$
//ignorei18n_start
var fieldSizeClass = {
		DBDESCRIPTION : 250,
		DBNAME : 50,
		DEFAULTNULLVALUE : 100
};
//MIXIN DECLARATION STARTS

var InputStateMaintainerMixin = {
	inputStateModifier : function(){
		var ref = this.refs.BASEINPUTCOMPONENT || this.refs.BASESELECTCOMPONENT;
		if(this.state.checked){
			ref.checked = true;
		}
		else{
			ref.checked = false;
		}
		if(this.state.disabled){
			ref.disabled = true;
		}
		else{
			ref.disabled = false;
		}
		if(this.state.required){
			ref.required = true;
		}
		else{
			ref.required = false;
		}
	}
};

var ToolTipMixins = {
	showToolTips : function(event){
		ZDBToolTip.show(event.target,event);
	},
	hideToolTips : function(event){
		ZDBToolTip.hide(event.target,event);
	}
};
//MIXIN DECLARATION END

var ZRBaseComponentsUtils = {
	unmountComponentAtNode : function(id){
		var holder = document.getElementById(id);
		if(holder){
			var bool = ReactDOM.unmountComponentAtNode(holder);
			holder.parentNode.removeChild(holder);
			return bool;
		}
		return false;
	},
	mergeObjsAndReturnNewObj : function(obj1, obj2){
		var temp = {};
		this.combineObjects(temp,obj1);
		this.combineObjects(temp,obj2);
		return temp;
	},
	combineObjects : function(obj1, obj2){
		for(var val in obj2){
			if(obj2[val] instanceof Array){
				if(!(obj1[val] instanceof Array)){
					obj1[val] = [];
				}
				this.combineObjects(obj1[val],obj2[val]);
			}
			else if(typeof obj2[val] === 'object'){
				if(typeof obj1[val] !== 'object'){
					obj1[val] = {};
				}
				this.combineObjects(obj1[val],obj2[val]);
			}
			else if(obj2.hasOwnProperty(val)){
				obj1[val] = obj2[val];
			}
		}
	},
	getGoogleContacts : function(){
		var callBack = this.googleContCallBack;
		var event = this.googleContCallBackEvent;
		if(callBack){
			callBack(event);
		}
	},
	getContainer : function(id, holder){
		//ID and holder must be present
		var container = document.querySelector("#"+id);
		if(!container){
			container = document.createElement("div");
			container.setAttribute("id",id);
			holder.appendChild(container);
		}
		container.style.display = "";
		return container;
	},
	getUniqueArray : function(array){
		var temp = array.concat();
	    for(var i=0; i < temp.length; ++i) {
	        for(var j=i+1; j < temp.length; ++j) {
	            if(temp[i] === temp[j])
	                temp.splice(j--, 1);
	        }
	    }
    	return temp;
	},
	arrayContains : function(arr,valToCheck){
		try{
			for(var i=0; i < arr.length; i++){
				if(arr[i] === valToCheck){
					return i;
				}
			}
			return -1;
		}
		catch(e){
			return -1;
		}
	},
	reverseArray : function(array){
		var left,right,length = array.length;
		for (left = 0, right = length - 1; left < right; left += 1, right -= 1)
		{
		    var temporary = array[left];
		    array[left] = array[right];
		    array[right] = temporary;
		}
	},
	commonErrorHandler : function(knownErrorNumCodes, knownErrorCodes, response){
		var errorNumCode = response.data.errorNumCode;
		var errorName = response.data.errorName;
		var errorMsg = response.message.trim();
		if(errorNumCode===6054 || errorNumCode===6055 || errorNumCode===6056 || errorNumCode===6057){
			var msg = this.withoutLoginSlideErrorMsg(errorNumCode);
			ZDBAlertAPI.showErrorMsg(msg,null,errorName);
		} else if(knownErrorNumCodes.indexOf(errorNumCode.toString()) > -1 && knownErrorCodes.indexOf(errorName) > -1){
			ZDBMsgBox.showError(errorMsg);
		}
		else{
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.js.commonfailure"));
		}
	},
	withoutLoginSlideErrorMsg: function (errcoNumCode) {
		var msg = "";
		if(errcoNumCode === 6054) {
			msg = ZDBI18NMap.g("zrpt.pricing.err.js.publishcnt_violation");
		} else if (errcoNumCode === 6055) {
			msg = ZDBI18NMap.g("zrpt.pricing.err.js.regenerate_violation");
		} else if (errcoNumCode === 6056) {
			msg = ZDBI18NMap.g("zrpt.pricing.err.js.shared_usr_publishcnt_violation");
		} else if (errcoNumCode === 6057) {
			msg = ZDBI18NMap.g("zrpt.pricing.err.js.shared_usr_regenerate_violation");
		}
		msg = msg.split(";");
		if(msg[1]){
			var upgradeTabLink = ZDBGlobal.upgradeLink;
			var target =  typeof CrmPlusImpl !== 'undefined' && CrmPlusImpl.isLoadedInCrmplus() ? "_blank" : "_self";//No I18N
			msg[1] = '<a href="'+upgradeTabLink+'" target="'+target+'">' + msg[1] + '</a>';
		}
		msg = msg.join("");
		return msg;
	}
};


var emptyFunc = function(){
	return;
};
//Event Objects
ZRBaseComponentsUtils.clipboardEvents = {onCopy:emptyFunc,onCut:emptyFunc,onPaste:emptyFunc};
ZRBaseComponentsUtils.compositionEvents = {onCompositionEnd:emptyFunc,onCompositionStart:emptyFunc,onCompositionUpdate:emptyFunc};
ZRBaseComponentsUtils.keyBoardEvents = {onKeyDown:emptyFunc,onKeyPress:emptyFunc,onKeyUp:emptyFunc};
ZRBaseComponentsUtils.focusEvents = {onFocus:emptyFunc,onBlur:emptyFunc};
ZRBaseComponentsUtils.formEvents = {onChange:emptyFunc,onInput:emptyFunc,onSubmit:emptyFunc};
ZRBaseComponentsUtils.mouseEvents = {onClick:emptyFunc,onContextMenu:emptyFunc,onDoubleClick:emptyFunc,onDrag:emptyFunc,onDragEnd:emptyFunc,onDragEnter:emptyFunc,
				   onDragExit:emptyFunc,onDragLeave:emptyFunc,onDragOver:emptyFunc,onDragStart:emptyFunc,onDrop:emptyFunc,onMouseDown:emptyFunc,
				   onMouseEnter:emptyFunc,onMouseLeaveonMouseMove:emptyFunc,onMouseOut:emptyFunc,onMouseOver:emptyFunc,onMouseUp:emptyFunc};
ZRBaseComponentsUtils.selectEvents = {onSelect:emptyFunc};
ZRBaseComponentsUtils.touchEvents = {onTouchCancel:emptyFunc,onTouchEnd:emptyFunc,onTouchMove:emptyFunc,onTouchStart:emptyFunc};
ZRBaseComponentsUtils.uiEvents = {onScroll:emptyFunc};
ZRBaseComponentsUtils.wheelEvents = {onWheel:emptyFunc};
ZRBaseComponentsUtils.mediaEvents ={onAbort:emptyFunc,onCanPlay:emptyFunc,onCanPlayThrough:emptyFunc,onDurationChange:emptyFunc,onEmptied:emptyFunc,onEncrypted:emptyFunc,onEnded:emptyFunc};
ZRBaseComponentsUtils.imageEvents = {onLoad:emptyFunc,onError:emptyFunc};

/*<SELECT> COMPONENT START
PROPS :
 	1. optionValues - options to be shown in the select box.
 	2. id - ID for the select box.
 	3. onChange - the function to be executed when interacted with the select boxes.
 	4. style - the style to be applied 
 	5. class - the class to be assigned to the select element
 	NOTE:send style as an object.
*/
var SelectComponent = React.createClass({
	mixins : [InputStateMaintainerMixin],
	getDefaultProps : function(){
		var props = {id:"", classname:"", style:{}, tip:''};
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.uiEvents);
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.wheelEvents);
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.formEvents);
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.focusEvents);
		return props;
	},
	componentWillMount : function(){
		this.setState({
			disabled:this.props.disabled,value:this.props.value
		});
	},
	componentDidMount : function(){
		this.inputStateModifier();
	},
	componentWillReceiveProps : function(nextProps){
		this.setState({
			disabled:nextProps.disabled,value:nextProps.value
		});
	},
	componentDidUpdate : function(){
		this.inputStateModifier();
	},
	render : function(){
		var optionValues = [];
		this.props.optionValues.forEach(function(options){
			optionValues.push(<option key={options.value} value={options.value}>{options.i18nValue}</option>);
		});
		return(
			<select ref="BASESELECTCOMPONENT" className={this.props.className} id={this.props.id} style={this.props.style} 
			value={this.state.value} onScroll={this.props.onScroll} onWheel={this.props.onWheel}
			onChange={this.props.onChange} onFocus={this.props.onFocus} onBlur={this.props.onBlur} data-tip={this.props.tip}>
				{optionValues}
			</select>
		);
	}
});
///*<SELECT> COMPONENT END


/*<CUSTOMSELECT> COMPONENT START
*/
var CustomSelect = React.createClass({
	render : function(){
		return(
			<div className={this.props.holderClassName}>
				<SelectComponent optionValues={this.props.optionValues} className={this.props.className} id={this.props.id} style={this.props.style} 
				value={this.props.value} onScroll={this.props.onScroll} onWheel={this.props.onWheel} disabled={this.props.disabled}
				onChange={this.props.onChange} onFocus={this.props.onFocus} onBlur={this.props.onBlur} data-tip={this.props.tip}/>
			</div>
		);
	}
});
///*<CustomSelect> COMPONENT END


//<CUSTOMRADIO> COMPONENT START
var CustomRadio = React.createClass({
	getDefaultProps:function(){
		return({defaultValue:""});
	},
	render : function(){
		return(
			<div className={this.props.holderClassName}>
				<InputComponent type="radio" checked={this.props.checked}/>
				<label ref='label' id={this.props.id} onClick={this.props.onClick} data-value={this.props.value}>
				<span id={this.props.id} className={this.props.className} style={{display:'block',float:'left',marginTop:'3px'}}></span>{this.props.text}</label>
			</div>
		);
	}
});
//<CUSTOMRADIO> COMPONENT END
/*
<INPUT> COMPONENT START
PROPS:
     1. id =  id of the element
     2. className = class to be attached
     3. style = style to be applied
     5. type = type of input required
     6. value = value to be attached to the input
     7. name = name of the input field which is used in forms
     8. min = used only for number input type for specifying minimum value
     9. max = used only for number input type for specifying maximum value
     10. size = size of the input field 
     11. step = used only for number input type for specifying increase range
     12. maxlength = max length of the value of the input field
     13. pattern = regex which evaluates the input fields value
     14. placeholder = placeholder for text fields.

     NOTE:Do not provide ref as a prop.
*/
var InputComponent = React.createClass({
	mixins : [InputStateMaintainerMixin],
	defaultOnChange : function(event){
		this.setState({
			value:this.refs.BASEINPUTCOMPONENT.value
		});
	},
	getDefaultProps : function(){
		var props = {id:"",className:'',style:{},type:'button',value:'',name:'',min:'',max:'',size:'',step:'',
						maxlength:'',placeholder:''};
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.mouseEvents);
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.keyBoardEvents);
		return props;
	},
	componentWillMount : function(){
		this.setState({
			value:this.props.value,checked:this.props.checked,disabled:this.props.disabled,required:this.props.required
		});
	},
	componentDidMount : function(){
		this.inputStateModifier();
	},
	componentWillReceiveProps : function(nextProps){
		this.setState({
			checked:nextProps.checked,disabled:nextProps.disabled,required:nextProps.required
		});
	},
	componentDidUpdate : function(){
		this.inputStateModifier();
	},
	render : function(){
		var onChange = (!this.props.onChange)?this.defaultOnChange:this.props.onChange;
		return (
			<input id={this.props.id} ref="BASEINPUTCOMPONENT" className={this.props.className} style={this.props.style} type={this.props.type} data-action={this.props.action}
		   value={this.state.value} name={this.props.name} min={this.props.min} max={this.props.max} 
		   placeholder={this.props.placeholder} defaultValue={this.props.defaultValue} onChange={onChange}
		   size={this.props.size} step={this.props.steps} maxLength={this.props.maxlength} pattern={this.props.pattern}
		   onClick={this.props.onClick} onDoubleClick={this.props.onDoubleClick} onKeyUp={this.props.onKeyUp} onKeyDown={this.props.onKeyDown}
		   onDrag={this.props.onDrag} onDragEnd={this.props.onDragEnd} onDragEnter={this.props.onDragEnter} onKeyPress={this.props.onKeyPress}
		   onDragExit={this.props.onDragExit} onDragLeave={this.props.onDragLeave} onDragOver={this.props.onDragOver}
		   onDragStart={this.props.onDragStart} onDrop={this.props.onDrop} onMouseDown={this.props.onMouseDown}
		   onMouseEnter={this.props.onMouseEnter} onMouseLeave={this.props.onMouseLeave} onMouseMove={this.props.onMouseMove}
		   onMouseOut={this.props.onMouseOut} onMouseOver={this.props.onMouseOver} onMouseUp={this.props.onMouseUp}>
		   </input>
		);
	}
});
//<INPUT> COMPONENT END

/*<A> COMPONENT START
PROPS :
 	1. id = ID of the element
 	2. className = class that has to be applied to the component
 	3. target = choose to open in cur tab or new tabl.
 	4. href = the target URL.
 	5. linkTxt = text to be shown as link
*/
var AnchorComponent = React.createClass({
	getDefaultProps : function(){
		var props = {id:'',className:'',target:'_blank', style:{}, linkTxt:'', tip:''};
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.focusEvents);
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.mouseEvents);
		return props;
	},
	render : function(){
		return (
			<a id={this.props.id} className={this.props.className} href={this.props.href} target={this.props.target} 
			   style={this.props.style} onClick={this.props.onClick} onDoubleClick={this.props.onDoubleClick}
			   onDrag={this.props.onDrag} onDragEnd={this.props.onDragEnd} onDragEnter={this.props.onDragEnter}
			   onDragExit={this.props.onDragExit} onDragLeave={this.props.onDragLeave} onDragOver={this.props.onDragOver}
			   onDragStart={this.props.onDragStart} onDrop={this.props.onDrop} onMouseDown={this.props.onMouseDown}
			   onMouseEnter={this.props.onMouseEnter} onMouseLeave={this.props.onMouseLeave} onMouseMove={this.props.onMouseMove}
			   onMouseOut={this.props.onMouseOut} onMouseOver={this.props.onMouseOver} onMouseUp={this.props.onMouseUp}
			   onFocus={this.props.onFocus} onBlur={this.props.onBlur} data-tip={this.props.tip}>
			   {this.props.linkTxt}
			</a>
		);
	}
});
//<A> COMPONENT END


/*<BUTTON> COMPONENT START
PROPS :
 	1. buttonText - text to be shown inside the function
 	2. onclick - function to be executed when button is clicked
 	3. onChange - the function to be executed when interacted with the select boxes.
 	4. style - style to be attached to the button
 	NOTE: send style as an object
*/
var ButtonComponent = React.createClass({
	getDefaultProps : function(){
		var props = {id:"", classname:"", style:{}, tip:''};
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.mouseEvents);
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.focusEvents);
		return props;
	},
	render:function(){
		return(
				<button className={this.props.classname} id={this.props.id} style={this.props.style} onClick={this.props.onClick} onDoubleClick={this.props.onDoubleClick}
					onDrag={this.props.onDrag} onDragEnd={this.props.onDragEnd} onDragEnter={this.props.onDragEnter}
					onDragExit={this.props.onDragExit} onDragLeave={this.props.onDragLeave} onDragOver={this.props.onDragOver}
					onDragStart={this.props.onDragStart} onDrop={this.props.onDrop} onMouseDown={this.props.onMouseDown}
					onMouseEnter={this.props.onMouseEnter} onMouseLeave={this.props.onMouseLeave} onMouseMove={this.props.onMouseMove}
					onMouseOut={this.props.onMouseOut} onMouseOver={this.props.onMouseOver} onMouseUp={this.props.onMouseUp}
					onFocus={this.props.onFocus} onBlur={this.props.onBlur} data-tip={this.props.tip}>
					{this.props.buttonText}
				</button>
			);
	}
});
/*<BUTTON> COMPONENT END

/*<BACKICON> COMPONENT START
PROPS:
	1. style - style of back icon
	2. classname - class of back icon
*/
var BackIcon = React.createClass({
	getDefaultProps : function(){
		var props = {id:"", classname:"", style:{}};
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.mouseEvents);
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.focusEvents);
		return props;
	},
	render : function(){
		return(
			<div style={this.props.style}>
				<a href="#" style={{display:'block'}} className={this.props.classname} onClick={this.props.onClick} onMouseEnter={this.props.onMouseEnter} 
				onMouseLeave={this.props.onMouseLeave} onMouseMove={this.props.onMouseMove} onMouseOut={this.props.onMouseOut} onMouseOver={this.props.onMouseOver} 
				onMouseUp={this.props.onMouseUp} onFocus={this.props.onFocus} onBlur={this.props.onBlur}> 
				</a>
			</div>
			);
	}
});
//<BACKICON> COMPONENT END

/*<GRAPHICALTOGGLER> COMPONENT START

*/
var GraphicalToggler = React.createClass({
	mixins : [InputStateMaintainerMixin],
	getDefaultProps : function(){
		var props = {ref:'BASEINPUTCOMPONENT',className:""};
		props = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj(props,ZRBaseComponentsUtils.mouseEvents);
		return props;
	},
	render : function(){
		var className = (this.props.enable)?"sliderBtn activeBtn":"sliderBtn deactiveBtn";
		return(
			<div className={className} onClick={this.props.onClick}>
				<div className="circleSlide"></div>
				<div className="spnOn">{this.props.activeText}</div>
				<div className="spnOff">{this.props.inactiveText}</div>
			</div>
		);
	}
});
//<GRAPHICALTOGGLER> COMPONENT END

/*<FULLPAGEDIALOG> COMPONENT START

*/
var DialogTemplate = React.createClass({
	attachResizer : function(event){
		var el = event.target;
		ZDBDialogUtil.attachResizeEvt(el, el.getAttribute("data-resizeAction"), event);
	},
	toolTipHide : function(event){
		ZDBToolTip.hide();
	},
	toolTipShow : function(event){
		ZDBToolTip.show(event.target,event);
	},
	minMaxDialog : function(event){
		ZDBDialogUtil.minMaxDlg(event.target.getAttribute('data-resizeAction'));
	},
	closeDialog : function(event){
		ZDBDialogUtil.closeDialog(event.target, event);
	},
	focusDialog : function(event){
		ZDBDialogUtil.setFocusDialog(event.target);
	},
	render: function(){
		var helpTxt = ZDBI18NMap.g("zrpt.dialoginfo.js.help");
		var bodyContent = null;
		var onClose = null;
		if(this.props.bodyContent){
			bodyContent = this.props.bodyContent;
		}
		onClose = (this.props.closeDialog)?this.props.closeDialog:this.closeDialog;
		return(
		  		<div className="dlgBorder font12" data-elname="dlgTable" onMouseDown={this.focusDialog}>
		  			<DialogTemplateTitleBar helpTxt={helpTxt} closeDialog={onClose} minMaxDialog={this.minMaxDialog} toolTipHide={this.toolTipHide} toolTipShow={this.toolTipShow}/>
		  			<DialogTemplateBody bodyContent = {this.props.bodyContent} resizer={this.attachResizer}/>
		  			<DialogTemplateResizeElements resizer={this.attachResizer}/>
		  		</div>
		);
	}
});
var DialogTemplateTitleBar = React.createClass({
	render: function(){
			return(
				<div className="dlgTitleBar" data-elname="dlgTitleBar">
				    <span data-elname="ArrowBefore"></span>
				    <span data-elname="ArrowAfter"></span>
				    <div>
				      	<div className="dlgTitle font14 fLeft ellipsis" data-elname="dlgTitle"></div>
				      	<span className='fLeft QHelpIcon' style={{display:'none',margin:'1px 0 0 5px'}} data-elname="dlgDesc" onMouseOut={this.props.toolTipHide} onMouseMove={this.props.toolTipShow}></span>
				    </div>
					<div>
				      	<div className="dlgTitle font14 fLeft ellipsis" data-elname="dlgTitle"></div>
				        <a className="fRight" target="_blank" href="" data-elname="dlgHelp" >
				            <span className='fLeft QHelpIcon' data-tip={this.props.helpTxt}style={{display:'none',margin:'-1px 0 0 -55px'}}  data-elname="dlgHelpIcon" onMouseOut={this.props.toolTipHide} onMouseMove={this.props.toolTipShow}></span>
				        </a>
				    </div>
				    <div className="fRight" style={{display:'inline'}}>
				        <span className="iconbg ZRSMinIcon" style={{display:'none',marginLeft:10+'px'}} data-elname="minBtn" data-resizeAction='min' onClick={this.props.minMaxDialog}></span>
				        <span className="iconbg ZRSMaxIcon" style={{display:'none',marginLeft:10+'px'}} data-elname="maxBtn" data-resizeAction='max' onClick={this.props.minMaxDialog}></span>
				        <span className="iconbg closeDlg" style={{marginLeft:10+'px'}} data-elname="closeBtn" onClick={this.props.closeDialog}></span>
				    </div>
				    <div style={{clear:'both'}}></div>
			    </div>
			);
		}
});
var DialogTemplateBody = React.createClass({
	render: function(){
			return(
					<div className="dlgBody" style={{position:'relative'}} data-elname="dlgBody">
				      <div data-elname="dlgBodyDIV">{this.props.bodyContent}</div>
				      <div data-elname="corner" className="resizeDlg" style={{display:'none',postion:'absolute',zIndex:1000,bottom:0+'px',right:0+'px',cursor:'se-resize'}} data-resizeAction="ALL" onMouseDown={this.props.resizer}></div>           
				    </div>
			);
		}
});

var DialogTemplateResizeElements = React.createClass({
	render: function(){
			return(
					<div data-elname="resizeEls" style={{display:'none'}}>
				      <div data-elname="resizeLR" style={{position:'absolute',top:0+'px',right:-5+'px',width:10+'px',cursor:'e-resize',zIndex:1000}} data-resizeAction="LR" onMouseDown={this.props.resizer}>&nbsp;</div>
				      <div data-elname="resizeTB" style={{fontSize:0+'px',position:'absolute',bottom:0+'px',left:0+'px',height:5+'px',cursor:'n-resize',zIndex:1000}}  data-resizeAction="TB" onMouseDown={this.props.resizer}>&nbsp;</div>
				      <div data-elname="vLine" style={{display:'none',backgroundColor:'black',position:'absolute',zIndex:6}}></div>
				      <div data-elname="hLine" style={{display:'none',backgroundColor:'black',position:'absolute',zIndex:6}}></div>      
				    </div>
			);
		}
});

var FullPageDialog = React.createClass({
	render : function(){
		var bodyContent = null;
		var dlg = this.props.dlgName;
		var onClose = (this.props.onClose)?this.props.onClose:null;
		switch(dlg){
		case "COPYDB":
		case "RENAMEDB":
			bodyContent = (<DBRenameAndCopyDialog onCancel={onClose} jsonInfo={this.props.jsonInfo} />);
			break;
		case "BACKUPDB":
			bodyContent = (<BackupDB onCancel={onClose} jsonInfo={this.props.jsonInfo}/>);
			break;
		}
		return(	
				<DialogTemplate closeDialog={onClose} bodyContent = {bodyContent} />
		);
	}
});
//<FULLPAGEDIALOG> COMPONENT END
//BACKUPDBURLCOMP START
var BackupDBURLComponent = React.createClass({
	render : function(){
		var urls = this.props.jsonInfo.BACKUP_URLS;
		var size = this.props.jsonInfo.BACKUP_URL_LENGTH;
		var divs = [];
		{(function(cont){
					var div;
					for(var i=0;i<size;i++){
						var key = "DB" + (i+1);
						var value = urls[key];
						if(value.LATEST){
							div = (<div key={key}>
									<a className={cont.props.className} href={value.URL}>{value.CREATEDDATE}</a>
									<span style={{color:'red'}}>
										<strong>&nbsp;{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.latestbackup")}</strong>
									</span>
								</div>);
						}
						else{
							div = (<div key={key}><a className={cont.props.className} href={value.URL}>{value.CREATEDDATE}</a></div>);
						}
						divs.push(div);
					}
		})(this);}
		return(
				<div style={this.props.style}>
					{divs}
				</div>
		);
	}
});
//BACKUPDBURL END

//Email Bubble Start
var EmailBubbleContainerInput = React.createClass({
	getDefaultProps : function(){
		return {
			containerClassName:'email-bubble-textarea',
			placeholder:ZDBI18NMap.g("zrpt.dbsettings.variables.js.emails")
		};
	},
	getInitialState : function(){
		return {};
	},
	componentWillMount : function(){
		ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare","APPENDTODOC");
	},
	handleOnKeyDown : function(event){
		if(event.which == KEY.SPACE || event.which == 188){
			event.preventDefault();	
			if(this.props.customOnKeyUpHandler){
				this.props.customOnKeyUpHandler(event);
				event.target.value="";
			}
		}	
		else if(event.which == KEY.BACKSPACE && !(event.target.value)){
			if(this.backspacePressed){
				this.props.removeEmailBubble(event,true);
				this.backspacePressed = false;
				return true;
			}
			this.backspacePressed = true;
		}
		else if(event.which == KEY.TAB && document.contactsString){
			event.preventDefault();
			this.createDropDown();
			if(ZDBAutoFillContacts)
				ZDBAutoFillContacts.autolist(event.target,event,'dropdown', ZDBAutoFillContacts.matchSample,false,this.props.emails);
			if(this.props.customOnKeyUpHandler){
				this.props.customOnKeyUpHandler(event);
				event.target.value="";
			}
		}
	},
	handleOnKeyUp : function(event){
		if(document.contactsString){
			this.createDropDown();
			if(ZDBAutoFillContacts)
				ZDBAutoFillContacts.autolist(event.target,event,'dropdown',ZDBAutoFillContacts.matchSample,false,this.props.emails);
		}
		if(event.which == KEY.ENTER){
			if(this.props.customOnKeyUpHandler){
				this.props.customOnKeyUpHandler(event);
				event.target.value="";
			}
		}
	},
	createDropDown : function(){
		if(!this.alreadyCreated){
			var el = document.createElement("div");
			el.setAttribute("id","dropdown");
			el.style.display='none';
			el.style.zIndex="10000001";
			el.className="dropdown";
			document.body.appendChild(el);
			this.alreadyCreated = true;
		}
	},
	onClick : function(event){
		if(this.refs.basecontainer.classList){
			this.refs.basecontainer.classList.add("focused");
		}
		else{
			this.refs.basecontainer.className += " focused";
		}
		this.refs.input.focus();
	},
	
	inputFocus : function(event){
		if(this.refs.basecontainer.classList && 
			!this.refs.basecontainer.classList.contains("focused")){
			this.refs.basecontainer.classList.add("focused");
		}
		else if(this.refs.basecontainer.className.indexOf(" focused") < 0){
			this.refs.basecontainer.className += " focused";
		}
		if(this.props.customOnFocus){
			this.props.customOnFocus(event);
		}
	},

	onBlur : function(event){
		if(this.refs.basecontainer.classList){
			this.refs.basecontainer.classList.remove("focused");
		}
		else{
			this.refs.basecontainer.className = this.refs.basecontainer.className.substr(0,
				this.refs.basecontainer.className.indexOf(" focused"));
		}
		if(this.props.customOnBlur){
			this.props.customOnBlur(event);
			this.refs.input.value = "";
			event.preventDefault();
		}
		ZDBAutoFillContacts.hidepopup('dropdown');
		event.stopPropagation();
	},
	render : function(){
		var emails = (this.props.emails)?this.props.emails.split(","):[];
		var renderedEmailBubble = [];
		emails.forEach(function(email){
			renderedEmailBubble.push(
				<EmailBubbles email={email} editEmail={this.props.editEmail} valRef={this.props.valRef} zaid={this.props.zaid} 
				removeEmailBubble={this.props.removeEmailBubble} key={Math.random().toString(36).substring(2)} />
			);
		}.bind(this));
		var inputStyle = (this.props.inputStyle)?this.props.inputStyle:{width:'inherit',marginLeft:'2px'};
		return(
			<div id={this.props.id} ref="basecontainer" className={this.props.containerClassName} style={this.props.containerStyles}
			onClick={this.onClick} data-emails={this.props.emails}>
				{renderedEmailBubble}
				<div className="ZRDBSetAddList" style={{display:(this.props.needGroups)?'block':'none'}} onMouseEnter={this.props.showToolTips} onMouseLeave={this.props.hideToolTips} onClick={this.props.handleAddUsersClick} data-tip={ZDBI18NMap.g("zrpt.common.js.addusrorgrp")}></div>
				<input type="text" ref="input" data-type="emails" data-valRef={this.props.valRef} 
				onKeyDown={this.handleOnKeyDown} onBlur={this.onBlur} onKeyUp={this.handleOnKeyUp} 
				style={inputStyle} onFocus={this.inputFocus} placeholder={this.props.placeholder}></input>
			</div>
		);
	}
});

var EmailBubbles = React.createClass({
	getDefaultProps : function(){
		return {
			contactClassName:'contact',
			email:'john.peter@zohocorp.com',
			userIconClass:'icon user',
			userEmailClass:'userEmailClass',
			userEmailClear:'icon clear',
			groupIconClass:'icon group'
		};
	},
	getInitialState : function(){
		return {};
	},
	removeEmail : function(event){
		this.props.removeEmailBubble(event);
	},
	stopClickEvent : function(event){
		event.stopPropagation();
	},
	render : function(){
		var isGroup = false;
		var regex = ZDBGlobal.emailRegex;
		var contactClassName = this.props.contactClassName;
		if(this.props.zaid){
			var groups = (document.zaidToDomainMap)?document.zaidToDomainMap[this.props.zaid]:[];
			groups = (groups)?groups:[];
			isGroup = (groups.indexOf(decodeURIComponent(this.props.email)) > -1)?true:false;
		}
		if(!regex.test(decodeURIComponent(this.props.email)) && !isGroup){
			contactClassName += " errorEmail";
		}
		return(
			<div data-type="bubble" onDoubleClick = {this.props.editEmail} onClick={this.stopClickEvent} className={contactClassName} data-valRef={this.props.valRef} data-email={decodeURIComponent(this.props.email)} title={decodeURIComponent(this.props.email)}>
				<span className={(isGroup)?this.props.groupIconClass:this.props.userIconClass} style={{float:'left'}}></span>
				<div className={this.props.userEmailClass}>{decodeURIComponent(this.props.email)}</div>
				<span className={this.props.userEmailClear} data-email={decodeURIComponent(this.props.email)} 
				data-valRef={this.props.valRef} data-type="bubble" onClick={this.removeEmail}></span>
			</div>
		);
	}
});
//Email Bubble Start


//Delete Confirmation Start
var DeleteConfirmUsageDeletion = React.createClass({
	render:function(){
		return(
			<div id='outerdiv' style={{width:'405px',fontSize:'12px'}}>
				<div style={{paddingBottom:"10px"}}>
					<span>{this.props.suggestionMsg}</span>
				</div>
				<div id='innerdiv' style={{border:'1px solid #cccccc',maxHeight:'160px',
				overflowY:'auto'}}>
				{
					(function(comp){
						var totalcomp = [];
						for(var key in comp.props.delInfo){
							var values = comp.props.delInfo[key];
							var valuesComp = [];
							for(var i=0; i<values.length; i++){
								var indexNValue = (i+1) + ". "+ values[i];
								valuesComp.push(
									<div style={{paddingLeft:'15px',paddingBottom:"5px"}} key={key+i}>
										{indexNValue}
									</div>
								);
							}
							totalcomp.push(
								<div key={key}>
									<div style={{paddingBottom:'7px',paddingTop:'7px'}}>
									<span style={{paddingLeft:'6px',fontWeight:'bold'}}>
										{key}
									</span>
									<span>: {ZDBI18NMap.f("zrpt.dbsettings.slideshow.js.usedin","")}</span>
									</div>
									{valuesComp}
								</div>
							);
						}
						return totalcomp;
					})(this)
				}
				</div>
			</div>
		);
	}
});
//Delete Confirmation End

//Image Slider Start
var ZRImageSliderComponent = React.createClass({
	gotoNextImage : function(){
	 var imageLen = this.props.images.length;
	 var curSel = this.state.curSelProps;
	 curSel = (curSel + 1 >= imageLen) ? 0 : curSel + 1;
	 this.changeImage(curSel);
	},
	gotoPrevImage : function(){
	 var imageLen = this.props.images.length;
	 var curSel = this.state.curSelProps;
	 curSel = (curSel - 1 < 0) ? imageLen - 1 : curSel - 1;
	 this.changeImage(curSel);
	},
	componentDidMount:function(){
		this.changeImage(0);
	},
	changeImage : function(curSel){
		this.refs.ImageContainer.style.background = "url("+this.props.images[curSel]+") no-repeat";
		this.refs.ImageDescription.innerHTML = this.props.imagesDesc[curSel];
		this.setState({curSelProps:curSel});
	},
	render:function(){
		var images = [];
		this.props.images.forEach(function(image,index){
			images.push(
				(<img src={image} key={index} style={{display:'none'}} />)
			);
		});
		return(
			<div style={this.props.cStyle}>
				<a className="dbSettingArrow forward" onClick={this.gotoNextImage}>
					<span className="ZRSDBNavNext" style={{margin:'4px 8px 8px 8px'}}></span>
				</a>
				<div ref="ImageDescription" style={{textAlign:'center',paddingBottom:'15px'}}>
				</div>
				<div ref="ImageContainer" style={this.props.icStyle}></div>
				{images}
				<a className="dbSettingArrow back" onClick={this.gotoPrevImage}>
					<span className="ZRSDBNavPre" style={{margin:'4px 8px 8px 7px'}}></span>
				</a>
			</div>
		);
	}
});
//Image Slider End

//Listing Start
//Always mount this component in document.body.
var ZRListingSelectorComp = React.createClass({
	getDefaultProps : function(){
		return {list : [],searchPlaceholder:ZDBI18NMap.g("zrpt.common.js.search"),buttonText:ZDBI18NMap.g("zrpt.share.button_val.js.add"),
		noMatchSearchStr:ZDBI18NMap.g("zrpt.common.js.nomatchresult")};
	},
	positionThisComp : function(){
		if(this.props.customPositionFunc){
			this.props.customPositionFunc({target:this.props.srcEl});
		}
		else if(this.props.srcEl){
			var listingDlg = this.refs.ZRReactListingDlg;
			var holder = listingDlg.parentNode;
			var boundingClient = this.props.srcEl.getBoundingClientRect();
			var holderBoundingClient = listingDlg.getBoundingClientRect();
			var bodyBoundingClient = document.body.getBoundingClientRect();
			var top = boundingClient.top + boundingClient.height;
			var left = boundingClient.left - holderBoundingClient.width + boundingClient.width;
			if(top > bodyBoundingClient.height){
				top = top - boundingClient.height - holderBoundingClient.height;
			}
			holder.style.position = "absolute";
			holder.style.top = top + 'px';
			holder.style.left = left + 'px';
		}
	},
	componentWillMount : function(){
		this.setState({
			selectedItems : this.props.selectedItems
		});
	},
	componentDidMount : function(){
		this.positionThisComp();
		if(this.state.searchStr){this.setColorForSearch(this.refs.search);}
		document.body.addEventListener("click",this.documentClickCloser);
		document.body.addEventListener("keyup",this.escapeHandler);
	},
	documentClickCloser : function(event){
		// console.log("documentclick");
		var el = DOMUtils.getElOrParentWithAttr(event.target,"data-listDlg");
		if(!el){
			this.handleCancel();
		}
	},
	escapeHandler : function(event){
		// console.log("escapeHandler");
		if(event.which == KEY.ESC){
			this.handleCancel();
		}
	},
	componentDidUpdate : function(){
		this.positionThisComp();
		if(this.state.searchStr){
			this.setColorForSearch(this.refs.search);
		}
		
	},
	handleAddItems : function(){
		if(this.props.items.length <=0){
			var key = (this.props.isGroup)?"zrpt.common.js.nogroups":"zrpt.common.js.nousersavail";
			ZDBMsgBox.showError(ZDBI18NMap.g(key));
			return;
		}
		var items = [];
		this.state.selectedItems.forEach(function(itm){
			items.push(itm);
		});
		if(items.length <= 0){
			ZDBMsgBox.showError(ZDBI18NMap.f("zrpt.common.js.saogroup",(this.props.isGroup)?ZDBI18NMap.g("zrpt.common.js.group"):ZDBI18NMap.g("zrpt.common.js.user")));
			return;
		}
		if(this.props.addItemsFunc){
			this.props.addItemsFunc(items);
		}
		this.handleCancel();
	},
	handleCancel : function(){
		var holder = this.refs.ZRReactListingDlg.parentNode;
		if(holder){
			ReactDOM.unmountComponentAtNode(holder);
			var emailHolder = holder.parentNode.querySelector(".email-bubble-textarea.focused");
			if(emailHolder){
				ZDBUtil.removeClass(emailHolder,"focused");
			}
			holder.parentNode.removeChild(holder);
		}
		document.body.removeEventListener("click",this.documentClickCloser);
		document.body.removeEventListener("keyup",this.escapeHandler);
	},
	checkBoxChange : function(event){
		var itm = event.target.getAttribute("data-item");
		if(event.target.checked){
			this.state.selectedItems.push(itm);
		}
		else{
			this.state.selectedItems.splice(this.state.selectedItems.indexOf(itm),1);
		}
		this.setState({
			selectedItems : this.state.selectedItems
		});
	},
	handleClick : function(event){
		var checkBox = event.target.parentNode.children[0];
		checkBox.checked = !checkBox.checked;
		this.checkBoxChange({target:checkBox});
	},
	searchUIChange : function(event){
		var iconChange = event.target.previousSibling;
		if(event.target.value.length > 0){
			iconChange.className = 'ZRSSearchClearIcon';
			iconChange.addEventListener("click",this.clearSearch);
		}
		else{
			iconChange.className = 'ZRSSearchIconLeft';
			iconChange.removeEventListener("click",this.clearSearch);
		}
	},
	clearSearch : function(event){
		var input = event.target.nextSibling;
		input.value = "";
		this.removeColorForSearch(input);
		this.handleSearch({target:input});
	},
	handleSearch : function(event){
		this.searchUIChange(event);
		this.setState({
			searchStr : event.target.value
		});
	},
	setColorForSearch : function(target){
		var parent = target.parentNode;
		parent.style.borderBottomColor = "#7FBBEE";
		//parent.style.borderBottomWidth = "2px";
		ZDBUtil.addClass(parent.children[0],"hovered");
	},
	removeColorForSearch : function(target){
		var parent = target.parentNode;
		parent.style.borderBottomColor = "#E0E0E0";
		//parent.style.borderBottomWidth = "1px";
		ZDBUtil.removeClass(parent.children[0],"hovered");
	},
	handleOnFocus : function(event){
		this.setColorForSearch(event.target);
	},
	handleOnBlur : function(event){
		this.removeColorForSearch(event.target);
	},
	render : function(){
		var items = this.props.items;
		var itemsContent,holderStyle={};
		if(items && items.length > 0){
			itemsContent = [];
			items.forEach(function(itm){
				var isItmSelected = (this.state.selectedItems && this.state.selectedItems.indexOf(itm) > -1)?true:false;
				if(this.state.searchStr){
					if(itm.toLowerCase().startsWith(this.state.searchStr.toLowerCase())){
						itemsContent.push(
						<div className="groupHolder" key={itm}>
							<input onChange={this.checkBoxChange} type="checkbox" checked={isItmSelected} style={{float:'left',margin:'13px 10px 0px 13px'}} data-item={itm}></input>
							<span className="ellipsis width85" title={itm} onClick={this.handleClick}>{itm}</span>
						</div>
						);
					}
				}
				else{
					itemsContent.push(
					<div className="groupHolder" key={itm}>
						<input onChange={this.checkBoxChange} type="checkbox" checked={isItmSelected} style={{float:'left',margin:'13px 10px 0px 13px'}} data-item={itm}></input>
						<span className="ellipsis width85" title={itm} onClick={this.handleClick}>{itm}</span>
					</div>
					);
				}
			}.bind(this));
			if(this.state.searchStr && itemsContent.length === 0){
				itemsContent.push(
					<div className="groupHolder" style={{padding:'4px',textAlign:'center'}} key={Math.random().toString().substring(3,6)}>
						<span className="ellipsis" style={{width:'100%'}} title={this.props.noMatchSearchStr}>{this.props.noMatchSearchStr}</span>
					</div>
				);
			}	
			holderStyle = {maxHeight:'180px',overflowY:'auto',overflowX:'hidden',width:'100%'};
		}else{
			itemsContent = (<span className="font13">{this.props.noResultText}</span>);
			holderStyle = {textAlign:"center",margin:'40px 0'};
		}
		return(
			<div ref="ZRReactListingDlg" className="ZRAddGroupDlg" data-listDlg="true">
				<div className="ZRAddGroupDlg title">
				<span className={this.props.iconClass} style={{display:(this.props.iconClass)?'block':'none'}}></span>
				<span className="ZRSSearchIconLeft" style={{float:'right'}}></span>
				<input ref="search" placeholder={this.props.searchPlaceholder} onChange={this.handleSearch}
				onFocus={this.handleOnFocus} onBlur={this.handleOnBlur}></input>
				
				</div>
				<div style={holderStyle} ref="itemsHolder">
					{itemsContent}
				</div>
				{
					(function(comp){
						if(comp.props.customLinkText){
							return(
								<div className="ZRSLink customLink" onClick={comp.props.customLinkAction}>
									<span>{comp.props.customLinkText}</span>
								</div>
							);
						}
					})(this)
				}
				<div style={{textAlign:'center',margin:'1px 0px 6px 11px'}}>
					<button onClick={this.handleAddItems} ref="addGrp">{this.props.buttonText}</button>
					<button onClick={this.handleCancel} ref="cancelAddGrp">{ZDBI18NMap.g("zrpt.common.js.cancel")}</button>
				</div>
			</div>
		);
	}
});
//Listing End

//MenuItems Component Start
var ReactMenu = React.createClass({
	getDefaultProps : function(){
		return {MenuBatches:[],key:0};
	},
	positionMenu : function(){
		if(this.props.customPositionFunc){
			this.props.customPositionFunc({target:this.props.srcEl});
		}
		else if(this.props.srcEl && this.refs.MenuHolder){
			var menuHolder = this.refs.MenuHolder;
			var boundingClient = this.props.srcEl.getBoundingClientRect();
			var holderBoundingClient = menuHolder.getBoundingClientRect();
			var bodyBoundingClient = document.body.getBoundingClientRect();
			var top = boundingClient.top + boundingClient.height;
			var left = boundingClient.left - holderBoundingClient.width + boundingClient.width;
			if(top > bodyBoundingClient.height){
				top = top - boundingClient.height - holderBoundingClient.height;
			}
			menuHolder.parentNode.style.position = "absolute";
			menuHolder.parentNode.style.top = top + 'px';
			menuHolder.parentNode.style.left = left + 'px';
		}
	},
	mouserEnter : function(event){
		var el = DOMUtils.getElOrParentWithAttr(event.target,"data-menuItem");
		ZDBUtil.addClass(el,"ZRSMenuHover");
	},
	mouseLeave : function(event){
		var el = DOMUtils.getElOrParentWithAttr(event.target,"data-menuItem");
		ZDBUtil.removeClass(el,"ZRSMenuHover");
	},
	componentDidMount : function(){
		this.positionMenu();
		document.body.addEventListener("click",this.documentClickCloser);
		document.body.addEventListener("keyup",this.escapeHandler);
	},
	documentClickCloser : function(event){
		// console.log("domclickcloser");
		var el = DOMUtils.getElOrParentWithAttr(event.target,"data-reactmenu");
		if(!el){
			this.handleCancel();
		}
	},
	componentDidUpdate : function(){
		this.positionMenu();
		document.body.addEventListener("click",this.documentClickCloser);
		document.body.addEventListener("keyup",this.escapeHandler);
	},
	handleCancel : function(){
		if(this.refs.MenuHolder){
			var holder = this.refs.MenuHolder.parentNode;
			if(holder){
				ReactDOM.unmountComponentAtNode(holder);
				var emailHolder = holder.parentNode.querySelector(".email-bubble-textarea.focused");
				if(emailHolder){
					ZDBUtil.removeClass(emailHolder,"focused");
				}
				holder.parentNode.removeChild(holder);
			}
		}
		document.body.removeEventListener("click",this.documentClickCloser);
		document.body.removeEventListener("keyup",this.escapeHandler);
		if(this.props.closeFunc)
			this.props.closeFunc(this.props.srcEl);
	},
	escapeHandler : function(event){
		// console.log("escape");
		this.handleCancel();
	},
	render : function(){
		var menuLen = this.props.MenuBatches[0] && this.props.MenuBatches[0].length;
		var key = 0;
		var style=this.props.holderStyle;
		if(menuLen > 0){
			var content=[];
			this.props.MenuBatches.forEach(function(menuBatch,index){
				menuBatch.forEach(function(menuItem){
					if(this.props.showSelectedTick && this.props.selected && this.props.selected.indexOf(menuItem.addData) > -1){
						content.push(
							<li key={"menuItem"+key} onMouseEnter={this.mouserEnter} onMouseLeave={this.mouseLeave} data-menuItem='true' onClick={menuItem.clickEvtHand} data-userData={menuItem.addData}>
								<span className="sortTickMenu" style={this.props.tickStyle}></span>
								<a><span className={(menuItem.iconClass)?menuItem.iconClass:''} style={{display:(menuItem.iconClass)?"":"none",marginTop:"5px"}} />{menuItem.value}</a>
							</li>
						);
					}
					else{
						content.push(
							<li key={"menuItem"+key} onMouseEnter={this.mouserEnter} onMouseLeave={this.mouseLeave} data-menuItem='true' onClick={menuItem.clickEvtHand} data-userData={menuItem.addData}>
								<a><span className={(menuItem.iconClass)?menuItem.iconClass:''} style={{display:(menuItem.iconClass)?"":"none",marginTop:"5px"}} />{menuItem.value}</a>
							</li>
						);
					}
					key++;
				}.bind(this));
				if(this.props.MenuBatches[index+1]){
					content.push(<li key={"menuItem"+key}><a className="ZRSMenuSeparator"></a></li>);
					key++;
				}
			}.bind(this));
			if(this.props.isLister){
				if(style)
					style.maxHeight = "200px";
				else
					style = {maxHeight:"200px"}; 
			}
			return(
				<div ref="MenuHolder" className="ZRReactMenuHolder shadowAdded" data-reactmenu='true' style={style}>
					<ul>
						{content}
					</ul>
				</div>
			);
		}
		else if(this.props.isLister && menuLen === 0){
			return (
				<div ref="MenuHolder" className="ZRReactMenuHolder shadowAdded" data-reactmenu='true' style={style}>
					<div style={{padding:'20px',textAlign:'center'}}>
						{this.props.listEmptyText}
					</div>
				</div>
			);
		}
		else{
			return(<div></div>);
		}
	}
});
//MenuItems Component End

//TitleNDesc Component Start 
var TitleNDesc = React.createClass({
	render : function(){
		return(
			<div style={{height:"63px"}}>
				<div className="bold font14 ZRDBMarginBottom5">{this.props.title}</div>
				<div className="ZRDBMarginTop5 ZRDBMarginBottom5">{this.props.desc}</div>
                                <div className="ZRDBSeparator"></div>
			</div>
		);
	}
});
//TitleNDesc Component End

//Search Component Start
var SearchComponent = React.createClass({
	setFocusToSearch : function(event){
		if(event.type == "blur"){
			this.refs.search.placeholder = this.props.placeholder;
			this.refs.searchHolder.style.borderColor = "";
			this.refs.searchHolder.style.boxShadow = "";
			if(this.props.onBlur)
				this.props.onBlur(event);
		}
		else if(event.type == "focus"){
			this.refs.search.placeholder = "";
			this.refs.searchHolder.style.borderColor = "#7FBBEE";
			this.refs.searchHolder.style.boxShadow = "0 0 3px #A8D3F5";
			if(this.props.onFocus)
				this.props.onFocus(event);
		}

	},
	clearSearch : function(event){
		this.refs.clearSearch.className = "ZRSSearchIcon";
		this.refs.search.value = "";
		if(this.props.clearSearch)
			this.props.clearSearch(event);
	},
	handleChange : function(event){
		if(event.keyCode == KEY.ESC){
			this.clearSearch(event);
			event.target.blur();
		}
		else if(event.target.value){
			var value = event.target.value;
			this.refs.clearSearch.className = "ZRSSearchClearIcon";
		}
		else{
			this.clearSearch();
		}
		event.stopPropagation();
		if(this.props.inputChangeHandler)
			this.props.inputChangeHandler(event);
	},
	render : function(){
		return (
			<div className="searchBox" ref="searchHolder" style={this.props.holderStyle}>
				<div ref="clearSearch" className="ZRSSearchIcon" onClick={this.clearSearch}>
				</div>
				<input 
				onFocus={this.setFocusToSearch} 
				onBlur={this.setFocusToSearch}
				placeholder={this.props.placeholder} 
				ref="search" style={this.props.inputStyle} 
				className="searchEl" type="text" 
				onKeyUp={this.handleChange} />
			</div>
		);
	}	
});
//Search Component End

//Custom Search With DropDown Start
var CustomSearchComp = React.createClass({
	setFocusToSearch : function(event){
		if(event.type == "blur"){
			this.refs.search.placeholder = this.props.placeholder;
			this.refs.searchHolder.style.borderColor = "";
			this.refs.searchHolder.style.boxShadow = "";
			if(this.props.onBlur)
                            this.props.onBlur(event);
		}
		else if(event.type == "focus"){
			this.refs.search.placeholder = "";
			this.refs.searchHolder.style.borderColor = "#7FBBEE";
			this.refs.searchHolder.style.boxShadow = "0 0 3px #A8D3F5";
			if(this.props.onFocus)
                            this.props.onFocus(event);
		}

	},
	clearSearch : function(event){
		this.refs.clearIcon.style.display = "none";
		this.refs.search.value = "";
		if(this.props.clearSearch)
			this.props.clearSearch(event);
	},
	handleChange : function(event){
		if(event.keyCode == KEY.ESC){
			this.clearSearch(event);
			event.target.blur();
		}
		else if(event.target.value){
			this.refs.clearIcon.style.display = "";
		}
		else{
			this.clearSearch();
		}
		event.stopPropagation();
		if(this.props.inputChangeHandler)
			this.props.inputChangeHandler(event);
	},
	render : function(){
		return (
			<div className="searchBox" ref="searchHolder" style={this.props.holderStyle}>
				<div className="ZRSSearchIconLeft" style={{width:(this.props.dropDownHandler)?"27px":"23px"}}>
					<div className="dropDownMenu" style={{height:'20px',marginLeft:'13px',marginTop:'3px',display:(this.props.dropDownHandler) ? '': 'none'}} onClick={this.props.dropDownHandler}> </div>
				</div>
				<div ref="clearIcon" className="ZRSSearchClearIcon" onClick={this.clearSearch} style={{display:"none"}}>
				</div>
				<input
					onFocus={this.setFocusToSearch}
					onBlur={this.setFocusToSearch}
					placeholder={this.props.placeholder}
					ref="search" style={this.props.inputStyle}
					className="searchEl" type="text"
					onKeyUp={this.handleChange} />
			</div>
		);
	}
});
//Custom Search With DropDown End

//Dynamic Body Container
var DynamicBodyContainer = React.createClass({
	componentDidMount : function(){
		this.position();
		document.body.addEventListener("click",this.documentClickCloser);
		document.body.addEventListener("keyup",this.escapeHandler);
	},
	documentClickCloser : function(event){
		// console.log("domclickcloser");
		var el = DOMUtils.getElOrParentWithAttr(event.target,"data-dynamicBodyCont");
		if(!el){
			this.handleCancel(event);
		}
	},
	componentWillUnmount : function() {
		document.body.removeEventListener("click",this.documentClickCloser);
		document.body.removeEventListener("keyup",this.escapeHandler);
	},
	escapeHandler : function(event){
		this.handleCancel(event);
	},
	handleCancel : function(event){
		if(this.refs.parent){
			var holder = this.refs.parent.parentNode;
			ReactDOM.unmountComponentAtNode(holder);
		}
		document.body.removeEventListener("click",this.documentClickCloser);
		document.body.removeEventListener("keyup",this.escapeHandler);
		if(this.props.cancelFunc)
			this.props.cancelFunc(event.target);
	},
	position : function(){
		var holder = this.refs.parent.parentNode;
		var holderBounds = holder.getBoundingClientRect();
		var window = document.body.getBoundingClientRect();
		holder.style.left = (parseFloat(window.width) * 0.5) - (parseFloat(holderBounds.width) * 0.5) + 'px';
		holder.style.top = (parseFloat(window.height) * 0.5) - (parseFloat(holderBounds.height) * 0.5) + 'px';
	},
	render : function(){
		return(
			<div className="ZRSShadow" ref="parent" data-dynamicBodyCont="true">
				<div className="dlgBorder font12">
					<div className="dlgTitleBar" style={{height:'22px'}}>
						<div className="dlgTitle font14 fLeft ellipsis" style={{width:'175px'}}>{this.props.title}
						</div>
						<span style={{float:"right"}} className="iconbg closeDlg" onClick={this.props.cancelFunc}></span>
					</div>
					<div className="dlgBody">
						{this.props.bodyContent}
						<div style={{marginTop:'15px',textAlign:'center'}}>
							<input type="button" onClick={this.props.okFunc} value={this.props.okText}/>
							<input type="button" onClick={this.props.cancelFunc} value={this.props.cancelText}/>
						</div>
					</div>
					
				</div>
			</div>
		);
	}
});
//Dynamic Body Container


ZRBaseComponentsUtils.repeatValues = [
					{"value":"none", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.backup.js.notscheduled")},
                    {"value":"daily", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.backup.js.everyday")},
                    {"value":"weekly", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.backup.js.weeklyonce")},
                    {"value":"monthly", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.backup.js.monthlyonce")}
                    ];
ZRBaseComponentsUtils.hrsArr = [
                   {"value":"0", "i18nValue":"00"},{"value":"1", "i18nValue":"01"},
                   {"value":"2", "i18nValue":"02"},{"value":"3", "i18nValue":"03"},
                   {"value":"4", "i18nValue":"04"},{"value":"5", "i18nValue":"05"},
                   {"value":"6", "i18nValue":"06"},{"value":"7", "i18nValue":"07"},
                   {"value":"8", "i18nValue":"08"},{"value":"9", "i18nValue":"09"},
                   {"value":"10", "i18nValue":"10"},{"value":"11", "i18nValue":"11"},
                   {"value":"12", "i18nValue":"12"},{"value":"13", "i18nValue":"13"},
                   {"value":"14", "i18nValue":"14"},{"value":"15", "i18nValue":"15"},
                   {"value":"16", "i18nValue":"16"},{"value":"17", "i18nValue":"17"},
                   {"value":"18", "i18nValue":"18"},{"value":"19", "i18nValue":"19"},
                   {"value":"20", "i18nValue":"20"},{"value":"21", "i18nValue":"21"},
                   {"value":"22", "i18nValue":"22"},{"value":"23", "i18nValue":"23"},
                   ];
ZRBaseComponentsUtils.minsArr = [
                    {"value":"0", "i18nValue":"00"},{"value":"5", "i18nValue":"05"},
                    {"value":"10", "i18nValue":"10"},{"value":"15", "i18nValue":"15"},
                    {"value":"20", "i18nValue":"20"},{"value":"25", "i18nValue":"25"},
                    {"value":"30", "i18nValue":"30"},{"value":"35", "i18nValue":"35"},
                    {"value":"40", "i18nValue":"40"},{"value":"45", "i18nValue":"45"},
                    {"value":"50", "i18nValue":"50"},{"value":"55", "i18nValue":"55"}
                    ];
ZRBaseComponentsUtils.weekdays = [
                    {"value":"1", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.sunday")},
                    {"value":"2", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.monday")},
                    {"value":"3", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.tuesday")},
                    {"value":"4", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.wednesday")},
                    {"value":"5", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.thursday")},
                    {"value":"6", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.friday")},
                    {"value":"7", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.saturday")}
                    ];
ZRBaseComponentsUtils.monthdays = [
                 	{"value":"1", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.1")},{"value":"2", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.2")},
                 	{"value":"3", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.3")},{"value":"4", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.4")},
                 	{"value":"5", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.5")},{"value":"6", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.6")},
                 	{"value":"7", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.7")},{"value":"8", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.8")},
                 	{"value":"9", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.9")},{"value":"10", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.10")},
                 	{"value":"11", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.11")},{"value":"12", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.12")},
                 	{"value":"13", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.13")},{"value":"14", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.14")},
                 	{"value":"15", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.15")},{"value":"16", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.16")},
                 	{"value":"17", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.17")},{"value":"18", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.18")},
                 	{"value":"19", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.19")},{"value":"20", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.20")},
                 	{"value":"21", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.21")},{"value":"22", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.22")},
                 	{"value":"23", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.23")},{"value":"24", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.24")},
                 	{"value":"25", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.25")},{"value":"26", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.26")},
                 	{"value":"27", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.27")},{"value":"28", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.28")},
                 	{"value":"29", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.29")},{"value":"30", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.30")},
                 	{"value":"31", "i18nValue":ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.31")},{ "value": "99", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.last") }
                 	];
//ignorei18n_end
