//$Id$
//ignorei18n_start
/*
Side nav for DB Settings Controller Array. Used in DBSettingsSideNav Component
*/
 var sideNavComponentArr = [ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.general"),
						   ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings"),
						   ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables")
						   ];
if(ZDBGlobal.isClrPltEnabled()){
	sideNavComponentArr.push(ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.colorpic"));
}

sideNavComponentArr.push(ZDBI18NMap.g("zrpt.dbsettings.gridTheme.js.gridTheme"));

if(ZDBGlobal.enableUsersSett){
	sideNavComponentArr.push(ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage"));
	sideNavComponentArr.push(ZDBI18NMap.g("zrpt.dbsettings.variables.js.users"));
}
if(ZDBClientUI.isPublishAllowed)
{	
sideNavComponentArr.push(ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"));
}
/*
DB Settings component. 
Returns the whole container of DB Settings. Takes as props the JsonInfo for rendering the Internal components.
*/
var DBSettingComponent = React.createClass({
	mixins : [ToolTipMixins],
	//For future use when we need to close any dialogs opened within the dbsettings dialog.
	closeInSequence : function(event){
		var openedDlg = ZRDBSettings.openedDlg;
		if(openedDlg <= 0){
			this.dbSettingsClose(event);
		}
		else{
			ZRDBSettings.openedDlg--;
			return true;
		}
		event.stopPropagation();
	},
	//For future use when we need to close any dialogs opened within the dbsettings dialog.
	closeInnerDlg : function(event){
		ZRDBSettings.openedDlg--;
		ZDBDialogUtil.closeDialog(event.target,event);
	},
	//Esc key handler for dbsettings
	//attached in componentDidMount and removed in ComponentWillUnmount
	dbSettingsKeyHandler : function(event){
		switch(event.keyCode){
			case KEY.ESC:
				//this.closeInSequence(event);
				event.stopPropagation();
				break;
			// case KEY.ENTER:
			// 	this.saveDBSettings(event);
			// 	break;
			default:
				return;
		}
	},
	//Unmounts the DbSettings component from the UI. Called in Back Button of UI or the Esc Key.
	dbSettingsClose : function(event){
		var holder = this.refs.DBSettingsComponent.parentNode;
		ReactDOM.unmountComponentAtNode(holder);
		ZRDBSettings.closeDBSetting();
	},
	//Side panel click handler
	handleSideNaveClicks : function(event){
		var target = event.target;	
		var navType = target.getAttribute("data-navType");
		if(navType === this.state.navType){
			return;
		}
		this.sendCorrespNavReq(navType,this.state.navType);
	},
	highlightFirstInput : function(navType){
		switch(navType){
			case sideNavComponentArr[0]:
			window.setTimeout(function(){ZRDBSettings.domNodeRef.querySelector("#ZRDBSetDBName").select();},0);
			break;
		}
	},
	//Sends server requests based on the side nav item selected.
	sendCorrespNavReq : function(navType, prevNavType){
		var params;
		ZRDBSettings.jsonInfoMap[this.state.navType] = this.state.jsonInfo;
		var jsonInfo = ZRDBSettings.jsonInfoMap[navType];
		if(jsonInfo){
			//this.setInitialState(jsonInfo,navType);
			if(navType == ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables")){
				if(jsonInfo.origVariables){
					delete jsonInfo.variables;
					var temp = jsonInfo.origVariables.slice(0);
					delete jsonInfo.origVariables;
					jsonInfo.variables = temp;
				}
			}
			this.setState({navType:navType,jsonInfo:jsonInfo});
			this.highlightFirstInput(navType);
			return;
		}
		var domNode = this.disableHolder();
		switch(navType){
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.general"):
				//General Settings
				params = "DBID="+ ZDBClientUI.dbId;
//				AjaxAPI.sendRequest({URL:"/ZRDBSettingsInfoFetcher.ma",PARAMETERS:params,
//		                    ONSUCCESSFUNC:this.handleSideNavServerRespSuccess,
//		                    ONFAILUREFUNC:this.commonFailureFunc,PREVNAVTYPE:prevNavType,
//		                    OPSTATUSID:"ZDBMainLoader",NAVTYPE:navType,DOMNODE:domNode
//                                });
                                ZRSAjax.get('/reportsapi/DBSETTINGS', params, {
                                    successHandler: {
                                        func: this.handleSideNavServerRespSuccess,
                                        ctx: this
                                    },
                                    failureHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    errorHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    PREVNAVTYPE:prevNavType,
                                    NAVTYPE:navType,
                                    DOMNODE:domNode
                                });
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings"):
				//Backup Settings
				params = "DBID="+ ZDBClientUI.dbId;
//				AjaxAPI.sendRequest({URL:"/ZRDBSettingsInfoFetcher.ma",PARAMETERS:params,
//		                    ONSUCCESSFUNC:this.handleSideNavServerRespSuccess,
//		                    DOMNODE:domNode,ONFAILUREFUNC:this.commonFailureFunc,
//		                    OPSTATUSID:"ZDBMainLoader",NAVTYPE:navType,PREVNAVTYPE:prevNavType
//		                 });
                                ZRSAjax.get('/reportsapi/DBBACKUPINFO', params, {
                                    successHandler: {
                                        func: this.handleSideNavServerRespSuccess,
                                        ctx: this
                                    },
                                    failureHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    errorHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    NAVTYPE:navType,
                                    PREVNAVTYPE:prevNavType,
                                    DOMNODE:domNode
                                });
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables"):
				//Variables Settings
				this.sendVariableReq(navType,false,prevNavType);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.colorpic"):
				//ColorModel Settings
//				AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId 
//				+"/GETDBCOLORMODEL",PARAMETERS: "DBID=" + ZDBClientUI.dbId,
//				ONSUCCESSFUNC:this.handleSideNavServerRespSuccess,
//				DOMNODE:domNode,ONFAILUREFUNC:this.commonFailureFunc,
//				LAZYLOADREQ:true,LAZYLOADJS:"ZDBChartSetting,zdbjs/react/ZRDBColorModel.js",
//                                LAZYLOADCSS:"CSSLIST_ANALYSISVIEWSTYLES",
//				OPSTATUSID:"ZDBMainLoader",NAVTYPE:navType,PREVNAVTYPE:prevNavType});
                                
                                ZRSAjax.get('/reportsapi/db/'+ ZDBClientUI.dbId +'/GETDBCOLORMODEL', 'DBID=' + ZDBClientUI.dbId, {
                                    successHandler: {
                                        func: this.handleSideNavServerRespSuccess,
                                        ctx: this
                                    },
                                    failureHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    errorHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    DOMNODE:domNode,
                                    LAZYLOADREQ:true,
                                    LAZYLOADJS:'ZDBChartSetting,zdbjs/react/ZRDBColorModel.js',
                                    LAZYLOADCSS:'CSSLIST_ANALYSISVIEWSTYLES',
                                    NAVTYPE:navType,
                                    PREVNAVTYPE:prevNavType
                                });
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.gridTheme.js.gridTheme"):
				this.sendGridThemeReq(navType,false,prevNavType);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage"):
				//Resources Settings
//				AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId 
//				+"/GETDBRESOURCE",ONSUCCESSFUNC:this.handleSideNavServerRespSuccess,
//				DOMNODE:domNode,ONFAILUREFUNC:this.commonFailureFunc,
//				LAZYLOADREQ:true,LAZYLOADJS:"zdbjs/react/ZRResourcesSettings.js",
//				OPSTATUSID:"ZDBMainLoader",NAVTYPE:navType,PREVNAVTYPE:prevNavType});
                                
                                ZRSAjax.get('/reportsapi/db/'+ ZDBClientUI.dbId +'/GETDBRESOURCE', null, {
                                    successHandler: {
                                        func: this.handleSideNavServerRespSuccess,
                                        ctx: this
                                    },
                                    failureHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    errorHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    DOMNODE:domNode,
                                    LAZYLOADREQ:true,
                                    LAZYLOADJS:'zdbjs/react/ZRResourcesSettings.js',
                                    NAVTYPE:navType,
                                    PREVNAVTYPE:prevNavType
                                });
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.variables.js.users"):
				//Users Settings
//				AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId 
//				+"/GETDBUSERLIST",ONSUCCESSFUNC:this.handleSideNavServerRespSuccess,
//				DOMNODE:domNode,ONFAILUREFUNC:this.commonFailureFunc,
//				LAZYLOADREQ:true,LAZYLOADJS:"zdbjs/react/ZRUsersSettings.js",
//				OPSTATUSID:"ZDBMainLoader",NAVTYPE:navType,PREVNAVTYPE:prevNavType});
                                ZRSAjax.get('/reportsapi/db/'+ ZDBClientUI.dbId +'/GETDBUSERLIST', null, {
                                    successHandler: {
                                        func: this.handleSideNavServerRespSuccess,
                                        ctx: this
                                    },
                                    failureHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    errorHandler: {
                                        func: this.commonFailureFunc,
                                        ctx: this
                                    },
                                    DOMNODE:domNode,
                                    LAZYLOADREQ:true,
                                    LAZYLOADJS:'zdbjs/react/ZRUsersSettings.js',
                                    NAVTYPE:navType,
                                    PREVNAVTYPE:prevNavType
                                });
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"):
				//Slideshow settings
//				AjaxAPI.sendRequest({URL:"/reportsapi/SLIDESINFO",
//				PARAMETERS:"DBID=" + ZDBClientUI.dbId,
//				ONSUCCESSFUNC:this.handleSideNavServerRespSuccess,
//				DOMNODE:domNode,ONFAILUREFUNC:this.slideShowFailure,
//				LAZYLOADREQ:true,LAZYLOADJS:"zdbjs/react/ZRSlideshow.js",
//				LAZYLOADCSS:["ZDBSlideshowDialog.css", "CSSLIST_ANALYSISVIEWSTYLES"],
//				OPSTATUSID:"ZDBMainLoader",NAVTYPE:navType,PREVNAVTYPE:prevNavType});
                                ZRSAjax.get('/reportsapi/SLIDESINFO', 'DBID=' + ZDBClientUI.dbId, {
                                    successHandler: {
                                        func: this.handleSideNavServerRespSuccess,
                                        ctx: this
                                    },
                                    failureHandler: {
                                        func: this.slideShowFailure,
                                        ctx: this
                                    },
                                    errorHandler: {
                                        func: this.slideShowFailure,
                                        ctx: this
                                    },
                                    DOMNODE:domNode,
                                    LAZYLOADREQ:true,
                                    LAZYLOADJS:'zdbjs/react/ZRSlideshow.js',
                                    LAZYLOADCSS:['ZDBSlideshowDialog.css', 'CSSLIST_ANALYSISVIEWSTYLES'],
                                    NAVTYPE:navType,
                                    PREVNAVTYPE:prevNavType
                                });
				break;
		}
	},
	commonFailureFunc : function(response,requestOptions){
		this.enableHolder(requestOptions["DOMNODE"]);
		this.setState({navType:requestOptions["PREVNAVTYPE"]});
		ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.js.commonfailure"));
	},
	slideShowFailure : function(response, requestOptions){
		var errorNumCode = response.data.errorNumCode;
		if(errorNumCode === 6063){
//			var json = {};
//			json.slideShowNotPossible = true;
//			response.responseText = JSON.stringify(json);
                        response.slideShowNotPossible = true;
			this.handleSideNavServerRespSuccess(response, requestOptions);
		}
		else{
			this.commonFailureFunc(response, requestOptions);
		}
		

	},
	sortVariablesByName : function(jsonInfo){
		var variables = jsonInfo.variables;
		var tempNameArr = [];
		var tempObj = {};
		variables.forEach(function(variable){
			tempNameArr.push(variable.VarName);
			tempObj[variable.VarName] = variable;
		});
		
		tempNameArr.sort(function(a,b){
			if(a.toLowerCase() < b.toLowerCase())
				return -1;
			if(a.toLowerCase() > b.toLowerCase())
				return 1;
			return 0;
		});
		var newVariables = [];
		tempNameArr.forEach(function(name){
			var variable = tempObj[name];
			newVariables.push(variable);
		})
		jsonInfo.variables = newVariables;
	},
	//Side Navigation interactions, server response handler.
	handleSideNavServerRespSuccess : function(jsonInfo, requestOptions){
		var navType = requestOptions["NAVTYPE"];
		if(requestOptions["LAZYLOADREQ"]){
			if(requestOptions["LAZYLOADJS"] && !ZDBLazyLoadUtil.loadJsAlone(requestOptions["LAZYLOADJS"], "APPENDTODOC", this.handleSideNavServerRespSuccess, [jsonInfo, requestOptions],"ZDBMainLoader")){
		  		return;
	  		}
	  		if(requestOptions["LAZYLOADCSS"] && !ZDBLazyLoadUtil.loadCssOnly(requestOptions["LAZYLOADCSS"], "APPENDTODOC", this.handleSideNavServerRespSuccess, [jsonInfo, requestOptions], "ZDBMainLoader")){
				return;
			}
		}
		this.enableHolder(requestOptions["DOMNODE"]);
//		var jsonInfo = JSON.parse(response.responseText);
		switch(navType){
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.general"):
				//Default Settings Success
				jsonInfo.FIELDSIZECLASS = fieldSizeClass;
				this.setInitialState(jsonInfo,ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.general"));
				this.setState({navType:ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.general"),jsonInfo:jsonInfo});
				this.highlightFirstInput(navType);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings"):
				//Backup Settings Success	
				this.setInitialState(jsonInfo,ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings"));
				this.setState({navType:ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings"),jsonInfo:jsonInfo})
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables"):
				//Variables Settings Success
				var jsonTemp = {};
				if(!requestOptions["DOMAINLOADED"]){
					jsonTemp.domains = this.reworkDomains(jsonInfo);
					ZRDBSettings.domains = jsonTemp.domains;	
					jsonTemp.variables = requestOptions.GETVARRESP.dbVariables;
				}
				else{
					jsonTemp.domains = ZRDBSettings.domains;
					jsonTemp.variables = jsonInfo.dbVariables;
				}
				jsonInfo = jsonTemp;
				this.sortVariablesByName(jsonInfo);
				this.setInitialState(jsonInfo,ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables"));
				jsonInfo.newValCount = 1;
				jsonInfo.allValKey = "__All__Value";
				jsonInfo.sort = "asc";
				jsonInfo.newVariableKey = "__new__variable";
				jsonInfo.defaultValueKey = "__DEFAULT";
				this.setState({navType:ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables"),jsonInfo:jsonInfo});
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.colorpic"):
				//ColorMode Settings Success
				this.setInitialState(jsonInfo,ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.colorpic"));
				this.setState({navType:ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.colorpic"),jsonInfo:jsonInfo});
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.gridTheme.js.gridTheme"):
				this.setInitialState(jsonInfo, ZDBI18NMap.g("zrpt.dbsettings.gridTheme.js.gridTheme"));
				this.setState({ navType: ZDBI18NMap.g("zrpt.dbsettings.gridTheme.js.gridTheme"), jsonInfo: jsonInfo });
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage"):
				//Resources Settings Success
				this.setInitialState(jsonInfo,ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage"));
				this.setState({navType:ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage"),jsonInfo:jsonInfo});
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.variables.js.users"):
				//Users Settings Success
				this.setInitialState(jsonInfo,ZDBI18NMap.g("zrpt.dbsettings.variables.js.users"));
				this.setState({navType:ZDBI18NMap.g("zrpt.dbsettings.variables.js.users"),jsonInfo:jsonInfo});
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"):
				this.setInitialState(jsonInfo,ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"));
				this.setState({navType:ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"),jsonInfo:jsonInfo});
				break;
		}
	},
	reworkDomains : function(jsonInfo){
		var domains = [];
		//var domains = [{value:'-1', i18nValue:ZDBGlobal.REPORTS_SERVER_URL.replace(/.*?:\/\//g,"")}];
		jsonInfo.zaidVsDomain.forEach(function(domain){
			var temp = {};
			temp.value = domain.Zaid;
			temp.i18nValue = domain.DomainName;
			domains.push(temp);
		})
		return domains;
	},
	sendVariableReq : function(navType,domainLoaded,prevNavType){
		var domNode = this.disableHolder();
		var succFunc = (domainLoaded)?this.handleSideNavServerRespSuccess:this.sendDomainReq;
//		var requestOptions = {URL:"/reportsapi/db/"+ ZDBClientUI.dbId +"/GETDBVARIABLES",
//							ONSUCCESSFUNC:succFunc,DOMNODE:domNode,PREVNAVTYPE:prevNavType,
//							ONFAILUREFUNC:this.commonFailureFunc,DOMAINLOADED:domainLoaded,
//                    		OPSTATUSID:"ZDBMainLoader",NAVTYPE:navType};
//		AjaxAPI.sendRequest(requestOptions);
                
                ZRSAjax.get('/reportsapi/db/'+ ZDBClientUI.dbId +'/GETDBVARIABLES', null, {
                    successHandler: {
                        func: succFunc,
                        ctx: this
                    },
                    failureHandler: {
                        func: this.commonFailureFunc,
                        ctx: this
                    },
                    errorHandler: {
                        func: this.commonFailureFunc,
                        ctx: this
                    },
                    DOMNODE: domNode,
                    PREVNAVTYPE:prevNavType,
                    DOMAINLOADED:domainLoaded,
                    NAVTYPE:navType
                });
	},
	sendDomainReq : function(response,requestOptions){
//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId +"/GETZAIDVSDOMAIN",
//                    ONSUCCESSFUNC:this.handleSideNavServerRespSuccess,
//                    ONFAILUREFUNC:this.commonFailureFunc,
//                    DOMNODE:requestOptions["DOMNODE"],
//                    OPSTATUSID:"ZDBMainLoader",
//                    GETVARRESP:response,
//                    LAZYLOADREQ:true,LAZYLOADJS:"zdbjs/react/ZRDBVariables.js",
//                    NAVTYPE:requestOptions["NAVTYPE"]
//                });
                ZRSAjax.get('/reportsapi/db/'+ ZDBClientUI.dbId +'/GETZAIDVSDOMAIN', null, {
                    successHandler: {
                        func: this.handleSideNavServerRespSuccess,
                        ctx: this
                    },
                    failureHandler: {
                        func: this.commonFailureFunc,
                        ctx: this
                    },
                    errorHandler: {
                        func: this.commonFailureFunc,
                        ctx: this
                    },
                    DOMNODE:requestOptions["DOMNODE"],
                    GETVARRESP:response,
                    LAZYLOADREQ:true,
                    LAZYLOADJS:"zdbjs/react/ZRDBVariables.js",
                    NAVTYPE:requestOptions["NAVTYPE"]
                });
	},
	sendGridThemeReq:function(navType,dialogueLoaded,prevNavType){
		var domNode = this.disableHolder();
		if(ThemeComponent.pivotThemeDialogue)
		{
		dialogueLoaded = true;
		}
		var succFunc = dialogueLoaded ? this.handleSideNavServerRespSuccess : this.sendGridThemeReq;	
		if(!dialogueLoaded)
			{
		ZDBLazyLoadUtil.loadSnippet("ZRTheme","/ZRTheme.cc",this,"APPENDTODOC",null,this.sendGridThemeReq,[navType,true,prevNavType]);
			}
		else
			{
//			AjaxAPI.sendRequest({ URL: "/reportsapi/db/" + ZDBClientUI.dbId + "/GETDBGRIDTHEME", PARAMETERS: "DBID=" + ZDBClientUI.dbId, ONSUCCESSFUNC: succFunc,
//				DOMNODE: domNode, ONFAILUREFUNC: this.commonFailureFunc,
//				LAZYLOADREQ: true, LAZYLOADJS: "zdbjs/react/ZRDBGridTheme.js",
//				LAZYLOADCSS: "CSSLIST_ANALYSISVIEWSTYLES",
//				OPSTATUSID: "ZDBMainLoader", NAVTYPE: navType, PREVNAVTYPE: prevNavType });
                            ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETDBGRIDTHEME', 'DBID=' + ZDBClientUI.dbId, {
                                successHandler: {
                                    func: succFunc,
                                    ctx: this
                                },
                                failureHandler: {
                                    func: this.commonFailureFunc,
                                    ctx: this
                                },
                                errorHandler: {
                                    func: this.commonFailureFunc,
                                    ctx: this
                                },
                                DOMNODE: domNode,
                                LAZYLOADREQ: true, 
                                LAZYLOADJS: "zdbjs/react/ZRDBGridTheme.js",
				LAZYLOADCSS: "CSSLIST_ANALYSISVIEWSTYLES", 
                                NAVTYPE: navType, 
                                PREVNAVTYPE: prevNavType
                            });
			}	
	},
	//Sets a reference to fallback to when reset is clicked.
	setInitialState : function(jsonInfo,navType){
		if(!ZRDBSettings.initialState){
			ZRDBSettings.initialState = {};
		}
		ZRDBSettings.initialState[navType] = {};
		ZRDBSettings.initialState[navType] = ZDBClientUtil.merge(ZRDBSettings.initialState[navType],jsonInfo);
	},
	//Sets the Backup settings to disable it.
	disableBackup : function(){
		var jsonInfo = this.state.jsonInfo;
		jsonInfo.BACKUPENABLED = false;
		jsonInfo.SCHEDULEINFO.CALENDAR_TIME = -1;
		jsonInfo.SCHEDULEINFO.CALENDAR_DAY = -1;
		jsonInfo.SCHEDULEINFO.CALENDAR_DATE = -1;
		this.checkAndAppendToModifiedObj("BACKUPENABLED",false);
		this.checkAndAppendToModifiedObj("CALENDARFREQ",-1);
		this.checkAndAppendToModifiedObj("CALENDARTIME",-1);
		this.checkAndAppendToModifiedObj("CALENDARDATE",-1);
		this.rerenderComp(jsonInfo);
	},
	//Sets the Backup settings to enable it.
	enableBackup : function(){
		var jsonInfo = this.state.jsonInfo;
		jsonInfo.SCHEDULEINFO.CALENDAR_FREQ = "daily";
		jsonInfo.SCHEDULEINFO.CALENDAR_TIME = 0;
		jsonInfo.SCHEDULEINFO.CALENDAR_DAY = -1;
		jsonInfo.SCHEDULEINFO.CALENDAR_DATE = -1;
		this.checkAndAppendToModifiedObj("BACKUPENABLED",true);
		this.checkAndAppendToModifiedObj("CALENDARFREQ","daily");
		this.checkAndAppendToModifiedObj("CALENDARTIME",0);
		this.checkAndAppendToModifiedObj("CALENDARDAY",-1);
		this.checkAndAppendToModifiedObj("CALENDARDATE",-1);
		this.rerenderComp(jsonInfo);
	},
	//Returns scheduler nave for scheduling backup
	getSchedulerName : function(modifiedJson){
		if(!modifiedJson.BACKUPENABLED){
			return 'none';
		}
		var schInfo = modifiedJson.SCHEDULEINFO;
		switch(schInfo.CALENDAR_FREQ){
			case "daily":
			return schInfo.CALENDAR_TIME + "_" + schInfo.CALENDAR_FREQ;
			break;
			case "weekly":
			return schInfo.CALENDAR_TIME + "_" + schInfo.CALENDAR_FREQ + 
					"_" + schInfo.CALENDAR_DAY;
			break;
			case "monthly":
			return schInfo.CALENDAR_TIME + "_" + schInfo.CALENDAR_FREQ + 
					"_" + schInfo.CALENDAR_DATE;
			break;
		}
	},
	sendBackupReqNClose : function(event){
		this.sendBackupReq({closeDBSettings: true});
//		this.dbSettingsClose(event);
	},
	//Sends server request to set backup.
	sendBackupReq : function(closeDBSet){
		var jsonInfo = this.state.jsonInfo;
		if(!jsonInfo.MODIFIED){
			ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.dbsettings.variables.js.backupmodsucc"));
			return;
		}
		var domNode = this.disableHolder();
		var schedulerName = encodeURIComponent(this.getSchedulerName(this.state.jsonInfo));
		var params = "ZDBACTION=BACKUPSCHEDULESET&SCHEDULERNAME="+schedulerName+"&DBID="+encodeURIComponent(jsonInfo.DBID);
		AjaxAPI.sendRequest({URL:"/ZDBBackupDatabase.ve?",PARAMETERS:params,
						     ONSUCCESSFUNC:this.handleSendBackupReqSuccess,
						     ONFAILUREFUNC:this.handleSendBackupReqFailure,
						 	 DOMNODE:domNode,OPSTATUSID:"ZDBMainLoader",
                                                     CLOSEDBSETTINGS:closeDBSet && closeDBSet.closeDBSettings});
	},
	//Handles backup schedule server response.
	handleSendBackupReqSuccess : function(response,requestOptions){
		var domNode = requestOptions["DOMNODE"];
		this.enableHolder(domNode);
		var jsonInfo = this.state.jsonInfo;
		jsonInfo.MODIFIED = null;
		ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.dbsettings.variables.js.backupmodsucc"));
                if(requestOptions.CLOSEDBSETTINGS)
                    this.dbSettingsClose();
		this.setInitialState(jsonInfo,this.state.navType);
		this.rerenderComp(jsonInfo);
	},
	handleSendBackupReqFailure : function(response,requestOptions){
		var domNode = requestOptions["DOMNODE"]
		this.enableHolder(domNode);
		ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.variables.js.backupmodfail"));
	},
	//Handles interactions to backup settings.
	handleBackupDBChange : function(event){
		var el = event.target;
		var id = el.getAttribute("id");
		var jsonInfo = this.state.jsonInfo;
		switch(id){
			case "ZRDBSettingsBackupYes":
			jsonInfo.BACKUPENABLED = true;
			jsonInfo.SCHEDULEINFO = {};
			this.enableBackup();
			break;
			case "ZRDBSettingsBackupNo":
			this.disableBackup();
			break;
			case "BackupRepeat":
			var value = el.value;
			switch(value){
				case "daily":
				this.enableBackup();
				break;
				case "none":
				this.disableBackup();
				break;
				case "weekly":
				jsonInfo.SCHEDULEINFO.CALENDAR_FREQ = "weekly";
				jsonInfo.SCHEDULEINFO.CALENDAR_TIME = 0;
				jsonInfo.SCHEDULEINFO.CALENDAR_DAY = 1;
				jsonInfo.SCHEDULEINFO.CALENDAR_DATE = -1;
				this.checkAndAppendToModifiedObj("CALENDARFREQ","weekly");
				this.checkAndAppendToModifiedObj("CALENDARTIME",0);
				this.checkAndAppendToModifiedObj("CALENDARDAY",1);
				this.checkAndAppendToModifiedObj("CALENDARDATE",-1);
				this.setState({jsonInfo:jsonInfo});
				break;
				case "monthly":
				jsonInfo.SCHEDULEINFO.CALENDAR_FREQ = "monthly";
				jsonInfo.SCHEDULEINFO.CALENDAR_TIME = 0;
				jsonInfo.SCHEDULEINFO.CALENDAR_DATE = 1;
				jsonInfo.SCHEDULEINFO.CALENDAR_DAY = -1;
				this.checkAndAppendToModifiedObj("CALENDARFREQ","monthly");
				this.checkAndAppendToModifiedObj("CALENDARTIME",0);
				this.checkAndAppendToModifiedObj("CALENDARDATE",1);
				this.checkAndAppendToModifiedObj("CALENDARDAY",-1);
				this.setState({jsonInfo:jsonInfo});
				break;
			}
			break;
			case "BackupPerformEvery":
				var value = parseInt(el.value);
				jsonInfo.SCHEDULEINFO.CALENDAR_DAY = value;
				this.checkAndAppendToModifiedObj("CALENDARDAY",value);
				this.setState({jsonInfo:jsonInfo});
			break;
			case "BackupDayOfMonth":
				var value = parseInt(el.value);
				jsonInfo.SCHEDULEINFO.CALENDAR_DATE = value;
				this.checkAndAppendToModifiedObj("CALENDARDATE",value);
				this.setState({jsonInfo:jsonInfo});
			break;
			case "BackupHrs":
			var mins = jsonInfo.SCHEDULEINFO.CALENDAR_TIME % 60;
			var value = parseInt(el.value);
			var totalValue = (value * 60) + mins;
			jsonInfo.SCHEDULEINFO.CALENDAR_TIME = totalValue;
			this.checkAndAppendToModifiedObj("CALENDARTIME",totalValue);
			this.setState({jsonInfo:jsonInfo});
			break;
			case "BackupMins":
			var mins = jsonInfo.SCHEDULEINFO.CALENDAR_TIME % 60;
			var hrs = jsonInfo.SCHEDULEINFO.CALENDAR_TIME - mins;
			mins = parseInt(el.value);
			var totalValue = hrs + mins;
			jsonInfo.SCHEDULEINFO.CALENDAR_TIME = totalValue;
			this.checkAndAppendToModifiedObj("CALENDARTIME",totalValue);
			this.setState({jsonInfo:jsonInfo});
			break;
		}
	},
	//Default props for Db settings component
	getDefaultProps:function(){
		return {id:"DBSettingsComponent", className:"ZRDBSettingsComponent", style:{}};
	},
	//Default State for DB Settings component
	getInitialState : function(){
		return {navType : this.props.initialRender}
	},
	//Sets initial state of reference and initialises state for DB Settings Component
	componentWillMount : function(event){
		this.setInitialState(this.props.jsonInfo,sideNavComponentArr[0]);
		this.setState({
			jsonInfo:this.props.jsonInfo,
			navType:this.props.initialRender
		})
	},
	//attaches escape key handler for DB Settings Component
	componentDidMount : function(event){
		ZRDBSettings.domNodeRef = ReactDOM.findDOMNode(this);
		ZRDBSettings.domNodeRef.addEventListener("keydown",this.dbSettingsKeyHandler);
		this.highlightFirstInput(this.state.navType);
	},
	//remove escape key handler for DB Settings Component
	componentWillUnmount : function(event){
		delete ZRDBSettings.initialState;
		delete ZRDBSettings.jsonInfoMap;
		ZRDBSettings.jsonInfoMap = {};
		ZRDBSettings.domNodeRef.removeEventListener("keydown",this.dbSettingsKeyHandler);
	},
	//validation of dbname and dbdesc leng checks.
	validateAndUpdateStateDBNameAndDesc : function(event){
		var el = event.target;
		var value = el.value;
		var inputType = el.getAttribute("data-inputtype");
		var length = el.getAttribute("data-zdbfieldlength");
		var cond = (inputType == "DBNAME")?(value.length == 0 || value.length > length):(value.length > length);
		if(cond){
			var errMsg = el.getAttribute("data-errormsg");
			showCustomMessage(errMsg,el);
			if(value.length !=0){
				return;
			}
		}
		else{
			hideCustomMessage();
		}
		var jsonInfo = this.state.jsonInfo;
		if(inputType == "DBNAME"){jsonInfo.DBNAME=el.value;}else{jsonInfo.DBDESC=el.value;}
		this.checkAndAppendToModifiedObj(inputType,el.value);
		this.rerenderComp(jsonInfo);
	},
	validateDefaultNullValue : function(event){
		var el = event.target;
		var value = el.value;
		var length = el.getAttribute("data-zdbfieldlength");
		if(value.length > length){
			var errMsg = el.getAttribute("data-errormsg");
			showCustomMessage(errMsg,el);
			return;
		}
		var jsonInfo = this.state.jsonInfo;
		jsonInfo.DEFAULTNULLVALUE = value;
		this.checkAndAppendToModifiedObj("DEFAULTNULLVALUE",value);
		this.rerenderComp(jsonInfo);
	},
	//on blur check for dbname
	focusValidationDBName : function(event){
		var el = event.target;
		ZRDBSettings.dbName = el;
		if(el.value.length == 0){
			var errMsg = el.getAttribute("data-errormsg");
			showCustomMessage(errMsg,el);
			window.setTimeout(function(){ZRDBSettings.dbName.focus();},0);
			return;
		}
	},
	//db prop change handler
	handleDBPropChange : function(event){
		var el = event.target;
		var value = el.value;
		var type = el.getAttribute("id");
		var jsonInfo = this.state.jsonInfo;
		var modifiedJson;
		switch(type){
			case "ZRDBSettingsWeekStart":
			jsonInfo.CURWEEKSTART = value;
			this.checkAndAppendToModifiedObj("CURWEEKSTART",value);
			break;
			case "ZRDBSettingsStartMonth":
			jsonInfo.STARTMONTH = value;
			this.checkAndAppendToModifiedObj("STARTMONTH",value);
			break;
			case "ZRDBSettingsYearFormat":
			jsonInfo.YEARFORMAT = value;
			this.checkAndAppendToModifiedObj("YEARFORMAT",value);
			break;
			case "ZRDBSettingsDefaultNUllValue":
			jsonInfo.DEFAULTNULLVALUE = value;
			this.checkAndAppendToModifiedObj("DEFAULTNULLVALUE",value);
			break;
			case "ZRDBSettingsDefaultDBYes":
			jsonInfo.ISDEFAULTDB = "true";
			this.checkAndAppendToModifiedObj("ISDEFAULTDB","true");
			break;
			case "ZRDBSettingsDefaultDBNo":
			jsonInfo.ISDEFAULTDB = "false";
			this.checkAndAppendToModifiedObj("ISDEFAULTDB","false");
			break;
			case "ZRDBSettingsShowHiddenColumnsInReportCreationYes":
			jsonInfo.SHOWHIDDENCOLSINREPORTCREATION = "true";
			this.checkAndAppendToModifiedObj("SHOWHIDDENCOLSINREPORTCREATION","true");
			break;
			case "ZRDBSettingsShowHiddenColumnsInReportCreationNo":
			jsonInfo.SHOWHIDDENCOLSINREPORTCREATION = "false";
			this.checkAndAppendToModifiedObj("SHOWHIDDENCOLSINREPORTCREATION","false");
			break;
			case "ZRDBSettingsWeekYearFormat":
			jsonInfo.WEEKYEARFORMAT = value;
			this.checkAndAppendToModifiedObj("WEEKYEARFORMAT",value);
			break;
			case "ZRDBSettingsWeekMode":
			jsonInfo.WEEKMODE = value;
			this.checkAndAppendToModifiedObj("WEEKMODE",value);
			break;
		}
		this.rerenderComp(jsonInfo);
	},
	//resets all value to the initial state.
	resetToInitial : function(event){
		var jsonInfo = {};
		jsonInfo = ZDBClientUtil.merge(jsonInfo,ZRDBSettings.initialState[this.state.navType]);
		var src = event.target;
		src.parentNode.querySelector("#DBSetSaveSuccess").style.display = "none";
		src.parentNode.querySelector("#DBSetSaveFailure").style.display = "none";
		this.rerenderComp(jsonInfo);
		hideCustomMessage();
	},
	saveNCloseDBSettings : function(event){
		this.saveDBSettings(event, {closeDBSettings: true});
//		this.dbSettingsClose(event);
	},
	//sends the modified value to the server for changes
	saveDBSettings : function(event, eventData){
		if(this.state.navType == ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables")){
			return;
		}
		if(!this.state.jsonInfo.MODIFIED){
			ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.dbsettings.variables.js.generalmodsucc"));
			return;
		}
		else if(ZRDBSettings.dbName && ZRDBSettings.dbName.value.trim().length <= 0){
			var errMsg = ZRDBSettings.dbName.getAttribute("data-errormsg");
			showCustomMessage(errMsg,ZRDBSettings.dbName);
			window.setTimeout(function(){ZRDBSettings.dbName.focus();},0);
			return;
		}
		if(this.state.jsonInfo.MODIFIED.SHOWHIDDENCOLSINREPORTCREATION)
		{
			ZDBClientUI.dbConfig.showHiddenColsInReportCreation = (this.state.jsonInfo.MODIFIED.SHOWHIDDENCOLSINREPORTCREATION == "true") ? true : false;
		}
		var domNode = this.disableHolder();
		var params = "JSONINFO="+encodeURIComponent(JSON.stringify(this.state.jsonInfo.MODIFIED))+"&DBID="+encodeURIComponent(this.state.jsonInfo.DBID);
//		AjaxAPI.sendRequest({URL:"/ZRDBSettingsInfoFetcher.ma",PARAMETERS:params,
//		                    ONSUCCESSFUNC:this.handleDBSettSaveSuccess,
//		                    ONFAILUREFUNC:this.handleDBSettSaveFailure,
//		                    OPSTATUSID:"ZDBMainLoader",DOMNODE:domNode,SRC:event.target,
//                                    CLOSEDBSETTINGS:eventData && eventData.closeDBSettings
//		                 });
                ZRSAjax.post('/reportsapi/UPDATEDBSETTINGS', params, {
                    successHandler: {
                        func: this.handleDBSettSaveSuccess,
                        ctx: this
                    },
                    failureHandler: {
                        func: this.handleDBSettSaveFailure,
                        ctx: this
                    },
                    errorHandler: {
                        func: this.handleDBSettSaveFailure,
                        ctx: this
                    },
                    DOMNODE: domNode,
                    SRC: event.target,
                    CLOSEDBSETTINGS: eventData && eventData.closeDBSettings
                });
	},
	//disable db settings holder during server interaction.
	disableHolder : function(){
		var domNode = ZRDBSettings.domNodeRef;
		if(domNode.classList){
			ZRDBSettings.domNodeRef.classList.add("disableDiv");
		}
		else{
			domNode.className += " disableDiv";
		}
		return domNode;
	},
	//enables the db settings holder during server interaction.
	enableHolder : function(el){
		if(el.classList){
			el.classList.remove("disableDiv");
		}
		else{
			el.className = el.className.substr(0,el.className.indexOf(" disableDiv"));
		}
	},
	//success handler for db settings prop changes
	handleDBSettSaveSuccess : function(response,requestOptions){
		var jsonInfo = this.state.jsonInfo;
		var domNode = requestOptions["DOMNODE"]
		this.enableHolder(domNode);
		ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.dbsettings.variables.js.generalmodsucc"));
		if(jsonInfo.MODIFIED["DBNAME"] || jsonInfo.MODIFIED["DBDESC"]){
			var params = {"DBNAME":jsonInfo["DBNAME"],"DESC":jsonInfo["DBDESC"]};
			ZDBNavigation.updateDBDetails(params);
		}
                if(requestOptions.CLOSEDBSETTINGS){
                    this.dbSettingsClose();
                    return;
                }
		jsonInfo.MODIFIED = null;
		this.setInitialState(this.state.jsonInfo,this.state.navType);
		this.setState({jsonInfo:jsonInfo});
	},	
	//failure handler for db settings prop changes.
	handleDBSettSaveFailure : function(response,requestOptions){
		var domNode = requestOptions["DOMNODE"]
		this.enableHolder(domNode);
		var errorNumCode = response.code;
		if(errorNumCode === 7101){
			ZDBMsgBox.showError(response.message);
			return;
		}
		ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.variables.js.backupmodfail"));
	},
	//changes modified values and appends the modified object to the json info
	checkAndAppendToModifiedObj : function(modifiedField,modifiedValue){
		var originalValue = ZRDBSettings.initialState[this.state.navType][modifiedField];
		var modifiedJson = this.state.jsonInfo.MODIFIED;
		if(originalValue == modifiedValue && this.state.navType != ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings")){
			if(modifiedJson && modifiedJson[modifiedField] != null){
				delete modifiedJson[modifiedField];
				if(Object.keys(modifiedJson).length <= 0){
					modifiedJson = null;
					this.state.jsonInfo.MODIFIED = modifiedJson;
				}
			}
			return;
		}
		if(!modifiedJson){
			modifiedJson = {};
		}
		var newObj = {};
		newObj[modifiedField] = modifiedValue;
		var modifiedJson = ZDBClientUtil.merge(modifiedJson,newObj);
		this.state.jsonInfo.MODIFIED = modifiedJson;
	},
	handleDoSearchForVariables : function(value){
		var variables = this.state.jsonInfo.origVariables || this.state.jsonInfo.variables;
		var searchVariables = [];
		variables.forEach(function(variable){
			if(variable.VarName.toLowerCase().indexOf(value) != -1 || variable.VarDefVal.toLowerCase().indexOf(value) != -1){
				searchVariables.push(variable);
			}
			// if(value == "all" && variable.VarDefVal == this.state.jsonInfo.allValKey){
			// 	searchVariables.push(variable);
			// }
		}.bind(this));
		var jsonInfo = this.state.jsonInfo;
		if(!jsonInfo.origVariables){
			jsonInfo.origVariables = variables.slice(0);
		}
		delete jsonInfo.variables;
		jsonInfo.variables = searchVariables;
		this.rerenderComp(jsonInfo);
	},
	resetSearchForVariables : function(){
		var jsonInfo = this.state.jsonInfo;
		if(jsonInfo.origVariables){
			delete jsonInfo.variables;
			jsonInfo.variables = jsonInfo.origVariables.slice(0);
		}
		delete jsonInfo.origVariables;
		this.rerenderComp(jsonInfo);
	},
	rerenderComp : function(jsonInfo){
		this.setState({
			jsonInfo:jsonInfo
		})
	},
	//the main render function of db settings component.
	render:function(){
			var jsonInfo = this.state.jsonInfo;
		return(
			<div id={this.props.id} ref={this.props.id}	style={this.props.style} className={this.props.className}>
				<DBSettingsHeader onClose={this.dbSettingsClose} jsonInfo={jsonInfo}/>
				<DBSettingsBody showToolTips={this.showToolTips} hideToolTips={this.hideToolTips} ref="BODYCONTENT" handleBackupDBChange={this.handleBackupDBChange}
				validateAndUpdateStateDBNameAndDesc={this.validateAndUpdateStateDBNameAndDesc} handleDBPropChange={this.handleDBPropChange}
				saveNCloseDBSettings={this.saveNCloseDBSettings}
				sidenavClick={this.handleSideNaveClicks} navType={this.state.navType} jsonInfo={jsonInfo} closeDBSettings={this.dbSettingsClose}
				focusValidationDBName={this.focusValidationDBName} resetToInitial={this.resetToInitial} saveDBSettings={this.saveDBSettings}
				sendBackupReq={this.sendBackupReq} 
				sendBackupReqNClose={this.sendBackupReqNClose}
				validateDefaultNullValue={this.validateDefaultNullValue}  sendVariableReq={this.sendVariableReq} 
				disableHolder={this.disableHolder} enableHolder={this.enableHolder}
				handleDoSearchForVariables={this.handleDoSearchForVariables} resetSearchForVariables={this.resetSearchForVariables}
				rerenderComp={this.rerenderComp}/>
			</div>
		);
	}
});

var DBSettingsHeader = React.createClass({
	//default properties of db settings header.
	getDefaultProps:function(){
		return {
				desc:ZDBI18NMap.g("zrpt.dbsettings.js.desc"),
				ref:"DBSettingsHeader",
				classname:"ZRDBSettingsHeader"};
	},
	//main render function of dbsettings header component.
	render:function(){
		var props = this.props;
		var dbName = ZRDBSettings.initialState[ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.general")].DBNAME || document.getElementById("ZDBDBNAME").innerText;
		return(
			<div ref={this.props.ref} id={this.props.ref} style={this.props.style} className={this.props.classname}>
				<BackIcon style={{float:'left',margin:'10px',marginTop:'15px'}} classname="navBack" onClick={this.props.onClose} />
				<div className="ZRDBSettingsDBName">{dbName}</div>
				<div className="ZRDBSettingsDBDesc">{props.desc}</div>
			</div>
		);
	}
});

var DBSettingsBody = React.createClass({
	//main render function of dbsettings body component.
	render : function(){
		return (
				<div className="ZRDBSettingsBody">
					<DBSettingsSideNav sidenavClick={this.props.sidenavClick} ref='DBSettingsSideNav' jsonInfo={this.props.jsonInfo} navType={this.props.navType}/>
					<DBSettingsBodyContent showToolTips={this.props.showToolTips} saveDBSettings={this.props.saveDBSettings}
					saveNCloseDBSettings={this.props.saveNCloseDBSettings}
					validateAndUpdateStateDBNameAndDesc={this.props.validateAndUpdateStateDBNameAndDesc} closeDBSettings={this.props.closeDBSettings}
					focusValidationDBName={this.props.focusValidationDBName} resetToInitial={this.props.resetToInitial}
					hideToolTips={this.props.hideToolTips} jsonInfo={this.props.jsonInfo} onClose={this.props.closeInnerDlg}
					curSelSideNav={this.props.navType} handleDBPropChange={this.props.handleDBPropChange} ref='DBSettingsBodyContent'
					handleBackupDBChange={this.props.handleBackupDBChange}
					sendBackupReqNClose={this.props.sendBackupReqNClose} sendBackupReq={this.props.sendBackupReq}
					validateDefaultNullValue={this.props.validateDefaultNullValue} sendVariableReq={this.props.sendVariableReq}
					disableHolder={this.props.disableHolder}
					enableHolder={this.props.enableHolder} handleDoSearchForVariables={this.props.handleDoSearchForVariables}
					resetSearchForVariables={this.props.resetSearchForVariables}
					rerenderComp={this.props.rerenderComp}/>
				</div>
			)
	}
})


var DBSettingsSideNav = React.createClass({
	//default props of dbsettings side nav component.
	getDefaultProps : function(){
		return {sideComponents:sideNavComponentArr};
	},
	//main render function of dbsettings side nav component.
	render : function(){
		var sideComps = [];
		var hideBackup = (!ZDBGlobal.isDBOwnerNotAdmin || ZDBClientUI.isCustomDomain || ZDBGlobal.IS_ONPREMISE_BUILD )?"none":"";
		this.props.sideComponents.forEach(function(sideComp){
			var classname = 'ZRDBSettingsSideNavItem';
			if(this.props.navType == sideComp){
				classname += ' ZRDBSettingsNavSelected';
			}
			var comp = (<div ref={sideComp} className={classname} onClick={this.props.sidenavClick} data-navtype={sideComp} key={sideComp}>{sideComp}</div>);
			if(hideBackup == "none" && sideComp == ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings")){
				comp = (<div ref={sideComp} style={{display:hideBackup}} className={classname} onClick={this.props.sidenavClick} data-navtype={sideComp} key={sideComp}>{sideComp}</div>);
			}
			sideComps.push(comp);
		}.bind(this));
		return(
			<div className="ZRDBSettingsSideNav">
				{sideComps}
			</div>
		)
	}
});


var DBSettingsBodyContent = React.createClass({
	//main render function of dbsettingsbodycomponent
	render : function(){
		var bodyContentContainer = null;
		switch(this.props.curSelSideNav){
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.general"):
				bodyContentContainer = (<DBSettingsBodyContentOfGeneral resetToInitial={this.props.resetToInitial} saveDBSettings={this.props.saveDBSettings}
					showToolTips={this.props.showToolTips} hideToolTips={this.props.hideToolTips} handleDBPropChange={this.props.handleDBPropChange}
					jsonInfo={this.props.jsonInfo}
					saveNCloseDBSettings={this.props.saveNCloseDBSettings} focusValidationDBName={this.props.focusValidationDBName}  closeDBSettings={this.props.closeDBSettings}
					showCopyDlg={this.showDBSettingsCopyDlg} validateAndUpdateStateDBNameAndDesc={this.props.validateAndUpdateStateDBNameAndDesc} 
					validateDefaultNullValue={this.props.validateDefaultNullValue}/>);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings"):
				bodyContentContainer = (<DBSettingsBackupDlg handleBackupDBChange={this.props.handleBackupDBChange} jsonInfo={this.props.jsonInfo} 
										sendBackupReqNClose={this.props.sendBackupReqNClose}
										sendBackupReq={this.props.sendBackupReq} resetToInitial={this.props.resetToInitial}  closeDBSettings={this.props.closeDBSettings}
										showToolTips={this.props.showToolTips} hideToolTips={this.props.hideToolTips} />);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables"):
				bodyContentContainer = (<DBSettingsVariableDlg jsonInfo={this.props.jsonInfo} sendVariableReq={this.props.sendVariableReq}
										 closeDBSettings={this.props.closeDBSettings}
										 disableHolder={this.props.disableHolder}
										 enableHolder={this.props.enableHolder} handleDoSearchForVariables={this.props.handleDoSearchForVariables}
										 showToolTips={this.props.showToolTips} hideToolTips={this.props.hideToolTips} rerenderComp={this.props.rerenderComp}
										 resetSearchForVariables={this.props.resetSearchForVariables} />);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.colorpic"):
				bodyContentContainer = (
					<DBSettingsColorModel jsonInfo={this.props.jsonInfo} 
						showToolTips={this.props.showToolTips}
						hideToolTips={this.props.hideToolTips}
						rerenderComp={this.props.rerenderComp}
						disableHolder={this.props.disableHolder}
						enableHolder={this.props.enableHolder}
						isViewMode={false}
						closeDBSettings={this.props.closeDBSettings} />
				);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.gridTheme.js.gridTheme"):
				bodyContentContainer = React.createElement(DBSettingsGridTheme,{ jsonInfo: this.props.jsonInfo,closeDBSettings: this.props.closeDBSettings});
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage"):
				bodyContentContainer = (
					<DBResourceSettings jsonInfo={this.props.jsonInfo}
						rerenderComp={this.props.rerenderComp}
						disableHolder={this.props.disableHolder}
						enableHolder={this.props.enableHolder}/>
				);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.variables.js.users"):
				bodyContentContainer = (
					<DBUsersSettingsComponent jsonInfo={this.props.jsonInfo} 
						showToolTips={this.props.showToolTips}
						hideToolTips={this.props.hideToolTips}
						rerenderComp={this.props.rerenderComp}
						disableHolder={this.props.disableHolder}
						enableHolder={this.props.enableHolder}
						closeDBSettings={this.props.closeDBSettings}/>
				);
				break;
			case ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"):
				bodyContentContainer = (
					<DBSettingsSlideShowComponent jsonInfo={this.props.jsonInfo}
						showToolTips={this.props.showToolTips}
						hideToolTips={this.props.hideToolTips}
						rerenderComp={this.props.rerenderComp}
						disableHolder={this.props.disableHolder}
						enableHolder={this.props.enableHolder}
					/>
				);
				break;
		}	
		return (
			<div className="ZRDBSettingsMainHolder" ref="ZRDBSettingsMainHolder">
				{bodyContentContainer}
			</div>
		)
	}
});


var DBSettingsBodyContentOfGeneral = React.createClass({
	render : function(){
		var jsonInfo = this.props.jsonInfo;
		var date = new Date();
		var year = date.getFullYear();
		var curMonth = date.getUTCMonth();
		if((jsonInfo.STARTMONTH - 2) < curMonth){
			year += 1;
		}
		var disableForDBOwnerNotAdmin = (jsonInfo.ISDBOWNERNOTADMIN == "true")?false:true;
		var monthFiscalOptionI18n = ZDBI18NMap.m("zrpt.dialoginfo.monthinterval");
		var yearFiscalOptionsI18n = ZDBI18NMap.m("zrpt.dialoginfo.yearinterval");
		var monthFiscalOptions = [
								   {"value":"1", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.jan"]},
								   {"value":"2", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.feb"]},
								   {"value":"3", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.mar"]},
								   {"value":"4", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.apr"]},
								   {"value":"5", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.may"]},
								   {"value":"6", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.june"]},
								   {"value":"7", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.july"]},
								   {"value":"8", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.aug"]},
								   {"value":"9", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.sep"]},
								   {"value":"10", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.oct"]},
								   {"value":"11", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.nov"]},
								   {"value":"12", "i18nValue":monthFiscalOptionI18n["zrpt.dialoginfo.monthinterval.js.dec"]}
								  ];
		var yearFiscalOptions = [
									{"value":"1","i18nValue":year + " - " + yearFiscalOptionsI18n["zrpt.dialoginfo.yearinterval.js.curyear"]},
									{"value":"0","i18nValue":(year - 1) + " - " + yearFiscalOptionsI18n["zrpt.dialoginfo.yearinterval.js.previousyear"]},
									{"value":"2","i18nValue":"(" + (year - 1) + " - " + (year) +") - " + yearFiscalOptionsI18n["zrpt.dialoginfo.yearinterval.js.yearrange"]}
								];
                var weekYearFrmt = [
                                        { "value": "0", "i18nValue": ZDBI18NMap.g("zrpt.chartview.setting.js.wkyrshort") }, 
                                        { "value": "1", "i18nValue": ZDBI18NMap.g("zrpt.chartview.setting.js.wkyrmedium") }, 
                                        { "value": "2", "i18nValue": ZDBI18NMap.g("zrpt.chartview.setting.js.wkyrlong") }];
		
		var startMonth = jsonInfo.STARTMONTH;
                var curMonthText = "";
                monthFiscalOptions.forEach(function(month){
                    if(month.value == startMonth){
                        curMonthText = month.i18nValue;
                    }
                });
                var weekMode = [{ "value": '1', 'i18nValue': ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.weekmodeiso") }, { "value": "2", "i18nValue": ZDBI18NMap.f("zrpt.dbsettings.bodycontent.js.weeksrtjan",curMonthText) }];
		var startYear = jsonInfo.YEARFORMAT;
		var diableYearFormat = (startMonth == "1")?true:false;
		var showDefaultDB = (ZDBClientUI.isCustomDomain)?"none":"";
		var dbNameErr = ZDBI18NMap.f("zrpt.dialoginfo.copyrename.js.dbnameerr", jsonInfo.FIELDSIZECLASS.DBNAME);
		var dbDescErr = ZDBI18NMap.f("zrpt.dialoginfo.copyrename.js.descerr", jsonInfo.FIELDSIZECLASS.DBDESCRIPTION);
		var defaultNullValErr = ZDBI18NMap.f("zrpt.common.analysis.settings.js.nullValMaxLenExceedErr", jsonInfo.FIELDSIZECLASS.DEFAULTNULLVALUE);
		var defaultDB, showHiddenColsInReportCreation;
		if(jsonInfo.ISDEFAULTDB == "true"){
			defaultDB = (<div style={{height:'40px'}}><CustomRadio id="ZRDBSettingsDefaultDBYes" ref='makedefaultyes' type="text" onClick={this.props.handleDBPropChange} holderClassName="customRadio" className="customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.yes")} checked={true}/>
						<CustomRadio id="ZRDBSettingsDefaultDBNo" ref='makedefaultno' type="text" onClick={this.props.handleDBPropChange} holderClassName="customRadio" className="customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.no")} /></div>
			);
		}
		else{
			defaultDB = (<div style={{height:'40px'}}><CustomRadio id="ZRDBSettingsDefaultDBYes" ref='makedefaultyes' type="text" onClick={this.props.handleDBPropChange} holderClassName="customRadio" className="customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.yes")}/>
						<CustomRadio id="ZRDBSettingsDefaultDBNo"ref='makedefaultno' type="text" onClick={this.props.handleDBPropChange} holderClassName="customRadio" className="customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.no")} checked={true}/> </div>
			);
		}
		if (jsonInfo.SHOWHIDDENCOLSINREPORTCREATION == "true") {
                showHiddenColsInReportCreation = (<div style={{height:'40px'}}><CustomRadio id="ZRDBSettingsShowHiddenColumnsInReportCreationYes" ref='showhideyes' type="text" onClick={this.props.handleDBPropChange} holderClassName="customRadio" className="customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.yes")} checked={true}/>
				<CustomRadio id="ZRDBSettingsShowHiddenColumnsInReportCreationNo" ref='showhideno' type="text" onClick={this.props.handleDBPropChange} holderClassName="customRadio" className="customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.no")} /></div>
                );
        } else {
                showHiddenColsInReportCreation = (<div style={{height:'40px'}}><CustomRadio id="ZRDBSettingsShowHiddenColumnsInReportCreationYes" ref='showhideyes' type="text" onClick={this.props.handleDBPropChange} holderClassName="customRadio" className="customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.yes")} />
				<CustomRadio id="ZRDBSettingsShowHiddenColumnsInReportCreationNo" ref='showhideno' type="text" onClick={this.props.handleDBPropChange} holderClassName="customRadio" className="customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.no")} checked={true} /></div>
                );
        }
		return (
				<div id="ZRDBSettingsBodyContentDiv"> 
					<div id="ZRDBSettingsBodyContentInnerDiv">
						<TitleNDesc title={ZDBI18NMap.g("zrpt.dbsettings.js.generalheader")} desc={ZDBI18NMap.g("zrpt.dbsettings.js.generaldesc")} />
						<ul className="ZRDBPaddingTop15">
							<li>
								<label className="ZRDBSettingsGeneralSettingsLabel ZRMandatory">{ZDBI18NMap.g("zrpt.dialoginfo.copyrename.js.dbname")}*</label>
								<input style={{margin:'5px 0px'}} ref="ZRDBSetDBName" id="ZRDBSetDBName" data-inputtype="DBNAME" type="text" value={jsonInfo.DBNAME}
								data-zdbfieldlength={jsonInfo.FIELDSIZECLASS.DBNAME} onBlur={this.props.focusValidationDBName} 
									data-errormsg={dbNameErr} onChange={this.props.validateAndUpdateStateDBNameAndDesc} disabled={disableForDBOwnerNotAdmin}/>
							</li>
							<li style={{paddingBottom:'10px'}}>
								<label className="ZRDBSettingsGeneralSettingsLabel">{ZDBI18NMap.g("zrpt.dialoginfo.copyrename.js.desc")}</label>
								<textarea style={{margin:'5px 0px'}} ref="ZRDBSetDBDesc" data-inputtype="DBDESC" type="text" value={jsonInfo.DBDESC}  
								data-zdbfieldlength={jsonInfo.FIELDSIZECLASS.DBDESCRIPTION}
									data-errormsg={dbDescErr} onChange={this.props.validateAndUpdateStateDBNameAndDesc}  disabled={disableForDBOwnerNotAdmin}/>
							</li>
							<li style={{paddingBottom:'10px',display:showDefaultDB}}>
								<label className="ZRDBSettingsGeneralSettingsLabel">
								<span>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.makedbdefault")}</span>
								<div className="ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5" data-tip={ZDBI18NMap.f("zrpt.dbsettings.bodycontent.js.makedbdefaulthelp",ZDBGlobal.PRODUCTNAME)} 
								onMouseMove={this.props.showToolTips} onMouseOut={this.props.hideToolTips}></div>
								</label>
								{defaultDB}
							</li>
                            <li>
								<label className="ZRDBSettingsGeneralSettingsLabel ZRDBSettingShowHideColsOption">
								<span>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.showhiddencolsinreportcreation")}</span>
								<div className="ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5" data-tip={ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.showhiddencolsinreportcreationhelp")} 
								onMouseMove={this.props.showToolTips} onMouseOut={this.props.hideToolTips}></div>
								</label>
								{showHiddenColsInReportCreation}
							</li>
							<li>
								<div className="ZRDBSeparator"></div>
							</li>
							<li style={{display:"none"}}>
								<label className="ZRDBSettingsGeneralSettingsLabel">
								<span>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.defaultnullvalue")}</span>
								<div className="ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5" data-tip={ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.defaultnullvaluehelp")} 
								onMouseMove={this.props.showToolTips} onMouseOut={this.props.hideToolTips}></div>
								</label>
								<input style={{margin:'5px 0px'}} id="ZRDBSettingsDefaultNUllValue" data-zdbfieldlength={jsonInfo.FIELDSIZECLASS.DEFAULTNULLVALUE} type="text"
								 value={jsonInfo.DEFAULTNULLVALUE} onChange={this.props.validateDefaultNullValue} data-errormsg={defaultNullValErr}/>
							</li>
							
							<li>
								<label className="ZRDBSettingsGeneralSettingsLabel" style={{height:'80px',lineHeight:'72px'}}>
								<span>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.fiscalyear")}</span>
								<div className="ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5" data-tip={ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.fiscalyearhelp")} 
								onMouseMove={this.props.showToolTips} onMouseOut={this.props.hideToolTips}></div>
								</label>
								<div>
									<div className="fLeft">
									<label style={{fontSize:'11px',marginRight:'30px',cursor:'default'}}>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.startingmonth")}</label>
									{
										(<SelectComponent className="inlineSelect" ref='fiscalyearstartmonth' id="ZRDBSettingsStartMonth" optionValues={monthFiscalOptions} 
											onChange={this.props.handleDBPropChange} value={jsonInfo.STARTMONTH}/>)
									}
									</div>
									<div>
									<label style={{fontSize:'11px',cursor:'default'}}>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.fiscalyearend")}</label>
									{
										(<SelectComponent className="inlineSelect" ref='fiscalyearyearformat' id="ZRDBSettingsYearFormat" optionValues={yearFiscalOptions} 
											onChange={this.props.handleDBPropChange} value={jsonInfo.YEARFORMAT} disabled={diableYearFormat}/>)
									}
									</div>
								</div>
							</li>
							<li>
								<label className="ZRDBSettingsGeneralSettingsLabel" style={{height:'80px',lineHeight:'72px',clear:'both'}}>
								<span>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.weeksettings")}:</span>
								</label>
								<div>
									<div className="fLeft">
									<label style={{fontSize:'11px',marginRight:'30px',cursor:'default'}}>
										<span>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.weekstartday")}:</span>
										<div style={{height:'12px',lineHeight:'12px',width:'12px',display:'inline-block'}} className="ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5" data-tip={ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.weekstarthelp")} onMouseMove={this.props.showToolTips} onMouseOut={this.props.hideToolTips}></div>
									</label>
									{
										(<SelectComponent className="inlineSelect" ref='curweekstart' id="ZRDBSettingsWeekStart" optionValues={ZRBaseComponentsUtils.weekdays} 
										onChange={this.props.handleDBPropChange} value={jsonInfo.CURWEEKSTART}/>)
									}
									</div>
									<div className="fLeft" style={{marginRight:'20px'}}>
									<label style={{fontSize:'11px',cursor:'default'}}>
										<span>{ZDBI18NMap.g("zrpt.chartview.setting.js.weekyearfmt")}</span>
										<div style={{height:'12px',lineHeight:'12px',width:'12px',display:'inline-block'}} className="ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5" onMouseMove={this.props.showToolTips} onMouseOut={this.props.hideToolTips} data-tip={ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.weekyrfrmthelp")}></div>
									</label>
									{
										(<SelectComponent className="inlineSelect" ref='weekyearformat' id="ZRDBSettingsWeekYearFormat" optionValues={weekYearFrmt} 
											onChange={this.props.handleDBPropChange} value={jsonInfo.WEEKYEARFORMAT}/>)
									}
									</div>
									<div className="fLeft" style={{display:'block'}}>
									<label style={{fontSize:'11px',cursor:'default'}}>
										<span>{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.weekmode")}:</span>
										<div style={{height:'12px',lineHeight:'12px',width:'12px',display:'inline-block'}} className="ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5" onMouseMove={this.props.showToolTips} onMouseOut={this.props.hideToolTips} data-tip={ZDBI18NMap.f("zrpt.dbsettings.bodycontent.js.weekmodehelp", curMonthText)} data-noencode="true"></div>
									</label>
									{
										(<SelectComponent className="inlineSelect" ref='weekmode' id="ZRDBSettingsWeekMode" optionValues={weekMode} 
											onChange={this.props.handleDBPropChange} value={jsonInfo.WEEKMODE}/>)
									}
									</div>
								</div>
							</li>
							<li style={{paddingBottom:'10px',clear:'both'}}>
								<div className="ZRDBSeparator"></div>
							</li>
							
						</ul>
						<div style={{marginBottom:'80px',clear:'both'}}>
							<input ref="saveNClose" type="button" className="ZRDBMarginLeft5" onClick={this.props.saveNCloseDBSettings} value={ZDBI18NMap.g("zrpt.common.js.saveNclose")} />
							<input ref="save" type="button" className="ZRDBMarginLeft5" onClick={this.props.saveDBSettings} value={ZDBI18NMap.g("zrpt.dialoginfo.backup.js.save")} />
							<input ref="cancel" type="button" className="ZRDBMarginLeft5" onClick={this.props.closeDBSettings} value={ZDBI18NMap.g("zrpt.common.js.cancel")} />
						</div>
					</div>
				</div>
			)
	}
});

var DBSettingsBackupDlg = React.createClass({
	//creates pricing link when backup is not allowed.
	openPricing : function(event){
		if (ZDBGlobal.IS_ONPREMISE_BUILD) {
			zroptopbar.upgradePlan(event);
		}
		else
		{
			var href = window.location.href;
			var dbURL = ZDBGlobal.upgradeLink;
			window.open(dbURL,'_blank');
		}
	},
	//main render function for dbsettings backup dialog component
	render : function(){
		var jsonInfo = this.props.jsonInfo;
		var backupEnabled;
		if(jsonInfo.BACKUPENABLED){
			backupEnabled = (<div style={{height:'40px'}}>
				<CustomRadio id="ZRDBSettingsBackupYes" type="text" 
				onClick={this.props.handleBackupDBChange} holderClassName="customRadio" 
				className="iconbg customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.yes")} checked={true}/>
				<CustomRadio id="ZRDBSettingsBackupNo" type="text" onClick={this.props.handleBackupDBChange} 
				holderClassName="customRadio" className="iconbg customRadioBtn" 
				text={ZDBI18NMap.g("zrpt.common.js.no")} /></div>
			);
		}
		else{
			backupEnabled = (<div style={{height:'40px'}}>
				<CustomRadio id="ZRDBSettingsBackupYes" type="text" 
				onClick={this.props.handleBackupDBChange} holderClassName="customRadio" 
				className="iconbg customRadioBtn" text={ZDBI18NMap.g("zrpt.common.js.yes")}/>
				<CustomRadio id="ZRDBSettingsBackupNo" type="text" onClick={this.props.handleBackupDBChange} 
				holderClassName="customRadio" className="iconbg customRadioBtn" 
				text={ZDBI18NMap.g("zrpt.common.js.no")} checked={true}/> </div>
			);
		}
		var calendarFreq = "daily",calendarTime = -1,calendarDay = -1,calendarDate = -1, hrs=0, mins=0; 
		if(jsonInfo.SCHEDULEINFO){
			calendarFreq = jsonInfo.SCHEDULEINFO.CALENDAR_FREQ,
			calendarTime = jsonInfo.SCHEDULEINFO.CALENDAR_TIME,
			calendarDay = jsonInfo.SCHEDULEINFO.CALENDAR_DAY,
			calendarDate = jsonInfo.SCHEDULEINFO.CALENDAR_DATE;
			mins = calendarTime % 60;
			hrs = (calendarTime - mins) / 60;
		}
		var dispCalendarTime = (calendarTime == -1)?"none":"";
		var dispCalendarDay = (calendarDay == -1)?"none":"";
		var dispCalendarDate = (calendarDate == -1)?"none":"";
		var dispCalendarFreq = (jsonInfo.BACKUPENABLED)?"":"none";
		var bodyContent = null;
		if(!jsonInfo.ISDBOWNERNOTADMIN){
			bodyContent = (<div id="ZRDBSettingsBodyContentInnerDiv">
					<div style={{textDecoration:'none',cursor:'default'}} className="ZRDBWarnText ZRDBTextAlignCenter">
					{ZDBI18NMap.g("zrpt.dbsettings.bodycontent.js.backupnotallowedadmin")}
					</div></div>);
		}
		else if(jsonInfo.DONTSHOWBACKUP == "true"){
			bodyContent = (<div id="ZRDBSettingsBodyContentInnerDiv">
					<div className="ZRDBWarnText ZRDBTextAlignCenter" onClick={this.openPricing}>
					{ZDBI18NMap.f("zrpt.dbsettings.bodycontent.js.backupnotallowed", ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.backupsettings"))}
					</div>
				</div>)
		}
		else{
			bodyContent = (
				<div id="ZRDBSettingsBodyContentInnerDiv">
					<TitleNDesc title={ZDBI18NMap.g("zrpt.common.pricing.backup.js.bkp_setting")}  />
					<ul style={{marginTop:"-20px"}}>
						<li style={{paddingBottom:'15px'}}>
							<label className="ZRDBSettingsGeneralSettingsLabel">
								<span>{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.backupenabled")}</span>
							</label>
							{backupEnabled}
						</li>
						<li style={{display : dispCalendarFreq}}>
							<label className="ZRDBSettingsGeneralSettingsLabel">
								<span>{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.repeat")}</span>
							</label>
							{
								(<SelectComponent style={{marginTop:'6px'}} className="inlineSelect" id="BackupRepeat" 
							optionValues={ZRBaseComponentsUtils.repeatValues} onChange={this.props.handleBackupDBChange}
							disabled={!jsonInfo.BACKUPENABLED} value={calendarFreq}/>)
							}
						</li>
						<li style={{display : dispCalendarDay}}>
							<label className="ZRDBSettingsGeneralSettingsLabel">
								<span>{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.performevery")}</span>
							</label>
							{
								(<SelectComponent style={{marginTop:'6px'}} className="inlineSelect" id="BackupPerformEvery" value={calendarDay}
							optionValues={ZRBaseComponentsUtils.weekdays} disabled={!jsonInfo.BACKUPENABLED}
							 onChange={this.props.handleBackupDBChange}/>)
							}
						</li>
						<li style={{display : dispCalendarDate}}>
							<label className="ZRDBSettingsGeneralSettingsLabel">
								<span>{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.perform")}</span>
							</label>
							{
								(<SelectComponent style={{marginTop:'6px'}} className="inlineSelect" id="BackupDayOfMonth" optionValues={ZRBaseComponentsUtils.monthdays} 
							 disabled={!jsonInfo.BACKUPENABLED} value={calendarDate}  onChange={this.props.handleBackupDBChange}/>)
							}
							<span>&nbsp;{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.dayofeverymonth")}</span>
						</li>
						<li style={{display : dispCalendarTime}}>
							<label className="ZRDBSettingsGeneralSettingsLabel">
								<span>{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.time")}</span>
							</label>
							{
								(<SelectComponent style={{marginTop:'6px'}} className="inlineSelect" id="BackupHrs" optionValues={ZRBaseComponentsUtils.hrsArr}  
							disabled={!jsonInfo.BACKUPENABLED} value={hrs} onChange={this.props.handleBackupDBChange}/>)
							}
							<span className="ZRDBMarginRight15 ZRDBMarginLeft8">{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.hrs")}</span>
							{
								(<SelectComponent style={{marginTop:'6px'}} className="inlineSelect" id="BackupMins" optionValues={ZRBaseComponentsUtils.minsArr}  
							disabled={!jsonInfo.BACKUPENABLED} value={mins} onChange={this.props.handleBackupDBChange}/>)
							}
							<span className="ZRDBMarginLeft8">{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.min")}&nbsp;</span>
							<span className="font11">{ZDBI18NMap.f("zrop.dialoginfo.backup.js.usertimezone",ZDBGlobal.TimeZone)}</span>
						</li>
						<li>
							<label style={{lineHeight:'50px'}} className="ZRDBSettingsGeneralSettingsLabel">
								<span>{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.backuparchiveurl")}</span>
							</label>
							{(function(comp){
						  		if(jsonInfo.BACKUP_URL_LENGTH > 1){
						  			return(
						  					<BackupDBURLComponent className="ZRDBLinkText" style={{height:'40px',lineHeight:'17px',paddingTop:'15px'}} jsonInfo={comp.props.jsonInfo}/>
						  			);
						  		}
						  		else if(jsonInfo.BACKUP_URL_LENGTH == 1){
						  			return(
						  				<BackupDBURLComponent className="ZRDBLinkText" style={{height:'40px',lineHeight:'50px'}} jsonInfo={comp.props.jsonInfo}/>
						  			);
						  		}
						  		else{
						  			return(
						  					<div style={{height:'40px',lineHeight:'50px'}}>{ZDBI18NMap.g("zrpt.dialoginfo.backup.js.nobackupavailable")}</div>
						  			);
						  		}
						  	})(this)}
						</li>
						<li style={{paddingBottom:'10px'}}>
								<div className="ZRDBSeparator"></div>
						</li>
					</ul>
					<div className="ZRDBMarginBottom20">
							<input type="button" className="ZRDBMarginLeft5" onClick={this.props.sendBackupReqNClose} value={ZDBI18NMap.g("zrpt.common.js.saveNclose")} />
							<input type="button" className="ZRDBMarginLeft5" onClick={this.props.sendBackupReq} value={ZDBI18NMap.g("zrpt.dialoginfo.backup.js.save")} />
							<input type="button" className="ZRDBMarginLeft5" onClick={this.props.closeDBSettings} value={ZDBI18NMap.g("zrpt.common.js.cancel")} />
					</div>
				</div>
			)
		}
		return(
			<div id="ZRDBSettingsBodyContentDiv"> 
				{bodyContent}
			</div>
		)
	}
});
var ZRDBSettings = new function(){
	this.openedDlg = 0;
	this.isIE9 = (BROWSER.IE == 1 && BROWSER.VERSION.charAt(0) == "9")?true:false;
	this.jsonInfoMap = {};
	this.getDBInfo = function(element){
		var dbID = ZDBClientUI.dbId;
		var params = "DBID=" + dbID;
		var url = "/ZRDBSettingsInfoFetcher.ma";
//		var onSuccessFunc = (!isRefetch)?this.getDBSettingsComponent:this.updateDBSettings;
//		AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
//		                    ONSUCCESSFUNC:onSuccessFunc,
//		                    ONFAILUREFUNC:this.failurefunc,
//		                    OPSTATUSID:"ZDBMainLoader",
//		                    DBID:dbID,
//		                    El:element
//		                    });
                ZRSAjax.get('/reportsapi/DBSETTINGS', params, {
                    successHandler: {
                        func: this.getDBSettingsComponent,
                        ctx: this
                    },
                    failureHandler: {
                        func: this.failurefunc,
                        ctx: this
                    },
                    errorHandler: {
                        func: this.failurefunc,
                        ctx: this
                    },
                    DBID:dbID,
                    EL:element
                });
	}
	this.failurefunc = function(response,requestOptions){
		ZDBToolTip.hide();
		requestOptions['EL'].style.pointerEvents = 'auto';
		ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.js.commonfailure"));
	}
	this.getDBSettingsComponent = function(jsonInfo,requestOptions){
		requestOptions['EL'].style.pointerEvents = 'auto';
		ZDBToolTip.hide();
//		var jsonInfo = JSON.parse(response.responseText);
		ZDBClientUI.dbConfig.showHiddenColsInReportCreation = jsonInfo.SHOWHIDDENCOLSINREPORTCREATION == "true" ? true : false;
		jsonInfo.FIELDSIZECLASS = fieldSizeClass;
		var holder = ZRBaseComponentsUtils.getContainer("DBSettingsHolder", document.body);
		var factory = React.createFactory(DBSettingComponent);
		ZRDBSettings.dBSettingContainerRef = ReactDOM.render(factory({jsonInfo:jsonInfo,initialRender:sideNavComponentArr[0]}),holder);
		ZRDBSettings.showDBSettingsComponent(holder);
		//requestOptions.OPSTATUSID.style.display="none";
	}
	this.getSlideInfo = function(element, action){
//		AjaxAPI.sendRequest({URL:"/reportsapi/SLIDESINFO",
//		PARAMETERS:"DBID=" + ZDBClientUI.dbId,
//		ONSUCCESSFUNC:this.handleSlideInfoSuccess,
//		EL:element,
//		ONFAILUREFUNC:this.handleSlideInfoFailure,
//		ACTION: action,
//		OPSTATUSID:"ZDBMainLoader"});
                ZRSAjax.get('/reportsapi/SLIDESINFO', 'DBID=' + ZDBClientUI.dbId, {
                    successHandler: {
                        func: this.handleSlideInfoSuccess,
                        ctx: this
                    },
                    failureHandler: {
                        func: this.handleSlideInfoFailure,
                        ctx: this
                    },
                    errorHandler: {
                        func: this.handleSlideInfoFailure,
                        ctx: this
                    },
                    EL:element,
                    ACTION: action
                });
	}

	this.handleSlideInfoFailure = function(response, requestOptions){
		var errorNumCode = response.data.errorNumCode;
		if(errorNumCode === 6063){
                    ZDBMsgBox.showError(ZDBI18NMap.f("zrpt.dbsettings.bodycontent.js.backupnotallowed", ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow")));
		}
	}

	this.handleSlideInfoSuccess = function(jsonInfo, requestOptions){
		var action = requestOptions.ACTION;
		if(action === "CREATE"){
			jsonInfo.CREATEOREDITSLIDESHOW = true;
			jsonInfo.CREATEOREDITSLIDESHOWSTATE = {PRIVATELINK : false, SELECTEDVIEWS : [], editMode : false, editableSlide : null};
		}
		ZDBClientUI.selectTabEl(ZDBNavigation.explorerTab);
		try{
			var dbSettDlg = document.getElementById("DBSettingsHolder");
			if(dbSettDlg){
				ReactDOM.unmountComponentAtNode(dbSettDlg);
			}
			ZRDBSettings.closeDBSetting();
		}
		catch(e){
			//dbsettings not opened in explorer.
		}
		var holder = ZRBaseComponentsUtils.getContainer("DBSettingsHolder", document.body);
		var factory = React.createFactory(DBSettingComponent);
		ZRDBSettings.dBSettingContainerRef = ReactDOM.render(factory({jsonInfo:jsonInfo,initialRender:ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow")}),holder);
		ZRDBSettings.showDBSettingsComponent(holder);
	}

	this.closeDBSetting = function()
    {
        if(ZDBGlobal.ISNEWLAYOUT)
        {
            ZDBClientUI.removeTab(ZRDBSettings.DBSettingsTab);
            ZRDBSettings.DBSettingsTab = null;
        }
        else
        {
            ZDBInlineDialog.closeDialog();   
        }
    };
    this.showDBSettingsComponent = function(holder)
    {
        if(ZDBGlobal.ISNEWLAYOUT) {
            var tabName = ZDBI18NMap.g("zrpt.dbsettings.js.dlgtitle");
            var tab = ZDBClientUI.createDummyTab(tabName, tabName, holder, tabName, null, null, true);
            ZRDBSettings.DBSettingsTab = tab;
            ZDBClientUI.selectTab(tab, true);
	}
        else
        {
            ZDBInlineDialog.showDialog(holder, { MODAL: true, TITLE: ZDBI18NMap.g("zrpt.dbsettings.js.dlgtitle"), ISREACT: true });
        }
    };
}
//ignorei18n_end
