//$Id$

var ZRCRMPlus = new function () {

	this.optionActions = {};

	this.zrViewType = ["Table", "Tabular View", "Chart View", "Pivot View", "Summary View", "Chart View", "Query Table", "Dashboard", "Widget"];//No I18N

	this.landingPageObj = {"ZDBHome":"ZRCRMPlusHomePage", "ZDBDataSheetView":"ZRCRMPlusDataSheetViewPage", "ZDBPricing":"ZRCRMPlusSettingsPage", "ZDBSlideshow":"ZRCRMPlusSlideshowPage"}; //No I18N

	this.addRecord = function(type, viewobj)
	{//This method is done for RECENTITEMS Push to CRMPlus end. If any other need to push, modify the below definition accordingly.
		if(!CrmPlusImpl.isLoadedInCrmplus() || viewobj.objId < 0)
		{
			return;
		}
		var module = this.zrViewType[viewobj.typeValue];
		if(module === undefined)
		{
			var type = viewobj.type;
			for (var i in ZDBClientViewAPI.TYPES_VALUE_MAP) 
			{
				if(i == type)
				{
					module = this.zrViewType[ZDBClientViewAPI.TYPES_VALUE_MAP[i]];
					break;
				}
			}
		}
		var displayName = viewobj.displayName+"("+ZDBClientUI.dbName+")";
		var uri = "reports/ZDBDataSheetView.cc?DBID="+ZDBClientUI.dbId+"&OBJID="+viewobj.objId;//No I18N
		var recentItem = {"Type":"RecentItems", //No I18N
				"DisplayName":displayName, //No I18N
				"ClickAction":uri, //No I18N
				"Module":module };//No I18N
		// console.log(recentItem);
		CrmPlusLib.addRecord(recentItem);
	}
	
	this.pushChanges = function(changeType, key, value){
		if(!CrmPlusImpl.isLoadedInCrmplus()){
			return;
		}
		if(changeType == ZRCRMPlus.RENAMEDATABASE){
			CrmPlusImpl.trigger("updateField",["department",key,value]);//NO I18N
		} 
		else if(changeType == ZRCRMPlus.DELETEDATABASE){
			CrmPlusImpl.trigger("removeUIElement",["department",{"id" : key.toString()}]);//NO I18N
		} 
		else if(changeType == ZRCRMPlus.COPYDATABASE){
			var dbList = [];
			dbList.push(ZRCRMPlusDataSheetViewPage.constructAndGetDepartment(key, value, 1));
			ZRCRMPlusDataSheetViewPage.pushDepartmentList(dbList, true, false);
		}
	}
	
	this.showBadge = function(count){
		if(!CrmPlusImpl.isLoadedInCrmplus()){
			return;
		}
		CrmPlusImpl.trigger("setNotificationCount", ["general",count]);//NO I18N
	}

	this.onloadChanges = function(jsonChgCont, entityKey){
		if((typeof CrmPlusLib === "undefined") || ZRCRMPlus.UIReady){
			/*
			 * CRMPlus team said :
			 * Some case due to asynchronous in CRMPlus iframe UI, CrmPlusLib.isLoadedInCrmplusFrame value will be false for partial loading.
			 * So, checking CrmPlusLib object undefined is enough. CrmPlusLib object will be present for only CRMPlus user.
			 */
			return;
		}
		switch(ZDBGlobal.LANDINGPAGE){
		case "ZDBHome": //No I18N
			ZRCRMPlusHomePage.changeOnLoadActionCompletedStatus(jsonChgCont);
			ZRCRMPlusHomePage.invokeCRMPlusOnUIReady(entityKey);
			break;
		case "ZDBDataSheetView": //No I18N
			ZRCRMPlusDataSheetViewPage.changeOnLoadActionCompletedStatus(jsonChgCont);
			ZRCRMPlusDataSheetViewPage.invokeCRMPlusOnUIReady();
			break;
		case "ZDBPricing": //No I18N
			ZRCRMPlusSettingsPage.invokeCRMPlusOnUIReady();
			break;
		case "ErrorPage": //No I18N
			ZRErrorPage.invokeCRMPlusOnUIReady();
			break;
		}
	}

	this.selectModule = function(moduleKey){

		//Two types of module: 1. Onclick(crmplus-module-clickname) - do any sub action. 2. Just toggle the modules element.  
		var clickEls = document.querySelectorAll("[crmplus-module-clickname='"+moduleKey+"']");//No I18N
		if(clickEls.length > 0){
			var curEl = clickEls[0];
			var tagName = curEl.tagName.toLowerCase();
			if(tagName == "a"){
				var href = curEl.getAttribute('href');
				window.open(href, '_self');
			}
			else {
				ZRSHomepageListing.changeDBListHash(curEl);
			}
		} else {
			var hasValue=ZRCRMPlusHomePage.moduleKeyVsHashValue[moduleKey];
			ZRCRMPlus.selectHash(hasValue);
			if(hasValue == "CREATEDB"){
				ZRSHomeUtil.resizeHolders();
			}
		}
		var dbList = [];
		dbList.push(ZRCRMPlusDataSheetViewPage.constructAndGetDepartment("", ZDBI18NMap.g("zrpt.crmplus.js.selectdatabase"), 1));//No I18N
		ZRCRMPlusDataSheetViewPage.pushDepartmentList(dbList, false, true);//It is not working in CRMPlus end. So, can check and enable it later.
	}
	
	this.selectHash = function(hashValue){
		if(typeof CrmPlusLib === "undefined"){
			return;
		}
		
		var keyNames = document.querySelectorAll("[crmplus-module-display='show']");//No I18N
		for(var i=0,len=keyNames.length; i<len; i++){
			var curEl = keyNames[i];
			curEl.setAttribute('crmplus-module-display', 'hide');
		}
		
		var moduleKey=ZRCRMPlusHomePage.hashValueVsModuleKey[hashValue];
		var onloadHiddenKeyEls = document.querySelectorAll("[crmplus-module-keyname*='"+moduleKey+"']");//No I18N
		for(var i=0,len=onloadHiddenKeyEls.length; i<len; i++){
			var curEl = onloadHiddenKeyEls[i];
			curEl.setAttribute('crmplus-module-display', 'show');
		}

		if(hashValue == "CREATEDB"){
			window.location.hash="CREATEDB";//No I18N
			ZRSHomeUtil.resizeHolders();
		}
		CrmPlusImpl.trigger("selectEntity",["module",moduleKey]); //No I18N
	}
	
	this.getCurrentPortalAdminSOID = function(){
		if(!CrmPlusImpl.isLoadedInCrmplus()){
			return -1;
		}
		return CrmPlusLib.getServiceSOID("reports");
	}
	
	this.manageUser = function(){
		if(CrmPlusImpl.isLoadedInCrmplus()){
			CrmPlusLib.handleAction('adduser');
		}else{
			window.open(ZDBGlobal.zohoSuiteManageUsersLink, '_blank');
		}
	}

	this.setUIReady = function(){
		ZRCRMPlus.UIReady=true;
	}

};
ZRCRMPlus.UIReady = false;
ZRCRMPlus.RENAMEDATABASE = "RENAMEDATABASE";//NO I18N
ZRCRMPlus.DELETEDATABASE = "DELETEDATABASE";//NO I18N
ZRCRMPlus.COPYDATABASE = "COPYDATABASE";//NO I18N

var ZRCRMPlusHomePage = new function(){

	this.changeOnLoadActionCompletedStatus = function(jsonChgCont){
		var jsonObj = JSON.parse(ZRCRMPlusHomePage.onLoadActionsCompletedStatus);
		var jsonChgContObj = JSON.parse(jsonChgCont);
		for (var actionName in jsonChgContObj){
			jsonObj[actionName] = jsonChgContObj[actionName];
		}
		ZRCRMPlusHomePage.onLoadActionsCompletedStatus=JSON.stringify(jsonObj);
	};

	this.invokeCRMPlusOnUIReady = function(entityKey){
		if(entityKey)
		{//entityKey will be passed if which module should be select. If it not passed, already assigned entityKey will be selected as module.
			ZRCRMPlusHomePage.selectEntity = entityKey;
		}
		var jsonObj = JSON.parse(ZRCRMPlusHomePage.onLoadActionsCompletedStatus);
		for (var actionName in jsonObj){
			var value = jsonObj[actionName];
			if(!value){
				return;
			}
		}

		var hashValue=window.location.hash.replace("#","");
		var moduleName=ZRCRMPlusHomePage.hashValueVsModuleKey[hashValue];

		var hash="";
		for(var i = 0; i < ZRCRMPlusHomePage.hashValues.length; i++){
			hash = ZRCRMPlusHomePage.hashValues[i];
			if(hash == hashValue){
				ZRCRMPlus.selectHash(hashValue);
				break;
			}
		}
		if(hash != hashValue){
			CrmPlusImpl.trigger("selectEntity",["module",ZRCRMPlusHomePage.selectEntity]); //No I18N
		}
		CrmPlusImpl.trigger("UIReady"); //No I18N
	}

};

ZRCRMPlusHomePage.moduleNames = ["zrpt.home.mydb", "zrpt.home.shareddb", "zrpt.home.js.createreportdb"];//No I18N
ZRCRMPlusHomePage.hashValues = ["MYDBS", "SHARED", "CREATEDB"];//No I18N
ZRCRMPlusHomePage.hashValueVsModuleKey = {"MYDBS":"zrpt.home.mydb", "SHARED":"zrpt.home.shareddb", "CREATEDB":"zrpt.home.js.createreportdb"};//No I18N
ZRCRMPlusHomePage.moduleKeyVsHashValue = {"zrpt.home.mydb":"MYDBS", "zrpt.home.shareddb":"SHARED", "zrpt.home.js.createreportdb":"CREATEDB"};//No I18N
ZRCRMPlusHomePage.RECENTITEMS = "RECENTITEMS";//No I18N
ZRCRMPlusHomePage.onLoadActionsCompletedStatus = '{"IMPORTDBOPTS":false,"RECENTITEMS":false,"MYDBLIST":false,"SHAREDDBLIST":false}';//No I18N
ZRCRMPlusHomePage.selectEntity = '';

var ZRCRMPlusDataSheetViewPage = new function(){

	this.changeOnLoadActionCompletedStatus = function(jsonChgCont){
		var jsonObj = JSON.parse(ZRCRMPlusDataSheetViewPage.onLoadActionsCompletedStatus);
		var jsonChgContObj = JSON.parse(jsonChgCont);
		for (var actionName in jsonChgContObj){
			jsonObj[actionName] = jsonChgContObj[actionName];
		}
		ZRCRMPlusDataSheetViewPage.onLoadActionsCompletedStatus=JSON.stringify(jsonObj);
	};

	this.invokeCRMPlusOnUIReady = function(){
		var jsonObj = JSON.parse(ZRCRMPlusDataSheetViewPage.onLoadActionsCompletedStatus);
		for (var actionName in jsonObj){
			var value = jsonObj[actionName];
			if(!value){
				return;
			}
		}
		CrmPlusImpl.trigger("UIReady"); //No I18N
	}

	this.getAndShowDepartmentList = function(offset, range, searchText){
		if(ZRCRMPlusDataSheetViewPage.databaseList){
			ZRCRMPlusDataSheetViewPage.showDepartmentList(offset, range, searchText);
		}
		AjaxAPI.sendRequest({URL:"/ZDBListDatabases.ve?ZDBACTION=SHOWDATABASES",METHOD:"GET",
			ONSUCCESSFUNC:ZRCRMPlusDataSheetViewPage.handleDepartmentListResponse,OFFSET:offset,RANGE:range,SEARCHTEXT:searchText}); //No I18N
	}

	this.handleDepartmentListResponse = function(response, requestOptions){
		ZRCRMPlusDataSheetViewPage.databaseList = JSON.parse(response.responseText);
		var range = requestOptions["RANGE"];
		var offset = requestOptions["OFFSET"];
		var searchText = requestOptions["SEARCHTEXT"];
		ZRCRMPlusDataSheetViewPage.showDepartmentList(offset, range, searchText);
	}
	
	this.showDepartmentList = function(offset, range, searchText){
		var databaseList = ZRCRMPlusDataSheetViewPage.databaseList;
		var dbSize = databaseList.length;
		dbSize = dbSize > (offset + range) ? (offset + range) : dbSize;
		if(searchText){
			dbSize = databaseList.length;
			offset = 0;
		}
		var dbList = [];
		
		for(var i = offset; i < dbSize; i++){
			var dbId = databaseList[i][0];
			var dbName = databaseList[i][1];
			var dbTypeInt = databaseList[i][2];
			if(searchText){
				index = dbName.indexOf(searchText);
				if(index == -1){
					continue;
				}  
			}
			dbList.push(ZRCRMPlusDataSheetViewPage.constructAndGetDepartment(dbId, dbName, dbTypeInt));
		}
		ZRCRMPlusDataSheetViewPage.departmentList=ZRCRMPlusDataSheetViewPage.pushDepartmentList(dbList, false, false);
	}
	
	this.openDBInSameTab = function(dbIDToOpen){
		var databaseList = ZRCRMPlusDataSheetViewPage.databaseList;
		var dbSize = databaseList.length;
		for(var i = 0; i < dbSize; i++){
			var dbID = databaseList[i][0];
			var soid = databaseList[i][3];
			if(dbIDToOpen == dbID && soid == ZRCRMPlus.getCurrentPortalAdminSOID()){
				return true;
			}
		}
		return false;
	}
	
	this.pushDepartmentList = function(dbArrayList, isNewDB, canSetSelect){
		var list = {};
		var department = [];
		
		list["list"] = dbArrayList;
		list["isnewdepartment"] =  isNewDB;
		list["cansetselected"] = canSetSelect;
		department.push("department");
		department.push(list);
		// console.log(JSON.stringify(department));
		CrmPlusImpl.trigger("modifyUI", department);//NO I18N
		return department;
	}
	
	this.constructAndGetDepartment = function(dbId, dbName, dbTypeInt){
		var item = {};
			item["key"] = dbId.toString();
			item["label"] = dbName;
			if(dbTypeInt == 2){
				item["group_name"] = "Shared";
			}
			return item;
	}
	
	this.getDepartment = function(departmentKey){
		var list=ZRCRMPlusDataSheetViewPage.departmentList[1]["list"];
		for(var i = 0; i < list.length; i++){
			var department = list[i];
			if(department["key"] == departmentKey){
				return department;
			}
		}
	}
};
ZRCRMPlusDataSheetViewPage.onLoadActionsCompletedStatus = '{"VIEWLIST":false}';//No I18N
ZRCRMPlusDataSheetViewPage.selectEntity = '';
ZRCRMPlusDataSheetViewPage.databaseList = "";
ZRCRMPlusDataSheetViewPage.departmentList = "";

var ZRCRMPlusSettingsPage = new function(){
	this.invokeCRMPlusOnUIReady = function(){
		CrmPlusImpl.trigger("UIReady"); //No I18N
	}
};

var ZRErrorPage = new function(){
	this.invokeCRMPlusOnUIReady = function(){
		CrmPlusImpl.trigger("UIReady"); //No I18N
	}
};
