//$Id$
var ZRCustomGeocoder = new function()
{
    this.fetchReqGeoDetFromTable = function(tblObjId,colId,geoRole,focusDlg,view,onSuccessFun,ev)
    {
        jQuery(focusDlg.bodyContent).addClass("georole"+geoRole);
        focusDlg.bodyContent.geoSettingdesc.innerHTML = geoRole>1 ? ZDBI18NMap.f("zrpt.table.geocoding.js.parentColsDesc") : ZDBI18NMap.f("zrpt.table.geocoding.js.parentColsDescCountry");
        var params = "&OBJID="+view.objId+"&PARENTVIEWID="+ tblObjId+"&COLID="+ colId+"&GEOROLE="+geoRole; //NO I18N
        var xml = "";
        if(view.typeValue === ZDBClientViewAPI.TYPE_ANALYSISVIEW)
        {
            xml =ZDBAnalysisConfig.getCurrentConfig(view,true);
            params+="&XMLBODY="+encodeURIComponent(xml); //NO I18N
        }
        var url = ZDBGlobal.CTX + "/ZDBCustomGeocodingAction.ma?ZDBACTION=FETCHGEOHRCHYDET"; //NO I18N
        AjaxAPI.sendRequest({
          URL: url,
          COLID: colId,
          EVENT: ev,
          GEOROLE: geoRole,
          PARAMETERS:params,
          OPSTATUSID:focusDlg.bodyContent.loadingEl,
          ONSUCCESSFUNC:onSuccessFun
          });
    }
    this.handleGeoDetResp = function(response,requestOptions)
    {
        var focusDlg = ZDBDialogUtil.focusDialog;
        if(!focusDlg)
        {
            return;
        }
        var geoSettingsDlg = focusDlg.bodyContent;
        ZDBUtil.setNamedChildEls(geoSettingsDlg,geoSettingsDlg);
        var respJSON = JSON.parse(response.responseText);
        ZRCustomGeocoder.updateCustomGeoDettoDlg(geoSettingsDlg,respJSON);
        
    }
    this.updateCustomGeoDettoDlg = function(geoSettingsDlg,customGeoDetJson)
    {
        geoSettingsDlg.geoColsDet = customGeoDetJson.GEOCOLSLIST;
        geoSettingsDlg.unknownLocDet = customGeoDetJson.UNKNOWNLOCDET;
        geoSettingsDlg.geoHrchyDet = customGeoDetJson.GEOHRCHYDET;
        ZRCustomGeocoder.updateGeoHrchyDetInDlg(geoSettingsDlg);
        geoSettingsDlg.geoOptsEl = ZRCustomGeocoder.constructGeocolsList(geoSettingsDlg.geoColsDet);
//        jQuery(geoSettingsDlg).addClass()
        ZRCustomGeocoder.appendCustomLocDetInDlg(geoSettingsDlg,geoSettingsDlg.unknownLocDet);
        ZRCustomGeocoder.updateUnknownLocDetInDlg();
        ZRCustomGeocoder.updateInvalidParLocStatus(geoSettingsDlg,customGeoDetJson.UNKNOWNLOCDET.INVALIDCUSTOMLOCS);
    }
    this.handleGeoHrchyColsResp = function(response,requestOptions)
    {
        var respJSON = JSON.parse(response.responseText);
        var geoSettingsDlg = requestOptions["CUSTOMGEODLG"];
        var ev = requestOptions["EVENT"];
        geoSettingsDlg.geoColsDet = respJSON.GEOCOLSLIST;
        geoSettingsDlg.geoOptsEl= ZRCustomGeocoder.constructGeocolsList(geoSettingsDlg.geoColsDet);
        var el = requestOptions["SELECTOREL"];
        ZRCustomGeocoder.showGeoHrchyColListByRole(el,geoSettingsDlg.geoOptsEl,ev);
        ZRCustomGeocoder.updateInvalidParLocStatus(geoSettingsDlg,respJSON.UNKNOWNLOCDET.INVALIDCUSTOMLOCS);
    }
    this.showGeoHrchyColList = function(el,ev)
    {
        var geoSettingsDlg = ZDBDialogUtil.focusDialog.bodyContent;
        var view = ZDBClientUI.ZDBViewEl.view;
        if(geoSettingsDlg.geoColsDet)
        {
            this.showGeoHrchyColListByRole(el,geoSettingsDlg.geoOptsEl,ev);
            return;
        }
        ZRCustomGeocoder.fetchReqGeoDetFromTable(view.objId,ZDBDialogUtil.focusDialog.params.GEOCOLID,ZDBDialogUtil.focusDialog.params.GEOROLE,el,geoSettingsDlg,ZRCustomGeocoder.handleGeoHrchyColsResp);
    }
    
    this.updateInvalidParLocStatus = function(geoSettingsDlg,invalidLocDet)
    {
        var compEls= DOMUtils.getChildElsWithAttr(geoSettingsDlg,"elname","compElContainer");//NO I18N
        for(var i=0 ; i< compEls.length;i++)
        {
            var compEl = compEls[i];
            if(invalidLocDet.indexOf(compEl.getAttribute("georole"))>-1)
            {
                jQuery(compEl.wronglocStatus).addClass("wrongloc");
            }
            else
            {
                jQuery(compEl.wronglocStatus).removeClass("wrongloc");
            }
        }
    }
    
    this.showGeoHrchyColListByRole = function(el,comboList,event)
    {
        var jcomboList = jQuery(comboList);
        var compElContainer = DOMUtils.getSelfOrParentWithAttrValue(el,"elname","compElContainer"); //NO I18N
        if(jcomboList.is(":visible"))
        {
            ZAComboList.closeListWithAnimation(el);
            return;
        }
        compElContainer.appendChild(comboList);
        ZRCustomGeocoder.setOptLstHgtNWidth(comboList,compElContainer);
        comboList.compElContainer = compElContainer;
        var geoRole = compElContainer.getAttribute("georole");
        var liEls = jcomboList.find("li[optionel='true']").hide().filter("[georole="+geoRole+"]").show();//NO I18N
        this.tickSelectedGeoCol(liEls,jcomboList,compElContainer);
        MenuUtil.slideDown(jcomboList,250,function(){
        },!ZDBGlobal.isQAEnabled);
        ZAComboList.curList = comboList;
        ZDBUtil.attachEvent(document,'keydown',ZAComboList.checkKeyNContinue,false);
        ZDBUtil.attachEvent(document,(ZDBGlobal.IS_MOBILE) ? 'touchstart' :'click',ZAComboList.closeListWithAnimation,false);
        ZDBUtil.stopEventBubble(event);
        
    }
    
    this.setOptLstHgtNWidth = function(optList,compElContainer)
    {
        var focusDlg = ZDBDialogUtil.focusDialog;
        if(!focusDlg)
        {
            return;
        }
        ZDBUtil.setNamedChildEls(optList,optList);
        var optLstHgt = focusDlg.offsetHeight*0.6;
        var optListWdth = focusDlg.offsetWidth-160;
        var filterHead = DOMUtils.getFirstMatchingChild(compElContainer,"*","filterhead","true");
        var actListWdth = filterHead.offsetWidth;
        optList.optionListEL.style.display = "";
        optList.style.minWidth = actListWdth+"px"; //NO I18N
        optList.style.maxHeight= optLstHgt+"px";//NO I18N
        optList.style.maxWidth = optListWdth+"px";//NO I18N
        
    }
    
    this.updateUnknownLocDetInDlg = function()
    {
        var focusDlg = ZDBDialogUtil.focusDialog;
        if(!focusDlg)
        {
            return;
        }
        var geoSettingsDlg = focusDlg.bodyContent;
        var unknownLocCnt = geoSettingsDlg.unknownLocDet.UNKNOWNLIST.length;
        var resolvedLocCnt = Object.keys(geoSettingsDlg.unknownLocDet.RESOLVEDLIST).length
        var noUnresolveLoc = unknownLocCnt<1 && resolvedLocCnt<1;
        var title = ZDBI18NMap.f("zrpt.table.geosetting.js.dlgtitlecount",unknownLocCnt);
        focusDlg.dlgTitle.innerHTML = title;
        if(noUnresolveLoc)
        {
            focusDlg.bodyContent.geoSettingdesc.innerHTML= ZDBI18NMap.f("zrpt.table.geosetting.js.nounknownloc");
        }
        geoSettingsDlg.unknownLocCount.innerHTML=unknownLocCnt;
        geoSettingsDlg.locResolveContainer.style.display =  noUnresolveLoc? "none" : "";
        var solvedIssuesCount = geoSettingsDlg.unknownLocCnt-unknownLocCnt;
        geoSettingsDlg.unknownLocCnt = unknownLocCnt;
        this.showResolvedIssuesBanner(solvedIssuesCount,geoSettingsDlg);
    }
    
    this.showResolvedIssuesBanner = function(solvedIssuesCount,geoSettingsDlg)
    {
        if(!solvedIssuesCount || solvedIssuesCount<1)
        {
            jQuery(geoSettingsDlg.resolvedLocEl).hide();
            return;
        }
        geoSettingsDlg.locResolvedcountEl.innerHTML = solvedIssuesCount;
        MenuUtil.slideDown(jQuery(geoSettingsDlg.resolvedLocEl),250, function() {
                            jQuery(geoSettingsDlg.resolvedLocEl).delay(3000).slideUp();
                         },!ZDBGlobal.isQAEnabled);
    }
    
    this.updateGeoHrchyDetInDlg = function(geoSettingsDlg)
    {
        var geoHrchyDet = geoSettingsDlg.geoHrchyDet;
//        var geoHrchyDet = hrchyDet.split("$$$");
        var countryDet = geoHrchyDet[ZDBUtil.geoNameVsRole.COUNTRY];
        var stateDet = geoHrchyDet[ZDBUtil.geoNameVsRole.STATEPROVINCE];
        var compEls= DOMUtils.getChildElsWithAttr(geoSettingsDlg,"elname","compElContainer");//NO I18N
        ZRCustomGeocoder.updateHrchyDetByGeoroleInDlg(geoSettingsDlg,"1",countryDet,DOMUtils.getFirstMatchingElement(compEls,null,"georole","1"));
        ZRCustomGeocoder.updateHrchyDetByGeoroleInDlg(geoSettingsDlg,"2",stateDet,DOMUtils.getFirstMatchingElement(compEls,null,"georole","2"));        
    }
    
   this.updateHrchyDetByGeoroleInDlg = function(geoSettingsDlg,geoRole,geoHrchy,compEl)
   {
       if(jQuery.isEmptyObject(geoHrchy))
       {
           return;
       }
        var geoColsList = geoSettingsDlg.geoColsDet;
        var colsList = geoColsList[geoRole];
        
        ZDBUtil.setNamedChildEls(compEl,compEl);
//        var geoHrchyDet = geoHrchy.split("_");
        var colid = geoHrchy["COLUMNID"];
        var locName = geoHrchy["PAR_LOC_NAME"];
        var dispVal;
        if(colid)
        {
            var colDet; 
            for(var i in colsList)
            {
                if(colsList[i].COLUMNID==colid)
                {
                    colDet = colsList[i];
                    break;
                }
            }
            if(colDet)
            {
                compEl.customParLocHolder.style.display = "none";
                compEl.customParentLocEl.value = "";
                compEl.setAttribute("COLUMNID",colDet["COLUMNID"]);
                compEl.setAttribute("PARENTOBJID",colDet["PARENTOBJID"]);
                compEl.setAttribute("COLDISPLAYNAME",colDet["COLDISPLAYNAME"]);
                compEl.setAttribute("DISPLAYNAME",colDet["DISPLAYNAME"]);
                dispVal = colDet["DISPLAYNAME"];   
            }
            compEl.removeAttribute("isCustomOpt");
        }
        else if(locName)
        {
            compEl.customParentLocEl.value = ZDBEscapeUtil.encodeForHtml(locName);
            compEl.customParentLocEl.innerHTML = ZDBEscapeUtil.encodeForHtml(locName);
            compEl.customParentLocEl.setAttribute("CUSTOMVALUE",locName);
            compEl.setAttribute("PAR_LOC_NAME",locName);
            compEl.customParLocHolder.style.display="";
            compEl.setAttribute("isCustomOpt","true");
            dispVal = ZDBI18NMap.g('zrpt.common.js.customlocation');
        }
        if(dispVal)
        {
            var dispEl = compEl.displaySelected;
            dispEl.innerHTML = ZDBEscapeUtil.encodeForHtml(dispVal);
            dispEl.setAttribute("value",ZDBEscapeUtil.encodeForHtmlDispChar(dispVal));
            dispEl.setAttribute("tip", ZDBEscapeUtil.encodeForHtmlDispChar(dispVal));
        }
   }
    
    this.constructGeocolsList= function(geoDet)
    {
        var geoHrchyList= ZRCustomGeocodeUtil.getGeoHrchyListTpl();
        ZRCustomGeocoder.appendDefListElements(geoHrchyList);
        ZRCustomGeocoder.appendGeoColListElements(geoHrchyList,geoDet);
        geoHrchyList.setAttribute("onclick","ZRCustomGeocoder.selectOptionListEl(this,event);");
        return geoHrchyList;
    }
    this.appendDefListElements= function(parEl)
    {
        var clearOpt = ZRCustomGeocodeUtil.getClearOptionElTpl();
//        clearOpt.setAttribute("onclick","ZRCustomGeocoder.clearGeoHrchySelectedOpt(this,ev);");
        clearOpt.setAttribute("funVal","clearGeoHrchySelectedOpt");
        clearOpt.setAttribute("listel","true");
        parEl.appendChild(clearOpt);
        parEl.appendChild(ZRCustomGeocodeUtil.getListSeparatorTpl());
        var customOpt = ZRCustomGeocodeUtil.getCustomInputElTpl();
        customOpt.setAttribute("listel","true");
        customOpt.setAttribute("funVal","resetNselectCustomHrchyOpt");
        parEl.appendChild(customOpt);
        parEl.appendChild(ZRCustomGeocodeUtil.getListSeparatorTpl());
    }
    this.appendGeoColListElements= function(parEl,geoDet)
    {
        var listGrpHdr = ZRCustomGeocodeUtil.getListGroupheaderTpl();
        listGrpHdr.setAttribute("listel","true");
        parEl.appendChild(listGrpHdr);
        var ul = ZRCustomGeocodeUtil.getOptionListElTpl();
//        ul.setAttribute("onclick","ZRCustomGeocoder.updateSelectedOption(this,ev)");
        ul.setAttribute("funVal","updateSelectedOption");
        for(var role in geoDet)
        {
            var geoDetByRole = geoDet[role];
            for (var i = 0; i < geoDetByRole.length; i++)
            {
                var colDet = geoDetByRole[i]
                var li = ZRCustomGeocodeUtil.getOptionElTpl();
                ZDBUtil.setNamedChildEls(li,li);
                for (var key in colDet)
                {
                    li.setAttribute(key,colDet[key]);
                }
                li.setAttribute("georole",role);
                li.setAttribute("listel","true");
//                li.setAttribute("COLDISPLAYNAME",colDet["COLDISPLAYNAME"]);
//                li.setAttribute("DISPLAYNAME",colDet["DISPLAYNAME"]);
//                li.innerHTML = colDet["DISPLAYNAME"];
                jQuery(li).addClass(colDet["ISMULTITBL"]==true ? "multiTblList" : "singleTblList");
                li.colName.innerHTML = ZDBEscapeUtil.encodeForHtml(colDet["COLDISPLAYNAME"]);
                li.colName.setAttribute("tip",ZDBEscapeUtil.encodeForHtmlDispChar(colDet["COLDISPLAYNAME"]));
                li.tblName.innerHTML = ZDBEscapeUtil.encodeForHtml(colDet["TBLDISPLAYNAME"]);
                li.tblName.setAttribute("tip",ZDBEscapeUtil.encodeForHtmlDispChar(colDet["TBLDISPLAYNAME"]));
                ul.appendChild(li);
            }
        }
        listGrpHdr.appendChild(ul);
    }
    
    this.tickSelectedGeoCol = function(colElsLst,jcomboList,compElContainer)
    {
        var cid = compElContainer.getAttribute("COLUMNID");
//        var colName = compElContainer.getAttribute("COLUMNNAME");
        var iscustomCol = compElContainer.getAttribute("isCustomOpt")=="true";
        jcomboList.find("[optionel='true'],[customEl='true'],[noneEl='true']").removeClass("optionlistElSelected");
        var lstGrpHdr = jcomboList.find("[elname=listGroupheader]");
        lstGrpHdr.removeClass("ListExpand");
        if(iscustomCol)
        {
            jcomboList.find("[customEl='true']").addClass("optionlistElSelected");
        }
        else if(!cid || cid==null||cid=="")
        {
            jcomboList.find("[noneEl='true']").addClass("optionlistElSelected");
        }
        else
        {
            lstGrpHdr.addClass("ListExpand");
            colElsLst.filter("[COLUMNID="+cid+"]").addClass("optionlistElSelected");//NO I18N
        }
        if(colElsLst.length <1)
        {
            lstGrpHdr.hide();
        }
        else
        {
            lstGrpHdr.show();
        }
    }
    
    this.selectCustomHrchyOpt= function(el,ev)
    {
//        var srcEl = ZDBUtil.getSourceElement(ev);
        var compElContainer = DOMUtils.getSelfOrParentWithAttrValue(el,"elname","compElContainer");//NO I18N
        compElContainer.customParLocHolder.style.display = "";
        compElContainer.customParentLocEl.value = "";
        compElContainer.setAttribute("isCustomOpt","true");
        compElContainer.customParentLocEl.focus();
    }
    
    this.selectOptionListEl= function(el,ev)
    {
        var srcEl = ZDBUtil.getSourceElement(ev);
        var listEL = DOMUtils.getSelfOrParentWithAttr(srcEl,"funVal");//NO I18N
        if(listEL==null)
        {
            ZDBUtil.stopEventBubble(ev);
            return;
        }
        var func = listEL.getAttribute("funVal");
        ZRCustomGeocoder[func](listEL,ev);
    }
    this.clearGeoHrchySelectedOpt= function(el,ev)
    {
        var srcEl = ZDBUtil.getSourceElement(ev);
        var compElContainer = DOMUtils.getSelfOrParentWithAttrValue(srcEl,"elname","compElContainer");//NO I18N
        if(!ZRCustomGeocoder.isoptionChanged(srcEl,compElContainer))
        {
            return;
        }
        ZRCustomGeocoder.resetHrchyDet(el,ev);
        compElContainer.removeAttribute("isCustomOpt");
        compElContainer.customParLocHolder.style.display = "none";
        compElContainer.customParentLocEl.value = "";
        ZRCustomGeocoder.fetchUnknownLocationDet();
    }
    this.resetNselectCustomHrchyOpt= function(el,ev)
    {
//        ZRCustomParLocSearch.fetchSuggestList(el,ev);
        ZRCustomGeocoder.resetHrchyDet(el,ev);
        ZRCustomGeocoder.selectCustomHrchyOpt(el,ev);
    }
    this.resetHrchyDet= function(el,ev)
    {
//        var srcEl = ZDBUtil.getSourceElement(ev);
//        var optEl = DOMUtils.getSelfOrParentWithTagName(srcEl,"div");//NO I18N
        var compElContainer = DOMUtils.getSelfOrParentWithAttrValue(el,"elname","compElContainer");//NO I18N
        ZDBUtil.setNamedChildEls(compElContainer,compElContainer);
        compElContainer.removeAttribute("COLUMNID");
        compElContainer.removeAttribute("PARENTOBJID");
        compElContainer.removeAttribute("COLDISPLAYNAME");
        compElContainer.removeAttribute("DISPLAYNAME");
        compElContainer.removeAttribute("PAR_LOC_NAME");
        var colName = el.getAttribute("DISPLAYNAME");
        var dispEl = compElContainer.displaySelected;
        dispEl.innerHTML = ZDBEscapeUtil.encodeForHtml(colName);
        dispEl.setAttribute("value",ZDBEscapeUtil.encodeForHtmlDispChar(colName));
        dispEl.setAttribute("tip", ZDBEscapeUtil.encodeForHtmlDispChar(colName));
    }

    this.updateColDetToCompEl= function(compElContainer,selectedLi)
    {
        compElContainer.setAttribute("COLUMNID",selectedLi.getAttribute("COLUMNID"))
        compElContainer.setAttribute("PARENTOBJID",selectedLi.getAttribute("PARENTOBJID"))
        compElContainer.setAttribute("COLDISPLAYNAME",selectedLi.getAttribute("COLDISPLAYNAME"));
        compElContainer.setAttribute("DISPLAYNAME",selectedLi.getAttribute("DISPLAYNAME"));
        var colName = selectedLi.getAttribute("DISPLAYNAME");
        var dispEl = compElContainer.displaySelected;
        dispEl.innerHTML = ZDBEscapeUtil.encodeForHtml(colName);
        dispEl.setAttribute("value",ZDBEscapeUtil.encodeForHtmlDispChar(colName));
        dispEl.setAttribute("tip", ZDBEscapeUtil.encodeForHtmlDispChar(colName));
        
    }
    
    this.customValueChanged= function(srcEl)
    {
        var prevVal = srcEl.getAttribute("CUSTOMVALUE");
        prevVal = prevVal ? prevVal : "";
        var curVal = srcEl.value;
        return prevVal!=curVal;
    }
    this.isValidCustomName= function(el,ev)
    {
        return true;
    }
    this.updateSelectedCustomOption= function(el,ev)
    {
        var compElContainer = DOMUtils.getParentWithAttrValue(el,"elname","compElContainer");//NO I18N
        if(!this.customValueChanged(el))
        {
            return;
        }
//        if(!this.isValidCustomName())
//        {
//         return;   
//        }
        ZDBUtil.setNamedChildEls(compElContainer,compElContainer);
        el.setAttribute("CUSTOMVALUE",el.value);
        compElContainer.setAttribute("PAR_LOC_NAME",el.value);
//        compElContainer.customParentLocEl.style.display="none";
        ZRCustomGeocoder.fetchUnknownLocationDet();
    }
    this.updateSelectedOption= function(el,ev)
    {
        var srcEl = ZDBUtil.getSourceElement(ev);
        var li = DOMUtils.getSelfOrParentWithTagName(srcEl,"li");//NO I18N
        var compElContainer = DOMUtils.getParentWithAttrValue(el,"elname","compElContainer");//NO I18N
        if(!ZRCustomGeocoder.isoptionChanged(li,compElContainer))
        {
            return;
        }
        compElContainer.removeAttribute("isCustomOpt");
        ZDBUtil.setNamedChildEls(compElContainer,compElContainer);
        compElContainer.customParentLocEl.value = "";
        ZRCustomGeocoder.updateColDetToCompEl(compElContainer,li);
        compElContainer.customParLocHolder.style.display="none";
        ZRCustomGeocoder.fetchUnknownLocationDet();
    }
    this.submitCustomGeoSettings= function(el,ev)
    {
        var focusDlg = ZDBDialogUtil.focusDialog;
        if(!focusDlg)
        {
            return;
        }
        var geoSettingsDlg = focusDlg.bodyContent;
        var invalidLocs = geoSettingsDlg.unknownLocDet.INVALIDCUSTOMLOCS;
        // if(invalidLocs.length>0)
        // {
        //     var compEls= DOMUtils.getChildElsWithAttr(geoSettingsDlg,"elname","compElContainer");//NO I18N
        //     showCustomMessage(ZDBI18NMap.g("zrpt.table.geocoding.js.invalidcustomparent"), DOMUtils.getFirstMatchingElement(compEls,null,"georole",invalidLocs[0]).customParentLocEl); //NO I18N
        //     return;
        // }
        var hrchyDet = this.getGeoHrchyDetAsJSON(focusDlg);
        var colId = focusDlg.params.GEOCOLID;
        var geoRole = focusDlg.params.GEOROLE;
        var tblObjId = focusDlg.params.TBLOBJID;
        var params="&PARENTVIEWID="+ tblObjId+"&COLID="+colId+"&GEOROLE="+geoRole;//NO I18N
        if(hrchyDet)
        {
            params+="&HRCHYDET="+encodeURIComponent(JSON.stringify(hrchyDet));//NO I18N
        }
        var customLocDet = this.getcustomLocDetAsJSON(focusDlg);
        if(customLocDet==false)
        {
            return;
        }
        else if(customLocDet!=null)
        {
            params+="&CUSTOMLOC="+customLocDet;//NO I18N
        }
        
        var url = ZDBGlobal.CTX + "/ZDBCustomGeocodingAction.ma?ZDBACTION=UPDATECUSTOMGEODET"; //NO I18N
        var ajaxOptions = {
            URL:url,
            PARAMETERS:params,
            HRCHYDET:hrchyDet,
            FOCUSDLG:focusDlg,
            ONSUCCESSFUNC:ZRCustomGeocoder.handleGeoSettingsUpdate 
          };
        AjaxAPI.sendRequest(ajaxOptions);  
    }
    this.cancelGeocodingDlg= function(el,ev)
    {
        ZDBDialogUtil.closeDialog();
    }
    
    this.handleGeoSettingsUpdate = function(response,requestOptions)
    {
        ZDBDialogUtil.closeDialog();
        ZDBMsgBox.showSuccess(response.responseText);
        var focusDlg = requestOptions["FOCUSDLG"];
//        if(focusDlg.bodyContent.colObj)
//        {
//            var hrchyDet = requestOptions["HRCHYDET"];
////            focusDlg.bodyContent.colObj.geoHrchyDet=hrchyDet;
//        }
        if(focusDlg.view.type=="AnalysisView")
        {
            focusDlg.view.refreshView();
        }
    }
    
    this.getcustomLocDetAsJSON=function(focusDlg)
    {
        var customizedLocs = new Object();
        var junknownTbl = jQuery(focusDlg.bodyContent.unknownListTbl);
        if(junknownTbl.find("[isInvalid='true']").length>0)
        {
            return false;
        }
        var unknownLocEls = junknownTbl.find("[elname='unknownLocEl'][valChanged='true']");
        unknownLocEls.each(function(){
            var lat = this.latitudeEl.value;
            var lng = this.longitudeEl.value;
            customizedLocs[this.getAttribute("locationName")]=(lat||lng) ? [lat,lng] : [];
        });
        return Object.keys(customizedLocs).length>0? JSON.stringify(customizedLocs) : null;
    }
    this.getGeoHrchyDetAsJSON=function(geoSettingsDlg)
    {
        var compEls = DOMUtils.getChildElsWithAttr(geoSettingsDlg,"elname","compElContainer");//NO I18N
        var geoHrchyDet = {};
        for(var i=0;i<compEls.length;i++)
        {
            var compEl = compEls[i];
            var role = compEl.getAttribute("georole");
            ZDBUtil.setNamedChildEls(compEl,compEl);
            var colId = compEl.getAttribute("COLUMNID");
            var colName = compEl.getAttribute("PAR_LOC_NAME");
            var colDet ={};
            if(colId && colId!="" && colId!="null")
            {
                colDet["COLUMNID"]=colId;
                colDet["PARENTOBJID"]=compEl.getAttribute("PARENTOBJID");//NO I18N
            }
            else if(colName && colName!="")
            {
             colDet["PAR_LOC_NAME"]=colName;
            }
            if(Object.keys(colDet).length >0)
            {
                geoHrchyDet[role]=colDet;
            }
        }
        return Object.keys(geoHrchyDet).length>0 ? geoHrchyDet : null;
    }
    this.showHideUnknownLocList=function ()
    {
        var geoSettingsDlg = ZDBDialogUtil.focusDialog.bodyContent;
//        var jEl = jQuery(geoSettingsDlg.locResolveContainer);
        var hrchyDet = ZRCustomGeocoder.getGeoHrchyDetAsJSON(geoSettingsDlg);
        if(jQuery(geoSettingsDlg.unknownListTbl).find("tr[elname='unknownLocEl']").length<1)
        {
            ZRCustomGeocoder.appendCustomLocDetInDlg(geoSettingsDlg,geoSettingsDlg.unknownLocDet);
        }
        ZRCustomGeocoder.showHideContent(geoSettingsDlg.locResolveContainer,geoSettingsDlg.unknownLocLister);
    }
    this.showHideGeoHrchyCols = function (el,event)
    {
        ZRCustomGeocoder.showHideContent(el,DOMUtils.getFirstMatchingChild(el,"*","elname","optionListEL"));
        
        var srcEl = ZDBUtil.getSourceElement(event);
        if(DOMUtils.getSelfOrParentWithAttrValue(srcEl, "dontclose", "true")!=null)
        {
            ZDBUtil.stopEventBubble(event);
        }
    }
    this.showHideContent = function(headerEl,bodyEl)
    {
        var jBodyEl = jQuery(bodyEl);
        var jEl =jQuery(headerEl);
        if(jBodyEl.is(":visible") )
        {
            MenuUtil.slideUp(jBodyEl,250,function()
            {
                jEl.removeClass("ListExpand");
            },!ZDBGlobal.isQAEnabled);
        }
        else if(jBodyEl.not(":visible"))
        {
            MenuUtil.slideDown(jBodyEl,250,function()
            {
                jEl.addClass("ListExpand");
            },!ZDBGlobal.isQAEnabled);
        }
    }
    
    this.fetchUnknownLocationDet = function()
    {   
        var focusDlg = ZDBDialogUtil.focusDialog;
        if(!focusDlg)
        {
            return;
        }
        var geoSettingsDlg = focusDlg.bodyContent;
        var colId = focusDlg.params.GEOCOLID;
        var geoRole = focusDlg.params.GEOROLE;
        var tblObjId = focusDlg.params.TBLOBJID;
        var view = focusDlg.params.VIEW;
        var hrchyDet = ZRCustomGeocoder.getGeoHrchyDetAsJSON(geoSettingsDlg);
        var params = "&OBJID="+view.objId+"&PARENTVIEWID="+ tblObjId+"&COLID="+colId+"&GEOROLE="+geoRole;//NO I18N
        if(hrchyDet)
        {
            params+="&HRCHYDET="+encodeURIComponent(JSON.stringify(hrchyDet));//NO I18N
        }
        var xml = "";
        if(view.typeValue === ZDBClientViewAPI.TYPE_ANALYSISVIEW)
        {
            xml =ZDBAnalysisConfig.getCurrentConfig(view,true);
            params+="&XMLBODY="+encodeURIComponent(xml); //NO I18N
        }
        var url = ZDBGlobal.CTX + "/ZDBCustomGeocodingAction.ma?ZDBACTION=FETCHUNKNOWNDATA"; //NO I18N
        AjaxAPI.sendRequest({
          URL: url,
          HRCHYDET: hrchyDet,
          PARAMETERS:params,
          OPSTATUSID:geoSettingsDlg.loadingEl,
          ONSUCCESSFUNC:ZRCustomGeocoder.handleUnknownLocResp
          });
    }
    this.handleUnknownLocResp = function (response,requestOptions)
    {
        var respJSON = JSON.parse(response.responseText);
        var geoSettingsDlg = ZDBDialogUtil.focusDialog.bodyContent;
        geoSettingsDlg.unknownLocDet = respJSON;
        var tblEl =geoSettingsDlg.unknownListTbl;
        var jTblEl = jQuery(tblEl);
        var unknownLocEls = jTblEl.find("[elname='unknownLocEl']");
        unknownLocEls.remove();
        ZRCustomGeocoder.appendCustomLocDetInDlg(geoSettingsDlg,geoSettingsDlg.unknownLocDet);
        ZRCustomGeocoder.updateUnknownLocDetInDlg();
        ZRCustomGeocoder.updateInvalidParLocStatus(geoSettingsDlg,geoSettingsDlg.unknownLocDet.INVALIDCUSTOMLOCS);
    }
    this.isoptionChanged= function (srcEl,compElContainer)
    {
        var curColId = srcEl.getAttribute("COLUMNID");
        var prevColId = compElContainer.getAttribute("COLUMNID");
        if(curColId!=prevColId)
        {
            return true;
        }
        else
        {
            if(!curColId || curColId==null)
            {
                var iscurEl_CustomPar = srcEl.getAttribute("customel");
                var prevOptCustomPar = compElContainer.getAttribute("iscustomopt");
                return iscurEl_CustomPar!=prevOptCustomPar;
            }
            else
            {
                return false;
            }
        }
    }
    this.appendCustomLocDetInDlg= function (customGeoDlg,unknownLocDet)
    {
        this.appendUnknownLocLst(customGeoDlg,unknownLocDet.UNKNOWNLIST);
        this.appendResolvedLocLst(customGeoDlg,unknownLocDet.RESOLVEDLIST);
    }
    this.appendUnknownLocLst = function(customGeoDlg,unknownLocList)
    {
        var tblEl =customGeoDlg.unknownListTbl;
        for(var i in unknownLocList)
        {
            if(unknownLocList.hasOwnProperty(i))
            {
                var locDet = unknownLocList[i];
                var locName = locDet;
                var trEl = ZRCustomGeocodeUtil.getUnknownLocationRowTpl();
                ZDBUtil.setNamedChildEls(trEl,trEl);
                trEl.locStatus.className = "UnknownLocStatus";
                trEl.locationEl.innerHTML=ZDBEscapeUtil.encodeForHtml(locName);
//                trEl.locationEl.setAttribute("locationName",locName);
                trEl.setAttribute("locationName",locName);
                tblEl.appendChild(trEl);
            }
        }
        
    }
    this.appendResolvedLocLst = function(customGeoDlg,resolvedLocList)
    {
        var tblEl =customGeoDlg.unknownListTbl;
        for(var i in resolvedLocList)
        {
            if(resolvedLocList.hasOwnProperty(i))
            {
                var locDet = resolvedLocList[i];
                var locName = locDet[1];
                var trEl = ZRCustomGeocodeUtil.getUnknownLocationRowTpl();
                ZDBUtil.setNamedChildEls(trEl,trEl);
                trEl.locStatus.className = "resolvedLocStatus";
                trEl.locationEl.innerHTML=ZDBEscapeUtil.encodeForHtml(locName);
//                trEl.locationEl.setAttribute("locationName",locName);
                trEl.setAttribute("locationName",locName);
                trEl.latitudeEl.value = locDet[2];
                trEl.longitudeEl.value = locDet[3];
                tblEl.appendChild(trEl);
            }
        }
        
    }
    this.updateCustomLocCurValue = function(el)
    {
        el.setAttribute("prevVal",el.value);
    }
    this.isValidLatLngVal = function(val,el)
    {
        if(!ZDBValidator.isDecimal(val,true))
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.table.geocoding.js.invalidInput"), el);
            return;
        }
        var geoRole = el.getAttribute("georole");
        if(geoRole=="LATITUDE" && (val<-90|| val>90))
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.table.geocoding.js.invalidLat"),el);
            return false;
        }
        else if(geoRole=="LONGITUDE" && (val<-180 || val > 180))
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.table.geocoding.js.invalidLng"),el);
            return false;
        }
        return true;
    }
    this.updateCustomLocChangeStatus = function(el)
    {
        var curVal = el.value;
        if(!ZRCustomGeocoder.isValidLatLngVal(curVal,el))
        {
            el.setAttribute("isInvalid","true");
            return;
        }
        el.removeAttribute("isInvalid");
        var prevVal = el.getAttribute("prevVal");
        if(prevVal != curVal)
        {
            var unknownEl = DOMUtils.getParentWithAttrValue(el,"elname","unknownLocEl"); //NO I18N
            unknownEl.setAttribute("valChanged","true");
        }
    }
}

    