//$Id$
var ZRCustomParLocSearch = new function()
{
    var searchSuggest = {};
    this.promptSuggestedSearch = function(el,ev)
    {
        if(ev.keyCode==13)
        {
            el.onblur();
            ZDBUtil.stopEventBubble(ev);
        }
        if(ev.keyCode==37 || ev.keyCode==39||ev.keyCode==40 || ev.keyCode==38 ||ev.keyCode==13 || ev.keyCode==32)
       {
            return;
       }
       if(el.value==el.getAttribute("prevVal"))
       {
           return;
       }
       el.setAttribute("prevVal",el.value);
       ZRCustomParLocSearch.fetchSuggestList(el,ev);
    }
    this.fetchSuggestList = function(el,ev)
    {
        var geoSettingsDlg =ZDBDialogUtil.focusDialog.bodyContent;
        var compEl = DOMUtils.getSelfOrParentWithAttrValue(el,"elname","compElContainer"); //NO I18N
        var geoRole = compEl.getAttribute("georole");
        var countryLocName;
        if(geoRole==ZDBUtil.geoNameVsRole.STATEPROVINCE)
        {
         var compEls= DOMUtils.getChildElsWithAttr(geoSettingsDlg,"elname","compElContainer");//NO I18N
         var countryCompEl = DOMUtils.getFirstMatchingElement(compEls,null,"georole","1");//NO I18N
         countryLocName = countryCompEl.getAttribute("PAR_LOC_NAME");
        }
        var searchSuggestList;
        if(geoRole==ZDBUtil.geoNameVsRole.STATEPROVINCE && !searchSuggest[geoRole])
        {
            searchSuggest[geoRole]={};
        }
        searchSuggestList = geoRole==ZDBUtil.geoNameVsRole.STATEPROVINCE ? searchSuggest[geoRole][countryLocName] : searchSuggest[geoRole];
        if(searchSuggestList)
        {
            ZRCustomParLocSearch.suggestMatchedResult(el,searchSuggestList);
            return;
        }
        var params="&GEOROLE="+geoRole;//NO I18N
        if(parseInt(geoRole)>ZDBUtil.geoNameVsRole.COUNTRY && countryLocName)
        {
            params+="&COUNTRYLOCNAME="+countryLocName;//NO I18N
        }
        
        var url = ZDBGlobal.CTX + "/ZRSearchSuggest.ve?ZDBACTION=CUSTOM_PARLOC_SEARCH"; //NO I18N
        var ajaxOptions = {
            URL:url,
            METHOD:"GET", //NO I18N
            PARAMETERS:params,
            COMPEL:compEl,
            GEOROLE:geoRole,
            COUNTRYLOCNAME:countryLocName,
            SEARCHEL:el,
            ONSUCCESSFUNC:ZRCustomParLocSearch.updateNSuggestMatchedResult,
            ONFAILUREFUNC:ZRCustomParLocSearch.handleFailure
          };
        AjaxAPI.sendRequest(ajaxOptions);
    }
    this.handleFailure = function(response,requestOptions)
  {
    var errCode = response.getResponsePart("ERRORCODE");
    errCode = trimAll(errCode);
    if(errCode == "INVALID_COUNTRY_VALUE")
    {
        var geoSettingsDlg =ZDBDialogUtil.focusDialog.bodyContent;
        var compEls= DOMUtils.getChildElsWithAttr(geoSettingsDlg,"elname","compElContainer");//NO I18N
        var countryCompEl = DOMUtils.getFirstMatchingElement(compEls,null,"georole","1");//NO I18N
        jQuery(countryCompEl.wronglocStatus).addClass("wrongloc")
    }
    else
    {
        AjaxAPI.onFailureFunc(response,requestOptions);
    }
  }
    this.updateNSuggestMatchedResult = function(response,requestOptions)
    {
        var searchEl = requestOptions["SEARCHEL"];
        var georole = requestOptions["GEOROLE"];
        var countryLocName = requestOptions["COUNTRYLOCNAME"];
        var respJSON = JSON.parse(response.responseText);
        if(georole==ZDBUtil.geoNameVsRole.STATEPROVINCE )
        {
            if(!searchSuggest[georole])
            {
                searchSuggest[georole]={};
            }
            searchSuggest[georole][countryLocName]=respJSON;
        }
        else if(georole==ZDBUtil.geoNameVsRole.COUNTRY )
        {
            searchSuggest[georole] = respJSON;
        }
        ZRCustomParLocSearch.suggestMatchedResult(searchEl,respJSON)
    }
    this.suggestMatchedResult = function(searchEl,locArray)
    {
        var compEl = DOMUtils.getSelfOrParentWithAttrValue(searchEl,"elname","compElContainer");//NO I18N
        if(!searchEl.value || searchEl.value=="")
        {
            return;
        }
        var matchedLocs = ZRCustomParLocSearch.getMatchedResult(locArray,searchEl.value);
        var searchList = DOMUtils.getFirstMatchingChild(compEl,"*","elname","searchList");
        var listPar;
        if(searchList==null)
        {
            searchList = document.createElement("div");
            compEl.appendChild(searchList);
            searchList.className = "searchListHolderEl shadowAdded";
            searchList.setAttribute("elname","searchList");
            listPar = document.createElement("ul");
            listPar.className = "optionListUl";
            listPar.setAttribute("onclick","ZRCustomParLocSearch.selectSearchedVal(this,event);");
            searchList.appendChild(listPar);
        }
        else
        {
            listPar = DOMUtils.getFirstMatchingChild(searchList,"ul");//NO I18N
        }
        listPar.searchEl = searchEl;
        searchEl.listPar = listPar;
        var left = ZDBUtil.getObjLeft(searchEl,true,compEl);
        searchList.style.left = left+"px";
        listPar.innerHTML='';
        if(matchedLocs.length<1)
        {
            jQuery(searchList).hide();
            return;
        }
        matchedLocs.forEach(function(loc)
        {
            var liEl = document.createElement("li");
            liEl.setAttribute("locVal",loc);
            liEl.setAttribute("listEl","true");
            liEl.className = "optionlistEl";
            liEl.innerHTML=ZDBEscapeUtil.encodeForHtml(loc);
            listPar.appendChild(liEl);
        });
        jQuery(searchList).show();
        ZAComboList.curList = searchList;
        ZDBUtil.attachEvent(document,'keydown',ZAComboList.checkKeyNContinue,true);
        ZDBUtil.attachEvent(document,(ZDBGlobal.IS_MOBILE) ? 'touchstart' :'click',ZAComboList.closeList,true);
        ZDBUtil.stopEventBubble(event);
    }
    this.selectSearchedVal = function(el, ev)
    {
        var srcEl = ZDBUtil.getSourceElement(ev);
        var li = DOMUtils.getSelfOrParentWithTagName(srcEl,"li");//NO I18N
        var locName = li.getAttribute("locVal");
        el.searchEl.value = ZDBEscapeUtil.encodeForHtml(locName);
        el.searchEl.innerHTML = ZDBEscapeUtil.encodeForHtml(locName);
        el.searchEl.onblur();
        ZDBUtil.stopEventBubble(ev);
    }
    this.getMatchedResult = function(locNamesList, searchKey)
    {
        var matchedLocs = [];
        for(var i=0 ;i<locNamesList.length;i++)
        {   
            var loc = locNamesList[i]
            if(loc.toString().toLowerCase().indexOf(searchKey.toString().toLowerCase()) >=0)
            {
                matchedLocs.push(loc);
            }
        }
        return matchedLocs;
    }
}