//$Id$
var ZDBValidator = new function()
{
    
    ///PK: move to global?
    this.monthList = ["JANUARY","FEBRUARY","MARCH",
                      "APRIL","MAY", "JUNE",
                      "JULY","AUGUST","SEPTEMBER",
                      "OCTOBER","NOVEMBER","DECEMBER"];
    this.monthLenth = 12;
    
    this.weekList = ["SUNDAY","MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY"];
    this.weekLength = 7; 

    this.isPositive1 = function(value, allowBlank)
    {
        return (ZDBValidator.isPositive(value, allowBlank) && (ZDBValidator.isBlank(value) || parseInt(value) > 0));
    }

    this.isYear = function(value, allowBlank)
    {
      if(allowBlank && ZDBValidator.isBlank(value))
      {
          return true;    
      }
      var year = parseInt(value, 10); //PK: should do the same for other...
      if(isNaN(year))
      {
        return false;
      }
      return year > 999 && year < 9999;
    }
    
    this.isRange = function(value, min, max)
    {
        try
        {
            if(value >= min && value <= max)
            {
                return true;
            }
        }
        catch(e){}
        return false;
    }
    
    this.isQuarter = function(value)
    {
        return /^[Qq]?[1-4]?([ ,]+[1-9]([0-9]){3}){0,1}$/.test(value);
    }
    this.isMonth = function(value, allowBlank)
    {
        if(allowBlank && ZDBValidator.isBlank(value))
        {
            return true;    
        }
        try
        {
            var month = parseInt(value);
            if(month > 0 && month < 13)
            {
                return true;
            }  
            value = (""+value).toUpperCase();
            var index = ZDBUtil.indexOf(ZDBValidator.monthList, value, 3);
            if(index >= 0)
            {
                return true;
            }
        }catch(e){}
        return false;
    }
    this.isDay = function(value, allowBlank)
    {
        if(allowBlank && ZDBValidator.isBlank(value))
        {
            return true;    
        }
        try
        {
            var day = parseInt(day);
            return day > 0 && day < 31; // No leap year No 30 days...  
        }catch(e){}
        return false;
    
    }
    this.isWeekDay = function(value,allowBlank)
    {
        if(allowBlank && ZDBValidator.isBlank(value))
        {
            return true;    
        }
        value = ("" + value).toUpperCase();
        try
        {
            var index = ZDBUtil.indexOf(ZDBValidator.weekList, value, 3);
            if(index >= 0)
            {
                return true;
            }
        }
        catch(e){}
        return false;
    
    }


    this.isBlank = function(value)
    {
        return value !== null && value !== undefined && value === ''; 
    }

    this.isArgCountOK = function(value, noArgs, separator, strict)
    {
        if(!separator)
        {
            separator = ",";
        }
        try
        {
            if(value.split(separator).length == noArgs)
            {
                    return true;
            }
        }catch(e){}
        return false;
        ///to be implemented later
    }

  this.isPositive = function(value, allowBlank, strict)
  {
    if(ZDBValidator.isNumber(value, allowBlank, strict))
    {
        if(value === '' || parseInt(value) >= 0)
        {
            return true;
        }
    }
    return false;
  }
  this.isNumber = function(value, allowBlank, strict)
  {
    if(!strict)
    {
     value = ZDBConvert.trimData(value);
    }
    if(value === '')
    {
      return allowBlank;	
    }
    return /^[+-]?[0-9]+$/.test(value);
  }
  
  this.isValidImgWidth = function(value,allowBlank,strict)
  {
      if(ZDBValidator.isNumber(value, allowBlank, strict))
      {
          if(value === '' || (parseInt(value) >= 250 && parseInt(value) <= 2000))
        {
              return true;
        }
     }
    return false;
  }
  this.isValidImgHeight = function(value,allowBlank,strict)
  {
      if(ZDBValidator.isNumber(value, allowBlank, strict))
      {
          if(value === '' || (parseInt(value) >= 200 && parseInt(value) <= 2000))
        {
              return true;
        }
     }
    return false;
  }
  
  this.isDecimal = function(value, allowBlank, strict)
  {
    if(!strict)
    {
     value = ZDBConvert.trimData(value);
    }
    if(value === '')
    {
      return allowBlank;	
    }
    return /^[+-]?[0-9]*[.]?[0-9]+$/.test(value);
    /// consider parseFloat too!  
  }

  this.isCurrency = function(value, allowBlank, strict, currencySymbol)
  {
    if(!strict)
    {
     value = ZDBConvert.trimData(value);
     value = ZDBUtil.removeChar(value, currencySymbol);
    }
    if(value === '')
    {
      return allowBlank;	
    }
    
    return ZDBValidator.isDecimal(value);
  }
  
  this.isPercent = function(value, allowBlank, strict)
  {
    if(!strict)
    {
     value = ZDBConvert.trimData(value);
     value = ZDBUtil.removeChar(value, '%');
    }
    if(value === '')
    {
      return allowBlank;	
    }
    return ZDBValidator.isDecimal(value);
  }
  

  this.isEmail = function(value, allowBlank, strict)
  {
    if(!strict)
    {
     value = ZDBConvert.trimData(value);
    }
    if(value === '')
    {
      return allowBlank;	
    }
    
    if(ZDBGlobal.emailRegex.test(value))
    {
    	return true;
    }
    else
    {
    	return false;
    }

  }
  
  this.isWebpageURL = function(value, allowBlank, strict){
	  if(!strict)
	  {
		  value = ZDBConvert.trimData(value); 	 
	  }
	  if(value === '')
	  {
		  return allowBlank;
	  }
	  if(ZDBGlobal.webpageURLRegex.test(value)){
		  return true;
	  }
	  return false;
  }
  
  this.isWebpageURLWithHTTP = function(value, allowBlank, strict){
	  if(!strict)
	  {
		  value = ZDBConvert.trimData(value); 	 
	  }
	  if(value === '')
	  {
		  return allowBlank;
	  }
	  if(ZDBGlobal.webpageURLRegexWithHTTP.test(value)){
		  return true;
	  }
	  return false;
  }
  
  this.isUrl = function(value, allowBlank, strict)  	 
  { 	 
	  if(!strict) 	 
	  { 	 
		  value = ZDBConvert.trimData(value); 	 
	  } 	 
	  if(value === '') 	 
	  { 	 
		  return allowBlank;         	 
	  }
	  //No validation
	  return true; 	 
  }
  
  this.domainName = function(value, allowBlank, strict){
	  if(!strict) 	 
	  { 	 
		  value = ZDBConvert.trimData(value); 	 
	  } 	 
	  if(value === '') 	 
	  { 	 
		  return allowBlank;         	 
	  }
	  if(ZDBGlobal.domainNameRegex.test(value)){
		  return true;
	  }
	  return false;
  }
  
  this.isPublicIPAddress = function(value, allowBlank, strict){
	  if(!strict) 	 
	  { 	 
		  value = ZDBConvert.trimData(value); 	 
	  } 	 
	  if(value === '') 	 
	  { 	 
		  return allowBlank;         	 
	  }
	  var IPRegex=/^[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}$/i;
	  if(IPRegex.test(value)){
		  var id = value.split(".");
		  var idLen = id.length;
		  if(id[0] == 0 || id[0] == 127 || id[0] == 172 || id[0] == 192 || id[0] > 223 || (id[idLen-1] == "" && id[0] == 10))
		  {//Private address,Loopback address,Not an address
			  return false;
		  }
		  for(var i=1; i<idLen; i++)
		  {
			  if(id[i] > 255)
			  {
				  return false;
			  }
		  }
	  }
	  else{
		  return false;
	  }
	  return true;
  }
  
  this.dataValFn = function(cellObj,objType)
    {
        // Not checking for null and It should be done separately
        // return null -> No Error
        var val = cellObj.getValue('validate');
        var colObj = cellObj.colObj;
        if(objType == null)
        {
          objType = colObj.type;
        }
        var colName = colObj.displayName;
        var errorMsg = "";
        if(cellObj.rowObj.rid)
        {
        	errorMsg = ZDBI18NMap.f("zrpt.common.table.showinfo.js.invalidDataErr1",ZDBEscapeUtil.encodeForHtml(colName),cellObj.rowObj.rid); 
        }
        else
        {
        	errorMsg = ZDBI18NMap.f("zrpt.common.table.showinfo.js.invalidDataErr",ZDBEscapeUtil.encodeForHtml(colName));
        }
        switch(objType)
        {
         case "EMAIL" :
         {
            if(!ZDBValidator.isEmail(val,true, false))
            {
                cellObj.setValidatedInfo(errorMsg + ZDBI18NMap.g("zrpt.common.table.showinfo.js.invalidEmail"), "CELL");
                return false;         
            }
            break;
         }
         case "URL" :  	 
         { 	 
            if(!ZDBValidator.isUrl(val,true, false)) 	 
            { 	 
                cellObj.setValidatedInfo(errorMsg + ZDBI18NMap.g("zrpt.common.table.showinfo.js.invalidURL"), "CELL");
                return false;          	 
            } 	 
            break; 	 
         }         
         case "NUMBER" :
         {
            if(!ZDBValidator.isNumber(val,true,false))
            {
                cellObj.setValidatedInfo(errorMsg +  ZDBI18NMap.g("zrpt.common.table.showinfo.js.invalidNumber") , "CELL");
                return false;         
            }
            break;
         }
         case "POSITIVE_NUMBER" : 
         {
            if(!ZDBValidator.isPositive(val,true,false))
            {
                cellObj.setValidatedInfo(errorMsg + ZDBI18NMap.g("zrpt.common.table.showinfo.js.invalidPosNumber"), "CELL");
                return false;         
            }
            break;
         }
         case "DECIMAL_NUMBER" :
         {
            if(!ZDBValidator.isDecimal(val,true,false))
            {
                cellObj.setValidatedInfo(errorMsg +  ZDBI18NMap.g("zrpt.common.table.showinfo.js.invalidDeciNumber"), "CELL");
                return false;         
            }
            break;
         } 
         case "CURRENCY" :
         {
            var symbol = colObj.formatStr ? colObj.formatStr : "$"; /// PK: Temp
            if(!ZDBValidator.isCurrency(val,true,false, symbol))
            {
                cellObj.setValidatedInfo(errorMsg + ZDBI18NMap.f("zrpt.common.table.showinfo.js.invalidCurrencyVal",symbol) , "CELL");
                return false;         
            }
            break;
         } 
         case "PERCENT" : 
         {
            if(!ZDBValidator.isPercent(val,true,false))
            {
                cellObj.setValidatedInfo(errorMsg + ZDBI18NMap.g("zrpt.common.table.showinfo.js.invalidPercentVal"), "CELL");
                return false;         
            }
            break;
         } 
         case "DATE" :
         case "DATE_AS_DATE" : //No I18N
         {
           var fmt = colObj.dateFormat;
           if(fmt && !(ZDBUtil.containsAnyValue(fmt,["Z","MILLI"])))
           {
             fmt = ZDBUtil.calendarDateFormat(fmt);
             if(typeof(val) == 'object')
             {
               val = val.print(fmt);
             }
             var value = ZDBUtil.removeSpace(val.toLowerCase());
             var parsedDateVal = Date.parseDate(val,fmt).print(fmt).toLowerCase();
//             if(typeof(val) != 'object')
//             {
//                 var defaultCalendarFormat = "%d %b %Y %H:%M:%S.%f"; //No I18N
//               val =  Date.parseDate(val,fmt).print(defaultCalendarFormat).toLowerCase();
//             }
             parsedDateVal = ZDBUtil.removeSpace(parsedDateVal);
             if(value != parsedDateVal)
             {
                if(!ZDBValidator.isDate(val,true,false))
                {
                    cellObj.setValidatedInfo(errorMsg + ZDBI18NMap.g("zrpt.common.table.showinfo.js.invalidDate"), "CELL");
                    return false;         
                }
              }
            }
            else if(!ZDBValidator.isDate(val,true,false))
            {
                cellObj.setValidatedInfo(errorMsg + ZDBI18NMap.g("zrpt.common.table.showinfo.js.invalidDate"), "CELL");
                return false;         
            }
            
            break;
         } 
        }
        cellObj.clearError(true, false, false);
        return true;
    }


    /// Assumption: (for most of the formats?) Date.parse(value) produces date value
    
    this.resetDateSeparator = function(value)
    {
        try { return value.replace(/[.\-]/g, "/");}
        catch(e){return value}
    }
    this.getYMDConvertedDate = function(value)
    {
        /// to Handle D/M/Y variations -- convert to unambiguous form
        /// Assumption:
        //// Year value greater than 999
        /// Month == Day, Month, Day < 12 is not handled here!
        try
        {
            var dateVals = ZDBValidator.resetDateSeparator(value).split('/');
            var field1 = parseInt(dateVals[0],10);
            var field2 = parseInt(dateVals[1],10);
            var field3 = parseInt(dateVals[2],10);
            var year = month = day = 0;
            field1 > 31 ? year = field1 : field1 > 12 ? day = field1 : field1 > 0 ? month = field1 : 0;  
            field2 > 31 ? year = field2 : field2 > 12 ? day = field2 : field2 > 0 ? month = field2 : 0;
            field3 > 31 ? year = field3 : field3 > 12 ? day = field3 : field3 > 0 ? month = field3 : 0;
            if(day && month && year)
            {
                var temp = dateVals[0] + "/" + dateVals[1] + "/" + field3;
                var dateStr = ZDBUtil.getMonthName(month,true,true) + " " + day + ", " + year + value.substring(temp.length);                    
                return dateStr;
            }
        }
        catch(e)
        {
            /// No conversion done!!!
        }
        return value;
    }       


    this.isDateFieldFound = function(dateStr, fieldName)
    {
        /// Assumption: Date.parse(value) produces a date value
        var date = new Date(Date.parse(dateStr));
        switch(fieldName.toLowerCase())
        {
            case "year":
                    return (dateStr.indexOf(date.getFullYear()) >= 0);
            case "month":
                    var mm = date.getMonth(); // 0 - 11
                    var userMonth = mm + 1;
                    var monthAbr = ZDBUtil.getMonthName(mm,false,true).toUpperCase();
                    return (dateStr.indexOf(userMonth) >= 0 || dateStr.toUpperCase().indexOf(monthAbr) >= 0);
            case "date":
                    return (dateStr.indexOf(date.getDate()) >= 0);
            case "hour":
                    return (dateStr.indexOf(date.getHours()) >= 0);
            case "minute":
                    return (dateStr.indexOf(date.getMinutes()) >= 0);
            case "second":
                    return (dateStr.indexOf(date.getSeconds()) >= 0);
        }
    }
    
    this.isValidDateFound = function(dateStr)
    {
        var date = new Date(Date.parse(dateStr));
        return ZDBValidator.isDateFieldFound(dateStr, "date") && 
               ZDBValidator.isDateFieldFound(dateStr, "month") &&
               ZDBValidator.isDateFieldFound(dateStr, "year");
    }
    
    this.isValidTimeFound = function(dateStr)
    {
        var colonFirstIndex = dateStr.indexOf(":");
        var colonLastIndex = dateStr.lastIndexOf(":");
        
        if(colonFirstIndex < 0)
        {
            return false;
        }
        
        return ZDBValidator.isDateFieldFound(dateStr, "hour") && 
               ZDBValidator.isDateFieldFound(dateStr, "minute") &&
               ((colonLastIndex < 0 || colonFirstIndex == colonLastIndex) || ZDBValidator.isDateFieldFound(dateStr, "second"));    
    }
    

    this.isTempDate = function(value)
    {
        var dt = Date.parse(value);
        if(isNaN(dt))
        {
            return false;
        }
        var year = parseInt(value.substring(0,3),10);
        if(year < 1000)
        {
            return false;
        }
        return true;
    }
    
    
    
    this.getReplacedValue = function(value)
    {
        var  retVal = "";
        if(value)
        {
            for(var i=0;i<value.length;++i)
            {
                var curChar = value.charAt(i);
                if(curChar == '.' || curChar == '-')
                {
                    curChar = '/';
                }
                retVal += curChar;
            }
        }
        return retVal;
        //return value.replace(/[/.\-,]/g, " ");
    }
    
    this.isDate = function(value)
    {
        try
        {
            if(value == undefined)
            {
                return false;
            }
            if(value == "")
            {
                return true; // Should I consider empty as a date value?
            }
            value  = value.replace(/[.\-]/g, "/");//reset this line and change the below line accordingly
            value = value.replace(/\/\d{6}/g,"");
            value = value.replace(/\/\d{3}\b/g,"");
            value = ZDBValidator.getYMDConvertedDate(value);
            var date = Date.parse(value);
            if(isNaN(date))
            {
                return false;
            }
            return ZDBValidator.isValidDateFound(value) &&
                    ((value.indexOf(":") < 0) || (ZDBValidator.isValidTimeFound(value)));
        }
        catch(e)
        {
            return false;
        }
        
    }
    

    this.isUnique = function(colHeader)
    {
      var rowData = colHeader.parGrid.rowData;
      var index = colHeader.cellPos;
      var validCol = true;
      var startIndex = ZDBDataGrid.getFirstRowIndex(rowData, false);
      if(startIndex < 0)
      {
        return validCol;
      }
      var endIndex = ZDBDataGrid.getLastRowIndex(rowData, false);
      for(var i=startIndex; i <= endIndex;  i++)
      {
        var cellObjI = rowData[i].values[index]; 
        var val = cellObjI.getValue('validate');
        val = val.toLowerCase().trim();
        for(var j = startIndex; j < i; j++)
        {
          var cellObjJ = rowData[j].values[index]; 
          if((cellObjJ.getValue('validate').toLowerCase().trim()) == val)
          {
            cellObjI.setValidatedInfo(colHeader.displayName+ " "+ZDBI18NMap.g("zrpt.common.showinfo.js.duplicateEntryErr"), "COL");
            validCol = false;
            break;
          }
        }
        if(j == i){cellObjI.clearError(false, true, false);}
      }
      return validCol;
    }

		this.isUniqueANC = function(colHeader)
		{
      var rowData = colHeader.parGrid.rowData;
      var index = colHeader.cellPos;
      var validCol = true;
      var startIndex = ZDBDataGrid.getFirstRowIndex(rowData, false);
      var endIndex = ZDBDataGrid.getLastRowIndex(rowData, false);
      for(var i=startIndex; i < endIndex;  i++)
      {
        var dataObjI = rowData[i].values[index];
        var val = dataObjI.getValue('validate');
        for(var j = startIndex; j < i; j++)
        {
          var dataObjJ =rowData[j].values[index];
          if(val == ZDBDesignGridConst.AUTO_NUMBER && dataObjJ.getValue('validate') == val)
          {
            dataObjI.setValidatedInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.multiAutoNumColErr"), "COL");
            validCol = false;
            break;
          }
        }
        if(j == i){dataObjI.clearError(false, true, false);}
      }
      return validCol;
		}


    this.isLossLess = function(src, tgt)
    {
      if(src == tgt || tgt == ZDBConst.PLAIN || tgt == ZDBConst.GEO  || tgt == ZDBConst.MULTI_LINE || tgt == ZDBConst.URL)
      {//tgt - PLAIN/MULTI_LINE
        return true;
      }
      if((src == ZDBConst.NUMBER || src == ZDBConst.POSITIVE_NUMBER) &&
         (tgt  == ZDBConst.DECIMAL_NUMBER || tgt == ZDBConst.CURRENCY || tgt == ZDBConst.PERCENT || tgt == ZDBConst.AUTO_NUMBER || tgt == ZDBConst.GEO_NUM))
      {// src - NUMBER/POSITIVE_NUMBER
       // tgt - DECIMAL_NUMBER/CURRENCY/PERCENT/GEO
        return true;
      }
      if(src == ZDBConst.POSITIVE_NUMBER && tgt == ZDBConst.NUMBER)
      {// POSITIVE_NUMBER to NUMBER
        return true;
      }
      if((src == ZDBConst.DECIMAL_NUMBER || src == ZDBConst.CURRENCY || src == ZDBConst.PERCENT || src == ZDBConst.GEO_NUM) &&
         (tgt == ZDBConst.DECIMAL_NUMBER || tgt == ZDBConst.CURRENCY || tgt == ZDBConst.PERCENT || tgt == ZDBConst.AUTO_NUMBER || tgt == ZDBConst.GEO_NUM))
      {// Within DECIMAL_NUMBER/CURRENCY/PERCENT/GEO
        return true;
      }
      
      if((src !== ZDBConst.REFCOL || src !== ZDBConst.RELCOL) && (tgt === ZDBConst.REFCOL || tgt === ZDBConst.RELCOL))
      {
        return true;
      }
      return false;
    }

    this.formulaColDataTypeChg = function(src, tgt)
    {
      var arr1 = [ZDBConst.PLAIN,ZDBConst.MULTI_LINE,ZDBConst.EMAIL,ZDBConst.URL,ZDBConst.GEO];
      var arr2 = [ZDBConst.NUMBER,ZDBConst.POSITIVE_NUMBER,ZDBConst.DECIMAL_NUMBER,ZDBConst.CURRENCY,ZDBConst.PERCENT,ZDBConst.GEO_NUM];
      if(ZDBUtil.indexOf(arr1,src) != -1 &&
         ZDBUtil.indexOf(arr1,tgt) != -1)
      {
        return true;
      }
      else if(ZDBUtil.indexOf(arr2,src) != -1 &&
              ZDBUtil.indexOf(arr2,tgt) != -1)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    
    this.checkValidInput = function(str)
    {
        str = str.trim();
        return (!ZDBValidator.isBlank(str));
    }
    
    this.checkLength = function(str,formElement)
    {
      str = str.trim();	
      if(!str.length && formElement.getAttribute("isnullable")) {
        return true;
      }
      if( (str.length != 0) && (str.length <= parseInt(formElement.getAttribute("zdbfieldlength"))))
      {
        return true;
      }
      return false;
    }
    
    this.checkFieldLength = function(str,formElement)
    {
        try
        {
            var range = ZDBUtil.getAttribute(formElement, "ZDBFIELDLENGTH").split(",");
            var min = parseInt(ZDBConvert.trimData(range[0]),10); 
            var max = parseInt(ZDBConvert.trimData(range[1]),10);
            return ZDBValidator.isRange(ZDBConvert.trimData(str).length, min, max);
        }
        catch(e){ }
        return false;
    }

    this.validateFindAndReplaceVal = function(type,val,allowBlank)
    {
      switch(type)
      {
        case "PLAIN" :
        case "MULTI_LINE" :
        case "GEO" : //NO I18N
        case "URL" :  	 
        { 	 
          if(!ZDBValidator.isUrl(val,allowBlank, false)) 	 
          { 	 
            return false;          	 
          } 	 
          break; 	 
        }         
        case "NUMBER" :
        {
          if(!ZDBValidator.isNumber(val,allowBlank,false))
          {
            return false;         
          }
          break;
        }
        case "POSITIVE_NUMBER" : 
        {
          if(!ZDBValidator.isPositive(val,allowBlank,false))
          {
            return false;         
          }
          break;
        }
        case "DECIMAL_NUMBER" :
        case "CURRENCY" :
        case "GEO_NUM" : //NO I18N
        case "PERCENT" :
        {
          if(!ZDBValidator.isDecimal(val,allowBlank,false))
          {
            return false;         
          }
          break;
        } 
      }
      return true;
    }
    
    this.isValidYear = function(value,el)
    {
      if(ZDBValidator.tipValue(value,el))
      {
        return true;
      }
      if(ZDBValidator.isPositive(value,false))
      {
        return value > 1901 && value < 2038;
      }
      return false;
    }
    
    this.isValidMonth = function(value,el)
    {
      if(ZDBValidator.tipValue(value,el))
      {
    	return true;
      }
      if(ZDBValidator.isMonth(value,false))
      {
    	return true;
      }
      return false;
    }
    
    this.isValidDay = function(value,el)
    {
      if(ZDBValidator.tipValue(value,el))
      {
        return true;
      }
      if(ZDBValidator.isPositive(value,false))
      {
        return value > 0 && value <= 31;
      }
      return false;
    }
    
    this.isValidHour = function(value,el)
    {
      if(ZDBValidator.tipValue(value,el))
      {
        return true;
      }
      if(ZDBValidator.isPositive(value,false))
      {
        return value >= 0 && value < 24;
      }
      return false;
    }
    
    this.isValidMinSec = function(value,el)
    {
      if(ZDBValidator.tipValue(value,el))
      {
        return true;
      }
      if(ZDBValidator.isPositive(value,false))
      {
        return value >= 0 && value < 60;
      }
      return false;
    }
    
    this.tipValue = function(value,el)
    {
      if(el.getAttribute("tipValue") == value)
      {
        return true;
      }
      return false;
    }
     this.isValidGSheet = function(value,el)
    {
        var isNamePresent = ZDBValidator.tipValue(value,el);
        var sheetIdElt = $("ZDBGSHEETID");
        if(isNamePresent || sheetIdElt.value=="")
        {
            return false;
        }
        return true;
    }
     this.isValidZDOCS = function(value,el)
    {
        var isNamePresent = ZDBValidator.tipValue(value,el);
        var fileType = ($("ZDBFILETYPE")) ? $("ZDBFILETYPE").value : $("ZDBEXFILETYPE").value; //No I18N
        var sheetIdElt = (fileType === "GSHEET") ? $("ZDBGSHEETID"): $("DOCID");  //No I18N
        var arr = new Array();
        arr["ZDOCS"] = ZDBI18NMap.f("zrpt.common.external.js.empty",ZDBI18NMap.g("zrpt.common.external.js.zdocs"));      //NO I18N  
        arr["DROPBOX"] = ZDBI18NMap.f("zrpt.common.external.js.empty",ZDBI18NMap.g("zrpt.common.external.js.dropbox"));//NO I18N
        arr["BOX"] = ZDBI18NMap.f("zrpt.common.external.js.empty",ZDBI18NMap.g("zrpt.common.external.js.box"));//NO I18N
        arr["ONEDRIVE"] = ZDBI18NMap.f("zrpt.common.external.js.empty",ZDBI18NMap.g("zrpt.common.external.js.skydrive"));//NO I18N
        arr["GSHEET"] = ZDBI18NMap.f("zrpt.common.external.js.empty",ZDBI18NMap.g("zrpt.common.external.js.gdrive"));//NO I18N
        el.setAttribute("errormsg",arr[fileType]);       
        if(isNamePresent || sheetIdElt.value=="")
        {
            return false;
        }
        return true;
    }
    
    
    this.isEmailValue = function(findVal,replaceVal,allowBlank)
    {
      if(findVal == "")
      {
        return ZDBValidator.isEmail(replaceVal,true, false);
      }
      if(allowBlank && ZDBValidator.isBlank(replaceVal))
      {
        return true;    
      }
      if(!ZDBGlobal.emailRegex.test(findVal))
      {
    	  return false;
      }
      if(!ZDBGlobal.emailRegex.test(replaceVal))
      {
    	  return false;
      }
      return true;
    }
    this.isAlphanumeric= function(str)
    {
        var regex=/^[0-9a-zA-Z\s:]+$/; //^[a-zA-z]+$/
        if(regex.test(str)){
        return true;
        } else {
        return false;
        }
    }
    this.ValUserFltrDtFormat= function(el,includeTime)
    {
        var val = el.value.trim();
        var fmt = (includeTime)?  "%d %b %Y %H:%M:%S":"%d %b %Y ";//NO I18N
        var value = ZDBUtil.removeSpace(val.toLowerCase());
        var parsedDateVal = Date.parseDate(val,fmt).print(fmt);
        var parsedDateVal1 = ZDBUtil.removeSpace(parsedDateVal.toLowerCase());
        if(value != parsedDateVal1)
        {
            if(!ZDBValidator.isDate(val,true,false))
            {
             showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidDate")+'"', el);
            return "false";
            }
        }
        return parsedDateVal;
    }
}

ZDBValidator.functionMap = {"ZDBValidator.isPositive1":ZDBValidator.isPositive1,	//No I18N
		"ZDBValidator.isPositive":ZDBValidator.isPositive,	//No I18N
		"ZDBValidator.isNumber":ZDBValidator.isNumber,	//No I18N
		"ZDBValidator.isDecimal":ZDBValidator.isDecimal,	//No I18N
		"ZDBValidator.isQuarter":ZDBValidator.isQuarter,	//No I18N
		"ZDBValidator.isMonth":ZDBValidator.isMonth,	//No I18N
		"ZDBValidator.isWeekDay":ZDBValidator.isWeekDay,	//No I18N
		"ZDBValidator.isDay":ZDBValidator.isDay,	//No I18N
		"ZDBValidator.isYear":ZDBValidator.isYear};	//No I18N

var ZDBConvert = new function()
{
    this.toMonthNumber = function(value, startZero)
    {
        var monthVal = (""+value).toUpperCase();
        var index = ZDBUtil.indexOf(ZDBValidator.monthList, monthVal, 3); 
        if(index >= 0)
        {
            return (startZero ? index : (index+1));
        }
        return value;
    }
    
    this.toWeekNumber = function(value, startZero, startDay)
    {
        if(!startDay)
        {
            startDay = "SUNDAY";
        }
        var startIndex = ZDBUtil.indexOf(ZDBValidator.weekList,3);
        var index = ZDBUtil.indexOf(ZDBValidator.weekList,3);
        var actual = (index - startIndex);
        if(actual < 0)
        {
            actual += 7;
        }
        if(!startZero)
        {
            actual += 1;
        }
        return actual;
    }
    
    
    this.trimData = function(val)    /// some util?
    {
      if(val.trim)
      {
        try
        {
          return val.trim();
        }
        catch(e)
        {
          return val;
        }
      }
      else
      {
        return val;
      }
    }
    
    this.toPercent = function(val)
    {
        return ZDBConvert.trimData(ZDBUtil.removeChar(val, '%'));
    }
    
    
    
    this.toCurrency = function(val,currencySymbol)
    {
        if(currencySymbol != 'undefined')
        {
            currencySymbol = '$';
        }
        return ZDBConvert.trimData(ZDBUtil.removeChar(val, currencySymbol));
    }
    
    this.toDate = function(val,cellObj)
    {
      if(val == null || !val)
      {
        return "";
      }
      var defaultCalendarFormat = "%d %b %Y %H:%M:%S.%f"; //No I18N
      var dateFormat = cellObj.colObj.dateFormat;
      if(dateFormat && dateFormat.toUpperCase().indexOf("MILLI") == -1)
      {
        dateFormat = ZDBUtil.calendarDateFormat(dateFormat);
      }
      else
      {
        dateFormat = defaultCalendarFormat;
      }
      if(typeof(val) == 'object')
      {
        val = val.print(dateFormat);
      }
      val = Date.parseDate(val,dateFormat).print(defaultCalendarFormat);
      return val;
    }
    
    this.toDateFilter = function(val)
    {
        if(val == null || !val)
        {
          return "";
        }
        
        //Assumption val is Valid date here for the below operations!
        val = ZDBValidator.resetDateSeparator(val);
        val = ZDBValidator.getYMDConvertedDate(val);
        var date = new Date(val);
        var dd = date.getDate();
        var mm = date.getMonth();
        var yy = date.getFullYear();
        
        var hh = date.getHours();
        var MM = date.getMinutes();
        var ss = date.getSeconds();

        function get(value){if(value < 10) {return "0" + value;} else {return value;}}
        return (get(dd) + " " + ZDBUtil.getMonthName(mm,false,true) + " " + yy + ' ' + get(hh) + ':' + get(MM) + ':' + get(ss));
    }   
}


var ZDBValidationUtil = new function(){
	
	email_regex = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890@+-. '"; // No I18N
	
	this.applyKeyStrokeRestrictions = function(el){
    	var numEls = jQuery(el).find("input[allowNumericOnly=true]");
    	for(var i = 0; i < numEls.length; i++){
    		ZDBValidationUtil.allowNumericOnly(numEls[i]);
    	}
    };
	
	this.allowNumericOnly = function(el){
		jQuery(el).bind("keypress", ZDBValidationUtil.bindAllowNumeric);	  
	};
	
	this.allowNumericOnlyWithSpace = function(el){
		jQuery(el).bind("keypress", ZDBValidationUtil.bindAllowNumericWithSpace);
	};
	
	this.restrictEmailField = function(el){
		ZDBValidationUtil.restrict(el, email_regex);
	};
	
	this.restrict = function(el, allowedChars){
		jQuery(el).attr('allowedChars',allowedChars); // No I18N
		jQuery(el).bind("keypress",ZDBValidationUtil.bindRestrict);	  
	};   
	
	this.bindAllowNumeric = function(){
		var code = (event.keyCode ? event.keyCode : event.which);
		var val = String.fromCharCode(code);
		if(isNaN(val) || code == 32){
			return false;
		}
		return true;
	};
	
	this.bindAllowNumericWithSpace = function(){
		var code = (event.keyCode ? event.keyCode : event.which);
		var val = String.fromCharCode(code);
		if(isNaN(val)){
			return false;
		}
		return true;
	};
	
	this.bindRestrict = function(event){
		var tarEl = event.target;
		var allowedChars = jQuery(tarEl).attr('allowedChars'); // No I18N
		var code = event.keyCode ? event.keyCode : event.which;
		var char = (String.fromCharCode(code));
		if(code == 8){
			return true;
		}
		if(allowedChars.indexOf(char) == -1){
			return false;
		}
		return true;
	};
};
