//$Id$

  function ZRSDrillDown(criteria,view,drillModel,drillLevel,dispVal,extraParams)
  {
    this.view = view;
    if(criteria == null)
    {
        if(view.drillDet && view.drillDet.drillLevel) {
            this.drillLevel = parseInt(view.drillDet.drillLevel);
        }
        else {
            this.drillLevel = 0;
        }
    }
    else
    {
        this.drillLevel = drillModel==="BREADCRUMB" ? drillLevel:parseInt(view.drillDet.drillLevel) +1; //NO I18N
    }
    
    this.criteria = criteria;
    this.dispVal = dispVal;
    this.extraParams = extraParams;
    view.zrsDrillObj = this;
  }
  
  ZRSDrillDown.getDrillParams = function(view)
  {
    if(!view || !view.zrsDrillObj)
    {
        return "";
    }
    var params = "";
    params += "&DRILLLEVEL=" + view.zrsDrillObj.drillLevel + ""; //NO I18N
    params += "&DRILLCRITERIA=" + encodeURIComponent(view.zrsDrillObj.criteria) + ""; //NO I18N
    var critInfo = view.drillDet.critInfo;
    if(critInfo && critInfo!="")
    {
      params += "&DRILLPATH=" + encodeURIComponent(critInfo); //NO I18N
    }
    return params;
  }
  
   ZRSDrillDown.getDrillParamsForDashboard = function(dashView)
  {
    var dashDiv = dashView.dashDiv;
    var dashChilds = DOMUtils.getChildElsWithAttr(dashDiv, "eltype", "VIEW"); //NO I18N
//    var dashChilds = dashView.dashChilds;
    var dashDrillDet = {};
    for(var i=0;i<dashChilds.length;i++)
    {
        var el = dashChilds[i];
        var view = el.ctx.view;        
        var isAnalysisView = ZDBAnalysisViewAPI.isAnalysisView(view);
        if(isAnalysisView && view.zrsDrillObj)
        {
          var drillDet = {};
          drillDet["DRILLLEVEL"] = view.zrsDrillObj.drillLevel;
          drillDet["DRILLCRITERIA"] = view.zrsDrillObj.criteria;          
          drillDet["DRILLPATH"] = view.drillDet.critInfo;
          dashDrillDet[view.objId]=drillDet;
        }
    }
    return JSON.stringify(dashDrillDet);
  }
  
  ZRSDrillDown.updateViewDrillDet = function(view)
  {
    var drillDet = view.drillDet;
    drillDet.isNextDrillAllowed = drillDet.isNextDrillAllowed && view.permissions.drilldown;
    ZRSDrillDown.updateBreadCrumbFlow(view);
  }
  
  ZRSDrillDown.clearDrillDet = function(view)
  {
      if(view.drillDet)
      {
        view.drillDet.drillLevel=0;
        ZRSDrillDown.hideOrRemoveDrillFlow(view, view.drillDet.drillLevel);
      }
      view.zrsDrillObj = null;
      if(view.drillDownFlow)
      {
    	  view.drillDownFlow.style.display = "none";
      }
  }
  
  ZRSDrillDown.switchPrevDrillLevel = function(el,ev)
  {
     var view = ZDBClientUI.getViewObj(el,"view");
     view.drillDet.drillLevel =parseInt(view.drillDet.drillLevel)-1;
     var drillDownFlow = view.drillDownFlow;
	 ZDBUtil.setNamedChildEls(drillDownFlow, drillDownFlow, "drillEl");
     jQuery(drillDownFlow.bcArea).children("span:last").remove(); //NO I18N
     new ZRSDrillDown(null, view,"BREADCRUMB",view.drillDet.drillLevel); //NO I18N
     ZRSDrillDown.hideOrRemoveDrillFlow(view, view.drillDet.drillLevel, true);
     if(view.graphSelected == "PIE") 
     {
//        ZRSDrillDown.emptyLegendFilterCriteria(view);
     }
     view.refreshView();
  }
  
  ZRSDrillDown.drillWithBreadCrumb = function(el,ev)
  {
    var view = ZDBClientUI.getViewObj(el,"view");
    if(view.drillDet.drillLevel==el.getAttribute("drillLevel"))
    {
      return;
    }
    view.drillDet.drillLevel=el.getAttribute("drillLevel");
    var dispVal = el.getAttribute("value");
    new ZRSDrillDown(null, view,"BREADCRUMB",view.drillDet.drillLevel,dispVal); //NO I18N
    ZRSDrillDown.hideOrRemoveDrillFlow(view, view.drillDet.drillLevel);
    if(view.graphSelected == "PIE") {
//        ZRSDrillDown.emptyLegendFilterCriteria(view);
    }
    view.refreshView();
    ZRSDrillDown.disableSettings(view);
  }
  
  ZRSDrillDown.disableSettings = function(view)
  {
      var enableSettings = true;
      if(view.zrsDrillObj.drillLevel > 0) {
          enableSettings = false;
      }
      ZDBMenu.editCSSClass($("ZDBANAL_SETTING_TIP"), "disabledonnotsaved", enableSettings); //No I18N
  }

  ZRSDrillDown.hideOrRemoveDrillFlow = function(view,drillLvl, dontRemove)
  {
	var drillDownFlow = view.drillDownFlow;
	ZDBUtil.setNamedChildEls(drillDownFlow, drillDownFlow, "drillEl");
    var bcArea = drillDownFlow.bcArea;
    var drillPths = jQuery(bcArea).children("span"); //NO I18N
    if(drillPths.length <=1 || drillLvl<1)
    {
    	if(!dontRemove)
		{
    		ZDBUtil.removeAllUnwanted(bcArea, "span"); //No I18N
		}
    	view.drillDownFlow.style.display = "none";
    }
  }
  
  ZRSDrillDown.updateBreadCrumbFlow = function(view)
  {
    var drillBrdCrmbMdl= view.drillBrdCrmbMdl;
    var drillDownFlow = view.drillDownFlow;
    if(!drillBrdCrmbMdl || drillBrdCrmbMdl.length <= 0 )
    {
    	drillDownFlow.style.display = "none";
    	return;
    }
    ZDBUtil.setNamedChildEls(drillDownFlow, drillDownFlow, "drillEl");
    var bcArea = drillDownFlow.bcArea;
    ZDBUtil.removeAllUnwanted(bcArea, "span"); //No I18N
    drillDownFlow.style.visibility = "visible";
    drillDownFlow.style.display = "";
	drillDownFlow.bcAllEl.className = "drilllink";
    for(var i in drillBrdCrmbMdl)
	{
    	if(drillBrdCrmbMdl.hasOwnProperty(i))
		{
    		var bcMdl = drillBrdCrmbMdl[i];
        	var drillLevel = bcMdl.drillLevel;
        	var value = bcMdl.value;
        	var dispVal = bcMdl.dispVal;
        	var newSpanEl = ZDBUtil.getCloneNode(drillDownFlow.bcAllEl);
        	newSpanEl.removeAttribute('elname');
			newSpanEl.removeAttribute('keeptext');
            if(!ZDBGlobal.isMobileDevice)
        	{
            	ZDBUtil.attachEvent(newSpanEl, "mouseover", ZRSDrillDown.showToolTip, false);
            	ZDBUtil.attachEvent(newSpanEl, "mouseout", ZRSDrillDown.hideToolTip, false);
        	}
            newSpanEl.setAttribute("drillLevel", drillLevel);
            newSpanEl.setAttribute("value", value);
            newSpanEl.setAttribute("tip", value);
            dispVal = dispVal.length > 25 ? dispVal.toString().substr(0, 25) + "....." : dispVal;
            newSpanEl.innerHTML = ZDBEscapeUtil.encodeForHtml(dispVal);;
            newSpanEl.className = "drilllink rightArrow";
        	bcArea.appendChild(newSpanEl);
		}
	}
    drillDownFlow.bcClose.style.visibility="visible";
    var lastEl = jQuery(drillDownFlow.bcArea).children("span:last");//NO I18N
    lastEl[0].style.color = "#000";
    lastEl.removeClass("drilllink").addClass("drillPlain"); //NO I18N
  }
  
  ZRSDrillDown.showToolTip = function(event)
  {
	  var srcEl = ZDBUtil.getSourceElement(event);
	  ZDBToolTip.show(srcEl, event);
  }
  
  ZRSDrillDown.hideToolTip = function(event)
  {
	  var srcEl = ZDBUtil.getSourceElement(event);
	  ZDBToolTip.hide(srcEl, event);
  }

  ZRSDrillDown.selectDrillModel = function(el,event)
  {
    var clickedDrillEl = el.clickedDrillEl;
    var srcEl = ZDBUtil.getSourceElement(event);
    var drillFunc = srcEl.getAttribute("func");
    if(!drillFunc)
      {
        return;
      }
    ZDBAnalysisView[drillFunc](event,clickedDrillEl,true);
  };

  ZRSDrillDown.TOP = 1;
  ZRSDrillDown.RIGHT = 2;
  ZRSDrillDown.BOTTOM = 3;
  ZRSDrillDown.LEFT = 4;
  ZRSDrillDown.setDrillMenuPos = function(menu, event, menuContainer)
  {
      //Code duplication - to display option similar to Tooltip - can be avoided 
      event = (event) ?  event : window.event;
      var arrow = ZDBUtil.getElWithTagNAttrWithVal(menu, "id", "DRILLMENUARROW", "div"); //No I18N
      var arrow2 =  ZDBUtil.getElWithTagNAttrWithVal(menu, "id", "DRILLMENUARROW2", "div"); //No I18N
      arrow.style.borderColor = "transparent"; //No I18N

      var posInfo = ZRSDrillDown.getPositionInfo(menu, event, menuContainer);
      var view = menu.clickedDrillEl.view;
      var chartObj = view.chartObj;
      var src =ZDBUtil.getSourceElement(event);
      var fill = src.style.fill;
      var borderColor = chartObj ? ((chartObj.seriesIdx !== null ) ? chartObj.getColor(chartObj.seriesIdx) : fill) : ToolTip.legendColor;
      var nxtdrillChartColour  = chartObj  && (chartObj.seriesIdx !== null ) ? chartObj.getColor(chartObj.seriesIdx) : null ; 
      var legModelchck = chartObj.getLegendModel() ? !(chartObj.getLegendModel() instanceof ZCPieLegendModel) : true  ; 
      

      view.nxtdrillChartColour = legModelchck  ? ( nxtdrillChartColour ? nxtdrillChartColour :(view.chartObj.getColorIdx() === null && view.drillDet.drillLevel > 0 ? view.nxtdrillChartColour:null) ) :null;
      switch(posInfo.arrowBorder)
      {
          case ZRSDrillDown.TOP:
              arrow.style.borderTopColor = borderColor;
              break;
          case ZRSDrillDown.RIGHT:
              arrow.style.borderRightColor = borderColor;
              break;
          case ZRSDrillDown.BOTTOM:
              arrow.style.borderBottomColor = borderColor;
              break;
          case ZRSDrillDown.LEFT:
              arrow.style.borderLeftColor = borderColor;
              break;
      }
      ZRSDrillDown.setMenuArrowClassName(arrow, arrow2, posInfo.arrowStyle);
      var adjLeft = ZDBUtil.getObjLeft(menuContainer);
      var adjTop = ZDBUtil.getObjTop(menuContainer);
	  
      if(ZDBGlobal.IS_MOBILE)
      {
    	  var xChck = event.changedTouches && event.changedTouches[0] ? event.changedTouches[0].pageX : event.pageX ;
    	  var yChck = event.changedTouches && event.changedTouches[0] ? event.changedTouches[0].pageY : event.pageY ;
          menu.style.left = xChck - adjLeft + posInfo.adjX + "px"; //No I18N
          menu.style.top = yChck - adjTop + posInfo.adjY + "px"; //No I18N
      }
      else
      {
    	  menu.style.left = event.clientX - adjLeft + posInfo.adjX + "px"; //No I18N
          menu.style.top = event.clientY - adjTop + posInfo.adjY + "px"; //No I18N
      }
      var drillMenu =  ZDBUtil.getElWithTagNAttrWithVal(menu, "id", "DRILLMENU", "div"); //No I18N//No I18N
      drillMenu.style.border = "2px solid " + borderColor;
  };

  ZRSDrillDown.setMenuArrowClassName = function(arrow1, arrow2, className)
  {
       arrow1.className = className + "before";
       arrow2.className = className + "after";
  };

  ZRSDrillDown.getPositionInfo = function(menu, event, menuContainer)
  {
      var offset = 10;
      var adjLeft = ZDBUtil.getObjLeft(menuContainer);
      var adjTop = ZDBUtil.getObjTop(menuContainer);
      var xChck = event.changedTouches && event.changedTouches[0] ? event.changedTouches[0].pageX : event.pageX ;
	  var yChck = event.changedTouches && event.changedTouches[0] ? event.changedTouches[0].pageY : event.pageY ;
      var clientX = ZDBGlobal.IS_MOBILE ? xChck - adjLeft : event.clientX - adjLeft;
      var clientY = ZDBGlobal.IS_MOBILE ? yChck - adjTop :event.clientY - adjTop;
      var menuWidth = menu.offsetWidth, menuHeight = menu.offsetHeight;
      var halfWidth = menuWidth / 2, halfHeight = menuHeight / 2;
      var adjustX = -halfWidth, adjustY = -(menuHeight + offset);
      var screenWidth = menuContainer.offsetWidth;
      var arrowBorder = ZRSDrillDown.TOP, arrowStyle = "";
      var info = clientX + menuWidth + 15;
      if(clientY > menuHeight && (clientX + halfWidth + offset) < screenWidth)
      {
          arrowStyle = "TooltipBottomArrow"; //No I18N
      }
      else if(clientY < (halfHeight - offset))
      {  // top gets hidden. show at bottom
          if((clientX + halfWidth + offset) >= screenWidth)
          { // touches the right. show at left side. tool tip will be hidden on top for this case.
              adjustX = -(menuWidth + offset);
              adjustY = -halfHeight;
              arrowBorder = ZRSDrillDown.LEFT;
              arrowStyle = "TooltipRightArrow"; //No I18N
          }
          else
          {
              adjustX = -halfWidth + offset;
              adjustY = 30;
              arrowBorder = ZRSDrillDown.BOTTOM;
              arrowStyle = "TooltipTopArrow"; //No I18N
          }
      }
      else if((clientX + menuWidth + 15) >= screenWidth)
      { // touches the right. show at left side
          adjustX = -(menuWidth + offset);
          adjustY = -halfHeight;
          arrowBorder = ZRSDrillDown.LEFT;
          arrowStyle = "TooltipRightArrow"; //No I18N
      }
      else
      {
          adjustX = 15;
          adjustY = -halfHeight;
          arrowBorder = ZRSDrillDown.RIGHT;
          arrowStyle = "TooltipLeftArrow"; //No I18N
      }
      return {adjX:adjustX, adjY:adjustY, arrowBorder:arrowBorder, arrowStyle:arrowStyle};
  }

  ZRSDrillDown.showmoreTables = function(refColList,el,event)
  {
      ZDBUtil.setNamedChildEls(refColList,refColList);
      var refColUi = jQuery(refColList.refColUi);
      var drillList = refColList.refColFunList;
      var screenHeight = document.body.offsetHeight;
      var maxListHt = screenHeight * 0.40;
      var availHt = screenHeight - ZDBUtil.getObjTop(refColList) - 15;
      if(availHt > maxListHt) {
          availHt = maxListHt;
      }
      MenuUtil.slideDown(refColUi.children(), 250, function() {
          if(drillList.offsetHeight > availHt)
          {
              drillList.style.height = availHt + "px";
              drillList.style.overflowX = "hidden"; //No I18N
              drillList.style.overflowY = "auto"; //No I18N
              drillList.style.webkitOverflowScrolling = 'touch'; //No I18N
          }
      });
      jQuery(el).hide();
  }
  
  