//$Id$
var CommAPI = new function(){
  this.DATASHEETURL = ZDBGlobal.CTX + "/ZDBTableGrid.ve?";
  this.DESIGNURL=ZDBGlobal.CTX + "/ZDBTableDesignView.ve?";
  this.REORDERCOLURL=ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=UPDATECOLUMNUIDETAIL";
  this.RESIZECOLURL=ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=RESIZECOLUMN";
  this.SHOWFKCOLSURL = ZDBGlobal.CTX + "/ZDBFKComboMI.ma?"; //NO I18N
  this.ALLOWEDVALURL = ZDBGlobal.CTX + "/ZDBTableDataAction.ma?";                          
  this.SHOWHIDECOLURL = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=UPDATECOLUMNUIDETAIL";
  this.UPDATECOLUMNUIDETAIL = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=UPDATECOLUMNUIDETAIL";
  this.UPDATETHEMEDETAILS = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=UPDATETHEMEDETAILS"; //NO I18N
  this.DELETETHEMEDETAILS = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=DELETETHEMEDETAILS"; //NO I18N
  this.UPDATEVUDCOLDET = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=UPDATEVUDCOLDET"; //NO I18N
  this.FETCHDRILLCOMBOLIST = ZDBGlobal.CTX + "/ZDBDrillDownFetch.cc?"; //NO I18N
  this.FETCHDRILLFLOW = ZDBGlobal.CTX + "/ZDBDrillFlowFetch.ma?ZDBACTION=FETCHDRILLFLOW"; //NO I18N
  this.RESETDRILLFLOW = ZDBGlobal.CTX + "/ZDBDrillFlowFetch.ma?ZDBACTION=RESETDRILLFLOW"; //NO I18N
  this.FORMATDRILLFLOW = ZDBGlobal.CTX + "/ZDBDrillFlowFetch.ma?ZDBACTION=FORMATDRILLFLOW"; //NO I18N
  this.VALNUPDATEDRILLDET = ZDBGlobal.CTX + "/ZDBValidateNUpdateDrillDet.ve?"; //NO I18N
  
  this.genXMLForModData = function(rowData,dataGrid,newRowIndex)
  {   
    var validData = true;
    var xmlStr = "";
    var rowLen = rowData.length;
    var row, validRow, dataVals, curHead, data, value;
    for(var i = 0; i < rowLen; i++)
    {
      row = rowData[i];
      if((row.sentStatus) || (row.objType != ZDBConst.DATA)|| ((i >= newRowIndex) && (row.status == ZDBConst.DELETED)))
      {
    	  continue;
      }
      if(dataGrid.cellObj != undefined && row.rDisp == dataGrid.cellObj.rowObj.rDisp)		// avoid sending the formula column details if name of the column entered in deisgn grid
      {		
    	  continue;		
      }
      xmlStr += "\n<T "; 
      dataVals = row.values;
      validRow = true;
      for(var j =0; j < dataVals.length;j++)
      {
        data = dataVals[j];
        curHead = data.colObj;
        if(curHead.objType != ZDBConst.COLHEAD)
        {
          continue;
        }        
        if((row.status != ZDBConst.DELETED) && !data.validate())
        {
          validRow = false;
          continue;
        }
        if(((row.status != ZDBConst.DELETED) &&  (data.isModified())) 
           || curHead.isPK)
        {
          value = data.getValue();
          if(curHead.colName == "DATATYPE" && (value == ZDBDesignGridConst.REFCOLID.toString() || value == ZDBDesignGridConst.RELCOLID.toString()))
          {
        	  var refColValue = row.values[dataGrid.getColumnIndex("REFERREDCOLUMN")];
        	  xmlStr += " REFERREDCOLUMN=\"" + ZDBEscapeUtil.encodeForXML(refColValue.getValue()) + "\"";  //No I18N
          }
          else
          {
              xmlStr += " " + curHead.colName + "=\"" + ZDBEscapeUtil.encodeForXML(value) + "\"";  
          }
          if(curHead.colName == "DATATYPE" && (value == ZDBConst.GEO.toString()||value == ZDBConst.GEO_NUM.toString()))
          {              
              var geoRole = data.rowObj.values[data.rowObj.parGrid.getColumnIndex("GEOOPT")].originalValue;
                xmlStr +=" GEOROLE=\""+geoRole+"\""; //No I18N
          }
          if(curHead.colName == "REFERREDCOLUMNOPT")
          {
            xmlStr += " FKCONSTRAINT=\"" + data.fkConstraint + "\""; //No I18N
          }
        }
      }
      xmlStr += " ___oper=\"" + row.status + "\"/>";
      //$$ We might need to add support for rowid - multi column editable pk stuff!!
      if(validRow && (dataGrid.validateRowFunc != null))
      {
        validRow = dataGrid.validateRowFunc(row);
      }
      validData = (validData) && (validRow);      
    }

    if(validData)
    {
      var colHeaders = dataGrid.colHeaders;
      var colLen = colHeaders.length;
      for(var i =0; i < colLen; i++)
      {
        curHead = colHeaders[i]; 
        if(curHead.objType == ZDBConst.COLHEAD && curHead.validateColFunc != null)
        {
          validData = (validData) && curHead.validateColFunc(curHead);
        }
      }
    }
    if((xmlStr != "") && (validData))
    {
      xmlStr = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + 
               "' tablename=\"" + dataGrid.tableName + "\">" + xmlStr + 
               dataGrid.getSimpleFilter(true) + "</data>";
      for(var i =0; i < rowData.length; i++)
      {
        rowData[i].sentStatus = 1;
      }
    }
    return (validData)? xmlStr:null;
  }


  this.sendModData = function (dataGrid,url,requestOptions)
  {
    this.sendModData(dataGrid,url,requestOptions,false);
  }

  this.sendModData = function (dataGrid,url,requestOptions,skipFCCheck)
  {
    var initialURL = url;
    var skipFC = (skipFCCheck != null && skipFCCheck);
    var rowData = dataGrid.rowsToUpdate.concat(dataGrid.newRows);
    var xmlData = this.genXMLForModData(rowData,dataGrid,dataGrid.rowsToUpdate.length);
    if(xmlData == null)
    {
      var errorCells = dataGrid.getTableErrorInfo();
      if(errorCells.length != 0)
      {
        ZDBMsgBox.showErrorIfNeeded(errorCells[0]);
        var msg = ZDBI18NMap.f("zrpt.common.tbleditdesign.zdbalertmsg.js.fixErrBeforeSave",errorCells.length);
        for(var j=0;j<errorCells.length;++j)
        {
            if(errorCells[j].colObj.visible == false)
            {
                msg += "<BR>"+ZDBI18NMap.g("zrpt.common.tbleditdesign.zdbalertmsg.js.fixErrBeforeSaveNote");
                break;
            }
        }
        ZDBAlertAPI.showMsg(msg);
        return;
      }
 
      //$$ Not handling the row level errors!!
      return;
    }
    
    url = url + "&" + dataGrid.getGridDetailsAsParams();
    url += "&" + dataGrid.getNavDetails(false,true) + "&REFRESHDATAONLY=true&SKIPFILTERCRITERIACHECK="+skipFC;            // No I18N
    if(xmlData == "") 
    { 
        dataGrid.clearModified();
        return;
    }
    var loadDiv = dataGrid.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.tbleditdesign.loadingdiv.js.savingModifications"));
    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},
                       OPSTATUSID:loadDiv, ONSUCCESSFUNC: this.handleSaveResp,
                       SENTID:dataGrid.modified,SENTROWS: rowData,GRIDOBJ:dataGrid,
                       REFRESHEXPLORER:(ZDBUtil.isNewView(dataGrid)),
                       ONFAILUREFUNC:this.handleFailure,ORIGREQOPTIONS:requestOptions,PREVIOUSURL:initialURL};
    AjaxAPI.sendRequest(ajaxOptions);
    dataGrid.sent = dataGrid.modified;
  }

  
  this.continueSendModData = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      return;
    }
    var dataGrid = requestOptions["GRIDOBJ"];
    var url = requestOptions["URLTOSEND"];
    var reqOpts = requestOptions["ORIGREQOPTIONS"];
    CommAPI.sendModData(dataGrid,url,reqOpts,true);
  }

  this.handleFailure = function(response,requestOptions)
  {
    ZDBCreateViewAPI.handleViewSaveFailure(response,requestOptions);
    var gridObj = requestOptions["GRIDOBJ"];
    gridObj.sent =0;
    var sentRows = requestOptions["SENTROWS"];
    if(sentRows == null)
    {
      return;
    }
    for(var i =0; i < sentRows.length; i++)
    {
      sentRows[i].sentStatus = 0;
    }
  }



  this.handleSaveResp = function(response,requestOptions)
  {
    var gridObj = requestOptions["GRIDOBJ"];
    gridObj.update(requestOptions);
    ZDBDataGrid.parseGridResponse(gridObj,response.responseText);
    if(requestOptions["ORIGREQOPTIONS"] != null)
    {
      requestOptions["ORIGREQOPTIONS"]["HANDLESAVE"](requestOptions["ORIGREQOPTIONS"]);
    }    
    if(requestOptions["REFRESHEXPLORER"])
    {
      ZDBNavigation.refreshExplorer();
    }
    if(gridObj.type != "PivotSheet" && gridObj.type != "SummarySheet") // temporary check for pivot and summary 
	{
    	if(BROWSER.SAFARI == 1) //  to fix safari issue , safari current version only computes table layout fixed after this
  	  {
    		ZDBUtil.removeAndInsertJsObj(gridObj);
  	  }
      if(!gridObj.freeze || gridObj.readOnly) 
	  {
         gridObj.maintainWidthArray(gridObj.colHead);
         if(gridObj.freeze)
  	     {
  	        gridObj.setFreezeIcon();
  	     }
	  }
      if (gridObj.totalRecords < gridObj.dTable.children.length) 
	  {// this is because in table there will be an extra input row and a filler row
		gridObj.setFillerHeight();
	  } 
      else {
		gridObj.adjustInViewRowsHeight();
	   }
    }
    var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
    if(lastFocusCell)
    {
      gridObj.setCellFocus(lastFocusCell,gridObj);
    }
  }


}
