//$Id: $

ZDBDataGrid.prototype.getRowIndex = function(row)
{
return ZDBUtil.indexOf(this.rowData,row);
}

ZDBDataGrid.prototype.setSecurityDetails = function(permLevel,grpShared,isPublic , isSystemTable,enableSysTabMenu,isSyncStatusApplicable)
{
  ZDBClientViewAPI.setSecurityDetails(this, permLevel, grpShared, isPublic , isSystemTable,enableSysTabMenu,isSyncStatusApplicable);
}

ZDBDataGrid.prototype.getColIndexForDispName = function(colDispName)
{
  var colHeaders = this.colHeaders;
  for(var i =0;i < colHeaders.length;i++)
  {
    if(colHeaders[i].displayName == colDispName)
    {
      return i;
    }
  }
  return -1;
}

ZDBDataGrid.prototype.deleteSelectedRows = function()
{
  var selectedRows = [];
  if(this.selectedRows.length > 0)
  {
    selectedRows = this.selectedRows;
  }
  else
  {
    var cellObj = ZDBDataGrid.getCurrentCell(this);
    if(!cellObj)
    {
      return;
    }
    selectedRows.push(cellObj.rowObj);
  }
  this.scrollUp = false; // ON DELETE ALWAYS ADD NEW ROW AT THE BOTTOM, SCROLL DIRECTION IS RESET
  var selLen = selectedRows.length;
  var indices = this.deleteRows(selectedRows);
  var firstRowIndex = indices[0];
  var lastRowIndex = indices[1];
  if(firstRowIndex == -1 || lastRowIndex == -1)
  {
    return;
  }
  this.setDataModified();
  this.maintainRowCount();
  this.adjustRowFill();
  this.setFirstRowWidth();
  this.deletedRowCount+=this.selectedRows.length;
  this.selectedRows = [];
  //ZDBUtil.setTimeout(ZDBDataGrid.resetRowHighlight, null, [this, lastRowIndex, selLen], 100);
  ZDBDataGrid.resetRowHighlight(this, lastRowIndex, selLen);
}


ZDBDataGrid.resetRowHighlight = function(gridObj, startIndex, selLength)
{
  var rowData = gridObj.rowData;
  var rowLen = rowData.length;
  var curRow;
  for(var i=startIndex; (i < rowLen) && (i - startIndex < selLength);++i)
  {
    curRow = rowData[i];
    if(curRow.objType == ZDBConst.FILLER || curRow.objType == ZDBConst.DUMMY)
    {
      break;
    }
    gridObj.selectedRows.push(curRow);
  }
  gridObj.selectRow();

}

ZDBDataGrid.prototype.sendClientState = function(fetchUIAlso, requestFor,loadMsg,isModified)
{
  var colHeaders = this.colHeaders;
  var colLen = colHeaders.length;
  var col;
  var params = this.getCompleteGridDetailsAsParams();

  var successFunc = ZDBDataGrid.evalAjaxResponse;
  if(fetchUIAlso)
  {
    successFunc = ZDBTableGrid.placeDataSheet;
  }
  params +="&REFRESHDATAONLY="+ ((!fetchUIAlso)? "true":"false")+"&CLEARCACHEANDROWS=true"; //No I18N
  if(requestFor)
  {
    params += "&REQUESTFOR=" + requestFor; //No I18N
  }
  if(requestFor && (requestFor == 'REORDERCOLUMN' || requestFor == 'SHOWHIDECOLUMN'))
  {
    successFunc = null;
  }  
  if(this.zaGridType == "VUDSheet")
  {
      var url = CommAPI.UPDATEVUDCOLDET;
      params += "&VUDPARENTID=" + this.parentViewId; //NO I18N
  }
  else
  {
      var url = CommAPI.UPDATECOLUMNUIDETAIL;
      if(!this.canSaveUIChanges())
      {
          url = "/ZDBTableDataAction.ma?ZDBACTION=DATAVIEW"; //No I18N
      }
  }
  

  if(this.viewCtx.dashView) // Should send dashboard UF details also when it is in the dashboard
  {
    var xml = "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n";//No I18N
    var sendCompleteInfo = (this.viewCtx.dashView.permissions.designModify == 1&& ZDBUtil.isViewModified(this.viewCtx.dashView))
    var dashDynFltrConfig = ZDBDashboardUF.getDashDynFltrConfig(this.viewCtx);
    
    var xmlBuf = new ZDBStrBuf();
    xmlBuf.a("<dcdet") //NO I18N
      .attr("cinfo",sendCompleteInfo) // NO I18N
      .a(">\n"); // NO I18N
    xmlBuf.a(dashDynFltrConfig);
    xmlBuf.a("</dcdet>");    // No I18N
    xml += xmlBuf.toString();
    xml+="</DBSVRequest>"//No I18N
    params += "&CONFIGASXML=true";   // No I18N
    url += params
    AjaxAPI.sendRequest({URL:url,
                             POSTBODY:xml,
                             REQUESTHEADERS:{"Content-type":"text/xml"},    // No I18N
                             ISMODIFIED:isModified,
                             GRIDOBJ:this,
                             GRIDUIMOD:true,
                             ONSUCCESSFUNC:successFunc,
                             VIEWCTX:this.viewCtx,
                             OPSTATUSID:this.viewCtx.getLoadIndicator(loadMsg)});
  }
  else
  {

    AjaxAPI.sendRequest({URL: url,
                              PARAMETERS:params,
                              METHOD:"POST", //No I18N
                              ISMODIFIED:isModified,
                              GRIDOBJ:this,
                              GRIDUIMOD:true,
                              ONSUCCESSFUNC:successFunc,
                              VIEWCTX:this.viewCtx,
                              OPSTATUSID:this.viewCtx.getLoadIndicator(loadMsg)});
  }
}

ZDBDataGrid.prototype.sendAndUpdateClientState = function(fetchUIAlso, requestFor,isVUD){
	
	var colHeaders = this.colHeaders;
	var isModified = null;
	var loadMsg = null;
	  var colLen = colHeaders.length;
	  var col;
	  var params = this.getGridDetailsAsParamsNoColheaders();
	  var successFunc = ZDBDataGrid.evalAjaxResponse;
	  var isVUD = isVUD;
	  if(fetchUIAlso)
	  {
	    successFunc = ZDBTableGrid.placeDataSheet;
	  }
	  params +="&REFRESHDATAONLY="+ ((!fetchUIAlso)? "true":"false")+"&CLEARCACHEANDROWS=true"; //No I18N
	  if(requestFor)
	  {
	    params += "&REQUESTFOR=" + requestFor; //No I18N
	  }
	  if(requestFor && (requestFor == 'REORDERCOLUMN' || requestFor == 'SHOWHIDECOLUMN'))
	  {
	    successFunc = null;
	  }  
	  if(this.zaGridType == "VUDSheet")
	  {
	      var url = CommAPI.UPDATEVUDCOLDET;
	      params += "&VUDPARENTID=" + this.parentViewId; //NO I18N
	  }
	  else
	  {
	      var url = CommAPI.UPDATECOLUMNUIDETAIL;
	      if(!this.canSaveUIChanges())
	      {
	          url = "/ZDBTableDataAction.ma?ZDBACTION=DATAVIEW"; //No I18N
	      }
	  }
	  

	  
	  

	    AjaxAPI.sendRequest({URL: url,
	                              PARAMETERS:params,
	                              METHOD:"POST", //No I18N
	                              ISMODIFIED:isModified,
	                              ISVUD: isVUD,
	                              GRIDOBJ:this,
	                              GRIDUIMOD:true,
	                              ONSUCCESSFUNC:this.refreshSheet,
	                              VIEWCTX:this.viewCtx,
	                             // OPSTATUSID:this.viewCtx.getLoadIndicator(loadMsg)
	                            });
	  
}

ZDBDataGrid.prototype.refreshSheet = function(req,response){
	  var isVUD = response["ISVUD"];
	  var grid = response["GRIDOBJ"];
	  ZDBTableGrid.refreshDataForView(grid);
	}

ZDBDataGrid.prototype.canSaveUIChanges = function()
{
    return (this.zaGridType == "VUDSheet") ? true : !(ZDBUtil.isNewView(this) || this.noUIUpdations || this.noUISave|| !this.permissions.designModify); //NO I18N
}

ZDBDataGrid.prototype.deleteRows = function(rowsToDelete)
{

  var len = rowsToDelete.length;
  var rowData = this.rowData;
  var rowObj, rowIndex, firstRowIndex = -1, lastRowIndex = -1, atleastOneDeleted = false;
  if(this.readOnly || len == 0) { return [firstRowIndex, lastRowIndex];}
  for(var i=0;i<len;++i)
  {
    rowObj = rowsToDelete[i];
    if(rowObj.objType == ZDBConst.DUMMY)
    {
      continue;
    }
    rowIndex = this.getRowIndex(rowsToDelete[i]);
    if(firstRowIndex < 0 || firstRowIndex < rowIndex)
    {
      firstRowIndex = rowIndex;
    }
    if(lastRowIndex < 0 || lastRowIndex > rowIndex)
    {
      lastRowIndex = rowIndex;
    }
    rowData.splice(rowIndex,1);
    if(rowObj.status == ZDBConst.CLEAR)
    {
      this.rowsToUpdate.push(rowObj);
    }
    rowObj.status = ZDBConst.DELETED;
    this.domCache.addDOMElsToCache(rowObj,true);
    if(atleastOneDeleted == false)
    {
      atleastOneDeleted = true;
    }
  }
  if(atleastOneDeleted)
  {
    this.deletedCount += len;
    this.updateTotalCountUI();
  }
  return [firstRowIndex, lastRowIndex];
}


ZDBDataGrid.prototype.focusFirstCell = function()
{
  var gridObj = this;
  var rowData = gridObj.rowData;
  var dataRow = row = ZDBDataGrid.getFirstRowObj(rowData, true);
  if(!dataRow)
  {
    return; ///PK: no rows in readonly view?
  }
  var cellObjs = dataRow.values;
  var cellObj = ZDBDataGrid.getDataCell(cellObjs, true, false);
  if(cellObj)
  {
    gridObj.setCurrentCell(cellObj);
  }

}

ZDBDataGrid.prototype.getTableLastCell = function()
{
  var lastDataRow = ZDBDataGrid.getLastRowObj(this.rowData, true);
  return lastDataRow ? ZDBDataGrid.getRowLastVisibleCell(lastDataRow, 'object', false) : null; //No I18N
}



ZDBDataGrid.prototype.focusRowFirstCell = function(rowIndex)
{
  var rowObj = this.rowData[rowIndex];
  var cellObj = ZDBDataGrid.getDataCell(rowObj.values, true, false);
  this.setCurrentCell(cellObj);
  //this.setHighlightRowCol(cellObj,true);
}

ZDBDataGrid.prototype.focusRowLastCell = function(rowIndex)
{
  var rowObj = this.rowData[rowIndex];
  var cellObj = ZDBDataGrid.getRowLastVisibleCell(rowObj, 'object', false);
  this.setCurrentCell(cellObj);
  this.setHighlightRowCol(cellObj,true);
}


ZDBDataGrid.getRowLastVisibleCell = function(rowObj, objOrIndex, includeNonData)
{
 var values = rowObj.values;
 var valLen = values.length;
 var curObj, colObj;
 for(var i=valLen-1;i>=0;--i)
 {
   curObj = values[i];
   colObj = curObj.colObj;
   if(!colObj.visible)
   {
       continue;
   }
   if(includeNonData == false && colObj.objType != ZDBConst.COLHEAD)
   {
    continue;
   }
   return objOrIndex == 'object' ? curObj : i;//No I18N
 }

}


ZDBDataGrid.prototype.getCellAt = function(rowIndex,colIndex)
{
  return this.getCell(rowIndex, colIndex);
}

ZDBDataGrid.prototype.setValueAt = function(rowIndex,colIndex,newValue)
{
  this.getCellAt(rowIndex,colIndex).setValue(newValue, null, false, false);
}
ZDBDataGrid.prototype.setAsReadOnly = function()
{
  this.focusFirstCell = ZDBUtil.dummyFunc;
  this.setCellEditable = ZDBUtil.dummyFunc;
  this.addDummyRow = ZDBUtil.dummyFunc;
  this.addRowSupported = false;
  this.readOnly = true;
}
//useFilterParams should be passed as true, only when params are used in POST
ZDBDataGrid.prototype.getGridDetailsAsParams = function()
{
  var params ="&GRIDID=" + this.ID //No I18N
              +"&OBJTYPE="+ (this.isAnalysis ? "AnalysisGrid" : this.type); //No I18N

  if(this.objId != null && this.objId > 0)
  {
    params += "&OBJID=" + this.objId; //No I18N
  }
  else if(this.parentViewId != null)
  {
    params += "&PARENTVIEWID=" + this.parentViewId; //No I18N
  }
  else
  {
    params += "&DBID=" + this.dbId; //No I18N
  }

  if(this.objId < 0)
  {//This fix is for UPDATECONFIG option. Needed for unsaved views.
    params +="&OBJID=" + this.objId; //No I18N
  }

  if(this.designModTime != null)
  {
    params += "&DDLTIME=" + this.designModTime; //No I18N
  }
  params += this.viewCtx.getAdditionalParams();
  if(this.directFilterStr != null)
  {
    params += "&ZDBFILTERVALUE=" + this.directFilterStr; //No I18N
  }
  if(this.isFilter && this.isFilter == true)
  {
    params += "&ZDBSEARCHVALUE=" + this.searchValue; //No I18N
  }

  return params;
}


ZDBDataGrid.prototype.getCompleteGridDetailsAsParams = function()
{
  return this.getGridDetailsAsParams() + this.getSimpleFilter(false) + "&" + this.getColDetail();
}

ZDBDataGrid.prototype.getGridDetailsAsParamsNoColheaders = function(){
	  
	  return this.getGridDetailsAsParams() + this.getSimpleFilter(false) + "&" + this.getColDetailWhenNoColheaders();
	}

ZDBDataGrid.prototype.getColDetailWhenNoColheaders = function(asAttribVal){
    var propsToSend = ["colId","colPos","visible","width","freeze","sortOrder","sortIndex","grouped","section"]; //No I18N
    var propMap = [0,11,12,10,null,14,15,16,21];
    var propParam = [];
    var propLen = propsToSend.length;
    var colDetailStr = propsToSend.join(";").toUpperCase();
    var prop;
    var colHeaders = this.allColHead;
    var colLen = colHeaders.length;

 for(var i= 0; i < colLen;i++)
 {
   col = colHeaders[i];
   // if(col.objType !== ZDBConst.COLHEAD)
   // {
   //   continue;
   // }
   colDetailStr += "\n"; //No I18N
   for(var k =0; k < propLen; k++)
   {
     var prop = propsToSend[k];
     var propUp = prop.toUpperCase();
     if(propParam[propUp] === undefined)
     {
       propParam[propUp] = [];
     }

     if(prop == 'colPos')
     {
       prop = 'cellPos'; //No I18N
     }

     if(col[prop] !== undefined || col[prop] !== null)
     {
       if(prop === "width")
         {
         //propParam[propUp].push(Math.round(col[propMap[k]]*12/this.getFontSize()));
         propParam[propUp].push(Math.round(col[propMap[k]]*ZDBGlobal.defaultFontsize/this.getFontSize()));
         }
       else if(prop === "freeze"){
         propParam[propUp].push(false);  
       }
       else
         {
       propParam[propUp].push(col[propMap[k]]);
         }
     }
   }
 }

 var colDetailStr = "";
 for(var k=0;k<propLen;++k)
 {
   var propUp = propsToSend[k].toUpperCase();
   colDetailStr += ZDBUtil.getParam(propUp,propParam[propUp].join(";"),asAttribVal);
 }
 if(this.getFunctionDetails)
 {
   colDetailStr += this.getFunctionDetails(asAttribVal);
 }
 var objId = this.objId;
 if(objId == null){objId = "-1";}
 colDetailStr += ZDBUtil.getParam("UPDATECONFIG",objId,asAttribVal); //No I18N
 return colDetailStr;
}

ZDBDataGrid.prototype.getColDetail = function(asAttribVal)
{
  var propsToSend = ["colId","colPos","visible","width","freeze","sortOrder","sortIndex","grouped","section"]; //No I18N
  var propParam = [];
  var propLen  = propsToSend.length;
  var colDetailStr = propsToSend.join(";").toUpperCase();
  var prop;
  var colHeaders = this.colHeaders;
  var colLen = colHeaders.length;

  for(var i= 0; i < colLen;i++)
  {
    col = colHeaders[i];
    if(col.objType !== ZDBConst.COLHEAD)
    {
      continue;
    }
    colDetailStr += "\n"; //No I18N
    for(var k =0; k < propLen; k++)
    {
      var prop = propsToSend[k];
      var propUp = prop.toUpperCase();
      if(propParam[propUp] === undefined)
      {
        propParam[propUp] = [];
      }

      if(prop == 'colPos')
      {
        prop = 'cellPos'; //No I18N
      }

      if(col[prop] !== undefined || col[prop] !== null)
      {
    	  if(prop === "width")
    		  {
    		  propParam[propUp].push(Math.round(col[prop]*ZDBGlobal.defaultFontsize/this.getFontSize()));
    		  }
    	  else
    		  {
        propParam[propUp].push(col[prop]);
    		  }
      }
    }
  }
  var colDetailStr = "";
  for(var k=0;k<propLen;++k)
  {
    var propUp = propsToSend[k].toUpperCase();
    colDetailStr += ZDBUtil.getParam(propUp,propParam[propUp].join(";"),asAttribVal);
  }
  if(this.getFunctionDetails)
  {
    colDetailStr += this.getFunctionDetails(asAttribVal);
  }
  var objId = this.objId;
  if(objId == null){objId = "-1";}
  colDetailStr += ZDBUtil.getParam("UPDATECONFIG",objId,asAttribVal); //No I18N
  return colDetailStr;
}


ZDBDataGrid.mouseoverHighlight = function(curObj, enable, isMouseOut)
{
  var prevCellObj = ZDBEvents.mouseoverObj;
  if(prevCellObj)
  {
    var rowObj = prevCellObj.rowObj;
    if(isMouseOut)
    {
      ZDBEvents.mouseoverObj = null;
      if((rowObj.parGrid.type == "TableDesign") && (rowObj.objType == ZDBConst.DATA))
      {
      var rowHeaderCellObj = ZDBDataGrid.getRowHeaderCellObj(rowObj);
      if(rowObj.rDisp != null)
      {
        rowHeaderCellObj.cellEl.appendChild(rowObj.rIdEl);
        rowObj.setRID(null,rowObj.rDisp);
      }
      else
      {
        rowHeaderCellObj.cellEl.innerHTML = rowHeaderCellObj.displayValue;
      }
      }
    }
    if((enable || isMouseOut) && curObj && (rowObj == curObj.rowObj))
    {
      ZDBDataGrid.highlight_MO(rowObj, false);
      return;
    }
  }
  if(!curObj)
  {
    return;
  }

  var rowObj = curObj.rowObj;
  var gridObj = rowObj.parGrid;
  if(gridObj.mouseoverDisabled)
  {
    return;
  }
  if(enable)
  {
    ZDBEvents.mouseoverObj = curObj;
  }

  ZDBDataGrid.highlight_MO(rowObj, enable);
}

ZDBDataGrid.highlight_MO = function(rowObj, enable)
{

  var gridObj = rowObj.parGrid;
  if(!gridObj || rowObj.objType == ZDBConst.FILLER || rowObj.objType == ZDBConst.DUMMY)
  {
    //!gridObj issue
    return;
  }
  var cellObjs = rowObj.values;
  var cellObjsLen = cellObjs.length;
  var curCellObj;
  var cellEl;
  if(enable && (rowObj.parGrid.type == "TableDesign") && (rowObj.objType == ZDBConst.DATA))
  {
    var rowHeaderCellObj = ZDBDataGrid.getRowHeaderCellObj(rowObj);
    rowHeaderCellObj.cellEl.innerHTML = "";
  }
  for(var i=0;i<cellObjsLen;++i)
  {
    curCellObj = cellObjs[i];
    cellEl = curCellObj.cellEl;
    if(!cellEl)
    {
      continue;
    }
    if(curCellObj.hiddenDispValue)
    {
      curCellObj.displayNode.style.display = enable ? "inline" : "none";
    }
    cellEl = curCellObj.cellEl;
    if(enable)
    {
      cellEl.className = cellEl.className.replace(' zdbMouseOver','');
      cellEl.className += " zdbMouseOver";
    }
    else
    {
      cellEl.className = cellEl.className.replace(' zdbMouseOver','');
    }
  }
}

ZDBDataGrid.prototype.setGroupDataForHighlight = function(rowObj, isSet)
{
  isSet = isSet & rowObj.isMouseOver;
  var dataObjs = this.rowData[rowIndex].values;
  var dataLen = dataObjs.length;
  var curClassName;
  for(var i=0;i<dataLen;++i)
  {
    var curDataObj = dataObjs[i];
    if(curDataObj.hiddenDispValue)
    {
      curDataObj.setOnDataEl((isSet ? curDataObj.hiddenDispValue : ""));
    }
  }

}




ZDBDataGrid.prototype.setRowHighLight = function(enable)
{
  ZDBUtil.clearTextSelection();
  this.rowHeadFocus = true;
  var len = this.selectedRows.length;
  for(var i=0;i<len;++i)
  {
    var selRow = this.selectedRows[i];
    selRow.selected = enable;
    selRow.className = enable ? "zdbRowHeadFocus" : "zdbRowHead";    //No I18N
    var values = selRow.values;
    for(var j=0,k= values.length;j < k;j++)
    {
      values[j].setClass();
    }
  }
  if(!enable)
  {
    this.selectedRows = [];
  }
}
ZDBDataGrid.prototype.setColHighLight = function(enable)
{
  ZDBUtil.clearTextSelection();
  var len = this.selectedCols.length;
  if(len == 0) {return;}
  var headColObj = null;
  for(var i=0;i<len;++i)
  {
    var headColObj = this.selectedCols[i];
    headColObj.selected = enable;
    headColObj.setClass();
    //headColObj.updateCSSLink();
  }
  ZDBDataGrid.invokeLazyly(this,0,10,this.highLightAllCellsForCol,10,5,[this.selectedCols]);
  if(!enable)
  {
    this.selectedCols = [];
  }
  ZDBMenu.setToolbarStatus(this);
}

ZDBDataGrid.prototype.findCellBasedOnLeft = function(cursorLeft)
{
    if(!this.position)
	{
		this.position = ZDBUtil.getObjCoordinates(this.parNode);
	}
    var colHeads = this.colHeaders;
    var colLen = colHeads.length;
    var curLeft = this.position.x - this.dArea.scrollLeft;
    var curHead;
    for(var i=0;i<colLen;++i)
    {
      curHead = colHeads[i];
      if(curHead.visible)
      {
          if(curLeft <= cursorLeft && cursorLeft < (curLeft + curHead.width))
          {
              return curHead;
          }
          curLeft += curHead.width;
      }
    }
    return null; ///PK: consider returning the last cell
}


ZDBDataGrid.prototype.getCellLeft = function(cellObjs, cellPos, nonEmpty)
{
  var rowLen = cellObjs.length;
  if(cellPos == 0)
  {
    return cellObjs[cellPos];
  }

  if(nonEmpty == null){nonEmpty == false;}
  var leftObj;
  var displayValue;
  var colHead;
  for(var i=cellPos-1;i >=0;--i)
  {
    leftObj = cellObjs[i];
    colHead = leftObj.colObj;
    if(!colHead.visible || colHead.objType != ZDBConst.COLHEAD)
    {
      continue;
    }
    displayValue = leftObj.displayValue;
    if((!nonEmpty) || ((displayValue != "") && (displayValue !=  null)))
    {
      return leftObj;
    }
  }
  return cellObjs[cellPos];
}

ZDBDataGrid.prototype.getCellRight = function(cellObjs, cellPos, nonEmpty)
{
  var rowLen = cellObjs.length;
  if(cellPos == rowLen-1)
  {
    return cellObjs[cellPos];
  }

  if(nonEmpty == null){nonEmpty == false;}
  var rightObj;
  var displayValue;
  var colHead;
  for(var i=cellPos+1;i < rowLen;++i)
  {
    rightObj = cellObjs[i];
    colHead = rightObj.colObj;
    if(!colHead.visible || colHead.objType != ZDBConst.COLHEAD)
    {
      continue;
    }
    displayValue = rightObj.displayValue;
    if((!nonEmpty) || ((displayValue != "") && (displayValue !=  null)))
    {
      return rightObj;
    }
  }
  return cellObjs[cellPos];
}

ZDBDataGrid.prototype.getCellUp = function(rowIndex, cellIndex,callBack)
{
  var curCellObj = this.getCellAt(rowIndex, cellIndex);
  var colObj = curCellObj.colObj;
  if(colObj.grouped)
  {
    rowIndex = this.getGroupStartIndex(rowIndex, cellIndex);
  }

  var rowData = this.rowData;
  var upCell = null;

  var curRow = rowData[rowIndex];
  var firstRowIndex = ZDBDataGrid.getFirstRowIndex(rowData, false);
  if((rowIndex <= firstRowIndex) && callBack)
  {
    if(this.addNextRows((rowIndex *-1) + 1,-1,-1,true,callBack) == ZDBScrollConst.NOTINCACHE)
    {
    }
    rowIndex = ZDBUtil.indexOf(rowData, curRow);
  }

  if(rowIndex > firstRowIndex)
  {
    rowIndex -= 1;
  }
  return rowData[rowIndex].values[cellIndex];
}



ZDBDataGrid.prototype.getGroupEndIndex = function(rowIndex,cellIndex)
{
  var cellObj = this.getCellAt(rowIndex, cellIndex);
  var colObj = cellObj.colObj;
  if(!colObj.grouped)
  {
    return rowIndex;
  }
  var rowData = this.rowData;
  var curCellObj, curRow;
  var rowLen = rowData.length;
  while(rowIndex < rowLen)
  {
    curRow = rowData[rowIndex];
    if(curRow.objType == ZDBConst.DUMMY || curRow.objType == ZDBConst.FILLER)
    {
      --rowIndex;
      break;
    }
    curCellObj = this.getCellAt(rowIndex, cellIndex);
    if(curCellObj.groupStatus & ZDBConst.GROUPEND)
    {
      break;
    }
    ++rowIndex;
  }
  return rowIndex;
}


ZDBDataGrid.prototype.getGroupStartIndex = function(rowIndex,cellIndex)
{
  var cellObj = this.getCellAt(rowIndex, cellIndex);
  var colObj = cellObj.colObj;
  if(!colObj.grouped)
  {
    return rowIndex;
  }
  var rowData = this.rowData;
  var curCellObj, curRow;
  while(rowIndex >= 0)
  {
    curRow = rowData[rowIndex];
    if(curRow.objType == ZDBConst.COLHEAD)
    {
      break;
    }
    curCellObj = this.getCellAt(rowIndex, cellIndex);
    if(curCellObj.groupStatus & ZDBConst.GROUPSTART)
    {
      break;
    }
    --rowIndex;
  }
  return rowIndex;
}



ZDBDataGrid.prototype.getCellDown = function(rowIndex, cellIndex,callBack)
{
  var curCellObj = this.getCellAt(rowIndex, cellIndex);
  var colObj = curCellObj.colObj;
  if(colObj.grouped)
  {
    rowIndex = this.getGroupEndIndex(rowIndex, cellIndex);
  }

  var downCell = null;
  var rowData = this.rowData;
  var maxRowIndex = ZDBDataGrid.getLastRowIndex(rowData, true);


  if((rowIndex >= maxRowIndex) && callBack)
  {
    if(this.addNextRows(rowIndex - maxRowIndex + 1,-1,-1,false,callBack) == ZDBScrollConst.NOTINCACHE)
    {
      return null;
    }
    maxRowIndex = ZDBDataGrid.getLastRowIndex(rowData, true);
  }
  if(rowIndex < maxRowIndex)
  {
    rowIndex += 1;
    downCell = rowData[rowIndex].values[cellIndex];
  }
  return downCell;
}



ZDBDataGrid.prototype.getCellNext = function(rowIndex, cellIndex, up, callBack)
{
  var curCellObj = this.rowData[rowIndex].values[cellIndex];
  if(up)
  {
    var nextCellObj = this.getCellLeft(this.rowData[rowIndex].values, cellIndex, false)
  }
  else
  {
    var nextCellObj = this.getCellRight(this.rowData[rowIndex].values, cellIndex, false);
  }
  if(curCellObj != nextCellObj)
  {
    return nextCellObj;
  }

  var colHeaders = this.colHeaders;
  if(up)
  {
    if(rowIndex === ZDBDataGrid.getFirstRowIndex(this.rowData, false))
    {
      return curCellObj;
    }
    var nextCellObj = this.getCellUp(rowIndex, ZDBDataGrid.getVisibleColumn(colHeaders, colHeaders.length-1, false, true), callBack);
  }
  else
  {
    var nextCellObj = this.getCellDown(rowIndex, ZDBDataGrid.getVisibleColumn(colHeaders, 0, true, true), callBack);
  }

  return (curCellObj == nextCellObj) ? curCellObj : nextCellObj;
}



ZDBDataGrid.getLastFocusCell = function(gridObj)
{
  if(!gridObj)
  {
    return null;
  }

  var lastPos = gridObj.lastFocusPos;
  if(!lastPos)
  {
    return null;
  }
  return gridObj.getCell(lastPos.row, lastPos.col);
}


ZDBDataGrid.prototype.refineThemeProp = function()
{
	this.setThemeNo(this.getThemeNo());
	this.setThemeColor(this.getThemeColor());
	this.setFontSize(this.getFontSize());
	this.setFontFamily(this.getFontFamily());
	this.setRowSpacing(this.getRowSpacing());
}

ZDBDataGrid.prototype.isDifferentFromDB = function()
{
	var type = this.type;
	var dbThemeProp;
	switch(type)
	{
	case "PivotSheet": //NO I18N
		dbThemeProp = ThemeComponent.dbProps["PIVOT"];
		break;
	case "SummarySheet"://NO I18N
		dbThemeProp = ThemeComponent.dbProps["SUMMARY"];
		break;
	case "Report"://NO I18N
		dbThemeProp = ThemeComponent.dbProps["SUMMARY"];
		break;
		
	}
	return this.checkIsDifferentFromDB(dbThemeProp,this.themeProp)
}

ZDBDataGrid.prototype.getModifiedThemeProps = function(themeProp)
{
	var type = this.type;
	var dbThemeProp;
	switch(type)
	{
	case "PivotSheet"://NO I18N
		dbThemeProp = ThemeComponent.dbProps["PIVOT"];
		break;
	case "SummarySheet"://NO I18N
		dbThemeProp = ThemeComponent.dbProps["SUMMARY"];
		break;
	case "Report"://NO I18N
		dbThemeProp = ThemeComponent.dbProps["TABULAR"];
		break;
		
	}
		return ThemeComponent.getModifiedProps(dbThemeProp,themeProp ? themeProp : this.themeProp);

}

ZDBDataGrid.prototype.checkIsDifferentFromDB = function(dbProp,viewProp)
{
	for(var key in dbProp)
		{
		if(dbProp[key] != viewProp[key])
			{
			return true;
			}
		}
	return false;
}

ZDBDataGrid.getCurrentCell = function(gridObj)
{
  if(!gridObj)
  {
    return null;
  }

  var curPos = gridObj.curCellPos;
  if(curPos==null)
  {
  return null;
  }
  var cell = gridObj.getCell(curPos.row, curPos.col);
  return cell;
}



ZDBDataGrid.prototype.getCell = function(rowIndex, colIndex)
{
  if(rowIndex < 0 || colIndex < 0)
  {
    return null;
  }
  var rowObj = this.rowData[rowIndex];
  if(!rowObj || rowObj.objType === ZDBConst.COLHEAD)
  {
    return null;
  }
  var cellObjs = rowObj.values;
  var cellLen = cellObjs.length;
  var curObj, colObj;
  for(var i=0;i<cellLen;++i)
  {
    curObj = cellObjs[i];
    colObj = curObj.colObj;
    if(colObj.cellPos == colIndex)
    {
      return curObj;
    }
    if(colObj.startIndex >= colIndex) // && colObj.endIndex <= colIndex)
    {
      return curObj;
    }
  }
  return null;
}



ZDBDataGrid.prototype.getNextGroupStart = function(rowIndex,colIndex)
{
  var grpRowIndex = this.getGroupStartIndex(rowIndex,colIndex);
  var grpCount =  this.rowData[grpRowIndex].values[colIndex].groupCount;
  if(!grpCount)
  {
    return rowIndex + 1;
  }
  else
  {
    return grpRowIndex + grpCount;
  }
}
ZDBDataGrid.prototype.getPrevGroupStart = function(rowIndex,colIndex)
{
  var grpRowIndex = this.getGroupEndIndex(rowIndex,colIndex);
  var grpCount =  this.rowData[grpRowIndex].values[colIndex].groupCount;
  if(!grpCount)
  {
    return rowIndex -1;
  }
  else
  {
    return grpRowIndex - grpCount;
  }
}

ZDBDataGrid.prototype.getGroupRange = function(cellObj)
{
  var rowIndex = ZDBUtil.indexOf(this.rowData, cellObj.rowObj);
  var colIndex = cellObj.colObj.cellPos;
  return [this.getGroupStartIndex(rowIndex,colIndex),
          this.getGroupEndIndex(rowIndex,colIndex)];
}


ZDBDataGrid.prototype.setCellEditable = function(cellObj)
{
  if(this.isEdit)
  {
    return;
  }
  if(this.editDisabled || cellObj.editDisabled)
  {
    return;
  }
  var colObj = cellObj.colObj;
  if(!this.checkEditWithMsg(colObj))
  {
    return ZDBConst.BROWSER_HANDLE_NO;
  }

  this.removeCellFocus();
  this.hideSelection();
  var cHeadType = colObj.typeObj;
  this.rightFocus.style.display = "none";
  this.leftFocus.style.display = "none";
  this.lastFocusPos = {row:ZDBUtil.indexOf(this.rowData, cellObj.rowObj), col:cellObj.colObj.cellPos};
  cHeadType.editFn(cellObj);
  if(colObj.type == "REFCOL" || colObj.type == "RELCOL")
  {
    ZDBSuggestionBox.showAllRefColSuggestion(colObj);
  }
}



ZDBDataGrid.prototype.removeCellFocus = function()
{
  var curCellObj = ZDBDataGrid.getCurrentCell(this);
  this.dataFocus = false;
  if(!curCellObj)
  {
    return;
  }

  this.rightFocus.style.display = "none";
  this.leftFocus.style.display = "none";
  this.rightDropDownIcon.style.display = "none";
  this.leftDropDownIcon.style.display = "none";

  if(curCellObj.cellEl.linkEl) { curCellObj.cellEl.linkEl.style.position = ""; }
  if(curCellObj.cellEl.diff)
  {
    curCellObj.cellEl.style.width = parseInt(curCellObj.cellEl.style.width) + 18 + "px";
    curCellObj.cellEl.style.paddingRight = parseInt(curCellObj.cellEl.style.paddingRight) - 18 + "px";  //No I18N
    curCellObj.cellEl.diff = false;
  }

  curCellObj.rowObj.values[0].setClass();
  curCellObj.colObj.setClass();
  curCellObj.isCellFocused = false;
  this.setHighlightRowCol(curCellObj, false);
  this.lastFocusPos = {row:ZDBUtil.indexOf(this.rowData, curCellObj.rowObj), col:curCellObj.colObj.cellPos};
  this.curCellPos = null;
}


ZDBDataGrid.prototype.setCellFocus = function(cellObj,scrollToView)
{
    var curCellObj = ZDBDataGrid.getCurrentCell(this);
    /*if(cellObj == curCellObj)
    {
      ZDBDataGrid.setupFocusDiv(cellObj);
      return;
    }*/
    this.removeCellFocus(); ///PK: Previous Cell

    var startRowIndex = ZDBDataGrid.setupFocusDiv(cellObj); ///PK: Set returns ;-)
    var rIndex = ZDBUtil.indexOf(this.rowData, cellObj.rowObj);
    this.curCellPos = {row: rIndex, col: cellObj.colObj.cellPos};

    this.isEdit = false;
    this.dataFocus = true;
    this.gridFocus = true;
    if(scrollToView && scrollToView != false)
    {
      if(startRowIndex !== undefined || startRowIndex!=null)
      {
        this.scrollToView(this.getCellAt(startRowIndex, cellObj.colObj.cellPos).cellEl)
      }
      else
      {
        this.scrollToView(cellObj.cellEl);
      }
    }
    this.hideSelection(true, true);
    this.lastFocusPos = {row:ZDBUtil.indexOf(this.rowData, cellObj.rowObj), col:cellObj.colObj.cellPos};
    this.selectionType = ZDBConst.DATA;
    cellObj.isCellFocused = true;
    var colObj = cellObj.colObj;
    var gridObj = colObj.parGrid;
    if(((colObj.typeObj && colObj.typeObj.editorType == 'list') || colObj.type == "REFCOL" || colObj.type == "RELCOL") && !(gridObj.readOnly || gridObj.editDisabled))
    {
      ZDBEvents.showDropDownIcon(gridObj,cellObj);
    }
    else
    {
      ZDBEvents.hideDropDownIcon(gridObj);
    }
}

ZDBDataGrid.setupFocusDiv = function(cellObj)
{
    ///PK: Should be adjusted when sheet scrolled for a group column at the page end
  if(ZDBGlobal.IS_MOBILE){return;}
    var colObj = cellObj.colObj;
    var rowObj = cellObj.rowObj;
    var gridObj = colObj.parGrid;
    var cellPosObj = gridObj.getCellElPosInGrid(cellObj);
    if(gridObj.focusDisabled)
    {
      return;
    }

    var fDiv;
    if(colObj.freeze)
    {
      fDiv = gridObj.leftFocus;
    }
    else
    {
      fDiv = gridObj.rightFocus;
    }
    var divPar = fDiv.parentNode;
    gridObj.leftFocus.style.display = "none";
    gridObj.rightFocus.style.display = "none";
    gridObj.rightDropDownIcon.style.display = "none";
    gridObj.leftDropDownIcon.style.display = "none";

    var top = 0;
    var height = 0;
    var gIndices = [];
    if(colObj.grouped)
    {
      var rowData = gridObj.rowData;
      gIndices = gridObj.getGroupRange(cellObj);
      var gStart = rowData[gIndices[0]];
      var gStartCellObj = gStart.values[colObj.cellPos];
      var gEnd = rowData[gIndices[1]];
      var gEndCellObj = gEnd.values[colObj.cellPos];
      var startCellPos = gridObj.getCellElPosInGrid(gStartCellObj);
      var endCellPos = gridObj.getCellElPosInGrid(gEndCellObj);
      top = startCellPos.cellTop;
      height = endCellPos.cellTop + endCellPos.cellHeight - top; // adjustment for grouped cells
    }
    else
    {
      top = cellPosObj.cellTop;
      height = cellObj.cellEl.offsetHeight -1 ;
    }

    if(cellObj.cellEl.linkEl) { cellObj.cellEl.linkEl.style.position = "relative"; }

//    var diff;
//    diff = gridObj.type == "Report" ? 0 : 0;
    fDiv.cellObj = cellObj;
    var fDivStyle = fDiv.style;
    fDivStyle.left =  cellPosObj.cellLeft + "px";
    fDivStyle.top = top + "px";
    fDivStyle.width = (colObj.width -1 )+ "px";
    fDivStyle.height = height + "px";
    if(fDivStyle.display != "block")
    {
      fDivStyle.display = "block";
    }
    gridObj.setHighlightRowCol(cellObj, true);
    ZDBDataGrid.setKeyHandlerFocus(gridObj, 3);
    return gIndices[0];
}




ZDBDataGrid.prototype.setGroupCellTopHeight = function(cell, fDivStyle)
{
  var styleDiff = BROWSER.IE ? 0 : -2; //PK: temp;
  var range = this.getGroupRange(cell);
  var colIndex = cell.cellObj.colObj.cellPos;
  fDivStyle.top = (this.rowData[range[0]].values[colIndex].dataEl.offsetTop - 1
         + styleDiff) +  "px";
  var height = 0;
  for(var i=range[0];i<= range[1];i++)
  {
    height += this.rowData[i].values[colIndex].dataEl.offsetHeight;
  }
  fDivStyle.height = height + 2 + styleDiff + "px";
}


ZDBDataGrid.prototype.setCurrentCell = function(cellObj)
{
  this.lastFocusPos = {row:ZDBUtil.indexOf(this.rowData, cellObj.rowObj), col:cellObj.colObj.cellPos};
  this.setCellFocus(cellObj, true);
  this.curCellPos = {row:ZDBUtil.indexOf(this.rowData, cellObj.rowObj), col:cellObj.colObj.cellPos};  
}
ZDBDataGrid.prototype.addSelectedCol = function(col)
{
  return ZDBUtil.addToSet(this.selectedCols,col);
}
ZDBDataGrid.prototype.removeSelectedCol = function(col)
{
  ZDBUtil.removeFromSet(this.selectedCols,col);
}
ZDBDataGrid.prototype.addSelectedRow = function(row)
{
  return ZDBUtil.addToSet(this.selectedRows,row);
}
ZDBDataGrid.prototype.removeSelectedRow = function(row)
{
  ZDBUtil.removeFromSet(this.selectedRows,row);
}


ZDBDataGrid.prototype.setHighlightRowCol = function(cellObj, highLight)
{
  cellObj.colObj.selected = highLight;
  cellObj.rowObj.values[0].selected = highLight;
  cellObj.colObj.setClass();
  cellObj.rowObj.values[0].setClass();
  ZDBMenu.setToolbarStatus(this);
  return;
}
ZDBDataGrid.prototype.save = function(requestOptions)
{
  var perms = this.permissions;
  var canSave = false;
  if(perms.add || perms.modify || perms.deletePerm || perms.deleteAll)
  {
     canSave = true;
  }
  if(!canSave)
  {
    return;
  }


  if(!ZDBGlobal.integrated)
  {
    /// ZDBGlobal.integrated added for sheet
    ///PK: return;
  }
  if(!this.checkSave())
  {
    ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.resaveInfo"));
    return;
  }
  CommAPI.sendModData(this,CommAPI.DATASHEETURL,requestOptions);
  AllowedValPopup.cache[this.tableName] = null;
}

ZDBDataGrid.prototype.saveAsNewView = function()
{
  if(!ZDBCreateViewAPI.getNameForNewView(this,null,true))
  {
    return;
  }

  var params = ZDBCreateViewAPI.getNewNameInfoAsParams(this);

  var url =ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=SAVEASNEWVIEW";
  AjaxAPI.sendRequest({URL:url,
                             PARAMETERS:this.getCompleteGridDetailsAsParams() + params,
                             ONSUCCESSFUNC:ZDBCreateViewAPI.handleViewSave,
                             ONFAILUREFUNC:ZDBCreateViewAPI.handleViewSaveFailure,
                             VIEW:this,
                             ISNEWVIEW:true,
                             OPSTATUSID:this.viewCtx.getLoadIndicator()});
}
ZDBDataGrid.prototype.saveTableAsNewView = function(viewname,objid,dbid,folderID,desc,hugeDataCopy)
{
  if(!ZDBCreateViewAPI.getNameForNewView(this,null,true))
  {
    return;
  }
  var defaultFolderId = ZDBExpViewHandler.defaultFolderId;
  if(folderID == "newFolder")
    {
        folderID=defaultFolderId;
    }
  var params = "VIEWNAME="+encodeURIComponent(viewname)+"&DESCRIPTION="+encodeURIComponent(desc)+"&OBJID="+objid+"&DBID="+dbid+"&FOLDERID="+folderID+"&COPYLOOKUP="+$("ZDBDBCPLookupChkBox").checked+"&COPYDATA="+$("ZDBDBCPDataChkBox").checked+"&HUGEDATACOPY="+hugeDataCopy;//No I18N
  var url =ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=COPYTABLE";//No I18N
  AjaxAPI.sendRequest({URL:url,
                             ONSUCCESSFUNC:this.handleTableSaveAsResp,
                             ONFAILUREFUNC:this.handleTableSaveAsFailure,
                             PARAMETERS: params,
                             VIEW:this,
                             ISNEWVIEW:true,
                             OPSTATUSID:this.viewCtx.getLoadIndicator()});
}
ZDBDataGrid.prototype.handleTableSaveAsResp= function(response,requestOptions)
{
    var view = requestOptions["VIEW"];
    ZDBCreateViewAPI.handleViewSave(response,requestOptions,true);
    var tab = ZDBClientUI.getExistingTab(view.objId);
    ZDBClientUI.fetchView(view.objId,view.objId,view.displayName,"Table",tab);//No I18N
  setTimeout(function()
    {
    var settingsList=jQuery.parseJSON(response.responseText);
    var err = settingsList["WARNING"];
    if(err!=null)
    {
    ZDBMsgBox.showHintMsg(ZDBI18NMap.g("zrpt.common.toolbar.successmsg.js.saveaggwarning"), "info");//No I18N
    }
    else
     {
    ZDBMsgBox.showViewSavedMsg(view.displayName);
     }},1000);
}
ZDBDataGrid.prototype.handleTableSaveAsFailure= function(response,requestOptions)
  {
    var errCode = response.getResponsePart("ERRORCODE");
    errCode = trimAll(errCode);
    if(errCode == "META_DBOBJECT_NAME_DUPLICATED")
    {
      var dlg = ZDBCreateViewAPI.saveDlg;
      ZDBDialogUtil.showDialog(dlg,{MODAL:true, TITLE:ZDBI18NMap.g("zrpt.common.newrpt.saveas.js.dlgTtl",dlg),ADDFRAME:true});
      ZDBCreateViewAPI.saveDlg.nameTxtFld.focus();
      showCustomMessage(response.getResponsePart("STATUS_MESSAGE"), ZDBCreateViewAPI.saveDlg.nameTxtFld);
    $("customAlertMessage").style.zIndex = 20001;
    $("_CUSTOMALERTFRAME").style.zIndex = 20000;
    }
    else if(errCode == "COPY_TABLE_TIMEOUT")
    {
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.copy.dbobj.delayed"));
    }
    else if(errCode =="COPY_TABLE_SCHEDULED")
    {
        ZDBMsgBox.showInfo(response.getResponsePart("STATUS_MESSAGE"));
    }
    else if(errCode == "COPY_TABLE_ROW_EXCEEDS")
    {
        var dlg = ZDBCreateViewAPI.saveDlg;
        ZDBDialogUtil.showDialog(dlg,{MODAL:true, TITLE:ZDBI18NMap.g("zrpt.common.newrpt.saveas.js.dlgTtl",dlg),ADDFRAME:true});
        ZDBAlertAPI.showMsg(response.getResponsePart("STATUS_MESSAGE"),"ZDBYESNO",{ONCLICK:ZDBCreateViewAPI.confirmCopySettings});  //No I18N
        return;
    }
    else
    {
      AjaxAPI.onFailureFunc(response,requestOptions);
    }
}
ZDBDataGrid.prototype.checkSave = function()
{
  if(this.modified == 0 || this.modified == this.sent){return false;}
  if((this.modified != this.sent) && (this.sent != 0))
  {ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.saveInProgressInfo"));return false;}
  return true;
}
ZDBDataGrid.prototype.getRowId = function(row)
{
  return row.values[this.pkCols[0].cellPos].originalValue;
}
ZDBDataGrid.prototype.getMultiPkRowId = function(row)
{
  var rowId = null;
  for(var i = 0; i < this.pkCols.length; i++)
  {
    var val = row.values[i].originalValue;
    rowId = (rowId)? rowId + "-" + val:val;
  }
  return rowId;
}


ZDBDataGrid.prototype.getColumnIndex = function(value, isDisplay)
{
  var colHeaders = this.colHeaders;
  var colLen = colHeaders.length;
  var prop = isDisplay ? "displayName" : "colName";
  for(var i =0;i < colLen;i++)
  {
    if(colHeaders[i][prop] == value)
    {
      return i;
    }
  }
  return -1;
}

/**
 * @param {Map[]} updatedRowData A map of colindex to value.
 *
 */
ZDBDataGrid.prototype.update = function(requestOptions)
{
  if(requestOptions["SENTROWS"]  == null)
  {
    return;
  }
  this.dataCache = new ZDBGridDataCache(this);
}
ZDBDataGrid.prototype.initNewRowRid = function(clearOld)
{
  if((this.newRid <= this.totalRecords) || (clearOld))
  {
    //console.log(" inside  initNewRowRid");
    this.newRid = this.totalRecords + 1;
  }
}




ZDBDataGrid.prototype.updateViewAfterSave = function()
{
  this.onLostFocus();
  if(this.type == 'TableDesign')
  {
  var designDIV = ZDBClientUI.selectedTab.focusedDialog.designDIV;
  designDIV["SearchBoxTd"].style.display = '';
  designDIV["TDExport"].style.display = '';
  designDIV["TDExport"].setAttribute('onClick','ZDBDesignGrid.showTDExportMenu(this,event);');  // No I18N
  designDIV["AddFC"].style.display = '';
  designDIV["AddFC"].setAttribute('onClick','ZDBDesignGrid.showAddFCMenu(this,event);');  // No I18N
  designDIV["ZRAddColMenu"].className = "newGrpTextBtn first";
  }
  var hiddenRowsLength =  ZDBGridScroll.getStartRowInView(this);
  var rowData = this.rowData;
  this.newRows =[];
  this.saved();
  this.initNewRowRid(true);
  var firstDataRow = ZDBDataGrid.getFirstRowObj(rowData, false);
  var arr=[];
  if(firstDataRow && firstDataRow.rid != null)
  {
    this.dataCache.fetchRows(firstDataRow.rid,firstDataRow.arrIdx -1,this.minRows,false,arr);
  }
  else
  {
    this.dataCache.fetchRows(this.recordStart,-1,this.minRows,false,arr);
  }
  if(arr.length == 0)
  {
    throw new Error("The fetched data does not match with current view!!");
  }
  this.refreshRows(arr);
  var lastFocusCell = ZDBDataGrid.getLastFocusCell(this);
  if(lastFocusCell)
  {
    this.setCellFocus(lastFocusCell,true);
  }
  else
  {
    var selectedColHead = this.getSelectedColHead();
    if(!selectedColHead)
    {
      this.focusFirstCell();
    }
  }
  this.showSavedMsg();
}

ZDBDataGrid.prototype.showSavedMsg = function(addedCount,modifiedCount,deletedCount)
{
  ZDBMsgBox.showSuccess(ZDBI18NMap.f("zrpt.common.toolbar.successmsg.js.saveSuccess",ZDBEscapeUtil.encodeForHtml(this.displayName)));
  //(Records : "
  //                    + ((addedCount > 0)?  (" added : " + addedCount) : "")
  //                    + ((modifiedCount > 0)?  (" modified : " + modifiedCount) : "")
  //                    + ((deletedCount > 0)?  (" deleted : " + deletedCount) : "") + ")");
}
ZDBDataGrid.prototype.saved = function()
{
  this.sent = 0;
  this.clearModified();
}
ZDBDataGrid.prototype.clearModified = function()
{
  this.modified = 0;
  this.dataModified = false;
  this.deletedCount = 0;
  this.rowsToUpdate=[];
  this.updateTotalCountUI();
  this.viewCtx.updateModified();
}
ZDBDataGrid.prototype.updateTotalCountUI= function()
{
  var value = this.totalRecords - this.deletedCount;
  if(value < 0)
  {
    value = 0;
  }
  var elToSet = this.totalRecordsDiv;
  if(this.totalRecords == -1)
  {
    elToSet.innerHTML = ZDBI18NMap.g('zrpt.common.rowcount.js.tip.title');
    elToSet.onclick = function(){ZDBDataGrid.setRowCountNavig(elToSet);}
    ZDBUtil.setAttribute(elToSet,"true","keeptext");
    ZDBUtil.setAttribute(elToSet,"true","linkshown");
    elToSet.className = "zrRowCount ZRSAnchor normalfont11";
    ZDBUtil.setAttribute(elToSet,ZDBI18NMap.g('zrpt.common.rowcount.js.tip.desc1'),"tip");
    elToSet.onmouseover = function(event){ZDBToolTip.show(elToSet);}
    elToSet.onmouseout = function(event){ZDBToolTip.hide(elToSet);}
  }
  else
  {
    elToSet.className = (ZDBGlobal.IS_MOBILE) ? "normalfont11 normalFont12" : "normalfont11";
    elToSet.innerHTML = ZDBI18NMap.g('zrpt.common.rowcount.js.rows')+ ": " + value;
    elToSet.onmouseover = null;
    elToSet.style.width = "";
    elToSet.className = "zrRowCount normalfont11";
    ZDBUtil.removeAttribute(elToSet,"tip");  
    ZDBUtil.setAttribute(elToSet,"false","linkshown");
  }
}


ZDBDataGrid.prototype.addDummyRow = function(resetTop,addToView)
{
  var newRows = this.newRows;
  var newLen = newRows.length;

  if(((newLen > 0) && (newRows[newLen -1].objType == ZDBConst.DUMMY)) || (this.addRowSupported == false))
  {
    return;
  }
  var values = [];
  var colHeaders = this.colHeaders;
  var colLen = colHeaders.length;
  var curHead;

  for(var i=1;i<colLen -2;++i)
  {
    curHead = colHeaders[i];
    if(curHead.isAuto)
    {
      values.splice(i,0,"AUTOID:" + ++ZDBDataGrid.AUTOID_COUNTER);
    }
    else if(curHead.type == "FORMULACOL")
    {
      if(this.objId != undefined)
      {
        values.push(curHead.defaultVal);
      }
    }
    else
    {
      values.push(curHead.defaultVal);
    }
  }
  values.push("*");
  values.push(null);
  var row = new ZDBRow(this,values,ZDBConst.DUMMY);
  newRows.push(row);
  row.arrIdx = newLen;

  if((this.recordEnd == this.totalRecords)
     && addToView)
  {
    this.addNewRow(row);
    this.resetDummyTop();
  }
  this.dummy = true;
}

ZDBDataGrid.prototype.getBlankRow = function(rowType)
{
  var values = [];
  var len = this.colHeaders.length;
  for(var i=0;i<len-3;++i)
  {
    values.push("");
  }
  values.push("");
  values.push(null);
  return (new ZDBRow(this,values,rowType));

}


ZDBDataGrid.prototype.addFillerRow = function(addToView)
{
  var rowData = this.rowData;
  var rowLen = rowData.length;
  if(rowLen > 0 && rowData[rowLen-1].objType === ZDBConst.FILLER)
  {
    return;
  }

  var fillerRow = this.getBlankRow(ZDBConst.FILLER);
  this.addNewRow(fillerRow);
}

ZDBDataGrid.prototype.setJSONNodePath = function(jsonNodes)
{
  var nodesList = new Array();
  for(var i=0; i<jsonNodes.length; i++)
  {
    var node = jsonNodes[i];
    nodesList[node[0]] = node[1];
  }
  this.nodesList = nodesList;
}

ZDBDataGrid.prototype.setTableIdNameMapping = function(tableIdDispNameMapping)
{
  for (var key in tableIdDispNameMapping) 
  {
    if (tableIdDispNameMapping.hasOwnProperty(key)) 
    {
        var val = tableIdDispNameMapping[key];
        this.tableIdNameMapping[key] = val; 
    }
  }        
  
}

ZDBDataGrid.prototype.setOtherRelatedTableIds = function(otherRelatedTables)
{
  for (var i=0; i<otherRelatedTables.length; i++) 
  {
    
        this.otherRelatedTableNames.push(this.tableIdNameMapping[otherRelatedTables[i]]);
    
  }        
  
}

ZDBDataGrid.prototype.setColumnHeaders = function(colHeaders)
{
  this.resetColumnProps();
  var colRow = this.baseRow;
  var freezeHackDesign = this.freezeHack;
  var freezeHackPivot = this.zaFreezeIDX;
  var totCols = colHeaders.length;
  var freezeIt = freezeHackDesign !== undefined;
  var chRowWidth = 0, chRowHeight = 0, tcRowWidth = 0;
  this.chAreaRowDiv.innerHTML = "";
  this.tcAreaRowDiv.innerHTML = "";
  if(this.type == "VUDSheet")
  {
    var colNamesAndCounts = new Object();
    for(var j=0;j<totCols;++j)
    {
        var c = colHeaders[j];

        if(colNamesAndCounts[c[2]] != undefined)
        {
            var count = colNamesAndCounts[c[2]];
            colNamesAndCounts[c[2]] = ++count;
            this.duplicateColNames.push(c[2]);
        }
        else
        {
            colNamesAndCounts[c[2]] = 1;
        }
    }
  }
  for(var i=0;i<totCols;++i)
  {
    var c = colHeaders[i];
    var colHeader = new ZDBColHeader(this,c[0],c[1],c[2],c[3],c[4],c[5],c[6],c[7],c[8],c[9],c[10],c[11], c[12], c[13],c[14],c[15],false, ZDBConst.CLEAR, c[16], c[17], c[18], c[19], c[20], c[21], c[22], c[23], c[24],c[25], c[26],c[27],c[28],c[29],c[30],c[31],c[32],c[33],c[34],c[35],c[36],c[37],c[38],c[39],c[40],c[41],c[42],c[43],c[44],c[ZRGRIDIDXCONSTS.get("GEODET")],c[46],c[47],c[48],c[49],c[50]);
    if(freezeIt && freezeHackDesign != colHeader.colName)
    {
      colHeader.freeze = true;
    }
    else if(freezeIt && freezeHackDesign == colHeader.colName)
    {
      colHeader.freeze = true;
      freezeIt = false;
    }
    if(freezeHackPivot !== undefined && freezeHackPivot >= i)
    {
      colHeader.freeze = true;
    }
    this.addColumn(colHeader, colRow);
    tcRowWidth = ((colHeader.objType === ZDBConst.ROWHEAD || colHeader.freeze) && colHeader.visible) ? tcRowWidth + colHeader.width : tcRowWidth;
  }
  if(this.type == "PivotSheet" &&  this.tcAreaRowDiv.lastChild)
	  {
	  this.tcAreaRowDiv.lastChild.className += " groupRightEnd";  //NO I18N
	  }
  this.addTcColumn(colRow);
  this.addDummyColumn(colRow);
  this.addFillerColumn(colRow);
  if(this.type == "PivotSheet" || this.type == "SummarySheet")  // temporary check for pivot and summary
	  {
  this.adjustColFill(true);
	  }
  if(this.isFilterApplied || (this.simpleFilterData.length > 0))
  {
    this.showFilterArea();
  }
  this.retainPropsOnRefresh();
  this.setRowHeight(colRow);
  //ZDBColHeader.addCSSLinkForGrid(this);
}

ZDBDataGrid.prototype.maintainWidthArray = function(colHeaders)
{
  if(colHeaders)
	  {
  var widthArray = []; 
  for(var i = 0; i < colHeaders.length; i++)
  {
    var colHead = colHeaders[i];
    // In tabular view having grouped column where __ZDBID column is not the fist one and in preview cases(query table) there is no __ZDBID column
    if(this.type != "AnalysisSheet")
    	{
    widthArray[i] = (colHead[2].toUpperCase() == "__ZDBID") || (this.type == "TableDesign"  && colHead[2].toUpperCase() == "FIELDID") || (colHead[12] == false) ? 0 : Math.round(colHead[10] * this.getFontSize()/ZDBGlobal.defaultFontsize); // index 2 - column display name, 10 - coumn width
    	}
    else
    	{
    	widthArray[i]=Math.round(150 * this.getFontSize()/ZDBGlobal.defaultFontsize);
    	}
  }
  widthArray[widthArray.length] = 0;
  widthArray[widthArray.length] = 0;
  var rhWidthArray=[Math.round(30*this.getFontSize()/ZDBGlobal.defaultFontsize)];
  this.rhWidthArray=rhWidthArray;
  if(this.freezePos)
	  {
	  for(var i=0;i<this.freezePos;i++)
		  {
		  this.rhWidthArray.push(widthArray.shift());
		  }
	  }
  this.generateColumnWidth(widthArray);
  this.generateLeftColumnWidth(rhWidthArray);
	  }
}
ZDBDataGrid.prototype.generateColumnWidth = function(widthArray, totalDataWidth)
{
	if(widthArray.length === 0)
		{
		return;
		}
	  if(!totalDataWidth)
		  {
	  totalDataWidth=widthArray.reduce(function sum(total,num){return total+num;});
		  }
	  if(this.gridSizeBasedOnData === true)
      {
        this.adjustDimension();
      }
	  else
		  {
	  var gRightAreaWidth=this.gRightArea.style.width;
	  gRightAreaWidth=parseInt(gRightAreaWidth);
	  totalDataWidth-=widthArray[widthArray.length-1];
	  if(gRightAreaWidth > totalDataWidth)
		  {
		  widthArray[widthArray.length-1]=gRightAreaWidth - totalDataWidth;
		  
		  }
	  else
		  {
		  widthArray[widthArray.length-1]=0;
		  }

	/*  for(var i=0;i<widthArray.length-2;i++)
	  {
		  this.colHead[i][10]=widthArray[i];
	  }*/
		  }
	  if(widthArray[widthArray.length-1] >0)
		  {
          widthArray[widthArray.length-1]-=this.getScrollThick();
          if(widthArray[widthArray.length -1] <  0)
        	  {
        	  widthArray[widthArray.length-1] = 0;
        	  }
		  }
	  totalDataWidth+=widthArray[widthArray.length-1];
	  this.widthArray=widthArray;
	  this.dTable.style.width=totalDataWidth+'px';
	  this.chTable.style.width=totalDataWidth+'px';
	  this.fTable.style.width=totalDataWidth+'px';
	  
	  var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
	  var cssRule ="div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell], div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell], div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]{width:"+(150/totalDataWidth)*100+"%;}"; //NO I18N
	  
	  for(var i = 0; i < widthArray.length-1; i++)
	  {
		  if(widthArray[i] == 150)
		  {
			  continue;
		  }
		  cssRule += "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell]:nth-child("+(i+1)+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell]:nth-child("+(i+1)+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]:nth-child("+(i+1)+"){width:"+(widthArray[i]/totalDataWidth)*100+"%;}";//NO I18N
	  }
	  var length=widthArray.length;
	  if(widthArray[length-1] > 0)
		  {   // only column filler is represented in pixel because IE calculates percentage wrongly .. This need to be fixed
		  cssRule += "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell]:nth-child("+length+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell]:nth-child("+length+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]:nth-child("+length+"){width:"+widthArray[length-1]+"px;}";//NO I18N

		  }
	  else
		  {
		  cssRule += "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell]:nth-child("+length+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell]:nth-child("+length+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]:nth-child("+length+"){width:"+0+"%; display:none;}";//NO I18N
		  }
	  styleSheet.innerHTML= cssRule;
}
ZDBDataGrid.prototype.generateLeftColumnWidth = function(widthArray,totalDataWidth)
{      
	  if(this.isForImport)
		  {
		  return;
		  }
	  if(!totalDataWidth)
		  {
	  var totalDataWidth=widthArray.reduce(function sum(total,num){return total+num;});
		  }
	  if(this.hideRhId)
		  {
		  totalDataWidth-=widthArray[0];
		  }
	  this.gLeftArea.style.width=totalDataWidth+'px';
	  var defColWidth = (this.defColWidth && (this.defColWidth != -1)) ? this.defColWidth : 150;
	  var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
	  var cssRule = styleSheet.innerHTML ;
	  if(widthArray.length > 1 || widthArray[0] === defColWidth) //No need to generate width css for defWidth when there is only one left column
		  {
	  cssRule += "div[gridid='"+this.ID+"'] div[elname=gLeftArea] div[zdbname=colheadcell], div[gridid='"+this.ID+"'] div[elname=gLeftArea] div[zdbname=datacell], div[gridid='"+this.ID+"'] div[elname=gLeftArea] div[zdbname=filterCell]{width:"+(defColWidth/totalDataWidth)*100+"%;}"; //NO I18N
		  }
	  
	  for(var i=0;i<widthArray.length;i++)
	  {
		  if(widthArray[i] == defColWidth)
		  {
			  continue;
		  }
		  cssRule += "div[gridid='"+this.ID+"'] div[elname=gLeftArea] div[zdbname=colheadcell]:nth-child("+(i+1)+"), div[gridid='"+this.ID+"'] div[elname=gLeftArea] div[zdbname=datacell]:nth-child("+(i+1)+"), div[gridid='"+this.ID+"'] div[elname=gLeftArea] div[zdbname=filterCell]:nth-child("+(i+1)+"){width:"+(widthArray[i]/totalDataWidth)*100+"%;}";//NO I18N
	  }
	  if(this.hideRhId && (this.type == "PivotSheet" || this.type == "SummarySheet")) //generatingleft borderCss when rhId is hidden
		  {
		  var area = widthArray.length == 1 ? "gRightArea" : "gLeftArea"; //NO I18N
		  var childNo = widthArray.length == 1 ? 1 : 2;
		  cssRule += "div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=colheadcell]:nth-child("+childNo+"), div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=datacell]:nth-child("+childNo+"), div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=filterCell]:nth-child("+childNo+"){ border-left-width:1px;border-left-style: solid;}";//NO I18N
		  }
	  styleSheet.innerHTML = cssRule;
}
ZDBDataGrid.prototype.generateHiddenRhIdBorderCss = function()
{     
	  var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
	  var cssRule;
	  var widthArray = this.rhWidthArray;
	  var area = widthArray.length == 1 ? "gRightArea" : "gLeftArea"; //NO I18N
	  var childNo = widthArray.length == 1 ? 1 : 2;
	  if(this.hideRhId)
		  {
		  cssRule  = "div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=colheadcell]:nth-child("+childNo+"), div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=datacell]:nth-child("+childNo+"), div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=filterCell]:nth-child("+childNo+"){ border-left-width:1px;border-left-style: solid;}";//NO I18N
		  }
	  else
		  {
		  cssRule  = "div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=colheadcell]:nth-child("+childNo+"), div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=datacell]:nth-child("+childNo+"), div[gridid='"+this.ID+"'] div[elname="+area+"] div[zdbname=filterCell]:nth-child("+childNo+"){ border-left:0px solid;}";//NO I18N
		  }
	  styleSheet.innerHTML+=cssRule;
}
ZDBDataGrid.prototype.updatePreviewGridColumnWidth = function()
{//used for import preview dialog
	var colLen = this.colHeaders.length - 3;
	var widthArray = [];
	var totalDataWidth = 0;
	for(var i = 0; i < colLen; i++)
	{
		widthArray[i] = 150; //constant column width
		totalDataWidth += widthArray[i];
	}
	var fillerPos = colLen+1;
	widthArray[colLen]=0;
	widthArray[fillerPos] = 0;
	var gRightAreaWidth = this.gRightArea.style.width;
	gRightAreaWidth = parseInt(gRightAreaWidth);
	
	if(gRightAreaWidth > totalDataWidth)
	{
		widthArray[fillerPos] = gRightAreaWidth - totalDataWidth;
		totalDataWidth += widthArray[fillerPos];
	}
	//this.widthArray = widthArray;
	
	var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
	var cssRule = "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell], div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell], div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]{width:"+(150/totalDataWidth)*100+"%;}"; //NO I18N
	
		cssRule += "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell]:nth-child("+(fillerPos+1)+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell]:nth-child("+(fillerPos+1)+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]:nth-child("+(fillerPos+1)+"){width:"+widthArray[fillerPos]+"px;}"; //NO I18N
	this.widthArray=widthArray;
	styleSheet.innerHTML = cssRule;
	this.dTable.style.width=totalDataWidth+'px';
	this.chTable.style.width=totalDataWidth+'px';
	this.fTable.style.width=totalDataWidth+'px';
	this.setFillerHeight();
}

ZDBDataGrid.prototype.setFillerHeight = function(isFromEditorBlur)
{
var table = this.dTable.children;
var rhTable = this.rhTable.children;
if(!isFromEditorBlur)
	{
this.adjustInViewRowsHeight();
	}
var dataTableHeight=this.dTable.offsetHeight-this.dTable.children[this.dTable.children.length-1].offsetHeight;
var fillerHeight=0;
if(dataTableHeight < this.dHeight)
	{
	fillerHeight = this.dHeight - dataTableHeight;
	}
fillerHeight-=this.getScrollThick();
if(fillerHeight > 0)
	{
	table[table.length-1].style.height=fillerHeight+'px';
	table[table.length-1].style.display = "";
	rhTable[table.length-1].style.display = "";
	rhTable[rhTable.length -1].style.height=fillerHeight+'px';
	}
else
	{
	fillerHeight=0;
	table[table.length-1].style.display="none";
	table[table.length-1].style.height=fillerHeight+'px';
	rhTable[table.length-1].style.display="none";
	rhTable[rhTable.length -1].style.height=fillerHeight+'px';
	}
}
ZDBDataGrid.prototype.adjustInViewRowsHeight = function(onlyHeaderRow)
{   
	if(!this.gArea || !this.gArea.parentNode){
    return;
  }
	var length=this.rhTable.children.length;
	var defHeaderHeight = this.defHeaderHeight;
    if(!defHeaderHeight)
    	{
        var colHt = (ZDBGlobal.ISNEWLAYOUT) ? 35 : 26;
    	defHeaderHeight = Math.round((colHt/ZDBGlobal.defaultFontsize) * this.getFontSize());
    	}

  		this.tcTable.children[0].style.height = "";
 		this.chTable.children[0].style.height ="";
		this.tcArea.style.height = "";
		this.chArea.style.height = "";
		var tcHeight = this.tcTable.children[0].offsetHeight;
		var chHeight = this.chTable.children[0].offsetHeight;
		var heightToChange = tcHeight < chHeight ? chHeight : tcHeight;
        heightToChange = heightToChange > defHeaderHeight ? heightToChange : defHeaderHeight;
        this.tcArea.style.height = heightToChange +"px";
        this.chArea.style.height = heightToChange +"px";
        this.tcTable.children[0].style.height = heightToChange +"px";
        if(this.rowData[0].height != heightToChange)//for Tabular report when font size is changed header height varies, so need to adjust all dimensions
        	{
            this.rowData[0].height = heightToChange;
            this.adjustDimension();
        	}
        
        if(onlyHeaderRow)
        	{
        	return;
        	}
        
	if(BROWSER.IE == 1 && BROWSER.IE11AndAbove == 0 && BROWSER.EDGE == 0)
	{
		this.removeRowHeights();
		ZDBUtil.removeAndInsertJsObj(this); //IE 9 issue
	}
	for(var i=0;i<length-1;i++)
	{
        this.adjustRowHeight(i);
	}
	if(this.type === "Report")
	{
		this.includeSortIconTop(true);
	}
}
ZDBDataGrid.prototype.adjustRowHeight = function(index)
{    
	var headerRowCount;
	if(this.type == "PivotSheet" || this.type == "SummarySheet")
	{
	headerRowCount = this.chArea.children.length;
	}
	else
		{
		headerRowCount = 1;
		}
	var defCellHeight = this.defCellHeight;
	if(!defCellHeight)
		{
		defCellHeight = ZDBGlobal.stdCellHeight;
		}
	this.defCellHeight = (ZDBGlobal.ISNEWLAYOUT && (this.type == "Table" || this.type == "QueryTable" || this.type == "Report")) ? 35 : defCellHeight;
	var dTable =  this.dTable;
	var rhTable = this.rhTable;
	var dHeight;
	var rhHeight;
	dTable.children[index].style.height = '';
  rhTable.children[index].style.height='';
  dHeight=dTable.children[index].offsetHeight;
  rhHeight=rhTable.children[index].offsetHeight;
  var heightToChange;
  heightToChange= dHeight < rhHeight ? rhHeight :dHeight;
  heightToChange= heightToChange < defCellHeight ? defCellHeight : heightToChange;
  heightToChange++; //for mobile devices the the offsetHeight will be 26 
                    //this is becuase in firefox some case for example if the visible height of the row will be 22.4  
        	          //but we will get offsetHeight as only 22. Even if we set height to row as 22px it will be visually 22.4
        	          //this will cause the miss alignment of left and right Area rows.
        	          //Because of that we will increase the heightToChange by 1px
  rhTable.children[index].style.height=heightToChange+'px';
  dTable.children[index].style.height=heightToChange+'px';
  this.rowData[index+headerRowCount].height=heightToChange;
}
ZDBDataGrid.prototype.adjustInViewPivotRowsHeight = function(onlyHeaderRows)
{   
  if(!this.gArea || !this.gArea.parentNode){
    return;
  }
	var tcRows = this.tcTable.children;
    var chRows = this.chArea.children;
    var headerRowCount = chRows.length;
    var defHeaderHeight = this.defHeaderHeight;
    if(!defHeaderHeight)
    	{
    	defHeaderHeight = Math.round((26/ZDBGlobal.defaultFontsize) * this.getFontSize());
    	}
    for(var i=chRows.length-1;i>=0;i--)
    	{
    	chRows[i].style.height='';
    	var chHeight = chRows[i].offsetHeight;
    	var tcHeight = 0;//for Pivot multiheaders there will be no header on left tcArea. So no need to take offset of tcheight
    	if(i === chRows.length-1)
    		{//only for the column header ther will be data on both left header(colHeadL) and right header(colHeadR), so need to take offset of both
    		tcRows[i].style.height='';
    		tcHeight = tcRows[i].offsetHeight;
    		}
    	var heightToChange = chHeight > tcHeight ? chHeight : tcHeight;
    	heightToChange = heightToChange > defHeaderHeight ? heightToChange : defHeaderHeight;
    	chRows[i].style.height = heightToChange+ 'px';
    	tcRows[i].style.height = heightToChange + 'px'; 
    	this.rowData[i].height = heightToChange;
    	}
    
    this.defHeaderHeight = defHeaderHeight;

	var	length=this.rhTable.children.length;
if(!onlyHeaderRows)
	{
	if(BROWSER.IE == 1 && BROWSER.IE11AndAbove == 0 && BROWSER.EDGE == 0) 
	{
		this.removeRowHeights();
		ZDBUtil.removeAndInsertJsObj(this); //IE 9 issue
	}
	for(var i=0;i<length-1;i++)
	{
        this.adjustRowHeight(i);
	}
	}
    this.includeSortIconTop(true);
}

ZDBDataGrid.prototype.includeSortIconTop = function(appendInStyleSheet)
{
	var headerHeight = this.chTable.offsetHeight;
	var top = parseInt(headerHeight / 4);
	if((headerHeight/this.getFontSize()) < 3)
		{
		top = top-4;
		}
	var tl = new Object();
	tl.mainClass = "div[gridid='"+this.ID+"']"; //No I18N
	tl.affectedStyleGroups = [];
	tl.affectedStylesAndValues = [];	
	tl.affectedStyleGroups = [["headerSortAsc","headerSortDesc"]]; //No I18N
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("top",1,top+"px"));
	var styleText = ZDBUtil.getInnerHTML(tl,true);
	if(appendInStyleSheet)
		{
	var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
	styleSheet.innerHTML += styleText;
	return;
		}
	return styleText;
}
ZDBDataGrid.prototype.removeRowHeights =  function()
{
	var	length=this.rhTable.children.length;
	for(var i=0;i<length-1;i++)
	{
		var dTable =  this.dTable;
		var rhTable = this.rhTable;
		dTable.children[i].style.height="";
		rhTable.children[i].style.height="";       
	}
}

ZDBDataGrid.prototype.adjustFilterRowHeight =  function()
{
	var fTable=this.fTable;
	var fhTable= this.fhTable;
	for(var i=0;i<fTable.children.length;i++)
		{
		fhTable.children[i].style.height = fTable.children[i].offsetHeight + "px";
		}
}
ZDBDataGrid.prototype.removeAllChild = function(parent)
{
	while (parent.firstChild) {
		  parent.removeChild(parent.firstChild);
		}
}
ZDBDataGrid.prototype.maintainPivotWidthArray = function(colHeaders) {
	var length = colHeaders.length;
	var widthArray = [];
	var rhWidthArray = [ Math.round(30*this.getFontSize()/ZDBGlobal.defaultFontsize) ];
	var totalWidth = 0;
	var defColWidth = this.defColWidth != -1 ? this.defColWidth : 150;
	var colHeadNo = 0;
	for (var i = 1; i < length-2; i++) {//last two colheaders need not be be maintained in array because they are not used
		var x = colHeaders[i].width
		if ((colHeaders[i].cellEl.className.indexOf("colHeadL") !=-1)) {
			rhWidthArray.push(x);
		} else {
			widthArray.push(x);
			totalWidth += x;
		}
	}
	this.rhWidthArray = rhWidthArray;
	this.defColWidth = parseInt((this.defColWidth > 0 ? this.defColWidth : 150 ) * this.getFontSize() / ZDBGlobal.defaultFontsize);
	this.widthArray = widthArray;
	/*if(this.defColWidth < 0)//for compact width needed for future reference
		{
	this.defColWidth = parseInt((this.defColWidth > 0 ? this.defColWidth : 150 ) * this.getFontSize() / 12);
	//this.widthArray = this.getCompactWidthArray();
	this.widthArray = widthArray;
		}
	else
		{
		this.widthArray = widthArray;
		}*/
	
	if(this.widthArray.length > 0)  // no need to calculate percentage array if the widthArray is empty
		{
	this.maintainPercentageArray(this.widthArray, totalWidth);
		}
	this.tableWidth = totalWidth;

}
ZDBDataGrid.prototype.maintainGridHeadArrays = function(gridHead,inPixel) {
	if (gridHead) {
		var length = gridHead.length;
		var HeaderWidthArrays = [];
		var HeaderActualArrays = [];
		for (var i = 0; i < length; i++) {
			var row = gridHead[i];
			var tempArray = [];
			var actualArray =[];
			var count = 0;			
			for (var j = this.rhWidthArray.length; j < row.length-2; j++) { // neglecting two headers at last
				var colSpan = row[j][2];                                    //because last two headers are  useless 
				var temp = count;
				var width = 0;
				var actualWidth = 0;
				for (var k = count; k < (temp + colSpan); k++) {
					width += this.percentageArray[count];
					//width = parseFloat(width.toFixed(2));
					actualWidth += this.widthArray[count];
					count++;
				}
				tempArray.push(width);
				actualArray.push(actualWidth);
			}
			HeaderWidthArrays.push(tempArray);
			HeaderActualArrays.push(actualArray);
		}
		this.HeaderWidthArrays = HeaderWidthArrays;
		this.HeaderActualArrays = HeaderActualArrays;
		this.setGridHeadCellWidth(inPixel);
	}
}
ZDBDataGrid.prototype.maintainPercentageArray = function (widthArray, totalWidth)
{
var percentageArray = [];
	if (!totalWidth) {
		totalWidth = widthArray.reduce(function sum(total, num) {
			return total + num;
		});
	}
for(var i=0;i<widthArray.length;i++)
	{
	percentageArray.push((widthArray[i]/totalWidth)*100);
	}
this.percentageArray = percentageArray;
}
ZDBDataGrid.prototype.addPivotHeadTable = function(index)
{
	var div=document.createElement("div");
	div.style.display="table";
	var id = "ghTable"+(index+1); //No I18N
	div.id=id;
	div.style.tableLayout="fixed";//No I18N
	if(BROWSER.IE == 1 && BROWSER.IE11AndAbove == 0 && BROWSER.EDGE == 0 && (BROWSER.VERSION.indexOf("10") == -1))
	{
		div.style.borderCollapse="collapse"; //No I18N
	}
	else
	{
		div.style.borderCollapse="separate"; //No I18N	
	}
	div.style.width = this.tableWidth+"px";//No I18N
	var nextChild = this.chTable;
	div.appendChild(this.chArea.children[index]);
	this.chArea.insertBefore(div,nextChild);
}
ZDBDataGrid.prototype.generatePivotColumnWidth = function(widthArray,inPixel)
{
	if(widthArray.length === 0)
	{
		return;
	}
      var totalDataWidth=widthArray.reduce(function sum(total,num){return total+num;}); 
	  if(this.gridSizeBasedOnData === true)
      {
        this.adjustDimension();
      }
	  var defColWidth = this.defColWidth != -1 ? this.defColWidth : 150;
	  var chRows = this.chArea.children;
	  for(var i=chRows.length-1;i>=0;i--)
		  {
		  chRows[i].style.width = totalDataWidth+"px";
		  }
	  this.dTable.style.width = totalDataWidth+"px";
	  var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
	  this.maintainPercentageArray(this.widthArray,totalDataWidth);
	  var cssRule;
	  if(inPixel)
		  {
	  cssRule ="div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell], div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell], div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]{width:"+ defColWidth +"px;}"; //NO I18N
		  }
	  else
		  {
	  cssRule ="div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell], div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell], div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]{width:"+ (defColWidth/totalDataWidth)*100+"%;}"; //NO I18N
		  }
	  for(var i = 0; i < this.percentageArray.length; i++)
	  {
		  if(this.widthArray[i] == defColWidth)
		  {
			  continue;
		  }
		  if(inPixel)
			  {
		  cssRule += "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell]:nth-child("+(i+1)+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell]:nth-child("+(i+1)+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]:nth-child("+(i+1)+"){width:"+this.widthArray[i] + "px;}";//NO I18N
			  }
		  else
			  {
			  cssRule += "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell]:nth-child("+(i+1)+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell]:nth-child("+(i+1)+"), div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]:nth-child("+(i+1)+"){width:"+this.percentageArray[i]+"%;}";//NO I18N
			  }
	  }
	  styleSheet.innerHTML= cssRule;	  
}
ZDBDataGrid.prototype.setGridHeadCellWidth = function(inPixel)
{
	var HeaderArrays = this.HeaderWidthArrays;
	var chArea = this.chArea;
	var totalDataWidth=this.widthArray.reduce(function sum(total,num){return total+num;});
	for(var i=0;i<HeaderArrays.length;i++)
		{
		var gridTable = chArea.children[i];
		var gridWidthArray = HeaderArrays[i];
		var actualArray = this.HeaderActualArrays[i];
		for(var j=gridWidthArray.length-1;j>=0;j--)
			{
			if(inPixel)
				{
				gridTable.firstChild.children[j].style.width = actualArray[j]+"px";
				}
			else
				{
			gridTable.firstChild.children[j].style.width = gridWidthArray[j] +"%";//(Math.round(gridWidthArray[j]*100000))/100000+ "%";
				}
			}
		//gridTable.firstChild.children[gridWidthArray.length-1].style.width = actualArray[gridWidthArray.length-1]+"px";
		}
}
ZDBDataGrid.prototype.changeFontSize = function(newFontSize,prevFontSize,fontFamily)
{
	if(!prevFontSize)
		{
		prevFontSize = ZDBGlobal.defaultFontsize;
		}
	if(prevFontSize == newFontSize)
		{
		return;
		}
	
	var colHead = this.colHeaders;
	for(var i=0;i<colHead.length;i++) // changing width of all colHeader object
		{
		colHead[i].width = Math.round((colHead[i].width/prevFontSize) *  newFontSize);
		ZDBDataGrid.setColHeadDisplayWidth(this,colHead[i]);
		}
	
	var previousFreezeStatus = this.freeze;
	this.adjustDimension();
	var currentFreezeStatus = this.freeze;
	var widthArray = this.widthArray;
	var rightWidth = 0;
	var leftWidth = 0;
	
	for(var i=0;i<widthArray.length;i++)
		{
		rightWidth += widthArray[i] = Math.round((widthArray[i]/prevFontSize)*newFontSize);
		}
	
	var rhWidthArray = this.rhWidthArray;
	for(var i=0;i<rhWidthArray.length;i++)
	{
	rhWidthArray[i] = Math.round((rhWidthArray[i]/prevFontSize) * newFontSize);
	}

	this.widthArray = widthArray;
	this.rhWidthArray = rhWidthArray;
	
	this.chTable.style.width  = this.dTable.style.width = rightWidth+"px";
	for(var i=0;i<this.chArea.children.length-1;i++) // setting width for grid header rows in pivot
		{
         this.chArea.children[i].style.width = rightWidth +"px";
		}
	
	if(previousFreezeStatus != currentFreezeStatus) // if unfreeze takes place during fontsize change, width styles need to be generated
		{
	this.generatePivotColumnWidth(this.widthArray);
	this.generateLeftColumnWidth(this.rhWidthArray);
	this.maintainGridHeadArrays(this.gridHeaderRows);
	this.needToChangeToPercentage = false;
		}
	else if(this.needToChangeToPercentage != false && this.fontSizeNo == 1) //fontSizeNo is variable which shows how many 
		   { 																//times this function called consequtively
		   this.generatePivotColumnWidth(this.widthArray);
		   this.generateLeftColumnWidth(this.rhWidthArray);
		   this.maintainGridHeadArrays(this.gridHeaderRows);
		   this.removeRowHeights();
		   this.needToChangeToPercentage = false;
		   }
	
	if(!this.fontSizeNo)
		{
		this.fontSizeNo  = 0;
		}
		this.fontSizeNo++;
		
	
	//changeing default cell height, default header height and default column width according to new font size
	var defCellHeight = this.defCellHeight;
	if(!defCellHeight)
		{
		defCellHeight = ZDBGlobal.stdCellHeight;
		}	
	defCellHeight = (defCellHeight/prevFontSize) * newFontSize;
	this.defCellHeight = Math.round(defCellHeight);
	
	var defHeaderHeight = this.defHeaderHeight;
	if(!defHeaderHeight)
		{
		defHeaderHeight = Math.round((26/ZDBGlobal.defaultFontsize) * prevFontSize);
		}
	defHeaderHeight = (defHeaderHeight/prevFontSize) *  newFontSize;
	this.defHeaderHeight = Math.round(defHeaderHeight);
	
	var defColWidth = this.defColWidth;
	if(defColWidth === -1)
		{
		defColWidth = 150;
		}
	this.defColWidth = Math.round((defColWidth/prevFontSize)* newFontSize);
	
	this.appendFontSizeAndPadding(ThemeComponent.pivotThemeDialogue.inViewRowSpacing,newFontSize,ThemeComponent.pivotThemeDialogue.inViewFontFamily);
	
	if(this.gHeight < (this.gDataHeight / this.getFontSize())*7)
		{
	this.adjustInViewPivotRowsHeight(true);
		}
	else if(this.type != "Report")
		{
		this.adjustInViewPivotRowsHeight();
		}
	else
		{
		this.adjustInViewRowsHeight(true);
		}

	
	this.adjustDimension();
	if(this.type == "Report") // resize is called to set vertical and horizontal filler if possible
		{
	this.resize(true);
     	}
}

ZDBDataGrid.prototype.appendFontSizeAndPadding = function(rowSpacing,newFontSize,fontFamily)
{
	
	var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID,false);
	var padding = this.getPaddingForFont(rowSpacing,newFontSize);
    var paddingGroup = ["dR","dL","sL","sR","tR","tL","zdbRowHead","groupCell","groupCellEnd","zdbDataCell","sectionHeader","groupSummary"];//No I18N
	if(this.type == "Report")
	{
		paddingGroup.push("zdbColHeadDisplay");
	}
    var tl = new Object();
    tl.mainClass = "div[gridid='"+this.ID+"']"; //No I18N
    tl.affectedStyleGroups = [];
    tl.affectedStyleGroups.push(paddingGroup);
    tl.affectedStyleGroups.push([""]);
	tl.affectedStylesAndValues = [];
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("padding-top",1,padding+"px"));
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("padding-bottom",1,padding+"px"));
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("font-size",2,newFontSize+"px"));
	styleSheet.innerHTML = ZDBUtil.getInnerHTML(tl,true);
	styleSheet.innerHTML += this.generateFontFamilyWithWeight(fontFamily);
	
	}
ZDBDataGrid.prototype.generateFontFamilyWithWeight = function(fontFamily)
{
	var fontWeight = "bold"; //No I18N
    var fontWeightGroup = ["hRow","colHeadL","sL","colHeadL","sR","tR","tL","zdbRhColHead","zdbColHead","zdbFillerColHead","groupCell","zdbHiddenDataCell","groupCellEnd","sectionHeader"];//No I18N

    var tl = new Object();
	tl.mainClass = "div[gridid='"+this.ID+"']"; //No I18N
	tl.affectedStyleGroups = [];
	tl.affectedStylesAndValues = [];
	tl.affectedStyleGroups.push(fontWeightGroup);
	tl.affectedStyleGroups.push([""]);
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("font-family",2,fontFamily));
	if(fontFamily == "Proxima Nova")
		{
			fontWeight = "normal"; //No I18N
			fontFamily = "ProximaNovaBold"; //No I18N
		}
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("font-family",1,fontFamily));
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("font-weight",1,fontWeight));
	return ZDBUtil.getInnerHTML(tl,true);
}
ZDBDataGrid.prototype.getPaddingForFont = function(rowSpacing,fontSize,model)
{
	var padding;
    padding = fontSize / 3;
    this.defCellHeight = Math.round(fontSize*ZDBGlobal.stdCellHeight/ZDBGlobal.defaultFontsize);
    var	defHeaderHeight = Math.round((this.defCellHeight/fontSize)*ZDBGlobal.defaultFontsize);
    defHeaderHeight = (rowSpacing)*4+defHeaderHeight;
    this.defHeaderHeight = Math.round((defHeaderHeight/ZDBGlobal.defaultFontsize) * fontSize);
   
    padding = parseInt(padding);
    if(model == 1)
    	{
    	return fontSize - 8;
    	}
    if(model == 2)
    	{
    	padding + 2;
    	}
    if(rowSpacing && rowSpacing != 1)
    	{
    	padding += 2*(rowSpacing-1);
    	}
    return padding;
}

ZDBDataGrid.prototype.changeFontFamily = function(fontFamily)
{
	var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID,false);
	styleSheet.innerHTML+= this.generateFontFamilyWithWeight(fontFamily);
}

ZDBDataGrid.prototype.removeGridFromThemeArrays = function(index)
{
	
	 for(var i=1;i<=7;i++)
	  {
	  var arrayName = "t"+i+"Grids"; //NO I18N
	  var gridArray = ThemeComponent[arrayName];
	  var checkIndex = gridArray.indexOf(this.ID);
	  if(checkIndex > -1)
		  {
		  gridArray.splice(checkIndex,1);
		  break;
		  }
	  }
	
}

ZDBDataGrid.prototype.changeGridTheme = function(index,baseColor)
{    
//	this.removeGridFromThemeArrays();
//     if(ThemeComponent.isThemeGenerated[index])
//    	 {
    if((index > 0 && index < 4) || index === 6 || index === 8)
    	{
    	 var tempIndex = index;
    	 if(tempIndex == 6 || tempIndex == 8)
    		 {
    		 tempIndex = 3;
    		 }
    	 if(this.type == "PivotSheet" || this.type == "SummarySheet")
            {
    		 this.gArea.className = "PivotSheet t"+tempIndex;
            }
    	 else if(this.type == "Report")
    	 	{
    		 this.gArea.className = "tabularSheet t"+tempIndex;
    	 	}
    	}
    else if(index > 0)
    	{
    	 if(this.type == "PivotSheet" || this.type == "SummarySheet")
    	 	{
    		 this.gArea.className = "PivotSheet"
    		}
    	 else if(this.type == "Report")
    		{
    		 this.gArea.className = "tabularSheet";
    		}
    	}
//    	 }
 /*    else if((index > 0 && index < 4) || index === 6 || index === 8)
    	 {
	var tl=new Object();
	var mainClass = "t"+index; //NO I18N
	tl.mainClass = mainClass;
	var affectedStylesAndValues =[];
	switch (index)
	{
	case 1:
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-right",1,"0px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-width",2,"0px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-bottom",3,"1px solid #fff !important"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-right",4,"1px solid"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("background-color",1,"#fff"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("background-color",2,"#fff"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-top-width",5,"0px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-top-color",5,"#fff"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-bottom-width",5,"1px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-right",6,"1px solid"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-left",1,"0px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-right",7,"1px solid"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-bottom-color",8,"#fff"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("background-image",9,"none"));
		break;
	case 3:
	case 6:
	case 8:
		tl.mainClass = "t3"; //NO I18N
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-right-width",1,"0px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-right-width",2,"1px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-bottom-width",3,"0px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("border-bottom-width",4,"1px"));
		affectedStylesAndValues.push(ZDBUtil.returnStyleObject("background-image",5,"none"));
		break;
	}
	if(index != 2)
		{
	var affectedStyleGroups = [];
	
	affectedStyleGroups = ThemeComponent[tl.mainClass + "affectedStyleGroups"];
		
	tl.affectedStyleGroups = affectedStyleGroups;
	tl.affectedStylesAndValues = affectedStylesAndValues;
	ZDBUtil.createAndAppendThemeStyle(tl);
		}
	if(this.type == "PivotSheet" || this.type == "SummarySheet")
    {
	this.gArea.className = "PivotSheet "+tl.mainClass;
    }
 else if(this.type == "Report")
	 {
	 this.gArea.className = "tabularSheet "+tl.mainClass;
	 }	
	if(index == 6 || index == 3 || index ==8)
	    {
	 	ThemeComponent.isThemeGenerated[3] = true;
	 	ThemeComponent.isThemeGenerated[6] = true;
	 	ThemeComponent.isThemeGenerated[8] = true;
		}
	ThemeComponent.isThemeGenerated[index] = true;
    }
     else if(index > 0)
    	 {
    	 if(this.type == "PivotSheet" || this.type == "SummarySheet")
    		 {
   this.gArea.className = "PivotSheet"
    		 }
    	 else if(this.type == "Report")
    		 {
    		 this.gArea.className = "tabularSheet";
    		 }
    }
     
     ThemeComponent["t"+index+"Grids"].push(this.ID);  //NO I18N

     */
	var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID,true);
	styleSheet.innerHTML = this.applyThemeColor(index,baseColor);
}

ZDBDataGrid.prototype.setSpacing = function(rowSpacing,currentFontSize)
{
	var styleSheet = ZDBUtil.getStyleSheet(this.gArea,this.ID,false);
	rowSpacing = parseInt(rowSpacing);
//	this.setRowSpacing(rowSpacing);
	var padding = this.getPaddingForFont(rowSpacing,currentFontSize);
	var paddingGroup = ["dR","dL","sL","sR","tR","tL","zdbRowHead","groupCell","groupCellEnd","zdbDataCell","groupSummary","sectionHeader"];//No I18N
	if(this.type == "Report")
	{
		paddingGroup.push("zdbColHeadDisplay");
	}
    var tl = new Object();
    tl.mainClass = "div[gridid='"+this.ID+"']"; //No I18N
    tl.affectedStyleGroups = [];
    tl.affectedStyleGroups.push(paddingGroup);
	tl.affectedStylesAndValues = [];
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("padding-top",1,padding+"px"));
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("padding-bottom",1,padding+"px"));
	styleSheet.innerHTML += ZDBUtil.getInnerHTML(tl,true);	
}

ZDBDataGrid.prototype.applyUrlTheme = function()
{
        if(ZDBGlobal.PVT_THEME_NAME > 0 && ZDBGlobal.PVT_THEME_NAME < 8)
        {
            this.themeProp.zr_theme_name = ZDBGlobal.PVT_THEME_NAME;
        }
        if(ZDBGlobal.PVT_THEME_FS >0)
        {
            this.themeProp.zr_theme_font_size = ZDBGlobal.PVT_THEME_FS;
        }
        if(ZDBGlobal.PVT_THEME_RS > 0)
        {
            this.themeProp.zr_theme_row_spacing = ZDBGlobal.PVT_THEME_RS;
        }
        if(ZDBGlobal.PVT_THEME_COLOR)
        {
            this.themeProp.zr_theme_color = "#"+ZDBGlobal.PVT_THEME_COLOR;
        }
        if(ZDBGlobal.PVT_THEME_FF)
        {
            this.themeProp.zr_theme_font_family =  ZDBGlobal.PVT_THEME_FF;
        }
}

ZDBDataGrid.prototype.getThemeNo = function()
{
	return parseInt(this.themeProp.zr_theme_name) ? parseInt(this.themeProp.zr_theme_name) : 4;
} 
ZDBDataGrid.prototype.getThemeColor = function()
{
	return this.themeProp.zr_theme_color ? this.themeProp.zr_theme_color.substring(1) : "e2e2e2";//NO I18N
}
ZDBDataGrid.prototype.getFontSize = function()
{
	return parseInt(this.themeProp.zr_theme_font_size) ? parseInt(this.themeProp.zr_theme_font_size) : ZDBGlobal.defaultFontsize;
}

ZDBDataGrid.prototype.getFontFamily = function()
{
	var fontFamily = this.themeProp.zr_theme_font_family ? this.themeProp.zr_theme_font_family : ZDBGlobal.defaultFont;
        
	if(ThemeComponent.themeFontValues[fontFamily])
		{
		return fontFamily;
		}
	else
		{
		return ZDBGlobal.defaultFont;
		}
}
ZDBDataGrid.prototype.getRowSpacing = function()
{
	return parseInt(this.themeProp.zr_theme_row_spacing) ? parseInt(this.themeProp.zr_theme_row_spacing) : 1;
}
ZDBDataGrid.prototype.setThemeNo = function(themeNo)
{
	ThemeComponent.setThemeNo(this.themeProp,themeNo);
}
ZDBDataGrid.prototype.setThemeColor = function(themeColor)
{
	ThemeComponent.setThemeColor(this.themeProp,themeColor);
}
ZDBDataGrid.prototype.setFontSize = function(fontSize)
{
	ThemeComponent.setFontSize(this.themeProp,fontSize);
}
ZDBDataGrid.prototype.setFontFamily = function(fontFamily)
{
	ThemeComponent.setFontFamily(this.themeProp,fontFamily);
}
ZDBDataGrid.prototype.setRowSpacing = function(rowSpacing)
{
	ThemeComponent.setRowSpacing(this.themeProp,rowSpacing);
}

ZDBDataGrid.prototype.adjustPivotDimension = function()
{
	  this.generatePivotColumnWidth(this.widthArray,true);
	  this.generateLeftColumnWidth(this.rhWidthArray);
	  this.maintainGridHeadArrays(this.gridHeaderRows,true);
	  this.adjustInViewPivotRowsHeight();
	  this.adjustDimension();
	  this.checkAndInsertHeaderAlignCssIE();
}

ZDBDataGrid.prototype.checkAndInsertHeaderAlignCssIE = function()
{
	if(BROWSER.IE != 1 || BROWSER.IE11AndAbove == 1 || BROWSER.EDGE == 1)
	{
		return;
	}
	var isAlreadyGenerated = document.getElementById("columnHeaderVAlign") ? true : false; //No I18N
	if(isAlreadyGenerated)
	{
		return;
	}
	var transform ;
	if(BROWSER.VERSION.indexOf("10") == -1)
		{
		transform = "-ms-transform";//No I18N
		}
	else
		{
		transform = "transform";//No I18N	
		}
	var style = document.createElement('style'); //No I18N
	style.type = "text/css";//No I18N
	style.id = "columnHeaderVAlign"; //No I18N
	document.getElementsByTagName("head")[0].appendChild(style);
	var tl = new Object();
	tl.mainClass = "PivotSheet"; //No I18N
	tl.affectedStylesAndValues = [];
	tl.affectedStyleGroups= [["zdbColHeadDisplay"],["hRow > span"]]; //No I18N
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject(transform,1,"translateY(-50%)"));
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("top",1,"50%"));
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("top",2,"50%"));
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject(transform,2,"translateY(-50%)"));
	tl.affectedStylesAndValues.push(ZDBUtil.returnStyleObject("position",2,"relative"));
	style.innerHTML = ZDBUtil.getInnerHTML(tl);

}

ZDBDataGrid.prototype.adjustOnData = function()
{
	var child = this.dTable.children[0].children;
	this.dTable.style.width = "";
	var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
	styleSheet.innerHTML ="";
    for(var i=0;i<this.widthArray.length;i++)
    	{
    	this.widthArray[i] = child[i].offsetWidth;
    	}
    var colHead = this.colHeaders;
	for(var i=this.rhWidthArray.length;i<colHead.length-2;i++)
		{
		colHead[i].width = this.widthArray[i-this.rhWidthArray.length];
		 ZDBDataGrid.setColHeadDisplayWidth(this,colHead[i]);
		}
	this.adjustPivotDimension();
}

ZDBDataGrid.prototype.getCompactWidthArray = function()
{
	var rhWidthArray = this.rhWidthArray;
	var widthArray = [];
	var colHead = this.colHeaders;
	var span = document.createElement("span");
	var fontSize = this.getFontSize();
	span.style.fontSize = fontSize + "px"; //No I18N
	span.style.left = "-10000px";
    document.getElementsByTagName("body")[0].appendChild(span);
    for(var i=rhWidthArray.length;i<colHead.length-2;i++)
    	{
    	if(colHead[i].width == this.defColWidth && !this.colHeaders[i].grouped) //grouped columns not to be made compact
    		{
    		colHead[i].width = widthArray[i-this.rhWidthArray.length] = this.getCalculatedWidth(colHead[i].longString,span) + (30/ZDBGlobal.defaultFontsize)*fontSize;
		    ZDBDataGrid.setColHeadDisplayWidth(this,colHead[i]);
    		}
    	else
    		{
    		widthArray[i-this.rhWidthArray.length] = colHead[i].width;
    		}
    	}
    span.parentNode.removeChild(span);
    return widthArray;
}

//ZDBDataGrid.prototype.adjustOnCalculatedData = function()
//{
//	var rhWidthArray = this.rhWidthArray;
//	var widthArray = this.widthArray;
//	var colHead = this.colHeaders;
//	var span = document.createElement("span");
//	var fontSize = this.getFontSize();
//	span.style.fontSize = fontSize + "px"; //No I18N
//    document.getElementsByTagName("body")[0].appendChild(span);
//    for(var i=rhWidthArray.length;i<colHead.length-2;i++)
//    	{
//    	colHead[i].width = this.widthArray[i-this.rhWidthArray.length] = this.getCalculatedWidth(colHead[i].longString,span) + (30/12)*fontSize;
//		ZDBDataGrid.setColHeadDisplayWidth(this,colHead[i]);
//    	}
//    span.parentNode.removeChild(span);
//    this.adjustPivotDimension();
//}

ZDBDataGrid.prototype.getCalculatedWidth = function(value,span)
{
span.innerHTML = value;
var width = span.offsetWidth;
return width > (80 * this.getFontSize()/ZDBGlobal.defaultFontsize) ? width : Math.round(80 * this.getFontSize()/ZDBGlobal.defaultFontsize);
}
ZDBDataGrid.prototype.setRowHeight = function(rowObj)
{
	var cellObjs = rowObj.values;
	for(var i=0; i<cellObjs.length; i++)
	{
		curCellObj = cellObjs[i];     
	    curCellObj.height = rowObj.height;
	    this.placeCellElement(curCellObj,[false,false,true,false],[false,false,true,false]);
	}
}

ZDBDataGrid.prototype.retainPropsOnRefresh = function()
{
  //MAINTAINED SELECTED COLUM PROPERTY
  var selectedCols = this.selectedCols;
  if(selectedCols.length > 0)
  {
    this.selectedCols = this.getSelColsObjArr(selectedCols);
    this.selectColumn();
  //MAINTAINED SELECTED COLUM PROPERTY
  //ADD OTHER PROPERTIES BELOW
  }
}

ZDBDataGrid.prototype.getSelColsObjArr = function(colObjArr)
{
  //METHOD RETURNS SELECTED COLMNS REFERENCE ARRAY
  var colHeads = this.colHeaders;
  var colIds = [];
  var newSelectedColObj = [];

    for(var j = 0; j < colObjArr.length; j++)
    {
      for(var i = 0; i < colHeads.length; i++)
      {
        if(colHeads[i].colId == colObjArr[j].colId)
        {
          newSelectedColObj.push(colHeads[i]);
        }
      }
    }
    return newSelectedColObj;
}

ZDBDataGrid.prototype.getAdditionalCol = function(rowObj, objType, className, isFreeze, isVisible)
{

  ////var colHeader = new ZDBColHeader(this,"-1", "New", "(New)",false, false, false,null, "", "", -1 , ZDBGlobal.stdCellWidth, this.colHeaders.length, false, null,0,-1,false, ZDBConst.DUMMY, false, 1, null, null, null, false, null, null,null,null,"Left",-1,false,true,true,"dd MMM, yyyy HH:mm:ss",true);
  var colHeader = new ZDBColHeader(this, null, "", "",false, false, false, 'PLAIN',null, null, null, ZDBGlobal.stdCellWidth, -1, true, "", -1,-1, false, ZDBConst.CLEAR, false, null, null, null, -1, null, null, null, null,null, null);
  colHeader.objType = objType;
  colHeader.className = className;
  colHeader.rowObj = rowObj;
  colHeader.freeze = isFreeze;
  colHeader.visible = isVisible;
  colHeader.colObj = colHeader;
  colHeader.left = ZDBConst.NOTSET;
  colHeader.dataColRefIdx = -1;
  return colHeader;
}


ZDBDataGrid.prototype.addDummyColumn = function(baseRow)
{
  this.addColumn(this.getAdditionalCol(baseRow, ZDBConst.DUMMY, 'zdbColHead', false, false), baseRow);
}

ZDBDataGrid.prototype.addTcColumn = function(baseRow)
{
  var rIdWidth = this.calculateWidth(this.recordEnd);
  var hideRhId = baseRow.gridObj.hideRhId;
  if(rIdWidth < 30)
  {
    rIdWidth = hideRhId ? 0 : 30 ;
  }

  var colHeader = this.getAdditionalCol(baseRow, ZDBConst.ROWHEAD, 'zdbRhColHead',true, true);
  colHeader.width = rIdWidth;
  colHeader.selectDisabled = true;
  this.addColumn(colHeader, baseRow);
  if(this.type == "PivotSheet" || this.type == "SummarySheet") // temporary check for pivot and summary
	  {
  this.tcAreaRowDiv.style.width = (parseInt(this.tcAreaRowDiv.style.width) + colHeader.width) + "px";
	  }
  this.tcAreaRowDiv.style.height = colHeader.rowObj.height + "px";
}


ZDBDataGrid.prototype.addFillerColumn = function(baseRow)
{
  var fillHead = this.getAdditionalCol(baseRow, ZDBConst.FILLER, 'zdbFillerColHead', false, true);
  fillHead.selectDisabled = true;
  if(this.type == "PivotSheet" || this.type == "SummarySheet")
	  {
	  fillHead.visible = false;
	  }
  this.addColumn(fillHead, baseRow);
  this.chAreaRowDiv.style.width = (parseInt(this.chAreaRowDiv.style.width) + fillHead.width) + "px";
}


ZDBDataGrid.prototype.getLastVisibleColumn = function(startPos)
{
  var colHeads = this.colHeaders;
  var len = colHeads.length;
  if(startPos === undefined)
  {
    startPos = len -1;
  }
  for(var i=startPos; i>=0; --i)
  {
    if(colHeads[i].visible)
    {
        return colHeads[i];
    }
  }
  return null;
}

ZDBDataGrid.prototype.getFirstVisibleColumn = function()
{
  var colHeads = this.colHeaders;
  var len = colHeads.length;
  for(var i=0; i>len; ++i)
  {
    if(colHeads[i].visible)
    {
        return colHeads[i];
    }
  }
  return null;
}

ZDBDataGrid.prototype.setColVUDPerm = function(vudPerm)
{
  var colHeads = this.colHeaders;
  for(var i=0; i < colHeads.length; ++i)
  {
    if(colHeads[i].colId == null)  { continue; }
        if(LangUtils.indexOf(vudPerm,colHeads[i].colId) > -1)
        {
              colHeads[i].vudPerm = false;
        }
  }
  return null;
}

ZDBDataGrid.prototype.addColumn = function(newHeader, colHeadRow)
{
  var colHeads = colHeadRow.values;
  var colLen = colHeads.length;
//   if(colLen == 0)
//   {
//     this.addTcColumn();
//     this.addColumn(newHeader, colHeadRow);
//     return;
//   }
//   else if(colLen == 1)
//   {
//     this.addDummyColumn();
//     this.addColumn(newHeader, colHeadRow);
//     return;
//   }
//   else if(colLen == 2)
//   {
//     this.addFillerColumn();
//     this.addColumn(newHeader, colHeadRow);
//     return;
//   }
//
//   colHeads.splice(colLen-2,0,newHeader);



  ///Add columns in the proper order. i.e., rowHEAD, Dummy, Filler and then the rest;

  if(newHeader.objType === ZDBConst.ROWHEAD)
  {
    colHeads.unshift(newHeader);
  }
  else if(newHeader.objType === ZDBConst.FILLER)
  {
    colHeads.splice(colLen,0, newHeader);
  }
  else if(newHeader.objType === ZDBConst.DUMMY)

  {
    if(colHeads[colLen-1].objType == ZDBConst.FILLER)
    {
      colHeads.splice(colLen-1, 0, newHeader);
    }
    else
    {
      colHeads.push(newHeader);
    }
  }
  else
  {
    if(colLen == 0)
    {
      colHeads.push(newHeader);
    }
    else if(colLen == 1)
    {
      if(colHeads[0].objType === ZDBConst.ROWHEAD)
      {
        colHeads.push(newHeader);
      }
      else if(colHeads[0].objType === ZDBConst.COLHEAD)
      {
        colHeads.push(newHeader);
      }
      else
      {
        colHeads.unshift(newHeader);
      }
    }
    else
    {
      if(colHeads[colLen-1].objType === ZDBConst.DUMMY)
      {
        colHeads.splice(colLen-1,0, newHeader);
      }
      else if(colHeads[colLen-2].objType === ZDBConst.DUMMY)
      {
        colHeads.splice(colLen-2,0,newHeader);
      }
      else if(colHeads[colLen-1].objType === ZDBConst.FILLER)
      {
        colHeads.splice(colLen-2,0, newHeader);
      }
      else
      {
        colHeads.push(newHeader);
      }
    }
  }
  newHeader.rowObj = colHeadRow;
  colLen = colHeads.length;
  for(var i=0;i<colLen;++i) ///PK: colLen is not updated so <=, Why should I reset for all columns?
  {
    colHeads[i].cellPos = i;
  }
  
  this.addColToView(newHeader, colHeadRow);
  if(newHeader.isPK)
  {
    this.pkCols.push(newHeader); ///PK: only valid columns
    if(this.pkCols.length > 1)
    {
      this.getRowId = this.getMultiPkRowId;
    }
  }
//  if(this.getFontSize())
//	{
//	  newHeader.width =Math.round(( newHeader.width / 12) * this.getFontSize());
//	}

}


ZDBDataGrid.prototype.addRows = function(rows,addToTop)
{
  // IF addToTop equals to TRUE, SCROLL UP EVENT CALLED ELSE SCROLL DOWN
  // "rows" is an array of data
  // ONSCROLL UP, "rows" array is reversed and added to the grid
  // ONSCROLL DOWN "rows" array is not reversed
  
  var rowData = this.rowData;
  var index;
  if(addToTop)
  {
    index = ZDBDataGrid.getFirstRowIndex(rowData, false);
  }
  else
  {
    index = ZDBDataGrid.getLastRowIndex(rowData, false);
  }
  if(index < 0)
  {
    index = rowData.length;
  }
  else if(!addToTop)
  {
    ++index;
  }
  if(index > rowData.length)
  {
    index = rowData.length;
  }
 
  var dLen = rows.length;
  if(dLen>0)
    {
      if(addToTop && dLen > 1)
      {
        rows.reverse();
      }
      for(var i =0;i < dLen; ++i)
      {
        this.addNewRow(rows[i],index, null, i==(dLen-1));
        if(!(addToTop && dLen > 1))
        {
          ++index;
        }
      }
    }
  this.addFillerRow();
  this.resetDummyTop();

  this.updateNavig();
}

ZDBDataGrid.prototype.appendGrandSummaryCell = function(grandSummaryCell)
{
	//var grandSummaryCell=rows[dLen-1].values[1];
    if(grandSummaryCell && grandSummaryCell.originalValue == '-NA-')
    {
      var parentNode=grandSummaryCell.cellEl;
      parentNode.childNodes[0].innerHTML=ZDBEscapeUtil.encodeForHtml(grandSummaryCell.displayValue);
      var insertNode=ZDBUtil.getCloned('summaryValue');//No I18N
      parentNode.style.textAlign="left";
      insertNode.style.cssFloat="right";//No I18N
      insertNode.style.styleFloat="right";//No I18N
      parentNode.insertBefore(insertNode,parentNode.childNodes[0]);
    }
}

ZDBDataGrid.prototype.addNewRow = function(rowObj,index,insertBeforeDummyRow, isGrandSummaryCell)
{
  var rowData = this.rowData;
  var rowLen = rowData.length;
  var colLen = this.colHeaders.length;
  if(!(rowObj instanceof ZDBRow))
  {
    rowObj = new ZDBRow(this,rowObj, ZDBConst.DATA);
  }
  if(index === undefined)
  {
    ///PK: either DUMMY or FILLER
    var objType = rowObj.objType;
    if(objType == ZDBConst.FILLER)
    {
      rowData.push(rowObj);
    }
    else if(objType == ZDBConst.DUMMY)
    {
      ///PK: Assumption header present
        var lastRowObj = rowData[rowLen-1];
        if(lastRowObj.objType == ZDBConst.FILLER)
        {
          rowData.splice(rowLen-1,0,rowObj); 
        }
        else
        {
          rowData.push(rowObj);
        }
    }
  }
  else
  {
    rowData.splice(index,0,rowObj);
  }
  this.addRowToView(rowObj,index,insertBeforeDummyRow, isGrandSummaryCell);
}
  

ZDBDataGrid.prototype.setDataModified = function()
{
  this.dataModified = true;
  this.setModified();
}
ZDBDataGrid.prototype.setModified = function()
{
  this.modified++;
  this.addDummyRow(true, true);
  this.adjustRowFill(true);
  this.viewCtx.updateModified();
}

ZDBDataGrid.prototype.getTableErrorInfo = function() //should be removed later
{
  var rowsToCheck = this.rowsToUpdate.concat(this.newRows);
  var totRows = rowsToCheck.length; // take the local reference of this.rowData
  if(totRows == 0)
  {
    return [];
  }
  var totCols = this.colHeaders.length;
  var errorCells = [];
  for(var i=0;i<totRows;++i)
  {
    for(var j=0;j<totCols;++j)
    {
      var cellObj = rowsToCheck[i].values[j];
      if(cellObj.isError())
      {
        errorCells.push(cellObj);
      }
    }
  }
  return errorCells; //length, objects....
}
ZDBDataGrid.prototype.setNavigationInfo = function(recordStart,recordEnd,totalRecords, summaryRecords, overAllSumCount)
{
  this.recordStart = recordStart;
  this.recordEnd = recordEnd;
  this.totalRecords = totalRecords;
  this.summaryRecords = summaryRecords ? summaryRecords : 0;
  this.overAllSumCount = overAllSumCount ? overAllSumCount : 0;
  this.updateTotalCountUI();
  this.initNewRowRid(true);
}
ZDBDataGrid.prototype.setRowCountDiv = function(rowCount)
{
    this.totalRecords = rowCount;
    this.updateTotalCountUI();
    this.initNewRowRid(true);
}

ZDBDataGrid.prototype.clearCache = function()
{
  this.dataCache = new ZDBGridDataCache(this);
}

ZDBDataGrid.prototype.showFirstPage = function()
{
  this.rowsToUpdate = [];
  this.newRows = [];
  if(!ZDBGridScroll._showFirstPage(this))
  {
    this.setFirstRowWidth();
  }
  ZDBMenu.setToolbarStatus(this);
}

ZDBDataGrid.prototype.removedPVTCrs = function(criteria)
  {
    var view = this.view;
    view.removePVCritColSettings(criteria);
  }

  ZDBDataGrid.prototype.setInstMap = function(instMap)
  {
    var view = this.view;
    if(view.modified)
    {
        view.setInstMap(instMap);
    }
  }

  ZDBDataGrid.prototype.setRevInstMap = function(revInstMap)
  {
    var view = this.view;
    if(view.modified)
    {
        view.setRevInstMap(revInstMap);
    }
  }
  
  ZDBDataGrid.prototype.setMissValCol = function(isShowMissingValueAllowed,allowedMissValColInXAxis,allowedMissValColInYAxis,duplicateAllowedColMapInXAxis,duplicateAllowedColMapInYAxis,errMsg)
  {
    var view = this.view;
    view.setMissValCol(isShowMissingValueAllowed,allowedMissValColInXAxis,allowedMissValColInYAxis,duplicateAllowedColMapInXAxis,duplicateAllowedColMapInYAxis,errMsg);
  }
  
  ZDBDataGrid.prototype.setZAVCIProp = function(vciVals)
  {
    var view = this.view;
    view.setZAVCIProp(vciVals);
  }
  
  ZDBDataGrid.prototype.setPVCritProp = function(pvpVals)
  {
    var view = this.view;
    view.setPVCritProp(pvpVals);
  }
  
ZDBDataGrid.prototype.refreshRows = function(rows)
{

  this.domCache.addAllToCache();
  var colHeads = this.rowData.splice(0, ZDBDataGrid.getColRowLength(this.rowData, true));
  this.rowData = colHeads;
  if(this.type != "PivotSheet" && this.type != "SummarySheet") //temporaray check for pivot and summary
	  {
  this.addTable();
	  }
  this.addRows(rows, false);
  ZDBGridScroll.checkAndShowScroll(this,null,null);
  this.adjustRowFill(true);
  if(!this.tcWidth)
	  {
	  this.tcWidth = this.getTcAreaWidth();
	  }
}

ZDBDataGrid.prototype.addTable = function()
{  
	if(this.dTable == undefined)
	{
	var isIE9 = BROWSER.IE == 1 && BROWSER.IE11AndAbove == 0 && BROWSER.EDGE == 0 && (BROWSER.VERSION.indexOf("10") == -1);
	var div=document.createElement("div");
	div.style.display="table";
	div.id="dTable";
	div.style.tableLayout="fixed";//No I18N
	div.style.borderCollapse="separate";//No I18N
	this.dArea.appendChild(div); // ie9 is not fixed with collapse so dtable only set to separate to get visibility of fillers
	this.dTable=div;
	div=document.createElement("div");
	div.style.display="table";
	div.style.width="inherit";
	div.id="rhTable";
	div.style.tableLayout="fixed";   //No I18N
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	this.rhArea.appendChild(div);
	this.rhTable=div;
	div=document.createElement("div");
	div.style.display="table";
	div.id="chTable";
	div.style.tableLayout="fixed"; //No I18N
	div.style.height="inherit";
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	div.appendChild(this.chArea.children[0]);
	this.chArea.appendChild(div);
	this.chTable=div;
	div=document.createElement("div");
	div.style.display="table";
	div.id="tcTable";
	div.style.tableLayout="fixed";   //No I18N
	div.style.width="inherit";
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	div.appendChild(this.tcArea.children[0]);
	this.tcArea.appendChild(div);
	this.tcTable=div;
	div=document.createElement("div");
	div.style.display="table";
	div.id="fTable";
	div.style.tableLayout="fixed"; //No I18N
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	div.appendChild(this.fArea1.children[0]);
	div.appendChild(this.fArea1.children[0]);
	this.fArea1.appendChild(div);
	this.fTable=div;
	div=document.createElement("div");
	div.style.display="table";
	div.id="fhTable";
	div.style.tableLayout="fixed"; //No I18N
	div.style.width="100%";
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	div.appendChild(this.fhArea1.children[0]);
	div.appendChild(this.fhArea1.children[0]);
	this.fhArea1.appendChild(div);
	this.fhTable=div;
	}
}
ZDBDataGrid.prototype.addPivotTable = function()
{
	if(this.dTable == undefined)
	{
	var isIE9 = BROWSER.IE == 1 && BROWSER.IE11AndAbove == 0 && BROWSER.EDGE == 0 && (BROWSER.VERSION.indexOf("10") == -1);
	var div=document.createElement("div");
	div.style.display="table";
	div.id="dTable";
	div.style.tableLayout="fixed";//No I18N
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	div.style.position = "relative";
	div.style.width = this.tableWidth+"px";//No I18N
	this.dArea.appendChild(div);
	this.dTable=div;
	div=document.createElement("div");
	div.style.display="table";
	div.style.width="inherit";
	div.id="rhTable";
	div.style.tableLayout="fixed";   //No I18N
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	div.style.position = "relative";
	this.rhArea.appendChild(div);
	this.rhTable=div;
	div=document.createElement("div");
	div.style.display="table";
	div.id="chTable";
	div.style.tableLayout="fixed"; //No I18N
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	div.style.width = this.tableWidth+"px";//No I18N
	div.style.position = "relative";
	div.appendChild(this.chArea.lastChild);
	this.chArea.appendChild(div);
	this.chTable=div;
	div=document.createElement("div");
	div.style.display="table";
	div.id="tcTable";
	div.style.tableLayout="fixed";   //No I18N
	div.style.width="inherit";
	div.style.borderCollapse= isIE9 ? "collapse" : "separate";//No I18N
	div.style.position = "relative";
	div.appendChild(this.tcArea.lastChild);
	this.tcArea.appendChild(div);
	this.tcTable=div;
	}
}
ZDBDataGrid.AUTOID_COUNTER=0;
ZDBDataGrid.INSTANCEID_COUNTER=0;
ZDBDataGrid.INSTANCES= new Object();
ZDBDataGrid.addInstance = function(gridObj)
{
  gridObj.ID = ZDBDataGrid.INSTANCEID_COUNTER++;
  ZDBDataGrid.INSTANCES[gridObj.ID] = gridObj;
}
ZDBDataGrid.removeInstance = function(gridId)
{
  var gridObj =  ZDBDataGrid.INSTANCES[gridId];
  if(gridObj == null)
  {
    return;
  }
  if(gridObj.gArea.parentNode != null)
  {
    gridObj.gArea.parentNode.removeChild(gridObj.gArea);
  }
  if(gridObj.rwGrid)
  {
    gridObj.rwGrid.gArea.parentNode.removeChild(gridObj.rwGrid.gArea);
  }
  delete gridObj;
  delete ZDBDataGrid.INSTANCES[gridId];
}
ZDBDataGrid.getModifiedGrids = function()
{
  var modifiedGrids = [];
  for(var i in ZDBDataGrid.INSTANCES)
  {
    if((ZDBDataGrid.INSTANCES[i]) && (ZDBDataGrid.INSTANCES[i].modified != 0))
    {
      modifiedGrids.push(ZDBDataGrid.INSTANCES[i]);
    }
  }
  return modifiedGrids;
}


ZDBDataGrid.prototype.invokeDerivedFunction = function(zdbrow)
{
  var colHeaders = this.colHeaders;
  var headers = [];
  for(var i = 0;i < colHeaders.length;i++)
  {
    if(colHeaders[i].derivedFunction != null)
    {
      headers.push(colHeaders[i]);
    }
  }

  for(var i = 0;i < headers.length - 1;i++)
  {
    for(var j = i + 1;j < headers.length;j++)
    {
      if(headers[j].dervIndex < headers[i].dervIndex)
      {
        var temp = headers[i];
        headers[i] = headers[j];
        headers[j] = temp;
      }
    }
  }

  for(var i = 0;i < headers.length;i++)
  {
    var value = headers[i].derivedFunction(zdbrow);
    var dispVal = null;
    if(value != null)
    {
      var zdbcell = zdbrow.values[headers[i].cellPos];
      if(zdbcell != null)
      {
        if(value == ZDBConst.NEEDSAVE)
        {
          dispVal = ZDBConst.NEEDSAVE;
          value = '';
          zdbcell.isHtml = true;
          zdbcell.displayNode = zdbcell.cellEl;
        }
        zdbcell.setValue(value, dispVal, true, false);
      }
    }
  }
}



ZDBDataGrid.prototype.isFieldExists = function(fieldName)
{
  var headers = this.colHeaders;
  for(var i = 1;i < headers.length;i++)
  {
    var header = headers[i];
    if(header.displayName && header.displayName.toLowerCase() == fieldName.toLowerCase())
    {
      return true;
    }
  }
  return false;
}
ZDBDataGrid.prototype.getNewRowIndex = function()
{
  var rowData = this.rowData;
  for(var i=rowData.length -1; i > -1; i--)
  {
    if((rowData[i].rowType != ZDBConst.DUMMY)
       && (rowData[i].status != ZDBConst.CREATED))
    {
      return i+1;
    }
  }
  return 0;
}

/**
 * You can pass args to be passed to the functions via funcArgs. But it should be stateless
 * or should do proper validation as the grid structure might have changed!!. A good example would
 * be the setClass method.
 * <br><b>Speed</b> is muliplied with colheader size!!
 * <br><b>Note</b>
 */
ZDBDataGrid.invokeLazyly = function(gridObj,curIndex,stepSize,funcToInvoke,initialTimeout,speed,funcArgs)
{
  var combined = new Array(2);
  if(funcArgs != null)
  {
    combined = combined.concat(funcArgs);
  }
  var invoker = function(){
    var endIndex = curIndex + stepSize;
    if(endIndex > gridObj.rowData.length)
    {
      endIndex = gridObj.rowData.length;
    }
    combined[0] = curIndex;
    combined[1] = endIndex;
    if(funcToInvoke instanceof Function)
    {
      try //PK: Check try catch required
      {
        funcToInvoke.apply(gridObj,combined);
      }
      catch(e)
      {//$$ Should log some message!!.
        //console.log(e);
        endIndex = gridObj.rowData.length;
      }
    }
    if(endIndex < gridObj.rowData.length)
    {
      curIndex = endIndex;
      ZDBUtil.setTimeout(arguments.callee, null, null, gridObj.colHeaders.length * speed);
    }
    else
    {
      gridObj = null;
      combined = null;
      funcToInvoke = null;
    }
  }
  ZDBUtil.setTimeout(invoker, null, null, initialTimeout);
}

ZDBDataGrid.evalAjaxResponse = function(response,requestOptions)
{
  ZDBDataGrid.parseGridResponse(requestOptions["GRIDOBJ"],response.responseText);
}

ZDBDataGrid.parseGridResponse = function(gridObj,responseText,view,isFromScroll)
{
  var jsonObj = JSON.parse(responseText);
  var visibleColHead,allColHeads;
  /* visibleColsAlone in jsonObj is true for Table View, Tabular View and Query Table view. In these cases we will not receive hidden 
     in the client. So we maintain two arrays for columns. jsonObj.allColHead will contain details of all the columns(Event the hidden ones)
     jsonObj.colHead will have only the column details of visible Columns */
  /*All the above mentioned are applicable only for Table view, Tabular View and Query Table View only, not for VUD or any views present in 
  a Dashboard*/

  if(jsonObj.colHead && jsonObj.visibleColsAlone) {
		visibleColHead = [];
		allColHeads = [];
		for (var i = 0; i < jsonObj.colHead.length; i++) {

			allColHeads.push(jsonObj.colHead[i]);
			
			if (jsonObj.colHead[i][ZDBGlobal.columnVisible]
					|| jsonObj.colHead[i][ZDBGlobal.columnId] == "__ZDBID" 
					|| jsonObj.colHead[i][ZDBGlobal.columnSection]) {
				visibleColHead.push(jsonObj.colHead[i]);
			} else {
				continue;
			}
		}
		jsonObj.colHead = visibleColHead;  //Only visible column header details are present. 
		jsonObj.allColHead = allColHeads;  //All the column Details are present in here.
  }
  else{
	  jsonObj.allColHead = jsonObj.colHead
  }
  
  if(jsonObj.grid_instance)
  {
    var gridObj = ZDBDataGrid.INSTANCES[jsonObj.grid_instance];
    if(jsonObj.saved){gridObj.saved();}
    if(jsonObj.refErrors){gridObj.setRefErrors(jsonObj.refErrors);}
    return gridObj;
  }
  var retVal = null;
  var type = null;  
  type = jsonObj.grid_param.type;
  if(jsonObj.new_grid)
  {
    retVal = ZDBDataGrid.createAndInitGridObj(jsonObj.new_grid,type,view,jsonObj.theme_prop);
  }
  if(gridObj == null)
  {
    gridObj = retVal;
  }
  if(gridObj == null){ return retVal;}
  gridObj.loaded = false;
  if(view && view.height)
	  {//if there is 'view.height', it was invoked for the purpose of setting grid dimensions
	  gridObj.view = null;//In ZDBTableGrid.placeDataSheet function we will use temp view to pass height and width
	  }//that view to be removed, because for grids, there should not be gridObj.view
  else
	  {
	  gridObj.view = view;
	  }
  if(jsonObj.clearCache)
  {
    gridObj.clearCache();
  }
  gridObj.dataCache.addToCache(jsonObj.dataText,jsonObj.grid_param.dataColOrder,jsonObj.navigInfo,jsonObj.dataIndexArray);
  gridObj.invokeGridScripts(jsonObj);
  if(gridObj.type == "PivotSheet" || gridObj.type =="SummarySheet")
	  {
  for(var i=0;i<jsonObj.maxValueArray.length;i++)
	  {
	  gridObj.colHeaders[i+1].longString = jsonObj.maxValueArray[i];
	  }
	  }
  gridObj.colHead=jsonObj.colHead;
  if(gridObj.type == "TableDesign")
  { 
	gridObj.addTable();
    gridObj.freezeColumn(gridObj.getColumnIndex('FIELDNAME'));  //No I18N
    //$$NEWUI$$: cell focus changed when freeze column(above function gridObj.freezeColumn) is applied for table design
    //Need to remove this call and handle properly(repeated use of setCellFocus)
    var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
    if(lastFocusCell)
    {
      gridObj.setCellFocus(lastFocusCell, false);
    }
  }
  if(gridObj.type == "PivotSheet" ||  gridObj.type == "SummarySheet")
	  {
	  gridObj.addPivotTable();
	  if(gridObj.gridHeaderRows != null)
      {
		  gridObj.addPivotHeadRows(gridObj.gridHeaderRows);
      }
	  gridObj.maintainPivotWidthArray(gridObj.colHeaders);
	  gridObj.adjustColHeadAreaDimension();
	  gridObj.generatePivotColumnWidth(gridObj.widthArray,true);
	  gridObj.generateLeftColumnWidth(gridObj.rhWidthArray);
	  gridObj.maintainGridHeadArrays(gridObj.gridHeaderRows,true);
	  }
  else if(gridObj.type == "Table" || gridObj.type == "AnalysisSheet" || gridObj.type == "Report" || gridObj.type == "QueryTable")
	  {
	  gridObj.addTable();
	  }
  if(jsonObj.showFirstPage)
  {
    gridObj.showFirstPage();
  }
  if(jsonObj.killedForMaxTime)
  {
	ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.js.datasheet.viewsorttimeout"));
  }
  gridObj.loaded = true;
  if(gridObj.freeze && !(gridObj.type == "TableDesign") && !isFromScroll)
  {
    gridObj.freezeColumn(gridObj.colHeaders[gridObj.freezePos]);
  }
  ZDBUtil.setCacheTime(gridObj,jsonObj.oldCacheTime);
  var deletedRowCount =0 ;
  gridObj.deletedRowCount = deletedRowCount ;
  var addedRowCount = 0;
  gridObj.addedRowCount = addedRowCount;
  return gridObj;
  
}

ZDBDataGrid.createAndInitGridObj = function(gridParamArr,type,view,themeProp)
{
  var gridObj = null;
  switch(type)
  {
  case "Table": //No I18N
  case "QueryTable":  //No I18N
    gridObj = ZDBTableGrid.createGrid.apply(null,gridParamArr);
    break;
  case "Report":  //No I18N
    gridObj = ZDBReportGrid.createGrid.apply(null,gridParamArr);
    break;
  case "PivotSheet":  //No I18N
  case "SummarySheet":  //No I18N
	  gridObj = ZDBAnalysisGrid.createGrid.apply(null,gridParamArr);
	  break;
  case "VUDSheet":  //No I18N
  case "AnalysisSheet": //No I18N
    gridObj = ZDBAnalysisGrid.createGrid.apply(null,gridParamArr);
    break;
  case "TableDesign": //No I18N
    gridObj = ZDBDesignGrid.createGrid.apply(null,gridParamArr);
    break;
  //case query table preview grid
    
  }
  if(gridObj)
	  {
	  gridObj.init(view,themeProp);
	  }
  return gridObj;
}

ZDBDataGrid.prototype.invokeGridScripts = function(jsonObj)
{
  if(jsonObj.grid_param)
  {
    for(key in jsonObj.grid_param)
    {
      this[key] = jsonObj.grid_param[key];
    }
  }
    if(jsonObj.newTableInfo)
    {
      ZDBDesignGrid.newTableAdded.apply(this, jsonObj.newTableInfo);
    }
  if(jsonObj.perm)
  {
    this.setSecurityDetails.apply(this,jsonObj.perm);
  }
  if(jsonObj.tableIdDispNameMapping && this.type == "VUDSheet" )
  {
    this.setTableIdNameMapping(jsonObj.tableIdDispNameMapping);
    if(jsonObj.otherRelatedTables)
    {
        this.setOtherRelatedTableIds(jsonObj.otherRelatedTables);
    }
  }
  if(jsonObj.theme_prop)
  {
	  this.themeProp = jsonObj.theme_prop;
	  this.changeGridTheme(this.getThemeNo(),this.getThemeColor());
	  this.appendFontSizeAndPadding(this.getRowSpacing(),this.getFontSize(),this.getFontFamily());
	  this.calculateMinRowsCount();
  }
  if(jsonObj.colHead)
  {
        this.setColumnHeaders(jsonObj.colHead);
  }
  if(jsonObj.allColHead){
	  this.allColHead = jsonObj.allColHead;
	  this.visibleColsAlone = jsonObj.visibleColsAlone;
  }
  if(jsonObj.reportFunction)
  {
    this.addRepFn(jsonObj.reportFunction);
  }
  if(jsonObj.navigInfo)
  {
    this.setRowCountDiv(jsonObj.navigInfo[2]);
    this.setNavigationInfo.apply(this,jsonObj.navigInfo);
  }
  if(jsonObj.PVCritProp)
  {
    this.setPVCritProp(jsonObj.PVCritProp);
  }
  if(jsonObj.ZAVCIProp)
  {
    this.setZAVCIProp(jsonObj.ZAVCIProp);
  }
  if(jsonObj.InstMap)
  {
    this.setInstMap(jsonObj.InstMap);
  }
  if(jsonObj.RevInstMap)
  {
    this.setRevInstMap(jsonObj.RevInstMap);
  }
  if(jsonObj.hasOwnProperty("isShowMissingValueAllowed") && jsonObj.allowedMissValColInXAxis && jsonObj.allowedMissValColInYAxis && jsonObj.duplicateAllowedColMapInXAxis && jsonObj.duplicateAllowedColMapInYAxis)
  {
		var errMsg = null;
		if(jsonObj.hasOwnProperty("showMissValFailMsg"))
		{
			errMsg = jsonObj.showMissValFailMsg;
		}
		this.setMissValCol(jsonObj.isShowMissingValueAllowed,jsonObj.allowedMissValColInXAxis,jsonObj.allowedMissValColInYAxis,jsonObj.duplicateAllowedColMapInXAxis,jsonObj.duplicateAllowedColMapInYAxis,errMsg);
  }
  if(jsonObj.RemovedPVTCrs)
  {
    this.removedPVTCrs(jsonObj.RemovedPVTCrs);
  }
  if(jsonObj.PVTColHead)
  {
    this.setPvtColumnHeaders(jsonObj.PVTColHead);
  }
  if(jsonObj.simpleFilter)
  {
    this.setSimpleFilter(jsonObj.simpleFilter);
  }
  if(jsonObj.filterId)
  {
    this.setFilterId.apply(this, jsonObj.filterId);
  }
  if(jsonObj.directFilter)
  {
    this.setDirectFilter(jsonObj.directFilter);
  }
    if(jsonObj.grid_param.ReplaceCount)
    {
      ZDBFindAndReplace.showSummaryReport(this.ReplaceCount);
    }
    if(jsonObj.updateView)
    {
      this.updateViewAfterSave();
    }
    if(jsonObj.zaf && this.view)
    {
        this.view.zacf.setData(jsonObj.zaf);
    }
    if(jsonObj.condFormat && this.view)
    {
    	var condFormatObj = jsonObj.condFormat;
    	var condFormat = new CondFormDetails(condFormatObj.condRules, condFormatObj.formatRows, condFormatObj.kpiRows, condFormatObj.textFuncRows);
      condFormat.setCondFormatRule();
    	condFormat.setCname(this.view);
      this.view.condFormat = condFormat;
    }
    if(jsonObj.isCondViewModified)
    {
      ZACondFormUtil.checkAndDisplayMessage(jsonObj.isCondViewModified);
    }
}

ZDBDataGrid.prototype.getFieldName = function(field)
{
  var headers = this.colHeaders;
  var fieldName = "Column";
  var counter = 1;
  if(field)
  {
    fieldName = field;
  }
  for(var i = 1;i < headers.length;i++)
  {
    var header = headers[i];
    if(field)
    {
      //$$ : This is done to avoid the same name generated in two different reports
      // Need to handle the name generation in server side - after confirming
      // about the view concepts
      if("Funny" == "Report") ///PK: to be analysed
      {
        counter = ++ZDBGlobal.dervFieldNameCnt;
        break;
      }
      else if(header.displayName.toLowerCase().indexOf(field.toLowerCase()) != -1)
      {
        counter++;
      }
    }
    else if(header.formula)
    {
      counter++;
    }
  }
  fieldName = this.isExists(counter, fieldName);
  return fieldName;
}
ZDBDataGrid.prototype.isExists = function(counter, fieldName)
{
  var connector = '';
  var gridObj= this;;
  if(gridObj.type == "Report")
  {// to have a different generated name as that of from table view
    connector = '_';
  }
  if(gridObj.isFieldExists(fieldName + connector + counter))
  {
    return this.isExists(++counter, fieldName);
  }
  return fieldName + connector + counter;
}
ZDBDataGrid.prototype.getFirstVisibleHeaderPos = function()
{
  var headers = this.colHeaders;
  for(var i = 0; i < headers.length; i++)
  {
    var curHead = headers[i];
    if(curHead.objType === ZDBConst.COLHEAD && curHead.visible)
    {
      return headers[i].cellPos;
    }
  }
  return 1;
}
ZDBDataGrid.prototype.getDispNameForId = function(colId)
{
  var headers = this.colHeaders;
  for(var i = 0; i < headers.length; i++)
  {
    if(headers[i].colId == colId)
    {
      return headers[i].displayName;
    }
  }
  return null;
}
ZDBDataGrid.prototype.isGrouped = function()
{
  var headers = this.colHeaders;
  for(var i = 0; i < headers.length; i++)
  {
    if(headers[i].grouped)
    {
      return true;
    }
  }
  return false;
}
ZDBDataGrid.prototype.deleteAllRows = function(clickType,requestOptions)
{
  var gridObj= this;
  var checkDepParam = "";
  var onSuccessFunc;
  if(!clickType)
  {
    checkDepParam = "&CHECKDEP=true";
    onSuccessFunc = gridObj.handleDelRowsWithDep;
  }
  else if(clickType)
  {
    if(clickType == "NO")
    {
      return;
    }
    gridObj= requestOptions["GRIDOBJ"];
    onSuccessFunc = gridObj.handleDelRows;
  }
  var action = "DELETEALLROWS"; //No I18N
  var params = "OBJID=" + gridObj.objId + checkDepParam +
               "&GRIDID=" + gridObj.ID;
  var filterDelete = (requestOptions) ? requestOptions["FILTERDELETE"] : false;
  if(filterDelete)
  {
    action = "DELETEFILTEREDROWS"; //No I18N
    var filterParams = gridObj.getSimpleFilter(false) + gridObj.getDirectFilter();
    if(ZDBClientUI.zoho_criteria)
    {
        filterParams += "&ZOHO_CRITERIA=" + encodeURIComponent(ZDBClientUI.zoho_criteria); //No I18N
    }
    params += filterParams;
  }
  var url = "/ZDBDatabaseActionMI.ma?ZDBACTION="+action; //No I18N
  var curTab = ZDBClientUI.selectedTab;
  AjaxAPI.sendRequest({URL:url,PARAMETERS:params,GRIDOBJ:gridObj,
                       ONSUCCESSFUNC:onSuccessFunc,FILTERDELETE:filterDelete,
                       "TAB":curTab,OPSTATUSID:curTab.tabIcon});
}
ZDBDataGrid.prototype.handleDelRowsWithDep = function(response,requestOptions)
{
  var gridObj= requestOptions["GRIDOBJ"];
  var params = response.getResponseParams();
  var depTbls = params["DEPTABLES"];
  var msg = "";
  var filterDelete = requestOptions["FILTERDELETE"];
   if(depTbls != "")
  {
    var key = (filterDelete) ? "zrpt.common.toolbar.table.zdbalertmsg.js.delFilteredRowsWithDepConfirm" : "zrpt.common.toolbar.table.zdbalertmsg.js.delRowsWithDepConfirm"; //No I18N
    msg = ZDBI18NMap.f(key, ZDBEscapeUtil.encodeForHtml(gridObj.displayName), ZDBEscapeUtil.encodeForHtml(depTbls));
  }
  else
  {
    var key = (filterDelete) ? "zrpt.common.toolbar.table.zdbalertmsg.js.delFilteredRowsConfirm" : "zrpt.common.toolbar.table.zdbalertmsg.js.delRowsConfirm"; //No I18N
    msg = ZDBI18NMap.f(key,ZDBEscapeUtil.encodeForHtml(gridObj.displayName));
  }

  var func = (filterDelete) ? gridObj.deleteFilteredRows : gridObj.deleteAllRows;
  ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:func,GRIDOBJ:gridObj}); //No I18N
}

ZDBDataGrid.prototype.handleDelRows = function(response,requestOptions)
{
  var gridObj = requestOptions["GRIDOBJ"];
  ZDBDataGrid.parseGridResponse(gridObj,response.responseText);
}

ZDBDataGrid.prototype.getSelectedColHead = function()
{
  if(this.selectedCols.length > 0)
  {
    return this.selectedCols[0]; //PK: First column selected
  }
  else if(ZDBDataGrid.getLastFocusCell(this))
  {
    return ZDBDataGrid.getLastFocusCell(this).colObj;
  }
  return null;
}

ZDBDataGrid.prototype.addPivotHeadRows = function(headRows)
{
      ///PK:: should add Rows from leaf row to root row
    ///top column row should be added at the end
//     var head0 = [['The Head',8]];
//     var head1 = [['T1',3], ['T2',5]];
//     var head2 = [['H1',1], ['H2',2], ['H3',4],['H4',1]];
//     headRows = [head2, head1, head0];
    //headRows = [[['X1',1], ['X2',2],['X3',2], ['X4',2],['X5',1]] , [['T1',3], ['T2',5]] , [['The Head',8]]];
    if(this.pivotAdded)
    {
      return; ///PK: To be removed
    }
    this.pivotAdded = true;

    if(headRows != null)
    {
        //for(var i=headRows.length-1;i>=0;i--)
        for(var i=0; i<headRows.length;i++)
        {
            this.addPivotRow(headRows[i],i);
            this.addPivotHeadTable(i);
        }
    }
    else
    {
        return;
    }
    this.adjustDimension();
    var rowData = this.rowData;
    var rowLen = rowData.length;
    var colLen = ZDBUtil.indexOf(rowData, this.baseRow);

    var curRow, values, valLen;
    for(var i=0;i<rowLen;++i)
    {
      curRow = rowData[i];
      if(curRow.objType === ZDBConst.COLHEAD)
      {
        values = curRow.values;
        valLen = values.length;
        for(var k=0;k<valLen;++k)
        {
          this.placeCellElement(values[k], [true, false, false, false],[false, false, false,false]);
        }
      }
      else
      {
        break;
      }
    }
  i=0;
  while(rowData[i] && rowData[i].objType === ZDBConst.COLHEAD)
  {
    i++;
  }
  i=i-2;
  if(i>=0)
  {
   values=rowData[i].values;
   valLen=values.length;
   var sumNode=values[valLen-3]
   if(sumNode.originalValue == "&hyp;NA&hyp;")
   {
     var parentNode=sumNode.cellEl;
     parentNode.childNodes[0].innerHTML=ZDBEscapeUtil.encodeForHtml(sumNode.displayValue);
     var insertNode=ZDBUtil.getCloned('summaryValue');//No I18N
     parentNode.insertBefore(insertNode,parentNode.childNodes[0]);
   }
  }
}

ZDBDataGrid.prototype.addPivotRow = function(curRowData, index)
{
    var rowData = this.rowData;
    var pivotRow = new ZDBRow(this,null,ZDBConst.COLHEAD,"colHeadR", ZDBGlobal.stdColHeight, true,true); //No I18N
    pivotRow.height = ZDBGlobal.stdColHeight;

    var baseHeads = this.colHeaders;
    var baseLen = baseHeads.length;

    for(var i=0;i<baseLen;++i)
    {
     if(baseHeads[i].freeze || baseHeads[i].unFreezeForScroll)
     {
      curRowData.splice(i,0,(["","",1])); /// Add blank for FREEZE zone
     }
    }

    curRowData.push(["","",1]); //Dummy
    curRowData.push(["","",1]); //Filler

    var curDataLen = curRowData.length;


    var colObj, curHead;
    var disp, orig, len;
    var curCellInfo;
    var cellObj;
    var baseHeads = this.colHeaders;
    var colIndex = 0;
    var values = [];
    for(var i=0;i<curDataLen;++i)
    {
      curCellInfo = curRowData[i];
      disp = curCellInfo[1];
      orig = curCellInfo[0];
      len = parseInt(curCellInfo[2],10);

      cellObj = new ZDBCell(pivotRow, baseHeads[colIndex],  orig, disp, 'hRow', ZDBConst.GROUPNONE, false, 0); //No I18N
      if(i == 0)
      {
        cellObj.className = "zdbRhColHead";
      }
      else if(i == curDataLen-1)
      {
        cellObj.className = "zdbFillerColHead";
      }
      cellObj.startIndex = colIndex;
      for(var j=0;j<len;++j)
      {
        ++colIndex;
      }
      cellObj.endIndex = colIndex-1;
      cellObj.vcIdent = curCellInfo[3];
      values.push(cellObj);
    }
    pivotRow.values = values;
    this.addNewRow(pivotRow, index);
}

ZDBDataGrid.prototype.pivotCellOnClick = function(cellObj)
{
  var msg = ZDBDataGrid.getCriteriaMsg(this, cellObj, true);
  ZDBVUDataAPI.viewUD(this.viewObj,msg);
}

ZDBDataGrid.getCriteriaMsg = function(gridObj, cellObj, isVud)
{
  var colObj = cellObj.colObj;
    if(colObj.objType == ZDBConst.ROWHEAD)
    {
        return;
    }

    if(colObj.vudPerm==false)
    {
      return;
    }

    var view = gridObj.viewObj;
    if(view.chartArea.blured==null || view.chartArea.blured==true)
    {
      return;
    }
    var rowInfo = ZDBDataGrid.getPivotRow(gridObj, cellObj);

    var msg = "-PVT-";
    for(var i=0;i<rowInfo.length;++i) //rowObj
    {
        msg += ZDBAnalysisView.replaceInstKey(view, rowInfo[i][0].colName, isVud) + "-P-" + ZDBDataGrid.getOrigValForVUD(rowInfo[i][1]) + "-N-";
    }
    //console.log("ROWMSG: " + msg);
    var cellPos = colObj.cellPos;
    var yAxisListLength = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","YAXIS").length;//No I18N
    if(cellPos > yAxisListLength) //non freeze cols meaning Xdata as cols
    {
        //getting X headers and consytructing criteria         //XheaClick
        var colInfo = ZDBDataGrid.getPivotCOLUMN(gridObj, cellObj);
        for(var i=0;i<colInfo.length;++i)
        {
            msg += ZDBAnalysisView.replaceInstKey(view, colInfo[i].vcIdent, isVud) + "-P-" + ZDBDataGrid.getOrigValForVUD(colInfo[i].originalValue) + "-N-";
        }
        //console.log("HEADERMSG: " + msg);
        if(cellObj.rowObj.objType == ZDBConst.DATA) //if selected is data cell    //data cell
        {
            msg = ZDBDataGrid.getPivotOrSummaryMsg(msg, colObj, view.typeValue, view, isVud);
            msg +="-VL--P-"+ZDBDataGrid.getOrigValForVUD(cellObj.originalValue);
        }
        else //if selected is summary cell/ViewColObjCell/XHeaderCellheader cell
        {
            if(cellObj.rowObj.objType == ZDBConst.SUMMARY) //summary cell
            {
                msg = ZDBDataGrid.getPivotOrSummaryMsg(msg, colObj, view.typeValue, view, isVud);
                //console.log("DTMSG: " + msg);
                msg +="-VL--P-"+ZDBDataGrid.getOrigValForVUDForNull(cellObj.originalValue,"-FR-");
            }
            else if(cellObj instanceof ZDBColHeader) //view col HEAD and not x col head         // ViewColObj
            {
                 msg = ZDBDataGrid.getPivotOrSummaryMsg(msg, colObj, view.typeValue, view, isVud);
                 //console.log("DTMSG: " + msg);
                 msg +="-VL--P-"+ZDBDataGrid.getOrigValForVUDForNull(cellObj.originalValue,"-FR-");
            } //no handling for xcol header
            //console.log("FMSG: " + msg);
        }
    }
    else
    {
        msg +="-VL--P--FR-";
    }
    //console.log("MSG: " + msg);
    return msg;
}



ZDBDataGrid.getPivotOrSummaryMsg= function(msg, colObj, typeValue, view, isVUD)
{
    if(typeValue == ZDBClientViewAPI.TYPE_SUMMARY)
    {
        msg += ZDBAnalysisView.replaceInstKey(view, colObj.colName, isVUD)+"-P--V-"+ZDBAnalysisView.replaceInstKey(view, colObj.colName, isVUD)+"-N-";//No I18N
        return msg;
    }
    else
    {
        msg += ZDBAnalysisView.replaceInstKey(view, colObj.colName, isVUD)+"-P-"+ZDBAnalysisView.replaceInstKey(view, colObj.pivotKeyValue, isVUD)+"-N-";//No I18N
        return msg;
    }
}

ZDBDataGrid.getOrigValForVUDForNull = function(val , nullValue)
{
    if(val == null || val == "")
    {
        val =  nullValue;
    }
    return val;
}

ZDBDataGrid.getOrigValForVUD = function(val)
{
    if(val == null || val == "")
    {
        val =  "--NULL--";
    }
    return val;
}

ZDBDataGrid.getPivotRow  = function(gridObj, cellObj)
{
  var colObj = cellObj.colObj;
  var rowObj = cellObj.rowObj;

  var colHeads = gridObj.colHeaders;
  var colLen = colHeads.length;
  var rowData = rowObj.values;
  var pivotRow = [];
  var curHead;
  var yAxisListLength = ZDBUtil.getElementsWithAttribute(gridObj.viewObj.currentList, "viewType","YAXIS").length;//No I18N
  if(rowObj.objType != ZDBConst.COLHEAD)
  {
      for(var i=0;i<colLen;++i)
      {
          curHead = colHeads[i];
          if(curHead.cellPos > yAxisListLength)
          {
              break;
          }
          if(curHead.objType == ZDBConst.COLHEAD)
          {
              pivotRow.push([curHead, rowData[i].originalValue]);
          }
          if(curHead == colObj)
          {
              break;
          }
      }
  }
  return pivotRow;
}


  ZDBDataGrid.getColGroupCell = function(headRow, baseColIndex)
  {
    if(baseColIndex instanceof ZDBColHeader)
    {
      baseColIndex = baseColIndex.cellPos;
    }
    var values = headRow.values;
    var valLen = values.length;
    var cellObj;
    for(var k=0;k<valLen;++k)
    {
      cellObj = values[k];
      if(cellObj.endIndex >= baseColIndex && cellObj.startIndex <= baseColIndex)
      {
        return cellObj;
      }
    }
    return null ///PK: Shouldn't be here!
  }


ZDBDataGrid.getPivotCOLUMN = function(gridObj, cellObj)
  {
    var groupColInfo = [];
    var colObj = cellObj.colObj;
    var rowObj = cellObj.rowObj;
    var rowData = gridObj.rowData;
    var rowLen = rowData.length;
    var colHeaders = gridObj.colHeaders;
    var cellPos = ZDBUtil.indexOf(colHeaders, colObj);
    var curRow;
    var grpCol;
    for(var i=0;i<rowLen;++i)
    {
      curRow = rowData[i];
      if(curRow.objType !== ZDBConst.COLHEAD)
      {
        break;
      }
      grpCol = ZDBDataGrid.getColGroupCell(curRow, cellPos);
      if(grpCol) ///PK: No need for this IF
      {
        groupColInfo.push(grpCol);
      }
      if(curRow == rowObj)
      {
          break;
      }
    }
    return groupColInfo;
  }

ZDBDataGrid.getSummaryColInfo = function(gridObj, cell)
{
  var curRowEl = cell.parentNode;
  var curRowObj = curRowEl.rowObj;
  var rowObjs = gridObj.rowData;
  var curRowIndex = ZDBUtil.indexOf(rowObjs, curRowObj);
  var totSummary = 0;
  var firstSummaryIndex = 0;
  for(var i = curRowIndex; i >=0; --i)
  {
    if(rowObjs[i].rowType == ZDBConst.SUMMARY)
    {
      ++totSummary;
      firstSummaryIndex = i;
    }
    else
    {
      break;
    }
  }
  for(var i = curRowIndex + 1; i < rowObjs.length;++i)
  {
    if(rowObjs[i].rowType == ZDBConst.SUMMARY)
    {
      ++totSummary;
    }
    else
    {
      break;
    }
  }
  var summaryInfo = [];
  var endI = totSummary - (curRowIndex - firstSummaryIndex);
  for(var i=0;i < endI;++i)
  {
    summaryInfo.push(i);
  }
  return summaryInfo;
}


ZDBDataGrid.getDataCell = function(cellObjs, isFirst, isIndex)
{
  var cellLen = cellObjs.length;
  var colHead;
  var cellObj;
  for(var i=0;i<cellLen;++i)
  {
    colHead = cellObjs[i].colObj;
    if(colHead.objType != ZDBConst.COLHEAD || !colHead.visible)
    {
      continue;
    }
    return isIndex ? i : cellObjs[i];
  }
  return isIndex ? -1 : null;
}


ZDBDataGrid.prototype.resetDummyTop = function()
{
  if(!this.dummy)
  {
    return;
  }
  var rowLen = this.rowData.length;
  return //PK: to analyse


  var rowData = this.rowData;
  var lastDataRow = ZDBDataGrid.getLastRowObj(rowData, false);
  var dummyIndex = ZDBDataGrid.getLastRowIndex(rowData, true);
  var dummyRow = rowData[dummyIndex];
  if(!dummyRow || dummyRow.objType !== ZDBConst.DUMMY || lastDataRow.rid != null)
  {
    return;
  }
  var dummyCells = dummyRow.values;
  var dummyLen = dummyCells.length;
  for(var i=0;i<dummyLen;++i)
  {
    this.placeCellElement(dummyCells[i],[true,false,false, false],[true,false,false,false]);
  }

}


ZDBDataGrid.getFirstVisibleCell = function(rowObj)
{
  var cellObjs = rowObj.values;
  var cellLen = cellObjs.length;
  for(var i=0;i<cellLen;++i)
  {
    if(cellObjs[i].colObj.visible && cellObjs[i].colObj.objType == ZDBConst.COLHEAD)
    {
      return cellObjs[i];
    }
  }
}

ZDBDataGrid.getRowHeaderCellObj = function(rowObj)
{
  var cellObjs = rowObj.values;
  var cellLen = cellObjs.length;
  for(var i=0;i<cellLen;++i)
  {
  if(cellObjs[i].colObj.objType == ZDBConst.ROWHEAD)
  {
    return cellObjs[i];
  }
  }
}

ZDBDataGrid.prototype.checkEditWithMsg = function(colObj)
{

  if(!colObj.isColCellsEditable)
  {
    if(colObj.formula != null && !this.reportViewMode)
    {
      ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.table.showinfo.js.editFormulaDataErr"));
    }
    if(colObj.type == 'AUTO_NUMBER')
    {
      ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.table.showinfo.js.cantEditAutoNumCol"));
    }
    return false;
  }
  return true;
}

ZDBDataGrid.prototype.isCellClickAllowed = function()
{
    if(!this.isCellClick)
    {
        var view = this.viewObj;
        if((this.type == 'PivotSheet' || this.type=='SummarySheet') && view && view.permissions.vud)
        {
            this.isCellClick= true;
        }
        else
        {
            this.isCellClick = false;
        }
    }
    return this.isCellClick;
}

ZDBDataGrid.prototype.resize = function(isFromFontSize)
{
  var dim = this.viewCtx.getSize();
  this.scrollUp = false;
  this.resizeGrid(dim.width,dim.height,isFromFontSize);
}

ZDBDataGrid.prototype.removeView = function()
{
  ZDBDataGrid.removeInstance(this.ID);
}

ZDBDataGrid.prototype.setVisible = function()
{
  this.parNode = this.viewCtx.getParComp();
  ZDBTableGrid.updateTableViewEls(this,this,this.viewCtx);
  ZDBTableGrid.updateNavigComp(this,this,this.viewCtx);
  this.resize();
  this.showTable();
}

ZDBDataGrid.prototype.refreshView = function()
{
  if(!ZDBClientUI.checkAskSaveView(this," "+ZDBI18NMap.g("zrpt.common.js.refresh"),this))
  {
    return;
  }
  ZDBTableGrid.refreshDataForView(this);
}

ZDBDataGrid.prototype.getDrillDet = function()
{
  return this.configInfo ? this.configInfo.DRILLPARAMS : "";
}
ZDBDataGrid.prototype.getConfigAsXML = function(recordInfo , ignoreColInfo)
{
    var xml = "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n";//No I18N
    xml += "<DBSVParams ";//No I18N

    if(ignoreColInfo == null)
    {
        ignoreColInfo = false;
    }

    if(recordInfo)
    {
        xml += recordInfo;
    }

    if(!ignoreColInfo)
    {
        xml += " " + this.getColDetail(true); 
    }

    if(this.configInfo)
    {
        xml+=this.configInfo.PARAMSATTR;
    }

    if(this.vudTblObjId != null)
    {
        xml +=" VUDTBLOBJID='"+this.vudTblObjId+"' ";  //No I18N
    }

    xml+="> </DBSVParams>\n"//No I18N
    if(!ignoreColInfo)
    {
        xml+=this.getSimpleFilter(true);
    }
    if(this.configInfo)
    {
      xml+= this.configInfo.DOXML;
    }
    if(this.configInfo)
    {
      xml += this.configInfo.FILTERXML;
    }
    if(this.viewCtx.dashView) // Should send dashboard UF details also when it is in the dashboard
    {
      var sendCompleteInfo = (this.viewCtx.dashView.permissions.designModify == 1&& ZDBUtil.isViewModified(this.viewCtx.dashView))
      var dashDynFltrConfig = ZDBDashboardUF.getDashDynFltrConfig(this.viewCtx);
      var xmlBuf = new ZDBStrBuf();
      xmlBuf.a("<dcdet") //NO I18N
          .attr("cinfo",sendCompleteInfo) // NO I18N
          .a(">\n"); // NO I18N
      xmlBuf.a(dashDynFltrConfig)
      xmlBuf.a("</dcdet>");    // No I18N
      xml += xmlBuf.toString();
    }
    xml+="</DBSVRequest>";//No I18N
    return xml;
}

ZDBDataGrid.getCurColHead = function(gridObj)
{

  var cellObj = ZDBDataGrid.getLastFocusCell(gridObj);
  if(cellObj)
  {
    if(cellObj instanceof ZDBCell)
    {
      return cellObj.colObj;
    }
    else
    {
      return cellObj;
    }
  }
  return null;
}

ZDBDataGrid.prototype.getColHeadFromId = function(colId)
{
  var colHeaders = this.colHeaders;
  for(var i=0; i < colHeaders.length; i++)
  {
    if(colHeaders[i].colId == colId)
    {
      return colHeaders[i];
    }
  }
  return null;
}

ZDBDataGrid.prototype.getCellElPosInGrid = function(cellObj)
{
  var cellEl = cellObj.cellEl;
  var colObj = cellObj.colObj;
  var rowObj = cellObj.rowObj;
  var colObjType = colObj.objType;
  var rowObjType = rowObj.objType;
  var scrollEl;
  
  if(colObj.freeze)
  {
    scrollEl = (cellObj instanceof ZDBColHeader) ? this.gLeftArea : this.rhArea;
  }
  else
  {
    switch(rowObjType)
    {
      case ZDBConst.COLHEAD:
      {
        switch(colObjType)
        {
          case ZDBConst.COLHEAD:
            scrollEl = this.chArea;
            break;
          case ZDBConst.ROWHEAD:
            scrollEl = this.tcArea;
            break;
        }
        break;
      }    
      case ZDBConst.DATA:
      {
        switch(colObjType)
        {
          case ZDBConst.COLHEAD:
            scrollEl = this.dArea;
            break;
          case ZDBConst.ROWHEAD:
            scrollEl = this.rhArea;
            break;
        }
      }
      case ZDBConst.DUMMY:
      case ZDBConst.FILLER:
      case ZDBConst.SECTION:
      case ZDBConst.SUMMARY:
      {
        switch(colObjType)
        {
          case ZDBConst.COLHEAD:
            scrollEl = this.dArea;
            break;
          case ZDBConst.ROWHEAD:
            scrollEl = this.rhArea;
            break;
        }
      }
    }
  }

  
  var scrollTop = scrollEl.scrollTop;
  var scrollLeft = scrollEl.scrollLeft;
  var top = ZDBUtil.getObjTop(cellEl,false,scrollEl);
  var left = ZDBUtil.getObjLeft(cellEl,false,scrollEl);
  var height = jQuery(cellEl).outerHeight(true);
  var width = jQuery(cellEl).width();
  return {"cellTop":top,"cellLeft":left,"cellHeight":height,"cellWidth":width};  //No I18N
}

ZDBDataGrid.loadAnalysisJSList = function(element)
{ //similar to LazyLoad loadSnippet function - for the time being
    var funcStr = element.getAttribute("func");
    var lazyLoad = element.getAttribute("lazyLoad");
    if(lazyLoad == "true")
    {
      var lzName = element.getAttribute("lzName");
      var lzUrl = element.getAttribute("lzUrl");  
      var lzOper = element.getAttribute("lzOper");
      var lzJs = ["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList","ZAAnalysisFields"]; //No I18N
      var mode = element.getAttribute("mode");
      if(!ZDBLazyLoadUtil.loadSnippet(lzName,lzUrl,this,lzOper,lzJs))
      {
    	  return;
      }
    }
    ZDBLoadJsAlone.invokeGridFunc(funcStr,element,mode);
}

var ZRGRIDIDXCONSTS = (function () {
    var constants = {
        'GEODET':45 //NO I18N
    };
    return {
        get:function(name) {return constants[name];}
    };
})();

