//$Id$
var ZDBTableGrid = new function()
{
  this.createGrid = function(objId,dbId,tableName,displayName,type,designModTime,description,qryDataLimitExceeded,qryTblMaxRows, qtStatus)
  {
    var gridObj = new ZDBDataGrid();
    ZDBClientViewAPI.init(gridObj,objId,dbId,null,displayName,type,designModTime,description,null);
    gridObj.tableName = tableName;
    gridObj.showDatatype = true;
    gridObj.showSortIcon = true;
    gridObj.qryTblMaxRows = qryTblMaxRows;
    gridObj.themeProp = new Object();
    if(type == "QueryTable")
    {
      gridObj.setAsReadOnly();
      if(!ZDBGlobal.qryTblDataLimitShown[objId] && qryDataLimitExceeded == "true")
      {
        ZDBGlobal.qryTblDataLimitShown[objId] = false;
      }
      if (qtStatus == false)
      {
        ZDBMsgBox.showInfo("This query table is deactivated.");
      }
    }
    return gridObj;
  }

  this.getTableInstance = function(objId)
  {
    for(var i in ZDBDataGrid.INSTANCES)
    {
      if((ZDBDataGrid.INSTANCES[i] != null) && (ZDBDataGrid.INSTANCES[i].objId == objId))
      {
        return ZDBDataGrid.INSTANCES[i];
      }
    }
  }

}

ZDBTableGrid.refreshDataForView = function(view,loadMsg)
{
  var url = "/ZDBTableDataAction.ma?ZDBACTION=DATAVIEW&CONFIGASXML=true&"
            + "&REFRESHDATAONLY=true&CLEARCACHEANDROWS=true&GRIDID=" + view.ID + "&" //No I18N
  + view.getGridDetailsAsParams();
  url+=view.getDrillDet();
  if(view.cacheTime) //ZDBClientUI.selectedTab.view.forceRefresh
  {
    url += "&FORCEREFRESH=" + true; //No I18N
  }
  var xml = view.getConfigAsXML();
  var dashRefreshCounter = (view.viewCtx && view.viewCtx.dashView) ? view.viewCtx.dashView.refreshCounter : -1;
  AjaxAPI.sendRequest({URL:url,
                             POSTBODY:xml,
                             REQUESTHEADERS:{"Content-type":"text/xml"},
                             VIEWCTX:view.viewCtx,GRIDOBJREF:view,VIEW:view,
                             ONSUCCESSFUNC:ZDBTableGrid.placeDataSheet,
                             DASHREFCOUNTER:dashRefreshCounter,
                             OPSTATUSID:view.viewCtx.getLoadIndicator(loadMsg)});
 
}


ZDBTableGrid.sendRequestForDataView = function(url,params,viewCtx,msg)
{  
  if(!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList","APPENDTODOC",ZDBTableGrid.sendRequestForDataView,[url,params,viewCtx,msg]))
  {
    return;
  }
  if(viewCtx.dashView) // Should send dashboard UF details also when it is in the dashboard
  {
    var xml = "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n";//No I18N
    var sendCompleteInfo = (viewCtx.dashView.permissions.designModify == 1&& ZDBUtil.isViewModified(viewCtx.dashView))
    var dashDynFltrConfig = ZDBDashboardUF.getDashDynFltrConfig(viewCtx);
    var xmlBuf = new ZDBStrBuf();
    xmlBuf.a("<dcdet") //NO I18N
      .attr("cinfo",sendCompleteInfo) // NO I18N
      .a(">\n"); // NO I18N
    xmlBuf.a(dashDynFltrConfig)
    xmlBuf.a("</dcdet>");    // No I18N
    xml += xmlBuf.toString();
    xml+="</DBSVRequest>"//No I18N
    params += "&CONFIGASXML=true";  // No I18N
    params += "&OBJTYPE="+ (this.isAnalysis ? "AnalysisGrid" : this.type);  // No I18N
    url += params
    AjaxAPI.sendRequest({URL:url,
                             POSTBODY:xml,
                             REQUESTHEADERS:{"Content-type":"text/xml"},    // No I18N
                             ONSUCCESSFUNC:ZDBTableGrid.placeDataSheet,
                             VIEWCTX:viewCtx,
                             DASHREFCOUNTER:viewCtx.dashView.refreshCounter,
                             OPSTATUSID:viewCtx.getLoadIndicator(msg)});
  }
  else
  {
	  if(ZDBClientUI.isChartViewed)
	  {
		  params += "&isViewed="+ZDBClientUI.isChartViewed;//NO I18N        
	  }
    AjaxAPI.sendRequest({URL:url,
                             PARAMETERS:params,
                             ONSUCCESSFUNC:ZDBTableGrid.placeDataSheet,
                             VIEWCTX:viewCtx,
                             OPSTATUSID:viewCtx.getLoadIndicator(msg)});
  }
}

    

ZDBTableGrid.placeDataSheet = function(response,requestOptions)
{
  var viewCtx = requestOptions["VIEWCTX"];
  var responseValidity = viewCtx.checkIfRespValid(response,requestOptions);
  if(viewCtx.dashView)// Tab switch is handled only for dashboard
      {
        var tabView = viewCtx.dashView;
        var respJson = JSON.parse(response.responseText);
        var func = function(){ZDBTableGrid.placeDataSheet(response, requestOptions);};
        if(!ZDBTabSwitchHandler.isRelevendTab2Exec(tabView,func))
        {
        return;
        }
        if(!response.alreadyUpdated)
        {
          if(respJson.oldCacheTime && responseValidity)
          {
            tabView.maxCacheTime = ZDBUtil.maxTime(respJson.oldCacheTime,tabView.maxCacheTime);
          }
        	tabView.updateRespStatus();
        }
        ZDBDashboard.viewLoaded = true; 
        if(requestOptions["DASHREFCOUNTER"] < tabView.refreshCounter)
    	{
    	return;
    	}
        if(tabView.isViewRendering ||  tabView.animatingViewWaiting > 0)
        {
        	response.alreadyUpdated = true;
        	setTimeout(func,0);
        	return;
        }
      }
  
  if(!viewCtx.checkIfRespValid(response,requestOptions))
  {
    var loadIcon = requestOptions["OPSTATUSID"]; ///PK: I shouldn't be doing
    if(loadIcon)
    {
      loadIcon.style.display = "none";
    }
    return;
  }
  var isModified = requestOptions["ISMODIFIED"];
  var gridObj = requestOptions["GRIDOBJREF"];
  ZDBGlobal.stdCellHeight = (BROWSER.IS_MOBILE) ? 26 : 22 ;
  var tempView = viewCtx.getSize();//this is just a temp View we use it to pass height and width , will be removed later
  if(viewCtx.dashView)			  	
  {	
	 tempView.isForDash = true; 
  }
  gridObj = ZDBDataGrid.parseGridResponse(gridObj,response.responseText,tempView);
  if(viewCtx.dashView){
	  if(viewCtx.dashView.dashLayout){
		  var dashBoardDiv = viewCtx.dashChildDiv;
		  var title = ZDBEscapeUtil.encodeForHtml((gridObj.title) ? gridObj.title : gridObj.displayName);
		  var desc = ZDBEscapeUtil.encodeForHtml((gridObj.description) ? gridObj.description : "");
		  if(dashBoardDiv != null)
		  {	
			  dashBoardDiv.dlgTitle.innerHTML = title;
			  dashBoardDiv.dlgDesc.innerHTML = desc;
			  dashBoardDiv.dlgBody.style.height = "calc(100% - "+dashBoardDiv.titleDescArea.offsetHeight+"px)";
		  }  
	  }
	  viewCtx.dashView.appendPermissionsForView(gridObj,viewCtx.dashChildDiv);
  }
  viewCtx.handle(gridObj);
  if(!viewCtx.dashView)
  {
    ZDBUtil.ShowHideForceRefresh(gridObj);
  }
  if(gridObj.fromVW)
  {
    ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.FromVW"));
  }
  if(gridObj.importInProgress)
      {
          ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.importInProgress"));
      }
  if(gridObj.errmsg != 'null')
  {
     ZDBMsgBox.showInfo(gridObj.errmsg);
  }
  if(ZDBUtil.isNewView(gridObj))
  {
    gridObj.setModified();
  }
  if(gridObj.objId > 0 && gridObj.type == 'QueryTable' &&
     ZDBGlobal.qryTblDataLimitShown[gridObj.objId] == false)
  {
    ZDBMsgBox.showInfo(ZDBI18NMap.f("zrpt.common.querytable.showinfo.js.maxRowsExceededInfo",gridObj.qryTblMaxRows));
    ZDBGlobal.qryTblDataLimitShown[gridObj.objId] = true;
  }
  if(isModified==true)
  {          
      gridObj.setModified();
  }
  if(gridObj.type != "PivotSheet" && gridObj.type != "SummarySheet") // temporary check for pivot and summary 
	  {
	  if(BROWSER.SAFARI == 1) //  to fix safari issue , safari current version only computes table layout fixed after this
	  {
		  ZDBUtil.removeAndInsertJsObj(gridObj);
	  }
  if(!gridObj.freeze || gridObj.readOnly) 
	  {
  gridObj.maintainWidthArray(gridObj.colHead);
       if(gridObj.freeze)
    	   {
    	   gridObj.setFreezeIcon();
    	   }
	  }
  if (gridObj.totalRecords < gridObj.dTable.children.length) 
	   {// this is because in table there will be an extra input row and a filler row
		gridObj.setFillerHeight();
	   } 
  else {
	  gridObj.adjustInViewRowsHeight();
  }
	  }
//
//  if(gridObj.type == "Table" || gridObj.type == "QueryTable" || gridObj.type == "Report")
//	  {
	  if(viewCtx.dashView && !viewCtx.dashView.editMode)
		  {
		  ZDBReportDashUtil.checkAndRemoveFromDOM(gridObj.viewCtx.dashView,gridObj.gArea.parentNode,gridObj.gArea);
		  ZDBReportDashUtil.checkAndAppendToDOM(gridObj.viewCtx.dashView);
		  }
	//  }
  gridObj.focusFirstCell();
  if(viewCtx.dashView)
  {
	  return;
  }
  if(gridObj.type === "Report")
  {
	  if(!ThemeComponent.dbProps && gridObj.permissions.designModify)
	  {
//		  AjaxAPI.sendRequest({ URL: "/reportsapi/db/" + ZDBClientUI.dbId + "/GETDBGRIDTHEME",PARAMETERS: "DBID=" + ZDBClientUI.dbId, ONSUCCESSFUNC: ThemeComponent.setDBProps,
//			  LAZYLOADREQ: true});
            ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETDBGRIDTHEME', 'DBID=' + ZDBClientUI.dbId,{
                successHandler: {
                    func: ThemeComponent.setDBProps,
                    ctx: ThemeComponent
                }
            });
	  }
  } 
  typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.addRecord(ZRCRMPlusHomePage.RECENTITEMS,ZDBClientUI.selectedTab.view);//NO I18N
}


ZDBTableGrid.fetchView = function(objId,viewCtx)
{
  if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBGridList"],"APPENDTODOC",ZDBTableGrid.fetchView,[objId,viewCtx]))//NO I18N
  {
	  return;
  }
  if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_GRIDSTYLES", "ZDBAnalysis_NEW.css"],"APPENDTODOC",ZDBTableGrid.fetchView,[objId,viewCtx])){
	  return;
  }
  if(ZDBClientUI.sampleViewStatus || ZDBClientUI.sampleView)
  {
	  if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/autogen/ZDBSampleViews.js",this,ZDBTableGrid.fetchView,[objId,viewCtx]))
	   {
	 	return;
	   }
  }
  var params = "&OBJID=" + objId + "&ZDBACTION=DATAVIEW" + viewCtx.getAdditionalParams();
  if(ZDBClientUI.directFilterString)
  {
    params += "&" + ZDBClientUI.directFilterString;
  }

  ZDBTableGrid.sendRequestForDataView("/ZDBTableDataAction.ma?",params,viewCtx);
  if(ZDBClientUI.sampleViewStatus || ZDBClientUI.sampleView)
  {
    setTimeout(function(){ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.zdbalertmsg.js.autoGenDlgContent",ZDBGlobal.PRODUCTNAME), "ZDBYESNO",
    {ONCLICK:ZDBSampleViews.createSampleViews,OBJID:objId},ZDBI18NMap.g('zrpt.common.zdbalertmsg.js.autoGenDlgTtl'),null,'ZDBAutoReports');},1000);
  }  
}

ZDBTableGrid.updateTableViewEls = function(gridObj,view,viewCtx)
{
  var type = view.type;
  if(type == null)
  {
    type = gridObj.type;
  }
  //In embed/publish url, search box and row count comp are in same div. 
  //New UI - div should be displayed only if embedded with search box.
  //old UI - div should always be displayed to show row count.
  var dashboardDiv = DOMUtils.getParentWithAttr(gridObj.viewComp,"isdashboarddiv");
  //var dashboardDiv = viewCtx.dashChildDiv || DOMUtils.getParentWithAttr(gridObj.viewComp,"isdashboarddiv");$#Dash#$
  if(dashboardDiv !== null && ((!gridObj.showNavVisibility) || (type === "Table") || (type === "Report") || (type === "QueryTable")))//for table, querytable, tabular view title change
  {
    var dlgTitle = dashboardDiv.dlgTitle;
    var dlgDesc = dashboardDiv.dlgDesc;
    dlgTitle.innerHTML = ZDBEscapeUtil.encodeForHtml((gridObj.title != null && gridObj.title != "") ? gridObj.title : gridObj.displayName);
    var desc = (gridObj.description==null)?"":gridObj.description;
    dlgDesc.innerHTML = ZDBEscapeUtil.encodeForHtml(desc);
    if(desc==null || desc==""){dlgDesc.style.display="none";}
    if(viewCtx.dashView && viewCtx.dashView.editMode && dashboardDiv.modalDiv)
    {
        dashboardDiv.modalDiv.style.height = dashboardDiv.offsetHeight + "px";
        dashboardDiv.det = null;
        dashboardDiv.oldDet = null;
        if(ZDBEditModeSelect.editOptsEl!=null)
        {
            ZDBEditModeSelect.reposMenu(dashboardDiv,ZDBDashEdit.getCurEditState());
        }
    }
  }
}

ZDBTableGrid.updateNavigComp=function(gridObj,view,viewCtx)
{
  var type = view.type;
  if(type == null)
  {
    type = gridObj.type;
  }
  var navigHolder = viewCtx.getNavigPlHolder(view);
  var navigCompPar = navigHolder.el;
  if(navigCompPar == null)
  {
    return;
  }
  ZDBUtil.removeNonElements(navigCompPar);
  if(gridObj.navigComp && !ZDBGlobal.IS_MOBILE)
  {
	  if(navigCompPar.childNodes.length > 0)
	  {
	    navigCompPar.replaceChild(gridObj.navigComp,navigCompPar.childNodes[0]);
	  }
	  else
	  { 
	    navigCompPar.appendChild(gridObj.navigComp);     
	  }
	  gridObj.navigComp.style.display="";
  }
  navigCompPar.style.display="";
  if(gridObj.showNavVisibility)//only for pivot and summary views (All the grids in case of IOS - table, tabular, query, vud, pivot & summary)
  {
      var gDataWidth = gridObj.gDataWidth;
      var gWidth= gridObj.gWidth;
      var gHeight = gridObj.gHeight;
      var overallRecords = gridObj.totalRecords + gridObj.overAllSumCount;
      var dataHeight = (overallRecords * ZDBGlobal.stdCellHeight)+ gridObj.tcHeight;
      //showHideNavToolBar - true (to show navig comp), false (to hide navig comp) 
      //IOS cases - navig comp displayed in desktop will not be loaded. Hence, value is set explicitly based on the dataHeight < gHeight check
      if(dataHeight < gHeight && overallRecords > 0)//disabling w.r.t. size (no. of rows)
      {
        gridObj.showHideNavToolBar = (ZDBGlobal.IS_MOBILE) ? false : ZDBAnalysisGrid.showNavComp(navigHolder, gridObj,false);
      }
      else
      {
        gridObj.showHideNavToolBar = (ZDBGlobal.IS_MOBILE) ? true : ZDBAnalysisGrid.showNavComp(navigHolder, gridObj,true);
      }
      view.resize();
      var dashboardDiv = DOMUtils.getParentWithAttr(gridObj.viewComp,"isdashboarddiv");
      if(dashboardDiv != null && !ZDBGlobal.IS_MOBILE)//for dashboard change (excluding for IOS case)
      {
        navigCompPar.style.right = (gWidth > gDataWidth)?(gWidth - gDataWidth - ZDBGlobal.scrollThick) + "px" : "0px"; //No I18N
        //17px is to align with scroll bar
        dashboardDiv.showNavVisibility =  gridObj.showNavVisibility;
      }
      if(viewCtx.standAlone && dashboardDiv == null && !ZDBGlobal.IS_MOBILE)//for embed and url changes
      {
          if(viewCtx.configMap.REMTOOLBAR == "true")
          {
        		navigCompPar.style.paddingRight=(gWidth > gDataWidth)?(gWidth - gDataWidth - ZDBGlobal.scrollThick) + "px" : "0px";  //No I18N
                //17px is to align with scroll bar
          }
      }
  }

}

ZDBClientUI.typeDefns["Table"] = {fetchView:ZDBTableGrid.fetchView,dummyView:"dummyGrid"};

