//$Id$

var ZDBGridMenu = new function()
{
}

ZDBGridMenu.deleteRows = function(srcEl, event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(srcEl, 'gridObj','object');
    if(gridObj.selectedRows.length == 0)
    {
      var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
      if(!lastFocusCell)
      {
        ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selRow2DelErr"));
        return false;
      }
      else
      {
        gridObj.addSelectedRow(lastFocusCell.rowObj);  
      }
    }
    gridObj.deleteSelectedRows();
    if(gridObj.totalRecords - gridObj.deletedRowCount + gridObj.addedRowCount == gridObj.dTable.children.length-2)  // this is because in table there will be an extra input row and a filler row
	{
	gridObj.setFillerHeight();
	}
  }

ZDBGridMenu.deleteAllRows = function(srcEl, event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(srcEl, 'gridObj','object');
    gridObj.deleteAllRows();
  }

ZDBGridMenu.editRow = function(srcEl, event)
{
	var gridObj = ZDBUtil.getPropertyFromEl(srcEl,'gridObj','object');
	if(!gridObj)
	{
	  return;
	}
  if(gridObj.selectedRows.length == 0)
  {
    var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
    gridObj.addSelectedRow(lastFocusCell.rowObj);
  }
	gridObj.focusRowFirstCell(ZDBUtil.indexOf(gridObj.rowData, gridObj.selectedRows[0]));
	setTimeout(function(){gridObj.setCellEditable((ZDBDataGrid.getCurrentCell(gridObj)));},100);
}

ZDBGridMenu.addRow = function(element, event)
    {
	  if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList","ZAAnalysisFields"],"APPENDTODOC",ZDBGridMenu.addRow,[element, event]))
	  {
	      return;
	  }
      var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
      var pos = gridObj.getFirstVisibleHeaderPos();
      ZDBGridScroll.navigate(3,gridObj,pos);
    }

ZDBGridMenu.refreshSheet = function(element, event)
{
  var view = ZDBClientUI.selectedTab.view;
  view.refreshView();
}


  ZDBGridMenu.unfreezeColumn = function(srcEl, event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(srcEl, 'gridObj','object');
    gridObj.unfreezeColumn();
  }

  ZDBGridMenu.freezeColumn = function(srcEl, event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(srcEl, 'gridObj','object');
    var selCols = gridObj.selectedCols;
    var selLen = selCols.length;
    var colObj;
    var cellObj = ZDBDataGrid.getLastFocusCell(gridObj);
    
    if(selLen < 1)
    {
      if(!cellObj)
      {
        ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selColsErr"));
        return false;
      }
      else
      {
        gridObj.addSelectedCol(cellObj.colObj);
        gridObj.selectColumn();
      }
    }

    var index = -1;
    var lastCol;
    var selLen = selCols.length;
    for(var i=0;i<selLen;++i) // getMax selected col pos
    {
      colObj = selCols[i];
      if(index < colObj.cellPos)
      {
        lastCol = colObj;
        index = lastCol.cellPos;
      }
    }
    gridObj.freezeColumn(lastCol);
  }

    ZDBGridMenu.groupColumn = function(td, event, sortType, unGroupAndGroup, section)
    {
      var gridObj =  ZDBUtil.getPropertyFromEl(td, 'gridObj','object');
      if(gridObj.isFilterApplied)
      {
          ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.tabularview.showinfo.js.filterGroupErr"));
          return;
      }
      if(section && gridObj.colHeaders.length == 2)
      {
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.tabularview.showinfo.js.secGroupErr")); // Throwing unexpected error
        return;
      }
      
      if(section)
      {
        for(var i = 0; i < gridObj.colHeaders.length; i++)
        {
          if(gridObj.colHeaders[i].section)
          {
            ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.tabularview.showinfo.js.multiSecGroupErr"));
            return;
          }
        }
      }
      if(gridObj.selectedCols.length == 0)
      {
        var colObj = ZDBDataGrid.getCurColHead(gridObj);
        if(colObj == null)
        { 
          if(section)
          {
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selColErr"));
          }
          else
          {
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selColsErr"));
          }  
          return;
        }
        gridObj.addSelectedCol(colObj);
      }
      else if(section && gridObj.selectedCols.length > 1)
      {
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.tabularview.showinfo.js.multiSecGroupErr"));
        return;
      }
      ZDBGrouping.groupColumn(gridObj, sortType, unGroupAndGroup, section);
    }

ZDBGridMenu.removeGrouping = function(td, event)
    {
      var gridObj =  ZDBUtil.getPropertyFromEl(td, 'gridObj','object');
      if(ZDBGrouping.removeGrouping(gridObj))
      {
		    ZDBMenu.setDefaultToolbarStatus();
      }
    }

ZDBGridMenu.sortColumn = function(menuElement, event, sortType)
 {
    var menuInfo = ZDBUtil.getPropertyFromEl(menuElement, 'gridObj','both');
    var gridObj = menuInfo[0];
    var menuEl = menuInfo[1];
    var curColObj = null;
    var selColLen = gridObj.selectedCols.length;
    var grouped = gridObj.isGrouped();
  	if(sortType == ZDBSorting.NONE)
  	{
  		 var colHeaders = gridObj.colHeaders;
  		 var len = colHeaders.length;
  		 var isSortPresent = false;
  		 var curHead;
  		 for(var i=0;i<len;++i)
  		 {
          curHead = colHeaders[i];
          if(curHead.objType != ZDBConst.COLHEAD)
          {
            continue;
          }
          if(colHeaders[i].sortOrder != 0)
          {
              isSortPresent = true;
              break;    
          }
        }
       if(isSortPresent)
       {
          ZDBSorting.removeSorting(gridObj, true);
       }
       else
       {
          ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.remSortingErr"));
          return; 
       }
  	}             
    else if(selColLen > 1 || grouped)
    {
        ZDBSorting.sortColumn(gridObj, sortType);
    }
    else
    {
        if(selColLen == 1)
        {
           curColObj = gridObj.selectedCols[0];
        }
        else if(selColLen == 0)
        {
            var curCell = ZDBDataGrid.getLastFocusCell(gridObj);
            if(curCell == null)
            {
              ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selCol2SortErr"));
              return;
            }
            curColObj = curCell.colObj;
            if(!curColObj)
            {
                ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selColsErr"));
                return; 
            }
        }
    
    	if(curColObj.sortOrder == sortType)
    	{
          ZDBSorting.removeSorting(gridObj, false);
    	}
    	else 
    	{
          gridObj.addSelectedCol(curColObj);

          ZDBSorting.sortColumn(gridObj,sortType);
        }
    }
    ZDBMenu.setToolbarStatus(gridObj);
 }

