//$Id$
function ZDBDataGrid()
{
  var gridObj = this;
  gridObj.themeProp = {};
  ZDBDataGrid.addInstance(this);

  this.displayOptions = function()
  {
    var tbl = $("ZDBDESIGN_OPTION");
    var nodes = tbl.getElementsByTagName('tr');
    $('ZDBD_ABORT').setAttribute("checked",true);
    for(var i = 0;i < nodes.length;i++)
    {
      var tr = nodes[i];
      if(tr.getAttribute && tr.getAttribute("type") != null)
      {
          tr.style.display = ZDBUtil.visibleTrStyle;
      }
    }
  }  

  this.submitOptionDlg = function(src, event)
  {
    var gridObj=  ZDBUtil.getPropertyFromEl(src, 'gridObj','object');
    var arr = ["ABORT","DEFAULT","EMPTY"];
    var selOption = "";
    var idPrefix = '';
    if(!src)
    {//$$ Need to pass the source instead of storing the reference
      src = gridObj.ZDBDESIGN_SETTINGS.src;
      idPrefix = 'ZDBD_';
    }  
    else
    {// popup
      idPrefix = 'ZDBPopUpTypeChange_';
    }
    for(var i=0;i < arr.length;i++)
    {
      if($(idPrefix + arr[i]).checked)
      {
        if(arr[i] == "DEFAULT")
        {
          var defVal = src.header.defaultVal;
          if(defVal == null)
          {
            ZDBDialogUtil.closeDialog();
            var colName = src.header.displayName; 
	        ZDBMsgBox.showInfo(ZDBI18NMap.f("zrpt.common.tbleditdesign.showinfo.js.noDefValErr",ZDBEscapeUtil.encodeForHtml(colName)));
            return;
          }
        }
        selOption = arr[i];
        break;
      }
    }
    ZDBMetaDataChange.changeDataType(src.header,src.selType,selOption);
    ZDBDialogUtil.closeDialog();
  }
  this.closeOptionDlg = function(element, event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(srcEl, 'gridObj','object');
    var selCols = gridObj.selectedCols;
    var dataTypeEl = gridObj.ZDBDESIGN_SETTINGS.src;
    if(selCols.length == 1)
    {
      var index = getDataIndex(dataTypeEl,'defaultvaltype',selCols[0].type);
      dataTypeEl[index].selected = true;
    }
    return true;
  }
  
  this.setupBaseRow = function()
  {
      var baseRow = {values:[]};
      baseRow.objType = ZDBConst.COLHEAD;
      baseRow.gridObj = this;
      baseRow.parGrid = this;
      baseRow.height = (this.type == "TableDesign") ? ZDBGlobal.stdEditGridCellHeight : ZDBGlobal.stdColHeight;
      this.baseRow = baseRow;
      this.colHeaders = baseRow.values;
  }
  
  this.resetColumnProps = function()
  {
    this.pkCols = [];
    this.setupBaseRow();
    this.rowData[0] = this.baseRow;//resetting the column header value. In any case rowData[0] will be the columnHeader
    this.tcWidth = ZDBConst.NOTSET;
    this.chWidth = ZDBConst.NOTSET;
  }
  
  this.init = function(view,themeProp)
    {
      if(!ZDBGlobal.isGlobalSet)
      {
        ZDBDataGrid.setGlobals();
      }
      this.permissions = ZDBConst.ALLPERMS;
      this.pkCols = [];
      this.setupBaseRow();
      this.rowData = [this.baseRow];
      this.newRid=1;
      this.recordStart = 0;
      this.recordEnd = 0;
      this.totalRecords = 0;
      this.overAllSumCount = 0;
      this.rowsToUpdate = [];
      this.newRows = [];
      this.selectedRows = [];
      this.selectedCols = [];
      this.lastFocusPos = null;
      this.domCache = new ZDBGridDomCache(this);
      this.dataCache= new ZDBGridDataCache(this);
      this.drag = false;
      this.isEdit = false;
      this.isFilterEdit = false;
      this.freezeIndex = -1;
      this.scrollUp = false;
      this.colHeadFocus = this.rowHeadFocus = this.dataFocus = this.filterFocus = false;  
      this.tcArea = null;
      this.chArea = null;
      this.rhArea = null;
      this.dArea = null;
      if(this.type == "VUDSheet")
      {
        this.tableIdNameMapping= new Object();
        this.otherRelatedTableNames = new Array();
        this.duplicateColNames = new Array();
      }
      
      
      this.tcWidth = ZDBConst.NOTSET;
      this.chWidth = ZDBConst.NOTSET;
      this.dWidth = ZDBConst.NOTSET;

      this.tcHeight = ZDBConst.NOTSET;
      this.rhHeight = ZDBConst.NOTSET;
      this.fHeight = ZDBConst.NOTSET;
      this.dHeight = ZDBConst.NOTSET;
      
      this.modified = 0;
      this.sent = 0;
      this.gWidth = 0;
      this.gDataWidth = 0;
      this.gHeight = 0;
      this.gDataHeight = 0;   
      this.resizeable = true;
      this.selectable = true;
      this.deletedCount = 0;
      this.rowIdObj = {}; ///to hold rowID width
      
      if(themeProp)
    	  {
    	  	this.themeProp = themeProp;
    	  	this.refineThemeProp();
          if(ZDBClientUI.fs == "ZC")
          {
              this.applyUrlTheme();
          }
    	  }
      
      if(view && (this.type == "PivotSheet" || this.type == "SummarySheet" || this.type == "AnalysisSheet"))//for pivot and summarysheet in dashboard need to create grid with chartsDimensions
    	  {
    	  this.view = view;
    	  this.createZdbGrid(view.chartArea.offsetWidth,view.chartArea.offsetHeight-1);
    	  }
      else if(view && view.height && view.width)//for other grid.i.e.,table,qTable,Report we will use the tempView created with height and width
    	  {
    	  this.view = view;
    	  this.createZdbGrid(view.width,view.height);
    	  }
      else
    	  {
    	  this.createZdbGrid(300,300);
    	  }
      if(this.type == "QueryTable")
      {
        this.setAsReadOnly();
      }
      this.simpleFilterData = [];
    }


  this.setGridProp = function()
  {
    // PK: Should be done at each gridType level
    // PK: Server should decide    

    this.reorderDisabled = true;
    this.showDatatype = false;
    this.showCheck = false;
    this.showIcon = true;
    this.isFreeze = false;
    this.rowMenuDisabled = true;
    this.editDisabled = true;
    this.unfreezeDisabled = false;
    this.showSortIcon = true;
    this.readOnly = true;
    this.gridSizeBasedOnData = false;
    this.showRenameIcon=false;
    this.showNavVisibility = (ZDBGlobal.IS_MOBILE) ? true : false;
    var gridType = this.type;
    
    switch(gridType)
    {
      case 'Table':
      case undefined: //PK: ???
        this.reorderDisabled = false;
        this.contextDisabled = false;
        this.showDatatype = true;
        this.rowMenuDisabled = false;
        this.editDisabled = false;
        this.readOnly = false;
        break;
      case 'Report':
      case undefined:
        this.reorderDisabled = false;
        this.contextDisabled = false;
        this.showDatatype = true;
        break;
      case 'QueryTable':
        this.contextDisabled = false;
        this.showDatatype = true;
        this.reorderDisabled = false;
        break;
      case 'TableDesign':
        this.showDatatype = false;
        this.showIcon = false;
        this.editDisabled = false;        
        this.unfreezeDisabled = true;
        this.readOnly = false;
        this.gridSizeBasedOnData = true;
        this.showSortIcon = false;
        break;
      case 'SummarySheet':
        this.showDatatype = false;
        this.showIcon = true;
        this.showCheck = false;
        this.unfreezeDisabled = true;
        this.focusDisabled = true;
        this.gridSizeBasedOnData = true;
        this.showRenameIcon=true;
        this.showNavVisibility=true;
        this.selectionDisabled = true;
        break;
      case 'PivotSheet':
        this.selectionDisabled = true;
        this.focusDisabled = true;
        this.editDisabled = true;
        this.showDatatype = false;
        this.unfreezeDisabled = true;
        this.gridSizeBasedOnData = true;
        this.showRenameIcon=true;
        this.showNavVisibility=true;
        break;
      case 'VUDSheet':
        this.reorderDisabled = false;
        this.showSortIcon = true;
        break;
      case 'AnalysisSheet':
        this.showSortIcon = false;
        this.gridSizeBasedOnData = true;
        this.showNavVisibility=true;
        this.gridSizeBasedOnData = true;
        break;
        
    }

    if(this.subtype && this.subtype == 'EnterData')
    {
      this.noUISave = true;
      this.readOnly = false;
      
      this.reorderDisabled = true;
    }

    if(this.isForImport)
    {
      this.showDatatype = false;
      this.showIcon = false;
      this.showCheck = true;
      this.reorderDisabled = true;
      this.focusDisabled = true;
      this.selectionDisabled = true;
      this.editDisabled = true;
    }
    if(ZDBClientUI.readOnlyMode)
    {
    this.editDisabled = true;
    }
  }

  // Grid Area 
  this.createZdbGrid = function(width,height)
  {
    
    this.setGridProp();
    ZDBDataGrid.setTemplateLayout(this);
    this.gArea.gridObj = this;
    this.setGridDimension(width,height);
    this.dArea.gridObj = this;
    if(this.type == "Report")
    	{
    	this.gAreaClass = "tabularSheet";//NO I18N
    	}
    if(this.gAreaClass != null){this.gArea.className = this.gAreaClass;}
    this.setRoughWorkArea();
    this.OUTER = {};
    this.freezeIcon = ZDBGlobal.freezeIcon.cloneNode(true);
    this.gArea.appendChild(this.freezeIcon);
    ZDBDataGrid.setIndices(this);
  }
    
    
    this.calculateWidth = function(text, addSpace, singleLine, isa)
    {
      var dummyCell = ZDBGlobal.dummyCell;
      var space = addSpace ? "&nbsp;" : "";
      text = space + text + space;
      dummyCell.innerHTML = singleLine ? "<nobr>" + text + "</nobr>" : text;
      return ZDBUtil.getStyleNumeric(dummyCell,'width');
    }

    
  this.resizeGrid = function(width,height,isFromFontSize)
    {
	  var isFiller=false;
	  if(this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
		  {
	  if(this.widthArray)
		  {
		  if(this.widthArray[this.widthArray.length-1] > 0)
			  {
			  isFiller=true;
			  }
		  }
		  }
      if(!width || !height)
      {
        return;
      }
      var border = 2;
      if(this.viewCtx && this.viewCtx.dashView) {
	    var dashboard = this.viewCtx.dashView;
//	    20 px new dashboard padding space
        width = parseInt(dashboard.dashLayout ? this.viewCtx.dashChildDiv.dlgBody.offsetWidth - 20 : this.viewCtx.dashChildDiv.dlgBody.style.width);
        //width = this.viewCtx.dashChildDiv.dlgBody.offsetWidth; $#Dash#$
        height = (this.type === 'PivotSheet' || this.type === 'SummarySheet')? height : parseInt(dashboard.dashLayout ? this.viewCtx.dashChildDiv.dlgBody.offsetHeight - 20 : this.viewCtx.dashChildDiv.dlgBody.style.height);
        //height = (this.type === 'PivotSheet' || this.type === 'SummarySheet')? height : parseInt(this.viewCtx.dashChildDiv.dlgBody.offsetHeight);$#Dash#$
        border = (this.type === 'PivotSheet' || this.type === 'SummarySheet') ? 0 : border;
      }
      width = width - border; 
      height = height - 2; 
      if((width && width == this.gWidth) && (height && height == this.gHeight))
      {
    	  if(!isFromFontSize)
		  {
    		  return;
		  }
      }
      var parNode = this.gArea.parentNode;
      if(parNode != null){parNode.removeChild(this.gArea);}
      this.setGridDimension(width,height);
      if(parNode != null){parNode.appendChild(this.gArea);}
      this.setShowHide();
      this.maintainRowCount();
      this.adjustDimension(); 
      if(this.type == "PivotSheet" || this.type == "SummarySheet")
    	  {
    	  this.adjustRowFill(true);
    	  }
      this.adjustFilterAreaDimension();
      if(ZDBGlobal.IS_MOBILE)
      {
        if(this.scroller){this.scroller.resizeScroller(this.dArea);}
      }
      if(this.selectedCols !== null && this.selectedCols.length > 0)
      {
        this.selectColumn();
      }
      if(this.type != "PivotSheet" && this.type != "SummarySheet") 
	  {
  if(this.widthArray)
	  {
	  var totalDataWidth=this.widthArray.reduce(function sum(total,num){return total+num;});
	  var gRightWidth=this.gRightArea.style.width;
	  gRightWidth=parseInt(gRightWidth);
	  if(gRightWidth > (totalDataWidth-this.widthArray[this.widthArray.length-1]))
	  {
	  this.generateColumnWidth(this.widthArray,totalDataWidth);
	  }
	  else if(isFiller)
		  {
		  this.generateColumnWidth(this.widthArray,totalDataWidth);
		  }
	  if(this.rhWidthArray)
		  {
		  this.generateLeftColumnWidth(this.rhWidthArray);
		  }
	  }
      this.adjustRowFill();
	  }
      ZDBGridScroll.checkAndShowScroll(this, null, null);
    }

    this.finalAdjustments = function()
    {// What is this final Adjustments method do?
            // We mainly have this method to adjust and tweak the grid dimension based on the available space.
            // The overflow property is auto. Hence we need to find the which scroll(vertical/horizontal) is present and based on that the adjustments are made.
      var gridType = this.type;
      var isEditDesign = (gridType == "TableDesign");		//No I18N
      if(gridType != "PivotSheet" && gridType != "SummarySheet" && !isEditDesign && !this.isForImport){return;}
      var gLeftArea = this.gLeftArea;
      var gRightArea = this.gRightArea;
      var dArea = this.dArea;
      var chArea = this.chArea;
      var gLeftAreaWidth = parseInt(gLeftArea.style.width);
      var gRightAreaWidth = parseInt(gRightArea.style.width);

      dArea.style.width = gRightAreaWidth+"px";
      chArea.style.width = gRightAreaWidth+"px";
      var isScrolling = this.checkIsScrollable();
      var scrollWidth = (isScrolling)?ZDBGlobal.scrollThick:0;
      var adjustedWidth = ((gLeftAreaWidth + gRightAreaWidth) >= this.gWidth)?gRightAreaWidth-scrollWidth:gRightAreaWidth;
      chArea.style.width = ((adjustedWidth>0)?adjustedWidth:0)+"px";
      var dAreaWidth = ((gLeftAreaWidth + gRightAreaWidth) >= this.gWidth)?gRightAreaWidth:(gRightAreaWidth+scrollWidth);
      dArea.style.width = ((dAreaWidth>0)?dAreaWidth:0)+"px";
    }

    this.checkIsScrollable = function()
    {
    	if(this.type === "PivotSheet" ||  this.type === "SummarySheet")
    		{//for pivot and summary no need to take the offsetheight which is costly
    		var isScrollable = this.gHeight < this.gDataHeight;
    		return isScrollable;
    		}
      var dTableHeight = parseInt(this.dTable.offsetHeight);//dTable is the table under dArea
      var dAreaHeight = parseInt(this.dArea.style.height);
      var isScrollable = (dAreaHeight < dTableHeight);
      return isScrollable;
    }
    
  this.getRowHeight = function(rowData, rowLen, rowObj)
  {
    var startType = rowObj.objType;
    var curRow;
    var height = 0;
    if(startType === ZDBConst.COLHEAD)
    {
      for(var j=0;j<rowLen;++j)
      {
        curRow = rowData[j];
        if(curRow !== rowObj)
        {
          height += curRow.height;  
        }
        else
        {
          break;
        }
      }
    }
    else
    {
      for(var j=0;j<rowLen;++j)
      {
        curRow = rowData[j];
        if(curRow.objType === ZDBConst.COLHEAD || curRow.status == ZDBConst.DELETED)
        {
          continue;  
        }
        else if(curRow == rowObj)
        {
          break;
        }
        else
        {
          height += curRow.height;
        }
      }
    }
    return height;
    
  }  
    
this.adjustRowFill = function(adjustGrid)
    {
//      var adjustGrid = true;
	  if(this.type == "PivotSheet" || this.type == "SummarySheet") // temporary check for pivot and summary
		  {
      var rowData = this.rowData;
      var rowLen = rowData.length;
      if(rowLen == 0)
      {
        return;
      }
      if(this.gridSizeBasedOnData === true)
      {//adjustment for Pivot and Summary view alone - gridSizeBasedOnData = true
        this.adjustRowHeadAreaDimension();
        this.adjustDataAreaDimension();
      }
      var fillerRow = this.rowData[rowLen-1];
      fillerRow.rowHeaderEl.style.display =  "none";
      fillerRow.rowDataEl.style.display =  "none";
      return;
		  }
	  else
		  {
      	if(this.totalRecords + this.addedRowCount - this.deletedRowCount < this.dTable.children.length && this.dArea.scrollTop == 0) 
		{ // this is because in table there will be an extra input row and a filler and addedrows and deletedrows count are taken into account
		if(this.type == "TableDesign" || this.type == "AnalysisSheet")
			{
			this.setFillerHeight(); // for Edit design and analysis sheet need to set row heights
			}
      	else
      		{
      		this.setFillerHeight(true); // filler is set only if the scrollTop is 0 & true is given because no need to adjust height of all rows here
      		}
		}
		  }
	   if(this.gridSizeBasedOnData)
		  {
		  this.adjustRowHeadAreaDimension();
		  this.adjustDataAreaDimension();
		  }
    }


    this.adjustColFill = function(alsoLeft)
    {
      if(!this.visible)
      {
        return;
      }
      var rowData = this.rowData;
      var rowLen = rowData.length;
      var baseCols = this.colHeaders;
      var baseColLen = baseCols.length;
      if(baseColLen < 1 || baseCols[baseColLen-1].objType !== ZDBConst.FILLER)
      {
        return;
      }
      
      if(this.chWidth === ZDBConst.NOTSET)
      {
        this.adjustColHeadAreaDimension();
      }
      var remainWidth = this.chWidth - this.getChAreaWidth();
	    if(remainWidth < 0)
      {
        remainWidth = 0;
      }
      
      if(remainWidth < 10) //PK: to check with KPS
      {
        //remainWidth = 10;
      }
      
      
      var fillerCol = baseCols[baseColLen-1];
      var fRowPrevWidth = fillerCol.width;
      if(this.isForImport)
          {
              remainWidth = remainWidth +parseInt(30);
          }
      fillerCol.width = remainWidth;
      var newFillerRowElWidth = parseInt(this.chAreaRowDiv.style.width) - fRowPrevWidth + remainWidth;
      if(fRowPrevWidth != remainWidth)
      {
        this.chAreaRowDiv.style.width = newFillerRowElWidth + "px";
      }
      fillerCol.visible = remainWidth ? true : false;
      if(fillerCol.visible && this.isFilterApplied)
      {
        var filterOptionFillerCell =  this.filterOptionRow.values[baseColLen-1];
        var filterDataFillerCell = this.filterDataRow.values[baseColLen-1];
        filterOptionFillerCell.width = remainWidth;
        filterDataFillerCell.width = remainWidth;
        this.placeCellElement(filterOptionFillerCell,[false, true, false, true], [false, alsoLeft,false,true]);
        this.placeCellElement(filterDataFillerCell,[false, true, false, true], [false, alsoLeft,false,true]);
      }
      var rowObj, cellObj, cellObjs;
      for(j=0;j<rowLen;++j)
      {
        rowObj = rowData[j];
        cellObjs = rowObj.values;
        cellObj = cellObjs[cellObjs.length-1];
        if(fRowPrevWidth != remainWidth && rowObj instanceof ZDBRow)
        {
        	if(this.type == "PivotSheet" || this.type == "SummarySheet")  // temporary check for pivot and summary
        		{
          rowObj.rowDataEl.style.width = newFillerRowElWidth + "px";
        		}
        }
        this.placeCellElement(cellObj, [false, true, false, true], [false, alsoLeft,false,true]);
      }
    }
    
    
  this.adjustDimension = function()
    {
      if(!this.visible)
      {
        return;
      }
      this.adjustTableControlAreaDimension();
      this.adjustColHeadAreaDimension();
      this.adjustRowHeadAreaDimension();
      this.adjustDataAreaDimension();
      //this.position = ZDBUtil.getObjCoordinates(this.parNode);
      this.tcArea.className = this.hideRhId ? "zdbTcAreaHidden" : "zdbTcArea";
      this.rhArea.className = this.hideRhId ? "zdbRhAreaHidden" : "zdbRhArea";
    }
  
    this.getTcAreaWidth = function()
    {
      var colHeaders = this.colHeaders;
      var colLen = colHeaders.length;
      var width = 0;
      var colObj = null;
      for(var k=0; k<colLen; ++k)
      {
        colObj = colHeaders[k].colObj;
        if(!colObj.freeze)
        {
          break;
        }
        if(colObj.visible)
        {
          width += colObj.width;
        }
      }
      //var hideRhId = colHeaders[0].parGrid.hideRhId;
      width = (isNaN(width))? 0 : width;
      return width; // borderWidth not to be considered
                    //here so returning only width not width+1 even when rhId is hidden
    }
    
    this.getTcAreaHeight = function()
    {
      var rowData = this.rowData;
      var rowLen = rowData.length;
      var height = 0;
      for(var i=0;i<rowLen;++i)
      {
        if(rowData[i].objType === ZDBConst.COLHEAD)
        {
          height += rowData[i].height;
        }
        else
        {
          break;
        }
        
      }
      return height;
    }
    
    this.getTableOffsetHeight = function(tableTbody)
    {
      var rows = tableTbody.childNodes;
      var rowLen = rows.length;
      var height = 0;
      for(var i=0;i<rowLen;++i)
      {
        height += parseInt(ZDBUtil.getStyle(rows[i], 'height'), 10); ///PK: Assumption rows has height value set
      }
      return height;
    }
    
    
    this.getChAreaWidth = function()
    {
      var colHeaders = this.colHeaders;
      var colLen = colHeaders.length;
      var width = 0;
      var colObj = null;
      for(var i=0;i<colLen;++i)
      {
        colObj = colHeaders[i];
        if(colObj.visible && colObj.freeze == false && colObj.objType != ZDBConst.FILLER)
        {
          width += colObj.width;
        }
      }
      return width;
    }


    this.setGridDimension = function(width, height)
    {
      if(!width || !height)
      {
        return;
      }
      this.gWidth = width;
      this.gHeight = height;
      this.gArea.style.width  = width + "px" ;
      this.gArea.style.height = height + "px";
      this.calculateMinRowsCount();
    }

    this.calculateMinRowsCount = function()
    {
    	if((this.view && this.view.isForDash) || (this.viewCtx && this.viewCtx.dashView))
    	{
    		this.minRows =  Math.ceil(this.gHeight/(ZDBGlobal.stdCellHeight*this.getFontSize()/ZDBGlobal.defaultFontsize));
    	}
    	else
    	{
    		this.minRows = Math.ceil(this.gHeight/parseInt(ZDBGlobal.stdCellHeight*7/ZDBGlobal.defaultFontsize));//7 is for minimum possible fontSize

    	}
    }
    
  this.adjustGridAreaDimension = function()
    {
      this.gArea.style.width = this.gWidth + "px";
      this.gArea.style.height = this.gHeight + "px";
    }

  this.adjustColHeadAreaDimension = function(reset)
  {
    if(this.tcWidth === ZDBConst.NOTSET)
    {
      this.adjustTableControlAreaDimension();
    }
    // We are hiding row number column in import preview table- so we are excluding tcWidth in the calculation  
    if(this.type == "PivotSheet" || this.type == "SummarySheet")
    	{
    	this.chWidth = this.setAndGetGridWidth() - this.tcWidth - this.getScrollThick();
    	}
    else
    	{
    this.chWidth = (this.isForImport) ? this.setAndGetGridWidth() - this.getScrollThick() : this.setAndGetGridWidth() - this.tcWidth - this.getScrollThick();
    	}
    if(this.chWidth < 0)
    {
      this.chWidth = 0;
    }

    this.gRightArea.style.width = (this.chWidth + this.getScrollThick()) + "px";
    this.chArea.style.width = this.chWidth + "px";
    this.chArea.style.height = this.tcHeight + "px";
    if(this.type == "PivotSheet" || this.type == "SummarySheet")//it is used only for Pivot to enable scroll bar 
    {
/*      var currentList=this.viewObj.currentList;
      var textAxisList = ZDBUtil.getElementsWithAttribute(currentList, "viewType","TEXTAXIS");//NO I18N
      var columnAxisList=ZDBUtil.getElementsWithAttribute(currentList, "viewType","XAXIS");//NO I18N*/
      var gLeftAreaWid;
      if(this.rhWidthArray.length > 0)
    	  {
         gLeftAreaWid = this.rhWidthArray.reduce(function(total,num){return total+num;});
    	  }
      var gAreaWid = this.gWidth;//parseInt(this.gArea.style.width);
      if((gLeftAreaWid && gAreaWid && gLeftAreaWid + 100 > gAreaWid)  || this.widthArray.length == 0) //No need to unfreeze for analysissheet
      {	 
    	//offsetWidth is Zero when tab is switched
        this.unfreezeColumn(true); 	 
      }
    }
  }


  this.getScrollThick = function()
  {
    if(this.isForImport)
    {
      this.gLeftArea.style.display ="none";
    }
	  if(ZDBGlobal.IS_MOBILE)
	  {
		  return 0;
	  }
    if(this.gridSizeBasedOnData === false)
    {
      return ZDBGlobal.scrollThick;
    }
    var st = ((this.gridSizeBasedOnData === true) && (this.gWidth < this.gDataWidth || this.gHeight < this.gDataHeight));
    // var st = (((this.gridSizeBasedOnData === true) && (this.gWidth < this.gDataWidth || this.gHeight < this.gDataHeight))? ZDBGlobal.scrollThick : 0);
    // st is used a criteria, hence assigning a numeric value leads to issue
    var scrollDivVisible = false;
    this.dArea.style.overflow = (st || scrollDivVisible )? "auto" : "hidden";
    return (((this.gWidth < this.gDataWidth) || (this.gHeight < this.gDataHeight) || (scrollDivVisible))? ZDBGlobal.scrollThick : 0);
  }
  
this.setAndGetGridWidth = function()
  {
    if(this.gridSizeBasedOnData === false)
    {
      return this.gWidth;
    }
    var gridWidth = 0;
    var colHeads = this.colHeaders; 
    var colLen = colHeads.length;
    var curCol;
    for(var i=0; i< colLen; ++i)
    {
      curCol = this.colHeaders[i]; 
      if(curCol.visible && curCol.objType != ZDBConst.FILLER)
      {
        gridWidth += curCol.width;
      }
    }
   this.gDataWidth = gridWidth;
    if(this.gWidth < this.gDataWidth)
    {
            gridWidth += this.getScrollThick();
    }
    else if(this.hideRhId)
    {
        gridWidth++;
    }
    this.gDataWidth = gridWidth;
    return gridWidth < this.gWidth ? gridWidth : this.gWidth;
  }


  this.adjustDataAreaDimension = function()
    {
      var dHeight = this.rhHeight + this.getScrollThick();
      var dWidth = this.chWidth + this.getScrollThick();
      var gridObj = this;
      if(dWidth < 0)
      {
        dWidth = 0;
      }
 
     this.dArea.style.width =  dWidth + "px";
      this.dArea.style.height = dHeight + "px";
      this.dWidth = dWidth;
      this.dHeight = dHeight;
      if(ZDBGlobal.IS_MOBILE && ((this.type == 'VUDSheet') || !(BROWSER.IS_MOBILE_PHONE && ZDBClientUI.selectedTab
              && window.ZDBDashboard && ZDBClientUI.selectedTab.view instanceof ZDBDashboard)))
      {
          if(!this.scroller && !this.scrollDisabled)
          {
              var opts = {"V_SCROLL_ELS" : [this.rhArea], "H_SCROLL_ELS" : [this.chArea,this.fArea1],
                      "ONSCROLLDOWN_LAZYLOAD" : function(){ZDBGridScroll.addRowsToGrid(gridObj,false,false,ZDBCallBack.dummyCallBack);},  //No I18N
                      "ONSCROLLUP_LAZYLOAD" : function(){ZDBGridScroll.addRowsToGrid(gridObj,true,false,ZDBCallBack.dummyCallBack)},  //No I18N
                      "ONSCROLL_START" : function(){ZDBGridScroll.showRowNavigComp(gridObj);ZDBGridScroll.positionIpadNavComp(gridObj);gridObj.clearScrollTimeout();}, //No I18N
                      //"ONTOUCH_START" : function(){},	//No I18N
                      "ONSCROLL_STOPS" : function(){ZDBGridScroll.positionIpadNavComp(gridObj,true);}}; //No I18N
              this.scroller = new ZRScroller(this.dArea,opts);
          }
          else
          {
        	  this.scroller.resizeScroller(this.dArea);
          }
          ZDBGridScroll.positionIpadNavComp(gridObj);
          this.setRowNavigComp(false);
      }
      else
      {
    	  this.setRowCount();
      }
      this.finalAdjustments();
    }
    
  this.adjustTableControlAreaDimension = function()
  {
    this.tcWidth = this.getTcAreaWidth();
    this.tcHeight = this.getTcAreaHeight();
    if(this.type == "PivotSheet" || this.type == "SummarySheet") // temporary check for Pivot and Summary 
    	{
      this.tcArea.style.width =  this.tcWidth + "px";
    	}
    this.gLeftArea.style.width = this.tcWidth + "px";
    this.tcArea.style.height = this.tcHeight + "px";
  }
    
this.adjustRowHeadAreaDimension = function()
  {
    ///PKDIV: this.rhArea.style.height = this.gHeight - parseInt(this.tcArea.style.height,10) - this.getFilterHeight() - this.getScrollThick() + "px";
    if(this.tcHeight === ZDBConst.NOTSET)
    {
      this.adjustTableControlAreaDimension();
    }
    if(this.fHeight === ZDBConst.NOTSET)
    {
      this.adjustFilterAreaDimension();
    }
 
    var height = this.setAndGetGridHeight();
    var scrollThick = this.getScrollThick();
    if(scrollThick < 1 && this.type != "TableDesign")
    {
      this.dArea.style.borderBottomWidth = "1px";//No I18N
      //this.dArea.style.borderBottomStyle = "solid"
    }
    else
    {
      this.dArea.style.borderBottomWidth = "0px";//No I18N
    }
 
    this.rhHeight = height - this.tcHeight - this.fHeight - scrollThick;
    this.rhArea.style.height = this.rhHeight + "px";
    if(this.type == "PivotSheet" || this.type == "SummarySheet") //temporary check for pivot and summary
    	{
    this.rhArea.style.width = this.tcWidth + "px";
    if((this.gridSizeBasedOnData === true) && (this.gWidth < this.gDataWidth) && !(this.gHeight < this.gDataHeight) && (this.dArea.style.width!=null && this.dArea.style.width!=""))
    {
        this.chArea.style.width = parseInt(this.dArea.style.width)+"px";
//            this.dArea.style.borderRight = "1px solid #cccccc";//No I18N
//  //  //  an additional line for Pivot
    }
    	}
    if((this.gridSizeBasedOnData === true) && (this.gHeight < this.gDataHeight) && !(this.gWidth < this.gDataWidth) && (this.dArea.style.height!=null && this.dArea.style.height!=""))
    {
        this.rhArea.style.height = parseInt(this.rhHeight + scrollThick) + "px";
        if(this.type != "TableDesign")
        {
        	//this.gLeftArea.style.borderBottom = "1px solid #cccccc";//No I18N
        	this.dArea.style.borderBottomWidth = "1px";//No I18N
        }
    }
    this.gLeftArea.style.height = height + "px";
    this.gRightArea.style.height = this.gLeftArea.style.height;
  }    

  this.setAndGetGridHeight = function()
  {
    if(this.gridSizeBasedOnData === false)
    {
      this.gDataHeight = this.gHeight;
      return this.gHeight;
    }

    var rowData = this.rowData;
    var rowLen = rowData.length;
    var curRow;
    gridHeight = 0;
    for(var i=0; i<rowLen; ++i)
    {
        curRow = rowData[i];
        if(curRow.objType != ZDBConst.FILLER)
        {
          gridHeight += curRow.height;
        }
    }
    this.gDataHeight = gridHeight;
    gridHeight += this.getScrollThick();
    return gridHeight < this.gHeight ? gridHeight : this.gHeight;
  }
  
  this.onLostFocus = function()
    {
      this.rowHeadFocus = false;
      this.colHeadFocus = false;
      this.dataFocus = false;
      this.gridFocus = false;
      this.curCellPos = null;      
      this.removeCellFocus();
    }

this.onFocus = function(event, noCellFocus)
{

  /// Need to handle a lot more ;-)

  if(event)
  {
    //PK: Hack for FF2
    var srcEl = ZDBUtil.getSourceElement(event);
    if(srcEl && srcEl.tagName && srcEl.tagName.toUpperCase() == 'SELECT')
    {
      return;
    }
  }

  if(this.isEdit == true)
  {
    return;
  }
  this.gridFocus = true;
  var keyHandler = this.keyHandler;
  if(!keyHandler.gridObj)
  {
    keyHandler.gridObj = this;
  }         
  var lastFocusCell = ZDBDataGrid.getLastFocusCell(this);
  if(lastFocusCell && !noCellFocus)
  {
    this.setCellFocus(lastFocusCell, false);
  }
  ZDBDataGrid.setKeyHandlerFocus(gridObj, 10);
}
  this.showTable = function()
    {
      if(!this.shown)
      {
//          if(this.gridHeaderRows != null)
//          {
//            this.addPivotHeadRows(this.gridHeaderRows);
//          }
        this.visible = true;
        this.adjustDimension();
        this.adjustRowFill();
        if(this.gArea.addEventListener)
        {
          this.gArea.addEventListener('DOMMouseScroll', ZDBGridScroll.onMouseWheel, false);
          this.gArea.getElementsByClassName("zdbGLeftArea")[0].addEventListener("mousewheel",function(event){event.stopPropagation();}); //NO I18N
          this.gArea.getElementsByClassName("zdbGLeftArea")[0].addEventListener("DOMMouseScroll",function(event){event.stopPropagation();}); //NO I18N
        }
        this.shown = true;
      }
      if(this.viewCtx && this.viewCtx.dashView && !ZDBGlobal.IS_MOBILE) // To Prevent Scroll on Tables(pivot,summary,tabular,query,table) in Dashboard
      {
    	  DashUtils.scrollFreezeLayer(this, this.viewCtx.dashView);
      }
      var lastFocusCell = ZDBDataGrid.getLastFocusCell(this);
      if(lastFocusCell)
      {
        this.setCellFocus(lastFocusCell,true);
      }
      else if((this.viewCtx == null) || (this.viewCtx.canGrabFocus()))
      {//The checks have has been added for dashboard .Otherwise dashboard scrolls down.
        this.focusFirstCell();
        if(this.type == "TableDesign" && this.objId == "null")
        {
        	setTimeout(function(){
        		gridObj.setCellEditable((ZDBDataGrid.getCurrentCell(gridObj)));
        	},100);
        }
      }
      this.setFreezeIcon();
      this.reorderDisabled = (this.type == "VUDSheet") ? false : this.reorderDisabled; 
      if(!this.isFilterApplied){
      this.setShowHide();
      }
      this.onFocus(null, false);
    }
    
  this.setShowHide = function()
  {
      this.showHideElInEmbed = ZDBUtil.getAttribute(this.showHide, "showInEmbed");
      if(this.reorderDisabled === false)
      {
        var shStyle = this.showHide.style;
        var left = this.setAndGetGridWidth() - this.getScrollThick();
        if(left < 0)
        {
          left = 0;
        }
        var height = ZDBGlobal.stdColHeight + (BROWSER.IE ? 0 : -5);
        if(height < 0)
        {
          height = 0;
        }
        shStyle.top = '0px';
        shStyle.left = '6px';  //NO I18N
        shStyle.height = height + "px";
        shStyle.width = "18px"; ///??? fixed width
        shStyle.display = (this.type == "VUDSheet")? ((this.showHideColsVisible==true)? "block" : "none") : "block";
      }
      else
      {
        this.showHide.style.display = "none";
      }
      if(this.showHideElInEmbed == "false")
      {
          this.showHide.className = "zdbColHead";
          this.showHide.style.display = "none";
          this.showHide.style.height = BROWSER.IE ? "22px" : "20px";
          this.showHide.style.width = "18px";
          this.showHide.onclick = null;
          this.showHide.onmousedown = null;
          this.showHide.onmouseover = null;
      }
  }
  
  this.associateColHead = function(cellEl, colHead, headRow)
  {
      ZDBUtil.removeNonElements(cellEl);
      colHead.cellEl = cellEl;
      cellEl.cellObj = colHead;
      colHead.rowObj = headRow;
      colHead.colObj = colHead;
      var colNodes = cellEl.getElementsByTagName("div");
      var colNodesLen = colNodes.length;
      colHead.checkNode = colNodes[0];
      colHead.typeNode = colNodes[1];
      colHead.renameIcon=colNodes[2];
      colHead.displayNode = colNodes[3];
      colHead.iconNode = colNodes[4];
      var displayname = colHead.displayName;
      if(colHead.parGrid.type == 'VUDSheet')
      {
          if(this.duplicateColNames.indexOf(displayname) >= 0)
          {
            var tableName = this.tableIdNameMapping[colHead.parentViewId];
            displayname = displayname + " ("+tableName+") ";
          }
      }
      colHead.displayNode.innerHTML = ZDBEscapeUtil.encodeForHtml(displayname);
      cellEl.style.display = (colHead.visible)? "block":"none";
      if(colHead.parGrid.type == 'PivotSheet' || colHead.parGrid.type == 'SummarySheet')
      {
        colHead.renameIcon.style.display="block";
      }
      if(colHead.objType != ZDBConst.COLHEAD)
      {
        for(var i=0;i<colNodesLen;++i)
        {
          colNodes[i].style.display = "none";
        }
      }
      if(ZDBGlobal.IS_MOBILE && !this.isForImport)
      {
    	  new TouchButton(colHead.iconNode,ZDBSorting.sortIconTapped,true,null,null,null,true,true,false,true);	//No I18N
      }
      colHead.setClass();
  } 


  this.addColToView = function(colHead, baseRow)
  {
    var cellEl = ZDBGlobal.colHead.cloneNode(true);
    if(!baseRow)
    {
      baseRow = this.baseRow;
    }
    this.associateColHead(cellEl, colHead, baseRow);
    if(colHead.objType === ZDBConst.ROWHEAD)
    {
      jQuery(this.tcAreaRowDiv).prepend(cellEl);
    }
    else if(colHead.objType === ZDBConst.DUMMY || colHead.objType === ZDBConst.FILLER)
    {
      this.chAreaRowDiv.appendChild(cellEl);
    } 
    else
    {
      if(colHead.freeze)
      {
        this.tcAreaRowDiv.appendChild(cellEl);
      }
      else
      {
        this.chAreaRowDiv.appendChild(cellEl);
      }
    }
    if(colHead.width < 0)
    {
      colHead.width = ZDBDataGrid.calculateColWidth(colHead, this);
    }   

    colHead.width =Math.round(( colHead.width / ZDBGlobal.defaultFontsize) * this.getFontSize());
    
    this.placeCellElement(colHead, [true, true, true, true], [false, false, true, true]);
    ZDBDataGrid.setColHeadDisplayWidth(this, colHead);
    
    if(this.view && this.view.chartProp && this.view.chartProp.zr_wrap_colHead)
    {
    	ZDBDataGrid.setColHeadDisplayHeight(colHead, baseRow);
    }

    //Grid-Header Tooltip
    cellEl.setAttribute("dontwrap",true);
    if(!ZDBGlobal.IS_MOBILE)
    {
        var displayname = colHead.displayName;
        if(colHead.parGrid.type == 'VUDSheet')
        {
            if(this.duplicateColNames.indexOf(displayname) >= 0)
            {
                var tableName = this.tableIdNameMapping[colHead.parentViewId];
                displayname = displayname + " ("+tableName+") ";
            }
        }
    	cellEl.setAttribute("tiptitle",displayname);
    	cellEl.setAttribute("showTipAtCursorPos", "true");
    	if(colHead.description)
    	cellEl.setAttribute("tipdesc1",colHead.description);
        
    }
  }
  
  
  
  this.showHideColumn = function(shList,list,donNotUpdateClient,isVUD)
  {
    
    var shLen = shList.length;
    if(shLen == 0)
    {
      return;
    }
    var leftIndex = shList[0][0][11];
    var curHead;                  
    var colHeaders = this.allColHead;
    var colLen = colHeaders.length;
    var visibleList = [];
    for(var i=0;i<shLen;++i)
    {
        visibleList.push(shList[i][12]);   
    }
    for(var i=0;i<shLen;++i)
    {
        visibleList[shList[i][0][11]] = shList[i][1]; //PK: assumption index available 
    }

    var atleastOneVisible = false;
    for(var i=0;i<colLen;++i)
    {
      if(colHeaders[i][12])          //PK: listLen == colLen
      {
        atleastOneVisible = true;
        break;
      }
    }
    
    if(!atleastOneVisible)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.showrhide.js.allColHideErr'));
      return;
    }
    
    
    
    for(var i=0;i<shLen;++i)
    {
        curHead = shList[i][0];
        curHead[12] = shList[i][1];
        if(curHead[11] < leftIndex)
        {
          leftIndex = curHead[11];
        }
    }

    var rowData = this.rowData;
    var rowLen = rowData.length;
    var curRow, cellObjs, cellObj, colObj, cellLen;
    var disp;
    for(var i=0;i<rowLen;i++)
    {
      curRow = rowData[i];
      cellObjs = curRow.values;
      cellLen = cellObjs.length;
      var rhEl = (curRow.objType != ZDBConst.COLHEAD) ? curRow.rowHeaderEl : this.tcAreaRowDiv;
      var rdEl = (curRow.objType != ZDBConst.COLHEAD) ? curRow.rowDataEl : this.chAreaRowDiv;
      var rhRowDivWidth = parseInt(rhEl.style.width);
      var rdRowDivWidth = parseInt(rdEl.style.width);
      rhEl.style.width = rhRowDivWidth + "px";
      rdEl.style.width = rdRowDivWidth + "px";
    }   

    if(this.type == "PivotSheet"  || this.type == "SummarySheet") // temporary check for pivot and summary. no need to call adjustColFill()  for table because it will be handled by generateWidthArray() method
  	  {
     //this.adjustColFill(true);
  	  }
    if(this.filterVisible)
    {
  //    this.resetFilterColumnVisible();
    }
    if(shList && this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
  	  {
  	  var count=0;
  	  for(var i=1;i<this.rhWidthArray.length;i++)
  		  {
  		  if(this.rhWidthArray[i] > 0)
  			  {
  			  if(!visibleList[i])
  				  {
  				  this.rhWidthArray[i]=0;
  				  }
  			  }
  		  else
  			  {
  			  if(visibleList[i])
  				  {
  				  this.rhWidthArray[i]=colHeaders[i][10];
  				  }
  			  }
  		  count++;
  		  }
  	  for(var i=this.rhWidthArray.length;i<visibleList.length;i++)
  		  {
  		  if(this.widthArray[i-count-1] > 0)
			  {
			  if(!visibleList[i])
				  {
				  this.widthArray[i-count-1]=0;
				  }
			  }
		  else
			  {
			  if(visibleList[i])
				  {
				  this.widthArray[i-count-1]=colHeaders[i][10];
				  }
			  }
  		  }
  //	  this.generateColumnWidth(this.widthArray);
  	  if(this.rhWidthArray)
  		  {
  //		  this.generateLeftColumnWidth(this.rhWidthArray);
  		  }
  	  if(count > 0)
  		  {
  		  this.setFreezeIcon();
  		  }
  	  }
    this.hideSelection();
    this.removeCellFocus();
    if(donNotUpdateClient){
    	return;
    }
    else{
    	this.sendAndUpdateClientState(true,"SHOWHIDECOLUMN",isVUD); //NO I18N	
    }
    
  }
  
  this.showHideColumnDash = function(shList)
    {
      
      var shLen = shList.length;
      if(shLen == 0)
      {
        return;
      }
      var leftIndex = shList[0][0].cellPos;
      var curHead;                  
      var colHeaders = this.colHeaders;
      var colLen = colHeaders.length;
      var visibleList = [];
      for(var i=0;i<colLen;++i)
      {
        if(colHeaders[i].objType !== ZDBConst.COLHEAD)
        {
          visibleList.push(false); //PK: non-COLHEADs are not considered
        }
        else
        {
          visibleList.push(colHeaders[i].visible);
        }
        
      }
      for(var i=0;i<shLen;++i)
      {
          visibleList[shList[i][0].cellPos] = shList[i][1]; //PK: assumption index available 
      }

      var atleastOneVisible = false;
      for(var i=0;i<colLen;++i)
      {
        if(colHeaders[i].objType === ZDBConst.COLHEAD && visibleList[i])          //PK: listLen == colLen
        {
          atleastOneVisible = true;
          break;
        }
      }
      
      if(!atleastOneVisible)
      {
        ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.showrhide.js.allColHideErr'));
        return;
      }
      
      
      
      for(var i=0;i<shLen;++i)
      {
          curHead = shList[i][0];
          curHead.visible = shList[i][1];
          if(curHead.cellPos < leftIndex)
          {
            leftIndex = curHead.cellPos;
          }
      }

      var rowData = this.rowData;
      var rowLen = rowData.length;
      var curRow, cellObjs, cellObj, colObj, cellLen;
      var disp;
      for(var i=0;i<rowLen;i++)
      {
        curRow = rowData[i];
        cellObjs = curRow.values;
        cellLen = cellObjs.length;
        var rhEl = (curRow.objType != ZDBConst.COLHEAD) ? curRow.rowHeaderEl : this.tcAreaRowDiv;
        var rdEl = (curRow.objType != ZDBConst.COLHEAD) ? curRow.rowDataEl : this.chAreaRowDiv;
        var rhRowDivWidth = parseInt(rhEl.style.width);
        var rdRowDivWidth = parseInt(rdEl.style.width);
        for(var k=0;k<cellLen;++k)
        {
          cellObj = cellObjs[k];
          colObj = cellObj.colObj;
          if(colObj.cellPos < leftIndex)
          {
            continue;
          }
          if(this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivto and summary
        	  {
          disp = colObj.visible ? "" : "none";  //No I18N
        	  }
          else
        	  {
              disp = colObj.visible ? "inline-block" : "none";  //No I18N
        	  }
          if(cellObj.cellEl.style.display != disp)
          {
            if(colObj.freeze)
            {
              rhRowDivWidth = (colObj.visible) ? rhRowDivWidth + colObj.width : rhRowDivWidth - colObj.width;
            }
            else
            {
              rdRowDivWidth = (colObj.visible) ? rdRowDivWidth + colObj.width : rdRowDivWidth - colObj.width;
            }
            cellObj.cellEl.style.display = disp;
          }
        }
        rhEl.style.width = rhRowDivWidth + "px";
        rdEl.style.width = rdRowDivWidth + "px";
      }   
      this.adjustDimension();
      if(this.type == "PivotSheet"  || this.type == "SummarySheet") // temporary check for pivot and summary. no need to call adjustColFill()  for table because it will be handled by generateWidthArray() method
    	  {
       //this.adjustColFill(true);
    	  }
      if(this.filterVisible)
      {
        this.resetFilterColumnVisible();
      }
      if(shList && this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
    	  {
    	  var count=0;
    	  for(var i=1;i<this.rhWidthArray.length;i++)
    		  {
    		  if(this.rhWidthArray[i] > 0)
    			  {
    			  if(!visibleList[i])
    				  {
    				  this.rhWidthArray[i]=0;
    				  }
    			  }
    		  else
    			  {
    			  if(visibleList[i])
    				  {
    				  this.rhWidthArray[i]=colHeaders[i].width;
    				  }
    			  }
    		  count++;
    		  }
    	  for(var i=this.rhWidthArray.length;i<visibleList.length;i++)
    		  {
    		  if(this.widthArray[i-count-1] > 0)
			  {
			  if(!visibleList[i])
				  {
				  this.widthArray[i-count-1]=0;
				  }
			  }
		  else
			  {
			  if(visibleList[i])
				  {
				  this.widthArray[i-count-1]=colHeaders[i].width;
				  }
			  }
    		  }
    	  this.generateColumnWidth(this.widthArray);
    	  if(this.rhWidthArray)
    		  {
    		  this.generateLeftColumnWidth(this.rhWidthArray);
    		  }
    	  if(count > 0)
    		  {
    		  this.setFreezeIcon();
    		  }
    	  }
      this.hideSelection();
      this.removeCellFocus();
      this.sendClientState(false,"SHOWHIDECOLUMN");		//NO I18N
    }


    
  this.freezeColumn = function(colObj)
    {
      var colHeaders = this.colHeaders;
      if(!(colObj instanceof ZDBColHeader))
      {
        colObj = colHeaders[parseInt(colObj,10)+1]; /// colObj is instance
      }
      if(colObj.freeze)
      {
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.table.showinfo.js.freezingColErr"));
        return;
      }
      var curHead;
      var freezePos = colObj.cellPos;
      this.freezePos = freezePos;
      var freezeStart = -1;
      
      for(var i=0; i<=freezePos;++i)
      {
        curHead = colHeaders[i];
        if(curHead.freeze)
        {
          continue;
        }
        if(freezeStart == -1) {freezeStart = i;}
        curHead.freeze = true;     
      }

      var rowData = this.rowData;
      var rowLen = rowData.length;
      var curHead, colEl;
      var tcArea = this.tcArea;
      var rhArea = this.rhArea;
      var rowType, cellObj, cellObjs;
      for(var i=0;i<rowLen;++i)
      {
        var curRow = rowData[i];
        if(curRow.status == ZDBConst.DELETED)
        {
          continue;
        }
        rowType = curRow.objType;
        cellObjs = curRow.values;
        var cellLen = cellObjs.length;
        for(var j = 0; j < cellLen;++j)
        {
          cellObj = cellObjs[j];
          curHead = cellObj.colObj;
          if(curHead.cellPos < freezeStart)
          {
            continue;
          }
          if(curHead.cellPos > freezePos)
          {
            break;
          }
          if(rowType === ZDBConst.COLHEAD)
          { 
            this.tcAreaRowDiv.appendChild(cellObj.cellEl);
            if(curHead.visible)
            {      
            	var tc = this.tcTable;    // tc will be tcTable if type is not Pivot and Summary else it will be tcAreaRowDiv
            	var ch = this.chTable;    // same as tc
            	if(this.type == "PivotSheet"  || this.type == "SummarySheet")  // temporary check for pivot and summary
            		{
            		tc = this.tcAreaRowDiv;
            		ch = this.chAreaRowDiv;
            		tc.style.width = (parseInt(tc.style.width) + curHead.width) + "px";
            		}              
              ch.style.width = (parseInt(ch.style.width) - curHead.width) + "px";
            }
          }
          else
          {
            curRow.rowHeaderEl.appendChild(cellObj.cellEl);
            if(curHead.visible)
            {
              curRow.rowHeaderEl.style.width = (parseInt(curRow.rowHeaderEl.style.width) + curHead.width) + "px";
              curRow.rowDataEl.style.width = (parseInt(curRow.rowDataEl.style.width) - curHead.width) + "px";
            }
          }
        }
        var tc=this.tcTable; // tc will be tcTable if type is not Pivot and Summary else it will be tcArea
        var rh=this.rhTable; // same as tc
        if(this.type == "PivotSheet" || this.type == "SummarySheet")  // temporary check for pivot and summary
        	{
        	tc=this.tcArea;
        	rh=this.rhArea;
        	}
        if(rowType == ZDBConst.COLHEAD)
        {
          tc.appendChild(this.tcAreaRowDiv);
        }
        else
        {
          rh.appendChild(curRow.rowHeaderEl);
        }
      }

      this.freeze = true;
      this.adjustDimension();
      if(this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
    	  {
    	  if(this.type != "TableDesign")
    		  {
      var rhWidthArray=[];
      if(this.rhWidthArray != null)
    	  {
    		  rhWidthArray=this.rhWidthArray;
    	  }
      else
    	  {
      rhWidthArray=[30];
    	  }
      for(var i=rhWidthArray.length-1;i<freezePos;i++)
    	  {
    	  rhWidthArray.push(this.widthArray.shift());
    	  }
      this.rhWidthArray=rhWidthArray;
      this.generateColumnWidth(this.widthArray);
      this.generateLeftColumnWidth(rhWidthArray);
    		  }
    	  else
    		  {
    		  this.maintainWidthArray(this.colHead);  		  
    		  }
      this.adjustInViewRowsHeight();
    	  }
      this.setFreezeIcon();
      this.resetFilterOnFreeze();
      this.selectColumn();
      if(this.type != "PivotSheet" && this.type != "SummarySheet" && this.filterVisible)  // there will be no filte inside the grid in pivot and sumamry
	  {
  this.adjustFilterRowHeight();
	  }
    }
  
    this.unfreezeColumn = function(isPvt)
    {
      if(this.type == 'TableDesign')
      {
        return;
      }      
      if(this.rhWidthArray.length <= 1)
      {
    	  return;//No need to unfreeze if there is only one column or less in left side table(rhTable)
      }
      var colHeaders = this.colHeaders;
      var colLen = colHeaders.length;
      var rowData = this.rowData;
      var rowLen = rowData.length;
      var curHead, cellObj, cellObjs;
      var chArea = this.chArea;
      var dArea = this.dArea;

      for(var i=0;i<rowLen;++i)
      {
        var curRow = rowData[i];
        var rowType = curRow.objType;
        cellObjs = curRow.values;
        var cellLen = cellObjs.length;
        var rdEl = (rowType == ZDBConst.COLHEAD && !curRow.rowDataEl) ? this.chAreaRowDiv : curRow.rowDataEl;
        var rhEl = (rowType == ZDBConst.COLHEAD && !curRow.rowHeaderEl) ? this.tcAreaRowDiv : curRow.rowHeaderEl;
        var rdElWidth = 0;
        var rhElWidth = 0;
        for(var j = 0; j < cellLen;++j)
        {
          cellObj = cellObjs[j];
          curHead = cellObj.colObj;
          if(curHead.objType == ZDBConst.ROWHEAD)
          {
            rhElWidth = rhElWidth + curHead.width;
            continue;
          }
          if(isPvt && curHead.freeze)
          {
            curHead.unFreezeForScroll = true;
          }
          curHead.freeze = false; ///PK: Apply intelligence
          rdEl.appendChild(cellObj.cellEl);
          //Pivot with multiple column headers and unFreezeForScroll == true, row width should be based on cell width
          var curCellWidth = (rowType == ZDBConst.COLHEAD && cellObj.width) ? cellObj.width : curHead.width;
          rdElWidth = (curHead.visible) ? rdElWidth + curCellWidth : rdElWidth;
          //(rowType === ZDBConst.COLHEAD ? chArea : dArea).appendChild(cellObj.cellEl);
        }
      }
      this.freeze = false;
      while(this.rhWidthArray.length != 1)
	  {
	  this.widthArray.unshift(this.rhWidthArray.pop());
	  }
      this.adjustDimension();

    if(this.type != "PivotSheet" && this.type != "SummarySheet") // temporary check for pivot and summary
 	 {
      this.generateColumnWidth(this.widthArray);
      this.generateLeftColumnWidth(this.rhWidthArray);
      this.adjustInViewRowsHeight();
      }
      this.setFreezeIcon();
      this.resetFilterOnFreeze();
      this.selectColumn();
      if(this.type != "PivotSheet" && this.type != "SummarySheet" && this.filterVisible)  // there will be no filte inside the grid in pivot and sumamry
    	  {
      this.adjustFilterRowHeight();
    	  }
      this.freezePos = undefined;
    }



    this.setFreezeIcon = function()
    {
      if(this.type == "TableDesign" || this.type == "SummarySheet" || this.type == "PivotSheet")
    	{
    		this.freezeIcon.style.display = "none";
    		return;
    	}
      var colHeads = this.colHeaders;
      var colLen = colHeads.length;
      var fIndex = null;
      for(var i=1;i<colLen;++i)
      {
        if(!colHeads[i].freeze)
        {
          break;
        }
        fIndex = i;
      }
      if(fIndex === null)
      {
        this.freezeIcon.style.display = "none";
        return;      
      }
      while(true)
    	  {
    	  if(colHeads[fIndex].visible)
    		  {
    		  break;
    		  }
    	  fIndex--;
    	  }
      var left = colHeads[fIndex].cellEl.offsetLeft + colHeads[fIndex].width;
      var top = 0;
      var freezeStyle = this.freezeIcon.style;
      var adjust = 8;
      freezeStyle.top = top - adjust + "px";
      freezeStyle.left = left - adjust + "px";
              
      if((this.parentViewType + "").toLowerCase() == 'pivot')
      {
        this.freezeIcon.style.display = "none";
      }
      else
      {
        this.freezeIcon.style.display = "block";
      }
      if(this.unfreezeDisabled)
      {
        ZDBDataGrid.setUnfreezeInfo(this.freezeIcon)
      }

    }

  
  
  this.addRowToView = function(rowObj,index,insertBeforeDummy, isGrandSummaryCell)
  {
    //First batch will always be 10 or less rows & filler row will be added as soon as first batch completes.
    //Hence, first 10 records are append and next consecutive rows will be insert before filler row.
    //In design grid, when error occurs on deleting and saving the grid deleted row will be reverted.
    //In this case alone it has to be inserted before the dummy row.
    this.domCache.associateRow(rowObj);
    this.columnAlignment(rowObj);
    
	//Append GrandSummaryCell here
    if(isGrandSummaryCell && rowObj.values != undefined)
    {
      this.appendGrandSummaryCell(rowObj.values[1]);
    }
    
    var cellObjs = rowObj.values;
    var dataLen = cellObjs.length;
    var heightObj, height = rowObj.height, curHeight;
    var rowDataEl = rowObj.rowDataEl;
    var rowHeaderEl = rowObj.rowHeaderEl;

    var colHeaders = this.colHeaders;
    var colLen = colHeaders.length;
    var rhArea = this.rhArea;
    var dArea = this.dArea;
    var tcArea = this.tcArea;
    var chArea = this.chArea;
    var dataEl, cellObj, curHead;
    var par;
    var rowType = rowObj.objType;
    var colObj, isFreeze, isVisible;
    var rhElWidth = 0, rdElWidth = 0;
    for(var i=0;i<dataLen;++i)
    {
      cellObj = cellObjs[i];
      dataEl = cellObj.cellEl;
      isFreeze = cellObjs[i].colObj.freeze;
      isVisible = cellObj.colObj.visible;
      
      rhElWidth = (rowType != ZDBConst.COLHEAD && isFreeze && isVisible) ? rhElWidth + cellObj.colObj.width : 
                  (isFreeze && isVisible) ? rhElWidth + cellObj.colObj.width : rhElWidth;
      rdElWidth = (rowType != ZDBConst.COLHEAD && !isFreeze && isVisible) ? rdElWidth + cellObj.colObj.width : 
                  (!isFreeze && isVisible) ? rdElWidth + cellObj.colObj.width : rdElWidth;
      (rowType === ZDBConst.COLHEAD ? isFreeze ? rowHeaderEl : rowDataEl : isFreeze ? rowHeaderEl : rowDataEl).appendChild(dataEl);
      //(rowType === ZDBConst.COLHEAD ? isFreeze ? tcArea : chArea : isFreeze ? rhArea : dArea).appendChild(dataEl);
      this.placeCellElement(cellObj, [true, true, true, true], [false, false, false, false]);
    }
    
    rowHeaderEl.className = "zdbDataRowDiv";  

    rowDataEl.className = "zdbDataRowDiv";
    
//    if(this.type == "Report")  //need for future reference
//    	{
//    	if((rowObj.rid % 2) == 0)
//    		{
//    		rowHeaderEl.className = rowDataEl.className += " zdbEvenRow";
//    		}
//    	else
//    		{
//    		rowHeaderEl.className = rowDataEl.className += " zdbOddRow";
//    		}
//    	}
    if(this.type == "SummarySheet" || this.type =="Report")
    {
    	var cells = rowDataEl.children;
    	count= 0;
    	for(var i=0;i<cells.length;i++)
    	{
    		if(cells[i].className.indexOf("groupCellEnd") != -1)
    		{
    			count++;
    		}
    		else if(cells[i].className.indexOf("zdbDataCell") != -1)
    		{
    			this.totalGroupedCol = i;
    			break;
    		}
    	}
    	for(var i=cells.length-1;i>=0;i--)
    	{
    		if((count > 1 && this.type =="SummarySheet") || (count >= 1 && this.type == "Report"))
    		{
    			if(cells[i].className.indexOf("zdbDataCell") != -1)
    			{
    				cells[i].className += " dataBottomLine";
    			}
    			if(cells[i].className.indexOf("groupCellEnd") != -1)
    			{
    				cells[i].className += " groupRightEnd";
    				break;
    			}
    		}
    		else if(cells[i].className.indexOf("groupCellEnd") != -1)
    		{
    			cells[i].className += " groupRightEnd notBottomLine";
    			break;
    		}
    	}
    }
    if(this.type == "PivotSheet")
    {
    	var cells = rowHeaderEl;
    	cells.lastChild.className += " groupRightEnd"; //No I18N
    }
    if(rowType == ZDBConst.FILLER)
    {
    	this.zdbFillerHRowDiv = rowHeaderEl;
    	this.zdbFillerDRowDiv = rowDataEl;
    }
    if(rowType == ZDBConst.DUMMY)
    {
    	this.zdbDummyHRowDiv = rowHeaderEl;
    	this.zdbDummyDRowDiv = rowDataEl;
    }
    var chTable,dTable,rhTable,tcTable;

    dTable=this.dTable;
    rhTable=this.rhTable;
    tcTable=this.tcTable;
    chTable=this.chTable;

    if(this.zdbFillerHRowDiv && this.zdbFillerDRowDiv && (rowType != ZDBConst.FILLER) 
    		&& (rowType != ZDBConst.COLHEAD) && this.zdbFillerHRowDiv.parentElement && this.zdbFillerDRowDiv.parentElement)
    {
    	var pointerHRow = (insertBeforeDummy) ? this.zdbDummyHRowDiv : ((gridObj.scrollUp) ? rhTable.firstChild : this.zdbFillerHRowDiv);
    	var pointerDRow = (insertBeforeDummy) ? this.zdbDummyDRowDiv : ((gridObj.scrollUp) ? dTable.firstChild : this.zdbFillerDRowDiv);
    	rhTable.insertBefore(rowHeaderEl,pointerHRow);
    	dTable.insertBefore(rowDataEl,pointerDRow);
    }
    else if(rowType == ZDBConst.COLHEAD)
    {
    	tcTable.insertBefore(rowHeaderEl,this.tcAreaRowDiv);
    	chArea.insertBefore(rowDataEl,this.chTable);
    }
    else
    {
    	rhTable.appendChild(rowHeaderEl);
    	(rowType === ZDBConst.COLHEAD) ? chTable.appendChild(rowDataEl) : dTable.appendChild(rowDataEl);
    }
    if(this.selectionType === ZDBConst.COLHEAD)
    {
    	this.rightSelect.style.height = ZDBDataGrid.getDataHeight(this,this.rightSelect) - (BROWSER.IE ? 0 : ZDBUtil.getElementOuterHeight(this.rightSelect)) + "px"; 
    	this.leftSelect.style.height = ZDBDataGrid.getDataHeight(this,this.leftSelect) - (BROWSER.IE ? 0 : ZDBUtil.getElementOuterHeight(this.leftSelect)) + "px";
    }
    if(gridObj.scrollUp)
    {
    	this.adjustRowHeight(0);
    }
    else if(dTable.children[dTable.children.length-2] != null)
    {
    	this.adjustRowHeight(dTable.children.length-2);
    }
  }
  this.columnAlignment = function(rowObj)
  {
    if(rowObj.objType == ZDBConst.COLHEAD)
    {
      return;
    }
    var len = this.colHeaders.length;
    var cellObjs = rowObj.values;
    var cellLen = cellObjs.length;
    var colObj;    
    var alignment;
    for(var i = 0; i < cellLen; i++)
    {
      colObj = cellObjs[i].colObj;
      alignment = this.colHeaders[i].alignment;
      if(alignment)
      {
        cellObjs[i].cellEl.style.textAlign = alignment;
      }  
    }  
  }
  
  this.setScrollPosition = function(){}


}

ZDBDataGrid.setIndices = function(gridObj)
{
  var curMaxIndex = ZDBDialogUtil.zCounter + 1;
  gridObj.freezeIcon.style.zIndex = curMaxIndex;
}

ZDBDataGrid.setGlobals = function()
{
  //Assumption: called only once         
  ZDBGlobal.moveIndicator = ZDBUtil.addToNode("zdbMoveIndicator");
  ZDBGlobal.moveMsg = ZDBUtil.addToNode("zdbMoveMsg");
      
  ZDBGlobal.resizeDIV = ZDBUtil.addToNode("resizeDIV");

  ZDBGlobal.freezeIcon = ZDBUtil.getCloned("freezeIcon");
  ZDBGlobal.linkIcon = ZDBUtil.addToNode("linkIcon");
  ZDBGlobal.dataCell  = ZDBUtil.getCloned("zdbDataCell");
  ZDBUtil.removeNonElements(ZDBGlobal.dataCell);
  ZDBGlobal.cellDIV = ZDBUtil.getCloned("zdbCellDIV");
  ZDBGlobal.colHead = ZDBUtil.getCloned("zdbColHeadCell");
  ZDBGlobal.rowHead = ZDBUtil.getCloned("zdbRowHeadCell");
  ZDBUtil.removeNonElements(ZDBGlobal.rowHead);
  ZDBGlobal.rowHead.appendChild(document.createTextNode(" "));
      
  ZDBGlobal.fillerVCell = ZDBUtil.getCloned("zdbFillerVCell");
  ZDBGlobal.fillerHCell = ZDBUtil.getCloned("zdbFillerHCell");
  ZDBGlobal.fillerDCell = ZDBUtil.getCloned("zdbFillerDCell");
      
  ZDBGlobal.filterCell = ZDBUtil.getCloned("zdbFilterCell");
  ZDBUtil.removeNonElements(ZDBGlobal.filterCell);
  ZDBGlobal.filterOptionCell = ZDBUtil.getCloned("zdbFilterCell");
  ZDBUtil.removeNonElements(ZDBGlobal.filterOptionCell);
  ZDBGlobal.filterHead = ZDBUtil.getCloned("zdbFilterHeadCell");
  ZDBUtil.removeNonElements(ZDBGlobal.filterHead);
      
  ZDBGlobal.dummyCell = ZDBUtil.addToNode("zdbDummyCell");
  ZDBGlobal.dummyDIV = ZDBUtil.addToNode("zdbDummyDIV");

      
  ZDBGlobal.gridTmpHolder = document.getElementById("gridTmpHolder");
  ZDBUtil.addToNode('tabEdit');
  ZDBGlobal.isGlobalSet = true;    
}

ZDBDataGrid.prototype.reorderColumns = function(orderList, startIndex, endIndex)
{
  //PK: orderList:- columns ordered within startIndex and endIndex
  

  var dOrder = [];
  if(this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
	  {
  var cellOrderWidth=[];
  for(var i=0;i<orderList.length;i++)
  {
	  cellOrderWidth.push(this.widthArray[orderList[i][ZDBGlobal.columnPos]-1]);
  }
	  }
  if(this.reorderDisabled)
  {
    return;
  }
  
  ///PK: Apply lazy logic
  var ordLen = orderList.length;
  if(ordLen == 0)
  {
    return;
  }

  var values = [];
  var colHeads = this.allColHead;
  var colLen = colHeads.length;
  
  for(var i=0;i<colLen;++i)
  {
    
      if(colHeads[i].freeze)
      {
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.table.showinfo.js.reorderFreezeColErr"));
        return;
      }
      else if(i >= startIndex && i <= endIndex && colHeads[i][ZDBGlobal.columnGrouped])
      {
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.table.showinfo.js.reorderGrpColErr"));
        return; 
      }
    
  }
  
  for(var i=0; i<startIndex; i++)
  {
    dOrder.push(i);
  }
  
  for(var i = startIndex;i<=endIndex;i++)
  {
    dOrder.push(orderList[i-startIndex][ZDBGlobal.columnPos]);
    colHeads[i] = orderList[i-startIndex];
  }
  for(var i=endIndex+1; i<colLen; i++)
  {
    dOrder.push(colHeads[i][ZDBGlobal.columnPos]);
  }
  for(var i=startIndex;i<=endIndex;i++)
  {
    var prevHead = colHeads[endIndex];
    var curHead = colHeads[i];
    //this.chAreaRowDiv.insertBefore(curHead.cellEl,prevHead.cellEl);
    curHead[ZDBGlobal.columnPos] = i;
    dOrder.push(curHead[ZDBGlobal.columnPos]);
  }
  
  var rowData = this.rowData;
  var dataIndex = ZDBDataGrid.getFirstRowIndex(rowData, true); 
  rowData[dataIndex -1].values = colHeads;
//  this.colHeaders = rowData[dataIndex -1].values;
  var rowLen = rowData.length;
  var dataLen = colHeads.length;
  var dataCells;
  
//  for(var i=0;i<rowLen;++i)
//  {
//    if(rowData[i].values == this.colHeaders)
//    {
//      continue;
//    }
//    dataCells = rowData[i].values;
//    var newOrderedCells = [];
//    for(var j=0; j<colLen; j++)
//    {
//      newOrderedCells.push(dataCells[dOrder[j]]);
//    }
//    for(var k=startIndex;k<=endIndex;k++) //PK: startIndex to endIndex
//    {
//      var prevCell = newOrderedCells[endIndex];
//      var curCell = newOrderedCells[k];
//      rowData[i].rowDataEl.insertBefore(curCell.cellEl,prevCell.cellEl);
//    }
//    rowData[i].values = newOrderedCells;
//  }
  if(this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
	  {
  var dTableWidth=this.dTable.style.width;
  dTableWidth=parseInt(dTableWidth);
  //var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
  //var cssRule = styleSheet.innerHTML;
  for(var i=0;i<orderList.length;i++)
	  {
	  this.widthArray[orderList[i][ZDBGlobal.columnPos]-1]=cellOrderWidth[i];
	  //cssRule += "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell]:nth-child("+(orderList[i][ZDBGlobal.columnPos])+"),div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell]:nth-child("+(orderList[i][ZDBGlobal.columnPos])+"),div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]:nth-child("+(orderList[i][ZDBGlobal.columnPos])+"){width:"+(this.widthArray[orderList[i][ZDBGlobal.columnPos]-1]/dTableWidth)*100+"%;}";//NO I18N
	  }
   //styleSheet.innerHTML = cssRule;
	  }
  this.dataCache.colsReordered();
  this.sendAndUpdateClientState(true,'REORDERCOLUMN'); //NO I18N

}

ZDBDataGrid.prototype.reorderColumnsDash = function(orderList, startIndex, endIndex)
{
	  //PK: orderList:- columns ordered within startIndex and endIndex

	  var dOrder = [];
	  if(this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
		  {
	  var cellOrderWidth=[];
	  for(var i=0;i<orderList.length;i++)
	  {
		  cellOrderWidth.push(this.widthArray[orderList[i].cellPos-1]);
	  }
		  }
	  if(this.reorderDisabled)
	  {
	    return;
	  }
	  
	  ///PK: Apply lazy logic
	  var ordLen = orderList.length;
	  if(ordLen == 0)
	  {
	    return;
	  }

	  var values = [];
	  var colHeads = this.colHeaders;
	  var colLen = colHeads.length;
	  
	  for(var i=0;i<colLen;++i)
	  {
	    if(colHeads[i].objType == ZDBConst.COLHEAD)
	    {
	      if(colHeads[i].freeze)
	      {
	        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.table.showinfo.js.reorderFreezeColErr"));
	        return;
	      }
	      else if(i >= startIndex && i <= endIndex && colHeads[i].grouped)
	      {
	        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.table.showinfo.js.reorderGrpColErr"));
	        return; 
	      }
	    }
	  }
	  
	  for(var i=0; i<startIndex; i++)
	  {
	    dOrder.push(i);
	  }
	  
	  for(var i = startIndex;i<=endIndex;i++)
	  {
	    dOrder.push(orderList[i-startIndex].cellPos);
	    colHeads[i] = orderList[i-startIndex];
	  }
	  for(var i=endIndex+1; i<colLen; i++)
	  {
	    dOrder.push(colHeads[i].cellPos);
	  }
	  for(var i=startIndex;i<=endIndex;i++)
	  {
	    var prevHead = colHeads[endIndex];
	    var curHead = colHeads[i];
	    this.chAreaRowDiv.insertBefore(curHead.cellEl,prevHead.cellEl);
	    curHead.cellPos = i;
	    dOrder.push(curHead.cellPos);
	  }
	  
	  var rowData = this.rowData;
	  var dataIndex = ZDBDataGrid.getFirstRowIndex(rowData, true); 
	  rowData[dataIndex -1].values = colHeads;
	  this.colHeaders = rowData[dataIndex -1].values;
	  var rowLen = rowData.length;
	  var dataLen = colHeads.length;
	  var dataCells;
	  
	  for(var i=0;i<rowLen;++i)
	  {
	    if(rowData[i].values == this.colHeaders)
	    {
	      continue;
	    }
	    dataCells = rowData[i].values;
	    var newOrderedCells = [];
	    for(var j=0; j<colLen; j++)
	    {
	      newOrderedCells.push(dataCells[dOrder[j]]);
	    }
	    for(var k=startIndex;k<=endIndex;k++) //PK: startIndex to endIndex
	    {
	      var prevCell = newOrderedCells[endIndex];
	      var curCell = newOrderedCells[k];
	      rowData[i].rowDataEl.insertBefore(curCell.cellEl,prevCell.cellEl);
	    }
	    rowData[i].values = newOrderedCells;
	  }
	  if(this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
		  {
	  var dTableWidth=this.dTable.style.width;
	  dTableWidth=parseInt(dTableWidth);
	  var styleSheet = ZDBUtil.getStyleSheet(this.gArea, this.ID);
	  var cssRule = styleSheet.innerHTML;
	  for(var i=0;i<orderList.length;i++)
		  {
		  this.widthArray[orderList[i].cellPos-1]=cellOrderWidth[i];
		  cssRule += "div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=colheadcell]:nth-child("+(orderList[i].cellPos)+"),div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=datacell]:nth-child("+(orderList[i].cellPos)+"),div[gridid='"+this.ID+"'] div[elname=gRightArea] div[zdbname=filterCell]:nth-child("+(orderList[i].cellPos)+"){width:"+(this.widthArray[orderList[i].cellPos-1]/dTableWidth)*100+"%;}";//NO I18N
		  }
	   styleSheet.innerHTML = cssRule;
		  }
	  this.dataCache.colsReordered();
	  this.sendClientState(false,'REORDERCOLUMN'); //NO I18N

	}






ZDBDataGrid.prototype.adjustColumnWidth = function(resizeObj, adjustSize)
{
  var resizePos = resizeObj.cellPos;
  var rowData = this.rowData;
  var rowLen = rowData.length;
  var cellObjs;
  var cellLen;
  var curRow;
  var cellObj, colObj;
  var curResizeObj;

  resizeObj.width += adjustSize;
  for(var i=0;i<rowLen;++i)
  {
    curRow = rowData[i];
    cellObjs = curRow.values;
    cellLen = cellObjs.length;
    for(var j=0;j<cellLen;++j)
    {
      cellObj = cellObjs[j];
      colObj = cellObj.colObj;
      if((cellObj.startIndex < 0 && colObj == resizeObj) ||(cellObj.startIndex <= resizePos && cellObj.endIndex >= resizePos))
      {
        curResizeObj = cellObj;
        break;
      }
    }
    this.placeCellElement(curResizeObj,[false, false, false, true], [false, false, false, true]);
    if(resizeObj.freeze)
    {
      if(curRow.objType == ZDBConst.COLHEAD && !curRow.rowHeaderEl)
      {
        this.tcAreaRowDiv.style.width = ((parseInt(this.tcAreaRowDiv.style.width)) + adjustSize) + "px";
      }
      else
      {
        curRow.rowHeaderEl.style.width = ((parseInt(curRow.rowHeaderEl.style.width)) + adjustSize) + "px";
      }
    }
    else
    {
      if(curRow.objType == ZDBConst.COLHEAD && !curRow.rowDataEl)
      {
        this.chAreaRowDiv.style.width = ((parseInt(this.chAreaRowDiv.style.width)) + adjustSize) + "px";
      }
      else
      {
        curRow.rowDataEl.style.width = ((parseInt(curRow.rowDataEl.style.width)) + adjustSize) + "px";
      }
    }
  }
  ZDBDataGrid.setColHeadDisplayWidth(this, resizeObj);
}



ZDBDataGrid.prototype.resizeColumn = function(event, resizeObj)
{
  this.resizeColumnUI(event, resizeObj);
  this.saveResize(resizeObj);
  if(this.type != "PivotSheet" && this.type != "SummarySheet")  // temporary check for pivot and summary
	  {
  this.adjustInViewRowsHeight();
	  }
}


ZDBDataGrid.prototype.saveResize = function(resizeObj)
{
  if(resizeObj.objType == ZDBConst.COLHEAD && this.canSaveUIChanges())
  {
    var param = 'COLID=' + resizeObj.colId + '&WIDTH=' + Math.round(resizeObj.width * ZDBGlobal.defaultFontsize/this.getFontSize()) //NO I18N
    +"&" + this.getGridDetailsAsParams(); 
    AjaxAPI.sendRequest({URL: CommAPI.RESIZECOLURL,PARAMETERS: param});
  }
}

ZDBDataGrid.prototype.saveThemeDetails = function()
{
	if(this.canSaveUIChanges())
	{
		var param="";
		var differentProps = this.getModifiedThemeProps();
		if(differentProps)
		{
			if(this.themeProp.zr_theme_name)
			{
				param+="zr_theme_name=" + this.themeProp.zr_theme_name+"&"; //NO I18N
			}
			if(this.themeProp.zr_theme_color)
			{
				param+="zr_theme_color=" + this.themeProp.zr_theme_color+"&"; //NO I18N
			}
			if(this.themeProp.zr_theme_font_size)
			{
				param+="zr_theme_font_size=" + this.themeProp.zr_theme_font_size+"&"; //NO I18N
			}
			if(this.themeProp.zr_theme_row_spacing)
			{
				param+="zr_theme_row_spacing=" + this.themeProp.zr_theme_row_spacing+"&"; //NO I18N
			}
			if(this.themeProp.zr_theme_font_family)
			{
				param+="zr_theme_font_family=" + this.themeProp.zr_theme_font_family+"&"; //NO I18N
			}
			if(this.objId != null && this.objId > 0)
			{
				param += "&OBJID=" + this.objId; //No I18N
			} 
			AjaxAPI.sendRequest({URL: CommAPI.UPDATETHEMEDETAILS,PARAMETERS: param});
		}
		else
		{
			if(this.objId != null && this.objId > 0)
			{
				param += "&OBJID=" + this.objId; //No I18N
			    AjaxAPI.sendRequest({URL: CommAPI.DELETETHEMEDETAILS,PARAMETERS: param});
			}		
		}
	}
}

ZDBDataGrid.prototype.resizeColumnUI = function(event, resizeObj, widthChange)
{
	var colObj = ZDBGlobal.resizeDIV.cellObj;
	
  if(this.resizeDisabled)
  {
    return true;
  }
  widthChange = !widthChange ? parseInt(ZDBEvents.mouseUpPos.x - ZDBEvents.mouseDownPos.x) : widthChange;
  if(resizeObj.width + widthChange < 10)
  {
    widthChange = 10;
  }
  var isRhAreaResize=false;
  if(this.rhWidthArray != undefined)
	  {
  if(resizeObj.cellPos >= this.rhWidthArray.length)
  {
    widthChange=this.widthArray[resizeObj.cellPos-1-(this.rhWidthArray.length-1)]+=widthChange;
  }
  else 
	  {
	  var gRightWidth=this.gRightArea.style.width;
	  gRightWidth=parseInt(gRightWidth);
	  gRightWidth-=widthChange;
	  this.gRightArea.style.width=gRightWidth+this.getScrollThick()+'px';
	  widthChange=this.rhWidthArray[resizeObj.cellPos]+=widthChange;
	  isRhAreaResize=true;
	  }
	  }
  else
  { 
	  widthChange=this.widthArray[resizeObj.cellPos-1]+=widthChange;
  }
  resizeObj.width=widthChange;
    var setallColhead = function(elmt){
    if(elmt[ZDBGlobal.columnId] == resizeObj.colName){
      elmt[ZDBGlobal.columnWidth] = widthChange;
    }
  }
  if(this.allColHead){
  this.allColHead.forEach(setallColhead);
  }
  ZDBDataGrid.setColHeadDisplayWidth(this,resizeObj);
  if(isRhAreaResize)
	  {
  this.adjustDimension();
  if(this.freeze)
	  {
	  this.fArea1.style.width = this.chArea.style.width;
	  }
  if(this.type != "PivotSheet" &&  this.type != "SummarySheet")
	  {
  this.generateColumnWidth(this.widthArray);
	  }
  else
	  {
	  this.generatePivotColumnWidth(this.widthArray,true);
	  }
  this.generateLeftColumnWidth(this.rhWidthArray);
  if(this.type !=  "PivotSheet" && this.type != "SummarySheet")
	  {
  this.setFreezeIcon();
	  }
	  }
else if(!(colObj.endIndex>-1)) // if endindex > -1 it indicates that resize of 
	{                          // grouped headers in pivot. generation of styles is not necessary here
	if(this.type != "PivotSheet" && this.type != "SummarySheet")
		{
  this.generateColumnWidth(this.widthArray);
  this.generateLeftColumnWidth(this.rhWidthArray);
		}
	 else
	  {
	  this.generatePivotColumnWidth(this.widthArray,true);
	  this.generateLeftColumnWidth(this.rhWidthArray);
	  this.maintainGridHeadArrays(this.gridHeaderRows,true);
	  }  
  }
   if(this.gridSizeBasedOnData)
  {   
	 if(this.type != "PivotSheet" && this.type != "SummarySheet")
		 {
	  this.adjustInViewRowsHeight();
		 }
	 else if(!(colObj.endIndex>-1))
		 {
		 this.adjustInViewPivotRowsHeight();
		  this.adjustDimension();
		 }
	  this.adjustRowHeadAreaDimension();
	  this.adjustDataAreaDimension();
  }
else
	{
this.setFillerHeight();
	}
  if(this.type == "TableDesign")
	  {
  this.adjustDimension();
	  }

  this.selectColumn();
  if(this.isForImport)
	  {
	  this.finalAdjustments();
	  }
  var curFocusCell = ZDBDataGrid.getCurrentCell(this);
  if(this.type == "TableDesign" && curFocusCell)  //For edit design view, cell selection has to be changed acc to new column size
  {
	this.setCellFocus(curFocusCell,false);  
  }
  return;
}

ZDBDataGrid.prototype.resizeGridArea = function(resizeObj, widthChange)
{
    this.adjustColumnWidth(resizeObj,widthChange);
    //this.adjustRowHeightOnResize(resizeObj);
    this.adjustDimension();
    this.adjustColFill();
    this.selectedCols = [resizeObj];
    this.resizeFilterColumn(widthChange);
    this.setFreezeIcon();
}


ZDBDataGrid.prototype.adjustFillerSize = function(colObj)
{

  var rhTds = this.rhTbody.childNodes[0].childNodes;;
  var rhLen = rhTds.length;
  var rhFillerTds = this.rhFillerRow.childNodes;
  
  for(var i=1;i<rhLen;++i)
  {
    rhFillerTds[i].style.width = rhTds[i].style.width;
  }
  
  var dTds = this.dTbody.childNodes[0].childNodes;;
  var dLen = dTds.length;
  var dFillerTds = this.dFillerRow.childNodes;
  
  for(var i=0;i<dLen;++i)
  {
    dFillerTds[i].style.width = dTds[i].style.width;
  }
  
  return;
}

ZDBDataGrid.prototype.adjustRowHeadSize = function()
{
  var curLen = this.tcDummySpan.innerHTML.length;  
  if(this.recordEnd == null){return;}
  var reqLen = (this.recordEnd + "").length + 1;
  if(reqLen < 4)
  {
    reqLen = 4;
  }
  if(curLen != reqLen)
  {
    var str = Math.pow(10,reqLen -1) +"";
    this.tcDummySpan.innerHTML = str;
    this.adjustDimension();
  }  
}

ZDBDataGrid.prototype.setRefErrors = function(errRows)
{
  var innerHtml = "";
  var title = "";
  for(var i = 0;i < errRows.length;i++)
  {
    var fieldId = errRows[i][0];
    var colName = errRows[i][1];
    var text = "";
    if(title == "")
    {
      title = (colName[0] == "DATATYPE") ? ZDBI18NMap.g("zrpt.common.referr.errmsg.js.dataTypeChngDlgTtl"): //NO I18N
                                           (colName[0] == "REFERREDCOLUMN") ? ZDBI18NMap.g("zrpt.common.lookup.js.changetolookup") : //NO I18N
                                           ZDBI18NMap.g("zrpt.common.referr.errmsg.js.delColsDlgTtl");
    }
    if(colName[0] == "FIELDNAME")
    {
       var fieldName = ZDBEscapeUtil.encodeForHtml(this.getDispNameForId(fieldId));
       if(fieldName != "")
       {
         fieldName = "'" + fieldName + "'";
         text = "<br><b>"+ZDBI18NMap.f("zrpt.common.referr.errmsg.js.delColsDlgText",fieldName)+"</b></br>";
       }
       else
       {
         text = "<br><b>"+ZDBI18NMap.g("zrpt.common.referr.errmsg.js.delAggFormulaDlgText")+"</b></br>";
       }
    }
    else if(colName[0] == "DATATYPE")
    {
      text = "<br><b>"+ZDBI18NMap.f("zrpt.common.referr.errmsg.js.dataTypeChngDlgText",ZDBEscapeUtil.encodeForHtml(this.getDispNameForId(fieldId)))+"</b></br>";
    }
    else if(colName[0] == "REFERREDCOLUMN")
    {
      text = "<br><b>"+ZDBI18NMap.f("zrpt.common.referr.errmsg.js.chbglookupcol",ZDBEscapeUtil.encodeForHtml(this.getDispNameForId(fieldId)))+"</b></br>";
    }
    innerHtml = innerHtml + text + errRows[i][2];
  }
  ZDBUtil.showRefErr(innerHtml,title);
}

ZDBDataGrid.setTemplateLayout = function(gridObj)
{
  if(ZDBDataGrid.ZDBGRIDTPL==null)
  {
    ZDBDataGrid.ZDBGRIDTPL = $("ZDBGRIDTPL");    
    ZDBUtil.deepRemoveNonElements(ZDBDataGrid.ZDBGRIDTPL);    
    ZDBUtil.setNamedChildEls(ZDBDataGrid.ZDBGRIDTPL,ZDBDataGrid.ZDBGRIDTPL);
    ZDBUtil.removeNonElements(ZDBDataGrid.ZDBGRIDTPL.chArea);
    ZDBDataGrid.ZDBGRIDTPL.parentNode.removeChild(ZDBDataGrid.ZDBGRIDTPL);
  }
  var gridStruct = ZDBDataGrid.ZDBGRIDTPL.cloneNode(true);
  gridStruct.removeAttribute("id");
  gridStruct.setAttribute("GRIDID",gridObj.ID);
  ZDBUtil.setNamedChildEls(gridStruct,gridObj);
  gridObj.rightSelect.gridObj = gridObj;
  gridObj.leftSelect.gridObj = gridObj;
  gridObj.gArea = gridStruct;
  gridObj.viewComp = gridObj.gArea;//This is for the new view design.
  if(gridObj.navigComp && !ZDBGlobal.IS_MOBILE)
  {
	  gridObj.navigComp.parGrid = gridObj;
  }
}


ZDBDataGrid.prototype.setDataWidth = function(startIndex, endIndex)
{
  var rowData = this.rowData;
  var rowLen = rowData.length;
  var colHeaders = this.colHeaders;
  var colLen = colHeaders.length;
  
  if(startIndex < 0)
  {
    startIndex = 0;
  }
  
  if(endIndex === undefined || endIndex < 0)
  {
    endIndex = colLen;
  }
  var dataEl;
  var curHead;
  for(var i=startIndex;i<endIndex;++i)
  {
    curHead = colHeaders[i];
    for(var j=0;j<rowLen;++j)
    {
      dataEl = rowData[j].values[i].dataEl;
      dataEl.style.width = curHead[ZDBDataGrid.getPropertyID(curHead, rowData[j])] + "px";
    }  
    dataEl = this.fillerRow.values[i].dataEl;
    dataEl.style.width = curHead[ZDBDataGrid.getPropertyID(curHead, this.fillerRow)] + "px";
  }
  
}

ZDBDataGrid.prototype.setFirstRowWidth = function()
{
  if(this.rowData.length > 0)
  {
    this.setRowWidth(this.rowData[0], false);
  }
  else
  {
    this.setRowWidth(this.dummyRowObj, true);
  }
  
  
}


ZDBDataGrid.prototype.setRowWidth = function()
{
  return;
}


ZDBDataGrid.getVisibleColumn = function(colHeaders, startIndex, isNext, isIndex)
{
  var colLen = colHeaders.length;
  var curHead;
  for(var i=startIndex; isNext ? i < colLen : i >= 0; isNext ? ++i : --i)
  {
    curHead = colHeaders[i];
    if(curHead.objType == ZDBConst.COLHEAD && curHead.visible)
    {
      return (isIndex ? i : curHead);
    }
  }
  return isIndex ? -1 : null;
}


ZDBDataGrid.getLastVisibleColumn = function(colHeaders, startIndex, isIndex, isViewLast)
{
  var colLen = colHeaders.length;
  var curHead;
  for(var i=startIndex; i < colLen; --i)
  {
    curHead = colHeaders[i];
    if((isViewLast || curHead.objType == ZDBConst.COLHEAD) && curHead.visible)
    {
      return (isIndex ? i : curHead);
    }
  }
  return isIndex ? -1 : null;
}

ZDBDataGrid.getLastVisibleColumninColArr = function (colHeaders, startIndex, isIndex, isViewLast){
	var colLen = colHeaders.length;
	var curHead;
	for(var i=startIndex; i < colLen; --i){
		if(colHeaders[i][ZDBGlobal.columnVisible]){
			return colHeaders[i];
		}
		else{
			return null;
		}
	}
}


ZDBDataGrid.getFirstVisibleColumn = function(colHeaders, startIndex, isIndex, isViewLast)
{
  var colLen = colHeaders.length;
  var curHead;
  for(var i=startIndex; i < colLen; ++i)
  {
    curHead = colHeaders[i];
    if((isViewLast || curHead.objType == ZDBConst.COLHEAD) && curHead.visible)
    {
      return (isIndex ? i : curHead);
    }
  }
  return isIndex ? -1 : null;
}




ZDBDataGrid.getPreviousVisibleColumn = function(colHeaders, curIndex)
{
  var colLen = colHeaders.length;
  var curHead;
  if(curIndex >= colLen || curIndex < 0)
  {
    return null;
  }
  else
  {
    colHead = colHeaders[curIndex];
  }
  for(var i=curIndex-1;i>=0;--i)
  {
    curHead = colHeaders[i];
    if(colHead.freeze != curHead.freeze)
    {
      return null;
    }
    if(curHead.visible)
    {
      return curHead;
    }
  }
  return null;
}


ZDBDataGrid.prototype.getPivotIndex = function(colIndex, pivotRowIndex)
{
  var pivotRow = this.colData[pivotRowIndex];
  var pivotRowLen = pivotRow.length;
  var curHead;
  for(var i=0;i<pivotRowLen;++i)
  {
    curHead = pivotRow[i];
    if(curHead.startIndex <= colIndex && curHead.endIndex >= colIndex)
    {
      return i;
    }
  }
}


ZDBDataGrid.getDataHeight = function(gridObj,selectionDiv)
{
 if(gridObj==null){return 0;}
  if(selectionDiv!=null){
	  selectionDiv.style.height = "";  
  }
  var height = gridObj.dArea.scrollHeight;
  return height;
}


ZDBDataGrid.prototype.selectColumn = function()
{
  if(this.selectionDisabled || ZDBGlobal.IS_MOBILE || (this.type == 'TableDesign')) //No I18N
  {
    return;
  }
  this.hideSelection();
  this.removeCellFocus();
  
  var borderSize = 2;
  var selCols = this.selectedCols;
  var selLen = selCols.length;
  var rightSelect = this.rightSelect;
  var leftSelect = this.leftSelect;
  this.selectionType = ZDBConst.COLHEAD;
  
  var lLeft = -1, rLeft = -1, lWidth = 0, rWidth = 0;
  var newSelectedCols = new Array();
  for(var i=0;i<selLen;++i)
  {
    var curHead = selCols[i];
    curHead = (curHead.parentNode)?curHead:this.getColHeadFromId(curHead.colId);
    if(curHead==null){continue;}
    newSelectedCols.push(curHead);
    var colLeft = this.getCellElPosInGrid(curHead).cellLeft;
    if(curHead.selectDisabled)
    {
      ///PK: incorrect
      return;
    }
    curHead.selected = true;
    curHead.setClass();
    if(curHead.freeze)
    {
      if(lLeft == -1 || colLeft < lLeft)
      {
        lLeft = colLeft;
      }
      lWidth += curHead.width;
    }
    else
    {
      if(rLeft == -1  || colLeft < rLeft)
      {
        rLeft = colLeft;
      }
      rWidth += curHead.width;
    }
  }
  this.selectedCols = newSelectedCols;
  var rStyle = rightSelect.style;
  var lStyle = leftSelect.style;
  
  var height = ZDBDataGrid.getDataHeight(this,(lWidth)?leftSelect:rightSelect);
  
  if(lWidth)
  {
    if(rWidth)
    {
      leftSelect.className = "zdbSelect zdbSelectNoRight";
      lWidth -= borderSize;
    }
    else
    {
      leftSelect.className = "zdbSelect";
      lWidth -= 2 * borderSize;
    }
    lStyle.top = "0px";
    lStyle.left = lLeft + "px";
    lStyle.height = height - (borderSize * 2) + "px";
    lStyle.width =  lWidth + "px";
  }
  lStyle.display = lWidth ? "block" : "none";
  
  if(rWidth)
  {
    rightSelect.className = lWidth ? "zdbSelect zdbSelectNoLeft" : "zdbSelect";
    if(lWidth)
    {
      lWidth -= borderSize;
    }
    else
    {
      rWidth -= 2 * borderSize;
    }
    rStyle.top = "0px";
    rStyle.left = rLeft + "px";
    rStyle.height = height - (borderSize * 2) + "px";
    rStyle.width =  rWidth  + "px";
  }
  
  rStyle.display = rWidth ? "block" : "none";
  this.removeCellFocus();
  this.lastFocusPos = {row:-1, col:-1};
  this.rightSelect.selCols = this.selectedCols.slice();
}


ZDBDataGrid.prototype.hideSelection = function(removeCol, removeRow)
{
 var rightSelect = this.rightSelect;
 var selCols = rightSelect.selCols;
 if(selCols)
 {
   var selLen = selCols.length;
   for(var i=0;i<selLen;++i)
   {
    selCols[i].selected = false;
    selCols[i].setClass();
   } 
 }
 
 var selRows = rightSelect.selRows;
 if(selRows)
 {
   var selLen = selRows.length;
   for(var i=0;i<selLen;++i)
   {
    selRows[i].selected = false;
    selRows[i].setClass();
   } 
 }

 rightSelect.selCols = [];
 rightSelect.selRows = [];
 rightSelect.style.display = "none";
 this.leftSelect.style.display = "none";
 this.selectionType = ZDBConst.NONE;
 if(removeRow)
 {
  this.selectedRows = [];
 }
 
 if(removeCol)
 {
  this.selectedCols = [];
 }
}

ZDBDataGrid.prototype.selectRow = function()
{
  if(this.selectionDisabled || ZDBGlobal.IS_MOBILE)
  {
    return;
  }
  this.hideSelection();
  this.removeCellFocus();

  var borderSize = 2;
  var selRows = this.selectedRows;
  var selLen = selRows.length;
  if(selLen == 0)
  {
    this.rowFocus = false;
    this.rightSelect.style.display = "none";
    this.leftSelect.style.display = "none";
    return;
  }
  var height = 0;
  var top = (selLen > 0) ? this.getCellElPosInGrid(selRows[0].values[0]).cellTop : 0;
  for(var i=0;i<selLen;++i)
  {
    height += selRows[i].height;
    var cellPosObj = this.getCellElPosInGrid(selRows[i].values[0]);
    if(cellPosObj.cellTop < top)
    {
      top = cellPosObj.cellTop;
    }
    selRows[i].selected = true;
    selRows[i].setClass();
  }

  var rightSelect = this.rightSelect;
  var leftSelect = this.leftSelect;
  
  var colHeads = this.colHeaders;
  var colLen = colHeads.length;
  
  this.selectionType = ZDBConst.ROWHEAD;
  var lStyle = leftSelect.style;
  var rStyle = rightSelect.style;
  var lWidth = 0, rWidth = 0;
  var curHead;
  for(var i=1;i<colLen;++i)
  {
      curHead = colHeads[i];
      if(curHead.objType !== ZDBConst.COLHEAD)
      {
        break;
      }
      var curHeadCellPos = this.getCellElPosInGrid(curHead);
      if(curHead.freeze)
      {
        lWidth = (curHead.visible) ? (lWidth + curHead.width) : lWidth; 
      }
      else
      {
        rWidth = (curHead.visible) ? (curHeadCellPos.cellLeft + curHead.width) : rWidth;
      }
  }
  height -= 2 * borderSize;
  if(lWidth)
  {
    if(rWidth)
    {
      rWidth -= borderSize;
    }
    else
    {
      rWidth -= 2 * borderSize;
    }
    leftSelect.className = "zdbSelect zdbSelectNoRight";
    lStyle.top = top + "px";
    var visCol = ZDBDataGrid.getVisibleColumn(this.colHeaders, 0, true, false);
    lStyle.left = this.getCellElPosInGrid(visCol).cellLeft + "px";
    lStyle.height = height + "px";
    lStyle.width = lWidth + "px";
  }
  lStyle.display = lWidth ? "block" : "none";
  
  if(rWidth)
  {
    if(lWidth)
    {
      rWidth -= borderSize;
    }
    else
    {
      rWidth -= 2 * borderSize;
    }
    rightSelect.className = lWidth ? "zdbSelect zdbSelectNoLeft" : "zdbSelect";
    rStyle.top = top+ "px";
    rStyle.left = "0px";
    rStyle.height = height + "px";
    rStyle.width = rWidth + "px";
  }
  rStyle.display = rWidth ? "block" : "none";
  this.rightSelect.selRows = this.selectedRows.slice();
  this.onFocus(null, true);
  this.rowHeadFocus = true;
  this.lastFocusPos = {row:-1, col:-1}
}



ZDBDataGrid.prototype.onSelectClick = function(zdbEvent, isDouble)
{
  var mousePos = ZDBEvents.mouseDownPos;
  var cellObj = this.getCellAtPos(mousePos.x, mousePos.y);
  this.rowHeadFocus = (cellObj.colObj.objType === ZDBConst.ROWHEAD);
  this.setCellFocus(cellObj);
  this.hideSelection();
}


ZDBDataGrid.prototype.getCellAtPos = function(x, y)
{
	if(!this.position)
		{
			this.position = ZDBUtil.getObjCoordinates(this.parNode);
		}
  var top = y - this.position.y + this.dArea.scrollTop;
  var left = x - this.position.x + this.dArea.scrollLeft;
  var curTop = 0;
  var curLeft = 0;
  
  var rowData = this.rowData;
  var rowLen = rowData.length;
  var curRow, curObj;
  var rowIndex = 0;
  for(var i=0;i<rowLen;++i)
  {
    curRow = rowData[i];
    if(curTop <= top && (curTop + curRow.height) >= top) ///PK: won't work for Pivot head
    {
      rowIndex = i;
      break;
    }
    curTop += curRow.height;
  }
  curRow = rowData[rowIndex];
  var cellObjs = curRow.values;
  var colObj;
  var cellLen = cellObjs.length;
  var colIndex = 0;
  for(var i=0;i<cellLen;++i)
  {
    colObj = cellObjs[i].colObj;
    if(!colObj.visible)
    {
      continue;
    }
    if(curLeft <= left && (curLeft + colObj.width) >= left) ///PK: won't work for Pivot head
    {
      colIndex = i;
      break;
    }
    curLeft += colObj.width;
  }  
  return rowData[rowIndex].values[colIndex];
}


ZDBDataGrid.prototype.getCellHeadPos = function(cellObj)
{
  var cellElPos = this.getCellElPosInGrid(cellObj);
  var colObj = cellObj.colObj;
  var rowObj = cellObj.rowObj;
  var left, top;
  if(colObj.freeeze)
  {
    left =  cellElPos.cellLeft;
  } 
  else
  {
    left = this.tcWidth + cellElPos.cellLeft;
  }
  if(rowObj.objType === ZDBConst.COLHEAD)
  {
    top = cellElPos.cellTop;
  }
  else
  {
    top = this.tcHeight + cellElPos.cellTop;
  }
  return ({x:left,y:top});
}


ZDBDataGrid.calculateRowHeight = function(cellObj, cellWidth, colLen)
{
  var cellEl = cellObj.cellEl;
  if(!cellObj)
  {
    return ZDBGlobal.stdCellHeight;
  }
  if(!cellEl)
  {
    return ZDBGlobal.stdCellHeight;
  }
  if(!cellObj.colObj.visible)
  {
    return ZDBGlobal.stdCellHeight;
  }
  var rowObj = cellObj.rowObj;
  var gridObj = rowObj.parGrid;
  var heightDIV = ZDBGlobal.heightDIV;
  if(!heightDIV)
  {
    heightDIV = $('zdbHeightDiv');
    ZDBGlobal.heightDIV = heightDIV;
  }

  if(!cellEl.parentNode)
  {
    if(gridObj.type === "VUDSheet" || 
      gridObj.type === "Table" || 
      gridObj.type === "Report"){}else{ 
    //temporary hack for perf improvement. Need to rework the model #TOBEREMOVED
    var rhArea = gridObj.rhArea;
    var dArea = gridObj.dArea;
    var tcArea = gridObj.tcArea;
    var chArea = gridObj.chArea;
    var isFreeze = cellObj.colObj.freeze;
    var rowType = rowObj.objType; 

      (rowType === ZDBConst.COLHEAD ? isFreeze ? tcArea : chArea : isFreeze ? rhArea : dArea).appendChild(cellEl);
    }
  }

  if(heightDIV.parentNode != gridObj.rwGrid.dArea)
  {
    gridObj.rwGrid.dArea.appendChild(heightDIV);
  }
  ZDBDataGrid.checkWrapColHead(gridObj, cellEl, heightDIV, rowObj.objType == ZDBConst.COLHEAD);
  heightDIV.className = (gridObj.type == "TableDesign") ? 
		  (cellEl.className + " zdbEditGridHeightDiv") : (cellEl.className + " zdbHeightDiv");	//No I18N
  heightDIV.style.width = (cellWidth ? cellWidth : gridObj.getSize(cellEl, cellObj.colObj.width, true)) + "px";
  heightDIV.innerHTML = cellEl.innerHTML;
  heightDIV.style.lineHeight = "";
  
  var height = (ZDBUtil.getStyleNumeric(heightDIV, 'height') + ZDBUtil.getElementOuterSize(heightDIV, false));//No I18N
  var height = heightDIV.offsetHeight;
  
  if(gridObj.type == "TableDesign" && ((height - 2) > ZDBGlobal.stdEditGridCellHeight) &&
	  (cellObj.colObj.colName == "FORMULACOLUMN" || cellObj.colObj.colName == "DESCRIPTION"))	//No I18N
  {
	heightDIV.style.lineHeight = "16px";
	cellEl.style.lineHeight = "16px";
	height = heightDIV.offsetHeight;
	return height;
  }
  else if(gridObj.type == "TableDesign" && ((height - 2) <= ZDBGlobal.stdEditGridCellHeight))
  {
	heightDIV.style.lineHeight = "";
	return ZDBGlobal.stdEditGridCellHeight;
  }
  else if(height <= ZDBGlobal.stdCellHeight)
  {
    return ZDBGlobal.stdCellHeight;
  }
  else
  {
    return height;
  }
}


ZDBDataGrid.calculateColWidth = function(colObj, gridObj)
{
  ///PK: Same as calculateRowHeight? Why two methods?
  if(!colObj)
  {
    return ZDBGlobal.stdCellWidth;
  }
  if(gridObj && gridObj.defColWidth > 0)
  {
      return gridObj.defColWidth;
  }
  var displayValue = colObj.getDispNameForHtml();
  if((displayValue + "" ).length < 15)
  {
    return ZDBGlobal.stdCellWidth;
  }
  if(gridObj && gridObj.type != "PivotSheet" && gridObj.type != "SummarySheet")
  {//other than pivot and summary, other grids will be having default width as 150
    return ZDBGlobal.stdCellWidth;
  }
  var cellEl = colObj.cellEl;
  var gridObj = colObj.parGrid;
  var extraWidth = ZDBDataGrid.getColHeadNonTextWidth(gridObj);  
  var widthDIV = ZDBGlobal.widthDIV;
  if(!widthDIV)
  {
	  widthDIV = $('zdbWidthDiv');
	  ZDBGlobal.widthDIV = widthDIV;
  }


  if(widthDIV.parentNode != gridObj.rwGrid.dArea)
  {
	  gridObj.rwGrid.dArea.appendChild(widthDIV);
  }
  ZDBDataGrid.checkWrapColHead(gridObj, cellEl, widthDIV, colObj.rowObj.objType == ZDBConst.COLHEAD);
  widthDIV.className = cellEl.className + " zdbWidthDIV";
  widthDIV.innerHTML = ZDBEscapeUtil.encodeForHtml(displayValue); //PK: colObj is a ZDBColHeader

//var width = BROWSER.IE ? widthDIV.offsetWidth : (ZDBUtil.getStyleNumeric(widthDIV, 'width') + ZDBUtil.getElementOuterSize(widthDIV, true));
  var width = widthDIV.offsetWidth;
  width += extraWidth;
  if(width < ZDBGlobal.stdCellWidth)
  {
	  return ZDBGlobal.stdCellWidth;
  }
  else
  {
	  return width;
  }
}

ZDBDataGrid.checkWrapColHead = function(gridObj, cellEl, sizeDiv, isColHead)
{
	if(isColHead && gridObj.view && gridObj.view.chartProp && gridObj.view.chartProp.zr_wrap_colHead)
	{
		jQuery(cellEl).find(".zdbColHeadDisplay").css({"whiteSpace":"normal"});	//NO I18N
		sizeDiv.style.whiteSpace = "normal";	//NO I18N
	}
	else if(isColHead)
	{
		jQuery(cellEl).find(".zdbColHeadDisplay").css({"whiteSpace":"nowrap"});	//NO I18N
		sizeDiv.style.whiteSpace = "nowrap";	//NO I18N
	}
	else
	{
		sizeDiv.style.whiteSpace = "";
	}
}

ZDBDataGrid.prototype.adjustRowHeightBasedOnCell = function(cellObj)
{
  var rowObj = cellObj.rowObj;
  var curHeight = ZDBDataGrid.calculateRowHeight(cellObj);
  if(curHeight <= rowObj.height && rowObj.heightObj != cellObj)
  {
    return;
  }
  rowObj.height = curHeight;
  this.adjustRowFill();
}


ZDBDataGrid.prototype.adjustRowHeightOnResize = function(resizeHead)
{
  var rowData = this.rowData;
  var rowLen = rowData.length;
  var curRow;
  var startIndex = -1;
  var endIndex = rowLen-1;
  var curCellObj;
  var resizePos = resizeHead.cellPos;        
  for(var i=0;i<rowLen;++i)
  {
    curRow = rowData[i];
    var cellObjs = curRow.values;
    curCellObj = cellObjs[resizePos]; ///PK: getCellAt     
    
    if(curRow.objType == ZDBConst.COLHEAD)
    {
    	if(this.view && this.view.chartProp && !this.view.chartProp.zr_wrap_colHead)
    	{
    		continue;
    	}
	  for(var k=0; k<cellObjs.length; k++)
	  {
	    if(!(cellObjs[k] instanceof ZDBCell))
	    {
	      break;
	    }
	    if(cellObjs[k].endIndex > -1 && cellObjs[k].startIndex<=resizePos && cellObjs[k].endIndex>=resizePos)
	    {
	      curCellObj = cellObjs[k];
	      break;
	    }
	  }
    }  
    
    var w = this.calcPivotHeaderWidth(curRow, curCellObj);
    
    var curHeight = ZDBDataGrid.calculateRowHeight(curCellObj, w);
    if(curHeight <= curRow.height && curRow.heightObj != curCellObj)
    {
      continue;
    }
    if(startIndex < 0)
    {
      startIndex = i;
    }
    curRow.height = curHeight;
    curRow.heightObj = curCellObj;
    for(var j = 0; j < cellObjs.length; j++)
    {
    	var cellObj = cellObjs[j];
    	var cellPivotHeaderWidth = this.calcPivotHeaderWidth(curRow, cellObj);
    	var cellObjHeight = ZDBDataGrid.calculateRowHeight(cellObj, cellPivotHeaderWidth);
    	if(cellObjHeight > curHeight)
  		{
      		curHeight = cellObjHeight;
      		curRow.height = curHeight;
      		curRow.heightObj = cellObj;
      		j = -1;
      		continue;
  		}
    	cellObj.height = curHeight;
    	this.placeCellElement(cellObj,[false,false,true,false],[false,false,true,false]);
      	
    }
    if(curRow.rowDataEl)
    {
    	curRow.rowDataEl.style.height = curHeight + "px";
        curRow.rowHeaderEl.style.height = curHeight + "px";
    }
  }
  if(startIndex >= 0)
  {
    this.adjustRowFill();
  }
}

ZDBDataGrid.prototype.calcPivotHeaderWidth = function(curRow, curCellObj)
{
	var w=0;
	if(curRow.objType == ZDBConst.COLHEAD && curCellObj.startIndex > -1)
    {
    	for(var j=curCellObj.startIndex; j<=curCellObj.endIndex; j++)
        {
          w+= this.getSize(curCellObj.colObj.parGrid.colHeaders[j].cellEl, curCellObj.colObj.parGrid.colHeaders[j].width, false);
        }
    }
	w = w>0 ? w : false;
	return w;
}


ZDBDataGrid.getColHeadNonTextWidth = function(gridObj)
{
  //PK: Consider as a grid property or consider as colhead property?
  var nonTextWidth = 0;
  if(gridObj.showDatatype) //PK: find someother way to do it.
  {
    nonTextWidth += 16;
  }
  if(gridObj.showCheck)
  {
    nonTextWidth += 20;
  }
  if(gridObj.showIcon)
  {
    nonTextWidth += 20;
  }
  if(gridObj.showRenameIcon)
  {
      nonTextWidth +=20;
  }
  return nonTextWidth+4;  //+4 is to adjust issues in colHeadDisplay particularly in currency type colHeaders
}

ZDBDataGrid.setColHeadDisplayWidth = function(gridObj, colHead)
{
    var disWidth = colHead.width;

    if(colHead.objType == ZDBConst.COLHEAD)
    {
     disWidth -= ZDBDataGrid.getColHeadNonTextWidth(gridObj);
    } 
    if(disWidth < 0)
    {
      disWidth = 0;
    }
    colHead.displayNode.style.width = (disWidth/colHead.width)*100 + '%';
}

ZDBDataGrid.setColHeadDisplayHeight = function(colHead, baseRow)
{
	var height = baseRow.height, heightObj = baseRow.heightObj;
    var curHeight = ZDBDataGrid.calculateRowHeight(colHead);
    
	if(curHeight > height)
	{
	  height = curHeight;
	  heightObj = colHead; 
	}
    if(baseRow.heightObj)
    {
      curHeight = ZDBDataGrid.calculateRowHeight(baseRow.heightObj);
      if(curHeight > height)
      {
        height = curHeight;
        heightObj = baseRow.heightObj; 
      }
    }
    baseRow.heightObj = heightObj;
    baseRow.height = height;
}


ZDBDataGrid.getFirstRowIndex = function(rowData, includeDummy)
{
  return ZDBDataGrid.getRow(rowData, true, true, includeDummy);
}

ZDBDataGrid.getLastRowIndex = function(rowData, includeDummy)
{
  return ZDBDataGrid.getRow(rowData, false, true, includeDummy);
}

ZDBDataGrid.getFirstRowObj = function(rowData, includeDummy)
{
  return ZDBDataGrid.getRow(rowData, true, false, includeDummy);
}

ZDBDataGrid.getLastRowObj = function(rowData, includeDummy)
{
  return ZDBDataGrid.getRow(rowData, false, false, includeDummy);
}



ZDBDataGrid.getRow = function(rowData, isFirst, isIndex, onlyData)
{
  var rowLen = rowData.length;
  var i = 0;
  var end = rowLen;
  var incr = 1;

  if(!isFirst)
  {
    i = rowLen -1;
    end = -1;
    incr = -1;
  }
  var curRow;
  for(;isFirst ? i<end : i >end;i+= incr)
  {
    curRow = rowData[i];
    switch(curRow.objType)
    {
      case ZDBConst.COLHEAD:
      case ZDBConst.FILLER:
      /*PK:Must update if you add new non-data type*/
      continue;
    }
    if(curRow.status == ZDBConst.DELETED)
    {
      continue;
    }
    if(!onlyData && ZDBConst.DUMMY == curRow.objType)
    {
      continue;
    }
    return isIndex ? i : curRow;
  }
  return isIndex ? -1 : null;
}


ZDBDataGrid.reorderDragAndDrop = function(moveObj, targetObj)
{  
    var gridObj = moveObj.parGrid;
    if(!gridObj.visibleColsAlone){
    	ZDBDataGrid.reorderDragAndDropDash(moveObj, targetObj);
    	return
    }
    if(ZDBUtil.isViewModified(gridObj)){
      ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.analysis.js.altering"));
      return;
      }
    if(gridObj.freeze)
    {
        ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.common.zdbalertmsg.js.colReorderWithFrozenColErr'));
        return false;
    }
    var moveObjColId = moveObj.colName;
    var targetObjColId = targetObj.colName
    var moveColArr, targetObjColArr;
    
    for(var i=0;i<gridObj.allColHead.length;i++){	
    	if(gridObj.allColHead[i][ZDBGlobal.columnId] == moveObjColId){
    		moveColArr = gridObj.allColHead[i];
    	 }
    	else if(gridObj.allColHead[i][ZDBGlobal.columnId] == targetObjColId){
    		targetObjColArr = gridObj.allColHead[i];
    	}
    	else if(moveColArr && targetObjColArr){
    		break;
    	}
    	else{
    		continue;
    	}
    }
    
    gridObj.addSelectedCol(moveObj);
    gridObj.selectedAllCols = [];
    for(var i=0;i<gridObj.selectedCols.length;i++){
    	for(var k=0;k<gridObj.allColHead.length;k++){
    		if(gridObj.allColHead[k][ZDBGlobal.columnId] == gridObj.selectedCols[i].colName){
    			gridObj.selectedAllCols.push(gridObj.allColHead[k]);
    		}
    	}
    }
    
    var colHeaders = gridObj.allColHead;
    var colLen = colHeaders.length;
    var orderList = [];
    var selCols = gridObj.selectedAllCols;
    var selLen = selCols.length;
    var min = colLen, max = -1;
    var curObj;
//    if(targetObj.objType !== ZDBConst.COLHEAD)
//    {
//    	targetObjColArr = ZDBDataGrid.getLastVisibleColumninColArr(colHeaders, targetObjColArr[ZDBGlobal.columnPos]-1, false, true);
//      if(!targetObjColArr)
//      {
//        return;
//      }
//    }
    if(targetObjColArr == moveColArr)
    {
      return;
    }
    for(var i=0;i<selLen;++i)
    {
      curObj = selCols[i];
      if(curObj[ZDBGlobal.columnPos] < min)
      {
        min = curObj[ZDBGlobal.columnPos];
      }
      if(curObj[ZDBGlobal.columnPos] > max)
      {
        max = curObj[ZDBGlobal.columnPos];
      }
      orderList.push(curObj);
    }
    var isLeft = targetObjColArr[ZDBGlobal.columnPos] < moveColArr[ZDBGlobal.columnPos]; 

    if(isLeft)
    {
      orderList.push(targetObjColArr);
      for(i=targetObjColArr[ZDBGlobal.columnPos]+1;i<min;++i)
      {
        orderList.push(colHeaders[i]);
      }
    }
    else
    {
      orderList.unshift(targetObjColArr);
      for(i=targetObjColArr[ZDBGlobal.columnPos]-1;i>max;--i)
      {
        orderList.unshift(colHeaders[i]);
      }
    }
    
    selLen = selCols.length;
    var startIndex = isLeft ? targetObjColArr[ZDBGlobal.columnPos] : min;
    var endIndex = isLeft ? max : targetObjColArr[ZDBGlobal.columnPos];
    if(startIndex > endIndex)
    {
      var temp = startIndex;
      startIndex = endIndex;
      endIndex = temp;
    }
    
    gridObj.reorderColumns(orderList, startIndex, endIndex);
    gridObj.selectColumn();
}

ZDBDataGrid.reorderDragAndDropDash = function(moveObj, targetObj){
	var gridObj = moveObj.parGrid;
    gridObj.addSelectedCol(moveObj);
    var colHeaders = gridObj.colHeaders;
    var colLen = colHeaders.length;
    var orderList = [];
    var selCols = gridObj.selectedCols;
    var selLen = selCols.length;
    var min = colLen, max = -1;
    var curObj;
    if(targetObj.objType !== ZDBConst.COLHEAD)
    {
      targetObj = ZDBDataGrid.getLastVisibleColumn(colHeaders, targetObj.cellPos-1, false, true);
      if(!targetObj)
      {
        return;
      }
    }
    if(targetObj == moveObj)
    {
      return;
    }
    for(var i=0;i<selLen;++i)
    {
      curObj = selCols[i];
      if(curObj.cellPos < min)
      {
        min = curObj.cellPos;
      }
      if(curObj.cellPos > max)
      {
        max = curObj.cellPos;
      }
      orderList.push(curObj);
    }
    var isLeft = targetObj.cellPos < moveObj.cellPos; 

    if(isLeft)
    {
      orderList.push(targetObj);
      for(i=targetObj.cellPos+1;i<min;++i)
      {
        orderList.push(colHeaders[i]);
      }
    }
    else
    {
      orderList.unshift(targetObj);
      for(i=targetObj.cellPos-1;i>max;--i)
      {
        orderList.unshift(colHeaders[i]);
      }
    }
    
    selLen = selCols.length;
    var startIndex = isLeft ? targetObj.cellPos : min;
    var endIndex = isLeft ? max : targetObj.cellPos;
    if(startIndex > endIndex)
    {
      var temp = startIndex;
      startIndex = endIndex;
      endIndex = temp;
    }
    
    gridObj.reorderColumnsDash(orderList, startIndex, endIndex);
}


ZDBDataGrid.setUnfreezeInfo = function(freezeIcon)
{
  freezeIcon.setAttribute("alt","Fixed column");
  freezeIcon.setAttribute("title","Fixed column");
  freezeIcon.onmousemove = null;
  freezeIcon.onmouseout = null;
  freezeIcon.onclick = null;
  freezeIcon.style.cursor = "default";
}


ZDBDataGrid.setKeyHandlerFocus = function(gridObj, timeOut)
{
	//keypad pop-ups in Android tablet, added !ZDBGlobal.IS_MOBILE
	//since there is no need to focus the cellObj 
	//no need for key handlers like up, down arrows
	//Moreover, for Dashboard tables and Tables in Standalone mode, keyhandlers were not handled
  if(!ZDBGlobal.IS_MOBILE && (gridObj.keyFocusRequired == true || !ZDBClientUI.standAlone) && (gridObj.viewCtx!=null && gridObj.viewCtx.dashView==null) && (!gridObj.viewCtx.isZia))
  {
    ZDBUtil.setTimeout(ZDBUtil.setFocus, null, [gridObj.keyHandler], timeOut);
  }
}
ZDBDataGrid.setRowCountNavig = function(el,event)
{ 
   el.innerHTML = "";
   var srcEl = ZDBUtil.getSourceElement(event);    
   var gridObj = ZDBClientUI.selectedTab.view;
   if(gridObj.type == "Dashboard")
   {
      var dashBoardDiv =  DOMUtils.getParentWithAttr(el,"isDashBoardDiv");  //No I18N
      gridObj = (dashBoardDiv == null) ? ZDBUtil.getPropertyFromEl(srcEl, 'gridObj','object') : dashBoardDiv.dlgBody.view;
   }
   if(gridObj.type == "AnalysisView" || gridObj.type == "Pivot" || gridObj.type == "SummaryView")
   {
       gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
   }  
   var params = "&ZDBACTION=FETCHROWCOUNT" + gridObj.getCompleteGridDetailsAsParams(); //No I18N   
   if(gridObj.type == "VUDSheet")
   {       
       params += "&ISFILTERAPPLIED=true" + ZDBVUDataAPI.getConfigXmlAsParam(gridObj,"VUDSheet"); //No I18N   
   }
   else
   {
       params += (gridObj.isFilterApplied) ? "&ISFILTERAPPLIED=true" : "&ISFILTERAPPLIED=false"; //No I18N              
   }   
   ZDBDataGrid.sendRequestForRowCount("/ZDBDatabaseActionMI.ma?",params,gridObj,srcEl);  //No I18N
}
ZDBDataGrid.sendRequestForRowCount = function(url,params,gridObj,srcEl)
{   
	var loadingDiv = gridObj.totalRecordsDiv;
    AjaxAPI.sendRequest({URL:url,
                             PARAMETERS:params,
                             ONSUCCESSFUNC:ZDBDataGrid.setRowCountInfo,                             
                             GRIDOBJ:gridObj,OPSTATUSID:loadingDiv});     
}
ZDBDataGrid.setRowCountInfo = function(response,requestOptions)
{
    var dg = requestOptions["GRIDOBJ"];
    dg.setRowCountDiv(parseInt(response.responseText));
}

