//$Id: $
/**
 *@class
 * Each data cell.
 * @constructor
 */


///PK: type == " ... " must be analysed



ZDBConst.DISLEN = 15;

function ZDBCell(rowObj, colObj,value,displayValue,mainClass,groupStatus,isHtml,groupCount, hiddenDispValue,bgCol,fontCol) ///PK Object type and add TEXT or DIV
{    
  ///PK: get grouped args
  if(displayValue)
  {
    if((""+displayValue).indexOf("&nbsp;") >= 0)
    {
      //PK: Hack, to be fixed later
      displayValue = (displayValue+"").replace(/&nbsp;/g, " ");
    }
    if((""+displayValue).indexOf("\n") >= 0)
    {
      //PK: Hack, to be fixed later
      displayValue = (displayValue+"").replace(/\n/g, "<br />");
    }
  }

  this.colObj = colObj;
  this.rowObj = rowObj;
  this.modifiedValue = null;
  this.displayNode = null;
  this.cellEl = null;
  this.errorMsg = null;
  this.className =(mainClass)? mainClass:"zdbDataCell";
  this.isHtml = (isHtml == null)? colObj && colObj.typeObj.isHtml:isHtml;
  this.startIndex = -1;
  this.endIndex = -1;
  if(rowObj.objType == ZDBConst.FILLER)
  {
    return;
  }
  this.reset(value, displayValue);
  this.groupStatus = (groupCount === undefined) ? ZDBConst.GROUPNONE : (groupStatus == null)? ZDBConst.GROUPMIDDLE:groupStatus;//BAD integrating groupStatus at this level!!
  this.groupCount = groupCount;
  this.hiddenDispValue = hiddenDispValue ? hiddenDispValue : "";
//  this.hiddenDispValue = mainClass;
  this.editBackup = null;
  this.editDisabled = false;
  var disLen = this.displayValue.length;
  if(rowObj.txtLength < disLen && disLen > ZDBConst.DISLEN)
  {
    rowObj.heightObj = this;
    rowObj.txtLength = disLen;
  }
  if(colObj.type == 'MULTI_LINE')
  {
    rowObj.multiLine.push(this);
  }
  this.bgCol = bgCol;
  this.fontCol = fontCol;
}

ZDBCell.isList = function(cellObj)
{
  var colObj = cellObj.colObj;

  if(colObj.typeObj && colObj.typeObj.editorType == 'list')
  {
    return true;
  }
  return false;
}

ZDBCell.prototype.setValue = function(newValue,displayValue, setOnElementAlso, fullValidate, clearError)
{
  ///PK: only on data modification
  var colObj;
  colObj = this.colObj;
  if(colObj.type == 'REFCOL')
  {
    if(colObj.refData !== undefined) //PK: To Do: Handle like usual type, colLevel validation???
    {
      var temp = displayValue;
      displayValue = newValue;
      var index = ZDBUtil.indexOf(colObj.refData, ZDBEscapeUtil.decodeForHtml(newValue), null, true);
      if(index > -1)
      {
        newValue = colObj.pkData[index];
      }
      else
      {
        newValue = ""; ///PK: Handle
      }
    }
  }
  
  if(!(clearError == false))
  {
    this.clearError(true, true, true);
  }  
  var needNoSave =  (this.originalValue == null && newValue === '' && displayValue != ZDBConst.NEEDSAVE);
  var dtNtChanged = this.originalValue == newValue;
  var GeOptCell = this.rowObj.values[this.rowObj.parGrid.getColumnIndex("GEOOPT")];
  dtNtChanged =  (dtNtChanged && (newValue == ZDBConst.GEO || newValue == ZDBConst.GEO_NUM ) && GeOptCell) ?GeOptCell.oldgeoRole==this.georole: dtNtChanged;   // for grid edit design
  if(newValue == null ||(!this.isModified() && (dtNtChanged || needNoSave)))
  {
    return;
  }

  this.modifiedValue = newValue;
  var deciSepSymbol = ZDBConst.DECISEPSYMBOL[this.colObj.decimalSeparator];
  if(!this.colObj.userLocale && (deciSepSymbol != ZDBConst.DEFAULT_DECISEPSYMBOL))
  {
    this.modifiedValue = ZDBFunctions.replace(this.modifiedValue,deciSepSymbol,ZDBConst.DEFAULT_DECISEPSYMBOL);
  }
  this.rowObj.setModified();
  if(fullValidate)
  {
    this.completeValidate();
    if(!this.isError())
    {
     this.rowObj.parGrid.invokeDerivedFunction(this.rowObj);
    }
  }
  else
  {
    this.validate();
  }

  if(!this.isError())
  {
    this.modifiedValue = this.getConvertedValue();

  }

  if(displayValue != null)
  {
    this.displayValue = displayValue;
  }
  else
  {
    this.displayValue = this.calculateDispVal();
  }
  if(setOnElementAlso)
  {
    this.setOnDataEl(this.displayValue,this.isError());
  }
  if(fullValidate) { ZDBMsgBox.showErrorIfNeeded(this); }
}

ZDBCell.prototype.isRolesame = function(src)
{
    var origRole = src.origGeorole;
    var selGeorole = src[src.selectedIndex].getAttribute("georole");
    return origRole == selGeorole;
}
ZDBCell.prototype.completeValidate = function()
{
  if(!this.validate()) { return false; }
  var validFunc = this.rowObj.parGrid.validateRowFunc;
  if((validFunc != null) && (!validFunc(this.rowObj))){ return false;}
  var validFunc = this.colObj.validateColFunc;
  if((validFunc != null) && (!validFunc(this.colObj))){ return false;}
  return true;
}

ZDBCell.prototype.validate = function()
{
    if(this.rowObj.objType != ZDBConst.DATA)
    {
        return true;
    }
    var cHead = this.colObj
    var typeObj = cHead.typeObj;
    if(typeObj && typeObj.dataValFn) /// Wrong! Should use ValFn!
    {
        typeObj.dataValFn(this);
    }

    if(!cHead.isNullable && this.getValue('validate') === '') //colLevel?
    {
      if(this.rowObj.rid)
      {
        this.setValidatedInfo(cHead.displayName + " "+ZDBI18NMap.f("zrpt.common.tbleditdesign.showinfo.js.emptyColNameErr",(this.rowObj.rid)), "COL"); //No I18N
      }
      else
      {
        this.setValidatedInfo(ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.ColNameEmptyErr"), "COL"); //No I18N
      }
    }

  return !this.isError();
}


ZDBCell.prototype.setValidatedInfo = function(errorMsg, errorLevel)
{
    switch(errorLevel.toUpperCase())
    {
        case "CELL":
        {
            this.cellLevel = true;
            break;
        }
        case "COL":
        {
            this.colLevel = true;
            break;
        }
        case "ROW":
        {
            this.rowLevel = true;
            break;
        }
    }
    this.errorMsg = errorMsg;
    if(this.cellEl != null)
    {
      if(errorMsg != null)
      {
            this.cellEl.setAttribute("title",errorMsg.replace("<br>","\n").replace("<BR>","\n")); //PK: Hack
      }
      else
      {
            this.cellEl.removeAttribute("title");
      }
    }
    this.setClass(); //PK: Too many calls?
}

ZDBCell.prototype.isError = function()
{
    return (this.cellLevel || this.rowLevel || this.colLevel);
}

ZDBCell.prototype.clearError = function(cell, row, col)
{
    if(cell)
    {
        this.cellLevel = false;
    }
    if(row)
    {
        this.rowLevel = false;
    }
    if(col)
    {
        this.colLevel = false;
    }
    if(cell && row && col)
    {
        this.errorMsg = "";
    }
    this.setClass();
}


ZDBCell.prototype.setClass = function(appendClass)
{
  var rowObj = this.rowObj;
  var colObj = this.colObj;
  var newClass = this.className;
  var cellEl = this.cellEl;
  if(!cellEl)
  {
    return; ///PK: ?
  }

  var curClass = cellEl.className;


  if(colObj.objType == ZDBConst.ROWHEAD)
  {
    if(this.selected || colObj.selected || rowObj.selected)
    {
      newClass = newClass + " zdbRowHeadFocus";
    }
    if(curClass != newClass)
    {
      cellEl.className = newClass;
    }
    return;
  }

  if(this.isError() || this.refErrorMsg)
  {
    newClass += " zdbDataCellError";
  }

  if(appendClass)
  {
      newClass += " " + appendClass;
  }
  if(curClass != newClass)
  {
   cellEl.className = newClass;
  }
}

ZDBCell.prototype.getValue = function(forWhat)
{
  forWhat = forWhat ? forWhat.toLowerCase() : "default";
  if(forWhat == 'validate')
  {
    if(this.isModified())
    {
        return this.modifiedValue;
    }
    else
    {
     return (this.originalValue ? this.originalValue : '');
    }
  }
  else if(forWhat == 'edit')
  {
    if(this.isError() && this.isModified())
    {
        return this.modifiedValue;
    }
    else if(this.colObj.type == 'REFCOL') ///PK: has to be fixed as in API
    {
      return this.displayValue;
    }
    else if(this.colObj.typeObj.editValue)
    {
        return this.colObj.typeObj.editValue(this);
    }
    else if(this.isModified())
    {
      return (this.colObj.userDateFmt) ? this.displayValue : this.modifiedValue;
    }
    else if(this.originalValue == null)
    {
      return "";
    }
    else
    {
      return (this.colObj.userDateFmt) ? this.displayValue : this.originalValue;
    }
  }
  else
  {

    return ((this.isError() || !this.isModified())? this.originalValue : this.modifiedValue);
  }
}

  ZDBCell.prototype.isModified = function()
    {
      return (this.modifiedValue != null);
    }

  ZDBCell.prototype.reset = function(newDBValue,displayValue)
    {
      this.modifiedValue = null;
      this.clearError(true, true, true);
      var convData = newDBValue;
        // Hack ... Let me consider this while I do "formatting"
      var colObj = this.colObj;
      var rowObj = this.rowObj;
      if(colObj instanceof Array)
      {
        colObj = null; //PK: Multicolumn no type
      }

      if(newDBValue && colObj && rowObj.objType != ZDBConst.COLHEAD)
      {
          switch(colObj.type)
          {
            case 'DECIMAL_NUMBER':
            case 'CURRENCY':
            case 'PERCENT':
             convData = parseFloat(newDBValue);
             if(isNaN(convData) == true)
             {
                convData = newDBValue;
             }
          }
          convData += "";
      }
      this.originalValue = convData;
      if(displayValue != null)
      {
        this.displayValue = displayValue;
      }
      else
      {
        this.displayValue = ""+ this.calculateDispVal();
      }
      if(this.cellEl != null)
      {
        this.cellEl.removeAttribute("title");
        this.setOnDataEl(this.displayValue);
      }
    }

ZDBCell.prototype.setOnDataEl = function(value,isError)
{
  var type = ZDBEvents.colBaseType(this.colObj);
  if(((type=="EMAIL") || (type == "URL")) && this.displayValue)
  {//$$: Email & URL column display values handled.
    value = (isError) ? ZDBEscapeUtil.encodeForHtml(value) : ZDBEvents.generateLinkEl(this,type);
  }
  value = (value != null) ? value : "";
  var dataNode = this.displayNode;
  var isHtml = this.isHtml;
  if(isHtml || this.colObj.parGrid.isSpanData)
  {
    dataNode.innerHTML =  value;
  }
  else
  {
    dataNode.data = value;
  }
  if(this.hiddenDispValue)
  {
      dataNode.innerHTML = this.hiddenDispValue;
  }
  var dataNodeEl = (dataNode.tagName == null) ? dataNode.parentNode : dataNode;
  if(this.bgCol != null && this.fontCol != null && this.className != "sectionHeader")
  {
      dataNodeEl.style.backgroundColor = this.bgCol;
      dataNodeEl.style.borderTopColor = this.bgCol;
      dataNodeEl.style.borderLeftColor = this.bgCol;
      dataNodeEl.style.color = this.fontCol;
  }
  else
  {
      dataNodeEl.style.backgroundColor = "";
      dataNodeEl.style.color = "";
      dataNodeEl.style.borderTopColor = "";
      dataNodeEl.style.borderLeftColor = "";
      dataNodeEl.style.borderBottomColor = "";
  }
  if(this.colObj.grouped && this.className != "sectionHeader")
  {
      this.setBorderColor(dataNodeEl);
  }
  this.setClass();
}

//The below method is to set the bg color for a grouped column in tabular view
// Group status: 1 - First cell of a grouped column, 2 - Last cell,
// 0 - middle cells and 3 - only one cell in the grouped column.

ZDBCell.prototype.setBorderColor = function(el)
{
    var elToSet = ZDBUtil.getParentWithTagName(el, "DIV");      //No I18N
    if(this.bgCol != null && this.fontCol != null)
    {
        var bgCol = this.bgCol;
        var fontCol = this.fontCol;
        //In styleArr style props are ordered as - bgCol,fontCol,borderTop,borderRight,borderBottom,borderLeft
        var styleArr = [[bgCol,fontCol,bgCol,,bgCol,bgCol],[bgCol,fontCol,,,bgCol,],[bgCol,fontCol,bgCol,,,bgCol],[bgCol,fontCol,,,,]];
        elToSet.style.backgroundColor = styleArr[this.groupStatus][0];
        elToSet.style.color = styleArr[this.groupStatus][1];
        elToSet.style.borderTopColor = styleArr[this.groupStatus][2];
        elToSet.style.borderRightColor = styleArr[this.groupStatus][3];
        elToSet.style.borderBottomColor = styleArr[this.groupStatus][4];
        elToSet.style.borderLeftColor = styleArr[this.groupStatus][5];
    }
    else
    {
        elToSet.style.backgroundColor = "";
        elToSet.style.color = "";
        elToSet.style.borderTopColor = "";
        elToSet.style.borderRightColor = "";
        elToSet.style.borderBottomColor = "";
        elToSet.style.borderLeftColor = "";
    }
}

ZDBCell.prototype.getConvertedValue = function()
{
  if(this.colObj.typeObj.convertFn)
  {
    return this.colObj.typeObj.convertFn(this.modifiedValue, this); ///PK: Issue this sent for default value
  }
  else
  {
         return this.modifiedValue;
  }
}

ZDBCell.prototype.calculateDispVal = function()
{
  if(this.refErrorMsg){} //PK: Revisit here!

  if(this.cellLevel)
  {
    return this.modifiedValue;
  }
  if(this.colObj.typeObj.dispFn)
  {
    return this.colObj.typeObj.dispFn(this);
  }
  else if(this.isModified())
  {
    return ZDBEscapeUtil.encodeForHtml(this.modifiedValue);
  }
  else
  {
    return this.originalValue == null ? "" : this.originalValue;
  }
}



function ZDBColHeader(parGrid,colId,colName,displayName,isPK,isAuto,isNullable,type,refTblName,refColName,refDispCol,
                      width,cellPos, visible, defaultVal,sortOrder,sortIndex, freeze, status, grouped, typeMetadata,
                      formula, derivedFunction, dervIndex, section, refColType, description, currencyFormat,className,
                      parentViewId,alignment,thousandSeparator,decimalPlaces,showSymbol,dateFormat,showNegativeSign,tobeListed,
                      dataColRef,decimalSeparator,userLocale,altText,relColTypeID,relColType,relTblName,relDispCol,refColConstriant,unitsSymbol,refViewType,geoRoleDet,lookupType,sysColInfo,condFormat,cellSelArr,isPii)
{

  ///PK: get grouped args
  this.instId = ZDBColHeader.COLINSTID++;
  this.parGrid = parGrid;
  this.colId = colId;
  this.colName = colName;
  if(this.colName === "FIELDNAME")
  {
    this.validateColFunc = ZDBValidator.isUnique;
  }
  if(this.colName === "DATATYPE")
  {
    this.validateColFunc = ZDBValidator.isUniqueANC;
  }
  this.displayNode = null;
  this.displayName = displayName;
  this.isPK = isPK;
  this.isAuto = isAuto;
  this.isNullable = isNullable;
  this.type = type;
  this.typeObj  = null;
  this.lookupType = lookupType;
  if(type == 'RELCOL' || lookupType == ZDBConst.RELCOL)
  {
  this.refTblName = relTblName;
  this.refDispCol = relDispCol;
  this.refViewType = refViewType;
  }
  else
  {
  this.refTblName = refTblName;
  this.refColName = refColName;
  this.refDispCol = refDispCol;
  }
  if(!width)
  {
    width = ZDBGlobal.stdCellWidth;
  }

  this.width = width;
  this.left = ZDBConst.NOTSET;
  this.cellPos = cellPos;
  this.sortOrder = sortOrder;
  this.sortIndex = sortIndex;
  this.grouped = grouped;
  this.visible = (visible != null) ? visible : true; // temp - update later
  if(this.isAuto)
  {
    this.visible = false;
  }
  this.tobeListed = (tobeListed != null) ? tobeListed : true;
  this.freeze = freeze ? freeze : false; // temp - update later
  this.status = status ? status : ZDBConst.CLEAR; // temp - updata later
  this.defaultVal = defaultVal;
  this.defCellClass = "zdbDataCell";
  if(type && ZDBColumnType[type])
  {
    this.typeObj = ZDBColumnType[type];
  }
  else
  {
    this.type = "PLAIN";
    this.typeObj = ZDBColumnType["PLAIN"]; //default TEXT
  }

  // Reporting
  this.typeMetadata = typeMetadata;
  this.fnArr = [];

  this.formula = formula;
  this.derivedFunction = (this.formula) ? ZDBFunctions.needSave : null;
  this.dervIndex = dervIndex;
  this.isColCellsEditable = true;
  if(formula != null)
  {
    this.isColCellsEditable = false;
  }
  if(type == 'AUTO_NUMBER')
  {
    this.isColCellsEditable = false;
  }

  this.section = section;
  this.refColType = refColType;
  this.reorder = !(grouped || section);
  this.description = description;
  this.currencyFormat = currencyFormat;
  this.unitsSymbol = unitsSymbol;
  this.className = className;
  this.parentViewId = parentViewId;
  this.objType = ZDBConst.COLHEAD;
  this.colObj = this;
  this.startIndex = -1;
  this.alignment = alignment;
  this.thousandSeparator = thousandSeparator;
  this.decimalPlaces = decimalPlaces;
  this.showSymbol = showSymbol;
  this.dateFormat = dateFormat;
  this.showNegativeSign = showNegativeSign;
  this.vudPerm = true;
  this.dataColRefIdx = dataColRef;
  this.decimalSeparator = decimalSeparator;
  this.userLocale = userLocale;
  this.condFormat = condFormat;
  this.cellSelArr = cellSelArr;
  this.altText = altText;
  this.relColType = relColType;
  this.relColTypeID = relColTypeID;
  this.refColConstriant=refColConstriant;
  if(sysColInfo === null ||typeof sysColInfo === 'undefined')
  {
    this.isSysCol = false;
  }
  else
  {
      this.isSysCol = sysColInfo[0];
      this.sysRefCol = ZDBEscapeUtil.escSplCharAsHTMLWithSpaceEncode(sysColInfo[1]+"."+sysColInfo[2]);
      this.connName = sysColInfo[3];
  }
  if(this.parGrid.isJSONOrXMLImp)
  {
    this.jsonNodePath = this.parGrid.nodesList[cellPos];
  }
  this.rowHeaderEl = ZDBUtil.getCloned("zdbRowDiv");  //No I18N
  this.rowDataEl = ZDBUtil.getCloned("zdbRowDiv");  //No I18N
  if(geoRoleDet && geoRoleDet !==null)
  {      
    this.geoRole = geoRoleDet[0];
    this.geoRoleName = geoRoleDet[1];
  }
  this.isPii = isPii;
}



ZDBColHeader.prototype.setExprValues = function(obj, zdbrow, colArr)
{
  var assigned = false;
  for(var i = 0;i < zdbrow.values.length;i++)
  {
    var colHead = zdbrow.parGrid.colHeaders[i];
    for(var j = 0;j < colArr.length;j++)
    {
      if(colHead.colName.toLowerCase() == colArr[j].toLowerCase())
      {
        var zdbcell = zdbrow.values[i];
        var value = zdbcell.modifiedValue; // new row added
        if(value == null)
        {// In case of saved data
          value = zdbcell.originalValue;
        }
        if(value == null)
        {
          return false;
        }
        else
        {
          assigned = true;
          if(colHead.typeObj.typeValue)
          {
            value = colHead.typeObj.typeValue(value, zdbcell);
          }
          obj[colArr[j]] = value;
        }
      }
    }
  }
  if(!assigned)
  {// In case where column name does not match - code bug !!
    return false;
  }
  return true;
}



ZDBColHeader.prototype.getDispNameForHtml= function()
{
  return ZDBEscapeUtil.encodeForHtml(this.displayName);
}

ZDBColHeader.COLINSTID=0;


function ZDBRow(parGrid,values,rowType,className, height, skipSet, isPivot)
{
  this.txtLength = 0;
  this.heightObj = null
  this.multiLine = [];
  this.objType = rowType;
  this.status = ZDBConst.CLEAR;
  this.sentStatus = 0;
  this.parGrid = parGrid;
  this.className = (className)? className:"dRow";
  if(!skipSet)
  {
    this.setValues(values);
  }
  else if(skipSet && (!isPivot)){
	  this.values=values;
	  this.rid=values[0].rowObj.rid;
  }
  
  this.height = (parGrid.type == "TableDesign") ? ZDBGlobal.stdEditGridCellHeight : (height || ZDBGlobal.stdCellHeight);
  this.top = ZDBConst.NOTSET;
  this.rowDataEl = ZDBUtil.getCloned("zdbRowDiv");  //No I18N
  this.rowDataEl.setAttribute("refElname",(rowType == ZDBConst.COLHEAD) ? "chArea" : "dArea");
  
  this.rowHeaderEl = ZDBUtil.getCloned("zdbRowDiv");  //No I18N
  this.rowHeaderEl.setAttribute("refElname",(rowType == ZDBConst.COLHEAD) ? "tcArea" :"rhArea")
}

ZDBRow.prototype.setValues = function(values)
{
  this.values = values;
  var valLen = values.length - 1;
  var colHeaders = this.parGrid.colHeaders;
  var colLen = colHeaders.length;
  var objType = this.objType;
  var rid = values[valLen--];
  values.pop();
  this.rid = rid;
  var rDisp = values[valLen];
  values.pop();
  if(rDisp === null || rDisp === undefined)
  {
    rDisp = '';
  }
  values.unshift(new ZDBCell(this, colHeaders[0],rDisp,rDisp,'zdbRowHead',-1, false,-1));
  if(objType !== ZDBConst.COLHEAD) ///PK:Move to row contruction
  {
     values.push(this.parGrid.domCache.getDummyCellObj(colHeaders[colLen-2],this)); ///DUMMYCOL
     values.push(this.parGrid.domCache.getDummyCellObj(colHeaders[colLen-1], this)); ///FILLERCOL
  }
  for(var i = 0;i < colLen; i++)
  {
      var curHead = colHeaders[i];
    if(!(values[i] instanceof ZDBCell))
    {
      var val = values[i];
      var dispVal = null;
      var mainClass = null;
      var groupStatus = null;
      var isHtml = null;
      var groupCount = -1;
      var origValue = val;
      var hiddenDispValue = null;
      var bgCol = null;
      var fontCol = null;
      var j=0;      
      if(val instanceof Array)
      {
        if(val[1] instanceof Object)
        {
            j = 1;
            bgCol = val[1].BGCOLOR;
            fontCol = val[1].FONTCOLOR;
        }
        dispVal = val[1+j];
        mainClass = val[2+j];
        groupStatus = val[3+j];
        isHtml = val[4+j];
        groupCount = val[5+j];
        origValue = val[0];
        hiddenDispValue = val[6+j];
        if(hiddenDispValue && hiddenDispValue.indexOf("java.lang")==0 || dispVal !== '')
        {
          hiddenDispValue = null; //PK: Holy hack, to be fixed soon!
        }
      }
      if(curHead.type == "URL" && curHead.altText != null && origValue != null && groupStatus == null)
      {
        values[i] = new ZDBCell(this, curHead,origValue,ZDBEscapeUtil.encodeForHtml(curHead.altText),mainClass,groupStatus,isHtml,groupCount, hiddenDispValue, bgCol, fontCol);
      }
      else
      {
        values[i] = new ZDBCell(this, curHead,origValue,dispVal,mainClass,groupStatus,isHtml,groupCount, hiddenDispValue, bgCol, fontCol);
      }
  }
  }

}

ZDBRow.prototype.saved = function()
{
  var values = this.values;
  for(var i =0,len = values.length; i < len; i++)
  {
    if(values[i].isModified())
    {
      values[i].reset(values[i].modifiedValue,values[i].displayValue);
    }
  }
  this.sentStatus = 0;
  this.status = ZDBConst.CLEAR;
}

ZDBRow.prototype.setModified = function()
{
  if(this.objType == ZDBConst.DUMMY)
  {
    this.objType = ZDBConst.DATA;
    this.status = ZDBConst.CREATED;
    this.setRID(null,"*" + this.parGrid.newRid++);
    this.parGrid.addedRowCount+=1;
  }
  else if(this.status == ZDBConst.CLEAR)
  {
    this.status = ZDBConst.MODIFIED;
    this.parGrid.rowsToUpdate.push(this);
  }
  if(this.sentStatus == 1){ this.sentStatus = 2;}
  this.parGrid.setDataModified();
}




ZDBColHeader.prototype.setValue = function(displayValue)
{
  var colHeads = this.parGrid.colHeaders;
  var colLen = colHeads.length;
  for(var i=0;i<colLen;++i)
  {
    if(displayValue == "" || ((displayValue.toUpperCase() == "__ZDBID" ||
        colHeads[i].displayName.toLowerCase().trim() == displayValue.toLowerCase().trim()) &&
        colHeads[i] != this))
    {
        return false;
    }
  }
  this.displayName = displayValue;
  this.displayNode.innerHTML = this.getDispNameForHtml();
  return true;
}




ZDBColHeader.prototype.setClass = function()
{
    var iconClass = "zdbColHeadArea zdbColHeadIcon "; //No I18N
    var gridObj = this.parGrid;
    this.cellEl.className = (this.className != null)? this.className:"zdbColHead";
    if(this.selected)
    {
      this.cellEl.className += " zdbColHeadFocus"; ///PK:  this.selectedClassName?
    }

    if(this.objType != ZDBConst.COLHEAD)
    {
      return;
    }

    if(gridObj.showDatatype)
    {
      var type = this.type;
      if(type == "REFCOL")
      {
        type = this.refColType;
      }
      if(type == "RELCOL")
      {
        type = this.relColType;
      }

      var url = ZDBGlobal.oldURL!=undefined?ZDBGlobal.oldURL:window.location.href; ///PK: should go to the Grid ????
      var src = url.split("?")[1]?url.split("?")[1]:url;
      var els = src.split("&");
      var objid = null;
      var dataTypeSymbol = null;
      var standAlone = null;
      for(var i=0,j=els.length;i<j;i++)
      {
          if(els[i].substring(0,els[i].indexOf("=")) == "OBJID")
          {
              objid = els[i].split("=")[1];
          }
          else if(els[i].substring(0,els[i].indexOf("=")) == "DATATYPESYMBOL")
          {
              dataTypeSymbol = els[i].split("=")[1];
          }
          else if(els[i].substring(0,els[i].indexOf("=")) == "STANDALONE")
          {
              standAlone = els[i].split("=")[1];
          }
      }
      if(objid == gridObj.objId && standAlone == "true")
      {
            gridObj.showDatatype = dataTypeSymbol== "true"? true:false;
            //this.typeNode.style.display="none";  // to fix error in standAlone view because first column header typeNode is visible 
      }
      this.typeNode.className = "zdbColHeadArea zdbColHeadDataType " + (ZDBColumnType[type] ? ZDBColumnType[type].typeClass : "");
    }
    else
    {
      this.typeNode.style.display="none";
    }

    if(this.sortOrder == ZDBConst.ASC)
    {
      iconClass += " headerSortAsc";
    }
    else if(this.sortOrder == ZDBConst.DESC)
    {
      iconClass += " headerSortDesc";
    }
    this.iconNode.className = iconClass;
}





ZDBColHeader.prototype.setModified = function()
{
  if(this.status == ZDBConst.DUMMY)
  {
    this.status = ZDBConst.CREATED;
  }
  else if((this.status != ZDBConst.CREATED))
  {
    this.status = ZDBConst.MODIFIED;
  }
  if(this.sentStatus == 1)
  {
    this.sentStatus = 2;
  }
}




ZDBColHeader.prototype.getViewIndex = function()
{
  return this.cellPos + ((this.cellPos <= this.parGrid.freezeIndex )? 1: -(this.parGrid.freezeIndex +1));
}

ZDBRow.prototype.setRID = function(rid,rDisp)
{
  this.rid = rid;
  this.rDisp = rDisp;
  if(this.rIdEl != null)
  {
    this.rIdEl.data =  this.rDisp;
  }
}


ZDBRow.setEls = function(cells, obj)
{
  obj.rIdEl = cells[0];
  cells[0].rowObj = obj;

  if(obj.rDisp != null)
  {
    obj.rIdEl.innerHTML =  obj.rDisp;
  }
  if(obj.objType != ZDBConst.FILLER)
  {
    obj.rIdEl.className = (obj.selected)? "zdbRowHeadFocus":"zdbRowHead";
  }
}


ZDBRow.unsetEls= function(rowObj)
{
  //PK: do more clean up
  if(rowObj.rIdEl)
  {
   delete rowObj.rIdEl;
  }
}


ZDBCell.setClass = function(cellObj, className, isAppend)
{

  if(this.colObj.objType == ZDBConst.ROWHEAD)
  {

  }

  var cellEl = cellObj.cellEl;
  if(className && isAppend === false)
  {
    cellEl.className = className;
    return;
  }
  var newClass = "";
  if(cellObj.className)
  {
    newClass = cellObj.className;
  }
  else if(ZDBCell.getRowClass(cellObj))
  {
    newClass = ZDBCell.getRowClass(cellObj);
  }
  else if(ZDBCell.getColClass(cellObj))
  {
    newClass = ZDBCell.getColClass(cellObj);
  }
  else
  {
    newClass = ZDBCell.getDefaultClass(cellObj);
  }

  if(className)
  {
    newClass += " " + className;
  }
  cellEl.className = newClass;
}




ZDBCell.getDefaultClass = function(cellObj)
{
  switch(cellObj.objType)
  {
    case ZDBConst.COLHEAD:
      return 'zdbColHead';
    default:
      return "";
  }

}

ZDBCell.getRowClass = function(cellObj)
{
  var rowObj = cellObj.rowObj;
  if(rowObj.className)
  {
    return rowObj.className;
  }
  else
  {
    return "";
  }
}


ZDBCell.getColClass = function(cellObj)
{
  var colObj = cellObj.colObj;
  if(colObj.className)
  {
    return colObj.className;
  }
  else
  {
    return "";
  }
}

ZDBRow.prototype.setClass = function()
{
  var cellObj = this.values[0]; ///PK: Assumption Always RowHead!
  var cellEl = cellObj.cellEl;
  if(!cellEl)
  {
    return; //PK: Analyse and fix
  }
  var colObj = cellObj.colObj;
  var newClass = cellObj.className;

  if(colObj.objType == ZDBConst.ROWHEAD)
  {
    if(this.selected || cellObj.selected)
    {
      cellEl.className = newClass + " zdbRowHeadFocus";
    }
    else
    {
      cellEl.className = newClass;
    }
    return;
  }

}

function ZDBFormatColHeader(dataType)
{
  this.type = ZDBUtil.dataTypeNumVsSubtypeDisp[dataType];
  var formatType = (dataType) ? ZDBUtil.datatypeVsFormatType[this.type] : null;
  this.typeNo = dataType;
  this.alignment = (dataType && (formatType != "Text" && formatType != "Date")) ? "Right" : "Left";   //No I18N
  this.altText = null;
  this.dateFormat = "dd MMM, yyyy HH:mm:ss";  //No I18N
  this.userLocale = false;
  this.thousandSeparator = (dataType == ZDBConst.CURRENCY) ? 1 : 0;
  this.decimalSeparator = 0;
  this.decimalPlaces = (dataType == ZDBConst.CURRENCY) ? 2 : -1;
  this.currencyFormat = "en;US;"; //No I18N
  this.showSymbol = (dataType == ZDBConst.CURRENCY) ? false : true; //For currency, by default currency option should be None
  this.showNegativeSign = true;
}
