//$Id$
var ZRSHomeHandler = new function () {
    var json;
    var databasesInfo = [];
    var dashboardsInfo = null;
    var myDashboards = [];
    var sharedDashboards = [];
    var recentItemsInfo = [];
    var displayedImportOpts = [];
    var homeProps = {};
    var enabledConnectors = {};
    var scrollWidth = 0;
    var countryName = "";
    var ignoreHashChange = false;
    var hometab;
    var tabNameInfo = {'tab1': 'databases', 'tab2': 'dashboards', 'tab3': 'recentitems'}; //NO I18N
    var tabClassDetails = {'tab1': {'header': 'ZRSHome-tab1-selected', 'list': 'tab1-list-selected', 'grid': 'tab1-grid-selected'}, //NO I18N
        'tab2': {'header': 'ZRSHome-tab2-selected', 'list': 'tab2-list-selected', 'grid': 'tab2-grid-selected'}, //NO I18N
        'tab3': {'header': 'ZRSHome-tab3-selected', 'list': 'tab3-list-selected', 'grid': 'tab3-grid-selected'} //NO I18N
    };
    var viewNames = ['Tables', 'TabularReports', 'Charts', //NO I18N
        'Pivots', 'SummaryViews', 'EditDesign', 'QueryTables', //NO I18N
        'Dashboards']; //NO I18N
    var viewTypeForSVG = ['Table', 'Report', 'AnalysisView', //NO I18N
        'Pivot', 'SummaryView', 'EditDesign', 'QueryTable', //NO I18N
        'Dashboard']; //NO I18N
    this.searchString = '';
    this.navigState = {
        databases: {
            start: 0,
            end: 0,
            totalValues: 0
        },
        dashboards: {
            start: 0,
            end: 0,
            totalValues: 0
        },
        recentitems: {
            start: 0,
            end: 0,
            totalValues: 0
        }
    };
    this.curRenderedJSON = [];
    this.placeHolder = null;
    this.noMatchDiv = null;
    this.iconLoadCheckTimer = null;
    this.triggerCardPreviewImageTimer = null;
    this.initializeHomepage = function (homepageJSONString) {
        json = JSON.parse(homepageJSONString);
        this.initializeJSVariables();
        ZDBClientUI.loadBaseSVGIcons();
        ZRSHomeHandler.getHomePageData(ZRSHomeHandler.initHomePage, ZRSHomeHandler, 'ZDBHomePageLoader');//NO I18N
        ZRSHomeHandler.loadjs("https://iplocation.zoho.com"); //NO I18N
    };
    this.loadTemplates = function () {
        ZDBLazyLoadUtil.loadJsAlone('ZRSHome_TEMPLATE', ZRSHomeHandler, ZRSHomeHandler.templateLoadSuccessb); //NO I18N
    };

    this.loadjs = function (filename) {
        var head = document.getElementsByTagName('head')[0];
        var script = document.createElement('script');
        script.type = 'text/javascript';
        script.src = filename;
        script.defer = true;
        script.async = true;
        if (filename === "https://iplocation.zoho.com") {
            script.onload = function () {
                var countryEleList = document.getElementsByClassName('countrylist');//No I18N
                for (var n = 0; n < countryEleList.length; ++n) {
                    countryEleList[n].value = countryName;
                }
            };
        }
        head.appendChild(script);
    };

    this.templateLoadSuccess = function () {
        if (!ZDBClientUI.baseSVGLoaded) {
            this.iconLoadCheckTimer = setTimeout(this.templateLoadSuccessb, 10);
            return;
        } else {
            clearInterval(this.iconLoadCheckTimer);
        }
        this.removeMainLoader();
        ////ignorei18n_start
        var domJSON = [];
        //Base Layout structure start
        //domJSON.push(['licenseTopBar', 'zrsheader']);
        domJSON.push(['homepage', 'zrsheader']);
        domJSON.push(['body_container', 'zrsbody']);
        domJSON.push(['import_options', 'zrsbody', 'ZDBMainContainer']);
        domJSON.push(['homepage_tabs', 'zrsbody', 'ZDBMainContainer']);
        domJSON.push(['homepage', 'zrsfooter']);
        //Base Layout structure end

        //Other sub components initialization start
        domJSON.push(['zohoapps', 'zrsheader']);
        domJSON.push(['signOutLinkMenu', 'zrsheader']);
        //domJSON.push(['headerPopUpMenu', 'zrsheader']);
        //domJSON.push(['notificationMenu', 'zrsheader']);
        domJSON.push(['headerhelpmenu', 'zrsmenu']);
        domJSON.push(['fullPageDialog', 'commonDialogs']);
        domJSON.push(['dialogTemplate', 'commonDialogs']);
        domJSON.push(['hiddenDialogDiv', 'commonDialogs']);
        domJSON.push(['messageBox', 'commonComponents']);
        domJSON.push(['tooltipDiv', 'commonComponents']);
        domJSON.push(['tooltipTable', 'commonComponents']);
        domJSON.push(['headerToolTip', 'commonComponents']);
        domJSON.push(['zdbViewDets', 'commonComponents']);
        domJSON.push(['zrsToolTip', 'commonComponents']);
        domJSON.push(['zrsToolTipError', 'commonComponents']);
        domJSON.push(['feedbackButton','commonComponents']);
        this.initializeMultipleDom(domJSON);
        this.placeHolder = document.querySelector('div[elname="placeholder"]');
        var loader = ZRSStringTemplateCreator.createTemplateForDynamicData('loader', 'zrsheader', false, {
            loaderId: 'ZDBMainLoader',
            loaderClassName: 'zdbLoaded',
            elname: 'textEl',
            loadingText: ZDBI18NMap.g('zrpt.chart.dyndrilldown.js.loading')
        });
        document.body.appendChild(loader);
        ZROrg.loadProfileImage();
        //Adding search to toolbar
        var homeBody = document.getElementById('ZRSHome-body');
        var searchHolderLi = homeBody.querySelector('li[elname="searchBoxHolder"]');
        var search = ZRSSearchComponent.standardSearchComp({
            srchCallBack: this.searchListing,
            clearCallBack: this.searchListing
        });
        var themeEl = $("ZRAccountOptions").querySelector("." + ZDBGlobal.currentTheme);
        ZDBUtil.addClass(themeEl, "theme-selected");
        ZDBUtil.setNamedChildEls(search, search);
        search.srchInput.setAttribute('placeholder', ZDBI18NMap.g('zrpt.common.js.search'));
        searchHolderLi.appendChild(search);
        //Base Layout structure start
        ZRSHomeHandler.showHomePage();
        ZRSHomeHandler.addEventListeners();
        setTimeout(function () {
            ZDBClientUI.loadWMS();
        }, 100);
        //Other sub components initialization end
        //ignorei18n_end
    };
    this.templateLoadSuccessb = this.templateLoadSuccess.bind(this);
    this.addEventListeners = function () {
        window.addEventListener('hashchange', this.handleUIonHashChange);
        window.addEventListener("resize", this.handleHomepageOnResizeb);
    };
    this.initializeMultipleDom = function (json) {
        for (var i = 0, len = json.length; i < len; i++) {
            var currentDOM = json[i];
            var template = ZRSStringTemplateCreator.createTemplateForData(currentDOM[0], currentDOM[1]);
            if (currentDOM[2]) {
                var dom = document.getElementById(currentDOM[2]);
                dom.appendChild(template);
            } else {
                document.body.appendChild(template);
            }
        }
    };
    this.initializeDOM = function (module, submodule) {
        var dom = ZRSStringTemplateCreator.createTemplateForData(module, submodule);
        document.body.appendChild(dom);
    };
    this.removeMainLoader = function () {
        var loader = document.getElementById('ZDBHomePageLoader');
        loader && loader.parentNode.removeChild(loader);
    };
    this.initializeJSVariables = function () {
        ZDBClientUI.initJSVariables(json);
        hometab = json.HOMETAB;
        var jsLazyLoadInitialization = new Function(json.JSLAZYLOADSTRING);
        var cssLazyLoadInitialization = new Function(json.CSSLAZYLOADSTRING);
        var svgLazyLoadInitialization = new Function(json.SVGLAZYLOADSTRING);
        jsLazyLoadInitialization();
        cssLazyLoadInitialization();
        svgLazyLoadInitialization();
        this.updateScrollWidthData();
    };
    this.updateScrollWidthData = function () {
        var div = document.createElement('div');
        div.setAttribute('style', "width: 100%;height: 100%;position: absolute;overflow: auto;visibility: hidden;");
        document.body.appendChild(div);
        div.innerHTML = '<div style="width: 100%;height: 200%;"></div></div>';
        scrollWidth = div.offsetWidth - div.clientWidth;
        div.parentNode.removeChild(div);
    };
    this.getHomePageData = function (successHandler, ctx, loader) {
        var errorHandler = {
            func: ZRSHomeHandler.handleHomepageRequestFailure,
            ctx: ZRSHomeHandler
        };
        ZRSAjax.get('/reportsapi/HOMEPAGEREQUESTS',
                {
                    NEWLAYOUT: true
                },
                {
                    successHandler: {
                        func: successHandler,
                        ctx: ctx
                    },
                    failureHandler: errorHandler,
                    errorHandler: errorHandler,
                    loader: loader
                }
        );
    };
    this.handleHomepageRequestFailure = function (response) {
        ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g('zrpt.common.js.clientcommonerror'));
    };
    this.updateData = function (respData) {
        databasesInfo = respData.DBLIST ? respData.DBLIST.values : [];
        recentItemsInfo = (respData.RECENTVIEWLIST) ? respData.RECENTVIEWLIST.values : [];
        enabledConnectors = respData.ENABLEDCONNECTORS;
    };

    this.initHomePage = function (respData) {
        ZRSHomeHandler.updateData(respData);
        var localStorageKeys = Object.keys(localStorage);
        for (var i = 0, len = localStorageKeys.length; i < len; i++) {
            var key = localStorageKeys[i];
            if (key.indexOf('newHomepageProps') > -1 && key !== 'newHomepageProps_version2') {//NO I18N
                ZDBUtil.deleteValueFromLocal(key);
            }
        }
        var homePropsHomepage = ZDBUtil.getValueFromLocal('newHomepageProps_version2');//NO I18N
        homeProps = homePropsHomepage ? JSON.parse(homePropsHomepage) :
                {'selectedtab': hometab, //NO I18N
                    'applyFav': false, //NO I18N
                    'databases': {'viewtype': 'grid', 'fav': false, 'dropdown': 'all', 'sorttype': 'dsc', 'sortcolumn': 'createdon'}, //NO I18N
                    'dashboards': {'viewtype': 'grid', 'fav': false, 'dropdown': '__all__', 'sorttype': 'dsc', 'sortcolumn': 'lastmodon'}, //NO I18N
                    'recentitems': {'viewtype': 'grid', 'fav': false, 'dropdown': 'all', 'sorttype': 'dsc', 'sortcolumn': 'lastaccess'} //NO I18N
                };
        homeProps.selectedtab = hometab;
        homeProps.dashboards.dropdown = '__all__';//NO I18N
        homeProps.dashboards.dbId = null;
        ZRSHomeHandler.updateHomePagePropsToLocal();
        ZRSHomeHandler.loadTemplates();
        ZROrg.handleLoadOrgDetails(respData);
    };
    this.updateHomePagePropsToLocal = function () {
        ZDBUtil.setValueToLocal('newHomepageProps_version2', JSON.stringify(homeProps));//NO I18N
    };
    this.showHomePage = function () {
        //$TODO$ - readonly case
        ZDBUtil.show($('ZDBMainContainer'));
        ZDBUtil.show($('ZDBHeader'));
        if (databasesInfo.length === 0) {
            ZRSHomeHandler.showImportOpts();
            if (ZDBClientUI.isFreshUser) {
                setTimeout(ZDBClientUI.openGettingStartedDlg, 100);
            }
            ZRSHomeHandler.hideImportBackButton();
        } else {
            ZRSHomeHandler.constructTemplateDomsForAllViews();
            ZRSHomeHandler.selectTab();
        }
    };
    this.updateHomeProps = function (jsonData) {
        for (var key in jsonData) {
            if (homeProps.hasOwnProperty(key)) {
                homeProps[key] = jsonData[key];
            }
        }
    };
    this.getHomeProps = function (propName) {
        return homeProps[propName];
    };
    this.selectTab = function (el) {
        var parentEl = document.querySelector('.ZRSHome-nav-container'); //NO I18N
        if (!parentEl) {
            return;
        }
        var tabNum = '';
        var tabDispName;
        if (el) {
            tabNum = el.getAttribute('tab');
            tabDispName = tabNameInfo[tabNum];
            ZRSHomeHandler.updateHomeProps({'selectedtab': tabDispName}); //NO I18N
            ZRSHomeHandler.updateHomePagePropsToLocal();
        } else {
            tabDispName = ZRSHomeHandler.getHomeProps('selectedtab'); //NO I18N
            tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
            el = DOMUtils.getChildElsWithAttr(parentEl, 'tab', tabNum)[0];
        }
        if (tabDispName === 'dashboards' && !dashboardsInfo) {
            ZRSHomeHandler.getDashboardInfo(el);
            return;
        }
        parentEl.className = 'ZRSHome-nav-container ' + tabClassDetails[tabNum].header;
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        var viewType = tabHeaderDetails.viewtype;
        var hashValue = ZRSHomeHandler.getWindowHashValue();
        var curDropdown = hashValue === 'MYDBS' ? 'owned' : hashValue === 'SHARED' ? 'shared' : 'all';//NO I18N
        if (tabDispName === 'databases') {
            tabHeaderDetails.dropdown = curDropdown;
            ZRSHomeHandler.updateHomePagePropsToLocal();
        }
        ZRSHomeHandler.resetNavigState();
        ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, viewType);
        if (ZRSHomeHandler.searchString) {
            var search = document.getElementById('ZRSHome-body').querySelector('li[elname="searchBoxHolder"] input');//NO I18N
            search.focus();
        }
        AjaxAPI.sendRequest({
            URL: "/ZDBUserAction.ma?ZDBACTION=UPDATEHOMETABPREF", //No I18N
            PARAMETERS: "&HOMETAB=" + tabDispName //NO I18N
        });
    };
    this.resetNavigState = function () {
        ZRSHomeHandler.navigState = {
            databases: {
                start: 0,
                end: 0,
                totalValues: 0
            },
            dashboards: {
                start: 0,
                end: 0,
                totalValues: 0
            },
            recentitems: {
                start: 0,
                end: 0,
                totalValues: 0
            }
        };
    };
    this.handleUIonHashChange = function () {
        if (ignoreHashChange) {
            ignoreHashChange = false;
            return;
        }
        var hashValue = ZRSHomeHandler.getWindowHashValue();
        var curDropdown = hashValue === 'MYDBS' ? 'owned' : hashValue === 'SHARED' ? 'shared' : '';//NO I18N
        if (!curDropdown) {
            return;
        }
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab'); //NO I18N
        if (tabDispName === 'databases') {
            ZRSHomeHandler.resetNavigState();
            var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
            var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
            tabHeaderDetails.dropdown = curDropdown;
            ZRSHomeHandler.updateHomePagePropsToLocal();
            ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, tabHeaderDetails.viewtype);
        }
    };
    this.handleHomepageOnResize = function () {
        this.animateDebounce(this.animateImport);
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab'); //NO I18N
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        var viewType = tabHeaderDetails.viewtype;
        var placeHolder = ZRSHomeHandler.placeHolder;
        var tabDiv = placeHolder.querySelector('.' + tabNum + '-' + viewType);
        var tabUl = tabDiv[viewType === 'list' ? 'list-data' : 'grid'];//NO I18N
        this.updateScrollWidthData();
        this.updateTabMarginBasedOnScroll(tabUl);
        if (getComputedStyle(document.getElementById('ZRSDBCreateOptsHldr')).display !== 'none') {
            ZRSHomeHandler.animateImport();
        }
    };
    this.handleHomepageOnResizeb = this.handleHomepageOnResize.bind(this);
    this.getDBInfoFromDBID = function (dbId) {
        for (var i = 0, len = databasesInfo.length; i < len; i++) {
            var curDB = databasesInfo[i];
            if (curDB[3] === dbId) {
                return curDB;
            }
        }
    };
    this.updatePlaceHolder = function (tabHeaderDetails, tabNum, viewType) {
        var placeHolder = ZRSHomeHandler.placeHolder;
        ZRSHomeHandler.updateToolbar(placeHolder, tabHeaderDetails);
        ZRSHomeHandler.curRenderedJSON = ZRSHomeHandler.getJSONToRenderBasedOnUserContext();
        ZRSHomeHandler.updateNavigValues(0, ZRSHomeHandler.curRenderedJSON.length > 20 ? 20 : ZRSHomeHandler.curRenderedJSON.length, ZRSHomeHandler.curRenderedJSON.length);
        ZRSHomeHandler.updateTabListContainer(tabNum, viewType, ZRSHomeHandler.curRenderedJSON);
        var className = 'ZRSHome-placeholder ';//NO I18N
//        if (placeHolder.className.indexOf('showNav') > -1) {
//            className += 'showNav ';//NO I18N
//        }
        placeHolder.className = className + tabClassDetails[tabNum][viewType];
        if (viewType === 'grid') {
            clearTimeout(ZRSHomeHandler.triggerCardPreviewImageTimer);
            ZRSHomeHandler.triggerCardPreviewImageTimer = setTimeout(ZRSCardPreviewHandler.initializePreviewHandlerForHome, 300);
        }
        var curTab = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        ZRSHomeHandler.handlerEmptyRenderJSON(curTab, tabHeaderDetails);
    };
    this.getCurrentShareFilter = function () {
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        return tabHeaderDetails.dropdown;
    };
    this.getCurrentDBFilter = function () {
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        return tabHeaderDetails.dbId;
    };
    this.handlerEmptyRenderJSON = function (curTab, tabHeaderDetails) {
        if (!this.noMatchDiv) {
            this.noMatchDiv = DOMUtils.getChildElsWithAttr(ZRSHomeHandler.placeHolder, 'elname', 'nomatchdiv')[0];//NO I18N
        }
        ZDBUtil.addClass(this.noMatchDiv, 'hide');
        if (!ZRSHomeHandler.curRenderedJSON.length) {
            var isSearchCtx = ZRSHomeHandler.searchString.length > 0;
            var message = null;
            if (isSearchCtx) {
                message = ZDBI18NMap.g('zrpt.common.js.nosearchmatch');
            } else {
                switch (curTab) {
                    case 'recentitems'://NO I18N
                        message = ZDBI18NMap.g('zrpt.common.js.norecentitms');
                        break;
                    case 'databases'://NO I18N
                        var shareStatus = tabHeaderDetails.dropdown === 'shared';//NO I18N
                        var ownedStatus = tabHeaderDetails.dropdown === 'owned';//NO I18N
                        message = shareStatus ? (tabHeaderDetails.fav ? ZDBI18NMap.g('zrpt.common.js.nosharedfavdb') : ZDBI18NMap.g('zrpt.home.js.nosharedb')) :
                                ownedStatus ? (tabHeaderDetails.fav ? ZDBI18NMap.g('zrpt.common.js.noownedfavdb') : ZDBI18NMap.g('zrpt.common.js.noowneddb')) :
                                (tabHeaderDetails.fav ? ZDBI18NMap.g('zrpt.common.js.nofavdb') : ZDBI18NMap.g('zrpt.home.js.nodb'));
                        break;
                    case 'dashboards'://NO I18N
                        var dbFilterStatus = tabHeaderDetails.dropdown !== '__all__';//NO I18N
                        message = dbFilterStatus ? ZDBI18NMap.g('zrpt.common.js.nodashboardindb') : ZDBI18NMap.g('zrpt.common.js.nodashboards');
                        break;
                }
            }
            if (message) {
                this.noMatchDiv.innerText = message;
                ZDBUtil.removeClass(this.noMatchDiv, 'hide');
//                if(tabHeaderDetails.viewtype === 'grid'){
//                    this.noMatchDiv.style.left = 'calc(50% - ('+this.noMatchDiv.offsetWidth / 2+ 'px))';
//                }
//                else{
//                this.noMatchDiv.style.left = 'calc(50% - ('+(this.noMatchDiv.offsetWidth / 2 + 50) + 'px))';
//                }

            }
        }
    };
    this.updateNavigValues = function (start, end, totValues) {
        var curTab = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        ZRSHomeHandler.navigState[curTab].start = start;
        ZRSHomeHandler.navigState[curTab].end = end;
        ZRSHomeHandler.navigState[curTab].totalValues = totValues;
    };
    this.getJSONToRenderBasedOnUserContext = function () {
        var curTab = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var inputJSON;
        switch (curTab) {
            case 'recentitems'://NO I18N
//                ZRSHomeHandler.updateWindowHashValue('');
                var recentItemsForOrg = ZROrg.selectedOrgZsoid == -1 ? recentItemsInfo : ZRSHomeHandler.getRecentItemsForOrg(recentItemsInfo);
                inputJSON = ZRSHomeHandler.applySearchFilterForRecentNDatabases(recentItemsForOrg, true);
                break;
            case 'databases'://NO I18N
                var curShareFilter = ZRSHomeHandler.getCurrentShareFilter();
                inputJSON = ZRSHomeHandler.applyShareFilter(databasesInfo, curShareFilter, ZROrg.selectedOrgZsoid);
                inputJSON = ZRSHomeHandler.applyFavFilter(inputJSON);
                inputJSON = ZRSHomeHandler.applySearchFilterForRecentNDatabases(inputJSON, false);
                break;
            case 'dashboards'://NO I18N
//                ZRSHomeHandler.updateWindowHashValue('');
                var curSelDBId = ZRSHomeHandler.getCurrentDBFilter();
                inputJSON = ZRSHomeHandler.applyDBFilter(dashboardsInfo, curSelDBId);
                inputJSON = ZRSHomeHandler.applySearchFilterForDashboards(inputJSON);
                break;
        }
        inputJSON = ZRSHomeHandler.applySorting(inputJSON, curTab);
        return inputJSON;
    };
    //ignorei18n_start
    this.applySorting = function (json, curSelTab) {
        if (json && json.length > 0) {
            var tabDetails = ZRSHomeHandler.getHomeProps(curSelTab);
            if (tabDetails) {
                var sortBy = tabDetails.sortcolumn;
                var sortType = tabDetails.sorttype;
                switch (curSelTab) {
                    case 'databases':
                        switch (sortBy) {
                            case 'name':
                                switch (sortType) {
                                    case 'asc':
                                        json = ZRSHomeHandler.sortAscending(json, 0);
                                        break;
                                    case 'dsc':
                                        json = ZRSHomeHandler.sortDescending(json, 0);
                                        break;
                                }
                                break;
                            case 'createdon':
                                switch (sortType) {
                                    case 'asc':
                                        json = ZRSHomeHandler.sortAscending(json, 8);
                                        break;
                                    case 'dsc':
                                        json = ZRSHomeHandler.sortDescending(json, 8);
                                        break;
                                }
                                break;
                        }
                        break;
                    case 'dashboards':
                        switch (sortBy) {
                            case 'name':
                                switch (sortType) {
                                    case 'asc':
                                        json = ZRSHomeHandler.sortAscending(json, 1);
                                        break;
                                    case 'dsc':
                                        json = ZRSHomeHandler.sortDescending(json, 1);
                                        break;
                                }
                                break;
                            case 'lastmodon':
                                switch (sortType) {
                                    //here the sorting is reversed because last modified is calculated differently.
                                    case 'asc':
                                        json = ZRSHomeHandler.sortDescending(json, 8);
                                        break;
                                    case 'dsc':
                                        json = ZRSHomeHandler.sortAscending(json, 8);
                                        break;
                                }
                                break;
                        }
                        break;
                    case 'recentitems':
                        switch (sortBy) {
                            case 'name':
                                switch (sortType) {
                                    case 'asc':
                                        json = ZRSHomeHandler.sortAscending(json, 0);
                                        break;
                                    case 'dsc':
                                        json = ZRSHomeHandler.sortDescending(json, 0);
                                        break;
                                }
                                break;
                            case 'lastaccess':
                                switch (sortType) {
                                    case 'asc':
                                        json = ZRSHomeHandler.sortAscending(json, 6);
                                        break;
                                    case 'dsc':
                                        json = ZRSHomeHandler.sortDescending(json, 6);
                                        break;
                                }
                                break;
                        }
                        break;
                }
            }
        }
        return json;
    };

    this.sortAscending = function (arr, propOrIndexToCompare) {
        if (arr instanceof Array) {
            return arr.sort(function (a, b) {
                if (a instanceof Array || a instanceof Object) {
                    if (a[propOrIndexToCompare] < b[propOrIndexToCompare])
                        return -1;
                    else if (a[propOrIndexToCompare] > b[propOrIndexToCompare])
                        return 1;
                    else
                        return 0;
                } else if (typeof a === 'string') {
                    if (a < b)
                        return -1;
                    else if (a > b)
                        return 1;
                    else
                        return 0;
                } else
                    return 0;
            });
        }
    };

    this.sortDescending = function (arr, propOrIndexToCompare) {
        if (arr instanceof Array) {
            return arr.sort(function (a, b) {
                if (a instanceof Array || a instanceof Object) {
                    if (a[propOrIndexToCompare] < b[propOrIndexToCompare])
                        return 1;
                    else if (a[propOrIndexToCompare] > b[propOrIndexToCompare])
                        return -1;
                    else
                        return 0;
                } else if (typeof a === 'string') {
                    if (a < b)
                        return 1;
                    else if (a > b)
                        return -1;
                    else
                        return 0;
                } else
                    return 0;
            });
        }
    };
    //ignorei18n_end
    this.applyDBFilter = function (json, curSelDBId) {
        if (!curSelDBId) {
            return json;
        }
        var respJSON = [];
        for (var i = 0, len = json.length; i < len; i++) {
            var curItem = json[i];
            if (curItem[17] === curSelDBId) {
                respJSON.push(curItem);
            }
        }
        return respJSON;
    };

    this.applyOrgSettings = function (toolbar, curTab)
    {
        if (getCookie("org-selected") != "undefined" && getCookie("org-selected") != null) {
            ZROrg.selectedOrgZsoid = getCookie("org-selected"); //No I18N
            setCookie("org-selected", undefined); //No I18N
        }
        if (getCookie("orgname") != "undefined" && getCookie("orgname") != null) {
            ZROrg.selectedOrgName = getCookie("orgname"); //No I18N
            setCookie("orgname", undefined); //No I18N
            ZDBMsgBox.showSuccess(ZDBI18NMap.f("zr.org.js.switchorg_msg", ZROrg.selectedOrgName));
        }
        if (getCookie("orgemail") != "undefined" && getCookie("orgemail") != null) {
            ZROrg.selectedOrgEmail = getCookie("orgemail"); //No I18N
            setCookie("orgemail", undefined); //No I18N
        }
        var canShowShareFilter = (ZROrg.selectedOrgZsoid == -1 && curTab === 'databases');//NO I18N
        toolbar.shareFilter.className = canShowShareFilter ? "dFlex alignCenter" : "hide"; //No I18N
        toolbar.searchBoxHolder.style.marginLeft = canShowShareFilter ? '10px' : '0px';//NO I18N
        if (curTab === 'dashboards') {
            ZDBUtil.removeClass(toolbar.dbFilter, 'hide');
        } else {
            ZDBUtil.addClass(toolbar.dbFilter, 'hide');
        }
        $("ZRImportButton").style.display = (ZROrg.selectedOrgZsoid == -1) ? "block" : (ZROrg.selectedOrgZsoid == ZDBGlobal.adminZsoId) ? "block" : "none"; //No I18N
    };

    this.applyFavFilter = function (json) {
        if (ZRSHomeHandler.getHomeProps('applyFav')) {
            var respJSON = [];
            for (var i = 0, len = json.length; i < len; i++) {
                var curItem = json[i];
                if (curItem[7]) {
                    respJSON.push(curItem);
                }
            }
            return respJSON;
        } else {
            return json;
        }
    };
    this.getRecentItemsForOrg = function (json)
    {
        var respJSON = [];
        for (var i = 0, len = json.length; i < len; i++) {
            var curItem = json[i];
            for (var j = 0, leng = databasesInfo.length; j < leng; j++)
            {
                if (curItem[4] == databasesInfo[j][3] && databasesInfo[j][5] == ZROrg.selectedOrgZsoid)
                {
                    respJSON.push(curItem);
                }
            }
        }
        return respJSON;
    };
    this.applySearchFilterForRecentNDatabases = function (json, isRecent) {
        var respJSON = [];
        for (var i = 0, len = json.length; i < len; i++) {
            var curItem = json[i];
            var curItemName = curItem[0];
            var curItemDBName = isRecent ? curItem[3] : curItem[2];
            var searchStringLower = ZRSHomeHandler.searchString.toLowerCase();
            if (curItemName.toLowerCase().indexOf(searchStringLower) !== -1 || curItemDBName.toLowerCase().indexOf(searchStringLower) !== -1) {
                respJSON.push(curItem);
            }
        }
        return respJSON;
    };
    this.applySearchFilterForDashboards = function (json) {
        var respJSON = [];
        for (var i = 0, len = json.length; i < len; i++) {
            var curItem = json[i];
            var curItemName = curItem[1];
            var curItemDBName = curItem[18];
            var searchStringLower = ZRSHomeHandler.searchString.toLowerCase();
            if (curItemName.toLowerCase().indexOf(searchStringLower) !== -1 || curItemDBName.toLowerCase().indexOf(searchStringLower) !== -1) {
                respJSON.push(curItem);
            }
        }
        return respJSON;
    };
    this.applyShareFilter = function (json, curShareFilter, orgZsoid) {
        var respJSON = [];
        if (orgZsoid == -1)
        {
            if (curShareFilter === "all")
            {
                return json;
            } else
            {
                for (var i = 0, len = json.length; i < len; i++) {
                    var curItem = json[i];
                    var curItemOwnerZUID = curItem[6];
                    var cond = curShareFilter === 'owned' ? curItemOwnerZUID === ZDBGlobal.zuID : curShareFilter === 'shared' ? curItemOwnerZUID !== ZDBGlobal.zuID : false;//NO I18N
                    if (cond) {
                        respJSON.push(curItem);
                    }
                }
            }
        } else
        {
            ZRSHomeHandler.updateWindowHashValue((orgZsoid == ZDBGlobal.adminZsoId) ? "MYDBS" : "SHARED"); //No I18N
            for (var i = 0, len = databasesInfo.length; i < len; i++) {
                if (databasesInfo[i][5] == orgZsoid) {
                    respJSON.push(databasesInfo[i]);
                }
            }
        }
        return respJSON;
    };
    this.updateTabListContainer = function (tabNum, viewType, jsonToRender) {
        var placeHolder = ZRSHomeHandler.placeHolder;
        var tabDiv = placeHolder.querySelector('.' + tabNum + '-' + viewType);
        var curTab = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var curTabNavigState = ZRSHomeHandler.navigState[curTab];
        if (tabDiv) {
            ZDBUtil.setNamedChildEls(tabDiv, tabDiv, null, null, null, true);
            var tabUl = tabDiv[viewType === 'list' ? 'list-data' : 'grid'];//NO I18N
            tabUl.scrollTop = '0';
            var lis = tabUl.querySelectorAll('li[dbid]');
            var lisLength = lis.length;
            var renderMethod = curTab === 'databases' ? ZRSHomeHandler.updateLiForDatabases : curTab === 'recentitems' ? ZRSHomeHandler.updateLiForRecentItems : curTab === 'dashboards' ? ZRSHomeHandler.updateLiForDashboards : null;//NO I18N
            var j = 0;
            for (var i = curTabNavigState.start; i < curTabNavigState.end && j < lisLength; i++, j++) {
                var curLi = lis[j];
                ZDBUtil.removeClass(curLi, 'hide');
                var curJSON = jsonToRender[i];
                renderMethod.apply(ZRSHomeHandler, [viewType, curJSON, curLi]);
            }
            while (j < lisLength) {
                ZDBUtil.addClass(lis[j], 'hide');
                j++;
            }
            this.updateTabMarginBasedOnScroll(tabUl);
        }
    };
    this.updateTabMarginBasedOnScroll = function (ul) {
        if (ul.clientWidth) {
            if (ul.clientWidth !== ul.offsetWidth) {
                //scrollbar happened
                ul.style.marginRight = -scrollWidth + 'px';//NO I18N
            } else {
                //no scrollbar
                ul.style.marginRight = '';//NO I18N
            }
        } else {
            setTimeout(function () {
                ZRSHomeHandler.updateTabMarginBasedOnScroll(ul);
            }, 0);
        }
    };
    this.commonScrollHandler = function (event) {
        if (event.target.scrollTop + event.target.clientHeight > (event.target.scrollHeight - 100)) {
            var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
            var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
            var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
            var viewType = tabHeaderDetails.viewtype;
            var jsonToRender = ZRSHomeHandler.curRenderedJSON;
            var placeHolder = ZRSHomeHandler.placeHolder;
            var tabDiv = placeHolder.querySelector('.' + tabNum + '-' + viewType);
            var curTabNavigState = ZRSHomeHandler.navigState[tabDispName];
            var tabUl = tabDiv[viewType === 'list' ? 'list-data' : 'grid'];//NO I18N
            var lis = tabUl.querySelectorAll('li[dbid]');
            if (curTabNavigState.end < jsonToRender.length && tabDiv) {
                //unrendered json remaining
                ZDBUtil.setNamedChildEls(tabDiv, tabDiv, null, null, null, true);
                var renderMethod = tabDispName === 'databases' ? ZRSHomeHandler.updateLiForDatabases : tabDispName === 'recentitems' ? ZRSHomeHandler.updateLiForRecentItems : tabDispName === 'dashboards' ? ZRSHomeHandler.updateLiForDashboards : null;//NO I18N
                var createMethod = tabDispName === 'databases' ? ZRSHomeHandler.createLiForDatabases : tabDispName === 'recentitems' ? ZRSHomeHandler.createLiForRecentItems : tabDispName === 'dashboards' ? ZRSHomeHandler.createLiForDashboards : null;//NO I18N
                var diff = jsonToRender.length - curTabNavigState.end;
                var noOfLisToRender = diff > 20 ? 20 : diff;
                if (lis.length < (curTabNavigState.end + noOfLisToRender)) {
                    createMethod.apply(ZRSHomeHandler, [viewType, (curTabNavigState.end + noOfLisToRender) - lis.length, tabUl]);
                }
                lis = tabUl.querySelectorAll('li[dbid]');
                var lisLength = lis.length;
                for (var i = 0, j = curTabNavigState.end; i < noOfLisToRender && j < lisLength; i++, j++) {
                    var offsetIndex = curTabNavigState.end + i;
                    var curLi = lis[j];
                    ZDBUtil.removeClass(curLi, 'hide');
                    var curJSON = jsonToRender[offsetIndex];
                    renderMethod.apply(ZRSHomeHandler, [viewType, curJSON, curLi]);
                }
                while (j < lisLength) {
                    ZDBUtil.addClass(lis[j], 'hide');
                    j++;
                }
                curTabNavigState.end += noOfLisToRender;
            }
        }
    };
    this.updateLiForDatabases = function (viewType, json, li) {
        ZDBUtil.setNamedChildEls(li, li, null, null, null, true);
        switch (viewType) {
            case 'list'://NO I18N
                var ownerZuid = json[6];
                var isSharedDB = ownerZuid !== ZDBGlobal.zuID;
                li.dbname.innerHTML = ZDBEscapeUtil.encodeForHtml(json[0]);
                li.setAttribute('dbid', json[3]);
                li.setAttribute('zsoid', json[5]);
                li.setAttribute('ownerzuid', ownerZuid);
                li.dbname.href = ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBDataSheetView.cc?DBID=' + json[3];
                li.dbdesc.innerHTML = ZDBEscapeUtil.encodeForHtml(json[2] ? json[2] : ZDBI18NMap.g('zrpt.common.js.NO_DESC'));
                li.createdon.innerHTML = ZDBEscapeUtil.encodeForHtml(json[4]);
                if (isSharedDB) {
                    li.ownedDBIcon.style.display = 'none';
                    li.sharedDBIcon.style.display = '';
                    li.sharedDBIcon.setAttribute('tip', ZDBI18NMap.g('zrpt.home.share.js.sharedby') + ' ' + json[10]);
                } else {
                    li.sharedDBIcon.style.display = 'none';
                    li.ownedDBIcon.style.display = '';
                    li.ownedDBIcon.setAttribute('tip', ZDBI18NMap.g('zrpt.common.js.ownedbyme'));
                }

                if (json[6] === ZDBGlobal.zuID) {
                    ZDBUtil.removeClass(li.ico, 'hide');
                } else {
                    ZDBUtil.addClass(li.ico, 'hide');
                }
                var isfav = json[7];
                if (isfav)
                {
                    ZDBUtil.addClass(li.fav, "selected");
                } else
                {
                    ZDBUtil.removeClass(li.fav, "selected");
                }
                break;
            case 'grid'://NO I18N
                var ownerZuid = json[6];
                var isSharedDB = ownerZuid !== ZDBGlobal.zuID;
                li.cardTitle.innerHTML = ZDBEscapeUtil.encodeForHtml(json[0]);
                li.setAttribute('dbId', json[3]); //No i18N
                li.setAttribute('zsoid', json[5]); //NO I18N
                li.setAttribute('ownerzuid', ownerZuid); //NO I18N
                li.viewSnap.innerHTML = '';
                var svgEl = ZDBUtil.createSVGTemplate(isSharedDB ? '#ZR-sharedDatabase' : '#ZR-database'); //No i18N
                li.viewSnap.appendChild(svgEl);
                li.removeAttribute('snapreqsent');
//                li.viewSnap.className = isSharedDB ? 'viewSnap' : 'viewSnap cardFooterAbsent';
                li.viewSnap.className = 'viewSnap';
//                li.cardFooter.style.display = isSharedDB ? '' : 'none';//currently settings card footer will change to shareholder in future after likes and comments are added.
                if (isSharedDB) {
                    li.ownedIcon.style.display = 'none';
                    li.shareIcon.style.display = '';
                    ZDBUtil.addClass(li.optionsBtn, 'hide');
                } else {
                    li.ownedIcon.style.display = '';
                    li.shareIcon.style.display = 'none';
                    ZDBUtil.removeClass(li.optionsBtn, 'hide');
                }
                li.sharedText.innerText = isSharedDB ? json[10] : ZDBI18NMap.g('zr.org.js.me');
                li.viewCreatedDet.innerHTML = ZDBI18NMap.f('zrpt.explorer.js.created_on', '') + ': ' + ZDBEscapeUtil.encodeForHtml(json[4]);
                var isfav = json[7];
                if (isfav)
                {
                    ZDBUtil.addClass(li.favTag, "ZRSFav");
                } else
                {
                    ZDBUtil.removeClass(li.favTag, "ZRSFav");
                }
                break;
        }
    };
    this.createLiForDatabases = function (viewType, noOfLis, ulToAppendTo) {
        switch (viewType) {
            case 'list'://NO I18N
                var listDataTemp = ZDBUtil.templateCreator('_homeListDataStruct', true); //NO I18N
                for (var i = 0; i < noOfLis; i++)
                {
                    var listDataEl = listDataTemp.cloneNode(true);
                    ZDBUtil.setNamedChildEls(listDataEl, listDataEl, null, null, null, true);
                    listDataEl.dbname.innerText = '';
                    listDataEl.setAttribute('dbid', '');
                    listDataEl.setAttribute('zsoid', '');
                    listDataEl.setAttribute('ownerzuid', '');
                    listDataEl.dbname.href = '';
                    listDataEl.dbdesc.innerText = '';
                    listDataEl.createdon.innerText = '';
                    ulToAppendTo.appendChild(listDataEl);
                }
                break;
            case 'grid'://NO I18N
                var gridDataEl = ZRSHomeHandler.constructGridView();
                for (var i = 0; i < noOfLis; i++)
                {
                    gridDataEl.cardTitle.innerText = '';
                    gridDataEl.setAttribute('dbId', ''); //No i18N
                    gridDataEl.setAttribute('zsoid', ''); //NO I18N
                    gridDataEl.setAttribute('ownerzuid', ''); //NO I18N
                    var svgEl = ZDBUtil.createSVGTemplate('#ZR-database'); //No i18N
                    gridDataEl.viewSnap.innerHTML = '';
                    gridDataEl.viewSnap.appendChild(svgEl);
                    gridDataEl.viewCreatedDet.innerText = '';
                    var gridDataElClone = gridDataEl.cloneNode(true);
                    ZDBUtil.setNamedChildEls(gridDataElClone, gridDataElClone, null, null, null, true);
                    gridDataElClone.optionsBtn.addEventListener('mouseenter', this.handleFavMouseEnter);
                    gridDataElClone.optionsBtn.addEventListener('mouseleave', ZDBToolTip.hide);
                    gridDataElClone.favTag.addEventListener('mouseenter', this.handleFavMouseEnter);
                    gridDataElClone.favTag.addEventListener('mouseleave', ZDBToolTip.hide);
                    ulToAppendTo.appendChild(gridDataElClone);
                }
                break;
        }
    };

    this.handleFavMouseEnter = function (event) {
        var target = event.target;
        if (event.target.getAttribute('elname') === 'favTag') {
            target.setAttribute('tip', ZDBI18NMap.f(target.className.indexOf('ZRSFav') > -1 ? 'zrpt.title.remfav.js.title' : 'zrpt.title.fav.js.title', ZDBI18NMap.g('zr.notification.js.database')));
        }
        ZDBToolTip.show(target, event);
    };

    this.updateLiForRecentItems = function (viewType, json, li) {
        ZDBUtil.setNamedChildEls(li, li, null, null, null, true);
        switch (viewType) {
            case 'list'://NO I18N
                li.viewname.innerHTML = ZDBEscapeUtil.encodeForHtml(json[0]);
                li.viewdesc.style.display = 'none';
//                li.viewdesc.innerText = json[7] ? json[7] : ZDBI18NMap.g('zrpt.common.share.shareview.js.desc_not_provided');
                li.viewcontainer.href = ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBDataSheetView.cc?DBID=' + json[4] + '&OBJID=' + json[1];
                li.dbname.innerHTML = ZDBEscapeUtil.encodeForHtml(json[3]);
                li.viewicon.className = viewNames[json[2]] + 'Nav';
                li.modified.innerHTML = ZDBEscapeUtil.encodeForHtml(json[5]);
                break;
            case 'grid'://NO I18N
                li.cardTitle.innerHTML = ZDBEscapeUtil.encodeForHtml(json[0]);
                li.setAttribute('dbId', json[4]);
                li.setAttribute('objId', json[1]);
                var objType = viewTypeForSVG[json[2]];
                li.setAttribute('objType', objType);
                var svgEl = ZDBUtil.createSVGTemplate('#ZR-' + objType); //No i18N
                li.viewSnap.innerHTML = '';
                li.viewSnap.className = 'viewSnap';
                li.viewSnap.appendChild(svgEl);
                li.removeAttribute('snapreqsent');
                ZDBUtil.addClass(li.favTag, 'hide');
                li.sharedText.innerText = json[3];
                li.sharedText.style.marginLeft = '';
                li.shareIcon.style.display = "none";
                li.viewCreatedDet.innerHTML = ZDBI18NMap.g('zrpt.explorer.js.last_modified') + ': ' + ZDBEscapeUtil.encodeForHtml(json[5]);
                break;
        }
    };
    this.createLiForRecentItems = function (viewType, noOfLis, ulToAppendTo) {
        switch (viewType) {
            case 'list'://NO I18N
                var listDataTemp = ZDBUtil.templateCreator('_homeListDataStruct1'); //NO I18N
                for (var i = 0; i < noOfLis; i++)
                {
                    var listDataEl = listDataTemp.cloneNode(true);
                    ZDBUtil.setNamedChildEls(listDataEl, listDataEl, null, null, null, true);
                    listDataEl.viewname.innerText = '';
                    listDataEl.setAttribute('dbId', '');
                    listDataEl.viewcontainer.href = '';
                    listDataEl.dbname.innerText = '';
                    listDataEl.viewicon.className = '';
                    listDataEl.modified.innerText = '';
                    ulToAppendTo.appendChild(listDataEl);
                }
                break;
            case 'grid'://NO I18N
                var gridDataEl = ZRSHomeHandler.constructGridView();
                for (var i = 0; i < noOfLis; i++)
                {
                    gridDataEl.cardTitle.innerText = '';
                    ZDBUtil.addClass(gridDataEl.moreOpt, 'hide');
                    gridDataEl.setAttribute('dbId', '');
                    gridDataEl.setAttribute('objId', '');
                    gridDataEl.setAttribute('objType', '');
                    var svgEl = ZDBUtil.createSVGTemplate('#ZR-Table'); //No i18N
                    gridDataEl.viewSnap.innerHTML = '';
                    gridDataEl.viewSnap.appendChild(svgEl);
                    gridDataEl.viewCreatedDet.innerText = '';
                    ulToAppendTo.appendChild(gridDataEl.cloneNode(true));
                }
                break;
        }
    };
    this.updateLiForDashboards = function (viewType, json, li) {
        ZDBUtil.setNamedChildEls(li, li, null, null, null, true);
        switch (viewType) {
            case 'list'://NO I18N
                li.viewicon.className = viewNames[7] + 'Nav';
                li.viewname.innerHTML = ZDBEscapeUtil.encodeForHtml(json[1]);
                li.viewdesc.innerText = json[4] ? json[4] : ZDBI18NMap.g('zrpt.common.share.shareview.js.desc_not_provided');
                li.dbname.innerHTML = ZDBEscapeUtil.encodeForHtml(json[18]);
                li.modified.innerHTML = ZDBEscapeUtil.encodeForHtml(json[13]);
                li.setAttribute('dbId', json[17]);
                li.viewcontainer.href = ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBDataSheetView.cc?DBID=' + json[17] + '&OBJID=' + json[0];
                break;
            case 'grid'://NO I18N
                li.cardTitle.innerHTML = ZDBEscapeUtil.encodeForHtml(json[1]);
                li.setAttribute('dbId', json[17]);
                li.setAttribute('objId', json[0]);
                var objType = viewTypeForSVG[7];
                li.setAttribute('objType', objType);
                var svgEl = ZDBUtil.createSVGTemplate('#ZR-' + objType); //No i18N
                li.viewSnap.innerHTML = '';
                li.viewSnap.appendChild(svgEl);
                li.viewSnap.className = 'viewSnap';
                li.removeAttribute('snapreqsent');

                li.sharedText.innerText = json[18];
                li.sharedText.style.marginLeft = '';
                li.shareIcon.style.display = "none";

                ZDBUtil.addClass(li.favTag, 'hide');
                li.viewCreatedDet.innerHTML = ZDBI18NMap.g('zrpt.explorer.js.last_modified') + ': ' + ZDBEscapeUtil.encodeForHtml(json[13]);
                break;
        }
    };
    this.createLiForDashboards = function (viewType, noOfLis, ulToAppendTo) {
        switch (viewType) {
            case 'list'://NO I18N
                var listDataTemp = ZDBUtil.templateCreator('_homeListDataStruct1'); //NO I18N
                for (var i = 0; i < noOfLis; i++)
                {
                    var listDataEl = listDataTemp.cloneNode(true);
                    ZDBUtil.setNamedChildEls(listDataEl, listDataEl, null, null, null, true);
                    listDataEl.viewname.innerText = '';
                    listDataEl.viewcontainer.href = '';
                    listDataEl.dbname.innerText = '';
                    listDataEl.setAttribute('dbId', '');
                    listDataEl.viewicon.className = '';
                    listDataEl.modified.innerText = '';
                    ulToAppendTo.appendChild(listDataEl);
                }
                break;
            case 'grid'://NO I18N
                var gridDataEl = ZRSHomeHandler.constructGridView();
                var svgEl = ZDBUtil.createSVGTemplate('#ZR-Dashboard'); //No i18N
                for (var i = 0; i < noOfLis; i++)
                {
                    gridDataEl.cardTitle.innerText = '';
                    gridDataEl.setAttribute('dbId', ''); //No i18N
                    gridDataEl.setAttribute('objId', ''); //No i18N
                    gridDataEl.viewSnap.innerHTML = '';
                    gridDataEl.viewSnap.appendChild(svgEl);
                    gridDataEl.viewCreatedDet.innerText = '';
                    ulToAppendTo.appendChild(gridDataEl.cloneNode(true));
                }
                break;
        }
    };
    this.updateToolbar = function (placeHolder, tabDetails) {
        var toolbar = DOMUtils.getChildElsWithAttr(placeHolder, 'elname', 'toolbar')[0]; //NO I18N
        ZDBUtil.setNamedChildEls(toolbar, toolbar, null, null, null, true);
        var curTab = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        if (curTab === 'recentitems') {
            ZDBUtil.addClass(toolbar.shareFilter, 'hide');
            ZDBUtil.addClass(toolbar.fav, 'hide');
            ZDBUtil.addClass(toolbar.dbFilter, 'hide');
        } else if (curTab === 'databases') {//NO I18N
            ZDBUtil.removeClass(toolbar.shareFilter, 'hide');
            ZDBUtil.removeClass(toolbar.fav, 'hide');
            ZDBUtil.addClass(toolbar.dbFilter, 'hide');
            if (ZRSHomeHandler.getHomeProps('applyFav')) {
                ZDBUtil.addClass(toolbar.fav, 'selected');
                ZDBUtil.animateFavIcon(toolbar.fav, "FavFill", 0);
            } else {
                ZDBUtil.removeClass(toolbar.fav, 'selected');
                ZDBUtil.animateFavIcon(toolbar.fav, "", 0);
            }
            ZRSHomeHandler.updateShareBasedFilter(toolbar, tabDetails);
        } else if (curTab === 'dashboards') {//NO I18N
            ZDBUtil.addClass(toolbar.shareFilter, 'hide');
            ZDBUtil.removeClass(toolbar.dbFilter, 'hide');
            ZDBUtil.addClass(toolbar.fav, 'hide');
            ZRSHomeHandler.updateDBBasedFilter(toolbar, tabDetails);
        }
        ZRSHomeHandler.updateSortStatus(curTab, toolbar, tabDetails);
        ZRSHomeHandler.updateViewTypeState(toolbar, tabDetails);
        ZRSHomeHandler.applyOrgSettings(toolbar, curTab);
    };
    //ignorei18n_start
    this.updateSortStatus = function (curTab, toolbar, tabDetails) {
        var sortBy = tabDetails.sortcolumn;
        var sorttype = tabDetails.sorttype;
        var toolTipText = '';
        var key = '';
        switch (curTab) {
            case 'dashboards':
                switch (sortBy) {
                    case 'name':
                        key = 'zrpt.common.js.dashboardname';
                        toolTipText = 'zrpt.explorer.js.last_modified';
                        break;
                    case 'lastmodon':
                        key = 'zrpt.explorer.js.last_modified';
                        toolTipText = 'zrpt.common.js.dashboardname';
                        break;
                }
                break;
            case 'databases':
                switch (sortBy) {
                    case 'name':
                        key = 'zrpt.common.js.dbname';
                        toolTipText = 'zrpt.explorer.js.created_on';
                        break;
                    case 'createdon':
                        key = 'zrpt.explorer.js.created_on';
                        toolTipText = 'zrpt.common.js.dbname';
                        break;
                }
                break;
            case 'recentitems':
                switch (sortBy) {
                    case 'name':
                        key = 'zrpt.common.js.viewname';
                        toolTipText = 'zrpt.homepage.js.lastAccessed';
                        break;
                    case 'lastaccess':
                        key = 'zrpt.homepage.js.lastAccessed';
                        toolTipText = 'zrpt.common.js.viewname';
                        break;
                }
                break;
        }
        toolbar.sortbywhat.innerText = ZDBI18NMap.f(key, '');
        toolbar.sortbywhat.parentNode.setAttribute('tip', ZDBI18NMap.f('zrpt.common.js.togglesortby', ZDBI18NMap.f(toolTipText, '')));
        switch (sorttype) {
            case 'asc':
                ZDBUtil.addClass(toolbar.dsc, 'hide');
                ZDBUtil.removeClass(toolbar.asc, 'hide');
                toolbar.asc.parentNode.setAttribute('tip', ZDBI18NMap.g('zrpt.common.js.sortdsc'));
                break;
            case 'dsc':
                ZDBUtil.addClass(toolbar.asc, 'hide');
                ZDBUtil.removeClass(toolbar.dsc, 'hide');
                toolbar.asc.parentNode.setAttribute('tip', ZDBI18NMap.g('zrpt.common.js.sortasc'));
                break;
        }
    };
    //ignorei18n_end
    this.updateViewTypeState = function (toolbar, tabDetails) {
        var viewType = tabDetails.viewtype;
        ZDBUtil.removeClass(toolbar.listView, 'selected');
        ZDBUtil.removeClass(toolbar.gridView, 'selected');
        ZDBUtil.addClass(toolbar[viewType === 'list' ? 'listView' : 'gridView'], 'selected');
    };

    this.getWindowHashValue = function () {
        var hashValue = window.location.hash.replace('#', '');
        hashValue = hashValue ? hashValue : '';
        return hashValue;
    };
    this.updateWindowHashValue = function (newHash) {
        ignoreHashChange = true;
        window.location.hash = newHash;
    };
    this.updateShareBasedFilter = function (toolbar, tabDetails) {
        var curDropdown = tabDetails.dropdown;
        var tabs = ['all', 'owned', 'shared'];//NO I18N
        tabs.forEach(function (tab) {
            ZDBUtil.removeClass(toolbar[tab], 'selected');
        });
        ZDBUtil.addClass(toolbar[curDropdown], 'selected');
    };
    this.updateDBBasedFilter = function (toolbar, tabDetails) {
        var curDropDown = tabDetails.dropdown;
        toolbar.dbBasedFilter.innerText = curDropDown === '__all__' ? ZDBI18NMap.g('zrpt.common.js.alldb') : curDropDown;//NO I18N
    };
    this.showSelectedView = function (viewType, element) {
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab'); //NO I18N
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        var tabs = ['databases', 'recentitems', 'dashboards'];//NO I18N
        if (tabHeaderDetails.viewtype === viewType) {
            return;
        }
        tabHeaderDetails.viewtype = viewType;
        tabs.splice(tabs.indexOf(tabDispName), 1);
        for (var i = 0, len = tabs.length; i < len; i++) {
            var curTab = tabs[i];
            var curTabHeaderDetails = ZRSHomeHandler.getHomeProps(curTab);
            curTabHeaderDetails.viewtype = tabHeaderDetails.viewtype;
        }
        ZRSHomeHandler.updateHomePagePropsToLocal();
        ZDBToolTip.hide();
        ZRSHomeHandler.selectTab();
    };
    this.constructTemplateDomsForAllViews = function () {
        var placeHolder = ZRSHomeHandler.placeHolder;
        var section = placeHolder.querySelector('section');//NO I18N
        ZRSHomeHandler.constructTemplateDomForDatabaseList(placeHolder, section);
        ZRSHomeHandler.constructTemplateDomForDatabaseGrid(placeHolder, section);
        ZRSHomeHandler.constructTemplateDomForRecentItemList(placeHolder, section);
        ZRSHomeHandler.constructTemplateDomForRecentItemGrid(placeHolder, section);
        ZRSHomeHandler.constructTemplateDomForDashboardList(placeHolder, section);
        ZRSHomeHandler.constructTemplateDomForDashboardGrid(placeHolder, section);
    };
    this.constructTemplateDomForDatabaseList = function (placeHolder, section) {
        var listHeadEl = ZDBUtil.templateCreator('_homeListHeaderStruct', true); //NO I18N
        ZDBUtil.setNamedChildEls(listHeadEl, listHeadEl, null, null, null, true);
        listHeadEl.dbName.innerHTML = ZDBI18NMap.g('zrpt.common.js.dbname');
        listHeadEl.createdOn.innerHTML = ZDBI18NMap.f('zrpt.common.js.createdon', '');
        var ul = ZRSHomeHandler.createULEl('list-data'); //NO I18N
        ZRSHomeHandler.createLiForDatabases('list', 20, ul);//NO I18N
        var separator = document.createElement('div');
        separator.className = 'ZRSMenuSeparator';
        listHeadEl.appendChild(separator);
        listHeadEl.appendChild(ul);
        ul.addEventListener('scroll', ZRSHomeHandler.commonScrollHandler);
        placeHolder.insertBefore(listHeadEl, section);
    };
    this.constructTemplateDomForDatabaseGrid = function (placeHolder, section) {
        var div = document.createElement('div');
        div.setAttribute('elname', 'databases-grid');
        div.className = 'tab1-grid';
        var ul = ZRSHomeHandler.createULEl('grid'); //NO I18N
        ZRSHomeHandler.createLiForDatabases('grid', 20, ul);//NO I18N
        ul.addEventListener('click', ZRSHomeHandler.openView, false);
        div.appendChild(ul);
        ul.addEventListener('scroll', ZRSHomeHandler.commonScrollHandler);
        placeHolder.insertBefore(div, section);
    };
    this.constructTemplateDomForRecentItemList = function (placeHolder, section) {
        var listHeadEl = ZDBUtil.templateCreator('_homeListHeaderStruct1', true); //NO I18N
        ZDBUtil.setNamedChildEls(listHeadEl, listHeadEl, null, null, null, true);
        listHeadEl.viewName.innerHTML = ZDBI18NMap.g('zrpt.common.js.viewname');
        listHeadEl.dbName.innerHTML = ZDBI18NMap.g('zrpt.common.js.dbname');
        listHeadEl.lastModified.innerHTML = ZDBI18NMap.g('zrpt.homepage.js.lastAccessed');
        var ul = ZRSHomeHandler.createULEl('list-data'); //NO I18N
        ZRSHomeHandler.createLiForRecentItems('list', 20, ul);//NO I18N
        var separator = document.createElement('div');
        separator.className = 'ZRSMenuSeparator';
        listHeadEl.appendChild(separator);
        listHeadEl.appendChild(ul);
        ul.addEventListener('scroll', ZRSHomeHandler.commonScrollHandler);
        placeHolder.insertBefore(listHeadEl, section);
    };
    this.constructTemplateDomForRecentItemGrid = function (placeHolder, section) {
        var div = document.createElement('DIV');
        div.setAttribute('elname', 'recentitems-grid');
        div.className = 'tab3-grid';
        var ul = ZRSHomeHandler.createULEl('grid'); //NO I18N
        ZRSHomeHandler.createLiForRecentItems('grid', 20, ul);//NO I18N
        ul.addEventListener('click', ZRSHomeHandler.openView, false);
        div.appendChild(ul);
        ul.addEventListener('scroll', ZRSHomeHandler.commonScrollHandler);
        placeHolder.insertBefore(div, section);
    };
    this.constructTemplateDomForDashboardList = function (placeHolder, section) {
        var listHeadEl = ZDBUtil.templateCreator('_homeListHeaderStruct1', true); //NO I18N
        listHeadEl.setAttribute('elname', 'dashboards-list');
        ZDBUtil.setNamedChildEls(listHeadEl, listHeadEl, null, null, null, true);
        listHeadEl.className = 'tab2-list';
        listHeadEl.viewName.innerHTML = ZDBI18NMap.g('zrpt.common.js.dashboardname');
        listHeadEl.dbName.innerHTML = ZDBI18NMap.g('zrpt.common.js.dbname');
        listHeadEl.lastModified.innerHTML = ZDBI18NMap.g('zrpt.explorer.js.last_modified');
        var ul = ZRSHomeHandler.createULEl('list-data'); //NO I18N
        ZRSHomeHandler.createLiForDashboards('list', 20, ul);//NO I18N
        var separator = document.createElement('div');
        separator.className = 'ZRSMenuSeparator';
        listHeadEl.appendChild(separator);
        listHeadEl.appendChild(ul);
        ul.addEventListener('scroll', ZRSHomeHandler.commonScrollHandler);
        placeHolder.insertBefore(listHeadEl, section);
    };
    this.constructTemplateDomForDashboardGrid = function (placeHolder, section) {
        var div = document.createElement('DIV');
        div.setAttribute('elname', 'dashboards-grid');
        div.className = 'tab2-grid';
        var ul = ZRSHomeHandler.createULEl('grid'); //NO I18N
        ZRSHomeHandler.createLiForDashboards('grid', 20, ul);//NO I18N
        ul.addEventListener('click', ZRSHomeHandler.openView, false);
        div.appendChild(ul);
        ul.addEventListener('scroll', ZRSHomeHandler.commonScrollHandler);
        placeHolder.insertBefore(div, section);
    };
    this.constructGridView = function () {
        var gridTemp = ZDBUtil.templateCreator('_cardViewTemp'); //NO I18N
        ZDBUtil.addClass(gridTemp.checkbox, 'hide');
        return gridTemp;
    };
    this.createULEl = function (elname) {
        var ul = document.createElement('ul');
        ul.setAttribute('elname', elname);
        return ul;
    };
    this.showImportOpts = function () {
        if (!ZDBLazyLoadUtil.loadJsAlone("ZRSImport_NEW", "APPENDTODOC", ZRSHomeHandler.showImportOpts)) {
            return;
        }
        if (!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_HOME_IMPORT_NEW", "APPENDTODOC", ZRSHomeHandler.showImportOpts)) {
            return;
        }
        var createOptHolder = $('ZRSDBCreateOptsHldr');
        $('ZRSHome-body').style.display = 'none';
        createOptHolder.style.display = '';
        var importOpts = $('ZDBDBOptsDiv').childNodes;
        if (importOpts && importOpts.length > 0) {
            this.animateImport(displayedImportOpts);
            return;
        }
        var searchData = {
            srchCallBack: ZRSHomeHandler.searchImportOpts,
            clearCallBack: ZRSHomeHandler.clearImportOpts
        }
        var srchComp = ZRSSearchComponent.standardSearchComp(searchData);
        var srchHolder = ZDBUtil.getElWithTagNAttrWithVal(createOptHolder, "elname", "searchHolder", "div");//No I18N
        srchHolder.appendChild(srchComp);
        ZRSHomeUtil.createDBOpts(enabledConnectors);
        ZRSHomeHandler.showHideImportOpts("");
    };
    this.closeImportOpts = function () {
        $('ZRSHome-body').style.display = '';
        $('ZRSDBCreateOptsHldr').style.display = 'none';
    };
    this.hideImportBackButton = function () {
        var impBackBtn = document.getElementsByClassName('ZRSImportBack'); //NO I18N
        ZDBUtil.addClass(impBackBtn[0], 'ZRSHide');
    };
    this.getKeyForJSONValue = function (jsonData, value) {
        for (var key in jsonData) {
            if (jsonData.hasOwnProperty(key) && jsonData[key] == value) {
                return key;
            }
        }
    };
    this.searchImportOpts = function (value) {
        ZRSHomeHandler.selectDefaultTag();
        ZRSHomeHandler.showHideImportOpts(value);
    };
    this.clearImportOpts = function () {
        ZRSHomeHandler.selectDefaultTag();
        ZRSHomeHandler.showHideImportOpts('');
    };
    this.showHideImportOpts = function (searchVal) {
        var importOptsContainer = $('ZDBDBOptsDiv');
        displayedImportOpts = [];
        for (var conn in enabledConnectors) {
            var importOpt = ZDBUtil.getElWithTagNAttrWithVal(importOptsContainer, 'id', conn, 'li'); //NO I18N
            var showImportOpts = (searchVal.trim() === '') ? true : false;
            if (!showImportOpts) {
                var taglist = ZRSHomeUtil.importOptions[conn]['TAGS'];
                for (var i = 0; i < taglist.length; i++) {
                    var tagVal = ZDBI18NMap.g(taglist[i]).toLowerCase();
                    if (tagVal.indexOf(searchVal.toLowerCase()) > -1) {
                        showImportOpts = true;
                        break;
                    }
                }
            }
            if (!showImportOpts)
            {
                importOpt.style.transform = "scale(.5) translate(0px,0px)"; //No I18N
                importOpt.style.opacity = "0";
                importOpt.style.visibility = 'hidden';
            } else
            {
                displayedImportOpts.push(importOpt);
            }
        }
        var noMatchDiv = DOMUtils.getChildElsWithAttr(importOptsContainer.parentNode, 'elname', 'nomatchdiv')[0];//NO I18N
        if (displayedImportOpts.length === 0) {
            ZDBUtil.removeClass(noMatchDiv, 'hide');
        } else {
            ZDBUtil.addClass(noMatchDiv, 'hide');
        }
        this.animateImport(displayedImportOpts);
    };
    this.filterImportOpts = function (el, tagValue) {
        if (tagValue || tagValue === '') {
            //tagValue is undefined for clear search
            var selectedTagClass = el.getAttribute('tag');
            el.parentNode.className = 'ZRSImport-tags-holder ' + selectedTagClass;
        } else {
            tagValue = '';
        }
        ZRSHomeHandler.showHideImportOpts(tagValue);
    };

// To Animate Import Page Based on Browser Width (Refer Media Queries For Width)

    this.animateImport = function ()
    {
        var browserWidth = window.innerWidth;
        var additionalWidth = (browserWidth < 1090) ? 25 : 55; // Padding N Scrollbar Width
        var maxImportOptsCount = 8;
        importOptsCount = Math.floor((browserWidth - additionalWidth) / 207);
        importOptsCount = (importOptsCount > 8) ? maxImportOptsCount : importOptsCount;
        for (var count = 0; count < displayedImportOpts.length; count++)
        {
            var row = Math.floor(count / importOptsCount);
            var col = Math.floor(count - (row * importOptsCount));
            var xValue = col * 207; //Width
            var yValue = row * 162; //Height
            displayedImportOpts[count].style.visibility = 'visible'; //No I18N
            displayedImportOpts[count].style.transform = "scale(1) translate(" + xValue + "px," + yValue + "px)"; //No I18N
            displayedImportOpts[count].style.opacity = "1"; //No I18N
        }
    };
    this.animateDebounce = function (func)
    {
        var timer;
        return function (event) {
            if (timer)
                clearTimeout(timer);
            timer = setTimeout(func, 250, event);
        };
    };


    this.selectDefaultTag = function () {
        var parentEl = $('ZRSDBCreateOptsHldr').querySelectorAll('.ZRSImport-tags-holder')[0];
        parentEl.className = 'ZRSImport-tags-holder ZRSImport-tag1';
    };
    this.openWindow = function (url) {
        window.location.href = url;
    };
    this.openView = function (event) {
        var elClassName = event.target.className;
        var parEl = DOMUtils.getSelfOrParentWithAttr(event.target, 'dbId'); //NO I18N
        if (parEl && (elClassName === 'cardTitle' || elClassName.indexOf('viewSnap') > -1 || elClassName === 'cardImage')) {
            var dbId = parEl.getAttribute('dbId');
            var url = ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBDataSheetView.cc?DBID=' + dbId; //NO I18N
            var objId = parEl.getAttribute('objId');
            if (objId) {
                url += '&OBJID=' + objId; //NO I18N
            }
            ZRSHomeHandler.openWindow(url);
        } else if (elClassName.indexOf("favTag") >= 0) {
            ZRSHomeHandler.setFavourite(parEl, parEl.getAttribute('dbId'), 'ZRSFav', parEl.favTag);//NO I18N
        } else if (elClassName.indexOf('expOptionMenu') >= 0) {
            ZRSHomeHandler.showMoreOpts(event);
        }
    };
    this.setFavList = function (el) {
        var par = DOMUtils.getElOrParentWithAttr(el, 'dbId');//NO I18N
        ZRSHomeHandler.setFavourite(el, par.getAttribute('dbId'), 'selected', el);//NO I18N
    };

    this.setFavourite = function (el, dbId, className, elToAttachClass) {
        var url = "reportsapi/MARKFAVOURITE";  //No I18N
        for (var i = 0, len = databasesInfo.length; i < len; i++) {
            var curDB = databasesInfo[i];
            if (curDB[3] === dbId) {
                var isFav = curDB[7];
                var params = "DBID=" + dbId + "&ISFAVOURITE=" + !isFav + "&ISDB=true"; //No I18N
                if (!isFav)
                {
                    ZDBUtil.addClass(elToAttachClass, className);
                    ZDBUtil.animateFavIcon(elToAttachClass, "FavFill", 0);
                } else
                {
                    ZDBUtil.animateFavIcon(elToAttachClass, "FavEmpt", 0);
                    var Timeout = setTimeout(function () {
                        ZDBUtil.animateFavIcon(elToAttachClass, "", 0);
                        ZDBUtil.removeClass(elToAttachClass, className);
                    }, 500);
                }
                ZRSAjax.post(url, params, {
                    successHandler: {
                        func: ZRSHomeHandler.favouriteResponseSuccess,
                        ctx: ZRSHomeHandler
                    },
                    failureHandler: {
                        func: ZRSHomeHandler.favouriteResponseFailure,
                        ctx: ZRSHomeHandler
                    },
                    errorHandler: {
                        func: ZRSHomeHandler.favouriteResponseFailure,
                        ctx: ZRSHomeHandler
                    },
                    ISFAVOURITE: !isFav,
                    DBINDEX: i,
                    DBEL: elToAttachClass,
                    CLASSTOATTACH: className,
                    TIMEOUT: Timeout,
                    NAME: curDB[0],
                    noLoader: true
                });
                break;
            }
        }
    };
    this.favouriteResponseSuccess = function (response, requestOptions) {
        var dataJSON = databasesInfo[requestOptions.DBINDEX];
        dataJSON[7] = requestOptions.ISFAVOURITE;
    };
    this.favouriteResponseFailure = function (response, requestOptions) {
        var isFav = requestOptions.ISFAVOURITE;
        var favTag = requestOptions.DBEL;
        var className = requestOptions.CLASSTOATTACH;
        if (isFav)
        {
            ZDBUtil.animateFavIcon(favTag, "FavEmpt", 0);
            setTimeout(function () {
                ZDBUtil.removeClass(favTag, className);
                ZDBUtil.animateFavIcon(favTag, "", 0);
            }, 500);
            ZDBMsgBox.showError(ZDBI18NMap.f('zrpt.common.js.markfavfail', ZDBEscapeUtil.encodeForHtml(requestOptions.NAME)));
        } else
        {
            clearTimeout(requestOptions.TIMEOUT);
            ZDBUtil.addClass(favTag, className);
            ZDBUtil.animateFavIcon(favTag, "FavFill", 0);
            ZDBMsgBox.showError(ZDBI18NMap.f('zrpt.common.js.remfavfail', ZDBEscapeUtil.encodeForHtml(requestOptions.NAME)));
        }
    };

    this.toggleDashboardListFilterMenu = function (el, event) {
        event.stopPropagation();
        var dashboardFilterMenuModel = {menuItems: [
                {
                    text: ZDBI18NMap.g('zrpt.common.js.alldb'),
                    onclickHandler: 'ZRSHomeHandler.handleDBFilterChange(null, "__all__");'//NO I18N
                }
            ]};
        var curShareFilter = (ZROrg.selectedOrgZsoid == '-1') ? 'all' : (ZROrg.selectedOrgZsoid == ZDBGlobal.adminZsoId) ? 'owned' : 'shared';//NO I18N
        var json = ZRSHomeHandler.applyShareFilter(databasesInfo, curShareFilter, ZROrg.selectedOrgZsoid);
        for (var i = 0, len = json.length; i < len; i++) {
            var curDBInfo = json[i];
            dashboardFilterMenuModel.menuItems.push({
                text: ZDBEscapeUtil.encodeForHtml(curDBInfo[0]),
                onclickHandler: 'ZRSHomeHandler.handleDBFilterChange("' + curDBInfo[3] + '","' + curDBInfo[0] + '");'//NO I18N
            });
        }
        ZRSMenu_controller.show('3', dashboardFilterMenuModel, document.body, el, 4, event);
        delete dashboardFilterMenuModel;
    };
    this.handleShareFilterChange = function (selOrg, curSelFilter) {
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        ZRSHomeHandler.resetNavigState();
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        if (tabDispName === 'databases') {
            curSelFilter = curSelFilter ? curSelFilter : (selOrg == -1) ? 'all' : (selOrg == ZDBGlobal.adminZsoId) ? 'owned' : 'shared'; //No I18N
            tabHeaderDetails.dropdown = curSelFilter;
        }
        ZRSHomeHandler.updateHomePagePropsToLocal();
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, tabHeaderDetails.viewtype);
        ZRSHomeHandler.updateWindowHashValue(curSelFilter === 'owned' ? 'MYDBS' : curSelFilter === 'shared' ? 'SHARED' : '');//NO I18N
    };
    this.handleDBFilterChange = function (dbId, dbName) {
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        ZRSHomeHandler.resetNavigState();
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        tabHeaderDetails.dropdown = dbName;
        tabHeaderDetails.dbId = dbId;
        ZRSHomeHandler.updateHomePagePropsToLocal();
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, tabHeaderDetails.viewtype);
    };
    this.toggleFavFilter = function (el) {
        var applyFav = ZRSHomeHandler.getHomeProps('applyFav');//NO I18N
        ZRSHomeHandler.updateHomeProps({'applyFav': !applyFav});//NO I18N
        ZRSHomeHandler.updateHomePagePropsToLocal();
        ZRSHomeHandler.resetNavigState();
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        tabHeaderDetails.fav = !applyFav;
        ZRSHomeHandler.updateHomePagePropsToLocal();
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, tabHeaderDetails.viewtype);
    };
    this.searchListing = function (searchStr) {
        ZRSHomeHandler.searchString = typeof searchStr === 'string' ? searchStr : '';//NO I18N
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, tabHeaderDetails.viewtype);
    };

    this.getSrcLiFromDBID = function (dbId) {
        var placeHolder = ZRSHomeHandler.placeHolder;
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        var tabDiv = placeHolder.querySelector('.' + tabNum + '-' + tabHeaderDetails.viewtype);
        ZDBUtil.setNamedChildEls(tabDiv, tabDiv, null, null, null, true);
        var tabUl = tabDiv[tabHeaderDetails.viewtype === 'list' ? 'list-data' : 'grid'];//NO I18N
        return tabUl.querySelector('li[dbId="' + dbId + '"]');//NO I18N
    };
    this.showRenameDBDialog = function (el) {
        var parEl = DOMUtils.getElOrParentWithAttr(el, 'dbId');//NO I18N
        var dbId = parEl.getAttribute('dbId');
        ZRSHomeHandler.showRenameDB(dbId, el, parEl);
    };

    this.showRenameDB = function (dbId, el, parEl) {
        if (!el) {
            //grid
            el = ZRSHomeHandler.getSrcLiFromDBID(dbId);
            el = el.optionsBtn;
        } else {
            //list
            ZRSHomeHandler.freezeList(parEl);
        }
        var dbInfo = ZRSHomeHandler.getDBInfoFromDBID(dbId);
        var renameDBDlg_dynamicModel = {
            nameText: ZDBI18NMap.g('zrpt.dialoginfo.copyrename.js.dbname'),
            descTxt: ZDBI18NMap.g('zrpt.dialoginfo.copyrename.js.desc'),
            okTxt: ZDBI18NMap.g('zrpt.dialoginfo.js.okbtn'),
            cancelTxt: ZDBI18NMap.g('zrpt.dialoginfo.js.cancelbtn'),
            okHandler: 'ZRSHomeHandler.submitRenameDB()', //NO I18N
            cancelHandler: 'ZDBDialogUtil.closeDialog(this,event);', //NO I18N
            origName: ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[0]),
            origDesc: ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[2]) || ''
        };
        var renameDBHTML = ZRSStringTemplateCreator.createTemplateForDynamicData('renameDBDialog', 'commonDialogs', false, renameDBDlg_dynamicModel);//NO I18N
        ZDBDialogUtil.showDialog(renameDBHTML, {TITLE: ZDBI18NMap.g('zrpt.common.home.js.renamedb'), ADDFRAME: true, MODAL: true, DONTREMOVE: false,
            ONENTER: ZRSHomeHandler.submitRenameDB, ORIGNAME: dbInfo[0], ORIGDESC: dbInfo[2], DBID: dbId,
            CALLOUT: true, SRCEL: el, PAREL: parEl, ONCLOSE: ZRSHomeHandler.unfreezeListFromDialog
        });
    }

    this.submitRenameDB = function () {
        var dlg = ZDBDialogUtil.focusDialog;
        var origName = dlg.params["ORIGNAME"];
        var origDesc = dlg.params["ORIGDESC"];
        var curName = dlg.querySelector('input[elname="name"]').value;//NO I18N
        var curDesc = dlg.querySelector('textarea[elname="desc"]').value;//NO I18N
        curName = curName.replace(/\u00a0/g, " ");
        if (origName === curName && origDesc === curDesc)
        {
            ZDBDialogUtil.closeDialog();
            return;
        }
        var action = "EDITDBDETAILS"; //NO I18N
        if (origName === curName)
        {
            action = "EDITDBDESC"; //NO I18N
        }
        var url = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?"; //NO I18N
        var params = "&ZDBACTION=" + action + "&DBNAME=" + encodeURIComponent(curName) + //NO I18N
                "&DESC=" + encodeURIComponent(curDesc) + "&DBID=" + dlg.params["DBID"]; //NO I18N
        AjaxAPI.sendRequest({URL: url, PARAMETERS: params, ONSUCCESSFUNC: ZRSHomeHandler.handleRenameDBSuccess,
            ONFAILUREFUNC: ZRSHomeHandler.handleRenameDBFailure, OPSTATUSID: dlg.querySelector('[elname="loader"]'), //NO I18N
            DBID: dlg.params["DBID"]});
    };

    this.handleRenameDBSuccess = function (response, requestOptions) {
        var dbId = requestOptions.DBID;
        var dbInfo = ZRSHomeHandler.getDBInfoFromDBID(dbId);
        var params = response.getResponseParams();
        dbInfo[0] = params.DBNAME;
        dbInfo[2] = params.DESC;
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, tabHeaderDetails.viewtype);
        ZRSHomeHandler.unfreezeListFromDialog(ZDBDialogUtil.focusDialog);
        ZDBMsgBox.showSuccess(ZDBI18NMap.f('zrpt.common.js.successfulrename', ZDBI18NMap.g('zrpt.common.js.database')));
    };

    this.handleRenameDBFailure = function (response, requestOptions) {
        var errCode = response.getResponsePart("ERRORCODE");
        errCode = trimAll(errCode);
        if (errCode === "META_DBNAME_DUPLICATE")
        {
            var dlg = ZDBDialogUtil.focusDialog;
            showCustomMessage(response.getResponsePart("STATUS_MESSAGE"), dlg.querySelector('input[elname="name"]'));//NO I18N
            dlg.querySelector('input[elname="name"]').select();//NO I18N
        } else
        {
            ZRSHomeHandler.unfreezeListFromDialog(ZDBDialogUtil.focusDialog);
            AjaxAPI.onFailureFunc(response, requestOptions);
        }
    };

    this.showDeleteDBConfirmation = function (el) {
        var parLi = DOMUtils.getParentWithAttr(el, "dbid");
        var dbId = parLi.getAttribute("dbid");
        ZRSHomeHandler.showDeleteDB(dbId, el, parLi);
    };

    this.showDeleteDB = function (dbId, el, parLi) {
        if (!el) {
            //grid
            el = ZRSHomeHandler.getSrcLiFromDBID(dbId);
            el = el.optionsBtn;
        } else {
            //list
            ZRSHomeHandler.freezeList(parLi);
        }
        var dbInfo = ZRSHomeHandler.getDBInfoFromDBID(dbId);
        var dbName = dbInfo[0];

        ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.home.errmsg.js.del_db", ZDBEscapeUtil.encodeForHtml(dbName)), "ZDBYESNO", //NO I18N
                {ONCLICK: ZRSHomeHandler.submitTrashDB, DBID: dbId, CALLOUT: true, SRCEL: el, PAREL: parLi});
    };

    this.submitTrashDB = function (clickType, requestOptions) {
        if (clickType === "NO") {
            ZRSHomeHandler.unfreezeList(requestOptions.PAREL);
            return;
        }
        var dbId = requestOptions.DBID;
        var url = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma";    //NO I18N
        AjaxAPI.sendRequest({URL: url, PARAMETERS: "ZDBACTION=MOVEDBTOTRASH&DBID=" + dbId, PAREL: requestOptions.PAREL,
            ONSUCCESSFUNC: ZRSHomeHandler.handleTrashDBSuccess, ONFAILUREFUNC: ZRSHomeHandler.handleTrashDBFailure, DBID: dbId, ACTION: "MOVEDBTOTRASH"});  //NO I18N
    };

    this.handleTrashDBFailure = function (response, requestOptions) {
        ZRSHomeHandler.unfreezeList(requestOptions.PAREL);
        ZDBAlertAPI.showErrorMsg(response.getResponsePart("STATUS_MESSAGE"));
    };

    this.handleTrashDBSuccess = function (response, requestOptions) {
        for (var i = 0, len = databasesInfo.length; i < len; i++) {
            var curDB = databasesInfo[i];
            if (curDB[3] === requestOptions.DBID) {
                databasesInfo.splice(i, 1);
                break;
            }
        }
        ZRSHomeHandler.unfreezeList(requestOptions.PAREL);
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, tabHeaderDetails.viewtype);
    };

    this.showCopyDBDialog = function (dbId, event) {
        var dbInfo = ZRSHomeHandler.getDBInfoFromDBID(dbId);
        var parEl = ZRSHomeHandler.getSrcLiFromDBID(dbId);
        var src = ZRSMenu_controller.shownMenuSrc;
        var renameDBDlg_dynamicModel = {
            nameText: ZDBI18NMap.g('zrpt.dialoginfo.copyrename.js.dbname'),
            descTxt: ZDBI18NMap.g('zrpt.dialoginfo.copyrename.js.desc'),
            okTxt: ZDBI18NMap.g('zrpt.dialoginfo.js.okbtn'),
            cancelTxt: ZDBI18NMap.g('zrpt.dialoginfo.js.cancelbtn'),
            okHandler: 'ZRSHomeHandler.submitCopyDB()', //NO I18N
            cancelHandler: 'ZDBDialogUtil.closeDialog(this,event);', //NO I18N
            origName: ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[0]) + ' - ' + ZDBI18NMap.g('zrpt.dialoginfo.copyrename.js.copy'),
            origDesc: ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[2]) || '',
            copyDB: {
                condition: !dbInfo[9],
                data: {
                    copyWithDataText: ZDBI18NMap.g('zrpt.dialoginfo.copyrename.js.copywithdata')
                }
            }
        };
        var renameDBHTML = ZRSStringTemplateCreator.createTemplateForDynamicData('renameDBDialog', 'commonDialogs', false, renameDBDlg_dynamicModel);//NO I18N
        ZRSMenu_controller.closeOpenedMenus(event);
        ZRSHomeHandler.freezeList(parEl);
        ZDBDialogUtil.showDialog(renameDBHTML, {TITLE: ZDBI18NMap.g('zrpt.homepage.db.copydb.js.dlgTtl'), ADDFRAME: true, MODAL: true, DONTREMOVE: false,
            ONENTER: ZRSHomeHandler.submitCopyDB, ORIGNAME: dbInfo[0], ORIGDESC: dbInfo[2], DBID: dbId, PAREL: parEl, ONCLOSE: ZRSHomeHandler.unfreezeListFromDialog, CALLOUT: true, SRCEL: src
        });
    };

    this.submitCopyDB = function () {
        var dlg = ZDBDialogUtil.focusDialog;
        var curName = dlg.querySelector('input[elname="name"]').value;//NO I18N
        var curDesc = dlg.querySelector('textarea[elname="desc"]').value;//NO I18N
        var copyDataCB = dlg.querySelector('input[elname="copyDB"]');//NO I18N
        var url = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma";    //NO I18N
        var params = "ZDBACTION=COPYDATABASE&DBNAME=" + encodeURIComponent(curName) + "&DESCRIPTION=" + encodeURIComponent(curDesc) + //NO I18N
                "&DBTOCOPY=" + dlg.params["DBID"];  //NO I18N
        if (copyDataCB && copyDataCB.checked === true)
        {
            params += "&COPYDATA=true"; //NO I18N
        } else
        {
            params += "&COPYDATA=false";    //NO I18N
        }
        AjaxAPI.sendRequest({URL: url, PARAMETERS: params, ONSUCCESSFUNC: ZRSHomeHandler.handleCopyDBSuccess,
            OPSTATUSID: dlg.querySelector('[elname="loader"]')   //NO I18N
        });
    };

    this.handleCopyDBSuccess = function () {
        ZRSHomeHandler.getHomePageData(ZRSHomeHandler.refreshDBList, ZRSHomeHandler, 'ZDBMainLoader');//NO I18N
        ZRSHomeHandler.unfreezeListFromDialog(ZDBDialogUtil.focusDialog);
        ZDBMsgBox.showSuccess(ZDBI18NMap.g('zrpt.common.js.copysuccess'));
    };

    this.refreshDBList = function (dbList) {
        ZRSHomeHandler.updateData(dbList);
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');//NO I18N
        var tabHeaderDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updatePlaceHolder(tabHeaderDetails, tabNum, tabHeaderDetails.viewtype);
    };

    this.getBackupDBDialog = function (dbId) {
        ZDBLazyLoadUtil.loadJsAlone(["backup/js/ZDBBackupUtil.js"]);//NO I18N
        var parEl = ZRSHomeHandler.getSrcLiFromDBID(dbId);
        var src = ZRSMenu_controller.shownMenuSrc;
        ZRSAjax.get('/reportsapi/DBBACKUPINFO', 'DBID=' + dbId, {
            successHandler: {
                func: ZRSHomeHandler.showBackupDBDialog,
                ctx: ZRSHomeHandler
            },
            DBID: dbId,
            PAREL: parEl,
            SRCEL: src
        });
    };

    this.showBackupDBDialog = function (resp, config) {
        if (!ZDBLazyLoadUtil.loadJsAlone(["backup/js/ZDBBackupUtil.js"], "APPENDTODOC", ZRSHomeHandler.showBackupDBDialog, [resp, config])) {
            return;
        }
        if (resp.DONTSHOWBACKUP === "true") {
            var msg = resp.DONTSHOWBACKUPMSG;
            var arr = msg.split(';');
            if (arr[1] !== null)
            {
                var upgradeTabLink = ZDBGlobal.upgradeLink;
                if (ZDBGlobal.IS_ONPREMISE_BUILD && ZDBGlobal.IS_FREE_EDITION)
                {
                    var compareTabLink = ZDBI18NMap.g("zrop.license.compare.js.editions");
                    arr[1] = '<a href="' + compareTabLink + '" target="_blank"">' + arr[1] + '</a>';
                } else
                {
                    arr[1] = '<a href="' + upgradeTabLink + '">' + arr[1] + '</a>';
                }
                msg = arr.join("");
            }
            StatusMsgAPI.showErrorMsg(msg);
            return;
        }
        var disableScheduleDisp = '';
        var backupURLsDivDisp = true;

        var periodicUnit = calendarFreq = calendarTime = calendarDay = calendarDate = "Not Applicable";//NO I18N
        if (!resp.hasOwnProperty("SCHEDULEINFO")) {
            disableScheduleDisp = 'none';//NO I18N
        } else {
            periodicUnit = resp.SCHEDULEINFO.PERIODIC_UNIT;
            calendarFreq = resp.SCHEDULEINFO.CALENDAR_FREQ;
            calendarTime = resp.SCHEDULEINFO.CALENDAR_TIME;
            calendarDay = resp.SCHEDULEINFO.CALENDAR_DAY;
            calendarDate = resp.SCHEDULEINFO.CALENDAR_DATE;
        }
        if (!resp.hasOwnProperty("BACKUP_URLS")) {
            backupURLsDivDisp = false;
        }
        //ignorei18n_start
        var defModel = ZRSCommonDialogs_Model.getBackupDefaultData();
        var hrsSelectBoxOptionData = [
            {"value": "0", "i18nValue": "00"}, {"value": "1", "i18nValue": "01"},
            {"value": "2", "i18nValue": "02"}, {"value": "3", "i18nValue": "03"},
            {"value": "4", "i18nValue": "04"}, {"value": "5", "i18nValue": "05"},
            {"value": "6", "i18nValue": "06"}, {"value": "7", "i18nValue": "07"},
            {"value": "8", "i18nValue": "08"}, {"value": "9", "i18nValue": "09"},
            {"value": "10", "i18nValue": "10"}, {"value": "11", "i18nValue": "11"},
            {"value": "12", "i18nValue": "12"}, {"value": "13", "i18nValue": "13"},
            {"value": "14", "i18nValue": "14"}, {"value": "15", "i18nValue": "15"},
            {"value": "16", "i18nValue": "16"}, {"value": "17", "i18nValue": "17"},
            {"value": "18", "i18nValue": "18"}, {"value": "19", "i18nValue": "19"},
            {"value": "20", "i18nValue": "20"}, {"value": "21", "i18nValue": "21"},
            {"value": "22", "i18nValue": "22"}, {"value": "23", "i18nValue": "23"}
        ];
        var minSelectBoxOptionData = [
            {"value": "0", "i18nValue": "00"}, {"value": "5", "i18nValue": "05"},
            {"value": "10", "i18nValue": "10"}, {"value": "15", "i18nValue": "15"},
            {"value": "20", "i18nValue": "20"}, {"value": "25", "i18nValue": "25"},
            {"value": "30", "i18nValue": "30"}, {"value": "35", "i18nValue": "35"},
            {"value": "40", "i18nValue": "40"}, {"value": "45", "i18nValue": "45"},
            {"value": "50", "i18nValue": "50"}, {"value": "55", "i18nValue": "55"}
        ];
        var daily_hrsSelectBoxString = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'ZDB_DLY_HRS_INT',
            optionsData: hrsSelectBoxOptionData
        });
        var weekly_hrsSelectBoxString = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'ZDB_WLY_HRS_INT',
            optionsData: hrsSelectBoxOptionData
        });
        var monthly_hrsSelectBoxString = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'ZDB_MLY_HRS_INT',
            optionsData: hrsSelectBoxOptionData
        });
        var daily_minSelectBoxString = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'ZDB_DLY_MINS_INT',
            optionsData: minSelectBoxOptionData
        });
        var weekly_minSelectBoxString = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'ZDB_WLY_MINS_INT',
            optionsData: minSelectBoxOptionData
        });
        var monthly_minSelectBoxString = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'ZDB_MLY_MINS_INT',
            optionsData: minSelectBoxOptionData
        });
        var weekIntervalSelectBoxString = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'weeklyinterval',
            optionsData: [
                {"value": "1", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.sunday")},
                {"value": "2", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.monday")},
                {"value": "3", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.tuesday")},
                {"value": "4", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.wednesday")},
                {"value": "5", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.thursday")},
                {"value": "6", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.friday")},
                {"value": "7", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.weeklyinterval.js.saturday")}
            ]
        });
        var monthDaySelectBoxString = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'monthlyinterval',
            optionsData: [
                {"value": "1", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.1")}, {"value": "2", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.2")},
                {"value": "3", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.3")}, {"value": "4", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.4")},
                {"value": "5", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.5")}, {"value": "6", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.6")},
                {"value": "7", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.7")}, {"value": "8", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.8")},
                {"value": "9", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.9")}, {"value": "10", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.10")},
                {"value": "11", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.11")}, {"value": "12", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.12")},
                {"value": "13", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.13")}, {"value": "14", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.14")},
                {"value": "15", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.15")}, {"value": "16", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.16")},
                {"value": "17", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.17")}, {"value": "18", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.18")},
                {"value": "19", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.19")}, {"value": "20", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.20")},
                {"value": "21", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.21")}, {"value": "22", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.22")},
                {"value": "23", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.23")}, {"value": "24", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.24")},
                {"value": "25", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.25")}, {"value": "26", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.26")},
                {"value": "27", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.27")}, {"value": "28", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.28")},
                {"value": "29", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.29")}, {"value": "30", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.30")},
                {"value": "31", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.31")}, {"value": "99", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.monthlyinterval.js.last")}
            ]
        });
        defModel.showDisableCheck = disableScheduleDisp;
        defModel.repeatSelectBox = ZRSStringTemplateCreator.createTemplateForDynamicData('selectBox', 'commonComponents', true, {
            selectBoxId: 'repeatinterval',
            optionsData: [
                {"value": "none", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.backup.js.notscheduled")},
                {"value": "daily", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.backup.js.everyday")},
                {"value": "weekly", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.backup.js.weeklyonce")},
                {"value": "monthly", "i18nValue": ZDBI18NMap.g("zrpt.dialoginfo.backup.js.monthlyonce")}
            ]
        });
        defModel.daily_hrsSelectBox = daily_hrsSelectBoxString;
        defModel.daily_minSelectBox = daily_minSelectBoxString;
        defModel.weekly_hrsSelectBox = weekly_hrsSelectBoxString;
        defModel.weekly_minSelectBox = weekly_minSelectBoxString;
        defModel.monthly_hrsSelectBox = monthly_hrsSelectBoxString;
        defModel.monthly_minSelectBox = monthly_minSelectBoxString;
        defModel.userTimezoneText = ZDBI18NMap.f("zrop.dialoginfo.backup.js.usertimezone", ZDBGlobal.TimeZone);
        defModel.weekIntervalSelectBox = weekIntervalSelectBoxString;
        defModel.monthDaySelectBox = monthDaySelectBoxString;
        if (backupURLsDivDisp) {
            var urls = json.BACKUP_URLS;
            var urlsSize = json.BACKUP_URL_LENGTH;
            defModel.backupURL = [];
            for (var i = 0; i < urlsSize; i++) {
                var key = "DB" + (i + 1);
                var value = urls[key];
                if (value.LATEST) {
                    defModel.latestBackupURL = {
                        condition: backupURLsDivDisp,
                        data: {
                            url: value.URL,
                            createdTime: value.CREATEDDATE,
                            latestbackupText: ZDBI18NMap.g("zrpt.dialoginfo.backup.js.latestbackup")
                        }
                    };
                } else {
                    defModel.backupURL.push({
                        url: value.URL,
                        createdTime: value.CREATEDDATE
                    });
                }
            }
            defModel.noBackupURL = {
                condition: false
            };
        } else {
            defModel.latestBackupURL = {
                condition: false
            };
            defModel.backupURL = [];
            defModel.noBackupURL = {
                condition: true,
                data: {
                    noBackupText: ZDBI18NMap.g("zrpt.dialoginfo.backup.js.nobackupavailable")
                }
            };
        }
        defModel.backupSaveHandler = 'ZRSHomeHandler.handleBackupSave(this, "' + config.DBID + '")';
        defModel.closeBackupHandler = 'ZDBDialogUtil.closeDialog();';
        defModel.periodicUnit = periodicUnit;
        defModel.calenderFreq = calendarFreq;
        defModel.calendarTime = calendarTime;
        defModel.calendarDay = calendarDay;
        defModel.calendarDate = calendarDate;
        //ignorei18n_end
        var backupDlg = ZRSStringTemplateCreator.createTemplateForDynamicData('backupDBDialog', 'commonDialogs', false, defModel);//NO I18N
        ZDBUtil.addClass(config.PAREL, 'liselected');
        ZDBDialogUtil.showDialog(backupDlg, {TITLE: ZDBI18NMap.g("zrpt.common.pricing.backup.js.bkp_setting"),
            DESC: ZDBI18NMap.g("zrpt.common.pricing.backup.js.desc"), ADDFRAME: true, ONCLOSE: ZRSHomeHandler.unfreezeListFromDialog,
            MODAL: true, DONTREMOVE: false, CALLOUT: true, SRCEL: config.SRCEL, PAREL: config.PAREL});
        ZDBBackupUtil.setUserSettings();
        document.getElementById('repeatinterval').onchange = function (event) {
            var el = event.target;
            ZDBBackupUtil.toggleSchedulePeriod(el.options[el.options.selectedIndex].value, true);
        };
    };

    this.handleBackupSave = function (el, dbId) {
        ZDBBackupUtil.setBackupSchedule(el, dbId);
    };

    this.showMoreActionsMenu = function (el, event) {
        event.stopPropagation();
        ZDBToolTip.hide(event, true);
        var parWithDBID = DOMUtils.getElOrParentWithAttr(el, 'dbId');//NO I18N
        var dbId = parWithDBID.getAttribute('dbId');
        var moreActionModel = {
            menuItems: [
                {
                    text: ZDBI18NMap.g('zrpt.homepage.db.copydb.js.dlgTtl'),
                    onclickHandler: 'ZRSHomeHandler.showCopyDBDialog("' + dbId + '", event);'//NO I18N
                },
                {
                    text: ZDBI18NMap.g('zrpt.title.backupdb.tip.js.title'),
                    onclickHandler: 'ZRSHomeHandler.getBackupDBDialog("' + dbId + '", event);'//NO I18N
                }
            ]
        };
//        var dbInfo = ZRSHomeHandler.getDBInfoFromDBID(dbId);
//        if(dbInfo[1]){
//            moreActionModel.menuItems.push({
//                text: ZDBI18NMap.g('zrpt.title.undef.js.title'),
//                onclickHandler: 'ZRSHomeHandler.markAsDefaultDB("'+dbId+'", event, false, "'+ ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[0])+'");'//NO I18N
//            });
//        }
//        else{
//            moreActionModel.menuItems.push({
//                text: ZDBI18NMap.g('zrpt.title.def.js.title'),
//                onclickHandler: 'ZRSHomeHandler.markAsDefaultDB("'+dbId+'", event, true, "'+ ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[0])+'");'//NO I18N
//            });
//        }

        ZRSHomeHandler.freezeList(parWithDBID);
        ZRSMenu_controller.show('2', moreActionModel, document.body, el, 2, event, ZRSHomeHandler.unfreezeList, [parWithDBID], ZRSHomeHandler);
        delete moreActionModel;
    };
    this.freezeList = function (li) {
        ZDBUtil.addClass(li, 'liselected');
    };
    this.unfreezeList = function (li) {
        ZDBUtil.removeClass(li, 'liselected');
    };
    this.unfreezeListFromDialog = function (dlg) {
        ZRSHomeHandler.unfreezeList(dlg.params.PAREL);
        dlg.params.ONCLOSE = null;
        ZDBDialogUtil.closeDialog();
    };
    this.showMoreOpts = function (event) {
        event.stopPropagation();
        var el = event.target;
        var parWithDBID = DOMUtils.getElOrParentWithAttr(el, 'dbId');//NO I18N
        var dbId = parWithDBID.getAttribute('dbId');
        var dbInfo = ZRSHomeHandler.getDBInfoFromDBID(dbId);
        var dbMoreOpts = {};
        if (dbInfo[6] === ZDBGlobal.zuID) {
            dbMoreOpts.menuItems = [
                {
                    text: ZDBI18NMap.g('zrpt.dashboard.js.duplicate'),
                    onclickHandler: 'ZRSHomeHandler.showCopyDBDialog("' + dbId + '", event);'//NO I18N
                },
                {
                    text: ZDBI18NMap.g('zrpt.common.js.rename'),
                    onclickHandler: 'ZRSHomeHandler.showRenameDB("' + dbId + '");'//NO I18N
                },
                {
                    text: ZDBI18NMap.g('zrpt.common.emailsch.js.delete'),
                    onclickHandler: 'ZRSHomeHandler.showDeleteDB("' + dbId + '");'//NO I18N
                },
                {
                    text: ZDBI18NMap.g('zrpt.dbsettings.sideNav.js.backupsettings'),
                    onclickHandler: 'ZRSHomeHandler.getBackupDBDialog("' + dbId + '", event);'//NO I18N
                }
            ];
        }
//            if(dbInfo[1]){
//                dbMoreOpts.menuItems.push({
//                    text: ZDBI18NMap.g('zrpt.title.undef.js.title'),
//                    onclickHandler: 'ZRSHomeHandler.markAsDefaultDB("'+dbId+'", event, false, "'+ ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[0])+'");'//NO I18N
//                });
//            }
//            else{
//                dbMoreOpts.menuItems.push({
//                    text: ZDBI18NMap.g('zrpt.title.def.js.title'),
//                    onclickHandler: 'ZRSHomeHandler.markAsDefaultDB("'+dbId+'", event, true, "'+ ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[0])+'");'//NO I18N
//                });
//            }
//        }else{
//            dbMoreOpts.menuItems = [];
//            if(dbInfo[1]){
//                dbMoreOpts.menuItems.push({
//                    text: ZDBI18NMap.g('zrpt.title.undef.js.title'),
//                    onclickHandler: 'ZRSHomeHandler.markAsDefaultDB("'+dbId+'", event, false, "'+ ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[0])+'");'//NO I18N
//                });
//            }
//            else{
//                dbMoreOpts.menuItems.push({
//                    text: ZDBI18NMap.g('zrpt.title.def.js.title'),
//                    onclickHandler: 'ZRSHomeHandler.markAsDefaultDB("'+dbId+'", event, true, "'+ ZDBEscapeUtil.encodeForHtmlAttr(dbInfo[0])+'");'//NO I18N
//                });
//            }
//        } 
        ZRSMenu_controller.show('2', dbMoreOpts, document.body, event.target, 2, event);
    };

    this.markAsDefaultDB = function (dbId, event, makeDefault, dbName) {
        ZRSAjax.post('/reportsapi/MAKEDBDEFAULT', 'DBID=' + dbId + '&ISADDDEFAULTDB=' + makeDefault, {//NO I18N
            successHandler: {
                func: ZRSHomeHandler.markDefDBSucc,
                ctx: ZRSHomeHandler
            },
            dbId: dbId,
            dbName: dbName,
            makeDef: makeDefault
        });
    };

    this.markDefDBSucc = function (response, config) {
        if (response.prevDefDB) {
            var preDefDBInfo = this.getDBInfoFromDBID(response.prevDefDB);
            preDefDBInfo[1] = false;
        }

        var curDefDBInfo = this.getDBInfoFromDBID(config.dbId);
        curDefDBInfo[1] = config.makeDef;
        if (config.makeDef) {
            //marked as default db
            ZDBMsgBox.showSuccess(ZDBI18NMap.f('zrpt.common.home.makedefaultdb.js.success', config.dbName));
        } else {
            //removed as default db
            ZDBMsgBox.showSuccess(ZDBI18NMap.f('zrpt.common.home.removedefaultdb.js.success', config.dbName));
        }
    };

    this.getDashboardInfo = function (dashboardTab) {
        if (!this.dashboardRequestSent) {
            ZRSAjax.get('/reportsapi/GETALLDASHBOARDS', null, {
                successHandler: {
                    func: ZRSHomeHandler.handleDashboardResp,
                    ctx: ZRSHomeHandler
                },
                dashboardTab: dashboardTab
            });
            this.dashboardRequestSent = true;
        }
    };

    this.handleDashboardResp = function (response) {
        myDashboards = response.myDashboards.values;
        sharedDashboards = response.sharedDashboards.values;
        this.getDashboardsForOrg();
    };

    this.getDashboardsForOrg = function ()
    {
        if (ZROrg.selectedOrgZsoid == -1) {
            var combinedList = [];
            for (var i = 0, len1 = myDashboards.length; i < len1; i++) {
                combinedList.push(myDashboards[i]);
            }
            for (var j = 0, len2 = sharedDashboards.length; j < len2; j++) {
                combinedList.push(sharedDashboards[j]);
            }
            dashboardsInfo = combinedList;
        } else if (ZROrg.selectedOrgZsoid == ZDBGlobal.adminZsoId) {
            dashboardsInfo = myDashboards;
        } else {
            var sharedList = [];
            for (var i = 0, len = sharedDashboards.length; i < len; i++) {
                var curItem = sharedDashboards[i];
                if (curItem[19] == ZROrg.selectedOrgZsoid) {
                    sharedList.push(curItem);
                }
            }
            dashboardsInfo = sharedList;
        }
        this.selectTab();
    };

    this.autoDatabaseName = function (el) {
        var autoName = ZDBI18NMap.g("zrpt.common.js.database") + " - ";
        var max = 0;
        if (databasesInfo) {
            for (var i = 0; i < databasesInfo.length; i++) {
                var dbName = databasesInfo[i][0];
                var subDbName = dbName.substring(0, 11);
                if (subDbName == autoName) {
                    var int = parseInt(dbName.substring(11));
                    if (!isNaN(int)) {
                        max = max > int ? max : int;
                    }
                }
            }
        }
        $(el).children[1].value = autoName + (max + 1);
    };
    //ignorei18n_start
    this.toggleSortType = function () {
        ZDBToolTip.hide(null, true);
        clearTimeout(ZRSHomeHandler.triggerCardPreviewImageTimer);
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');
        var tabDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        tabDetails.sorttype = tabDetails.sorttype === 'asc' ? 'dsc' : 'asc';
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updateHomePagePropsToLocal();
        ZRSHomeHandler.updatePlaceHolder(tabDetails, tabNum, tabDetails.viewtype);
    };

    this.toggleSortBy = function () {
        ZDBToolTip.hide(null, true);
        clearTimeout(ZRSHomeHandler.triggerCardPreviewImageTimer);
        var tabDispName = ZRSHomeHandler.getHomeProps('selectedtab');
        var tabDetails = ZRSHomeHandler.getHomeProps(tabDispName);
        switch (tabDispName) {
            case 'databases':
                tabDetails.sortcolumn = tabDetails.sortcolumn === 'name' ? 'createdon' : 'name';
                break;
            case 'dashboards':
                tabDetails.sortcolumn = tabDetails.sortcolumn === 'name' ? 'lastmodon' : 'name';
                break;
            case 'recentitems':
                tabDetails.sortcolumn = tabDetails.sortcolumn === 'name' ? 'lastaccess' : 'name';
                break;
        }
        var tabNum = ZRSHomeHandler.getKeyForJSONValue(tabNameInfo, tabDispName);
        ZRSHomeHandler.updateHomePagePropsToLocal();
        ZRSHomeHandler.updatePlaceHolder(tabDetails, tabNum, tabDetails.viewtype);
    };
    //ignorei18n_end
};
