//$Id$
var ZDBLazyLoadUtil = new function()
{
   this.moduleJSURLs={};
   this.moduleCSSURLs={};
   this.moduleSVGImages={};
   this.loadedSnippets = {};
   this.loadedScripts = {};
   this.loadedCss = {};
   this.loadedSVGImages = {};
   this.loadingUrls = {};
   this.sendSnippetRequest=true;
   
   this.loadSnippet= function(snippetName,url,ownerObj,loadOption,jsFileNames,func,args,opStatusId,cssFileNames)
   {
     if(snippetName)
     {
       var snipList = snippetName.split(",");
       var snippetLoaded = (ZDBLazyLoadUtil.checkSnippetsList(snipList) == 0);
     }
     else
     {
       var snippetLoaded = true;
     }
     var jsLoaded = (jsFileNames == null); 
     if(jsFileNames != null)
     {
       jsFileNames = (jsFileNames instanceof Array) ? jsFileNames : jsFileNames.split(',');
       var filesCount = ZDBLazyLoadUtil.checkFileslist(jsFileNames);
       jsLoaded = (filesCount == 0);
     }
     var cssLoaded = (cssFileNames == null);
     if(cssFileNames != null){
       cssFileNames = (cssFileNames instanceof Array) ? cssFileNames : cssFileNames.split(',');
       var filesCount = ZDBLazyLoadUtil.checkCssFileslist(cssFileNames);
       cssLoaded = (filesCount == 0);
     }
     if((snippetLoaded) && (jsLoaded) && (cssLoaded))
     {
      return true;
     }

     if(func == null)
     {
       func =  arguments.callee.caller;
       args = func.arguments;
     }
     if(!args)
     {
       args = [];
     }
     args = LangUtils.cloneArray(args);
     var reqObj = {
       func:func,
       ownerObj:ownerObj,
       args:args,
       snippetName:snippetName,
       snippetUrl:url,
       loadOption:loadOption,
       isJs:true,
       jsFileNames:jsFileNames,
       jsLoaded:jsLoaded,
       opStatusId:opStatusId,
       snippetLoaded:snippetLoaded
     };
     var cssReqObj = {
       ownerObj:ownerObj,
       args:args,
       loadOption:loadOption,
       isCss:true,
       cssFileNames:cssFileNames,
       cssLoaded:cssLoaded,
       opStatusId:opStatusId,
       snippetLoaded:snippetLoaded
     };
     if(!reqObj.jsLoaded)
     {
       var jsUrls = ZDBLazyLoadUtil.getFileURLs(jsFileNames, false, "");
       LazyLoad.js(jsUrls,ZDBLazyLoadUtil.handleResponse,reqObj,false);
     }
     if(!cssLoaded){
       var cssUrls = ZDBLazyLoadUtil.getFileURLs(cssFileNames, false, "", true, cssReqObj);
       LazyLoad.css(cssUrls, ZDBLazyLoadUtil.handleResponse, cssReqObj, false);
     }
     if(!reqObj.snippetLoaded)
     {
       ZDBLazyLoadUtil.fetchSnippet(reqObj,cssReqObj);
     }
     return false;
   }
   
  this.checkFileslist = function(jsFileNames)
  {
    return ZDBLazyLoadUtil.getFilesToLoad(jsFileNames,ZDBLazyLoadUtil.loadedScripts);
  }
  
  this.checkCssFileslist = function(cssFileNames)
  {
    return ZDBLazyLoadUtil.getFilesToLoad(cssFileNames,ZDBLazyLoadUtil.loadedCss);
  }

  this.checkSVGImageFilesList = function(svgFileName){
    return ZDBLazyLoadUtil.getFilesToLoad(svgFileName,ZDBLazyLoadUtil.loadedSVGImages);
  }
  this.getFilesToLoad = function(filesList, loadedURLContainer){
    for(var i=0;i<filesList.length;i++)
    {
      var urlLoaded = loadedURLContainer[filesList[i]] != null;
      if(urlLoaded)
      {
        filesList.splice(i,1);
        i--;
      }
    }
    return filesList.length;
  }
  
  this.checkSnippetsList = function(snipList)
  {
    var loadedSnipList = snipList;
    for(var i=0;i<snipList.length;i++)
    {
      var snippetLoaded = ZDBLazyLoadUtil.loadedSnippets[loadedSnipList[i]];
      if(snippetLoaded)
      {
      loadedSnipList.splice(i,1);
      i--;
      }
    }
    return loadedSnipList.length;
  }

   this.loadJsAlone= function(jsFileNames,ownerObj,func,args,opStatusId,isJsUrl,excludeCrossOrigin)
   {
     jsFileNames = (jsFileNames instanceof Array) ? jsFileNames : jsFileNames.split(',');
     var filesCount = ZDBLazyLoadUtil.checkFileslist(jsFileNames);
     if(filesCount == 0)
     {
       return true;
     }
     
     if(!args)
     {
       args = [];
     }
     var reqObj = {
       func:func,
       ownerObj:ownerObj,
       args:args,
       jsFileNames:jsFileNames,
       isJs:true,
       jsLoaded:false,
       snippetLoaded:true,
       opStatusId:opStatusId};
     var jsUrls = ZDBLazyLoadUtil.getFileURLs(jsFileNames, isJsUrl, "", false, reqObj);
     if(jsUrls.length <= 0){
       setTimeout(function(){ZDBLazyLoadUtil.invokeFunc(reqObj)},500);
       return false;
     }
     LazyLoad.js(jsUrls,ZDBLazyLoadUtil.handleResponse,reqObj,false,excludeCrossOrigin);
     StatusMsgAPI.showOperationStatus(StatusMsgAPI.OPSTATUS.STARTED,reqObj.opStatusId);
   }

   this.getFileURLs = function(fileNames, isUrl, path, isCss, reqObj)
   {
    //Since URL containing double slash leads to error for onpremise, the path is replaced with empty string. */      
    if(path == "/"){
      path="";
    }
    var files = (fileNames instanceof Array) ? fileNames : fileNames.split(',');
    var newFiles = [];
    for(var i = 0, len=files.length; i<len; i++){
      var file = files[i];
      if(ZDBLazyLoadUtil.loadingUrls.hasOwnProperty(file)){
    	  continue;
      }
      else{
        ZDBLazyLoadUtil.loadingUrls[file] = true;
        newFiles.push(file);
      }
    }
    if(isUrl)
    {
      return fileNames;
    }
    var urls = [];
    for(var i = 0; i < newFiles.length; i++)
    {
        var localFile = newFiles[i];      
        var modUrl = (isCss) ? ZDBLazyLoadUtil.moduleCSSURLs[localFile] : ZDBLazyLoadUtil.moduleJSURLs[localFile];
        //removing the below code to make everyone add the individual loaded js files into jslist_all.txt
        if(!modUrl && isCss)
        {
            urls = urls.concat([path  +  localFile]);
        }
        else if(typeof modUrl == 'string')
        {
            urls = urls.concat([path  +  modUrl]);
        }
        else if(typeof modUrl == 'object')
        {
            urls = urls.concat(modUrl);
        }   
        else
        {
            throw new Error("Unexpected Url type " + modUrl + "; file name " + localFile);//No I18N
        }
    }
    ZDBLazyLoadUtil.addVersion(urls);
    return urls;
   }   
   
   this.handleJsAndCssFilePathResp = function(response, requestOptions){
     var script = document.createElement("script");
     script.innerHTML = response.responseText;
     document.getElementsByTagName("body")[0].appendChild(script);
     ZDBLazyLoadUtil.snippetsLoaded = true;
     ZDBLazyLoadUtil.sendSnippetRequest = true;
   }
   
   this.fetchSnippet = function(reqObj, cssReqObj)
   {
//     var toBeLoadedURLs= reqObj.snippetUrl.split(",");
//     for(var i=0, len=toBeLoadedURLs.length; i<len; i++){
//         if(ZDBLazyLoadUtil.loadingUrls.hasOwnProperty(toBeLoadedURLs[i])){
//             toBeLoadedURLs.splice(i, 1);
//         }
//         else{
//             ZDBLazyLoadUtil.loadingUrls[toBeLoadedURLs[i]] = true;
//         }
//     }
//     if(toBeLoadedURLs.length == 0){
//         return;
//     }  
     AjaxAPI.sendRequest({URL:reqObj.snippetUrl,METHOD:"GET",
                                REQOBJ:reqObj,CSSREQOBJ:cssReqObj,
                                OPSTATUSID:reqObj.opStatusId,
                                ONSUCCESSFUNC:ZDBLazyLoadUtil.handleSnippetResp});
   }
   
   this.handleSnippetResp = function(response,requestOptions)
   {
     var reqObj = requestOptions["REQOBJ"];
     var cssReqObj = requestOptions.CSSREQOBJ;
     var loadOpt = reqObj.loadOption;
     var snippetName = reqObj.snippetName;
     if(loadOpt == "APPENDTODOC")
     {
       var div = document.createElement("div");
       div.innerHTML = response.responseText;
       div.style.display="none";
       document.body.appendChild(div);
       if(snippetName)
       {
         var snipList = snippetName.split(",");
         var snipUrlList = reqObj.snippetUrl.split(",");
         for(var i=0;i<snipList.length;i++)
         {
           ZDBLazyLoadUtil.loadedSnippets[snipList[i]] = true;
           delete ZDBLazyLoadUtil.loadingUrls[snipUrlList[i]];
         } 
       }
       else
       {
        ZDBLazyLoadUtil.loadedSnippets[snippetName] = true;
        delete ZDBLazyLoadUtil.loadingUrls[snippetName];
       }
     }
     else
     {
       throw new Error("Unknown loadOption " + loadOpt);
     }
     reqObj.snippetLoaded = true;
     if(reqObj.jsLoaded && cssReqObj.cssLoaded)
     {
       ZDBLazyLoadUtil.invokeFunc(reqObj);
       return StatusMsgAPI.OPSTATUS.FINISHED;
     }
     else
     {
       return StatusMsgAPI.OPSTATUS.INPROGRESS;
     }
   } 

   this.handleResponse = function(reqObj)
   {
     if(reqObj.isJs)
     {
       var fileNames = (reqObj.jsFileNames instanceof Array) ? reqObj.jsFileNames : reqObj.jsFileNames.split(',');
       reqObj.jsLoaded = true;
       for(var i = 0; i < fileNames.length; i++)
       {
         ZDBLazyLoadUtil.loadedScripts[fileNames[i]] = true;
       }
     }
     else if(reqObj.isCss)
     {
       var fileNames = (reqObj.cssFileNames instanceof Array) ? reqObj.cssFileNames : reqObj.cssFileNames.split(',');
       reqObj.cssLoaded = true;
       for(var i = 0; i < fileNames.length; i++)
       {
         ZDBLazyLoadUtil.loadedCss[fileNames[i]] = true;
       }
     }     
     
     if(reqObj.snippetLoaded)
     {
       ZDBLazyLoadUtil.invokeFunc(reqObj);
     }
   }
   
   this.invokeFunc = function(reqObj)
   {
     if(reqObj.finished)
     {
       return;
     }
     reqObj.finished= true;
     var func = reqObj.func;
     var opStatus = StatusMsgAPI.OPSTATUS.FINISHED;
     try
     {
       if(func)
       {
        opStatus =  func.apply(reqObj.ownerObj,reqObj.args);     
       }
     }
     finally
     {
       if((opStatus === StatusMsgAPI.OPSTATUS.FINISHED)
          || (opStatus == null))
       {
         StatusMsgAPI.showOperationStatus(StatusMsgAPI.OPSTATUS.FINISHED,reqObj.opStatusId);
       }
     }
   }

  this.addVersion = function(urls)
  {
    if(ZDBGlobal.isDevelopmentMode)
    {
      var time=new Date().getTime();
      for(var i=0,len = urls.length;i<len;i++)
      {
        urls[i] += "?VER=" + time;
      }
    }
  }
  
  this.loadCssOnly = function(cssFileNames,ownerObj,func,args,opStatusId,isCssUrl)
  {
      cssFileNames = (cssFileNames instanceof Array) ? cssFileNames : cssFileNames.split(',');
      var filesCount = ZDBLazyLoadUtil.checkCssFileslist(cssFileNames);
      if(filesCount == 0)
      {
        return true;
      }
      
      if(!args)
      {
        args = [];
      }
      var reqObj = {
        func:func,
        ownerObj:ownerObj,
        args:args,
        isCss:true,
        cssFileNames:cssFileNames,
        cssLoaded:false,
        snippetLoaded:true,
        opStatusId:opStatusId};
      var cssUrls = ZDBLazyLoadUtil.getFileURLs(cssFileNames, isCssUrl, "", true, reqObj); 
      if(cssUrls.length <= 0){
       setTimeout(function(){ZDBLazyLoadUtil.invokeFunc(reqObj)},500);
       return false;
      }
      LazyLoad.css(cssUrls, ZDBLazyLoadUtil.handleResponse, reqObj, false);
      StatusMsgAPI.showOperationStatus(StatusMsgAPI.OPSTATUS.STARTED,reqObj.opStatusId);
  }


  this.loadExternalSVG = function(svgFileNames, callback, args, context){
    svgFileNames = (svgFileNames instanceof Array) ? svgFileNames : svgFileNames.split(',');
    if(ZDBLazyLoadUtil.checkSVGImageFilesList(svgFileNames) == 0)
    {
      return true;
    }
    for(var i=0,len=svgFileNames.length; i<len; i++){
      var orgUrl = ZDBLazyLoadUtil.moduleSVGImages[svgFileNames[i]], newURL;
      if(BROWSER.IE && BROWSER.VERSION.indexOf("9") === 0){
        newURL = orgUrl + "?NOCACHE=" + new Date().getTime();
      }
      else{
        newURL = orgUrl;
      }
      ZDBLazyLoadUtil.loadedSVGImages[svgFileNames[i]] = true;
      AjaxUtils.sendResourceGetRequest(newURL,{ONSUCCESSFUNC:ZDBLazyLoadUtil.handleSVGResponses, URLS:svgFileNames, URL:orgUrl, CALLBACK: callback, ARGS: args, CONTEXT: context});
    }
    return false;
  }
  this.handleSVGResponses = function(reqObjs,requestOptions){
    var urlsToLoad = requestOptions["URLS"];
    var div = document.createElement("div");
    div.style.display = "none";
    div.innerHTML = reqObjs.transport.responseText;
    document.body.insertBefore(div, document.body.childNodes[0]);
    var allURLsLoaded = true;
    for(var i=0,len=urlsToLoad.length;i<len;i++){
        if(!ZDBLazyLoadUtil.loadedSVGImages[urlsToLoad[i]]){
            allURLsLoaded = false;
        }
    }
    if(allURLsLoaded){
        var func = requestOptions.CALLBACK;
        if(func instanceof Function)
            func.apply(requestOptions.CONTEXT, requestOptions.ARGS);
    }
  }
}

var ZDBLazyLoadFuncMap = new function()
{
  this.lazyLoadFuncMap = {"ZDBClientUI.openGettingStartedDlg":ZDBClientUI.openGettingStartedDlg,   //No I18N
                "ZDBEvents.onFilterAreaButtonClick":(typeof(ZDBEvents) != 'undefined'  && ZDBEvents.onFilterAreaButtonClick) //No I18N
               };
}
