//$Id$
function dataLabel(seriesGroups, chartObj, seriesDetails,markerType,columnIdx) {
    
        var dataLabelDetails = [];
        var dataset = chartObj.map_util.getDataset();
        var chartType = chartObj.chartTypes[0].value;
        
        var chartName = $ZC.DataProcessor.helpers.getChartType(chartType, "string");//NO I18N
        var dataLabelsOptions = chartObj.map_util.getPlotOptions(chartName).datalabels;
        var isExport = chartObj.userdata.geo.isExport;
        var showlabel = isDatalabelEnabled(dataLabelsOptions, chartObj);
        if(chartType != geopie && chartType !=geobubblepie )
        {
                seriesGroups.each(function(d, i) {
                    if(chartObj.seriesdata[i].disabled)
                    {
                      return;
                    }
                    var GLT = dataLabelTextContent(chartObj, null, dataLabelsOptions, "datalabels", 0, i), //0 should be replaced by yscale domain //NO I18N
                         markerOptions = chartObj.map_util.getMarkerOptions(chartName);                    
                    var markerRadius = (markerOptions.size * 5) + validateNullVal(markerOptions.padding, 3);
                    if(d.type != geofilled)
                    {
                    d3_select(this).selectAll('g')//NO I18N
                        .each(function(d, j) {
                            var currentGroup = d3_select(this);
                            var translation = d3_transform(currentGroup.attr("transform")).translate,//NO I18N
                                DY = /bubble/g.test(chartName) ? "0.3em" : null,//NO I18N
                                X = 0,
                                Y = /bubble/g.test(chartName) ? 0 : markerType && markerType !="default" ? markerRadius :  (-markerRadius);//No I18N
                            var textEle = appendEle(currentGroup, "text", showlabel ? [1] : []); // appendEle will create element
                            textEle
                                .text(GLT(seriesDetails[i][j]))
                                .attr({
                                    "text-anchor": "middle",//NO I18N
                                    "transform": "translate(" + X + "," + Y + ")",//NO I18N
                                    "dy": DY,//NO I18N
                                })
                                .style("display", null);//NO I18N
                                if(!isExport && (!$Browser.IE && !BROWSER.EDGE))
                                        textEle.attr("class","dataLabelMap");//NO I18N
                            applyDatalabelFonts(textEle, dataLabelsOptions, chartObj, chartObj.seriesColor[i]); // Applies style
                            var bb = bbox(textEle.node());
                            var obj = {
                                X:X,
                                Y:Y,
                                translation:translation,
                                seriesPos: i,
                                itemPos: j,
                                centre: translation,
                                x1: bb.x + translation[0],
                                y1: bb.y + translation[1],
                                x2: bb.x + bb.width + translation[0],
                                y2: bb.y + bb.height + translation[1]
                            };
                            dataLabelDetails.push(obj);
                        });
                    }
                    else
                    {
                        var currentGroup =  d3_select(this);
                        var textEle = appendEle(currentGroup, "text", showlabel ? Object.keys(seriesDetails[i]) : []); // appendEle will create element
                            textEle.each(function(j){  
                                    var xVal = dataset.getActualX(seriesDetails[i]);
                                    var textLocation = chartObj.mapObj.plotted_data[seriesDetails[i][j][0]].latLng;
                                    var currentPoint =  map.latLngToLayerPoint(textLocation);
                                        d3.select(this).text(GLT(seriesDetails[i][j]));
                                        d3.select(this).attr({
                                            "text-anchor": "middle",//NO I18N
                                            "x":currentPoint.x,//NO I18N
                                            "y":currentPoint.y,//NO I18N
                                            "dy": null,//NO I18N
                                        })
                                        .style("display", null);//NO I18N
                                        if(!isExport && (!$Browser.IE && !BROWSER.EDGE))
                                                    textEle.attr("class","dataLabelMap");//NO I18N
                                    var bb = bbox(d3.select(this).node());
                                    var obj = {
                                        seriesPos: i,
                                        itemPos: j,
                                        centre:currentPoint,
                                        x1: bb.x ,
                                        y1: bb.y ,
                                        x2: bb.x + bb.width,
                                        y2: bb.y + bb.height
                                    };
                                    dataLabelDetails.push(obj);
                                    });  
                          applyDatalabelFonts(textEle, dataLabelsOptions, chartObj, chartObj.seriesColor[i]); // Applies style
                        }

                });
                 // Overlapping handler--
                // For scatter
                var zScale = chartObj.map_util.getScale(),
                    dataset = chartObj.map_util.getDataset();
                for (var i = 0, length = dataLabelDetails.length; i < length; i++) {
                    var currentLabel = dataLabelDetails[i],
                        previousLabels = dataLabelDetails.slice(0, i),
                        hideLabel = false;
                        if(previousLabels.length)
                        {
                    for (var index = i - 1; index >= 0; index--) {
                        var prev = previousLabels[index];
                        var chartType = $ZC.DataProcessor.helpers.getChartType(chartObj.seriesdata[currentLabel.seriesPos].type, "numeric");
                        var overlap = !seriesDetails[prev.seriesPos][prev.itemPos].hidden && doOverlap(prev, currentLabel);

                        hideLabel = hideLabel || overlap;
                    }
                        }
                    if (chartType === geobubble) { //Bubble chart - The datalabel should be within radius
                        var centre = currentLabel.centre;
                        var leftTopDist = mathSQRT(mathPow((centre[0] - currentLabel.x1), 2) + mathPow((centre[1] - currentLabel.y1), 2)),
                            rightBottomDist = mathSQRT(mathPow((centre[0] - currentLabel.x2), 2) + mathPow((centre[1] - currentLabel.y2), 2)),
                            radius = zScale(dataset.getZ(seriesDetails[currentLabel.seriesPos][currentLabel.itemPos])) / 2;
                        hideLabel = hideLabel || ((leftTopDist > radius) || (rightBottomDist > radius));
                    }

                    seriesDetails[currentLabel.seriesPos][currentLabel.itemPos].hidden = hideLabel;
                }
                // --Overlapping handler
                seriesGroups.each(function(d, i) {
                    if(d.type != geofilled)
                    {
                        d3_select(this).selectAll('g').each(function(d, j) {//NO I18N
                            var currentPoint = seriesDetails[i][j];
                            d3_select(this).selectAll('text').style("display", currentPoint.hidden ? "none" : null);//NO I18N
                        });
                    }
                    else
                    {
                        d3_select(this).selectAll('text').each(function(d, j) {//NO I18N
                        var currentPoint = seriesDetails[i][j];
                            d3.select(this).style("display", currentPoint ? (currentPoint.hidden ? "none" : null) : null);//NO I18N
                    });
                    }
                });
                
            }
            else
            {
                var piegroups = chartObj.map_util.getSVG().selectAll("g.scatter");//NO I18N
                var scale = chartObj.map_util.getScale();
                var GLT = dataLabelTextContent(chartObj, null, dataLabelsOptions, "datalabels", 0, 0); //0 should be replaced by yscale domain //NO I18N
                if(typeof columnIdx)
                {
                    if(columnIdx)
                    {
                            piegroups.each(function(d, i){
                                var labelGroup = appendEle(d3_select(this), "g", [1], "." , "class", "labelgroup");//NO I18N
                                var xVal = chartObj.dataset.getActualX(seriesDetails[i][0]);
                                var radius = chartObj.chartTypes[0].value == $ZC.charttype.geopie ? 15 : scale(chartObj.mapObj.plotted_data[xVal].size) / 2 ;
                                var markerRadius = radius + 10;

                                var translation = d3_transform(d3_select(this).attr("transform")).translate,//NO I18N
                                    X = 0,
                                    Y = markerRadius ; 

                                var textEle = appendEle(labelGroup, "text", showlabel ? [1] : []);

                                textEle
                                        .text(GLT(seriesDetails[i][0]))
                                        .attr({
                                            "text-anchor": "middle",//NO I18N
                                            "transform": "translate(" + X + "," + Y + ")",//NO I18N
                                        })
                                        .style("display", null);//NO I18N
                                       if(!isExport && (!$Browser.IE && !BROWSER.EDGE))
                                                    textEle.attr("class","dataLabelMap");//NO I18N
                                    applyDatalabelFonts(textEle, dataLabelsOptions, chartObj, chartObj.seriesColor[i]); // Applies style

                                    var bb = bbox(textEle.node());
                                    var obj = {
                                        itemPos: i,
                                        centre: translation,
                                        x1: bb.x + translation[0],
                                        y1: bb.y + translation[1],
                                        x2: bb.x + bb.width + translation[0],
                                        y2: bb.y + bb.height + translation[1]
                                    };

                                    dataLabelDetails.push(obj);

                        });
//                         // Overlapping handler--
                        var  dataset = chartObj.map_util.getDataset();
                        for (var i = 1, length = dataLabelDetails.length; i < length; i++) {
                            var currentLabel = dataLabelDetails[i],
                                previousLabels = dataLabelDetails.slice(0, i),
                                hideLabel = false;
                            for (var index = i - 1; index >= 0; index--) {
                                var prev = previousLabels[index];
                                var overlap = !seriesDetails[prev.itemPos].hidden && doOverlap(prev, currentLabel);

                                hideLabel = hideLabel || overlap;
                            }
                            seriesDetails[currentLabel.itemPos].hidden = hideLabel;
                        }
                        // --Overlapping handler
                        piegroups.each(function(d, i) {    
                            {
                                    d3_select(this).selectAll('text').each(function(d, j) {//NO I18N
                                    var currentPoint = seriesDetails[i];
                                        d3.select(this).style("display", currentPoint ? (currentPoint.hidden ? "none" : null) : null);//NO I18N
                                });
                            }
                        });
                        
                    }
                    else
                    {
                        piegroups.each(function(d, i){
                            var pieLabelDetails = [];
                            var currentGroup = d3_select(this);
                            var labelGroup = appendEle(currentGroup, "g", [1], "." , "class", "labelgroup");//NO I18N
                            chartObj.piedata[0][i].forEach(function(d, j)
//                            for(var j = 0 ;j < chartObj.piedata[0][i].length ;j++ )//chartObj.piedata[0][i].forEach(function(d, j)
                            {
                                    if(!d.disabled)
                                    {
                                        var textAnchor = "middle";//NO I18N

                                        var data = chartObj.renderedPiedata[chartObj.dataset.getActualX(d)][j];
                                        
                                        if(data.value == 0)
                                            return;
                                        
                                        var midAngle = (data.startAngle + data.endAngle)/2 ;
                                        
                                        var radius = chartObj.chartTypes[0].value == geopie ? chartObj.mapObj.plotted_data[chartObj.dataset.getActualX(d)].size/2 : scale(chartObj.mapObj.plotted_data[chartObj.dataset.getActualX(d)].size)/2 ;
                                        
                                        var midPointInSector = polarToXY(radius,midAngle);
                                        
                                        var dy = (midAngle > mathPI / 2 && midAngle < 3 * mathPI / 2) ? getDY(midAngle) + "em" : "0";//NO I18N
                                        
                                        textAnchor =  (midAngle < 0 || midAngle > mathPI) ? "end" : "start";//NO I18N

                                        var translation = d3_transform(currentGroup.attr("transform")).translate,//NO I18N
                                            X = midPointInSector[0],
                                            Y = midPointInSector[1]; 
                                        var textEle = appendEle(labelGroup, "text", showlabel ? [1] : [],"#","id","label_"+j);//NO I18N

                                        textEle
                                                .text(GLT(d))
                                                .attr({
                                                    "text-anchor": textAnchor,//NO I18N
                                                    "x":X, //NO I18N
                                                    "y":Y,//NO I18N
                                                    "dy":dy,//NO I18N
                                                })
                                                .style("display", null);//NO I18N
                                                if(!isExport && (!$Browser.IE && !BROWSER.EDGE))
                                                    textEle.attr("class","dataLabelMap");//NO I18N
                                            applyDatalabelFonts(textEle, dataLabelsOptions, chartObj, chartObj.seriesColor[i]); // Applies style

                                            var bb = bbox(textEle.node());
                                            var obj = {
                                                height:bb.height,
                                                x1: bb.x + translation[0],
                                                y1: bb.y + translation[1],
                                                x2: bb.x + bb.width + translation[0],
                                                y2: bb.y + bb.height + translation[1],
                                                h1:bb.y,
                                                h2:bb.y + bb.height,
                                                itemPos: i,
                                                sectorPos:j,
                                            };
                                            pieLabelDetails.push(obj);
                                    }
                                    
                            });
                            dataLabelDetails.push(pieLabelDetails);
                        });
                            function doSecOverlap(rect1, rect2) {
                                if(rect1 && rect2)
                                    return !((rect1.x1 >= rect2.x2) || (rect2.x1 >= rect1.x2) || (rect1.y1 > rect2.y2) || (rect2.y1 > rect1.y2) || ((rect1.y2 - rect2.y1) < (rect1.height / 3)));
                            }
                            
                            function doEnableDataLabel(overlap,i,dataLabelDetails)
                                {
                                var hideLabel = false;
                                if((!overlap && i))
                                {
                                    var prevPieLabels = dataLabelDetails.slice(0, i);
                                    for(var k = 0 ;k < prevPieLabels.length ; k++)
                                    {
                                        var prevLabel = prevPieLabels.slice(k,k+1);
                                        for(var l = 0; l <  prevLabel[0].length ; l++)
                                        {
                                            hideLabel = !seriesDetails[prevLabel[0][l].itemPos][prevLabel[0][l].sectorPos].hidden &&  doSecOverlap(prevLabel[0][l], currentLabel);
                                            if(hideLabel)
                                            {
                                                 break;
                                            }
                                        }
                                        if(hideLabel)
                                        {
                                            seriesDetails[currentLabel.itemPos][currentLabel.sectorPos].hidden =  hideLabel;
                                            break;
                                        }
                                    }

                                }
                                
                            }
                            var  dataset = chartObj.map_util.getDataset();
                            
                            for (var i = 0, length = dataLabelDetails.length; i < length; i++) {
                                
                                for(var j = 0 ; j < dataLabelDetails[i].length ; j++)
                                {
                                    if((j-1+i) >=0)
                                    {
                                        var currentLabel = dataLabelDetails[i][j],
                                        previousLabels = dataLabelDetails[i].slice(0, j),
                                        hideLabel = false;
                                        for (var index = j-1 ;  index >= 0 ; index--) { 
                                            var prev = previousLabels[index];
                                            var overlap = doSecOverlap(prev, currentLabel);
                                            if(overlap)
                                            {
                                                if(!seriesDetails[prev.itemPos][prev.sectorPos].hidden)
                                                {
                                                      hideLabel = overlap;
                                                      break;
                                                }
                                                else
                                                    continue;
                                            }
                                            else
                                            {
                                                hideLabel = overlap;
                                                 break;
                                            }

                                          }
                                        seriesDetails[currentLabel.itemPos][currentLabel.sectorPos].hidden =  hideLabel;
                                        // checking overlapping for other pie labels 
                                        doEnableDataLabel(overlap,i,dataLabelDetails);
                                    }
                                  }
                            }
                            // --Overlapping handler
                            piegroups.each(function(d, i) {   
                                for(var j = 0 ; j < d3_select(this).selectAll('text')[0].length; j++)
                                {
//                                        d3_select(this).selectAll('text').each(function(d, j) {//NO I18N
                                    var labelIdx = Number(d3_select(this).selectAll('text')[0][j].id.slice(6));
                                    var currentPoint = seriesDetails[i][labelIdx];
                                    d3_select(d3_select(this).selectAll('text')[0][j]).style("display", currentPoint ? (currentPoint.hidden || currentPoint.disabled ? "none" : null) : null);//NO I18N
//                                    });
                                }
                            });
                        
                     }
                    
                }
                
            }
       
    };
function addCustomMarker(parentElement,options,markerType,mouseEvent)
{ 
    var type = markerType;
    var transform =  getTransform(type);
    var translate = "translate(" + transform.tx + "," + transform.ty + ")";  //NO I18N     
    drawShadowPath(parentElement,translate,options,type);
    drawOuterPath(parentElement,translate,options,type,mouseEvent);
        drawInnerPath(parentElement,translate,options,type,mouseEvent);
    
    }
function drawShadowPath(parentElement,translate,options,type){
 var shadowPath = appendEle(parentElement,"path",[1],".","class","shadowPath");//NO I18N
                    
    shadowPath
            .attr({
                    "d" : getShadowPath(type),//NO I18N
                    "transform" : translate,//NO I18N
                    "opacity":type == "Type5" ? 0.1 : 0.3,//NO I18N
            })
            .style({
                    "fill" : "url(#SVGUrl)",//NO I18N
            })   
}
function drawOuterPath(parentElement,translate,options,type,mouseEvent)
{
    var outerPath = appendEle(parentElement, "path", [1], ".", "class", "outer");//NO I18N
    var clr = getColor(options.color,"darker");//NO I18N
    outerPath
            .attr({
                    "d":getOuterPath(type),//NO I18N
                    "transform":translate//NO I18N
             })
            .style({
                    "fill":mouseEvent ? "#FFFFFF" : options.color,//NO I18N
                    "stroke": mouseEvent ? options.color : getColor(clr,"darker"),//NO I18N
                    "stroke-width":mouseEvent? 2 : 1 //NO I18N
           });
}
function drawInnerPath(parentElement,translate,options,type,mouseEvent)
{
    var innerPath = appendEle(parentElement, "path", [1], ".", "class", "inner");//NO I18N
    var clr = getColor(options.color,"darker");//NO I18N
    innerPath
            .attr({
                    "d":getInnerPath(type),//NO I18N
                    "transform":translate//NO I18N
            })
            .style({
                     "fill":mouseEvent ?  options.color : "#FFFFFF",  //NO I18N
                                "stroke":getColor(clr,"darker")//NO I18N
                        });
            }
function getOuterPath(markerType)
{
	switch(markerType)
	{
                case "Type1"://No I18N
		{
			return "M17.5,3.7c-3.9-3.9-10.2-3.9-14,0s-3.9,10.2,0,14.1c0,0,7,6.9,7,14.8c0-8,7-14.8,7-14.8   C21.4,13.9,21.4,7.6,17.5,3.7L17.5,3.7z";//NO I18N
		}
		break;
		case "Type2"://NO I18N
		{
			return "M11.7,0.7C6,0.9,1.3,5.3,0.8,11c-0.1,1.1,0,2.2,0.2,3.3c0,0,0,0.1,0.1,0.4c0.2,0.8,0.4,1.6,0.8,2.3   c1.1,2.7,3.8,7.3,9.8,12.2c0.4,0.3,0.9,0.3,1.3,0c6-4.9,8.6-9.5,9.8-12.2c0.3-0.7,0.6-1.5,0.8-2.3c0.1-0.2,0.1-0.4,0.1-0.4   c0.1-0.7,0.2-1.4,0.2-2.2C23.6,5.7,18.3,0.5,11.7,0.7L11.7,0.7z"; //NO I18N
		}
		break;
		case "Type3"://NO I18N
		{
			return "M25.4,12.9C25.4,6,19.8,0.5,13,0.5S0.5,6,0.5,12.9c0,5.7,3.9,10.5,9.1,12l3.3,8.7l3.3-8.7C21.5,23.5,25.4,18.6,25.4,12.9z"; //NO I18N
		}
		break;
                case "Type4"://NO I18N
		{
			return "M17.28,9.038   c0-4.576-3.722-8.298-8.298-8.298c-4.576,0-8.298,3.722-8.298,8.298c0,4.39,3.428,7.982,7.744,8.271v15.764   c0,0.308,0.249,0.554,0.554,0.554c0.305,0,0.554-0.245,0.554-0.554V17.309C13.852,17.02,17.28,13.428,17.28,9.038L17.28,9.038z";//NO I18N
		}
		break;
		case "Type5"://NO I18N
		{
			return "M21.603,15.618l-4.623-3.533   l4.623-3.532c0.264-0.298,0.328-0.723,0.164-1.087c-0.163-0.363-0.524-0.597-0.923-0.597h-6.011V2.563   c0-0.559-0.453-1.012-1.013-1.012H2.097c0,0,0.104-0.788-0.692-0.788c-0.737,0-0.68,0.788-0.68,0.788V31.81l0.709,1.751   l0.679-1.751V13.672h6.997v2.617c0,0.559,0.453,1.012,1.013,1.012h10.722c0.398,0,0.759-0.233,0.923-0.597   C21.932,16.342,21.867,15.916,21.603,15.618L21.603,15.618z M21.603,15.618"; //NO I18N
		}
                break;
	}
}

function getInnerPath(markerType)
{
	switch(markerType)
	{
                case "Type1"://No I18N
		{
			return "M10.5,14.7c-2.2,0-4-1.8-4-4c0-2.2,1.8-4,4-4c2.2,0,4,1.8,4,4C14.5,12.9,12.7,14.7,10.5,14.7L10.5,14.7z";//NO I18N
		}
		break;
		case "Type2"://NO I18N
		{
			return "M12.2,17.3L12.2,17.3c-3.1,0-5.6-2.5-5.6-5.6c0-3.1,2.5-5.6,5.6-5.6c3.1,0,5.6,2.5,5.6,5.6   C17.7,14.8,15.2,17.3,12.2,17.3";//NO I18N
		}
		break;
		case "Type3"://NO I18N
		{
			return "M13,7.3c3.1,0,5.6,2.5,5.6,5.6s-2.5,5.6-5.6,5.6S7.4,16,7.4,12.9S9.9,7.3,13,7.3";//NO I18N
		}
		break;
                case "Type4"://NO I18N
		{
			return "M11.886,8.245c-1.221,0-2.212-0.992-2.212-2.212   c0-1.221,0.991-2.212,2.212-2.212c1.221,0,2.212,0.991,2.212,2.212C14.098,7.254,13.107,8.245,11.886,8.245L11.886,8.245z";//NO I18N
		}
		break;
		case "Type5"://NO I18N
		{
			return "";
		}
                break;
	}
}

function getShadowPath(markerType)
{
	switch(markerType)
	{
                case "Type1"://No I18N
		{
			return "M36,17.4c0-5.5-4.4-9.9-9.9-9.9s-9.9,4.5-9.9,9.9c0,0,0.1,9.8-5.5,15.5c4.1-4.1,16.7-5.5,15.5-5.5    C31.6,27.4,36,22.9,36,17.4L36,17.4z";//NO I18N
		}
		break;
		case "Type2"://NO I18N
		{
			return "M27.8,5.5c-4.8-3-11.3-2-14.9,2.4c-0.7,0.9-1.3,1.8-1.7,2.8c0,0-0.1,0.1-0.1,0.3c-0.3,0.8-0.5,1.5-0.6,2.3    c-0.6,2.9-0.9,8.2,1.3,15.6c0.1,0.5,0.6,0.8,1.1,0.7c7.7-0.8,12.4-3.1,14.9-4.7c0.7-0.4,1.3-0.9,1.9-1.5c0.2-0.2,0.3-0.3,0.3-0.3    c0.5-0.5,1-1.1,1.4-1.7C34.9,16.2,33.4,8.9,27.8,5.5L27.8,5.5z"; //NO I18N
		}
		break;
		case "Type3"://NO I18N
		{
			return "M34.8,25.2c4.3-5.4,3.4-13.2-1.9-17.5s-13.2-3.4-17.5,2c-3.6,4.5-3.6,10.6-0.4,15.1l-1.9,9.3l7.1-5.2C25.2,31,31.2,29.7,34.8,25.2z";//NO I18N
		}
		break;
                case "Type4"://NO I18N
		{
			return "M31.1,20.4c2.9-3.5,2.5-8.8-1-11.7s-8.8-2.5-11.7,1C15.5,13.1,15.8,18,19,21L8.8,33.1   c-0.2,0.2-0.2,0.6,0.1,0.8c0.2,0.2,0.6,0.2,0.8-0.1l10.1-12.1C23.3,24.3,28.2,23.7,31.1,20.4L31.1,20.4z";//NO I18N
		}
		break;
		case "Type5"://NO I18N
		{
			return "M28.4,33.5l-1.3-5.7l5.8,0.2c0.4,0,0.7-0.3,0.8-0.8c0.1-0.3,0-0.8-0.3-1.1l-4.6-3.8l2.8-3.3  c0.4-0.4,0.3-1-0.1-1.4l-8.9-7.5c0,0,0.6-0.5,0-1c-0.6-0.5-1,0.2-1,0.2L2,32.4l-0.6,1.8L3,33.3l11.7-13.8l5.3,4.6l-1.7,2  c-0.4,0.4-0.3,1,0.1,1.4l8.2,6.9c0.3,0.2,0.7,0.3,1.1,0.1C28.2,34.3,28.4,33.9,28.4,33.5L28.4,33.5z";//NO I18N
		}
                break;
	}
} 
function getHighlightPath(markerType)
{
	switch(markerType)
	{
                case "Type1"://No I18N
		{
			return "M15,2.1c3.5,0,6.7,1.4,9.2,3.8c2.5,2.5,3.8,5.7,3.8,9.2s-1.4,6.7-3.8,9.2C24,24.3,15.8,32,15,47.1c-0.9-15.3-9-22.8-9.1-22.9c-5-5-5-13.2,0-18.3C8.3,3.5,11.5,2.1,15,2.1 M15,0.1c-4,0-7.8,1.6-10.5,4.4c-5.7,5.9-5.7,15.4,0.1,21.1c0,0,0,0,0,0c0.3,0.3,7.7,7.4,8.5,21.5c0.1,1.1,0.9,1.9,2,1.9c0,0,0,0,0,0c1.1,0,1.9-0.8,2-1.9c0.8-13.9,8.2-21.2,8.5-21.5c2.9-2.9,4.4-6.6,4.4-10.6c0-4-1.6-7.8-4.4-10.6C22.7,1.7,19,0.1,15,0.1L15,0.1z";//NO I18N
		}
		break;
		case "Type2"://NO I18N
		{
			return "M16.6,2.2c7.9,0,14.5,6.3,14.8,14.3l0,0.1c0,1-0.1,1.8-0.2,2.5c0,0.3-0.1,0.6-0.2,1c-0.2,0.8-0.5,1.6-0.9,2.5C27.9,27.5,24.3,32,19.4,36l-0.1,0.1c-0.7,0.5-1.6,0.8-2.4,0.8c-0.9,0-1.7-0.3-2.4-0.8L14.3,36C7.6,30.6,4.8,25.5,3.7,22.8c-0.5-1-0.8-2-1-2.8c-0.1-0.3-0.1-0.5-0.2-0.8c-0.3-1.5-0.3-2.8-0.2-4c0.6-7.2,6.6-12.8,13.8-13C16.3,2.2,16.4,2.2,16.6,2.2M16.6,0.2c-0.2,0-0.3,0-0.5,0C7.8,0.5,1,6.9,0.3,15.1c-0.1,1.4,0,2.9,0.2,4.5c0,0.3,0.1,0.7,0.2,1c0.2,1,0.5,2,1.1,3.1c1.2,2.8,4.2,8.2,11.2,13.9l0.1,0.1c1.1,0.8,2.4,1.3,3.7,1.3c1.3,0,2.6-0.4,3.6-1.2l0.1-0.1c5.2-4.2,9-9,11.3-14.1c0.4-1,0.7-1.9,1-2.7c0.2-0.5,0.3-0.9,0.3-1.4c0.1-0.7,0.2-1.6,0.2-2.7l0-0.2c0,0,0,0,0-0.1C33,7.3,25.6,0.2,16.6,0.2L16.6,0.2z"; //NO I18N
		}
		break;
		case "Type3"://NO I18N
		{
			return "M17.7,2.2c8.5,0,15.4,6.9,15.4,15.4c0,6.5-4,12.2-9.9,14.4l-5.6,14.7L12,32c-5.8-2.3-9.8-8-9.8-14.4C2.2,9.1,9.2,2.2,17.7,2.2 M17.7,0.2C8.1,0.2,0.2,8,0.2,17.6c0,6.8,4.1,13,10.2,15.9l5.3,14c0.3,0.8,1,1.3,1.9,1.3c0,0,0,0,0,0=c0.8,0,1.6-0.5,1.9-1.3l5.3-13.9c6.2-2.8,10.3-9,10.3-15.9C35.1,8,27.3,0.2,17.7,0.2L17.7,0.2z";//NO I18N
		}
		break;
                case "Type4"://NO I18N
		{
			return "M13.5,2.2c6.2,0,11.3,5.1,11.3,11.3c0,4.9-3.2,9.2-7.7,10.7v13.4c0,2.1-1.5,3.6-3.6,3.6c-2,0-3.6-1.6-3.6-3.6V24.2c-4.5-1.5-7.7-5.8-7.7-10.7C2.2,7.3,7.3,2.2,13.5,2.2 M13.5,0.2c-7.3,0-13.3,6-13.3,13.3c0,5.2,3,9.9,7.7,12.1v12c0,3.1,2.5,5.6,5.6,5.6s5.6-2.5,5.6-5.6v-12c4.7-2.2,7.7-6.9,7.7-12.1C26.8,6.2,20.8,0.2,13.5,0.2L13.5,0.2z";//NO I18N
		}
		break;
		case "Type5"://NO I18N
		{
			return "M5.8,2.1c0.9,0,1.7,0.3,2.3,0.8h10.1c2.2,0,4,1.8,4,4v1.3h3c1.6,0,3,0.9,3.7,2.4c0.6,1.4,0.4,3.1-0.7,4.3L28,15.1l-1.7,1.3l1.7,1.3l0.2,0.2c1.1,1.2,1.3,2.9,0.7,4.3c-0.6,1.4-2.1,2.4-3.7,2.4H14.5c-2.1,0-3.8-1.6-4-3.6h-1v15.7L5.9,46l-3.8-9.3V5.9c0-0.5,0.1-1.7,1-2.7C3.8,2.5,4.7,2.1,5.8,2.1 M5.8,0.1c-1.6,0-3.1,0.6-4.2,1.8C0.2,3.4,0.1,5.2,0.1,5.9v30.8c0,0.3,0,0.5,0.1,0.8L4,46.7c0.3,0.8,1,1.2,1.9,1.2c0,0,0,0,0,0c0.8,0,1.6-0.5,1.8-1.3l3.6-9.3c0.1-0.2,0.1-0.5,0.1-0.7V25.8c0.9,0.5,1.9,0.8,3,0.8h10.7c2.4,0,4.5-1.4,5.5-3.5c1-2.2,0.6-4.7-1-6.5l-0.2-0.2c0,0,0,0,0,0l0.2-0.2c1.6-1.8,2-4.3,1-6.5c-1-2.2-3.1-3.5-5.5-3.5h-1.1c-0.3-3-2.9-5.3-6-5.3H8.7C7.8,0.3,6.8,0.1,5.8,0.1L5.8,0.1z";//NO I18N
		}
                break;
	}
} 
function getTransform(markerType)
{
    var translate = {};
	switch(markerType)
	{
                case "Type1"://No I18N
		{
                        translate.tx = -10.7;
                        translate.ty = -31.77;
		}
                break;
		case "Type2"://NO I18N
		{
                       translate.tx = -12.5;
                       translate.ty = -28.77;
		}
		break;
		case "Type3"://NO I18N
		{
                        translate.tx = -13;
                        translate.ty = -33.5;
		}
		break;
		case "Type4"://NO I18N
		{
			translate.tx = -9;
                        translate.ty = -33;
		}
		break;
		case "Type5"://NO I18N
		{
                        translate.tx = -1.7;
                        translate.ty = -33.5;
		}
		break;
		
		}
        return translate;
}
function getColor(color,copyType)
{
    if(color.indexOf("rgba") >= 0)
    {
        color = rgb2hex(color);
    }
    return getColorCopy(color,1,copyType);
}
function patternFill(color,canvas)
{
        var prop=$ZC.getPattern("tinyHatchfill");//NO I18N
        var patternId;
        prop.bgClr_base = color;
        prop.strokeWidth = "1";   
        prop.stroke_base = "white"; //NO I18N
        if(canvas)
        {
            patternId = effects.get(canvas_patterns,"canvasPatternFill",prop);
        var ctx = canvas.getContext('2d');   //NO I18N
            return ctx.fillStyle = patternId;
}
        else
        {
            patternId = effects.get(svg_patterns,"svgPatternFill",prop);
            var patternURL = "url(" + "#" + patternId + ")";//NO I18N
            return patternURL;
        }
        
}