//$Id$
chart.initialize = function(container, data){
        // To override the default initialise function given by ZC.charts.get in order to set up things for the map chart
        
        try {

            //removing existing contianer
              container.selectAll(".d3container").remove(); //NO I18N

            //initialising the map
            data.tooltip? data.tooltip.withinChart = true : null; //to cehck for the tooltip display
            var chartType = data.seriesdata && data.seriesdata.chartdata[0].type;
            var leafletMap = initMap(container.node(), data.geo.tileProvider,chartType);
            this.mapObj = $ZC.GeoChart.getMapObj(container, leafletMap);
            map_util.setChartObj(this);
            
            //reset of the default functionalities but the chartholder div will not be initialised
            var mode = (chartType == geofilled)? "canvas" : "svg";//NO I18N
            if (!this.plot.renderer) {
                var context = this;
                this.plot.renderer = {
                    "mode": mode,//NO I18N
                    "draw": function(update) {//NO I18N
                        context.render(update);
                    }
                }
            }
            this.userdata = data;
            this.chartRendered = false;
            this.container = container;
            this.createHelperElements();
            this.isGeoChart = true;
            var chartHeight = parseFloat(this.container.style("height"));//NO I18N
            var chartWidth = parseFloat(this.container.style("width"));//NO I18N
            this.setCanvasDimension(chartWidth, chartHeight);
            //Scale
            this.axes.x = {};
            this.axes.y = {
                groups: []
            };
            
            this.chartTypes = this.dataProcessorHelpers.getAllChartTypes(data, "object");//NO I18N
            //Populate data into the chart object
            this.globalProp = setGlobalPropByUserdata(data, {
                "width": chartWidth,//NO I18N
                "height": chartHeight//NO I18N
            }, {});
            populateChartObj.call(this, getThemeOptions(this.globalProp));
            
            if (this.nochartdata) {
                return;
            }
            
            var parentContainer = d3_select(document.body);
           
            //Initialising the tooltip element
            this.tooltip = {}
            this.tooltip.element = appendEle(parentContainer, "div", [1], "#", "id", "zctooltip"); //NO I18N
            this.eventHandler = {}
            this.eventHandler.tooltipElement = $ZC.events.tooltip(this.tooltip.element, data, this);
            this.eventHandler.tooltipElement.initialize();
            this.eventHandler.trackerElement = this.container.selectAll("rect.eventHandler");//NO I18N
            
            //related to initializing the svg adding definitions
            this.defsLocation = getDefsLocation();
            var svg = map_util.getSVG();
            this.legendHighlight = new $ZC.legendHighlight(chart, svg)
            appendEle(svg, "defs", [1]);
            
            //initialize holders for legend and title
            map_ui_util.legend(this);
            map_ui_util.legend.init();
            
        } catch (err) {
             console.log(err.stack);
             console.log("Oops! Sorry something went wrong to render the chart...")
             console.log("Error message : " + err.message);
            chart.breakOnErr = true;
        }
    };
    
    chart.render = function(update) {
        
        try {
            
            var svg = map_util.getSVG();
            
            mapObj = this.mapObj;
            
            map = mapObj.map;
            
            if (this.nochartdata) {
                
                this.chartRendered = true;
                map_renderer_util.initNoDataHandlerElement(svg);
                this.handleNoData(this.systemConf.noDataHandler, svg.selectAll('g.nodatahandler'));//NO I18N
                this.mapObj.disable();
                // map_ui_util.legend.remove();
                
            } else {
                $ZC.mapdataset(this.dataset, this.systemConf);
                
                var chartType = this.chartTypes[0].value;
                var marker = map_util.getMarkerType();
                this.getChartSeriesColor();
                this.isAxisCategory = true;
                this.isNonAxisMultiSeriesCategory = this.dataObject.isNonAxisMultiSeriesCategory;
                this.xymultiRenderer = this.isAxisCategory;
                this.zscale = chartType == 22 || chartType == 27 ? $ZC.scale.getScale(this, this.dataObject, map_util.getMapDimension(), this.axes.x.orient, null, this.dataset, "z") : null; //No I18N
                $ZC.legend.render(this);
                map_ui_util.legend.checkAndSetStyles(update, this.legendarea.show);
                legend_helpers.updateBubblePieData = function(d, i, chartObj) {
                if (chartObj.dataObject.pieWithAxis) {
                        d.data.forEach(function(subseries) {
                                subseries.forEach(function(dataPoint) {
                                        dataPoint.disabled = d.disabled;
                                });
                        });
                    }
                };
                     this.legend.component.highlightSeries = function(ele, d, i, data, chartObj, onLegHover)
                    {
                    if(chartObj.chartTypes[0].value == geofilled)
                    {

                        if(!d.disabled)
                        {
                          var curLayer = chartObj.mapObj.plotted_layer[i];
                          var color = curLayer.color;
                          var canvasLayer = document.getElementsByClassName("leaflet-zoom-animated");//NO I18N
                          var canvas;
                          for(var i = 0 ; i < canvasLayer.length ; i++)
                          {
                                if(canvasLayer[i].nodeName == "CANVAS")
                                {
                                     canvas = canvasLayer[i];
                                }
                          }
                          if(onLegHover)
                          {
                             curLayer.layer.bringToFront();
                             curLayer.layer.setStyle({
                                 "weight" : 1.5,//NO I18N                            
                                 "color":"#727070",//NO I18N     
                                 "fillOpacity":1//NO I18N
                             });
                             
                          }
                          else
                          {
                               curLayer.layer.eachLayer(function(layer){
                                   curLayer.geoJson.resetStyle(layer);
                               })
                              
                               chartObj.seriesdata.forEach(function(d,i){
                                   if(!d.disabled)
                                   {
                                        var gLayer = chartObj.mapObj.plotted_layer[i].geoJson;
                                        gLayer.bringToFront();
                                   }
                                });
                          }
                        }
                    
                }
                if(chartObj.chartTypes[0].value == geoscatter && marker != "default")
                {
                        if(onLegHover)
                         {
                              if(!d.disabled)
                                highlightUnSelectedSeries(chartObj,i);
                              else
                                 deselectHighlightUnSelectedSeries(chartObj,i);
                          }
                        else
                               deselectHighlightUnSelectedSeries(chartObj,i);
                }
                    if(chartObj.chartTypes[0].value == geoscatter && marker == "default")
                    {
                        var selectedSeriesGroup = map_util.getSVG().select(".scatterseries_"+i);//NO I18N
                        if(onLegHover)
                         {
                              if(!d.disabled)
                              {
                                selectedSeriesGroup.selectAll(".outer").style('transform',"scale(1.35)");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").style('transform',"scale(1.35)");//NO I18N
                                selectedSeriesGroup.selectAll(".outer").attr('transform',"scale(1.35)");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").attr('transform',"scale(1.35)");//NO I18N
                              }
                              else
                              {
                                selectedSeriesGroup.selectAll(".outer").style('transform',"scale(1)");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").style('transform',"scale(1)");//NO I18N
                                selectedSeriesGroup.selectAll(".outer").attr('transform',"scale(1)");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").attr('transform',"scale(1)");//NO I18N
                              }
                          }
                        else
                        {
                            selectedSeriesGroup.selectAll(".outer").style('transform',"scale(1)");//NO I18N
                            selectedSeriesGroup.selectAll(".inner").style('transform',"scale(1)");//NO I18N
                            selectedSeriesGroup.selectAll(".outer").attr('transform',"scale(1)");//NO I18N
                            selectedSeriesGroup.selectAll(".inner").attr('transform',"scale(1)");//NO I18N
                        }
                    }
                    if(chartObj.chartTypes[0].value == geobubble)
                    {
                        var selectedSeriesGroup = map_util.getSVG().select(".scatterseries_"+i);//NO I18N
                        if(onLegHover)
                         {
                              if(!d.disabled)
                              {
                                selectedSeriesGroup.selectAll(".outer").style('stroke-width',"3");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").style('stroke-width',"3");//NO I18N
                              }
                              else
                              {
                                selectedSeriesGroup.selectAll(".outer").style('stroke-width',"1");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").style('stroke-width',"1");//NO I18N
                              }
                          }
                        else
                        {
                            selectedSeriesGroup.selectAll(".outer").style('stroke-width',"1");//NO I18N
                            selectedSeriesGroup.selectAll(".inner").style('stroke-width',"1");//NO I18N
                        }
                    }
                    if(chartObj.chartTypes[0].value == geopie || chartObj.chartTypes[0].value == geobubblepie)
                    {
                        var selectedSeriesGroup = map_util.getSVG().selectAll("g.piegroup");//NO I18N
                        var seriesPies = selectedSeriesGroup.selectAll("path#arc_" + i);//NO I18N
                        var actualClr = chartObj.seriesColor[i];
                        if(onLegHover)
                         {
                              if(!d.disabled)
                              {
                                seriesPies.style('fill',patternFill(actualClr));//NO I18N
                              }
                              else
                              {
                                seriesPies.style('fill',actualClr);//NO I18N
                              }
                          }
                        else
                        {
                            seriesPies.style('fill',actualClr);//NO I18N
                        }
                    }
                }
                function highlightUnSelectedSeries(chartObj,index)
                {
                    chartObj.seriesdata.forEach(function(d,i){
                                   if(!d.disabled && i != index)
                                   {
                                       var unSelectedSeriesGroup = map_util.getSVG().select(".scatterseries_"+i);//NO I18N
                                       unSelectedSeriesGroup.selectAll(".outer").style('opacity',"0.4");//NO I18N
                                       unSelectedSeriesGroup.selectAll(".inner").style('opacity',"0.4");//NO I18N
                                       unSelectedSeriesGroup.selectAll(".shadowPath").style('opacity',0.1);//NO I18N
                                   }
                        });
                }
                function deselectHighlightUnSelectedSeries(chartObj,index)
                {
                    chartObj.seriesdata.forEach(function(d,i){
                                   if(!d.disabled && i != index)
                                   {
                                      var unSelectedSeriesGroup = map_util.getSVG().select(".scatterseries_"+i);//NO I18N
                                       unSelectedSeriesGroup.selectAll(".outer").style('opacity',"1");//NO I18N
                                       unSelectedSeriesGroup.selectAll(".inner").style('opacity',"1");//NO I18N
                                       unSelectedSeriesGroup.selectAll(".shadowPath").style('opacity',marker == "Type5" ? 0.1 : 0.3);//NO I18N
                                   }
                        });
                }
                map_renderer_util.plotMapChart(svg, this, update);
                if (Object.keys(this.mapObj.plotted_data).length === 0) {
                    map_renderer_util.initNoDataHandlerElement(svg);
                    this.handleNoData(this.systemConf.noDataHandler, svg.selectAll('g.nodatahandler'));//NO I18N
                    this.mapObj.disable();
                    map_ui_util.legend.remove();
                    this.nochartdata = true;
                    this.hasUnknownData=true;
                }
                if(!update)
                {
                    var maxZoom = map_util.getMaxZoomLevel();
                    var prop = maxZoom ? {maxZoom : maxZoom} : null;
                    this.chartTypes[0].value == geofilled && !this.nochartdata ? this.mapObj.fitBounds(map_util.getLayerBounds()) : this.mapObj.fitBounds(map_util.getLatLngArray(),prop);
                }
                var seriesGroups = svg.selectAll('g.seriesholder').selectAll("g.series");//NO I18N
                
                this.chartRendered = true;
                
            }
            
        } catch (err) {
            
    		 console.log(err.stack);
             console.log("Oops! Sorry something went wrong to render the chart...")
             console.log("Error message : " + err.message);
            this.breakOnErr = true;
            
        }
        
    };
    
    chart.resetdata = function(newSystemConf) {
        var chartHeight = parseFloat(this.container.style("height"));//NO I18N
        var chartWidth = parseFloat(this.container.style("width"));//NO I18N
        this.setCanvasDimension(chartWidth, chartHeight);
        populateChartObj.call(this, newSystemConf, true);
        this.globalProp = setGlobalPropByUserdata(newSystemConf, {
            "width": chartWidth,//NO I18N//NO I18N
            "height": chartHeight//NO I18N
        }, {});
    };
    
    chart.showLoading = function(holder) {
        return;
    };
    
    chart.getChartSeriesColor = function() {
        var colors = []
        var legend_data = systemconf.legend;
        if (legend_data.colors) {
            if (!(legend_data.colors instanceof Array)) {
                var legendColors = [];
                for (var key in legend_data.colors) {
                    if (legend_data.colors.hasOwnProperty(key)) {
                        legendColors.push(legend_data.colors[key]);
                    }
                }
                colors = legendColors;
            } else {
                colors = legend_data.colors;
            }
        } else if (legend_data.patternPallete) {
            var patternPallete = $ZC.legutil.patternPallete.get(legend_data.patternPallete);
            colors = patternPallete.map(function(d, i) {
                var id = patterns.get("imageFill", {//NO I18N
                    "name": d,//NO I18N
                    "width": 50,//NO I18N
                    "height": 50//NO I18N
                });
                return "url(" + chart.defsLocation + "#" + id + ")"; //NO I18N
            })
        } else if (legend_data.colorPallete) {
            if (legend_data.colorPallete.type == "monochrome") {
                colors = $ZC.legutil.getMonochromeColorPallette(legend_data.colorPallete.options.monochrome);
            } else {
                colors = $ZC.legutil.colorpallete.get(legend_data.colorPallete.options.multicolor) || $ZC.legutil.colorpallete.get("flat-ui-colors");
            }
        }
        /*
         * setting seriesdata color
         */
        if (colors != null) {
            this.seriesColor = colors.slice(0, colors.length);
            this.seriesdata.map(function(d, i) {
                if (d.color != null && d.color != "") {
                    chart.seriesColor[i] = d.color;
                }
            })
        }
    };
    
    chart.redraw = function() {
        this.resetdata(systemconf);
        this.mapObj.map.invalidateSize();
        this.flushCanvas();
        this.render(true);
    };
    
    chart.flushCanvas = function()
    {
        Object.keys(chart.mapObj.plotted_layer).forEach(function(key){
            chart.mapObj.plotted_layer[key].layer.clearLayers();
        });
    };
    chart.polarToXY = function(r,a)
    {
        a = a - (mathPI / 2);
        return [mathCos(a) * r, mathSin(a) * r];
    }
    chart.addRemoveSeries = function(series, i) {

        var svg = this.map_util.getSVG();
        var chart = this;
        var seriesHolder = svg.select("g");//NO I18N
        var seriesGroups =  chart.chartTypes[0].value == geopie ? seriesHolder.selectAll("g#subseries_0").selectAll("g") : seriesHolder.selectAll("g");//NO I18N
        var textEle = seriesGroups.selectAll("text");//NO I18N
   
        var resetDataLabelAndEnable = function(chart)
        {
            chart.seriesDetails.forEach(function(d){ 
                 d.forEach(function(d){
                        d.hidden = false;
                    });
              });
            dataLabel(seriesGroups,chart,chart.seriesDetails); 

        }

        this.dataObject.initialize("addorremoveseries");//NO I18N
        
        if (this.isAxisCategory) {
            (this.dataObject.isBubbleEnabled) ? this.zscale.domain(this.dataObject.getMinMaxZ()) : null;
        }
        if(chart.chartTypes[0].value == geofilled)
        {
            if(!(series instanceof Array))
            {
                var selectedLayer= chart.mapObj.plotted_layer[series.seriesidx].layer;
                if(series.disabled)
                {
                     textEle.remove();
                     chart.mapObj.map.removeLayer(selectedLayer);
                     //data lables to be reset for the selected layer
                     resetDataLabelAndEnable(chart);
                }
                else
                {
                    textEle.remove();
                    chart.seriesdata.forEach(function(d){
                        var gLayer = chart.mapObj.plotted_layer[d.seriesidx].layer;
                        chart.mapObj.map.removeLayer(gLayer);
                    });
                    chart.seriesdata.forEach(function(d){
                        if(!d.disabled)
                        {
                            var gLayer = chart.mapObj.plotted_layer[d.seriesidx].layer;
                            chart.mapObj.map.addLayer(gLayer);
                        }

                    });
                    //data lables to be reset
                    resetDataLabelAndEnable(chart);
                } 
            }
            else
            {
                chart.seriesdata.forEach(function(d){
                        var gLayer = chart.mapObj.plotted_layer[d.seriesidx].layer;
                        chart.mapObj.map.removeLayer(gLayer);
                 });
                chart.seriesdata.forEach(function(d){
                        if(!d.disabled)
                        {
                            var gLayer = chart.mapObj.plotted_layer[d.seriesidx];
                            gLayer.layer.eachLayer(function(layer){
                                    gLayer.geoJson.resetStyle(layer);
                            });
                            chart.mapObj.map.addLayer(gLayer.layer);
                        }
                });
                dataLabel(seriesGroups,chart,chart.seriesDetails);
            }
            
        }
        else
         {
          this.plot.renderer.draw(true);  
         }   
    };
    
    chart.setChartDimension = function(width, height) {
        this.chartarea = {
            width: width,
            height: height
        }
    };
    
    chart.handleNoData = function(data, ele) {
        // var isGeoChart = chart.dataObject.isGeoChart;
        var nodatawrap = (ele != null) ? ele : wrap.selectAll("g.nodatahandler");//NO I18N
        if (data.htmlEl != null) {
            var customHandler = appendEle(chart.container.selectAll("div.canvas-component"), "div", [1], ".", "class", "nodatahandler");//NO I18N
            customHandler
                .style("position", "absolute")//NO I18N
                .html(data.htmlEl);
            
            var node = customHandler.node();
            customHandler.style({
                "left": validateNullVal(data.x, ((chart.chartarea.width / 2) - (node.offsetWidth / 2))) + "px",//NO I18N
                "top": validateNullVal(data.y, ((chart.chartarea.height / 2) - (node.offsetHeight / 2))) + "px"//NO I18N
            });
        } else if (data.imageUrl != null) {
            var image = appendEle(nodatawrap, "image", [1]);
            image
                .attr({
                    "x": data.x || (chart.chartarea.width / 2) - 50,//NO I18N
                    "y": data.y || (chart.chartarea.height / 2) - 50,//NO I18N
                    "width": 100,//NO I18N
                    "height": 100,//NO I18N
                    "xlink:href": data.imageUrl//NO I18N
                });
        } else if (data.text != null) {
            
            var text = appendEle(nodatawrap, "text", [data], ".", "class", "nodata");//NO I18N
            text
                .attr({
                    "x": data.x || chart.chartarea.width / 2,//NO I18N
                    "y": data.y || chart.chartarea.height / 2,//NO I18N
                    "text-anchor": "middle"//NO I18N
                })
                .text(decodeHTML(data.text || "No Data"));//NO I18N
            applyFont(text, [data, systemconf.canvas, $ZCG]);
        }
    };
    
    return chart;
    
    function initMap(container, tiles,type) {
        
        if (container._ZCMap) {
            // If map already initialised for the container
            container._ZCMap.remove();
        }
        
        var southWest = L.latLng(85, -180),
            northEast = L.latLng(-180, +180),
            bounds = L.latLngBounds(southWest, northEast);
        
        var tileProps = tiles.tileProps;
        tileProps.worldCopyJump = tileProps.worldCopyJump || true;
        tileProps.noWrap = tileProps.noWrap || false;
        tileProps.continuousWorld = tileProps.continuousWorld || true;
        // to stop leaflet fetching invalid tiles. Its a bug in Leaflet new version which results console log error for all the invalid tiles
        //  even though no error in the UI. So forcefully we are stopping leaflet fetching the tiles out side of the world bounds.
        if (tileProps.noWrap) {
            tileProps.bounds = bounds;
        }
            var mapProp = tileProps.noWrap ? {
                // to stop leaflet moving out of the world to the blank space
                maxBounds: bounds,
                maxBoundsViscosity: 1.0,
                zoomAnimationThreshold:10
            } : {};
             mapProp.preferCanvas = type == geofilled ? true :false
             var map = L.map(container, mapProp).fitWorld();
        
            var tileLayer = L.tileLayer(tiles.tileUrl, tileProps);
        // for performace log in zoho reports. do not move this after tilelayer.add(map)
            tileLayer.on("loading", function() {
                this.startTime = new Date().getTime();
            });
            tileLayer.addTo(map);
            container._ZCMapTileLayer = tileLayer;
            container._ZCMap = map;
            map_renderer_util.initMapSVG(map);    
        var hideAttributions = tileProps.hideAttributions || false;
        if (hideAttributions) {
            map.attributionControl.remove();
        }
        var hideZoomControls = tileProps.hideZoomControls || false;
        if (hideZoomControls) {
            map.zoomControl.remove();
        }
        return map;
    }
    
    function getThemeOptions(globalProp) {
        var overallTypes = $ZC.charttypenames.values();
        var allSeriesTypes = $ZC.DataProcessor.helpers.getAllChartTypes(chart.userdata, "string")//NO I18N
        var theme = null,
            userTheme;
        var defaultThemeOptions, userThemeOptions;
        if (chart.userdata.canvas) {
            theme = chart.userdata.canvas.theme;
        }
        var defaultTheme = new $ZC.defaultTheme(globalProp);
        overallTypes.map(function(d, i) {
            if (allSeriesTypes.indexOf(d) != -1) {
                  getGeoDefaultOptions(d, defaultTheme.chart.plot.plotoptions, globalProp);
//                $ZC.getDefaultOptions(d, defaultTheme.chart.plot.plotoptions, globalProp);
            }
            
        })
        if ((theme != null) && ($ZC[theme] != null)) {
            userTheme = new $ZC[theme](globalProp);
            userTheme = mergeJSON(defaultTheme, userTheme, true, true);
        } else {
            userTheme = defaultTheme;
        }
        return userTheme;
    }
    
    function getDataObject(systemconf) {
        var daobj = new $ZC.DataProcessor(systemconf, chart.dataset, chart);
        chart.seriesdata = daobj.isHierarchy ? simpleClone(chart.seriesdata) : chart.seriesdata;
        return daobj;
    }
    
    function populateChartObj(baseSystemConf, update) {
        this.preProcessor = {}; // zohochart need to fix
        this.systemConf = systemconf = mergeJSON(baseSystemConf, this.userdata, true, true);
        this.nochartdata = !systemconf.seriesdata || !systemconf.seriesdata.chartdata || systemconf.seriesdata.chartdata.length <= 0;
        this.seriesdata = this.nochartdata ? null : systemconf.seriesdata.chartdata;
        if (!update) {
            stateChangeListener(chart, systemconf.canvas.events, "chart", "init");//NO I18N
        }
        
        if(!this.nochartdata)
        {
            this.dataset = new $ZC.dataset.get(systemconf,this);
            this.dataObject = getDataObject(systemconf);
            this.dataset.setDataObj(this.dataObject)
            this.dataset.geocolumnidx = (this.systemConf.metadata.axes.geoidxpos != null) ? this.systemConf.metadata.columns[this.systemConf.metadata.axes.geoidxpos].dataindex : null
            
            //overiding prop of map pie and map bubble pie for legend filter state update
            this.dataObject.pieWithAxis = this.chartTypes[0].value == $ZC.charttype.geopie || this.chartTypes[0].value == $ZC.charttype.geobubblepie;
            
        }        
        this.nochartdata = this.nochartdata || (this.dataObject.totalnoofdatas < 1);
        this.axes.rotated = this.dataObject ? this.dataObject.getAxisRotated() : null;
        this.axes.x.orient = this.axes.rotated ? "left" : "bottom";//NO I18N
        this.axes.y.orient = this.axes.rotated ? "bottom" : "left";//NO I18N
        var chartHeight = parseFloat(chart.container.style("height"));//NO I18N
        var chartWidth = parseFloat(chart.container.style("width"));//NO I18N
        this.setChartDimension(chartWidth, chartHeight);  
    }
};

var GEOROLEBASED_MAXZOOMLEVELS = (function() {
    var zoomlevelByRole = {
        0:1,
        1: 4,
        2: 6,
        3: 7,
        4: 7,
        5: 9
    };
    return {
        getMaxZoom: function(georole) {
            return zoomlevelByRole[georole];
        }
    };
    
})();