
//$Id$
$ZC.mapcharts.events = function(systemConf) {
    
    var global = {
        systemConf: systemConf
    };
      var current_id = null;
    return {
        "initialize": function(util) { //NO I18N
            global.util = util;
            global.svg = util.getSVG();
            if (!global.svg) {
                return;
            }
            global.leafletMapObj = util.getLeafletMap();
            global.seriesHolder = global.svg.select("g.seriesholder");//NO I18N
            global.seriesElements = global.svg.select("g").selectAll("g.scatter"); //global.svg.select("g").selectAll("g").selectAll("g");//NO I18N
            global.latLngArray = util.getLatLngArray();
            global.chartObj = util.getChartObject();
            global.dataset = util.getDataset();
            global.leafletMapObj.on('zoomend', function() {
                update(util);
                global.seriesHolder.style("opacity","1");//NO I18N
            });
            // with out zoom change we are resetting view for search, so need to update the position
            global.leafletMapObj.on('viewreset', function() {
                update(util);
            });
            global.leafletMapObj.on('mousemove', mousemove);
            global.leafletMapObj.on('click', click);
            global.leafletMapObj.on('dblclick', dblclick);
            global.leafletMapObj.on('mouseout', mouseout);
            global.leafletMapObj.on('zoomstart',function(){
                 global.seriesHolder.style("opacity","0");//NO I18N
                mouseout();
            });
            update(util);
            global.legend =  getLegendDetails(systemConf);
        },
        "setId": function(id) { //NO I18N
            current_id = id;
        }
    }

    function getLegendDetails() {
        var showOnDataHover = systemConf.legend.itemHoverStyle && systemConf.legend.itemHoverStyle.showOnDataHover;
        var legendSeries = global.chartObj.legendarea.element.selectAll(".legseries").node(); //NO I18N
        return {
            element: legendSeries,                  
            reverse: showOnDataHover,       
            children: legendSeries ? toArray(legendSeries.children) : [],       
            height: legendSeries ? legendSeries.offsetHeight : null
        }
    }
    function updateDataLabel(util) {
        
        var type = global.chartObj.chartTypes[0].value;
        if(type != geopie && type != geobubblepie)
        {
            var seriesGroups = global.svg.selectAll('g.seriesholder').selectAll("#series");//NO I18N
            var series = global.chartObj.seriesdata;
            seriesGroups.data(series);
            dataLabel(seriesGroups, global.chartObj, global.chartObj.seriesDetails,util.getMarkerType());
        }
        else
        {             
            var metaData =  global.chartObj.dataObject.data.metadata;
            var labelIdx =  metaData.axes.label;
            var x = metaData.axes.x;
            var columnIdx = labelIdx ? metaData.columns[labelIdx].columnname == metaData.columns[x].columnname : null;
            // to check the text column is involved in chart
                dataLabel(global.chartObj.piedata, global.chartObj,global.chartObj.seriesDetails,null,columnIdx);
        }
    }
    
    function update(util) {
        //reason to have global variables is to avoid computing the variables for every event trigger.
        global.seriesElements = (global.chartObj.chartTypes[0].value == geobubblepie || global.chartObj.chartTypes[0].value == geopie) ? global.svg.select("g").selectAll("g.scatter") : global.seriesElements;

        //translating the highlighting element 
        
        var srchEle;
        
        var highlightEle = global.svg.select("g.leaflet-zoom-hide.highlight-group").select("g.highlight");//NO I18N

        if(highlightEle[0][0])
        {
            global.seriesElements.each(function(data,i){
                if(d3.transform(d3.select(this).attr("transform")).translate.toString() == d3.transform(highlightEle.attr("transform")).translate.toString())
                        srchEle = i;
            });
            
        }

        global.seriesElements.attr("transform", function(data,i) { //NO I18N
            var layerPoint = global.leafletMapObj.latLngToLayerPoint(L.latLng(data[0], data[1]));
            //search highlighting to translate the g element for outer stroke 
            if(srchEle == i)
            {
                highlightEle.attr("transform","translate(" + layerPoint.x + "," +layerPoint.y + ")") ; //NO I18N
            }
            return "translate(" + //NO I18N
                layerPoint.x + "," +
                layerPoint.y + ")";
        });    
        
        if (global.chartObj.seriesDetails) {
            updateDataLabel(util);
        }
    }    
    function mousemove(event) {      
        
        if(global.chartObj.systemConf.chart.plot.events.enabled==false)
        {
            return;
        }
        var series = global.chartObj.map_util.getSeries();
        var chartType = global.chartObj.chartTypes[0].value;
        var marker = global.util.getMarkerType() != "default" ? global.util.getMarkerType() : null; //No I18N
        var leafletMapObj = global.leafletMapObj;
        var MINDIST = getMinDist(global.chartObj,marker); //Minimum distance a point should be from the cursor to be highlighted - 10 in pixel scale

        handleReverseHovering(false); // geopie and geobubblepie;

        if (leafletMapObj.getZoom() < 1) {
            //If not focused the event is not triggered
            return;
        }
        var latLngWidth = (leafletMapObj.getBounds().getEast() - leafletMapObj.getBounds().getWest() ) * Math.pow(2,(leafletMapObj._zoom - 1));
        
        var minDistanceForHighlight = MINDIST* latLngWidth / (leafletMapObj.getContainer().getBoundingClientRect().width);
        
        var seriesnumber = findSelectedPoint(series,event,minDistanceForHighlight,marker,global,current_id);
        
        var tooltipElement = global.chartObj.systemConf.tooltip;

        var tooltipObject = global.chartObj.eventHandler.tooltipElement;
        
        if(seriesnumber)
        {
            handleReverseHovering(false); // geopie and geobubblepie;

                var dataset = global.dataset;
                    //Show highlight over point
                    this._container.style.cursor = "pointer";

            if(chartType != geofilled)
            {
                    var highlightElement = getHighlightGroupElement(seriesnumber, global.svg,chartType,marker);
                    var layerPoint = leafletMapObj.latLngToLayerPoint(seriesnumber.latLng);
                    highlightElement.style('visibility', 'visible').attr("transform", 'translate(' + layerPoint.x + ',' + layerPoint.y + ')'); //NO I18N
                    var color = global.chartObj.seriesColor[seriesnumber.seriesIndex];
                    if(chartType == geopie || chartType == geobubblepie)
                          highlightElement.selectAll("#arc_"+seriesnumber.seriesIndex).style("fill",patternFill(color)); //NO I18N
            }
                    //To show the tooltip
                    if (tooltipElement.enabled) {
                        enableToolTip(global,event,seriesnumber,dataset,tooltipObject);
                        if(global.legend.activeIndex !== seriesnumber.seriesIndex && defined(global.legend.activeIndex)) {
                            handleReverseHovering(false);
                        }
                        handleReverseHovering(true, seriesnumber.seriesIndex);
                    }
                    //Make a callback to the user event listener if any provided
                    makeCallback(seriesnumber, "mousemove", event);//NO I18N
                    
                    }
           else {
                this._container.style.cursor = "default";//NO I18N
                global.svg.select('g.highlight-group').select('g.piegroup').remove();//NO I18N
                global.svg.select('g.highlight-group').select('g').attr('transform', null).style('visibility', 'hidden'); //NO I18N
                tooltipObject.hide(tooltipElement.element);
                handleReverseHovering(false);
            }
        }
 
    function mouseout(event) {

        var tooltip = global.chartObj.systemConf.tooltip;
        var tooltipObject = global.chartObj.eventHandler.tooltipElement;
        global.svg.select('g.highlight-group').select('g').attr('transform', null).style('visibility', 'hidden');//NO I18N
        tooltipObject.hide(tooltip.element);
        handleReverseHovering(false);
        makeCallback(undefined, "mouseout", event);//NO I18N
    }
    
    function click(event) {
        //To find if there is any point nearby
        var marker =global.util.getMarkerType();
        var leafletMapObj = global.leafletMapObj;
        var MINDIST = marker ? 30 : getMinDist(global.chartObj,marker); //Minimum distance a point should be from the cursor to be highlighted - 10 in pixel scale
        var series = global.chartObj.map_util.getSeries();
        //Hiding the tooltip
        var tooltip = global.chartObj.systemConf.tooltip;
        var tooltipObject = global.chartObj.eventHandler.tooltipElement;
        global.svg.select('g.highlight-group').select('g').attr('transform', null).style('visibility', 'hidden');//NO I18N
        tooltipObject.hide(tooltip.element);
        
        var latLngWidth = (leafletMapObj.getBounds().getEast() - leafletMapObj.getBounds().getWest() ) * Math.pow(2,(leafletMapObj._zoom - 1));
        var minDistanceForHighlight = MINDIST * latLngWidth / (leafletMapObj.getContainer().getBoundingClientRect().width);
        
        var chartType = global.chartObj.chartTypes[0].value;    
            
        var series = global.chartObj.map_util.getSeries();

        var seriesnumber = findSelectedPoint(series, event, minDistanceForHighlight,marker,global,current_id);

        if (seriesnumber) {
               makeCallback(seriesnumber, "click", event);//NO I18N
        }
             
    }
        
    function dblclick(event) {
        
        var series = global.chartObj.map_util.getSeries();
        var marker = global.util.getMarkerType();
        var leafletMapObj = global.leafletMapObj;
        var MINDIST = getMinDist(global.chartObj); //Minimum distance a point should be from the cursor to be highlighted - 10 in pixel scale
        
        var latLngWidth = (leafletMapObj.getBounds().getEast() - leafletMapObj.getBounds().getWest() ) * Math.pow(2,(leafletMapObj._zoom - 1));
        var minDistanceForHighlight = MINDIST * latLngWidth / (leafletMapObj.getContainer().getBoundingClientRect().width);
        var chartType = global.chartObj.chartTypes[0].value;    
        
        var seriesnumber = findSelectedPoint(series, event, minDistanceForHighlight,marker,global,current_id);
        
        if (seriesnumber) 
        {           
           makeCallback(seriesnumber, "doubleclick", event);     //NO I18N
        } 
    }

    function handleReverseHovering(show, seriesIndex) {
        var prevIndx ; 
        if (global.legend.reverse === true) {
            if (show === false) {
                seriesIndex = global.legend.activeIndex;
                if (!defined(seriesIndex)) {
                    return;
                }
            } else {
                prevIndx = global.legend.prevActiveIndex ? global.legend.prevActiveIndex : null ;
                global.legend.activeIndex = seriesIndex;
            }
            if(global.legend.children[seriesIndex])
            {
               if(show)
                {
                    global.legend.element.scrollTop =  global.legend.children[seriesIndex].offsetTop - global.legend.height/2;
                    global.chartObj.legend.component.highlightItem(global.legend.children[seriesIndex], global.chartObj.seriesdata[seriesIndex], seriesIndex, systemConf.legend, show);
                    global.legend.prevActiveIndex = global.legend.activeIndex;
                }
                else
                {
                    global.chartObj.legend.component.highlightItem(global.legend.children[seriesIndex], global.chartObj.seriesdata[seriesIndex], seriesIndex, systemConf.legend, show);
                }
            }
        }
    }

    function makeCallback(seriesnumber, eventType, leafletEvent) {
        
        if (!seriesnumber) {
            //default value of seriesnumber
            seriesnumber = {
                seriesIndex: 0,
                data: null
            }
        }
        
        if (!global.chartObj.chartRendered) {
            return;
        }
        
        var plotOptions = global.util.getSeries()[seriesnumber.seriesIndex].plotoptions;
        var type = global.util.getSeries()[seriesnumber.seriesIndex].type;
        var defaultPlotOptions = global.systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)];
        
        var userCallback = getEventConf(plotOptions, defaultPlotOptions, global.chartObj, eventType);
        if (userCallback != null) {
            var data = {
                "x": leafletEvent.containerPoint.x,//NO I18N
                "y": leafletEvent.containerPoint.y,//NO I18N
                "data": global.util.getDataset().getMetaInfoObj(global.chartObj, seriesnumber.data, seriesnumber.seriesIndex)//NO I18N
            };
            invokeFunction(userCallback, leafletEvent.originalEvent, data, global.chartObj);
        }
    }
    
    function getMinDist(chartObj,marker) {  
        var type = chartObj.chartTypes[0].value;
        var value;
        switch(type)
        {
            case geoscatter : value = marker ? 20 : 10; //20 - size of markers
            break;
            case geobubblepie:
            case geobubble : 
            {
                value = chartObj.zscale.range()[1]/4;
            }
            break;
            case geopie : value = 35; // size of pie ;
            break;
            default:value = 10;
    }
        return  value ;
    }
    
    function getHighlightGroupElement(seriesNumber, svg, type,marker) {
        
       //for rendering new pie on mouse hover event
       if(type == geopie || type == geobubblepie)
       {
            }
        var highlightElement = svg.select('g.highlight-group').select('g');//NO I18N
        var seriesdata = global.util.getSeries();
        var series = seriesdata[seriesNumber.seriesIndex];
        var color = global.chartObj.seriesColor[seriesNumber.seriesIndex];
        var scale = global.util.getScale();
        var type = $ZC.DataProcessor.helpers.getChartType(series.type, "numeric");//NO I18N
        
        var hoverOptions = global.util.getHoverOptions($ZC.DataProcessor.helpers.getChartType(series.type, "string")),//NO I18N
            extraOptions = {
                "color" : color, // series color//NO I18N
                "width":2//NO I18N
            };
        
        switch (type) {
            case geobubblepie:
            case geopie:       
            {
                var basicAttr = global.util.getPlotOptions(global.chartObj.chartTypes[0].name);
                var fillOpacity = basicAttr.fillOpacity;
                basicAttr.animation.enabled = false;
                basicAttr.fillOpacity = 1;
                
                var commonRendererProp = {
                    params: {
                    chartObj: global.chartObj,
                    commonPlotOptions: basicAttr,
                    dataset: global.chartObj.dataset
                    }
                }
                
                var highlightElementPie = appendEle(highlightElement, "g", [1], ".", "class", "highlightScatter");//NO I18N
                var xVal = global.chartObj.dataset.getActualX(seriesNumber.data);
                var data;
                //to identify the selected pie
                global.chartObj.piedata[0].forEach(function(d)
                {
                    if(global.chartObj.dataset.getActualX(d[0]) == xVal)
                        data = d;
                })

                var size = scale ? scale(global.chartObj.mapObj.plotted_data[xVal].size) : 35;
                                var pieRenderer = svg_plot_renderer.pie()
                                  .commonRendererProp(commonRendererProp)
                                  .plotarea({
                                  width: size,
                                  height: size,
                                  left: size / 2,
                                  top: size / 2
                                });
                                highlightElementPie.datum(data);
                                highlightElementPie.call(pieRenderer);
                                highlightElementPie.selectAll("path").filter(function(d){return (d.startAngle === d.endAngle) || !d.endAngle ;}).each(function(){ d3.select(this).style("display","none","important") });//NO I18N
                                var translate = d3.transform(highlightElementPie.selectAll("g").attr("transform")).translate;//NO I18N
                                highlightElementPie.selectAll("g").attr("transform","translate("+ (translate[0] - size/2) + "," + (translate[1] - size/2) +")");//NO I18N
                
               //resetting the attributes;
               basicAttr.animation.enabled = true;
               basicAttr.fillOpacity = fillOpacity;
            }
            case geobubble:
            {
                extraOptions.symbolSize = {
                    "inner" : 0.5, // Percentage of inner marker size//NO I18N
                    "outer" : 1 // Percentage of outer marker size//NO I18N
                };

                var z = scale ? type == 22 ? scale(global.util.getDataset().getZ(seriesNumber.data)) :  scale(global.chartObj.mapObj.plotted_data[seriesNumber.data[0]].size) : 35;
                if((type == geopie || type == geobubblepie)){
                    z = z + 2 ;  
                }
                var hoverRing = 6;
                hoverOptions.size = (z + hoverRing) / 10;
                addSVGmarker(highlightElement, null, hoverOptions, extraOptions);
                
            }
                break;
            case geoscatter:
            {
                extraOptions.symbolSize = {
                    "inner" : 1, // Percentage of inner marker size//NO I18N
                    "outer" : 2 // Percentage of outer marker size//NO I18N
                };
                marker && marker != "default" ? addCustomMarker(highlightElement, extraOptions,marker,true) : addSVGmarker(highlightElement, null, hoverOptions, extraOptions);//No I18N
            }
                break;
        }
        return highlightElement;
    }
    
    function findSelectedPoint(series, mouseEvent, minDistForHighlight,marker,global,curntId)
    {
        var chartType = global.chartObj.chartTypes[0].value;
        var result = null;
        var dataset = global.dataset;
        var scale = global.util.getScale();
        var minDist,minCircum,nearBubble,isWithinCurrentbubble,circumference,point,pointInBubble=false;        
        if (!minDistForHighlight) {
            minDistForHighlight = 0;
        }
        var filterSeries = function(subgroup, subGroupIndex) {
            var filteredSubgroup = new Array();
            if (subgroup && subgroup.constructor == Array) {
                filteredSubgroup = subgroup.filter(function(data, itemPos) {
                point = false;
                var latLng,id;
                chartType != geofilled ?  latLng = dataset.getLatLng(data) : id = dataset.getId(data) ;
                var mousePoint = global.leafletMapObj.latLngToContainerPoint(mouseEvent.latlng);
                if(latLng && data[1])
                {
                   var curntPoint = global.leafletMapObj.latLngToContainerPoint(latLng);
                   curntPoint.y =  marker && marker != "default" ? curntPoint.y - 16 : curntPoint.y;//No I18N
                   curntPoint.x =  marker && marker == "Type5" ? curntPoint.x + 8 : curntPoint.x;//No I18N
                   var distance = mathSQRT(mathPow(curntPoint.x - mousePoint.x, 2) + mathPow(curntPoint.y - mousePoint.y, 2));
                }
                if((latLng || id) &&  data[1])
                {
                   switch(chartType)
                    {
                           case geoscatter:
                                            point = nearestPoint(distance,data,subGroupIndex,itemPos,latLng);
                                            break;
                           case geobubblepie:
                           case geobubble:
                           {
                               var xVal = dataset.getActualX(data);
                               var radius = (chartType == geobubblepie ? scale(global.chartObj.mapObj.plotted_data[xVal].size) : global.util.getScale()(dataset.getZ(data)))/2;
                               if(nearestBubble(distance,radius))    
                               {
                                    if(chartType == geobubblepie ? findAngleInPie(mousePoint,curntPoint,i,data) : true)
                                      setMeasures(distance);
                               }
                           }
                           break;
                           case geofilled:
                               point = id === curntId;
                           break;
                           case geopie:
                               point = findAngleInPie(mousePoint,curntPoint,i,data) ? nearestPoint(distance,data,subGroupIndex,itemPos,latLng) :  false;
                           break;
                    }
                   if(point)
                   {
                       result={
                                  seriesIndex: i,
                                  subGroupIndex: subGroupIndex,
                                  itemPos: itemPos,
                                  data: data,
                                  latLng:latLng
                              }
                  }
                  
                }
              });
            }
            return filteredSubgroup.length > 0;
        };
        
        if (series && series.constructor == Array) {
            for (var i = series.length - 1; i >=0 ; i--) {
                if (!series[i].disabled) {
                    var filteredSeries = series[i].data.filter(filterSeries);
                    if(chartType == geoscatter || chartType == geofilled)
                    {
                        if(result != null)
                            break;
                }
            }
        }
        }
        return result !== null ? result : null;
        
        function findAngleInPie(mousePoint,curntPoint,seriespos,d)
        {
             var X = global.dataset.getX(d);
             var pieRenderer = global.chartObj.renderedPiedata[X];
             var pieData = pieRenderer[seriespos];
             var theta1 = pieData.startAngle,
                 theta2 = pieData.endAngle,
                    angle = mathAtan2((mousePoint.x - curntPoint.x), -(mousePoint.y - curntPoint.y));
            return isAngleInside(theta1, theta2, angle);
        }
        function nearestBubble(distance,radius)
        {
            circumference = 2 * mathPI * radius;
            isWithinCurrentbubble = (distance <= radius);
            isWithinCurrentbubble ? pointInBubble = true : distance = distance - radius;
            nearBubble =(minDist ? distance < minDist : true &&  distance < minDistForHighlight) ;
            return isWithinCurrentbubble ? minCircum ? circumference < minCircum : true :pointInBubble ? false : nearBubble ;
    }
        function nearestPoint(dist)
        {
            if (dist <= minDistForHighlight && (minDist ? dist <= minDist  : true)) {
                minDist = dist;
                minDistForHighlight = mathAbs(dist - minDistForHighlight);
                return true;
            }
            return false;
        }
        function setMeasures(distance)
        {
            minDistForHighlight = distance;
            minDist = nearBubble ? distance : minDist;
            minCircum = isWithinCurrentbubble ? circumference : minCircum;
            point = true;
        }
    }
        
};

function enableToolTip(global,event,seriesnumber,dataset,tooltipObject)
{
    d3.event = event.originalEvent;
    var containerPoint = d3.mouse(global.chartObj.container.node());

    var tooltipPosition = {
        left: containerPoint[0],
        top: containerPoint[1]
        }
        
    var dLeft = containerPoint[0] - event.originalEvent.clientX,
    dTop = containerPoint[1] - event.originalEvent.clientY;                       
    tooltipPosition.left -= dLeft;                       
    tooltipPosition.top -= dTop;                       
    tooltipPosition.dLeft = dLeft; 
    tooltipPosition.dTop = dTop; 

    var tooltipArguments = {
        "dataset": dataset,//NO I18N
        "seriesindex": seriesnumber.seriesIndex,//NO I18N
        "subseriespos": seriesnumber.subGroupIndex,//NO I18N
        "itempos": seriesnumber.itemPos,//NO I18N
        "color": global.chartObj.seriesColor //NO I18N
    }
    tooltipObject.show(global.chartObj, tooltipPosition, null, true, tooltipArguments);
}
