//$Id$
map_ui_util.legend = function(chart) {
        
        var showLegendByDefault = chart.userdata.geo.showLegendByDefault;
        var map = chart.mapObj.map;
        var mapHeight = map.getSize().y;
        var mapLegend;
        
        var mapLegendControl = L.Control.extend({
            options: {
                position: 'topright'//NO I18N
            },
            initialize: function(options) {
                L.setOptions(this, options);
                this._legendHolder = null;
                this._legendShown = true;
            },
            onAdd: function(map) {
                var container = this._container = L.DomUtil.create('div', 'zcmap-legend-container');//NO I18N
                this._legendToggle = L.DomUtil.create('div', 'zcmap-legend-toggle', container);//NO I18N
                this._legendHolder = L.DomUtil.create('div', 'zcmap-legend-holder', container);//NO I18N
                this._setEvents();
                return container;
            },
            onRemove: function(map) {
                L.DomEvent.removeListener(this._legendToggle, 'click', this._update);//NO I18N
            },
            getLegendHolderElement: function() {
                return this._legendHolder;
            },
            _setEvents: function() {
                L.DomEvent.addListener(this._legendToggle, 'click', function(event) {//NO I18N
                    this.maintainLgndHideState=false;
                    this._update();
                    L.DomEvent.stopPropagation(event);
                }, this);
                L.DomEvent.addListener(this._legendHolder, 'mousewheel', L.DomEvent.stopPropagation);//NO I18N
                L.DomEvent.addListener(this._legendHolder, 'click', L.DomEvent.stopPropagation);//NO I18N
                L.DomEvent.addListener(this._legendHolder, 'dblclick', L.DomEvent.stopPropagation);//NO I18N
                L.DomEvent.addListener(this._legendHolder, 'mousemove', L.DomEvent.stopPropagation);//NO I18N
            },
            _update: function() {
                this._legendShown ? this.hideLegend() : this.showLegend();
            },
            showLegend : function(){
                if(this.maintainLgndHideState)
                {
                    return;
                }
                this._legendShown = true;
                this.setStyles();                                
            },
            hideLegend: function() {
                this._legendShown = false;                
                var width = this._legendHolder.offsetWidth;
                d3_select(this._container).style({
                    "transform": "translateX(" + width + "px)"//NO I18N
                });
                this.maintainLgndHideState =true;                
                d3.select(this._legendToggle).attr("tip","Show Legend");//NO I18N
            },
            setStyles: function(update) {
                //check for legend to be show or to be hidden 
                    if(update)
                    {
                d3_select(this._container).style({
                    "margin-right": "0px",//NO I18N
                    "width": "auto",//NO I18N
                            "height": "auto"//NO I18N
                        });
                        this.hideLegend();
                    }
                    else
                    {
                        d3_select(this._container).style({
                            "margin-right": "0px",//NO I18N
                            "width": "auto",//NO I18N
                    "height": "auto",//NO I18N
                    "transform": "translateX(0px)",//NO I18N
                    "transition": "transform .3s"//NO I18N
                });
                    }
                d3_select(this._legendHolder).style({                    
                    "background" : "white",//NO I18N
                    "position":null,//NO I18N
                    "display" : "inline-block",//NO I18N
                    "verticle-align" : "top",//NO I18N
                    "left": "40px",//NO I18N
                    "top": "0px",//NO I18N
                    "padding":"7px 5px 5px 5px",//NO I18N
                    "vertical-align":"top",//NO I18N
                    "border-bottom-left-radius":"3px"//NO I18N
                });
                d3_select(this._legendToggle).style({
                    "display" : chart.systemConf.legend.hidelegendcontrol ? "none" : "inline-block", //NO I18N
                }).attr("tip","Hide Legend");//NO I18N
                if (update) {
                    this._legendShown = !this._legendShown;
                    this._update();
                }
            },
             showToggle : function(){
                d3.select(this._legendToggle).style({
                    "transform" : "translateX(0px)",//NO I18N
                    "transition" : "transform .3s"//NO I18N
                });
            },
            hideToggle : function(){
                d3.select(this._legendToggle).style({
                    "transform" : "translateX(30px)",//NO I18N
                    "transition" : "transform .3s"//NO I18N
                });
            }            
        });
        
        this.legend.init = function() {
            mapLegend = new mapLegendControl();
            mapLegend.addTo(map);
            if(showLegendByDefault == "false")
            {
                  mapLegend._legendShown = false;
                  
            }
            chart.legendarea.element = d3_select(mapLegend.getLegendHolderElement());      
        };
        this.legend.checkAndSetStyles = function(update, legendShown){
            if(mapLegend){
                if(legendShown){
                    mapLegend.setStyles(!mapLegend._legendShown);
                    // mapLegend.showLegend();
                } else {
                    mapLegend.remove();
                }
                
            }
        };
        
        this.legend.hide = function() {
            mapLegend.hideLegend();
        };
        
        this.legend.show = function() {
            mapLegend.showLegend();
        };
        
        this.legend.remove = function() {
            mapLegend.remove();
        }
    };