//$Id$
/*
 Map properties and functions based on type of map. _GeoChart is intended to be used by internal javascript functions of GeoChart.
 */
$ZC._GeoChart = {};

$ZC._GeoChart._getMapObjectFactroy = function() {
    var _abstractMapObj = {
        //Properties to be implemented mandatory
        container: null,
        map: null,
        
        plotted_data: null,
        unknowndata_Key: null,
        basegeorole: null,
        //Super class functions with implementations
        getBounds: function() {
            var bound = L.latLngBounds(arguments);
            return {
                northEast: bound._northEast,
                southWest: bound._southWest
            }
        }
    };
    
    var _mapObjFactory = {};
    var leafletConstructor, svgmapConstructor, mapboxConstructor;
    
    //Lazy loading the singletons of mapobject constructors
    _mapObjFactory.leaflet = function() {
        if (!leafletConstructor) {
            leafletConstructor = $ZC._GeoChart.getLeaflet(_abstractMapObj);
        }
        return leafletConstructor;
    };
    _mapObjFactory.svgmap = function() {
        if (!svgmapConstructor) {
            svgmapConstructor = $ZC._GeoChart.getSVGMap(_abstractMapObj);
        }
        return svgmapConstructor;
    };
    
    _mapObjFactory.mapbox = function() {
        if (!mapboxConstructor) {
            mapboxConstructor = $ZC._GeoChart.getLeaflet(_abstractMapObj);
        }
        return mapboxConstructor;
    };
    return _mapObjFactory;
};