//$Id$
var ZDBMenu = new function()
{
 this.setForRelEl = function(element, action)
 {
   var relId = element.getAttribute("relid");
   if(relId != null)
   {
     var len = "iconitem".length;
     var relEl = document.getElementById(relId);
     var bClass = this.getBaseClass(relEl.className);
     if(action == 'hover' || action == 'over')
     {
        this.setMouseOver(relEl, len, bClass);
     }
     else if(action == '' || action == 'out')
     {
        this.setMouseOut(relEl, bClass);
     }
   }
 }

 this.getBaseClass = function(className)
 {
   var bClass = className.split(" ");
   for(var i = 1;i < bClass.length;i++)
   {// i == 0 is iconitem
     if(bClass[i].trim().length > 0)
     {
       return bClass[i];
     }
   }
 }

 this.setMouseOver = function(element, len, baseClass)
 {
   var oldClass = element.className.substring(len);
   element.setAttribute("oldClass", oldClass);
   element.className = "iconitem " + baseClass + " hover";
 }

 this.setMouseOut = function(element, baseClass)
 {
   var oldClass = element.getAttribute("oldClass");
   element.className =  "iconitem " + (oldClass ? oldClass : baseClass);
   element.removeAttribute("oldClass");
 }

 this.zdbHighLighter = function(element, baseClassName, action)
 {
   if((element.getAttribute("enabled")=="false") || (!baseClassName))
   {
     return;
   }
   element.className = "iconitem " + baseClassName +" " + action;
   this.setForRelEl(element, action);
 }

  this.save = function(element, event, saveType)
  {
    if(saveType == 'TableDesign')
    {
      var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
      gridObj.save();
    }
    else if(ZDBClientUI.selectedTab)
    {
      var view = ZDBClientUI.getViewObj(element,"view");
      if(ZDBUtil.isViewModified(view)){				//Save Tabular only when the view is modified.
    	  ZDBClientUI.selectedTab.view.save();  
      }
      else{
    	  ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.resaveInfo"));
    	  return;
      }
      
    }
  }

    this.showMenu = function(el,event, menuId,close,view)
    {
      var menu = $(menuId);
      return ZDBMenu.showMenuEl(el,event, menu,close,view);
    }

    this.showModuleMenu = function(el,event,menuName,moduleName,close,view)
    {
      var menu = ZDBContentCache.appendAndGet(menuName,moduleName,document.body);
      if(menu == null){return;}
      return ZDBMenu.showMenuEl(el, event, menu, close, view);      
    }
    
    this.showDashOptsMenu = function (el, event, menuName, moduleName, closeFunc, menuType) {
        var menu = ZDBContentCache.appendAndGet(menuName, moduleName, document.body);
        if (menu == null) {
            return;
        }
        ZDBUtil.setNamedChildEls(menu,menu);
        var view = el.view;
        menu.view = view;
        if(view.exportPerm || view.permissions.exportPerm){
        	ZDBExport.enableDisableExpMailSubMenuItems($("ExportImage"),view.type,view);
        }
        el.topDerc = 3;
        ZRSMenu.showMenu(event, el, menu, menuType, closeFunc);
        return menu;
    }
    
    this.showModuleMenuRight = function(el,event,menuName,moduleName,close,view)
    {
      var menu = ZDBContentCache.appendAndGet(menuName,moduleName,document.body);
      if(menu == null){return;}
      ZDBMenu.showMenuEl(el,event, menu,close,view,2);
    }

    this.showDropDownMenu = function(el,event,menuName,moduleName,place,isLegendSort)
    {
        var menu = ZDBContentCache.appendAndGet(menuName,moduleName,document.body);
        if(menu == null){return;}
        if(menuName=="Sort_Chart")
        {
            var dispStatus = ZAChartSortMenu.SHOW_LEGEND_MENU;
            if(isLegendSort===null){dispStatus = ZAChartSortMenu.SHOW_AXIS_MENU;}
            ZAChartSortMenu.showSubMenu(dispStatus);
        }
        if(place=="left")
        {
            var posVal = ZDBMenu.checkAndGetPositionVal(el, menu, menuName, moduleName, event);
            var leftVal = posVal[0];
            var topVal = posVal[1];
        }
        else
        {
            var menuEl = ZDBContentCache.getContent(menuName,moduleName);
            ZRSMenu.showMenu(event,null,menu,1);
            leftVal = ZDBUtil.getObjLeft(el) + el.offsetWidth - menuEl.offsetWidth;
            topVal = ZDBUtil.getElementAbsolutePos(el).y - menuEl.offsetHeight;
            topVal = parseInt(topVal);
            leftVal = parseInt(leftVal);
            ZDBUtil.stopEventBubble(event);
        }
        menu.style.top = topVal + "px";
        menu.style.left = leftVal + "px";
        ZRSMenu.showMenu(event,null,menu,1);
        ZDBUtil.stopEventBubble(event);
    }

    // return position for menu based on width of menu el. If menu width exceeds screen width,
    // place menu on TOP position otherwise DOWN position
    this.checkAndGetPositionVal = function(el, menu, menuName, moduleName, event)
    {
        var screenWidth = document.body.offsetWidth;
        var leftVal = ZDBUtil.getObjLeft(el);
        var topVal = ZDBUtil.getObjTop(el) + el.offsetHeight;
        var menuEl = ZDBContentCache.getContent(menuName, moduleName);
        ZRSMenu.showMenu(event, null, menu, 1);
        if(menuEl.offsetWidth + leftVal + 5 > screenWidth)
        {
            leftVal = parseInt(ZDBUtil.getObjLeft(el) + el.offsetWidth - menuEl.offsetWidth);
            topVal = parseInt(ZDBUtil.getElementAbsolutePos(el).y - menuEl.offsetHeight);
        }
        return [leftVal, topVal];
    }

    this.showHideMenuItems = function(menu,gridObj,el)
    {
        this.showHideDrillMenu(menu,gridObj,el);
        this.showHideGeocodingMenu(menu,gridObj,el);
    }
    this.showHideGeocodingMenu = function(menu,gridObj,el)
    {
        var menuitem = $('ZDBTblGeocoding');
        if(el && el.id=="ZDBColPropMenuQT") {
            menuitem = $("ZDBTblGeocodingQT");
        }
        if(menuitem)
        {
            jQuery(menuitem).show();
            if(!gridObj){return;}
            var selCol = gridObj.getSelectedColHead();
            var colObj = selCol ? selCol.colObj : menu.colObj;
            if(!colObj)
            {
                menuitem.setAttribute("enabled", false);
                menuitem.style.display = "none";
                return;
            }
            var type = colObj.type;
            type = (type=="RELCOL" || type=="REFCOL") ? colObj.relColType : type; //NO I18N
            if(menuitem.style.display !== 'none')
            {
                menuitem.style.display = (type=="GEO") ? ZDBUtil.visibleTrStyle : 'none';
            }
            this.updateMenuItemProps(menuitem);
        }
       
    }
    this.showHideDrillMenu = function(menu,gridObj,el)
    {
        var menuitem = $('ZDBTbldrill');
        if(el && el.id=="ZDBColPropMenuQT") {
            menuitem = $("ZDBTbldrillQT");
        }
        
        if(menuitem)
        {
            jQuery(menuitem).show();
            if(!gridObj){return;}
            var selCol = gridObj.getSelectedColHead();
            var colObj = selCol ? selCol.colObj : menu.colObj;
            if(!colObj)
            {
                menuitem.setAttribute("enabled", false);
                menuitem.style.display = "none";
                return;
            }
            var type = colObj.type;
            type = (type=="RELCOL" || type=="REFCOL") ? colObj.relColType : type; //NO I18N
            if(menuitem.style.display !== 'none')
            {
                menuitem.style.display = (jQuery.inArray(type, ZDBUtil.allowedTypes_for_Drill)>=0) ? ZDBUtil.visibleTrStyle : 'none';
            }
            this.updateMenuItemProps(menuitem);
        }
    }
    this.updateMenuItemProps = function(menuitem)
    {
        var enabled = (menuitem.style.display==='none') ? false : true;
            if(enabled)
            {
                jQuery(menuitem).prev("tr").children("td").removeClass("iconitem3"); //NO I18N
            }
            else
            {
                var el = jQuery(menuitem).prev("tr").children("td").addClass("iconitem3");//NO I18N
                if(el.length > 0) {
                    el[0].setAttribute("menuitemclass",el[0].className);
                }
            }
            menuitem.setAttribute("enabled",enabled);
    }
    this.showMenuEl = function(el,event, menu,close,view,menuType)
    {
      var curView = ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
      if(curView && curView instanceof ZDBDataGrid)
      {
        menu.gridObj = curView;
        var cellObj = ZDBDataGrid.getLastFocusCell(curView);
        if(cellObj)
        {
          menu.cellObj = cellObj;
          menu.colObj = cellObj.colObj;
          menu.rowObj = cellObj.rowObj;
          curView.setCellFocus(cellObj, false);
        }
      }

      if(menu.getAttribute("isEnableDisable") == "true")
      {
        var list = jQuery(menu).find('li a');
        this.enableDisableMenuItems(ZDBClientUI.selectedTab.view,list,false);        
        this.showHideMenuItems(menu,curView,el);
      }
      if(view)
      {
        menu.view = view;
      }
      ZRSMenu.showMenu(event, el, menu,menuType);
      return;
    }

 this.showNewObjectsPopup = function(el,event, isDashboard)
 {
   if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/autogen/ZDBSampleViews.js",this,ZDBMenu.showNewObjectsPopup,[el,event,isDashboard]))
   {
 	return;
   }
   if(this.warnIfNotLoggedIn())
   {
     return;
   }
   this.showModuleMenu(el, event,"New_Objects_Menu","GridMenu",true); //No I18N
   var menu = $("ZDBNewObjectsMenu");
   if(!ZDBGlobal.ISNEWLAYOUT) {
        var top = menu.offsetTop;		
        var left = menu.offsetLeft;
        menu.style.top = top + 10 + "px";
        menu.style.left = left - 9 + "px";		
        ZDBPopUpMenu.hideSeparator(menu);
    } else {
         var ZRSMenuTop = menu.getElementsByClassName("ZRSMenuTop"); //No I18N
         while(ZRSMenuTop.length) {
             ZRSMenuTop[0].parentElement.removeChild(ZRSMenuTop[0]);
         }
     }
   var autoAnalysisMenuItem = jQuery('#ZRSAutoAnalysis'); //No I18N
   if(autoAnalysisMenuItem && ZDBClientUI.isDBOwner)
	 {
	   if(isDashboard)
		 {
	  	 autoAnalysisMenuItem.hide();
		 }
	   else
		 {
	  	 autoAnalysisMenuItem.show();
		 }
	 }
 }
this.showViewRelationsPopup = function(el,event)
{
    var view = ZDBClientUI.getViewObj(el,"view");    //No I18N
	if(this.warnIfNotLoggedIn())
    {
	     return;
	}
	if(ZDBGlobal.ISNEWLAYOUT) {
        this.showModuleMenu(el, event,"ERD_View_Chart_Relationship","GridMenu",true,view); //No I18N
    } else {
        this.showModuleMenuRight(el, event,"ERD_View_Chart_Relationship","GridMenu",true,view); //No I18N
    }
	 var menu = jQuery('#ZDBERDGChartMenu'); //No I18N
	 var pos = menu.position();
	 var top = pos.top;
	 var left = pos.left;
	 menu.css({top:top + 10,left:left - 9});
   ZDBPopUpMenu.hideSeparator(menu);
}

 this.showExploreNewPopup = function(el,event)
 {
   var expMenu = ZDBContentCache.appendAndGet("Exp_New_Menu","GridMenu",document.body);
   if(!expMenu){
	   return;
   }
   if(!ZDBClientUI.isDBOwner)
   {
     $("ZDBEXPNEWTABLEROW").style.display = "none";
   }
   this.showMenuEl(el, event,expMenu,true);
   var menuEl = jQuery(expMenu);
   if(el.id == 'ZDBEXPLORERNEW_TITEM')
   {
        menuEl.children('span').show(); //No I18N
        var pos = menuEl.position();
        var top = pos.top;
        var left = pos.left;
        menuEl.css({top:top + 10,left:left - 9});
   }
   else
   {
        menuEl.children('span').hide(); //No I18N
   }
   if(typeof ZDBExpViewHandler != "undefined"){
    var types = ["Table","QueryTable"]; //No I18n
    var tableList = ZDBExpViewHandler.getViewListForGivenTypes(types);
    $("ZDBExpNewReport").style.display = (tableList.length > 0) ? "" : "none";
   }
   ZDBPopUpMenu.hideSeparator(expMenu);
 }
  
 this.showExplorerLocalDBConnListPopup = function(el,event)
 {
    var expLocalDBMenu = ZDBContentCache.appendAndGet("Exp_LocalDBConnList_Menu","GridMenu",document.body);
    this.showMenuEl(el,event,expLocalDBMenu,true);
 }
 
 this.showConnSettingsMenu = function(el,event)
 {
    var parDiv = ZDBUtil.getParentWithAttributeValue(el, "isparent", "true");		//No I18N
    var expCreatorMenu = ZDBContentCache.appendAndGet("Exp_DataSources_Menu","GridMenu",document.body);
    this.showMenuEl(el,event,expCreatorMenu,true,null,5);
    
    $("ConnEditMenuItem").setAttribute("parId",parDiv.id);
    $("ConnReAuthMenuItem").setAttribute("parId",parDiv.id);
    $("CloudConnEditMenuItem").setAttribute("parId",parDiv.id);
    $("CloudSyncEditMenuItem").setAttribute("parId",parDiv.id);
    $("DelConnMenuItem").setAttribute("parId",parDiv.id);
    
    if(parDiv.getAttribute("isauthreq") != "true")
    {
        $("ConnReAuthMenuItem").style.display="none";
    }
    else
    {
    	$("ConnReAuthMenuItem").style.display="";
    }
    if(parDiv.getAttribute("isCloudDBSrc") == "true" || parDiv.getAttribute("isODataSrc") == "true")
    {
         $("ConnEditMenuItem").style.display = "none";
		 //--ZROP Changes--
		 if(ZDBGlobal.IS_ONPREMISE_BUILD&&ZDBGlobal.IS_FREE_EDITION){
			 $("CloudSyncEditMenuItem").style.display = "none";
		 }
		 //--ZROP Changes--
    }
    else
    {
        $("CloudConnEditMenuItem").style.display = "none";
        $("CloudSyncEditMenuItem").style.display = "none";
    }
    
    $("DelConnMenuItem").style.display= (parDiv.getAttribute("delconn") == "true") ? "" : "none";
 }
 
 this.showExploreSharePopup = function(el,event)
 {
   if(ZDBClientUI.isDBOwner)
   {
     var contentName = (ZDBGlobal.newShareEnabled && !BROWSER.isIE9 == 1) ? "Exp_New_Share_Menu" : "Exp_Share_Menu"; // no I18N
     var expShareMenu = ZDBContentCache.appendAndGet(contentName,"GridMenu",document.body);
     expShareMenu.setAttribute("dbId",ZDBClientUI.dbId);
     if(ZDBGlobal.IS_ONPREMISE_BUILD)
     {
    	 var IsConfigured = zroptopbar.isMailConfigured();     
         if(!IsConfigured)
           {
             ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrop.mail.notify.js.errorMsg",ZROPConst.MALTABADDR));
             return;
           }
     }
     this.showMenuEl(el, event,expShareMenu,true);
     
     var shareToSupport = $("ZDBExpShareToSupportMenuItem");
     var removeShareToSupport = $("ZDBExpRemoveShareToSupportMenuItem");
     if(shareToSupport && removeShareToSupport && ZDBClientUI.showShareToSupport){
	     if(ZDBClientUI.isDBSharedToSupport == 1)
	     {
	    	 shareToSupport.style.display="none";
	    	 removeShareToSupport.style.display="";
	     }
	     else
	     {
	    	 shareToSupport.style.display="";
	    	 removeShareToSupport.style.display="none";
	     }
     }
     else
     {
    	 //To hide the share to support option for OnPremise -- nshankar 
         shareToSupport.style.display="none";
         removeShareToSupport.style.display="none";
     }
          
       if(ZDBClientUI.showMakeDBPublic)
       {
           $("ZDBMakePublicQa").style.display="";
       }
       else
       {
           $("ZDBMakePublicQa").style.display="none";
       }
   }
   else
   {
     var contentName = (ZDBGlobal.newShareEnabled && !BROWSER.isIE9 == 1) ? "Explorer_New_Grp_User_Shr_Menu" : "Explorer_Grp_User_Shr_Menu"; // No I18N
     var expGrpShareMenu = ZDBContentCache.appendAndGet(contentName,"GridMenu",document.body);
     expGrpShareMenu.setAttribute("dbId",ZDBClientUI.dbId);
     this.showMenuEl(el, event,expGrpShareMenu,true);
   }
 }
}

ZDBMenu.setToolbarStatus = function(gridObj)
{
    if(gridObj.isForImport ||
       (gridObj.subtype && gridObj.subtype == "EnterData"))
    {
      return;
    }
    var gridType = gridObj.type;
    var colHeaders = gridObj.selectedCols;
    var colLen = colHeaders.length;

    if(gridType == 'Table')
    {
      var dataTypeEl = ZDBClientUI.sheetDataTypeEl;
      if(dataTypeEl)
      {
        dataTypeEl.setAttribute("disabled",true);
        var type = "";
        var header;
        if(colHeaders.length == 1)
        {
          header = colHeaders[0];
          type = header.type;
        }
        else if(gridObj.lastCellFocus)
        {
          header = gridObj.lastCellFocus.colObj;
          type = header.type;
        }
        var index = getDataIndex(dataTypeEl,'defaultvaltype',type);
        if(index > -1)
        {
          if(colHeaders.length == 1 && ZDBClientUI.isDBOwner)
          {
            dataTypeEl.removeAttribute("disabled");
            dataTypeEl.origVal = dataTypeEl[index].value;
            dataTypeEl.colName = header.displayName;
            dataTypeEl.tableName = gridObj.displayName;
            dataTypeEl.header = header;
          }
          dataTypeEl[index].selected = true;
        }
      }
    }

    if(colLen == 0)
    {
        var colObj = ZDBDataGrid.getCurColHead(gridObj);
        if(!colObj)
        {
            ZDBMenu.setDefaultToolbarStatus();
            return;
        }
    }
}

ZDBMenu.setDefaultToolbarStatus = function()
{

}

ZDBMenu.saveViewAs = function(element, event)
{
	var tab  = ZDBClientUI.selectedTab;
	var view = tab.view;
	var viewType = view.type;
  if(tab == null || ZDBUtil.isNewView(view) || ZDBUtil.isViewModified(view))
  { 
	  if( viewType == "Report" || viewType == "Table" )
	  {
		  ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.saveAsErr"));
	  	  return;
	  }
     if(ZDBUtil.isNewView(view)) {
        ZDBMenu.save(element, event);
        return;
     }
  }
  
  var canSave = (viewType == "Report" || viewType == "Table" || viewType == "Dashboard") ? true :ZDBAnalysisEditViewMode.validateView(view);//No I18N
  if(canSave==false)
  {
    return;
  }


  if(viewType == "AnalysisView" ||viewType == "Pivot" || viewType == "SummaryView" || viewType == "Dashboard" ||viewType == "Table")
  {
  	ZDBCreateViewAPI.saveAsNewView(view);
  }
  else
  {
	view.saveAsNewView();
  }
}

ZDBMenu.addShadow = function(el)
{
	var el = (el.iframe!=null && el.iframe.tagName.toLowerCase() == "iframe")?el.iframe:el;// No I18N
	if(el.shadowAdded)
        {
	  return;
        }
	var className = el.className;
  el.className = (className) ? className + " ZRSShadow" : "ZRSShadow";
	el.shadowAdded = true;
	return;
}


ZDBMenu.updateToolbar = function(view)
{
	if(ZDBGlobal.ISNEWLAYOUT || ZDBClientUI.standAlone || ZDBClientUI.notLoggedIn){
		//For new layout and for embedded views
		ZDBMenu.updateToolbar_NEW(view);
		return;
	}
  var type=view.type;
  var extraViewParentNode = ZDBClientUI.$$("ZDBViewEl");
  var viewParentNode = ZDBClientUI.$$("ZDBSheetActions");
  viewParentNode.view = view;
  extraViewParentNode.view = view;
  viewParentNode.style.display = "";
  jQuery(viewParentNode).find("li a").bind("mousemove",function(event){ZDBToolTip.showTip(event);});//No I18N  
  if(window.ZDBDataGrid && view instanceof ZDBDataGrid)
  {
    ///PK: should check for other types
    viewParentNode.gridObj = view;
  }
  var childNodes = viewParentNode.childNodes;
  var toolbarTr = null;
  
  for(var i=0, j = childNodes.length;i < j; i++)
  {
  	if(!(childNodes[i].getAttribute(type + "Obj") == "true") || ((ZDBClientUI.standAlone || ZDBClientUI.notLoggedIn || ZDBGlobal.integrated) && (childNodes[i].getAttribute("notLoggedInOrStandAlone") == "false")))
    {
      childNodes[i].style.display="none";//NO I18N
      continue;
    }
    childNodes[i].style.display = ZDBUtil.visibleTrStyle;
    toolbarTr = childNodes[i];
  }
      
  if(!(view instanceof DummyView))
  {
    if(toolbarTr)
    {
      toolbarTr.style.display="";
      view.toolbar = toolbarTr;
      ZDBUtil.setNamedChildEls(toolbarTr,view.toolbar);
      this.enableDisableMenuItems(view,jQuery(toolbarTr).find("li a"),true);
      ZDBMenu.updateViewTitleNDesc(view);
      this.groupToolbarItems(toolbarTr);
      ZDBUtil.ShowHideForceRefresh(view,true);
    }
  }
  else if(view instanceof DummyView && (view.type != "QueryTable")){
	  if(toolbarTr){
		  toolbarTr.style.display="none";
	  }
  }
  //for highlighting save option
  if(!(view instanceof DummyView) && toolbarTr)
  {
	  if(view.modified)
	  {
		 ZDBUtil.highlightSave(view); 
	  }
	  else
	  {
		  ZDBUtil.removeHighlight(view);
	  }
  }
}

ZDBMenu.updateToolbar_NEW = function(view)
{
  var type=view.type;
  var extraViewParentNode = ZDBClientUI.$$("ZDBViewEl");
  var viewParentNode = ZDBClientUI.$$("ZDBSheetActions");
  viewParentNode.view = view;
  extraViewParentNode.view = view;
  if((ZDBClientUI.standAlone || ZDBClientUI.notLoggedIn) && view.type != "VUDSheet") {
      ZDBEmbed.constructToolbar(view, viewParentNode);
  }
  if(ZDBGlobal.ISNEWLAYOUT && typeof ZDBExpViewHandler !== "undefined" && (ZDBExpViewHandler.viewTypes.indexOf(type) == -1)) {
      viewParentNode.style.display = "none";
      return;
  }
  viewParentNode.style.display = "";
  jQuery(viewParentNode).find("li a").bind("mousemove",function(event){ZDBToolTip.showTip(event);});//No I18N  
  if(window.ZDBDataGrid && view instanceof ZDBDataGrid)
  {
    ///PK: should check for other types
    viewParentNode.gridObj = view;
  }
  var childNodes = (ZDBGlobal.ISNEWLAYOUT && type != "Explorer") ? viewParentNode.getElementsByClassName("secondRow") : viewParentNode.childNodes;//No I18N
  var toolbarTr = (ZDBGlobal.ISNEWLAYOUT && type == "Dashboard") ? viewParentNode.childNodes[0] : null;
  for(var i=0, j = childNodes.length;i < j; i++)
  {
  	if(childNodes[i].className != "embedToolbarPadding" && (childNodes[i].getAttribute(type + "Obj") != "true" || (ZDBClientUI.standAlone || ZDBClientUI.notLoggedIn || ZDBGlobal.integrated) && childNodes[i].getAttribute("notLoggedInOrStandAlone") == "false") || (ZDBGlobal.ISNEWLAYOUT && !view.editMode && type == "Dashboard"))
    {
      childNodes[i].style.display="none";//NO I18N
      continue;
    }
    childNodes[i].style.display = ZDBUtil.visibleTrStyle;
    toolbarTr = (ZDBGlobal.ISNEWLAYOUT) ? viewParentNode.childNodes[0] : childNodes[i];
  }
      
  if(!(view instanceof DummyView))
  {
    if(toolbarTr)
    {
      toolbarTr.style.display="";
      view.toolbar = toolbarTr;
      ZDBUtil.setNamedChildEls(toolbarTr,view.toolbar);
      if(!ZDBGlobal.ISNEWLAYOUT && !((ZDBClientUI.standAlone || ZDBClientUI.notLoggedIn || ZDBGlobal.integrated) ^ !ZDBEmbed.removeToolbar)) {
      	this.enableDisableMenuItems(view,jQuery(toolbarTr).find("li a"),true);
      }
      ZDBMenu.updateViewTitleNDesc(view);
      this.groupToolbarItems(toolbarTr);
      ZDBUtil.ShowHideForceRefresh(view,true);
    }
  }
  else if(view instanceof DummyView && (view.type != "QueryTable")){
	  if(toolbarTr){
		  toolbarTr.style.display="none";
	  }
  }
  //for highlighting save option
  if(!(view instanceof DummyView) && toolbarTr)
  {
	  if(view.modified)
	  {
		 ZDBUtil.highlightSave(view); 
	  }
	  else
	  {
		  ZDBUtil.removeHighlight(view);
	  }
  }
  if(ZDBGlobal.ISNEWLAYOUT && type != "Explorer") {
      ZDBMenu.viewSpcToolbarUpdate(view, toolbarTr, type);
      ZDBMenu.checkButtonPermissions(view, toolbarTr, type);
  }
}

ZDBMenu.checkButtonPermissions = function(view, toolbarTr, type) {
    var isDBOwner = ZDBClientUI.isDBOwner;
    var objId = view.objId;
    var perm = view.permissions;
    var toolbarBtns = toolbarTr.getElementsByTagName("li");
    for(var i = 0; i < toolbarBtns.length; i++) {
        var btn = toolbarBtns[i];
        var attrs = btn.attributes;
        if(!attrs) {
            continue;
        }
        if(attrs["createNewPermitted"] && !(ZDBClientUI.ISDBOWNER || ZDBNavigation.viewsCountByType[0] || ZDBNavigation.viewsCountByType[1])) {
            btn.style.display = "none";
            continue;
        }
        if(attrs["disableOnNew"] && ZDBUtil.isNewView(view)) {
            btn.style.display = "none";
            continue;
        }
        if(attrs["isDBOwnerReq"] && !ZDBClientUI.isDBOwner) {
            btn.style.display = "none";
            continue;
        }
        if(attrs["zdbModPermReq"] && !perm.designModify) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isSystemTable"] && view.isSystemTable) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isAddPermReq"] && !perm.add) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isVUDPermReq"] && !perm.vud) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isAddPermReq"] && !(perm.deleteAll && perm.deletePerm)) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isSaveAllowed"] && !(perm.designModify || perm.add || perm.modify || perm.deleteAll || perm.deletePerm || view.enterData)) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isImportPermReq"] && !(perm.appendImport || perm.truncateImport || perm.updateImport || perm.deleteupdateadd)) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isExportPermReq"] && !perm.exportPerm) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isSharePermReq"] && !perm.share) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isEmailReportPermReq"] && !perm.emailrptperm) {
                btn.style.display = "none";
                continue;
        }
        if(attrs["isPublishPermReq"] && !perm.publishperm) {
                btn.style.display = "none";
                continue;
        }
        btn.style.display = "";
    }
}

 ZDBMenu.viewSpcToolbarUpdate = function (view, toolbarTr, type) {
        toolbarTr.getElementsByClassName("firstRow")[0].style.height = (type == "Dashboard") ? "50px" : "unset";
        var dispCondition = (!view.editMode || type == "Table" || type == "Report");//NO I18N
        var showHide = ZDBUtil.getElsWithTagNAttrWithVals(toolbarTr, "mode", ["showMode", "hideMode"], "div");//NO I18N
        var editButton = ZDBUtil.getElWithTagNAttrWithVal(showHide[0], "action", "show", "a");//NO I18N
        var settNThemeBtn = ZDBUtil.getElsWithTagNAttrWithVals(showHide[0], "id", ["ZDBANAL_SETTING_TIP", "ZDBDashboardThemeBtn"], "a");//NO I18N
        showHide[0].style.display = (dispCondition) ? "" : "none";
        showHide[1].style.display = (dispCondition) ? "none" : "";
        var modeType = (view.editMode) ? "edit" : "view";//NO I18N
        var buttons = ZDBUtil.getElsWithAttrName(toolbarTr, "modeType");//NO I18N
        for(var i = 0; i < buttons.length; i++) {
            var button = buttons[i];
            var btnModeType = button.getAttribute("modeType");
            button.style.display = (btnModeType == modeType) ? "" : "none";
        }
        editButton.style.display = (type == "Report") ? "none" : "";
        settNThemeBtn[0].style.display = (type == "AnalysisView" || type == "Pivot" || type == "SummaryView") ? "" : "none";//NO I18N
        settNThemeBtn[1].style.display = (type == "Dashboard" && !view.editMode) ? "" : "none";//NO I18N
 }

ZDBMenu.showHideToolbarOptions = function(el,show)
{
  var display = (show) ? "" : "none"; //No I18N
  jQuery(el).find('li a:not([default])').css('display',display); //No I18N
}

ZDBMenu.updateViewTitleNDesc = function(view)
{
  if(!view.viewCtx.isZia && view.toolbar.viewTitleEl)
  {
    view.chartTitleEl = view.toolbar.viewTitleEl;
    view.chartDescEl = view.toolbar.viewDescEl;
    view.vertLineEl = view.toolbar.vertLineEl;
    var desc = ZDBEscapeUtil.encodeForHtml((view.description == null || view.description == "" || view.description == "null") ? "" : view.description); //No I18N
    view.chartDescEl.innerHTML = desc;
    if(view.vertLineEl)
	{//vertical line will not be there in embed mode
    	view.toolbar.vertLineEl.style.height=(desc == "") ? "25px" : "36px";
	}
    view.chartTitleEl.innerHTML = ZDBEscapeUtil.encodeForHtml((view.title== null || view.title=="")?view.displayName:view.title);
    ZDBMenu.resizeTitleNDesc(view.toolbar);
  }
}

ZDBMenu.resizeTitleNDesc = function(toolbar)
{
	if(toolbar)
	{
		var titleBarEl = jQuery(toolbar.titleBar);
		var viewTitleEl = jQuery(toolbar.viewTitleEl);
		var viewDescEl = jQuery(toolbar.viewDescEl);
		viewTitleEl.css("width",""); //No I18N
		viewDescEl.css("width",""); //No I18N
		titleBarEl.css("width",""); //No I18N
		var prevEl = titleBarEl.prev();
		var nextEl = titleBarEl.next();
		var prevElWidth = prevEl.is(":visible") ? prevEl.width() : 0; //No I18N
		var nextElWidth = nextEl.is(":visible") ? nextEl.width() : 0; //No I18N
                var leftSidePanelWidth = (ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState || ZDBClientUI.standAlone || ZDBGlobal.integrated) ? 0 : 250;//No I18N
                if(ZDBGlobal.ISNEWLAYOUT)
                {
                    leftSidePanelWidth=leftSidePanelWidth+jQuery("#ZRSingleLayoutNavTD").width(); //No I18N
                }
                var documentBodyWidth = document.body.getBoundingClientRect().width;
		var toolbarWidth = documentBodyWidth - leftSidePanelWidth;
		var totalWidth = toolbarWidth - (prevElWidth + nextElWidth + 35);
		totalWidth = (totalWidth < 100) ? 100 : totalWidth;
		var titleNextElWidth = viewTitleEl.next().width() + 85; //refresh, save and (copy options and padding 20px)
    var totalTileNNextElWidth = viewTitleEl.width() + titleNextElWidth;
		if(totalTileNNextElWidth > totalWidth)
		{
			viewTitleEl.css("width",totalWidth - titleNextElWidth); //No I18N
		}
    if(toolbar.FetchData)
    {
      if((totalWidth - totalTileNNextElWidth) < 130)
      {
        toolbar.FetchData.style.display = "none"; 
      }
      else if(toolbar.FetchData.innerText)
      {
        toolbar.FetchData.style.display = "inline-block";  
      }
    }
		titleBarEl.css("width",totalWidth); //No I18N
		viewDescEl.css("max-width",totalWidth); //No I18N
	}
}

ZDBMenu.groupToolbarItems = function(toolbarTr)
{
  
  var grpElement = jQuery(toolbarTr).find('div[grpdiv="true"]');
  grpElement.find("li a.newGrpTextBtn:visible:first").addClass("first");//No I18N
  grpElement.find("li a.newGrpTextBtn:visible:last").addClass("last"); //No I18N
}

ZDBMenu.enableDisableMenuItems = function(view,actions,checkToolItems)
{
  var readOnlyMode = ZDBClientUI.readOnlyMode;
  if(readOnlyMode)
  {
  jQuery(actions).hide();
  return;
  }
  var isDBOwner = ZDBClientUI.isDBOwner;
  var isDBOwnerAndNotDBAdmin = ZDBClientUI.isDBOwnerAndNotDBAdmin;
  var isGroupMember = ZDBClientUI.isGroupMember;
  var isDBExportAllowed = ZDBClientUI.isDBExportAllowed;
  var isMakePublicAllowed = ZDBClientUI.isMakePublicAllowed;
  var isSupportAdminAccessDB = ZDBClientUI.isSupportAdminAccess;
  var perms = view.permissions;
  if(!perms)
  {
    return;
  }
  var readPerm = perms.read;
  var exportPerm = perms.exportPerm;
  var vudPerm = perms.vud;
  var addPerm = perms.add;
  var writePerm = perms.modify;
  var deletePerm = perms.deletePerm;
  var deleteAllPerm = perms.deleteAll;
  var appendImportPerm = perms.appendImport;
  var updateImportPerm = perms.updateImport;
  var truncateImportPerm = perms.truncateImport;
  var deleteUpdateAddPerm = perms.deleteupdateadd;
  var sharePerm = ((perms.share == 1) || ((perms.grpMember == 1 || perms.dbOwner == 1) && (perms.designModify == 1)));
  var modAllowed = perms.designModify;
  var createReportPerm = perms.createChildReports;
  var emailReportPerm = perms.emailrptperm;
  var publishPerm = perms.publishperm;
  var enableToolItems = (checkToolItems)?view.enableToolItems:null;
  var grpPerm = view.permissions.grpMember;
  var enterData = view.enterData;
  var isExportCSVPerm = view.isExportCSV != null ? view.isExportCSV : true;
  var isERDGEnable = view.isERDGEnable;
  var isQueryTable = view.type === 'QueryTable';
  /* this js property  isExportCSV will available only for chart.
   * for all views grid/pivot/summary/tabular etc this perm is
   * assumed as true. Other security attributes will take care of its action.
   */

  var viewModeType = (view.editMode)? "edit":"view";
  var exportBtn = $("ZDBExportButton");
  if(exportBtn) {exportBtn.setAttribute("dontwrap","true"); }
  var isSystemTable = (view.isSystemTable) ? view.isSystemTable : false;
  var isSyncStatusApplicable = (view.isSyncStatusApplicable) ? view.isSyncStatusApplicable : false;
  var saved = (view.objId != null) && (view.objId  > -1);
  var isAllParentNotShared = view.haveAllInvolvedTablesReadPermission && view.haveAllInvolvedTablesReadPermission == "false";
  
  // Enable all dividers so that the divider removal will happen for the views opened in another tab
  for(var k=0, l = actions.length;k< l;k++)
  {
    var curAction = actions[k];
    if(curAction.getAttribute && curAction.getAttribute("divider"))
    {
      curAction.style.display = "";
      curAction.setAttribute("hided","");
      curAction.setAttribute("donthide","");
    }
  }
  var firstDividerFound = false;
  for(var k=0, l = actions.length;k< l;k++)
  {
    var curAction = actions[k];
    if(!curAction.getAttribute || curAction.getAttribute("visualtd"))
    {
        continue;
    }
    if(curAction.getAttribute && curAction.getAttribute("divider") && firstDividerFound == false)
    {
       firstDivider = curAction;
       firstDividerFound = true;
    }
    if(curAction.getAttribute && curAction.getAttribute("divider") && curAction.getAttribute("hided") == "true")
    {
       continue;
    }
    var searchElname = "SearchBoxEl"; //No I18N    
  
    if(curAction.getAttribute("elname") == searchElname)
    {
        var searchEl = curAction.getElementsByTagName("INPUT")[0];
        if(view.directFilterStr)
        {
            searchEl.setAttribute("tipShown","false");
            searchEl.value = view.directFilterStr;
            jQuery(searchEl).css("color","black"); // No I18N
            jQuery(searchEl).attr("searchempty","true").siblings("#ZDBSearchButton").removeClass("ZRSSearchIcon").addClass("ZRSSearchClearIcon");//No I18N
        }
        else
        {
            searchEl.setAttribute("tipShown","true");
            searchEl.value = ZDBI18NMap.g("zrpt.common.js.search");
            jQuery(searchEl).css("color","grey"); // No I18N
            jQuery(searchEl).siblings("#ZDBSearchButton").removeClass("ZRSSearchClearIcon").addClass("ZRSSearchIcon"); //No I18N
        }
    }
    var reqRole = curAction.getAttribute("isDBOwnerReq");
    var reqDBOwnerAndNotDBAdminRole = curAction.getAttribute("isDBOwnerAndNotDBAdminReq");
    var reqGroupRole = curAction.getAttribute("isGroupMemberReq");
    var isLoginReq = curAction.getAttribute("isLoginReq");
    var modPermReq = curAction.getAttribute("zdbModPermReq") =="true";
    var loggedIn = !ZDBClientUI.notLoggedIn;
    var saveNeeded = curAction.getAttribute("disableOnNew") == "true";
    var delOrDelAllNeeded = curAction.getAttribute("DELETEORDELETEALLNEEDED") == "true";

    var readPermNeeded = curAction.getAttribute("isReadPermReq");
    var exportPermNeeded = curAction.getAttribute("isExportPermReq");
    var vudPermNeeded = curAction.getAttribute("isVUDPermReq");
    var writePermNeeded = curAction.getAttribute("isWritePermReq");
    var addPermNeeded = curAction.getAttribute("isAddPermReq");
    var deletePermNeeded = curAction.getAttribute("isDeletePermReq");
    var deleteAllPermNeeded = curAction.getAttribute("isDeleteAllPermReq");
    var importPermNeeded = curAction.getAttribute("isImportPermReq");
    var saveAllowed = curAction.getAttribute("isSaveAllowed");
    var grpPermNeeded = curAction.getAttribute("isGroupPermNeeded");
    var createReportPermNeeded = curAction.getAttribute("isCreateReportPermReq");
    var sharePermNeeded = curAction.getAttribute("isSharePermReq");
    var isExportCSVPermNeeded = curAction.getAttribute("isExportCSVPermReq");
    var isSystemTableNeeded = curAction.getAttribute("isSystemTable") ? curAction.getAttribute("isSystemTable") : false ;
    var addModifyPermNeeded = curAction.getAttribute("isAddModifyPermReq");
    var emailReportPermNeeded = curAction.getAttribute("isEmailReportPermReq");
    var publishPermNeeded = curAction.getAttribute("isPublishPermReq");
    var isDBExportPermNeeded  = curAction.getAttribute("isDBExportPermReq");
    var isDBMakePublicPermNeeded  = curAction.getAttribute("isMakePublicPermReq");
    var isSupportAdminPermNeeded  = curAction.getAttribute("isSupportAdminPermReq");
    var enableForIOS = curAction.getAttribute("enableForIOS");
    var erdgEnable = curAction.getAttribute("isERDGEnable");
    var isSyncStatusNeeded = curAction.getAttribute("isSyncStatusApplicaple");
    var hideForQueryTable = curAction.getAttribute('hideForQueryTable');
    
    var actModeType = curAction.getAttribute("modeType");
    
    var actIsSFDB = curAction.getAttribute("isSFDB") == "true";
    var enabled =(( (reqRole == null) || (isDBOwner))
      && (reqGroupRole == null  || isGroupMember || isDBOwner)
      && (reqDBOwnerAndNotDBAdminRole == null  || isDBOwnerAndNotDBAdmin)
      && ((!modPermReq)||(modAllowed == 1))
      && ((isLoginReq == null) || (loggedIn))
      && ((saved) || (!saveNeeded))
      && ((!createReportPermNeeded)||(createReportPerm))
      && ((!readPermNeeded) || (readPerm == 1))
      && ((!exportPermNeeded) || (exportPerm == 1))
      && ((!vudPermNeeded) || (vudPerm == 1))
      && ((!writePermNeeded) || (writePerm == 1))
      && ((!addPermNeeded) || (addPerm == 1))
      && ((!deletePermNeeded) || (deletePerm == 1))
      && ((!deleteAllPermNeeded) || (deleteAllPerm == 1))
      && ((!delOrDelAllNeeded) || (deletePerm == 1 || deleteAllPerm == 1))
      && ((!importPermNeeded) || (appendImportPerm == 1 || truncateImportPerm == 1 || updateImportPerm == 1 || deleteUpdateAddPerm == 1))
      && ((!sharePermNeeded) || (sharePerm == 1))
      && ((!saveAllowed) || (writePerm == 1 || addPerm == 1 || deletePerm == 1 || deleteAllPerm == 1) || enterData)
      && ((!addModifyPermNeeded) || (writePerm == 1 || addPerm == 1))
      && ((!grpPermNeeded) || (grpPerm || isDBOwner))
      && ((!enableToolItems) || ((curAction.getAttribute("tname") == null)) ||
          ZDBUtil.indexOf(enableToolItems, curAction.getAttribute("tname")) != -1)
      && ((!actModeType) || (actModeType == viewModeType))
      && ((!actIsSFDB) || (actIsSFDB == ZDBGlobal.ISSFDB))
      && ((!isExportCSVPermNeeded) || (isExportCSVPerm))
      && ( !isSystemTableNeeded || !isSystemTable)
      && (!erdgEnable || isERDGEnable)
      && ((!emailReportPermNeeded) || (emailReportPerm == 1))
      && ((!publishPermNeeded) || (publishPerm == 1))
      && (!isDBExportPermNeeded || isDBExportAllowed)
      && (!isDBMakePublicPermNeeded || isMakePublicAllowed)
      && (!isSupportAdminPermNeeded || isSupportAdminAccessDB)
      && (!isSyncStatusNeeded || isSyncStatusApplicable)
      && (!isQueryTable || !hideForQueryTable)
                  );
    enableForIOS = (enableForIOS == "true");
    enabled = (ZDBGlobal.IS_MOBILE) ? enableForIOS : enabled;
    //isMultiTabSharedRep    when view involves multiple table. And parent view and report/view is shared. Still we wont support saveas.
     //Since all table need not be shared. This happens only for shared user and report is multi table report.
    var saveAs = ((!modAllowed) && (createReportPerm) && !isAllParentNotShared);
    var cusAttr = curAction.getAttribute("CUSATTR");
    if(cusAttr != null)
    {
      if(cusAttr == "SAVEAS"){curAction.style.display = (saveAs)? ZDBUtil.visibleTdStyle:"none";}
      else if(cusAttr == "SAVE"){curAction.style.display = (saveAs)? "none":ZDBUtil.visibleTdStyle;}
      else if(cusAttr == "OWNERSHIP"){curAction.style.display = (modAllowed && isDBOwner)?
                                   "none":ZDBUtil.visibleTdStyle;}
    }

    curAction.setAttribute("enabled",enabled? "true":"false");
    var hideOnDisable = curAction.getAttribute("hideOnDisable");

    if(hideOnDisable != null)
    {
      curAction.style.display=(enabled)? "":"none";
    }
    else
    {
      if(!saved && saveNeeded)
      {
        ZDBMenu.editCSSClass(curAction,"notpermitted",true);  //No I18N
        ZDBMenu.editCSSClass(curAction,"disabledonnotsaved",enabled);  //No I18N
        if(curAction.id=="ZDBQTDependencyListDia")
        ZDBMenu.removeAddQTToolbarSecondRow(curAction,"disabledonnotsaved",enabled);  //No I18N
      }
      else
      {
        ZDBMenu.editCSSClass(curAction,"disabledonnotsaved",enabled);  //No I18N
        ZDBMenu.editCSSClass(curAction,"notpermitted",enabled);  //No I18N
        if(curAction.id=="ZDBQTDependencyListDia")
        ZDBMenu.removeAddQTToolbarSecondRow(curAction,"disabledonnotsaved","true");  //No I18N
        
//        var QTToolbar = ZDBUtil.getParentWithAttributeValue(curAction,"id","QuerytableToolbar");
//        if(QTToolbar){
//        	QTToolbar.getElementsByClassName("secondRow")[0].style.display = "none";
//        }
      }
      if(curAction.getAttribute("disableChild") != null)
      {
          var searchEl = curAction.getElementsByTagName("INPUT")[0];
          searchEl.disabled = !enabled;
      }
    }
  }
}

ZDBMenu.warnIfNotLoggedIn = function()
{
  if(ZDBClientUI.notLoggedIn)
  {
    ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.common.zdbalertmsg.js.notLoggedInErr",ZDBGlobal.PRODUCTNAME));
  }
  return ZDBClientUI.notLoggedIn;
}

ZDBMenu.selectTab = function(element)
{
	var formHolder = DOMUtils.getParentWithAttrValue(element,"elname","feedBackDemoRequestFormHolder");//NO I18N
	var prevEl = DOMUtils.getFirstMatchingChild(formHolder,"*","selected","true");
	var successFeed = $("ZDBInsFeed_Success");
	var failureFeed = $("ZDBInsFeed_Failure");
	var curFocusElName = element.getAttribute("focusEl");
	var curFocusEl = $(curFocusElName);
	if(element == prevEl)
		{
			ZDBUtil.setFocus(curFocusEl,true);
			return;
		}
	successFeed.style.display="none";
	failureFeed.style.display="none";
	jQuery(prevEl).removeClass("greenBtn");
	jQuery(element).addClass("greenBtn");	
	prevEl.removeAttribute("selected");
	element.setAttribute("selected","true");
	var prevDialogElName = prevEl.getAttribute("frmName");
	var currentDialogName = element.getAttribute("frmName");
	var currentFrm = DOMUtils.getFirstMatchingChild(formHolder,"*","name",currentDialogName);//NO I18N
	var prevFrm = DOMUtils.getFirstMatchingChild(formHolder,"*","name",prevDialogElName);//NO I18N
	currentFrm.style.display = "block";
	prevFrm.style.display = "none";
	ZDBUtil.setFocus(curFocusEl,true);
}

ZDBMenu.addIframe = function(el,parentNode)
{
  if(((el.iframe)!=null)){return;}
  var iframe = ZDBUtil.getCachedIframe();
	iframe.className = "";
	iframe.shadowAdded = null;
  if(el.style.zIndex!=null)
  {
    iframe.style.zIndex = (el.style.zIndex)?el.style.zIndex- 1:0;
  }
  el.iframe = iframe;
  ZDBMenu.resizeIframe(el);
  var left = jQuery(el).position().left;
  left = (left)?parseInt(left):ZDBUtil.getObjLeft(el,true,parentNode);
  var top = jQuery(el).position().top;
  top = (top)?parseInt(top):ZDBUtil.getObjTop(el,true,parentNode);
  iframe.style.left = (jQuery.isNumeric(left)?left+"px":"auto");
  iframe.style.top = (jQuery.isNumeric(top)?top+"px":"auto");
  var appendTo = (parentNode==null)?document.body:parentNode;
  appendTo.appendChild(iframe);
}

ZDBMenu.resizeIframe = function(el)
{
  if(el.iframe != null)
  {
		var display = (el.iframe.style.display != null)?el.iframe.style.display:"";
		el.iframe.style.width = "";
		el.iframe.style.height = "";
		el.iframe.style.visibility = "hidden";
		el.iframe.style.display = "";
		var height = el.offsetHeight;
		var width = el.offsetWidth;
		el.iframe.style.visibility = "visible";
		el.iframe.style.display = display;
		if(width >= 4 && height >=4)
		{
    el.iframe.style.width= width + "px";
    el.iframe.style.height = height + "px";
		}
  }
  else
  {
    // console.log("ZDBMenu.resizeIframe issue");
  }
}

ZDBMenu.resizeIframeNSetPosition = function(el)
{
  ZDBMenu.resizeIframe(el);
  el.iframe.style.left = ZDBUtil.getObjLeft(el,true);
  el.iframe.style.top = ZDBUtil.getObjTop(el,true);
}


ZDBMenu.removeIframe = function(el)
{
  if(el.iframe !=null)
  {
    ZDBUtil.returnIframeToCache(el.iframe);
    el.iframe=null;
  }
}
ZDBMenu.editCSSClass = function(el,className,enabled)
{
	if(!el)
	{
		return;
	}
    if(enabled)
    {
        DOMUtils.removeCSSClass([el],className);
        if(el.onclick == null &&
           el.onclickorig != null)
        {
          el.onclick = el.onclickorig;
        }
    }
    else
    {
        DOMUtils.addCSSClass([el],className);
        if(el.onclick != null)
        {
          el.onclickorig = el.onclick;
        }
        el.onclick = null;
    }
}

ZDBMenu.removeAddQTToolbarSecondRow = function(el,curAction,enabled){
	
	if(!el){
		return;
	}
	if(enabled){
		var QTToolbar = ZDBUtil.getParentWithAttributeValue(el,"id","QuerytableToolbar");  //NO I18N
		if(QTToolbar){
      	QTToolbar.getElementsByClassName("secondRow")[0].style.display = "block";
      }
		
	}
	else{
		var QTToolbar = ZDBUtil.getParentWithAttributeValue(el,"id","QuerytableToolbar"); //NO I18N
		if(QTToolbar){
      	QTToolbar.getElementsByClassName("secondRow")[0].style.display = "none";
      }
		
	}
	
}

ZDBMenu.editTitleInline = function(el,event)
{
	ZDBTabHandler.editTitleNDesc(el,event,"titleEdit");//NO I18N
}

ZDBMenu.editDescInline = function(el,event)
{
	ZDBTabHandler.editTitleNDesc(el,event,"descEdit");//NO I18N
}

ZDBMenu.editTitleForChart = function(el,event)
{
	ZDBTabHandler.editTitleNDesc(el,event,"titleEditChart");//NO I18N
}

ZDBMenu.editDescForChart = function(el,event)
{
	ZDBTabHandler.editTitleNDesc(el,event,"descEditChart");//NO I18N
}
