//$Id$

var ZDBMenuUtil = new function()
{
  this.curMenuEl = null;
  this.subMenuEl = null;
  this.minMenuHeight = 10;

  this.clearAndSetPopupPosition = function(popupContainer, event)
  {
    popupContainer.style.visibility="hidden";
    popupContainer.style.right="auto";
    popupContainer.style.bottom="auto";
    ZDBMenuUtil.setPopupPosition(popupContainer, event);
    popupContainer.style.visibility="visible";
  }
    
  this.setPopupPosition = function(popupContainer, event)
  {
    if(!event.event)
    { 
      event = (window.event != null)? window.event:event;
    } 
    ZDBMenuUtil.setPopupPositionWithOffset(popupContainer,event.clientX,event.clientY,0);
  }

  this.setPopupPositionWithOffset = function(popupContainer, clientX,clientY,offset)
  {
    var pos = ZDBMenuUtil.getPopupPositionWithOffset(popupContainer.offsetWidth,
                                                     popupContainer.offsetHeight,
                                                     clientX,clientY,offset);
    popupContainer.style.top = pos.top;
    popupContainer.style.left = pos.left;
    popupContainer.style.bottom = pos.bottom;
    popupContainer.style.right = pos.right;
  }

  this.getPopupPositionWithOffset = function(offsetWidth,offsetHeight, clientX,clientY,offset)
  {
    //PK: Handling only the right edge

    var remainRight, remainBottom;
    var pos={left:"auto",right:"auto",top:"auto",bottom:"auto"};
    if(BROWSER.IE)
    {
      remainRight = document.body.clientWidth - clientX;
      remainBottom = document.body.clientHeight - clientY;
    } 
    else // Firefox and ...
    {
      remainRight = window.innerWidth - clientX;
      remainBottom = window.innerHeight - clientY;
    }
          
    var requiredRight = offsetWidth + offset;
    var requiredBottom = offsetHeight + offset;
            
    var top, left, right, bottom;
    if(requiredRight > remainRight)
    {
      pos.right = "0px";
    }
    else
    {
      pos.left = clientX + "px";
    }
          
          
    if(requiredBottom > remainBottom)
    {
      pos.bottom = "0px";
    }
    else
    {
      pos.top = clientY + "px";
    }         
    return pos;
  }
       
  this.closeSubMenu = function()
  {
    if(ZDBMenuUtil.subMenuEl != null)
    {
      ZDBMenu.removeIframe(ZDBMenuUtil.subMenuEl);
      ZDBMenuUtil.subMenuEl.style.display = "none";
      ZDBMenuUtil.subMenuEl = null;
      ZDBUtil.detachEvent(document,'click',ZDBMenuUtil.closeSubMenu,false);
    }
  }          
    
  this.checkAndClose =function(ev)
  {
    var keyCode = (BROWSER.IE)?window.event.keyCode:ev.which;
    if (keyCode == 27)
    {
      if(ZDBMenuUtil.subMenuEl != null)
      {
        ZDBMenuUtil.closeSubMenu();
      }
      else
      {
        ZDBMenuUtil.closeMenu();
      }
    }
  }
    
  this.closeMenu = function(event) //$$ These should have been moved to the dialog stuff!!
  {
    var tarEl = event ? event.target : null;
    if(ZDBMenuUtil.curMenuEl != null)
    {
      if(ZDBMenuUtil.curMenuEl.isExportSpecific)
      {
        ZDBMenuUtil.curMenuEl.hide();
        ZDBMenuUtil.curMenuEl=null;
        return;
      }
      if(ZDBMenuUtil.curMenuEl.onCloseFunc != null)
      {
        ZDBMenuUtil.curMenuEl.onCloseFunc();             
      }
      else
      {
        var element = ZDBMenuUtil.curMenuEl.srcEl;
        if(element != null)
        {
          ZDBMenu.zdbHighLighter(element,element.getAttribute("baseclass"),'');
          ZDBUtil.attachEvent(element,'mouseover',ZDBMenuUtil.highLightOver,false);
          ZDBUtil.attachEvent(element,'mouseout',ZDBMenuUtil.highLightOut,false);
        }
      }
      if(ZDBMenuUtil.curMenuEl.menuItemEl != null)
      {// to set the onmouseout bg
        ZDBMenuUtil.setClass(ZDBMenuUtil.curMenuEl.menuItemEl);
      }
      ZDBUtil.detachEvent(ZDBMenuUtil.curMenuEl,'mouseover',ZDBMenuUtil.onMouseOver,false);
      ZDBUtil.detachEvent(ZDBMenuUtil.curMenuEl,'mouseout',ZDBMenuUtil.onMouseOut,false);
      ZDBMenu.removeIframe(ZDBMenuUtil.curMenuEl);
    	  
      ZDBMenuUtil.closeSubMenu();
      ZDBToolTip.hideTip();
         
      ZDBUtil.detachEvent(document,"keydown",ZDBMenuUtil.checkAndClose,false);    
      ZDBUtil.detachEvent(ZDBMenuUtil.curMenuEl,'contextmenu',ZDBUtil.stopEventBubble,false);
      ZDBUtil.detachEvent(document,'click',ZDBMenuUtil.closeMenu,false);
      ZDBMenuUtil.curMenuEl.style.display="none";
      ZDBMenuUtil.curMenuEl.onCloseFunc = null;
      ZDBMenuUtil.curMenuEl = null;
    }
  }
    
  this.highLightOver = function(event)
  {
    var element = ZDBUtil.getSourceElement(event);
    ZDBMenu.zdbHighLighter(element,element.getAttribute("baseclass"),'hover');
  }
    
  this.highLightOut = function(event)
  {
    var element = ZDBUtil.getSourceElement(event);
    ZDBMenu.zdbHighLighter(element,element.getAttribute("baseclass"),'');
    ZDBToolTip.hideTip();
  }
    
  this.onMouseOver = function(event)
  {
    ZDBMenuUtil.setClassName(event, "menuitem_mouseover");
  }
    
  this.onMouseOut = function(event)
  {
    ZDBMenuUtil.setClassName(event);
    ZDBToolTip.hideTip();
  }
    
  this.setClassName = function(event, className)
  {
    var menuItemEl = ZDBUtil.getSourceElement(event);
    if(ZDBMenuUtil.curMenuEl != null)
    {
      ZDBMenuUtil.curMenuEl.menuItemEl = menuItemEl;
      ZDBMenuUtil.setClass(menuItemEl, className);
    }
  }
    
  this.setClass = function(menuItemEl, className)
  {
    // In case there are two TDs in the same menu item	
    while(menuItemEl.parentNode && menuItemEl.parentNode.tagName!="TR")
    {
      menuItemEl = menuItemEl.parentNode;
    }
    if(!menuItemEl.parentNode)
    {
      return;
    }
    var menuItemEls = menuItemEl.parentNode.childNodes;
    for(var i = 0;i < menuItemEls.length;i++)
    {
      menuItemEl = menuItemEls[i];	
      if(menuItemEl.getAttribute)
      {
        var origClassName = menuItemEl.getAttribute("menuitemclass");
        if(origClassName != null)
        {
          var class1 = origClassName;
          if(className)
          {
            class1 = class1 + " " + className;
          }
          menuItemEl.className = class1;
        }
      }	
    }
  }

  this.positionEl = function(el,srcEl,toRight)
  {
    el.style.visibility = "hidden";
    document.body.appendChild(el);
    el.style.left = "0px";
    el.style.top = "0px";
    el.style.display = "";
    var left = ZDBUtil.getObjLeft(srcEl);
    var top = ZDBUtil.getObjTop(srcEl)+srcEl.offsetHeight;
		var finalLeft = (toRight)?(left+srcEl.offsetWidth)-(el.offsetWidth):left;
		var clientWidth = document.body.clientWidth;
    finalLeft = ((finalLeft+el.offsetWidth) > clientWidth)?finalLeft-((finalLeft+el.offsetWidth)-clientWidth):finalLeft;
    el.style.left = finalLeft+"px";
    el.style.top = top+"px";
		el.style.visibility = "visible";
  }
}

var MenuUtil = new function()
{
    var transitionAllowed = document.documentMode&& document.documentMode<9 ? false: true ;
    
    this.slideDown = function(jQueryObj,speed,callbackFn,animationAllowed)
    {
        speed = speed ? speed : 250;
        if(!transitionAllowed ||animationAllowed==false)
        {
            jQueryObj.show();
            if(callbackFn && typeof callbackFn=="function")
            {
                callbackFn.apply();
            }
        }
        else
        {
            jQueryObj.slideDown(speed, callbackFn);
        }
    }
    this.slideUp = function(jQueryObj,speed,callbackFn,animationAllowed)
    {
        speed = speed ? speed : 250;
        if(!transitionAllowed || animationAllowed==false)
        {
            jQueryObj.hide();
            if(callbackFn && typeof callbackFn=="function")
            {
                callbackFn.apply();
            }
        }
        else
        {
            jQueryObj.slideUp(speed, callbackFn);
        }
    }
    this.animate = function(jQueryObj,animateProps,speed,callbackFn)
    {
        var transition = transitionAllowed && !ZDBGlobal.isQAEnabled;
        if(!transition)
        {
            jQueryObj.is(":visible") ? jQueryObj.hide() : jQueryObj.show(); //NO I18N
            if(typeof callbackFn=="function")
            {
                callbackFn.apply(jQueryObj);
            }
        }
        else
        {
            speed = speed ? speed : 250;
            jQueryObj.animate(animateProps,speed,callbackFn);
        }
    }
}
