//$Id$

var ZDBPopUpMenu = new function()
{
    this.gridContextMenu = function(cellObj,event)
    {
      var colObj = cellObj.colObj;
      var rowObj = cellObj.rowObj;
      var gridObj = colObj.parGrid;
      if(rowObj.objType == ZDBConst.FILLER || colObj.objType == ZDBConst.FILLER || gridObj.isPreview)
      {
        return;
      }
      
      if(gridObj.type == 'PivotSheet' || gridObj.type == 'SummarySheet')
      {
            ZDBPopUpMenu.pivotContextMenu(cellObj, colObj, rowObj, gridObj, event);
            return;
      }
      
      if(ZDBUtil.indexOf(gridObj.selectedCols, colObj) < 0)
      {
        gridObj.hideSelection(true, false);
      }
      
      if(ZDBUtil.indexOf(gridObj.selectedRows, rowObj) < 0)
      {
        gridObj.hideSelection(false, true);
      }

      if(gridObj.contextDisabled)
      {
        return;
      }      
      var level = null;      
      
      
      switch(rowObj.objType)
      {
        case ZDBConst.DATA:
        {
          if(colObj.objType == ZDBConst.ROWHEAD)
          {
            if(gridObj.rowMenuDisabled)
            {
              return;
            }
            gridObj.addSelectedRow(rowObj);
            gridObj.selectRow();
            level = "ROW";
          }
          else if(colObj.objType == ZDBConst.FILLER)
          {
            return;
          }
          else
          {
            level = "CELL";
            ZDBUtil.setTimeout(gridObj.setCellFocus, gridObj, [cellObj], 3);
          }
          break;
        }
        case ZDBConst.COLHEAD: //rowhead
        {
          if(colObj.objType == ZDBConst.ROWHEAD)
          {
            level = "TABLE";
            return; //PK: yet to be implemented
          }
          else if(colObj.objType == ZDBConst.FILLER || (gridObj.type == 'TableDesign')) //No I18N
          {
            return;
          }
          else
          {
            level = "COLUMN";
            ///check shift
            gridObj.addSelectedCol(colObj);
            gridObj.selectColumn();
          }
          break;
        }
        case ZDBConst.DUMMY:
        {
          if(colObj.objType == ZDBConst.ROWHEAD)
          {
            if(gridObj.rowMenuDisabled)
            {
              return;
            }
            gridObj.addSelectedRow(rowObj);
            gridObj.selectRow();
            level = "ROW";   //No I18N
          }
          else if(colObj.objType == ZDBConst.FILLER)
          {
            return;
          }
          else
          {
            level = "DUMMY";  //No I18N
            ZDBUtil.setTimeout(gridObj.setCellFocus, gridObj, [cellObj], 3);
          }
          break;
        }
        default:
          return;
      }
      ZDBPopUpMenu.showPopup(event, level, cellObj, colObj, rowObj);
    }
    
  
  this.pivotAddSortCols = function(cellObj, menu, sortType)
  {
	  ZDBUtil.setNamedChildEls(menu,menu);
	    var menuItemTbody = menu.tbody;
	    if(!ZDBPopUpMenu['templateRow'])
	    {
	      ZDBPopUpMenu['templateRow'] = ZDBUtil.getCloned(menu.tempRow);
	    }
	    ZDBUtil.removeAllChildren(menuItemTbody);
	    if(!cellObj)
	    {
	      return;
	    }
	    var colObj = cellObj.colObj;
	    var gridObj = colObj.parGrid;
	    var colHeads = gridObj.colHeaders;
	    var colLen = colHeads.length;
	    var curHead = null;
	    var newSortRow = null;
	    menuItemTbody.gridObj = gridObj;
	   
	    if(colObj.freeze || colObj.unFreezeForScroll)
	    {
	      var startPos = -1, endPos = -1;
	      var colHeads = gridObj.colHeaders;
	      var colLen = colHeads.length;
	      var curHead = null;
	      for(var i=0;i<colLen;++i)
	      {
	        curHead = colHeads[i];
	        if(curHead.isSummary && startPos == -1)
	        {
	          startPos = endPos = i;
	        }
	        if(curHead.isSummary && endPos < i)
	        {
	          endPos = i;
	        }
	      }

	      newSortRow = ZDBPopUpMenu['templateRow'].cloneNode(true);
	      newSortRow.title = ZDBI18NMap.g("zrpt.pivot.menu.js.sortSnip")+" "  + colObj.displayName;
	      menuItemTbody.appendChild(newSortRow);
	      var newSortRowChildEl = jQuery(newSortRow).find('a')[0];
	      newSortRowChildEl.innerHTML = ZDBI18NMap.g("zrpt.pivot.menu.js.sortBySnip")+" " + ZDBUtil.getTrimmedString(colObj.getDispNameForHtml(), 15, "...");
        newSortRowChildEl.dataColObj = colObj;
        newSortRowChildEl.byColObj = colObj;
	      if(startPos > -1)
	      {
	        for(var i=startPos; i<=endPos;++i)
	        {
	          curHead = colHeads[i];
	          newSortRow = ZDBPopUpMenu['templateRow'].cloneNode(true);
	          newSortRow.title = ZDBI18NMap.g("zrpt.pivot.menu.js.sortSnip")+" "  + curHead.displayName;
	          menuItemTbody.appendChild(newSortRow);
	          var newSortRowChildEl = jQuery(newSortRow).find('a')[0];
	          newSortRowChildEl.innerHTML = ZDBI18NMap.g("zrpt.pivot.menu.js.sortBySnip")+" " + ZDBUtil.getTrimmedString(curHead.getDispNameForHtml(), 15, "...");
            newSortRowChildEl.dataColObj = curHead;
            newSortRowChildEl.byColObj = colObj;
	        }
	      }
	    }
	    else
	    {
	      for(var i=0;i<colLen;++i)
	      {
	        curHead = colHeads[i];
	        if(curHead.objType != ZDBConst.COLHEAD)
	        {
	          continue;
	        }
	        if(curHead.freeze || curHead.unFreezeForScroll)
	        {
	          newSortRow = ZDBPopUpMenu['templateRow'].cloneNode(true);
	          newSortRow.title = ZDBI18NMap.g("zrpt.pivot.menu.js.sortSnip")+" "  + colObj.displayName + " "+ZDBI18NMap.g("zrpt.pivot.menu.js.sortBySnip")+" " + curHead.displayName;
	          menuItemTbody.appendChild(newSortRow);
	          var newSortRowChildEl = jQuery(newSortRow).find('a')[0];
	          newSortRowChildEl.innerHTML = ZDBI18NMap.g("zrpt.pivot.menu.js.sortBySnip")+" " + ZDBUtil.getTrimmedString(curHead.getDispNameForHtml(), 15, "...");
            newSortRowChildEl.dataColObj = colObj;
            newSortRowChildEl.byColObj = curHead;
	        }
	      }
	      var view = cellObj.colObj.parGrid.viewObj;
	      var curListProp = view.curListProp;
	      var instKey = cellObj.colObj.colName;
          var listEl = ZDBUtil.getElementsWithAttribute(view.currentList, "instkey",instKey)[0];
          if(listEl.getAttribute("viewtype")!="XAXIS"){
        	  return;
          }
          newSortRow = ZDBPopUpMenu['templateRow'].cloneNode(true);
          newSortRow.title = ZDBI18NMap.g("zrpt.pivot.menu.js.sortSnip")+" "+listEl.getAttribute("title");
          menuItemTbody.appendChild(newSortRow);
          var newSortRowChildEl = jQuery(newSortRow).find('a')[0];
          var elName = curListProp[instKey]['PVTCOLUMNNAME'] ? curListProp[instKey]['PVTCOLUMNNAME'] : listEl.getAttribute("title");
          newSortRowChildEl.setAttribute("listindex",view.currentList.indexOf(listEl));
          newSortRowChildEl.innerHTML = ZDBI18NMap.g("zrpt.pivot.menu.js.sortBySnip")+" " + ZDBUtil.getTrimmedString(elName, 15,"...");
	    }
  }
  
    this.pivotPopup = function(cellObj, colObj, rowObj, gridObj, event)
    {
        if(ZDBUtil.indexOf(gridObj.rowData, rowObj) < ZDBUtil.indexOf(gridObj.rowData, colObj.rowObj)) //PK: ZDBConst.PIVOTHEAD????????
        {
        	return ZDBPopUpMenu.showColHeaderMenu(cellObj, colObj, rowObj, gridObj, event);//pvtSortSubMenuEl = ZDBContentCache.getContent("Pvt_Sort_Toolbar_Menu","GridMenu");//return;
        }
    
        var pvtSortMenuEl = ZDBContentCache.getContent("Pvt_Sort_Menu","GridMenu");
        var pvtSortSubMenuEl = ZDBContentCache.getContent("Pvt_Sort_Sub_Menu","GridMenu");
     
        var index=cellObj.colObj.dataColRefIdx;
        var colId=cellObj.colObj.colId;
        var view = cellObj.colObj.parGrid.viewObj;
        var summary = gridObj.type === "SummarySheet" ? true : false;
        var textAxisList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","TEXTAXIS");//NO I18N
        var groupAxisList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","GROUP");//NO I18N
        var rowAxisList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","YAXIS");//NO I18N
        var columnAxisList=ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","XAXIS");//NO I18N
        var textAxisLength = textAxisList.length;
        var groupAxisLength = groupAxisList.length;
        var rowAxisLength = rowAxisList.length;
        var columnAxisLength = columnAxisList.length;

        if(summary)
        {
            menu = pvtSortMenuEl;
            menuitem = 1;
        }
        else if(colId < rowAxisList.length)
        {
            menu = pvtSortSubMenuEl;
            menuitem = 2;
        }
        else if(rowObj.objType === ZDBConst.COLHEAD)
        {
            menu = pvtSortSubMenuEl;
            menuitem = 2;
        }
        else if(rowObj.objType === ZDBConst.DATA)
        {
            menu = pvtSortMenuEl;
            menuitem = 1;
        }
        else if(rowObj.objType === ZDBConst.SUMMARY)
        {
            menu = pvtSortMenuEl;
            menuitem = 1;
        }

        ZDBUtil.setNamedChildEls(menu,menu);
        var renameMenu = (menuitem == 1)?menu.pvtcolumnnameforSortMenu:menu.pvtcolumnnameforSortSubMenu;
        var sumRenameMenu =(menuitem == 1)?menu.summaryLabelforSortMenu:menu.summaryLabelforSortSubMenu;
        var removeSort = (menuitem == 1)?menu.sortMenuRemove:menu.sortMenuRemove;
        var ascSort = (menuitem == 1)?menu.sortMenuAsc:menu.sortMenuAsc;
        var descSort = (menuitem == 1)?menu.sortMenuDesc:menu.sortMenuDesc;
        var showhideMenu =(menuitem == 1)?menu.showhideforSortMenu:menu.showhideforSortSubMenu;
        var showTotalAs =menu.showTotalAsMenu;
        var showMissVal = (menuitem == 2)?menu.showMissValforPivotRowSubMenu:null;
        var list = jQuery(menu).find("li a");
        var viewUd = (menuitem == 1)?menu.viewUD:menu.viewUD;
        var separator = menu.getElementsByClassName("ZRSMenuSeparator");	//NO I18N
        var isSortingVisible = true;
        var isRenamingVisible = true;
        
        ZDBMenu.enableDisableMenuItems(gridObj.viewObj,list,false);
        
        ascSort.style.display = "";
    	descSort.style.display = "";
    	removeSort.style.display = "";

    	var listLen = summary ? groupAxisLength : textAxisLength;
    	if(colId>=rowAxisLength && rowObj.objType != ZDBConst.COLHEAD)
    	{
    		var idx = ZACondFormUtil.getIdx(cellObj, gridObj, view);
    	}
    	if(listLen>0 && menu.ZACondFormat && colId>=rowAxisLength)
    	{
    		ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZACondFormUtil.showCondFormMenu"]=ZACondFormUtil.showCondFormMenu;
    		menu.ZACondFormat.style.display = "";
    	}
    	else if(menu.ZACondFormat)
    	{
    		menu.ZACondFormat.style.display = "none";
    	}
    	
        menu.cellObj = cellObj;
        if(menu.parentNode != document.body)
        {
            document.body.appendChild(menu);
        }
        
        var listEl = ZDBUtil.getElementsWithAttribute(view.currentList, "instkey",	//No I18N
        		ZDBAnalysisView.replaceInstKey(view,cellObj.colObj.colName))[0];	//to replace the instKey with the proper value
        
        if(!summary)
        {
	        var dataRefIndx = colObj.dataColRefIdx;
	        var curDataEl = textAxisList[dataRefIndx];
	        
	        
	        if(!curDataEl || curDataEl.getAttribute("showvalueas") != "0" || curDataEl.getAttribute("operation") == "MX_DATE" || curDataEl.getAttribute("operation") == "MI_DATE")
	        {
	        	showTotalAs.style.display = "none"
	        }
        }
        if(view.viewCtx.isStandAlone() || !view.permissions.designModify)
        {
        	if(menu.ZACondFormat)
        	{
        		var condFormRules = view.condFormat.getCondRules();
        		if(condFormRules)
        		{
        			condFormRules = condFormRules[JSON.stringify(idx)];
        		}
        		if(!condFormRules)
        		{
        			menu.ZACondFormat.style.display = "none";
        		}
        		else
        		{
        			menu.ZACondFormat.style.display = "";
        		}
        	}
        	if(listEl && listEl.getAttribute("custombaseid")=="" || !listEl.getAttribute("custombaseid"))
        	{
        		if(menu.customSort)
        		{
            		menu.customSort.style.display = "none";	//No I18N
            	}
        	}
        	else
        	{
        		if(menu.customSort)
        		{
            		menu.customSort.style.display = "";	//No I18N
            	}
        	}
        }
        else{
        	if((listEl.getAttribute("viewtype")=="TEXTAXIS") || (columnAxisList.length<1 && colId>=rowAxisList.length) || (listEl.getAttribute("addontype")=="ABSDATECATEGORICAL") || (listEl.getAttribute("addontype")=="NUMBER"))	//No I18N
            {
            	if(menu.customSort){
            		menu.customSort.style.display = "none";	//No I18N
            	}
            }
            else
            {
            	if(menu.customSort){
            		menu.customSort.style.display = "";	//No I18N
            	}
            }
        }
        if(listEl.getAttribute("addontype")!="ABSDATECATEGORICAL")	//No I18N
        {
        	if(menu.customSort){
        		menu.customSort.setAttribute("listindex",view.currentList.indexOf(listEl));
        	}
        }

        if((index == -1 || textAxisLength == 1) && !summary) //for Rename Column menu Item in Pivot
        {
            if(cellObj.colObj.isSummary == null  && (colId>=rowAxisList.length && colObj.colSummary != 1))
//            if(cellObj.colObj.isSummary == null && (colId>=rowAxisList.length))
            {
                renameMenu.style.display = "none" ;
                isRenamingVisible = false;
            }
        }
        if(index != -1 || (textAxisLength==0) || !(view.colGrandSummary))//for Rename Summary Label menu Item in Pivot
        {
            if(cellObj.colObj.isSummary == null || (columnAxisList.length == 1 && textAxisLength == 1)  || columnAxisList.length==0)
            {
                sumRenameMenu.style.display = "none" ;
            }
        }
        if(summary)
        {
            if(!view.enableSumSubTot)
            {
                showhideMenu.style.display = "none" ;
                showTotalAs.style.display = "none";
            }
            else if(groupAxisLength === 0)
            {
                showhideMenu.style.display = "none" ;
                showTotalAs.style.display = "none";
            }
        }
        else if((!summary && textAxisLength===0))
        {
            showhideMenu.style.display = "none" ;
            showTotalAs.style.display = "none";
            removeSort.style.display = "none";
            if(menuitem==1)
            {
            	ascSort.style.display = "none";
            	descSort.style.display = "none";
            	isSortingVisible = false;
            }
        }
        
        else if(!summary && textAxisLength>0)	//for various cases where sorting has to enabled or disabled
        {
        	if(!(colId>=rowAxisLength))
        	{
        		removeSort.style.display = "none";
        	}
        	if(rowAxisLength==0 && (menuitem==1 || columnAxisLength==0))
        	{
        		ascSort.style.display = "none";
                descSort.style.display = "none";
                removeSort.style.display = "none";
                isSortingVisible = false;
        	}
        	else if(rowAxisLength==0 && textAxisLength==1 && colId>=rowAxisLength)
        	{
        		removeSort.style.display="none";
        	}
        	else if(rowAxisLength==0 && textAxisLength>1 && colId>=rowAxisLength)
        	{
        		ascSort.style.display = "none";
                descSort.style.display = "none";
        		removeSort.style.display="none";
        		isSortingVisible = false;
        	}
        }
        if(separator.length>0)
        {
        	if(isSortingVisible && !(renameMenu.style.display=="none") && !summary)
            {
            	separator[0].style.display="";
            	isRenamingVisible=true;
            }
            else
            {
            	separator[0].style.display="none";
            	isRenamingVisible=false;
            }
            if((isRenamingVisible || isSortingVisible) && !(viewUd.getAttribute("enabled")=="false") && !summary)
            {
            		separator[1].style.display="";
            }
            else
            {
            	separator[1].style.display="none";
            }
        }
        if(showMissVal != null)
        {
        	ZDBPivotView.showMissValMenu(showMissVal,listEl,view);
        }
        ZRSMenu.showMenu(event,null,menu,1);
        ZDBEvents.disableContextMenu(menu);
    }

  this.showPopup = function(event, level, cellObj, colObj, rowObj)
  {
    var gridObj = colObj.parGrid;
    var type = gridObj.type;
    var menuDiv = (type == "VUDSheet") ? "VUD_Popup_Menu" : ((type == "TableDesign" && level == "ROW") ? "DesignGrid_Popup_Menu" : "Popup_Menu"); //No I18N
    var menu = ZDBContentCache.appendAndGet(menuDiv,"GridMenu",document.body);
    if(!(type == "Table" || type == "Report" || type == "QueryTable" || type == "VUDSheet" || (type == "TableDesign" && level == "ROW")))
    {
      //$$ Check can be removed once right click supported in pivot, summary
      return false;
    }

    if(colObj)
    {
      if(gridObj && ZDBUtil.isNewView(gridObj) && type == 'Table')
      {// for Enter data right away
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.dobleClk2RenameColInfo"));
        return;
      }        
      if(ZDBUtil.isNewView(gridObj) && type == "QueryTable")
      {// Preview table of Query Table
        return false;
      }
    }
    else
    {
      level = "ROW";
      if(type != "Table" && !(type == "TableDesign"))
      {
        return false;
      }
    }
    if(type == "VUDSheet")
    {
      var showFilterMenuItem = (cellObj.rowObj.objType == ZDBConst.DATA);
      this.showHideVUDMenuItems(showFilterMenuItem);      
    }
    else if(type != "TableDesign")
    {
      var list = jQuery('#ZDBTColHeadMenu').find('li a'); //No I18N
      ZDBMenu.enableDisableMenuItems(gridObj,list,false);
      this.showHideMenuItems(gridObj,cellObj, colObj, rowObj, type,level);
    }
    
    menu.cellObj = cellObj;
    menu.colObj = colObj;
    menu.rowObj = rowObj;
    menu.gridObj = gridObj;
      
    // In setPopupPosition, offsetWidth of the menuEl is used - offsetWidth will have value
    // only when menu is visible, hence menu is made visible in the outer view range
    // and then gets reset in setPopupPosition
    ZRSMenu.showMenu(event,null,menu,1);
    ZDBEvents.disableContextMenu(menu);
    ZDBPopUpMenu.hideSeparator(menu);
    
    this.enableDisablePaste(event);
    ZDBUtil.stopEventBubble(event);
    return false;
  }
  
  this.enableDisablePaste = function(event)
  { 
      var srcEl = ZDBUtil.getSourceElement(event);
      var gridObj = ZDBUtil.getPropertyFromEl(srcEl, 'gridObj','object');
      var perms = gridObj.permissions;
      if(perms.add || perms.modify)
      {
	      var el = $("ZDBPasteCell");
	      if(el)
		  {
		      var isEnable = (ZDBEvents.copyType == ZDBConst.DATA) ? true : false;
		      ZDBMenu.editCSSClass(el,"notpermitted",isEnable);  //No I18N
		  }
      }
  }

  this.showHideVUDMenuItems = function(showFilterMenuItem)
  {
	$('ZDBPopUpVUDCopyCell').style.display = (showFilterMenuItem) ? ZDBUtil.visibleTrStyle : 'none'; //No I18N
    $('ZDBPopUpVUDFilterInclude').style.display = (showFilterMenuItem) ? ZDBUtil.visibleTrStyle : 'none'; //No I18N
    $('ZDBPopUpVUDFilterExclude').style.display = (showFilterMenuItem) ? ZDBUtil.visibleTrStyle : 'none'; //No I18N
  }
    
  this.showHideMenuItems = function(gridObj,cellObj, colObj, rowObj, type,level)
  {
    this.showHideMenuItemsBasedOnViewType(gridObj,type,cellObj, colObj, rowObj, level);
    var curCellObj = cellObj;
    var isSystemTable = (gridObj.isSystemTable) ? gridObj.isSystemTable : false;
    
    if(level == 'COLUMN' || level == 'CELL' || level == 'DUMMY')
    {
      var menuitem = $('ZDBHide');      
      menuitem.style.display = (gridObj && gridObj.freezeIndex >= 0 || colObj.grouped == true || gridObj.showHideElInEmbed == "false") ? 'none' :ZDBUtil.visibleTrStyle;
      
      var integMenuItemArr = ["ZDBDeleteColumn","ZDBRenameColumn","ZDBPopUpDataTypeChange","ZDBPopUpFindAndReplace","ZDBPopUpAdd","ZDBDelete"]; // No I18N
      for(var i=0;i<integMenuItemArr.length;i++)
      {
        var menuitem = $(integMenuItemArr[i]);
        if(menuitem && menuitem.style.display != 'none')
        {
          menuitem.style.display = (isSystemTable && !colObj.formula)?'none':ZDBUtil.visibleTrStyle;
        }
        var enabled = (menuitem.style.display=='none')?false:true;
        menuitem.setAttribute("enabled",enabled);
      }

      menuitem = $('ZDBPopUpDataTypeChange');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (colObj.type === 'REFCOL') || (colObj.lookupType === ZDBConst.REFCOL) ? 'none' :ZDBUtil.visibleTrStyle;
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBFormula');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = ((colObj.type === ('BOOLEAN')) || (colObj.type === ('REFCOL') || colObj.lookupType === ZDBConst.REFCOL || (colObj.type === ('AUTO_NUMBER')) || 
                                  (colObj.colName == ZDBConst.DYNAMIC_COL_NAME)) || (ZDBUtil.isNewView(gridObj))) ? 'none' :ZDBUtil.visibleTrStyle; //No I18N
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBColumnFormat');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (ZDBUtil.isNewView(gridObj)) ? 'none' :ZDBUtil.visibleTrStyle;      
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);

      menuitem = $('ZDBCondFormat');
      if(menuitem.style.display != 'none')
      {
          menuitem.style.display = (ZDBUtil.isNewView(gridObj) || colObj.colName == ZDBConst.DYNAMIC_COL_NAME) ? 'none' : ZDBUtil.visibleTrStyle;
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBDervEdit');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (colObj.formula && colObj.parGrid.objId == colObj.parentViewId) ? ZDBUtil.visibleTrStyle:'none';
        menuitem.header = colObj;
        for(var i = 0; i < menuitem.childNodes.length; i++)
        {
          menuitem.childNodes[i].header = colObj;
        }
        var enabled = (menuitem.style.display=='none') ? false : true;
        menuitem.setAttribute("enabled",enabled);
      }  
      
      menuitem = $('ZDBGrouping');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (colObj.grouped == false) ? ZDBUtil.visibleTrStyle:'none';
      }  
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBUnGroup');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (colObj.grouped == true) ? ZDBUtil.visibleTrStyle:'none';
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBPopUpFilterInclude');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (curCellObj.rowObj.objType == ZDBConst.DATA) ? ZDBUtil.visibleTrStyle:'none';
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBPopUpFilterExclude');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (curCellObj.rowObj.objType == ZDBConst.DATA) ? ZDBUtil.visibleTrStyle:'none';
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBPopUpFindAndReplace');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (colObj.formula || colObj.type == 'REFCOL' || colObj.type == 'AUTO_NUMBER') ? 'none' : ZDBUtil.visibleTrStyle;
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
            
      menuitem = $('ZDBPasteCell');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = (colObj.formula || colObj.type === 'AUTO_NUMBER' || colObj.type === 'BOOLEAN' || colObj.type === 'REFCOL') ? 'none' : ZDBUtil.visibleTrStyle;       
      }
      var enabled = (menuitem.style.display === 'none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      if($('ZDBEditLookup'))
      {
    	  menuitem = $('ZDBEditLookup');
      }
      if(menuitem.style.display !== 'none')
      {
    	  menuitem.style.display = (colObj.type !== 'REFCOL' && colObj.lookupType !== ZDBConst.REFCOL) && (colObj.type !== 'RELCOL' &&  colObj.lookupType !== ZDBConst.RELCOL ) || colObj.refViewType === 6 ? 'none' : (isSystemTable) ?'none' :ZDBUtil.visibleTrStyle;
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBChangeToLookup');
      if(menuitem.style.display != 'none')
      {
        if(typeof ZDBNavigation === "undefined")
          var tblCount = 2;
        else
          var tblCount = ZDBNavigation.viewsCountByType[0] + ZDBNavigation.viewsCountByType[1];  //Total no. of tables-[0] and query tables-[1] present in DB
        menuitem.style.display = (colObj.formula || colObj.type === 'REFCOL' || colObj.lookupType === ZDBConst.REFCOL || colObj.type === 'AUTO_NUMBER' || colObj.lookupType === ZDBConst.RELCOL || colObj.type === 'RELCOL' || ZDBClientUI.isRemoteDB || tblCount === 1) ? 'none' :ZDBUtil.visibleTrStyle;
      }
      var enabled = (menuitem.style.display=='none')?false:true;
      menuitem.setAttribute("enabled",enabled);
      
      menuitem = $('ZDBRemoveLookup');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = ((colObj.type !== 'REFCOL' && colObj.type !== 'RELCOL' && colObj.lookupType !== ZDBConst.REFCOL && colObj.lookupType !== ZDBConst.RELCOL) || ZDBClientUI.isRemoteDB) ? 'none' :colObj.isSysCol ===true ? 'none': ZDBUtil.visibleTrStyle;
      }
      
      menuitem = $('ZDBSysLookup');
      if(menuitem.style.display != 'none')
      {
        menuitem.style.display = ( (colObj.type !== 'REFCOL' && colObj.type !== 'RELCOL' && colObj.lookupType !== ZDBConst.REFCOL && colObj.lookupType !== ZDBConst.RELCOL))  ? 'none': (isSystemTable) ?  ZDBUtil.visibleTrStyle : "none";
        menuitem.setAttribute("isSysCol",colObj.isSysCol);
      }     

      menuitem = $('ZDBTbldrillDownMenu');      
      if(menuitem)
      {
          var type = colObj.type;
          type = (type=="RELCOL" || type=="REFCOL") ? colObj.relColType : type; //NO I18N
          if(menuitem.style.display !== 'none')
          {
            menuitem.style.display = (jQuery.inArray(type,ZDBUtil.allowedTypes_for_Drill)>=0) ? ZDBUtil.visibleTrStyle : 'none';
          }
         var enabled = (menuitem.style.display==='none')?false:true;
         menuitem.setAttribute("enabled",enabled);      
      }
      menuitem = $('ZDBMarkAsPII');
      if(menuitem && menuitem.style.display != 'none')
      {
        menuitem.style.display = (colObj.formula || colObj.isPii || !ZDBGlobal.isPIIEnabled) ? 'none' : ZDBUtil.visibleTrStyle;
      } 
      menuitem = $('ZDBRemoveAsPII');
      if(menuitem && menuitem.style.display != 'none')
      {
        menuitem.style.display = (colObj.formula || !colObj.isPii || !ZDBGlobal.isPIIEnabled) ? 'none' : ZDBUtil.visibleTrStyle;
      } 
      menuitem = $('ZDBTblGeocodingMenu');
      if(menuitem)
      {
          var type = colObj.type;
          type = (type=="RELCOL" || type=="REFCOL") ? colObj.relColType : type; //NO I18N
          if(menuitem.style.display !== 'none')
          {
            menuitem.style.display = (type=="GEO") ? ZDBUtil.visibleTrStyle : 'none';
          }
         var enabled = (menuitem.style.display==='none')?false:true;
         menuitem.setAttribute("enabled",enabled);      
      }
    }    
  }
  
  this.hideSeparator = function(menu)
  {
    menu = jQuery(menu);
    menu.find('a.ZRSMenuSeparator').show();
    var menuItems = menu.find('a:visible');
    for(var i = 0, len = menuItems.length; i < len; i++)
    {
      var menuItem = jQuery(menuItems[i]);
      if(menuItem.hasClass('ZRSMenuSeparator'))
      {
        if(i == len - 1 || jQuery(menuItems[i+1]).hasClass('ZRSMenuSeparator'))
        {
          menuItem.hide();
        }
      }
    }
    menuItems = menu.find('a:visible');
    var firstMenuItem = menuItems.first();
    if(firstMenuItem.hasClass('ZRSMenuSeparator'))
    {
      firstMenuItem.hide();
    }
    if(menuItems.length == 0)
    {
      menu.hide();
    }          
  }
  
  this.showHideMenuItemsBasedOnViewType = function(gridObj,type,cellObj, colObj, rowObj, level)
  {
    var view = gridObj;
    if(gridObj.viewObj)
    {
      view = gridObj.viewObj;
    }
    var menu = $("ZDBTColHeadMenu");
    var menuEl = jQuery(menu);
    menu.gridObj = colObj.parGrid;
    var menuItems = menuEl.find("li a:not('.ZRSMenuSeparator')"); //No I18N
    var integ = ZDBGlobal.integrated;
    var standAlone = view.viewCtx.isStandAlone();
    for(var i = 0; i < menuItems.length; i++)
    {
      var menuItem = menuItems[i];
      if(menuItem.getAttribute && menuItem.getAttribute("divider") && menuItem.getAttribute("hided") == "true")
      {
        continue;
      }
      if((integ && (menuItem.getAttribute("integ") != "true")) ||
         (menuItem.getAttribute("isDBOwnerReq") && standAlone))
      {
        menuItem.style.display = "none";
        menuItem.setAttribute("enabled","false");
        continue;
      }
      var viewTypes = menuItem.getAttribute("viewType").split(",");
      var menuLevel = menuItem.getAttribute("level").split(",");
      menuItem.style.display = (ZDBUtil.indexOf(viewTypes,type) > -1) && (ZDBUtil.indexOf(menuLevel,level) > -1) ? "" :'none';
    }
  }


  this.subMenu = function(element, event, menuEl,isDynamicMenuItems)
  { 
    if((typeof menuEl) == 'string')
    {
      menuEl = $(menuEl);
    }
    return ZDBPopUpMenu.subMenuEl(element, event, menuEl,isDynamicMenuItems);
  }
  
  this.subModuleMenu = function(element,event,menuName,moduleName,isDynamicMenuItems)
  {
    var menuEl = ZDBContentCache.appendAndGet(menuName,moduleName,document.body);
    if(menuEl == null)
    {
      return;
    }
    return ZDBPopUpMenu.subMenuEl(element, event, menuEl,isDynamicMenuItems);
  }
  
  this.subMenuEl = function(element, event, menuEl,isDynamicMenuItems)
  {  
    /*PK: Non sense?? */
    var infoEl = ZDBUtil.getPropertyFromEl(element, 'gridObj', 'element');
    if(infoEl)
    {
      menuEl.gridObj = infoEl.gridObj;
      menuEl.cellObj = infoEl.cellObj;
      menuEl.colObj = infoEl.colObj;
      menuEl.rowObj = infoEl.rowObj;
      var gridObj = infoEl.gridObj;
    }
    else
    {
      var view = ZDBClientUI.getViewObj(element,"view");//No I18N
      gridObj = view;
    }
    
    menuEl.sortType = element.sortType;
    menuEl.colObj = element.colObj; ///PK:
    
    var menu = jQuery(menuEl);
    if(view)
    {
      ZDBMenu.enableDisableMenuItems(gridObj,menu.find("li a"),false);
    }
    if(menuEl.parentNode != document.body)
    {
      document.body.appendChild(menuEl);
    }
    if(jQuery(element).parents("[isLeftNavItem]").length)
      {
          jQuery(menuEl).attr("isLeftNavItem","true"); //No I18N
      }
    ZRSMenu.showMenu(event,element,menuEl,3);
    return;
  }

  this.subMenuOnTypeBased = function(element,event, isFormula)
  {
    var gridObj = ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var length = gridObj.selectedCols.length;
    if(length == 0)
    {
      var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
      if(lastFocusCell != null)
      {
        gridObj.addSelectedCol(lastFocusCell.colObj);
      }    
    }
    length = gridObj.selectedCols.length;
    if(length == 0)
    {
      return;
    }

    var colHeads = gridObj.selectedCols[length - 1];
    var type = colHeads.type;
    var dataTypeBasedMenu = {};
    if(isFormula)
    { 
      var derivedFldMenuContent = ZDBContentCache.appendAndGet("Derived_Field_Menu","GridMenu",document.body);      
      dataTypeBasedMenu = {"DATE" : "ZDBDerivedFieldDateMenu_T1", //No I18N
                            "DATE_AS_DATE" : "ZDBDerivedFieldDateMenu_T1", //No I18N
                            "CURRENCY" : "ZDBDerivedFieldNumericMenu_T1", //No I18N
                            "PERCENT" : "ZDBDerivedFieldNumericMenu_T1", //No I18N
                            "POSITIVE_NUMBER" : "ZDBDerivedFieldNumericMenu_T1", //No I18N
                            "NUMBER" : "ZDBDerivedFieldNumericMenu_T1", //No I18N
                            "AUTO_NUMBER" : "ZDBDerivedFieldNumericMenu_T1", //No I18N
                            "DECIMAL_NUMBER" : "ZDBDerivedFieldFloatMenu_T1", //No I18N
                            "GEO_NUM" : "ZDBDerivedFieldFloatMenu_T1", //No I18N
                            "PLAIN" : "ZDBDerivedFieldStringMenu_T1", //No I18N
                            "GEO" : "ZDBDerivedFieldStringMenu_T1", //No I18N
                            "MULTI_LINE" : "ZDBDerivedFieldStringMenu_T1", //No I18N
                            "EMAIL" : "ZDBDerivedFieldStringMenu_T1", //No I18N
                            "URL" : "ZDBDerivedFieldStringMenu_T1" //No I18N      																					
                            };
    }
    else
    {
      var numMenuContent = ZDBContentCache.appendAndGet("Summ_Num_Menu","GridMenu",document.body);
      var otherMenuContent = ZDBContentCache.appendAndGet("Summ_Other_Menu","GridMenu",document.body);      
      dataTypeBasedMenu = {"CURRENCY" : "ZDBNumericSumFunc", //No I18N
                             "PERCENT" : "ZDBNumericSumFunc", //No I18N
                             "POSITIVE_NUMBER" : "ZDBNumericSumFunc", //No I18N
                             "NUMBER" : "ZDBNumericSumFunc", //No I18N
                             "DECIMAL_NUMBER" : "ZDBNumericSumFunc", //No I18N
                             "GEO_NUM" : "ZDBNumericSumFunc", //No I18N
                             "AUTO_NUMBER" : "ZDBNumericSumFunc", //No I18N
                             "DATE" : "ZDBOtherSumFunc", //No I18N
                             "DATE_AS_DATE" : "ZDBOtherSumFunc", //No I18N
                             "PLAIN" : "ZDBOtherSumFunc", //No I18N
                             "GEO" : "ZDBOtherSumFunc", //No I18N
                             "MULTI_LINE" : "ZDBOtherSumFunc", //No I18N
                             "EMAIL" : "ZDBOtherSumFunc", //No I18N
                             "URL" : "ZDBOtherSumFunc", //No I18N
                             "REFCOL" : "ZDBOtherSumFunc", //No I18N
                             "BOOLEAN" : "ZDBOtherSumFunc", //No I18N
                             "RELCOL" : "ZDBOtherSumFunc" //No I18N
                            };
    }
    if(type == "RELCOL")
    {
        type = colHeads.relColType;
    }
    var menu = dataTypeBasedMenu[type.toUpperCase()];
    if(!menu) { return;}
    var div = $(menu);
    this.subMenuEl(element,event,div);
    ZDBPopUpMenu.hideSeparator(div);
    var menuID=div;

    if(isFormula)
    {
      var displayType = (gridObj.type == 'Report') ? 'none' :ZDBUtil.visibleTrStyle;
      ZDBUtil.setNamedChildEls(div,div);
      div.aggFormula.style.display = displayType;
      div.editFormula.style.display = displayType;
    }
    if(!isFormula)
    {
      this.changeClass(menuID,colHeads);   
    }
  }

  this.gridOper = function(element)
  {
    var gridObj = ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    if(element.getAttribute("checkSave") == "true")
    {
      var message = element.getAttribute("message");
      if(!ZDBClientUI.checkAskSave(gridObj,message,this))
      {
        return;
      }
    } 
    var funcStr = element.getAttribute("func");
    var lazyLoad = element.getAttribute("lazyLoad");
    if(lazyLoad == "true")
    {
      var lzName = element.getAttribute("lzName");
      var lzUrl = element.getAttribute("lzUrl");  
      var lzOper = (element.getAttribute("lzOper")) ? element.getAttribute("lzOper") : "APPENDTODOC"; //No I18N
      var lzJs = element.getAttribute("lzJs");
      if(!ZDBLazyLoadUtil.loadSnippet(lzName,lzUrl,this,lzOper,lzJs))
      {
        return;
      }
    }
    ZDBPopUpMenu.invokeGridFunc(funcStr,element,gridObj);
  }
    
    this.invokeGridFunc = function(funcStr,element,gridObj)
    {
      var func = ZDBLazyLoadFuncMap.lazyLoadFuncMap[funcStr];
      func(element,gridObj);
    }
  
  this.hide = function(element, event)
  {
    var gridObj = ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    if(gridObj.isFilterApplied){
    	ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.common.zdbalertmsg.js.colReorderWithFilterColErr'));
    	return;
    }
    if(!gridObj.visibleColsAlone){
    	this.hideDash(element, event);
    	return;
    }
    if(gridObj.selectedCols.length == 0)
    {
      var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
      if(lastFocusCell != null)
      {
        gridObj.addSelectedCol(lastFocusCell.colObj);
      }    
    }
    if(gridObj.selectedCols.length == 0)
    {
      return;
    }
    if(ZDBUtil.isViewModified(gridObj)){
      ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.analysis.js.altering"));
      return;
      }
    if(gridObj.freeze)
    {
        ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.common.zdbalertmsg.js.colReorderWithFrozenColErr'));
        return false;
    }
    var colObj = gridObj.selectedCols[0];
    var colHeads = gridObj.allColHead;
    for(var i=0;i<gridObj.allColHead.length;i++){
    	if(colObj.colName==gridObj.allColHead[i][ZDBGlobal.columnId]) {
    		colObj=gridObj.allColHead[i];
    		break;
    	}
    }
    var colLen = colHeads.length;
    var visibleCount = 0;
    for(var i = 0; i < colLen; i++)
    {
      if(colHeads[i][ZDBGlobal.columnVisible])
      {
        visibleCount = visibleCount + 1;
        if(visibleCount > 1)
        {  
          gridObj.showHideColumn([[colObj, false]]);
          return;
        }
      }
    }
    ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.showrhide.js.allColHideErr'));
  }
  
  this.hideDash = function(element, event){
	    var gridObj = ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
	    if(gridObj.selectedCols.length == 0)
	    {
	      var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
	      if(lastFocusCell != null)
	      {
	        gridObj.addSelectedCol(lastFocusCell.colObj);
	      }   
	    }
	    if(gridObj.selectedCols.length == 0)
	    {
	      return;
	    }

	    var colObj = gridObj.selectedCols[0];
	    var colHeads = gridObj.colHeaders;
	    var colLen = colHeads.length;
	    var visibleCount = 0;
	    for(var i = 0; i < colLen; i++)
	    {
	      if(colHeads[i].visible)
	      {
	        visibleCount = visibleCount + 1;
	        if(visibleCount > 1)
	        { 
	          gridObj.showHideColumnDash([[colObj, false]]);
	          return;
	        }
	      }
	    }
	    ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.showrhide.js.allColHideErr'));
  }
  
  this.applyPopUpSummaryFunctions = function(el, event)
  {
    var gridObj = ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
    var colHead = gridObj.getSelectedColHead();
    var index = ZDBUtil.removeFromSet(colHead.fnArr,el.getAttribute("fnname"));          
    if(index == -1)
    {
      colHead.fnArr[colHead.fnArr.length] = el.getAttribute("fnname");
    }
    gridObj.modified = 1;
    gridObj.sendClientState(true);      
  }
  
  this.changeClass = function(menuID,colHeads)
  {
    var els = jQuery(menuID).find("li a");
    for(var i = 0;i < els.length;i++)
    {
      var el = jQuery(els[i]);
      var index = ZDBUtil.indexOf(colHeads.fnArr,el.attr("fnname"));
      el.find('span')[0].className = (index != -1) ? "ZRSMarked" : "ZRSUnMarked";        
    }
  }
  
  this.showFilter = function(element, event,filterType)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    if(!ZDBClientUI.checkAskSaveView(gridObj,ZDBI18NMap.g("zrpt.common.toolbar.filter.loadingdiv.js.applyingFilter"),
                                  gridObj))
    {
        return;
    }
    var cellObj = ZDBDataGrid.getCurrentCell(gridObj);
    if(!cellObj)
    {
      //PK: THE stupid code by me
      cellObj = ZDBDataGrid.getLastFocusCell(gridObj);
    }
    var colObj = cellObj.colObj;
    
    // for null value in plain text,email and multiline text we replace it with empty string    
    var filterValue = (cellObj.originalValue) ? ((colObj.type !== "REFCOL") ? cellObj.originalValue : cellObj.displayValue) : "";//No I18N                     
    filterValue = (colObj.type == "URL" && colObj.altText != null && filterValue != "") ? colObj.altText : filterValue;
    var opt = 0;
    if(!gridObj.filterVisible)
    {
      gridObj.showFilterArea();
    }
    if(filterValue != "" || colObj.type == "BOOLEAN" || colObj.refColType == "BOOLEAN")
    {
      if(colObj.type == "BOOLEAN"  || colObj.refColType == "BOOLEAN")
      {
        opt = (filterValue.toUpperCase() == "TRUE") ? 1 : ((filterValue.toUpperCase() == "FALSE") ? 2 : 3);
        if(filterType == 1)
        {
          opt = (opt == 1) ? 2 : ((opt == 2) ? 1 : 4);
        }
      }
      else
      {     
        colObj.filterInput.value = filterValue;
      }
      var types = "PLAIN,GEO,MULTI_LINE,EMAIL,URL";//NO I18N
      if((types.indexOf(colObj.type) != -1) || (types.indexOf(colObj.refColType) != -1))
      {
        opt = 3 + filterType;
      }
      else
      {
        if(colObj.type != "BOOLEAN" && colObj.refColType != "BOOLEAN")
        {
          opt = 1 + filterType;
        }
      }
    }
    else 
    {
      opt = ((colObj.type == "DATE" || colObj.type == "DATE_AS_DATE") ? 7 : 9) + filterType;
    }
    colObj.filterListEl.options[opt].selected = true;
    ZDBDataGrid.filterOptionChanged(colObj.filterListEl);
    if(colObj.type != "BOOLEAN" && colObj.refColType != "BOOLEAN" && filterValue != "")
    {
      colObj.filterInput.value = filterValue;
    }
    gridObj.removeCellFocus();
    gridObj.doFilter();
  }
  
  this.showColHeaderMenu = function(cellObj, colObj, rowObj, gridObj, event)
  {
	  var colHeadMenu = $("Pvt_Sort_Toolbar_Menu");	//No I18N
	  if(colHeadMenu == null)
	  {
		  colHeadMenu = ZDBContentCache.appendAndGet("Pvt_Sort_Toolbar_Menu","GridMenu", document.body);	//No I18N
	  }
	  ZDBUtil.setNamedChildEls(colHeadMenu,colHeadMenu);
	  colHeadMenu.cellObj = cellObj;
	  var dataColObj = cellObj.colObj;
	  var view = dataColObj.parGrid.viewObj;
	  var listEl = ZDBUtil.getElementsWithAttribute(view.currentList, "instkey",cellObj.vcIdent);	//No I18N
	  ZDBPivotView.setSubMenu(colHeadMenu, listEl[0], view, view.currentList.indexOf(listEl[0]),true);
	  ZRSMenu.showMenu(event,null,colHeadMenu,1);
    ZDBEvents.disableContextMenu(colHeadMenu);
  }
}

ZDBPopUpMenu.pivotContextMenu = function(cellObj, colObj, rowObj, gridObj, event)
{
  if(gridObj.contextDisabled || colObj.objType == ZDBConst.ROWHEAD || colObj.objType == ZDBConst.FILLER)
  {
    return;
  }      
  var view = gridObj.viewObj;
  if(view.chartArea.blured==null || view.chartArea.blured==true)
  {
    return;
  }
  if(ZDBPivotView.renameIcon != undefined)
  {
    var verify=ZDBPivotView.renameIcon.getAttribute("editable");
    if(verify == "false")
    {
      ZDBPivotView.hideInputElement();
    }
  }
  //*PK: Only Pivot Sort Menu */
  ZDBPopUpMenu.pivotPopup(cellObj, colObj, rowObj, gridObj, event);
}
  
  ZDBPopUpMenu.openDrillSettingsDlg = function(element,event)
  {
	urls = ["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_VMFILTERSTYLES"];//NO I18N
	if(!ZDBLazyLoadUtil.loadCssOnly(urls,"APPENDTODOC",ZDBPopUpMenu.openDrillSettingsDlg,[element,event]))
	{
		return;
	}
    DrillDownSettings.updateRefToTblView();
    DrillDownSettings.showDrillStngsDlgByColType(element, event);
    var drillDlg = ZDBDialogUtil.focusDialog.bodyContent;
      var gridObj = drillDlg.gridObj;
    var objId = gridObj.objId;    
    DrillDownSettings.fetchNUpdateDrillComboList(objId);
  }

  ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBPopUpMenu.openDrillSettingsDlg"]=ZDBPopUpMenu.openDrillSettingsDlg;
