/*$Id$*/

var ZRSMenu = new function()
{
  this.zIndex = 21000;
  this.visibleMenu = new Array();
  
  jQuery(document).bind('keydown', function(e)
  {
    ZRSMenu.keyHandling(e);
  });
    
  var evtype = BROWSER.IS_MOBILE ? "touchend" : "click" ;
  jQuery(document).bind(evtype, function(event)
  {
    ZRSMenu.closeAllMenu();
  });
  
  this.showMenu = function(event,el,menuEl,menuType,closeFunc)
  {
    ZDBToolTip.hide(event,true);
    if(ZRSMenu.visibleNavMenu)
        {
            ZDBNavigation.closeNavViewList(event,true);  
        }
    if(event.button != 2)//not for context menu
    {
      if(event.stopPropagation)
      {
        event.stopPropagation();
      }
    }
    var menu = jQuery(menuEl);
    var srcEl = jQuery(el);
    if(menu.is(":visible") && el && menuEl.srcEl == el)//avoid repeated call(submenu case - onmouseover) - return
    {
      if(menuType != 3)//menu toggle on repeated click - not for submenu case
    {
        ZRSMenu.closeAllMenu(el);
    }
      return;
    }
    if(srcEl.attr("submenu"))
    {
        ZRSMenu.closeAllSubMenuOfCurEl(el); //Close last opened menu while opening menu.
    }
    else
    {
      ZRSMenu.closeAllMenu(el);
    }
    menu[0].srcEl = el;
    menu.show();
    ZRSMenu.zIndex++;
    menuEl.closeFunc = closeFunc;
    this.visibleMenu.push(menu);
    menu[0].srcEl = el;
    var srcEl = jQuery(el);
    if(!srcEl.attr('submenu') && menuType!=5 && menuType!=4 && menuType!=6 && !srcEl.attr("menuparent"))
    {
     srcEl.addClass("ZRSDropDown");
    }
    if(!menu[0].positioned)
    {
    	ZRSMenu.position(menu,srcEl,menuType,event);
    }
    var menuItem = menu.find("li:not('.nonMenuItem')").has("a:visible:not('.ZRSMenuSeparator')").has("a[OPERATION!='DUMMY']"); //No I18N
    menu[0].menuItemList = menuItem;
    menuItem.mouseover(function(event)
    {
      var menuItemEl = jQuery(this);
      if(menuItemEl.hasClass('ZRSMenuHover'))
      {
       return;
      }
      var currentHoveredEl = menuItemEl.parents('ul').find('li.ZRSMenuHover');//NO I18N
      var isCurHovElASubMenu = currentHoveredEl.find("a").attr("submenu");//NO I18N
      if(currentHoveredEl && isCurHovElASubMenu)
      {
        ZRSMenu.closeAllSubMenuOfCurEl(currentHoveredEl[0]);
      }
      currentHoveredEl.removeClass('ZRSMenuHover');
      var anchorEl = menuItemEl.addClass("ZRSMenuHover").find('a');
      var submenu = anchorEl.attr('submenu'); //No I18N
      var analysisCase = anchorEl.attr('specialCase'); //NO I18N
      if(submenu && !analysisCase)
      {
        anchorEl.click();
      }
      else if(submenu && analysisCase)
      {
          if(anchorEl.attr("isRange")){
              var func = window["ZDBAnalysisFuncMenu"].showRangeSubMenuIfNeeded; //NO I18N
              func.apply(null, [event]);
          }
          else{
              var func = window["ZDBAnalysisFuncMenu"].showSubMenuIfNeeded; //NO I18N
              var isDate = anchorEl.attr("isDate");//NO I18N
            isDate = (isDate === "true")?isDate=true:isDate=false;
            var isSubMenu = anchorEl.attr("isSubMenu");//NO I18N
            isSubMenu = (isSubMenu === "true")?isSubMenu=true:isSubMenu=false;
            var funcAttr = [event,isDate,isSubMenu];
            func.apply(null, funcAttr);
          }  
      }
      else
      {
        ZRSMenu.closeMenu(menuItemEl);
      }
    });
    menuItem.mouseout(function()
    {
      var el = jQuery(this);
      if(el.find('a').attr('submenu'))
      {
        return;
      }
      el.removeClass("ZRSMenuHover");
    });
  }
  
  this.closeAllSubMenuOfCurEl = function(el)
  {
    var menuEls = ZRSMenu.visibleMenu.slice();
      for(var i = (menuEls.length - 1); i > -1 ; i--)
      {
        var menu = menuEls[i];
        if(!(menu.find(el).length > 0))
        {
          ZRSMenu.closeLastMenu(menu);
        }
        else
        {
          break;
        }
      }
  }
  
  this.keyHandling = function(e)
  {
    var event = e;
    var menu = ZRSMenu.visibleMenu.last();
    if(!menu.length)
    {
      return;
    }
    var code = e.keyCode ? e.keyCode : e.which;
    var menuItem = menu[0].menuItemList;
    var currentMenuItem = jQuery('.ZRSMenuHover'); //No I18N
    if (code === 27) 
    {
      ZRSMenu.closeMenu();
    }
    else if(code === 13)
    {//Enter key
      currentMenuItem.find('a').click(); //No I18N
    }
    else if(code === 38)
    {//up arrow
        var mLen = menuItem.length;
      var li = currentMenuItem.removeClass("ZRSMenuHover"); //No I18N
      var idx = menuItem.index(li);
      var prevEl = (idx <= 0) ? menuItem[mLen - 1] : menuItem[idx - 1]; //No I18N
      jQuery(prevEl).addClass("ZRSMenuHover");
    }
    else if(code === 40)
    {//down arrow
        var mLen = menuItem.length;
      var li = currentMenuItem.removeClass("ZRSMenuHover"); //No I18N
      var idx = menuItem.index(li);
      var nextEl = (idx < 0 || idx == mLen-1) ? menuItem[0] : menuItem[idx + 1]; //No I18N
      jQuery(nextEl).addClass("ZRSMenuHover");      
    }
    else if(code === 37)
    {//Left arrow
      var visibleMenus = ZRSMenu.visibleMenu;
      if(visibleMenus.length > 1)
      {
        ZRSMenu.closeMenu(null,true);
      }
      
    }
    else if(code === 39)
    {//Right arrow
      //currentMenuItem.find('a[submenu]').click(); //No I18N
    	var anchorEl = currentMenuItem.find('a');
        var submenu = anchorEl.attr('submenu'); //No I18N
        var analysisCase = anchorEl.attr('specialCase'); //NO I18N
        if(submenu && !analysisCase)
        {
          anchorEl.click();
        }
        else if(submenu && analysisCase)
        {
      	  if(anchorEl.attr("isRange")){
              var func = window["ZDBAnalysisFuncMenu"].showRangeSubMenuIfNeeded; //NO I18N
              func.apply(null, [event]);
          }
          else{
              var func = window["ZDBAnalysisFuncMenu"].showSubMenuIfNeeded; //NO I18N
              var isDate = anchorEl.attr("isDate");//NO I18N
              isDate = (isDate === "true")?isDate=true:isDate=false;
              var isSubMenu = anchorEl.attr("isSubMenu");//NO I18N
              isSubMenu = (isSubMenu === "true")?isSubMenu=true:isSubMenu=false;
              var funcAttr = [event,isDate,isSubMenu];
              func.apply(null, funcAttr);
          }  
        }
      }
    else
    {
      return;
    }
  }
  
  this.closeMenu = function(currentEl,isKeyHandle)
  {
    var menu = ZRSMenu.visibleMenu.last();
    if(menu.length > 0)
    {
      if(menu.find(currentEl).length > 0)
      {
        return;
      }
      ZRSMenu.closeLastMenu(menu,isKeyHandle);
    }    
  }
  
  this.closeAllMenu = function(currentEl)
  {
    var menuEls = ZRSMenu.visibleMenu.slice();
    for(var i = 0; i < menuEls.length; i++)
    {
      var menu = menuEls[i];
      if(menu.find(currentEl).length > 0)
      {
        continue;
      }
      ZRSMenu.closeLastMenu(menu);
    }
  }
  
  this.closeLastMenu = function(menu,isKeyHandle)
  {
    if(menu.length <= 0)
    {
      return;
    }
    if(menu[0].closeFunc)
    {
      menu[0].closeFunc();
    }
    var srcEl = jQuery(menu[0].srcEl);
    if(srcEl.attr('submenu') && !isKeyHandle)
    {
      srcEl.parent().removeClass('ZRSMenuHover');
    }
    else
    {
      srcEl.removeClass("ZRSDropDown");      
    }
   if(!menu.noHide) //  for themes dialogue another hide is not needed;
    {
    menu.hide();
    }
    ZRSMenu.visibleMenu.pop();
    ZRSMenu.zIndex--;
  }
    
  this.popupPosition = function(menu,event)
  {
    var clientX = event.clientX;
    var clientY = event.clientY;
    var pos = {left:"auto",right:"auto",top:"auto",bottom:"auto"}; //No I18N
    var wWidth = window.innerWidth;
    var wHeight = window.innerHeight;
    var remainRight = wWidth - clientX;
    var remainBottom = wHeight - clientY;
    
          
    var requiredRight = menu.width();
    var requiredBottom = menu.height();
    
    if(requiredRight > remainRight)
    {
      pos.left = wWidth - requiredRight - 20;
    }
    else
    {
      pos.left = clientX - 3;
    }
          
    if(requiredBottom > remainBottom)
    {
      pos.top = wHeight - requiredBottom - 20;
    }
    else
    {
      pos.top = clientY - 3;
    }
    return pos;
  }
  
  this.position = function(menu,srcEl,menuType,event)
  {
    var pos,top;
    var left = 'auto'; //No I18N
    var right = 'auto'; //No I18N
    if(menuType === 1)
    {//popup
      pos = ZRSMenu.popupPosition(menu,event);
      menu.css({left:pos.left,right:pos.right,top:pos.top,bottom:pos.bottom});
    }
    else if(menuType === 2)
    {//bottom right
      pos = srcEl.offset();
      top = pos.top + srcEl.outerHeight() - (srcEl[0].topDerc ? srcEl[0].topDerc : 1) ;
//    right = jQuery(window).width() - pos.left - srcEl.outerWidth();
      left = pos.left - (menu.outerWidth() - srcEl.outerWidth()); 
      menu.css({left:left,right:right,top: top}); 
    }
    else if(menuType === 3)
    {//submenu
      pos = srcEl.parent().offset();
      top = pos.top;
      var windowWidth = jQuery(window).width();
      var parMenuWidth = srcEl.parent().outerWidth();
      right = windowWidth - pos.left - parMenuWidth - menu.outerWidth();
      var windowHeight = jQuery(window).height();
      var menuHeight = menu.outerHeight();
      if(right < 0)
      {
        right = windowWidth - pos.left;
      }
      if(top + menuHeight >= windowHeight)
      {
        menu.css({left:left,right:right,top:"auto",bottom: 8,'z-index':ZRSMenu.zIndex}); //No I18N
      }
      else
      {
        menu.css({left:left,right:right,top: top,bottom:"auto",'z-index':ZRSMenu.zIndex}); //No I18N
      }
    }
    else if(menuType == 4)
    {//bottom left - moving menu postion regarding other element      
      var parId = srcEl.attr('relid'); //No I18N
      var parEl = jQuery('#'+parId);
      pos = parEl.offset();
      if(!pos)
      {
    	  pos = srcEl.offset();
    	  top = pos.top + srcEl.outerHeight() - 1;
    	  left = pos.left;
    	  var menuWidth = menu.outerWidth();
          var windowWidth = jQuery(window).width();
          if(windowWidth < (left + menuWidth + 20))
          {        
            right = windowWidth - left - srcEl.outerWidth();
            left = "auto"; //No I18N       
          }
          menu.css({left:left,right:right,top: top}); //No I18N
      }
      else
      {
    	  top = pos.top + srcEl.outerHeight() - 2;
          menu.css({left:pos.left,right:right,top: top }); //No I18N  
      }
    }
    else if(menuType==5)
    {//Simple dropdown
      pos = srcEl.offset();
      top = pos.top + srcEl.outerHeight();
      left = pos.left;
      menu.css({left:left,right:right,top: top}); //No I18N
    }
    else if(menuType==6)
    {
      	var pos = srcEl.offset();
        var wWidth = window.innerWidth;
        var wHeight = window.innerHeight;
        
        var remainRight = wWidth - pos.left;
        var remainBottom = wHeight - (pos.top + srcEl.outerHeight());
        
        var requiredRight = menu.outerWidth();
        var requiredBottom = menu.outerHeight();
        
        if(requiredRight > remainRight)
        {
          left = pos.left - requiredRight;
        }
        else
        {
          left = pos.left - 3;
        }
              
        if(requiredBottom > remainBottom)
        {
          $("MenuPtAfter").className = "ZRSMenuBottomAfter";
          $("MenuPtBefore").className = "ZRSMenuBottomBefore";
          top = pos.top - requiredBottom;
        }
        else
        {
          $("MenuPtAfter").className = "ZRSMenuTopAfter";
          $("MenuPtBefore").className = "ZRSMenuTopBefore";
          top = pos.top + srcEl.outerHeight() - 3;
        }
        menu.css({left:left,top: top});
    }
    else
    {//bottom left :: default
      pos = srcEl.offset();
      top = pos.top + srcEl.outerHeight() - 1;
      var menuWidth = menu.outerWidth();
      var windowWidth = jQuery(window).width();
      left = pos.left;
      if(windowWidth < left + menuWidth)
      {        
        right = windowWidth - Math.floor(left) - srcEl.outerWidth();
        left = "auto"; //No I18N       
      }
      menu.css({left:left,right:right,top: top}); //No I18N
    }
  }
  
  this.showHideToolBarEls = function(el)
  {
    el = jQuery(el);
    el.siblings("div").toggleClass("removeToolbar"); //No I18N
    el.toggleClass('ZR_LeftNavArrow').toggleClass('ZR_RightNavArrow'); //No I18N
    var tooltip = el.hasClass("ZR_LeftNavArrow") ? "zrpt.toolbar.embed.js.showtoolbar.tip.title" : "zrpt.toolbar.embed.js.hidetoolbar.tip.title"; //No I18N
    el.attr("tip",ZDBI18NMap.g(tooltip)); //No I18N
    var view = ZDBClientUI.getViewObj(el[0],"view");
    if(view && view.toolbar)
    {
      ZDBMenu.resizeTitleNDesc(view.toolbar);
    }
  }
  
  this.showHeaderMenu = function(el,event,menuId)
  {
    ZDBToolTip.hide(event,true);
    var menuEl = jQuery("#"+menuId);
    if(menuEl.is(":visible")) //No I18N
    {
      ZRSMenu.closeAllMenu(el);
      return;
    }
    ZDBMenu.showMenu(el, event,menuEl[0]);
    var top = jQuery("#ZDBMainHeader").position().top; //No I18N
    var right = parseInt(menuEl.css('right')); //No I18N
    if(!ZDBGlobal.ISNEWLAYOUT){
        right = right < 10 ? right : right - 10;
        top += 40;
    }
    else{
        DOMUtils.removeCSSClass([el], 'ZRSDropDown');
        top += 40;
    }
    menuEl.css({top:top,right:right});
  }
  
}
