//$Id$

var ZACondFormUtil = new function()
{
	//Constants - 
	
	this.FORMATROW = 1;
	this.KPIROW = 2;
	this.TEXTFUNCROW = 3;
	this.isSetModified = 2;
	
	//Condition Function List-
	this.isNull = "isn";	//NO I18N
	this.isBetween = "btw";	//NO I18N
	this.isNotBetween = "notbtw";	//NO I18N
	this.isNotNull = "notisn";	//NO I18N
	this.isNotEqual = "isnot";	//NO I18N
	this.curYear = "curYear";	//NO I18N
	this.prevYear = "prevYear";	//NO I18N
	this.prevNYears = "prevNYears";	//NO I18N
	this.lastNYears = "lastNYears";	//NO I18N
	this.nextYear = "nextYear";	//NO I18N
	this.nextNYears = "nextNYears";	//NO I18N
 	this.curMonth = "curMonth";	//NO I18N
	this.prevMonth = "prevMonth";	//NO I18N
	this.nextMonth = "nextMonth";	//NO I18N
	this.prevNMonths = "prevNMonths";	//NO I18N
	this.lastNMonths = "lastNMonths";	//NO I18N
	this.nextNMonths = "nextNMonths";	//NO I18N
	this.curWeek = "curWeek";	//NO I18N
	this.prevWeek = "prevWeek";	//NO I18N
	this.nextWeek = "nextWeek";	//NO I18N
	this.prevNWeeks = "prevNWeeks";	//NO I18N
	this.lastNWeeks = "lastNWeeks";	//NO I18N
	this.nextNWeeks = "nextNWeeks";	//NO I18N
	this.curQuarter = "curQuarter";	//NO I18N
	this.prevQuarter = "prevQuarter";	//NO I18N
	this.nextQuarter = "nextQuarter";	//NO I18N
	this.prevNQuarters = "prevNQuarters";	//NO I18N
	this.lastNQuarters = "lastNQuarters";	//NO I18N
	this.nextNQuarters = "nextNQuarters";	//NO I18N
	this.today = "today";	//NO I18N
	this.yesterday = "yest";	//NO I18N
	this.tomorrow = "tom";	//NO I18N
	this.prevNDays = "prevNDays";	//NO I18N
	this.lastNDays = "lastNDays";	//NO I18N
	this.nextNDays = "nextNDays";	//NO I18N
	this.isDate = "isd";	//NO I18N
	this.isNotDate = "isnotd";	//NO I18N
	
	this.yearGroup = [this.curYear, this.prevYear, this.nextYear, this.prevNYears, this.lastNYears, this.nextNYears];
	this.monthGroup = [this.curMonth, this.prevMonth, this.nextMonth, this.prevNMonths, this.lastNMonths, this.nextNMonths];
	this.weekGroup = [this.curWeek, this.prevWeek, this.nextWeek, this.prevNWeeks, this.lastNWeeks, this.nextNWeeks];
	this.dayGroup = [this.today, this.yesterday, this.tomorrow, this.prevNDays, this.lastNDays, this.nextNDays];
	this.quarterGroup = [this.curQuarter, this.prevQuarter, this.nextQuarter, this.prevNQuarters, this.lastNQuarters, this.nextNQuarters];
	this.prevNextGroup = [this.prevYear, this.nextYear, this.prevMonth, this.nextMonth, this.prevWeek, this.nextWeek, this.prevQuarter, this.nextQuarter, this.yesterday, this.tomorrow];
	this.nReqdGroup = [this.prevNYears, this.lastNYears, this.nextNYears, this.prevNMonths, this.lastNMonths, this.nextNMonths, this.prevNWeeks, this.lastNWeeks, this.nextNWeeks, this.prevNDays, this.lastNDays, this.nextNDays, this.prevNQuarters, this.lastNQuarters, this.nextNQuarters];
	this.noValueReqdCondList = [this.isNull, this.isNotNull, this.curYear, this.prevYear, this.nextYear, this.curMonth, this.prevMonth, this.nextMonth, this.curWeek, this.prevWeek, this.nextWeek, this.curQuarter, this.prevQuarter, this.nextQuarter, this.today, this.yesterday, this.tomorrow];
	
	//Callback
	this.iconColorPaletteCallback = 1;
	
	//KPI Options Constants
	this.ICONOPTION_VALICON = 1;
	this.ICONOPTION_ICON = 2;
	this.ICONPLACEMENT_NEAR = true;
	this.ICONPLACEMENT_FAR = false;
	this.ICONALIGN_LEFT = 1;
	this.ICONALIGN_CENTER = 2;
	this.ICONALIGN_RIGHT = 3;
	this.ICONALIGN_LEFTSTR = "left";	//NO I18N
	this.ICONALIGN_CENTERSTR = "center";	//NO I18N
	this.ICONALIGN_RIGHTSTR = "right";	//NO I18N
	
	//Condition Constant
	this.COND_COND = 0;
	this.COND_VAL = 1;
	this.COND_FONTCOLOR = 2;
	this.COND_BGCOLOR = 3;
	this.COND_TEXTALIGN = 4;
	this.COND_KPI = 5;
	this.COND_TF = 6;
	
	//Format Row Constants
	this.FORMATROW_FORMATID = 0;
	this.FORMATROW_FONTCOLOR = 1;
	this.FORMATROW_BGCOLOR = 2;
	this.FORMATROW_TEXTALIGN = 3;
	
	//KPI Row Constants
	this.KPIROW_KPIID = 0;
	this.KPIROW_KPIICON = 1;
	this.KPIROW_KPICOLOR = 2;
	this.KPIROW_KPIOPTION = 3;
	this.KPIROW_KPIPLACEMENT = 4;
	this.KPIROW_KPIALIGN = 5;
	
	//Text Func Row Constants
	this.TFROW_TFID = 0;
	this.TFROW_TEXTPREFIX = 1;
	this.TFROW_TEXTREPLACE = 2;
	this.TFROW_TEXTSUFFIX = 3;
	
	//Condition List Constants
	this.CONDLIST_FORMATID = 2;
	this.CONDLIST_KPIID = 3;
	this.CONDLIST_TEXTFUNCID = 4;
	
	this.formatClassNames = {};
	this.kpiClassNames = {};
	this.textFuncClassNames = {};
	
	this.populateMenu = function(view, id, parentEl)
	{
		if(view.condFormat)
		{
			view.condFormat.populateAll(view, id, parentEl);
		}
		else
		{
			parentEl.ZACondFormatMainTab.style.display = "none";
		}
	}
	
	this.showCondFormMenu = function(el)
	{
		var cellObj = ZDBUtil.getPropertyFromEl(el, 'cellObj','object');
		var colObj = (cellObj instanceof ZDBCell) ? cellObj.colObj : cellObj;
		var gridObj = colObj.parGrid;
		var view = gridObj.viewObj;
		if(!view)	
		{
			view = ZDBClientUI.getViewObj(el, "view");
		}
		if(!view.condFormat)
		{
			view.condFormat = new CondFormDetails();
		}
		var idx = ZACondFormUtil.getIdx(cellObj, gridObj, view);
		var menu = ZDBUtil.getCloneNode($("ZACFMenu"));
		ZACondFormUtil.setCtxMenuBody(menu);
		var callOut = true;
		var srcel = cellObj.cellEl;
		view.condFormat.setCondFormMenu(menu, view, idx, true);
		var helpDoc = ZDBI18NMap.g('zrpt.pivot.condFormat.js.condFormat.helpDoc');	//NO I18N
		var mainDlg = ZDBDialogUtil.showDialog(menu,{TITLE:ZDBI18NMap.g('zrpt.pivot.condFormat.js.condFormat'),VIEW:view,ADDFRAME:true,MODAL:true,DONTREMOVE:true,CALLOUT:callOut,SRCEL:srcel, HELPDOC:helpDoc});
		ZACondFormUtil.setFocusEl(menu);
	}
	
	this.setFocusEl = function(menu)
	{
		if(!menu)
		{
			return;
		}
		var condFormatRows = menu.getElementsByClassName("condFormatRow");	//NO I18N
		for(var i=0; i<condFormatRows.length; i++)
		{
			var condFormRow = condFormatRows[i];
			if(condFormRow.style.display == "none")
			{
				continue;
			}
			ZDBUtil.setNamedChildEls(condFormRow, condFormRow);
			var focusEl = condFormRow.formatVal;
			var cond = condFormRow.condition.value;
			focusEl = (cond == this.isBetween || cond == this.isNotBetween) ? condFormRow.btwFrom : focusEl;
			if(this.noValueReqdCondList.indexOf(cond) < 0)
			{
				ZDBUtil.setFocus(focusEl, false);
				return;
			}	
		}
	}
	
	this.submitForm = function(el)
	{
		var view = ZDBClientUI.getViewObj(el, "view");
		var menu = this.getParentElByClassName(el, "ctxMenu");	//NO I18N
		var modified = view.condFormat.isCondFormatModified(view, menu, true);
		if(modified == ZDBConst.CLEAR)	//Stop execution as Validation Failed
		{
			return false;
		}
		ZDBDialogUtil.closeDialog();
		if(modified == true)
		{
			view.setModified();
			view.refreshView();
		}
		else if(modified == this.isSetModified)
		{
			view.setModified();
		}
	}
	
	this.getIdx = function(cellObj, gridObj, view)
	{
		var msg = ZDBDataGrid.getCriteriaMsg(gridObj, cellObj, false);
		return this.getIdxFromCtx(view, msg);
	}
	
	this.getIdxFromCtx = function(view, msg)
	{
		var msgSplit = msg.split(/-N-/g);
		var rowIdx = null, colIdx = null, valIdx = null;
		var textAxisListLength = view.typeValue==ZDBClientViewAPI.TYPE_SUMMARY ? ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","GROUP").length : 	//NO I18N
			ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","TEXTAXIS").length;//NO I18N 
		
		if(view.typeValue==ZDBClientViewAPI.TYPE_PIVOT)
		{
			var rowAxisListLength = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","YAXIS").length;//NO I18N
	        var columnAxisListLength = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","XAXIS").length;//NO I18N
			
	        for(var i=rowAxisListLength-1; i>=0; i--)
	        {
	        	var rowMsg = msgSplit[i].split(/-P-/);
	        	if(rowMsg[1] != "-NA-")
	        	{
	        		rowIdx = rowMsg[0].replace(/\D/g,'');
	        		break;
	        	}
	        }
	        
	        for(var i=rowAxisListLength + columnAxisListLength - 1; i>=rowAxisListLength; i--)
	        {
	        	var colMsg = msgSplit[i].split(/-P-/);
	        	if(!(/&hyp;NA&hyp;|-V-/.test(colMsg[1])))
	        	{
	        		colIdx = colMsg[0].replace(/\D/g,'');
	        		break;
	        	}
	        }
		}
        
        if(textAxisListLength == 1)
        {
        	var textAxisList = view.typeValue==ZDBClientViewAPI.TYPE_SUMMARY ? ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","GROUP") : //NO I18N
        						ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","TEXTAXIS");	//NO I18N
        	valIdx = textAxisList[0].getAttribute("instkey");
        }
        else
        {
        	var valMsg = msgSplit[msgSplit.length-2].split(/-P-/);
        	valIdx = valMsg[0].replace(/\D/g,'');
        }
        
		return [rowIdx, colIdx, valIdx];
	}
	
	this.setCtxMenuBody = function(menu)
	{
		ZDBUtil.setNamedChildEls(menu, menu);
		menu.style.display="block";
		menu.style.padding = "0px";
		menu.condLists.style.width = "auto";
	}
	
	this.getParentElByClassName = function(el, className)
	{
		var parentNode = el.parentElement;
		while(parentNode.className.indexOf(className)==-1)
		{
			parentNode = parentNode.parentElement;
		}
		return parentNode;
	}
	
	this.addCondRow = function(el, className, addOn, menu, view, ctxMenu)
	{
		menu = menu == null ? (el==null || className==null) ? $("ZACFMenu") : this.getParentElByClassName(el, className) : menu;
		ZDBUtil.setNamedChildEls(menu, menu);
		var addBeforeEl = addOn==null ? (className=="condFormatRow" ? menu.addCondRow : menu.addFullCondRow) : (addOn=="condFormatRow" ? menu.addCondRow : menu.addFullCondRow);	//No I18N
		className = addOn==null ? className : addOn;
		var getClonedNode = menu.getElementsByClassName(className)[0];
		var condRowMenu = ZDBUtil.getCloneNode(getClonedNode);	//NO I18N
		condRowMenu.style.display = "";
		condRowMenu.removeAttribute("keeptext");
		var childEls = condRowMenu.querySelectorAll("div[keeptext]");
		for(var i=0;i<childEls.length; i++)
		{
			childEls[i].removeAttribute("keeptext");
		}
		if(ctxMenu)
		{
			var menuBottom = menu.ZACFMenuBottom;
			menuBottom.style.display = "";
		}
		addBeforeEl = !addBeforeEl ? menuBottom : addBeforeEl;
		addBeforeEl.parentElement.insertBefore(condRowMenu, addBeforeEl);
		ZDBInlineDialog.resizeDlgHeight();
		this.resizeSettingsTab();
		this.showHideAddCond(addBeforeEl.parentElement, className);
		return condRowMenu;
	}
	
	this.resizeSettingsTab = function()
	{
		var menu = $("ZACFSettingsMenu");
		if(menu.offsetHeight <= 0)
		{
			return;
		}
		ZDBUtil.setNamedChildEls(menu, menu);
		menu.leftContainer.style.height = "auto";
		menu.rightContainer.style.height = "auto";
		var height = menu.leftContainer.offsetHeight > menu.rightContainer.offsetHeight ? menu.leftContainer.offsetHeight : menu.rightContainer.offsetHeight;
		menu.leftContainer.style.height = height + "px";
	}
	
	this.showHideAddCond = function(parentEl, className)
	{
		if(className == "condFormatRow")
		{
			ZDBUtil.setNamedChildEls(parentEl, parentEl);
			var addBeforeEl = parentEl.addCondRow;
			var noOfConditions = this.getRowsLeft(parentEl, className);
			if(noOfConditions >= 10)
			{
				addBeforeEl.style.display = "none";
			}
			else
			{
				addBeforeEl.style.display = "";
			}
		}
	}
	
	this.getRowsLeft = function(parentEl, className)
	{
		return parentEl.getElementsByClassName(className).length - 1;	//the original one which is hidden
	}
	
	this.checkAndAdjustHeader = function(view, menu, subMenu, axisType)
	{
		if(view.typeValue==ZDBClientViewAPI.TYPE_SUMMARY && axisType != "GROUP")
		{
			var submenuHeader = axisType == "YAXIS" ? menu.rowAxisHeader : menu.colAxisHeader;	//NO I18N
			submenuHeader.style.display = "none";
			subMenu.style.display = "none";
			return true;
		}
		else if(axisType === "GROUP" && menu.dataHeaderSelect)
		{
			menu.dataHeaderSelect.style.width = "40%";
		}
		return false;
	}
	
	this.getHeaderDisplayName = function(axisLists, axisType, index, view, instNo)
	{
		var name = null;
		var axisList = axisLists[index];
		var curListProp = view.curListProp;
		if(axisType == "TEXTAXIS" || axisType == "GROUP")
		{
			name = curListProp[instNo]['PVTCOLUMNNAME'] || view.zacf.get(instNo).displayLabel;	//NO I18N
		}
		else
		{
			if(index == -1 || index==axisLists.length-1)
			{
				name = (index == axisLists.length-1 && index > -1) ? ZDBI18NMap.g('zrpt.pivot.condFormat.js.allPrefix')+" " : "";
				name += axisType == "XAXIS" ? ZDBI18NMap.g('zrpt.pivot.condFormat.js.colData') : ZDBI18NMap.g('zrpt.pivot.condFormat.js.rowData');	//NO I18N
				name += index == -1 ? " "+ZDBI18NMap.g('zrpt.pivot.condFormat.js.grandTotal') : ZDBI18NMap.g('zrpt.pivot.condFormat.js.suffix');
			}
			else
			{
				name = ((instNo == null || instNo == "null") ? axisList.getAttribute("title") : curListProp[instNo]['PVTCOLUMNNAME'] || view.zacf.get(instNo).displayLabel);	//No I18N
				name += " "+ZDBI18NMap.g('zrpt.pivot.condFormat.js.subtotal');
			}
		}
		name = ZDBEscapeUtil.encodeForHtml(name);
		return name;
	}
	
	this.setRuleHeaders = function(view, menu, axisDets, inlineHeader)
	{
		var group = view.typeValue==ZDBClientViewAPI.TYPE_SUMMARY ? "GROUP" : "TEXTAXIS";	//No I18N
		if(inlineHeader)
		{
			this.populateHeader(view, group, menu, axisDets==null? null : parseInt(axisDets[2]));	//No I18N
			this.populateHeader(view, "XAXIS", menu, axisDets==null? null : axisDets[1]==null || axisDets[1]=="null" ? "null" : parseInt(axisDets[1]));	//No I18N
			this.populateHeader(view, "YAXIS", menu, axisDets==null? null : axisDets[0]==null || axisDets[0]=="null" ? "null" : parseInt(axisDets[0]));	//No I18N
		}
		else
		{
			this.populateEl(view, group, menu, axisDets==null? null : parseInt(axisDets[2]));	//No I18N
			this.populateEl(view, 'XAXIS', menu, axisDets==null? null : axisDets[1]==null || axisDets[1]=="null" ? "null" : parseInt(axisDets[1]));	//No I18N
			this.populateEl(view, 'YAXIS', menu, axisDets==null? null : axisDets[0]==null || axisDets[0]=="null" ? "null" : parseInt(axisDets[0]));	//No I18N
		}
	}
	
	this.populateHeader = function(view, axisType, menu, instNo)
	{
		ZDBUtil.setNamedChildEls(menu, menu);
		var axisList = ZDBUtil.getElementsWithAttribute(view.currentList,"viewType", axisType);	//NO I18N
		var subMenu = (axisType == "TEXTAXIS" || axisType == "GROUP") ? menu.dataHeader : axisType=="YAXIS"? menu.rowHeader : menu.colHeader;	//No I18N
		var limit = (axisType == "TEXTAXIS" || axisType == "GROUP") ? 0 : -1;	//No I18N
		if(this.checkAndAdjustHeader(view, menu, subMenu.parentElement, axisType))
		{
			return;
		}
		var selectMenu = (axisType == "TEXTAXIS" || axisType == "GROUP") ? menu.dataHeaderSelect : axisType=="YAXIS"? menu.rowHeaderSelect : menu.colHeaderSelect;	//No I18N
		for(var i=axisList.length-1; i >= limit; i--)
		{
			var value = i==-1 ? "null" : axisList[i].getAttribute("instkey");	//NO I18N
			
			var name = this.getHeaderDisplayName(axisList, axisType, i, view, instNo);
			if(instNo && value == instNo)
			{
				subMenu.innerHTML = name;
				subMenu.setAttribute("title", name);
				subMenu.parentElement.value = value;
				return;
			}
			else if(!instNo &&  i==axisList.length - 1)
			{
				subMenu.innerHTML = name;
				subMenu.parentElement.value = value;
				return;
			}
		}
	}
	
	this.populateEl = function(view, axisType, menu, instNo)
	{
		ZDBUtil.setNamedChildEls(menu, menu);
		
		var axisList = ZDBUtil.getElementsWithAttribute(view.currentList,"viewType", axisType);	//NO I18N
		var subMenu = (axisType == "TEXTAXIS" || axisType == "GROUP") ? menu.dataAxis : axisType=="YAXIS"? menu.rowAxis : menu.colAxis;	//No I18N
		if(this.checkAndAdjustHeader(view, menu, subMenu, axisType))
		{
			return;
		}
		
		var option = document.createElement("option");
		var opElName = (axisType == "TEXTAXIS" || axisType == "GROUP") ? "dataAxisOption" : axisType=="YAXIS"? "rowAxisOption" : "colAxisOption";	//No I18N
		option.setAttribute("elname",opElName);
		var limit = (axisType == "TEXTAXIS" || axisType == "GROUP") ? 0 : -1;	//No I18N
		
		for(var i=axisList.length-1; i >= limit; i--)
		{
			var newOption = this.getNewNode(option);
			newOption.value = i==-1 ? null : axisList[i].getAttribute("instkey");	//NO I18N
			if((instNo && newOption.value==instNo))
			{
				newOption.selected = true;
			}
			else if(!instNo && i==axisList.length-1)
			{
				newOption.selected = true;
			}
			newOption.innerHTML = this.getHeaderDisplayName(axisList, axisType, i, view, newOption.value);
			subMenu.getElementsByTagName("select")[0].appendChild(newOption);
		}
	}
	
	this.getNewNode = function(node)
	{
		var newOption = ZDBUtil.getCloneNode(node);
		newOption.removeAttribute("style");	
		newOption.removeAttribute("keeptext");
		return newOption;
	}
	
	this.disableCondition = function(menu, disable)
	{
		if(disable)
		{
			var addFormatsLink = menu.addFormats.getAttribute("onclick");
			menu.condition.parentElement.innerHTML = menu.condition.options[menu.condition.selectedIndex].text;
			this.deepDisableEl(menu, true, "1");
			this.enableEl(menu.addFormats);
			this.enableEl(menu.addFormats.parentElement);
			menu.addFormats.setAttribute("onclick", addFormatsLink);
	        menu.addFormats.style.cursor = "pointer";	//NO I18N
			menu.removeCondRow.style.display = "none";
		}
	}
	
	this.appendRules = function(origSet, newSet)	
	{
		var rules = [];
		var length = Object.keys(origSet).length;
		var newSetFormat = ZACondFormUtil.validateData(newSet.getCondFormats());
		var modified = false;
		for(var i=0, k=0;i<length; i++)
		{
			if(!origSet[i])
			{
				continue;
			}
			var rule = new CondFormEntity(origSet[i]);
			var condForm = rule.getCondFormats();
			if(condForm[0]==newSetFormat[0] && condForm[1]==newSetFormat[1] && condForm[2]==newSetFormat[2])
			{
				rule.setCondList(newSet.getCondList());
				modified = true;
			}
			rules[k++] = rule;
		}
		if(!modified && newSet.getCondList().length > 0)
		{
			rules[length] = newSet;
		}
		return rules;
	}
	
	this.validateData = function(idx)
	{
		for(var i=0;i<idx.length; i++)
		{
			if(idx[i]=="null" || !idx[i] || idx[i]=="")
			{
				idx[i] = null;
			}
		}
		return idx;
	}
	
	this.getCondFormatData = function(menu, view)
	{
		var rules = [];
		for(var i=1,k=Object.keys(rules).length;i<menu.length;i++)
		{
			ZDBUtil.setNamedChildEls(menu[i], menu[i]);
			if(menu[i].getAttribute("key"))
			{
				ZACondFormUtil.changeTabFromCondList(menu[i], i);
			}
			var idx = ZACondFormUtil.getIdxFromMenu(menu[i]);
			var rowVal = idx[0];
			var colVal = idx[1];
			var dataVal = idx[2];
			var condFormatRows = menu[i].getElementsByClassName("condFormatRow");
		    var condList = ZACondFormUtil.checkCondForm(rules, dataVal, rowVal, colVal);
		    var isNewCond = condList.length==0 ? true : false;
		    
		    for(var j=1, z=condList.length;j<condFormatRows.length;j++)
		    {
		    	ZDBUtil.setNamedChildEls(condFormatRows[j], condFormatRows[j]);
		    	var condition = condFormatRows[j].condition.value;
			    
		    	var formatVal = (this.noValueReqdCondList.indexOf(condition) >= 0) ? "-1" : condFormatRows[j].formatVal.value;
		    	formatVal = this.prevNextGroup.indexOf(condition) >= 0 ? "1" : formatVal;
		    	formatVal = (condition == this.isBetween || condition == this.isNotBetween) ? condFormatRows[j].btwFrom.value + "," + condFormatRows[j].btwTo.value : formatVal;
		    	
			    var checkValidDateOp = ZACondFormUtil.checkValidDateOp(dataVal, view.currentList);
			    
			    if(formatVal == "")
		        {
			    	continue;
		        }
			    var validate = ZACondFormUtil.validateConditionValue(condition, formatVal, checkValidDateOp);
			    if(!validate)
			    {
			    	var errorMessage = ZACondFormUtil.getErrorMessage(condition, formatVal, checkValidDateOp);
			    	showCustomMessage(errorMessage,condFormatRows[j].formatVal.parentElement,null);
			    	return false;
			    }
			    formatVal = ZACondFormUtil.getFormatVal(formatVal, condition, checkValidDateOp);
			    var fontDisp = "#"+condFormatRows[j].fontDisp.getAttribute("value");
			    var bgDisp = "#"+condFormatRows[j].bgDisp.getAttribute("value");
			    var addFormats = condFormatRows[j].addFormats.addFormats;
			    if(!addFormats)
			    {
			    	condList[z++] = [condition, formatVal, fontDisp, bgDisp];
			    }
			    else
			    {
			    	condList[z++] = [condition, formatVal, fontDisp, bgDisp, addFormats["textAlign"], addFormats["kpi"], addFormats["textFunc"]];
			    }
		    }
		    if(isNewCond)
		    {
		    	rules[k++] = new CondFormEntity(dataVal, rowVal, colVal, condList);
		    }
		}
	    return rules;
	}
	
	this.checkCondForm = function(rules, dataVal, rowVal, colVal)
	{
		if(!rules)
		{
			return [];
		}
		for(var i=0;i<Object.keys(rules).length; i++)
		{
			var rule = rules[i];
			var condForm = rule.getCondFormats();
			if(condForm[0]==dataVal && condForm[1]==rowVal && condForm[2]==colVal)
			{
				return rule.getCondList();
			}
		}
		return [];
	}
	
	this.modifyHeader = function(view, menu)
	{
		if(view.typeValue==ZDBClientViewAPI.TYPE_SUMMARY)
		{
			return;
		}
		ZDBUtil.setNamedChildEls(menu, menu);
		var rowData = menu.rowHeader.innerHTML;
		var colData = menu.colHeader.innerHTML;
		menu.rowAxis.parentElement.style.display = "none";
		
		menu.appliedTo.parentElement.style.display = "";
		menu.appliedTo.innerHTML = "[" + rowData + ", " + colData + "]";
		menu.appliedTo.title = menu.appliedTo.innerHTML;
	}
	
	this.pruneSettingsTab = function(menu)
	{
		menu.style.display = "none";
		menu.style.paddingLeft = "10px"; //No I18N
		menu.style.width = "85%";
	}
	
	this.changeTab = function(el, deleteRow)
	{
		var idx = ZACondFormUtil.getIdxFromMenu(el);
		var menu = ZACondFormUtil.getParentElByClassName(el, "tabEl3");	//No I18N
		ZDBUtil.setNamedChildEls(menu, menu);
		var condFormats = menu.leftContainer.getElementsByClassName("condFormatRuleTab");	//No I18N
		this.setBackgroundColorOrDelete(condFormats, el, deleteRow);
		var condList = menu.condLists.parentElement.getElementsByTagName("table");
		var selectedCondList;
		for(var i=1; i<condList.length; i++)
		{
			var key = condList[i].getAttribute("key");
			key = ZACondFormUtil.getAxisDetails(key);
			if(key[0]===idx[0] && key[1]===idx[1] && key[2]===idx[2])
			{
				condList[i].style.display = "";
				selectedCondList = condList[i];
				if(deleteRow)
				{
					condList[i].parentElement.removeChild(condList[i]);
				}
			}
			else
			{
				condList[i].style.display = "none";
			}
		}
		ZDBUtil.setFocus(el, true);
		ZACondFormUtil.resizeSettingsTab();
		ZACondFormUtil.setFocusEl(selectedCondList);
	}
	
	this.setBackgroundColorOrDelete = function(formats, el, deleteRow)
	{
		for(var i=1; i<formats.length; i++)
		{
			if(formats[i] === el)
			{
				formats[i].style.backgroundColor = "#efefef";
				formats[i].setAttribute("selected",true);
				if(deleteRow)
				{
					el.parentElement.removeChild(el);
					return;
				}
			}
			else
			{
				formats[i].removeAttribute("selected");
				formats[i].style.backgroundColor = "";
			}
		}
	}
	
	this.isModified = function(newObj, oldObj, attrs)
	{
		var newUpdatedObj = attrs ? {} : newObj;
		var oldUpdatedObj = attrs ? {} : oldObj;
		if(attrs)
		{
			for(var i=0; i<attrs.length; i++)
			{
				if(newObj && newObj.hasOwnProperty(attrs[i]))
				{
					newUpdatedObj[attrs[i]] = newObj[attrs[i]];
				}
				if(oldObj && oldObj.hasOwnProperty(attrs[i]))
				{
					oldUpdatedObj[attrs[i]] = oldObj[attrs[i]];
				}
			}
		}
		
		newUpdatedObj = jQuery.isEmptyObject(newUpdatedObj) ? null : newUpdatedObj;
		oldUpdatedObj = jQuery.isEmptyObject(oldUpdatedObj) ? null : oldUpdatedObj;
		
		if(!(JSON.stringify(newUpdatedObj) == JSON.stringify(oldUpdatedObj)))
		{
			return true;
		}
		return false;
	}
	
	this.changeTabFromCondList = function(el, index)
	{
		var parEl = ZACondFormUtil.getParentElByClassName(el, "tabEl3");	//NO I18N
		this.changeTab(parEl.leftContainer.getElementsByClassName("condFormatRuleTab")[index]);
	}
	
	this.getAxisDetails = function(key)
	{
		return JSON.parse(key);
	}
	
	this.showColorPalette = function(el, type, callback)
	{
		var currClr = el.getAttribute("value");
		var view = ZDBClientUI.getViewObj(el, "view");	//No I18N
		callback = callback == this.iconColorPaletteCallback ? ZACondFormUtil.changeIconColor : ZACondFormUtil.setPalleteStyle;
		ZDBColorPalette.showClrPalette(el, currClr, PropSettings.getTitleForColorPalette(type), view, callback);
	}
	
	this.setPalleteStyle = function(el)
	{
		if(el.className == "inlineFontColorIcon")
		{
			el.style.color = el.style.backgroundColor;
			el.style.backgroundColor = "white";
			el.style.border = "none";
		}
	}
	
	this.addClassName = function(className, attrs)
	{
		if(!attrs)
		{
			return;
		}
		var style = document.createElement('style');
		style.type = 'text/css';
		var formats = "";
		for(var attr in attrs)
		{
			formats += attr + ": " + attrs[attr] + ";";
		}
		style.innerHTML = "." + className + "{ " + formats + " }";
		document.getElementById("ZDBAnalysisViewTpl").appendChild(style);
		return style;
	}
	
	this.addNewCondition = function(el, className, addOn, menu, checkValidDateOp)
	{
		var condRow = ZACondFormUtil.addCondRow(el, className, addOn, menu);
		var randomColor = this.generateRandomColor(this.getRowsLeft(condRow.parentElement, "condFormatRow"));	//NO I18N
		ZDBUtil.setNamedChildEls(condRow, condRow);
		
		condRow.bgDisp.setAttribute("value", randomColor);
		condRow.bgDisp.style.backgroundColor = "#" + randomColor;
		var fontRandomColor = ZDBColorUtil.getPatternColor("#"+randomColor, true);
		condRow.fontDisp.setAttribute("value", fontRandomColor.replace("#",""));
		condRow.fontDisp.style.color = fontRandomColor;
		
		if(checkValidDateOp == null || checkValidDateOp == undefined)
		{
			menu = ZDBUtil.getParentWithAttributeValue(condRow, "elname", "ZACondFormatTab");	//NO I18N
			menu = !menu ? ZDBUtil.getParentWithAttr(condRow, "key") : menu;
			var idxMenu = menu.getAttribute("key") ? menu : menu.headerTable;
			var view = ZDBClientUI.getViewObj(condRow, "view");	
			var idx = ZACondFormUtil.getIdxFromMenu(idxMenu);
			checkValidDateOp = ZACondFormUtil.checkValidDateOp(idx[2], view.currentList);
		}
		condRow.condition.style.display = checkValidDateOp ? "none" : "";
		condRow.dateCondition.style.display = checkValidDateOp ? "" : "none";
		condRow.condition = checkValidDateOp ? condRow.dateCondition : condRow.condition;
		
		ZACondFormUtil.checkAndSetDatePicker(condRow, checkValidDateOp);
		ZACondFormUtil.getAndSetPlaceholderAndTitle(condRow.condition, condRow.formatVal);
		ZDBUtil.setFocus(condRow.formatVal, true);
		try
		{
			var parTable = ZACondFormUtil.getParentElByClassName(condRow, "condLists");	//NO I18N
		}
		catch(e)	//Will throw exception incase of adding condition from Settings Tab
		{
			return condRow;
		}
		jQuery(parTable).animate({scrollTop: parTable.scrollHeight}, 500);
		return condRow;
	}
	
	this.generateRandomColor = function(step)
	{
		var letters = '0123456789ABCDEF'.split('');	//NO I18N
	    var color = '';
	    for (var i = 0; i < 6; i++ ) {
	        color += letters[Math.floor(Math.random() * 16)];
	    }
	    return color;
	}
	
	this.removeCondRow = function(el, className, event)
	{
		var view = ZDBClientUI.getViewObj(el, "view");
		var condRowNode = ZACondFormUtil.getParentElByClassName(el, className);
		var parentClass = className=="condFormatRow" ? "condFormatRuleTab" : "tabEl3";	//NO I18N
		var parentEl = ZACondFormUtil.getParentElByClassName(condRowNode, parentClass);
		var isLast = this.checkLastRow(parentEl, className);
		if(!isLast)
		{
			condRowNode.parentElement.removeChild(condRowNode);
			ZACondFormUtil.showHideAddCond(parentEl, className);
		}
		else if(className=="condFormatRow")
		{
			isLast = this.checkLastRow(parentEl.parentElement, parentClass);
			if(isLast)
			{
				condRowNode.parentElement.removeChild(condRowNode);
				view.condFormat.populateCondEl(view, null, parentEl);
			}
			else
			{
				var key = parentEl.getAttribute("key");
				var menu = ZACondFormUtil.getParentElByClassName(parentEl, "tabEl3");	//No I18N
				ZDBUtil.setNamedChildEls(menu, menu);
				var leftMenu = menu.leftContainer.getElementsByClassName("condFormatRuleTab");	//No I18N
				 
				for(var i=1; i<leftMenu.length; i++)
				{
					var condMenu = leftMenu[i];
					var idx = ZACondFormUtil.getIdxFromMenu(condMenu);
					if(JSON.stringify(idx)===key)
					{
						var nextEl = this.getNextElement(condMenu, leftMenu);
						condMenu.parentElement.removeChild(condMenu);
						break;
					}
				}
				parentEl.parentElement.removeChild(parentEl);
				ZACondFormUtil.changeTab(nextEl);
			}
		}
		else
		{
			condRowNode.parentElement.removeChild(condRowNode);
			view.condFormat.addNewRule(null, "condFormatRuleTab", null, view);	//No I18N
		}
		ZDBInlineDialog.resizeDlgHeight();
		ZACondFormUtil.resizeSettingsTab();
		if(event)
		{
			event.stopPropagation();
		}
	}
	
	this.checkLastRow = function(parentEl, className)
	{
		var rowsLeft = ZACondFormUtil.getRowsLeft(parentEl, className);
		if(rowsLeft > 1)
		{
			return false;
		}
		return true; 
	}
	
	this.getNextElement = function(menu, formatRules)
	{
		var nextEl = null;
		for(var i=1; i<formatRules.length; i++)
		{
			nextEl = formatRules[i-1];
			if(menu == formatRules[i] && (i+1) < formatRules.length)
			{
				nextEl = formatRules[i+1];
				break;
			}
		}
		return nextEl;
	}
	
	this.deleteRule = function(el, event)
	{
		var menu = ZACondFormUtil.getParentElByClassName(el, "condFormatRuleTab");	//No I18N
		var parentEl = menu.parentElement;
		var formatRules = parentEl.getElementsByClassName("condFormatRuleTab");	//No I18N
		
		if(menu.getAttribute("selected"))
		{
			var nextEl = this.getNextElement(menu, formatRules);
		}
		else
		{
			var nextEl = this.getSelectedRule(formatRules);
		}
		
		ZACondFormUtil.changeTab(menu, true);	//This is deleting the rule check function definition
		ZACondFormUtil.changeTab(nextEl);	//this is changing the tab to the nearest element, next one preferred over the prev one
		
		if(parentEl.getElementsByClassName("condFormatRuleTab").length == 1)
		{
			parentEl = parentEl.parentElement;
			ZDBUtil.setNamedChildEls(parentEl, parentEl);
			parentEl.leftContainer.style.display = "none";
			parentEl.condFormTitle.innerHTML = ZDBI18NMap.g('zrpt.pivot.condFormat.js.noConditions');
			parentEl.condFormTitle.style.border = "none";
			parentEl.condFormTitle.style.margin = "15% 0px 0px 30%";	//No I18N
		}
		
		if(event)
		{
			event.stopPropagation();
		}
	}
	
	this.getSelectedRule = function(formatRules)
	{
		for(var i=1; i<formatRules.length; i++)
		{
			var nextEl = formatRules[i];
			if(nextEl.getAttribute("selected"))
			{
				return nextEl;
			}
		}
	}
	
	this.getIdxFromMenu = function(menu)
	{
		ZDBUtil.setNamedChildEls(menu, menu);
		if(!menu.dataHeaderSelect)
		{
			var idx = this.getAxisDetails(menu.getAttribute("key"));
		}
		var rowVal, colVal, dataVal;
		
		if(!idx)
		{
			rowVal = !menu.rowHeaderSelect ? menu.rowAxis.value : menu.rowHeaderSelect.value ? menu.rowHeaderSelect.value : menu.rowAxis.value;
			colVal = !menu.colHeaderSelect ? menu.colAxis.value : menu.colHeaderSelect.value ? menu.colHeaderSelect.value : menu.colAxis.value;
			dataVal = !menu.dataHeaderSelect ? menu.dataAxis.value : menu.dataHeaderSelect.value ? menu.dataHeaderSelect.value : menu.dataAxis.value;
		}
		else
		{
			rowVal = idx[0];
			colVal = idx[1];
			dataVal = idx[2];
		}
	    return this.validateData([rowVal, colVal, dataVal]);
	}
	
	this.editHeader = function(el)
	{
		var menu = this.getParentElByClassName(el, "condFormatRuleTab");	//No I18N
		ZDBUtil.setNamedChildEls(menu, menu);
		var view = ZDBClientUI.getViewObj(el, "view");
		var idx = [menu.rowAxis.value, menu.colAxis.value, menu.dataAxis.value];
		
		menu.dataHeader.style.display = "none";
		menu.rowHeader.style.display = "none";
		menu.colHeader.style.display = "none";
		menu.editHeader.style.display = "none";
		
		menu.dataHeaderSelect.style.display = "";
		menu.rowHeaderSelect.style.display = "";
		menu.colHeaderSelect.style.display = "";
		this.setRuleHeaders(view, menu, idx);
	}
	
	this.updateCondList = function(el)
	{
		var menu = this.getParentElByClassName(el, "condFormatRuleTab");	//No I18N
		ZDBUtil.setNamedChildEls(menu, menu);
		var dataVal = menu.dataHeaderSelect.value;
		var rowVal = menu.rowHeaderSelect.value;
		var colVal = menu.colHeaderSelect.value;
		
		dataVal = (!dataVal || dataVal === "null") ? null : dataVal;	//No I18N
		rowVal = (!rowVal || rowVal === "null") ? null : rowVal;	//No I18N
		colVal = (!colVal || colVal === "null") ? null : colVal;	//No I18N
		ZDBUtil.removeElementsByClassName(menu.condLists, "condFormatRow"); //No I18N
		var view = ZDBDialogUtil.focusDialog.view;
		var condRules = view.condFormat.getCondRules();
		var checkValidDateOp = ZACondFormUtil.checkValidDateOp(dataVal, view.currentList);
		view.condFormat.setCondListInMenu(view, condRules[JSON.stringify([rowVal, colVal, dataVal])], menu, null, checkValidDateOp);
	}
	
	this.checkAndDisplayMessage = function(isCondViewModified)
	{
		if(isCondViewModified)
		{
			ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.pivot.condFormat.js.condModified'));
		}
	}
	
	this.checkValidDateOp = function(dataIdx, list)
	{
		for(var i=0; i<list.length; i++)
		{
			if(list[i].getAttribute("instkey") == dataIdx && list[i].getAttribute("addontype") == "ABSDATECATEGORICAL" && (list[i].getAttribute("operation") == "MI_DATE" || list[i].getAttribute("operation") == "MX_DATE"))
			{
				return true;
			}
		}
		return false;
	}
	
	this.checkIfNull = function(el, removeVal, checkValidDateOp)
	{
		var parEl = ZDBUtil.getParentWithAttributeValue(el, "elname", "condFormatRow");	//NO I18N
		var condition = el.value;
		this.checkAndSetDatePicker(parEl, checkValidDateOp);
		if(this.noValueReqdCondList.indexOf(condition) < 0 && !(condition == "btw" || condition == "notbtw"))
		{
			this.enableDisableFormatEl(parEl, true);
		}
		else if(this.noValueReqdCondList.indexOf(condition) < 0 && (condition == "btw" || condition == "notbtw"))
		{
			this.enableDisableFormatEl(parEl, false);
		}
		else
		{
			this.enableDisableFormatEl(parEl, true);
			this.disableEl(parEl.formatVal, true, "0.5");
			parEl.formatVal.value = "";
		}
		this.getAndSetPlaceholderAndTitle(el, parEl.formatVal); 
	}
	
	this.enableDisableFormatEl = function(menu, enable)
	{
		if(enable)
		{
			this.enableEl(menu.formatVal);
			menu.btwFrom.style.display = "none";
			menu.formatVal.style.display = "";
			var cond = menu.condition.value;
			jQuery(menu.btwTo).animate({"width":"0%"}, "fast", "linear", function(){	//NO I18N
				menu.btwTo.style.display = "none";
			});
			jQuery(menu.formatVal).animate({"width":"90%"}, "fast", "linear", function(){	//NO I18N
				if(ZACondFormUtil.noValueReqdCondList.indexOf(cond) < 0)
				{
					ZDBUtil.setFocus(menu.formatVal, false);
				}
			});
		}
		else
		{
			jQuery(menu.formatVal).animate({"width":"42%"}, "fast", "linear", function(){	//NO I18N
				menu.formatVal.style.display = "none";
				menu.btwFrom.style.display = "";
				ZDBUtil.setFocus(menu.btwFrom, false);
			});
			menu.btwTo.style.display = "";
			jQuery(menu.btwTo).animate({"width":"42%"}, "fast", "linear");	//NO I18N
		}
	}
	
	this.getAndSetPlaceholderAndTitle = function(el, formatVal)
	{
		var placeHolder = el.options[el.selectedIndex].getAttribute("ph");
		if(!placeHolder && placeHolder != "")
		{
			placeHolder = this.getCurrentTime(el.value);
			formatVal.placeholder = placeHolder;
		}
		else
		{
			formatVal.placeholder = "";
		}
		formatVal.title = placeHolder;
	}
	
	this.checkAndSetDatePicker = function(el, checkValidDateOp)
	{
		var condition = el.condition.value;
		var formatVal = el.formatVal.value;
		if(checkValidDateOp == null)
		{
			var parEl = ZDBUtil.getParentWithAttributeValue(el, "elname", "ZACondFormatTab");	//NO I18N
			parEl = !parEl ? ZDBUtil.getParentWithAttributeValue(el, "elname", "condLists") : parEl;	//NO I18N
			var idx = this.getIdxFromMenu(parEl);
			var view = ZDBClientUI.getViewObj(el, "view");
			checkValidDateOp = this.checkValidDateOp(idx[2], view.currentList);
		}
		
		if(checkValidDateOp && this.nReqdGroup.indexOf(condition) < 0)
		{
			this.showDatePicker(el.formatVal);
			this.showDatePicker(el.btwFrom);
			this.showDatePicker(el.btwTo);
			formatVal = ZDBValidator.isDecimal(formatVal, false, false) ? null : formatVal;
		}
		else if(checkValidDateOp && this.nReqdGroup.indexOf(condition) >= 0)
		{
			el.formatVal.onclick = null;
			el.btwFrom.onclick = null;
			el.btwTo.onclick = null;
			el.formatVal.initialized = false;
			el.btwFrom.initialized = false;
			el.btwTo.initialized = false;
			formatVal = ZDBValidator.isDecimal(formatVal, false, false) ? formatVal : null;
		}
		
		el.formatVal.value = formatVal;
	}
	
	this.setCondDesc = function(el, disable)
	{
		var parEl = ZDBUtil.getParentWithAttributeValue(el, "elname", "ZACFMenu");	//NO I18N
		parEl = !parEl ? ZDBUtil.getParentWithAttributeValue(el, "elname", "ZACondFormat") : parEl;	//NO I18N
		this.clearAnimationQueue(parEl);
		var condDescHeader = parEl.condDescHeader;
		var condDesc = parEl.condDesc;
		if(disable)
		{
			jQuery(condDesc.parentElement).animate({"opacity" : "0"}, "fast");	//NO I18N
			return;
		}
		var condRow = ZDBUtil.getParentWithAttributeValue(el, "elname", "condFormatRow");	//NO I18N
		//ZDBUtil.setNamedChildEls(condRow, condRow);
		var placeHolder = condRow.condition.options[condRow.condition.selectedIndex].getAttribute("ph");
		if(placeHolder)
		{
			condDescHeader.innerHTML = condRow.condition.options[condRow.condition.selectedIndex].innerHTML + " - ";
			condDesc.innerHTML = placeHolder;
			jQuery(condDesc.parentElement).animate({"opacity":"1"},"fast");	//NO I18N
		}
	}
	
	this.showDatePicker = function(el)
	{
		ZAVMFilterComp.initCalender(el,false,[]);
	}
	
	this.getCurrentTime = function(timeType)
	{
		var d = new Date();
		if(this.yearGroup.indexOf(timeType) >= 0)
		{
			return timeType == "curYear" ? d.getFullYear() : timeType == "prevYear" ? d.getFullYear() - 1 : d.getFullYear() + 1;	//NO I18N
		}
		else if(this.monthGroup.indexOf(timeType) >= 0)
		{
			var monIndex = timeType == "curMonth" ? d.getMonth() : timeType == "prevMonth" ? (d.getMonth()-1) : (d.getMonth()+1);	//NO I18N
			var dNew = new Date(d.getFullYear(), monIndex, 1);
			return dNew.print("%B") + ", " + dNew.getFullYear();	//NO I18N
		}
		else if(this.weekGroup.indexOf(timeType) >= 0)
		{
			var weekNo = timeType == "curWeek" ? 0 : timeType == "prevWeek" ? -7 : 7;	//NO I18N
			var week = new Date(d.getFullYear(), d.getMonth(), d.getDate()+weekNo);
			var first = week.getDate() - week.getDay();
			var last = first + 6; 
			var firstDay = new Date(week.setDate(first));
			var lastDay = new Date(week.setDate(last));
			return (this.getStdDisplayOfDate(firstDay) + " - " + this.getStdDisplayOfDate(lastDay));
		}
		else if(this.quarterGroup.indexOf(timeType) >= 0)
		{
			var quarter = parseInt((d.getMonth() / 3) + 1);
			quarter = timeType == "curQuarter" ? quarter : timeType == "prevQuarter" ? quarter - 1 : (quarter + 1) % 4;	//NO I18N
			var year = d.getFullYear();
			year = quarter <= 0 ? year - 1 : (quarter == 1 && timeType == "nextQuarter") ? year + 1 : year;	//NO I18N
			quarter = quarter <= 0 ? 4 + quarter : quarter;
			return "Q" + quarter + ", " + year;	//NO I18N
		}
		else if(this.dayGroup.indexOf(timeType) >= 0)
		{
			var newDay = timeType == "today" ? d.getDate() : timeType == "yest" ? d.getDate()-1 : d.getDate()+1;	//NO I18N
			var dNew = new Date(d.getFullYear(), d.getMonth(), newDay);
			return dNew.print("%A") + ", " + this.getStdDisplayOfDate(dNew);	//NO I18N
		}
		else 
		{
			return "";
		}
	}
	
	this.getStdDisplayOfDate = function(date)
	{
		return date.print("%d %b %Y");	//NO I18N
	}
	
	this.showMoreOptions = function(el)
	{
		view = ZDBClientUI.getViewObj(el, "view");
		var menu = ZDBUtil.getCloneNode($("ZAFormatOptions"));
		var restrictAccess = false;
		if(view.viewCtx.isStandAlone() || !view.permissions.designModify)
		{
			restrictAccess = true;
		}
		var hideMenuComponent = this.checkAndSetAddDialog(menu, el, restrictAccess);
		var noFocus = restrictAccess ? true : false;
		var toggleEls = menu.getElementsByClassName("inlineToggle");	//NO I18N
		this.setToggleFunc(toggleEls);
		var mainDlg = ZDBDialogUtil.showDialog(menu,{TITLE:ZDBI18NMap.g('zrpt.pivot.condFormat.js.addFormatSettings'),VIEW:view,ADDFRAME:true,NOFOCUS:noFocus,
			MODAL:true,DONTREMOVE:true,CALLOUT:true,SRCEL:el,LRPOS:true,ONCLOSE:function(){return ZACondFormUtil.parseFormatOptions(menu, el);}});
		hideMenuComponent.style.display = "none";
	}
	
	this.showSelectedOptions = function(el)
	{
		var menu = ZDBUtil.getParentWithAttributeValue(el, "elname", "ZAFormatOptions");	//NO I18N
		ZDBUtil.setNamedChildEls(menu, menu);
		var elname = el.getAttribute("elname");
		if(elname == "textHeader" || elname == "textFunctions")
		{
			var slideDown = menu.textHide;
			var slideUp = menu.kpiHide;
		}
		else
		{
			var slideDown = menu.kpiHide;
			var slideUp = menu.textHide;
		}
		
		slideUp = slideUp.getAttribute("disabled") ? null : slideUp;
		slideDown = slideDown.getAttribute("disabled") ? null : slideDown;
		
		if(elname == "textHeader" || elname == "kpiHeader")
		{
			jQuery(slideDown).slideToggle("slow");	//NO I18N
			jQuery(slideUp).slideToggle("slow");	//NO I18N
			this.animateExpandIcon(menu.textExpandIcon);
			this.animateExpandIcon(menu.kpiExpandIcon);
		}
		else if(slideDown && slideDown.style.display == "none")
		{
			jQuery(slideDown).slideDown("slow");	//NO I18N
			var expandIconDown = slideDown == menu.kpiHide ? menu.kpiExpandIcon : menu.textExpandIcon;
			this.animateExpandIcon(expandIconDown, "expanded");	//NO I18N

			jQuery(slideUp).slideUp("slow");	//NO I18N
			var expandIconUp = (expandIconDown == menu.textExpandIcon) ? menu.kpiExpandIcon : menu.textExpandIcon;
			this.animateExpandIcon(expandIconUp, "constricted");	//NO I18N
		}
	}
	
	this.animateExpandIcon = function(el, value)
	{
		el.className = el.className.indexOf("expanded") >= 0 ? el.className.replace("expanded","constricted") : el.className.replace("constricted","expanded");
		if(value)
		{
			el.className = "expandIcon " + value;
		}
	}
	
	this.checkAndSetAddDialog = function(menu, el, restrictAccess)
	{
		menu.style.display = "";
		if(ZDBDialogUtil.focusDialog)
		{
			var computedDialogParams = getComputedStyle(ZDBDialogUtil.focusDialog.params["SRCEL"]);
			if(computedDialogParams.getPropertyValue("font-weight") == "bold" || computedDialogParams.getPropertyValue("font-weight") == "700")
			{
				var setBoldForGrandRow = true;
			}
		}
		
		var addFormats = el.addFormats;
		ZDBUtil.setNamedChildEls(menu, menu);
		var hideComponent = menu.kpiHide;
		if(setBoldForGrandRow)
		{
			addFormats = !addFormats ? {} : addFormats;
			addFormats["textFunc"] = !addFormats["textFunc"] ? {} : addFormats["textFunc"];
		}
		if(!addFormats)
		{
			this.disableKpiOptions(menu);
			return hideComponent;
		}
		var textAlign = addFormats["textAlign"];
		var kpi = addFormats["kpi"];
		var textFunc = addFormats["textFunc"];
		
		if(textAlign)
		{
			this.setSelectedIcon(menu.textAlign, textAlign, "div");	//NO I18N
		}
		
		if(kpi)
		{
			if(!(kpi instanceof Object))
			{
				kpi = JSON.parse(kpi);
			}
			var kpiIcon = kpi["kpiIcon"];
			var iconColor = kpi["iconColor"];
			var iconOption = kpi["iconOption"];
			var iconPlacement = (kpi["iconPlacement"] === "false" || !kpi["iconPlacement"]) ? false : true;	//NO I18N
			iconPlacement = !iconPlacement ? false : true;
			var iconAlign = kpi["iconAlign"];
			
			this.setSelectedKpiIcon(menu, kpiIcon, "div");	//NO I18N
			menu.iconColor.setAttribute("value",iconColor.split("#")[1]);
			menu.iconColor.style.backgroundColor = iconColor;
			this.changeIconColor(menu.iconColor);
			this.setSelectedIcon(menu.iconOption, iconOption, "div");	//NO I18N
			menu.iconPlacement.getElementsByTagName("input")[0].checked = iconPlacement;
			this.setSelectedIcon(menu.iconAlign, iconAlign, "div");	//NO I18N
		}
		else
		{
			this.disableKpiOptions(menu);
		}
		
		if(textFunc)
		{
			if(!(textFunc instanceof Object))
			{
				textFunc = JSON.parse(textFunc);
			}
			var textPrefix = !textFunc["textPrefix"] || textFunc["textPrefix"] == "null" ? null : textFunc["textPrefix"];	//NO I18N
			var textReplacement = !textFunc["textReplacement"] || textFunc["textReplacement"] == "null" ? null : textFunc["textReplacement"];	//NO I18N
			var textSuffix = !textFunc["textSuffix"] || textFunc["textSuffix"] == "null" ? null : textFunc["textSuffix"];	//NO I18N
			var textBold = textFunc["textBold"];
			var textItalic = textFunc["textItalic"];
			
			if((textBold == undefined) && setBoldForGrandRow)
			{
				textBold = true;
			}
			
			menu.textPrefix.value = !textPrefix ? "" : textPrefix;
			menu.textReplacement.value = !textReplacement ? "" : textReplacement;
			menu.textSuffix.value = !textSuffix ? "" : textSuffix;
			menu.textBold.className = textBold == true ? "inlineToggleElSelected" : "inlineToggleEl";
			menu.textItalic.className = textItalic == true ? "inlineToggleElSelected" : "inlineToggleEl";
		}
		
		if(iconOption == this.ICONOPTION_ICON)
		{
			hideComponent = menu.textHide;
			this.animateExpandIcon(menu.textExpandIcon, "constricted");	//NO I18N
			this.animateExpandIcon(menu.kpiExpandIcon, "expanded");	//NO I18N
			this.clearAnimationQueue(menu);
		}
		if(restrictAccess)
		{
			this.deepDisableEl(menu.textFunctions, true, "1");
			this.deepDisableEl(menu.kpiFunctions, true, "1");
		}
		return hideComponent;
	}
	
	this.setSelectedKpiIcon = function(menu, icon, tagName)
	{
		menu.extendedIcons.style.display = "";
		var els = menu.kpiIcons.getElementsByTagName(tagName);
		for(var i=0; i<els.length; i++)
		{
			var iconList = this.getIconList(els[i], menu);
			var iconSet = this.setSelectedIcon(iconList, icon, tagName);
			if(iconSet)
			{
				this.setToggleEl(els[i]);
				return;
			}
		}
	}
	
	this.clearAnimationQueue = function(menu)
	{
		jQuery(menu).find('*').stop(true, true);
	}
	
	this.displaySelectedFunc = function(els, selectedMenu)
	{
		for(var i=1; i<els.length; i++)
		{
			if(els[i] == selectedMenu)
			{
				els[i].style.display = "";
			}
			else
			{
				els[i].style.display = "none";
			}
		}
	}
	
	this.disableKpiOptions = function(menu)
	{
		this.disableEl(menu.iconColor, true);
		jQuery(menu.kpiHide).slideUp("fast", "linear", function(){	//NO I18N
			menu.kpiHide.setAttribute("disabled","true");
			ZACondFormUtil.disableEl(menu.textHeader, true, "1");
			ZACondFormUtil.disableEl(menu.kpiHeader, true, "1");
		});
		ZACondFormUtil.showSelectedOptions(menu.textFunctions);
	}
	
	this.enableAdditionalOptions = function(menu)
	{
		this.enableEl(menu.iconColor);
		this.enableEl(menu.textHeader);
		this.enableEl(menu.kpiHeader);
		menu.kpiHide.removeAttribute("disabled");
	}
	
	this.disableEl = function(el, setDisabledAttr, opacity)
	{
		el.blur();
		opacity = !opacity ? "0.2" : opacity;
		el.style.pointerEvents = "none";	//NO I18N
		el.style.opacity = opacity;
		if(setDisabledAttr)
		{
			el.setAttribute("disabled", true);
		}
	}
	
	this.deepDisableEl = function(el, setDisabled, opacity)
	{
		opacity = !opacity ? "0.2" : opacity;
		jQuery(el).find("*").blur().css({"pointer-events":"none", "opacity":opacity}).off("click").attr("onclick", null).find(":input").attr("disabled",true);
	}
	
	this.deepSetPropertyEl = function(el, propName, propVal)
	{
		jQuery(el).find("*").attr(propName, propVal);
	}
	
	this.deepSetRemoveProp = function(el, propName)
	{
        jQuery(el).find("*").removeAttr(propName);
    }
	
	this.enableEl = function(el)
	{
		el.style.pointerEvents = "auto";	//NO I18N
		el.style.opacity = "1";
		if(el.getAttribute("disabled"))
		{
			el.removeAttribute("disabled");
		}
	}
	
	this.setSelectedIcon = function(menu, value, tagName)
	{
		if(!value)
		{
			return;
		}
		var options = menu.getElementsByTagName(tagName);
		for(var i=0; i<options.length; i++)
		{
			var optVal = options[i].getAttribute("value");
			if(optVal == value)
			{
				this.setToggleEl(options[i]);
				return true;
			}
		}
	}
	
	this.changeIconColor = function(el)
	{
		if(!el)
		{
			return;
		}
		var parEl = ZDBUtil.getParentWithAttributeValue(el, "elname", "kpiFunctions");	//NO I18N
		var newColor = "#" + el.getAttribute("value");
		jQuery(parEl).find(".condFormKpiHeader").css("color",newColor);	//NO I18N
		jQuery(parEl).find(".condFormKpiIcons").css("color",newColor);	//NO I18N
	}
	
	this.checkIfChangedFromDefault = function(srcEl, attrName, attrVal)
	{
		var defaultVal = getComputedStyle(srcEl).getPropertyValue(attrName);
		return !(defaultVal.toLowerCase() == attrVal.toLowerCase());
	}
	
	this.parseFormatOptions = function(dlg, el)
	{
		ZDBUtil.setNamedChildEls(dlg, dlg);
		var textAlign = !dlg.textAlign.getElementsByClassName("inlineToggleElSelected")[0] ? null : dlg.textAlign.getElementsByClassName("inlineToggleElSelected")[0].getAttribute("value");	//NO I18N
		
		var kpiIcons = dlg.kpiIcons;
		var kpiIconSelected = kpiIcons.getElementsByClassName("inlineToggleEl selected")[0];
		kpiIconSelected = !kpiIconSelected ? null : kpiIconSelected.getAttribute("value");
		var iconDisp = !kpiIconSelected ? null : "#" + dlg.iconColor.getAttribute("value");
		var iconOption = dlg.iconOption.getElementsByClassName("inlineToggleElSelected")[0];
		iconOption = !kpiIconSelected ? null : iconOption.getAttribute("value");
		var iconPlacement = !kpiIconSelected ? null : dlg.iconPlacement.getElementsByTagName("input")[0].checked;
		var iconAlign = !kpiIconSelected ? null : dlg.iconAlign.getElementsByClassName("inlineToggleElSelected")[0].getAttribute("value");	//NO I18N
		
		var textPrefix = dlg.textPrefix.value ? dlg.textPrefix.value : null;
		var textReplacement = dlg.textReplacement.value ? dlg.textReplacement.value : null;
		var textSuffix = dlg.textSuffix.value ? dlg.textSuffix.value : null;
		var textBold = dlg.textBold.className == "inlineToggleElSelected" ? true : false;
		var textItalic = dlg.textItalic.className == "inlineToggleElSelected" ? true : false;
		
		var srcEl = ZDBDialogUtil.dialogs[0].params["SRCEL"];
		var boldVal = textBold ? "bold" : "normal";	//NO I18N
		var italicVal = textItalic ? "italic" : "normal";	//NO I18N
		
		var prevAddFormats = el.addFormats;
		var prevTextFunc = prevAddFormats && prevAddFormats["textFunc"] && Object.keys(prevAddFormats["textFunc"]).length > 0 ? prevAddFormats["textFunc"] : null;
		var kpiIcon = null;
		
		var textFunc = {"textPrefix" : textPrefix, "textReplacement" : textReplacement, "textSuffix" : textSuffix, "textBold" : textBold, "textItalic" : textItalic};	//NO I18N
		this.removeNullAttributes(textFunc);
		
		var isTextFuncApplied = ((this.isModified(textFunc, prevTextFunc, ["textPrefix","textReplacement","textSuffix"])) || (prevTextFunc != null && this.isModified(textFunc, prevTextFunc, ["textBold", "textItalic"])) ||	//NO I18N
				this.checkIfChangedFromDefault(srcEl, "font-weight", boldVal) || this.checkIfChangedFromDefault(srcEl, "font-style", italicVal));	//NO I18N
		
		if(kpiIconSelected)
		{
			kpiIcon = {"kpiIcon" : kpiIconSelected, "iconColor" : iconDisp, "iconOption" : iconOption, "iconPlacement" : iconPlacement, "iconAlign" : iconAlign};	//NO I18N
		}
		this.removeNullAttributes(kpiIcon);
		
		if(!isTextFuncApplied)
		{
			textFunc = prevTextFunc;
		}
		
		if(dlg.textFunctions.getAttribute("disabled"))
		{
			textFunc = null;
		}
		
		var additionalFormats = {"textAlign" : textAlign, "kpi" : kpiIcon, "textFunc" : textFunc};	//NO I18N
		this.removeNullAttributes(additionalFormats);
		el.addFormats = additionalFormats;
		return true;
	}
	
	this.removeNullAttributes = function(obj)
	{
		for (var key in obj) 
		{
			if (obj.hasOwnProperty(key) && obj[key] == null) 
			{
				delete obj[key];
			}
		}
	}
	
	this.setToggleFunc = function(toggleEls)
	{
		for(var i=0; i<toggleEls.length; i++)
		{
			var toggleEl = toggleEls[i];
			var childEls = toggleEl.getElementsByTagName("div");
			for(var j=0; j< childEls.length; j++)
			{
				var childEl = childEls[j];
				if(childEl.onclick == null || childEl.onclick == "")
				{
					childEl.onclick = function(){ZACondFormUtil.setToggleEl(this);};
				}
			}
		}
	}
	
	this.setToggleEl = function(el)
	{
		var parEl = ZDBUtil.getParentWithAttributeValue(el, "elname", "ZAFormatOptions");	//NO I18N
		if(el.parentElement.getAttribute("elname")=="kpiIcons" && el.className.indexOf("selected") < 0)
		{
			this.disableAndDisplayAdditionalIcons(el, parEl);
			this.enableAdditionalOptions(parEl);	//NO I18N
			this.setToggleCustomClass(el, parEl, "selected");	//NO I18N
			var iconOption = parEl.iconOption.getElementsByClassName("inlineToggleElSelected")[0];
			if(iconOption.getAttribute("value") == this.ICONOPTION_ICON)
			{
				this.modifyFormatOptionsMenu(parEl, iconOption);	//NO I18N
			}
			el.style.cursor = "pointer";
		}
		else if(el.parentElement.getAttribute("elname")=="kpiIcons" && el.className.indexOf("selected") >= 0)
		{
			this.disableAndDisplayAdditionalIcons(el, parEl);
			this.setToggleCustomClass(el, parEl, "selected");	//NO I18N
			jQuery(parEl.textFunctions).animate({"opacity":"1"}, "fast", function(){	//NO I18N
				ZACondFormUtil.enableEl(parEl.textFunctions);
				ZACondFormUtil.deepSetRemoveProp(parEl.textFunctions, "disabled");	//NO I18N
			});
			this.disableKpiOptions(parEl);	//NO I18N
		}
		else if(el.parentElement.getAttribute("elname")=="iconOption")
		{
			this.modifyFormatOptionsMenu(parEl, el);	//NO I18N
			ZDBAxisProp.setToggleEl(el);
		}
		else if(ZDBUtil.getParentWithAttributeValue(el, "elname", "extendedIcons"))
		{
			this.modifyIconList(el, parEl);
			ZDBAxisProp.setToggleEl(el);
			this.setAdditionalStyles(el, "condFormKpiIcons", "div");	//NO I18N
		}
		else
		{
			ZDBAxisProp.setToggleEl(el);
		}
	}
	
	this.setAdditionalStyles = function(el, className, tagName)
	{
		var els = el.parentElement.getElementsByTagName(tagName);
		for(var i=0; i<els.length; i++)
		{
			els[i].className += " " + className;
		}
	}
	
	this.modifyIconList = function(el, menu)
	{
		var kpiIcon = this.getIcon(el.parentElement, menu);
		var val = el.getAttribute("value");
		var icon = el.innerHTML;
		kpiIcon.setAttribute("value", val);
		kpiIcon.innerHTML = icon;
	}
	
	this.setToggleCustomClass = function(el, menu, className)
	{
		var parEl = el.parentElement;
		className = !className ? "" : className;
		var els = parEl.getElementsByClassName("inlineToggleEl");	//NO I18N
		for(var i=0; i<els.length; i++)
		{
			if(els[i] == el && els[i].className.indexOf(className) < 0)
			{
				var pos = i+1;
				els[i].className += " " + className;
			}
			else
			{
				els[i].className = els[i].className.replace(" " + className, "");
			}
		}
	}
	
	this.getElPosition = function(el)
	{
		var parEl = el.parentElement;
		var els = parEl.getElementsByTagName("div");
		for(var i=0; i<els.length; i++)
		{
			if(els[i] == el)
			{
				return i+1;
			}
		}
	}
	
	this.disableAndDisplayAdditionalIcons = function(el, menu)
	{
		var selectedEl = menu.kpiIcons.getElementsByClassName("inlineToggleEl selected")[0];
		var prevSelectedIcons = this.getIconList(selectedEl, menu);
		var newIcons = this.getIconList(el, menu);
		if(prevSelectedIcons || prevSelectedIcons == newIcons)
		{
			jQuery(prevSelectedIcons).slideUp("fast", "linear", function(){	//NO I18N
				prevSelectedIcons.style.display = "none";
			});
		}
		if(newIcons && !(prevSelectedIcons == newIcons))
		{
			jQuery(newIcons).slideToggle("fast", "linear");	//NO I18N
		}
	}
	
	this.getIcon = function(elList, menu)
	{
		if(!elList)
		{
			return;
		}
		var kpiIcons = menu.kpiIcons.children;
		var iconLists = menu.extendedIcons.children;
		for(var i=0; i<iconLists.length; i++)
		{
			if(iconLists[i] == elList)
			{
				return kpiIcons[i];
			}
		}
	}
	
	this.getIconList = function(el, menu)
	{
		if(!el)
		{
			return;
		}
		var elName = el.getAttribute("elname");
		if(elName == "topArrow")
		{
			return menu.topArrowIcons;
		}
		else if(elName == "downArrow")
		{
			return menu.downArrowIcons;
		}
		else if(elName == "doubleArrow")
		{
			return menu.doubleArrowIcons;
		}
		else if(elName == "bullet")
		{
			return menu.bulletIcons;
		}
		else if(elName == "smiley")
		{
			return menu.smileyIcons;
		}
		else if(elName == "star")
		{
			return menu.starIcons;
		}
		else if(elName == "heart")
		{
			return menu.heartIcons;
		}
	}
	
	this.toggleSelectEl = function(el)
	{
		if(el.className == "inlineToggleElSelected")
		{
			ZDBAxisProp.removeToggleElStyle(el);
		}
		else
		{
			ZDBAxisProp.setToggleEl(el);
		}
	}
	
	this.selectMultipleEl = function(el)
	{
		if(el.className == "inlineToggleElSelected")
		{
			el.className = "inlineToggleEl";
		}
		else
		{
			el.className = "inlineToggleElSelected";
		}
	}
	
	this.modifyFormatOptionsMenu = function(menu, el)
	{
		ZDBUtil.setNamedChildEls(menu, menu);
		var textFunctions = menu.textFunctions;
		var iconAligns = menu.iconAlign.getElementsByTagName("div");
		var iconPlacement = menu.iconPlacement;
		var centerEl = iconAligns[1];
		
		if(el.getAttribute("value")==this.ICONOPTION_VALICON)
		{
			jQuery(textFunctions).animate({"opacity":"1"}, "fast", function(){	//NO I18N
				ZACondFormUtil.enableEl(textFunctions);
				ZACondFormUtil.deepSetRemoveProp(textFunctions, "disabled");	//NO I18N
				ZACondFormUtil.enableEl(menu.textHeader);
				ZACondFormUtil.enableEl(menu.kpiHeader);
				
			});	
			jQuery(iconPlacement).animate({"opacity":"1"},"fast",function(){	//NO I18N
				ZACondFormUtil.enableEl(iconPlacement);
			});
			jQuery(centerEl).animate({"width":"0px"}, "fast", function(){	//NO I18N
				jQuery(centerEl).css({"display":"none"});	//NO I18N
			});
		}
		else
		{
			jQuery(textFunctions).animate({"opacity":"0.2"}, "fast", function(){	//NO I18N
				ZACondFormUtil.disableEl(textFunctions, true);
				ZACondFormUtil.deepSetPropertyEl(textFunctions, "disabled");	//NO I18N
				ZACondFormUtil.disableEl(menu.textHeader, true, "1");
				ZACondFormUtil.disableEl(menu.kpiHeader, true, "1");
			});
			jQuery(iconPlacement).animate({"opacity":"0.2"},"fast",function(){	//NO I18N
				ZACondFormUtil.disableEl(iconPlacement, true); 
			});
			jQuery(centerEl).css({"display":""}).animate({"width":"26px"}, "fast");	//NO I18N
		}
	}
	
	this.validateConditionValue = function(condition, formatVal, checkValidDateOp)
	{
		if((condition != ZACondFormUtil.isBetween && condition != ZACondFormUtil.isNotBetween) && !checkValidDateOp && !ZDBValidator.isDecimal(formatVal, false, false))
	    { 
            return false;
        }
		if((condition != ZACondFormUtil.isBetween && condition != ZACondFormUtil.isNotBetween) && checkValidDateOp && this.nReqdGroup.indexOf(condition) >= 0)
	    { 
            return (!ZDBValidator.isDecimal(formatVal, false, false) ? false : true);
        }
		else if((condition != ZACondFormUtil.isBetween && condition != ZACondFormUtil.isNotBetween) && checkValidDateOp && !((this.yearGroup.indexOf(condition) >=0 || this.monthGroup.indexOf(condition) >= 0 || this.weekGroup.indexOf(condition) >= 0 || this.quarterGroup.indexOf(condition) >= 0 || this.dayGroup.indexOf(condition) >= 0)))
		{
			formatVal = Date.parse(formatVal);
			return (!ZDBValidator.isDecimal(formatVal, false, false) ? false : true);
		}
	    else if((condition == ZACondFormUtil.isBetween || condition == ZACondFormUtil.isNotBetween))
	    {
	    	var formatVals = formatVal.split(",");
	    	formatVals[0] = checkValidDateOp ? Date.parse(formatVals[0]) : formatVals[0];
	    	formatVals[1] = checkValidDateOp ? Date.parse(formatVals[1]) : formatVals[1];
	    	if(formatVals.length != 2)
	    	{
	    		return false;
	    	}
	    	else if(!ZDBValidator.isDecimal(formatVals[0], false, false) || !ZDBValidator.isDecimal(formatVals[1], false, false))
	    	{
	    		return false;
	    	}
	    	else if(parseFloat(formatVals[0]) > parseFloat(formatVals[1]))
	    	{
	    		return false;
	    	}
	    }
		return true;
	}
	
	this.getErrorMessage = function(condition, formatVal, checkValidDateOp)
	{
		var errorMessage = ZDBI18NMap.g('zrpt.pivot.condFormat.js.numberError');
	    
	    if((condition == ZACondFormUtil.isBetween || condition == ZACondFormUtil.isNotBetween))
    	{
    		var formatVals = formatVal.toString().split(",");
    		if(formatVals[0] == "" || formatVals[1] == "")
    		{
    			return ZDBI18NMap.g('zrpt.pivot.condFormat.js.betweenError');
    		}
    		else if(Date.parse(formatVals[0]) > Date.parse(formatVals[1]))
    		{
    			return ZDBI18NMap.g('zrpt.pivot.condFormat.js.greaterError');
    		}
    	}
	    
	    if(checkValidDateOp && this.nReqdGroup.indexOf(condition) < 0)
	    {
	    	errorMessage = ZDBI18NMap.g('zrpt.pivot.condFormat.js.dateError');
	    }
	    
	    return errorMessage;
	}
	
	this.getFormatVal = function(formatVal, condition, checkValidDateOp)
	{
		if(checkValidDateOp && (this.yearGroup.indexOf(condition) >=0 || this.monthGroup.indexOf(condition) >= 0 || this.weekGroup.indexOf(condition) >= 0 || this.quarterGroup.indexOf(condition) >= 0 || this.dayGroup.indexOf(condition) >= 0))
		{
			return formatVal;
		}
		else if(checkValidDateOp && (condition == ZACondFormUtil.isDate || condition == ZACondFormUtil.isNotDate))
		{
			formatVal = this.getFirstAndLastTimeOfDay(formatVal);
		}
		else if(checkValidDateOp && (condition == ZACondFormUtil.isBetween || condition == ZACondFormUtil.isNotBetween))
	    {
	    	formatVal = Date.parse(formatVal.split(",")[0]) + "," + Date.parse(formatVal.split(",")[1]);
	    }
	    else if(checkValidDateOp  && (condition != ZACondFormUtil.isBetween && condition != ZACondFormUtil.isNotBetween))
	    {
	    	formatVal = Date.parse(formatVal);
	    }
		return formatVal;
	}
	
	this.getFirstAndLastTimeOfDay = function(date)
	{
		date = new Date(date);
		var firstTime = date.setHours(0,0,0,0);
		var lastTime = date.setHours(23, 59, 59, 999);
		return firstTime + "," + lastTime;	
	}
	
	this.getFormatDisplayVal = function(formatRuleVal, condition, checkValidDateOp)
	{
		formatRuleVal = formatRuleVal=="NULL" ? "" : formatRuleVal;	//NO I18N
		if(checkValidDateOp && (this.yearGroup.indexOf(condition) >=0 || this.monthGroup.indexOf(condition) >= 0 || this.weekGroup.indexOf(condition) >= 0 || this.quarterGroup.indexOf(condition) >= 0 || this.dayGroup.indexOf(condition) >= 0))
		{
			return formatRuleVal;
		}
		else if(checkValidDateOp && (condition == ZACondFormUtil.isDate || condition == ZACondFormUtil.isNotDate))
		{
			var d = new Date(Number(formatRuleVal.split(",")[0]));
			formatRuleVal = this.getStdDisplayOfDate(d);
		}
		else if(checkValidDateOp && (condition != ZACondFormUtil.isBetween && condition != ZACondFormUtil.isNotBetween))
		{
			var d = new Date(Number(formatRuleVal));
			formatRuleVal = this.getStdDisplayOfDate(d);
		}
		else if(checkValidDateOp && (condition == ZACondFormUtil.isBetween || condition == ZACondFormUtil.isNotBetween))
		{
			var d1 = new Date(Number(formatRuleVal.split(",")[0]));
			var d2 = new Date(Number(formatRuleVal.split(",")[1]));
			formatRuleVal = this.getStdDisplayOfDate(d1) + "," + this.getStdDisplayOfDate(d2);
		}
		return formatRuleVal;
	}
	
	this.isFidModified = function(newCond, oldCond)
	{
		return !(newCond[ZACondFormUtil.COND_FONTCOLOR] == oldCond[ZACondFormUtil.COND_FONTCOLOR] && newCond[ZACondFormUtil.COND_BGCOLOR] == oldCond[ZACondFormUtil.COND_BGCOLOR] && 
		newCond[ZACondFormUtil.COND_TEXTALIGN] == oldCond[ZACondFormUtil.COND_TEXTALIGN]);
	}
	
	this.checkIdReused = function(condRules, id, idPos)
	{
		var occurance = 0;
		for(var i in condRules)
		{
			var condRule = condRules[i];
			for(var j=0; j<condRule.length; j++)
			{
				var cond = condRule[j];
				if(id == cond[idPos])
				{
					occurance++;
				}
				if(occurance > 1)
				{
					return true;
				}
			}
		}
		return false;
	}
	
	this.modifyClassName = function(newCond, oldCond, formatRows, kpiRows, textFuncRows, view)
	{
		var isFidModified = (!formatRows && this.isFidModified(newCond, oldCond)) ? false : true;
		var isKidModified = (!kpiRows && this.isModified(newCond[this.COND_KPI], oldCond[this.COND_KPI])) ? false : true;
		var isTfidModified = (!textFuncRows && this.isModified(newCond[this.COND_TF], oldCond[this.COND_TF])) ? false : true;
		
		if(isFidModified && formatRows && this.isFidModified(newCond, oldCond))
		{
			for(var i=0; i<formatRows.length; i++)
			{
				var formatRow = formatRows[i];
				if(formatRow[this.FORMATROW_FONTCOLOR] == oldCond[this.COND_FONTCOLOR] && formatRow[this.FORMATROW_BGCOLOR] == oldCond[this.COND_BGCOLOR] && formatRow[this.FORMATROW_TEXTALIGN] == oldCond[this.COND_TEXTALIGN])
				{
					isFidModified = true;
					formatRow[this.FORMATROW_FONTCOLOR] = newCond[this.COND_FONTCOLOR];
					formatRow[this.FORMATROW_BGCOLOR] = newCond[this.COND_BGCOLOR];
					formatRow[this.FORMATROW_TEXTALIGN] = newCond[this.COND_TEXTALIGN];
					var fid = formatRow[ZACondFormUtil.FORMATROW_FORMATID];
					
					var checkFidReused = this.checkIdReused(view.condFormat.getCondRules(), fid, this.CONDLIST_FORMATID);
					if(checkFidReused)
					{
						return false;
					}
					
					this.removeUnusedStyle(view.fidStyleTags, fid);
					var className = "FID"+String(fid).replace('@','_'); //NO I18N
					var attrs = this.getFormatRowAttrs(formatRow);
					var style = ZACondFormUtil.addClassName(className, attrs);
					view.fidStyleTags[fid] = style;
					break;
				}
				else
				{
					isFidModified = false;
				}
			}
		}
		
		if(isKidModified && kpiRows && this.isModified(newCond[this.COND_KPI], oldCond[this.COND_KPI]))
		{
			for(var i=0; i<kpiRows.length; i++)
			{
				var kpiRow = kpiRows[i];
				var oldKpiRow = oldCond[this.COND_KPI];
			
				var kpiId = kpiRow["kpiId"];
				delete(kpiRow["kpiId"]);
				if(!this.isModified(kpiRow, oldKpiRow))
				{
					isKidModified = true;
					kpiRow = newCond[this.COND_KPI];
					kpiRows[i] = kpiRow;
					kpiRows[i]["kpiId"] = kpiId;
					
					var checkKidReused = this.checkIdReused(view.condFormat.getCondRules(), kpiId, this.CONDLIST_KPIID);
					if(checkKidReused)
					{
						return false;
					}
					
					this.removeUnusedStyle(view.kidStyleTags, kpiId);
					var className = "KID"+String(kpiId).replace('@','_'); //NO I18N
					var attrs = this.getKpiRowAttrs(kpiRow, className);
					var selectorPos = attrs["selectorPos"];
					delete(attrs["selectorPos"]);
					var style = ZACondFormUtil.addClassName(className+"::"+selectorPos, attrs);
					view.kidStyleTags[kpiId] = style;
					break;
				}
				else
				{
					isKidModified = false;
				}
				kpiRow["kpiId"] = kpiId;
			}
		}
		
		if(isTfidModified && textFuncRows && this.isModified(newCond[this.COND_TF], oldCond[this.COND_TF]))
		{
			for(var i=0; i<textFuncRows.length; i++)
			{
				var tfRow = textFuncRows[i];
				var oldTfRow = oldCond[this.COND_TF];
			
				var tfId = tfRow["tfId"];
				delete(tfRow["tfId"]);
				if(!this.isModified(tfRow, oldTfRow))
				{
					isTfidModified = true;
					tfRow = newCond[this.COND_TF];
					textFuncRows[i] = tfRow;
					textFuncRows[i]["tfId"] = tfId;
					
					var checkTfidReused = this.checkIdReused(view.condFormat.getCondRules(), tfId, this.CONDLIST_TFID);
					if(checkTfidReused)
					{
						return false;
					}
					
					this.removeUnusedStyle(view.tfidStyleTags, tfId);
					var className = "TID"+String(tfId).replace('@','_'); //NO I18N
					var attrs = this.getTextFuncRowAttrs(tfRow);
					var style = ZACondFormUtil.addClassName(className, attrs);
					view.tfidStyleTags[tfId] = style;
					break;
				}
				else
				{
					isTfidModified = false;
				}
				tfRow["tfId"] = tfId;
			}
		}
		
		return (isFidModified && isKidModified && isTfidModified);
	}
	
	this.getFormatRowAttrs = function(formatRow)
	{
		var attrs = {};
		var bgCol = formatRow[ZACondFormUtil.FORMATROW_BGCOLOR];
		var fontCol = formatRow[ZACondFormUtil.FORMATROW_FONTCOLOR];
		var textAlign = formatRow[ZACondFormUtil.FORMATROW_TEXTALIGN];
		attrs["background-color"] = bgCol + (" !important");	//No I18N
		attrs["color"] = fontCol + " !important";	//No I18N
		if(textAlign)
		{
			textAlign = textAlign == ZACondFormUtil.ICONALIGN_LEFT ? ZACondFormUtil.ICONALIGN_LEFTSTR : textAlign == ZACondFormUtil.ICONALIGN_CENTER ? ZACondFormUtil.ICONALIGN_CENTERSTR : ZACondFormUtil.ICONALIGN_RIGHTSTR;	//NO I18N
			attrs["text-align"] = textAlign + " !important";	//NO I18N
		}
		return attrs;
	}
	
	this.getKpiRowAttrs = function(kpiRow, className)
	{
		var attrs = {};
		var kpiIcon = kpiRow["kpiIcon"];
		var iconColor = kpiRow["iconColor"];
		var iconOption = kpiRow["iconOption"];	//formatRows[i][6];
		var iconPlacement = (kpiRow["iconPlacement"] === "false" || !kpiRow["iconPlacement"]) ? false : true;	//NO I18N
		var iconAlign = kpiRow["iconAlign"];
		
		if(kpiIcon && iconOption == ZACondFormUtil.ICONOPTION_ICON && iconAlign == ZACondFormUtil.ICONALIGN_CENTER)
		{
			attrs["text-align"] = "center !important";	//NO I18N
			ZACondFormUtil.addClassName(className, attrs);
		}
		
		if(kpiIcon)
		{
			attrs = {};
			attrs["content"] = '"\\'+kpiIcon+'"';	//NO I18N
			attrs["color"] = iconColor + " !important";	//NO I18N
			var selectorPos = iconAlign == ZACondFormUtil.ICONALIGN_LEFT ? "before" : "after";	//NO I18N
			attrs["selectorPos"] = selectorPos;
			iconAlign = iconAlign == ZACondFormUtil.ICONALIGN_LEFT ? "left" : iconAlign == ZACondFormUtil.ICONALIGN_CENTER ? "center" : "right";	//NO I18N
			attrs["float"]  = iconAlign + " !important";	//NO I18N
			attrs["font-size"] = "15px";	//NO I18N
			if(iconAlign == ZACondFormUtil.ICONALIGN_CENTERSTR || (iconPlacement && iconOption != ZACondFormUtil.ICONOPTION_ICON))
			{
				delete attrs["float"];
			}
			attrs["vertical-align"] = "top";	//NO I18N
			attrs["font-weight"] = "normal !important";	//NO I18N
			attrs["font-style"] = "normal !important";	//NO I18N
		}
		return attrs;
	}
	
	this.getTextFuncRowAttrs = function(tf)
	{
		var attrs = {};
		var bold = tf["textBold"] == true ? "bold !important" : null;	//NO I18N
		var italic = tf["textItalic"] == true ? "italic !important" : null;	//NO I18N
		if(bold != null)
		{
			attrs["font-weight"] = bold;	//NO I18N
		}
		else
		{
			attrs["font-weight"] = "normal !important";	//NO I18N
		}
		if(italic != null)
		{
			attrs["font-style"] = italic;	//NO I18N
		}
		return attrs;
	}
	
	this.removeUnusedFormatStyles = function(styles, rows, rowType)
	{
		var rowIds = [];
		if(styles && rows)
		{
			for(var i=0; i<rows.length; i++)
			{
				if(rowType == this.FORMATROW)
				{
					rowIds.push(rows[i][this.FORMATROW_FORMATID]);
				}
				else
				{
					var idType = rowType == this.KPIROW ? "kpiId" : "tfId"; 	//NO I18N
					rowIds.push(rows[i][idType]);
				}
			}
		}
		if(styles)
		{
			for(var id in styles)
			{
				if(rowIds.indexOf(id) < 0)
				{
					this.removeUnusedStyle(styles, id);
				}
			}
		}
	}
	
	this.removeUnusedStyle = function(styleTags, id)
	{
		if(styleTags && styleTags[id])
		{
			var styleTag = styleTags[id];
			delete(styleTags[id]);
			styleTag.parentElement.removeChild(styleTag);
		}
	}
}

function CondFormDetails(condRules, formatRows, kpiRows, textFuncRows, condFormatRules)
{
	var condRules = !condRules ? null : condRules;
	var formatRows = !formatRows ? null : formatRows;
	var condFormatRules = !condFormatRules ? null : condFormatRules;
	var kpiRows = !kpiRows ? null : kpiRows;
	var textFuncRows = !textFuncRows ? null : textFuncRows;
	
	this.getCondRules = function()
	{
		return condRules;
	}
	
	this.getFormatRows = function()
	{
		return formatRows;
	}

	this.getKpiRows = function()
	{
		return kpiRows;
	}
	
	this.getTextFuncRows = function()
	{
		return textFuncRows;
	}
	
	this.getCondFormatRules = function()
	{
		return condFormatRules;
	}
	
	this.setCondFormatRule = function(condFormatRules)
	{
		if(condFormatRules)
		{
			this.condFormatRules = condFormatRules;
		}
		else
		{
			this.condFormatRules = this.setCondFormatRules();
		}
	}
	
	this.setCondRules = function(condRulesArg)
	{
		this.condRules = condRulesArg;
	}
	
	this.setFormatRows = function(formatRowsArg)
	{
		this.formatRows = formatRowsArg;
	}
	
	this.setCondFormatRules = function()
	{
		var rules = [], k=0;
		if(condRules && formatRows)
		{
			for(var key in condRules)
			{
				var axisDets = ZACondFormUtil.getAxisDetails(key);
				var conditions = condRules[key];
				var condList = [];
				for(var i=0;i<conditions.length;i++)
				{
					var condRule = conditions[i];
					var formatDets = this.getFormatDetails(condRule[ZACondFormUtil.CONDLIST_FORMATID], condRule[ZACondFormUtil.CONDLIST_KPIID], condRule[ZACondFormUtil.CONDLIST_TEXTFUNCID]);
					condList[i] = [condRule[0], condRule[1], formatDets[0], formatDets[1], formatDets[2]["textAlign"], formatDets[2]["kpi"], formatDets[2]["textFunc"]];
				}
				rules[k++] = new CondFormEntity(axisDets[2], axisDets[0], axisDets[1], condList);
			}
		}
		return rules;
	}

	this.populateAll = function(view, id, parentEl)
	{
		ZDBUtil.setNamedChildEls(parentEl, parentEl);
		if(condRules && formatRows.length>0)
		{
			parentEl.ZACondFormatMainTab.style.display = "";
			var menu = id instanceof String ? $(id) : id;
			ZDBUtil.setNamedChildEls(menu, menu);
			menu.condLists.style.display = "none";
			menu.condLists.className = "condFormatRuleTab";
			var rowInst, colInst, dataInst;
			ZDBUtil.removeElementsByClassName(menu.leftContainer, "condFormatRuleTab"); //No I18N
			for(var key in condRules)
			{
				var condRule = condRules[key];
				if(condRule.length == 0)
				{
					continue;
				}
				var subMenu = ZACondFormUtil.addCondRow(null, "condFormatRuleTab", null, menu);	//No I18N
				var axisDets = ZACondFormUtil.getAxisDetails(key);
				ZACondFormUtil.setRuleHeaders(view, subMenu, axisDets, true);
				ZACondFormUtil.modifyHeader(view, subMenu);
				var condListMenu = ZDBUtil.getCloneNode(menu.condLists);
				ZACondFormUtil.pruneSettingsTab(condListMenu);
				condListMenu.setAttribute("key", key);
				menu.condLists.parentElement.appendChild(condListMenu);
				var checkValidDateOp = ZACondFormUtil.checkValidDateOp(axisDets[2], view.currentList);
				this.setCondListInMenu(view, condRule, condListMenu, null, checkValidDateOp);
			}
			ZACondFormUtil.changeTab(menu.getElementsByClassName("condFormatRuleTab")[1]);
		}
		else
		{
			parentEl.ZACondFormatMainTab.style.display = "none";
		}
	}
	
	this.setCondListInMenu = function(view, condLists, subMenu, restrictAccess, checkValidDateOp)
	{
		if(!condLists || condLists.length == 0)
		{
			this.populateCondEl(view, null, subMenu, restrictAccess, checkValidDateOp);
		}
		else
		{
			for(var i=0;i<condLists.length;i++)
			{
				this.populateCondEl(view, condLists[i], subMenu, restrictAccess, checkValidDateOp);
			}
		}
		if(restrictAccess && subMenu.headerTable)
		{
			subMenu.headerTable.style.display = "none";
			subMenu.addCondRow.style.display = "none";
		}
		else if(!restrictAccess  && subMenu.headerTable)
		{
			subMenu.headerTable.style.display = "";
			subMenu.addCondRow.style.display = "";
		}
	}
	
	this.populateCondEl = function(view, condList, menu, restrictAccess, checkValidDateOp)
	{
		menu = ZACondFormUtil.addNewCondition(null, "condFormatRow", null, menu, checkValidDateOp);	//No I18N
		ZDBUtil.setNamedChildEls(menu, menu);
		
		if(condList)
		{
			var condition = menu.condition;
			var condValue = condList[0];
			var formatVal = menu.formatVal;
			var formatRuleVal = condList[1];
			var fontDisp = menu.fontDisp;
			var formatId = condList[2];
			
			var formatDets = this.getFormatDetails(formatId, condList[3], condList[4]);
			
			var fontRuleDisp = formatDets[0];
			var bgDisp = menu.bgDisp;
			var bgRuleDisp = formatDets[1];
			var addFormats = formatDets[2];
			if(addFormats)
			{
				menu.addFormats.addFormats = addFormats;
			}
			
			var options = condition.getElementsByTagName("option");
			for(i in options)
			{
				if(options[i].value==condValue)
				{
					options[i].selected = true;
				}
			}
			formatRuleVal = ZACondFormUtil.getFormatDisplayVal(formatRuleVal, condValue, checkValidDateOp);
			if(condValue == ZACondFormUtil.isBetween || condValue == ZACondFormUtil.isNotBetween)
			{
				ZACondFormUtil.enableDisableFormatEl(menu, false);
				menu.btwFrom.value = formatRuleVal.split(",")[0];
				menu.btwTo.value = formatRuleVal.split(",")[1];
			}
			else
			{
				ZACondFormUtil.enableDisableFormatEl(menu, true);
				formatVal.value = formatRuleVal;
			}
			
			ZACondFormUtil.checkIfNull(condition, true, checkValidDateOp);
			ZACondFormUtil.getAndSetPlaceholderAndTitle(condition, formatVal);
			
			fontDisp.style.color = fontRuleDisp;
			fontDisp.setAttribute("value",fontRuleDisp.split("#")[1]);
			bgDisp.style.backgroundColor = bgRuleDisp;
			bgDisp.setAttribute("value",bgRuleDisp.split("#")[1]);
			
			if(restrictAccess)
			{
				ZACondFormUtil.disableCondition(menu, true);
			}
			else
			{
				ZACondFormUtil.disableCondition(menu, false);
			}
		}
	}
	
	this.getFormatDetails = function(formatId, kpiId, textFuncId)
	{
		if(!formatRows)
		{
			return;
		}
		for(i in formatRows)
		{
			if(formatRows[i][ZACondFormUtil.FORMATROW_FORMATID]==formatId)
			{
				var fontCol = formatRows[i][ZACondFormUtil.FORMATROW_FONTCOLOR];
				var bgCol = formatRows[i][ZACondFormUtil.FORMATROW_BGCOLOR];
				var textAlign = formatRows[i][ZACondFormUtil.FORMATROW_TEXTALIGN];
				break;
			}
		}
		
		if(kpiRows && kpiId)
		{
			for(i in kpiRows)
			{
				if(!(kpiRows[i] instanceof Object))
				{
					kpiRows[i] = JSON.parse(kpiRows[i]);
				}
				if(kpiRows[i]["kpiId"] == kpiId)
				{
					if(kpiRows[i]["iconColor"] && kpiRows[i]["iconColor"].indexOf("#") < 0)
					{
						kpiRows[i]["iconColor"] = "#" + kpiRows[i]["iconColor"];
					}
					var kpi = jQuery.extend(true, {}, kpiRows[i]);
					delete kpi["kpiId"];
					break;
				}
			}
		}
		
		if(textFuncRows && textFuncId)
		{
			for(i in textFuncRows)
			{
				if(!(textFuncRows[i] instanceof Object))
				{
					textFuncRows[i] = JSON.parse(textFuncRows[i]);
				}
				if(textFuncRows[i]["tfId"] == textFuncId)
				{
					var tfRow = jQuery.extend(true, {}, textFuncRows[i]);
					delete tfRow["tfId"];
					break;
				}
			}
		}
		
		var addFormats = {"textAlign": textAlign, "kpi": kpi, "textFunc" : tfRow};	//NO I18N
		ZACondFormUtil.removeNullAttributes(addFormats);
		return new Array(fontCol, bgCol, addFormats);
	}
	
	this.isCondFormatModified = function(view, menu, ctxMenu)
	{
		menu = !menu ? $("ZACFMenu") : menu;
		var condFormMenu = menu.getElementsByClassName("condFormatRuleTab");	//NO I18N
		var oldCondRules = !condFormatRules ? this.setCondFormatRules() : condFormatRules;
	    var newCondRules = ZACondFormUtil.getCondFormatData(condFormMenu, view);
	    var condRuleLength = Object.keys(newCondRules).length;
	    
	    if(!newCondRules)
	    {
	    	return ZDBConst.CLEAR;	//Stop execution as Validation Failed
	    }
	    
	    if(ctxMenu)
	    {
	    	for(var i=0; i<condRuleLength; i++)
	    	{
	    		newCondRules = ZACondFormUtil.appendRules(oldCondRules, newCondRules[i]); 
	    	}
	    }
	    
	    var isCondFormModified = newCondRules.length != oldCondRules.length ? true : false;
	    for(var i=0;i<newCondRules.length; i++)
		{
	    	if(isCondFormModified)
	    	{
	    		break;
	    	}
	    	else if(!ZACondFormUtil.isModified(newCondRules[i].getCondFormats(), oldCondRules[i].getCondFormats()) && newCondRules[i].getCondList().length == oldCondRules[i].getCondList().length)
	    	{	
	    		var newConditions = newCondRules[i].getCondList();
	    		var oldConditions = oldCondRules[i].getCondList();
	    		for(var j=0; j< newConditions.length; j++)
    			{
	    			if(isCondFormModified)
		    		{
		    			break;
		    		}
	    			var newCond = newConditions[j];
	    			var oldCond = oldConditions[j];
	    			if(!ZACondFormUtil.isModified(newCond, oldCond))
	    			{
	    				isCondFormModified = false;
	    			}
	    			else if(newCond[ZACondFormUtil.COND_COND] == oldCond[ZACondFormUtil.COND_COND] && newCond[ZACondFormUtil.COND_VAL] == oldCond[ZACondFormUtil.COND_VAL] && 
	    					!ZACondFormUtil.isModified(newCond[ZACondFormUtil.COND_TF],oldCond[ZACondFormUtil.COND_TF], ["textPrefix", "textReplacement", "textSuffix"]) &&
	    					!ZACondFormUtil.isModified(newCond[ZACondFormUtil.COND_KPI], oldCond[ZACondFormUtil.COND_KPI], ["iconOption"]))
	    			{
	    					var isSetModified = ZACondFormUtil.modifyClassName(newCond, oldCond, formatRows, kpiRows, textFuncRows, view);
		    				isCondFormModified = isSetModified ? false : true;
	    			}
	    			else
	    			{
	    				isCondFormModified = true;
	    			}
    			}
	    	}
	    	else
	    	{
	    		isCondFormModified = true;
	    	}
		}
	    if(!isCondFormModified && isSetModified)
	    {
	    	isCondFormModified = 2;
	    }
	    if(isCondFormModified)
	    {
	    	if(!view.condFormat)
	    	{
	    		view.condFormat = new CondFormDetails(null, null, null, null, newCondRules);
	    	}
	    	else
	    	{
	    		view.condFormat.setCondFormatRule(newCondRules);
	    	}	
	    	newCondRules = isCondFormModified == 2 ? null : newCondRules;
	    }
	    return isCondFormModified;
	}
	
	this.setCname = function(view)
	{
		ZACondFormUtil.removeUnusedFormatStyles(view.fidStyleTags, formatRows, ZACondFormUtil.FORMATROW);
		if(formatRows)
		{
			view.fidStyleTags = !view.fidStyleTags ? {} : view.fidStyleTags;
			for(var i=0;i<formatRows.length; i++)
			{
				var className = "FID"+String(formatRows[i][ZACondFormUtil.FORMATROW_FORMATID]).replace('@','_'); //NO I18N
				if(formatRows[i][ZACondFormUtil.FORMATROW_FORMATID] in view.fidStyleTags)
				{
					continue;
				}
				var attrs = ZACondFormUtil.getFormatRowAttrs(formatRows[i]);
				var style =ZACondFormUtil.addClassName(className, attrs);
				view.fidStyleTags[formatRows[i][ZACondFormUtil.FORMATROW_FORMATID]] = style;
				
				attrs = {};
				attrs["-webkit-filter"] = "contrast(75%)";	//No I18N
				attrs["filter"] = "contrast(75%)";	//No I18N
				ZACondFormUtil.addClassName(className+".zdbMouseOver", attrs);	//No I18N
				
			}
		}
		
		ZACondFormUtil.removeUnusedFormatStyles(view.kidStyleTags, kpiRows, ZACondFormUtil.KPIROW);
		if(kpiRows)
		{
			view.kidStyleTags = !view.kidStyleTags ? {} : view.kidStyleTags;
			for(var i=0; i<kpiRows.length; i++)
			{
				var className = "KID"+String(kpiRows[i]["kpiId"]).replace('@','_'); //NO I18N
				if(kpiRows[i]["kpiId"] in view.kidStyleTags)//.indexOf() > -1)
				{
					continue;
				}
				var attrs = ZACondFormUtil.getKpiRowAttrs(kpiRows[i], className);
				var selectorPos = attrs["selectorPos"];
				delete(attrs["selectorPos"]);
				var style = ZACondFormUtil.addClassName(className+"::"+selectorPos, attrs);
				view.kidStyleTags[kpiRows[i]["kpiId"]] = style;
			}
		}
		
		ZACondFormUtil.removeUnusedFormatStyles(view.tfidStyleTags, textFuncRows, ZACondFormUtil.TEXTFUNCROW);
		if(textFuncRows)
		{
			view.tfidStyleTags = !view.tfidStyleTags ? {} : view.tfidStyleTags;
			for(var i=0; i<textFuncRows.length; i++)
			{
				var tf = textFuncRows[i];
				var className = "TID"+String(tf["tfId"]).replace('@','_'); //NO I18N
				if(tf["tfId"] in view.tfidStyleTags)
				{
					continue;
				}
				attrs = ZACondFormUtil.getTextFuncRowAttrs(tf);
				var style = ZACondFormUtil.addClassName(className, attrs);	//NO I18N
				view.tfidStyleTags[tf["tfId"]] = style;
			}
		}
		
		
	}
	
	this.addNewRule = function(el, className, addOn, view)
	{
		view = view==null ? ZDBClientUI.getViewObj(el, "view") : view;	//No I18N
		var menu = ZACondFormUtil.addCondRow(el, className, addOn);
		this.populateCondEl(view, null, menu);
		ZACondFormUtil.setRuleHeaders(view, menu);	
	}
	
	this.setCondFormMenu = function(menu, view, idx, editHeader)
	{
		ZDBUtil.removeElementsByClassName(menu.condLists, "condFormatRow"); //No I18N
		var subMenu = ZACondFormUtil.addCondRow(null, "condFormatRuleTab", null, menu, view, true);	//No I18N
		ZDBUtil.setNamedChildEls(subMenu, subMenu);
		var restrictAccess = false;
		if(view.viewCtx.isStandAlone() || !view.permissions.designModify)
		{
			restrictAccess = true;
		}
		else
		{
			ZACondFormUtil.setRuleHeaders(view, subMenu, idx, editHeader);
		}
		var condLists = condRules[JSON.stringify(idx)];
		var checkValidDateOp = ZACondFormUtil.checkValidDateOp(idx[2], view.currentList);
		this.setCondListInMenu(view, condLists, subMenu, restrictAccess, checkValidDateOp);
		ZACondFormUtil.clearAnimationQueue(menu);
	}
}

function CondFormEntity(dataVal, rowVal, colVal, condList)
{

	if(dataVal instanceof CondFormEntity)
	{
		var allData = dataVal.getAllVals();
		dataVal = allData[0];
		rowVal = allData[1];
		colVal = allData[2];
		condList = allData[3];
	}
	
	var dataVal = dataVal;
	var rowVal = rowVal;
	var colVal = colVal;
	var condList = condList;
	
	this.getCondFormats = function()
	{
		return [dataVal, rowVal, colVal];
	}
	
	this.getCondList = function()
	{
		return condList;
	}
	
	this.setCondList = function(condListNew)
	{
		condList = condListNew;
	}
	
	this.getAllVals = function()
	{
		return [dataVal, rowVal, colVal, condList];
	}
}