//$Id$  
  
var RDBPage = new function()
{
	this.selectedTablesArray = [];
	this.totTables = 0;
	this.selectedTables = 0;
	this.matchedCount = 0;
	this.matchedTablesSelectedCont = 0;
	this.mismatch = false;
	this.serviceNameMap = {"0":"Amazon RDS", "1":ZDBI18NMap.g("zrpt.rdb.js.redshift"),"2":"Microsoft Azure SQL"};
	this.serviceNameDBTypeMap = {"1":"3", "2":"1"};
	this.dbTypeMap = {"0":"MYSQL", "1":"SQLSERVER", "2":"ORACLE", "3":"POSTGRESQL", "4":"AURORA", "5":"MARIADB"};
	this.defaultValMap = {"Amazon Redshift":{"PORT":"5439","HOST":ZDBI18NMap.g("zrpt.databasedata.connname.js.endpoint")}};	//No I18N
	this.dispNameMap = {"1":"Redshift","2":"Azure"};
	this.RDB_TABLE_NOT_EXISTS = 0;
    this.RDB_COL_NOT_EXISTS = 1;
    this.RDB_COL_TYPE_ERR = 2;
    this.RDB_COL_REF_ADD = 3;
    this.RDB_COL_REF_DEL = 4;
    this.RDB_COL_REF_CHANGE = 5;
    this.RDB_COL_ADD = 6;
	this.mismatchDescText = {0:ZDBI18NMap.g("zrpt.rdb.js.tabledelerr"),
							 1:ZDBI18NMap.g("zrpt.rdb.js.coldelerr"),
							 2:ZDBI18NMap.g("zrpt.rdb.js.coltypeerr"),
							 3:ZDBI18NMap.g("zrpt.rdb.js.colreferr"),
							 4:ZDBI18NMap.g("zrpt.rdb.js.colrefadd"),
							 5:ZDBI18NMap.g("zrpt.rdb.js.colrefdel")};
	this.datatypeIconClass = {"1":"plainIcon", //No I18N
						        "2":"multilineIcon", //No I18N
						        "3":"mailIcon",  //No I18N
						        "4":"numberIcon", //No I18N
						        "5":"positiveIcon",  //No I18N
						        "6":"decimalIcon", //No I18N
						        "7":"currencyIcon", //No I18N
						        "8":"percentageIcon",  //No I18N
						        "9":"dateIcon", //No I18N
						        "10":"booleanIcon", //No I18N
						        "18":"autoNumberIcon", //No I18N
						        "19":"urlIcon"};  //No I18N
	this.jdbc_map = {"-5":"4",
						"16":"10",
						"1":"1",
						"12":"1",
						"-1":"2",
						"91":"9",
						"8":"6",
						"-7":"10",
    					"3":"6",
						"6":"6",
						"4":"4",
    					"2":"6",
						"7":"6",
    					"93":"9",
    					"92":"1",
						"-6":"10",
						"5":"4",
    					"-2":"1",
						"-3":"1",
						"-4":"1",
						"0":"4"};
	this.remapColList = [];
	this.zcollist = [];
	this.COL_REMAP = 0;
	this.COL_DATATYPE = 1;
	this.COL_DEL = 2;
	this.COL_ADD = 3;
	this.COL_CONVERT_REF = 4;
	this.COL_REF_DEL = 5;
	this.COL_REF_MOD = 6;
	
	this.getDBTypeForService = function(serviceName)
	{
		var dbType = RDBPage.serviceNameDBTypeMap[serviceName];
		if(dbType == null)
		{
			dbType = $("DBTYPE").value;
		}
		return dbType;
	}
	
	this.showCreateRDB = function(element)
	{
	  var lzName = element.getAttribute("lzName");
	  var lzOper = (element.getAttribute("lzOper")) ? element.getAttribute("lzOper") : "APPENDTODOC"; //No I18N
	  var lzJs = element.getAttribute("lzJs");
	  if(!ZDBLazyLoadUtil.loadSnippet(lzName,"/ZRCloudDB.cc",this,lzOper))
	  {
		return;
	  }
	  var fromExp = element.getAttribute("fromExplorer");
	  RDBPage.showCreateRDBDlg(fromExp);
	}
	this.showCreateRDBDlg = function(fromExp)
	{
	  var checkROMode = ZDBClientUI.readOnlyMode;
	  if(checkROMode)
	  {
	  	ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.javaerr.common.js.ro_mode"));
	  	return;
	  }
	  
	  var rdbDlg = ZDBClientUI.$("ZRCloudDBDialog");
	  if(fromExp)
	  {
		var url = "/RDBAction.ma?";		//No I18N
		var rdbView = ZDBClientUI.dbConfig.rdbView;
		var params = "&ZDBACTION=GETCONNECTIONDETAILS&DBID=" + rdbView.dbId;	//No I18N
		AjaxAPI.sendRequest({URL:url,PARAMETERS:params,METHOD:"GET",
			ONSUCCESSFUNC:RDBPage.showCreateRDBDlgFromExp,
			ONFAILUREFUNC:RDBPage.handlegetDatabasesFailure});
	  }
	  else
	  {
		ZDBFullPageDialog.showDialog(rdbDlg,{MODAL:true}); 
		$("ZRRDBTitleBar").style.display = "block";
		$("ZRRDBInlineDlgBar").style.display = "none";
		$("ZRRDBTitle").innerHTML = ZDBI18NMap.f("zrpt.home.import.step1.js.createdbremote",RDBPage.curStep);
		CloudDBPage.enableOptForStep();     
	  }
	     
	}
	
	this.showCreateRDBDlgFromExp = function(response,requestOptions)
	{
		RDBPage.enableDisableOptsForExp();
		RDBPage.setConnDetails(response,requestOptions);
		RDBPage.getDatabases(true);
	}
	
	this.enableDisableOptsForExp = function()
	{
		var rdbDlg = ZDBClientUI.$("ZRCloudDBDialog");
		ZDBInlineDialog.showDialog(rdbDlg,{MODAL:true,TITLE:ZDBI18NMap.g("zrpt.home.import.step2.js.remotedb")});
		$("ZRCloudDBInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.home.import.step2.js.remotedb");
		$("ZRCloudDBInlineTitleStep").style.display="inline-block";
		$("ZRCloudBTitleBar").style.display = "none";
		$("ZRCloudDBInlineDesc").style.display = "none";
		$("SERVICENAME").disabled = true;
		$("DBTypeDiv").style.display = "none";
		$("SchSettings").style.display = "none";
		$("PreviewGrid").style.display = "none";
		$("OnImpError").style.display = "none";
		$("ZRCloudDBPrevBtn").style.display = "none";
		$("ZRCloudDBCreateBtn").style.display = "none";
		$("ZRCloudDBImportBtn").style.display = "none";
		$("ZRRDBCreateBtn").style.display = "none";
		$("ZRCloudDBCmpltOk").style.display = "none";
		ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 2, "stepNo");
		ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
		$("ZRCloudDBNextBtn").className='buttonCompBoxBg';
		CloudDBPage.enableOptForStep();
	}
	
	this.updateLabelsNDefVals = function()
	{
		var rdbFrm = ZDBUtil.getCachedRef(ZRRDBForm, "ZRRDBForm");
		ZDBUtil.setNamedChildEls(rdbFrm,rdbFrm,"name");
		var servicename = rdbFrm.SERVICENAME.value;
		var dbtypeStr = RDBPage.getDBTypeForService(servicename);
		var defaultVal =  RDBPage.defaultValMap[dbtypeStr];
		rdbFrm.PORT.value = (rdbFrm.PORT.value != '') ? rdbFrm.PORT.value : defaultVal.PORT;
		rdbFrm.HOST_Label.innerHTML = defaultVal.HOST;
	}
	
	this.gotoPrevStep = function()
	{
	  CloudDBPage.enableOptForStep();
	}
	
	this.gotoNextStep = function()
	{
	  RDBPage.getDatabases();
	}
	
	this.submitRDBForm = function(frm)
	{
		frm = (frm) ? frm : $("CloudDBImport");
		frm.TABLEARRAY.value = RDBPage.selectedTablesArray.toString();
		if(RDBPage.selectedTablesArray.length < 1)
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.databasedata.js.selecttbl"),null,null);
			return false;
		}
		$("ZRRDBCreateBtn").onclick = "";
		var inlineDiv = ZDBUtil.getParentWithAttr(frm,"inlinediv");
		var fromExp = (inlineDiv) ? true : false;
		
		var rdbSelected = document.getElementById("rdbComboSelected");
		var serviceName = $("SERVICENAME").value;
		var dbtype = RDBPage.getDBTypeForService(serviceName);
		if(fromExp)
		{
			ZDBClientUI.dbConfig.rdbView.rdbName = ZDBEscapeUtil.decodeForHtml(rdbSelected.innerHTML);
		}
		url = (fromExp) ? "/RDBAction.ma?" : "/ZDBDatabaseActionMI.ma?";	//No I18N
		var params = (fromExp) ? "ZDBACTION=CREATEREMOTETABLEWITHKEYS&DBID="+ZDBClientUI.dbId+	//No I18N
			"&EDITCONNANDCREATE=true&CONNECTIONID=" + ZDBClientUI.dbConfig.rdbView.connId :	//No I18N
				"ZDBACTION=CREATEREMOTECONNECTION";		//No I18N
		params += "&TABLEARRAY="+encodeURIComponent(frm.TABLEARRAY.value)+"&RDBNAME="+encodeURIComponent(ZDBEscapeUtil.decodeForHtml(rdbSelected.innerHTML))+ //No I18N
			"&HOST="+encodeURIComponent($("HOST").value)+"&PORT="+$("PORT").value+	//No I18N
			"&USERNAME="+encodeURIComponent($("USERNAME").value)+"&PASSWORD="+encodeURIComponent($("PASSWORD").value)+	//No I18N
			"&SERVICENAME="+serviceName+"&DBTYPE="+dbtype+"&USESSL=" + $("USESSL").checked;	//No I18N
		AjaxAPI.sendRequest({URL:url,PARAMETERS:params,FROMEXP:fromExp,
			ONSUCCESSFUNC:RDBPage.handleCreateRDBSuccess,
			ONFAILUREFUNC:RDBPage.handleCreateRDBFailure,
			OPSTATUSID:$("ZDBCREATEDBOPTSTATUS")});
	}
	
	this.handleCreateRDBSuccess = function(response,requestOptions)
    {
		
		var fromExp = requestOptions["FROMEXP"];
		var params = response.getResponseParams();
		ZDBUtil.setAttribute($("ZRRDBCreateBtn"), 'RDBPage.submitRDBForm(this.form)', 'onclick');
		if(fromExp)
		{
			ZDBInlineDialog.closeDialog();
		}
		else
		{
			ZDBFullPageDialog.closeDialog();
		}
		RDBPage.showExplorer(params,fromExp);
//		var params = response.getResponseParams();
//		
//		var imp_report = ZDBUtil.getCachedRef(RDBPage,"zrrdbimpreport");
//		imp_report.style.display = "";
//		var importSummaryDiv = document.createElement("div");
//		importSummaryDiv.setAttribute("id","importSummaryDiv");
//		importSummaryDiv.setAttribute("name","importSummaryDiv");
//		importSummaryDiv.innerHTML = imp_report.innerHTML;
//		importSummaryDiv.style.display = "";
//		
//		if(fromExp)
//		{
//		  ZDBInlineDialog.closeDialog();
//		  RDBPage.showExplorer();
//		  ZDBInlineDialog.showDialog(importSummaryDiv,{MODAL:true, DONTREMOVE:false,ONCLOSE:RDBPage.showExplorer, FROMEXP:true,REQPARAMS:response.getResponseParams()});
//		  $("zrrdbimpreport_title").className = "";
//		  $("zrdbreportdbname_tr").style.display = "none";
//		}
//		else
//		{
//		  ZDBFullPageDialog.closeDialog();
//		  ZDBFullPageDialog.showDialog(importSummaryDiv,{MODAL:true, DONTREMOVE:false,ONCLOSE:RDBPage.showExplorer, FROMEXP:false, REQPARAMS:response.getResponseParams()});
//		  $("zrrdbimpreport_title").className = "dlgTitleBar";
//		  $("zrdbreportdbname_tr").style.display = "";
//		  var zdbName = ZDBEscapeUtil.encodeForHtml(params["ZDBNAME"]);
//		  $("RDB_IM_DBNAME").innerHTML = zdbName;
//		}
//		var rdbView = (fromExp) ? ZDBClientUI.dbConfig.rdbView : null;
//		var rdbName = (fromExp) ? rdbView.rdbName : ZDBEscapeUtil.encodeForHtml(params["RDBNAME"]);
//		
//		var dbType = (fromExp) ? ZDBEscapeUtil.encodeForHtml(RDBPage.dbTypeMap[rdbView.dbType.toString()]) : ZDBEscapeUtil.encodeForHtml(RDBPage.dbTypeMap[params["DBTYPE"].toString()]);
//		var tablesCount = (fromExp) ? JSON.parse(response.responseText).length : JSON.parse(params["TABLES"]).length;
//		
//		$("zrdbreportdbtype").innerHTML = dbType;
//		$("zrdbreportdbname").innerHTML = zdbName;
//		$("zrdbtablecount").innerHTML = tablesCount;
		
    }
	
	this.showExplorer = function(params,fromExp)
	{
		if(fromExp)
		{
			jQuery(ZDBNavigation.rdbLinkTablesOpt).hide();
			ZDBNavigation.refreshExplorer();
		}
		else
		{
			ZDBCreateDB.changeWindowURL(params["DBID"]);
		}
	}
	
	this.handleCreateRDBFailure = function(response,requestOptions)
	{
		var errCode = response.getResponsePart("ERRORCODE");
	    var errMsg = response.getResponsePart("STATUS_MESSAGE");
	    errCode = trimAll(errCode);
		ZDBAlertAPI.showErrorMsg(errMsg,null,errCode);
		ZDBUtil.setAttribute($("ZRRDBCreateBtn"), 'RDBPage.submitRDBForm(this.form)', 'onclick');
	}
	
	this.setConnDetails = function(response,requestOptions)
	{
		var respObj=JSON.parse(response.responseText);
		$("SERVICENAME").value = respObj.servicename;
		$("HOST").value = respObj.host;
		$("PORT").value = respObj.port;
		$("USERNAME").value = respObj.username;
		$("PASSWORD").value = respObj.password;
		$("CONN_CloudDBNAME").value = respObj.dbname;
                $("USESSL").checked = respObj.useSSL;
		ZDBClientUI.dbConfig.rdbView.rdbName = respObj.dbname;
	}
	
	this.getDatabases =function(fromExp)
	{
		var host= $("HOST").value;
		var port= $("PORT").value;
		var username= $("USERNAME").value;
		var password= $("PASSWORD").value;
		var serviceName= $("SERVICENAME").value;
		var dbtype = RDBPage.getDBTypeForService(serviceName);
		var dbname = $("CONN_CloudDBNAME").value;
                var useSSL = $("USESSL").checked;
		var url = "/RDBAction.ma?";	//No I18N
		var params = "HOST=" + encodeURIComponent(host) + "&PORT=" + port + "&USERNAME=" + encodeURIComponent(username) + "&PASSWORD=" + encodeURIComponent(password)+ 	//No I18N
		"&SERVICENAME=" +serviceName + "&DBTYPE=" + dbtype+"&USESSL=" + useSSL+ "&ZDBACTION=GETDATABASES";		//No I18N
		url += (dbname != '') ? ("&RDBNAME=" + encodeURIComponent(dbname)) : "";	//No I18N
		var loadingDiv = (fromExp) ? $("ZRRDBTablesOverlay") : $("ZDBCREATEDBOPTSTATUS");
		if(host!='' && username!='' && port!='' && password!='')
		{
			AjaxAPI.sendRequest({URL:url,PARAMETERS:params,METHOD:"POST", FROMEXP:fromExp,
	              ONSUCCESSFUNC:RDBPage.handlegetDatabasesSuccess,
	              ONFAILUREFUNC:RDBPage.handlegetDatabasesFailure,
	              OPSTATUSID:loadingDiv});
		}
	}
	 this.handlegetDatabasesSuccess=function(response,requestOptions)
	  {
		 var result=JSON.parse(response.responseText);
		 var connecteddb = result.connecteddb;
		 var dblist = result.dblist;
		 RDBPage.dblist = dblist;
//		 if(requestOptions["FROMEXP"])
//		 {
//			 RDBPage.enableDisableOptsForExp();
//		 }
		 if(dblist.length <= 0)
		 {
			 ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.databasedata.connname.js.nodbs"));
			 return;
		 }
		 else
		 {
			 var rdbSelected = document.getElementById("rdbComboSelected");
			 rdbSelected.innerHTML = connecteddb;
			 $("seldbname").innerHTML = ZDBI18NMap.f("zrpt.databasedata.connname.js.rdbname",RDBPage.dispNameMap[$("SERVICENAME").value]);
			 var rdbOptionsList = $("rdbOptionList");
			 ZDBUtil.setNamedChildEls(rdbOptionsList,rdbOptionsList,"elname");
			 var listElement = rdbOptionsList.listElement;
			 var mainList = rdbOptionsList.mainList;
			 jQuery(mainList).children().not(':first').remove();	//No I18N
			 RDBPage.curList = rdbOptionsList;
			 for(var i=0; i < dblist.length; i++)
			 {
			   var liEl = $(listElement).cloneNode(true);
			   ZDBUtil.setAttribute(liEl,"","elname");
			   ZDBUtil.setAttribute(liEl,dblist[i],"value");
			   liEl.innerHTML = dblist[i];
			   ZDBUtil.setAttribute(liEl,dblist[i],"tip");
			   if(connecteddb == dblist[i])
			   {
				   var origClass = ZDBUtil.getAttribute(liEl,"origClass");
				   newClass = origClass + "Selected";	//No I18N
				   liEl.className = newClass;
				   ZDBUtil.setAttribute(liEl,newClass,"origClass");
				   RDBPage.curList.selectedEl = liEl;
			   }
			   else
			   {
				   var origClass = ZDBUtil.getAttribute(liEl,"origClass");
				   newClass = origClass.replace("Selected","");
				   liEl.className = newClass;
				   ZDBUtil.setAttribute(liEl,newClass,"origClass");
			   }
			   liEl.style.display = "block";
			   mainList.appendChild(liEl);
			 }
			 listElement.style.display = "none";
			 CloudDBPage.enableOptForStep();
			 RDBPage.loadTables(connecteddb);
		 }
	  }
	 
	  this.showTip = function(el, event)
	  {
		  if(el.offsetWidth < el.scrollWidth)
		  {
			  ZDBToolTip.show(el, event);
			  ZDBUtil.setAttribute(el,true,"tipshown");
		  }
	  }
	  
	  this.hideTip = function(el, event)
	  {
		  if(ZDBUtil.getAttribute(el,"tipshown"))
		  {
			  ZDBToolTip.hide(el, event);
		  }
	  }

	  this.showDatabaseList = function(el,event)
	  {
		var rdbOptionsList = $("rdbOptionList");
//		if(rdbOptionsList.style.display == "block")
//		{
//			return;
//		}
		ZDBUtil.attachEvent(RDBPage.curList,'mouseover',RDBPage.highlightSelected,true);
	    ZDBUtil.attachEvent(document,'click',RDBPage.closeList,true);
	    ZDBUtil.attachEvent(document,'keydown',RDBPage.checkKeyNContinue,true);
	    ZDBUtil.stopEventBubble(event);
		rdbOptionsList.style.visibility = "visible";
		rdbOptionsList.style.display = "block";
		var searchDiv = DOMUtils.getChildElsWithAttr(rdbOptionsList, "rdbSearch", "true")[0]; //NO I18N
        searchDiv.style.display=(RDBPage.dblist.length > 15) ? "" : "none";
		if(!ZDBUtil.getAttribute(el,"positionset"))
		{
			el.appendChild(rdbOptionsList);
			RDBPage.positionDBList(el);
		}
	  }
	  
	  this.positionDBList = function(el)
	  {
		if(ZDBUtil.getAttribute(el,"positionset"))
		{
			return;
		}
		var rdbOptionsList = $("rdbOptionList");
        var optionDiv = rdbOptionsList.optionDiv;
        ZDBUtil.setNamedChildEls(optionDiv,optionDiv,"elname");
        var maxDivHgt = (window.innerHeight)*0.40;//viewArea.offsetHeight * 0.40;
        optionDiv.style.display="";
        optionDiv.style.height = "";
        var divHgt = ZDBClientUtil.getInnerHeight(optionDiv.selectListEl);//optList.offsetHeight;
        var maxHgtOptList = parseInt(optionDiv.getAttribute("maxHgt"), 10);
        maxDivHgt = (maxHgtOptList>maxDivHgt)?maxDivHgt:maxHgtOptList;
//        if((optionDiv.offsetWidth-10 < rdbOptionsList.offsetWidth))
//        {
//          optionDiv.style.width = rdbOptionsList.offsetWidth+"px";
//        }
        if(optionDiv.scrollHeight > optionDiv.clientHeight) //taking scrollbar width as 20px approximately
        {
          optionDiv.style.width = optionDiv.offsetWidth+20+"px";
        }
        if(divHgt>maxDivHgt)
        {
          optionDiv.style.height = maxDivHgt+'px' ;
          var searchDiv = DOMUtils.getChildElsWithAttr(rdbOptionsList, "rdbSearch", "true")[0]; //NO I18N
          searchDiv.style.display="";
          optionDiv.style.overflowY = "auto";//NO I18N
          optionDiv.style.overflowX = "hidden";//NO I18N
          optionDiv.style.webkitOverflowScrolling = 'touch'; //NO I18N
        }
        rdbOptionsList.style.zIndex = "5000";
        ZDBUtil.setAttribute(el,true,"positionset");
	  }
	  
	  this.setDBListHeight = function(optionDiv)
	  {
		  var maxDivHgt = (window.innerHeight)*0.40;
		  var divHgt = ZDBClientUtil.getInnerHeight(optionDiv.selectListEl);//optList.offsetHeight;
	      var maxHgtOptList = parseInt(optionDiv.getAttribute("maxHgt"), 10);
	      maxDivHgt = (maxHgtOptList>maxDivHgt)?maxDivHgt:maxHgtOptList;
	      if(divHgt > maxDivHgt)
	      {
	    	  optionDiv.style.height = maxDivHgt+'px' ;
	      }
	      else
	      {
	    	  optionDiv.style.height = divHgt+'px' ;
	      }
	  }
	  
	  this.checkKeyNContinue = function(event)
	  {
        if(RDBPage.searchFocused){return;} // if search focused event should be handled by search box
        if(event == null)
        {
            event = window.event;
        }
        if(event.keyCode==27)
        {
        	RDBPage.closeList(event, true);
        }
        else if(event.keyCode==40 || event.keyCode==38)
        {
        	RDBPage.highlightSelected(event, true);
        }
        else if(event.keyCode==13 || event.keyCode==32)
        {
        	RDBPage.selectDB(RDBPage.curList.currentHighlightedItem,event);
        	RDBPage.closeList(event,true);
        }
	  }

	  this.checkKeyAndSearch = function(el,ev,searchInTable)
	  {
		if(searchInTable)
		{
			RDBPage.searchTables(el);
			return true;
		}
	    if(!ev){ev = window.event;}
	    if(ev.keyCode==27)
	    {
	        RDBPage.closeList(ev, true);
	    }
	    else
	    {
	    	RDBPage.searchDBs(el);
	    }
	  }
	  
	  this.closeList = function(event, isKeyPress)
	  {
		  RDBPage.curList.style.display = "none";
          RDBPage.curList.listVisible = false;
		  ZDBUtil.detachEvent(RDBPage.curList,'mouseover',RDBPage.highlightSelected,true);
		  ZDBUtil.detachEvent(document, 'click', RDBPage.closeList, true);
	      ZDBUtil.detachEvent(document,'keydown',RDBPage.checkKeyNContinue,true);
	  }
	  
	  this.handleFocus = function(el, event)
	  {
		  ZDBSearchUtil.handleFocus(el);
		  ZDBUtil.detachEvent(document, 'click', RDBPage.closeList, true);
		  ZDBUtil.stopEventBubble(event);
	  }
	  
	  this.highlightSelected = function(event, isKeyPress)
	  {
	        if(event == null)
	        {
	            event = window.event;
	        }
	        var mouseOnEl;
	        if(isKeyPress)
	        {
	            var options = RDBPage.curList.getElementsByTagName("LI");
	            var noofitems = options.length;
	            var highlightedItemIndex = ZDBUtil.indexOf(options,RDBPage.curList.currentHighlightedItem);
	            switch(event.keyCode)
	            {
	                case 40:
	                if(highlightedItemIndex == (noofitems-1))
	                {
	                return;
	                }
	                else
	                {
	                    highlightedItemIndex++;
	                } break;
	                case 38: if(highlightedItemIndex == 0)
	                {
	                    return;
	                }
	                else
	                {
	                    highlightedItemIndex--;
	                } break;
	            }
	            mouseOnEl = options[highlightedItemIndex];
	        }
	        else
	        {
	            mouseOnEl = ZDBUtil.getSourceElement(event);
	        }
	        if(mouseOnEl.tagName != "LI")
	        {
	            if(curHighLitedEl && mouseOnEl.getAttribute("searchBox")=="true")
	            {
	                curHighLitedEl.className = curHighLitedEl.getAttribute("origClass");
	            }
	            return;
	        }
	        var curHighLitedEl = RDBPage.curList.currentHighlightedItem;
	        RDBPage.curList.currentHighlightedItem = null;
	        if(curHighLitedEl)
	        {
	            curHighLitedEl.className = curHighLitedEl.getAttribute("origClass");
	        }
	        RDBPage.curList.currentHighlightedItem = mouseOnEl;
	        curHighLitedEl = RDBPage.curList.currentHighlightedItem;
	        curHighLitedEl.className = curHighLitedEl.getAttribute("origClass") + "Hover";
	  }
	  
	  this.selectDB = function(el,event)
	  {
		  var comboEl = $("rdbComboSelected");
		  var prevSelectedEl = RDBPage.curList.selectedEl;
		  if(prevSelectedEl)
		  {
			var prevElOrigClass = ZDBUtil.getAttribute(prevSelectedEl,"origClass");
			prevElOrigClass = prevElOrigClass.replace("Selected","");
			prevSelectedEl.className = prevElOrigClass;
			ZDBUtil.setAttribute(prevSelectedEl,prevElOrigClass,"origClass");
		  }
		  comboEl.innerHTML = ZDBUtil.getAttribute(el,"value");
		  var origClass = ZDBUtil.getAttribute(el,"origClass");
		  el.className = origClass + "Selected";
		  ZDBUtil.setAttribute(el,el.className,"origClass");
		  RDBPage.curList.selectedEl = el;
		  var rdbName = ZDBUtil.getAttribute(el,"value");
		  $("CONN_CloudDBNAME").value = rdbName;
		  RDBPage.selectedTablesArray = [];
		  RDBPage.loadTables(rdbName,"*");
		  ZDBUtil.stopEventBubble(event);
	  }
	  
	  this.handlegetDatabasesFailure=function(response,requestOptions)
	  {
		  var errCode = response.getResponsePart("ERRORCODE");
	      var errMsg = response.getResponsePart("STATUS_MESSAGE");
	      errCode = trimAll(errCode);
		  ZDBAlertAPI.showErrorMsg(errMsg,null,errCode);
		  CloudDBPage.decValueByOne($("ZRCloudDBNextBtn"), "stepNo"); //No I18N
		  ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
		  $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
	  }
	  
	  this.onDBChange = function(el)
	  {
		  var rdbFrm = ZDBUtil.getCachedRef(ZRRDBForm, "ZRRDBForm");
		  var rdbName = el.options[el.selectedIndex].value;
		  rdbFrm.RDBNAME.value = rdbName;
		  RDBPage.selectedTablesArray = [];
		  RDBPage.loadTables(rdbName,"*");
	  }
	 
	  this.loadTables = function(rdbName,pattern)
	  {
		  var params = "HOST=" + encodeURIComponent($("HOST").value) + "&PORT=" + $("PORT").value + "&USERNAME=" + encodeURIComponent($("USERNAME").value) + "&PASSWORD=" + encodeURIComponent($("PASSWORD").value) + 	//No I18N
		  				"&SERVICENAME=" + $("SERVICENAME").value + "&DBTYPE=" +RDBPage.getDBTypeForService($("SERVICENAME").value)+ "&RDBNAME=" + encodeURIComponent(rdbName)+"&USESSL=" + $("USESSL").checked+		//No I18N
		  				"&PATTERN="+ encodeURIComponent(pattern) + "&ZDBACTION=GETTABLES";	//No I18N
	      AjaxAPI.sendRequest({URL:"/RDBAction.ma?", PARAMETERS: params,METHOD:"POST",
              ONSUCCESSFUNC:RDBPage.handlegetTableSuccess,
              ONFAILUREFUNC:RDBPage.handlegetTableFailure,
              OPSTATUSID:$("ZRRDBTablesOverlay")});//No I18N
	  }
	  
	  this.editConnectionDialog = function(fromExp)
	  {
	    var dbId = ZDBClientUI.dbId;
		var dlg =  ZDBUtil.getCachedRef(this, "ZDBEDITCONNECTIONDIALOG");
		dlg.style.display = "block";
		if(fromExp)
		{
		  $("ZDBCREATERDBVIEW").style.display = "none";
		}
		else
		{
		  ZDBInlineDialog.showDialog(dlg,{MODAL:true});
		}
		var rdbView = ZDBClientUI.dbConfig.rdbView;
		var conDbtypeCol = ZDBUtil.getCachedRef(this, "EDITRDB_SERVICENAME");
		conDbtypeCol.value = rdbView.serviceName;
		conDbtypeCol.disabled = true;
		$("EDITRDB_HOST").focus();
	  }
	  
	  this.saveEditConnectionDetails = function(form)
	  {
		AjaxAPI.submit(form);
	  }
	  
	  this.handleEditRDBConnectionSuccess = function(response,requestOptions)
	  {
		  ZDBInlineDialog.closeDialog();
		  var errorEl = $("RDBConnectErr_Exp");
		  errorEl.style.display = "none";
		  jQuery($("navListFreeze")).remove();
		  jQuery($("toolbarFreeze")).remove();
		  jQuery($("viewsListFreeze")).remove();
		  $("ZDBNAVIGTD").style.position = "";
		  ZDBNavigation.refreshExplorer();
		  RDBPage.syncDesign(true);
	  }
	  
	  this.handleEditRDBConnectionFailure = function(response,requestOptions) {
		  var errCode = response.getResponsePart("ERRORCODE");
		    var errMsg = response.getResponsePart("STATUS_MESSAGE");
		    errCode = trimAll(errCode);
			ZDBAlertAPI.showErrorMsg(errMsg,null,errCode);
//		  ZDBMsgBox.showError(response.getResponsePart("STATUS_MESSAGE"));
	         return false;
	  }
	  
	  this.explainQuery = function(form) {
		  
		  var dbId = document.getElementsByName("DBID")[0].value;//NO I18N
		  var queryText = document.getElementsByName("queryText")[0].value;//No I18N
		  var params="ZDBACTION=EXPLAINRDBQUERY"+"&queryText="+queryText; //NO I18N
			  params+="&DBID="+dbId; //NO I18N
		  
		  AjaxAPI.sendRequest({URL:"/ZDBAdminActionMI.ma?",METHOD:"GET",PARAMETERS:params
              , ONSUCCESSFUNC:RDBPage.handleExplainQuerySuccess
              , ONFAILUREFUNC:RDBPage.handleExplainQueryFailure});
		  
	  };
	  
	  this.convertDB = function(form) {
		  
		  var dbId = document.getElementsByName("LOCALDBID")[0].value;//NO I18N
		  var conid = document.getElementsByName("CONID")[0].value;//No I18N
		  var rdbname = document.getElementsByName("RDBNAME")[0].value;//No I18N
		 var params="ZDBACTION=CONVERTTOREMOTE"+"&DBID="+dbId; //NO I18N
			  params+="&CONID="+conid; //NO I18N
			  params+="&RDBNAME="+rdbname; //NO I18N
		  
		  AjaxAPI.sendRequest({URL:"/ZDBAdminActionMI.ma?",PARAMETERS:params
              , ONSUCCESSFUNC:RDBPage.handleConvertDBSuccess
              , ONFAILUREFUNC:RDBPage.handleconvertDBFailure});
		  
	  };
	    
	  this.killQuery = function(form) {
		  var killQueryIdNodeList = document.getElementsByName("KILLID");//NO I18N
		  var killQueryId = [];
		  for(var i = killQueryIdNodeList.length; i--;) {
			  if(killQueryIdNodeList[i].checked) {
			  killQueryId.unshift(killQueryIdNodeList[i].value);
			  }
		  }
		  
		  var dbId = document.getElementsByName("DBID")[0].value;//NO I18N
		  var params="ZDBACTION=KILLRDBQUERY"+"&KILLID="+killQueryId; //NO I18N
			  params+="&DBID="+dbId; //NO I18N
			  
			  var confirmText = "Are you sure you want to kill selected query(s)?"; //NO I18N
			    if(confirm(confirmText)) {
	 
		AjaxAPI.sendRequest({URL:"/ZDBAdminActionMI.ma?",PARAMETERS:params
	                                 , ONSUCCESSFUNC:RDBPage.handleKillQuerySuccess
	                                 , ONFAILUREFUNC:RDBPage.handleKillQueryFailure});
			    } else {
			    	return false;
			    }
		  
	  };
	  
	  this.handleConvertDBSuccess = function(response,requestOptions)
	    {
	    	 $("convertDBResult").innerHTML = response.responseText;
	    	 return false;
	    }
	  
	  this.handleconvertDBFailure = function(response,requestOptions)
	    {  
		  var msg = response.getResponsePart("STATUS_MESSAGE");
	      var errorCode = response.getResponsePart("ERRORCODE");
	      $("convertDBResult").innerHTML = msg;
	    	 
	    }
	  
	  this.handleExplainQuerySuccess = function(response,requestOptions)
	    {
			 $("explainQueryResult").innerHTML = response.responseText;
	    	 return false;
	    }
	  
	    this.handleExplainQueryFailure = function(response,requestOptions)
	    {
	    	var msg = response.getResponsePart("STATUS_MESSAGE");
	        var errorCode = response.getResponsePart("ERRORCODE");
	    
	    	 $("explainQueryResult").innerHTML = msg;
	    }
	  
	  this.handleKillQuerySuccess = function(response,requestOptions)
	    {

	    	 $("killQueryResult").innerHTML = response.responseText;
	    	 return false;
	    }
	  
	    this.handleKillQueryFailure = function(response,requestOptions)
	    {
	    	var msg = response.getResponsePart("STATUS_MESSAGE");
	        var errorCode = response.getResponsePart("ERRORCODE");
	    
	    	 $("killQueryResult").innerHTML = msg;
	    }
	    
	    this.handlegetTableSuccess = function(response,requestOptions)
	    {
	    	var result = response.responseText;
	    	var tablesList = JSON.parse(result);
	    	var listLength = tablesList.length;
	    	RDBPage.totTables = listLength;
	    	RDBPage.selectedTables = 0;
	    	var selectTbl = $("ZRRDBSelectTables");
	    	jQuery(selectTbl).empty();
	    	jQuery($("ZRRDBSelectedTables")).empty();
	    	var selAllTable = $("ZRRDBSelectAllTables");
	    	selAllTable.className = "zrcheckbox";
	    	ZDBUtil.setAttribute(selAllTable,"false","selected");
	    	if(listLength < 1)
	    	{	
	    		var tblDiv = document.createElement("div");
	    		tblDiv.innerHTML = ZDBI18NMap.g("zrpt.common.newrpt.zdbalertmsg.js.noTblsFound");
	    		tblDiv.className = "noData";
	    		selectTbl.appendChild(tblDiv);
	    	}
	    	for(var i=0; i<listLength; i++)
	    	{
	    		var tblDiv = document.createElement("span");
	    		tblDiv.innerHTML = tablesList[i];
	    		tblDiv.className = "zrcheckbox";
	    		tblDiv.onclick = RDBPage.selectTables;
	    		ZDBUtil.setAttribute(tblDiv,"false","added");
	    		ZDBUtil.setAttribute(tblDiv,"false","selected");
	    		selectTbl.appendChild(tblDiv);
	    	}
	    }
	    
	    this.selectTables = function(event)
	    {
	      var el = window.event ? window.event.srcElement : event.target;
	      var attrVal = ZDBUtil.getAttribute(el,"selected");
	      var status = (attrVal == "true") ? "false" : "true";
	      RDBPage.selectRDBTables(el,status);
	    }
	    
	    this.selectAllTables = function(el)
	    {
	    	var selected = ZDBUtil.getAttribute(el,"selected");
	    	var selectTblCont = $("ZRRDBSelectTables");
	    	var selectTblList = jQuery(selectTblCont).children(":visible");		//No I18N
	    	el.className = (selected == "true") ? "zrcheckbox" : "zrcheckboxsel";
	    	var status = (selected == "true") ? "false" : "true";
	    	ZDBUtil.setAttribute(el,status,"selected");
	    	for(var i=0;i < selectTblList.length; i++)
	    	{
	    		var selectTbl = selectTblList[i];
	    		RDBPage.selectRDBTables(selectTbl,status);
	    	}
	    }
	    
	    this.selectRDBTables = function(el,attrVal)
	    {
	      var added = ZDBUtil.getAttribute(el,"added");
	      ZDBUtil.setAttribute(el,attrVal,"selected");
	      var selectedTblCont = $("ZRRDBSelectedTables");
	      
	      if(attrVal == "true" && added == "false")
	      {
	    	el.className = "zrcheckboxsel";
	    	ZDBUtil.setAttribute(el,"true","added");
	    	var selectedTbl = document.createElement("div");
	    	var selectedTblClose = document.createElement("input");
	    	selectedTblClose.setAttribute("type","button");
	    	selectedTblClose.className = "zrdbRemoveSelTbl";
	    	selectedTbl.innerHTML = el.innerHTML;
	    	selectedTblClose.onclick = RDBPage.removeSelectedTables;
	    	selectedTbl.appendChild(selectedTblClose);
	    	selectedTbl.selectTbl = el;
	    	selectedTbl.className = "zrdbSelectedTbl";
	    	selectedTbl.setAttribute("value",el.innerHTML);
		  	el.selectedTbl = selectedTbl;
		  	RDBPage.selectedTables++;
		  	if(RDBPage.matchedCount > 0)
		  		RDBPage.matchedTablesSelectedCont++;
		  	RDBPage.selectedTablesArray.push(ZDBEscapeUtil.decodeForHtml(el.innerHTML));
		  	selectedTblCont.appendChild(selectedTbl);
	      }
	      else if(attrVal == "false" && added == "true")
	      {
	    	el.className = "zrcheckbox";
		    ZDBUtil.setAttribute(el,"false","added");
		    RDBPage.selectedTables--;
		    if(RDBPage.matchedCount > 0)
		  		RDBPage.matchedTablesSelectedCont--;
		    RDBPage.selectedTablesArray.splice(RDBPage.selectedTablesArray.indexOf(el.innerHTML),1);
		    var selectedTbl = el.selectedTbl;
		    jQuery(selectedTbl).remove();
	      }
	      
	      var selectAllEl = $("ZRRDBSelectAllTables");
	      if((RDBPage.selectedTables == RDBPage.totTables) || (RDBPage.matchedCount > 0 && RDBPage.matchedCount == RDBPage.matchedTablesSelectedCont))
	      {
	    	  selectAllEl.className = "zrcheckboxsel";
		      ZDBUtil.setAttribute(selectAllEl,"true","selected");
	      }
	      else
	      {
	    	  selectAllEl.className = "zrcheckbox";
		      ZDBUtil.setAttribute(selectAllEl,"false","selected");
	      }
	      if(RDBPage.selectedTables > 0)
	      {
	    	  $("ZRRDBRemoveAll").style.display = "";
	      }
	      else
	      {
	    	  $("ZRRDBRemoveAll").style.display = "none";
	      }
	  	  
	    }
	    
	    this.removeSelectedTables = function(event)
	    {	
	      var srcEl = window.event ? window.event.srcElement : event.target;
	      var el = jQuery(srcEl).parent("div").get(0);		//No I18N
	      el.selectTbl.className = "zrcheckbox";
	      RDBPage.selectedTables--;
	      if(RDBPage.matchedCount > 0 && jQuery(el.selectTbl).is(":visible") && (ZDBUtil.getAttribute(el.selectTbl,"selected") == "true"))
	    	  RDBPage.matchedTablesSelectedCont--;
	      ZDBUtil.setAttribute(el.selectTbl,"false","added");
	      ZDBUtil.setAttribute(el.selectTbl,"false","selected");
	      RDBPage.selectedTablesArray.splice(RDBPage.selectedTablesArray.indexOf(ZDBUtil.getAttribute(el,"value")),1);
	      jQuery(el).remove();
	      var selectAllTbl = $("ZRRDBSelectAllTables");
	      if(RDBPage.matchedCount > 0 && 
	    		  !jQuery(el.selectTbl).is(":visible") && (RDBPage.matchedCount == RDBPage.matchedTablesSelectedCont))	//No I18N
	      {
	    	  selectAllTbl.className = "zrcheckboxsel";
	    	  ZDBUtil.setAttribute(selectAllTbl,"true","selected");
	      }
	      else
	      {
	    	  selectAllTbl.className = "zrcheckbox";
	    	  ZDBUtil.setAttribute(selectAllTbl,"false","selected");
	      }
	      if(RDBPage.selectedTables <= 0)
	      {
	    	  $("ZRRDBRemoveAll").style.display = "none";
	      }
	    }
	    
	    this.removeAllTables = function()
	    {
	    	var selectedTblCont = $("ZRRDBSelectedTables");
	    	var selectedTbl = selectedTblCont.getElementsByTagName("div");
	    	for(var i=selectedTbl.length; i>0; i--)
	    	{
	    		var selectTbl = selectedTbl[0].selectTbl;
	    		RDBPage.selectRDBTables(selectTbl,"false");
	    	}
	    }
	    
	    this.searchDBs = function(searchEl)
	    {
	    	var value = ZDBSearchUtil.getSearchValue(searchEl);
			value = (value) ? value.toLowerCase() : "";
			var dblist = RDBPage.dblist;
			var rdbOptionsList = $("rdbOptionList");
			var mainList = rdbOptionsList.mainList;
			  var tblsList = mainList.getElementsByTagName("li");
	    	for(var i=0; i < tblsList.length; i++)
			  {
				  var tblEl = tblsList[i];
				  var tblName = ZDBUtil.getAttribute(tblEl,"value");
				  var matched = ((tblName.toLowerCase().indexOf(value)) > -1);
				  tblEl.style.display = ((matched || (value == null) || (value == "")) && tblName != "") ? "block" : "none";
			  }
	    	RDBPage.setDBListHeight(rdbOptionsList.optionDiv);
	    }
	    
		this.searchTables = function(searchEl)
		{
		  RDBPage.matchedCount = 0;
		  RDBPage.matchedTablesSelectedCont = 0;
		  var value = ZDBSearchUtil.getSearchValue(searchEl);
		  value = (value) ? value.toLowerCase() : "";
		  var selectTbl = $("ZRRDBSelectTables");
		  var tblsList = selectTbl.getElementsByTagName("span");
		  if(selectTbl.getElementsByTagName("div"))
			  jQuery(selectTbl.getElementsByTagName("div")).remove();
		  var tblDiv = document.createElement("div");
		  tblDiv.innerHTML = ZDBI18NMap.g("zrpt.common.toolbar.table.findnreplace.zdbalertmsg.js.findNReplaceFailedErr");
		  tblDiv.className = "noData";
		  selectTbl.appendChild(tblDiv);  
		  for(var i=0; i < tblsList.length; i++)
		  {
			  var tblEl = tblsList[i];
			  var tblName = tblEl.innerHTML;
			  var matched = ((tblName.toLowerCase().indexOf(value)) > -1);
			  tblEl.style.display = (matched || (value == null) || (value == "")) ? "block" : "none";
			  if(matched || (value == null) || (value == ""))
				  RDBPage.matchedCount++;
			  if((ZDBUtil.getAttribute(tblEl,"selected") == "true") && (matched || (value == null) || (value == "")))
			      RDBPage.matchedTablesSelectedCont++;
		  }
		  
		  if(RDBPage.matchedCount > 0)
			  jQuery(tblDiv).remove();
		  
		  var selectAllEl = $("ZRRDBSelectAllTables");
		  if((RDBPage.selectedTables == RDBPage.totTables) || (RDBPage.matchedCount > 0 && RDBPage.matchedCount == RDBPage.matchedTablesSelectedCont))
		  {
			  selectAllEl.className = "zrcheckboxsel";
			  ZDBUtil.setAttribute(selectAllEl,"true","selected");
		  }
		  else
		  {
		   	  selectAllEl.className = "zrcheckbox";
			  ZDBUtil.setAttribute(selectAllEl,"false","selected");
		  }
		}
	    
	    this.trashObject = function(srcEl)
	    {
	      var el = srcEl.parentNode;
	      var objName = el.getAttribute("viewname");
	      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.delObjConfirm",ZDBEscapeUtil.encodeForHtml(objName)),"ZDBYESNO",{ONCLICK:this.trashView,ELEMENT:el});   //No I18N
	    }

	    this.trashView = function(clickType, requestOptions)
	    {
	      var el = requestOptions["ELEMENT"];
	      var objId = el.getAttribute("objid");
	      var objName = el.getAttribute("viewname");
	      var objType = el.getAttribute("objtype");
	      if(clickType == "NO")
	      {
	        return;
	      }
	      AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=MOVEOBJECTTOTRASH",
	                                 PARAMETERS:"OBJID="+objId+"&CHECKVIEWDEP=true", //No I18N
	                                 ONSUCCESSFUNC:RDBPage.resourceRemoved,
	                                 OBJID:objId,OBJNAME:objName,OBJTYPE:objType,ELEMENT:el,
	                                 OPSTATUSID:"ZDBMainLoader"}); //No I18N
	    }

	    this.resourceRemoved = function(response,requestOptions)
	    {
	      var el = requestOptions["ELEMENT"];
	      var params = response.getResponseParams();
	      var refTablesStr = (params["REFTABLES"]);
	      var objName = requestOptions["OBJNAME"];
	      var arr = (refTablesStr.length > 0) ? refTablesStr.split(",") : [];
	      if(arr.length > 0)
	      {
	        var title = ZDBI18NMap.g('zrpt.common.analysis.errmsg.js.refErrDlgTtl');
	        var innerHTML = "<br><b>"+ZDBI18NMap.f("zrpt.common.analysis.errmsg.js.delTblWithRefObjErr",ZDBEscapeUtil.encodeForHtml(requestOptions["OBJNAME"]))+"</b><br>";
	        for(var i = 0; i < arr.length; i++)
	        {
	          innerHTML = (i == 0) ? (innerHTML + ZDBEscapeUtil.encodeForHtml(arr[i])) : (innerHTML + ", " + ZDBEscapeUtil.encodeForHtml(arr[i]));
	        }
	        ZDBUtil.showRefErr(innerHTML,title);
	        return;
	      }
	      var depViewsStr = (params["DEPVIEWS"]);
	      arr = (depViewsStr.length > 0 ) ? depViewsStr.split(",") : [];
	      var type = requestOptions["OBJTYPE"];
	      if(arr.length > 0)
	      {
	        ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.delTblWithDepViewConfirm",type.toLowerCase()), "ZDBYESNO", //No I18N
	                          {ONCLICK:RDBPage.trashObjAndDepViews,
	        					OBJIDS:arr,OBJID:requestOptions["OBJID"],
	        					OBJTYPE:type,OBJNAME:objName,ELEMENT:el});
	        return;
	      }
	      ZDBNavigation.refreshExplorer();
	      var objIdsStr = (params["OBJIDS"]);
	      var objIds = (objIdsStr.length > 0 ) ? objIdsStr.split(",") : [];
	      ZDBClientUI.removeObjects(objIds);
	      jQuery(el).remove();
	      var rdbView = ZDBClientUI.dbConfig.rdbView;
	      rdbView.linkedTablesCount--;
	      $("ZRDBManage_LinkTblCount").innerHTML = rdbView.linkedTablesCount;
	      var idx = rdbView.linkedTablesList.indexOf(objName);
	      rdbView.linkedTablesList.splice(idx, 1);
	      rdbView.deleteMismatchEntry(ZDBUtil.getAttribute(el,"objid"));
	      RDBPage.showMismatchInTab();
	    }
	    
	    this.trashObjAndDepViews = function(clickType, requestOptions)
	    {
	      if(clickType == "NO")
	      {
	        return;
	      }
	      var arr = requestOptions["OBJIDS"];
	      var objId = requestOptions["OBJID"];
	      var type = requestOptions["OBJTYPE"];
	      AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=MOVEOBJECTTOTRASH",
	                           PARAMETERS:"OBJID=" + objId + "&CHECKVIEWDEP=false&OBJIDS=" + arr,	//No I18N
	                           ONSUCCESSFUNC:RDBPage.resourceRemoved,
	                           OBJID:objId,OBJTYPE:type,ELEMENT:requestOptions["ELEMENT"]});
	    }
		
		this.checkConnectionInDBExp = function(dbId)
		{
			dbId = (dbId) ? dbId : ZDBClientUI.dbId;
			var url = "/RDBAction.ma?DBID=" + dbId + "&ZDBACTION=CHECKCONNECTION&ISFROMEDIT=false";		//No I18N
			var ajaxOptions = {URL:url,FROM:"exp",METHOD:"GET",	//No I18N
					ONFAILUREFUNC:RDBPage.handleCheckConnectionFailure,
					OPSTATUSID:"ZDBMainLoader"};	//No I18N
			AjaxAPI.sendRequest(ajaxOptions);
		}
		
		this.handleCheckConnectionFailure = function(response,requestOptions)
		{
			var fromWhere = requestOptions["FROM"];
			if(fromWhere == "exp")
			{
				RDBPage.showErrorNEditInExp();
			}
			else if(fromWhere == "editconn")
			{
				var errMsg = response.getResponsePart("STATUS_MESSAGE");
				ZDBAlertAPI.showErrorMsg(errMsg,null,null);
			}
		}
		
		this.syncDesign = function(fromEditConn)
		{
		  var dbId = ZDBClientUI.dbId;
		  var onsuccessfunc = (fromEditConn) ? RDBPage.handleSyncAfterEditConn : RDBPage.handlesyncDesignSuccess;
		  if(!fromEditConn)
		  {
			  $("ZRDBNoMismatchMsg").style.display = "none";
		      $("ZRDBNoMismatchMsg").className = "";
		  }
		  AjaxAPI.sendRequest({URL:"/RDBAction.ma?DBID=" + dbId + "&ZDBACTION=SYNCDESIGN", //No I18N
		              ONSUCCESSFUNC:onsuccessfunc,
		              ONFAILUREFUNC:RDBPage.handlesyncDesignFailure,
		              OPSTATUSID:"ZRDBSyncDesignLoading"});//No I18N
		}
		
	    this.handlesyncDesignSuccess = function(response,requestOptions)
		{
	    	var respObj = JSON.parse(response.responseText);
		    var rdbView = ZDBClientUI.dbConfig.rdbView;
		    rdbView.updateSyncStatus(respObj);
		    RDBPage.updateManageDB();
		    if(rdbView.mismatchCount > 0)
		    {
		    	RDBPage.selectTab($("RDBMismatchTab"));
				RDBPage.showMismatchInfo();
		    }
		    else
		    {
		    	$("ZRDBNoMismatchMsg").style.display = "inline-block";
		    	$("ZRDBNoMismatchMsg").className = "slideError";
		    }
		}
		    
		this.handlesyncDesignFailure = function(response,requestOptions)
		{
			var errMsg = response.getResponsePart("STATUS_MESSAGE");
			ZDBAlertAPI.showErrorMsg(errMsg,null,null);
		}
		
		this.handleSyncAfterEditConn = function(response,requestOptions)
		{
		  var respObj = JSON.parse(response.responseText);
		  var rdbView = ZDBClientUI.dbConfig.rdbView;
		  var rdbDlg = $("RDBDLG");
		  rdbView.updateSyncStatus(respObj);
		  var mismatchCount = rdbView.mismatchCount;
		  if(jQuery(rdbDlg).is(':visible'))
		  {
			  RDBPage.updateManageDB();
			  if(mismatchCount > 0)
			  {
				  RDBPage.selectTab($("RDBMismatchTab"));
				  RDBPage.showMismatchInfo();
			  }
			  else
			  {
				  ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.databasedata.connname.js.dbuptodate"));	//No I18N
			  }
		  }
		  else
		  {
			  RDBPage.showMismatchInExp(mismatchCount);
		  }
		  
		}
		
		this.showMismatchInExp = function(mismatchCount)
		{
                  var mismatchEl = $("RDBSync_Mismatch");
                  if(mismatchCount && mismatchCount > 0)
                  {
                    mismatchEl.innerHTML = mismatchCount;
                    mismatchEl.style.display = "inline-block"; 
                  }
                  else
                  {
                    mismatchEl.style.display = "none"; 
                  }
		}
		
		this.clearMismatch = function()
		{
			var mismatchEl = $("RDBSync_Mismatch");
			mismatchEl.style.display = "none";
		}
		
		this.showErrorNEditInExp = function()
		{
			var errorEl = $("RDBConnectErr_Exp");
			errorEl.style.display = "block";
			jQuery(ZDBNavigation.rdbLinkTablesOpt).hide();
			var navList = $("ZDBNAVIGTD");
			navList.style.position = "relative";	//No I18N
			var toolbarParent = jQuery("#ZRExpToolBar > .secondRow").get(0);//$("ZRExpToolBar");//No I18N
			var viewsList = $("ZDBVIEWLISTDIV");
			var navListFreeze = document.createElement("div");
			var toolbarFreeze = document.createElement("div");
			var viewsListFreeze = document.createElement("div");
			navListFreeze.id = "navListFreeze";
			navList.appendChild(navListFreeze);
			navListFreeze.className = "ZROverlayFreeze";
			jQuery(navListFreeze).css({"position":"absolute",	//No I18N
					"top": "0",	//No I18N
					"left" : "0",	//No I18N
					"height" : "100%",	//No I18N
					"width" : "100%"});	//No I18N
			
			
			toolbarFreeze.id = "toolbarFreeze";
			toolbarParent.appendChild(toolbarFreeze);
			toolbarFreeze.className = "ZROverlayFreeze";
			jQuery(toolbarFreeze).css({"position":"relative",	//No I18N
					"height" : (jQuery("#ZRExpToolBar > .secondRow").height()) + "px",	//No I18N
					"width" : (jQuery("#ZRExpToolBar > .secondRow").width()) + "px"});	//No I18N
			jQuery(toolbarParent).css({"display":"block"});		//No I18N
			
			viewsListFreeze.id = "viewsListFreeze";
			viewsList.appendChild(viewsListFreeze);
			viewsListFreeze.className = "ZROverlayFreeze";
			
		}
		
		this.updateManageDB = function()
		{
		  var editConnDlg =  ZDBUtil.getCachedRef(this, "ZDBEDITCONNECTIONDIALOG");
		  editConnDlg.style.display = "none";
		  $("ZDBCREATERDBVIEW").style.display = "block";
		  
		  var rdbView = ZDBClientUI.dbConfig.rdbView;
		  $("ZRDBManage_DBName").innerHTML = rdbView.rdbName;
		  
		  var createdOnTime = new Date(parseInt(rdbView.createdOnTime));
		  var dispCreatedTime = ZDBFunctions.day(createdOnTime) + " " + ZDBFunctions.partOfMonth(createdOnTime) + " " +
			ZDBFunctions.year(createdOnTime) + ", " + createdOnTime.getHours() + ":" + createdOnTime.getMinutes();
		  $("ZRDBManage_CreatedOn").innerHTML = dispCreatedTime;
		  
		  $("ZRDBManage_DBType").innerHTML = RDBPage.serviceNameMap[rdbView.serviceName];
		  
		  var syncTime = (rdbView.lastSyncTime != null) ? new Date(parseInt(rdbView.lastSyncTime)) : createdOnTime; 
		  var dispSyncTime = (rdbView.lastSyncTime != null) ? (ZDBFunctions.day(syncTime) + " " + ZDBFunctions.partOfMonth(syncTime) + " " +
			ZDBFunctions.year(syncTime) + ", " + syncTime.getHours() + ":" + syncTime.getMinutes()) : dispCreatedTime;
		  $("ZRDBManage_SyncTime").innerHTML = dispSyncTime;
		  
		  RDBPage.fetchNUpdateTablesList();
		  $("ZRDBManage_LinkTblCount").innerHTML = rdbView.linkedTablesCount;
                  
                  $("ZRDBNoMismatchMsg").style.display = "none";
		  $("ZRDBNoMismatchMsg").className = "";
		  $("ZRDBNoTablesErr").style.display = "none";
		  
		  RDBPage.showMismatchInTab();
          RDBPage.showMismatchInExp(rdbView.mismatchCount);
		}
		
		this.showMismatchInTab = function()
		{
		  var rdbView = ZDBClientUI.dbConfig.rdbView;
		  var mismatchCount = rdbView.mismatchCount;
		  if(mismatchCount && mismatchCount > 0)
		  {
			$("RDBMismatchNotifyEl").style.display = "inline-block";
			$("RDBMismatchNotifyEl").innerHTML = mismatchCount;
			$("RDBMismatchTab").className.replace(" alpha","");
			$("RDBMismatchTab").onclick = function(){
				RDBPage.selectTab($("RDBMismatchTab"));
			}
		  }
		  else
		  {
			$("RDBMismatchNotifyEl").style.display = "none";
			$("RDBMismatchTab").onclick = null;
			RDBPage.selectTab($("RDBLinkTablesTab"));
			$("RDBMismatchTab").className += " alpha";	//No I18N
		  }
		}
		
		this.fetchNUpdateTablesList = function()
		{
		  var rdbView = ZDBClientUI.dbConfig.rdbView;
		  var tableElList = jQuery(ZDBExpViewHandler.getTypeViewList("Table"));//jQuery(ZDBClientUI["Objects_TBODY"]).find("tr[typeofview='Tables']");	//NO I18N
		  var tablesList = new Array();
		  var listTblEl = jQuery("#ZRDBTablesListEl").find("#ZDBRDBListTables").get(0);	//No I18N
		  var contDiv = (listTblEl) ? listTblEl : document.createElement("div");
		  contDiv.id = "ZDBRDBListTables";
		  jQuery(contDiv).empty();
		  tableElList.each(function(){
                        var viewDetails = ZDBExpViewHandler.fetchViewListInfo(this);
			var dispName = viewDetails[ZDBExpViewHandler.VIEW_NAME];//jQuery(this).attr("viewname");	//No I18N
			var rowDiv = document.createElement("div");
			rowDiv.className = "listviews";
			jQuery(rowDiv).attr("viewname",dispName);	//No I18N
			jQuery(rowDiv).attr("objid",this);	//No I18N
			jQuery(rowDiv).attr("objtype",viewDetails[ZDBExpViewHandler.VIEW_TYPE]);	//No I18N
			var imgSpan = document.createElement("span");
			imgSpan.className = "TablesNav";
			var viewNameDiv = document.createElement("div");
			viewNameDiv.className = "displayName";
			viewNameDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(dispName);
			var deleteDiv = document.createElement("div");
			deleteDiv.className = "inlineLinkStyle";
			deleteDiv.innerHTML = ZDBI18NMap.g("zrpt.common.emailsch.js.delete");
			jQuery(deleteDiv).on("click",function(){RDBPage.trashObject(this);});	//No I18N
			rowDiv.appendChild(imgSpan);
			rowDiv.appendChild(viewNameDiv);
			rowDiv.appendChild(deleteDiv);
			contDiv.appendChild(rowDiv);
			tablesList.push(dispName);
		  });
		  rdbView.linkedTablesCount = tablesList.length;
		  rdbView.linkedTablesList = tablesList;
		  $("ZRDBTablesListEl").appendChild(contDiv);
		}
		
		this.showMismatchInfo = function()
		{
		  $("ZRDBAddTables").style.display = "none";
		  var rdbView = ZDBClientUI.dbConfig.rdbView;
		  var mismatchCount = rdbView.mismatchCount;
		  RDBPage.fetchNUpdateMismatches();
		}
		
		this.fetchNUpdateMismatches = function()
		{
		  var rdbView = ZDBClientUI.dbConfig.rdbView;
		  var mismatchInfo = rdbView.getMismatchInfo();
			
		  var mismatchEl = jQuery("#ZRDBTablesListEl").find("#ZRRDBListMismatches").get(0);	//No I18N
		  var contDiv = (mismatchEl) ? mismatchEl : document.createElement("div");
		  contDiv.id = "ZRRDBListMismatches";
		  jQuery(contDiv).empty();
		  var mainDiv = document.createElement("div");
		  var listMMDiv = document.createElement("div");
		  if(mismatchInfo.length > 0)
		  {  
			  var headerRowDiv = document.createElement("div");
			  var headerNameDiv = document.createElement("div");
			  var headerDescDiv = document.createElement("div");
			  headerRowDiv.className = "listviews";
			  headerNameDiv.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.tablecols");
			  headerNameDiv.className = "displayName bold";
			  headerDescDiv.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.mmreason");
			  headerDescDiv.className = "desc bold";
			  headerRowDiv.appendChild(headerNameDiv);
			  headerRowDiv.appendChild(headerDescDiv);
			  mainDiv.appendChild(headerRowDiv);  
		  }
		  for(var i=0; i<mismatchInfo.length; i++)
		  {
		    var mmObj = mismatchInfo[i];
		    var colMismatchObj = mmObj.colInfo;
		    if(colMismatchObj && colMismatchObj.mismatchCount <= 0)
		    {
		    	continue;
		    }
			var rowDiv = $("RDBMismatchRows").cloneNode(true);
			rowDiv.id = "";
			ZDBUtil.setNamedChildEls(rowDiv,rowDiv,"name");
			var nameDiv = rowDiv.tablename;
			nameDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(mmObj.displayname);
			var mismatchType = "TABLE";		//No I18N
			ZDBUtil.setAttribute(rowDiv,mismatchType,"mismatchtype");
			ZDBUtil.setAttribute(rowDiv,mmObj.objid,"objid");
			ZDBUtil.setAttribute(rowDiv,mmObj.displayname,"displayname");
			ZDBUtil.setAttribute(rowDiv,mmObj.displayname,"viewname");
			ZDBUtil.setAttribute(rowDiv,mmObj.rtablename,"tableName");
			ZDBUtil.setAttribute(rowDiv,mmObj.ddltime,"ddltime");
			var descDiv = rowDiv.description;
			if(mmObj.desc == 0)
			{
				descDiv.innerHTML = ZDBI18NMap.f("zrpt.rdb.js.tabledelerr",ZDBEscapeUtil.encodeForHtml(mmObj.displayname));
			}
			else
			{
				descDiv.innerHTML = RDBPage.mismatchDescText[mmObj.desc];
			}
			if(colMismatchObj)
			{
			  rowDiv.colMismatchObj = colMismatchObj;
			  rowDiv.colInfo = colMismatchObj.colInfo;
			  mismatchType = "COLUMN";	//No I18N
			  descDiv.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.colmismatch");	//No I18N
			}
		    var remapDiv = rowDiv.remap;
		    ZDBUtil.setAttribute(rowDiv,mismatchType,"mismatchtype");
		    ZDBUtil.setAttribute(remapDiv,"REMAP","requestfrom");
		    remapDiv.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.remap");
		    jQuery(remapDiv).on("click",function(){	//No I18N
		  	  RDBPage.showReMapDlg(this);
		    })
		    var delDiv = rowDiv.remove;
		    delDiv.innerHTML = ZDBI18NMap.g("zrpt.common.emailsch.js.delete");
		    jQuery(delDiv).on("click",function(){RDBPage.trashObject(this);});	//No I18N
		    listMMDiv.appendChild(rowDiv);
		  }
		  contDiv.appendChild(mainDiv);
		  contDiv.appendChild(listMMDiv);
		  $("ZRDBTablesListEl").appendChild(contDiv);
		}
		
		this.selectTab = function(tab)
		{
		  var siblings = tab.parentNode.childNodes;
		  var tabName = "";
		  var loadingSpan = document.createElement("span");
		  loadingSpan.className = "ZRSFillLoading";
		  loadingSpan.style.display = "inline";
		  loadingSpan.style.width = "100%";
		  for(var i=0,j = siblings.length;i<j;i++)
		  {
		    if((siblings[i].getAttribute) && (siblings[i].getAttribute("LISTTYPE") != null))
		    {
		      if(siblings[i] == tab)
		      {
		    	siblings[i].className="buttonSelected";
		    	tabName = siblings[i].getAttribute("LISTTYPE");
		    	siblings[i].appendChild(loadingSpan);
		      }
		      else
		      {
		    	siblings[i].className="buttonDeselected";
		    	(jQuery(siblings[i]).find("span.ZRSFillLoading")).remove();
		      }
		    }
		  }
		  
		  var listTblEl = jQuery("#ZRDBTablesListEl").find("#ZDBRDBListTables").get(0);	//No I18N
		  var mismatchEl = jQuery("#ZRDBTablesListEl").find("#ZRRDBListMismatches").get(0);	//No I18N
		  if(tabName == "LINKEDTABLES")
		  {
			$("ZRDBAddTables").style.display = "block";
			if(mismatchEl)
				mismatchEl.style.display = "none";
			if(listTblEl)
			  listTblEl.style.display = "block";
			else
			  RDBPage.fetchNUpdateTablesList(); 	
		  } 
		  else if(tabName == "MISMATCH")
		  {
			$("ZRDBAddTables").style.display = "none";
			if(listTblEl)
			  listTblEl.style.display = "none";
			if(mismatchEl)
			  mismatchEl.style.display = "block";
			else
			  RDBPage.showMismatchInfo();
		  }
		}
		
		this.getTables = function(srcEl)
		{
		  var rdbView = ZDBClientUI.dbConfig.rdbView;
		  var connId = rdbView.connId;
		  $("ZRDBNoTablesErr").className = "";
	      $("ZRDBNoTablesErr").style.display = "none";
		  AjaxAPI.sendRequest({URL:"/RDBAction.ma?ZDBACTION=GETREMAPTABLES&DBID=" + ZDBClientUI.dbId,METHOD:"GET", //No I18N
              ONSUCCESSFUNC:RDBPage.showMoreTablesDlg,
              ONFAILUREFUNC:RDBPage.handleShowMoreTablesFailure,
              RDBVIEW: rdbView,
              SRCEL:srcEl,
              OPSTATUSID:$("ZRDBGetTablesLoading")});//No I18N
		}
		
		this.getRemapTables = function(srcEl,loadingEl)
		{
			var dbId = ZDBClientUI.dbId;
			if(RDBPage.remapTableList && RDBPage.remapTableList.length > 0)
			{
				var reqOpt = {SRCEL:srcEl};
				RDBPage.showReMapTableDlg(RDBPage.remapTableList,reqOpt);
			}
			else
			{
				AjaxAPI.sendRequest({URL:"/RDBAction.ma?DBID="+ dbId + "&ZDBACTION=GETREMAPTABLES",METHOD:"GET", //No I18N
		              ONSUCCESSFUNC:RDBPage.showReMapTableDlg,
		              ONFAILUREFUNC:RDBPage.handleShowMoreTablesFailure,
		              SRCEL:srcEl,
		              OPSTATUSID:loadingEl});//No I18N
			}
		}
		
		this.showMoreTablesDlg = function(response,requestOptions)
		{
		  var result = response.responseText;
	      var tablesList = JSON.parse(result);
	      var rdbView = requestOptions["RDBVIEW"];
	      var srcEl = requestOptions["SRCEL"];
	      var linkTblList = rdbView.linkedTablesList;
	      for(var x=0; x < linkTblList.length; x++)
	      {
	    	  var index = tablesList.indexOf(linkTblList[x]);
	    	  if(index > -1)
	    		tablesList.splice(index,1);
	      }
	      if(tablesList.length < 1)
	      {
	    	  $("ZRDBNoTablesErr").className = "slideError";
	    	  $("ZRDBNoTablesErr").style.display = "inline-block";
	      }
	      else
	      {
	    	$("ZRDBNoTablesErr").style.display = "none";
	    	callOutEl = jQuery(srcEl).children(".inlineLinkStyle").get(0);	//No I18N
		    var title = ZDBI18NMap.g("zrpt.databasedata.connname.js.addmoretables");
		    var el = ZDBUtil.getCachedRef(RDBPage,"RDBAddMoreTablesDlg");
		    ZDBDialogUtil.showDialog(el,{TITLE:title,ADDFRAME:true,MODAL:true,CALLOUT:true,SRCEL:callOutEl});
	    	var moreTablesEl = jQuery("#RDBMoreTablesList");	//No I18N
	    	moreTablesEl.empty();
	    	jQuery("#RDBAddTblSelAll").prop("checked",false);	//No I18N
	    	$("ZRRDBSEARCHBOX").value = "";
	    	for(var i=0; i<tablesList.length; i++)
	    	{
	    		var tableListRowEl = jQuery("#RDBAddTblSel").clone(true);	//No I18N
	    		tableListRowEl.removeAttr("id");	//No I18N
		    	var inputEl = tableListRowEl.children('input'); //NO I18N
	            inputEl.prop("checked",false);	//No I18N
	            inputEl.attr("value",tablesList[i]);
		        inputEl.bind("click",function(){
		        	RDBPage.selectAllNewTables(this,false);
		        	
		        }); 
		        tableListRowEl.children("span").html(ZDBEscapeUtil.encodeForHtml(tablesList[i]));//.attr("title",tablesList[i]).bind("click",function(){ZDBListColumnChooser.selectColumn(this);}); // jshint ignore:line //NO I18N
		        moreTablesEl.append(tableListRowEl);
	    	}
	      }
		}
		
		this.selectAllNewTables = function(inputEl, isSelectAll)
		{
		  ZDBNavigation.selection(inputEl,'RDBAddTblSelAll','#RDBMoreTablesList',isSelectAll);  //NO I18N
		}
		
		this.linkNewTables = function()
		{	  
		  var chkArray = [];
		  var inputList = jQuery("#RDBMoreTablesList").find("input:checkbox:checked");	//No I18N
		  inputList.each(function() {
			        chkArray.push(jQuery(this).attr("value"));	//No I18N
			    });
		  var table_list;
		  table_list = chkArray.join(',');
		  if(table_list.length < 1)
		  {
	        ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.databasedata.connname.js.selecttble"));  //No I18N
	        return false;
	      }  
		  var csrf = ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")); //No I18N
		  AjaxAPI.sendRequest({URL:"/RDBAction.ma?ZDBACTION=CREATEREMOTETABLEWITHKEYS&DBID="+ZDBClientUI.dbId+"&TABLEARRAY=" + encodeURIComponent(table_list) + "&CSRF=" + csrf, //No I18N
	        ONSUCCESSFUNC:RDBPage.handlecreateTableSuccess,
	        ONFAILUREFUNC:RDBPage.handlecreateTableFailure,
	        OPSTATUSID:$("ZRLinkTablesLoading")});    // No I18N
		}
		  
		this.handlecreateTableSuccess = function(response,requestOptions)
		{
		  ZDBDialogUtil.closeDialog();
		  ZDBNavigation.refreshExplorer();
		  ZDBUtil.setTimeout(RDBPage.refreshLinkedTablesList,null,null,500);
		}
		
		this.refreshLinkedTablesList = function()
		{
			RDBPage.fetchNUpdateTablesList();
			$("ZRDBManage_LinkTblCount").innerHTML = ZDBClientUI.dbConfig.rdbView.linkedTablesCount;
		}
		
		    
		this.handlecreateTableFailure = function(response,requestOptions)
		{
			var errMsg = response.getResponsePart("STATUS_MESSAGE");
			ZDBAlertAPI.showErrorMsg(errMsg,null,null);
		}
		
		this.searchTablesInAddDlg = function(searchEl)
		{
		  var value = ZDBSearchUtil.getSearchValue(searchEl);
		  value = (value) ? value.toLowerCase() : "";
		  var matchCount = 0;
		  var parentElId = ZDBUtil.getAttribute(searchEl,"parentid");
		  var selectTbl = $(parentElId);
		  var tblsList = selectTbl.getElementsByTagName("div");
		  for(var i=0; i < tblsList.length; i++)
		  {
		    var tblEl = tblsList[i];
			var tblName = jQuery(tblEl).children(".ellipsis").get(0).innerHTML;		//No I18N
			var matched = ((tblName.toLowerCase().indexOf(value)) > -1);
			tblEl.style.display = (matched || (value == null) || (value == "")) ? "block" : "none";
			matchCount = (matched || (value == null) || (value == "")) ? (matchCount + 1) : matchCount;
		  }
		  var tblDiv = jQuery(selectTbl).children("span").get(0);	//No I18N
		  tblDiv = (tblDiv) ? tblDiv : document.createElement("span");
		  tblDiv.id = "SearchResults";
		  tblDiv.innerHTML = ZDBI18NMap.g("zrpt.common.toolbar.table.findnreplace.zdbalertmsg.js.findNReplaceFailedErr");
		  tblDiv.className = "noData";
		  tblDiv.style.display = "none";
		  selectTbl.appendChild(tblDiv);
		  var selectAllInpEl = $("RDBAddTblSelAll");
		  if(matchCount < 1)
		  {
			tblDiv.style.display = "block";
			selectAllInpEl.parentNode.style.display = "none";
		  }
		  else
		  {
			jQuery(tblDiv).remove();
			selectAllInpEl.parentNode.style.display = "";
		  }
		  return true;
		}
		
		this.showReMapDlg = function(el)
		{
		  var rowDiv = el.parentNode;
		  var mismatch = ZDBUtil.getAttribute(rowDiv,"mismatchtype");
		  rowDiv.className += " listviewsHover";	//No I18N
		  if(mismatch == "TABLE")
		  {
			var loadingDiv = rowDiv.loading.getElementsByTagName("span")[0];
		    RDBPage.getRemapTables(el,loadingDiv);
		  }
		  else if(mismatch == "COLUMN")
		  {
			var objid = ZDBUtil.getAttribute(rowDiv,"objid");
			var remoteTableName = ZDBUtil.getAttribute(rowDiv,"tablename");
			var loadingDiv = rowDiv.loading.getElementsByTagName("span")[0];
			var zTableName = ZDBUtil.getAttribute(rowDiv,"displayname");
			var ddltime = ZDBUtil.getAttribute(rowDiv,"ddltime");
			RDBPage.showReMapColumnDlg(rowDiv.colInfo,objid,zTableName,remoteTableName,ddltime,false,rowDiv);
		  }
		}
		
		this.showReMapTableDlg = function(response,requestOptions)
		{
		  var tablesList = [];
		  if(response instanceof Array)
		  {
			tablesList = RDBPage.remapTableList;
		  }
		  else
		  {
			var result = response.responseText;
			tablesList = JSON.parse(result);
			RDBPage.remapTableList = tablesList;
		  }
		  var el = requestOptions["SRCEL"];
		  var rowDiv = el.parentNode;
		  if(tablesList.length > 0)
	      {
		    if(!ZDBLazyLoadUtil.loadSnippet("ZRRDBRemapTable","/ZRRDBRemapTable.cc?",this,"APPENDTODOC"))
		    {
		      return;
		    }
			var rdbView = ZDBClientUI.dbConfig.rdbView;
			var remapDlgCont = $("ZRReMapTableDlgCont");
			remapDlgCont.rowDiv = rowDiv;
		    document.body.appendChild(remapDlgCont);
			$("ZRMismatchTblName").innerHTML = ZDBEscapeUtil.encodeForHtml(ZDBUtil.getAttribute(rowDiv,"displayname"));
			$("remaptable_objid").value = ZDBUtil.getAttribute(rowDiv,"objid");
			$("remaptable_ddltime").value = ZDBUtil.getAttribute(rowDiv,"ddltime");
			$("remaptable_name").value="";
		    var moreTablesEl = jQuery("#ZRMapLists");	//No I18N
		    moreTablesEl.empty();
		    for(var i=0; i<tablesList.length; i++)
		    {
		    	var tableListRowEl = jQuery("#RDBReMapTblSel").clone(true);	//No I18N
		    	tableListRowEl.removeAttr("id");	//No I18N
			   	var inputEl = tableListRowEl.children('input'); //NO I18N
		        inputEl.prop("checked",false);	//No I18N
		        inputEl.attr("value",tablesList[i]);
		        inputEl.get(0).style.verticalAlign = "middle";	//No I18N
			    inputEl.bind("click",function(){
//			    RDBPage.selectAllNewTables(this,false);
			        $("remaptable_name").value = this.value;
			        $("ZRReMapTableDlgCont").confirmRemap = false;
			    }); 
			    tableListRowEl.children("span").html(tablesList[i]);
			    moreTablesEl.append(tableListRowEl);
		    }
		    remapDlgCont.style.display = "block";
		    RDBPage.positionReMapDlg(remapDlgCont);
			var maxHeight = window.innerHeight - (ZDBUtil.getElementAbsoluteTop($("ZRMapLists").parentNode) + 
					ZDBUtil.getElementOuterHeight(remapDlgCont.dlgButtons) + ZDBUtil.getElementAbsoluteTop(remapDlgCont));
		    moreTablesEl.css('max-height',maxHeight+'px');	//No I18N
			jQuery(remapDlgCont).animate({right:0}, {duration:500});
			ZDBDialogUtil.freezeBackground(remapDlgCont);//No I18N
	      }
	      else
	      {
	    	  rowDiv.description.style.display = "none";
	    	  rowDiv.errMsg.style.display = "inline-block";
	    	  rowDiv.errMsg.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.notblremap");	//No I18N
	    	  rowDiv.errMsg.className = "slideError";
	    	  rowDiv.remap.style.display = "none";
	      }
		  
		  
		}
		
		this.showReMapColumnDlg = function(colInfo,objid,zTableName,rTableName,ddltime,fromTable,rowDiv)
		{
			if(!ZDBLazyLoadUtil.loadSnippet("ZRRDBRemapColumn","/ZRRDBRemapColumn.cc?",this,"APPENDTODOC"))
			{
			    return;
			}
			if(fromTable)
			{
				var remapDlgCont = $("ZRReMapTableDlgCont");
//				RDBPage.closeRemapDlg(remapDlgCont,true);
				$("ZRReMapColDlgCont").fromTable = fromTable;
			}
			else
			{
				$("ZRReMapColDlgCont").fromTable = false;
			}
		      var remapDlgCont = $("ZRReMapColDlgCont");
		      remapDlgCont.rowDiv = rowDiv;
		      document.body.appendChild(remapDlgCont);
		      var moreTablesEl = jQuery("#ZRMapColLists");	//No I18N
		      moreTablesEl.empty();
		      var rdbColRemap = new Array();
		      remapDlgCont.allColObj = rdbColRemap;
		      RDBPage.remapColList = [];
		      RDBPage.remapSelColList = [];
		      RDBPage.zcollist = [];
		      RDBPage.remapColListMenu = null;
		      for(var i=0; i<colInfo.length; i++)
		      {
		    	if(colInfo[i].newcol && !colInfo[i].zcolname && colInfo[i].mismatch)
		    	{
		    		var newZColName = colInfo[i].rcolname;
		    		var newZDatatype = RDBPage.jdbc_map[colInfo[i].rdatatype];
		    		var count = 1;
		    		var found = false;
					do
					{
						found = jQuery.inArray(newZColName, RDBPage.zcollist) > -1;
						newZColName = (found) ? colInfo[i].rcolname + "_" + count : newZColName;
						count++;
					}while(found);
					var newColObj = {"rcolname":colInfo[i].rcolname,"rdatatype":colInfo[i].rdatatype, "zcolname":newZColName,"zdatatype":newZDatatype,	//No I18N
							"newcol":true,"mismatch":true,"objid":objid,"desc":colInfo[i].desc};		//No I18N
					var remapColInfo = new ColRemap(newColObj);
		    		RDBPage.remapColList.push(remapColInfo);
		    	}
		    	else if(colInfo[i].mismatch)
		    	{
		    		var remapColInfo = new ColRemap(colInfo[i]);
			    	RDBPage.zcollist.push(colInfo[i].zcolname);
			    	rdbColRemap.push(remapColInfo);
			    	moreTablesEl.append(remapColInfo.rowEl);
		    	}
		      }
		      if(RDBPage.remapColList.length > 0)
		      {
		    	  var listDiv = $("RDBRemapColList");
		    	  jQuery(listDiv).find("ul").remove();		//No I18N
		    	  var ulEl = document.createElement("ul");
		    	  jQuery(ulEl).css({'max-height':"300px",overflow:"auto"});		//No I18N
		    	  var liEl = document.createElement("li");
		    	  liEl.menuEl = listDiv;
		    	  var aEl = document.createElement("a");
	    		  aEl.innerHTML = "--None--";	//No I18N
	    		  jQuery(liEl).on("click",function(){	//No I18N
	    			 RDBPage.selectNoneInRemap(this); 
	    		  });
	    		  liEl.appendChild(aEl);
	    		  ulEl.appendChild(liEl);
	    		  listDiv.appendChild(ulEl);
		    	  for(var k=0; k<RDBPage.remapColList.length; k++)
		    	  {
		    		  var colObj = RDBPage.remapColList[k];
		    		  RDBPage.addRDBColInMapList(listDiv,colObj.rcolname,colObj.rdatatype,colObj);
		    	  }
		    	  listDiv.appendChild(ulEl);
		    	  RDBPage.remapColListMenu = listDiv;
		    	  document.body.appendChild(listDiv);
		    	  $("ZRDBAddColumn").style.display = "";
		    	  $("ZRMapColLists").className = "";
		      }
		      else
		      {
		    	  $("ZRDBAddColumn").style.display = "none";
		    	  $("ZRMapColLists").className = "hideList";
		      }
			  $("ZRColMismatchTblName").innerHTML = ZDBEscapeUtil.encodeForHtml(zTableName);
			  $("remapcol_ddltime").value = ddltime;
			  $("remapcol_rtablename").value = rTableName;
			  $("remapcol_ztablename").value = zTableName;
			  $("remapcol_objid").value = objid;
			  $("ZRRemapColCloseBtn").style.display = (fromTable) ? "none" : "" ;	//No I18N
			  $("ZRRemapColOkBtn").style.display = (fromTable) ? "" : "none" ;
			  $("ZRRemapColRemapBtn").style.display = (fromTable) ? "none" : "" ;	//No I18N
			  $("ZRRemapBackBtn").style.display = (fromTable) ? "inline-block" : "none";	//No I18N
			  remapDlgCont.style.display = "block";
			  RDBPage.positionReMapDlg(remapDlgCont,true);
			  var maxHeight = window.innerHeight - (ZDBUtil.getElementAbsoluteTop($("ZRMapColLists").parentNode) + 
						ZDBUtil.getElementOuterHeight(remapDlgCont.dlgButtons) + ZDBUtil.getElementAbsoluteTop(remapDlgCont));
			    moreTablesEl.css('max-height',(maxHeight-jQuery($("ZRDBAddColumn")).outerHeight())+'px');	//No I18N
			    jQuery("#ZRMapColListsCont").css('max-height',maxHeight+'px');	//No I18N
			  jQuery(remapDlgCont).animate({right:0}, {duration:500});
			  if(!fromTable)
			  {
				  ZDBDialogUtil.freezeBackground(remapDlgCont);//No I18N  
			  }
		}
		
		this.addRDBColInMapList = function(menuEl,colName,datatype,obj)
		{
			var ulEl = jQuery(menuEl).find("ul").get(0);
			var liEl = document.createElement("li");
    		var spanEl = document.createElement("span");
    		var convertedDatatype = RDBPage.jdbc_map[datatype];
    		var rdtypeClass = RDBPage.datatypeIconClass[convertedDatatype];
    		spanEl.className = "dtypeIcon " + rdtypeClass;
    		var aEl = document.createElement("a");
    		aEl.innerHTML = ZDBEscapeUtil.encodeForHtml(colName);
    		spanEl.style.display = "inline-block";
    		aEl.style.display = "inline-block";
    		ZDBUtil.setAttribute(liEl,colName,"colname");
    		  ZDBUtil.setAttribute(liEl,convertedDatatype,"datatype");
    		  liEl.menuEl = menuEl;
    		  jQuery(liEl).on("click",function(){	//No I18N
    			  RDBPage.selectRDBColumnToRemap(this);
    		  });
    		  liEl.appendChild(spanEl);
    		  liEl.appendChild(aEl);
    		  liEl.obj = obj;
    		  obj.liEl = liEl;
    		  ulEl.appendChild(liEl);
		}
		
		this.positionReMapDlg = function(remapDlgCont,isColDlg)
		{
			ZDBUtil.setNamedChildEls(remapDlgCont,remapDlgCont,"elname");
                        var tabholder = ZDBGlobal.ISNEWLAYOUT ? jQuery("#ZRSTabHolder") : jQuery("#ZDBTabHolder"); //No I18N
			var offSetTop = tabholder.position().top;
			var elTop = offSetTop + tabholder.height();
			remapDlgCont.style.top = elTop + "px";
			var dlgHeight = (jQuery(window).height() - elTop);
			remapDlgCont.style.height = dlgHeight + "px";
			var remapDlg = remapDlgCont.remapDlg;
			ZDBUtil.setNamedChildEls(remapDlg,remapDlg,"elname");
			var dlgTitleBar = remapDlg.dlgTitleBar;
			var dlgBody = remapDlg.dlgBody;
			var dlgButtons = remapDlg.dlgButtons;
			ZDBUtil.setNamedChildEls(dlgBody,dlgBody,"elname");
			var mismatchNote = dlgBody.mismatchNote;
			var dlgTool = dlgBody.dlgTool;
			var listHeight = dlgHeight - (jQuery(dlgTitleBar).outerHeight() +
					jQuery(mismatchNote).outerHeight() +
					jQuery(dlgTool).outerHeight() + 
					jQuery(dlgButtons).outerHeight()); 
			var mapList = (isColDlg) ? "ZRMapColListsCont" : "ZRMapLists";		//No I18N
			$(mapList).style.height = listHeight + "px";
		}
		
		this.closeRemapDlg = function(el,isClose)
		{
			var dlgCont = ZDBUtil.getParentWithAttributeValue(el,"elname","remapDlgCont");		//No I18N
			if(isClose)
			{
				dlgCont.style.display = "none";
			}
			else
			{
				jQuery(dlgCont).animate({right:-700}, {duration:500,complete:function()
					{
						dlgCont.style.display = "none";
					}});	
			}
			if(!dlgCont.fromTable)
			{
				var rowDiv = dlgCont.rowDiv;
				rowDiv.className = "listviews";
				jQuery("div[class='freezeLayer']").remove();	//No I18N
			}
		}
		
		this.confirmTableRemap = function(el)
		{
			var allColObj = $("ZRReMapColDlgCont").allColObj;
			var ddltime = $("remapcol_ddltime").value;
			var rTableName = $("remapcol_rtablename").value;
			var objid = $("remapcol_objid").value;
			$("remaptable_objid").value = objid;
			$("remaptable_ddltime").value = ddltime;
			$("remaptable_name").value = rTableName;
			$("ZRReMapTableDlgCont").allColObj = allColObj;
			RDBPage.closeRemapDlg(el);
			$("ZRReMapTableDlgCont").confirmRemap = true;
		}
		
		this.validateTableRemap = function(el)
		{
			var rTableName = $("remaptable_name").value;
			if(!rTableName)
			{
				ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.databasedata.js.selecttblremap"),null,null);
				return;
			}
			var objid = $("remaptable_objid").value;
			var dbid = ZDBClientUI.dbId;
			var remapTableName = rTableName;
			var zTableName = $("ZRMismatchTblName").innerHTML;
			var ddltime = $("remaptable_ddltime").value;
			var params = "&DBID=" + dbid + "&OBJID=" + objid + "&RDBTABLENAME=" + encodeURIComponent(remapTableName);		//No I18N
			AjaxAPI.sendRequest({URL:"/RDBAction.ma?" + params + "&ZDBACTION=VALIDATETABLEREMAP",METHOD:"GET", //No I18N
				  OBJID:objid,RTABLENAME:remapTableName,ZTABLENAME:zTableName,DDLTIME:ddltime,
	              ONSUCCESSFUNC:RDBPage.handleTableValSuccess,
	              ONFAILUREFUNC:RDBPage.handleTableValFailure,
	              OPSTATUSID:$("RemapTableLoading")});//No I18N
		}
		
		this.handleTableValSuccess = function(response,requestOptions)
		{
			var result = response.responseText;
			var resultObj = JSON.parse(result);
			var ddltime = requestOptions["DDLTIME"];
			var confirmRemap = $("ZRReMapTableDlgCont").confirmRemap;
			var rdbView = ZDBClientUI.dbConfig.rdbView;
			if(resultObj.mismatchCount > 0 && !confirmRemap)
			{
//				rdbView.updateColInfoAfterTableVal(requestOptions["OBJID"],resultObj);
				RDBPage.showReMapColumnDlg(resultObj.colInfo,requestOptions["OBJID"],requestOptions["ZTABLENAME"],
											requestOptions["RTABLENAME"],ddltime,true);
			}
			else if(confirmRemap)
			{
				rdbView.updateColInfoAfterTableVal(requestOptions["OBJID"],resultObj);
				RDBPage.remapColumn(true);
			}
			else
			{
				var objId = requestOptions["OBJID"];
				var tableName = requestOptions["RTABLENAME"];
				RDBPage.remapTableList.splice(RDBPage.remapTableList.indexOf(tableName),1);
		        var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?"; //No I18N
		        var params = "&ZDBACTION=RENAMETABLEOBJECT&TABLENAME=" + encodeURIComponent(tableName) + "&OBJID=" + objId + "&DDLTIME=" + ddltime;//No I18N
		        AjaxAPI.sendRequest({URL:url,PARAMETERS:params,OBJID:objId,
		        					 ONSUCCESSFUNC:RDBPage.handleTableRemapSuccess,
		                             ONFAILUREFUNC:RDBPage.handleRenameFailure, //NO I18N
		                             OPSTATUSID:$("RemapTableLoading")});//No I18N
			}

		}
		
		this.handleTableValFailure = function(response,requestOptions)
		{
			var errMsg = response.getResponsePart("STATUS_MESSAGE");
			ZDBAlertAPI.showErrorMsg(errMsg,null,null);
		}
		
		this.handleTableRemapSuccess = function(response,requestOptions)
	    {
			var params = response.getResponseParams();
			RDBPage.closeRemapDlg($("ZRReMapTableDlgCont"));
			ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.databasedata.connname.js.tblremapsuccess")); //No I18N
			var rdbView = ZDBClientUI.dbConfig.rdbView;
			rdbView.deleteMismatchEntry(requestOptions["OBJID"]);
			RDBPage.showMismatchInfo();
			RDBPage.showMismatchInTab();
            RDBPage.showMismatchInExp(rdbView.mismatchCount);
	    }
		
		
		this.showRemapColList = function(el,event,fromAddCol)
		{
			if(RDBPage.remapColList.length <= 0)
			{
				return;
			}
			var menuEl = RDBPage.remapColListMenu;
			menuEl.fromAddCol = fromAddCol;
			menuEl.rowEl = (fromAddCol) ? null : ZDBUtil.getParentWithAttributeValue(el,"class","listviews");	//No I18N
			menuEl.obj = (fromAddCol) ? el.obj : menuEl.rowEl.obj;
			var firstChild = jQuery(menuEl).find("li:first-child").get(0);
			firstChild.style.display = (fromAddCol) ? "none" : "";
			if(!fromAddCol)
			{
				menuEl.rowEl.remapLink.className += " linkDropDown" ;	//No I18N
				menuEl.rowEl.className += " listviewsHover";	//No I18N
			}
			jQuery.each(jQuery(menuEl).children("span"),function(index,value){	//No I18N
				value.style.left = "20px";
				value.style.right = "";
			});
	        ZRSMenu.showMenu(event,el,menuEl,6,RDBPage.closeRemapColList);
		}
		
		this.closeRemapColList = function()
		{
			var menu = this;
			if(menu.rowEl)
			{
				menu.rowEl.className = "listviews";	//No I18N
				menu.rowEl.remapLink.className = "inlineLinkStyle";
			}
		}
		
		this.validateDatatypeChange = function(el)
		{
			var obj = el.obj;
			if(obj.reference)
			{
				var errMsg = ZDBI18NMap.f("zrpt.common.analysis.js.dataTypeChangeWithDepViewConfirm","Column",ZDBEscapeUtil.encodeForHtml(obj.zcolname),ZDBEscapeUtil.encodeForHtml(obj.zcolname));
				ZDBAlertAPI.showMsg(errMsg,"ZDBYESNO",{ONCLICK:RDBPage.confirmDatatypeChange,COLMODTYPE:RDBPage.COL_DATATYPE,OBJ:obj});    //No I18N
				return;
			}
			else
			{
				var reqOpt = {COLMODTYPE:RDBPage.COL_DATATYPE,OBJ:obj};
				RDBPage.confirmDatatypeChange("YES",reqOpt);	//No I18N
			}
		}
		
		this.confirmDatatypeChange = function(clickType, requestOptions)
		{
			var obj = requestOptions["OBJ"];
			if(clickType == "NO")
			{
				return;
			}
			else
			{
				obj.modified = true;
				obj.error = false;
				obj.colModType = RDBPage.COL_DATATYPE;
				obj.colRemapEl.style.display = "none";
				obj.linkedColEl.style.display = "inline-block";
				obj.rcolnameEl.innerHTML = obj.rcolname;
				var rdtypeClass = RDBPage.datatypeIconClass[obj.rdatatype];
				obj.rdatatypeEl.className = rdtypeClass;
				obj.zdatatypeEl.className = rdtypeClass;
				obj.convertDTypeLink.style.display = "none";
			}
		}
		
		this.convertToLookup = function(el)
		{
			var obj = el.obj;
			obj.modified = true;
			obj.error = false;
			obj.colModType = RDBPage.COL_CONVERT_REF;
			obj.colRemapEl.style.display = "none";
			obj.linkedColEl.style.display = "inline-block";
			obj.rcolnameEl.innerHTML = obj.rcolname;
			var rdtypeClass = RDBPage.datatypeIconClass[obj.rdatatype];
			obj.rdatatypeEl.className = rdtypeClass;
			obj.zdatatypeEl.className = rdtypeClass;
			obj.convertDTypeLink.style.display = "none";
		}
		
		this.removeLookup = function(el)
		{
			var obj = el.obj;
			var errMsg = ZDBI18NMap.f("zrpt.common.zdbalertmsg.js.removelookupcolumn",ZDBEscapeUtil.encodeForHtml(obj.zcolname));
			ZDBAlertAPI.showMsg(errMsg,"ZDBYESNO",{ONCLICK:RDBPage.confirmRemoveLookup,COLMODTYPE:RDBPage.COL_DATATYPE,OBJ:obj});    //No I18N
		}
		
		this.confirmRemoveLookup = function(clickType, requestOptions)
		{
			var obj = requestOptions["OBJ"];
			if(clickType == "NO")
			{
				return;
			}
			else
			{
				obj.modified = true;
				obj.error = false;
				obj.colModType = RDBPage.COL_REF_DEL;
				obj.colRemapEl.style.display = "none";
				obj.linkedColEl.style.display = "inline-block";
				obj.rcolnameEl.innerHTML = obj.rcolname;
				var rdtypeClass = RDBPage.datatypeIconClass[obj.rdatatype];
				obj.rdatatypeEl.className = rdtypeClass;
				obj.zdatatypeEl.className = rdtypeClass;
				obj.convertDTypeLink.style.display = "none";
			}
		}
		
		this.selectRDBColumnToRemap = function(el)
		{
			var menuEl = el.menuEl;
			var obj = menuEl.obj;
			var rdbView = ZDBClientUI.dbConfig.rdbView;
			var newColName = ZDBUtil.getAttribute(el,"colname");
			var newDatatype = ZDBUtil.getAttribute(el,"datatype");
			if(menuEl.fromAddCol) 
			{
				RDBPage.addNewRDBColumns(el,newColName,newDatatype);
				return;
			}
			if(obj.zdatatype != newDatatype)
			{
				ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.databasedata.connname.js.dtypevalidate"));	//No I18N
			}
			else
			{
				obj.errMsg.style.display = "none";
				obj.newcolnameEl.style.display = "inline-block";
				obj.newdatatypeEl.style.display = "inline-block";
				obj.newcolnameEl.innerHTML = ZDBEscapeUtil.encodeForHtml(newColName);
	    		var newDtypeClass = RDBPage.datatypeIconClass[newDatatype];
				obj.newdatatypeEl.className = newDtypeClass;
				obj.newcolname = newColName;
				obj.newdatatype = newDatatype;
				obj.rcolname = newColName;
				obj.rdatatype = newDatatype;
				obj.modified = true;
				obj.error = false;
				obj.colModType = RDBPage.COL_REMAP;
				jQuery(obj.liEl).show();
				obj.liEl = el;
				RDBPage.remapColList.splice(RDBPage.remapColList.indexOf(obj),1);
				RDBPage.remapSelColList.push(obj);
				jQuery(el).hide();
			}
			if(RDBPage.remapColList.length > 0)
			{
				$("ZRMapColLists").className = "";	
				$("ZRDBAddColumn").style.display = "";
			}
			else
			{
				$("ZRMapColLists").className = "hideList";	
				$("ZRDBAddColumn").style.display = "none";
			}
		}
		
		this.selectNoneInRemap = function(el)
		{
			var menuEl = el.menuEl;
			var obj = menuEl.obj;
			var rdbView = ZDBClientUI.dbConfig.rdbView;
			if(obj.modified == true)
			{
				obj.errMsg.style.display = "inline-block";
				obj.newcolnameEl.style.display = "none";
				obj.newdatatypeEl.style.display = "none";
				jQuery(obj.liEl).show();
				RDBPage.remapColList.push(obj);
				RDBPage.remapSelColList.splice(RDBPage.remapSelColList.indexOf(obj),1);
			}
			obj.modified = false;
			obj.error = true;
			if(RDBPage.remapColList.length > 0)
			{
				$("ZRMapColLists").className = "";	
				$("ZRDBAddColumn").style.display = "";
			}
			else
			{
				$("ZRMapColLists").className = "hideList";	
				$("ZRDBAddColumn").style.display = "none";
			}
		}
		
		this.addNewRDBColumns = function(el,colName,datatype)
		{
			var menuEl = RDBPage.remapColListMenu;
			var remapColInfo = el.obj;
			remapColInfo.colModType = RDBPage.COL_ADD;
			remapColInfo.modified = true;
	    	RDBPage.zcollist.push(remapColInfo.zcolname);
	    	$("ZRReMapColDlgCont").allColObj.push(remapColInfo);
	    	jQuery("#ZRMapColLists").append(remapColInfo.rowEl);		//No I18N
	    	jQuery(el).hide();
	    	RDBPage.remapColList.splice(RDBPage.remapColList.indexOf(remapColInfo),1);
	    	RDBPage.remapSelColList.push(remapColInfo);
	    	if(RDBPage.remapColList.length > 0)
			{
				$("ZRMapColLists").className = "";	
				$("ZRDBAddColumn").style.display = "";
			}
			else
			{
				$("ZRMapColLists").className = "hideList";	
				$("ZRDBAddColumn").style.display = "none";
			}
	    	
		}
		
		this.deleteRDBColumn = function(el,obj)
		{
			if(obj.newcol || obj.colModType == RDBPage.COL_REMAP)
			{
				obj.colModType = null;
				obj.modified = false;
				RDBPage.zcollist.splice(RDBPage.zcollist.indexOf(obj.zcolname),1);
				$("ZRReMapColDlgCont").allColObj.splice($("ZRReMapColDlgCont").allColObj.indexOf(obj),1);
				obj.rowEl.parentNode.removeChild(obj.rowEl);
		    	jQuery(obj.liEl).show();
		    	RDBPage.remapColList.push(obj);
		    	RDBPage.remapSelColList.splice(RDBPage.remapSelColList.indexOf(obj),1);
		    	if(RDBPage.remapColList.length > 0)
				{
					$("ZRMapColLists").className = "";	
					$("ZRDBAddColumn").style.display = "";
				}
				else
				{
					$("ZRMapColLists").className = "hideList";	
					$("ZRDBAddColumn").style.display = "none";
				}
			}
			else
			{
				var errMsg = (obj.reference) ? ZDBI18NMap.f("zrpt.common.analysis.js.delTblWithDepViewConfirm","column") :
					ZDBI18NMap.f("zrpt.common.toolbar.table.zdbalertmsg.js.delColConfirm",ZDBEscapeUtil.encodeForHtml(obj.zcolname));
				ZDBAlertAPI.showMsg(errMsg,"ZDBYESNO",{ONCLICK:RDBPage.confirmDelete,OBJ:obj,COLMODTYPE:RDBPage.COL_DEL});    //No I18N
			}
		}
		
		this.confirmDelete = function(clickType, requestOptions)
		{
			var obj = requestOptions["OBJ"];
			if(clickType == "NO")
			{
				obj.delDepViews = false;
				return;
			}
			obj.rdatatype = obj.zdatatype;
			obj.rowEl.parentNode.removeChild(obj.rowEl);
//			RDBPage.remapSelColList.splice(RDBPage.remapSelColList.indexOf(obj),1);
			RDBPage.zcollist.splice(RDBPage.zcollist.indexOf(obj.zcolname),1);
//			RDBPage.remapColList.push(obj);
			jQuery(obj.liEl).show();
			if(RDBPage.remapColList.length > 0)
			{
				$("ZRMapColLists").className = "";	
				$("ZRDBAddColumn").style.display = "";
			}
			else
			{
				$("ZRMapColLists").className = "hideList";	
				$("ZRDBAddColumn").style.display = "none";
			}
			obj.delDepViews = true;
			obj.error = false;
			obj.modified = true;
			obj.colModType = requestOptions["COLMODTYPE"];
		}
		
		this.remapColumn = function(fromTable)
		{
//		  var fromTable = $("ZRReMapTableDlgCont").fromTable;
		  fromTable = (fromTable) ? true : false;
		  var allColObj = (fromTable) ? $("ZRReMapTableDlgCont").allColObj : $("ZRReMapColDlgCont").allColObj;
		  var ddltime = (fromTable) ? $("remaptable_ddltime").value : $("remapcol_ddltime").value;
		  var rTableName = (fromTable) ? $("remaptable_name").value : $("remapcol_rtablename").value;
		  var objid = (fromTable) ? $("remaptable_objid").value : $("remapcol_objid").value;
//			var hasError = false;
			var paramObj = [];
			for(var i=0; i<allColObj.length; i++)
			{
				var obj = allColObj[i];
//				hasError = obj.error;
				if(obj.modified)
				{
					var colObj = {"COLID":obj.colId,"ZCOLNAME":obj.zcolname,"RCOLNAME":obj.rcolname,	//No I18N
									"OBJID":obj.objId,"DDLTIME":ddltime,"DATATYPE":obj.rdatatype,	//No I18N
									"COLMODTYPE":obj.colModType,"REFERREDCOL":obj.referredcol};	//No I18N
					paramObj.push(colObj);
				}
			}
//			if(hasError)
//			{
//				ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.home.import.js.remapColErr"));	//No I18N
//			}
//			else
//			{
				//submit remap column dialog
				AjaxAPI.sendRequest({URL:"/RDBAction.ma?",
					PARAMETERS:"COLINFO=" + encodeURIComponent(JSON.stringify(paramObj)) + 	//No I18N
					"&ZDBACTION=REMAPCOLUMNS&DBID=" + ZDBClientUI.dbId +	//No I18N
					"&RTABLENAME=" + encodeURIComponent(rTableName) + "&OBJID=" + objid + "&RENAMETABLEOBJECT=" + fromTable, //No I18N
					OBJID:objid,FROMTABLE:fromTable,ALLCOLOBJS:allColObj,RTABLENAME:rTableName,
		              ONSUCCESSFUNC:RDBPage.handleValidateChildColumnSuccess,
		              ONFAILUREFUNC:RDBPage.handleColumnRemapFailure,
		              OPSTATUSID:$("RemapColumnLoading")});//No I18N
//			}
		}
		
		
		this.handleValidateChildColumnSuccess = function(response,requestOptions)
		{
			var resultObj = JSON.parse(response.responseText);
			var fromTable = requestOptions["FROMTABLE"];
			var rTableName = requestOptions["RTABLENAME"];
			var dlg = fromTable ? $("ZRReMapTableDlgCont") : $("ZRReMapColDlgCont");
			RDBPage.closeRemapDlg(dlg);
			if(fromTable)
			{
				RDBPage.remapTableList.splice(RDBPage.remapTableList.indexOf(rTableName),1);
				ZDBUtil.setAttribute(dlg.rowDiv,rTableName,"tablename");
			}
//			ZDBMsgBox.showSuccess("Columns remapped successfully."); //No I18N
			var rdbView = ZDBClientUI.dbConfig.rdbView;
//			rdbView.deleteMismatchEntry(requestOptions["OBJID"]);
			rdbView.updateColInfo(requestOptions["OBJID"],requestOptions["ALLCOLOBJS"]);
			RDBPage.showMismatchInfo();
			RDBPage.showMismatchInTab();
			RDBPage.showMismatchInExp(rdbView.mismatchCount);
		}
		
		this.handleColumnRemapFailure = function()
		{
			
		}
		
};

function ColRemap(colInfo)
{
  this.colId = colInfo.colid;
  this.objId = colInfo.objid;
  this.rcolname = colInfo.rcolname;
  this.zcolname = colInfo.zcolname;
  this.mismatch = colInfo.mismatch;
  this.newcol = colInfo.newcol;
  this.desc = colInfo.desc;
  this.rdatatype = colInfo.rdatatype;
  this.zdatatype = colInfo.zdatatype;
  this.reference = colInfo.reference;
  this.referredcol = colInfo.referredcol;
  this.lookuptable = colInfo.lookuptable;
  this.lookupcolumn = colInfo.lookupcolumn;
  var rowObj = jQuery("#RDBReMapColSel").clone(true);	//No I18N
  rowObj.removeAttr("id");	//No I18N
  var rowEl = rowObj.get(0);
  rowEl.obj = this;
  this.rowEl = rowEl;
  ZDBUtil.setNamedChildEls(this.rowEl,this.rowEl,"name");
  this.zdatatypeEl = rowEl.zdatatype;
  this.zcolnameEl = rowEl.zcolname;
  this.colRemapEl = rowEl.colRemap;
  ZDBUtil.setNamedChildEls(this.colRemapEl,this.colRemapEl,"name");
  this.errMsg = this.colRemapEl.errMsg;
  this.newcolnameEl = this.colRemapEl.newcolname;
  this.newdatatypeEl = this.colRemapEl.newdatatype;
  this.remapLink = this.colRemapEl.remapLink;
  this.remapLink.obj = this;
  this.convertDTypeLink = this.colRemapEl.convertDTypeLink;
  this.convertDTypeLink.obj = this;
  this.deleteRColLink = this.colRemapEl.deleteRColLink;
  this.linkedColEl =  rowEl.linkedCol;
  ZDBUtil.setNamedChildEls(this.linkedColEl,this.linkedColEl,"name");
  this.rdatatypeEl = this.linkedColEl.rdatatype;
  this.rcolnameEl = this.linkedColEl.rcolname;
  this.deleteZColLink = this.linkedColEl.deleteZColLink;
  this.modified = false;
  this.init();
}

ColRemap.prototype.init = function()
{
	this.zcolnameEl.innerHTML = ZDBEscapeUtil.encodeForHtml(this.zcolname);
	var zdtypeClass = RDBPage.datatypeIconClass[this.zdatatype];
	this.zdatatypeEl.className = zdtypeClass;
	var colRemapObj = this;
	  if(this.zcolname && !this.mismatch)
	  {
		  this.colRemapEl.style.display = "none";
		  this.linkedColEl.style.display = "inline-block";
		  this.rcolnameEl.innerHTML = ZDBEscapeUtil.encodeForHtml(this.rcolname);
		  var rdtypeClass = RDBPage.datatypeIconClass[this.rdatatype];
		  this.rdatatypeEl.className = rdtypeClass;
		  jQuery(this.deleteZColLink).on("click",function(){	//No I18N
			  RDBPage.deleteRDBColumn(this,colRemapObj);
		  });
		  this.error = false;
	  }
	  else
	  {
		  this.colRemapEl.style.display = "inline-block";
		  this.linkedColEl.style.display = "none";
		  this.error = true;
		  if(this.desc == 1)
		  {
			  this.errMsg.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.colnotexist");	//No I18N
			  this.convertDTypeLink.style.display = "none";	//No I18N
			  jQuery(this.remapLink).on("click",function(event){	//No I18N
				  RDBPage.showRemapColList(this,event);
			  });
		  }
		  else if(this.desc == 2)
		  {
			  this.errMsg.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.dtypemismatch");	//No I18N
			  this.remapLink.style.display = "none";	//No I18N
			  jQuery(this.convertDTypeLink).on("click",function(){	//No I18N
				  RDBPage.validateDatatypeChange(this);
			  });
		  }
		  else if(this.desc == 3 && !this.newcol)
		  {
			  var zcolname = this.zcolname;
			  var errMsg = ZDBI18NMap.g("zrpt.databasedata.connname.js.newlookup");
			  if(this.lookuptable)
			  {
				  var lookuptable = this.lookuptable;
				  var errMsg = ZDBI18NMap.f("zrpt.databasedata.connname.js.lookuptable",zcolname,lookuptable);
			  }
			  else if(this.lookupcolumn)
			  {
				  var lookupcolumn = this.lookupcolumn;
				  var errMsg = ZDBI18NMap.f("zrpt.databasedata.connname.js.lookupcolumn",zcolname,lookupcolumn);
			  }
			  this.errMsg.innerHTML = errMsg;
			  this.convertDTypeLink.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.convert");	//No I18N
			  jQuery(this.convertDTypeLink).on("click",function(){	//No I18N
				  RDBPage.convertToLookup(this);
			  });
		  }
		  else if(this.desc == 4)
		  {
			  this.errMsg.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.removelookup");		//No I18N
			  this.convertDTypeLink.innerHTML = ZDBI18NMap.g("zrpt.databasedata.connname.js.convert");	//No I18N
			  jQuery(this.convertDTypeLink).on("click",function(){	//No I18N
				  RDBPage.removeLookup(this);
			  });
		  }
		  else if(this.desc == 5)
		  {
			  var zcolname = this.zcolname;
			  var errMsg = null;
			  if(this.lookuptable)
			  {
				  var lookuptable = this.lookuptable;
				  var errMsg = ZDBI18NMap.f("zrpt.databasedata.connname.js.lookuptable",zcolname,lookuptable);
			  }
			  if(this.lookupcolumn)
			  {
				  var lookupcolumn = this.lookupcolumn;
				  var errMsg = ZDBI18NMap.f("zrpt.databasedata.connname.js.lookupcolumn",zcolname,lookupcolumn);
			  }
			  this.errMsg.innerHTML = errMsg;
			  this.convertDTypeLink.style.display = "none";
		  }
		  else if(this.newcol == true)
		  {
			  this.errMsg.style.display = "none";
			  this.remapLink.style.display = "none";
			  this.convertDTypeLink.style.display = "none";
			  this.newcolnameEl.style.display = "inline-block";
			  this.newdatatypeEl.style.display = "inline-block";
			  this.newcolnameEl.innerHTML = ZDBEscapeUtil.encodeForHtml(this.rcolname);
	    	  var newDtypeClass = RDBPage.datatypeIconClass[RDBPage.jdbc_map[this.rdatatype]];
	    	  this.newdatatypeEl.className = newDtypeClass;
	    	  this.newcolname = this.rcolname;
	    	  this.newdatatype = this.rdatatype;
	    	  this.modified = true;
	    	  this.error = false;
		  }
		  jQuery(this.deleteRColLink).on("click",function(){	//No I18N
			  RDBPage.deleteRDBColumn(this,colRemapObj);
		  });
	  }  
	  
}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["RDBPage.showCreateRDB"]=RDBPage.showCreateRDB
