//$Id$
//ignorei18n_start
var DBUsersSettingsComponent = React.createClass({
	displayName: "DBUsersSettingsComponent",

	getDefaultProps: function () {
		return {
			APIURL: "/reportsapi/db/" + ZDBClientUI.dbId
		};
	},
	getInitialState: function () {
		return {
			emailListingLimit: 100
		};
	},
	componentWillMount: function () {
		this.generateUserToDomainMap();
		ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare");
	},
	componentDidUpdate: function () {
		this.generateUserToDomainMap();
	},
	componentWillUnmount: function () {
		this.zaidVsDomain = null;
	},
	generateUserToDomainMap: function () {
		var jsonInfo = this.props.jsonInfo;
		var keys = jsonInfo.keys;
		this.userToTypeNIndex = {};
		this.mapUsers(jsonInfo.admin, keys, "admin");
		this.mapUsers(jsonInfo.users, keys, "users");
		this.mapUsers(jsonInfo.dbOwners, keys, "dbOwners");
	},
	mapUsers: function (userArray, arrayKey, userRole) {
		if (userArray && userArray.length > 0) {
			for (var i = 0, len = userArray.length; i < len; i++) {
				var curUser = userArray[i];
				this.userToTypeNIndex[curUser[arrayKey.Email] + "###" + curUser[arrayKey.ZaId]] = [i, userRole, curUser[arrayKey.Status], curUser[arrayKey.ZaId], curUser[arrayKey.Email]];
			}
		}
	},
	modifyJsonForActivateNDeactivateUsers: function (response, requestOptions, action) {
		this.props.enableHolder(requestOptions.DOMNODE);
		var emails = requestOptions.EMAILS;
		var jsonInfo = this.props.jsonInfo;
		var keys = jsonInfo.keys;
		var userAction = requestOptions.USERACTION;
		var i, len;
		for (i = 0, len = emails.length; i < len; i++) {
			// var userDets = emails[i].split("###");
			// var email = userDets[0];
			// var zuID = userDets[1];
			var userInfo = this.userToTypeNIndex[emails[i]];
			var userIndexInJson = userInfo[0];
			var userRole = userInfo[1];
			jsonInfo[userRole][userIndexInJson][keys.Status] = action;
		}
		this.refs.selectAllCheckbox.checked = false;
		var inputs = this.refs.usersList.querySelectorAll("input:checked");
		for (i = 0, len = inputs.length; i < len; i++) {
			inputs[i].checked = false;
		}
		ZDBMsgBox.showSuccess(ZDBI18NMap.f("zrpt.dbsettings.users.js.actionsuccess", userAction && userAction === "activate" ? ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.activated") : ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.deactivated")));
		delete ZRDBSettings.jsonInfoMap[ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage")];
		this.hideAllActionButtons();
		this.props.rerenderComp(jsonInfo);
	},
	activateDBUsers: function (emails, actualEmails) {
		this.updateActionBtns();
		var domNode = this.props.disableHolder();
		//		AjaxAPI.sendRequest({URL: this.props.APIURL +"/ACTIVATEDBUSER",
		//				PARAMETERS:"ZOHO_EMAILS=" + encodeURIComponent(emails),
		//		 		ONSUCCESSFUNC:this.handleActivateDBSuccess,
		//				ONFAILUREFUNC:this.handleActivateDBFailure,
		//				DOMNODE:domNode,
		//				EMAILS:actualEmails,
		//				USERACTION:"activate",
		//				OPSTATUSID:"ZDBMainLoader"});
		ZRSAjax.post(this.props.APIURL + '/ACTIVATEDBUSER', 'ZOHO_EMAILS=' + encodeURIComponent(emails), {
			successHandler: {
				func: this.handleActivateDBSuccess,
				ctx: this
			},
			failureHandler: {
				func: this.handleActivateDBFailure,
				ctx: this
			},
			errorHandler: {
				func: this.handleActivateDBFailure,
				ctx: this
			},
			DOMNODE: domNode,
			EMAILS: actualEmails,
			USERACTION: 'activate'
		});
	},
	handleActivateDBSuccess: function (response, requestOptions) {
		this.modifyJsonForActivateNDeactivateUsers(response, requestOptions, true);
	},
	handleActivateDBFailure: function (response, requestOptions) {
		//Need to handle failure cases
		this.props.enableHolder(requestOptions.DOMNODE);
		this.hideAllActionButtons();
		this.commonErrorHandler(["7301", "7309", "7340", "7339", "7345", "7346", "7347"], ["SECURITY_NOT_PERMITTED", "SECURITY_NEEDS_LOGIN", "USER_INACTIVE_IN_ACCOUNT", "DB_USER_LIMIT_EXCEED", "DB_USER_LIMIT_EXCEED_DOMAIN", "ACTION_CAN_NOT_PREFORM", "USER_INACTIVE_IN_ACCOUNT_DOMAIN"], response);
	},
	deactivateDBUser: function (emails, actualEmails) {
		this.updateActionBtns();
		var domNode = this.props.disableHolder();
		//		AjaxAPI.sendRequest({URL: this.props.APIURL +"/DEACTIVATEDBUSER",
		//				PARAMETERS:"ZOHO_EMAILS=" + encodeURIComponent(emails),
		//		 		ONSUCCESSFUNC:this.handleDeActivateDBSuccess,
		//				ONFAILUREFUNC:this.handleDeActivateDBFailure,
		//				DOMNODE:domNode,
		//				EMAILS:actualEmails,
		//				USERACTION:"deActivate",
		//				OPSTATUSID:"ZDBMainLoader"});

		ZRSAjax.post(this.props.APIURL + '/DEACTIVATEDBUSER', 'ZOHO_EMAILS=' + encodeURIComponent(emails), {
			successHandler: {
				func: this.handleDeActivateDBSuccess,
				ctx: this
			},
			failureHandler: {
				func: this.handleDeActivateDBFailure,
				ctx: this
			},
			errorHandler: {
				func: this.handleDeActivateDBFailure,
				ctx: this
			},
			DOMNODE: domNode,
			EMAILS: actualEmails,
			USERACTION: 'deActivate'
		});
	},
	handleDeActivateDBSuccess: function (response, requestOptions) {
		this.modifyJsonForActivateNDeactivateUsers(response, requestOptions, false);
	},
	handleDeActivateDBFailure: function (response, requestOptions) {
		//Need to handle failure cases
		this.props.enableHolder(requestOptions.DOMNODE);
		this.hideAllActionButtons();
		this.commonErrorHandler(["7301", "7309", "7346"], ["SECURITY_NOT_PERMITTED", "SECURITY_NEEDS_LOGIN", "ACTION_CAN_NOT_PREFORM"], response);
	},
	commonErrorHandler: function (knownErrorNumCodes, knownErrorCodes, response) {
		var errorNumCode = response.data.errorNumCode.toString();
		var errorCode = response.data.errorName.toString();
		var errorMsg = response.message;
		if (knownErrorNumCodes.indexOf(errorNumCode) > -1 && knownErrorCodes.indexOf(errorCode) > -1) {
			ZDBMsgBox.showError(errorMsg);
		} else {
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.js.commonfailure"));
		}
	},
	getEmailStringFromArray: function (emailArray) {
		var jsonInfo = this.props.jsonInfo;
		var isClientPortalDBOwner = jsonInfo.isClientPortalDBOwner;
		// var domainAlreadyAdded = false;
		var tempEmailArr = [];
		var tempZuidArr = [];
		for (var i = 0, len = emailArray.length; i < len; i++) {
			var email, tempEmail;
			email = tempEmail = emailArray[i];
			// if(email.indexOf("###") > 0){
			var temp = email.split("###");
			tempEmail = temp[0];
			tempEmailArr.push(tempEmail);
			tempZuidArr.push(temp[1]);
			// domainAlreadyAdded = true;
			// }
			if (!ZDBGlobal.emailRegex.test(tempEmail)) {
				ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.invalid_email_ids"));
				throw new Error("Invalid email ID provided by " + ZDBGlobal.zuID);
			}
		}
		// if(!isClientPortalDBOwner || domainAlreadyAdded){
		if (!isClientPortalDBOwner) {
			return tempEmailArr.join(",");
		}
		var returnText = '';
		for (i = 0, len = emailArray.length; i < len; i++) {
			// var domainID = this.userToDomainMap[email];
			// domainID = (domainID)?domainID:jsonInfo.zaId;
			// var email = emailArray[i];
			returnText += emailArray[i] + ",";
		}
		returnText = returnText.substring(0, returnText.length - 1);
		return returnText;
	},
	activateOrDeactivateSingleUser: function (event) {
		var dataElement = ZDBUtil.getParentWithAttr(event.target, "data-email");
		var email = dataElement && dataElement.getAttribute("data-email");
		var action = dataElement && dataElement.getAttribute("data-action");
		// var emailInfo = this.userToTypeNIndex[email];
		var parentTarget = DOMUtils.getElOrParentWithAttr(event.target, "data-zuid");
		var userRole = parentTarget.getAttribute("data-role");
		var userZuid = parentTarget.getAttribute("data-zuid");
		this.refs.selectAllCheckbox.checked = false;
		var inputs = this.refs.usersList.querySelectorAll("input:checked");
		for (var i = 0, len = inputs.length; i < len; i++) {
			inputs[i].checked = false;
			var parent = DOMUtils.getElOrParentWithAttr(inputs[i], "data-role");
			parent.style.backgroundColor = '';
		}
		if (userRole == ZDBI18NMap.g("zrpt.common.js.admin")) {
			this.updateActionBtns();
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.users.js.admindeactivate"));
			return;
		} else if (userRole == ZDBI18NMap.g("zrpt.common.js.dbowner")) {
			var currentUser = this.userToTypeNIndex[ZDBGlobal.emailID + "###" + userZuid];
			if (currentUser && currentUser[1] == "dbOwners") {
				ZDBMsgBox.showError(ZDBI18NMap.f("zrpt.dbresource.js.actioncannotperform", action == "activate" ? ZDBI18NMap.g("zrpt.dbsettings.users.js.activate") : ZDBI18NMap.g("zrpt.dbsettings.users.js.deactivate"), ZDBI18NMap.g("zrpt.common.js.dbowner")));
				return;
			}
		}
		var temp = this.getEmailStringFromArray([email + "###" + userZuid]);
		return action && action == "activate" ? this.activateDBUsers(temp, [email + "###" + userZuid]) : this.deactivateDBUser(temp, [email + "###" + userZuid]);
	},
	activateOrDeactivateMultipleUsers: function (event) {
		var target = event.target;
		var action = target.getAttribute("data-action");
		var usersList = this.refs.usersList;
		var inputs = usersList.querySelectorAll("input:checked");
		this.refs.selectAllCheckbox.checked = false;
		if (inputs.length > 0) {
			var emailsArr = [];
			for (var i = 0, len = inputs.length; i < len; i++) {
				var input = inputs[i];
				var email = input.getAttribute("data-email");
				var parentTarget = DOMUtils.getElOrParentWithAttr(input, "data-zuid");
				var userZuid = parentTarget.getAttribute("data-zuid");
				parentTarget.style.backgroundColor = '';
				input.checked = false;
				emailsArr.push(email + "###" + userZuid);
			}
			emailsArr = this.validateMultipleSelectedAction(emailsArr, action);
			if (emailsArr.length > 0) {
				//has atleast one deactivated or activated users for converse requests
				var temp = this.getEmailStringFromArray(emailsArr);
				return action && action == "activate" ? this.activateDBUsers(temp, emailsArr) : this.deactivateDBUser(temp, emailsArr);
			} else {
				//selected already activated or already deactivated users for converse requests
				ZDBMsgBox.showError(ZDBI18NMap.f("zrpt.common.pricing.manageusr.js.usr_already_exist", action == "activate" ? ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.activated") : ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.deactivated")));
			}
		} else {
			//Need to handle empty request action.
			ZDBMsgBox.showError(ZDBI18NMap.f("zrpt.dbsettings.users.js.selectoneuser", action == "activate" ? ZDBI18NMap.g("zrpt.dbsettings.users.js.activate") : ZDBI18NMap.g("zrpt.dbsettings.users.js.deactivate")));
		}
	},
	validateMultipleSelectedAction: function (emailsArr, action) {
		var jsonInfo = this.props.jsonInfo;
		var keys = jsonInfo.keys;
		var i,
		    len,
		    resultantEmails = [];
		for (i = 0, len = emailsArr.length; i < len; i++) {
			var curEmail = emailsArr[i];
			var userInfo = this.userToTypeNIndex[curEmail];
			var userIndex = userInfo[0];
			var userRole = userInfo[1];
			var curEmailJson = jsonInfo[userRole][userIndex];
			var condition = action == "activate" ? !curEmailJson[keys.Status] : curEmailJson[keys.Status];
			if (condition) resultantEmails.push(curEmail);
		}
		return resultantEmails;
	},
	setSearchState: function (event) {
		var target = event.target;
		var value = target.value;
		this.setState({
			searchStr: value
		});
	},
	clearSearchState: function (event) {
		this.setState({
			searchStr: ""
		});
	},
	updateActionBtns: function (event) {
		var selectedInputs = this.refs.usersList.querySelectorAll("input:checked");
		var activeUserSelected = false,
		    deactiveUserSelected = false;
		for (var i = 0, len = selectedInputs.length; i < len; i++) {
			var curInput = selectedInputs[i];
			var curEmail = curInput.getAttribute("data-email");
			var parentTarget = DOMUtils.getElOrParentWithAttr(curInput, "data-zuid");
			var userZuid = parentTarget.getAttribute("data-zuid");
			var status = this.userToTypeNIndex[curEmail + "###" + userZuid][2];
			if (status) activeUserSelected = true;else deactiveUserSelected = true;
		}
		if (selectedInputs.length) {
			this.refs.deleteBtn.refs.BASEINPUTCOMPONENT.style.display = "";
			this.refs.deactivateBtn.refs.BASEINPUTCOMPONENT.style.display = activeUserSelected ? "" : "none";
			this.refs.activateBtn.refs.BASEINPUTCOMPONENT.style.display = deactiveUserSelected ? "" : "none";
		} else {
			this.refs.deleteBtn.refs.BASEINPUTCOMPONENT.style.display = "none";
			this.refs.deactivateBtn.refs.BASEINPUTCOMPONENT.style.display = "none";
			this.refs.activateBtn.refs.BASEINPUTCOMPONENT.style.display = "none";
		}
	},
	checkBoxChange: function (event) {
		this.updateActionBtns(event);
		var inputLen = this.refs.usersList.querySelectorAll("input[type=checkbox]").length;
		var checkedInputLen = this.refs.usersList.querySelectorAll("input:checked").length;
		if (inputLen == checkedInputLen) {
			this.refs.selectAllCheckbox.checked = true;
		} else {
			this.refs.selectAllCheckbox.checked = false;
		}
		var target = event.target;
		var parent = DOMUtils.getElOrParentWithAttr(target, "data-role");
		parent.style.backgroundColor = target.checked ? "#efefee" : '';
	},

	selectAllCheckboxChange: function (event) {
		var checked = event.target.checked;
		var inputs = this.refs.usersList.querySelectorAll("input[type=checkbox]");
		var input, parent;
		for (var i = 0, len = inputs.length; i < len; i++) {
			input = inputs[i];
			parent = DOMUtils.getElOrParentWithAttr(input, "data-role");
			input.checked = checked;
			parent.style.backgroundColor = checked ? "#efefee" : '';
		}
		this.updateActionBtns(event);
	},

	deleteUsers: function (event) {
		var usersList = this.refs.usersList;
		var inputs = usersList.querySelectorAll("input:checked");
		if (inputs.length > 0) {
			var emailsArr = [];
			for (var i = 0, len = inputs.length; i < len; i++) {
				var input = inputs[i];
				var parentTarget = DOMUtils.getElOrParentWithAttr(input, "data-zuid");
				var userZuid = parentTarget.getAttribute("data-zuid");
				var email = input.getAttribute("data-email");
				emailsArr.push(email + "###" + userZuid);
			}
			var temp = this.getEmailStringFromArray(emailsArr);
			var domNode = this.props.disableHolder();
			//			AjaxAPI.sendRequest({URL: this.props.APIURL +"/DELETEDBUSER",
			//				PARAMETERS:"ZOHO_EMAILS=" + encodeURIComponent(temp),
			//		 		ONSUCCESSFUNC:this.handleDeleteUserSuccess,
			//				ONFAILUREFUNC:this.handleDeleteUserFailure,
			//				DOMNODE:domNode,
			//				EMAILS:emailsArr,
			//				OPSTATUSID:"ZDBMainLoader"});
			ZRSAjax.post(this.props.APIURL + '/DELETEDBUSER', 'ZOHO_EMAILS=' + encodeURIComponent(temp), {
				successHandler: {
					func: this.handleDeleteUserSuccess,
					ctx: this
				},
				failureHandler: {
					func: this.handleDeleteUserFailure,
					ctx: this
				},
				DOMNODE: domNode,
				EMAILS: emailsArr
			});
		} else {
			//empty selection alert the user
			ZDBMsgBox.showError(ZDBI18NMap.f("zrpt.dbsettings.users.js.selectoneuser", ZDBI18NMap.g("zrpt.common.emailsch.js.delete")));
		}
	},

	handleDeleteUserSuccess: function (response, requestOptions) {
		this.props.enableHolder(requestOptions.DOMNODE);
		var newJSONInfo = {};
		var oldJSONInfo = this.props.jsonInfo;
		var deletedEmails = requestOptions.EMAILS;
		var i, len;
		var userToTypeNIndex = this.userToTypeNIndex;
		for (i = 0, len = deletedEmails.length; i < len; i++) {
			var curEmail = deletedEmails[i];
			var curEmailInfo = userToTypeNIndex[curEmail];
			var curEmailUserType = curEmailInfo[1];
			var curEmailIndex = curEmailInfo[0];
			delete oldJSONInfo[curEmailUserType][curEmailIndex];
		}
		newJSONInfo.admin = oldJSONInfo.admin;
		newJSONInfo.keys = oldJSONInfo.keys;
		newJSONInfo.showDomain = oldJSONInfo.showDomain;
		newJSONInfo.isClientPortalDBOwner = oldJSONInfo.isClientPortalDBOwner;
		newJSONInfo.isDBOwner = oldJSONInfo.isDBOwner;
		newJSONInfo.zaId = oldJSONInfo.zaId;
		newJSONInfo.dbOwners = [];
		newJSONInfo.users = [];
		var oldDBOwners = oldJSONInfo.dbOwners;
		if (oldDBOwners) {
			for (i = 0, len = oldDBOwners.length; i < len; i++) {
				var curDBOwner = oldDBOwners[i];
				if (curDBOwner) {
					newJSONInfo.dbOwners.push(curDBOwner);
				}
			}
		}
		var oldUsers = oldJSONInfo.users;
		if (oldUsers) {
			for (i = 0, len = oldUsers.length; i < len; i++) {
				var curUser = oldUsers[i];
				if (curUser) {
					newJSONInfo.users.push(curUser);
				}
			}
		}
		this.refs.selectAllCheckbox.checked = false;
		var inputs = this.refs.usersList.querySelectorAll("input:checked");
		for (i = 0, len = inputs.length; i < len; i++) {
			inputs[i].checked = false;
		}
		delete ZRDBSettings.jsonInfoMap[ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage")];
		this.hideAllActionButtons();
		this.props.rerenderComp(newJSONInfo);
	},

	handleDeleteUserFailure: function (response, requestOptions) {
		this.props.rerenderComp(requestOptions.DOMNODE);
		this.hideAllActionButtons();
		this.commonErrorHandler(["7346"], ["ACTION_CAN_NOT_PREFORM"], response);
	},

	unmountAddnewUsersDlg: function (dlg) {
		var ref = document.getElementById("ZRADDNEWDLG");
		ReactDOM.unmountComponentAtNode(ref);
		ZDBSecuritySettings.clearAllBeforeCloseDialog();
		return true;
	},

	sendAddNewUsersReq: function (emailIds) {
		emailIds = emailIds.split(",");
		var temp = [];
		for (var i = 0, len = emailIds.length; i < len; i++) {
			var curEmail = emailIds[i];
			if (curEmail.indexOf("###") > 0) {
				temp.push(curEmail);
			} else {
				temp.push(curEmail + "###" + "-1");
			}
		}
		emailIds = this.getEmailStringFromArray(temp);
		var domNode = this.props.disableHolder();
		//		AjaxAPI.sendRequest({URL: this.props.APIURL +"/ADDDBUSER",
		//			PARAMETERS:"ZOHO_EMAILS=" + encodeURIComponent(emailIds),
		//	 		ONSUCCESSFUNC:this.handleAddUserSuccess,
		//			ONFAILUREFUNC:this.handleAddUserFailure,
		//			DOMNODE:domNode,
		//			EMAILS:temp,
		//			OPSTATUSID:"ZDBMainLoader"});
		ZRSAjax.post(this.props.APIURL + '/ADDDBUSER', 'ZOHO_EMAILS=' + encodeURIComponent(emailIds), {
			successHandler: {
				func: this.handleAddUserSuccess,
				ctx: this
			},
			failureHandler: {
				func: this.handleAddUserFailure,
				ctx: this
			},
			errorHandler: {
				func: this.handleAddUserFailure,
				ctx: this
			},
			DOMNODE: domNode,
			EMAILS: temp
		});
	},

	handleAddUserSuccess: function (newJSONInfo, requestOptions) {
		this.props.enableHolder(requestOptions.DOMNODE);
		var dialog = DOMUtils.getElOrParentWithAttr(document.getElementById("ZRADDNEWDLG"), "isDialog");
		ZDBDialogUtil.closeReactDialog(dialog);
		this.refs.selectAllCheckbox.checked = false;
		var inputs = this.refs.usersList.querySelectorAll("input:checked");
		for (var i = 0, len = inputs.length; i < len; i++) {
			inputs[i].checked = false;
		}
		delete ZRDBSettings.jsonInfoMap[ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage")];
		this.hideAllActionButtons();
		this.props.rerenderComp(newJSONInfo);
	},
	handleAddUserFailure: function (response, requestOptions) {
		this.props.enableHolder(requestOptions.DOMNODE);
		this.hideAllActionButtons();
		var errCode = response.data.errorName.trim();
		if (errCode === 'USER_NOT_EXISTS_IN_CRMPLUS' || errCode === "USER_NOT_EXISTS_IN_ZOHOONEORG") {
			var msg = response.message.trim();
			msg = msg.split(";");
			if (msg[1]) {
				if (ZDBGlobal.isZohoBundleOrgObjPresent) {
					msg[1] = '<a href="javascript:ZRCRMPlus.manageUser();">' + msg[1] + '</a>';
				} else {
					msg[1] = '<a href="' + ZDBGlobal.zohoSuiteManageUsersLink + '" target="_blank">' + msg[1] + '</a>';
				}
			}
			msg = msg.join("");
			ZDBAlertAPI.showErrorMsg(msg, null, errCode);
		} else {
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.js.commonfailure"));
		}
	},

	addNewUsers: function (event) {
		var inputs = this.refs.usersList.querySelectorAll("input:checked");
		for (var i = 0, len = inputs.length; i < len; i++) {
			inputs[i].checked = false;
		}
		this.updateActionBtns();
		var jsonInfo = this.props.jsonInfo;
		if (this.zaidVsDomain) {
			ZDBGlobal.isClientPortalAdmin = this.zaidVsDomain.length > 1 ? true : false;
			var holder = ZRBaseComponentsUtils.getContainer("ZRADDNEWDLG", document.body);
			holder.style.position = 'absolute';
			holder.style.top = '0px';
			holder.style.opacity = "0";
			var backupFactory = React.createFactory(AddNewUserDlg);
			var backupRef = ReactDOM.render(backupFactory({ onAdd: this.sendAddNewUsersReq, domains: this.zaidVsDomain, disableHolder: this.props.disableHolder, enableHolder: this.props.enableHolder }), holder);
			holder.objRef = backupRef;
			var offsetWidth = holder.offsetWidth,
			    offsetHeight = holder.offsetHeight;
			holder.style.position = "";
			var windowBounds = document.body.getBoundingClientRect();
			var top = windowBounds.height * 0.5 - offsetHeight * 0.5;
			var left = windowBounds.width * 0.5 - offsetWidth * 0.5;
			ZDBDialogUtil.showDialog(holder, { ADDFRAME: true, MODAL: true, onClose: this.unmountAddnewUsersDlg,
				TITLE: ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.add_new_usr"),
				LEFT: left, TOP: top });
			holder.style.opacity = "1";
		} else {
			var domNode = this.props.disableHolder();
			//			AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId +"/GETZAIDVSDOMAIN",
			//                            ONSUCCESSFUNC:this.handleDomainReqSuccess,
			//                            OPSTATUSID:"ZDBMainLoader",
			//                            DOMNODE:domNode
			//                        });
			ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETZAIDVSDOMAIN', null, {
				successHandler: {
					func: this.handleDomainReqSuccess,
					ctx: this
				},
				DOMNODE: domNode
			});
		}
	},

	handleDomainReqSuccess: function (response, requestOptions) {
		this.props.enableHolder(requestOptions.DOMNODE);
		this.zaidVsDomain = response.zaidVsDomain;
		this.addNewUsers();
	},

	customToolTipShow: function (event) {
		var holder = ZRBaseComponentsUtils.getContainer("ZRUserRoleToolTip", document.body);
		var factory = React.createFactory(DBUserRoleToolTip);
		var reference = ReactDOM.render(factory(), holder);
		var tip = reference.refs.ZDBPManageUserHelp;
		tip.style.position = "absolute";
		tip.style.display = "";
		var tipBoundingClient = tip.getBoundingClientRect();
		var left = ZDBUtil.getObjLeft(event.target) + event.target.offsetWidth;
		if (left + tipBoundingClient.width > document.body.offsetWidth) left = ZDBUtil.getObjLeft(event.target) - event.target.offsetWidth - tip.offsetWidth;
		tip.style.left = left + "px";
		tip.style.top = ZDBUtil.getObjTop(event.target) - 15 + "px";
	},
	customToolTipHide: function () {
		ZRBaseComponentsUtils.unmountComponentAtNode("ZRUserRoleToolTip");
	},
	roleChanger: function (event) {
		var email = event.target.getAttribute("data-email");
		var parentTarget = DOMUtils.getElOrParentWithAttr(event.target, "data-zuid");
		var userZuid = parentTarget.getAttribute("data-zuid");
		var curUserInfo = this.userToTypeNIndex[email + "###" + userZuid];
		if (!curUserInfo[2] && curUserInfo[1] != "dbOwners") {
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.users.js.enableuser"));
			return;
		}
		var cont = ZRBaseComponentsUtils.getContainer("DBRoleChangeComponent", document.body);
		var factory = React.createFactory(DBRoleChangeComponent);
		ReactDOM.render(factory({ cancelFunc: this.cancelFunc, userInfo: curUserInfo, email: email, sendRoleChangeRequest: this.sendRoleChangeRequest, zuid: userZuid }), cont);
		var freeze = document.createElement("div");
		freeze.className = "freezeLayer";
		freeze.style.zIndex = "1000";
		document.body.appendChild(freeze);
	},
	cancelFunc: function () {
		var freeze = document.querySelector(".freezeLayer");
		freeze.parentElement.removeChild(freeze);
		var holder = document.getElementById("DBRoleChangeComponent");
		ReactDOM.unmountComponentAtNode(holder);
		holder.parentNode.removeChild(holder);
	},
	sendRoleChangeRequest: function (notifyByEmail, role, email, userInfo, zuid) {
		var currentUserRole = userInfo[1];
		if (role == currentUserRole) {
			ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.dbsettings.users.js.nochangeinrole"));
			return;
		} else {
			var domNode = this.props.disableHolder();
			var action = role == "users" ? "/REMOVEDBOWNERDBSETTINGS" : "/ADDDBOWNERDBSETTINGS";
			//			AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ZDBClientUI.dbId + action,
			//				PARAMETERS: "ZOHO_EMAILS=" + encodeURIComponent(email) +
			//				"&SENDDEFAULTMAIL=" + notifyByEmail +
			//				"&ZOHO_DOMAINNAME=" + this.props.jsonInfo[this.userToTypeNIndex[email + "###" + zuid][1]][this.userToTypeNIndex[email + "###" + zuid][0]][1] +
			//				"&ZOHO_INVITE_MAIL=" + notifyByEmail,
			//				ONSUCCESSFUNC:this.handleRoleChangeSuccess,
			//				ONFAILUREFUNC:this.handleRoleChangeFailure,
			//				OPSTATUSID:"ZDBMainLoader",DOMNODE:domNode,
			//			});
			var params = 'ZOHO_EMAILS=' + encodeURIComponent(email) + '&SENDDEFAULTMAIL=' + notifyByEmail + '&ZOHO_DOMAINNAME=' + this.props.jsonInfo[this.userToTypeNIndex[email + '###' + zuid][1]][this.userToTypeNIndex[email + '###' + zuid][0]][1] + '&ZOHO_INVITE_MAIL=' + notifyByEmail;
			ZRSAjax.post('/reportsapi/db/' + ZDBClientUI.dbId + action, params, {
				successHandler: {
					func: this.handleRoleChangeSuccess,
					ctx: this
				},
				failureHandler: {
					func: this.handleRoleChangeFailure,
					ctx: this
				},
				errorHandler: {
					func: this.handleRoleChangeFailure,
					ctx: this
				},
				DOMNODE: domNode
			});
			this.cancelFunc();
		}
	},
	handleRoleChangeSuccess: function (response, requestOptions) {
		this.props.enableHolder(requestOptions.DOMNODE);
		ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.dbsettings.users.js.successrolechange"));
		delete ZRDBSettings.jsonInfoMap[ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.resusage")];
		this.hideAllActionButtons();
		this.sendDBUserListReq();
	},
	handleRoleChangeFailure: function (response, requestOptions) {
		this.props.enableHolder(requestOptions.DOMNODE);
		this.hideAllActionButtons();
		var errorCode = response.data.errorName.trim();
		if (errorCode === "SHARE_TO_DEACTIVATED_USR") {
			var errorMsg = response.message.trim();
			errorMsg = errorMsg.split(";");
			if (errorMsg[1]) {
				errorMsg[1] = '<a href="' + ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBPricing.cc?SHOWPAGE=ManageUsers&STRUCT=true&ZDBACTION=MANAGEUSERS' + '" target="_blank"">' + errorMsg[1] + "</a>";
			}
			errorMsg = errorMsg.join("");
			ZDBAlertAPI.showErrorMsg(errorMsg, null, errorCode);
		} else {
			this.commonErrorHandler(["6015", "6039", "8040"], ["MULTIPLE_DBOWNERS_NOT_ALLOWED", "CUSTOM_DOMAIN_MULTI_DBOWNERS_NOT_ALLOWED", "NOT_DBOWNER"], response);
		}
	},
	sendDBUserListReq: function () {
		var domNode = this.props.disableHolder();
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId + "/GETDBUSERLIST",
		//				ONSUCCESSFUNC:this.updateList,
		//				DOMNODE:domNode});
		ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETDBUSERLIST', null, {
			successHandler: {
				func: this.updateList,
				ctx: this
			},
			DOMNODE: domNode
		});
	},
	updateList: function (newJSONInfo, requestOptions) {
		this.props.enableHolder(requestOptions.DOMNODE);
		var inputs = this.refs.usersList.querySelectorAll("input:checked");
		for (var i = 0, len = inputs.length; i < len; i++) {
			inputs[i].checked = false;
		}
		this.props.rerenderComp(newJSONInfo);
	},
	hideAllActionButtons: function () {
		this.refs.deleteBtn.refs.BASEINPUTCOMPONENT.style.display = "none";
		this.refs.activateBtn.refs.BASEINPUTCOMPONENT.style.display = "none";
		this.refs.deactivateBtn.refs.BASEINPUTCOMPONENT.style.display = "none";
	},
	render: function () {
		var jsonInfo = this.props.jsonInfo;
		var showDomain = jsonInfo.showDomain;
		var titleLIContent = [React.createElement(
			"span",
			{ key: 0, style: { marginLeft: "5px", width: "3%" } },
			React.createElement("input", { type: "checkbox", onChange: this.selectAllCheckboxChange, ref: "selectAllCheckbox" })
		), React.createElement(
			"span",
			{ key: 1, style: { width: "35%" } },
			ZDBI18NMap.g("zrpt.dbsettings.users.js.emails")
		)];
		if (showDomain) {
			titleLIContent.push(React.createElement(
				"span",
				{ key: 2, style: { width: "25%" } },
				ZDBI18NMap.g("zrpt.dbsettings.variables.js.domain")
			));
		}
		titleLIContent.push(React.createElement(
			"span",
			{ key: 3, style: { width: "19%" } },
			ZDBI18NMap.g("zrpt.conn.js.status")
		));
		titleLIContent.push(React.createElement(
			"span",
			{ key: 4, style: { width: "17%", position: "relative" } },
			ZDBI18NMap.g("zrpt.dbsettings.users.js.roles"),
			React.createElement("span", { className: "helpDet", onMouseMove: this.customToolTipShow, onMouseOut: this.customToolTipHide })
		));
		return React.createElement(
			"div",
			{ id: "ZRDBSettingsBodyContentDiv" },
			React.createElement(
				"div",
				{ id: "ZRDBSettingsBodyContentInnerDiv" },
				React.createElement(TitleNDesc, { title: ZDBI18NMap.g("zrpt.dbsettings.variables.js.users"), desc: ZDBI18NMap.g("zrpt.dbsettings.users.js.usersdesc") }),
				React.createElement(
					"div",
					{ style: { width: "90%", height: "30px" } },
					React.createElement(
						"div",
						{ className: "fLeft" },
						React.createElement(InputComponent, { onClick: this.addNewUsers,
							className: "newBtn greenBtn", type: "button",
							value: ZDBI18NMap.g("zrpt.dbsettings.users.js.addnewusers") }),
						React.createElement(InputComponent, { ref: "deleteBtn", style: { display: "none" },
							className: "newBtn", type: "button", onClick: this.deleteUsers,
							value: ZDBI18NMap.g("zrpt.dbsettings.users.js.deleteusers") }),
						React.createElement(InputComponent, { ref: "activateBtn", action: "activate", style: { display: "none" },
							className: "newBtn", type: "button", onClick: this.activateOrDeactivateMultipleUsers,
							value: ZDBI18NMap.g("zrpt.dbsettings.users.js.activateusers") }),
						React.createElement(InputComponent, { ref: "deactivateBtn", action: "deactivate", style: { display: "none" },
							className: "newBtn", type: "button", onClick: this.activateOrDeactivateMultipleUsers,
							value: ZDBI18NMap.g("zrpt.dbsettings.users.js.deactivateusers") })
					),
					React.createElement(
						"div",
						{ className: "fRight" },
						React.createElement(SearchComponent, { placeholder: ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.searchuseremail"),
							holderStyle: { marginTop: "5px" },
							inputStyle: { width: "130px" },
							inputChangeHandler: this.setSearchState,
							clearSearch: this.clearSearchState })
					)
				),
				React.createElement(
					"div",
					{ style: { clear: "both", width: "90%", height: "35px" } },
					React.createElement(
						"ul",
						{ className: "DBUserSettingsTitleUL" },
						React.createElement(
							"li",
							{ style: { paddingBottom: "0px" } },
							titleLIContent
						)
					)
				),
				React.createElement(
					"div",
					{ style: { width: "90%", overflow: "auto", height: "calc(100% - 155px)" }, ref: "usersList" },
					function (jsonInfo, objRef) {
						var returnLIs = [];
						var filteredEmails = [];
						if (jsonInfo.admin && jsonInfo.admin.length > 0) {
							if (objRef.state.searchStr) {
								filteredEmails = filteredEmails.concat(jsonInfo.admin.filter(function (individualAdmin) {
									return individualAdmin[jsonInfo.keys.Email].indexOf(objRef.state.searchStr) === 0;
								}));
							} else {
								filteredEmails = filteredEmails.concat(jsonInfo.admin);
							}
						}
						if (jsonInfo.dbOwners && jsonInfo.dbOwners.length > 0) {
							if (objRef.state.searchStr) {
								filteredEmails = filteredEmails.concat(jsonInfo.dbOwners.filter(function (individualOwner) {
									return individualOwner[jsonInfo.keys.Email].indexOf(objRef.state.searchStr) === 0;
								}));
							} else {
								filteredEmails = filteredEmails.concat(jsonInfo.dbOwners);
							}
						}
						if (jsonInfo.users && jsonInfo.users.length > 0) {
							if (objRef.state.searchStr) {
								filteredEmails = filteredEmails.concat(jsonInfo.users.filter(function (individualUser) {
									return individualUser[jsonInfo.keys.Email].indexOf(objRef.state.searchStr) === 0;
								}));
							} else {
								filteredEmails = filteredEmails.concat(jsonInfo.users);
							}
						}
						if (filteredEmails.length > 0) {
							returnLIs.push(React.createElement(DBUserLI, { jsonInfo: filteredEmails, keys: jsonInfo.keys, key: "users", showDomain: jsonInfo.showDomain, searchStr: objRef.state.searchStr, isDBOwner: jsonInfo.isDBOwner, activateOrDeactivateSingleUser: objRef.activateOrDeactivateSingleUser, checkBoxChange: objRef.checkBoxChange, roleChanger: objRef.roleChanger }));
						} else {
							returnLIs.push(React.createElement(
								"div",
								{ key: "0", className: "bold", style: { textAlign: "center", marginTop: "40px" } },
								ZDBI18NMap.g("zrpt.common.js.nomatchresult")
							));
						}

						return returnLIs;
					}(jsonInfo, this)
				)
			)
		);
	}
});

var DBUserRoleToolTip = React.createClass({
	displayName: "DBUserRoleToolTip",

	render: function () {
		return React.createElement(
			"div",
			{ ref: "ZDBPManageUserHelp", style: { display: "none", top: "156px" }, className: "userInfoHelp" },
			React.createElement("div", { dangerouslySetInnerHTML: { __html: ZDBI18NMap.g("zrpt.pricing.manage_usr.roles.js.admin") + ZDBI18NMap.g("zrpt.pricing.manage_usr.roles.js.db_owner") + ZDBI18NMap.f("zrpt.pricing.manage_usr.roles.js.user", ZDBGlobal.PRODUCTNAME) + ZDBI18NMap.g("zrpt.pricing.manage_usr.roles.js.msg") } })
		);
	}
});

var DBUserLI = React.createClass({
	displayName: "DBUserLI",

	render: function () {
		var keys = this.props.keys;
		var users = this.props.jsonInfo;
		var showDomain = this.props.showDomain;
		var lis = [];
		for (var i = 0, len = users.length; i < len; i++) {
			var curUser = users[i];
			var liContent = [];
			var isAdmin = curUser[keys.Role] == ZDBI18NMap.g("zrpt.common.js.admin");
			var isDBOwner = curUser[keys.Role] == ZDBI18NMap.g("zrpt.common.js.dbowner");
			var isCurrentUserDBOwner = this.props.isDBOwner;
			//Search Check
			if (this.props.searchStr && curUser[keys.Email].indexOf(this.props.searchStr) !== 0) continue;

			//Admin checkbox removal check
			if (isAdmin || isDBOwner && isCurrentUserDBOwner) {
				liContent.push(React.createElement("span", { key: 0, style: { marginLeft: "5px", width: "3%", overflow: "hidden" } }));
			} else {
				liContent.push(React.createElement(
					"span",
					{ key: 0, style: { marginLeft: "5px", width: "3%", overflow: "hidden" } },
					React.createElement("input", { type: "checkbox", "data-email": curUser[keys.Email], onChange: this.props.checkBoxChange })
				));
			}

			//Email pushed
			liContent.push(React.createElement(
				"span",
				{ key: 1, style: { width: "35%" }, className: "ellipsis" },
				curUser[keys.Email]
			));

			//Domain check for custom domain.
			if (showDomain) {
				liContent.push(React.createElement(
					"span",
					{ key: 2, style: { width: "25%" }, className: "ellipsis" },
					curUser[keys.Domain]
				));
			}

			//Status toggler addition
			liContent.push(React.createElement(
				"span",
				{ key: 3, style: { width: "19%", overflow: "hidden" }, "data-email": curUser[keys.Email], "data-action": curUser[keys.Status] ? "deactivate" : "activate" },
				React.createElement(GraphicalToggler, {
					onClick: this.props.activateOrDeactivateSingleUser,
					activeText: ZDBI18NMap.g("zrpt.dbsettings.users.js.active"), inactiveText: ZDBI18NMap.g("zrpt.dbsettings.users.js.inactive"),
					enable: curUser[keys.Status] })
			));

			//Roles rendering
			if (isAdmin) {
				liContent.push(React.createElement(
					"span",
					{ key: 4, style: { width: "17%", overflow: "hidden" } },
					React.createElement("span", { style: { marginTop: "11px" }, className: "iconbg user" }),
					curUser[keys.Role]
				));
			} else {
				liContent.push(React.createElement(
					"span",
					{ key: 4, style: { width: "17%", overflow: "hidden" } },
					React.createElement(
						"span",
						null,
						curUser[keys.Role]
					),
					React.createElement("span", { className: "iconbg userRoleEdit", style: { float: "none", display: isCurrentUserDBOwner || ZDBGlobal.userPlanName === "Free" ? "none" : "" }, onClick: this.props.roleChanger, "data-email": curUser[keys.Email] })
				));
			}

			lis.push(React.createElement(
				"li",
				{ key: i, style: { paddingBottom: "0px" }, "data-role": curUser[keys.Role], "data-zuid": curUser[keys.ZaId] },
				liContent
			));
		}
		return React.createElement(
			"ul",
			{ className: "DBuserLI", style: { backgroundColor: "white", marginTop: "" } },
			lis
		);
	}
});

//ADDNEWUSER COMPONENT START
var AddNewUserDlg = React.createClass({
	displayName: "AddNewUserDlg",

	componentWillMount: function () {
		ZDBSecuritySettings.getMyContactsFromIAM();
		this.createDropDown();
		if (!document.zohoContacts) {
			this.getZohoContacts();
		}
	},
	componentWillUnmount: function () {
		var dropDown = document.getElementById("dropdown");
		if (dropDown) document.body.removeChild(dropDown);
		this.alreadyCreated = false;
		ZRBaseComponentsUtils.unmountComponentAtNode("ZRAddUsersMenu");
		ZRBaseComponentsUtils.unmountComponentAtNode("ZRDBSetAddList");
	},

	createDropDown: function () {
		if (!this.alreadyCreated) {
			var el = document.createElement("div");
			el.setAttribute("id", "dropdown");
			el.style.display = 'none';
			el.style.zIndex = "10000001";
			el.className = "dropdown";
			document.body.appendChild(el);
			this.alreadyCreated = true;
		}
	},
	getDefaultProps: function () {
		return {
			domainIndex: 0
		};
	},
	getDomainUserEl: function () {
		var domainOptions = [];
		for (var i = 0, len = this.props.domains.length; i < len; i++) {
			var domain = this.props.domains[i];
			domainOptions.push(React.createElement(
				"option",
				{ value: domain.Zaid, key: domain.Zaid },
				domain.DomainName
			));
		}
		var domainUserEl = React.createElement(
			"div",
			{ style: { marginTop: "10px", display: "inline-block", lineHeight: "20px" }, key: this.props.domainIndex, "data-domainUserEl": "true" },
			React.createElement(
				"div",
				{ className: "fLeft" },
				React.createElement("input", { type: "text", className: "textInput", style: { width: "270px" }, onKeyDown: this.handleKey,
					onKeyUp: this.handleKey, onBlur: this.handleBlur, "data-emailEl": "true" })
			),
			React.createElement(
				"div",
				{ className: "fLeft", style: { margin: "-1px 0px 0px 7px" } },
				React.createElement(
					"select",
					{ className: "inlineSelect", style: { width: "150px" }, "data-domainSelect": "true" },
					domainOptions
				)
			),
			React.createElement(
				"div",
				{ className: "inlineLinkStyle zrlink fLeft", style: { margin: "3px 0px 0px 3px" }, onClick: this.handleRemoveDomainUser },
				ZDBI18NMap.g("zrpt.dbsettings.users.js.remove")
			)
		);
		this.props.domainIndex += 1;
		return [domainUserEl];
	},
	showAddUsersMenu: function (event) {
		var target = DOMUtils.getElOrParentWithAttr(event.target, "data-link");
		var menuBatches = [];
		var zCont = { value: ZDBI18NMap.g("zrpt.common.js.zusers"), clickEvtHand: this.zohoUsrsFunc };
		var gCont = { value: ZDBI18NMap.g("zrpt.common.js.gusers"), clickEvtHand: this.googleUsrsFunc };
		var gAppCont = { value: ZDBI18NMap.g("zrpt.common.js.gappusers"), clickEvtHand: this.googleAppUsrsFunc };
		var crmAppCont = { value: ZDBI18NMap.g("zrpt.common.js.crmplususers"), clickEvtHand: this.CRMPlusUsrsFunc };
		if (ZDBClientUI.showZContacts) {
			menuBatches.push(zCont);
		}
		if (!ZDBClientUI.disableGadgets) {
			if (ZDBClientUI.showGoogleContacts) menuBatches.push(gCont);
			//if(ZDBClientUI.isGAppUser)
			//	menuBatches.push(gAppCont);
			//if(ZDBGlobal.isCRMPlusUser)
			//	menuBatches.push(crmAppCont);
		}
		var holder = ZRBaseComponentsUtils.getContainer("ZRAddUsersMenu", document.body);
		var factory = React.createFactory(ReactMenu);
		ReactDOM.render(factory({ MenuBatches: [menuBatches], srcEl: target, holderStyle: { width: "135px" } }), holder);
	},
	zohoUsrsFunc: function (event) {
		if (!document.zohoContacts) this.getZohoContacts(this.zohoUsrsFunc);else this.emailOrGroupListingFunc('zohoCnt');
	},
	googleUsrsFunc: function (event) {
		if (!document.googleContacts) this.getGoogleContacts(this.googleUsrsFunc, event);else {

			if (event.callCloseDlg) {
				ZDBDialogUtil.closeDialog();
			}
			this.emailOrGroupListingFunc('googleCnt');
		}
	},
	googleAppUsrsFunc: function (event) {},
	CRMPlusUsrsFunc: function (event) {},
	emailOrGroupListingFunc: function (scenario, event) {
		ZRBaseComponentsUtils.unmountComponentAtNode("ZRAddUsersMenu");
		var itemList;
		switch (scenario) {
			case 'zohoCnt':
				itemList = document.zohoContacts;
				break;
			case 'googleCnt':
				itemList = document.googleContacts;
				break;
		}
		var holder = ZRBaseComponentsUtils.getContainer("ZRDBSetAddList", document.body);
		var factory = React.createFactory(ZRListingSelectorComp);
		var selItms = "";
		if (!ZDBGlobal.isClientPortalAdmin) {
			selItms = ZDBSecuritySettings.getUsersFromUserDlg();
			try {
				selItms = ZDBUtil.getValidatedEmailsAsCommaSeparated(selItms);
			} catch (e) {
				ZDBMsgBox.showError(e.message);
				return;
			}
		} else {
			selItms = ZDBSecuritySettings.getUsersFromDomainUsersDlg(true);
		}
		selItms = selItms && selItms.split(",");
		if (!selItms) {
			selItms = [];
		}
		var json = {
			items: itemList,
			addItemsFunc: this.handleAddEmails,
			selectedItems: selItms,
			iconClass: "iconbg user",
			searchPlaceholder: ZDBI18NMap.g("zrpt.common.toolbar.share.zdbalertmsg.js.searchusers"),
			buttonText: ZDBI18NMap.g("zrpt.common.js.addusers"),
			noResultText: ZDBI18NMap.g("zrpt.common.js.nousersavail"),
			isGroup: false, srcEl: this.refs.ZDBAddUsersFromMenu,
			noMatchSearchStr: ZDBI18NMap.g("zrpt.common.js.nomatchusers")
		};
		if (scenario == "googleCnt") {
			json.customLinkText = ZDBI18NMap.g("zrpt.share.sharenewusr.addmycontact.js.signinasdiffguser");
			json.customLinkAction = this.revokeGAuthToken;
		}
		ReactDOM.render(factory(json), holder);
	},
	handleAddEmails: function (items) {
		if (items && items.length > 0) {
			if (ZDBGlobal.isClientPortalAdmin) {
				var domainListHolder = this.refs.domainUsersHolder;
				var children = domainListHolder.children;
				for (var i = 0, len = children.length; i < len; i++) {
					var curChild = children[i];
					ReactDOM.unmountComponentAtNode(curChild);
				}
				domainListHolder.innerHTML = "";
				items.forEach(function (email) {
					var div = document.createElement("div");
					div.setAttribute("data-domainInfoHolder", "true");
					ReactDOM.render(this.getDomainUserEl()[0], div);
					domainListHolder.appendChild(div);
					div.querySelector("input").value = email;
				}.bind(this));
			} else {
				var textArea = this.refs.zdbcontactsholder;
				textArea.value = "";
				items.forEach(function (email) {
					textArea.value += email + "\n";
				});
				textArea.focus();
			}
		}
	},
	getZohoContacts: function (callback) {
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ZDBClientUI.dbId+"/GETZOHOCONTACTS",
		//                    ONSUCCESSFUNC:this.getZohoContactSucc,
		//                    ONFAILUREFUNC:this.getZohoContactFail,
		//                    CALLBACK:callback,OPSTATUSID:"ZDBMainLoader"
		//                });
		ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETZOHOCONTACTS', null, {
			successHandler: {
				func: this.getZohoContactSucc,
				ctx: this
			},
			failureHandler: {
				func: this.getZohoContactFail,
				ctx: this
			},
			errorHandler: {
				func: this.getZohoContactFail,
				ctx: this
			},
			CALLBACK: callback
		});
	},
	getZohoContactSucc: function (response, requestOptions) {
		document.zohoContacts = response.zohoContacts;
		if (requestOptions.CALLBACK && typeof requestOptions.CALLBACK === "function") requestOptions["CALLBACK"]();
	},
	getZohoContactFail: function () {
		document.zohoContacts = null;
	},
	getGoogleContacts: function (callBack, event) {
		ZRBaseComponentsUtils.unmountComponentAtNode("ZRAddUsersMenu");
		var domNode = this.props.disableHolder();
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ZDBClientUI.dbId+"/GETGOOGLECONTACTS",
		//                    PARAMETERS:"REFETCH=true",
		//                    ONSUCCESSFUNC:this.getGoogleContactsSucc,
		//                    ONFAILUREFUNC:this.getGoogleContactsFail,OPSTATUSID:'ZDBMainLoader',
		//                    FUNCTOCALLBACK:callBack,EVENT:event,DOMNODE:domNode
		//                });
		ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETGOOGLECONTACTS', 'REFETCH=true', {
			successHandler: {
				func: this.getGoogleContactsSucc,
				ctx: this
			},
			failureHandler: {
				func: this.getGoogleContactsFail,
				ctx: this
			},
			errorHandler: {
				func: this.getGoogleContactsFail,
				ctx: this
			},
			FUNCTOCALLBACK: callBack,
			EVENT: event,
			DOMNODE: domNode
		});
	},
	getGoogleContactsSucc: function (response, requestOption) {
		this.props.enableHolder(requestOption.DOMNODE);
		document.googleContacts = response.googleContacts;
		requestOption["FUNCTOCALLBACK"](requestOption.EVENT);
	},
	getGoogleContactsFail: function (response, requestOption) {
		this.props.enableHolder(requestOption.DOMNODE);
		var errCode = response.data.errorName;
		errCode = errCode ? errCode.trim() : '';
		if (errCode == "GOOGLE_AUTH_REQUIRED") {
			this.authenticateGoogle();
		}
		requestOption.EVENT.callCloseDlg = true;
		ZRBaseComponentsUtils.googleContCallBack = requestOption.FUNCTOCALLBACK;
		ZRBaseComponentsUtils.googleContCallBackEvent = requestOption.EVENT;
		document.googleContacts = null;
	},
	authenticateGoogle: function () {
		var authURL = ZDBGlobal.GAPP_EMBED_GADGET_URL + "/gcontacts?auth=true&zservice=" + ZDBGlobal.GAPP_ZSERVICE + "&border=no&serURL=" + ZDBGlobal.REPORTS_SERVER_URL + ZDBGlobal.REPORTS_CONTEXT_NAME + encodeURIComponent("/integ/GResponseRedirect.jsp?gauth_type=contacts&ISREACT=true");
		ZDBGoogleInteg.authGoogle(authURL);
	},
	revokeGAuthToken: function () {
		delete document.googleContacts;
		var url = "/ZDBSecurityAction.ma?ZDBACTION=ZDBREVOKEGTOKEN&GTYPE=contacts"; //No I18N
		AjaxAPI.sendRequest({ URL: url, //No I18N
			ONSUCCESSFUNC: this.handleRevokeGToken,
			ONFAILUREFUNC: this.handleRevokeGTokenFailure,
			GOOGLETYPE: "contacts",
			OPSTATUSID: "ZDBMainLoader" }); //No I18N
	},
	handleRevokeGToken: function () {
		ZRBaseComponentsUtils.unmountComponentAtNode("ZRAddUsersMenu");
		this.authenticateGoogle();
	},
	handleRevokeGTokenFailure: function () {
		ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.share.shareview.js.errInGAuth"));
	},
	handleAdd: function () {
		var emailIds = "";
		if (!ZDBGlobal.isClientPortalAdmin) {
			emailIds = ZDBSecuritySettings.getUsersFromUserDlg();
			try {
				emailIds = ZDBUtil.getValidatedEmailsAsCommaSeparated(emailIds);
			} catch (e) {
				ZDBMsgBox.showError(e.message);
				return;
			}
		} else {
			emailIds = ZDBSecuritySettings.getUsersFromDomainUsersDlg();
		}
		if (emailIds === "") {
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.invalid_email_ids"));
			return;
		}
		if (this.props.onAdd) this.props.onAdd(emailIds);
	},

	handleKey: function (event) {
		ZDBAutoFillContacts.autolist(event.target, event, 'dropdown', ZDBAutoFillContacts.matchSample);
	},
	handleBlur: function (event) {
		ZDBAutoFillContacts.hidepopup('dropdown');
	},
	handleClose: function (event) {
		var dialog = DOMUtils.getElOrParentWithAttr(event.target, "isDialog");
		ZDBDialogUtil.closeReactDialog(dialog, event);
	},
	handleRemoveDomainUser: function (event) {
		var target = event.target;
		var topParent = DOMUtils.getParentWithAttrValue(target, "id", "domainUsersHolder");
		var holder = DOMUtils.getParentWithAttr(target, "data-domainInfoHolder");
		ReactDOM.unmountComponentAtNode(holder);
		holder.parentNode.removeChild(holder);
	},
	handleAddNewDomainUser: function (event) {
		var target = event.target;
		if (target) {
			var previousSibling = target.previousElementSibling;
			var div = document.createElement("div");
			div.setAttribute("data-domainInfoHolder", "true");
			ReactDOM.render(this.getDomainUserEl()[0], div);
			previousSibling.appendChild(div);
			div.querySelector("input").focus();
		}
	},
	componentDidMount: function () {
		this.handleAddNewDomainUser({ target: this.refs.zdbaddnewuserlink });
	},
	render: function () {
		var body = ZDBGlobal.isClientPortalAdmin ? React.createElement(
			"div",
			{ style: { width: "500px", height: "280px", overflowX: "hidden", overflowY: "auto", cursor: "text", marginTop: "10px", display: "inline-block" } },
			React.createElement("div", { id: "domainUsersHolder", ref: "domainUsersHolder" }),
			React.createElement(
				"div",
				{ ref: "zdbaddnewuserlink", id: "zdbaddnewuserlink", className: "inlineLinkStyle zrlink", style: { marginTop: "10px", lineHeight: "10px" }, onClick: this.handleAddNewDomainUser },
				"+ ",
				ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.add_new_usr")
			)
		) : React.createElement("textarea", { ref: "zdbcontactsholder", id: "zdbcontactsholder", style: { width: "500px", height: "200px", resize: "none" }, onKeyDown: this.handleKey, onKeyUp: this.handleKey, onBlur: this.handleBlur });
		return React.createElement(
			"div",
			{ id: "ZDBAddUserDlg" },
			React.createElement(
				"div",
				{ style: { background: "#efefef", width: "500px", margin: "-7px 0px 3px 0px", padding: "5px" } },
				React.createElement(
					"ul",
					{ style: { listStyle: "initial", marginLeft: "20px" } },
					React.createElement(
						"li",
						null,
						ZDBI18NMap.f("zrpt.dbresource.js.adduserline1", ZDBGlobal.PRODUCTNAME)
					),
					React.createElement(
						"li",
						null,
						ZDBI18NMap.f("zrpt.dbresource.js.adduserline2", ZDBGlobal.PRODUCTNAME)
					),
					React.createElement(
						"li",
						null,
						ZDBI18NMap.g("zrpt.dbresource.js.adduserline3")
					)
				)
			),
			React.createElement(
				"div",
				{ style: { height: "20px" } },
				React.createElement(
					"div",
					{ style: { lineHeight: "20px", float: "left" }, className: "bold" },
					ZDBI18NMap.g("zrpt.explorer.share.shareview.js.enteremailadd")
				),
				React.createElement(
					"div",
					{ style: { float: "right", paddingRight: "5px", paddingTop: "2px" } },
					React.createElement("div", { id: "ZDBAddUsersProcess", className: "mcLoaded" }),
					React.createElement(
						"a",
						{ className: "ZRSLink", ref: "ZDBAddUsersFromMenu", id: "ZDBAddUsersFromMenu", onClick: this.showAddUsersMenu, "data-link": "true", style: { display: ZDBClientUI.isCustomDomain ? "none" : "" } },
						ZDBI18NMap.g("zrpt.dbsettings.users.js.addusersfrom"),
						React.createElement("span", { className: "dropDownMenu" })
					)
				)
			),
			body,
			React.createElement(
				"div",
				{ style: { lineHeight: "30px", textAlign: "center" } },
				React.createElement("div", { id: "ZDBInvUsersProcess", className: "mcLoaded" }),
				React.createElement(InputComponent, { type: "button", value: ZDBI18NMap.g("zrpt.share.button_val.js.add"), className: "buttonCompBoxBg", style: { marginTop: "15px" }, onClick: this.handleAdd }),
				React.createElement(InputComponent, { type: "button", value: ZDBI18NMap.g("zrpt.dialoginfo.js.cancelbtn"), className: "buttonCompBoxBg", style: { marginTop: "15px" }, onClick: this.handleClose })
			)
		);
	}
});
//ADDNEWUSER COMPONENT END

//RoleChange Component Start
var DBRoleChangeComponent = React.createClass({
	displayName: "DBRoleChangeComponent",

	roleChange: function (event) {
		var value = this.refs.select.refs.BASESELECTCOMPONENT.value;
		// console.log(value);
		this.refs.select.setState({
			value: value
		});
	},
	okFunc: function () {
		var parent = this.refs.dynamicContainer.refs.parent;
		var checkbox = parent.querySelector("input[type='checkbox']").checked;
		var select = parent.querySelector("select").value;
		this.props.sendRoleChangeRequest(checkbox, select, this.props.email, this.props.userInfo, this.props.zuid);
	},
	render: function () {
		var userInfo = this.props.userInfo;
		var userEmail = this.props.email;
		var optionValues = [{
			value: "dbOwners",
			i18nValue: ZDBI18NMap.g("zrpt.common.js.dbowner")
		}, {
			value: "users",
			i18nValue: ZDBI18NMap.g("zrpt.common.js.user")
		}];
		var bodyContent = React.createElement(
			"div",
			{ style: { borderBottom: "1px solid #dfdfdf" } },
			React.createElement(
				"div",
				{ style: { padding: "5px" } },
				React.createElement(
					"span",
					{ className: "width50 bold" },
					ZDBI18NMap.g("zrpt.dbsettings.users.js.useremail"),
					":"
				),
				React.createElement(
					"span",
					{ className: "width50" },
					userEmail
				)
			),
			React.createElement(
				"div",
				{ style: { padding: "5px", lineHeight: "40px", height: "40px" } },
				React.createElement(
					"span",
					{ className: "width50 bold" },
					ZDBI18NMap.g("zrpt.dbsettings.users.js.role"),
					":"
				),
				React.createElement(
					"span",
					{ className: "width50" },
					React.createElement(SelectComponent, { ref: "select", optionValues: optionValues, value: userInfo[1], onChange: this.roleChange, style: { width: "90%" } })
				)
			),
			React.createElement(
				"div",
				{ style: { padding: "5px", height: "20px", lineHeight: "18px" } },
				React.createElement("input", { type: "checkbox", ref: "notifyThroughEmail", className: "fLeft" }),
				React.createElement(
					"span",
					{ className: "fLeft" },
					ZDBI18NMap.g("zrpt.dbsettings.users.js.notifythroughmail")
				)
			),
			React.createElement(
				"div",
				{ style: { padding: "5px", color: "#9C0808", display: userInfo[1] == "users" ? "none" : "" } },
				ZDBI18NMap.g("zrpt.dbsettings.users.js.dbownerrolechange")
			)
		);
		return React.createElement(DynamicBodyContainer, { bodyContent: bodyContent, ref: "dynamicContainer",
			title: ZDBI18NMap.g("zrpt.dbsettings.users.js.changeuserrole"),
			okText: ZDBI18NMap.g("zrpt.dbsettings.users.js.update"),
			cancelText: ZDBI18NMap.g("zrpt.common.js.cancel"),
			cancelFunc: this.props.cancelFunc,
			okFunc: this.okFunc
		});
	}
});
//RoleChange Component End

//ignorei18n_end