//$Id$
var ZAChartSortMenu = new function()
{
    this.SHOW_FULL_MENU = 0;   // sort menu from tool bar
    this.SHOW_AXIS_MENU = 1;   // sort menu from axis sort icon in edit mode
    this.SHOW_LEGEND_MENU = 2; // sort menu from legend sort icon in edit mode

    this.showSortMenu = function(srcEl, event, place, isLegendSort)
    {
        var view = ZDBClientUI.getViewObj(srcEl, "view"); //No I18N
        settings.currentViewObj = view;
        if(place)
        {
            if(isLegendSort && (view.legendPos.indexOf("TOP") == 0 || view.legendPos.indexOf("LEFT") == 0
                                   || view.legendPos.indexOf("DEF") == 0 || view.legendPos == "RIGHT")) //No I18N
            {
                ZDBMenu.showDropDownMenu(srcEl, event, "Sort_Chart", "GridMenu", "left", isLegendSort); //No I18N
            }
            else
            {
                ZDBMenu.showDropDownMenu(srcEl, event, "Sort_Chart", "GridMenu", place, isLegendSort); //No I18N
            }
        }
        else
        {
            if($("ZDBChartSortMenu")==null) {
                ZDBContentCache.appendAndGet("Sort_Chart", "GridMenu", document.body); //No I18N
            }
            var displayType = this.SHOW_FULL_MENU;
            if(view.legendPos == "NONE") {
                displayType = this.SHOW_AXIS_MENU;
            }
            else if(view.sortAllowedAxis=="") {
                displayType = this.SHOW_LEGEND_MENU;
            }
            ZAChartSortMenu.showSubMenu(displayType);
            ZDBMenu.showModuleMenu(srcEl, event, "Sort_Chart", "GridMenu", true); //No I18N
        }
        ZAChartSortMenu.showTickMark(view);
    }

    // display drop down menu and set tool tip text
    this.showSubMenu = function(displayType)
    {
        var sortMenu = $("ZDBChartSortMenu");
        if(sortMenu==null) {return;}
        ZDBUtil.setNamedChildEls(sortMenu, sortMenu);
        var axisSrtHeader = sortMenu.srtHeader;
        if(axisSrtHeader==null) {return;}

        var view = settings.currentViewObj;
        if(!view || !view.axisDetails) {return;}

        var actValMenu = new Array(sortMenu.actAscSrt, sortMenu.actDscSrt);
        var xValMenu = new Array(sortMenu.xAscSrt, sortMenu.xDscSrt);
        var yValMenu = new Array(sortMenu.yAscSrt, sortMenu.yDscSrt);
        switch(displayType)
        {
            case this.SHOW_LEGEND_MENU: // click from legend sort icon
                ZAChartSortMenu.hideAxisSortMenu(sortMenu, axisSrtHeader, actValMenu, xValMenu, yValMenu);
                ZAChartSortMenu.displayLegendMenu(view, true);
                break;

            case this.SHOW_AXIS_MENU: // click from sort axis icon
                ZAChartSortMenu.displayLegendMenu(view, false);
                ZAChartSortMenu.showAxisSortMenu(view, axisSrtHeader, actValMenu, xValMenu, yValMenu, view.chartSelectedEl.isMultiY);
                break;

            default: // click from tool bar sort menu
                ZAChartSortMenu.showAxisSortMenu(view, axisSrtHeader, actValMenu, xValMenu, yValMenu, view.chartSelectedEl.isMultiY);
                ZAChartSortMenu.isLegendSortAllowed(view) ? ZAChartSortMenu.displayLegendMenu(view, true) :
                                                ZAChartSortMenu.displayLegendMenu(view, false);
        }
    }

    this.isLegendSortAllowed = function(view)
    {
//        if(view.chartArea.legendList && !view.chartSelectedEl.isMultiY && view.graphSelected!=="PIE")
//        {
//            return view.legendSortAllowed;
//        }
//        else 
    	
    	var legendModel = view.chartObj && view.chartObj.getLegendModel();
    	if(legendModel instanceof ZCColorLegendModel)
		{
    		return view.legendSortAllowed;
		}
    	return false;
    }

    // show (along with tick mark) or hide legend sort menu
    this.displayLegendMenu = function(view, status)
    {
        var sortMenu = $("ZDBChartSortMenu");
        ZDBUtil.setNamedChildEls(sortMenu, sortMenu);
        var els = new Array(sortMenu.legSrtHeader, sortMenu.legAscSrt, sortMenu.legDesSrt);
        ZAChartSortMenu.displayEls(els, status);
        var custSortEl = new Array(sortMenu.legCustSrt);
        var showCustSrt = status, menuNameChange = false;
        if(view.viewCtx.isStandAlone() || view.permissions.designModify==0)  // standalone or shared view
        {
            if(view.legendCustomSortId)
            {
                showCustSrt = true;
                menuNameChange = true;
            }
            else
            {
                showCustSrt = false;
            }
        }
        if(!view.legendCustSortAllowed)
        {
            showCustSrt = false;
        }
        var custSortMenu = $("ZALegendCustomSort");
        custSortMenu = custSortEl[0];
        custSortMenu.style.display = "none";
        if(showCustSrt && status)
        {
            custSortMenu.style.display = "";
            var custSrtEl = [custSortMenu];
            if(menuNameChange)
            {
                var text = custSrtEl[0].innerHTML;
                var idx = text.toLowerCase().indexOf("<span");
                custSrtEl[0].innerHTML = ZDBI18NMap.g("zrpt.toolbar.sort.js.share_customSort")
                    + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +    //No I18N
                    text.substring(idx);
            }
        }

        if(status) // to show tick mark
        {
            var legIdx = 0;
            var legendTickEls = new Array(sortMenu.legAscTick, sortMenu.legDesTick, sortMenu.legCustTick);
            ZAChartSortMenu.displayTickMark(legendTickEls, -1); // remove all tick marks
            if(view.legendSortVal) {
                legIdx = view.legendSortVal;
            }
            var legCustSortTick = $("legCustomTick");
            if(view.legendCustomSort && view.legendCustomSortId &&
                            view.legendCustSrtColId == ZDBChartSort.getColumnId(view, "COLORAXIS")) //No I18N
            {
                legCustSortTick.className = "sortTickMenu";
                legCustSortTick.style.display = "";
            }
            else
            {
                legCustSortTick.className = "";
                legCustSortTick.style.display = "none";
                ZAChartSortMenu.displayTickMark(legendTickEls, legIdx);
            }
        }
    }

    this.showTickMark = function(view)
    {
        var ascTxtEl  = $("srtByTextAscTick");
        var desTxtEl  = $("srtByTextDscTick");
        var yascValEl = $("ZASortAscTick");
        var ydesValEl = $("ZASortDescTick");
        var xascValEl = $("ZASortXAscTick");
        var xdesValEl = $("ZASortXDscTick");
        var custSortEl = $("ZACustomTick");
        if(yascValEl==null || ydesValEl==null || ascTxtEl==null || desTxtEl==null ||
                                xascValEl==null || xdesValEl==null)
        {
            return;
        }

        var catAxis = view.sortAllowedAxis;
        var srtAxis = view.sortAxis;
        var srtVal = view.sortVal;
        if(srtAxis=="NONE")
        {
            srtVal = 0;
            if(view.graphSelected=="PIE" && (view.subGraphType=="FUNNEL" || ZDBGlobal.sortPieDesc) ) // for funnel,pie,ring set sort by val as default
            {
                srtVal = 1;
                srtAxis = ZDBChartSort.getRevAxis(srtAxis);
            }
            else
            {
                srtAxis = catAxis;
            }
        }

        if(view.singleAxis) {
            srtAxis = catAxis;
        }

        var srtRowArray = new Array(ascTxtEl, desTxtEl, yascValEl, ydesValEl, xascValEl,
                                            xdesValEl, custSortEl);
        var idx=0;
        if(catAxis==srtAxis) {
            idx = (srtVal==1) ? 1 : 0;
        }
        else {
            if(catAxis=="XAXIS") {
                idx = (srtVal==1) ? 3 : 2;
            }
            else {
                idx = (srtVal==1) ? 5 : 4;
            }
        }
        
        if(view.customSort==true)
        {
            var colId = ZDBChartSort.getSortAxisColId(view);
            var csColId = view.custSrtColId;
            if(csColId==colId) {
                idx = 6;
            }
        }
        if(view.sortAxis === "YAXIS" && view.chartSelectedEl.isMultiY) {
            idx = 0;
        }
        ZAChartSortMenu.displayTickMark(srtRowArray, idx);
    }

    // display drop down menu related to axis sort
    this.showAxisSortMenu = function(view, sortHeader, actValMenu, xValMenu, yValMenu, isMultiY)
    {
        ZAChartSortMenu.displayEls(actValMenu, true);
        var axisVal = view.sortAllowedAxis.charAt(0);
        var showXValMenu = false, showYValMenu = false;
        if(axisVal=="X" && !(isMultiY || view.singleAxis)) {
            showYValMenu = true;
        }
        else if(axisVal=="Y" && !view.singleAxis) {
            showXValMenu = true;
        }
        ZAChartSortMenu.displayEls(xValMenu, showXValMenu);
        ZAChartSortMenu.displayEls(yValMenu, showYValMenu);
        sortHeader.style.display = "";
        $("ZASortHeaderText").innerHTML = ZDBI18NMap.f("zrpt.toolbar.sort.js.headerText", axisVal);
        ZAChartSortMenu.showCustomSortMenu(view, axisVal);
    }

    // hide drop down menu related to axis sort
    this.hideAxisSortMenu = function(sortMenu, sortHeader, actValMenu, xValMenu, yValMenu)
    {
        sortHeader.style.display = "none";
        ZAChartSortMenu.displayEls(actValMenu, false);
        ZAChartSortMenu.displayEls(xValMenu, false);
        ZAChartSortMenu.displayEls(yValMenu, false);
        sortMenu.custSrt.style.display = "none";
    }

    this.showCustomSortMenu = function(view, axisVal)
    {
        var showCustSrt=false, menuNameChange=false;
        if(view.viewCtx.isStandAlone() || view.permissions.designModify==0) // standalone or shared view
        {
            if(view.customBaseId)
            {
                showCustSrt = true;
                menuNameChange = true;
            }
        }
        else if(view.isCustSortAllowed) // owner
        {
            showCustSrt = true;
        }

        var custSortMenu = $("ZACustomSort");
        custSortMenu.style.display = "none";
        if(showCustSrt)
        {
            custSortMenu.style.display = "";
            var custSrtEl = [custSortMenu];
            custSrtEl[0].setAttribute("tipdesc1", ZDBI18NMap.f("zrpt.toolbar.sort.js.custSrtToolTip", axisVal));
            if(menuNameChange)
            {
                var text = custSrtEl[0].innerHTML;
                var idx = text.toLowerCase().indexOf("<span");
                custSrtEl[0].innerHTML = ZDBI18NMap.g("zrpt.toolbar.sort.js.share_customSort")
                    + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +    //No I18N
                    text.substring(idx);
            }
        }
    }

    this.displayTickMark = function(srtRowArray, idx)
    {
        for(var i=0; i<srtRowArray.length; i++)
        {
            var el = srtRowArray[i];
            el.className = "";
            el.style.display = "none";
            if(i==idx)
            {
                el.className = "sortTickMenu";
                el.style.display = "";
            }
        }
    }

    // show or hide the given els
    this.displayEls = function(els, status)
    {
        var display = "none"; //No I18N
        if(status) {
            display = "";
        }
        for(var i=0; i<els.length; i++) {
            els[i].style.display = display;
        }
    }

} // jshint ignore:line