//$Id$

var ZDBDesignGrid = new function()
{
    this.NOLOOKUP = "";

  this.createGrid = function(dbId,objId,displayName,designModTime)
  {
    var gridObj = new ZDBDataGrid();
    gridObj.dbId = dbId;
    gridObj.type="TableDesign";
    ZDBDesignGrid.updateDetails(gridObj,objId,displayName);
    gridObj.save = ZDBDesignGrid.save;
    gridObj.showSavedMsg = ZDBDesignGrid.showSavedMsg;
    gridObj.validateRowFunc = ZDBDesignGrid.validateRowFunc;    
    gridObj.designModTime = designModTime;
    gridObj.isFieldExists = ZDBDesignGrid.isFieldExists;
    gridObj.noUIUpdations = true;
    gridObj.setRefErrors = ZDBDesignGrid.setRefErrors;
    gridObj.addDeletedRows = ZDBDesignGrid.addDeletedRows;
    gridObj.getCellObj = ZDBDesignGrid.getCellObj;
    gridObj.clearOptionCols = ZDBDesignGrid.clearOptionCols;
    gridObj.showDatatype = false;
    gridObj.showSortIcon = false;
    gridObj.askCheckSave = true;
    return gridObj;
  }

  /**
   *This is an gridobj instance function!!
   */
  this.save = function(requestOptions)
  {
	if(!(this.objId > 0) && this.modified == 0)
	{
		ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.tbleditdesign.zdbalertmsg.js.emptyColErrMsg"));
	}
    if(!this.checkSave())
    {
      return;
    }
    var url = CommAPI.DESIGNURL;
    if(!(this.objId > 0))
    {//Note : requestOptions has to be null. 
      if(!ZDBCreateViewAPI.getNameForNewView(this,requestOptions))
      {
        return;
      }
      url += ZDBCreateViewAPI.getNewNameInfoAsParams(this);
      this.newTable= true;
    }
    CommAPI.sendModData(this,url,requestOptions);
    var lookUpEl = ZDBClientUI.TBLLIST;
    ZDBClientUI.clearCache();
    var objId = this.objId;
    if(objId > 0)
	{
    	var objIdsToDropCache = [objId];
    	var colHeaders = this.colHeaders;
    	var refColIndex;
    	for(var i=0; i<colHeaders.length; i++)
    	{
    		if(colHeaders[i].colName == "REFERREDCOLUMN")
    		{
    			refColIndex = i;
    			break;
    		}
    	}
    	var rowsToUpdate = this.rowsToUpdate;
    	var refColCell, modifiedValue, colEl, tblEl, objId;
    	for(var i=0; i<rowsToUpdate.length; i++)
    	{
    		refColCell = rowsToUpdate[i].values[refColIndex];
    		modifiedValue = refColCell.modifiedValue;
    		if(modifiedValue && modifiedValue != "")
    		{
    			colEl = DOMUtils.getFirstMatchingChild(lookUpEl, "*", "value", modifiedValue);
    			tblEl = colEl.parentNode;
    			objId = tblEl.getAttribute("objId");
    			objIdsToDropCache.push(objId);
    			
    		}
    	}
    	for(var i=0; i<objIdsToDropCache.length; i++)
    	{
    		ZDBClientUtil.deleteJsonForObjId(objIdsToDropCache[i]);
    	}
	}
  }
  
  
  /**
   *This is an gridobj instance function!!
   */
  this.showSavedMsg = function(addedCount,modifiedCount,deletedCount)
  {
    if(this.newTable)
    {
      ZDBMsgBox.showSuccess(ZDBI18NMap.f("zrpt.common.tbleditdesign.successmsg.js.newTblCreation", ZDBEscapeUtil.encodeForHtml(this.displayName)));
      this.newTable = false;
      this.newName = null;
      this.newDesc = null;
    }
    else
    { 
      ZDBMsgBox.showSuccess(ZDBI18NMap.f("zrpt.common.tbleditdesign.successmsg.js.designModified", ZDBEscapeUtil.encodeForHtml(this.displayName)));
//                              + ". (Columns: "
//                             + ((addedCount)? " added " + addedCount:"")
//                             + ((modifiedCount)? " modified " + modifiedCount:"")
//                             + ((deletedCount)? " deleted " + deletedCount:"") + ");");      
   
      //Design save will not do a full refresh of data. Hence explicit clean up of the dummy cols
      //(DATATYPEOPT, MANDATORYOPT, REFERREDCOLUMNOPT) is done here 
      this.clearOptionCols();
    }
  }

  this.clearOptionCols = function()
  {
    var idx1 = this.getColumnIndex("DATATYPEOPT");
    var idx2 = this.getColumnIndex("MANDATORYOPT");
    var idx3 = this.getColumnIndex("REFERREDCOLUMNOPT");
    for(var i = 0;i < this.rowData.length - 1;i++)
    {
      this.rowData[i].values[idx1].originalValue = null;
      this.rowData[i].values[idx2].originalValue = null;
      this.rowData[i].values[idx3].originalValue = null;
    }
  }

  /**
   *This is an gridobj instance function!!
   */
  this.validateRowFunc = function(row)
  {
    var validRow = [true];
    var gridObj = row.parGrid;
    var dataTypeData = row.values[gridObj.getColumnIndex("DATATYPE")];
    var refTypeData = row.values[gridObj.getColumnIndex("REFERREDCOLUMN")];
    var refTemp = refTypeData.getValue('display');
    var originalDataType =row.values[gridObj.getColumnIndex("DATATYPE")].originalValue;
    var refValue =  refTemp == undefined || refTemp === '' || refTemp == null ? "" : refTemp;
    
    var newErrMsg = (((dataTypeData.getValue() == ZDBDesignGridConst.REFCOLID)
                    && (refValue == ZDBDesignGrid.NOLOOKUP)) || ((dataTypeData.getValue() == ZDBDesignGridConst.RELCOLID)
                    && (refValue == ZDBDesignGrid.NOLOOKUP)))? ZDBI18NMap.g('zrpt.toolbar.table.editdesign.js.selLoopUp'):(((dataTypeData.getValue() != ZDBDesignGridConst.REFCOLID) && (originalDataType != ZDBDesignGridConst.REFCOLID))
                && (refValue != ZDBDesignGrid.NOLOOKUP) && !(originalDataType != ZDBDesignGridConst.RELCOLID))? ZDBI18NMap.g('zrpt.toolbar.table.editdesign.js.loopUpDataTypeErr'):null;

    var errorMsg = (newErrMsg == null && refTypeData.errorMsg != "") ? null : newErrMsg;
    var datatypeConvError = (originalDataType == ZDBDesignGridConst.REFCOLID && dataTypeData.getValue() != ZDBDesignGridConst.REFCOLID && refValue != ZDBDesignGrid.NOLOOKUP)?"zrpt.toolbar.table.editdesign.js.loopUpDataTypeErr_new":null;
    if(datatypeConvError==null)
    {
    ZDBDesignGrid.setError(refTypeData, errorMsg, validRow);
    }
    else
    {
    ZDBDesignGrid.setError(refTypeData, datatypeConvError, validRow,true);
    }
    var mandatoryData = row.values[gridObj.getColumnIndex("MANDATORY")];
    errorMsg = ((dataTypeData.getValue() == ZDBDesignGridConst.REFCOLID && refValue != ZDBDesignGrid.NOLOOKUP)&& (mandatoryData.getValue() == "true"))?
    ZDBI18NMap.g('zrpt.toolbar.table.editdesign.js.loopUpMandSetErr'):null;
    ZDBDesignGrid.setError(mandatoryData, errorMsg, validRow);
    errorMsg = null;
    var defaultData = row.values[gridObj.getColumnIndex("DEFAULT")];
    errorMsg = ((dataTypeData.getValue() == ZDBDesignGridConst.REFCOLID && refValue !== ZDBDesignGrid.NOLOOKUP) && (defaultData.getValue() != null && defaultData.getValue() !== '')) ?
    ZDBI18NMap.g('zrpt.toolbar.table.editdesign.js.loopUpDefSetErr') : 
        ((dataTypeData.getValue() == ZDBConst.DATE || dataTypeData.getValue() == ZDBConst.DATE_AS_DATE) && (defaultData.getValue() != null && defaultData.getValue() !== '')) ?
    ZDBI18NMap.g('zrpt.toolbar.table.editdesign.js.dateColDefSetErr') : null;
    ZDBDesignGrid.setError(defaultData, errorMsg, validRow);
    errorMsg = null;
    var src = dataTypeData.originalValue;
    var tgt = dataTypeData.getValue();
    if(tgt == ZDBDesignGridConst.AUTO_NUMBER)
        {
            if(mandatoryData.getValue() == "true")
          {
                    errorMsg = ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.AutoNumMandSetErr");
                    ZDBDesignGrid.setError(mandatoryData, errorMsg, validRow);
          }
 
            if(defaultData.getValue() != null && defaultData.getValue() !== '')
            {
                errorMsg = ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.AutoNumDefSetErr");
                ZDBDesignGrid.setError(defaultData, errorMsg, validRow);
            }
 
            if(refValue != ZDBDesignGrid.NOLOOKUP)
      {
                errorMsg = ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.AutoNumLookUpErr");
 
                ZDBDesignGrid.setError(refTypeData, errorMsg, validRow);
      }
        }
        else if(tgt == ZDBDesignGridConst.URL && defaultData.getValue() != null 
            & defaultData.getValue() !== '')
        {
      errorMsg = ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.URLDefSetErr");
            ZDBDesignGrid.setError(defaultData, errorMsg, validRow);
    }
    else if(tgt == ZDBDesignGridConst.MULTI_LINE && defaultData.getValue() != null 
            && defaultData.getValue() !== '')
    {
      errorMsg = ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.multiLineDefSetErr");
            ZDBDesignGrid.setError(defaultData, errorMsg, validRow);
    }
    else if(tgt == "9" && refValue != ZDBDesignGrid.NOLOOKUP)
{
errorMsg = ZDBI18NMap.g("zrpt.common.tbleditdesign.showinfo.js.dateLookUpErr");
            ZDBDesignGrid.setError(refTypeData, errorMsg, validRow);
}        
    if(ZDBDesignGrid.getColumnValue(dataTypeData, "FORMULACOLUMN") != null &&
       src != tgt && !ZDBValidator.formulaColDataTypeChg(src,tgt) && ZDBDesignGrid.getColumnValue(dataTypeData, "FORMULACOLUMN") != ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.addformula"))  // No i18N
    {
      errorMsg = ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.FormulaTypeChangeErr");
    }
    errorMsg = datatypeConvError!=null?null:errorMsg;
    ZDBDesignGrid.setError(dataTypeData, errorMsg, validRow);
    errorMsg = null;
    
    var colNameObj = row.values[gridObj.getColumnIndex("FIELDNAME")];
    ZDBDesignGrid.validateColName(colNameObj,validRow);
    
    return validRow[0];
  }

  this.validateColName = function(colNameObj, validRow)
  {
    var colName = colNameObj.getValue();
    if(colName == null) 
    {// not null validation is done in cell level(ZDBGridComponents) - since mandatory column
      return validRow; 
    }
    var errorMsg = (colName.trim().length == 0) ? ZDBI18NMap.g("zrpt.common.table.zdbalertmsg.js.emptyColName") : null;
    if(errorMsg == null)
    {
      errorMsg = (colName.length > ZDBConst.COLNAME_MAX_LENGTH) ? ZDBI18NMap.f("zrpt.toolbar.table.editdesign.js.ColNameMaxLnErr",ZDBConst.COLNAME_MAX_LENGTH) : null;
    }              
    if(errorMsg != null)
    {                
      colNameObj.setValidatedInfo(errorMsg,"CELL");
      validRow[0] = false;
    }
  }

  this.setRefErrors = function(errRows)
  {
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.tbleditdesign.zdbalertmsg.js.saveErr"));
    this.sent = 0;
    this.addDeletedRows();
    for(var i = 0;i < errRows.length;i++)
    {
      var fieldId = errRows[i][0];
      var header = errRows[i][1];
      var innerHtml = errRows[i][2];
      for(var j = 0;j < header.length;j++)
      {
        var cellObj = this.getCellObj(fieldId, this.getColumnIndex(header[j]));
        cellObj.refErrorMsg = innerHtml;
        cellObj.rowObj.sentStatus = 0;
        cellObj.setClass();
      }
     }
     this.refError = true;
  }

  this.addDeletedRows = function()
  {
    for(var i = 0; i < this.rowsToUpdate.length; i++)
    {
      var row = this.rowsToUpdate[i];
      row.deleted = false;
      if(row.status == ZDBConst.DELETED)
      {
        row.deleted = true;
        this.addNewRow(row,ZDBDataGrid.getLastRowIndex(this.rowData, false) + 1,true);
      }
    }
    this.resetDummyTop();
  }

  this.showRefErrorMsg = function(cellObj)
  {
    var refEl = ZDBContentCache.appendAndGet("Ref_Error_Dlg","GridMenu",document.body);
    this.ZDBREFERENCE_ERROR = refEl;
    refEl.style.display = "block";
    var div = ZDBUtil.getCachedRef(refEl, "ZDBREFERR_CONTENT");
    div.style.width="400px";
    var colName = cellObj.rowObj.values[cellObj.colObj.parGrid.getColumnIndex("FIELDNAME")].getValue();
    var errorHeader = (cellObj.rowObj.deleted) ? "zrpt.toolbar.table.editdesign.coldelerrdlg.js.ColDelErr" : "zrpt.toolbar.table.editdesign.coldelerrdlg.js.ColModErr"; //No I18N
    div.innerHTML = "<br/><strong>" + ZDBI18NMap.f(errorHeader,ZDBEscapeUtil.encodeForHtml(colName))+"</strong><br/>" + cellObj.refErrorMsg; //No I18N
    this.ZDBREFERENCE_ERROR.cellObj = cellObj;
    refEl.gridObj = cellObj.colObj.parGrid;
    ZDBDialogUtil.showDialog(refEl,{MODAL:true,TITLE:ZDBI18NMap.g("zrpt.toolbar.table.editdesign.coldelerrdlg.js.ColDelErrDlgTtl"),ADDFRAME:true,
                                    ONCLOSE:ZDBDesignGrid.closeRefErrDlg,DONTREMOVE:true});
  }

  this.closeRefErrDlg = function(srcEl)
  {
    var cellObj = ZDBDesignGrid.ZDBREFERENCE_ERROR.cellObj;
    if(cellObj)
    {
      var gridObj = cellObj.colObj.parGrid;
      gridObj.setCurrentCell(cellObj);
    }
    return true;
  }

  this.updateDetails = function(gridObj,objId,displayName)
    {
      gridObj.displayName = displayName;
      if(objId != null)
      { 
        gridObj.objId = objId;
      }
    }

  this.updateDrillDetNshowOptns = function(cellObj,event)
  {
   
    ZAComboList.closeList(event, true);   
//    var datatypeNo = cellObj.rowObj.values[cellObj.rowObj.parGrid.getColumnIndex("DATATYPE")].originalValue;
    var type = ZDBUtil.getOrigColTypeForEl(cellObj);
//    var idx = cellObj.rowObj.values[0].getValue();
//    var parViewColHdr = ZDBClientUI.ZDBViewEl.view.colHeaders[parseInt(idx)+1];      
    var isAllowedForDrill = ZDBUtil.isColTypeAllowedForDrill(cellObj);
//    if(type == "RELCOL" || type == "REFCOL")
//    {
      
//    }
    if(!isAllowedForDrill)
    {
      return;
    }
    if(!ZDBLazyLoadUtil.loadSnippet("DrillSettings","/ZDBDrillDown.cc?",this,"APPENDTODOC",["ZDBAnalysisViewList","ChartTPVendors","ZRJSChartsList","ZAAnalysisFields"],ZDBDesignGrid.updateDrillDetNshowOptns,[cellObj,event]))
    {
    	return;
    }
   urls = ["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_VMFILTERSTYLES"];//NO I18N
   if(!ZDBLazyLoadUtil.loadCssOnly(urls, "APPENDTODOC", 
		   ZDBDesignGrid.updateDrillDetNshowOptns,[cellObj])){
   	return;
   }
   if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBDesignGrid.updateDrillDetNshowOptns,[cellObj]))
   {
       return;
   }
   DrillDownSettings.updateRefToTblView();
   var gridObj = cellObj.rowObj.parGrid;
   var objId = gridObj.objId;
   var colId = cellObj.rowObj.values[gridObj.getColumnIndex("FIELDID")].originalValue;
   var colName = cellObj.rowObj.values[gridObj.getColumnIndex("FIELDNAME")].originalValue;
   colName = ZDBEscapeUtil.encodeForHtml(colName);
   if(!colName) {return;}
   if( type === 'DATE' || type === 'DATE_AS_DATE')
   {
      //        Open dialog
      var drillDlg = DrillDownSettings.showDrillSettingsDlg(gridObj,colName,cellObj.cellEl,colId,type);
      drillDlg.cellObj = cellObj;
      drillDlg.type = type;
      drillDlg.colId = colId;
      var drillFlow = cellObj.originalValue;
            
      drillDlg.colName = cellObj.colObj.colName;
      var idx = cellObj.rowObj.parGrid.getColumnIndex(drillDlg.colName + 'OPT'); //No i18N
      var drillOptionsObj = cellObj.rowObj.values[idx];
      var enabledOp = drillOptionsObj.originalValue;
      if(cellObj.modifiedValue!=null)
      {
        enabledOp = drillOptionsObj.modifiedValue!=null ? drillOptionsObj.modifiedValue : enabledOp;
        drillFlow = ZDBDesignGridDrill.getFormattedDrillFlowForNewVal(drillDlg,objId,cellObj.modifiedValue,enabledOp);
        return;
      }
      
      DrillDownSettings.updateDrillFlowByType(drillFlow, drillDlg,enabledOp);
      // fetching combo list in prior
      DrillDownSettings.fetchNUpdateDrillComboList(objId);
    }
    else if(isAllowedForDrill)
    {
      
      var dArea = cellObj.colObj.parGrid.dArea;  
      var comboHdr =cellObj.comboHdr;
      if(!cellObj.comboHdr)
      {
        var comboTpl = ZDBClientUI.ZDBViewEl.view["DRILLFLOWCOMBOTPL"];
        comboHdr = cellObj.comboHdr = comboTpl.cloneNode(true);;
        ZDBUtil.setNamedChildEls(comboHdr,comboHdr);
        comboHdr.cellObj=comboHdr.compElContainer.cellObj = cellObj;
        dArea.appendChild(comboHdr);
        comboHdr.cellObj = cellObj;
        ZDBClientUI.positionComboHdr(cellObj,dArea);
      }
      jQuery(comboHdr).show();
      var attrs = [comboHdr.compElContainer,type,colId,event];
      DrillDownSettings.fetchNUpdateDrillComboList(objId,DrillDownSettings.showComboList,attrs);
    }
  }
  
  this.showFKCols = function(cellObj)
  {
    if(ZDBDesignGrid.isFormulaField(cellObj) || ZDBDesignGrid.isANCType(cellObj))
    {
      return;
    }
    var gridObj = cellObj.rowObj.parGrid;
    if(ZDBClientUI.TBLLIST == null)
    {
      var params = "DBID=" + gridObj.dbId //NO I18N
      AjaxAPI.sendRequest({URL:CommAPI.SHOWFKCOLSURL ,PARAMETERS:params,
                                 ONSUCCESSFUNC:"ZDBClientUI.showCombo",
                                 CELLOBJ:cellObj,OBJID:gridObj.objId});
    }
    else
    {
      ZDBClientUI.showList(cellObj,gridObj.objId);      
    }
  }

  

  this.customFunc = function(event)
  {
    //$$  onblur of lookup column list called twice - need to check
    var cellObj = this.cellObj;
    var rowObj = cellObj.rowObj;
    var gridObj = rowObj.parGrid;
    var values = rowObj.values;
    var listObj = this[this.selectedIndex];
    this.clearError = true;
        
        
    if(listObj == null){return;}
    if(this.selectedIndex != 0)
    {
      var listObj = this[this.selectedIndex];
      var subtype = listObj.getAttribute("subtype");
      var lookupType=listObj.getAttribute("lookupType");
      if(subtype == "9" || lookupType == "14" || subtype == "22")
      {
        this.clearError = false;
        this.cellObj.errorMsg = (subtype == "9" || subtype == "22") ? ZDBI18NMap.g("zrpt.common.tbleditdesign.showinfo.js.dateLookUpErr") :
                                                          ZDBI18NMap.g("zrpt.common.tbleditdesign.showinfo.js.multiLookUpErr");
        ZDBMsgBox.showInfo(this.cellObj.errorMsg);
        return;
      }
      var dispValue = ZDBEscapeUtil.decodeForHtml(listObj.innerHTML) + " in " + listObj.getAttribute("displayname");	//No I18N
      
      if(gridObj.disablePhysicalLookup!=true && gridObj.disablePhysicalLookup!=undefined)
      {
      values[gridObj.getColumnIndex("DATATYPE")].reset(ZDBDesignGridConst.REFCOLID,"Lookup Column");//No i18N
      }
      if(rowObj.status == ZDBConst.CLEAR)
      {// saved
        cellObj.oldDispValue = cellObj.displayValue;
      }
      cellObj.setValue(listObj.value,dispValue, true, false);
      if(ZDBClientUI.showInvokeOptionDlg)
      {
	      ZDBDesignGrid.invokeOptionDlg(this); // hide for OnPremise
      }
      var isPiiColumn = (listObj.getAttribute("pii") == "true") ? true : false;
      for(var i = 0; i < rowObj.values.length; i++)
      {
        if(rowObj.values[i].colObj.colName == "PII")
        {
          var piiCellObj = rowObj.values[i];
          break;
        }
      } 
      if(isPiiColumn)
      {
        piiCellObj.setValue("true","Yes",true,false); //No I18N
        piiCellObj.editDisabled = true;
      }
      else
      {
        piiCellObj.setValue("false","No",true,false); //No I18N
        piiCellObj.editDisabled = false;
      }
    }
    else
    {
      var dataType = values[gridObj.getColumnIndex("DATATYPE")];
      if(dataType.getValue() == ZDBDesignGridConst.REFCOLID || dataType.getValue() == ZDBDesignGridConst.RELCOLID)
      {//To reset the datatype to Plain Text once the lookup column is selected to NONE
        values[gridObj.getColumnIndex("DATATYPE")].reset(ZDBDesignGridConst.PLAINTEXTID,"Plain Text");//$$ Wrong!! - Needs to be handled!!
      }
      cellObj.setValue(ZDBDesignGrid.NOLOOKUP,"", true, false, true);
    }
  }
      
  this.showDataTypes = function(cellObj)
  {
    var newList = document.getElementById("DATATYPE").cloneNode(true);
    newList.removeAttribute("id");
    newList.removeAttribute("name");
    var nodeList = newList.getElementsByTagName("option");
    var node;
    var dateType;
    for(var i = nodeList.length - 1; i >= 0; i--)
    {
      node = nodeList.item(i);
      var type = node.getAttribute("value");
      if(type !== null && type !== undefined)
      {
        if(type === ZDBConst.RELCOL.toString() || (type === ZDBConst.REFCOL.toString() && cellObj.originalValue !=ZDBConst.REFCOL && (cellObj.rowObj.parGrid.disablePhysicalLookup==undefined || cellObj.rowObj.parGrid.disablePhysicalLookup == true)) )
        {
          node.parentNode.removeChild(node);
        }
        if(type === ZDBConst.DATE_AS_DATE.toString())
        {
            dateType = ZDBConst.DATE_AS_DATE;
        }
        if(type === ZDBConst.DATE.toString())
        {
            dateType = ZDBConst.DATE;
        }
      }
    }
    

    var list = newList;                  
    list.gridObj = cellObj.rowObj.parGrid;
    list.cellObj = cellObj;
    var colSubTypeOrig = cellObj.originalValue;
    if(colSubTypeOrig === ZDBConst.RELCOL.toString())
    {
        cellObj.originalValue =ZDBConst.REFCOL;
    }
    if(colSubTypeOrig == ZDBConst.DATE.toString() || colSubTypeOrig == ZDBConst.DATE_AS_DATE.toString())
    {
	cellObj.originalValue = dateType;
	colSubTypeOrig = dateType;
    }
    ZDBEditors.configureListEditor(cellObj,list);
    cellObj.originalValue =colSubTypeOrig;
    list.onBlurCustomFunc = ZDBDesignGrid.onBlurForDataType;
    ZDBEditors.showListEditor(cellObj,list);
    //node.parentNode.appendChild(removednode);
  }  

  this.invokeOptionDlg = function(list)
  {
    var cellObj = list.cellObj;
    var rowObj = cellObj.rowObj;
    if(!cellObj)
    {
      return;
    }
    var colName = cellObj.colObj.colName;
    if(colName == "DATATYPE" || colName == "REFERREDCOLUMN")
    {
      if(cellObj.modifiedValue != null) 
      {
          if(colName == "REFERREDCOLUMN" || ((colName == "DATATYPE") && 
          (cellObj.modifiedValue == ZDBDesignGridConst.REFCOLID.toString() || 
          cellObj.modifiedValue == ZDBDesignGridConst.RELCOLID.toString())))
          {
            if(!ZDBDesignGrid.dialogInvoked)
            {// This is done since customFunc(onBlurCustomFunc) is called from onListItemChange and onListBlur
              if(colName == "DATATYPE" && !rowObj.parGrid.disablePhysicalLookup)
                  {
                    ZDBDesignGrid.showOptionDlg(colName, cellObj);
                  }
            }  
          }
          else if(!ZDBValidator.isLossLess(cellObj.originalValue, cellObj.modifiedValue) && (cellObj.rowObj.status != ZDBConst.CREATED))
          {
          	//$$HACK$$: The statement next to showOptionDlg executes before it load in that function call
          	//So, the lazyload content is again included here
          	 if(!ZDBLazyLoadUtil.loadSnippet("OPTIONSETTINGS_DLG","/ZDBOptionSettings.cc",this,"APPENDTODOC"))
             {
               return;
             }
                  if(colName == "DATATYPE" || !rowObj.parGrid.disablePhysicalLookup)
                  {
                    ZDBDesignGrid.showOptionDlg(colName, cellObj);
                    $("ZDBD_EMPTY").disabled = false;
                    $("ZDBD_ABORT").disabled = false;
                  }
          }
      }
    }
    else if(colName == "MANDATORY")
    {
      if(cellObj.modifiedValue == "true")
      {
        if(ZDBDesignGrid.validateRowFunc(rowObj))
        {
          ZDBDesignGrid.showOptionDlg(colName, cellObj);
        }  
      }
    }
  }

  this.showOptionDlg = function(colName, cellObj)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("OPTIONSETTINGS_DLG","/ZDBOptionSettings.cc",this,"APPENDTODOC"))
    {
      return;
    }
    ZDBDesignGrid.dialogInvoked = true;
    this.curFocusDialog = ZDBDialogUtil.focusDialog;
    var optionEl = ZDBUtil.getCachedRef(this, "ZDBDESIGN_SETTINGS");
    optionEl.gridObj = this;
    optionEl.style.display = "block";    
    var title = ZDBI18NMap.g("zrpt.toolbar.table.editdesign.dataTypeChngdlg.js.dlgTitle",optionEl);
    ZDBDialogUtil.showDialog(optionEl,{MODAL:true, TITLE:title,ADDFRAME:true,
                                       ONCLOSE:this.closeOptionCalledFrmDlg,DONTREMOVE:false}); 
    ZDBDialogUtil.focusDialog.gridObj = this;
    this.displayOptions(colName, cellObj);
    this.ZDBDESIGN_SETTINGS.cellObj = cellObj;
    this.ZDBDESIGN_SETTINGS.colName = colName;
    this.ZDBDESIGN_SETTINGS.zdbAbort.focus();
    if(colName === "REFERREDCOLUMN" || ((colName == "DATATYPE") && 
    (cellObj.modifiedValue == ZDBDesignGridConst.REFCOLID.toString() || 
    cellObj.modifiedValue == ZDBDesignGridConst.RELCOLID.toString())))
    {
    var dlgEl = ZDBDialogUtil.focusDialog.bodyContent;
    DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBD_EMPTY")[0].disabled = true;//No i18N
    DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBD_ABORT")[0].disabled = true;//No i18N
    if($('ZDBNoCascade'))
    	{
		DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBNoCascade")[0].checked=true;//No i18N
   	}    
    }
  }

  this.submitOptionDlg = function()
  {      
    var cellObj = this.ZDBDESIGN_SETTINGS.cellObj;
    var rowObj = cellObj.rowObj; 
    var gridObj = rowObj.parGrid;
    if(gridObj.type == 'Table')
    {
      gridObj.submitOptionDlg();
      return;
    }    
    var idx = ((this.ZDBDESIGN_SETTINGS.colName == "DATATYPE") && //No I18N
    (cellObj.modifiedValue == ZDBDesignGridConst.REFCOLID.toString() || cellObj.modifiedValue == ZDBDesignGridConst.RELCOLID.toString())) ?
    		gridObj.getColumnIndex('REFERREDCOLUMNOPT') : gridObj.getColumnIndex(this.ZDBDESIGN_SETTINGS.colName + 'OPT'); //No i18N
    if((this.ZDBDESIGN_SETTINGS.colName == "REFERREDCOLUMN") || ((this.ZDBDESIGN_SETTINGS.colName == "DATATYPE") && (cellObj.modifiedValue == "14" || cellObj.modifiedValue == "20")))
    {
      var dlgEl = ZDBDialogUtil.focusDialog.bodyContent;
      if($('ZDBConstCascade'))
      {
    	  var consCascade = DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBConstCascade")[0];   //No i18N 
      }
      if($('ZDBConstSetNull'))
      {
    	  var consSetNull = DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBConstSetNull")[0];//No i18N
      }
      if($('ZDBNoCascade'))
      {
    	  var noCascade = DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBNoCascade")[0];//No i18N
      }  
      var lookupColValue=2; // No action on this (child) table default value is 2
      if($('ZDBConstCascade') || $('ZDBConstSetNull') || $('ZDBNoCascade'))
      {
    	  lookupColValue= (consCascade.checked) ? consCascade.value : (noCascade.checked) ? noCascade.value : consSetNull.value;
      }
      rowObj.values[idx].fkConstraint = lookupColValue;
    }
    var arr = ["ABORT","DEFAULT","EMPTY"];
    //This is hack. To be removed once we fixed the default selection for the conversion option
    //"ABORT" option is selected as default.
    rowObj.values[idx].setValue(arr[0], arr[0], false, false);
    for(var i=0;i < arr.length;i++)
    {      
      if($('ZDBD_' + arr[i]).checked)
      {
        if(arr[i] == "DEFAULT")
        {
          var idx1 = gridObj.getColumnIndex("DEFAULT"); 
          var defVal = rowObj.values[idx1].getValue();
          if(defVal == null)
          {
            ZDBDialogUtil.closeDialog();
            ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.tbleditdesign.showinfo.js.defValMisErr"));
            gridObj.setCurrentCell(rowObj.values[idx1]);
            return;
          }
        }
        rowObj.values[idx].setValue(arr[i], arr[i], false, false);
        break;
      }
    }    
    ZDBDialogUtil.closeDialog(null,null,false);
  }
  
  this.closeOptionCalledFrmDlg = function(dlg,action)
  {
     ZDBDialogUtil.focusDialog = this.curFocusDialog;
     var gridObj = dlg.gridObj
     var cancel = true;
     if(action != null)
     {
      cancel = action;
     }
     gridObj.closeOptionDlg(cancel);
     ZDBDesignGrid.dialogInvoked = false;
     return true;
  }

  this.closeOptionDlg = function(cancel)
  {
    var cellObj = this.ZDBDESIGN_SETTINGS.cellObj;
    if(cancel)
    {
      cellObj.setValue(cellObj.originalValue,cellObj.oldDispValue,true,false);
    }
    cellObj.colObj.parGrid.setCurrentCell(cellObj);
  }

  this.displayOptions = function(colName, cellObj)
  {
    var tbl = ZDBUtil.getCachedRef(this,"ZDBDESIGN_OPTION");
    var nodes = tbl.getElementsByTagName('tr');
    var zdbAbort = $('ZDBD_ABORT');
    var cellValue = cellObj.getValue();
    zdbAbort.setAttribute("checked",false);
    this.ZDBDESIGN_SETTINGS.zdbAbort = zdbAbort;
    $('ZDBD_DEFAULT').setAttribute("checked",false);
    $('ZDBD_EMPTY').setAttribute("checked",false);
    var chosenType = ZDBDesignGrid.getColumnValue(cellObj, colName + 'OPT');
    if(chosenType)
    {
      $('ZDBD_' + chosenType).checked = true;
    }
    else
    {      
      zdbAbort.checked = true;
    }
    for(var i = 0;i < nodes.length;i++)
    {
      var tr = nodes[i];
      if(tr.getAttribute && tr.getAttribute("type") != null)
      {
        var type = tr.getAttribute("type");
        if(colName == "DATATYPE" && type != "CONSTRAINT")
        {
          var isLookUpCol = (cellValue == ZDBDesignGridConst.REFCOLID.toString() || 
  				cellValue == ZDBDesignGridConst.RELCOLID.toString());
          tr.style.display = (isLookUpCol && type == "DEFAULT") ? 'none' : ZDBUtil.visibleTrStyle;
        }
        else if(colName == "MANDATORY" &&
                (type == "DEFAULT" || type == "ABORT"))
        {
            tr.style.display = ZDBUtil.visibleTrStyle;
        }
        else if((colName == "REFERREDCOLUMN" || 
        		(colName == "DATATYPE" && //No I18N
				(cellValue == ZDBDesignGridConst.REFCOLID.toString() || 
				cellValue == ZDBDesignGridConst.RELCOLID.toString()))) &&
                (type == "EMPTY" || type == "ABORT" || type == "CONSTRAINT")) //No I18N
        {
            tr.style.display = ZDBUtil.visibleTrStyle;
        }
        else
        {
            tr.style.display = 'none';
        }
      }
    }
  }

  this.isFormulaField = function(cellObj)
  {
    var formula = ZDBDesignGrid.getColumnValue(cellObj, "FORMULACOLUMN");
    if(formula != null && formula != ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.addformula") && formula) ///PK: to check
    {
      ZDBMsgBox.showInfo(ZDBI18NMap.f("zrpt.common.tbleditdesign.showinfo.js.formulaColEditErr",cellObj.colObj.displayName));
      return true;
    }
    return false;
  }
 
   this.isANCType = function(cellObj)
  {
    var dataType = ZDBDesignGrid.getColumnValue(cellObj, "DATATYPE");
    if(dataType ==  ZDBDesignGridConst.AUTO_NUMBER)
    {
      ZDBMsgBox.showInfo(ZDBI18NMap.f("zrpt.common.tbleditdesign.showinfo.js.autoNumEditErr",cellObj.colObj.displayName));
      return true;
    }
    return false;
  }

 
  this.newTableAdded = function(gridId,objId,displayName)
  {
    var gridObj = ZDBDataGrid.INSTANCES[gridId];
    ZDBDesignGrid.updateDetails(gridObj,objId,displayName);
    ZDBClientUI.newViewAdded(gridObj);
  }

  this.showRefVals = function(cellObj)
  {
    var colHeader = cellObj.colObj;
    AllowedValPopup.showAllowedVal(cellObj,colHeader.parGrid.objId,colHeader.colId,
                                   colHeader.refTblName,colHeader.refColName,colHeader.refDispCol);
  }


  this.getColumnDataTypeForField = function(cellObj)
  {
    var idx =  cellObj.colObj.parGrid.getColumnIndex("DATATYPE"); //NO I18N
    var selValue = cellObj.rowObj.values[idx].getValue();
    if(!selValue)
    {
      ///PK: Issue?
      return "PLAIN"; //NO I18N
    }
    return ZDBUtil.dataTypeNumVsSubtypeDisp[selValue];
  }
  this.getColumnTypeForField = function(cellObj)
  {
    var idx =  cellObj.colObj.parGrid.getColumnIndex("DATATYPE");
    var selValue = cellObj.rowObj.values[idx].getValue();
    if(!selValue)
    {
      ///PK: Issue?
      return "PLAIN";
    }
    if(selValue == 21)
    {
        return "GEO";//NO I18N
    }
    if(selValue == 9 || selValue == 22)
    {
        return "DATE";//NO I18N
    }
    if(selValue == 23)
    {
        return "GEO_NUM";//NO I18N
    }
    if(ZDBDesignGrid.DATATYPECOMBO == null)
    {
      ZDBDesignGrid.DATATYPECOMBO = document.getElementById("DATATYPE");
    }
    var option = DOMUtils.getFirstMatchingElement(ZDBDesignGrid.DATATYPECOMBO.getElementsByTagName("option"),null,"value",selValue); //NO I18N
    var type = option.getAttribute("defaultvaltype");
    return type;
  }

  this.showDerivedFieldUI = function(cellObj)
  {
    var formula = cellObj.originalValue;
    if(ZDBGlobal.haveFormulaSuggestionFeature){
	    if(!ZDBLazyLoadUtil.loadJsAlone(["ZRQueryEditor", "ZDBFormulaSuggestion"],"APPENDTODOC",ZDBDesignGrid.showDerivedFieldUI,[cellObj])) //NO I18N
	    {
	  	  return;
	    }
	    if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_QUERYEDITOR","CSSLIST_FORMULASUGGESTION"],"APPENDTODOC",ZDBDesignGrid.showDerivedFieldUI,[cellObj])){ //NO I18N
	  	  return;
	    }
    }
    if(!ZDBLazyLoadUtil.loadSnippet("ZDBDERIVEDFIELDDLG","/ZDBDerivedField.cc",ZDBDesignGrid,"APPENDTODOC","ZDBFormulaSuggestion"))
    {
      return;
    }

    
      var fieldName = ZDBDesignGrid.getColumnValue(cellObj, "FIELDNAME");  //No I18N
      var fieldId = ZDBDesignGrid.getColumnValue(cellObj, "FIELDID");   //No I18N
      var fieldDesc = ZDBDesignGrid.getColumnValue(cellObj, "DESCRIPTION");		//No I18N
    var gridObj = cellObj.colObj.parGrid;
    fieldName = fieldName == null ? "" : fieldName;
    fieldId = fieldId == null ? "" : fieldId;
    fieldDesc = fieldDesc == null ? "" : fieldDesc;

    if(formula != null && !ZDBUtil.isNewView(gridObj) && formula != ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.addformula"))
    {
      cellObj.rowObj.parGrid.onLostFocus();
      ZDBDerivedField.showDerivedFieldUI(cellObj.colObj.parGrid, fieldName, fieldDesc, formula, fieldId);
    }
    else
      {
      if(formula == ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.addformula") && !ZDBUtil.isNewView(gridObj))
      {
        cellObj.rowObj.parGrid.onLostFocus();
        gridObj.cellObj = cellObj;
        ZDBDerivedField.showDerivedFieldUI(gridObj, fieldName, fieldDesc, "", null, false);
      }
    }  
  }

  this.getColumnValue = function(cellObj, colName)
  {
    var idx =  cellObj.rowObj.parGrid.getColumnIndex(colName);
    return cellObj.rowObj.values[idx].getValue();
  }

  this.isFieldExists = function(fieldName)
  {
    var rowData = this.rowData;
    var cellPos = this.getColumnIndex("FIELDNAME");
    var colNameCount = {};
    for(var i = 1;i < rowData.length - 1;i++)
    {//i starts from 1; In design grid the first row is column header
      var colName = rowData[i].values[cellPos].getValue();
//      while(j < rowData.length - 1)
//      {
//
//      }
      if(colNameCount[colName])
      {
        colNameCount[colName] = colNameCount[colName] ++ ;
      }
      else
      {
        colNameCount[colName] = 1 ;
      }

//      if(colName != null && fieldName.toLowerCase() == colName.toLowerCase())
//      {
//        return true;
//      }
    }
    var j = 0;
    while(j < colNameCount.lenth)
    {
      alert(colNameCount[j]);
      if(colNameCount[j] > 1)
      {
        return true;
      }
    }
    return false;
  } 

  this.getCellObj = function(fieldId, cellPos)
  {
    var rowData = this.rowData;
    var rowLen = rowData.length;
    var curRow;
    for(var i = 0;i < rowLen;i++)
    {
       curRow = rowData[i];
       if(curRow.objType !== ZDBConst.DATA)
       {
        continue;
       }
       if(fieldId == curRow.values[1].getValue())
       {
          return curRow.values[cellPos];
       }
    }
  }

  this.showAddFCMenu = function(el,event)
  {
    var menu = ZDBContentCache.appendAndGet("Formula_Menu", "GridMenu", document.body);
    $("AddFCMenu").style.display="";
    ZDBMenu.showMenuEl(el, event, menu, true, null, 4);
  }

  this.showTDExportMenu = function(el,event)
  {
    var menu = ZDBContentCache.appendAndGet("TableDesign_Export_Menu", "GridMenu", document.body);
    $("TDExportMenu").style.display="";  // No I18N
    ZDBMenu.showMenuEl(el, event, menu, true);
}

}

ZDBColumnType.FKCOL =
{
 valfunc:null,
 editFn:ZDBDesignGrid.showFKCols,
 editorType: "list"
};

ZDBColumnType.DRILLDOWN =
{
 valfunc:null,
// editFn:ZDBDesignGrid.showDrillCols,
 editFn:ZDBDesignGrid.updateDrillDetNshowOptns,
 editorType: "Drillcombo" //NO I18N
};

ZDBColumnType.DATATYPE =
{
  editFn :  ZDBDesignGrid.showDataTypes,
  editorType: "list"
}

ZDBColumnType.FORMULACOL =
{
  valfunc:null,
  editFn:ZDBDesignGrid.showDerivedFieldUI
};

ZDBColumnType.DEFAULTVAL =
{
  dataValFn: function(cellObj)
            { 
                var colType = ZDBDesignGrid.getColumnTypeForField(cellObj);
                var colTypeObj = ZDBColumnType[colType];
                return (colTypeObj.dataValFn != null)? colTypeObj.dataValFn(cellObj,colType): true;
            },
  dispFn : function(cellObj)
            { 
                var colType = ZDBDesignGrid.getColumnTypeForField(cellObj);
                var colTypeObj = ZDBColumnType[colType];
                return (colTypeObj.dispFn != null)? colTypeObj.dispFn(cellObj) : cellObj.isModified() ? cellObj.modifiedValue : cellObj.originalValue;
            },
  editFn :  function(cellObj)
            { 
                if(ZDBDesignGrid.isFormulaField(cellObj) || ZDBDesignGrid.isANCType(cellObj))
                { 
                    return;
                }
                var colType = ZDBDesignGrid.getColumnTypeForField(cellObj);
                return ZDBColumnType[colType].editFn(cellObj);
            },
  convertFn :  function(modifiedValue, cellObj)
            { 
                    var colType = ZDBDesignGrid.getColumnTypeForField(cellObj);
                    var cFn = ZDBColumnType[colType].convertFn; 
                    return (cFn ? cFn(cellObj.getValue(),cellObj) : cellObj.getValue());
            }
}


ZDBDesignGrid.setError = function(dataObj, errorMsg, isValidStatus,showAlert)
{
  if(errorMsg != null)
  {
      dataObj.setValidatedInfo(errorMsg, "ROW");
      isValidStatus[0] = false;
      if(showAlert == true)
      {
        dataObj.cellEl.setAttribute("onClick","ZDBAlertAPI.showMsg(ZDBI18NMap.g(\""+errorMsg+"\"))");
        dataObj.cellEl.removeAttribute("title");
        dataObj.errorMsg = null;
      }
  }
  else
  {
      dataObj.clearError(false, true, false);
      if(dataObj.cellEl != null)
      {
      dataObj.cellEl.removeAttribute("onClick");
        }

  }
}
ZDBDesignGrid.setLookupError = function(dataObj, errorMsg, isValidStatus)
{
  if(errorMsg != null)
  {
      dataObj.setValidatedInfo(ZDBI18NMap.g(errorMsg), "ROW");
      dataObj.cellEl.setAttribute("onClick","ZDBAlertAPI.showMsg(ZDBI18NMap.g(\""+errorMsg+"\"))");
      dataObj.cellEl.removeAttribute("title");
      dataObj.errorMsg = null;
      isValidStatus[0] = false;
  }
  else
  {
      dataObj.clearError(false, true, false);
      dataObj.cellEl.removeAttribute("onClick");
  }
}

ZDBDesignGrid.fetchDesignView = function(element,objId, isRefresh, view, fromExplorer)
  {
	if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", ZDBDesignGrid.fetchDesignView,[element,objId, isRefresh, view, fromExplorer])){
	   	return;
	}
    if(!ZDBLazyLoadUtil.loadSnippet("EDIT_DESIGN_DLG","/ZDBEditDesign.cc?",this,"APPENDTODOC","ZDBGridList",ZDBDesignGrid.fetchDesignView,[element,objId, isRefresh, view, fromExplorer]))
    {
      return;
    }
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    if(gridObj == null && isRefresh)
    {
      gridObj = view;
    }
    if(objId == null && gridObj)
    {
      objId = gridObj.objId;
    }
    var params = "&ZDBACTION=SHEETVIEW";
    if(objId != null)
    {
      params += "&OBJID=" + objId;
    }
    else
    {
      params += "&DBID=" + ZDBClientUI.dbId; 
    }
    var searchVal = "";
    if(gridObj && gridObj.isFilter != undefined && gridObj.isFilter == true)
    {
      searchVal = gridObj.searchValue;
      params += "&ZDBSEARCHVALUE=" + encodeURIComponent(searchVal);  // No I18N
      }

    var viewCtx = null;
    var designDIV = ZDBDesignGrid.getDesignDIV();
    if(!isRefresh)
    {
      if(gridObj == null) // for using design view, we should hide the export, formula, search
      {
        designDIV["SearchBoxTd"].removeAttribute('enabled');  // No I18N
        designDIV["SearchBoxTd"].style.display = 'none';  // No I18N
        designDIV["TDExport"].style.display = 'none';  // No I18N
        designDIV["TDExport"].removeAttribute('onClick');  // No I18N
        designDIV["AddFC"].style.display = 'none';  // No I18N
        designDIV["AddFC"].removeAttribute('onClick');  // No I18N
        if(designDIV["ERDTABLEBTN"])
        { 
        	designDIV["ERDTABLEBTN"].style.display = 'none';  // No I18N
        }
      	designDIV["ZRAddColMenu"].className = "newBtn";
      }
      else
      {
        designDIV["SearchBoxTd"].setAttribute('enabled', 'true');  // No I18N
        designDIV["SearchBoxTd"].style.display = '';  // No I18N
        designDIV["TDExport"].style.display = '';  // No I18N
        designDIV["TDExport"].setAttribute('onClick', 'ZDBDesignGrid.showTDExportMenu(this,event)');  // No I18N
        designDIV["AddFC"].style.display = '';  // No I18N
        designDIV["AddFC"].setAttribute('onClick', 'ZDBDesignGrid.showAddFCMenu(this, event)');  // No I18N
        if(designDIV["ERDTABLEBTN"])
        { 
        	designDIV["ERDTABLEBTN"].style.display = '';  // No I18N
        }
      	designDIV["ZRAddColMenu"].className = "newGrpTextBtn first";
      }

      designDIV["editGridHolder"].innerHTML = "";
      var dispName = null;
//      Uncomment after getting SYSTEMTABLE info.
//      if(fromExplorer)
//      {
//	      var tab = ZDBClientUI.getExistingTab(objId);
//	      if(tab != null)
//	      {
//	    	  var view = (tab.focusedDialog) ? tab.focusedDialog.viewCtx.view :
//		    		tab.view;
//	    	if(view.type == 'TableDesign')
//	    	{
//	    		ZDBClientUI.selectTab(tab);
//		        return;
//	    	}
//	      }
//	      else
//	      {
//	    	  var viewInfo = ZDBExpViewHandler.fetchViewListInfo(objId);
//	      	  dispName = viewInfo[ZDBExpViewHandler.VIEW_NAME];
//	      	  var type = viewInfo[ZDBExpViewHandler.VIEW_TYPE];
//	    	  tab = ZDBClientUI.createUpdateDummyTab(objId,dispName,type);
//	      }
//	      viewCtx = tab.viewCtx;
//      }
      dispName = (gridObj) ? gridObj.displayName : ((dispName) ? dispName : null);
      var tabTitle = (dispName) ? (ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.dialogtitle") + " " + dispName) :
  		  (ZDBI18NMap.g("zrpt.toolbar.table.editdesign.js.tabtitle"));
  	  ZDBInlineDialog.showDialog(designDIV,{MODAL: true, TITLE:ZDBEscapeUtil.encodeForJs(tabTitle)});
  	  var dlg = ZDBClientUI.selectedTab.focusedDialog;
      dlg.designDIV = designDIV;
      dlg.bodyContent = designDIV["ZDBEditDesignBody"];
      if(dlg.bodyContent==null)
      {
          ZDBUtil.setNamedChildEls(dlg,dlg,"elname"); // I need the dlgBodyContent even it is your own dlg...CURSOR ISSUE.
      }

      var editHolder = designDIV["editGridHolder"];
      dlg.bodyContent.editGridHolder = editHolder;
      ZDBClientUI.editGridHolder = editHolder;
      var tab = {isDialog:true,
                 tabIcon:designDIV["tabIcon"],
                 tabModified:designDIV["tabModified"],
                 tabHeader:designDIV["ZDBEditTitle"]};
      viewCtx = new ZDBDesignGridCtx(tab,editHolder,dlg);
      dlg.viewCtx = viewCtx;
      tab.viewCtx = viewCtx;
      dlg.tblGridObj = gridObj;
    }
    else
    {
      dlg = ZDBClientUI.selectedTab.focusedDialog;
      viewCtx = dlg.viewCtx;
    }

    var loadMsg = isRefresh ? ZDBI18NMap.g("zrpt.common.tbleditdesign.loadingdiv.js.refreshEditDgn") : ZDBI18NMap.g("zrpt.common.tbleditdesign.loadingdiv.js.fetchEditDgn");
    AjaxAPI.sendRequest({URL:"/ZDBTableDataAction.ma?",PARAMETERS:params,METHOD:"GET",
                               ONSUCCESSFUNC:ZDBDesignGrid.showDesignDialog,
                               DIALOG:dlg,
                               OPSTATUSID:viewCtx.getLoadIndicator(loadMsg),
                               FILTER:searchVal});
  }
  


ZDBDesignGrid.showDesignDialog = function(response,requestOptions)
{ 
  var gridObj = ZDBDataGrid.parseGridResponse(null,response.responseText);
  if(gridObj == null)
  {
    return;
  }
  gridObj.isFilter = (requestOptions['FILTER'] != undefined) ? true : false;
  gridObj.searchValue = (requestOptions['FILTER'] != undefined) ? requestOptions['FILTER'] : "";

  if(ZDBUtil.isNewView(gridObj))
  {
    gridObj.modified = 0;
  }

  var dlg = requestOptions['DIALOG'];
  jQuery(dlg).find("[inlinediv='mainDialogDiv']").get(0).style.overflow = "hidden";
  dlg.gridObj = gridObj;
  dlg.viewCtx.tab.view = gridObj;
  dlg.viewCtx.handle(gridObj);
	ZDBClientUI.resizeEditGridHolder();
	ZDBDesignGrid.resizeToolBarDiv(gridObj);
  dlg.viewCtx.tab.tabHeader.innerHTML = ZDBEscapeUtil.encodeForHtml(gridObj.displayName);
  gridObj.dlg = dlg;
  if(BROWSER.SAFARI == 1) //  to fix safari issue , safari current version only computes table layout fixed after this
  {
	  ZDBUtil.removeAndInsertJsObj(gridObj);
  }
  gridObj.adjustInViewRowsHeight();
}

ZDBDesignGrid.resizeToolBarDiv = function(gridObj)
{
  var gridWidth = ZDBUtil.getStyleNumeric(gridObj.rhArea,'width') + gridObj.dWidth;	//No I18N
  var toolbarTr = $("ZREditDesignToolBar");
  var toolbarDiv = toolbarTr.firstElementChild;
  toolbarDiv.style.width = gridWidth + "px";
}

ZDBDesignGrid.getColumnDetails = function(gridObj, isAggregate)
{
  var params = "&ZDBACTION=GETTABLECOLUMNDETAILS&OBJID=" + gridObj.objId +"&NOCACHE="+new Date().getTime(); //No I18N
  AjaxAPI.sendRequest({URL:"/ZDBDatabaseActionMI.ma?",METHOD:'GET',
                     REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                     PARAMETERS:params,ONSUCCESSFUNC:ZDBDesignGrid.updateColumnDetails,
                     ISAGGREGATE: isAggregate, GRIDOBJ: gridObj
                     });
}

ZDBDesignGrid.updateColumnDetails = function(response, reqOptions)
{	
	var gridObj = reqOptions['GRIDOBJ'];
	var isAggregate=reqOptions['ISAGGREGATE'];	
	gridObj.tableColDetails = JSON.parse(response.responseText);
	ZDBDerivedField.showInsertFieldsMenu(gridObj, isAggregate);
}

ZDBDesignGrid.getGridObj = function(objId, dbId, gridObj, colId, fieldName, formula,isAggregate)
{
  var params = "&ZDBACTION=SHEETVIEW";  // No I18N
  if(objId != null)
  {
    params +=  "&OBJID=" + objId;  // No I18N
  }
  if(dbId != null)
  {
    params += "&DBID=" + dbId;  // No I18N
  }
  AjaxAPI.sendRequest({URL:"/ZDBTableDataAction.ma?",PARAMETERS:params,
                               ONSUCCESSFUNC:ZDBDesignGrid.parseGridObj,
                               GRIDOBJ:gridObj,METHOD:"GET",    //No I18N
                               COLID:colId,
                               FIELDNAME:fieldName,
                               FORMULA:formula,
                               ISAGGREGATE:isAggregate});
}

ZDBDesignGrid.parseGridObj = function(response, reqOptions)
{
  var gridObj = reqOptions['GRIDOBJ'];
  var colId = reqOptions['COLID'];
  var fieldName = reqOptions['FIELDNAME'];
  var formulaEl = document.getElementById("ZDBExprEditorFormula");
  var formula = reqOptions['FORMULA'];
  var isAggregate=reqOptions['ISAGGREGATE'];
  ZDBDesignGrid.newGridObj = ZDBDataGrid.parseGridResponse(null, response.responseText);
  if(colId == null && fieldName != "")
  {
    var rowData = (ZDBDesignGrid.newGridObj != undefined && gridObj.isFilter) ? ZDBDesignGrid.newGridObj.rowData : gridObj.rowData ;
    var curRow;
    var i = 0;
    for(i=0; i< rowData.length; i++)
    {
      curRow = rowData[i];
      if(curRow.values[gridObj.getColumnIndex("FIELDNAME")].originalValue == fieldName)
      {
        colId = curRow.values[gridObj.getColumnIndex("FIELDID")].originalValue;
}
    }
  }

  if(formula != "" || colId != null)
  {
    formulaEl.focus();
    formulaEl.colId = colId;
    formulaEl.origDispColName = fieldName;
  }
  ZDBDerivedField.showInsertFieldsMenu(gridObj, isAggregate);
}

ZDBDesignGrid.getDesignDIV = function()
{
  ZDBClientUI.tableDesignHolder = ZDBUtil.getCachedRef(this, "ZDBEditDesign");
  ZDBClientUI.designDIV = ZDBClientUI.tableDesignHolder.cloneNode(true);
  ZDBClientUI.designDIV.removeAttribute("id");
  ZDBUtil.setNamedChildEls(ZDBClientUI.designDIV,ZDBClientUI.designDIV);
  return ZDBClientUI.designDIV;
}


ZDBDesignGrid.showDesignView = function(el,fromExplorer)
{
  if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", ZDBDesignGrid.showDesignView,[el,fromExplorer])){
  	return;
  }
  if(!ZDBClientUI.checkAskSaveView(ZDBClientUI.selectedTab.view,ZDBI18NMap.g("zrpt.common.tbleditdesign.zdbalertmsg.js.askSaveViewSnip"),this))
  {
    return;
  }
  var gridObj = ZDBClientUI.selectedTab.view;
  var objId = (fromExplorer) ? ZDBNavigation.element.getAttribute("objid") : gridObj.objId;
  ZDBDesignGrid.fetchDesignView(el,objId,false,ZDBClientUI.selectedTab.view,fromExplorer);
}

ZDBDesignGrid.refreshDesign = function(element, event)
{
  var view = ZDBClientUI.selectedTab.focusedDialog.gridObj;
        
  if(ZDBUtil.isNewView(view))
  {
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.tbleditdesign.zdbalertmsg.js.newViewRefreshErr"));
    return;
  }
  if(view.askCheckSave != undefined && view.askCheckSave == true)
  {
  if(!ZDBClientUI.checkAskSave(view," "+ZDBI18NMap.g("zrpt.common.js.refresh"),this))
  {
    return;
  }
  }
  view.askCheckSave = true;
  ZDBDesignGrid.fetchDesignView(element,view.objId, true, view);
}

ZDBDesignGrid.closeDesign = function(element, event)
  {
    var parentEl = ZDBUtil.getParentWithAttributeValue(element, "elname", "dlgTable");  // No I18N
    if(parentEl == null) // On ESC key, the element will be the parent of the dialog.
    {
      parentEl = element;
    }
    var searchEl = ZDBUtil.getElWithTagNAttrWithVal(parentEl, "elname", "TDSearchBoxEl", "input");  // No I18N
    if(searchEl)
    {
    searchEl.value = "";  // No I18N
    }
    var gridObj = ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    
    if(!gridObj)
    {
      gridObj = ZDBClientUI.selectedTab.focusedDialog.gridObj;
    }
    
    ZDBClientUI.curFocusDialog = ZDBClientUI.selectedTab.focusedDialog;
    
    if(gridObj.modified != 0)
    {
        ZDBDesignGrid.closeDesignDialog.element = element;
        ZDBClientUI.checkAskSave(gridObj,ZDBI18NMap.g("zrpt.common.analysis.js.closing"),element, null, ZDBDesignGrid.closeDesignDialog);
    }
    else
    {
    	ZDBClientUI.selectedTab.tabModified.style.visibility = 'hidden';
        ZDBDesignGrid.closeDesignDialog(element, event);
    }
  }

  ZDBDesignGrid.closeDesignDialog = function(el, event)
  {
    var element = el || ZDBDesignGrid.closeDesignDialog.element; ///PK: Hack
    var gridObj =  ZDBClientUI.selectedTab.focusedDialog.gridObj;
    if(!gridObj)
    {
      gridObj = ZDBUtil.getPropertyFromEl(element, 'gridObj','object'); 
    }
    if(gridObj && gridObj.refError)
    {
      return;
    }
    ZDBInlineDialog.closeDialog();
    ZDBDataGrid.removeInstance(gridObj.ID);
    ZDBDesignGrid.showSheetOnCloseDesign(element, event, gridObj);
  }

ZDBDesignGrid.showSheetOnCloseDesign = function(element, event, gridObj)
  {
    if(!gridObj)
    {
      gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    }    
    if(!gridObj.objId || gridObj.objId === "null")
    {
      return;
    }

    ZDBDesignGrid.showDataView(element, event, gridObj);
    var newTab = ZDBClientUI.selectedTab;
    if(ZDBClientUI.designTab)
    {
        ZDBTabHandler.removeSelectedTab(ZDBClientUI.designTab, null);
        ZDBClientUI.designTab = null;
        ZDBClientUI.selectedTab = newTab;
    }
    if(newTab)
    {
      ZDBClientUI.selectTab(newTab);
    }
  }

ZDBDesignGrid.searchOnClick = function (el)
{
  var elToSet = el.parentNode;
  ZDBUtil.setNamedChildEls(elToSet,elToSet);
  el = elToSet.getElementsByTagName("INPUT")[1];
  this.searchValue(el);
}

ZDBDesignGrid.searchValue = function(el)
{
  if(el.getAttribute("searchempty") == "false")
  {
      return;
  }
  var gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
  if(!ZDBClientUI.checkAskSaveView(gridObj,ZDBI18NMap.g("zrpt.common.tbleditdesign.zdbalertmsg.js.askSaveViewSnip"),this))
  {
    return;
  }
  var value = ZDBSearchUtil.getSearchValue(el);

  if(value == null)
  {
    gridObj.isFilter = false;
    gridObj.searchValue = "";
  }
  else
  {
    gridObj.isFilter = true;
    gridObj.searchValue = value;
  }
  ZDBDesignGrid.fetchDesignView(el,gridObj.objId,true);
}

ZDBDesignGrid.showDataView = function(el, event, gridObj)
{
  if(!gridObj)
  {
	gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');  
  }
  if(ZDBUtil.isViewModified(gridObj))
  {
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.tbleditdesign.zdbalertmsg.js.newViewRefreshErr"));
    return;
  }
  ZDBClientUI.fetchView(gridObj.objId,gridObj.dbId,gridObj.displayName,"Table",
                        ZDBClientUI.selectedTab);
}

ZDBDesignGrid.searchInTable = function(el,ev)
{
    if(!ev)
    {
        ev = window.event;
    }
    if(ev.keyCode != 13)
    {
        el.setAttribute("searchempty","true");
        return true;
    }
    else
    {
        this.searchValue(el);
    }
    ZDBSearchUtil.dntBlur=true;
}

  ZDBDesignGrid.checkAskSaveTD = function(view, operation, obj, label, func, option)
  {
    var msgOpt = "ZDBSAVE";   // No I18N
    if(option != undefined)
    {
      msgOpt = option;
    }
    if(func == null)
    {
      func =  arguments.callee.caller;
    }
    var args = func.arguments;
    if(!args)
    {
        args = [];
    }

    if(func.OPTION != null){return func.OPTION;}

    if(ZDBUtil.isViewModified(view))
    {
      args = LangUtils.cloneArray(args);
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.operationOnModifiedViewConfirm",operation) +" ?", msgOpt
                          ,{ONCLICK:ZDBDesignGrid.handleTDSaveOption,OWNEROBJECT:obj,FUNC:func, ARGS:args,LABEL:label,VIEW:view},
                          view.displayName + " "+ZDBI18NMap.g("zrpt.common.analysis.js.isModified"));  //No I18N
      return false;
    }
    return true;
  }

  ZDBDesignGrid.handleTDSaveOption = function(clickType,requestOptions)
  {
    if(clickType == "YES")
    {
      requestOptions["HANDLESAVE"] = ZDBClientUI.invokeAfterOption;
      requestOptions["VIEW"].save(requestOptions);
    }
  }

  ZDBDesignGrid.getSearchValue = function(viewObj)
  {
    if(viewObj.searchValue != undefined && viewObj.searchValue != "")
    {
      return "ZDBSEARCHVALUE=" + viewObj.searchValue;  // No I18N
    }
  }


function ZDBDesignGridCtx(tab,parComp,dlg)
{
  this.base = ZDBDefViewCtx;
  this.base();
  this.tab = tab;
  this.parComp = parComp;
  this.dlg = dlg;
  this.loadIndicator = ZDBUIViewCtx.getViewLoadingDiv(dlg);
}

ZDBDesignGridCtx.prototype = new ZDBDefViewCtx;

ZDBDesignGridCtx.prototype.updateModified = function()
{
  var modified = ZDBUtil.isViewModified(this.tab.view);
  var designView = true;
  var newTab = ZDBUtil.isNewView(this.tab.view);
  var selectedTabModified = ZDBClientUI.selectedTab.tabModified;
  if(newTab && this.tab.view.modified == 0 && this.tab.view.newRows.length > 1)
  {
	  selectedTabModified.style.visibility = 'hidden';
	  return;
  }
  if(modified)
  {
	selectedTabModified.style.visibility = 'visible';
	ZDBUtil.highlightSave(this.dlg, designView); 
  }
  else
  {
	  selectedTabModified.style.visibility = 'hidden';
	  ZDBUtil.removeHighlight(this.dlg, designView);
  }
}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBDesignGrid.fetchDesignView"]=ZDBDesignGrid.fetchDesignView;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBDesignGrid.showDesignView"]=ZDBDesignGrid.showDesignView;
