/*$Id$*/

/**
 * Created by sam-2198 on 24/03/17.
 */

/** Share Dialog Scripts **/

var ZRShare = new function() {

    var self = this;
    self.viewTypeIcon = ['Table', 'Report', 'AnalysisView', 'Pivot', 'SummaryView', 'TableView', 'QueryTable', 'Dashboard']; // No I18N
    self.typesAllowedInVUD = ['Report', 'AnalysisView', 'Pivot', 'SummaryView', 'Dashboard']; // No I18N
    self.typesAllowedInDD = ['Report', 'AnalysisView', 'Dashboard']; // No I18N

    self.show = function(isFolderShare, isViewShare) {
        // isFolderShare will be TRUE when share call invoked from "Share Views from this folder"
        // isViewShare will be TRUE when share call invoked from the view options
        self.construct(isFolderShare, isViewShare);
    };

    self.construct = function(isFolderShare, isViewShare) {
        Contacts.get();
        if (!self.view) {
            var objIds = ZDBClientUI.selectedTab.view.objId;
            // Share from explorer
            if (isViewShare) {
                self.viewIds = dom(ZDBNavigation.element).attr('objid'); // No I18N
                self.getViewsInfoForShare();
            } else if (objIds == 'Explorer') { // No I18N
                var selectedViews = (isFolderShare) ? ZDBNavigation.getViewIdsFromFolder() : ZDBNavigation.getSelectedViewIdsInExplorer();
                self.viewIds = selectedViews.join(',');
                if (selectedViews.length > 0) {
                    self.viewType = (selectedViews.length > 1) ? 'Multiple' : ''; // No I18N
                    self.getViewsInfoForShare();
                } else {
                    ZDBAlertAPI.showMsg(ZDBI18NMap.g(isFolderShare ? 'zrpt.common.toolbar.share.zdbalertmsg.js.noviewsinfolder' : 'zrpt.common.toolbar.share.zdbalertmsg.js.selShareViews'));
                }
            } else {
                self.viewType = ZDBClientUI.selectedTab.view.type;
                self.viewIds = objIds;
                // Share from the view
                self.getViewsInfoForShare();
            }
        }
    };

    self.constructViews = function() {
        if (!self.layer1Body) { self.layer1Body = dom(ZRSStringTemplateCreator.createTemplateForData('shareBody1', 'sharingmodule')); } // No I18N
        if (!self.layer1Footer) { self.layer1Footer = dom(ZRSStringTemplateCreator.createTemplateForData('shareFooter1', 'sharingmodule')); } // No I18N 
        self.constructPermAndFilterCriteria();
        if (!self.layer2Footer && self.footer2) { self.layer2Footer = dom.construct(self.footer2); }
    };

    self.constructPermAndFilterCriteria = function() {
        if (!self.permCont || !self.perm) {
            self.permCont = dom(ZRSStringTemplateCreator.createTemplateForData('permContainer', 'sharingmodule')); // No I18N
            self.perm = dom(ZRSStringTemplateCreator.createTemplateForData('permTemplate', 'sharingmodule')); // No I18N
        }
        self.layer2Body = tab.construct({
            switches: [ ZDBI18NMap.g('zrpt.explorer.share.shareview.js.permissions'), ZDBI18NMap.g('zrpt.explorer.share.shareview.js.fc') ],
            contents: [ self.constructPerms(), fc.construct(self.viewType) ]
        });
    };

    self.hide = function() {
        self.template.removeClass('is-active');
        vud.template = null;
    };

    self.extractObjIds = function(selectedViews) {
        var objIds = '';
        for (var i = 0; i < selectedViews.length; i++) {
            var view = selectedViews[i];
            if (i > 0) { objIds += ','; }
            var objEl = DOMUtils.getElOrParentWithAttr(view, 'objId'); //No I18N
            objIds += objEl.getAttribute('objId');
        }
        return objIds;
    };

    self.extractViewName = function(view) {
        var objEl = DOMUtils.getElOrParentWithAttr(view, 'objId'); //No I18N
        return dom(objEl).first('[elname=fullName]').text(); // No I18N
    };

    self.getViewsInfoForShare = function() { AjaxAPI.sendRequest({ URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/GETVIEWSINFO?OBJIDS=' + self.viewIds, METHOD: 'GET', ONSUCCESSFUNC: self.handleGetViewsInfo, OPSTATUSID: 'ZDBMainLoader' }); };

    self.handleGetViewsInfo = function(response, request) {
        self.json = JSON.parse(response.responseText).data;
        if (self.json.views.length == 1) {
            self.viewType = self.json.views[0].type;
        }

        self.constructViews();
        self.layer1Body.removeClass('domain-admin').removeClass('custom-domain');
        if (self.json.isDomainAdmin) {
            self.layer1Body.addClass('domain-admin');
            self.layer1Body.first('.domain-name-1').attr('data-zaid', self.json.domainsInfo[0].zaid).text('(' + self.json.domainsInfo[0].domainName + ')'); // No I18N
            self.layer1Body.first('.domain-name-2').attr('data-zaid', self.json.domainsInfo[1].zaid).text('(' + self.json.domainsInfo[1].domainName + ')'); // No I18N
        } else if (self.json.isCustomDomain) {
            self.layer1Body.addClass('custom-domain');
            self.layer1Body.first('.domain-name-1').attr('data-zaid', self.json.domainsInfo[0].zaid).text(self.json.domainsInfo[0].domainName);
        }

        sidepane.show({
            header1: ZDBI18NMap.g('zr.sharing.js.dlg_title'),
            body1: self.layer1Body,
            footer1: self.layer1Footer,
            header2: ZDBI18NMap.g('zr.sharing.js.apply_perms'),
            body2: self.layer2Body,
            alertOnAccidentClose: true,
            helpdoc: ZDBI18NMap.g('zrpt.explorer.share.shareview.js.shareToUserHelpLink'),
            setOnCompletion: true
        });

        self.resetAllFields();
       // self.toggleColumnSharingOptions(self.viewType);
        self.shareParams = JSON.parse(JSON.stringify(SharingModule_Model.shareParams));

        var viewNames = '';
        for (var i = 0; i < self.json.views.length; i++) {
            viewNames += self.json.views[i].name + ', ';
        }
        viewNames = viewNames.substr(0, viewNames.length - 2);

        if (self.viewType == 'Table') {
            self.columnShareInfo = self.json.views[0].viewInfo[0];
            self.shareParams.sharedColumnIds = [];
        }
        self.vudColumnsInfo = self.json.views[0];

        fc.fill({ objId: self.json.views[0].objId, viewInfo: self.json.views[0].viewInfo, variables: self.json.variables });

        //self.layer1Body.first('[data-view-name]').attr('tip', viewNames).text(viewNames); // No I18N
        self.layer1Body.first('#sharingMailSubject').val(self.json.mailSubject); // No I18N
        self.layer1Body.first('#sharingMailMessage').val(self.json.mailMessage); // No I18N
    };

    self.share = function() {
        if (!self.constructShareParams()) { return; }
        preloader.show(sidepane.getActivePane().first('.sidepane-container'), 'medium', ZDBI18NMap.g('zr.share.js.info_sharing')); // No I18N
        // Share the view
        AjaxAPI.sendRequest({ URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/SHAREVIEWS?SHAREINFO=' + encodeURIComponent(JSON.stringify(self.shareParams)), METHOD: 'POST', ONSUCCESSFUNC: self.shareOnSuccess, ONFAILUREFUNC: self.shareOnFailure });
    };

    self.constructShareParams = function() {
        self.shareParams.dbId = ZDBClientUI.dbId;
        self.shareParams.objIds = self.viewIds.split(',');

        var contacts = bubble.extractContacts(self.layer1Body.first('#contactsCont')); // No I18N
        if (self.json.isDomainAdmin) {
            var secondDomainContacts = bubble.extractContacts(self.layer1Body.first('.contact-textarea.second-domain')); // No I18N
            if (contacts.users.length == 0 && contacts.groups.length == 0 && secondDomainContacts.users.length == 0 && secondDomainContacts.groups.length == 0) {
                ZDBAlertAPI.showAlertMsg(ZDBI18NMap.g('zr.share.js.please_specify_user'));
                return false;
            } else if (contacts.warnings > 0 || secondDomainContacts.warnings > 0) {
                ZDBAlertAPI.showAlertMsg(ZDBI18NMap.g('zr.share.js.please_specify_valid'));
                return false;
            }
            self.shareParams.users = [
                { zaid: self.layer1Body.first('.domain-name-1').attr('data-zaid'), emailIds: contacts.users }, // No I18N
                { zaid: self.layer1Body.first('.domain-name-2').attr('data-zaid'), emailIds: secondDomainContacts.users } // No I18N
            ];
            self.shareParams.groups = contacts.groups.concat(secondDomainContacts.groups);
        } else {
            if (contacts.users.length == 0 && contacts.groups.length == 0) {
                self.handleValidationErrors('zr.share.js.please_specify_user'); // No I18N
                return false;
            } else if (contacts.warnings > 0) {
                self.handleValidationErrors('zr.share.js.please_specify_valid'); // No I18N
                return false;
            }
            if (self.json.isCustomDomain) {
                self.shareParams.users = [ { zaid: self.layer1Body.first('.domain-name-1').attr('data-zaid'), emailIds: contacts.users } ]; // No I18N
            } else {
                self.shareParams.users[0].emailIds = contacts.users;
            }
            self.shareParams.groupIds = contacts.groups;
        }

        self.shareParams.filterCriteria = self.layer2Body.first('#fcTextArea').val(); // No I18N
        self.shareParams.inheritParentCriteria = self.layer2Body.first('#inheritParentCriteria').checked(); // No I18N

        if (self.shareParams.permissions.colsModified == undefined) { self.shareParams.permissions.colsModified = false; }

        var sendInvMail = self.layer1Body.first('#sendInvMail').checked(); // No I18N
        self.shareParams.sendMail = sendInvMail;
        if (sendInvMail) {
            self.shareParams.mailSubject = self.layer1Body.first('#sharingMailSubject').val(); // No I18N
            self.shareParams.mailMessage = self.layer1Body.first('#sharingMailMessage').val(); // No I18N
            self.shareParams.sendCopy = self.layer1Body.first('#sendCopy').checked(); // No I18N
        } else {
            self.shareParams.mailSubject = '';
            self.shareParams.mailMessage = '';
            self.shareParams.sendCopy = false;
        }
        return true;
    };

    self.handleValidationErrors = function(message) {
        bubble.focusInputEl(self.layer1Body.first('.contact-textarea')); // No I18N
        var errorMsgEl = self.layer1Body.first('.specify-user-group'); // No I18N
        errorMsgEl.removeClass('invalid').addClass('invalid').first('span').i18n(message); // No I18N
    };

    self.shareOnSuccess = function(response, request) {
        preloader.hide(sidepane.getActivePane().first('.sidepane-container')); // No I18N
        sidepane.close();

        var sendInvMail = self.shareParams.sendMail;
        
        // Resets the shareParams JSON
        self.shareParams = null;
        // Show the warning message
        var warning = JSON.parse(response.responseText).data.warning;
        warning && ZDBAlertAPI.showAlertMsg(warning);
        // Shows the success message
        ZDBMsgBox.showSuccess(ZDBI18NMap.g(self.viewType == 'Multiple' ? 'zr.share.js.views_shared' : 'zr.share.js.view_shared') + (sendInvMail ? ' ' +  ZDBI18NMap.g('zr.share.js.notifications_sent') : ''));
    };

    self.shareOnFailure = function(response, request) {
        preloader.hide(sidepane.getActivePane().first('.sidepane-container')); // No I18N
        ZDBAlertAPI.showMsg(JSON.parse(response.responseText).message);
    };

    self.toggleInvMail = function() {
        self.layer1Body.first('.mail-container').toggleClass('is-active'); // No I18N
        setTimeout(function() {
           var subjectField = self.layer1Body.first('#sharingMailMessage'); // No I18N
           subjectField.focus().text(subjectField.text());
        }, 300);
    };

    self.hideInvMail = function() { self.layer1Body.first('.mail-container').dFadeOut(); }; // No I18N

    self.toggleEditMsg = function() {
        self.layer1Body.first('.edit-msg-link').toggleClass('is-active'); // No I18N
        (!self.layer1Body.first('#sendInvMail').checked()) && self.hideInvMail(); // No I18N
    };

    self.checkAllChildren = function(el) {
        var targetEl = dom(el);
        var parentChkBox = targetEl.first('input'); // No I18N
        var childrenCont = targetEl.toDOM().nextElementSibling;
        var children = dom(childrenCont).find('input[type=checkbox]');
        for (var i = 0; i < children.length; i++) { if (!dom(children[i]).hasClass('disabled')) { children[i].checked = parentChkBox.checked(); } }
        self.handlePerm(children[0]);
    };

    self.handlePerm = function(el) {
        var targetEl = dom(el);
        var permEls = self.layer2Body.find('div.view-perms label');
        var permString = '';
        var permissions = {};
        for (var i = 0; i < permEls.length; i++) {
            var chkBox = dom(permEls[i]).first('input');
            if (chkBox.checked()) { permString += dom(permEls[i]).first('[data-perm]').text() + ', '; } // No I18N
            permissions[chkBox.attr('name')] = chkBox.checked();
        }
        if (self.shareParams) { self.shareParams.permissions = permissions; }
        permString = permString.substr(0, permString.length - 2);
        if ($('permInfoEl')) {
            var permInfoEl = self.layer1Body.first('#permInfoEl'); // No I18N
            permInfoEl.attr('tip', permString).text(permString); // No I18N
        } else if (self.permStrEl) {
            self.permStrEl.attr('tip', permString).text(permString); // No I18N
        }
        self.toggleParentChkBox(targetEl);
    };

    self.toggleParentChkBox = function(element) {
        var cont = element.parent('perms'); // No I18N
        var permEls = dom(cont).find('input');
        var parentEl = cont.previousElementSibling;
        var allChecked = true;
        for (var i = 0; i < permEls.length; i++) {
            var permEl = permEls[i];
            if (!dom(permEl.parentElement).hasClass('perm-hidden')) { allChecked = (allChecked && permEl.checked); }
        }
        dom(parentEl).first('input').checked(allChecked); // No I18N
    };

    self.getPopup = function() {
        if (!self.popup) { self.popup = dom(ZRSStringTemplateCreator.createTemplateForData('popup', 'sharingmodule')); } // No I18N
        self.layer2Body.first('.perms-container').append(self.popup); // No I18N
        return self.popup;
    };

    self.showColumns = function(event) {
        event.preventDefault();
        event.stopPropagation();
        if (self.viewType == 'Table') {
            var targetEl = dom(event.currentTarget);
            var popup = self.getPopup();
            popup.attr('data-type', 'column'); // No I18N
            self.adjustPopupArrow('72px'); // No I18N

            var columnSharing = self.constructColumnsList(self.columnShareInfo);
            popup.first('[data-title]').i18n('zr.share.js.column_sharing_desc'); // No I18N
            popup.first('[data-content]').empty().append(columnSharing); // No I18N
            popup.toggleClass('is-active'); // No I18N
            self.layer2Body.parent('panel').addEventListener('click', self.handleHide); // No I18N

            var selectedColumns = self.shareParams.sharedColumnIds;
            // By default, all the columns should be selected
            (selectedColumns.length > 0) ? self.selectedColumns(columnSharing, selectedColumns) : self.popup.first('.perm-head').click(); // No I18N

            // Adds the escape key handling
            ev.addEscHandle(self.handleHide);
        }
    };

    self.selectedColumns = function(dlg, columnsToBeSelected) { for (var i = 0; i < columnsToBeSelected.length; i++) { dlg.first('#col_' + columnsToBeSelected[i]).checked(true); } };

    self.handleHide = function(event) {
        if (event.target != self.popup.toDOM()) {
            self.hidePopup();
            self.layer2Body.parent('panel').removeEventListener('click', self.handleHide); // No I18N
        }
    };

    self.showVUD = function(event) {
        event.preventDefault();
        event.stopPropagation();
        if (self.viewType == 'Multiple') {
            self.handleMultiVUDrDrill(event, 'vudForMultiple', '330px', 'multi-vud'); // No I18N
        } else {
            var data = self.vudColumnsInfo;
            self.handleSingleVUDrDrill(event, 'vudForSingle', data, '330px', 'single-vud'); // No I18N
        }
    };

    self.showDrillDown = function(event) {
        event.preventDefault();
        event.stopPropagation();

        if (self.typesAllowedInDD.indexOf(self.viewType) != -1) {
            var data = self.vudColumnsInfo;
            self.handleSingleVUDrDrill(event, 'drillForSingle', data, '510px', 'single-drill'); // No I18N
        } else if (self.viewType == 'Multiple') { // No I18N
            self.handleMultiVUDrDrill(event, 'drillForMultiple', '510px', 'multi-drill'); // No I18N
        }
    };

    self.handleSingleVUDrDrill = function(event, type, data, arrowPos, dlgType) {
        var targetEl = dom(event.currentTarget);
        var popup = self.getPopup();
        popup.attr('data-type', dlgType); // No I18N
        self.adjustPopupArrow(arrowPos);

        var vudDlg, dlgTitle;
        if (data.viewInfo.length > 1) {
            popup.removeClass('single-table').addClass('multi-table'); // No I18N
            dlgTitle = (type == 'vudForSingle') ? 'zrpt.share.esd.js.vud_show_selcol_desc' : 'zrpt.chart.dyndrilldown.js.dyndrillmessage'; // No I18N
            var tableList = dom.new('ul', { attributes: { class: 'table-list' } }); // No I18N
            var columnsList = dom.new('ul', { attributes: { class: 'table-column-list' } }); // No I18N
            var views = data.viewInfo;
            for (var i = 0; i < views.length; i++) {
                var tableLi = dom.new('li', { attributes: { 'data-index': i, onclick: 'ZRShare.makeViewInfoActive(this);' } }); // No I18N

                views[i].type = 0;

                tableLi.append(dom.new('span', { attributes: { class: 'viewTypeIcon ' + self.viewTypeIcon[views[i].type] } })); // No I18N
                tableLi.toDOM().append(document.createTextNode(views[i].viewName));
                tableList.append(tableLi);
                var li = dom.new('li', { attributes: { 'data-index': i } }); // No I18N
                li.append(self.constructColumnsList(views[i]));
                columnsList.append(li);
            }
            vudDlg = columnsList;
            var searchEl = dom(ZRSStringTemplateCreator.createTemplateForData('search', 'sharingmodule')); // No I18N
            searchEl.first('input').attr('onkeyup', 'ZRShare.searchColumns(this, event);'); // No I18N
            popup.first('[data-content]').empty().append(searchEl).append(tableList).append(columnsList); // No I18N
            self.makeViewInfoActive(tableList.first('li')); // No I18N
        } else {
            popup.removeClass('multi-table').addClass('single-table');
            var vudDlg = self.constructColumnsList(data.viewInfo[0]);
            dlgTitle = (type == 'vudForSingle') ? 'zrpt.share.esd.js.vud_show_selcol_desc' : 'zrpt.chart.dyndrilldown.js.dyndrillmessage'; // No I18N
            popup.first('[data-content]').empty().append(vudDlg); // No I18N
        }

        // selecting the default columns
        var selectedCols = (type == 'vudForSingle') ? data.vudInfo.selectedVudCols : data.drillInfo.selectedDrillCols; // No I18N
        var cols = (type == 'vudForSingle') ? self.shareParams.defVudCols : self.shareParams.defDrillCols; // No I18N
        self.selectedColumns(vudDlg, (cols.length > 0) ? cols : selectedCols);

        if (type == 'drillForSingle') {
            var dataTitle = popup.first('[data-title]'); // No I18N
            dataTitle.empty().addClass('axis-container');

            var drillPathOpt = dom.new('div', { attributes: { style: 'display: flex; cursor: pointer;', class: 'axis-container' } }); // No I18N
            drillPathOpt.html(svgDownArrowIcon);
            drillPathOpt.append(dom.new('span', { attributes: { style: 'padding-left: 5px;' }, i18n: 'zr.share.js.included_drill_paths' })); // No I18N
            drillPathOpt.on('click', function() {
                var el = dataTitle.toDOM();
                el.style.maxHeight = dataTitle.isActive() ? '10px' : el.scrollHeight + 'px'; // No I18N
                dataTitle.toggleClass('is-active'); // No I18N
            });
            dataTitle.append(drillPathOpt);
            var axisTitle = data.drillInfo.axisLabel + ZDBI18NMap.g('zr.share.js.drill_path'); // No I18N
            dataTitle.append(dom.new('div', { attributes: { class: 'font13 gray enable-transition', style: 'padding-top: 10px' }, text: axisTitle })); // No I18N

            var xPathEl = dom.new('ul', { attributes: { class: 'class-path' } }); // No I18N
            for (var i = 0; i < data.drillInfo.axisPathList.length; i++) {
                var li = dom.new('li', { attributes: { class: 'ellipsis' } }); // No I18N
                li.toDOM().append(document.createTextNode(data.drillInfo.drillInTableDet[0] + '.' + data.drillInfo.axisPathList[i][1]));
                (i < data.drillInfo.axisPathList.length - 1) && li.append(dom.new('a', { attributes: { class: 'rightArrow' } })); // No I18N
                xPathEl.append(li);
            }
            dataTitle.append(xPathEl);
        } else {
            popup.first('[data-title]').i18n(dlgTitle); // No I18N
        }
        popup.toggleClass('is-active'); // No I18N
        self.layer2Body.parent('panel').addEventListener('click', self.handleHide); // No I18N

        // Adds the escape key handling
        ev.addEscHandle(self.handleHide);
    };

    self.makeViewInfoActive = function(el) {
        var popup = self.popup;
        if (popup.first('.table-list > li.is-active')) {
            var searchEl = popup.first('.search-view-cont > input'); // No I18N
            searchEl.val('');
            self.searchColumns(searchEl.toDOM());
            ZRShare.closeSearch(searchEl.toDOM());
            popup.first('.table-list > li.is-active').dFadeOut(); // No I18N
            popup.first('.table-column-list > li.is-active').dFadeOut(); // No I18N
        }
        var index = dom(el).attr('data-index'); // No I18N
        popup.first('.table-list > li[data-index="' + index + '"]').dFadeIn(); // No I18N
        popup.first('.table-column-list > li[data-index="' + index + '"]').dFadeIn(); // No I18N
    };

    self.searchColumns = function(el, event) {
        el = dom(el);
        var lists = self.popup.find('.table-column-list > li.is-active .perms > label');
        var searchKey = el.val().toLowerCase();

        for (var i = 0; i < lists.length; i++) {
            var item = lists[i];
            var value = dom(item).attr('name').toLowerCase(); // No I18N
            if (value.indexOf(searchKey) != -1) { dom(item).show(); } else { dom(item).hide(); }
        }
    };

    self.adjustPopupArrow = function(arrowPos) {
        self.popup.first('.ZRSMenuTopBefore').attr('style', 'left: ' + arrowPos + ';'); // No I18N
        self.popup.first('.ZRSMenuTopAfter').attr('style', 'left: ' + arrowPos + ';'); // No I18N
    };

    self.constructColumnsList = function(view) {
        var tableName = view.viewName;
        var columns = view.columns;
        var cont = self.permCont.clone(true);
        cont.attr('style', 'padding: 0;'); // No I18N
        var headEl = cont.first('[data-perm-head]'); // No I18N
        var id = tableName.replace(' ', '');
        headEl.attr('for', id); // No I18N
        headEl.first('input').attr('id', id); // No I18N
        headEl.first('span').text(tableName); // No I18N
        cont.append(headEl);

        var bodyEl = cont.first('.perms'); // No I18N
        bodyEl.attr('style', 'border-bottom: none;'); // No I18N
        for (var i = 0; i < columns.length; i++) {
            var columnEl = self.perm.clone(true);
            var columnElId = 'col_' + columns[i].id;
            columnEl.attr('for', columnElId).attr('id', columns[i].id).attr('name', columns[i].name); // No I18N
            columnEl.first('input').attr('id', columnElId); // No I18N
            columnEl.first('span').text(columns[i].name);
            bodyEl.append(columnEl);
        }
        cont.append(bodyEl);
        return cont;
    };

    self.handleMultiVUDrDrill = function(event, template, arrowPos, type) {
        var targetEl = dom(event.currentTarget);

        var popup = self.getPopup();
        popup.attr('data-type', type); // No I18N
        self.adjustPopupArrow(arrowPos);

        var vudDlg = dom(ZRSStringTemplateCreator.createTemplateForData(template, 'sharingmodule')); // No I18N
        popup.first('[data-title]').text(''); // No I18N
        popup.first('[data-content]').empty().append(vudDlg); // No I18N
        popup.toggleClass('is-active'); // No I18N
        self.layer2Body.parent('panel').addEventListener('click', self.handleHide); // No I18N

        // Adds the escape key handling
        ev.addEscHandle(self.handleHide);
    };

    self.hidePopup = function() {
        self.popup.dFadeOut();
    };

    self.applyColumnInfo = function() {
        var type = self.popup.attr('data-type'); // No I18N

        // Setting the default value : There are chances for this value to be modified
        self.shareParams.drill_type_index = 4;

        if (type == 'column') {
            var allSelected = self.popup.first('.perm-head > input').checked(); // No I18N
            self.shareParams.sharedColumnIds = (allSelected) ? [] : self.getColumnIds();
        } else if (type == 'single-vud') { // No I18N
            var involvedCols = self.vudColumnsInfo.vudInfo.selectedVudCols.sort().toString();
            var modifiedCols = self.getColumnIds();
            if (involvedCols == modifiedCols.sort().toString()) {
                self.shareParams.defVudCols = [];
                self.shareParams.permissions.colsModified = false;
            } else {
                self.shareParams.defVudCols = modifiedCols;
                self.shareParams.permissions.colsModified = true;
            }
        } else if (type == 'multi-vud') {} else if (type == 'single-drill') { // No I18N
            self.shareParams.defDrillCols = self.getColumnIds();
        } else if (type == 'multi-drill') { // No I18N
            self.shareParams.drillTypeIndex = (self.layer2Body.first('#incInvReport').checked()) ? 1 : 4; // No I18N
        }
        self.hidePopup();
    };

    self.getColumnIds = function() {
        var selectedEls = self.popup.find('.perms > label');
        var columns = [];
        for (var i = 0; i < selectedEls.length; i++) {
            var selectedEl = dom(selectedEls[i]);
            selectedEl.first('input').checked() && columns.push(selectedEl.attr('id')); // No I18N
        }
        return columns;
    };

    self.constructPerms = function() {
        var permHolder = dom.new('div', { attributes: { class: 'perms-container', style: 'padding: 10px 15px;' } }); // No I18N
        var selectPermsEl = dom.new('div', { attributes: { style: 'padding-bottom: 5px;border-bottom: 1px solid #ededed;margin-top: 13px;' }, i18n: 'zrpt.explorer.share.shareview.js.selectperms' }); // No I18N
        permHolder.append(selectPermsEl);
        var permCont = self.permCont.clone(true);
        var data = SharingModule_Model.permissions;

        for (var i = 0; i < data.length; i++) {
            var datum = data[i];

            var cont = permCont.clone(true);
            var permHead = cont.first('[data-perm-head]').clone(true); // No I18N
            permHead.attr('for', datum.permHead); // No I18N
            permHead.first('input').attr('id', datum.permHead); // No I18N
            permHead.first('[data-perm-title]').i18n(datum.permTitle); // No I18N
            self.hideUnrelatedPerm(permHead, self.viewType);

            var permGroup = cont.first('.perms').addClass('view-perms'); // No I18N
            for (var j = 0; j < datum.perms.length; j++) {
                var p = self.perm.clone(true);
                p.attr('for', datum.perms[j].id);
                self.hideUnrelatedPerm(p, self.viewType);
                var inputEl = p.first('input'); // No I18N
                inputEl.attr('id', datum.perms[j].id).attr('name', datum.perms[j].name); // No I18N
                datum.perms[j].checked && inputEl.attr('checked', 'checked'); // No I18N
                datum.perms[j].disabled && inputEl.addClass('disabled').attr('onclick', 'return false;'); // No I18N
                p.first('[data-perm]').i18n(datum.perms[j].title);

                // Extra options
                var extraOpts = datum.perms[j].extraOpts;
                if (extraOpts) {
                    var extraEl = dom.new('div').addClass('extra-opts'); // No I18N
                    extraEl.append(dom.new('span', { attributes: { class: 'ZRSLink' }, i18n: '(' + ZDBI18NMap.g(extraOpts.name) + ')' })); // No I18N
                    extraEl.on('click', window['ZRShare'][extraOpts.action]);
                    p.append(extraEl);
                }

                permGroup.append(p);
            }
            permHolder.append(permHead);
            permHolder.append(permGroup);
        }
        return permHolder;
    };

    self.viewSpecificPerms = {
        'Table': ['vud', 'drilldown'], // No I18N
        'Report': ['checkAllWrite', 'checkAllImport'], // No I18N
        'AnalysisView': ['checkAllWrite', 'checkAllImport'], // No I18N
        'Pivot': ['drilldown', 'checkAllWrite', 'checkAllImport'], // No I18N
        'SummaryView': ['drilldown', 'checkAllWrite', 'checkAllImport'], // No I18N
        'TableView': ['drilldown', 'checkAllWrite', 'checkAllImport'], // No I18N
        'QueryTable': ['vud', 'drilldown', 'checkAllWrite', 'checkAllImport'], // No I18N
        'Dashboard': ['checkAllWrite', 'checkAllImport'], // No I18N
        'Multiple': [] // No I18N
    };

    self.hideUnrelatedPerm = function(element, viewType) {
        if (!viewType) { viewType = 'Multiple'; }
        var unrelatedPerms = self.viewSpecificPerms[viewType];
        for (var i = 0; i < unrelatedPerms.length; i++) {
            if (unrelatedPerms[i] == element.attr('for')) {
                element.addClass('perm-hidden');
                return;
            }
        }
        element.removeClass('perm-hidden');
    };

    self.editSharedDetails = function(isItFromNavigation) {
        var objIds = ZDBClientUI.selectedTab.view.objId;
        if (isItFromNavigation) {
            self.getExistingShareDetails(dom(ZDBNavigation.element).attr('objid')); // No I18N
        } else if (objIds == 'Explorer') { // No I18N
            var selectedViews = ZDBNavigation.getSelectedViewIdsInExplorer();
            objIds = selectedViews.join(',');
            if (selectedViews.length > 0) {
                self.getExistingShareDetails(objIds);
            } else {
                ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.toolbar.share.zdbalertmsg.js.selEditShareViews'));
            }
        } else {
            self.getExistingShareDetails(objIds);
        }
    };

    self.showConfirmDialog = function() {
        sidepane.showConfirmDialog({
            message: ZDBI18NMap.g('zr.share.js.ext_shr_det_warning'),
            onProceed: self.getExistingShareDetails
        }); 
    };

    self.hideConfirmDialog = function() { self.layer1Body.first('.confirm-dlg-cont').dFadeOut(); }; // No I18N

    self.showOpts = function(el) { dom(el).first('.list-opts').show(); }; // No I18N

    self.hideOpts = function(el) { dom(el).first('.list-opts').hide(); }; // No I18N

    self.getExistingShareDetails = function(objIds) {
        sidepane.close();
        AjaxAPI.sendRequest({ URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/GETEXISTINGSHAREDETAILS?OBJIDS=' + ((objIds && !(objIds instanceof Event)) ? objIds : self.viewIds), METHOD: 'GET', ONSUCCESSFUNC: self.showExistingShareDetails, OPSTATUSID: 'ZDBMainLoader' });
    };

    self.constructExtShareDlg = function() {
        if (!self.extShareDlg || !self.extShareInfo) {
            self.extShareDlg = dom(ZRSStringTemplateCreator.createTemplateForData('extShareDlg', 'sharingmodule')); // No I18N
            self.extShareInfo = dom(ZRSStringTemplateCreator.createTemplateForData('extShareInfo', 'sharingmodule')); // No I18N
        }
        if (!self.permFooter) { self.permFooter = dom(ZRSStringTemplateCreator.createTemplateForData('editPermFooter', 'sharingmodule')); } // No I18N
        self.constructPermAndFilterCriteria();
    };

    self.showExistingShareDetails = function(response, request) {
        self.constructExtShareDlg();
        self.existingShareDetails = JSON.parse(response.responseText).data.existingSharedDetails;

        var cont = dom.new('div', { attributes: { class: 'existing-share-details-cont', style: 'padding: 10px' } }); // No I18N
        self.isDomainAdmin = self.existingShareDetails.length > 0 && self.existingShareDetails[0].isDomainAdmin;
        self.isDomainAdmin && cont.addClass('domain-admin');
        var viewToBeExpanded = null;

        var shareDlgHeader = dom(ZRSStringTemplateCreator.createTemplateForData('extShareDlgTitle', 'sharingmodule')); // No I18N
        cont.append(shareDlgHeader);
        var noMatchFound = dom(ZRSStringTemplateCreator.createTemplateForData('noMatchFound', 'sharingmodule')); // No I18N
        shareDlgHeader.append(noMatchFound);

        // Search Container
        var searchEl = dom(ZRSStringTemplateCreator.createTemplateForData('search', 'sharingmodule')); // No I18N
        searchEl.first('input').attr('onkeyup', 'ZRShare.searchShareInfo(this, event);'); // No I18N
        shareDlgHeader.first('li').append(searchEl); // No I18N

        for (var i = 0; i < self.existingShareDetails.length; i++) {
            var viewInfo = self.existingShareDetails[i];
            var viewTable = self.constructShareDetailsForView(viewInfo);
            viewTable.attr('data-index', i); // No I18N
            if (i == 0) {
                viewToBeExpanded = viewTable;
            }
            cont.append(viewTable);
        }
        setTimeout(function() {
            self.toggleSharedInfo(viewToBeExpanded.toDOM().childNodes[0]); // Expands the first one by default
        }, 400);
        
        sidepane.show({
            header1: ZDBI18NMap.g('zr.sharing.js.existing'), // No I18N
            body1: cont,
            header2: ZDBI18NMap.g('zr.share.js.edit_permission'),
            body2: self.layer2Body,
            footer2: self.permFooter.toDOM(),
            helpdoc: ZDBI18NMap.g('zrpt.explorer.share.js.editExistSharedDetHelpLink'), // No I18N
            stickyHeaderOptions: {
                top: 12, element: shareDlgHeader, on: 'body1' // No I18N
            }
        });
    };

    self.constructShareDetailsForView = function(view) {
        var table = self.extShareDlg.clone(true);
        table.first('.view-name').attr('objid', view.objId); // No I18N
        table.first('.viewTypeIcon').addClass(self.viewTypeIcon[view.type]);
        table.first('[data-view-name]').text(view.objName); // No I18N

        var shareInfo = view.sharedInfo;
        for (var i = 0; i < shareInfo.length; i++) {
            var info = shareInfo[i];
            var row = self.extShareInfo.clone(true);
            row.attr('data-id', info.isGroup ? info.sharedToId : info.sharedTo).attr('data-index', i).attr('data-name', info.sharedTo); // No I18N
            self.isDomainAdmin && row.attr('data-zaid', info.sharedToZaid); // No I18N
            if(info.isGroup) {
                row.first('.zdbIconMG').removeClass('zdbIconMG').html(svgGroupIcon); // No I18N
            } else if(info.sharedToId == -30) {
                row.first('.zdbIconMG').removeClass('zdbIconMG').html(svgPrivateLinkIcon); // No I18N
            } else if(info.sharedToId == -20) {
                row.first('.zdbIconMG').removeClass('zdbIconMG').html(svgPublicVisitorIcon); // No I18N
            } else {
                row.first('.zdbIconMG').addClass('zdb-user-icon'); // No I18N
            }
            row.first('[data-email]').attr('tip', info.sharedTo).text(info.sharedTo); // No I18N
            row.first('[data-perms]').attr('tip', info.permString).text(info.permString); // No I18N
            row.first('.shared-by-info').text(ZDBI18NMap.g('zrpt.home.share.js.sharedby') + ' ' + (info.sharedBy == ZDBGlobal.emailID ? ZDBI18NMap.g('zr.share.js.me') : info.sharedBy)); // No I18N

            table.append(row);
        }

        if (shareInfo.length == 0) {
            var row = self.extShareInfo.clone(true).addClass('not-shared');
            var nothingShared = dom(ZRSStringTemplateCreator.createTemplateForData('nothingShared', 'sharingmodule')); // No I18N
            row.empty().append(nothingShared).removeAttr('onclick').removeAttr('onmouseout').removeAttr('onmouseover').addClass('not-shared'); // No I18N
            table.append(row);
            table.first('.select-all').remove(); // No I18N
        } else {
            var noUsersGroups = dom(ZRSStringTemplateCreator.createTemplateForData('noUsersGroups', 'sharingmodule')); // No I18N
            table.append(noUsersGroups);
        }

        return table;
    };

    self.toggleSharedInfo = function(el) {
        el = dom(el.parentNode);
        el.toggleClass('is-active'); // No I18N
        el.toDOM().style.maxHeight = el.hasClass('is-active') ? el.toDOM().scrollHeight + 'px' : '37px'; // No I18N

        var iconEl = el.first('.arrow-icon'); // No I18N
        (iconEl.hasClass('down')) ? iconEl.removeClass('down').addClass('up') : iconEl.removeClass('up').addClass('down'); // No I18N
    };

    self.editPermission = function(el) {
        var index = dom(el).dParent('ext-share-det-table').getIndex(); // No I18N
        var data = self.existingShareDetails[index];

        self.constructAndShowEditPermDialog(data, index);
    };

    self.constructAndShowEditPermDialog = function(data, index) {
        if (!self.editPermDlg || !self.permInfo) {
            self.editPermDlg = dom(ZRSStringTemplateCreator.createTemplateForData('editPermDialog', 'sharingmodule')); // No I18N
            self.permInfo = dom(ZRSStringTemplateCreator.createTemplateForData('editPermInfo', 'sharingmodule')); // No I18N
            self.permFooter = dom(ZRSStringTemplateCreator.createTemplateForData('editPermFooter', 'sharingmodule')); // No I18N
        };

        var viewType = self.viewType;

        //self.toggleColumnSharingOptions(viewType);

        var cont = self.editPermDlg.clone(true);
        var sharedBy = data.sharedInfo[0].sharedBy;
        var table = cont.first('#permsTable').attr('data-index', index); // No I18N

        for (var i = 0; i < data.sharedInfo.length; i++) {
            var row = self.permInfo.clone(true);
            var info = data.sharedInfo[i];

            row.first('[data-shared-to]').attr('tip', info.sharedTo).text(info.sharedTo); // No I18N
            row.first('[data-permissions]').attr('tip', info.permString).text(info.permString); // No I18N
            row.first('.zdbInfoIcon').attr('tip', ZDBI18NMap.g('zrpt.home.share.js.sharedby') + ' ' + (info.sharedBy == ZDBGlobal.emailID ? ZDBI18NMap.g('zr.share.js.me') : info.sharedBy)); // No I18N
            table.append(row);
        }

        var noUsersGroups = dom(ZRSStringTemplateCreator.createTemplateForData('noUsersGroups', 'sharingmodule')); // No I18N
        table.append(noUsersGroups);

        var permEls = self.layer2Body.find('[for]'); // No I18N
        for (var i = 0; i < permEls.length; i++) { self.hideUnrelatedPerm(dom(permEls[i]), viewType); }

        sidepane.show({
            header1: ZDBI18NMap.g('zr.share.js.edit_permission_for') + " '" + data.objName + "'",
            body1: cont.toDOM(),
            header2: ZDBI18NMap.g('zr.share.js.edit_permission'),
            body2: self.layer2Body,
            footer2: self.permFooter.toDOM()
        });
        table.height(sidepane.getActivePane().height() - 148);
    };

    self.toggleColumnSharingOptions = function(viewType) {
        var readExtOptions = self.layer2Body.first('label[for="readAccess"] > .extra-opts'); // No I18N
        if (viewType != 'Table') { readExtOptions.hide(); } else { readExtOptions.show(); }
    };

    self.updatePermsAndFilterCriteria = function(el, type) {
        el = dom(el);
        self.shareParams = JSON.parse(JSON.stringify(SharingModule_Model.updateViewPermParams));
        var isGroup, viewInfoEl;
        self.updateType = type;
        if (type == 'db-user-info') {
            viewInfoEl = el.dParent('view-info'); // No I18N
            var userInfoEl = viewInfoEl.dParent('db-user-info'); // No I18N
            isGroup = !(isNaN(userInfoEl.attr('data-id'))); // No I18N
            var infoIndex = viewInfoEl.parent().attr('data-index'); // No I18N
            var viewIndex = viewInfoEl.attr('data-index'); // No I18N
            var userInfo = isGroup ? self.dbShareInfoJSON.groups[infoIndex] : self.dbShareInfoJSON.users[infoIndex];
            var view = userInfo.views[viewIndex];
            self.viewType = self.viewTypeIcon[view.type];
            self.dataToBeUpdatedOn = { view: viewIndex, info: infoIndex, group: isGroup };
            self.getUserPermForView(view, userInfo, isGroup, viewInfoEl);
        } else {
            var viewIndex = el.dParent('ext-share-det-table').attr('data-index'); // No I18N
            var view = self.existingShareDetails[viewIndex];
            self.viewType = self.viewTypeIcon[view.type];
            viewInfoEl = el.dParent('view-info'); // No I18N
            var userIndex = parseInt(dom(viewInfoEl).attr('data-index')); // No I18N
            var userInfo = view.sharedInfo[userIndex];
            self.updateFields(view, userInfo, true);
            self.updatePermissionsInUI(view.sharedInfo[userIndex].permissions);
            if (self.viewType == 'Table') {
                self.columnShareInfo = view.viewInfo[0];
                self.shareParams.sharedColumnIds = userInfo.sharedColumnIds;
            }
            self.vudColumnsInfo = view;
            view.vudInfo.selectedVudCols = userInfo.vudColsForPerm;
            view.drillInfo.selectedDrillCols = userInfo.drillColsForPerm;

            self.shareParams.permissions = view.sharedInfo[userIndex].permissions;
            self.dataToBeUpdatedOn = { view: viewIndex, user: [userIndex] };
            self.constructUIandJSON(view, userInfo, userInfo.isGroup, viewInfoEl);
        }
        self.shareParams.objId = view.objId;
    };

    self.constructUIandJSON = function(view, userInfo, isGroup, viewInfoEl) {
        var permEls = self.layer2Body.find('[for]'); // No I18N
        for (var i = 0; i < permEls.length; i++) { self.hideUnrelatedPerm(dom(permEls[i]), self.viewType); }
        /* Column Sharing
        var readEl = self.layer2Body.first('[for=readAccess]'); // No I18N
        if (self.viewType == 'Table') { readEl.first('.extra-opts').show(); } else { readEl.first('.extra-opts').hide(); }
        */
        if (isGroup) {
            self.shareParams.groupIds.push(userInfo.sharedToId);
        } else {
            if (self.isDomainAdmin) { self.shareParams.users = [{ zaid: userInfo.sharedToZaid, emailIds: [userInfo.sharedTo] }]; } else { self.shareParams.users[0].emailIds.push(userInfo.sharedTo); }
        }
        self.permStrEl = viewInfoEl.first('[data-perms]'); // No I18N
    };

    self.getUserPermForView = function(view, userInfo, isGroup, viewInfoEl) {
        preloader.show(sidepane.getActivePane().first('.sidepane-container'), null, ZDBI18NMap.g('zr.share.js.info_fetching')); // No I18N
        AjaxAPI.sendRequest({
            URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/GETUSERPERMISSIONFORVIEW?OBJID=' + view.objId + '&PERMID=' + view.permId, METHOD: 'GET', // No I18N
            ONSUCCESSFUNC: self.showEditPermDlg,
            VIEW: view,
            USER: userInfo,
            ISGROUP: isGroup,
            VIEWEL: viewInfoEl
        });
    };

    self.showEditPermDlg = function(response, request) {
        preloader.hide(sidepane.getActivePane().first('.sidepane-container')); // No I18N
        var json = JSON.parse(response.responseText).data;
        request.VIEW.variables = self.dbShareInfoJSON.variables;
        request.VIEW.viewInfo = json.viewInfo;
        request.VIEW.vudInfo = json.vudInfo;
        request.VIEW.drillInfo = json.drillInfo;
        request.USER.filterCrieria = request.VIEW.filterCrieria;
        request.VIEW.inheritParentFilterCriteria = false; // To be removed once privided from API
        request.USER.inheritParentFilterCriteria = request.VIEW.inheritParentFilterCriteria;
        self.columnShareInfo = json.viewInfo[0];
        self.vudColumnsInfo = request.VIEW;
        self.shareParams.permissions = request.VIEW.permissions;
        self.updateFields(request.VIEW, request.USER, true);
        self.updatePermissionsInUI(request.VIEW.permissions);
        self.constructUIandJSON(request.VIEW, request.USER, request.ISGROUP, request.VIEWEL);
    };

    self.updateUserPermForView = function(response, request) {
        var responseJSON = JSON.parse(response.responseText).data;
        request.view.viewInfo = responseJSON.viewInfo;
        request.view.filterCriteria = responseJSON.filterCriteria;
        request.view.invalidFilterCriteria = responseJSON.invalidFilterCriteria;
        request.view.vudColsForPerm = responseJSON.vudColsForPerm;
        request.view.drillColsForPerm = responseJSON.drillColsForPerm;
    };

    self.updatePermissionsInUI = function(permissions) {
        for (perm in permissions) {
            if (perm == 'colsModified') continue;
            var checkboxEl = self.layer2Body.first('[name="' + perm + '"]'); // No I18N
            checkboxEl.checked(permissions[perm]);
            self.toggleParentChkBox(checkboxEl);
        }
    };

    self.updatePermAndFC4All = function(el) {
        el = dom(el).dParent('ext-share-det-table'); // No I18N
        var viewIndex = el.attr('data-index'); // No I18N
        var view = self.existingShareDetails[viewIndex];
        self.viewType = self.viewTypeIcon[view.type];
        self.vudColumnsInfo = view;
        self.columnShareInfo = view.viewInfo[0];
        /* Column Sharing
        if (self.viewType == 'Table') { self.layer2Body.first('[for=readAccess] .extra-opts').show(); } else { self.layer2Body.first('[for=readAccess] .extra-opts').hide(); } // No I18N
        */

        self.updateFields(view, view.sharedInfo[0], false);
        self.shareParams = JSON.parse(JSON.stringify(SharingModule_Model.updateViewPermParams));
        self.shareParams.objId = view.objId;
        var children = el.find('.selection-child > input:checked');
        var userIndices = [];
        for (var i = 0; i < children.length; i++) {
            var viewEl = dom(children[i]).dParent('view-info'); // No I18N
            var id = viewEl.attr('data-id'); // No I18N
            var index = viewEl.attr('data-index'); // No I18N
            var isGroup = view.sharedInfo[index].isGroup;
            if (isGroup) {
                self.shareParams.groupIds.push(id);
            } else {
                var matchFound = false;
                for (var j = 0; j < self.shareParams.users.length; j++) {
                    var temp = self.shareParams.users[j];
                    if (!view.sharedInfo[i].sharedToZaid) { view.sharedInfo[i].sharedToZaid = -1; }
                    if (temp.zaid == view.sharedInfo[i].sharedToZaid) {
                        temp.emailIds.push(view.sharedInfo[i].sharedTo);
                        matchFound = true;
                    }
                }
                if (!matchFound) { self.shareParams.users.push({ zaid: view.sharedInfo[i].sharedToZaid, emailIds: [view.sharedInfo[i].sharedTo] }); }
            }
            userIndices.push(index);
        }

        var firstUserPermission = view.sharedInfo[userIndices[0]].permissions;
        var allPermsAreSame = true;
        for (var i = 1; i < userIndices.length; i++) {
            var currPermission = view.sharedInfo[userIndices[i]].permissions;
            if (!Helper.compare(firstUserPermission, currPermission)) {
                allPermsAreSame = false;
                break;
            }
        }
        self.shareParams.permissions = allPermsAreSame ? firstUserPermission : currPermission;
        allPermsAreSame && self.updatePermissionsInUI(firstUserPermission);

        var permEls = self.layer2Body.find('[for]'); // No I18N
        for (var i = 0; i < permEls.length; i++) { self.hideUnrelatedPerm(dom(permEls[i]), self.viewType); }

        self.dataToBeUpdatedOn = { view: viewIndex, user: userIndices };
    };

    self.updateFields = function(view, userInfo, isSingleUser) {
        fc.fill({
            objId: view.objId,
            viewInfo: view.viewInfo,
            variables: view.variables
        });
        fc.toggleViewType(view.type);

        self.layer2Body.first('#fcTextArea').val(isSingleUser ? userInfo.filterCriteria : ''); // No I18N
        self.layer2Body.first('#inheritParentCriteria').checked(isSingleUser ? JSON.parse(userInfo.inheritParentFilterCriteria) : false); // No I18N

        self.resetPerms();
    };

    self.resetAllFields = function() {
        if (!self.json.isDomainAdmin) {
            var errorMsgEl = self.layer1Body.first('.specify-user-group'); // No I18N
            errorMsgEl.removeClass('invalid').first('span').i18n('zrpt.explorer.share.shareview.js.specifyusersgroups'); // No I18N
        }
        var textArea = self.layer1Body.first('.contact-textarea'); // No I18N
        bubble.clear(textArea);
        bubble.focusInputEl(textArea);
        
        var secondTextArea = self.layer1Body.first('.contact-textarea.second-domain'); // No I18N
        secondTextArea && bubble.clear(secondTextArea);
        
        self.resetPerms();
        self.layer2Body.first('#readAccess').checked(true); // No I18N
        self.layer1Body.first('#permInfoEl').i18n('zr.share.js.readonly'); // No I18N

        var sendInvMailEl = self.layer1Body.first('#sendInvMail'); // No I18N
        if (!sendInvMailEl.checked()) { sendInvMailEl.click(); }
        self.layer1Body.first('#sendCopy').checked(false); // No I18N
        self.layer1Body.first('.mail-container').dFadeOut(); // No I18N

        self.layer1Body.first('.confirm-dlg-cont').dFadeOut(); // No I18N

        // Group member related restrictions
        if (ZDBClientUI.isGroupMember) {
            // Server implementation not done yet
        }
    };

    self.resetPerms = function() {
        var permEls = self.layer2Body.find('div.view-perms input'); // No I18N
        for (var i = 0; i < permEls.length; i++) { if (permEls[i].name != 'read') { permEls[i].checked = false; } }

        var permHeads = self.layer2Body.find('.perm-head > input');
        for (var i = 0; i < permHeads.length; i++) { permHeads[i].checked = false; }
    };

    self.selectThisElement = function(el) {
        var inputEl = dom(el).first('input'); // No I18N
        var currentState = inputEl.checked();
        inputEl.checked(!currentState);

        self.toggleShareParent(el);
    };

    self.checkAllShare = function(el) {
        //selection-parent
        var par = dom(el).dParent('selection-parent'); // No I18N
        var inputEls = par.find('.selection-child > input');

        for (var i = 0; i < inputEls.length; i++) { inputEls[i].checked = el.checked; }
        self.showRhideOpts(par);
    };

    self.toggleShareParent = function(el) {
        var par = dom(el).dParent('selection-parent'); // No I18N
        var inputEls = par.find('.selection-child > input');

        var allChecked = true;
        for (var i = 0; i < inputEls.length; i++) { allChecked = (allChecked && inputEls[i].checked); }
        par.first('input[type=checkbox]').checked(allChecked); // No I18N
        self.showRhideOpts(par);
        event.stopPropagation();
    };

    self.showRhideOpts = function(el) {
        var viewOptsCont = dom(el).first('.views-opt-cont'); // No I18N
        if (viewOptsCont) {
            var inputEls = dom(el).find('.selection-child > input:checked'); // No I18N
            if (inputEls.length > 0) { viewOptsCont.show(); } else { viewOptsCont.hide(); }
        }
    };

    self.updatePermission = function() {
        if (self.shareParams.permissions.colsModified == undefined) { self.shareParams.permissions.colsModified = true; }
        self.shareParams.filterCriteria = self.layer2Body.first('#fcTextArea').val(); // No I18N
        self.shareParams.inheritParentCriteria = self.layer2Body.first('#inheritParentCriteria').checked(); // No I18N
        var viewId = self.shareParams.objId;
        var shareInfo = encodeURIComponent(JSON.stringify(self.shareParams));
        preloader.show(sidepane.getActivePane().first('.sidepane-container'), null, ZDBI18NMap.g('zr.share.js.info_updating_permissions')); // No I18N
        AjaxAPI.sendRequest({ URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/view/' + viewId + '/UPDATEVIEWPERMISSION?SHAREINFO=' + shareInfo, METHOD: 'POST', ONSUCCESSFUNC: self.updatePermissionOnSuccess, perms: self.shareParams.permissions });
    };

    self.updatePermissionOnSuccess = function(response, request) {
        var responseJSON = JSON.parse(response.responseText).data;
        preloader.hide(sidepane.getActivePane().first('.sidepane-container')); // No I18N
        ZDBMsgBox.showSuccess(ZDBI18NMap.g('zrpt.common.toolbar.share.successmsg.js.selUsersChngPermSuccess'));
        if (self.updateType == 'db-user-info') {
            var info = self.dataToBeUpdatedOn.group ? self.dbShareInfoJSON.groups[self.dataToBeUpdatedOn.info] : self.dbShareInfoJSON.users[self.dataToBeUpdatedOn.info];
            info.views[self.dataToBeUpdatedOn.view].permissions = responseJSON.permissions;
            info.views[self.dataToBeUpdatedOn.view].permString = responseJSON.permString;
        } else {
            var parent = sidepane.getActivePane();
            for (var i = 0; i < self.dataToBeUpdatedOn.user.length; i++) {
                var data = self.existingShareDetails[self.dataToBeUpdatedOn.view].sharedInfo[self.dataToBeUpdatedOn.user[i]];
                if (self.isDomainAdmin) {
                    parent.first('[data-id="' + data.sharedTo + '"][data-zaid="' + data.sharedToZaid + '"] [data-perms]').attr('tip', responseJSON.permString).text(responseJSON.permString); // No I18N
                } else {
                    parent.first('[data-id="' + (data.isGroup ? data.sharedToId : data.sharedTo) + '"] [data-perms]').attr('tip', responseJSON.permString).text(responseJSON.permString); // No I18N
                }
                data.permissions = responseJSON.permissions;
                data.permString = responseJSON.permString;
                data.filterCrieria = self.shareParams.filterCrieria;
                data.inheritParentCriteria = self.shareParams.inheritParentCriteria;
                data.vudColsForPerm = self.shareParams.defVudCols;
                data.drillColsForPerm = self.shareParams.defDrillCols;
                data.sharedColumnIds = self.shareParams.sharedColumnIds;
            }
        }
        sidepane.slideIn();
    };

    self.removePermission = function(el, type) {
        el = dom(el);
        var shareInfo = JSON.parse(JSON.stringify(SharingModule_Model.removeParams));
        if (type) {
            var par = el.dParent(type);
            var userIndex = par.getIndex();
            var id = par.attr('data-id'); // No I18N
            var data = isNaN(id) ? self.dbShareInfoJSON.users[userIndex] : self.dbShareInfoJSON.groups[userIndex];
            var viewEl = el.dParent('view-info'); // No I18N
            var viewIndex = el.closest('li').attr('data-index'); // No I18N
            shareInfo.objId = data.views[viewIndex].objId;
            isNaN(id) ? shareInfo.users[0].emailIds.push(id) : shareInfo.groupIds.push(id);
            preloader.show(viewEl, 'xs', ZDBI18NMap.g('zr.share.js.info_removing_permissions')); // No I18N
        } else {
            var par = el.closest('ul'); // No I18N
            var viewIndex = par.attr('data-index'); // No I18N
            var data = self.existingShareDetails[viewIndex];
            var elIndex = el.closest('li').attr('data-index'); // No I18N
            shareInfo.objId = data.objId;
            if (data.sharedInfo[elIndex].isGroup) {
                shareInfo.groupIds.push(data.sharedInfo[elIndex].sharedToId);
            } else {
                if (self.isDomainAdmin) { shareInfo.users = [{ zaid: data.sharedInfo[elIndex].sharedToZaid, emailIds: [data.sharedInfo[elIndex].sharedTo] }]; } else { shareInfo.users[0].emailIds.push(data.sharedInfo[elIndex].sharedTo); }
            }
            preloader.show(par, 'xs', ZDBI18NMap.g('zr.share.js.info_removing_permissions')); // No I18N
        }
        var viewId = shareInfo.objId;
        shareInfo = encodeURIComponent(JSON.stringify(shareInfo));
        AjaxAPI.sendRequest({ URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/view/' + viewId + '/REMOVEVIEWPERMISSION?SHAREINFO=' + shareInfo, METHOD: 'POST', ONSUCCESSFUNC: self.removePermissionOnSuccess, ELEMENT: el, VIEWINDEX: viewIndex, SHAREINDEX: elIndex });
    };

    self.removePermissionOnSuccess = function(response, request) {
        preloader.hide(sidepane.getActivePane().first('.sidepane-container')); // No I18N
        var el = dom(request.ELEMENT);
        var li = el.closest('li').fadeOut(); // No I18N
        ZDBMsgBox.showSuccess(ZDBI18NMap.f("zrpt.common.toolbar.share.successmsg.js.shareRemSuccess", ZDBI18NMap.g("zrpt.common.toolbar.share.successmsg.js.seluser")));
        setTimeout(function() { li.remove(); }, 300);
    };

    self.removePermissions = function(el) {
        var dlg = sidepane.getActivePane().first('.confirm-dlg-cont'); // No I18N
        dlg.first('[data-message]').text(ZDBI18NMap.g('zrpt.common.toolbar.share.zdbalertmsg.js.remPermConfirm')); // No I18N
        dlg.dFadeIn();
        var positiveButton = dlg.first('.greenBtn').replaceSelf(); // No I18N
        positiveButton.on('click', function() { // No I18N
            dlg.dFadeOut();
            var par = dom(el).closest('ul'); // No I18N
            var data = self.existingShareDetails[par.attr('data-index')]; // No I18N
            var shareInfo = JSON.parse(JSON.stringify(SharingModule_Model.removeParams));
            shareInfo.objId = data.objId;

            var inputEls = par.find('.selection-child > input');
            for (var i = 0; i < inputEls.length; i++) {
                if (inputEls[i].checked) {
                    if (data.sharedInfo[i].isGroup) {
                        shareInfo.groupIds.push(data.sharedInfo[i].sharedToId);
                    } else {
                        var matchFound = false;
                        for (var j = 0; j < shareInfo.users.length; j++) {
                            var temp = shareInfo.users[j];
                            if (!data.sharedInfo[i].sharedToZaid) { data.sharedInfo[i].sharedToZaid = -1; }
                            if (temp.zaid == data.sharedInfo[i].sharedToZaid) {
                                temp.emailIds.push(data.sharedInfo[i].sharedTo);
                                matchFound = true;
                            }
                        }
                        if (!matchFound) { shareInfo.users.push({ zaid: data.sharedInfo[i].sharedToZaid, emailIds: [data.sharedInfo[i].sharedTo] }); }
                    }
                }
            }
            var viewId = shareInfo.objId;
            shareInfo = encodeURIComponent(JSON.stringify(shareInfo));
            preloader.show(sidepane.getActivePane().first('.sidepane-container'), 'medium', ZDBI18NMap.g('zr.share.js.info_removing_permissions')); // No I18N
            AjaxAPI.sendRequest({ URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/view/' + viewId + '/REMOVEVIEWPERMISSION?SHAREINFO=' + shareInfo, ONSUCCESSFUNC: self.removePermissionsOnSuccess, PARENT: par });
        });
    };

    self.removePermissionsOnSuccess = function(response, request) {
        preloader.hide(sidepane.getActivePane().first('.sidepane-container')); // No I18N
        var par = dom(request.PARENT);
        var inputEls = par.dFind('input:checked'); // No I18N
        for (var i = 0; i < inputEls.length(); i++) { inputEls.eq(i).dParent('view-info').remove(); }
    };

    self.searchShareInfo = function(el, event) {
        var el = dom(el);
        var par = dom(el).dParent('existing-share-details-cont'); // No I18N
        var parLists = par.find('.ext-share-det-table');
        var noMatchEl = par.first('.no-match'); // No I18N
        noMatchEl && noMatchEl.hide();

        var searchKey = el.val().trim().toLowerCase();
        for (var i = 0, parMatchCount = 0; i < parLists.length; i++) {
            var parItem = parLists[i];
            var parValue = dom(parItem).first('[data-view-name]').text().toLowerCase().trim(); // No I18N
            var isEmail = Helper.isValidEmail(parValue);
            var childLists = dom(parItem).find('[data-name]');
            for (var j = 0, childMatchCount = 0; j < childLists.length; j++) {
                var childItem = childLists[j];
                var childValue = dom(childItem).text().toLowerCase().trim();
                if (parValue.indexOf(searchKey) != -1 || childValue.indexOf(searchKey) != -1) {
                    childMatchCount++;
                    dom(childItem).show();
                } else {
                    dom(childItem).hide();
                }
            }
            var searchMatchInfo = '';
            if (searchKey == '') {} else if (parValue.indexOf(searchKey) != -1) { searchMatchInfo = '(' + ZDBI18NMap.g('zr.share.js.view_match_found') + ')'; } else { searchMatchInfo = '(' + ((childMatchCount > 0) ? (childMatchCount + ' ' + ZDBI18NMap.g(childMatchCount == 1 ? 'zr.share.js.match_found' : 'zr.share.js.matches_found')) : ZDBI18NMap.g('zr.share.js.no_views_found')) + ')'; }
            dom(parItem).first('.ext-share-search-result').text(searchMatchInfo); // No I18N
            if (parValue.indexOf(searchKey) != -1 || childMatchCount > 0) {
                parMatchCount++;
                dom(parItem).show();
            } else {
                dom(parItem).hide();
            }
        }
        if (parMatchCount == 0) { noMatchEl && noMatchEl.show(); }
    };

    self.getDBShareInfo = function() {
        //self.setDBShareInfo();
        AjaxAPI.sendRequest({ URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/GETDBSHAREINFO', METHOD: 'GET', ONSUCCESSFUNC: self.setDBShareInfo, OPSTATUSID: 'ZDBMainLoader' });
    };

    self.setDBShareInfo = function(response, request) {
        self.dbShareInfoJSON = JSON.parse(response.responseText).data;
        //self.dbShareInfoJSON = SharingModule_Model.dbShareInfo;

        self.constructDBShareInfoDlg();
        self.fillDBShareInfo();
    };

    self.constructDBShareInfoDlg = function() {
        if (!self.dbUserInfo) { self.dbUserInfo = dom(ZRSStringTemplateCreator.createTemplateForData('dbUserInfo', 'sharingmodule')); }
        if (!self.dbShareInfo) { self.dbShareInfo = dom(ZRSStringTemplateCreator.createTemplateForData('dbShareInfo', 'sharingmodule')); }
        if (!self.editPermFooter) { self.editPermFooter = dom(ZRSStringTemplateCreator.createTemplateForData('editPermFooter', 'sharingmodule')); }
        self.constructPermAndFilterCriteria();
    };

    self.fillDBShareInfo = function() {
        var tabView;
        if (self.dbShareInfoJSON.isDomain) {
            var commonPerms = self.constructDBPerms(self.dbShareInfoJSON.users[0].permInfo);
            var zohoDomainPerms = self.constructDBPerms(self.dbShareInfoJSON.users[1].permInfo);
            var otherDomainPerms = self.constructDBPerms(self.dbShareInfoJSON.users[2].permInfo);
            self.dbShareInfoJSON.users[1].domainName = 'reports.zoho.com'; // should be removed
            tabView = tab.construct({
                switches: [ ZDBI18NMap.g('zr.share.js.common_perms'), self.dbShareInfoJSON.users[1].domainName, self.dbShareInfoJSON.users[2].domainName ],
                contents: [ commonPerms, zohoDomainPerms, otherDomainPerms ],
                callback: self.clearSearchBox
            });
        } else {
            var userPerms = self.constructDBPerms(self.dbShareInfoJSON.users);
            var groupPerms = self.constructDBPerms(self.dbShareInfoJSON.groups, true);
            tabView = tab.construct({
                switches: [ ZDBI18NMap.g('zrpt.dbsettings.variables.js.users'), ZDBI18NMap.g('zr.share.js.groups') ],
                contents: [ userPerms, groupPerms ],
                callback: self.clearSearchBox
            });
        }
        tabView.append(dom(ZRSStringTemplateCreator.createTemplateForData('search', 'sharingmodule'))); // No I18N

        sidepane.show({
            header1: ZDBI18NMap.g('zrpt.explorer.share.editsharedet.js.dlgTtl'),
            body1: tabView,
            header2: ZDBI18NMap.g('zr.share.js.edit_permission'),
            body2: self.layer2Body,
            footer2: self.editPermFooter.toDOM()
        });
    };

    self.clearSearchBox = function() { self.clearSearch(sidepane.getActivePane().first('.search-view').toDOM()); };  // No I18N

    self.constructDBPerms = function(json, isGroup) {
        var dbPerms = dom.new('div', { attributes: { style: 'padding: 10px;' } }); // No I18N
        var nothingHere = dom(ZRSStringTemplateCreator.createTemplateForData('nothingHere', 'sharingmodule')); // No I18N
        (json.length == 0) && (dbPerms.append(nothingHere));
        for (var i = 0; i < json.length; i++) {
            var user = json[i];
            var ul = dom.new('ul', { attributes: { class: 'db-share-info-table enable-transition' } }); // No I18N
            ul.attr('data-index', i); // No I18N

            for (var j = 0; j < user.views.length; j++) {
                var view = user.views[j];
                var shareInfo = self.dbShareInfo.clone(true);

                shareInfo.attr('data-index', j); // No I18N
                shareInfo.first('.viewTypeIcon').addClass(self.viewTypeIcon[view.type]);
                shareInfo.first('[data-view-name]').text(view.name).attr('tip', view.name); // No I18N
                shareInfo.first('[data-perms]').text(view.permString).attr('tip', view.permString); // No I18N
                shareInfo.first('.db-user-shared-by').text(ZDBI18NMap.g('zrpt.home.share.js.sharedby') + ' ' + (view.sharedByEmail == ZDBGlobal.emailID ? ZDBI18NMap.g('zr.share.js.me') : view.sharedByEmail)); // No I18N
                ul.append(shareInfo);
            }
            var userInfo = self.dbUserInfo.clone(true);
            var userName = user.sharedTo;

            if (isGroup) {
                userInfo.attr('data-id', user.sharedToId); // No I18N
                userInfo.first('.pic-holder > img').hide(); // No I18N
                userInfo.first('.pic-holder > .no-image').show().html(svgGroupIcon); // No I18N
            } else {
                userInfo.attr('data-id', user.sharedTo); // No I18N
                userInfo.first('.no-image').text(userName.toUpperCase()[0]).hide();

                if(user.sharedToId == '-20') { // Public Visitor
                    userInfo.first('.pic-holder > img').hide(); // No I18N
                    userInfo.first('.pic-holder > .no-image').show().html(svgPublicVisitorIcon); // No I18N
                } else if(user.sharedToId == '-30') { // Private Link
                    userInfo.first('.pic-holder > img').hide(); // No I18N
                    userInfo.first('.pic-holder > .no-image').show().html(svgPrivateLinkIcon); // No I18N
                } else {
                    var contactImgEl = userInfo.first('img').toDOM(); // No I18N
                    contactImgEl.src = ContactsAPI.getImgURL(user.sharedToId);

                    contactImgEl.onerror = function(event) {
                        var img = dom(event.currentTarget);
                        var conImg = img.hide().dParent('pic-holder'); // No I18N
                        conImg.first('.no-image').show(); // No I18N
                    };
                }
            }
            userInfo.first('[data-name]').text(userName); // No I18N
            userInfo.append(ul);
            dbPerms.append(userInfo);
        }

        var noMatchFound = dom(ZRSStringTemplateCreator.createTemplateForData('noMatchFound', 'sharingmodule')); // No I18N
        (json.length > 0) && dbPerms.append(noMatchFound);
        return dbPerms;
    };

    self.toggleDBShareInfo = function(el) {
        var parentNode = dom(el.parentNode).toggleClass('is-active'); // No I18N
        var content = parentNode.first('.db-share-info-table'); // No I18N
        content.height(dom(el.parentNode).isActive() ? content.toDOM().scrollHeight : '0');
        var iconEl = dom(el).first('.arrow-icon'); // No I18N
        (iconEl.hasClass('down')) ? iconEl.removeClass('down').addClass('up') : iconEl.removeClass('up').addClass('down'); // No I18N
    };

    self.removeUserPermission = function(el) {
        sidepane.showConfirmDialog({
            message: ZDBI18NMap.g('zrpt.explorer.share.editsharedet.js.removePerm4UserConfirm'),
            onProceed: function(extras) {
                sidepane.hideConfirmDialog();
                var parent = dom(extras.el).dParent('db-user-info'); // No I18N
                preloader.show(parent, 'xs', ZDBI18NMap.g('zr.share.js.info_removing_permissions')); // No I18N
                var id = parent.attr('data-id'); // No I18N
                var json = {};
                if (isNaN(id)) {
                    json.emailId = id;
                    json.zaid = '-1';
                } else {
                    json.groupId = id;
                }
                AjaxAPI.sendRequest({ URL: '/reportsapi/db/' + ZDBClientUI.dbId + '/REMOVEUSERPERMISSION?SHAREINFO=' + encodeURIComponent(JSON.stringify(json)), METHOD: 'POST', ONSUCCESSFUNC: self.removeUserPermOnSuccess, ELEMENT: parent });
            },
            extras: { el: el }
        });
    };

    self.removeUserPermOnSuccess = function(response, request) { request.ELEMENT.fadeOut(); };

    self.toggleSearch = function(event) {
        var cont = dom(event.currentTarget).parent();
        cont.toggleClass('is-active'); // No I18N
        var el = cont.first('input'); // No I18N
        el.focus();
    };

    self.search = function(el) {
        var el = dom(el);
        var par = dom(el).dParent('tabs').first('.tab-contents li.active'); // No I18N
        var parLists = par.find('.db-user-info');
        var noMatchEl = par.first('.no-match'); // No I18N
        noMatchEl && noMatchEl.hide();

        var searchKey = el.val().trim().toLowerCase();
        for (var i = 0, parMatchCount = 0; i < parLists.length; i++) {
            var parItem = parLists[i];
            var parValue = dom(parItem).first('[data-name]').text().toLowerCase().trim(); // No I18N
            var isEmail = Helper.isValidEmail(parValue);
            var childLists = dom(parItem).find('.view-info');
            for (var j = 0, childMatchCount = 0; j < childLists.length; j++) {
                var childItem = childLists[j];
                var childValue = dom(childItem).first('[data-view-name]').attr('tip').toLowerCase().trim(); // No I18N
                if (parValue.indexOf(searchKey) != -1 || childValue.indexOf(searchKey) != -1) {
                    childMatchCount++;
                    dom(childItem).show();
                } else {
                    dom(childItem).hide();
                }
            }
            var searchMatchInfo = '';
            if (searchKey == '') {} else if (parValue.indexOf(searchKey) != -1) { searchMatchInfo = '(' + ZDBI18NMap.g(isEmail ? 'zr.share.js.user_match_found' : 'zr.share.js.group_match_found') + ')'; } else { searchMatchInfo = '(' + ((childMatchCount > 0) ? (childMatchCount + ' ' + ZDBI18NMap.g(childMatchCount == 1 ? 'zr.share.js.view_found' : 'zr.share.js.views_found')) : ZDBI18NMap.g('zr.share.js.no_views_found')) + ')'; }
            dom(parItem).first('.search-match-info').text(searchMatchInfo); // No I18N
            if (parValue.indexOf(searchKey) != -1 || childMatchCount > 0) {
                parMatchCount++;
                dom(parItem).show();
            } else {
                dom(parItem).hide();
            }
        }
        if (parMatchCount == 0) { noMatchEl && noMatchEl.show(); }
    };

    self.closeSearch = function(el) { if (el.value.trim() == '') { dom(el).dParent("search-view-cont").removeClass("is-active"); } }; //No I18N

    self.clearSearch = function(el) {
        var textEl = dom(el).dParent('search-view-cont').first('input'); // No I18N
        if (textEl.val() != '') {
            setTimeout(function() {
                self.resetSearch(textEl);
                textEl.focus();
            }, 100);
        }
    };

    self.resetSearch = function(textEl) {
        textEl.val(''); // No I18N
        self.search(textEl); // No I18N4
    };

};

// SVG Icon Reference
var svgGroupIcon = '<svg class="svgIcons share-icons"><use class="gr" xlink:href="#ZR-group"></use></svg>'; // No I18N
var svgPrivateLinkIcon = '<svg class="svgIcons share-icons"><use class="gr" xlink:href="#ZR-privateLink"></use></svg>'; // No I18N
var svgPublicVisitorIcon = '<svg class="svgIcons share-icons"><use class="gr" xlink:href="#ZR-publicVistor"></use></svg>'; // No I18N
var svgDownArrowIcon = '<svg class="svgIcons enable-transition" style="margin: initial; height: 14px; width: 14px; stroke-width: 1px;"><use class="gr" xlink:href="#ZR-downArrow"></use></svg>'; // No I18N