// $Id$ 
//ignorei18n_start
var ZRSMenu_Model = new function(){
    this.headerHelpMenu = function(){
        var menuData = {};
        menuData.divID = 'ZDBProductLinksMenu';
        menuData.divStyle = 'display:none';
        menuData.pointerReq = {
            condition : true,
            data : {
                beforePointerClass:'ZRSMenuTopBefore',
                beforePointerStyle:'right:7px',
                afterPointerClass:'ZRSMenuTopAfter',
                afterPointerStyle:'right:8px'
            }
        };
        if(ZDBGlobal.IS_SAS_BUILD){
            menuData.menuData = this.buildSASHeaderHelpMenu();
        }
        else{
            //OP help menu.
			menuData.menuData = this.buildOnPremiseHelpMenu();
        }
        return menuData;
    };
    this.buildSASHeaderHelpMenu = function(){
        var menuData = [];
        //adding getting started menu.
        if(!ZDBGlobal.ISDEMO){
            menuData.push({
                link: 'javascript:void(0)',
                onclick: 'ZDBClientUI.openGettingStartedDlg(this)',
                menuText: ZDBI18NMap.g('zrpt.common.js.gettingstarted')
            });
        }
        
        //adding videos, api, webinar, helpdocs links
        if(ZDBGlobal.isZDomain || ZDBGlobal.isFujiDomain){
            menuData.push({
                link: ZDBI18NMap.g('zrpt.links.js.videodemo'),
                target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.home.productlinks.js.videodemos')
            });
            menuData.push({
                link: ZDBI18NMap.g('zrpt.links.js.webinar'),
                target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.common.js.webinars')
            });
            menuData.push({
                link: ZDBI18NMap.g('zrpt.links.js.apidoc'),
                target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.home.productlinks.js.apidoc')
            });
            menuData.push({
                link: ZDBI18NMap.g('zrpt.links.js.helpdoc'),
                target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.home.productlinks.js.helpdoc')
            });
        }
        //FAQ help
        menuData.push({
            link: ZDBI18NMap.g('zrpt.links.js.faq'),
            target: '_blank',
            menuText: ZDBI18NMap.g('zrpt.common.js.faq')
        });
        menuData.push({
            link: '#',
            class: 'ZRSMenuSeparator'
        });
        //whats new link
        if(!ZDBGlobal.ISPUBLICUSER){
            menuData.push({
                link:ZDBI18NMap.g('zrpt.links.js.whatsnew'),
                target: '_blank',
                menuText: ZDBGlobal.HEADERWHATSNEWTEXT
            });
        }
        
        if(ZDBGlobal.isZDomain){
            menuData.push({
                link:ZDBI18NMap.g('zrpt.links.js.submitanidea'),
                target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.common.js.submitanidea')
            });
            menuData.push({
                link:ZDBI18NMap.g('zrpt.links.js.forum'),
                target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.common.js.forum')
            });
            menuData.push({
                link:ZDBI18NMap.g('zrpt.links.js.blogs'),
                target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.common.js.blogs')
            });
        }
        menuData.push({
            link: '#',
            class: 'ZRSMenuSeparator'
        });
        
        //Sample Database link
        menuData.push({
            link:ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBSampleDatabases.cc',
            target: '_blank',
            menuText: ZDBI18NMap.g('zrpt.common.trysampledbs.js.new')
        });
        //public databsae
        if(ZDBGlobal.SHOWMAKEDBPUBLIC){
            menuData.push({
                link:ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBPublicDatabases.cc',
                target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.common.trypublicdbs.js.new')
            });
        }
        
        menuData.push({
            link: '#',
            class: 'ZRSMenuSeparator'
        });
        
        if(!ZDBGlobal.ISSTANDALONE && !ZDBGlobal.ISPUBLICUSER && ZDBGlobal.SHOWLIVECHAT){
            menuData.push({
                link : 'javascript:void(null)',
                onclick: 'ZRSupportClass.handleLiveChatClick(this,event)',
                class: 'quickLink',
                menuText: ZDBI18NMap.g('zrpt.common.js.livechat')
            });
        }
        
        menuData.push({
            link : 'javascript:void(null)',
            onclick: 'ZDBGlobal.showFeedBack(this,event)',
            class: 'quickLink bold',
            menuText: ZDBI18NMap.g('zrpt.home.js.feedback')
        });
        
        menuData.push({
            link : 'javascript:void(null)',
            onclick: 'ZDBGlobal.showFeedBack(this,event)',
            class: 'quickLink bold',
            elname: 'contactsupport',
            menuText: ZDBI18NMap.g('zrpt.common.home.js.contactsupport')
        });
        
        return menuData;
    };
	
	this.buildOnPremiseHelpMenu = function(){
		var menuData = [];
		
		//adding helpdoc menu.
		if(!ZDBGlobal.ISOPOEM) {
			menuData.push({
				link : ZDBI18NMap.f('zrpt.links.js.helpdoc',ZDBGlobal.DID),
				target: '_blank',
                menuText: ZDBI18NMap.g('zrpt.home.productlinks.js.helpdoc')
			});
		}
		
		//adding getting started menu.
        if(!ZDBGlobal.ISOPOEM){
            menuData.push({
                link: 'javascript:void(0)',
                onclick: 'zroptopbar.openZROPGettingStartedDlg(false,ZDBGlobal.ISORGADMINUSER)',
                menuText: ZDBI18NMap.g('zrpt.common.js.gettingstarted')
            });
        }
		
		if(!ZDBGlobal.ISOPOEM){
			menuData.push({
				link: '#',
				class: 'ZRSMenuSeparator'
			});
		}
		
		if(ZDBGlobal.SHOWSAMPLEDB && !ZDBGlobal.ISSAMPLEDBPOPULATED){
			menuData.push({
				link: 'https://analyticsplusdemo.manageengine.com/ZROPSampleDatabases.cc',
				target: '_blank',
				menuText: ZDBI18NMap.g('zrpt.common.trysampledbs.js.new')
			});
		}
		
		if(ZDBGlobal.SHOWSAMPLEDB && ZDBGlobal.ISSAMPLEDBPOPULATED){
			menuData.push({
				link : 'javascript:void(0)',
				onclick: 'openLink("/ZROPSampleDatabases.cc/", "false", "true")',
				menuText: ZDBI18NMap.g('zrpt.common.trysampledbs.js.new')
			});
		}
		
		
		
		if(ZDBGlobal.SHOWMAKEDBPUBLIC){
			menuData.push({
				link : ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBPublicDatabases.cc',
				target: '_blank',
				menuText: ZDBI18NMap.g('zrpt.common.home.js.publicdb')
			});
		}
		
		if(ZDBGlobal.SHOWSAMPLEDB && !ZDBGlobal.ISOPOEM){
			menuData.push({
				link: '#',
				class: 'ZRSMenuSeparator'
			});
		}
		
		menuData.push({
			link : 'javascript:void(0)',
			onclick: 'zropmisc.showDialog("/ZROPAbout.cc", afterAboutLoad)',
			menuText: ZDBI18NMap.g('zrop.js.about'),
			class : 'quicklink'
		});
		
		menuData.push({
			link : 'javascript:void(0)',
			onclick: 'zropmisc.showDialog("/ZROPTroubleshoot.cc", afterTroubleshootLoad)',
			menuText: ZDBI18NMap.g('zrop.troubleshoot.menu.js.item'),
			class : 'quicklink'
		});
		
		if(!ZDBGlobal.ISOPOEM){
			menuData.push({
				link : 'javascript:void(0)',
				onclick: 'loadContactSupport(this, event)',
				menuText: ZDBI18NMap.g('zrpt.home.feedback.js.contactsupport'),
				class : 'quicklink' 
			});
		}				
		
		
		return menuData;
	};
};
//ignorei18n_end
ZRSHTMLTemplateStrings["__headerhelpmenu__zrsmenu__model"] = ZRSMenu_Model.headerHelpMenu();
