/*$Id$*/

var TholdComponents = new function()
{
    this.initComponents = function(propSetUtil, trEl, tholdAxisDivEls, tholdLabelSize)
    {
        TholdComponents.initScope(propSetUtil, trEl);
        TholdComponents.initRefAxis(propSetUtil, trEl, tholdAxisDivEls, tholdLabelSize);
        TholdComponents.initValue(propSetUtil, trEl);
        TholdComponents.initFormat(trEl);
    };
    
    // initialise scope select box - set style, add options, handle events
    this.initScope = function(propSetUtil, trEl)
    {
        var scopeEl = jQuery(trEl.scopeEl);
        scopeEl.data("zselectbox") && scopeEl.zselectbox("destroy"); //No I18N
        scopeEl.zselectbox({
                dropdownList : {width: "60", height:"100"} //No I18N
            });
        if(!propSetUtil.view.nopercell)
        {
            scopeEl.zselectbox('addOption', [{ //No I18N
                label: ZDBI18NMap.g("zrpt.common.analysis.threshold.settings.js.percell"),
                value: "1"
            }]);
        }
        else
        {
            scopeEl.zselectbox("setAttribute", "disabled", true); //No I18N
        }
        scopeEl.on("zselectboxchange", function(event, data) {
            var tdEl = ZDBUtil.getParentWithTagName(this, "td"); //No I18N
            tdEl.setAttribute("propvalue", data.selectedValue);
        });
        scopeEl.on("zselectboxbeforedropdownlistopen", function(event, data) {
           ZDBAxisProp.hideComboOptComp(); 
        });
    };

    // initialise ref. axis select box - set style, add options, handle events
    this.initRefAxis = function(propSetUtil, trEl, tholdAxisDivEls, size)
    {
        var axisEl = jQuery(trEl.refAxisEl);
        axisEl.data("zselectbox") && axisEl.zselectbox("destroy"); //No I18N
        axisEl.zselectbox({
                dropdownList : {width: "60", height:"150"} //No I18N
            });
        for(var i=0; i < size ; i++)
        {
            var tholdEl = tholdAxisDivEls[i];
            var instKey = ZDBAnalysisView.replaceInstKey(propSetUtil.view, tholdEl.key);
            axisEl.zselectbox('addOption', [{ //No I18N
                label: tholdEl.label,
                value: i,
                customData: instKey
            }]);
            if(i === 0) {
                trEl.tSelect.value = instKey;
            }
        }
        if(size === 1) {
            axisEl.zselectbox("setAttribute", "disabled", true); //No I18N
        }
        axisEl.zselectbox("setAttribute", "selectedIndex", 0); //No I18N
        axisEl.on("zselectboxchange", function(event, data) {
            var tdEl = ZDBUtil.getParentWithTagName(this, "td"); //No I18N
            var selVal = data.selectedValue;
            tdEl.setAttribute("propvalue", selVal);
            tdEl.value = data.optionData.customData;
        });
        axisEl.on("zselectboxbeforedropdownlistopen", function(event, data) {
           ZDBAxisProp.hideComboOptComp(); 
        });
    };
    
    // intialise value select box - set default value
    this.initValue = function(propSetUtil, trEl)
    {
        trEl.funcDiv.innerHTML = propSetUtil.propSetForm.func0.innerHTML;
    };

    // initialise format select box - set style, add options, handle events
    this.initFormat = function(trEl)
    {
        var formatEl = jQuery(trEl.formatEl);
        formatEl.data("zselectbox") && formatEl.zselectbox("destroy"); //No I18N
        formatEl.zselectbox({
            contentType: 'custom', //No I18N
            dataSource : TholdComponents.getFormatData(),
            dropdownList : {width: "82", height:"150"} //No I18N
        });
        formatEl.zselectbox("setAttribute", "selectedIndex", 0); //No I18N
        formatEl.on("zselectboxchange", function(event, data) {
            var tdEl = ZDBUtil.getParentWithTagName(this, "td"); //No I18N
            tdEl.setAttribute("propvalue", data.selectedValue);
        });
        formatEl.on("zselectboxbeforedropdownlistopen", function(event, data) {
           ZDBAxisProp.hideComboOptComp(); 
        });
    };
    
    this.getFormatData = function()
    {
        var dataSource = [];
        var label = [ZDBI18NMap.g("zrpt.common.analysis.threshold.settings.js.default"),
                'style1', 'style2', 'style3', 'style4', 'style5', 'style6']; //No I18N
        var hrClass = " strokeStyle"; //No I18N
        var innerHTML = '<div style="text-align: center">'+label[0]+'</div>'; //No I18N
        for(var i=0; i<label.length; i++)
        {
            if(i > 0)
            {
                var ctr = 1;
                var lineClass = "solidStrokeStyle"; //No I18N
                if(i === 3 || i === 4) {
                    ctr = 2;
                }
                else if(i === 5 || i === 6) {
                    ctr = 3;
                }
                if(i === 2 || i === 4 || i === 6) {
                    lineClass = "dashedStrokeStyle"; //No I18N
                }
                innerHTML = '<div><hr class="'+lineClass +hrClass+ctr+'" style="width:65px"></div>';
            }
            dataSource.push({
                'label' : label[i],
                'innerHTML' : innerHTML, //No I18N
                'value' : i //No I18N
            });
        }
        return dataSource;
    };
    ZDBLazyLoadUtil.loadCssOnly("CSSLIST_ZOHOCOMPONENTS", "APPENDTODOC"); // No I18N
};
