//$Id$
var ZRTimelineFilter = new function()
{
  this.hideDateString = function(el,event)
  {
      var component = DOMUtils.getSelfOrParentWithAttrValue(el, "elname","timeLineMenuEl"); //NO I18N
      var view = ZDBClientUI.getViewObj(el,"view");
      el.component = component;
      component.drBtnSet = false;
      ZDBUtil.setNamedChildEls(component,component,"drBtn");//NO I18N
      component.tlApplyBtn.removeAttribute("disabled");
      component.tlApplyBtn.className = "glossyButton";
      ZAVMFilterComp.initCalender(el);
      if(el.getAttribute("inputVal") != "From" && el.getAttribute("inputVal") != "To" )
      {
          return;
      }
      if(el.getAttribute("tipShown") == "true")
      {
        el.value="";
        el.setAttribute("inputVal","");
        el.setAttribute("tipShown","false");
      }
  }
  
  this.showDateString = function(el,event)
  {
    if((el.value == "" ) && (el.getAttribute("tipShown") == "false"))
    {
        var dateType = el.getAttribute("elname");
        el.value= (dateType == "fromValue")?ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.from") : ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.to"); //NO I18N

        var inputVal = (dateType == "fromValue")?"From":"To"; //NO I18N
        el.setAttribute("inputVal",inputVal);
        el.setAttribute("tipShown","true");
        var component = DOMUtils.getSelfOrParentWithAttrValue(el, "elname","timeLineMenuEl"); //NO I18N
        component.elnameSet = false;
        ZDBUtil.setNamedChildEls(component,component);//NO I18N
        if(component.fromValue.getAttribute("inputVal")!="From" && component.toValue.getAttribute("inputVal")!="To")
        {
          component.tlApplyBtn.setAttribute("disabled","true");
          component.tlApplyBtn.className = "glossyButton alpha";
        }
    }
  }
  
  this.showCalendar = function(el, event)
  {
	ZAVMFilterComp.initCalender(el, null, null, true);
  }

  this.hideCalendar=function(el, event)
  {
  	if((el.value == "" ))
    {
        var dateType = el.getAttribute("elname");
        el.value= (dateType == "fromValue")?ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.from") : ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.to"); //NO I18N
    }
  }
  
  this.validateNRefresh = function(el,event)
  {
    
    var view = ZDBClientUI.getViewObj(el,"view");
    var component = view.timelineComp;
    var highlightReq = false;
    ZDBUtil.setNamedChildEls(component.timeLineMenuEl,component);
    if(el.getAttribute("crType") == "dateRange")
    {
    	if(ZAVMFilterComp.isValidDateRange(component,component.fromValue,component.toValue))
    	{
    		ZAVMFilterComp.setSelectedRange(component,component.fromValue,component.toValue);
        	ZAVMFilter.refreshView(component);
        	ZRTimelineFilter.closeTimeLineMenuEl(event, true);
        	highlightReq = true;
    	}
    }
    else
    {
    	component.compElContainer.setAttribute("selVal",el.getAttribute("criteria"));
    	component.compElContainer.setAttribute("dispSelVal",el.getAttribute("dispcriteria"));
    	component.displayAppliedFilter.setAttribute("value",el.getAttribute("dispcriteria"));
    	component.displayAppliedFilter.innerHTML = el.getAttribute("dispcriteria");
    	component.fromValue.value = "";
    	component.toValue.value = "";
    	component.dataRangeHolder.style.height = "0px";
    	component.dataRangeHolder.setAttribute("dateRangeShown","false");
    	ZAVMFilter.refreshView(component);
    	ZRTimelineFilter.closeTimeLineMenuEl(event, true);
    	highlightReq = true;
    }
    if(highlightReq)
    {
    	ZAVMFilter.showHideResetBtn(view, false);
    	component.setAttribute("canReset","true");
    	jQuery(component).addClass("compFilterApplied");
    }
  }
  
  this.getAllTimelineFilterCr = function(dashView, viewCtx)
  {
    var xmlBuf = new ZDBStrBuf();
    var isTimeLineEnabled = dashView.timeLineCompEnabled;
    if(!isTimeLineEnabled)
    {
      return "";
    }
    var comp = dashView.timelineComp;
    ZDBUtil.setNamedChildEls(comp,comp,"elname");//NO I18N
    var func = comp.getAttribute("valFunc");

    ZRTimelineFilter.checkNApplyDefaultTimelineCr(comp, dashView);
    var cr = ZAVMFilter[func](comp,dashView);
    var lbl = comp.getAttribute("label");
    if(cr != null)
    {
        var dcr = comp.compElContainer.getAttribute("dispselval");
        if(viewCtx && viewCtx.dashChildDiv &&  viewCtx.dashChildDiv.getAttribute("tlColumnMapping") && viewCtx.dashChildDiv.getAttribute("tlColumnMapping") != "null")
        {
        	var tlColumnMapping = viewCtx.dashChildDiv.getAttribute("tlColumnMapping");
        	xmlBuf.sTag("zrtlv").attr("cr", cr)//NO I18N
            .attr("dcr", dcr)//Currently generating dcr as cr itself.//NO I18N
            .attr("aot","ABSDATECATEGORICAL")//NO I18N
            .attr("op","ABS")//NO I18N
            .attr("st",107)//NO I18N
            .attr("lbl",lbl)//NO I18N
            .attr("tlcolmapid",tlColumnMapping)//NO I18N
            .eTag();//NO I18N
        }
        else
        {
        	xmlBuf.sTag("zrtlv").attr("cr", cr)//NO I18N
            .attr("dcr", dcr)//Currently generating dcr as cr itself.//NO I18N
            .attr("aot","ABSDATECATEGORICAL")//NO I18N
            .attr("op","ABS")//NO I18N
            .attr("st",107)//NO I18N
            .attr("lbl",lbl)//NO I18N
            .eTag();//NO I18N
        }
    }
    return xmlBuf.toString();
  }
  
  this.checkNApplyDefaultTimelineCr = function(comp, dashView)
  {
	  var selVal = comp.compElContainer.getAttribute("selval");
	  var isDefValPresent = (!comp.getAttribute("value") || comp.getAttribute("value") == "") ? false : true; 
	  if(selVal != null || !isDefValPresent)
	  {
		  return;
	  }
	  ZRTimelineFilter.resetToDefaultValues(comp, dashView);
  }
  
  this.getDefTlCrit = function(func,comp,dashView)
  {
    ZDBUtil.setNamedChildEls(comp,comp);//NO I18N    
    ZAVMFilterComp.setSelectedRange(comp,comp.fromValue,comp.toValue);   
    return ZAVMFilter[func](comp,dashView);
  }
  
  this.updateRange = function(el,event)
  {
	  var view = ZDBDialogUtil.currentViewObj;
	  var dlgBody = DOMUtils.getParentWithAttrValue(el, "elname","dlgBodyDIV");//NO I18N
	  ZDBUtil.setNamedChildEls(dlgBody,dlgBody);
	  var optionList =dlgBody.optionList.value;
	  var displayPrefix = (dlgBody.optionList.value=="R L_")?"Last":"Next";//NO I18N
	  var rangeValueEL = dlgBody.rangeValue;
	  var rangeValue = rangeValueEL.value.trim();
	  var filterEl = DOMUtils.getFirstMatchingChild(view.tlDlgFilterNav,"div","filterEl","true");//NO I18N
	  ZDBUtil.setNamedChildEls(filterEl,filterEl,"scrollel");
	  ZDBUtil.setNamedChildEls(filterEl,filterEl,"elname");
      if((ZDBValidator.isDecimal(rangeValue,false)))
      {
          if(!ZDBValidator.isNumber(rangeValue,false))
          {
              showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidNumber"), dlgBody.rangeValue);
              return;
          }
          if(rangeValue>99999)
          {
        	  showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.maxFiveDigitRange")+'"', dlgBody.rangeValue);
        	  dlgBody.rangeValue.select();
              return;
          }
          var ctype = rangeValueEL.getAttribute("criteria");
          //var displayvalue = "zrpt.common.analysis.filter.custommsg.js."+displayPrefix+"_"+rangeValueEL.getAttribute("displayRangeCriteria"); //NO I18N
          //displayfiltervalue  = ZDBI18NMap.f(displayvalue,rangeValue);
          displayfiltervalue  = displayPrefix + " " + rangeValue + " " + ctype;
          var filtervalue = optionList+rangeValue+"_"+ctype.toUpperCase();
          var relJSONResp = view.relJSONResp;
          var curRelTab = view.curRelTab;
          var jsonToUpdate = relJSONResp[curRelTab.getAttribute("subType")];
          var newRangeVals = view.newRangeVals ? view.newRangeVals : "";
          if(jsonToUpdate.indexOf(filtervalue)>=0)
          {
        	  showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.duplicateInput")+'"', dlgBody.rangeValue);
        	  return;
          }
          newRangeVals = newRangeVals + filtervalue + ",";
          view.newRangeVals = newRangeVals;
          var tmpCr = view.tmpCriteria ? view.tmpCriteria : "";
          var tmpDispCr = view.tmpDisplayCriteria ? view.tmpDisplayCriteria : "";
          view.tmpCriteria =  tmpCr +  filtervalue + ",";
          view.tmpDisplayCriteria = tmpDispCr + displayfiltervalue + ",";
          jsonToUpdate.push(filtervalue);
          jsonToUpdate.push(displayfiltervalue);
          ZRTimelineFilter.constructFilterList(curRelTab, event, view);
          ZDBScroller.checkNSetButtonStyle(filterEl);
          ZDBDialogUtil.closeDialog();
      }
      else
      {
    	  showCustomMessage('"'+ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidInput")+'"', dlgBody.rangeValue);
    	  return;
      }
  }
  
  this.enableTimeLineComp = function(el, toDropInPosition)
  {
    var view = ZDBClientUI.getViewObj(el, "view");
    var hoverTLEl = DOMUtils.getParentWithAttrValue(el,"elname","hoverTLEl");//NO I18N
    if(ZDBDashboardAPI.viewsInDashboard(view).length == 0)
    {
        return;
    }
    view.timeLineCompLabel = view.timeLineCompName ? view.timeLineCompName : ZDBI18NMap.g("zrpt.dashboard.js.tldeflabel");
    view.colAssIdx = view.colAssIdx ? view.colAssIdx : "2";
    view.Criteria = view.Criteria ? view.Criteria : "R TODAY,R TWEEK,R TMONTH,R TQUARTER,R TYEAR,";//NO I18N
    view.DisplayCriteria = view.DisplayCriteria ? view.DisplayCriteria : ZDBI18NMap.f("zrpt.dashboard.js.defdispcrit") + ",";
    view.defTimelineValue = (view.defTimelineValue) ? view.defTimelineValue : "";
    if(!view.timeLineCompEnabled)
    {
      view.timeLineCompEnabled = true;
      ZRTimelineFilter.dropTimeLineComp(view, toDropInPosition);
      ZAVMFilterEdit.orderVMFiltersList(view);
      jQuery(hoverTLEl).removeClass("ZDBDNDFieldMainBG");
      el.className = "ZDBDNDFieldChecked";
    }
    else
    {
      view.timeLineCompEnabled = false;
      ZRTimelineFilter.removeTimeLineComp(view);
      view.setModified();
      jQuery(hoverTLEl).addClass("ZDBDNDFieldMainBG");
      el.className = "ZDBDNDFieldUncheck";
    }
  }
  
  this.dropTimeLineComp = function(view, toDropInPosition)
  {
	  var dummyComp = ZAVMFilterEdit.getCompEl();
	  var droppedArea = view.VMFilterDropArea;
	  var timeLineLabel = view.timeLineCompLabel;
	  var params = ZDBAnalysisConfig.ZRTLPARAMS;
	  droppedArea.appendChild(dummyComp);
      dummyComp.style.display = "";
      dummyComp.style.visibility = "hidden";
      view.timelineComp = dummyComp;
      dummyComp.setAttribute(params[0],timeLineLabel);
      dummyComp.setAttribute(params[1],view.defTimelineValue);
      dummyComp.setAttribute(params[2],view.Criteria);
      dummyComp.setAttribute(params[3],view.DisplayCriteria);
      dummyComp.setAttribute(params[4],"");
      dummyComp.setAttribute(params[5],"");
      dummyComp.setAttribute(params[6],view.colAssIdx);
      dummyComp.setAttribute(params[7],"1");
      dummyComp.setAttribute("ISALLVAL","true");
      ZDBUtil.setNamedChildEls(dummyComp, dummyComp);
      var inputComp = $("ZAVMFilterType_7").cloneNode(true);
      inputComp.id = "";
      dummyComp.compLabel.innerHTML = timeLineLabel;
      dummyComp.compLabel.setAttribute("value", timeLineLabel);
      dummyComp.compElContainer.appendChild(inputComp);
      dummyComp.elnameSet = false;
      ZDBUtil.setNamedChildEls(dummyComp, dummyComp);
      if(!toDropInPosition)
      {
    	  jQuery(droppedArea).prepend(ZDBGlobal.getDropSpace());
      }
      ZDBAnalysisView.addFieldInDropArea(view.VMFilterDropArea,dummyComp);
      dummyComp.style.display = "";
      dummyComp.style.visibility = "visible";
      dummyComp.setAttribute("isTimeLineComp","true");
      dummyComp.setAttribute("addOnType","timelinecomp");
      dummyComp.setAttribute("valFunc","getSelectVal");
      dummyComp.setAttribute("MINDATE",ZDBGlobal.TIMELINE_MINRANGE);
      dummyComp.setAttribute("MAXDATE",ZDBGlobal.TIMELINE_MAXRANGE);
      ZAVMFilter.placeVMFilterDefinition(view);
      view.VMFilterResetBtn.setAttribute("class","vmfResetButton");
      dummyComp.style.cursor = "default";
      dummyComp.onmouseover = ZAVMFilter.showCompOptions;
      dummyComp.onmouseout = ZAVMFilter.hideCompOptions;
      view.setModified();
  }
  
  this.closeAutoListForTimelineDlg = function()
  {
	  ZDBAutoFillContacts.hidepopup('dropdown');//NO I18N
	  return true;
  }
  
  this.showTimeLineCompEditDlg = function(el)
  {
	if(!ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare","APPENDTODOC",ZRTimelineFilter.showTimeLineCompEditDlg,[el]))//NO I18N
    {
        return;
    }
    var addOnType = el.getAttribute("addOnType");
    var dlgBody = ZAVMFilterEdit.getDlgId(1,addOnType);
    ZRTimelineFilter.resetTimeLineDlg(dlgBody);
    var view = ZDBClientUI.getViewObj(el, "view");
    var isDashBoard = view.type == "Dashboard"; // NO I18N
    var dlgTitle = dlgBody.getAttribute("dlgTitle");
    var desc = ZDBI18NMap.g("zrpt.dashboard.js.timelinehelplink");
    view.timelineComp.style.cursor = "default";
    ZDBDialogUtil.showDialog(dlgBody,{MODAL:true,ADDFRAME:true,SHADOW:false,VIEW:view,TITLE:dlgTitle,HELPDOC:desc,DONTREMOVE:true,COMPEL:el,ONCLOSE:ZRTimelineFilter.closeAutoListForTimelineDlg});
    var timeLineCompNameLabel = DOMUtils.getFirstMatchingChild(dlgBody,"*","elname","timeLineCompNameLabel");
    timeLineCompNameLabel.value = (view.timeLineCompName) ? view.timeLineCompName : view.timeLineCompLabel;
    view.timeLineCompNameLabel = timeLineCompNameLabel;
    view.tmpCriteria = view.Criteria ? view.Criteria : el.getAttribute("selVals");
    view.tmpDisplayCriteria = view.DisplayCriteria ? view.DisplayCriteria : el.getAttribute("display_selvals");
    view.tmpColAssIdx = view.colAssIdx ? view.colAssIdx : el.getAttribute("col_assosidx");
    view.tmpColNamesToMatch = view.colNamesToMatch ? view.colNamesToMatch : (el.getAttribute("pref_cols") == "" || (!el.getAttribute("pref_cols"))) ? "" : JSON.parse(el.getAttribute("pref_cols"));
    view.tmpDefTimelineValue = (view.defTimelineValue) ? view.defTimelineValue : el.getAttribute("value");
    ZDBDashboardUF.constructDashUFFields(view);
    if(view.relJSONResp)
    {
      var ZDBSubOprnDateRel = $("ZDBSubOprnDateRel");
        var commonTab = DOMUtils.getFirstMatchingChild(ZDBSubOprnDateRel,"*","subtype","100");
        var selectTab = view.curRelTab ? view.curRelTab : commonTab;
        ZRTimelineFilter.constructFilterList(selectTab, null, view, true);
        ZRTimelineFilter.updateDateColsForThisView(view);
        ZRTimelineFilter.setColAssIdx(null, view,  true);
        ZRTimelineFilter.setColNamesToMatch(view);
        view.timeLineCompNameLabel.focus();
        return;
    }
      AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZAGetTimeLineFilterVals.ma?OBJID="+view.objId+"&ZDBACTION="+"ZAGETTIMELINEFILTERVALS",
    	  METHOD: "GET", //No I18N
          ONSUCCESSFUNC:ZRTimelineFilter.updateNavPanel,
          VIEW:view});
  }
  
  this.resetTimeLineDlg = function(dlgBody)
  {
	  var advTLSettings = jQuery(dlgBody).find('[advOptShown]');
	  advTLSettings[0].setAttribute("advOptShown","false");
	  var advOptContainer = advTLSettings.find('[elname="advOptContainer"]');
	  advOptContainer[0].style.height = "0px";
	  var filterEl = jQuery(dlgBody).find('[filterEl="true"]');
	  filterEl[0].className = "closeEditorMode";
	  var itemSelectedContent = filterEl.find('[elname="itemSelectedContent"]');
	  itemSelectedContent.innerHTML = "";
  }
  
  this.setColNamesToMatch = function(view)
  {
	  var parEl = $("zdbMatchColNames");
	  var inputEl = DOMUtils.getFirstMatchingChild(parEl, "*", "elname", "colNamesInputEl");//NO I18N
	  ZRTimelineFilter.removeExistingEls(parEl);
	  var colNamesToMatch = view.tmpColNamesToMatch;
	  if(colNamesToMatch == "" || !colNamesToMatch)
	  {
		  EmailBubble.showOrHidePlaceHolder(jQuery(inputEl));
		  return;
	  }
	  for(var i=0; i<colNamesToMatch.length; i++)
	  {
		  EmailBubble.createBubbleFromStrToEl(colNamesToMatch[i], inputEl, view);
	  }
  }
  
  this.removeExistingEls = function(parEl)
  {
	  var els = jQuery(parEl).find("[data-email]");
	  for(var i=0; i<els.length; i++)
	  {
		  els[i].parentNode.removeChild(els[i]);
	  }
  }
  
  this.updateSelValInItemSelected = function(cr, dispCr, valTemplate, filterNav, view)
  {
	  var criteria = cr.split(",");
	  var dispCriteria = dispCr.split(",");
	  var selectedItemHolder, customRangeValue;
	  filterNav.selItemHolder.innerHTML = "";
	  for(var i=0; i<criteria.length-1; i++)
	  {
		 var valEl = valTemplate.cloneNode(true);
		 valEl.setAttribute("sel","yes")
		 valEl.setAttribute("value",dispCriteria[i]);
		 valEl.setAttribute("criteria",criteria[i]);
		 valEl.setAttribute("dispval",dispCriteria[i]);
		 valEl.setAttribute("displayfiltervalue",dispCriteria[i]);
		 valEl.setAttribute("filtervalue",criteria[i]);
		 valEl.style.display="block";//NO I18N
		 valEl.className="filterFieldRemoveSel font12 selElsList";//NO I18N
		 valEl.setAttribute("cloned","true");//NO I18N
		 valEl.style.height = "";
		 valEl.style.paddingBottom = "";
		 ZRTimelineFilter.constructElAndSetAttrForListSelItems(valEl);
		 filterNav.selItemHolder.appendChild(valEl);
	  }
	  customRangeValue = filterNav.customRangeValue.cloneNode(true);
	  filterNav.selItemHolder.appendChild(customRangeValue);
	  customRangeValue.style.display = "";
	  ZRTimelineFilter.highLightDefaultVal(filterNav.selItemHolder, view);
  }
  
  this.constructElAndSetAttrForListSelItems = function(valEl)
  {
      var valNameEl = document.createElement("span");
      valNameEl.setAttribute("elname","valNameEl");
      valNameEl.innerHTML = ZDBEscapeUtil.encodeForHtml(valEl.getAttribute("value"));
      valEl.valNameEl = valNameEl;
      var defaultValIcon = document.createElement("span");
      defaultValIcon.style.float = "right";//NO I18N
      defaultValIcon.style.marginRight = "15px";//NO I18N
      defaultValIcon.style.cursor="pointer";
      
      jQuery(defaultValIcon).attr({"elname" : "defaultValIcon", "class" : "tIconbg defaultVal", "onmousemove" : "ZDBToolTip.show(this,event)", "onmouseout" : "ZDBToolTip.hide(this,event)" ,"onclick": "ZRTimelineFilter.makeAsDefaultValueForTL(this,event)","tip" : ZDBI18NMap.f("zrpt.dashboard.js.makedefault")});//NO I18N
      jQuery(valEl).attr({"onmouseover" : "this.className = 'filterFieldRemoveSel font12 selElsList highLightListVal'", "onmouseout" : "this.className = 'filterFieldRemoveSel font12 selElsList'"});//NO I18N
      jQuery(valNameEl).attr({"style" : "float:left; display:inline-block; width:calc(100% - 34px); cursor:default;", "onclick" : "ZDBUtil.stopEventBubble(event);"});//NO I18N
      valEl.appendChild(valNameEl);
      valEl.appendChild(defaultValIcon);
  }
  
  this.resetTimeLineComp = function(el, event, resetToAllVals)
  {
	var view = ZDBClientUI.getViewObj(el, "view"); 
	var comp = view.timelineComp;
	ZDBUtil.setNamedChildEls(comp,comp);
    var compElContainer = comp.compElContainer;
    if(!comp.getAttribute("value") || (comp.getAttribute("value") == "") || resetToAllVals)
    {
	    compElContainer.setAttribute("selVal","");
	    compElContainer.setAttribute("dispSelVal","");
	    comp.fromValue.value = "";
	    comp.toValue.value = "";
	    comp.displayAppliedFilter.innerHTML = ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
	    comp.displayAppliedFilter.setAttribute("value",ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select"));
    }
    else
    {
    	ZRTimelineFilter.resetToDefaultValues(comp, view, event);
    }
    if(event)
    {
    	ZRTimelineFilter.closeTimeLineMenuEl(event, true);
    	ZAVMFilter.refreshView(comp);
    }
  }
  
 this.resetToDefaultValues = function(component, view, event)
 {
	var defVal = component.getAttribute("value");
	var selVals = component.getAttribute("selVals").split(",");
	var dispSelVals = component.getAttribute("display_selVals").split(",");
	var indexOf = selVals.indexOf(defVal);
	var defValType = (indexOf >= 0) ? "relVals" : "dateRange";//NO I18N
	component.elnameSet = false;
    ZDBUtil.setNamedChildEls(component.timeLineMenuEl,component);
    if(defValType == "dateRange")
    {
    	var indexOfMinus = defVal.indexOf("-");
    	var fromVal = defVal.substring(2,indexOfMinus);
    	var toVal = defVal.substring(indexOfMinus+1, defVal.length - 1);
    	component.fromValue.value = fromVal;
    	component.toValue.value = toVal;
    	if(ZAVMFilterComp.isValidDateRange(component,component.fromValue,component.toValue))
    	{
    		ZAVMFilterComp.setSelectedRange(component,component.fromValue,component.toValue);
    		if(event)
        	{
    			ZRTimelineFilter.closeTimeLineMenuEl(event, true);
        	}
    	}
    }
    else
    {
    	component.compElContainer.setAttribute("selVal",selVals[indexOf]);
    	component.compElContainer.setAttribute("dispSelVal",dispSelVals[indexOf]);
    	component.displayAppliedFilter.setAttribute("value",dispSelVals[indexOf]);
    	component.displayAppliedFilter.innerHTML = dispSelVals[indexOf];
    	component.fromValue.value = "";
    	component.toValue.value = "";
    	component.dataRangeHolder.style.height = "0px";
    	component.dataRangeHolder.setAttribute("dateRangeShown","false");
    	if(event)
    	{
    		ZRTimelineFilter.closeTimeLineMenuEl(event, true);
    	}
    }
    component.setAttribute("canReset","false");
    jQuery(component).removeClass("compFilterApplied");
 }
 
 this.removeDefaultValues = function(component, view)
 {
    var compElContainer = component.compElContainer;
	compElContainer.setAttribute("selVal","");
	compElContainer.setAttribute("dispSelVal","");
	component.fromValue.value = "";
	component.toValue.value = "";
	component.displayAppliedFilter.innerHTML = ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
	component.displayAppliedFilter.setAttribute("value",ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select"));
 }
  
  this.removeTimeLineComp = function(view)
  {
    var timelineComp = view.timelineComp;
    view.timeLineCompEnabled = false;
    timelineComp.style.cursor = "default";
    timelineComp.parentNode.removeChild(timelineComp);
    ZAVMFilterEdit.orderVMFiltersList(view);
    ZAVMFilter.placeVMFilterDefinition(view);
    view.setModified();
  }
  
  this.updateNavPanel = function(response, requestOptions)
  {
    var view = requestOptions["VIEW"];
    var jsonResp = JSON.parse(response.responseText);
    var ZDBSubOprnDateRel = $("ZDBSubOprnDateRel");
    var commonTab = DOMUtils.getFirstMatchingChild(ZDBSubOprnDateRel,"*","defTab","true");
    view.relJSONResp = jsonResp;
    var filterEl = DOMUtils.getParentWithAttrValue(ZDBSubOprnDateRel,"filterel","true");//NO I18N
    var itemList = DOMUtils.getFirstMatchingChild(filterEl,"*","elname","itemList");
    var tdTemplate = ZDBAnalysisCaching.tdTemplate ? ZDBAnalysisCaching.tdTemplate : DOMUtils.getFirstMatchingChild(itemList,"*","filterTDTemplate","true").cloneNode(true);
    var valTemplate = ZDBAnalysisCaching.valTemplate ? ZDBAnalysisCaching.valTemplate : DOMUtils.getFirstMatchingChild(itemList,"*","filterValTemplate","true").cloneNode(true);
    var addNewRangeTemplate = ZDBAnalysisCaching.addNewRangeTemplate ? ZDBAnalysisCaching.addNewRangeTemplate : DOMUtils.getFirstMatchingChild(itemList,"*","elname","addNewRangeDIV").cloneNode(true);
    tdTemplate.style.display = "";
    valTemplate.style.display = "";
    addNewRangeTemplate.style.display = "";
    ZDBAnalysisCaching.tdTemplate = tdTemplate;
    ZDBAnalysisCaching.valTemplate = valTemplate;
    ZDBAnalysisCaching.addNewRangeTemplate = addNewRangeTemplate;
    ZRTimelineFilter.constructFilterList(commonTab, null, view, true);
    ZRTimelineFilter.updateDateColsForThisView(view);
    ZRTimelineFilter.setColAssIdx(null, view,  true);
    ZRTimelineFilter.setColNamesToMatch(view);
    view.timeLineCompNameLabel.focus();
  }
  
  this.validateAndApplyTimeLineSetting = function(el, event)
  {
	  var colNamesToMatchTextArea = $("zdbMatchColNames");
	  var invalidCols = jQuery(colNamesToMatchTextArea).find('[neglectbubble="true"]');
	  if(invalidCols.length >0)
	  {
		  ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.dashboard.js.invaliddatecolumnsproceedalert"),"ZDBYESNO",{ONCLICK:ZRTimelineFilter.applyTimelineSettings,ELEMENT:el,EVENT:event});   //No I18N
  
	  }
	  else
	  {
		  ZRTimelineFilter.addTimeLineSettings(el,event);
	  }
  }
  
  this.applyTimelineSettings = function(clickType, requestOptions)
  {
	  var el = requestOptions["ELEMENT"];
	  var event = requestOptions["EVENT"];
	  if(clickType == "NO")
      {
        return;
      }
	  ZRTimelineFilter.addTimeLineSettings(el,event);
  }
  
  this.addTimeLineSettings = function(el, event)
  {
    var view = ZDBClientUI.getViewObj(el, "view");
    var ZDBTimeLineCompDlg = $("ZDBTimeLineCompDlg");
    var timeLineCompNameLable = DOMUtils.getFirstMatchingChild(ZDBTimeLineCompDlg,"*","elname","timeLineCompNameLabel");
    var timeLineLabel = timeLineCompNameLable.value;
    if(timeLineLabel.trim() == "")
    {
    	showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.emptyLabel"),timeLineCompNameLable);
    	timeLineCompNameLable.select();
    	return;
    }
    if(timeLineLabel.length>100)
    {
    	showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.exeededLabel"),timeLineCompNameLable);
        $("customAlertMessage").style.width = timeLineCompNameLable.parentNode.offsetWidth/2+"px";
        $("_CUSTOMALERTFRAME").style.width = timeLineCompNameLable.parentNode.offsetWidth/2+"px";
  	  	timeLineCompNameLable.select();
  	  	return;
    }
    if(!ZRTimelineFilter.validateTimelineDefValue(view))
    {
    	return;
    }
    view.timeLineCompName = ZDBEscapeUtil.encodeForHtml(timeLineLabel);
    view.Criteria = view.tmpCriteria;
    view.DisplayCriteria = view.tmpDisplayCriteria;
    view.colAssIdx = view.tmpColAssIdx;
    view.defTimelineValue = view.tmpDefTimelineValue;
    view.timelineComp.compLabel.innerHTML = view.timeLineCompName;
    view.timelineComp.compLabel.setAttribute("value", view.timeLineCompName);
    var params = ZDBAnalysisConfig.ZRTLPARAMS;
    var newRangeVals = view.newRangeVals ? view.newRangeVals : "";
    var colNamesToMatch = EmailBubble.getEmailsAsCSV("zdbMatchColNames");//NO I18N
    view.colNamesToMatch = colNamesToMatch.split(",");
    view.timelineComp.setAttribute(params[0],view.timeLineCompName);
    view.timelineComp.setAttribute(params[1],view.defTimelineValue);
    view.timelineComp.setAttribute(params[2],view.Criteria);
    view.timelineComp.setAttribute(params[3],view.DisplayCriteria);
    view.timelineComp.setAttribute(params[4],newRangeVals);
    view.timelineComp.setAttribute(params[5],JSON.stringify(view.colNamesToMatch));
    view.timelineComp.setAttribute(params[6],view.colAssIdx);
    if(view.defTimelineValue != "")
    {
    	ZRTimelineFilter.resetToDefaultValues(view.timelineComp, view);
    }
    else
    {
    	ZRTimelineFilter.removeDefaultValues(view.timelineComp,view);
    }
    ZDBDialogUtil.closeDialog(el,event);
    view.setModified();
  }
  
  this.validateTimelineDefValue = function(view)
  {
	  var itemSelectedContent = $("itemSelectedContent");
	  var isValid = true;
	  var indexOf = view.tmpDefTimelineValue.indexOf("-");
	  if(indexOf < 0)
	  {
		  return true;
	  }
	  var fromValue = jQuery(itemSelectedContent).find("[elname='fromValue']")[0];
	  var toValue = jQuery(itemSelectedContent).find("[elname='toValue']")[0];
	  if(fromValue.value.trim() == "" || fromValue.value.trim() == "From")
	  {
		  showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.selectfromvalue"), fromValue); // need I18N
          return false;
	  }
	  else if(toValue.value.trim() == "" || toValue.value.trim() == "To")
	  {
		  showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.selecttovalue"), toValue); // need I18N
          return false;
	  }
	  if((new Date(fromValue.value) > new Date(toValue.value)))
      {
          showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.FromDtLarge"), fromValue); // need I18N
          return false;
      }
	  view.tmpDefTimelineValue = "B " + fromValue.value + "-" + toValue.value + ",";//NO I18N
	  return true;
  }
  
  this.showHideAdvancedOptions = function(el)
  {
	  var advTLSetEl = DOMUtils.getSelfOrParentWithAttr(el, "advOptShown");//NO I18N
	  var showAdvOption = advTLSetEl.getAttribute("advOptShown") == "false" ? true : false;
	  var advOptContainer = DOMUtils.getFirstMatchingChild(advTLSetEl,"*","elname","advOptContainer");
	  var toggleSwitch = DOMUtils.getFirstMatchingChild(el,"*","elname","toggleSwitch");
	  var colAssIdxContainer = DOMUtils.getFirstMatchingChild(advOptContainer,"*","elname","colAssIdxContainer");
	  var matchColNames =  DOMUtils.getFirstMatchingChild(advOptContainer,"*","elname","matchColNames");
	  if(showAdvOption)
	  {
		  advOptContainer.style.height = colAssIdxContainer.offsetHeight + matchColNames.offsetHeight + "px";
		  advTLSetEl.setAttribute("advOptShown", "true");
		  toggleSwitch.className = "zdbDownArrowFC";
	  }
	  else
	  {
		  advOptContainer.style.height = "0px";
		  advTLSetEl.setAttribute("advOptShown", "false");
		  toggleSwitch.className = "zdbRightArrowFC";
	  }
  }
  
  this.changeColAssIdx = function(inputEl, event)
  {
	  var val = inputEl.value;
	  if(val == "")
	  {
		  return;
	  }
	  var view = ZDBClientUI.getViewObj(inputEl,"view");
	  var colName = view.dispNameToColNameMap[val];
	  if(!colName)
	  {
	  	 return;
	  }
	  var tblColJsonData = ZDBAnalysisCaching.tblColInfo.data;
	  var dashViews = ZDBDashboardAPI.viewsInDashboard(view);
	  var colAssIdxId = 0;
	  for(var i=0; i<dashViews.length; i++)
	  {
		  var dashEl = dashViews[i];
		  var tableObjId = (dashEl.getAttribute("parentViewId") == "null") ? dashEl.getAttribute("objId") : dashEl.getAttribute("parentViewId");//NO I18N
		  var relModelId = ZDBClientUtil.getJsonRelModelIdForObjId(tableObjId);
		  var json = tblColJsonData[relModelId]["colDet"];
		  if(ZRTimelineFilter.checkForInvColsMatch(dashEl, tableObjId, json, colName))
		  {
			  colAssIdxId = 0;
			  continue;
		  }
		  else if(ZRTimelineFilter.checkForParentTableMatch(dashEl, tableObjId, json, colName))
		  {
			  colAssIdxId = 1;
			  continue;
		  }
		  else if(ZRTimelineFilter.checkForRelTableMatch(dashEl, tableObjId, json, colName))
		  {
			  colAssIdxId = 2;
			  break;
		  }
	  }
	  if(Number(view.tmpColAssIdx) < colAssIdxId)
	  {
		  var advTLSettings = $("advTLSettings");
		  var idxEl = DOMUtils.getFirstMatchingChild(advTLSettings, "*", "colassidx", colAssIdxId.toString());
		  ZRTimelineFilter.setColAssIdx(idxEl,view);
	  }
  }
  
  this.checkForInvColsMatch = function(dashEl, tableObjId, json, val)
  {
	  var currentList = (dashEl.view && dashEl.view.currentList) ? dashEl.view.currentList : (dashEl.ctx.view && dashEl.ctx.view.currentList) ? dashEl.ctx.view.currentList : null;
	  if(dashEl.getAttribute("viewType") == "REPORT")
	  {
		  return false;
	  }
	  if(!currentList)
	  {
		  var colObj = json[tableObjId]
		  for(var colId in colObj)
		  {
			  var colDispName = colObj[colId]["DISP_NAME"];
			  if(val.toLowerCase() == colDispName.toLowerCase())
			  {
				  return true;
			  }
		  }
	  }
	  else
	  {
		  for(var i=0; i<currentList.length; i++)
		  {
			  var invCol = currentList[i];
			  var colId = invCol.getAttribute("column_id");
			  var parentTableId = invCol.getAttribute("parent_obj_id");
			  var colDispName = json[parentTableId][colId]["DISP_NAME"];
			  if(val.toLowerCase() == colDispName.toLowerCase())
			  {
				  return true;
			  }
		  }
	  }
	  return false;
  }
  
  this.checkForParentTableMatch = function(dashEl, tableObjId, json, val)
  {
	  if(dashEl.getAttribute("parentViewId") != null)
	  {
		  var colObj = json[tableObjId];
		  for(var colId in colObj)
		  {
			  var colDispName = colObj[colId]["DISP_NAME"];
			  if(val.toLowerCase() == colDispName.toLowerCase())
			  {
				  return true;
			  }
		  }
	  }
	  return false;
  }
  
  this.checkForRelTableMatch = function(dashEl, tableObjId, json, val)
  {
	  var currentList;	
	  for(var tableId in json)
	  {
		  var colObj = json[tableId];
		  for(var colId in colObj)
		  {
			  var colDispName = colObj[colId]["DISP_NAME"];
			  if(val.toLowerCase() == colDispName.toLowerCase())
			  {
				  return true;
			  }
		  }
	  }
	  return false;
  }
  
  this.setColAssIdx = function(idxEl, view, dontModIdx)
  {
	  var advTLSettings = $("advTLSettings");
	  var tmpColAssIdx;
	  if(!idxEl)
	  {
	      var colAssIdx = view.tmpColAssIdx;
	      if(!colAssIdx)
	      {
	    	  colAssIdx = "2";
	    	  dontModIdx = true;
	      }
	      idxEl = DOMUtils.getFirstMatchingChild(advTLSettings,"*","colAssIdx",colAssIdx);
	  }
	  if(idxEl)
	  {
		  var idxElVal = Number(idxEl.getAttribute("colAssIdx"));
		  tmpColAssIdx = ((idxEl.getAttribute("checked") == "true") && !dontModIdx) ? (idxElVal-1) : idxElVal;
		  if(!view)
		  {
			  view = ZDBClientUI.getViewObj(idxEl, "view");
		  }
	  }
	  else
	  {
		  tmpColAssIdx = 0;
	  }
	  var colAssIdxEls = jQuery(advTLSettings).find("[type='checkbox']");
	  view.tmpColAssIdx = tmpColAssIdx.toString();
	  for(var i=0; i<colAssIdxEls.length; i++)
	  {
	      var idxVal = Number(colAssIdxEls[i].getAttribute("colAssIdx"));
	      if(idxVal <= tmpColAssIdx)
	      {
	        colAssIdxEls[i].checked = true;
	        colAssIdxEls[i].setAttribute("checked","true");
	        if(idxVal == 0)
	        {
	        	colAssIdxEls[i].disabled = true;
	        }
	      }
	      else
	      {
	        colAssIdxEls[i].checked = false;
	        colAssIdxEls[i].setAttribute("checked","false");
	      }
	  }
  }
  
  this.makeAsDefaultValueForTL = function(el,event)
  {
	  var defValEl = el.parentNode;
	  var view = ZDBClientUI.getViewObj(el, "view");
	  var defaultValIcon = DOMUtils.getFirstMatchingChild(defValEl, "span","elname","defaultValIcon");//NO I18N
	  if(view.tmpDefTimelineValue != "")
	  {
		  ZRTimelineFilter.removeAsDefaultValueForTL(el, event, true);
	  }
	  if(defValEl.getAttribute("elname") == "customRangeValue")
	  {
		  ZDBUtil.setNamedChildEls(defValEl,defValEl);
		  jQuery(defValEl.customDataRangeHolder).addClass("showCustomRangeEl");
		  var curDate = new Date();
		  var fromDate = new Date();
		  fromDate = new Date(fromDate.setDate(fromDate.getDate()-7));
		  var toDate = ZRTimelineFilter.getDateInFromat(curDate);
		  fromDate = ZRTimelineFilter.getDateInFromat(fromDate);
		  defValEl.fromValue.value = fromDate;
		  defValEl.toValue.value = toDate;
		  view.tmpDefTimelineValue = "B " + fromDate + "-" + toDate + ",";//NO I18N
	  }
	  else
	  {
		  view.tmpDefTimelineValue = defValEl.getAttribute("filtervalue");
	  }
	  jQuery(defaultValIcon).addClass("defValSet");
	  defaultValIcon.setAttribute("onclick","ZRTimelineFilter.removeAsDefaultValueForTL(this,event)");
	  defaultValIcon.setAttribute("tip",ZDBI18NMap.f("zrpt.dashboard.js.removedefault"));
	  ZDBUtil.stopEventBubble(event);
  }
  
  this.getDateInFromat = function(fullDate)
  {
	  var monthArr = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];//NO I18N
	  var date = fullDate.getDate();
	  var month = monthArr[fullDate.getMonth()];
	  var year = fullDate.getFullYear();
	  var formattedDateStr = date + " " + month + " " + year;
	  return formattedDateStr;
  }
  
  this.removeAsDefaultValueForTL = function(el,event, dontStopEventBubble)
  {
	  var itemList = el.parentNode.parentNode;
	  var view = ZDBClientUI.getViewObj(el, "view");
	  var prevDefVal = view.tmpDefTimelineValue;
	  var defValEl;
	  if(prevDefVal.indexOf("-")>0)
	  {
		  defValEl = DOMUtils.getFirstMatchingChild(itemList, "div","elname","customRangeValue");//NO I18N  
		  ZDBUtil.setNamedChildEls(defValEl,defValEl);
		  var customDataRangeHolder = defValEl.customDataRangeHolder;
		  jQuery(customDataRangeHolder).removeClass("showCustomRangeEl");
		  defValEl.fromValue.value = "";
		  defValEl.toValue.value = "";
	  }
	  else
	  {
		defValEl = DOMUtils.getFirstMatchingChild(itemList,"div","filtervalue",prevDefVal);//NO I18N
	  }
	  var defaultValIcon = DOMUtils.getFirstMatchingChild(defValEl, "span","elname","defaultValIcon");//NO I18N
	  view.tmpDefTimelineValue = "";
	  jQuery(defaultValIcon).removeClass("defValSet");
	  defaultValIcon.setAttribute("onclick","ZRTimelineFilter.makeAsDefaultValueForTL(this,event)");
	  defaultValIcon.setAttribute("tip",ZDBI18NMap.f("zrpt.dashboard.js.makedefault"));
	  if(!dontStopEventBubble)
	  {
		  ZDBUtil.stopEventBubble(event);
	  }
  }
  
  this.highLightDefaultVal = function(itemHolder, view)
  {
	  var defVal = view.tmpDefTimelineValue;
	  var highLightEl;
	  var indexOf = defVal.indexOf("-");
	  if(defVal == "")
	  {
		  return;
	  }
	  if(indexOf>0)
	  {
		  highLightEl = DOMUtils.getFirstMatchingChild(itemHolder, "div","elname","customRangeValue");//NO I18N
		  ZDBUtil.setNamedChildEls(highLightEl,highLightEl);
		  var customDataRangeHolder = highLightEl.customDataRangeHolder;
		  jQuery(customDataRangeHolder).addClass("showCustomRangeEl");
		  var fromValue = defVal.substring(2,indexOf);
		  var toValue = defVal.substring(indexOf+1,defVal.length-1);
		  highLightEl.fromValue.value = fromValue;
		  highLightEl.toValue.value = toValue;
	  }
	  else
	  {
		  highLightEl = DOMUtils.getFirstMatchingChild(itemHolder, "div","filtervalue",defVal);//NO I18N
	  }
	  var defaultValIcon = DOMUtils.getFirstMatchingChild(highLightEl,"span","elname","defaultValIcon");//NO I18N
	  jQuery(defaultValIcon).addClass("defValSet");
	  defaultValIcon.setAttribute("onclick","ZRTimelineFilter.removeAsDefaultValueForTL(this,event)");
	  defaultValIcon.setAttribute("tip",ZDBI18NMap.f("zrpt.dashboard.js.removedefault"));
  }
  
  this.selectBestTab = function(tabEl, view)
  {
	  var operationTabElHolder = DOMUtils.getParentWithAttrValue(tabEl, "elname","operationTabElHolder");//NO I18N
	  var tabEls = jQuery(operationTabElHolder).find('[subtype]');
	  var cr = (!view.tmpCriteria) ? (!view.Criteria) ? "" : view.Criteria : view.tmpCriteria;
	  if(cr == "")
	  {
		  return tabEl;
	  }
	  var crArr = cr.split(",");
	  for(var i=0; i<tabEls.length;i++)
	  {
		  var breakLoop = false;
		  var tabEl = tabEls[i];
		  var subType = tabEl.getAttribute("subType");
		  var valArr = view.relJSONResp[subType];
		  for(var j=0; j<crArr.length; j++)
		  {
			  if(valArr.indexOf(crArr[j]) >=0)
			  {
				  breakLoop = true;
				  break;
			  }
		  }
		  if(breakLoop)
		  {
			  break;
		  }
	  }
	  return tabEls[i];
  }
  
  this.constructFilterList = function(tabEl, event,  view, selectBestTabEl)
  {
	if(selectBestTabEl)
	{
		tabEl = ZRTimelineFilter.selectBestTab(tabEl, view);
	}
    var prevSelEl = jQuery(tabEl.parentNode).find(".selectedLink");
    if(!view)
    {
      view = ZDBClientUI.getViewObj(tabEl, "view");
    }
    var filterNav = DOMUtils.getParentWithAttrValue(tabEl,"elname","VMFilterNav");//NO I18N
    var filterEl = DOMUtils.getFirstMatchingChild(filterNav, "*","filterEl","true");//NO I18N
    filterEl.elnameSet=false;
    ZDBUtil.setNamedChildEls(filterNav,filterNav);
    var itemList = filterNav.itemList;
    var subType = tabEl.getAttribute("subType");
    var valArr = view.relJSONResp[subType];
    var tdTemplate = ZDBAnalysisCaching.tdTemplate;
    var valTemplate = ZDBAnalysisCaching.valTemplate;
    var addNewRangeTemplate = ZDBAnalysisCaching.addNewRangeTemplate.cloneNode(true);
    var selVals = [];
    view.curRelTab = tabEl;
    view.tlDlgFilterNav = filterNav;
    if(view.tmpCriteria || view.tmpCriteria=="")
    {
      selVals = view.tmpCriteria.split(",");
    }
    else if(view.Criteria || view.Criteria == "")
    {
      selVals = view.Criteria.split(",");
    }
    else
    {
      selVals = [];
    }
    prevSelEl[0].className = "defAnchor deselectedLink";
    tabEl.className = "selectedLink";
    itemList.innerHTML = "";
    var i=1;
    while(i<valArr.length)
    {
      var tdEl = tdTemplate.cloneNode(true);
      for(var j=0; j<4 && i<valArr.length; j++)
      {
        var valEl = valTemplate.cloneNode(true);
        valEl.innerHTML = valArr[i];
        valEl.setAttribute("criteria",valArr[i]);
        valEl.setAttribute("dispval",valArr[i]);
        valEl.setAttribute("displayfiltervalue",valArr[i]);
        valEl.setAttribute("value",valArr[i]);
        valEl.setAttribute("filtervalue",valArr[i-1]);
        tdEl.appendChild(valEl);
        if(selVals.indexOf(valArr[i-1])>=0)
        {
          ZDBAnalysisFilter.changeSelection(valEl,true);
        }
        i=i+2;
      }
      if((j!=4)  && (subType != 100))
      {
        addNewRangeTemplate.setAttribute("subType",subType);
        addNewRangeTemplate.setAttribute("dispType",tabEl.getAttribute("dispType"));
        tdEl.appendChild(addNewRangeTemplate); 
      }
      itemList.appendChild(tdEl);
    }
    if((valArr.length % 8 == 0) && (subType != 100))
    {
      var tdEl = tdTemplate.cloneNode(true);
      addNewRangeTemplate.setAttribute("subType",subType);
      addNewRangeTemplate.setAttribute("dispType",tabEl.getAttribute("dispType"));
      tdEl.appendChild(addNewRangeTemplate);
      itemList.appendChild(tdEl);
    }
    ZRTimelineFilter.updateSelValInItemSelected(view.tmpCriteria, view.tmpDisplayCriteria, valTemplate, filterNav, view);
    ZDBScroller.intializeScroller(filterEl);
    ZDBScroller.checkNSetButtonStyle(filterEl);
    if(event)
    {
    	ZDBUtil.stopEventBubble(event);
    }
  }

  var dispNameToColNameMap;
  var colNameToDispNameMap;
  var toolTipForDispName;
  this.updateDateColsForThisView = function(view)
  {
	  var jsonData = ZDBAnalysisCaching.tblColInfo.data;
	  var objIdArr = ZDBDashboardUF.getViewsWithUniqueParentViewId(view, true);
	  var relModelsIterated = [];
	  objIdArr = objIdArr.split(",");
	  dispNameToColNameMap = new Object();
	  colNameToDispNameMap = new Object();
	  toolTipForDispName = new Object();
	  view.colNameToDispNameMap = colNameToDispNameMap;
	  view.dispNameToColNameMap = dispNameToColNameMap;
	  view.toolTipForDispName = toolTipForDispName;
	  objIdArr.forEach( function(objId){
		   var relModelId = ZDBClientUtil.getJsonRelModelIdForObjId(objId);
		   if(jsonData[relModelId] && (relModelsIterated.indexOf(relModelId)<0))
		   {
			   var tblDetForRelModelId = jsonData[relModelId].colDet;
			   relModelsIterated.push(relModelId);
			   for(var tableKey in tblDetForRelModelId)
			   {
				   var colDetForTbl = tblDetForRelModelId[tableKey];
				   for(var colKey in colDetForTbl)
				   {
					   var isDateCol = (colDetForTbl[colKey]["ADDONTYPE"] == "ABSDATECATEGORICAL") ? true : false;
					   if(isDateCol)
					   {
						   var colName = colDetForTbl[colKey]["DISP_NAME"];
						   var tableName = jsonData[relModelId]["tableDet"][tableKey]["displayName"]
						   var dispName, toolTip;
						   if(colNameToDispNameMap[colName])
						   {
							   dispName = colNameToDispNameMap[colName];
							   toolTip = toolTipForDispName[dispName];
							   delete toolTipForDispName[dispName];
							   delete dispNameToColNameMap[dispName];
							   dispName = dispName + "," + tableName;
							   toolTip = toolTip + "," + tableName;
							   colNameToDispNameMap[colName] = dispName;
							   dispNameToColNameMap[dispName] = colName;
							   toolTipForDispName[dispName] = toolTip;
						   }
						   else
						   {
							   dispName = colName + " " + (ZDBI18NMap.g("zrpt.dashboard.js.intext")).italics().toLowerCase() + " " + tableName;
							   toolTip = colName + " " + ZDBI18NMap.g("zrpt.dashboard.js.intext") + " " + tableName;
							   colNameToDispNameMap[colName] = dispName;
							   dispNameToColNameMap[dispName] = colName;
							   toolTipForDispName[dispName] = toolTip;
						   }
					   }
				   }
			   }
	   	    }
	   });
  }
  
  this.matchSample = function(str)
  {
	 var temp = new Object();
     var temp1 = new Array();
     var temp2 = new Array();
     str = ZDBAutoFillContacts.escapeSpecialChar(str);
     for (var name in dispNameToColNameMap)
     {
        var dispName = name;
        var toolTip = toolTipForDispName[name];
        var index = dispName.toLowerCase().indexOf(str.toLowerCase());
        if (index >= 0 && ZRTimelineFilter.checkForNoDuplication(dispNameToColNameMap[name])){
           temp1[temp1.length] = dispName;
           temp2[temp2.length] = toolTip;
        }
     }
     temp["dispNameArray"] = temp1;
     temp["toolTipArray"] = temp2;
     return temp;
  }
  
  this.checkForNoDuplication = function(colNameToSuggest)
  {
	  var colsMatchedAlready = EmailBubble.getEmailsAsCSV("zdbMatchColNames");//NO I18N
	  colsMatchedAlready = colsMatchedAlready.split(",");
	  for(var i=0; i<colsMatchedAlready.length && colsMatchedAlready[i]!=""; i++)
	  {
		  if(colsMatchedAlready[i] == colNameToSuggest)
		  {
			  return false;
		  }
	  }
	  return true;
  }
  
  this.getColsNamesToMatch = function(elname){
		var parEl = jQuery('#' + elname);
		var bubbleEls = parEl.find(".contact");
		var cols = '';
		var tmp;
		for(var i = 0; i < bubbleEls.length; i++){
			tmp = bubbleEls.eq(i).attr("data-email"); //NO I18N
			cols += dispNameToColNameMap[tmp];
			if(i < bubbleEls.length - 1){ cols += ","; }
		}
		return cols;
	};
  
  this.showAddNewRangeDlg = function(addEl)
  {
    var subType = addEl.getAttribute("subType");
    var dlgType = addEl.getAttribute("dlgType");
    var dlgBody = ZAVMFilterEdit.getDlgId(1,dlgType);
    var view = ZDBClientUI.getViewObj(addEl, "view");
    var dlgTitle = "Add New Range:";//NO I18N
    var exDiv = DOMUtils.getFirstMatchingChild(dlgBody,"*","elname","exDiv");
    var rangeValue = DOMUtils.getFirstMatchingChild(dlgBody,"*","elname","rangeValue");
    rangeValue.value = "";
    rangeValue.setAttribute("criteria",addEl.getAttribute("dispType"));
    rangeValue.setAttribute("displayrangecriteria",addEl.getAttribute("dispType"));
    exDiv.innerHTML = "(E.g.: Last 10 " + addEl.getAttribute("dispType") +")";//NO I18N
    ZDBDialogUtil.showDialog(dlgBody,{MODAL:true,ADDFRAME:true,SHADOW:false,VIEW:view,TITLE:dlgTitle,DONTREMOVE:true});
  }
  
  this.updateFilterChange = function(selField)
  {
    var view = ZDBClientUI.getViewObj(selField,"view");
    var filterEl = DOMUtils.getParentWithAttr(selField,"FILTEREL");
    var selAttrib = selField.getAttribute("sel");
    var selected = (selAttrib=="no");//No I18N
    ZDBUtil.setNamedChildEls(filterEl,filterEl);
    ZDBAnalysisFilter.changeSelection(selField,selected);
    var cloneSelField, customRangeValue;
    if(selected)
    {
      cloneSelField = selField.cloneNode(true);
      cloneSelField.style.display="block";//NO I18N
      cloneSelField.className="filterFieldRemoveSel font12 selElsList";//NO I18N
      cloneSelField.setAttribute("cloned","true");//NO I18N
      cloneSelField.style.height = "";
      cloneSelField.style.paddingBottom = "";
      customRangeValue = DOMUtils.getFirstMatchingChild(filterEl.selItemHolder, "div","elname","customRangeValue");//NO I18N
      filterEl.selItemHolder.insertBefore(cloneSelField,customRangeValue);
      cloneSelField.innerHTML = "";
      ZRTimelineFilter.constructElAndSetAttrForListSelItems(cloneSelField);
    }
    else
    {
        cloneSelField = (selField.getAttribute("cloned") == "true")? selField:
        DOMUtils.getFirstMatchingElement(filterEl.selItemHolder.childNodes,null,
                                         "filtervalue",selField.getAttribute("filtervalue"));//NO I18N
        if(cloneSelField.getAttribute("filtervalue") == view.tmpDefTimelineValue)
        {
        	var defaultValIcon = DOMUtils.getFirstMatchingChild(cloneSelField, "span","elname","defaultValIcon");//NO I18N
        	ZRTimelineFilter.removeAsDefaultValueForTL(defaultValIcon, null, true);
        }
        cloneSelField.parentNode.removeChild(cloneSelField);
        selField = (selField.getAttribute("cloned") != "true")?selField:
        DOMUtils.getFirstMatchingElement(filterEl.itemList.getElementsByTagName("div"),null
                                         ,"filtervalue",selField.getAttribute("filtervalue"));//NO I18N

        if(selField != null)
        {
          ZDBAnalysisFilter.changeSelection(selField,selected);
        }

    }
    var selList = (filterEl.selItemHolder !=null)? filterEl.selItemHolder.childNodes:DOMUtils.getChildElsWithAttr(filterEl,"sel","yes");//NO I18N
    var filter = "";
    var dispFilter = "";
    for(var i=0,j = selList.length; i < j ; i++)
    {
      if(selList[i].getAttribute && (selList[i].getAttribute("elname") != "customRangeValue"))
      {
        filter +=selList[i].getAttribute("filtervalue") + ",";
        dispFilter +=selList[i].getAttribute("displayfiltervalue") + ",";
      }
    }
    view.tmpCriteria = filter;
    view.tmpDisplayCriteria = dispFilter;
  }
  
  this.clearAllSel = function(el)
  {
    var filterEl = ZDBUtil.getParentWithAttributeValue(el,"filterel","true");//NO I18N
    var itemSelectedContent= DOMUtils.getFirstMatchingChild(filterEl,"*","elname","selItemHolder");
      if(itemSelectedContent==null)
      {
              return;
      }
      ZDBUtil.removeNonElements(itemSelectedContent);
      var itemSelected= itemSelectedContent.childNodes;
      var view = ZDBClientUI.getViewObj(itemSelectedContent,"view");
      while(itemSelected.length>0)
      {
        if(itemSelected[0].getAttribute("elname") == "customRangeValue")
        {
            break;
        }
        this.updateFilterChange(itemSelected[0]);
      }
  }
  
  this.showTimeLineCompMenu = function(el, event)
  {
	ZAVMFilterUtil.closeList(event, true);
    if(el.getAttribute("menuElShown") == "true")
    {
      return;
    }
    var view = ZDBClientUI.getViewObj(el,"view");
	var menuEl = $("vmFilterTimeLineMenuEl");
	var timeLineRangeHeader = DOMUtils.getFirstMatchingChild(menuEl,"*","elname","timeLineRangeHeader");
	var dateRangeEl = jQuery(timeLineRangeHeader).siblings("[elname='dataRangeHolder']")[0];
	ZDBUtil.setNamedChildEls(view.timelineComp,view.timelineComp,"elname");//NO I18N
	menuEl.parentNode.removeChild(menuEl);
	view.dashDiv.appendChild(menuEl);
	view.timelineComp.timeLineMenuEl = menuEl;
	menuEl.component = view.timelineComp;
	menuEl.style.display = "block";
	menuEl.style.visibility = "hidden";
	ZAVMFilter.positionOptionList(menuEl, view.timelineComp.compElContainer, view, true);
	menuEl.style.visibility = "visible";
	ZDBUtil.setNamedChildEls(menuEl,menuEl,"elname");//NO I18N
    ZRTimelineFilter.includeRelValuesSelByUsr(el, menuEl);
    if(view.timelineComp.getAttribute("selvals") == "" || !view.timelineComp.getAttribute("selvals"))
    {
    	dateRangeEl.style.height = "28px";
    	ZDBUtil.detachEvent(timeLineRangeHeader,'mousedown',ZRTimelineFilter.showOrHideDateRange,false);
    }
    else
    {
    	ZDBUtil.attachEvent(timeLineRangeHeader,'mousedown',ZRTimelineFilter.showOrHideDateRange,false);
    }
    ZDBUtil.attachEvent(document,'mousedown',ZRTimelineFilter.closeTimeLineMenuEl,false);
    el.setAttribute("menuElShown","true"); 
  }
  
  this.closeTimeLineMenuEl = function(event, closeMenu)
  {
	var el = ZDBUtil.getSourceElement(event);
	var isTimeLineMenu = DOMUtils.getParentWithAttrValue(el, "elname","timeLineMenuEl");//NO I18N
	if(!closeMenu && el && isTimeLineMenu)
	{
		return;
	}
    var view = ZDBClientUI.selectedTab.view;
    var ZRTimeLineUIComp = view.timelineComp;
    var timeLineHead = DOMUtils.getFirstMatchingChild(ZRTimeLineUIComp, "div", "elname","timeLineHead");//NO I18N
    view.timelineComp.timeLineMenuEl.style.display = "";
    timeLineHead.setAttribute("menuElShown","false");
    ZDBUtil.detachEvent(document,'mousedown',ZRTimelineFilter.closeTimeLineMenuEl,false);
    ZDBUtil.stopEventBubble(event);
  }
  
  this.includeRelValuesSelByUsr = function(el, menuEl)
  {
    var view = ZDBClientUI.getViewObj(el,"view");
    var timelineComp = DOMUtils.getParentWithAttrValue(el,"isTimeLineComp","true");//NO I18N
    var relSelElsCr = timelineComp.getAttribute("selVals");
    var relSelElsDispCr = timelineComp.getAttribute("display_selvals");
    var relCompFilterHead = DOMUtils.getFirstMatchingChild(menuEl, "div", "elname","relCompFilterHead");//NO I18N
    relCompFilterHead.innerHTML = "";
    if(relSelElsCr && relSelElsDispCr)
    {
        relSelElsCr = relSelElsCr.split(",");
        relSelElsDispCr = relSelElsDispCr.split(",");
        var resetDiv = document.createElement("div");
        resetDiv.className = "font12 dComboSSOption";
        resetDiv.style.paddingLeft = "23px";//NO I18N
        jQuery(resetDiv).addClass("timelineResetDiv");
        resetDiv.innerHTML=ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
        resetDiv.setAttribute("onclick","ZRDynFilterUtil.validateNRefresh(this,event,'TIMELINE')");
        resetDiv.setAttribute("criteria","All");
        resetDiv.setAttribute("dispcriteria",ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select"));
        relCompFilterHead.appendChild(resetDiv);
        for(var i=0; i<(relSelElsCr.length - 1); i++)
        {
          var div = document.createElement("div");
          if(view.timelineComp.compElContainer.getAttribute("selval") == relSelElsCr[i])
          {
        	  div.className = "font12 dComboSSOptionSelected";
          }
          else
          {
        	  div.className = "font12 dComboSSOption";
          }
          div.style.paddingLeft = "23px";//NO I18N
          div.setAttribute("criteria",relSelElsCr[i]);
          div.setAttribute("dispCriteria",relSelElsDispCr[i]);
          div.innerHTML = relSelElsDispCr[i];
          div.setAttribute("onclick","ZRDynFilterUtil.validateNRefresh(this,event,'TIMELINE')");
          relCompFilterHead.appendChild(div);
        }
        relCompFilterHead.style.display = "";
    }
    else
    {
    	relCompFilterHead.style.display = "none";
    }
  }
  
  this.showOrHideDateRange = function(event)
  {
	  var el = ZDBUtil.getSourceElement(event);
	  el = DOMUtils.getSelfOrParentWithAttrValue(el, "elname", "timeLineRangeHeader");//NO I18N
	  var dateRangeEl = jQuery(el).siblings("[elname='dataRangeHolder']")[0];
	  var rangeElHgt;
	  if(dateRangeEl.getAttribute("dateRangeShown") != "true")
	  {
		  rangeElHgt = "28px";//NO I18N
		  dateRangeEl.setAttribute("dateRangeShown","true");
	  }
	  else
	  {
		  rangeElHgt = "0px";//NO I18N
		  dateRangeEl.setAttribute("dateRangeShown","false");
	  }
	  dateRangeEl.style.height = rangeElHgt;
  }
  
  this.expCollapseSelValEditor = function(el, isEdit)
  {
	  var filterEl = DOMUtils.getParentWithAttrValue(el,"filterel","true");//NO I18N
	  var itemListCompHolder = DOMUtils.getFirstMatchingChild(filterEl,"*","elname","itemListCompHolder");
	  if(isEdit == "true")
	  {
		  itemListCompHolder.style.visibility = "hidden";
		  filterEl.className = "editSelValMode";
		  setTimeout(function(){ itemListCompHolder.style.visibility = "visible"; }, 300);//NO I18N
	  }
	  else
	  {
		  filterEl.className = "closeEditorMode";
		  itemListCompHolder
	  }
  }
}