//$Id$

var ZDBTabHandler = new function()
{
	this.initialize = function()
	{
		
	}
	this.getTabConfig = function(scrollClick, ev, step,timeInterval,stopAtPoint)
	{
		ZDBTabHandler.initialize();
		
		ZDBTabHandler.startScroll(scrollClick,ev,step,timeInterval,stopAtPoint);
	}
	
	this.moveToVisibleArea = function()
	{
          if(ZDBGlobal.integrated || ZDBGlobal.ISNEWLAYOUT){return;}
          
        var selectedTab = ZDBClientUI.selectedTab;
        var tabHolder = $("ZDBTabHolder");
        ZDBTabHandler.enableScrollKeysIfNeeded()
        var isFullyVisible = ZDBClientUtil.isElFullyVisible(selectedTab,tabHolder);
        if(!isFullyVisible)
        	{
        		ZDBClientUtil.scrollElToVisible(selectedTab, tabHolder, {DIRECTION:"left",ONCOMPLETE:function(){ZDBTabHandler.enableDisableNavButtons();}});// NO I18N
        	}
	}
	
	this.enableScrollKeysIfNeeded = function()
	{
		if(ZDBClientUI.standAlone){return;}
		var tabHolder = ZDBClientUI.ZRSTabHolder; var tabSpace = $("ZDBTabHolder"); 
		var leftArrow = jQuery("#ZR_LeftTabNavArrow"); 	var rightArrow = jQuery("#ZR_RightTabNavArrow"); var listArrow = jQuery("#ZR_ListTabNavArrow");// NO I18N
		var show = (tabHolder.scrollWidth > tabSpace.clientWidth);
		var action = show?"show":"hide";// NO I18N
		rightArrow[action]("slow");
		leftArrow[action]("slow");
		listArrow[action]("slow");
		
		var movableAddNewTab = jQuery("#ZR_MovableAddNewTab");//No i18N
		var newTab = jQuery("#ZRNewTab");//No i18N
		if(ZDBClientUtil.isElFullyVisible(movableAddNewTab[0],tabSpace)){
			movableAddNewTab.css("visibility",'visible');//No i18N
			newTab[0].style.display = "none";
		}else{
			movableAddNewTab.css("visibility",'hidden');//No i18N
			newTab[0].style.display = "inline-block";
		}
	}
	
	this.removeSelectedTab = function(el,event)
	{
		// if((el!=null) && (el!=ZDBClientUI.selectedTab))
  //       {
  //         ZDBClientUI.selectTabEl(el,event);
        // }	
		if(ZRSMenu.visibleNavMenu)
        {
            ZDBNavigation.closeNavViewList(event,true);  
        }
        if(el != null && el.className != "viewCloseIcon" ) { 
			var parTab = ZDBUtil.getParentWithAttr(el, "partab"); 
			if(parTab != ZDBClientUI.selectedTab) { 
				ZDBClientUI.selectTabEl(el,event); 
			} 
		}	
        ZDBUtil.stopEventBubble(event);
	   var tab= ZDBClientUI.selectedTab;
       if(tab.view.type === "DBSettingTab"){
            ReactDOM.unmountComponentAtNode(tab.view.viewComp);
        }
       if(tab.view.dialogStatus && tab.view.dialogStatus > 0)
       {//Closing the dialog inside the tab. Literally associating the dialog close with tab close.
            for(var i=tab.view.dialogStatus; i > 0;i--)
            {
            	if(tab.focusedDialog.gridObj && tab.focusedDialog.gridObj.type == "TableDesign")
            	{
            		ZDBDesignGrid.closeDesign(el);
            	}
            	else
            	{
            		ZDBInlineDialog.closeDialog();
            	}            
            }
            return;
       }
    
		if(tab.view.type=="Explorer"){return;}
		ZDBClientUI.removeTabEl(tab);
        if(ZDBGlobal.ISNEWLAYOUT) {
           var tabHeaderWidth = tab.tabHeader.offsetWidth;
           ZDBNavigation.restructureTabHolder(null,tabHeaderWidth);
        }
   		if(event != null){ ZDBUtil.stopEventBubble(event); }
	}
	

  this.editTab = function(el, event)
  {
    var parNode = DOMUtils.getParentWithAttr(el,"parTab");
    if(parNode!=ZDBClientUI.selectedTab)
    {
      ZDBClientUI.selectTabEl(el, event);
    }
    this.editTitleNDesc(el,event,"tabEdit");//NO I18N
  }
  
  this.editTitleNDesc = function(el,event,editorName)
  {
	  var tab = ZDBClientUI.selectedTab;
	  var tabEl = tab.tabHeader;
	  var view = tab.view;
	  if(!view || view.isDummyView || !view.permissions.designModify || view.dialogStatus > 0)
	  {
		  return;
	  }
	  if(view instanceof ZDBDataGrid)
	  {
		  view.onLostFocus();
	  }
	  if(tabEl.getAttribute("editable") == "true")
	  {
	      var inputTabEl = this.getTabEditField(editorName); // No I18N
	      document.body.appendChild(inputTabEl);
	      inputTabEl.style.display = "block";
	      inputTabEl.style.position = "absolute";
	      if(editorName == "tabEdit")
	      {
	    	  var tabElHeight = jQuery(tabEl).height();
	          var width =  tabEl.parentNode.offsetWidth;
	          inputTabEl.style.top = ZDBUtil.getObjTop(tabEl) - 1 + "px";
	          inputTabEl.style.left = ZDBUtil.getObjLeft(tabEl)- 4 +"px";
	          inputTabEl.originalValue = view.displayName;
	          inputTabEl.style.width = width + 5 + "px";
	          inputTabEl.style.height = (tabElHeight - 6)+ "px";
	          inputTabEl.value = view.displayName;
	      }
	      else
	      {
	          var height = jQuery(el).height();
	          var width =  jQuery(el).width();
	          inputTabEl.style.top = ZDBUtil.getElementAbsoluteTop(el)  - 2 + "px";
	          inputTabEl.style.left = ZDBUtil.getElementAbsoluteLeft(el)  - 6 + "px";
	          inputTabEl.style.width = width + 2 +"px";
	          inputTabEl.style.height = height + "px";
	          if(editorName == "titleEdit")
	          {
	        	  inputTabEl.originalValue = view.displayName;
	        	  inputTabEl.value = view.displayName;
	          }
	          else if (editorName == "titleEditChart")
	          {
	        	  var titleOrDisplayName = (view.title== null || view.title=="") ? view.displayName : view.title;
	        	  inputTabEl.originalValue = titleOrDisplayName;
	        	  inputTabEl.value = titleOrDisplayName;
	          }
	          else
	          {
	        	  inputTabEl.originalValue = view.description;
	        	  inputTabEl.value = view.description;
	          }
	      }
	      inputTabEl.view = view;
	      tabEl.setAttribute("editable","false");
	      ZDBTabHandler.inputTabEl = inputTabEl;
	      ZDBTabHandler.tabEl = tabEl;
	      ZDBUtil.setTimeout(ZDBUtil.setFocus, null, [inputTabEl], 10);
	  }
	  ZDBUtil.stopEventBubble(event);
	  if(ZDBNavigation.popOut)
	  {
		  ZDBNavigation.popInNavigation(true);
	  }
  }
  
  this.getTabEditField = function(editorId)
  {
    if(this[editorId] == null)
    { 
      this[editorId] = document.getElementById(editorId);          
    }
    return this[editorId];
  }

  this.resetTabContent = function(el)
  {
    var view = el.view;
    var inputTabEl = ZDBTabHandler.inputTabEl; 
    var value = inputTabEl.value;
    if(value.trim() == '')
    {
      ZDBTabHandler.hideInputTabEl();
      ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.common.showinfo.js.emptyViewName'));
      //showCustomMessage('Table/View name cannot be empty',inputTabEl);
      //inputTabEl.focus(true);
      return;
    }
    if(value.length > ZDBConst.DBOBJECT_NAME_MAX_LENGTH)
    {
      ZDBTabHandler.hideInputTabEl();
      ZDBMsgBox.showInfo(ZDBI18NMap.f('zrpt.common.showinfo.js.viewNameMaxLengthExceedErr', ZDBConst.DBOBJECT_NAME_MAX_LENGTH));
      return;
    }
    hideCustomMessage();
    if(value.trim() == view.displayName)
    {
      ZDBTabHandler.hideInputTabEl();
      return;
    }
    if(ZDBUtil.isNewView(view))
    {
      ZDBTabHandler.hideInputTabEl();
      ZDBClientUI.updateDisplayName(ZDBClientUI.selectedTab,value);
      view.displayName = value;
      return;
    }
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?";// NO I18N
    var params = "&ZDBACTION=RENAMEOBJECT&DISPNAME=" + encodeURIComponent(value) + "&OBJID=" + view.objId;// NO I18N
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:ZDBTabHandler.renameObject,
                         ONFAILUREFUNC:ZDBTabHandler.handleRenameFailure,OPSTATUSID:ZDBClientUI.selectedTab.tabIcon,
                         VIEW:view,TAB:ZDBClientUI.selectedTab});
  }

  this.resetdescInline = function(el)
  {
	  var view = el.view;
	  var inputTabEl = ZDBTabHandler.inputTabEl; 
	  var value = inputTabEl.value;
	  var displayname = view.displayName;
	  if(value.length > ZDBConst.DESCRIPTION_MAX_LENGTH)
	    {
	      ZDBTabHandler.hideInputTabEl();
	      ZDBMsgBox.showInfo(ZDBI18NMap.f('zrpt.common.showinfo.js.descMaxLenExceedErr', ZDBConst.DESCRIPTION_MAX_LENGTH));
	      return;
	    }
	  hideCustomMessage();
	  if(value.trim() == view.description)
	    {
	      ZDBTabHandler.hideInputTabEl();
	      return;
	    }
	  if(ZDBUtil.isNewView(view))
	    {
	      ZDBTabHandler.hideInputTabEl();
	      ZDBClientUI.updateDisplayName(ZDBClientUI.selectedTab,view.displayName,value);
	      view.description = value;
	      return;
	    }
	  var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?";// NO I18N
	  var params = "&ZDBACTION=RENAMEOBJECT&DISPNAME=" + encodeURIComponent(displayname) + "&DESCRIPTION=" + encodeURIComponent(value) + "&OBJID=" + view.objId;// NO I18N
	  AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:ZDBTabHandler.renameObjectDesc,
	                         ONFAILUREFUNC:ZDBTabHandler.handleRenameFailure,OPSTATUSID:ZDBClientUI.selectedTab.tabIcon,
	                         VIEW:view,TAB:ZDBClientUI.selectedTab});
  }
  
  this.renameObjectDesc = function(response, requestOptions)
  {
    ZDBTabHandler.hideInputTabEl();
    var params = response.getResponseParams();
    var view = requestOptions["VIEW"];
    view.description = params["DESCRIPTION"] == "null" ? "": params["DESCRIPTION"];//NO I18N
    ZDBClientUI.updateDisplayName(requestOptions["TAB"],params["DISPNAME"],view.description);
    view.displayName = params["DISPNAME"];
    view.designModTime= params["DESIGNMODTIME"];
    ZDBNavigation.renameObj(view.displayName,view.objId,view.description);
  }
  
  this.resetTitleInline = function (el)
  {
	  var view = el.view;
	  var inputTabEl = ZDBTabHandler.inputTabEl; 
	  var value = inputTabEl.value;
	  var propSetUtil = view.propSetUtil;
	  var prevTitle = (view.title== null || view.title=="") ? view.displayName:view.title;
	  if(value.length > ZDBConst.TITLE_MAX_LENGTH)
	   {
	      ZDBTabHandler.hideInputTabEl();
	      ZDBMsgBox.showInfo(ZDBI18NMap.f('zrpt.common.showinfo.js.titleMaxLenExceedErr', ZDBConst.TITLE_MAX_LENGTH));
	      return;
	   }
	  hideCustomMessage();
	  if(value == prevTitle)
	    {
	      ZDBTabHandler.hideInputTabEl();
	      return;
	    }
	  if((value == view.displayName) || (value.trim() == ''))
		{
		  view.title = null;
		  if(propSetUtil)
		  	{
			  	var propName = PropSettings.CHART_TITLE;
			  	var instId = PropSettings.STATIC_PROP;
			  	var propType = PropSettings.STRING_PROPTYPE;
			  	propSetUtil.checkInPropMapObj(propName, instId, propType);
		  		propSetUtil.deleteFromPropMap(propName, instId, propType);
		  		propSetUtil.createPropSetDiv(view);
		  	}
		  value = view.displayName;
		}
	  else
		{
		  view.title = value;
		  if(propSetUtil)
		  	{
			  	var propName = PropSettings.CHART_TITLE;
			  	var instId = PropSettings.STATIC_PROP;
			  	var propType = PropSettings.STRING_PROPTYPE;
			  	propSetUtil.checkInPropMapObj(propName, instId, propType);
		  		propSetUtil.propMap[propName][instId][propType] = view.title;
		  		propSetUtil.createPropSetDiv(view);
		  	}
		}
	  view.toolbar.viewTitleEl.innerHTML = ZDBEscapeUtil.encodeForHtml(value);
	  ZDBTabHandler.hideInputTabEl();
	  view.setModified();
	  ZDBMenu.resizeTitleNDesc(view.toolbar);
  }
  
  this.resetdescInlineChart = function (el)
  {
	  var view = el.view;
	  var inputTabEl = ZDBTabHandler.inputTabEl; 
	  var value = inputTabEl.value;
	  var propSetUtil = view.propSetUtil;
	  var prevDesc = view.description;
	  if(value.length > ZDBConst.DESCRIPTION_MAX_LENGTH)
	   {
	      ZDBTabHandler.hideInputTabEl();
	      ZDBMsgBox.showInfo(ZDBI18NMap.f('zrpt.common.showinfo.js.descMaxLenExceedErr', ZDBConst.DESCRIPTION_MAX_LENGTH));
	      return;
	   }
	  hideCustomMessage();
	  if(value == prevDesc)
	    {
	      ZDBTabHandler.hideInputTabEl();
	      return;
	    }
	  if(value == '')
		{
		  view.description = "";
		  if(propSetUtil)
		  	{
			  	var propName = PropSettings.CHART_DESCRIPTION;
			  	var instId = PropSettings.STATIC_PROP;
			  	var propType = PropSettings.STRING_PROPTYPE;
			  	propSetUtil.checkInPropMapObj(propName, instId, propType);
		  		propSetUtil.deleteFromPropMap(propName, instId, propType);
		  		propSetUtil.createPropSetDiv(view);
		  	}
		}
	  else
		{
		  view.description = value;
		  if(propSetUtil)
		  	{
			  	var propName = PropSettings.CHART_DESCRIPTION;
			  	var instId = PropSettings.STATIC_PROP;
			  	var propType = PropSettings.STRING_PROPTYPE;
			  	propSetUtil.checkInPropMapObj(propName, instId, propType);
		  		propSetUtil.propMap[propName][instId][propType] = view.description;
		  		propSetUtil.createPropSetDiv(view);
		  	}
		}
	  view.toolbar.viewDescEl.innerHTML = ZDBEscapeUtil.encodeForHtml(value);
	  ZDBTabHandler.hideInputTabEl();
	  view.setModified();
	  ZDBMenu.resizeTitleNDesc(view.toolbar);
  }
  
  this.renameObject = function(response, requestOptions)
  {
    ZDBTabHandler.hideInputTabEl();
    var params = response.getResponseParams();
    ZDBClientUI.updateDisplayName(requestOptions["TAB"],params["DISPNAME"]);
    var view = requestOptions["VIEW"];
    view.displayName = params["DISPNAME"];
    view.designModTime= params["DESIGNMODTIME"];
    ZDBNavigation.renameObj(view.displayName,view.objId,null);
  }

  this.handleRenameFailure = function(response, requestOptions)
  {
    var errCode = response.getResponsePart("ERRORCODE");
    errCode = trimAll(errCode);
    if(errCode == "META_DBOBJECT_NAME_DUPLICATED")
    {
      ZDBTabHandler.hideInputTabEl();
      ZDBMsgBox.showInfo(response.getResponsePart("STATUS_MESSAGE"));
      //showCustomMessage(response.getResponsePart("STATUS_MESSAGE"), ZDBTabHandler.inputTabEl);
    }
    else
    {
      ZDBTabHandler.hideInputTabEl(); 
      AjaxAPI.onFailureFunc(response,requestOptions);
    }
  }

  this.hideInputTabEl = function()
  {
    ZDBTabHandler.tabEl.setAttribute("editable","true");
    ZDBTabHandler.inputTabEl.style.display = 'none';
  }
	
	this.showEditIcon = function(el)
	{
          var tab = DOMUtils.getParentWithAttr(el,"parTab");
          var view = tab.view;
          if(!view)
          {
            return; //PK: Possible?
          }
          if(view.isDummyView || view.dialogStatus > 0)
          {
            tab.tabIcon.title = "";
            return;
          }

          ZDBUtil.setNamedChildEls(tab,tab);
          var renameIcon=jQuery(tab.tabIcon);
          renameIcon.attr("tip", ZDBI18NMap.g("zrpt.db.tab.title.js.renametab")); //No i18N
          renameIcon.bind("mousemove",function(event){ZDBToolTip.show(this,event);});//No I18N
          renameIcon.bind("mouseout",function(){ZDBToolTip.hide(this);});//No I18N
          tab.tabIcon.className="renameIcon mcLoaded";
	}
	
	this.showTabIcon = function(el)
	{
          var tab = DOMUtils.getParentWithAttr(el,"parTab");
          ZDBUtil.setNamedChildEls(tab,tab);
          tab.tabIcon.className="tabIcon mcLoaded";		
          var view = tab.view;
          if(!view)
          {
            return; //PK: Possible?
          }
	}
	
	this.quickHandling = function(key,e)
	{
		if(key==220){//ON KEY ctrl + "\" PRESS
			ZDBTabHandler.removeSelectedTab(ZDBClientUI.selectedTab);
			return;
		}
		
		if("37,39,38,40".indexOf(key) != -1) //ON KEY (left/right/up/down) PRESS
			{
			ZDBTabHandler.switchTabs(key,e);
			}
	}
	
	
	this.switchTabs = function(key,e)
	{
		
		if(key==38 || key==40)
		{
		ZDBTabHandler.listTabsNSwitch(key,e);
		return;
		}
		
		var selectedListItem = ZDBClientUI.selectedTab;		
		this.selectedListItem = selectedListItem;
		var nextItem = selectedListItem.previousSibling;
		var previousItem = selectedListItem.nextSibling;
		if(key==39 && previousItem!=null)
			{
			ZDBClientUI.selectTab(previousItem);
			}
		else if(key==37 && nextItem!=null)
			{
			ZDBClientUI.selectTab(nextItem);
			}
		
	}
	
	this.listTabsNSwitch = function(key,e)
	{
		if(ZDBTabHandler.tabPointer==null || ZDBTabHandler.tabList==null)
			{
			 var tabList = ZDBTabHandler.getTabList();
			 ZDBTabHandler.tabList = tabList;
			}
		var tabList = ZDBTabHandler.tabList;
		var tabPointer = ZDBTabHandler.tabPointer;
		jQuery(tabList).show();
		var tabListItems = jQuery(tabList).find("div");
		var len = tabListItems.length;
		jQuery(tabListItems[tabPointer]).addClass("pointed");
		jQuery(tabListItems[tabPointer]).toggleClass("pointed");
		if(key==40){
			tabPointer++;
			if(tabPointer>=len){tabPointer = 0;}
		}else{
			tabPointer--;
			if(tabPointer<0){tabPointer = len-1;}
		}
		
		var pointedTab = tabListItems[tabPointer];
		ZDBTabHandler.movePointedTabToVisible(pointedTab);
		jQuery(pointedTab).toggleClass("pointed");// NO I18N
		ZDBTabHandler.tabPointer = tabPointer;
		ZDBTabHandler.tabList = tabList;
		
	}
	
	this.getTabList = function()
	{
		var openedTabs = ZDBClientUI.ZRSTabHolder.children;
		var openedTabList = jQuery("#ZROpenedTabList")[0];
		var tabsToShow = 5;
		var sampleListItem = jQuery("#ZRSampleTabListItem");// NO I18N
		var height = jQuery(sampleListItem).outerHeight();
		var margin = parseInt(jQuery(sampleListItem).css("margin-top"))+parseInt(jQuery(sampleListItem).css("margin-bottom"));// NO I18N
		jQuery(openedTabList).css("height",(tabsToShow * (height+margin)));// NO I18N
		for(var i = 0, j = openedTabs.length; i < j; i++) 
        {
            var tab = openedTabs[i];
			if(tab==ZDBClientUI.selectedTab)
            {
                ZDBTabHandler.tabPointer = i;
            }
			var listItem = sampleListItem.clone();
			listItem[0].relTab = tab;
			listItem[0].className = tab.view.type + "Obj"
			listItem.find('[elname="tabName"]')[0].innerHTML = ZDBEscapeUtil.encodeForHtml(tab.view.displayName);
			listItem.appendTo(openedTabList);
		}
		document.body.appendChild(openedTabList);
		return openedTabList;
	}
    
	this.removeListedTab = function()
	{
		jQuery(ZDBTabHandler.tabList).empty();
		ZDBTabHandler.tabPointer = null;
		ZDBTabHandler.tabList = null;
	}

	this.movePointedTabToVisible = function(tab)
	{
		var parent = jQuery("#ZROpenedTabList")[0];
		ZDBClientUtil.scrollElToVisible(tab, parent, {ADJUSTTOP:-10, DURATION:"fast"});// NO I18N
	}

	this.scrollTab = function(direction)
	{
		if(ZDBTabHandler.scroll!=true){
			ZDBTabHandler.scroll = true;
			ZDBTabHandler.focusedTab = null;
			return;
		}
		var newFocusedTab = (ZDBTabHandler.focusedTab!=null && ZDBTabHandler.focusedTab.parentNode!=null)?ZDBTabHandler.focusedTab
																					:ZDBTabHandler.getFirstHiddenTab(direction);
		if(newFocusedTab!=null){
			var nextTab = (ZDBTabHandler.focusedTab!=null)?(direction=="left")?newFocusedTab.previousSibling:newFocusedTab.nextSibling // NO I18N
							:newFocusedTab;

			ZDBTabHandler.focusedTab = (nextTab==null)?newFocusedTab:nextTab;
			ZDBClientUtil.scrollElToVisible(ZDBTabHandler.focusedTab, ZDBTabHandler.tabHolderParent, {DIRECTION:"left",ONCOMPLETE:function(){ZDBTabHandler.enableDisableNavButtons();}});// NO I18N
		}

		if(ZDBTabHandler.scrollTimer!=null){clearTimeout(ZDBTabHandler.scrollTimer);}
		this.scrollTimer = setTimeout(function(){ZDBTabHandler.scrollTab(direction);},200);
	}

	this.enableDisableNavButtons = function()
	{
		var visibleArea = jQuery("#ZDBTabHolder");//No i18N
		var openedTabs = ZDBClientUI.ZRSTabHolder.children;
		var firstTab = openedTabs[0];
		var lastTab = openedTabs[openedTabs.length - 1];

		var fadeLevel = "alpha10";//No i18N

		var lTab = jQuery("#ZR_LeftTabNavArrow"); var rTab = jQuery("#ZR_RightTabNavArrow");//No i18N
		if(ZDBClientUtil.isElFullyVisible(firstTab,visibleArea)){lTab.addClass(fadeLevel);}else{lTab.removeClass(fadeLevel);}
		if(ZDBClientUtil.isElFullyVisible(lastTab,visibleArea)){rTab.addClass(fadeLevel);}else{rTab.removeClass(fadeLevel);}

	}

	this.getFirstHiddenTab = function(direction)
	{
		if(direction==null){
//			console.log("direction is null");
			return;
		}
		var firstHiddenTab = null;
		var visibleArea = ZDBTabHandler.tabHolderParent;
		var openedTabs = ZDBClientUI.ZRSTabHolder.children;
				var i = (direction=="left")?0:(openedTabs.length - 1);// NO I18N

		while(ZDBClientUtil.isElFullyVisible(openedTabs[i],visibleArea)!=true)
		{
			firstHiddenTab = openedTabs[i];
			if(direction=="left"){i++;}else{i--;}
		}
		return firstHiddenTab;
	}
	
	this.stopScroll = function()
	{
		ZDBTabHandler.scroll = false;
		ZDBTabHandler.focusedTab = null;
	}
}


jQuery(document).ready(
	function()
	{
	jQuery(document).bind("keydown",// No I18N
						function(e)
						{
							if(ZDBUtil.isCursorBusyOnInputField()){return;}
						    if(e.shiftKey)
							{
								jQuery(document).bind("keyup",function isShiftUp(e) // NO I18N
								{
								if(e.keyCode==16)
									{
									jQuery(document).unbind("keyup", isShiftUp);// NO I18N
									if(ZDBTabHandler.tabPointer==null){return;}
									var tabList = ZDBTabHandler.tabList;
									ZDBClientUI.selectTab(jQuery(tabList).find("div")[ZDBTabHandler.tabPointer].relTab);
									jQuery(tabList).hide();
									ZDBTabHandler.removeListedTab();
									}
								
								});
							}
						    var shiftHotKeys = "37,39,38,40";//left, right, up, down
							if(e.shiftKey && (shiftHotKeys.indexOf(e.which)!=-1) && (ZDBDialogUtil.focusDialog==null || ZDBDialogUtil.focusDialog==undefined))
							{
								e.preventDefault();
								e.stopPropagation();
								ZDBTabHandler.quickHandling(e.which,e);
							}
							
							var ctrlHotKeys = "220"; // "\":TAB CLOSE
							if(e.ctrlKey && (ctrlHotKeys.indexOf(e.which)!=-1) && (ZDBDialogUtil.focusDialog==null || ZDBDialogUtil.focusDialog==undefined))
							{
								e.preventDefault();
								e.stopPropagation();
								ZDBTabHandler.quickHandling(e.which,e);
							}
						    
						});
	});

jQuery(document).ready(
		function()
		{
			var leftArrow = jQuery("#ZR_LeftTabNavArrow"); 	// NO I18N
			var rightArrow = jQuery("#ZR_RightTabNavArrow");// NO I18N
			leftArrow.on("mousedown",function(){ZDBTabHandler.scrollTab("left")});// NO I18N
			leftArrow.on("mouseup",function(){ZDBTabHandler.stopScroll();});// NO I18N
			rightArrow.on("mousedown",function(){ZDBTabHandler.scrollTab("right")});// NO I18N
			rightArrow.on("mouseup",function(){ZDBTabHandler.stopScroll();});// NO I18N
			ZDBTabHandler.tabHolderParent = (ZDBGlobal.ISNEWLAYOUT) ? $("ZRSTabParent") : $("ZDBTabHolder");
			ZDBTabHandler.scroll = true;
		});
