//$Id$

var ZDBTrash = new function()
{
    this.TrashType = "All";// No I18N
    this.wholeList = null;
    this.initialCount = null;
    this.nameSortOrder = false;
    this.dateSortOrder = true;
    this.processingEvent = false;
    this.searchRenderingData = {
        
    };
         
    this.highlightTrashListItem = function(el)
    {
        var restoreButton = jQuery(el).find("span[elname='RestoreButton']").show();
        var deleteButton = jQuery(el).find("span[elname='DeleteButton']").show();	
        var infoButton = jQuery(el).find("span[elname='InfoButton']").show();
        jQuery(el).removeClass("trHighLight").addClass("trHighLight"); // No I18N
    }
		 
		 	 
    this.dehighlightTrashListItem = function(el)
    {
        if(!el){
            jQuery("#TrashObjectList li").find("input#TrashCheckBox:not(:checked)").parents("[fromtrash='true']").removeClass("trHighLight"); //NO I18N
            return;
        }
        var restoreButton = jQuery(el).find("span[elname='RestoreButton']").hide();
        var deleteButton = jQuery(el).find("span[elname='DeleteButton']").hide();
        var infoButton = jQuery(el).find("span[elname='InfoButton']").hide();
        var input = jQuery(el).find("input#TrashCheckBox")[0];
        if((input && (input.checked == true))){
            return;
        }
        jQuery(el).removeClass("trHighLight");
    }
		 
		 
		 
    this.trashSingleRestore = function(el)
     {
        if(ZDBTrash.processingEvent)
        {
            return;
        }
        else
        {
            ZDBTrash.processingEvent = true;
            el.setAttribute("clicked", "yes");//No I18N
            var dbId = ZDBClientUI.dbId;
            var objType = DOMUtils.getParentWithAttr(el,"objType").getAttribute("objType");
            var objId = el.attributes["objId"].value; //No I18N
            ZDBTrash.trashRestore(objId, dbId);
            if(objType == "Table" || objType == "QueryTable")
            {
                ZDBAnalysisCaching.tblColInfo = {};
                ZDBAnalysisCaching.tblColInfo.data = {};
                ZDBAnalysisCaching.tblColInfo.relModelInfo = {};
                ZDBAnalysisCaching.tblColInfo.relCount = 0;
            }
        }
     }
			
    this.clearTrashSearch = function()
    { 
        ZDBTrash.fetchTrashObjectsListForDB(false); //No I18N
        return;
    }
		
    this.clearSearch = function(event)
    {
        if(!jQuery("#TrashObjectList")[0])
        {
            jQuery("#TrashSearchResults").hide();//no i18n
            jQuery("#TrashSearchClearField").hide();//no i18n
            jQuery("#TrashSearchTxtFld").val("").focus();//no i18n
            $("TrashCount").innerHTML = ZDBTrash.initialCount;
            return;
        }
        $("TrashObjectList").parentNode.replaceChild($("TrashObjectList"), ZDBTrash.wholeList);
        jQuery("#TrashObjectList").find("li").show(); //No I18N
        jQuery("#TrashSearchResults").hide();//no i18n
        jQuery("#TrashSearchClearField").hide();//no i18n
        jQuery("#TrashSearchTxtFld").val("").focus();//no i18n
        $("TrashCount").innerHTML = ZDBTrash.initialCount;
        ZDBUtil.stopEventBubble(event);
    }
		
    this.searchTrashList = function(event)
    {
        if(!jQuery("#TrashObjectList")[0])
        {
            jQuery("#TrashSearchClearField").show(); //No I18N  
            $("TrashSearchResults").style.display = "block"; //No I18N
            $("TrashSearchCount").innerHTML = ZDBI18NMap.g('zrpt.common.showinfo.js.no'); 
            $("TrashCount").innerHTML = "Total Count: "+ "0";//No I18N
            if(event.keyCode == 27)
            {
                ZDBTrash.fetchTrashObjectsListForDB(false);
            }
            return;
        }
        var txtFld = $("TrashSearchTxtFld");
        var value = ZDBSearchUtil.getSearchValue(txtFld);
        if(event.keyCode == 27)
        {
            ZDBTrash.fetchTrashObjectsListForDB(false);
        }
        if(value == null || value == "")
        {
            jQuery("#TrashSearchClearField").hide(); //No I18N  
            $("TrashObjectList").parentNode.replaceChild($("TrashObjectList"), ZDBTrash.wholeList);
            jQuery("#TrashObjectList").find("li").show(); //No I18N
            $("TrashSearchResults").style.display = "none"; //No I18N
            //$("TrashSearchCount").innerHTML = "No";//No I18N
            //$("TrashSearchCount").style.display = "none";//No I18N
            $("TrashCount").innerHTML = ZDBTrash.initialCount;
            return;
        }
        else
        {
            value = value.toLowerCase();
            jQuery("#TrashSearchClearField").show(); //No I18N  
        }
        var childEls;
        if(ZDBTrash.TrashType !=="All")
        {
            childEls=jQuery("#TrashObjectList").find("li[objtype='"+ZDBTrash.TrashType+"']"); //No i18N
            jQuery("#TrashObjectList").find("li[objtype!='"+ZDBTrash.TrashType+"']").hide(); //No i18N
        }
        else
        {
           childEls = jQuery("#TrashObjectList")[0].getElementsByTagName("li"); //No I18N  
        }
        var count = 0;
        for(var i=0;i < childEls.length; i++)
        {
            var child = childEls[i];
            var dispname = child.getAttribute("dispname");
            var matched = ((value == null)||((dispname != null) && (dispname.toLowerCase().indexOf(value) > -1)));
            child.style.display= (matched)? "":"none";      
            count += (matched)? 1:0;     
        }
        $("TrashSearchResults").style.display = (value == null)?"none":"block"; //No I18N
        $("TrashSearchCount").innerHTML = (count>0)?count:ZDBI18NMap.g('zrpt.common.showinfo.js.no');
        $("TrashCount").innerHTML = "Total Count: "+ count;//No I18N
    }
		
		
    this.showTrashSearchByOpts = function(el,event)
    {
        var menu = ZDBContentCache.appendAndGet("Trash_View_Menu","GridMenu",document.body);
        var menuEl=jQuery(menu);
        var list=menuEl.find("[isViewType='true']"); //No I18N
        menuEl.find("span").removeClass("sortTickMenu");    //No I18N  
        menuEl.find("#Search"+ZDBTrash.TrashType).addClass("sortTickMenu");   //No I18N
        ZRSMenu.showMenu(event,el,menu,5,ZDBNavigation.searchOptsClose);
    }
		
    this.sortByStringValue = function(el, sortOrder, attr)
    {
        if(el == null)
        {
            if(!sortOrder)
            {
                jQuery('#TrashStringSort').removeClass("zr_trashSortDesc").addClass("zr_trashSortAsc");
                jQuery('#TrashDateSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
            }
            else
            {
                jQuery('#TrashStringSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
                jQuery('#TrashDateSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
            }
            return;
        }
        var new_ul = el.cloneNode(false);
        var lis = jQuery(el).find('li[typeOfView]');
        if(!sortOrder)
        {
            lis.sort(function(a,b)//No I18N
            {
                var aValue = a.attributes[attr].value.toLowerCase();
                var bValue = b.attributes[attr].value.toLowerCase();
                if(aValue < bValue)
                    return -1;
                if(aValue > bValue) 
                    return 1;
                return 0;
            });
        }
        else
            {
                lis.sort(function(a,b)//No I18N
                {
                    var aValue = a.attributes[attr].value.toLowerCase();
                    var bValue = b.attributes[attr].value.toLowerCase();
                    if(aValue < bValue)
                        return 1;
                    if(aValue > bValue) 
                        return -1;
                    return 0;
                });
            }

        for (var i = 0; i < lis.length; i++)
        {
            new_ul.appendChild(lis[i]);
        }
        el.parentNode.replaceChild(new_ul, el);
        if(!sortOrder)
        {
            jQuery('#TrashStringSort').removeClass("zr_trashSortDesc").addClass("zr_trashSortAsc");
            jQuery('#TrashDateSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
        }
        else
        {
            jQuery('#TrashStringSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
            jQuery('#TrashDateSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
        }
    }
		
    this.sortByStringForTrash = function()
    {
        list =  $('TrashObjectList');
        ZDBTrash.sortByStringValue(list, ZDBTrash.nameSortOrder, "dispname"); //No I18N	
        ZDBTrash.nameSortOrder = !(ZDBTrash.nameSortOrder);
    }
		
    this.sortByDateForTrash = function()
    {
        var ul = $('TrashObjectList');
        ZDBTrash.sortByDateValue(ul, ZDBTrash.dateSortOrder);
        ZDBTrash.dateSortOrder = !(ZDBTrash.dateSortOrder);
    }
		
    this.sortByDateValue = function(el, sortOrder)
    {
        if(el == null)
        {
            if(!sortOrder)
            {
                jQuery('#TrashDateSort').removeClass("zr_trashSortDesc").addClass("zr_trashSortAsc");
                jQuery('#TrashStringSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
            }
            else
            {
                jQuery('#TrashDateSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
                jQuery('#TrashStringSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
            }
            return;
        }
        var lis = jQuery(el).find('li[typeOfView]');
        if(sortOrder)
        {
            lis.sort(function(a, b) //No I18N
            {
                var aDate = new Date(Number(a.attributes["trashedTime"].value));
                var bDate = new Date(Number(b.attributes["trashedTime"].value));	
                if(aDate < bDate)
                    return 1;
                if(aDate > bDate)
                    return -1;
                return 0;
            });
        }
        else
        {
            lis.sort(function(a, b) //No I18N
            {
                var aDate = new Date(Number(a.attributes["trashedTime"].value));
                var bDate = new Date(Number(b.attributes["trashedTime"].value));	
                if(aDate < bDate)
                    return -1;
                if(aDate > bDate)
                    return 1;
                return 0;
            });
        }
        jQuery(el).empty();
        for (var i = 0; i < lis.length; i++)
            el.appendChild(lis[i]);
        if(!sortOrder)
        {
            jQuery('#TrashDateSort').removeClass("zr_trashSortDesc").addClass("zr_trashSortAsc");
            jQuery('#TrashStringSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
        }
        else
        {
            jQuery('#TrashDateSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
            jQuery('#TrashStringSort').removeClass("zr_trashSortAsc").addClass("zr_trashSortDesc");
        }
    }
		
    this.searchTrashViewsList = function(type)
    {
        ZDBTrash.TrashType=type;
        if(type !=='All')
        {
            if(type === 'Report')
            {
                jQuery("#ZRTrashSearchIcon").attr("class","ZRSMenuIcon "+'Tabular'+"Icon").show();//no i18n
            }
            else
            {
                jQuery("#ZRTrashSearchIcon").attr("class","ZRSMenuIcon "+type+"Icon").show();//no i18n
            }
            jQuery("#TrashSearchTxtFld").css("width","95px");//no i18n
        }
        else
        {
            jQuery("#ZRTrashSearchIcon").hide();//no i18n
            jQuery("#TrashSearchTxtFld").css("width","120px");//no i18n
        }
    }
		
    this.fetchTrashObjectsListForDB = function(explorer)
    {
        var params = "DBID=" + ZDBClientUI.dbId;//No I18N
        var url = "/ZDBTrashListObjectsForDB.cc?";//No I18N
        var opStatus="ZDBMainLoader";//No I18N
        if(explorer)
        {
                AjaxAPI.sendRequest({URL:url,PARAMETERS:params,METHOD:"GET",
                ONSUCCESSFUNC:this.handleTrashRespDuringExplorerRefresh,
                OPSTATUSID:opStatus,
                DBID:ZDBClientUI.dbId, 
                TRASHTAB: explorer
                });
        }
        else
        {
            AjaxAPI.sendRequest({URL:url,PARAMETERS:params,METHOD:"GET",
            ONSUCCESSFUNC:this.handleTrashViewsListResp,
            OPSTATUSID:opStatus,
            DBID:ZDBClientUI.dbId
            });
        }    
    }  
		
    this.handleTrashRespDuringExplorerRefresh = function(response, requestOptions)
    {
        var trashTab = requestOptions["TRASHTAB"];
        if(ZDBClientUI.selectedTab != trashTab)
        {
            var curTab = ZDBClientUI.selectedTab;
            ZDBClientUI.selectTab(trashTab);
            var tabContent = document.getElementById('TrashViewDiv'); //No I18N
            tabContent.innerHTML = "";
            tabContent.innerHTML = response.responseText;
            ZDBTrash.wholeList = jQuery("#TrashObjectList")[0];
            ZDBTrash.initialCount = $("TrashCount").innerHTML;
            ZDBTrash.dateSortOrder = true;
            ZDBTrash.sortByDateForTrash();
            ZDBTrash.resizeTrashListSize();
            ZDBTrash.searchTrashViewsList(ZDBTrash.TrashType);
            ZDBClientUI.selectTab(curTab);
        }
        ZDBTrash.removeProcessingState();
    }
	  
    this.handleTrashViewsListResp = function(response, requestOptions)
    {
        var TrashTab = jQuery(".TrashTabObj")[0]; //No I18N
        if(!TrashTab)
        {
            trashViewDiv = document.createElement('div');
            trashViewDiv.innerHTML = response.responseText;
            trashViewDiv.setAttribute('id', 'TrashViewDiv');
            trashViewDiv.style.height="inherit";
            var tab = ZDBClientUI.createDummyTab(ZDBClientUI.curDummyViewId--,ZDBI18NMap.g("zrpt.common.js.Trash"),trashViewDiv,"TrashTab", null, null, true); //No I18N
            ZDBClientUI.selectTab(tab);  
            ZDBTrash.wholeList = jQuery("#TrashObjectList")[0];
            ZDBTrash.initialCount = $("TrashCount").innerHTML;
            ZDBTrash.dateSortOrder = true;
            ZDBTrash.sortByDateForTrash();
            ZDBTrash.resizeTrashListSize();
            ZDBTrash.searchTrashViewsList(ZDBTrash.TrashType);
        }
        else
        {
            if(ZDBClientUI.selectedTab != TrashTab)
            {
                ZDBClientUI.selectTab(TrashTab);
            }
            var tabContent = document.getElementById('TrashViewDiv'); //No I18N
            tabContent.innerHTML = "";
            tabContent.innerHTML = response.responseText;
            ZDBTrash.wholeList = jQuery("#TrashObjectList")[0];
            ZDBTrash.initialCount = $("TrashCount").innerHTML;
            ZDBTrash.dateSortOrder = true;
            ZDBTrash.sortByDateForTrash();
            ZDBTrash.resizeTrashListSize();
            ZDBTrash.searchTrashViewsList(ZDBTrash.TrashType);
        }
        ZDBTrash.removeProcessingState();
    }
	  
    this.resizeTrashListSize = function()
    {
        var list = $('TrashObjectListContainer');//No I18N
        if(list)
        {
            var headerHeight;
            if($("ZDBHEADER").style.display == "")
            {
                headerHeight = $("ZDBHEADER").offsetHeight;
            }
            else
            {
                headerHeight = 0;
            }
            var tabHeader = ZDBGlobal.ISNEWLAYOUT ? 'ZRSTabParent' : 'ZDBTabHolder';//NO I18N
            list.style.height = document.body.offsetHeight-(headerHeight+$(tabHeader).offsetHeight+$("TrashHeader").offsetHeight)+"px";
        }
    }
    this.trashRestore = function(objIds, dbId)
    {
        var opStatus = "ZDBMainLoader";//No I18N
        var params = "OBJIDS=" + objIds + "&DBID=" + dbId;//No I18N
        var url = "/ZDBDatabaseActionMI.ma?ZDBACTION=TRASHRESTORE";//No I18N 
        AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
        ONSUCCESSFUNC:this.handleTrashRestoreResponse,
        ONFAILURECLEANUPFUNC:ZDBTrash.removeProcessingState,
        OPSTATUSID:opStatus
        });
    }
	  
    this.removeProcessingState = function(response, requestOptions)
    {
        ZDBTrash.processingEvent = false;
    }
	  
    this.confirmTrashSingleDelete = function(el)
    {
        ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.showinfo.js.deleteprompt"),"ZDBYESNO",{ONCLICK:this.permanentDelete,ELEMENT:el});   //No I18N
    }
	  
    this.permanentDelete = function(clickType, requestOptions)
    {
        if(clickType == "NO")
        {
            ZDBTrash.dehighlightTrashListItem();
            return;
        }
        ZDBTrash.processingEvent = true;
        var opStatus = "ZDBMainLoader";//No I18N
        var el = requestOptions["ELEMENT"];
        var objId = el.attributes["objId"].value;
        var dbId = ZDBClientUI.dbId;
        var params = "OBJIDS=" + objId + "&DBID=" + dbId;//No I18N
        var url = "/ZDBDeleteAction.ma?ZDBACTION=TRASHOBJECTDELETE";//No I18N 
        AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
        ONSUCCESSFUNC:ZDBTrash.handleTrashDeleteResponse,
        ONFAILURECLEANUPFUNC:ZDBTrash.removeProcessingState,
        OPSTATUSID:opStatus
        });

    }
	  
    this.confirmTrashMultipleDelete = function()
    {
        var objsList = jQuery("#TrashObjectList").find("input:checked");//No I18N
        if(objsList.length == 0)
        {
            ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.showinfo.js.plsselviewtodel'), "ZDBERROR", null, ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.del.alert"), null, null, null);//No I18N
        }
        else
        {
            ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.showinfo.js.deleteprompt"),"ZDBYESNO",{ONCLICK:this.deleteSelected});   //No I18N
        }
    }
	  
    this.deleteSelected = function(clickType, requestOptions)	
    {
        if(clickType == "NO")
        {
            ZDBTrash.dehighlightTrashListItem();
            return;
        }
        ZDBTrash.processingEvent = true;
        var opStatus = "ZDBMainLoader";//No I18N
        var objsList = jQuery("#TrashObjectList").find("input:checked");//No I18N
        if(objsList.length != 0)
        {
            var objIds = objsList.map(function(){return this.getAttribute("objId")}).get().join(",")
            var dbId = ZDBClientUI.dbId;
            var params = "OBJIDS=" + objIds + "&DBID=" + dbId;//No I18N
            var url = "/ZDBDeleteAction.ma?ZDBACTION=TRASHOBJECTDELETE";//No I18N 
            AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
            ONSUCCESSFUNC:ZDBTrash.handleTrashDeleteResponse,
            ONFAILURECLEANUPFUNC:ZDBTrash.removeProcessingState,
            OPSTATUSID:opStatus
            });  
        }
    }
	 
    this.handleTrashDeleteResponse = function(response, requestOptions)
    {
        var params = response.getResponseParams();
        var depViews = params["DEPVIEWS"] ? params["DEPVIEWS"] : [];
		var relIds = params["RELIDS"] ? params["RELIDS"] : [];
		var aggFormulaIds = params["FORMULAIDS"] ? params["FORMULAIDS"] : [];
		var objIds = params["OBJIDS"] ? params["OBJIDS"] : [];
		var dbId = params["DBID"] ? params["DBID"] : [];

        if(objIds.length>0 && (depViews.length>0 || relIds.length>0 || aggFormulaIds.length>0))
        {
            ZDBTrash.removeProcessingState();
            ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.showinfo.js.depdelete"), "ZDBYESNO",{ONCLICK:ZDBTrash.depViewDelHandling, DEPVIEWS: depViews, OBJIDS:objIds, DBID: dbId,RELIDS:relIds,FORMULAIDS:aggFormulaIds});//No I18N
            return;
        }
        ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.showinfo.js.delconf")); 
        ZDBTrash.fetchTrashObjectsListForDB(false);
    }
	  
    this.depViewDelHandling = function(clickType, requestOptions)
    {
        if(clickType == "NO")
        {
            ZDBTrash.dehighlightTrashListItem();
            return;
        }
        ZDBTrash.processingEvent = true;
        var opStatus = "ZDBMainLoader";//No I18N
        var depViews = requestOptions["DEPVIEWS"];
        var objIds = requestOptions["OBJIDS"];
        var dbId = requestOptions["DBID"];
		var relIds = requestOptions["RELIDS"];
		var aggFormulaIds = requestOptions["FORMULAIDS"];
		var depViewsStr = depViews.length>0?"&DEPVIEWS="+depViews:"";//No I18N
		var relIdsStr = relIds.length>0?"&RELIDS="+relIds:"";//No I18N
		var aggFormulaIdsStr = aggFormulaIds.length>0?"&FORMULAIDS="+aggFormulaIds:"";//No I18N
		var forceDelete  ="&FORCEDELETE=true"; //No I18N
        var params = "OBJIDS=" + objIds + "&DBID=" + dbId + depViewsStr + relIdsStr + aggFormulaIdsStr + forceDelete;//No I18N
        var url = "/ZDBDeleteAction.ma?ZDBACTION=TRASHOBJECTDELETE";//No I18N 
        AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
        ONSUCCESSFUNC:ZDBTrash.handleTrashDeleteResponse,
        ONFAILURECLEANUPFUNC:ZDBTrash.removeProcessingState,
        OPSTATUSID:opStatus
        }); 
    }
	  
	  this.restore = function(clickType, requestOptions)
	  {
		  if(clickType == "NO")
		  {
			  if(jQuery("#TrashObjectList"[0]))
			  {
				  jQuery('#TrashButtons').find('input[clicked="yes"]').removeAttr('clicked');//No I18N
				  jQuery("#TrashObjectList").find("span[clicked='yes']").removeAttr('clicked');//No I18N
				  ZDBTrash.singleRestoreClicked = false;
				  ZDBTrash.dehighlightTrashListItem();
				  //jQuery("#TrashObjectList li").removeClass("trHighLight");
			  }
			  return;
		  }
                    var opStatus = "ZDBMainLoader";//No I18N
                    var delCol = requestOptions["COLIDS"];
                    var delAggForm = requestOptions["AGGFORMIDS"];
                    var delLookup = requestOptions["RELIDS"];
                    var dbId = requestOptions["DBID"];
                    var objIds = requestOptions["OBJIDS"];
                    var parObjIds = requestOptions["PAROBJIDS"];
                  
                  var lookupIds = delAggForm?"&AGGFORMIDS="+delAggForm:"";//No I18N
                  var formulaIds = delLookup?"&RELIDS="+delLookup:"";//No I18N
                  var colIds = delCol?"&COLIDS="+delCol:"";//No I18N
		  if(delCol || formulaIds || lookupIds || parObjIds)
		  {
                                                          
			  var params = "OBJIDS=" + objIds +","+parObjIds + "&DBID=" + dbId+  colIds + formulaIds + lookupIds; //No I18N
			  var url = "/ZDBDatabaseActionMI.ma?ZDBACTION=RESTOREVIEWS";//No I18N 
		      AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
			                          ONSUCCESSFUNC:ZDBTrash.handleRestoreViewResponse,
			                          ONFAILURECLEANUPFUNC:ZDBTrash.removeProcessingState,
			                          OPSTATUSID:opStatus
			                             });
		  }
		  else
		  {
			  var params = "OBJIDS=" + objIds + "&DBID=" + dbId;//No I18N
			    var url = "/ZDBDatabaseActionMI.ma?ZDBACTION=TRASHRESTORE";//No I18N 
				AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
			                               ONSUCCESSFUNC:ZDBTrash.handleTrashRestoreResponse,
			                               ONFAILURECLEANUPFUNC:ZDBTrash.removeProcessingState,
			                               OPSTATUSID:opStatus
			                               });
		  }
		  
	  }
	  
    this.handleRestoreViewResponse = function(response, requestOptions)
    {
        ZDBClientUI.TBLLIST = null; // to clear cache of tables to list the restore table in lookup
        ZDBMsgBox.showSuccess(response.responseText); //No I18N
        ZDBTrash.fetchTrashObjectsListForDB(false);
        ZDBNavigation.fetchObjectsListForDB(ZDBNavigation.navSelect.value,true); 
        ZDBTrash.removeProcessingState();
    }
	  
	  this.handleTrashRestoreResponse = function(response, requestOptions)
	  {
                            var params = response.getResponseParams();
                            var delColArr = params["DELCOL"];
                            var delAggFormArr = params["DELAGGFORMULA"];
                            var dellookupArr = params["DELRELATION"];
                            var objIds = params["OBJIDS"];
                            var parObjIds = params["PARENTOBJIDS"];
                            var dbId = params["DBID"];
                            var restoreParent = params["PARENTVIEWNAMES"];
                            var columnNames = params["DELCOLNAMES"];
                            var aggFormulaNames = params["DELAGGFORMULANAMES"];
		  if( (restoreParent && (restoreParent.length > 0) ) || (delColArr && (delColArr.length >0) ) || (delAggFormArr && (delAggFormArr.length >0)) || (dellookupArr && (dellookupArr.length >0)) )
		  {   
			  ZDBAlertAPI.showMsg("", "ZDBYESNO",{ONCLICK:ZDBTrash.restore, OBJIDS:objIds,PAROBJIDS: parObjIds, DBID: dbId, COLIDS: delColArr, AGGFORMIDS:delAggFormArr, RELIDS:dellookupArr});//No I18N
			  var zdbMsg = jQuery("#ZDBMSG").append("<div id='outerdiv' style='width:405px; font-size:12px;'></div>");
			  var outerdiv = jQuery("#outerdiv");//no I18n
			  outerdiv.append('<div style="padding-bottom:10px;"><span>'+ZDBI18NMap.g('zrpt.common.showinfo.js.trashnotf')+'</span></div>');
			  jQuery("<div id='innerdiv' style='border: 1px solid #cccccc; max-height:160px;overflow-y:auto;'></div>").appendTo('#outerdiv');
			  if(restoreParent)
			  {
				  var innerdiv = jQuery("#innerdiv");//no I18n
				  innerdiv.append('<div style="padding-bottom:7px;padding-top:7px;"><span style="padding-left:6px;font-weight:bold;">'+ZDBI18NMap.g('zrpt.common.showinfo.js.trashtbledet')+'</span></div>');
				  var parentArr = restoreParent.split(',');
				  for(var i =0; i<parentArr.length; i++)
				  {
					  jQuery("#innerdiv").append('<div style="padding-left:15px;padding-bottom:5px;">'+(i+1)+". "+parentArr[i]+'</div>');//no i18n
				  }
			  }
			  if(delColArr)
			  {
				  var innerdiv = jQuery("#innerdiv");//no I18n
				  innerdiv.append('<div style="padding-bottom:7px;padding-top:5px;"><span style="padding-left:6px;font-weight:bold;">'+ZDBI18NMap.g('zrpt.common.showinfo.js.trashcoldet')+'</span></div>');
				  var colArr = columnNames.split(',');
				  for(var i = 0; i<colArr.length; i++)
				  {
					  jQuery("#innerdiv").append('<div style="padding-left:15px;padding-bottom: 5px;">'+(i+1)+". "+colArr[i]+'</div>');//no I18n
				  }
			  }
                                                          if(delAggFormArr)
			  {
				  var innerdiv = jQuery("#innerdiv");//no I18n
				  innerdiv.append('<div style="padding-bottom:7px;padding-top:5px;"><span style="padding-left:6px;font-weight:bold;">'+ZDBI18NMap.g('zrpt.common.showinfo.js.trashaggformdet')+'</span></div>');
				  var colArr = aggFormulaNames.split(',');
				  for(var i = 0; i<colArr.length; i++)
				  {
					  jQuery("#innerdiv").append('<div style="padding-left:15px;padding-bottom: 5px;">'+(i+1)+". "+colArr[i]+'</div>');//no I18n
				  }
			  }
                                                          if(dellookupArr)
			  {
				  var innerdiv = jQuery("#innerdiv");//no I18n
				  innerdiv.append('<div style="padding-bottom:7px;padding-top:5px;"><span style="padding-left:6px;font-weight:bold;">'+ZDBI18NMap.g('zrpt.common.showinfo.js.trashrelationdet')+'</span></div>');	
                  jQuery("#innerdiv").append('<div style="padding-left:15px;padding-bottom: 5px;">'+ZDBI18NMap.g('zrpt.common.showinfo.js.trashrelationtextdet')+'</div>');//no I18n
			  }
              ZDBTrash.removeProcessingState();
		  }
		  else
		  {
			 ZDBClientUI.TBLLIST = null; // to clear cache of tables to list the restore table in lookup
			 ZDBMsgBox.showSuccess(response.responseText); //No I18N
			 ZDBTrash.fetchTrashObjectsListForDB(false);
			 ZDBNavigation.fetchObjectsListForDB(ZDBNavigation.navSelect.value,true);
		  }
		  
	  }
	  
	 
    this.restoreSelected = function(el)	
    {
        if(ZDBTrash.processingEvent)
        {
            return false;
        }
        else
        {
            ZDBTrash.processingEvent = true;
            var objsList = jQuery("#TrashObjectList").find("input:checked");//No I18N
            if(objsList.length != 0)
            {
                var objIds = objsList.map(function(){return this.getAttribute("objId")}).get().join(",")
                var dbId = ZDBClientUI.dbId;
                var objType;
                var jsonData = ZDBAnalysisCaching.tblColInfo.data;
                for(var i=0;i<objsList.length;i++)
                {
                    objType = DOMUtils.getParentWithAttr(objsList[i],"objType").getAttribute("objType");
                    if(objType == "Table" || objType == "QueryTable")
                    {
                        ZDBAnalysisCaching.tblColInfo = {};
                        ZDBAnalysisCaching.tblColInfo.data = {};
                        ZDBAnalysisCaching.tblColInfo.relModelInfo = {};
                        ZDBAnalysisCaching.tblColInfo.relCount = 0;
                        break;
                    }
                }
                ZDBTrash.trashRestore(objIds, dbId);
            }
            else
            {
                jQuery('#TrashButtons').find('input[clicked="yes"]').removeAttr('clicked');//No I18N
                ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.showinfo.js.plsselviewtorest'), "ZDBERROR", null, ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.restore.alert"), null, null, null);//No I18N
                ZDBTrash.removeProcessingState()
            }
        }
    }
	  
    this.toggleTrashSelection = function(el)
    {
        var trashList = jQuery("#TrashObjectList"); //No I18N
        var lis = trashList.find("input:checkbox").prop("checked",el.checked).parents("[fromtrash='true']"); //No I18N	
        if(lis && lis.length > 0){
            for(var i=0; i<lis.length; i++){
                if(el.checked){
                    jQuery(lis[i]).addClass("trHighLight");
                }
                else{
                    jQuery(lis[i]).removeClass("trHighLight");
                }
            }
        }
    }
	  
    this.checkAllTrashListSelected = function(el)
    {
        var trashList = jQuery('#TrashObjectList'); //No I18N
        var inputList = jQuery(trashList).find("input:checkbox"); //No I18N
        var alltoggled = false;
        for(var i=0; i<inputList.length; i++)
        {
            if(!(inputList[i].checked))
            {
                jQuery("#SelectAllTrashViews")[0].checked = false; //No I18N
                alltoggled = false;
                break;
            }
            else
            {
                    alltoggled = true;
            }
        }
        if(alltoggled)
        {
            jQuery("#SelectAllTrashViews")[0].checked = true;
        }
    }  
}  
	  
	  
	  
	  
	  

	

