//$Id$
//ignorei18n_start
function __ZRSCardPreviewClass() {
    var self = this;
    this.ul = null;
    this.timer = null;
    this.ulCurrentScrollTop = 0;
    this.liOffsetHeight = 0;
    this.liOffsetWidth = 0;
    this.ulOffsetWidth = 0;
    this.ulOffsetHeight = 0;
    this.ulOffsetTop = 0;
    this.keySep = "###";
    this.zuid = 0;
    this.baseKey = 'SNAPSHOT_';
    this.cardImageClassName = "cardImage";
    this.api = "/reportsapi/";
    this.typeToIndex = {
        'Table': '0',
        'QueryTable': '6',
        'AnalysisView': '2',
        'Pivot': '3',
        'SummaryView': '4',
        'Report': '1',
        'Dashboard': '7'
    };
    this.defaultImages = {
        'Table': 'ZR-Table',
        'QueryTable': 'ZR-QueryTable',
        'AnalysisView': 'ZR-AnalysisView',
        'Pivot': 'ZR-Pivot',
        'SummaryView': 'ZR-SummaryView',
        'Report': 'ZR-Report',
        'Dashboard': 'ZR-Dashboard',
        'db': 'ZR-Db'
    };
    this.taggedViewIds = [];
    this.handleViewListScroll = function () {
        self.waitNExecute(self.handleCurrentlyVisibleCards);
    };
    this.handleWindowResize = function () {
        self.waitNExecute(function () {
            if (ZDBGlobal.LANDINGPAGE === 'ZDBHome') {
                setTimeout(self.initializePreviewHandlerForHome, 250);
            } else {
                setTimeout(self.addCardPreviewEvntsNInitialize, 250);
            }
        });
    };
    this.waitNExecute = function (func) {
        clearTimeout(this.timer);
        this.timer = setTimeout(func, 250);
    };
    this.handleCurrentlyVisibleCards = function () {
        self.ulCurrentScrollTop = self.ul.scrollTop;
        var visibleLis = ZDBGlobal.LANDINGPAGE === 'ZDBHome' ? self.ul.querySelectorAll('li[elname="viewEl"]') : self.ul.querySelectorAll('[objid]:not([style*="display: none"])');
        var prevLiVisible = false;
        var viewsToSendInImageReq = [], viewTypes = [], i, len, dbsToSendInImageReq = [], corrDBs = [];
        for (i = 0, len = visibleLis.length; i < len; i++) {
            var curLi = visibleLis[i];
            var liTop = curLi.offsetTop - self.ulOffsetTop;
            var objId = curLi.getAttribute('objId');
            var currentLiVisible = (liTop - self.ulCurrentScrollTop > 0 && liTop < (self.ulCurrentScrollTop + self.ulOffsetHeight)) || (liTop + self.liOffsetHeight < (self.ulCurrentScrollTop + self.ulOffsetHeight));
            if (currentLiVisible && !curLi.getAttribute('snapReqSent')) {
                prevLiVisible = true;
                if (ZDBGlobal.LANDINGPAGE === 'ZDBHome') {
                    var dbId = curLi.getAttribute('dbId');
                    var objType = !objId ? curLi.getAttribute('objType') : 'db';
                    var imageURL = self.getImageURLForObjIDFromLS(objId ? objId : dbId);
                    if (imageURL) {
                        self.updateLiWithImageURL(curLi, imageURL, self.cardImageClassName, objType);
                    } else {
                        self.updateLiWithImageURL(curLi, '', self.defaultImages[objType], objType);
                    }
                    if (objId) {
                        //view
                        viewsToSendInImageReq.push(objId);
                        viewTypes.push(self.typeToIndex[objType]);
                        corrDBs.push(dbId);
                    } else {
                        //dashboard
                        dbsToSendInImageReq.push(dbId);
                    }
                } else {
                    var objInfo = ZDBExpViewHandler.fetchViewListInfo(objId);
                    var objType = objInfo[2];
                    var imageURL = self.getImageURLForObjIDFromLS(objId);
                    if (imageURL) {
                        self.updateLiWithImageURL(curLi, imageURL, self.cardImageClassName, objType);
                    } else {
                        self.updateLiWithImageURL(curLi, '', self.defaultImages[objType], objType);
                    }
                    viewsToSendInImageReq.push(objId);
                    viewTypes.push(self.typeToIndex[objType]);
                    corrDBs.push(ZDBClientUI.dbId);
                }
            } else if (prevLiVisible) {
                break;
            }
        }
        if (viewsToSendInImageReq.length > 0) {
            self.handleObjsWithNoImages(viewsToSendInImageReq, viewTypes, corrDBs);
        }
        if (dbsToSendInImageReq.length > 0) {
            self.handleDBsWithNoImages(dbsToSendInImageReq);
        }
    };

    this.handleDBsWithNoImages = function (dbsToSendInImageReq) {
        var taggedViewIds = self.taggedViewIds.join(',');
        var newDBIds = [];
        for (var i = 0, len = dbsToSendInImageReq.length; i < len; i++) {
            var curDB = dbsToSendInImageReq[i];
            if (taggedViewIds.indexOf(curDB) < 0) {
                newDBIds.push(curDB);
                self.taggedViewIds.push(curDB);
            }
        }
        if (newDBIds.length > 0) {
            ZRSAjax.get(self.api + 'GENSNAPSHOTFORDBS', "DBIDS=" + newDBIds.join(','), {
                successHandler: {
                    func: self.noImageReqSuccessForDB,
                    ctx: self
                },
                failureHandler: {
                    func: self.noImageReqFailureForDB,
                    ctx: self
                },
                errorHandler: {
                    func: self.noImageReqFailureForDB,
                    ctx: self
                },
                noLoader: true
            });
        }
    };

    this.initializePreviewHandlerForHome = function () {
        var placeHolder = document.querySelector('[elname="placeholder"]'); //NO I18N
        var placeHolderClassList = placeHolder.className.split(' ');
        var tabClass = '';
        for (var i = 0, len = placeHolderClassList.length; i < len; i++) {
            if (placeHolderClassList[i].indexOf('grid') > -1) {
                tabClass = placeHolderClassList[i];
                break;
            }
        }
        var tabNum = tabClass.split('-')[0];
        self.ul = placeHolder.querySelector('.' + tabNum + '-grid ul');
        if (self.ul.firstChild) {
            self.initializePrivateVariables(self.ul.firstChild);
            self.initializeEvents();
            self.handleCurrentlyVisibleCards();
        }
    };

    this.addCardPreviewEvntsNInitialize = function (tabNum) {
        if (ZDBClientUI.ISCARDLAYOUT) {
            //heavy calculations cant avoid.
            self.ul = ZDBNavigation.viewListBody.querySelector('[elname="viewHolder"]');
            var li = self.ul.querySelector('[objid]') || self.ul.querySelector('[foldid]');
            self.initializePrivateVariables(li);
            self.initializeEvents();
            self.handleCurrentlyVisibleCards();
        }
    };

    this.initializePrivateVariables = function (li) {
        var liMargin = document.defaultView.getComputedStyle(li);
        self.liOffsetWidth = parseInt(liMargin.width) + parseInt(liMargin.paddingLeft) + parseInt(liMargin.paddingRight) + parseInt(liMargin.borderLeftWidth) + parseInt(liMargin.borderRightWidth) + parseInt(liMargin.marginLeft) + parseInt(liMargin.marginTop);
        self.liOffsetHeight = parseInt(liMargin.height) + parseInt(liMargin.paddingTop) + parseInt(liMargin.paddingBottom) + parseInt(liMargin.borderTopWidth) + parseInt(liMargin.borderBottomWidth) + parseInt(liMargin.marginTop) + parseInt(liMargin.marginBottom);
        self.ulOffsetWidth = self.ul.offsetWidth;
        self.ulOffsetHeight = self.ul.offsetHeight;
        self.ulOffsetTop = self.ul.offsetTop;
        self.zuid = ZDBGlobal.zuID;
    };

    this.initializeEvents = function () {
        self.ul.removeEventListener('scroll', self.handleViewListScroll);
        window.removeEventListener('resize', self.handleWindowResize);
        self.ul.addEventListener('scroll', self.handleViewListScroll);
        window.addEventListener('resize', self.handleWindowResize);
    };

    this.noImageReqSuccess = function (respJSON, requestOptions) {
        var viewIds = requestOptions.VIEWIDS.split(',');
        var dbIds = requestOptions.DBIDS.split(',');
        for (var i = 0, len = viewIds.length; i < len; i++) {
            var viewId = viewIds[i], imgURL;
            var li = self.ul.querySelector('li[objId="' + viewId + '"]');
            var dfsId = respJSON[viewId];
            var imageURL = self.constructImageURLFromDFSID(dfsId, dbIds[i]);

            if (li) {
                if (dfsId)
                    self.updateLiWithImageURL(li, imageURL, self.cardImageClassName);
                else {
                    var objType = ZDBGlobal.LANDINGPAGE === 'ZDBHome' ? li.getAttribute('objType') : ZDBExpViewHandler.fetchViewListInfo(viewId)[2];
                    self.updateLiWithImageURL(li, '', self.defaultImages[objType]);
                }
            }
            self.updateSnapInfoToLocalStorage(viewId, dfsId, imageURL);
        }
    };

    this.updateSnapInfoToLocalStorage = function (viewId, dfsId, imageURL) {
        var viewKey = self.generateKey(viewId);
        if (dfsId)
            __ZRSCardPreviewClass.pushToLocalStorage(viewKey, imageURL);
        else
            __ZRSCardPreviewClass.removeFromLocalStorage(viewKey);
    };

    this.noImageReqFailure = function (response) {
        console.log(response);
    };

    this.noImageReqSuccessForDB = function (respJSON) {
        var dbIds = Object.keys(respJSON);
        for (var i = 0, len = dbIds.length; i < len; i++) {
            var curDB = dbIds[i];
            var li = self.ul.querySelector('li[dbId="' + curDB + '"]');
            var dfsId = respJSON[curDB];
            var imageURL = self.constructImageURLFromDFSID(dfsId, curDB);
            if (li) {
                if (dfsId)
                    self.updateLiWithImageURL(li, imageURL, self.cardImageClassName);
                else {
                    self.updateLiWithImageURL(li, '', self.defaultImages['DB']);
                }
            }
            self.updateSnapInfoToLocalStorage(curDB, dfsId, imageURL);
        }
    };

    this.noImageReqFailureForDB = function (response) {
        console.log(response);
    }

    this.constructImageURLFromDFSID = function (dfsID, dbId) {
        if (!ZDBGlobal.IS_ONPREMISE_BUILD) {
            return 'usersnapshot?ZDBFILEID=' + dfsID + '&ZRZUID=' + self.zuid + '&ISNAMESPACE=DBID' + '&DBID=' + dbId;
        } else {
            return 'zropimagefetch?ZDBFILEID=' + dfsID + '&ZRZUID=' + self.zuid;
        }
    };

    this.handleObjsWithNoImages = function (objIds, objTypes, corrDBs) {
        var taggedViewIds = self.taggedViewIds.join(',');
        var newViewIds = [], newViewTypes = [], newDbs = [];
        for (var i = 0, len = objIds.length; i < len; i++) {
            var objId = objIds[i];
            if (taggedViewIds.indexOf(objId) === -1) {
                newViewIds.push(objId);
                newViewTypes.push(objTypes[i]);
                newDbs.push(corrDBs[i]);
                self.taggedViewIds.push(objId);
            }
        }
        var objs = newViewIds.join(',');
        var dbs = newDbs.join(',');
        if (objs) {
            ZRSAjax.get(self.api + 'GENSNAPSHOTFORVIEWS', 'VIEWIDS=' + objs + '&VIEWTYPE=' + newViewTypes.join(',') + '&DBIDS=' + dbs, {
                successHandler: {
                    func: self.noImageReqSuccess,
                    ctx: self
                },
                failureHandler: {
                    func: self.noImageReqFailure,
                    ctx: self
                },
                errorHandler: {
                    func: self.noImageReqFailure,
                    ctx: self
                },
                VIEWIDS: objs,
                DBIDS: dbs,
                noLoader: true
            });
        }
    };

    this.updateLiWithImageURL = function (liElement, imgURL, className, objType) {
        //In future add small and actual image loading here.
        var viewSnap = liElement.querySelector(".cardHeader").nextSibling;
        if (imgURL) {
            //image URL present
            var imgTag = document.createElement('img');
            imgTag.className = className;
            imgTag.setAttribute('type', objType);
            var isImgTagPresent = viewSnap.firstChild instanceof HTMLImageElement;
            if (isImgTagPresent) {
                var presentImg = viewSnap.firstChild;
                var src = presentImg.src.replace(window.location.protocol + '//' + window.location.hostname + ':' + window.location.port + '/', '');
                if (src === imgURL) {
                    return;
                }
            }
            viewSnap.innerHTML = '';
            viewSnap.appendChild(imgTag);
            viewSnap.prevClass = viewSnap.prevClass ? viewSnap.prevClass : viewSnap.className;
            viewSnap.className = "cardViewLoading";
            imgTag.onload = function (event) {
                var target = event.target;
                var parentHolder = target.parentNode;
                if (parentHolder) {
                    parentHolder.className = parentHolder.prevClass;
                    parentHolder.prevClass = null;
                    target.style.opacity = '1';
                }
            };
            imgTag.onerror = function (event) {
                var eventImage = event.target;
                var eventParent = eventImage.parentNode;
                if (eventParent) {
                    eventParent.className = eventParent.prevClass;
                    var objType = eventImage.getAttribute('type');
                    eventParent.removeChild(eventImage);
                    var svgHTML = '<svg class="svgIcons"><use xlink:href="#' + self.defaultImages[objType] + '"></use></svg>';
                    eventParent.innerHTML = svgHTML;
                }
            };
            imgTag.src = imgURL;
            imgTag.style.opacity = '0';
        }
        liElement.setAttribute('snapReqSent', 'true');
    };

    this.getImageURLForObjIDFromLS = function (objID) {
        var curKey = self.generateKey(objID);
        var imageURL = __ZRSCardPreviewClass.getFromLocalStorage(curKey);
        return imageURL;
    };

    this.generateKey = function (objID) {
        return self.baseKey + self.zuid + self.keySep + objID;
    };

    this.handleSnapshowWMSEvent = function (json) {
        var dbId = json.data.DBID;
        var dfsKey = json.data.DFSKEY;
        var viewId = json.data.VIEWID;
        var imageURL = self.constructImageURLFromDFSID(dfsKey, dbId);
        __ZRSCardPreviewClass.pushToLocalStorage(self.generateKey(viewId), imageURL);
        if (ZDBClientUI.ISCARDLAYOUT) {
            var li = self.ul.querySelector('li[objId="' + viewId + '"]');
            if (li)
                self.updateLiWithImageURL(li, imageURL, self.cardImageClassName);
        }
    };
}

__ZRSCardPreviewClass.pushToLocalStorage = function (key, value) {
    try {
        if (!window.localStorage) {
            return;
        }
        localStorage.setItem(key, value);
    } catch (e) {
        //To avoid NS Errors
        return;
    }
};

__ZRSCardPreviewClass.getFromLocalStorage = function (key) {
    try {
        if (!window.localStorage) {
            return null;
        }
        return localStorage.getItem(key);
    } catch (e) {
        return null;
    }
};

__ZRSCardPreviewClass.removeFromLocalStorage = function (key) {
    try {
        if (!window.localStorage) {
            return;
        }
        localStorage.removeItem(key);
    } catch (e) {
        //To avoid NS Error.
        return;
    }
};
//ignorei18n_end

var ZRSCardPreviewHandler = new __ZRSCardPreviewClass();
