// $Id$ 
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * @author: john-3139
 */

//use https://kangax.github.io/html-minifier/ to convert html to string


//Do not create any more instance of the following class. Use the instance instantiated below.
function __ZRSStringTemplateCreatorClass() {
    this.parentRegex = /({{[^}}]+}})/g;
    this.parentInternalKeyRegex = /([^{{]+)([^}}]+)/i;
    this.conditionalTemplateRegex = /^(for:)|^(if:)/g;
    this.childRegex = /(###[^###]+###)/g;
    this.childInternalKeyRegex = /([^###]+)([^###]+)/i;
    this.div = document.createElement('div');
}

__ZRSStringTemplateCreatorClass.prototype.createTemplateForDynamicData = function (module, templateName, returnString, dynamicModel) {
    ZRSHTMLTemplateStrings["__" + module + "__" + templateName + "__model"] = dynamicModel;
    var template = this.createTemplateForData(module, templateName, returnString);
    delete ZRSHTMLTemplateStrings["__" + module + "__" + templateName + "__model"];
    return template;
};

/*
 * @params: module - the module under which the template is defined.
 * @params: templateName - the name of the template to be created.
 * @params: templateData - The data with which the template should be created.
 *          Should contain the keys used within the template. All placeholder datas are optional.
 * @usage: ZRSStringTemplateCreator.createTemplateForData("YourModuleName", "YourTemplateName")
 *
 *          Template definitions:
 *          '<div __{{divId}}__ onclick="__{{onclickHandler}}__"> __{{for:data:<li style="display:none;">###el###</li>}}__ </div>'
 *          '<div __{{divId}}__ onclick="__{{onclickHandler}}__"> __{{if:data:<li style="display:none;">###el###</li>}}__ </div>'
 *
 * @returns: DOM Element.
 *
 * @constraints:
 *          1. Template should have one parent i.e should either return a <div>, <span> or any valid HTML element as a parent.
 *          2. Only one level of custom template i.e for, if,  are allowed. Multi level hierarchies of custom templates are not supported.
 */

__ZRSStringTemplateCreatorClass.prototype.createTemplateForData = function (module, templateName, returnString) {
    var templateString = ZRSHTMLTemplateStrings["__" + module + "__" + templateName + "__view"];
    var templateData = ZRSHTMLTemplateStrings["__" + module + "__" + templateName + "__model"];
    if (!templateString) {
        throw "Template String not defined";//NO I18N
    }
    var parsedString = this.parseString(templateString, templateData);
    if (returnString) {
        return parsedString;
    }
    this.div.innerHTML = parsedString;
    return this.div.removeChild(this.div.firstChild);
};

__ZRSStringTemplateCreatorClass.prototype.parseString = function (templateString, templateData, processInternalData) {
    var instances;
    //For children custom template use the child regex for else use parent regex. This regex splits the __{{key}}__ or ###key### 
    var regex = (!processInternalData) ? this.parentRegex : this.childRegex;
    //For children custom template use the childInternalKeyRegex or use parentInternalKeyRegex. This regex splits the key from __{{key}}__
    var internalKeyRegex = (!processInternalData) ? this.parentInternalKeyRegex : this.childInternalKeyRegex;
    //This key is used to check if the current split element is a custom template syntax.
    var conditionalTemplateRegex = this.conditionalTemplateRegex;
    while ((instances = regex.exec(templateString)) !== null) {
        var curMatchStartIndex = instances.index;
        var curMatchEndIndex = regex.lastIndex;
        //internalMatch contains the __{{key}}__
        var internalMatch = templateString.substring(curMatchStartIndex, curMatchEndIndex);
        var internalMatchExecArr = internalKeyRegex.exec(internalMatch);
        var dynamicRegex;
        if (internalMatchExecArr) {
            //jsonKey contains the key from __{{key}}__
            var jsonKey = internalMatchExecArr[0];
            conditionalTemplateRegex.lastIndex = 0;
            var conditionalExecResult = conditionalTemplateRegex.exec(jsonKey);
            if (conditionalExecResult) {
                //The current split is a custom template syntax i.e. __{{for:data:template}}__
                templateString = this.handleConditionalTemplates(jsonKey, templateData, templateString, conditionalExecResult[0].replace(":", ""));
            } else {
                if(jsonKey.indexOf('i18n:') != -1) {
                    var i18nKey = jsonKey.split('i18n:')[1];
                    templateString = templateString.replace('{{' + jsonKey + '}}', ZDBI18NMap.g(i18nKey));
                } else {
                    //replaces the __{{key}}__ with the actual keys value.
                    var keyValue = templateData[jsonKey] || '';
                    dynamicRegex = (!processInternalData) ? new RegExp("{{" + jsonKey + "}}", 'i') : new RegExp("###" + jsonKey + "###", "i");
                    templateString = templateString.replace(dynamicRegex, keyValue);
                }
            }
        } else {
            //The data is not given for the matched split. so removing the __{{key}}__
            dynamicRegex = new RegExp(internalMatch, 'i');
            templateString = templateString.replace(dynamicRegex, '');
        }
        regex.lastIndex = 0;
    }
    regex.lastIndex = 0;
    internalKeyRegex.lastIndex = 0;
    return templateString;
};

__ZRSStringTemplateCreatorClass.prototype.handleConditionalTemplates = function (jsonKey, templateData, templateString, conditionalExecResult) {
    //the following regex removes the :data: from __{{for:data:template}}__
    var dynamicRegex = new RegExp(":[\\w]*:", "g");
    var internalMatchKeyData = dynamicRegex.exec(jsonKey);
    var resultantString = '';
    if (internalMatchKeyData) {
        var match = internalMatchKeyData[0];
        //dataKey contains the data from :data: got from dynamicRegex
        var dataKey = match.replace(/:/g, "");
        var templateStringInternal = jsonKey.replace(conditionalExecResult + match, "");
        //based on context the child template will be rendered based on their data.
        switch (conditionalExecResult) {
            case 'for':                     //NO I18N
                var forLoopData = templateData[dataKey];
                for (var i = 0; forLoopData!= null && i< forLoopData.length ; i++) {
                    var curData = forLoopData[i];
                    resultantString += this.parseString(templateStringInternal, curData, true);
                }
                break;
            case 'if':                      //NO I18N
                var ifData = templateData[dataKey];
                if (ifData && ifData.condition) {
                    resultantString += this.parseString(templateStringInternal, ifData.data, true);
                }
                break;
        }
    }
    templateString = templateString.replace("{{" + jsonKey + "}}", resultantString);
    return templateString;
};

var ZRSStringTemplateCreator = new __ZRSStringTemplateCreatorClass();