//$Id$
//ignorei18n_start
function ZRUserAnalytics(options) {
    this.module = null;
    this.USERANALYTICSID = null;
    this.action = null;
    this.subModule = null;
    this.isSuccess = null;
    this.additionalParams = null;
    this.EMAIL = null;
    this.ZUID = null;
    this.loggedInfo = ["USERID,EMAILID,ACTION,MODULE,ISSUCCESS"];
    this.logCount;
    this.timers = null;
    this.limit;

    this.pushUsageToServer = function (action, subModule, module, isSuccess, additionalParams, timerValue)
    {
        //action = the action to be monitored;
        //module = the place of origin of action;
        //isSuccess = whether call made on actions success or failure;
        //additionalParams = any additional information to be logged for specific purposes
        if (!ZDBGlobal.isUserAnalyticsEnabled)
        {
            return;
        }

        if (!module)
        {
            module = this.module;
        }
        if (!isSuccess)
        {
            isSuccess = this.isSuccess;
        }
        if (!action || !subModule || !this.USERANALYTICSID || !this.ZUID || !this.EMAIL || !module || !isSuccess)
        {
            return;
        }
        if (additionalParams && (additionalParams instanceof Object) && (!(additionalParams instanceof Array))) {
            this.additionalParams = this.merge({}, additionalParams);
        }
        this.action = action;
        var date = new Date();
        date = date.getTime();
        var params = {'LOGGERID': this.USERANALYTICSID,
            'USERID': this.ZUID,
            'EMAIL': this.EMAIL,
            'TIMEOFREQUEST': date,
            'ACTION': encodeURIComponent(action),
            'SUBMODULE': encodeURIComponent(subModule),
            'MODULE': encodeURIComponent(module),
            'ISSUCCESS': isSuccess,
            'ADDITIONALPARAMS': this.additionalParams,
            'TIMERVALUE': timerValue
        };
        var userAnalyticsLogPresent = ZDBUtil.getValueFromLocal("ualog");
        var uaLog = userAnalyticsLogPresent ? JSON.parse(ZDBUtil.getValueFromLocal("ualog")) : {};
        var logID = "ualog_" + Math.random().toString(36).substring(2);
        ZDBUtil.deleteValueFromLocal("ualog");
        uaLog[logID] = params;
        ZDBUtil.setValueToLocal("ualog", JSON.stringify(uaLog));
        this.logCount++;
        if (this.logCount >= this.limit) {
            this.pushToServer();
            this.logCount = 0;
            ZDBUtil.setValueToLocal("ualogcount", 0);
            ZDBUtil.deleteValueFromLocal("ualog");
        } else {
            ZDBUtil.setValueToLocal("ualogcount", this.logCount);
        }
    };

    this.pushToServer = function () {
        var urlParam = "PARAMS=" + encodeURIComponent(ZDBUtil.getValueFromLocal("ualog")) + "&LOGGEDINFO=" + this.loggedInfo.toString();
        var url = "/ZRUserAnalytics.ma?ZDBACTION=LOGUSAGE";
        AjaxAPI.sendRequest({URL: url, PARAMETERS: urlParam, ONFAILUREFUNC: function () {
                void(0);
            }
        });
    };

    this.initializeValues = function (options)
    {
        if (!options)
        {
            return;
        }
        this.module = options.MODULE;
        this.USERANALYTICSID = options.USERANALYTICSID;
        this.isSuccess = "NA";
        this.additionalParams = options.ADDITIONALPARAMS;
        this.EMAIL = options.EMAILID;
        this.ZUID = options.ZUID;
        this.timers = {};
        this.limit = options.LIMIT;
        this.logCount = parseInt(ZDBUtil.getValueFromLocal("ualogcount")) || 0;
        for (var op in this.additionalParams) {
            if (this.additionalParams.hasOwnProperty(op)) {
                this.loggedInfo.push(op);
            }
        }
    };
    this.merge = function (object1, object2)
    {
        var temp = {};
        this.combineValues(temp, object1);
        this.combineValues(temp, object2);
        return temp;
    };
    this.combineValues = function (temp, object1)
    {
        for (var val in object1)
        {
            if (typeof object1[val] === 'object')
            {
                if (typeof temp[val] !== 'object')
                {
                    temp[val] = {};
                }
                this.combineValues(temp[val], object1[val]);
            } else if (object1.hasOwnProperty(val))
            {
                temp[val] = object1[val];
            }
        }
    };
    this.initialize = function (options)
    {
        this.initializeValues(options);
    };
    this.initialize(options);
}

ZRUserAnalytics.initialize = function () {
    if (window.ZRUserAnalytics_Options) {
        var tracker_Object = 'ZRUserAnalyticsObject';
        if (window[tracker_Object])
        {
            console.warn('ZRUserAnalytics already Started Successfully');
            void(0); //Already instantiated
        } else
        {
            window[tracker_Object] = new ZRUserAnalytics(window.ZRUserAnalytics_Options);
        }
    } else
    {
        console.warn('ZRUserAnalytics Not Configured');
        //No ZRUserAnalytics Options Included;
        void(0);
    }
};

ZRUserAnalytics.indexes = {
    "ELEMENT": 0,
    "ACTION": 1,
    "SUBMODULE": 2,
    "MODULE": 3,
    "ADDITIONALPARAM": 4,
    "TIMERSTART": 5,
    "TIMEREND": 6
};

ZRUserAnalytics.checkAndPushToServer = function (action, subModule, module, isSuccess, additionalParams, timerStart, timerEnd) {
    //checks whether ZRUserAnalyticsObject is initialised and tries to push to server.
    //action = the action to be monitored;
    //module = the place of origin of action;
    //isSuccess = whether call made on actions success or failure;
    //additionalParams = any additional information to be logged for specific purposes
    //timerStart = boolean param that starts the timer for the specified module
    //timerEnd = boolean param that ends the timer for the specified module
    //NOTE: for a module there many actions that starts the timer and only one action that ends the particular module respectively.
    //if monitoring time is not required pass it as undefined or null.
    var timerValue = null;
    if ((typeof ZRUserAnalyticsObject !== 'undefined') && ZRUserAnalyticsObject instanceof Object && !(ZRUserAnalyticsObject instanceof Array)) {
        if (timerStart) {
            var timer = ZRUserAnalyticsObject.timers[module];
            if (!timer) {
                ZRUserAnalyticsObject.timers[module] = new ZRUserAnalyticsTimer(module);
                ZRUserAnalyticsObject.timers[module].startTimer();
                timerValue = ZRUserAnalyticsObject.timers[module].getTime();
            } else {
                if (timer.timerStarted) {
                    timerValue = ZRUserAnalyticsObject.timers[module].getTime();
                }
            }
        } else if (timerEnd) {
            var timer = ZRUserAnalyticsObject.timers[module];
            if (timer && timer.timerStarted) {
                timerValue = ZRUserAnalyticsObject.timers[module].getTime();
                ZRUserAnalyticsObject.timers[module].stopTimer();
                delete ZRUserAnalyticsObject.timers[module];
            }
        } else {
            var timer = ZRUserAnalyticsObject.timers[module];
            if (timer && timer.timerStarted) {
                timerValue = ZRUserAnalyticsObject.timers[module].getTime();
            } else {
                timerValue = "NA";
            }
        }
    }
    if (!timerValue) {
        timerValue = "NA";
    }
    if ((typeof ZRUserAnalyticsObject != 'undefined') && ZRUserAnalyticsObject instanceof Object && !(ZRUserAnalyticsObject instanceof Array)) {
        ZRUserAnalyticsObject.pushUsageToServer(action, subModule, module, isSuccess, additionalParams, timerValue);
    }
};

ZRUserAnalytics.attachPushCodeToElement = function (arr, module) {
    //el = HTMLElement.
    //action = action to be attached to  element
    //module = module to be attached to each element
    //additionalParams = additional information to be attached to each element for specific purposed only.
    //timerStart = boolean param that starts the timer for the specified module
    //timerEnd = boolean param that ends the timer for the specified module
    //NOTE: for a module there should be only one action that starts and ends the particular module respectively.
    //if monitoring time is not required pass it as undefined or null.
    arr.forEach(function (innerarr, index, basearr) {
        var el = innerarr[ZRUserAnalytics.indexes.ELEMENT];
        var action = innerarr[ZRUserAnalytics.indexes.ACTION];
        var subModule = innerarr[ZRUserAnalytics.indexes.SUBMODULE];
        module = module || innerarr[ZRUserAnalytics.indexes.MODULE];
        var additionalParams = innerarr[ZRUserAnalytics.indexes.ADDITIONALPARAM];
        var timerStart = innerarr[ZRUserAnalytics.indexes.TIMERSTART];
        var timerEnd = innerarr[ZRUserAnalytics.indexes.TIMEREND];
        if (el instanceof Object && el instanceof Array) {//el is an array
            for (var i = 0; i < el.length; i++)
            {
                if (el[i].getAttribute(module) === "attached") {
                    continue;
                }
                jQuery(el[i]).on("click", {action: action, subModule: subModule, module: module, additionalParams: additionalParams, timerStart: timerStart, timerEnd: timerEnd},
                        ZRUserAnalytics.userAnalyticsEventHandler
                        ).attr(module, "attached");

            }
        } else if ((el instanceof Object && !(el instanceof Array)) || (el instanceof HTMLElement)) {//el is an jquery object
            if (!module || jQuery(el).attr(module) === "attached") {
                return;
            }
            jQuery(el).on("click", {action: action, subModule: subModule, module: module, additionalParams: additionalParams, timerStart: timerStart, timerEnd: timerEnd},
                    ZRUserAnalytics.userAnalyticsEventHandler
                    ).attr(module, "attached");
        }
    });
};

ZRUserAnalytics.userAnalyticsEventHandler = function (event) {
    ZRUserAnalytics.checkAndPushToServer(event.data.action, event.data.subModule, event.data.module, null, event.data.additionalParams, event.data.timerStart, event.data.timerEnd);
};

ZRUserAnalytics.removeUserAnalyticsEventHandler = function (el, module) {
    if (el instanceof Object && el instanceof Array) {//el is an array
        for (var i = 0; i < el.length; i++)
        {
            jQuery(el[i]).off("click", ZRUserAnalytics.userAnalyticsEventHandler).attr(module, null);
        }
    } else if ((el instanceof Object && !(el instanceof Array)) || (el instanceof HTMLElement)) {//el is an jquery object
        jQuery(el).off("click", ZRUserAnalytics.userAnalyticsEventHandler).attr(module, null);
    }
};

ZRUserAnalytics.removeUserAnalyticsEventHandlerThroughID = function (id, module) {
    var el = jQuery($(id));
    jQuery(el).off("click", ZRUserAnalytics.userAnalyticsEventHandler).attr(module, null);
};

ZRUserAnalytics.attachPushCodeToId = function (id, action, subModule, module, additionalParams, timerStart, timerEnd) {
    //id = id of HTMLElement.
    //action = action to be attached to  element
    //module = module to be attached to each element
    //additionalParams = additional information to be attached to each element for specific purposed only.
    //timerStart = boolean param that starts the timer for the specified module
    //timerEnd = boolean param that ends the timer for the specified module
    //NOTE: for a module there should be only one action that starts and ends the particular module respectively.
    //if monitoring time is not required pass it as undefined or null.
    var el = jQuery($(id));
    if (el.attr(module) === "attached") {
        return;
    }
    el.on("click", {action: action, subModule: subModule, module: module, additionalParams: additionalParams, timerStart: timerStart, timerEnd: timerEnd},
            ZRUserAnalytics.userAnalyticsEventHandler
            ).attr(module, "attached");
};

function ZRUserAnalyticsTimer(module) {
    this.module = module;
    this.timerValue = 1;
    this.timerController;
    this.timerStarted = false;
    var objRef;
    this.startTimer = function () {
        this.timerStarted = true;
        objRef = this;
        this.timerController = setInterval(this.timeOutFunc, 1000);
    };
    this.timeOutFunc = function () {
        if (objRef.timerValue < 1800) {
            objRef.timerValue++;
        } else {
            objRef.stopTimer();
        }
    };
    this.stopTimer = function () {
        clearInterval(this.timerController);
        this.timerValue = 0;
        this.timerStarted = false;
    };
    this.getTime = function () {
        return this.timerValue;
    };
}

var ZRUserAnalyticsAttacher = new function () {

    this.attachUAToTopBanner = function () {

        var upgradeBar = document.getElementById('ZDBUpgradeBar');
        if (upgradeBar) {
            var anchor = upgradeBar.querySelector('a');
            anchor.addEventListener('click', function (event) {
                    var content = event.target.getAttribute('data-bannerText');
                    ZRUserAnalytics.immediatePushToServer("UpgradeBar", "Banner", "Support", null, {bannerContent: content});//NO I18N
            });
        }
    };

    this.attachUAToAnnouncement = function () {

        var announcementTab = document.getElementById("announcements");
        if(announcementTab){
            var announcementsList = announcementTab.querySelectorAll("li.enable-transition");   //get the list of announcements present
            for(var i=0;i<announcementsList.length;i++){                                        //add on-click event listener to all announcements
                var anAnnouncement = announcementsList[i];
                anAnnouncement.addEventListener('click', this.onAnnouncementClicks);
            }
        }
    };

    this.attachUAToSubAnnouncementLinks = function () {
        var subAnnouncementCard = document.getElementById("notificationCard");
        if(subAnnouncementCard){
            var subAnnouncementCardLinksList = subAnnouncementCard.querySelectorAll(".ZRSLink"); //get the list of links available in sub-announcement card

            for(var i=0;i<subAnnouncementCardLinksList.length;i++){                             //add on-click event listener to all links present in sub-announcement card
                  var link = subAnnouncementCardLinksList[i];
                  link.addEventListener('click',this.onAnnouncementLinkClicks);
            }
        }
    };

    this.onAnnouncementClicks = function(event){
        var aId = GlobalNotification.json[event.currentTarget.getAttribute("data-index")].messageId;
        ZRUserAnalytics.immediatePushToServer("ReadByClick","Announcement","Support",null,{announcementId:aId});  //No I18N
    };

    this.onAnnouncementLinkClicks = function(event){
        var aId = GlobalNotification.json[event.currentTarget.getAttribute("data-index")].messageId;
        var fid = event.target.getAttribute("feature-index")==null?"Footer":event.target.getAttribute("feature-index");
        ZRUserAnalytics.immediatePushToServer("LinkClicks","Announcement","Support",null,{announcementId:aId,featureId:fid})
    };

};

ZRUserAnalytics.immediatePushToServer = function(action, subModule, module, isSuccess, additionalParams){
    if(typeof ZRUserAnalyticsObject != "undefined"){
        var currentLimit = ZRUserAnalyticsObject.limit;
        ZRUserAnalyticsObject.limit = -1;
        ZRUserAnalytics.checkAndPushToServer(action, subModule, module, isSuccess, additionalParams);
        ZRUserAnalyticsObject.limit = currentLimit;
    }
}


//ignorei18n_end
