//$Id$
var ZDBClientUI = new function()
{

  this.curDummyViewId = -10;
  this.loadDivs = {};
  this.typeDefns = {};
  this.tabOrderList=[];

  this.resizeMain = function()
  {
    var el = document.getElementById("ZDBRIGHTDIV");
    el.style.display = "none";
    var height = ZDBUtil.getOffsetSize($("ZDBHEADER"), false) + ZDBUtil.getOffsetSize($("ZDBMAINDIV"), false);
    height = (jQuery(window).height()) - height - 4;
    el.style.height = height + "px";
    el.style.display = "";
  };

  this.resizeDomainHmePage = function()
  {
    var el = jQuery("#ZDBDomainHomePageDiv");   //No I18N
    var headerHeight = jQuery("#ZDBHEADER").height(); //No I18N
    var height = jQuery(window).height() - headerHeight;
    el.css("height",height-5); //5px variant. //No I18N
    var domainListHeight = (height-45); //40px extra variant for Domain list Height - Needs to Find out - Earlier we have set 93% as height of this div.
    jQuery("#ZDBDomainDBList").css("height",domainListHeight); //No I18N
  };
    
  this.loadBaseSVGIcons = function(){
      ZDBLazyLoadUtil.loadExternalSVG('themes/common/svgimages/baseIcons.svg', this.handleSVGSuccess, null, ZDBClientUI);//NO I18N
  };
  this.handleSVGSuccess = function(){
      this.baseSVGLoaded = true;
  };
  this.focusMain = function(event)
  {
    var srcEl = ZDBUtil.getSourceElement(event);
    if(srcEl && srcEl.parentNode)
    {
      return true;
    }

    if(!ZDBClientUI.selectedTab)
    {
      return true;
    }
    var curView = ZDBClientUI.selectedTab.view;
  };


  this.initReferences = function()
  {//Note: initialize only references that are immediately needed!!.
    //Other wise the initial loading will become slow!!
    this.placeHolder = document.getElementById("ZDBPLACEHOLDER");
    this.poweredByEl = document.getElementById("ZDBPoweredByEl");
    this.mainPanel = document.getElementById("ZDBMAINEL");
    this.headerArea = document.getElementById("ZDBHEADER");
    this.dummyGrid = document.getElementById("ZDBDUMMYGRID");
    this.blankView = document.getElementById("ZDBBLANKVIEW");
    this.dummyGraph = document.getElementById("ZDBDUMMYGRAPH");
    this.mainLoader = document.getElementById("ZDBMainLoader");
    this.iPhoneBlankView = document.getElementById("ZDBIPHONEBLANKVIEW");
    this.dummyGraph.parentNode.removeChild(this.dummyGraph);
    
    this.ZRSTabHolder = document.getElementById("ZDBTABCONT");
    this.tabTpl = document.getElementById("ZDBTABTPL");
    this.swipeArea = document.getElementById("ZDBSWIPE");
    this.swipeAreaTD = document.getElementById("ZDBSWIPETD");
    this.responseHolder = document.getElementById("ZDBRESPONSEHOLDER");
    this.viewOption = document.getElementById("ZDBViewOption");
    this.viewList = document.getElementById("ZDBVIEWLISTDIV");
    this.layoutMode = "normal";
    this.navigatable = $("ZDBNAVIGTABLE");
    this.swipeBar = $("ZDBSwipeBar");
    this.pasteArea = $("ZDBPasteArea");

      this.leftArrowWidth = jQuery("#ZR_LeftTabNavArrow").width();// NO I18N
    this.minMaxIconWidth = jQuery("#ZR_MinMaxIcon").width();// NO I18N

    this.rightArrowWidth = jQuery("#ZR_RightTabNavArrow").width();// NO I18N
    this.addTabIconWidth = jQuery("#ZRNewTab").width();// NO I18N
    this.listTabNavArrowWidth = jQuery("#ZR_ListTabNavArrow").width();// NO I18N
  }


  this.resizeAllDInst = function()
  {
    var body = document.body;
    var borderHeight = (this.standAlone)?0:2;
    var insets = 2; // (this.standAlone)?0:2; //dashboard re-sizing issue fix in IPAD for the time being
    var cWidth  = jQuery(window).width()-insets;
    var cHeight = jQuery(window).height()-borderHeight;
    var mainBox = $("ZDBMainBox");
    mainBox.style.margin="auto"; //No I18N
    var tab = ZDBClientUI.selectedTab;
    if(ZDBGlobal.IS_MOBILE && tab && tab.view.type === 'Dashboard') {
        mainBox.style.height=""; //No I18N
    } else {
        jQuery(mainBox).height(cHeight);
    }
    jQuery(mainBox).width(cWidth);

    var headHeight = jQuery("#ZDBHead").height();//No I18N

    if((cHeight == body.prevClientHeight)
    && (cWidth == body.prevClientWidth))
    {
    return;
    }
    body.prevClientHeight = cHeight;
    body.prevClientWidth = cWidth;

    if(tab && tab.view.dialogStatus > 0)
    {
    ZDBClientUI.resizeHolders(false);
    ZDBInlineDialog.resized = true;
    ZDBInlineDialog.resizeDialog();
    if(tab.focusedDialog && tab.focusedDialog.gridObj && tab.focusedDialog.gridObj.type == "TableDesign")
  {
    ZDBClientUI.resizeEditGridHolder();
  }
    return;
    }
    ZDBClientUI.resizeHolders(true);
    if(tab)
    {
      if(tab.view instanceof ZDBDashboard && tab.view.OldDashDivSize)
        {
          tab.view.OldDashDivSize.width = tab.view.dashDiv.clientWidth;
        }
      tab.view.resize();
      ZDBMenu.resizeTitleNDesc(tab.view.toolbar); //Toolbar title resize
      ZDBTabHandler.moveToVisibleArea();
    }
  }

  this.resizeLeftSideNav = function(cHeight)
  {
      var leftNav=jQuery("#ZRSingleLayoutNavTD"); //No I18N
      var footerEl=leftNav.find("[elname='footerElements']:visible");
      var minIcon=leftNav.find('[elname="minmax"]:visible').outerHeight(true);
      var menuHeight=(leftNav.find(".singleLayoutComp.explorerNav:visible").outerHeight(true));
      var availableHeight=cHeight-(jQuery("#ZDBMainHeader").height())-(menuHeight*5)-2; // top 5 menu el   //No I18N
      var requiredHeight=menuHeight*2; //totally 2 menu EL in footer (trash & settings)
      if(availableHeight>requiredHeight)
        {
            footerEl.addClass("positionBottom");
        }
        else
        {
            footerEl.removeClass("positionBottom");
        }
  }

  this.resizeHolders = function(resizePlaceHolder)
  { // Resize order has to be maintained. It should be in the below order only. Else, it won't work in IE
    if(resizePlaceHolder)
    {
         ZDBClientUI.resizePlaceHolder();
    }
    ZDBClientUI.resizeSwipe();
    ZDBClientUI.resizeTabHolder();
    ZDBClientUI.resizeCustomDashboardHeader();
  }

  this.resizeCustomDashboardHeader = function()
  {
    if(window.CustomHomePage)    //CustomHomePage object check
    {
      CustomHomePage.resizeCustomDashboardHeader();
    }
  }

  this.resizeSwipe = function()
  {
      var swipe = ZDBClientUI.swipeArea;
      swipe.style.display = "none";
      var height = ZDBClientUtil.offsetHeight(ZDBClientUI.headerArea) + ZDBClientUtil.offsetHeight($("ZDBNAVIGTABLE")) + ZDBClientUtil.offsetHeight($("ZDBLeftPanelBtm"));
      height = document.body.prevClientHeight - height;
      height += (BROWSER.IE)? 0 : -2;
      swipe.style.display = "";
      swipe.style.height = (height -1) + "px";
      ZDBClientUI.resizeRightExplorerView();
  }

  this.resizeRightExplorerView = function()
  {
    var explorerBand1 = $("ZDBEXPTITLE");
    var explorerBand2 = $("ZDBEXPHEADERROW");
    var lftAndRghtPanel = ["toolbarLeftPor", "toolbarRightPor"];//No I18N
    var toolbarLeftPor = ZDBUtil.getElsWithTagNAttrWithVals(explorerBand2, "elname", lftAndRghtPanel, "div");//No I18N
    if(toolbarLeftPor && toolbarLeftPor.length) {
        toolbarLeftPor[0].style.width = explorerBand2.offsetWidth - toolbarLeftPor[1].offsetWidth - 50 + "px";  
    }
    var rightSideViewListheight = ZDBUtil.getOffsetSize($("ZDBPLACEHOLDER"),false) - (ZDBUtil.getOffsetSize(explorerBand1,false) + ZDBUtil.getOffsetSize(explorerBand2,false));
    rightSideViewListheight += (BROWSER.IE)? 0 : -2;
    var viewList = ZDBClientUI.viewList;
    viewList.style.height = rightSideViewListheight + "px";
  }

  this.positionWorkArea=function()
  {
      var width = 0;
      if((ZDBClientUI.layoutMode == "max" || ZDBNavigation.hiddenState)){
            width = jQuery("#attachedSwipeArea").width(); //No I18N
      }
      jQuery("[elname='graphFieldHolder']").css("left",width+"px"); //No I18N
      jQuery("[elname='workArea']").css("left",width+"px"); //No I18N
  }


  this.resizeTabHolder = function()
  {
    if(this.standAlone!=true)
    {
      var navWidth=(ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState)?0:250; //No I18N
      var documentBodyWidth = document.body.getBoundingClientRect().width;
      var viewAreaWidth = documentBodyWidth - navWidth;

      var tabHolder = document.getElementById("ZDBTabHolder");
      var width = viewAreaWidth;// NO I18N
      if(width > 5)
      {
      var leftArrowWidth = ZDBClientUI.leftArrowWidth;
      var minMaxIconWidth = ZDBClientUI.minMaxIconWidth;
      var leftInsets = 4;
      var leftSpace = leftArrowWidth + minMaxIconWidth + leftInsets;

      var rightArrowWidth = ZDBClientUI.rightArrowWidth;
      var listTabNavArrowWidth = ZDBClientUI.listTabNavArrowWidth;
      var addTabIconWidth = ZDBClientUI.addTabIconWidth;

      var rightinsets = 20;
      var rightSpace = rightArrowWidth + addTabIconWidth + listTabNavArrowWidth + rightinsets;
        tabHolder.style.width = (width-(leftSpace + rightSpace))+"px";
      }
      tabHolder.style.display = "";
    }
  }

  this.resizePlaceHolder = function()
  {
    var body = document.body;
    document.body.style.overflow = "hidden";

    var placeHolder = ZDBClientUI.placeHolder;
    placeHolder.style.display = "none";
    var height = ZDBClientUtil.offsetHeight(ZDBClientUI.headerArea) + ZDBClientUtil.offsetHeight(ZDBClientUI.mainPanel);
    height = body.prevClientHeight - height - 3; // -3 border? otherwise trembling LHS view listing
    if(this.poweredByEl)
    {
      height -= ZDBClientUtil.offsetHeight(this.poweredByEl.parentNode);
    }
    $("ZRDataSheetView").style.display = "";
    placeHolder.style.height = (height)  + "px";
    placeHolder.style.display = "block";
    //var otherSpacer = (ZDBGlobal.integrated) ? 0 : ZDBClientUtil.offsetWidth($("ZDBShowHideNavigIconContainer"));//No I18N
    var navBar = $("ZDBNavigationBarTD");
    var display="";
    if(ZDBClientUI.standAlone || ZDBGlobal.integrated || ZDBClientUI.layoutMode=="max")
    {
        display="none"; //No I18N
    }
    else if(ZDBNavigation.hiddenState && !ZDBNavigation.popOut)
    {
           jQuery(navBar).css({"position":"absolute","z-index":"10000","box-shadow":"0px 4px 10px #666666","left":"-256px"});//No I18N
    }

    navBar.style.display=display;
    ZDBClientUI.mainPanel.style.display = "";
    var width = 2; //TD before the swipe width
    width += (ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState || ZDBClientUI.standAlone || ZDBGlobal.integrated) ? 0 : 250; //No I18N
    var padding = (!ZDBClientUI.standAlone) ? 17 : 2;//here 17 px is the margin left and right
    var view = ZDBClientUI.getViewObj(placeHolder, "view");
    placeHolder.style.width = (document.body.prevClientWidth - width - padding) + "px";
    ZDBClientUI.placeHolderWidth = placeHolder.clientWidth;
    ZDBClientUI.placeHolderHeight = placeHolder.clientHeight;
    if(view && view.type == "QueryTable" && view.editMode && view.editor)
    {
      var editorTD = $("ZDBSQLQueryTxtFldTD");
      var editorEl = editorTD.getElementsByTagName("div")[0];
      var editor = view.editor;
      editor.setSize($("ZDBPLACEHOLDER").offsetWidth, editorEl.offsetHeight);
      ZDBSQLTable.positionResizeEl();
    }
  }

  this.resizeEditGridHolder = function()
  {
  var body = document.body;
  body.style.overflow = "hidden";

  var tab = ZDBClientUI.selectedTab;
  var dlg = tab.focusedDialog;
  var editGridHolder = ZDBClientUI.editGridHolder;

  var height = ZDBClientUtil.offsetHeight(ZDBClientUI.headerArea) + ZDBClientUtil.offsetHeight($("TABSHOLDERPARENT")) + ZDBClientUtil.offsetHeight(dlg.designDIV.dlgTitleBar) + ZDBClientUtil.offsetHeight($("ZREditDesignToolBar"));
  height = body.prevClientHeight - height;

    var navBar = $("ZDBNavigationBarTD");
    var display="";
    display = ((ZDBClientUI.standAlone || ZDBGlobal.integrated  || ((ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState )&& !ZDBNavigation.popOut)))?"none":""; //No I18N
    navBar.style.display=display;
    var width = 2;
    width += (ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState || ZDBClientUI.standAlone || ZDBGlobal.integrated) ? width : 250; //No I18N
    width = (body.prevClientWidth - width - 15 + 2);

  ZDBClientUI.editGridHolderHeight = (height - ZDBGlobal.scrollThick);
  ZDBClientUI.editGridHolderWidth = (width - ZDBGlobal.scrollThick);
  editGridHolder.style.height = ZDBClientUI.editGridHolderHeight + "px";
  editGridHolder.style.width = ZDBClientUI.editGridHolderWidth + "px";
  dlg.gridObj.resizeGrid(ZDBClientUI.editGridHolderWidth,ZDBClientUI.editGridHolderHeight);
  }

  this.replaceInSwipeArea = function(newSwipeComp)
  {
    var oldComp = ZDBClientUI.swipeArea.curComp;
    if(oldComp != newSwipeComp)
    {
      if(oldComp == null)
      {
        ZDBClientUI.swipeArea.appendChild(newSwipeComp);
      }
      else
      {
        ZDBClientUI.swipeArea.replaceChild(newSwipeComp,oldComp);
      }
      ZDBClientUI.swipeArea.curComp = newSwipeComp;
    }
  }

  this.checkIfRespValid = function(tab)
  {
    if(tab.removed) {return false;}
    if(ZDBClientUI.integrated && (ZDBClientUI.selectedTab.view != null)
       && (ZDBClientUI.selectedTab.view.objId != tab.view.objId)){return false;}
    return true;
  }

  this.$$ = function(elName)
  {
    var el = this.$(elName);
    ZDBUtil.removeNonElements(el);
    return el;
  }

  this.$ = function(elName)
  {
    var el = this[elName];
    if(el == null)
    {
      this[elName] = el = document.getElementById(elName);
    }
    return el;
  }


  this.createDummyTab = function(objId,displayName,tabComp,type,objKey,parentViewId)
  {
    var view = new DummyView(objId,displayName,type,tabComp,objKey,parentViewId);
    var tab = this.createTab(view,tabComp);
    this.selectTab(tab);
    return tab;
  }

  this.createEmptyTab = function()
  {
    var tab = this.tabTpl.cloneNode(true);
    ZDBUtil.setNamedChildEls(tab,tab);
    this.$$("ZDBTABCONT").appendChild(tab);
    if(ZDBClientUI.standAlone)
    {
      tab.tabIcon = $("ZDBMainLoader");
      setTimeout(function(){ZDBClientUI.appendTabIconToBody(tab.tabIcon);},1000);
    }
    tab.viewCtx = new ZDBUIViewCtx(tab);
    return tab;
  }

  this.createUpdateDummyTab = function(objId,displayName,type,tab,objKey,parentViewId)
  {
    var dummyViewComp = ZDBClientUI[ZDBClientUI.typeDefns[type].dummyView];
    if(tab == null)
    {
      tab = this.createDummyTab(objId,displayName,dummyViewComp,type,objKey,parentViewId);
    }
    else
    {
      var view = new DummyView(objId,displayName,type,dummyViewComp);
      tab.viewCtx.handle(view);
    }
    return tab;
  }

  this.toCheckIfTabAlreadyOpen = function(objId, displayName, type) {
    if(objId < 0 && ZDBClientUI.tabOrderList.length) {
      for(var i = 0; i < ZDBClientUI.tabOrderList.length; i++ ) {
        var tab = ZDBClientUI.tabOrderList[i];
        var view = tab.view;
        if(view.objId < 0 && view.type == type && view.displayName == displayName) {
          this.selectTab(tab);
          return tab;
        }
      }
      return false;
    }
  }

  this.appendTabIconToBody = function(tabIcon)
  {
    if(tabIcon.parentNode != document.body)
    {
      document.body.appendChild(tabIcon);
    }
  }

  this.isObjectInView = function(objId)
  {
    var tabNameList=ZDBContentCache.appendAndGet("Tab_List","GridMenu",document.body);
    if(tabNameList.parentNode != document.body){document.body.appendChild(tabNameList);}
    ZDBUtil.setNamedChildEls(tabNameList,tabNameList,"item");
    ZDBUtil.removeAllChildren(tabNameList.tbody);
    var tabs = this.$$("ZDBTABCONT").childNodes;
    for(var i=0; i< tabs.length; i++)
    {
      if(tabs[i].view.objId == objId)
      {
        return true;
      }
    }
    return false;
  }

  this.selectTabFromList = function(el)
  {
    ZDBMenuUtil.closeMenu();
    var element = DOMUtils.getParentWithTagName(el, 'li'); //No I18N
    var tab = element.tabRef;
    ZDBClientUI.selectTab(tab);
    ZDBClientUI.resizePlaceHolder();
    tab.view.resize(true);
  }

  this.removeTabFromList = function(el,event)
  {
    ZDBMenuUtil.closeMenu();
    var element = DOMUtils.getParentWithTagName(el, 'li'); //No I18N
    var tab = element.tabRef;
    ZDBTabHandler.removeSelectedTab(tab,event);
  }

  this.createTab = function(view,comp)
  {
    if(jQuery("#ZDBTABCONT").children().length==2){jQuery("#ZR_MovableAddNewTab").removeClass("movableAddNewTabGreen").addClass("movabaleAddNewTabGrey");}
    var tab = ZDBClientUI.createEmptyTab();
    this.initializeTab(tab,view,comp);
    ZDBClientUI.tabOrderList.push(tab);
    return tab;
  }
  
  this.selectTabEl = function(el, event)
  {
    var parNode = DOMUtils.getElOrParentWithAttr(el,"parTab");//NO I18N
    this.selectTab(parNode);
  var x = setTimeout(function(){ZDBTabSwitchHandler.executeMatchedFuncsInQ(parNode.view);},1000);
    ZDBUtil.stopEventBubble(event);
    if(ZDBNavigation.popOut)
    {
       ZDBNavigation.popInNavigation(true);
  }

  }
  this.openedViewsObjId = [];
  this.fetchViewEl = function(el,event,dnthighlight)
  {
    ZDBMenuUtil.closeMenu();
    ZDBUtil.stopEventBubble(event);
    if(ZDBDashboardAPI.modeHelper.isInNavigDragMode())//Bad Fix - Cosmic. To be removed!!.
    {
      return;
    }

    var parNode = DOMUtils.getSelfOrParentWithAttr(el,"objId");//NO I18N
    if(!dnthighlight)
    {
    ZDBNavigation.deHighlightListItem(parNode);
    }
    var objId = parNode.getAttribute("objId");
    // To remove template notifications
    ZDBClientUI.isChartViewed = false;
    //if(jQuery(el.parentNode.parentNode.children).hasClass('zr-op-newLeft'))
    	if(jQuery(el).find('span.zr-op-newLeft').length!=0)
    {
      ZDBClientUI.isChartViewed = true;
      jQuery(el.parentElement.parentElement.children).remove('span.zr-op-newLeft'); //NO I18N
      ZDBGlobal.templateNotifyObjIds = ZDBClientUI.removeObjId(objId);
      ZDBTemplateList.showNewIconNotification(ZDBGlobal.templateNotifyObjIds);
    } 
    
    if(typeof ZDBExpViewHandler !="undefined"){
      //For client portal case ZDBExpViewHandler is not loaded.
      var viewInfo = ZDBExpViewHandler.fetchViewListInfo(objId);
      var dbId = ZDBClientUI.dbId;
    }
    else{
      //Client portal - tabbed view case (No left side panel and secondary js file is not loaded)
      //All values are in attribute - there is no attibute called dispname - compied old code
      //dbId - multiple views from different databases will be listed
      //# reference - To be modified
      var viewInfo = [objId, parNode.getAttribute("dispname"), parNode.getAttribute("objtype")];
      var dbId = DOMUtils.getParentWithAttr(parNode,"dbid").getAttribute("dbid");
    }
    var dispName = viewInfo[1];//ZDBExpViewHandler.VIEW_NAME

    var tab = ZDBClientUI.getExistingTab(objId);
    if(tab != null)
    {
      this.selectTab(tab);
      return;
    }
    var type = viewInfo[2]; //ZDBExpViewHandler.VIEW_TYPE
    this.fetchView(objId,dbId,dispName,type,null);
  }

  this.removeObjId = function(objId)
  {
    var objIds = jQuery.grep(ZDBGlobal.templateNotifyObjIds, function(value) {
        return value != objId;
      });
    return objIds;
  }

  this.fetchView = function(objId,dbId,dispName,type,tab,objKey,parentViewId)
  {
    var tab = this.createUpdateDummyTab(objId,dispName,type,tab,objKey,parentViewId);
    ZDBClientUI.typeDefns[type].fetchView(objId,tab.viewCtx);
  }



  this.createView = function(dbId,parentViewId,parDispName,type,tab)
  {
    ZDBMenuUtil.closeMenu();
    if(type == "AnalysisView" || type == "Pivot" || type == "SummaryView")
    {
      if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ZDBAnalysisEditList","ChartTPVendors","ZRJSChartsList","ZAVMFilterList","zdbjs/analysisedit/ZDBFieldsView.js","ZAAnalysisFields"],"APPENDTODOC",ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab]))
      {
        return;
      }
      urls = ["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_VMFILTERSTYLES"];//NO I18N
      if(!ZDBLazyLoadUtil.loadCssOnly(urls, "APPENDTODOC", ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab]))
      {
        return;
      }
      if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab]))
      {
        return;
      }
    }
    else if(type == "Report" || type == "QueryTable")
    {
      if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBGridList", "ZRQueryEditor"],"APPENDTODOC",ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab])) //NO I18N
      {
        return;
      }
      if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_QUERYEDITOR", "CSSLIST_GRIDSTYLES", "CSSLIST_VMFILTERSTYLES"],"APPENDTODOC",ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab])){
        return
      }
    }

    var viewName = ZDBI18NMap.g(ZDBClientUI.typeDefns[type].newName);
    tab = ZDBClientUI.createUpdateDummyTab(ZDBClientUI.curDummyViewId--,viewName,type,tab);
    tab.view.parentViewId = parentViewId;
    ZDBClientUI.typeDefns[type].createView(tab.viewCtx,type,dbId,parentViewId,parDispName,
                                           tab.view.objId);
    }


  this.updateViewInTab = function(view,tab)
  {
    ZDBClientUI.initializeTab(tab,view,view.viewComp);
    ZDBClientUI.selectTab(tab);
  }


  this.getExistingTab = function(objId)
  {
    if(objId == null){objId = "";}
    if(!this.$$("ZDBTABCONT"))
    {
      return null;
    }
    var childNodes = this.$$("ZDBTABCONT").childNodes;
    for(var i=0,j = childNodes.length; i < j; i++)
    {
      var child = childNodes[i];
      if((child.getElementsByTagName) && (child.view.objId == objId))
      {
        return child;
      }
    }
  }

  this.updateLayout =function(tab)
  {
  var view = tab.view;
//    if(view.type=="QueryTable" && !ZDBClientUI.standAlone)
//    {
//      if(!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList","APPENDTODOC",null)){
//        return;
//    }else{
//      ZDBSQLTable.appendSQLFunctionList();
//    }
//    }
    ZDBUtil.removeNonElements(this.placeHolder);
    this.placeHolder.className = "alpha0";
    var newComp = tab.comp;
    if(!newComp)
    {
      return; //"design view fix"
    }

    ZDBMenu.updateToolbar(view);

    var oldComp = this.placeHolder.oldComp; //this.placeHolder.firstChild;
    if(oldComp && oldComp.parentNode != this.placeHolder)
    {
      oldComp = null;
    }

    if(oldComp != newComp)
    {
      if(oldComp != null)
      {
        this.placeHolder.replaceChild(newComp,oldComp);
      }
      else
      {
        this.placeHolder.appendChild(newComp);
      }
      this.placeHolder.oldComp = newComp;
      this.resizePlaceHolder();
      view.setScrollPosition(false);
    }
    this.placeHolder.className = "showView100";
    if(ZDBClientUI.isRemoteDB && view.type == "Explorer" &&
      ZDBClientUI.dbConfig.rdbView && ZDBClientUI.dbConfig.rdbView.mismatchCount)
    {
      RDBPage.showMismatchInExp(ZDBClientUI.dbConfig.rdbView.mismatchCount);
    }
  }

  this.updateDisplayName = function(tab,displayName,desc)
  {
    var headerEl = tab.tabHeader;
    jQuery(headerEl).attr("tip",displayName).bind("mouseover",function(event){ZDBToolTip.checkLengthAndShow(this,event);}).bind("mouseout",function(){ZDBToolTip.hide(this);});//No I18N
    headerEl.innerHTML = ZDBEscapeUtil.encodeForHtml(displayName);
    headerEl.style.maxWidth = 150 + 'px';//NO I18N
    var view = tab.view;
    if(!view.dialogStatus || view.dialogStatus == 0)
    {
        view.displayName = displayName;
        if(desc)
        {
          view.description = desc;
        }
        if(view.toolbar)
        {
          ZDBMenu.updateViewTitleNDesc(view);
        }
    }
  }

  this.selectTab = function(tab)
  {
    ZRSMenu.closeAllMenu();
    if(tab!=ZDBNavigation.explorerTab)
    {
    var indexOfTab=ZDBClientUI.tabOrderList.indexOf(tab);
    var len =ZDBClientUI.tabOrderList.length;
    if(indexOfTab!=len-1){ //if the opening view is not in top
       ZDBClientUI.tabOrderList.splice(indexOfTab, 1);
       ZDBClientUI.tabOrderList.push(tab);
    }
    }
    if(tab != this.selectedTab)
    {
        this.unselectTab();
    }

    var childEls = null;

        childEls = this.$$("ZDBTABCONT").childNodes;


    for(var i=0;i < childEls.length; i++)
    {
      if( childEls[i].view.type == "NewOption" ) {
        if(childEls[i].view.displayName == ZDBI18NMap.g("zrpt.common.js.newReport")) {
          childEls[i].className = "AnalysisViewObj " + ((childEls[i] == tab)?
                        "tabSelected":"tabNotSelected");    //No I18N
        }
        else if(childEls[i].view.displayName == ZDBI18NMap.g("zrpt.common.js.newTable")){
          childEls[i].className = "TableObj " + ((childEls[i] == tab)?
                        "tabSelected":"tabNotSelected");    //No I18N
        }
      }
      else {
          childEls[i].className = childEls[i].view.type + "Obj " + ((childEls[i] == tab)?
                    "tabSelected":"tabNotSelected");
      }
    }
    if(!ZDBGlobal.integrated)
    {
      var title =  ZDBGlobal.EXPBROWSERTXT + " - ";
      title += tab.tabHeader.getAttribute("tip");
      document.title = title;
    }

    this.updateLayout(tab);
    ZDBClientUI.selectedTab = tab;
    ZDBClientUI.navigatable.view = tab.view;
    tab.view.setVisible();
    if(tab == ZDBNavigation.explorerTab)
    {
        jQuery("#ZRViewSelectedInNav").attr("id", ""); //No i18N
    }
    ZDBClientUI.resizeRightExplorerView();
    this.modeHelper.selectTab();
    var curView = tab.view;
    var viewType = curView.type;
    if(window.ZDBDataGrid && curView instanceof ZDBDataGrid)
    {
      curView.onFocus(null, false);
    }

    if(curView.dialogStatus > 0)
    {
        ZDBInlineDialog.showOrHideInlineDlgDiv(tab,true);
        hideCustomMessage();
    }
    var modeChanged = (tab.layoutMode != ZDBClientUI.layoutMode);
    ZDBNavigation.showOrHideNavIcon(curView,modeChanged);
    tab.layoutMode = ZDBClientUI.layoutMode;
    if( curView.editMode && (viewType == "AnalysisView" || viewType == "Pivot" || viewType == "SummaryView"))
    {
      curView.checkNSendTblColInfoReq();
    }
  }

  this.unselectTab = function()
  {
    var oldTab = ZDBClientUI.selectedTab;
    ToolTip.hide();
    ZDBMenuUtil.closeMenu();

    if(oldTab && oldTab.view.dialogStatus > 0)
    {
        hideCustomMessage();
        ZDBInlineDialog.showOrHideInlineDlgDiv(oldTab,false);
    }

    var view = null
    if(oldTab!=null)
    {
      view = oldTab.view;
      view.setScrollPosition(true);
      view.setHidden();
    }

    ZDBClientUI.selectedTab = null;
  }

  this.newViewAdded = function(view)
  {
    var tab = view.viewCtx.tab;
    ZDBClientUI.updateDisplayName(tab,view.displayName);
    if(tab.isDialog)
    {
      return;
    }
    ZDBClientUI.selectTab(tab);
    ZDBNavigation.refreshExplorer();
  }

    this.removeTabEl = function(el)
    {
      var tab = DOMUtils.getSelfOrParentWithAttr(el,"parTab");//NO I18N
      if(tab==null)
      {
        tab=el;
      }
      if(!this.checkAskSaveView(tab.view,ZDBI18NMap.g("zrpt.common.analysis.js.closing"),this))
      {
        return;
      }
      this.removeTab(tab);
    }

    this.removeTab = function(tab)
    {
      tab.removed = true;
      if(!ZDBGlobal.integrated)
      {
          var index=ZDBClientUI.tabOrderList.indexOf(tab);
          ZDBClientUI.tabOrderList.splice(index, 1);
            if(ZDBClientUI.selectedTab != ZDBNavigation.explorerTab)
            {
                var nextTab = ZDBClientUI.tabOrderList[ZDBClientUI.tabOrderList.length-1]
                nextTab = (nextTab==null) ? ZDBNavigation.explorerTab : nextTab;
                this.selectTab(nextTab);
            }
      }
      else
      {
        ZDBClientUI.unselectTab();
      }
      ZDBTabSwitchHandler.deleteViewInQ(tab.view);
      ZDBTabSwitchHandler.clearWMSQueue(tab.view);
      tab.parentNode.removeChild(tab);
      tab.view.removeView();
      tab.view = null;

          ZDBTabHandler.moveToVisibleArea();

            if(jQuery("#ZDBTABCONT").children().length==2)
            {jQuery("#ZR_MovableAddNewTab").removeClass("movabaleAddNewTabGrey").addClass("movableAddNewTabGreen");}//No I18N


    }

    this.trashView = function(clickType, requestOptions)
    {
      var el = requestOptions["ELEMENT"];
      var objId = (el) ? el.getAttribute("objId") : requestOptions["OBJID"];    //No I18N
      var viewInfo = ZDBExpViewHandler.fetchViewListInfo(objId);
      var objName = viewInfo[ZDBExpViewHandler.VIEW_NAME];
      var objType = viewInfo[ZDBExpViewHandler.VIEW_TYPE];
      if(clickType == "NO")
      {
        return;
      }
      AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=MOVEOBJECTTOTRASH",
                                 PARAMETERS:"OBJID="+objId+"&CHECKVIEWDEP=true",
                                 ONSUCCESSFUNC:ZDBClientUI.resourceRemoved,
                                 OBJID:objId,OBJNAME:objName,OBJTYPE:objType,
                                 OPSTATUSID:"ZDBMainLoader"});
    }


    this.trashObject = function(el)
    {
      var viewId = el.getAttribute("objId");
      var viewName = ZDBExpViewHandler.getviewListData(viewId, ZDBExpViewHandler.VIEW_NAME);
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.delObjConfirm",ZDBEscapeUtil.encodeForHtml(viewName)),"ZDBYESNO",{ONCLICK:this.trashView,ELEMENT:el});   //No I18N
    }

    this.trashObj = function(clickType, requestOptions)
    {
      if(clickType == "NO")
      {
        return;
      }
      var arr = requestOptions["OBJIDS"];
      var objId = requestOptions["OBJID"];
      var type = requestOptions["OBJTYPE"];
      ZDBExpViewHandler.removeElFromExpView(objId,arr);
      AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=MOVEOBJECTTOTRASH",
                           PARAMETERS:"OBJID=" + objId + "&CHECKVIEWDEP=false&OBJIDS=" + arr,
                           ONSUCCESSFUNC:ZDBClientUI.resourceRemoved,
                           OBJID:objId,OBJTYPE:type});
    }

    this.resourceRemoved = function(response,requestOptions)
    {
      var params = response.getResponseParams();
      var refTablesStr = (params["REFTABLES"]);
      var objType = requestOptions["OBJTYPE"];
      var objId = requestOptions["OBJID"];
      var arr = (refTablesStr.length > 0) ? refTablesStr.split(",") : [];
      if(arr.length > 0)
      {
        var title = ZDBI18NMap.g('zrpt.common.analysis.errmsg.js.refErrDlgTtl');
        var innerHTML = "<br><b>"+ZDBI18NMap.f("zrpt.common.analysis.errmsg.js.delTblWithRefObjErr",ZDBEscapeUtil.encodeForHtml(requestOptions["OBJNAME"]))+"</b><br>";
        for(var i = 0; i < arr.length; i++)
        {
          innerHTML = (i == 0) ? (innerHTML + ZDBEscapeUtil.encodeForHtml(arr[i])) : (innerHTML + ", " + ZDBEscapeUtil.encodeForHtml(arr[i]));
        }
        ZDBUtil.showRefErr(innerHTML,title);
        return;
      }
      var depViewsStr = (params["DEPVIEWS"]);
      arr = (depViewsStr.length > 0 ) ? depViewsStr.split(",") : [];
      var type = requestOptions["OBJTYPE"];
      if(arr.length > 0)
      {
        ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.delTblWithDepViewConfirm",type.toLowerCase()), "ZDBYESNO",
                          {ONCLICK:ZDBClientUI.trashObj,OBJIDS:arr,OBJID:requestOptions["OBJID"],OBJTYPE:type});
        return;
      }
     ZDBExpViewHandler.removeElFromExpView(objId,"");
      var objIdsStr = (params["OBJIDS"]);
      var objIds = (objIdsStr.length > 0 ) ? objIdsStr.split(",") : [];
      ZDBClientUI.removeObjects(objIds);
      var trashViewDiv = document.querySelector("#ZDBTABTPL.TrashTabObj") //No I18N
      if(trashViewDiv)
      {
        ZDBTrash.fetchTrashObjectsListForDB(trashViewDiv);
      }
      if(objType == "Table" || objType == "QueryTable")
      {
        ZDBClientUtil.deleteJsonForObjId(objId);
      }
    }

  this.removeObjects = function(objIds)
  {
  ZDBClientUI.TBLLIST = (objIds.length > 0) ? null : ZDBClientUI.TBLLIST;
    var childNodes = ZDBClientUI.$$("ZDBTABCONT").childNodes;
    for(var i=0; i < childNodes.length; i++)
    {
      var child = childNodes[i];
      for(var k = 0; k < objIds.length; k++)
      {
        var objId = objIds[k];
        if(child.view.objId == objId)
        {
          ZDBClientUI.removeTab(child);
          i--;
          break;
        }
      }
    }
  }

  this.showDlgToSaveModViews = function() {
    if(!ZDBLazyLoadUtil.loadSnippet("ZDBUNSAVEDVIEWS_DLG","/ZDBUnsavedList.cc",ZDBClientUI,"APPENDTODOC"))
      {
        return true;
      }
      var tabs = ZDBClientUI.$$("ZDBTABCONT").childNodes;
      var unsavedTabs = [], unSavedTabList = ""; modified = false;
      var unSavedListCon = ZDBUtil.getCachedRef(ZDBClientUI, 'unSavedListContainer');
      var unsavedViewtemp = jQuery(".alertViewList"); //No I18N
      var unSavedList = jQuery(unSavedListCon).find(".unsavedListAlert").empty();
      for(var i=0;i < tabs.length;i++)
      {
        if(tabs[i].view.modified != 0)
        {
          var viewtemp = unsavedViewtemp.clone();
          unsavedTabs.push(tabs[i]);
          viewtemp.find(".viewTypeIcon").addClass(tabs[i].view.type);
          viewtemp.find(".ZDBExpData").text(tabs[i].view.displayName);
          unSavedList.append(viewtemp[0]);
          modified = true;
        }
      }
      if(unsavedTabs.length == 1)
      {
        ZDBTabHandler.removeSelectedTab(unsavedTabs[0]);
      }
      else{
          var title = ZDBI18NMap.f("zrpt.common.js.SaveAll");
          ZDBDialogUtil.showDialog(unSavedListCon,{TITLE: title, ADDFRAME:true, MODAL: true});
      }
  }

 this.onBeforeWindowUnLoad = function()
  {
    if(ZDBClientUI.dontCheckForModified == true)
    {//This is for QA - In order to refresh and proceed to next test case with out stopping.
      return;
    }
    var tabs = ZDBClientUI.$$("ZDBTABCONT").childNodes;
   var modified = false;
    if(ZDBClientUI.modified)
    {
        modified = true;
    }
    for(var i=0;i < tabs.length;i++)
    {
      if(tabs[i].view.modified != 0)
      {
        modified = true;
        break;
      }
    }

    if(modified)
    {
        return "\n "+ZDBI18NMap.g("zrpt.common.browser.js.unsavedInformationErr")+" \n";
    }
  }

  this.checkAskImgSave = function(view,operation,obj,label,func)
  {
     if(func == null)
     {
      func =  arguments.callee.caller;
     }
     var args = func.arguments;
     if(!args)
     {
        args = [];
     }
     if(func.OPTION != null){return func.OPTION;}
     if(view.modified != 0 && !ZDBGlobal.integrated)
     {
       args = LangUtils.cloneArray(args);
       ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.analysis.js.save2ExportConfirmMsg")
                           ,"ZDBYESNO",{ONCLICK:this.handleImgExportSaveOption,OWNEROBJECT:obj,FUNC:func,
                                                            ARGS:args,LABEL:label,VIEW:view},
                           view.displayName + " "+ZDBI18NMap.g("zrpt.common.analysis.js.isModified"));
       return false;
     }
     return true;
  }
  this.checkAskReorderSave = function(view,operation,obj,label,func){
    if(func == null)
       {
        func =  arguments.callee.caller;
       }
       var args = func.arguments;
       if(!args)
       {
          args = [];
       }
       if(func.OPTION != null){return func.OPTION;}
       if(view.modified != 0 && !ZDBGlobal.integrated)
       {
         args = LangUtils.cloneArray(args);
         ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.analysis.js.altering")
                             ,"ZDBYESNO",{ONCLICK:this.handleImgExportSaveOption,OWNEROBJECT:obj,FUNC:func, // NO I18N
                                                              ARGS:args,LABEL:label,VIEW:view},
                             view.displayName + " "+ZDBI18NMap.g("zrpt.common.analysis.js.isModified"));
         return false;
       }
       return true;
  }

  this.handleImgExportSaveOption = function(clickType,requestOptions)
   {

     if(clickType == "YES")
     {
       requestOptions["HANDLESAVE"] = ZDBClientUI.invokeAfterOption;
       requestOptions["VIEW"].save(requestOptions);
     }
   }


  this.checkAskSaveView = function(view,operation,obj,label)
  {
    if(view == null){return true;}
    return this.checkAskSave(view,operation,obj,label,arguments.callee.caller);
  }

  this.checkAskSave = function(view,operation,obj,label,func)
  {
    if(func == null)
    {
      func =  arguments.callee.caller;
    }
    var args = func.arguments;
    if(!args)
    {
        args = [];
    }

    if(func.OPTION != null){return func.OPTION;}

    if(ZDBUtil.isViewModified(view))
    {
      args = LangUtils.cloneArray(args);
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.operationOnModifiedViewConfirm",operation) +" ?","ZDBSAVE",{ONCLICK:this.handleSaveOption,OWNEROBJECT:obj,FUNC:func, ARGS:args,LABEL:label,VIEW:view},view.displayName + " "+ZDBI18NMap.g("zrpt.common.analysis.js.isModified"));  //No I18N
      return false;
    }
    return true;
  }

  this.handleSaveOption = function(clickType,requestOptions)
  {
    if(clickType == "NO")
    {
      if(requestOptions["VIEW"].clearModified && requestOptions["VIEW"].type !== "Dashboard")
      {
        requestOptions["VIEW"].clearModified();
      }
      else
      {
        //console.error("Clear modified has not been implemented for this view!!");
        //alert("Clear modified has not been implemented for this view!!");
      }
      if(requestOptions["VIEW"].refError)
      {
      requestOptions["VIEW"].refError = false;
      }
      ZDBClientUI.invokeAfterOption(requestOptions);
    }
    else if(clickType == "YES")
    {
      requestOptions["HANDLESAVE"] = ZDBClientUI.invokeAfterOption;
      requestOptions["VIEW"].save(requestOptions);
    }
  }

  this.invokeAfterOption = function(requestOptions)
  {
    var func = requestOptions["FUNC"];
    try
    {
      func.LABEL = requestOptions["LABEL"];
      func.OPTION = true;
      func.apply(requestOptions["OWNEROBJECT"],requestOptions["ARGS"]);
    }
    finally
    {
      delete func.LABEL;
      delete func.OPTION;
    }

  }

  this.getParentViewId = function(objId)
  {

    var pTabView = ZDBClientUI.selectedTab.view;

    if((pTabView.objId!=null && pTabView.parentViewId == null) || objId!=null)
    {
      var objectId = (objId!=null)?objId:pTabView.objId;
      var objectLink = $("OBJ_"+objectId);
      if(objectLink)
      {
        var parentTR = DOMUtils.getParentWithAttr(objectLink,"parentviewid");
        var parentViewId = parentTR.getAttribute("parentviewid");
      }
    }

    if(pTabView.parentViewId != null)
    {
      var parentViewId = pTabView.parentViewId;
    }

    return parentViewId;
  }




  this.getSelectedViewIndex = function()
  {
    return this.viewOption.selectedIndex;
  }


  /**
   * An internal method. Maybe unnecessary complexity??
   */
  this.initializeTab = function(tab,view,comp)
  {
    if((tab.view != null) && (tab.view != view))
    {
      tab.view.removeView();
    }
    view.viewCtx = tab.viewCtx;
    tab.view = view;
    view.tab = tab;
    tab.comp = comp;
    if(view.displayName && !tab.viewCtx.isZia)
    {
      this.updateDisplayName(tab,view.displayName);
    }

    tab.viewCtx.updateModified();
  }

    this.dBTypeJSON="";

  this.attachedSwipeArea = function()
  {
    ZDBClientUI.swipeArea.style.display="";
    var attachedSwipeArea = $("attachedSwipeArea");
    attachedSwipeArea.appendChild(ZDBClientUI.swipeArea);
    attachedSwipeArea.style.display="";
    var view = ZDBClientUI.selectedTab.view; // to be fixed
    view.eModeHelper.setFieldsDimension(view);
  }

  this.navPanelSwipeArea = function()
  {
    ZDBClientUI.swipeArea.style.display="";
    var attachedSwipeArea = $("attachedSwipeArea");
    var navPanelSwipeArea = ZDBClientUI.swipeAreaTD;
    var viewType = ZDBClientUI.selectedTab.view.type;
    if(ZDBClientUI.selectedNav==null
       ||(ZDBClientUI.selectedNav=="Fields" && !((viewType=="AnalysisView" || viewType=="Pivot" || viewType=="SummaryView") && ZDBClientUI.selectedTab.view.editMode)))
    {
      var selectNav = "All";
    }
    else
    {
      var selectNav = ZDBClientUI.selectedNav
    }

    ZDBClientUI.selectNavTab(selectNav);
    navPanelSwipeArea.appendChild(ZDBClientUI.swipeArea);
    if(attachedSwipeArea!=null){attachedSwipeArea.style.display="none";}
  }


  this.setUpDBView = function(action,dbId,objId,dispName,type,isDBOwner,isDBOwnerAndNotDBAdmin,
                              isGroupMember,
                              notLoggedIn,
                              standAlone,sampleViewStatus, privateKey, zrauthkey, authtoken, containerObjId,analysisType,folderPerm,
                              zoho_criteria,isBetaCustomer,integrationMode,fs,rsConfig,localeInfo,sessionKey,showHiddenColsInReportCreation,isRemoteDB,objKey,parentViewId,isMakePublicAllowed,isPublishAllowed,isDBExportAllowed,isFromGDrive,mode,url,tableName,fileType,isSupportAdminAccess,directFilterString)

  {
    this.dbId = dbId;
    this.isDBOwner = isDBOwner;
    this.isDBOwnerAndNotDBAdmin = isDBOwnerAndNotDBAdmin;
    this.isGroupMember = isGroupMember;
    this.notLoggedIn = notLoggedIn;
    this.standAlone = standAlone;
    this.modeHelper = (standAlone)? ZDBStandAloneMode:ZDBMainMode;
    this.zoho_criteria = zoho_criteria;
    this.directFilterString = directFilterString;
    this.folderPerm = folderPerm;
    this.sampleViewStatus = sampleViewStatus;
    this.hideOnStandAlone = standAlone || notLoggedIn;
    this.hideOnNotDBOwnerAndNotGroupUser = !(isDBOwner || isGroupMember);
    this.isBetaCustomer = isBetaCustomer;
    this.isRemoteDB = isRemoteDB;
    ZDBGlobal.integrated = integrationMode;
    this.fs = fs;
    this.rsConfig = rsConfig;
    this.isMakePublicAllowed = isMakePublicAllowed;
    this.isPublishAllowed = isPublishAllowed;
    this.isDBExportAllowed = isDBExportAllowed;
if(isFromGDrive == "true")
    {
    var freezelayer = jQuery(document.createElement("div"));
    freezelayer.attr("class","freezeLayer"); //No I18N
    freezelayer.attr("ID","IMPORTFREEZE"); //No I18N
    freezelayer.css("top","0px");//No I18N
    freezelayer.css("opacity",'1');//No I18N
    freezelayer.css("z-index","1000");//No I18N
    jQuery(document.body).append(freezelayer);
        var loadingDiv = jQuery(document.createElement("div"));
        loadingDiv.attr("ID","ZDBMainLoader_new");// No I18N
        loadingDiv.attr("class","zdbLoading");// No I18N
        loadingDiv.attr("elname","loadingDiv");// No I18N

        loadingDiv.css("top","50%");// No I18N
        loadingDiv.css("left","50%");// No I18N
        loadingDiv.css("height","auto");// No I18N
        loadingDiv.css("margin-top","-20px");// No I18N
        loadingDiv.css("margin-left","-80px");// No I18N
        jQuery(document.body).append(loadingDiv);
        $("ZDBMainLoader_new").innerHTML = "<div elname=\"textEl\" style=\"padding: 10px 40px; vertical-align: middle; background-position: 10px 5px;white-space: nowrap\" class=\"loadingImage\">Loading</div>";

}
  this.isSupportAdminAccess = isSupportAdminAccess;
    this.dbConfig = new DBConfig(dbId, showHiddenColsInReportCreation);
    this.initReferences();

    if(ZDBGlobal.integrated)
    {
      this.layoutMode="max";
    }
    this.resizeAllDInst();
    this.privateKey = privateKey;
    this.zrauthkey = zrauthkey;
    this.authtoken = authtoken;
    this.sessionKey = sessionKey;
    this.containerObjId = containerObjId;
    this.Objects_TBODY = document.getElementById("Objects_TBODY");
    ZDBToolTip.init();

    this.updateScrollSize();

    if(action == "ENTERDATA")
    {
      ZDBNavigation.initializeExplorerView(false);
      setTimeout(function(){ZDBCreateViewAPI.fetchEnterDataView(null, null, dbId,false,ZDBI18NMap.g("zrpt.table.existimport.step1.js.untitled1"));},100);
    }
    else if(action =="CREATEANALYSIS")
    {
      this.createView(dbId,objId,"Sheet",analysisType,null);
    }
    else if(action == "VUD")
    {
      ZDBVUDataAPI.sendVUDRequestInWindow(objId);
    }
    else if(objId != null)
    {
      if(!standAlone && !ZDBGlobal.integrated)
        {
          ZDBNavigation.initializeExplorerView(false);//$$$ - Remember the main loading clash
        }
      this.fetchView(objId,dbId,dispName,type,null,objKey,parentViewId);
    }
    else
    {
      ZDBNavigation.initializeExplorerView(true);
    }

    if(!ZDBGlobal.integrated)
    {
      jQuery(window).resize(
              function()
              {
                ZDBClientUI.handleWindowResize();
              }
      );
      window.onbeforeunload = this.onBeforeWindowUnLoad;
      window.onfocus = ZDBClientUI.focusMain;
    }

    if(this.isRemoteDB)
    {
      this.setUpRDBConnInfoObj(dbId);
    }

    setTimeout(function(){ZDBContentCache.contentCache(localeInfo);},1000);
    ZDBVersionCheck.checkVersionChange();
    if(!ZDBClientUI.standAlone && !ZDBGlobal.integrated){
        ZDBNavigation.navSelect.value = ZDBClientUI.Objects_TBODY.getAttribute("navigType");
        ZDBExpViewHandler.valueFetch(ZDBClientUI.dbId, ZDBNavigation.navSelect.value);
        ZDBNavigation.manageNavState();
    }
    ZDBGlobal.initializeFontInfo();
  if(isFromGDrive == "true")
    {
        this.handleCreateDBResp_new(mode,url,tableName,fileType);
    }
  };
  
this.handleCreateDBResp_new = function(mode,url,tableName,extn)
  {
      
    $("ZDBMainLoader").className = "zdbLoading";
    if(!ZDBLazyLoadUtil.loadJsAlone(["import/js/ZDBImport.js","template/js/ZDBTemplate.js"],this,ZDBClientUI.handleCreateDBResp_new,[mode,url,tableName,extn]))
  {
    return;
  }
    if(ZDBClientUI.notLoggedIn)
    {
      document.body.removeChild($("IMPORTFREEZE"));
  document.body.removeChild($("ZDBMainLoader_new"));
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.newrpt.js.signIn2CreateNewRpt",ZDBGlobal.PRODUCTNAME));
      return;
    }
    if(!ZDBClientUI.isDBOwner)
    {
      document.body.removeChild($("IMPORTFREEZE"));
      document.body.removeChild($("ZDBMainLoader_new"));
      //ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.newtbl.js.noPerm2CreateNewTbl"));
      return;
    }
    if(mode == "readDoc")
    {
    var params = "&DBID="+ZDBClientUI.dbId+// No I18N
    "&LOCATION="+"GINTEG"+// No I18N
    "&TABLENAME="+tableName+// No I18N
    "&FILETYPE="+ZDBUtil.replaceAll(extn,'.','').toUpperCase()+// No I18N
    "&URL="+encodeURIComponent(url)+// No I18N
    "&ZDBFILESUBTYPE="+extn+// No I18N
    "&ZDBFILENAME="+encodeURIComponent(url)+// No I18N
    "&isFromGInteg="+true;//No I18N
    
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBImportData.cc?ZDBACTION=CREATETABLEFROMGDRIVE"+params, METHOD:"POST",
        ONSUCCESSFUNC:ZDBClientUI.handleGIntegTable,ONFAILUREFUNC:ZDBClientUI.handleGIntegTableError});
    }
    else
    {
        ZDBCreateViewAPI.showCreateNewTblDlg(false,true,mode);
    }
    
  }
  this.handleGIntegTableError = function(response,requestOptions)
  {
  document.body.removeChild($("IMPORTFREEZE"));
  document.body.removeChild($("ZDBMainLoader_new"));
  var msg = response.getResponsePart("STATUS_MESSAGE");
  ZDBAlertAPI.showMsg(msg);
  }
  this.handleGIntegTable = function(response,requestOptions)
  {

    if(!ZDBLazyLoadUtil.loadSnippet("CREATE_NEW_TABLE_GINTEG","/ZDBCreateTableViaImport.cc?&DBID="+ZDBClientUI.dbId,this,"APPENDTODOC",null,ZDBClientUI.handleGIntegTable,[response,requestOptions]))
    {
      return;
    }
    if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBGridList"],"APPENDTODOC",ZDBClientUI.handleGIntegTable,[response,requestOptions]))
    {
      return false;
    }
          if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC",ZDBClientUI.handleGIntegTable,[response,requestOptions])){
    return false;
  }
  ZDBCreateViewAPI.showCreateNewTblDlg(false,true,"readDoc",response);//No I18N     
  }
  this.importGDriveFile=function(response)
  {
      var div = document.createElement("div");
  div.id = "ZDBImportFile";
  div.style.width="100%";
  div.style.height="100%";
  div.innerHTML = response.getOnlyHtml();
  var dlg = $("ZDBCREATEDIALOG").cloneNode(true);
  jQuery(dlg).find("#ZDBCreateDBCntTd")[0].innerHTML = ""
  jQuery(dlg).find("#ZDBCreateDBCntTd")[0].appendChild(div);
   //var tab = ZDBClientUI.createDummyTab(ZDBClientUI.curDummyViewId--,"sd",dlg,
                                         //"NewOption");
    //ZDBClientUI.selectTab(tab);
    
    window.curStep = 1;
    window.totStep = 2;
    ZDBInlineDialog.showDialog(dlg,{MODAL:true,VIEW:ZDBClientUI.selectedTab.view});
    response.invokeScripts();
    $("ZDBPreviousDBBtn").style.display = "none";
  
  document.body.removeChild($("IMPORTFREEZE"));
  document.body.removeChild($("ZDBMainLoader_new"));
    
      
  }
  this.documentReadyState = function() {
      if(document.readyState == 'complete'){
          if(ZDBGlobal.LANDINGPAGE === "ZDBDataSheetView")
              ZDBClientUI.checkAndRedirectForApps();
          if(typeof ZRSupportClass != "undefined")
              ZRSupportClass.handleInitialLiveChatVisibility();
          // For Global Notification
          if(!ZDBClientUI.standAlone && ZDBGlobal.zuID>0){
              if(typeof ZROrg != 'undefined') {
                ZROrg.loadProfileImage();
              }
              switch(ZDBGlobal.LANDINGPAGE){
                case "ZDBDataSheetView": //NO I18N
                  setTimeout(lazyLoadJSAndCssFiles, 2000);
                break;
                case "ZDBHome":  //NO I18N
                  setTimeout(lazyLoadJSAndCssFilesHome, 2000);
                break;
              }

              if(!ZDBGlobal.integrated && !ZDBClientUI.isCustomDomain && !ZDBGlobal.IS_ONPREMISE_BUILD && !(ZDBGlobal.LANDINGPAGE === 'ZDBHome' && ZDBGlobal.ISNEWLAYOUT))
              {
                setTimeout(ZDBClientUI.loadWMS, 1500);
              }
          }

      }
  };

  this.loadWMS = function()
  {
      if(!ZDBLazyLoadUtil.loadJsAlone("//"+ZDBGlobal.wmsJSURL, "APPENDTODOC",ZDBClientUI.loadWMS,null,null,true,true)) //last arg is for excluding crossorigin attribute
      {
          return;
      }
      if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/ui/GlobalNotification.js", "APPENDTODOC",ZDBClientUI.loadWMS))
      {
          return;
      }

      ZDBClientUI.initGlobalNotification();
  }

  this.initGlobalNotification = function () {
    if(typeof WMSSessionConfig != 'undefined') {
      // Initialize WMS framework
      var settings = WMSSessionConfig.CROSS_PRD;
      WebMessanger.setIamServer(ZDBGlobal.IAMServerURL);
      WebMessanger.setConfig(settings);
      WebMessanger.setNoDomainChange();
      WebMessanger.register('ES', ZDBGlobal.zuID, true); // No I18N
      WebMessanger.disableNetworkDownBanner();

      // Requests the server for notification feed
      GlobalNotification.get();
    }

    if(typeof Collaboration != "undefined") {
      Collaboration.handleCustomMessage = function (json) {
          switch(json.event){
              case "newGlobalNotification"://NO I18N
                  if(json["domain-name"]==document.domain){
                    GlobalNotification.emit(json.data);
                    }
                  break;
              case "notificationPreferenceChange"://NO I18N
                  if(json["domain-name"]==document.domain){
                    GlobalNotification.preferences[json.data.type] = json.data.value;
                    GlobalNotification.applyPreferencesInUI();
                    }
                  break;
              case "WMS_SNAPSHOT_EVENT"://NO I18N
                  if(ZDBGlobal.ISNEWLAYOUT){
                      ZRSCardPreviewHandler.handleSnapshowWMSEvent(json);
                  }
                  break;
              case "LAZYLOAD_EVENT": //No I18N
                  ZALazyLoadData.handleLazyLoadEvent(json);
                  break;
              case "NEW_USER_OR_GROUP_ADDED": // No I18N
                  setTimeout(function() { (typeof Contacts != "undefined") && Contacts.get(true); }, 5000); // No I18N
                  break;
          }
      };


        Collaboration.handleServiceMessage = function (json) {
            if(json.msg=="ZRAnnouncement")
                {
                   GlobalNotification.get();
                }
        };

        if(ZDBGlobal.isQAEnabled) {
            WebMessanger.reload = undefined;
        }
    }
  };

  this.setUpRDBConnInfoObj = function(dbId)
  {
    if(!ZDBLazyLoadUtil.loadJsAlone(["ZRRemoteDB"],"APPENDTODOC",ZDBClientUI.setUpRDBConnInfoObj,[dbId]))
      {
          return;
      }
    var url = "/RDBAction.ma?";   //No I18N
    var params = "&ZDBACTION=GETCONNECTIONDETAILS&DBID=" + dbId;  //No I18N
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,DBID:dbId,METHOD:"GET",
      ONSUCCESSFUNC:ZDBClientUI.setRDBConnectionDetails});
  }

  this.setRDBConnectionDetails = function(response,requestOptions)
  {
    var respObj=JSON.parse(response.responseText);
    var dbId = requestOptions["DBID"];
    ZDBClientUI.dbConfig.rdbView = new ZRRemoteView(dbId, respObj.conid,respObj.dbname,respObj.servicename,respObj.dbtype,respObj.createdtime,respObj.lastsynctime);
    RDBPage.checkConnectionInDBExp(dbId);
  }

  this.checkAndRedirectForApps = function(){
    if(document.readyState == 'complete' && (getCookie("APPCHECKSHOWN")!= "true") && !ZDBClientUI.standAlone){
      if(BROWSER.IPAD || (BROWSER.ANDROID && navigator.userAgent.toLowerCase().indexOf("mobile") == -1)){
        var el = jQuery("#ZDBAppCheck");//NO I18N
        var height = window.innerHeight;
        var linkContainter = el.find("#linkContainer");
        var appDesc = el.find("#AppDesc");
        ZDBClientUI.handleAppCheckLinkPositioning(height, linkContainter, appDesc);
        el.find("#Container").height(height);
        (BROWSER.IPAD)?(el.find("#ZRPlayLink").hide()):(el.find("#ZRItuneLink").hide());
        document.body.style.margin = '0px';//NO I18N
        el.show();
        ZDBClientUI.appCheckShown = true;
        window.addEventListener("resize",ZDBClientUI.handleAppCheckResize);//NO I18N
        setCookie("APPCHECKSHOWN",true);//NO I18N
    }
  }
  }

  this.handleAppCheckLinkPositioning = function(height, jqueryEl1, jqueryEl2){
    if(height <= 600){
      jqueryEl1.css("bottom", "28px");//NO I18N
      jqueryEl2.css("top", "13px");//NO I18N
    }
    else if(height <=700){
      jqueryEl1.css("bottom", "65px");//NO I18N
      jqueryEl2.css("top", "41px");//NO I18N
    }
    else if(height <=800){
      jqueryEl1.css("bottom", "114px");//NO I18N
      jqueryEl2.css("top", "75px");//NO I18N
    }
    else if(height <= 900){
      jqueryEl1.css("bottom", "156px");//NO I18N
      jqueryEl2.css("top", "108px");//NO I18N
    }
    else if(height <= 1000){
      jqueryEl1.css("bottom", "186px");//NO I18N
      jqueryEl2.css("top", "129px");//NO I18N
    }
    else if(height <= 1100){
      jqueryEl1.css("bottom", "186px");//NO I18N
      jqueryEl2.css("top", "129px");//NO I18N
    }
    else if(height > 1100){
      jqueryEl1.css("bottom", "229px");//NO I18N
      jqueryEl2.css("top", "183px");//NO I18N
    }
  }

  this.handleAppCheckResize = function(){
    if(ZDBClientUI.appCheckShown){
      var height = window.innerHeight;
      var el = jQuery("#ZDBAppCheck");//NO I18N
      var linkContainter = el.find("#linkContainer");
      var appDesc = el.find("#AppDesc");
      ZDBClientUI.handleAppCheckLinkPositioning(height, linkContainter, appDesc);
      jQuery("#Container").height(height);//NO I18N
      return;
    }
  }

  this.closeCheckApps = function(){
    jQuery("#ZDBAppCheck").hide();//NO I18N
    ZDBClientUI.appCheckShown = false;
  }

  this.handleWindowResize = function()
  {
     if(ZDBClientUI.windowResizeTimeout != null)
        {
        clearTimeout(ZDBClientUI.windowResizeTimeout);
        }
     ZDBClientUI.windowResizeTimeout = setTimeout("ZDBClientUI.resizeAllDInst(true)",500);
     return true;
  }

  this.openView=function(el,event)
  {
    ZDBToolTip.hide();
    ZDBDialogUtil.closeDialog();
    var objId=jQuery(el).attr("objId"); //No I18N
    var dbId=jQuery(el).attr("dbId"); //No I18N
    var dispName=jQuery(el).attr("dispName"); //No I18N
    var type=jQuery(el).attr("type"); //No I18N
    var tab = ZDBClientUI.getExistingTab(objId);
    if(tab != null)
    {
      this.selectTab(tab);
      return;
    }
    this.fetchView(objId,dbId,dispName,type,null);
  }

  this.updateScrollSize = function()
  {
    var div = $("ZDBTPLGRIDAREA");
    if(div.offsetHeight == 0)
    {
      document.body.appendChild(div.parentNode);
    }
    ZDBGlobal.scrollThick = ZDBGlobal.scrollWidth = ZDBGlobal.getScrollThickness();
    div.parentNode.parentNode.removeChild(div.parentNode);
  }


  this.saveAll = function()
  {
    var unsavedNewView, childNodes = ZDBClientUI.$$("ZDBTABCONT").childNodes;
    ZDBDialogUtil.closeDialog();
    for(var i=0; i < childNodes.length; i++)
    {
      var child = childNodes[i];
      if(child == ZDBNavigation.explorerTab || !child.view.modified)
      {
        continue;
      }
      else{
        ZDBClientUI.selectTab(child);
        if(!ZDBUtil.isNewView(child.view)) {
              child.view.save();
        }
        else if(!unsavedNewView){
          unsavedNewView = child.view;
        }
      }
    }
    if(unsavedNewView) {
      unsavedNewView.save();
      return;
    }
    return true;
  }

  this.changeFont = function(fontName)
  {
    AjaxAPI.sendRequest({URL:"/ZDBDatabaseActionMI.ma?ZDBACTION=CHANGEFONT",
                               PARAMETERS:"FONTNAME="+ encodeURIComponent(fontName), //No I18N
                               ONSUCCESSFUNC:ZDBClientUI.reload,
                               OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.changeTheme = function(themeName,path)
  {
    AjaxAPI.sendRequest({URL:"/ZDBDatabaseActionMI.ma?ZDBACTION=CHANGETHEME",
                               PARAMETERS:"THEMENAME="+encodeURIComponent(themeName),
                               ONSUCCESSFUNC:ZDBClientUI.reload,
                               OPSTATUSID:"ZDBMainLoader"});
  }

  this.reload = function()
  {
    window.location.reload();
    //window.location.href=window.location.href;
  }

   this.handleProjectsMenu = function(isProjDB)
   {
        var projElt = $("ZDBEXPLORERPROJECTS_TITEM");
  if(isProjDB != true && projElt)
      {
          DOMUtils.addCSSClass([projElt],"disabledonnotsaved");
          DOMUtils.addCSSClass([projElt],"notpermitted");
          projElt.onclick = null;
      }
   }

   this.setImportOptions = function(showDocs, showExt, showGDrive, customDomain)
   {
     this.isCustomDomain = customDomain;
     this.showDocs = showDocs;
     this.showExt = showExt;
     this.showGDrive = showGDrive;
   }

}



ZDBClientUI.getViewObj = function(el,property)
{
  var curEl = el;
  while(curEl && (curEl[property] == null))
  {
    curEl = curEl.parentNode;
  }
  if(curEl == null){return null;}
  return curEl[property];
}

var ZDBStandAloneMode = new function()
{
   this.dummyFunc = function(){};
   this.removeObjects = this.dummyFunc;
   this.selectTab = this.dummyFunc;
}

var ZDBMainMode = new function()
{
   this.removeObjects = function(objIds)
   {
    ZDBClientUI.TBLLIST = null;
    ZDBNavigation.removeObjects(objIds);
   }

   this.selectTab = function()
   {
    ZDBTabHandler.moveToVisibleArea();
    ZDBNavigation.highlightSelectedInNavList();
   }
}

  ZDBClientUI.clearCache = function()
  {
    ZDBClientUI.TBLLIST = null;
    AllowedValPopup.cache = new Object();
    if(typeof ZDBAnalysisCaching !== "undefined"){//For datatype change in table, ZDBAnalysisCaching will not be loaded.
      ZDBAnalysisCaching.cachedFields = new Object();
    }
  }

  ZDBClientUI.positionComboHdr = function(cellObj,dArea)
  {
    var comboHdr = cellObj.comboHdr;
    var drillFlow = cellObj.originalValue;
    if(drillFlow)
    {
      var jObj = JSON.parse(drillFlow);
      var flowDet  = jObj[ZDBDesignGrid.getColumnDataTypeForField(cellObj)];
      if(flowDet.length>1)
      {
       jQuery(comboHdr.compElContainer).attr({DRILLCOLID:flowDet[0],DRILLTBLID:flowDet[1],DRILLCOLADDONTYPE:flowDet[2],DRILLCOLOPERATION:flowDet[3],DISPCOLNAME:flowDet[4]});
       comboHdr.displaySelected.innerHTML = ZDBEscapeUtil.encodeForHtml(flowDet[4]);
       comboHdr.displaySelected.setAttribute("value",ZDBEscapeUtil.encodeForHtml(flowDet[4]));
      }
    }
    var left = ZDBUtil.getObjLeft(cellObj.cellEl,false,dArea);
    var top = ZDBUtil.getObjTop(cellObj.cellEl,false,dArea);
    comboHdr.style.position = "absolute";
    comboHdr.style.top = top-1+"px";
    comboHdr.style.left = left-1+"px";
    comboHdr.displaySelected.style.width = (cellObj.cellEl.offsetWidth - 28)+"px";
  }

  ZDBClientUI.showCombo = function(response,requestOptions)
  {
    var cellObj;
    cellObj = requestOptions["CELLOBJ"]; ///PK: You must believe in hell
    var div = document.createElement("div");
    div.innerHTML = response.getOnlyHtml();
    ZDBClientUI.TBLLIST = div.childNodes[0];
    ZDBClientUI.showList(cellObj,requestOptions["OBJID"]);
  }

  ZDBClientUI.showList = function(cellObj,objId)
  {
    var orglist = ZDBClientUI.TBLLIST;
    var list = orglist.cloneNode(true);
    if((typeof ZDBQa) == "object")
    {//Qa
       if(list.id) {list.id = "";}
       list.id = cellObj.id;
    }
    var nodeList = list.getElementsByTagName("optgroup");
    var length = nodeList.length;
    var toRemove;
    for(var i=0 ; i<length; i++)
    {
        var grpNode = nodeList.item(i);
        var curObjId = grpNode.getAttribute("objId");
        if(curObjId == objId)
        {
            toRemove = grpNode;
        }
    }
    if(toRemove != null && toRemove != undefined)
    {
        list.removeChild(toRemove);
    }

    ZDBEditors.configureListEditor(cellObj,list);
    list.onchange = ZDBDesignGrid.customFunc;
    list.onblur = function(event){return ZDBEditors.onListBlur(this,event);};
    ZDBEditors.showListEditor(cellObj,list);
  }
  ZDBClientUI.validateEmail = function(field)
  {
    var regex=/^([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x22([^\x0d\x22\x5c\x80-\xff]|\x5c[\x00-\x7f])*\x22)(\x2e([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x22([^\x0d\x22\x5c\x80-\xff]|\x5c[\x00-\x7f])*\x22))*\x40([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x5b([^\x0d\x5b-\x5d\x80-\xff]|\x5c[\x00-\x7f])*\x5d)(\x2e([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x5b([^\x0d\x5b-\x5d\x80-\xff]|\x5c[\x00-\x7f])*\x5d))*$/;
    return (regex.test(field)) ? true : false;
  }

    ZDBClientUI.openGettingStartedDlg = function()
    {
        if(!ZDBLazyLoadUtil.loadJsAlone("main/js/ZRGettingStarted_new.js", "APPENDTODOC", ZDBClientUI.openGettingStartedDlg)) {
            return;
        }

        ZRSAjax.get('/reportsapi/GETTINGSTARTEDINIT', null, {
            successHandler: {
                func: ZRGettingStarted.gettingStartedDlg,
                ctx: ZRGettingStarted
            }
        });
    }
  
    ZDBClientUI.hoverLinkInGS = function(el,hover)
    {
        var parent=jQuery(el).parents("[elname='gsoption']"); //No I18N
        var ico=parent.find("div");
        var className=ico.attr("elname"); //No I18N
        var link=parent.find("[elname='txt']");
        if(hover)
        {
            ico.removeClass().addClass(className+"Hover");  //No I18N
            link.removeClass().addClass("gsLinkTxtHover");  //No I18N
        }
        else
        {
            ico.removeClass().addClass(className);
            link.removeClass().addClass("gsLinkTxt"); //No I18N
        }
    }
  
    ZDBClientUI.closeVideoDialog=function(isEsc) {
        var dlg=$("gsvideoHolder");
        dlg.style.display="none"
        dlg.freezeLayer.style.display="none";
        jQuery(".gsiframe").removeAttr("src"); //No I18N
        if(!isEsc){ev.escKeyPressStack.pop();}
        ZDBClientUI.gsVideoOpened = false;
        ZDBUtil.removeChildrenWithClass(document.body, "freezeLayer"); //No I18N
    }

    ZDBClientUI.showVideo=function(src)
    {
        var dlg=$("gsvideoHolder");
        if(!dlg)
        {
            dlg=document.createElement('div');
            dlg.setAttribute("id","gsvideoHolder");
            dlg.appendChild(jQuery(".gsiframeholder").show()[0]);
            document.body.appendChild(dlg);
            var freezeLayer = document.createElement("DIV");
            freezeLayer.className = "freezeLayer";
            freezeLayer.style.zIndex = 1100;
            dlg.freezeLayer = freezeLayer;
            document.body.appendChild(dlg.freezeLayer);
        }
        else
        {
            dlg.style.display="";
            dlg.freezeLayer.style.display="";
        }
        dlg.style.zIndex = 4000;
        try {
            var width = document.body.getBoundingClientRect().width / 2 - dlg.getBoundingClientRect().width / 2;
            dlg.style.left = width + "px";
        }
        catch(e){
          //error in getBoundingClientRect
        }
        ZDBClientUI.gsVideoOpened = true;
        jQuery(".gsiframe").attr("src",src+"&autoplay=1"); //No I18N
        ev.addEscHandle(ZDBClientUI.closeVideoDialog);
    }

  ZDBClientUI.getDispName = function(viewId)
  {
      var el = ZDBUtil.getElWithTagNAttrWithVal(ZDBClientUI.swipeArea, "objid", viewId, "tr"); //No I18N
      return (el ? el.getAttribute("dispname"): null);
  }

  ZDBClientUI.hideSubscriptionLink = function(isSharedDB)
  {
      if(!isSharedDB)
          {
              jQuery("#ZRSubscriptionLink").hide(); //No I18N
          }
  }

  ZDBClientUI.loadLiveChat = function(){
    if(!ZDBClientUI.liveChatLoadingDivGen){
      var loadDiv = ZDBUtil.getCloned(document.querySelector("#ZDBMainLoader"));//NO I18N
      loadDiv.className = "zdbLoaded";//NO I18N
      ZDBUtil.setNamedChildEls(loadDiv,loadDiv);
      loadDiv.textEl.innerHTML = ZDBI18NMap.g("zrpt.common.js.activlivechat") + "...";//NO I18N
      loadDiv.id="ZRLiveChatLoading";//NO I18N
      document.body.appendChild(loadDiv);
      ZDBClientUI.liveChatLoadingDivGen = true;
      ZRUserAnalytics.checkAndPushToServer("LiveChat","SalesIQ","Support",null,{planName:ZDBGlobal.userPlanName});//NO I18N
    }
    if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/ui/ZRSalesIq.js","APPENDTODOC",null,null
      ,"ZDBMainLoader")){//NO I18N
      return;
    }
    ZRSalesIq.fireClick();
  }

  ZDBClientUI.copyToClipboard = function(text, elname) {
    try {
      ZDBClientUI.pasteArea.value = text;
      ZDBClientUI.pasteArea.select();
      if(document.execCommand('copy')) {
        ZDBClientUI.pasteArea.value = '';
        var el = jQuery('#' + elname);
        if(el.length > 0) {
          el.stop().fadeIn(300).delay(2000).fadeOut(300);
        }
      }
    }
    catch(err) {
      // Unsupported Browser
    }
  };

  ZDBClientUI.launchTemplateReports = function(dbId,connectorId){
         var DBID = dbId.replace(",","");
         ZDBCreateViewAPI.showTemplateViewTab(DBID,connectorId,"true");
      }

/*  --------------------- visualize More Video Play and close functions  ------------------------------ */

ZDBClientUI.showNewReleaseDlg = function() {
    var banner = $("newReleaseBan");
     ZDBDialogUtil.freezeBackground(banner, "fullPageFreezeLayer");
     ZDBUtil.addClass(banner, "showBan");
}

ZDBClientUI.visualizeMoreVideoPlay = function (el) {
    var videoArea = document.getElementsByClassName("conVideoImg")[0];
    ZDBUtil.removeClass(videoArea, "imageView");
    videoArea.getElementsByClassName("video_play")[0].style.display = "none";
    var videoFrame = videoArea.getElementsByClassName("videoFrame")[0];
    videoFrame.children[0].setAttribute("src", "https://www.youtube.com/embed/qmWvaILTs5U?&autoplay=1");
    videoFrame.style.display = "block";
}

ZDBClientUI.closeVisualizeMoreDlg =  function (e) {
   AjaxAPI.sendRequest({
            URL:"/ZDBUserAction.ma?ZDBACTION=TOVISUALIZEMORE", //No I18N
            ONSUCCESSFUNC:ZDBClientUI.removeVisualizeBanner
            });
}
ZDBClientUI.removeVisualizeBanner = function () {
    var banner = $("newReleaseBan");
    banner.className = "popUpContainer";
    setTimeout(function () {
        if (banner.freezeLayer)
        {
            document.body.removeChild(banner.freezeLayer);
        }
        banner.parentElement.removeChild(banner);
    }, 400);
}
ZDBClientUI.showShare = function(isFolderShare, isViewShare) {
  if (!ZDBLazyLoadUtil.loadJsAlone('JS_SHARING_MODULE', this, ZDBClientUI.showShare, [isFolderShare, isViewShare])) { return; }
  if (!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_SHARING_MODULE"], "APPENDTODOC", ZDBClientUI.showShare, [isFolderShare, isViewShare])) { return; }
  ZRShare.show(isFolderShare, isViewShare);
};
ZDBClientUI.editSharedDetails = function(isItFromNavigation) {
  if (!ZDBLazyLoadUtil.loadJsAlone('JS_SHARING_MODULE', this, ZDBClientUI.editSharedDetails, [isItFromNavigation])) { return; }
  if (!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_SHARING_MODULE"], "APPENDTODOC", ZDBClientUI.editSharedDetails, [isItFromNavigation])) { return; }
  ZRShare.editSharedDetails(isItFromNavigation);
};
ZDBClientUI.getDBShareInfo = function () {
  if (!ZDBLazyLoadUtil.loadJsAlone('JS_SHARING_MODULE', this, ZDBClientUI.getDBShareInfo, [])) { return; }
  if (!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_SHARING_MODULE"], "APPENDTODOC", ZDBClientUI.getDBShareInfo, [])) { return; }
  ZRShare.getDBShareInfo();
};

document.onreadystatechange = ZDBClientUI.documentReadyState;
