//$Id$
var ZDBClientUI = new function()
{

  this.curDummyViewId = -10;
  this.loadDivs = {};
  this.typeDefns = {};
  this.tabOrderList=[];
  
  this.resizeMain = function()
  {
    var el = document.getElementById("ZDBRIGHTDIV");
    el.style.display = "none";
    var height = ZDBUtil.getOffsetSize($("ZDBHEADER"), false) + ZDBUtil.getOffsetSize($("ZDBMAINDIV"), false);
    height = (jQuery(window).height()) - height - 4;
    el.style.height = height + "px";
    el.style.display = "";
  };

  this.resizeDomainHmePage = function()
  {
    var el = jQuery("#ZDBDomainHomePageDiv");   //No I18N
    var headerHeight = jQuery("#ZDBHEADER").height(); //No I18N
    var height = jQuery(window).height() - headerHeight;
    el.css("height",height-5); //5px variant. //No I18N
    var domainListHeight = (height-45); //40px extra variant for Domain list Height - Needs to Find out - Earlier we have set 93% as height of this div.
    jQuery("#ZDBDomainDBList").css("height",domainListHeight); //No I18N
  };
    
  this.loadBaseSVGIcons = function(){
      ZDBLazyLoadUtil.loadExternalSVG('themes/common/svgimages/baseIcons.svg', this.handleSVGSuccess, null, ZDBClientUI);//NO I18N
  };
  this.handleSVGSuccess = function(){
      this.baseSVGLoaded = true;
  };
    
  this.focusMain = function(event)
  {
    var srcEl = ZDBUtil.getSourceElement(event);
    if(srcEl && srcEl.parentNode)
    {
      return true;
    }

    if(!ZDBClientUI.selectedTab)
    {
      return true;
    }
    var curView = ZDBClientUI.selectedTab.view;
  };


  this.initReferences = function()
  {//Note: initialize only references that are immediately needed!!.
    //Other wise the initial loading will become slow!!
    this.placeHolder = document.getElementById("ZDBPLACEHOLDER");
    this.poweredByEl = document.getElementById("ZDBPoweredByEl");
    this.mainPanel = document.getElementById("ZDBMAINEL");
    this.headerArea = document.getElementById("ZDBHEADER");
    this.dummyGrid = document.getElementById("ZDBDUMMYGRID");
    this.blankView = document.getElementById("ZDBBLANKVIEW");
    this.dummyGraph = document.getElementById("ZDBDUMMYGRAPH");
    this.mainLoader = document.getElementById("ZDBMainLoader");
    this.iPhoneBlankView = document.getElementById("ZDBIPHONEBLANKVIEW");
    this.dummyGraph.parentNode.removeChild(this.dummyGraph);

    this.ZRSTabHolder = document.getElementById("ZRSTabHolder");
    this.swipeArea = document.getElementById("ZDBSWIPE");
    this.swipeAreaTD = document.getElementById("ZDBSWIPETD");
    this.responseHolder = document.getElementById("ZDBRESPONSEHOLDER");
    this.viewOption = document.getElementById("ZDBViewOption");
    this.viewList = document.getElementById("ZDBVIEWLISTDIV");
    this.layoutMode = "normal"; //No i18N
    this.navigatable = $("ZDBNAVIGTABLE");
    this.swipeBar = $("ZDBSwipeBar");
    this.pasteArea = $("ZDBPasteArea");

      this.leftArrowWidth = jQuery("#ZR_LeftTabNavArrow").width();// NO I18N
    this.minMaxIconWidth = jQuery("#ZR_MinMaxIcon").width();// NO I18N
  
    this.rightArrowWidth = jQuery("#ZR_RightTabNavArrow").width();// NO I18N
    this.addTabIconWidth = jQuery("#ZRNewTab").width();// NO I18N
    this.listTabNavArrowWidth = jQuery("#ZR_ListTabNavArrow").width();// NO I18N
  
    
   
  }


  this.resizeAllDInst = function()
  {
    var body = document.body;
    var cWidth  = jQuery(window).width();
    var cHeight = jQuery(window).height();
    var mainBox = $("ZDBMainBox");
    mainBox.style.margin="auto"; //No I18N
    var tab = ZDBClientUI.selectedTab;
    if(ZDBGlobal.IS_MOBILE && tab && tab.view.type === 'Dashboard') {
        mainBox.style.height=""; //No I18N
        cWidth = cWidth - 2; //dashboard re-sizing issue fix in IPAD for the time being
    } else {
        jQuery(mainBox).height(cHeight);
    }
    jQuery(mainBox).width(cWidth);

    var headHeight = jQuery("#ZDBHead").height();//No I18N
    
    if((cHeight == body.prevClientHeight)
    && (cWidth == body.prevClientWidth))
    {
    return;
    }
    body.prevClientHeight = cHeight;
    body.prevClientWidth = cWidth;

    if(tab && tab.view.dialogStatus > 0)
    {
        ZDBClientUI.resizeHolders(false);
        ZDBInlineDialog.resized = true;
        ZDBInlineDialog.resizeDialog();
        if(tab.focusedDialog && tab.focusedDialog.gridObj && tab.focusedDialog.gridObj.type == "TableDesign")
        {
            ZDBClientUI.resizeEditGridHolder();
        }
        return;
    }
    ZDBClientUI.resizeHolders(true);
    if(tab)
    {
      if(tab.view instanceof ZDBDashboard && tab.view.OldDashDivSize)
        {
          tab.view.OldDashDivSize.width = tab.view.dashDiv.clientWidth;
        }
      tab.view.resize();
      ZDBMenu.resizeTitleNDesc(tab.view.toolbar); //Toolbar title resize
    }
    ZDBClientUI.resizeLeftSideNav(cHeight);
  }

    this.resizeLeftSideNav = function(cHeight)
    {
        var leftNav=jQuery("#ZRSingleLayoutNavTD"); //No I18N
        var footerEl=leftNav.find("[elname='footerElements']:visible");
        var menuHeight=(leftNav.find(".singleLayoutComp.explorerNav:visible").outerHeight(true));
        var topTiles = $("ZRIconAndDescModeNav").getElementsByTagName("ul")[0];
        var bottomTiles = $("ZRIconAndDescModeNav").getElementsByTagName("ul")[1];
        var tileNumber =  parseInt((cHeight-(jQuery("#ZDBMainHeader").height())-40) / menuHeight); //40 - height of createNew menu //No I18N
        
        var navtiles = $("ZRIconAndDescModeNav").querySelectorAll(".singleLayoutComp");
        var visibleTileCount = 0; 
        for(var i=0; i<ZDBNavigation.navtiles.length; i++) {
            if(ZDBNavigation.navtiles[i]["status"] != "hidden") {
                visibleTileCount++;
            }
        }
        if(tileNumber >= (visibleTileCount-1))
        {
            footerEl.addClass("positionBottom");
            for(var i=0; i<ZDBNavigation.navtiles.length; i++) {
                if(ZDBNavigation.navtiles[i]["status"] != "hidden") {
                    navtiles[i].style.display = "block";
                    ZDBNavigation.navtiles[i]["status"] = "visible";
                }
            }
            bottomTiles.querySelector(".moreNav").style.display = "none";
        }
        else
        {
            footerEl.removeClass("positionBottom");
            var i=0, j=0;
            while(i < tileNumber && j<ZDBNavigation.navtiles.length) {
                if(ZDBNavigation.navtiles[j]["status"] != "hidden") {
                    navtiles[j].style.display = "block";
                    ZDBNavigation.navtiles[j]["status"] = "visible";
                    i++;
                }
                else {
                    navtiles[j].style.display = "none";
                }
                j++;
            }
            if(j == ZDBNavigation.navtiles.length) {
                return;
            }
            for(; j<ZDBNavigation.navtiles.length; j++) {
                if(ZDBNavigation.navtiles[j]["status"] != "hidden") {
                    ZDBNavigation.navtiles[j]["status"] = "more";
                    navtiles[j].style.display = "none";
                }
            }
            bottomTiles.querySelector(".moreNav").style.display = "block";
        }
  }

  this.resizeHolders = function(resizePlaceHolder)
  { // Resize order has to be maintained. It should be in the below order only. Else, it won't work in IE
    if(resizePlaceHolder)
    {
         ZDBClientUI.resizePlaceHolder();
    }
    ZDBClientUI.resizeSwipe();
    ZDBClientUI.resizeTabHolder();
    ZDBClientUI.resizeCustomDashboardHeader();
    ZDBNavigation.resizeNavMenu();
  }

  this.resizeCustomDashboardHeader = function()
  {
    if(window.CustomHomePage)    //CustomHomePage object check
    {
      CustomHomePage.resizeCustomDashboardHeader();
    }
  }

  this.resizeSwipe = function()
  {
      var swipe = ZDBClientUI.swipeArea;
      swipe.style.display = "none";
      var height = ZDBClientUtil.offsetHeight(ZDBClientUI.headerArea) + ZDBClientUtil.offsetHeight($("ZDBNAVIGTABLE")) + ZDBClientUtil.offsetHeight($("ZDBLeftPanelBtm"));
      height = document.body.prevClientHeight - height;
      height += (BROWSER.IE)? 0 : -2;
      swipe.style.display = "";
      swipe.style.height = (height -1) + "px";
      ZDBClientUI.resizeRightExplorerView();
  }

  this.resizeRightExplorerView = function()
  {
    var explorerBand1 = $("ZDBEXPTITLE");
    var explorerBand2 = $("ZDBEXPHEADERROW");
    var explorerBand3 = $("ZDBEXPHEADERROW_2");
    var lftAndRghtPanel = ["toolbarLeftPor", "toolbarRightPor"]; //No i18N
    var toolbarLeftPor = ZDBUtil.getElsWithTagNAttrWithVals(explorerBand2, "elname", lftAndRghtPanel, "div"); //No i18N
    if(toolbarLeftPor && toolbarLeftPor.length) {
        toolbarLeftPor[0].style.width = explorerBand2.offsetWidth - toolbarLeftPor[1].offsetWidth - 80 + "px";  
    }
    var rightSideViewListheight = ZDBUtil.getOffsetSize($("ZDBPLACEHOLDER"),false) - (ZDBUtil.getOffsetSize(explorerBand1,false) + ZDBUtil.getOffsetSize(explorerBand2,false) + ZDBUtil.getOffsetSize(explorerBand3,false));
    rightSideViewListheight += (BROWSER.IE)? 0 : -2;
    var viewList = ZDBClientUI.viewList;
    viewList.style.height = rightSideViewListheight + "px";
      viewList.style.overflow = "hidden";
        var expNewLayout = viewList.getElementsByClassName(ZDBExpViewHandler.viewHolderClass)[0];
        if(expNewLayout){
            var expHeader = viewList.getElementsByClassName("newExpHeader"); //No I18N
            var expHeaderHeight = (ZDBClientUI.ISCARDLAYOUT) ? 55 : expHeader[0].offsetHeight + 15; // 20 for margin
            jQuery(expNewLayout).height(ZDBUtil.getOffsetSize(ZDBClientUI.viewList,false) - expHeaderHeight);
            expNewLayout.scrollTop = ZDBNavigation.expScrollPos;
            if(expNewLayout.scrollHeight == expNewLayout.offsetHeight) {
                ZDBExpViewHandler.batchViewsOnScroll(null, expNewLayout);
            }
        }
  }
  
  this.positionWorkArea=function()
  {
      var width = 0;
      if((ZDBClientUI.layoutMode == "max" || ZDBNavigation.hiddenState)){
            width = jQuery("#attachedSwipeArea").width(); //No I18N
      }
      jQuery("[elname='graphFieldHolder']").css("left",width+"px"); //No I18N
      jQuery("[elname='workArea']").css("left",width+"px"); //No I18N
  }
  
  
  this.resizeTabHolder = function(fromViewMode)
  {
       if(this.standAlone!=true) {
          ZDBClientUI.resizePlaceHolder();
          if(fromViewMode) { ZDBClientUI.selectedTab.view.resize(); }
          var tabParent = ZDBClientUI.ZRSTabHolder.parentElement;
          ZDBNavigation.moveToMoreTabs(tabParent, null , (tabParent.scrollWidth > tabParent.offsetWidth));
          return;
       }
  }

  this.resizePlaceHolder = function()
  {
    var body = document.body;
    document.body.style.overflow = "hidden";
    var placeHolder = ZDBClientUI.placeHolder;
    placeHolder.style.display = "none";
    var sepTab = ZDBUtil.getElWithTagNAttrWithVal($("ZDBBody"), "elname", "ZRSepTab", "div");//No I18N
    var height = ZDBClientUtil.offsetHeight(ZDBClientUI.headerArea) + ZDBClientUtil.offsetHeight(ZDBClientUI.mainPanel) + ZDBClientUtil.offsetHeight(sepTab);
    height = body.prevClientHeight - height;
    if(this.poweredByEl)
    {
      height -= ZDBClientUtil.offsetHeight(this.poweredByEl.parentNode);
    }
    placeHolder.style.height = (height)  + "px";
    placeHolder.style.display = "block";
    $("ZRDataSheetView").style.display = "";
    var otherSpacer = (ZDBGlobal.integrated) ? 0 : ZDBClientUtil.offsetWidth($("ZDBShowHideNavigIconContainer"));//No I18N
    var navBar = $("ZDBNavigationBarTD");
    var display="";
    if(ZDBClientUI.standAlone || ZDBGlobal.integrated || ZDBClientUI.layoutMode=="max")
    {
        display="none"; //No I18N
    }
    else if(ZDBNavigation.hiddenState && !ZDBNavigation.popOut)
    {
           jQuery(navBar).css({"position":"absolute","z-index":"10000","box-shadow":"0px 4px 10px #666666","left":"-256px"});//No I18N
    }
           
    navBar.style.display=display;
    ZDBClientUI.mainPanel.style.display = "";
    var width = 2; //TD before the swipe width
    width += (ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState || ZDBClientUI.standAlone || ZDBGlobal.integrated) ? 0 : 250; //No I18N
    var padding = (!ZDBClientUI.standAlone) ? 17 : 2;//here 17 px is the margin left and right
    var view = ZDBClientUI.getViewObj(placeHolder, "view");
    if(!ZDBClientUI.standAlone && !ZDBGlobal.integrated)
        {
            width=jQuery("#ZRSingleLayoutNavTD").width(); //No I18N
            if(view && view.editMode) 
            {
                if((view.type == "AnalysisView" || view.type == "Pivot" || view.type == "SummaryView"))
                {
                    width=  width+jQuery("#ZRFieldListTD").width();  //No I18N
                }
                else if(view.type == "Dashboard")
                {
                    width=  width+jQuery("#ZDBNavigationBarTD").width();  //No I18N
                }
            }
            width=width; 
            padding = (!ZDBClientUI.standAlone) ? 25 : 2;//here 25 px is the margin left and right
        }
        
        if(!ZDBGlobal.isSepTabLayer) {
            $("topbarTab").style.width = "0px";
            var par = $("ZDBMainHeader");
            var tabpar = par.children[0];
            $("topbarTab").children[0].style.width = par.offsetWidth - (tabpar.offsetWidth + par.children[1].offsetWidth + 80) + "px"; //No I18N
        }
        
    placeHolder.style.width = (document.body.prevClientWidth - width - padding) + "px";
    ZDBClientUI.placeHolderWidth = placeHolder.clientWidth;
    ZDBClientUI.placeHolderHeight = placeHolder.clientHeight;   
    if(view && view.type == "QueryTable" && view.editMode && view.editor)
    {
      var editorTD = $("ZDBSQLQueryTxtFldTD");
      var editorEl = editorTD.getElementsByTagName("div")[0];
      var editor = view.editor;
      editor.setSize($("ZDBPLACEHOLDER").offsetWidth, editorEl.offsetHeight);
      ZDBSQLTable.positionResizeEl();
    }
  }

  this.resizeEditGridHolder = function()
  {
  var body = document.body;
  body.style.overflow = "hidden";
  
  var tab = ZDBClientUI.selectedTab;
  var dlg = tab.focusedDialog;
  var editGridHolder = ZDBClientUI.editGridHolder;

  var height = ZDBClientUtil.offsetHeight(ZDBClientUI.headerArea) + ZDBClientUtil.offsetHeight($("TABSHOLDERPARENT")) + ZDBClientUtil.offsetHeight(dlg.designDIV.dlgTitleBar) + ZDBClientUtil.offsetHeight($("ZREditDesignToolBar"));
  height = body.prevClientHeight - height;
  
    var navBar = $("ZDBNavigationBarTD");
    var display="";
    display = ((ZDBClientUI.standAlone || ZDBGlobal.integrated  || ((ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState )&& !ZDBNavigation.popOut)))?"none":""; //No I18N
    navBar.style.display=display;
    var width = 2;
    width += (ZDBClientUI.layoutMode=="max" || ZDBNavigation.hiddenState || ZDBClientUI.standAlone || ZDBGlobal.integrated) ? width : 250; //No I18N
    width = (body.prevClientWidth - width - 15 + 2);
  
  ZDBClientUI.editGridHolderHeight = (height - ZDBGlobal.scrollThick);
  ZDBClientUI.editGridHolderWidth = (width - ZDBGlobal.scrollThick);
  editGridHolder.style.height = ZDBClientUI.editGridHolderHeight + "px";
  editGridHolder.style.width = ZDBClientUI.editGridHolderWidth + "px";
  dlg.gridObj.resizeGrid(ZDBClientUI.editGridHolderWidth,ZDBClientUI.editGridHolderHeight);
  }

  this.replaceInSwipeArea = function(newSwipeComp)
  { 
    var oldComp = ZDBClientUI.swipeArea.curComp;
    if(oldComp != newSwipeComp)
    {
      if(oldComp == null)
      {
        ZDBClientUI.swipeArea.appendChild(newSwipeComp);
      }
      else
      {
        ZDBClientUI.swipeArea.replaceChild(newSwipeComp,oldComp);
      }
      ZDBClientUI.swipeArea.curComp = newSwipeComp;
    }
  }

  this.checkIfRespValid = function(tab)
  {
    if(tab.removed) {return false;}
    if(ZDBClientUI.integrated && (ZDBClientUI.selectedTab.view != null)
       && (ZDBClientUI.selectedTab.view.objId != tab.view.objId)){return false;}
    return true;
  }

  this.$$ = function(elName)
  {
    var el = this.$(elName);
    ZDBUtil.removeNonElements(el);
    return el;
  }

  this.$ = function(elName)
  {
    var el = this[elName];
    if(el == null)
    {
      this[elName] = el = document.getElementById(elName);
    }
    return el;
  }


  this.createDummyTab = function(objId,displayName,tabComp,type,objKey,parentViewId, isNoTabComp)
  {
    var view = new DummyView(objId,displayName,type,tabComp,objKey,parentViewId);
    var tab = this.createTab(view,tabComp, isNoTabComp);
//    this.selectTab(tab);
    return tab;
  }

  this.createEmptyTab = function(isNoTabComp)
  {
    var tab = ZDBUtil.templateCreator("_tabComp");//No I18N
    tab = tab.cloneNode(true);
    ZDBUtil.setNamedChildEls(tab,tab);
    if(ZDBClientUI.standAlone)
    {
      tab.tabIcon = $("ZDBMainLoader");
      setTimeout(function(){ZDBClientUI.appendTabIconToBody(tab.tabIcon);},1000);
    }
    tab.viewCtx = new ZDBUIViewCtx(tab);
    return tab;
  }

  this.createUpdateDummyTab = function(objId,displayName,type,tab,objKey,parentViewId)
  {
    var dummyViewComp = ZDBClientUI[ZDBClientUI.typeDefns[type].dummyView];
    if(tab == null)
    {
      tab = this.createDummyTab(objId,displayName,dummyViewComp,type,objKey,parentViewId);
    }
    else
    {
      var view = new DummyView(objId,displayName,type,dummyViewComp);
      tab.viewCtx.handle(view);
    }
    return tab;
  }

  this.toCheckIfTabAlreadyOpen = function(objId, displayName, type) {
    if(objId < 0 && ZDBClientUI.tabOrderList.length) {
      for(var i = 0; i < ZDBClientUI.tabOrderList.length; i++ ) {
        var tab = ZDBClientUI.tabOrderList[i];
        var view = tab.view;
        if(view.objId < 0 && view.type == type && view.displayName == displayName) {
          this.selectTab(tab);
          return tab;
        }
      }
      return false;
    }
  }
  
  this.appendTabIconToBody = function(tabIcon)
  {
    if(tabIcon.parentNode != document.body)
    {
      document.body.appendChild(tabIcon);
    }
  }

  this.isObjectInView = function(objId)
  {
    var tabNameList=ZDBContentCache.appendAndGet("Tab_List","GridMenu",document.body);
    if(tabNameList.parentNode != document.body){document.body.appendChild(tabNameList);}
    ZDBUtil.setNamedChildEls(tabNameList,tabNameList,"item");
    ZDBUtil.removeAllChildren(tabNameList.tbody);
    var tabs = ZDBClientUI.tabOrderList;
    for(var i=0; i< tabs.length; i++)
    {
      if(tabs[i].view.objId == objId)
      {
        return true;
      }
    }
    return false;
  }

  this.selectTabFromList = function(el)
  {
    ZDBMenuUtil.closeMenu();
    var element = DOMUtils.getSelfOrParentWithTagName(el, 'li'); //No I18N
    var tab = element.tabRef;
    ZDBClientUI.selectTab(tab);
    ZDBClientUI.resizePlaceHolder();
    tab.view.resize(true);
  }
  
  this.removeTabFromList = function(el,event)
  {
    var element = DOMUtils.getParentWithTagName(el, 'li'); //No I18N
    var tab = element.tabRef;
    ZDBTabHandler.removeSelectedTab(tab,event);
  }

  this.createTab = function(view,comp, isNoTabComp)
  {
    var tab = ZDBClientUI.createEmptyTab(isNoTabComp);
    this.initializeTab(tab,view,comp);
    if(!isNoTabComp) {
        ZDBNavigation.restructureTabHolder(tab);
        ZDBClientUI.tabOrderList.push(tab);
        ZDBClientUI.openedViewsObjId.push(view.objId);
    }
    return tab;
  }

  this.selectTabEl = function(el, event)
  {
    var parNode = DOMUtils.getElOrParentWithAttr(el,"parTab");//NO I18N
    this.selectTab(parNode);
  var x = setTimeout(function(){ZDBTabSwitchHandler.executeMatchedFuncsInQ(parNode.view);},1000);
    ZDBUtil.stopEventBubble(event);
    if(ZDBNavigation.popOut)
    {
       ZDBNavigation.popInNavigation(true);
  }

  }
  this.openedViewsObjId = [];
  this.fetchViewEl = function(el,event,dnthighlight)
  {
    ZDBMenuUtil.closeMenu();
    ZDBUtil.stopEventBubble(event);
    var parNode = DOMUtils.getSelfOrParentWithAttr(el,"objId");//NO I18N
    if(!dnthighlight)
    {
    ZDBNavigation.deHighlightListItem(parNode);
    }
    var objId = parNode.getAttribute("objId");
    var tab = ZDBClientUI.getExistingTab(objId);
    if(tab != null)
    {
      ZDBClientUI.ZRSTabHolder.parentElement.scrollLeft = tab.offsetLeft;
      this.selectTab(tab);
      return;
    }
//    else {
//        $("ZDBBody").querySelector(".ZRSepTabLayer").style.display = "block";
//        ZDBClientUI.resizePlaceHolder();
//    }
    if(typeof ZDBExpViewHandler !="undefined"){
      //For client portal case ZDBExpViewHandler is not loaded.     
      var viewInfo = ZDBExpViewHandler.fetchViewListInfo(objId);
      var dbId = ZDBClientUI.dbId;
    }
    else{
      //Client portal - tabbed view case (No left side panel and secondary js file is not loaded)
      //All values are in attribute - there is no attibute called dispname - compied old code
      //dbId - multiple views from different databases will be listed
      //# reference - To be modified
      var viewInfo = [objId, parNode.getAttribute("dispname"), parNode.getAttribute("objtype")];
      var dbId = DOMUtils.getParentWithAttr(parNode,"dbid").getAttribute("dbid");
    }
    var dispName = viewInfo[1];//ZDBExpViewHandler.VIEW_NAME
    var type = viewInfo[2]; //ZDBExpViewHandler.VIEW_TYPE
    this.fetchView(objId,dbId,dispName,type,null);
  }

  this.fetchView = function(objId,dbId,dispName,type,tab,objKey,parentViewId, isEdit)
  {
    var tab = this.createUpdateDummyTab(objId,dispName,type,tab,objKey,parentViewId);
    ZDBClientUI.typeDefns[type].fetchView(objId,tab.viewCtx, isEdit);
  }



  this.createView = function(dbId,parentViewId,parDispName,type,tab)
  {
    ZDBMenuUtil.closeMenu();
    if(type == "AnalysisView" || type == "Pivot" || type == "SummaryView")
    {
      if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ZDBAnalysisEditList","ChartTPVendors","ZRJSChartsList","ZAVMFilterList","zdbjs/analysisedit/ZDBFieldsView.js","ZAAnalysisFields"],"APPENDTODOC",ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab]))
      {
        return;
      }
        urls = ["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_VMFILTERSTYLES"];//NO I18N
        if(!ZDBLazyLoadUtil.loadCssOnly(urls, "APPENDTODOC", ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab]))
        {
          return;
        }
        if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab]))
        {
          return;
        }
    }
    else if(type == "Report" || type == "QueryTable")
    {
      if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBGridList", "ZRQueryEditor"],"APPENDTODOC",ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab])) //NO I18N
      {
        return;
      }
      if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_QUERYEDITOR", "CSSLIST_GRIDSTYLES", "CSSLIST_VMFILTERSTYLES"],"APPENDTODOC",ZDBClientUI.createView,[dbId,parentViewId,parDispName,type,tab])){
        return
      }
    }

    var viewName = ZDBI18NMap.g(ZDBClientUI.typeDefns[type].newName);
    tab = ZDBClientUI.createUpdateDummyTab(ZDBClientUI.curDummyViewId--,viewName,type,tab);
    tab.view.parentViewId = parentViewId;
    ZDBClientUI.typeDefns[type].createView(tab.viewCtx,type,dbId,parentViewId,parDispName,
                                           tab.view.objId);
    }


  this.updateViewInTab = function(view,tab)
  {
    ZDBClientUI.initializeTab(tab,view,view.viewComp);
    ZDBClientUI.selectTab(tab);
  }


  this.getExistingTab = function(objId)
  {
    if(objId == null){objId = "";}
    var tabs = this.tabOrderList;
    var noOfTabs = tabs.length;
    if(!noOfTabs)
    {
      return null;
    }
    for(var i=0,j = noOfTabs; i < j; i++)
    {
      var tab = tabs[i];
      if((tab.getElementsByTagName) && (tab.view.objId == objId))
      {
        return tab;
      }
    }
  }

  this.updateLayout =function(tab)
  {
  var view = tab.view;
//    if(view.type=="QueryTable" && !ZDBClientUI.standAlone)
//    {
//      if(!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList","APPENDTODOC",null)){
//        return;
//    }else{
//      ZDBSQLTable.appendSQLFunctionList();
//    }
//    }
    ZDBUtil.removeNonElements(this.placeHolder);
    this.placeHolder.className = "alpha0";
    var newComp = tab.comp;
    if(!newComp)
    {
      return; //"design view fix"  //No i18N
    }

    ZDBMenu.updateToolbar(view);

    var oldComp = this.placeHolder.oldComp; //this.placeHolder.firstChild;
    if(oldComp && oldComp.parentNode != this.placeHolder)
    {
      oldComp = null;
    }
    
    if(oldComp != newComp)
    {
      if(oldComp != null)
      {
        this.placeHolder.replaceChild(newComp,oldComp);
      }
      else
      {
        this.placeHolder.appendChild(newComp);
      }
      this.placeHolder.oldComp = newComp;
      this.resizePlaceHolder();
      view.setScrollPosition(false);
    }
    this.placeHolder.className = "showView100";
    if(ZDBClientUI.isRemoteDB && view.type == "Explorer" &&
      ZDBClientUI.dbConfig.rdbView && ZDBClientUI.dbConfig.rdbView.mismatchCount)
    {
      RDBPage.showMismatchInExp(ZDBClientUI.dbConfig.rdbView.mismatchCount);
    }
  }

  this.updateDisplayName = function(tab,displayName,desc)
  {
    var headerEl = tab.tabHeader;
    jQuery(headerEl).attr("tip",displayName).bind("mouseover",function(event){ZDBToolTip.checkLengthAndShow(this,event);}).bind("mouseout",function(){ZDBToolTip.hide(this);});//No I18N
    headerEl.innerHTML = ZDBEscapeUtil.encodeForHtml(displayName);
    ZDBNavigation.resizeTabHolderWidth(ZDBClientUI.ZRSTabHolder);
    var view = tab.view;
    if(!view.dialogStatus || view.dialogStatus == 0)
    {
        view.displayName = displayName;
        if(desc)
        {
          view.description = desc;
        }
        if(view.toolbar)
        {
          ZDBMenu.updateViewTitleNDesc(view);
        }
    }
  }

  this.selectTab = function(tab, fromPopState) // if from pop state we don need to push the state to history
  {
    ZRSMenu.closeAllMenu();
    if(tab!=ZDBNavigation.explorerTab)
    {
    var indexOfTab=ZDBClientUI.tabOrderList.indexOf(tab);
    var len =ZDBClientUI.tabOrderList.length;
    if(indexOfTab != -1 && indexOfTab!=len-1){ //if the opening view is not in top
       ZDBClientUI.tabOrderList.splice(indexOfTab, 1);
       ZDBClientUI.tabOrderList.push(tab);
    }
    }
    if(tab != this.selectedTab)
    {
        this.unselectTab();
    }

    var childEls = null;

        childEls = ZDBClientUI.tabOrderList;

    
    for(var i=0;i < childEls.length; i++)
    {
      if( childEls[i].view.type == "NewOption" ) {
        if(childEls[i].view.displayName == ZDBI18NMap.g("zrpt.common.js.newReport")) {
          childEls[i].className = "ZRSTabComp AnalysisViewObj " + ((childEls[i] == tab)?
                        "tabSelected":"tabNotSelected");    //No I18N
        }
        else if(childEls[i].view.displayName == ZDBI18NMap.g("zrpt.common.js.newTable")){
          childEls[i].className = "ZRSTabComp TableObj " + ((childEls[i] == tab)?
                        "tabSelected":"tabNotSelected");    //No I18N
        }
      }
      else {
          childEls[i].className = childEls[i].view.type + "Obj ZRSTabComp " + ((childEls[i] == tab) ?
                                        "tabSelected":"tabNotSelected"); //No i18N
      }
    }
    if(!ZDBGlobal.integrated)
    {
      var title =  ZDBGlobal.EXPBROWSERTXT + " - ";
      title += tab.tabHeader.getAttribute("tip");
      document.title = title;
    }
    
    this.updateLayout(tab);
    ZDBClientUI.selectedTab = tab;
    ZDBClientUI.navigatable.view = tab.view;
    tab.view.setVisible();
    ZDBNavigation.selectCorrespondingOpt(tab);
    if(tab.view.type == "Dasboard") { dashView.resize(true);}
    if(tab == ZDBNavigation.explorerTab)
    {
        jQuery("#ZRViewSelectedInNav").attr("id", ""); //No i18N
        var headerDisplay = (ZDBExpViewHandler.isViewListEmpty() && ZDBClientUI.isDBOwner ) ? "none" : "block"; //No i18N
        jQuery(".newExpHeader").css("display", headerDisplay); //No i18N
        ZDBClientUI.resizeRightExplorerView();
    }
    
    //Need to add a function to show the opened tab to visible area if the tab is opened from moreTabs option
    var curView = tab.view;
    var viewType = curView.type;
    if(window.ZDBDataGrid && curView instanceof ZDBDataGrid)
    {
      curView.onFocus(null, false);
    }

    if(curView.dialogStatus > 0)
    {
        ZDBInlineDialog.showOrHideInlineDlgDiv(tab,true);
        hideCustomMessage();
    }
    var modeChanged = (tab.layoutMode != ZDBClientUI.layoutMode);
    ZDBNavigation.showOrHideNavIcon(curView,modeChanged);
    tab.layoutMode = ZDBClientUI.layoutMode;
    if( curView.editMode && (viewType == "AnalysisView" || viewType == "Pivot" || viewType == "SummaryView"))
    {
      curView.checkNSendTblColInfoReq();
    }
    if(!fromPopState) {ZDBNavigation.pushToHistory(curView.objId,curView.displayName); }
  }

  this.unselectTab = function()
  {
    var oldTab = ZDBClientUI.selectedTab;
    ToolTip.hide();
    ZDBMenuUtil.closeMenu();

    if(oldTab && oldTab.view.dialogStatus > 0)
    {
        hideCustomMessage();
        ZDBInlineDialog.showOrHideInlineDlgDiv(oldTab,false);
    }

    var view = null
    if(oldTab!=null)
    {
      view = oldTab.view;
      view.setScrollPosition(true);
      view.setHidden();
    }

    ZDBClientUI.selectedTab = null;
  }

  this.newViewAdded = function(view)
  {
    var tab = view.viewCtx.tab;
    ZDBClientUI.updateDisplayName(tab,view.displayName);
    if(tab.isDialog)
    {
      return;
    }
    ZDBClientUI.selectTab(tab);
    ZDBNavigation.refreshExplorer();
  }

    this.removeTabEl = function(el)
    {
      var tab = DOMUtils.getSelfOrParentWithAttr(el,"parTab");//NO I18N
      if(tab==null)
      {
        tab=el;
      }
      if(!this.checkAskSaveView(tab.view,ZDBI18NMap.g("zrpt.common.analysis.js.closing"),this))
      {
        return;
      }
      this.removeTab(tab);
    }

    this.removeTab = function(tab)
    {
        tab.removed = true;
        if(!ZDBGlobal.integrated)
        {
            var index=ZDBClientUI.tabOrderList.indexOf(tab);
            ZDBClientUI.tabOrderList.splice(index, 1);
            if(ZDBGlobal.ISNEWLAYOUT) {
                var moreTabInd = ZDBNavigation.moreTabs.indexOf(tab);
                if(moreTabInd > -1) {
                    ZDBNavigation.moreTabs.splice(moreTabInd, 1);
                    ZDBNavigation.moveToMoreTabs(ZDBClientUI.ZRSTabHolder.parentElement);
                }
            }
            if(ZDBClientUI.selectedTab != ZDBNavigation.explorerTab)
            {
                var nextTab = ZDBClientUI.tabOrderList[ZDBClientUI.tabOrderList.length-1]
                nextTab = (nextTab==null) ? ZDBNavigation.explorerTab : nextTab;
                this.selectTab(nextTab);
            }
        }
        else
        {
        ZDBClientUI.unselectTab();
        }
        var menuList = jQuery("#ZRNavigationViewListComponent");    //No I18N
        var objId = tab.view.objId;
        var viewType = tab.view.type;
        var index = ZDBClientUI.openedViewsObjId.indexOf(objId);
        if( index > -1) {
            ZDBClientUI.openedViewsObjId.splice(index, 1);
        }
        ZDBTabSwitchHandler.deleteViewInQ(tab.view);
        ZDBTabSwitchHandler.clearWMSQueue(tab.view);
        if(tab.parentNode) {tab.parentNode.removeChild(tab);}
        //ZDBNavigation.restructureTabHolder();
        tab.view.removeView();
        tab.view = null;
   }

    this.trashView = function(clickType, requestOptions)
    {
      var el = requestOptions["ELEMENT"];
      var objId = (el) ? el.getAttribute("objId") : requestOptions["OBJID"];    //No I18N
      var viewInfo = ZDBExpViewHandler.fetchViewListInfo(objId);
      var objName = viewInfo[ZDBExpViewHandler.VIEW_NAME];
      var objType = viewInfo[ZDBExpViewHandler.VIEW_TYPE];
      if(clickType == "NO")
      {
        return;
      }
      AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=MOVEOBJECTTOTRASH",
                                 PARAMETERS:"OBJID="+objId+"&CHECKVIEWDEP=true",  //No i18N
                                 ONSUCCESSFUNC:ZDBClientUI.resourceRemoved,
                                 OBJID:objId,OBJNAME:objName,OBJTYPE:objType,
                                 OPSTATUSID:"ZDBMainLoader"}); //No i18N
    }


    this.trashObject = function(el)
    {
      var viewId = el.getAttribute("objId");
      var viewName = ZDBExpViewHandler.getviewListData(viewId, ZDBExpViewHandler.VIEW_NAME);
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.delObjConfirm",ZDBEscapeUtil.encodeForHtml(viewName)),"ZDBYESNO",{ONCLICK:this.trashView,ELEMENT:el});   //No I18N
    }

    this.trashObj = function(clickType, requestOptions)
    {
      if(clickType == "NO")
      {
        return;
      }
      var arr = requestOptions["OBJIDS"];
      var objId = requestOptions["OBJID"];
      var type = requestOptions["OBJTYPE"];
      ZDBExpViewHandler.removeElFromExpView(arr);
      AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=MOVEOBJECTTOTRASH",
                           PARAMETERS:"OBJID=" + objId + "&CHECKVIEWDEP=false&OBJIDS=" + arr, //No i18N
                           ONSUCCESSFUNC:ZDBClientUI.updateOpenedTabs,
                           OBJID:objId,OBJTYPE:type});
    }

    this.resourceRemoved = function(response,requestOptions)
    {
          var params = response.getResponseParams();
          var refTablesStr = (params["REFTABLES"]);
          var objType = requestOptions["OBJTYPE"];
          var objId = requestOptions["OBJID"];
          var arr = (refTablesStr.length > 0) ? refTablesStr.split(",") : [];
          if(arr.length > 0)
          {
            var title = ZDBI18NMap.g('zrpt.common.analysis.errmsg.js.refErrDlgTtl');
            var innerHTML = "<br><b>"+ZDBI18NMap.f("zrpt.common.analysis.errmsg.js.delTblWithRefObjErr",ZDBEscapeUtil.encodeForHtml(requestOptions["OBJNAME"]))+"</b><br>";
            for(var i = 0; i < arr.length; i++)
            {
              innerHTML = (i == 0) ? (innerHTML + ZDBEscapeUtil.encodeForHtml(arr[i])) : (innerHTML + ", " + ZDBEscapeUtil.encodeForHtml(arr[i]));
            }
            ZDBUtil.showRefErr(innerHTML,title);
            return;
          }
          var depViewsStr = (params["DEPVIEWS"]);
          arr = (depViewsStr.length > 0 ) ? depViewsStr.split(",") : [];
          var type = requestOptions["OBJTYPE"];
          var trashTab = ZDBClientUI.ZRSTabHolder.getElementsByClassName("TrashTabObj")[0];
          if(trashTab) {
          ZDBTrash.fetchTrashObjectsListForDB(trashTab); }
          if(arr.length > 0)
          {
            ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.delTblWithDepViewConfirm",type.toLowerCase()), "ZDBYESNO", //No i18N
                              {ONCLICK:ZDBClientUI.trashObj,OBJIDS:arr,OBJID:requestOptions["OBJID"],OBJTYPE:type});
            return;
          }
         ZDBExpViewHandler.removeElFromExpView(objId.split(","));
         ZDBClientUI.updateOpenedTabs(response,requestOptions);
    }
    
  this.updateOpenedTabs = function(response,requestOptions) {
     var objIds = response.getResponseParams()["OBJIDS"].split(","); //No i18N
     var objType = requestOptions["OBJTYPE"];
     var objId = requestOptions["objId"];
     ZDBClientUI.removeObjects(objIds);
     if(objType == "Table" || objType == "QueryTable")
     {
        ZDBClientUtil.deleteJsonForObjId(objId);
     }
     
     ZDBNavigation.refreshExplorer();
 }

  this.removeObjects = function(objIds)
  {
    ZDBClientUI.TBLLIST = (objIds.length > 0) ? null : ZDBClientUI.TBLLIST;
    var childNodes = ZDBClientUI.tabOrderList;
    var objLen = objIds.length;
    for(var i=0; i < childNodes.length; i++)
    {
        var child = childNodes[i];
        if(objIds.indexOf(child.view.objId) > -1)
        {
            ZDBClientUI.removeTab(child);
            if(--objLen == 0){
                break;
            }
            i--;
        }
    }
  }

  this.showDlgToSaveModViews = function() {
    if(!ZDBLazyLoadUtil.loadSnippet("ZDBUNSAVEDVIEWS_DLG","/ZDBUnsavedList.cc",ZDBClientUI,"APPENDTODOC"))
      {
        return true;
      }
      var tabs = ZDBClientUI.tabOrderList;
      var unsavedTabs = [], unSavedTabList = ""; modified = false;
      var unSavedListCon = ZDBUtil.getCachedRef(ZDBClientUI, 'unSavedListContainer');
      var unsavedViewtemp = jQuery(".alertViewList"); //No I18N
      var unSavedList = jQuery(unSavedListCon).find(".unsavedListAlert").empty();
      for(var i=0;i < tabs.length;i++)
      {
        if(tabs[i].view.modified != 0)
        {
          var viewtemp = unsavedViewtemp.clone();
          unsavedTabs.push(tabs[i]);
          viewtemp.find(".viewTypeIcon").addClass(tabs[i].view.type);
          viewtemp.find(".ZDBExpData").text(tabs[i].view.displayName);
          unSavedList.append(viewtemp[0]);
          modified = true;
        }
      }
      if(unsavedTabs.length == 1)
      {
        ZDBTabHandler.removeSelectedTab(unsavedTabs[0]);
      }
      else{
          var title = ZDBI18NMap.f("zrpt.common.js.SaveAll");
          ZDBDialogUtil.showDialog(unSavedListCon,{TITLE: title, ADDFRAME:true, MODAL: true});
      }
  }

 this.onBeforeWindowUnLoad = function()
  {
    if(ZDBClientUI.dontCheckForModified == true)
    {//This is for QA - In order to refresh and proceed to next test case with out stopping.
      return;
    }
    var tabs = ZDBClientUI.tabOrderList;
   var modified = false; 
    if(ZDBClientUI.modified)
    {
        modified = true;
    }
    for(var i=0;i < tabs.length;i++)
    {
      if(tabs[i].view.modified != 0)
      {
        modified = true;
        ZDBClientUI.showDlgToSaveModViews();
        break;
      }
    }
    
    if(modified)
    {
        return "\n "+ZDBI18NMap.g("zrpt.common.browser.js.unsavedInformationErr")+" \n"; //No i18N
    }
  }
 
  this.checkAskImgSave = function(view,operation,obj,label,func)
  {
     if(func == null)
     {
      func =  arguments.callee.caller;
     }
     var args = func.arguments;
     if(!args)
     {
        args = [];
     }
     if(func.OPTION != null){return func.OPTION;}
     if(view.modified != 0 && !ZDBGlobal.integrated)
     {
       args = LangUtils.cloneArray(args);
       ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.analysis.js.save2ExportConfirmMsg")
                           ,"ZDBYESNO",{ONCLICK:this.handleImgExportSaveOption,OWNEROBJECT:obj,FUNC:func, //No i18N
                                                            ARGS:args,LABEL:label,VIEW:view},
                           view.displayName + " "+ZDBI18NMap.g("zrpt.common.analysis.js.isModified"));
       return false;
     }
     return true;
  }

  this.handleImgExportSaveOption = function(clickType,requestOptions)
   {

     if(clickType == "YES")
     {
       requestOptions["HANDLESAVE"] = ZDBClientUI.invokeAfterOption;
       requestOptions["VIEW"].save(requestOptions);
     }
   }


  this.checkAskSaveView = function(view,operation,obj,label)
  {
    if(view == null){return true;}
    return this.checkAskSave(view,operation,obj,label,arguments.callee.caller);
  }

  this.checkAskSave = function(view,operation,obj,label,func)
  {
    if(func == null)
    {
      func =  arguments.callee.caller;
    }
    var args = func.arguments;
    if(!args)
    {
        args = [];
    }

    if(func.OPTION != null){return func.OPTION;}

    if(ZDBUtil.isViewModified(view))
    {
      args = LangUtils.cloneArray(args);
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.operationOnModifiedViewConfirm",operation) +" ?","ZDBSAVE",{ONCLICK:this.handleSaveOption,OWNEROBJECT:obj,FUNC:func, ARGS:args,LABEL:label,VIEW:view},view.displayName + " "+ZDBI18NMap.g("zrpt.common.analysis.js.isModified"));  //No I18N
      return false;
    }
    return true;
  }

  this.handleSaveOption = function(clickType,requestOptions)
  {
    if(clickType == "NO")
    {
      if(requestOptions["VIEW"].clearModified)
      {
        requestOptions["VIEW"].clearModified();
      }
      else
      {
        //console.error("Clear modified has not been implemented for this view!!");
        //alert("Clear modified has not been implemented for this view!!");
      }
      if(requestOptions["VIEW"].refError)
      {
      requestOptions["VIEW"].refError = false;
      }
      ZDBClientUI.invokeAfterOption(requestOptions);
    }
    else if(clickType == "YES")
    {
      requestOptions["HANDLESAVE"] = ZDBClientUI.invokeAfterOption;
      requestOptions["VIEW"].save(requestOptions);
    }
  }

  this.invokeAfterOption = function(requestOptions)
  {
    var func = requestOptions["FUNC"];
    try
    {
      func.LABEL = requestOptions["LABEL"];
      func.OPTION = true;
      func.apply(requestOptions["OWNEROBJECT"],requestOptions["ARGS"]);
    }
    finally
    {
      delete func.LABEL;
      delete func.OPTION;
    }

  }

  this.getParentViewId = function(objId)
  {

    var pTabView = ZDBClientUI.selectedTab.view;

    if((pTabView.objId!=null && pTabView.parentViewId == null) || objId!=null)
    {
      var objectId = (objId!=null)?objId:pTabView.objId;
      var objectLink = $("OBJ_"+objectId);
      if(objectLink)
      {
        var parentTR = DOMUtils.getParentWithAttr(objectLink,"parentviewid");
        var parentViewId = parentTR.getAttribute("parentviewid");
      }
    }

    if(pTabView.parentViewId != null)
    {
      var parentViewId = pTabView.parentViewId;
    }

    return parentViewId;
  }




  this.getSelectedViewIndex = function()
  {
    return this.viewOption.selectedIndex;
  }


  /**
   * An internal method. Maybe unnecessary complexity??
   */
  this.initializeTab = function(tab,view,comp)
  {
    if((tab.view != null) && (tab.view != view))
    {
      tab.view.removeView();
    }
    view.viewCtx = tab.viewCtx;
    tab.view = view;
    view.tab = tab;
    tab.comp = comp;
    if(view.displayName && !tab.viewCtx.isZia)
    {
      this.updateDisplayName(tab,view.displayName);
    }

    tab.viewCtx.updateModified();
  }

    this.dBTypeJSON="";

  this.attachedSwipeArea = function()
  {
    ZDBClientUI.swipeArea.style.display="";
    var attachedSwipeArea = $("attachedSwipeArea");
    attachedSwipeArea.appendChild(ZDBClientUI.swipeArea);
    attachedSwipeArea.style.display="";
    var view = ZDBClientUI.selectedTab.view; // to be fixed
    view.eModeHelper.setFieldsDimension(view);
  }

  this.navPanelSwipeArea = function()
  {
    ZDBClientUI.swipeArea.style.display="";
    var attachedSwipeArea = $("attachedSwipeArea");
    var navPanelSwipeArea = ZDBClientUI.swipeAreaTD;
    var viewType = ZDBClientUI.selectedTab.view.type;
    if(ZDBClientUI.selectedNav==null
       ||(ZDBClientUI.selectedNav=="Fields" && !((viewType=="AnalysisView" || viewType=="Pivot" || viewType=="SummaryView") && ZDBClientUI.selectedTab.view.editMode))) //No i18N
    {
      var selectNav = "All"; //No i18N
    }
    else
    {
      var selectNav = ZDBClientUI.selectedNav
    }

    ZDBClientUI.selectNavTab(selectNav);
    navPanelSwipeArea.appendChild(ZDBClientUI.swipeArea);
    if(attachedSwipeArea!=null){attachedSwipeArea.style.display="none";}
  }
  
    this.initJSVariables = function(json)
    {
        ZDBGlobal._ZVER_ = json.SERVERVERSION;
        ZDBGlobal.REPORTS_CONTEXT_NAME = json.REPORTSCONTEXTNAME;
        ZDBGlobal.isZDomain = json.ISZOHODOMAIN;
        ZDBGlobal.isFujiDomain = json.ISFUJIDOMAIN;
        ZDBGlobal.checkForVersion = json.CHECKSERVERVERSION;
        ZDBGlobal.isCRMPlusUser = json.ISCRMPLUSUSER;
        ZDBGlobal.IS_MOBILE = json.ISMOBILEDEVICE;
        ZDBGlobal.TimeZone = json.TIMEZONE;
        ZDBGlobal.PRODUCT_NAME = json.PRODUCTNAME;
        ZDBGlobal.IS_ONPREMISE_BUILD = json.ISOPBUILD;
        ZDBGlobal.IS_SAS_BUILD = json.ISSASBUILD;
        ZDBGlobal.REPORTS_SERVER_URL = json.REPORTSSERVERURL;
        ZDBGlobal.GAPP_GADGET_URL = json.GADGETSSERVERURL;
        ZDBGlobal.GAPP_EMBED_GADGET_URL = json.GADGETSEMBERSERVERURL;
        ZDBGlobal.GAPP_ZSERVICE = json.GADGETSZSERVICE;
        ZDBGlobal.EXT_LIST_URL = json.EXTLISTURLS;
        ZDBGlobal.ALLOWED_GDRIVE_FILETYPES = json.ALLOWEDGDRIVEFILETYPES;
        ZDBGlobal.ALLOWED_CLOUD_FILETYPES = json.ALLOWEDCLOUDFILETYPES;
        ZDBGlobal.EXT_DRIVE_SERVICE = json.EXTDRIVESERVICE;
        ZDBGlobal.zuID = json.ZUID;
        ZDBGlobal.ISNEWLAYOUT = json.ISNEWLAYOUT;
        ZDBGlobal.emailID = json.EMAILID;
        ZDBGlobal.upgradeLink = json.UPGRADELINK;
        ZDBGlobal.isClientErrorLoggingEnabled = json.ENABLECLIENTERRORLOG;
        ZDBGlobal.isUserAnalyticsEnabled = json.ENABLEUSERANALYTICS;
        ZDBGlobal.isPaidCustomer = json.ISPAIDCUSTOMER;
        ZDBGlobal.isDevelopmentMode = json.ISDEVELOPMENTMODE;
        ZDBGlobal.LANDINGPAGE = json.LANDINGPAGE;
        ZDBGlobal.fontFolder = json.FONTNAME;
        ZDBGlobal.currentTheme = json.CURRENTTHEME;
        ZDBGlobal.userPlanName = json.PLANNAME;
        ZDBGlobal.isUserPhotoPresent = json.ISUSERPHOTOPRESENT;
        ZDBGlobal.isDomainRebranded = json.ISDOMAINREBRANDED;
        ZDBGlobal.SUPPORTMAILID = json.SUPPORTMAILID;
        ZDBGlobal.SUPPORTNUMBER = json.SUPPORTNUMBER;
        ZDBGlobal.DEMODATABASE = json.DEMODATABASE;
        ZDBGlobal.DOMAINLOGO = json.DOMAINLOGO;
        ZDBGlobal.DOMAINURL = json.DOMAINURL;
        ZDBGlobal.HEADERZAPPS = json.HEADERZAPPS;
        ZDBGlobal.CONTEXTPATH = json.CONTEXTPATH;
        ZDBGlobal.DOMAINHEADERHME = json.DOMAINHEADERHOME;
        ZDBGlobal.ENABLEHOMELINK = json.ENABLEHOMELINK;
        ZDBGlobal.CPDBITEM = json.CPDBITEM;
        ZDBGlobal.ENABLECOPYDBLINK = json.SHOWCOPYDBLINK;
        ZDBGlobal.ADMINTAKEOVERLINK = json.ADMINTAKEOVERLINK;
        ZDBGlobal.ENABLEADMINTAKEOVERLINK = json.ENABLEADMINTAKEOVERLINK;
        ZDBGlobal.ENABLESUBSCRIPTIONLLINK = json.ENABLESUBSCRIPTIONLLINK;
        ZDBGlobal.ISTRIALALLOWED = json.ISTRIALALLOWED;
        ZDBGlobal.ISCRMULTIMATEUSER = json.ISCRMULTIMATEUSER;
        ZDBGlobal.ENABLEFEEDBACKLINK = json.ENABLEFEEDBACKLINK;
        ZDBGlobal.ENABLEHELPLINK = json.ENABLEHELPLINK;
        ZDBGlobal.HELPLINKTIP = json.HELPLINKTIP;
        ZDBGlobal.ENABLESIGNOUTLINK = json.ENABLESIGNOUTLINK;
        ZDBGlobal.ISPUBLICUSER = json.ISPUBLICUSER;
        ZDBGlobal.SUBSCRIPTIONTEXT = json.SUBSCRIPTIONTEXT;
        ZDBGlobal.DBID = json.DBID;
        ZDBGlobal.HEADERSIGNINTEXT = json.HEADERSIGNINTEXT;
        ZDBGlobal.CONTACTSSERVERURL = json.CONTACTSSERVERURL;
        ZDBGlobal.ZAPPSTLD = json.ZAPPSTLD;
        ZDBGlobal.ISDEMO = json.ISDEMO;
        ZDBGlobal.USERPROFILEPHOTO = json.USERPROFILEPHOTO;
        ZDBGlobal.USERFULLNAME = json.USERFULLNAME;
        ZDBGlobal.IAMURL = json.IAMURL;
        ZDBGlobal.wmsJSURL = json.WMSJSURL;
        ZDBGlobal.LOGOUTURL = json.LOGOUTURL;
        ZDBGlobal.ENABLELAYOUT = json.ENABLELAYOUT;
        ZDBGlobal.IS_NEW_LAYOUT_ENABLED = json.IS_NEW_LAYOUT_ENABLED;
        ZDBGlobal.ISBAIHUIDOMAIN = json.ISBAIHUIDOMAIN;
        ZDBGlobal.HEADERWHATSNEWTEXT = json.HEADERWHATSNEWTEXT;
        ZDBGlobal.SHOWMAKEDBPUBLIC = json.SHOWMAKEDBPUBLIC;
        ZDBGlobal.ISSTANDALONE = json.ISSTANDALONE;
        ZDBGlobal.SHOWLIVECHAT = json.SHOWLIVECHAT;
        ZDBGlobal.isSampleDbPopulated = json.ISSAMPLEDBPOPULATED;
        ZDBClientUI.isFreshUser = json.CANSHOWGETTINGSTARTDLG;
        ZDBClientUI.readOnlyMode = json.READONLYMODE;
        ZDBClientUI.isCustomDomain = json.ISCUSTOMDOMAIN;
        ZDBClientUI.showDocs = json.CANSHOWZDOCSOPT;
        ZDBClientUI.showExt = json.CANSHOWEXTERNALDRIVEOPTS;
        ZDBClientUI.showGDrive = json.ENABLEGDRIVE;
        ZDBClientUI.dbName = json.DBNAME;
        ZDBClientUI.dbDesc = json.DBDESC;
        
        ZDBGlobal.SERVICEURL = json.SERVICEURL; //on_premise
        ZDBGlobal.LOGOURL = json.LOGOURL; //on_premise
        ZDBGlobal.ISAPLUSBUILD = json.ISAPLUSBUILD; //on_premise
        ZDBGlobal.ISOPOEM = json.ISOPOEM; //on_premise
        ZDBGlobal.ISPERSONALEDITION = json.ISPERSONALEDITION; //on_premise
        ZDBGlobal.ISTRIALOREXTENDED = json.ISTRIALOREXTENDED; //on_premise
        ZDBGlobal.PHOTOURL = json.PHOTOURL; //on_premise
        ZDBGlobal.ISCLOUDUTIL = json.ISCLOUDUTIL; //on_premise
        ZDBGlobal.ISGENERALUTIL = json.ISGENERALUTIL //on_premise
        ZDBGlobal.SERVERURL = json.SERVERURL; //on_premise
        ZDBGlobal.ISDAYSLEFT = json.ISDAYSLEFT; //on_premise
        ZDBGlobal.ISVERYCRITICAL = json.ISVERYCRITICAL; //on_premise
        ZDBGlobal.ISCRITICAL = json.ISCRITICAL; //on_premise
        ZDBGlobal.ISORGADMINUSER = json.ISORGADMINUSER; //on_premise
        ZDBGlobal.MSGKEY = json.MSGKEY; //on_premise
        ZDBGlobal.CSSCLASSNAME = json.CSSCLASSNAME; //on_premise
        ZDBGlobal.DAYSSTRING = json.DAYSSTRING; //on_premise
        ZDBGlobal.DID = json.DID; //on_premise
        ZDBGlobal.SHOWSAMPLEDB = json.SHOWSAMPLEDB; //on_premise
        ZDBGlobal.ISSAMPLEDBPOPULATED = json.ISSAMPLEDBPOPULATED; //on_premise
        ZDBGlobal.CANSHOWCHAT = json.CANSHOWCHAT; //on_premise
        ZDBGlobal.isLogoRebrand = json.isLogoRebrand;
        
        ZDBGlobal.initializeFontInfo();
    }

  this.setUpDBView = function(action,dbId,objId,dispName,type,isDBOwner,isDBOwnerAndNotDBAdmin,
                              isGroupMember,
                              notLoggedIn,
                              standAlone,sampleViewStatus, privateKey, zrauthkey, authtoken, containerObjId,analysisType,folderPerm,
                              zoho_criteria,isBetaCustomer,integrationMode,fs,rsConfig,localeInfo,sessionKey,showHiddenColsInReportCreation,isRemoteDB,objKey,parentViewId,isMakePublicAllowed,isPublishAllowed,isDBExportAllowed,isFromGDrive,mode,url,tableName,fileType,isSupportAdminAccess,directFilterString)

  {
    this.dbId = dbId;
    this.isDBOwner = isDBOwner;
    this.isDBOwnerAndNotDBAdmin = isDBOwnerAndNotDBAdmin;
    this.isGroupMember = isGroupMember;
    this.notLoggedIn = notLoggedIn;
    this.standAlone = standAlone;
    this.modeHelper = (standAlone)? ZDBStandAloneMode:ZDBMainMode;
    this.zoho_criteria = zoho_criteria;
    this.directFilterString = directFilterString;
    this.folderPerm = folderPerm;
    this.sampleViewStatus = sampleViewStatus;
    this.hideOnStandAlone = standAlone || notLoggedIn;
    this.hideOnNotDBOwnerAndNotGroupUser = !(isDBOwner || isGroupMember);
    this.isBetaCustomer = isBetaCustomer;
    this.isRemoteDB = isRemoteDB;
    ZDBGlobal.integrated = integrationMode;
    this.fs = fs;
    this.rsConfig = rsConfig;
    this.isMakePublicAllowed = isMakePublicAllowed;
    this.isPublishAllowed = isPublishAllowed;
    this.isDBExportAllowed = isDBExportAllowed;
    if(isFromGDrive == "true")
    {
    var freezelayer = jQuery(document.createElement("div"));
    freezelayer.attr("class","freezeLayer"); //No I18N
    freezelayer.attr("ID","IMPORTFREEZE"); //No I18N
    freezelayer.css("top","0px");//No I18N
    freezelayer.css("opacity",'1');//No I18N
    freezelayer.css("z-index","1000");//No I18N
    jQuery(document.body).append(freezelayer);
        var loadingDiv = jQuery(document.createElement("div"));
        loadingDiv.attr("ID","ZDBMainLoader_new");// No I18N
        loadingDiv.attr("class","zdbLoading");// No I18N
        loadingDiv.attr("elname","loadingDiv");// No I18N

        loadingDiv.css("top","50%");// No I18N
        loadingDiv.css("left","50%");// No I18N
        loadingDiv.css("height","auto");// No I18N
        loadingDiv.css("margin-top","-20px");// No I18N
        loadingDiv.css("margin-left","-80px");// No I18N
        jQuery(document.body).append(loadingDiv);
        $("ZDBMainLoader_new").innerHTML = "<div elname=\"textEl\" style=\"padding: 10px 40px; vertical-align: middle; background-position: 10px 5px;white-space: nowrap\" class=\"loadingImage\">Loading</div>";

    }
  this.isSupportAdminAccess = isSupportAdminAccess;
    this.dbConfig = new DBConfig(dbId, showHiddenColsInReportCreation);

    if(ZDBGlobal.integrated)
    {
      this.layoutMode="max"; //No i18N
    }
    this.privateKey = privateKey;
    this.zrauthkey = zrauthkey;
    this.authtoken = authtoken;
    this.sessionKey = sessionKey;
    this.containerObjId = containerObjId;
    this.Objects_TBODY = document.getElementById("Objects_TBODY");
    
    if(!standAlone && !integrationMode && !ZDBClientUI.isCustomDomain && !ZDBGlobal.IS_ONPREMISE_BUILD) {
        ZRSAjax.get('/reportsapi/DATASHEETREQUESTS', 
            {
                DBID: dbId,
                CURRENTZSOID: ZDBGlobal.currentZsoId
            }, 
            {
            successHandler: {
                func: ZDBClientUI.initDatasheetVariables,
                ctx: ZDBClientUI
            },
            options: [action, objId, dispName, type, analysisType, localeInfo, objKey, parentViewId, mode, url, tableName, fileType, isFromGDrive]
        });
    }
    else
    {
        var options = [action, objId, dispName, type, analysisType, localeInfo, objKey, parentViewId, mode, url, tableName, fileType, isFromGDrive];
        ZDBGlobal.initializeFontInfo();
        ZDBClientUI.setUpDBViewContd(options);
    }
    
  };
  
  this.initDatasheetVariables = function(resp, requestOptions)
    {   
        ZROrg.handleLoadOrgDetails(resp);
        ZDBClientUI.initJSVariables(resp.datasheetJson);
        ZDBGlobal.ENABLESUBSCRIPTIONLLINK = (ZROrg.selectedOrgZsoid == ZDBGlobal.adminZsoId);
        ZDBClientUI.loadBaseSVGIcons();
        ZDBClientUI.templateLoadSuccess(requestOptions["options"]);
    }
    
    this.templateLoadSuccess = function(requestOptions)
    {
        if(!ZDBLazyLoadUtil.loadJsAlone("ZRSDatasheet_TEMPLATE","APPENDTODOC", ZDBClientUI.templateLoadSuccess, [requestOptions])) {
            return;
        }
        
        var par = $("ZDBHEADER").children[1];
        var template = ZRSStringTemplateCreator.createTemplateForData('homepage', 'zrsheader'); //No I18N 
        par.appendChild(template);
        template = ZRSStringTemplateCreator.createTemplateForData('zohoapps', 'zrsheader');//No I18N 
        par.appendChild(template);
        template = ZRSStringTemplateCreator.createTemplateForData('signOutLinkMenu', 'zrsheader');//No I18N 
        par.appendChild(template);
        template = ZRSStringTemplateCreator.createTemplateForData('headerhelpmenu', 'zrsmenu');//No I18N 
        par.appendChild(template);
        ZROrg.loadProfileImage();
        var themeEl = $("ZRAccountOptions").querySelector("."+ZDBGlobal.currentTheme);
        ZDBUtil.addClass(themeEl, "theme-selected");
        if(ZDBGlobal.tabLayer == "1") {
            var par = $("ZDBMainHeader");
            var tabpar = par.children[0];
            template = ZRSStringTemplateCreator.createTemplateForData('topbarTab', 'zrsheader');//No I18N
            template.children[0].style.width = par.offsetWidth - (tabpar.offsetWidth + par.children[1].offsetWidth + 80) + "px";
            tabpar.appendChild(template);
        }
        ZDBClientUI.setUpDBViewContd(requestOptions);
        if(!ZDBGlobal.integrated && !ZDBClientUI.isCustomDomain && !ZDBGlobal.IS_ONPREMISE_BUILD && !(ZDBGlobal.LANDINGPAGE === 'ZDBHome' && ZDBGlobal.ISNEWLAYOUT))
        {
            setTimeout(ZDBClientUI.loadWMS, 1500);
        }
    }
  
  this.setUpDBViewContd = function(requestOptions)
  {
      this.initReferences();
      this.resizeAllDInst();
      ZDBToolTip.init();
      this.updateScrollSize();

      if(requestOptions[0] == "ENTERDATA")
      {
        ZDBNavigation.initializeExplorerView(false);
        setTimeout(function(){ZDBCreateViewAPI.fetchEnterDataView(null, null, ZDBClientUI.dbId,false,ZDBI18NMap.g("zrpt.table.existimport.step1.js.untitled1"));},100);
      }
      else if(requestOptions[0] =="CREATEANALYSIS")
      {
        this.createView(ZDBClientUI.dbId,requestOptions[1],"Sheet",requestOptions[4],null); //No i18N
      }
      else if(requestOptions[0] == "VUD")
      {
        ZDBVUDataAPI.sendVUDRequestInWindow(requestOptions[1]);
      }
      else if(!ZDBClientUI.standAlone && !ZDBGlobal.integrated)
      {
          ZDBNavigation.initializeExplorerView();//$$$ - Remember the main loading clash
          if(requestOptions[1] != null)
          {
            this.fetchView(requestOptions[1],ZDBClientUI.dbId,requestOptions[2],requestOptions[3],null,requestOptions[6],requestOptions[7]);
            var url = "ZDBDataSheetView.cc?DBID=" + ZDBClientUI.dbId + "&OBJID="+requestOptions[1];//No I18N
            history.replaceState(requestOptions[1], requestOptions[2], url);
          }
      }

      if(!ZDBGlobal.integrated)
      {
        jQuery(window).resize(
                function()
                {
                  ZDBClientUI.handleWindowResize();
                }
        );
        window.onbeforeunload = this.onBeforeWindowUnLoad;
        window.onfocus = ZDBClientUI.focusMain;
      }

      if(this.isRemoteDB)
      {
        this.setUpRDBConnInfoObj(ZDBClientUI.dbId);
      }

      setTimeout(function(){ZDBContentCache.contentCache(requestOptions[5]);},1000);
      ZDBVersionCheck.checkVersionChange();
      if(!ZDBClientUI.standAlone && !ZDBGlobal.integrated){
          this.loadBaseSVGIcons();
          ZDBNavigation.navSelect.value = ZDBClientUI.Objects_TBODY.getAttribute("navigType");
          ZDBExpViewHandler.valueFetch(ZDBClientUI.dbId, ZDBNavigation.navSelect.value);
          ZDBNavigation.setLayout();
      }
    if(requestOptions[12] == "true")
      {
          this.handleCreateDBResp_new(requestOptions[8],requestOptions[9],requestOptions[10],requestOptions[11]);
      }
  }

this.handleCreateDBResp_new = function(mode,url,tableName,extn)
  {
      
    $("ZDBMainLoader").className = "zdbLoading";
    if(!ZDBLazyLoadUtil.loadJsAlone(["import/js/ZDBImport.js","template/js/ZDBTemplate.js"],this,ZDBClientUI.handleCreateDBResp_new,[mode,url,tableName,extn]))
  {
    return;
  }
    if(ZDBClientUI.notLoggedIn)
    {
      document.body.removeChild($("IMPORTFREEZE"));
  document.body.removeChild($("ZDBMainLoader_new"));
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.newrpt.js.signIn2CreateNewRpt",ZDBGlobal.PRODUCTNAME));
      return;
    }
    if(!ZDBClientUI.isDBOwner)
    {
      document.body.removeChild($("IMPORTFREEZE"));
      document.body.removeChild($("ZDBMainLoader_new"));
      //ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.newtbl.js.noPerm2CreateNewTbl"));
      return;
    }
    if(mode == "readDoc")
    {
    var params = "&DBID="+ZDBClientUI.dbId+// No I18N
    "&LOCATION="+"GINTEG"+// No I18N
    "&TABLENAME="+tableName+// No I18N
    "&FILETYPE="+ZDBUtil.replaceAll(extn,'.','').toUpperCase()+// No I18N
    "&URL="+encodeURIComponent(url)+// No I18N
    "&ZDBFILESUBTYPE="+extn+// No I18N
    "&ZDBFILENAME="+encodeURIComponent(url)+// No I18N
    "&isFromGInteg="+true;//No I18N
    
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBImportData.cc?ZDBACTION=CREATETABLEFROMGDRIVE"+params, METHOD:"POST",
        ONSUCCESSFUNC:ZDBClientUI.handleGIntegTable,ONFAILUREFUNC:ZDBClientUI.handleGIntegTableError});
    }
    else
    {
        ZDBCreateViewAPI.showCreateNewTblDlg(false,true,mode);
    }
    
  }
  this.handleGIntegTableError = function(response,requestOptions)
  {
  document.body.removeChild($("IMPORTFREEZE"));
  document.body.removeChild($("ZDBMainLoader_new"));
  var msg = response.getResponsePart("STATUS_MESSAGE");
  ZDBAlertAPI.showMsg(msg);
  }
  this.handleGIntegTable = function(response,requestOptions)
  {

    if(!ZDBLazyLoadUtil.loadSnippet("CREATE_NEW_TABLE_GINTEG","/ZDBCreateTableViaImport.cc?&DBID="+ZDBClientUI.dbId,this,"APPENDTODOC",null,ZDBClientUI.handleGIntegTable,[response,requestOptions]))
    {
      return;
    }
    if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBGridList"],"APPENDTODOC",ZDBClientUI.handleGIntegTable,[response,requestOptions]))
    {
      return false;
    }
          if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC",ZDBClientUI.handleGIntegTable,[response,requestOptions])){
    return false;
  }
  ZDBCreateViewAPI.showCreateNewTblDlg(false,true,"readDoc",response);//No I18N     
  }
  this.importGDriveFile=function(response)
  {
      var div = document.createElement("div");
  div.id = "ZDBImportFile";
  div.style.width="100%";
  div.style.height="100%";
  div.innerHTML = response.getOnlyHtml();
  var dlg = $("ZDBCREATEDIALOG").cloneNode(true);
  jQuery(dlg).find("#ZDBCreateDBCntTd")[0].innerHTML = ""
  jQuery(dlg).find("#ZDBCreateDBCntTd")[0].appendChild(div);
   //var tab = ZDBClientUI.createDummyTab(ZDBClientUI.curDummyViewId--,"sd",dlg,
                                         //"NewOption");
    //ZDBClientUI.selectTab(tab);
    
    window.curStep = 1;
    window.totStep = 2;
    ZDBInlineDialog.showDialog(dlg,{MODAL:true,VIEW:ZDBClientUI.selectedTab.view});
    response.invokeScripts();
    $("ZDBPreviousDBBtn").style.display = "none";
  
  document.body.removeChild($("IMPORTFREEZE"));
  document.body.removeChild($("ZDBMainLoader_new"));
    
      
  }
  this.documentReadyState = function() {
      if(document.readyState == 'complete'){
          if(ZDBGlobal.LANDINGPAGE === "ZDBDataSheetView")
              ZDBClientUI.checkAndRedirectForApps();
          if(typeof ZRSupportClass != "undefined")
              ZRSupportClass.handleInitialLiveChatVisibility();
          // For Global Notification
          if(!ZDBClientUI.standAlone){
              if(typeof ZROrg != 'undefined' && ZDBGlobal.LANDINGPAGE != "ZDBHome") {
                ZROrg.loadProfileImage();// For home page it is handled in the initail html template load method
              }
              
              switch(ZDBGlobal.LANDINGPAGE){
                case "ZDBDataSheetView": //NO I18N
                  setTimeout(lazyLoadJSAndCssFiles, 2000);
                break;
                case "ZDBHome":  //NO I18N
                  setTimeout(lazyLoadJSAndCssFilesHome, 2000);
                break;
              }
          }  
      }
  };
  
  this.loadWMS = function()
  {
      if(!ZDBLazyLoadUtil.loadJsAlone("//"+ZDBGlobal.wmsJSURL, "APPENDTODOC",ZDBClientUI.loadWMS,null,null,true,true)) //last arg is for excluding crossorigin attribute
      {
          return;
      }
      if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/ui/GlobalNotification.js", "APPENDTODOC",ZDBClientUI.loadWMS))
      {
          return;
      }

      ZDBClientUI.initGlobalNotification();
  }

  this.initGlobalNotification = function () {
    if(typeof WMSSessionConfig != 'undefined') {
      // Initialize WMS framework
      var settings = WMSSessionConfig.CROSS_PRD;
      WebMessanger.setIamServer(ZDBGlobal.IAMServerURL);
      WebMessanger.setConfig(settings);
      WebMessanger.setNoDomainChange();
      WebMessanger.register('ES', ZDBGlobal.zuID, true); // No I18N
      WebMessanger.disableNetworkDownBanner();

      // Requests the server for notification feed
      GlobalNotification.get();
    }
    
    if(typeof Collaboration != "undefined") {

        Collaboration.handleCustomMessage = function (json) {
            switch(json.event){
              case "newGlobalNotification"://NO I18N
                  GlobalNotification.emit(json.data);
                  break;
              case "notificationPreferenceChange"://NO I18N
                  GlobalNotification.preferences[json.data.type] = json.data.value;
                  GlobalNotification.applyPreferencesInUI();
                  break;
              case "WMS_SNAPSHOT_EVENT"://NO I18N
                  if(ZDBGlobal.ISNEWLAYOUT){
                      ZRSCardPreviewHandler.handleSnapshowWMSEvent(json);
                  }
                  break;
              case "LAZYLOAD_EVENT": //No I18N
                  ZALazyLoadData.handleLazyLoadEvent(json);
                  break;
              case "NEW_USER_OR_GROUP_ADDED": // No I18N
                  setTimeout(function() { (typeof Contacts != "undefined") && Contacts.get(true); }, 5000); // No I18N
                  break;
            }
        };

        if(ZDBGlobal.isQAEnabled) {
            WebMessanger.reload = undefined;
        }
    }
  };
  
  this.setUpRDBConnInfoObj = function(dbId)
  {
    if(!ZDBLazyLoadUtil.loadJsAlone(["ZRRemoteDB"],"APPENDTODOC",ZDBClientUI.setUpRDBConnInfoObj,[dbId]))
      {
          return;
      }
    var url = "/RDBAction.ma?";   //No I18N
    var params = "&ZDBACTION=GETCONNECTIONDETAILS&DBID=" + dbId;  //No I18N
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,DBID:dbId,METHOD:"GET",
      ONSUCCESSFUNC:ZDBClientUI.setRDBConnectionDetails});
  }
  
  this.setRDBConnectionDetails = function(response,requestOptions)
  {
    var respObj=JSON.parse(response.responseText);
    var dbId = requestOptions["DBID"];
    ZDBClientUI.dbConfig.rdbView = new ZRRemoteView(dbId, respObj.conid,respObj.dbname,respObj.servicename,respObj.dbtype,respObj.createdtime,respObj.lastsynctime);
    RDBPage.checkConnectionInDBExp(dbId);
  }
  
  this.checkAndRedirectForApps = function(){
    if(document.readyState == 'complete' && (getCookie("APPCHECKSHOWN")!= "true") && !ZDBClientUI.standAlone){
      if(BROWSER.IPAD || (BROWSER.ANDROID && navigator.userAgent.toLowerCase().indexOf("mobile") == -1)){
        var el = jQuery("#ZDBAppCheck");//NO I18N
        var height = window.innerHeight;
        var linkContainter = el.find("#linkContainer");
        var appDesc = el.find("#AppDesc");
        ZDBClientUI.handleAppCheckLinkPositioning(height, linkContainter, appDesc);
        el.find("#Container").height(height);
        (BROWSER.IPAD)?(el.find("#ZRPlayLink").hide()):(el.find("#ZRItuneLink").hide());
        document.body.style.margin = '0px';//NO I18N
        el.show();
        ZDBClientUI.appCheckShown = true;
        window.addEventListener("resize",ZDBClientUI.handleAppCheckResize);//NO I18N
        setCookie("APPCHECKSHOWN",true);//NO I18N
    }
  }
  }
  
  this.handleAppCheckLinkPositioning = function(height, jqueryEl1, jqueryEl2){
    if(height <= 600){
      jqueryEl1.css("bottom", "28px");//NO I18N
      jqueryEl2.css("top", "13px");//NO I18N
    }
    else if(height <=700){
      jqueryEl1.css("bottom", "65px");//NO I18N
      jqueryEl2.css("top", "41px");//NO I18N
    }
    else if(height <=800){
      jqueryEl1.css("bottom", "114px");//NO I18N
      jqueryEl2.css("top", "75px");//NO I18N
    }
    else if(height <= 900){
      jqueryEl1.css("bottom", "156px");//NO I18N
      jqueryEl2.css("top", "108px");//NO I18N
    }
    else if(height <= 1000){
      jqueryEl1.css("bottom", "186px");//NO I18N
      jqueryEl2.css("top", "129px");//NO I18N
    }
    else if(height <= 1100){
      jqueryEl1.css("bottom", "186px");//NO I18N
      jqueryEl2.css("top", "129px");//NO I18N
    }
    else if(height > 1100){
      jqueryEl1.css("bottom", "229px");//NO I18N
      jqueryEl2.css("top", "183px");//NO I18N
    }
  }
  
  this.handleAppCheckResize = function(){
    if(ZDBClientUI.appCheckShown){
      var height = window.innerHeight;
      var el = jQuery("#ZDBAppCheck");//NO I18N
      var linkContainter = el.find("#linkContainer");
      var appDesc = el.find("#AppDesc");
      ZDBClientUI.handleAppCheckLinkPositioning(height, linkContainter, appDesc);
      jQuery("#Container").height(height);//NO I18N
      return;
    }
  }
  
  this.closeCheckApps = function(){
    jQuery("#ZDBAppCheck").hide();//NO I18N
    ZDBClientUI.appCheckShown = false;
  }

  this.handleWindowResize = function()
  {
     if(ZDBClientUI.windowResizeTimeout != null)
        {
        clearTimeout(ZDBClientUI.windowResizeTimeout);
        }
     ZDBClientUI.windowResizeTimeout = setTimeout("ZDBClientUI.resizeAllDInst(true)",500);
     return true;
  }

  this.openView=function(el,event)
  {
    ZDBToolTip.hide();
    ZDBDialogUtil.closeDialog();
    var objId=jQuery(el).attr("objId"); //No I18N
    var dbId=jQuery(el).attr("dbId"); //No I18N
    var dispName=jQuery(el).attr("dispName"); //No I18N
    var type=jQuery(el).attr("type"); //No I18N
    var tab = ZDBClientUI.getExistingTab(objId);
    if(tab != null)
    {
      this.selectTab(tab);
      return;
    }
    this.fetchView(objId,dbId,dispName,type,null);
  }

  this.updateScrollSize = function()
  {
    var div = $("ZDBTPLGRIDAREA");
    if(div.offsetHeight == 0)
    {
      document.body.appendChild(div.parentNode);
    }
    ZDBGlobal.scrollThick = ZDBGlobal.scrollWidth = ZDBGlobal.getScrollThickness();
    div.parentNode.parentNode.removeChild(div.parentNode);
  }


  this.saveAll = function()
  {
    var unsavedNewView, childNodes = ZDBClientUI.tabOrderList;
    ZDBDialogUtil.closeDialog();
    for(var i=0; i < childNodes.length; i++)
    {
      var child = childNodes[i];
      if(!child.view.modified)
      {
        continue;
      }
      else{
        ZDBClientUI.selectTab(child);
        if(!ZDBUtil.isNewView(child.view)) {
              child.view.save();
        }
        else if(!unsavedNewView){
          unsavedNewView = child.view;
        }
      }
    }
    if(unsavedNewView) {
      unsavedNewView.save();
      return;
    }
    return true;
  }

  this.changeFont = function(fontName)
  {
    AjaxAPI.sendRequest({URL:"/ZDBDatabaseActionMI.ma?ZDBACTION=CHANGEFONT",
                               PARAMETERS:"FONTNAME="+ encodeURIComponent(fontName), //No I18N
                               ONSUCCESSFUNC:ZDBClientUI.reload,
                               OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.changeTheme = function(themeName,path)
  {
    AjaxAPI.sendRequest({URL:"/ZDBDatabaseActionMI.ma?ZDBACTION=CHANGETHEME",
                               PARAMETERS:"THEMENAME="+encodeURIComponent(themeName), //No i18N
                               ONSUCCESSFUNC:ZDBClientUI.reload,
                               OPSTATUSID:"ZDBMainLoader"}); //No i18N
  }

  this.reload = function()
  {
    window.location.reload();
    //window.location.href=window.location.href;
  }

   this.handleProjectsMenu = function(isProjDB)
   {
        var projElt = $("ZDBEXPLORERPROJECTS_TITEM");
  if(isProjDB != true && projElt)
      {
          DOMUtils.addCSSClass([projElt],"disabledonnotsaved");
          DOMUtils.addCSSClass([projElt],"notpermitted");
          projElt.onclick = null;
      }
   }
   
   this.setImportOptions = function(showDocs, showExt, showGDrive, customDomain)
   {
     this.isCustomDomain = customDomain;
     this.showDocs = showDocs;
     this.showExt = showExt; 
     this.showGDrive = showGDrive;
   }

}

ZDBClientUI.getViewObj = function(el,property)
{
  var curEl = el;
  while(curEl && (curEl[property] == null))
  {
    curEl = curEl.parentNode;
  }
  if(curEl == null){return null;}
  return curEl[property];
}

var ZDBStandAloneMode = new function()
{
   this.dummyFunc = function(){};
   this.removeObjects = this.dummyFunc;
   this.selectTab = this.dummyFunc;
}

var ZDBMainMode = new function()
{
   this.removeObjects = function(objIds)
   {
    ZDBClientUI.TBLLIST = null;
    ZDBNavigation.removeObjects(objIds);
   }

   this.selectTab = function()
   {
    ZDBTabHandler.moveToVisibleArea();
   }
}

  ZDBClientUI.clearCache = function()
  {
    ZDBClientUI.TBLLIST = null;
    AllowedValPopup.cache = new Object();
    if(typeof ZDBAnalysisCaching !== "undefined"){//For datatype change in table, ZDBAnalysisCaching will not be loaded.
      ZDBAnalysisCaching.cachedFields = new Object();
    }
  }

  ZDBClientUI.positionComboHdr = function(cellObj,dArea)
  {
    var comboHdr = cellObj.comboHdr;
    var drillFlow = cellObj.originalValue;
    if(drillFlow)
    {
      var jObj = JSON.parse(drillFlow);
      var flowDet  = jObj[ZDBDesignGrid.getColumnDataTypeForField(cellObj)];
      if(flowDet.length>1)
      {
       jQuery(comboHdr.compElContainer).attr({DRILLCOLID:flowDet[0],DRILLTBLID:flowDet[1],DRILLCOLADDONTYPE:flowDet[2],DRILLCOLOPERATION:flowDet[3],DISPCOLNAME:flowDet[4]});
       comboHdr.displaySelected.innerHTML = ZDBEscapeUtil.encodeForHtml(flowDet[4]);
       comboHdr.displaySelected.setAttribute("value",ZDBEscapeUtil.encodeForHtml(flowDet[4]));
      }
    }
    var left = ZDBUtil.getObjLeft(cellObj.cellEl,false,dArea);
    var top = ZDBUtil.getObjTop(cellObj.cellEl,false,dArea);
    comboHdr.style.position = "absolute";
    comboHdr.style.top = top-1+"px";
    comboHdr.style.left = left-1+"px";
    comboHdr.displaySelected.style.width = (cellObj.cellEl.offsetWidth - 28)+"px";
  }
  
  ZDBClientUI.showCombo = function(response,requestOptions)
  {
    var cellObj;
    cellObj = requestOptions["CELLOBJ"]; ///PK: You must believe in hell
    var div = document.createElement("div");
    div.innerHTML = response.getOnlyHtml();
    ZDBClientUI.TBLLIST = div.childNodes[0];
    ZDBClientUI.showList(cellObj,requestOptions["OBJID"]);
  }

  ZDBClientUI.showList = function(cellObj,objId)
  {
    var orglist = ZDBClientUI.TBLLIST;
    var list = orglist.cloneNode(true);
    if((typeof ZDBQa) == "object")
    {//Qa
       if(list.id) {list.id = "";}
       list.id = cellObj.id;
    }
    var nodeList = list.getElementsByTagName("optgroup");
    var length = nodeList.length;
    var toRemove;
    for(var i=0 ; i<length; i++)
    {
        var grpNode = nodeList.item(i);
        var curObjId = grpNode.getAttribute("objId");
        if(curObjId == objId)
        {
            toRemove = grpNode;
        }
    }
    if(toRemove != null && toRemove != undefined)
    {
        list.removeChild(toRemove);
    }

    ZDBEditors.configureListEditor(cellObj,list);
    list.onchange = ZDBDesignGrid.customFunc;
    list.onblur = function(event){return ZDBEditors.onListBlur(this,event);};
    ZDBEditors.showListEditor(cellObj,list);
  }  
  ZDBClientUI.validateEmail = function(field) 
  {    
    var regex=/^([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x22([^\x0d\x22\x5c\x80-\xff]|\x5c[\x00-\x7f])*\x22)(\x2e([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x22([^\x0d\x22\x5c\x80-\xff]|\x5c[\x00-\x7f])*\x22))*\x40([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x5b([^\x0d\x5b-\x5d\x80-\xff]|\x5c[\x00-\x7f])*\x5d)(\x2e([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x5b([^\x0d\x5b-\x5d\x80-\xff]|\x5c[\x00-\x7f])*\x5d))*$/;    
    return (regex.test(field)) ? true : false;  
  }
  
    ZDBClientUI.openGettingStartedDlg = function(el)
    {
        if(!ZDBLazyLoadUtil.loadJsAlone("main/js/ZRGettingStarted_new.js", "APPENDTODOC", ZDBClientUI.openGettingStartedDlg)) {
            return;
        }

        ZRSAjax.get('/reportsapi/GETTINGSTARTEDINIT', null, {
            successHandler: {
                func: ZRGettingStarted.gettingStartedDlg,
                ctx: ZRGettingStarted
            }
        });
    }
  
  ZDBClientUI.hoverLinkInGS = function(el,hover)
  {
        var parent=jQuery(el).parents("[elname='gsoption']"); //No I18N
        var ico=parent.find("div");
        var className=ico.attr("elname"); //No I18N
        var link=parent.find("[elname='txt']");
        if(hover)
        {    
            ico.removeClass().addClass(className+"Hover");  //No I18N
            link.removeClass().addClass("gsLinkTxtHover");  //No I18N
        }
        else
        {
            ico.removeClass().addClass(className);
            link.removeClass().addClass("gsLinkTxt"); //No I18N
        }
  } 
  
  ZDBClientUI.closeVideoDialog=function(isEsc)
  {
      var dlg=$("gsvideoHolder");
      dlg.style.display="none"
      dlg.freezeLayer.style.display="none";
      jQuery(".gsiframe").removeAttr("src"); //No I18N
      if(!isEsc){ev.escKeyPressStack.pop();} 
      ZDBClientUI.gsVideoOpened = false;
      ZDBUtil.removeChildrenWithClass(document.body, "freezeLayer"); //No I18N
  }
  
  ZDBClientUI.showVideo=function(src)
  {
      var dlg=$("gsvideoHolder");
      if(!dlg)
          {
            dlg=document.createElement('div');  
            dlg.setAttribute("id","gsvideoHolder");
            dlg.appendChild(jQuery(".gsiframeholder").show()[0]);
            document.body.appendChild(dlg);
            var freezeLayer = document.createElement("DIV");
            freezeLayer.className = "freezeLayer";
            freezeLayer.style.zIndex = 1100;
            dlg.freezeLayer = freezeLayer;
            document.body.appendChild(dlg.freezeLayer);
          }
          else
          {
                  dlg.style.display="";
                  dlg.freezeLayer.style.display="";
          }
      dlg.style.zIndex = 4000;
      try{
        var width = document.body.getBoundingClientRect().width / 2 - dlg.getBoundingClientRect().width / 2;
        dlg.style.left = width + "px"; 
      }
      catch(e){
        //error in getBoundingClientRect
      }
      ZDBClientUI.gsVideoOpened = true;
      jQuery(".gsiframe").attr("src",src+"&autoplay=1"); //No I18N
      ev.addEscHandle(ZDBClientUI.closeVideoDialog);
  }

  ZDBClientUI.getDispName = function(viewId)
  {
      var el = ZDBUtil.getElWithTagNAttrWithVal(ZDBClientUI.swipeArea, "objid", viewId, "tr"); //No I18N
      return (el ? el.getAttribute("dispname"): null);
  }
  
  ZDBClientUI.hideSubscriptionLink = function(isSharedDB)
  {
      if(!isSharedDB)
          {
              jQuery("#ZRSubscriptionLink").hide(); //No I18N
          }
  }

  ZDBClientUI.loadLiveChat = function(){
    if(!ZDBClientUI.liveChatLoadingDivGen){
      var loadDiv = ZDBUtil.getCloned(document.querySelector("#ZDBMainLoader"));//NO I18N
      loadDiv.className = "zdbLoaded";//NO I18N
      ZDBUtil.setNamedChildEls(loadDiv,loadDiv);
      loadDiv.textEl.innerHTML = ZDBI18NMap.g("zrpt.common.js.activlivechat") + "...";//NO I18N
      loadDiv.id="ZRLiveChatLoading";//NO I18N
      document.body.appendChild(loadDiv);
      ZDBClientUI.liveChatLoadingDivGen = true;
      ZRUserAnalytics.checkAndPushToServer("LiveChat","SalesIQ","Support",null,{planName:ZDBGlobal.userPlanName});//NO I18N
    }
    if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/ui/ZRSalesIq.js","APPENDTODOC",null,null
      ,"ZDBMainLoader")){//NO I18N
      return;
    }
    ZRSalesIq.fireClick();
  }

  ZDBClientUI.copyToClipboard = function(text, elname) {
    try {
      ZDBClientUI.pasteArea.value = text;
      ZDBClientUI.pasteArea.select();
      if(document.execCommand('copy')) {
        ZDBClientUI.pasteArea.value = '';
        var el = jQuery('#' + elname);
        if(el.length > 0) {
          el.stop().fadeIn(300).delay(2000).fadeOut(300);
        }
      }
    }
    catch(err) {
      // Unsupported Browser
    }
  };


/*  --------------------- visualize More Video Play and close functions  ------------------------------ */

ZDBClientUI.showNewReleaseDlg = function() {
    var banner = $("newReleaseBan");
     ZDBDialogUtil.freezeBackground(banner, "fullPageFreezeLayer"); //No i18N
     ZDBUtil.addClass(banner, "showBan");
}

ZDBClientUI.visualizeMoreVideoPlay = function (el) {
    var videoArea = document.getElementsByClassName("conVideoImg")[0];
    ZDBUtil.removeClass(videoArea, "imageView");
    videoArea.getElementsByClassName("video_play")[0].style.display = "none";
    var videoFrame = videoArea.getElementsByClassName("videoFrame")[0];
    videoFrame.children[0].setAttribute("src", "https://www.youtube.com/embed/qmWvaILTs5U?&autoplay=1");
    videoFrame.style.display = "block";
}

ZDBClientUI.closeVisualizeMoreDlg =  function (e) {
   AjaxAPI.sendRequest({
            URL:"/ZDBUserAction.ma?ZDBACTION=TOVISUALIZEMORE", //No I18N
            ONSUCCESSFUNC:ZDBClientUI.removeVisualizeBanner
            });
}
ZDBClientUI.removeVisualizeBanner = function () {
    var banner = $("newReleaseBan");
    banner.className = "popUpContainer";
    setTimeout(function () {
        if (banner.freezeLayer)
        {
            document.body.removeChild(banner.freezeLayer);
        }
        banner.parentElement.removeChild(banner);
    }, 400);
};
ZDBClientUI.showShare = function(isFolderShare, isViewShare) {
  if (!ZDBLazyLoadUtil.loadJsAlone('JS_SHARING_MODULE', this, ZDBClientUI.showShare, [isFolderShare, isViewShare])) { return; }
  if (!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_SHARING_MODULE"], "APPENDTODOC", ZDBClientUI.showShare, [isFolderShare, isViewShare])) { return; }
  ZRShare.show(isFolderShare, isViewShare);
};
ZDBClientUI.editSharedDetails = function(isItFromNavigation) {
  if (!ZDBLazyLoadUtil.loadJsAlone('JS_SHARING_MODULE', this, ZDBClientUI.editSharedDetails, [isItFromNavigation])) { return; }
  if (!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_SHARING_MODULE"], "APPENDTODOC", ZDBClientUI.editSharedDetails, [isItFromNavigation])) { return; }
  ZRShare.editSharedDetails(isItFromNavigation);
};
ZDBClientUI.getDBShareInfo = function () {
  if (!ZDBLazyLoadUtil.loadJsAlone('JS_SHARING_MODULE', this, ZDBClientUI.getDBShareInfo, [])) { return; }
  if (!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_SHARING_MODULE"], "APPENDTODOC", ZDBClientUI.getDBShareInfo, [])) { return; }
  ZRShare.getDBShareInfo();
};

document.onreadystatechange = ZDBClientUI.documentReadyState;
