//$Id$

var ZAVMFilter = new function()
{
    this.START_VAR_PATTERN = "${";
    this.END_VAR_PATTERN = "}";
    this.VAR_REGEX_PATTERN = new RegExp("(,|^)\\$\\{[^~`!@#$%^&*+=[\\]';,/{}|\\\\<>()\\\"?]*\\}(,|$)");
    this.ALL_KEY = "All"; //No I18N
    this.OTHERS_CR_KEY = "$$$Others$$$"; //No I18N
    this.OTHERS_KEY = "Others"; //No I18N
    this.UNKNOWN_KEY = "Unknown"; //No I18N
    this.ARLCount=0;
    this.prevEl = null;
    this.tmpLstCntr = rem$("tmpLstCntr");
    this.MApplydiv = rem$("MApplydiv");
    this.MAllSlcOp = rem$("MAllSlcOp");
    this.SSLiopt = rem$("SSLiopt");
    this.tmpLstCntrForSrch = rem$("tmpLstCntrForSrch");
    this.resizableOptTmp = rem$("resizableOptTmp");//resizable option for vmflist
    this.IncRelLstUl = rem$("IncRelLstUl");
    
    this.refreshView = function(el,view, isResetFilters)
    {
        if(view==null){
            view = ZDBClientUI.getViewObj(el,"view"); //NO I18N
        }
        (view.type=="Dashboard")?(view.dashLayout ? ZRDashboardAPI.refreshViews(el, !isResetFilters, true) : ZDBDashboardAPI.refreshViews(el, !isResetFilters, true)):view.refreshView();
        //(view.type=="Dashboard")?ZRDashboardLayoutAPI.refreshViews(el):view.refreshView(); $#Dash#$
    }

    this.getAllVMFilterCriteria = function(view,xmlBuf)
    {
    	var component;
    	var canCascade = false;
    	if(view.curComponent!=null){
    		component=view.curComponent;
    	}
    	
        view.isVMFilterApplied = false;
        var childNodes = view.VMFiltersList;
        if(childNodes == null)
        {
            return;
        }
//        var dashUFConfig = view.DashUFConfig;
        if(view.viewCtx.dashView) // Should send dashboard UF details also when it is in the dashboard
        {
          var dashUFConfig = ZDBDashboardUF.getDashDynFltrConfig(view.viewCtx);
          xmlBuf.a(dashUFConfig);
        }
        if(view.viewCtx.dashChildDiv && view.viewCtx.dashChildDiv.getAttribute("showVMFilter")=="false")
        {
          return;
        }
        for(var i =0,len = childNodes.length;i<len;i++)
        {
            var childNode = childNodes[i];
            if(!childNode.filterHead)
            {
                childNode.elnameSet = false;
            }
            if(childNode.getAttribute("IS_VALID_COL")!="true")
            {
              continue;
            }
            ZDBUtil.setNamedChildEls(childNode,childNode,"elname");//NO I18N
//            ZAVMFilter.checkForDefaultCriteria(childNode, view);
            var func = childNode.filterHead.getAttribute("valFunc");
            var exclude = childNode.getAttribute("EXCLUDE");
            var cr = this[func](childNode,view);
            var lbl = childNode.getAttribute("LABEL");
            var colid = childNode.getAttribute("COLUMN_ID");
            if(cr != null)
            {
                view.isVMFilterApplied = true;
                var dcr = childNode.compElContainer.getAttribute("dispselval");
                if(component!=null && lbl==component.getAttribute("label")){
                	continue;
                }
                canCascade=true;
                xmlBuf.sTag("zavmfv").attr("cr", cr)//NO I18N
                      .attr("dcr", dcr)//Currently generating dcr as cr itself.//NO I18N
                      .attr("lbl",lbl)//NO I18N
                      .attr("cno",colid)//NO I18N
                      .attr("ex",exclude) //NO I18N
                       .attr("isDashCr",view.type=="Dashboard") //NO I18N
                      .attr("ft",childNode.getAttribute("FIELD_COL_TYPE"))  //NO I18N
                      .attr("po" ,childNode.getAttribute("PARENT_OBJ_ID")) //NO I18N
                      .attr("op",childNode.getAttribute("OPERATION")) //NO I18N
                      .eTag();//NO I18N
            }
        }
        if(view.curComponent)
        {
        	view.curComponent.canCascade = canCascade && component.getAttribute("CASCADELIST")=="true";
        }
    }
    this.checkAndUpdateDefaultValue=function(view)
    {
    	var childNodes = view.VMFiltersList;
    	if(childNodes == null)
        {
            return;
        }
    	if(view.viewCtx.dashChildDiv && view.viewCtx.dashChildDiv.getAttribute("showVMFilter")=="false")
        {
          return;
        }
        for(var i =0,len = childNodes.length;i<len;i++)
        {
            var childNode = childNodes[i];
            if(!childNode.filterHead)
            {
                childNode.elnameSet = false;
            }
            if(childNode.getAttribute("IS_VALID_COL")!="true")
            {
              continue;
            }
            ZDBUtil.setNamedChildEls(childNode,childNode,"elname");//NO I18N
            ZAVMFilter.checkForDefaultCriteria(childNode, view);
        }
    }
    
    this.checkForDefaultCriteria = function(childNode, view)
    {
        var selVal = childNode.compElContainer.getAttribute("selVal");
        if(selVal != null || selVal == "" )
        {
            return;
        }	
        // if criteria is not set it should filter the chart with default criteria
        var optionListHeader =  childNode.compElContainer;
        var criteria = childNode.getAttribute("CRITERIA");
        var dispCriteria= childNode.getAttribute("DISPLAYCRITERIA");
        if(criteria!==null && criteria!=="")
        {
          criteria = criteria.charAt(criteria.length-1)!=="," ? criteria+"," : criteria;
          dispCriteria = dispCriteria.charAt(dispCriteria.length-1)!=="," ? dispCriteria+"," : dispCriteria;
        }
        var includeOthers = (criteria.indexOf(ZAVMFilter.OTHERS_CR_KEY)!=-1);
        var relcriteria = childNode.getAttribute("REL_CRITERIA")==null ? "" : childNode.getAttribute("REL_CRITERIA");
        var reldispCriteria= childNode.getAttribute("REL_DISPCRITERIA") == null ? "" : childNode.getAttribute("REL_DISPCRITERIA");
        criteria = criteria+relcriteria;
        dispCriteria = dispCriteria+reldispCriteria;
        var isAllVal = (childNode.getAttribute("ISALLVAL")=="true");
        var uiType = childNode.getAttribute("UITYPE");
        if( uiType== "1" || uiType =="6")//checking for date range and slider components ; if it is Date range no need to set default criteria
        {
            if(!isAllVal)
            {
                optionListHeader.setAttribute("selVal",criteria);
                optionListHeader.setAttribute("dispSelVal",dispCriteria);
                optionListHeader.setAttribute("displayVal",dispCriteria);
            }
            return;
        }
        var defCr = childNode.getAttribute("DEFAULTCRITERIA");
        defCr = ZDBUtil.replaceStr(defCr, "--S--", "$"); //NO I18N
        var defDispCr = childNode.getAttribute("DEFAULTDISPLAYCRITERIA");
        var clickToSelect = (!defDispCr && uiType =="4") ? ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.clicktoselect") : null;
        var valOfVar = childNode.getAttribute("VALUEOFVAR");
        var dispVarCr = childNode.getAttribute("DISPVALUEOFVAR");
        if(dispVarCr!=null && dispVarCr!="")
        {
            dispVarCr = ZAVMFilterUtil.trimCommaAtEnd(dispVarCr);
        }

        var isDefCrNCrEqual = (!isAllVal && ZAVMFilter.isCrEqual(defCr,criteria));
        ZDBUtil.setNamedChildEls(optionListHeader,optionListHeader,"elname");//NO I18N
        var exclude = "false";
        //if all values is selected , in case od default values prence it should filter with def value or else it should show with out filtering
        if(isAllVal)
        {
            if(defCr!="")
            {
                if(valOfVar == null)
                {
                    optionListHeader.setAttribute("selVal",defCr);
                    optionListHeader.setAttribute("dispSelVal",defDispCr);
                    optionListHeader.setAttribute("displayVal",defDispCr);
                    exclude = "false";
                }
                else
                {
                    ZAVMFilter.setAttributeForVar(optionListHeader, valOfVar, dispVarCr);
                    exclude = "false";
                }
            }
            else
            {
                optionListHeader.removeAttribute("selVal");
                optionListHeader.removeAttribute("dispSelVal");
                optionListHeader.removeAttribute("displayVal");
                exclude = "false";
            }
        }
        //if not all values ie, selected values
        else
        {
            if(defCr=="")
            {
                //if default criteria is null, if not others is checked it should filter with only the selected values or else it wont have any filter criteria
                 if(includeOthers)
                {
                    if(valOfVar == null)
                    {
                        optionListHeader.removeAttribute("selVal");
                        optionListHeader.removeAttribute("dispSelVal");
                        optionListHeader.removeAttribute("displayVal");
                        exclude = "false";
                    }
                    else
                    {
                        ZAVMFilter.setAttributeForVar(optionListHeader, valOfVar, dispVarCr);
                        exclude = "false";
                    }
                }
                else
                {
                    optionListHeader.setAttribute("selVal",criteria);
                    optionListHeader.setAttribute("dispSelVal",dispCriteria);
                    optionListHeader.setAttribute("displayVal",dispCriteria);
                    exclude = "false";
                }
            }
            else
            {
                if(includeOthers)
                {
                    if(isDefCrNCrEqual) // def criteria not null and others is included , if default criteria and criteria is equal then no filtring id needed
                    {
                        optionListHeader.removeAttribute("selVal");
                        optionListHeader.removeAttribute("dispSelVal");
                        optionListHeader.removeAttribute("displayVal");
                        exclude = "false";
                    }
                     // if display criteria not includes others , filters just the display criteria . if it includes others then it should include the excluded selected values in place of thers
                    else if(defDispCr.indexOf(ZAVMFilter.OTHERS_KEY)<0)
                    {
                        if(valOfVar == null)
                        {
                            optionListHeader.setAttribute("selVal",defCr);
                            optionListHeader.setAttribute("dispSelVal",defDispCr);
                            optionListHeader.setAttribute("displayVal",defDispCr);
                            exclude = "false";
                        }
                        else
                        {
                            ZAVMFilter.setAttributeForVar(optionListHeader, valOfVar, dispVarCr);
                            exclude = "false";
                        }
                    }
                    else
                    {
                        var varDefCr = defCr;
                        var varDefDispCr = defDispCr;
                        if(valOfVar != null && valOfVar!="")
                        {
                            varDefCr = valOfVar+",";
                            varDefDispCr = ZAVMFilter.replaceComma(valOfVar);
                        }
                        var deselectedCr = ZAVMFilterSearch.remDefCrFromCr(varDefCr,criteria);
                        var deselectedDispCr = ZAVMFilterSearch.remDefCrFromCr(varDefDispCr,dispCriteria);
                        optionListHeader.setAttribute("selVal",deselectedCr);
                        optionListHeader.setAttribute("dispSelVal",deselectedDispCr);
                        optionListHeader.setAttribute("displayVal",defDispCr);
                        exclude = "true";
                    }
                }
                else
                {
                    // others not checked case. if cr and default criteria equal , no need to filter.if not equal criteria will be the default criteria
                     if(isDefCrNCrEqual)
                    {
                        optionListHeader.setAttribute("selVal",criteria);
                        optionListHeader.setAttribute("dispSelVal",dispCriteria);
                        optionListHeader.setAttribute("displayVal",dispCriteria);
                        exclude = "false";
                    }
                    else
                     {
                        if(valOfVar == null)
                        {
                            optionListHeader.setAttribute("selVal",defCr);
                            optionListHeader.setAttribute("dispSelVal",defDispCr);
                            optionListHeader.setAttribute("displayVal",defDispCr);
                            exclude = "false";
                        }
                        else
                        {
                            ZAVMFilter.setAttributeForVar(optionListHeader, valOfVar, dispVarCr);
                            exclude = "false";
                        }
                     }
                }
            }
        }
        optionListHeader.setAttribute("EXCLUDE",exclude);
        childNode.setAttribute("EXCLUDE",exclude);
        var isCrNdefEqual = (defCr=="" || isDefCrNCrEqual);
        var displayStr = (uiType==2)?ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all"):ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
        defDispCr = (defDispCr=="" || isCrNdefEqual)?displayStr:defDispCr;//NO I18N
        var dispDiv = childNode.displaySelected;
        childNode.compElContainer.displayValue = defDispCr;
        if(!childNode.displaySelected)
        {
            dispDiv = optionListHeader.displaySelected;
        }
        if(view.editMode)
        {
            if(uiType == "2") {
                dispDiv.value = defDispCr;
                if(!childNode.dispSelDiv) {
                    childNode.dispSelDiv = optionListHeader.dispSelDiv;
                }
                childNode.dispSelDiv.setAttribute("value", ZDBUtil.getSubString(defDispCr, 150));
            }
            else {
                dispDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(defDispCr);
            }
            dispDiv.setAttribute("value",ZDBUtil.getSubString(defDispCr,150));
            return;
        }
        var selectedVal = defDispCr;
        if(valOfVar != null)
        {
            if(dispVarCr == "" || (criteria!=null && ZAVMFilter.isVarValContainsAllCriteria(criteria, valOfVar)))
            {
                selectedVal = displayStr;
            }
            else
            {
                selectedVal = dispVarCr;
            }
        }
        if(uiType == "2") {
            dispDiv.value = selectedVal;
            childNode.compElContainer.displayValue = selectedVal;
        }
        else {
            dispDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(selectedVal);
        }
        if(clickToSelect)
        	{
        		selectedVal = clickToSelect;
        	}
        dispDiv.setAttribute("value",ZDBUtil.getSubString(selectedVal,150));
        dispDiv.setAttribute("data-tip",ZDBUtil.getSubString(selectedVal,150));
        if(childNode.dispSelDiv) {
            childNode.dispSelDiv.setAttribute("value", ZDBUtil.getSubString(selectedVal, 150));
            childNode.dispSelDiv.setAttribute("data-tip", ZDBUtil.getSubString(selectedVal, 150));
        }
    }

    this.isVarValContainsAllCriteria = function(cr, valOfVar)
    {
        var containsAll = true;
        cr = ZAVMFilterUtil.trimCommaAtEnd(cr);
        var crArr = cr.split(",");
        if(crArr.length == 1 && crArr[0]=="")
        {
            return false;
        }
        for(var i=0; i<crArr.length; i++)
        {
            var crVal = crArr[i];
            if(crVal != "" && valOfVar.indexOf(crVal)==-1)
            {
                containsAll = false;
                break;
            }
        }
        return containsAll;
    }

    this.setAttributeForVar = function(optionListHeader, valOfVar, dispValOfVar)
    {
        if(valOfVar == "")
        {
            optionListHeader.removeAttribute("selVal");
            optionListHeader.removeAttribute("dispSelVal");
            optionListHeader.removeAttribute("displayVal");
        }
        else
        {
            optionListHeader.setAttribute("selVal", valOfVar+",");
            optionListHeader.setAttribute("dispSelVal", ZAVMFilter.replaceComma(valOfVar));
            optionListHeader.setAttribute("displayVal", dispValOfVar);
        }
    }

    // replace --C-- with , and enclose it with double quotes
    this.replaceComma = function(cr)
    {
        if(cr=="") {return cr;}
        var newCr = "";
        var crArr = cr.split(",");
        for(var i=0; i<crArr.length; i++)
        {
            var crArrVal = crArr[i];
            newCr += (crArrVal.indexOf("--C--")>=0) ?
                "\"" + ZDBUtil.replaceStr(crArrVal,"--C--",",") + "\"," : crArrVal + ","; //NO I18N
        }
        return ZAVMFilterUtil.trimCommaAtEnd(newCr);
    }

    this.isCrEqual = function(defCr,cr)
    {
        defCr = (defCr.lastIndexOf(",")==defCr.length-1)?defCr:defCr+"," ;
        cr = (cr.lastIndexOf(",")==cr.length-1)?cr:cr+",";
        var defCrArray = defCr.split(",");
        var crArray = cr.split(",");
        if(defCrArray.length==crArray.length)
        {
            for(var i=0;i<defCrArray.length&&defCrArray[i]!="";i++)
            {
                cr = cr.replace(defCrArray[i]+",","");
            }
            return(cr=="");
        }
        else
        {
            return false;
        }
    }

    this.getSelectVal = function(critDiv,view)
    {
        var el = critDiv.compElContainer;
        if(el==null){return null;}
        var selVal = el.getAttribute("selVal");
        return (selVal == "All" || selVal == "" )?null:selVal;//NO I18N
    }

    this.getDateRange = function(component)
    {
        var dates = new Array();
        var dateRange = component.getAttribute("CRITERIA");
        var startPos =  dateRange.indexOf('B')+1;
        var index = dateRange.indexOf('-');
        var fromVal = dateRange.substring(parseInt(startPos),parseInt(index));
        startPos = index+1;
        index = dateRange.charAt(dateRange.length-1) == "," ? dateRange.length-1 :dateRange.length;
        var toVal = dateRange.substring(parseInt(startPos),parseInt(index));
        dates.push(fromVal, toVal);
        return dates;
    }

    this.fetchAllCriteria = function(el,labelName,event)
    {
        var optionList = ZDBUtil.getParentWithAttributeValue(el,"optionList", "true");//NO I18N
        var component = optionList.component;
        component.showMoreClicked = true ; 
        this.fetchVMFilterCriteria(component.filterHead,labelName,event,"false");
    }

    this.fetchVMFilterCriteria = function(el,labelName,event,includeCr,initialtrigger)
    {
        var component = DOMUtils.getParentWithAttr(el, "column_id");//NO I18N
        if(!component)
        {
        	var menuEl = DOMUtils.getSelfOrParentWithAttrValue(el,"elname","dateMenuEl");//No I18N
            component = menuEl.component;
        }
        component.showMoreClicked = initialtrigger ? false : component.showMoreClicked ;
        if(labelName=="")
        {
            labelName = component.getAttribute("label");
        }
        var view =  ZDBClientUI.getViewObj(component,"view");//NO I18N
        var fetchState = component.getAttribute("VMFilterFetchStatus");
        var uiType = component.getAttribute("UITYPE");
        if(( fetchState == "1")|| (fetchState == "2" && uiType=="1"))
        {
            return;
        }
        else if(component.getAttribute("CASCADELIST")!="true" && ( fetchState == "2"))
        {
            ZAVMFilter.showOptionList(component,component.compElContainer,event);
            if(uiType == "2") {
                ZAVMFilterUtil.moveCursorToEnd(component.displaySelected);
                ZAEditableUF.setInputEl(component.displaySelected);
            }
            return;
        }
        if(fetchState=="2" && uiType!="1" && (component.optionList && component.optionList.style.display!="none"))
        {
            var srcEl = ZDBUtil.getSourceElement(event);
            if((includeCr!="false") && (srcEl.getAttribute("showalldiv")!="true"))
            {
                ZAVMFilterUtil.closeList(event, true);
                return;
            }
        }
        if(view.type=="AnalysisView" || view.type=="Pivot" || view.type=="SummaryView")
        {
            ZAVMFilter.fetchVMFListForAnalysisView(view,el,component,includeCr,event);
        }
        else if(view.type=="Dashboard")
        {
             ZAVMFilter.fetchVMFListForDashView(view,el,component,includeCr,event);
        }
    }

    this.fetchVMFListForDashView = function (view, opStatusEl, component, includeCr, event, isPreLoad)
    {
        if(!ZDBTabSwitchHandler.isRelevendTab2Exec(view, view.dashQ.resumeQ)) {
            view.dashQ.suspendQ();
            return false;
        };
        var labelName = component.getAttribute("label");
        // no need to send the UF criteria since cascading is not supported. it should send true if cascading is allowed
        includeCr = (!includeCr) ? component.getAttribute("CASCADELIST") : includeCr;
        includeCr = includeCr === "true" ? true : false;
        component.setAttribute("INCLUDECR",includeCr.toString());
        view.curComponent=component;
        var doXML = ZDBDStructure.getDashBoardCurrentConfig(view, includeCr);
        //var doXML = ZRDashboardLayoutAPI.getCurrentConfig(view, includeCr); $#Dash#$
        includeCr = view.curComponent ? includeCr&&view.curComponent.canCascade: includeCr;
        view.curComponent=null;
        var viewParams = view.getViewParams();
          var srcEl = ZDBUtil.getSourceElement(event);
        var isShowAllVals = (srcEl  && srcEl.getAttribute && srcEl.getAttribute("showalldiv") === "true")//NO I18N
        if(!ZAVMFilter.isListModified(component, view, doXML) && !isShowAllVals)
        {
            ZAVMFilter.showOptionList(component,component.compElContainer, event);
            return false;
        }
        viewParams += "&PARENTVIEWID=" + component.getAttribute("PARENT_OBJ_ID");//NO I18N
        viewParams += "&=" + component.getAttribute("PARENT_OBJ_ID");//NO I18N
        viewParams += "&CONOBJID=" + view.objId; //NO I18N

        var url = ZDBClientUI.isNewRequest ? "/VMFilterDataFetch.ve?" : "/VMFilterListFetch.cc?" ; //No I18N
        url+= "VMFILTERLBLNAME=" + encodeURIComponent(labelName) + viewParams + "&VMFILTERACTION=FILTERLISTFETCH"; //No I18N
        url += "&ISDASHBOARDUF=" + true;// NO I18N
        url+="&INCLUDECR="+includeCr;//No I18N
        if (isPreLoad)
        {
            url += "&ISPRELOAD=" + isPreLoad //No I18N
        }
        if(includeCr)
        {
             var selValDetStr = ZAVMFilter.getSelValsDetails(component);
             url+="&SELVALDETSTR="+encodeURIComponent(selValDetStr);// NO I18N

        }
        AjaxAPI.sendRequest({URL: url, POSTBODY: doXML, REQUESTHEADERS: {"Content-type": "text/xml;charset=utf-8"}, //No I18N
            ONFAILUREFUNC: ZAVMFilter.onFailureFunc, VIEW: view, COMPONENT: component, INCLUDECR: includeCr, CONFIG: doXML, PRELOAD: isPreLoad,
            ONSUCCESSFUNC: ZAVMFilter.placeVMFilterCrView, OPSTATUSID: opStatusEl});
        return true;
    };
    this.fetchVMFListForAnalysisView = function(view,opStatusEl,component,includeCr,event,isPreLoad)
    {
        if(view.viewCtx && view.viewCtx.dashView && !ZDBTabSwitchHandler.isRelevendTab2Exec(view.viewCtx.dashView, view.viewCtx.dashView.dashQ.resumeQ)) {
            view.viewCtx.dashView.dashQ.suspendQ();
            return false;
        };
        view.curComponent=component;
        var labelName = component.getAttribute("label");
        var viewParams = view.getViewParams();
        includeCr = (includeCr==null || !includeCr) ? component.getAttribute("CASCADELIST") : includeCr;
        includeCr = includeCr=="true" ? true : false;
        var config = ZDBAnalysisConfig.getCurrentConfig(view,includeCr);
        includeCr = view.curComponent ? includeCr&&view.curComponent.canCascade: includeCr;
        component.setAttribute("INCLUDECR",includeCr.toString());
        view.curComponent=null;
         var srcEl = ZDBUtil.getSourceElement(event);
        var isShowAllVals = (srcEl!=null && srcEl.getAttribute && srcEl.getAttribute("showalldiv")=="true");//NO I18N
         if(!ZAVMFilter.isListModified(component,view,config)&&!isShowAllVals)
        {
             ZAVMFilter.showOptionList(component,component.compElContainer,event);
             component.setAttribute("VMFilterFetchStatus",2);
             return false;
        }
        var url = ZDBClientUI.isNewRequest ? "/VMFilterDataFetch.ve?" : "/VMFilterListFetch.cc?";//No I18N
        url+="VMFILTERLBLNAME="+encodeURIComponent(labelName)+viewParams+"&VMFILTERACTION=FILTERLISTFETCH";// NO I18N
        url+="&INCLUDECR="+(includeCr&&view.isVMFilterApplied);  //NO I18N
        url+="&ISDASHBOARDUF="+false; //NO I18N
        if(includeCr)
         {
              var selValDetStr = ZAVMFilter.getSelValsDetails(component);
              url+="&SELVALDETSTR="+encodeURIComponent(selValDetStr);// NO I18N
         }
        if(isPreLoad)
        {
            url+="&ISPRELOAD="+isPreLoad //No I18N
        }
        component.setAttribute("VMFilterFetchStatus","1");
        AjaxAPI.sendRequest({URL:url,POSTBODY:config,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                            ONFAILUREFUNC:ZAVMFilter.onFailureFunc,VIEW:view,COMPONENT:component,INCLUDECR:includeCr,CONFIG:config,PRELOAD:isPreLoad,
                            ONSUCCESSFUNC:ZAVMFilter.placeVMFilterCrView,OPSTATUSID:opStatusEl //No I18N
                            });
        return true;
    }
 
    this.placeVMFilterCrView =function(response,requestOptions)
    {
        var component = requestOptions["COMPONENT"];
        var includeCr = requestOptions["INCLUDECR"];
        var view = requestOptions["VIEW"];
        var config = requestOptions["CONFIG"];
        var isPreLoad = requestOptions["PRELOAD"];
        var uiType = component.getAttribute("UITYPE");
        var lab = component.getAttribute("label");
        if(uiType=="1")
        {
            var div = document.createElement("div");
            var el = requestOptions["OPSTATUSID"];
            if(ZDBClientUI.isNewRequest){
                var responseData = JSON.parse(response.responseText);
                var divEl = document.createElement("DIV");
                divEl.setAttribute("elname","filterHead");
                divEl.setAttribute("MINDATE",responseData.BASE_LIST[1][1]);
                divEl.setAttribute("MAXDATE",responseData.BASE_LIST[0][1]);
                div.appendChild(divEl);
            }
            else{
                div.innerHTML =response.responseText;
            }
            var filterHead = DOMUtils.getChildElsWithAttr(div,"elname","filterHead")[0]//NO I18N
            var minDate = filterHead.getAttribute("MINDATE");
            var maxDate = filterHead.getAttribute("MAXDATE");
            component.setAttribute("MINDATE",minDate);
            component.setAttribute("MAXDATE",maxDate);
            el.initialized = false;
            component.setAttribute("VMFilterFetchStatus","2");
            // ZAVMFilterComp.hideDateString(el,event);
        }
        else
        {
            if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/ios/touchbutton.js",this,ZAVMFilter.placeVMFilterCrView,[response,requestOptions]))
            {
                return;
            }
            if(component.optionList)
            {
                component.optionList.parentNode.removeChild(component.optionList);
            }
            var resElement=document.createElement("DIV");
            if(ZDBClientUI.isNewRequest){
                responseData = JSON.parse(response.responseText);
                component.jsonData = responseData;
                component.next = responseData.EXTRA_INFO.NEXT > 0 ? 0 : responseData.EXTRA_INFO.NEXT;
                var VMFlisEl = ZAVMFilter.getVMFFullLst(responseData,component,resElement,false,true);
                if(VMFlisEl!="true" && responseData.EXTRA_INFO.containsOthers){
                    var VMFSp = document.createElement("DIV");// VMFSp = VMFilterSeparator
                    jQuery(VMFSp).addClass("VMFilterSeparator");
                    VMFlisEl.selectListEl.appendChild(VMFSp);
                   ZAVMFilter.constructOthersOpt(VMFlisEl.selectListEl,uiType);
                }

            }
            else{
                resElement.innerHTML=response.responseText;
                var next = DOMUtils.getChildElsWithAttr(resElement,"optionlist","true")[0].getAttribute("next");//No I18n
                component.next = next > 0 ? 0 : next;
            }
            ZDBUtil.setNamedChildEls(component,component);
          
           var prevOptLst=DOMUtils.getFirstMatchingChild(component.compElContainer, "div", "optionList", "true"); //NO I18N
           var newOptLst=DOMUtils.getFirstMatchingChild(resElement, "div", "optionList", "true"); //NO I18N
           if(prevOptLst)
           {
            prevOptLst.parentNode.removeChild(prevOptLst);
           }
           component.compElContainer.appendChild(newOptLst);
            var showAllDiv = DOMUtils.getFirstMatchingChild(component.compElContainer,"div","showAllDiv", "true"); //NO I18N
            if(showAllDiv)
            {
                showAllDiv.style.display= (includeCr&&view.isVMFilterApplied )?"":"none";
            }
            component.optionList = null;
            component.elnameSet=false;
            ZDBUtil.setNamedChildEls(component,component);
            if(!isPreLoad)
            {
                ZAVMFilter.showOptionList(component,component.compElContainer);
                if(uiType == "2") {
                    ZAVMFilterUtil.moveCursorToEnd(component.displaySelected);
                    ZAEditableUF.setInputEl(component.displaySelected);
                }
            }

            var isMultiSel = (uiType.toString()==="2");
            var handler;
            var optionDiv = DOMUtils.getFirstMatchingChild(newOptLst, "div","elname","optionDiv");//NO I18N
            if(isMultiSel)
            {
                handler = ZAVMFilterComp.multiSelect;
                var applyDiv = DOMUtils.getFirstMatchingChild(newOptLst, "div","elname","applyDiv");//NO I18N
                var el = applyDiv ? applyDiv : optionDiv;
                new TouchButton(el,handler);
            }
            else 
            {
                handler = ZAVMFilterComp.singleSelect;
            }
            new TouchButton(optionDiv,handler);
        }
        if(component.getAttribute("CASCADELIST")=="true")
        {
            var lblName = component.getAttribute("LABEL");
            view.vmFilterListCatch[lblName]=config;
        }
        component.setAttribute("VMFilterFetchStatus","2");//2 means already the list is fetched
        if(isPreLoad && (view.type === 'Dashboard' || view.viewCtx && view.viewCtx.dashView)) {
            view = (view.type === 'Dashboard') ? view : view.viewCtx.dashView;
            view.dashQ.dequeueBgQ();
        }
    }

    this.onFailureFunc= function(response,requestOptions)
    {
        var view = requestOptions["VIEW"];
        var component = requestOptions["COMPONENT"];
        component.setAttribute("VMFilterFetchStatus","0");
        ZDBUtil.setNamedChildEls(component,component);
        var isPreLoad = requestOptions["PRELOAD"];

        if(!isPreLoad)
        {
        var errCode = response.getResponsePart("ERRORCODE");
        errCode = trimAll(errCode);
        if(errCode == "SQL_QUERY_TIME_EXCEEDED")
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.errorFetchList"),component.compElContainer);
            $("customAlertMessage").style.width = "auto";
            $("_CUSTOMALERTFRAME").style.width = "auto";
        }
        else
        {
            AjaxAPI.onFailureFunc(response,requestOptions);
        }
        } else if(view.type === 'Dashboard' || view.viewCtx && view.viewCtx.dashView) {
            view = (view.type === 'Dashboard') ? view : view.viewCtx.dashView;
            view.dashQ.dequeueBgQ();
        }
        
    }

    this.preLoadVMFilterIfNeeded = function (view)
    {
        if (view.canPreLoad && !view.preLoaded)
        {
            view.preLoaded = true;
            var viewFilters = view.VMFiltersList;
            var len = viewFilters.length;
            for (var i = 0; i < len; i++)
            {
                var component = viewFilters[i];
                if(!component.getAttribute("is_valid_col") || component.getAttribute("is_valid_col") == "false")
                {
                	continue;
                }
                ZDBUtil.setNamedChildEls(component, component)
                var uiType = component.getAttribute("UITYPE");
                if (component.getAttribute("VMFilterFetchStatus") == "0" && component.getAttribute("CASCADELIST") != "true" && uiType != 6)
                {
                    var offStatusEl = (uiType == 1) ? component.fromValue : component.filterHead;
                    if (view.type === "Dashboard")
                    {
                        view.dashQ.preloadVMQ.prioritize({func: ZAVMFilter.fetchVMFListForDashView, args: [view, offStatusEl, component, null, null, true]});
                    } else if (view.viewCtx.dashView) {
                        view.viewCtx.dashView.dashQ.preloadVMQ.push({func: ZAVMFilter.fetchVMFListForAnalysisView, args: [view, offStatusEl, component, null, null, true]});
                    }
                    else
                    {
                        ZAVMFilter.fetchVMFListForAnalysisView(view, offStatusEl, component, null, null, true);
                    }
                }
            }
        }
    }

   this.isListModified = function(component,view,config)
    {
        var lblName = component.getAttribute("LABEL");
         var newConfig = view.vmFilterListCatch[lblName];
         var includeCr = component.getAttribute("INCLUDECR")=="true";
         if(view.lastAppliedEl === component)
         {
             return newConfig==null? true: false;
         }
         else if(!includeCr)
         {
             return true;
         }
         else if(newConfig == config)
         {
             return false;
         }
         return true;
    }

    this.getSelValsDetails = function(component)
    {
        var compElContainer = DOMUtils.getFirstMatchingChild(component,"td","elName", "compElContainer"); //NO I18N
        var selValDetStr = "";
        var selval = compElContainer.getAttribute("selVal");
        var dispselval =compElContainer.getAttribute("dispSelVal");
        var exclude = compElContainer.getAttribute("exclude");
        var isAllSelected = true;
        if(selval!=null)
        {
             isAllSelected = (selval=="All" || ZAVMFilter.isCrEqual(selval,component.getAttribute("CRITERIA"))); //NO I18N
        }
        if(selval!=null && selval!="" && !isAllSelected)
        {
            selValDetStr=selval+"___"+dispselval+"___"+exclude;
        }
        return selValDetStr;
    }

    this.placeVMFilterCriteria = function(view)
    {
        var objId = view.objId;
        var div = $("ZAVMFilterDiv_"+objId);//NO I18N
        if(div == null){return;}
        div.parentNode.removeChild(div);
        view.VMFilterDropArea.innerHTML = div.innerHTML;
        ZAVMFilter.initVMFilterDropArea(view);
        ZDBDashboardAPI.markInvalidUserFilters(view);
        //ZRDashboardLayoutAPI.markInvalidUserFilters(view); $#Dash#$
    }

  this.addVMFilterToDashIfNeeded = function(view)
  {
    if( !(view.viewCtx.dashView && view.viewCtx.dashView.editMode && view.viewCtx.dashChildDiv.autoVMFilter && view.viewCtx.dashView.autoVMFilterCheckbox.checked && ZDBClientUI.isDBOwner)){return;}
    var viewFilters = DOMUtils.getChildElsWithAttr(view.VMFiltersHolder,"viewtype","VMFILTERCRITERIA")//NO I18N
    var dashFilters = DOMUtils.getChildElsWithAttr(view.viewCtx.dashView.VMFilterDropArea,"viewtype","VMFILTERCRITERIA");//NO I18N
    var dashFiltersLen = dashFilters.length;
    var viewFiltersLen = viewFilters.length;

    var dFColID, dfOperation,dfUiType;
    var vFColID, vfOperation,vfUiType;
    var matched;

    for(var i=0; i<viewFiltersLen; i++)
    {
        var viewComp= viewFilters[i];
        vFColID = viewComp.getAttribute("column_id");
        vfOperation = viewComp.getAttribute("operation");
        vfUiType = viewComp.getAttribute("uitype");

        matched = false;
        for(var j=0; j<dashFiltersLen; j++)
        {
          var dashComp = dashFilters[j];
          dFColID = dashComp.getAttribute("column_id");
          dfOperation = dashComp.getAttribute("operation");
          dfUiType = dashComp.getAttribute("uitype");
          var sameSubType = true;
          var addonType = viewComp.getAttribute("ADDONTYPE").toLowerCase();
//          For number and date (actual and seasonal) components we need to consider the sub type check also for adding the user filters at dashboard level
          if(((addonType=="absdatecategorical") && (vfOperation=="ABS" || vfOperation=="REL")) || (addonType=="number"))
          {
            var vfSubType = viewComp.getAttribute("subtype");
            var dfSubType = dashComp.getAttribute("subtype");
            sameSubType = vfSubType == dfSubType;
          }
          if( (vFColID==dFColID) && (vfOperation==dfOperation) && (vfUiType==dfUiType) && sameSubType)
          {
              matched = true;
              continue;
          }
        }

        if(matched==false)
        {
          ZAVMFilter.addVMFilterToDash(view.viewCtx.dashView,viewFilters[i]);
        }

      }
      ZDBDashboardAPI.setIfVMFilterApplicable(view.viewCtx.dashChildDiv);
      ZAVMFilter.placeVMFilterDefinition(view.viewCtx.dashView);
  }

    this.addVMFilterToDash = function(dashView,viewFilter)
    {
        var VMFilterDropArea = dashView.VMFilterDropArea;
        var vFilterCopy = ZDBUtil.getCloneNode(viewFilter);
        ZAVMFilter.resetFieldsForDashView(dashView,vFilterCopy);
        VMFilterDropArea.appendChild(vFilterCopy);
        dashView.VMFiltersList.push(vFilterCopy);
        ZAVMFilter.placeVMFilterDefinition(dashView);
        vFilterCopy.onmouseover = ZAVMFilter.showCompOptions;
        vFilterCopy.onmouseout = ZAVMFilter.hideCompOptions;
        ZAVMFilterEdit.orderVMFiltersList(dashView);
    }

    this.removeVariableAttributes = function(el)
    {
        el.removeAttribute("VALUEOFVAR");
        el.removeAttribute("DISPVALUEOFVAR");
        el.removeAttribute("VARIABLEVALUE");
        el.removeAttribute("VARVALINCRITERIA");
    }

    this.resetFieldsForDashView = function(view,viewFilter)
    {
        var addonType = viewFilter.getAttribute("ADDONTYPE").toLowerCase(); //NO I18N
        var operation = viewFilter.getAttribute("OPERATION"); //NO I18N
        var resetCr = !((addonType=="number") || (addonType=="absdatecategorical" && (operation=="PF" || operation=="REL"))); //NO I18N
        viewFilter.setAttribute("CASCADELIST","false");
        if(resetCr)
        {
          viewFilter.setAttribute("ISALLVAL",resetCr.toString());
          viewFilter.setAttribute("CRITERIA","");
          viewFilter.setAttribute("DISPLAYCRITERIA","");
        }
        viewFilter.setAttribute("DEFAULTCRITERIA","");
        viewFilter.setAttribute("DEFAULTDISPLAYCRITERIA","");
        ZAVMFilter.removeVariableAttributes(viewFilter);
        var label = viewFilter.getAttribute("LABEL").trim();
        var newLabelName = ZAVMFilter.validateNGetLabelName(view,label);
        viewFilter.setAttribute("LABEL",newLabelName);
        ZDBUtil.setNamedChildEls(viewFilter,viewFilter);
        viewFilter.compLabel.innerHTML = ZDBEscapeUtil.encodeForHtml(newLabelName);
        viewFilter.compLabel.setAttribute("value", ZDBEscapeUtil.encodeForHtml(newLabelName));
        ZAVMFilterEdit.applyDefaultValue(viewFilter);
    }

    this.validateNGetLabelName= function(view, label)
    {
         var counter=0;
         var labelName = label.trim();
         while(!ZAVMFilter.isValidlabel(view,label))
         {
             counter++;
             label= labelName+counter;
         }
         return label;
    }
    this.isValidlabel = function(view,label)
    {
        if(label==null || label=="")
        {
          return false;
        }
         var VMFiltersList = view.VMFiltersList;var len = VMFiltersList.length;var compEl = null;
         for(var i=0; i<len; i++)
        {
            compEl = VMFiltersList[i];
            var existLabel = compEl.getAttribute("LABEL");
            if(existLabel.toUpperCase()==label.toUpperCase())
            {
                return false;
            }
        }
        return true;
    }
    this.initVMFilterDropArea = function(view)
    {
        var VMFilterDropArea = view.VMFilterDropArea;
        var VMFilterFields = VMFilterDropArea.childNodes;//No I18N
        var len = VMFilterFields.length;
        var VMFiltersList = view.VMFiltersList;
        for(var i=0; i<len; i++)
        {
            var child = VMFilterFields[i];
            if(child.getAttribute && (child.getAttribute("COLUMN_ID") != null))
            {
                VMFiltersList.push(child);
                child.onmouseover = ZAVMFilter.showCompOptions;
                child.onmouseout = ZAVMFilter.hideCompOptions;
            }
            if(child.getAttribute && (child.getAttribute("istimelinecomp") == "true"))
            {
            	view.timeLineCompEnabled = true;
            	view.timelineComp = child; 
            	view.timelineComp.setAttribute("MINDATE",ZDBGlobal.TIMELINE_MINRANGE);
            	view.timelineComp.setAttribute("MAXDATE",ZDBGlobal.TIMELINE_MAXRANGE);
            	view.timeLineCompLabel = child.getAttribute("label");
            	view.Criteria = child.getAttribute("selvals");
            	view.DisplayCriteria = child.getAttribute("display_selvals");
            	view.newRangeVals = child.getAttribute("nr");
            	view.defTimelineValue = child.getAttribute("value");
            	view.colNamesToMatch = JSON.parse(child.getAttribute("pref_cols"));
            	view.colAssIdx = child.getAttribute("col_assosidx");
            	child.onmouseover = ZAVMFilter.showCompOptions;
                child.onmouseout = ZAVMFilter.hideCompOptions;
            }
        }
        ZAVMFilter.placeVMFilterDefinition(view);
    }

    this.placeVMFilterDefinition = function(view)
    {
      if(view.typeValue==ZDBClientViewAPI.TYPE_WIDGET)
        {
            return;
        }
      view.VMFilterDefinition.innerHTML = (view.type=="Dashboard")? ZDBI18NMap.g("zrpt.VMFilters.dropArea.js.DashVMFDefinition") : ZDBI18NMap.g("zrpt.VMFilters.dropArea.js.VMFilterDefinition");
      view.VMFilterDropArea.appendChild(view.VMFilterResetBtn);
      view.VMFilterDropArea.appendChild(view.VMFilterDefinition);
      view.VMFilterResetBtn.style.display="none";
      if(view.VMFiltersList.length > 0 || view.timeLineCompEnabled)
      {
          view.VMFilterDefinition.style.display = "none";
      }
      else
      {
          view.VMFilterDefinition.style.display = "";
      }
    }
    
    this.showHideResetBtn = function(view, hideReset)
    {
        var iniHeight = (view.typeValue == ZDBClientViewAPI.TYPE_ANALYSISVIEW || view.typeValue == ZDBClientViewAPI.TYPE_PIVOT || view.typeValue == ZDBClientViewAPI.TYPE_SUMMARY) ? view.grphAddOnHolder.offsetHeight : iniHeight ;
    	if(hideReset)
    	{
    		view.VMFilterResetBtn.style.display = "none";
    	}
    	else
    	{
    		view.VMFilterResetBtn.style.display = "";
    	}
        if(iniHeight && !view.editMode)
        {
           var finalHght =  view.grphAddOnHolder.offsetHeight ;
           if(finalHght !== iniHeight && view.type != "Dashboard") 
           {
              view.resize(); 
           }   
        }
    }
    
    this.showHideCompResetBtn = function(el, showResetBtn)
    {
    	var view = ZDBUtil.getParentWithProperty(el, "view").view;//NO I18N
    	if(view.editMode)
    	{
    		return;
    	}
    	if(showResetBtn)
    	{
    		jQuery(el).addClass("showCompResetBtn");
    	}
    	else
    	{
    		jQuery(el).removeClass("showCompResetBtn");
    	}
    }
    
    this.showCompOptions = function(event)
    {
        if(event == null)
        {
            event = window.event;
        }
        var el = ZDBUtil.getSourceElement(event);
        var compEl = DOMUtils.getElOrParentWithAttr(el,"compBodyEl");//No I18N
        var view = ZDBClientUI.getViewObj(compEl,"view");//No I18N
        var VMFilterArea = ZDBUtil.getParentWithAttributeValue(compEl,"elname","VMFilterFields");//NO I18N
        var isVMFilterDropArea =((VMFilterArea!=null)&&VMFilterArea.style.display!="none");//NO I18N
        if(!view.editMode || !isVMFilterDropArea)
        {
            return;
        }
        var VMFilterOptions = view.VMFilterOptions;
        var modalDiv = view.modalDiv;
        modalDiv.style.display="";
        if(VMFilterOptions.parentNode != compEl.contentHolder)
        {
            ZDBUtil.setNamedChildEls(compEl,compEl);
            compEl.contentHolder.appendChild(modalDiv);
            compEl.contentHolder.appendChild(VMFilterOptions);
            var modalDivReSize = 4;		//Adjustment to show the dashed border for VMFilter columns
            modalDiv.style.height = (compEl.offsetHeight - modalDivReSize)+"px";
            modalDiv.style.width = (compEl.offsetWidth - modalDivReSize)+"px";
            var dbColName = compEl.getAttribute('dbcolname');
            var isEditNotNeeded = (dbColName == ZDBConst.DYNAMIC_COL_NAME) || compEl.getAttribute("IS_VALID_COL")=="false" || compEl.getAttribute("IS_AUTHORISED_COL")=="false";
            view.editLink.style.display = isEditNotNeeded ? 'none': '';
        }
        modalDiv.className = "VMFilterModalDivHover alpha";
        if(VMFilterOptions)
        {
            VMFilterOptions.style.display = "";
        }
    }

    this.hideCompOptions = function(event)
    {
        if(event == null)
        {
            event = window.event;
        }
        var el = ZDBUtil.getSourceElement(event);
        var compEl = DOMUtils.getElOrParentWithAttr(el,"compBodyEl");//No I18N
        var view = ZDBClientUI.getViewObj(compEl,"view");//No I18N
        var VMFilterArea = ZDBUtil.getParentWithAttributeValue(compEl,"elname","VMFilterFields");//NO I18N
        var isVMFilterDropArea =((VMFilterArea!=null)&&VMFilterArea.style.display!="none");//NO I18N
        if(!view.editMode || !isVMFilterDropArea)
        {
            return;
        }
        var VMFilterOptions = view.VMFilterOptions;
        var modalDiv = view.modalDiv;
        modalDiv.style.display="none";
        modalDiv.className = "VMFilterModalDiv alpha";
        VMFilterOptions.style.display = "none";
    }

    this.appendCompOptionsToDropArea = function(view)
    {
        var VMFilterOptions = view.VMFilterOptions;
        var modalDiv = view.modalDiv;
        view.VMFilterOptsHolder.appendChild(VMFilterOptions);
        view.VMFilterOptsHolder.appendChild(modalDiv);
    }

    this.clearAll = function(el,view,refreshView)
    {
        hideCustomMessage();
        if(view==null)
        {
            view = ZDBUtil.getParentWithProperty(el, "view").view;//NO I18N
        }
        var childNodes = view.VMFiltersList;
        if(childNodes == null)
        {
            return;
        }
        for(var i =0,len = childNodes.length;i<len;i++)
        {
          var comp = childNodes[i];
          var isValidComp = comp.getAttribute("IS_VALID_COL")=="true" ;
          var isslider = comp.getAttribute("UITYPE")=="6";
          if(isValidComp)
          {
            ZAVMFilterComp.resetComp(comp);
            comp.setAttribute("canReset","false");
            jQuery(comp).removeClass("compFilterApplied");
          }
          view.changeSliderBoundaries = true;
          view.lastAppliedEl = null;
        }
        var timelineComp = view.timelineComp;
        if(view.timeLineCompEnabled)
        {
        	ZRTimelineFilter.resetTimeLineComp(timelineComp);
        	timelineComp.setAttribute("canReset","false");
        	jQuery(timelineComp).removeClass("compFilterApplied");
        }
        if(refreshView)
        {
        	var isDashReset = ((view.type) == "Dashboard");//NO I18N
            view.changeSliderBoundaries = true;
            view.lastAppliedEl = null;
            ZAVMFilter.refreshView(el,view, isDashReset);
        }
        ZAVMFilter.showHideResetBtn(view, true);
    }
    
    this.clearSingleUserFilter = function(el)
    {
    	var comp = DOMUtils.getParentWithAttr(el,"compbodyel");
    	var view = ZDBUtil.getParentWithProperty(el, "view").view;//NO I18N
    	if(comp.getAttribute("canReset") == "true")
    	{
    		if(comp.getAttribute("istimelinecomp") == "true")
        	{
        		ZRTimelineFilter.resetTimeLineComp(comp);
        	}
        	else
        	{
        		ZAVMFilterComp.resetComp(comp);
        	}
        	view.changeSliderBoundaries = true;
        	view.lastAppliedEl = comp;
        	ZAVMFilter.refreshView(comp,view);
        	comp.setAttribute("canReset","false");
        	jQuery(comp).removeClass("compFilterApplied");
    	}
    }
    
     this.defaultCriteriaSelection = function(component,defCr,tempFetch)
    {
      // for selecting or deselecting all elements based on the criteria.
       var exclude = tempFetch ?(component.compElContainer.getAttribute("EXCLUDE")=="true"):(component.getAttribute("EXCLUDE")=="true");
       var isAllVals = component.getAttribute("ISALLVAL")=="true";
      if(isAllVals && !exclude && defCr != "All")
       {
            ZAVMFilterComp.deselectAll(component,true);
       }
       if(exclude && !isAllVals)
       {
           ZAVMFilterComp.deselectAll(component,false);
       }
       else if(tempFetch && !exclude && defCr=="All")
       {
             ZAVMFilterComp.deselectAll(component,true);
       }
       else if(defCr=="All")
       {
           ZAVMFilterComp.deselectAll(component,false);
       }
       else if(exclude && isAllVals)
       {
           ZAVMFilterComp.deselectAll(component,false);
       }
       else
       {
           ZAVMFilterComp.deselectAll(component,true);
       }
       var crList;
       if(component.getAttribute("uiType") == "4")
       {
           var temp = defCr.split(",");
           if(temp.length>2)
           {
               crList = defCr;
           }
           else
           {
               crList = defCr.split(",");
           }
       }
       else
       {
           crList = defCr.split(",");
       }
        ZDBUtil.setNamedChildEls(component,component,"elname");//NO I18N
        var selList = component.selectListEl;
         var Allselected = true;
         var optionList = component.optionList;
//         checking the selected values based on excluded or included it will check or uncheck the elements.
        for(var i=0;i<crList.length&&crList[i]!="";i++)
        {
            var value =(crList[i] =="All")?crList[i]:crList[i]+",";
//            var element =   ZDBUtil.getElementsWithAttribute(selList,"filteredValue",value);//NO I18N
            var element =  DOMUtils.getChildElsWithAttr(selList,"filteredValue",value);//NO I18N
            if(element.length<1)
            {
               if(value!=="All"){Allselected = false;}
                continue;
            }
            var srcEl = element[0];
            ZDBUtil.setNamedChildEls(srcEl,srcEl,"valFunc");//NO I18N
            if(optionList == null)
            {   
                optionList = DOMUtils.filterElements(component.compElContainer.childNodes,null,"optionList","true")[0];//NO I18N
                component.optionList = optionList;
                optionList.component = component;
            }
            var func = srcEl.getAttribute("valFunc");
            if(func==null)
            {
                return;
            }
            (ZAVMFilterComp[func](optionList,srcEl));
        }
        var showAllDiv =DOMUtils.getFirstMatchingChild(optionList,"div","showalldiv","true");//NO I18N
        var cascaded = showAllDiv.style.display=="";
        if(isAllVals && !Allselected && !tempFetch ) // default element is not there in first fetch list
        {
            var optionDiv = DOMUtils.getChildElsWithAttr(optionList, "elname", "optionDiv")[0]; //NO I18N
            optionDiv.setAttribute("SelCr",component.compElContainer.getAttribute("selval"));
            optionDiv.setAttribute("selDcr",component.compElContainer.getAttribute("dispselval"));
            if(!cascaded)
            {
                optionDiv.setAttribute("selDVal",component.compElContainer.getAttribute("displayval"));
            }
        }
    }

    this.removeDuplicates = function(strList)
    {
        if(strList != null && strList.length > 0)
        {
            var resultArr = [];
            var strArr = strList.split(",");
            jQuery.each(strArr, function(i, val) {
                if(jQuery.inArray(val, resultArr) == -1) {
                    resultArr.push(val);
                }
            });
            return resultArr + "";
        }
    }

    this.showOptionList = function(component,optionListHeader,event,tempFetch,isnextFetch,isSearch)
    {
        var curList = ZAVMFilterUtil.curList;
//        var component = DOMUtils.getSelfOrParentWithAttr(el, "COLUMN_ID");//NO I18N
        if((curList&& curList.getAttribute("optionList")=="true") && !tempFetch)
        {
            var optionDiv = DOMUtils.getChildElsWithAttr(ZAVMFilterUtil.curList, "elname", "optionDiv")[0]; //NO I18N
            optionDiv.removeAttribute("SelCr");
            optionDiv.removeAttribute("selDcr");
            optionDiv.removeAttribute("selDVal");
            if(ZAVMFilterUtil.curList == component.optionList &&  ZAVMFilterUtil.curList.style.display == "")
            {
                ZAEditableUF.resetValue(component);
                ZAVMFilterUtil.closeList(event, true);
                return;
            }
              ZAVMFilterUtil.closeList(event, true);
        }
        var view = ZDBClientUI.getViewObj(component,"view");//NO I18N
        var optionList = component.optionList;
//        var optionListHeader = el.compElContainer;
        if(optionList == null)
        {
            optionList = DOMUtils.filterElements(optionListHeader.childNodes,null,"optionList","true")[0];//NO I18N
            component.optionList = optionList;
            optionList.component = component;
        }
//        if(comScrlWid){ //comScrlWid-before appending list.
//            component.optionList.style.minWidth = comScrlWid+"px";//NO I18N
//        }
//        else{
//            component.optionList.style.minWidth = (optionListHeader.offsetWidth-3)+"px"; //NO I18N
//        }
        ZDBUtil.setNamedChildEls(optionList,optionList,"elName");//NO I18N
        var uiType = component.getAttribute("UITYPE");
        var selVal = (tempFetch && uiType=="2")?component.optionDiv.getAttribute("selCr"):optionListHeader.getAttribute("selVal"); // for single select we wont hold the selected list
        selVal = ZAVMFilter.removeDuplicates(selVal);
        var defCr;
        if(selVal==null||selVal=="")
        {
            defCr = ZAVMFilter.ALL_KEY;
        }
        else if(uiType=="4")
        {
            var exclude = tempFetch ?(optionListHeader.getAttribute("EXCLUDE")=="true"):(component.getAttribute("EXCLUDE")=="true");
            defCr = (exclude)?component.getAttribute("CRITERIA").replace(selVal,""):selVal;
            defCr = (component.getAttribute("ISALLVAL")!="true" && ZAVMFilter.isCrEqual(defCr,component.getAttribute("CRITERIA")))?"All":defCr; //NO I18N
        }
        else
        {
            defCr = selVal;
        }
        if(tempFetch && optionList.selAllLi.getAttribute("origClass") =="dComboselectAllCheckbox")
        {
            ZAVMFilterComp.deselectAll(component,false,isSearch);
        }
        else
        {
            ZAVMFilter.defaultCriteriaSelection(component,defCr,tempFetch);
        }
        var selAllLi_old = DOMUtils.getFirstMatchingChild(optionList, "*","elname","selAllLi");
        optionList.selAllLi ? optionList.selAllLi.style.display = isSearch?"none":"" : null;
        if(optionList.selAllLi && uiType=="4" && ZDBClientUI.isNewRequest){
            var mainList = DOMUtils.getFirstMatchingChild(optionList, null,"elname","mainList");//No I18N
            (!isSearch && !selAllLi_old) ? ZAVMFilter.insertExtraElForVMFLst(mainList,ZAVMFilter.sslcLstopt,true,0) : "";
        }
        ZAVMFilterUtil.curList = optionList;
        ZDBUtil.setNamedChildEls(component,component);
        var optList = (optionList.optionDiv) ? optionList.optionDiv :component.optionList;
        if(!isnextFetch)
        {
            optList.style.height = "";
            optList.scrollTop = 0;
            ZAVMFilter.displayDefOrSelectedVals(component);
            ZAVMFilter.setOptListHgtAndWdth(component,view,optionListHeader);
        }
        if(isSearch){
            ZAVMFilter.setHghAndRezableVsble(view,component);
        }
        if(optList == optionList)   
        {
            ZAVMFilter.selectedOption();
        }
        var modetype = ZDBClientUI.selectedTab.view.editMode;
        if(modetype){optionList.style.visibility = "hidden";}
        else{optionList.style.visibility = "visible";}
        if(!(tempFetch&&!isnextFetch) || isSearch)
        {
        ZDBUtil.attachEvent(document,'keydown',ZAVMFilterUtil.checkKeyNContinue,true);
        }
        ZDBUtil.attachEvent(document, (ZDBGlobal.IS_MOBILE) ? 'touchstart' : 'click',
                                                    ZAVMFilterUtil.closeList, true);
        if(!ZDBGlobal.IS_MOBILE) {
            ZDBUtil.attachEvent(ZAVMFilterUtil.curList,'mouseover',ZAVMFilterUtil.highlightSelected,true);
            ZDBUtil.attachEvent(ZAVMFilterUtil.curList,'mouseleave',ZAVMFilterUtil.leaveFocuse,true);
        }
        ZDBUtil.stopEventBubble(event);
        component.listFetched=true;
    }
    
    this.showDateRangeMenuEl = function(el, event)
    {
        if(el.getAttribute("menuElShown") == "true")
        {  
          return;
        }
    	var component = DOMUtils.getParentWithAttrValue(el,"compbodyel","true");//NO I18N
    	var compLabel = component.getAttribute("label");
    	var compMenuElId = "vmOptionList_" + compLabel;//NO I18N
    	var view = ZDBClientUI.getViewObj(el, "view");
    	var dateMenuEl = DOMUtils.getFirstMatchingChild(el, "*", "elname", "dateMenuEl");//NO I18N 
    	var parNode;
    	if(!dateMenuEl)
    	{
    		dateMenuEl = component.dateMenuEl;
    	}
    	else
    	{
    		component.dateMenuEl = dateMenuEl;
    		parNode  = (view.type=="Dashboard")? view.dashDiv :view.viewComp;
    		dateMenuEl.parentNode.removeChild(dateMenuEl);
    		parNode.appendChild(dateMenuEl);
    	}
        ZDBUtil.setNamedChildEls(dateMenuEl,dateMenuEl);
        component.fromValue = dateMenuEl.fromValue;
        component.toValue = dateMenuEl.toValue;
    	view.curDateComp = component;
        dateMenuEl.component = component;
        dateMenuEl.style.visibility = "hidden";
        dateMenuEl.style.display = "block";
    	ZAVMFilter.positionOptionList(dateMenuEl, component.compElContainer, view);
    	dateMenuEl.style.visibility = "visible";
    	ZDBUtil.attachEvent(document,'mousedown',ZAVMFilter.hideDateRangeMenuEl,false);
        ZDBUtil.attachEvent(document,'touchstart',ZAVMFilter.hideDateRangeMenuEl,false);
        el.setAttribute("menuElShown","true");
        var inputFromEl = DOMUtils.getFirstMatchingChild(dateMenuEl, "*","elname","fromValue");//NO I18N
        ZRDynFilterUtil.hideDateString(inputFromEl,event,'USERFILTER',el);//NO I18N
        var evt = document.createEvent("MouseEvent");//NO I18N		
        evt.initMouseEvent("click",true,true,window,0,0,0,0,0,false,false,false,false,0,null);//NO I18N
        inputFromEl.dispatchEvent(evt);
        inputFromEl.focus();
    }
    
    this.hideDateRangeMenuEl = function(event, closeMenu)
    {
    	var el = ZDBUtil.getSourceElement(event);
    	var isDateMenuEl = DOMUtils.getParentWithAttrValue(el, "elname","dateMenuEl");//NO I18N
        var isCalendarMenu = DOMUtils.getParentWithAttrValue(el, "elname","calendarTbl");//NO I18N
    	if(!closeMenu && isDateMenuEl || isCalendarMenu)
    	{
    		return;
    	}
    	var view = ZDBClientUI.getViewObj(el, "view");
        if(!(view && view.curDateComp)){return;}
        var timeLineHead = DOMUtils.getFirstMatchingChild(view.curDateComp, "div", "elname","timeLineHead");//NO I18N
        view.curDateComp.dateMenuEl.style.display = "";
        Calendar._checkCalendar(event);
        timeLineHead.setAttribute("menuElShown","false");
        ZDBUtil.detachEvent(document,'mousedown',ZAVMFilter.hideDateRangeMenuEl,false);
        ZDBUtil.detachEvent(document,'touchstart',ZAVMFilter.hideDateRangeMenuEl,false);
        ZDBUtil.stopEventBubble(event);
    }

    this.displayDefOrSelectedVals = function(component)
    {
        var optionList = component.optionList;
        var optionListHeader = component.compElContainer;
        optionList.displaySelected = component.displaySelected;
        var criteria = component.getAttribute("CRITERIA");
        var isVarValPresent = component.getAttribute("VARVALINCRITERIA");
        if(isVarValPresent!=null && isVarValPresent == "false")
        {
            var varValue = component.getAttribute("VARIABLEVALUE");
            criteria += varValue + ",";
        }
        var relcriteria = component.getAttribute("REL_CRITERIA")==null ? "" : component.getAttribute("REL_CRITERIA");
        var uiType = component.getAttribute("UITYPE");
        var displayStr = (uiType==2)?ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all"):ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
        var dispCr = ((optionListHeader.getAttribute("SelVal")==criteria+relcriteria)&& component.getAttribute("ISALLVAL")!="true"&&(component.getAttribute("OPERATION")!="PF"))? displayStr:optionListHeader.getAttribute("displayVal");//NO I18N
        if((criteria.indexOf(ZAVMFilter.OTHERS_CR_KEY)>=0 && optionListHeader.getAttribute("SelVal")==criteria.replace(ZAVMFilter.OTHERS_CR_KEY+",","")) &&(component.getAttribute("EXCLUDE")=="true"))
        {
            if(ZAVMFilter.isCrContainsVariable(dispCr))
            {
                dispCr = component.getAttribute("VALUEOFVAR");
                dispCr = ZDBUtil.replaceStr(dispCr,ZAVMFilter.OTHERS_CR_KEY,ZAVMFilter.OTHERS_KEY);
            }
            else
            {
                dispCr = ZAVMFilter.OTHERS_KEY;
            }
        }
        var dispVal = (dispCr==""||dispCr==null)?displayStr:dispCr;//NO I18N
        var varVal = component.getAttribute("VALUEOFVAR");
        if(varVal!=null && ZAVMFilter.isCrContainsVariable(dispCr))
        {
            if(criteria!=null && ZAVMFilter.isVarValContainsAllCriteria(criteria, varVal)) {
                dispVal = displayStr;
            }
            else {
                dispVal = ZAVMFilterUtil.trimCommaAtEnd(component.getAttribute("DISPVALUEOFVAR"));
            }
        }
        if(uiType != "2")
        {
            optionList.displaySelected.innerHTML = ZDBEscapeUtil.encodeForHtml(dispVal);
            if(uiType !="4"){
            	optionList.displaySelected.setAttribute("value",ZDBUtil.getSubString(dispVal,150));
                optionList.displaySelected.setAttribute("data-tip",ZDBUtil.getSubString(dispVal,150));
            }
        }
        optionList.style.zIndex = 3000;
    }

    this.isCrContainsVariable = function(criteria)
    {
        if(criteria == null || criteria == "")
        {
            return false;
        }
        return ZAVMFilter.VAR_REGEX_PATTERN.test(criteria);
    }

    this.getVarPosition = function(crArr)
    {
        var pos = 0;
        var len = crArr.length;
        for(var i=0; i<len; i++)
        {
            var cr = crArr[i];
            if(ZAVMFilter.isCrContainsVariable(cr))
            {
                pos = i;
                break;
            }
        }
        return pos;
    }

    this.setOptListHgtAndWdth = function(component,view,optionListHeader)
    {
        var viewArea = (view.type=="Dashboard")? view.dashDiv :view.viewComp;
        viewArea = component.getAttribute("uiType") ? viewArea : ZDBDialogUtil.focusDialog;
        //var viewArea = view.viewComp; $#Dash#$
        var optionList = component.optionList;
        ZDBUtil.setNamedChildEls(optionList,optionList)
        optionList.style.display="";
        optionList.style.visibility = "hidden";
        viewArea.appendChild(optionList);
        this.positionOptionList(optionList,optionListHeader,view,true);
        ZAVMFilter.setHghAndRezableVsble(view,component);
        optionList.style.visibility = "visible";
        optionList.widthSet = true;
    }

    this.setHghAndRezableVsble = function(view,component){
        var viewArea = (view.type=="Dashboard")? view.dashDiv :view.viewComp;
        var optionList = component.optionList;
        var compEl = component.compElContainer;
        var optList = (component.optionDiv) ? component.optionDiv :component.optionList;
        var divHgt = ZDBClientUtil.getInnerHeight(optList);//optList.offsetHeight;
        var maxHgtOptList = parseInt(optList.getAttribute("maxHgt"), 10);
        var maxDivHgt = ZDBClientUtil.getInnerHeight(viewArea)*0.40;//viewArea.offsetHeight * 0.40;
        maxDivHgt = (maxHgtOptList>maxDivHgt)?maxDivHgt:maxHgtOptList;
        ZDBUtil.setNamedChildEls(optionList,optionList);
        var viewComp = view.viewComp;//ZDBClientUI.selectedTab.view.viewComp;
        var wrkAreaWdth = viewComp.offsetWidth;
        var wrkAreaHgt = viewComp.offsetHeight;
        var compElLeftBound = ZDBUtil.getObjLeft(compEl,true,viewComp);
        var compElTopBound = ZDBUtil.getObjTop(compEl,false,viewArea);
        var compElRightBound = (viewComp.offsetWidth- (compElLeftBound+compEl.offsetWidth));
        var maxOptLstWdth = wrkAreaWdth*0.5;
        var y =compElTopBound +compEl.offsetHeight;
        if(divHgt>maxDivHgt)
        {
            optList.style.height = maxDivHgt+'px' ;
            var searchDiv = DOMUtils.getChildElsWithAttr(optionList, "userFilterSearch", "true")[0]; //NO I18N
            searchDiv.style.display="";
            optList.style.overflowY = "auto";//NO I18N
            optList.style.overflowX = "hidden";//NO I18N
            optList.style.webkitOverflowScrolling = 'touch'; //NO I18N
        }
        if(y+maxDivHgt > wrkAreaHgt)
        {
             optionList.style.top = (compElTopBound-optionList.offsetHeight)+"px";
        }
        else
        {
            optionList.style.top= y+'px';
        }
        // if(compEl.offsetWidth < optionList.scrollWidth)
        // {
             if(maxOptLstWdth < optionList.offsetWidth)
             {
                 optionList.style.width = maxOptLstWdth+"px";   
             }
             if(compElLeftBound+maxOptLstWdth > wrkAreaWdth)
             {  // reverse the list
                optionList.style.left="";
                optionList.style.right=compElRightBound+"px";//No I18N
                optionList.resizeLft.style.display="block";
                optionList.resizeRgt.style.display="none";
            }
            else
            {
                optionList.style.right="";
                optionList.style.left=compElLeftBound+"px";
                optionList.resizeLft.style.display="none";
                optionList.resizeRgt.style.display="block";

            }
        // }
        optionList.style.minWidth=(compEl.offsetWidth+15)+"px";//No I18N
        //this.positionOptionList(optionList,component.filterHead,component,view); $#Dash#$
    }
    
  this.positionOptionList = function(optionList, filterHeader, view,isWidthFixed)
  //$Dash$this.positionOptionList = function(optionList, filterHeader, view, isWidthFixed)
  {
    var viewArea  = (view.type=="Dashboard")? view.dashDiv :view.viewComp;
    var x = ZDBUtil.getObjLeft(filterHeader,false,viewArea);
    var y = ZDBUtil.getObjTop(filterHeader,false,viewArea)+filterHeader.offsetHeight;

    var isRevHgt = (ZDBUtil.getObjTop(filterHeader,false,viewArea)-viewArea.scrollTop+optionList.offsetHeight)>=viewArea.offsetHeight;
    if(!optionList.widthSet)
    {
        optionList.style.width =  (optionList.offsetWidth > viewArea.offsetWidth/2 && !isWidthFixed) ? viewArea.offsetWidth/2+"px" : (jQuery(optionList).width()+15)+"px";//15 for scroll bar
       optionList.widthSet = true; 
    } 
    var isRevWdth = (x+optionList.offsetWidth)>viewArea.offsetWidth;

    y = (isRevHgt && view.type=="Dashboard") ? ZDBUtil.getObjTop(filterHeader,false,viewArea)-optionList.offsetHeight: y;
    x = isRevWdth ? x-(optionList.offsetWidth-filterHeader.offsetWidth):x;

    optionList.style.position = "absolute";
    optionList.style.left = x+"px";
    optionList.style.top = y+"px";
    optionList.style.zIndex = "5000";
    optionList.defaultLeft = x;
  }

    this.optionListElsReverse = function(n)
    {
      var kids = n.childNodes;   // Get the list of children
      var numkids = kids.length; // Figure out how many there are
    for(var i = numkids-1; i >= 0; i--) {  // Loop through them backwards
          var c = n.removeChild(kids[i]);    // Remove a child
          n.appendChild(c);                  // Put it back at its new position
      }
    }
    this.selectedOption = function()
    {
        var optionList = ZAVMFilterUtil.curList;
        var optnLstEls = optionList.getElementsByTagName("LI");
        var noofoption = optnLstEls.length;
        var optionLstEl = null;
        for(var i=0; i<noofoption; i++)
        {
            optionLstEl = optnLstEls[i];
            var clsName = optionLstEl.getAttribute("origClass");
            optionLstEl.className = (clsName==null || clsName=="") ? optionLstEl.className : clsName
            optionLstEl.setAttribute("origClass",optionLstEl.className);
            if(optionLstEl.getAttribute("filtered")=="true")
            {
                ZAVMFilterUtil.currentSelectedItem = optionLstEl;
                optionLstEl.className = optionLstEl.getAttribute("origClass") + "Hover";
            }
        }
        ZAVMFilterUtil.curList.currentHighlightedItem = ZAVMFilterUtil.currentSelectedItem;
    }

    // Tab Related.
    this.tabChanged = function(critValDiv,ev)
    {
        var srcEl = ZDBUtil.getSourceElement(ev);
        var tabList = $(critValDiv.getAttribute("optionListID"));
        if(srcEl.getAttribute("orgval")=="more")
        {
            ZAVMFilter.showTabList(tabList,critValDiv);
        }
        else if(ZAVMFilter.selectTab(critValDiv,srcEl))
        {
            ZAVMFilter.refreshView(critValDiv);
        }
    }

    this.selectTab  = function(critValDiv,selTab)
    {
        if(selTab.getAttribute("isValue") != "true")
        {
            return false;
        }
        if(selTab.getAttribute("dcrName") == "critNoneOpt")
        {
            critValDiv.removeAttribute("selVal");
        }
        else
        {
            critValDiv.setAttribute("selVal",selTab.innerHTML);
        }
        ZAVMFilter.highLightTab(critValDiv,selTab);
        return true;
    }

    this.highLightTab= function(critValDiv,selTab)
    {
        var childNodes = critValDiv.getElementsByTagName("span");
        for(var i =0,j= childNodes.length;i<j;i++)
        {
            var child = childNodes[i];
            if(child.style == null)
            {
                continue;
            }
            if(child == selTab || (selTab.getAttribute("orgVal")==child.getAttribute("orgVal")))
            {
                child.style.fontWeight = "bold"; //NO I18N
                continue;
            }
            child.style.fontWeight = "normal";//NO I18N
        }
        var tabList = $(critValDiv.getAttribute("optionListID"));
        if(tabList.getAttribute("isMenu"))
        {
            tabList.style.display="none";
        }
    }

    this.clearTab = function(critDiv)
    {
        ZAVMFilter.selectTab(critDiv.critValue,critDiv.critNoneOpt);
    }

    this.getDivVal = function(critDiv)
    {
        var val = critDiv.critValue.getAttribute("selVal");
        return (val == "")?null:val;
    }

    this.showTabList = function(tabList,critValDiv)
    {
        tabList.style.border= "1px solid #dfdfdf"; //No I18N
        tabList.style.backgroundColor="#FFFFFF";
        tabList.style.width =critValDiv.offsetWidth+"px";
        tabList.style.left= critValDiv.offsetLeft+"px";
        tabList.style.display="";
    }

    this.startDrag = function(el,mEvent)
    {
        if(mEvent.button==2){ZDBUtil.stopEventBubble(mEvent);return false;}
        var view = ZDBClientUI.getViewObj(el,"view");//NO I18N
        if(view.type.toLowerCase() == "dashboard")
            {
                ZDBDashboardUF.resetVMFilterPosition(view);
            }
        if(!view.editMode)
        {
            return;
        }
        DNDEvents.startDrag(el,mEvent);
    }

    // display value is replaced with value of variable in view mode and with variable name in edit mode
    this.replaceVariableName = function(vmFilterComp, viewMode)
    {
        var compDiv = DOMUtils.getChildElsWithAttr(vmFilterComp, "compbodyel", "true"); //No I18N
        var size = compDiv.length-1;
        for(var i=0; i<size; i++)
        {
            var compEl = compDiv[i];
            if(compEl)
            {
                var valOfVar = compEl.getAttribute("VALUEOFVAR");
                if(valOfVar != null)
                {
                    var dispDivs = DOMUtils.getChildElsWithAttr(compEl.compElContainer, "elname", "displaySelected"); //NO I18N
                    var dispDiv = dispDivs[0];
                    var uiType = compEl.getAttribute("UITYPE");
                    if(viewMode)
                    {
                        var selAllStr = (uiType==2) ? ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all") :
                                                    ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
                        var displayStr = ZAVMFilterUtil.trimCommaAtEnd(compEl.getAttribute("DISPVALUEOFVAR"));
                        var criteria = compEl.getAttribute("CRITERIA");
                        if(valOfVar == "" || (criteria!=null &&
                                ZAVMFilter.isVarValContainsAllCriteria(criteria, valOfVar)))
                        {
                            displayStr = selAllStr;
                        }
                        dispDiv.setAttribute("value", displayStr);
                        if(uiType == "2")
                        {
                            dispDiv.value = displayStr;
                            compEl.compElContainer.displayValue = displayStr;
                            if(compEl.dispSelDiv) {
                                compEl.dispSelDiv.setAttribute("value", ZDBUtil.getSubString(displayStr, 150));
                            }
                        }
                        else
                        {
                            dispDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(displayStr);
                        }
                    }
                    else
                    {
                        var defDispCr = compEl.getAttribute("DEFAULTDISPLAYCRITERIA");
                        dispDiv.setAttribute("value", defDispCr);
                        if(uiType == "2")
                        {
                            dispDiv.value = defDispCr;
                        }
                        else
                        {
                            dispDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(defDispCr);
                        }
                    }
                }
            }
        }
    }

	this.showOrHideVMFilterPanel = function(view,showDFilter)
	{
            view.VMFiltersHolder.style.display = (showDFilter)?"":"none";
            if(showDFilter)
            {
                ZAVMFilter.replaceVariableName(view.VMFilterDropArea, true);
                ZAVMFilter.moveCompsNGetHeight(view,view.VMFilterDropArea,view.VMFiltersHolder);// + "px";
            }
            else
            {
                ZAVMFilter.replaceVariableName(view.VMFiltersHolder, false);
                ZAVMFilter.moveCompsNGetHeight(view,view.VMFiltersHolder,view.VMFilterDropArea);
            }
        if(view.type=="Dashboard")
        {
           view.VMFilterArea.style.display = (showDFilter)?"":"none";
           view.VMFilterFields.style.display = (showDFilter)?"none":"";
           view.vmfEditModeHeader.style.display = (showDFilter)?"none":"";
        }
        else
        {
        	ZAVMFilter.showMoreLessOption(view, showDFilter);
        }
	}
	
	this.showMoreLessOption = function(view, showDFilter)
	{
		var vmfHolder = view.VMFiltersHolder;
		var vmfOffWidth = vmfHolder.offsetWidth;
		var widthReqToShowAllComp = 0;
		var moreLessFilter = view.moreLessFilter;
		var ufList = jQuery(vmfHolder).find('[compbodyel="true"]').filter('[elname!="VMFilterResetBtn"]');//NO I18N
		var classToSetOn = moreLessFilter.getAttribute("classToSetOn");
        var resetBtn = view.VMFilterResetBtn;
		for(var i=0; i<ufList.length  && showDFilter; i++)
		{
			widthReqToShowAllComp = widthReqToShowAllComp + ufList[i].offsetWidth;
			if(widthReqToShowAllComp > vmfOffWidth)
			{
				showDFilter = true;
				break;
			}
			else if(i == (ufList.length -1))
			{
				showDFilter = false;
			}
		}
		if(!showDFilter)
		{
			moreLessFilter.style.display = "none";
			vmfHolderHgt = "";
            if(!view.editMode)
            {
                view.VMFiltersHolder.appendChild(resetBtn);
                jQuery(resetBtn).addClass("vmfResetButton");
            }
		}
		else
		{
			if(ufList.length <= 1)
			{
				moreLessFilter.style.display = "none";
				vmfHolderHgt = "";
			}
			else
			{
				moreLessFilter.style.display = "";
				if(classToSetOn == "showLessOption")
				{
					vmfHolderHgt = "60px";//NO I18N
					moreLessFilter.className = "showMoreOption";
					if(resetBtn.parentNode.getAttribute("elname") != "VMFilterArea")
					{
						view.VMFiltersHolder.removeChild(resetBtn);
						view.VMFilterArea.appendChild(resetBtn);
						jQuery(resetBtn).removeClass("vmfResetButton");
					}
				}
				else
				{
					//vmfHolderHgt = vmfHolder.offsetHeight + "px";//NO I18N
                    vmfHolderHgt = "";
					moreLessFilter.className = "showLessOption";
					if(resetBtn.parentNode.getAttribute("elname") != "VMFiltersHolder")
					{
						view.VMFilterArea.removeChild(resetBtn);
						view.VMFiltersHolder.appendChild(resetBtn);
						jQuery(resetBtn).addClass("vmfResetButton");
					}
				}
			}
		}
		vmfHolder.style.height = vmfHolderHgt;
	}
	
	this.showMoreLessFilters = function(el)
	{
		var view = ZDBClientUI.getViewObj(el, "view");
		var classToSetOn = el.getAttribute("classToSetOn");
		var vmfHolder = view.VMFiltersHolder;
		var resetBtn = view.VMFilterResetBtn;
		var vmfArea = view.VMFilterArea;
		var vmfHolderHgt;
		var className = classToSetOn;
		if(classToSetOn == "showLessOption")
		{
			classToSetOn = "showMoreOption";//NO I18N
			vmfHolderHgt = view.VMFiltersHolder.scrollHeight;
			vmfArea.removeChild(resetBtn);
			vmfHolder.appendChild(resetBtn);
			jQuery(resetBtn).addClass("vmfResetButton");
		}
		else
		{
			classToSetOn = "showLessOption";//NO I18N
			vmfHolderHgt =  60;
			vmfHolder.removeChild(resetBtn);
			vmfArea.appendChild(resetBtn);
			jQuery(resetBtn).removeClass("vmfResetButton");
		}
		el.setAttribute("classToSetOn",classToSetOn);
		var styleEl = null;
		el.className = className
		if(view.dashLayout){
			var $node = ZDBUtil.getParentWithAttributeValue(el, "class", "ZR-DashboardUFContainer").$node; //No i18N
			$node.scrollHeight = vmfHolderHgt+ view.moreLessFilter.offsetHeight;
			var styleEl = document.createElement("style");
			styleEl.innerText = ".ly-node { transition : top 0.35s; }"; //No i18N
			view.dashDiv.appendChild(styleEl);
			view.VMFiltersHolder.style.height = vmfHolderHgt + "px";
			view.resize();
			setTimeout(function() { view.dashDiv.removeChild(styleEl) } , 351);
		}
		else{
			jQuery(view.VMFiltersHolder).animate({height:vmfHolderHgt+""},20,"linear",function(){el.className = className; });
		}
		if(view.type != "Dashboard")
		{
			setTimeout(function(){ 
                            view.resize();
                        },350);
		}
        else if (BROWSER.IS_MOBILE_PHONE)
        {
            setTimeout(function(){view.enableBodyScroll();},350);
        }
	}

     this.removeComponent = function(el)
    {
        var compEl = (el.getAttribute("COMPBODYEL")!=null)?el:DOMUtils.getSelfOrParentWithAttr(el,"compBodyEl");//No I18N
        if(compEl==null){return;}
        var view = ZDBClientUI.getViewObj(el,"view");//No I18N
        if(compEl.getAttribute("isTimeLineComp") == "true")
        {
        	view.timeLineCompEnabled = false;
        	ZRTimelineFilter.removeTimeLineComp(view);
        	return;
        }
        ZDBUtil.removeFromSet(view.VMFiltersList,compEl);
        view.VMFilterDropArea.removeChild(compEl);
        ZAVMFilter.placeVMFilterDefinition(view);
        var optLst = compEl.optionList;
        if(optLst)
        {
          optLst.parentNode.removeChild(optLst);
        }
        if(view.type=="Dashboard")
        {
          ZDBDashboardUF.updateAddedFields(view);
        }
        ZDBAnalysisView.setModAndShowRefresh(view);
    }

	this.moveCompsNGetHeight = function(view, fromHolder, toHolder)
	{
		var comps = ZDBUtil.getElsWithAttrName(fromHolder,"compBodyEl");//No I18N
		var minHeight = 0;
		var len = comps.length;
		ZAVMFilter.showOrhideDFilterOption(view,len);
		if(len<1)
                {
                        view.VMFiltersHolder.style.display = "none";
			return minHeight;
		}
        for(var i=0; i<len; i++)
		{
                        toHolder.appendChild(comps[i]);
			var height = comps[i].offsetHeight;
			minHeight = (height > minHeight)?height:minHeight;
       }
       return minHeight + 5;//5px is for margin
	}

        this.showOrhideDFilterOption = function(view,len)
	{

            var display = (len<1)?"none":""; //NO I18N
            if(view.VMFilter == "false") //NO I18N
            {
                 display = "none"; //NO I18N
            }

	    view.VMFilterArea.style.display = display;
	}

    this.showVariableList = function(el,event){
        if(ZDBClientUI.isDBOwner){
            ZDBToolTip.hide(null,true);
            if(!loadReact(ZAVMFilter.showVariableList,[el,event])){
                return;
            }
            if(ZAVMFilter.curDBVars){
                var holder = ZRBaseComponentsUtils.getContainer("ZRDBVariables", document.body);//NO I18N
                var factory = React.createFactory(ReactMenu);
                ReactDOM.render(factory({MenuBatches:ZAVMFilter.curDBVars,srcEl:el,isLister:true,listEmptyText:ZDBI18NMap.g("zrpt.common.js.novariable")}),holder);
            }
            else{
                ZAVMFilter.getVariableList(el);
            }
            event && event.stopPropagation();
        }
    }

    this.getVariableList = function(el){
        var requestOptions = {URL:"/reportsapi/db/"+ ZDBClientUI.dbId +"/GETDBVARIABLES", //NO I18N
        ONSUCCESSFUNC:this.handleGetVariableListSucc,
        ONFAILUREFUNC:this.handleGetVariableListFail,OPSTATUSID:"ZDBMainLoader", //NO I18N
        SRC:el};
        AjaxAPI.sendRequest(requestOptions);
    }
    this.handleGetVariableListSucc = function(response,requestOptions){
        var respJSON = JSON.parse(response.responseText);
        var variables = [];
        respJSON.forEach(function(variable){
            variables.push(variable.VarName);
        })
        var menuBatches = [];
        variables.forEach(function(variable){
            var temp = {};
            temp.value = variable;
            temp.clickEvtHand = ZAVMFilter.handleVariableSelection;
            menuBatches.push(temp);
        })
        ZAVMFilter.curDBVars = [menuBatches];
        ZAVMFilter.showVariableList(requestOptions["SRC"]);
    }
    this.handleGetVariableListFail = function(response,requestOptions){
        ZAVMFilter.curDBVars = null;
        ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.userdata.variable.js.errorretrievingvar"));
    }
    this.handleVariableSelection = function(event){
        var valueH = event.target.innerHTML;
        var dlg = document.getElementById("ZDBCatChooseValDlg");
        var input = dlg.querySelector("#defInput");//NO I18N
        input.setAttribute("selDefCr","");
        input.setAttribute("TIPSHOWN","false");
        var value = input.value;
        var appendor = (value && value.substring(value.length-1,value.length) == ",")?"${":",${";
        input.value = (value)?value+appendor+valueH+"}":"${"+valueH+"}";
        ReactDOM.unmountComponentAtNode(document.getElementById("ZRDBVariables"));
    }
    
    this.getList = function(arrayOfData,uitype,label,isSearch,component,isFirstTime)
    {
        var jsonlen = arrayOfData.BASE_LIST.length;
        var lstEL = isSearch ? ZAVMFilter.tmpLstCntrForSrch.cloneNode(true) : ZAVMFilter.tmpLstCntr.cloneNode(true);
        lstEL.setAttribute("id","vmOptionList_"+label);
        lstEL.setAttribute("next",arrayOfData.EXTRA_INFO.NEXT);
        ZDBUtil.setNamedChildEls(lstEL,lstEL);
        var list = component.optionDiv ? component.optionDiv : lstEL;
        var emptyData = ZAVMFilter.checkIsNoDataFromServer(arrayOfData, list);
        if(emptyData)
        {
            return [lstEL,"true"];//No I18N
        }
        if(!isSearch)
        {
            ZAVMFilter.sslcLstopt = ZAVMFilter.SSLiopt.cloneNode(true);
            var mslcLstopt = ZAVMFilter.MAllSlcOp.cloneNode(true);
            uitype=="4"?ZAVMFilter.insertExtraElForVMFLst(lstEL.mainList,ZAVMFilter.sslcLstopt,false):ZAVMFilter.insertExtraElForVMFLst(lstEL.optionDiv,mslcLstopt,true,1)
        }
        lstEL = ZAVMFilter.VMFilterLstCreation(lstEL,lstEL.mainList,arrayOfData.BASE_LIST,jsonlen,uitype,null,component);
        if(uitype != "4" && (!isSearch))
        {
            var okCancelBtn =  ZAVMFilter.MApplydiv.cloneNode(true);
            ZAVMFilter.insertExtraElForVMFLst(lstEL,okCancelBtn);
        }
        var resizeOpLst = ZAVMFilter.resizableOptTmp.cloneNode(true);
        lstEL.appendChild(resizeOpLst); 
        return lstEL; // return VMFilter List
    }
    
    
    this.setAttrForliEl = function(liEl,className,valfunc)
    {//set Attributes for VMFList's liEl
        liEl.setAttribute("class",className);
        liEl.setAttribute("origClass",className);
        liEl.setAttribute("valfunc",valfunc);
    }

    this.insertExtraElForVMFLst = function(lstEL,childEl,place,position)
    {
        !(place) ? lstEL.appendChild(childEl) : lstEL.insertBefore(childEl,lstEL.childNodes[position]);
    }
    
    this.VMFilterLstCreation = function(lstEL,lstUlEL,arrayOfData,l,uitype,isVarLst,component)//lstUlEL normal list Ul or include list Ul
    {
            ZDBUtil.setNamedChildEls(lstEL,lstEL);
            for(var i=0;i<l;i++)
            {
                var liEl = document.createElement("LI");
                liEl.setAttribute("value",arrayOfData[i][1]);
                liEl.setAttribute("data-tip",arrayOfData[i][1]);
                liEl.innerHTML = ZDBEscapeUtil.encodeForHtml(arrayOfData[i][1]);
                liEl.setAttribute("displayvalue",arrayOfData[i][1]);
                liEl.setAttribute("filterdispvalue",arrayOfData[i][1]);
                liEl.setAttribute("filteredvalue",arrayOfData[i][0]+",");
                if(uitype == "4")
                {
                    ZAVMFilter.setAttrForliEl(liEl,"dComboSSOption","singleSelectChange");//No I18N
                }
               else
               {
                   if(component.compElContainer.getAttribute("exclude") == "true")
                   { 
                       ZAVMFilter.setAttrForliEl(liEl,"dComboSelectOption","selOrDeselEl");//No I18N
                   }
                   else{
                       ZAVMFilter.setAttrForliEl(liEl,"dComboDeselectOption","selOrDeselEl");//No I18N
                   }
               }
                ZDBUtil.attachEvent(liEl,"mouseover",function(event){ZDBToolTip.show(this, event)});//ToolTip.show(event,this);
                ZDBUtil.attachEvent(liEl,"mouseout",function(event){ZDBToolTip.hide(this, event)});
                if(isVarLst)
                {
                    var selAllLi = DOMUtils.getFirstMatchingChild(lstEL,null,"elname","selAllLi");//No I18N
                    uitype == "2" ? lstUlEL.insertBefore(liEl, lstUlEL.childNodes[0]) : jQuery(liEl).insertAfter(selAllLi);
                }
                else
                {
                    lstUlEL.appendChild(liEl);//append normal List liEl
                }

            }
            return lstEL; //return VMFilter List
    }
    
    this.checkIsNoDataFromServer = function(datas, list)
    {
        var baseLen = datas.BASE_LIST.length;
        var varLen = datas.VAR_LIST.length;
        var relLen = datas.REL_LIST ? datas.REL_LIST.lenght : 0;
        if(baseLen==0 && varLen==0 && relLen==0)
        {
            ZAVMFilter.constructNoDataAvailableMsg(list);
            return true;
        }
    }
    
    this.constructNoDataAvailableMsg = function(list)
    {
            var jquryLstEl = jQuery(list);
            var visibleLis = jquryLstEl.find("li:visible").length;
            var mainList =  DOMUtils.getFirstMatchingChild(list,null,"elname","mainList") //No I18N
            var noDataAvlEl = DOMUtils.getFirstMatchingChild(mainList,null,"elname","noData");//No I18N
            if(noDataAvlEl && visibleLis>0)
            {
                mainList.removeChild(noDataAvlEl);
            }
            else
            {
                if(!noDataAvlEl && visibleLis<1)
                {
                    var NDdivEl = document.createElement("DIV");// ND = No data;
                    jQuery(NDdivEl).text(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.noData"));
                    NDdivEl.classList.add("noDataAvl");//NO I18N
                    NDdivEl.setAttribute("elname","noData");
                    mainList.appendChild(NDdivEl);
                }

            }
    }
    
    this.constructRelativeList = function(vmfLstEl,slctLstEl,responseData,uitype,component)
    {
        var vmfSp = document.createElement("DIV");// vmfSp = VMFilterSeparator
        jQuery(vmfSp).addClass("VMFilterSeparator");
        slctLstEl.appendChild(vmfSp);
        var relativeUl = ZAVMFilter.IncRelLstUl.cloneNode(true); //IncRelUl = include relative List ulEl
        slctLstEl.appendChild(relativeUl);
        var relLen = responseData.REL_LIST.length;
        var fetchedElm = ZAVMFilter.VMFilterLstCreation(vmfLstEl,relativeUl,responseData.REL_LIST,relLen,uitype,null,component);
        return fetchedElm;
    }
    
    this.constructVariableList = function(data, list, component, isFirstTime)
    { 
        var uiType = component.getAttribute("UITYPE");
        var varDataLen = data.VAR_LIST.length;
        var copyVariableData = data.VAR_LIST;
        for (var i=0;i<varDataLen;i++)
        {   
            var isDublicateData = ZAVMFilter.isDublicateData(data, data.VAR_LIST[i][1]);
            if(isDublicateData)
            {  
                var orgliEl = DOMUtils.getChildElsWithAttr(list, "value", data.VAR_LIST[i][1])[0];
                uiType == "2" ? list.selectListEl.insertBefore(orgliEl, list.selectListEl.childNodes[0]) : jQuery(orgliEl).insertAfter(list.selAllLi) //NO I18N
                copyVariableData.splice(i);
            }
        }
        if(0<copyVariableData.length)
        {
            ZAVMFilter.VMFilterLstCreation(list, list.mainList, copyVariableData, varDataLen, uiType, true, component);   
        }
    }
    
    this.constructOthersOpt = function(selectListEl,uitype)
    {
            var liEl = document.createElement("LI");
            liEl.setAttribute("value",ZAVMFilter.OTHERS_KEY);
            liEl.setAttribute("data-tip",ZAVMFilter.OTHERS_KEY);
            liEl.innerHTML = ZAVMFilter.OTHERS_KEY;   
            liEl.setAttribute("displayvalue",ZAVMFilter.OTHERS_KEY);
            liEl.setAttribute("filterdispvalue",ZAVMFilter.OTHERS_KEY);
            liEl.setAttribute("filteredvalue",ZAVMFilter.OTHERS_CR_KEY+",");
            uitype == "4"?ZAVMFilter.setAttrForliEl(liEl,"dComboSSOption","singleSelectChange"):ZAVMFilter.setAttrForliEl(liEl,"dComboSelectOption","selOrDeselEl");
            ZDBUtil.attachEvent(liEl,"mouseover",function(event){ZDBToolTip.show(liEl, event)});
            ZDBUtil.attachEvent(liEl,"mouseout",function(event){ZDBToolTip.hide(liEl, event)});
            selectListEl.appendChild(liEl);
    }
    
    this.getVMFFullLst = function(jsonData,component,resElement,isSearch,isFirstTime)
    {
         var uiType = component.getAttribute("UITYPE");
         var label = component.getAttribute("LABEL");
         var list = ZAVMFilter.getList(jsonData,uiType,label,isSearch,component,isFirstTime);
         if(list[0])
         {
            resElement.appendChild(list[0]);
            return "true";//No I18N
         }
         resElement.appendChild(list);
         list.elnameSet=false;
         ZDBUtil.setNamedChildEls(list,list);
         var slctLstEl = list.getAttribute("fetcheddiv") != "true" ? list.selectListEl : ZDBUtil.getParentWithAttributeValue(list,"elname", "selectListEl");//No I18N
        if(jsonData.VAR_LIST)
        {
            ZAVMFilter.constructVariableList(jsonData, list, component, isFirstTime);
        }
        if(jsonData.REL_LIST)
        {
            ZAVMFilter.constructRelativeList(list,slctLstEl,jsonData,uiType,component); 
        }
        list.style.display = "none";
        return list;
    }
    
    
    this.isDublicateData = function(datas, value, data)//for variable data
    {       
        if(data)
        {
            for(var i=0; i<data.length; i++)
            {
                if(data[i][1] == value)
                {
                    return true;
                }
            }
            data.isCheck=true;
        }  
        if(datas.BASE_LIST && (0<datas.BASE_LIST.length) && (!datas.BASE_LIST.isCheck))
        {
            data = datas.BASE_LIST;
            if(ZAVMFilter.isDublicateData(datas, value, data)){return true};
        }
        else if(datas.REL_LIST && (0<datas.REL_LIST.length) && (!datas.REL_LIST.isCheck))
        {
            data = datas.REL_LIST;
            if(ZAVMFilter.isDublicateData(datas, value, data)){return true};
        }
        else
        {
            return false;
        }
            
    }
    
    
    this.switchComponentFocus = function(el)
    {
        var view = ZDBClientUI.getViewObj(el, "view");
        if(view.editMode)
        {
            var lists = view.VMFiltersList;
            for(var i=0; i<lists.length; i++)
            {
                jQuery(lists).removeClass("highLight");
            }
            jQuery(el).addClass("highLight");
        }
    }
        
}
