//$Id$
var ZAVMFilterUtil = new function ()
{
    this.getComboOptAsCSV = function (combo, within, selectedOnly)
    {
        var len = combo.length;
        var opt = combo.options;
        within = (within == null) ? "" : within;
        var val = "";
        var text = "";
        var delimiter = "";
        var condition = "";
        var symbol = "";
        for (var i = 0; i < len; i++) {
            condition = (selectedOnly) ? opt[i].selected : opt[i];
            if (condition && opt[i].value != "") {
                delimiter = (val != "") ? "," : "";
                val = val + delimiter + within + opt[i].value + within;
                text = text + delimiter + within + opt[i].text + within;
            }
        }
        return [val, text];
    }

    this.getFilterDateFormat = function (dt)
    {
        var val = ZDBValidator.resetDateSeparator(dt);
        val = ZDBValidator.getYMDConvertedDate(val);
        var date = Date.parse(val);
        if (isNaN(date))
        {
            return val;
        }
        var MILLI = date;
        date = new Date(date);

        var dd = date.getDate();
        dd = (dd < 10) ? "0" + dd : dd;
        var MM = date.getMonth();
        MM = (MM < 10) ? "0" + MM : MM;
        var yyyy = date.getFullYear();
        if (yyyy < 1000)
        {
            yyyy = yyyy + 1900; /// Will this be an issue?
        }
        yyyy = yyyy + "";
        var HH = date.getHours();
        HH = (HH < 10) ? "0" + HH : HH;
        var mm = date.getMinutes();
        mm = (mm < 10) ? "0" + mm : mm;
        var ss = date.getSeconds();
        ss = (ss < 10) ? "0" + ss : ss;

        return yyyy + "-" + MM + "-" + dd + " " + HH + ":" + mm + ":" + ss;
    }

    this.clearIDNSetupCalender = function (orgComp, newComp)
    {
        ZDBUtil.setNamedChildEls(orgComp, orgComp);
        var fromValueId = orgComp.fromValue.getAttribute("id");
        var toValueId = orgComp.toValue.getAttribute("id");
        orgComp.fromValue.setAttribute("id", "");
        orgComp.toValue.setAttribute("id", "");
        ZDBUtil.setNamedChildEls(newComp, newComp);
        ZAVMFilterEdit.initCalender(newComp);
        orgComp.fromValue.setAttribute("id", fromValueId);
        orgComp.toValue.setAttribute("id", toValueId);
    }

    this.isValidData = function (compEl, value)
    {
        var dispAll = ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all");
        if (value.length == 0 || value == dispAll || jQuery.inArray(dispAll, value) != -1) {
            return true;
        }

        var optionDiv = compEl.optionDiv;
        var valExists = false;
        var dispCrStr = optionDiv.getAttribute("dispcrstr");
        var dispCrArr = ZAVMFilterUtil.splitAsArray(dispCrStr);
        for (var i = 0; i < value.length; i++)
        {
            if (jQuery.inArray(value[i], dispCrArr) != -1)
            {
                valExists = true;
                break;
            }
        }
        if (!valExists)
        {
            var errMsg = ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.dataMismatch");
            ZDBUtil.setFocus(compEl.compElContainer, true);
            showCustomMessage(errMsg, compEl.compElContainer);
            return false;
        }
        return true;
    }

    // fix it so that it does not contain repeating values, consecutive commas, etc
    this.fixValue = function (value)
    {
        if (value.length == 0 || value == ",") {
            return "";
        }

        if (value.charAt(0) == ',') {
            value = value.substring(1);
        }
        if (value.charAt(value.length - 1) == ',') {
            value = value.substring(0, value.length - 1);
        }

        var arrVal = ZAVMFilterUtil.splitAsArray(value);
        return ZAVMFilterUtil.removeDuplicate(arrVal);
    }

    this.removeDuplicate = function (arrVal)
    {
        var result = [];
        jQuery.each(arrVal, function (i, val) {
            if (val != "" && jQuery.inArray(val, result) == -1) {
                result.push(val);
            }
        });
        return result;
    }

    this.checkKeyNContinue = function (event)
    {
        if (ZAVMFilter.searchFocused) {
            return;
        } // if search focused event should be handled by search box
        if (event == null)
        {
            event = window.event;
        }
        if (event.keyCode == 27)
        {
            ZAVMFilterUtil.closeList(event, true);
            event.stopPropagation();
        } else if (event.keyCode == 40 || event.keyCode == 38)
        {
            ZAVMFilterUtil.highlightSelected(event, true);
        } else if (event.keyCode == 13 || event.keyCode == 32)
        {
            ZAVMFilterUtil.selectOption(ZAVMFilterUtil.curList.currentHighlightedItem, event);
        }
    }

    this.highlightSelected = function (event, isKeypress)
    {
        if (event == null)
        {
            event = window.event;
        }
        var mouseOnEl;
        if (isKeypress)
        {
            var options = ZAVMFilterUtil.curList.getElementsByTagName("LI");
            var noofitems = options.length;
            var highlightedItemIndex = ZDBUtil.indexOf(options, ZAVMFilterUtil.curList.currentHighlightedItem);
            switch (event.keyCode)
            {
                case 40:
                    if (highlightedItemIndex == (noofitems - 1))
                    {
                        return;
                    } else
                    {
                        highlightedItemIndex++;
                    }
                    break;
                case 38:
                    if (highlightedItemIndex == 0)
                    {
                        return;
                    } else
                    {
                        highlightedItemIndex--;
                    }
                    break;
            }
            mouseOnEl = options[highlightedItemIndex];
        } else
        {
            mouseOnEl = ZDBUtil.getSourceElement(event);
        }
        if (mouseOnEl && mouseOnEl.tagName != "LI")
        {
            if (curHighLitedEl && mouseOnEl.getAttribute("searchBox") == "true")
            {
                curHighLitedEl.className=curHighLitedEl.getAttribute("origClass");
            }
            return;
        }
        var curHighLitedEl = ZAVMFilterUtil.curList.currentHighlightedItem;
        ZAVMFilterUtil.curList.currentHighlightedItem = null;
        if (curHighLitedEl)
        {
            curHighLitedEl.className=curHighLitedEl.getAttribute("origClass");
        }
        ZAVMFilterUtil.curList.currentHighlightedItem = mouseOnEl;
        curHighLitedEl = ZAVMFilterUtil.curList.currentHighlightedItem;
        curHighLitedEl.className=(curHighLitedEl.getAttribute("origClass") + "Hover");
    }
    
    this.leaveFocuse = function()
    {
        var curHighLitedEl = ZAVMFilterUtil.curList.currentHighlightedItem;
        if(curHighLitedEl){curHighLitedEl.className=curHighLitedEl.getAttribute("origClass")};
    }
    
    this.selectOption = function (listItem, ev)
    {
        var optList = ZDBUtil.getParentWithAttributeValue(listItem, "optionlist", "true");//NO I18N
        var defList = ZDBUtil.getParentWithAttributeValue(listItem, "defList", "true");//NO I18N
        if (optList)
        {
            ZAEditableUF.sendReq = true;
            if (ZAVMFilterUtil.curList.style.display == "" && (ZAEditableUF.inputEl == null ||
                    listItem.className.substring(listItem.className.length - 5) == "Hover")) //No I18N
            {
                ZAVMFilterUtil.selectOptionListEl(listItem, ev);
                ZAEditableUF.sendReq = false;
            }
        } else if (defList)
        {
            ZAVMFilterUtil.selectDefListEl(listItem, ev);
            ZAVMFilterUtil.closeList(ev, true);
        } 

    }
    this.selectDefListEl = function (listItem, ev)
    {
        ZAVMFilterUtil.currentSelectedItem = listItem;
        ZAVMFilterUtil.curList.currentHighlightedItem = ZAVMFilterUtil.currentSelectedItem;
        var defList = ZDBUtil.getParentWithAttributeValue(ZAVMFilterUtil.currentSelectedItem, "defList", "true");//NO I18N
        var func = listItem.getAttribute("valFunc");
        ZAVMFilterSearch[func](defList, listItem);
    }
    this.selectOptionListEl = function (listItem, ev)
    {
        ZAVMFilterUtil.currentSelectedItem = listItem;
        ZAVMFilterUtil.curList.currentHighlightedItem = ZAVMFilterUtil.currentSelectedItem;
        var optList = ZDBUtil.getParentWithAttributeValue(ZAVMFilterUtil.currentSelectedItem, "optionlist", "true");//NO I18N
        var func = listItem.getAttribute("valFunc");
        ZAVMFilterComp[func](optList, listItem);
        if (func == "singleSelectChange")
        {
            ZAVMFilterUtil.closeList(ev, true);
            var view = ZDBClientUI.getViewObj(optList.component, "view"); //NO I18N
            view.changeSliderBoundaries = true;
            view.lastAppliedEl = optList.component;
            ZAVMFilter.refreshView(optList.component);
        }
    }

    this.closeList = function (event, isKeypress)
    {
        if(ZAVMFilterUtil.isResize)
        {
            ZAVMFilterUtil.isResize = false;
            return;
        }
        if (!isKeypress)
        {
            var tarEl = event ? ZDBUtil.getSourceElement(event) : null;
            var compEl = ZDBUtil.getParentWithAttributeValue(tarEl, "elname", "compElContainer");//No I18N
            var optList = ZDBUtil.getParentWithAttributeValue(tarEl, "optionlist", "true");//NO I18N
            var defList = ZDBUtil.getParentWithAttributeValue(tarEl, "deflist", "true");//NO I18N
            var defEl = tarEl.id == "defInput";
            var alertDlg = ZDBUtil.getParentWithAttributeValue(tarEl, "id", "customAlertMessage");//NO I18N
            var isTooltip = ZDBUtil.getParentWithAttributeValue(tarEl, "elname", "toolTipArea");//No I18N
            if (compEl != null || optList != null || alertDlg != null || defEl || defList != null || isTooltip != null)
            {
                return;
            }
        }   
        hideCustomMessage();
        if (ZAVMFilterUtil.curList) {
            ZAEditableUF.resetValue(ZAVMFilterUtil.curList.component);
            if(ZAVMFilterUtil.curList.currentHighlightedItem){
                ZAVMFilterUtil.curList.currentHighlightedItem.className=(ZAVMFilterUtil.curList.currentHighlightedItem.getAttribute("origClass"));
            }
            ZAVMFilterUtil.curList.style.display = "none";
            ZAVMFilterUtil.curList.listVisible = false;
            ZDBUtil.detachEvent(ZAVMFilterUtil.curList, 'mouseover', ZAVMFilterUtil.highlightSelected, true);
            ZDBUtil.detachEvent(ZAVMFilterUtil.curList, 'mouseleave', ZAVMFilterUtil.leaveFocuse, true);
        }
        ZDBUtil.detachEvent(document, (ZDBGlobal.IS_MOBILE) ? 'touchstart' : 'click', ZAVMFilterUtil.closeList, true);
        ZDBUtil.detachEvent(document, 'keydown', ZAVMFilterUtil.checkKeyNContinue, true);
    }

    this.trimCommaAtEnd = function (defVal)
    {
        defVal = (defVal.lastIndexOf(",") == defVal.length - 1) ? defVal.substring(0, defVal.length - 1) : defVal;
        return defVal;
    }

    // moves the cursor to the end of the text in the input box
    this.moveCursorToEnd = function (el)
    {
        if (typeof el.createTextRange != "undefined") // for IE
        {
            el.focus();
            var range = el.createTextRange();
            range.collapse(false);
            range.select();
        } else if (typeof el.selectionStart == "number")
        {
            el.focus();
            el.selectionStart = el.selectionEnd = el.value.length;
        }
    }

    // comma separated string is changed to an array of string
    this.splitAsArray = function (strVal)
    {
        var strArr = [];
        var copyStr = strVal.trim();
        while (copyStr.length > 0)
        {
            var commaIdx = copyStr.indexOf(",");
            if (commaIdx == -1)
            {
                strArr.push(copyStr.trim());
                break;
            }
            var commaEndIdx = copyStr.indexOf("\",");
            if (commaEndIdx == -1 && copyStr.charAt(copyStr.length - 1) == "\"") {
                commaEndIdx = copyStr.length - 1;
            }
            if (copyStr.indexOf('"') == 0 && commaEndIdx != -1) // comma data
            {
                strArr.push(copyStr.substr(0, commaEndIdx).trim() + "\"");
                copyStr = copyStr.substr(commaEndIdx + 2);
            } else
            {
                strArr.push(copyStr.substr(0, commaIdx).trim());
                copyStr = copyStr.substr(commaIdx + 1);
            }
        }
        return strArr;
    }
    
    //related to vmfilter list resize.
    this.attachResizeEvent = function(el,elBoundsStatus,event)
    {
        var list = DOMUtils.getParentWithAttrValue(el,"optionlist","true"); //NO I18N
        this.list = list;
        this.elBounds = elBoundsStatus;//right or left
        ZDBUtil.attachEvent(document,"mousemove",ZAVMFilterUtil.triggerResizeEvent,true);
        ZDBUtil.attachEvent(document,"mouseup",ZAVMFilterUtil.detachResizeEvent);
        ZDBUtil.stopEventBubble(event);
    }
    
    this.triggerResizeEvent = function(event)
    {
        var list = ZAVMFilterUtil.list;
        var workArea = ZDBClientUI.ZDBViewEl.view.viewComp;
        var listStarBound = ZDBUtil.getObjLeft(list);
        var listEndBound = listStarBound+list.offsetWidth;
        var moveDiff = ZAVMFilterUtil.elBounds == "right" ? (event.clientX-(listEndBound)) : (listStarBound-event.clientX);//No I18N
        list.style.width = (list.offsetWidth+moveDiff)+"px";//No I18N 
        ZDBUtil.stopEventBubble(event);
    }
    
    this.detachResizeEvent = function(event)
    {   
           ZDBUtil.stopEventBubble(event);
           ZDBUtil.detachEvent(document,"mousemove",ZAVMFilterUtil.triggerResizeEvent,true);
           ZDBUtil.detachEvent(document,"mouseup",ZAVMFilterUtil.detachResizeEvent);
           ZAVMFilterUtil.isResize = true;
    }
}
