/* $Id$ */
//ignorei18n_start
var ZRNLP = new function(){
    this.autosuggester = null;
    var self = this;
    this.pickedRequestZOHO_TOKENS = '';
    this.apiToUse = window.location.href.indexOf('zia') > 0 ? '/zia/reportsnlp/' : '/reportsnlp/';
    this.htmlCreator = AutoSuggest.DomCreator;
    this.htmlEncoder = new AutoSuggest.Encoder.getHTMLEncoder();
    this.jsEncoder = new AutoSuggest.Encoder.getJSEncoder();
    this.dbList = this.htmlCreator.getDivWithGivenOptions({id: 'ZNLPDBList', class: 'ZNLPDBList hide'});
    var div = this.htmlCreator.getDivWithGivenOptions({style: {padding: '5px', height: '22px'}});
    var span1 = this.htmlCreator.getSpanWithGivenOptions({class: 'ellipsis fLeft', style: {width: '77%'}});
    var span2 = this.htmlCreator.getSpanWithGivenOptions({class: 'ellipsis fRight', style: {width: '20%'}});
    this.init = function(){
        this.setUpTestingMode();
        for (var dbType in dbIdArr)
        {
            var dbIds = Object.keys(window.dbIdArr[dbType]);
            this.selectBox = document.getElementById('ZRNLPDBList');
            this.curDBInfoHolder = document.getElementById('ZRNLPCurrDB');
            for (var i = 0, len = dbIds.length; i < len; i++) {
                var db = dbIds[i];
                var dbName = window.dbIdArr[dbType][db].name;
                if (i === 0) {
                    this.selectBox.value = db;
                    this.curDBInfoHolder.innerText = dbName;
                }
                var tempOption = span1.cloneNode();
                var tempDiv = div.cloneNode();
                tempDiv.setAttribute('dbId', db);
                tempDiv.setAttribute('dbName', dbName);
                tempOption.value = db;
                tempOption.innerHTML = this.htmlEncoder.encode(dbName);
                tempDiv.appendChild(tempOption);
                tempOption = span2.cloneNode();
                tempOption.innerHTML = this.htmlEncoder.encode(dbType);
                tempDiv.appendChild(tempOption);
                tempDiv.addEventListener('click', function (event) {
                    var target = AutoSuggest.GeneralUtils.getElOrParentWithAttr(event.target, 'dbId');
                    this.selectBox.value = target.getAttribute('dbId');
                    this.selectBox.innerText = target.getAttribute('dbName');
                    this.toggleDBList(event);
                    self.tableOBJId = null;
                    AutoSuggest.close(this.autosuggester);
                    this.initializeAutosuggest();
                    this.resetView();
                    this.sendTableInfoReq();
                }.bind(this));
                this.dbList.appendChild(tempDiv);
            }
        }
        document.body.appendChild(this.dbList);
        this.initializeAutosuggest();
        this.sendTableInfoReq();
        this.selectBox.addEventListener('click', this.toggleDBList);
        document.body.addEventListener('click', this.hideDBListNSettings);
    };
    
    this.initializeAutosuggest = function () {
        this.autosuggester = new AutoSuggest({
            uiConfig : {
                holder: document.getElementById('ZRNLPInputHolder'),
                searchBox: {
                    style: {},
                    customAttributes: {}
                },
                suggestionBox: {
                    style: {},
                    customAttributes: {}
                }
            },
            metaConfig : {
                suggestionRequest: this.apiToUse + 'getsuggestions',
                alternateSuggestionRequest: this.apiToUse + 'autosuggestalternatesuggestions',
                completionRequestHandler: this.sendGraphGenerateRequest,
                suggestionRequestCallback: this.updateTimeLog,
                suggestionRequestParams: 'DBID='
                        + this.selectBox.value
                        + (self.tableOBJId ? '&TABLEID=' + self.tableOBJId : ''),
                alternateSuggestionRequestParams: 'DBID='
                        + this.selectBox.value
                        + (self.tableOBJId ? '&TABLEID=' + self.tableOBJId : '')
                
            }
        });
    };

    this.sendTableInfoReq = function () {
        var dbID = self.selectBox.value;
        var ajaxAPI = AutoSuggest.Ajax;
        ajaxAPI.sendRequest({
            URL: self.apiToUse + 'gettabledetailsfordb',
            DEFAULTPARAMS: 'DBID=' + dbID,
            METHOD: "GET",
            ONSUCCESSFUNC: self.handleTableMetaSuccess
        });
    };

    this.handleTableMetaSuccess = function(response){
        var respJSON = JSON.parse(response);
        var tables = Object.keys(respJSON);
        var tn;
        var tableList = document.getElementById('ZNLPTableList') || ZRNLP.htmlCreator.getDivWithGivenOptions({id: 'ZNLPTableList', class: 'ZNLPTableList hide'});
        self.tableList = tableList;
        tableList.innerHTML = '';
        var innerHolderDiv = ZRNLP.htmlCreator.getDivWithGivenOptions({style: {padding: '5px', height: '22px'}});
        var allTableDiv = innerHolderDiv.cloneNode();
        allTableDiv.setAttribute('name', 'All Tables');
        allTableDiv.setAttribute('objid', '');
        allTableDiv.innerText = 'All Tables';
        allTableDiv.addEventListener('click', self.changeTable);
        tableList.appendChild(allTableDiv);
        for (var i = 0, len = tables.length; i < len; i++) {
            var tableObjId = tables[i];
            tn = respJSON[tableObjId].name;
            var innerDiv = innerHolderDiv.cloneNode();
            innerDiv.setAttribute('name', tn);
            innerDiv.setAttribute('objid', tableObjId);
            innerDiv.innerText = tn;
            innerDiv.addEventListener('click', self.changeTable);
            tableList.appendChild(innerDiv);
            document.getElementById('ZRNLPCurrTable').innerText = 'All Table';
        }
        document.getElementById('ZRNLPCurrTable').addEventListener('click', self.toggleTableList);
        self.tableList.style.left = document.getElementById('ZRNLPTableList').getBoundingClientRect().left + 'px';
        if (!document.getElementById('ZNLPTableList')) {
            document.body.appendChild(self.tableList);
        }
    };

    this.changeTable = function (event) {
        var target = event.target;
        var tn = target.getAttribute('name');
        var tableObjId = target.getAttribute('objid');
        self.tableOBJId = (tableObjId) ? tableObjId : null;
        self.toggleTableList(event);
        document.getElementById('ZRNLPCurrTable').innerText = tn;
        AutoSuggest.close(self.autosuggester);
        self.initializeAutosuggest();
    };

    this.showServerInfo = function(element){
        if (self.serverInfoShowed) {
            //close
            self.serverInfoShowed = false;
            AutoSuggest.GeneralUtils.removeClass(element, 'toggleRight');
            AutoSuggest.GeneralUtils.removeClass(document.getElementsByClassName('ZNLPServerInfoHolder')[0], 'scrollLeft');
        }
        else {
            //open
            self.serverInfoShowed = true;
            AutoSuggest.GeneralUtils.addClass(element, 'toggleRight');
            AutoSuggest.GeneralUtils.addClass(document.getElementsByClassName('ZNLPServerInfoHolder')[0], 'scrollLeft');
        }
    };

    this.sendGraphGenerateRequest = function (json) {
//        var json = {
//            eq: self.autosuggester.uiHandler.inputBox.value,
//            sugaf: self.autosuggester.uiHandler.inputBox.value,
//            eqt: self.autosuggester.metaHandler.serverResponseMap[self.autosuggester.uiHandler.inputBox.value.toLowerCase()].eqt
//        };
        self.NLPTEXT = JSON.stringify(json);
        var params = 'DBID=' + self.selectBox.value + '&MODELTYPE=1'+ '&NLPTEXT=' + encodeURIComponent(JSON.stringify(json)) + (self.tableOBJId ? '&TABLEID=' + self.tableOBJId : '');
        AutoSuggest.Ajax.sendRequest({
            URL: self.apiToUse + 'createreport',
            METHOD: 'POST',
            DEFAULTPARAMS: params, ONSUCCESSFUNC: self.handleGraphGenerationSuccess
        });
    };

    this.resetView = function () {
        self.resetInterpretedQuery();
        self.refreshPreviousReport();
        self.resetSwitchLinks();
        self.resetColumns();
        AutoSuggest.GeneralUtils.addClass(document.getElementById('ZRNLPFeedback'), 'hide');
        var reportOutputHolder = document.querySelector('#ZRNLPReportResult');
        AutoSuggest.GeneralUtils.addClass(reportOutputHolder, 'hide');
    };

    this.resetColumns = function () {
        var holder = document.getElementById('ZRNLPReportColumns');
        holder.innerHTML = '';
    };

    this.refreshPreviousReport = function () {
        var report = document.getElementById('ZRNLPReport');
        report.innerHTML = '';
    };

    this.handleGraphGenerationSuccess = function(response){
        var genRepJSON = JSON.parse(response);
        self.graphGenerated = true;
        self.storeGenerateTestCaseData(genRepJSON);
        self.reports = genRepJSON.reports;
        self.nlpTrace = genRepJSON.nlptrace;
        self.timelog=genRepJSON.timelog;
        self.redisKey = genRepJSON.rediskey;
        if (self.reports.length > 0) {
            self.resetView();
            self.placeReports(0);
            self.generateSwitchLinks(0);
            self.updateInterpretedQuery(0);
            self.updateColumns(0);
            self.curSelChartIndex = 0;
            self.positionAllElements();
            AutoSuggest.GeneralUtils.removeClass(document.getElementById('ZRNLPFeedback'), 'hide');
        }
        var reportOutputHolder = document.querySelector('#ZRNLPReportResult');
        AutoSuggest.GeneralUtils.removeClass(reportOutputHolder, 'hide');
        AutoSuggest.GeneralUtils.removeClass(document.querySelector('.ZRNLPFeedback'), 'hide');
    };

    this.updateColumns = function (index) {
        var curReportData = self.reports[index].reportdesc;
        var columnHolder = document.getElementById('ZRNLPReportColumns');
        columnHolder.innerHTML = '';
        var i, j, len, len2, template;
        var filterColumns = curReportData.filtercolumns;
        if (filterColumns && filterColumns.length > 0) {
            var columnCategory = AutoSuggest.DomCreator.getDivWithGivenOptions({class: 'ZRColumnCategoryTitle'});
            columnCategory.innerText = 'Filters';
            columnHolder.appendChild(columnCategory);
            for (i = 0, len = filterColumns.length; i < len; i++) {
                template = self.getColumnTemplate(filterColumns[i]);
                columnHolder.appendChild(template);
            }
        }
    };

    this.getColumnTemplate = function (columnData) {
        var htmlEncoder = AutoSuggest.Encoder.getHTMLEncoder();
        var jsEncoder = AutoSuggest.Encoder.getJSEncoder()
        var columnIcon = AutoSuggest.DomCreator.getDivWithGivenOptions({class: 'nlpIcons columnsIcon'});
        var columnInfo = AutoSuggest.DomCreator.getDivWithGivenOptions({class: 'columnInfo'});
        var div = AutoSuggest.DomCreator.getDivWithGivenOptions({class: 'ellipsis'});
        var span = AutoSuggest.DomCreator.getSpanWithGivenOptions({title: jsEncoder.encode(htmlEncoder.encode(columnData.partblname) + "." + htmlEncoder.encode(columnData.column))});
        span.innerHTML = htmlEncoder.encode(columnData.partblname) + "." + "<b>" + htmlEncoder.encode(columnData.column) + "</b>";
        div.appendChild(span);
        columnInfo.appendChild(div);
        var div2 = AutoSuggest.DomCreator.getDivWithGivenOptions({class: 'ellipsis'});
        span = AutoSuggest.DomCreator.getSpanWithGivenOptions({title: "Function : " + htmlEncoder.encode(columnData.operation)});
        span.innerHTML = "Function : " + "<b>" + htmlEncoder.encode(columnData.operation) + "</b>";
        div2.appendChild(span);
        columnInfo.appendChild(div2);
        if (columnData.filtervalues) {
            var div3 = AutoSuggest.DomCreator.getDivWithGivenOptions({class: 'ellipsis'});
            var str = columnData.filtervalues[0];
            for (var i = 1, len = columnData.filtervalues.length; i < len; i++) {
                str += ', ' + columnData.filtervalues[i];
            }
            span = AutoSuggest.DomCreator.getSpanWithGivenOptions({title: "Criteria : " + htmlEncoder.encode(str)});
            span.innerHTML = "Criteria : <b>" + htmlEncoder.encode(str) + "</b>";
            div3.appendChild(span);
            columnInfo.appendChild(div3);
        }
        var holder = AutoSuggest.DomCreator.getDiv();
        holder.appendChild(columnIcon);
        holder.appendChild(columnInfo);
        return holder;
    };

    this.positionAllElements = function () {
        var textAreaHeight = document.querySelector('.__autoSuggestSearchBox').getBoundingClientRect().height;
        var chartHolder = document.getElementById('ZRNLPReportResult');
        chartHolder.style.top = textAreaHeight + 60 + 'px';
        var interpretedQuery = document.getElementById('ZRNLPInterpretedQueryText');
        var switchLinks = document.getElementById('ZRNLPReportLinks');
        var height = interpretedQuery.getBoundingClientRect().height;
        height = height ? height : 33;
        switchLinks.style.top = height + 'px';
    };

    this.updateInterpretedQuery = function (index) {
        var interpretedQuery = self.reports[index].interpretedQuery;
        document.getElementById("ZRNLPInterpretedQueryText").innerHTML = interpretedQuery;
        var nlpQueryOutput = self.reports[index].nlpqueryoutput;
        var nlpQueryOutputDiv = document.getElementById('nlpquerytrace');
        nlpQueryOutputDiv.textContent = nlpQueryOutput;
        var nlpTrace = self.nlpTrace;
        var timeLog=self.timelog;
        var nlpTraceDiv = document.getElementById('nlptrace');
        nlpTraceDiv.innerHTML = nlpTrace;
        var nlpTimeLogDiv=document.getElementById('timelog');
        nlpTimeLogDiv.innerHTML=timeLog;
    };

    this.generateSwitchLinks = function (selectedIndex){
        var switchLinkHolder = document.getElementById('ZRNLPReportLinks');
        var editIcon = AutoSuggest.DomCreator.getDivWithGivenOptions({class: 'nlpIcons editReport'});
        editIcon.addEventListener('click', self.editReport);
        switchLinkHolder.appendChild(editIcon);
        self.reports.forEach(function (report, index) {
            var objId = report.parentobjid;
            var div = AutoSuggest.DomCreator.getDivWithGivenOptions({class: (index === selectedIndex) ? 'indexHolder selected' : 'indexHolder', 'data-objid': objId, 'data-index': index});
            div.innerText = index + 1;
            div.addEventListener('click', self.switchReport);
            switchLinkHolder.appendChild(div);
            var checkBox = ZRNLP.getTestCaseCheckBox(index, "ZRRLink");
            var inputBox = (checkBox !== "") ? switchLinkHolder.appendChild(checkBox) : "";
        });
    };

    this.resetSwitchLinks = function () {
        var switchLinkHolder = document.getElementById('ZRNLPReportLinks');
        switchLinkHolder.innerHTML = '';
    };

    this.editReport = function (event) {
        var dbId = self.selectBox.value;
        var url = window.location.origin + '/ZDBDataSheetView.cc?DBID=' + dbId + "&OBJKEY=" + self.redisKey + "_" + self.curSelChartIndex;
        window.open(url, '_blank');
    };

    this.switchReport = function (event) {
        var target = event.target;
        var index = target.getAttribute('data-index');
        self.resetView();
        self.curSelChartIndex = index;
        self.placeReports(index);
        self.generateSwitchLinks(index);
        self.updateInterpretedQuery(index);
        self.updateColumns(index);
        self.positionAllElements();
        AutoSuggest.GeneralUtils.removeClass(document.getElementById('ZRNLPFeedback'), 'hide');
        AutoSuggest.GeneralUtils.removeClass(document.getElementById('ZRNLPReportResult'), 'hide');
    };

    this.resetInterpretedQuery = function () {
        var interpQryDiv = document.getElementById('ZRNLPInterpretedQueryText');
        interpQryDiv.textContent = '';
    };

    this.placeReports = function (index) {
        var reportHolder = document.getElementById('ZRNLPReport');
        var dbId = self.selectBox.value;
        var errorMsg = self.reports[index].errormsg;
        if (errorMsg === null || errorMsg === undefined)
        {
            var objKey = self.redisKey + '_' + index;
            var iframeEl = document.createElement('iframe');
            iframeEl.id = 'ZRNLPDisplayReport';
            iframeEl.src = '/ZDBDataSheetView.cc?DBID=' + dbId + '&OBJKEY=' + objKey + '&STANDALONE=true&INTERVAL=-1&REMTOOLBAR=false&INCLUDETITLE=false&INCLUDEDESC=false';
            iframeEl.width = '100%';
            iframeEl.height = '100%';
            iframeEl.frameborder = '0';
            reportHolder.appendChild(iframeEl);
        }
        else
        {
            var errorDiv = AutoSuggest.DomCreator.getDiv();
            errorDiv.textContent = errorMsg;
            reportHolder.appendChild(errorDiv);
        }
    };

    this.handleFeedback = function () {
        var feedbackDlg = self.createFeedBackDialog();
        document.body.appendChild(feedbackDlg);
        var fTypeDivs = feedbackDlg.querySelectorAll('.fTypesDiv');
        for (var i = 0, len = fTypeDivs.length; i < len; i++) {
            fTypeDivs[i].addEventListener('click', self.handleFTypeChange);
        }
        feedbackDlg.submit.addEventListener('click', self.sendFeedback);
        feedbackDlg.close.addEventListener('click', self.closeFeedback);
        setTimeout(function () {
            var feedbackDlg = document.querySelector('.ZRNLPFeedbackDlg');
            AutoSuggest.GeneralUtils.addClass(feedbackDlg, 'show');
            setTimeout(function () {
                var feedbackDlg = document.querySelector('.ZRNLPFeedbackDlg');
                feedbackDlg.sub.focus();
            }, 200);
            document.body.addEventListener('keyup', self.feedbackKeyboardEscHandler);
        }, 200);
    };

    this.toggleSettNHandleFeedback = function (el, event) {
        self.toggleSettings(event);
        self.handleFeedback();
    };

    this.feedbackKeyboardEscHandler = function (event) {
        if (event.keyCode === 27) {
            self.closeFeedback();
        }
    };

    this.sendFeedback = function () {
        var nlpText = JSON.stringify(self.autosuggester.metaHandler.getSuggestionRequestJSON());
        var feedbackDlg = document.querySelector('.ZRNLPFeedbackDlg');
        var selRadio = feedbackDlg.querySelector('.fTypesDiv .nlpIcons.selected');
        var fType = selRadio.parentNode.children[1].innerText;
        var feedbackSub = feedbackDlg.sub.value;
        var feedbackCont = feedbackDlg.tArea.value;
        feedbackDlg.loader.style.display = '';
        feedbackDlg.freezeLayer.style.display = '';
        AutoSuggest.Ajax.sendRequest({
            URL: self.apiToUse + 'addfeedback',
            DEFAULTPARAMS:
                    'DBID=' + self.selectBox.value +
                    '&NLPTEXT=' + encodeURIComponent(nlpText) +
                    '&FEEDBACK=' + encodeURIComponent(feedbackCont) +
                    '&FEEDBACKTYPE=' + encodeURIComponent(fType) +
                    '&FEEDBACKSUBJ=' + encodeURIComponent(feedbackSub),
            METHOD: 'POST',
            ONSUCCESSFUNC: self.feedbackSuccess,
            ONFAILUREFUNC: self.feedbackSuccess
        });
    };

    this.feedbackSuccess = function(response){
        var feedbackDlg = document.querySelector('.ZRNLPFeedbackDlg');
        feedbackDlg.loader.style.display = 'none';
        feedbackDlg.succDiv.style.display = 'block';
        setTimeout(self.closeFeedback, 1000);
    };

    this.handleFTypeChange = function (event) {
        var target = AutoSuggest.GeneralUtils.getParentWithAttributeValue(event.target, 'class', 'fTypesDiv');
        var feedbackDlg = document.querySelector('.ZRNLPFeedbackDlg');
        var selRadio = feedbackDlg.querySelector('.fTypesDiv .nlpIcons.selected');
        AutoSuggest.GeneralUtils.removeClass(selRadio, 'selected');
        AutoSuggest.GeneralUtils.addClass(target.querySelector('.nlpIcons'), 'selected');
    };

    this.createFeedBackDialog = function () {
        var domCreator = AutoSuggest.DomCreator;
        var feedbackMainDiv = domCreator.getDivWithGivenOptions({class: 'ZRNLPFeedbackDlg'});
        var feedbackTitle = domCreator.getDivWithGivenOptions({class: 'ZRNLPFeedbackTitle'});
        var feedbackTitleContent = domCreator.getSpanWithGivenOptions({class: 'c'});
        feedbackTitleContent.textContent = 'Share your Feedback';
        feedbackTitle.appendChild(feedbackTitleContent);
        var feedbackTitleClose = domCreator.getSpanWithGivenOptions({class: 'ZRNLPFeedbackClose'});
        feedbackTitleClose.textContent = 'X';
        feedbackTitle.appendChild(feedbackTitleClose);
        var radioSpan = domCreator.getSpanWithGivenOptions({class: 'nlpIcons radio', style: {margin: '1px 7px 0px 3px'}});
        var fTypeDiv = domCreator.getDiv();
        fTypeDiv.className = 'fType';
        fTypeDiv.textContent = 'Feedback Type:';
        feedbackMainDiv.appendChild(feedbackTitle);
        feedbackMainDiv.appendChild(fTypeDiv);
        var fTypeOptions = ['General', 'Auto suggest', 'Ranking', 'Graph'];
        for (var i = 0, len = fTypeOptions.length; i < len; i++) {
            var curType = fTypeOptions[i];
            var div = domCreator.getDivWithGivenOptions({class: 'fTypesDiv'});
            var textSpan = domCreator.getSpanWithGivenOptions({});
            textSpan.textContent = curType;
            if (curType === 'General') {
                var temp = radioSpan.cloneNode();
                temp.className = 'nlpIcons radio selected';
                div.appendChild(temp);
            }
            else {
                div.appendChild(radioSpan.cloneNode());
            }
            div.appendChild(textSpan);
            feedbackMainDiv.appendChild(div);
        }
        var subInput = domCreator.getInputWithGivenOptions({class: 'sub', placeholder: 'Subject'});
        feedbackMainDiv.appendChild(subInput);
        var bodyTArea = domCreator.getTextAreaWithGivenOptions({class: 'tArea', placeholder: 'Enter your message here'});
        feedbackMainDiv.appendChild(bodyTArea);
        var submitBtn = domCreator.getInputWithGivenOptions({type: 'button', class: 'subm', value: 'Submit'});
        feedbackMainDiv.appendChild(submitBtn);
        var freezeLayer = domCreator.getDivWithGivenOptions({class: 'freezeLayer', style: {position: 'absolute', display: 'none', opacity: '0.8'}});
        feedbackMainDiv.appendChild(freezeLayer);
        var succDiv = domCreator.getDivWithGivenOptions({class: 'fSucc'});
        succDiv.textContent = 'Thank you for the feedback';
        feedbackMainDiv.appendChild(succDiv);
        var loader = domCreator.getDivWithGivenOptions({class: 'ZDBLoader', style: {display: 'none'}});
        feedbackMainDiv.appendChild(loader);
        feedbackMainDiv.close = feedbackTitleClose;
        feedbackMainDiv.sub = subInput;
        feedbackMainDiv.tArea = bodyTArea;
        feedbackMainDiv.submit = submitBtn;
        feedbackMainDiv.freezeLayer = freezeLayer;
        feedbackMainDiv.succDiv = succDiv;
        feedbackMainDiv.loader = loader;
        return feedbackMainDiv;
    };

    this.closeFeedback = function () {
        var feedbackDlg = document.querySelector('.ZRNLPFeedbackDlg');
        AutoSuggest.GeneralUtils.removeClass(feedbackDlg, 'show');
        setTimeout(function () {
            var feedbackDlg = document.querySelector('.ZRNLPFeedbackDlg');
            feedbackDlg.parentNode.removeChild(feedbackDlg);
        }, 500);
        document.body.removeEventListener('keyup', self.feedbackKeyboardEscHandler);
    };

    this.handleGraphFeedback = function (element) {
        var action = element.getAttribute('action');
        if (action === 'yes') {
            AutoSuggest.GeneralUtils.addClass(document.querySelector('.ZRNLPFeedback'), 'hide');
        }
        else {
            self.handleFeedback();
        }
    };

    this.handleRefreshDataModel = function () {
        self.toggleSettings(event);
        var params = 'DBID=' + self.selectBox.value;   //No I18N
        AutoSuggest.Ajax.sendRequest({
            URL: self.apiToUse + 'datamodelrefresh',
            DEFAULTPARAMS: params,
            METHOD: "GET",
            ONSUCCESSFUNC: self.responseForRefresh
        });
    };

    this.responseForRefresh = function () {
        alert('Datamodel Refreshed');
    };

    this.showDataModel = function () {
        if (self.alreadyShownDataModel) {
            self.hideDataModel(null, true);
            return;
        }
        var dataBody = document.querySelector('.dataModel');
        AutoSuggest.GeneralUtils.addClass(document.getElementById('ZRNLPReportResult'), 'hide');
        AutoSuggest.GeneralUtils.addClass(dataBody, 'bg');
        self.constructDataModel();
        document.addEventListener("keydown", ZRNLP.hideDataModel);
        self.alreadyShownDataModel = true;
        self.autosuggester.renderer.suggestionBox.hide();
    };

    this.toggleNShowDataModel = function (el, event) {
        self.toggleSettings(event);
        self.showDataModel();
    };

    this.hideDataModel = function (event, override) {
        if (override || event.keyCode === 27) {
            self.alreadyShownDataModel = false;
            var nlpBody = document.querySelector('.nlpBody');
            var dataBody = document.querySelector('.dataModel');
            // ZDBUtil.removeClass(nlpBody, 'scaleDown');
            // ZDBUtil.addClass(dataBody, 'hide');
            var text = document.getElementById('ZRNLPSearchHolder');
            if (self.graphGenerated)
                AutoSuggest.GeneralUtils.removeClass(document.getElementById('ZRNLPReportResult'), 'hide');
                AutoSuggest.GeneralUtils.removeClass(dataBody, 'bg');
            self.clearDataModel();
            document.removeEventListener("keydown", self.hideDataModel);
        }
    };

    this.constructDataModel = function () {
        if (!self.autosuggester.metaHandler.initialMeta)
            return;
        var initialData = AutoSuggest.GeneralUtils.duplicateObject(self.autosuggester.metaHandler.initialMeta.md);
        var tableToColumnMap = {};
        var columnKeys = Object.keys(initialData);
        columnKeys.map(function (column) {
            var curColInfo = initialData[column];
            var curColTable = curColInfo.tn;
            tableToColumnMap[curColTable] = tableToColumnMap[curColTable] ? tableToColumnMap[curColTable] : [];
            var tableColumns = tableToColumnMap[curColTable];
            tableColumns.push(curColInfo.cn);
        });
        self.constructDataModelUI(tableToColumnMap);
    };

    this.constructDataModelUI = function (tableToColumnMap) {
        var tables = Object.keys(tableToColumnMap);
        var domCreator = AutoSuggest.DomCreator;
        var holder = document.querySelector('.dataModel .relative100');
        var separator = domCreator.getDivWithGivenOptions({'class': 'toolbarSeparator'});
        tables.map(function (table) {
            var tableColumns = tableToColumnMap[table];
            var div = domCreator.getDivWithGivenOptions({'class': 'table1'});
            var span = domCreator.getSpan();
            span.textContent = table;
            div.appendChild(span);
            holder.appendChild(div);
            holder.appendChild(domCreator.getDiv());
            var columnsDiv = domCreator.getDivWithGivenOptions({'style': {'marginLeft': '30px'}});
            tableColumns.forEach(function (column) {
                var div = domCreator.getDivWithGivenOptions({'class': 'column'});
                div.textContent = column;
                columnsDiv.appendChild(div);
            });
            holder.appendChild(columnsDiv);
            holder.appendChild(separator.cloneNode(false));
        });
        setTimeout(function () {
            var holder = document.querySelector('.dataModel .relative100');
            AutoSuggest.GeneralUtils.addClass(holder, 'animateTranslate');
        }, 10);
    };

    this.clearDataModel = function () {
        var holder = document.querySelector('.dataModel .relative100');
        AutoSuggest.GeneralUtils.removeClass(holder, 'animateTranslate');
        holder.innerHTML = '';
    };

    this.hideDBListNSettings = function () {
        AutoSuggest.GeneralUtils.addClass(self.dbList, 'hide');
        if (self.tableList) {
            AutoSuggest.GeneralUtils.addClass(self.tableList, 'hide');
        }
        AutoSuggest.GeneralUtils.addClass(document.getElementById("ZNLPExternalLinks"), 'hide');
    };

    this.toggleDBList = function (event) {
        if (self.tableList) {
            AutoSuggest.GeneralUtils.addClass(self.tableList, 'hide');
        }
        AutoSuggest.GeneralUtils.addClass(document.getElementById("ZNLPExternalLinks"), 'hide');
        AutoSuggest.GeneralUtils.toggleClass(self.dbList, 'hide');
        event.stopPropagation();
    };

    this.toggleTableList = function (event) {
        AutoSuggest.GeneralUtils.addClass(self.dbList, 'hide');
        AutoSuggest.GeneralUtils.addClass(document.getElementById("ZNLPExternalLinks"), 'hide');
        AutoSuggest.GeneralUtils.toggleClass(self.tableList, 'hide');
        event.stopPropagation();
    };

    this.toggleSettings = function (event) {
        AutoSuggest.GeneralUtils.addClass(self.dbList, 'hide');
        if (self.tableList) {
            AutoSuggest.GeneralUtils.addClass(self.tableList, 'hide');
        }
        AutoSuggest.GeneralUtils.toggleClass(document.getElementById("ZNLPExternalLinks"), 'hide');
        if (event)
            event.stopPropagation();
    };

    this.openLink = function (el, event) {
        var link = el.getAttribute('data-href');
        link = window.location.href.indexOf('zia') > 0 ? link.replace('/nlp/', '/zia/') : link;
        self.toggleSettings(event);
        window.open(link, '_blank');
    };
    this.updateTimeLog = function (json) {
        if (json.hasOwnProperty('nlptrace')) {
            var nlpTrace = json.nlptrace;
            var nlpTraceDiv = document.getElementById('nlptrace');
            nlpTraceDiv.innerHTML = nlpTrace;
        }
        if (json.hasOwnProperty('timelog')) {
//            var content = "<table style='border: 0px;'>";
//            for (i = 0; i < timeLogLen; i++) {
//                var allprop = json.timelog[i];
//                content += '<tr><td>' + allprop.operation + '</td><td>' + allprop.time + '</td></tr>';
//            }
//            content += "</table>";
            document.getElementById('timelog').innerHTML = json.timelog;
        }
    };

    //**********Test case related methods starts**********
    this.sendGenerateTestCaseRequest = function (event, ele)
    {
        self.currTestCaseEle = ele;
        var allCheckBoxes = document.getElementById('ZRNLPReportLinks');
        allCheckBoxes = allCheckBoxes.querySelectorAll('input');
        var selectedGraphIdx = [];
        for(var i=0,len=allCheckBoxes.length; i<len; i++){
            if(allCheckBoxes[i].checked){
                selectedGraphIdx.push(allCheckBoxes[i].value);
            }
        }
        var params = 'dbName=' + self.selectBox.innerText +
                     '&DBID=' + self.selectBox.value +
                     '&NLPTEXT=' + self.NLPTEXT +
                     '&testCaseOwner=' + encodeURIComponent(currLoginUser) +
                     '&nerOutput=' + self.nerOutput +
                     '&chunkerOutput=' + self.chunkerOutput +
                     '&queryOutputs=' + self.queryOutputs +
                     '&output=' + self.output +
                     '&validOutputs=' + selectedGraphIdx.toString();
        AutoSuggest.Ajax.sendRequest({
            URL: self.apiToUse + 'nlpaddtestcase',
            DEFAULTPARAMS: params,
            METHOD: 'POST',
            ONSUCCESSFUNC: self.handleTestCaseGenerationSuccess
        });
    };

    this.handleTestCaseGenerationSuccess = function (response) {
        if (response === 'true') {
            AutoSuggest.GeneralUtils.addClass(self.currTestCaseEle, 'ZRGENERATETestCaseSucc');
        } else {
            AutoSuggest.GeneralUtils.addClass(self.currTestCaseEle, 'ZRGENERATETestCaseFailure');
        }

        setTimeout(function () {
            self.currTestCaseEle.className = '';
            AutoSuggest.GeneralUtils.addClass(self.currTestCaseEle, 'ZRGENERATETestCase');
        }, '2000');
    };


    this.setUpTestingMode = function ()
    {
        if (!self.isNLPReportsInTestingModeSetupDone && isNLPReportsInTestingMode === 'true') {
            self.isNLPReportsInTestingModeSetupDone = true;
            var el = document.getElementById('ZRGENERATETESTCASE');
            el.addEventListener('click', function(event){
                ZRNLP.sendGenerateTestCaseRequest(event, this);
                event.stopPropagation();
            });
        }
    };

    this.storeGenerateTestCaseData = function (genRepJSON)
    {
        self.nerOutput = (genRepJSON.nerOutput !== undefined) ? genRepJSON.nerOutput : '';
        self.chunkerOutput = (genRepJSON.chunkerOutput !== undefined) ? genRepJSON.chunkerOutput : '';
        self.queryOutputs = (genRepJSON.queryOutputs !== undefined) ? JSON.stringify(genRepJSON.queryOutputs) : '[]';
        self.output = (genRepJSON.output !== undefined) ? JSON.stringify(genRepJSON.output) : '[]';
    };

    this.getTestCaseCheckBox = function (idx, className)
    {
        if (isNLPReportsInTestingMode === 'true') {
            var input = AutoSuggest.DomCreator.getInputWithGivenOptions({class: className, type: 'checkbox', name: 'selectedReport', value: idx, 'rediskey': self.redisKey + '_' + idx});
            input.oncick = function (event) {
                ZDBUtil.stopEventBubble(event);
                return;
            };
            return input;
        }
        return '';
    };
    //**********Test case related methods end**********
};
//ignorei18n_end
