#!/usr/bin/env bash
main()
{
  SET_VARIABLES $2 $3 $4
  SELECTED_MODULES $1
  CREATE_JS_LIST
  CATJS_FILES
}

SET_VARIABLES()
{
        CUR_DIR=`pwd`
        CHARTPROD_HOME=$2
        CHARTSRC_DIR=${CHARTPROD_HOME}/src/zcjs
        CHARTCOMP_JS=${CHARTPROD_HOME}/zohocharts.js
        CHARTCOMP_ERR_JS=${CHARTPROD_HOME}/zohochartserr.js
        COMP_CSS=${CHARTPROD_HOME}/zp_comp.css
        JSLIST_DIR=$1
        OUTPUT_JSDIR=$3
        OUTPUT_JS=zc.js
        OUTPUT_MIN_JS=zc.min.js
        OUTPUT_GZ_JS=zc.gz
}

SELECTED_MODULES()
{

  selModules=$1
  echo "Selected Modules"
  echo $selModules
  canvasCoreModules="canvascore"
  canvasOptionalModules="canvasbar:canvasscatter:canvasarea:canvasline"

  coreModules="core:utils:axis:plot:legend:events:formatter:tooltip"
  optionalModules="bar:line:area:scatter:pie:funnel:web:pyramid:sunburst:dial:packedbubble:bubblepie:heatmap:threshold:annotation:zoom:scroll:label:loader:zotheme:flatuitheme:transparenttheme:eleganttheme:penciltheme:colorpenciltheme:zohoreportstheme:zohoreportsoldtheme:canvasbar:canvasscatter:canvasarea:canvasline"
  
  allModules=$coreModules:$canvasCoreModules:$optionalModules:$canvasOptionalModules
  echo $allModules

  if [ "${selModules}" = "ALL" ]
  then
    output="$allModules:end"
    echo $output
  else
    
    temp="$coreModules"

    # canvas module

    if echo "$selModules" | grep -q "canvas"; then
      temp="$temp:$canvasCoreModules"
    fi

   
    if [[ "$selModules" = "canvasAll" ]]; then
        temp="$temp:$canvasOptionalModules"
    fi

    if [[ "$selModules" = "svgAll" ]]; then
        temp="$temp:$optionalModules"
    fi
    # canvas module


    for moduleName in `echo $optionalModules | tr  ":" "\n"`
    do
            echo ${selModules} | grep -w "${moduleName}"
            if [ $? -eq 0 ]
            then
              
                    temp="$temp:$moduleName"
                      echo $temp
            fi
    done
    temp="$temp:end"
    echo $temp
    #output=`echo $temp | tr ":" "\n" | awk '! array[$0]++'`
    output=`echo $temp`
    echo $output
  fi

}


CREATE_JS_LIST()
{
       list="$output"
       rm -rf ${CUR_DIR}/zcjslist.txt
       > ${CUR_DIR}/zcjslist.txt
        for moduleName in `echo $list | tr ":" "\n"`
        do
          echo ${moduleName}
            for fileName in `cat ${JSLIST_DIR}/${moduleName}.txt`
              do
                    echo "${fileName}" >> ${CUR_DIR}/zcjslist.txt
             done
        done
        
        # remove duplicate files
        awk '!seen[$0]++' ${CUR_DIR}/zcjslist.txt > ${CUR_DIR}/zcjsuniquelist.txt
        rm -rf ${CUR_DIR}/zcjslist.txt
}

CATJS_FILES()
  {
          
      cd ${CUR_DIR}
      
          INPUT_LIST=${CUR_DIR}/zcjsuniquelist.txt
          
          cd ${CHARTSRC_DIR}
          rm -rf  ${OUTPUT_JSDIR}/${OUTPUT_JS}
          rm -rf  ${OUTPUT_JSDIR}/${OUTPUT_MIN_JS}
          rm -rf  ${OUTPUT_JSDIR}/${OUTPUT_GZ_JS}

          touch ${CUR_DIR}/combine.js
          cat `cat $INPUT_LIST | grep -v "#"` >> ${CUR_DIR}/combine.js
          #${JAVA_HOME}/bin/java -jar $JAR -opt -1 -c  ${CUR_DIR}/combine.js > ${COMP_JS}
          cat `cat $INPUT_LIST | grep -v "#"` >> ${OUTPUT_JSDIR}/${OUTPUT_JS}
          uglifyjs -nc --mangle -o ${CHARTCOMP_JS} ${CUR_DIR}/combine.js
          if [ $? != 0 ]
          then
              echo "Error occurred in js compression ...."
              exit
          fi
          cat ${CHARTCOMP_JS} >> ${OUTPUT_JSDIR}/${OUTPUT_MIN_JS}
          gzip -c ${OUTPUT_JSDIR}/${OUTPUT_MIN_JS} > ${OUTPUT_JSDIR}/${OUTPUT_GZ_JS}
          rm -rf ${CHARTCOMP_JS}
          rm -rf ${CUR_DIR}/combine.js
          rm -rf $INPUT_LIST
      
  }

main $*
