//$Id$
canvas_plot_renderer.area = function() {
    var commonRendererProp, shiftInfo, shiftDiff, line = canvas_plot_renderer.line(),
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    
    function chart(context, seriesdata, pattern) {
        var rp = commonRendererProp.params,
            chartObj = rp.chartObj,
            xscale = rp.xscale,
            yscale = rp.yscale,
            stacked = rp.stacked,
            index = rp.datasetIndex,
            axisrotated = rp.axisrotated,
            commonPlotOptions = rp.commonPlotOptions,
            color = rp.color,
            labelQueue = rp.labelQueue,
            hasNegValue = rp.hasNegValue,
            yaxiscolumnorder = rp.yaxiscolumnorder,
            dataset = rp.dataset,
            systemconf = chartObj.systemConf;
        
        var plotoptions = seriesdata.plotoptions;
        var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions);
        var interpolation = gvp("mode"),
            fillOpacity = gvp("fillOpacity"),
            strokeWidth = gvp("strokeWidth"),
            strokeColor = gvp("strokeColor"),
            markerEnabled = defined(plotoptions) ? $ZC.utils.getValueOfPlotOptions(plotoptions.marker, commonPlotOptions.marker)("enabled") : commonPlotOptions.marker.enabled,
            borderEnabled = ((defined(strokeWidth) && strokeWidth != "" && pInt(strokeWidth) != 0) || (defined(strokeColor) && strokeColor != "") || (markerEnabled)),
            
            datatypeX = chartObj.dataset.getDataType("x"),
            datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

            isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
            isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),

            xCategories = (datatypeX == ORDINAL_DATATYPE) ? xscale.domain() : null,
            yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

            categories = (datatypeX == ORDINAL_DATATYPE && !defined(chartObj.dataObject.hierarchical)) ? xCategories : chartObj.dataObject.getCategories("x"),

            charttype = chartObj.chartTypes[index].name,
            isRangeChart = (charttype) == "arearange",
            yrangePos = (isRangeChart) ? 1 : null,
            
            gradientDim = [chartObj.plotarea.width, chartObj.plotarea.height],
            // gradientOptions = systemconf.chart.plot.plotoptions[charttype].gradients,
            // gradient = effects.get(canvas_gradients, gradientOptions.type, gradientOptions, "area" ,null, null, chartObj);
            // gradient = gradients.get(systemconf.chart.plot.plotoptions[charttype].gradients, color, gradientDim, "area", chartObj, fillOpacity),
            fillStyle = chart.fillColorFunc = getFillColor(chartObj, index, gradientDim),
            strokeColor = getStrokeColor(chartObj, index);
            // fillStyle = (color && /canvasGradient/ig.test(color.toString())) ? color : gradient || canvasUtils.rgba(color, fillOpacity);
        
        if (defined(pattern)) {
            fillStyle = pattern;
        }

        var legend_data = systemconf.legend;
        var imagePallete = legend_data.imagePallete,
            patternPallete = legend_data.patternPallete;
        

        if (!seriesdata.disabled) {
            
            chart.seriesdataAfterUpdate = [];
            seriesdata.data.forEach(function(d, i) {
                
                var serData;
                if (datatypeX == ORDINAL_DATATYPE || datatypeY == ORDINAL_DATATYPE) {
                    serData = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(d), xCategories, yCategories, yaxiscolumnorder);
                } else {
                    serData = d;
                }

                chart.seriesdataAfterUpdate[i] = serData;
                shiftDiff = (shiftInfo != null) ? (((shiftDiff == null) || (shiftDiff == 0)) ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 1], "x") -
                        chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 2], "x") : shiftDiff) : 0;
                var area = canvas_drawer.area();
                area.defined(function(d) {
                        if (stacked) {
                            return !isCatNullX(dataset.getX(d));
                        }
                        return !isCatNullY(dataset.getY(d, yaxiscolumnorder)) && !isCatNullX(dataset.getX(d));
                    })
                    .x(function(d) {
                        var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos);
                        if (isNaN(x) && defined(shiftInfo)) {
                            x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 1], "x", null, yrangePos) + shiftDiff;
                        }
                        return x;
                    })
                    .y(function(d) {
                        return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos);
                    })
                    .interpolation(interpolation);
                
                if (axisrotated) {
                    area.x1(function(d) {
                        if (stacked) {
                            return (index == 0) ? mathMax(yscale.range()[0], yscale(hasNegValue)) : yscale(d.y0);
                        } else {
                            if (isRangeChart) {
                                
                                return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, 0);
                            } else {
                                return (defined(yscale.rangeBand)) ? (yscale.range()[0] + yscale.rangeBand()) : mathMax(yscale.range()[0], yscale(hasNegValue));
                            }
                        }
                    })
                } else {
                    area.y1(function(d, i) {
                        if (stacked) {
                            return (index == 0 && i == 0) ? mathMin(yscale.range()[0], yscale(hasNegValue)) : yscale(d.y0);
                        } else {
                            if (isRangeChart) {
                                return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, 0);
                            } else {
                                return (defined(yscale.rangeBand)) ? (yscale.range()[0] + yscale.rangeBand()) : mathMin(yscale.range()[0], yscale(hasNegValue));
                            }
                        }
                    });
                }

                var drawAreaFunction = function (context, fillStyle) {
                    context.beginPath();
                    context.fillStyle = fillStyle;
                    area.context(context)(d);
                    context.fill();
                    context.restore();
                };
                // var args = {"offset":"area", "dimension":gradientDim},
                //     prop =  getGradientProp(commonPlotOptions.gradients,gradientDim,(strokeColor || chartObj.seriesColor[index % chartObj.seriesColor.length]),strokeOpacity),
                //     gradientID = (!isAreaChart ? effects.get(canvas_gradients, "canvasGradientFill", prop, args) || color : null);
                // context.strokeStyle = gradientID ? gradientID  : canvasUtils.rgba(strokeColor || color, strokeOpacity);

                if(chartObj.imagePallete){
                    canvas_patterns.imageFill({context:context,name:chartObj.imagePallete[index]},drawAreaFunction);
                }else{
                    var fillStyle = defined(pattern) ? pattern : chart.fillColorFunc(index, null, null, color, fillOpacity,gradientDim,null, false);
                    drawAreaFunction(context, fillStyle);
                }

            });
            
            if ((borderEnabled || markerEnabled) && !seriesdata.disabled) {
                line.chartRendered = false;
                line.commonRendererProp(commonRendererProp)
                    .shiftInfo(shiftInfo);
                line(context, seriesdata);
            }
        }
        
        if (defined($ZC.labelRenderer) && (!(borderEnabled || markerEnabled))) {
            if (isRangeChart) {
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "scatter",
                    "chartObj": chartObj,
                    "args": [seriesdata, index, 0, 1]
                });
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "scatter",
                    "chartObj": chartObj,
                    "args": [seriesdata, index, 0, 0]
                });
            } else {
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "scatter",
                    "chartObj": chartObj,
                    "args": [seriesdata, index, 0, null]
                });
            }
        }
        chart.chartRendered = true;
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    return chart;
};