//$Id$
$ZC.axis.render = function(chartObj, chartWidth, chartHeight, update) {
    
    var systemconf = chartObj.systemConf,
        dataObject = chartObj.dataObject;
    var plotBorderDrawn = {
            left: false,
            right: false,
            top: false,
            bottom: false
        },
        wrap = chartObj.svg.selectAll('g.xychart'),
        axes_animation_duration = get_animation_duration(),
        metaData = chartObj.systemConf.metadata,
        yMajorTicksIndex = 0,
        xMajorTicksIndex = 0,
        // data processor helpers

        dataProcessorHelpers = $ZC.DataProcessor.helpers,
        getParsedYAxisOrder = dataProcessorHelpers.getParsedYAxisOrder;

    chartObj.axes.animationDuration = axes_animation_duration;
    // construct zscale
    chartObj.zscale = defined(chartObj.dataset.zidx) ? $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, chartObj.axes.x.orient, null, chartObj.dataset, "z") : null;
    /*
     construct ticks
     */
    //copy of plotarea
    var plotarea_approx = {
        "left": chartObj.plotarea.left,
        "top": chartObj.plotarea.top,
        "width": chartObj.plotarea.width,
        "height": chartObj.plotarea.height
    };

    $ZC.axis.constructTickObj(chartObj, chartWidth, chartHeight, "left", plotarea_approx, update);
    $ZC.axis.constructTickObj(chartObj, chartWidth, chartHeight, "bottom", plotarea_approx, update);
    chartObj.zscale = defined(chartObj.dataset.zidx) ? $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, chartObj.axes.x.orient, null, chartObj.dataset, "z") : null;

    //Changing plot area for bullet chart
    if (chartObj.chartTypes[0].value === $ZC.charttype.bullet) {
        var commonPlotOptions = systemconf.chart.plot.plotoptions.bullet,
            len = dataObject.getCategories("x").length,
            padding = pick(commonPlotOptions.padding, 0.2),
            outerPadding = commonPlotOptions.outerPadding;
        outerPadding = ((outerPadding != null) && (outerPadding !== "")) ? outerPadding : 0.2;
        outerPadding = $ZC.scale.getOuterPadding((rotated ? [0, plotarea_approx.width] : [plotarea_approx.height, 0]), len, padding, outerPadding); //consider plot borderSize in range
        var levelMarkerOptions = commonPlotOptions.levelMarker,
            targetMarkerOptions = commonPlotOptions.targetMarker || {},
            plotarea = chartObj.plotarea,
            rotated = chartObj.axes.rotated;
        
        var defaultBandWidth = ((rotated ? plotarea_approx.height : plotarea_approx.width) / (len - padding + (2 * outerPadding))) * (1 - padding);
        var levelMarkerBandWidth = validateNullVal(levelMarkerOptions.bandWidth, defaultBandWidth),
            levelMarkerMaxBandWidth = validateNullVal(levelMarkerOptions.maxBandWidth, defaultBandWidth);
        var LBW = mathMin(levelMarkerBandWidth, levelMarkerMaxBandWidth, defaultBandWidth);
        
        var barBandWidth = validateNullVal(commonPlotOptions.bandWidth, LBW),
            barMaxBandWidth = validateNullVal(commonPlotOptions.maxBandWidth, barBandWidth);
        var BBW = mathMin(barBandWidth, barMaxBandWidth, defaultBandWidth);
        
        var targetMarkerWidth = defined(targetMarkerOptions.size) ? mathMin((targetMarkerOptions.size * 10), defaultBandWidth) : 0;
        var bandWidth = mathMax(BBW, LBW, targetMarkerWidth);
        
        var step = bandWidth / (1 - padding);
        bandWidth = step * (len - padding + (2 * outerPadding));
        
        if (rotated) {
            plotarea.height = bandWidth + (plotarea.height - plotarea_approx.height);
            plotarea.top += (plotarea.adjust = (plotarea_approx.height - bandWidth) / 2);
        } else {
            plotarea.width = bandWidth + (plotarea.width - plotarea_approx.width);
            plotarea.left += (plotarea.adjust = (plotarea_approx.width - bandWidth) / 2);
        }
    }
    
    var scale1 = $ZC.scale.constructor(chartObj, "left")
    for (var i = 0; i < scale1.length; i++) {
        var axis = createAxis("left", i);
        
        axis = setAxisProp(scale1[i].scale, "left", i, update);
        if (axis != null) {
            drawAxes(axis, i, "left", update);
        }
    }
    var scale2 = $ZC.scale.constructor(chartObj, "bottom")
    for (var i = 0; i < scale2.length; i++) {
        var axis = createAxis("bottom", i);
        
        axis = setAxisProp(scale2[i].scale, "bottom", i, update);
        if (axis != null) {
            drawAxes(axis, i, "bottom", update);
        }
    }
    
    if (chartObj.dataset.getDataType("x") == ORDINAL_DATATYPE) {
        $ZC.scale.barBandwidth(chartObj);
    }
    
    function get_animation_duration() {
        var axes_animation = systemconf.chart.axes.animation || {},
            enabled = axes_animation.enabled;
        
        if(!defined(enabled)) {
            var serdata = (chartObj.isAxisCategory || chartObj.isNonAxisMultiSeriesCategory) ? chartObj.seriesdata : chartObj.seriesdata.slice(0, 1);
            enabled = serdata.some(function(d, i) {
                var type = chartObj.chartTypes[i].name;
                return getAnimationConf(systemconf.chart.plot.plotoptions[type], d.plotoptions, chartObj, type).enabled;
            });
        }

        return enabled ? pick(axes_animation.duration, 600) : 0;
    }
    //To bring axis line front
    function updateAxisLine(orient, axisdata, wrap, axisComp, isaxis) {
        // To bring axis line front, make plotarea border color as axis line color
        var plotBorderData = systemconf.chart.plot.border;
        
        var plotareaBorderEle = chartObj.container.selectAll("g.plotareaBorder-property");
        var bkpInf = null;

        if ((defined(plotBorderData) && plotBorderData.show === true) ) {
            var borderEle = plotareaBorderEle.selectAll("path.plotBorderPath");
            var borderSize =validateValWithinLimit(plotBorderData, "size", 0, 10, chartObj.plotarea.width, chartObj.plotarea.height);
            borderSize = (borderSize == null || borderSize === "") ? 2 : borderSize;
            var radius = chartObj.dataObject.getTransRectValue("radius",null,null,null,null,plotBorderData.radius);
            var rectAttr = roundedRect(0,0,chartObj.plotarea.width,chartObj.plotarea.height,radius,false,false);
            

            borderEle.style({
                "stroke-width" : borderSize,
                "stroke" : plotBorderData.color,
                "stroke-dasharray": getDashArray(plotBorderData.style, borderSize),
                "fill":"none",
                "pointer-events":"none"
            }).attr({
                "d":rectAttr
            })
            plotareaBorderEle.selectAll("line").style("stroke","transparent");
        }
        
        else {
            var axislineData = axisdata.axisline;
            var axislineClr = (axislineData.show == false || axislineData.color == null) ? "transparent" : axislineData.color;
            var axislineWidth = validateNullVal(axislineData.strokeWidth, 1);
            var axislineStyle = axislineData.style || "solid";

            var axislineEle = appendEle(plotareaBorderEle, "line", [1], ".", "class", orient);

            if(isaxis  == false || axisdata.show == false || wrap.style("visibility") == "hidden"){
                axislineEle.style("stroke","transparent");
                return;
            }
            var x1,x2,y1,y2;
            if(orient == "bottom"){
                x1 = 0 , x2 = chartObj.plotarea.width, y1 = chartObj.plotarea.height, y2 = chartObj.plotarea.height
            }else if(orient == "left"){
                x1 = 0 , x2 = 0, y1 = 0, y2 = chartObj.plotarea.height
            }else if(orient == "right"){
                x1 = chartObj.plotarea.width , x2 = chartObj.plotarea.width, y1 = 0, y2 = chartObj.plotarea.height
            }else if(orient == "top"){
                x1 = 0 , x2 = chartObj.plotarea.width, y1 = 0, y2 = 0
            }

            axislineEle.style({
                "stroke-width" : axislineWidth,
                "stroke" : axislineClr,
                "shape-rendering":"crispedges",
                "stroke-dasharray": getDashArray(axislineStyle, axislineWidth)
            }).attr({
                "x1":x1,"x2":x2,"y1":y1,"y2":y2
            })

            bkpInf = {
                "size": axislineWidth,
                "clr": axislineClr
            };
            plotareaBorderEle.node()["border-" + orient] = bkpInf;
           
        }
        
        wrap.selectAll("path.domain")
            .style("stroke", "transparent")
        
    }
    
    function getAxisOrient(data, type, index) {
        var orient = data.orient;
        var axesRotated = chartObj.axes.rotated;
        orient = (orient == null) ? ((type == "x") ? ((axesRotated) ? "left" : "bottom") :
                ((axesRotated) ? "bottom" : (index == 0) ? "left" : "right")) :
            orient;
        return orient;
    }
    
    function createAxis(orient, index) {
        var axes = [];
        switch (orient) {
            case 'left':
                axes = (chartObj.axes.rotated) ? createAxisComp("x", index) : createAxisComp("y", index);
                break;
            case 'bottom':
                axes = (chartObj.axes.rotated) ? createAxisComp("y", index) : createAxisComp("x", index);
                break;
        }
        return axes;
    }
    
    function setAxisProp(scale, orient, i, update) {
        var type = (orient == "left") ? ((chartObj.axes.rotated) ? "x" : "y") :
            ((chartObj.axes.rotated) ? "y" : "x");
        var axisComp = getAxisObject(chartObj,type,i).component;

        var axes = setAxisCompConfig(axisComp, type, scale, orient, i, update);
        return axes;
    };
    
    function createAxisComp(type, index) {
        var axes = getAxisObject(chartObj,type,index);
        var axis_data = (type == "x") ? systemconf.chart.axes.xaxis : (systemconf.chart.axes.yaxis[index] || systemconf.chart.axes.yaxis[0]);

        // first axis disabled. on redraw it is enabled
        var axisComp = axes.component;
        if (axisComp) {
            return axisComp;
        }
        axes.component = (type == "x") ? ((axis_data.show && dimension_based_intelligence(chartObj, "xaxis", chartHeight)) ? $ZC.axis.get() : null) :
                                        (axis_data.show) ? $ZC.axis.get() : null;

        return axisComp;
    }
    
    function drawAxes(axis, index, orient, update) {
        var axes = [];
        var type = (orient == "left") ? ((chartObj.axes.rotated) ? "x" : "y") :
            ((chartObj.axes.rotated) ? "y" : "x");
        axes = drawAxisComp(axis, type, index, update);
        return axes;
    };
    
    function setAxisCompConfig(axis, type, scale, orient, index, update) {
        var axisdata = (type == "x") ? systemconf.chart.axes.xaxis : systemconf.chart.axes.yaxis[index];
        var orient = getAxisOrient(axisdata, type, index);
        var tickPadding = (orient == "bottom") ? axisdata.ticklabel.marginTop : (orient == "top") ? axisdata.ticklabel.marginBottom : (orient == "left") ? axisdata.ticklabel.marginRight : axisdata.ticklabel.marginLeft;
        tickPadding = pick(tickPadding, 5);
        
        var dim = (orient == "bottom" || orient == "top") ? chartHeight : chartWidth;
        var isaxis = axisdata.show === true && dimension_based_intelligence(chartObj, (type + "axis"), dim);
        if (type === "y" && !isaxis) {
            yMajorTicksIndex++;
        }
        if (isaxis) {
            var yaxisComp = chartObj.axes.y.groups;
            var tickObj = getAxisObject(chartObj,type,index).ticks;

            var oldAxisLen = tickObj.preCalcAxisLen;
            var preCalcTickLen = tickObj.preCalcApproxAxisLength(plotarea_approx);
            var adjustVal = (tickObj.preCalcAxisLen - oldAxisLen);
            var tickValueObj = tickObj.tickValueObj;

            if (adjustVal) {
                adjustPlotarea(orient, adjustVal);
            }

            
            if (axis != null) {
                var isMergedAxis = (type == "y") ? (metaData.axes.y[index].length > 1) : false;
                var hasTimegroupBy = tickObj && tickObj.isHierarchy() && chartObj.dataObject.hierarchical.groupByTime;
                var columnidx = chartObj.dataset.getColumnIdx(type, (hasTimegroupBy)?0:index); //column index should be 0 for multi level x axis
                var datatype = metaData.columns[columnidx]["datatype"];
                datatype = tickObj && tickObj.isHierarchialLevelType() &&chartObj.dataObject.hierarchical.categoryTree ? ORDINAL_DATATYPE : datatype;
                var formatConf = metaData.columns[columnidx][datatype];
                formatConf = (isMergedAxis && type == "y") ? merged_axis_column_intersect(index, chartObj) : formatConf;
                var axisFormat = formatConf && (formatConf.axisformat || formatConf.format);
                var tickSize = validateNullVal(axisdata.tickmark.size, 6);
                var formattingFunction = (dataObject.isStackedPercentChart && type == "y") ? getFormattedValueByPercent : getFormattedValue;
                var specifierIndex =  (hasTimegroupBy) ? index : null;
                axis
                    .scale(scale)
                    .tickPadding(tickPadding)
                    .tickSize(tickSize, 0)
                    .majorTicks((index === (type === "y" ? yMajorTicksIndex : xMajorTicksIndex)) ? getMajorTicks(orient) : null)
                    .orient(orient)
                    .plotarea(chartObj.plotarea)
                    .systemconf(chartObj.systemConf)
                    .tickRotation(tickValueObj.rotation)
                    .preCalcTickLen(tickObj.preCalcTickLen)
                    .chartObj(chartObj)
                    .columnIndices((isMergedAxis && type == "y") ? metaData.axes.y[index] : [columnidx])
                    .isMultiLineTick((!(tickObj && tickObj.isHierarchy()))&&formatConf && axisFormat && axisFormat.specifier && axisFormat.specifier.constructor == Array);
                
                var format = (formatConf != null) ? (formatConf.axisformat || formatConf.format) : null;
                if (format && format.specifier == "auto") {
                    axis
                        .ticks(orient == "bottom" ? chartObj.plotarea.width / 100 : chartObj.plotarea.height / 40)
                } else {
                    var tickPos = tickObj.getActualTicklabel();
                    axis
                        .tickValues(tickObj.getTicksforAxisComp())
                        .tickFormat(function(d,i) {
                            var tick = tickPos(i);
                            return formattingFunction(formatConf, tick, datatype, chartObj, "axis",null,null, specifierIndex);
                        });
                }
                
                if (!((type === "y") && yaxisComp[index].disabled)) {
                    axis.plotBorderDrawn = !plotBorderDrawn[orient];
                    plotBorderDrawn[orient] = true;
                }
                
                axis.hideAxisLabel = !dimension_based_intelligence(chartObj, (type + "axislabel"), dim); //hide axislabel by intelligence
                
            }
        }
        
        return axis;
    }
    
    function drawAxisComp(axis, type, index, update) {
        var axisdata = (type == "x") ? systemconf.chart.axes.xaxis : systemconf.chart.axes.yaxis[index];
        var orient = axis.orient();
        var dim = (orient == "bottom" || orient == "top") ? chartHeight : chartWidth;
        var isaxis = axisdata.show === true && dimension_based_intelligence(chartObj, (type + "axis"), dim);
        var selector = (type == "x") ? type + '-axis-' + index : type + '-axis-' + index;
        var axisWrap = appendEle(wrap.selectAll("g." + type + "-axis"), "g", (isaxis ? [axisdata] : []), ".", "class", selector);

        axisWrap
            .style("display", ((type === "y") && chartObj.axes.y.groups[index].disabled) ? "none" : null);
        
        if (update) {
            axis.tickLabelWidth(0);
        }
        if (isaxis) {
            axisWrap.transition().duration(axes_animation_duration).call(axis, type, index);
            chartObj.plotarea = axis.plotarea();

            if(type === "x") {
                adjustXAxiswrap(axisdata, index, axis)
            } else {
                adjustYAxeswrap(axisdata, index, axis)
            }
            if (update) {
                setTimeout(function() {
                    if(axis.isMultiLineTick()){
                        axisWrap.selectAll("text.ticklabel").call(wrapTicklabels);
                    }

                    handleOverflowTicks_init(axisWrap, axis, chartObj, axisdata, orient,index);
                }, axes_animation_duration)
            } else {
                handleOverflowTicks_init(axisWrap, axis, chartObj, axisdata, orient,index);
            }
        }else{
            updateAxisLine(orient, axisdata, axisWrap, axis,isaxis)
        }
        
        //Initializing chart brush before drawing x axes
        if (type == "y" && isObjectPropDefined(systemconf.chart, "scroll") && systemconf.chart.scroll.enabled) {
            chartObj.brush.initialize(chartObj.plotarea)
        }
    }
    
    function adjustXAxiswrap(data, index, axis) {
        var usedAxisSpace = {
            left : 0,
            top : 0,
            right : 0,
            bottom : 0
        };
        var axisCount = chartObj.axes.x.count;
        if(index == axisCount -1){
            for(var i=0; i<axisCount; i++){
                var axisObj = getAxisObject(chartObj,"x",i);
                var axisComp = axisObj.component;
                var xwrapboxWid = axisComp.tickLabelWidth();
                var xwrap = wrap.selectAll('.x-axis-' + i);
                var xorient = axis.orient();
                var transX = (xorient == "right") ? (chartObj.plotarea.left + chartObj.plotarea.width) + usedAxisSpace.right : (chartObj.plotarea.left - usedAxisSpace.left);
                var transY = (chartObj.axes.rotated || xorient == "top") ? chartObj.plotarea.top - usedAxisSpace.top: (chartObj.plotarea.top + chartObj.plotarea.height + usedAxisSpace[xorient])
                usedAxisSpace[xorient] += xwrapboxWid;
                xwrap
                    .attr("transform", "translate(" + transX + "," + transY + ")");
            }
            var xwrap = wrap.selectAll('g.x-axis-0');

            // if (chartObj.axes.rotated) {
            //     xwrap
            //         .selectAll("line.majorTicks")
            //         .attr("x2", chartObj.plotarea.width)
            // }
            updateAxisLine(xorient, data, xwrap, axis);
        }

    }
    
    function adjustYAxeswrap(data, index, axis, strictMode) {
        var yaxisData = systemconf.chart.axes.yaxis,
            yaxesLength = chartObj.axes.y.groups.length;
        var yaxis0_wrap = wrap.selectAll('.y-axis-0');
        var yaxis0_orient = yaxisData[0].orient || ((chartObj.axes.rotated) ? "bottom" : (yaxisData[0].orient || "left"));

        if (strictMode || index == yaxesLength - 1) {
            var usedAxisSpace = {
                left : 0,
                top : 0,
                right : 0,
                bottom : 0
            };
            for (var j = 0; j < yaxesLength; j++) {
                
                var ydata = yaxisData[j];
                var orient = ydata.orient;
                orient = orient || ((chartObj.axes.rotated) ? "bottom" : (ydata.orient != null) ? ydata.orient : (j == 0) ? "left" : "right")
                if (ydata.show === true) {
                    var axisComp = chartObj.axes.y.groups[j].component;
                    var ywrap = wrap.selectAll('.y-axis-' + j);
                    var ywrapboxWid = axisComp.tickLabelWidth();
                    
                    var translateX = (orient == "bottom" || orient == "top")
                            ? chartObj.plotarea.left
                            : ((orient === "left")
                                ? (chartObj.plotarea.left - usedAxisSpace[orient])
                                : (chartObj.plotarea.left + chartObj.plotarea.width + usedAxisSpace[orient])),
                        translateY = ((orient == "bottom") ? (chartObj.plotarea.height + chartObj.plotarea.top) : (chartObj.plotarea.top)) ;
                    usedAxisSpace[orient] += (chartObj.axes.y.groups[j].disabled) ? 0 : ywrapboxWid;


                    ywrap
                        .attr("transform", "translate(" + translateX + "," + translateY + ")");
                    
                    // handleOverflowTicks_init(ywrap, axisComp, chartObj, ydata, axisComp.orient());
                    
                    //Bringing Axis line to front
                    if (axisComp.plotBorderDrawn == true) {
                        updateAxisLine(orient, ydata, ywrap, axis);
                    }
                    
                }
            }
            
            (!chartObj.axes.rotated) ? yaxis0_wrap
                    .selectAll("line.majorTicks")
                    .attr("x2", (yaxis0_orient == "right") ? -chartObj.plotarea.width : chartObj.plotarea.width): null;
        }
        
    }
    function getMajorTicks(orient) {
        if (orient == "bottom") {
            return [0, -chartObj.plotarea.height]
        } else if (orient == "top") {
            return [0, chartObj.plotarea.height]
        } else if (orient == "left") {
            return [chartObj.plotarea.width, 0]
        } else if (orient == "right") {
            return [-chartObj.plotarea.width, 0]
        }
        
    }

    function adjustPlotarea(orient, adjustVal) {
        var plotarea = chartObj.plotarea;
        if (orient === "left") {
            plotarea.left += adjustVal;
            plotarea.width -= adjustVal;
        } else if (orient === "right") {
            plotarea.width -= adjustVal;
        } else if (orient === "bottom") {
            plotarea.height -= adjustVal;
            plotarea.bottom += adjustVal;
        } else {
            plotarea.height -= adjustVal;
            plotarea.top += adjustVal;
        }
    }
    
    function addorremoveAxis(axisWrap, axisComp, data, index, type, mode) {
        //Now only type is "Y" as multiY axis is available
        /*
         *For multiY axis charts alone,
         *mode - add, add the axis  mode - remove ,filtering or remove axis
         *Change the plotarea width, left with respect to the axis wrap width
         */
         //Reset plotborderdrawn and g.plotareaBorder-property
         plotBorderDrawn = {
            left: false,
            right: false,
            top: false,
            bottom: false
        }
        chartObj.container.selectAll("g.plotareaBorder-property").selectAll("line").style("stroke","transparent");
        var orient = axisComp.orient();
        var scale = axisComp.scale();
        var majorTicks = axisComp.majorTicks();
        var wrapWid = axisWrap.node().getBBox().width;
        wrapWid += (orient == "left") ? data.label.marginLeft : data.label.marginRight;
        wrapWid = (majorTicks != null) ? axisComp.tickLabelWidth() : axisComp.tickLabelWidth();
        if (!(axisWrap.style("visibility") === "hidden" && mode === "remove")){
            chartObj.plotarea.width = (mode == "add") ? chartObj.plotarea.width - wrapWid : chartObj.plotarea.width + wrapWid;
            chartObj.plotarea.left = (orient == "left") ? (mode == "add") ? chartObj.plotarea.left + wrapWid : chartObj.plotarea.left - wrapWid : chartObj.plotarea.left;
        }

        
        var co = 0;
        var visibility = (mode == "add") ? "visible" : "hidden";
        axisWrap.style("visibility", visibility);
        if ((mode == "add")){
            axisWrap.style("display", null);
        }
        
        for (var i = 0; i < chartObj.axes.y.groups.length; i++) {
            var ywrap = wrap.selectAll("g.y-axis-" + i)
            var curAxisComp = chartObj.axes.y.groups[i].component;
            var curAxisOrient = curAxisComp.orient();
            var curMajorTicks = curAxisComp.majorTicks();
            var curAxisData = systemconf.chart.axes.yaxis[i] || systemconf.chart.axes.yaxis[0];
            
            //Translate the yaxis wraps according to added/removed axiswrap width
            // adjustYAxeswrap(data, index, curAxisComp, true);

            //If the axis to be removed have majorticks, then draw the major ticks for next upcoming axis
            if (ywrap.style("visibility") != "hidden" && co == 0) {
                curMajorTicks = getMajorTicks(curAxisOrient);
                curAxisComp.majorTicks(curMajorTicks);
                ywrap.transition().duration(axes_animation_duration).call(curAxisComp, type, i);
                co++
            } else if (curMajorTicks != null && co > 0) {
                curAxisComp.majorTicks(null);
                ywrap.transition().duration(axes_animation_duration).call(curAxisComp, type, i);
            }
            //set proper curAxisComp.plotBorderDrawn according to their visibility in order
            if(ywrap.style("visibility") == "visible" &&  !plotBorderDrawn[curAxisOrient]){
                plotBorderDrawn[curAxisOrient] = true;
                curAxisComp.plotBorderDrawn = true;
            }else{
                curAxisComp.plotBorderDrawn = false;
                //Set axisline color for the other components where plotBorderDrawn = false
                if (ywrap.style("visibility") == "visible") {
                    ywrap.selectAll("path.domain")
                        .style("stroke", curAxisData.axisline.color);
                }else{
                    ywrap.selectAll("path.domain")
                        .style("stroke", "transparent");
                }
            }
            
            
        }
        adjustYAxeswrap(data, index, axisComp, true);
    }
    chartObj.updateZscale = function() {
        defined(chartObj.dataset.zidx) ? chartObj.zscale.domain(dataObject.getMinMaxZ()): null;
    };
    
    chartObj.updateScale = function(serData, type, zmInterval, axisorder) {
        var extentVal;
        var yaxiscolumnorder = (type == "y") ? getParsedYAxisOrder((serData == null || isArray(serData)) ? serData : serData.yaxiscolumnorder) : 0,
            axisorder = (type == "x" && defined(axisorder)) ? axisorder : yaxiscolumnorder,
            axiswrap = wrap.selectAll("g." + type + "-axis-" + axisorder),
            axes = getAxisObject(chartObj,type,axisorder),
            tickObj = axes.ticks,
            axisdata = (type == "x") ? systemconf.chart.axes.xaxis : systemconf.chart.axes.yaxis[yaxiscolumnorder],
            orient = (axes.component) ? axes.component.orient() : getAxisOrient(axisdata, type, yaxiscolumnorder),
            dim = (orient == "bottom" || orient == "top") ? chartHeight : chartWidth,
            isaxis = axisdata.show === true && dimension_based_intelligence(chartObj, (type + "axis"), dim);
        
        var columnidx = chartObj.dataset.getColumnIdx(type, yaxiscolumnorder),
            datatype = metaData.columns[columnidx].datatype,
            datatype = tickObj && tickObj.isHierarchialLevelType() &&chartObj.dataObject.hierarchical.categoryTree ? ORDINAL_DATATYPE : datatype,
            formatConf = metaData.columns[columnidx][datatype],
            hasTimegroupBy = tickObj && tickObj.isHierarchy() && chartObj.dataObject.hierarchical.groupByTime,
            specifierIndex =  (hasTimegroupBy) ? axisorder : null;
        //Update scale
        if (zmInterval) {
            extentVal = zmInterval;
            var newScale = $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, orient, yaxiscolumnorder, chartObj.dataset, type, extentVal);
            axes.eventscale = axes.scale = newScale;
        } else {
            var chartType = chartObj.chartTypes[0].name;
            var outerPadding = systemconf.chart.plot.plotoptions[chartType].outerPadding;
            extentVal = (datatype == ORDINAL_DATATYPE) ? dataObject.getCategories(type, axisorder) : (type == "x") ? chartObj.dataObject.getMinMaxX(validateNullVal(outerPadding, 0.2)) : chartObj.dataObject.getMinMaxY(yaxiscolumnorder);
            var newScale = $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, orient, axisorder, chartObj.dataset, type);
            axes.eventscale = axes.scale = newScale;
        }

        //Update axis
        if (type == "y" && !axiswrap.empty() && extentVal[0] == "NoData" && extentVal[1] == "NoData") { //Check again; no updation in ordinal y scale
            //No need to update the scale and axis
            if (isaxis) addorremoveAxis(axiswrap, axes.component, axisdata, yaxiscolumnorder, "y", "remove")
            
        } else if (type == "y" && !axiswrap.empty() && axiswrap.style("visibility") == "hidden" && axiswrap.style("display") !== "none") {
            if (isaxis) addorremoveAxis(axiswrap, axes.component, axisdata, yaxiscolumnorder, "y", "add");
        } else {
            
            if (dataObject.isBubbleEnabled && type == "y") {
                axes.eventscale = axes.scale = $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, orient, yaxiscolumnorder, chartObj.dataset, "y");
            }
            
            if (isaxis) {
                axes.component.scale(axes.scale);
                //set axisconfig
                formatConf = ((metaData.axes.y[yaxiscolumnorder].length > 1) && type == "y" && formatConf != null && !formatConf.axisformat) ? null : formatConf;
                var formattingFunction = (dataObject.isStackedPercentChart && type == "y") ? getFormattedValueByPercent : getFormattedValue;
                var formatConf_axis = (formatConf != null) ? (formatConf.axisformat || formatConf.format) : null;
                if (formatConf_axis && formatConf_axis.specifier == "auto") {
                    axes.component
                        .ticks(chartObj.axes.rotated ? chartObj.plotarea.height / 40 : chartObj.plotarea.width / 100)
                } else {
                    var tickObj = axes.ticks;
                    var oldLongTickSize = (orient == "bottom" || orient == "top") ? tickObj.tickValueObj.longTickSize.height : tickObj.tickValueObj.longTickSize.width;
                    var tickValueObj = tickObj.getTickValues(chartObj.plotarea.width, chartObj.plotarea.height, zmInterval, false, null, axes.Ticks, chartObj.plotarea);
                    tickObj.tickValueObj = tickValueObj;
                    var curLongTickSize = (orient == "bottom" || orient == "top") ? tickObj.tickValueObj.longTickSize.height : tickObj.tickValueObj.longTickSize.width;
                    var preCalcTickLen = tickObj.preCalcTickLen;
                    
                    var adjustVal = (oldLongTickSize > curLongTickSize) ? (curLongTickSize - oldLongTickSize) : ((oldLongTickSize < curLongTickSize) ? (curLongTickSize - oldLongTickSize) : 0);
                    (orient == "bottom" || orient == "top") ? preCalcTickLen.height = preCalcTickLen.height + adjustVal: preCalcTickLen.width = preCalcTickLen.width + adjustVal

                    var tickValues = tickObj.getTicksforAxisComp();
                    var tickPos = tickObj.getActualTicklabel();
                    axes.component.tickValues(tickValues)
                                  .tickFormat(function(d,i) {
                                        var tick = tickPos(i);
                                        return formattingFunction(formatConf, tick, datatype, chartObj, "axis",null,null,specifierIndex);
                                    })
                                  .tickRotation(tickValueObj.rotation);
                }
                //call axis
                axiswrap.transition().duration(axes_animation_duration).call(axes.component, type, axisorder).each("end", function() {
                    handleOverflowTicks_init(axiswrap, axes.component, chartObj, axisdata, orient, axisorder);
                });

                var fullUpation = !axiswrap.empty() && axiswrap.style("display") === "none" && (type === "y");
                if (fullUpation) {
                    addorremoveAxis(axiswrap, axes.component, axisdata, yaxiscolumnorder, "y", "add")
                }

                if (adjustVal && adjustVal != 0) { //Bug IdZC795 //hack ; hav to change logic for redraw in zoom

                    if (!fullUpation) {
                        adjustPlotarea(orient, adjustVal);
                    }
                    var type_opp = (type == "x") ? "y" : "x";
                    chartObj.updateScale(serData, type_opp);
                    chartObj.drawPlotareaClippath();
                    chartObj.updatePlotareaProp();

                }
                if (type === "y") {
                    axiswrap
                        .style({
                            "display" : null,
                            "visibility" : "visible"
                        });
                    adjustYAxeswrap(axisdata, yaxiscolumnorder, axes.component, true)
                } else {
                    adjustXAxiswrap(axisdata, axisorder, axes.component)
                }

                var PW = chartObj.plotarea.width;
                (!chartObj.axes.rotated && type == "y") ? wrap.selectAll('.y-axis-'+yaxiscolumnorder)
                        .selectAll("line.majorTicks")
                        .attr("x2", (orient != "right") ? PW : -PW): null;
                if (axes.component.plotBorderDrawn == true) {
                    updateAxisLine(orient, axisdata, axiswrap, axes.component);
                }

            }
        }
    };

    function handleOverflowTicks_init(wrap, axis, chartObj, axisdata, orient, index) {
        var ticklabel_data = axisdata.ticklabel;
        var textOverflow = ticklabel_data.textOverflow;
        if (textOverflow !== "none") {
            var args = [null, orient, chartObj, axis.tickRotation(), textOverflow, axis.scale(), wrap, axis, "ticklabel", ticklabel_data,index];
            setTimeout(function() {
                handleOverflowTicks.apply(null, args);
            },17)
        }
    }
};

