//$Id$
$ZC.axis.get = function() {
    var axis = d3_axis(),
        scale = d3_scaleLinear();
    var scale, ticks;

    var axisLabelMargin = {
            top: 0,
            right: 0,
            bottom: 5,
            left: 0
        },
        width = null,
        height = null,
        majorTicks = null,
        plotarea,
        tickLabelWidth = 0,
        curTickLabelWidth = 0,
        systemconf, axisline, chartObj, preCalcTickLen, orient, columnIndices,isMultiLineTick;

    var labeldata = {
            text: "Axis",
            fontFamily: "sans-serif",
            fontSize: 11,
            fontColor: "#575757"
        },
        ticklabeldata = {
            fontFamily: "sans-serif",
            fontSize: 11,
            fontColor: "#575757",
            rotation: 0
        },
        griddata = {
            color: "#666666",
            style: "strokeStyle1"
        },
        tickmarkdata = {
            color: "#ececec",
            size: 3,
            strokeWidth: null
        },
        axislinedata = {
            color: "#ececec"
        },
        tickRotation = 0,
        topbaseline = "0.71em"

    function chart(selection, type, axisOrder) {
        selection.each(function(data) {


            var container = d3_select(this);

            labeldata = data.label;
            ticklabeldata = data.ticklabel;
            tickmarkdata = data.tickmark;
            axisline = data.axisline;
            griddata = data.grid;

            var axisObj = getAxisObject(chartObj,type,axisOrder),
                tickComp = axisObj.ticks,
                tickObj = tickComp.tickValueObj;

            var hideAxisLabel = chart.hideAxisLabel || labeldata.show === false || !defined(labeldata.text) || labeldata.text === "" || (tickComp.isHierarchy() && axisOrder < chartObj.dataObject.hierarchical.finalDepth);
            if(hideAxisLabel) {
                axisLabelMargin.top = axisLabelMargin.bottom = axisLabelMargin.left = axisLabelMargin.right = 0;
            } else {
                axisLabelMargin.top = pick(labeldata.marginTop, 5);
                axisLabelMargin.bottom = pick(labeldata.marginBottom, 5);
                axisLabelMargin.left = pick(labeldata.marginLeft, 5);
                axisLabelMargin.right = pick(labeldata.marginRight, 5);
            }

            var marginTickLabel_right = pick(ticklabeldata.marginRight, 5),
                marginTickLabel_left = pick(ticklabeldata.marginLeft, 5),
                marginTickLabel_bottom = pick(ticklabeldata.marginBottom, 5),
                marginTickLabel_top = pick(ticklabeldata.marginTop, 5);

            //For hierarchy only rotate 0 available
            // if(tickComp.isHierarchy()){
            //     tickRotation = 0;
            // }
            tickRotation = pick(tickRotation, 0);
            var rotation = (tickRotation < 0) ? (360 - mathAbs(tickRotation)) : tickRotation;
            rotation = (rotation > 360) ? (mathAbs(rotation) - 360) : rotation;

            chart.update = function() {
                container.call(chart);
            };

            orient = axis.orient();

            var g = container.selectAll('g.axisgroup').data([data]);
            g.enter().append('g').attr('class', 'axisgroup');
            g.exit().remove();

            if (ticks) {
                axis.ticks(ticks[0], ticks[1]);
            }

            // add clip-path

            if(chartObj.isAxisCategory && type !== "clr") {
                var defs = appendEle(chartObj.svg, "defs", [1]);

                //  Google Chrome(66.0.3359.139) crash fix #ZC1174
                var propertyObject = simpleClone(chartObj.plotarea);
                propertyObject.id = chartObj.id;
                //

                var id = generateIdByPropValue(propertyObject, type + axisOrder);
                var clipPath = appendEle(defs, "clipPath", [1], "#", "id", id);
                var clipRect = appendEle(clipPath, "rect", [1]);

                var rect = {}, axisRect = tickObj.axisgroup, percentLimit = 0.5, margin = {
                    left: (percentLimit * plotarea.left),
                    right: (percentLimit * (chartObj.canvasarea.width - (plotarea.left + plotarea.width))),
                    top: (percentLimit * plotarea.top),
                    bottom: (percentLimit * plotarea.bottom)
                };

                switch (orient) {
                    case "top": {
                        rect.x = -margin.left;
                        rect.y = -axisRect.height - tickmarkdata.size;

                        rect.height = axisRect.height + chartObj.plotarea.height + tickmarkdata.size;
                        rect.width = axisRect.width + margin.left + margin.right;
                        break;
                    }
                    case "right": {
                        rect.x = -chartObj.plotarea.width;
                        rect.y = -margin.top;
                        rect.width = axisRect.width + chartObj.plotarea.width;
                        rect.height = axisRect.height + margin.top + margin.bottom;
                        break;
                    }
                    case "bottom": {
                        rect.x = -margin.left;
                        rect.y = -chartObj.plotarea.height;
                        rect.height = axisRect.height + chartObj.plotarea.height;
                        rect.width = axisRect.width + margin.left + margin.right;
                        break;
                    }
                    case "left": {
                        rect.x = -axisRect.width;
                        rect.y = -margin.top;
                        rect.width = axisRect.width + chartObj.plotarea.width;
                        rect.height = axisRect.height + margin.top + margin.bottom;
                        break;
                    }
                }

                clipRect.attr(rect);
                g.attr('clip-path', "url(" + chartObj.defsLocation + "#" + id + ")");
            }

            var majorticklength = 0;


            g.call(axis);

            //Event handlers for tick labels
            var events = data.ticklabel.events;
            var mousemoveFn, mouseoutFn, clickFn, dblclickFn, cursor, eventDisabled,
                tapFn,
                tapHoldFn,
                tapHoldEndFn,
                doubleTapFn;

            if (events != null) {
                eventDisabled = (validateNullVal(events.enabled, true) == false);
                mousemoveFn = events.mousemove;
                mouseoutFn = events.mouseout;
                clickFn = events.click;
                dblclickFn = events.doubleclick;
                cursor = events.cursor;

                tapFn = events.tap;
                tapHoldFn = events.taphold;
                tapHoldEndFn = events.tapholdend;
                doubleTapFn = events.doubletap;
            }
            cursor = cursor || "pointer";

            var tickG0 = g.selectAll(".tick");
            var ticks1 = axis.tickValues() == null ? scale.ticks ? scale.ticks.apply(scale, [tickG0[0].length]) : scale.domain() : axis.tickValues();
            var tickG = g.selectAll(".tick").data(ticks1, scale);
            //Round Transform translate Attribute
            //
            //          tick.attr("transform",function(d,i){
            //              var ele = d3_select(this);
            //              var transform = ele.attr("transform");
            //              var replaced = transform.replace("translate(","").replace(")","").split(",")
            //
            //              return "translate("+parseFloat(replaced[0])+","+parseFloat(replaced[1])+")";
            //          })
            var majorticks = appendEle(tickG, "line", (griddata.show ? [1] : []), ".", "class", "majorTicks");
            var majorticksUpdate = tickG.select("line.majorTicks");


            var labelSize, axisLabel;
            if (type === "clr") {
                labelSize = 0;
            } else {
                var axes = type === "y" ? chartObj.axes.y.groups[axisOrder] : chartObj.axes.x;
                axisLabel = axes.axisLabel;
                labelSize = axisLabel.getBBox().height;
            }


            // var myAxisLabel = chartObj.axis

            var minorticks = tickG.selectAll("line").filter(function() {
                return this.getAttribute("class") != "majorTicks"
            });
            minorticks.attr('class', 'minorTicks');
            tickG.selectAll("text").attr('class', 'ticklabel');

            // Apply ticklabel properties

            var ticklabels = g.selectAll("text.ticklabel").data(ticks1, scale);
            if(isMultiLineTick){
                ticklabels.call(wrapTicklabels,chart.tickFormat());
            }
            if(tickComp.isHierarchialLevelType()){
                extendTickmarkLineLength(tickG,type,axisOrder);
            }
            var rotationInfo = getTickRotateInfo(orient, rotation, ticklabels, axis, tickmarkdata.size);
            applyFont(ticklabels, [ticklabeldata, systemconf.chart, systemconf.canvas, $ZCG]);

            ticklabels.style({
                    "cursor": cursor,
                    "text-anchor": rotationInfo.textAnchor
                })
                .attr({
                    "dy": function(d,i){
                        return (ticklabeldata.zigzag &&i%2 && rotationInfo.dy1) ? rotationInfo.dy1 : rotationInfo.dy
                    },
                    "transform": "rotate(" + rotationInfo.rotate[0] + " " + rotationInfo.rotate[1] + " " + rotationInfo.rotate[2] + ")"
                });

            var minmaxlabelsdata = ticklabeldata.minmaxlabels || {};
            if (minmaxlabelsdata.show === true) {
                var domain = scale.domain();
                var domainLength = domain.length - 1;
                var minmaxlabels = ticklabels.filter(function(d, i) {
                    return !(d - domain[0]) || !(d - domain[domainLength]);
                });
                applyFont(minmaxlabels, [minmaxlabelsdata, ticklabeldata, systemconf.chart, systemconf.canvas, $ZCG]);

                if ((orient === "top" || orient === "bottom") && (rotationInfo.textAnchor === "middle")) {
                    var axisReversed = data.reversed === true;
                    minmaxlabels
                        .style("text-anchor", function(d) {
                            return !(d - domain[axisReversed ? domainLength : 0]) ? null : "end"
                        });
                }
            }

            if (type !== "clr") {
                var columnInfo = {
                    "data": columnIndices.map(function(d) {
                        return mergeJSON(chartObj.systemConf.metadata.columns[d], {
                            "columnindex": d
                        }, true);
                    })
                };

                if (!eventDisabled) {
                    var mousemove, mouseout, click, dblclick,
                        tap, taphold, tapholdend, doubletap;
                    if (mousemoveFn) {
                        mousemove = function(d) {
                            invokeFunction(mousemoveFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (mouseoutFn) {
                        mouseout = function(d) {
                            invokeFunction(mouseoutFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (clickFn) {
                        click = function(d) {
                            invokeFunction(clickFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (dblclickFn) {
                        dblclick = function(d) {
                            invokeFunction(dblclickFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }

                    if (tapFn) {
                        tap = function(d) {
                            invokeFunction(tapFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (tapHoldFn) {
                        taphold = function(d) {
                            invokeFunction(tapHoldFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (tapHoldEndFn) {
                        tapholdend = function(d) {
                            invokeFunction(tapHoldEndFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (doubleTapFn) {
                        doubletap = function(d) {
                            invokeFunction(doubleTapFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }

                    var mouseHandlers = {
                        "mousemove": mousemove,
                        "mouseout": mouseout,
                        "click": click,
                        "dblclick": dblclick
                    },
                    touchHandlers = {
                        "taphold": taphold,
                        "tapholdend": tapholdend,
                        "tap": tap,
                        "dbltap": doubletap
                    };
                    attachevents(ticklabels, mouseHandlers, touchHandlers);
                }


                if(defined(ticklabeldata.showAs)) {
                    ticklabels.each(function(d, i) {
                        if(defined(tickObj.customTicks[i])) {
                            this.innerHTML = "";
                            wrapTextContent(d3.select(this), tickObj.customTicks[i], null, true);
                        }
                    });
                }
            }

            if(ticklabeldata.tooltip === true) {
                addSVGtitleEle(ticklabels)
            }

            // Apply tickmarks properties

            if(!tickComp.isHierarchialLevelType() && tickmarkdata.align == "between"){
                drawTickLinesBetweenTicklabels(scale,tickG, "minorTicks");

            }

            g.selectAll("line.minorTicks,line#minorTicksAlign")
                .style({
                    "fill": "none",
                    "shape-rendering": "crispedges",
                    "stroke-width": tickmarkdata.strokeWidth,
                    "stroke": (tickmarkdata.hideParent && tickComp.isHierarchialLevelType()) ? "transparent" : tickmarkdata.color
                })

            // Apply Axisline properties
                g.selectAll("path.domain")
                    .style({
                        "stroke": axisline.show === false || axisline.hideParent ? "transparent" : axisline.color,
                        "stroke-width": pick(axisline.strokeWidth, 1),
                        "stroke-dasharray": getDashArray(axisline.style, pick(axisline.strokeWidth, 1))
                    });
            
            if (type !== "clr") {
                if(labeldata.tooltip === true) {
                    addSVGtitleEle(axisLabel.element);
                }
                if(tickComp.isHierarchialLevelType()){
                    ticklabels.call(centeringTicklabel,scale);
                }

                axisLabel.transformLabel(preCalcTickLen, plotarea, orient);
                switch (orient) {
                    case 'top':
                        curTickLabelWidth = (preCalcTickLen != null) ? preCalcTickLen.height + marginTickLabel_top + axisLabelMargin.bottom : 0;
                        curTickLabelWidth = curTickLabelWidth + labelSize + axisLabelMargin.top;
                        tickLabelWidth = curTickLabelWidth;
                        handleOverflowTicks(axisLabel.element, orient, chartObj, 0, "ellipsis", scale, g, chart, "axislabel");
                        break;
                    case 'bottom':
                        curTickLabelWidth = (preCalcTickLen != null) ? preCalcTickLen.height + marginTickLabel_bottom + axisLabelMargin.top : 0; //7 -> spacing between tickmark and ticklabels,axisLabelMargin.bottom -space bw ticklabel and axislabel
                        curTickLabelWidth = curTickLabelWidth + labelSize + axisLabelMargin.bottom;
                        tickLabelWidth = curTickLabelWidth;
                        handleOverflowTicks(axisLabel.element, orient, chartObj, 0, "ellipsis", scale, g, chart, "axislabel");
                        break;
                    case 'left':
                        curTickLabelWidth = (preCalcTickLen != null) ? preCalcTickLen.width + marginTickLabel_left + axisLabelMargin.right : 0;
                        curTickLabelWidth = curTickLabelWidth + labelSize + axisLabelMargin.left;
                        tickLabelWidth = curTickLabelWidth;
                        if (majorTicks !== null && griddata.show) {
                            majorTicks[0] = plotarea.width;
                        }
                        handleOverflowTicks(axisLabel.element, orient, chartObj, 270, "ellipsis", scale, g, chart, "axislabel");
                        break;
                    case 'right':
                        curTickLabelWidth = (preCalcTickLen != null) ? preCalcTickLen.width + marginTickLabel_right + axisLabelMargin.left : 0;
                        curTickLabelWidth = curTickLabelWidth + labelSize + axisLabelMargin.right;
                        tickLabelWidth = curTickLabelWidth;
                        handleOverflowTicks(axisLabel.element, orient, chartObj, 90, "ellipsis", scale, g, chart, "axislabel");
                        break;
                }
            }

            if (majorTicks && griddata.show) {
                var strokeWidth = pick(griddata.strokeWidth, 1),
                    strokeDashArray = getDashArray(griddata.style, strokeWidth),
                    strokeLineCap = getLineCap(griddata.lineCap, griddata.style);
                if(scale.rangeBand && tickmarkdata.align == "between"){
                    drawTickLinesBetweenTicklabels(scale,tickG, "majorTicks");
                }
                g.selectAll("line.majorTicks,line#majorTicksAlign")
                    .attr({
                        "x2": majorTicks[0],
                        "y2": majorTicks[1]
                    })
                    .style({
                        "fill": "none",
                        "shape-rendering": "crispedges",
                        "stroke-width": griddata.strokeWidth,
                        "stroke": griddata.color,
                        "stroke-dasharray": strokeDashArray,
                        "stroke-linecap": strokeLineCap
                    });

                if (type !== "clr") {
                    //To bring axis line front, make grid lines overlapped with axis line transparent
                    // var range = (scale.rangeExtent != null) ? scale.rangeExtent() : scale.range();
                    // var firstVal = (chart.tickValues() == null) ? null : (scale(chart.tickValues()[0]) + (scale.rangeBand ? (scale.rangeBand() / 2) : 0)),
                    //     opp_axisdata = (type == "x") ? systemconf.chart.axes.yaxis[0].axisline : systemconf.chart.axes.xaxis.axisline;
                    

                    //To bring axis line front, make grid lines overlapped with axis line transparent
                    var range = (scale.rangeExtent != null) ? scale.rangeExtent() : scale.range();
                    var firstVal = (chart.tickValues() == null) ? null : (scale(chart.tickValues()[0]) + (scale.rangeBand ? (scale.rangeBand() / 2) : 0));
                    var plotBorderData = chartObj.systemConf.chart.plot.border;

                    var plotareaBorderColor = plotBorderData === true ? plotBorderData.color : axislinedata.color;
                    if (defined(firstVal) && griddata.color !== "transparent" && plotareaBorderColor !== "transparent" && range[0] === firstVal) {
                        // d3_select(majorticksEnter[0][0]).style("stroke","transparent")
                        d3_select(majorticksUpdate[0][0]).style("stroke", "transparent")
                    }
                }
            }

            //BaseLine
            var baseLineData = data.baseline;
            if (baseLineData != null) {
                var baseLine = appendEle(g, "line", ((baseLineData.show === true && ((scale.domain()[0] <= baseLineData.value) && (baseLineData.value < scale.domain()[1]))) ? [1] : []), ".", "class", "zeroBase");
                baseLine.attr({
                        "x1": (orient == "left" || orient == "right") ? 0 : scale(baseLineData.value),
                        "y1": (orient == "left" || orient == "right") ? scale(baseLineData.value) : -plotarea.height,
                        "x2": (orient == "left" || orient == "right") ? plotarea.width : scale(baseLineData.value),
                        "y2": (orient == "left" || orient == "right") ? scale(baseLineData.value) : 0
                    })
                    .style({
                        "fill": "none",
                        "stroke": baseLineData.color,
                        "shape-rendering": "crispedges",
                        "stroke-width": (baseLineData.strokeWidth)
                    })
            }

        })
        return chart;
    }

    chart.axis = axis;

    d3_rebind(chart, axis, 'orient', 'ticks', 'tickValues', 'tickSubdivide', 'tickSize', 'tickPadding', 'tickFormat');
    d3_rebind(chart, scale, 'domain', 'range', 'rangeBand', 'rangeBands', 'ticks');
    chart.scale = function(_) {
        if (!arguments.length) {
            return scale;
        }
        scale = _;
        axis.scale(scale);
        d3_rebind(chart, scale, 'domain', 'range', 'rangeBand', 'rangeBands');
        return chart;
    }
    chart.systemconf = function(_) {
        if (!arguments.length) {
            return systemconf;
        }
        systemconf = _;
        return chart;
    };
    chart.ticks = function() {
        if (!arguments.length) {
            return ticks;
        }
        ticks = arguments;
        return chart;
    };

    chart.majorTicks = function(_) {
        if (!arguments.length) {
            return majorTicks;
        }
        majorTicks = _;
        return chart;
    }
    chart.plotarea = function(_) {
        if (!arguments.length) {
            return plotarea;
        }
        plotarea = _;
        return chart;
    };

    chart.tickLabelWidth = function(_) {
        if (!arguments.length) {
            return tickLabelWidth;
        }
        tickLabelWidth = _;
        return chart;
    };
    chart.tickRotation = function(_) {
        if (!arguments.length) {
            return tickRotation;
        }
        tickRotation = _;
        return chart;
    };
    chart.preCalcTickLen = function(_) {
        if (!arguments.length) {
            return preCalcTickLen;
        }
        preCalcTickLen = _;
        return chart;
    };
    chart.chartObj = function(_) {
        if (!arguments.length) {
            return chartObj;
        }
        chartObj = _;
        return chart;
    };
    chart.columnIndices = function(_) {
        if (!arguments.length) {
            return columnIndices;
        }
        columnIndices = _;
        return chart;
    };
    chart.isMultiLineTick = function(_) {
        if (!arguments.length) {
            return isMultiLineTick;
        }
        isMultiLineTick = _;
        return chart;
    };


    function getDatawithColumnInfo(columnInfo, d) {
        columnInfo.data = columnInfo.data.map(function(dt) {
            var datatype = dt.datatype;
            if (datatype == TIME_DATATYPE) {
                dt.value = generateDateVal(d, null, dt.time).getTime();
            } else {
                dt.value = d;
            }
            return dt;
        });
        return columnInfo;
    }
    //To align the tick lines (grid lines or tick mark) in between the ticklabels
    function drawTickLinesBetweenTicklabels(scale,tickG,type){
        var x2, y2,
            ticks = tickG[0],
            startTickG = d3.select(tickG.node()),
            lastTickG = d3.select(ticks[ticks.length-1]),
            tickLineNode = tickG.selectAll("line."+type).filter(function(d,i){
                return (this.getAttribute("id") != "minorTicksAlign")
            }),
            lastTickLineNode = lastTickG.selectAll("line."+type),
            newStartTickLineNode = appendEle(startTickG, "line", [1], "#", "id", type+"Align");

        var adjustDistance = getNewPositionForTickmark(scale);
        if(type == "minorTicks"){
            x2 = (orient == "bottom" || orient == "top") ? 0 : (-tickmarkdata.size),
            y2 = orient == "bottom" ? tickmarkdata.size : orient == "top" ? -tickmarkdata.size : 0;
        }else{
            x2 = majorTicks[0],
            y2 = majorTicks[1];
        }

        if(scale.rangeBand){
            tickLineNode.attr("transform","translate("+adjustDistance.mid+")");
            lastTickLineNode.attr("transform","translate("+adjustDistance.end+")");
            newStartTickLineNode.attr("transform","translate("+adjustDistance.start+")").attr("x2",x2).attr("y2",y2);
        }else{
            var co =0;
            tickLineNode.attr("transform",function (d,i) {
                var pos = getNewPositionForTickmark(scale,co++);
                return "translate("+pos.mid+")"
            })
            lastTickLineNode.attr("transform","translate("+adjustDistance.end+")");
            newStartTickLineNode.attr("transform","translate("+adjustDistance.start+")").attr("x2",x2).attr("y2",y2);
        }

    }

    function getNewPositionForTickmark(scale,index){
        var startPos, midPos, endPos, value_1,value_2;
        if(scale.rangeBand){
            var rangeBand = scale.rangeBand(),
                rangeExtent = scale.rangeExtent(),
                outerPadding = (scale.range()[0] - rangeExtent[0])+(rangeBand/2),
                diffBand = (scale.domain().length > 1) ? scale.range()[1] - scale.range()[0] - rangeBand : 0;
                value_1 = rangeBand/2 + diffBand/2,
                value_2 = mathMin(outerPadding,value_1);

        }
        else{
            var categories = chartObj.dataObject.hierarchical ? chartObj.dataObject.hierarchical.leafCategories : chart.tickValues(),
                continousRangeBand = $ZC.scale.getContinuousRangeBand(scale, categories ,index),
                rangeBand = continousRangeBand.rangeBand;
                value_1 = rangeBand,
                value_2 = continousRangeBand.outerPaddingInPixel;
        }

        midPos = (orient == "bottom" || orient == "top") ? (value_1 + ",0") : ("0,"+value_1),
        startPos = (orient == "bottom" || orient == "top") ? ((-value_2) + ",0") : ("0,"+(-value_2)),
        endPos = (orient == "bottom" || orient == "top") ? (value_2 + ",0") : ("0,"+value_2);

        return {
            "start" : startPos, "mid" : midPos , "end" : endPos
        };
    }




    // For hierarchy level type, tickmark line should get extend based on the last rendered axis ticklabel width

    function extendTickmarkLineLength(tickG,type,axisOrder){
        var axisObj = getAxisObject(chartObj,type,axisOrder) , axisComp = axisObj.component;
        var minorTicksNode = tickG.selectAll("line.minorTicks");
        var ticklabelWidth = getPreCalculatedTickWidth(type,axisOrder);
        axisObj.ticks.tickValueObj.tickMarkSize = ticklabelWidth+axisComp.tickSize();
        var index = axisOrder;

        var key = (orient == "left" || orient == "right") ? "x1" : "y1",
            value = (orient == "left" || orient == "top") ? ticklabelWidth : -ticklabelWidth;

        var nullKey = (orient == "left") ? "y1" : "x1"

        if(index == chartObj.dataObject.hierarchical.finalDepth){
            var y2 = (orient == "bottom") ? tickmarkdata.size : 0;
            var ticks = tickG[0];
            tickG.selectAll("line#minorTicksAlign").remove();
            var endTickG = d3.select(ticks[ticks.length-1]);
            var newEndTickmark = appendEle(endTickG, "line", [1], "#", "id", "minorTicksAlign");
            var scale = chartObj.axes.x.levels[index-1].scale;
            var domainLen = scale.domain().length;
            var toTranslate = (orient == "top" || orient == "bottom") ? (scale.discreteWidth(domainLen-1) + ",0") : ("0,"+scale.discreteWidth(domainLen-1));
            var key2 = (orient == "left" || orient == "right") ? "x2" : "y2",
                value2 = (orient == "left"|| orient == "top") ? -tickmarkdata.size : tickmarkdata.size;
            newEndTickmark.attr("transform","translate("+toTranslate+")").attr(key,value).attr(key2,value2);
        }

        minorTicksNode.attr(nullKey,null);
        minorTicksNode.attr(key,value);
    }

    function getPreCalculatedTickWidth(type, axisOrder){
        var ticklabelWidth = 0;
        while(axisOrder > 0){
            var axisObj = getAxisObject(chartObj,type,axisOrder-1) , axisComp = axisObj.component;
            ticklabelWidth += axisComp.tickLabelWidth();
            axisOrder--;
        }
        return ticklabelWidth;
    }

    //For nonlinear ordinal scale there is dynamic rangeband for every data. so we are centering it here.
    function centeringTicklabel(g, scale) {
        g[0].forEach(function(tickG,i){
            // if(scale.discreteWidth(i)){
            var keyIndex = (orient == "left" || orient == "right") ? 1 : 0;
            var old_transform = [0,0]//d3.transform(tickG.getAttribute("transform")).translate;
            var rangeBand_nonLinear = scale.discreteWidth(i)/2;

            old_transform[keyIndex] = old_transform[keyIndex]+rangeBand_nonLinear;
            tickG.setAttribute("transform","translate("+old_transform[0]+","+old_transform[1]+")");
            // }

        })
    }

    return chart;
};