//$Id$
function merged_axis_column_intersect(axisorder, chartObj) {
    var metaData = chartObj.systemConf.metadata;
    var indices = metaData.axes.y[axisorder];
    var start = 1,
        end = indices.length - 1;
    
    var col1 = metaData.columns[indices[start - 1]];
    var output = col1[col1.datatype];
    
    for (; start <= end; start++) {
        var col2 = metaData.columns[indices[start]];
        var formatConf2 = col2[col2.datatype];
        
        output = intersectObject(output, formatConf2);
    }
    return output;
}

function getOppositeOrient(orient) {
    switch (orient) {
        case "left":
            return "right";
        case "right":
            return "left";
        case "top":
            return "bottom";
        case "bottom":
            return "top"
    }
}

function isRotatedChart(type, axisRotated) {
    return (type == "x" && axisRotated) || (type == "y" && !axisRotated)
}

function getAxisObject(chartObj, type, index){
    var obj;
    if(type == "x"){
        if(index == 0){
            obj = chartObj.axes.x;
        }else{
            chartObj.axes.x.levels[index-1] = chartObj.axes.x.levels[index-1] || {};
            obj = chartObj.axes.x.levels[index-1];
        }
    } else if (type === "clr") {
        obj = chartObj.axes.clr;
    } else {
        chartObj.axes.y.groups[index] = chartObj.axes.y.groups[index] || {};
        obj = chartObj.axes.y.groups[index];
    }
    return obj;
}
function isTickAutoRotate(chartObj, type, order,tickLabelConfig){
    var isHierarchy = chartObj.axes.x.count > 1 && type == "x" && order > 0,
        rotation = tickLabelConfig.rotation;
    return (rotation == "auto" && !isHierarchy);
}
