;

$ZC.nonLinearOrdinalScale = function() {

    var range, domain, rangeBands, rangeExtent, ranges;

    function scale(x) {
        if(range) {
            return range.get(x)
        }
        return null;
    }

    scale.domain = function(_) {
        if (!arguments.length) {
            return domain
        }
        domain = _;
        return scale;
    };
    scale.rangeBand = function(){
        return 0; //Dummy rangeband for proper tickTransform and tickExit in d3.v3
    }
    scale.rangeBands = function(x) {
        if (!arguments.length) {
            return rangeBands
        }
        if(x == null) {return scale}
        ranges = x;
        rangeBands = new d3_map();
        range = new d3_map();
        var i = -1,
            n = x.length;
            temp = 0;
        while (++i < n) {
            range.set(i, x[i][0]);
            rangeBands.set(i, x[i][1]-x[i][0]);
        }
        return scale;
    };
    scale.discreteWidth = function(x) {
        if(!rangeBands){
            return null
        }
        return rangeBands.get(x);
    };
    scale.rangeExtent = function(_) {
        if (!arguments.length) {
            return rangeExtent
        }
        rangeExtent = _;
        return scale;
    };
    scale.range = function() {
        if(range){
            return range.values();
        }
        return null;
    };
    scale.copy = function() {
        return $ZC.nonLinearOrdinalScale().domain(domain).rangeBands(ranges).rangeExtent(rangeExtent);
    };
    return scale;
};