//$Id$
$ZC.axis.ticks = function(chartObj, axisdata, type, axisorder, orient, plotarea) {
    "use strict";
    var ticks = {};
    $ZC.axis.ticks.maxTickSizeRatio_Vert = "50%";
    $ZC.axis.ticks.maxTickSizeRatio_Hori = "50%";
    
    var dataObject = chartObj.dataObject,
        systemConf = chartObj.systemConf,
        container = chartObj.svg,
        isPreCalc = true,
        tickvalues,
        intelligenceDim = chartObj.canvasarea[(orient == "bottom" || orient == "top") ? "height" : "width"];
    
    var axisLabelMargin = {
        top: 5,
        right: 5,
        bottom: 5,
        left: 5
    };

    ticks.isHierarchy = isHierarchy, ticks.isHierarchialLevelType = isHierarchialLevelType;
    var datatype = chartObj.dataset.getDataType(type, axisorder),
        orient, axisrotated = dataObject.getAxisRotated();
    
    var axislabeldata = axisdata.label || {};
    var axisticklabeldata = axisdata.ticklabel || {};
    var axistickmarkdata = axisdata.tickmark;
    

    var axislabelProp = {},
        ticklabelFontSize = parseFloat($ZC.utils.getVal(getValByPriority([axisticklabeldata, systemConf.chart, systemConf.canvas, $ZCG], "fontSize"))),
        ticklabelFontFamily = $ZC.utils.getVal(getValByPriority([axisticklabeldata, systemConf.chart, systemConf.canvas, $ZCG], "fontFamily"));
    
    var rotation = (axisticklabeldata != null && axisticklabeldata.rotation != null && axisticklabeldata.rotation != "auto") ? axisticklabeldata.rotation : 0;
    //For hierarchy only rotate 0 available
    if(isHierarchy()){
        rotation = 0;
    }
    rotation = (rotation == null || rotation == "") ? 0 : parseFloat(rotation)
    rotation = (rotation < 0) ? (360 - mathAbs(rotation)) : rotation;
    rotation = (rotation > 360) ? (mathAbs(rotation) % 360) : rotation;


    var hideAxisLabel = axislabeldata.show === false || !defined(axislabeldata.text) || axislabeldata.text === "" || !dimension_based_intelligence(chartObj, (type + "axislabel"), intelligenceDim)
                        || (isHierarchy() && axisorder < chartObj.axes.x.count-1);

    var marginAxisLabel_right, marginAxisLabel_left, marginAxisLabel_bottom, marginAxisLabel_top;
    
    if(hideAxisLabel) {
        marginAxisLabel_right = marginAxisLabel_left = marginAxisLabel_bottom = marginAxisLabel_top = 0;
    } else {
        marginAxisLabel_top = pick(axislabeldata.marginTop, 5);
        marginAxisLabel_bottom = pick(axislabeldata.marginBottom, 5);
        marginAxisLabel_left = pick(axislabeldata.marginLeft, 5);
        marginAxisLabel_right = pick(axislabeldata.marginRight, 5);
    }

    var marginTickLabel_right = pick(axisticklabeldata.marginRight, 5),
        marginTickLabel_left = pick(axisticklabeldata.marginLeft, 5),
        marginTickLabel_bottom = pick(axisticklabeldata.marginBottom, 5),
        marginTickLabel_top = pick(axisticklabeldata.marginTop, 5);

    var topbaseline = "0.71em";
    
    var metaData = chartObj.systemConf.metadata;
    var columnidx = chartObj.dataset.getColumnIdx(type, axisorder);
    var dt = metaData.columns[columnidx].datatype;
    var metaConf = metaData.columns[columnidx][dt];
    
    var isMergedAxis = (type == "y") ? (metaData.axes.y[axisorder].length > 1) : false;
    var formatConf = metaConf;
    formatConf = (isMergedAxis && type == "y") ? merged_axis_column_intersect(axisorder, chartObj) : metaConf;

    this.preCalcAxisLen = 0;
    var tickmarkSize = pick(axistickmarkdata.size, 6);
    
    ticks.preCalcApproxAxisLength = function(plotarea) {
        var extent = (type == "x" && chartObj.brush) ? chartObj.brush.extent : null;

        /**
         * Calculating the tick values here
         *  TODO need to check
         */

        var axes = getAxisObject(chartObj,type,axisorder);

        var tickValues;

        var tickHelper = {
            axisRotated: axisrotated,
            axisOrder: axisorder,
            chart: chartObj,
            orient: orient
        };

        if (!axes.Ticks) {
            axes.Ticks = new $ZC.axis.Ticks(type, axisdata, plotarea, tickHelper);
        }

        this.tickValueObj = ticks.getTickValues(plotarea.width, plotarea.height, extent, true, null, axes.Ticks);

        // end calculating tick values

        var selector = (type == "x") ? type + '-axis-' + axisorder : type + '-axis-' + axisorder;
        var axisWrap = chartObj.svg.selectAll("g." + type + "-axis")
        axisWrap = axisWrap.selectAll("g." + selector).data(function() {
            return 1 > 0 ? [axisdata] : [];
        });
        axisWrap.enter().append("g").attr("class", selector);
        axisWrap.exit().remove();

        var dummygroup = axisWrap.selectAll('g.axisgroup').data([axisdata]);
        dummygroup.enter().append('g').attr('class', 'axisgroup');
        dummygroup.exit().remove();
        dummygroup.selectAll("line.majorTicks").style("display", "");

        // var dummygroup = container.append("g").attr("class","dummy").style("visibility","hidden");
        var axisarea = this.tickValueObj.axisgroup;
        var width = axisarea.width,
            height = axisarea.height,
            maxWidth = axisticklabeldata.maxWidth,
            maxHeight = axisticklabeldata.maxHeight;

        if ((orient === "left" || orient === "right") && defined(axisticklabeldata.width)) {
            width = perToPx((getPriorityValue(axisticklabeldata.width, maxWidth) || $ZC.axis.ticks.maxTickSizeRatio_Hori), plotarea.width);
        } else if (defined(axisticklabeldata.height)) {
            height = perToPx((getPriorityValue(axisticklabeldata.height, maxHeight) || $ZC.axis.ticks.maxTickSizeRatio_Vert), plotarea.height);
        }

        axisarea = this.preCalcTickLen = {
            "x": axisarea.left,
            "y": axisarea.top,
            "width": width,
            "height": height
        };

        var isHorizontal = type === "x" && !axisrotated,
            isVertical = !isHorizontal;

        var axisLabelProperties = {
            systemConf: systemConf,
            bound: axisarea,
            horizontal: isHorizontal,
            vertical: isVertical,
            axisOrder: axisorder,
            plotRect: plotarea,
            hide: hideAxisLabel
        };

        /**
         * Adding the axis label here for the only first time. Next time just calls the transform method.
         */
        var axisSize = 0;

        if (axes.axisLabel) {
            axes.axisLabel.show = !hideAxisLabel;
            axes.axisLabel.transformLabel(axisarea, plotarea, orient);
        } else {
            axes.axisLabel = new $ZC.axis.AxisLabel(axisdata, axisLabelProperties, orient, axisWrap);
        }

        if (!hideAxisLabel) {
            axisSize = axes.axisLabel.getBBox().height;
            axislabelProp.textAnchor = "middle";
            switch (orient) {
                case "left": {
                    axislabelProp.y = axisarea.height / 2;
                    axislabelProp.x = -(axisarea.width + marginTickLabel_left + axisLabelMargin.right)
                    axislabelProp.db = ""
                    this.preCalcAxisLen = axisarea.width + marginTickLabel_left + marginAxisLabel_right + axisSize + marginAxisLabel_left;
                    break
                }
                case "right": {
                    axislabelProp.x = axisarea.height / 2;
                    axislabelProp.y = -(axisarea.width + marginTickLabel_left + axisLabelMargin.right)
                    this.preCalcAxisLen = axisarea.width + marginAxisLabel_left + marginTickLabel_right + axisSize + marginAxisLabel_right;
                    break
                }
                case "bottom": {
                    axislabelProp.x = axisarea.width / 2;
                    axislabelProp.y = axisarea.height + marginTickLabel_bottom + axisLabelMargin.top
                    axislabelProp.dy = topbaseline;
                    this.preCalcAxisLen = axisarea.height + marginTickLabel_bottom + marginAxisLabel_bottom + axisSize + marginAxisLabel_top;
                    break
                }
                case "top": {
                    axislabelProp.x = axisarea.width / 2;
                    axislabelProp.y = axisarea.height + marginTickLabel_top + axisLabelMargin.bottom
                    axislabelProp.dy = topbaseline
                    this.preCalcAxisLen = axisarea.height + marginTickLabel_top + marginAxisLabel_top + axisSize + marginAxisLabel_bottom;
                    break
                }
            }
        } else {
            this.preCalcAxisLen = (orient === "bottom" || orient == "top") ? (axisarea.height + marginTickLabel_bottom) : (axisarea.width + marginTickLabel_left);
        }
        // dummygroup.remove()
        return this.preCalcAxisLen
    };
    
    
    ticks.getTickValues = function(width, height, zmInterval, isPreCalc, tickcount, Ticks, newPlotArea) {
        var tickValueObj = {};

        var tickHelper = {
            axisRotated: axisrotated,
            axisOrder: axisorder,
            chart: chartObj,
            orient: orient,
            extent: zmInterval
        };

        var tickValuesInfo = Ticks.getTicks(plotarea, tickcount, tickHelper),
            useHTML = defined(axisticklabeldata.showAs);

        var prop = tickValuesInfo.tickMargin;
        datatype = chartObj.dataset.getDataType(type, axisorder);
        var plotArea = pick(newPlotArea, plotarea);
        var dummygroup = container.append("g").attr("class", "dummy"),
            left = (orient === "right") ? plotArea.left + plotArea.width : plotArea.left,
            top = (orient === "bottom") ? plotArea.top + plotArea.height : plotArea.top;

        dummygroup.attr("transform", "translate(" + left + "," + top + ")");

        rotation = isNaN(tickValuesInfo.rotation) ? rotation : tickValuesInfo.rotation;

        var tickgroup = dummygroup.append("g").attr("class", "tick");
        var dummyBox = calcDummyTextBox(tickgroup, tickValuesInfo.longestTickValue.formattedVal, prop, rotation, useHTML, tickValuesInfo);
        dummyBox.call(function() {
            tickValueObj = getPreciseLongTickSize(plotArea, this, dummygroup, tickgroup, tickValuesInfo, defined(tickcount), useHTML);
        });

        dummygroup.remove();
        return tickValueObj;
    };

    ticks.getActualTicklabel = function () {
        var a = this.tickValueObj , b = a.ticks, value;
        if(this.isHierarchy()  && !this.isHierarchialLevelType() && a.tickValueIndices){
            value = function(i){
                var includes = a.tickValueIndices.indexOf(i);
                if( includes != -1){
                    return b[includes];
                }else{
                    return null;
                }
            }
        }else{
            value = function(i){
                return b[i];
            }
        }
        return value;
    }

    ticks.getTicksforAxisComp = function () {
        var datatype = chartObj.dataset.getDataType(type, axisorder);
        if ((isHierarchy(chartObj,type) && chartObj.dataObject.hierarchical.categoryTree && (datatype == ORDINAL_DATATYPE || datatype == "ordinalNonLinear")) || (isHierarchialLevelType() && chartObj.dataObject.hierarchical.groupByTime)){
            return null; // To be handled in TickFormats. No need to filter ticks (for hierarchy and ordinal)
        }else{
            return this.tickValueObj.ticks;
        }
    }

    function isHierarchialLevelType(){
        return isHierarchy() && axisorder > 0;
    }

    function isHierarchy(){
        return  type == "x" && chartObj.axes.x.count > 1;
    }

    function getPreciseLongTickSize(plotarea, dummyText, dummygroup, tickgroup, tickValuesInfo, iswebChart, useHTML) {
        var tickValueObj;

        var refContainer = dummyText;
        var hasTimeAutoFormat = (datatype === TIME_DATATYPE) && hasAutoFormat(formatConf);

        var tickvalues_formatted = tickValuesInfo.formatterTickValues;
        tickvalues = tickValuesInfo.rawTickValues;
        var longtick = tickValuesInfo.longestTickValue;
        var tickValueIndices = tickValuesInfo.tickValueIndices;
        var scale = tickValuesInfo.scale;


        // custom tick values.
        var customTickStyles, customTickValues;
        if(defined(tickValuesInfo.customTickInfo) && tickValuesInfo.customTickInfo.length) {
            customTickStyles = tickValuesInfo.customTickInfo.styles;
            customTickValues = tickValuesInfo.customTickInfo.userRawTicks;
        }

        var marginInfo = getMarginInfo(orient);

        var tickvalues_formatted_copy = sortByLength(tickvalues_formatted);

        var textWidth = function(text, index) {
            var style, dimension;
            if(defined(customTickStyles)) {
                style = customTickStyles[index];
            }

            dimension = getTextBound(text, ticklabelFontSize, ticklabelFontFamily, style);

            if(useHTML) {
                return dimension.width * dimension.height;
            }

            return dimension.width;
        };

        if (!iswebChart) {

            dummygroup.append("line").attr("class", "domain")
                .attr({
                    "x1": 0,
                    "y1": 0,
                    "x2": (orient == "bottom" || orient == "top") ? plotarea.width : 0.0001, // phantomjs 1.9.8 issue
                    "y2": (orient == "bottom" || orient == "top") ? 0.0001 : plotarea.height // // phantomjs 1.9.8 issue
                })
                .style("stroke", "black")

            var overflow = (axisticklabeldata.textOverflow == "none") ? "" : axisticklabeldata.textOverflow;
            var isFinalLongtick = false;
            var co = -1; // dummyText content has been changed if the ticklabels are filtered and the already defined maxTick is also filtered
            var tempLongtick = longtick.actualVal,
                tempFormattedLongTick = hasTimeAutoFormat ? tempLongtick : longtick.formattedVal;

            if(useHTML) {
                tempFormattedLongTick  = getCurrentCustomTick(tickValuesInfo.longestTickValue, null, tickValuesInfo);
            }


            wrapTextContent(dummyText, tempFormattedLongTick, null, useHTML);


            var rotationInfo = getTickRotateInfo(orient, rotation, dummyText, null, tickmarkSize, marginInfo);
            tickRotate(dummyText, rotationInfo);
            var pos = (scale(tempLongtick) || 0) + ((scale.rangeBand == null) ? 0 : scale.rangeBand() / 2); //scale(tempLongtick) || 0 (Test_496.json)
            pos = (orient == "bottom" || orient == "top") ? pos + ",0" : "0," + pos;
            tickgroup
                .attr("transform", "translate(" + pos + ")");


            handleOverflowTicks(dummyText, orient, {
                "svg": chartObj.svg,
                "canvasarea": chartObj.canvasarea,
                "plotarea": plotarea,
                "chartarea": chartObj.chartarea,
                "legendarea": chartObj.legendarea,
                "actChartObj": chartObj
            }, rotation, overflow, scale, dummygroup, null, "ticklabel", axisticklabeldata,axisorder);

            var curTick,maxTick,nextTick;
                //Initialize curtick,maxtick
                maxTick = curTick = useHTML ? tempFormattedLongTick: getTextContent(dummyText);//(hasTimeAutoFormat ? tempLongtick : longtick.formattedVal)

            while (datatype != "ordinalNonLinear" &&( !isFinalLongtick && (co < tickvalues.length))) {
                co = co + 1;
                var pos = (scale(tempLongtick) || 0) + ((scale.rangeBand == null) ? 0 : scale.rangeBand() / 2);
                pos = (orient == "bottom" || orient == "top") ? pos + ",0" : "0," + pos;
                tickgroup
                    .attr("transform", "translate(" + pos + ")");
                handleOverflowTicks(dummyText, orient, {
                    "svg": chartObj.svg,
                    "canvasarea": chartObj.canvasarea,
                    "plotarea": plotarea,
                    "chartarea": chartObj.chartarea,
                    "legendarea": chartObj.legendarea,
                    "actChartObj": chartObj
                }, rotation, overflow, scale, dummygroup, null, "ticklabel", axisticklabeldata,axisorder); // Test_462.json

                //Updating maxLength Tick which is longest tick after handle overflow //ZR506
                curTick = getTextContent(dummyText);
                //compare maxtick with curtick
                if (textWidth(curTick, co) > textWidth(maxTick, co)) {
                    tempFormattedLongTick = curTick;
                    if(useHTML) {
                        tempFormattedLongTick = getCurrentCustomTick(null, co, tickValuesInfo);
                    }
                    maxTick = tempFormattedLongTick;
                }
                //Apply maxtick to refgroup
                wrapTextContent(dummyText, maxTick, null, useHTML);

                //check overflow and next tick
                var isLastTick = (!tickvalues.length || (co === tickvalues.length - 1) || (tickvalues.length === 1));
                nextTick = ((isLastTick) ? null : (hasTimeAutoFormat ? tickvalues_formatted_copy[co] : tickvalues_formatted_copy[co] || ""));

                var isoverflow = (isLastTick) ? false : textWidth(curTick, co) < textWidth(nextTick, co);

                //set next tick to refgroup
                if (isoverflow) {
                    tempLongtick = tickvalues_formatted_copy[co];
                    curTick = nextTick;
                    tempFormattedLongTick = nextTick;
                    if(useHTML) {
                        tempFormattedLongTick = getCurrentCustomTick(null, co, tickValuesInfo);
                    }
                    wrapTextContent(dummyText, tempFormattedLongTick, null, useHTML);
                } else {
                    isFinalLongtick = true;
                }
            }
        }


        var referenceLongTickSize = refContainer.node().getBoundingClientRect();
        var refAxisgroupSize = dummygroup.node().getBoundingClientRect();

        tickValueObj = {
            "ticks": tickvalues,
            "rotation": rotation,
            "longTickSize": referenceLongTickSize,
            "longtick": longtick,
            "axisgroup": refAxisgroupSize,
            "customTicks": customTickValues
        };
        if(tickValueIndices){
            tickValueObj.tickValueIndices = tickValueIndices;
        }
        return tickValueObj;
    }
    
    function getMarginInfo(orient) {
        switch (orient) {
            case "left":
                return marginTickLabel_right;
                break;
            case "right":
                return marginTickLabel_left;
                break;
            case "bottom":
                return marginTickLabel_top;
                break;
            case "top":
                return marginTickLabel_bottom;
                break;
        }
    }

    /**
     *
     * @param longTick
     * @param index
     * @param tickInfo
     */
    function getCurrentCustomTick(longTick, index, tickInfo) {
        return tickInfo.customTickInfo.userRawTicks[defined(index) ? index : longTick.index];
    }
    
    function calcDummyTextBox(g, text, prop, rotation, useHTML, tickValueInfo) {

        var dummyText = g.selectAll("text").data([1]);
        dummyText.enter().append("text")
            .attr({
                "x": prop.x || 0,
                "y": prop.y || 0,
                "dy": prop.dy || 0
            })
            .attr("transform", "rotate(" + (rotation) + " " + (prop.x) + " " + (prop.y) + ")"); //7-spacing bw tickmark anad ticklabel

        if (useHTML) {
            text = getCurrentCustomTick(tickValueInfo.longestTickValue, null, tickValueInfo);
        } else {
            dummyText.text(text)
        }

        wrapTextContent(dummyText, text, null, useHTML);
        applyFont(dummyText, [axisticklabeldata, systemConf.chart, systemConf.canvas, $ZCG]);
        return dummyText
    }
    function tickRotate(ticklabels, rotationInfo) {
        ticklabels.attr({
            "dy": (axisticklabeldata.zigzag) ? rotationInfo.dy1 || rotationInfo.dy : rotationInfo.dy ,
            "transform": "rotate(" + rotationInfo.rotate[0] + " " + rotationInfo.rotate[1] + " " + rotationInfo.rotate[2] + ")"
        }).style({
            "text-anchor": rotationInfo.textAnchor
        })
    }

    return ticks;
};

$ZC.axis.constructTickObj = function(chartObj, chartWidth, chartHeight, orient, plotarea_approx, update) {
    /*
     constructing tick object for all axes which contains precalculated approximate axis area,tick values
     For calculating plot area precisely,first we are rendering left,right axes, for that we should have bottom axes area
     so we are pre calculating the left ,right axes area,From that we will get plotarea.width
     From plot area.width,we have calculate exact bottom axis area
     From exact bottom axis area, we will get plot area,height
     From plotarea.height,we will draw left right axes precisely
     Here wile calculating left/right axes, plotarea_approx is going to change
     But while calculating bottom axis exact plotarea height is going to change
     */
    var systemconf = chartObj.systemConf;

    var index = 0,
        type, axisdata;
    
    type = ((orient == "left" && chartObj.axes.rotated) || (orient == "bottom" && !chartObj.axes.rotated)) ? "x" : "y";
    var axesCount = chartObj.axes[type].count;
    
    for (var i = 0; i < axesCount; i++) {
        var yaxisData = systemconf.chart.axes.yaxis
        
        if (i > 0 && type == "y") {
            axisdata = update ? yaxisData[i] : mergeJSON(yaxisData[i], yaxisData[0], false);
            var dt = ((yaxisData[i] != null) && (yaxisData[i] !== "")) ? yaxisData[i] : {};
            axisdata.interval = dt.interval;
            axisdata.tickCount = dt.tickCount;
            axisdata.minRange = dt.minRange;
            axisdata.maxRange = dt.maxRange;
            axisdata.categories = dt.categories; //Test_523.json
            yaxisData[i] = axisdata;
        }
        axisdata = (type == "x") ? systemconf.chart.axes.xaxis : yaxisData[i];
        orient = axisdata.orient || ((type == "x")
                                        ? (chartObj.axes.rotated ? "left" : "bottom")
                                        : (chartObj.axes.rotated ? "bottom" : ((i == 0) ? "left" : "right")));
        var dim = (orient == "bottom" || orient == "top") ? chartHeight : chartWidth;
        var axisShow = axisdata.show === true && dimension_based_intelligence(chartObj, (type + "axis"), dim);

        if (axisShow) {
            var axisObj = getAxisObject(chartObj, type, i);
            if (type == "y" && !axisObj) {
                axisObj =  {}
            }
            if(type == "x" && !axisObj){
                axisObj = (i > 0) ? {} : axisObj;
            }
            var tickObj = $ZC.axis.ticks(chartObj, axisdata, type, i, orient, plotarea_approx);
            axisObj.ticks = tickObj;
            var axisarea = tickObj.preCalcApproxAxisLength(plotarea_approx);
            
            if(!((type === "y") && chartObj.axes.y.groups[i].disabled)){
                var plotarea = chartObj.plotarea;
                if (orient == "left") {
                    plotarea_approx.left += axisarea
                    plotarea_approx.width = plotarea_approx.width - axisarea

                    plotarea.left = plotarea_approx.left;
                    plotarea.width = plotarea_approx.width;
                } else if(orient == "right") {
                    plotarea_approx.width = plotarea_approx.width - axisarea;

                    plotarea.width = plotarea_approx.width;

                } else if (orient == "bottom") {
                    plotarea.height = plotarea.height - (axisarea);
                    plotarea.bottom += axisarea;
                    
                    plotarea_approx.height = plotarea.height;
                    plotarea_approx.bottom += plotarea.bottom;
                } else if (orient == "top") {
                    plotarea.height = plotarea.height - (axisarea);
                    plotarea.top += axisarea;
                    
                    plotarea_approx.height = plotarea.height;
                    plotarea_approx.top += plotarea.top;
                }
            }
        } else {
            // reset axis label and tick label
            var axes = type === "y" ? chartObj.axes.y.groups[i] : chartObj.axes.x;
            axes.axisLabel = axes.Ticks = null;
        }
        
    }
    
    //Initializing chart brush before pre rrendering X tick obj
    if (type == "y" && isObjectPropDefined(systemconf.chart, "scroll") && systemconf.chart.scroll.enabled) {
        chartObj.svg.call(chartObj.brush);
        chartObj.brush.initialize(plotarea_approx)
    }
};

function getTickRotateInfo(orient, rotation, ticklabels, axis, tickmarkSize, tickPadding, zigzag) {
    var rotateInfo = {}
    var topbaseline = "0.71em",
        middlebaseline = "0.35em",
        bottombaseline = "",
        tickPadding = (tickPadding == null) ? axis.tickPadding() : tickPadding;
    
    switch (orient) {
        case 'top':
            rotateInfo.rotate = [rotation, 0, -(mathMax(tickmarkSize, 0) + tickPadding)];
            
            if ((rotation >= 0 && rotation < 45) || (rotation > 315 && rotation <= 360)) {
                rotateInfo.dy = bottombaseline;
            } else if ((rotation >= 45 && rotation <= 90) || (rotation >= 90 && rotation <= 135) || (rotation >= 225 && rotation <= 315)) {
                rotateInfo.dy = middlebaseline;
            } else if ((rotation > 135 && rotation < 225)) {
                rotateInfo.dy = topbaseline
            }
            rotateInfo.textAnchor = (rotation == "0" || pInt(rotation) == 180 || pInt(rotation) == 360) ? "middle" : (pInt(rotation) < 180) ? "end" : "start"
            break;
        
        case 'bottom':
            rotateInfo.rotate = [rotation, 0, (mathMax(tickmarkSize, 0) + tickPadding)];
            
            if ((rotation >= 0 && rotation < 45) || (rotation > 315 && rotation <= 360)) {
                rotateInfo.dy = topbaseline;
                rotateInfo.dy1 = "1.71em";
            } else if ((rotation >= 45 && rotation <= 90) || (rotation >= 90 && rotation <= 135) || (rotation >= 225 && rotation <= 315)) {
                rotateInfo.dy = middlebaseline;
            } else if ((rotation > 135 && rotation < 225)) {
                rotateInfo.dy = bottombaseline
            }
            rotateInfo.textAnchor = (rotation == "0" || pInt(rotation) == 180 || pInt(rotation) == 360) ? "middle" : (pInt(rotation) < 180) ? "start" : "end"
            break;
        
        case 'left':
            rotateInfo.rotate = [rotation, -(mathMax(tickmarkSize, 0) + tickPadding), 0];
            
            if ((rotation >= 0 && rotation < 45)) {
                rotateInfo.dy = middlebaseline;
            } else if ((rotation >= 45 && rotation <= 90) || (rotation >= 90 && rotation <= 135)) {
                rotateInfo.dy = topbaseline;
            } else if ((rotation > 135 && rotation < 225) || (rotation >= 225 && rotation <= 315) || (rotation > 315 && rotation <= 360)) {
                rotateInfo.dy = bottombaseline
            }
            rotateInfo.textAnchor = (rotation == "90" || pInt(rotation) == 270) ? "middle" : (rotation > 90 && rotation < 270) ? "start" : "end"
            break;
        
        case 'right':
            rotateInfo.rotate = [rotation, (mathMax(tickmarkSize, 0) + tickPadding), 0];
            
            if ((rotation >= 0 && rotation < 45) || (rotation > 135 && rotation < 225)) {
                rotateInfo.dy = middlebaseline;
            } else if ((rotation >= 225 && rotation <= 315) || (rotation > 315 && rotation <= 360)) {
                rotateInfo.dy = topbaseline;
            } else if ((rotation >= 90 && rotation <= 135) || (rotation >= 45 && rotation <= 90)) {
                rotateInfo.dy = bottombaseline
            }
            rotateInfo.textAnchor = (rotation == "90" || pInt(rotation) == 270) ? "middle" : (rotation > 90 && rotation < 270) ? "end" : "start"
            break;
    }
    
    return rotateInfo;
}

function tickRotate(ticklabels, rotationInfo) {
    ticklabels.attr({
        "dy": (axisticklabeldata.zigzag) ? rotationInfo.dy1 || rotationInfo.dy : rotationInfo.dy ,
        "transform": "rotate(" + rotationInfo.rotate[0] + " " + rotationInfo.rotate[1] + " " + rotationInfo.rotate[2] + ")"
    }).style({
        "text-anchor": rotationInfo.textAnchor
    })
}

function handleOverflowTicks(axisgroup, orient, chartObj, rotation, overflow, scale, wrap, axisComp, labelType, ticklabelOptions,index) {
    var plotarea = chartObj.plotarea,
        chartarea = chartObj.chartarea,
        canvasarea = chartObj.canvasarea,
        ticklabelOptions = (labelType == "ticklabel") ? ticklabelOptions : {},
        actChartObj = chartObj.actChartObj || chartObj;
    var percentLimit = 0.5;

    var labelSize = getMaxTickSize(ticklabelOptions, chartarea),
        maxTickSize_Vert = labelSize.vertical,
        maxTickSize_Hori = labelSize.horizontal;
    
    var pattern = (overflow == null || overflow == "ellipsis") ? ".." : "";
    
    var margin = {};
    margin.left = (labelType == "axislabel") ? (percentLimit * (canvasarea.width - (plotarea.left + plotarea.width))) : (percentLimit * plotarea.left), //ZC743 If its axislabel margin right and left should be same, because always axislabel placed at center of plotarea with textanchor middle
    margin.right = (percentLimit * (canvasarea.width - (plotarea.left + plotarea.width))),
    margin.top = (percentLimit * plotarea.top),
    margin.bottom = (percentLimit * plotarea.bottom);
    
    
    // var marginValue = (orient == "bottom") ? (plotarea.width*margin)/100 : (plotarea.height*margin)/100;
    // var range = (scale.rangeBand != null) ? (orient == "bottom" || orient == "top") ? scale.rangeExtent() : scale.rangeExtent().reverse() : scale.range(); //reverse it only for orient left
    var  isHierarchialLevelType = scale.discreteWidth != null;
    if (axisgroup == null && labelType == "ticklabel") {
        var ticks = axisComp.tickValues() == null ? scale.ticks ? scale.ticks.apply(scale, [10]) : scale.domain() : axisComp.tickValues();
        var tickWrap = wrap.selectAll(".tick").data(ticks, scale);
        axisgroup = tickWrap.selectAll("text.ticklabel")
    }
    
    axisgroup.filter(function(d, j) {

        /*
         * Cropping the text to maximum ticklabel size (according to bounded box of the text)
         */

        var childNodes  = [this.childNodes[0]];//If the SVG text has title element, the title element will be removed while changing this.textContent as because it modifies all the childNodes of it. So take the text element alone to trim

        var tspan = d3.select(this).selectAll("tspan")[0];
        if(tspan.length){ // only for multiple line ticklabel
            tspan.sort(function(a,b){
                return b.textContent.length - a.textContent.length
            })
            childNodes = tspan;
        }

        if (!childNodes) {
            return;
        }
        for (var i = 0; i < childNodes.length; i++) {
            var txtNode = (tspan.length) ? childNodes[i] : this;
            var clientRect = (txtNode.nodeName == "tspan") ? getTspanBoundingClientRect : getDefaultBoundingClientRect;
            var textBounds = clientRect(txtNode);
            var overflowLength = -1;


            if (isHierarchialLevelType && labelType == "ticklabel" && !chartObj.actChartObj) {
                var axisObj = getAxisObject(actChartObj, "x", index - 1),
                    tickMarkSize = axisObj.ticks.tickValueObj.tickMarkSize,
                    prevAxisObj = getAxisObject(actChartObj, "x", index),
                    prevTickMarkSize = (prevAxisObj) ? prevAxisObj.ticks.tickValueObj.tickMarkSize : 0;


                var rb = (orient == "left" || orient =="right") ? Math.abs(prevTickMarkSize - tickMarkSize) : Math.abs(scale.discreteWidth(d)) || maxTickSize_Hori;
                naiveEllipsis(txtNode, txtNode, txtNode.textContent, rb, maxTickSize_Vert, textBounds, pattern);
                return;
            }

            var initial_textContent = txtNode.textContent,
                initial_textBound = textBounds,
                max = { // This should be changed for axis labels
                    width: maxTickSize_Hori,
                    height: maxTickSize_Vert
                },
                trimmed,
                minMargin = bbox(this).height; //if margin is very less, tick labels are trimmed unnecessarily. So set minMargin as its height
            if (labelType == "ticklabel") {
                if (maxTickSize_Hori < textBounds.width) {
                    overflowLength = (textBounds.width - maxTickSize_Hori) / textBounds.width;
                    var croppedTextLength = mathCeil((1 - overflowLength) * txtNode.textContent.length);
                    txtNode.textContent = txtNode.textContent.substring(0, croppedTextLength - 2) + pattern;
                    textBounds = clientRect(txtNode); //update new textbounds
                }
                if (maxTickSize_Vert < textBounds.height) {
                    overflowLength = (textBounds.height - maxTickSize_Vert) / textBounds.height;
                    var croppedTextLength = mathCeil((1 - overflowLength) * txtNode.textContent.length);
                    txtNode.textContent = txtNode.textContent.substring(0, croppedTextLength - 2) + pattern;
                    textBounds = clientRect(txtNode); //update new textbounds
                }
            }

            // var svgarea = document.querySelectorAll("svg")[0].getBoundingClientRect();
            var axisGroupBounds = wrap.selectAll(".domain").node().getBoundingClientRect();

            var newTextBounds = {
                left: (textBounds.left - axisGroupBounds.left),
                right: (textBounds.left + textBounds.width - axisGroupBounds.left),
                top: (textBounds.top - axisGroupBounds.top),
                bottom: (textBounds.top + textBounds.height - axisGroupBounds.top),
                width: textBounds.width,
                height: textBounds.height
            };

            //Edge details for hierarchy data and between tickmarks
            var edge = {};
            edge.top = edge.left = 0;
            edge.right = (orient == "bottom" || orient == "top") ? getPlotSize(actChartObj, "width", plotarea) : 0;
            edge.bottom = (orient == "bottom" || orient == "top") ? 0 : getPlotSize(actChartObj, "height", plotarea);
            if ((orient == "left" || orient == "right") && (rotation != 0 && rotation != 180 && rotation != 360)) {
                if ((newTextBounds.top + mathMax(minMargin, margin.top) < edge.top) || (newTextBounds.bottom - mathMax(minMargin, margin.bottom) > edge.bottom)) {
                    trimmed = true;
                    trimText(txtNode, txtNode.textContent, newTextBounds, edge, orient, pattern, margin, max, this);
                }
            } else if ((orient == "bottom" || orient == "top") && (rotation != 90 && rotation != 270)) {
                if ((newTextBounds.left + mathMax(minMargin, margin.left) < edge.left) || (newTextBounds.right - mathMax(minMargin, margin.right) > edge.right)) {
                    trimmed = true;
                    trimText(txtNode, txtNode.textContent, newTextBounds, edge, orient, pattern, margin, max, this);
                }
            }

            if ((labelType == "ticklabel") && !trimmed) {
                var textBounds = clientRect(txtNode);
                if ((textBounds.width != initial_textBound.width) || (textBounds.height != initial_textBound.height)) {
                    naiveEllipsis(txtNode, this, initial_textContent, max.width, max.height, textBounds, pattern);
                }
            }
        }
    })
}

var getPriorityValue = function(constant, max) {
    if (defined(constant) && defined(constant)) {
        return constant > max ? max : constant
    } else {
        return constant || max;
    }
};

/**
 *
 * @param obj tick label object or axis label object
 * @param p plotarea
 * @returns {{vertical: *, horizontal: *}}
 */
function getMaxTickSize(obj, p) {
    return {
        vertical: perToPx(pick(obj.height, obj.maxHeight, $ZC.axis.ticks.maxTickSizeRatio_Vert), p.height),
        horizontal: perToPx(pick(obj.width, obj.maxWidth, $ZC.axis.ticks.maxTickSizeRatio_Hori), p.width)
    }
}

/**
 * Check if the formatter is specified to auto
 *
 * @param {Object} formatConf
 * @returns {boolean}
 */

function hasAutoFormat(formatConf) {
    return formatConf && formatConf.format && (formatConf.format.specifier === "auto");
}

function toRadians(angle) {
    return angle * (Math.PI / 180);
}

function getTspanBoundingClientRect(tspan){
    var range = document.createRange();
    range.selectNode(tspan);
    var rect = range.getBoundingClientRect();
    range.detach(); // frees up memory in older browsers
    return rect;
}

function getDefaultBoundingClientRect(text){
    return text.getBoundingClientRect();
}

function getBoundingClientRect(text, angle, fontSize, fontFamily) {
    var width = getTextWidth(text, fontSize, fontFamily);
    return calculateBound(width, getFontHeight(fontSize), angle);
}

function calculateBound(width, height, angle) {
    angle = toRadians(angle);
    return {
        width: Math.sin(angle) * height + Math.cos(angle) * width,
        height: Math.sin(angle) * width + Math.cos(angle) * height
    }
}

/**
 *
 * @param text
 * @param fontSize
 * @param fontFamily
 * @param {{fontFamily: string, fontSize: number, fontStyle: string}} styles
 * @returns {{width: *, height: *}}
 */

function getTextBound(text, fontSize, fontFamily, styles, dontUseEmpirical) {
    var hasMultipleLines = isArray(text), w, h,
        fontHeight = getFontHeight(fontSize);

    if (hasMultipleLines) {
        text.forEach(function(d, i) {
            if (defined(styles) && styles.length) {
                fontSize = styles[i].fontSize || fontSize;
                fontFamily = styles[i].fontFamily || fontFamily;
            }
            var tempWid = getTextWidth(d, fontSize, fontFamily);
            fontHeight = getFontHeight(fontSize);
            w = (!defined(w)) ? tempWid : mathMax(w, tempWid);
            h = (!defined(h)) ? fontHeight : h + (1.1 * fontHeight);
        })
    } else {
        if (defined(styles)) {
            fontSize = styles.fontSize || fontSize;
            fontFamily = styles.fontFamily || fontFamily;
        }
        w = getTextWidth(text, fontSize, fontFamily);
        h = getFontHeight(fontSize, dontUseEmpirical);
    }
    return {
        "width": w,
        "height": h
    }
}

function getTextWidth(text, fontSize, fontFamily) {
    tempCanvasContext.save();
    tempCanvasContext.font = (fontSize || 12) + "px " + (fontFamily || $ZCG.fontFamily);
    var t = tempCanvasContext.measureText(text).width;
    tempCanvasContext.restore();
    return t;
}

function getFontHeight(fontSize, dontUseEmpirical) {

    // Empirical values found by comparing font size and bounding box height.
    // Applies to the default font family. http://jsfiddle.net/highcharts/7xvn7/
    if(dontUseEmpirical){
        return fontSize;
    }
    return fontSize < 24 ? fontSize + 3 : ~~(fontSize * 1.195);
}

function getBBox(fontSize, text, X, Y, DY) {

    var fontFamily = $ZCG.fontFamily;

    var textBound = getTextBound(text, fontSize, fontFamily);

    var fontHeight = getFontHeight(fontSize);
    var baseline = -fontHeight * 0.8;

    var x = textBound.width / 2;
    var y = baseline + Y + (fontSize * DY);

    return {
        x: -x,
        y: y,
        width: textBound.width,
        height: textBound.height
    }
}


function wrapTicklabels(text,tickFormat){
    text.each(function (d,i) {
        var tick = d3.select(this);
        var formattedValue = (tickFormat) ? tickFormat(d,i) : getTextContent(tick);
        wrapTextContent(tick,formattedValue);
    })
}


