//$Id$

function getBulletLevelMarkerGradient(d, levelMarker, chartObj, baseClr, levelMarkerColor) {
    var level = d[levelMarker.dataindex] || [];
    if (level != null && !(level instanceof Array)) { //If level marker is a single value and in non-array format, make it as array
        return null;
    }

    if (!level.length) {
        return null;
    }

    if (!levelMarkerColor) { //If colors are not specified, create monochrome colors
        levelMarker.color = [];
        var colorGamma = levelMarker.colorGamma || [0.3, 0.9];
        var domain = [0, level.length - 1],
            range = [+colorGamma[0], +colorGamma[1]];
        var monoClrGen = getMonochromeColor(baseClr, domain, range);
        levelMarker.color = level.map(function(d, i) {
            return monoClrGen(i);
        });
    } else if (levelMarkerColor.constructor != Array) {
        levelMarker.color = [levelMarkerColor];
    }

    var neg = level.filter(function(d) {
        return d < 0;
    });

    var thValues;
    if (neg.length > 0) { // If negative values are present, add 0
        thValues = level.slice();
        var zeroIndex = thValues.indexOf(0);
        if (zeroIndex > -1) {
            thValues.splice(zeroIndex, 1);
        }

        var negthClr = levelMarker.color;
        thValues = thValues.sort(d3_descending);
        var color = [];

        for (var i = 0; i < thValues.length; i++) {
            var index = level.indexOf(thValues[i])
            color.push(negthClr[index]);
        }
        levelMarker.color = color;
        thValues.splice((thValues.length - neg.length), 0, 0);
        level = thValues;
    }
    levelMarker.values = level;
    var thOverlay = $ZC.axis.threshold.overlay(chartObj, "continous")("transparent", levelMarker, 0, "y");
    if (neg.length > 0) {
        level = thValues;
    }

    return thOverlay;
}