//$Id$
;
canvas_plot_renderer.bar = function() {
    
    var commonRendererProp, bandwidth1, bandwidth2, yscale, barDatasetIndex,
        shiftInfo;
    
    function chart(context, seriesdata, effect, filterIndex) {
        var rp = commonRendererProp.params,
            chartObj = rp.chartObj,
            xscale = rp.xscale,
            stacked = rp.stacked,
            index = rp.datasetIndex,
            axisrotated = rp.axisrotated,
            commonPlotOptions = rp.commonPlotOptions,
            color = rp.color,
            labelQueue = rp.labelQueue,
            hasNegValue = rp.hasNegValue,
            yaxiscolumnorder = rp.yaxiscolumnorder,
            dataset = rp.dataset,
            systemconf = chartObj.systemConf,
            plotarea = chartObj.plotarea,
            dataObject = chartObj.dataObject;
            // categories = xscale.domain();
            // categories = chartObj.dataObject.getCategories("x");

        if (!bandwidth1 || !bandwidth2) { //Test_515.json (Combinational chart(bar + line) where all the bar series are disabled)
            isredraw = true;
            chart.chartRendered = true;
            return;
        }

        yscale = rp.yscale;
        var datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

            xCategories = xscale.domain(),
            yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

            categories = defined(dataObject.hierarchical) ? dataObject.getCategories("x") : xCategories;

        var charttype = chartObj.chartTypes[index].name;
        var gradientDim = null//[w,h];
        var yAxisReversed = chartObj.systemConf.chart.axes.yaxis[yaxiscolumnorder || 0].reversed;

        var plotoptions = seriesdata.plotoptions;
        var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions),
            isBullet = chartObj.chartTypes[index].value === $ZC.charttype.bullet;

        var levelMarker = (plotoptions && plotoptions.levelMarker) ? mergeJSON(commonPlotOptions.levelMarker, plotoptions.levelMarker, true) : commonPlotOptions.levelMarker,
            borderOptions = (plotoptions && plotoptions.border) ? mergeJSON(commonPlotOptions.border, plotoptions.border, true) : commonPlotOptions.border;
        var multiColoring = isTrue(gvp("multiColoring") || false) && !chartObj.legendarea.show,
            hasColorScale = colorscale_helpers.isQuantileColorScale(chartObj);

        var fillStyle = chart.fillColorFunc = getFillColor(chartObj, index, gradientDim),
            strokeColor = getStrokeColor(chartObj, index);
        
        var fillOpacity = gvp("fillOpacity"),
            getParamValue = chart.getParamValue = function() {
                return chartObj.dataObject.getTransRectValue.apply(chartObj.dataObject, toArray(arguments));
            };
        
        var commonOption = getBarCommonOption(chartObj.rendererConf[index], index);
        var levelMarkerWidth = commonOption.levelMarkerWidth,
            levelMarkerPadding = commonOption.levelMarkerPadding;
        levelMarker.overlayRange = "below";
        var levelMarkerColor = levelMarker.color; //Saving the levelMarker colors, helps in multi categories bullet if each categories dont have same no of levels
        
        var borderRadius = {
            tlx: 0,
            tly: 0,
            trx: 0,
            trY: 0,
            brx: 0,
            bry: 0,
            blx: 0,
            bly: 0
        };
        var borderSize = 0,
            borderColor = null,
            borderStyle = null,
            radius = 0;
        if (defined(borderOptions) && isTrue(borderOptions.show)) {
            borderSize = defined(borderOptions.size) ? borderOptions.size : 1;
            borderColor = borderOptions.color;
            borderStyle = borderOptions.style;
            radius = borderOptions.radius;
            borderRadius = getParamValue("radius", null, null, null, commonOption, radius);
        }
        
        var dashStyle = getDashArray(borderStyle, (borderSize == null ? 2 : borderSize));

        
        
        var legend_data = systemconf.legend;
        var rounded = isRounded(borderRadius),
            patternName = legend_data.patternPallete,
            patternPallete = legend_data.patternPallete,
            rgba = canvasUtils.rgba;
        
        //STACKED BAR : for which series the level marker should be drawn
        var isLevelMarkerIndex;
        if (stacked && levelMarker.enabled && !defined(effect)) {
            var stackGroup = chartObj.userdata.seriesdata.stackGroup,
                groupedByStack = chartObj.dataObject.groupedByStack;
            var actualStackGroupIndex = (stackGroup) ? getStackGroupIndex(index, stackGroup) : 0;
            isLevelMarkerIndex = groupedByStack.has(actualStackGroupIndex) && (groupedByStack.get(actualStackGroupIndex)[0].si == index);
        }
        
        if (!seriesdata.disabled) {
            chart.seriesdataAfterUpdate = [];
            seriesdata.data.forEach(function(data, i) {
                
                var dataUpdate = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(data), xCategories, yCategories, yaxiscolumnorder);

                if (chartObj.systemConf.chart.axes.xaxis.reversed) {
                    dataUpdate = dataUpdate.slice(0).reverse();
                }

                if (hasColorScale && defined(effect)) {
                    dataUpdate = legend_helpers.filterSelectionByColor(dataUpdate, true, filterIndex, chartObj);
                }
                chart.seriesdataAfterUpdate[i] = dataUpdate;

                dataUpdate.forEach(function(d, j) {
                    var x, y, w, h, gradient,
                        fillColor = getRawColor(chartObj, (multiColoring ? j : index), d, index);
                    
                    if (levelMarker.enabled && !defined(effect)) {
                        if ((stacked && isLevelMarkerIndex && i === 0) || !stacked) {
                            var level = d[levelMarker.dataindex] || [],
                                hasLevels = defined(levelMarker.dataindex),
                                min,
                                max;
                            if (level != null && !(level instanceof Array)) { //If level marker is a single value and in non-array format, make it as array
                                level = [level];
                            }
                            
                            if (hasLevels && !level.length) {
                                min = max = 0;
                            } else {
                                min = d3_min(level);
                                max = d3_max(level);
                            }
                            
                            var v = dataset.getX(d);
                            x = (stacked ? (bandwidth1(v) + (bandwidth2(commonOption.stackGroupIndex) || 0)) : bandwidth1(v) + bandwidth2(barDatasetIndex + i)) + levelMarkerPadding;
                            y = hasLevels ? (axisrotated ? yscale(mathMin(0, min)) : yscale(mathMax(0, max))) : ((axisrotated && (hasNegValue != null)) ? yscale(hasNegValue) : 0);
                            w = (axisrotated) ? (hasLevels ? (yscale(mathMax(0, max)) - yscale(mathMin(0, min))) : ((hasNegValue != null) ? (plotarea.width - yscale(hasNegValue)) : plotarea.width)) : levelMarkerWidth;
                            h = (axisrotated) ? levelMarkerWidth : (hasLevels ? (yscale(mathMin(0, min)) - yscale(mathMax(0, max))) : ((hasNegValue != null) ? yscale(hasNegValue) : plotarea.height));
                            
                            context.save();
                            context.beginPath();
                            context.fillStyle = getBulletLevelMarkerGradient(d, levelMarker, chartObj, fillColor, levelMarkerColor) || rgba(((isArray(levelMarker.color) ? levelMarker.color[0] : levelMarker.color) || fillColor), levelMarker.fillOpacity);
                            (axisrotated) ? canvasUtils.roundedRect(context, y, x, w, h, borderRadius): canvasUtils.roundedRect(context, x, y, w, h, borderRadius);
                            context.fill();
                            context.closePath();
                            context.restore();
                        }
                    }

                    x = getParamValue("x", d, i, j, commonOption);
                    y = getParamValue("y", d, i, j, commonOption);
                    w = getParamValue("width", d, i, j, commonOption);
                    h = getParamValue("height", d, i, j, commonOption);
                    
                    if (yAxisReversed) {
                        if (axisrotated) {
                            x = x - w
                        } else {
                            y = y - h;
                        }
                    }
                    gradientDim = [w,h];

                    var drawBarFunction = function(context, fillStyle){
                        context.save();
                        context.translate(x, y);
                        context.strokeStyle = rgba(fillColor, fillOpacity);
                        context.fillStyle = fillStyle;
                        if (rounded) {
                            context.beginPath();
                            canvasUtils.roundedRect(context, 0, 0, w, h, borderRadius);
                            context.fill();
                        } else {
                            context.beginPath();
                            context.rect(0, 0, w, h);
                            context.fill();
                        }
                        setBorder(context, borderSize, borderColor || fillColor, dashStyle);
                        context.closePath();
                        context.restore();
                    };

                    if(chartObj.imagePallete){
                        canvas_patterns.imageFill({x:x,y:y,width:w,height:h,context:context,name:chartObj.imagePallete[(multiColoring ? j : index)]},drawBarFunction);
                    }else{
                        var fillStyle;
                        if (hasColorScale && defined(effect)) {
                            fillStyle = effect(getRawColor(chartObj, index, d, index), fillOpacity);
                        } else {
                            fillStyle = defined(effect) ? effect : chart.fillColorFunc((multiColoring ? j : index), d, null, null, fillOpacity,gradientDim,{x:x,y:y,width:w,height:h,context:context}, false);
                        }
                        drawBarFunction(context, fillStyle);
                    }

                });
            });
            
        }
        labelQueue.push({
            "renderer": chart,
            "charttype": "bar",
            "chartObj": chartObj,
            "args": [seriesdata, index]
        });
        
        chart.chartRendered = true;
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    chart.bandwidth1 = function(_) {
        if (!arguments.length) {
            return bandwidth1;
        }
        bandwidth1 = _;
        return chart;
    };
    chart.bandwidth2 = function(_) {
        if (!arguments.length) {
            return bandwidth2;
        }
        bandwidth2 = _;
        return chart;
    };
    chart.barDatasetIndex = function(_) {
        if (!arguments.length) {
            return barDatasetIndex;
        }
        barDatasetIndex = _;
        return chart;
    };

    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    
    function isRounded(radius) {
        for (var l in radius) {
            if (radius.hasOwnProperty(l)) {
                return !!radius[l];
            }
        }
        return false;
    }

    function setBorder(context, size, color, dashStyle) {
        if (size > 0) {
            context.lineWidth = size;
            if (isArray(dashStyle) && dashStyle.length && defined(context.setLineDash)) {
                context.setLineDash(dashStyle);
            }
            context.strokeStyle = color;
            context.stroke();
        }
    }
    return chart;
};