//$Id$
/**
 *
 * @returns {chart} bubblePie.
 */
/*
 PENDING :
 -------
 1) Total datalabel
 2) Annotation at centre / on arc?
 */
svg_plot_renderer.bubblepie = function() {
    var shiftInfo, commonRendererProp,
        redraw = false;
    
    function chart(selection) {
        selection.each(function(data) {
            
            //renderer config values
            var rp = commonRendererProp.params;
            var chartObj = rp.chartObj,
                index = rp.datasetIndex,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                axisrotated = rp.axisrotated,
                stacked = rp.stacked,
                xscale = rp.xscale,
                yscale = rp.yscale,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                labelQueue = rp.labelQueue;
            
            var container = d3_select(this);
            var currentdata = data[index];
            var plotoptions = currentdata.plotoptions;
            var currentseriesdata = currentdata.data;
            
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, "bubblepie");
            var transitionDuration = animationOptions.duration;
            
            var pieData = chartObj.dataObject.bubblepieData,
                pieRenderer = chartObj.subrenderer;
            
            var series = appendEle(container, "g", (pieData ? [1] : []), ".", "class", "scatterseries");
            if (pieData) {
                pieData.forEach(function(piedatum, ssi) {
                    pieRenderer[ssi] = pieRenderer[ssi] || {};
                    var subseries = appendEle(series, "g", [1], ".", "class", ("subseries_" + ssi));
                    var g = subseries.selectAll('g.scatter').data(piedatum, function(d) {
                        return d && dataset.getX(d); // Test_605.json
                    });
                    g.enter().append("g").attr("class", "scatter");
                    g.exit().remove();
                    
                    g.each(function(d, i) {
                        if (!d) { // Test_605.json
                            return;
                        }

                        var dt = d[chartObj.bubblePieRendererIndex]; //chartObj.bubblePieRendererIndex -> For combinational chart, it will help to identify the first bubblepie series
                        var X = dataset.getX(dt);
                        pieRenderer[ssi][X] = (pieRenderer[ssi][X] || svg_plot_renderer.pie())
                            .commonRendererProp(commonRendererProp);
                        var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, dt, "x") || 0,
                            y = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, dt, "y") || 0,
                            size = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, dt, "z", chartObj.zscale);
                        pieRenderer[ssi][X].plotarea({
                            width: size,
                            height: size,
                            left: (x - size / 2),
                            top: (y - size / 2)
                        });
                        pieRenderer[ssi][X].chartRendered = false;
                        d3_select(this)
                            .attr("transform", "translate(" + (x - size / 2) + "," + (y - size / 2) + ")")
                            .call(pieRenderer[ssi][X]);
                    });
                });
            }
            
            chart.renderedTimer = setTimeout(function() {
                redraw = true;
                chart.chartRendered = true;
                
                var seriesData = chartObj.seriesdata;
                seriesData.forEach(function(d, i) {
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "scatter",
                        "chartObj": chartObj,
                        "args": [d, i]
                    });
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "pieInnerLabels",
                        "chartObj": chartObj,
                        "args": [seriesData, i, pieData]
                    });
                });
                
            }, (transitionDuration));
        });
        return chart;
    }
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };

    return chart;
};