/**
 *
 * @param {String} type chart type
 * @param {number} index series index
 */

$ZC.DataProcessor.prototype.getCategories = function(type, index) {

    var processor = this,
        chart = processor.chartObj,
        hierarchical = chart.dataObject.hierarchical,
        categoriesStore = processor.categoriesStore,
        categories;

    if (isObjectPropDefined(chart.systemConf, "chart.zoom." + type + ".categories")) {
        return chart.systemConf.chart.zoom[type].categories;
    }

    if (type === "x") {

        if(defined(hierarchical)) {
            // for time group
            if(hierarchical.groupByTime) {
                if(index > 0) {
                    categories = hierarchical.categoriesList[index - 1];
                } else {
                    // for time grouped bar chart in leaf category return the original categories.
                    categories = hierarchical.groupByDiscreteTime ? processor.xaxisData.categories : hierarchical.leafCategories
                }
            }
            else {
                // normal multi level axis.
                categories = index > 0 ? hierarchical.categoriesList[index - 1] : hierarchical.leafCategories;
            }
        } else {
            categories = processor.xaxisData.categories;
        }
        index = ""; // this will save a condition. see id=1
    } else {
        categories = processor.yaxesData[index].categories;
    }

    if (!defined(categories) || categories.length === 0) {
        categories = categoriesStore[type + index]; // id=1
    }

    if (type === "y" && !categoriesStore["y" + index].enabled) {
        categories = ["NoData", "NoData"]; // Axis is filtered
    }

    return categories;
};
