/**
 *
 * @param cType
 * @returns {boolean}
 */

$ZC.DataProcessor.prototype.isstacked = function(cType) {

    var data = this.data,
        plotoptions = data.chart.plot.plotoptions,
        stackedChart = this.stackedChart,
        helpers = $ZC.DataProcessor.helpers;

    if (defined(cType)) {
        var numType = helpers.getChartType(cType, NUMERIC_DATATYPE);
        cType = helpers.getChartType(cType, "string");
        plotoptions = plotoptions[cType];
        return numType === $ZC.charttype.stkdarea
            || numType === $ZC.charttype.stkdbar
            || numType === $ZC.charttype.bullet
            || cType === "bullet"
            || ( (cType === "bar" || cType === "area" || cType === "web" || cType === "line") && (getPropVal(plotoptions, "stacked.enabled") === true) );
    }

    if (!defined(stackedChart)) {
        var allChartTypes = this.allChartTypes || helpers.getAllChartTypes(data);
        var type = allChartTypes[0];
        this.stackedChart = stackedChart = (allChartTypes.indexOf($ZC.charttype.stkdarea) !== -1) //contains StkdArea
            || (allChartTypes.indexOf($ZC.charttype.stkdbar) !== -1) //contains StkdBar
            || (allChartTypes.indexOf($ZC.charttype.bullet) !== -1) //contains Bullet
            || ( (allChartTypes.indexOf($ZC.charttype.bar) !== -1) && (getPropVal(plotoptions, "bar.stacked.enabled") === true) ) //contains bar + (stacked.enabled = true)
            || ( (allChartTypes.indexOf($ZC.charttype.area) !== -1) && (getPropVal(plotoptions, "area.stacked.enabled") === true) ) //contains area + (stacked.enabled = true)
            || ( (type === $ZC.charttype.web) && (getPropVal(plotoptions, "web.stacked.enabled") === true) ) //contains web + (stacked.enabled = true)
            || ( (type === $ZC.charttype.line) && (getPropVal(plotoptions, "line.stacked.enabled") === true) ) //contains line + (stacked.enabled = true)
    }
    return stackedChart;
};
