
/**
 *
 * @param d
 * @param groupbyDataIndices
 * @param chartType
 * @return {*|Array}
 */

$ZC.DataProcessor.prototype.convertTo3DArray = function(d, groupbyDataIndices, chartType) {

    var curdata = d.data;

    if (groupbyDataIndices.length > 0 && (chartType === $ZC.charttype.bar || chartType === $ZC.charttype.stkdbar)) {
        //Finding unique categories across series

        var groupbyCategories = getDistinctGroupbyCategories(d, groupbyDataIndices),
            distintGroupbyCat = groupbyCategories.distintGroupbyCat,
            allGroupbyCat = groupbyCategories.allGroupbyCat;

        //Grouping data by unique categories across series
        var newSeriesdata = [];
        d.data.forEach(function(d, j) {
            var index = distintGroupbyCat.indexOf(allGroupbyCat[j]);
            if (!newSeriesdata[index]) {
                newSeriesdata[index] = [];
                newSeriesdata[index].push(d);
            } else {
                newSeriesdata[index].push(d);
            }
        });
        curdata = d.data = newSeriesdata;
    }
    // If data is [[]], don't convert to 3D as stacked bar chart throws error on d3.layout.stack().
    // Convert is possible, if data is [] or 2D with data points

    else if ((defined(curdata)) && ((!curdata.length) || ((defined(curdata[0])) && curdata[0].length))) {
        d.data = [];
        d.data.push(curdata);
        curdata = d.data;
    }

    return curdata;
};

/**
 *
 * @param curSeriesdata
 * @param groupbyDataIndices
 * @return {{distintGroupbyCat: Array, allGroupbyCat: Array}}
 */

function getDistinctGroupbyCategories(curSeriesdata, groupbyDataIndices) {
    var distintGroupbyCat = [],
        allGroupbyCat = [];
    curSeriesdata.data.forEach(function(d) {
        var x = groupbyDataIndices.reduce(function(prev, cur) {
            return prev + d[cur]
        }, "");
        allGroupbyCat.push(x)
        if (distintGroupbyCat.indexOf(x) === -1) {
            distintGroupbyCat.push(x)
        }
    });

    return {
        "distintGroupbyCat": distintGroupbyCat,
        "allGroupbyCat": allGroupbyCat
    }
}