/**
 *
 * @param domain
 * @param type
 * @param index
 * @returns {number}
 */

$ZC.DataProcessor.prototype.getCorrectionOverDataLabels = function(domain, type, index) {

    var processor = this,
        chartObj = processor.chartObj,
        xaxisData = processor.xaxisData,
        yaxesData = processor.yaxesData,
        domainCorrections = processor.domainCorrections,
        processedseriesData = processor.processedseriesData,
        groupedDataBySplitAxes = processor.groupedDataBySplitAxes;

    var isXaxis = (type == "x"),
        id = type + (defined(index) ? index : ""),
        axisConf = (isXaxis ? xaxisData : yaxesData[index]),
        customMinval = axisConf.minRange,
        customMaxval = axisConf.maxRange,
        pHeight = chartObj.plotarea.height;
    if (!processor.isStackedPercentChart && !(processor.isBubbleEnabled && !processor.pieWithAxis) && (processor.isAxisCategory || processor.isNonAxisMultiSeriesCategory) && !(customMinval != null && customMaxval != null) && $ZC.labelRenderer && ((domainCorrections.byDatalabels[id] == null) || (pHeight != domainCorrections.plotHeight))) {
        domainCorrections.plotHeight = pHeight;
        var orient = chartObj.axes[type].orient,
            rangeDiff = chartObj.plotarea[(orient == "left") ? "height" : "width"],
            domainDiff = (domain[1] - domain[0]),
            serData = isXaxis ? processedseriesData : groupedDataBySplitAxes[index],
            maxFontSize = (serData != null) ? getDataLabelsSize(type, serData, chartObj) : 0; //stacked bar + line chart, throws error when filtering all the bar series
        domainCorrections.byDatalabels[id] = (domainDiff / (rangeDiff - maxFontSize)) * maxFontSize;
    }
    return (domainCorrections.byDatalabels[id] || 0);
};