
/**
 *
 * @param param
 * @param d
 * @param i
 * @param j
 * @param cp
 * @param radius
 * @param yrangePos
 * @returns {*}
 */

$ZC.DataProcessor.prototype.getTransRectValue = function(param, d, i, j, cp, radius, yrangePos) {

    var dataset = this.dataset,
        helpers = $ZC.DataProcessor.helpers,
        priorityBasedValue = helpers.priorityBasedValue

    var isYRange = cp && dataset.getY(d, cp.yaxiscolumnorder) instanceof Array;
    var minRange = cp && (cp.yscale.range()[0] + cp.addRangeBand(cp.yscale)),
        maxRange = cp && cp.yscale.range()[1];
    switch (param) {
        case "x":
            if (cp.axisrotated) {
                yrangePos = (isYRange) ? 0 : null;
                var curY = dataset.getY(d, cp.yaxiscolumnorder, yrangePos);
                return (cp.yscale.rangeExtent) ?
                    cp.yscale.rangeExtent()[0] :
                    ((cp.stacked ? cp.yscale(mathMin(d.y0, (d.y + d.y0))) :
                        (yrangePos != null) ? cp.yscale(curY) :
                            cp.yscale((cp.hasNegValue != null) ? ((curY < cp.hasNegValue) ? curY : cp.hasNegValue) : cp.yscale.domain()[0])));
            }

            var v = dataset.getX(d);
            return ((cp.stacked ? cp.bandwidth1(v) + cp.bandwidth2(cp.stackGroupIndex) : cp.bandwidth1(v) + cp.bandwidth2(cp.barDatasetIndex + i)) + cp.padding);
        case "y":
            if (cp.axisrotated) {
                var v = dataset.getX(d);
                return (cp.stacked ? cp.bandwidth1(v) + cp.bandwidth2(cp.stackGroupIndex) : cp.bandwidth1(v) + cp.bandwidth2(cp.barDatasetIndex + i)) + cp.padding;
            }
            yrangePos = (yrangePos != null) ? yrangePos : ((isYRange) ? 1 : null);
            var curY = dataset.getY(d, cp.yaxiscolumnorder, yrangePos);
            return (cp.stacked ? cp.yscale(mathMax(d.y0, (d.y + d.y0))) + cp.addRangeBand(cp.yscale) :
                (cp.yscale((cp.yscale.rangeBand == null) ? mathMax(cp.hasNegValue || 0, curY) : curY) + cp.addRangeBand(cp.yscale)));
        case "width":
            if (cp.axisrotated) {
                var basevalue = cp.hasNegValue == null ? (isYRange) ? cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, 0)) :
                    minRange :
                    cp.yscale(cp.hasNegValue);
                yrangePos = (isYRange) ? 1 : null;
                var curY = cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, yrangePos));
                return (cp.yscale.rangeExtent) ?
                    curY + cp.addRangeBand(cp.yscale) :
                    ((cp.stacked) ? (mathAbs(cp.yscale(d.y + d.y0) - cp.yscale(d.y0))) + cp.addRangeBand(cp.yscale) :
                        (mathAbs((maxRange - basevalue) - (maxRange - curY)) || 0) + cp.addRangeBand(cp.yscale));
            }
            return cp.barWidth;
        case "height":
            if (cp.axisrotated) {
                return cp.barWidth;
            }
            var basevalue = cp.hasNegValue != null ? cp.yscale(cp.hasNegValue) : (isYRange && !cp.stacked) ? cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, 0)) :
                minRange
            yrangePos = (isYRange) ? 1 : null;
            var curY = cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, yrangePos));
            return cp.stacked ? mathAbs(((basevalue) - cp.yscale(d.y + d.y0)) - ((basevalue) - cp.yscale(d.y0))) + cp.addRangeBand(cp.yscale) :
                mathAbs(basevalue - curY) + cp.addRangeBand(cp.yscale);
        case "radius": {
            var parsedVal = {}
            var splittedStr = (radius != null) ? radius.toString().split("/") : null
            var rx = (splittedStr != null && splittedStr[0] != null) ? splittedStr[0].split(" ") : [],
                ry = (splittedStr != null && splittedStr[1] != null) ? splittedStr[1].split(" ") : rx;
            /*
             * index 0-->topleft,  1-->topright,  2-->bottomright,  3-->bottomleft
             */
            parsedVal.tlx = pInt(priorityBasedValue([rx[0]]))
            parsedVal.tly = pInt(priorityBasedValue([ry[0], rx[0]]))

            parsedVal.trx = pInt(priorityBasedValue([rx[1], rx[0]]))
            parsedVal.trY = pInt(priorityBasedValue([ry[1], ry[0], rx[1], rx[0]]))

            parsedVal.brx = pInt(priorityBasedValue([rx[2], rx[0]]))
            parsedVal.bry = pInt(priorityBasedValue([ry[2], ry[0], rx[2], rx[0]]))

            parsedVal.blx = pInt(priorityBasedValue([rx[3], rx[1], rx[0]]))
            parsedVal.bly = pInt(priorityBasedValue([ry[3], ry[1], rx[3], rx[0]]))

            return parsedVal
        }
    }
};