/**
 *
 * @param axisrotated
 * @param stacked
 * @param xscale
 * @param yscale
 * @param yaxiscolumnorder
 * @param d
 * @param type
 * @param zscale
 * @param yrangePos
 * @returns {*}
 */

$ZC.DataProcessor.prototype.getXYvalue = function(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, type, zscale, yrangePos) {

    var model = this,
        yaxesData = this.yaxesData,
        dataset = this.dataset;

    if (model.isPolarAxisCategory) {
        var baseIdx = (yaxesData[yaxiscolumnorder].reversed && !stacked) ? yscale.domain().length - 1 : 0;
        var a = xscale(dataset.getX(d)),
            r = stacked ?
                yscale(d.y + d.y0) :
                (yscale(dataset.getY(d, yaxiscolumnorder)) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
        r = mathMax(r, yscale.range()[baseIdx]);
        var xy = polarToXY(r, a);
        return (type === "x") ? xy[0] : xy[1];
    }
    switch (type) {
        case "x":
            if (axisrotated) {
                return (stacked) ? yscale(d.y + d.y0) : (yscale(dataset.getY(d, yaxiscolumnorder, yrangePos)) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
            }
            return xscale(dataset.getX(d)) + ((xscale.rangeBand != null) ? xscale.rangeBand() / 2 : 0);
        case "y":
            if (axisrotated) {
                return xscale(dataset.getX(d)) + ((xscale.rangeBand != null) ? xscale.rangeBand() / 2 : 0);
            }
            return (stacked) ? yscale(d.y + d.y0) : (yscale(dataset.getY(d, yaxiscolumnorder, yrangePos)) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
        case "z":
            return zscale(dataset.getZ(d) || zscale.domain()[0]);

    }
};
