;

/**
 *
 * @param correctionFactor
 * @returns {[number,number]}
 */

$ZC.DataProcessor.prototype.getMinMaxX = function(correctionFactor) {

    var processor = this,
        xAxisConfig = processor.xaxisData,
        seriesData = processor.processedseriesData,
        chart = processor.chartObj,
        dataSet = processor.dataset,
        customMin = xAxisConfig.minRange,
        customMax = xAxisConfig.maxRange,
        dataType = dataSet.getDataType("x"),
        temp,
        extendX = processor.xRange;

    correctionFactor = pick(correctionFactor, 0.05);

    // if zoom range is defined, use it by default.
    if (isObjectPropDefined(chart.systemConf, "chart.zoom.x")) {
        xRange = chart.systemConf.chart.zoom.x;
        return [xRange.minRange, xRange.maxRange];
    }

    if (!defined(extendX)) {
        temp = seriesData.map(function(d) {
            return d.data.map(function(d) {
                return (d3_extent(d, function(d) {
                    return dataSet.getX(d)
                }));
            });
        });

        var xAxis = pick(getPropVal(chart.userdata, "chart.axes.xaxis"), {});
        extendX = processor.xRange = d3_extent(d3_merge(d3_merge(temp)).concat(processor.getThresholdValues(xAxis)));
    }


    if (processor.isBubbleEnabled && dataType !== TIME_DATATYPE && !defined(customMin) && !defined(customMax)) {
        temp = processor.overBubbles(extendX, "x");
        extendX = [extendX[0] - temp[0], extendX[1] + temp[1]]
    }

    var correctionOverDatalabels = 0, diff, correction;

    // no need to find correction datalabel,if correction factor is 0
    if (dataType !== TIME_DATATYPE && correctionFactor !== 0) {
        correctionOverDatalabels = processor.getCorrectionOverDataLabels(extendX, "x");
    }

    diff = (extendX[1] - extendX[0]);

    if (diff === 0) {
        diff = 1;
    }

    correction = (diff * correctionFactor) + correctionOverDatalabels;
    return [pick(customMin, extendX[0] - correction, 0), pick(customMax, extendX[1] + correction, 0)];
};
