/**
 *
 * @param extentY
 * @returns {*}
 */

$ZC.DataProcessor.prototype.overLevelMarker = function(extentY) {

    var context = this,
        helpers = $ZC.DataProcessor.helpers,
        qualitativeRanges = context.qualitativeRanges,
        processedseriesData = context.processedseriesData,
        chartName = helpers.getChartType((context.processedseriesData[0].type || context.globalChartType), "string"),
        conf = context.data.chart.plot.plotoptions[chartName],
        levelMarker = conf.levelMarker,
        targetMarker = conf.targetMarker,
        levelMarkerIndex,
        targetMarkerIndex;


    if (!defined(qualitativeRanges)) {

        qualitativeRanges = context.qualitativeRanges = [];

        processedseriesData.forEach(function(series) {
            var plotOptions = series.plotoptions || {};

            levelMarker = mergeJSON(levelMarker, plotOptions.levelMarker);
            targetMarker = mergeJSON(targetMarker, plotOptions.targetMarker);

            levelMarkerIndex = levelMarker.dataindex;
            targetMarkerIndex = targetMarker.dataindex;

            if ((levelMarker.enabled || targetMarker.enabled)) {

                if ((levelMarkerIndex || targetMarkerIndex)) {
                    series.data.forEach(function(subSeries) {
                        subSeries.forEach(function(point) {


                            if (targetMarker.enabled && defined(point[targetMarkerIndex])) {
                                qualitativeRanges.push(point[targetMarkerIndex]);
                            }

                            if (levelMarker.enabled &&defined(point[levelMarkerIndex])) {
                                // in bullet chart data comes in array
                                if (isArray(point[levelMarkerIndex])) {
                                    qualitativeRanges = qualitativeRanges.concat(point[levelMarkerIndex]);
                                } else {
                                    qualitativeRanges.push(point[levelMarkerIndex]);
                                }
                            }
                        })
                    })
                } else if (levelMarker.enabled && defined(levelMarker.values)) {
                    qualitativeRanges = qualitativeRanges.concat(levelMarker.values);
                }
            }
        })
    }

    if (isNaN(qualitativeRanges[1] - qualitativeRanges[0]) && !this.hasLevelMarker) {
        return extentY;
    }

    return d3.extent(d3.merge([qualitativeRanges, extentY, [0]]));
};