

$ZC.DataProcessor.prototype.storeCategories = function(curdata, stacked, groupbyDataIndices, chartType, actXdatatype, yDatatype, yaxiscolumnorder) {

    var processor = this,
        dataset = processor.dataset,
        categoriesStore = processor.categoriesStore,
        XCat = categoriesStore.x,
        yCat = categoriesStore["y" + yaxiscolumnorder],
        helpers = $ZC.DataProcessor.helpers;

    var isCatNullX = helpers.isCatNull(dataset, "x"),
        isCatNullY = helpers.isCatNull(dataset, "y", yaxiscolumnorder);

    if (stacked) {
        curdata.map(function(subgroup, j) {
            if (!curdata.disabled && isArray(subgroup)) {
                return subgroup.map(function(dataPoint) {
                    var xVal = dataset.getX(dataPoint);
                    var groupByVal = (groupbyDataIndices.length > 0) ? dataset.getGroupByValues(dataPoint, groupbyDataIndices) : null;

                    if (xVal > processor.lastCategoryValue && !processor.needXCategoriesSorting) {
                        processor.lastCategoryValue = xVal
                    } else if (!processor.needXCategoriesSorting && XCat.indexOf(xVal) == -1) {
                        processor.needXCategoriesSorting = true;
                    }

                    (!isCatNullX(xVal) && XCat.indexOf(xVal) == -1) ? XCat.push(xVal) : null;

                    if (groupByVal != null) {
                        subgroup.groupByVal = groupByVal;
                        dataPoint.groupByVal = groupByVal;
                        (categoriesStore.subseries.indexOf(groupByVal) == -1) ? categoriesStore.subseries.push(groupByVal) : null;
                    }

                })
            }
        })
    }

    else if ((actXdatatype === ORDINAL_DATATYPE) || (yDatatype === ORDINAL_DATATYPE)) {
        curdata.map(function(subgroup, j) {
            if (!curdata.disabled && isArray(subgroup)) {
                return subgroup.map(function(dataPoint) {
                    var xVal = dataset.getActualX(dataPoint),
                        yVal = dataset.getY(dataPoint, yaxiscolumnorder);
                    if (actXdatatype === ORDINAL_DATATYPE && !isCatNullX(xVal)) {
                        (XCat.indexOf(xVal) === -1) ? XCat.push(xVal) : null;
                    }
                    if (yDatatype === ORDINAL_DATATYPE) {
                        if (chartType === $ZC.charttype.arearange || chartType === $ZC.charttype.gantt) {
                            (defined(yVal) && yCat.indexOf(yVal[0]) === -1) ? yCat.push(yVal[0]) : null;
                            (defined(yVal) && yCat.indexOf(yVal[1]) === -1) ? yCat.push(yVal[1]) : null;
                        } else {
                            (!isCatNullY(yVal) && yCat.indexOf(yVal) === -1) ? yCat.push((yVal)) : null;
                        }
                    }
                })
            }
        })
    }
};
