//$Id$
$ZC.defaultTheme = function(userProp) {
    //userProp for getting fontSize wrt chartObj not globally
    
    var defaulttheme = {
        "canvas": {
            "fontFamily": $ZCG.globalProp.fontL1Family, //Note: import font to your application if it is not supported by the browser.
            "fontColor": $ZCG.globalProp.fontL1Color,
            "fontSize": userProp.fontL1Size.l3,
            "fontWeight": $ZCG.globalProp.fontL1Weight, //normal || bold || bolder || lighter || 100 || 200 || 300 || 400 || 500 || 600 || 700 || 800 || 900
            "fontStyle": $ZCG.globalProp.fontL1Style, //normal || italic || oblique
            
            "title": {
                "show": true,
                "text": "Title comes here",
                "hAlign": "left",
                "vAlign": "top",
                "marginTop": 10,
                "marginRight": 0,
                "marginBottom": 0,
                "marginLeft": 10,
                "fontSize": userProp.fontL1Size.l1
            },
            "subtitle": {
                "show": true,
                "text": "Description comes here",
                "hAlign": "left",
                "vAlign": "top",
                "marginTop": 0,
                "marginRight": 0,
                "marginBottom": 0,
                "marginLeft": 10,
                "fontSize": userProp.fontL1Size.l2
            },
            "background": {
                "alpha": 1,
                "color": "#FFFFFF"
            },
            
            "border": {
                "show": true,
                "size": 1,
                "style": "solid",
                "radius": 1,
                "color": "#cccccc"
            },
            
            "shadow": {
                "show": true,
                "x": 1,
                "y": 1,
                "color": "rgba(0,0,0,0.1)",
                "blur": 2,
                "inset": false
            },
            "intelligence": {
                "dimension": {
                    "title": 100, // 0 or null -> don't remove
                    "subtitle": 120, // 0 or null -> don't remove
                    "xaxis": 70, // 0 or null -> don't remove
                    "xaxislabel": 80,
                    "yaxis": 70, // 0 or null -> don't remove
                    "yaxislabel": 80,
                    "legend": 140, // 0 or null -> don't remove
                    "credits": 150, // 0 or null -> don't remove
                    "marker": 50
                },
                "dataCount": {
                    "marker": 300, //null -> don't remove
                    "animation": 300, //null -> don't remove
                    "datalabels": 300 //null -> don't remove
                }
            }
        },
        "legend": {
            "enabled": true,
            "colorPallete": {
                "type": "multicolor", //muticolor || monochrome
                "options": {
                    "multicolor": "countries",
                    "monochrome": {
                        "baseColor": "red",
                        "count": 5,
                        "colorGamma": [0.3, 0.9]
                    }
                }
            },
            "hAlign": "right", //left, right, center
            "vAlign": "center", //top, center, bottom.
            "fontSize": userProp.fontL1Size.l5,
            "textPadding": 5,
            "itemMargin": 3,
            "marginTop": 10,
            "marginRight": 10,
            "marginBottom": 10,
            "marginLeft": 10,
            "colorBox": {
                "shape": "square", //square,circle,diamond,bean,butterfly,clover,cloverFour,cross,ellipse,heart,triangle-up,triangle-down,arrow,rocket,malteseCross,asterisk,gear
                "strokeWidth": 2
            },
            "colorBand": {

            },
            "title": {
                "show": false,
                "text": "Legend",
                "fontSize": userProp.fontL1Size.l4
            },
            "background": {
                "color": "transparent",
                "alpha": 0
            },
            "border": {
                "show": true,
                "size": 1,
                "style": "solid",
                "radius": 0,
                "color": "transparent"
            },
            "itemDisabledStyle": {
                //css properties except margin alignment and visibility properties
                "color": "#d1d1d1",
                "strikeout": false
            },
            "shadow": {
                "show": false,
                "color": "rgba(0,0,0,0.3)",
                "x": 2,
                "y": 2,
                "blur": 3,
                "inset": false
            },
            "filter": {
                "enabled": true
            },
            "highlightEffect": {
                "selectedSeries": null, //diagonalPattern,circlePattern,crossStripes,horizontalStripes,strokeEnlarge
                "unselectedSeries": "none" //fadeOut || blur || grayscale || saturate || none
            },
            "expandable": {
                "fontSize": userProp.fontL1Size.l5
            }
        },
        "chart": {
            "marginTop": 10,
            "marginRight": 10,
            "marginBottom": 10,
            "marginLeft": 10,
            "fontSize": userProp.fontL2Size.l3,
            "zoom":{
                "type":"none"
            },
            "effects": {
                "choice": "auto", //Choices: auto, dropShadow, chalk, freehand
                "options": {
                    "dropShadow": {
                        "dx": "5",
                        "dy": "5",
                        "blur": "3",
                        "color": "rgba(0,0,0,0.6)"
                    },
                    "freeHand": {
                        "scale": 7
                    }
                }
            },
            "plot": {
                "renderer": { // this option is under development
                    "mode": "svg",
                    "image": {
                        "source": "auto", // auto | <any url>
                        "addDimensionInSource": false, // paramas are plotWidth & plotHeight
                        "exportUrl": ""
                    }
                    
                },
                "background": {
                    "alpha": 1,
                    "color": "transparent",
                    "gradients": {
                        "show": false,
                        "type": "radial"
                    }
                },
                "border": {
                    "show": false,
                    "size": 1,
                    "style": "solid", //solid, shortdash, shortdot, shortdashdotdot, dotted, dashed, longdash, dashdot, longdashdot, longdashdotdot
                    "radius": 0,
                    "color": "#ececec"
                },
                "animation": {
                    "enabled": $ZCG.globalProp.animation.enabled,
                    "easingType": $ZCG.globalProp.animation.easingType,
                    "duration": $ZCG.globalProp.animation.duration
                },
                "datalabels": {
                    "show": $ZCG.globalProp.datalabels.enabled,
                    "handleOverlapping": true,
                    "fontSize": userProp.datalabels.fontSize.l5,
                    "boundBox": {
                        "strokeColor": $ZCG.fontColor,
                        "fillColor": "white"
                    }
                },
                "events": {
                    "cursor": null,
                    "click": $ZCG.globalProp.events.click, // On click on the plot, user function can be binded, el and event will be passed
                    "mousemove": $ZCG.globalProp.events.mouseMove, // on hovering the plot, user function can be binded, el and event will be passed
                    "mouseout": $ZCG.globalProp.events.mouseOut, //on mouseout the plot, user function can be binded, el and event will be passed
                    "doubleclick": $ZCG.globalProp.events.doubleClick, //on mouseout the plot, user function can be binded, el and event will be passed
                    "contextmenu": null, // right click event
                    "init": null,
                    "onload": null
                },
                "plotoptions": {}
            },
            "axes": {
                "xaxis": {
                    "show": true,
                    "label": {
                        "show": true,
                        "text": "Xaxis",
                        "fontSize": userProp.fontL2Size.l4,
                        "marginTop": 5,
                        "marginRight": 5,
                        "marginBottom": 5,
                        "marginLeft": 5
                    },
                    "grid": {
                        "show":true,
                        "color": "transparent",
                        "strokeWidth": null
                    },
                    "ticklabel": {
                        "rotation": 0, // auto,0,45,60,90
                        "textOverflow": "ellipsis", // none,ellipsis,hidden
                        "fontSize": userProp.fontL2Size.l5,
                        "zigzag":false
                    },
                    "tickmark": {
                        "strokeWidth": null,
                        "color": "#ececec",
                        "size": 3
                    },
                    "axisline": {
                        "show": true,
                        "color": "#ececec",
                        "strokeWidth": null,
                        "style": "solid"
                    },
                    "baseline": {
                        "show": false,
                        "value": 10,
                        "color": "black"
                    },
                    "threshold": {
                        "line": {
                            "show": false,
                            "values": [],
                            "label": {
                                "text": ["Description comes here"],
                                "fontSize": userProp.fontL2Size.l5
                            },
                            "marker": {
                                "enabled": true
                            }
                            
                        },
                        "coloroverlay": {
                            "show": false,
                            "values": [],
                            "overlayRange": "below"
                        },
                        "range": {
                            "show": false,
                            "values": [],
                            "label": {
                                "text": ["Description comes here"],
                                "fontSize": userProp.fontL2Size.l5
                            }
                        }
                        
                    }
                },
                "yaxis": [{
                    "show": true,
                    "label": {
                        "show": true,
                        "text": "Yaxis",
                        "fontSize": userProp.fontL2Size.l4,
                        "marginTop": 5,
                        "marginRight": 5,
                        "marginBottom": 5,
                        "marginLeft": 5
                    },
                    "grid": {
                        "show":true,
                        "color": "#ececec"
                    },
                    "ticklabel": {
                        "textOverflow": "ellipsis", // none,ellipsis,hidden
                        "fontSize": userProp.fontL2Size.l5,
                        "rotation": 0
                    },
                    "tickmark": {
                        "color": "#ececec",
                        "size": 3
                    },
                    "subtickmark": {
                        "color": "#ececec",
                        "size": 5,
                        "count": 0
                    },
                    "axisline": {
                        "show": true,
                        "color": "#ececec",
                        "strokeWidth": null,
                        "style": "solid"
                    },
                    "baseline": {
                        "show": false,
                        "value": 0,
                        "color": "grey",
                        "strokeWidth": null
                    },
                    "threshold": {
                        "line": {
                            "show": false,
                            "values": [],
                            "label": {
                                "text": ["Description comes here"],
                                "fontSize": userProp.fontL2Size.l5
                            },
                            "marker": {
                                "enabled": true
                            }
                            
                        },
                        "coloroverlay": {
                            "show": false,
                            "values": [],
                            "overlayRange": "below"
                        },
                        "range": {
                            "show": false,
                            "values": [],
                            "label": {
                                "text": ["Description comes here"],
                                "fontSize": userProp.fontL2Size.l5
                            }
                        }
                    }
                    
                }]
                
            }
            
        },
        "tooltip": {
            "enabled": true,
            "fontSize": userProp.fontL1Size.l5,
            "opacity": 0.8,
            "zindex": 2000,
            "view": "normal", //normal | column
            "crosshair": {
                "type": "none",
                "color": "grey"
            }
        },
        "noDataHandler": {
            "text": "No Data",
            "fontSize": userProp.fontL1Size.l1
        },
        "loader": {
            "type": "none", //zBlocks, zBars, zCircle1, zCircle2, zCrossBars, wheel, snake
            "fontSize": userProp.fontL1Size.l3
        }
    };
    return defaulttheme;
};

$ZC.getDefaultOptions = function(type, source, userProp) {
    var options;
    switch (type) {
        case 'zoom':
            options = {
                "type": "none", // none, x, y, xy
                "resetButton": {
                    "fillColor": "grey",
                    "label": {
                        "text": "Reset Zoom",
                        "marginTop": 5,
                        "marginRight": 5,
                        "marginBottom": 5,
                        "marginLeft": 5,
                        "fontSize": userProp.fontL2Size.l5
                    },
                    "border": {
                        "show": true,
                        "size": 1,
                        "radius": 6,
                        "color": "#cccccc"
                    },
                    "shadow": {
                        "show": false,
                        "dx": 1,
                        "dy": 1,
                        "color": "#cccccc",
                        "blur": 1
                    }
                },
                "selectionArea": {
                    "fillColor": "grey",
                    "fillOpacity": 0.4
                }
            };
            break;
        case 'scroll':
            //To implement NAVIGATOR later
            options = {
                "enabled": true,
                "categoryThickness": null,
                "visibleCategories": null,
                "height": 10,
                "slider": {
                    "fillOpacity": 0.3,
                    "strokeColor": "black"
                }
            };
            break;
        case "legend":
            options = {};
            break;
        
        case "credits":
            options = {
                "enabled": false,
                "imageWidth": 150,
                "imageHeight": 50,
                "hAlign": "right", //left, center, "right"
                "vAlign": "bottom", //top, middle, bottom
                "text": "Zoho Reports",
                "target": "newtab", //newtab || newwindow || null
                "marginTop": 0,
                "marginRight": 10,
                "marginBottom": 10,
                "marginLeft": 0,
                "fontSize": userProp.fontL1Size.l4
            };
            break;
        
        case "notes":
            options = {
                "enabled": false,
                "chartValues": [
                    //example
                    //                      {
                    //                        "text": "notesText",
                    //                        "x": 0,
                    //                        "y": "50%"
                    //                      }
                ],
                "plotValues": [
                    //single series bar example data
                    //                              {
                    //                                 "data": [2010,57],
                    //                                 "text": "High value"
                    //                             }
                    //multiseries area,stacked area,line,scatter example data
                    //                             {
                    //                                 "data": [1356978600000,6,"West"],
                    //                                 "text": "High value"
                    //                             }
                ],
                "blockValues": [
                    //  {
                    //    "htmlEl": "Annotate here",
                    //    "hAlign": "center",
                    //    "vAlign": "bottom",
                    //    "type" : "customNote"
                    // }
                ],
                "type": "stickyNote", //stickyNote || customNote
                "options": {
                    "stickyNote": {
                        "headWidth": 15,
                        "headHeight": 15,
                        "bodyWidth": 100,
                        "bodyHeight": 100,
                        "fontSize": userProp.fontL1Size.l5,
                        "color": ["#F0F8FF", "#FFE4C4", "#DCDCDC", "#ADFF2F", "#90EE90", "#87CEFA", "#FFC0CB", "#B0E0E6", "#D2B48C", "#D8BFD8", "#EE82EE", "#F5DEB3"],
                        "mode": "close", //open || close
                        "border": "1px solid grey"
                    },
                    "customNote": {
                        "fontSize": userProp.fontL1Size.l5
                    }
                }
            };
            break;
        
        case "bar":
            options = {
                "outerPadding": 0.04,
                "fillOpacity": 0.9,
                "maxBandWidth": 200,
                "multiColoring": false,
                "border": {
                    "show": false,
                    "size": null,
                    "style": "solid",
                    "radius": 0,
                    "color": null
                },
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "levelMarker": {
                    "enabled": false,
                    "color": ["#d8d8d8"],
                    "fillOpacity": 0.9
                },
                "datalabels": {
                    "showAs": "y", //x,y,percent
                    "stackLabels": {
                        "show": false,
                        "showAs": "y" //y,percent
                    }
                },
                "animation": {
                    "type": "verticalAll" //verticalAll || vertical
                },
                "gradients": { //linear || none
                    "options": {
                        "linear": {
                            "y2": 50
                        }
                    }
                }
            };
            break;
        
        case "line":
            options = {
                "mode": "linear", //linear,step-before,step-after,cardinal
                "strokeWidth": 2,
                "outerPadding": 0.02,
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "marker": {
                    "enabled": true,
                    "innerStrokeWidth": 2,
                    "outerFillColor": "transparent",
                    "outerStrokeColor": "transparent"
                },
                "hoveroptions": {
                    "innerStrokeWidth": 2,
                    "outerFillOpacity": 0.5,
                    "outerStrokeOpacity": 0.1
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "animation": {
                    "type": "strokeTween", //strokeTween,horiPathTween,vertPathTween,pointbypoint,pointTween
                    "marquee": {
                        "enabled": false,
                        "duration": 300
                    },
                    "blink": {
                        "enabled": false,
                        "type": "twinkle", //twinkle | fade
                        "duration": 400
                    }
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 10,
                            "spreadMethod": "reflect" // pad || repeat || reflect
                        }
                    }
                }
            };
            break;
        case "area":
            options = {
                "strokeOpacity": 0.5,
                "outerPadding": 0.02,
                "fillOpacity": 0.4,
                "mode": "linear", //linear,step-before,step-after,cardinal
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "marker": {
                    "enabled": false,
                    "outerFillColor": "transparent",
                    "outerStrokeOpacity": 0.5,
                    "size": 1 //1,2....
                },
                "hoveroptions": {
                    "innerStrokeWidth": 2,
                    "outerFillOpacity": 0.5,
                    "outerStrokeOpacity": 0.1
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 50
                        }
                    }
                },
                "animation": {
                    "type": "vertPathTweenAll", //horiPathTween || vertPathTween || vertPathTweenAll || pointTween
                    "marquee": {
                        "enabled": false,
                        "duration": 300
                    },
                    "blink": {
                        "enabled": false,
                        "type": "twinkle", //twinkle | fade
                        "duration": 400
                    }
                }
            };
            break;
        case "arearange":
            options = {
                "strokeOpacity": 0.5,
                "outerPadding": 0.02,
                "fillOpacity": 0.4,
                "mode": "linear", //linear,step-before,step-after,cardinal
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "marker": {
                    "enabled": false,
                    "outerFillColor": "transparent",
                    "outerStrokeOpacity": 0.5,
                    "size": 1 //1,2....
                },
                "hoveroptions": {
                    "innerStrokeWidth": 2,
                    "outerFillOpacity": 0.5,
                    "outerStrokeOpacity": 0.1
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 50
                        }
                    }
                },
                "animation": {
                    "type": "vertPathTweenAll", //horiPathTween || vertPathTween || vertPathTweenAll || pointTween
                    "marquee": {
                        "enabled": false,
                        "duration": 300
                    },
                    "blink": {
                        "enabled": false,
                        "type": "twinkle", //twinkle | fade
                        "duration": 400
                    }
                }
            };
            break;
        case "scatter":
            options = {
                "outerPadding": 0.02,
                "multiColoring": false,
                "marker": {
                    "size": 1,
                    "innerFillColor": "white",
                    "innerStrokeColor": "white",
                    "innerStrokeWidth": 0,
                    "innerStrokeOpacity": 1,
                    "outerFillColor": "white",
                    "outerStrokeOpacity": 1,
                    "outerStrokeWidth": 2
                },
                "hoveroptions": {
                    "innerStrokeOpacity": 1,
                    "outerFillColor": "white",
                    "outerStrokeWidth": 2
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "animation": {
                    "type": "allseries" //onebyone || seriesbyseries || allseries || fade || fadeAll
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "y2": 100,
                            "gradientUnits": "userSpaceOnUse", //objectBoundingBox || userSpaceOnUse
                            "colorGamma": [2, 0]
                        },
                        "radial": {
                            "radius": 90,
                            "colorGamma": [2, 0]
                        }
                    }
                }
            };
            break;
        case "bubblepie":
        case "pie":
            options = {
                "startAngle": 0,
                "endAngle": 2 * mathPI,
                "innerRadius": 0,
                "outerPadding": 10,
                "datalabels": {
                    "type": "circular", // circular || doubleside
                    "padding": 5,
                    "line": {
                        "strokeColor": "grey",
                        "strokeWidth": 0.3
                    },
                    "innerLabel": {
                        "show": false,
                        "showAs": "percent" //x,y,percent
                    }
                },
                "animation": {
                    "type": "fanAll" //inner, wheel, fanAll, fanonebyone , inneronebyone
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "x2": 15,
                            "spreadMethod": "repeat", // pad || repeat || reflect
                            "gradientUnits": "userSpaceOnUse" //objectBoundingBox || userSpaceOnUse
                        },
                        "radial": {
                            "radius": 90
                        }
                    }
                },
                "models": {
                    "count": 50
                }
            };
            if (type == "bubblepie") {
                options.strokeColor = "transparent";
                options.outerPadding = 0.02;
                options.datalabels.showAs = "percent"; //x,y,percent
                options.hoveroptions = {
                    "innerFillColor": "transparent",
                    "innerStrokeColor": "transparent",
                    "outerFillColor": "transparent",
                    "outerStrokeWidth": 3
                };
            } else {
                options.strokeColor = "white";
                options.sliceOutHeight = 5;
                options.maxRadius = 250;
                options.datalabels.showAs = "x"; //x,y,percent
            }
            break;
        
        case "funnel":
            options = {
                "weighted": "height", //height | width | none
                "split": false,
                "canOverlap": true,
                "threeDimension": true,
                "outerPadding": "2%",
                "stemHeight": "20%",
                "stemWidth": "20%",
                "coneWidth": "100%",
                "strokeColor": "transparent",
                "emptyFunnel": {
                    "show": false,
                    "color": "#FAFAFA"
                },
                "datalabels": {
                    "showAs": "x", //x,y,percent
                    "type": "strokeddoubleside", // singleside || doubleside || strokeddoubleside
                    "padding": 30,
                    "line": {
                        "strokeColor": "grey",
                        "strokeWidth": 0.3
                    },
                    "innerLabel": {
                        "show": false,
                        "showAs": "percent" //x,y,percent
                    }
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 50,
                            "spreadMethod": "reflect", // pad || repeat || reflect
                            "colorGamma": [0.6, 0]
                        }
                    }
                },
                "animation": {
                    "type": "vertical" //horizontalAll, verticalAll, vertical
                }
            };
            break;
        
        case "web":
            options = {
                "fillOpacity": 0.5,
                "strokeWidth": 2,
                "mode": "linear-closed", //linear-closed || cardinal-closed
                "outerPadding": 10,
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "marker": {
                    "enabled": true,
                    "innerStrokeOpacity": 1,
                    "outerFillColor": "white"
                },
                "hoveroptions": {
                    "innerStrokeWidth": 2,
                    "innerStrokeOpacity": 1,
                    "outerFillColor": "white"
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "animation": {
                    "type": "strokeTween", //strokeTween , pathTween , pointbypointTween , fade
                    "marquee": {
                        "enabled": false,
                        "duration": 300
                    },
                    "blink": {
                        "enabled": false,
                        "type": "twinkle", //twinkle | fade
                        "duration": 400
                    }
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "x2": 15,
                            "spreadMethod": "repeat", // pad || repeat || reflect
                            "gradientUnits": "userSpaceOnUse" //objectBoundingBox || userSpaceOnUse
                        },
                        "radial": {
                            "radius": 90,
                            "x": 0,
                            "y": 0
                        }
                    }
                }
            };
            break;
        
        case "pyramid":
            options = {
                "threeDimension": true,
                "strokeColor": "black",
                "strokeWidth": null,
                "strokeOpacity": 0.5,
                "fillOpacity": 0.8,
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 50,
                            "spreadMethod": "reflect", // pad || repeat || reflect
                            "colorGamma": [0.8, 0]
                        }
                    }
                },
                "datalabels": {
                    "showAs": "y", //x,y,percent
                    "type": "singleside", // singleside || doubleside || strokeddoubleside
                    "padding": 10,
                    "relativeX": true,
                    "line": {
                        "strokeColor": "grey",
                        "strokeWidth": 0.3
                    },
                    "innerLabel": {
                        "show": false,
                        "showAs": "percent" //x,y,percent
                    }
                },
                "animation": {
                    "type": "vertical" //vertical || verticalAll
                }
            };
            break;
        case "sunburst":
            options = {
                "strokeColor": "white",
                "innerRadius": 30,
                "outerPadding": 20,
                "animation": {
                    "type": "fan" //fan, inner, wheel
                },
                "datalabels": {
                    "showAs": "y", //x,y,percent
                    "type": "circular", // circular || doubleside
                    "padding": 10,
                    "line": {
                        "strokeColor": "grey",
                        "strokeWidth": 0.3
                    },
                    "innerLabel": {
                        "show": false,
                        "showAs": "percent", //x,y,percent
                        "parentLabel": {
                            "show": false
                        }
                    }
                }
            };
            break;
        
        case "dial":
            options = {
                "startAngle": -mathPI / 2,
                "endAngle": mathPI / 2,
                "innerRadius": "65%",
                "maxRadius": 500,
                "outerPadding": 20,
                "padding": 0,
                "strokeColor": "rgba(0,0,0,0.1)",
                "animation": {
                    "type": "fanAll" //fanAll
                },
                "needle": {
                    "show": true,
                    "type": "round", //clock || round || sharp
                    "strokeColor": "black",
                    "fillColor": "grey",
                    "width": 15,
                    "padding": 15
                },
                "minmaxlabels": {
                    "show": true,
                    "fontSize": userProp.datalabels.fontSize.l5
                },
                "datalabels": {
                    "show": true,
                    "showAs": "y", //x,y,percent
                    "padding": 2
                },
                "levelMarker": {
                    "enabled": true,
                    "strokeColor": "rgba(0,0,0,0.1)",
                    // "color" : ["#d1d1d1"],
                    "innerPadding": 0,
                    "outerPadding": 0,
                    "colorGamma": [0.3, 0.9]
                },
                "targetMarker": {
                    "outerStrokeWidth": 3,
                    "symbol": "line",
                    "innerFillOpacity": 0,
                    "innerStrokeOpacity": 0,
                    "outerFillColor": "grey",
                    "outerStrokeColor": "#000"
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "x2": 2,
                            "y2": 2,
                            "spreadMethod": "repeat", // pad || repeat || reflect
                            "gradientUnits": "userSpaceOnUse" //objectBoundingBox || userSpaceOnUse
                        },
                        "radial": {
                            "radius": 16.5,
                            "spreadMethod": "reflect" // pad || repeat || reflect
                        }
                    }
                },
                "events": {
                    "enabled": false
                }
            };
            break;
        case "bubble":
            options = {
                "outerPadding": 0.02,
                "multiColoring": false,
                "marker": {
                    "innerFillOpacity": 0,
                    "innerStrokeWidth": 0,
                    "innerStrokeOpacity": 0,
                    "outerFillOpacity": 0.4,
                    "outerStrokeOpacity": 1
                },
                "hoveroptions": {
                    "innerFillColor": "transparent",
                    "innerStrokeColor": "transparent",
                    "innerStrokeOpacity": 1,
                    "innerStrokeWidth": 0,
                    "outerFillOpacity": 0.3,
                    "outerStrokeOpacity": 0.5
                },
                "datalabels": {
                    "showAs": "y" //x,y,z,percent
                },
                "animation": {
                    "type": "sizing" //sizing || onebyone || seriesbyseries || allseries || fade || fadeAll || verticalAll
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "y2": 100,
                            "gradientUnits": "userSpaceOnUse", //objectBoundingBox || userSpaceOnUse
                            "colorGamma": [1.5, 0]
                        },
                        "radial": {
                            "radius": 90,
                            "colorGamma": [1.5, 0]
                        }
                    }
                }
            };
            break;
        
        case "packedbubble":
            options = {
                "fillOpacity": 0.2,
                "outerPadding": 5,
                "animation": {
                    "type": "sizing" //sizing | fade | fadeAll
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                }
            };
            break;
        case "bullet":
            options = {
                "outerPadding": 0,
                "levelMarker": {
                    "enabled": true,
                    "dataindex": 2,
                    "color": [],
                    "colorGamma": [0.3, 0.9],
                    "fillOpacity": 0.9,
                    "maxBandWidth": 200
                },
                "targetMarker": {
                    "enabled": true,
                    "dataindex": 3,
                    "symbol": "line",
                    "innerFillColor": "transparent",
                    "innerStrokeColor": "transparent",
                    "innerStrokeWidth": 0,
                    "innerStrokeOpacity": 0,
                    "outerFillColor": "rgba(0, 0, 0, 0.6)",
                    "outerStrokeOpacity": 1,
                    "outerStrokeWidth": 5,
                    "outerStrokeColor": "rgba(0, 0, 0, 0.6)",
                    "label": {
                        "fontSize": userProp.datalabels.fontSize.l5
                    }
                },
                "animation": {
                    "type": "verticalAll"
                },
                "datalabels": {
                    "textOverlap": "none",
                    "showAs": "y", //x,y,percent
                    "stackLabels": {
                        "show": false,
                        "showAs": "y" //y,percent
                    }
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "y2": 50
                        }
                    }
                }
            };
            break;
        case "gantt":
            options = {
                "outerPadding": 0.04,
                "padding": 0,
                "interPadding": 0.05,
                "maxBandWidth": 200,
                "levelMarker": {
                    "enabled": false,
                    "dataindex": 2,
                    "fillOpacity": 0.3,
                    "bandWidth": 4
                },
                "hoveroptions": {
                    "enabled": false,
                    "start": {
                        "innerStrokeOpacity": 1,
                        "outerFillColor": "white",
                        "outerStrokeWidth": 2
                    },
                    "end": {
                        "innerStrokeOpacity": 1,
                        "outerFillColor": "white",
                        "outerStrokeWidth": 2
                    }
                },
                "marker": {
                    "enabled": false,
                    "start": {
                        "size": 1,
                        "innerStrokeWidth": 0,
                        "outerStrokeWidth": 2
                    },
                    "end": {
                        "size": 1,
                        "innerStrokeWidth": 0,
                        "outerStrokeWidth": 2
                    }
                },
                "border": {
                    "show": false,
                    "size": null,
                    "style": "solid",
                    "radius": 0,
                    "color": null
                },
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "animation": {
                    "type": "verticalAll"
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "y2": 50
                        }
                    }
                },
                "dependency": {
                    "enabled": false,
                    "targetIndex": 0,
                    "link": {
                        "type": "ES",
                        "strokeWidth": 2,
                        "strokeColor": "#111111",
                        "errorStyle": "red",
                        "padding": 20
                    },
                    "marker": {
                        "enabled": true,
                        "padding": 10,
                        "size": 1.5,
                        "innerFillColor": "transparent",
                        "innerStrokeWidth": 0,
                        "innerStrokeOpacity": 0,
                        "outerStrokeOpacity": 0,
                        "outerStrokeColor": "red",
                        "outerFillColor": "blue"
                    }
                }
            };
            break;
        case "treemap":
            options = {
                "strokeColor": "rgba(255,255,255,0.7)",
                "animation": {
                },
                "datalabels": {
                    "showAs": "y"
                }
            };
            break;
        case "heatmap":
            options = {
                "strokeColor": "white",
                "animation": {
                },
                "datalabels": {
                    "showAs": "y"
                },
                "legendHighlightEffect": {
                    "selectedSeries": "tinyHatchfill"
                },
                "gradients": { //linear | radial | none
                    "options": {
                        "linear": {
                            "y2": 100
                        },
                        "radial": {
                            "radius": 100
                        }
                    }
                }
            };
            break;
        case "dotgrid":
            options = {
                "fillOpacity": 0.2,
                "outerPadding": 0.2,
                "animation": {
                    "type":"grid"
                },
                "datalabels": {
                    "showAs": "x" //x,y,percent
                }
            };
            break;
        case "metadata":
            options = {
                "axes": {
                    "x": [0],
                    "y": [
                        [1]
                    ],
                    "tooltip": [0, 1]
                },
                "columns": [{
                    "dataindex": 0,
                    "columnname": "",
                    "datatype": "numeric"
                }, {
                    "dataindex": 1,
                    "columnname": "",
                    "datatype": "numeric"
                }]
            };
            break;
        
    }
    return options;
};

$ZC.setDefaultOptions = function(type, source , userProp, options, dontFetchDefault){
    if(!dontFetchDefault){
        //or To fetch default options from above
        options = $ZC.getDefaultOptions(type,source,userProp);
    }
    var dest = (source[type] == null) ? source[type] = {} : source[type];
    mergeJSON(options, dest, true, true);
    source[type] = options;
    return options;
}