//$Id$
(function(root) {
    // "use strict";
    var $ZC = {};
    $ZC.version = "1.0.8";
    $ZC.versionName = "Euclid";
    $ZC.d3Version = "3.4.8";
    /*
     * Initiate  functions
     */
    $ZC.model = function() {};
    $ZC.axis = function() {};
    $ZC.legend = function() {};
    $ZC.renderer = function() {};
    $ZC.dataset = function() {};
    $ZC.scale = function() {};
    $ZC.events = function() {};
    $ZC.plot = function() {};
    $ZC.plot.canvas = function() {};
    /*
     * Constants
     */
    $ZC.charttype = {};
    var line = $ZC.charttype.line = 11,
        pie = $ZC.charttype.pie = 8,
        bar = $ZC.charttype.bar = 9,
        stkdbar = $ZC.charttype.stkdbar = 10,
        scatter = $ZC.charttype.scatter = 12,
        area = $ZC.charttype.area = 14,
        stkdarea = $ZC.charttype.stkdarea = 15,
        bubble = $ZC.charttype.bubble = 20,
        packedbubble = $ZC.charttype.packedbubble = 19,
        funnel = $ZC.charttype.funnel = 7,
        web = $ZC.charttype.web = 16,
        sunburst = $ZC.charttype.sunburst = 17,
        pyramid = $ZC.charttype.pyramid = 13,
        dial = $ZC.charttype.dial = 18,
        bullet = $ZC.charttype.bullet = 6,
        arearange = $ZC.charttype.arearange = 21,
        bubblepie = $ZC.charttype.bubblepie = 5,
        gantt = $ZC.charttype.gantt = 24,
        treemap = $ZC.charttype.treemap = 4,
        heatmap = $ZC.charttype.heatmap = 3,
        dotgrid = $ZC.charttype.dotgrid = 26;
    $ZC.charttypenames = d3.map();
    $ZC.charttypenames.set($ZC.charttype.line, "line");
    $ZC.charttypenames.set($ZC.charttype.pie, "pie");
    $ZC.charttypenames.set($ZC.charttype.bar, "bar");
    $ZC.charttypenames.set($ZC.charttype.stkdbar, "bar");
    $ZC.charttypenames.set($ZC.charttype.scatter, "scatter");
    $ZC.charttypenames.set($ZC.charttype.area, "area");
    $ZC.charttypenames.set($ZC.charttype.funnel, "funnel");
    $ZC.charttypenames.set($ZC.charttype.web, "web");
    $ZC.charttypenames.set($ZC.charttype.stkdarea, "area");
    $ZC.charttypenames.set($ZC.charttype.sunburst, "sunburst");
    $ZC.charttypenames.set($ZC.charttype.pyramid, "pyramid");
    $ZC.charttypenames.set($ZC.charttype.bubble, "bubble");
    $ZC.charttypenames.set($ZC.charttype.dial, "dial");
    $ZC.charttypenames.set($ZC.charttype.packedbubble, "packedbubble");
    $ZC.charttypenames.set($ZC.charttype.bullet, "bullet");
    $ZC.charttypenames.set($ZC.charttype.arearange, "arearange");
    $ZC.charttypenames.set($ZC.charttype.gantt, "gantt");
    $ZC.charttypenames.set($ZC.charttype.bubblepie, "bubblepie");
    $ZC.charttypenames.set($ZC.charttype.treemap, "treemap");
    $ZC.charttypenames.set($ZC.charttype.heatmap, "heatmap");
    $ZC.charttypenames.set($ZC.charttype.dotgrid, "dotgrid");

    //ALLOWED CHARTS
    $ZC.chartcategory = {};
    $ZC.chartcategory.axis = [line, area, scatter, stkdarea, bar, stkdbar, bubble, bullet, arearange, bubblepie, gantt, heatmap];
    $ZC.chartcategory.nonaxis = [pie, funnel, pyramid, dial, dotgrid];
    $ZC.chartcategory.nonaxismultiseries = [web, sunburst, packedbubble, treemap];
    $ZC.chartcategory.hierarchy = [packedbubble,sunburst, treemap];
    $ZC.chartcategory.continous = [line, area, scatter, stkdarea,bubble,arearange,bubblepie];
    $ZC.chartcategory.discrete = [pie, bar, stkdbar, sunburst,funnel,pyramid,dial, bullet, gantt, heatmap];
    $ZC.chartcategory.dotPlot = [scatter, bubble];
    $ZC.chartcategory.piePlot = [pie, bubblepie];

    //The main object can be renamed by calling this method by passing a customized object name.
    $ZC.rename = function(newObjName) {
        if (newObjName != null && newObjName != "" && typeof newObjName === 'string') {
            root[newObjName] = $ZC;
            root.$ZC = null;
            delete root.$ZC;
            return true; // renamed successfully
        }
        return false; // rename failed.
    };
    
    $ZC.setLegendColorPallete = function(name, value) {
        $ZC.legutil.colorpallete.set(name, value);
    };
    
    $ZC.getLegendColorPallete = function(name) {
        return $ZC.legutil.colorpallete.get(name);
    };
    
    $ZC.setLegendPatternPallete = function(name, value) {
        $ZC.legutil.patternPallete.set(name, value);
    };
    
    $ZC.getLegendPatternPallete = function(name) {
        return $ZC.legutil.patternPallete.get(name);
    };

    $ZC.setLegendImagePallete = function(name, value) {
        $ZC.legutil.imagePallete.set(name, value);
    };
    
    $ZC.getLegendImagePallete = function(name) {
        return $ZC.legutil.imagePallete.get(name);
    };
    
    $ZC.setTheme = function(name, value) {
        $ZC[name] = value;
    };
    
    $ZC.getTheme = function(name) {
        return $ZC[name];
    };
    
    /**
     * Common functions and variables
     */
    
    var svg_plot_renderer = {},
        renderer_helpers = {},
        dataLabel_handler = {},
        datalabelsBoundBox_handler = {},
        patternPalleteTemplates = {};
    
    
    // constants
    var CUSTOM_VALUE_PATTERN = /\{\{val\((\d+)\)\}\}|\{\{col\((\d+)\)\}\}|\{\{per\((\d+)\)\}\}|\{\{splitper\((\d+)\)\}\}|\{\{clr\}\}/gi, // regxr
        RGBA_PATTERN = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/i,
        PERCENT_PATTERN = /\{\{per\((\d+)\)\}\}|\{\{splitper\((\d+)\)\}\}/gi,
        Console = window.console,
        tempCanvasContext = document.createElement("canvas").getContext("2d");
