// zc constant functions and variables;

var UNDEFINED,
    math = Math,
    mathRound = math.round,
    mathFloor = math.floor,
    mathCeil = math.ceil,
    mathMax = math.max,
    mathMin = math.min,
    mathAbs = math.abs,
    mathPow = math.pow,
    mathSQRT = math.sqrt,
    mathCos = math.cos,
    mathSin = math.sin,
    mathLog = math.log,
    mathTan = math.tan,
    mathAtan2 = math.atan2,
    mathLN10 = math.LN10,
    mathPI = math.PI,
    mathPI2 = mathPI * 2,
    deg2rad = mathPI * 2 / 360,
    MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991,
    
    PX = 'px ',
    NONE = 'none',
    STROKE_WIDTH = 'stroke-width',
    TRANSPARENT = "transparent",
    BASE_HELPER_CONTAINER = null,
    CURRENT_CHART_COUNT = 0,
    BASE_CONTAINER_POSITION = -9999;


/**
 * Shortcut for parseInt
 * @param {Object} s
 * @param {Number} mag Magnitude
 */
function pInt(s, mag) {
    return parseInt(s, mag || 10);
}

/**
 * Check for string
 * @param {Object} s
 */
function isString(s) {
    return typeof s === 'string';
}

/**
 * Check for object
 * @param {Object} obj
 */
function isObject(obj) {
    return obj && typeof obj === 'object';
}

/**
 * Check for array
 * @param {Object} obj
 */
function isArray(obj) {
    if(Array.isArray) {
        return Array.isArray(obj)
    }
    return !!obj && obj.constructor === Array;
    // return Object.prototype.toString.call(obj) === '[object Array]';
}

/**
 * Check for number
 * @param {Object} n
 */
var isNumber = function isNumber(n) {
    return typeof n === 'number' && !isNaN(n);
};

/**
 *
 * @param {Function|*}object
 * @returns {boolean}
 */

function isFunction(object) {
    return !!(object && object.constructor && object.call && object.apply);
}

function jsonStringify(obj) {
    if (defined(obj)) {
        return JSON.stringify(obj);
    }
    return UNDEFINED;
}

var tempCanvasContext = document.createElement("canvas").getContext("2d");