//$Id$
/* Default global prop */
/*$ZCG stands for ZohoChartsGlobal object
 All global properties and methods are set here.
 */
var $ZCG = {};
$ZCG.fontFamily = "'Roboto','Open Sans',sans-serif";
$ZCG.fontColor = "#616161";
$ZCG.fontStyle = null;
$ZCG.fontWeight = null;
$ZCG.fontL1Size = null;
$ZCG.fontL2Size = null;
$ZCG.fontL3Size = null;

function calculateGlobalFontSize(userdata, globalFontSize, chartFontSize, denominator) {
    var props = toArray(arguments).slice(4),
        temp = null,
        fontSize;

    for (var i = 0, len = props.length; i < len + 1; i++) {
        fontSize = (i === len) ? null : getPropVal(userdata, props[i]);
        temp = calcfontSize(denominator, null, fontSize, globalFontSize, chartFontSize);
        if (isNumber(fontSize)) {
            break;
        }
    }
    return temp;
}

function setGlobalPropByUserdata(userdata, denominator, chartProp) {
    
    // denominator is an object. It contains {"width": chart_width, "height": chart_height}
    
    $ZCG.globalProp = {};
    
    //font size
    chartProp.fontL1Size = calculateGlobalFontSize(userdata, $ZCG.fontL1Size, chartProp.fontL1Size, denominator, "canvas.fontSize");
    chartProp.fontL2Size = calculateGlobalFontSize(userdata, $ZCG.fontL2Size, chartProp.fontL2Size, denominator, "chart.fontSize", "canvas.fontSize");
    
    //font color
    $ZCG.globalProp.fontL1Color = null;
    $ZCG.globalProp.fontL2Color = null;
    
    //font family
    $ZCG.globalProp.fontL1Family = null;
    $ZCG.globalProp.fontL2Family = null;
    
    //font style
    $ZCG.globalProp.fontL1Style = null;
    $ZCG.globalProp.fontL2Style = null;
    
    //font weight
    $ZCG.globalProp.fontL1Weight = null;
    $ZCG.globalProp.fontL2Weight = null;
    
    //text shadow
    $ZCG.globalProp.textShadow = null;
    
    //animation
    var userAnimation = pick(getPropVal(userdata, "chart.plot.animation"), {});

    $ZCG.globalProp.animation = {};
    $ZCG.globalProp.animation.enabled = userAnimation.enabled !== false;
    $ZCG.globalProp.animation.duration = userAnimation.duration || null;
    $ZCG.globalProp.animation.easingType = userAnimation.easingType || null;
    
    //datalabels
    $ZCG.globalProp.datalabels = {}
    chartProp.datalabels = (chartProp.datalabels == null) ? {} : chartProp.datalabels;
    $ZCG.globalProp.datalabels.enabled = null
    chartProp.datalabels.fontSize = calculateGlobalFontSize(userdata, $ZCG.fontL3Size, chartProp.datalabels.fontSize,
        denominator, "chart.plot.datalabels.fontSize", "chart.fontSize", "canvas.fontSize");

    $ZCG.globalProp.datalabels.fontColor = null
    $ZCG.globalProp.datalabels.fontFamily = null
    $ZCG.globalProp.datalabels.fontStyle = null
    $ZCG.globalProp.datalabels.fontWeight = null
    
    //events
    $ZCG.globalProp.events = {}
    $ZCG.globalProp.events.mouseMove = null
    $ZCG.globalProp.events.mouseOut = null
    $ZCG.globalProp.events.click = null
    $ZCG.globalProp.events.doubleClick = null
    
    return chartProp;
}

/*
 * font size are calculated based on viewport of the chart placeholder.
 * L1 to L5 sizes are defined, based on the width and height which ever is minimum, the font-size is set.
 * */
function calcfontSize(dimension, multiplier, customFontSize, globalFontSize, chartFontProp) {
    
    var denominator = mathMin(dimension.width, dimension.height);
    var globalMultiplier = isObjectPropDefined($ZC, "fontProperties.ratio") && $ZC.fontProperties.ratio;
    if (typeof globalMultiplier === "function") {
        globalMultiplier = globalMultiplier(dimension);
    }
    multiplier = (multiplier == null) ?
        globalMultiplier && !isNaN(globalMultiplier) ? globalMultiplier : 0.038 :
        multiplier;
    
    var defaultSize = mathRound(denominator * multiplier);
    
    $ZCG.minL1Size = $ZC.fontProperties.minsize;
    $ZCG.maxL1Size = $ZC.fontProperties.maxsize;
    var min = $ZCG.minL1Size,
        max = $ZCG.maxL1Size;
    var fontSize = {}
    defaultSize = (defaultSize < min) ? min : (defaultSize > max) ? max : defaultSize;
    
    
    if (customFontSize != null) {
        multiplier = (pInt(customFontSize) * multiplier) / defaultSize;
        defaultSize = mathRound(denominator * multiplier);
        defaultSize = (defaultSize < min) ? min : (defaultSize > max) ? max : defaultSize;
    }
    var chartFontProp = (globalFontSize == null) ? (chartFontProp == null) ? {} : chartFontProp : globalFontSize;
    chartFontProp.size = defaultSize;
    chartFontProp.l1 = function() {
        return chartFontProp.size;
    }
    chartFontProp.l2 = function() {
        return chartFontProp.size - 2;
    }
    chartFontProp.l3 = function() {
        return chartFontProp.size - 3;
    }
    chartFontProp.l4 = function() {
        return chartFontProp.size - 4;
    }
    chartFontProp.l5 = function() {
        return chartFontProp.size - 5;
    }
    
    return chartFontProp;
}

/*Helpful for Developement
 * defining DOMBorder will show you the area division lines in the chart
 * */
$ZCG.DOMBorder = "none";

var $Browser = new function() {
    this.NETSCAPE = 0;
    this.FIREFOX = 0;
    this.OPERA = 0;
    this.IE = 0;
    this.SAFARI = 0;
    this.MOZILA = 0;
    this.CHROME = 0;
    this.NONIE = 1;
    this.WEBKIT = 0;
    var agent = navigator.userAgent.toLowerCase();
    this.OSX = (agent.indexOf('mac') != -1);
    this.LINUX = (agent.indexOf('linux') != -1);
    this.IPHONE = ((agent.indexOf('iphone') != -1));
    this.IPAD = ((agent.indexOf('ipad') != -1));
    this.ANDROID = (agent.indexOf("android") != -1);
    this.IS_IOS = (this.IPHONE || this.IPAD);
    this.isTouchDevice = ("ontouchstart" in window) || (navigator.maxTouchPoints > 0) || (navigator.msMaxTouchPoints > 0);
    this.isMouseDevice = !(this.IS_IOS || this.ANDROID || (agent.indexOf('mobile') != -1));
    this.uiwebview = this.IS_IOS && !/safari/.test(agent);
    var prefix = "";
    this.detect = function() {
        var agent = navigator.userAgent;
        var uaLen = agent.length;
        var vendor = navigator.vendor;
        var operaObject = window.opera;
        var versionSub = "";
        if (operaObject) {
            this.OPERA = 1;
            prefix = "o";
        } else if (agent.indexOf("Chrome") > -1) {
            this.CHROME = 1;
            versionSub = "Chrome/";
            prefix = "webkit";
        } else if (agent.indexOf("Firefox") > -1) {
            this.FIREFOX = 1;
            versionSub = "Firefox/";
            prefix = "moz";
        } else if (agent.indexOf("MSIE ") > -1 || agent.indexOf("Trident/") > -1) {
            this.IE = 1;
            versionSub = "MSIE ";
            prefix = "ms";
        } else if (vendor.indexOf("Apple") > -1) {
            this.SAFARI = 1;
            versionSub = "Version/";
            prefix = "webkit";
        } else {
            versionSub = "Unknown Browser";
        }
        this.VERSION = agent.substring(agent.indexOf(versionSub), uaLen).match(/[0-9\.]+/)[0];
    };
    this.detect();
    this.NONIE = !this.IE;
    this.WEBKIT = (this.SAFARI || this.CHROME);
    this.prefix = {
        lowercase: prefix,
        css: (prefix) ? '-' + prefix + '-' : prefix, //prefix = "" if browser is unknown
        js: (prefix) ? prefix[0].toUpperCase() + prefix.substr(1) : prefix //prefix = "" if browser is unknown
    }
};