//$Id$
/**
 *
 * @returns {chart} dial chart renderer.
 */
/*
 * PENDING:-
 * If target label is overlapping with minmax label
 * Pre render target
 */
svg_plot_renderer.dial = function() {
    var commonRendererProp, chartObj, innerRadius, color, isredraw = false,
        commonPlotOptions, dataset, yaxiscolumnorder,
        totalEngagement, plotarea_approx,
        systemconf, yscale, oldData, minMax,
        levelmarkerClr = [],
        hasNegValue,
        hasPreviousNegValue,
        previousRadiusFactors,
        previousOuterRadius,
        previousInnerRadius,
        currentRadiusFactors,
        arc;
    var pie = svg_plot_renderer.pie();
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                dataset = rp.dataset,
                yaxiscolumnorder = rp.yaxiscolumnorder;
            systemconf = chartObj.systemConf;

            var plotoptions = data[0].plotoptions;
            totalEngagement = dataset.getY(data[0].data[0][0], yaxiscolumnorder);
            hasPreviousNegValue = hasNegValue;
            hasNegValue = (totalEngagement < 0);
            var defsLocation = chartObj.defsLocation;
            var labelQueue = rp.labelQueue;
            var index = 0;
            
            yscale = chartObj.axes.y.groups[0].scale;
            minMax = yscale.domain();
            plotarea_approx = chartObj.plotarea_approx;

            commonPlotOptions = plotoptions ? mergeJSON(commonPlotOptions, plotoptions, true) : commonPlotOptions;
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, "dial");
            var isAnimationEnable = animationOptions.enabled,
                easingType = animationOptions.easingType,
                transitionDuration = isredraw ? (isAnimationEnable ? 200 : 0) : animationOptions.duration;
            
            var container = d3_select(this).data(createDataForPie(data));
            oldData = container.selectAll("path.dial").data();
            
            var levelMarkerConf = commonPlotOptions.levelMarker;
            currentRadiusFactors = commonPlotOptions.innerRadius + " _ " + commonPlotOptions.outerPadding + " _ " + commonPlotOptions.maxRadius + " _ " + commonPlotOptions.bandWidth + " _ " + levelMarkerConf.bandWidth + " _ " + levelMarkerConf.innerPadding + " _ " + levelMarkerConf.outerPadding;
            var OR = plotarea_approx.radius,
                levelmarkerSW = validateNullVal(levelMarkerConf.strokeWidth, 1),
                visibility;
            
            var stacked = true;
            var IR = getInnerRadius(commonPlotOptions, OR);
                arc = d3_arc()
                    .endAngle(function(d) {
                        return yscale(d[1]);
                    });
            if (stacked) {
                var innerPadding,
                    outerPadding;

                if (defined(levelMarkerConf.bandWidth) || defined(levelMarkerConf.maxBandWidth)) {
                    var maxLevelMarkerBandWidth = validateNullVal(levelMarkerConf.maxBandWidth, OR);
                    var levelMarkerBandWidth = Math.min(perToPx(levelMarkerConf.bandWidth, OR, (OR - IR)), maxLevelMarkerBandWidth);

                    innerPadding = ((OR -  IR) - levelMarkerBandWidth) / 2,
                    outerPadding = ((OR -  IR) - levelMarkerBandWidth) / 2;

                    visibility = (levelMarkerBandWidth === 0) ? "hidden" : null;
                } else {
                    innerPadding = mathMax(0, perToPx(levelMarkerConf.innerPadding, OR, 0)),
                    outerPadding = mathMax(0, perToPx(levelMarkerConf.outerPadding, OR, 0));
                }

                arc
                    .innerRadius(IR + innerPadding)
                    .outerRadius(OR - outerPadding - (0.5 * levelmarkerSW))
                    .startAngle(function(d) {
                        return yscale(d[0]);
                    });
            } else {
                var interPadding = perToPx(levelMarkerConf.interPadding, OR, 10),
                    len = data[0].data[0].length;
                var band = ((OR - IR) - ((len - 1) * interPadding)) / len;
                arc
                    .innerRadius(function(d, i) {
                        return (i * (band + interPadding)) + IR;
                    })
                    .outerRadius(function(d, i) {
                        return ((i + 1) * band) + (i * interPadding) + IR;
                    })
                    .startAngle(commonPlotOptions.startAngle);
            }
            var levelmarkerSeries = appendEle(container, "g", [1], ".", "class", "levelmarkerSeries");
            var levelmarker = appendEle(levelmarkerSeries, "path", (levelMarkerConf.enabled ? genLevels(data, levelMarkerConf) : []));
            levelmarker
                .attr("transform", "translate(" + plotarea_approx.x + "," + plotarea_approx.y + ")")
                .style({
                    "stroke": function(d, i) {
                        return levelMarkerConf.strokeColor || levelmarkerClr[i];
                    },
                    "stroke-width": levelmarkerSW,
                    "stroke-opacity": levelMarkerConf.strokeOpacity,
                    "fill-opacity": levelMarkerConf.fillOpacity,
                    "fill": function(d, i) {
                        var clr = levelmarkerClr[i];
                        var prop = getGradientProp(commonPlotOptions.gradients,[OR, OR],clr);
                        var gradientID = (prop) ? effects.get(svg_gradients,"svgGradientFill", prop, {"offset":"pie"}) : null;
                        return gradientID ? "url(" + defsLocation + "#" + gradientID + ")" : clr;
                    },
                    "visibility" : visibility
                });

            if (isredraw && (currentRadiusFactors != previousRadiusFactors)) {
                levelmarker
                    .transition()
                    .duration(transitionDuration)
                    .ease("linear")
                    .call(function(element){
                        arcInnerTween(element, arc, [previousInnerRadius, arc.innerRadius()()], [previousOuterRadius, arc.outerRadius()()]);
                    });
            } else {
                levelmarker
                    .attr("d", arc);
            }
            
            // add event listeners for dial level marker
            dialChartEventHandler(chartObj, levelmarker, levelMarkerConf, "levelmarker", data);
            
            commonRendererProp.commonPlotOptions(commonPlotOptions);
            pie.commonRendererProp(commonRendererProp);
            pie.chartRendered = false;
            container.call(pie);
            
            innerRadius = pie.innerRadius();
            
            // Target marker---
            var targetMarkerSeries = appendEle(container, "g", [1], ".", "class", "targetSeries");
            svg_plot_renderer.dial.targetMarker(targetMarkerSeries, plotarea_approx.actualRadius, plotarea_approx.innerRadius, chartObj)
            targetMarkerSeries
                .attr("transform", "translate(" + plotarea_approx.x + "," + plotarea_approx.y + ")");
            // ---Target marker
            
            var dialPath = appendEle(container, "path", (commonPlotOptions.needle.show ? [totalEngagement] : []), ".", "class", "dial");
            dialPath
                .attr("d", getNeedlePath())
                .style({
                    "stroke": commonPlotOptions.needle.strokeColor || "black",
                    "stroke-width": commonPlotOptions.needle.strokeWidth,
                    "fill": commonPlotOptions.needle.fillColor || "none"
                })
                .transition()
                .duration(transitionDuration)
                .ease(easingType)
                .call(dialTween);
            
            if ($ZC.labelRenderer) {
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "dial",
                    "chartObj": chartObj,
                    "args": [data, 0]
                });
            }
            
        });
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.endFunctions = function() {
        previousRadiusFactors = currentRadiusFactors;
        previousOuterRadius = arc.outerRadius()();
        previousInnerRadius = arc.innerRadius()();
        chart.chartRendered = true;
        isredraw = true;
    };
    
    function createDataForPie(data) {
        var dt = data[0].data[0];
        data[0].data[0] = [dt[0]];
        return [data];
    }
    
    function genLevels(data, levelMarkerConf) {
        var levels = [],
            dt = data[0].data[0];
        var origValues = dt[0][levelMarkerConf.dataindex] || levelMarkerConf.values || [],
            clr = levelMarkerConf.color;
        if (!(origValues instanceof Array)) {
            origValues = [origValues];
        }

        if (clr === undefined && origValues.length <= 1) {
            clr = ["#d1d1d1"];
        }
        
        if (origValues.length > 0) {
            var thValues = origValues.slice(0);
            if (!clr) { //If colors are not specified, create monochrome colors
                var baseClr = color[0],
                    domain = [0, thValues.length - 1],
                    range = [levelMarkerConf.colorGamma[0], levelMarkerConf.colorGamma[1]];
                var monoClrGen = getMonochromeColor(baseClr, domain, range);
            }
            thValues.sort(d3_ascending);
            var prev = minMax[0];
            thValues.forEach(function(d, i) {
                var thIdx = origValues.indexOf(d);
                var currentValue = Math.min( Math.max(d, minMax[0]), minMax[1] );
                levels[i] = [prev, currentValue];
                levelmarkerClr[i] = !clr ? monoClrGen(i) : clr[thIdx]; //if clr is null, monochrome colors will be applied using 'i', else user specified color is picked up using 'thIdx'
                prev = currentValue;
            });
        } else {
            dt.forEach(function(d, i) {
                levels[i] = minMax;
                levelmarkerClr[i] = ((clr instanceof Array) ? clr[i] : clr) || "#d1d1d1";
            });
        }
        return levels;
    }
    
    function getNeedlePath() {
        var needleConf = commonPlotOptions.needle;
        var wid = pick(needleConf.width / 2, 7),
            IR = -perToPx(needleConf.innerRadius, plotarea_approx.radius, 0),
            OR = -perToPx(needleConf.radius, plotarea_approx.radius, innerRadius) + needleConf.padding,
            minNeedleHeight = -3 * wid;

        OR = mathMin(OR, minNeedleHeight);

        switch (needleConf.type) {
            case "clock":
                return "M" + wid + " " + IR + " A" + wid + " " + wid + " 0 0 1 " + (-wid) + " " + IR + " A" + wid + " " + wid + " 0 0 1 " + wid + " " + IR + " " + "M0 " + (IR - wid) + " L0 " + OR + " M" + (-wid) + " " + (wid + OR) + " L0 " + OR + " L" + wid + " " + (wid + OR) + " L0 " + OR;
            case "sharp":
                return "M" + wid + " " + IR + " L" + 0 + " " + (IR + wid) + " L" + (-wid) + " " + IR + " L0 " + OR + " L" + wid + " " + IR;
            default:
                return "M" + wid + " " + IR + " A" + wid + " " + wid + " 0 0 1 " + (-wid) + " " + IR + " L0" + " " + OR + " L" + wid + " " + IR;
        }
    }
    
    function dialTween(element) {
        var cx = plotarea_approx.x,
            cy = plotarea_approx.y,
            baseValue = (commonPlotOptions.baseValue !== undefined) ? commonPlotOptions.baseValue : 0,
            currentValue,
            previousValue,
            currentAngle,
            previousAngle;

        element.attrTween("transform", function(d, i) {
            if (isredraw) {
                previousAngle = d3.transform(d3.select(this).attr("transform")).rotate;
            } else {
                previousValue = hasNegValue ? minMax[1] : minMax[0];
                if (baseValue != null) {
                    previousValue = hasNegValue
                        ? mathMin(baseValue, previousValue)
                        : mathMax(baseValue, previousValue);
                }
                previousAngle = radianToDegree( yscale(previousValue) );
            }

            currentValue = mathMin( mathMax(d, minMax[0]), minMax[1]); //currentValue should be in between min & max
            var currentAngle = radianToDegree( yscale(currentValue) );

            var interpolateAngle = d3_interpolate(previousAngle, currentAngle);
            return function(t) {
                return "translate(" + cx + "," + cy + ") rotate(" + interpolateAngle(t) + ",0,0)"
            };
        });
    }
    
    return chart;
};

svg_plot_renderer.dial.targetMarker = function(container, OR, innerRadius, chartObj) {
    var systemconf = chartObj.systemConf,
        commonPlotOptions = systemconf.chart.plot.plotoptions.dial,
        dataset = chartObj.dataset,
        index = 0;
    
    var yscale = chartObj.axes.y.groups[0].scale,
        minMax = yscale.domain(),
        data = chartObj.seriesdata;
    var targetMarkerOptions = commonPlotOptions.targetMarker;
    var align = targetMarkerOptions.align,
        dAlign = targetMarkerOptions.dAlign,
        padding = +(targetMarkerOptions.padding || 0),
        symbol_rotation = /line/.test(targetMarkerOptions.symbol) ? 90 : 0; //For line symbol, the symbol should be rotated by 90 degree
    
    var default_size = (!/(outer|inner)/g.test(align) && /line/.test(targetMarkerOptions.symbol)) ? ((OR - innerRadius - (2 * padding)) / 10) : 1;
    var size = validateNullVal(targetMarkerOptions.size, default_size) * 10;
    var extraOptions = {
        symbolSize: {
            outer: 1,
            inner: 0.5
        },
        color: chartObj.seriesColor[0],
        strokeWidth: default_size
    };
    var dr = (dAlign === "outer") // dr - shift along radius
        ?
        (size / 2) + padding :
        ((dAlign === "inner") ?
            -(size / 2) - padding :
            0);
    var r = (align === "outer") // radius
        ?
        (OR + dr) :
        ((align === "inner") ?
            (innerRadius + dr) :
            ((OR + innerRadius) / 2));
    
    var targetMarker = appendEle(container, "g", (targetMarkerOptions.enabled ? [data[0].data[0][0]] : []));
    
    targetMarker
        .attr("transform", function(d) {
            var targetValue = d[targetMarkerOptions.dataindex];
            if (defined(targetValue)) {
                targetValue = getTargetWithinDomain(targetValue);
                var angle_radian = yscale(targetValue);
                var xy = polarToXY(r, angle_radian);
                var angle_degree = radianToDegree(angle_radian) + symbol_rotation;
                return "translate(" + xy[0] + "," + xy[1] + ") rotate(" + angle_degree + ",0,0)";
            }
        })
        .style({
            "display": function(d) {
                var targetValue = d[targetMarkerOptions.dataindex];
                return !defined(targetValue) ? "none" : null;
            },
            "stroke-dasharray": getDashArray(targetMarkerOptions.dashStyle, validateNullVal(targetMarkerOptions.outerStrokeWidth, 1)),
            "stroke-linecap": getLineCap(targetMarkerOptions.lineCap, targetMarkerOptions.dashStyle)
        })
        .each(function(d) {
            var ele = d3_select(this);
            addSVGmarker(ele, null, targetMarkerOptions, extraOptions);
        });
    
    // add event listeners for dial target marker
    dialChartEventHandler(chartObj, targetMarker, targetMarkerOptions, "targetmarker", data);
    
    var targetLabelOptions = targetMarkerOptions.label || {};
    var targetLabelPadding = validateNullVal(targetLabelOptions.padding, 2);
    var targetLabelRadius = (align === "outer") ?
        (r + (size / 2) + targetLabelPadding) :
        ((align === "inner") ?
            (((dAlign === "outer") ? innerRadius : (r - (size / 2))) - targetLabelPadding) :
            (OR + targetLabelPadding));
    
    var targetLabel = appendEle(container, "text", (targetMarkerOptions.enabled && pick(targetLabelOptions.enabled, true)) ? [data[0].data[0][0]] : []);
    applyFont(targetLabel, [targetLabelOptions, systemconf.chart, systemconf.canvas, $ZCG]);
    
    targetLabel
        .each(function(d) {
            var ele = d3_select(this);
            ele
                .style("display", "none");

            var targetValue = d[targetMarkerOptions.dataindex];
            if (defined(targetValue)) {
                targetValue = getTargetWithinDomain(targetValue);
                if (!(!JSON.parse(commonPlotOptions.minmaxlabels.show) || minMax.indexOf(targetValue) == -1)) {
                    return;
                }
                var angle = yscale(targetValue);
                var angle_radian = d0_360(angle);
                var xy = polarToXY(targetLabelRadius, angle);
                
                var columns = chartObj.userdata.metadata.columns;
                var columnidx = columns.filter(function(d) {
                    return d.dataindex === targetMarkerOptions.dataindex;
                });
                var targetColumn = (columnidx.length) ? columnidx[0] : columns[dataset.getColumnIdx("y", 0)];
                var datatype = targetColumn.datatype;
                var formatConf = targetColumn[datatype];
                
                var TEXTANCHOR = (align === "inner") ?
                        (angle_radian < 0 || angle_radian > mathPI) ? null : "end" :
                        (angle_radian < 0 || angle_radian > mathPI) ? "end" : null,
                    DY = (align === "inner") ?
                        ((!(angle_radian > mathPI / 2 && angle_radian < 3 * mathPI / 2)) ? -getDY(angle_radian) + "em" : null) :
                        ((angle_radian > mathPI / 2 && angle_radian < 3 * mathPI / 2) ? getDY(angle_radian) + "em" : null),
                    TEXT = defined(targetLabelOptions.text) ? dataset.getCustomizedVal(chartObj, targetLabelOptions.text, index, null, null, d, "targetLabel") : getFormattedValue(formatConf, targetValue, datatype, chartObj, "targetLabel");
                
                ele
                    .text(TEXT)
                    .style("display", null)
                    .attr({
                        "text-anchor": TEXTANCHOR,
                        "dy": DY,
                        "transform": "translate(" + xy[0] + "," + xy[1] + ")"
                    });
            }
        });
    function getTargetWithinDomain(value) {
        return Math.min( Math.max(value, minMax[0]), minMax[1] );
    }
};

function dialChartEventHandler(chartObj, element, options, type, data) {
    var currentPoint = data[0].data[0][0],
        isLevelMarker = (type === "levelmarker"),
        commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions.dial,
        tooltipEnabled = chartObj.systemConf.tooltip.enabled,
        events = options.events || {},
        metaInfo,
        formatConf,
        datatype;
    
    var isEventEnabled = validateNullVal(events.enabled, commonPlotOptions.events.enabled);
    var cursor = isEventEnabled ? (events.cursor || "pointer") : null;
    
    element
        .style("cursor", cursor);
    
    if (isEventEnabled) {
        var dataset = chartObj.dataset,
            columns = chartObj.userdata.metadata.columns;
        var columnidx = columns.filter(function(d) {
            return d.dataindex === options.dataindex;
        });
        var targetColumn = (columnidx.length) ? columnidx[0] : columns[dataset.getColumnIdx("y", 0)];
        datatype = targetColumn.datatype;
        formatConf = targetColumn[datatype];
        
        var mousemove = function(d, i) {
                var val = isLevelMarker ? d[1] : d[options.dataindex];

                var userCallback = createUserObject(d),
                    position = getTooltipPosition(d3.event, {
                        x: 0,
                        y: 0
                    }, 0, 0, chartObj, {
                        seriesPos: 0,
                        subseriesindex: 0,
                        itemPos: 0
                    });

                handleUserCallback(currentPoint, "mousemove", d3.event, d);

                if (tooltipEnabled) {
                    var tooltipContent = invokeFunction(events.tooltipContent, userCallback, chartObj) || ((isLevelMarker ? "Range: " : "Target: ") + userCallback.formattedValue);
                    var tooltip = chartObj.eventHandler.tooltipElement;
                    tooltip.show(chartObj, getTooltipPositionForNonAxisCharts(), tooltipContent, false, position.helpers);
                }
            },
            mouseout = function(d, i) {
                handleUserCallback(currentPoint, "mouseout", d3.event, d);

                if (tooltipEnabled) {
                    var tooltip = chartObj.eventHandler.tooltipElement;
                    tooltip.hide(tooltip.element);
                }
            },
            click = function(d) {
                handleUserCallback(currentPoint, "click", d3.event, d);
            },
            dblclick = function(d, i) {
                handleUserCallback(currentPoint, "doubleclick", d3.event, d);
            },
            eventAttacherOptions = {
                target: "plot",
                touchleave: true,
                chartObj: chartObj
            };
        var mouseHandlers = {
                "mousemove": mousemove,
                "mouseout": mouseout,
                "click": click,
                "dblclick": dblclick
            },
            touchHandlers = {
                "singletouchmove": mousemove,
                "touchend": mouseout,
                "tap": click,
                "dbltap": dblclick
            };
        attachevents(element, mouseHandlers, touchHandlers, eventAttacherOptions);
    }
    
    function getTooltipPositionForNonAxisCharts() {
        var mouse = getMousePosition(chartObj.svg.node(), d3.event);
        var relmousePt = {
            x: mouse[0],
            y: mouse[1]
        };
        var tooltipPos = {
            left: relmousePt.x,
            top: relmousePt.y
        };
        var evt = getEventObject(d3.event);
        var dLeft = relmousePt.x - evt.clientX,
            dTop = relmousePt.y - evt.clientY;
        tooltipPos.left -= dLeft;
        tooltipPos.top -= dTop;
        tooltipPos.dLeft = dLeft;
        tooltipPos.dTop = dTop;
        return tooltipPos;
    }
    
    function handleUserCallback(data, type, event, d) {
        return invokeFunction(events[type], event, createUserObject(d), chartObj);
    }
    
    function createUserObject(d) {
        var val = isLevelMarker ? d[1] : d[options.dataindex];
        return {
            value: val,
            formattedValue: getFormattedValue(formatConf, val, datatype, chartObj),
            actualData: currentPoint,
            data: (metaInfo = metaInfo || chartObj.dataset.getMetaInfoObj(chartObj, currentPoint, 0))
        };
    }
}