//$Id$
var canvas_patterns = function(){}

canvas_patterns.canvasPatternFill = function(prop, clr, returnURL){
    var pattern, image, canvas, context;
    canvas = document.createElement('canvas');
    context = canvas.getContext("2d");
    if(prop.ele){
        image = generateCanvasPatternBySVGimage(prop, clr);
    }else{
        image = generateCanvasPatternByProp(prop, clr);
    }
    pattern = context.createPattern(image, 'repeat');
    return pattern;
}
canvas_patterns.imageFill = function(options,callback){
    var image = fillSVGimageInCanvas(options.name,options,callback);
}
function fillSVGimageInCanvas(url, options,callback) {
    var img = new Image();
    img.onload = function() {
        var patternCanvas = document.createElement('canvas');
        patternCanvas.width =  50;
        patternCanvas.height = 50;
        patternCanvas.getContext('2d').drawImage(img, 0, 0,  patternCanvas.width, patternCanvas.height);
        var fillStyle = options.context.createPattern(patternCanvas, 'repeat');
        callback(options.context, fillStyle);
    };
    img.src = url;
};

function generateCanvasPatternBySVGimage(properties, color) {
    var pattern = effects.get(svg_patterns,"svgPatternFill",properties, {"returnSVGimage":true, "base64":true});
    fillSVGimageInCanvas(pattern.url, pattern);
};

function generateCanvasPatternByProp(properties, color){
    var patternID = "zp" + generateIdByPropValue(properties, "canvasFill");
    var canvas;
    if($ZC[patternID]){
        canvas = $ZC[patternID];
    }else{
        var patternCanvas = document.createElement("canvas");

        var bgClr_base = properties.bgClr || properties.bgClr_base, 
        stroke_base = properties.stroke || properties.stroke_base;
        var regExp = /\{\{([a-z]+)\}\}/;
        
        var symbolTypes = properties.type.split(","),
        noOfSymbols = symbolTypes.length,
        size = properties.size.split(","),
        strokeWidth = properties.strokeWidth.split(","),
        fillColor = bgClr_base.split(","),
        stroke = stroke_base.split(","),
        fillOpacity = (properties.fillOpacity || "").split(","),
        strokeOpacity = (properties.strokeOpacity || "").split(",");
        translate = properties.translate ? properties.translate.split(",") : null;
        size = properties.width ? getPatternSize(properties,size) : size;

        patternCanvas.width = size[0];
        patternCanvas.height = size[0];

        var patternCanvas_context = patternCanvas.getContext("2d");
        

        for (var j=0; j<noOfSymbols; j++){
            var stroke_cur = isNull(stroke[j] || stroke[0]) ?  properties.stroke_base : (stroke[j] || stroke[0]),
            fill_cur = isNull(fillColor[j] || fillColor[0]) ?  properties.bgClr_base : (fillColor[j] || fillColor[0]);
            stroke_cur = (regExp.test(stroke_cur)) ? getColorCopy(properties.stroke_base, 1, stroke_cur.replace(regExp, '$1') ,d3_hsl) : stroke_cur;
            fill_cur = (regExp.test(fill_cur)) ? getColorCopy(properties.bgClr_base, 1, fill_cur.replace(regExp, '$1') ,d3_hsl) : fill_cur;
            trans_cur = (size[j] || size[0]) / 2;
            if(translate){
                var subTranslate = translate[j] || translate[0];
                trans_cur += parseFloat(subTranslate);
            }

            patternCanvas_context.save();
            patternCanvas_context.translate(trans_cur, trans_cur);
            patternCanvas_context.beginPath();
            patternCanvas_context.lineWidth = strokeWidth[j] || strokeWidth[0];
            patternCanvas_context.fillStyle = canvasUtils.rgba(fill_cur, fillOpacity[j] || fillOpacity[0]);
            patternCanvas_context.strokeStyle = stroke_cur;
            
            if (symbolTypes[j] === "circle") {
                patternCanvas_context.arc(0,0, size[j]/2, 0, mathPI * 2,false);
            }else{
              var patternPath = getSVGsymbol(symbolTypes[j])(size[j] || size[0]);
              canvasUtils.drawPath(patternCanvas_context, patternPath);  
            } 
            
            patternCanvas_context.fill();
            patternCanvas_context.stroke();
            patternCanvas_context.closePath();
            patternCanvas_context.restore();
        }
        canvas = $ZC[patternID] = patternCanvas;
    }
    return canvas;
}

