//$Id$
$ZC.patternutil = function() {};
var patternThemes = {};

$ZC.addPattern = function(name,type,size,strokeWidth,strokeClr,bgClr,fillOpacity,strokeOpacity,translate){
	patternThemes[name] = {
		"type" : type || "diagonal-line-right",
		"size" : size || 5,
		"strokeWidth" : strokeWidth || 1,
		"bgClr" : bgClr,
		"stroke" : strokeClr,
		"fillOpacity" : fillOpacity || 1,
		"strokeOpacity" : strokeOpacity || 1,
		"translate" : translate
	} 
}
$ZC.getPattern = function(name){
	return {
		"type" : patternThemes[name].type,
		"size" : patternThemes[name].size,
		"strokeWidth" : patternThemes[name].strokeWidth,
		"bgClr" : patternThemes[name].bgClr,
		"stroke" : patternThemes[name].stroke,
		"fillOpacity" : patternThemes[name].fillOpacity,
		"strokeOpacity" : patternThemes[name].strokeOpacity,
		"translate" : patternThemes[name].translate
	}
}
function generateDefaultPatternTheme(){

	$ZC.addPattern("hatch",   "diagonal-line-right",   "5",   "1",   "null",      "white",   "1",   "1");
	$ZC.addPattern("hatchDash",   "square,diagonal-line-right",   "5,5",   "1",   "transparent,{{brighter}}",   "transparent,transparent",   "1",   "1",   "0,3");
	$ZC.addPattern("thinThickHatch",   "square,diagonal-line-right,diagonal-line-right",   "10,10,10",   "1,1,3",   "transparent,null,null",   "transparent",   "1",   "1",   "0,2.5,0");
	$ZC.addPattern("thickHatch",   "diagonal-line-right",   "5",   "3",   "null",      "white",   "1",   "1");
	$ZC.addPattern("thinHatch",   "diagonal-line-right",   "2",   "1",   "null",      "white",   "1",   "1");
	$ZC.addPattern("hatchLeft",   "diagonal-line-left",   "5",   "1",   "null",      "white",   "1",   "1");
	$ZC.addPattern("horizontalStripes",   "horizontal-line",   "5",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("thinHorizontalStripes",   "horizontal-line",   "2",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("verticalStripes",   "vertical-line",   "5",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("thinVerticalStripes",   "vertical-line",   "2",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("crossStripes",   "vertical-line,horizontal-line",  "5",   "1",   "null",   "white",    "1",   "1");

	$ZC.addPattern("tinyHatchfill",   "square,diagonal-line-right",   "5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("hatchfill",   "square,diagonal-line-right",   "10",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("hatchDashfill",   "square,diagonal-line-right",   "5,5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1",   "0,3");
	$ZC.addPattern("hatchLeftfill",   "square,diagonal-line-left",   "5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("horizontalStripesfill",   "square,horizontal-line",   "5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("verticalStripesfill",   "square,vertical-line",   "5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("crossStripesfill",   "square,square",  "5,5",   "1",   "transparent,{{brighter}}",   "null,transparent",    "1",   "1");
	$ZC.addPattern("checkerBoard",   "square,square,square",  "10,5,5",   "1",   "transparent",   "transparent,null,{{brighter}}",    "1",   "1",   "0,0,5");


	$ZC.addPattern("circle",   "circle",   "10",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("tinyCircle",   "circle",   "5",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("crossCircle",   "square,circle,circle",   "10,5,5",   "1",      "transparent,null,{{brighter}}",   "transparent",   "1",   "1",   "0,0,5");
	$ZC.addPattern("floatingCircle",   "square,circle",   "10,5",   "1",      "transparent,{{brighter}}",   "transparent",   "1",   "1",   "0,2.5");
	$ZC.addPattern("dot",   "square,circle",   "5,2.5",   "1",      "transparent,{{brighter}}",   "transparent,transparent",   "1",   "1",   "0,1.25");
	$ZC.addPattern("dotSquare",   "square,circle",   "10,2.5",   "1",      "null,{{brighter}}",   "transparent,transparent",   "1",   "1",   "0,3.75");

	$ZC.addPattern("circlefill",   "square,circle",   "10,10",   "1",      "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("crossCirclefill",   "square,circle,circle",   "10,5,5",   "1",      "transparent,null,{{brighter}}",   "null,{{brighter}},null",   "1",   "1",   "0,0,5");
	$ZC.addPattern("floatingCirclefill",   "square,circle",   "10,5",   "1",      "transparent,{{brighter}}",   "null,transparent",   "1",   "1",   "0,2.5");
	$ZC.addPattern("dotfill",   "square,circle",   "5,2.5",   "1",      "transparent,{{brighter}}",   "null,transparent",   "1",   "1",   "0,1.25");


	$ZC.addPattern("square",   "square",   "5",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("squarefill",   "square",   "5",   "1",      "{{brighter}}",   "null",      "1",   "1");

	$ZC.addPattern("star",   "star",   "10",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("starfill",   "square,star",   "10,5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	
	$ZC.addPattern("wave",   "waves",  "5",   "1",   "null",   "white",    "1",   "1");
	$ZC.addPattern("wavefill",   "square,waves",   "10,10",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");

	$ZC.addPattern("cap",   "caps",  "5",   "1",   "null",   "white",    "1",   "1");
	$ZC.addPattern("capfill",   "square,caps",   "10,10",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");

	$ZC.addPattern("nylon",   "nylon",  "5",   "1",   "null",   "white",    "1",   "1");
	$ZC.addPattern("nylonfill",   "square,nylon",   "10,10",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
}

function addPatternThemeByEle(ele){
	return {"ele" : ele};
}

