//$Id$
var svg_filters = function(){};

svg_filters.chalk = function(properties, filterID) {
    var svg = $ZCG.patternSVG;
    var filter = svg.select('defs')
        .append('filter')
        .attr({
            'id': filterID,
            'x': -0.3,
            'y': -0.5,
            'height': 2,
            'width': 1.6,
            'color-interpolation-filters': "sRGB"
        });
    filter.append('feTurbulence')
        .attr({
            'baseFrequency': 0.32065,
            'seed': 115,
            'result': 'result1',
            'numOctaves': 1,
            'type': 'turbulence'
        });
    
    filter.append('feOffset')
        .attr({
            'result': 'result2',
            'dx': -2,
            'dy': -2
        });
    
    filter.append('feDisplacementMap')
        .attr({
            'scale': 5,
            'yChannelSelector': "G",
            'in2': "result1",
            'xChannelSelector': "R",
            'in': "SourceGraphic"
        });
    
    return filterID;
}

svg_filters.dropShadow = function(properties, filterID) {
    
    var svg = $ZCG.patternSVG;
    var filter = svg.select('defs').append("filter")
        .attr({
            "x": properties.x,
            "y": properties.y,
            "width": properties.width,
            "height": properties.height,
            "id": filterID,
            "filterUnits": properties.filterUnits
        });
    
    filter.append("feGaussianBlur")
        .attr({
            "in": properties.source || "SourceAlpha",
            "stdDeviation": properties.blur
        });
    
    if (properties.source !== "SourceGraphic") {
        filter.append("feOffset")
            .attr({
                "dx": properties.dx,
                "dy": properties.dy,
                "result": "offsetblur"
            });
        
        var floodColor = properties.color,
            floodOpacity = null;
        var rgba = floodColor.match(RGBA_PATTERN); //#ZC910 SAFARI dont consider alpha in rgba color
        if (rgba && rgba.length === 5) {
            floodColor = rgb2hex(floodColor);
            floodOpacity = rgba[4];
        }

        var feFlood = filter.append("feFlood");
        feFlood
            .attr({
                "flood-color": floodColor,
                "flood-opacity": floodOpacity
            });
        
        filter.append("feComposite")
            .attr({
                "in2": "offsetblur",
                "operator": "in"
            });
        
        var feMerge = filter.append("feMerge");
        
        feMerge.append("feMergeNode");
        feMerge.append("feMergeNode")
            .attr("in", "SourceGraphic");
    }
    return filterID;
}

svg_filters.colorMatrix = function(properties, filterID) {
    var svg = $ZCG.patternSVG;
    var filter = svg.select('defs').append("filter")
        .attr("id", filterID)
    
    var feGaussianBlur = filter.append("feColorMatrix")
        .attr({
            "in": "SourceGraphic",
            "type": properties.type,
            "values": properties.values
        });
    return filterID;
};

svg_filters.freeHand = function(properties, filterID) {
    var svg = $ZCG.patternSVG;
    var scale = (properties.scale == null) ? 7 : properties.scale;
    
    var filter = svg.select('defs').append("filter")
        .attr("id", filterID)
    
    var feTurbulence = filter.append("feTurbulence")
        .attr({
            "type": "fractalNoise",
            "baseFrequency": 0.015,
            "numOctaves": 2,
            "result": "turbulence_3",
            "data-filterId": 3
        });
    
    var feDisplacementMap = filter.append("feDisplacementMap")
        .attr({
            "xChannelSelector": "R",
            "yChannelSelector": "G",
            "in": "SourceGraphic",
            "in2": "turbulence_3",
            "scale": properties.scale
        });
    return filterID;
}
