//$Id$
var svg_masks = function(){};

svg_masks.tenbytenGrid = function(properties, maskID){
	var pattern_svg = $ZCG.patternSVG;
	var maskNode = pattern_svg.select("defs")
        .append("mask")
        .attr({
            'id': maskID,
            'maskUnits': 'userSpaceOnUse',
            'width': properties.width,
            'height': properties.height,
			'x':properties.x,
			'y':properties.y
        });
    var poly = maskNode.append("polygon")
    				.attr("points", getPolyPoints(properties.x, properties.y, properties.type, properties.percent, properties.size, properties.width))
    				.style({
    					"fill" : properties.fillColor
    				});
	return maskID;
}

function getPolyPoints(x,y, type, percent, cellSize, totalSize){
	var quo = (parseInt(percent / 10)) * cellSize,
		rem = percent % 10;
	var start1X = x, start1Y = (rem == 0) ? ((totalSize - quo)+y) : ((totalSize - (quo + cellSize))+y),
		mid1X = (rem * cellSize)+x, mid1Y = start1Y,
		mid2X = mid1X , mid2Y = (rem == 0) ? start1Y : start1Y+cellSize,
		end1X = totalSize+x, end1Y = mid2Y,
		end2X, end2Y, start2X, start2Y;


		
	switch(type) {
		case 'top2Bottom' :
			end2X = totalSize+x, end2Y = y, 
			start2X = x, start2Y = y;
			break;
		case 'bottom2Top' :
			end2X = totalSize+x, end2Y = totalSize+y, 
			start2X = x, start2Y = totalSize+y;
			break;
	}

	var points = start1X + "," + start1Y + " " + 
				 mid1X + "," + mid1Y + " " + 
				 mid2X + "," + mid2Y + " " + 
				 end1X + "," + end1Y + " " + 
				 end2X + "," + end2Y + " " + 
				 start2X + "," + start2Y + " " + 
				 start1X + "," + start1Y;

    return points;

}

