//$Id$
var effects = function(){};


effects.get = function(module, submodule, properties, args) {
    args = args || {};
    var offset = args.offset,
        dimension = args.dimension,
        returnSVGimage = args.returnSVGimage,
        base64 = args.base64,
        chartObj = args.chartObj;
    if (!((submodule != null || submodule != "") && module[submodule])) {
        return;
    }
    
    /* Generate PatternID and check the pattern if already generated with the PatternID
     * If already exist return the patternID to apply
     * else create new pattern and return patternID.
     * */
    var effectID = "zp" + generateIdByPropValue(properties, submodule);
    
    if (effectID == null) {
        return;
    }
    if ($ZC[effectID] != null) {
        var effectEle = $ZC[effectID];
        if(returnSVGimage){
            return effectEle;
        }
        return effectEle.id || effectEle;
    }
    var effectEle = module[submodule](properties, effectID, offset, returnSVGimage, base64, chartObj);
    if(effectEle){
        $ZC[effectID] = effectEle;
        if(returnSVGimage){
            return effectEle;
        }
        return effectEle.id || effectEle;//for filters returns id, for patterns returns element. Need to make it common
    }
    
}

function getChartEffects(systemconf) {
    var effectName = systemconf.chart.effects.choice;
    var effect = svg_filters[effectName];
    if (!effect) {
        return;
    }
    var properties = systemconf.chart.effects.options[effectName];
    if (effectName === "dropShadow") {
        properties.blur = mathMax(0, properties.blur);
    }
    var effectID = effects.get(svg_filters,effectName, properties);
    return effectID;
}

function getGradientProp(gradient,dimension,color,opacity){
    var type = gradient.type;
    if (!type || type === "none") {
        return;
    }
    var options = gradient.options[type] || gradient.options;
    var prop = simpleClone(options);
    prop.color = (color != null) ? color : prop.color;
    prop.opacity =  (opacity != null) ? opacity : prop.opacity;
    prop.dimension = (dimension != null) ? dimension : prop.dimension;
    prop.type = type;
    // prop.defsLocation = chartObj ? chartObj.defsLocation : "";
    return prop;
}

function getPatternProp(pattern,baseClr,opacity,customPatternDim){
    var prop = patternThemes[pattern] ? patternThemes[pattern] : addPatternThemeByEle(pattern);
        prop.bgClr_base = baseClr;
        prop.stroke_base = baseClr;
        prop.fillOpacity = prop.fillOpacity || opacity;
    if(customPatternDim){
        prop.x = customPatternDim.x,
        prop.y = customPatternDim.y,
        prop.width = customPatternDim.width,
        prop.height = customPatternDim.height;
    }
    return prop;
}
function getPatternSize(properties, size){
    var patternSize = size.map(function(d,i){
        var s = parseInt(d);
        var rem = properties.width % s;
        var quo = parseInt(properties.width / s);
        var partial  = rem / quo;
        return partial+s;
    })
    return patternSize;
}

