//$Id$
$ZC.events.mouseevents = function(chartObj, tooltipele, systemConf, plotarea, dataset, xscale, barscale1, barscale2, ysca, wrap, color, labelhighter) {
    var element, gvpFn = $ZC.utils.getValueOfPlotOptions;
    var datatype = dataset.getDataType("x");
    var yscale = ysca,
        color = color;
    var axisrotated = chartObj.dataObject.getAxisRotated(),
        tooltipEnabled = systemConf.tooltip.enabled === true,
        defaultScrollElement = chartObj.container.selectAll(".zohocharts_scroll"),
        levelMarkerPoint,
        eventAttacherOptions = {
            target: "plot",
            chartObj: chartObj
        },
        tapOldInfo,
        dataProcessorHelpers = $ZC.DataProcessor.helpers,
        getParsedYAxisOrder = dataProcessorHelpers.getParsedYAxisOrder,
        getChartType = dataProcessorHelpers.getChartType,
        isCatNull = dataProcessorHelpers.isCatNull;
    
    // for reverse legend hovering
    var legendSeries = chartObj.legendarea.element.selectAll(".legseries").node(),
        legendElements = legendSeries ? legendSeries.children : [],
        highlightItem = chartObj.legend.component.highlightItem,
        legendStyle = systemConf.legend,
        itemHighlighted = false,
        hoveredSeriesIndex = null,
        previousHoveredSeriesIndex = null,
        showOnDataHover = systemConf.legend.itemHoverStyle && systemConf.legend.itemHoverStyle.showOnDataHover,
        legend_series_height, legendScrollable;
    if (legendSeries) {
        legend_series_height = legendSeries.clientHeight;
        legendScrollable = legendSeries.scrollHeight > legend_series_height;
    }
    
    var events = {};
    var timer = 0,
        highlightpoint, stacked = function(cType) {
            return chartObj.dataObject.isstacked(cType)
        };
    
    events.initializeListener = function() {
        var eventHandler = chartObj.eventHandler;
        tapOldInfo = chartObj.eventHandler.tapOldInfo = null; //Tap event in touch devices - to toggle (defaultMouseOverFunc & defaultMouseOutFunc) on tap;

        eventHandler.trackerElement = wrap.selectAll("rect.eventhandler").data([1]);
        eventHandler.tooltipElement = $ZC.events.tooltip(tooltipele, systemConf, chartObj);
        eventHandler.tooltipElement.initialize();

        var trackerEle = chartObj.eventHandler.trackerElement;
        trackerEle.enter().append("rect").attr("class", "eventhandler").style("fill-opacity", 0);


        // Bullet event
        if ((chartObj.chartTypes[0].name === "bullet") && systemConf.chart.plot.renderer.mode.toLocaleLowerCase() === "svg") {
            events.bulletEvent = bulletChartEventHandler(chartObj, trackerEle, hoverSeries, events);
            return false;
        }

        var zoomType = isObjectPropDefined(systemConf.chart, "zoom.type", true),
            clickHandlers = {
                "click": eventHandler.click,
                "dblclick": eventHandler.doubleclick,
                "contextmenu": eventHandler.contextMenu
            },
            moveHandlers = {
                "mousemove": eventHandler.mouseMove,
                "mouseout": eventHandler.mouseOut
            };

        attachevents(trackerEle, clickHandlers, null, eventAttacherOptions, "chart");
        attachevents(trackerEle, moveHandlers, null, eventAttacherOptions, "chartmove");
        attachevents(tooltipele, moveHandlers, null, eventAttacherOptions);

        if (zoomType && (zoomType !== "none")) {
            $ZC.setDefaultOptions("zoom", chartObj.systemConf.chart, chartObj.globalProp);
            eventHandler.initializeZoomListener();
        } else {
            var touchHandlers = {
                "tap" : eventHandler.click,
                "dbltap": eventHandler.doubleclick,
                "singletouchmove" : eventHandler.mouseMove,
                "touchend" : eventHandler.mouseOut
            };

            attachevents(trackerEle, {}, touchHandlers, eventAttacherOptions);
        }

        // handle scroll
		var tooltip = chartObj.eventHandler.tooltipElement;
        var scrollEventName = "onwheel" in document.createElement("div") ? "wheel" : document.onmousewheel !== undefined ? "mousewheel" : "DOMMouseScroll";
        var parentNode = chartObj.container.node(), lastPosition = null;
        chartObj.d3container.on(scrollEventName, function() {
            var currentPosition = parentNode.getBoundingClientRect();
            if(lastPosition) {
            	if(lastPosition.left !== currentPosition.left || lastPosition.top !== currentPosition.top) {
            		tooltip.hide(tooltip.element);
            	}
            }
			lastPosition = currentPosition;
        });

    };
    events.initializeZoomListener = function() {
        chartObj.zoom = $ZC.events.zoom(chartObj, axisrotated, systemConf, dataset);
        var trackerEle = chartObj.eventHandler.trackerElement,
            documentElement = d3_select(document.documentElement);
        var zmevent = chartObj.zoom;
        var eventHandler = chartObj.eventHandler;
        zmevent.zmInit();
        var zoomInitialized = false;
        
        var handlers = {
            "mousedown": function() {
                detachevent(trackerEle, "chartmove"); //Stop event listening for .chart eventType while zooming.
                attachevents(documentElement, mousemoveHandlers, null, eventAttacherOptions); //Enable move event
                d3.event.preventDefault();
            }
        };
        
        var mousemoveHandlers = {
            "mousemove": function() {
                chartObj.eventHandler.mousePos = getMousePosition(trackerEle.node(), d3.event);
                if (!zoomInitialized) {
                    chartObj.eventHandler.mouseOut();
                    zmevent.zmStart(chartObj.eventHandler.mousePos);
                    zoomInitialized = true
                }
                zmevent.zmMove(chartObj.eventHandler.mousePos);
            },
            
            "mouseup": function() {
                detachevent(documentElement, null, mousemoveHandlers); //Disable move event.
                var zmdata = zmevent.zmEnd(chartObj.eventHandler.mousePos);
                if (zoomInitialized) {
                    chartObj.eventHandler.mousePos = getMousePosition(trackerEle.node(), d3.event);
                    zmevent = chartObj.zoom;
                    zmevent.zoomed(zmdata);
                }
                // Re-initialize default events
                var handlers = {
                    "mousemove": eventHandler.mouseMove,
                    "mouseout": eventHandler.mouseOut
                };
                attachevents(trackerEle, handlers, null, eventAttacherOptions, "chartmove");
                zoomInitialized = false;
            }
        };

        var zoomMoveHandlers = {
            "tap" : eventHandler.click,
            "dbltap": eventHandler.doubleclick,
            "doubletouchmove": function() {
                chartObj.eventHandler.mousePos = getMousePosition(trackerEle.node(), d3.event);
                if (!zoomInitialized) {
                    chartObj.eventHandler.mouseOut();
                    zmevent.zmStart(chartObj.eventHandler.mousePos);
                    zoomInitialized = true
                }
                zmevent.zmMove(chartObj.eventHandler.mousePos);
            },
            "touchend": function() {
                detachevent(documentElement, null, mousemoveHandlers); //Disable move event.
                var zmdata = zmevent.zmEnd(chartObj.eventHandler.mousePos);
                if (zoomInitialized) {
                    chartObj.eventHandler.mousePos = getMousePosition(trackerEle.node(), d3.event);
                    zmevent = chartObj.zoom;
                    zmevent.zoomed(zmdata);
                } else {
                    eventHandler.mouseOut();
                }
                zoomInitialized = false;
            },
            "singletouchmove" : eventHandler.mouseMove
        };
        attachevents(trackerEle, handlers, zoomMoveHandlers, eventAttacherOptions, "zoom");
    };
    
    events.updateParams = function(chartObj_new) {
        chartObj = chartObj_new;
        systemConf = chartObj.systemConf;
        plotarea = chartObj.plotarea;
        dataset = chartObj.dataset;
        xscale = chartObj.axes.x.eventscale;
        yscale = chartObj.axes.y.groups;
        barscale1 = chartObj.barscale1;
        barscale2 = chartObj.barscale2;
        color = chartObj.seriesColor;
        tooltipele = chartObj.tooltip.element;
        stacked = function(cType) {
            return chartObj.dataObject.isstacked(cType)
        };
        axisrotated = chartObj.dataObject.getAxisRotated();
        wrap = chartObj.staticPaneSVG.selectAll("g.eventgroup");
        datatype = dataset.getDataType("x");
        
        tooltipEnabled = systemConf.tooltip.enabled === true;
        chartObj.eventHandler.tooltipElement = $ZC.events.tooltip(chartObj.tooltip.element, systemConf, chartObj);
        chartObj.eventHandler.tooltipElement.initialize();

        if (chartObj.xymultiRenderer || chartObj.dataObject.isPolarAxisCategory) {
            drawBorderBox(chartObj.eventHandler.trackerElement, chartObj.plotarea);
        }

        // update bullet events
        if (events.bulletEvent) {
            updateBulletEvents(chartObj, events.bulletEvent);
        }
    };
    
    events.mouseMove = function(args) {
        var eventEle = args.element || this;
        if (chartObj.chartRendered) {
            var tooltip = chartObj.eventHandler.tooltipElement;
            if ((tooltip != null) && (tooltip.timeout != null)) {
                clearTimeout(tooltip.timeout); // To avoid flickering on  mouse move, clearing the timeout that makes the tooltip's display prop to none
            }
            // if (d3.event.defaultPrevented) return;
            if (chartObj.stopPropogate !== false) {
                d3.event.stopPropagation();
            }
            chartObj.eventHandler.targetEvent = d3.event;
            if (!chartObj.xymultiRenderer && !chartObj.dataObject.isPolarAxisCategory) {
                var node = chartObj.svg.node();
                chartObj.eventHandler.mousePos = getMousePosition(node, d3.event);
                var relMouseX = chartObj.eventHandler.mousePos[0];
                var relMouseY = chartObj.eventHandler.mousePos[1];
                
                var relmousePt = {
                    x: relMouseX,
                    y: relMouseY
                };
                
                var currentEle = d3.event.srcElement || d3.event.target;
                var elementID = d3_select(currentEle).attr("id");
                var isMouseOveronTooltip = (eventEle.id == "zctooltip") || /(zctooltip|tooltipcontent|zctooltipafter|zctooltipbefore)/.test(elementID);
                if (!isMouseOveronTooltip) {
                    var seriesdata = chartObj.seriesdata;
                    var chartName = chartObj.chartTypes[0].name;

                    var plotOptions = seriesdata[args.seriesPos].plotoptions,
                        commonPlotOptions = systemConf.chart.plot.plotoptions[chartName],
                        eventType = (chartObj.zcEventType) || "mousemove";
                    var mouseMoveFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType);
                    
                    if (mouseMoveFn != null) {
                        var evt = d3.event || chartObj.eventHandler.targetEvent,
                            dt = {
                                "data": chartObj.dataset.getMetaInfoObj(chartObj, (args.data.data || args.data), args.seriesPos)
                            };
                        invokeFunction(mouseMoveFn, evt, dt, chartObj);
                    } else {
                        chartObj.eventHandler.oldRenderer = args;
                        args.renderer.defaultMouseOverFunc(args.data, args.seriesPos, args.itemPos);
                    }
                    if (tooltipEnabled) {
                        var tooltipPos = {
                            left: relmousePt.x,
                            top: relmousePt.y
                        };
                        var evt = getEventObject(d3.event);
                        var dLeft = relmousePt.x - evt.clientX,
                            dTop = relmousePt.y - evt.clientY;
                        tooltipPos.left -= dLeft;
                        tooltipPos.top -= dTop;
                        tooltipPos.dLeft = dLeft;
                        tooltipPos.dTop = dTop;
                        var tooltipArgs = {
                            "seriesindex": args.seriesPos,
                            "subseriespos": args.subseriesPos,
                            "color": (args.color || color),
                            "svgFillFunc":args.renderer.fillColorFunc,
                            "itempos": args.itemPos,
                            "d": (chartObj.dataObject.isHierarchy ? (args.data.data || args.data) : null)
                        }
                        tooltip.show(chartObj, tooltipPos, null, true, tooltipArgs);
                    }
                }
                hoveredSeriesIndex = hoveredSeriesIndex = getLegendIndex(args.data.data || args.data, chartObj.isNonAxisMultiSeriesCategory ? args.seriesPos : args.itemPos);
            } else {
                if (chartObj.eventHandler.mousemovetimer) {
                    clearTimeout(chartObj.eventHandler.mousemovetimer)
                }
                var node = chartObj.eventHandler.trackerElement.node();
                chartObj.eventHandler.mousePos = getMousePosition(node, d3.event);
                chartObj.eventHandler.mousemovetimer = setTimeout(function() {
                    var containsBarchart = (chartObj.dataObject.noofBarEnabledSeries > 0);
                    var func = ((datatype === ORDINAL_DATATYPE) && (containsBarchart || systemConf.tooltip.sharedSeriesInfo)) ? ordinalDatamouseMove : xydatamouseMove;
                    func(chartObj.eventHandler.mousePos, chartObj.eventHandler.targetEvent, node);
                }, timer)
            }
        }
        // reverse hovering
        if (showOnDataHover && hoveredSeriesIndex !== null) {
            if (legendElements[hoveredSeriesIndex]) {
                var legendData = legend_helpers.getLegendData(chartObj);
                
                if (hoveredSeriesIndex !== previousHoveredSeriesIndex && previousHoveredSeriesIndex !== null) {
                    highlightItem(legendElements[previousHoveredSeriesIndex], legendData[previousHoveredSeriesIndex], previousHoveredSeriesIndex, legendStyle);
                }
                
                highlightItem(legendElements[hoveredSeriesIndex], legendData[hoveredSeriesIndex], hoveredSeriesIndex, legendStyle, true);
                itemHighlighted = true;
                
                // scroll into view;
                if (legendScrollable && !(chartObj.systemConf.legend.expandable && chartObj.systemConf.legend.expandable.show)) {
                    legendSeries.scrollTop = legendElements[hoveredSeriesIndex].offsetTop - legend_series_height / 2;
                }
            }
            previousHoveredSeriesIndex = hoveredSeriesIndex;
        }
    };
    
    events.mouseOut = function(renderer, data, index, showTooltip, forceMouseOut) {
        var seriesdata = chartObj.seriesdata,
            eventEle = this;
        index = index || 0; // Touch double tap
        var chartName = chartObj.chartTypes[0].name;
        var plotOptions = (chartObj.isNonAxisMultiSeriesCategory && !chartObj.dataObject.isPolarAxisCategory) ? seriesdata[index].plotoptions : seriesdata[0].plotoptions,
            commonPlotOptions = systemConf.chart.plot.plotoptions[chartName];
        var mouseOutFn = getEventConf(plotOptions, commonPlotOptions, chartObj, "mouseout");
        var oldInfo = chartObj.eventHandler.oldInfo;
        
        if (forceMouseOut || chartObj.chartRendered) {
            var event = d3.event;
            var withIn = 0
            if(mouseOutFn != null){
            	if((!chartObj.xymultiRenderer) || (oldInfo != null && !oldInfo.isNoInfo)){
            		var evt = event || chartObj.eventHandler.targetEvent,
            			dt = (data) ? {
                                "data": chartObj.dataset.getMetaInfoObj(chartObj, (data.data || data), index)
                            } : null;

            		invokeFunction(mouseOutFn, evt, dt, chartObj);
            	}
            
            }else{
            if (chartObj.xymultiRenderer || chartObj.dataObject.isPolarAxisCategory) {
                var node = chartObj.eventHandler.trackerElement.node();
                var mouse = (event != null) ? getMousePosition(node, event) : chartObj.eventHandler.mousePos;
                var relativeelement = bbox(node);
                var relMouseX = (axisrotated) ? mouse[1] : mouse[0];
                var relMouseY = (axisrotated) ? mouse[0] : mouse[1];
                var relmousePt = {
                    x: relMouseX,
                    y: relMouseY
                };
                
                withIn = isWithin(relativeelement, relmousePt);
            }
            
            var tooltip = chartObj.eventHandler.tooltipElement
            var relatedTarget = (event != null) ? event.relatedTarget : null;
            var target = (event != null) ? event.target : null;
            
            if (((chartObj.xymultiRenderer) && withIn == 0) && relatedTarget != null && tooltip != null && (target == tooltip.element.node() || target == tooltip.element.selectAll("div#tooltipcontent").node() || relatedTarget == tooltip.element.node() ||
                relatedTarget == tooltip.element.selectAll("div#tooltipcontent").node())) {
                return
            } else {
                if (!chartObj.xymultiRenderer && !chartObj.dataObject.isPolarAxisCategory) {
                    renderer = renderer || chartObj.renderer[index];

                    if (eventEle.id == "zctooltip" || relatedTarget != null && tooltip != null && (target == tooltip.element.node() || target == tooltip.element.selectAll("div#tooltipcontent").node() || target == tooltip.element.selectAll("div#zctooltipafter").node() || target == tooltip.element.selectAll("div#zctooltipbefore").node() || relatedTarget == tooltip.element.node() || relatedTarget == tooltip.element.selectAll("div#tooltipcontent").node() || relatedTarget == tooltip.element.selectAll("div#zctooltipafter").node() || relatedTarget == tooltip.element.selectAll("div#zctooltipbefore").node())) {
                        var actualRenderer = chartObj.eventHandler.oldRenderer;
                        if (actualRenderer != null) {
                            actualRenderer.renderer.defaultMouseOutFunc(actualRenderer.data, ((chartObj.isNonAxisMultiSeriesCategory) ? actualRenderer.seriesPos : actualRenderer.itemPos), forceMouseOut);
                        }
                    } else {
                        renderer.defaultMouseOutFunc(data, index, forceMouseOut);
                    }
                }
                if (chartObj.eventHandler.mouseouttimer) {
                    clearTimeout(chartObj.eventHandler.mouseouttimer);
                }
                
                chartObj.eventHandler.mouseouttimer = setTimeout(function() {
                    wrap.selectAll("#zcscatterhighlight,#zcbarhighlight,#zcareahighlight")
                        .style('display', "none");
                    
                    if (chartObj.eventHandler.tooltipElement.timeout) {
                        clearTimeout(chartObj.eventHandler.tooltipElement.timeout);
                    }
                    if (showTooltip !== true) {
                        chartObj.eventHandler.tooltipElement.timeout = setTimeout(function() {
                            tooltip.hide();
                        }, 110)
                    }
                }, timer)
            }
            // // mouse out callback
            // if (mouseOutFn != null) {
            //     if ((!chartObj.xymultiRenderer) || (oldInfo != null && !oldInfo.isNoInfo)) {
            //         var evt = event || chartObj.eventHandler.targetEvent,
            //             dt = (data) ? {
            //                     "data": chartObj.dataset.getMetaInfoObj(chartObj, (data.data || data), index)
            //                 } : null;
            //         invokeFunction(mouseOutFn, evt, dt, chartObj);
            //     }
                
            // }
            }
            if (itemHighlighted) {
                if (defined(legendElements[hoveredSeriesIndex])) {
                    var legendData = legend_helpers.getLegendData(chartObj);
                    highlightItem(legendElements[hoveredSeriesIndex], legendData[hoveredSeriesIndex], hoveredSeriesIndex, legendStyle);
                }
                hoveredSeriesIndex = null;
            }
            itemHighlighted = false;
            events.hideCursor(chartObj.eventHandler.trackerElement);
        }
    };
    
    events.click = function(renderer, data, seriesPos, itemPos, args) {
        if (chartObj.chartRendered) {

            var seriesdata = chartObj.seriesdata;
            var isPolar = chartObj.dataObject.isPolarAxisCategory,
                isTouchEvent = d3.event && d3.event.touches,
                eventType = (chartObj.zcEventType) || "click";

            if(isTouchEvent && eventType !== "taphold") {
                docTapFunction(chartObj);

                clickedTime = new Date().getTime();
                clickedElement = this;
                clickArguments = [renderer, data, seriesPos, itemPos];
                previousChartObj = chartObj;
            }

            var tooltip = chartObj.eventHandler.tooltipElement;
            tooltip.hide(tooltip.element);
            events.hideCursor(chartObj.eventHandler.trackerElement);

            if (!chartObj.xymultiRenderer && !isPolar) {
                var chartName = chartObj.chartTypes[0].name;
                var plotOptions = seriesdata[chartObj.isNonAxisMultiSeriesCategory ? seriesPos : 0].plotoptions,
                    commonPlotOptions = systemConf.chart.plot.plotoptions[chartName];
                var clickFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType);
                if (clickFn != null) {
                    var evt = d3.event || chartObj.eventHandler.targetEvent,
                        dt = {
                            "data": chartObj.dataset.getMetaInfoObj(chartObj, (data.data || data), (chartObj.isNonAxisMultiSeriesCategory ? seriesPos : itemPos))
                        };
                    invokeFunction(clickFn, evt, dt, chartObj);
                } else if(isTouchEvent && (eventType !== "taphold")) {
                    tapOldInfo = chartObj.eventHandler.tapOldInfo;
                    if (!tapOldInfo || (args.level ? (args.level != tapOldInfo.level) : (tapOldInfo.itemPos != itemPos || tapOldInfo.seriesPos != seriesPos || tapOldInfo.subseriesindex != 0))) {
                        renderer.defaultMouseOverFunc(data, seriesPos, itemPos);

                        if (tooltipEnabled) {
                            var node = chartObj.svg.node();
                            chartObj.eventHandler.mousePos = getMousePosition(node, d3.event);
                            var relMouseX = chartObj.eventHandler.mousePos[0];
                            var relMouseY = chartObj.eventHandler.mousePos[1];
                            
                            var relmousePt = {
                                x: relMouseX,
                                y: relMouseY
                            };

                            var tooltipPos = {
                                left: relmousePt.x,
                                top: relmousePt.y
                            };
                            var evt = getEventObject(d3.event);
                            var dLeft = relmousePt.x - evt.clientX,
                                dTop = relmousePt.y - evt.clientY;
                            tooltipPos.left -= dLeft;
                            tooltipPos.top -= dTop;
                            tooltipPos.dLeft = dLeft;
                            tooltipPos.dTop = dTop;
                            var tooltipArgs = {
                            "seriesindex": args.seriesPos,
                            "subseriespos": args.subseriesPos,
                            "color": (args.color || color),
                            "svgFillFunc":args.renderer.fillColorFunc,
                            "itempos": args.itemPos,
                            "d": (chartObj.dataObject.isHierarchy ? (args.data.data || args.data) : null)
                        }
                            tooltip.show(chartObj, tooltipPos, null, true, tooltipArgs);
                        }

                        chartObj.eventHandler.tapOldInfo = {
                            seriesPos : seriesPos,
                            subseriesindex : 0,
                            itemPos : itemPos,
                            level: args.level
                        };
                    } else {
                        renderer.defaultMouseOutFunc(data, itemPos);
                        chartObj.eventHandler.tapOldInfo = null;
                    }

                }
            } else {
                var event = d3.event;
                element = chartObj.eventHandler.trackerElement.node();
                var mouse = getMousePosition(element, event) || chartObj.eventHandler.mousePos;
                var relativeelement = bbox(element);
                var relMouseX = mouse[0] - relativeelement.x - (isPolar ? chartObj.plotarea_approx.x : 0);
                var relMouseY = mouse[1] - relativeelement.y - (isPolar ? chartObj.plotarea_approx.y : 0);
                var relmousePt = {
                    x: relMouseX,
                    y: relMouseY
                };
                
                element = this;
                var containsBarchart = (chartObj.dataObject.noofBarEnabledSeries > 0);
                var func = (datatype === ORDINAL_DATATYPE && containsBarchart) ? getOrdinalDataPoint : getClosestPoint;
                var nearestPoint = func(relmousePt, xscale, yscale, systemConf);
                
                var seriespos = nearestPoint.seriesPos;
                var itemPos = nearestPoint.itemPos;
                var subseriesindex = (nearestPoint.subseriesindex instanceof Array) ? nearestPoint.subseriesindex[seriespos] : nearestPoint.subseriesindex;
                if (seriespos == null) {
                    if (isTouchEvent) {
                        chartObj.eventHandler.mouseOut();
                        chartObj.eventHandler.tapOldInfo = null;
                    }
                    return
                }
                
                var type = chartObj.chartTypes[seriespos].value;
                var plotOptions = seriesdata[seriespos].plotoptions,
                    commonPlotOptions = systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)];
                var clickFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType),
                    cursor = getEventConf(plotOptions, commonPlotOptions, chartObj, "cursor");
                
                if (clickFn != null) {
                    var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
                    var ysc = yscale[yscindex].eventscale;
                    var renderer = chartObj.renderer[seriespos];
                    var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
                    var data = currentSeriesdata[itemPos];
                    if (isBarChartType(type)) {
                        events.addCursor(cursor);
                        var evt = d3.event || chartObj.eventHandler.targetEvent,
                            dt = {
                                "x": nearestPoint.highlightpoint.x,
                                "y": nearestPoint.highlightpoint.y,
                                "data": chartObj.dataset.getMetaInfoObj(chartObj, data, seriespos)
                            };
                        invokeFunction(clickFn, evt, dt, chartObj);
                        
                    } else {
                        var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x");
                        var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y");
                        var mindist = (type === $ZC.charttype.area || type === $ZC.charttype.stkdarea || isPolar) ? null : lineDistance({
                                "x": xval,
                                "y": yval
                            }, relmousePt);
                        var rad = isBubbleChartType(type) ? chartObj.zscale(chartObj.dataset.getZ(data)) / 2 : 10;
                        if (mindist <= rad) {
                            events.addCursor(cursor);
                            //						var extraParams = "GC 0 "+tooltip.formatValue(systemConf,xdata,"x")+",2 "+seriesdata[seriespos].data[subseriesindex][itemPos][dataset.indices.clr]+",";
                            var evt = d3.event || chartObj.eventHandler.targetEvent,
                                dt = {
                                    "x": xval,
                                    "y": yval,
                                    "data": chartObj.dataset.getMetaInfoObj(chartObj, data, seriespos)
                                };
                            invokeFunction(clickFn, evt, dt, chartObj);
                            
                        } else {
                            events.hideCursor(chartObj.eventHandler.trackerElement);
                            return;
                        }
                    }
                } else if(isTouchEvent && (eventType !== "taphold")) {
                    tapOldInfo = chartObj.eventHandler.tapOldInfo;
                    if (!tapOldInfo || (tapOldInfo.itemPos != itemPos || tapOldInfo.seriesPos != seriespos || tapOldInfo.subseriesindex != subseriesindex)) {
                        chartObj.eventHandler.mouseMove({});

                        chartObj.eventHandler.tapOldInfo = {
                            seriesPos : seriespos,
                            subseriesindex : subseriesindex,
                            itemPos : itemPos
                        };
                    } else {
                        chartObj.eventHandler.mouseOut();
                        chartObj.eventHandler.tapOldInfo = null;
                    }
                }
            }
        }
    };
    
    events.doubleclick = function(data, index, args) {
        if (chartObj.chartRendered) {
            if (chartObj.noPropogate) {
                d3.event.stopPropagation();
            }

            var isTouchEvent = d3.event && d3.event.touches;
            if (isTouchEvent) {
                chartObj.eventHandler.mouseOut();
                chartObj.eventHandler.tapOldInfo = null;
            }

            var tooltip = chartObj.eventHandler.tooltipElement;
            tooltip.hide(tooltip.element);
            events.hideCursor(chartObj.eventHandler.trackerElement);
            
            var seriesdata = chartObj.seriesdata;
            var isPolar = chartObj.dataObject.isPolarAxisCategory,
                eventType = (chartObj.zcEventType) || "doubleclick";
            if (!chartObj.xymultiRenderer && !isPolar) {
                var chartName = chartObj.chartTypes[0].name;
                var plotOptions = seriesdata[chartObj.isNonAxisMultiSeriesCategory ? index : 0].plotoptions,
                    commonPlotOptions = systemConf.chart.plot.plotoptions[chartName];
                var dblClickFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType);
                if (dblClickFn != null) {
                    var evt = d3.event || chartObj.eventHandler.targetEvent,
                        dt = {
                            "data": chartObj.dataset.getMetaInfoObj(chartObj, (data.data || data), index)
                        };
                    invokeFunction(dblClickFn, evt, dt, chartObj);
                } else {
                    addNoteFunction(args);
                }
            } else {
                element = chartObj.eventHandler.trackerElement.node();
                var mouse = getMousePosition(element, d3.event);
                var relativeelement = bbox(element);
                var relMouseX = mouse[0] - relativeelement.x - (isPolar ? chartObj.plotarea_approx.x : 0);
                var relMouseY = mouse[1] - relativeelement.y - (isPolar ? chartObj.plotarea_approx.y : 0);
                var relmousePt = {
                    x: relMouseX,
                    y: relMouseY
                };
                
                element = this;
                var containsBarchart = (chartObj.dataObject.noofBarEnabledSeries > 0);
                var func = (datatype === ORDINAL_DATATYPE && containsBarchart) ? getOrdinalDataPoint : getClosestPoint;
                var nearestPoint = func(relmousePt, xscale, yscale, systemConf);
                
                var seriespos = nearestPoint.seriesPos;
                if (seriespos == null) {
                    return
                }
                var itemPos = nearestPoint.itemPos;
                var subseriesindex = (nearestPoint.subseriesindex instanceof Array) ? nearestPoint.subseriesindex[seriespos] : nearestPoint.subseriesindex;
                var renderer = chartObj.renderer[seriespos];
                var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
                var data = currentSeriesdata[itemPos];
                var type = chartObj.chartTypes[seriespos].value;
                var plotOptions = seriesdata[seriespos].plotoptions,
                    commonPlotOptions = systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)];
                var dblClickFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType),
                    cursor = getEventConf(plotOptions, commonPlotOptions, chartObj, "cursor");
                
                if (isBarChartType(type)) {
                    events.addCursor(cursor);
                    if (dblClickFn != null) {
                        var evt = d3.event || chartObj.eventHandler.targetEvent,
                            dt = {
                                "data": chartObj.dataset.getMetaInfoObj(chartObj, data, seriespos)
                            };
                        invokeFunction(dblClickFn, evt, dt, chartObj);
                    } else {
                        addNoteFunction(null, seriespos, itemPos, currentSeriesdata, nearestPoint.highlightpoint.x, nearestPoint.highlightpoint.y);
                    }
                } else {
                    var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
                    var ysc = yscale[yscindex].eventscale;
                    var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x") + (isPolar ? chartObj.plotarea_approx.x : 0);
                    var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y") + (isPolar ? chartObj.plotarea_approx.y : 0);
                    var mindist = (type === $ZC.charttype.area || type === $ZC.charttype.stkdarea || isPolar) ? null : lineDistance({
                            "x": xval,
                            "y": yval
                        }, relmousePt);
                    var rad = isBubbleChartType(type) ? chartObj.zscale(chartObj.dataset.getZ(data)) / 2 : 10;
                    if (mindist <= rad) {
                        events.addCursor(cursor);
                        if (dblClickFn != null) {
                            var evt = d3.event || chartObj.eventHandler.targetEvent,
                                dt = {
                                    "x": xval,
                                    "y": yval,
                                    "data": chartObj.dataset.getMetaInfoObj(chartObj, data, seriespos)
                                };
                            invokeFunction(dblClickFn, evt, dt, chartObj);
                        } else {
                            addNoteFunction(null, seriespos, itemPos, currentSeriesdata, xval, yval);
                        }
                    } else {
                        events.hideCursor(chartObj.eventHandler.trackerElement);
                        return;
                    }
                }
            }
        }
    };
    
    events.contextMenu = function(args) {
        var contextMenuFn = systemConf.chart.plot.events.contextmenu;
        if (contextMenuFn != null) {
            var evt = d3.event || chartObj.eventHandler.targetEvent;
            invokeFunction(contextMenuFn, evt, chartObj);
            d3.event.preventDefault();
        }
    };
    
    events.addCursor = function(cur) {
        var trackerElement = getEventTrackerElement();
        var cur = cur || (isObjectPropDefined(systemConf.chart, "zoom.type") && (chartObj.systemConf.chart.zoom.type != "none") ? "crosshair" : "pointer");
        trackerElement.style("cursor", cur);
    };
    
    events.hideCursor = function() {
        var trackerElement = getEventTrackerElement();
        trackerElement.style("cursor", "default");
    };
    
    function getEventTrackerElement() {
        return (chartObj.isAxisCategory && (chartObj.systemConf.chart.width || chartObj.systemConf.chart.height))
            ? defaultScrollElement
            : chartObj.eventHandler.trackerElement
    }
    function ordinalDatamouseMove(mouse, event, element) {
        var relativeelement = bbox(element);
        var relMouseX = mouse[0] - relativeelement.x;
        var relMouseY = mouse[1] - relativeelement.y;
        
        var relmousePt = {
            x: relMouseX,
            y: relMouseY
        };
        
        var nearestPoint = getOrdinalDataPoint(relmousePt, xscale, yscale, systemConf);
        var seriesdata = chartObj.seriesdata;
        var seriespos = nearestPoint.seriesPos;
        var xpos = nearestPoint.itemPos;
        var subseriesindex = nearestPoint.subseriesindex;
        highlightpoint = nearestPoint.highlightpoint;
        levelMarkerPoint = nearestPoint.levelMarkerPoint;
        subseriesindex = subseriesindex[seriespos];
        var oldInfo = chartObj.eventHandler.oldInfo;
        var tooltipShared = chartObj.systemConf.tooltip.sharedSeriesInfo;

        var isNoInfo = (seriespos == null) ? true : false;
        if (seriespos == null) {
            chartObj.eventHandler.mouseOut();
            chartObj.eventHandler.oldInfo = {
                "isNoInfo": isNoInfo
            };
            return
        }
        
        var type = chartObj.chartTypes[seriespos].value;
        var isRangeChart = type == $ZC.charttype.arearange;
        var yrangePos = (isRangeChart) ? 1 : null;
        var rangeBand = xscale.rangeBand != null ? xscale.rangeBand() : null;
        var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
        var ysc = yscale[yscindex].eventscale;
        var renderer = chartObj.renderer[seriespos];
        var data = ((renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex])[xpos];
        var xdata = dataset.getX(data); //chartObj.dataObject.getCategories("x")[xpos];
        var ydata = dataset.getY(data, yscindex);
        
        var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x", null, yrangePos);
        var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y", null, yrangePos);

        hoveredSeriesIndex = getLegendIndex(data, seriespos);

        if (!isBarChartType(type) && isWithinPlotarea(xval, yval) == null) {
            return;
        }
        // zcareahighlight
        
        if (oldInfo != null && !oldInfo.isNoInfo) {
            var oldNearestPoint = oldInfo.nearestPoint;
            var oldType = getChartType((oldInfo.type || chartObj.userdata.seriesdata.type), NUMERIC_DATATYPE);
            if (oldNearestPoint && (oldNearestPoint.seriesPos == nearestPoint.seriesPos) && (oldNearestPoint.itemPos == nearestPoint.itemPos) && (oldNearestPoint.subseriesindex == nearestPoint.subseriesindex) && (oldType == type)) {
                wrap.selectAll("#zcbarhighlight,#zcareahighlight").style("display", "");
                tooltipele.style("visibility", tooltipEnabled ? "visible" : "hidden");
                if (crosshair_enabled()) {
                    chartObj.staticPaneSVG.selectAll("g.crosshair").style("visibility", "visible")
                }
                return
            }
        }
        
        var distance = lineDistance({
            "x": xscale(xdata),
            "y": ysc(ydata)
        }, relmousePt);
        var seriesLen = (tooltipShared) ? chartObj.seriesdata.length : 1
        //highlighting new Info
        wrap.selectAll("#zcscatterhighlight").selectAll("*").remove();
        var tooltipSharedInfo = d3_map();
        
        for (var i = 0; i < seriesLen; i++) {
            var curSeriespos = (tooltipShared) ? i : seriespos;
            hoverSeries(chartObj, curSeriespos, xdata, xpos, subseriesindex, nearestPoint, tooltipShared, (distance > 10), tooltipSharedInfo)
            
        }
        
        // Tooltip shown values
        
        var tooltip = chartObj.eventHandler.tooltipElement;
        if (tooltipEnabled) {
            var evt = getEventObject(event);
            
            var tooltipPos = (tooltipShared && crosshair_enabled()) ? (
                    (axisrotated) ? ({
                            left: plotarea.width,
                            top: relmousePt.y,
                            actLeft: xval + plotarea.left,
                            actTop: relmousePt.y + plotarea.top
                        }) : ({
                            left: relmousePt.x,
                            top: 0,
                            actLeft: relmousePt.x + plotarea.left,
                            actTop: yval + plotarea.top
                        })
                ) : (
                    (axisrotated) ? ({
                            left: relmousePt.x,
                            top: relmousePt.y,
                            actLeft: xval + plotarea.left,
                            actTop: relmousePt.y + plotarea.top
                        }) : ({
                            left: relmousePt.x,
                            top: relmousePt.y,
                            actLeft: relmousePt.x + plotarea.left,
                            actTop: yval + plotarea.top
                        })
                );
            var dLeft = relmousePt.x - evt.clientX,
                dTop = relmousePt.y - evt.clientY;
            tooltipPos.left -= dLeft;
            tooltipPos.top -= dTop;
            tooltipPos.dLeft = dLeft + plotarea.left;
            tooltipPos.dTop = dTop + plotarea.top;
            
            var tooltipArgs = {
                "seriesindex": seriespos,
                "subseriespos": subseriesindex,
                "itempos": xpos,
                "color": color,
                "svgFillFunc":renderer.fillColorFunc,
                "tooltipSharedInfo": tooltipSharedInfo,
                "tooltipShared": tooltipShared
            };
            
            // TODO tooltipPos has to be changed with bellow code.
            // var tooltipPos = getTooltipPosition(evt, relmousePt, xval, yval, chartObj, nearestPoint, axisrotated, tooltipShared, tooltipSharedInfo, true);
            // tooltip.show(chartObj, tooltipPos, null, true, tooltipPos.helpers);
            
            tooltip.show(chartObj, tooltipPos, null, true, tooltipArgs);
        }
    }
    
    function xydatamouseMove(mouse, event, element) {
        var cursorFollowDist = 10,
            isPolar = chartObj.dataObject.isPolarAxisCategory;
        var relativeelement = bbox(element);
        var relMouseX = mouse[0] - relativeelement.x - (isPolar ? chartObj.plotarea_approx.x : 0);
        var relMouseY = mouse[1] - relativeelement.y - (isPolar ? chartObj.plotarea_approx.y : 0);
        var relmousePt = {
            x: relMouseX,
            y: relMouseY
        };
        
        var oldInfo = chartObj.eventHandler.oldInfo;
        var tooltipShared = systemConf.tooltip.sharedSeriesInfo;

        var evt = getEventObject(event),
            cur_container_top = relmousePt.y - event.clientY,
            cur_container_left = relmousePt.x - event.clientX;

        var nearestPoint = (tooltipShared) ? bisectX(relmousePt, xscale, yscale, systemConf) : getClosestPoint(relmousePt, xscale, yscale, systemConf);
        // var bisect = bisectX(relmousePt,xscale,yscale,systemConf)
        
        var seriespos = nearestPoint.seriesPos;
        var itemPos = nearestPoint.itemPos;
        var subseriesindex = nearestPoint.subseriesindex;
        
        var isNoInfo = (seriespos == null) ? true : false;
        if (seriespos == null) {
            // if(oldInfo != null && !oldInfo.isNoInfo){
            // 	console.log("mouseout")
            chartObj.eventHandler.mouseOut();
            // }
            chartObj.eventHandler.oldInfo = {
                "isNoInfo": isNoInfo
            }
            return
        }
        
        var seriesdata = chartObj.seriesdata;
        var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
        var ysc = yscale[yscindex].scale;
        var type = chartObj.chartTypes[seriespos].value;
        var isRangeChart = type == $ZC.charttype.arearange;
        var yrangePos = (isRangeChart) ? 1 : null;
        var rangeBand = xscale.rangeBand != null ? xscale.rangeBand() : null;
        var renderer = chartObj.renderer[seriespos];
        var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
        var data = currentSeriesdata[itemPos];
        var xdata = chartObj.dataset.getX(data);
        
        var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x", null, yrangePos);
        var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y", null, yrangePos);

        hoveredSeriesIndex = getLegendIndex(data, seriespos);

        var isAreaChart;
        if (!isPolar && isWithinPlotarea(xval, yval) == null) {
            return;
        }
        
        var tooltip = chartObj.eventHandler.tooltipElement;
        var distance = lineDistance({
            "x": xval,
            "y": yval
        }, relmousePt);
        // retaining oldinfo
        if (oldInfo != null && !tooltipShared) {
            var oldNearestPoint = oldInfo.nearestPoint;
            var oldType = getChartType((oldInfo.type || chartObj.userdata.seriesdata.type), NUMERIC_DATATYPE);
            if (oldNearestPoint && (oldNearestPoint.seriesPos == nearestPoint.seriesPos) && (oldNearestPoint.itemPos == nearestPoint.itemPos) && (oldNearestPoint.subseriesindex[oldNearestPoint.seriesPos] == nearestPoint.subseriesindex[nearestPoint.seriesPos]) && (oldType == type) && (oldInfo.containerLeft === cur_container_left) && (oldInfo.containerTop === cur_container_top)) {
                wrap.selectAll(isAreaChartType(type) ? "#zcscatterhighlight,#zcareahighlight" : "#zcscatterhighlight")
                    .style('display', "");
                tooltipele
                    .style("visibility", tooltipEnabled ? "visible" : "hidden");
                if (crosshair_enabled()) {
                    chartObj.staticPaneSVG.selectAll("g.crosshair").style("visibility", "visible")
                }
                return
            }
        }
        
        var seriesLen = (tooltipShared) ? chartObj.seriesdata.length : 1
        //highlighting new Info
        wrap.selectAll("#zcscatterhighlight").selectAll("*").remove();
        var tooltipSharedInfo = d3_map();
        
        for (var i = 0; i < seriesLen; i++) {
            var curSeriespos = (tooltipShared) ? i : seriespos;
            hoverSeries(chartObj, curSeriespos, xdata, itemPos, subseriesindex, nearestPoint, tooltipShared, (cursorFollowDist > distance), tooltipSharedInfo)
            
        }
        
        //tooltip
        if (tooltipEnabled) {
            var tooltipPos = (tooltipShared && crosshair_enabled()) ? (
                    (axisrotated) ? ({
                            left: plotarea.left,
                            top: yval,
                            actLeft: plotarea.left + xval,
                            actTop: plotarea.top + yval
                        }) : ({
                            left: xval,
                            top: 0,
                            actLeft: plotarea.left + xval,
                            actTop: plotarea.top + yval
                        })
                ) : ({
                    left: xval,
                    top: yval,
                    actLeft: (plotarea.left + xval),
                    actTop: (plotarea.top + yval),
                    distance: (chartObj.dataObject.isBubbleEnabled ? (chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "z", chartObj.zscale) / 2) : 0)
                });
            var dLeft = relmousePt.x - evt.clientX,
                dTop = relmousePt.y - evt.clientY;
            tooltipPos.left -= dLeft;
            tooltipPos.top -= dTop;
            tooltipPos.dLeft = dLeft + plotarea.left + (isPolar ? chartObj.plotarea_approx.x : 0);
            tooltipPos.dTop = dTop + plotarea.top + (isPolar ? chartObj.plotarea_approx.y : 0);
            
            var tooltipArgs = {
                "seriesindex": seriespos,
                "subseriespos": subseriesindex,
                "itempos": itemPos,
                "color": color,
                "svgFillFunc": (chartObj.dataObject.pieWithAxis ? chartObj.subrenderer[subseriesindex][xdata] : renderer).fillColorFunc,
                "tooltipShared": tooltipShared,
                "tooltipSharedInfo": tooltipSharedInfo
            };
            
            
            // TODO tooltipPos has to be changed with bellow code.
            // tooltipPos = getTooltipPosition(evt, relmousePt, xval, yval, chartObj, nearestPoint, axisrotated, tooltipShared, tooltipSharedInfo, false, isPolar);
            // if(chartObj.dataObject.isBubbleEnabled) {
            // 	tooltipPos.distance = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "z", chartObj.zscale) / 2;
            // }
            
            tooltip.show(chartObj, tooltipPos, null, true, tooltipArgs);
            
            // tooltip.show(chartObj,tooltipele,labelhighter,systemConf,dataset,{},{x:tooltip.formatValue(systemConf,xdata,"x"),y:ydata},seriespos,subseriesindex,itemPos,wrap,color,"numeric",plotarea,event);

            var oldInfo = chartObj.eventHandler.oldInfo;
            if (oldInfo) {
                oldInfo.containerLeft = cur_container_left;
                oldInfo.containerTop = cur_container_top;
            }
        }
        
    }
    
    function hoverPolygon(areahighlightWrap, type, plotOptions, commonPlotOptions, seriespos, subseriesindex, itemPos, xscale, ysc, yscindex, rangeBand, poly) {
        var seriesdata = chartObj.seriesdata;
        var fillOpacity = chartObj.systemConf.legend.patternPallete ? 0.5 : 0.2,
            fillColor = getRawColor(chartObj, seriespos, getCurrentDataPoint(seriespos, subseriesindex, itemPos), seriespos);
        var highlightEffect = chartObj.legendHighlight.getLegendHighlightEffect(seriespos, "selectedSeries", "plot");
        var highlightStyle = (highlightEffect === "none") ? {
                "fill": "transparent"
            } : chartObj.legendHighlight.getEffect(highlightEffect, "area", fillColor, {fill: "transparent", stroke:fillColor}, seriespos);
        hideUnselectedWrap(wrap.selectAll("g#zcbarhighlight"));
        areahighlightWrap.style("display", "")
            .attr("transform", "translate(" + plotarea.left + "," + (plotarea.top) + ")")
            .style(highlightStyle);
        var interpolation = gvpFn(plotOptions, commonPlotOptions)("mode"),
            fillOpacity = validateNullVal(commonPlotOptions.hoveroptions.fillOpacity, 0.2);
        var y0 = null;
        var x1, y1, x2, y2;
        var x, y, width, height;
        var isCatNullX = isCatNull(dataset, "x"),
            isCatNullY = isCatNull(dataset, "y", yscindex);
        
        if (interpolation == "linear" && poly != null) {
            var polyPoints = d3_merge(poly.map(function(d, i) {
                return [d.x, d.y]
            }));
            
            var polygon = appendEle(areahighlightWrap, "polygon", [poly], ".", "class", "areapoly");
            polygon
                .attr("points", polyPoints.toString())
                .style({
                    "fill-opacity": fillOpacity,
                    "display": ""
                });
        } else {
            var isStkd = stacked(type),
                hasNegValue = chartObj.dataObject.containsNegativeData(yscindex),
                xaxisReversed = chartObj.systemConf.chart.axes.xaxis.reversed,
                yaxisReversed = chartObj.systemConf.chart.axes.yaxis[yscindex || 0].reversed,
                area, serdata;
            if (chartObj.dataObject.isPolarAxisCategory) {
                var renderer = chartObj.renderer[seriespos];
                serdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
                var polarBaseIdx = (yaxisReversed && !isStkd) ? ysc.domain().length - 1 : 0;

                var outerRadiusFn = function(d, j) {
                        var OR = (isStkd) ? ysc(d.y0 + d.y) : (ysc(dataset.getY(d, yscindex)) + ((ysc.rangeBand != null) ? ysc.rangeBand() / 2 : 0));
                        return mathMax(OR, ysc.range()[polarBaseIdx]);
                    },
                    innerRadiusFn = function(d, j) {
                        var IR;
                        if (isStkd) {
                            IR = (seriespos == 0) ? mathMin(ysc.range()[0], ysc(hasNegValue)) : ysc(d.y0);
                        } else {
                            IR = (ysc(ysc.domain()[polarBaseIdx]) + ((ysc.rangeBand != null) ? ysc.rangeBand() / 2 : 0));
                        }
                        return mathMax(IR, ysc.range()[polarBaseIdx]);
                    },
                    isLineHighlight = highlightEffect === "strokeEnlarge";

                area = (isLineHighlight ? d3_lineRadial : d3_areaRadial)()
                    .angle(function(d, j) {
                        return xscale(dataset.getX(d));
                    })
                    .interpolate(interpolation);

                if (isLineHighlight) {
                    area
                    .radius(outerRadiusFn);
                } else {
                    area
                    .outerRadius(outerRadiusFn)
                    .innerRadius(innerRadiusFn);
                }
   
            } else {
                var isRangeChart = type == $ZC.charttype.arearange;
                var yrangePos = (isRangeChart) ? 1 : null;
                var renderer = chartObj.renderer[seriespos];
                var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
                var data = currentSeriesdata[itemPos];
                var xval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, data, "x", null, yrangePos),
                    yval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, data, "y", null, yrangePos),
                    isNotFirstData = (itemPos != 0),
                    isNotLastData = (itemPos != currentSeriesdata.length - 1);

                if (xaxisReversed ? isNotLastData : isNotFirstData) {
                    var prevData = currentSeriesdata[xaxisReversed ? (itemPos + 1) : (itemPos - 1)];
                    var prevXval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, prevData, "x", null, yrangePos);
                    var prevYval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, prevData, "y", null, yrangePos);
                    x1 = (xval + prevXval) / 2;
                    y1 = (yval + prevYval) / 2;
                }
                if (xaxisReversed ? isNotFirstData : isNotLastData) {
                    var nextData = currentSeriesdata[xaxisReversed ? (itemPos - 1) : (itemPos + 1)]
                    var nextXval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, nextData, "x", null, yrangePos);
                    var nextYval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, nextData, "y", null, yrangePos);
                    x2 = (xval + nextXval) / 2;
                    y2 = (yval + nextYval) / 2;
                }
                
                x = (axisrotated) ? 0 : (x1 == null) ? xval : x1;
                y = d3_min([y1, yval, y2, ysc(ysc.domain()[yaxisReversed ? 0 : 1])]);
                width = (axisrotated) ? (d3_max([x1, xval, x2, (ysc(hasNegValue) || xval)])) : (x1 != null && x2 != null) ? (x2 - x1) : (x1 == null) ? ((x2 == null) ? 1 : (x2 - xval)) : (xval - x1);
                height = (axisrotated) ? ((y1 == null) ? (yval - y2) : ((y2 == null) ? (y1 - yval) : (y1 - y2))) : plotarea.height - y;

                var dx1 = Math.max(0, -x),
                    dy1 = Math.max(0, -y),
                    dx2 = Math.max(0, x + width - plotarea.width - (chartObj.scrolledX || 0)),
                    dy2 = Math.max(0, y + height - plotarea.height - (chartObj.scrolledY || 0));

                x = Math.max(0, x);
                y = Math.max(0, y);
                width -= (dx1 + dx2);
                height -= (dy1 + dy2);
                
                areahighlightWrap
                    .style("display", "block");
                
                serdata = currentSeriesdata;
                area = d3_area()
                    .defined(function(d, j) {
                        return !isCatNullY(dataset.getY(d, yscindex)) && !isCatNullX(dataset.getX(d));
                    })
                    .x(function(d, j) {
                        return chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, d, "x")
                    })
                    .y(function(d, j) {
                        return chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, d, "y", null, yrangePos)
                    })
                    .interpolate(interpolation);
                if (axisrotated) {
                    area.x0(function(d, i) {
                        if (isStkd) {
                            return ((seriespos == 0) && (subseriesindex == 0) && (i == 0)) ? mathMax(ysc.range()[0], ysc(hasNegValue)) : ysc(d.y0);
                        } else {
                            return (ysc.rangeBand != null) ? (ysc.range()[0] + ysc.rangeBand()) : mathMax(ysc.range()[0], ysc(hasNegValue));
                        }
                    });
                } else {
                    area.y0(function(d, i) {
                        if (isStkd) {
                            return ((seriespos == 0) && (subseriesindex == 0) && (i == 0)) ? mathMin(ysc.range()[0], ysc(hasNegValue)) : ysc(d.y0);
                        } else {
                            if (isRangeChart) {
                                return chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, d, "y", null, 0);
                            } else {
                                return (ysc.rangeBand != null) ? (ysc.range()[0] + ysc.rangeBand()) : mathMin(ysc.range()[0], ysc(hasNegValue));
                            }
                        }
                        // return (ysc.rangeBand != null) ? (ysc.range()[0]+ysc.rangeBand()) : Math.min(ysc.range()[0],ysc(hasNegValue));}
                    });
                }
            }

            var properties = {
                name: "rect",
                id: chartObj.id,
                x: x,
                y: y,
                width: width,
                height: height
            },
            args = {
                chartObj: chartObj
            };
            var clipID = effects.get(svg_clips, "rect", properties, args);

            var areahighlight = wrap.selectAll("#areapath");
            areahighlight.datum(serdata)
                .attr("d", area)
                .attr("stroke", "")
                .attr("clip-path", chartObj.dataObject.isPolarAxisCategory ? null : "url(" + chartObj.defsLocation + "#" + clipID + ")")
                .style({
                    "fill-opacity": fillOpacity,
                    "display": ""
                });
        }
        
        
    }
    
    function hoverRect(barWrap, highlightpoint, radius, renderer, yaxisReversed) {
        var t = getRectTranslation(highlightpoint),
            path = getRect(highlightpoint, radius, yaxisReversed);

        hideUnselectedWrap(wrap.selectAll("g#zcareahighlight,g#zcscatterhighlight"));
        wrap.selectAll("g#zcbarhighlight").style("display", "");
        barWrap
            .attr("d", path)
            .attr("transform", "translate(" + t[0] + "," + t[1] + ")")
            .style("display", "");
    }
    
    function hoverScatter(scatterWrap, type, plotOptions, commonPlotOptions, xval, yval, xscale, ysc, yscindex, seriesdata, subseriesindex, seriespos, itemPos, isAreaChart, ganttMarkerProp) {
        var isGantt = type == $ZC.charttype.gantt,
            highlightEffect = chartObj.legendHighlight.getLegendHighlightEffect(seriespos, "selectedSeries", "plot"),
            isPatternPalleteEnabled = hasPatternPallete(chartObj) && (isBubbleChartType(type) || type === $ZC.charttype.scatter) && (highlightEffect !== "strokeEnlarge"),
            fillColor = getRawColor(chartObj, (commonPlotOptions.multiColoring && !chartObj.legendarea.show ? itemPos : seriespos), getCurrentDataPoint(seriespos, subseriesindex, itemPos), seriespos);
        if (!isGantt) {
            hideUnselectedWrap(wrap.selectAll("g#zcbarhighlight"));
        }
        if (!isAreaChart && !chartObj.dataObject.isPolarAxisCategory) {
            hideUnselectedWrap(wrap.selectAll("g#zcareahighlight").selectAll("*"));
            hideUnselectedWrap(wrap.selectAll("g#zcareahighlight"));
        }
        
        var scatterParentWrap = wrap.selectAll("#zcscatterhighlight"),
            mOptions = (plotOptions ? mergeJSON(commonPlotOptions.hoveroptions, plotOptions.hoveroptions, true) : commonPlotOptions.hoveroptions),
            innerSymbolSize, outerSymbolSize;
        
        if (isGantt && commonPlotOptions.marker && commonPlotOptions.marker.enabled === false) {
            return
        }
        
        if (isBubbleChartType(type)) {
            var z = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, seriesdata[seriespos].data[subseriesindex][itemPos], "z", chartObj.zscale);

            if (isPatternPalleteEnabled) {
                outerSymbolSize = z * 0.1;
                innerSymbolSize = 0;
            } else {
                outerSymbolSize = (z + perToPx("2.5%", mathMin(plotarea.width, plotarea.height))) * 0.1;
                innerSymbolSize = (z / 2) * 0.1;
            }

        } else {
            var lineOrArea = (type === $ZC.charttype.line || isAreaChartType(type)),
                isPolar = chartObj.dataObject.isPolarAxisCategory,
                markerSize = (plotOptions && plotOptions.marker) ? gvpFn(plotOptions.marker, commonPlotOptions.marker)("size") : commonPlotOptions.marker.size;
            
            var symbolsize = ((lineOrArea || isPolar) && (markerSize == null || markerSize === "")) ? gvpFn(plotOptions, commonPlotOptions)("strokeWidth") : (markerSize || 1);
            symbolsize = (mOptions.size != null && mOptions.size !== "") ? 1 : +symbolsize;
            if (isGantt) {
                mOptions = (plotOptions ? mergeJSON(ganttMarkerProp.hoveroptions, plotOptions.hoveroptions, true) : ganttMarkerProp.hoveroptions)
            }

            var outerSymbolSizeFactor,
                innerSymbolSizeFactor;

            if (isPolar) {
                outerSymbolSizeFactor = 0.7;
                innerSymbolSizeFactor = 0.35;
            } else if (lineOrArea) {
                outerSymbolSizeFactor = 0.9;
                innerSymbolSizeFactor = 0.4;
            } else if (isPatternPalleteEnabled) {
                outerSymbolSizeFactor = 1;
                innerSymbolSizeFactor = 0;
            } else {
                outerSymbolSizeFactor = 2;
                innerSymbolSizeFactor = 1;
            }

            outerSymbolSize = symbolsize * outerSymbolSizeFactor;
            innerSymbolSize = symbolsize * innerSymbolSizeFactor;
        }
        
        scatterParentWrap
            .attr("transform", "translate(" + plotarea.left + "," + plotarea.top + ")")
            .style('display', "");
        addSVGmarker(scatterWrap, null, (isPatternPalleteEnabled ? {symbol: mOptions.symbol} : mOptions), {
            "color": isPatternPalleteEnabled ? null : fillColor,
            symbolSize: {
                "inner": innerSymbolSize,
                "outer": outerSymbolSize
            },
            "transform": [xval, yval],
            "imageSize": 15
        });

        if (isPatternPalleteEnabled) {
            var highlightStyle = (highlightEffect === "none") ? {
                    "fill": "transparent"
                } : chartObj.legendHighlight.getEffect(highlightEffect, "scatter", (/(illuminate|moody|flip)/.test(highlightEffect) ? fillColor : "transparent"), {fill: "transparent", stroke:fillColor}, seriespos);
            scatterWrap.style(highlightStyle);
        }

    }
    
    function hoverSeries(chartObj, seriespos, actXdata, itemPos, subseriesindex, nearestPoint, tooltipShared, showCursor, tooltipSharedInfo, highlightPoints) {
        var seriesdata = chartObj.seriesdata;
        var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
        var ysc = yscale[yscindex].scale;
        var type = chartObj.chartTypes[seriespos].value;
        var isRangeChart = type == $ZC.charttype.arearange;
        var isGantt = type === $ZC.charttype.gantt;
        var isPolar = chartObj.dataObject.isPolarAxisCategory;
        var yrangePos = (isRangeChart || isGantt) ? 1 : null;
        var rangeBand = xscale.rangeBand != null ? xscale.rangeBand() : null;
        var renderer = chartObj.renderer[seriespos];
        var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
        var actData = currentSeriesdata[itemPos];
        itemPos = (actData && dataset.getX(actData) === actXdata) ? itemPos : getContinousDataItempos(actXdata, currentSeriesdata);
        if (itemPos == null || eventDisabled(chartObj.seriesdata[seriespos])) { // If there is no data for this particular item for this series
            return
        }
        
        tooltipSharedInfo.set(seriespos, itemPos);
        add_pattern_to_tooltipSharedInfo(tooltipSharedInfo, seriespos);
        
        var data = currentSeriesdata[itemPos];
        var isAreaChart;
        
        var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x", null, yrangePos);
        var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y", null, yrangePos);
        
        var plotOptions = seriesdata[seriespos].plotoptions;
        var commonPlotOptions = systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)],
            eventType = (chartObj.zcEventType) || "mousemove";
        var mouseMoveFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType),
            cursor = getEventConf(plotOptions, commonPlotOptions, chartObj, "cursor");
        
        if (!((type === $ZC.charttype.line || type === $ZC.charttype.scatter && (showCursor)))) {
            events.addCursor(cursor);
        } else {
            events.hideCursor(chartObj.eventHandler.trackerElement);
        }
        
        if (mouseMoveFn != null) {
            var evt = d3.event || chartObj.eventHandler.targetEvent;
            ((typeof mouseMoveFn === "string") ? window[mouseMoveFn] : mouseMoveFn)(evt, {
                "x": xval,
                "y": yval,
                "data": chartObj.dataset.getMetaInfoObj(chartObj, seriesdata[seriespos].data[subseriesindex][itemPos], seriespos)
            }, chartObj);
        } else {
            highlightpoint = highlightPoints || highlightpoint;
            if (highlightpoint != null && isBarChartType(type)) {
                var yaxisReversed = chartObj.systemConf.chart.axes.yaxis[yscindex || 0].reversed;
                var borderOptions = gvpFn(plotOptions, commonPlotOptions)("border") || {};
                var borderRadius = (type === $ZC.charttype.bullet) ? 0 : borderOptions.radius;
                borderRadius = (borderOptions && borderOptions.show) ? borderRadius : 0;
                var renderer = chartObj.renderer[seriespos];
                //radius = renderer.getParamValue("radius",null,null,null,borderRadius);
                var radius = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, borderRadius);
                var highlightEffect = chartObj.legendHighlight.getLegendHighlightEffect(seriespos, "selectedSeries", "plot"),
                    fillColor = getRawColor(chartObj, (commonPlotOptions.multiColoring && !chartObj.legendarea.show ? itemPos : seriespos), getCurrentDataPoint(seriespos, subseriesindex, itemPos), seriespos);
                var highlightStyle = (highlightEffect === "none") ? {
                        "fill": "transparent"
                    } : chartObj.legendHighlight.getEffect(highlightEffect, "bar", (/(illuminate|moody|flip)/.test(highlightEffect) ? fillColor : "transparent"), {fill: "transparent", stroke:fillColor}, seriespos);
                
                var barWrap = wrap.selectAll("#zcbarhighlight").select("#barpath")
                    .style(highlightStyle);
                hoverRect(barWrap, highlightpoint, radius, renderer, yaxisReversed);
                var levelMarker = (plotOptions && plotOptions.levelMarker) ? mergeJSON(commonPlotOptions.levelMarker, plotOptions.levelMarker, true) : commonPlotOptions.levelMarker;
                if (isGantt && levelMarker.enabled) {
                    
                    var levelMarkrad = chartObj.dataObject.getTransRectValue("radius", null, null, null, 0);
                    var style = {
                        "fill": levelMarker.color || fillColor
                    };
                    var levelMarkerWrap = appendEle(wrap.selectAll("#zcbarhighlight"), "path", [1], "#", "id", "levelMarkerpath");
                    levelMarkerWrap.style(style)
                    hoverRect(levelMarkerWrap, levelMarkerPoint, levelMarkrad, renderer, yaxisReversed)
                }
            }
            
            if (!tooltipShared && (isAreaChartType(type) || isPolar)) {
                isAreaChart = true;
                var areahighlightWrap = wrap.selectAll("#zcareahighlight");
                hoverPolygon(areahighlightWrap, type, plotOptions, commonPlotOptions, seriespos, subseriesindex, itemPos, xscale, ysc, yscindex, rangeBand, nearestPoint.poly)
            }
            if (isAreaChartType(type) || isPointChartType(type) || type === $ZC.charttype.line || isPolar || isGantt) {
                var scatterWrap = wrap.selectAll("#zcscatterhighlight");
                var currentWrap = appendEle(scatterWrap, "g", [1], ".", "class", ("highlight" + seriespos));
                var ganttMarkerSize = 0;
                
                if (isRangeChart || isGantt) {
                    var yrangePos_0 = appendEle(currentWrap, "g", [1], ".", "class", "yrangePos_0");
                    var yrangePos_1 = appendEle(currentWrap, "g", [1], ".", "class", "yrangePos_1");
                    var xval_0, yval_0, prop = {};
                    if (isGantt) {
                        prop = renderer.markerProperties;
                        
                        var pos = renderer.getMarkerPosition(data, prop.subseriesIndex, 0, renderer.commonOption);
                        if (axisrotated) {
                            xval = pos.y;
                            yval = pos.x + pos.width / 2;
                            xval_0 = pos.y + pos.height;
                            yval_0 = pos.x + pos.width / 2;
                        } else {
                            xval = pos.x + pos.width / 2;
                            yval = pos.y;
                            xval_0 = pos.x + pos.width / 2;
                            yval_0 = pos.y + pos.height;
                        }
                    } else {
                        xval_0 = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x", null, 0);
                        yval_0 = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y", null, 0);
                        ;
                    }
                    hoverScatter(yrangePos_0, type, plotOptions, commonPlotOptions, xval_0, yval_0, xscale, ysc, yscindex, seriesdata, subseriesindex, seriespos, itemPos, isAreaChart, {
                        "size": prop.size,
                        "hoveroptions": commonPlotOptions.hoveroptions.end
                    });
                    hoverScatter(yrangePos_1, type, plotOptions, commonPlotOptions, xval, yval, xscale, ysc, yscindex, seriesdata, subseriesindex, seriespos, itemPos, isAreaChart, {
                        "size": prop.size,
                        "hoveroptions": commonPlotOptions.hoveroptions.start
                    })
                } else {
                    hoverScatter(currentWrap, type, plotOptions, commonPlotOptions, xval, yval, xscale, ysc, yscindex, seriesdata, subseriesindex, seriespos, itemPos, isAreaChart)
                }
                
            }
            
            if (isPolar) {
                wrap.selectAll("#zcareahighlight,#zcscatterhighlight")
                    .attr({
                        "clip-path": null,
                        "transform": "translate(" + (plotarea.left + chartObj.plotarea_approx.x) + "," + (plotarea.top + chartObj.plotarea_approx.y) + ")"
                    })
                    .style("display", "");
            }
            
        }
        chartObj.eventHandler.oldInfo = {
            "nearestPoint": nearestPoint,
            "type": type,
            "chartObj": chartObj,
            "isNoInfo": false
        };
    }
    
    function add_pattern_to_tooltipSharedInfo(tooltipSharedInfo, seriespos) {
        var clrIdx = dataset.getColumnIdx("clr"),
            yidx = dataset.getColumnIdx("y", (chartObj.seriesdata[seriespos].yaxiscolumnorder || [0, 0]));
        var y_pattern = "{{val(" + yidx + ")}}";
        tooltipSharedInfo.y_val_pattern = tooltipSharedInfo.y_val_pattern || "";
        tooltipSharedInfo.y_col_pattern = tooltipSharedInfo.y_col_pattern || "";
        
        if (tooltipSharedInfo.y_val_pattern.indexOf(y_pattern) == -1) {
            tooltipSharedInfo.y_val_pattern += y_pattern;
            tooltipSharedInfo.y_col_pattern += (chartObj.ismultiy || clrIdx == null) ?
                ((tooltipSharedInfo.y_col_pattern != "") ? "" : "{{val(null)}}") :
                "{{val(" + clrIdx + ")}}";
        }
    }
    
    function getOrdinalDataPoint(relmousePt, xscale, yscale, systemConf) {
        var xaxisReversed = chartObj.systemConf.chart.axes.xaxis.reversed;
        var categorypos = $ZC.scale.invert(ORDINAL_DATATYPE, relmousePt, barscale1, axisrotated, null, xaxisReversed);
        
        
        var seriesdata = chartObj.seriesdata;
        var isComboChart = chartObj.dataObject.isCombinationalChart;
        
        var series_enabled = -1;
        var highlightpoint, levelMarkerPoint, itemPos, minTriggerOffset, xpos, subseries;
        var poly = null;
        var containsLine = false;
        var toHighlight = false;
        var tooltipShared = systemConf.tooltip.sharedSeriesInfo;
        
        var X = "x",
            Y = "y";
        if (axisrotated) {
            X = "y";
            Y = "x";
        }
        
        var yminimumBisected = seriesdata.map(function(d, i) {
            var type = chartObj.chartTypes[i].value;
            minTriggerOffset =  (minTriggerOffset == null) ? getTriggeringOffset(type,tooltipShared,chartObj.dataObject.isCombinationalChart,null) : minTriggerOffset;
            var yaxiscolumnorder = getParsedYAxisOrder(d.yaxiscolumnorder);
            var yaxisReversed = chartObj.systemConf.chart.axes.yaxis[yaxiscolumnorder || 0].reversed;
            var ysc = yscale[yaxiscolumnorder].eventscale;
            var hasNegValue = chartObj.dataObject.containsNegativeData(yaxiscolumnorder),
                isCatNullY = isCatNull(dataset, "y", yaxiscolumnorder),
                polygonPoints = {};
            
            if (eventDisabled(d)) {
                return [null]
            } else {
                series_enabled++;
                var renderer = chartObj.renderer[i];
                
                /**
                 *
                 * @type {*|{stacked, categories, axisrotated, bandwidth1, bandwidth2, barDatasetIndex, padding, yscale, hasNegValue, yaxiscolumnorder, addRangeBand, barWidth, levelMarkerWidth, levelMarkerPadding}|*}
                 */
                var commonOption = renderer.commonOption || getBarCommonOption(chartObj.rendererConf[i], i);
                
                return d.data.map(function(d, j) {
                    // var curpt = {};
                    var seriesdataAfterUpdate = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[j] : d;
                    xpos = getCategoryXpos(categorypos, seriesdataAfterUpdate) || null; //fix for different category set for two different series
                    if(xpos == null){
                        return;
                    }
                    if (isHeatMapChartType(type)) {
                        var a = null;
                        seriesdataAfterUpdate.forEach(function(dt, k) {
                            var curpt = getHeatCellPosition(chartObj, dt, xscale, ysc, yaxiscolumnorder);
                            var isWithinClrRange = isWithinColorRange(dataset.getClr(dt), chartObj);
                            var dist = isWithin(curpt, relmousePt);

                            if (isWithinClrRange && dist == 0 && !toHighlight && a === null) {
                                toHighlight = true;
                                itemPos = k;
                                highlightpoint = curpt;
                                a = dist;
                            }

                        });
                        return a;
                    } else if (isBarChartType(type)) {
                        var len = xpos.length;
                        var dist = null;
                        for(var m = 0;m<len;m++){
                            var curXpos = xpos[m]; //Handled multi data for same category
                            if (seriesdataAfterUpdate[curXpos] == null) {
                                return null;
                            }

                            var curpt = getBarPosition(chartObj, seriesdataAfterUpdate[curXpos], j, commonOption);

                            if (isCatNullY(seriesdataAfterUpdate[curXpos])) { //If the y value is null and nullformatter is undefined, don't show tooltip for that data
                                return null;
                            }
                            var curdist = isWithin(curpt, relmousePt, yaxisReversed);
                            var isWithinClrRange = isWithinColorRange(dataset.getClr(seriesdataAfterUpdate[curXpos]), chartObj);

                            if (isWithinClrRange && curdist == 0 && !toHighlight) {
                                dist = 0;
                                toHighlight = true;
                                itemPos = curXpos;
                                highlightpoint = curpt;
                                if (type === $ZC.charttype.gantt) {
                                    levelMarkerPoint = renderer.getGanttLevelMarkerProp(seriesdataAfterUpdate[curXpos], j, curXpos, commonOption);
                                }
                            }
                        }
                        return dist;
                    } else if (isAreaChartType(type) || isPointChartType(type) || type === $ZC.charttype.line) {
                        xpos = xpos[0]; //Hack for other charts where multi data for same category not handled
                        minTriggerOffset = isBubbleChartType(type) ? getTriggeringOffset(type,tooltipShared,chartObj.dataObject.isCombinationalChart,chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yaxiscolumnorder, seriesdataAfterUpdate[xpos], "z", chartObj.zscale) / 2) : minTriggerOffset;
                        var isWithinClrRange = isWithinColorRange(dataset.getClr(seriesdataAfterUpdate[xpos]), chartObj);

                        if (isScatterChartType(type) || type === $ZC.charttype.line) {
                            var markerSize = (renderer.getSymbolSize) ? renderer.getSymbolSize(d) : 0;
                            dist = getMinDistByPtToPt(seriesdataAfterUpdate[xpos], relmousePt, xscale, ysc, yaxiscolumnorder, type, null, X, Y);
                            dist = dist - (markerSize/2);
                        } else {
                            var isRangeChart = type == $ZC.charttype.arearange;
                            polygonPoints = getPolygonPoints(i, j, xpos, seriesdataAfterUpdate, seriesdataAfterUpdate[xpos - 1], seriesdataAfterUpdate[xpos], seriesdataAfterUpdate[xpos + 1], chartObj.dataObject, dataset, axisrotated, stacked(type), xscale, ysc, yaxiscolumnorder, hasNegValue, isRangeChart)
                            var isWithinPoly = (isAreaChartType(type) || isComboChart) ? ((type === $ZC.charttype.bubblepie) ? pointInPie(relmousePt, polygonPoints, i, j, seriesdataAfterUpdate[xpos]) : pointInPolygon(relmousePt, polygonPoints.points)) : true;
                            if (isWithinPoly) {
                                dist = (j == 0) ? distToSegment(relmousePt, polygonPoints.curpt, polygonPoints.curNext) :
                                    (j == seriesdataAfterUpdate.length - 1) ? distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt) :
                                        d3_min([distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt), distToSegment(relmousePt, polygonPoints.curpt, polygonPoints.curNext)]);
                            }
                        }
                        
                        if (isWithinClrRange && (minTriggerOffset == null || dist < minTriggerOffset) && dist != null) {
                            toHighlight = true;
                            minTriggerOffset = dist;
                            seriespos = i;
                            subseries = j;
                            itemPos = xpos;
                            poly = polygonPoints.points;
                            containsLine = (type === $ZC.charttype.line || isPointChartType(type));
                        }
                        return dist
                    }
                    
                })
            }
            
        });
        
        var subseriesindex = [];
        var min_yminimumBisected = yminimumBisected.map(function(d, i) {
            var min = d3_min(d);
            subseriesindex[i] = (min != null) ? d.indexOf(min) : null;
            return min
        });
        if (containsLine) {
            min_yminimumBisected = min_yminimumBisected.map(function(d, i) {
                var type = chartObj.chartTypes[i].value;
                if (type === $ZC.charttype.line || isPointChartType(type)) {
                    return d;
                } else {
                    return null
                }
            })
        }
        
        var seriespos = min_yminimumBisected.indexOf(d3_min(min_yminimumBisected));
        if (min_yminimumBisected[seriespos] == null || !toHighlight) {
            seriespos = null
        }
        return {
            "seriesPos": seriespos,
            "itemPos": itemPos,
            "subseriesindex": subseriesindex,
            "highlightpoint": highlightpoint || null,
            "levelMarkerPoint": levelMarkerPoint || null,
            "distance": min_yminimumBisected[seriespos],
            "poly": poly
        };
    }
    
    function getCategoryXpos(xpos, data, isMultiCat) {
        var categories = xscale.domain();
        var xval = categories[xpos],
            pos = null,
            isCatNullX = isCatNull(dataset, "x");
        data.forEach(function(d, i) {
            var hasX = !isCatNullX(dataset.getX(d)) && (dataset.getX(d) === xval);
            if (hasX) {
                (pos == null) ?pos =  [i] : pos.push(i); // Create array for multiple data for same category
            }
            return hasX;
        });
        return pos;
    }
    
    function getContinousDataItempos(item, data) {
        var pos = null,
            isCatNullX = isCatNull(dataset, "x");
        data.some(function(d, i) {
            var hasX = !isCatNullX(dataset.getX(d)) && (dataset.getX(d) === item);
            if (hasX) {
                pos = i;
            }
            return hasX;
        });
        return pos;
    }
    
    function addNoteFunction(args, seriespos, itemPos, currentSeriesdata, xval, yval) {
        var canAddOnDoubleclickEvent = (chartObj.systemConf.notes) && chartObj.systemConf.notes.addOnDoubleclickEvent;
        if ($ZC.annotation && canAddOnDoubleclickEvent) {
            if (!args) {
                var seriesdata = chartObj.seriesdata;
                var currentEle = currentSeriesdata[itemPos];
                var clonedata = currentEle.slice();
                var data = clonedata.splice(0, clonedata.length);
                if (seriesdata.length > 1) {
                    data.push(seriesdata[seriespos].seriesname);
                }
                args = {
                    "coordinate": [xval, yval],
                    "data": data,
                    "basedOn": "plot"
                };
            }
            $ZC.annotation.addNotes(chartObj, args);
        }
    }
    
    function bisectX(relmousePt, xscale, yscale, systemConf) {
        var plotX = xscale.invert((axisrotated) ? relmousePt.y : relmousePt.x);
        var seriesdata = systemConf.seriesdata.chartdata;
        
        var xBisector = d3_bisector(function(d) {
            return dataset.getX(d)
        }).left;
        
        var xbisect = seriesdata.map(function(d, i) {
            if (d.disabled) {
                return null;
            }

            var renderer = chartObj.renderer[i];
            return d.data.map(function(d, j) {
                d = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[j] : d;
                return xBisector(d, plotX, 0, d.length - 1);
            })
            
        });
        
        var xminimumBisected = seriesdata.map(function(d, i) {
            if (d.disabled) {
                return null;
            }

            var renderer = chartObj.renderer[i];
            var yscindex = getParsedYAxisOrder(d.yaxiscolumnorder);
            var type = chartObj.chartTypes[i].value;
            var ysc = yscale[yscindex].scale;
            return d.data.map(function(d, j) {
                d = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[j] : d;
                var xbis = xbisect[i][j],
                    curpt,
                    isWithinClrRange;

                if (d[xbis]) { //Test_615.json If seriesdata.chartdata[i].data =[[]] and other series has data, d[xbis] will be null
                    curpt = {
                        x: xscale(dataset.getX(d[xbis])),
                        y: (stacked(type) ? ysc(d[xbis].y + d[xbis].y0) : ysc(dataset.getY(d[xbis], yscindex)))
                    };
                    isWithinClrRange = isWithinColorRange(dataset.getClr(d), chartObj);
                }

                if (xbis > 0) {
                    var dis = mathAbs(relmousePt.x - curpt.x)
                    var prevpt = {
                        x: xscale(dataset.getX(d[xbis - 1])),
                        y: (stacked(type) ? ysc(d[xbis - 1].y + d[xbis - 1].y0) : ysc(dataset.getY(d[xbis - 1], yscindex)))
                    };
                    var prevptDis = mathAbs(relmousePt.x - prevpt.x);
                    var vv = ((dis) > (prevptDis) ? xbis - 1 : xbis);
                    dis = (dis) > (prevptDis) ? prevptDis : dis;
                    var curpt2mousedis = lineDistance(curpt, relmousePt);
                    var prept2mousedis = lineDistance(relmousePt, prevpt);
                    return {
                        "dist": isWithinClrRange ? dis : null,
                        "xbis": vv
                    };
                } else if (xbis == 0) {
                    var dis = (isWithinClrRange && curpt) ? mathAbs(relmousePt.x - curpt.x) : null;
                    return {
                        "dist": dis,
                        "xbis": xbis
                    };
                }
            })
            
        });
        var subseriesindex = [];
        var xpos = [];
        var min_xminimumBisected = xminimumBisected.map(function(d, i) {
            if (!d) {
                return null;
            }
            var arr = d.map(function(d) {
                return d.dist
            })
            var min = d3_min(arr);
            var idx = arr.indexOf(min);
            subseriesindex[i] = (min) ? idx : null;
            xpos[i] = (min) ? d[idx].xbis : null;
            return min;
        });
        var seriespos = min_xminimumBisected.indexOf(d3_min(min_xminimumBisected));
        var itemPos = xpos[seriespos];
        // console.log("minbisect")
        // console.log(itemPos)
        return {
            "itemPos": itemPos,
            "seriesPos": seriespos,
            "subseriesindex": subseriesindex[seriespos]
        };
    }
    
    function getClosestPoint(relmousePt, xscale, yscale) {
        var mindist_trigger, dist,
            is_within_bubble, bubbleRadius, cx, cy, prevBubbleInfo,
            series, subseries, item,
            seriesdata = chartObj.seriesdata,
            poly = null,
            isPolar = chartObj.dataObject.isPolarAxisCategory,
            tooltipShared = systemConf.tooltip.sharedSeriesInfo,
            bubbleTriggerOffset = chartObj.dataObject.isBubbleEnabled ? (chartObj.zscale.range()[1] / 2 + 50) : null,
            prev_trigger_offset = null;
        
        var X = "x",
            Y = "y";
        if (axisrotated) {
            X = "y";
            Y = "x";
        }
        seriesdata.map(function(d, i) {
            
            var chartType = chartObj.chartTypes[i],
                type = chartType.value,
                chartName = chartType.name,
                isRangeChart = type == $ZC.charttype.arearange;

            var cur_trigger_offset = getTriggeringOffset(type,tooltipShared,chartObj.dataObject.isCombinationalChart,bubbleTriggerOffset);
            if (!eventDisabled(d)) {
                if (chartObj.dataObject.isCombinationalChart) {
                    if (!defined(mindist_trigger) || (defined(series) ? (cur_trigger_offset != null && cur_trigger_offset <= mindist_trigger) : (cur_trigger_offset < prev_trigger_offset || prev_trigger_offset == null || cur_trigger_offset == null))) {
                        mindist_trigger = cur_trigger_offset;
                    }
                } else {
                    mindist_trigger =  (mindist_trigger == null) ? cur_trigger_offset : mindist_trigger;
                }
            }

            var renderer = chartObj.renderer[i];
            var yscindex = getParsedYAxisOrder(d.yaxiscolumnorder);
            var ysc = yscale[yscindex].scale;
            var hasNegValue = chartObj.dataObject.containsNegativeData(yscindex);
            var prevData;
            var yrangePos = (isRangeChart) ? 1 : null;
            var polygonPoints = {};
            
            if (eventDisabled(d)) {
                return [null]
            } else {
                return d.data.map(function(data, j) {
                    data = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[j] : data;
                    var markerSize = (renderer.getSymbolSize && !isBubbleChartType(type)) ? renderer.getSymbolSize(data) : 0;
                    var cusPoints = isPolar ?
                        data.map(function(d, k) {
                            var x = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "x"),
                                y = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "y");
                            return {
                                x: x,
                                y: y
                            };
                        }) :
                        null;
                    
                    return data.map(function(d, k) {
                        if (isNullData(d, dataset, yscindex)) {
                            return;
                        }

                        var is_within_current_bubble;
                        if (isScatterChartType(type)) {
                            dist = getMinDistByPtToPt(d, relmousePt, xscale, ysc, yscindex, type, yrangePos, X, Y);
                            dist = dist - (markerSize/2); //consider marker size
                            if (isBubbleChartType(type)) {
                                /*
                                 * If mouse point is inside the bubbles, find the bubble with minimum dist (from mouse point to centre)
                                 * Else find the bubble with minimum dist (from mouse point to arc)
                                 */
                                is_within_current_bubble = (dist <= (bubbleRadius = (chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "z", chartObj.zscale) / 2)));
                                is_within_bubble = is_within_bubble || is_within_current_bubble;
                                if (!is_within_current_bubble) {
                                    dist = dist - bubbleRadius; // distance to the arc
                                }
                            }
                        } else {
                            var dist_n_polyPoints = getMinDistByPtToSegment(d, i, j, k, data, relmousePt, prevData, type, xscale, ysc, yscindex, hasNegValue, isRangeChart, cusPoints, isPolar);
                            dist = dist_n_polyPoints.distance;
                            polygonPoints = dist_n_polyPoints.polygonPoints;
                            prevData = d;
                        }

                        var condition;
                        if (isBubbleChartType(type) && is_within_bubble) {
                            if (is_within_current_bubble) {
                                cx = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "x");
                                cy = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "y")
                                if (prevBubbleInfo) {
                                    var prevSurface = mathPI * prevBubbleInfo.r * prevBubbleInfo.r,
                                        curSurface = mathPI * bubbleRadius * bubbleRadius,
                                        inside = (mathSQRT(sqr(prevBubbleInfo.cx - cx) + sqr(prevBubbleInfo.cy - cy)) <= mathAbs(prevBubbleInfo.r - bubbleRadius));

                                    condition = prevBubbleInfo.dist == null || dist < prevBubbleInfo.dist || !(prevSurface < curSurface && inside);
                                } else {
                                    condition = true;
                                }
                            }
                        } else {
                            condition = mindist_trigger == null || dist <= mindist_trigger;
                        }

                        var isWithinClrRange = isWithinColorRange(dataset.getClr(d), chartObj);
                        
                        if (isWithinClrRange && condition && dist != null) {
                            mindist_trigger = dist;
                            series = i;
                            subseries = j;
                            item = k;
                            poly = polygonPoints.points;
                            if (is_within_current_bubble) {
                                prevBubbleInfo = {
                                    cx : cx,
                                    cy : cy,
                                    r : bubbleRadius,
                                    dist : dist
                                };
                            }
                        }
                    })
                    
                })
            }
            prev_trigger_offset = cur_trigger_offset;
        });
        return {
            "seriesPos": series,
            "itemPos": item,
            "subseriesindex": subseries,
            "poly": poly
        };
    }
    
    function isNullData(data, dataset, yscindex) {
        if (chartObj.seriesdata[0].type == $ZC.charttype.stkdarea) {
            return false;
        }
        return (data == null) || isCatNull(dataset, "x")(dataset.getX(data)) || isCatNull(dataset, "y", yscindex)(dataset.getY(data, yscindex));
    }
    
    function getMinDistByPtToSegment(d, i, j, k, data, relmousePt, prevData, type, xscale, ysc, yscindex, hasNegValue, isRangeChart, cusPoints, isPolar) {
        var dist = null;
        var polygonPoints = getPolygonPoints(i, j, k, data, prevData, data[k], data[k + 1], chartObj.dataObject, dataset, axisrotated, stacked(type), xscale, ysc, yscindex, hasNegValue, isRangeChart);

        var hasSinglePolygonPoint = polygonPoints.points.length == 1;
        if (isPolar) {
            polygonPoints.points = cusPoints;
        }

        var isWithinPoly = (isAreaChartType(type) || isPolar) ? pointInPolygon(relmousePt, polygonPoints.points) : ((type === $ZC.charttype.bubblepie) ? pointInPie(relmousePt, polygonPoints, i, j, d) : true);
        if (((data.length == 1 || hasSinglePolygonPoint) && !isNullData(d, dataset, yscindex))) { // if series had one point
            dist = dist2(relmousePt, polygonPoints.curpt);

            // #ZC800
            var isComboChart = chartObj.dataObject.isCombinationalChart,
                areaSeriesCount = chartObj.dataObject.noofAreaEnabledSeries,
                triggerOffset = getTriggeringOffset($ZC.charttype.line, null, isComboChart);
            if ((areaSeriesCount > 1 || (areaSeriesCount === 1 && isComboChart)) && (dist > triggerOffset)) {
                dist = null;
            }

        }
        if (isWithinPoly && !isNullData(d, dataset, yscindex)) {
            
            var pointA = distToSegment(relmousePt, polygonPoints.curpt, polygonPoints.curNext),
                pointB = distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt),
                prevDataNull = (k !== 0 && isNullData(prevData, dataset, yscindex));
            dist = (k == 0) ? pointA : (k == data.length - 1) ? pointB : prevDataNull ? pointA : d3_min([pointB, pointA]);
            
            // dist = (k == 0) ? distToSegment(relmousePt , polygonPoints.curpt , polygonPoints.curNext) :
            // 	(k == data.length-1) ? distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt) :
            // 		d3.min([distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt) , distToSegment(relmousePt, polygonPoints.curpt, polygonPoints.curNext)]);
        }
        
        return {
            "distance": dist,
            "polygonPoints": polygonPoints
        }
    }

    function getTriggeringOffset(type,tooltipShared,isComboChart,bubbleTriggerOffset){
        var triggerOffset;
        var commonPlotOptions = systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)];
        var isContinousPointType = isPointChartType(type) || type === $ZC.charttype.line; //without area,as area should have no mindist
        var filledChartType = !isContinousPointType;
        var customTriggerOffset = (commonPlotOptions && commonPlotOptions.events && commonPlotOptions.events.triggerOffset);
        if(customTriggerOffset !== undefined){
            triggerOffset = customTriggerOffset;
        }else if(chartObj.dataObject.isBubbleEnabled){ // for bubble charts
            triggerOffset = bubbleTriggerOffset;
        }else if(filledChartType || tooltipShared){ //for area charts and tooltip chared
            triggerOffset = null;
        }else if(isComboChart && isContinousPointType){ // for combo chart with line
            triggerOffset = 10;
        }else{ //for line charts
            triggerOffset = 50;
        }
        return triggerOffset;
    }
    
    function getMinDistByPtToPt(d, relmousePt, xscale, ysc, yscindex, type, yrangePos, X, Y) {
        var curpt = {};
        curpt[X] = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "x");
        curpt[Y] = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "y", null, yrangePos)
        var dx = curpt.x - relmousePt[X];
        var dy = curpt.y - relmousePt[Y];
        return mathSQRT(sqr(dx) + sqr(dy));
    }
    
    
    function getPolygonPoints(seriespos, subseriespos, itempos, data, prevData, curData, nextData, dataObject, dataset, axisrotated, stacked, xscale, ysc, yscindex, hasNegValue, isRangeChart) {
        var prevpt, curpt, nextpt, prevBasept, curBasept, nextBasept;
        var yrangePos = (isRangeChart) ? 1 : null;
        

        curpt = isNullData(curData, dataset, yscindex) ?
            {
                x: 0,
                y: 0
            } :
            {
                x: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, curData, "x"),
                y: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, curData, "y", null, yrangePos)
            };
        prevpt = (itempos == 0) ?
            {
                x: 0,
                y: 0
            } : isNullData(prevData, dataset, yscindex) ? curpt :
                {
                    x: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, prevData, "x"),
                    y: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, prevData, "y", null, yrangePos)
                }
        nextpt = (itempos == data.length - 1) ?
            {
                x: 0,
                y: 0
            } : isNullData(nextData, dataset, yscindex) ? curpt :
            {
                x: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, nextData, "x"),
                y: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, nextData, "y", null, yrangePos)
            }

        curBasept = (isNullData(curData, dataset, yscindex)) ? {
            x: 0,
            y: 0
        } : addBasePointForArea(dataObject, axisrotated, stacked, seriespos, subseriespos, itempos, xscale, ysc, yscindex, hasNegValue, curData, isRangeChart);

        prevBasept = (itempos == 0) ? {
                x: 0,
                y: 0
            } : isNullData(prevData, dataset, yscindex) ?  curBasept :
            addBasePointForArea(dataObject, axisrotated, stacked, seriespos, subseriespos, itempos - 1, xscale, ysc, yscindex, hasNegValue, prevData, isRangeChart);

        nextBasept = (itempos == data.length - 1) ? {
                x: 0,
                y: 0
            } : isNullData(nextData, dataset, yscindex) ? curBasept :
            addBasePointForArea(dataObject, axisrotated, stacked, seriespos, subseriespos, itempos + 1, xscale, ysc, yscindex, hasNegValue, nextData, isRangeChart);

        var prevCur = (itempos == 0) ? {
                x: 0,
                y: 0
            } : isNullData(prevData, dataset, yscindex) ? curpt : {
                x: ((prevpt.x + curpt.x) / 2),
                y: ((prevpt.y + curpt.y) / 2)
            }
        var curNext = (itempos == data.length - 1) ? {
                x: 0,
                y: 0
            } : isNullData(nextData, dataset, yscindex) ? curpt : {
                x: ((nextpt.x + curpt.x) / 2),
                y: ((nextpt.y + curpt.y) / 2)
            }
        
        var prevbaseCur = (itempos == 0) ? {
                x: 0,
                y: 0
            } : isNullData(prevData, dataset, yscindex) ? curBasept :
            {
                x: ((prevBasept.x + curBasept.x) / 2),
                y: ((prevBasept.y + curBasept.y) / 2)
            }
        var curbaseNext = (itempos == data.length - 1) ? {
                x: 0,
                y: 0
            } : isNullData(nextData, dataset, yscindex) ? curBasept : {
                x: ((nextBasept.x + curBasept.x) / 2),
                y: ((nextBasept.y + curBasept.y) / 2)
            }
        
        var points = []
        
        var temp = (isNullData(prevData, dataset, yscindex) && isNullData(nextData, dataset, yscindex)) ? points.push(curpt) : (itempos == 0 || isNullData(prevData, dataset, yscindex)) ? points.push(curpt, curNext, curbaseNext, curBasept) :
                (itempos == data.length - 1 || isNullData(nextData, dataset, yscindex)) ? points.push(prevCur, curpt, curBasept, prevbaseCur) :
                    points.push(prevCur, curpt, curNext, curbaseNext, curBasept, prevbaseCur);
        return {
            "points": points,
            "prevCur": prevCur,
            "curNext": curNext,
            "curpt": curpt
        };
    }
    
    function addBasePointForArea(dataObject, axisrotated, stacked, seriespos, subseriespos, itemPos, xsc, ysc, yscindex, hasNegValue, point, isRangeChart) {
        var basePoint;
        var yrangePos = (isRangeChart) ? 0 : null;
        var temp;
        if (axisrotated) {
            var xval = dataObject.getXYvalue(axisrotated, stacked, xsc, ysc, yscindex, point, "y", null, yrangePos);
            var yval = (isRangeChart) ? dataObject.getXYvalue(axisrotated, stacked, xsc, ysc, yscindex, point, "x", null, yrangePos) : ysc.range()[0];
            if (stacked) {
                temp = ((seriespos == 0) && (subseriespos == 0) && (itemPos == 0)) ? mathMax(ysc.range()[0], ysc(hasNegValue)) : ysc(point.y0);
                basePoint = {
                    x: temp,
                    y: xval
                }
            } else {
                temp = (ysc.rangeBand != null) ? (ysc.range()[0] + ysc.rangeBand()) : mathMax(yval, ysc(hasNegValue));
                basePoint = {
                    x: temp,
                    y: xval
                }
            }
        } else {
            var xval = dataObject.getXYvalue(axisrotated, stacked, xsc, ysc, yscindex, point, "x");
            var yval = (isRangeChart) ? dataObject.getXYvalue(axisrotated, stacked, xsc, ysc, yscindex, point, "y", null, yrangePos) : ysc.range()[0];
            if (stacked) {
                temp = ((seriespos == 0) && (subseriespos == 0) && (itemPos == 0)) ? mathMin(ysc.range()[0], ysc(hasNegValue)) : ysc(point.y0);
                basePoint = {
                    x: xval,
                    y: temp
                }
            } else {
                temp = (ysc.rangeBand != null) ? (yval + ysc.rangeBand()) : mathMin(yval, ysc(hasNegValue));
                basePoint = {
                    x: xval,
                    y: temp
                }
            }
        }
        return basePoint;
    }
    
    function hideUnselectedWrap(wrap) {
        wrap.style("display", "none");
    }
    
    function crosshair_enabled() {
        return (chartObj.systemConf.tooltip.crosshair.type != "none");
    }
    
    function isWithin(dataPt, mousePt, reversed) {
        var x1 = dataPt.x;
        var y1 = dataPt.y;
        var x2 = x1 + dataPt.width;
        var y2 = y1 + dataPt.height;
        if (reversed) {
            (axisrotated) ? (x2 = (x1 = x1 - dataPt.width) + dataPt.width) : (y2 = y1 - dataPt.height);
        }
        
        var condition = (x1 <= mousePt.x && mousePt.x <= x2) && ((reversed && !axisrotated) ? (y2 <= mousePt.y && mousePt.y <= y1) : (y1 <= mousePt.y && mousePt.y <= y2));
        if (condition) {
            return 0;
        } else {
            return null;
        }
        
    }

    function isWithinPlotarea(xval, yval) {
        return isWithin({
            "x": plotarea.left + (chartObj.scrolledX || 0),
            "y": plotarea.top + (chartObj.scrolledY || 0),
            "width": plotarea.width,
            "height": plotarea.height
        }, {
            "x": plotarea.left + xval,
            "y": plotarea.top + yval
        });
    }

    function sqr(x) {
        return x * x;
    }
    
    function dist2(v, w) {
        return sqr(v.x - w.x) + sqr(v.y - w.y)
    }
    
    function distToSegmentSquared(p, v, w) {
        var l2 = dist2(v, w);
        if (l2 === 0) {
            return dist2(p, v);
        }
        var t = ((p.x - v.x) * (w.x - v.x) + (p.y - v.y) * (w.y - v.y)) / l2;
        if (t < 0) {
            return dist2(p, v);
        }
        if (t > 1) {
            return dist2(p, w);
        }
        return dist2(p, {
            x: v.x + t * (w.x - v.x),
            y: v.y + t * (w.y - v.y)
        });
    }
    
    function distToSegment(p, v, w) {
        return mathSQRT(distToSegmentSquared(p, v, w));
    }
    
    function lineDistance(point1, point2) {
        var xs = 0;
        var ys = 0;
        
        xs = point2.x - point1.x;
        xs = xs * xs;
        
        ys = point2.y - point1.y;
        ys = ys * ys;
        
        return mathSQRT(xs + ys);
    }
    
    function isAbove(a, b, c) {
        //a = line point 1; b = line point 2; c = point to check against.
        return (((b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x)) > 0) &&
            (((b.x - a.x) * (c.y - b.y) - (b.y - a.y) * (c.x - b.x)) > 0);
        // var numerator = ((b.y - a.y)*c.x) - ((b.x - a.x)*c.y) + (b.x*a.y) - (b.y*a.x);
        // return numerator > 0
    }
    
    function pointInPolygon(point, poly) {
        // ray-casting algorithm based on
        // www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html
        var xi, xj, yi, yj, i, intersect,
            x = point.x,
            y = point.y,
            inside = false;
        for (var i = 0, j = poly.length - 1; i < poly.length; j = i++) {
            xi = poly[i].x,
                yi = poly[i].y,
                xj = poly[j].x,
                yj = poly[j].y,
                intersect = ((yi > y) != (yj > y)) &&
                    (x < (xj - xi) * (y - yi) / (yj - yi) + xi);
            if (intersect) inside = !inside;
        }
        return inside;
    }
    
    function pointInPie(point, poly, seriespos, subseriespos, d) {
        var X = dataset.getX(d);
        var pieRenderer = chartObj.subrenderer[subseriespos][X];
        var pieData = pieRenderer.data[seriespos];
        var theta1 = pieData.startAngle,
            theta2 = pieData.endAngle,
            angle = mathAtan2((point.x - poly.curpt.x), -(point.y - poly.curpt.y));
        return isAngleInside(theta1, theta2, angle);
    }
    
    function eventDisabled(d) {
        /*
         * returns true if the series is filtered or event is disabled for that series
         */
        var plotOptions = d.plotoptions;
        var cName = getChartType((d.type || chartObj.userdata.seriesdata.type), "string");
        var commonPlotOptions = systemConf.chart.plot.plotoptions[cName];
        return d.disabled || (validateNullVal(getEventConf(plotOptions, commonPlotOptions, chartObj, "enabled"), true) == false);
    }

    function getCurrentDataPoint(seriesIndex, subseriesIndex, itemIndex) {
        var renderer = chartObj.renderer[seriesIndex];
        var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesIndex] : chartObj.seriesdata[seriesIndex].data[subseriesIndex];
        return currentSeriesdata[itemIndex];
    }

    function getRect(highlightpoint, radius, yaxisReversed) {
        if (isHeatMapChartType(chartObj.chartTypes[0].value)) {
            var commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions.heatmap;
            var symbolPath = commonPlotOptions.symbol && getSVGsymbol(commonPlotOptions.symbol);
            if (symbolPath) {
                return symbolPath(mathMin(highlightpoint.width, highlightpoint.height));
            } else {
                return roundedRect(-highlightpoint.width / 2, -highlightpoint.height / 2, highlightpoint.width, highlightpoint.height, radius, null, axisrotated);
            }
        } else {
            return roundedRect(highlightpoint.x, highlightpoint.y, highlightpoint.width, highlightpoint.height, radius, yaxisReversed, axisrotated);
        }
    }

    function getRectTranslation(highlightpoint) {
        var tx = plotarea.left,
            ty = plotarea.top;
        if (isHeatMapChartType(chartObj.chartTypes[0].value)) {
            tx += (highlightpoint.x + highlightpoint.width / 2);
            ty += (highlightpoint.y + highlightpoint.height / 2);
        }
        return [tx, ty];
    }

    function getLegendIndex(d, seriesIndex) {
        if (chartObj.axes.clr.scaleType) {
            return getColorIndex(chartObj, chartObj.axes.clr.indexScale, d);
        } else if (seriesIndex != null) {
            return seriesIndex;
        }
    }

    return events;
};

/*
 *Events related to statechange
 */

function stateChangeListener(chartObj, eventdata, ele, type, defaultCallback) {
    
    //type: chartinit, chartload, chartreload, axisinit, axisload, plotinit, plotload
    
    var callback = (eventdata && eventdata[type]) || defaultCallback;
    if (defined(callback)) {
        invokeFunction(callback, d3.event, chartObj)
    }
}

function getEventConf(plotOptions, commonPlotOptions, chartObj, eventType) {
    var events_cpo = commonPlotOptions.events, //cpo - commonplotoptions
        events_plot = chartObj.systemConf.chart.plot.events;
    
    var eventFn = (plotOptions != null && plotOptions.events) ? $ZC.utils.getValueOfPlotOptions(plotOptions.events, events_cpo)(eventType) :
        (events_cpo != null) ? events_cpo[eventType] :
            (events_plot != null) ? events_plot[eventType] : null;

    if (eventFn === undefined && events_plot) {
        eventFn = events_plot[eventType];
    }

    return eventFn;
}

function updateBulletEvents(chartObj, bulletHandler) {
    var bulletPoints = chartObj.events.bullet,
        allPoints = arrayJoin(bulletPoints.levelmarker, bulletPoints.marker, bulletPoints.point);
    bulletHandler.update(allPoints)
}

// handles bullet chart event
function bulletChartEventHandler(chartObj, eventRectangular, hoverSeries, eventsHandler) {
    
    // update the old event if the first arguments is true
    if (arguments[0] === true) {
        return arguments[1].update(arguments[2]);
    }
    
    var bulletPoints = chartObj.events.bullet,
        axisrotated = chartObj.dataObject.getAxisRotated(),
        allPoints = arrayJoin(bulletPoints.levelmarker, bulletPoints.marker, bulletPoints.point),
        sharedTooltip = chartObj.systemConf.tooltip.sharedSeriesInfo,
        tooltip = chartObj.eventHandler.tooltipElement,
        plotoptions = chartObj.systemConf.chart.plot.plotoptions.bullet,
        coordinate, dataset = chartObj.dataset,
        seriesIndex, subseriesIndex, itemIndex,
        tooltipSharedInfo = d3_map(),
        xdata, highlightPoints, renderer, data, position,
        bulletEvents = getPropVal(plotoptions, "events") || {},
        levelMarkerEvents = getPropVal(plotoptions, "levelMarker.events") || {},
        targetMarkerEvents = getPropVal(plotoptions, "targetMarker.events") || {},
        eventAttacherOptions = {
            target: "plot",
            chartObj: chartObj,
            namespace: "bullet"
        },

        levelMarkerColumnInfo = getColumnIdxBasedOnDataindex(chartObj, plotoptions.levelMarker),
        targetMarkerColumnInfo = getColumnIdxBasedOnDataindex(chartObj, plotoptions.targetMarker),

        columnInfo, value, dataType, userCallback, metaInfo, text, formattedValue;
    
    var handleUserCallback = function(current, type, event, metaInfo) {
        metaInfo = metaInfo || chartObj.dataset.getMetaInfoObj(chartObj, current.data, current.seriesPos);
        type = (d3.event && d3.event.zcEventType) || type;
        var userObject = {
            "data": metaInfo
        };
        
        switch (current.type) {
            case "levelmarker": {
                return invokeFunction(levelMarkerEvents[type], event, userObject, chartObj);
            }
            case "marker": {
                return invokeFunction(targetMarkerEvents[type], event, userObject, chartObj);
            }
            case "point": {
                return invokeFunction(bulletEvents[type], event, userObject, chartObj);
            }
        }
    };
    
    // bullet event
    var bulletEvent = new $ZC.RectangleEventSurface(eventRectangular.node(), allPoints, eventAttacherOptions);
    
    bulletEvent.mousemove(function(event, mouseCoords) {
        if(!chartObj.chartRendered) {
            return false;
        }
        bulletEvent.stopPropagation();
        
        var currentPoint = this,
            data = currentPoint.data;
        coordinate = {
            x: mouseCoords[0],
            y: mouseCoords[1]
        };
        seriesIndex = currentPoint.seriesPos;
        subseriesIndex = currentPoint.subseriesindex;
        itemIndex = currentPoint.itemPos;
        tooltipSharedInfo = d3_map();
        xdata = dataset.getX(data);
        renderer = chartObj.renderer[seriesIndex];
        position = getTooltipPosition(event, coordinate, 0, 0, chartObj, currentPoint, axisrotated, sharedTooltip, tooltipSharedInfo, true, false);
        switch (this.type) {
            case "point": {
                highlightPoints = getBarPosition(chartObj, data, seriesIndex, renderer.commonOption);
                eventRectangular.selectAll("#zcscatterhighlight").selectAll("*").remove();
                hoverSeries(chartObj, seriesIndex, xdata, itemIndex, subseriesIndex, data, sharedTooltip, true, tooltipSharedInfo, highlightPoints)
                return tooltip.show(chartObj, position, null, true, position.helpers);
            }
            case "levelmarker":
            case "marker": {
                columnInfo = ((this.type === "marker") ? targetMarkerColumnInfo : levelMarkerColumnInfo) || chartObj.dataset.getColumn("y", currentPoint.yaxiscolumnorder);
                value = currentPoint.currentStage;
                dataType = columnInfo.datatype;
                metaInfo = chartObj.dataset.getMetaInfoObj(chartObj, data, seriesIndex);
                formattedValue = getFormattedValue(columnInfo[dataType], value, dataType, chartObj, "tooltip"),
                    userCallback = {
                        value: value,
                        formattedValue: formattedValue,
                        actualData: data,
                        data: metaInfo
                    };
                handleUserCallback(this, "mousemove", metaInfo);
                if (this.type === "marker") {
                    text = invokeFunction(targetMarkerEvents.tooltipContent, userCallback, chartObj, "tooltip") || "Target: " + formattedValue;
                    eventsHandler.addCursor(targetMarkerEvents.cursor);
                } else {
                    text = invokeFunction(levelMarkerEvents.tooltipContent, userCallback, chartObj, "tooltip") || "Range: " + formattedValue;
                    eventsHandler.addCursor(levelMarkerEvents.cursor);
                }
                return tooltip.show(chartObj, position, text, false, position.helpers);
            }
        }
    });
    
    bulletEvent.click(function(event) {
        bulletEvent.stopPropagation();
        tooltip.hide(tooltip.element);
        eventsHandler.hideCursor(chartObj.eventHandler.trackerElement);
        if (this.type !== "point") {
            handleUserCallback(this, "click", event);
        } else {
            eventsHandler.click();
        }
    });
    
    bulletEvent.dblclick(function(event) {
        bulletEvent.stopPropagation();
        if (this.type !== "point") {
            handleUserCallback(this, "doubleclick", event);
        } else {
            eventsHandler.doubleclick();
        }
    });
    
    bulletEvent.mouseleave(function(event) {
        if (this.type !== "point") {
            handleUserCallback(this, "mouseout", event);
        }
        eventsHandler.hideCursor(eventRectangular);
        eventsHandler.mouseOut(renderer, data, seriesIndex, !bulletEvent._finalMouseLeave);
    });
    
    return bulletEvent;
}

function hasPatternPallete(chartObj) {
    var patternPallete = chartObj.patternPallete;
    return patternPallete && patternPallete.length;
}

