//$Id$
/**
 *
 * @returns {chart} funnel renderer.
 */
svg_plot_renderer.funnel = function() {
    var MAXWIDTH_DATALABELS = 0.3;
    var cfg = {};
    var commonRendererProp, chartObj, data_processed, noofNonZeroDatas, coneHeigth, noOfGaps, stemHeight, stemWidth, xAxisWidth, dataset, percentage = 0.375,
        chartWidth, totalEngagement, trapezoid, chartHeight, color, funnelsections, ellipseSections;
    var threeDimension, arcHeight, arcHeight1,
        padding, minPadding, maxPadding,
        minArcHeight = 1,
        isredraw = false,
        arcCorrection = 0,
        container, ellipse, funnel, label, labelLinkgroup, rightXscale, leftXscale, yaxiscolumnorder;
    var plotoptions, commonPlotOptions, systemconf, notesArray, datalabelPadding, isSplit, outerPadding, gradientDim, isPatternPalleteEnabled;
    var maxPer, isWeightedWidth, noWeighted, defsLocation, rp,
        gElementsCollected,
        fillColor;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                notesArray = rp.notesArray,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset;
            systemconf = chartObj.systemConf;
            var labelQueue = rp.labelQueue;
            
            defsLocation = chartObj.defsLocation;
            
            chartWidth = chartObj.plotarea.width,
                chartHeight = chartObj.plotarea.height;
            gElementsCollected = false;
            
            plotoptions = data[0].plotoptions;
            var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions);
            isPatternPalleteEnabled = systemconf.legend.imagePallete || hasPatternPallete(chartObj);
            cfg.canOverlap = gvp("canOverlap");
            isSplit = gvp("split");
            threeDimension = gvp("threeDimension");
            var emptyFunnelOptions = commonPlotOptions.emptyFunnel;
            datalabelPadding = commonPlotOptions.datalabels.padding;
            var showlabel = isDatalabelEnabled(commonPlotOptions.datalabels, chartObj);
            
            var strokeColor = getStrokeColor(chartObj, 0);

            minPadding = pick(commonPlotOptions.minPadding, (threeDimension ? 4 : 1));
            maxPadding = pick(commonPlotOptions.maxPadding, 10);
 
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, "funnel");
            var animationType = animationOptions.type,
                easingType = animationOptions.easingType,
                isAnimationEnable = animationOptions.enabled,
                transitionDuration = animationOptions.duration;
            var redrawDuration = isAnimationEnable ? 200 : 0
            
            outerPadding = perToPx(gvp("outerPadding"), chartHeight, 0) / 2;
            stemHeight = gvp("stemHeight");
            stemWidth = gvp("stemWidth");
            isWeightedWidth = (gvp("weighted") === "width"),
                noWeighted = (gvp("weighted") === "none");
            
            if (isWeightedWidth) {
                stemHeight = stemWidth = 0;
                isSplit = true;
            }
            
            data_processed = data = data[0].data[0];
            noofNonZeroDatas = data_processed.reduce(function(prev, cur, i) {
                return prev + ((dataset.getY(cur, yaxiscolumnorder) && !cur.disabled) ? 1 : 0)
            }, 0);
            noOfGaps = noofNonZeroDatas - 1;
            var preArcHeight = preCalArcHeight();
            cfg.height = chartHeight - (2 * preArcHeight) - (chartHeight * 0.01) - (2 * outerPadding);
            
            var coneWidth = gvp("coneWidth");
            coneWidth = perToPx(coneWidth, cfg.height, (cfg.height * 0.95));
            cfg.width = mathMin(chartWidth, coneWidth);

            padding = getFunnelPadding(cfg.height);
            cfg.gapHeight = (!isAnimationEnable || isSplit || isredraw) ? padding : ((animationType == "horizontalAll") ? padding : 0);
            
            if ((isWeightedWidth || noWeighted) && defined(commonPlotOptions.maxSliceHeight)) {
                /*
                 * Set max height for each trapezoid if isWeightedWidth or noWeighted
                 */
                cfg.height -= mathMax(0, (cfg.height - (padding * noOfGaps) - (perToPx(commonPlotOptions.maxSliceHeight, cfg.height) * noofNonZeroDatas)));
            }
            if (showlabel) {
                /*
                 *If chart width is lesser than height, datalabels are hidden as default padding is 30 and there is no space to show datalabels.
                 * So 30% of the width is allocated for datalabels and the default padding will be changed to 5
                 */
                var minDatalabelsWidth = chartWidth * MAXWIDTH_DATALABELS,
                    availableDatalabelsWidth = chartWidth - cfg.width;
                if (availableDatalabelsWidth < minDatalabelsWidth) {
                    datalabelPadding = cfg.datalabelPadding = 5;
                    cfg.width -= mathMax((minDatalabelsWidth - availableDatalabelsWidth), 0);
                }
            }
            stemHeight = perToPx(stemHeight, cfg.height, (cfg.height * 0.2));
            xAxisWidth = stemWidth = perToPx(stemWidth, cfg.width, ((stemHeight * cfg.width) / cfg.height)) / 2;
            coneHeigth = cfg.height - stemHeight;
            arcHeight = cfg.height * 0.05;
            
            arcHeight = mathMax(minArcHeight, (arcHeight - data_processed.length) / data_processed.length);
            arcHeight1 = arcHeight = !threeDimension ? 0 : (cfg.canOverlap ? (arcHeight + (maxPadding / 2)) : ((padding / 2) - arcCorrection));
            chart.total = totalEngagement = data_processed.reduce(function(prev, cur, i) {
                return prev + (data_processed[i].disabled ? 0 : mathAbs(dataset.getY(data_processed[i], yaxiscolumnorder) || 0))
            }, 0);
            maxPer = mathMax.apply(null, data_processed.map(function(d, i) {
                return data_processed[i].disabled ? 0 : mathAbs(dataset.getY(data_processed[i], yaxiscolumnorder)) / totalEngagement;
            }));
            leftXscale = d3_scaleLinear()
                .domain(isWeightedWidth ? [0, maxPer] : [stemHeight, cfg.height])
                .range([(cfg.width / 2) - stemWidth, 0]);
            rightXscale = d3_scaleLinear()
                .domain(isWeightedWidth ? [0, maxPer] : [stemHeight, cfg.height])
                .range([(cfg.width / 2) + stemWidth, cfg.width]);
            trapezoid = funnelLayout(data_processed);
            gradientDim = [cfg.width, cfg.height];
            fillColor = chart.fillColorFunc = getFillColor(chartObj, 0, gradientDim);
            
            var eventDisabled = (validateNullVal(getEventConf(plotoptions, commonPlotOptions, chartObj, "enabled"), true) == false);
            var cursor = eventDisabled ? null : getEventConf(plotoptions, commonPlotOptions, chartObj, "cursor") || "pointer";
            
            var containerArea = d3_select(this);
            container = appendEle(containerArea, "g", [data], ".", "class", "funnelgroup");
            container
                .attr("transform", "translate(" + ((chartWidth / 2) - (cfg.width / 2)) + "," + (arcHeight + 2 + outerPadding) + ")")
                .style({
                    "cursor": cursor,
                    "stroke-opacity": gvp("strokeOpacity"),
                    "stroke-width": gvp("strokeWidth")
                });
            ellipse = appendEle(container, "g", [1], ".", "class", "ellipsegroup");
            funnel = appendEle(container, "g", [1], ".", "class", "trapezoidgroup");
            
            funnelsections = appendEle(funnel, "path", data_processed);
            changeSelectionOrder(funnelsections);
            
            funnelsections
                .attr("id", function(d, i) {
                    return "funnel" + i;
                })
                .style({
                    "fill-opacity" : commonPlotOptions.fillOpacity,
                    "fill": function(d, i) {
                        return fillColor(i, d);
                    },
                    "stroke" : function(d, i) {
                        return strokeColor(i, d, commonPlotOptions.strokeColor);
                    }
                });
            
            ellipseSections = appendEle(ellipse, "path", (threeDimension ? data_processed : []));
            changeSelectionOrder(ellipseSections);
            
            ellipseSections
                .attr("id", function(d, i) {
                    return "ellipse" + i;
                })
                .style({
                    "fill-opacity" : commonPlotOptions.fillOpacity,
                    "fill" : function(d, i) {
                        return fillColor(i, d, 0.5);
                    },
                    "stroke" : function(d, i) {
                        return strokeColor(i, d, commonPlotOptions.strokeColor, 0.5);
                    }
                });

            if (!eventDisabled) {
                var mousemove = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.mouseMove(args);
                    },
                    mouseout = function(d, i) {
                        chartObj.eventHandler.mouseOut(chart, d, i);
                    },
                    click = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.click(chart, d, 0, i, args);
                    },
                    dblclick = function(d, i) {
                        var dt = $ZC.annotation ? generateDataForAnnotation(d, null) : d;
                        var coordinates = trapezoid[data.length - 1 - i].bottomLeft;
                        coordinates = [coordinates[0] + ((chartWidth / 2) - (cfg.width / 2)), (coordinates[1] + (arcHeight + 2 + outerPadding))];
                        var args = {
                            "coordinate": coordinates,
                            "data": dt,
                            "basedOn": "plot"
                        };
                        chartObj.eventHandler.doubleclick(d, (data.length - 1 - i), args);
                    },
                    eventAttacherOptions = {
                        target: "plot",
                        touchleave: true,
                        chartObj: chartObj
                    };
                var mouseHandlers = {
                    "mousemove": mousemove,
                    "mouseout": mouseout,
                    "click": click,
                    "dblclick": dblclick
                },
                touchHandlers = {
                    "singletouchmove": mousemove,
                    "touchend": mouseout,
                    "tap": click,
                    "dbltap": dblclick
                };
                attachevents(funnelsections, mouseHandlers, touchHandlers, eventAttacherOptions);
                attachevents(ellipseSections, mouseHandlers, touchHandlers, eventAttacherOptions);
            }
            
            var A = cfg.canOverlap ? (((2 * stemWidth) / cfg.width) * arcHeight) : (arcHeight + arcCorrection);
            var funnelOutline = "M0,0L" + ((cfg.width / 2) - stemWidth) + "," + coneHeigth + "L" + ((cfg.width / 2) - stemWidth) + "," + cfg.height + "A" + stemWidth + "," + A + ",0,0,0," + ((cfg.width / 2) + stemWidth) + "," + cfg.height + "L" + ((cfg.width / 2) + stemWidth) + "," + coneHeigth + "L" + cfg.width + ",0A" + (cfg.width / 2) + "," + arcHeight + ",0,0,0,0,0" + "A" + (cfg.width / 2) + "," + arcHeight + ",0,0,0," + cfg.width + ",0";
            var eFunnel = appendEle(container, "path", ((!isredraw && emptyFunnelOptions.show && isAnimationEnable) ? [1] : []), "#", "id", "emptyFunnel");
            eFunnel
                .attr("d", funnelOutline)
                .style({
                    "stroke": (emptyFunnelOptions.color || "grey"),
                    "fill": "none"
                });
            addFunnelClipPath(funnelOutline);
            if (!isredraw) {
                hideDisabledElements(data, 0);
                var prev = 0,
                    funneldrawn = 0;
                funnelsections
                    .transition()
                    .duration(function(d, i) {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        return (animationType == "vertical") ? ((d.disabled || !yVal) ? 0 : ((isWeightedWidth || noWeighted) ? (transitionDuration / noofNonZeroDatas) : ((mathAbs(yVal)) / totalEngagement) * transitionDuration)) : transitionDuration;
                    })
                    .delay(function(d, i) {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        prev += (d.disabled || !yVal) ? 0 : ((isWeightedWidth || noWeighted) ? (transitionDuration / noofNonZeroDatas) : mathAbs(yVal));
                        var del = (animationType == "vertical") ? ((isWeightedWidth || noWeighted) ? (transitionDuration - prev) : (((totalEngagement - prev) / totalEngagement) * transitionDuration)) : 0;
                        return del || 0;
                    })
                    .ease(easingType)
                    .attrTween("d", function(d, i) {
                        return tweenAll(d, (data_processed.length - 1 - i), "funnel", animationType);
                    })
                    .each("end", function(d, i) {
                        funneldrawn++;
                    });
                prev = 0;
                ellipseSections
                    .transition()
                    .duration(function(d, i) {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        return (animationType == "vertical") ? ((d.disabled || !yVal) ? 0 : ((isWeightedWidth || noWeighted) ? (transitionDuration / noofNonZeroDatas) : ((mathAbs(yVal)) / totalEngagement) * transitionDuration)) : transitionDuration;
                    })
                    .delay(function(d, i) {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        prev += (d.disabled || !yVal) ? 0 : ((isWeightedWidth || noWeighted) ? (transitionDuration / noofNonZeroDatas) : mathAbs(yVal));
                        var del = (animationType == "vertical") ? ((isWeightedWidth || noWeighted) ? (transitionDuration - prev) : (((totalEngagement - prev) / totalEngagement) * transitionDuration)) : 0;
                        return del || 0;
                    })
                    .ease(easingType)
                    .attrTween("d", function(d, i) {
                        return tweenAll(d, (data_processed.length - 1 - i), "ellipse", animationType);
                    });
                var includeGap = setInterval(function() {
                    if (funneldrawn == data_processed.length) {
                        if (animationType != "horizontalAll") {
                            cfg.gapHeight = padding;
                            trapezoid = funnelLayout(data_processed);
                            funnelsections
                                .transition()
                                .duration(isAnimationEnable ? 250 : 0).delay(50)
                                .ease("linear")
                                .attr("d", function(d, i) {
                                    return drawTrapezoid(trapezoid[data_processed.length - 1 - i]);
                                });
                            ellipseSections
                                .transition()
                                .duration(isAnimationEnable ? 250 : 0).delay(50)
                                .ease("linear")
                                .attr("d", function(d, i) {
                                    return drawEllipse(trapezoid[data_processed.length - 1 - i]);
                                });
                        }
                        lableManagent();
                        container.selectAll("path#emptyFunnel").transition().duration(50).delay(310).style("stroke-opacity", 0).remove();
                        clearInterval(includeGap);
                    }
                }, 10);
            } else {
                funnelsections
                    .transition()
                    .duration(redrawDuration)
                    .ease("linear")
                    .attr("d", function(d, i) {
                        return drawTrapezoid(trapezoid[data_processed.length - 1 - i]);
                    });
                ellipseSections
                    .transition()
                    .duration(redrawDuration)
                    .ease("linear")
                    .attr("d", function(d, i) {
                        return drawEllipse(trapezoid[data_processed.length - 1 - i]);
                    });
                hideDisabledElements(data, redrawDuration);
                lableManagent();
            }
            
            function lableManagent() {
                chart.renderedTimer = setTimeout(function() {
                    var labelPosition = calculatePointsForLabelPlacement(data_processed);
                    if ($ZC.labelRenderer) {
                        var args = [chartObj.seriesdata, 0, data_processed, noofNonZeroDatas, arcHeight + 2 + outerPadding, totalEngagement, cfg, labelPosition];
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "funnel",
                            "chartObj": chartObj,
                            "args": args
                        });
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "funnelInnerLabels",
                            "chartObj": chartObj,
                            "args": args
                        });
                    }
                    
                    //Annotation preprocessing
                    if ($ZC.annotation) {
                        notesArray = $ZC.annotation.preprocessAnnotations(chartObj.seriesdata, 0, function(dt, k, j) {
                            return [trapezoid[trapezoid.length - 1 - j].bottomLeft[0] + ((chartWidth / 2) - (cfg.width / 2)), trapezoid[trapezoid.length - 1 - j].bottomLeft[1] + (arcHeight + 2 + outerPadding)];
                        }, notesArray, chartObj, rp);
                    }
                    
                    isredraw = true;
                    chart.chartRendered = true;
                }, (!isAnimationEnable ? 0 : (isredraw ? redrawDuration : 300)));
            }
            
            function changeSelectionOrder(selection) {
                /*
                 * Reverse the selection order. ISSUE: https://docs.zoho.com/viewcommentattachment/4807920000000048005?width=770&height=515&owner=42061464
                 */
                selection[0].reverse();
                selection.data(data_processed);
            }

            function getEventArgs(d, i) {
                var ev = getEventObject(d3.event);
                return {
                    "renderer": chart,
                    "seriesPos": 0,
                    "subseriesPos": 0,
                    "itemPos": i,
                    "color": color[i % color.length],
                    "coordinates": [ev.pageX, ev.pageY],
                    "element": this,
                    "data": d
                };
            }
        });
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    function funnelLayout(data) {
        var sumofvalues = 0,
            hgt = cfg.height,
            ht = 0,
            h = 0;
        trapezoid = [], xAxisWidth = stemWidth;
        data.forEach(function(value, index) {
            var d = data[data.length - 1 - index],
                yVal = dataset.getY(d, yaxiscolumnorder),
                disabled = d.disabled;
            h = !totalEngagement ? 0 :
                ((disabled ? 0 : ((isWeightedWidth || noWeighted) ? (yVal ? (1 / noofNonZeroDatas) : 0) : mathAbs(yVal) / totalEngagement)) * (cfg.height - ((noofNonZeroDatas - 1) * cfg.gapHeight)));
            h = h || 0;
            sumofvalues += disabled ? 0 : yVal;
            h = ht + h;
            var per = yVal / totalEngagement;
            per = per || 0;
            var points = {};
            if ((sumofvalues == totalEngagement) && (yVal == 0 || disabled)) {
                points.topLeft = points.bottomLeft = points.middleLeft = [leftXscale(isWeightedWidth ? maxPer : cfg.height), 0];
                points.topRight = points.bottomRight = points.middleRight = [rightXscale(isWeightedWidth ? maxPer : cfg.height), 0];
            } else {
                if (isWeightedWidth) {
                    points.bottomLeft = [leftXscale(per), (cfg.height - h)];
                    points.topLeft = [leftXscale(per), hgt];
                    points.middleLeft = [leftXscale(per), (cfg.height - h)];
                    points.bottomRight = [rightXscale(per), (cfg.height - h)];
                    points.topRight = [rightXscale(per), hgt];
                    points.middleRight = [rightXscale(per), (cfg.height - h)];
                } else {
                    points.bottomLeft = [(((cfg.height - h) >= coneHeigth) ? ((cfg.width / 2) - stemWidth) : leftXscale(h)), (cfg.height - h)];
                    points.topLeft = [((hgt >= coneHeigth) ? ((cfg.width / 2) - stemWidth) : leftXscale(ht)), hgt];
                    points.middleLeft = [((hgt >= coneHeigth) ? ((cfg.width / 2) - stemWidth) : points.bottomLeft[0]), (((hgt >= coneHeigth) && ((cfg.height - h) <= coneHeigth)) ? coneHeigth : (cfg.height - h))];
                    points.bottomRight = [(((cfg.height - h) >= coneHeigth) ? ((cfg.width / 2) + stemWidth) : rightXscale(h)), (cfg.height - h)];
                    points.topRight = [((hgt >= coneHeigth) ? ((cfg.width / 2) + stemWidth) : rightXscale(ht)), hgt];
                    points.middleRight = [((hgt >= coneHeigth) ? ((cfg.width / 2) + stemWidth) : points.bottomRight[0]), (((hgt >= coneHeigth) && ((cfg.height - h) <= coneHeigth)) ? coneHeigth : (cfg.height - h))];
                }
            }
            trapezoid.push(points);
            hgt = (!yVal || disabled) ? (cfg.height - h) : (cfg.height - h - cfg.gapHeight);
            ht = (!yVal || disabled) ? h : (h + cfg.gapHeight);
        });
        return trapezoid;
    }
    
    function calculatePointsForLabelPlacement(data) {
        var trape = [],
            hgt = cfg.height,
            ht = 0,
            h = 0;
        data.forEach(function(value, index) {
            var d = data[data.length - 1 - index],
                yVal = dataset.getY(d, yaxiscolumnorder),
                disabled = d.disabled;
            h = ((disabled ? 0 : ((isWeightedWidth || noWeighted) ? (yVal ? (1 / noofNonZeroDatas) : 0) : mathAbs(yVal) / totalEngagement)) * (cfg.height - ((noofNonZeroDatas - 1) * cfg.gapHeight))) / 2;
            h = h || 0;
            var half = h;
            h = ht + h;
            var per = yVal / totalEngagement;
            per = per || 0;
            var leftX = isWeightedWidth ? leftXscale(per) : (((cfg.height - h) >= coneHeigth) ? ((cfg.width / 2) - stemWidth) : leftXscale(h));
            var rightX = isWeightedWidth ? rightXscale(per) : (((cfg.height - h) >= coneHeigth) ? ((cfg.width / 2) + stemWidth) : rightXscale(h));
            trape.push({
                "rightx": (rightX + datalabelPadding),
                "leftx": (leftX - datalabelPadding),
                "y": mathAbs(cfg.height - h),
                "y0": mathAbs(cfg.height - h + half)
            });
            h = h + half;
            hgt = (!yVal || disabled) ? (cfg.height - h) : (cfg.height - h - cfg.gapHeight);
            ht = (!yVal || disabled) ? h : (h + cfg.gapHeight);
        });
        return trape;
    }
    
    function addFunnelClipPath(emptyFunnelPath) {
        var clipID;
        if (isWeightedWidth) {
            clipID = null;
        } else {
            var properties = {
                name: "FunnelClipPath",
                id: chartObj.id,
                d: emptyFunnelPath
            },
            args = {
                chartObj: chartObj
            };
            clipID = effects.get(svg_clips, "polygon", properties, args);
        }
        container
            .attr("clip-path", !clipID ? null : "url(" + defsLocation + "#" + clipID + ")");
    }
    
    chart.defaultMouseOverFunc = function(d, seriesPos, itemPos) {
        if (!gElementsCollected) {
            collectGroups();
        }

        if (isPatternPalleteEnabled) {
            funnelsections
                .style("opacity", function(d, i) {
                    return (i === itemPos) ? null : 0.4;
                });
            ellipseSections
                .style("opacity", function(d, i) {
                    return (i === itemPos) ? null : 0.4;
                });
        } else {
            funnelsections
                .style("fill", function(d, i) {
                    return fillColor(i, d, ((i === itemPos) ? 0.6 : null));
                });
            ellipseSections
                .style("fill", function(d, i) {
                    return fillColor(i, d, ((i === itemPos) ? 1 : 0.5));
                });
        }
        label.selectAll("text").style("text-shadow", null);
        labelLinkgroup.selectAll("path").style("stroke-width", null);
        label.selectAll("#lbl0_0_" + (data_processed.length - 1 - itemPos)).style("text-shadow", "0 0 0 rgba(0,0,0,1)");
        labelLinkgroup.selectAll("#link0_0_" + (data_processed.length - 1 - itemPos)).style("stroke-width", 1);
    };
    
    chart.defaultMouseOutFunc = function(d, i) {
        if (!gElementsCollected) {
            collectGroups();
        }

        if (isPatternPalleteEnabled) {
            funnelsections
                .style("opacity", null);
            ellipseSections
                .style("opacity", null);
        } else {
            funnelsections
                .style("fill", function(d, i) {
                    return fillColor(i, d);
                });
            ellipseSections
                .style("fill", function(d, i) {
                    return fillColor(i, d, 0.5);
                });
        }
        label.selectAll("text").style("text-shadow", null);
        labelLinkgroup.selectAll("path").style("stroke-width", null);
    };
    
    function tweenAll(d, i, elementType, animationType) {
        var base = baseData(animationType, i),
            d = trapezoid[i];
        var interpolate = (elementType == "funnel") ?
            d3_interpolate(drawTrapezoid(base), drawTrapezoid(d)) :
            d3_interpolate(drawEllipse(base), drawEllipse(d));
        return function(t) {
            return interpolate(t);
        };
    }
    
    function baseData(animationType, i) {
        var d = simpleClone(trapezoid[(animationType == "verticalAll") ? 0 : i]);
        if (animationType === "horizontalAll") {
            d.topLeft[0] = d.middleLeft[0] = d.bottomLeft[0] = d.topRight[0] = d.middleRight[0] = d.bottomRight[0] = (cfg.width / 2);
        } else {
            d.middleLeft = d.bottomLeft = d.topLeft;
            d.middleRight = d.bottomRight = d.topRight;
        }
        return d;
    }
    
    function hideDisabledElements(data, dur) {
        ellipseSections
            .each(function(d, i) {
                var hide = data[i].disabled || !dataset.getY(data_processed[i], yaxiscolumnorder);
                var t = hide ? dur : 0;
                if (t) {
                    setTimeout(function() {
                        hideSection(i, hide);
                    }, t);
                } else {
                    hideSection(i, hide);
                }
            });
    }

    function hideSection(i, hide) {
        var display = hide ? "none" : null;

        ellipse.selectAll("#ellipse" + i)
            .style("display", display);
        funnel.selectAll("#funnel" + i)
            .style("display", display);
    }
    
    function preCalArcHeight() {
        var h = chartHeight - (2 * outerPadding);
        var arcHeight = h * 0.05;
        var padding = getFunnelPadding(h);
        arcHeight = (arcHeight - data_processed.length) / data_processed.length;
        arcHeight = mathMax(minArcHeight, arcHeight);
        arcHeight = !threeDimension ? 0 : (cfg.canOverlap ? (arcHeight + (maxPadding / 2)) : ((padding / 2) - arcCorrection));
        return arcHeight;
    }

    function getFunnelPadding(h) {
        var userPadding = commonPlotOptions.padding;
        if (defined(userPadding)) {
            return invokeFunction(userPadding, h, noOfGaps, chartObj);
        }

        var maxPaddingHeight = h * percentage;
        return mathMin(maxPadding, mathMax(minPadding, maxPaddingHeight / noOfGaps));
    }
    
    function drawTrapezoid(d) {
        var topW = (d.topRight[0] - d.topLeft[0]) / 2,
            bottomW = (d.bottomRight[0] - d.bottomLeft[0]) / 2;
        var topCurve = cfg.canOverlap ? (((2 * topW) / cfg.width) * arcHeight) : arcHeight1,
            bottomCurve = cfg.canOverlap ? (((2 * bottomW) / cfg.width) * arcHeight) : arcHeight1;
        return "M" + d.topLeft[0] + " " + d.topLeft[1] +
            " A" + topW + " " + topCurve + " 0 0 0 " + d.topRight[0] + " " + d.topRight[1] +
            " L" + d.middleRight[0] + " " + d.middleRight[1] +
            " L" + d.bottomRight[0] + " " + d.bottomRight[1] +
            " A" + bottomW + " " + bottomCurve + " 0 0 1 " + d.bottomLeft[0] + " " + d.bottomLeft[1] +
            " L" + d.middleLeft[0] + " " + d.middleLeft[1] + "Z";
    }
    
    function drawEllipse(d) {
        var bottomW = (d.bottomRight[0] - d.bottomLeft[0]) / 2;
        var bottomCurve = cfg.canOverlap ? (((2 * bottomW) / cfg.width) * arcHeight) + arcCorrection : arcHeight1;
        return "M" + d.bottomLeft[0] + " " + d.bottomLeft[1] +
            " A" + bottomW + " " + bottomCurve + " 0 0 1 " + d.bottomRight[0] + " " + d.bottomRight[1] +
            " A" + bottomW + " " + (cfg.canOverlap ? bottomCurve : bottomCurve + arcCorrection) + " 0 0 1 " + d.bottomLeft[0] + " " + d.bottomLeft[1];
    }
    
    function collectGroups() {
        labelLinkgroup = labelLinkgroup || chartObj.staticPaneSVG.selectAll("g.link_0");
        label = label || chartObj.staticPaneSVG.selectAll("g.label_0");
        gElementsCollected = true;
    }

    return chart;
};