//$Id$
/*
 * PENDING:
 * *Bound box for stack labels
 */
$ZC.labelRenderer.bar = function() {
    var renderer, args;
    var axisrotated, textDirection, rotation,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                rp = renderer.commonRendererProp().params,
                plotoptions = currentdata.plotoptions,
                dataLabels,
                chartObj = rp.chartObj,
                systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                stacked = rp.stacked,
                yscale = rp.yscale,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                labelArray = rp.labelArray,
                isStackedLabels = (args[2] === "stackLabels"),
                isCanvasMode = chartObj.plot.renderer.mode === "canvas";
            axisrotated = rp.axisrotated;
            
            dataLabels = getMergedDatalabelOptions(commonPlotOptions, (isStackedLabels ? null : plotoptions), chartObj, index);

            if (isStackedLabels) {
                dataLabels = dataLabels.stackLabels;
            }
            var showlabel = isStackedLabels ?
                isStacklabelEnabled(dataLabels, chartObj) :
                isDatalabelEnabled(dataLabels, chartObj);
            
            if (currentdata.disabled || !showlabel) {
                return;
            }
            
            var currentPlotBound = getPlotBound(chartObj);
            var textOverlap = dataLabels.textOverlap, //hidden | adjust | clip
                labelPos = dataLabels.labelPos || "top", //bottom | top | middle
                showZeros = dataLabels.showZeros,
                multiColoring = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("multiColoring") && !chartObj.legendarea.show,
                left = currentPlotBound.left,
                top = currentPlotBound.top,
                right = currentPlotBound.right,
                bottom = currentPlotBound.bottom,
                rectBound = chartObj.svg.node().getBoundingClientRect(),
                rectBoundLeft = (rectBound.left + chartObj.plotarea.left),
                rectBoundTop = (rectBound.top + chartObj.plotarea.top),
                dim = (axisrotated ? chartObj.plotarea.width : chartObj.plotarea.height) * 0.75,
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, (args[2] || "datalabels"), yscale.domain()[1], index),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine,
                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),
                yaxisReversed = systemconf.chart.axes.yaxis[yaxiscolumnorder || 0].reversed,
                barW = chartObj.barscale2.rangeBand() || 0,
                fontSize = getFontSizeByHierarchy(dataLabels, chartObj);
            
            var boundBoxPadding = 0,
                boundBoxStrokeWidth = 0,
                hookHeight = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPadding = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxStrokeWidth = getBoundBoxStrokeWidth(dataLabels, chartObj);
                hookHeight = (stacked || (labelPos === "middle")) ? 0 : hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            var clip = (textOverlap === "clip"),
                handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping && (textOverlap !== "none"),
                padding = mathMax(0, validateNullVal(dataLabels.padding, 2)) + boundBoxPadding + hookHeight;
            padding = (padding > dim) ? dim : padding;
            textDirection = dataLabels.textDirection;
            textDirection = (!textDirection || (stacked && !isStackedLabels)) ? (axisrotated ? "vertical" : "horizontal") : textDirection;
            rotation = axisrotated ? ((textDirection == "horizontal") ? 90 : 0) : ((textDirection == "horizontal") ? 0 : 270);
            var commonOption = renderer.commonOption;
            var getParamValue = function() {
                return chartObj.dataObject.getTransRectValue.apply(chartObj.dataObject, toArray(arguments));
            };
            
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            var updateHandler = labelHandler.update,
                queue = labelHandler.add;
            
            currentdata.data.forEach(function(d, i) {
                var dataUpdate = (renderer.seriesdataAfterUpdate && !isStackedLabels) ? renderer.seriesdataAfterUpdate[i] : currentdata.data[i];
                
                var commonProperties = [];
                applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color, false, index);
                temp_label.style({
                    "fill": "transparent"
                });
                
                dataUpdate.forEach(function(d, j) {
                    var text, boundBox = null,
                        flip = (yaxisReversed ? -1 : 1),
                        isNeg = (isStackedLabels) ? (d[1] < 0) : (dataset.getY(d, yaxiscolumnorder) < 0);
                    
                    temp_label[contentType](function() {
                        if (isStackedLabels) {
                            var yVal = d[1];
                            text = (!showZeros && yVal == 0) ? null : GLT(yVal);
                        } else if (isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder)) || (!showZeros && dataset.getY(d, yaxiscolumnorder) == 0)) {
                            text = null;
                        } else {
                            text = GLT(d);
                        }
                        return text;
                    });

                    if (isMultiLine) {
                        translateTspan(temp_label, 0);
                    }
                    
                    var X, Y, DY, ANCHOR, HOOKPOSITION, actualDY;
                    boundBox = bbox(temp_label.node());
                    var widthToBeAdded = 0,
                        heightToBeAdded = 0;
                    
                    
                    if (isStackedLabels) {
                        // boundBox = bbox(temp_label.node());
                        var x = commonOption.bandwidth1(d[0]) + commonOption.bandwidth2(commonOption.stackGroupIndex) + commonOption.levelMarkerPadding,
                            y = yscale(d[1]);
                        X = axisrotated ? y : x;
                        Y = axisrotated ? x : y;
                        if (axisrotated) {
                            if (textDirection == "horizontal") {
                                X += (isNeg ? -padding : padding) * flip;
                                DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                            } else {
                                X += (isNeg ? -padding : padding) * flip;
                                Y += (barW / 2);
                                DY = "0.3em";
                                ANCHOR = yaxisReversed ? (isNeg ? null : "end") : (isNeg ? "end" : null);
                            }

                            if (isMultiLine) {
                                X += (boundBox.width / 2) * (isNeg ? -1 : 1) * flip;
                            }
                        } else {
                            X += (barW / 2);
                            Y += (isNeg ? padding : -padding) * flip;
                            if (textDirection == "vertical") {
                                DY = "0.3em";
                                ANCHOR = yaxisReversed ? (isNeg ? null : "end") : (isNeg ? "end" : null);
                            } else {
                                DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                                ANCHOR = "middle";
                            }
                        }
                    } else {
                        // var b = boundBox = bbox(temp_label.node()),
                        var b = boundBox,
                            x = getParamValue("x", d, i, j, commonOption) || 0,
                            y = getParamValue("y", d, i, j, commonOption) || 0,
                            width = getParamValue("width", d, i, j, commonOption) || 0,
                            height = getParamValue("height", d, i, j, commonOption) || 0,
                            CLIP = clip;
                        X = x;
                        Y = y;
                        if (axisrotated) {
                            if (stacked) {
                                Y += (height / 2);
                                DY = "0.3em";
                                if (labelPos == "middle") {
                                    X += (width / 2) * flip;
                                    ANCHOR = "middle";
                                } else if (labelPos == "top") {
                                    X += (isNeg ? padding : (width - padding)) * flip;
                                    ANCHOR = yaxisReversed ? (isNeg ? "end" : null) : (isNeg ? null : "end");

                                    if (isMultiLine) {
                                        X += (b.width / 2) * (isNeg ? 1 : -1) * flip;
                                    }
                                } else {
                                    X += (isNeg ? (width - padding) : padding) * flip;
                                    ANCHOR = yaxisReversed ? (isNeg ? null : "end") : (isNeg ? "end" : null);

                                    if (isMultiLine) {
                                        X += (b.width / 2) * (isNeg ? -1 : 1) * flip;
                                    }
                                }
                            } else {
                                if (textDirection == "vertical") {
                                    heightToBeAdded = getSizeToBeAdded(boundBox.height, boundBoxPadding, boundBoxRadius, hookWidth);
                                    Y += (height / 2) + (heightToBeAdded / 2);
                                    DY = "0.3em";
                                    CLIP = CLIP && ((labelPos != "top") && (b.width > width));
                                    HOOKPOSITION = yaxisReversed ? (isNeg ? "left" : "right") : (isNeg ? "right" : "left");
                                    
                                    if (!CLIP) {
                                        ANCHOR = yaxisReversed ? (isNeg ? null : "end") : (isNeg ? "end" : null);
                                        if (labelPos == "middle") {
                                            X += ((b.width > width) ? (isNeg ? width : 0) : (width / 2)) * flip;
                                            ANCHOR = (b.width > width) ? ANCHOR : "middle";
                                        } else if (labelPos == "top") {
                                            X += (isNeg ? -padding : (width + padding)) * flip;
                                        } else {
                                            X += (isNeg ? (width - padding) : padding) * flip;
                                        }

                                        if (isMultiLine && !(labelPos === "middle" && b.width <= width)) {
                                            X += (isNeg ? -boundBox.width/2 : boundBox.width/2) * flip;
                                        }
                                    } else {
                                        if (labelPos == "bottom") {
                                            X += yaxisReversed ? (isNeg ? -width + padding : -width) : (isNeg ? 0 : padding);
                                        } else if (labelPos == "middle") {
                                            X += yaxisReversed ? -width + boundBoxPadding : boundBoxPadding;
                                        }
                                    }
                                } else {
                                    widthToBeAdded = getSizeToBeAdded(boundBox.width, boundBoxPadding, boundBoxRadius, hookWidth);
                                    DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                                    CLIP = CLIP && (b.width > height);
                                    HOOKPOSITION = yaxisReversed ? (isNeg ? "bottom" : "top") : (isNeg ? "top" : "bottom");
                                    
                                    if (labelPos == "middle") {
                                        if (b.height > width) {
                                            if (isMultiLine) {
                                                X += (yaxisReversed ? (isNeg ? width : 0) : (isNeg ? 0 : width)) * flip;
                                                X += yaxisReversed ? ((b.height / 2) * (isNeg ? 1 : -1)) : 0;
                                            } else {
                                                X += (yaxisReversed ? (isNeg ? 0 : width) : (isNeg ? width : 0)) * flip;
                                            }
                                        } else {
                                            X += width / 2 * flip;
                                        }
                                        DY = (b.height > width) ? DY : "0.3em";
                                    } else if (labelPos == "top") {
                                        X += (isNeg ? -padding : (width + padding)) * flip;
                                    } else {
                                        X += (isNeg ? (width - padding) : padding) * flip;
                                    }
                                    if (!CLIP) {
                                        Y += (height / 2);
                                        ANCHOR = "middle";
                                        if (labelPos == "middle") {
                                            DY = "0.3em";
                                        }
                                    } else {
                                        X += (widthToBeAdded / 2);
                                        Y += boundBoxPadding;
                                    }
                                }
                            }
                        } else {
                            if (stacked) {
                                X += (width / 2);
                                ANCHOR = "middle";
                                if (labelPos == "middle") {
                                    Y += (height / 2) * flip;
                                    DY = "0.3em";
                                } else if (labelPos == "top") {
                                    Y += (isNeg ? (height - padding) : padding) * flip;
                                    DY = yaxisReversed ? (isNeg ? "1em" : "-0.3em") : (isNeg ? "-0.3em" : "1em");
                                } else {
                                    Y += (isNeg ? padding : (height - padding)) * flip;
                                    DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                                }
                            } else {
                                if (textDirection == "vertical") {
                                    heightToBeAdded = getSizeToBeAdded(boundBox.height, boundBoxPadding, boundBoxRadius, hookWidth);
                                    var BW = ((!yaxisReversed && isNeg) || (yaxisReversed && !isNeg)) ? b.width : 0;
                                    CLIP = CLIP && ((labelPos != "top") && ((b.width + padding) > height));
                                    DY = "0.3em";
                                    HOOKPOSITION = yaxisReversed ? (isNeg ? "left" : "right") : (isNeg ? "right" : "left");
                                    
                                    if (!CLIP) {
                                        X += (width / 2);
                                        if (labelPos == "middle") {
                                            if (b.width > height) {
                                                if (isMultiLine) {
                                                    Y += (isNeg ? (boundBox.width / 2) : (height - boundBox.width / 2)) * flip;
                                                } else {
                                                    Y += ((isNeg ? 0 : height) * flip) + BW;
                                                }
                                            } else {
                                                Y += height / 2 * flip;
                                            }
                                            ANCHOR = (b.width > height) ? null : "middle";
                                        } else if (labelPos == "top") {
                                            Y += ((isNeg ? (height + padding) : -padding) * flip) + BW;
                                            if (isMultiLine) {
                                                Y -= (boundBox.width / 2);
                                            }
                                        } else {
                                            Y += ((isNeg ? padding : (height - padding)) * flip) + BW;
                                            if (isMultiLine) {
                                                Y -= (boundBox.width / 2);
                                            }
                                        }
                                    } else {
                                        X += (width / 2);
                                        if (labelPos == "middle") {
                                            Y += yaxisReversed ? boundBoxPadding : height - boundBoxPadding;
                                        } else {
                                            Y += yaxisReversed ? (isNeg ? -padding : 0) : (height + (isNeg ? 0 : -padding));
                                        }
                                    }
                                } else {
                                    widthToBeAdded = getSizeToBeAdded(boundBox.width, boundBoxPadding, boundBoxRadius, hookWidth);
                                    CLIP = CLIP && ((b.width + (2 * boundBoxPadding)) > width);
                                    DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                                    HOOKPOSITION = yaxisReversed ? (isNeg ? "bottom" : "top") : (isNeg ? "top" : "bottom");
                                    
                                    if (labelPos == "middle") {
                                        Y += ((b.height < height) ? (height / 2) : (isNeg ? 0 : height)) * flip;
                                        DY = (b.height < height) ? "0.3em" : DY;
                                    } else if (labelPos == "top") {
                                        Y += (isNeg ? (height + padding) : -padding) * flip;
                                    } else {
                                        Y += (isNeg ? padding : (height - padding)) * flip;
                                    }
                                    if (!CLIP) {
                                        X += (width / 2);
                                        ANCHOR = "middle";
                                    } else {
                                        X += boundBoxPadding;
                                    }
                                }
                            }
                        }
                    }
                    
                    if (isMultiLine) {
                        DY = parseFloat(DY);
                        var lineCount = dataLabels.showAs.length - 1;
                        if (DY === -0.3) {
                            actualDY = DY;
                            DY -= lineCount;
                        } else if (DY === 0.3) {
                            actualDY = DY;
                            DY -= (lineCount / 2)
                        }
                        DY += "em";

                        if (!CLIP) {
                            ANCHOR = "middle";
                        }
                    }

                    temp_label.attr({
                        "x": X,
                        "y": Y,
                        "dy": DY,
                        "text-anchor": ANCHOR,
                        "transform": "rotate(" + rotation + " " + X + " " + Y + ")"
                    });
                    
                    var xDiff = 0,
                        yDiff = 0,
                        adjustX = 0,
                        adjustY = 0;
                    HOOKPOSITION = (labelPos === "middle") ? null : HOOKPOSITION // There is no hook for middle datalabels
                    if (axisrotated) {
                        adjustY = ((textDirection === "horizontal") ? widthToBeAdded : heightToBeAdded) / 2;
                    } else {
                        adjustX = ((textDirection === "horizontal") ? widthToBeAdded : heightToBeAdded) / 2;
                    }
                    
                    if (!clip) {
                        if (isMultiLine) {
                            translateTspan(temp_label, X);
                        }
                        var adjust = boundBoxPadding + (boundBoxStrokeWidth / 2),
                            scrolledX = 0,//chartObj.chartRendered ? (chartObj.scrolledX || 0) : 0,
                            scrolledY = 0;//chartObj.chartRendered ? (chartObj.scrolledY || 0) : 0;
                            
                        var b = temp_label.node().getBoundingClientRect(),
                            leftPos = (b.left - rectBoundLeft - adjust - adjustX - scrolledX),
                            rightPos = (leftPos + b.width + (2 * adjust) + (2 * adjustX)),
                            topPos = (b.top - rectBoundTop - adjust - adjustY - scrolledY),
                            bottomPos = (topPos + b.height + (2 * adjust) + (2 * adjustY));
                        
                        var newX = X + ((leftPos < left) ?
                                (left - leftPos) :
                                ((rightPos > right) ? -(rightPos - right) : 0));
                        if (newX != X) {
                            xDiff = newX - X;
                            X = newX;
                        }
                        var newY = Y + ((topPos < top) ? (top - topPos) : ((bottomPos > bottom) ? -(bottomPos - bottom) : 0));
                        if (newY != Y) {
                            yDiff = newY - Y;
                            Y = newY
                        }
                    }
                    

                    /**
                     * Overlapping handle
                     */
                    
                    var isWithinClrRange = isWithinColorRange(dataset.getClr(d), chartObj);
                    var display = isStackedLabels || isWithinClrRange;
                    if (handleOverlapping) {
                        if (stacked && !isStackedLabels) {
                            if (isMultiLine) {
                                translateTspan(temp_label, X);
                            }
                            boundBox = bbox(temp_label.node());
                            var x = getParamValue("x", d, i, j, commonOption) || 0,
                                y = getParamValue("y", d, i, j, commonOption) || 0,
                                height = getParamValue("height", d, i, j, commonOption) || 0,
                                width = getParamValue("width", d, i, j, commonOption) || 0;
                            
                            if (yaxisReversed) {
                                axisrotated ? (x -= width) : (y -= height);
                            }
                            
                            var labelBound = {
                                    "x1": boundBox.x - boundBoxPadding,
                                    "y1": boundBox.y - boundBoxPadding,
                                    "x2": (boundBox.x + boundBox.width + boundBoxPadding),
                                    "y2": (boundBox.y + boundBox.height + boundBoxPadding)
                                },
                                barBound = {
                                    x1: x,
                                    y1: y,
                                    x2: (x + width),
                                    y2: (y + height)
                                };
                            
                            var within = isLabelWithinBound(labelBound, barBound);
                            if (!within) {
                                display = false;
                            }
                            
                        } else {
                            if (!clip || isStackedLabels) {
                                if (isMultiLine) {
                                    translateTspan(temp_label, X);
                                }
                                var b = temp_label.node().getBoundingClientRect();
                                var bx = (b.left - rectBoundLeft),
                                    by = (b.top - rectBoundTop);
                                var obj = {
                                    id: "lbl" + index + "_" + i + "_" + j,
                                    translateFunction: updateHandler,
                                    x1: bx - boundBoxPadding + xDiff - adjustX,
                                    y1: by - boundBoxPadding + yDiff - adjustY,
                                    x2: (bx + b.width) + boundBoxPadding + xDiff + (!rotation ? 0 : (hookHeight + (2 * boundBoxStrokeWidth))) + adjustX,
                                    y2: (by + b.height) + boundBoxPadding + yDiff + (rotation ? 0 : (hookHeight + (2 * boundBoxStrokeWidth))) + adjustY,
                                    overlap: textOverlap
                                };
                                labelArray.push(obj);
                            } else {
                                if (textDirection != "horizontal") {
                                    var w = getParamValue((axisrotated ? "width" : "height"), d, i, j, commonOption) || 0;
                                    width = (labelPos == "top") ?
                                        boundBox.width :
                                        (w - ((labelPos == "bottom") ?
                                            (padding + boundBoxPadding) :
                                            (2 * boundBoxPadding)));
                                } else {
                                    width = barW - (2 * boundBoxPadding);
                                }
                                
                                boundBox.width = mathMin(width, boundBox.width);
                            }
                        }
                    }

                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "DY": DY,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "height": (boundBox.height + heightToBeAdded),
                        "width": (boundBox.width + widthToBeAdded),
                        "hookPosition": HOOKPOSITION,
                        "adjustVal": (textDirection === "horizontal") ? (axisrotated ? yDiff : xDiff) : null
                    };

                    if (actualDY !== undefined) {
                        coordinate.actualDY = actualDY;
                    }

                    if (isCanvasMode && contentType === "html") {
                        coordinate.tspanInfo = getTspanBound(temp_label, fontSize);
                    }

                    commonProperties.push(coordinate);
                });
                
                // add to drawing queue
                commonProperties.dataUpdate = dataUpdate; //Each subseries may have different dataUpdates
                var q = queue(commonProperties, index, i, null, isStackedLabels);
                q.properties = {
                    "type": "bar",
                    "dataLabels": dataLabels,
                    "rotation": rotation,
                    "color": rp.color,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "multiColoring": multiColoring,
                    "textDirection": textDirection,
                    "rp": rp,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
            });
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    
    return labels;
};