//$Id$
$ZC.labelRenderer.funnel = function() {
    var MARGIN = 5,
        renderer, args;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                data = args[2],
                noofNotNullData = args[3],
                arcHeight = args[4],
                totalEngagement = args[5],
                cfg = args[6],
                labelPosition = args[7];
            var chartWidth = cfg.width,
                chartHeight = cfg.height,
                rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                labelArray = rp.labelArray,
                chartName = chartObj.chartTypes[0].name,
                stage,
                dataLabels;
            var translation = chartObj.svg.selectAll("g." + chartName + "group").attr("transform"),
                isPyramid = (chartName === "pyramid");
            
            currentdata = currentdata[index];
            var plotoptions = currentdata.plotoptions,
                boundBoxPaddingAlone = 0,
                boundBoxPadding = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPaddingAlone = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxPadding = boundBoxPaddingAlone + getBoundBoxStrokeWidth(dataLabels, chartObj) + hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            var padding = cfg.datalabelPadding || (+dataLabels.padding || 0),
                type = dataLabels.type,
                handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping === true,
                txtHgt = getFontSizeByHierarchy(dataLabels, chartObj),
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", totalEngagement, index),
                contentType = GLT.contentType || "text",
                isHTMLContent = (contentType === "html"),
                isMultiLine = isHTMLContent && GLT.multiLine,
                showlabel = isDatalabelEnabled(dataLabels, chartObj),
                relativeX = dataLabels.relativeX === true;
            
            if (!showlabel) {
                return;
            }
            
            showlabel = showlabel ? type : "hidden";
            var data_length = data.length,
                PathGroupPosition = d3_transform(translation).translate,
                idx = 0;
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color);
            temp_label
                .attr("transform", translation)
                .style("fill", "transparent");
            var queue = labelHandler.add;
            
            currentdata.data.forEach(function(d, i) {
                var dataUpdate = labelPosition,
                    commonProperties = [];
                
                dataUpdate.forEach(function(d, j) {
                    var display = !isdisabled(j),
                        isLeft = isLeftHalf(idx),
                        heightToBeAdded = 0,
                        bb;
                    
                    var X = getEndX(d, idx) + (isLeft ? -boundBoxPadding : boundBoxPadding),
                        Y = (isPyramid && isLeft) ?
                            d.leftY :
                            mathMax(d.y, (txtHgt - arcHeight - d.y)),
                        ANCHOR = isMultiLine ? "middle" : (isLeft ? "end" : null),
                        DY = isMultiLine ? "0.9em" : "0.3em";
                    
                    var dt = d.data = data[data_length - 1 - j];
                    var text = GLT(dt);
                    
                    temp_label[contentType](text)
                        .attr({
                            "x": X,
                            "y": Y,
                            "text-anchor": ANCHOR,
                            "dy": DY
                        });

                    if (display && isMultiLine) {
                        translateTspan(temp_label, X);
                        var bb = bbox(temp_label.node());
                        Y -= (bb.height / 2);
                        X += (bb.width / 2) * (isLeft ? -1 : 1);
                        translateTspan(temp_label, X);
                        temp_label.attr("y", Y);
                    }
                    
                    if (handleOverlapping) {
                        if (display) {
                            bb = bbox(temp_label.node());
                            heightToBeAdded = getSizeToBeAdded(bb.height, boundBoxPaddingAlone, boundBoxRadius, hookWidth);
                            var DX = (isLeft ?
                                    -(0 + padding + boundBoxPadding) :
                                    (chartWidth + padding + boundBoxPadding));
                            if (isMultiLine) {
                                DX += (bb.width / 2) * (isLeft ? -1 : 1);
                            }

                            var obj = {
                                id: "lbl" + index + "_" + i + "_" + j,
                                x1: bb.x - boundBoxPadding,
                                x2: bb.x + bb.width + boundBoxPadding,
                                y1: bb.y - MARGIN - boundBoxPadding - (heightToBeAdded / 2),
                                isLeft: isLeft,
                                y2: (bb.y + bb.height + MARGIN + boundBoxPadding + (heightToBeAdded / 2)),
                                DX: DX - X
                            };
                            labelArray.push(obj);
                        }
                    } else {
                        bb = bbox(temp_label.node());
                        heightToBeAdded = getSizeToBeAdded(bb.height, boundBoxPaddingAlone, boundBoxRadius, hookWidth);
                    }
                    
                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "ANCHOR": ANCHOR,
                        "DY": DY,
                        "text": text,
                        "display": display,
                        "ID": "lbl" + index + "_" + i + "_" + j,
                        "width": (display ? bb.width : 0),
                        "height": (display ? (bb.height + heightToBeAdded) : 0),
                        "hookPosition": isLeft ? "right" : "left"
                    };

                    if (isHTMLContent) {
                        coordinate.isLeft = isLeft;
                    }

                    commonProperties.push(coordinate);
                    
                    idx += display ? 1 : 0;
                });
                
                idx = -1;
                // add to drawing queue
                var q = queue(commonProperties, index, i);
                q.properties = {
                    "type": "pie",
                    "dataLabels": dataLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "rp": rp,
                    "translation": translation,
                    "trans": PathGroupPosition,
                    "txtHgt": txtHgt,
                    "connectorPath": function(d, i) {
                        idx += isdisabled(i) ? 0 : 1;
                        var y = q[0][i].Y + (isMultiLine ? q[0][i].height/2 : 0),
                            y0 = (isPyramid && isLeftHalf(idx)) ? d.leftY : d.y;
                        return "M" + getStartX(d, idx) + " " + y0 +
                            " L" + getEndX(d, idx, 0) + " " + y0 +
                            " L" + getEndX(d, idx) + " " + y;
                    },
                    "reverseColor": true,
                    "onOverlap": function() {
                        stage = "overlap";
                    },
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
                
                labelArray.TOP = -PathGroupPosition[1],
                    labelArray.BOTTOM = chartHeight + PathGroupPosition[1];
                labelArray.actualType = "funnel";
                
            });
            
            
            function isdisabled(i) {
                var dt = data[data_length - 1 - i];
                var isWithinClrRange = isWithinColorRange(dataset.getClr(dt), chartObj);
                return dt.disabled || !dataset.getY(dt, yaxiscolumnorder) || !isWithinClrRange;
            }
            
            function isLeftHalf(idx) {
                switch (showlabel) {
                    case "singleside":
                        return false;
                    case "doubleside":
                        return idx % 2 == 0;
                    case "strokeddoubleside":
                        return idx >= (noofNotNullData / 2);
                }
            }
            
            function getStartX(d, i) {
                return isLeftHalf(i) ?
                    (d.leftx + padding) :
                    (d.rightx - padding);
            }
            
            function getEndX(d, i, pad) {
                var isLeft = isLeftHalf(i);
                if (!relativeX || (stage == "overlap")) {
                    pad = defined(pad) ? pad : padding;
                    return isLeft ? (0 - pad) : (chartWidth + pad)
                } else {
                    return isLeft ? (d.leftx - boundBoxPadding) : (d.rightx + boundBoxPadding);
                }
            }
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    return labels;
};