//$Id$
$ZC.labelRenderer.funnelInnerLabels = function() {
    var renderer, args;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                data = args[2],
                arcHeight = args[4],
                totalEngagement = args[5],
                cfg = args[6],
                labelPosition = args[7];
            var chartWidth = cfg.width,
                rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                chartName = chartObj.chartTypes[0].name;
            var translation = chartObj.svg.selectAll("g." + chartName + "group").attr("transform"),
                isPyramid = (chartName === "pyramid");
            
            currentdata = currentdata[index];
            var plotoptions = currentdata.plotoptions;
            var dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var innerLabels = dataLabels.innerLabel,
                padding = cfg.datalabelPadding || (+dataLabels.padding || 0),
                PathGroupPosition = d3_transform(translation).translate,
                data_length = data.length;
            
            var showInnerLabel = innerLabels.show === true,
                txtHgt = getFontSizeByHierarchy(innerLabels, chartObj),
                GLT = dataLabelTextContent(chartObj, rp, innerLabels, "innerLabel", totalEngagement, index),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine,
                boundBoxPadding = isBoundBoxEnabled(dataLabels, chartObj) ? (getBoundBoxPadding(dataLabels, chartObj) + getBoundBoxStrokeWidth(dataLabels, chartObj)) : 0;
            showInnerLabel = showInnerLabel && datacount_based_intelligence(chartObj, "datalabels");
            txtHgt = txtHgt + (2 * boundBoxPadding);
            
            if (currentdata.disabled || !showInnerLabel) {
                return;
            }
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            applyDatalabelFonts(temp_label, innerLabels, chartObj, rp.color);
            temp_label
                .attr("transform", translation)
                .style("fill", "transparent");
            var queue = labelHandler.add;
            
            currentdata.data.forEach(function(d, i) {
                var dataUpdate = labelPosition,
                    commonProperties = [];
                
                dataUpdate.forEach(function(d, j) {
                    var display = !isdisabled(j),
                        X = (isPyramid) ?
                            d.midX :
                            (chartWidth / 2),
                        Y = (isPyramid) ?
                            d.leftY :
                            d.y,
                        ANCHOR = "middle",
                        DY = isMultiLine ? "0.9em" : "0.5em",
                        text = GLT(data[data_length - 1 - j]),
                        bb = null;
                    
                    temp_label[contentType](text)
                        .attr({
                            "x": X,
                            "y": Y,
                            "dy": DY,
                            "text-anchor": ANCHOR
                        });

                    if (display && isMultiLine) {
                        translateTspan(temp_label, X);
                        bb = bbox(temp_label.node());
                        Y -= bb.height / 2;
                        txtHgt = bb.height;
                    }

                    if (display) {
                        bb = bb || bbox(temp_label.node());
                        if (isPyramid) {
                            display = !(txtHgt > ((d.y0 - d.leftY) * 2));
                        } else {
                            var ellipseArcHeight = cfg.canOverlap ? (((d.rightx - d.leftx - (2 * padding)) / chartWidth) * arcHeight) : arcHeight;
                            display = !((txtHgt < (d.y - (d.y0 - d.y) + ellipseArcHeight)) && (txtHgt > ((d.y0 + ellipseArcHeight) - (d.y - (d.y0 - d.y) + ellipseArcHeight))));
                        }
                    }
                    
                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "DY": DY,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "ID": "innerlbl" + index + "_" + i + "_" + j,
                        "width": display ? bb.width : 0,
                        "height": display ? bb.height : 0
                    };
                    commonProperties.push(coordinate);
                });
                
                // add to drawing queue
                var q = queue(commonProperties, index, i, null, null, true);
                q.properties = {
                    "type": "pie",
                    "dataLabels": innerLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": showInnerLabel,
                    "rp": rp,
                    "translation": translation,
                    "trans": PathGroupPosition,
                    "reverseColor": true,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
                
            });
            
            function isdisabled(i) {
                var dt = data[data_length - 1 - i];
                var isWithinClrRange = isWithinColorRange(dataset.getClr(dt), chartObj);
                return dt.disabled || !dataset.getY(dt, yaxiscolumnorder) || !isWithinClrRange;
            }
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    return labels;
};