//$Id$
/*
 * PENDING:
 * Bound box - minHeight should be considered for height on handling overlapping datalabels (if hook is enabled)
 */
 //multi coloring
$ZC.labelRenderer.hierarchy = function() {
    var renderer, args, labelseries;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                size = args[2] || 0,
                yrangePos = args[3],
                total = args[4],
                leafNodes = args[5],
                transform = args[6] || [0, 0],
                plotoptions = currentdata.plotoptions,
                dataLabels,
                rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                labelArray = rp.labelArray,
                xscale = rp.xscale,
                yscale = rp.yscale;
            
            dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var showlabel = isDatalabelEnabled(dataLabels, chartObj);
            
            if (currentdata.disabled || !showlabel) {
                return;
            }
            
            var chartName = chartObj.chartTypes[0].name;

            var currentPlotBound = getPlotBound(chartObj),
                boundBoxPadding = 0,
                boundBoxStrokeWidth = 0,
                hookHeight = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPadding = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxStrokeWidth = getBoundBoxStrokeWidth(dataLabels, chartObj);
                hookHeight = hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            var textOverlap = dataLabels.textOverlap,//dataLabels.textOverlap, //hidden | adjust | ellipsis
                hAlign = dataLabels.hAlign || "center",
                vAlign = dataLabels.vAlign || "center",
                padding = validateNullVal(dataLabels.padding, 0.5),
                handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping === true,
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", total, index, yrangePos),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine,
                fontSize = getFontSizeByHierarchy(dataLabels, chartObj),
                heightAdjustScale = d3_scaleLinear().domain([-0.3, 0.9]);
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            var updateHandler = labelHandler.update,
                queue = labelHandler.add;
            
            
            // currentdata.forEach(function(d, i) {
                var dataUpdate = leafNodes;
                
                var calculated_points = [];
                applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color, false, index);
                temp_label.style({
                    "fill": "transparent"
                });
                
                dataUpdate.forEach(function(d, j) {
                    var pos = getPosition(d);
                    var x = pos.x,
                        y = pos.y,
                        text = null,
                        tspanInfo = null,
                        display = colorscale_helpers.isQuantileColorScale(chartObj) ? isWithinColorRange(dataset.getClr(d.data || d), chartObj) : true,
                        id = "",
                        dy = getDy() + "em",
                        ANCHOR = getAnchor(),
                        HOOKPOSITION = null,
                        xDiff = 0,
                        yDiff = 0,
                        polarXY;

                    
                    temp_label[contentType](function() {
                            text = GLT(d.data || d);
                            return text;
                        })
                        .attr({
                            "dy": dy,
                            "x": x,
                            "y": y,
                            "text-anchor": ANCHOR,
                            "display": display
                        });
                    
                    // ID
                    id = "lbl" + d.level;

                    var textBound;
                    if (isMultiLine) {
                        translateTspan(temp_label, x);
                        textBound = bbox(temp_label.node());
                    } else if (contentType === "html") { //Test_665.json
                        textBound = bbox(temp_label.node());
                    } else {
                        textBound = getTextBound(text, fontSize, getFontFamilyByHierarchy(dataLabels, chartObj));
                        textBound = updateTextBound(textBound, ANCHOR, dy, x, y);
                    }

                    widthToBeAdded = 0;
                    var bb_width = textBound.width + widthToBeAdded,
                        bb_height = textBound.height,
                        bb_x = textBound.x + (widthToBeAdded / 2);
                    if (handleOverlapping) {
                        // Consider padding for label bound
                            var labelBound = {
                                    "x1": textBound.x - boundBoxPadding,
                                    "y1": textBound.y - boundBoxPadding,
                                    "x2": (textBound.x + textBound.width + boundBoxPadding),
                                    "y2": (textBound.y + textBound.height + boundBoxPadding)
                                },
                                nodeBound = getNodeBound(getRawPosition(d), textBound);

                            var within = isLabelWithinBound(labelBound, nodeBound);
                            if (!within) {
                                var trimmed;
                                if (textOverlap === "ellipsis") { // add ellipsis
                                    var h = pos.h;
                                    var w = pos.w;
                                    if ((bb_height + 2*boundBoxPadding) < h) {
                                        var bound = {
                                            "left": (nodeBound.x1 + boundBoxPadding),
                                            "top": (nodeBound.y1 + boundBoxPadding),
                                            "right": (nodeBound.x2 - boundBoxPadding),
                                            "bottom": (nodeBound.y2 - boundBoxPadding)
                                        };

                                        if (contentType === "html") {
                                            tspanInfo = getTspanBound(temp_label, fontSize);
                                            trimAllTspan(temp_label, chartObj, transform, 0, bound, tspanInfo);
                                        } else {
                                            callTrimText(temp_label, chartObj, transform, 0, bound);
                                        }

                                        var trimmedText = temp_label.text();
                                        if (trimmedText && trimmedText !== "..") { //If the textContent is just "..", hide the label
                                            text = temp_label[contentType]();
                                            trimmed = true;
                                            bb_width = w - (2 * boundBoxPadding);
                                            if (isMultiLine) {
                                                var newBB = bbox(temp_label.node());
                                                bb_height = newBB.height;
                                                bb_width = newBB.width + widthToBeAdded;
                                                y += (textBound.height - newBB.height) / 2;
                                            }
                                        }
                                    }
                                }
                                
                                if (!trimmed) {
                                    display = false;
                                }
                            }
                        
                    }

                    var coordinate = {
                        "X": x,
                        "Y": y,
                        "DY": dy,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "height": bb_height,
                        "width": bb_width,
                        "hookPosition": HOOKPOSITION,
                        "adjustVal": xDiff
                    };

                    calculated_points.push(coordinate);
                });

                calculated_points.dataUpdate = dataUpdate; //Each subseries may have different dataUpdates
                var q = queue(calculated_points, index, 0, yrangePos);
                q.properties = {
                    "type": "hierarchy",
                    "dataLabels": dataLabels,
                    "color": rp.color,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "rp": rp,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
            // });

            function getPosition(d) {
                var pos = getRawPosition(d),
                    x = pos.x;
                    y = pos.y;
                    w = pos.width;
                    h = pos.height;

                x = updateXposition(x, w) + transform[0];
                y = updateYposition(y, h) + transform[1];

                return {
                    x: x,
                    y: y,
                    w: w,
                    h: h
                };
            }

            function getNodeBound(pos, textBound) {
                var nodeheight = pos.height,
                    nodewidth = pos.width,
                    nodex = pos.x + transform[0],
                    nodey = pos.y + transform[1];

                var bb = {
                    x1: nodex,
                    y1: nodey,
                    x2: (nodex + nodewidth),
                    y2: (nodey + nodeheight)
                }

                if (chartName === "packedbubble") {
                    var radius = nodewidth / 2,// hypotenuse
                        vert = mathMin((textBound.height / 2), radius),
                        hori = mathSQRT(mathPow(radius, 2) - mathPow(vert, 2)),
                        excess = radius - hori;
                    bb.x1 += excess;
                    bb.x2 -= excess;
                    bb.y1 += excess;
                    bb.y2 -= excess;
                }
                return bb;
            }

            function updateXposition(x, w) {
                if (hAlign === "center") {
                    x += (w/2);
                } else if (hAlign === "right") {
                    x += (w - padding - boundBoxPadding);
                } else {
                    x += (padding + boundBoxPadding);
                }
                return x;
            }

            function updateYposition(y, h) {
                if (vAlign === "center") {
                    y += (h/2);
                } else if (vAlign === "bottom") {
                    y += h - padding - boundBoxPadding;
                } else {
                    y += (padding + boundBoxPadding);
                }
                return y;
            }

            function getAnchor() {
                return (hAlign === "center") ? "middle" : (hAlign === "right") ? "end" : null;
            }

            function getDy() {
                var DY;
                    if (vAlign === "center") {
                        DY = 0.3;
                    } else if (vAlign === "bottom") {
                        DY = -0.3;
                    } else {
                        DY = 1;
                    }
                if (isMultiLine) {
                        var lineCount = (dataLabels.showAs.length - 1) * 1.1;
                        if (DY === -0.3) {
                            DY -= lineCount;
                        } else if (DY === 0.3) {
                            DY -= (lineCount / 2)
                        }
                }
                return DY;
            }
            function getRawPosition(d) {
                switch(chartName) {
                    case "packedbubble":
                        return getPackedbubblePosition(d);
                        break;
                    case "treemap":
                        return getTreemapPosition(d);
                    case "heatmap":
                        return getHeatCellPosition(chartObj, d, xscale, yscale, yaxiscolumnorder);
                }
            }

            function updateTextBound(textBound, ANCHOR, dy, x, y) {
                var w = textBound.width,
                    h = textBound.height;
                var tx = ((ANCHOR === "middle") ?
                                (w / 2) :
                                ((ANCHOR === "end") ? w : 0)),
                    ty = heightAdjustScale.range([h, 0])(parseFloat(dy));
                textBound.x = x - tx;
                textBound.y = y - ty;
                return textBound;
            }
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    
    return labels;
};