//$Id$
$ZC.labelRenderer.pie = function() {
    var renderer, args,
        outline,
        isSunburst,
        chartObj,
        dataset;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                pieData = args[2],
                outerRadius = args[3],
                totalEngagement = args[4],
                outlineWithPad = args[5],
                translation = "translate(" + args[8][0] + "," + args[8][1] + ")",
                extraOptions = args[9] || {},
                rp = renderer.commonRendererProp().params;

            chartObj = rp.chartObj;
            dataset = chartObj.dataset;
            var systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                labelArray = rp.labelArray,
                index = rp.datasetIndex || args[1] || 0, //For pie & dial chart, rp.datasetIndex is undefined
                dataLabels,
                chartheight = (renderer.plotarea ? renderer.plotarea() : chartObj.plotarea).height;
            isSunburst = !pieData;
            currentdata = currentdata[index];
            outline = args[6];

            var handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping === true,
                datalabelPadding, padding, txtHgt, showlabel;
            
            var plotoptions = currentdata.plotoptions;
            var dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            showlabel = isDatalabelEnabled(dataLabels, chartObj);
            
            if (currentdata.disabled || !showlabel) {
                return;
            }
            
            var type = dataLabels.type,
                lineConf = dataLabels.line,
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", totalEngagement, index),
                contentType = GLT.contentType || "text",
                isHTMLContent = (contentType === "html"),
                isMultiLine = isHTMLContent && GLT.multiLine,
                boundBoxPaddingAlone = 0,
                boundBoxPadding = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPaddingAlone = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxPadding = boundBoxPaddingAlone + getBoundBoxStrokeWidth(dataLabels, chartObj) + hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            showlabel = showlabel ? type : "hidden";
            datalabelPadding = (extraOptions.padding || +(dataLabels.padding || 0)) + boundBoxPadding;
            txtHgt = getFontSizeByHierarchy(dataLabels, chartObj);
            padding = +($ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("outerPadding") || 0);
            renderer.autoLabelDone = false, renderer.showlabel = showlabel, renderer.lineStrokeWidth = validateNullVal(lineConf.strokeWidth, 1);
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            temp_label
                .attr("transform", translation);
            var queue = labelHandler.add;
            
            (isSunburst ? currentdata : currentdata.data).forEach(function(d, i) {
                var dataUpdate = (renderer.seriesdataAfterUpdate) ? renderer.seriesdataAfterUpdate[i] : (pieData || d);
                
                var commonProperties = [];
                applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color);
                temp_label
                    .style("fill", "transparent");
                
                dataUpdate.forEach(function(d, j) {
                    var text,
                        bb = null,
                        display = !isdisabled(d),
                        heightToBeAdded = 0;
                    
                    var angle = midAngle(d);
                    var isLeft = (angle < 0) || (angle > mathPI);
                    var X = (showlabel == "doubleside") ? ((angle < 0 || angle > mathPI) ? -(outerRadius + datalabelPadding) : (outerRadius + datalabelPadding)) : outlineWithPad.centroid(d)[0],
                        Y = outlineWithPad.centroid(d)[1] + mathMax(0, (txtHgt - padding - 10) - (outerRadius + outlineWithPad.centroid(d)[1])),
                        ANCHOR = isMultiLine ? "middle" : isLeft ? "end" : "start",
                        DY = isMultiLine ? "0.9em" : ((showlabel == "circular") && (angle > mathPI / 2 && angle < 3 * mathPI / 2) ? getDY(angle) + "em" : "0.3em");
                    var actualDY = DY;
                    
                    var dt = isSunburst ? d : d.data;
                    var toNull = isSunburst ? (d.depth == 0) : isdisabled(d);
                    text = (toNull ? null : GLT(dt));
                    
                    temp_label[contentType](text)
                        .attr({
                            "x": X,
                            "y": Y,
                            "dy": DY,
                            "text-anchor": ANCHOR
                        });

                    if (display && isMultiLine) {
                        translateTspan(temp_label, X);
                        var bb = bbox(temp_label.node());
                        if (showlabel == "circular") {
                            var yscale = d3_scaleLinear()
                                    .range([-1, 0])
                                    .domain((angle < mathPI) ? [0, mathPI] : [2 * mathPI, mathPI]);
                            Y += (yscale(angle) * bb.height);
                            X += ((angle>0 && angle < mathPI) ? 0.5 : (angle>mathPI && angle < 2*mathPI) ? -0.5 : 0) * bb.width;

                        } else {
                            Y -= (0.5 * bb.height);
                            X -= (bb.width / 2) * (isLeft ? 1 : -1);
                        }

                        temp_label.attr("y", Y);
                        translateTspan(temp_label, X);
                    }
                    
                    if (handleOverlapping) {
                        renderer.showlabel = "auto";
                        var MARGIN = 5,
                            extra = 10;
                        
                        if (!isMultiLine) {
                            DY = "0.3em";
                            temp_label
                                .attr("dy", DY); // Test_495.json
                        }
                        
                        if (display) {
                            bb = bbox(temp_label.node());
                            heightToBeAdded = getSizeToBeAdded(bb.height, boundBoxPaddingAlone, boundBoxRadius, hookWidth);
                            var DX = isLeft ?
                                    -(outerRadius + datalabelPadding + extra) :
                                    (outerRadius + datalabelPadding + extra);
                            if (isMultiLine) {
                                DX += (bb.width / 2) * (isLeft ? -1 : 1);
                            }

                            var obj = {
                                id: "lbl" + index + "_" + i + "_" + j,
                                x1: bb.x - boundBoxPadding,
                                x2: bb.x + bb.width + boundBoxPadding,
                                y1: bb.y - MARGIN - boundBoxPadding - (heightToBeAdded / 2),
                                y2: (bb.y + bb.height + MARGIN + boundBoxPadding + (heightToBeAdded / 2)),
                                isLeft: isLeft,
                                actualDY: actualDY,
                                DX: DX - X,
                                overlappingHookPosition: (isLeft ? "right" : "left")
                            };
                            labelArray.push(obj);
                        }
                    } else {
                        bb = bbox(temp_label.node());
                        heightToBeAdded = getSizeToBeAdded(bb.height, boundBoxPaddingAlone, boundBoxRadius, hookWidth);
                    }
                    
                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "DY": DY,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "ID": "lbl" + index + "_" + i + "_" + j,
                        "width": (display ? bb.width : 0),
                        "height": (display ? (bb.height + heightToBeAdded) : 0),
                        "hookPosition": (showlabel === "circular") ? null : (isLeft ? "right" : "left")
                    };

                    if (isHTMLContent) {
                        coordinate.isLeft = isLeft;
                    }

                    commonProperties.push(coordinate);
                });
                
                // add to drawing queue
                var q = queue(commonProperties, index, i);
                q.properties = {
                    "type": "pie",
                    "dataLabels": dataLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": renderer.showlabel,
                    "rp": rp,
                    "translation": translation,
                    "trans": args[8],
                    "txtHgt": txtHgt,
                    "isSunburst": isSunburst,
                    "connectorPath": function(d, i) {
                        var angle = midAngle(d);
                        var str = "M " + outline.centroid(d)[0] + " " + outline.centroid(d)[1] + " L" + outlineWithPad.centroid(d)[0] + " " + outlineWithPad.centroid(d)[1];
                        return str + " L" + outlineWithPad.centroid(d)[0] + " " + outlineWithPad.centroid(d)[1] + " L" + ((angle < 0 || angle > mathPI) ? -(outerRadius + datalabelPadding - boundBoxPadding) : (outerRadius + datalabelPadding - boundBoxPadding)) + " " + outlineWithPad.centroid(d)[1];
                    },
                    "onNonOverlap": function() {
                        q.properties.showlabel = renderer.showlabel = showlabel;
                        renderer.autoLabelDone = true;
                    },
                    "onOverlap": function() {
                        q.properties.connectorPath = function(d, i) {
                            var extra = 10;
                            var angle = midAngle(d);
                            var pad = mathMax(0, (txtHgt - padding - 10) - (outerRadius + outlineWithPad.centroid(d)[1]));
                            var y = outlineWithPad.centroid(d)[1] + pad;
                            var flip = ((angle < 0) || (angle > mathPI)) ? -1 : 1;
                            var newY = q[0][i].Y + (isMultiLine ? q[0][i].height/2 : 0);
                            // var path = "M " + outline.centroid(d)[0] + " " + outline.centroid(d)[1] +
                            //     " L" + outlineWithPad.centroid(d)[0] + " " + outlineWithPad.centroid(d)[1] +
                            //     " L" + ( (outerRadius + datalabelPadding) * flip ) + " " + outlineWithPad.centroid(d)[1] +
                            //     " L" + ( (outerRadius + datalabelPadding + extra) * flip ) + " " + newY;
                            // ele
                            // .attr("d", path);
                            
                            var xControl = (newY - y) ? (outerRadius + datalabelPadding - boundBoxPadding + extra) * flip : outlineWithPad.centroid(d)[0],
                                yControl = outlineWithPad.centroid(d)[1],
                                x2 = (outerRadius + datalabelPadding - boundBoxPadding + extra) * flip,
                                y2 = newY;
                            var path = "M " + outline.centroid(d)[0] + " " + outline.centroid(d)[1] +
                                " Q " + xControl + " " + yControl + " " + x2 + " " + y2;
                            return path;
                        };
                    },
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
                
                labelArray.TOP = -args[8][1],
                    labelArray.BOTTOM = (chartheight - args[8][1]);
                
            });
            
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    
    function isdisabled(d) {
        var isWithinClrRange = isWithinColorRange(dataset.getClr(isSunburst ? d : d.data), chartObj);
        return !isWithinClrRange || (isSunburst ?
            (d.parent == null || d.value == 0) :
            (d.value == 0));
    }
    
    function midAngle(d) {
        var start = isSunburst ? outline.startAngle()(d) : d.startAngle,
            end = isSunburst ? outline.endAngle()(d) : d.endAngle;
        return (start + end) / 2;
    }
    
    return labels;
};