//$Id$
$ZC.labelRenderer.pieInnerLabels = function() {
    var renderer, args,
        chartObj,
        dataset;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                pieData = args[2],
                totalEngagement = args[4],
                translation = args[8] ? "translate(" + args[8][0] + "," + args[8][1] + ")" : null,
                arc = args[7],
                rp = renderer.commonRendererProp().params;

            dataset = rp.dataset;
            chartObj = rp.chartObj;
            var commonPlotOptions = rp.commonPlotOptions,
                index = args[1] || 0,
                isSunburst = !pieData,
                outline = args[6],
                yaxiscolumnorder = rp.yaxiscolumnorder;
            
            currentdata = currentdata[index];
            var isBubblePie = chartObj.dataObject.pieWithAxis;
            
            var plotoptions = currentdata.plotoptions;
            var dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var innerLabels = dataLabels.innerLabel;
            
            var GLT = function(conf) {
                    return dataLabelTextContent(chartObj, rp, conf, "innerLabel", totalEngagement, index);
                },
                globalGLT = dataLabelTextContent(chartObj, rp, innerLabels, "innerLabel", totalEngagement, index),
                contentType = globalGLT.contentType || "text",
                isMultiLine = (contentType === "html") && globalGLT.multiLine,
                textOverlap = innerLabels.textOverlap || "adjust",
                showInnerLabel = innerLabels.show === true,
                showParentInnerLabel = isSunburst && ((innerLabels.parentLabel.show || showInnerLabel) != false),
                boundBoxPadding = isBoundBoxEnabled(innerLabels, chartObj) ? (getBoundBoxPadding(innerLabels, chartObj) + getBoundBoxStrokeWidth(innerLabels, chartObj)) : 0;
            showInnerLabel = showInnerLabel && datacount_based_intelligence(chartObj, "datalabels");
            var parentInnerLabel;
            if (showParentInnerLabel) {
                parentInnerLabel = mergeJSON(innerLabels.parentLabel, innerLabels);
            }
            
            if (currentdata.disabled || !(showInnerLabel || showParentInnerLabel)) {
                return;
            }
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            applyDatalabelFonts(temp_label, innerLabels, chartObj, rp.color);
            temp_label
                .attr("transform", translation)
                .style("fill", "transparent");
            var queue = labelHandler.add;
            
            (isSunburst ? currentdata : currentdata.data).forEach(function(d, i) {
                var dataUpdate = (isBubblePie) ? d : (pieData || getDataPlusParent(d)),
                    commonProperties = [];
                
                dataUpdate.forEach(function(d, j) {
                    
                    var bb = null;
                    var display = !isdisabled(d),
                        ANCHOR = "middle",
                        DY = isMultiLine ? "0.9em" : "0.35em",
                        X,
                        Y,
                        xVal = 0,
                        yVal = 0;
                    if (isBubblePie) {
                        var stacked = rp.stacked,
                            axisrotated = rp.axisrotated,
                            xscale = rp.xscale,
                            yscale = rp.yscale;
                        var X = dataset.getX(d);
                        var pieRenderer = chartObj.subrenderer[i][X];
                        d = pieRenderer.data[index];
                        arc = pieRenderer.arc;
                        
                        xVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d.data, "x", null);
                        yVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d.data, "y", null);
                        var zVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d.data, "z", chartObj.zscale);
                        
                        var outerRadius = (zVal / 4);
                        var polarXY = polarToXY(outerRadius, midAngle(d));
                        GLT = function(conf) {
                            return dataLabelTextContent(chartObj, rp, conf, "innerLabel", pieRenderer.total, index);
                        };
                        
                        
                        X = xVal + polarXY[0];
                        Y = yVal + polarXY[1];
                    } else {
                        X = arc.centroid(d)[0];
                        Y = arc.centroid(d)[1];
                    }
                    
                    
                    var dt = isSunburst ? d : d.data;
                    var toNull = isSunburst ? (d.depth == 0) : isdisabled(d);
                    var text = toNull ? null : GLT((showParentInnerLabel && d.children) ? parentInnerLabel : innerLabels)(dt);
                    
                    temp_label[contentType](text)
                        .attr({
                            "x": X,
                            "y": Y,
                            "dy": DY,
                            "text-anchor": ANCHOR
                        });

                    if (display && isMultiLine) {
                        translateTspan(temp_label, X);
                        bb = bbox(temp_label.node());
                        Y -= bb.height / 2;
                    }
                    
                    if (textOverlap != "none") {
                        /*
                         * Default position for the inner label is arc.centroid(d)
                         * innerLabelWithinArc() finds the best position for the inner label
                         * If the inner label overflows in its centroid position but it could be placed inside the arc, it will be translated to its best position
                         * Else it will not be displayed
                         */
                        bb = bb || bbox(temp_label.node());
                        var centre = arc.centroid(d);
                        var wid = bb.width / 2 + boundBoxPadding,
                            hei = bb.height / 2 + boundBoxPadding;
                        var TL = {
                                x: (centre[0] - wid),
                                y: (centre[1] - hei)
                            },
                            TR = {
                                x: (centre[0] + wid),
                                y: (centre[1] - hei)
                            },
                            BL = {
                                x: (centre[0] - wid),
                                y: (centre[1] + hei)
                            },
                            BR = {
                                x: (centre[0] + wid),
                                y: (centre[1] + hei)
                            };
                        var isPointInArc = pointIsInArc(TL, d) &&
                            pointIsInArc(TR, d) &&
                            pointIsInArc(BL, d) &&
                            pointIsInArc(BR, d);
                        if (!isPointInArc) {
                            if (textOverlap === "adjust") {
                                var SA = isSunburst ? outline.startAngle()(d) : d.startAngle,
                                    EA = isSunburst ? outline.endAngle()(d) : d.endAngle,
                                    MA = midAngle(d),
                                    extra = bb.height + (2 * boundBoxPadding), // / Math.cos(MA), //Need to check again
                                    s, e;
                                
                                var a1 = xyToAngle(TL),
                                    a2 = xyToAngle(TR),
                                    a3 = xyToAngle(BL),
                                    a4 = xyToAngle(BR);
                                var angleArray = [a1, a2, a3, a4],
                                    posArray = [TL, TR, BL, BR];
                                var minmax = d3_extent(angleArray);
                                
                                var s = posArray[angleArray.indexOf(minmax[0])],
                                    e = posArray[angleArray.indexOf(minmax[1])];
                                
                                var dist = mathSQRT(((s.x - e.x) * (s.x - e.x)) + ((s.y - e.y) * (s.y - e.y)));
                                var r = mathAbs((dist / 2) / mathTan((EA - SA) / 2)) + extra;
                                var newCentre = [(mathSin(MA) * r), -(mathCos(MA) * r)];
                                
                                var TL = {
                                        x: (newCentre[0] - wid),
                                        y: (newCentre[1] - hei)
                                    },
                                    TR = {
                                        x: (newCentre[0] + wid),
                                        y: (newCentre[1] - hei)
                                    },
                                    BL = {
                                        x: (newCentre[0] - wid),
                                        y: (newCentre[1] + hei)
                                    },
                                    BR = {
                                        x: (newCentre[0] + wid),
                                        y: (newCentre[1] + hei)
                                    };
                                isPointInArc = pointIsInArc(TL, d) &&
                                    pointIsInArc(TR, d) &&
                                    pointIsInArc(BL, d) &&
                                    pointIsInArc(BR, d);
                            }
                            
                            if (isPointInArc) {
                                X = newCentre[0] + xVal;
                                Y = newCentre[1] + yVal;
                            } else {
                                display = false;
                            }
                        }
                    } else {
                        bb = bbox(temp_label.node());
                    }
                    
                    
                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "DY": DY,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "ID": "innerlbl" + index + "_" + i + "_" + j,
                        "width": bb.width,
                        "height": bb.height
                    };
                    commonProperties.push(coordinate);
                });
                
                // add to drawing queue
                var q = queue(commonProperties, index, i, null, null, true);
                q.properties = {
                    "type": "pie",
                    "dataLabels": innerLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": showInnerLabel,
                    "rp": rp,
                    "translation": translation,
                    "trans": args[8],
                    "isSunburst": isSunburst,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
                
            });
            
            function getDataPlusParent(d) {
                var dPlusParent = showInnerLabel ? d.slice(0) : [];
                if (showParentInnerLabel && d[0]) {
                    dPlusParent.push(d[0].parent);
                }
                return dPlusParent;
            }
            
            function pointIsInArc(pt, ptData) {
                var r1 = arc.innerRadius()(ptData),
                    r2 = arc.outerRadius()(ptData),
                    theta1 = arc.startAngle()(ptData),
                    theta2 = arc.endAngle()(ptData),
                    dist = pt.x * pt.x + pt.y * pt.y,
                    angle = xyToAngle(pt);
                return (r1 * r1 <= dist) && (dist <= r2 * r2) && isAngleInside(theta1, theta2, angle);
            }
            
            function xyToAngle(obj) {
                return mathAtan2(obj.x, -obj.y);
            }
            
            function isdisabled(d) {
                var isWithinClrRange = isWithinColorRange(dataset.getClr(isSunburst ? d : d.data || d), chartObj);
                return !isWithinClrRange || (isSunburst ?
                    (d.parent == null || d.value == 0) :
                    (d.value == 0));
            }
            
            function midAngle(d) {
                var start = isSunburst ? outline.startAngle()(d) : d.startAngle,
                    end = isSunburst ? outline.endAngle()(d) : d.endAngle;
                return (start + end) / 2;
            }
            
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    return labels;
};