//$Id$
/*
 * PENDING:
 * Bound box - minHeight should be considered for height on handling overlapping datalabels (if hook is enabled)
 */
$ZC.labelRenderer.scatter = function() {
    var renderer, args, labelseries,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                size = args[2] || 0,
                yrangePos = args[3],
                transform = [0, 0],
                plotoptions = currentdata.plotoptions,
                dataLabels, rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                stacked = rp.stacked,
                axisrotated = rp.axisrotated,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                xscale = rp.xscale,
                yscale = rp.yscale,
                labelArray = rp.labelArray,
                chartType = chartObj.chartTypes[index].value,
                isRangeChart = chartObj.chartTypes[index].name == "arearange",
                isCanvasMode = chartObj.plot.renderer.mode === "canvas";
            var scatterOrBubble = isScatterChartType(chartType),
                isBubbleChart = (chartType == $ZC.charttype.bubble),
                isBubblePie = (chartType == $ZC.charttype.bubblepie),
                isPolar = chartObj.dataObject.isPolarAxisCategory;
            
            dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var showlabel = isDatalabelEnabled(dataLabels, chartObj);
            
            if (currentdata.disabled || !showlabel) {
                return;
            }
            
            var currentPlotBound = getPlotBound(chartObj),
                boundBoxPadding = 0,
                boundBoxStrokeWidth = 0,
                hookHeight = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPadding = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxStrokeWidth = getBoundBoxStrokeWidth(dataLabels, chartObj);
                hookHeight = hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            var padding = isBubbleChart ? 0 : (mathMax(0, +(dataLabels.padding || 0)) + boundBoxPadding + hookHeight),
                textOverlap = dataLabels.textOverlap, //hidden | adjust | ellipsis
                handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping === true,
                multiColoring = scatterOrBubble ? ($ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("multiColoring") && !chartObj.legendarea.show) : false,
                rectBound = chartObj.svg.node().getBoundingClientRect(),
                left = currentPlotBound.left,
                top = currentPlotBound.top,
                right = currentPlotBound.right,
                bottom = currentPlotBound.bottom,
                rectBoundLeft = (rectBound.left + chartObj.plotarea.left),
                rectBoundTop = (rectBound.top + chartObj.plotarea.top),
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", yscale.domain()[1], index, yrangePos),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine,
                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),
                fontSize = getFontSizeByHierarchy(dataLabels, chartObj);
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            var updateHandler = labelHandler.update,
                queue = labelHandler.add;
            
            
            currentdata.data.forEach(function(d, i) {
                var dataUpdate = renderer.seriesdataAfterUpdate ? renderer.seriesdataAfterUpdate[i] : currentdata.data[i];
                
                var calculated_points = [];
                applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color, false, index);
                temp_label.style({
                    "fill": "transparent"
                });
                
                dataUpdate.forEach(function(d, j) {
                    var xVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos),
                        yVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos),
                        zVal = (isBubbleChart || isBubblePie) ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "z", chartObj.zscale) : null,
                        isWithinClrRange = isWithinColorRange(dataset.getClr(d), chartObj);
                    var x = null,
                        y = null,
                        text = null,
                        tspanInfo = null,
                        display = isWithinClrRange,
                        id = "",
                        dy = isMultiLine ? "0.9em" : (isBubbleChart ? "0.3em" : "-0.3em"),
                        ANCHOR = "middle",
                        HOOKPOSITION = isBubbleChart ? null : "bottom",
                        xDiff = 0,
                        yDiff = 0,
                        polarXY;

                    if (isBubblePie) {
                        var X = dataset.getX(d);
                        var pieRenderer = chartObj.subrenderer[i][X];
                        var pieData = pieRenderer.data[index];
                        var midAngle = (pieData.startAngle + pieData.endAngle) / 2;
                        var outerRadius = (zVal / 2) + padding;
                        var polarXY = polarToXY(outerRadius, midAngle);
                        dy = (midAngle > mathPI / 2 && midAngle < 3 * mathPI / 2) ? getDY(midAngle) + "em" : "0";
                        ANCHOR = (midAngle < 0 || midAngle > mathPI) ? "end" : "start";
                        GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", pieRenderer.total, index, yrangePos);
                    }
                    temp_label[contentType](function() {
                            if (d.isDummy || isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder, yrangePos))) {
                                text = null;
                            } else {
                                text = GLT(d);
                            }
                            return text;
                        })
                        .style({
                            "display": function() {
                                if (isPolar) {
                                    return null;
                                }
                                //If the data point itself out of plot, need not to show label.
                                var ptX = xVal,
                                    ptY = yVal,
                                    pointOutOfPlot = (ptX < left || ptX > right || ptY < top || ptY > bottom);
                                return pointOutOfPlot ? ((display = false), "none") : null;
                            }
                        })
                        .attr({
                            "transform": null,
                            "dy": dy,
                            "x": function() {
                                x = isBubblePie ?
                                    (xVal + polarXY[0]) :
                                    xVal;
                                return x || 0;
                            },
                            "y": function() {
                                var radius = (isBubbleChart ? 0 : size) / 2;
                                y = isBubblePie ?
                                    (yVal + polarXY[1]) :
                                    yVal + ((radius + padding) * ((isRangeChart && !yrangePos) ? 1 : -1));
                                return y || 0;
                            },
                            "text-anchor": ANCHOR
                        });
                    
                    // ID
                    id = "lbl" + index + "_" + i + "_" + j + "_" + yrangePos;

                    var textBound;
                    if (isMultiLine) {
                        translateTspan(temp_label, x);
                        textBound = bbox(temp_label.node());
                        y -= isBubbleChart ? (textBound.height / 2) : textBound.height;
                        temp_label.attr("y", y);
                        textBound = bbox(temp_label.node());
                    } else if (contentType === "html") { //Test_665.json
                        textBound = bbox(temp_label.node());
                    } else {
                        textBound = getTextBound(text, fontSize, getFontFamilyByHierarchy(dataLabels, chartObj));
                        textBound.x = x - textBound.width / 2;
                        textBound.y = y - textBound.height;
                    }
                    
                    // Adjust Text Within Bound
                    var widthToBeAdded = 0;
                    if (!isPolar) {
                        widthToBeAdded = getSizeToBeAdded(textBound.width, boundBoxPadding, boundBoxRadius, hookWidth);
                        var adjust = boundBoxPadding + (boundBoxStrokeWidth / 2) + (widthToBeAdded / 2),
                            scrolledX = 0;//chartObj.chartRendered ? (chartObj.scrolledX || 0) : 0;

                        var label = temp_label,
                            leftPos = textBound.x - adjust,
                            rightPos = (leftPos + textBound.width + scrolledX + (2 * adjust));
                        var newX = x + ((leftPos < left) ? (left - leftPos) : ((rightPos > right) ? -(rightPos - right) : 0));


                        if (xDiff = (newX - x)) {
                            x = newX;
                            label.attr("x", newX);
                            if (isMultiLine) {
                                translateTspan(temp_label, newX);
                            }
                        }

                        // var z = +label.attr("y");
                        var newY = y + ((textBound.y < top) ? (textBound.height + size + padding) : 0);
                        if (yDiff = newY - y) {
                            if (chartObj.dataObject.isStackedPercentChart && !axisrotated) {
                                y = newY;
                                label.attr("y", newY);
                            } else {
                                display = false;
                            }
                        }

                        if(isMultiLine && (xDiff || yDiff)) {
                            textBound = bbox(temp_label.node());
                        } else {
                            textBound.x += xDiff;
                            textBound.y += yDiff
                        }
                    }



                    widthToBeAdded = (isPolar) ? getSizeToBeAdded(textBound.width, boundBoxPadding, boundBoxRadius, hookWidth) : widthToBeAdded;
                    var bb_width = textBound.width + widthToBeAdded,
                        bb_height = textBound.height,
                        bb_x = textBound.x + (widthToBeAdded / 2);
                    if (handleOverlapping) {
                        var radius = (isBubbleChart ? zVal : size) / 2;
                        
                        if (isBubbleChart) { // Bubble chart - Don't show datalabels when they are out of the bubble bound
                            var cx = xVal,
                                cy = yVal,
                                leftDist = mathSQRT(mathPow((cx - bb_x), 2) + mathPow((cy - textBound.y), 2)) + boundBoxPadding,
                                rightDist = mathSQRT(mathPow((cx - (bb_x + textBound.width)), 2) + mathPow((cy - (textBound.y + textBound.height)), 2)) + boundBoxPadding;
                            
                            if ((leftDist > radius) || (rightDist > radius)) {
                                var trimmed;
                                if (textOverlap === "ellipsis") { // add ellipsis
                                    var h = mathMin((textBound.height / 2), radius);
                                    var w = mathSQRT(mathPow(radius, 2) - mathPow(h, 2));
                                    var bubbleBound = {
                                        "left": (cx - w + boundBoxPadding),
                                        "top": (cy - w + boundBoxPadding),
                                        "right": (cx + w - boundBoxPadding),
                                        "bottom": (cy + w - boundBoxPadding)
                                    };

                                    if (contentType === "html") {
                                        tspanInfo = getTspanBound(temp_label, fontSize);
                                        trimAllTspan(temp_label, chartObj, transform, 0, bubbleBound, tspanInfo);
                                    } else {
                                        callTrimText(temp_label, chartObj, transform, 0, bubbleBound);
                                    }

                                    var trimmedText = temp_label.text();
                                    if (trimmedText && trimmedText !== "..") { //If the textContent is just "..", hide the label
                                        text = temp_label[contentType]();
                                        trimmed = true;
                                        bb_width = (2 * w) - (2 * boundBoxPadding);
                                        if (isMultiLine) {
                                            var newBB = bbox(temp_label.node());
                                            bb_height = newBB.height;
                                            bb_width = newBB.width + widthToBeAdded;
                                            y += (textBound.height - newBB.height) / 2;
                                        }
                                    }
                                }
                                
                                if (!trimmed) {
                                    display = false;
                                    temp_label.style("display", "none");
                                }
                            }
                        }

                        var obj = {
                            id: id,
                            x1: bb_x - boundBoxPadding,
                            y1: textBound.y - boundBoxPadding,
                            x2: (bb_x + bb_width + boundBoxPadding),
                            y2: (textBound.y + textBound.height + boundBoxPadding + hookHeight),
                            pointRadius: (radius + padding - hookHeight),
                            translateFunction: updateHandler,
                            overlap: textOverlap,
                            hookHeight: hookHeight
                        };
                        labelArray.push(obj);
                    }

                    var coordinate = {
                        "X": x,
                        "Y": y,
                        "DY": dy,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "height": bb_height,
                        "width": bb_width,
                        "hookPosition": HOOKPOSITION,
                        "adjustVal": xDiff
                    };

                    if (isCanvasMode && contentType === "html") {
                        coordinate.tspanInfo = tspanInfo || getTspanBound(temp_label, fontSize);
                    }

                    calculated_points.push(coordinate);
                });

                calculated_points.dataUpdate = dataUpdate; //Each subseries may have different dataUpdates
                var q = queue(calculated_points, index, i, yrangePos);
                q.properties = {
                    "type": "scatter",
                    "dataLabels": dataLabels,
                    "color": rp.color,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "multiColoring": multiColoring,
                    "rp": rp,
                    "rangeChart": isRangeChart,
                    "yrangePos": yrangePos,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
            });
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    
    return labels;
};