//$Id$
$ZC.legend.colorBand = function(element, chartObj) {
	//color band
	var legendOptions = chartObj.systemConf.legend,
		colorbandOptions = legendOptions.colorBand,

		dimension = legend_helpers.getColorBandDimension(chartObj),
		width = dimension[0],
		height = dimension[1],

		isHorizontal = (legendOptions.vAlign === "bottom" || legendOptions.vAlign === "top"),
		userRanges_length = colorbandOptions.ranges && colorbandOptions.ranges.length,

		borderRadius = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, colorbandOptions.borderRadius);

	var scale = chartObj.axes.clr.scale,
		scale_domain,
		scale_range,
		offsetScale;
		if (userRanges_length) {
			scale_range = scale.range().filter(function(d){ return d !== null;});
				var temp_domain = [], temp_range = [];
				for(var i=0; i<userRanges_length; i++){
					temp_domain.push(i, i+1);
					temp_range.push(scale_range[i], scale_range[i]);
				}
				scale_domain = temp_domain;
				scale_range = temp_range;

			offsetScale = d3_scaleOrdinal()
				.domain(scale_domain)
				.rangePoints([0, 100]);
		} else {
			scale_domain = scale.domain();
			scale_range = scale.range();

            if (scale_domain[0] === scale_domain[1]) { //Test_696.json
                scale_range = [scale_range[0], scale_range[0]];
            }

			offsetScale = d3_scaleLinear()
				.domain([scale_domain[0], scale_domain[scale_domain.length - 1]])
				.range([0, 100]);
		}

	var gradientOptions = {
			"type": "linear",
			"options": {
				"linear": {
					"x2": isHorizontal ? 100 : 0,
					"y1": isHorizontal ? 0 : 100,
					"gradientUnits": "objectBoundingBox",
					"stopColor": scale_range,
					"stopOffset": scale_domain.map(function(d) {
						return offsetScale(d) + "%";
					})
				}
			}
		},
		gradientDim = [0, width],

		prop = getGradientProp(gradientOptions, gradientDim),
		args = {
			"chartObj": chartObj
		},
		gradientEle = effects.get(svg_gradients, "svgGradientFill", prop, args);

	element
		.attr("d", roundedRect(0, 0, width, height, borderRadius))
		.style({
			"stroke": colorbandOptions.strokeColor,
			"stroke-opacity": colorbandOptions.strokeOpacity,
			"stroke-width": colorbandOptions.strokeWidth,
			"fill-opacity": colorbandOptions.fillOpacity,
			"fill": "url(" + chartObj.defsLocation + "#" + gradientEle + ")"
		});
};