//$Id$
$ZC.legend.render = function(chartObj) {
    var systemconf = chartObj.systemConf,
        legendData = systemconf.legend,
        dataObject = chartObj.dataObject,
        seriesdata = chartObj.seriesdata;

    var isQuantileColorScale = colorscale_helpers.isQuantileColorScale(chartObj),
        isContinousLegend = legend_helpers.isContinousLegend(chartObj),
        legComp = chartObj.legend.component = isContinousLegend ? $ZC.legend.continuous.get() : $ZC.legend.discrete.get();
    
    var legendShow = (chartObj.isAxisCategory || chartObj.isNonAxisMultiSeriesCategory) ?
        seriesdata.some(function(d){ return !legend_helpers.isHiddenItem(d) && d.seriesname !== UNDEFINED; }) :
        !(chartObj.chartTypes[0].value == $ZC.charttype.dial);
    legendShow = legendShow || isQuantileColorScale;

    
    var dim = chartObj.canvasarea[(legendData == null || legendData.vAlign == null) ? "height" : (legendData.vAlign === "top" || legendData.vAlign === "bottom") ? "height" : "width"],
        floating = (legendData != null && legendData.x != null && legendData.x !== "") && (legendData.y != null && legendData.y !== "");
    legendShow = (floating || dimension_based_intelligence(chartObj, "legend", dim)) ? legendShow : false;
    
    createColorAxis();

    if (legendShow && legendData.enabled === true) {
        chartObj.legendarea.show = true;
        chartObj.legendarea.element.style("display", "");
        drawLegend();
    } else {
        chartObj.legendarea.show = false
        chartObj.legendarea.element.style("display", "none");
        $ZC.legend.events(chartObj, chartObj.legendarea.element.selectAll("li.series"), {allSelected: true, isFirstClickAfterDeselection: false});
    }
    
    function getlegend(legdata) {
        var legend = legComp
            .chartarea(chartObj.chartarea)
            .systemconf(systemconf)
            .color(chartObj.seriesColor)
            .chartObj(chartObj);
        return legend;
    }
    
    function drawLegend() {
        var legpos = legendData.legpos;
        legComp = getlegend(legendData);
        legComp(chartObj.legendarea.element.datum(legendData));
        var legnode = chartObj.legendarea.element.node(),
            legwid,
            leghei,
            legx,
            legy;

        if (isContinousLegend) {
            var bb = bbox(legnode);
            legwid = bb.width;
            leghei = bb.height;
            legy = bb.y;
            legx = bb.x;
        } else {
            legwid = legnode.offsetWidth;
            leghei = legnode.offsetHeight;
            legy = legnode.offsetTop;
            legx = legnode.offsetLeft;
        }

        var floating = (legendData.x != null && legendData.x !== "") && (legendData.y != null && legendData.y !== "");
        legendData.marginLeft = +(legendData.marginLeft);
        legendData.marginRight = +(legendData.marginRight);
        legendData.marginTop = +(legendData.marginTop);
        legendData.marginBottom = +(legendData.marginBottom);
        if (!floating) {
            if (legendData.vAlign == "center") {
                chartObj.chartarea.width -= (legwid + legendData.marginLeft + legendData.marginRight)
                chartObj.plotarea.width -= (legwid + legendData.marginLeft + legendData.marginRight)
                if (legendData.hAlign == "left") {
                    chartObj.chartarea.left += (legwid + legendData.marginLeft + legendData.marginRight)
                    chartObj.plotarea.left += (legwid + legendData.marginLeft + legendData.marginRight)
                }
            } else if (legendData.vAlign == "top") {
                chartObj.chartarea.top += (leghei + legendData.marginTop + legendData.marginBottom);
                chartObj.plotarea.top += (leghei + legendData.marginTop + legendData.marginBottom);
                chartObj.chartarea.height -= (leghei + legendData.marginTop + legendData.marginBottom);
                chartObj.plotarea.height -= (leghei + legendData.marginTop + legendData.marginBottom);
            } else if (legendData.vAlign == "bottom") {
                chartObj.chartarea.height -= (leghei + legendData.marginTop + legendData.marginBottom);
                chartObj.plotarea.height -= (leghei + legendData.marginTop + legendData.marginBottom);
            }
        }
        chartObj.legendarea.x = legx, chartObj.legendarea.y = legy
        chartObj.legendarea.width = legwid, chartObj.legendarea.height = leghei;
    }

    function createColorAxis() {
        if (isQuantileColorScale) {
            var userRanges = chartObj.systemConf.legend.colorBand.ranges;
            if (userRanges && userRanges.length) {
                chartObj.userdata.legend.colorBand.ranges = chartObj.systemConf.legend.colorBand.ranges = getRawRanges(chartObj, true); //for  [10,20,30,40] ranges where the ranges are not array, it is mandatory to convert it to array and save it in userdata and systemconf for performing legend highlight, filter and redraw after legend filter
            }

            var colorScale = $ZC.scale.getScale(chartObj, dataObject, null, null, null, chartObj.dataset, "clr"),
                colorScale_domain = colorScale.domain(),
                indexScale = colorScale.copy();
            indexScale.range(colorscale_helpers.getProcessedColorRange(d3_range(colorScale_domain.length), colorScale_domain, chartObj.systemConf.legend.colorBand, chartObj));

            chartObj.axes.clr = {
                scaleType: "quantile",
                scale: colorScale,
                indexScale: indexScale
            };

        } else {
            chartObj.axes.clr = {};
        }
    }
};