//$Id$
var $ZC_legend_minmaxLabels;
(function() {
	ZC_legend_minmaxLabels = function (element, dimension, axisOptions, chartObj, orient) {
    	var systemConf = chartObj.systemConf,
    		minmaxlabelsOptions = axisOptions.minmaxlabels,
            legendOptions = chartObj.systemConf.legend,
            colorbandOptions = legendOptions.colorBand,
            sliderSize = legendOptions.filter.enabled ? getSliderSize(ZC_brushComponent_getSliderOptions(dimension, legendOptions.filter)) : [0, 0],

    		padding = validateNullVal(minmaxlabelsOptions.padding, 2),
    		align = minmaxlabelsOptions.align,
            userLabels = minmaxlabelsOptions.text,

            isDiscrete = colorbandOptions.ranges && colorbandOptions.ranges.length,
            data = [],

            //Formatter
            columnInfo = chartObj.dataset.getColumn("clr"),
            datatype = columnInfo.datatype,
            formatConf = columnInfo[datatype];

        if (minmaxlabelsOptions.show) {
            if (isDiscrete) {
                var isOrdinal = chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE,
                    ranges = getRawRanges(chartObj);

                data = [ranges[0][0], ranges[ranges.length - 1][defined(ranges[ranges.length - 1][0]) ? 0 : 1]];
            } else {
                var scale_domain = chartObj.axes.clr.scale.domain();
                data = [scale_domain[0], scale_domain[scale_domain.length - 1]];
            }
        }

    	var labelGroup = appendEle(element, "g", [1], ".", "class", "zchart-minmaxlabels");
    	var labels = appendEle(labelGroup, "text", data);

    	labels
    		.each(function(d,i) {
    			var pos = getPositionInfo(orient, dimension, align, padding, sliderSize, i);
    			d3_select(this)
    				.attr({
    					"x": pos.x,
    					"y": pos.y,
    					"text-anchor": pos.anchor,
    					"dy": pos.dy
    				})
    				.text(userLabels ? userLabels[i] : getFormattedValue(formatConf, d, datatype, chartObj, "minmaxlabels"));
    		});
    	applyFont(labels, [minmaxlabelsOptions, systemConf.chart, systemConf.canvas, $ZCG]);
    }

    function getPositionInfo(orient, dimension, align, padding, sliderSize, i) {
    	var x, y, dy, ANCHOR;
    	if (orient === "bottom") {
    		if (align === "top") {
    			dy = "-0.3em";
    			ANCHOR = (i === 0) ? null : "end";
    			y = -dimension[1] - padding - mathMax(0, (sliderSize[1] - dimension[1]) / 2);
    			if (i === 0) {
    				x = 0;
    			} else {
    				x = dimension[0];
    			}
    		} else if (align === "bottom") {
    			dy = "1em";
    			ANCHOR = (i === 0) ? null : "end";
    			y = padding + mathMax(0, (sliderSize[1] - dimension[1]) / 2);
    			if (i === 0) {
    				x = 0;
    			} else {
    				x = dimension[0];
    			}
    		} else {
    			dy = "0.3em";
    			ANCHOR = (i === 0) ? "end" : null;
    			y = -dimension[1] / 2;
    			if (i === 0) {
    				x = -padding - sliderSize[0] / 2;
    			} else {
    				x = dimension[0] + padding + sliderSize[0] / 2;
    			}
    		}
    	} else if (orient === "top") {
    		if (align === "top") {
    			dy = "-0.3em";
    			ANCHOR = (i === 0) ? null : "end";
    			y =  - padding - mathMax(0, (sliderSize[1] - dimension[1]) / 2);
    			if (i === 0) {
    				x = 0;
    			} else {
    				x = dimension[0];
    			}
    		} else if (align === "bottom") {
    			dy = "1em";
    			ANCHOR = (i === 0) ? null : "end";
    			y = dimension[1] + padding + mathMax(0, (sliderSize[1] - dimension[1]) / 2);
    			if (i === 0) {
    				x = 0;
    			} else {
    				x = dimension[0];
    			}
    		} else {
    			dy = "0.3em";
    			ANCHOR = (i === 0) ? "end" : null;
    			y = dimension[1] / 2;
    			if (i === 0) {
    				x = -padding - sliderSize[0] / 2;
    			} else {
    				x = dimension[0] + padding + sliderSize[0] / 2;
    			}
    		}
    	} else if (orient === "right"){
    		if (align === "left") {
    			dy = (i !== 0) ? "1em" : "-0.3em";
    			ANCHOR = "end";
    			x = -dimension[0] - padding - mathMax(0, (sliderSize[1] - dimension[0]) / 2);
    			if (i !== 0) {
    				y = 0;
    			} else {
    				y = dimension[1];
    			}
    		} else if (align === "right") {
    			dy = (i !== 0) ? "1em" : "-0.3em";
    			ANCHOR = null;
    			x = padding + mathMax(0, (sliderSize[1] - dimension[0]) / 2);
    			if (i !== 0) {
    				y = 0;
    			} else {
    				y = dimension[1];
    			}
    		} else {
    			dy = (i !== 0) ? "-0.3em" : "1em";
    			ANCHOR = "middle"
    			x = -dimension[0] / 2;
    			if (i !== 0) {
    				y = -padding - sliderSize[0] / 2;
    			} else {
    				y = dimension[1] + padding + sliderSize[0] / 2;
    			}
    		}
    	} else {
    		if (align === "left") {
    			dy = (i !== 0) ? "1em" : "-0.3em";
    			ANCHOR = "end";
    			x = - padding - mathMax(0, (sliderSize[1] - dimension[0]) / 2);
    			if (i !== 0) {
    				y = 0;
    			} else {
    				y = dimension[1];
    			}
    		} else if (align === "right") {
    			dy = (i !== 0) ? "1em" : "-0.3em";
    			ANCHOR = null;
    			x = dimension[0] + padding + mathMax(0, (sliderSize[1] - dimension[0]) / 2);
    			if (i !== 0) {
    				y = 0;
    			} else {
    				y = dimension[1];
    			}
    		} else {
    			dy = (i !== 0) ? "-0.3em" : "1em";
    			ANCHOR = "middle"
    			x = dimension[0] / 2;
    			if (i !== 0) {
    				y = -padding - sliderSize[0] / 2;
    			} else {
    				y = dimension[1] + padding + sliderSize[0] / 2;
    			}
    		}
    	}
    	return {
    		x: x,
    		y: y,
    		dy: dy,
    		anchor: ANCHOR
    	}
    }

    function getSliderSize(sliderOptions) {
        var type = sliderOptions.type,
            options = sliderOptions[type];
        if (type === "triangleUp" || type === "triangleDown") {
            return [0, 0];
        } else if (type === "lever") {
            return [options.width, options.height];
        } else {
            return [options.size, options.size];
        }
    }

})();