//$Id$
map_series_renderer.filled = function(parent, series, seriesIndx, color, pointDetails){
        var dataset = map_util.getDataset();

        var map = map_util.getChartObject().mapObj.map;

        var dataObj = map_util.getChartObject().dataObject;

        var features = [],id,centroid,nullDataIdxs = [];

        var fillColor, layer, geojson, geojson_id, seriesLayer ;

        var seriesGroupElement = parent.attr('class', 'series filled');//NO I18N

        var path = d3.geo.path().projection(d3.geo.transform({
            point : projectionPoint
        }));
                
        series.data.forEach(function(subgroup, index){ 
            if(subgroup && subgroup.constructor == Array){
                subgroup.forEach(function(point, index){
                    var xVal = dataset.getActualX(point)
                    var featurePoint = dataset.getFeature(point);
                    var feature =  featurePoint ?(featurePoint instanceof Object ? featurePoint : JSON.parse(featurePoint)) : null;
                    var id = seriesIndx + "_" + index;
                    if(feature && feature.type!="point"){
                        centroid = map.layerPointToLatLng(path.centroid(feature));
                        dataset.updateFeature(point,feature);
                        feature.centroid = centroid;
                        feature.id = id;
                        features.push(feature);
                        pointDetails.push(point);
                        map_util.addPlotPoint({
                            "xVal" : xVal,//NO I18N
                            "id" : id,//NO I18N
                            "latLng" : centroid,//NO I18N
                            "feature" : feature,//NO I18N
                            "color":color//NO I18N
                        });
                    }
                    else {
                        map_renderer_util.unknowndata.add(xVal);
                    }
                })
            }
        });
               
        var opacityVal = map_util.getOpacityValue();
        
        var fillOpacity =  opacityVal!=null ? opacityVal : 0.85;
    
        fillColor = {
            "weight":0,//NO I18N
            "fillOpacity": fillOpacity,//NO I18N
            "smoothFactor": 0,//NO I18N
            "fillColor":color//NO I18N
            
        };
        
        layer = new L.LayerGroup();

        geojson = L.geoJson(features,{
            style: fillColor,
            onEachFeature: onEachFeature
        }).addTo(layer);

        geojson_id = geojson._leaflet_id;
        seriesLayer = layer._layers[geojson_id];

        map_util.addPlotLayer({
                            "seriesVal"   : seriesIndx,//NO I18N
                            "seriesLayer" : seriesLayer,//NO I18N
                            "seriesColor" : color,//NO I18N
                            "seriesGeoJson" : geojson//NO I18N
                        });
                        
        if(!series.disabled)
        {
              map.addLayer(layer);
        }
        function onEachFeature(feature, layer) {
            layer.on({
                            mouseover: highlightFeature,
                            mouseout: resetHighlight,
                            click: showMenu
            });
        }
        function showMenu()
        {
              eventsObject.setId(id);
        }
        function resetHighlight(e) {
                eventsObject.setId(null);
                geojson.resetStyle(e.target);
        }

        function highlightFeature(e) {
            var layer = e.target;
            var canvas = document.getElementsByClassName("leaflet-zoom-animated leaflet-interactive")[0];
                id = layer.feature.geometry.id;
                eventsObject.setId(id);
            layer.setStyle({
//                        "fillColor" :  patternFill(color,canvas),//NO I18N //pattern 
                "weight" : 1.5,//NO I18N
                "color":"#727070"//NO I18N
            });   
        }

        function projectionPoint(x,y){
            var layerPoint = map.latLngToLayerPoint(L.latLng(y,x));
            this.stream.point(layerPoint.x, layerPoint.y);
        }

    };
