//$Id$
map_series_renderer.pie = function(parent, seriesData, seriesColor, pointDetails,update) {
        var pieRendererUpdate = [];
        var chartObj = map_util.getChartObject();
        var dataset = map_util.getDataset();
        var type = chartObj.chartTypes[0].value;
        var scale = map_util.getScale();
        var isExport = chartObj.userdata.geo.isExport;
        var latLngArray = [];
        var className = 'subseriesgroup_0' ; //NO I18N
        parent.attr("class",className);//NO I18N
        var points = [];
        var unknownIdx = [];
        var rendererData = [];
        var nullDataIdx = [];
        //inorder to set the domain for scaling 
        var maxTotalSum = 0;
        var minTotalSum = 0;
        var pieData =  map_util.processBubblePieData(type);
        pieData.forEach(function(group, index) {
            if (group && group.constructor == Array) {
                group.forEach(function(subgroup, index) {
                    var latLng;
                    var totalSum = 0;
                    var nullDataCount = 0;
                    var disabledDataCount = 0;
                    var indexCount = 0;
                    //for manipulating datalabels 
                    var pieDetails = [];
                    if(subgroup && subgroup.constructor == Array){
                        subgroup.forEach(function(point, i) {
                            latLng = latLng ? latLng : dataset.getLatLng(point);
                                pieDetails.push(point);
                                  if(!point.disabled)
                                  {
                                      if(point[1] != null)
                                      {
                                          if(typeof(point[3]) != "object") 
                                          {
                                              var zVal = dataset.getZ(point);
                                              totalSum = totalSum + zVal;
                                          }
                                      }
                                      else
                                      {
                                          point.disabled = true;
                                          nullDataCount++;
                                          disabledDataCount++;
                                      }
                                   }
                                  else
                                    disabledDataCount++;
                                  indexCount = i;
                            });
                            if(nullDataCount == indexCount+1 || disabledDataCount == indexCount+1)
                                subgroup.disabled = true;
                            else
                                subgroup.disabled = false;
                            if(maxTotalSum < totalSum)
                                maxTotalSum = totalSum;
                            else if(minTotalSum > totalSum && totalSum < 0 )
                                minTotalSum =  totalSum;
                            var xVal = dataset.getActualX(subgroup[0]);
                            if (latLng && !subgroup.disabled) {
                                latLngArray.push(latLng);
                                pointDetails.push(pieDetails);
                                map_util.addPlotPoint({
                                    "xVal": xVal,//NO I18N
                                    "latLng": latLng,//NO I18N
                                    "size":scale ? totalSum : 35,//NO I18N
                                });
                            } 
                            else if(subgroup.disabled)
                            {
                                nullDataIdx.push(index);
                            }
                            else {
                                map_renderer_util.unknowndata.add(xVal);
                                unknownIdx.push(index);
                            }
                    }
                    
                });
            }
       });
       minTotalSum = minTotalSum == 0 ? 0 : minTotalSum;
      // to set scale 
      type == geobubblepie ? chartObj.zscale.domain([minTotalSum,maxTotalSum]) : null;
      
       //to remove the unknow data and null data from the Pie Data;
       
       function compareNumbers(a, b)
        {
            return a - b;
        }
       
       var idxsToBeRemoved = [];
       idxsToBeRemoved = unknownIdx.concat(nullDataIdx);
       idxsToBeRemoved.sort(compareNumbers);
       idxsToBeRemoved.forEach(function(d,i){
             pieData[0].splice(d-i,1);
       });
       
       chartObj.piedata = pieData;
   
       var basicAttr = map_util.getPlotOptions(chartObj.chartTypes[0].name);
       basicAttr.fillOpacity = map_util.getOpacityValue();
       if(isExport)
            basicAttr.animation.enabled = false;
       
       var commonRendererProp = {
            params: {
            chartObj: chartObj,
            commonPlotOptions:basicAttr ,
            dataset: chartObj.dataset
            }
        }
        var scatterGroups = parent.selectAll('g.scatter').data(pieData[0]); //NO I18N
        scatterGroups.enter().append('g').attr('class','scatter'); //NO I18N
        scatterGroups.exit().remove();
        scatterGroups.
                   each(function(d,i)
                   {
                       var xVal = dataset.getActualX(d[0]);
                       var size = scale ? scale(chartObj.mapObj.plotted_data[xVal].size) : 35;
                       var pieRenderer;
                       if(!update)
                       {
                           pieRenderer = svg_plot_renderer.pie();
                       }
                       else
                       {
                           pieRenderer = chartObj.pieRenderer[xVal] ? chartObj.pieRenderer[xVal] : svg_plot_renderer.pie();
                       }
                        pieRenderer
                                .commonRendererProp(commonRendererProp)
                                .plotarea({
                                    width: size,
                                    height: size,
                                    left: size / 2,
                                    top: size / 2
                                });
                        d3_select(this).datum(d);
                        d3_select(this).call(pieRenderer);
                        d3.select(this).selectAll("path").filter(function(d){return (d.startAngle === d.endAngle) || !d.endAngle ;}).each(function(){ d3.select(this).style("display","none","important") });//NO I18N
                        var translate = d3.transform(d3.select(this).selectAll("g").attr("transform")).translate;//NO I18N
                        d3_select(this).selectAll("g").attr("transform","translate("+ (translate[0] - size/2) + "," + (translate[1] - size/2) +")");//NO I18N
                        pieRendererUpdate[xVal] = pieRenderer;
                        rendererData[xVal] = pieRenderer.data;
                            //data is needed for handling events
                    });
         // inorder to prohibit the data change occurs in pie renderer function      
         chartObj.renderedPiedata = $ZC.utils.simpleClone(rendererData);
         chartObj.pieRenderer = pieRendererUpdate;
        parent.selectAll("g.scatter").data(latLngArray);//NO I18N  
    };


