//$Id$
map_renderer_util.initMapSVG = function(leafletMapObj)
{
        
        var size = leafletMapObj.getSize();
        // var svg = d3_select(leafletMapObj.getPanes().overlayPane).select('svg');
        // if(!svg.empty()){
        //     svg.remove();
        // }
        var svg = d3_select(L.svg().addTo(leafletMapObj)._container).attr('class', 'chartsvg')//NO I18N
        svg.select('g').remove(); // Leaflet appends a g by default;//NO I18N
        return svg;
        
        //d3_select(leafletMapObj.getPanes().overlayPane)
        // .append('svg')
        // .attr('class','chartsvg')
        // .attr('width',size.x)
        // .attr('height',size.y) - previously created svg in this manner,
        // as the function resides in beta version of leaflet svg was appended explicitely
        
};
    
map_renderer_util.initNoDataHandlerElement = function(svg) 
{
        
        var width = map_util.getMapDimension().width;
        var height = map_util.getMapDimension().height;
        
        var g = appendEle(svg, "g", [1], ".", "class", "nodatahandler");//NO I18N
        var rect = appendEle(g, "rect", [1], ".", "class", "nodatahandler");//NO I18N
        
        rect.style({
            'width': width,//NO I18N
            'height': height//NO I18N
        });
        var transform = map_util.getLeafletMap()._mapPane.style.transform || map_util.getLeafletMap()._mapPane.style.webkitTransform;
        var result = transform.match(/translate3d\((.+)px,(.+)px,(.+)px\)/);

        result = result==null ? [0,0,0] : result;

        // to position no data g
        var x = -pInt(result[1]) + 'px';
        var y = -pInt(result[2]) + 'px';
        var z = -pInt(result[3]) + 'px';
        g.style({
            'transform': 'translate3d(' + x + ',' + y + ',' + z + ')'//NO I18N
        });
};
     
map_renderer_util.plotMapChart = function(svg, chartObj, update) 
{

        var seriesDetails = [];
        var g = update ? svg.select('g.seriesholder') : svg.append('g').attr('class', 'leaflet-zoom-hide seriesholder');//NO I18N
        var hover = update ? svg.select('g.highlight-group') : svg.append('g').attr('class', 'leaflet-zoom-hide highlight-group');//NO I18N
        var series = chartObj.seriesdata;
        var seriesColor = chartObj.seriesColor;
        //zoho charts need to fix;
        if(chartObj.userdata.metadata.axes.clr)
        {
            chartObj.rendererConf = [];
            series.forEach(function(d){
                chartObj.rendererConf[d.seriesidx] = {};
            });
        }
        
        var defs = svg.select("defs");//NO I18N

        setLinearGradient(defs);
        function setLinearGradient(defs)
        {
            var linearGradient = appendEle(defs,"linearGradient",[1]);
        
            linearGradient
                .attr("id","SVGUrl")//NO I18N
                .attr("gradientUnits","userSpaceOnUse")//NO I18N
                .attr("x1","-180.5832")//NO I18N
                .attr("y1","-159.5513")//NO I18N
                .attr("x2","-180.5832")  //NO I18N 
                .attr("y2","-134.1432") //NO I18N   
                .attr("gradientTransform","matrix(0.7071 0.7071 -0.7071 0.7071 43.6835 251.4735)");//NO I18N
        
            var stop = appendEle(linearGradient,"stop",[1],".","class","stop");//NO I18N
            
            stop
                    .attr({
                            "offset":0,//NO I18N
                    })
                    .style({
                            "stop-color" : "#FFFFFF",//NO I18N
                            "stop-opacity":0//NO I18N
                    });
                    
            var stop_1 = appendEle(linearGradient,"stop",[1],".","class","stop_1");//NO I18N
              
              stop_1
                    .attr({
                            "offset":1,//NO I18N
                    })
                    .style({
                            "stop-color" : "#000000",//NO I18N
                    })
        }
        
        chartObj.mapObj.map_util = map_util;
        map_renderer_util.unknowndata.flush();
        if(chartObj.chartTypes[0].value == geopie || chartObj.chartTypes[0].value == geobubblepie)
        {
            var pointDetails = seriesDetails = [];
            var subSeries = appendEle(g, "g",[1], "#", "id", "subseries_0");//NO I18N
            map_series_renderer.pie(subSeries,series,seriesColor,pointDetails,update);
        }
         else
         {      
            var seriesGroups = appendEle(g, "g", series, "#", "id", "series");//NO I18N
            seriesGroups.each(function(d, i) {
                var pointDetails = seriesDetails[i] = [];
                map_renderer_util.plotMapSeries(d3_select(this), d, i, seriesColor[i], pointDetails,update);
            });
         }
        
        if (!update) {
            hover.append('g').style('visibility', 'hidden');//NO I18N
        }
        
        chartObj.seriesDetails = seriesDetails;
        chartObj.map_util=map_util;
        map_util.setEvents();
        chartObj.mapObj.unknowndata = map_renderer_util.unknowndata;
        
};
    
map_renderer_util.removeSeriesGroups = function() 
{
        var svg = map_util.getSVG();
        svg.select('g.series-holder').remove();//NO I18N
        svg.select('g.highlight-group').remove();//NO I18N
};
    
map_renderer_util.plotMapSeries = function(parent, series, seriesIndx, color,pointDetails,update) 
{
        
        var type = $ZC.DataProcessor.helpers.getChartType(series.type, "numeric");//NO I18N
        if(type == geofilled)
        {
            map_series_renderer.filled(parent, series, seriesIndx, color,pointDetails);
        }
        else
        {
            if (series.disabled) {
                parent.selectAll('g').remove();//NO I18N
                return;
            }
            map_series_renderer.scatter(parent, series, seriesIndx, color,pointDetails,update);
        }
};
    
map_renderer_util.unknowndata = (function() 
{
        var _data = [];
        
        return {
            add: function(object) {
                if (object && _data.filter(function(data) {
                        return data === object;
                    }).length == 0) {
                    _data.push(object);
                }
            },
            
            remove: function(key) {
                var flag = false;
                _data = _data.filter(function(data) {
                    if (data != key) {
                        return true;
                    } else {
                        flag = data;
                        return false;
                    }
                });
                return flag;
            },
            
            flush: function() {
                _data = [];
            },
            
            toArray: function() {
                return _data.filter(function(element) {
                    return element != null;
                });
            }
        }
})();