//$Id$
map_util.setChartObj = function(chartObj) 
{
    this._chartObj = chartObj;
    this._chartObj.mapObj.plotted_data = {};
    this._chartObj.mapObj.plotted_layer = {};
};
    
map_util.getDataset = function()
{
    return this._chartObj ? this._chartObj.dataset : null;
};
    
map_util.getLeafletMap = function()
{
    return this._chartObj ? this._chartObj.mapObj.map : null;
};
    
map_util.getMarkerOptions = function(type)
{
    return this._chartObj ?
            this._chartObj.systemConf.chart.plot.plotoptions[type].marker : null;
};
    
map_util.getPlotOptions = function(type)
{
    return this._chartObj ?
            this._chartObj.systemConf.chart.plot.plotoptions[type] : null;
};
    
map_util.getHoverOptions = function(type) 
{
    return this._chartObj ? this._chartObj.systemConf.chart.plot.plotoptions[type].hoveroptions : null;
};
    
map_util.getSVG = function() 
{
    return this._chartObj ?
            d3_select(this._chartObj.mapObj.map.getContainer()).select("div.leaflet-overlay-pane").select("svg") : null;//NO I18N
};
    
map_util.getCanvas = function()
{
    return this._chartObj ?
            d3_select(this._chartObj.mapObj.map.getContainer()).select("div.leaflet-overlay-pane").select("canvas") : null;//NO I18N
};
    
map_util.getLatLngArray = function() 
{
    return this._chartObj && this._chartObj.dataObject.data.geo.latlngArray ?
//            this._chartObj.dataObject.data.geo.latlngArray.filter(function(d){return d!=null && !(d[0] instanceof Array)}) :
            Object.keys(this._chartObj.mapObj.plotted_data).map(function(key){
                return this._chartObj.mapObj.plotted_data[key].latLng;
            }, this) : null;
};
map_util.getLayerBounds = function() 
{
        return this._chartObj && this._chartObj.dataObject.data.geo.featureArray?
            Object.keys(this._chartObj.mapObj.plotted_layer).map(function(key){
                return this._chartObj.mapObj.plotted_layer[key].layer.getBounds();
            }, this) : null;
};
map_util.getMaxZoomLevel = function() 
{
        var georole = this._chartObj ? this._chartObj.dataObject.data.geo.geoRole : null;
        return georole ? GEOROLEBASED_MAXZOOMLEVELS.getMaxZoom(georole) : null;
};
    
map_util.getSeries = function() 
{
        return this._chartObj ?
            this._chartObj.seriesdata : null;
};
    
map_util.getMapDimension = function() 
{
        if (this._chartObj) {

            var bounds = this._chartObj.mapObj.map.getContainer().getBoundingClientRect();
            return {
                width: bounds.width,
                height: bounds.height
            };
        } else {
            return null;
        }};
    
map_util.getChartObject = function() 
{
        return this._chartObj ? this._chartObj : null;
};
    
map_util.setEvents = function() {
        eventsObject = $ZC.mapcharts.events(systemconf);
        eventsObject.initialize(this);};
    
map_util.addPlotPoint = function(point) {
        if (this._chartObj) {
            if (!this._chartObj.mapObj.plotted_data) {
                this._chartObj.mapObj.plotted_data = {};
            }
            if(this._chartObj.chartTypes[0].value == geofilled )
            {
               this._chartObj.mapObj.plotted_data[point.xVal] = {
                   "id":point.id, //NO I18N
                    "latLng":point.latLng,//NO I18N
                    "feature":point.feature,//NO I18N
                    "color":point.color//NO I18N
                };
            }
            else
             {
               this._chartObj.mapObj.plotted_data[point.xVal] = {
                   "latLng" : point.latLng,//NO I18N
                   "color" : point.color,//NO I18N
                   "size" : point.size  //NO I18N
               };
             }   
        }};
map_util.addPlotLayer = function(layer) 
{
    if (this._chartObj) 
    {
        if (!this._chartObj.mapObj.plotted_layer) {
             this._chartObj.mapObj.plotted_layer = {};
        }
        if(this._chartObj.chartTypes[0].value == geofilled)
        {
            this._chartObj.mapObj.plotted_layer[layer.seriesVal] = {
                "layer" : layer.seriesLayer,//NO I18N
                "color" : layer.seriesColor,//NO I18N
                "geoJson" : layer.seriesGeoJson//NO I18N
            };
        }
    }
};
    
map_util.getScale = function() 
{
    return this._chartObj ? this._chartObj.zscale : null;
};

map_util.getOpacityValue = function()
{
    return this._chartObj ? ( this._chartObj.userdata.geo.fillOpacity ? Number(this._chartObj.userdata.geo.fillOpacity.replace("%","")) / 100  : null) : null;
};

map_util.getMarkerType = function()
{
    return this._chartObj ? this._chartObj.chartTypes[0].value == geoscatter ? (this._chartObj.userdata.geo.markerType) : null : null;
};
map_util.processBubblePieData = function(baseChartType) {
        // baseChartType = bubblepie | geobubblepie | geopie
        baseChartType = baseChartType || $ZC.charttype.bubblepie;

            var chartObj = map_util.getChartObject();
            var seriesdata = chartObj.seriesdata;
            var dataset = map_util.getDataset();

        var pieData = [],
            dataindex = validateNullVal(chartObj.systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(baseChartType)].dataindex, 3),
            categories = chartObj.userdata.chart.axes.xaxis.categories;

        seriesdata.forEach(function(d, i) {
            var chartTypeNumeric = chartObj.chartTypes[i].value;
            var ishideable = d.disabled || (chartTypeNumeric !== baseChartType),
                currentseriesdata = d.data;
            currentseriesdata.forEach(function(d, subseries) {
                pieData[subseries] = pieData[subseries] || [];
                categories.forEach(function(cat, index) {
                    var filteredData = d.filter(function(d) {
                        return dataset.getX(d) ? (dataset.getX(d).toLocaleLowerCase() === cat && d[dataset.geocolumnidx] == index): null;
                    });
                    var dt = filteredData.length > 1 ? filteredData[1] : filteredData[0];
                    if (!dt) {
                        var v;
                        seriesdata.some(function(seires, si) {
                            var currentseriesdata = seires.data;
                            return currentseriesdata[subseries].some(function(d, i) {
                                var hasX = (dataset.getX(d) ? (dataset.getX(d).toLocaleLowerCase() === cat && d[dataset.geocolumnidx] == index): null);
                                if (hasX) {
                                    v = d.slice(0);
                                    v[dataindex] = null;
                                }
                                return hasX;
                            })
                        });
                        dt = v;
                    }
                    if (dt) { // if missing subseries available
                        dt.disabled = ishideable;
                        pieData[subseries][index] = pieData[subseries][index] || [];
                        pieData[subseries][index].push(dt);
                    }
                        
            });
        });
        });
        return pieData;
    };
