//$Id$
/**
 *
 * @returns {chart} pie renderer.
 */
svg_plot_renderer.pie = function() {
    var MAXWIDTH_DATALABELS = 0.3;
    var pie = d3_pie().sort(null),
        arc = d3_arc(),
        sliceOut = function(d) {
            return polarToXY(sliceOutHeight, (d.startAngle + d.endAngle) / 2);
        },
        isredraw = false,
        InsidelabelTextGroup,
        labelLinkGroup,
        labelTextGroup,
        innerBoundBoxGroup,
        boundBoxGroup,
        hasNegValue,
        hasPreviousNegValue,
        gElementsCollected,
        hasBoundBox,
        previousRadiusFactors,
        previousInnerRadius,
        previousOuterRadius,
        baseValue;
    var commonRendererProp, chartObj, outerRadius, innerRadius, totalEngagement, padding, color, container, piegroup, chartheight, chartwidth, pieArcs;
    var oldData, arcLabel, commonPlotOptions, systemconf, notesArray, isDial;
    var rad, OR, strokeWidth, strokeWid, noofNonZeroDatas, sliceOutHeight;
    var modelOptions, transX, transY, customPlotarea, plotarea, dataindex;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                notesArray = rp.notesArray,
                systemconf = chartObj.systemConf;
            var labelQueue = rp.labelQueue,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset,
                index = rp.datasetIndex || 0; //For pie,dial char, rp.datasetIndex is undefined
            
            var defsLocation = chartObj.defsLocation,
                serData = chartObj.seriesdata[index],
                currentRadiusFactors = commonPlotOptions.maxRadius + " _ " + commonPlotOptions.outerPadding + " _ " + commonPlotOptions.innerRadius;

            var chartName = chartObj.chartTypes[index].name;
            isDial = chartName === "dial";
            var isPie = chartName === "pie",
                isBubblePie = !isDial && !isPie;
            dataindex = isBubblePie ? validateNullVal(commonPlotOptions.dataindex, 3) : dataset.yidx(yaxiscolumnorder);
            
            plotarea = customPlotarea || (isDial ? chartObj.plotarea_approx : chartObj.plotarea);
            chartwidth = plotarea.width,
                chartheight = plotarea.height,
                outerRadius = validateNullVal(plotarea.radius, mathMin(chartwidth, chartheight) / 2);
            gElementsCollected = false;
            
            var plotoptions = serData.plotoptions,
                dataLabels = commonPlotOptions.datalabels,
                gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions);
            
            var maxRadius = validateNullVal(gvp("maxRadius"), 250),
                fillOpacity = gvp("fillOpacity"),
                levelMarkerConf = commonPlotOptions.levelMarker,
                padding = isPie ? +gvp("outerPadding") : 0,
                strokeWidth = gvp("strokeWidth"),
                visibility;
            baseValue = (commonPlotOptions.baseValue !== undefined) ? commonPlotOptions.baseValue : 0
            
            var showlabel = isDatalabelEnabled(dataLabels, chartObj),
                datalabelPadding = showlabel
                                ? (+(dataLabels.padding || 0) + (isBoundBoxEnabled(dataLabels, chartObj) ? ((getBoundBoxPadding(dataLabels, chartObj) + getBoundBoxStrokeWidth(dataLabels, chartObj)) * 2) : 0))
                                : 0,
                extraOptions = {},
                datalabelsWidth = 0;
            hasBoundBox = isBoundBoxEnabled(dataLabels, chartObj);
            
            padding += (isPie ? datalabelPadding : 0);
            rad = mathMin(maxRadius, (outerRadius - padding));
            if (isPie && showlabel) {
                /*
                 *If chart width is lesser than height, datalabels are hidden as default padding is 30 and there is no space to show datalabels.
                 * So 30% of the width is allocated for datalabels and the default padding will be changed to 2
                 */
                var minDatalabelsWidth = chartwidth * MAXWIDTH_DATALABELS,
                    availableDatalabelsWidth = chartwidth - (2 * rad);
                if (availableDatalabelsWidth < minDatalabelsWidth) {
                    datalabelPadding = extraOptions.padding = 5;
                    datalabelsWidth = mathMax((minDatalabelsWidth - availableDatalabelsWidth), 0)
                    rad -= datalabelsWidth / 2;
                }
            }
            innerRadius = getInnerRadius(commonPlotOptions, rad);
            strokeWidth = validateNullVal(strokeWidth, 1);
            
            if (isDial && levelMarkerConf.enabled) {
                var innerPadding,
                    outerPadding;

                if (defined(commonPlotOptions.bandWidth) || defined(commonPlotOptions.maxBandWidth)) {
                    var maxDialBandWidth = validateNullVal(commonPlotOptions.maxBandWidth, rad);
                    var dialBandWidth = mathMin(perToPx(commonPlotOptions.bandWidth, rad, (rad - innerRadius)), maxDialBandWidth);

                    innerPadding = -((rad -  innerRadius) - dialBandWidth) / 2,
                    outerPadding = -((rad -  innerRadius) - dialBandWidth) / 2;

                    visibility = (dialBandWidth === 0) ? "hidden" : null;
                } else {
                    innerPadding = mathMin(0, perToPx(levelMarkerConf.innerPadding, outerRadius, 0)),
                    outerPadding = mathMin(0, perToPx(levelMarkerConf.outerPadding, outerRadius, 0))
                }

                rad += outerPadding;
                innerRadius -= innerPadding;
            }

            rad -= 0.5 * strokeWidth;
            OR = mathMax(innerRadius, rad);
            modelOptions = ((plotoptions && plotoptions.models) ? mergeJSON(commonPlotOptions.models, plotoptions.models, true) : commonPlotOptions.models) || {};
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, chartName);
            var isAnimationEnable = animationOptions.enabled,
                transitionDuration = !isAnimationEnable ? 0 : (isredraw ? 200 : animationOptions.duration),
                easingType = animationOptions.easingType,
                animationType = animationOptions.type;
            
            var eventDisabled = (validateNullVal(getEventConf(plotoptions, commonPlotOptions, chartObj, "enabled"), true) == false);
            var cursor = (eventDisabled) ? null : getEventConf(plotoptions, commonPlotOptions, chartObj, "cursor") || "pointer";
            
            container = d3_select(this);
            piegroup = appendEle(container, "g", [data], ".", "class", "piegroup");
            piegroup.style({
                "stroke-width": strokeWidth,
                "fill-opacity": gvp("fillOpacity"),
                "stroke-opacity": commonPlotOptions.strokeOpacity,
                "cursor": cursor,
                "visibility": visibility
            });
            
            pie
                .startAngle(commonPlotOptions.startAngle)
                .endAngle(commonPlotOptions.endAngle)
                .value(function(d) {
                    return d.disabled ? 0 : mathAbs(d[dataindex] || 0);
                }); //d[dataindex] || 0 --> Why || 0 is, it may contain undefined Y value
            var pieData = pie(data = isBubblePie ? data : serData.data[0]);
            chart.data = pieData;
            
            noofNonZeroDatas = pieData.reduce(function(prev, cur, i) {
                return prev + (cur.value ? 1 : 0)
            }, 0);
            chart.total = totalEngagement = pieData.reduce(function(prev, cur, i) {
                return prev + cur.value
            }, 0);
            chart.arc = arc;
            
            var stacked = true;
            if (stacked) {
                arc
                    .outerRadius(OR)
                    .innerRadius(innerRadius);
            } else {
                var interPadding = perToPx(levelMarkerConf.interPadding, OR, 10),
                    len = data.length;
                var band = ((OR - innerRadius) - ((len - 1) * interPadding)) / len;
                arc
                    .innerRadius(function(d, i) {
                        return (i * (band + interPadding)) + innerRadius;
                    })
                    .outerRadius(function(d, i) {
                        return ((i + 1) * band) + (i * interPadding) + innerRadius;
                    })
                    .startAngle(commonPlotOptions.startAngle)
                    .endAngle(function(d) {
                        return d.endAngle;
                    });
            }
            arcLabel = d3_arc().innerRadius(OR).outerRadius(OR + datalabelPadding);
            var arcLabel1 = d3_arc().innerRadius(OR).outerRadius(OR);
            
            // translating the piegroup to center
            strokeWid = strokeWidth;
            var bb = translateWrap(piegroup);
            //calculating new radius
            var heightPercent = ((bb.height + strokeWidth) / rad),
                widthPercent = ((bb.width + strokeWidth) / rad);
            var newrad = rad + mathMin(((chartwidth - (2 * padding) - datalabelsWidth - (bb.width + strokeWidth)) / widthPercent), ((chartheight - (2 * padding) - datalabelsWidth - (bb.height + strokeWidth)) / heightPercent));
            newrad = mathMin(maxRadius, mathMax(rad, newrad));
            if (isDial) {
                currentRadiusFactors += " _ " + commonPlotOptions.bandWidth + " _ " + levelMarkerConf.bandWidth + " _ " + levelMarkerConf.innerPadding + " _ " + levelMarkerConf.outerPadding;

                var yscale = chartObj.axes.y.groups[0].scale;
                var minMax = yscale.domain();
                // var prev = yscale.domain()[0];
                pieData.forEach(function(d) {
                    // d.startAngle = yscale(prev);
                    // d.endAngle = yscale(prev + d.value);
                    // prev += d.value;
                    var val = d.data[dataindex];
                    hasPreviousNegValue = hasNegValue
                    if (hasNegValue = (val < 0)) { // Test_529.json
                        d.startAngle = yscale((baseValue != null) ? Math.min(baseValue, minMax[1]) : minMax[1]);
                        d.endAngle = yscale(Math.max(val, minMax[0]));
                    } else {
                        d.startAngle = yscale( (baseValue != null) ? Math.max(baseValue, minMax[0]) : minMax[0] );
                        d.endAngle = yscale( Math.min(d.value, minMax[1])) ;
                    }
                });
            } else if (newrad != rad) { // updating values based on new radius
                rad = newrad;
                innerRadius = getInnerRadius(commonPlotOptions, rad);
                OR = mathMax(innerRadius, rad);
                arc.outerRadius(OR).innerRadius(innerRadius);
                arcLabel = d3_arc().innerRadius(OR).outerRadius(OR + datalabelPadding);
                arcLabel1 = d3_arc().innerRadius(OR).outerRadius(OR);
                translateWrap(piegroup);
            }
            
            var modelID = (!isDial && modelOptions.type) ? "url(" + defsLocation + "#" + createModelClippath(getModelPath()) + ")" : null;
            var gradientDim = [OR, OR];
            var fillColor = chart.fillColorFunc = getFillColor(chartObj, index, gradientDim),
                strokeColor = getStrokeColor(chartObj, 0);

            sliceOutHeight = perToPx(gvp("sliceOutHeight"), rad, 0) * 2;
            
            oldData = piegroup.selectAll("path").data();
            
            pieArcs = appendEle(piegroup, "path", pieData);
            pieArcs
                .attr({
                    "clip-path": modelID,
                    "id": function(d, i) {
                        return "arc_" + i;
                    }
                })
                .style({
                    "display": "block",
                    "fill": function(d, i) {
                        return fillColor(i, d.data);
                    },
                    "stroke": function(d, i) {
                        return strokeColor(i, d.data, commonPlotOptions.strokeColor);
                    }
                });
            
            if (!eventDisabled) {
                var mousemove = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.mouseMove(args);
                    },
                    mouseout = function(d, i) {
                        chartObj.eventHandler.mouseOut(chart, d, i);
                    },
                    click = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.click(chart, d, 0, i, args);
                    },
                    dblclick = function(d, i) {
                        var data = $ZC.annotation ? generateDataForAnnotation(d.data, null) : d.data;
                        var coordinates = arcLabel.centroid(d);
                        coordinates = [(coordinates[0] + transX), (coordinates[1] + transY)];
                        var args = {
                            "coordinate": coordinates,
                            "data": data,
                            "basedOn": "plot"
                        };
                        chartObj.eventHandler.doubleclick(d, i, args);
                    },
                    eventAttacherOptions = {
                        target: "plot",
                        touchleave: true,
                        chartObj: chartObj
                    };
                var mouseHandlers = {
                    "mousemove": mousemove,
                    "mouseout": mouseout,
                    "click": click,
                    "dblclick": dblclick
                },
                touchHandlers = {
                    "singletouchmove": mousemove,
                    "touchend": mouseout,
                    "tap": click,
                    "dbltap": dblclick
                };
                attachevents(pieArcs, mouseHandlers, touchHandlers, eventAttacherOptions);
            }
            
            if (/(\D)+onebyone/.test(animationType) && !isredraw) {
                var isFan = (animationType == "fanonebyone");
                var duration = isFan ? transitionDuration : (transitionDuration / noofNonZeroDatas)
                var prev = 0;
                pieArcs
                    .transition()
                    .ease(easingType)
                    .duration(function(d) {
                        return isFan ? (duration * (d.value / totalEngagement)) : duration;
                    })
                    .delay(function(d) {
                        var dur = duration * prev;
                        prev += isFan ? (d.value / totalEngagement) : 1;
                        return dur;
                    })
                    .call(isFan ? arcTween : innerTween);
            } else {
                var tweenType;
                if (isredraw) {
                    tweenType = (currentRadiusFactors != previousRadiusFactors) ? innerTween : fanAllTween
                } else {
                    tweenType = (animationType == "fanAll") ? fanAllTween : (animationType == "inner" ? innerTween : arcTween)
                }

                pieArcs
                    .transition()
                    .duration(transitionDuration)
                    .ease(easingType)
                    .call(tweenType)
                    .each("end", function(d) {
                        var disabled = d.data.disabled || (d.startAngle === d.endAngle);// if disabled or value = 0 | null
                        d3_select(this).style("display", (disabled ? "none" : "block"));
                    });
            }
            chart.renderedTimer = setTimeout(function() {
                previousRadiusFactors = currentRadiusFactors;
                previousInnerRadius = innerRadius;
                previousOuterRadius = OR;
                if (isDial) {
                    chartObj.renderer[0].endFunctions();
                } else {
                    pieArcs.style("display", function(d) {
                        return (d.data.disabled || !d.value) ? "none" : null
                    });
                    if ($ZC.labelRenderer && !isBubblePie) {
                        var translation = [transX, transY];
                        var args = [piegroup.datum(), 0, pieData, OR, totalEngagement, arcLabel, arcLabel1, arc, translation, extraOptions];
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "pie",
                            "chartObj": chartObj,
                            "args": args
                        });
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "pieInnerLabels",
                            "chartObj": chartObj,
                            "args": args
                        });
                    }
                }
                
                //Annotation preprocessing
                if ($ZC.annotation && !isBubblePie) {
                    notesArray = $ZC.annotation.preprocessAnnotations(chartObj.seriesdata, 0, function(dt, k, j) {
                        var c = arcLabel.centroid(pieData[j]);
                        return [(c[0] + transX), (c[1] + transY)];
                    }, notesArray, chartObj, rp);
                }
                chart.chartRendered = true;
                isredraw = true;
            }, transitionDuration + (1000 / 60));

            function getEventArgs(d, i) {
                var ev = getEventObject(d3.event);
                return {
                    "renderer": chart,
                    "seriesPos": 0,
                    "subseriesPos": 0,
                    "itemPos": i,
                    "color": color[i % color.length],
                    "coordinates": [ev.pageX, ev.pageY],
                    "element": this,
                    "data": d
                };
            }
        });
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.plotarea = function(_) { //Bubble Pie chart will give you the plotarea
        if (!arguments.length) {
            return customPlotarea || plotarea;
        }
        customPlotarea = _;
        return chart;
    };
    
    chart.innerRadius = function(_) {
        if (!arguments.length) {
            return innerRadius;
        }
        innerRadius = _;
        return chart;
    };
    
    chart.defaultMouseOverFunc = function(d, seriesPos, itemPos) {
        if (noofNonZeroDatas == 1) {
            return;
        }
        
        if (!gElementsCollected) {
            collectGroups();
        }

        var pt = sliceOut(d);
        var slicedPosition = {
                "transform":  "translate(" + pt[0] + "," + pt[1] + ")"
            };
        
        pieArcs
            .transition()
            .ease("linear")
            .attr("transform", "translate(0,0)");

        piegroup.selectAll("#arc_" + itemPos)
            .transition()
            .ease("linear")
            .attr(slicedPosition);
        
        InsidelabelTextGroup.selectAll("#innerlbl0_0_" + itemPos)
            .transition()
            .ease("linear")
            .attr(slicedPosition);
        
        if (!hasBoundBox) {
            labelLinkGroup.selectAll("#link0_0_" + itemPos)
                .style("stroke-width", (3 * chart.lineStrokeWidth));
        }
        
        if (chart.showlabel == "circular") {
            labelTextGroup.selectAll("#lbl0_0_" + itemPos)
                .transition()
                .ease("linear")
                .attr(slicedPosition);
            
            boundBoxGroup.selectAll("#boundboxlbl0_0_" + itemPos)
                .transition()
                .ease("linear")
                .attr(slicedPosition);
        }
        labelTextGroup.selectAll("#lbl0_0_" + itemPos)
            .style("text-shadow", "0 0 0 rgba(0,0,0,1)");
        
        innerBoundBoxGroup.selectAll("#boundboxinnerlbl0_0_" + itemPos)
            .transition()
            .ease("linear")
            .attr(slicedPosition);
    };
    
    chart.defaultMouseOutFunc = function(d, i, forceMouseOut) {
        if (!gElementsCollected) {
            collectGroups();
        }

        var actualPosition = {
                "transform": "translate(0,0)"
            };

        labelTextGroup.selectAll("text")
            .style("text-shadow", null);
        if (!hasBoundBox) {
            labelLinkGroup.selectAll("path")
                .style("stroke-width", chart.lineStrokeWidth);
        }

        if (!clickedTime && forceMouseOut) {
            pieArcs
                .attr(actualPosition);

            InsidelabelTextGroup.selectAll("text")
                .attr(actualPosition);

            innerBoundBoxGroup.selectAll("path")
                .attr(actualPosition);

            if (chart.showlabel == "circular") {
                labelTextGroup.selectAll("text")
                    .attr(actualPosition);
                
                boundBoxGroup.selectAll("path")
                    .attr(actualPosition);
            }
            return;
        }
        pieArcs
            .transition()
            .ease("linear")
            .attr(actualPosition);
        
        InsidelabelTextGroup.selectAll("text")
            .transition()
            .ease("linear")
            .attr(actualPosition);
        
        
        if (chart.showlabel == "circular") {
            labelTextGroup.selectAll("text")
                .transition()
                .ease("linear")
                .attr(actualPosition);
            
            boundBoxGroup.selectAll("path")
                .transition()
                .ease("linear")
                .attr(actualPosition);
        }
        
        innerBoundBoxGroup.selectAll("path")
            .transition()
            .ease("linear")
            .attr(actualPosition);
    };
    
    function getGearData(count) {
        var array = [],
            data = [],
            x = 0;
        for (var i = 0; i < count; i++) {
            (modelOptions.type == "gear1") ? data.push([x++, 0], [x++, 1], [x++, 1]) : data.push([x, 0], [x++, 1], [x, 1], [x++, 0]);
        }
        array.push(data);
        return array;
    }
    
    function getModelPath() {
        var index = -1,
            count = modelOptions.count,
            min = (modelOptions.type == "zigzag") ? (-50 + innerRadius / 5) : ((modelOptions.type == "sun") ? -1 : -10);
        var gearData = getGearData(count);
        var angleScale = d3_scaleLinear().range([0, 2 * mathPI]).domain([0, ((modelOptions.type == "gear1") ? (3 * count) : (2 * count))]);
        var radiusScale = d3_scaleLinear().range([innerRadius, OR]).domain([min, 1]);
        var radialLine = d3_lineRadial().interpolate("linear-closed").radius(function(d) {
                return radiusScale(d[1]);
            })
            .angle(function(d, i) {
                index = (modelOptions.type == "gear") ? ((i % 2 == 0) ? (index + 1) : index) : ((modelOptions.type != "gear1") ? ((i % 2 != 0) ? (index + 1) : index) : index);
                return angleScale((modelOptions.type == "gear1") ? index++ : index);
            });
        return radialLine(gearData[0]);
    }
    
    function createModelClippath(gearPath) {
        var properties = {
            name: "pieModels",
            id: chartObj.id,
            d: gearPath
        },
        args = {
            chartObj: chartObj
        };
        var clipID = effects.get(svg_clips, "polygon", properties, args);
        return clipID;
    }
    
    function innerTween(element) {
        arcInnerTween(element, arc, [(isredraw ? previousInnerRadius : innerRadius), innerRadius], [(isredraw ? previousOuterRadius : innerRadius), OR]);
    }
    
    function arcTween(transition) {
        transition.attrTween("d", function(d, i) {
            var interpolate = d3_interpolate(d.startAngle, d.endAngle);
            return function(t) {
                d.endAngle = interpolate(t);
                return arc(d);
            };
        });
    }
    
    function fanAllTween(transition) {
        transition.attrTween("d", function(d, i) {
            var od = oldData[i] || oldData[oldData.length - 1],
                prevEA,
                prevSA;
            
            if (hasNegValue) {
                prevEA = (isredraw && od && hasPreviousNegValue) ? od.endAngle : d.startAngle,
                    prevSA = (isredraw && od && hasPreviousNegValue) ? od.startAngle : d.startAngle;
            } else {
                prevEA = (isredraw && od && !hasPreviousNegValue) ? od.endAngle : (isDial ? d.startAngle : commonPlotOptions.startAngle),
                prevSA = (isredraw && od && !hasPreviousNegValue) ? (oldData[i] ? od.startAngle : od.endAngle) : (isDial ? d.startAngle : commonPlotOptions.startAngle);
            }
            
            var interpolate = d3_interpolate(prevEA, d.endAngle);
            var interpolate1 = d3_interpolate(prevSA, d.startAngle);
            
            return function(t) {
                d.endAngle = interpolate(t) || 0;
                d.startAngle = interpolate1(t) || 0;
                return arc(d, i);
            };
        });
    }
    
    function translateWrap(wrap) {
        //dummy data
        var dummyData = [];
        dummyData[dataindex] = 1;
        
        //dummy pie for getting the bound
        var dummy = container.append("path")
            .attr("d", arc(pie([dummyData])[0], chart.data.length - 1))
            .style({
                "fill": "none",
                "stroke": "none"
            });
        var bb = bbox(dummy.node());
        dummy.remove();
        
        //Reference point calculation for pie layout
        var pt = polarRefPoint(bb, chartwidth, chartheight, rad, strokeWid);
        transX = isDial ? plotarea.x : pt[0],
            transY = isDial ? plotarea.y : pt[1];
        wrap.attr("transform", function(d, i) {
            return "translate(" + transX + "," + transY + ")"
        });
        return bb;
    }
    
    function collectGroups() {
        InsidelabelTextGroup = InsidelabelTextGroup || chartObj.staticPaneSVG.selectAll("g.innerlabel_0");
        labelLinkGroup = labelLinkGroup || chartObj.staticPaneSVG.selectAll("g.link_0");
        labelTextGroup = labelTextGroup || chartObj.staticPaneSVG.selectAll("g.label_0");
        boundBoxGroup = boundBoxGroup || chartObj.staticPaneSVG.selectAll("g.boundboxseries_0");
        innerBoundBoxGroup = innerBoundBoxGroup || chartObj.staticPaneSVG.selectAll("g.innerboundboxseries_0");
        gElementsCollected = true;
    }
    
    return chart;
};