//$Id$
$ZC.axis.polar.render = function(chartObj, type) {
    var type = type || "y",
        index = 0;
    var systemconf = chartObj.systemConf,
        renderer = chartObj.renderer[0],
        dataObj = chartObj.dataObject,
        plotarea = chartObj.plotarea,
        canvasarea = chartObj.canvasarea,
        columns = chartObj.systemConf.metadata.columns,
        chart = chartObj.chartTypes[0],
        chartType = chart.value,
        chartName = chart.name;

    var commonPlotOptions = systemconf.chart.plot.plotoptions[chartName];
    var axis_data = (type == "x") ? systemconf.chart.axes.xaxis : systemconf.chart.axes.yaxis[index],
        outerPadding = (+commonPlotOptions.outerPadding || 0),
        maxRadius = (+commonPlotOptions.maxRadius || 0);
    var isDial = (chartType === $ZC.charttype.dial);
    
    
    var show = axis_data.show && dimension_based_intelligence(chartObj, (type + "axis"), mathMin(canvasarea.width, canvasarea.height));
    var axislineSize = (show && axis_data.axisline.show) ? validateNullVal(axis_data.axisline.strokeWidth, 1) : 0,
        ticklabelPad = validateNullVal(axis_data.ticklabel.marginLeft, 5),
        tickmarkSize = validateNullVal(axis_data.tickmark.size, 3),
        subtickmarkSize = (axis_data.subtickmark) ? validateNullVal(axis_data.subtickmark.size, 2) : 0,
        ticklabelFontsize = $ZC.utils.getVal(axis_data.ticklabel.fontSize || systemconf.chart.fontSize || systemconf.canvas.fontSize || $ZCG.fontSize),
        orient = axis_data.orient || "outer",
        tickOrient = axis_data.tickOrient;
    
    var w = plotarea.width - (2 * outerPadding),
        h = plotarea.height - (2 * outerPadding);
    var radius = mathMin(w, h) / 2;
    var innerRadius = getInnerRadius(commonPlotOptions, radius),
        padding = show ? (+commonPlotOptions.padding || 0) : 0;
    chartObj.plotarea_approx = {
        x: 0,
        y: 0,
        innerRadius: innerRadius
    };
    
    var sc = $ZC.scale.constructor(chartObj, ((type == "x") ? "bottom" : "left"));
    var scale = (type == "x") ? sc[0].scale : sc[index].scale;
    var range = scale.rangeExtent ? scale.rangeExtent() : scale.range();
    
    var columnidx = chartObj.dataset.getColumnIdx(type, index);
    var colInfo = columns[columnidx];
    var datatype = colInfo.datatype;
    var formatConf = colInfo[datatype];
    // var ticksObj = $ZC.axis.ticks(chartObj, axis_data, type, index, "left", plotarea);
    // var tickVal = ticksObj.getTickValues(2*radius, 2*radius,null,null,radius/10);
    
    var axisRadius = (orient == "inner") ?
        ((tickOrient === "outer") ?
            (innerRadius - padding - axislineSize / 2 - mathMax(subtickmarkSize, (tickmarkSize + ticklabelPad + ticklabelFontsize))) :
            innerRadius) :
        radius;
    var axisComponent = $ZC.axis.polar()
        .scale(scale)
        .chartObj(chartObj)
        .radius(axisRadius)
        .columnIndices([columnidx])
        .tickFormat(function(d) {
            return getFormattedValue(formatConf, d, datatype, chartObj, "axis");
        })
        .tickValues(null); //.tickValues(tickVal.ticks);
    
    var container = appendEle(chartObj.svg.selectAll("g.chartgroup"), "g", [1], ".", "class", (type + "-axis"));
    var wrap = appendEle(container, "g", (show ? [axis_data] : []), ".", "class", "axisgroup");
    wrap.call(axisComponent);
    container.style("visibility", "hidden");
    
    //dummy arc
    var arc = d3_arc()
        .innerRadius((!isDial || commonPlotOptions.needle.show || isDatalabelEnabled(commonPlotOptions.datalabels, chartObj)) ? 0 : innerRadius)
        .outerRadius(radius)
        .startAngle(range[0])
        .endAngle(range[1]);
    var dummyArc = container.append("path")
        .attr("d", arc(1));
    
    //Minmax label and datalabel - dial chart
    var datalabel = container.append("g").attr("class", "datalabel");
    var targetMarkerSeries = container.append("g").attr("class", "targetSeries");
    if (isDial) {
        if (!renderer) {
            var curSeriesidx = 0;
            renderer = chartObj.renderer[curSeriesidx] = createSVGRenderer(chartName);
            chartObj.rendererConf = [];
            chartObj.rendererConf[curSeriesidx] = new $ZC.plot.rendererConf();
            renderer_helpers.setRendererProp(chartObj, renderer, chartObj.seriesdata[curSeriesidx], curSeriesidx, []);
        }
        datalabel
            .call($ZC.labelRenderer.dial()
                .renderer(renderer)
                .args([chartObj.seriesdata, 0]), chartObj.labelHandler, datalabel
            );
        
        drawMinMaxLabel(container, scale, radius, innerRadius);
        svg_plot_renderer.dial.targetMarker(targetMarkerSeries, radius, innerRadius, chartObj);
        
        //needle calculation
        var needleWidth = (+commonPlotOptions.needle.width) / 2 || 7
        var cir = appendEle(datalabel, "circle", (commonPlotOptions.needle.show ? [1] : []));
        cir
            .attr({
                "r": needleWidth,
                "transform": "translate(" + needleWidth + "," + needleWidth + ")"
            });
    }
    
    //calculating new radius
    var arcBound = bbox(dummyArc.node());
    var bb = bbox(container.node());
    var heightPercent = ((arcBound.height) / radius),
        widthPercent = ((arcBound.width) / radius);
    var newradius = radius + mathMin(((w - bb.width) / widthPercent), ((h - bb.height) / heightPercent));
    newradius = isDial ?
        ((newradius > maxRadius) ? maxRadius : newradius) // Setting maximum to the radius
        :
        newradius;
    innerRadius = getInnerRadius(commonPlotOptions, newradius) - ((orient == "inner") ? (+commonPlotOptions.strokeWidth || 0) / 2 : 0);
    axisRadius = ((orient == "inner") ?
            ((tickOrient == "inner") ? innerRadius : (innerRadius - (getMinRadius(radius) - radius))) :
            newradius) -
        ((tickOrient == "inner") ? (axislineSize / 2) : 0) -
        ((orient == "inner") ? padding : 0);
    axisComponent.radius(axisRadius);
    wrap.call(axisComponent);
    arc
        .outerRadius(newradius)
        .innerRadius((!isDial || commonPlotOptions.needle.show || isDatalabelEnabled(commonPlotOptions.datalabels, chartObj)) ? 0 : innerRadius);
    dummyArc.attr("d", arc(1));
    if (isDial) {
        drawMinMaxLabel(container, scale, newradius, innerRadius);
        svg_plot_renderer.dial.targetMarker(targetMarkerSeries, newradius, innerRadius, chartObj);
    }
    
    //Reference point calculation
    var arcBound = bbox(dummyArc.node());
    var bb = bbox(container.node());
    var pt = polarRefPoint(bb, plotarea.width, plotarea.height, newradius, 0);
    
    container
        .attr("transform", "translate(" + (plotarea.left + pt[0]) + "," + (plotarea.top + pt[1]) + ")");
    container.style("visibility", null);
    
    var arcRad = ((tickOrient == "inner" && orient == "outer") ?
            getMinRadius(newradius) :
            newradius - ((orient == "inner") ? 0 : (axislineSize / 2))) -
        ((orient == "inner") ? 0 : padding);
    var dwidth = (tickOrient == "inner") ? (newradius - arcRad) * widthPercent : 0,
        dheight = (tickOrient == "inner") ? (newradius - arcRad) * heightPercent : 0;
    
    chartObj.plotarea_approx = {
        x: pt[0],
        y: pt[1],
        width: arcBound.width - axislineSize - dwidth,
        height: arcBound.height - axislineSize - dheight,
        radius: arcRad,
        actualRadius: newradius,
        innerRadius: innerRadius
    };
    
    dummyArc.remove();
    datalabel.remove();
    targetMarkerSeries.remove();
    
    if (dataObj.isPolarAxisCategory) {
        var type = "y",
            yindex = 0;
        var yaxis_data = systemconf.chart.axes.yaxis[yindex],
            radius = chartObj.plotarea_approx.radius,
            x = chartObj.plotarea_approx.x,
            y = chartObj.plotarea_approx.y;
        
        var orient = yaxis_data.orient || "right",
            tickSize = validateNullVal(yaxis_data.tickmark.size, 6),
            tickPadding = validateNullVal(yaxis_data.ticklabel[(orient == "left") ? "marginRight" : "marginLeft"], 3),
            isArcGrid = (yaxis_data.grid.type === "arc");
        
        var sc = $ZC.scale.constructor(chartObj, "left");
        var yscale = sc[yindex].scale;
        var yRange = (yaxis_data.reversed && !dataObj.isstacked()) ? [0, radius] : [radius, 0];
        yscale.range(yRange)
        
        var plotarea_approx = {
            "left": chartObj.plotarea.left,
            "top": chartObj.plotarea.top,
            "width": radius,
            "height": radius
        };
        var axes = getAxisObject(chartObj, type, 0);
        var ticksObj = $ZC.axis.ticks(chartObj, yaxis_data, "y", 0, orient, plotarea_approx);
        axes.ticks = ticksObj;
        ticksObj.preCalcApproxAxisLength(plotarea_approx);

        // test
        var tickVal = ticksObj.getTickValues(radius, radius, null, null, (radius / 20), axes.Ticks);
        
        var metaData = chartObj.userdata.metadata;
        var isMergedAxis = (metaData.axes.y[yindex].length > 1); //For merged axis, need not to apply formatting
        var columnidx = chartObj.dataset.getColumnIdx(type, yindex);
        var datatype = metaData.columns[columnidx].datatype;
        var formatConf = (isMergedAxis && type == "y") ? merged_axis_column_intersect(yindex, chartObj) : metaData.columns[columnidx][datatype];
        var formattingFunction = (dataObj.isStackedPercentChart && type == "y") ? getFormattedValueByPercent : getFormattedValue;
        
        var axis = $ZC.axis.get()
            .scale(yscale)
            .tickPadding(tickPadding)
            .tickSize(tickSize, 0)
            .orient((orient))
            .plotarea({
                width: radius,
                height: radius
            })
            .systemconf(chartObj.systemConf)
            .chartObj(chartObj)
            .tickRotation(tickVal.rotation)
            .preCalcTickLen(ticksObj.preCalcTickLen)
            .tickValues(tickVal.ticks)
            .tickFormat(function(d) {
                return formattingFunction(formatConf, d, datatype, chartObj, "axis");
            })
            .columnIndices((isMergedAxis && type == "y") ? metaData.axes.y[index] : [columnidx]);
        var yWrap = chartObj.svg.selectAll("g.y-axis").data(yaxis_data.show ? [yaxis_data] : []);
        yWrap
            .call(axis, type, yindex)
            .attr("transform", "translate(" + (x + chartObj.plotarea.left) + "," + (y + chartObj.plotarea.top - radius) + ")");
        yWrap.exit().remove();
        
        var ticks = yWrap.selectAll('.tick');
        ticks.append("path");
        var gridLine = ticks.select("path");
        
        gridLine
            .attr("transform", function(d) {
                return "translate(0" + "," + (radius - yscale(d)) + ")";
            })
            .attr("d", function(d) {
                return grid((radius - yscale(d)), scale);
            })
            .style({
                "fill": "none",
                "stroke": yaxis_data.grid.color,
                "stroke-width": yaxis_data.grid.strokeWidth
            });
        
        wrap.selectAll("path.domain")
            .attr("d", function() {
                return grid(radius, scale);
            });
        
        yscale.range(yRange.reverse());
    }
    
    
    function getMinRadius(rad) {
        var a = [],
            subtickRad = rad + (((orient == "outer") ? axislineSize : axislineSize / 2) + subtickmarkSize * ((tickOrient == "inner") ? -1 : 1)),
            func = (tickOrient == "inner") ? d3_min : d3_max;
        wrap.selectAll("text")
            .each(function(d) {
                var bb = bbox(this),
                    textRad = rad + (((orient == "outer") ? axislineSize : axislineSize / 2) + tickmarkSize + ticklabelPad) * ((tickOrient == "inner") ? -1 : 1);
                var xy = polarToXY(textRad, scale(d));
                var arr = [getRad((xy[0] + bb.x), (xy[1] + bb.y)), getRad((xy[0] + bb.x), (xy[1] + bb.y + bb.height)), getRad((xy[0] + bb.x + bb.width), (xy[1] + bb.y)), getRad((xy[0] + bb.x + bb.width), (xy[1] + bb.y + bb.height)), subtickRad]
                a.push(func(arr));
            });
        return func(a);
    }
    
    function getRad(x, y) {
        return mathSQRT(mathPow(x, 2) + mathPow(y, 2));
    }
    
    function grid(r, scale) {
        if (isArcGrid) {
            var path = d3_arc()
                .innerRadius(r - 1)
                .outerRadius(r)
                .startAngle(range[0])
                .endAngle(range[1])(1);
            return "M" + path.split(/L|M/gi)[1];
        }
        var tickValues = scale.ticks ? scale.ticks() : scale.domain();
        var path = tickValues.reduce(function(prev, cur, i) {
            var a = scale(cur);
            var xy = polarToXY(r, a);
            return prev + "L" + xy[0] + " " + xy[1] + " ";
        }, "");
        return "M" + path.substring(1) + "Z";
    }
    
    function drawMinMaxLabel(container, scale, radius, innerRadius) {
        var mmConf = commonPlotOptions.minmaxlabels;
        var align = mmConf.align, //inner,outer options are available; enable for center
            padding = validateNullVal(mmConf.padding, 5),
            text = mmConf.text;
        var domain = scale.domain(),
            showAs = mmConf.showAs,
            r = (align == "inner") ? (innerRadius - padding) : (align == "center") ? (radius + innerRadius) / 2 : (radius + padding);
        var minmaxLabelData = mmConf.show ?
            ((showAs == "min") ?
                [domain[0]] :
                (showAs == "max") ?
                    [domain[1]] :
                    domain) :
            [];
        
        var minmaxLabel = appendEle(container, "text", minmaxLabelData, ".", "class", "mlabel");
        applyFont(minmaxLabel, [mmConf, systemconf.chart, systemconf.canvas, $ZCG]);
        minmaxLabel
            .attr({
                "text-anchor": function(d) {
                    if (align == "center") {
                        return "middle";
                    }
                    var a = d0_360(scale(d));
                    return (a % mathPI == 0) ?
                        "middle" :
                        (((align == "inner" && a < mathPI) || (align != "inner" && a > mathPI)) ? "end" : null);
                },
                "dy": function(d) {
                    if (align == "center") {
                        return "1em";
                    }
                    var a = d0_360(scale(d));
                    return (align == "inner") ?
                        ((!((a > mathPI / 2) && (a < 3 * mathPI / 2))) ? -getDY(a) + "em" : null) :
                        (((a > mathPI / 2) && (a < 3 * mathPI / 2)) ? getDY(a) + "em" : null);
                },
                "transform": function(d) {
                    var xy = polarToXY(r, scale(d)),
                        pad = (align == "center") ? padding : 0;
                    return "translate(" + xy[0] + "," + (xy[1] + pad) + ")";
                }
            })
            .text(function(d, i) {
                return (text && defined(text[i])) ?
                    getCustomThresholdText((text[i] + ""), minmaxLabelData, colInfo, chartObj) :
                    getFormattedValue(formatConf, d, datatype, chartObj, "minmaxlabels");
            });
        
        // var edge = {
        // 	"left" : -w / 2,
        // 	"top" : -h / 2,
        // 	"right" : w / 2,
        // 	"bottom" : h / 2
        // }
        // callTrimText(minmaxLabel, chartObj, [0,0], 0, edge);
    }
};