//$Id$
canvas_plot_renderer.scatter = function() {
    var shiftInfo, commonRendererProp, yrangePos,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;

    function chart(context, seriesData, pattern, filterIndex) {
        
        var rp = commonRendererProp.params,
            chartObj = rp.chartObj,
            xscale = rp.xscale,
            yscale = rp.yscale,
            stacked = rp.stacked,
            index = rp.datasetIndex,
            axisrotated = rp.axisrotated,
            commonPlotOptions = rp.commonPlotOptions,
            color = rp.color,
            labelQueue = rp.labelQueue,
            yaxiscolumnorder = rp.yaxiscolumnorder,
            dataset = rp.dataset,
            threshold = rp.threshold;

        var plotoptions = seriesData.plotoptions || {},
            cpOptions = plotoptions ? mergeJSON(commonPlotOptions, plotoptions, true) : commonPlotOptions,
            currentseriesdata = seriesData.data,
            temp = chartObj.chartTypes[index],
            chartType = temp.value,
            chartName = temp.name,
            scatterOrBubble = (chartType == 12 || chartType == 20),
            isBubbleChart = (chartType == 20),
            seriesColors = chartObj.seriesColor,
            legend_data = chartObj.systemConf.legend;

        var markerOptions = cpOptions.marker,
            symboltype = markerOptions.symbol || "circle",
            symbolsize = markerOptions.size,
            multiColoring = scatterOrBubble && chartObj.legendarea.show === false && cpOptions.multiColoring === true,
            patternPallete = legend_data.patternPallete,
            patternPallete = legend_data.patternPallete,
            hasColorScale = colorscale_helpers.isQuantileColorScale(chartObj);

        if (!scatterOrBubble) {
            if(!defined(symbolsize)) {
                symbolsize = pick(cpOptions.strokeWidth, 2);
            }
            symbolsize *= 0.8;
            color = pick(seriesData.color, chartObj.seriesColor[index % chartObj.seriesColor.length]);
            
        } else {
            symbolsize = pick(symbolsize, 1);
        }
        
        var outerSize = symbolsize * 5,
            outerFillOpacity = markerOptions.outerFillOpacity,
            outerStrokeOpacity = markerOptions.outerStrokeOpacity,
            innerFillOpacity = markerOptions.innerFillOpacity,
            innerStrokeOpacity = markerOptions.innerStrokeOpacity,
            outerStrokeWidth = pick(markerOptions.outerStrokeWidth, 1),
            innerStrokeWidth = pick(markerOptions.innerStrokeWidth, 1),
            outerStrokeColor = pick(markerOptions.outerStrokeColor, color),
            innerStrokeColor = pick(markerOptions.innerStrokeColor, color),
            outerFillColor = pick(markerOptions.outerFillColor, color),
            innerFillColor = pick(markerOptions.innerFillColor, color),
            outerDashArray = getDashArray(markerOptions.outerDashStyle, outerStrokeWidth),
            innerDashArray = getDashArray(markerOptions.innerDashStyle, innerStrokeWidth),
            outerStrokeLineCap = getLineCap(markerOptions.outerLineCap, markerOptions.outerDashStyle),
            innerStrokeLineCap = getLineCap(markerOptions.innerLineCap, markerOptions.innerDashStyle);
        
        if (defined(pattern)) {
            outerStrokeWidth = pattern["stroke-width"];
        }
        
        var rgba = canvasUtils.rgba;
        if (defined(outerFillOpacity) && outerFillColor) {
            outerFillColor = rgba(outerFillColor, outerFillOpacity);
        }
        if (defined(outerStrokeOpacity) && outerStrokeColor) {
            outerStrokeColor = rgba(outerStrokeColor, outerStrokeOpacity);
        }
        if (defined(innerFillOpacity) && innerFillColor) {
            innerFillColor = rgba(innerFillColor, innerFillOpacity);
        }
        if (defined(innerStrokeOpacity) && innerStrokeColor) {
            innerStrokeColor = rgba(innerStrokeColor, innerStrokeOpacity);
        }

        function getSymbolSize(d) {
            return chartType !== $ZC.charttype.stkdarea && (isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder))) ?
                0 :
                isBubbleChart ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "z", chartObj.zscale, yrangePos) / 2 : outerSize;
        }
        
        // function getGradients(color, opacity, size) {
        //     if (scatterOrBubble) {
        //         var gradientDim = [size, size],
        //             args = {"offset":"scatter", "dimension":gradientDim,"chartObj":chartObj},
        //             prop =  getGradientProp(cpOptions.gradients,gradientDim,(strokeColor || chartObj.seriesColor[index % chartObj.seriesColor.length]),opacity)
        //         var gradientID = effects.get(canvas_gradients, "canvasGradientFill", prop, args);
        //         if (gradientID) {
        //             return gradientID;
        //         }else{
        //             return rgba(color, opacity);
        //         }
        //     }
        //     return rgba(color, opacity);
        // }
        
        // function getColorOverlay(d, i, customColor, color) {
        //     if (customColor) {
        //         return customColor;
        //     } else if (defined(threshold)) {
        //         return getRawColor(chartObj, i, d, index) ;
        //     }
        //     return color;
        // }
        
        // function getMulticolor(index) {
        //     if (multiColoring === true) {
        //         return seriesColors[index % seriesColors.length]
        //     }
        //     return color;
        // }
        
        var useCache = !defined(threshold) && !multiColoring &&(chartName === "scatter" || chartName === "line" || chartName === "area") && !patternPallete && !patternPallete && !colorscale_helpers.isQuantileColorScale(chartObj),
            cache;

        var fillColor = chart.fillColorFunc = getFillColor(chartObj, index, null, !scatterOrBubble),
            strokeColor = getStrokeColor(chartObj, index),

            innerFillColorFunc = getFillColor(chartObj, index, null, true);

        if (useCache) {
            fillStyle = chart.fillColorFunc((0),  null ,null, outerFillColor, null, scatterOrBubble ? [outerSize,outerSize] : null, false);
            //getGradients(outerFillColor, outerFillOpacity, outerSize);
            cache = canvas_plot_renderer.scatter.getCache(symboltype, outerSize, outerStrokeColor, outerStrokeWidth, fillStyle, innerStrokeColor, innerStrokeWidth, innerFillColor, markerOptions);
            var adjust = cache.adjustPosition,
                cacheCanvas = cache.canvas,
                drawWidth = cache.width;
        }
        var usePatternPallete = scatterOrBubble;
        

        if (!seriesData.disabled) {
            
            var datatypeX = chartObj.dataset.getDataType("x"),
                datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),

                xCategories = (datatypeX == ORDINAL_DATATYPE) ? xscale.domain() : null,
                yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

                categories = (datatypeX == ORDINAL_DATATYPE && xscale.domain != null && !defined(chartObj.dataObject.hierarchical)) ? xCategories : chartObj.dataObject.getCategories("x"),
                fillStyle, strokeStyle;
            chart.seriesdataAfterUpdate = [];
            
            currentseriesdata.forEach(function(data, j) {

                var dataUpdate;
                if (datatypeX == ORDINAL_DATATYPE || datatypeY == ORDINAL_DATATYPE) {
                    dataUpdate = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(data), xCategories, yCategories, yaxiscolumnorder);
                } else {
                    dataUpdate = data;
                }

                chart.seriesdataAfterUpdate[j] = dataUpdate;

                if (hasColorScale && defined(pattern)) {
                    dataUpdate = legend_helpers.filterSelectionByColor(dataUpdate, true, filterIndex, chartObj);
                }

                dataUpdate.forEach(function(d, i) {

                    var outerFillStyle, outerStrokeStyle;
                    
                    if (!(d.isDummy || isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder))) || chartType === $ZC.charttype.stkdarea) {
                        
                        var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x"),
                            y = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y"),
                            size = getSymbolSize(d);
                        
                        if (useCache) {
                            // using cache image
                            context.beginPath();
                            var centered = size + (outerStrokeWidth / 2) + adjust;
                            context.drawImage(cacheCanvas, x - centered, y - centered, drawWidth - 1, drawWidth - 1);
                            context.closePath();
                        } else {
                            
                            // don't use cache in case of bubble, multicolor and colorOverlay.
                            // var multicolor = getMulticolor(i);

                            // outer circle
                            if ((outerFillColor || outerStrokeColor)) {
                                // fillStyle = getColorOverlay(value, markerOptions.outerFillColor || multicolor);
                                // fillStyle = svgPallete ? fillStyle : getGradients(fillStyle, outerFillOpacity, size);
                                // strokeStyle = getColorOverlay(value, markerOptions.outerStrokeColor || multicolor);
                                // outerFillStyle = chart.fillColorFunc((multiColoring ? i : index),  value ,null, outerFillColor, null,[size,size], false);
                                strokeClr = strokeColor((multiColoring ? i : index),  d, (chartObj.imagePallete ? null : markerOptions.outerStrokeColor));
                                outerStrokeStyle = rgba(strokeClr, outerStrokeOpacity)
                                // outerFillStyle = fillStyle;
                                // outerStrokeStyle = strokeStyle;

                                // canvas_plot_renderer.scatter.drawPath(symboltype, context, x, y, size, outerStrokeWidth, outerStrokeStyle, outerFillStyle, outerDashArray, outerStrokeLineCap);

                                var drawScatterFunction = function (context, fillStyle) {
                                    // context.fillStyle = fillStyle;
                                    canvas_plot_renderer.scatter.drawPath(symboltype, context, x, y, size, outerStrokeWidth, outerStrokeStyle, fillStyle, outerDashArray, outerStrokeLineCap);
                                };

                                if(chartObj.imagePallete){
                                    canvas_patterns.imageFill({x:x,y:y,context:context,name:chartObj.imagePallete[(multiColoring ? i : index)]},drawScatterFunction);
                                }else{
                                    var fillStyle = chart.fillColorFunc((multiColoring ? i : index),  d ,null, markerOptions.outerFillColor, outerFillOpacity, scatterOrBubble ? [size,size] : null, false);
                                    drawScatterFunction(context, fillStyle);
                                }

                                // if (defined(patternPallete)) {
                                //     var p = $ZC.legutil.patternPallete.get(patternPallete),
                                //         url = p[index % p.length];
                                //     canvasUtils.fillImagePattern(context, drawScatterFunction, url);
                                // } else if (svgPallete && svgPallete.length) {
                                //     var url = svgPallete[index % svgPallete.length];
                                //     canvasUtils.fillSVGPattern(context, drawScatterFunction, url, fillStyle);
                                // } else {
                                //     drawScatterFunction(context);
                                // }
                            }
                            
                            // inner circle
                            if (!(isBubbleChart && cpOptions.gradients.type && cpOptions.gradients.type !== "none") && (innerFillColor || innerStrokeColor)) {
                                fillStyle = innerFillColorFunc((multiColoring ? i : index),  d ,null, markerOptions.innerFillColor, innerFillOpacity, null, false);
                                strokeStyle = rgba(strokeColor((multiColoring ? i : index),  d, (chartObj.imagePallete ? null : markerOptions.innerStrokeColor)), innerStrokeOpacity);
                                
                                canvas_plot_renderer.scatter.drawPath(symboltype, context, x, y, size / 2, innerStrokeWidth, strokeStyle, fillStyle, innerDashArray, innerStrokeLineCap);
                            }
                        }
                    }
                });
            });
        }
        
        if (defined($ZC.labelRenderer)) {
            var markerSize;
            if (scatterOrBubble) {
                markerSize = (outerSize * 2) + markerOptions.outerStrokeWidth;
            } else {
                var strokeWidth = pick(cpOptions.strokeWidth, 2);
                markerSize = pick(markerOptions.size, strokeWidth) * outerSize + (strokeWidth / 2);
            }
            labelQueue.push({
                "renderer": chart,
                "charttype": "scatter",
                "chartObj": chartObj,
                "args": [seriesData, index, markerSize, yrangePos]
            });
        }
        chart.chartRendered = true;
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    
    chart.yrangePos = function(_) {
        if (!arguments.length) {
            return yrangePos;
        }
        yrangePos = _;
        return chart;
    };
    
    return chart;
};

/**
 * @param {String} symbol
 * @param {CanvasRenderingContext2D} context
 * @param {Number} x
 * @param {Number} y
 * @param {Number} size
 * @param {Number} strokeWidth
 * @param {String} strokeColor
 * @param {String} fillColor
 */

canvas_plot_renderer.scatter.drawPath = function(symbol, context, x, y, size, strokeWidth, strokeColor, fillColor, strokeDashArray, strokeLineCap) {
    
    context.save();
    context.translate(x, y);
    context.beginPath();
    context.lineWidth = strokeWidth;
    context.strokeStyle = strokeColor;
    context.fillStyle = fillColor;

    if (symbol === "circle") {
        context.arc(0, 0, size, 0, mathPI * 2);
    } else {
        var path = getSVGsymbol(symbol)(size * 2);
        canvasUtils.drawPath(context, path);
    }
    if (fillColor) {
        context.fill();
    }

    if (strokeDashArray && strokeDashArray.length && typeof strokeDashArray === "object" && defined(context.setLineDash)) {
        context.setLineDash(strokeDashArray);
        context.lineCap = strokeLineCap;
    }

    if (strokeWidth && strokeColor) {
        context.stroke();
    }
    context.closePath();
    context.restore();      
};

/**
 * osc, osw, ofc, isc, isw, ifc - params
 * o - outer
 * i - inner
 * s - stroke
 * f - fill
 * c - color
 * w - width
 * ----
 * @param {String} symbol
 * @param {Number} outerSize
 * @param {String} osc
 * @param {Number} osw
 * @param {String} ofc
 * @param {String} isc
 * @param {Number} isw
 * @param {String} ifc
 */

canvas_plot_renderer.scatter.getCache = function(symbol, outerSize, osc, osw, ofc, isc, isw, ifc, markerOptions) {
    var adjustPosition = 10, // to remove the sharp edge
        scaleRatio = pick(window.devicePixelRatio * 1.5, 1.5),
        cacheCanvas = document.createElement("canvas"),
        tempPos = ((outerSize + (osw / 2)) * scaleRatio) + adjustPosition / 2,
        cache = cacheCanvas.getContext("2d"),
        canvasDimension = (outerSize * 2 + osw + adjustPosition) * scaleRatio,
        width = canvasDimension / scaleRatio;
    cacheCanvas.height = cacheCanvas.width = canvasDimension;
    // outer symbol
    this.drawPath(symbol, cache, tempPos, tempPos, outerSize * scaleRatio, osw * scaleRatio, osc, ofc, getDashArray(markerOptions.outerDashStyle, osw, scaleRatio), getLineCap(markerOptions.outerLineCap, markerOptions.outerDashStyle));
    // inner symbol
    this.drawPath(symbol, cache, tempPos, tempPos, (outerSize / 2) * scaleRatio, isw * scaleRatio, isc, ifc, getDashArray(markerOptions.innerDashStyle, isw, scaleRatio), getLineCap(markerOptions.innerLineCap, markerOptions.innerDashStyle));
    
    return {
        canvas: cache.canvas,
        width: width,
        adjustPosition: (adjustPosition / 2) / scaleRatio
    };
};