//$Id$
var brushComponent;
(function(){
    brushComponent = function(chartObj, options) {
        this.chartObj = chartObj;
        this.options = options;
        this.isResizeInitiated = null;

        var brushScale = options.scale,
            orient = options.orient,
            dimension = options.dimension,

            isHorizontal = orient === "top" || orient === "bottom",
            rectPosition = {},

            component = this.component = d3_brush(),
            previousExtent = options.initialExtent, //if it is out of range????
            container;

        component
            .on("brush", function() {
                var extent =  component.extent();
                if (extent[0] === extent[1]) { // If user clicks
                    var bandWidth = mathAbs(previousExtent[1] - previousExtent[0]),
                        range = brushScale.rangeExtent ? brushScale.rangeExtent() : brushScale.domain();
                    extent = [extent[0] - bandWidth / 2, extent[1] + bandWidth / 2];

                    if (extent[1] > range[1]) {
                        extent[1] = range[1] - (brushScale.rangeExtent ? bandWidth * 0.1 : 0);
                        extent[0] = extent[1] - bandWidth;
                    }
                    if (extent[0] < range[0]) {
                        extent[0] = range[0] + (brushScale.rangeExtent ? bandWidth * 0.1 : 0);
                        extent[1] = extent[0] + bandWidth;
                    }

                    component.extent(extent);
                    container.call(component);
                }
                options.onBrush(component);
                previousExtent = component.extent();
                // Unhighlight the remaining space
            })
            .on("brushstart", function(event) {
                this.isResizeInitiated = false;
            })
            .on("brushend", function(event) {
                options.onEnd(component);
                previousExtent = component.extent();
            });

        if (!this.context) {
            this.context = container = appendEle(options.element || chartObj.svg, "g", options.brushOptions.enabled ? [1] : [], ".", "class", "brush");
        }

        if (isHorizontal) {
            component.x(brushScale);

            rectPosition = {
                y: null,
                height: dimension[1]
            };
        } else {
            component.y(brushScale);

            rectPosition = {
                x: null,
                width: dimension[0]
            };
        }

        component.extent(options.initialExtent);
        container.call(component);

        container.selectAll("rect.background")
            .attr(rectPosition);

        container.selectAll("rect.extent")
            .style({
                "fill":"transparent"
            })
            .attr(rectPosition);

        this.drawSlider();
    };

})();