//$Id$
function addDefaultScroll(chartObj, state) {
    if (!chartObj.isAxisCategory || (!chartObj.systemConf.chart.width && !chartObj.systemConf.chart.height)) {
        return;
    }
    
    var axisrotated = chartObj.dataObject.getAxisRotated(),
        plotarea = chartObj.plotarea,
        attrObj;
    
    var XSIZE = (getPlotSize(chartObj, "width") - plotarea.width),
        YSIZE = (getPlotSize(chartObj, "height") - plotarea.height);
    
    // Initial clip-path
    var axis = chartObj.container.selectAll(".x-axis-0"),
        scroll = chartObj.container.selectAll(".d3container").selectAll(".zohocharts_scroll");
    var scrollbar_size = +scroll.attr("scrollbarSize");

    var properties = {
        name: "rect_axis",
        id: chartObj.id
    },
    args = {
        chartObj: chartObj
    };
    if (axisrotated) {
        chartObj.scrolledY = chartObj.scrolledY || 0;
        properties.x = -plotarea.left;
        properties.y = 0;
        properties.width = plotarea.width + plotarea.left;
        properties.height = plotarea.height;
    } else {
        chartObj.scrolledX = chartObj.scrolledX || 0;
        properties.x = 0;
        properties.y = 0;
        properties.width = plotarea.width;
        properties.height = chartObj.canvasarea.height;
    }
    updateAxisClipPath(chartObj);
    
    // Scroll div
    scroll
        .style({
            "left": plotarea.left + "px",
            "top": plotarea.top + "px",
            "height": (plotarea.height + (axisrotated ? 0 : scrollbar_size)) + "px",
            "width": (plotarea.width + (axisrotated ? scrollbar_size : 0)) + "px"
        })
        .on("scroll", function(e) {
            var src = d3.event.srcElement || d3.event.target;
            var scrolled = (!axisrotated) ? src.scrollLeft : src.scrollTop;
            chartObj.scrolledY = (!axisrotated) ? 0 : scrolled;
            chartObj.scrolledX = (!axisrotated) ? scrolled : 0;
            chartObj.eventHandler.mouseOut();
            scrollGroups(scrolled);

        });
    
    scroll
        .style((axisrotated) ? {
                "overflow-y": "auto",
                "overflow-x": "hidden"
            } : {
                "overflow-x": "auto",
                "overflow-y": "hidden"
            });
    
    // Scroll child
    scroll.selectAll(".child")
        .style({
            "height": (plotarea.height + (!axisrotated ? 0 : YSIZE)) + "px",
            "width": (plotarea.width + (!axisrotated ? XSIZE : 0)) + "px",
            "pointer-events": "none",
            "margin": 0,
            "padding": 0,
            "background-color": "transparent"
        });
    
    // Reset scroll position
    if (state !== "addorremoveseries") {
        var scroll_node = scroll.node();
        scroll_node.scrollLeft = 0
        scroll_node.scrollTop = 0
    }
    
    // Event listners
    var eventHandler = chartObj.eventHandler,
        eventAttacherOptions = {
            target: "plot",
            chartObj: chartObj
        };
    var clickHandlers = {
            "click": eventHandler.click,
            "dblclick": eventHandler.doubleclick,
            "contextmenu": eventHandler.contextMenu
        },
        moveHandlers = {
            "mousemove": eventHandler.mouseMove,
            "mouseout": eventHandler.mouseOut
        };
    attachevents(scroll, clickHandlers, null, "chart");
    attachevents(scroll, moveHandlers, null, "chartmove");

    var touchHandlers = {
        "tap": eventHandler.click,
        "dbltap": eventHandler.doubleclick,
        "singletouchmove": eventHandler.mouseMove,
        "touchend": eventHandler.mouseOut
    };

    attachevents(scroll, {}, touchHandlers, eventAttacherOptions);
    
    var scrolled = (!axisrotated) ? chartObj.scrolledX : chartObj.scrolledY;
    if (scrolled && (state === "addorremoveseries")) {
        scrollGroups(scrolled);
    }
    
    function scrollGroups(scrolled) {
        var seriesholder = chartObj.container.selectAll(".seriesholder");

        var clipPathID = seriesholder.attr("clip-path").replace(/url\(|\)|\"/gi, "");
        
        var seriesTrans = d3_transform(seriesholder.attr("transform")).translate;
        var transX = (!axisrotated) ? (plotarea.left - scrolled) : seriesTrans[0],
            transY = (!axisrotated) ? seriesTrans[1] : (plotarea.top - scrolled);
        seriesholder
            .attr("transform", "translate(" + transX + "," + transY + ")");
        chartObj.container.selectAll(".labelholder")
            .attr("transform", "translate(" + transX + "," + transY + ")");
        chartObj.container.selectAll(".eventgroup")
            .attr("transform", "translate(" + (axisrotated ? 0 : -scrolled) + "," + (axisrotated ? -scrolled : 0) + ")");
        chartObj.container.selectAll("rect.eventhandler")
            .attr("transform", "translate(" + (axisrotated ? 0 : scrolled) + "," + (axisrotated ? scrolled : 0) + ")");

        ($Browser.SAFARI ? chartObj.svg : $ZCG.patternSVG).selectAll(clipPathID)
            .selectAll("rect")
            .attr((axisrotated) ? {
                    "y": scrolled
                } : {
                    "x": scrolled
                });
        var attrObj = (axisrotated) ? {
                "y": (plotarea.top - scrolled),
                "height": (plotarea.height + scrolled)
            } : {
                "x": (plotarea.left - scrolled),
                "width": (plotarea.width + scrolled)
            };
        chartObj.eventHandler.trackerElement
            .attr(attrObj)
            .attr("clip-path", "url(" + clipPathID + ")");
        updateAxisClipPath(chartObj);


        var properties = {
                name: "rect_highlight",
                id: chartObj.id
            },
            args = {
                chartObj: chartObj
            };
        if (axisrotated) {
            properties.x = -plotarea.left;
            properties.y = scrolled;
            properties.width = (plotarea.width + plotarea.left);
            properties.height = plotarea.height;
        } else {
            properties.x = scrolled;
            properties.y = plotarea.top;
            properties.width = plotarea.width;
            properties.height = plotarea.height;
        }
        var clipID = effects.get(svg_clips, "rect", properties, args);
        chartObj.container.selectAll("#zcareahighlight")
            .attr("clip-path", "url(#" + clipID + ")");


    }
}
addDefaultScroll.initialize = function(chartObj) {
    if (!chartObj.isAxisCategory || (!chartObj.systemConf.chart.width && !chartObj.systemConf.chart.height)) {
        return;
    }

    if (axisrotated) {
        chartObj.scrolledY = chartObj.scrolledY || 0;
    } else {
        chartObj.scrolledX = chartObj.scrolledX || 0;
    }

    var scroll = appendEle(chartObj.container.selectAll(".d3container"), "div", [1], ".", "class", "zohocharts_scroll");
    scroll
        .style({
            "width": 100 + "px",
            "height": 100 + "px",
            "overflow": "auto",
            "position": "absolute",
            "margin": 0,
            "padding": 0,
            "background-color": "rgba(0,0,0,0)",
            "box-sizing": "content-box",
            "-webkit-tap-highlight-color" : "transparent",
            "-webkit-overflow-scrolling" : "touch"
        });
    
    appendEle(scroll, "div", [1], ".", "class", "child")
        .style({
            "width": 200 + "px",
            "height": 200 + "px"
        });
    
    var axisrotated = chartObj.dataObject.getAxisRotated(),
        conf = chartObj.defaultScroll;
    
    //scrollbar size
    var scroll_node = scroll.node();
    var scrollbar_size = (axisrotated) ?
        scroll_node.offsetWidth - scroll_node.clientWidth :
        scroll_node.offsetHeight - scroll_node.clientHeight;
    scroll.attr("scrollbarSize", scrollbar_size);
    
    if (!conf) {
        conf = chartObj.defaultScroll = {};
        conf.tickmarkSize = +chartObj.systemConf.chart.axes.xaxis.tickmark.size;
        conf.marginRight = +chartObj.systemConf.chart.marginRight;
    }
    if (axisrotated) {
        chartObj.plotarea.bottom += scrollbar_size;
        chartObj.plotarea.width -= scrollbar_size;
    } else {
        chartObj.systemConf.chart.axes.xaxis.tickmark.size = +conf.tickmarkSize + scrollbar_size;
    }
};

function getPlotSize(chartObj, type, plotarea) {
    plotarea = plotarea || chartObj.plotarea;
    var customSize = chartObj.systemConf.chart[type];
    if (customSize == null || isNaN(customSize)) {
        return plotarea[type];
    }
    return mathMax(plotarea[type], +customSize);
}

function updateAxisClipPath(chartObj){
    var axisrotated = chartObj.dataObject.getAxisRotated(),
        plotarea = chartObj.plotarea,
        scrolled = (!axisrotated) ? chartObj.scrolledX : chartObj.scrolledY,
        attrObj;
    if (axisrotated) {
        attrObj = {
            "x": -plotarea.left,
            "y": scrolled,
            "width": (plotarea.width + plotarea.left),
            "height": plotarea.height
        };
    } else {
        var hierachyObj = chartObj.dataObject.hierarchical;
        var axisLen = 0;
        if(hierachyObj){
            for(var i=0; i<chartObj.axes.x.count; i++){
                var axisObj =  getAxisObject(chartObj,"x",i);
                axisLen += axisObj.ticks.preCalcAxisLen;
            }
        }else{
            axisLen = chartObj.axes.x.ticks.preCalcAxisLen
        }

        // var prevTickObj = hierachyObj ? hierachyObj.finalDepth == 1 ?  chartObj.axes.x.ticks.preCalcAxisLen : chartObj.axes.x.levels[hierachyObj.finalDepth-1].ticks.preCalcAxisLen : 0;
        attrObj = {
            "x": scrolled,
            "y": -plotarea.height,
            "width": plotarea.width,
            "height": axisLen + chartObj.plotarea.height
        };
    }

    attrObj.name = "rect_axis";
    attrObj.id = chartObj.id;
    var args = {
        chartObj: chartObj
    };

    var axisClipPathId = effects.get(svg_clips, "rect", attrObj, args);

    var axis = chartObj.container.selectAll("g.x-axis").selectAll(function(){return this.childNodes});
    axis.filter(function(){
        var comp = d3.select(this);
        var axisTrans = d3_transform(comp.attr("transform")).translate;
        var transX = (!axisrotated) ? (plotarea.left - scrolled) : axisTrans[0],
            transY = (!axisrotated) ? axisTrans[1] : (plotarea.top - scrolled);
        comp
            .attr({
                "transform": "translate(" + transX + "," + transY + ")",
                "clip-path" : "url(#"+axisClipPathId+")"
            });
        comp.selectAll("g.axisgroup").attr("clip-path","");
    })
    return axisClipPathId;
}