//$Id$
$ZC.axis.threshold = function(chartObj, update) {
    var threshold = {};
    
    var systemconf = chartObj.systemConf;
    var xaxisdata = systemconf.chart.axes.xaxis;
    var xaxis_userdata = isObjectPropDefined(chartObj.userdata, "chart.axes.xaxis") ? chartObj.userdata.chart.axes.xaxis : {};
    //X- Threshold Line
    if (xaxis_userdata.threshold != null && xaxis_userdata.threshold.line != null) {
        drawThreshold(chartObj.axes.x, xaxisdata.threshold.line, 0, update, "x", "line", xaxis_userdata.threshold.line);
    }
    
    //X- Threshold range
    if (xaxis_userdata.threshold != null && xaxis_userdata.threshold.range != null) {
        drawThreshold(chartObj.axes.x, xaxisdata.threshold.range, 0, update, "x", "range", xaxis_userdata.threshold.range);
    }
    
    //Y- Threshold line
    var yaxesdata = systemconf.chart.axes.yaxis;
    var yaxes_userdata = isObjectPropDefined(chartObj.userdata, "chart.axes.yaxis") ? chartObj.userdata.chart.axes.yaxis : {};
    for (var i = 0; i < chartObj.axes.y.count; i++) {
        if (yaxes_userdata != null && yaxes_userdata[i] != null && yaxes_userdata[i].threshold != null && yaxes_userdata[i].threshold.line != null) {
            drawThreshold(chartObj.axes.y.groups[i], yaxesdata[i].threshold.line, i, update, "y", "line", yaxes_userdata[i].threshold.line);
        }
        //Y-Threshold range
        if (yaxes_userdata != null && yaxes_userdata[i] != null && yaxes_userdata[i].threshold != null && yaxes_userdata[i].threshold.range != null) {
            drawThreshold(chartObj.axes.y.groups[i], yaxesdata[i].threshold.range, i, update, "y", "range", yaxes_userdata[i].threshold.range);
        }
    }
    
    
    function createthreshold(axis, data, index, category) {
        if (axis) {
            if (!axis.threshold) {
                axis.threshold = {}
            }
            axis.threshold[category] = (data.show) ? (category == "line") ? $ZC.axis.threshold.line() : $ZC.axis.threshold.range() : null;
            return axis.threshold[category];
        }
        return null;
    }
    
    function setThresholdProp(renderer, axisObj, index, type, category, userdata) {
        var values;
        threshold.axisObj = function(_) {
            if (!arguments.length) {
                return axisObj;
            }
            axisObj = _;
            return threshold;
        };
        threshold.thresholdIndex = function(_) {
            if (!arguments.length) {
                return index;
            }
            index = _;
            return threshold;
        };
        threshold.type = function(_) {
            if (!arguments.length) {
                return type;
            }
            type = _;
            return threshold;
        };
        threshold.values = function(_) {
            if (!arguments.length) {
                return values;
            }
            values = _;
            return threshold;
        };
        threshold.chartObj = function(_) {
            if (!arguments.length) {
                return chartObj;
            }
            chartObj = _;
            return threshold;
        };
        threshold
            .thresholdIndex(index)
            .type(type)
            .values(userdata.values)
            .chartObj(chartObj);
        if (category == "line") {
            threshold.axisObj(axisObj)
        }
        renderer.parentObj(threshold);
        return renderer;
    }
    
    function drawThreshold(axisObj, data, index, update, type, category, userdata) {
        var isUnderlayThreshold = userdata && userdata.underlay ;
        var thresholdGroup = (isUnderlayThreshold ? chartObj.svg : chartObj.staticPaneSVG).selectAll("g.threshold");
        
        var axisWrap = chartObj.svg.selectAll("g." + type + "-axis-" + index);
        var visibility = (axisWrap != null && !axisWrap.empty() && (axisWrap.style("visibility") == "" || axisWrap.style("visibility") == "visible")) ? "visible" : "hidden";
        var thWrap = appendEle(thresholdGroup, "g", ((userdata.show && visibility == "visible") ? [data] : []), ".", "class", ("threshold" + category + "-" + type + "-axis-" + index));
        // thWrap.style("visibility",visibility);
        
        if (axisObj != null && data.show) {
            
            var renderer = (update && axisObj.threshold != null && axisObj.threshold[category] != null) ? axisObj.threshold[category] : createthreshold(axisObj, data, index, category);
            renderer = setThresholdProp(renderer, axisObj, index, type, category, userdata);
            
            thWrap
                .call(renderer);
        }
    }
};

$ZC.axis.threshold.textAlign = function(hAlign, type, plotarea, axesRotated, padding, orient) {
    var x;
    padding = padding || 0;
    if (hAlign == "left") {
        if (axesRotated) {
            if (orient == "left" || orient == "bottom") {
                x = (type == "x") ? padding : plotarea.height - padding;
            } else {
                x = (type == "x") ? padding : plotarea.height - padding;
            }
        } else {
            if (orient == "left" || orient == "bottom") {
                x = (type == "x") ? plotarea.height - padding : padding;
            } else {
                x = (type == "x") ? padding : plotarea.width - padding;
            }
        }
    } else if (hAlign == "center") {
        if (axesRotated) {
            if(orient === "left" || orient === "bottom") {
                x = (type == "x") ? (plotarea.width + padding) / 2 : (plotarea.height - padding) / 2;
            } else {
                x = (type == "x") ? (plotarea.width - padding) / 2 : (plotarea.height + padding) / 2;
            }
        } else {
            if (orient == "left" || orient == "bottom") {
                x = (type == "x") ? (plotarea.height - padding) / 2 : (plotarea.width + padding) / 2;
            } else {
                x = (type == "x") ? (plotarea.height + padding) / 2 : (plotarea.width - padding) / 2;
            }
            
        }
    } else if (hAlign == "right") {
        if (axesRotated) {
            x = (type == "x") ? plotarea.width : 0;
        } else {
            if (orient == "left" || orient == "bottom") {
                x = (type == "x") ? 0 : plotarea.width;
            } else {
                x = (type == "x") ? plotarea.height : 0;
            }
            
        }
    }
    return x
};
