//$Id$
$ZC.axis.threshold.line = function() {
    var scale, index, plotarea, systemconf, chartObj, axesRotated, type, parentObj, axisObj, values;
    
    function chart(selection) {
        selection.each(function(data) {
            var container = d3_select(this);
            chart.update = function() {
                container.transition().call(chart);
            };
            
            chartObj = parentObj.chartObj();
            index = parentObj.thresholdIndex();
            type = parentObj.type();
            axisObj = parentObj.axisObj();
            values = parentObj.values();
            
            plotarea = chartObj.plotarea;
            var scale = axisObj.scale;
            var range = scale.range();
            range = range.slice(0, range.length);
            range.sort(function(a, b) {
                return a - b
            });
            var bandwidth = (scale.rangeBand != null) ? scale.rangeBand() / 2 : 0;
            var label = data.label;
            label = overrideThresholdFonts(label, isObjectPropDefined(chartObj.userdata, "chart.axes." + type + "axis" + (type === "x" ? "" : ("." + index)) + ".threshold.line.label", true));
            var markerInfo = data.marker || {};
            var markerEnabled = pick(markerInfo.enabled, true);
            axesRotated = chartObj.axes.rotated;
            systemconf = chartObj.systemConf;
            var thval = [],
                thname = [],
                thclr = [];
            
            // var yAxisColumnOrder = chartObj.systemConf.metadata.axes[type];
            // var colInfo = chartObj.systemConf.metadata.columns[index];
            
            var labelPadding = {
                "x": 2,
                "y": 2
            };
            var xAxisLine = systemconf.chart.axes.xaxis.axisline,
                yAxisLine = systemconf.chart.axes.yaxis[index].axisline;
            
            if (defined(xAxisLine) && xAxisLine.show) {
                labelPadding.x += +xAxisLine.strokeWidth - 1
            }
            
            if (defined(yAxisLine) && yAxisLine.show) {
                labelPadding.y += +yAxisLine.strokeWidth - 1
            }
            
            var count = 0;
            
            var hAlign = [],
                strokeDashArray = [],
                strokeWidth = [],
                markerWidth = [],
                markerBBox = [],
                markerSize = [],
                fontSizes = [],
                fontFamilies = [];
            
            var datatype = chartObj.dataset.getDataType(type, index);
            var formatConf;
            
            var colInfo = chartObj.dataset.getColumn(type, index),
                columnindex = chartObj.dataset.getColumnIdx(type, index);
            if (datatype == TIME_DATATYPE) {
                formatConf = getPropVal(colInfo, TIME_DATATYPE) || null;
            }
            
            values.map(function(d, i) {
                var d_scale = (d != null && d != "") ? (datatype == TIME_DATATYPE) ? ((generateDateVal(d, null, formatConf)).getTime()) : (d) : null;
                if (d != null && d !== "" && scale(d_scale) + bandwidth >= range[0] && scale(d_scale) + bandwidth <= range[range.length - 1]) {
                    thval[count] = d_scale;
                    thname[count] = getCustomThresholdText(getPropVal(data, "label.text[" + i + "]") || "", values, colInfo, chartObj);
                    thclr[count] = (isArray(data.color) ? data.color[i] : data.color) || "black";
                    hAlign[count] = (defined(data.label)) ? ((isArray(data.label.hAlign)) ? data.label.hAlign[i] : data.label.hAlign) || "center" : "center";
                    strokeWidth[count] = ((isArray(data.strokeWidth)) ? data.strokeWidth[i] : data.strokeWidth) || 1;
                    strokeDashArray[count] = ((isArray(data.dashStyle)) ? data.dashStyle[i] : data.dashStyle);
                    markerWidth[count] = (defined(data.marker) && data.marker.enabled) ? ((isArray(data.marker.strokeWidth)) ? data.marker.strokeWidth[i] : data.marker.strokeWidth) || 2 : null;
                    markerSize[count] = (data.marker && data.marker.enabled) ? (isArray(data.marker.size) ? data.marker.size[i] : data.marker.size) || 1 : null;
                    count++;
                }
            })
            var rect = chartObj.container.node().getBoundingClientRect(),
                bound = {
                    left: (rect.left + plotarea.left),
                    top: (rect.top + plotarea.top),
                    width: plotarea.width,
                    height: plotarea.height,
                    right: (rect.left + plotarea.left + plotarea.width),
                    bottom: (rect.top + plotarea.top + plotarea.height)
                },
                boundLeft = bound.left,
                boundTop = bound.top,
                orient = axisObj.component.orient(),
                margin = {
                    top: 0,
                    left: 0,
                    right: 0,
                    bottom: 0
                },
                overFlow = "..",
                thresholdEvents = chartObj.events.threshold = [];
            container.attr("transform", "translate(" + plotarea.left + "," + (plotarea.top) + ")");
            var wrap = appendEle(container, "g", [data], ".", "class", ('thresline-' + index));
            //plotarea border size to include in markerbox width
            var plotareaBorderEle = chartObj.container.selectAll("g.plotareaBorder-property").node();
            var plotareaBorder_bkp = plotareaBorderEle.border || plotareaBorderEle["border-" + orient];
            // var plotareaBorder_Oppbkp = (orient == "left") ? (plotareaBorderEle["border"] || plotareaBorderEle["border-right"]) : (orient == "right") ? (plotareaBorderEle["border"] || plotareaBorderEle["border-left"]) : null; //For dual side axes, need to consider border size on both axes
            var plotareaBorder_Oppbkp = plotareaBorderEle.border || plotareaBorderEle["border-" + getOppositeOrient(orient)];
            var wid1 = (plotareaBorder_bkp && plotareaBorder_bkp.clr !== "transparent") ? plotareaBorder_bkp.size : 0;
            var wid2 = (plotareaBorder_Oppbkp && plotareaBorder_Oppbkp.clr !== "transparent") ? plotareaBorder_Oppbkp.size : 0;
            var plotareaBorderWid_bkp = wid1 + wid2;

            var marker = appendEle(wrap, "path", ((markerInfo != null && markerEnabled) ? thval : []), ".", "class", "marker");
            marker
                .attr('d', function(d, i) {
                    return (getSVGsymbol(((isArray(markerInfo.symbol)) ? markerInfo.symbol[i] : markerInfo.symbol)))(markerSize[i] * 10)
                })
                // .attr("transform",function(d,i){return "translate("+((type == "x" && !axesRotated)||(type == "y" && axesRotated)? (scale(d)+bandwidth) : (0+(((markerWidth[i] || 1)*10)/2))) + "," + ((type == "x" && !axesRotated)||(type == "y" && axesRotated)? (plotarea.height-(((markerWidth[i] || 1)*10)/2)) :scale(d)+bandwidth)+")"})
                .style('stroke-width', function(d, i) {
                    return ((markerWidth[i]) || 2)
                })
                .style('stroke', function(d, i) {
                    return (isArray(markerInfo.strokeColor) ? markerInfo.strokeColor[i] : markerInfo.strokeColor) || thclr[i];
                })
                .attr('fill', function(d, i) {
                    var fillClr = isArray(markerInfo.fillColor) ? markerInfo.fillColor[i] : markerInfo.fillColor;
                    return fillClr || ((fillClr === null) ? thclr[i] : "white"); //If 'fillColor' is given as null explicitly by the user, use thclr
                });
            
            marker.attr("transform", function(d, i) {
                var mrkrWidth = markerWidth[i] / 2;
                var bbox = d3_select(this).node().getBBox();
                markerBBox[i] = (bbox.width + wid1);
                var translateX = (orient == "bottom" || orient == "top") ? (scale(d) + bandwidth) : (orient == "left") ? (mrkrWidth + wid1 + (bbox.width / 2)) : (plotarea.width - (mrkrWidth + wid1 + (bbox.width / 2))),
                    // translateY = (orient == "bottom") ? (plotarea.height - mrkrWidth - ((plotareaBorderWid_bkp + ((bbox.width) / 2)))) : (orient == "top") ? (mrkrWidth + plotareaBorderWid_bkp + ((bbox.height) / 2)) : (scale(d) + bandwidth);
                    translateY = (orient == "bottom") ? (plotarea.height - bbox.width / 2 - wid1 - mrkrWidth ) : (orient == "top") ? (mrkrWidth + (bbox.height) / 2) + wid1 : (scale(d) + bandwidth);

                    thresholdEvents.push({
                        x : translateX - (markerBBox[i] / 2),
                        y : translateY - (markerBBox[i] / 2),
                        width : markerBBox[i],
                        height : markerBBox[i],
                        color : thclr[i],
                        text : thname[i],
                        // value : d,
                        // columnindex : columnindex,
                        // eventOptions : data.events || {}
                    })
                return "translate(" + (translateX) + "," + (translateY) + ")"
            })
            
            var line = appendEle(wrap, "line", thval);
            line
                .attr('x1', function(d, i) {
                    return ((orient == "bottom" || orient == "top") ? (scale(d) + bandwidth) : (orient == "left" ? (markerBBox[i] || 0) + (markerWidth[i]) : wid2))
                })
                .attr('y1', function(d, i) {
                    return ((orient == "bottom") ? wid1 : (orient == "top") ? (markerBBox[i] || 0) + (markerWidth[i]) : (scale(d) + bandwidth))
                })
                .attr('x2', function(d, i) {
                    return ((orient == "bottom" || orient == "top") ? (scale(d) + bandwidth) : (orient == "left") ? (plotarea.width - wid2) : (plotarea.width - (markerWidth[i]) - (markerBBox[i] || 0)))
                })
                .attr('y2', function(d, i) {
                    return ((orient == "bottom") ? (plotarea.height - (markerWidth[i]) - ((markerBBox[i] || 0))) : (orient == "top") ? (plotarea.height - wid2) : (scale(d) + bandwidth))
                })
                .attr('stroke', function(d, i) {
                    return ("    " + thclr[i])
                })
                .attr('stroke-width', function(d, i) {
                    return strokeWidth[i] + "px"
                })
                .attr("shaperendering", "crispedges")
                .attr('stroke-dasharray', function(d, i) {
                    return getDashArray(strokeDashArray[i], strokeWidth[i])
                })
            
            
            var text = appendEle(wrap, "text", ((label != null) ? thval : []));
            text
                .text(function(d, i) {
                    return decodeHTML(thname[i]);
                })
                .attr('x', function(d, i) {
                    
                    var textPadding = markerSize[i] * 10 + labelPadding[type] + (markerWidth[i] || 2);
                    var x = ((type == "x" && !axesRotated) || (type == "y" && axesRotated)) ? -($ZC.axis.threshold.textAlign(hAlign[i] || "right", type, plotarea, axesRotated, textPadding, orient)) : $ZC.axis.threshold.textAlign(hAlign[i] || "right", type, plotarea, axesRotated, textPadding, orient);
                    return x
                })
                .attr('y', function(d, i) {
                    var y = ((type == "x" && !axesRotated) || (type == "y" && axesRotated) ? (scale(d) + bandwidth) : scale(d) + bandwidth);
                    return y - 5;
                })
                
                .attr("transform", ((type == "x" && !axesRotated) || (type == "y" && axesRotated)) ? "rotate(-90)" : "rotate(0)")
                .style({
                    "font-family": function(d, i) {
                        fontFamilies[i] = ((isArray(label.fontFamily)) ? label.fontFamily[i] : label.fontFamily) || systemconf.chart.fontFamily || systemconf.canvas.fontFamily || $ZCG.fontFamily;
                        return fontFamilies[i];
                    },
                    "font-size": function(d, i) {
                        fontSizes[i] = $ZC.utils.getVal(((isFunction(label.fontSize) || isArray(label.fontSize)) ? label.fontSize[i] : label.fontSize) || systemconf.chart.fontSize || systemconf.canvas.fontSize)
                        return fontSizes[i] + "px"
                    },
                    "fill": function(d, i) {
                        return ((isArray(label.fontColor)) ? label.fontColor[i] : label.fontColor) || systemconf.chart.fontColor || systemconf.canvas.fontColor || $ZCG.fontColor
                    },
                    "font-weight": function(d, i) {
                        return (((isArray(label.fontWeight)) ? label.fontWeight[i] : label.fontWeight) || systemconf.chart.fontWeight || systemconf.canvas.fontWeight || $ZCG.fontWeight)
                    },
                    "font-style": function(d, i) {
                        return (((isArray(label.fontStyle)) ? label.fontStyle[i] : label.fontStyle) || systemconf.chart.fontStyle || systemconf.canvas.fontStyle || $ZCG.fontStyle)
                    },
                    "text-Anchor": function(d, i) {
                        if (orient == "left" || orient == "bottom") {
                            return (hAlign[i] == "center") ? "middle" : (hAlign[i] == "right") ? "end" : "start"
                        } else {
                            return (hAlign[i] == "center") ? "middle" : (hAlign[i] == "right") ? "start" : "end"
                        }
                    }
                })
                .each(function(d, i) {
                    var text = decodeHTML(thname[i]);
                    var actualMarkerSize = markerSize[i] * 10,
                        textWidth = getTextWidth(text, fontSizes[i], fontFamilies[i]) + actualMarkerSize,
                        size = orient === "top" || orient === "bottom" ? plotarea.height : plotarea.width,
                        adjustment;

                    if(textWidth > size) {
                        adjustment = mathMin((textWidth - size), actualMarkerSize) + plotareaBorderWid_bkp;
                        bound.left = boundLeft + adjustment;
                        bound.top = boundTop + adjustment;
                        trimText(this, this.textContent, this.getBoundingClientRect(), bound, get_threshold_text_orient(orient), overFlow, margin);
                    }
                });
            
        });
    }
    
    chart.parentObj = function(_) {
        if (!arguments.length) {
            return parentObj;
        }
        parentObj = _;
        return chart;
    };
    
    // function align(hAlign,type,data){
    // 	var x;
    // 	if (hAlign == "left"){
    // 		if(axesRotated){
    // 			x = (type == "x")?0:plotarea.height;
    // 		}else{
    // 			x = (type == "x")?plotarea.height:0;
    // 		}
    // 	}else if(hAlign == "center"){
    // 		if(axesRotated){
    // 			x = (type == "x")?plotarea.width/2:plotarea.height/2;
    // 		}else{
    // 			x = (type == "x")?plotarea.height/2:plotarea.width/2;
    // 		}
    // 	}else if(hAlign == "right"){
    // 		if(axesRotated){
    // 			x= (type == "x")?plotarea.width:0;
    // 		}else{
    // 			x= (type == "x")?0:plotarea.width;
    // 		}
    // 	}
    // 	return x
    // }
    return chart;
};