//$Id$
$ZC.axis.threshold.overlay = function(chartObj, category, overlayData) {
    var axisrotated = chartObj.dataObject.getAxisRotated();
    if (category == "discrete") {
        var thvalues = overlayData.values.slice(0),
            overlayRange = overlayData.overlayRange,
            defaultColor = overlayData.defaultColor; //Use seriesColor for 'null' colors
    
        // old code
        // var thvalues_sort = thvalues.sort(function(a, b) {
        //     return ((overlayRange == "below") || (overlayRange == "equalandbelow")) ? (a < b ? -1 : a > b ? 1 : 0) : (a > b ? -1 : a < b ? 1 : 0);
        // });
        
        if ((overlayRange == "below") || (overlayRange == "equalandbelow")) {
            thvalues.sort(d3_ascending);
        } else {
            thvalues.sort(d3_descending);
        }
        
        
        return function(data, thColor, yvalue, seriescolor) {
            if (overlayData.values == null || overlayData.length == 0) {
                return seriescolor
            }
            
            for (var i = 0; i < thvalues.length; i++) {
                var compare = (thvalues[i]);
                /*
                 * For bottom oriented axis, if overlay range is below, yvalue should be lesser than thValue to have color overlay
                 * For bottom oriented axis, if overlay range is above, yvalue should be greater than thValue to have color overlay
                 *
                 * For left/right oriented axis, if overlay range is below, yvalue should be greater than thValue to have color overlay
                 * For left/right oriented axis, if overlay range is above, yvalue should be lesser than thValue to have color overlay
                 */

                var toCompare;
                switch(overlayRange) {
                    case "equal" :
                        toCompare = (yvalue === compare);
                        break;
                    case "equalandbelow":
                        toCompare = (yvalue <= compare);
                        break;
                    case "equalandabove":
                        toCompare = (yvalue >= compare);
                        break;
                    case "below":
                        toCompare = (yvalue < compare);
                        break;
                    default:
                        toCompare = (yvalue > compare);
                }

                if (toCompare) {
                    var index = overlayData.values.indexOf(compare);
                    return ((thColor == null || thColor[index] == null) ? (defaultColor ? seriescolor : "black") : thColor[index]);
                }
            }
            return seriescolor;
        }
    } else if (category == "continous") {
        
        return function(seriescolor, data, index, type) {
            
            /*
             * If type is x use Xaxis scale
             * If type is y use Yaxis scale
             */
            var scale = (type == "x") ? chartObj.axes.x.scale : chartObj.axes.y.groups[0].scale,
                temp = index;
            
            // var th = chartObj.axes.yaxis[0].threshold;
            var origValues = data.values;
            if (origValues == null || origValues.length == 0) {
                return seriescolor;
            }
            var thValues = origValues.slice();
            var negthClr = data.color;
            var overlayRange = data.overlayRange,
                defaultColor = data.defaultColor; //Use seriesColor for 'null' colors

            if (overlayRange) {
                overlayRange = overlayRange.replace("equaland", ""); //equalandabove = above, equalandbelow = below
            }
            // for time input format values
            var datatype = chartObj.dataset.getDataType(type, index);
            var formatConf;
            if (datatype == "time") {
                var column = chartObj.dataset.getColumn(type, index);
                formatConf = (column["time"] != null) ? column["time"] : null
            }
            thValues = thValues.map(function(d, i) {
                return (datatype == "time") ? ((generateDateVal(d, null, formatConf)).getTime()) : (d);
            })
            /*
             * For bottom oriented axis sort ascending
             * For left/right oriented axis sort descending
             */
            if ((type == "x" && !axisrotated) || (type == "y" && axisrotated)) {
                thValues.sort(function(a, b) {
                    return a < b ? -1 : a > b ? 1 : 0;
                });
            } else {
                thValues.sort(function(a, b) {
                    return a > b ? -1 : a < b ? 1 : 0;
                });
            }
            
            var scaleDomainLength = scale.domain().length;
            var range = ((type == "x" && !axisrotated) || (type == "y" && axisrotated)) ? scale(scale.domain()[scaleDomainLength - 1]) - scale(scale.domain()[0]) : scale(scale.domain()[0]) - scale(scale.domain()[scaleDomainLength - 1])
            var percent = [];
            percent.push(0);
            for (var i = 0; i < thValues.length; i++) {
                var val = scale(thValues[i]) + ((scale.rangeBand != null) ? (scale.rangeBand() / 2) : 0); //Half of the range band is added for the category scale
                var per = (val / range) * 100;

                if (per < 100) {
                    percent.push(per);
                    percent.push(per);
                }
            }

            percent.push(100);
            
            var color = [];
            if ((type == "y" && overlayRange == "below" && !axisrotated) || (type == "x" && overlayRange == "above" && !axisrotated) || (type == "y" && overlayRange == "above" && axisrotated) || (type == "x" && overlayRange == "below" && axisrotated)) {
                color.push(seriescolor)
            }
            
            for (var i = 0; i < thValues.length; i++) {
                var index = origValues.indexOf(thValues[i])
                color.push((negthClr == null || negthClr[index] == null) ? (defaultColor ? seriescolor : "black") : negthClr[index])
            }
            if ((type == "y" && overlayRange == "above" && !axisrotated) || (type == "x" && overlayRange == "below" && !axisrotated) || (type == "y" && overlayRange == "below" && axisrotated) || (type == "x" && overlayRange == "above" && axisrotated)) {
                color.push(seriescolor)
            }
            var offset = [];
            
            for (var i = 0; i < percent.length; i++) {
                var obj = {}
                obj.offset = percent[i] + "%";
                obj.color = ((i % 2) == 0) ? color[i / 2] : color[(i - 1) / 2]
                offset.push(obj)
            }
            
            var thresholdProp = {};
            thresholdProp.type = "thresholdLinear";
            thresholdProp.options = {};
            var options = thresholdProp.options;
            
            var scale_x = (!axisrotated) ? chartObj.axes.x.scale : chartObj.axes.y.groups[0].scale;
            var scale_y = (!axisrotated) ? chartObj.axes.y.groups[0].scale : chartObj.axes.x.scale;
            var isHorizontal = (type == "x" && !axisrotated) || (type == "y" && axisrotated);
            
            options.x1 = isHorizontal ? scale_x(scale_x.domain()[0]) : 0;
            options.x2 = isHorizontal ? scale_x(scale_x.domain()[scaleDomainLength - 1]) : 0;
            options.y1 = isHorizontal ? 0 : scale_y(scale_y.domain()[scaleDomainLength - 1]);
            options.y2 = isHorizontal ? 0 : scale_y(scale_y.domain()[0]);
            options.values = thValues;
            options.color = color;
            options.seriesclr = seriescolor;
            options.overlayRange = overlayRange;
            
            /*
             * Mandatory - The gradient ID should be changed whenever the scale domain is changing on scroll
             * test case : scroll-03.json
             */
            var domain = (isHorizontal ? scale_x : scale_y).domain();
            options.scale = domain[0] + "_" + domain[1];
            
            /**
             * This bellow two lines for passing stroke or fill opacity for area and line chart
             */
            
            var rendererMode = chartObj.plot.renderer.mode,
                chartName = chartObj.chartTypes[temp].name,
                plotOptions = chartObj.systemConf.chart.plot.plotoptions[chartName],
                opacity = (chartName === "line") ? plotOptions.strokeOpacity : plotOptions.fillOpacity,
                gradientDim = [options.x1, options.x2, options.y1, options.y2],
                prop = getGradientProp(thresholdProp,gradientDim,color,opacity),
                args = {"offset":chartName, "chartObj":chartObj, "offset":offset, "dimension":gradientDim, "color":color};
            var gradientID = (rendererMode == "svg") ? effects.get(svg_gradients, "svgGradientFill", prop, args) : effects.get(canvas_gradients, "canvasGradientFill", prop, args);
                
            return (rendererMode == "svg") ?  "url(" + chartObj.defsLocation + "#" + gradientID + ")" : gradientID;
        }
    }
};