//$Id$
function getAnimationConf(commonPlotOptions, plotoptions, chartObj, chartType) {
    var animationOptions = (plotoptions && plotoptions.animation) ? mergeJSON(commonPlotOptions.animation, plotoptions.animation, true) : commonPlotOptions.animation,
        globalAnimation = chartObj.systemConf.chart.plot.animation,
        obj = {};

    if (isHiddenDocument() || chartObj.isHiddenCoainer) {
        obj.enabled = false;
    } else {
        obj.enabled = datacount_based_intelligence(chartObj, "animation") ?
            getValByPriority([animationOptions, globalAnimation], "enabled") :
            false;
    }
    obj.type = animationOptions.type;
    obj.easingType = animationOptions.easingType || globalAnimation.easingType || (/(scatter|bubble$|packedbubble|heatmap)/.test(chartType) ? "cubic-in-out" : null) || "linear"; //bubble$ - bubblepie chart shouldnot pass this case
    obj.duration = !obj.enabled ? 0 : validateNullVal(animationOptions.duration, +(globalAnimation.duration || defaultDuration()));
    return obj;
    
    function defaultDuration() {
        return /(bar|bullet|gantt)/.test(chartType) ? 300 :
            /(line|area|arearange)/.test(chartType) ? 600 :
                /(scatter|bubble$|funnel|pyramid|heatmap)/.test(chartType) ? 1000 //bubble$ - bubblepie chart shouldnot pass this case
                    :
                    500;
    }
}

function interTween(baseData, basedataShift, serData, categories, animationType, easingType, transitionDuration, rp, layout, eleEnter, chartName) {
    var isPointTween = (animationType == "pointTween");
    var dataset = rp.dataset,
        yaxiscolumnorder = rp.yaxiscolumnorder;
    var count = isPointTween ? 0 : -1;
    var len = serData.length;
    var interTweenDuration = (transitionDuration - (17 * categories.length - 1));
    var duration = mathRound(interTweenDuration / (isPointTween ? (categories.length - 1) : len));
    tween();
    
    function tween() {
        count++;
        if (isPointTween) {
            for (var j = 0; j < len; j++) {
                baseData[j] = serData[(j < count) ? j : mathMax(0, count - 1)];
                basedataShift[j] = serData[(j < count) ? j : count];
            }
        } else {
            baseData[count - 1] = serData[count - 1];
            basedataShift[count] = serData[count];
        }
        if (count < len) {
            var del = ((count == 1 && isPointTween) ? (categories.indexOf(dataset.getX(serData[0])) - (count - 1)) * duration : 0),
                dur = ((isPointTween ? (categories.indexOf(dataset.getX(serData[count])) - categories.indexOf(dataset.getX(serData[count - 1]))) : 1) * duration),
                notNull = isPointTween ? (dataset.getY(serData[count], yaxiscolumnorder) != null && dataset.getY(serData[mathMax(0, count - 1)], yaxiscolumnorder) != null) : (dataset.getY(serData[count], yaxiscolumnorder) != null);
            if (notNull) {
                eleEnter
                    .attr(layout(baseData))
                    .transition()
                    .delay(del)
                    .duration(dur)
                    .ease(easingType)
                    .attr(layout(basedataShift))
                    .each("end", (chartName === "scatter") ?
                        
                        function(d, j) {
                            if (j == len - 1) {
                                tween();
                            }
                        } :
                        tween);
            } else {
                tween();
            }
        }
    }
}

function flipTween(element) {
    var rad = d3_interpolate(0, mathPI);
    element.attrTween("transform", function() {
        var transform = d3_select(this).attr("transform");
        return function(t) {
            return transform + " matrix(" + mathCos(rad(t)) + ",0,0,1,0,0)";
        };
    });
}

function fadeTween(element) {
    var opacity = d3_interpolate(0, 1);
    element.styleTween("opacity", function() {
        return function(t) {
            return opacity(t);
        };
    });
}

function scaleTween(element) {
    var scale = d3_interpolate(0, 1);
    element.attrTween("transform", function() {
        var transform = d3_select(this).attr("transform");
        return function(t) {
            return transform + " scale(" + scale(t) + ")";
        };
    });
}

function cancelAnimation(element) {
    element
        .interrupt();
}
