//$Id$
function appendEle(parentNode, nodeName, data, selector, selectorAttr, selectorVal, styleObj) {
    selector = selector || "";
    selectorVal = selectorVal || "";
    
    var node = parentNode
        .selectAll(nodeName + selector + selectorVal)
        .data(data);
    var nodeEnter = node
        .enter()
        .append(nodeName);
    if (selectorAttr) {
        nodeEnter.attr(selectorAttr, selectorVal);
    }
    if (styleObj) {
        nodeEnter.style(styleObj);
    }
    node.exit().remove();
    return node;
}

function trimText(textObj, text, textBounds, edge, orient, pattern, marginValue, max, parent, deepTrim) {
    if (text == null || !text.trim() || !textObj) { //#ZC676
        return text;
    }
    var maxWidth, maxHeight;
    parent = parent || textObj;
    if (max) {
        maxWidth = max.width;
        maxHeight = max.height;
    } else {
        maxWidth = edge.right - edge.left;
        maxHeight = edge.bottom - edge.top;
    }
    // var textBounds = textObj.getBoundingClientRect()
    var overflowLength = 0;
    
    if (orient == "left" || orient == "right") {
        if ((textBounds.top + textBounds.height - marginValue.bottom) > edge.bottom) {
            overflowLength += ((textBounds.top + textBounds.height - marginValue.bottom) - (edge.bottom)) / (textBounds.height)
        }
        if ((textBounds.top + marginValue.top) < edge.top) {
            overflowLength += ((edge.top - (textBounds.top + marginValue.top)) / (textBounds.height))
        }
        maxHeight = textBounds.height -
            mathMax(0, ((textBounds.top + textBounds.height - marginValue.bottom) - (edge.bottom))) -
            mathMax(0, (edge.top - (textBounds.top + marginValue.top)));
    } else if (orient == "bottom" || orient == "top") {
        if ((textBounds.left + textBounds.width - marginValue.right) > edge.right) {
            overflowLength += ((textBounds.left + textBounds.width - marginValue.right) - (edge.right)) / (textBounds.width)
        }
        if ((textBounds.left + marginValue.left) < edge.left) {
            overflowLength += (edge.left - (textBounds.left + marginValue.left)) / (textBounds.width)
        }
        maxWidth = textBounds.width -
            mathMax(0, ((textBounds.left + textBounds.width - marginValue.right) - edge.right)) -
            mathMax(0, (edge.left - (textBounds.left + marginValue.left)));
    }
    if (overflowLength > 0) {
        var croppedTextLength = mathCeil((1 - overflowLength) * (text.length))
        textObj.textContent = text.substring(0, croppedTextLength - 1) + pattern;
        
        var newTextBounds = parent.getBoundingClientRect();
        deepTrim = (textObj.nodeName == "tspan") ? false : deepTrim; //TODO
        if ((deepTrim !== false) && ((newTextBounds.width != textBounds.width) || (newTextBounds.height != textBounds.height))) {
            naiveEllipsis(textObj, parent, text, maxWidth, maxHeight, newTextBounds, pattern);
        }
    }
    
}

function wordWrap(text, width, height) {
    text.each(function() {
        var text = d3_select(this),
            words = text.text().split(/\s+/).reverse(),
            word,
            line = [],
            lineNumber = 0,
            lineHeight = 1.1, // ems
            y = text.attr("y"),
            dy = parseFloat(text.attr("dy")),
            tspan = text.text(null).append("tspan").attr("x", 0).attr("y", y).attr("dy", dy + "em");
        while (word = words.pop()) {
            line.push(word);
            tspan.text(line.join(" "));
            if (tspan.node().getComputedTextLength() > width) {
                line.pop();
                tspan.text(line.join(" "));
                line = [word];
                tspan = text.append("tspan").attr("x", 0).attr("y", y).attr("dy", ++lineNumber * lineHeight + dy + "em").text(word);
            }
        }
    });
}


function roundedRect(x, y, w, h, r, yReversed, axisrotated) {
    var x1, x2, y1, y2;
    x1 = ((yReversed && axisrotated) ? x - w : x), x2 = ((yReversed && axisrotated) ? x : x + w), //x1,y1 should be at top left . x2,y2 should be at bottom right .
        y1 = (yReversed && !axisrotated) ? y - h : y, y2 = (yReversed && !axisrotated) ? y : y + h,
        r = checkRadiusWithinBoundary(r, w, h)
    
    return "M" + x1 + "," + (y2 - r.bly) +
        "L" + x1 + "," + (y1 + r.tly) +
        "A" + (r.tlx + "," + r.tly + " 0 0 1 " + (x1 + r.tlx) + "," + y1) +
        "L" + (x2 - r.trx) + "," + (y1) +
        "A" + (r.trx + "," + r.trY + " 0 0 1 " + (x2) + "," + (y1 + r.trY)) +
        "L" + (x2) + "," + (y2 - r.bry) +
        "A" + (r.brx + "," + r.bry + " 0 0 1 " + (x2 - r.brx) + "," + (y2)) +
        "L" + (x1 + r.blx) + "," + (y2) +
        "A" + (r.blx + "," + r.bly + " 0 0 1 " + (x1) + "," + (y2 - r.bly))
        + "Z";
    
    function checkRadiusWithinBoundary(r, width, height) {
        var radius = Object.create(r)
        var top = radius.tlx + radius.trx,
            right = radius.trY + radius.bry,
            bottom = radius.brx + radius.blx,
            left = radius.tly + radius.bly;
        
        var z;
        
        if (height < left) {
            z = (left) / (left - height)
            radius.tly = (radius.tly - (radius.tly / z)), radius.bly = (radius.bly - (radius.bly / z))
        }
        if (width < top) {
            z = (top) / (top - width)
            radius.tlx = (radius.tlx - (radius.tlx / z)), radius.trx = (radius.trx - (radius.trx / z))
        }
        if (height < right) {
            z = (right) / (right - height)
            radius.trY = (radius.trY - (radius.trY / z)), radius.bry = (radius.bry - (radius.bry / z))
        }
        if (width < bottom) {
            z = (bottom) / (bottom - width)
            radius.brx = (radius.brx - (radius.brx / z)), radius.blx = (radius.blx - (radius.blx / z))
        }
        return radius
    }
    
}

function applyFont(ele, hierarchy, html) {
    var fSize = $ZC.utils.getVal(getValByPriority(hierarchy, "fontSize")),
        fFamily = getValByPriority(hierarchy, "fontFamily"),
        fWeight = getValByPriority(hierarchy, "fontWeight"),
        fStyle = getValByPriority(hierarchy, "fontStyle"),
        fShadow = getValByPriority(hierarchy, "textShadow"),
        fColor = getValByPriority(hierarchy, "fontColor"),
        txtDec = getValByPriority(hierarchy, "textDecoration"),
        strokeColor = getValByPriority(hierarchy, "strokeColor");
    
    var styleObj = {
        "font-size": fSize + "px",
        "font-family": fFamily,
        "font-weight": fWeight,
        "font-style": fStyle,
        "text-shadow": fShadow,
        "text-decoration": txtDec
    };
    
    if (defined(ele)) {
        styleObj[html ? "color" : "fill"] = fColor;
        if(!html && strokeColor && !$Browser.IE) {
            styleObj.stroke = strokeColor;
            styleObj["stroke-width"] = getValByPriority(hierarchy, "strokeWidth") || 3;
            styleObj["paint-order"] = "stroke";
        }
        ele.style(styleObj);
    } else {
        styleObj.color = fColor;
        return styleObj;
    }
}

function addSVGtitleEle(textEle) {
    textEle.append("title")
        .text(function() {
            return this.parentNode.textContent;
        });
}

function naiveEllipsis(textNode, parent, origTextContent, maxWidth, maxHeight, textBounds, pattern) {
    /*
     * If bound is less than the max, traverse from current length to original length and update the textContent
     * Else traverse from current length to 0 and update the textContent
     */
    var index = textNode.textContent.length - 1,
        textBound,
        pattern_length = pattern.length;
    if ((textBounds.width > maxWidth) || (textBounds.height > maxHeight)) {
        var end = 0;
        while (index >= end) {
            changeTextContent(true);
            if ((textBounds.width <= maxWidth) && (textBounds.height <= maxHeight)) {
                return;
            }
            index--;
        }
    } else {
        var end = origTextContent.length;
        while (index < end) {
            // changeTextContent();
            if ((textBounds.width >= maxWidth) || (textBounds.height >= maxHeight)) {
                index--;
                changeTextContent(false);
                return;
            }
            index++;
        }
    }
    
    function changeTextContent(updateBound) {
        /*
         * This will change the textContent based on 'index' value
         * And update 'textBound' with new text bound if 'dontUpdateBound' is not true
         */
        textNode.textContent = origTextContent.substring(0, index - pattern_length) + pattern;
        if (updateBound) {
            textBounds = parent.getBoundingClientRect();
        }
    }
}

function parseSVGPath(path) {
    var arr = path.match(/[a-z][^a-z]*/ig);
    return arr.map(function(d) {
        var func = d.match(/[a-z]/ig).pop();
        var moves = d.match(/-?[0-9]\d*(\.\d+)?/g);
        if (moves) {
            moves = moves.map(function(m) {
                return parseFloat(m);
            });
        }
        return {
            "function": func,
            "moves": moves
        }
    });
}

function wrapTextContent(node, text, prop, useHTML) {
    var isMultiLine = isArray(text) && text.length > 1,
        printProperty = useHTML ? "html" : "text",
        parentGroup = d3.select(node.node().parentNode);

    if(isMultiLine) {
        node.text(null);
        var lineNumber = 0, lineHeight = (defined(prop) && defined(prop.lineHeight)) ? prop.lineHeight : 0.71 ;
        var x = node.attr("x") || 0, y = node.attr("y") || 0;
        text.forEach(function(el) {
            if (useHTML) {
                insertSVGEle(parentGroup, node, el);
            } else {
                var tspan = node.append("tspan");
                tspan.attr("x", x)
                    .attr("y", y)
                    .attr("dy", function(d, i) {
                        return ((lineNumber++) + lineHeight) + "em";
                    });

                tspan[printProperty](function() {
                    return el;
                });
            }
        })
    } else {
        if (useHTML) {
            node.text(null);
            insertSVGEle(parentGroup, node, text)
        } else {
            node[printProperty](text)
        }
    }
    return node;
}


function insertSVGEle(parent, textNode, child) {
    var imageRegex = /^<image.+<\/image>/i,
        tspanRegex= /^<tspan.+<\/tspan>/i;

    if (imageRegex.test(child)) {
        appendEle(parent, "g", [1], ".", "class", "image").html(child);
    } else if (tspanRegex.test(child)) {
        var doc = new DOMParser().parseFromString('<svg xmlns="' + d3.ns.prefix.svg + '">' + child + '</svg>', 'application/xml');
        textNode.node().appendChild(doc.querySelector("tspan"));
    } else {
        textNode.append("tspan").text(child);
    }
}


function getTextContent(textNode){
    var tspan = textNode.selectAll("tspan")[0];
    if(tspan.length){
        var arr = [];
        tspan.forEach(function(d){
            arr.push(d.textContent);
        })
        return arr;
    }else{
        return textNode.node().textContent;
    }
}



