//$Id$
(function(root) {
    // "use strict";
    var $ZC = {};
    $ZC.version = "1.0.8";
    $ZC.versionName = "Euclid";
    $ZC.d3Version = "3.4.8";
    /*
     * Initiate  functions
     */
    $ZC.model = function() {};
    $ZC.axis = function() {};
    $ZC.legend = function() {};
    $ZC.renderer = function() {};
    $ZC.dataset = function() {};
    $ZC.scale = function() {};
    $ZC.events = function() {};
    $ZC.plot = function() {};
    $ZC.plot.canvas = function() {};
    /*
     * Constants
     */
    $ZC.charttype = {};
    var line = $ZC.charttype.line = 11,
        pie = $ZC.charttype.pie = 8,
        bar = $ZC.charttype.bar = 9,
        stkdbar = $ZC.charttype.stkdbar = 10,
        scatter = $ZC.charttype.scatter = 12,
        area = $ZC.charttype.area = 14,
        stkdarea = $ZC.charttype.stkdarea = 15,
        bubble = $ZC.charttype.bubble = 20,
        packedbubble = $ZC.charttype.packedbubble = 19,
        funnel = $ZC.charttype.funnel = 7,
        web = $ZC.charttype.web = 16,
        sunburst = $ZC.charttype.sunburst = 17,
        pyramid = $ZC.charttype.pyramid = 13,
        dial = $ZC.charttype.dial = 18,
        bullet = $ZC.charttype.bullet = 6,
        arearange = $ZC.charttype.arearange = 21,
        bubblepie = $ZC.charttype.bubblepie = 5,
        gantt = $ZC.charttype.gantt = 24,
        treemap = $ZC.charttype.treemap = 4,
        heatmap = $ZC.charttype.heatmap = 3,
        dotgrid = $ZC.charttype.dotgrid = 26;
    $ZC.charttypenames = d3.map();
    $ZC.charttypenames.set($ZC.charttype.line, "line");
    $ZC.charttypenames.set($ZC.charttype.pie, "pie");
    $ZC.charttypenames.set($ZC.charttype.bar, "bar");
    $ZC.charttypenames.set($ZC.charttype.stkdbar, "bar");
    $ZC.charttypenames.set($ZC.charttype.scatter, "scatter");
    $ZC.charttypenames.set($ZC.charttype.area, "area");
    $ZC.charttypenames.set($ZC.charttype.funnel, "funnel");
    $ZC.charttypenames.set($ZC.charttype.web, "web");
    $ZC.charttypenames.set($ZC.charttype.stkdarea, "area");
    $ZC.charttypenames.set($ZC.charttype.sunburst, "sunburst");
    $ZC.charttypenames.set($ZC.charttype.pyramid, "pyramid");
    $ZC.charttypenames.set($ZC.charttype.bubble, "bubble");
    $ZC.charttypenames.set($ZC.charttype.dial, "dial");
    $ZC.charttypenames.set($ZC.charttype.packedbubble, "packedbubble");
    $ZC.charttypenames.set($ZC.charttype.bullet, "bullet");
    $ZC.charttypenames.set($ZC.charttype.arearange, "arearange");
    $ZC.charttypenames.set($ZC.charttype.gantt, "gantt");
    $ZC.charttypenames.set($ZC.charttype.bubblepie, "bubblepie");
    $ZC.charttypenames.set($ZC.charttype.treemap, "treemap");
    $ZC.charttypenames.set($ZC.charttype.heatmap, "heatmap");
    $ZC.charttypenames.set($ZC.charttype.dotgrid, "dotgrid");

    //ALLOWED CHARTS
    $ZC.chartcategory = {};
    $ZC.chartcategory.axis = [line, area, scatter, stkdarea, bar, stkdbar, bubble, bullet, arearange, bubblepie, gantt, heatmap];
    $ZC.chartcategory.nonaxis = [pie, funnel, pyramid, dial, dotgrid];
    $ZC.chartcategory.nonaxismultiseries = [web, sunburst, packedbubble, treemap];
    $ZC.chartcategory.hierarchy = [packedbubble,sunburst, treemap];
    $ZC.chartcategory.continous = [line, area, scatter, stkdarea,bubble,arearange,bubblepie];
    $ZC.chartcategory.discrete = [pie, bar, stkdbar, sunburst,funnel,pyramid,dial, bullet, gantt, heatmap];
    $ZC.chartcategory.dotPlot = [scatter, bubble];
    $ZC.chartcategory.piePlot = [pie, bubblepie];

    //The main object can be renamed by calling this method by passing a customized object name.
    $ZC.rename = function(newObjName) {
        if (newObjName != null && newObjName != "" && typeof newObjName === 'string') {
            root[newObjName] = $ZC;
            root.$ZC = null;
            delete root.$ZC;
            return true; // renamed successfully
        }
        return false; // rename failed.
    };
    
    $ZC.setLegendColorPallete = function(name, value) {
        $ZC.legutil.colorpallete.set(name, value);
    };
    
    $ZC.getLegendColorPallete = function(name) {
        return $ZC.legutil.colorpallete.get(name);
    };
    
    $ZC.setLegendPatternPallete = function(name, value) {
        $ZC.legutil.patternPallete.set(name, value);
    };
    
    $ZC.getLegendPatternPallete = function(name) {
        return $ZC.legutil.patternPallete.get(name);
    };

    $ZC.setLegendImagePallete = function(name, value) {
        $ZC.legutil.imagePallete.set(name, value);
    };
    
    $ZC.getLegendImagePallete = function(name) {
        return $ZC.legutil.imagePallete.get(name);
    };
    
    $ZC.setTheme = function(name, value) {
        $ZC[name] = value;
    };
    
    $ZC.getTheme = function(name) {
        return $ZC[name];
    };
    
    /**
     * Common functions and variables
     */
    
    var svg_plot_renderer = {},
        renderer_helpers = {},
        dataLabel_handler = {},
        datalabelsBoundBox_handler = {},
        patternPalleteTemplates = {};
    
    
    // constants
    var CUSTOM_VALUE_PATTERN = /\{\{val\((\d+)\)\}\}|\{\{col\((\d+)\)\}\}|\{\{per\((\d+)\)\}\}|\{\{splitper\((\d+)\)\}\}|\{\{clr\}\}/gi, // regxr
        RGBA_PATTERN = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/i,
        PERCENT_PATTERN = /\{\{per\((\d+)\)\}\}|\{\{splitper\((\d+)\)\}\}/gi,
        Console = window.console,
        tempCanvasContext = document.createElement("canvas").getContext("2d");
//$Id$
(function () {
	var node_each = function(callback) {
	  var node = this, current, next = [node], children, i, n;
	  do {
	    current = next.reverse(), next = [];
	    while (node = current.pop()) {
	      callback(node), children = node.children;
	      if (children) {
	      	for (i = 0, n = children.length; i < n; ++i) {
		        next.push(children[i]);
		    }
		  }
	    }
	  } while (next.length);
	  return this;
	};

	var node_eachBefore = function(callback) {
	  var node = this, nodes = [node], children, i;
	  while (node = nodes.pop()) {
	    callback(node), children = node.children;
	    if (children) {
	    	for (i = children.length - 1; i >= 0; --i) {
		      nodes.push(children[i]);
		    }
		}
	  }
	  return this;
	};

	var node_eachAfter = function(callback) {
	  var node = this, nodes = [node], next = [], children, i, n;
	  while (node = nodes.pop()) {
	    next.push(node), children = node.children;
	    if (children) {
	    	for (i = 0, n = children.length; i < n; ++i) {
		      nodes.push(children[i]);
		    }
		}
	  }
	  while (node = next.pop()) {
	    callback(node);
	  }
	  return this;
	};

	var node_sum = function(value) {
	  return this.eachAfter(function(node) {
	    var sum = +value(node.data) || 0,
	        children = node.children,
	        i = children && children.length;
	    while (--i >= 0) {
	    	sum += children[i].value;
	    }
	    node.value = sum;
	  });
	};

	var node_sort = function(compare) {
	  return this.eachBefore(function(node) {
	    if (node.children) {
	      node.children.sort(compare);
	    }
	  });
	};

	var node_descendants = function() {
	  var nodes = [];
	  this.each(function(node) {
	    nodes.push(node);
	  });
	  return nodes;
	};

	var hierarchy = d3.hierarchy = function hierarchy(data, children) {
	  var root = new Node(data),
	      valued = +data.value && (root.value = data.value),
	      node,
	      nodes = [root],
	      child,
	      childs,
	      i,
	      n;

	  if (children == null) {
	  	children = defaultChildren;
	  }

	  while (node = nodes.pop()) {
	    if (valued) {
	    	node.value = +node.data.value;
	    }
	    if ((childs = children(node.data)) && (n = childs.length)) {
	      node.children = new Array(n);
	      for (i = n - 1; i >= 0; --i) {
	        nodes.push(child = node.children[i] = new Node(childs[i]));
	        child.parent = node;
	        child.depth = node.depth + 1;
	      }
	    }
	  }

	  return root.eachBefore(computeHeight);
	}

	function defaultChildren(d) {
	  return d.children;
	}

	function computeHeight(node) {
	  var height = 0;
	  do {
	  	node.height = height;
	  }while ((node = node.parent) && (node.height < ++height));
	}

	function Node(data) {
	  this.data = data;
	  this.depth =
	  this.height = 0;
	  this.parent = null;
	}

	Node.prototype = hierarchy.prototype = {
	  constructor: Node,
	  each: node_each,
	  eachAfter: node_eachAfter,
	  eachBefore: node_eachBefore,
	  sum: node_sum,
	  sort: node_sort,
	  descendants: node_descendants
	};

	function Node$2(value) {
	  this._ = value;
	  this.next = null;
	}

	var shuffle$1 = function(array) {
	  var i,
	      n = (array = array.slice()).length,
	      head = null,
	      node = head;

	  while (n) {
	    var next = new Node$2(array[n - 1]);
	    if (node) {
	    	node = node.next = next;
	    } else {
	    	node = head = next;
	    }
	    array[i] = array[--n];
	  }

	  return {
	    head: head,
	    tail: node
	  };
	};

	var enclose = function(circles) {
	  return encloseN(shuffle$1(circles), []);
	};

	function encloses(a, b) {
	  var dx = b.x - a.x,
	      dy = b.y - a.y,
	      dr = a.r - b.r;
	  return dr * dr + 1e-6 > dx * dx + dy * dy;
	}

	// Returns the smallest circle that contains circles L and intersects circles B.
	function encloseN(L, B) {
	  var circle,
	      l0 = null,
	      l1 = L.head,
	      l2,
	      p1;

	  switch (B.length) {
	    case 1: circle = enclose1(B[0]); break;
	    case 2: circle = enclose2(B[0], B[1]); break;
	    case 3: circle = enclose3(B[0], B[1], B[2]); break;
	  }

	  while (l1) {
	    p1 = l1._, l2 = l1.next;
	    if (!circle || !encloses(circle, p1)) {

	      // Temporarily truncate L before l1.
	      if (l0) {
	      	L.tail = l0, l0.next = null;
	      } else {
	      	L.head = L.tail = null;
	      }

	      B.push(p1);
	      circle = encloseN(L, B); // Note: reorders L!
	      B.pop();

	      // Move l1 to the front of L and reconnect the truncated list L.
	      if (L.head) {
	      	l1.next = L.head, L.head = l1;
	      } else {
	      	l1.next = null, L.head = L.tail = l1;
	      }
	      l0 = L.tail, l0.next = l2;

	    } else {
	      l0 = l1;
	    }
	    l1 = l2;
	  }

	  L.tail = l0;
	  return circle;
	}

	function enclose1(a) {
	  return {
	    x: a.x,
	    y: a.y,
	    r: a.r
	  };
	}

	function enclose2(a, b) {
	  var x1 = a.x, y1 = a.y, r1 = a.r,
	      x2 = b.x, y2 = b.y, r2 = b.r,
	      x21 = x2 - x1, y21 = y2 - y1, r21 = r2 - r1,
	      l = Math.sqrt(x21 * x21 + y21 * y21);
	  return {
	    x: (x1 + x2 + x21 / l * r21) / 2,
	    y: (y1 + y2 + y21 / l * r21) / 2,
	    r: (l + r1 + r2) / 2
	  };
	}

	function enclose3(a, b, c) {
	  var x1 = a.x, y1 = a.y, r1 = a.r,
	      x2 = b.x, y2 = b.y, r2 = b.r,
	      x3 = c.x, y3 = c.y, r3 = c.r,
	      a2 = 2 * (x1 - x2),
	      b2 = 2 * (y1 - y2),
	      c2 = 2 * (r2 - r1),
	      d2 = x1 * x1 + y1 * y1 - r1 * r1 - x2 * x2 - y2 * y2 + r2 * r2,
	      a3 = 2 * (x1 - x3),
	      b3 = 2 * (y1 - y3),
	      c3 = 2 * (r3 - r1),
	      d3 = x1 * x1 + y1 * y1 - r1 * r1 - x3 * x3 - y3 * y3 + r3 * r3,
	      ab = a3 * b2 - a2 * b3,
	      xa = (b2 * d3 - b3 * d2) / ab - x1,
	      xb = (b3 * c2 - b2 * c3) / ab,
	      ya = (a3 * d2 - a2 * d3) / ab - y1,
	      yb = (a2 * c3 - a3 * c2) / ab,
	      A = xb * xb + yb * yb - 1,
	      B = 2 * (xa * xb + ya * yb + r1),
	      C = xa * xa + ya * ya - r1 * r1,
	      r = (-B - Math.sqrt(B * B - 4 * A * C)) / (2 * A);
	  return {
	    x: xa + xb * r + x1,
	    y: ya + yb * r + y1,
	    r: r
	  };
	}

	function place(a, b, c) {
	  var ax = a.x,
	      ay = a.y,
	      da = b.r + c.r,
	      db = a.r + c.r,
	      dx = b.x - ax,
	      dy = b.y - ay,
	      dc = dx * dx + dy * dy;
	  if (dc) {
	    var x = 0.5 + ((db *= db) - (da *= da)) / (2 * dc),
	        y = Math.sqrt(Math.max(0, 2 * da * (db + dc) - (db -= dc) * db - da * da)) / (2 * dc);
	    c.x = ax + x * dx + y * dy;
	    c.y = ay + x * dy - y * dx;
	  } else {
	    c.x = ax + db;
	    c.y = ay;
	  }
	}

	function intersects(a, b) {
	  var dx = b.x - a.x,
	      dy = b.y - a.y,
	      dr = a.r + b.r;
	  return dr * dr - 1e-6 > dx * dx + dy * dy;
	}

	function distance2(node, x, y) {
	  var a = node._,
	      b = node.next._,
	      ab = a.r + b.r,
	      dx = (a.x * b.r + b.x * a.r) / ab - x,
	      dy = (a.y * b.r + b.y * a.r) / ab - y;
	  return dx * dx + dy * dy;
	}

	function Node$1(circle) {
	  this._ = circle;
	  this.next = null;
	  this.previous = null;
	}

	function packEnclose(circles) {
	  if (!(n = circles.length)) {
	  	return 0;
	  }

	  var a, b, c, n;

	  // Place the first circle.
	  a = circles[0], a.x = 0, a.y = 0;
	  if (!(n > 1)) {
	  	return a.r;
	  }

	  // Place the second circle.
	  b = circles[1], a.x = -b.r, b.x = a.r, b.y = 0;
	  if (!(n > 2)) {
	  	return a.r + b.r;
	  }

	  // Place the third circle.
	  place(b, a, c = circles[2]);

	  // Initialize the weighted centroid.
	  var aa = a.r * a.r,
	      ba = b.r * b.r,
	      ca = c.r * c.r,
	      oa = aa + ba + ca,
	      ox = aa * a.x + ba * b.x + ca * c.x,
	      oy = aa * a.y + ba * b.y + ca * c.y,
	      cx, cy, i, j, k, sj, sk;

	  // Initialize the front-chain using the first three circles a, b and c.
	  a = new Node$1(a), b = new Node$1(b), c = new Node$1(c);
	  a.next = c.previous = b;
	  b.next = a.previous = c;
	  c.next = b.previous = a;

	  // Attempt to place each remaining circle…
	  pack: for (i = 3; i < n; ++i) {
	    place(a._, b._, c = circles[i]), c = new Node$1(c);

	    // Find the closest intersecting circle on the front-chain, if any.
	    // “Closeness” is determined by linear distance along the front-chain.
	    // “Ahead” or “behind” is likewise determined by linear distance.
	    j = b.next, k = a.previous, sj = b._.r, sk = a._.r;
	    do {
	      if (sj <= sk) {
	        if (intersects(j._, c._)) {
	          b = j, a.next = b, b.previous = a, --i;
	          continue pack;
	        }
	        sj += j._.r, j = j.next;
	      } else {
	        if (intersects(k._, c._)) {
	          a = k, a.next = b, b.previous = a, --i;
	          continue pack;
	        }
	        sk += k._.r, k = k.previous;
	      }
	    } while (j !== k.next);

	    // Success! Insert the new circle c between a and b.
	    c.previous = a, c.next = b, a.next = b.previous = b = c;

	    // Update the weighted centroid.
	    oa += ca = c._.r * c._.r;
	    ox += ca * c._.x;
	    oy += ca * c._.y;

	    // Compute the new closest circle pair to the centroid.
	    aa = distance2(a, cx = ox / oa, cy = oy / oa);
	    while ((c = c.next) !== b) {
	      if ((ca = distance2(c, cx, cy)) < aa) {
	        a = c, aa = ca;
	      }
	    }
	    b = a.next;
	  }

	  // Compute the enclosing circle of the front chain.
	  a = [b._], c = b; 
	  while ((c = c.next) !== b) {
	  	a.push(c._);
	  }
	  c = enclose(a);

	  // Translate the circles to put the enclosing circle around the origin.
	  for (i = 0; i < n; ++i) {
	  	a = circles[i], a.x -= c.x, a.y -= c.y;
	  }

	  return c.r;
	}

	function optional(f) {
	  return f == null ? null : required(f);
	}

	function required(f) {
	  if (typeof f !== "function") {
	  	throw new Error();
	  }
	  return f;
	}

	function constantZero() {
	  return 0;
	}

	var constant$8 = function(x) {
	  return function() {
	    return x;
	  };
	};

	function defaultRadius$1(d) {
	  return Math.sqrt(d.value);
	}

	d3.pack = function() {
	  var radius = null,
	      dx = 1,
	      dy = 1,
	      padding = constantZero;

	  function pack(root) {
	    root.x = dx / 2, root.y = dy / 2;
	    if (radius) {
	      root.eachBefore(radiusLeaf(radius))
	          .eachAfter(packChildren(padding, 0.5))
	          .eachBefore(translateChild(1));
	    } else {
	      root.eachBefore(radiusLeaf(defaultRadius$1))
	          .eachAfter(packChildren(constantZero, 1))
	          .eachAfter(packChildren(padding, root.r / Math.min(dx, dy)))
	          .eachBefore(translateChild(Math.min(dx, dy) / (2 * root.r)));
	    }
	    return root;
	  }

	  pack.size = function(x) {
	    return arguments.length ? (dx = +x[0], dy = +x[1], pack) : [dx, dy];
	  };

	  pack.padding = function(x) {
	    return arguments.length ? (padding = typeof x === "function" ? x : constant$8(+x), pack) : padding;
	  };

	  return pack;
	};

	function radiusLeaf(radius) {
	  return function(node) {
	    if (!node.children) {
	      node.r = Math.max(0, +radius(node) || 0);
	    }
	  };
	}

	function packChildren(padding, k) {
	  return function(node) {
	    if (children = node.children) {
	      var children,
	          i,
	          n = children.length,
	          r = padding(node) * k || 0,
	          e;

	      if (r) {
	      	for (i = 0; i < n; ++i) {
	      		children[i].r += r;
	      	}
	      }
	      e = packEnclose(children);
	      if (r) {
	      	for (i = 0; i < n; ++i) {
	      		children[i].r -= r;
	      	}
	      }
	      node.r = e + r;
	    }
	  };
	}

	function translateChild(k) {
	  return function(node) {
	    var parent = node.parent;
	    node.r *= k;
	    if (parent) {
	      node.x = parent.x + k * node.x;
	      node.y = parent.y + k * node.y;
	    }
	  };
	}

	var pi$2 = Math.PI;
	var tau$2 = 2 * pi$2;
	var epsilon$1 = 1e-6;
	var tauEpsilon = tau$2 - epsilon$1;
	function Path() {
	  this._x0 = this._y0 = // start of current subpath
	  this._x1 = this._y1 = null; // end of current subpath
	  this._ = "";
	}

	function path() {
	  return new Path();
	}

	Path.prototype = path.prototype = {
	  constructor: Path,
	  moveTo: function(x, y) {
	    this._ += "M" + (this._x0 = this._x1 = +x) + "," + (this._y0 = this._y1 = +y);
	  },
	  closePath: function() {
	    if (this._x1 !== null) {
	      this._x1 = this._x0, this._y1 = this._y0;
	      this._ += "Z";
	    }
	  },
	  lineTo: function(x, y) {
	    this._ += "L" + (this._x1 = +x) + "," + (this._y1 = +y);
	  },
	  quadraticCurveTo: function(x1, y1, x, y) {
	    this._ += "Q" + (+x1) + "," + (+y1) + "," + (this._x1 = +x) + "," + (this._y1 = +y);
	  },
	  bezierCurveTo: function(x1, y1, x2, y2, x, y) {
	    this._ += "C" + (+x1) + "," + (+y1) + "," + (+x2) + "," + (+y2) + "," + (this._x1 = +x) + "," + (this._y1 = +y);
	  },
	  arcTo: function(x1, y1, x2, y2, r) {
	    x1 = +x1, y1 = +y1, x2 = +x2, y2 = +y2, r = +r;
	    var x0 = this._x1,
	        y0 = this._y1,
	        x21 = x2 - x1,
	        y21 = y2 - y1,
	        x01 = x0 - x1,
	        y01 = y0 - y1,
	        l01_2 = x01 * x01 + y01 * y01;

	    // Is the radius negative? Error.
	    if (r < 0) {
	    	throw new Error("negative radius: " + r);
	    }

	    // Is this path empty? Move to (x1,y1).
	    if (this._x1 === null) {
	      this._ += "M" + (this._x1 = x1) + "," + (this._y1 = y1);
	    }

	    // Or, is (x1,y1) coincident with (x0,y0)? Do nothing.
	    else if (!(l01_2 > epsilon$1)) {
	    	var dummy = true; //dummy comment
	    }

	    // Or, are (x0,y0), (x1,y1) and (x2,y2) collinear?
	    // Equivalently, is (x1,y1) coincident with (x2,y2)?
	    // Or, is the radius zero? Line to (x1,y1).
	    else if (!(Math.abs(y01 * x21 - y21 * x01) > epsilon$1) || !r) {
	      this._ += "L" + (this._x1 = x1) + "," + (this._y1 = y1);
	    }

	    // Otherwise, draw an arc!
	    else {
	      var x20 = x2 - x0,
	          y20 = y2 - y0,
	          l21_2 = x21 * x21 + y21 * y21,
	          l20_2 = x20 * x20 + y20 * y20,
	          l21 = Math.sqrt(l21_2),
	          l01 = Math.sqrt(l01_2),
	          l = r * Math.tan((pi$2 - Math.acos((l21_2 + l01_2 - l20_2) / (2 * l21 * l01))) / 2),
	          t01 = l / l01,
	          t21 = l / l21;

	      // If the start tangent is not coincident with (x0,y0), line to.
	      if (Math.abs(t01 - 1) > epsilon$1) {
	        this._ += "L" + (x1 + t01 * x01) + "," + (y1 + t01 * y01);
	      }

	      this._ += "A" + r + "," + r + ",0,0," + (+(y01 * x20 > x01 * y20)) + "," + (this._x1 = x1 + t21 * x21) + "," + (this._y1 = y1 + t21 * y21);
	    }
	  },
	  arc: function(x, y, r, a0, a1, ccw) {
	    x = +x, y = +y, r = +r;
	    var dx = r * Math.cos(a0),
	        dy = r * Math.sin(a0),
	        x0 = x + dx,
	        y0 = y + dy,
	        cw = 1 ^ ccw,
	        da = ccw ? a0 - a1 : a1 - a0;

	    // Is the radius negative? Error.
	    if (r < 0) {
	    	throw new Error("negative radius: " + r);
	    }

	    // Is this path empty? Move to (x0,y0).
	    if (this._x1 === null) {
	      this._ += "M" + x0 + "," + y0;
	    }

	    // Or, is (x0,y0) not coincident with the previous point? Line to (x0,y0).
	    else if (Math.abs(this._x1 - x0) > epsilon$1 || Math.abs(this._y1 - y0) > epsilon$1) {
	      this._ += "L" + x0 + "," + y0;
	    }

	    // Is this arc empty? We’re done.
	    if (!r) {
	    	return;
	    }

	    // Does the angle go the wrong way? Flip the direction.
	    if (da < 0) {
	    	da = da % tau$2 + tau$2;
	    }

	    // Is this a complete circle? Draw two arcs to complete the circle.
	    if (da > tauEpsilon) {
	      this._ += "A" + r + "," + r + ",0,1," + cw + "," + (x - dx) + "," + (y - dy) + "A" + r + "," + r + ",0,1," + cw + "," + (this._x1 = x0) + "," + (this._y1 = y0);
	    }

	    // Is this arc non-empty? Draw an arc!
	    else if (da > epsilon$1) {
	      this._ += "A" + r + "," + r + ",0," + (+(da >= pi$2)) + "," + cw + "," + (this._x1 = x + r * Math.cos(a1)) + "," + (this._y1 = y + r * Math.sin(a1));
	    }
	  },
	  rect: function(x, y, w, h) {
	    this._ += "M" + (this._x0 = this._x1 = +x) + "," + (this._y0 = this._y1 = +y) + "h" + (+w) + "v" + (+h) + "h" + (-w) + "Z";
	  },
	  toString: function() {
	    return this._;
	  }
	};
	var constant$10 = function(x) {
	  return function constant() {
	    return x;
	  };
	};

	var abs$1 = Math.abs;
	var atan2$1 = Math.atan2;
	var cos$2 = Math.cos;
	var max$2 = Math.max;
	var min$1 = Math.min;
	var sin$2 = Math.sin;
	var sqrt$2 = Math.sqrt;

	var epsilon$3 = 1e-12;
	var pi$4 = Math.PI;
	var halfPi$3 = pi$4 / 2;
	var tau$4 = 2 * pi$4;

	function acos$1(x) {
	  return x > 1 ? 0 : x < -1 ? pi$4 : Math.acos(x);
	}

	function asin$1(x) {
	  return x >= 1 ? halfPi$3 : x <= -1 ? -halfPi$3 : Math.asin(x);
	}

	function arcInnerRadius(d) {
	  return d.innerRadius;
	}

	function arcOuterRadius(d) {
	  return d.outerRadius;
	}

	function arcStartAngle(d) {
	  return d.startAngle;
	}

	function arcEndAngle(d) {
	  return d.endAngle;
	}

	function arcPadAngle(d) {
	  return d && d.padAngle; // Note: optional!
	}

	function intersect(x0, y0, x1, y1, x2, y2, x3, y3) {
	  var x10 = x1 - x0, y10 = y1 - y0,
	      x32 = x3 - x2, y32 = y3 - y2,
	      t = (x32 * (y0 - y2) - y32 * (x0 - x2)) / (y32 * x10 - x32 * y10);
	  return [x0 + t * x10, y0 + t * y10];
	}

	// Compute perpendicular offset line of length rc.
	// http://mathworld.wolfram.com/Circle-LineIntersection.html
	function cornerTangents(x0, y0, x1, y1, r1, rc, cw) {
	  var x01 = x0 - x1,
	      y01 = y0 - y1,
	      lo = (cw ? rc : -rc) / sqrt$2(x01 * x01 + y01 * y01),
	      ox = lo * y01,
	      oy = -lo * x01,
	      x11 = x0 + ox,
	      y11 = y0 + oy,
	      x10 = x1 + ox,
	      y10 = y1 + oy,
	      x00 = (x11 + x10) / 2,
	      y00 = (y11 + y10) / 2,
	      dx = x10 - x11,
	      dy = y10 - y11,
	      d2 = dx * dx + dy * dy,
	      r = r1 - rc,
	      D = x11 * y10 - x10 * y11,
	      d = (dy < 0 ? -1 : 1) * sqrt$2(max$2(0, r * r * d2 - D * D)),
	      cx0 = (D * dy - dx * d) / d2,
	      cy0 = (-D * dx - dy * d) / d2,
	      cx1 = (D * dy + dx * d) / d2,
	      cy1 = (-D * dx + dy * d) / d2,
	      dx0 = cx0 - x00,
	      dy0 = cy0 - y00,
	      dx1 = cx1 - x00,
	      dy1 = cy1 - y00;

	  // Pick the closer of the two intersection points.
	  // TODO Is there a faster way to determine which intersection to use?
	  if (dx0 * dx0 + dy0 * dy0 > dx1 * dx1 + dy1 * dy1) {
	  	cx0 = cx1, cy0 = cy1;
	  }

	  return {
	    cx: cx0,
	    cy: cy0,
	    x01: -ox,
	    y01: -oy,
	    x11: cx0 * (r1 / r - 1),
	    y11: cy0 * (r1 / r - 1)
	  };
	}

	var arc = function() {
	  var innerRadius = arcInnerRadius,
	      outerRadius = arcOuterRadius,
	      cornerRadius = constant$10(0),
	      padRadius = null,
	      startAngle = arcStartAngle,
	      endAngle = arcEndAngle,
	      padAngle = arcPadAngle,
	      context = null;

	  function arc() {
	    var buffer,
	        r,
	        r0 = +innerRadius.apply(this, arguments),
	        r1 = +outerRadius.apply(this, arguments),
	        a0 = startAngle.apply(this, arguments) - halfPi$3,
	        a1 = endAngle.apply(this, arguments) - halfPi$3,
	        da = abs$1(a1 - a0),
	        cw = a1 > a0;

	    if (!context) {
	    	context = buffer = path();
	    }

	    // Ensure that the outer radius is always larger than the inner radius.
	    if (r1 < r0) {
	    	r = r1, r1 = r0, r0 = r;
	    }

	    // Is it a point?
	    if (!(r1 > epsilon$3)) {
	    	context.moveTo(0, 0);
	    }

	    // Or is it a circle or annulus?
	    else if (da > tau$4 - epsilon$3) {
	      context.moveTo(r1 * cos$2(a0), r1 * sin$2(a0));
	      context.arc(0, 0, r1, a0, a1, !cw);
	      if (r0 > epsilon$3) {
	        context.moveTo(r0 * cos$2(a1), r0 * sin$2(a1));
	        context.arc(0, 0, r0, a1, a0, cw);
	      }
	    }

	    // Or is it a circular or annular sector?
	    else {
	      var a01 = a0,
	          a11 = a1,
	          a00 = a0,
	          a10 = a1,
	          da0 = da,
	          da1 = da,
	          ap = padAngle.apply(this, arguments) / 2,
	          rp = (ap > epsilon$3) && (padRadius ? +padRadius.apply(this, arguments) : sqrt$2(r0 * r0 + r1 * r1)),
	          rc = min$1(abs$1(r1 - r0) / 2, +cornerRadius.apply(this, arguments)),
	          rc0 = rc,
	          rc1 = rc,
	          t0,
	          t1;

	      // Apply padding? Note that since r1 ≥ r0, da1 ≥ da0.
	      if (rp > epsilon$3) {
	        var p0 = asin$1(rp / r0 * sin$2(ap)),
	            p1 = asin$1(rp / r1 * sin$2(ap));
	        if ((da0 -= p0 * 2) > epsilon$3) {
	        	p0 *= (cw ? 1 : -1), a00 += p0, a10 -= p0;
	        } else {
	        	da0 = 0, a00 = a10 = (a0 + a1) / 2;
	        }
	        if ((da1 -= p1 * 2) > epsilon$3) {
	        	p1 *= (cw ? 1 : -1), a01 += p1, a11 -= p1;
	        } else {
	        	da1 = 0, a01 = a11 = (a0 + a1) / 2;
	        }
	      }

	      var x01 = r1 * cos$2(a01),
	          y01 = r1 * sin$2(a01),
	          x10 = r0 * cos$2(a10),
	          y10 = r0 * sin$2(a10);

	      // Apply rounded corners?
	      if (rc > epsilon$3) {
	        var x11 = r1 * cos$2(a11),
	            y11 = r1 * sin$2(a11),
	            x00 = r0 * cos$2(a00),
	            y00 = r0 * sin$2(a00);

	        // Restrict the corner radius according to the sector angle.
	        if (da < pi$4) {
	          var oc = da0 > epsilon$3 ? intersect(x01, y01, x00, y00, x11, y11, x10, y10) : [x10, y10],
	              ax = x01 - oc[0],
	              ay = y01 - oc[1],
	              bx = x11 - oc[0],
	              by = y11 - oc[1],
	              kc = 1 / sin$2(acos$1((ax * bx + ay * by) / (sqrt$2(ax * ax + ay * ay) * sqrt$2(bx * bx + by * by))) / 2),
	              lc = sqrt$2(oc[0] * oc[0] + oc[1] * oc[1]);
	          rc0 = min$1(rc, (r0 - lc) / (kc - 1));
	          rc1 = min$1(rc, (r1 - lc) / (kc + 1));
	        }
	      }

	      // Is the sector collapsed to a line?
	      if (!(da1 > epsilon$3)) {
	      	context.moveTo(x01, y01);
	      }

	      // Does the sector’s outer ring have rounded corners?
	      else if (rc1 > epsilon$3) {
	        t0 = cornerTangents(x00, y00, x01, y01, r1, rc1, cw);
	        t1 = cornerTangents(x11, y11, x10, y10, r1, rc1, cw);

	        context.moveTo(t0.cx + t0.x01, t0.cy + t0.y01);

	        // Have the corners merged?
	        if (rc1 < rc) {
	        	context.arc(t0.cx, t0.cy, rc1, atan2$1(t0.y01, t0.x01), atan2$1(t1.y01, t1.x01), !cw);
	        }

	        // Otherwise, draw the two corners and the ring.
	        else {
	          context.arc(t0.cx, t0.cy, rc1, atan2$1(t0.y01, t0.x01), atan2$1(t0.y11, t0.x11), !cw);
	          context.arc(0, 0, r1, atan2$1(t0.cy + t0.y11, t0.cx + t0.x11), atan2$1(t1.cy + t1.y11, t1.cx + t1.x11), !cw);
	          context.arc(t1.cx, t1.cy, rc1, atan2$1(t1.y11, t1.x11), atan2$1(t1.y01, t1.x01), !cw);
	        }
	      }

	      // Or is the outer ring just a circular arc?
	      else {
	      	context.moveTo(x01, y01), context.arc(0, 0, r1, a01, a11, !cw);
	      }

	      // Is there no inner ring, and it’s a circular sector?
	      // Or perhaps it’s an annular sector collapsed due to padding?
	      if (!(r0 > epsilon$3) || !(da0 > epsilon$3)) {
	      	context.lineTo(x10, y10);
	      }

	      // Does the sector’s inner ring (or point) have rounded corners?
	      else if (rc0 > epsilon$3) {
	        t0 = cornerTangents(x10, y10, x11, y11, r0, -rc0, cw);
	        t1 = cornerTangents(x01, y01, x00, y00, r0, -rc0, cw);

	        context.lineTo(t0.cx + t0.x01, t0.cy + t0.y01);

	        // Have the corners merged?
	        if (rc0 < rc) {
	        	context.arc(t0.cx, t0.cy, rc0, atan2$1(t0.y01, t0.x01), atan2$1(t1.y01, t1.x01), !cw);
	        }

	        // Otherwise, draw the two corners and the ring.
	        else {
	          context.arc(t0.cx, t0.cy, rc0, atan2$1(t0.y01, t0.x01), atan2$1(t0.y11, t0.x11), !cw);
	          context.arc(0, 0, r0, atan2$1(t0.cy + t0.y11, t0.cx + t0.x11), atan2$1(t1.cy + t1.y11, t1.cx + t1.x11), cw);
	          context.arc(t1.cx, t1.cy, rc0, atan2$1(t1.y11, t1.x11), atan2$1(t1.y01, t1.x01), !cw);
	        }
	      }

	      // Or is the inner ring just a circular arc?
	      else {
	      	context.arc(0, 0, r0, a10, a00, cw);
	      }
	    }

	    context.closePath();

	    if (buffer) {
	    	return context = null, buffer + "" || null;
	    }
	  }

	  arc.centroid = function() {
	    var r = (+innerRadius.apply(this, arguments) + +outerRadius.apply(this, arguments)) / 2,
	        a = (+startAngle.apply(this, arguments) + +endAngle.apply(this, arguments)) / 2 - pi$4 / 2;
	    return [cos$2(a) * r, sin$2(a) * r];
	  };

	  arc.innerRadius = function(_) {
	    return arguments.length ? (innerRadius = typeof _ === "function" ? _ : constant$10(+_), arc) : innerRadius;
	  };

	  arc.outerRadius = function(_) {
	    return arguments.length ? (outerRadius = typeof _ === "function" ? _ : constant$10(+_), arc) : outerRadius;
	  };

	  arc.cornerRadius = function(_) {
	    return arguments.length ? (cornerRadius = typeof _ === "function" ? _ : constant$10(+_), arc) : cornerRadius;
	  };

	  arc.padRadius = function(_) {
	    return arguments.length ? (padRadius = _ == null ? null : typeof _ === "function" ? _ : constant$10(+_), arc) : padRadius;
	  };

	  arc.startAngle = function(_) {
	    return arguments.length ? (startAngle = typeof _ === "function" ? _ : constant$10(+_), arc) : startAngle;
	  };

	  arc.endAngle = function(_) {
	    return arguments.length ? (endAngle = typeof _ === "function" ? _ : constant$10(+_), arc) : endAngle;
	  };

	  arc.padAngle = function(_) {
	    return arguments.length ? (padAngle = typeof _ === "function" ? _ : constant$10(+_), arc) : padAngle;
	  };

	  arc.context = function(_) {
	    return arguments.length ? ((context = _ == null ? null : _), arc) : context;
	  };

	  return arc;
	};
	d3.d4_arc = arc; //v4.11.0

})();// zc constant functions and variables;

var UNDEFINED,
    math = Math,
    mathRound = math.round,
    mathFloor = math.floor,
    mathCeil = math.ceil,
    mathMax = math.max,
    mathMin = math.min,
    mathAbs = math.abs,
    mathPow = math.pow,
    mathSQRT = math.sqrt,
    mathCos = math.cos,
    mathSin = math.sin,
    mathLog = math.log,
    mathTan = math.tan,
    mathAtan2 = math.atan2,
    mathLN10 = math.LN10,
    mathPI = math.PI,
    mathPI2 = mathPI * 2,
    deg2rad = mathPI * 2 / 360,
    MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991,
    
    PX = 'px ',
    NONE = 'none',
    STROKE_WIDTH = 'stroke-width',
    TRANSPARENT = "transparent",
    BASE_HELPER_CONTAINER = null,
    CURRENT_CHART_COUNT = 0,
    BASE_CONTAINER_POSITION = -9999;


/**
 * Shortcut for parseInt
 * @param {Object} s
 * @param {Number} mag Magnitude
 */
function pInt(s, mag) {
    return parseInt(s, mag || 10);
}

/**
 * Check for string
 * @param {Object} s
 */
function isString(s) {
    return typeof s === 'string';
}

/**
 * Check for object
 * @param {Object} obj
 */
function isObject(obj) {
    return obj && typeof obj === 'object';
}

/**
 * Check for array
 * @param {Object} obj
 */
function isArray(obj) {
    if(Array.isArray) {
        return Array.isArray(obj)
    }
    return !!obj && obj.constructor === Array;
    // return Object.prototype.toString.call(obj) === '[object Array]';
}

/**
 * Check for number
 * @param {Object} n
 */
var isNumber = function isNumber(n) {
    return typeof n === 'number' && !isNaN(n);
};

/**
 *
 * @param {Function|*}object
 * @returns {boolean}
 */

function isFunction(object) {
    return !!(object && object.constructor && object.call && object.apply);
}

function jsonStringify(obj) {
    if (defined(obj)) {
        return JSON.stringify(obj);
    }
    return UNDEFINED;
}

var tempCanvasContext = document.createElement("canvas").getContext("2d");// d3 selections
var d3_select = d3.select,
    d3_selectAll = d3.selectAll,

    // de min-max

    d3_min = d3.min,
    d3_max = d3.max,

    // axes

    d3_axis = d3.svg.axis,

    // rebind

    d3_rebind = d3.rebind,

    // d3 scales

    d3_scaleLinear = d3.scale.linear,
    d3_scaleOrdinal = d3.scale.ordinal,
    d3_scaleTime = d3.time.scale

    // bisector

    d3_bisector = d3.bisector,


    // sum

    d3_sum = d3.sum,

    // d3 colors

    d3_hsl = d3.hsl,
    d3_rgb = d3.rgb,

    // d3 merge , map and ser

    d3_merge = d3.merge,
    d3_map = d3.map,
    d3_set = d3.set,

    // d3 behavior

    d3_zoom = d3.behavior.zoom,
    d3_drag = d3.behavior.drag,

    // d3 extent

    d3_extent = d3.extent,

    // event dispatch

    d3_dispatch = d3.dispatch,

    // d3 sort type

    d3_ascending = d3.ascending,
    d3_descending = d3.descending,

    // d3 shapes

    d3_line = d3.svg.line,
    d3_lineRadial = d3_line.radial,
    d3_area = d3.svg.area,
    d3_areaRadial = d3_area.radial,
    d3_arc = d3.svg.arc,

    // layouts
    d3_pack = d3.pack,
    d3_pie = d3.layout.pie,
    d3_partition = d3.layout.partition,

    // d3 transform

    d3_transform = d3.transform,

    // d3 mouse

    d3_mouse = d3.mouse,

    // d3 interpolate

    d3_interpolate = d3.interpolate,
    d3_interpolateRgb = d3.interpolateRgb,

    // d3 range

    d3_range = d3.range,


    // d3 times

    // days
    d3_timeSunday = d3.time.sunday,
    d3_timeMonday = d3.time.monday,
    d3_timeTuesday = d3.time.tuesday,
    d3_timeWednesday = d3.time.wednesday,
    d3_timeThursday = d3.time.thursday,
    d3_timeFriday = d3.time.friday,
    d3_timeSaturday = d3.time.saturday,

    // seconds, minute and hour
    d3_timeSeconds = d3.time.seconds,
    d3_timeMinutes = d3.time.minutes,
    d3_timeHours = d3.time.hours,
    d3_timeDays = d3.time.days,
    d3_timeWeeks = d3.time.weeks,
    d3_timeMonths = d3.time.months,
    d3_timeYears = d3.time.years,

    // formatter
    d3_format = d3.format,
    d3_timeFormat = d3.time.format,
    d3_timeFormatUTC = d3.time.format.utc,

    // d3_ajax
    d3_xhr = d3.xhr,
    d3_json = d3.json,

    // timer
    d3_timer = d3.timer,

    // brush
    d3_brush = d3.svg.brush;
//$Id$
var ORDINAL_DATATYPE = "ordinal",
	TIME_DATATYPE = "time",
	NUMERIC_DATATYPE = "numeric";//$Id$
$ZC.imageFilePath = window.location.protocol + "//" + window.location.hostname + "/src/images/";
$ZC.fontProperties = {
    "minsize": 15,
    "maxsize": 40,
    "ratio": 0.038
};

/*If Xaxis data (numeric or time) is not sorted, plot rendering for continous charts will look odd.
 Because of the performance issue, we are giving this configuration as optional. Better make this parameter as false, and make sure the input data is sorted, if you are considering performance
 */
$ZC.requireXDataSorting = false;
$ZC.dataEncoded = false;//$Id$
var btoa = window.btoa || function(input) { //window.btoa polyfill for IE9
    input = String(input);
    var B64_ALPHABET = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    var position = 0,
        out = [],
        o1, o2, o3,
        e1, e2, e3, e4;
    
    if (/[^\x00-\xFF]/.test(input)) {
        throw Error("InvalidCharacterError");
    }
    
    while (position < input.length) {
        o1 = input.charCodeAt(position++);
        o2 = input.charCodeAt(position++);
        o3 = input.charCodeAt(position++);
        
        // 111111 112222 222233 333333
        e1 = o1 >> 2;
        e2 = ((o1 & 0x3) << 4) | (o2 >> 4);
        e3 = ((o2 & 0xf) << 2) | (o3 >> 6);
        e4 = o3 & 0x3f;
        
        if (position === input.length + 2) {
            e3 = 64;
            e4 = 64;
        } else if (position === input.length + 1) {
            e4 = 64;
        }
        
        out.push(B64_ALPHABET.charAt(e1),
            B64_ALPHABET.charAt(e2),
            B64_ALPHABET.charAt(e3),
            B64_ALPHABET.charAt(e4));
    }
    return out.join('');
};

/**
 * innerHTML property for SVGElement
 * Copyright(c) 2010, Jeff Schiller
 *
 * Licensed under the Apache License, Version 2
 *
 * Works in a SVG document in Chrome 6+, Safari 5+, Firefox 4+ and IE9+.
 * Works in a HTML5 document in Chrome 7+, Firefox 4+ and IE9+.
 * Does not work in Opera since it doesn't support the SVGElement interface yet.
 *
 * I haven't decided on the best name for this property - thus the duplication.
 */

(function() {
var serializeXML = function(node, output) {
  var nodeType = node.nodeType;
  if (nodeType == 3) { // TEXT nodes.
    // Replace special XML characters with their entities.
    output.push(node.textContent.replace(/&/, '&amp;').replace(/</, '&lt;').replace('>', '&gt;'));
  } else if (nodeType == 1) { // ELEMENT nodes.
    // Serialize Element nodes.
    output.push('<', node.tagName);
    if (node.hasAttributes()) {
      var attrMap = node.attributes;
      for (var i = 0, len = attrMap.length; i < len; ++i) {
        var attrNode = attrMap.item(i);
        output.push(' ', attrNode.name, '=\'', attrNode.value, '\'');
      }
    }
    if (node.hasChildNodes()) {
      output.push('>');
      var childNodes = node.childNodes;
      for (var i = 0, len = childNodes.length; i < len; ++i) {
        serializeXML(childNodes.item(i), output);
      }
      output.push('</', node.tagName, '>');
    } else {
      output.push('/>');
    }
  } else if (nodeType == 8) {
    // TODO(codedread): Replace special characters with XML entities?
    output.push('<!--', node.nodeValue, '-->');
  } else {
    // TODO: Handle CDATA nodes.
    // TODO: Handle ENTITY nodes.
    // TODO: Handle DOCUMENT nodes.
    throw 'Error serializing XML. Unhandled node of type: ' + nodeType;
  }
}

// The innerHTML DOM property for SVGElement.
Object.defineProperty(SVGElement.prototype, 'innerHTML', {
  get: function() {
    var output = [];
    var childNode = this.firstChild;
    while (childNode) {
      serializeXML(childNode, output);
      childNode = childNode.nextSibling;
    }
    return output.join('');
  },
  set: function(markupText) {
    // Wipe out the current contents of the element.
    while (this.firstChild) {
      this.removeChild(this.firstChild);
    }

    try {
      // Parse the markup into valid nodes.
      var dXML = new DOMParser();
      dXML.async = false;
      // Wrap the markup into a SVG node to ensure parsing works.
      sXML = '<svg xmlns=\'http://www.w3.org/2000/svg\'>' + markupText + '</svg>';
      var svgDocElement = dXML.parseFromString(sXML, 'text/xml').documentElement;

      // Now take each node, import it and append to this element.
      var childNode = svgDocElement.firstChild;
      while(childNode) {
        this.appendChild(this.ownerDocument.importNode(childNode, true));
        childNode = childNode.nextSibling;
      }
    } catch(e) {
      throw new Error('Error parsing XML string');
    };
  }
});

// The innerSVG DOM property for SVGElement.
Object.defineProperty(SVGElement.prototype, 'innerSVG', {
  get: function() {
    return this.innerHTML;
  },
  set: function(markupText) {
    this.innerHTML = markupText;
  }
});

})();
//$Id$
/*
 * Main method to generate a chart or charts
 * containers,datas param can be an array if there have to be multiple chart generation.
 */
$ZC.charts = function(containers, datas, mapObj) {
    var isMulti = (containers.constructor === Array && datas.constructor === Array);
    if (isMulti) {
        return getMultiCharts(containers, datas, mapObj);
    } else {
        var chartObj = getChartObject(containers, datas);
        if (chartObj) {
            chartObj.draw();
        }
        return chartObj;
    }
};

/*
 * This is the actual chart object init method
 * here the data is binded with respective selected container
 * Note: Only the chart object is initialized here, but the chart generation or rendering will not happen.
 * */
function getChartObject(container, data) {
    if (!document.body.contains(container)) {
        Console.warn("No container");
        return null;
    }
    var dataObj = d3_select(container)
        .datum(data);
    var chart = null;
    
    /*
     * Each chart instance is instantiated with chartRendered flag false
     * chart.initialize is defined in chart-constructor.js
     * */
    dataObj.each(function(data) {
        var chartHolder = d3_select(this);
        chart = new $ZC.charts.get(chartHolder, data); // get chartobj
        chart.showLoading(chartHolder);
    });
    return chart;
}
/*
 * when it is multi charts instantiation, the chart rendering is queued here.
 */
function getMultiCharts(containers, datas) {
    
    if (!(containers.constructor === Array && datas.constructor === Array)) {
        return;
    }
    var chartObjs = [];
    for (var i in containers) {
        if (containers.hasOwnProperty(i)) {
            var container = containers[i];
            var data = datas[i];
            var chartObj = getChartObject(container, data);
            chartObjs.push(chartObj);
        }
    }
    var executedChartObjs = [];
    //unexecutedChartObjs are reversed just for the convenience of using Array.pop() method to remove first rendered chart object.
    var clonedObjs = chartObjs.slice();
    var unexecutedChartObjs = clonedObjs.reverse();
    drawEfficiently(unexecutedChartObjs, executedChartObjs, chartObjs);
    return chartObjs;
}


function drawEfficiently(unexecutedChartObjs, executedChartObjs, chartObjs) {
    
    var len = unexecutedChartObjs.length,
        chartObj = unexecutedChartObjs[len - 1];
    
    // all charts are rendered
    if (!len) {
        chartObjs.chartRendered = true;
    }
    
    if (len > 0 && (chartObj.drawStarted != true) && document.body.contains(chartObj.container.node())) {
        chartObj.draw();
        chartObj.drawStarted = true;
        checkStatusNCallNext(unexecutedChartObjs, executedChartObjs, chartObjs);
    }
    
}

/*
 * Executed/rendered chart objects are popped and pushed to the executed object list.
 * Waits till next chart object is rendered.
 * */
function checkStatusNCallNext(unexecutedChartObjs, executedChartObjs, chartObjs, timer) {
    var len = unexecutedChartObjs.length,
        chartObj = unexecutedChartObjs[len - 1];
    
    if (chartObj.chartRendered || chartObj.breakOnErr) {
        executedChartObjs.push(unexecutedChartObjs.pop());
        drawEfficiently(unexecutedChartObjs, executedChartObjs, chartObjs);
    } else {
        if (timer != null) {
            clearTimeout(timer);
        }
        
        var timer = setTimeout(function() {
            checkStatusNCallNext(unexecutedChartObjs, executedChartObjs, chartObjs, timer);
        }, 10)
    }
}//$Id$
//Returns the chart object after setting all the required properties and methods


(function(exports) {

    "use strict";

    // TODO renaming exports or $ZC
    exports.charts.get = function(chartHolder, data) {
        return new Chart(chartHolder, data);
    };

    function Chart(container, data) {
        this.container = container;
        this.userdata = data;
        this.dataObject = null;
        this.dataset = null;
        this.svg = null;
        this.canvasarea = {};
        this.chartarea = {};
        this.legendarea = {};
        this.plotarea = {};
        this.seriesColor = [];
        this.axes = {};
        this.renderer = [];
        this.subrenderer = [];
        this.ismultiy = null;
        this.plotarea_approx = null;
        this.nochartdata = false;
        this.chartRendered = false;
        this.plot = {};
        this.events = {};
        this.legend = {
            component: null
        };

        this.availableWidth = null;
        this.availableHeight = null;
        this.initialize();
    }

    Chart.prototype.initialize = function() {

        var chart = this;

        try {

            var data = this.userdata,
                dataProcessorHelpers = chart.dataProcessorHelpers = $ZC.DataProcessor.helpers;


            chart.chartRendered = false;
            chart.chartFontProp = {};
            chart.chartHeight = parseFloat(chart.container.style("height"));
            chart.chartWidth = parseFloat(chart.container.style("width"));

            chart.createHelperElements();
            chart.handleHiddenContainer();

            Chart.helpers.initializeChartHolders(chart);
            chart.setCanvasDimension();

            chart.axes.x = {
                levels: []
            };

            chart.axes.y = {
                groups: []
            };

            // get all chart types
            chart.chartTypes = dataProcessorHelpers.getAllChartTypes(data, "object");
            chart.globalProp = setGlobalPropByUserdata(data, {
                "width": chart.canvasarea.width,
                "height": chart.canvasarea.height
            }, chart.chartFontProp);

            chart.themeoptions = chart.getThemeOptions(chart.globalProp);

            (!data.metadata) ? $ZC.setDefaultOptions("metadata", data) : null; // If metadata is unavailable, get default metadata

            chart.processUserData(chart.themeoptions);
            chart.setChartDimension();

            chart.defsLocation = getDefsLocation();
            var svg = chart.svg;
            chart.legendHighlight = new $ZC.legendHighlight(chart, chart.svg);
            svg.append('defs');
            Chart.helpers.constructChartGroups(chart);


            CURRENT_CHART_COUNT++;
            chart.id = "ZC_" + CURRENT_CHART_COUNT;

        } catch (err) {
            // console.error(err.stack);
            // console.log("Oops! Sorry something went wrong to render the chart...")
            // console.log("Error message : " + err.message);
            // console.log(err.stack);

            chart.breakOnErr = true;
            if (isObjectPropDefined(chart.systemConf, "canvas.events")) {
                invokeFunction(chart.systemConf.canvas.events.onerror, d3.event, chart, err);
            }
        }
    };

    /**
     *
     */

    Chart.prototype.createHelperElements = function() {

        // create the base container first

        if (defined(BASE_HELPER_CONTAINER)) {
            return;
        }

        var parent = d3_select(document.body);
        var baseContainer = BASE_HELPER_CONTAINER = appendEle(parent, "div", [1], ".", "class", "__baseZC_Container__");
        baseContainer
        .style({
            "position": "absolute",
            "left": BASE_CONTAINER_POSITION + PX,
            "top": BASE_CONTAINER_POSITION + PX
        });

        var svg = $ZCG.patternSVG = appendEle(baseContainer, "svg", [1], ".", "class", "svgPattern");
        svg.attr({
            "version": "1.1",
            "xmlns": d3.ns.prefix.svg
        });
        appendEle(svg, "defs", [1]);
    };

    /**
     * Handles if the container is not visible or a virtual element in document.
     * @param {Boolean} normalize to restore the cloned element
     */

    Chart.prototype.handleHiddenContainer = function(normalize) {

        var chart = this,
            container = chart.container;

        if (normalize && defined(chart.originalContainer)) {

            chart.originalContainer.node().appendChild(chart.d3container.node()); // place the cloned element under the original element.
            chart.container.remove(); // remove the cloned element.
            chart.container = chart.originalContainer; // restore the tween element.

            delete chart.isHiddenCoainer; // delete the temp variable.
            delete chart.originalContainer; // delete the temp variable.

        } else {

            var containerNode = container.node();

            if (isHidden(containerNode)) {

                var containerClone = containerNode.cloneNode(0); // clone the parent node.
                BASE_HELPER_CONTAINER.node().appendChild(containerClone); // append to visible element.
                containerClone.style.setProperty("display", "block", 'important'); // ensure its properly visible.

                chart.isHiddenCoainer = true;
                chart.originalContainer = container; // save the original container
                chart.container = d3.select(containerClone); // set pointer to our cloned element as main container.
            }
        }
    };

    /**
     * @returns {void}
     */

    Chart.prototype.draw = function() {
        this.render(false);
    };

    /**
     *
     * @param {boolean} update
     */

    Chart.prototype.render = function(update) {

        var chart = this;

        try {
            chart.updateCanvasArea();

            var systemConfig = chart.systemConf;
            chart.applyChartProperties();
            if (chart.nochartdata) {
                chart.hideLoading(chart.container);
                chart.handleNoData(systemConfig.noDataHandler);
                chart.chartRendered = true;
                stateChangeListener(chart, systemConfig.canvas.events, "chart", (update) ? "onreload" : "onload");
            } else {
                chart.getChartSeriesColor();
                chart.isAxisCategory = chart.dataObject.isAxisCategory;
                chart.isNonAxisMultiSeriesCategory = chart.dataObject.isNonAxisMultiSeriesCategory;
                chart.xymultiRenderer = chart.isAxisCategory;
                $ZC.legend.render(chart, update);

                if ($ZC.annotation) { //Adding block level annotations
                    $ZC.annotation.addBlockAnnotations(chart);
                }

                //brushing
                if (isObjectPropDefined(chart.systemConf.chart, "scroll") && chart.systemConf.chart.scroll.enabled) {
                    $ZC.setDefaultOptions("scroll", chart.systemConf.chart, chart.globalProp);
                    chart.brush = new svg_brush(chart, "x");
                    // chart.svg.call(chart.brush);
                }

                addDefaultScroll.initialize(chart);

                // Axis renderer
                stateChangeListener(chart, systemConfig.chart.axes.events, null, "init");

                if (chart.isAxisCategory) {
                    $ZC.axis.render(chart, chart.chartWidth, chart.chartHeight, update)
                } else if (chart.dataObject.isPolarAxisCategory || chart.dataObject.hasLevelMarker) {
                    var type = (chart.dataObject.hasLevelMarker) ? "y" : "x";
                    $ZC.axis.polar.render(chart, type);
                }
                chart.zscale = (defined(chart.dataset.zidx) && !chart.dataObject.isHierarchy) ? $ZC.scale.getScale(chart, chart.dataObject, chart.plotarea, chart.axes.x.orient, null, chart.dataset, "z") : null;

                stateChangeListener(chart, systemConfig.chart.axes.events, null, ((update) ? "onreload" : "onload"));

                chart.updatePlotareaProp();
                chart.drawPlotareaClippath();

                if (chart.plot.renderer) {
                    chart.plot.renderer.draw(update);
                } else {
                    var renderer = chart.plot.renderer = $ZC.plot.render(chart, update);
                    renderer.draw(false);
                }

                if (chart.isAxisCategory) {
                    chart.drawThreshold(update);
                }
                chart.handleEvent(update);
                drawBorderBox(chart.wrap.selectAll("rect.dummy-rect-filter"), {
                    width: chart.plotarea.width,
                    height: chart.plotarea.height
                });
                // stateChangeListener(chart, systemConfig.canvas.events, "chart", (update)?"onreload":"onload");
            }
        } catch (err) {
            // console.error(err.stack);
            //    console.log("Oops! Sorry something went wrong to render the chart...")
            //    console.error("Error message : " + err.message);
            //    console.warn(err.stack);
            chart.breakOnErr = true;
            if (isObjectPropDefined(systemConfig, "canvas.events")) {
                invokeFunction(systemConfig.canvas.events.onerror, d3.event, chart, err);
            }
        }
    };


    /**
     *
     */

    Chart.prototype.updateCanvasArea = function() {
        var chart = this,
            systemConfig = chart.systemConf;

        chart.container.selectAll("div.d3container")
            .style({
                "position": "relative",
                "width": chart.container.style("width"),
                "height": chart.container.style("height")
                // "-webkit-transform" : "scale(1)",
                // "transform" : "scale(1)"
            });

        var canvas = chart.container.selectAll("div.canvas-component");
        canvas.style({
            "position": "relative",
            "width": chart.canvasarea.width + "px",
            "height": chart.canvasarea.height + "px"
        });

        var canvasProp = chart.container.selectAll("div.canvas-property");
        canvasProp.style({
            "position": "absolute",
            "width": chart.canvasarea.width + "px",
            "height": chart.canvasarea.height + "px"
        });
        chart.updateCommonBBSProp(canvasProp, null, systemConfig.canvas, "canvas");
    };

    /**
     * // BBS -->Border,Background,Shadow for canvas area, chartarea
     * @param ele
     * @param subEle
     * @param data
     * @param type
     */

    Chart.prototype.updateCommonBBSProp = function(ele, subEle, data, type) {

        var chart = this,
            systemConfig = chart.systemConf;

        var border = data.border || {};
        var background = data.background || {};
        var shadow = data.shadow || {},
            borderEle;
        //background
        ele.style({
            "background-color": background.color,
            "opacity": background.alpha
        });

        var bgImg = null, useGradient = getPropVal(background, "gradients.show") === true;
        if (useGradient) {
            var gradient, gradientColors = "";
            if (!defined(background.gradients.useCSS)) {
                if (defined(background.gradients.stopColor)) {
                    background.gradients.stopColor.map(function(d, i) {
                        var offset = (defined(background.gradients.stopOffset) && defined(background.gradients.stopOffset[i])) ? " " + background.gradients.stopOffset[i] : "";
                        gradientColors = gradientColors + ((i === 0) ? (d + " " + offset) : ("," + d + offset))
                    })
                }
                if (background.gradients.type === "radial") {
                    gradient = "radial-gradient(" + gradientColors + ")"
                } else if (background.gradients.type === "linear") {
                    gradient = "linear-gradient(" + gradientColors + ")"
                }
            } else {
                gradient = background.gradients.useCSS
            }


            if ($Browser.WEBKIT) {
                bgImg = "-webkit-" + gradient;
            } else if ($Browser.FIREFOX) {
                bgImg = "-moz-" + gradient;
            } else if ($Browser.IE) {
                bgImg = "-ms-" + gradient;
                var filter = (defined(background.gradients.stopColor)) ? ((background.gradients.type === "linear") ? "progid:DXImageTransform.Microsoft.gradient(startColorstr=" + (background.gradients.stopColor[0] || "black") + ", endColorstr=" + (background.gradients.stopColor[1] || "white") + ")" :
                    "progid:DXImageTransform.Microsoft.Alpha(opacity=100, finishopacity=0, style=2)") : null;
                ele.style("filter", filter);
            }

        }

        if (defined(background.imageUrl)) {
            bgImg = "url(" + background.imageUrl + ")";
        }
        if (!(($Browser.IE === 1) && ($Browser.VERSION.indexOf("9.") === 0))) {
            ele.style({
                "background-image": bgImg,
                "background-repeat": background.imageRepeat,
                "opacity": background.alpha
            })
        }

        //border
        if (border.show === true && type === "canvas") {

            borderEle = (type === "plotarea") ? subEle : ele;

            //border size validation
            var borderSize = (type === "canvas") ? validateValWithinLimit(systemConfig.canvas.border, "size", 0, 10, chart.canvasarea.width, chart.canvasarea.height) :
                validateValWithinLimit(systemConfig.chart.plot.border, "size", 0, 10, chart.plotarea.width, chart.plotarea.height);
            borderSize = pick(borderSize, 2);
            borderEle.style({
                "border": borderSize + "px " + border.style + " " + border.color,
                "border-radius": pInt(border.radius) + "px"
            });
            borderEle.node().border = {
                "size": borderSize,
                "clr": border.color
            }; //bkpinfo
        } else {
            borderEle = (type === "plotarea") ? subEle : ele;
            if (type !== "plotarea") {
                borderEle.style({
                    "border": ""
                })
            }
        }

        //shadow
        if (shadow.show === true) { // only for canvas area
            var shadowstyle = shadow.x + "px " + shadow.y + "px " + shadow.blur + "px " + shadow.color;
            // var shadowstyle = [shadow.x, shadow.y, shadow.blur, shadow.color].join(PX);

            if (shadow.inset === true) {
                shadowstyle += " inset";
            }

            ele.style({
                "box-shadow": shadowstyle
            })
        } else {
            ele.style("box-shadow", "");
        }
    };

    /**
     *
     * @param baseSystemConf
     * @param update
     */

    Chart.prototype.processUserData = function(baseSystemConf, update) {

        var chart = this,
            systemConfig,
            series, chartdata;

        chart.systemConf = systemConfig = mergeJSON(baseSystemConf, chart.userdata, true, true);
        series = getPropVal(systemConfig, "seriesdata") || {};
        chart.seriesdata = chartdata = series.chartdata;

        if (!update) {
            stateChangeListener(chart, systemConfig.canvas.events, "chart", "init");
        }

        chart.nochartdata = !defined(chartdata) || (defined(chartdata) && chartdata.length < 1);

        if (chart.nochartdata) {
            chart.seriesdata = null
        } else {
            chart.dataset = new $ZC.dataset.get(systemConfig, chart);
            chart.preProcessor = new $ZC.PreProcessor(chart);
            chart.dataObject = chart.getDataObject();
            chart.dataset.setDataObj(chart.dataObject);

            chart.nochartdata = chart.dataObject.totalnoofdatas < 1;
            chart.axes.rotated = chart.dataObject.getAxisRotated();

            if(chart.axes.rotated) {
                chart.axes.x.orient = "left";
                chart.axes.y.orient = "bottom";
            } else {
                chart.axes.x.orient = "bottom";
                chart.axes.y.orient = "left";
            }
            chart.ismultiy = chart.getAxesCount("y") > 1;
            chart.ismultix = chart.getAxesCount("x") > 1;
        }
    };

    /**
     *
     * @param width
     * @param height
     */

    Chart.prototype.setCanvasDimension = function(width, height) {
        var chart = this,
            svg = chart.svg,
            width_style, height_style;

        if (!width && !height) {
            width_style = svg.style("width");
            height_style = svg.style("height");
            //need to change validateNullval under zcutils and to use this for width_style
            width_style = (!defined(width_style) || width_style === "auto") ? 960 : parseFloat(width_style);
            height_style = (!defined(height_style) || height_style === "auto") ? 400 : parseFloat(height_style);
        }

        var availableWidth = chart.availableWidth = (width || width_style || 960),
            availableHeight = chart.availableHeight = (height || height_style || 400);

        this.canvasarea = {
            left: 0,
            top: 0,
            right: 0,
            bottom: 0,
            width: availableWidth,
            height: availableHeight
        };
    };

    /**
     *
     * @param globalProp
     * @returns {*}
     */

    Chart.prototype.getThemeOptions = function(globalProp) {

        var chart = this,
            overallTypes = $ZC.charttypenames.values(),
            allSeriesTypes = chart.dataProcessorHelpers.getAllChartTypes(chart.userdata, "string"),
            theme = null,
            userTheme,
            defaultTheme;

        if (chart.userdata.canvas) {
            theme = chart.userdata.canvas.theme;
        }

        defaultTheme = new $ZC.defaultTheme(globalProp);

        overallTypes.map(function(d, i) {
            if (allSeriesTypes.indexOf(d) !== -1) {
                $ZC.setDefaultOptions(d, defaultTheme.chart.plot.plotoptions, globalProp);
            }
        });


        if (defined($ZC[theme])) {
            userTheme = new $ZC[theme](globalProp);
            userTheme = mergeJSON(defaultTheme, userTheme, true, true);
        } else {
            userTheme = defaultTheme;
        }
        return userTheme;
    };

    /**
     *
     *
     * @returns {*}
     */

    Chart.prototype.getDataObject = function() {
        var chart = this,
            dataProcessor;

        if ($ZC.chartcategory.hierarchy.indexOf(chart.chartTypes[0].value) > -1) {
            dataProcessor = new $ZC.hierarchymodel.get(chart);
        } else {
            dataProcessor = new $ZC.DataProcessor(chart.systemConf, chart.dataset, chart);
        }
        chart.seriesdata = dataProcessor.isHierarchy ? simpleClone(chart.seriesdata) : chart.seriesdata;
        return dataProcessor;
    };

    /**
     *
     * @param type
     * @returns {number}
     */
    Chart.prototype.getAxesCount = function(type) {

        var chart = this,
            count = 1,
            metadata = chart.systemConf.metadata;

        if (type === "x") {
            var columnIndex = chart.dataset.getColumnIdx(type),
                originalDataType = metadata.columns[columnIndex].datatype,
                formatConfig = pick(metadata.columns[columnIndex][originalDataType], {}),
                formatFunction = formatConfig.subfunction;

            if (defined(chart.dataObject.hierarchical)) {
                count = chart.dataObject.hierarchical.finalDepth + 1;
            } else if (isArray(formatConfig.groupby) && formatConfig.groupby.length) {
                count = formatConfig.groupby.length + 1;
            } else if(formatConfig.groupby === "AUTO") {
                count = $ZC.HierarchicalTimeDataAdapter.getAutoGroupOrder(formatFunction).length + 1;
            }
            chart.axes[type].count = count;
        } else {

            var metadataY = metadata.axes.y;
            count = chart.axes[type].count = metadataY.length;
        }
        return count;
    };

    Chart.prototype.setChartDimension = function() {
        var chart = this,
            systemConfig = chart.systemConf;
        var borderOptions = systemConfig.canvas.border;
        var borderSize_canvas = borderOptions.show ? validateValWithinLimit(borderOptions, "size", 0, 10, chart.canvasarea.width, chart.canvasarea.height) : 0;
        chart.chartarea = {
            left: chart.canvasarea.left + borderSize_canvas,
            top: chart.canvasarea.top + borderSize_canvas,
            right: chart.canvasarea.right - borderSize_canvas,
            bottom: chart.canvasarea.bottom - borderSize_canvas,
            width: chart.canvasarea.width - (2 * borderSize_canvas),
            height: chart.canvasarea.height - (2 * borderSize_canvas)
        };
        chart.plotarea = Object.create(chart.chartarea)
    };

    /**
     *
     */

    Chart.prototype.applyChartProperties = function() {
        var chart = this,
            systemConfig = chart.systemConf,
            chartHeight = chart.chartHeight;

        var title = systemConfig.canvas.title,
            subtitle = systemConfig.canvas.subtitle,
            credits = systemConfig.credits || {};
        var showTitle = title.show && dimension_based_intelligence(chart, "title", chartHeight),
            showSubtitle = subtitle.show && dimension_based_intelligence(chart, "subtitle", chartHeight),
            showCredits = credits.enabled === true && dimension_based_intelligence(chart, "credits", chartHeight);
        if (showCredits) {
            var defaultCreditOptions = $ZC.setDefaultOptions("credits", chart.systemConf, chart.globalProp);
            // mergeJSON(chart.systemConf.credits, defaultCreditOptions, true, true);
            chart.drawTitle(chart.systemConf.credits, "credits");
        }
        if (showTitle) {
            (title.vAlign === "bottom" && subtitle.vAlign === "bottom" && subtitle.show) ? chart.drawTitle(systemConfig.canvas.subtitle, "subtitle") : chart.drawTitle(systemConfig.canvas.title,
                "title");
        }
        if (showSubtitle) {
            (subtitle.vAlign === "bottom" && title.vAlign === "bottom" && title.show) ? chart.drawTitle(systemConfig.canvas.title, "title") : chart.drawTitle(systemConfig.canvas.subtitle,
                "subtitle");
        }
        chart.plotarea = Object.create(chart.chartarea);
        chart.container.selectAll("g.plotareaBorder-property").selectAll("line", "path").style("border", ""); //reset plot area border color
        var plotOptions = systemConfig.chart;
        var mLeft = parseFloat(plotOptions.marginLeft),
            mRight = parseFloat(plotOptions.marginRight),
            mTop = parseFloat(plotOptions.marginTop),
            mBottom = parseFloat(plotOptions.marginBottom);
        // If margin values were greater than chart container width and height, reset to 0
        var mLeft_corr = (mLeft + mRight) > chart.plotarea.width ? 0 : mLeft,
            mRight_corr = (mLeft + mRight) > chart.plotarea.width ? 0 : mRight,
            mTop_corr = (mTop + mBottom) > chart.plotarea.height ? 0 : mTop,
            mBottom_corr = (mTop + mBottom) > chart.plotarea.height ? 0 : mBottom;
        chart.plotarea.left += mLeft_corr;
        chart.plotarea.right += mRight_corr;
        chart.plotarea.bottom += mBottom_corr;
        chart.plotarea.top += mTop_corr;
        chart.plotarea.width = chart.plotarea.width - mLeft_corr - mRight_corr;
        chart.plotarea.height = chart.plotarea.height - mBottom_corr - mTop_corr;
    };

    /**
     *
     * @param data
     * @param type
     */
    Chart.prototype.drawTitle = function(data, type) {
        var chart = this,
            svg = chart.svg,
            systemConfig = chart.systemConf,
            floating = defined(data.x) && defined(data.y),
            location = window.location;

        var margin = {
            top: validateNullVal(data.marginTop, 0),
            right: validateNullVal(data.marginRight, 0),
            bottom: validateNullVal(data.marginBottom, 0),
            left: validateNullVal(data.marginLeft, 0)
        };

        var titlearea = svg.selectAll("g.chart" + type);
        var titleAlign = (floating) ? {
            x: data.x + margin.left,
            y: data.y + margin.top,
            dy: "1",
            textAnchor: (data.hAlign === "left") ? "start" : (data.hAlign === "right") ? "end" : "middle"
        } : Chart.helpers.align(data.hAlign, data.vAlign, chart.chartarea, margin);

        // var titleBox = appendEle(titlearea, "rect", [data], ".", "class", (type+"Box"));
        var imageUrl = data.imageUrl;
        var isTextBox = !defined(imageUrl);
        var element = (isTextBox) ? (data.text === "" ? "none" : "text") : "image";

        if (element !== "none") {
            var title = appendEle(titlearea, element, [data], ".", "class", type);
            if (defined(data.href)) {
                var click = function() {
                    var isValidURL = validateURL(data.href);
                    if (isValidURL) {
                        var target = data.target;
                        if (target === "newtab" || target === "newwindow") {
                            window.open(data.href, 'popUpWindow', (target === "newwindow") ? "status=yes" : "");
                        } else {
                            location.href = data.href;
                        }
                    } else {
                        Console.log("invalid URL for credits")
                    }
                };
                var mouseHandlers = {
                        "click": click
                    },
                    touchHandlers = {
                        "tap": click
                    };
                attachevents(title, mouseHandlers, touchHandlers);
            }

            if (isTextBox) {
                var userdataCanvasFontColor = chart.userdata.canvas ? chart.userdata.canvas.fontColor : null;

                title
                    .attr({
                        "x": titleAlign.x,
                        "y": titleAlign.y,
                        "dy": titleAlign.dy + "em",
                        "text-anchor": titleAlign.textAnchor
                    })
                    .style({
                        "cursor": defined(data.href) ? "pointer" : "auto",
                        "display": "block"
                    })
                    .text(decodeHTML(data.text));

                if (data.tooltip === true) {
                    addSVGtitleEle(title)
                }

                applyFont(title, [{
                    fontColor: (type === "subtitle" && !defined(data.fontColor) && !defined(userdataCanvasFontColor)) ? "#CCCCCC" : data.fontColor || userdataCanvasFontColor
                }, data, systemConfig.canvas, $ZCG]);
            } else {
                title
                    .attr({
                        "x": titleAlign.x + (data.hAlign === "right" ? -data.imageWidth : 0),
                        "y": titleAlign.y + (data.vAlign === "bottom" ? -data.imageHeight : 0),
                        "width": data.imageWidth,
                        "height": data.imageHeight,
                        "xlink:href": data.imageUrl
                    })
                    .style({
                        "cursor": defined(data.href) ? "pointer" : "auto",
                        "display": "block"
                    });
            }

            //validate for long text value
            var titlenode = bbox(title.node());
            var textBounds = {
                    "left": floating ? data.x + margin.left : titlenode.x,
                    "top": floating ? data.y + margin.top : titlenode.y,
                    "width": titlenode.width,
                    "height": titlenode.height
                },
                edge = {
                    "left": margin.left,
                    "top": margin.top,
                    "right": chart.canvasarea.width - margin.right,
                    "bottom": chart.canvasarea.height
                };
            trimText(title.node(), decodeHTML(data.text), textBounds, edge, "bottom", "..", {
                "left": 5,
                "right": 5,
                "top": 5,
                "bottom": 5
            });

            if (!floating) {
                var nodeHeight = titlenode.height + margin.bottom + margin.top;
                if (data.vAlign === "top") {
                    chart.chartarea.top += nodeHeight;
                    chart.chartarea.height -= nodeHeight;
                }
                if (data.vAlign === "bottom") {
                    chart.chartarea.height -= nodeHeight;
                }
            }
        }

        titlearea.selectAll((element === "none") ? "text,image" : ((element === "image") ? "text" : "image"))
            .style("display", "none");
    };

    /**
     *
     */

    Chart.prototype.getChartSeriesColor = function() {
        var chart = this,
            systemConfig = chart.systemConf,
            colors = [],
            legend_data = systemConfig.legend;

        if (legend_data.colors) {
            if (!isArray(legend_data.colors)) {
                var legendColors = [];
                for (var key in legend_data.colors) {
                    if (legend_data.colors.hasOwnProperty(key)) {
                        legendColors.push(legend_data.colors[key]);
                    }
                }
                colors = legendColors;
            } else {
                colors = legend_data.colors;
            }

        } else if (legend_data.imagePallete) {
            chart.patternImageSizes = [];
            var imagePallete = $ZC.legutil.imagePallete.get(legend_data.imagePallete);
            chart.imagePallete = imagePallete;

            var defaultSize = (legend_data.imagePallete === "stripes") ? null : 50;
            var tempImage = appendEle($ZCG.patternSVG, "image", [1], ".", "class", "tempImage");

            imagePallete.map(function(d, i) {
                tempImage
                    .attr("xlink:href", d);

                var bb = bbox(tempImage.node());

                chart.patternImageSizes[i] = [defaultSize || bb.width || 3, defaultSize || bb.height || 3];
            });
            tempImage.remove();

        } else if (legend_data.colorPallete) {
            if (legend_data.colorPallete.type === "monochrome") {
                colors = $ZC.legutil.getMonochromeColorPallette(legend_data.colorPallete.options.monochrome);
            } else {
                colors = $ZC.legutil.colorpallete.get(legend_data.colorPallete.options.multicolor) || $ZC.legutil.colorpallete.get("flat-ui-colors");
            }
        }

        if (legend_data.patterns) {
            chart.patternPallete = legend_data.patterns;
        } else if (legend_data.patternPallete) {
            var patternPallete = $ZC.legutil.patternPallete.get(legend_data.patternPallete);
            if (!defined(patternPallete) && isArray(legend_data.patternPallete) && legend_data.patternPallete.length) {
                patternPallete = legend_data.patternPallete;
            }
            chart.patternPallete = patternPallete;
        }
        /*
         * setting seriesdata color
         */
        if (defined(colors)) {
            chart.seriesColor = colors.slice(0, colors.length);
            chart.seriesdata.map(function(d, i) {
                if (defined(d.color)) {
                    chart.seriesColor[i] = d.color;
                }
            })
        }
    };

    /**
     *
     */
    Chart.prototype.updatePlotareaProp = function() {
        var chart = this,
            systemConfig = chart.systemConf,
            container = chart.container,
            plotareaProp = container.selectAll("div.plotarea-property"),
            plotareaBorderProp = chart.staticPaneSVG.selectAll("g.plotareaBorder-property");

        var styles = {
            "position": "absolute",
            "left": chart.plotarea.left + "px",
            "top": chart.plotarea.top + "px",
            "width": chart.plotarea.width + "px",
            "height": chart.plotarea.height + "px",
            "pointer-events": "none",
            "box-sizing": "border-box"
        };
        // for adding prefix css
        styles[$Browser.prefix.css + "box-sizing"] = "border-box";

        container.selectAll("div.plotarea-property")
            .style(styles);
        plotareaBorderProp.attr({
            "transform": "translate(" + chart.plotarea.left + "," + chart.plotarea.top + ")"
        });
        chart.updateCommonBBSProp(plotareaProp, plotareaBorderProp, systemConfig.chart.plot, "plotarea");
    };

    /**
     *
     */

    Chart.prototype.drawPlotareaClippath = function() {
        var chart = this,
            systemConfig = chart.systemConf,

            //If the plot is zoomed, dont consider the marker size for clipPath
            zoomedX = isObjectPropDefined(systemConfig, "chart.zoom.x") || defined(chart.scrolledX),
            zoomedY = isObjectPropDefined(systemConfig, "chart.zoom.y") || defined(chart.scrolledY),
            axisrotated = chart.dataObject.getAxisRotated(),
            ms = getMarkerSize(chart),//ms -> Marker Size

            x = ((axisrotated ? zoomedY : zoomedX) ? 0 : -ms.left),
            y = ((axisrotated ? zoomedX : zoomedY) ? 0 : -ms.top),
            width = (chart.plotarea.width + ((axisrotated ? zoomedY : zoomedX) ? 0 : (ms.left + ms.right))),
            height = (chart.plotarea.height + ((axisrotated ? zoomedX : zoomedY) ? 0 : (ms.top + ms.bottom)));

        var properties = {
                name: "rect",
                id: chart.id,
                x: x,
                y: y,
                width: width,
                height: height
            },
            args = {
                chartObj: chart
            };
        var clipID = effects.get(svg_clips, "rect", properties, args);

        chart.wrap.selectAll("g.seriesholder")
            .attr('clip-path', "url(" + chart.defsLocation + "#" + clipID + ")");
        chart.staticPaneSVG.selectAll("g.labelholder,g#zcscatterhighlight,g#zcareahighlight,path#zcbarhighlight")
            .attr('clip-path', "url(" + chart.defsLocation + "#" + clipID + ")");

    };

    /**
     *
     * @param update
     */

    Chart.prototype.drawThreshold = function(update) {
        if ($ZC.axis.threshold) {
            $ZC.axis.threshold(this, update)
        }
    };

    /**
     *
     * @param update
     */
    Chart.prototype.handleEvent = function(update) {
        var chart = this,
            systemConfig = chart.systemConf;

        if (!update) {
            var eventgroup = chart.staticPaneSVG.selectAll("g.eventgroup")
                .style({
                    "pointer-events": "visible"
                });


            var areahighlight = eventgroup.append("g")
                .attr("id", "zcareahighlight");

            areahighlight.append("path").attr("id", "areapath");

            var barhighlight = eventgroup.append("g")
                .attr("id", "zcbarhighlight");

            barhighlight.append("path").attr("id", "barpath");

            if (systemConfig.tooltip.crosshair) {
                var crosshairEle = appendEle(eventgroup, "g", [1], ".", "class", "crosshair");
                crosshairEle.style("visibility", "hidden");
                appendEle(crosshairEle, "line", [1], ".", "class", "x-crosshair");
                appendEle(crosshairEle, "line", [1], ".", "class", "y-crosshair");
            }
            var scatterhighlight = eventgroup.append("g")
                .attr("id", "zcscatterhighlight");

            if (chart.dataObject.isHierarchy) {
                eventgroup.append("g")
                    .attr("id", "zchierarchyhighlight")
                    .style({
                        "opacity": 0,
                        "pointer-events": "none"
                    });
            }

            chart.eventHandler = $ZC.events.mouseevents(chart, chart.tooltip.element, systemConfig, chart.plotarea, chart.dataset, chart.axes.x.scale, chart.barscale1, chart.barscale2, chart.axes.y.groups,
                eventgroup, chart.seriesColor, chart.labelHighlighter);
            chart.eventHandler.initializeListener();
        } else {
            chart.eventHandler.updateParams(chart);
        }
        if (chart.xymultiRenderer || chart.dataObject.isPolarAxisCategory) {
            drawBorderBox(chart.eventHandler.trackerElement, chart.plotarea);
        }
        addDefaultScroll(chart);
    };

    /**
     *
     */

    Chart.prototype.redraw = function() {
        var chart = this,
            systemConfig = chart.systemConf;

        chart.svg
            .style({
                "width": chart.container.style("width"),
                "height": chart.container.style("height")
            });
        chart.staticPaneSVG
            .style({
                "width": chart.container.style("width"),
                "height": chart.container.style("height")
            });
        chart.resetdata(systemConfig);
        Chart.helpers.constructChartGroups(chart);
        chart.render(true);
    };

    /**
     *
     * @param newSystemConf
     */

    Chart.prototype.resetdata = function(newSystemConf) {
        var chart = this;
        chart.chartHeight = parseFloat(chart.container.style("height"));
        chart.chartWidth = parseFloat(chart.container.style("width"));
        chart.setCanvasDimension();
        chart.chartTypes = chart.dataProcessorHelpers.getAllChartTypes(newSystemConf, "object");
        chart.processUserData(newSystemConf, true);
        chart.setChartDimension();
        chart.globalProp = setGlobalPropByUserdata(newSystemConf, {
            "width": chart.canvasarea.width,
            "height": chart.canvasarea.height
        }, chart.chartFontProp);
        chart.events = {};
        if (chart.dataObject) {
            chart.dataObject.formattedData = {
                x: [],
                y: []
            };
        }
    };

    /**
     *
     * @param series
     * @param i
     * @param axisorder
     * @param updateAllAxes
     */

    Chart.prototype.addRemoveSeries = function(series, i, axisorder, updateAllAxes) {

        var chart = this,
            systemConfig = chart.systemConf;

        chart.dataObject.formattedData = {
            x: [],
            y: []
        };
        chart.dataObject.initialize("addorremoveseries");

        stateChangeListener(chart, systemConfig.chart.axes.events, null, "init");
        if (chart.isAxisCategory) {
            var brushExtent = chart.brush && chart.brush.extent;
            chart.updateZscale();
            if (updateAllAxes) {
                chart.axes.y.groups.forEach(function(d, i) {
                    chart.updateScale([i, 0], "y");
                })
            } else {
                chart.updateScale(axisorder, "y");
            }

            chart.updateScale(0, "x", brushExtent);
            if(chart.dataObject.hierarchical){
                chart.axes.x.rangeScale = chart.axes.x.scale.copy();
                if(chart.dataObject.hierarchical.groupByDiscreteTime) {
                    chart.axes.x.rangeScale.domain(d3.range(chart.axes.x.scale.domain().length));
                }
                chart.dataObject.hierarchical.setRanges(chart.axes.x.rangeScale); // initialize ranges
                chart.axes.x.levels.forEach(function(d,i){
                    chart.updateScale(axisorder, "x",null,i+1);
                })
            }
            chart.drawThreshold(true);
            chart.drawPlotareaClippath();
            chart.updatePlotareaProp();
        } else if (chart.dataObject.isPolarAxisCategory) {
            $ZC.axis.polar.render(chart, "x");
        }

        stateChangeListener(chart, systemConfig.chart.axes.events, null, "onreload");
        // update the events
        chart.events = {};
        chart.plot.renderer.draw(true);
        if (chart.isAxisCategory || chart.dataObject.isPolarAxisCategory) {
            drawBorderBox(chart.eventHandler.trackerElement, chart.plotarea);
            chart.eventHandler.updateParams(chart);
            addDefaultScroll(chart, "addorremoveseries");
        }
    };

    /**
     *
     * @param container
     */

    Chart.prototype.showLoading = function(container) {
        var chart = this,
            systemConfig = chart.systemConf;

        var data = systemConfig.loader;
        if (data.enabled === true && data.type !== "none") {
            var loader = appendEle(this.container.selectAll("div.d3container"), "div", [1], ".", "class", "loading");
            loader
                .style("position", "absolute")
                .html(Chart.helpers.getLoader(chart, data));
            applyFont(loader, [data, systemConfig.chart, systemConfig.canvas, $ZCG], true);
            var node = loader.node();
            loader.style({
                "left": ((chart.chartarea.width / 2) - (node.offsetWidth / 2)) + "px",
                "top": ((chart.chartarea.height / 2) - (node.offsetHeight / 2)) + "px"
            })
        }
    };

    Chart.prototype.hideLoading = function() {
        this.container.selectAll("div.loading").remove();
    };


    /**
     * Add data point to single series or multiple series
     * @param seriesidx
     * @param point
     * @param shift
     */
    Chart.prototype.pushDataPoint = function(seriesidx, point, shift) {
        var chart = this,
            isComboChart = chart.dataObject.isCombinationalChart,
            orderedSeriesdata = (isComboChart) ? renderer_helpers.arrangeSeriesRenderingOrder(chart.seriesdata) : chart.seriesdata;

        // If series indices were not of ARRAY type, then convert it to array and process
        if (!(Array.isArray(seriesidx))) {
            var seriesidx_arr = [],
                point_arr = [];
            seriesidx_arr.push(seriesidx);
            point_arr.push(point);
            seriesidx = seriesidx_arr;
            point = point_arr
        }

        seriesidx.forEach(function(d, i) {
            var currOrdereddata = orderedSeriesdata[d],
                curSeriesidx = (isComboChart) ? currOrdereddata.seriesidx : d,
                series = chart.seriesdata[curSeriesidx],
                renderer = chart.renderer[curSeriesidx],
                shiftPoint, shiftInfo

            series.data[0].push(point[i]);

            if (shift) {
                shiftPoint = series.data[0][0];
                var shiftedData = series.data[0].shift();
                if (defined(renderer.shiftInfo())) {
                    shiftInfo = renderer.shiftInfo();
                    shiftInfo.count++;
                } else {
                    shiftInfo = {};
                    shiftInfo.count = 0;
                }
                shiftInfo.point = shiftPoint;
                shiftInfo.shiftedData = shiftedData;
                renderer.shiftInfo(shiftInfo)
            } else {
                renderer.shiftInfo(null)
            }

            if (chart.ismultiy) {
                chart.updateScale(series, "y");
            }
        });

        chart.dataObject.initialize();
        chart.updateScale(null, "x");
        if (!chart.ismultiy) {
            chart.updateScale(chart.seriesdata[0], "y");
        }
        chart.plot.renderer.draw(true);
        chart.drawThreshold(true);
        chart.eventHandler.updateParams(chart);
    };

    /**
     *
     * @param seriesidx
     */

    Chart.prototype.popDataPoint = function(seriesidx) {
        var chart = this,
            series = chart.seriesdata[seriesidx];

        series.data.forEach(function(d) {
            d.pop()
        });
        chart.dataObject.initialize();
        chart.updateScale(series, "x");
        chart.updateScale(series, "y");
        chart.plot.renderer.draw(true);
        chart.drawThreshold(true);
        chart.eventHandler.updateParams(chart);
    };

    /**************** Zooom ********************/

    /**
     *
     * @param type
     */
    Chart.prototype.zoomON = function(type) {
        var chart = this;
        chart.changeZoomType(type);
        var zoomObj = chart.zoom;
        if (!zoomObj) {
            chart.eventHandler.initializeZoomListener();
        }
    };

    /**
     *
     */
    Chart.prototype.zoomOFF = function() {
        var chart = this;
        var zoomObj = chart.zoom;
        if (zoomObj) {
            zoomObj.reset();
        }
        chart.changeZoomType("none");
    };

    /**
     *
     * @param seriesidx
     * @param range
     */
    Chart.prototype.zoomX = function(seriesidx, range) {
        var chart = this;
        chart.changeZoomType("x");
        if (!chart.zoom) {
            chart.eventHandler.initializeZoomListener();
        }
        var zoomObj = chart.zoom;
        zoomObj.zoomed(null, seriesidx, range);
    };

    /**
     *
     * @param seriesidx
     * @param range
     */
    Chart.prototype.zoomY = function(seriesidx, range) {
        var chart = this;
        chart.changeZoomType("y");
        if (!chart.zoom) {
            chart.eventHandler.initializeZoomListener();
        }
        var zoomObj = chart.zoom;
        zoomObj.zoomed(null, seriesidx, null, range);
    };

    /**
     *
     * @param seriesidx
     * @param xrange
     * @param yrange
     */
    Chart.prototype.zoomXY = function(seriesidx, xrange, yrange) {
        var chart = this;
        chart.changeZoomType("xy");
        if (!chart.zoom) {
            chart.eventHandler.initializeZoomListener();
        }
        var zoomObj = chart.zoom;
        zoomObj.zoomed(null, seriesidx, xrange, yrange);
    };

    /**
     *
     * @param type
     */
    Chart.prototype.changeZoomType = function(type) {
        var chart = this,
            systemConfig = chart.systemConf;

        if (!systemConfig.chart.zoom) {
            $ZC.setDefaultOptions("zoom", systemConfig.chart, chart.globalProp);
        }
        systemConfig.chart.zoom.type = type;
    };

    /**
     *
     * @param data
     * @param ele
     */
    Chart.prototype.handleNoData = function(data, ele) {

        var chart = this,
            systemConfig = chart.systemConf,
            nodatawrap = pick(ele, chart.wrap.selectAll("g.nodatahandler"));

        if (defined(data.htmlEl)) {
            var customHandler = appendEle(chart.container.selectAll("div.canvas-component"), "div", [1], ".", "class", "nodatahandler");
            customHandler
                .style("position", "absolute")
                .html(data.htmlEl);

            var node = customHandler.node();
            customHandler.style({
                "left": validateNullVal(data.x, (chart.availableWidth - node.offsetWidth) / 2) + "px",
                "top": validateNullVal(data.y, (chart.availableHeight - node.offsetHeight) / 2) + "px"
            });
        } else if (defined(data.imageUrl)) {
            var image = appendEle(nodatawrap, "image", [1]);
            image
                .attr({
                    "x": data.x || (chart.chartarea.width / 2) - 50,
                    "y": data.y || (chart.chartarea.height / 2) - 50,
                    "width": 100,
                    "height": 100,
                    "xlink:href": data.imageUrl
                });
        } else if (defined(data.text)) {

            var text = appendEle(nodatawrap, "text", [data], ".", "class", "nodata");
            text
                .attr({
                    "x": data.x || chart.chartarea.width / 2,
                    "y": data.y || chart.chartarea.height / 2,
                    "text-anchor": "middle"
                })
                .text(decodeHTML(data.text || "No Data"));
            applyFont(text, [data, systemConfig.canvas, $ZCG]);
        }
    };

    /**
     *
     */
    Chart.prototype.destroy = function() {
        var chart = this;

        if (chart.eventHandler) {
            clearTimeout(chart.eventHandler.mouseouttimer);
            clearTimeout(chart.eventHandler.mousemovetimer);
            clearTimeout(chart.eventHandler.tooltipElement.timeout);
            chart.eventHandler.tooltipElement.destroy();
        }
        chart.container.datum(null);
        chart.d3container.remove();
        // var prop;
        // for(prop in chart) {
        //     delete chart[prop];
        // }
        chart.destroying = true;
    };

    /**
     *
     * @param data
     * @returns {*}
     */



    /************************** Helpers ****************/

    Chart.helpers = {

        initializeChartHolders: function(chart) {

            var container = chart.container,
                width_style, height_style;

            var d3container = container.selectAll("div.d3container");
            if (!d3container.empty()) {
                // If user going to create a new chart in the same container again, destroy the previous chart object
                var prevChartObj = d3container.datum();
                if (prevChartObj && prevChartObj.destroy) {
                    prevChartObj.destroy();
                }

                d3container.remove();
            }

            width_style = pick(parseFloat(container.style("width")), 960);
            height_style = pick(parseFloat(container.style("height")), 400);

            d3container = chart.d3container = appendEle(container, "div", [chart], ".", "class", "d3container");
            var styles = {
                "width": width_style + "px",
                "height": height_style + "px",
                "position": "relative",
                "left": "0px",
                "top": "0px",
                "box-sizing": "border-box",
                "-moz-user-select": "none",
                "-webkit-user-select": "none",
                "-ms-user-select": "none",
                "user-select": "none"
            };
            // for adding prefix css
            styles[$Browser.prefix.css + "box-sizing"] = "border-box";
            d3container.style(styles);

            //CANVASPROP - canvas area properties-border,background,shadow
            appendEle(d3container, "div", [1], ".", "class", "canvas-property");
            //PLOTAREA PROP - plotarea background prop
            appendEle(d3container, "div", [1], ".", "class", "plotarea-property");

            // Overview container for scroll
            appendEle(d3container, "div", [1], ".", "class", "zcoverview");

            //main canvas area - svg
            var canvas = appendEle(d3container, "div", [1], ".", "class", "canvas-component");
            canvas.style("-webkit-tap-highlight-color", "transparent");

        var tooltipElement = appendEle(BASE_HELPER_CONTAINER, "div", [1], "#", "id", "zctooltip" + CURRENT_CHART_COUNT);
        tooltipElement[0][0].isTooltipContainer = true;
        
        chart.tooltip = {
            "element": tooltipElement
        };
        chart.tooltip.element
            .style({
                "position": "fixed",
                "display": "inline-block",
                "visibility": "hidden",
                "white-space": "nowrap",
                "background-color": "white",
                "border": "1px solid",
                "-webkit-tap-highlight-color": "transparent"
            });

        chart.svg = appendEle(canvas, "svg", [1], ".", "class", "svgarea");
        chart.svg
            .style({
                "width": width_style + "px",
                "height": height_style + "px",
                "position": "absolute",
                "top": 0,
                "left": 0
            });
        
        

            var staticPane = d3_select(chart.svg.node().parentNode).datum(chart)
                .style({
                    "width": chart.container.style("width"),
                    "height": chart.container.style("height")
                });
            chart.staticPaneSVG = staticPane.append("svg")
                .attr("class", "static")
                .style({
                    "width": chart.container.style("width"),
                    "height": chart.container.style("height"),
                    "position": "absolute",
                    "top": 0,
                    "left": 0,
                    "pointer-events": "none"
                });

            chart.legendarea.element = canvas.append("div").attr("class", "legendarea");
            chart.notes = canvas.append("div").attr("class", "zcnotes");
        },

        removeChartHolders: function(chart) {
            var container = chart.container;
            container.select("div.d3container") //No I18N
                .remove();

            container.select("div.zc-staticPane") //No I18N
                .remove();
            container.select("div.zc-chartPane") //No I18N
                .remove();
        },

        /**
         *
         * @param hAlign
         * @param vAlign
         * @param box
         * @param margin
         * @returns {{}}
         */

        align: function(hAlign, vAlign, box, margin) {
            var attr = {};
            //hAlign
            if (hAlign === "center") {
                attr.x = box.width / 2 + (margin.left);
                attr.textAnchor = "middle";
            } else if (hAlign === "left") {
                attr.x = (box.left) + (margin.left);
                attr.textAnchor = "start";
            } else if (hAlign === "right") {
                attr.x = box.width + box.left - (margin.right);
                attr.textAnchor = "end";
            }
            //vAlign
            if (vAlign === "top") {
                attr.y = (box.top) + (margin.top);
                attr.dy = 1;
            } else if (vAlign === "bottom") {
                attr.y = box.height + box.top - (margin.bottom);
                attr.dy = -0.21;
            }
            return attr;
        },

        getLoader: function(chart, data) {
            var htmlEl = data.htmlEl,
                imageUrl = data.imageUrl,
                type = data.type,
                text = data.text,
                colors = data.colors;
            if (htmlEl) {
                return htmlEl;
            } else if (imageUrl) {
                return "<img src=" + imageUrl + " height=" + data.imageHeight + " width=" + data.imageWidth + ">";
            } else {
                var html = "",
                    ele = null;
                if (type) {
                    var loaderDiv = chart.container.selectAll("div.loading");
                    colors = (colors && colors.length) ? colors : null;
                    ele = ZCloader(loaderDiv, {
                        "type": type,
                        "colors": colors
                    });

                    var XMLS = new XMLSerializer();
                    html = XMLS.serializeToString(ele); // Converting DOM node into a string
                }
                if (text) {
                    html += "<p style=position:relative;display:inline-block>" + text + "</p>";
                }
                return html;
            }
        },

        constructChartGroups: function(chart) {

            var svg = chart.svg,
                systemConfig = chart.systemConf,
                chartHeight = chart.chartHeight,
                chartWidth = chart.chartWidth;
            //Title area
            var istitle = systemConfig.canvas.title.show === true && dimension_based_intelligence(chart, "title", chartHeight);
            appendEle(svg, "g", groupdata(istitle), ".", "class", "charttitle");

            //Subtitle area
            var issubtitle = systemConfig.canvas.subtitle.show === true && dimension_based_intelligence(chart, "subtitle", chartHeight);
            appendEle(svg, "g", groupdata(issubtitle), ".", "class", "chartsubtitle");
            //Credit Area
            var iscredits = systemConfig.credits && systemConfig.credits.enabled === true && dimension_based_intelligence(chart, "credits", chartHeight);
            appendEle(svg, "g", groupdata(iscredits), ".", "class", "chartcredits");

            var wrap = chart.wrap = appendEle(svg, "g", [systemConfig], ".", "class", "xychart");

            if (chart.nochartdata) {
                appendEle(wrap, "g", [1], ".", "class", "nodatahandler");
            } else {
                appendEle(wrap, "g", [0], ".", "class", "nodatahandler");
                var chartgroup = appendEle(wrap, "g", [chart.seriesdata], ".", "class", "chartgroup");

                var isxaxis = systemConfig.chart.axes.xaxis.show === true;
                //xaxisgroup
                appendEle(chartgroup, "g", groupdata(isxaxis), ".", "class", "x-axis");
                //yaxisgroup
                appendEle(chartgroup, "g", [chart.seriesdata], ".", "class", "y-axis");

                // Underlay threshold - So that threshold range will render first and then plot will be rendered
                appendEle(chartgroup, "g", [chart.seriesdata], ".", "class", "threshold");

                //series group
                var seriesgroup = appendEle(chartgroup, "g", [chart.seriesdata], ".", "class", "seriesholder");
                chart.filterEffectsID = getChartEffects(systemConfig);
                seriesgroup.attr("filter", (chart.filterEffectsID ? "url(" + chart.defsLocation + "#" + chart.filterEffectsID + ")" : null));

                var onlyBarChart = chart.dataObject.noofBarEnabledSeries && !chart.dataObject.isCombinationalChart; // For bar charts, the element should be before the highlighting element
                if (!onlyBarChart) {
                    //labelgroup
                    var labelgroup = appendEle(chart.staticPaneSVG, "g", [chart.seriesdata], ".", "class", "labelholder");
                }

                //thgroup
                appendEle(chart.staticPaneSVG, "g", [chart.seriesdata], ".", "class", "threshold");


                //plotarea border properties,as border has to be drawn over axis tickmarks // also below the event rect
                var plotBorder = appendEle(chart.staticPaneSVG, "g", [1], ".", "class", "plotareaBorder-property");
                var isplotBorder = systemConfig.chart.plot.border.show === true;
                appendEle(plotBorder, "path", groupdata(isplotBorder), ".", "class", "plotBorderPath");

                //eventgroup
                appendEle(chart.staticPaneSVG, "g", [1], ".", "class", "eventgroup");

                if (onlyBarChart) {
                    //labelgroup
                    var labelgroup = appendEle(chart.staticPaneSVG, "g", [chart.seriesdata], ".", "class", "labelholder");
                    labelgroup
                        .style("pointer-events", "none");
                }

                // Dummy rect added for filter - ISSUE : http://www.inkscapeforum.com/viewtopic.php?t=18611
                appendEle(seriesgroup, "rect", [1], ".", "class", "dummy-rect-filter");

                var isContinousLegend = legend_helpers.isContinousLegend(chart);

                var legendarea = appendEle(svg, "g", isContinousLegend ? [1] : [], ".", "class", "legendarea");
                if (isContinousLegend) {
                    chart.legendarea.element = legendarea;
                }


            }

            function groupdata(show) {
                return show ? [1] : [];
            }
        }
    };

    /**
     *
     * @type {Chart}
     */
    exports.Chart = Chart;

})($ZC);//$Id$
/* Default global prop */
/*$ZCG stands for ZohoChartsGlobal object
 All global properties and methods are set here.
 */
var $ZCG = {};
$ZCG.fontFamily = "'Roboto','Open Sans',sans-serif";
$ZCG.fontColor = "#616161";
$ZCG.fontStyle = null;
$ZCG.fontWeight = null;
$ZCG.fontL1Size = null;
$ZCG.fontL2Size = null;
$ZCG.fontL3Size = null;

function calculateGlobalFontSize(userdata, globalFontSize, chartFontSize, denominator) {
    var props = toArray(arguments).slice(4),
        temp = null,
        fontSize;

    for (var i = 0, len = props.length; i < len + 1; i++) {
        fontSize = (i === len) ? null : getPropVal(userdata, props[i]);
        temp = calcfontSize(denominator, null, fontSize, globalFontSize, chartFontSize);
        if (isNumber(fontSize)) {
            break;
        }
    }
    return temp;
}

function setGlobalPropByUserdata(userdata, denominator, chartProp) {
    
    // denominator is an object. It contains {"width": chart_width, "height": chart_height}
    
    $ZCG.globalProp = {};
    
    //font size
    chartProp.fontL1Size = calculateGlobalFontSize(userdata, $ZCG.fontL1Size, chartProp.fontL1Size, denominator, "canvas.fontSize");
    chartProp.fontL2Size = calculateGlobalFontSize(userdata, $ZCG.fontL2Size, chartProp.fontL2Size, denominator, "chart.fontSize", "canvas.fontSize");
    
    //font color
    $ZCG.globalProp.fontL1Color = null;
    $ZCG.globalProp.fontL2Color = null;
    
    //font family
    $ZCG.globalProp.fontL1Family = null;
    $ZCG.globalProp.fontL2Family = null;
    
    //font style
    $ZCG.globalProp.fontL1Style = null;
    $ZCG.globalProp.fontL2Style = null;
    
    //font weight
    $ZCG.globalProp.fontL1Weight = null;
    $ZCG.globalProp.fontL2Weight = null;
    
    //text shadow
    $ZCG.globalProp.textShadow = null;
    
    //animation
    var userAnimation = pick(getPropVal(userdata, "chart.plot.animation"), {});

    $ZCG.globalProp.animation = {};
    $ZCG.globalProp.animation.enabled = userAnimation.enabled !== false;
    $ZCG.globalProp.animation.duration = userAnimation.duration || null;
    $ZCG.globalProp.animation.easingType = userAnimation.easingType || null;
    
    //datalabels
    $ZCG.globalProp.datalabels = {}
    chartProp.datalabels = (chartProp.datalabels == null) ? {} : chartProp.datalabels;
    $ZCG.globalProp.datalabels.enabled = null
    chartProp.datalabels.fontSize = calculateGlobalFontSize(userdata, $ZCG.fontL3Size, chartProp.datalabels.fontSize,
        denominator, "chart.plot.datalabels.fontSize", "chart.fontSize", "canvas.fontSize");

    $ZCG.globalProp.datalabels.fontColor = null
    $ZCG.globalProp.datalabels.fontFamily = null
    $ZCG.globalProp.datalabels.fontStyle = null
    $ZCG.globalProp.datalabels.fontWeight = null
    
    //events
    $ZCG.globalProp.events = {}
    $ZCG.globalProp.events.mouseMove = null
    $ZCG.globalProp.events.mouseOut = null
    $ZCG.globalProp.events.click = null
    $ZCG.globalProp.events.doubleClick = null
    
    return chartProp;
}

/*
 * font size are calculated based on viewport of the chart placeholder.
 * L1 to L5 sizes are defined, based on the width and height which ever is minimum, the font-size is set.
 * */
function calcfontSize(dimension, multiplier, customFontSize, globalFontSize, chartFontProp) {
    
    var denominator = mathMin(dimension.width, dimension.height);
    var globalMultiplier = isObjectPropDefined($ZC, "fontProperties.ratio") && $ZC.fontProperties.ratio;
    if (typeof globalMultiplier === "function") {
        globalMultiplier = globalMultiplier(dimension);
    }
    multiplier = (multiplier == null) ?
        globalMultiplier && !isNaN(globalMultiplier) ? globalMultiplier : 0.038 :
        multiplier;
    
    var defaultSize = mathRound(denominator * multiplier);
    
    $ZCG.minL1Size = $ZC.fontProperties.minsize;
    $ZCG.maxL1Size = $ZC.fontProperties.maxsize;
    var min = $ZCG.minL1Size,
        max = $ZCG.maxL1Size;
    var fontSize = {}
    defaultSize = (defaultSize < min) ? min : (defaultSize > max) ? max : defaultSize;
    
    
    if (customFontSize != null) {
        multiplier = (pInt(customFontSize) * multiplier) / defaultSize;
        defaultSize = mathRound(denominator * multiplier);
        defaultSize = (defaultSize < min) ? min : (defaultSize > max) ? max : defaultSize;
    }
    var chartFontProp = (globalFontSize == null) ? (chartFontProp == null) ? {} : chartFontProp : globalFontSize;
    chartFontProp.size = defaultSize;
    chartFontProp.l1 = function() {
        return chartFontProp.size;
    }
    chartFontProp.l2 = function() {
        return chartFontProp.size - 2;
    }
    chartFontProp.l3 = function() {
        return chartFontProp.size - 3;
    }
    chartFontProp.l4 = function() {
        return chartFontProp.size - 4;
    }
    chartFontProp.l5 = function() {
        return chartFontProp.size - 5;
    }
    
    return chartFontProp;
}

/*Helpful for Developement
 * defining DOMBorder will show you the area division lines in the chart
 * */
$ZCG.DOMBorder = "none";

var $Browser = new function() {
    this.NETSCAPE = 0;
    this.FIREFOX = 0;
    this.OPERA = 0;
    this.IE = 0;
    this.SAFARI = 0;
    this.MOZILA = 0;
    this.CHROME = 0;
    this.NONIE = 1;
    this.WEBKIT = 0;
    var agent = navigator.userAgent.toLowerCase();
    this.OSX = (agent.indexOf('mac') != -1);
    this.LINUX = (agent.indexOf('linux') != -1);
    this.IPHONE = ((agent.indexOf('iphone') != -1));
    this.IPAD = ((agent.indexOf('ipad') != -1));
    this.ANDROID = (agent.indexOf("android") != -1);
    this.IS_IOS = (this.IPHONE || this.IPAD);
    this.isTouchDevice = ("ontouchstart" in window) || (navigator.maxTouchPoints > 0) || (navigator.msMaxTouchPoints > 0);
    this.isMouseDevice = !(this.IS_IOS || this.ANDROID || (agent.indexOf('mobile') != -1));
    this.uiwebview = this.IS_IOS && !/safari/.test(agent);
    var prefix = "";
    this.detect = function() {
        var agent = navigator.userAgent;
        var uaLen = agent.length;
        var vendor = navigator.vendor;
        var operaObject = window.opera;
        var versionSub = "";
        if (operaObject) {
            this.OPERA = 1;
            prefix = "o";
        } else if (agent.indexOf("Chrome") > -1) {
            this.CHROME = 1;
            versionSub = "Chrome/";
            prefix = "webkit";
        } else if (agent.indexOf("Firefox") > -1) {
            this.FIREFOX = 1;
            versionSub = "Firefox/";
            prefix = "moz";
        } else if (agent.indexOf("MSIE ") > -1 || agent.indexOf("Trident/") > -1) {
            this.IE = 1;
            versionSub = "MSIE ";
            prefix = "ms";
        } else if (vendor.indexOf("Apple") > -1) {
            this.SAFARI = 1;
            versionSub = "Version/";
            prefix = "webkit";
        } else {
            versionSub = "Unknown Browser";
        }
        this.VERSION = agent.substring(agent.indexOf(versionSub), uaLen).match(/[0-9\.]+/)[0];
    };
    this.detect();
    this.NONIE = !this.IE;
    this.WEBKIT = (this.SAFARI || this.CHROME);
    this.prefix = {
        lowercase: prefix,
        css: (prefix) ? '-' + prefix + '-' : prefix, //prefix = "" if browser is unknown
        js: (prefix) ? prefix[0].toUpperCase() + prefix.substr(1) : prefix //prefix = "" if browser is unknown
    }
};;

/**
 *
 * @param {Chart} chartInstance
 * @constructor
 */

function HierarchicalDataAdapter(chartInstance) {
    this.chart = chartInstance;
    this.originalSeries = chartInstance.seriesdata;
    this.initialize();
}


HierarchicalDataAdapter.prototype = {


    initialize: function() {

        var layout = this;

        layout.hierarchyLayout = true;
        layout.finalDepth = 0;
        layout.dataCount = 0;
        layout.categories = [];
        layout.leafNodes = [];
        layout.series = [];
        layout.categoriesByDepth = [];
        layout.globalChartType = layout.originalSeries.type;

    },

    /**
     *
     */
    setDepth: function() {
        var layout = this,
            categories = layout.categories,
            depths = layout.categoriesByDepth = [],
            leaves = layout.leafNodes = [],
            leafCategories = layout.leafCategories = [],
            categoriesList = layout.categoriesList = [],
            pointProperty = layout.dataType === TIME_DATATYPE || layout.groupByDiscreteTime ? "point" : "value";


        doDepth(categories, 0);

        /**
         *
         * @param {array} cats
         * @param {number} depth
         * @param {object} parent
         */

        function doDepth(cats, depth, parent) {

            if (depth > layout.finalDepth) {
                layout.finalDepth = depth;
            }

            cats.forEach(function(c) {

                if (defined(parent)) {
                    c.parent = parent;
                }

                if (!c.leaf) {
                    if (!depths[depth]) {
                        depths[depth] = [];
                        categoriesList[depth] = [];
                    }
                    categoriesList[depth].push(c[pointProperty]);
                    depths[depth].push(c);
                    doDepth(c.children, depth + 1, c)
                } else {
                    c.index = layout.dataCount++;
                    if (isArray(c.data)) {
                        c.data.forEach(function(d) {
                            d.index = c.index;
                        });
                    }
                    leaves.push(c);
                    leafCategories.push(c[pointProperty]); // store the values for reducing loops
                }
            });
        }
        categoriesList.reverse();
    },

    /**
     *
     */

    getCategories: function() {
        return this.categories;
    },

    /**
     *
     * @param depth
     * @returns {*}
     */
    getCategoriesByDepth: function(depth) {
        if (!defined(depth)) {
            depth = 0
        }

        var categories = {};
        categories.categories = categories.children = null;
        if (depth === this.finalDepth) {
            return this.leafNodes;
        }
        else if (depth < this.finalDepth) {
            categories.categories = this.categoriesByDepth[depth];
            categories.children = this.categoriesByDepth[depth].map(function(d) {
                return d.children;
            })
        }
        return categories
    },

    /**
     *
     * @param {number} itemIndex
     * @param {number} parentDepthIndex
     * @returns {object}
     */

    getParentByIndex: function(itemIndex, parentDepthIndex) {

        var layout = this,
            leaf = layout.leafNodes[itemIndex],
            parent = null,
            count = layout.finalDepth + 1;

        while (count--) {
            if (leaf.depth === parentDepthIndex) {
                parent = leaf;
                break
            } else if (leaf.depth === 0) {
                break;
            }
            leaf = leaf.parent;
        }
        return parent;
    },

    /**
     *
     * @param {function} leafScale
     * @returns {Array}
     */

    setRanges: function(leafScale) {


        var layout = this,
            isOrdinal = defined(leafScale.rangeBand),
            depth = layout.finalDepth,
            innerPadding = 0,
            outerPadding = 0,
            points = layout.leafNodes,
            firstPoint,
            lastPoint,
            ranges = leafScale.range();

        if (isOrdinal) {
            var span = isOrdinal && leafScale.rangeBand(),
                rangeExtent = leafScale.rangeExtent();

            firstPoint = points[0];
            lastPoint = points[points.length - 1];
            innerPadding = (ranges[1] - (ranges[0] + span)) / 2;
            outerPadding = ranges[0] - rangeExtent[0];
            outerPadding = mathMin(outerPadding, innerPadding);

        } else {

            firstPoint = points[0];
            lastPoint = points[points.length - 1];

            var continuousRangeBand = $ZC.scale.getContinuousRangeBand(leafScale, layout.leafCategories);
            innerPadding = continuousRangeBand.rangeBand / 2;
            outerPadding = continuousRangeBand.outerPaddingInPixel;
        }

        layout.scaleList = [];
        // layout.categoriesList = [];
        layout.rangeList = [];

        function setRange(d, i) {
            if (isLeafParent(d)) {
                d.rangeBand = getRangeBand(children[i]);
                tempRange = (isOrdinal ? leafScale(d.children[0].index) : leafScale(d.children[0].point)) - getSpan(d.children[0], true);
                d.range = [tempRange, tempRange + d.rangeBand];

            } else {
                d.rangeBand = d.children.reduce(sumLeaf, 0);
                d.range = [d.children[0].range[0], d.rangeBand + d.children[0].range[0]]
            }

            tempRangeBandList.push(d.rangeBand);
            tempRangeList.push(d.range);
        }

        while (depth--) {
            var obj = layout.getCategoriesByDepth(depth),
                children = obj.children,
                categories = obj.categories,
                tempRange, tempRangeBandList = [], tempRangeList = [];

            categories.forEach(setRange);
            // layout.rangeBandList.push(tempRangeBandList);
            layout.rangeList.push(tempRangeList);
        }

        /**
         *
         * @param d
         * @returns {*|boolean}
         */
        function isLeafParent(d) {
            return defined(d.children[0]) && d.children[0].leaf === true;
        }

        /**
         *
         * @param a
         * @param point
         * @returns {Number}
         */
        function sumLeaf(a, point) {
            if (point.leaf) {
                return a + span + getSpan(point, true) + getSpan(point);
            }
            return a + point.rangeBand;
        }

        /**
         *
         * @param children
         * @returns {*}
         */

        function getRangeBand(children) {
            if (layout.categoryTree) {
                return children.reduce(sumLeaf, 0);
            } else {

                var start = children[0],
                    end = children[children.length - 1],
                    pointProperty = "point",
                    barWidth = span;

                if (layout.groupByContinuousTime) {

                    barWidth = 0;

                    if (defined(layout.tickValues[start.index + 1])) {
                        var startTick = layout.tickValues[start.index],
                            nextTick = layout.tickValues[start.index + 1],
                            r = leafScale(nextTick) - leafScale(startTick);

                        innerPadding = r / 2;
                    }
                } else {
                    pointProperty = "index";
                }

                return (leafScale(end[pointProperty]) - leafScale(start[pointProperty])) + getSpan(start, true) + getSpan(end) + barWidth;
            }
        }

        /**
         *
         * @param {Object} point
         * @param {boolean} startSide
         * @returns {number}
         */

        function getSpan(point, startSide) {
            if ((startSide && point === firstPoint) || (!startSide && point === lastPoint)) {
            // if((firstPoint === point || lastPoint === point)) {
                return outerPadding;
            } else {
                return innerPadding
            }
        }

        return layout.scaleList;
    }
};

/* ********************************** Static Functions ****************************/

/**
 *
 * @param {Object} obj
 * @param {String} key
 * @return {Array}
 */

HierarchicalDataAdapter.getValuesByKey = function(obj, key) {
    var mapper = function(a) {
        return a[key];
    };
    return obj.map(mapper)
};

/**
 *
 * @param arr
 * @return {boolean}
 */

HierarchicalDataAdapter.is3D = function(arr) {
    return isArray(arr) && isArray(arr[0])
};

/**
 *
 * @param series
 * @return {boolean|*}
 */

HierarchicalDataAdapter.isArrayOfSeries = function(series) {
    return HierarchicalDataAdapter.is3D(series.data) && defined(series.seriesname)
};

/**
 *
 * @param series
 * @return {*|boolean}
 */

HierarchicalDataAdapter.hasInnerSeries = function(series) {
    return isArray(series.data) && typeof series.data[0] === "object" && defined(series.data[0].seriesname);
};

/**
 *
 * @param arr
 * @return {{}}
 */

HierarchicalDataAdapter.keysObject = function(arr) {
    var t = {};
    if (arr && arr.length) {
        arr.forEach(function(el) {
            t[el.value] = el;
        });
    }
    return t;
};

/**
 *
 * @param arr
 * @return {Array|null}
 */

HierarchicalDataAdapter.getValues = function(arr) {
    if (!defined(arr)) {
        return null;
    }
    return arr.map(function(d) {
        return d.value;
    })
};

$ZC.HierarchicalDataAdapter = HierarchicalDataAdapter;
(function() {


    "use strict";


    /**
     *
     * @param {Chart} chartInstance
     * @constructor
     */
    function HierarchicalOrdinalDataAdapter(chartInstance) {
        HierarchicalDataAdapter.call(this, chartInstance);
        this.dataType = ORDINAL_DATATYPE;
        this.categoryTree = true;
        this.update(true);
    }


    /**
     *
     * @type {{process: process, getSeries: getSeries, searchHierarchy: searchHierarchy}}
     */

    var hierarchicalOrdinalDataAdapter = {

        update: function(init) {

            if(!init) {
                this.initialize();
            }

            this.process();
            this.setDepth();
        },

        process: function() {

            var layout = this;
            layout.originalSeries.forEach(this.searchHierarchy, this);
        },


        getSeries: function(seriesIndex) {
            return defined(seriesIndex) ? this.series[seriesIndex] : this.series;
        },

        /**
         *
         * @param series
         * @param seriesIndex
         */
        searchHierarchy: function(series, seriesIndex) {

            var layout = this,
                chart = layout.chart,
                newSeries = layout.series[seriesIndex],
                column = pick(chart.dataset.getColumn("x"), {}),
                dataType = column.datatype,
                dataIndex = pick(column.dataindex, 0),
                seriesDisabled = series.disabled,
                hasNullFormatter = defined(column[dataType]) && defined(column[dataType].nullformatting),
                hasCategory = function(data) {
                    return hasNullFormatter || defined(data);
                };

            // create a new series if not exists
            if (!layout.series[seriesIndex]) {
                newSeries = layout.series[seriesIndex] = simpleClone(series);
                newSeries.data = [];
            }

            // start processing recursively
            search(series.data, 0, layout.categories);


            /**
             * @param {Object} series (current series)
             * @param depth depth of the children
             * @param children array to be stored the children
             */

            function search(series, depth, children) {

                var objKey = HierarchicalDataAdapter.keysObject(children);

                series.forEach(function(currentSeries) {

                    var hasChildren = HierarchicalDataAdapter.hasInnerSeries(currentSeries),
                        isArrayOfSeries = HierarchicalDataAdapter.isArrayOfSeries(currentSeries),
                        entry = null;

                    if (!objKey[currentSeries.seriesname]) {
                        entry = {
                            value: isArrayOfSeries || hasChildren ? pick(currentSeries.seriesname, "") : "",
                            depth: depth,
                            children: []
                        };
                        if(!seriesDisabled) {
                            children.push(entry);
                        }

                    } else {
                        entry = objKey[currentSeries.seriesname];
                    }

                    if (hasChildren) {
                        if (!objKey[currentSeries.seriesname]) {
                            objKey[currentSeries.seriesname] = entry;
                        }
                        search(currentSeries.data, depth + 1, objKey[currentSeries.seriesname].children);
                        if (entry.children.length === 0) {
                            removeElementFromArray(children, entry);
                        }

                    } else {

                        // convert data to 3d array
                        if (!HierarchicalDataAdapter.is3D(currentSeries.data)) {
                            currentSeries.data = [currentSeries.data];
                        }

                        var childrenEntries = HierarchicalDataAdapter.keysObject(entry.children);

                        currentSeries.data.forEach(function(d) {

                            var tp = {
                                value: d[dataIndex],
                                depth: depth + 1,// final depth,
                                leaf: true,
                                data: [d]
                            };

                            if (hasCategory(d[dataIndex])) {

                                // #ZC875
                                if(!seriesDisabled) {
                                    if (!childrenEntries[d[dataIndex]]) {
                                        entry.children.push(tp);
                                        childrenEntries[d[dataIndex]] = tp;

                                    }
                                    else if (childrenEntries[d[dataIndex]].leaf) {
                                        childrenEntries[d[dataIndex]].data.push(d);
                                    }

                                    // TODO need to verify.
                                    else if (childrenEntries[d[dataIndex]].children) {
                                        childrenEntries[d[dataIndex]].children.push(tp)
                                    }
                                }

                                // push the data to series
                                newSeries.data.push(d);
                            }

                        });

                        // remove the hierarchy if all is empty value
                        if (entry.children.length === 0) {
                            removeElementFromArray(children, entry);
                        }
                    }
                });
            }
        }
    };


    // inherit from HierarchicalDataAdapter
    inherit(HierarchicalOrdinalDataAdapter, HierarchicalDataAdapter);

    // extend all the functions
    extend(HierarchicalOrdinalDataAdapter.prototype, hierarchicalOrdinalDataAdapter);

    $ZC.HierarchicalOrdinalDataAdapter = HierarchicalOrdinalDataAdapter;

})();(function() {

    /**
     *
     * @param {Chart} chartInstance
     * @param {Array} tickValues
     * @param {Array} groupOrder
     * @param {Boolean} isDiscrete
     * @param {Object} columnInfo
     * @constructor
     */

    function HierarchicalTimeDataAdapter(chartInstance, tickValues, groupOrder, isDiscrete, columnInfo) {

        HierarchicalDataAdapter.call(this, chartInstance);

        this.dataType = TIME_DATATYPE;
        this.chart = chartInstance;
        this.columnInfo = columnInfo;

        if (isDiscrete) {
            this.groupByDiscreteTime = true;
        } else {
            this.groupByContinuousTime = true;
        }

        if(isArray(groupOrder)) {
            this.groupOrder = groupOrder.slice(0).reverse();
        } else if (groupOrder === "AUTO") {
            this.groupOrder = HierarchicalTimeDataAdapter.getAutoGroupOrder(columnInfo.time.subfunction);
        }

        this.groupByTime = true; // common

        this.update(tickValues);
    }


    var months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
        days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
        defaultGroupOrder = ["YEAR", "MONTH", "WEEK", "DAY"],
        formattingFunctions = {
            YEAR: "YEAR",
            ABSQUARTER: "YEAR",
            MONTH: "MONTH",
            ABSMONTH: "MONTH",
            WEEK: "WEEK",
            ABSWEEK: "WEEK",
            ABSDAY: "DAY"
        };

    /**
     *
     * @param {Date} d
     * @returns {string}
     */

    function getMonth(d) {
        return months[d.getMonth()]
    }


    /**
     *
     * @param {Date} d
     * @returns {string}
     */
    function getDay(d) {
        return days[d.getDay()];
    }

    /**
     *
     * @param {Date} d
     * @returns {number}
     */
    function getWeek(d) {
        var firstJanuary = new Date(d.getFullYear(), 0, 1);
        return mathCeil((((d - firstJanuary) / 86400000) + firstJanuary.getDay() + 1) / 7);
    }

    /**
     *
     * @param array
     * @param callback
     * @returns {*}
     */

    function groupBy(array, callback) {
        var key = null;
        return array.reduce(function(r, a) {
            key = callback.call(null, a);
            r[key] = r[key] || [];
            r[key].push(a);
            return r;
        }, {});
    }

    /**
     *
     * @param tickValues
     * @param columnInfo
     */
    function getDateFromTickValues(tickValues, columnInfo) {
        return tickValues.map(function(d) {
            return generateDateVal(d, null, columnInfo);
        });
    }

    /**
     *
     * @param data
     */

    function convertDateToObject(data) {

        var converter = function(point) {
            return {
                YEAR: point.getFullYear(),
                MONTH: getMonth(point),
                WEEK: getWeek(point),
                DAY: getDay(point),
                timestamps: point.getTime(),
                data: point
            };
        };
        return data.map(converter);
    }


    /**
     *
     * @param object
     * @param leaf
     * @param depth
     * @param isDiscreteTime
     * @returns {Array}
     */

    function toHierarchy(object, leaf, depth, isDiscreteTime) {
        var tree = [];
        for (var key in object) {
            if (object.hasOwnProperty(key)) {
                var entry = {
                    depth: depth
                };

                tree.push(entry);

                if (leaf) {
                    entry.leaf = true;
                    entry.value = isDiscreteTime ? object[key].data.getTime(): object[key].data;
                    // entry.value = object[key].data.getTime();
                    entry.point = object[key].data.getTime();

                } else {
                    entry.value = key;
                    entry.point = object[key][0].data;
                    entry.children = object[key]
                }
            }
        }
        return tree
    }

    /**
     *
     * @type {{update: update, process: process, getPossibleGroupBy: getPossibleGroupBy}}
     */

    var timeAxisGroup = {


        update: function(tickValues) {

            var layout = this;

            if(layout.groupByDiscreteTime) {
                tickValues = pick(layout.chart.dataObject.findXCategories(), tickValues);
            }

            layout.dataCount = 0;
            layout.tickValues = getDateFromTickValues(tickValues, layout.columnInfo);
            layout.process();
            layout.setDepth();
        },

        process: function() {

            var layout = this,
                data = layout.tickValues,
                index = 0,
                groupOrder = pick(layout.groupOrder, defaultGroupOrder),
                isDiscreteTime = layout.groupByDiscreteTime;

            // var groupByObject = layout.getPossibleGroupBy(data, groupOrder, index);
            // groupOrder = groupOrder.slice(groupOrder.indexOf(groupByObject));
            // axes count need to be updated
            // layout.chart.axes.x.count = groupOrder.length + 1;
            // layout.chart.ismultix = groupOrder.length > 0;

            var object = convertDateToObject(data, index),
                order = groupOrder.slice(0),
                key = order.shift(),
                yearlyGrouped = groupBy(object, function(date) {
                    return date[key];
                }),
                currentDepth = 0,
                storage = toHierarchy(yearlyGrouped, false, currentDepth, isDiscreteTime);



            function group(currentObj, keys, depth) {

                var key = keys.shift(), grouped;
                currentObj.forEach(function(d) {
                    if (key) {
                        grouped = groupBy(d.children, function(data) {
                            return data[key]
                        });

                        d.children = toHierarchy(grouped, false, depth, isDiscreteTime);
                        group(d.children, keys.slice(0), depth + 1);
                    } else {
                        d.children = toHierarchy(d.children, true, depth, isDiscreteTime);
                    }
                });

                return currentObj;
            }

            layout.categories = group(storage, order.slice(0), currentDepth + 1);
        },

        /**
         *
         * @param {[Date]} data array of dates
         * @param {array} groupOrder
         * @returns {string}
         */

        getPossibleGroupBy: function(data, groupOrder) {
            var startTime = data[0],
                endTime = data[data.length - 1],
                isSameYear = startTime.getFullYear() === endTime.getFullYear(),
                groupByObject = groupOrder[0];

            var timeDiff = data[data.length - 1] - data[0];
            var absoluteTime = millisecondToAbsoluteTime(timeDiff);

            for (var property in absoluteTime) {
                if (absoluteTime.hasOwnProperty(property)) {
                    if (absoluteTime[property] > 1 || (property === "YEAR" && !isSameYear)) {
                        groupByObject = property;
                        break;
                    }
                }
            }
            return groupByObject;
        }

    };


    /**
     *
     * @param {String} formattingFunction
     * @returns {Array.<string>}
     */
    HierarchicalTimeDataAdapter.getAutoGroupOrder = function(formattingFunction) {
        var index = defaultGroupOrder.indexOf(formattingFunctions[formattingFunction]);
        return defaultGroupOrder.slice(0, index);
    };


    // inherit from HierarchicalDataAdapter
    inherit(HierarchicalTimeDataAdapter, HierarchicalDataAdapter);

    // extend timeAxisGroup
    extend(HierarchicalTimeDataAdapter.prototype, timeAxisGroup);

    $ZC.HierarchicalTimeDataAdapter = HierarchicalTimeDataAdapter;

})();
//$Id$
/*
 * this file contains methods to extract the required forms of data from the user input
 */
$ZC.dataset.get = function(data, chartObj) {
    var metadata = data.metadata,
        columns = metadata.columns,
        axes = metadata.axes;
    var seriesdata = data.seriesdata.chartdata;
    var yaxisorderBySeries,

        // data processor helpers

        dataProcessorHelpers = $ZC.DataProcessor.helpers,
        getParsedYAxisOrder = dataProcessorHelpers.getParsedYAxisOrder;

    
    axes = sortAxesObject();
    var dataObject,
        columnInfo_clr = columns[axes.clr] || {};
    var colTypeOrder = columns.map(function(d, i) {
        return getColTypeOrder(i);
    });
    
    var dataset = {
        xidx: columns[axes.x].dataindex,
        yidx: function(order) {
            var columnidx = (order instanceof Array) ? axes.y[order[0]][order[1] || 0] : axes.y[order][0];
            return columns[columnidx].dataindex;
        },
        zidx: (columns[axes.z] || {}).dataindex,
        labelidx: (axes.label != null) ? ((columns[axes.label] != null) ? columns[axes.label].dataindex : axes.label) : null,
        tooltipidx: function(index) {
            return (axes.tooltip != null) ? columns[index].dataindex : null
        },
        clridx: columnInfo_clr.levelindex ? null : columnInfo_clr.dataindex
    };
    dataset.setDataObj = function(obj) {
        dataObject = obj;
    };
    dataset.getX = function(d) {
        if(defined(dataObject) && dataObject.hierarchical && !dataObject.hierarchical.groupByTime) {
            return d.index
        } else {
            return this.getActualX(d);
        }
        // return this.getActualX(d)
    },
        dataset.getY = function(d, yaxiscolumnorder, range) {
            /*
             * Meta data for y should be in array
             * Axis order may be array of objects or an object
             */
            try {
                var curYidx = this.yidx(yaxiscolumnorder);
                var yVal = (range == null) ? d[curYidx] : d[curYidx][range]
                return yVal;
            } catch (err) {
                
            }
            
        },
        dataset.getZ = function(d) {
            return d[this.zidx];
        },
        dataset.getClr = function(d) {
            return d[this.clridx];
        },
        dataset.getDataLabelValue = function(d) {
            return d[this.labelidx];
        },
        dataset.getGroupByValues = function(d, indices) {
            if (indices == null || indices.length == 0) {
                return null;
            }
            return indices.reduce(function(prev, cur, i) {
                return (defined(d[cur])) ? prev + d[cur] : prev
            }, "");
        }
    
    dataset.getActualX = function(d) {
        return d[this.xidx];
    };

        dataset.getDataType = function(type, index, seriestypes) {
            seriestypes = seriestypes || dataset.seriesTypes;

            if(type === "x" && index > 0) {
                return "ordinalNonLinear";
            }

            var datatype = null;
            if (metadata.axes[type] != null) {
                var columnidx = this.getColumnIdx(type, index);
                var columnInfo = columns[columnidx];
                datatype = columnInfo.datatype;
                //ordinal cases:
                var ordinalType = (type == "x") && (dataObject ? (dataObject.isPolarAxisCategory || dataObject.noofBarEnabledSeries) : ((seriestypes.indexOf($ZC.charttype.bar) != -1) || (seriestypes.indexOf($ZC.charttype.stkdbar) != -1) || (seriestypes.indexOf($ZC.charttype.bullet) != -1) || (seriestypes.indexOf($ZC.charttype.gantt) != -1) || (seriestypes.indexOf($ZC.charttype.web) != -1)));
                var isHeatmap = (seriestypes.indexOf($ZC.charttype.heatmap) != -1) && (type === "x" || type === "y");
                datatype = (ordinalType || columnInfo.useDiscrete || isHeatmap) ? ORDINAL_DATATYPE : datatype;
            }
            return datatype;
        }

    dataset.getColumnIdx = function(type, order) {
        var columnidx;
        var axes = metadata.axes[type];
        if (type == "y") {
            columnidx = (order instanceof Array && (order.length == 2)) ? axes[order[0]][order[1]] : axes[order][0];
        } else if (type == "tooltip") {
            columnidx = axes[order];
        } else if(type == "x" && order >0){
            metadata.columns.filter(function(d,i){
                if(d.levelindex == order){
                    columnidx = i;
                }
            })
            columnidx = columnidx || axes[0];
        } else {
            columnidx = (axes == null) ? null : axes[0];
        }
        return columnidx;
    };
    
    dataset.getColumn = function(type, yaxiscolumnorder) {
        var columnidx = this.getColumnIdx(type, yaxiscolumnorder);
        return columns[columnidx];
    };
    
    dataset.getColumnName = function(colidx, toDecode) {
        return ((toDecode != false) ? decodeHTML : encodeHTML)(columns[colidx].columnname);
    };
    
    dataset.getSeriesIdx = function(colidx) {
        
        var seriesidx = -1
        var typeandOrder = colTypeOrder[colidx],
            type = (typeandOrder != null) ? typeandOrder.type : null;
        
        if (type == "y" && (axes.y.length > 1 || axes.y[0].length > 1)) { //check for multi y case(only for multiy case colidx and series order are mapped)
            var order = typeandOrder.order;
            yaxisorderBySeries = yaxisorderBySeries || seriesdata.map(function(d, i) {
                return isUndefined(d.yaxiscolumnorder) ? "0" : d.yaxiscolumnorder.toString();
            });

            seriesidx = yaxisorderBySeries.indexOf(order.toString()); //yaxisorder should be 2d array
        }
        return seriesidx;
    };

    dataset.getCustomizedVal = function(chartObj, colidx, seriespos, subseriespos, itempos, d, type, color, toDecode) {
        if (isUndefined(toDecode)) {
            toDecode = !/(tooltip|legend)/.test(type);
        }

        return colidx.toString().replace(CUSTOM_VALUE_PATTERN, function() {
            var matchedString = arguments[0],
                valIndex = arguments[1], //INDEX value of {{val(INDEX)}}
                colIndex = arguments[2], //INDEX value of {{col(INDEX)}}
                perIndex = arguments[3], //INDEX value of {{per(INDEX)}}
                splitPerIndex = arguments[4]; //INDEX value of {{splitper(INDEX)}}
            var idx = valIndex || colIndex || perIndex || splitPerIndex;
            if (matchedString.indexOf("{{clr}}") != -1) { // theme color based on series color
                return color
            }
            if (columns[idx] != null) {
                var dataPoint = (type === "stackLabels") ? d : dataset.getDataPoint(chartObj, idx, seriespos, subseriespos, itempos, d);
                if (dataPoint != null) {
                    var operation = matchedString.match(/[a-z]+/gi)[0];
                    switch (operation) {
                        case "col":
                            return dataset.getColumnName(colIndex, toDecode); //return columnname
                        case "val":
                            return dataset.getDataPointValue(chartObj, dataPoint, valIndex, seriespos, false, type, subseriespos, toDecode); //return value
                        case "per":
                        case "splitper":
                            return dataset.getDataPointValue(chartObj, dataPoint, perIndex||splitPerIndex, seriespos, operation, type, subseriespos, toDecode); //return the percentage of value (percentage of Y value is only supported now)
                    }
                } else {
                    return "";
                }
            } else {
                return matchedString;
            }
        });
    };
    
    dataset.getDataPoint = function(chartObj, colidx, seriespos, subseriespos, itempos, d) {
        //mappedSeriesidx refers seriespos for multiY charts
        //seriesdataAfterUpdate refers seriesdata without null data,till now handled only in bar chart
        colidx = +colidx;
        var dataPoint = null,
            mappedSeriesidx = (colidx == null) ? seriespos : this.getSeriesIdx(colidx),
            colInfo = columns[colidx] || {};
        var curSeriesPos = (mappedSeriesidx != -1 && mappedSeriesidx == seriespos) ?
            mappedSeriesidx :
            ((mappedSeriesidx == -1) ? seriespos : null),
            hierarchyCondition = chartObj.dataObject.isHierarchy ? ((axes.clr && axes.clr[0] === colidx && d.depth === 1) || (chartObj.systemConf.metadata.axes.y[0].indexOf(colidx) !== -1) || (d.children && (colInfo.levelindex === d.depth-1 || (isArray(colInfo.levelindex) && colInfo.levelindex.indexOf(d.depth-1) !== -1))) || (!d.children && (colInfo.levelindex == null || colInfo.dataindex != null))) : true;

        if (curSeriesPos != null && hierarchyCondition) {
            var renderer = chartObj.renderer[(chartObj.isAxisCategory || chartObj.dataObject.isPolarAxisCategory) ? curSeriesPos : 0];
            var seriesdataAfterUpdate = (renderer != null && renderer.seriesdataAfterUpdate != null) ?
                renderer.seriesdataAfterUpdate[subseriespos] :
                seriesdata[curSeriesPos].data[subseriespos];
            dataPoint = d || seriesdataAfterUpdate[itempos];
        }
        return dataPoint;
    };
    
    dataset.getDataPointValue = function(chartObj, dataPoint, colidx, seriespos, percent, type, subseriespos, toDecode) {
        if (colidx != null) {
            colidx = +colidx;
        }

        if (isUndefined(toDecode)) {
            toDecode = !/(tooltip|legend)/.test(type);
        }

        var colInfo = columns[colidx] || {},
            datatype = colInfo.datatype,
            levelindex = colInfo.levelindex,
            dataindex = colInfo.dataindex;
        var format = colInfo[datatype];
        if (dataPoint != null) {
           if ((axes.clr != null || type === "legend") && colidx == axes.clr && !(chartObj.dataObject.isHierarchy && type !== "legend" && colInfo.dataindex != null)) { //Eventhough clrIdx is not specified in metadata, the seriesname will be returned correctly
                if (defined(this.clridx) && colorscale_helpers.isQuantileColorScale(chartObj)) {
                    if (type === "legend") {
                        var arraySeperator = "-";
                        return getFormattedValue(format, dataPoint, datatype, chartObj, type, toDecode, arraySeperator);
                    }
                    return getFormattedValue(format, this.getClr(dataPoint), datatype, chartObj, type, toDecode);
                } else {
                    return getFormattedValue(format, seriesdata[seriespos].seriesname, datatype, chartObj, type, toDecode);
                }
            } else if (chartObj.dataObject.isHierarchy && (levelindex === dataPoint.depth-1 || (isArray(levelindex) && levelindex.indexOf(dataPoint.depth-1) !== -1))) {
                var val = !dataPoint.children && (colInfo.dataindex != null) ? dataPoint[dataindex] : dataPoint.seriesname;
                return getFormattedValue(format, val, datatype, chartObj, type, toDecode);
            } else if(levelindex != null && chartObj.dataObject.hierarchical){
                var parentData = chartObj.dataObject.hierarchical.getParentByIndex(dataPoint.index, levelindex-1);
                if(parentData && parentData.value){
                    return getFormattedValue(format, parentData.value, datatype, chartObj, type, toDecode);
                }else{
                    return ""
                }

            }
            else {
                if (percent) {
                    var total = (datatype == NUMERIC_DATATYPE) ? getTotal(chartObj, seriespos, subseriespos, colidx, dataPoint, percent) : null;
                    if (total != null) {
                        var val = ((type == "stackLabels") ? dataPoint : ((chartObj.dataObject.isHierarchy && defined(dataPoint.value)) ? dataPoint.value : chartObj.dataObject.isStackedPercentChart ? dataPoint.y : dataPoint[dataindex])) / total * 100;
                        val = val || 0; //if total=0 and y=0, the 'val' holds NaN
                        return getFormattedValueByPercent(format, val, datatype, chartObj, type);
                    } else {
                        return "";
                    }
                }
                var yidx = this.getColumnIdx("y", getParsedYAxisOrder(chartObj.seriesdata[seriespos].yaxiscolumnorder));
                var arraySeperator = (colidx == yidx) ? " - " : undefined;
                return getFormattedValue(format, ((chartObj.dataObject.isHierarchy && colidx == yidx && defined(dataPoint.value)) ? dataPoint.value : (type == "stackLabels") ? dataPoint : dataPoint[dataindex]), datatype, chartObj, type, toDecode, arraySeperator);
            }
        }
        return null;
    };
    
    dataset.getMetaInfoObj = function(chartObj, data, seriespos) {
        var axes = chartObj.systemConf.metadata.axes,
            columns = chartObj.systemConf.metadata.columns,
            seriesdata = chartObj.systemConf.seriesdata.chartdata,
            seriespos = (chartObj.isAxisCategory || chartObj.isNonAxisMultiSeriesCategory) ? seriespos : 0,
            dataWithMetadata = [];
        var yindex = seriesdata[seriespos].yaxiscolumnorder || [0, 0]; //yaxiscolumnorder is not mandatory
        var yColIdx = (yindex instanceof Array) ? axes.y[yindex[0]][yindex[1] || 0] : axes.y[yindex][0];
        if (data instanceof Array) {
            data.forEach(function(d, i) {
                var colidx = columns.indexOf(columns.filter(function(c, j) {
                    return (c.dataindex == i) && ((dataset.yidx(yindex) != i) || (dataset.yidx(yindex) == i && yColIdx == j));
                })[0]);
                dataWithMetadata.push(getColObj(colidx, d));
            });
        }

        if (axes.clr != null) {
            var clrColIdx = (axes.clr instanceof Array) ? axes.clr[0] : axes.clr;
            dataWithMetadata.push(getColObj(clrColIdx, seriesdata[seriespos].seriesname));
        }
        return dataWithMetadata;
        
        function getColObj(colidx, value) {
            var obj = simpleClone(columns[colidx] || {});
            obj.value = value;
            obj.columnindex = colidx;
            return obj;
        }
    };

    dataset.processMetaData = function() {

        var legendIndex = getPropVal(metadata, "axes.clr");

        if(defined(legendIndex)) {
            legendIndex = legendIndex[0];
        }

        function process(metadata, i) {
            var type;

            if(i === legendIndex) {
                return
            }

            if(!defined(metadata.datatype)) {
                var data = dataset.getDataByColumnIndex(metadata.dataindex);
                type = dataset.findDataType(data);
                metadata.datatype = type;
            }
            if (defined(type) && !defined(metadata[type])) {
                metadata[type] = {};
            }
        }
        columns.forEach(process);
    };

    dataset.getDataByColumnIndex = function(index) {
        var data = null, found = false;
        chartObj.seriesdata.some(function(series) {
            return series.data.some(function(subSeries) {
                return subSeries.some(function(point) {
                    if(defined(point)) {
                        found = defined(point[index]);
                        if(found) {
                            data = point[index];
                        }
                        return found;
                    }
                })
            })
        });
        return data;
    };

    dataset.findDataType = function(data) {
        if (typeof data === "number") {
            if (data > 365 * 24 * 3600 * 1000) {
                return TIME_DATATYPE;
            }
            return NUMERIC_DATATYPE
        }
        return ORDINAL_DATATYPE;
    };

    // init
    dataset.processMetaData();
    // handle meta data.

    function getTotal(chartObj, seriespos, subseriespos, colidx, dataPoint, showAs) {
        colidx = (+colidx);
        var yaxes = axes.y,
            index = -1,
            isBubblePie = chartObj.chartTypes[seriespos].value === $ZC.charttype.bubblepie;
        if (chartObj.dataObject.isstacked(chartObj.chartTypes[seriespos].value) && !chartObj.dataObject.isStackedPercentChart) {
            return getStackedTotal(chartObj, seriespos, dataPoint, showAs);
        }

        if (yaxes != null) {
            if (yaxes[0] instanceof Array) {
                yaxes.forEach(function(d, i) {
                    index = ((index == -1) && (d.indexOf(colidx) > -1)) ? i : index;
                });
            } else {
                index = (yaxes.indexOf(colidx) > -1) ? 0 : -1;
            }
            if (index != -1 || isBubblePie) {
                var total;
                if (isBubblePie) {
                    var X = dataset.getX(dataPoint);
                    var pieRenderer = chartObj.subrenderer[subseriespos || 0][X];
                    total = pieRenderer.total;
                } else if (chartObj.isAxisCategory || chartObj.dataObject.isPolarAxisCategory) {
                    var domain = chartObj.axes.y.groups[index].scale.domain();
                    total = domain[1];
                } else {
                    if (chartObj.isNonAxisMultiSeriesCategory) {
                        total = dataPoint.parent.value;
                    } else {
                        total = chartObj.renderer[0].total;
                    }
                }
                return (!total && (total !== 0)) ? null : total;
            }
        }
        return null;
    }



    function getColTypeOrder(colidx) {
        var axesType, order = [];
        for (var type in axes) {
            if (axes.hasOwnProperty(type)) {
                var val = (type == "y") ? d3_merge(axes[type]) : axes[type];
                if (val.indexOf(colidx) != -1) {
                    if (type == "y") {
                        axes[type].map(function(d, i) {
                            var index = d.indexOf(colidx)
                            if (index != -1) {
                                order.push(i);
                                order.push(index)
                            }
                        })
                    }
                    axesType = type;
                    return {
                        "type": axesType,
                        "order": order
                    };
                }
            }
        }
    }
    
    function sortAxesObject() {
        var newaxes = {},
            keysSorted = Object.keys(axes).sort(function(a, b) {
                return (b.length > a.length) ? -1 : (b.length < a.length) ? 1 : 0; // (a.length > b.length) is incorrect in SAFARI
            });
        keysSorted.forEach(function(d) {
            newaxes[d] = axes[d];
        });
        return newaxes;
    }
    
    return dataset;
};

function getStackedTotal(chartObj, seriesPos, d, showAs) {
    var stackGroupIdx = 0,
        rp = chartObj.renderer[seriesPos].commonRendererProp().params,
        dataset = chartObj.dataset,
        X = dataset.getX(d),
        Y = dataset.getY(d, rp.yaxiscolumnorder||0),
        total;

    if (chartObj.userdata.seriesdata.stackGroup) {
        stackGroupIdx = getStackGroupIndex(seriesPos, chartObj.userdata.seriesdata.stackGroup);
    }

    var curStackExtent = chartObj.dataObject.groupedByStack.get(stackGroupIdx).stackExtent
        .filter(function(d) {
            return d[0] === X;
        });

    if (showAs === "percent" || showAs === "per") {
       total = curStackExtent
            .reduce(function(prev, cur) {
                return prev + mathAbs(cur[1]);
            }, 0);
    } else {
       total = curStackExtent[(Y < rp.hasNegValue && curStackExtent[1]) ? 1 : 0][1];
    }
    return total;
}

(function(win) {

    /**
     *
     * @param data
     * @param dataSet
     * @param chartInstance
     * @constructor
     */

    function DataProcessor(data, dataSet, chartInstance) {

        this.data = data;
        this.dataset = dataSet;
        this.chartObj = chartInstance;

        // support variables
        this.values = [];
        this.minmaxY = [];
        this.groupedDataBySplitAxes = [];
        this.groupedDataByCombo = d3_map();
        this.stackeddata = [];
        this.stackedChart = null;
        this.allChartTypes = null;
        this.hasNegativeValue = [];
        this.baseline = [];
        this.xRange = null;
        this.yRange = [];
        this.domainCorrections = {
            plotHeight: null,
            byDatalabels: {},
            forBubbles: {}
        };
        this.xaxisData = data.chart.axes.xaxis;
        this.yaxesData = data.chart.axes.yaxis;
        this.qualitativeRanges = null;
        this.groupedByStack = d3_map();
        this.ganttSeries_count = 0;
        this.categoriesStore = null;
        this.plotBorder = null;
        this.globalChartType = null;

        this.hierarchical = chartInstance.preProcessor.hierarchical;
        this.processedseriesData = chartInstance.seriesdata;
        this.initialize();
    }

    var DataProcessorProto = DataProcessor.prototype;

    /**
     *
     * @return {Array}
     */

    DataProcessorProto.getSeriesData = function() {
        var processor = this,
            chart = this.chartObj;

        if (defined(processor.hierarchical) && processor.hierarchical.categories) {
            // should be updated in the chartObj.seriesdata;
            var temp = processor.hierarchical.getSeries();
            chart.seriesdata = temp;
            return temp;
        }
        return chart.seriesdata;
    };

    /**
     * @returns {Array}
     */

    DataProcessorProto.getMinMaxZ = function() {
        return d3_extent(d3_merge(this.categoriesStore.z));
    };

    /**
     *
     * @param {Object} series is chart series
     * @returns {boolean}
     */

    DataProcessorProto.isBarEnabled = function(series) {
        var helpers = DataProcessor.helpers,
            cType = helpers.getChartType((series.type || this.globalChartType), NUMERIC_DATATYPE);
        return !series.disabled && isBarChartType(cType);
    };

    /**
     * Returns if the axis rotated
     * @returns {boolean}
     */

    DataProcessorProto.getAxisRotated = function() {
        var axes = this.data.chart.axes;
        return axes && axes.rotated === true;
    };

    /**
     *
     * @param {Number} index
     * @returns {*}
     */

    DataProcessorProto.containsNegativeData = function(index) {
        return this.hasNegativeValue[index];
    };

    /**
     *
     * @param seriesdata
     * @param categories
     * @returns {*}
     */
    DataProcessorProto.updateSeriesdatabyCategories = function(seriesdata, xCategories, yCategories, yaxiscolumnorder) {
        var dataSet = this.dataset,
            helpers = DataProcessor.helpers,
            isCatNullX = helpers.isCatNull(dataSet, "x"),
            isCatNullY = helpers.isCatNull(dataSet, "y", yaxiscolumnorder);
        seriesdata = seriesdata.filter(function(d) {
            var show = true;

            if (xCategories) {
                var x = dataSet.getX(d);
                show = show && !isCatNullX(x) && (xCategories.indexOf(x) > -1);
            }

            if (yCategories) {
                var y = dataSet.getY(d, yaxiscolumnorder);
                show = show && !isCatNullY(y) && (yCategories.indexOf(y) > -1);
            }

            return show;
        });
        return seriesdata;
    };

    /**
     *
     * @returns {*}
     */
    DataProcessorProto.getPlotBorder = function() {

        var processor = this,
            data = processor.data,
            borderSize = processor.plotBorder,
            plotBorderOptions = data.chart.plot.border;

        // var borderSize = validateValWithinLimit(plotBorderOptions, "size", 0, 10, chart.plotarea.width, chart.plotarea.height);

        var temp = 0;//(borderSize == 1) ? 0 : borderSize;
        if (plotBorderOptions.show === true) {
            borderSize = {};
            borderSize.top = borderSize.right = borderSize.bottom = borderSize.left = temp;
        }
        return borderSize;
    };

    /**
     *
     * @param domain
     * @param type
     * @param index
     * @returns {*}
     */

    DataProcessorProto.overBubbles = function(domain, type, index) {

        var processor = this,
            domainCorrections = processor.domainCorrections,
            xAxis = processor.xaxisData,
            yAxis = processor.yaxesData,
            chart = processor.chartObj,
            id = type + (defined(index) ? index : ""),
            plotHeight = chart.plotarea.height,
            chartObj = processor.chartObj

        // For bubble charts in which minrange and maxrange is not defined, extend the domain if the bubbles go out of the plotarea

        if (defined(domainCorrections.forBubbles[id]) && domainCorrections.plotHeight === plotHeight) {
            return domainCorrections.forBubbles[id];
        }


        domainCorrections.plotHeight = plotHeight;

        var isXAxis = (type === "x"),
            orient = chartObj.axes[type].orient,
            min = 0,
            max = chartObj.plotarea[(orient === "left") ? "height" : "width"],
            range = [min, max],
            axisConf = (isXAxis ? xAxis : yAxis[index]),
            scale = d3_scaleLinear().domain(domain).range(range);

        var updatedMinMax = processor.updateMinMaxForBubble(range, scale, type, index);

        min = (!defined(axisConf.minRange)) ? scale.invert(updatedMinMax[0]) : min;
        max = !defined(axisConf.maxRange) ? scale.invert(updatedMinMax[1]) : max;

        domainCorrections.forBubbles[id] = [(domain[0] - min), (max - domain[1])];
        return domainCorrections.forBubbles[id];
    };

    /**
     *
     * @param stacked
     * @param chartType
     * @param obj
     */

    DataProcessorProto.setGroupDataComboKey = function(stacked, chartType, obj) {
        var processor = this,
            data = processor.data,
            groupedByStack = processor.groupedByStack,
            groupedDataByCombo = processor.groupedDataByCombo,
            key = 0;

        if (stacked && isBarChartType(chartType)) {
            if (data.seriesdata.stackGroup) {
                key = getStackGroupIndex(obj.si, data.seriesdata.stackGroup);
            }

            if (!groupedByStack.has(key)) {
                groupedByStack.set(key, [obj]);
            } else {
                var lastData = groupedByStack.get(key);
                groupedByStack.set(key, lastData.concat([obj]));
            }
            groupedByStack.get(key).stackLabelIndex = obj.si;
        }

        /*
         * Grouping by chart type
         * chartType | chartType_stackGroupIdx (e.g): 10 | 10_0
         */

        var comboKey = defined(key) ? (chartType + "_" + key) : chartType;

        if (!groupedDataByCombo.has(comboKey)) {
            groupedDataByCombo.set(comboKey, [obj]);
        } else {
            var lastdat = groupedDataByCombo.get(comboKey);
            groupedDataByCombo.set(comboKey, lastdat.concat([obj]));
        }
    };

    /**
     *
     * @param curdata
     * @param stacked
     * @param yDatatype
     * @param chartType
     * @param isZenabled
     * @param yaxiscolumnorder
     */

    DataProcessorProto.setExtremes = function(curdata, stacked, yDatatype, chartType, isZenabled, yaxiscolumnorder) {

        var processor = this,
            dataset = processor.dataset,
            zCat = processor.categoriesStore.z;

        if (((yDatatype === NUMERIC_DATATYPE || yDatatype === TIME_DATATYPE) && !stacked) || isZenabled) {
            if (!curdata.disabled && isArray(curdata)) {
                var mergedSubgroup = d3_merge(curdata);
                if (isZenabled) {
                    var zExtremes = d3_extent(mergedSubgroup, function(d) {
                        return dataset.getZ(d)
                    });
                    zCat.push(zExtremes);
                }
                if (yDatatype === NUMERIC_DATATYPE || yDatatype === TIME_DATATYPE) {
                    var yExtremes;
                    if (chartType == $ZC.charttype.arearange || chartType == $ZC.charttype.gantt) {
                        var mergedYranges = d3_merge(mergedSubgroup.map(function(d) {
                            return dataset.getY(d, yaxiscolumnorder)
                        }));
                        yExtremes = d3_extent(mergedYranges);
                    } else {
                        yExtremes = d3_extent(mergedSubgroup, function(d) {
                            return dataset.getY(d, yaxiscolumnorder)
                        });
                    }
                    processor.seriesExtermes[yaxiscolumnorder].push(yExtremes);
                }
            }
        }
    };

    /**
     *
     * @param state
     */

    DataProcessorProto.initialize = function(state) {

        var processor = this,
            domainCorrections = processor.domainCorrections,
            xaxisData = processor.xaxisData,
            yaxesData = processor.yaxesData,
            allChartTypes = processor.allChartTypes,
            data = processor.data,
            chartObj = processor.chartObj,
            globalChartType = processor.globalChartType = data.seriesdata && data.seriesdata.type,

            noofYaxis = data.metadata.axes.y.length,
            metadata = data.metadata,
            axes = metadata.axes,
            stacked = processor.isstacked(),


            groupedDataBySplitAxes = processor.groupedDataBySplitAxes = [],
            groupedByStack = processor.groupedByStack = d3_map(),
            dataset = processor.dataset,
            categoriesStore = processor.categoriesStore = {},
            plotBorder,
            processedseriesData = processor.processedseriesData,
            helpers = DataProcessor.helpers;

        if (processor.hierarchical && !processor.hierarchical.groupByTime && defined(state)) {
            processor.hierarchical.update();
        }

        processor.xRange = null;
        processor.yRange = [];
        processor.qualitativeRanges = null;
        processor.groupedDataByCombo = d3_map();

        domainCorrections.plotHeight = null;
        domainCorrections.forBubbles = {};

        dataset.seriesTypes = [];

        processor.isBubbleEnabled = false;
        processor.noofBarEnabledSeries = 0;
        processor.noofAreaEnabledSeries = 0;
        processor.noofGanttEnabledSeries = 0;
        processor.totalnoofdatas = 0;
        processor.lastCategoryValue = 0;
        processor.isCombinationalChart = d3_set();
        processor.isAxisCategory = false;
        processor.isNonAxisMultiSeriesCategory = false;
        processor.isContinousChart = true;
        processor.isPolarAxisCategory = false;
        processor.hasLevelMarker = false;
        processor.isStackedPercentChart = false;

        categoriesStore.x = [];
        categoriesStore.z = [[0]];

        categoriesStore.subseries = [];
        dataset.hasNullFormatter = {};

        plotBorder = this.plotBorder = {};
        plotBorder.left = plotBorder.top = plotBorder.right = plotBorder.bottom = 0;

        // axisrotated = processor.getAxisRotated();
        // orient = xaxisData.orient || (axisrotated ? "left" : "bottom");
        // plotBorder[orient] = 0;//(xaxisData.show === true) && xaxisData.axisline && xaxisData.axisline.show === true && validateNullVal(xaxisData.axisline.strokeWidth, 0) || 0;

        processor.seriesExtermes = []; // finding series extremes for each series

        var yaxesGroups = chartObj.axes.y.groups;

        for (var i = 0; i < noofYaxis; i++) {

            categoriesStore["y" + i] = [];
            processor.seriesExtermes[i] = [];
            (!defined(yaxesData[i])) ? (yaxesData[i] = {}) : null;

            // Create yaxis group and mark the axis is disabled initially
            yaxesGroups[i] = yaxesGroups[i] || {};
            yaxesGroups[i].disabled = true;

            // var curYaxisData = (i > 0) ? mergeJSON(yaxesData[i], yaxesData[0], false) : yaxesData[i]; //CHANGE
            // var orient = curYaxisData.orient || (axisrotated ? "bottom" : (i ? "right" : "left"));
            // plotBorder[orient] = 0;//(curYaxisData.show === true && curYaxisData.axisline && curYaxisData.axisline.show === true && validateNullVal(curYaxisData.axisline.strokeWidth, 0)) || 0
        }

        if (isArray(processedseriesData)) {

            var xColumn = axes.x ? dataset.getColumn("x") : null,
                xDatatype = xColumn ? xColumn.datatype : null,
                isZenabled = defined(axes.z),
                groupbyDataIndices = helpers.groupByDataIndices(metadata);


            allChartTypes = processor.allChartTypes = allChartTypes || helpers.getAllChartTypes(data);

            // TODO have to rename of this function
            var temp = function(d) {
                return allChartTypes.indexOf(d) !== -1
            };

            processor.isDiscrete = $ZC.chartcategory.discrete.some(temp);
            processor.isHierarchy = $ZC.chartcategory.hierarchy.some(temp);

            //sorting of data
            var xColPos = data.metadata.axes.x;
            var datatype_x = data.metadata.columns[xColPos].datatype;

            processor.needXCategoriesSorting = false;
            var needXCategoriesSorting = false;

            processedseriesData.forEach(function(d, i) {

                var disabled = d.disabled,
                    curdata = d.data;
                var is3DArray = helpers.is3D(curdata);
                // var chart = chartObj.chartTypes[i],
                //     chartType = chart.value;
                var chartType = helpers.getChartType((d.type || globalChartType), NUMERIC_DATATYPE);
                var cType = helpers.getChartType((d.type || globalChartType), "string");
                var yaxiscolumnorder = helpers.getParsedYAxisOrder(d.yaxiscolumnorder);
                var yCat = categoriesStore["y" + yaxiscolumnorder];
                var yDatatype = dataset.getDataType("y", yaxiscolumnorder);

                dataset.seriesTypes.push(chartType);

                processor.isCombinationalChart.add(chartType);
                processor.isBubbleEnabled = processor.isBubbleEnabled || (!disabled && isBubbleChartType(chartType));
                processor.pieWithAxis = processor.pieWithAxis || (!disabled && chartType === $ZC.charttype.bubblepie);
                processor.noofBarEnabledSeries += (isBarChartType(chartType) && !disabled) ? 1 : 0;
                processor.noofAreaEnabledSeries += ((chartType == $ZC.charttype.area || chartType == $ZC.charttype.stkdarea) && !disabled) ? 1 : 0;
                processor.noofGanttEnabledSeries = processor.ganttSeries_count += ((chartType === $ZC.charttype.gantt) && !disabled) ? 1 : 0;


                processor.isContinousChart = processor.isContinousChart && (chartType == $ZC.charttype.line || isAreaChartType(chartType) || isPointChartType(chartType));
                processor.hasLevelMarker = processor.hasLevelMarker || (chartType == $ZC.charttype.bullet || chartType == $ZC.charttype.dial);

                processor.isAxisCategory = processor.isAxisCategory || (($ZC.chartcategory.axis).indexOf(chartType) >= 0);
                processor.isNonAxisMultiSeriesCategory = processor.isNonAxisMultiSeriesCategory || (($ZC.chartcategory.nonaxismultiseries).indexOf(chartType) >= 0);
                processor.isPolarAxisCategory = processor.isPolarAxisCategory || (chartType == $ZC.charttype.web);


                // convert data to 3d array even it is disabled;
                if (state !== "addorremoveseries" && !is3DArray && isArray(curdata)) {
                    curdata = processor.convertTo3DArray(d, groupbyDataIndices, chartType);
                }

                if (!disabled && isArray(curdata)) {

                    categoriesStore["y" + yaxiscolumnorder].enabled = true;
                    yaxesGroups[yaxiscolumnorder].disabled = false;

                    var obj = {
                        "si": i,
                        "d": curdata
                    };

                    //Grouping by split axes
                    if (!groupedDataBySplitAxes[yaxiscolumnorder]) {
                        groupedDataBySplitAxes[yaxiscolumnorder] = [obj];
                    } else {
                        groupedDataBySplitAxes[yaxiscolumnorder] = groupedDataBySplitAxes[yaxiscolumnorder].concat([obj]);
                    }

                    // Grouping by stack
                    processor.setGroupDataComboKey(stacked, chartType, obj);

                    var actXdatatype = dataset.getDataType("x", null, allChartTypes),
                        actYdatatype = dataset.getDataType("y", yaxiscolumnorder, allChartTypes),
                        yColumn = dataset.getColumn("y", yaxiscolumnorder);

                    // debugger
                    if (!defined(dataset.hasNullFormatter.x)) {
                        dataset.hasNullFormatter.x = !((actXdatatype === ORDINAL_DATATYPE) ? !isObjectPropDefined(xColumn[xDatatype], "nullformatting") : true);
                    }

                    if (!defined(dataset.hasNullFormatter["y" + yaxiscolumnorder])) {
                        dataset.hasNullFormatter["y" + yaxiscolumnorder] = !((yDatatype === ORDINAL_DATATYPE) ? !isObjectPropDefined(yColumn[yColumn.datatype], "nullformatting") : true);
                    }

                    //For stacked data need to iterate each data for collecting X and groupbyval
                    //Categories store update
                    processor.storeCategories(curdata, stacked, groupbyDataIndices, chartType, actXdatatype, yDatatype, yaxiscolumnorder);

                    //Numeric store extremes update
                    processor.setExtremes(curdata, stacked, yDatatype, chartType, isZenabled, yaxiscolumnorder);

                    //totalNo of datas
                    processor.totalDataCount(curdata);
                }
            });

            var userCategories = getPropVal(chartObj.userdata, "chart.axes.xaxis.categories");

            if (processor.isAxisCategory && datatype_x !== ORDINAL_DATATYPE && processor.needXCategoriesSorting && (!defined(userCategories) || (defined(userCategories) && userCategories.length === 0))) {
                categoriesStore.x.sort(d3_ascending);
            }

            //sort xcat, xoriginalcat
            processor.xymultiRenderer = processor.isAxisCategory;
            processor.isCombinationalChart = processor.isCombinationalChart.values().length > 1;
            processor.groupedByStack = groupedByStack;

            if (stacked) {
                var seriesTypes = dataset.seriesTypes,
                    plotoptions = processor.data.chart.plot.plotoptions;

                processor.isStackedPercentChart = ((processor.noofBarEnabledSeries && !processor.hasLevelMarker) && (plotoptions.bar.stacked.showAs === "percent")) ||
                    (processor.noofAreaEnabledSeries && (plotoptions.area.stacked.showAs === "percent")) ||
                    ((seriesTypes.indexOf($ZC.charttype.web) > -1) && (plotoptions.web.stacked.showAs === "percent")) ||
                    ((seriesTypes.indexOf($ZC.charttype.line) > -1) && (plotoptions.line.stacked.showAs === "percent"));
            }
            if (processor.pieWithAxis && (state !== "addorremoveseries")) {
                processor.bubblepieData = processor.processBubblePieData();
            }
        }
    };

    /**
     *
     * @return {Array}
     */

    DataProcessorProto.processBubblePieData = function(baseChartType) {
        // baseChartType = bubblepie | geobubblepie | geopie
        baseChartType = baseChartType || $ZC.charttype.bubblepie;

        var processor = this,
            processedseriesData = processor.processedseriesData,
            chartObj = processor.chartObj,
            dataset = processor.dataset;

        var pieData = [],
            dataindex = validateNullVal(processor.data.chart.plot.plotoptions[$ZC.charttypenames.get(baseChartType)].dataindex, 3),
            categories = processor.findXCategories(true);

        processedseriesData.forEach(function(d, i) {
            var chartTypeNumeric = chartObj.chartTypes[i].value;
            var ishideable = d.disabled || (chartTypeNumeric !== baseChartType),
                currentseriesdata = d.data;
            currentseriesdata.forEach(function(d, subseries) {
                pieData[subseries] = pieData[subseries] || [];
                categories.forEach(function(cat, i) {
                    var dt = d.filter(function(d) {
                        return dataset.getX(d) === cat
                    })[0];
                    if (!dt) {
                        var v;
                        processedseriesData.some(function(seires, si) {
                            var currentseriesdata = seires.data;
                            return currentseriesdata[subseries].some(function(d, i) {
                                var hasX = (dataset.getX(d) === cat);
                                if (hasX) {
                                    v = d.slice(0);
                                    v[dataindex] = null;
                                }
                                return hasX;
                            })
                        });
                        dt = v;
                    }

                    if (dt) { // if missing subseries available
                        dt.disabled = ishideable;
                        pieData[subseries][i] = pieData[subseries][i] || [];
                        pieData[subseries][i].push(dt);
                    }

                });
            });
        });
        return pieData;
    };

    /**
     *
     * @param conf
     * @return {Array}
     */

    DataProcessorProto.getThresholdValues = function(conf) {
        var values = [];
        if (defined(conf.threshold)) {
            each(conf.threshold, function(threshold) {
                if (threshold.show === true && threshold.values.length) {
                    values = values.concat(threshold.values)
                }
            });
        }
        return values;
    };

    /**
     *
     * @param {Array} categories
     * @param {Boolean} leaf
     * @return {*}
     */

    DataProcessorProto.getDomain = function(categories, leaf) {
        if (this.hierarchical && !(this.hierarchical.groupByDiscreteTime && leaf)) {
            return d3.range(categories.length)
        } else {
            return categories;
        }
    };

    /**
     *
     * @param range
     * @param scale
     * @param type
     * @param index
     * @return {[number,number]}
     */

    DataProcessorProto.updateMinMaxForBubble = function(range, scale, type, index) {

        var context = this,
            processedseriesData = context.processedseriesData,
            groupedDataBySplitAxes = context.groupedDataBySplitAxes,
            dataset = context.dataset,
            chartObj = context.chartObj,
            helpers = DataProcessor.helpers;

        var min = range[0],
            max = range[1],
            isXaxis = (type == "x"),
            serData = (isXaxis ? processedseriesData : groupedDataBySplitAxes[index]) || []; //serData = null on multi-y legend filter Test-502.json
        serData.forEach(function(series) {
            var currentdata = (isXaxis ? series.data : series.d),
                disabled = ((isXaxis ? series : processedseriesData[series.si]).disabled),
                yaxiscolumnorder = helpers.getParsedYAxisOrder((isXaxis ? series : processedseriesData[series.si]).yaxiscolumnorder);
            if (!disabled) {
                var isCatNullX = helpers.isCatNull(dataset, "x"),
                    isCatNullY = helpers.isCatNull(dataset, "y", yaxiscolumnorder);

                currentdata.forEach(function(subgroup) {
                    subgroup.forEach(function(data) {
                        var val = (isXaxis ? dataset.getX(data) : dataset.getY(data, index)),
                            z = dataset.getZ(data) || chartObj.zscale.domain()[0];

                        //If data is null, dont consider
                        if (!(!data || data.isDummy || isCatNullX(dataset.getX(data)) || isCatNullY(dataset.getY(data, yaxiscolumnorder)))) {

                            var zpx = chartObj.zscale(z),
                                valpx = scale(val) + ((scale.rangeBand != null) ? scale.rangeBand() / 2 : 0);
                            // if(isNaN(valpx)) debugger

                            var radPlus = valpx + (zpx / 2),
                                radMinus = valpx - (zpx / 2);

                            if (radPlus > max) {
                                max = radPlus;
                            }

                            if (radMinus < min) {
                                min = radMinus;
                            }
                        }
                    });
                });
            }
        });

        return [min, max];
    };


    /**************** Data Processor Helper Functions  **************/

    DataProcessor.helpers = {

        /**
         *
         * @param dataset
         * @param type
         * @param index
         * @return {Function}
         */

        isCatNull: function(dataset, type, index) {
            var noNullFormat = dataset.hasNullFormatter && !dataset.hasNullFormatter[type + (defined(index) ? index : "")];
            return function(cat) {
                return !defined(cat) && noNullFormat;
            }
        },


        /**
         *
         * @param data
         * @return {boolean}
         */

        is3D: function(data) {
            return isArray(data) && isArray(data[0]) && isArray(data[0][0]);
        },

        getParsedYAxisOrder: function(yaxiscolumnorder) {
            return isArray(yaxiscolumnorder) ? yaxiscolumnorder[0] : yaxiscolumnorder || 0;
        },

        /**
         *
         * @param type
         * @param chartTypeBy
         * @param index
         * @param data
         * @return {{name: *, value: *}}
         */
        getChartType: function(type, chartTypeBy, index, data) {
            if (type == null && index == null) {
                return
            }

            var seriesdata = data && data.seriesdata.chartdata,
                chartName,
                chartValue;
            if (defined(index)) {
                type = pick((seriesdata[index] || seriesdata[0]).type, data.seriesdata.type);
            }
            if (isNaN(+type)) {
                chartName = type.toLowerCase();
                chartValue = $ZC.charttype[chartName];
            } else {
                chartValue = +type;
                chartName = $ZC.charttypenames.get(chartValue);
            }
            return chartTypeBy === "string" ? chartName : chartTypeBy === NUMERIC_DATATYPE ? chartValue : {
                "name": chartName,
                "value": chartValue
            };
        },

        /**
         *
         * @param data
         * @param chartTypeBy
         */

        getAllChartTypes: function(data, chartTypeBy) {
            var helpers = this;
            var globalChartType = data.seriesdata && data.seriesdata.type;

            return pick(getPropVal(data, "seriesdata.chartdata"), []).map(function(a) {
                var temp = helpers.getChartType(pick(a.type, globalChartType), pick(chartTypeBy, NUMERIC_DATATYPE));
                if (!chartTypeBy && chartTypeBy === "object") {
                    return {}
                }
                return temp;
            })
        },

        /**
         *
         * @param array
         * @param startVal
         * @param endVal
         * @param accessor
         */

        filterDataToViewPort: function(array, startVal, endVal, accessor) {
            return array.filter(function(d) {
                var val = accessor(d);
                if (val >= startVal && val <= endVal) {
                    return d;
                }
            });
        },

        /**
         *
         * @param priorities
         * @param defaultValue
         * @return {number|*}
         */

        priorityBasedValue: function(priorities, defaultValue) {
            var value = null,
                size = priorities.length,
                i = 0;

            defaultValue = pick(defaultValue, 0)
            while (i < size && !defined(value)) {
                value = (priorities[i] != null) ? priorities[i] : null;
                i++
            }
            return pick(value, defaultValue)
        },

        groupByDataIndices: function(metadata) {

            /*
             * returns an array of groupby dataindices
             */
            var columns = metadata.columns,
                groupbyCol = metadata.axes.groupby || [];
            return groupbyCol.map(function(d) {
                return columns[d].dataindex;
            });
        }
    };


    $ZC.DataProcessor = DataProcessor;

})(window, $ZC);

;

(function(win) {


    "use strict";

    /**
     *
     * @param chart
     * @constructor
     */

    function PreProcessor(chart) {
        this.chart = chart;
        this.data = chart.systemConf;
        this.initialize();
    }

    PreProcessor.prototype.initialize = function() {

        var preProcessor = this,
            chart = preProcessor.chart,
            data = preProcessor.data,
            xColumnIndex = data.metadata.axes.x,
            xDataType = data.metadata.columns[xColumnIndex].datatype,
            dataProcessorHelpers = $ZC.DataProcessor.helpers,

            isDiscrete = $ZC.chartcategory.discrete.some(function(d) {
                return chart.chartTypes.indexOf(d) !== -1
            }),
            chartType = dataProcessorHelpers.getChartType(null, null, 0, chart.systemConf),
            chartValue = chartType.value,
            chartName = chartType.name;


        // check if the data has hierarchy
        var isAllowedHierarchyCharts = isBarChartType(chartValue) || isAreaChartType(chartValue) || isScatterChartType(chartValue)
            || isPointChartType(chartValue) || chartName === "line";

        if (this.isHierarchyLayout() && isAllowedHierarchyCharts) {
            preProcessor.hierarchical = new $ZC.HierarchicalOrdinalDataAdapter(this.chart);
            // update the chart data
            preProcessor.chart.seriesdata = this.hierarchical.getSeries();
        }

        // process the time data
        preProcessor.processTimeData();

        // sort if defined
        if ($ZC.requireXDataSorting && (xDataType === NUMERIC_DATATYPE || (xDataType === TIME_DATATYPE && !isDiscrete))) {
            preProcessor.sortData(xColumnIndex, xDataType);
        }
    };

    /**
     * Checks if the series has hierarchy
     * @return {boolean}
     */

    PreProcessor.prototype.isHierarchyLayout = function() {
        var processor = this,
            chart = processor.chart,
            series = chart.systemConf.seriesdata.chartdata;

        function hasHierarchy(series) {
            return HierarchicalDataAdapter.hasInnerSeries(series);
        }

        return series.some(hasHierarchy);
    };

    /**
     *
     */

    PreProcessor.prototype.processTimeData = function() {
        var processor = this,
            chart = processor.chart,
            timeDataInfo,
            timeDataIndices,
            timeDataInputFormat,
            hasTimeInputFormat,
            series = chart.seriesdata;

        timeDataInfo = PreProcessor.helpers.time.getDataInfo(processor.data);
        timeDataIndices = timeDataInfo.indices;
        timeDataInputFormat = timeDataInfo.formatConf;

        hasTimeInputFormat = timeDataInputFormat.some(function(d) {
            return defined(d) && defined(d.inputformat);
        });

        if (timeDataIndices && timeDataIndices.length && hasTimeInputFormat) {
            series.forEach(function(d, i) {
                var currentData = d.data;
                var is3DArray = $ZC.DataProcessor.helpers.is3D(currentData);
                if (isArray(currentData)) {
                    currentData.forEach(function(subgroup, j) {
                        if (is3DArray && isArray(subgroup)) {
                            subgroup.forEach(function(dataPoint, k) {
                                PreProcessor.helpers.time.applyFormats(dataPoint, timeDataInfo);
                            });
                        }
                        if (!is3DArray) {
                            PreProcessor.helpers.time.applyFormats(subgroup, timeDataInfo);
                        }
                    });
                }
            });
        }
    };


    /**
     *
     * @param xColPos
     * @return {*}
     */

    PreProcessor.prototype.sortData = function(xColPos) {

        var processor = this,
            chart = processor.chart,
            data = processor.data,
            series = chart.seriesdata;

        series.forEach(function(currentSeries) {
            var currentData = currentSeries.data,
                dataIndex = data.metadata.columns[xColPos].dataindex;

            if ($ZC.DataProcessor.helpers.is3D(currentData)) {
                if (isArray(currentData)) {
                    currentData.forEach(function(subgroup) {
                        PreProcessor.helpers.linear.sort(subgroup, dataIndex);
                    });
                }
            } else {
                PreProcessor.helpers.linear.sort(currentData, dataIndex);
            }
        });
        return data;
    };


    /**************** Pre Processor Dependency Functions  **************/

    PreProcessor.helpers = {
        time: {},
        ordinal: {},
        numeric: {},
        linear: {}
    };

    /************ Time Helpers Start **************/


    PreProcessor.helpers.time = {

        /**
         *
         * @param data
         * @param isDiscrete
         * @return {{indices: Array, formatConf: Array}}
         */

        getDataInfo: function(data, isDiscrete) {
            var xColumnIndex = data.metadata.axes.x,
                columnIndexes = d3_merge([xColumnIndex, d3_merge(data.metadata.axes.y)]),
                regexTimeStamp = /timestamp/i,
                timeFormatConfig,
                inputFormat,
                column,
                timeDataIndices = [],
                formatConf = [];

            columnIndexes.map(function(d) {

                column = pick(data.metadata.columns[d], {});
                timeFormatConfig = pick(column.time, {});

                if (column.datatype === "time" && (d !== xColumnIndex && !isDiscrete)) {

                    inputFormat = timeFormatConfig.inputformat;

                    if (!regexTimeStamp.test(inputFormat) || inputFormat === "function" || typeof win[inputFormat] === "function") {
                        formatConf.push(timeFormatConfig);
                    } else {
                        formatConf.push(null);
                    }
                    timeDataIndices.push(data.metadata.columns[d].dataindex);
                }
            });

            return {
                "indices": timeDataIndices,
                "formatConf": formatConf
            };
        },

        /**
         *
         * @param d
         * @param info
         * @return {*}
         */

        applyFormats: function(d, info) {
            var indices = info.indices,
                format = info.formatConf;

            indices.map(function(index, j) {
                if (defined(d[index])) {
                    if (isArray(d[index])) {
                        d[index] = d[index].map(function(d) {
                            return (generateDateVal(d, null, format[j], true)).getTime();
                        })
                    } else {
                        d[index] = (generateDateVal(d[index], null, format[j], true)).getTime();
                    }
                }
            });
            return d;
        }
    };

    /************ Time Helpers End **************/

    /************ Linear Helpers Start **************/

    PreProcessor.helpers.linear = {

        /**
         *
         * @param array
         * @param dataIndex
         */

        sort: function(array, dataIndex) {
            return array.sort(function(a, b) {
                a = a[dataIndex];
                b = b[dataIndex];
                return a < b ? -1 : a > b ? 1 : a >= b ? 0 : NaN;
            });
        }
    };

    /************ Linear Helpers End **************/


    $ZC.PreProcessor = PreProcessor;

})(window);/**
 *
 * @param {String} type chart type
 * @param {number} index series index
 */

$ZC.DataProcessor.prototype.getCategories = function(type, index) {

    var processor = this,
        chart = processor.chartObj,
        hierarchical = chart.dataObject.hierarchical,
        categoriesStore = processor.categoriesStore,
        categories;

    if (isObjectPropDefined(chart.systemConf, "chart.zoom." + type + ".categories")) {
        return chart.systemConf.chart.zoom[type].categories;
    }

    if (type === "x") {

        if(defined(hierarchical)) {
            // for time group
            if(hierarchical.groupByTime) {
                if(index > 0) {
                    categories = hierarchical.categoriesList[index - 1];
                } else {
                    // for time grouped bar chart in leaf category return the original categories.
                    categories = hierarchical.groupByDiscreteTime ? processor.xaxisData.categories : hierarchical.leafCategories
                }
            }
            else {
                // normal multi level axis.
                categories = index > 0 ? hierarchical.categoriesList[index - 1] : hierarchical.leafCategories;
            }
        } else {
            categories = processor.xaxisData.categories;
        }
        index = ""; // this will save a condition. see id=1
    } else {
        categories = processor.yaxesData[index].categories;
    }

    if (!defined(categories) || categories.length === 0) {
        categories = categoriesStore[type + index]; // id=1
    }

    if (type === "y" && !categoriesStore["y" + index].enabled) {
        categories = ["NoData", "NoData"]; // Axis is filtered
    }

    return categories;
};
;

/**
 *
 * @param correctionFactor
 * @returns {[number,number]}
 */

$ZC.DataProcessor.prototype.getMinMaxX = function(correctionFactor) {

    var processor = this,
        xAxisConfig = processor.xaxisData,
        seriesData = processor.processedseriesData,
        chart = processor.chartObj,
        dataSet = processor.dataset,
        customMin = xAxisConfig.minRange,
        customMax = xAxisConfig.maxRange,
        dataType = dataSet.getDataType("x"),
        temp,
        extendX = processor.xRange;

    correctionFactor = pick(correctionFactor, 0.05);

    // if zoom range is defined, use it by default.
    if (isObjectPropDefined(chart.systemConf, "chart.zoom.x")) {
        xRange = chart.systemConf.chart.zoom.x;
        return [xRange.minRange, xRange.maxRange];
    }

    if (!defined(extendX)) {
        temp = seriesData.map(function(d) {
            return d.data.map(function(d) {
                return (d3_extent(d, function(d) {
                    return dataSet.getX(d)
                }));
            });
        });

        var xAxis = pick(getPropVal(chart.userdata, "chart.axes.xaxis"), {});
        extendX = processor.xRange = d3_extent(d3_merge(d3_merge(temp)).concat(processor.getThresholdValues(xAxis)));
    }


    if (processor.isBubbleEnabled && dataType !== TIME_DATATYPE && !defined(customMin) && !defined(customMax)) {
        temp = processor.overBubbles(extendX, "x");
        extendX = [extendX[0] - temp[0], extendX[1] + temp[1]]
    }

    var correctionOverDatalabels = 0, diff, correction;

    // no need to find correction datalabel,if correction factor is 0
    if (dataType !== TIME_DATATYPE && correctionFactor !== 0) {
        correctionOverDatalabels = processor.getCorrectionOverDataLabels(extendX, "x");
    }

    diff = (extendX[1] - extendX[0]);

    if (diff === 0) {
        diff = 1;
    }

    correction = (diff * correctionFactor) + correctionOverDatalabels;
    return [pick(customMin, extendX[0] - correction, 0), pick(customMax, extendX[1] + correction, 0)];
};
/**
 *
 * @param index
 * @param correctionFactor
 * @returns {*}
 */

$ZC.DataProcessor.prototype.getMinMaxY = function(index, correctionFactor) {

    var processor = this,
        yAxisConfig = processor.yaxesData,
        hasNegativeValue = processor.hasNegativeValue,
        baseline = processor.baseline,
        yRange = processor.yRange,
        chart = processor.chartObj,
        dataSet = processor.dataset,
        stacked = processor.isstacked(),
        yAxisData = pick(yAxisConfig[index], {}),
        dataType = dataSet.getDataType("y", index),
        ganttSeriesCount = processor.ganttSeries_count,
        minY = yAxisData.minRange,
        maxY = yAxisData.maxRange,
        correction = 0,
        minMaxDataY = yRange[index],
        temp;

    index = pick(index, 0);
    baseline[index] = getPropVal(yAxisData, "baseline.show") === true ? yAxisData.baseline.value : null;

    if (isObjectPropDefined(chart.systemConf, "chart.zoom.y")) {
        var zoomedY = chart.systemConf.chart.zoom.y,
            zoomedYMinRange = zoomedY.minRange,
            zoomedYMaxRange = zoomedY.maxRange,
            baselineValue = baseline[index];
        hasNegativeValue[index] = (defined(baselineValue) && !stacked && baselineValue >= zoomedYMinRange && baselineValue <= zoomedYMaxRange) ? baselineValue : (zoomedYMinRange < 0) ? 0 : null;

        return [zoomedYMinRange, zoomedYMaxRange];

    }

    // TODO need to check
    // if (defined(minY) && defined(maxY)) {
    //     return [minY, maxY]
    // }

    correctionFactor = pick(correctionFactor, 0.05);
    if (!defined(yRange[index])) { // save the min and max of y at yRange

        if (stacked) {
            yRange[index] = updateMinMaxforStackedData(baseline[index], processor);
            temp = yRange[index][index];
        } else {
            yRange[index] = updateminMax(index, processor);
            temp = yRange[index];
        }

        var yAxis = pick(getPropVal(chart.userdata, "chart.axes.yaxis[" + index + "]"), {});
        if(defined(temp)) {
            temp = d3_extent(temp.concat(processor.getThresholdValues(yAxis)));
        }

        var levelMarkerMinMax;
        if (processor.hasLevelMarker || (processor.noofBarEnabledSeries && !ganttSeriesCount)) {
            levelMarkerMinMax = processor.overLevelMarker(temp)
        }

        if (stacked) {
            yRange[index][index] = pick(levelMarkerMinMax, temp);
        } else {
            yRange[index] = pick(levelMarkerMinMax, temp);
        }
        minMaxDataY = yRange[index];
    }


    if (!defined(minMaxDataY) || (stacked && !defined(minMaxDataY[index]))) {
        return ["NoData", "NoData"]
    }

    var extentY = stacked ? minMaxDataY[index] : minMaxDataY;

    if (dataType === TIME_DATATYPE) {
        hasNegativeValue[index] = null;
    } else {
        hasNegativeValue[index] = (defined(baseline[index]) && !stacked) ? baseline[index] : (yAxisData.minRange < 0 || extentY[0] < 0) ? 0 : null;
    }


    var hasDefaultBase = (processor.noofBarEnabledSeries || processor.noofAreaEnabledSeries) && !processor.hasLevelMarker && (hasNegativeValue[index] != null ? (hasNegativeValue[index] > 0) : (dataType == NUMERIC_DATATYPE));

    //If extentY = [undefined, undefined], don't change the extent with '0'

    if ((dataType === NUMERIC_DATATYPE) && (processor.noofBarEnabledSeries || processor.noofAreaEnabledSeries) && ((extentY[1] - extentY[0]) === 0)) {
        extentY = d3_extent(d3_merge([extentY, [0]])); // Test_511.json & Test_512.json
    }

    if (processor.isBubbleEnabled && dataType !== TIME_DATATYPE && !defined(yAxisData.minRange) && !defined(yAxisData.maxRange)) {

        //if 'hasDefaultBase' is present, apply that. so that we can adjust the bubbles within range.
        extentY[0] = hasDefaultBase ? 0 : extentY[0];

        temp = processor.overBubbles(extentY, "y", index);
        extentY = [(extentY[0] - temp[0]), (extentY[1] + temp[1])]
    }

    var diff = (extentY[1] - extentY[0]);

    if (diff === 0) {
        diff = 1;
    }

    if (!(processor.isStackedPercentChart || processor.hasLevelMarker)) {
        correction = diff * correctionFactor;
    }

    if (!defined(minY)) {
        minY = hasDefaultBase ? 0 : extentY[0] - correction;
    }

    if (!defined(maxY)) {
        maxY = extentY[1] + correction
    }

    var correctionOverDatalabels = 0;

    // no need to find correction datalabel,if correction factor is 0
    if (dataType !== "time" && correctionFactor !== 0) {
        correctionOverDatalabels = this.getCorrectionOverDataLabels([minY, maxY], "y", index);
    }


    if (!hasDefaultBase) {
        minY = (minY - correctionOverDatalabels) || 0;
    }

    maxY = (maxY + correctionOverDatalabels) || 0;
    return [minY, maxY];
};

function updateminMax(index, model) {
    // var yValues = categoriesStore["y"+index];
    var yValues = d3_merge(model.seriesExtermes[index]);
    var minmaxY = (yValues.length != 0) ? d3_extent(yValues) : (yValues.enabled) ? [0, 0] : null; // yvalues.enabled for referring that axis is visible or not.If the axis is visible,but all the data contains 0 or null,we dont want to remove axis
    return minmaxY;
}

function updateMinMaxforStackedData(baseline, context) {

    //

    var dataset = context.dataset,
        data = context.data,
        chartObj = context.chartObj;

    var processedseriesData = context.processedseriesData,
        groupedDataByCombo = context.groupedDataByCombo,
        groupedDataBySplitAxes = context.groupedDataBySplitAxes,
        categoriesStore = context.categoriesStore,
        groupedByStack = context.groupedByStack,
        dataObject = chartObj.dataObject,
        helpers = $ZC.DataProcessor.helpers;


    //
    var seriesdata = processedseriesData;
    var baseValue = 0; //(baseline == null) ? 0 : parseFloat(baseline)

    var grouped = (context.isCombinationalChart || data.seriesdata.stackGroup) ? groupedDataByCombo.values() : groupedDataBySplitAxes;
    var xCategories = dataObject.getDomain(context.getCategories("x")),
        xCategoriesLength = xCategories.length,
        groupByValues = categoriesStore.subseries,
        isCatNullX = helpers.isCatNull(dataset, "x"),
        minmaxY = [],
        lastSeriesY = [];

    var stackeddata = grouped.map(function(d, i) {
        var currType = groupedDataByCombo.keys()[i];
        var split = currType.split("_");
        var chartType = +split[0],
            groupIndex = defined(split[1]) ? +split[1] : i;
        var isStkd = context.isstacked(chartType);

        // y0 arrarys
        var y0Positive = [],
            y0Negative = [];

        var dt = d3_merge(d.map(function(da, j) {
            var seriesIndex = da.si;
            var yaxiscolumnorder = helpers.getParsedYAxisOrder(processedseriesData[seriesIndex].yaxiscolumnorder);

            if (isStkd && !isBarChartType(chartType)) { // CHANGE
                // add dummy group for missed groupbyvalues
                var curSubseriesVal = da.d.map(function(d) {
                    return d.groupByVal
                })
                for (var i = 0; i < groupByValues.length; i++) {
                    var key = groupByValues[i];
                    var havSubSeriesidx = curSubseriesVal.indexOf(key);
                    if (havSubSeriesidx < 0 && key != null) {
                        var duplicate = [];
                        da.d.splice(i, 0, duplicate);
                    }
                }
            }

            var dt = da.d.map(function(d, k) {
                if (isStkd && !isBarChartType(chartType)) { // CHANGE
                    var xMappingFunction = function(d) {
                        return dataset.getX(d)
                    };
                    var currentkeys = d.map(xMappingFunction);
                    for (var i = 0, len = xCategoriesLength; i < len; i++) {
                        var key = xCategories[i];
                        var haveKey = currentkeys.indexOf((key));
                        //aaranging order of data as per x order;
                        if (haveKey >= 0 && haveKey != i) {
                            d.splice(i, 0, d[haveKey]); //copying , Moving unordererd data to correct position i
                            d.splice(haveKey + 1, 1); // removing the copied data from old position havekey
                            currentkeys = d.map(xMappingFunction); // Rearranging the currentkeys
                        }
                        if (typeof currentkeys[i] != 'undefined' && isCatNullX(currentkeys[i])) {
                            d.splice(i, 1);
                        }
                        if (haveKey < 0) {
                            var duplicate = []
                            var order = helpers.getParsedYAxisOrder(processedseriesData[da.si].yaxiscolumnorder);
                            duplicate.splice(dataset.xidx, 0, (key));
                            duplicate.splice(dataset.yidx(order), 0, 0); //dummy data add as 0
                            duplicate.isDummy = true;
                            d.splice(i, 0, duplicate);
                            currentkeys = d.map(xMappingFunction); // Rearranging the currentkeys
                        }
                    }

                    // If the series has duplicate x values, just remove that. Test_586.json, Test_587.json
                    if (xCategoriesLength != d.length) {
                        d.splice(xCategoriesLength, (d.length - xCategoriesLength));
                    }
                }
                return d.map(function(d) {
                    var x = dataset.getX(d),
                        y = dataset.getY(d, yaxiscolumnorder);
                    var xCategoryIndex = xCategories.indexOf(x);
                    var y0ArrayToBeUpdated = (y < 0) ? y0Negative : y0Positive; // If y-value is (-ve) update on y0Negative, Else update on y0Positive array
                    var y0 = y0ArrayToBeUpdated[xCategoryIndex];

                    if (isStkd) {
                        y0 = defined(y0) ? y0 : baseValue;
                        d.y0 = y0;
                        d.y = y;
                        lastSeriesY[xCategoryIndex] = y0 + y;
                        y0ArrayToBeUpdated[xCategoryIndex] = y0 + y; // Update the y0 array
                    } else {
                        if (defined(y0)) {
                            y0ArrayToBeUpdated[xCategoryIndex] = ((y < 0) ? mathMin : mathMax)(y0, y);
                        } else {
                            y0ArrayToBeUpdated[xCategoryIndex] = y;
                        }
                    }

                    return d;
                });
            });
            return dt;
        }));

        minmaxY[i] = d3_extent(d3_merge([y0Positive, y0Negative, [0]]));

        // Save the stack extent
        // If stacklabel.show = true | datalabels.showAs = 'percent' | metadata.axes.tooltip = ['{{per(1)}}']
        var chartName = $ZC.charttypenames.get(chartType);
        if (isStkd && (isStacklabelEnabled(data.chart.plot.plotoptions[chartName].datalabels.stackLabels, chartObj) || isShowAsPercentage(chartName, chartObj) || PERCENT_PATTERN.test(data.metadata.axes.tooltip))) {
            if (!groupedByStack.has(groupIndex)) { // groupedByStack is available for bar chart only
                groupedByStack.set(groupIndex, {});
            }
            groupedByStack.get(groupIndex).stackExtent = updateStackExtent(xCategories, y0Positive, y0Negative);
        }

        return dt;
    });

    minmaxY = (groupedDataBySplitAxes.length > 1) ? minmaxY : [d3_extent(d3_merge(minmaxY))]

    if (context.isStackedPercentChart) {
        stackeddata.map(function(data) {
            return data.map(function(series) {
                return series.map(function(d) {
                    var xCategoryIndex = xCategories.indexOf(dataset.getX(d));
                    var max = lastSeriesY[xCategoryIndex] || 0;
                    if (isNaN(max) != true && max != null && max != 0) {
                        d.y0 /= max / 100;
                        d.y /= max / 100;
                    }
                    return d;
                })
            })

        });
        minmaxY[0][0] = 0, minmaxY[0][1] = 100;
    }
    return minmaxY;
}

function updateStackExtent(xCategories, pos, neg) {
    var stackValues = [];
    xCategories.forEach(function(x, j) {
        if (pos[j] >= 0) {
            stackValues.push([x, pos[j]]);
        }
        if (neg[j] < 0) {
            stackValues.push([x, neg[j]]);
        }
    });
    return stackValues;
}/**
 *
 * @param cType
 * @returns {boolean}
 */

$ZC.DataProcessor.prototype.isstacked = function(cType) {

    var data = this.data,
        plotoptions = data.chart.plot.plotoptions,
        stackedChart = this.stackedChart,
        helpers = $ZC.DataProcessor.helpers;

    if (defined(cType)) {
        var numType = helpers.getChartType(cType, NUMERIC_DATATYPE);
        cType = helpers.getChartType(cType, "string");
        plotoptions = plotoptions[cType];
        return numType === $ZC.charttype.stkdarea
            || numType === $ZC.charttype.stkdbar
            || numType === $ZC.charttype.bullet
            || cType === "bullet"
            || ( (cType === "bar" || cType === "area" || cType === "web" || cType === "line") && (getPropVal(plotoptions, "stacked.enabled") === true) );
    }

    if (!defined(stackedChart)) {
        var allChartTypes = this.allChartTypes || helpers.getAllChartTypes(data);
        var type = allChartTypes[0];
        this.stackedChart = stackedChart = (allChartTypes.indexOf($ZC.charttype.stkdarea) !== -1) //contains StkdArea
            || (allChartTypes.indexOf($ZC.charttype.stkdbar) !== -1) //contains StkdBar
            || (allChartTypes.indexOf($ZC.charttype.bullet) !== -1) //contains Bullet
            || ( (allChartTypes.indexOf($ZC.charttype.bar) !== -1) && (getPropVal(plotoptions, "bar.stacked.enabled") === true) ) //contains bar + (stacked.enabled = true)
            || ( (allChartTypes.indexOf($ZC.charttype.area) !== -1) && (getPropVal(plotoptions, "area.stacked.enabled") === true) ) //contains area + (stacked.enabled = true)
            || ( (type === $ZC.charttype.web) && (getPropVal(plotoptions, "web.stacked.enabled") === true) ) //contains web + (stacked.enabled = true)
            || ( (type === $ZC.charttype.line) && (getPropVal(plotoptions, "line.stacked.enabled") === true) ) //contains line + (stacked.enabled = true)
    }
    return stackedChart;
};
/**
 *
 * @param axisrotated
 * @param stacked
 * @param xscale
 * @param yscale
 * @param yaxiscolumnorder
 * @param d
 * @param type
 * @param zscale
 * @param yrangePos
 * @returns {*}
 */

$ZC.DataProcessor.prototype.getXYvalue = function(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, type, zscale, yrangePos) {

    var model = this,
        yaxesData = this.yaxesData,
        dataset = this.dataset;

    if (model.isPolarAxisCategory) {
        var baseIdx = (yaxesData[yaxiscolumnorder].reversed && !stacked) ? yscale.domain().length - 1 : 0;
        var a = xscale(dataset.getX(d)),
            r = stacked ?
                yscale(d.y + d.y0) :
                (yscale(dataset.getY(d, yaxiscolumnorder)) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
        r = mathMax(r, yscale.range()[baseIdx]);
        var xy = polarToXY(r, a);
        return (type === "x") ? xy[0] : xy[1];
    }
    switch (type) {
        case "x":
            if (axisrotated) {
                return (stacked) ? yscale(d.y + d.y0) : (yscale(dataset.getY(d, yaxiscolumnorder, yrangePos)) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
            }
            return xscale(dataset.getX(d)) + ((xscale.rangeBand != null) ? xscale.rangeBand() / 2 : 0);
        case "y":
            if (axisrotated) {
                return xscale(dataset.getX(d)) + ((xscale.rangeBand != null) ? xscale.rangeBand() / 2 : 0);
            }
            return (stacked) ? yscale(d.y + d.y0) : (yscale(dataset.getY(d, yaxiscolumnorder, yrangePos)) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
        case "z":
            return zscale(dataset.getZ(d) || zscale.domain()[0]);

    }
};

/**
 *
 * @param param
 * @param d
 * @param i
 * @param j
 * @param cp
 * @param radius
 * @param yrangePos
 * @returns {*}
 */

$ZC.DataProcessor.prototype.getTransRectValue = function(param, d, i, j, cp, radius, yrangePos) {

    var dataset = this.dataset,
        helpers = $ZC.DataProcessor.helpers,
        priorityBasedValue = helpers.priorityBasedValue

    var isYRange = cp && dataset.getY(d, cp.yaxiscolumnorder) instanceof Array;
    var minRange = cp && (cp.yscale.range()[0] + cp.addRangeBand(cp.yscale)),
        maxRange = cp && cp.yscale.range()[1];
    switch (param) {
        case "x":
            if (cp.axisrotated) {
                yrangePos = (isYRange) ? 0 : null;
                var curY = dataset.getY(d, cp.yaxiscolumnorder, yrangePos);
                return (cp.yscale.rangeExtent) ?
                    cp.yscale.rangeExtent()[0] :
                    ((cp.stacked ? cp.yscale(mathMin(d.y0, (d.y + d.y0))) :
                        (yrangePos != null) ? cp.yscale(curY) :
                            cp.yscale((cp.hasNegValue != null) ? ((curY < cp.hasNegValue) ? curY : cp.hasNegValue) : cp.yscale.domain()[0])));
            }

            var v = dataset.getX(d);
            return ((cp.stacked ? cp.bandwidth1(v) + cp.bandwidth2(cp.stackGroupIndex) : cp.bandwidth1(v) + cp.bandwidth2(cp.barDatasetIndex + i)) + cp.padding);
        case "y":
            if (cp.axisrotated) {
                var v = dataset.getX(d);
                return (cp.stacked ? cp.bandwidth1(v) + cp.bandwidth2(cp.stackGroupIndex) : cp.bandwidth1(v) + cp.bandwidth2(cp.barDatasetIndex + i)) + cp.padding;
            }
            yrangePos = (yrangePos != null) ? yrangePos : ((isYRange) ? 1 : null);
            var curY = dataset.getY(d, cp.yaxiscolumnorder, yrangePos);
            return (cp.stacked ? cp.yscale(mathMax(d.y0, (d.y + d.y0))) + cp.addRangeBand(cp.yscale) :
                (cp.yscale((cp.yscale.rangeBand == null) ? mathMax(cp.hasNegValue || 0, curY) : curY) + cp.addRangeBand(cp.yscale)));
        case "width":
            if (cp.axisrotated) {
                var basevalue = cp.hasNegValue == null ? (isYRange) ? cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, 0)) :
                    minRange :
                    cp.yscale(cp.hasNegValue);
                yrangePos = (isYRange) ? 1 : null;
                var curY = cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, yrangePos));
                return (cp.yscale.rangeExtent) ?
                    curY + cp.addRangeBand(cp.yscale) :
                    ((cp.stacked) ? (mathAbs(cp.yscale(d.y + d.y0) - cp.yscale(d.y0))) + cp.addRangeBand(cp.yscale) :
                        (mathAbs((maxRange - basevalue) - (maxRange - curY)) || 0) + cp.addRangeBand(cp.yscale));
            }
            return cp.barWidth;
        case "height":
            if (cp.axisrotated) {
                return cp.barWidth;
            }
            var basevalue = cp.hasNegValue != null ? cp.yscale(cp.hasNegValue) : (isYRange && !cp.stacked) ? cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, 0)) :
                minRange
            yrangePos = (isYRange) ? 1 : null;
            var curY = cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, yrangePos));
            return cp.stacked ? mathAbs(((basevalue) - cp.yscale(d.y + d.y0)) - ((basevalue) - cp.yscale(d.y0))) + cp.addRangeBand(cp.yscale) :
                mathAbs(basevalue - curY) + cp.addRangeBand(cp.yscale);
        case "radius": {
            var parsedVal = {}
            var splittedStr = (radius != null) ? radius.toString().split("/") : null
            var rx = (splittedStr != null && splittedStr[0] != null) ? splittedStr[0].split(" ") : [],
                ry = (splittedStr != null && splittedStr[1] != null) ? splittedStr[1].split(" ") : rx;
            /*
             * index 0-->topleft,  1-->topright,  2-->bottomright,  3-->bottomleft
             */
            parsedVal.tlx = pInt(priorityBasedValue([rx[0]]))
            parsedVal.tly = pInt(priorityBasedValue([ry[0], rx[0]]))

            parsedVal.trx = pInt(priorityBasedValue([rx[1], rx[0]]))
            parsedVal.trY = pInt(priorityBasedValue([ry[1], ry[0], rx[1], rx[0]]))

            parsedVal.brx = pInt(priorityBasedValue([rx[2], rx[0]]))
            parsedVal.bry = pInt(priorityBasedValue([ry[2], ry[0], rx[2], rx[0]]))

            parsedVal.blx = pInt(priorityBasedValue([rx[3], rx[1], rx[0]]))
            parsedVal.bly = pInt(priorityBasedValue([ry[3], ry[1], rx[3], rx[0]]))

            return parsedVal
        }
    }
};/**
 *
 * @param domain
 * @param type
 * @param index
 * @returns {number}
 */

$ZC.DataProcessor.prototype.getCorrectionOverDataLabels = function(domain, type, index) {

    var processor = this,
        chartObj = processor.chartObj,
        xaxisData = processor.xaxisData,
        yaxesData = processor.yaxesData,
        domainCorrections = processor.domainCorrections,
        processedseriesData = processor.processedseriesData,
        groupedDataBySplitAxes = processor.groupedDataBySplitAxes;

    var isXaxis = (type == "x"),
        id = type + (defined(index) ? index : ""),
        axisConf = (isXaxis ? xaxisData : yaxesData[index]),
        customMinval = axisConf.minRange,
        customMaxval = axisConf.maxRange,
        pHeight = chartObj.plotarea.height;
    if (!processor.isStackedPercentChart && !(processor.isBubbleEnabled && !processor.pieWithAxis) && (processor.isAxisCategory || processor.isNonAxisMultiSeriesCategory) && !(customMinval != null && customMaxval != null) && $ZC.labelRenderer && ((domainCorrections.byDatalabels[id] == null) || (pHeight != domainCorrections.plotHeight))) {
        domainCorrections.plotHeight = pHeight;
        var orient = chartObj.axes[type].orient,
            rangeDiff = chartObj.plotarea[(orient == "left") ? "height" : "width"],
            domainDiff = (domain[1] - domain[0]),
            serData = isXaxis ? processedseriesData : groupedDataBySplitAxes[index],
            maxFontSize = (serData != null) ? getDataLabelsSize(type, serData, chartObj) : 0; //stacked bar + line chart, throws error when filtering all the bar series
        domainCorrections.byDatalabels[id] = (domainDiff / (rangeDiff - maxFontSize)) * maxFontSize;
    }
    return (domainCorrections.byDatalabels[id] || 0);
};
/**
 *
 * @param domain
 * @param range
 * @param systemconf
 * @param padding
 * @param outerpadding
 * @param type
 * @param index
 * @returns {number}
 */

$ZC.DataProcessor.prototype.extendOuterpadding = function(domain, range, systemconf, padding, outerpadding, type, index) {

    var processedseriesData = this.processedseriesData,
        groupedDataBySplitAxes = this.groupedDataBySplitAxes,
        chartObj = this.chartObj;

    var outerPadding = 0;
    if (dataLabelEnabled(chartObj) || this.isBubbleEnabled) {
        if (range[0] > range[1]) {
            range = [range[1], range[0]];
        }
        var scale = d3_scaleOrdinal()
                .domain(domain)
                .rangeBands(range, padding, outerpadding),
            updatedMinMax = range;
        if (this.isBubbleEnabled) {
            var minmax = this.updateMinMaxForBubble(range, scale, type, index),
                correction = mathMax((range[0] - minmax[0]), (minmax[1] - range[1])) * 0.5;
            updatedMinMax = [(minmax[0] - correction), (minmax[1] + correction)];
        } else if ($ZC.labelRenderer) {
            var serData = (type == "x") ? processedseriesData : groupedDataBySplitAxes[index],
                maxFontSize = getDataLabelsSize(type, serData, chartObj),
                pad = scale.range()[0] - scale.rangeExtent()[0],
                maxFontSize = mathMax(0, (maxFontSize - pad));
            updatedMinMax = [(range[0] - maxFontSize), (range[1] + maxFontSize)];
        }
        outerPadding = calculateOuterpadding(scale, padding, outerpadding, updatedMinMax);
    }
    return outerPadding;
};

function dataLabelEnabled(chartInstance) {

    var systemConfig = chartInstance.systemConf,
        totalDataCount = chartInstance.dataObject.totalnoofdatas,
        allowedLabelCount = +systemConfig.canvas.intelligence.dataCount.datalabels;

    if (totalDataCount > allowedLabelCount) {
        return false;
    }

    if (getPropVal(systemConfig.chart, "plot.datalabels.show") === true) {
        return true;
    }
    var seriesData = chartInstance.seriesdata,
        len = seriesData.length;

    while (len--) {
        var commonPlotOptions = systemConfig.chart.plot.plotoptions[chartInstance.chartTypes[len].name],
            datalabels = commonPlotOptions.datalabels;

        if(defined(seriesData[len].plotoptions)) {
            datalabels = getMergedDatalabelOptions(commonPlotOptions, seriesData[len].plotoptions);
        }
        if(isDatalabelEnabled(datalabels, chartInstance)) {
            return true;
        }
    }
    return false;
}

function calculateOuterpadding(scale, padding, outerpadding, updatedMinMax) {
    var rangeExtent = scale.rangeExtent ? scale.rangeExtent() : scale.range(),
        domain = scale.domain(),
        rangeDiff = (rangeExtent[1] - rangeExtent[0]),
        min = updatedMinMax[0],
        max = updatedMinMax[1];
    var correction = mathMax((max - rangeExtent[1]), -(min));
    if (!correction) {
        return 0;
    }
    var step = rangeDiff / (domain.length - padding + 2 * outerpadding);
    var outerpad = step * outerpadding;
    var newouterpad = outerpad + correction;
    var newstep = (rangeDiff - (2 * newouterpad)) / (domain.length - padding);
    var newouterpadding = newouterpad / newstep;
    return newouterpadding - outerpadding;
}
/**
 *
 * @param d
 * @param groupbyDataIndices
 * @param chartType
 * @return {*|Array}
 */

$ZC.DataProcessor.prototype.convertTo3DArray = function(d, groupbyDataIndices, chartType) {

    var curdata = d.data;

    if (groupbyDataIndices.length > 0 && (chartType === $ZC.charttype.bar || chartType === $ZC.charttype.stkdbar)) {
        //Finding unique categories across series

        var groupbyCategories = getDistinctGroupbyCategories(d, groupbyDataIndices),
            distintGroupbyCat = groupbyCategories.distintGroupbyCat,
            allGroupbyCat = groupbyCategories.allGroupbyCat;

        //Grouping data by unique categories across series
        var newSeriesdata = [];
        d.data.forEach(function(d, j) {
            var index = distintGroupbyCat.indexOf(allGroupbyCat[j]);
            if (!newSeriesdata[index]) {
                newSeriesdata[index] = [];
                newSeriesdata[index].push(d);
            } else {
                newSeriesdata[index].push(d);
            }
        });
        curdata = d.data = newSeriesdata;
    }
    // If data is [[]], don't convert to 3D as stacked bar chart throws error on d3.layout.stack().
    // Convert is possible, if data is [] or 2D with data points

    else if ((defined(curdata)) && ((!curdata.length) || ((defined(curdata[0])) && curdata[0].length))) {
        d.data = [];
        d.data.push(curdata);
        curdata = d.data;
    }

    return curdata;
};

/**
 *
 * @param curSeriesdata
 * @param groupbyDataIndices
 * @return {{distintGroupbyCat: Array, allGroupbyCat: Array}}
 */

function getDistinctGroupbyCategories(curSeriesdata, groupbyDataIndices) {
    var distintGroupbyCat = [],
        allGroupbyCat = [];
    curSeriesdata.data.forEach(function(d) {
        var x = groupbyDataIndices.reduce(function(prev, cur) {
            return prev + d[cur]
        }, "");
        allGroupbyCat.push(x)
        if (distintGroupbyCat.indexOf(x) === -1) {
            distintGroupbyCat.push(x)
        }
    });

    return {
        "distintGroupbyCat": distintGroupbyCat,
        "allGroupbyCat": allGroupbyCat
    }
}/**
 *
 * @param includeDisabled
 */

$ZC.DataProcessor.prototype.findXCategories = function(includeDisabled) {

    var processor = this,
        categoriesStore = processor.categoriesStore,
        processedseriesData = processor.processedseriesData,
        dataset = processor.dataset;

    var XCat = categoriesStore.x;

    processedseriesData.forEach(function(d, i) {
        var disabled = d.disabled && !includeDisabled,
            curdata = d.data;
        if (!disabled && curdata != null && curdata.constructor == Array) {
            curdata.map(function(subgroup, j) {
                if (subgroup != null && subgroup.constructor == Array) {
                    return subgroup.map(function(dataPoint) {
                        var xVal = dataset.getX(dataPoint);
                        ((xVal != null) && (XCat.indexOf(xVal) == -1)) ? XCat.push(xVal) : null;
                    })
                }
            })
        }
    });
    return XCat;
};



$ZC.DataProcessor.prototype.storeCategories = function(curdata, stacked, groupbyDataIndices, chartType, actXdatatype, yDatatype, yaxiscolumnorder) {

    var processor = this,
        dataset = processor.dataset,
        categoriesStore = processor.categoriesStore,
        XCat = categoriesStore.x,
        yCat = categoriesStore["y" + yaxiscolumnorder],
        helpers = $ZC.DataProcessor.helpers;

    var isCatNullX = helpers.isCatNull(dataset, "x"),
        isCatNullY = helpers.isCatNull(dataset, "y", yaxiscolumnorder);

    if (stacked) {
        curdata.map(function(subgroup, j) {
            if (!curdata.disabled && isArray(subgroup)) {
                return subgroup.map(function(dataPoint) {
                    var xVal = dataset.getX(dataPoint);
                    var groupByVal = (groupbyDataIndices.length > 0) ? dataset.getGroupByValues(dataPoint, groupbyDataIndices) : null;

                    if (xVal > processor.lastCategoryValue && !processor.needXCategoriesSorting) {
                        processor.lastCategoryValue = xVal
                    } else if (!processor.needXCategoriesSorting && XCat.indexOf(xVal) == -1) {
                        processor.needXCategoriesSorting = true;
                    }

                    (!isCatNullX(xVal) && XCat.indexOf(xVal) == -1) ? XCat.push(xVal) : null;

                    if (groupByVal != null) {
                        subgroup.groupByVal = groupByVal;
                        dataPoint.groupByVal = groupByVal;
                        (categoriesStore.subseries.indexOf(groupByVal) == -1) ? categoriesStore.subseries.push(groupByVal) : null;
                    }

                })
            }
        })
    }

    else if ((actXdatatype === ORDINAL_DATATYPE) || (yDatatype === ORDINAL_DATATYPE)) {
        curdata.map(function(subgroup, j) {
            if (!curdata.disabled && isArray(subgroup)) {
                return subgroup.map(function(dataPoint) {
                    var xVal = dataset.getActualX(dataPoint),
                        yVal = dataset.getY(dataPoint, yaxiscolumnorder);
                    if (actXdatatype === ORDINAL_DATATYPE && !isCatNullX(xVal)) {
                        (XCat.indexOf(xVal) === -1) ? XCat.push(xVal) : null;
                    }
                    if (yDatatype === ORDINAL_DATATYPE) {
                        if (chartType === $ZC.charttype.arearange || chartType === $ZC.charttype.gantt) {
                            (defined(yVal) && yCat.indexOf(yVal[0]) === -1) ? yCat.push(yVal[0]) : null;
                            (defined(yVal) && yCat.indexOf(yVal[1]) === -1) ? yCat.push(yVal[1]) : null;
                        } else {
                            (!isCatNullY(yVal) && yCat.indexOf(yVal) === -1) ? yCat.push((yVal)) : null;
                        }
                    }
                })
            }
        })
    }
};
/**
 *
 * @param extentY
 * @returns {*}
 */

$ZC.DataProcessor.prototype.overLevelMarker = function(extentY) {

    var context = this,
        helpers = $ZC.DataProcessor.helpers,
        qualitativeRanges = context.qualitativeRanges,
        processedseriesData = context.processedseriesData,
        chartName = helpers.getChartType((context.processedseriesData[0].type || context.globalChartType), "string"),
        conf = context.data.chart.plot.plotoptions[chartName],
        levelMarker = conf.levelMarker,
        targetMarker = conf.targetMarker,
        levelMarkerIndex,
        targetMarkerIndex;


    if (!defined(qualitativeRanges)) {

        qualitativeRanges = context.qualitativeRanges = [];

        processedseriesData.forEach(function(series) {
            var plotOptions = series.plotoptions || {};

            levelMarker = mergeJSON(levelMarker, plotOptions.levelMarker);
            targetMarker = mergeJSON(targetMarker, plotOptions.targetMarker);

            levelMarkerIndex = levelMarker.dataindex;
            targetMarkerIndex = targetMarker.dataindex;

            if ((levelMarker.enabled || targetMarker.enabled)) {

                if ((levelMarkerIndex || targetMarkerIndex)) {
                    series.data.forEach(function(subSeries) {
                        subSeries.forEach(function(point) {


                            if (targetMarker.enabled && defined(point[targetMarkerIndex])) {
                                qualitativeRanges.push(point[targetMarkerIndex]);
                            }

                            if (levelMarker.enabled &&defined(point[levelMarkerIndex])) {
                                // in bullet chart data comes in array
                                if (isArray(point[levelMarkerIndex])) {
                                    qualitativeRanges = qualitativeRanges.concat(point[levelMarkerIndex]);
                                } else {
                                    qualitativeRanges.push(point[levelMarkerIndex]);
                                }
                            }
                        })
                    })
                } else if (levelMarker.enabled && defined(levelMarker.values)) {
                    qualitativeRanges = qualitativeRanges.concat(levelMarker.values);
                }
            }
        })
    }

    if (isNaN(qualitativeRanges[1] - qualitativeRanges[0]) && !this.hasLevelMarker) {
        return extentY;
    }

    return d3.extent(d3.merge([qualitativeRanges, extentY, [0]]));
};

$ZC.DataProcessor.prototype.totalDataCount = function(curdata) {
    var processor = this,
        temp = 0;
    curdata.map(function(subgroup) {
        if (!curdata.disabled && isArray(subgroup)) {
            var len = (processor.isAxisCategory || processor.isPolarAxisCategory || processor.isNonAxisMultiSeriesCategory) ?
                subgroup.length :
                subgroup.reduce(function(prev, cur) {
                    return prev + (cur.disabled ? 0 : 1)
                }, 0);
            temp += ((len === 1) && (subgroup[0] === null || !subgroup[0].length)) ? 0 : len;
        }
    });
    this.totalnoofdatas += temp;
    return temp;
};//$Id$
/*
 * this is an extended utility to the data parser to process the data with supporting methods like
 * getCategories, getMin or Max of a series values etc.,
 */
$ZC.hierarchymodel = {}
$ZC.hierarchymodel.get = function(chartObj) {
    var data = chartObj.systemConf,
        dataset = chartObj.dataset,
        processedseriesData = chartObj.seriesdata,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;

    var model = {
        data: data
    };

    model.getTransRectValue = function (param, d, i, j, cp, radius, yrangePos) {
        var priorityBasedValue = dataProcessorHelpers.priorityBasedValue;
        switch (param) {
            case "radius": {
                var parsedVal = {}
                var splittedStr = (radius != null) ? radius.toString().split("/") : null
                var rx = (splittedStr != null && splittedStr[0] != null) ? splittedStr[0].split(" ") : [],
                    ry = (splittedStr != null && splittedStr[1] != null) ? splittedStr[1].split(" ") : rx;
                /*
                 * index 0-->topleft,  1-->topright,  2-->bottomright,  3-->bottomleft
                 */
                parsedVal.tlx = pInt(priorityBasedValue([rx[0]]))
                parsedVal.tly = pInt(priorityBasedValue([ry[0], rx[0]]))
                
                parsedVal.trx = pInt(priorityBasedValue([rx[1], rx[0]]))
                parsedVal.trY = pInt(priorityBasedValue([ry[1], ry[0], rx[1], rx[0]]))
                
                parsedVal.brx = pInt(priorityBasedValue([rx[2], rx[0]]))
                parsedVal.bry = pInt(priorityBasedValue([ry[2], ry[0], rx[2], rx[0]]))
                
                parsedVal.blx = pInt(priorityBasedValue([rx[3], rx[1], rx[0]]))
                parsedVal.bly = pInt(priorityBasedValue([ry[3], ry[1], rx[3], rx[0]]))
                
                return parsedVal
            }
        }
    };
    model.getAxisRotated = function() {
        var axes = model.data.chart.axes;
        return axes && axes.rotated === true;
    };

    model.containsNegativeData = function() {
        return false;
    };

    model.isstacked = function() {
        return false;
    };    

    model.getPlotBorder = function() {
        var plotBorderOptions = data.chart.plot.border;
        var borderSize = plotBorderOptions.show === true
            ? validateValWithinLimit(plotBorderOptions, "size", 0, 10, chartObj.plotarea.width, chartObj.plotarea.height)
            : 0;
        borderSize = {
                "left": borderSize,
                "top": borderSize,
                "right": borderSize,
                "bottom": borderSize
            };
        return borderSize;
    };

    function dataToArray(obj){
        return obj.map(function(d){
            var arr;
            if (d.data && d.data[0] && d.data[0].constructor === Array) {
                arr = d.data;
                var leafColors = d.leafColors;
                if (leafColors) {
                    arr.forEach(function(d, i) {
                        d.color = leafColors[i %leafColors.length];
                    });
                }
            } else if (d.data){
                model.hasHierarchyData = true;
                arr = dataToArray(d.data);
            } else {
                arr = d;
            }

            for (var attr in d) {
                if (d.hasOwnProperty(attr) && attr !== "data") {
                    arr[attr] = d[attr];
                }
            }

            return arr;
        });
    }

    function processHierachyData(parent) {
        parent.forEach(function(d, i) {
            d.level = (parent.level != null) ? (parent.level + "_" + i) : (i + "");

            if (isArray(d[0])) {
                processHierachyData(d);
            } else {
                var seriesIndex = +d.level.split("_")[0],
                    currentdata = data.seriesdata.chartdata[seriesIndex],
                    yaxiscolumnorder = dataProcessorHelpers.getParsedYAxisOrder(currentdata.yaxiscolumnorder);

                if (!currentdata.disabled) {
                    var yExtremes = d3_extent([d], function(d) {
                                        return dataset.getY(d, yaxiscolumnorder)
                                    });

                    model.seriesExtermes[0].push(yExtremes);
                    model.totalnoofdatas++;
                }
            }
        });
    }

    model.initialize = function(state) {
        globalChartType = data.seriesdata && data.seriesdata.type;
        dataset.seriesTypes = [];
        model.totalnoofdatas = 0;
        model.isNonAxisMultiSeriesCategory = true;
        model.isHierarchy = true;
        model.seriesExtermes = [[]];
        
        if (processedseriesData != null && isArray(processedseriesData)) {
            if (state != "addorremoveseries") {
                chartObj.seriesdata = processedseriesData = dataToArray(processedseriesData);
            }

            processHierachyData(processedseriesData);
            processedseriesData.forEach(function(d, i) {
                var chartType = dataProcessorHelpers.getChartType((d.type || globalChartType), NUMERIC_DATATYPE);
                dataset.seriesTypes.push(chartType);
            });
        };
    }
    
    model.initialize();
    return model;
};

function getChildrenCount(dt, count) {
    if (!count) {
        count = 0;
    }

    dt.forEach(function(d) {
        if (isArray(d[0])) {
            count = getChildrenCount(d, count);
        } else {
            count++;
        }
    });
    return count;
}

//$Id$
$ZC.defaultTheme = function(userProp) {
    //userProp for getting fontSize wrt chartObj not globally
    
    var defaulttheme = {
        "canvas": {
            "fontFamily": $ZCG.globalProp.fontL1Family, //Note: import font to your application if it is not supported by the browser.
            "fontColor": $ZCG.globalProp.fontL1Color,
            "fontSize": userProp.fontL1Size.l3,
            "fontWeight": $ZCG.globalProp.fontL1Weight, //normal || bold || bolder || lighter || 100 || 200 || 300 || 400 || 500 || 600 || 700 || 800 || 900
            "fontStyle": $ZCG.globalProp.fontL1Style, //normal || italic || oblique
            
            "title": {
                "show": true,
                "text": "Title comes here",
                "hAlign": "left",
                "vAlign": "top",
                "marginTop": 10,
                "marginRight": 0,
                "marginBottom": 0,
                "marginLeft": 10,
                "fontSize": userProp.fontL1Size.l1
            },
            "subtitle": {
                "show": true,
                "text": "Description comes here",
                "hAlign": "left",
                "vAlign": "top",
                "marginTop": 0,
                "marginRight": 0,
                "marginBottom": 0,
                "marginLeft": 10,
                "fontSize": userProp.fontL1Size.l2
            },
            "background": {
                "alpha": 1,
                "color": "#FFFFFF"
            },
            
            "border": {
                "show": true,
                "size": 1,
                "style": "solid",
                "radius": 1,
                "color": "#cccccc"
            },
            
            "shadow": {
                "show": true,
                "x": 1,
                "y": 1,
                "color": "rgba(0,0,0,0.1)",
                "blur": 2,
                "inset": false
            },
            "intelligence": {
                "dimension": {
                    "title": 100, // 0 or null -> don't remove
                    "subtitle": 120, // 0 or null -> don't remove
                    "xaxis": 70, // 0 or null -> don't remove
                    "xaxislabel": 80,
                    "yaxis": 70, // 0 or null -> don't remove
                    "yaxislabel": 80,
                    "legend": 140, // 0 or null -> don't remove
                    "credits": 150, // 0 or null -> don't remove
                    "marker": 50
                },
                "dataCount": {
                    "marker": 300, //null -> don't remove
                    "animation": 300, //null -> don't remove
                    "datalabels": 300 //null -> don't remove
                }
            }
        },
        "legend": {
            "enabled": true,
            "colorPallete": {
                "type": "multicolor", //muticolor || monochrome
                "options": {
                    "multicolor": "countries",
                    "monochrome": {
                        "baseColor": "red",
                        "count": 5,
                        "colorGamma": [0.3, 0.9]
                    }
                }
            },
            "hAlign": "right", //left, right, center
            "vAlign": "center", //top, center, bottom.
            "fontSize": userProp.fontL1Size.l5,
            "textPadding": 5,
            "itemMargin": 3,
            "marginTop": 10,
            "marginRight": 10,
            "marginBottom": 10,
            "marginLeft": 10,
            "colorBox": {
                "shape": "square", //square,circle,diamond,bean,butterfly,clover,cloverFour,cross,ellipse,heart,triangle-up,triangle-down,arrow,rocket,malteseCross,asterisk,gear
                "strokeWidth": 2
            },
            "colorBand": {

            },
            "title": {
                "show": false,
                "text": "Legend",
                "fontSize": userProp.fontL1Size.l4
            },
            "background": {
                "color": "transparent",
                "alpha": 0
            },
            "border": {
                "show": true,
                "size": 1,
                "style": "solid",
                "radius": 0,
                "color": "transparent"
            },
            "itemDisabledStyle": {
                //css properties except margin alignment and visibility properties
                "color": "#d1d1d1",
                "strikeout": false
            },
            "shadow": {
                "show": false,
                "color": "rgba(0,0,0,0.3)",
                "x": 2,
                "y": 2,
                "blur": 3,
                "inset": false
            },
            "filter": {
                "enabled": true
            },
            "highlightEffect": {
                "selectedSeries": null, //diagonalPattern,circlePattern,crossStripes,horizontalStripes,strokeEnlarge
                "unselectedSeries": "none" //fadeOut || blur || grayscale || saturate || none
            },
            "expandable": {
                "fontSize": userProp.fontL1Size.l5
            }
        },
        "chart": {
            "marginTop": 10,
            "marginRight": 10,
            "marginBottom": 10,
            "marginLeft": 10,
            "fontSize": userProp.fontL2Size.l3,
            "zoom":{
                "type":"none"
            },
            "effects": {
                "choice": "auto", //Choices: auto, dropShadow, chalk, freehand
                "options": {
                    "dropShadow": {
                        "dx": "5",
                        "dy": "5",
                        "blur": "3",
                        "color": "rgba(0,0,0,0.6)"
                    },
                    "freeHand": {
                        "scale": 7
                    }
                }
            },
            "plot": {
                "renderer": { // this option is under development
                    "mode": "svg",
                    "image": {
                        "source": "auto", // auto | <any url>
                        "addDimensionInSource": false, // paramas are plotWidth & plotHeight
                        "exportUrl": ""
                    }
                    
                },
                "background": {
                    "alpha": 1,
                    "color": "transparent",
                    "gradients": {
                        "show": false,
                        "type": "radial"
                    }
                },
                "border": {
                    "show": false,
                    "size": 1,
                    "style": "solid", //solid, shortdash, shortdot, shortdashdotdot, dotted, dashed, longdash, dashdot, longdashdot, longdashdotdot
                    "radius": 0,
                    "color": "#ececec"
                },
                "animation": {
                    "enabled": $ZCG.globalProp.animation.enabled,
                    "easingType": $ZCG.globalProp.animation.easingType,
                    "duration": $ZCG.globalProp.animation.duration
                },
                "datalabels": {
                    "show": $ZCG.globalProp.datalabels.enabled,
                    "handleOverlapping": true,
                    "fontSize": userProp.datalabels.fontSize.l5,
                    "boundBox": {
                        "strokeColor": $ZCG.fontColor,
                        "fillColor": "white"
                    }
                },
                "events": {
                    "cursor": null,
                    "click": $ZCG.globalProp.events.click, // On click on the plot, user function can be binded, el and event will be passed
                    "mousemove": $ZCG.globalProp.events.mouseMove, // on hovering the plot, user function can be binded, el and event will be passed
                    "mouseout": $ZCG.globalProp.events.mouseOut, //on mouseout the plot, user function can be binded, el and event will be passed
                    "doubleclick": $ZCG.globalProp.events.doubleClick, //on mouseout the plot, user function can be binded, el and event will be passed
                    "contextmenu": null, // right click event
                    "init": null,
                    "onload": null
                },
                "plotoptions": {}
            },
            "axes": {
                "xaxis": {
                    "show": true,
                    "label": {
                        "show": true,
                        "text": "Xaxis",
                        "fontSize": userProp.fontL2Size.l4,
                        "marginTop": 5,
                        "marginRight": 5,
                        "marginBottom": 5,
                        "marginLeft": 5
                    },
                    "grid": {
                        "show":true,
                        "color": "transparent",
                        "strokeWidth": null
                    },
                    "ticklabel": {
                        "rotation": 0, // auto,0,45,60,90
                        "textOverflow": "ellipsis", // none,ellipsis,hidden
                        "fontSize": userProp.fontL2Size.l5,
                        "zigzag":false
                    },
                    "tickmark": {
                        "strokeWidth": null,
                        "color": "#ececec",
                        "size": 3
                    },
                    "axisline": {
                        "show": true,
                        "color": "#ececec",
                        "strokeWidth": null,
                        "style": "solid"
                    },
                    "baseline": {
                        "show": false,
                        "value": 10,
                        "color": "black"
                    },
                    "threshold": {
                        "line": {
                            "show": false,
                            "values": [],
                            "label": {
                                "text": ["Description comes here"],
                                "fontSize": userProp.fontL2Size.l5
                            },
                            "marker": {
                                "enabled": true
                            }
                            
                        },
                        "coloroverlay": {
                            "show": false,
                            "values": [],
                            "overlayRange": "below"
                        },
                        "range": {
                            "show": false,
                            "values": [],
                            "label": {
                                "text": ["Description comes here"],
                                "fontSize": userProp.fontL2Size.l5
                            }
                        }
                        
                    }
                },
                "yaxis": [{
                    "show": true,
                    "label": {
                        "show": true,
                        "text": "Yaxis",
                        "fontSize": userProp.fontL2Size.l4,
                        "marginTop": 5,
                        "marginRight": 5,
                        "marginBottom": 5,
                        "marginLeft": 5
                    },
                    "grid": {
                        "show":true,
                        "color": "#ececec"
                    },
                    "ticklabel": {
                        "textOverflow": "ellipsis", // none,ellipsis,hidden
                        "fontSize": userProp.fontL2Size.l5,
                        "rotation": 0
                    },
                    "tickmark": {
                        "color": "#ececec",
                        "size": 3
                    },
                    "subtickmark": {
                        "color": "#ececec",
                        "size": 5,
                        "count": 0
                    },
                    "axisline": {
                        "show": true,
                        "color": "#ececec",
                        "strokeWidth": null,
                        "style": "solid"
                    },
                    "baseline": {
                        "show": false,
                        "value": 0,
                        "color": "grey",
                        "strokeWidth": null
                    },
                    "threshold": {
                        "line": {
                            "show": false,
                            "values": [],
                            "label": {
                                "text": ["Description comes here"],
                                "fontSize": userProp.fontL2Size.l5
                            },
                            "marker": {
                                "enabled": true
                            }
                            
                        },
                        "coloroverlay": {
                            "show": false,
                            "values": [],
                            "overlayRange": "below"
                        },
                        "range": {
                            "show": false,
                            "values": [],
                            "label": {
                                "text": ["Description comes here"],
                                "fontSize": userProp.fontL2Size.l5
                            }
                        }
                    }
                    
                }]
                
            }
            
        },
        "tooltip": {
            "enabled": true,
            "fontSize": userProp.fontL1Size.l5,
            "opacity": 0.8,
            "zindex": 2000,
            "view": "normal", //normal | column
            "crosshair": {
                "type": "none",
                "color": "grey"
            }
        },
        "noDataHandler": {
            "text": "No Data",
            "fontSize": userProp.fontL1Size.l1
        },
        "loader": {
            "type": "none", //zBlocks, zBars, zCircle1, zCircle2, zCrossBars, wheel, snake
            "fontSize": userProp.fontL1Size.l3
        }
    };
    return defaulttheme;
};

$ZC.getDefaultOptions = function(type, source, userProp) {
    var options;
    switch (type) {
        case 'zoom':
            options = {
                "type": "none", // none, x, y, xy
                "resetButton": {
                    "fillColor": "grey",
                    "label": {
                        "text": "Reset Zoom",
                        "marginTop": 5,
                        "marginRight": 5,
                        "marginBottom": 5,
                        "marginLeft": 5,
                        "fontSize": userProp.fontL2Size.l5
                    },
                    "border": {
                        "show": true,
                        "size": 1,
                        "radius": 6,
                        "color": "#cccccc"
                    },
                    "shadow": {
                        "show": false,
                        "dx": 1,
                        "dy": 1,
                        "color": "#cccccc",
                        "blur": 1
                    }
                },
                "selectionArea": {
                    "fillColor": "grey",
                    "fillOpacity": 0.4
                }
            };
            break;
        case 'scroll':
            //To implement NAVIGATOR later
            options = {
                "enabled": true,
                "categoryThickness": null,
                "visibleCategories": null,
                "height": 10,
                "slider": {
                    "fillOpacity": 0.3,
                    "strokeColor": "black"
                }
            };
            break;
        case "legend":
            options = {};
            break;
        
        case "credits":
            options = {
                "enabled": false,
                "imageWidth": 150,
                "imageHeight": 50,
                "hAlign": "right", //left, center, "right"
                "vAlign": "bottom", //top, middle, bottom
                "text": "Zoho Reports",
                "target": "newtab", //newtab || newwindow || null
                "marginTop": 0,
                "marginRight": 10,
                "marginBottom": 10,
                "marginLeft": 0,
                "fontSize": userProp.fontL1Size.l4
            };
            break;
        
        case "notes":
            options = {
                "enabled": false,
                "chartValues": [
                    //example
                    //                      {
                    //                        "text": "notesText",
                    //                        "x": 0,
                    //                        "y": "50%"
                    //                      }
                ],
                "plotValues": [
                    //single series bar example data
                    //                              {
                    //                                 "data": [2010,57],
                    //                                 "text": "High value"
                    //                             }
                    //multiseries area,stacked area,line,scatter example data
                    //                             {
                    //                                 "data": [1356978600000,6,"West"],
                    //                                 "text": "High value"
                    //                             }
                ],
                "blockValues": [
                    //  {
                    //    "htmlEl": "Annotate here",
                    //    "hAlign": "center",
                    //    "vAlign": "bottom",
                    //    "type" : "customNote"
                    // }
                ],
                "type": "stickyNote", //stickyNote || customNote
                "options": {
                    "stickyNote": {
                        "headWidth": 15,
                        "headHeight": 15,
                        "bodyWidth": 100,
                        "bodyHeight": 100,
                        "fontSize": userProp.fontL1Size.l5,
                        "color": ["#F0F8FF", "#FFE4C4", "#DCDCDC", "#ADFF2F", "#90EE90", "#87CEFA", "#FFC0CB", "#B0E0E6", "#D2B48C", "#D8BFD8", "#EE82EE", "#F5DEB3"],
                        "mode": "close", //open || close
                        "border": "1px solid grey"
                    },
                    "customNote": {
                        "fontSize": userProp.fontL1Size.l5
                    }
                }
            };
            break;
        
        case "bar":
            options = {
                "outerPadding": 0.04,
                "fillOpacity": 0.9,
                "maxBandWidth": 200,
                "multiColoring": false,
                "border": {
                    "show": false,
                    "size": null,
                    "style": "solid",
                    "radius": 0,
                    "color": null
                },
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "levelMarker": {
                    "enabled": false,
                    "color": ["#d8d8d8"],
                    "fillOpacity": 0.9
                },
                "datalabels": {
                    "showAs": "y", //x,y,percent
                    "stackLabels": {
                        "show": false,
                        "showAs": "y" //y,percent
                    }
                },
                "animation": {
                    "type": "verticalAll" //verticalAll || vertical
                },
                "gradients": { //linear || none
                    "options": {
                        "linear": {
                            "y2": 50
                        }
                    }
                }
            };
            break;
        
        case "line":
            options = {
                "mode": "linear", //linear,step-before,step-after,cardinal
                "strokeWidth": 2,
                "outerPadding": 0.02,
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "marker": {
                    "enabled": true,
                    "innerStrokeWidth": 2,
                    "outerFillColor": "transparent",
                    "outerStrokeColor": "transparent"
                },
                "hoveroptions": {
                    "innerStrokeWidth": 2,
                    "outerFillOpacity": 0.5,
                    "outerStrokeOpacity": 0.1
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "animation": {
                    "type": "strokeTween", //strokeTween,horiPathTween,vertPathTween,pointbypoint,pointTween
                    "marquee": {
                        "enabled": false,
                        "duration": 300
                    },
                    "blink": {
                        "enabled": false,
                        "type": "twinkle", //twinkle | fade
                        "duration": 400
                    }
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 10,
                            "spreadMethod": "reflect" // pad || repeat || reflect
                        }
                    }
                }
            };
            break;
        case "area":
            options = {
                "strokeOpacity": 0.5,
                "outerPadding": 0.02,
                "fillOpacity": 0.4,
                "mode": "linear", //linear,step-before,step-after,cardinal
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "marker": {
                    "enabled": false,
                    "outerFillColor": "transparent",
                    "outerStrokeOpacity": 0.5,
                    "size": 1 //1,2....
                },
                "hoveroptions": {
                    "innerStrokeWidth": 2,
                    "outerFillOpacity": 0.5,
                    "outerStrokeOpacity": 0.1
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 50
                        }
                    }
                },
                "animation": {
                    "type": "vertPathTweenAll", //horiPathTween || vertPathTween || vertPathTweenAll || pointTween
                    "marquee": {
                        "enabled": false,
                        "duration": 300
                    },
                    "blink": {
                        "enabled": false,
                        "type": "twinkle", //twinkle | fade
                        "duration": 400
                    }
                }
            };
            break;
        case "arearange":
            options = {
                "strokeOpacity": 0.5,
                "outerPadding": 0.02,
                "fillOpacity": 0.4,
                "mode": "linear", //linear,step-before,step-after,cardinal
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "marker": {
                    "enabled": false,
                    "outerFillColor": "transparent",
                    "outerStrokeOpacity": 0.5,
                    "size": 1 //1,2....
                },
                "hoveroptions": {
                    "innerStrokeWidth": 2,
                    "outerFillOpacity": 0.5,
                    "outerStrokeOpacity": 0.1
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 50
                        }
                    }
                },
                "animation": {
                    "type": "vertPathTweenAll", //horiPathTween || vertPathTween || vertPathTweenAll || pointTween
                    "marquee": {
                        "enabled": false,
                        "duration": 300
                    },
                    "blink": {
                        "enabled": false,
                        "type": "twinkle", //twinkle | fade
                        "duration": 400
                    }
                }
            };
            break;
        case "scatter":
            options = {
                "outerPadding": 0.02,
                "multiColoring": false,
                "marker": {
                    "size": 1,
                    "innerFillColor": "white",
                    "innerStrokeColor": "white",
                    "innerStrokeWidth": 0,
                    "innerStrokeOpacity": 1,
                    "outerFillColor": "white",
                    "outerStrokeOpacity": 1,
                    "outerStrokeWidth": 2
                },
                "hoveroptions": {
                    "innerStrokeOpacity": 1,
                    "outerFillColor": "white",
                    "outerStrokeWidth": 2
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "animation": {
                    "type": "allseries" //onebyone || seriesbyseries || allseries || fade || fadeAll
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "y2": 100,
                            "gradientUnits": "userSpaceOnUse", //objectBoundingBox || userSpaceOnUse
                            "colorGamma": [2, 0]
                        },
                        "radial": {
                            "radius": 90,
                            "colorGamma": [2, 0]
                        }
                    }
                }
            };
            break;
        case "bubblepie":
        case "pie":
            options = {
                "startAngle": 0,
                "endAngle": 2 * mathPI,
                "innerRadius": 0,
                "outerPadding": 10,
                "datalabels": {
                    "type": "circular", // circular || doubleside
                    "padding": 5,
                    "line": {
                        "strokeColor": "grey",
                        "strokeWidth": 0.3
                    },
                    "innerLabel": {
                        "show": false,
                        "showAs": "percent" //x,y,percent
                    }
                },
                "animation": {
                    "type": "fanAll" //inner, wheel, fanAll, fanonebyone , inneronebyone
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "x2": 15,
                            "spreadMethod": "repeat", // pad || repeat || reflect
                            "gradientUnits": "userSpaceOnUse" //objectBoundingBox || userSpaceOnUse
                        },
                        "radial": {
                            "radius": 90
                        }
                    }
                },
                "models": {
                    "count": 50
                }
            };
            if (type == "bubblepie") {
                options.strokeColor = "transparent";
                options.outerPadding = 0.02;
                options.datalabels.showAs = "percent"; //x,y,percent
                options.hoveroptions = {
                    "innerFillColor": "transparent",
                    "innerStrokeColor": "transparent",
                    "outerFillColor": "transparent",
                    "outerStrokeWidth": 3
                };
            } else {
                options.strokeColor = "white";
                options.sliceOutHeight = 5;
                options.maxRadius = 250;
                options.datalabels.showAs = "x"; //x,y,percent
            }
            break;
        
        case "funnel":
            options = {
                "weighted": "height", //height | width | none
                "split": false,
                "canOverlap": true,
                "threeDimension": true,
                "outerPadding": "2%",
                "stemHeight": "20%",
                "stemWidth": "20%",
                "coneWidth": "100%",
                "strokeColor": "transparent",
                "emptyFunnel": {
                    "show": false,
                    "color": "#FAFAFA"
                },
                "datalabels": {
                    "showAs": "x", //x,y,percent
                    "type": "strokeddoubleside", // singleside || doubleside || strokeddoubleside
                    "padding": 30,
                    "line": {
                        "strokeColor": "grey",
                        "strokeWidth": 0.3
                    },
                    "innerLabel": {
                        "show": false,
                        "showAs": "percent" //x,y,percent
                    }
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 50,
                            "spreadMethod": "reflect", // pad || repeat || reflect
                            "colorGamma": [0.6, 0]
                        }
                    }
                },
                "animation": {
                    "type": "vertical" //horizontalAll, verticalAll, vertical
                }
            };
            break;
        
        case "web":
            options = {
                "fillOpacity": 0.5,
                "strokeWidth": 2,
                "mode": "linear-closed", //linear-closed || cardinal-closed
                "outerPadding": 10,
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "marker": {
                    "enabled": true,
                    "innerStrokeOpacity": 1,
                    "outerFillColor": "white"
                },
                "hoveroptions": {
                    "innerStrokeWidth": 2,
                    "innerStrokeOpacity": 1,
                    "outerFillColor": "white"
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "animation": {
                    "type": "strokeTween", //strokeTween , pathTween , pointbypointTween , fade
                    "marquee": {
                        "enabled": false,
                        "duration": 300
                    },
                    "blink": {
                        "enabled": false,
                        "type": "twinkle", //twinkle | fade
                        "duration": 400
                    }
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "x2": 15,
                            "spreadMethod": "repeat", // pad || repeat || reflect
                            "gradientUnits": "userSpaceOnUse" //objectBoundingBox || userSpaceOnUse
                        },
                        "radial": {
                            "radius": 90,
                            "x": 0,
                            "y": 0
                        }
                    }
                }
            };
            break;
        
        case "pyramid":
            options = {
                "threeDimension": true,
                "strokeColor": "black",
                "strokeWidth": null,
                "strokeOpacity": 0.5,
                "fillOpacity": 0.8,
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "x2": 50,
                            "spreadMethod": "reflect", // pad || repeat || reflect
                            "colorGamma": [0.8, 0]
                        }
                    }
                },
                "datalabels": {
                    "showAs": "y", //x,y,percent
                    "type": "singleside", // singleside || doubleside || strokeddoubleside
                    "padding": 10,
                    "relativeX": true,
                    "line": {
                        "strokeColor": "grey",
                        "strokeWidth": 0.3
                    },
                    "innerLabel": {
                        "show": false,
                        "showAs": "percent" //x,y,percent
                    }
                },
                "animation": {
                    "type": "vertical" //vertical || verticalAll
                }
            };
            break;
        case "sunburst":
            options = {
                "strokeColor": "white",
                "innerRadius": 30,
                "outerPadding": 20,
                "animation": {
                    "type": "fan" //fan, inner, wheel
                },
                "datalabels": {
                    "showAs": "y", //x,y,percent
                    "type": "circular", // circular || doubleside
                    "padding": 10,
                    "line": {
                        "strokeColor": "grey",
                        "strokeWidth": 0.3
                    },
                    "innerLabel": {
                        "show": false,
                        "showAs": "percent", //x,y,percent
                        "parentLabel": {
                            "show": false
                        }
                    }
                }
            };
            break;
        
        case "dial":
            options = {
                "startAngle": -mathPI / 2,
                "endAngle": mathPI / 2,
                "innerRadius": "65%",
                "maxRadius": 500,
                "outerPadding": 20,
                "padding": 0,
                "strokeColor": "rgba(0,0,0,0.1)",
                "animation": {
                    "type": "fanAll" //fanAll
                },
                "needle": {
                    "show": true,
                    "type": "round", //clock || round || sharp
                    "strokeColor": "black",
                    "fillColor": "grey",
                    "width": 15,
                    "padding": 15
                },
                "minmaxlabels": {
                    "show": true,
                    "fontSize": userProp.datalabels.fontSize.l5
                },
                "datalabels": {
                    "show": true,
                    "showAs": "y", //x,y,percent
                    "padding": 2
                },
                "levelMarker": {
                    "enabled": true,
                    "strokeColor": "rgba(0,0,0,0.1)",
                    // "color" : ["#d1d1d1"],
                    "innerPadding": 0,
                    "outerPadding": 0,
                    "colorGamma": [0.3, 0.9]
                },
                "targetMarker": {
                    "outerStrokeWidth": 3,
                    "symbol": "line",
                    "innerFillOpacity": 0,
                    "innerStrokeOpacity": 0,
                    "outerFillColor": "grey",
                    "outerStrokeColor": "#000"
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "x2": 2,
                            "y2": 2,
                            "spreadMethod": "repeat", // pad || repeat || reflect
                            "gradientUnits": "userSpaceOnUse" //objectBoundingBox || userSpaceOnUse
                        },
                        "radial": {
                            "radius": 16.5,
                            "spreadMethod": "reflect" // pad || repeat || reflect
                        }
                    }
                },
                "events": {
                    "enabled": false
                }
            };
            break;
        case "bubble":
            options = {
                "outerPadding": 0.02,
                "multiColoring": false,
                "marker": {
                    "innerFillOpacity": 0,
                    "innerStrokeWidth": 0,
                    "innerStrokeOpacity": 0,
                    "outerFillOpacity": 0.4,
                    "outerStrokeOpacity": 1
                },
                "hoveroptions": {
                    "innerFillColor": "transparent",
                    "innerStrokeColor": "transparent",
                    "innerStrokeOpacity": 1,
                    "innerStrokeWidth": 0,
                    "outerFillOpacity": 0.3,
                    "outerStrokeOpacity": 0.5
                },
                "datalabels": {
                    "showAs": "y" //x,y,z,percent
                },
                "animation": {
                    "type": "sizing" //sizing || onebyone || seriesbyseries || allseries || fade || fadeAll || verticalAll
                },
                "gradients": { // radial || linear || none
                    "options": {
                        "linear": {
                            "y2": 100,
                            "gradientUnits": "userSpaceOnUse", //objectBoundingBox || userSpaceOnUse
                            "colorGamma": [1.5, 0]
                        },
                        "radial": {
                            "radius": 90,
                            "colorGamma": [1.5, 0]
                        }
                    }
                }
            };
            break;
        
        case "packedbubble":
            options = {
                "fillOpacity": 0.2,
                "outerPadding": 5,
                "animation": {
                    "type": "sizing" //sizing | fade | fadeAll
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                }
            };
            break;
        case "bullet":
            options = {
                "outerPadding": 0,
                "levelMarker": {
                    "enabled": true,
                    "dataindex": 2,
                    "color": [],
                    "colorGamma": [0.3, 0.9],
                    "fillOpacity": 0.9,
                    "maxBandWidth": 200
                },
                "targetMarker": {
                    "enabled": true,
                    "dataindex": 3,
                    "symbol": "line",
                    "innerFillColor": "transparent",
                    "innerStrokeColor": "transparent",
                    "innerStrokeWidth": 0,
                    "innerStrokeOpacity": 0,
                    "outerFillColor": "rgba(0, 0, 0, 0.6)",
                    "outerStrokeOpacity": 1,
                    "outerStrokeWidth": 5,
                    "outerStrokeColor": "rgba(0, 0, 0, 0.6)",
                    "label": {
                        "fontSize": userProp.datalabels.fontSize.l5
                    }
                },
                "animation": {
                    "type": "verticalAll"
                },
                "datalabels": {
                    "textOverlap": "none",
                    "showAs": "y", //x,y,percent
                    "stackLabels": {
                        "show": false,
                        "showAs": "y" //y,percent
                    }
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "y2": 50
                        }
                    }
                }
            };
            break;
        case "gantt":
            options = {
                "outerPadding": 0.04,
                "padding": 0,
                "interPadding": 0.05,
                "maxBandWidth": 200,
                "levelMarker": {
                    "enabled": false,
                    "dataindex": 2,
                    "fillOpacity": 0.3,
                    "bandWidth": 4
                },
                "hoveroptions": {
                    "enabled": false,
                    "start": {
                        "innerStrokeOpacity": 1,
                        "outerFillColor": "white",
                        "outerStrokeWidth": 2
                    },
                    "end": {
                        "innerStrokeOpacity": 1,
                        "outerFillColor": "white",
                        "outerStrokeWidth": 2
                    }
                },
                "marker": {
                    "enabled": false,
                    "start": {
                        "size": 1,
                        "innerStrokeWidth": 0,
                        "outerStrokeWidth": 2
                    },
                    "end": {
                        "size": 1,
                        "innerStrokeWidth": 0,
                        "outerStrokeWidth": 2
                    }
                },
                "border": {
                    "show": false,
                    "size": null,
                    "style": "solid",
                    "radius": 0,
                    "color": null
                },
                "stacked": {
                    "enabled": false,
                    "showAs": "values" //values,percent
                },
                "animation": {
                    "type": "verticalAll"
                },
                "datalabels": {
                    "showAs": "y" //x,y,percent
                },
                "gradients": { // linear || none
                    "options": {
                        "linear": {
                            "y2": 50
                        }
                    }
                },
                "dependency": {
                    "enabled": false,
                    "targetIndex": 0,
                    "link": {
                        "type": "ES",
                        "strokeWidth": 2,
                        "strokeColor": "#111111",
                        "errorStyle": "red",
                        "padding": 20
                    },
                    "marker": {
                        "enabled": true,
                        "padding": 10,
                        "size": 1.5,
                        "innerFillColor": "transparent",
                        "innerStrokeWidth": 0,
                        "innerStrokeOpacity": 0,
                        "outerStrokeOpacity": 0,
                        "outerStrokeColor": "red",
                        "outerFillColor": "blue"
                    }
                }
            };
            break;
        case "treemap":
            options = {
                "strokeColor": "rgba(255,255,255,0.7)",
                "animation": {
                },
                "datalabels": {
                    "showAs": "y"
                }
            };
            break;
        case "heatmap":
            options = {
                "strokeColor": "white",
                "animation": {
                },
                "datalabels": {
                    "showAs": "y"
                },
                "legendHighlightEffect": {
                    "selectedSeries": "tinyHatchfill"
                },
                "gradients": { //linear | radial | none
                    "options": {
                        "linear": {
                            "y2": 100
                        },
                        "radial": {
                            "radius": 100
                        }
                    }
                }
            };
            break;
        case "dotgrid":
            options = {
                "fillOpacity": 0.2,
                "outerPadding": 0.2,
                "animation": {
                    "type":"grid"
                },
                "datalabels": {
                    "showAs": "x" //x,y,percent
                }
            };
            break;
        case "metadata":
            options = {
                "axes": {
                    "x": [0],
                    "y": [
                        [1]
                    ],
                    "tooltip": [0, 1]
                },
                "columns": [{
                    "dataindex": 0,
                    "columnname": "",
                    "datatype": "numeric"
                }, {
                    "dataindex": 1,
                    "columnname": "",
                    "datatype": "numeric"
                }]
            };
            break;
        
    }
    return options;
};

$ZC.setDefaultOptions = function(type, source , userProp, options, dontFetchDefault){
    if(!dontFetchDefault){
        //or To fetch default options from above
        options = $ZC.getDefaultOptions(type,source,userProp);
    }
    var dest = (source[type] == null) ? source[type] = {} : source[type];
    mergeJSON(options, dest, true, true);
    source[type] = options;
    return options;
}//$Id$
/*
 Map properties and functions based on type of map. _GeoChart is intended to be used by internal javascript functions of GeoChart.
 */
$ZC._GeoChart = {};

$ZC._GeoChart._getMapObjectFactroy = function() {
    var _abstractMapObj = {
        //Properties to be implemented mandatory
        container: null,
        map: null,
        
        plotted_data: null,
        unknowndata_Key: null,
        basegeorole: null,
        //Super class functions with implementations
        getBounds: function() {
            var bound = L.latLngBounds(arguments);
            return {
                northEast: bound._northEast,
                southWest: bound._southWest
            }
        }
    };
    
    var _mapObjFactory = {};
    var leafletConstructor, svgmapConstructor, mapboxConstructor;
    
    //Lazy loading the singletons of mapobject constructors
    _mapObjFactory.leaflet = function() {
        if (!leafletConstructor) {
            leafletConstructor = $ZC._GeoChart.getLeaflet(_abstractMapObj);
        }
        return leafletConstructor;
    };
    _mapObjFactory.svgmap = function() {
        if (!svgmapConstructor) {
            svgmapConstructor = $ZC._GeoChart.getSVGMap(_abstractMapObj);
        }
        return svgmapConstructor;
    };
    
    _mapObjFactory.mapbox = function() {
        if (!mapboxConstructor) {
            mapboxConstructor = $ZC._GeoChart.getLeaflet(_abstractMapObj);
        }
        return mapboxConstructor;
    };
    return _mapObjFactory;
};//$Id$
/*
 GeoChart object contains function to create MapObject specific to the map lirary used. Should be exposed to the user of library.
 */
$ZC.GeoChart = {
    _mapObjFactory: $ZC._GeoChart._getMapObjectFactroy(),
    getMapObj: function(container, map) {
        if (!isUndefined(window.L) && map instanceof L.Map) {
            return new(this._mapObjFactory.leaflet())(container, map);
        } else if (!isUndefined(window.mapboxgl) && map instanceof mapboxgl.Map) {
            return new(this._mapObjFactory.mapbox())(container, map);
        } else {
            return new(this._mapObjFactory.svgmap())(container, map);
        }
    }
};//$Id$
$ZC._GeoChart.getLeaflet = function(_abstractMapObj) {
    var _update, _setupMapEvents, _createStaticPane, _createChartPane;
    var mapObj = function(container, map) {
        this.container = container;
        this.map = map;
        this.plotted_data = null;
        this.unknowndata_Key = null;
        this.basegeorole = null;
    };
    mapObj.prototype = Object.create(_abstractMapObj);
    
    mapObj.prototype.fitBounds = function() {
        var bound;
        var arg0 = arguments[0];
        if (arg0 == null) {
            return;
        }
        if (arg0 instanceof Array) {
            var points = arg0;
            if (points.length > 0) {
                bound = L.latLngBounds(points);
            } else {
                return;
            }
        } else {
            var southWest = arg0.southWest,
                northEast = arg0.northEast;
            bound = L.latLngBounds(L.latLng(southWest.lat, southWest.lng), L.latLng(northEast.lat, northEast.lng));
        }
        var prop = arguments[1];
        this.map.fitBounds(bound, prop);
    };
    mapObj.prototype.disable = function() {
        this.map.zoomControl.remove();
        this.map.scrollWheelZoom.disable()
        this.map.dragging.disable()
        this.map.touchZoom.disable()
        this.map.doubleClickZoom.disable()
        this.map.boxZoom.disable()
        this.map.keyboard.disable()
        if (this.map.tap) {
            this.map.tap.disable()
        }
    };
    
    return mapObj;
};//$Id$
getGeoDefaultOptions = function(type,source,userProp)
{
	var options;
	switch(type){
		case "geoscatter"://NO I18N
		case "geobubble"://NO I18N
		case "geobubblepie"://NO I18N
		case "geopie"://NO I18N
                         var genType = type.replace("geo","");//NO I18N
			 options = $ZC.getDefaultOptions(genType, source, userProp);
                         if (type == "geopie" || type == "geobubblepie") {//NO I18N
                            options.dataindex = 1;
                            options.startAngle = 0;
                            options.endAngle = 2 * Math.PI;
                            options.fillOpacity = 0.65;
                            options.datalabels.showAs = "y";//NO I18N
                            options.strokeColor = "rgba(0,0,0,0.4)";//NO I18N
                            options.strokeWidth = 1;
                            options.outerPadding = 0.02;
                            options.hoveroptions = {
                                "innerFillColor": "transparent",//NO I18N
                                "innerStrokeColor": "transparent",//NO I18N
                                "outerFillColor": "transparent",//NO I18N
                                "outerStrokeWidth": 3//NO I18N
                            };
                        } 
                        if(type == "geobubblepie" || type == "geobubble"){//NO I18N
                            options.minSize = "2.75%";//NO I18N
                            options.maxSize = "15%"//NO I18N
                        }
			 $ZC.setDefaultOptions(type, source, userProp,options,true);
                        break;
		case "geofilled"://NO I18N
                    options = {
                        "marker": {//NO I18N
                        },
                        "hoveroptions": {//NO I18N
                        },
                        "datalabels": {//NO I18N
                             "showAs": "y" //x,y,percent//NO I18N
                        },
                        "animation": {//NO I18N
                        },
                        "gradients": {//NO I18N
                        }
                    };
                    $ZC.setDefaultOptions(type, source, userProp,options,true);        
                break;
       	}
}//$Id$
function dataLabel(seriesGroups, chartObj, seriesDetails,markerType,columnIdx) {
    
        var dataLabelDetails = [];
        var dataset = chartObj.map_util.getDataset();
        var chartType = chartObj.chartTypes[0].value;
        
        var chartName = $ZC.DataProcessor.helpers.getChartType(chartType, "string");//NO I18N
        var dataLabelsOptions = chartObj.map_util.getPlotOptions(chartName).datalabels;
        var isExport = chartObj.userdata.geo.isExport;
        var showlabel = isDatalabelEnabled(dataLabelsOptions, chartObj);
        if(chartType != geopie && chartType !=geobubblepie )
        {
                seriesGroups.each(function(d, i) {
                    if(chartObj.seriesdata[i].disabled)
                    {
                      return;
                    }
                    var GLT = dataLabelTextContent(chartObj, null, dataLabelsOptions, "datalabels", 0, i), //0 should be replaced by yscale domain //NO I18N
                         markerOptions = chartObj.map_util.getMarkerOptions(chartName);                    
                    var markerRadius = (markerOptions.size * 5) + validateNullVal(markerOptions.padding, 3);
                    if(d.type != geofilled)
                    {
                    d3_select(this).selectAll('g')//NO I18N
                        .each(function(d, j) {
                            var currentGroup = d3_select(this);
                            var translation = d3_transform(currentGroup.attr("transform")).translate,//NO I18N
                                DY = /bubble/g.test(chartName) ? "0.3em" : null,//NO I18N
                                X = 0,
                                Y = /bubble/g.test(chartName) ? 0 : markerType && markerType !="default" ? markerRadius :  (-markerRadius);//No I18N
                            var textEle = appendEle(currentGroup, "text", showlabel ? [1] : []); // appendEle will create element
                            textEle
                                .text(GLT(seriesDetails[i][j]))
                                .attr({
                                    "text-anchor": "middle",//NO I18N
                                    "transform": "translate(" + X + "," + Y + ")",//NO I18N
                                    "dy": DY,//NO I18N
                                })
                                .style("display", null);//NO I18N
                                if(!isExport && (!$Browser.IE && !BROWSER.EDGE))
                                        textEle.attr("class","dataLabelMap");//NO I18N
                            applyDatalabelFonts(textEle, dataLabelsOptions, chartObj, chartObj.seriesColor[i]); // Applies style
                            var bb = bbox(textEle.node());
                            var obj = {
                                X:X,
                                Y:Y,
                                translation:translation,
                                seriesPos: i,
                                itemPos: j,
                                centre: translation,
                                x1: bb.x + translation[0],
                                y1: bb.y + translation[1],
                                x2: bb.x + bb.width + translation[0],
                                y2: bb.y + bb.height + translation[1]
                            };
                            dataLabelDetails.push(obj);
                        });
                    }
                    else
                    {
                        var currentGroup =  d3_select(this);
                        var textEle = appendEle(currentGroup, "text", showlabel ? Object.keys(seriesDetails[i]) : []); // appendEle will create element
                            textEle.each(function(j){  
                                    var xVal = dataset.getActualX(seriesDetails[i]);
                                    var textLocation = chartObj.mapObj.plotted_data[seriesDetails[i][j][0]].latLng;
                                    var currentPoint =  map.latLngToLayerPoint(textLocation);
                                        d3.select(this).text(GLT(seriesDetails[i][j]));
                                        d3.select(this).attr({
                                            "text-anchor": "middle",//NO I18N
                                            "x":currentPoint.x,//NO I18N
                                            "y":currentPoint.y,//NO I18N
                                            "dy": null,//NO I18N
                                        })
                                        .style("display", null);//NO I18N
                                        if(!isExport && (!$Browser.IE && !BROWSER.EDGE))
                                                    textEle.attr("class","dataLabelMap");//NO I18N
                                    var bb = bbox(d3.select(this).node());
                                    var obj = {
                                        seriesPos: i,
                                        itemPos: j,
                                        centre:currentPoint,
                                        x1: bb.x ,
                                        y1: bb.y ,
                                        x2: bb.x + bb.width,
                                        y2: bb.y + bb.height
                                    };
                                    dataLabelDetails.push(obj);
                                    });  
                          applyDatalabelFonts(textEle, dataLabelsOptions, chartObj, chartObj.seriesColor[i]); // Applies style
                        }

                });
                 // Overlapping handler--
                // For scatter
                var zScale = chartObj.map_util.getScale(),
                    dataset = chartObj.map_util.getDataset();
                for (var i = 0, length = dataLabelDetails.length; i < length; i++) {
                    var currentLabel = dataLabelDetails[i],
                        previousLabels = dataLabelDetails.slice(0, i),
                        hideLabel = false;
                        if(previousLabels.length)
                        {
                    for (var index = i - 1; index >= 0; index--) {
                        var prev = previousLabels[index];
                        var chartType = $ZC.DataProcessor.helpers.getChartType(chartObj.seriesdata[currentLabel.seriesPos].type, "numeric");
                        var overlap = !seriesDetails[prev.seriesPos][prev.itemPos].hidden && doOverlap(prev, currentLabel);

                        hideLabel = hideLabel || overlap;
                    }
                        }
                    if (chartType === geobubble) { //Bubble chart - The datalabel should be within radius
                        var centre = currentLabel.centre;
                        var leftTopDist = mathSQRT(mathPow((centre[0] - currentLabel.x1), 2) + mathPow((centre[1] - currentLabel.y1), 2)),
                            rightBottomDist = mathSQRT(mathPow((centre[0] - currentLabel.x2), 2) + mathPow((centre[1] - currentLabel.y2), 2)),
                            radius = zScale(dataset.getZ(seriesDetails[currentLabel.seriesPos][currentLabel.itemPos])) / 2;
                        hideLabel = hideLabel || ((leftTopDist > radius) || (rightBottomDist > radius));
                    }

                    seriesDetails[currentLabel.seriesPos][currentLabel.itemPos].hidden = hideLabel;
                }
                // --Overlapping handler
                seriesGroups.each(function(d, i) {
                    if(d.type != geofilled)
                    {
                        d3_select(this).selectAll('g').each(function(d, j) {//NO I18N
                            var currentPoint = seriesDetails[i][j];
                            d3_select(this).selectAll('text').style("display", currentPoint.hidden ? "none" : null);//NO I18N
                        });
                    }
                    else
                    {
                        d3_select(this).selectAll('text').each(function(d, j) {//NO I18N
                        var currentPoint = seriesDetails[i][j];
                            d3.select(this).style("display", currentPoint ? (currentPoint.hidden ? "none" : null) : null);//NO I18N
                    });
                    }
                });
                
            }
            else
            {
                var piegroups = chartObj.map_util.getSVG().selectAll("g.scatter");//NO I18N
                var scale = chartObj.map_util.getScale();
                var GLT = dataLabelTextContent(chartObj, null, dataLabelsOptions, "datalabels", 0, 0); //0 should be replaced by yscale domain //NO I18N
                if(typeof columnIdx)
                {
                    if(columnIdx)
                    {
                            piegroups.each(function(d, i){
                                var labelGroup = appendEle(d3_select(this), "g", [1], "." , "class", "labelgroup");//NO I18N
                                var xVal = chartObj.dataset.getActualX(seriesDetails[i][0]);
                                var radius = chartObj.chartTypes[0].value == $ZC.charttype.geopie ? 15 : scale(chartObj.mapObj.plotted_data[xVal].size) / 2 ;
                                var markerRadius = radius + 10;

                                var translation = d3_transform(d3_select(this).attr("transform")).translate,//NO I18N
                                    X = 0,
                                    Y = markerRadius ; 

                                var textEle = appendEle(labelGroup, "text", showlabel ? [1] : []);

                                textEle
                                        .text(GLT(seriesDetails[i][0]))
                                        .attr({
                                            "text-anchor": "middle",//NO I18N
                                            "transform": "translate(" + X + "," + Y + ")",//NO I18N
                                        })
                                        .style("display", null);//NO I18N
                                       if(!isExport && (!$Browser.IE && !BROWSER.EDGE))
                                                    textEle.attr("class","dataLabelMap");//NO I18N
                                    applyDatalabelFonts(textEle, dataLabelsOptions, chartObj, chartObj.seriesColor[i]); // Applies style

                                    var bb = bbox(textEle.node());
                                    var obj = {
                                        itemPos: i,
                                        centre: translation,
                                        x1: bb.x + translation[0],
                                        y1: bb.y + translation[1],
                                        x2: bb.x + bb.width + translation[0],
                                        y2: bb.y + bb.height + translation[1]
                                    };

                                    dataLabelDetails.push(obj);

                        });
//                         // Overlapping handler--
                        var  dataset = chartObj.map_util.getDataset();
                        for (var i = 1, length = dataLabelDetails.length; i < length; i++) {
                            var currentLabel = dataLabelDetails[i],
                                previousLabels = dataLabelDetails.slice(0, i),
                                hideLabel = false;
                            for (var index = i - 1; index >= 0; index--) {
                                var prev = previousLabels[index];
                                var overlap = !seriesDetails[prev.itemPos].hidden && doOverlap(prev, currentLabel);

                                hideLabel = hideLabel || overlap;
                            }
                            seriesDetails[currentLabel.itemPos].hidden = hideLabel;
                        }
                        // --Overlapping handler
                        piegroups.each(function(d, i) {    
                            {
                                    d3_select(this).selectAll('text').each(function(d, j) {//NO I18N
                                    var currentPoint = seriesDetails[i];
                                        d3.select(this).style("display", currentPoint ? (currentPoint.hidden ? "none" : null) : null);//NO I18N
                                });
                            }
                        });
                        
                    }
                    else
                    {
                        piegroups.each(function(d, i){
                            var pieLabelDetails = [];
                            var currentGroup = d3_select(this);
                            var labelGroup = appendEle(currentGroup, "g", [1], "." , "class", "labelgroup");//NO I18N
                            chartObj.piedata[0][i].forEach(function(d, j)
//                            for(var j = 0 ;j < chartObj.piedata[0][i].length ;j++ )//chartObj.piedata[0][i].forEach(function(d, j)
                            {
                                    if(!d.disabled)
                                    {
                                        var textAnchor = "middle";//NO I18N

                                        var data = chartObj.renderedPiedata[chartObj.dataset.getActualX(d)][j];
                                        
                                        if(data.value == 0)
                                            return;
                                        
                                        var midAngle = (data.startAngle + data.endAngle)/2 ;
                                        
                                        var radius = chartObj.chartTypes[0].value == geopie ? chartObj.mapObj.plotted_data[chartObj.dataset.getActualX(d)].size/2 : scale(chartObj.mapObj.plotted_data[chartObj.dataset.getActualX(d)].size)/2 ;
                                        
                                        var midPointInSector = polarToXY(radius,midAngle);
                                        
                                        var dy = (midAngle > mathPI / 2 && midAngle < 3 * mathPI / 2) ? getDY(midAngle) + "em" : "0";//NO I18N
                                        
                                        textAnchor =  (midAngle < 0 || midAngle > mathPI) ? "end" : "start";//NO I18N

                                        var translation = d3_transform(currentGroup.attr("transform")).translate,//NO I18N
                                            X = midPointInSector[0],
                                            Y = midPointInSector[1]; 
                                        var textEle = appendEle(labelGroup, "text", showlabel ? [1] : [],"#","id","label_"+j);//NO I18N

                                        textEle
                                                .text(GLT(d))
                                                .attr({
                                                    "text-anchor": textAnchor,//NO I18N
                                                    "x":X, //NO I18N
                                                    "y":Y,//NO I18N
                                                    "dy":dy,//NO I18N
                                                })
                                                .style("display", null);//NO I18N
                                                if(!isExport && (!$Browser.IE && !BROWSER.EDGE))
                                                    textEle.attr("class","dataLabelMap");//NO I18N
                                            applyDatalabelFonts(textEle, dataLabelsOptions, chartObj, chartObj.seriesColor[i]); // Applies style

                                            var bb = bbox(textEle.node());
                                            var obj = {
                                                height:bb.height,
                                                x1: bb.x + translation[0],
                                                y1: bb.y + translation[1],
                                                x2: bb.x + bb.width + translation[0],
                                                y2: bb.y + bb.height + translation[1],
                                                h1:bb.y,
                                                h2:bb.y + bb.height,
                                                itemPos: i,
                                                sectorPos:j,
                                            };
                                            pieLabelDetails.push(obj);
                                    }
                                    
                            });
                            dataLabelDetails.push(pieLabelDetails);
                        });
                            function doSecOverlap(rect1, rect2) {
                                if(rect1 && rect2)
                                    return !((rect1.x1 >= rect2.x2) || (rect2.x1 >= rect1.x2) || (rect1.y1 > rect2.y2) || (rect2.y1 > rect1.y2) || ((rect1.y2 - rect2.y1) < (rect1.height / 3)));
                            }
                            
                            function doEnableDataLabel(overlap,i,dataLabelDetails)
                                {
                                var hideLabel = false;
                                if((!overlap && i))
                                {
                                    var prevPieLabels = dataLabelDetails.slice(0, i);
                                    for(var k = 0 ;k < prevPieLabels.length ; k++)
                                    {
                                        var prevLabel = prevPieLabels.slice(k,k+1);
                                        for(var l = 0; l <  prevLabel[0].length ; l++)
                                        {
                                            hideLabel = !seriesDetails[prevLabel[0][l].itemPos][prevLabel[0][l].sectorPos].hidden &&  doSecOverlap(prevLabel[0][l], currentLabel);
                                            if(hideLabel)
                                            {
                                                 break;
                                            }
                                        }
                                        if(hideLabel)
                                        {
                                            seriesDetails[currentLabel.itemPos][currentLabel.sectorPos].hidden =  hideLabel;
                                            break;
                                        }
                                    }

                                }
                                
                            }
                            var  dataset = chartObj.map_util.getDataset();
                            
                            for (var i = 0, length = dataLabelDetails.length; i < length; i++) {
                                
                                for(var j = 0 ; j < dataLabelDetails[i].length ; j++)
                                {
                                    if((j-1+i) >=0)
                                    {
                                        var currentLabel = dataLabelDetails[i][j],
                                        previousLabels = dataLabelDetails[i].slice(0, j),
                                        hideLabel = false;
                                        for (var index = j-1 ;  index >= 0 ; index--) { 
                                            var prev = previousLabels[index];
                                            var overlap = doSecOverlap(prev, currentLabel);
                                            if(overlap)
                                            {
                                                if(!seriesDetails[prev.itemPos][prev.sectorPos].hidden)
                                                {
                                                      hideLabel = overlap;
                                                      break;
                                                }
                                                else
                                                    continue;
                                            }
                                            else
                                            {
                                                hideLabel = overlap;
                                                 break;
                                            }

                                          }
                                        seriesDetails[currentLabel.itemPos][currentLabel.sectorPos].hidden =  hideLabel;
                                        // checking overlapping for other pie labels 
                                        doEnableDataLabel(overlap,i,dataLabelDetails);
                                    }
                                  }
                            }
                            // --Overlapping handler
                            piegroups.each(function(d, i) {   
                                for(var j = 0 ; j < d3_select(this).selectAll('text')[0].length; j++)
                                {
//                                        d3_select(this).selectAll('text').each(function(d, j) {//NO I18N
                                    var labelIdx = Number(d3_select(this).selectAll('text')[0][j].id.slice(6));
                                    var currentPoint = seriesDetails[i][labelIdx];
                                    d3_select(d3_select(this).selectAll('text')[0][j]).style("display", currentPoint ? (currentPoint.hidden || currentPoint.disabled ? "none" : null) : null);//NO I18N
//                                    });
                                }
                            });
                        
                     }
                    
                }
                
            }
       
    };
function addCustomMarker(parentElement,options,markerType,mouseEvent)
{ 
    var type = markerType;
    var transform =  getTransform(type);
    var translate = "translate(" + transform.tx + "," + transform.ty + ")";  //NO I18N     
    drawShadowPath(parentElement,translate,options,type);
    drawOuterPath(parentElement,translate,options,type,mouseEvent);
        drawInnerPath(parentElement,translate,options,type,mouseEvent);
    
    }
function drawShadowPath(parentElement,translate,options,type){
 var shadowPath = appendEle(parentElement,"path",[1],".","class","shadowPath");//NO I18N
                    
    shadowPath
            .attr({
                    "d" : getShadowPath(type),//NO I18N
                    "transform" : translate,//NO I18N
                    "opacity":type == "Type5" ? 0.1 : 0.3,//NO I18N
            })
            .style({
                    "fill" : "url(#SVGUrl)",//NO I18N
            })   
}
function drawOuterPath(parentElement,translate,options,type,mouseEvent)
{
    var outerPath = appendEle(parentElement, "path", [1], ".", "class", "outer");//NO I18N
    var clr = getColor(options.color,"darker");//NO I18N
    outerPath
            .attr({
                    "d":getOuterPath(type),//NO I18N
                    "transform":translate//NO I18N
             })
            .style({
                    "fill":mouseEvent ? "#FFFFFF" : options.color,//NO I18N
                    "stroke": mouseEvent ? options.color : getColor(clr,"darker"),//NO I18N
                    "stroke-width":mouseEvent? 2 : 1 //NO I18N
           });
}
function drawInnerPath(parentElement,translate,options,type,mouseEvent)
{
    var innerPath = appendEle(parentElement, "path", [1], ".", "class", "inner");//NO I18N
    var clr = getColor(options.color,"darker");//NO I18N
    innerPath
            .attr({
                    "d":getInnerPath(type),//NO I18N
                    "transform":translate//NO I18N
            })
            .style({
                     "fill":mouseEvent ?  options.color : "#FFFFFF",  //NO I18N
                                "stroke":getColor(clr,"darker")//NO I18N
                        });
            }
function getOuterPath(markerType)
{
	switch(markerType)
	{
                case "Type1"://No I18N
		{
			return "M17.5,3.7c-3.9-3.9-10.2-3.9-14,0s-3.9,10.2,0,14.1c0,0,7,6.9,7,14.8c0-8,7-14.8,7-14.8   C21.4,13.9,21.4,7.6,17.5,3.7L17.5,3.7z";//NO I18N
		}
		break;
		case "Type2"://NO I18N
		{
			return "M11.7,0.7C6,0.9,1.3,5.3,0.8,11c-0.1,1.1,0,2.2,0.2,3.3c0,0,0,0.1,0.1,0.4c0.2,0.8,0.4,1.6,0.8,2.3   c1.1,2.7,3.8,7.3,9.8,12.2c0.4,0.3,0.9,0.3,1.3,0c6-4.9,8.6-9.5,9.8-12.2c0.3-0.7,0.6-1.5,0.8-2.3c0.1-0.2,0.1-0.4,0.1-0.4   c0.1-0.7,0.2-1.4,0.2-2.2C23.6,5.7,18.3,0.5,11.7,0.7L11.7,0.7z"; //NO I18N
		}
		break;
		case "Type3"://NO I18N
		{
			return "M25.4,12.9C25.4,6,19.8,0.5,13,0.5S0.5,6,0.5,12.9c0,5.7,3.9,10.5,9.1,12l3.3,8.7l3.3-8.7C21.5,23.5,25.4,18.6,25.4,12.9z"; //NO I18N
		}
		break;
                case "Type4"://NO I18N
		{
			return "M17.28,9.038   c0-4.576-3.722-8.298-8.298-8.298c-4.576,0-8.298,3.722-8.298,8.298c0,4.39,3.428,7.982,7.744,8.271v15.764   c0,0.308,0.249,0.554,0.554,0.554c0.305,0,0.554-0.245,0.554-0.554V17.309C13.852,17.02,17.28,13.428,17.28,9.038L17.28,9.038z";//NO I18N
		}
		break;
		case "Type5"://NO I18N
		{
			return "M21.603,15.618l-4.623-3.533   l4.623-3.532c0.264-0.298,0.328-0.723,0.164-1.087c-0.163-0.363-0.524-0.597-0.923-0.597h-6.011V2.563   c0-0.559-0.453-1.012-1.013-1.012H2.097c0,0,0.104-0.788-0.692-0.788c-0.737,0-0.68,0.788-0.68,0.788V31.81l0.709,1.751   l0.679-1.751V13.672h6.997v2.617c0,0.559,0.453,1.012,1.013,1.012h10.722c0.398,0,0.759-0.233,0.923-0.597   C21.932,16.342,21.867,15.916,21.603,15.618L21.603,15.618z M21.603,15.618"; //NO I18N
		}
                break;
	}
}

function getInnerPath(markerType)
{
	switch(markerType)
	{
                case "Type1"://No I18N
		{
			return "M10.5,14.7c-2.2,0-4-1.8-4-4c0-2.2,1.8-4,4-4c2.2,0,4,1.8,4,4C14.5,12.9,12.7,14.7,10.5,14.7L10.5,14.7z";//NO I18N
		}
		break;
		case "Type2"://NO I18N
		{
			return "M12.2,17.3L12.2,17.3c-3.1,0-5.6-2.5-5.6-5.6c0-3.1,2.5-5.6,5.6-5.6c3.1,0,5.6,2.5,5.6,5.6   C17.7,14.8,15.2,17.3,12.2,17.3";//NO I18N
		}
		break;
		case "Type3"://NO I18N
		{
			return "M13,7.3c3.1,0,5.6,2.5,5.6,5.6s-2.5,5.6-5.6,5.6S7.4,16,7.4,12.9S9.9,7.3,13,7.3";//NO I18N
		}
		break;
                case "Type4"://NO I18N
		{
			return "M11.886,8.245c-1.221,0-2.212-0.992-2.212-2.212   c0-1.221,0.991-2.212,2.212-2.212c1.221,0,2.212,0.991,2.212,2.212C14.098,7.254,13.107,8.245,11.886,8.245L11.886,8.245z";//NO I18N
		}
		break;
		case "Type5"://NO I18N
		{
			return "";
		}
                break;
	}
}

function getShadowPath(markerType)
{
	switch(markerType)
	{
                case "Type1"://No I18N
		{
			return "M36,17.4c0-5.5-4.4-9.9-9.9-9.9s-9.9,4.5-9.9,9.9c0,0,0.1,9.8-5.5,15.5c4.1-4.1,16.7-5.5,15.5-5.5    C31.6,27.4,36,22.9,36,17.4L36,17.4z";//NO I18N
		}
		break;
		case "Type2"://NO I18N
		{
			return "M27.8,5.5c-4.8-3-11.3-2-14.9,2.4c-0.7,0.9-1.3,1.8-1.7,2.8c0,0-0.1,0.1-0.1,0.3c-0.3,0.8-0.5,1.5-0.6,2.3    c-0.6,2.9-0.9,8.2,1.3,15.6c0.1,0.5,0.6,0.8,1.1,0.7c7.7-0.8,12.4-3.1,14.9-4.7c0.7-0.4,1.3-0.9,1.9-1.5c0.2-0.2,0.3-0.3,0.3-0.3    c0.5-0.5,1-1.1,1.4-1.7C34.9,16.2,33.4,8.9,27.8,5.5L27.8,5.5z"; //NO I18N
		}
		break;
		case "Type3"://NO I18N
		{
			return "M34.8,25.2c4.3-5.4,3.4-13.2-1.9-17.5s-13.2-3.4-17.5,2c-3.6,4.5-3.6,10.6-0.4,15.1l-1.9,9.3l7.1-5.2C25.2,31,31.2,29.7,34.8,25.2z";//NO I18N
		}
		break;
                case "Type4"://NO I18N
		{
			return "M31.1,20.4c2.9-3.5,2.5-8.8-1-11.7s-8.8-2.5-11.7,1C15.5,13.1,15.8,18,19,21L8.8,33.1   c-0.2,0.2-0.2,0.6,0.1,0.8c0.2,0.2,0.6,0.2,0.8-0.1l10.1-12.1C23.3,24.3,28.2,23.7,31.1,20.4L31.1,20.4z";//NO I18N
		}
		break;
		case "Type5"://NO I18N
		{
			return "M28.4,33.5l-1.3-5.7l5.8,0.2c0.4,0,0.7-0.3,0.8-0.8c0.1-0.3,0-0.8-0.3-1.1l-4.6-3.8l2.8-3.3  c0.4-0.4,0.3-1-0.1-1.4l-8.9-7.5c0,0,0.6-0.5,0-1c-0.6-0.5-1,0.2-1,0.2L2,32.4l-0.6,1.8L3,33.3l11.7-13.8l5.3,4.6l-1.7,2  c-0.4,0.4-0.3,1,0.1,1.4l8.2,6.9c0.3,0.2,0.7,0.3,1.1,0.1C28.2,34.3,28.4,33.9,28.4,33.5L28.4,33.5z";//NO I18N
		}
                break;
	}
} 
function getHighlightPath(markerType)
{
	switch(markerType)
	{
                case "Type1"://No I18N
		{
			return "M15,2.1c3.5,0,6.7,1.4,9.2,3.8c2.5,2.5,3.8,5.7,3.8,9.2s-1.4,6.7-3.8,9.2C24,24.3,15.8,32,15,47.1c-0.9-15.3-9-22.8-9.1-22.9c-5-5-5-13.2,0-18.3C8.3,3.5,11.5,2.1,15,2.1 M15,0.1c-4,0-7.8,1.6-10.5,4.4c-5.7,5.9-5.7,15.4,0.1,21.1c0,0,0,0,0,0c0.3,0.3,7.7,7.4,8.5,21.5c0.1,1.1,0.9,1.9,2,1.9c0,0,0,0,0,0c1.1,0,1.9-0.8,2-1.9c0.8-13.9,8.2-21.2,8.5-21.5c2.9-2.9,4.4-6.6,4.4-10.6c0-4-1.6-7.8-4.4-10.6C22.7,1.7,19,0.1,15,0.1L15,0.1z";//NO I18N
		}
		break;
		case "Type2"://NO I18N
		{
			return "M16.6,2.2c7.9,0,14.5,6.3,14.8,14.3l0,0.1c0,1-0.1,1.8-0.2,2.5c0,0.3-0.1,0.6-0.2,1c-0.2,0.8-0.5,1.6-0.9,2.5C27.9,27.5,24.3,32,19.4,36l-0.1,0.1c-0.7,0.5-1.6,0.8-2.4,0.8c-0.9,0-1.7-0.3-2.4-0.8L14.3,36C7.6,30.6,4.8,25.5,3.7,22.8c-0.5-1-0.8-2-1-2.8c-0.1-0.3-0.1-0.5-0.2-0.8c-0.3-1.5-0.3-2.8-0.2-4c0.6-7.2,6.6-12.8,13.8-13C16.3,2.2,16.4,2.2,16.6,2.2M16.6,0.2c-0.2,0-0.3,0-0.5,0C7.8,0.5,1,6.9,0.3,15.1c-0.1,1.4,0,2.9,0.2,4.5c0,0.3,0.1,0.7,0.2,1c0.2,1,0.5,2,1.1,3.1c1.2,2.8,4.2,8.2,11.2,13.9l0.1,0.1c1.1,0.8,2.4,1.3,3.7,1.3c1.3,0,2.6-0.4,3.6-1.2l0.1-0.1c5.2-4.2,9-9,11.3-14.1c0.4-1,0.7-1.9,1-2.7c0.2-0.5,0.3-0.9,0.3-1.4c0.1-0.7,0.2-1.6,0.2-2.7l0-0.2c0,0,0,0,0-0.1C33,7.3,25.6,0.2,16.6,0.2L16.6,0.2z"; //NO I18N
		}
		break;
		case "Type3"://NO I18N
		{
			return "M17.7,2.2c8.5,0,15.4,6.9,15.4,15.4c0,6.5-4,12.2-9.9,14.4l-5.6,14.7L12,32c-5.8-2.3-9.8-8-9.8-14.4C2.2,9.1,9.2,2.2,17.7,2.2 M17.7,0.2C8.1,0.2,0.2,8,0.2,17.6c0,6.8,4.1,13,10.2,15.9l5.3,14c0.3,0.8,1,1.3,1.9,1.3c0,0,0,0,0,0=c0.8,0,1.6-0.5,1.9-1.3l5.3-13.9c6.2-2.8,10.3-9,10.3-15.9C35.1,8,27.3,0.2,17.7,0.2L17.7,0.2z";//NO I18N
		}
		break;
                case "Type4"://NO I18N
		{
			return "M13.5,2.2c6.2,0,11.3,5.1,11.3,11.3c0,4.9-3.2,9.2-7.7,10.7v13.4c0,2.1-1.5,3.6-3.6,3.6c-2,0-3.6-1.6-3.6-3.6V24.2c-4.5-1.5-7.7-5.8-7.7-10.7C2.2,7.3,7.3,2.2,13.5,2.2 M13.5,0.2c-7.3,0-13.3,6-13.3,13.3c0,5.2,3,9.9,7.7,12.1v12c0,3.1,2.5,5.6,5.6,5.6s5.6-2.5,5.6-5.6v-12c4.7-2.2,7.7-6.9,7.7-12.1C26.8,6.2,20.8,0.2,13.5,0.2L13.5,0.2z";//NO I18N
		}
		break;
		case "Type5"://NO I18N
		{
			return "M5.8,2.1c0.9,0,1.7,0.3,2.3,0.8h10.1c2.2,0,4,1.8,4,4v1.3h3c1.6,0,3,0.9,3.7,2.4c0.6,1.4,0.4,3.1-0.7,4.3L28,15.1l-1.7,1.3l1.7,1.3l0.2,0.2c1.1,1.2,1.3,2.9,0.7,4.3c-0.6,1.4-2.1,2.4-3.7,2.4H14.5c-2.1,0-3.8-1.6-4-3.6h-1v15.7L5.9,46l-3.8-9.3V5.9c0-0.5,0.1-1.7,1-2.7C3.8,2.5,4.7,2.1,5.8,2.1 M5.8,0.1c-1.6,0-3.1,0.6-4.2,1.8C0.2,3.4,0.1,5.2,0.1,5.9v30.8c0,0.3,0,0.5,0.1,0.8L4,46.7c0.3,0.8,1,1.2,1.9,1.2c0,0,0,0,0,0c0.8,0,1.6-0.5,1.8-1.3l3.6-9.3c0.1-0.2,0.1-0.5,0.1-0.7V25.8c0.9,0.5,1.9,0.8,3,0.8h10.7c2.4,0,4.5-1.4,5.5-3.5c1-2.2,0.6-4.7-1-6.5l-0.2-0.2c0,0,0,0,0,0l0.2-0.2c1.6-1.8,2-4.3,1-6.5c-1-2.2-3.1-3.5-5.5-3.5h-1.1c-0.3-3-2.9-5.3-6-5.3H8.7C7.8,0.3,6.8,0.1,5.8,0.1L5.8,0.1z";//NO I18N
		}
                break;
	}
} 
function getTransform(markerType)
{
    var translate = {};
	switch(markerType)
	{
                case "Type1"://No I18N
		{
                        translate.tx = -10.7;
                        translate.ty = -31.77;
		}
                break;
		case "Type2"://NO I18N
		{
                       translate.tx = -12.5;
                       translate.ty = -28.77;
		}
		break;
		case "Type3"://NO I18N
		{
                        translate.tx = -13;
                        translate.ty = -33.5;
		}
		break;
		case "Type4"://NO I18N
		{
			translate.tx = -9;
                        translate.ty = -33;
		}
		break;
		case "Type5"://NO I18N
		{
                        translate.tx = -1.7;
                        translate.ty = -33.5;
		}
		break;
		
		}
        return translate;
}
function getColor(color,copyType)
{
    if(color.indexOf("rgba") >= 0)
    {
        color = rgb2hex(color);
    }
    return getColorCopy(color,1,copyType);
}
function patternFill(color,canvas)
{
        var prop=$ZC.getPattern("tinyHatchfill");//NO I18N
        var patternId;
        prop.bgClr_base = color;
        prop.strokeWidth = "1";   
        prop.stroke_base = "white"; //NO I18N
        if(canvas)
        {
            patternId = effects.get(canvas_patterns,"canvasPatternFill",prop);
        var ctx = canvas.getContext('2d');   //NO I18N
            return ctx.fillStyle = patternId;
}
        else
        {
            patternId = effects.get(svg_patterns,"svgPatternFill",prop);
            var patternURL = "url(" + "#" + patternId + ")";//NO I18N
            return patternURL;
        }
        
}//$Id$
var geoscatter = $ZC.charttype.geoscatter = 23,
    geobubble = $ZC.charttype.geobubble = 22,
    geofilled =  $ZC.charttype.geofilled = 25,
    geopie = $ZC.charttype.geopie = 26,
    geobubblepie = $ZC.charttype.geobubblepie = 27;

$ZC.charttypenames.set($ZC.charttype.geoscatter, "geoscatter");//NO I18N
$ZC.charttypenames.set($ZC.charttype.geobubble, "geobubble");//NO I18N
$ZC.charttypenames.set($ZC.charttype.geofilled, "geofilled");//NO I18N
$ZC.charttypenames.set($ZC.charttype.geopie, "geopie");//NO I18N
$ZC.charttypenames.set($ZC.charttype.geobubblepie, "geobubblepie");//NO I18N
    
$ZC.chartcategory.dotPlot.push(geoscatter,geobubble);

$ZC.chartcategory.piePlot.push(geopie, geobubblepie);

$ZC.mapcharts = function(container,data) {
    
    var chartObj = getMapChartObject(container, data);
        if (chartObj) {
            chartObj.draw();
        }
        return chartObj;
    
};

function getMapChartObject(container, data) {
    if (!document.body.contains(container)) {
        Console.warn("No container");//NO I18N
        return null;
    }
    var dataObj = d3_select(container)
        .datum(data);
    var chart = null;
    
    /*
     * Each chart instance is instantiated with chartRendered flag false
     * chart.initialize is defined in chart-constructor.js
     * */
    dataObj.each(function(data) {
        var chartHolder = d3_select(this);
        chart = new $ZC.mapcharts.get(chartHolder, data); // get chartobj
        chart.initialize(chartHolder, data);
        chart.showLoading(chartHolder);
    });
    return chart;
}

$ZC.mapcharts.get = function(container,data) {
    
    //Override certain functionalities of default chart object. To fix things with mapchart.
    var chart = $ZC.charts.get(container, data);
    var systemconf;
    var map_util = {};
    var map_renderer_util = {};
    var map_series_renderer = {};
    var map_ui_util = {};
    var eventsObject;
    //$Id$
map_ui_util.legend = function(chart) {
        
        var showLegendByDefault = chart.userdata.geo.showLegendByDefault;
        var map = chart.mapObj.map;
        var mapHeight = map.getSize().y;
        var mapLegend;
        
        var mapLegendControl = L.Control.extend({
            options: {
                position: 'topright'//NO I18N
            },
            initialize: function(options) {
                L.setOptions(this, options);
                this._legendHolder = null;
                this._legendShown = true;
            },
            onAdd: function(map) {
                var container = this._container = L.DomUtil.create('div', 'zcmap-legend-container');//NO I18N
                this._legendToggle = L.DomUtil.create('div', 'zcmap-legend-toggle', container);//NO I18N
                this._legendHolder = L.DomUtil.create('div', 'zcmap-legend-holder', container);//NO I18N
                this._setEvents();
                return container;
            },
            onRemove: function(map) {
                L.DomEvent.removeListener(this._legendToggle, 'click', this._update);//NO I18N
            },
            getLegendHolderElement: function() {
                return this._legendHolder;
            },
            _setEvents: function() {
                L.DomEvent.addListener(this._legendToggle, 'click', function(event) {//NO I18N
                    this.maintainLgndHideState=false;
                    this._update();
                    L.DomEvent.stopPropagation(event);
                }, this);
                L.DomEvent.addListener(this._legendHolder, 'mousewheel', L.DomEvent.stopPropagation);//NO I18N
                L.DomEvent.addListener(this._legendHolder, 'click', L.DomEvent.stopPropagation);//NO I18N
                L.DomEvent.addListener(this._legendHolder, 'dblclick', L.DomEvent.stopPropagation);//NO I18N
                L.DomEvent.addListener(this._legendHolder, 'mousemove', L.DomEvent.stopPropagation);//NO I18N
            },
            _update: function() {
                this._legendShown ? this.hideLegend() : this.showLegend();
            },
            showLegend : function(){
                if(this.maintainLgndHideState)
                {
                    return;
                }
                this._legendShown = true;
                this.setStyles();                                
            },
            hideLegend: function() {
                this._legendShown = false;                
                var width = this._legendHolder.offsetWidth;
                d3_select(this._container).style({
                    "transform": "translateX(" + width + "px)"//NO I18N
                });
                this.maintainLgndHideState =true;                
                d3.select(this._legendToggle).attr("tip","Show Legend");//NO I18N
            },
            setStyles: function(update) {
                //check for legend to be show or to be hidden 
                    if(update)
                    {
                d3_select(this._container).style({
                    "margin-right": "0px",//NO I18N
                    "width": "auto",//NO I18N
                            "height": "auto"//NO I18N
                        });
                        this.hideLegend();
                    }
                    else
                    {
                        d3_select(this._container).style({
                            "margin-right": "0px",//NO I18N
                            "width": "auto",//NO I18N
                    "height": "auto",//NO I18N
                    "transform": "translateX(0px)",//NO I18N
                    "transition": "transform .3s"//NO I18N
                });
                    }
                d3_select(this._legendHolder).style({                    
                    "background" : "white",//NO I18N
                    "position":null,//NO I18N
                    "display" : "inline-block",//NO I18N
                    "verticle-align" : "top",//NO I18N
                    "left": "40px",//NO I18N
                    "top": "0px",//NO I18N
                    "padding":"7px 5px 5px 5px",//NO I18N
                    "vertical-align":"top",//NO I18N
                    "border-bottom-left-radius":"3px"//NO I18N
                });
                d3_select(this._legendToggle).style({
                    "display" : chart.systemConf.legend.hidelegendcontrol ? "none" : "inline-block", //NO I18N
                }).attr("tip","Hide Legend");//NO I18N
                if (update) {
                    this._legendShown = !this._legendShown;
                    this._update();
                }
            },
             showToggle : function(){
                d3.select(this._legendToggle).style({
                    "transform" : "translateX(0px)",//NO I18N
                    "transition" : "transform .3s"//NO I18N
                });
            },
            hideToggle : function(){
                d3.select(this._legendToggle).style({
                    "transform" : "translateX(30px)",//NO I18N
                    "transition" : "transform .3s"//NO I18N
                });
            }            
        });
        
        this.legend.init = function() {
            mapLegend = new mapLegendControl();
            mapLegend.addTo(map);
            if(showLegendByDefault == "false")
            {
                  mapLegend._legendShown = false;
                  
            }
            chart.legendarea.element = d3_select(mapLegend.getLegendHolderElement());      
        };
        this.legend.checkAndSetStyles = function(update, legendShown){
            if(mapLegend){
                if(legendShown){
                    mapLegend.setStyles(!mapLegend._legendShown);
                    // mapLegend.showLegend();
                } else {
                    mapLegend.remove();
                }
                
            }
        };
        
        this.legend.hide = function() {
            mapLegend.hideLegend();
        };
        
        this.legend.show = function() {
            mapLegend.showLegend();
        };
        
        this.legend.remove = function() {
            mapLegend.remove();
        }
    };//$Id$
map_util.setChartObj = function(chartObj) 
{
    this._chartObj = chartObj;
    this._chartObj.mapObj.plotted_data = {};
    this._chartObj.mapObj.plotted_layer = {};
};
    
map_util.getDataset = function()
{
    return this._chartObj ? this._chartObj.dataset : null;
};
    
map_util.getLeafletMap = function()
{
    return this._chartObj ? this._chartObj.mapObj.map : null;
};
    
map_util.getMarkerOptions = function(type)
{
    return this._chartObj ?
            this._chartObj.systemConf.chart.plot.plotoptions[type].marker : null;
};
    
map_util.getPlotOptions = function(type)
{
    return this._chartObj ?
            this._chartObj.systemConf.chart.plot.plotoptions[type] : null;
};
    
map_util.getHoverOptions = function(type) 
{
    return this._chartObj ? this._chartObj.systemConf.chart.plot.plotoptions[type].hoveroptions : null;
};
    
map_util.getSVG = function() 
{
    return this._chartObj ?
            d3_select(this._chartObj.mapObj.map.getContainer()).select("div.leaflet-overlay-pane").select("svg") : null;//NO I18N
};
    
map_util.getCanvas = function()
{
    return this._chartObj ?
            d3_select(this._chartObj.mapObj.map.getContainer()).select("div.leaflet-overlay-pane").select("canvas") : null;//NO I18N
};
    
map_util.getLatLngArray = function() 
{
    return this._chartObj && this._chartObj.dataObject.data.geo.latlngArray ?
//            this._chartObj.dataObject.data.geo.latlngArray.filter(function(d){return d!=null && !(d[0] instanceof Array)}) :
            Object.keys(this._chartObj.mapObj.plotted_data).map(function(key){
                return this._chartObj.mapObj.plotted_data[key].latLng;
            }, this) : null;
};
map_util.getLayerBounds = function() 
{
        return this._chartObj && this._chartObj.dataObject.data.geo.featureArray?
            Object.keys(this._chartObj.mapObj.plotted_layer).map(function(key){
                return this._chartObj.mapObj.plotted_layer[key].layer.getBounds();
            }, this) : null;
};
map_util.getMaxZoomLevel = function() 
{
        var georole = this._chartObj ? this._chartObj.dataObject.data.geo.geoRole : null;
        return georole ? GEOROLEBASED_MAXZOOMLEVELS.getMaxZoom(georole) : null;
};
    
map_util.getSeries = function() 
{
        return this._chartObj ?
            this._chartObj.seriesdata : null;
};
    
map_util.getMapDimension = function() 
{
        if (this._chartObj) {

            var bounds = this._chartObj.mapObj.map.getContainer().getBoundingClientRect();
            return {
                width: bounds.width,
                height: bounds.height
            };
        } else {
            return null;
        }};
    
map_util.getChartObject = function() 
{
        return this._chartObj ? this._chartObj : null;
};
    
map_util.setEvents = function() {
        eventsObject = $ZC.mapcharts.events(systemconf);
        eventsObject.initialize(this);};
    
map_util.addPlotPoint = function(point) {
        if (this._chartObj) {
            if (!this._chartObj.mapObj.plotted_data) {
                this._chartObj.mapObj.plotted_data = {};
            }
            if(this._chartObj.chartTypes[0].value == geofilled )
            {
               this._chartObj.mapObj.plotted_data[point.xVal] = {
                   "id":point.id, //NO I18N
                    "latLng":point.latLng,//NO I18N
                    "feature":point.feature,//NO I18N
                    "color":point.color//NO I18N
                };
            }
            else
             {
               this._chartObj.mapObj.plotted_data[point.xVal] = {
                   "latLng" : point.latLng,//NO I18N
                   "color" : point.color,//NO I18N
                   "size" : point.size  //NO I18N
               };
             }   
        }};
map_util.addPlotLayer = function(layer) 
{
    if (this._chartObj) 
    {
        if (!this._chartObj.mapObj.plotted_layer) {
             this._chartObj.mapObj.plotted_layer = {};
        }
        if(this._chartObj.chartTypes[0].value == geofilled)
        {
            this._chartObj.mapObj.plotted_layer[layer.seriesVal] = {
                "layer" : layer.seriesLayer,//NO I18N
                "color" : layer.seriesColor,//NO I18N
                "geoJson" : layer.seriesGeoJson//NO I18N
            };
        }
    }
};
    
map_util.getScale = function() 
{
    return this._chartObj ? this._chartObj.zscale : null;
};

map_util.getOpacityValue = function()
{
    return this._chartObj ? ( this._chartObj.userdata.geo.fillOpacity ? Number(this._chartObj.userdata.geo.fillOpacity.replace("%","")) / 100  : null) : null;
};

map_util.getMarkerType = function()
{
    return this._chartObj ? this._chartObj.chartTypes[0].value == geoscatter ? (this._chartObj.userdata.geo.markerType) : null : null;
};
map_util.processBubblePieData = function(baseChartType) {
        // baseChartType = bubblepie | geobubblepie | geopie
        baseChartType = baseChartType || $ZC.charttype.bubblepie;

            var chartObj = map_util.getChartObject();
            var seriesdata = chartObj.seriesdata;
            var dataset = map_util.getDataset();

        var pieData = [],
            dataindex = validateNullVal(chartObj.systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(baseChartType)].dataindex, 3),
            categories = chartObj.userdata.chart.axes.xaxis.categories;

        seriesdata.forEach(function(d, i) {
            var chartTypeNumeric = chartObj.chartTypes[i].value;
            var ishideable = d.disabled || (chartTypeNumeric !== baseChartType),
                currentseriesdata = d.data;
            currentseriesdata.forEach(function(d, subseries) {
                pieData[subseries] = pieData[subseries] || [];
                categories.forEach(function(cat, index) {
                    var filteredData = d.filter(function(d) {
                        return dataset.getX(d) ? (dataset.getX(d).toLocaleLowerCase() === cat && d[dataset.geocolumnidx] == index): null;
                    });
                    var dt = filteredData.length > 1 ? filteredData[1] : filteredData[0];
                    if (!dt) {
                        var v;
                        seriesdata.some(function(seires, si) {
                            var currentseriesdata = seires.data;
                            return currentseriesdata[subseries].some(function(d, i) {
                                var hasX = (dataset.getX(d) ? (dataset.getX(d).toLocaleLowerCase() === cat && d[dataset.geocolumnidx] == index): null);
                                if (hasX) {
                                    v = d.slice(0);
                                    v[dataindex] = null;
                                }
                                return hasX;
                            })
                        });
                        dt = v;
                    }
                    if (dt) { // if missing subseries available
                        dt.disabled = ishideable;
                        pieData[subseries][index] = pieData[subseries][index] || [];
                        pieData[subseries][index].push(dt);
                    }
                        
            });
        });
        });
        return pieData;
    };
//$Id$
map_renderer_util.initMapSVG = function(leafletMapObj)
{
        
        var size = leafletMapObj.getSize();
        // var svg = d3_select(leafletMapObj.getPanes().overlayPane).select('svg');
        // if(!svg.empty()){
        //     svg.remove();
        // }
        var svg = d3_select(L.svg().addTo(leafletMapObj)._container).attr('class', 'chartsvg')//NO I18N
        svg.select('g').remove(); // Leaflet appends a g by default;//NO I18N
        return svg;
        
        //d3_select(leafletMapObj.getPanes().overlayPane)
        // .append('svg')
        // .attr('class','chartsvg')
        // .attr('width',size.x)
        // .attr('height',size.y) - previously created svg in this manner,
        // as the function resides in beta version of leaflet svg was appended explicitely
        
};
    
map_renderer_util.initNoDataHandlerElement = function(svg) 
{
        
        var width = map_util.getMapDimension().width;
        var height = map_util.getMapDimension().height;
        
        var g = appendEle(svg, "g", [1], ".", "class", "nodatahandler");//NO I18N
        var rect = appendEle(g, "rect", [1], ".", "class", "nodatahandler");//NO I18N
        
        rect.style({
            'width': width,//NO I18N
            'height': height//NO I18N
        });
        var transform = map_util.getLeafletMap()._mapPane.style.transform || map_util.getLeafletMap()._mapPane.style.webkitTransform;
        var result = transform.match(/translate3d\((.+)px,(.+)px,(.+)px\)/);

        result = result==null ? [0,0,0] : result;

        // to position no data g
        var x = -pInt(result[1]) + 'px';
        var y = -pInt(result[2]) + 'px';
        var z = -pInt(result[3]) + 'px';
        g.style({
            'transform': 'translate3d(' + x + ',' + y + ',' + z + ')'//NO I18N
        });
};
     
map_renderer_util.plotMapChart = function(svg, chartObj, update) 
{

        var seriesDetails = [];
        var g = update ? svg.select('g.seriesholder') : svg.append('g').attr('class', 'leaflet-zoom-hide seriesholder');//NO I18N
        var hover = update ? svg.select('g.highlight-group') : svg.append('g').attr('class', 'leaflet-zoom-hide highlight-group');//NO I18N
        var series = chartObj.seriesdata;
        var seriesColor = chartObj.seriesColor;
        //zoho charts need to fix;
        if(chartObj.userdata.metadata.axes.clr)
        {
            chartObj.rendererConf = [];
            series.forEach(function(d){
                chartObj.rendererConf[d.seriesidx] = {};
            });
        }
        
        var defs = svg.select("defs");//NO I18N

        setLinearGradient(defs);
        function setLinearGradient(defs)
        {
            var linearGradient = appendEle(defs,"linearGradient",[1]);
        
            linearGradient
                .attr("id","SVGUrl")//NO I18N
                .attr("gradientUnits","userSpaceOnUse")//NO I18N
                .attr("x1","-180.5832")//NO I18N
                .attr("y1","-159.5513")//NO I18N
                .attr("x2","-180.5832")  //NO I18N 
                .attr("y2","-134.1432") //NO I18N   
                .attr("gradientTransform","matrix(0.7071 0.7071 -0.7071 0.7071 43.6835 251.4735)");//NO I18N
        
            var stop = appendEle(linearGradient,"stop",[1],".","class","stop");//NO I18N
            
            stop
                    .attr({
                            "offset":0,//NO I18N
                    })
                    .style({
                            "stop-color" : "#FFFFFF",//NO I18N
                            "stop-opacity":0//NO I18N
                    });
                    
            var stop_1 = appendEle(linearGradient,"stop",[1],".","class","stop_1");//NO I18N
              
              stop_1
                    .attr({
                            "offset":1,//NO I18N
                    })
                    .style({
                            "stop-color" : "#000000",//NO I18N
                    })
        }
        
        chartObj.mapObj.map_util = map_util;
        map_renderer_util.unknowndata.flush();
        if(chartObj.chartTypes[0].value == geopie || chartObj.chartTypes[0].value == geobubblepie)
        {
            var pointDetails = seriesDetails = [];
            var subSeries = appendEle(g, "g",[1], "#", "id", "subseries_0");//NO I18N
            map_series_renderer.pie(subSeries,series,seriesColor,pointDetails,update);
        }
         else
         {      
            var seriesGroups = appendEle(g, "g", series, "#", "id", "series");//NO I18N
            seriesGroups.each(function(d, i) {
                var pointDetails = seriesDetails[i] = [];
                map_renderer_util.plotMapSeries(d3_select(this), d, i, seriesColor[i], pointDetails,update);
            });
         }
        
        if (!update) {
            hover.append('g').style('visibility', 'hidden');//NO I18N
        }
        
        chartObj.seriesDetails = seriesDetails;
        chartObj.map_util=map_util;
        map_util.setEvents();
        chartObj.mapObj.unknowndata = map_renderer_util.unknowndata;
        
};
    
map_renderer_util.removeSeriesGroups = function() 
{
        var svg = map_util.getSVG();
        svg.select('g.series-holder').remove();//NO I18N
        svg.select('g.highlight-group').remove();//NO I18N
};
    
map_renderer_util.plotMapSeries = function(parent, series, seriesIndx, color,pointDetails,update) 
{
        
        var type = $ZC.DataProcessor.helpers.getChartType(series.type, "numeric");//NO I18N
        if(type == geofilled)
        {
            map_series_renderer.filled(parent, series, seriesIndx, color,pointDetails);
        }
        else
        {
            if (series.disabled) {
                parent.selectAll('g').remove();//NO I18N
                return;
            }
            map_series_renderer.scatter(parent, series, seriesIndx, color,pointDetails,update);
        }
};
    
map_renderer_util.unknowndata = (function() 
{
        var _data = [];
        
        return {
            add: function(object) {
                if (object && _data.filter(function(data) {
                        return data === object;
                    }).length == 0) {
                    _data.push(object);
                }
            },
            
            remove: function(key) {
                var flag = false;
                _data = _data.filter(function(data) {
                    if (data != key) {
                        return true;
                    } else {
                        flag = data;
                        return false;
                    }
                });
                return flag;
            },
            
            flush: function() {
                _data = [];
            },
            
            toArray: function() {
                return _data.filter(function(element) {
                    return element != null;
                });
            }
        }
})();//$Id$
map_series_renderer.scatter = function(parent, series, seriesIndx, color, pointDetails, update) {
        
        var dataset = map_util.getDataset();
        var type = $ZC.DataProcessor.helpers.getChartType(series.type, "numeric");//NO I18N
        var scale = map_util.getScale();
        var latLngArray = [];
        var className, markerOpt; 
        var chartObj = map_util.getChartObject();
        var isExport = chartObj.userdata.geo.isExport;
        
        var markerType = map_util.getMarkerType() ? map_util.getMarkerType() : "default" ;//NO I18N
                
        className = 'scatterseries_' + seriesIndx ; //NO I18N
        if (type == geoscatter || type == geofilled) {
            markerOpt = "geoscatter"; //NO I18N
        } else if (type == geobubble) {
            markerOpt = "geobubble"; //NO I18N
        }
        var markerOptions = map_util.getMarkerOptions(markerOpt);
        var extraOptions = {
            "color": color, // series color//NO I18N
            "symbolSize": {//NO I18N
                "inner": 0.5, // Percentage of inner marker size//NO I18N
                "outer": 1 // Percentage of outer marker size//NO I18N
            }
        };
        var points = [];
        
        series.data.forEach(function(subgroup, index) {
            if (subgroup && subgroup.constructor == Array) {
                subgroup.forEach(function(point, index) {
                    var xVal = dataset.getActualX(point)
                    var latLng = dataset.getLatLng(point);
                    if (latLng) {
                        if( point[1] )
                        {
                            latLngArray.push(latLng);
                            points.push(point);
                            pointDetails.push(point);
                            map_util.addPlotPoint({
                                "xVal": xVal,//NO I18N
                                "latLng": latLng,//NO I18N
                                "color":color,//NO I18N
                                "size":map_util.getScale() ? map_util.getScale()(dataset.getZ(point)) : 0//NO I18N
                            });
                        }
                    } else {
                        map_renderer_util.unknowndata.add(xVal);
                    }
                });
            }
        });
        parent.attr("class",className);//NO I18N
        var scatterGroups = parent.selectAll('g').data(points); //NO I18N
        scatterGroups.enter().append('g').attr('class','scatter'); //NO I18N
        scatterGroups.exit().remove();
        scatterGroups
            .each(function(d) {
                if (type == geobubble) {
                    var z = scale(dataset.getZ(d));
                    markerOptions.outerFillOpacity = map_util.getOpacityValue();
                    markerOptions.size = z / 10;
                }
               type != geobubble && markerType != "default" ?  addCustomMarker(d3_select(this),extraOptions,markerType) : addSVGmarker(d3_select(this), null, markerOptions, extraOptions);//NO I18N
        });
        parent.selectAll("g").data(latLngArray);//NO I18N
       
       
      if(!update && !isExport)
      {
          switch(type)
          {
              case geoscatter : markerType != "default"  ? animateMarker(scatterGroups) : animateScatter(scatterGroups);//NO I18N
                                break;
              case geobubble  : animateBubble(scatterGroups); 
                                break;
          }
      }
                
         function animateScatter(scatterGroups)
         {
             var delay = 5;
             var durationTime = scatterGroups[0].length > 100 ? 750 : 1000;
             scatterGroups
                .each(function(d,i){
                     d3_select(this).selectAll("path")//NO I18N
                                       .style("opacity","0.1")//NO I18N
                                       .transition()
                                       .delay(function()
                                        {
                                           return scatterGroups[0].length < 100 ?  delay + ( i == 0 ? (i+1) * 2 : i * 2) : delay = delay + 0.5 ;
                                        })
                                       .duration(durationTime)
                                       .style("opacity","1");//NO I18N
                });
         }
         
         function animateBubble(scatterGroups)
         {
             scatterGroups
                .each(function(d,i){ 
                     d3_select(this).selectAll("path")//NO I18N
                                       .attr("transform","scale(0)")//NO I18N
                                       .transition()
                                       .duration(1000)
                                       .ease("cubic-out")//NO I18N
                                       .attr("transform","scale(1)")//NO I18N
                });
         }
         
         function animateMarker(scatterGroups)
         {
           var delay = 2.5;
           var opacity;
           scatterGroups
                .each(function(d,i){         
                    var translate = d3.transform(d3.select(this).select("path").attr("transform")).translate;//NO I18N
                    d3_select(this)
                               .selectAll('*:not(text)')//NO I18N
                               .style("opacity",function()//NO I18N
                               {
                                   opacity = this.getAttribute("opacity");
                                   return "0";
                               })
                               .attr("transform","translate(" + translate[0] + "," + (translate[1] - 20) + ")")//NO I18N
                               .transition()
                               .delay(function()
                                {
                                    
                                    scatterGroups[0].length < 100 ?  delay = delay + 2.5 : delay = delay + 0.5;
                                       return delay ;
                                })
                               .duration(1000)
                               .ease("bounce")//NO I18N
                               .style("opacity",function()//NO I18N
                                {
                                    return opacity;

                                })
                               .attr("transform","translate(" + translate[0] + "," + translate[1] + ")");  //NO I18N
                });
         }
            
    };//$Id$
map_series_renderer.filled = function(parent, series, seriesIndx, color, pointDetails){
        var dataset = map_util.getDataset();

        var map = map_util.getChartObject().mapObj.map;

        var dataObj = map_util.getChartObject().dataObject;

        var features = [],id,centroid,nullDataIdxs = [];

        var fillColor, layer, geojson, geojson_id, seriesLayer ;

        var seriesGroupElement = parent.attr('class', 'series filled');//NO I18N

        var path = d3.geo.path().projection(d3.geo.transform({
            point : projectionPoint
        }));
                
        series.data.forEach(function(subgroup, index){ 
            if(subgroup && subgroup.constructor == Array){
                subgroup.forEach(function(point, index){
                    var xVal = dataset.getActualX(point)
                    var featurePoint = dataset.getFeature(point);
                    var feature =  featurePoint ?(featurePoint instanceof Object ? featurePoint : JSON.parse(featurePoint)) : null;
                    var id = seriesIndx + "_" + index;
                    if(feature && feature.type!="point"){
                        centroid = map.layerPointToLatLng(path.centroid(feature));
                        dataset.updateFeature(point,feature);
                        feature.centroid = centroid;
                        feature.id = id;
                        features.push(feature);
                        pointDetails.push(point);
                        map_util.addPlotPoint({
                            "xVal" : xVal,//NO I18N
                            "id" : id,//NO I18N
                            "latLng" : centroid,//NO I18N
                            "feature" : feature,//NO I18N
                            "color":color//NO I18N
                        });
                    }
                    else {
                        map_renderer_util.unknowndata.add(xVal);
                    }
                })
            }
        });
               
        var opacityVal = map_util.getOpacityValue();
        
        var fillOpacity =  opacityVal!=null ? opacityVal : 0.85;
    
        fillColor = {
            "weight":0,//NO I18N
            "fillOpacity": fillOpacity,//NO I18N
            "smoothFactor": 0,//NO I18N
            "fillColor":color//NO I18N
            
        };
        
        layer = new L.LayerGroup();

        geojson = L.geoJson(features,{
            style: fillColor,
            onEachFeature: onEachFeature
        }).addTo(layer);

        geojson_id = geojson._leaflet_id;
        seriesLayer = layer._layers[geojson_id];

        map_util.addPlotLayer({
                            "seriesVal"   : seriesIndx,//NO I18N
                            "seriesLayer" : seriesLayer,//NO I18N
                            "seriesColor" : color,//NO I18N
                            "seriesGeoJson" : geojson//NO I18N
                        });
                        
        if(!series.disabled)
        {
              map.addLayer(layer);
        }
        function onEachFeature(feature, layer) {
            layer.on({
                            mouseover: highlightFeature,
                            mouseout: resetHighlight,
                            click: showMenu
            });
        }
        function showMenu()
        {
              eventsObject.setId(id);
        }
        function resetHighlight(e) {
                eventsObject.setId(null);
                geojson.resetStyle(e.target);
        }

        function highlightFeature(e) {
            var layer = e.target;
            var canvas = document.getElementsByClassName("leaflet-zoom-animated leaflet-interactive")[0];
                id = layer.feature.geometry.id;
                eventsObject.setId(id);
            layer.setStyle({
//                        "fillColor" :  patternFill(color,canvas),//NO I18N //pattern 
                "weight" : 1.5,//NO I18N
                "color":"#727070"//NO I18N
            });   
        }

        function projectionPoint(x,y){
            var layerPoint = map.latLngToLayerPoint(L.latLng(y,x));
            this.stream.point(layerPoint.x, layerPoint.y);
        }

    };
//$Id$
map_series_renderer.pie = function(parent, seriesData, seriesColor, pointDetails,update) {
        var pieRendererUpdate = [];
        var chartObj = map_util.getChartObject();
        var dataset = map_util.getDataset();
        var type = chartObj.chartTypes[0].value;
        var scale = map_util.getScale();
        var isExport = chartObj.userdata.geo.isExport;
        var latLngArray = [];
        var className = 'subseriesgroup_0' ; //NO I18N
        parent.attr("class",className);//NO I18N
        var points = [];
        var unknownIdx = [];
        var rendererData = [];
        var nullDataIdx = [];
        //inorder to set the domain for scaling 
        var maxTotalSum = 0;
        var minTotalSum = 0;
        var pieData =  map_util.processBubblePieData(type);
        pieData.forEach(function(group, index) {
            if (group && group.constructor == Array) {
                group.forEach(function(subgroup, index) {
                    var latLng;
                    var totalSum = 0;
                    var nullDataCount = 0;
                    var disabledDataCount = 0;
                    var indexCount = 0;
                    //for manipulating datalabels 
                    var pieDetails = [];
                    if(subgroup && subgroup.constructor == Array){
                        subgroup.forEach(function(point, i) {
                            latLng = latLng ? latLng : dataset.getLatLng(point);
                                pieDetails.push(point);
                                  if(!point.disabled)
                                  {
                                      if(point[1] != null)
                                      {
                                          if(typeof(point[3]) != "object") 
                                          {
                                              var zVal = dataset.getZ(point);
                                              totalSum = totalSum + zVal;
                                          }
                                      }
                                      else
                                      {
                                          point.disabled = true;
                                          nullDataCount++;
                                          disabledDataCount++;
                                      }
                                   }
                                  else
                                    disabledDataCount++;
                                  indexCount = i;
                            });
                            if(nullDataCount == indexCount+1 || disabledDataCount == indexCount+1)
                                subgroup.disabled = true;
                            else
                                subgroup.disabled = false;
                            if(maxTotalSum < totalSum)
                                maxTotalSum = totalSum;
                            else if(minTotalSum > totalSum && totalSum < 0 )
                                minTotalSum =  totalSum;
                            var xVal = dataset.getActualX(subgroup[0]);
                            if (latLng && !subgroup.disabled) {
                                latLngArray.push(latLng);
                                pointDetails.push(pieDetails);
                                map_util.addPlotPoint({
                                    "xVal": xVal,//NO I18N
                                    "latLng": latLng,//NO I18N
                                    "size":scale ? totalSum : 35,//NO I18N
                                });
                            } 
                            else if(subgroup.disabled)
                            {
                                nullDataIdx.push(index);
                            }
                            else {
                                map_renderer_util.unknowndata.add(xVal);
                                unknownIdx.push(index);
                            }
                    }
                    
                });
            }
       });
       minTotalSum = minTotalSum == 0 ? 0 : minTotalSum;
      // to set scale 
      type == geobubblepie ? chartObj.zscale.domain([minTotalSum,maxTotalSum]) : null;
      
       //to remove the unknow data and null data from the Pie Data;
       
       function compareNumbers(a, b)
        {
            return a - b;
        }
       
       var idxsToBeRemoved = [];
       idxsToBeRemoved = unknownIdx.concat(nullDataIdx);
       idxsToBeRemoved.sort(compareNumbers);
       idxsToBeRemoved.forEach(function(d,i){
             pieData[0].splice(d-i,1);
       });
       
       chartObj.piedata = pieData;
   
       var basicAttr = map_util.getPlotOptions(chartObj.chartTypes[0].name);
       basicAttr.fillOpacity = map_util.getOpacityValue();
       if(isExport)
            basicAttr.animation.enabled = false;
       
       var commonRendererProp = {
            params: {
            chartObj: chartObj,
            commonPlotOptions:basicAttr ,
            dataset: chartObj.dataset
            }
        }
        var scatterGroups = parent.selectAll('g.scatter').data(pieData[0]); //NO I18N
        scatterGroups.enter().append('g').attr('class','scatter'); //NO I18N
        scatterGroups.exit().remove();
        scatterGroups.
                   each(function(d,i)
                   {
                       var xVal = dataset.getActualX(d[0]);
                       var size = scale ? scale(chartObj.mapObj.plotted_data[xVal].size) : 35;
                       var pieRenderer;
                       if(!update)
                       {
                           pieRenderer = svg_plot_renderer.pie();
                       }
                       else
                       {
                           pieRenderer = chartObj.pieRenderer[xVal] ? chartObj.pieRenderer[xVal] : svg_plot_renderer.pie();
                       }
                        pieRenderer
                                .commonRendererProp(commonRendererProp)
                                .plotarea({
                                    width: size,
                                    height: size,
                                    left: size / 2,
                                    top: size / 2
                                });
                        d3_select(this).datum(d);
                        d3_select(this).call(pieRenderer);
                        d3.select(this).selectAll("path").filter(function(d){return (d.startAngle === d.endAngle) || !d.endAngle ;}).each(function(){ d3.select(this).style("display","none","important") });//NO I18N
                        var translate = d3.transform(d3.select(this).selectAll("g").attr("transform")).translate;//NO I18N
                        d3_select(this).selectAll("g").attr("transform","translate("+ (translate[0] - size/2) + "," + (translate[1] - size/2) +")");//NO I18N
                        pieRendererUpdate[xVal] = pieRenderer;
                        rendererData[xVal] = pieRenderer.data;
                            //data is needed for handling events
                    });
         // inorder to prohibit the data change occurs in pie renderer function      
         chartObj.renderedPiedata = $ZC.utils.simpleClone(rendererData);
         chartObj.pieRenderer = pieRendererUpdate;
        parent.selectAll("g.scatter").data(latLngArray);//NO I18N  
    };


//$Id$
chart.initialize = function(container, data){
        // To override the default initialise function given by ZC.charts.get in order to set up things for the map chart
        
        try {

            //removing existing contianer
              container.selectAll(".d3container").remove(); //NO I18N

            //initialising the map
            data.tooltip? data.tooltip.withinChart = true : null; //to cehck for the tooltip display
            var chartType = data.seriesdata && data.seriesdata.chartdata[0].type;
            var leafletMap = initMap(container.node(), data.geo.tileProvider,chartType);
            this.mapObj = $ZC.GeoChart.getMapObj(container, leafletMap);
            map_util.setChartObj(this);
            
            //reset of the default functionalities but the chartholder div will not be initialised
            var mode = (chartType == geofilled)? "canvas" : "svg";//NO I18N
            if (!this.plot.renderer) {
                var context = this;
                this.plot.renderer = {
                    "mode": mode,//NO I18N
                    "draw": function(update) {//NO I18N
                        context.render(update);
                    }
                }
            }
            this.userdata = data;
            this.chartRendered = false;
            this.container = container;
            this.createHelperElements();
            this.isGeoChart = true;
            var chartHeight = parseFloat(this.container.style("height"));//NO I18N
            var chartWidth = parseFloat(this.container.style("width"));//NO I18N
            this.setCanvasDimension(chartWidth, chartHeight);
            //Scale
            this.axes.x = {};
            this.axes.y = {
                groups: []
            };
            
            this.chartTypes = this.dataProcessorHelpers.getAllChartTypes(data, "object");//NO I18N
            //Populate data into the chart object
            this.globalProp = setGlobalPropByUserdata(data, {
                "width": chartWidth,//NO I18N
                "height": chartHeight//NO I18N
            }, {});
            populateChartObj.call(this, getThemeOptions(this.globalProp));
            
            if (this.nochartdata) {
                return;
            }
            
            var parentContainer = d3_select(document.body);
           
            //Initialising the tooltip element
            this.tooltip = {}
            this.tooltip.element = appendEle(parentContainer, "div", [1], "#", "id", "zctooltip"); //NO I18N
            this.eventHandler = {}
            this.eventHandler.tooltipElement = $ZC.events.tooltip(this.tooltip.element, data, this);
            this.eventHandler.tooltipElement.initialize();
            this.eventHandler.trackerElement = this.container.selectAll("rect.eventHandler");//NO I18N
            
            //related to initializing the svg adding definitions
            this.defsLocation = getDefsLocation();
            var svg = map_util.getSVG();
            this.legendHighlight = new $ZC.legendHighlight(chart, svg)
            appendEle(svg, "defs", [1]);
            
            //initialize holders for legend and title
            map_ui_util.legend(this);
            map_ui_util.legend.init();
            
        } catch (err) {
             console.log(err.stack);
             console.log("Oops! Sorry something went wrong to render the chart...")
             console.log("Error message : " + err.message);
            chart.breakOnErr = true;
        }
    };
    
    chart.render = function(update) {
        
        try {
            
            var svg = map_util.getSVG();
            
            mapObj = this.mapObj;
            
            map = mapObj.map;
            
            if (this.nochartdata) {
                
                this.chartRendered = true;
                map_renderer_util.initNoDataHandlerElement(svg);
                this.handleNoData(this.systemConf.noDataHandler, svg.selectAll('g.nodatahandler'));//NO I18N
                this.mapObj.disable();
                // map_ui_util.legend.remove();
                
            } else {
                $ZC.mapdataset(this.dataset, this.systemConf);
                
                var chartType = this.chartTypes[0].value;
                var marker = map_util.getMarkerType();
                this.getChartSeriesColor();
                this.isAxisCategory = true;
                this.isNonAxisMultiSeriesCategory = this.dataObject.isNonAxisMultiSeriesCategory;
                this.xymultiRenderer = this.isAxisCategory;
                this.zscale = chartType == 22 || chartType == 27 ? $ZC.scale.getScale(this, this.dataObject, map_util.getMapDimension(), this.axes.x.orient, null, this.dataset, "z") : null; //No I18N
                $ZC.legend.render(this);
                map_ui_util.legend.checkAndSetStyles(update, this.legendarea.show);
                legend_helpers.updateBubblePieData = function(d, i, chartObj) {
                if (chartObj.dataObject.pieWithAxis) {
                        d.data.forEach(function(subseries) {
                                subseries.forEach(function(dataPoint) {
                                        dataPoint.disabled = d.disabled;
                                });
                        });
                    }
                };
                     this.legend.component.highlightSeries = function(ele, d, i, data, chartObj, onLegHover)
                    {
                    if(chartObj.chartTypes[0].value == geofilled)
                    {

                        if(!d.disabled)
                        {
                          var curLayer = chartObj.mapObj.plotted_layer[i];
                          var color = curLayer.color;
                          var canvasLayer = document.getElementsByClassName("leaflet-zoom-animated");//NO I18N
                          var canvas;
                          for(var i = 0 ; i < canvasLayer.length ; i++)
                          {
                                if(canvasLayer[i].nodeName == "CANVAS")
                                {
                                     canvas = canvasLayer[i];
                                }
                          }
                          if(onLegHover)
                          {
                             curLayer.layer.bringToFront();
                             curLayer.layer.setStyle({
                                 "weight" : 1.5,//NO I18N                            
                                 "color":"#727070",//NO I18N     
                                 "fillOpacity":1//NO I18N
                             });
                             
                          }
                          else
                          {
                               curLayer.layer.eachLayer(function(layer){
                                   curLayer.geoJson.resetStyle(layer);
                               })
                              
                               chartObj.seriesdata.forEach(function(d,i){
                                   if(!d.disabled)
                                   {
                                        var gLayer = chartObj.mapObj.plotted_layer[i].geoJson;
                                        gLayer.bringToFront();
                                   }
                                });
                          }
                        }
                    
                }
                if(chartObj.chartTypes[0].value == geoscatter && marker != "default")
                {
                        if(onLegHover)
                         {
                              if(!d.disabled)
                                highlightUnSelectedSeries(chartObj,i);
                              else
                                 deselectHighlightUnSelectedSeries(chartObj,i);
                          }
                        else
                               deselectHighlightUnSelectedSeries(chartObj,i);
                }
                    if(chartObj.chartTypes[0].value == geoscatter && marker == "default")
                    {
                        var selectedSeriesGroup = map_util.getSVG().select(".scatterseries_"+i);//NO I18N
                        if(onLegHover)
                         {
                              if(!d.disabled)
                              {
                                selectedSeriesGroup.selectAll(".outer").style('transform',"scale(1.35)");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").style('transform',"scale(1.35)");//NO I18N
                                selectedSeriesGroup.selectAll(".outer").attr('transform',"scale(1.35)");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").attr('transform',"scale(1.35)");//NO I18N
                              }
                              else
                              {
                                selectedSeriesGroup.selectAll(".outer").style('transform',"scale(1)");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").style('transform',"scale(1)");//NO I18N
                                selectedSeriesGroup.selectAll(".outer").attr('transform',"scale(1)");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").attr('transform',"scale(1)");//NO I18N
                              }
                          }
                        else
                        {
                            selectedSeriesGroup.selectAll(".outer").style('transform',"scale(1)");//NO I18N
                            selectedSeriesGroup.selectAll(".inner").style('transform',"scale(1)");//NO I18N
                            selectedSeriesGroup.selectAll(".outer").attr('transform',"scale(1)");//NO I18N
                            selectedSeriesGroup.selectAll(".inner").attr('transform',"scale(1)");//NO I18N
                        }
                    }
                    if(chartObj.chartTypes[0].value == geobubble)
                    {
                        var selectedSeriesGroup = map_util.getSVG().select(".scatterseries_"+i);//NO I18N
                        if(onLegHover)
                         {
                              if(!d.disabled)
                              {
                                selectedSeriesGroup.selectAll(".outer").style('stroke-width',"3");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").style('stroke-width',"3");//NO I18N
                              }
                              else
                              {
                                selectedSeriesGroup.selectAll(".outer").style('stroke-width',"1");//NO I18N
                                selectedSeriesGroup.selectAll(".inner").style('stroke-width',"1");//NO I18N
                              }
                          }
                        else
                        {
                            selectedSeriesGroup.selectAll(".outer").style('stroke-width',"1");//NO I18N
                            selectedSeriesGroup.selectAll(".inner").style('stroke-width',"1");//NO I18N
                        }
                    }
                    if(chartObj.chartTypes[0].value == geopie || chartObj.chartTypes[0].value == geobubblepie)
                    {
                        var selectedSeriesGroup = map_util.getSVG().selectAll("g.piegroup");//NO I18N
                        var seriesPies = selectedSeriesGroup.selectAll("path#arc_" + i);//NO I18N
                        var actualClr = chartObj.seriesColor[i];
                        if(onLegHover)
                         {
                              if(!d.disabled)
                              {
                                seriesPies.style('fill',patternFill(actualClr));//NO I18N
                              }
                              else
                              {
                                seriesPies.style('fill',actualClr);//NO I18N
                              }
                          }
                        else
                        {
                            seriesPies.style('fill',actualClr);//NO I18N
                        }
                    }
                }
                function highlightUnSelectedSeries(chartObj,index)
                {
                    chartObj.seriesdata.forEach(function(d,i){
                                   if(!d.disabled && i != index)
                                   {
                                       var unSelectedSeriesGroup = map_util.getSVG().select(".scatterseries_"+i);//NO I18N
                                       unSelectedSeriesGroup.selectAll(".outer").style('opacity',"0.4");//NO I18N
                                       unSelectedSeriesGroup.selectAll(".inner").style('opacity',"0.4");//NO I18N
                                       unSelectedSeriesGroup.selectAll(".shadowPath").style('opacity',0.1);//NO I18N
                                   }
                        });
                }
                function deselectHighlightUnSelectedSeries(chartObj,index)
                {
                    chartObj.seriesdata.forEach(function(d,i){
                                   if(!d.disabled && i != index)
                                   {
                                      var unSelectedSeriesGroup = map_util.getSVG().select(".scatterseries_"+i);//NO I18N
                                       unSelectedSeriesGroup.selectAll(".outer").style('opacity',"1");//NO I18N
                                       unSelectedSeriesGroup.selectAll(".inner").style('opacity',"1");//NO I18N
                                       unSelectedSeriesGroup.selectAll(".shadowPath").style('opacity',marker == "Type5" ? 0.1 : 0.3);//NO I18N
                                   }
                        });
                }
                map_renderer_util.plotMapChart(svg, this, update);
                if (Object.keys(this.mapObj.plotted_data).length === 0) {
                    map_renderer_util.initNoDataHandlerElement(svg);
                    this.handleNoData(this.systemConf.noDataHandler, svg.selectAll('g.nodatahandler'));//NO I18N
                    this.mapObj.disable();
                    map_ui_util.legend.remove();
                    this.nochartdata = true;
                    this.hasUnknownData=true;
                }
                if(!update)
                {
                    var maxZoom = map_util.getMaxZoomLevel();
                    var prop = maxZoom ? {maxZoom : maxZoom} : null;
                    this.chartTypes[0].value == geofilled && !this.nochartdata ? this.mapObj.fitBounds(map_util.getLayerBounds()) : this.mapObj.fitBounds(map_util.getLatLngArray(),prop);
                }
                var seriesGroups = svg.selectAll('g.seriesholder').selectAll("g.series");//NO I18N
                
                this.chartRendered = true;
                
            }
            
        } catch (err) {
            
    		 console.log(err.stack);
             console.log("Oops! Sorry something went wrong to render the chart...")
             console.log("Error message : " + err.message);
            this.breakOnErr = true;
            
        }
        
    };
    
    chart.resetdata = function(newSystemConf) {
        var chartHeight = parseFloat(this.container.style("height"));//NO I18N
        var chartWidth = parseFloat(this.container.style("width"));//NO I18N
        this.setCanvasDimension(chartWidth, chartHeight);
        populateChartObj.call(this, newSystemConf, true);
        this.globalProp = setGlobalPropByUserdata(newSystemConf, {
            "width": chartWidth,//NO I18N//NO I18N
            "height": chartHeight//NO I18N
        }, {});
    };
    
    chart.showLoading = function(holder) {
        return;
    };
    
    chart.getChartSeriesColor = function() {
        var colors = []
        var legend_data = systemconf.legend;
        if (legend_data.colors) {
            if (!(legend_data.colors instanceof Array)) {
                var legendColors = [];
                for (var key in legend_data.colors) {
                    if (legend_data.colors.hasOwnProperty(key)) {
                        legendColors.push(legend_data.colors[key]);
                    }
                }
                colors = legendColors;
            } else {
                colors = legend_data.colors;
            }
        } else if (legend_data.patternPallete) {
            var patternPallete = $ZC.legutil.patternPallete.get(legend_data.patternPallete);
            colors = patternPallete.map(function(d, i) {
                var id = patterns.get("imageFill", {//NO I18N
                    "name": d,//NO I18N
                    "width": 50,//NO I18N
                    "height": 50//NO I18N
                });
                return "url(" + chart.defsLocation + "#" + id + ")"; //NO I18N
            })
        } else if (legend_data.colorPallete) {
            if (legend_data.colorPallete.type == "monochrome") {
                colors = $ZC.legutil.getMonochromeColorPallette(legend_data.colorPallete.options.monochrome);
            } else {
                colors = $ZC.legutil.colorpallete.get(legend_data.colorPallete.options.multicolor) || $ZC.legutil.colorpallete.get("flat-ui-colors");
            }
        }
        /*
         * setting seriesdata color
         */
        if (colors != null) {
            this.seriesColor = colors.slice(0, colors.length);
            this.seriesdata.map(function(d, i) {
                if (d.color != null && d.color != "") {
                    chart.seriesColor[i] = d.color;
                }
            })
        }
    };
    
    chart.redraw = function() {
        this.resetdata(systemconf);
        this.mapObj.map.invalidateSize();
        this.flushCanvas();
        this.render(true);
    };
    
    chart.flushCanvas = function()
    {
        Object.keys(chart.mapObj.plotted_layer).forEach(function(key){
            chart.mapObj.plotted_layer[key].layer.clearLayers();
        });
    };
    chart.polarToXY = function(r,a)
    {
        a = a - (mathPI / 2);
        return [mathCos(a) * r, mathSin(a) * r];
    }
    chart.addRemoveSeries = function(series, i) {

        var svg = this.map_util.getSVG();
        var chart = this;
        var seriesHolder = svg.select("g");//NO I18N
        var seriesGroups =  chart.chartTypes[0].value == geopie ? seriesHolder.selectAll("g#subseries_0").selectAll("g") : seriesHolder.selectAll("g");//NO I18N
        var textEle = seriesGroups.selectAll("text");//NO I18N
   
        var resetDataLabelAndEnable = function(chart)
        {
            chart.seriesDetails.forEach(function(d){ 
                 d.forEach(function(d){
                        d.hidden = false;
                    });
              });
            dataLabel(seriesGroups,chart,chart.seriesDetails); 

        }

        this.dataObject.initialize("addorremoveseries");//NO I18N
        
        if (this.isAxisCategory) {
            (this.dataObject.isBubbleEnabled) ? this.zscale.domain(this.dataObject.getMinMaxZ()) : null;
        }
        if(chart.chartTypes[0].value == geofilled)
        {
            if(!(series instanceof Array))
            {
                var selectedLayer= chart.mapObj.plotted_layer[series.seriesidx].layer;
                if(series.disabled)
                {
                     textEle.remove();
                     chart.mapObj.map.removeLayer(selectedLayer);
                     //data lables to be reset for the selected layer
                     resetDataLabelAndEnable(chart);
                }
                else
                {
                    textEle.remove();
                    chart.seriesdata.forEach(function(d){
                        var gLayer = chart.mapObj.plotted_layer[d.seriesidx].layer;
                        chart.mapObj.map.removeLayer(gLayer);
                    });
                    chart.seriesdata.forEach(function(d){
                        if(!d.disabled)
                        {
                            var gLayer = chart.mapObj.plotted_layer[d.seriesidx].layer;
                            chart.mapObj.map.addLayer(gLayer);
                        }

                    });
                    //data lables to be reset
                    resetDataLabelAndEnable(chart);
                } 
            }
            else
            {
                chart.seriesdata.forEach(function(d){
                        var gLayer = chart.mapObj.plotted_layer[d.seriesidx].layer;
                        chart.mapObj.map.removeLayer(gLayer);
                 });
                chart.seriesdata.forEach(function(d){
                        if(!d.disabled)
                        {
                            var gLayer = chart.mapObj.plotted_layer[d.seriesidx];
                            gLayer.layer.eachLayer(function(layer){
                                    gLayer.geoJson.resetStyle(layer);
                            });
                            chart.mapObj.map.addLayer(gLayer.layer);
                        }
                });
                dataLabel(seriesGroups,chart,chart.seriesDetails);
            }
            
        }
        else
         {
          this.plot.renderer.draw(true);  
         }   
    };
    
    chart.setChartDimension = function(width, height) {
        this.chartarea = {
            width: width,
            height: height
        }
    };
    
    chart.handleNoData = function(data, ele) {
        // var isGeoChart = chart.dataObject.isGeoChart;
        var nodatawrap = (ele != null) ? ele : wrap.selectAll("g.nodatahandler");//NO I18N
        if (data.htmlEl != null) {
            var customHandler = appendEle(chart.container.selectAll("div.canvas-component"), "div", [1], ".", "class", "nodatahandler");//NO I18N
            customHandler
                .style("position", "absolute")//NO I18N
                .html(data.htmlEl);
            
            var node = customHandler.node();
            customHandler.style({
                "left": validateNullVal(data.x, ((chart.chartarea.width / 2) - (node.offsetWidth / 2))) + "px",//NO I18N
                "top": validateNullVal(data.y, ((chart.chartarea.height / 2) - (node.offsetHeight / 2))) + "px"//NO I18N
            });
        } else if (data.imageUrl != null) {
            var image = appendEle(nodatawrap, "image", [1]);
            image
                .attr({
                    "x": data.x || (chart.chartarea.width / 2) - 50,//NO I18N
                    "y": data.y || (chart.chartarea.height / 2) - 50,//NO I18N
                    "width": 100,//NO I18N
                    "height": 100,//NO I18N
                    "xlink:href": data.imageUrl//NO I18N
                });
        } else if (data.text != null) {
            
            var text = appendEle(nodatawrap, "text", [data], ".", "class", "nodata");//NO I18N
            text
                .attr({
                    "x": data.x || chart.chartarea.width / 2,//NO I18N
                    "y": data.y || chart.chartarea.height / 2,//NO I18N
                    "text-anchor": "middle"//NO I18N
                })
                .text(decodeHTML(data.text || "No Data"));//NO I18N
            applyFont(text, [data, systemconf.canvas, $ZCG]);
        }
    };
    
    return chart;
    
    function initMap(container, tiles,type) {
        
        if (container._ZCMap) {
            // If map already initialised for the container
            container._ZCMap.remove();
        }
        
        var southWest = L.latLng(85, -180),
            northEast = L.latLng(-180, +180),
            bounds = L.latLngBounds(southWest, northEast);
        
        var tileProps = tiles.tileProps;
        tileProps.worldCopyJump = tileProps.worldCopyJump || true;
        tileProps.noWrap = tileProps.noWrap || false;
        tileProps.continuousWorld = tileProps.continuousWorld || true;
        // to stop leaflet fetching invalid tiles. Its a bug in Leaflet new version which results console log error for all the invalid tiles
        //  even though no error in the UI. So forcefully we are stopping leaflet fetching the tiles out side of the world bounds.
        if (tileProps.noWrap) {
            tileProps.bounds = bounds;
        }
            var mapProp = tileProps.noWrap ? {
                // to stop leaflet moving out of the world to the blank space
                maxBounds: bounds,
                maxBoundsViscosity: 1.0,
                zoomAnimationThreshold:10
            } : {};
             mapProp.preferCanvas = type == geofilled ? true :false
             var map = L.map(container, mapProp).fitWorld();
        
            var tileLayer = L.tileLayer(tiles.tileUrl, tileProps);
        // for performace log in zoho reports. do not move this after tilelayer.add(map)
            tileLayer.on("loading", function() {
                this.startTime = new Date().getTime();
            });
            tileLayer.addTo(map);
            container._ZCMapTileLayer = tileLayer;
            container._ZCMap = map;
            map_renderer_util.initMapSVG(map);    
        var hideAttributions = tileProps.hideAttributions || false;
        if (hideAttributions) {
            map.attributionControl.remove();
        }
        var hideZoomControls = tileProps.hideZoomControls || false;
        if (hideZoomControls) {
            map.zoomControl.remove();
        }
        return map;
    }
    
    function getThemeOptions(globalProp) {
        var overallTypes = $ZC.charttypenames.values();
        var allSeriesTypes = $ZC.DataProcessor.helpers.getAllChartTypes(chart.userdata, "string")//NO I18N
        var theme = null,
            userTheme;
        var defaultThemeOptions, userThemeOptions;
        if (chart.userdata.canvas) {
            theme = chart.userdata.canvas.theme;
        }
        var defaultTheme = new $ZC.defaultTheme(globalProp);
        overallTypes.map(function(d, i) {
            if (allSeriesTypes.indexOf(d) != -1) {
                  getGeoDefaultOptions(d, defaultTheme.chart.plot.plotoptions, globalProp);
//                $ZC.getDefaultOptions(d, defaultTheme.chart.plot.plotoptions, globalProp);
            }
            
        })
        if ((theme != null) && ($ZC[theme] != null)) {
            userTheme = new $ZC[theme](globalProp);
            userTheme = mergeJSON(defaultTheme, userTheme, true, true);
        } else {
            userTheme = defaultTheme;
        }
        return userTheme;
    }
    
    function getDataObject(systemconf) {
        var daobj = new $ZC.DataProcessor(systemconf, chart.dataset, chart);
        chart.seriesdata = daobj.isHierarchy ? simpleClone(chart.seriesdata) : chart.seriesdata;
        return daobj;
    }
    
    function populateChartObj(baseSystemConf, update) {
        this.preProcessor = {}; // zohochart need to fix
        this.systemConf = systemconf = mergeJSON(baseSystemConf, this.userdata, true, true);
        this.nochartdata = !systemconf.seriesdata || !systemconf.seriesdata.chartdata || systemconf.seriesdata.chartdata.length <= 0;
        this.seriesdata = this.nochartdata ? null : systemconf.seriesdata.chartdata;
        if (!update) {
            stateChangeListener(chart, systemconf.canvas.events, "chart", "init");//NO I18N
        }
        
        if(!this.nochartdata)
        {
            this.dataset = new $ZC.dataset.get(systemconf,this);
            this.dataObject = getDataObject(systemconf);
            this.dataset.setDataObj(this.dataObject)
            this.dataset.geocolumnidx = (this.systemConf.metadata.axes.geoidxpos != null) ? this.systemConf.metadata.columns[this.systemConf.metadata.axes.geoidxpos].dataindex : null
            
            //overiding prop of map pie and map bubble pie for legend filter state update
            this.dataObject.pieWithAxis = this.chartTypes[0].value == $ZC.charttype.geopie || this.chartTypes[0].value == $ZC.charttype.geobubblepie;
            
        }        
        this.nochartdata = this.nochartdata || (this.dataObject.totalnoofdatas < 1);
        this.axes.rotated = this.dataObject ? this.dataObject.getAxisRotated() : null;
        this.axes.x.orient = this.axes.rotated ? "left" : "bottom";//NO I18N
        this.axes.y.orient = this.axes.rotated ? "bottom" : "left";//NO I18N
        var chartHeight = parseFloat(chart.container.style("height"));//NO I18N
        var chartWidth = parseFloat(chart.container.style("width"));//NO I18N
        this.setChartDimension(chartWidth, chartHeight);  
    }
};

var GEOROLEBASED_MAXZOOMLEVELS = (function() {
    var zoomlevelByRole = {
        0:1,
        1: 4,
        2: 6,
        3: 7,
        4: 7,
        5: 9
    };
    return {
        getMaxZoom: function(georole) {
            return zoomlevelByRole[georole];
        }
    };
    
})();//$Id$
/*
 * this file contains methods to extract the required forms of data from the user input
 */
$ZC.mapdataset = function(chartDataset, data) {
    var latLngArray = data.geo.latlngArray;
    var featureArray = data.geo.featureArray;
    // chartDataset.getX = function(d){
    //     return this.getLng(d);
    // },
    // chartDataset.getY = function(d,yaxiscolumnorder,range){
    //      return this.getLat(d);
    // }
    chartDataset.getActualX = function(d) {
        return d[this.xidx];
    },
        chartDataset.getLng = function(d) {
            return latLngArray[d[this.geocolumnidx]] == null ? null : latLngArray[d[this.geocolumnidx]][0];
        },
        chartDataset.getLat = function(d) {
            return latLngArray[d[this.geocolumnidx]] == null ? null : latLngArray[d[this.geocolumnidx]][1];
        },
        chartDataset.getLngLat = function(d) {
            return latLngArray[d[this.geocolumnidx]] == null ? null : [latLngArray[d[this.geocolumnidx]][1], latLngArray[d[this.geocolumnidx]][0]];
        },
        chartDataset.getLatLng = function(d) {
            return latLngArray[d[this.geocolumnidx]] == null ? null :
                (latLngArray[d[this.geocolumnidx]][0] instanceof Array ? null : [ latLngArray[d[this.geocolumnidx]][0] == null ? 0 : latLngArray[d[this.geocolumnidx]][0] , latLngArray[d[this.geocolumnidx]][1] == null ? 0 : latLngArray[d[this.geocolumnidx]][1] ]);
        }
        chartDataset.getFeature = function(d) {
            return featureArray[d[this.geocolumnidx]] == null ? null :
                featureArray[d[this.geocolumnidx]] instanceof Array ? null :featureArray[d[this.geocolumnidx]];
        } 
        // to replace json string to json object, as we need it as json object to handle events
        chartDataset.updateFeature = function(d,feature){
                featureArray[d[this.geocolumnidx]]=feature;
        }
        chartDataset.getCentroid = function(d)
        {
            return featureArray[d[this.geocolumnidx]] == null ? null : featureArray[d[this.geocolumnidx]].centroid;
        } 
        chartDataset.getId = function(d)
        {
            return featureArray[d[this.geocolumnidx]] == null ? null : featureArray[d[this.geocolumnidx]].id;
        }
    return chartDataset;
}
//$Id$
$ZC.mapcharts.events = function(systemConf) {
    
    var global = {
        systemConf: systemConf
    };
      var current_id = null;
    return {
        "initialize": function(util) { //NO I18N
            global.util = util;
            global.svg = util.getSVG();
            if (!global.svg) {
                return;
            }
            global.leafletMapObj = util.getLeafletMap();
            global.seriesHolder = global.svg.select("g.seriesholder");//NO I18N
            global.seriesElements = global.svg.select("g").selectAll("g.scatter"); //global.svg.select("g").selectAll("g").selectAll("g");//NO I18N
            global.latLngArray = util.getLatLngArray();
            global.chartObj = util.getChartObject();
            global.dataset = util.getDataset();
            global.leafletMapObj.on('zoomend', function() {
                update(util);
                global.seriesHolder.style("opacity","1");//NO I18N
            });
            // with out zoom change we are resetting view for search, so need to update the position
            global.leafletMapObj.on('viewreset', function() {
                update(util);
            });
            global.leafletMapObj.on('mousemove', mousemove);
            global.leafletMapObj.on('click', click);
            global.leafletMapObj.on('dblclick', dblclick);
            global.leafletMapObj.on('mouseout', mouseout);
            global.leafletMapObj.on('zoomstart',function(){
                 global.seriesHolder.style("opacity","0");//NO I18N
                mouseout();
            });
            update(util);
            global.legend =  getLegendDetails(systemConf);
        },
        "setId": function(id) { //NO I18N
            current_id = id;
        }
    }

    function getLegendDetails() {
        var showOnDataHover = systemConf.legend.itemHoverStyle && systemConf.legend.itemHoverStyle.showOnDataHover;
        var legendSeries = global.chartObj.legendarea.element.selectAll(".legseries").node(); //NO I18N
        return {
            element: legendSeries,                  
            reverse: showOnDataHover,       
            children: legendSeries ? toArray(legendSeries.children) : [],       
            height: legendSeries ? legendSeries.offsetHeight : null
        }
    }
    function updateDataLabel(util) {
        
        var type = global.chartObj.chartTypes[0].value;
        if(type != geopie && type != geobubblepie)
        {
            var seriesGroups = global.svg.selectAll('g.seriesholder').selectAll("#series");//NO I18N
            var series = global.chartObj.seriesdata;
            seriesGroups.data(series);
            dataLabel(seriesGroups, global.chartObj, global.chartObj.seriesDetails,util.getMarkerType());
        }
        else
        {             
            var metaData =  global.chartObj.dataObject.data.metadata;
            var labelIdx =  metaData.axes.label;
            var x = metaData.axes.x;
            var columnIdx = labelIdx ? metaData.columns[labelIdx].columnname == metaData.columns[x].columnname : null;
            // to check the text column is involved in chart
                dataLabel(global.chartObj.piedata, global.chartObj,global.chartObj.seriesDetails,null,columnIdx);
        }
    }
    
    function update(util) {
        //reason to have global variables is to avoid computing the variables for every event trigger.
        global.seriesElements = (global.chartObj.chartTypes[0].value == geobubblepie || global.chartObj.chartTypes[0].value == geopie) ? global.svg.select("g").selectAll("g.scatter") : global.seriesElements;

        //translating the highlighting element 
        
        var srchEle;
        
        var highlightEle = global.svg.select("g.leaflet-zoom-hide.highlight-group").select("g.highlight");//NO I18N

        if(highlightEle[0][0])
        {
            global.seriesElements.each(function(data,i){
                if(d3.transform(d3.select(this).attr("transform")).translate.toString() == d3.transform(highlightEle.attr("transform")).translate.toString())
                        srchEle = i;
            });
            
        }

        global.seriesElements.attr("transform", function(data,i) { //NO I18N
            var layerPoint = global.leafletMapObj.latLngToLayerPoint(L.latLng(data[0], data[1]));
            //search highlighting to translate the g element for outer stroke 
            if(srchEle == i)
            {
                highlightEle.attr("transform","translate(" + layerPoint.x + "," +layerPoint.y + ")") ; //NO I18N
            }
            return "translate(" + //NO I18N
                layerPoint.x + "," +
                layerPoint.y + ")";
        });    
        
        if (global.chartObj.seriesDetails) {
            updateDataLabel(util);
        }
    }    
    function mousemove(event) {      
        
        if(global.chartObj.systemConf.chart.plot.events.enabled==false)
        {
            return;
        }
        var series = global.chartObj.map_util.getSeries();
        var chartType = global.chartObj.chartTypes[0].value;
        var marker = global.util.getMarkerType() != "default" ? global.util.getMarkerType() : null; //No I18N
        var leafletMapObj = global.leafletMapObj;
        var MINDIST = getMinDist(global.chartObj,marker); //Minimum distance a point should be from the cursor to be highlighted - 10 in pixel scale

        handleReverseHovering(false); // geopie and geobubblepie;

        if (leafletMapObj.getZoom() < 1) {
            //If not focused the event is not triggered
            return;
        }
        var latLngWidth = (leafletMapObj.getBounds().getEast() - leafletMapObj.getBounds().getWest() ) * Math.pow(2,(leafletMapObj._zoom - 1));
        
        var minDistanceForHighlight = MINDIST* latLngWidth / (leafletMapObj.getContainer().getBoundingClientRect().width);
        
        var seriesnumber = findSelectedPoint(series,event,minDistanceForHighlight,marker,global,current_id);
        
        var tooltipElement = global.chartObj.systemConf.tooltip;

        var tooltipObject = global.chartObj.eventHandler.tooltipElement;
        
        if(seriesnumber)
        {
            handleReverseHovering(false); // geopie and geobubblepie;

                var dataset = global.dataset;
                    //Show highlight over point
                    this._container.style.cursor = "pointer";

            if(chartType != geofilled)
            {
                    var highlightElement = getHighlightGroupElement(seriesnumber, global.svg,chartType,marker);
                    var layerPoint = leafletMapObj.latLngToLayerPoint(seriesnumber.latLng);
                    highlightElement.style('visibility', 'visible').attr("transform", 'translate(' + layerPoint.x + ',' + layerPoint.y + ')'); //NO I18N
                    var color = global.chartObj.seriesColor[seriesnumber.seriesIndex];
                    if(chartType == geopie || chartType == geobubblepie)
                          highlightElement.selectAll("#arc_"+seriesnumber.seriesIndex).style("fill",patternFill(color)); //NO I18N
            }
                    //To show the tooltip
                    if (tooltipElement.enabled) {
                        enableToolTip(global,event,seriesnumber,dataset,tooltipObject);
                        if(global.legend.activeIndex !== seriesnumber.seriesIndex && defined(global.legend.activeIndex)) {
                            handleReverseHovering(false);
                        }
                        handleReverseHovering(true, seriesnumber.seriesIndex);
                    }
                    //Make a callback to the user event listener if any provided
                    makeCallback(seriesnumber, "mousemove", event);//NO I18N
                    
                    }
           else {
                this._container.style.cursor = "default";//NO I18N
                global.svg.select('g.highlight-group').select('g.piegroup').remove();//NO I18N
                global.svg.select('g.highlight-group').select('g').attr('transform', null).style('visibility', 'hidden'); //NO I18N
                tooltipObject.hide(tooltipElement.element);
                handleReverseHovering(false);
            }
        }
 
    function mouseout(event) {

        var tooltip = global.chartObj.systemConf.tooltip;
        var tooltipObject = global.chartObj.eventHandler.tooltipElement;
        global.svg.select('g.highlight-group').select('g').attr('transform', null).style('visibility', 'hidden');//NO I18N
        tooltipObject.hide(tooltip.element);
        handleReverseHovering(false);
        makeCallback(undefined, "mouseout", event);//NO I18N
    }
    
    function click(event) {
        //To find if there is any point nearby
        var marker =global.util.getMarkerType();
        var leafletMapObj = global.leafletMapObj;
        var MINDIST = marker ? 30 : getMinDist(global.chartObj,marker); //Minimum distance a point should be from the cursor to be highlighted - 10 in pixel scale
        var series = global.chartObj.map_util.getSeries();
        //Hiding the tooltip
        var tooltip = global.chartObj.systemConf.tooltip;
        var tooltipObject = global.chartObj.eventHandler.tooltipElement;
        global.svg.select('g.highlight-group').select('g').attr('transform', null).style('visibility', 'hidden');//NO I18N
        tooltipObject.hide(tooltip.element);
        
        var latLngWidth = (leafletMapObj.getBounds().getEast() - leafletMapObj.getBounds().getWest() ) * Math.pow(2,(leafletMapObj._zoom - 1));
        var minDistanceForHighlight = MINDIST * latLngWidth / (leafletMapObj.getContainer().getBoundingClientRect().width);
        
        var chartType = global.chartObj.chartTypes[0].value;    
            
        var series = global.chartObj.map_util.getSeries();

        var seriesnumber = findSelectedPoint(series, event, minDistanceForHighlight,marker,global,current_id);

        if (seriesnumber) {
               makeCallback(seriesnumber, "click", event);//NO I18N
        }
             
    }
        
    function dblclick(event) {
        
        var series = global.chartObj.map_util.getSeries();
        var marker = global.util.getMarkerType();
        var leafletMapObj = global.leafletMapObj;
        var MINDIST = getMinDist(global.chartObj); //Minimum distance a point should be from the cursor to be highlighted - 10 in pixel scale
        
        var latLngWidth = (leafletMapObj.getBounds().getEast() - leafletMapObj.getBounds().getWest() ) * Math.pow(2,(leafletMapObj._zoom - 1));
        var minDistanceForHighlight = MINDIST * latLngWidth / (leafletMapObj.getContainer().getBoundingClientRect().width);
        var chartType = global.chartObj.chartTypes[0].value;    
        
        var seriesnumber = findSelectedPoint(series, event, minDistanceForHighlight,marker,global,current_id);
        
        if (seriesnumber) 
        {           
           makeCallback(seriesnumber, "doubleclick", event);     //NO I18N
        } 
    }

    function handleReverseHovering(show, seriesIndex) {
        var prevIndx ; 
        if (global.legend.reverse === true) {
            if (show === false) {
                seriesIndex = global.legend.activeIndex;
                if (!defined(seriesIndex)) {
                    return;
                }
            } else {
                prevIndx = global.legend.prevActiveIndex ? global.legend.prevActiveIndex : null ;
                global.legend.activeIndex = seriesIndex;
            }
            if(global.legend.children[seriesIndex])
            {
               if(show)
                {
                    global.legend.element.scrollTop =  global.legend.children[seriesIndex].offsetTop - global.legend.height/2;
                    global.chartObj.legend.component.highlightItem(global.legend.children[seriesIndex], global.chartObj.seriesdata[seriesIndex], seriesIndex, systemConf.legend, show);
                    global.legend.prevActiveIndex = global.legend.activeIndex;
                }
                else
                {
                    global.chartObj.legend.component.highlightItem(global.legend.children[seriesIndex], global.chartObj.seriesdata[seriesIndex], seriesIndex, systemConf.legend, show);
                }
            }
        }
    }

    function makeCallback(seriesnumber, eventType, leafletEvent) {
        
        if (!seriesnumber) {
            //default value of seriesnumber
            seriesnumber = {
                seriesIndex: 0,
                data: null
            }
        }
        
        if (!global.chartObj.chartRendered) {
            return;
        }
        
        var plotOptions = global.util.getSeries()[seriesnumber.seriesIndex].plotoptions;
        var type = global.util.getSeries()[seriesnumber.seriesIndex].type;
        var defaultPlotOptions = global.systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)];
        
        var userCallback = getEventConf(plotOptions, defaultPlotOptions, global.chartObj, eventType);
        if (userCallback != null) {
            var data = {
                "x": leafletEvent.containerPoint.x,//NO I18N
                "y": leafletEvent.containerPoint.y,//NO I18N
                "data": global.util.getDataset().getMetaInfoObj(global.chartObj, seriesnumber.data, seriesnumber.seriesIndex)//NO I18N
            };
            invokeFunction(userCallback, leafletEvent.originalEvent, data, global.chartObj);
        }
    }
    
    function getMinDist(chartObj,marker) {  
        var type = chartObj.chartTypes[0].value;
        var value;
        switch(type)
        {
            case geoscatter : value = marker ? 20 : 10; //20 - size of markers
            break;
            case geobubblepie:
            case geobubble : 
            {
                value = chartObj.zscale.range()[1]/4;
            }
            break;
            case geopie : value = 35; // size of pie ;
            break;
            default:value = 10;
    }
        return  value ;
    }
    
    function getHighlightGroupElement(seriesNumber, svg, type,marker) {
        
       //for rendering new pie on mouse hover event
       if(type == geopie || type == geobubblepie)
       {
            }
        var highlightElement = svg.select('g.highlight-group').select('g');//NO I18N
        var seriesdata = global.util.getSeries();
        var series = seriesdata[seriesNumber.seriesIndex];
        var color = global.chartObj.seriesColor[seriesNumber.seriesIndex];
        var scale = global.util.getScale();
        var type = $ZC.DataProcessor.helpers.getChartType(series.type, "numeric");//NO I18N
        
        var hoverOptions = global.util.getHoverOptions($ZC.DataProcessor.helpers.getChartType(series.type, "string")),//NO I18N
            extraOptions = {
                "color" : color, // series color//NO I18N
                "width":2//NO I18N
            };
        
        switch (type) {
            case geobubblepie:
            case geopie:       
            {
                var basicAttr = global.util.getPlotOptions(global.chartObj.chartTypes[0].name);
                var fillOpacity = basicAttr.fillOpacity;
                basicAttr.animation.enabled = false;
                basicAttr.fillOpacity = 1;
                
                var commonRendererProp = {
                    params: {
                    chartObj: global.chartObj,
                    commonPlotOptions: basicAttr,
                    dataset: global.chartObj.dataset
                    }
                }
                
                var highlightElementPie = appendEle(highlightElement, "g", [1], ".", "class", "highlightScatter");//NO I18N
                var xVal = global.chartObj.dataset.getActualX(seriesNumber.data);
                var data;
                //to identify the selected pie
                global.chartObj.piedata[0].forEach(function(d)
                {
                    if(global.chartObj.dataset.getActualX(d[0]) == xVal)
                        data = d;
                })

                var size = scale ? scale(global.chartObj.mapObj.plotted_data[xVal].size) : 35;
                                var pieRenderer = svg_plot_renderer.pie()
                                  .commonRendererProp(commonRendererProp)
                                  .plotarea({
                                  width: size,
                                  height: size,
                                  left: size / 2,
                                  top: size / 2
                                });
                                highlightElementPie.datum(data);
                                highlightElementPie.call(pieRenderer);
                                highlightElementPie.selectAll("path").filter(function(d){return (d.startAngle === d.endAngle) || !d.endAngle ;}).each(function(){ d3.select(this).style("display","none","important") });//NO I18N
                                var translate = d3.transform(highlightElementPie.selectAll("g").attr("transform")).translate;//NO I18N
                                highlightElementPie.selectAll("g").attr("transform","translate("+ (translate[0] - size/2) + "," + (translate[1] - size/2) +")");//NO I18N
                
               //resetting the attributes;
               basicAttr.animation.enabled = true;
               basicAttr.fillOpacity = fillOpacity;
            }
            case geobubble:
            {
                extraOptions.symbolSize = {
                    "inner" : 0.5, // Percentage of inner marker size//NO I18N
                    "outer" : 1 // Percentage of outer marker size//NO I18N
                };

                var z = scale ? type == 22 ? scale(global.util.getDataset().getZ(seriesNumber.data)) :  scale(global.chartObj.mapObj.plotted_data[seriesNumber.data[0]].size) : 35;
                if((type == geopie || type == geobubblepie)){
                    z = z + 2 ;  
                }
                var hoverRing = 6;
                hoverOptions.size = (z + hoverRing) / 10;
                addSVGmarker(highlightElement, null, hoverOptions, extraOptions);
                
            }
                break;
            case geoscatter:
            {
                extraOptions.symbolSize = {
                    "inner" : 1, // Percentage of inner marker size//NO I18N
                    "outer" : 2 // Percentage of outer marker size//NO I18N
                };
                marker && marker != "default" ? addCustomMarker(highlightElement, extraOptions,marker,true) : addSVGmarker(highlightElement, null, hoverOptions, extraOptions);//No I18N
            }
                break;
        }
        return highlightElement;
    }
    
    function findSelectedPoint(series, mouseEvent, minDistForHighlight,marker,global,curntId)
    {
        var chartType = global.chartObj.chartTypes[0].value;
        var result = null;
        var dataset = global.dataset;
        var scale = global.util.getScale();
        var minDist,minCircum,nearBubble,isWithinCurrentbubble,circumference,point,pointInBubble=false;        
        if (!minDistForHighlight) {
            minDistForHighlight = 0;
        }
        var filterSeries = function(subgroup, subGroupIndex) {
            var filteredSubgroup = new Array();
            if (subgroup && subgroup.constructor == Array) {
                filteredSubgroup = subgroup.filter(function(data, itemPos) {
                point = false;
                var latLng,id;
                chartType != geofilled ?  latLng = dataset.getLatLng(data) : id = dataset.getId(data) ;
                var mousePoint = global.leafletMapObj.latLngToContainerPoint(mouseEvent.latlng);
                if(latLng && data[1])
                {
                   var curntPoint = global.leafletMapObj.latLngToContainerPoint(latLng);
                   curntPoint.y =  marker && marker != "default" ? curntPoint.y - 16 : curntPoint.y;//No I18N
                   curntPoint.x =  marker && marker == "Type5" ? curntPoint.x + 8 : curntPoint.x;//No I18N
                   var distance = mathSQRT(mathPow(curntPoint.x - mousePoint.x, 2) + mathPow(curntPoint.y - mousePoint.y, 2));
                }
                if((latLng || id) &&  data[1])
                {
                   switch(chartType)
                    {
                           case geoscatter:
                                            point = nearestPoint(distance,data,subGroupIndex,itemPos,latLng);
                                            break;
                           case geobubblepie:
                           case geobubble:
                           {
                               var xVal = dataset.getActualX(data);
                               var radius = (chartType == geobubblepie ? scale(global.chartObj.mapObj.plotted_data[xVal].size) : global.util.getScale()(dataset.getZ(data)))/2;
                               if(nearestBubble(distance,radius))    
                               {
                                    if(chartType == geobubblepie ? findAngleInPie(mousePoint,curntPoint,i,data) : true)
                                      setMeasures(distance);
                               }
                           }
                           break;
                           case geofilled:
                               point = id === curntId;
                           break;
                           case geopie:
                               point = findAngleInPie(mousePoint,curntPoint,i,data) ? nearestPoint(distance,data,subGroupIndex,itemPos,latLng) :  false;
                           break;
                    }
                   if(point)
                   {
                       result={
                                  seriesIndex: i,
                                  subGroupIndex: subGroupIndex,
                                  itemPos: itemPos,
                                  data: data,
                                  latLng:latLng
                              }
                  }
                  
                }
              });
            }
            return filteredSubgroup.length > 0;
        };
        
        if (series && series.constructor == Array) {
            for (var i = series.length - 1; i >=0 ; i--) {
                if (!series[i].disabled) {
                    var filteredSeries = series[i].data.filter(filterSeries);
                    if(chartType == geoscatter || chartType == geofilled)
                    {
                        if(result != null)
                            break;
                }
            }
        }
        }
        return result !== null ? result : null;
        
        function findAngleInPie(mousePoint,curntPoint,seriespos,d)
        {
             var X = global.dataset.getX(d);
             var pieRenderer = global.chartObj.renderedPiedata[X];
             var pieData = pieRenderer[seriespos];
             var theta1 = pieData.startAngle,
                 theta2 = pieData.endAngle,
                    angle = mathAtan2((mousePoint.x - curntPoint.x), -(mousePoint.y - curntPoint.y));
            return isAngleInside(theta1, theta2, angle);
        }
        function nearestBubble(distance,radius)
        {
            circumference = 2 * mathPI * radius;
            isWithinCurrentbubble = (distance <= radius);
            isWithinCurrentbubble ? pointInBubble = true : distance = distance - radius;
            nearBubble =(minDist ? distance < minDist : true &&  distance < minDistForHighlight) ;
            return isWithinCurrentbubble ? minCircum ? circumference < minCircum : true :pointInBubble ? false : nearBubble ;
    }
        function nearestPoint(dist)
        {
            if (dist <= minDistForHighlight && (minDist ? dist <= minDist  : true)) {
                minDist = dist;
                minDistForHighlight = mathAbs(dist - minDistForHighlight);
                return true;
            }
            return false;
        }
        function setMeasures(distance)
        {
            minDistForHighlight = distance;
            minDist = nearBubble ? distance : minDist;
            minCircum = isWithinCurrentbubble ? circumference : minCircum;
            point = true;
        }
    }
        
};

function enableToolTip(global,event,seriesnumber,dataset,tooltipObject)
{
    d3.event = event.originalEvent;
    var containerPoint = d3.mouse(global.chartObj.container.node());

    var tooltipPosition = {
        left: containerPoint[0],
        top: containerPoint[1]
        }
        
    var dLeft = containerPoint[0] - event.originalEvent.clientX,
    dTop = containerPoint[1] - event.originalEvent.clientY;                       
    tooltipPosition.left -= dLeft;                       
    tooltipPosition.top -= dTop;                       
    tooltipPosition.dLeft = dLeft; 
    tooltipPosition.dTop = dTop; 

    var tooltipArguments = {
        "dataset": dataset,//NO I18N
        "seriesindex": seriesnumber.seriesIndex,//NO I18N
        "subseriespos": seriesnumber.subGroupIndex,//NO I18N
        "itempos": seriesnumber.itemPos,//NO I18N
        "color": global.chartObj.seriesColor //NO I18N
    }
    tooltipObject.show(global.chartObj, tooltipPosition, null, true, tooltipArguments);
}
//$Id$
//shortdash, shortdot, shortdashdotdot, dotted, dashed, longdash, dashdot, longdashdot, longdashdotdot
var dashStyles = {
    "solid": "",
    "shortdash": "1.5,1.5",
    "shortdot": "0.1,1.5",
    "dashed": "2.5,2.5",
    "longdash": "5,5",
    "dotted": "0.1,2.5",
    "shortdashdotdot": "1.5,2,0.1,2,0.1,2",
    "dashdot": "2.5,2.5,0.1,2.5",
    "longdashdot": "5,5,0.1,5",
    "longdashdotdot": "5,2.5,0.1,2.5,0.1,2.5"
};

function getDashArray(dashStyleName, strokeWidth, scaleRatio) {

    var inList = defined(dashStyles[dashStyleName]),
        dashStyle = pick(dashStyles[dashStyleName], dashStyleName, null);

    if (!defined(dashStyle) || dashStyleName === "solid") {
        return [];
    }

    strokeWidth = inList ? pick(strokeWidth, 1) : 1;
    if (scaleRatio) {
        strokeWidth *= scaleRatio;
    }

    return dashStyle.split(",").map(function(e) {
        return +e * strokeWidth;
    });
}

function getLineCap(lineCap, dashStyle) {
    return lineCap || ((dashStyle && /dot/g.test(dashStyle)) ? "round" : null);
}

function applyMarquee(element, dur, strokeDashArray, chart) {
    var dashoffset = strokeDashArray.reduce(function(prev, current) {
        return current + prev;
    }, 0);
    
    element
        .attr("stroke-dasharray", strokeDashArray)
        .attr('stroke-dashoffset', dashoffset)
        .transition().duration(dur).ease("linear")
        .attr('stroke-dashoffset', 0)
        .each('end', function() {
            if (chart && chart.chartRendered) {
                applyMarquee(element, dur, strokeDashArray, chart);
            }
        });
}//$Id$
var effects = function(){};


effects.get = function(module, submodule, properties, args) {
    args = args || {};
    var offset = args.offset,
        dimension = args.dimension,
        returnSVGimage = args.returnSVGimage,
        base64 = args.base64,
        chartObj = args.chartObj;
    if (!((submodule != null || submodule != "") && module[submodule])) {
        return;
    }
    
    /* Generate PatternID and check the pattern if already generated with the PatternID
     * If already exist return the patternID to apply
     * else create new pattern and return patternID.
     * */
    var effectID = "zp" + generateIdByPropValue(properties, submodule);
    
    if (effectID == null) {
        return;
    }
    if ($ZC[effectID] != null) {
        var effectEle = $ZC[effectID];
        if(returnSVGimage){
            return effectEle;
        }
        return effectEle.id || effectEle;
    }
    var effectEle = module[submodule](properties, effectID, offset, returnSVGimage, base64, chartObj);
    if(effectEle){
        $ZC[effectID] = effectEle;
        if(returnSVGimage){
            return effectEle;
        }
        return effectEle.id || effectEle;//for filters returns id, for patterns returns element. Need to make it common
    }
    
}

function getChartEffects(systemconf) {
    var effectName = systemconf.chart.effects.choice;
    var effect = svg_filters[effectName];
    if (!effect) {
        return;
    }
    var properties = systemconf.chart.effects.options[effectName];
    if (effectName === "dropShadow") {
        properties.blur = mathMax(0, properties.blur);
    }
    var effectID = effects.get(svg_filters,effectName, properties);
    return effectID;
}

function getGradientProp(gradient,dimension,color,opacity){
    var type = gradient.type;
    if (!type || type === "none") {
        return;
    }
    var options = gradient.options[type] || gradient.options;
    var prop = simpleClone(options);
    prop.color = (color != null) ? color : prop.color;
    prop.opacity =  (opacity != null) ? opacity : prop.opacity;
    prop.dimension = (dimension != null) ? dimension : prop.dimension;
    prop.type = type;
    // prop.defsLocation = chartObj ? chartObj.defsLocation : "";
    return prop;
}

function getPatternProp(pattern,baseClr,opacity,customPatternDim){
    var prop = patternThemes[pattern] ? patternThemes[pattern] : addPatternThemeByEle(pattern);
        prop.bgClr_base = baseClr;
        prop.stroke_base = baseClr;
        prop.fillOpacity = prop.fillOpacity || opacity;
    if(customPatternDim){
        prop.x = customPatternDim.x,
        prop.y = customPatternDim.y,
        prop.width = customPatternDim.width,
        prop.height = customPatternDim.height;
    }
    return prop;
}
function getPatternSize(properties, size){
    var patternSize = size.map(function(d,i){
        var s = parseInt(d);
        var rem = properties.width % s;
        var quo = parseInt(properties.width / s);
        var partial  = rem / quo;
        return partial+s;
    })
    return patternSize;
}

//$Id$
$ZC.patternutil = function() {};
var patternThemes = {};

$ZC.addPattern = function(name,type,size,strokeWidth,strokeClr,bgClr,fillOpacity,strokeOpacity,translate){
	patternThemes[name] = {
		"type" : type || "diagonal-line-right",
		"size" : size || 5,
		"strokeWidth" : strokeWidth || 1,
		"bgClr" : bgClr,
		"stroke" : strokeClr,
		"fillOpacity" : fillOpacity || 1,
		"strokeOpacity" : strokeOpacity || 1,
		"translate" : translate
	} 
}
$ZC.getPattern = function(name){
	return {
		"type" : patternThemes[name].type,
		"size" : patternThemes[name].size,
		"strokeWidth" : patternThemes[name].strokeWidth,
		"bgClr" : patternThemes[name].bgClr,
		"stroke" : patternThemes[name].stroke,
		"fillOpacity" : patternThemes[name].fillOpacity,
		"strokeOpacity" : patternThemes[name].strokeOpacity,
		"translate" : patternThemes[name].translate
	}
}
function generateDefaultPatternTheme(){

	$ZC.addPattern("hatch",   "diagonal-line-right",   "5",   "1",   "null",      "white",   "1",   "1");
	$ZC.addPattern("hatchDash",   "square,diagonal-line-right",   "5,5",   "1",   "transparent,{{brighter}}",   "transparent,transparent",   "1",   "1",   "0,3");
	$ZC.addPattern("thinThickHatch",   "square,diagonal-line-right,diagonal-line-right",   "10,10,10",   "1,1,3",   "transparent,null,null",   "transparent",   "1",   "1",   "0,2.5,0");
	$ZC.addPattern("thickHatch",   "diagonal-line-right",   "5",   "3",   "null",      "white",   "1",   "1");
	$ZC.addPattern("thinHatch",   "diagonal-line-right",   "2",   "1",   "null",      "white",   "1",   "1");
	$ZC.addPattern("hatchLeft",   "diagonal-line-left",   "5",   "1",   "null",      "white",   "1",   "1");
	$ZC.addPattern("horizontalStripes",   "horizontal-line",   "5",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("thinHorizontalStripes",   "horizontal-line",   "2",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("verticalStripes",   "vertical-line",   "5",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("thinVerticalStripes",   "vertical-line",   "2",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("crossStripes",   "vertical-line,horizontal-line",  "5",   "1",   "null",   "white",    "1",   "1");

	$ZC.addPattern("tinyHatchfill",   "square,diagonal-line-right",   "5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("hatchfill",   "square,diagonal-line-right",   "10",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("hatchDashfill",   "square,diagonal-line-right",   "5,5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1",   "0,3");
	$ZC.addPattern("hatchLeftfill",   "square,diagonal-line-left",   "5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("horizontalStripesfill",   "square,horizontal-line",   "5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("verticalStripesfill",   "square,vertical-line",   "5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("crossStripesfill",   "square,square",  "5,5",   "1",   "transparent,{{brighter}}",   "null,transparent",    "1",   "1");
	$ZC.addPattern("checkerBoard",   "square,square,square",  "10,5,5",   "1",   "transparent",   "transparent,null,{{brighter}}",    "1",   "1",   "0,0,5");


	$ZC.addPattern("circle",   "circle",   "10",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("tinyCircle",   "circle",   "5",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("crossCircle",   "square,circle,circle",   "10,5,5",   "1",      "transparent,null,{{brighter}}",   "transparent",   "1",   "1",   "0,0,5");
	$ZC.addPattern("floatingCircle",   "square,circle",   "10,5",   "1",      "transparent,{{brighter}}",   "transparent",   "1",   "1",   "0,2.5");
	$ZC.addPattern("dot",   "square,circle",   "5,2.5",   "1",      "transparent,{{brighter}}",   "transparent,transparent",   "1",   "1",   "0,1.25");
	$ZC.addPattern("dotSquare",   "square,circle",   "10,2.5",   "1",      "null,{{brighter}}",   "transparent,transparent",   "1",   "1",   "0,3.75");

	$ZC.addPattern("circlefill",   "square,circle",   "10,10",   "1",      "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	$ZC.addPattern("crossCirclefill",   "square,circle,circle",   "10,5,5",   "1",      "transparent,null,{{brighter}}",   "null,{{brighter}},null",   "1",   "1",   "0,0,5");
	$ZC.addPattern("floatingCirclefill",   "square,circle",   "10,5",   "1",      "transparent,{{brighter}}",   "null,transparent",   "1",   "1",   "0,2.5");
	$ZC.addPattern("dotfill",   "square,circle",   "5,2.5",   "1",      "transparent,{{brighter}}",   "null,transparent",   "1",   "1",   "0,1.25");


	$ZC.addPattern("square",   "square",   "5",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("squarefill",   "square",   "5",   "1",      "{{brighter}}",   "null",      "1",   "1");

	$ZC.addPattern("star",   "star",   "10",   "1",   "null",   "white",   "1",   "1");
	$ZC.addPattern("starfill",   "square,star",   "10,5",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
	
	$ZC.addPattern("wave",   "waves",  "5",   "1",   "null",   "white",    "1",   "1");
	$ZC.addPattern("wavefill",   "square,waves",   "10,10",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");

	$ZC.addPattern("cap",   "caps",  "5",   "1",   "null",   "white",    "1",   "1");
	$ZC.addPattern("capfill",   "square,caps",   "10,10",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");

	$ZC.addPattern("nylon",   "nylon",  "5",   "1",   "null",   "white",    "1",   "1");
	$ZC.addPattern("nylonfill",   "square,nylon",   "10,10",   "1",   "transparent,{{brighter}}",   "null,transparent",   "1",   "1");
}

function addPatternThemeByEle(ele){
	return {"ele" : ele};
}

//$Id$
var svg_patterns = function() {};

svg_patterns.imageFill = function(properties, patternID) {
    var w = properties.width,
        h = properties.height,
        svg = $ZCG.patternSVG;
    svg.select("defs").append("pattern")
        .attr({
            "patternUnits": "userSpaceOnUse",
            "id": patternID,
            "width": w,
            "height": h,
            "x": properties.x || 0,
            "y": properties.y || 0
        })
        .append('image')
        .attr({
            "xlink:href": properties.name,
            "x": 0,
            "y": 0,
            "width": w,
            "height": h
        });
    
    return patternID;
}


svg_patterns.svgPatternFill = function(properties, patternID, returnSVGimage, base64, patternUnits) {
    var patternEle;

    if(properties.ele != null){
       patternEle =  generateSVGPatternByHTML(properties.ele,properties,patternID,patternUnits);
    }else{
       patternEle =  generateSVGPatternByProp(properties,patternID,patternUnits);
    }

    if (returnSVGimage) {
        var xml = "<svg xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' width='" + patternEle.w + "' height='" + patternEle.h + "'>" + new XMLSerializer().serializeToString(patternEle.node.node()) + "<path d='" + getSVGsymbol("square")(mathMin(patternEle.w, patternEle.h)) + "' transform='translate(" + (patternEle.w / 2) + "," + (patternEle.h / 2) + ")' style='fill: " + "url(#" + patternEle.id + ")'></path> </svg>";
        return {
            url :  ($Browser.FIREFOX || base64) ? ('data:image/svg+xml;base64,' + btoa(xml)) : ('data:image/svg+xml;utf8,' + xml),
            width : patternEle.w,
            height : patternEle.h,
            id :patternEle.id
        };
    }

    return patternEle;
}


function generateSVGPatternByHTML(ele,properties,patternID,patternUnits){
    var pattern_svg = $ZCG.patternSVG;
    var bgClr = properties.bgClr || properties.bgClr_base;
    var customele = invokeFunction(ele, bgClr);
    
    properties.ele = customele.replace(/\{\{clr\}\}/g, bgClr);

    var patternNode = pattern_svg.select("defs").append("pattern")
        .attr({
            "patternUnits": patternUnits || "userSpaceOnUse",
            "id": patternID,
            "x": properties.x || 0,
            "y": properties.y || 0
        })
        .html(properties.ele);

    var bb;
    if ($Browser.FIREFOX) {
        pattern_svg.append("g").html(properties.ele).each(function() {
            bb = bbox(this);
        }).remove()
    } else {
        bb = bbox(patternNode.node().firstChild);
    }

    var w = bb.width,
        h = bb.height;
    patternNode
        .attr({
            "width" : w,
            "height" : h
        });

    return {"node" : patternNode, "w":w, "h":h, "id":patternID};
}
function generateSVGPatternByProp(properties,patternID,patternUnits){
    var pattern_svg = $ZCG.patternSVG;
    var bgClr_base = properties.bgClr || properties.bgClr_base, 
        stroke_base = properties.stroke || properties.stroke_base;
    var regExp = /\{\{([a-z]+)\}\}/;

    var symbolTypes = (properties.type || "").split(","),
        noOfSymbols = symbolTypes.length,
        size = (properties.size || "").split(","),
        strokeWidth = (properties.strokeWidth || "").split(","),
        fillColor = bgClr_base.split(","),
        stroke = stroke_base.split(","),
        fillOpacity = (properties.fillOpacity || "").split(","),
        strokeOpacity = (properties.strokeOpacity || "").split(",")
        translate = properties.translate ? properties.translate.split(",") : null;
        size = properties.width ? getPatternSize(properties,size) : size;

    var patternNode = pattern_svg.select("defs")
        .append("pattern")
        .attr({
            'id': patternID,
            'patternUnits': patternUnits || 'userSpaceOnUse',
            'width': size[0],
            'height': size[0],
            'x' : properties.x || 0,
            'y' : properties.y || 0
        });
    
    for(var i=0; i<noOfSymbols; i++){
        var pattern_path = getSVGsymbol(symbolTypes[i])((size[i] || size[0])),
            stroke_cur = isNull(stroke[i] || stroke[0]) ?  properties.stroke_base : (stroke[i] || stroke[0]),
            fill_cur = isNull(fillColor[i] || fillColor[0]) ?  properties.bgClr_base : (fillColor[i] || fillColor[0]);
            stroke_cur = (regExp.test(stroke_cur)) ? getColorCopy(properties.stroke_base, 1, stroke_cur.replace(regExp, '$1') ,d3_hsl) : stroke_cur;
            fill_cur = (regExp.test(fill_cur)) ? getColorCopy(properties.bgClr_base, 1, fill_cur.replace(regExp, '$1') ,d3_hsl) : fill_cur;
            trans_cur = (size[i] || size[0]) / 2;
            if(translate){
                var subTranslate = translate[i] || translate[0];
                trans_cur += parseFloat(subTranslate);
            }
                
        patternNode
        .append('path')
        .attr({
            'transform': 'translate(' + trans_cur + ',' + trans_cur + ')',
            'd': pattern_path,
            'stroke': stroke_cur,
            'fill' : fill_cur,            
            'stroke-width': strokeWidth[i] || strokeWidth[0],
            'stroke-opacity': strokeOpacity[i] || strokeOpacity[0],
            'fill-opacity' : fillOpacity[i] || fillOpacity[0]
        });
    }
    

    return {"node" : patternNode, "w":size[0], "h":size[0], "id":patternID};
}

function getSVGImage(patternEle,base64){
    var xml = "<svg xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' width='" + patternEle.w + "' height='" + patternEle.h + "'>" + new XMLSerializer().serializeToString(patternEle.node.node()) + "<path d='" + "M-5,-5 L5,-5 L5,5 L-5,5 Z" + "' transform='translate(" + (patternEle.w / 2) + "," + (patternEle.h / 2) + ")' style='fill: " + "url(#" + patternEle.id + ")'></path> </svg>";
    return {
        url :  ($Browser.FIREFOX || base64) ? ('data:image/svg+xml;base64,' + btoa(xml)) : ('data:image/svg+xml;utf8,' + xml),
        width : patternEle.w,
        height : patternEle.h
    };
}
//$Id$
var svg_gradients = function(){};

svg_gradients.get = function(gradient, color, dimension, offset, chartObj, defaultOpacity) {
    /**
     * @param chartObj (optional)
     * @param defaultOpacity (optional) // for canvas.
     */
    
    var gradientTypeName = gradient.type;
    if (!gradientTypeName || gradientTypeName === "none") {
        return;
    }
    var mode = chartObj ? chartObj.plot.renderer.mode : "svg";
    
    var properties = gradient.options[gradientTypeName] || gradient.options;
    var propObj = simpleClone(properties);
    propObj.color = (color != null) ? color : propObj.color;
    propObj.dimension = (dimension != null) ? dimension : propObj.dimension;
    propObj.defsLocation = chartObj ? chartObj.defsLocation : "";
    propObj.id = chartObj.id;
    switch (mode) {
        case "canvas": {
            propObj.pointOpacity = defaultOpacity || 1;
            return canvasGradient.create(chartObj.context, gradientTypeName, propObj, offset);
            break;
        }
        default: {
            return effects.get(svg_gradients,gradientTypeName, propObj, {"offset":offset});
            break;
        }
    }
};
svg_gradients.svgGradientFill = function(properties, gradientID, offset, returnSVGimage, base64, chartObj){
        return (properties && properties.type) ? svg_gradients[properties.type](properties, gradientID, offset, returnSVGimage, base64, chartObj) : null;
}
svg_gradients.radial = function(properties, gradientID, type, returnSVGimage, base64, chartObj) {
    var svg = $ZCG.patternSVG,
        color = properties.color,
        dimension = properties.dimension,
        spread = properties.spreadMethod;
    var x = (dimension[0] / 100 * (+properties.x || 0)),
        y = (dimension[0] / 100 * (+properties.y || 0)),
        radius = ((spread === "repeat" || spread === "reflect") && ($Browser.IS_IOS || $Browser.SAFARI)) ? dimension[0] : (dimension[0] / 100 * (+properties.radius));
    var gradient = svg.select("defs").append("radialGradient")
        .attr({
            "id": gradientID,
            "gradientUnits": "userSpaceOnUse",
            "spreadMethod": spread,
            "cx": x + "px",
            "cy": y + "px",
            "r": radius + "px"
        });
    addStop(gradient, properties, color, "radial");
    return gradientID;
};
svg_gradients.linear = function(properties, gradientID, type, returnSVGimage, base64, chartObj) {
    var svg = $ZCG.patternSVG,
        color = properties.color,
        dimension = properties.dimension,
        spread = properties.spreadMethod,
        x1 = (+properties.x1 || 0),
        x2 = (+properties.x2 || 0),
        y1 = (+properties.y1 || 0),
        y2 = (+properties.y2 || 0);
    var dim = (spread === "repeat" || spread === "reflect") && ($Browser.IS_IOS || $Browser.SAFARI) ?
        mathMax(mathAbs(x2 - x1), mathAbs(y2 - y1)) :
        100;
    var min = (/(pie|dial|bubblepie|web)/.test(type)) ? (-dimension[0]) : 0;
    var xscale = d3_scaleLinear().domain([0, 100]).range([min, dimension[0]]),
        yscale = d3_scaleLinear().domain([0, 100]).range([min, dimension[1]]);
    x1 = x1 * 100 / dim,
        x2 = x2 * 100 / dim,
        y1 = y1 * 100 / dim,
        y2 = y2 * 100 / dim;
    var gradient = svg.select("defs").append("linearGradient")
        .attr({
            "id": gradientID,
            "gradientUnits": properties.gradientUnits,
            "spreadMethod": spread
        });
    if (properties.gradientUnits == "userSpaceOnUse") {
        gradient.attr({
            "x1": xscale(x1) + "px",
            "x2": xscale(x2) + "px",
            "y1": yscale(y1) + "px",
            "y2": yscale(y2) + "px"
        });
    } else {
        gradient.attr({
            "x1": x1 + "%",
            "x2": x2 + "%",
            "y1": y1 + "%",
            "y2": y2 + "%"
        });
    }
    addStop(gradient, properties, color, "linear");
    return gradientID;
};

svg_gradients.thresholdLinear = function(properties, gradientID, offset) {
    var svg = $ZCG.patternSVG;
    var gradient = svg.select("defs").append("linearGradient")
        .attr({
            "id": gradientID,
            "gradientUnits": "userSpaceOnUse",
            "x1": properties.x1,
            "x2": properties.x2,
            "y1": properties.y1,
            "y2": properties.y2
        });
    var stop = gradient.selectAll("stop").data(offset);
    
    var stopEnter = stop.enter().append("stop")
        .attr("offset", function(d) {
            return d.offset;
        })
        .attr("stop-color", function(d) {
            return d.color;
        });
    var stopUpdate = stop.attr("offset", function(d) {
            return d.offset;
        })
        .attr("stop-color", function(d) {
            return d.color;
        });
    stop.exit().remove();
    return gradientID;
}

function addStop(gradient, properties, color, type) {
    "use strict";
    var stops = getStops(gradient, properties, color, type);
    for (var i = 0; i < stops.offset.length; i++) {
        gradient.append("stop")
            .attr("offset", stops.offset[i])
            .style({
                "stop-color": stops.color[i],
                "stop-opacity": stops.opacity[i]
            });
    }
};

function getStops(gradient, properties, color, type) {
    "use strict";
    var stopoffset = properties.stopOffset,
        stopopacity = properties.stopOpacity,
        stopcolor = properties.stopColor,
        colorgamma = properties.colorGamma || [1, 0],
        spread = properties.spreadMethod,
        radius = (type == "radial") ? (+properties.radius) : mathMax(mathAbs((+properties.x2 || 0) - (+properties.x1 || 0)), mathAbs((+properties.y2 || 0) - (+properties.y1 || 0)));
    stopoffset = stopoffset || ["0%", "100%"];
    stopcolor = ((typeof stopcolor === "function") ? stopcolor(color) : stopcolor) || stopoffset.map(function(d, i) {
            return getColorCopy(color, (colorgamma[i] || 0), "brighter", d3_hsl);
        });
    stopopacity = stopopacity || [1, 1];
    
    if ((spread === "repeat" || spread === "reflect") && ($Browser.IS_IOS || $Browser.SAFARI)) {
        var newStopoffset = [],
            newStopColor = [],
            newStopOpacity = [],
            step = 0,
            repeat = 0;
        while (step < 100) {
            for (var i = 0, len = stopoffset.length; i < len; i++) {
                newStopoffset.push(((parseFloat(stopoffset[i]) / 100 * radius) + step) + "%");
                newStopOpacity.push(((repeat % 2) != 0) ? stopopacity[stopopacity.length - 1 - i] : stopopacity[i]);
                newStopColor.push(((repeat % 2) != 0) ? stopcolor[stopcolor.length - 1 - i] : stopcolor[i]);
            }
            step += radius;
            repeat += ((spread === "reflect") ? 1 : 0);
        }
        stopoffset = newStopoffset;
        stopcolor = newStopColor;
        stopopacity = newStopOpacity;
    }
    return {
        "offset": stopoffset,
        "color": stopcolor,
        "opacity": stopopacity
    }
};//$Id$
var svg_filters = function(){};

svg_filters.chalk = function(properties, filterID) {
    var svg = $ZCG.patternSVG;
    var filter = svg.select('defs')
        .append('filter')
        .attr({
            'id': filterID,
            'x': -0.3,
            'y': -0.5,
            'height': 2,
            'width': 1.6,
            'color-interpolation-filters': "sRGB"
        });
    filter.append('feTurbulence')
        .attr({
            'baseFrequency': 0.32065,
            'seed': 115,
            'result': 'result1',
            'numOctaves': 1,
            'type': 'turbulence'
        });
    
    filter.append('feOffset')
        .attr({
            'result': 'result2',
            'dx': -2,
            'dy': -2
        });
    
    filter.append('feDisplacementMap')
        .attr({
            'scale': 5,
            'yChannelSelector': "G",
            'in2': "result1",
            'xChannelSelector': "R",
            'in': "SourceGraphic"
        });
    
    return filterID;
}

svg_filters.dropShadow = function(properties, filterID) {
    
    var svg = $ZCG.patternSVG;
    var filter = svg.select('defs').append("filter")
        .attr({
            "x": properties.x,
            "y": properties.y,
            "width": properties.width,
            "height": properties.height,
            "id": filterID,
            "filterUnits": properties.filterUnits
        });
    
    filter.append("feGaussianBlur")
        .attr({
            "in": properties.source || "SourceAlpha",
            "stdDeviation": properties.blur
        });
    
    if (properties.source !== "SourceGraphic") {
        filter.append("feOffset")
            .attr({
                "dx": properties.dx,
                "dy": properties.dy,
                "result": "offsetblur"
            });
        
        var floodColor = properties.color,
            floodOpacity = null;
        var rgba = floodColor.match(RGBA_PATTERN); //#ZC910 SAFARI dont consider alpha in rgba color
        if (rgba && rgba.length === 5) {
            floodColor = rgb2hex(floodColor);
            floodOpacity = rgba[4];
        }

        var feFlood = filter.append("feFlood");
        feFlood
            .attr({
                "flood-color": floodColor,
                "flood-opacity": floodOpacity
            });
        
        filter.append("feComposite")
            .attr({
                "in2": "offsetblur",
                "operator": "in"
            });
        
        var feMerge = filter.append("feMerge");
        
        feMerge.append("feMergeNode");
        feMerge.append("feMergeNode")
            .attr("in", "SourceGraphic");
    }
    return filterID;
}

svg_filters.colorMatrix = function(properties, filterID) {
    var svg = $ZCG.patternSVG;
    var filter = svg.select('defs').append("filter")
        .attr("id", filterID)
    
    var feGaussianBlur = filter.append("feColorMatrix")
        .attr({
            "in": "SourceGraphic",
            "type": properties.type,
            "values": properties.values
        });
    return filterID;
};

svg_filters.freeHand = function(properties, filterID) {
    var svg = $ZCG.patternSVG;
    var scale = (properties.scale == null) ? 7 : properties.scale;
    
    var filter = svg.select('defs').append("filter")
        .attr("id", filterID)
    
    var feTurbulence = filter.append("feTurbulence")
        .attr({
            "type": "fractalNoise",
            "baseFrequency": 0.015,
            "numOctaves": 2,
            "result": "turbulence_3",
            "data-filterId": 3
        });
    
    var feDisplacementMap = filter.append("feDisplacementMap")
        .attr({
            "xChannelSelector": "R",
            "yChannelSelector": "G",
            "in": "SourceGraphic",
            "in2": "turbulence_3",
            "scale": properties.scale
        });
    return filterID;
}
//$Id$
var svg_masks = function(){};

svg_masks.tenbytenGrid = function(properties, maskID){
	var pattern_svg = $ZCG.patternSVG;
	var maskNode = pattern_svg.select("defs")
        .append("mask")
        .attr({
            'id': maskID,
            'maskUnits': 'userSpaceOnUse',
            'width': properties.width,
            'height': properties.height,
			'x':properties.x,
			'y':properties.y
        });
    var poly = maskNode.append("polygon")
    				.attr("points", getPolyPoints(properties.x, properties.y, properties.type, properties.percent, properties.size, properties.width))
    				.style({
    					"fill" : properties.fillColor
    				});
	return maskID;
}

function getPolyPoints(x,y, type, percent, cellSize, totalSize){
	var quo = (parseInt(percent / 10)) * cellSize,
		rem = percent % 10;
	var start1X = x, start1Y = (rem == 0) ? ((totalSize - quo)+y) : ((totalSize - (quo + cellSize))+y),
		mid1X = (rem * cellSize)+x, mid1Y = start1Y,
		mid2X = mid1X , mid2Y = (rem == 0) ? start1Y : start1Y+cellSize,
		end1X = totalSize+x, end1Y = mid2Y,
		end2X, end2Y, start2X, start2Y;


		
	switch(type) {
		case 'top2Bottom' :
			end2X = totalSize+x, end2Y = y, 
			start2X = x, start2Y = y;
			break;
		case 'bottom2Top' :
			end2X = totalSize+x, end2Y = totalSize+y, 
			start2X = x, start2Y = totalSize+y;
			break;
	}

	var points = start1X + "," + start1Y + " " + 
				 mid1X + "," + mid1Y + " " + 
				 mid2X + "," + mid2Y + " " + 
				 end1X + "," + end1Y + " " + 
				 end2X + "," + end2Y + " " + 
				 start2X + "," + start2Y + " " + 
				 start1X + "," + start1Y;

    return points;

}

//$Id$
var svg_clips = function(){};

svg_clips.polygon = function(properties, clipID, offset, returnSVGimage, base64, chartObj) {
    var svg = $Browser.SAFARI ? chartObj.svg : $ZCG.patternSVG; //Element order is important in safari. If the clipPath is appended on $ZCG.patternSVG, transition is not working properly
    svg.select("defs").append("clipPath")
        .attr("id", clipID)
        .append('path')
        .attr("d", properties.d);
    return clipID;
};

svg_clips.rect = function(properties, clipID, offset, returnSVGimage, base64, chartObj) {
    var svg = $Browser.SAFARI ? chartObj.svg : $ZCG.patternSVG; //Element order is important in safari. If the clipPath is appended on $ZCG.patternSVG, transition is not working properly
    svg.select("defs").append("clipPath")
        .attr("id", clipID)
        .append('rect')
        .attr({
            "x": properties.x,
            "y": properties.y,
            "width": properties.width,
            "height": properties.height
        });
    return clipID;
};
//$Id$
function getSVGsymbol(type) {
    return function(size) {
        switch (type) {
            case "asterisk":
                return "M0 0 C" + (-size * 0.284) + " " + (-size * 0.994) + " " + (size * 0.284) + " " + (-size * 0.994) + " 0 0 C" + (size * 0.73) + " " + (-size * 0.76) + " " + (size * 1.2) + " " + (-size * 0.277) + " 0 0 C" + (size * 1.008) + " " + (size * 0.142) + " " + (size * 0.703) + " " + (size * 0.703) + " 0 0 C" + (size * 0.27) + " " + (size * 0.923) + " " + (-size * 0.284) + " " + (size * 0.923) + " 0 0 C" + (-size * 0.712) + " " + (size * 0.66) + " " + (-size * 0.923) + " " + (size * 0.234) + " 0 0 C" + (-size * 0.98) + " " + (-size * 0.284) + " " + (-size * 0.745) + " " + (-size * 0.73) + " 0 0";
            case "bean":
                return "M0 " + (size * 0.5) + " A" + (size * 0.25) + " " + (size * 0.5) + " 0 0 1 0 " + (-size * 0.5) + " A" + (size * 0.15) + " " + (size * 0.25) + " 0 0 1 1 0 A" + (size * 0.15) + " " + (size * 0.25) + " 0 0 1 0 " + (size * 0.5) + "";
            case "butterfly":
                return "M0 " + (-size * 0.25) + " C0 " + (-size * 0.25) + " " + (size) + " " + (-size) + " " + (size * 0.3) + " " + (size * 0.25) + " " + (size * 0.6) + " " + (size * 0.8) + " 0 " + (size * 0.4) + " 0 " + (size * 0.4) + " M0 " + (-size * 0.25) + " C0 " + (-size * 0.25) + " " + (-size) + " " + (-size) + " " + (-size * 0.3) + " " + (size * 0.25) + " " + (-size * 0.6) + " " + (size * 0.8) + " 0 " + (size * 0.4) + " 0 " + (size * 0.4) + " M0 " + (-size * 0.25) + " L" + (size * 0.1) + " " + (-size * 0.7) + " M0 " + (-size * 0.25) + " L" + (-size * 0.1) + " " + (-size * 0.7) + "";
            case "clover":
                return "M0 0 C" + (-size * 0.2) + " " + (-size) + " " + (size) + " " + (-size * 0.15) + " 0 0 " + (size) + " " + (size * 0.25) + " " + (-size * 0.2) + " " + (size) + " " + (-size * 0.05) + " " + (size * 0.05) + " " + (-size * 0.7) + " " + (size * 0.6) + " " + (-size * 0.7) + " " + (-size * 0.6) + " 0 " + (-size * 0.05) + " Z";
            case "cloverFour":
                return "M" + (-size * 0.1) + " " + (-size * 0.1) + " C" + (-size * 0.5) + " " + (-size * 0.8) + " " + (size * 0.5) + " " + (-size * 0.8) + " " + (size * 0.1) + " " + (-size * 0.1) + " " + (size * 0.8) + " " + (-size * 0.5) + " " + (size * 0.8) + " " + (size * 0.5) + " " + (size * 0.1) + " " + (size * 0.1) + " " + (size * 0.5) + " " + (size * 0.8) + " " + (-size * 0.5) + " " + (size * 0.8) + " " + (-size * 0.1) + " " + (size * 0.1) + " " + (-size * 0.8) + " " + (size * 0.5) + " " + (-size * 0.8) + " " + (-size * 0.5) + " " + (-size * 0.1) + " " + (-size * 0.1) + " " + (-size * 0.5) + " " + (-size * 0.8) + " " + (size * 0.5) + " " + (-size * 0.8) + " " + (size * 0.1) + " " + (-size * 0.1) + "";
            case "cross":
                return "M" + (-size / 2) + " " + (-size * 0.2) + " L" + (-size * 0.2) + " " + (-size * 0.2) + " L" + (-size * 0.2) + " " + (-size / 2) + " L" + (size * 0.2) + " " + (-size / 2) + " L" + (size * 0.2) + " " + (-size * 0.2) + " L" + (size / 2) + " " + (-size * 0.2) + " L" + (size / 2) + " " + (size * 0.2) + " L" + (size * 0.2) + " " + (size * 0.2) + " L" + (size * 0.2) + " " + (size / 2) + " L" + (-size * 0.2) + " " + (size / 2) + " L" + (-size * 0.2) + " " + (size * 0.2) + " L" + (-size / 2) + " " + (size * 0.2) + " Z";
            case "diamond":
                return "M" + (-size * 0.4) + " 0 L0 " + (-size / 2) + " L" + (size * 0.4) + " 0 L0 " + (size / 2) + " Z";
            case "ellipse":
                return "M" + (-size * 0.5) + " 0 A" + (size * 0.5) + " " + (size * 0.35) + " 0 0 1 " + (size * 0.5) + " 0 A" + (size * 0.5) + " " + (size * 0.35) + " 0 0 1 " + (-size * 0.5) + " 0";
            case "gear":
                return "M" + (-size * 0.134) + " " + (-size * 0.541) + " L" + (-size * 0.127) + " " + (-size * 0.696) + " " + (size * 0.131) + " " + (-size * 0.696) + " " + (size * 0.138) + " " + (-size * 0.547) + " " + (size * 0.282) + " " + (-size * 0.47) + " " + (size * 0.393) + " " + (-size * 0.571) + " " + (size * 0.598) + " " + (-size * 0.39) + " " + (size * 0.494) + " " + (-size * 0.282) + " " + (size * 0.531) + " " + (-size * 0.134) + " " + (size * 0.699) + " " + (-size * 0.134) + " " + (size * 0.699) + " " + (size * 0.138) + " " + (size * 0.539) + " " + (size * 0.138) + " " + (size * 0.474) + " " + (size * 0.279) + " " + (size * 0.575) + " " + (size * 0.386) + " " + (size * 0.369) + " " + (size * 0.578) + " " + (size * 0.286) + " " + (size * 0.474) + " " + (size * 0.131) + " " + (size * 0.531) + " " + (size * 0.131) + " " + (size * 0.696) + " " + (-size * 0.127) + " " + (size * 0.696) + " " + (-size * 0.127) + " " + (size * 0.531) + " " + (-size * 0.276) + " " + (size * 0.467) + " " + (-size * 0.39) + " " + (size * 0.575) + " " + (-size * 0.574) + " " + (size * 0.379) + " " + (-size * 0.47) + " " + (size * 0.279) + " " + (-size * 0.524) + " " + (size * 0.138) + " " + (-size * 0.7) + " " + (size * 0.138) + " " + (-size * 0.7) + " " + (-size * 0.138) + " " + (-size * 0.528) + " " + (-size * 0.138) + " " + (-size * 0.47) + " " + (-size * 0.282) + " " + (-size * 0.568) + " " + (-size * 0.383) + " " + (-size * 0.396) + " " + (-size * 0.568) + " " + (-size * 0.275) + " " + (-size * 0.463) + " " + (-size * 0.134) + " " + (-size * 0.541) + " Z";
            case "heart":
                return "M0 " + (-size * 0.2) + " C" + (size * 0.7) + " " + (-size * 0.7) + " " + (size * 0.7) + " " + (size * 0.2) + " 0 " + (size * 0.45) + " " + (-size * 0.7) + " " + (size * 0.2) + " " + (-size * 0.7) + " " + (-size * 0.7) + " 0 " + (-size * 0.2) + "Z";
            case "star":
                return "M0 " + (-size * 0.5) + " L" + (size * 0.122) + " " + (-size * 0.12) + " L" + (size * 0.5) + " " + (-size * 0.12) + " L" + (size * 0.197) + " " + (size * 0.12) + " L" + (size * 0.306) + " " + (size * 0.5) + " L0 " + (size * 0.274) + " L" + (-size * 0.306) + " " + (size * 0.5) + " L" + (-size * 0.197) + " " + (size * 0.12) + " L" + (-size * 0.5) + " " + (-size * 0.12) + " L" + (-size * 0.122) + " " + (-size * 0.12) + " Z";
            case "malteseCross":
                return "M" + (-size * 0.38) + " " + (-size * 0.5) + " A" + (size * 0.38) + " " + (size * 0.1) + " 0 0 1 " + (size * 0.38) + " " + (-size * 0.5) + " L" + (size * 0.2) + " " + (-size * 0.2) + " L" + (size * 0.5) + " " + (-size * 0.38) + " A" + (size * 0.1) + " " + (size * 0.38) + " 0 0 1 " + (size * 0.5) + " " + (size * 0.38) + " L" + (size * 0.2) + " " + (size * 0.2) + " L" + (size * 0.38) + " " + (size * 0.5) + " A" + (size * 0.38) + " " + (size * 0.1) + " 0 0 1 " + (-size * 0.38) + " " + (size * 0.5) + " L" + (-size * 0.2) + " " + (size * 0.2) + " L" + (-size * 0.5) + " " + (size * 0.38) + " A" + (size * 0.1) + " " + (size * 0.38) + " 0 0 1 " + (-size * 0.5) + " " + (-size * 0.38) + " L" + (-size * 0.2) + " " + (-size * 0.2) + " Z";
            case "square":
                return "M" + (-size * 0.5) + " " + (-size * 0.5) + " L" + (size * 0.5) + " " + (-size * 0.5) + " " + (size * 0.5) + " " + (size * 0.5) + " " + (-size * 0.5) + " " + (size * 0.5) + " Z";
            case "triangle-up":
                return "M" + (-size * 0.5) + " " + (size * 0.285) + " L0 " + (-size * 0.43) + " " + (size * 0.5) + " " + (size * 0.285) + " Z";
            case "triangle-down":
                return "M0 " + (size * 0.43) + " " + (-size * 0.5) + " " + (-size * 0.285) + " " + (size * 0.5) + " " + (-size * 0.285) + " Z";
            case "triangle-right":
                return "M" + (-size * 0.5) + " " + (-size * 0.43) + " " + (size * 0.285) + " 0 " + (-size * 0.5) + " " + (size * 0.43) + " Z";
            case "triangle-left":
                return "M" + (size * 0.5) + " " + (size * 0.43) + " " + (-size * 0.285) + " 0 " + (size * 0.5) + " " + (-size * 0.43) + " Z";
            case "arrow":
                return "M" + (-size * 0.5) + " " + (size * 0.2) + " L0 " + (-size * 0.5) + " " + (size * 0.5) + " " + (size * 0.2) + " " + (size * 0.25) + " " + (size * 0.2) + " " + (size * 0.25) + " " + (size * 0.5) + " " + (-size * 0.25) + " " + (size * 0.5) + " " + (-size * 0.25) + " " + (size * 0.2) + " Z";
            case "rocket":
                return "M" + (-size * 0.5) + " " + (size * 0.5) + " L0 " + (-size * 0.5) + " " + (size * 0.5) + " " + (size * 0.5) + " 0 " + (size * 0.25) + " " + (-size * 0.5) + " " + (size * 0.5) + " Z";
            case "nylon":
                return "M" + (-size / 2) + " " + (-size / 4) + " L" + (-size / 4) + " " + (-size / 4) + " L" + (-size / 4) + " " + (-size / 2) + " M" + (-size / 4) + " 0 L" + (-size / 4) + " " + (size / 4) + " L0 " + (size / 4) + " M0 " + (-size / 4) + " L" + (size / 4) + " " + (-size / 4) + " L" + (size / 4) + " 0 M" + (size / 4) + " " + (size / 2) + " L" + (size / 4) + " " + (size / 4) + " L" + (size / 2) + " " + (size / 4);
            case "waves":
                return "M" + (-size) + " 0 C" + (-size * 7 / 8) + " " + (-size / 4) + " " + (-size * 5 / 8) + " " + (-size / 4) + " " + (-size / 2) + " 0 C" + (-size * 3 / 8) + " " + (-size / 4) + " " + (-size / 8) + " " + (-size / 4) + " 0 0 C" + (size / 8) + " " + (size / 4) + " " + (size * 3 / 8) + " " + (size / 4) + " " + (size / 2) + " 0 C" + (size * 5 / 8) + " " + (-size / 4) + " " + (size * 7 / 8) + " " + (-size / 4) + " " + (size * 3 / 4) + " 0";
            case "woven":
                return "M" + (-size / 4) + " " + (-size / 4) + " L" + (size / 4) + " " + (size / 4) + " M" + (size / 4) + " " + (-size / 4) + " L" + (size / 2) + " " + (-size / 2) + " M" + (-size / 4) + " " + (size / 4) + " L" + (-size / 2) + " " + (size / 2) + " M" + (size / 4) + " " + (size * 3 / 4) + " L" + (size * 3/ 4) + " " + (size / 4);
            case "crosses":
                return "M " + (-size / 4) + " " + (-size / 4) + " L" + (size / 4) + "," + (size / 4) + " M" + (-size / 4) + "," + (size / 4) + " L" + (size / 4) + "," + (-size / 4);
            case "caps":
                return "M" + (-size / 4) + " " + (size / 4) + " L0 " + (-size / 4) + " " + (size / 4) + " " + (size / 4);
            case "hexagons":
                return "M" + (-size / 2) + " 0 L" + (-size / 4) + " 0 M" + (size / 2) + " 0 L" + (size / 4 ) + " " + (-size / 2) + " L0 " + (-size / 2) + " L" + (-size / 4) + " 0 L0 " + (size / 2) + " L" + (size / 4) + " " + (size / 2) + "Z";
            case "line":
            case "horizontal-line":
                return "M" + (-size * 0.5) + " 0 L" + (size * 0.5) + " 0";
            case "diagonal-line-right":
                return "M" + (-size * 3 / 4) + " " + (-size / 4) + " L" + (-size / 4) + " " + (-size * 3 / 4) + " M" + (-size / 2) + " " + (size / 2) + " L" + (size / 2) + " " + (-size / 2) + " M" + (size / 4) + " " + (size * 3 / 4) + " L" + (size * 3 / 4) + " " + (size / 4);
            case "vertical-line":
                return "M0 " + (-size / 2) + " L0 " + (size / 2);
            case "hexagon":
                return "M" + (size * 0.433) + " " + (size * 0.25) + " L" + (0 * size) + " " + (size * 0.5) + " L" + (size * -0.433) + " " + (size * 0.25) + " L" + (size * -0.433) + " " + (size * -0.26) + " L" + (0 * size) + " " + (size * -0.5) + " L" + (size * 0.433) + " " + (size * -0.26) + " Z";
            case "diagonal-line-left":
                return "M" + (-size * 3 / 4) + " " + (-size / 2) + " L" + (-size / 4) + " " + (size / 2) + " M" + (-size / 4) + " " + (-size / 2) + " L" + (size / 4) + " " + (size / 2) +" M" + (size / 4) + " " + (-size / 2) + " L" + (size * 3 / 4) + " " + (size / 2);
            case "oval":
                return "M" + (-size / 2) + " 0 A" + (size / 2) + " " + (size / 2) + " 0 0 1 0 " + (-size / 2) + " A" + (size / 2) + " " + (size / 2) + " 0 0 1 " + (-size / 2) + " 0";
            default: //circle
                return "M" + (-size / 2) + " 0 A" + (size / 2) + " " + (size / 2) + " 0 0 1 " + (size / 2) + " 0 A" + (size / 2) + " " + (size / 2) + " 0 0 1 " + (-size / 2) + " 0";
        }
    };
}

function addSVGmarker(parentElement, id, markeroptions, extraParams) {
    var color = extraParams.color,
        DIM = 10,
        marker,
        sw = extraParams.strokeWidth,
        img = extraParams.imageSize,
        tran = extraParams.transform,
        symbolpath = getSVGsymbol(markeroptions.symbol || extraParams.symbol),
        hasImage = ((markeroptions.imageUrl != null && markeroptions.imageUrl !== "")),
        size = validateNullVal(markeroptions.size, validateNullVal(sw, 1)),
        outersize = size * extraParams.symbolSize.outer,
        innersize = size * extraParams.symbolSize.inner,
        transform = ((tran != null) ? ("translate(" + tran[0] + "," + tran[1] + ")") : null),
        imgSize = ((id != null) ? size : outersize) * ((img != null) ? img : DIM);
    if (id != null) { //if id is not null create marker element else create path/image element
        var defs = $ZCG.patternSVG.select("defs");
        marker = appendEle(defs, "marker", [1], "#", "id", id);
        marker
            .attr({
                "id": id,
                "orient": 0,
                "viewBox": (-size * DIM / 2) + " " + (-size * DIM / 2) + " " + (size * DIM) + " " + (size * DIM),
                "markerUnits": "userSpaceOnUse",
                "markerWidth": size * DIM,
                "markerHeight": size * DIM
            });
    } else {
        marker = parentElement;
    }
    
    var outermarkerpath = appendEle(marker, "path", [1], ".", "class", "outer");
    outermarkerpath
        .attr({
            "d": symbolpath(hasImage ? imgSize : (outersize * DIM)),
            "transform": transform
        })
        .style({
            "fill": function() {
                if (hasImage) {
                    var conf = {
                        "name": markeroptions.imageUrl,
                        "width": imgSize,
                        "height": imgSize,
                        "x": -imgSize / 2,
                        "y": -imgSize / 2
                    };
                    return "url(" + getDefsLocation() + "#" + effects.get(svg_patterns,"imageFill", conf) + ")";
                }
                return markeroptions.outerFillColor || color;
            },
            "fill-opacity": markeroptions.outerFillOpacity,
            "stroke": markeroptions.outerStrokeColor || color,
            "stroke-opacity": markeroptions.outerStrokeOpacity,
            "stroke-width": markeroptions.outerStrokeWidth,
            "stroke-dasharray": getDashArray(markeroptions.outerDashStyle, markeroptions.outerStrokeWidth),
            "stroke-linecap": getLineCap(markeroptions.outerLineCap, markeroptions.outerDashStyle)
        });
    
    var innermarkerpath = appendEle(marker, "path", ((!hasImage) ? [1] : []), ".", "class", "inner");
    innermarkerpath
        .attr({
            "d": symbolpath(innersize * DIM),
            "transform": transform
        })
        .style({
            "fill": markeroptions.innerFillColor || color,
            "fill-opacity": markeroptions.innerFillOpacity,
            "stroke": markeroptions.innerStrokeColor || color,
            "stroke-opacity": markeroptions.innerStrokeOpacity,
            "stroke-width": markeroptions.innerStrokeWidth,
            "stroke-dasharray": getDashArray(markeroptions.innerDashStyle, markeroptions.innerStrokeWidth),
            "stroke-linecap": getLineCap(markeroptions.innerLineCap, markeroptions.innerDashStyle)
        });
    return marker;
}

function getMarkerSize(chart) { // For area, line, scatter charts - if marker is enabled, the top markers will be clipped. To avoid this, calculate the marker size and increase the clip area
    var DIM = {
        left: 0,
        top: 0,
        right: 0,
        bottom: 0
    };
    if (!chart.isAxisCategory) {
        return DIM;
    }
    // If minrange and maxrange of the axes is specified, don't consider the marker size
    var xaxis = chart.systemConf.chart.axes.xaxis,
        yaxes = chart.systemConf.chart.axes.yaxis;
    var cXmin = (xaxis.minRange != null && xaxis.minRange !== ""),
        cXmax = (xaxis.maxRange != null && xaxis.maxRange !== ""),
        cYmin = yaxes.some(function(d) {
            return (d.minRange != null && d.minRange !== "");
        }),
        cYmax = yaxes.some(function(d) {
            return (d.maxRange != null && d.maxRange !== "");
        });
    if (cXmin && cXmax && cYmin && cYmax) {
        return DIM;
    }
    var rotated = chart.axes.rotated,
        seriesTypes = chart.dataset.seriesTypes,
        commonPlotoptions = chart.systemConf.chart.plot.plotoptions,
        canvasarea = chart.canvasarea;
    
    var ms = d3_max(chart.seriesdata.map(function(d, i) {
            var plotoptions = d.plotoptions,
                markerSize = 0,
                cName = chart.chartTypes[i].name;
            var gvp = $ZC.utils.getValueOfPlotOptions((plotoptions ? plotoptions.marker : null), commonPlotoptions[cName].marker);
            if (/(area|arearange|line)/.test(cName) && gvp("enabled") && datacount_based_intelligence(chart, "marker") && dimension_based_intelligence(chart, "marker", mathMin(canvasarea.width, canvasarea.height))) {
                var size = gvp("size");
                markerSize = validateNullVal(size, validateNullVal((plotoptions ? plotoptions.strokeWidth : commonPlotoptions[cName].strokeWidth), 1));
            } else if (cName === "scatter") {
                markerSize = validateNullVal(gvp("size"), 2);
            }
            return markerSize * 10;
        })) / 2;
    return {
        left: (rotated ? cYmin : cXmin) ? DIM.left : ms,
        top: (rotated ? cXmax : cYmax) ? DIM.top : ms,
        right: (rotated ? cYmax : cXmax) ? DIM.right : ms,
        bottom: (rotated ? cXmin : cYmin) ? DIM.bottom : ms
    };
}

function blinkSVGsymbols(ele, blinkConf, repeat) {
    var count = defined(repeat) ? (repeat - 1) : (blinkConf.repeat || Infinity);
    if (!ele.node() || !count) {
        ele
            .style({
                "transform": null,
                "opacity": null
            })
        return;
    }
    var isFade = (blinkConf.type === "fade");
    var dur = blinkConf.duration,
        ease = blinkConf.easingType || (isFade ? "linear-in-out" : "linear");
    var dur1 = dur,
        del1 = (isFade ? 500 : 0),
        dur2 = (isFade ? 0 : dur),
        del2 = (dur1 + del1),
        start = isFade ? {
                "transform": "scale(1)",
                "opacity": 0
            } : {
                "transform": "scale(0)"
            },
        end = isFade ? {
                "transform": "scale(0)",
                "opacity": 1
            } : {
                "transform": "scale(1)"
            };
    ele.transition(); //Stop all the transitions. This will help to switch the blink type.
    ele
        .style(end)
        .transition()
        .delay(del1)
        .duration(dur1)
        .ease(ease)
        .style(start)
        .transition()
        .delay(del2)
        .duration(dur2)
        .ease(ease)
        .style(end)
        .each("end", function() {
            blinkSVGsymbols(ele, blinkConf, count);
        });
}//$Id$
$ZC.utils = function() {};

/*
 * element - to which the bound box is drawn
 * component1 - node from which we start to draw the box
 * component2 - where to end the box
 * properties - outer box configuration
 */

function drawBorderBox(element, properties) {
    
    element
        .attr('x', properties.left)
        .attr('y', properties.top)
        .attr('width', properties.width)
        .attr('height', properties.height)
        .style('fill-opacity', 0)
        .style('stroke', "transparent");
    
}
$ZC.utils.getActualTextBounds = function(fontSize,width,rotation)
{   
    var width = width,
    height = fontSize,
    radian = rotation *(Math.PI * 2 / 360)
    var bbox = {}
    bbox.width = Math.abs(height * Math.sin(radian)) + Math.abs(width * Math.cos(radian))
    bbox.height = Math.abs(height * Math.cos(radian)) + Math.abs(width * Math.sin(radian))
    return bbox;
}
var mergeJSON = $ZC.utils.mergeJSON = function(source1, source2, mergeConflicts, mergeIntoExists) {
    /*
     * Properties from the Souce2 object will be copied to Source1 Object.
     * Note: mergeIntoExists : true -- Here source 1 and source2 will get merged into source1.
     * mergeIntoExists : false -- This method will return a new merged object, Source1 and Source2 original values will not be replaced.
     * */
    source1 = source1 || {};
    source2 = source2 || {};
    
    var mergedJSON = (mergeIntoExists != null && mergeIntoExists == true) ? source1 : simpleClone(source1); // Cloning the source1
    for (var attrname in source2) {
        if (source2.hasOwnProperty(attrname)) {
            if (mergedJSON[attrname] != undefined) {
                if (source2[attrname] != null && (source2[attrname].constructor == Object || source2[attrname].constructor == Array)) {
                    /*
                     * Recursive call if the property is an object,
                     * Iterate the object and set all properties of the inner object.
                     */
                    mergedJSON[attrname] = mergeJSON(mergedJSON[attrname], source2[attrname], mergeConflicts, mergeIntoExists);
                } else if (mergeConflicts == true && typeof mergedJSON === "object") { //Merge the property from source 2 to source1
                    mergedJSON[attrname] = source2[attrname];
                }
                
            } else { //else Add the property from source 2 to source1
                mergedJSON[attrname] = source2[attrname];
                
            }
        }
    }
    
    return mergedJSON;
};

$ZC.utils.getValueOfPlotOptions = function(obj1, obj2) {
    /*
     * obj1 -->high priority
     * obj2 -->Low priority
     */
    return function(key) {
        if (obj1 != null && obj1[key] != null) {
            return obj1[key];
        } else if (obj2 != null && obj2[key] != null) {
            return obj2[key];
        } else {
            return null
        }
    }
};

$ZC.utils.getVal = function(value) {
    /*
     * If the value is function, execute it and return the value
     */
    return (typeof value === "function") ? value() : value;
};


function generateIdByPropValue(properties, name) {
    if (properties == null || properties.constructor != Object) {
        if (name != null) {
            return name;
        }
        return;
    }
    var id = "",
        val;
    for (var prop in properties) {
        if (properties.hasOwnProperty(prop)) {
            val = properties[prop];
            id += (val == null || val == "") ? "$$" : (val + "_");
        }
    }
    id = name + id;
    id = id.replace(/[.-]/g, '_');
    id = id.replace(/[`~!@#$%^&*( )|+\-=?;:'",.<>{}[\]\\/\s]/gi, '_');
    return id;
}


function getMonochromeColor(baseClr, domain, range) {
    var hsl = d3_hsl(baseClr);
    
    var interpolateClr = d3_scaleLinear()
        .domain([-1, 0, 1])
        .range([d3_hsl(hsl.h, hsl.s, 0.1), hsl, d3_hsl(hsl.h, hsl.s, 0.9)])
        .interpolate(d3_interpolateRgb);
    var clrScale = d3_scaleLinear()
        .domain(domain)
        .range(range);
    return function(clr) {
        return interpolateClr(clrScale(clr));
    };
}

function bbox(ele) {
    //if element is removed from DOM, firefox will throw NS_ERROR_FAILURE on getBBox(). This function returns getBBox() of the given element if that element is present in DOM, else returns {x:0, y:0, height:0, width:0}
    if (ele) {
        if (document.body.contains(ele) && (ele.style.display != "none")) {
            return ele.getBBox();
        }
    }
    return {
        x: 0,
        y: 0,
        height: 0,
        width: 0
    };
}
var simpleClone = $ZC.utils.simpleClone = function(o) {
    var copy = o,
        k;
    
    if (o && typeof o === 'object') {
        copy = isArray(o) ? [] : {};
        for (k in o) {
            // if(o.hasOwnProperty(k)){
            copy[k] = simpleClone(o[k]);
            // }
        }
    }
    
    return copy;
};

function decodeHTML(text) {
    if (!$ZC.dataEncoded || text == null) {
        return text;
    }
    var tempDiv = document.createElement("div");
    tempDiv.innerHTML = encodeURI(text);
    var decodedText = tempDiv.textContent;
    return decodeURI(decodedText);
}

function encodeHTML(text) {
    if ($ZC.dataEncoded || text == null) {
        return text;
    }
    var tempDiv = document.createElement("div");
    tempDiv.textContent = decodeHTML(text);
    var encodedText = tempDiv.innerHTML;
    return encodedText;
}

function validateURL(url) {
    var exp_http = /https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)/g,
        exp_nonHttp = /[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)?/gi;
    var regExp_http = new RegExp(exp_http),
        regExp_nonHttp = new RegExp(exp_nonHttp);
    return (url.match(regExp_http) || url.match(regExp_nonHttp));
}

function d3_values(map) {
    return map.slice(0);
}

function getDefsLocation() {
    return d3_selectAll("base").node() ? location.href.split(location.search || location.hash || /[?#]/)[0] : "";
}

function isObjectPropDefined(obj, key, self) {
    var keySet = key.replace(/\[(\w+)\]/g, '.$1'); // convert indexes to properties
    keySet = keySet.replace(/^\./, ''); // strip a leading dot
    var keys = keySet.split('.');

    var childObj = keys.reduce(function(o, x) {
        return !defined(o) ? o : o[x];
    }, obj);
    return self ? childObj : defined(childObj);
    
    // return keys.every(function (x) {
    // 	if (typeof obj != "object" || obj === null || !x in obj)
    // 		return false;
    // 	obj = obj[x];
    // 	return true;
    // });
}

/**
 *
 * @param {Object|*} variable
 * @return {boolean}
 */
function isUndefined(variable) {
    return !defined(variable);
}

function toArray(objectLikeArray) {
    return Array.prototype.slice.call(objectLikeArray);
}

/**
 * It invokes a function with the given arguments.
 * If the first argument is true, then corresponding function will have
 * access to 'this' keyword with the value arguments[2]
 */

function invokeFunction() {
    var args = toArray(arguments),
        advanced = args[0] === true && args.shift(),
        callback = args.shift();
    
    
    if (typeof callback === "string") {
        var temp = getPropVal(window, callback);
        // callback = defined(temp) ? temp : callback; // for both global variable and global function support.
        callback = typeof temp === "function" ? temp : callback; // for only global function support.
    }
    return typeof callback === "function" ? advanced ? callback.apply(args[0], args.splice(1)) : callback.apply(undefined, args) : callback;
}

function getValByPriority(array, attr) {
    var i = 0,
        len = array.length,
        val;
    for (; (i < len && (val == null || val === "")); i++) {
        if(array[i]) {
            val = array[i][attr];
        }
    }
    return val;
}

function validateNullVal(actualVal, defaultVal) {
    var val = (actualVal == null || actualVal === "") ? defaultVal : actualVal;


    var parsedVal = JSON.parse(val);
    val = (typeof parsedVal == "number") ? parseFloat(parsedVal) : (typeof parsedVal == "boolean") ? JSON.parse(parsedVal) : parsedVal;
    return val;
}

function validateValWithinLimit(data, prop, minPercent, maxPercent, width, height) {
    var val;
    var refLevel = mathMin(width, height);
    var maxVal = (maxPercent * refLevel) / 100,
        minVal = (minPercent * refLevel) / 100;
    val = data[prop]
    val = (val == null || val === "") ? null : (val < minVal) ? minVal : (val > maxVal) ? maxVal : parseFloat(val);
    return val;
}

/**
 * Returns true if the object is not null or undefined.
 * @param {Object} obj
 */

function defined(obj) {
    return obj !== undefined && obj !== null;
}

/**
 * Returns true if the value is null object or null string
 * @param {Object} obj
 */

function isNull(value) {
    return value == null || value == "null";
}

/**
 *
 * @param e
 * @returns {boolean}
 */

function isTrue(e) {
    return e + "".toLocaleLowerCase() === "true";
}

function shorthand_px(val) {
    /*
     * Input : 10 5 5 10
     * Output : 10px 5px 5px 10px
     */
    val += "";
    return val.replace(/ /g, "px ") + "px";
}

/**
 *
 * @param {Object} obj
 * @param {String} key
 * @returns {*}
 */
var getPropVal = $ZC.utils.getPropVal = function(obj, key) {
    return isObjectPropDefined(obj, key, true);
};

function intersectObject(obj1, obj2) {
    if (!obj1 || !obj2) {
        return null;
    }
    var output = {},
        intersected;
    for (var prop in obj1) {
        if (obj1.hasOwnProperty(prop) && obj2.hasOwnProperty(prop)) {
            var val1 = obj1[prop],
                val2 = obj2[prop];
            if (val1 && (val1.constructor == Object || val1.constructor == Array)) {
                var i = intersectObject(val1, val2);
                if (i != null) {
                    output[prop] = i;
                    intersected = true;
                }
            } else if (val1 == val2) {
                output[prop] = val1;
                intersected = true;
            }
        }
    }
    return intersected ? output : null;
}

/**
 *
 * @param {String} color
 * @returns {boolean}
 */

function isDarkColor(color) {
    // http://stackoverflow.com/questions/2509443/check-if-uicolor-is-dark-or-bright/2509596#2509596
    // https://stackoverflow.com/questions/12043187/how-to-check-if-hex-color-is-too-black
    // https://stackoverflow.com/questions/24260853/check-if-color-is-dark-or-light-in-android
    // https://stackoverflow.com/questions/635022/calculating-contrasting-colours-in-javascript
    
    var rgb = d3_rgb(color);
    
    // return 1 - (0.299 * rgb.r + 0.587 * rgb.g + 0.114 * rgb.b) / 255 > 0.45;
    
    // return 0.2126 * rgb.r + 0.7152 * rgb.g + 0.0722 * rgb.r < 165; // zoho-reports version
    
    return (rgb.r * 299 + rgb.g * 587 + rgb.b * 114) / 1000 < 128; // tiny color
}

/**
 *
 * @param {String} color
 * @returns {boolean}
 */

function isLightColor(color) {
    return !isDarkColor(color);
}

/**
 *
 * @param {String} color
 * @returns {string}
 */

function getContrastColor(color) {
    return isDarkColor(color) ? "#f8f8f8" : "#444444";
}

/**
 *
 * @param {*} obj
 * @returns {boolean}
 */

function isWindow(obj) {
    return obj != null && obj === obj.window;
}

/**
 *
 * @param elem
 * @returns {boolean|DocumentView}
 */

function getWindow(elem) {
    return isWindow(elem) ? elem : elem.nodeType === 9 && elem.defaultView;
}

/**
 *
 * @param {Element} elem
 * @returns {{top: number, left: number}}
 */

function offset(elem) {
    var box = elem.getBoundingClientRect(),
        doc = elem && elem.ownerDocument,
        docElem = doc.documentElement,
        win = getWindow(doc);
    return {
        top: box.top + win.pageYOffset - docElem.clientTop,
        left: box.left + win.pageXOffset - docElem.clientLeft
    };
}

/**
 *
 * @param {String} str
 * @returns {Array}
 */
function stringifiedArrayReverse(str) {
    if (!str) {
        return str;
    }

    return str
        .split(",")
        .reverse()
        .join();
}

/**
 *
 * @returns {Boolean}
 */
function isHiddenDocument() {
    return defined(document.visibilityState) && document.visibilityState !== "visible"; //window blur state
}

/**
 *
 * @param {Element} element
 * @param {Element} container
 * @param {Boolean|null} partial
 * @returns {boolean}
 */

function elementIsVisible(element, container, partial) {
    var contHeight = container.offsetHeight,
        elemTop = offset(element).top - offset(container).top,
        elemBottom = elemTop + element.offsetHeight;
    return (elemTop >= 0 && elemBottom <= contHeight) || (partial && ((elemTop < 0 && elemBottom > 0) || (elemTop > 0 && elemTop <= contHeight)))
}

$ZC.utils.elementIsVisible = elementIsVisible;

/**
 * Return the first value that is defined.
 */

var pick = function() {
    var args = arguments,
        i, arg, length = args.length;
    for (i = 0; i < length; i++) {
        arg = args[i];
        if (defined(arg)) {
            return arg;
        }
    }
    return args[length - 1];
};

/**
 *
 * joins one or multiple arrays.
 * if the first argument is true, then remaining arrays will copied to the first array
 * else it copies all arrays to a new array.
 * @return {Array}
 */

function arrayJoin() {
    // performance https://jsperf.com/array-prototype-push-apply-vs-concat/5
    // https://jsperf.com/arrayconcatvsarraypushapply
    // return target.concat(newObject)
    
    var args = toArray(arguments),
        copyToExisting = args[0] === true && args.shift(),
        target = copyToExisting ? args.shift() : [];
    
    if ((copyToExisting && !args.length)) {
        return target;
    }
    
    args.forEach(function(newObject) {
        var i = 0,
            c = newObject.length;
        for (; i < c; ++i) {
            target.push(newObject[i]);
        }
    });
    return target;
}

// for identifying d3 selection
d3.selection.prototype.isD3Selection = true;

function formatArray(array, formatter, formatConf, chart, dataType, type,specifierIndex) {
    return array.map(function(value) {
        return formatter(formatConf, value, dataType, chart, type,null,null,specifierIndex);
    })
}

function sortByLength(array) {
    return array.slice(0).sort(function (a, b) {
        // ASC  -> a.length - b.length
        // DESC -> b.length - a.length
        if (!defined(a)) {
            a = "";
        }
        if (!defined(b)) {
            b = "";
        }
        return b.length - a.length;
    })
}

function isHidden(el) {
    return (el.offsetParent === null)
}

function each(obj, fn) {

    if (typeof obj !== "object") {
        return false;
    }

    if (isArray(obj) || typeof (obj.length) === "number") {
        Array.prototype.forEach.call(obj, fn)
    } else {
        for (var attr in obj) {
            if (obj.hasOwnProperty(attr)) {
                fn(obj[attr], attr, obj)
            }
        }
    }
}

/**
 * Extend one or more objects with the members of another
 * @param target
 * @returns {Object}
 */

function extend(target) {
    if (!arguments[1]) {
        return;
    }
    for (var ii = 1, ll = arguments.length; ii < ll; ii++) {
        var source = arguments[ii];
        for (var prop in source) {
            if (!target[prop] && source.hasOwnProperty(prop)) {
                target[prop] = source[prop];
            }
        }
    }
    return target;
}

/**
 * Inherits an Object
 * @param {Object|*} subClass
 * @param {Object|*} superClass
 */

function inherit(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            enumerable: false,
            writable: true,
            configurable: true
        }
    });
    if (superClass) {
        Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }
}

/**
 *
 * @param {Array} array
 * @param {*} element
 * @returns {Array}
 */
function removeElementFromArray(array, element) {
    var index = array.indexOf(element);
    if (index > -1) {
        array.splice(index, 1);
    }
    return array;
}//$Id$
function appendEle(parentNode, nodeName, data, selector, selectorAttr, selectorVal, styleObj) {
    selector = selector || "";
    selectorVal = selectorVal || "";
    
    var node = parentNode
        .selectAll(nodeName + selector + selectorVal)
        .data(data);
    var nodeEnter = node
        .enter()
        .append(nodeName);
    if (selectorAttr) {
        nodeEnter.attr(selectorAttr, selectorVal);
    }
    if (styleObj) {
        nodeEnter.style(styleObj);
    }
    node.exit().remove();
    return node;
}

function trimText(textObj, text, textBounds, edge, orient, pattern, marginValue, max, parent, deepTrim) {
    if (text == null || !text.trim() || !textObj) { //#ZC676
        return text;
    }
    var maxWidth, maxHeight;
    parent = parent || textObj;
    if (max) {
        maxWidth = max.width;
        maxHeight = max.height;
    } else {
        maxWidth = edge.right - edge.left;
        maxHeight = edge.bottom - edge.top;
    }
    // var textBounds = textObj.getBoundingClientRect()
    var overflowLength = 0;
    
    if (orient == "left" || orient == "right") {
        if ((textBounds.top + textBounds.height - marginValue.bottom) > edge.bottom) {
            overflowLength += ((textBounds.top + textBounds.height - marginValue.bottom) - (edge.bottom)) / (textBounds.height)
        }
        if ((textBounds.top + marginValue.top) < edge.top) {
            overflowLength += ((edge.top - (textBounds.top + marginValue.top)) / (textBounds.height))
        }
        maxHeight = textBounds.height -
            mathMax(0, ((textBounds.top + textBounds.height - marginValue.bottom) - (edge.bottom))) -
            mathMax(0, (edge.top - (textBounds.top + marginValue.top)));
    } else if (orient == "bottom" || orient == "top") {
        if ((textBounds.left + textBounds.width - marginValue.right) > edge.right) {
            overflowLength += ((textBounds.left + textBounds.width - marginValue.right) - (edge.right)) / (textBounds.width)
        }
        if ((textBounds.left + marginValue.left) < edge.left) {
            overflowLength += (edge.left - (textBounds.left + marginValue.left)) / (textBounds.width)
        }
        maxWidth = textBounds.width -
            mathMax(0, ((textBounds.left + textBounds.width - marginValue.right) - edge.right)) -
            mathMax(0, (edge.left - (textBounds.left + marginValue.left)));
    }
    if (overflowLength > 0) {
        var croppedTextLength = mathCeil((1 - overflowLength) * (text.length))
        textObj.textContent = text.substring(0, croppedTextLength - 1) + pattern;
        
        var newTextBounds = parent.getBoundingClientRect();
        deepTrim = (textObj.nodeName == "tspan") ? false : deepTrim; //TODO
        if ((deepTrim !== false) && ((newTextBounds.width != textBounds.width) || (newTextBounds.height != textBounds.height))) {
            naiveEllipsis(textObj, parent, text, maxWidth, maxHeight, newTextBounds, pattern);
        }
    }
    
}

function wordWrap(text, width, height) {
    text.each(function() {
        var text = d3_select(this),
            words = text.text().split(/\s+/).reverse(),
            word,
            line = [],
            lineNumber = 0,
            lineHeight = 1.1, // ems
            y = text.attr("y"),
            dy = parseFloat(text.attr("dy")),
            tspan = text.text(null).append("tspan").attr("x", 0).attr("y", y).attr("dy", dy + "em");
        while (word = words.pop()) {
            line.push(word);
            tspan.text(line.join(" "));
            if (tspan.node().getComputedTextLength() > width) {
                line.pop();
                tspan.text(line.join(" "));
                line = [word];
                tspan = text.append("tspan").attr("x", 0).attr("y", y).attr("dy", ++lineNumber * lineHeight + dy + "em").text(word);
            }
        }
    });
}


function roundedRect(x, y, w, h, r, yReversed, axisrotated) {
    var x1, x2, y1, y2;
    x1 = ((yReversed && axisrotated) ? x - w : x), x2 = ((yReversed && axisrotated) ? x : x + w), //x1,y1 should be at top left . x2,y2 should be at bottom right .
        y1 = (yReversed && !axisrotated) ? y - h : y, y2 = (yReversed && !axisrotated) ? y : y + h,
        r = checkRadiusWithinBoundary(r, w, h)
    
    return "M" + x1 + "," + (y2 - r.bly) +
        "L" + x1 + "," + (y1 + r.tly) +
        "A" + (r.tlx + "," + r.tly + " 0 0 1 " + (x1 + r.tlx) + "," + y1) +
        "L" + (x2 - r.trx) + "," + (y1) +
        "A" + (r.trx + "," + r.trY + " 0 0 1 " + (x2) + "," + (y1 + r.trY)) +
        "L" + (x2) + "," + (y2 - r.bry) +
        "A" + (r.brx + "," + r.bry + " 0 0 1 " + (x2 - r.brx) + "," + (y2)) +
        "L" + (x1 + r.blx) + "," + (y2) +
        "A" + (r.blx + "," + r.bly + " 0 0 1 " + (x1) + "," + (y2 - r.bly))
        + "Z";
    
    function checkRadiusWithinBoundary(r, width, height) {
        var radius = Object.create(r)
        var top = radius.tlx + radius.trx,
            right = radius.trY + radius.bry,
            bottom = radius.brx + radius.blx,
            left = radius.tly + radius.bly;
        
        var z;
        
        if (height < left) {
            z = (left) / (left - height)
            radius.tly = (radius.tly - (radius.tly / z)), radius.bly = (radius.bly - (radius.bly / z))
        }
        if (width < top) {
            z = (top) / (top - width)
            radius.tlx = (radius.tlx - (radius.tlx / z)), radius.trx = (radius.trx - (radius.trx / z))
        }
        if (height < right) {
            z = (right) / (right - height)
            radius.trY = (radius.trY - (radius.trY / z)), radius.bry = (radius.bry - (radius.bry / z))
        }
        if (width < bottom) {
            z = (bottom) / (bottom - width)
            radius.brx = (radius.brx - (radius.brx / z)), radius.blx = (radius.blx - (radius.blx / z))
        }
        return radius
    }
    
}

function applyFont(ele, hierarchy, html) {
    var fSize = $ZC.utils.getVal(getValByPriority(hierarchy, "fontSize")),
        fFamily = getValByPriority(hierarchy, "fontFamily"),
        fWeight = getValByPriority(hierarchy, "fontWeight"),
        fStyle = getValByPriority(hierarchy, "fontStyle"),
        fShadow = getValByPriority(hierarchy, "textShadow"),
        fColor = getValByPriority(hierarchy, "fontColor"),
        txtDec = getValByPriority(hierarchy, "textDecoration"),
        strokeColor = getValByPriority(hierarchy, "strokeColor");
    
    var styleObj = {
        "font-size": fSize + "px",
        "font-family": fFamily,
        "font-weight": fWeight,
        "font-style": fStyle,
        "text-shadow": fShadow,
        "text-decoration": txtDec
    };
    
    if (defined(ele)) {
        styleObj[html ? "color" : "fill"] = fColor;
        if(!html && strokeColor && !$Browser.IE) {
            styleObj.stroke = strokeColor;
            styleObj["stroke-width"] = getValByPriority(hierarchy, "strokeWidth") || 3;
            styleObj["paint-order"] = "stroke";
        }
        ele.style(styleObj);
    } else {
        styleObj.color = fColor;
        return styleObj;
    }
}

function addSVGtitleEle(textEle) {
    textEle.append("title")
        .text(function() {
            return this.parentNode.textContent;
        });
}

function naiveEllipsis(textNode, parent, origTextContent, maxWidth, maxHeight, textBounds, pattern) {
    /*
     * If bound is less than the max, traverse from current length to original length and update the textContent
     * Else traverse from current length to 0 and update the textContent
     */
    var index = textNode.textContent.length - 1,
        textBound,
        pattern_length = pattern.length;
    if ((textBounds.width > maxWidth) || (textBounds.height > maxHeight)) {
        var end = 0;
        while (index >= end) {
            changeTextContent(true);
            if ((textBounds.width <= maxWidth) && (textBounds.height <= maxHeight)) {
                return;
            }
            index--;
        }
    } else {
        var end = origTextContent.length;
        while (index < end) {
            // changeTextContent();
            if ((textBounds.width >= maxWidth) || (textBounds.height >= maxHeight)) {
                index--;
                changeTextContent(false);
                return;
            }
            index++;
        }
    }
    
    function changeTextContent(updateBound) {
        /*
         * This will change the textContent based on 'index' value
         * And update 'textBound' with new text bound if 'dontUpdateBound' is not true
         */
        textNode.textContent = origTextContent.substring(0, index - pattern_length) + pattern;
        if (updateBound) {
            textBounds = parent.getBoundingClientRect();
        }
    }
}

function parseSVGPath(path) {
    var arr = path.match(/[a-z][^a-z]*/ig);
    return arr.map(function(d) {
        var func = d.match(/[a-z]/ig).pop();
        var moves = d.match(/-?[0-9]\d*(\.\d+)?/g);
        if (moves) {
            moves = moves.map(function(m) {
                return parseFloat(m);
            });
        }
        return {
            "function": func,
            "moves": moves
        }
    });
}

function wrapTextContent(node, text, prop, useHTML) {
    var isMultiLine = isArray(text) && text.length > 1,
        printProperty = useHTML ? "html" : "text",
        parentGroup = d3.select(node.node().parentNode);

    if(isMultiLine) {
        node.text(null);
        var lineNumber = 0, lineHeight = (defined(prop) && defined(prop.lineHeight)) ? prop.lineHeight : 0.71 ;
        var x = node.attr("x") || 0, y = node.attr("y") || 0;
        text.forEach(function(el) {
            if (useHTML) {
                insertSVGEle(parentGroup, node, el);
            } else {
                var tspan = node.append("tspan");
                tspan.attr("x", x)
                    .attr("y", y)
                    .attr("dy", function(d, i) {
                        return ((lineNumber++) + lineHeight) + "em";
                    });

                tspan[printProperty](function() {
                    return el;
                });
            }
        })
    } else {
        if (useHTML) {
            node.text(null);
            insertSVGEle(parentGroup, node, text)
        } else {
            node[printProperty](text)
        }
    }
    return node;
}


function insertSVGEle(parent, textNode, child) {
    var imageRegex = /^<image.+<\/image>/i,
        tspanRegex= /^<tspan.+<\/tspan>/i;

    if (imageRegex.test(child)) {
        appendEle(parent, "g", [1], ".", "class", "image").html(child);
    } else if (tspanRegex.test(child)) {
        var doc = new DOMParser().parseFromString('<svg xmlns="' + d3.ns.prefix.svg + '">' + child + '</svg>', 'application/xml');
        textNode.node().appendChild(doc.querySelector("tspan"));
    } else {
        textNode.append("tspan").text(child);
    }
}


function getTextContent(textNode){
    var tspan = textNode.selectAll("tspan")[0];
    if(tspan.length){
        var arr = [];
        tspan.forEach(function(d){
            arr.push(d.textContent);
        })
        return arr;
    }else{
        return textNode.node().textContent;
    }
}



//$Id$
function getAnimationConf(commonPlotOptions, plotoptions, chartObj, chartType) {
    var animationOptions = (plotoptions && plotoptions.animation) ? mergeJSON(commonPlotOptions.animation, plotoptions.animation, true) : commonPlotOptions.animation,
        globalAnimation = chartObj.systemConf.chart.plot.animation,
        obj = {};

    if (isHiddenDocument() || chartObj.isHiddenCoainer) {
        obj.enabled = false;
    } else {
        obj.enabled = datacount_based_intelligence(chartObj, "animation") ?
            getValByPriority([animationOptions, globalAnimation], "enabled") :
            false;
    }
    obj.type = animationOptions.type;
    obj.easingType = animationOptions.easingType || globalAnimation.easingType || (/(scatter|bubble$|packedbubble|heatmap)/.test(chartType) ? "cubic-in-out" : null) || "linear"; //bubble$ - bubblepie chart shouldnot pass this case
    obj.duration = !obj.enabled ? 0 : validateNullVal(animationOptions.duration, +(globalAnimation.duration || defaultDuration()));
    return obj;
    
    function defaultDuration() {
        return /(bar|bullet|gantt)/.test(chartType) ? 300 :
            /(line|area|arearange)/.test(chartType) ? 600 :
                /(scatter|bubble$|funnel|pyramid|heatmap)/.test(chartType) ? 1000 //bubble$ - bubblepie chart shouldnot pass this case
                    :
                    500;
    }
}

function interTween(baseData, basedataShift, serData, categories, animationType, easingType, transitionDuration, rp, layout, eleEnter, chartName) {
    var isPointTween = (animationType == "pointTween");
    var dataset = rp.dataset,
        yaxiscolumnorder = rp.yaxiscolumnorder;
    var count = isPointTween ? 0 : -1;
    var len = serData.length;
    var interTweenDuration = (transitionDuration - (17 * categories.length - 1));
    var duration = mathRound(interTweenDuration / (isPointTween ? (categories.length - 1) : len));
    tween();
    
    function tween() {
        count++;
        if (isPointTween) {
            for (var j = 0; j < len; j++) {
                baseData[j] = serData[(j < count) ? j : mathMax(0, count - 1)];
                basedataShift[j] = serData[(j < count) ? j : count];
            }
        } else {
            baseData[count - 1] = serData[count - 1];
            basedataShift[count] = serData[count];
        }
        if (count < len) {
            var del = ((count == 1 && isPointTween) ? (categories.indexOf(dataset.getX(serData[0])) - (count - 1)) * duration : 0),
                dur = ((isPointTween ? (categories.indexOf(dataset.getX(serData[count])) - categories.indexOf(dataset.getX(serData[count - 1]))) : 1) * duration),
                notNull = isPointTween ? (dataset.getY(serData[count], yaxiscolumnorder) != null && dataset.getY(serData[mathMax(0, count - 1)], yaxiscolumnorder) != null) : (dataset.getY(serData[count], yaxiscolumnorder) != null);
            if (notNull) {
                eleEnter
                    .attr(layout(baseData))
                    .transition()
                    .delay(del)
                    .duration(dur)
                    .ease(easingType)
                    .attr(layout(basedataShift))
                    .each("end", (chartName === "scatter") ?
                        
                        function(d, j) {
                            if (j == len - 1) {
                                tween();
                            }
                        } :
                        tween);
            } else {
                tween();
            }
        }
    }
}

function flipTween(element) {
    var rad = d3_interpolate(0, mathPI);
    element.attrTween("transform", function() {
        var transform = d3_select(this).attr("transform");
        return function(t) {
            return transform + " matrix(" + mathCos(rad(t)) + ",0,0,1,0,0)";
        };
    });
}

function fadeTween(element) {
    var opacity = d3_interpolate(0, 1);
    element.styleTween("opacity", function() {
        return function(t) {
            return opacity(t);
        };
    });
}

function scaleTween(element) {
    var scale = d3_interpolate(0, 1);
    element.attrTween("transform", function() {
        var transform = d3_select(this).attr("transform");
        return function(t) {
            return transform + " scale(" + scale(t) + ")";
        };
    });
}

function cancelAnimation(element) {
    element
        .interrupt();
}
//$Id$
function dimension_based_intelligence(chartObj, factor, dimension) {
    var intelligenceInfo = +chartObj.systemConf.canvas.intelligence.dimension[factor];
    return (dimension >= intelligenceInfo);
}

function datacount_based_intelligence(chartObj, factor) {
    var intelligenceInfo = +chartObj.systemConf.canvas.intelligence.dataCount[factor];
    return (intelligenceInfo >= chartObj.dataObject.totalnoofdatas);
}//$Id$
function polarToXY(r, a) {
    a = a - (mathPI / 2);
    return [mathCos(a) * r, mathSin(a) * r];
}

function d0_360(a) {
    var a = a % (2 * mathPI);
    return (a < 0) ? (a + (2 * mathPI)) : a;
}

function polarRefPoint(bb, w, h, r, SW) {
    var leftWidth = 0 - (bb.x - (0.5 * SW)),
        rightWidth = bb.width + SW - leftWidth,
        topHeight = 0 - (bb.y - (0.5 * SW)),
        bottomHeight = bb.height + SW - topHeight;
    var leftWidthRemaining = (r - leftWidth),
        rightWidthRemaining = (r - rightWidth),
        topHeightRemaining = (r - topHeight),
        bottomHeightRemaining = (r - bottomHeight);
    return [((w / 2) - (leftWidthRemaining / 2) + (rightWidthRemaining / 2)),
        ((h / 2) - (topHeightRemaining / 2) + (bottomHeightRemaining / 2))
    ];
}

function perToPx(val, dim, defaultVal) {
    return ((typeof val === "string") && (val.indexOf("%") > -1)) ?
        (dim * (+val.replace(/%/g, "")) * 0.01) :
        validateNullVal(val, defaultVal);
}

function getDY(angle) {
    return d3_scaleLinear()
        .range([0, 1])
        .domain([((angle < mathPI) ? (mathPI / 2) : (3 * mathPI / 2)), mathPI])(angle);
}

function isAngleInside(theta1, theta2, angle) {
    if (theta2 < theta1) { //Swap the start and end angle if endangle is less than start angle
        theta2 = theta1 + ((theta1 = theta2) - theta2);
    }
    if (theta1 < 0 && theta2 < 0) {
        theta1 = (theta1 + 2 * mathPI), theta2 = (theta2 + 2 * mathPI);
    }
    if (theta1 < 0 && theta2 >= 0) {
        if (angle < 0) {
            theta2 = (2 * mathPI);
        } else {
            theta1 = 0;
        }
    }
    angle = (angle < 0) ? (angle + mathPI * 2) : angle; //Mapping [-Math.PI,Math.PI] to [0,2*Math.PI]
    return (theta1 <= angle) && (angle <= theta2);
}

function radianToDegree(rad) {
    return rad * 180 / mathPI;
}

/*
 * Returns the inner radius for pie | dial chart. If the inner radius is in percentage. It converts to pixel and considers bandWidth & maxBandWidth
 * @param {Object} commonPlotOptions
 * @param {String} | {Number} rad
 * @return {Number} inner radius
 */
function getInnerRadius(commonPlotOptions, rad) {
    var hasCustomBandWidth = defined(commonPlotOptions.bandWidth) || (commonPlotOptions.levelMarker && defined(commonPlotOptions.levelMarker.bandWidth)),
        hasCustomMaxBandWidth = defined(commonPlotOptions.maxBandWidth) || (commonPlotOptions.levelMarker && defined(commonPlotOptions.levelMarker.maxBandWidth));
    var innerRadius = mathMax(0, perToPx(commonPlotOptions.innerRadius, rad, 0));
    if (hasCustomBandWidth || hasCustomMaxBandWidth) {
        var bandWidth = defined(commonPlotOptions.bandWidth) ? perToPx(commonPlotOptions.bandWidth, rad, 0) : (rad - innerRadius),
            levelMarkerBandWidth = defined(commonPlotOptions.levelMarker.bandWidth) ? perToPx(commonPlotOptions.levelMarker.bandWidth, rad, 0) : (rad - innerRadius),
            maxBandWidth = validateNullVal(commonPlotOptions.maxBandWidth, rad),
            maxLevelMarkerBandWidth = validateNullVal(commonPlotOptions.levelMarker.maxBandWidth, rad);

        bandWidth = mathMin(bandWidth, maxBandWidth);
        levelMarkerBandWidth = mathMin(levelMarkerBandWidth, maxLevelMarkerBandWidth);
        
        return rad - mathMax(bandWidth, levelMarkerBandWidth)
    } else {
        return innerRadius;
    }
}
//$Id$
function rgb2hex(color){
   var rgb = color.match(RGBA_PATTERN);
   return (rgb && rgb.length === 5) ? "#" +
    ("0" + parseInt(rgb[1],10).toString(16)).slice(-2) +
    ("0" + parseInt(rgb[2],10).toString(16)).slice(-2) +
    ("0" + parseInt(rgb[3],10).toString(16)).slice(-2) : color;
}

function hex2rgba(hex, opacity){
    var hex = hex.toString().replace('#',''),
	    r = parseInt(hex.substring(0,2), 16),
	    g = parseInt(hex.substring(2,4), 16),
	    b = parseInt(hex.substring(4,6), 16);

    return 'rgba('+r+','+g+','+b+','+opacity+')';
}

function isRgba(color) {
    return /^rgba/.test(color);
}

function getColorCopy(color, k, copyType, colorMode) {
    if (color === "transparent") {
        return color;
    }

    copyType = pick(copyType, "darker");
    var convertToRGBA = false, d3Color, alpha;

    if (isRgba(color)) {
        alpha = color.match(RGBA_PATTERN)[4];
        color = rgb2hex(color);
        convertToRGBA = true;
    }

    d3Color = pick(colorMode, d3.rgb)(color);
    color = d3Color[copyType](k).toString();

    if (convertToRGBA) {
        color = hex2rgba(color, alpha);
    }

    return color;
}

function getFillColor(chartObj, seriesIndex, gradientDim, dontUsePatternPallete) {
	var defsLocation = chartObj.defsLocation,
        chartName = chartObj.chartTypes[seriesIndex].name,
		commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions[chartName],
        plotoptions = chartObj.seriesdata[seriesIndex].plotoptions,
        gradientOptions = (plotoptions && plotoptions.gradients) ? mergeJSON(commonPlotOptions.gradients, plotoptions.gradients, true)  : commonPlotOptions.gradients,
		patternPallete = chartObj.patternPallete,
        imagePallete = chartObj.imagePallete,
		patternPalleteLength = !dontUsePatternPallete && patternPallete && patternPallete.length,
        rendererMode = chartObj.plot.renderer.mode,
        colorIndexScale = getColorIndexScale(chartObj);

    return function(i, d, colorGamma, customColor, fillOpacity, customGradientDim, customPatternDim, returnSVGimage) {

        var baseClr;
    	gradientDim = customGradientDim || gradientDim;
    	i = Math.max(i, 0) || 0; // check packed bubble and sunburst

    	if (customColor) {
            baseClr = customColor;
    	} else {
            baseClr = getRawColor(chartObj, i, d, seriesIndex);
            if (colorIndexScale && isUndefined(i = getColorIndex(chartObj, colorIndexScale, d, i))) {
                return baseClr;
            }
        }

        if(rendererMode == "canvas" && !gradientOptions.type && !(baseClr instanceof Object)){
            baseClr = canvasUtils.rgba(baseClr,fillOpacity);
        }

	    if (patternPalleteLength && /(url|data)/.test(baseClr)) {
	    	return baseClr;
	    }

	    if (defined(colorGamma)) {
	    	baseClr = getColorCopy(baseClr, colorGamma).toString();
	    }
        if(imagePallete && imagePallete.length){
            var prop = {
                name : chartObj.imagePallete[i],
                width : (customPatternDim && customPatternDim.width) || chartObj.patternImageSizes[i][0],
                height : (customPatternDim && customPatternDim.height) ||chartObj.patternImageSizes[i][1],
                mode :rendererMode,
                context: customPatternDim && customPatternDim.context
            }
            var patternEle = (rendererMode == "svg" || returnSVGimage) ? effects.get(svg_patterns,"imageFill",prop,{"returnSVGimage":returnSVGimage})
                                                                        : effects.get(canvas_patterns,"imageFill",prop,{"returnSVGimage":returnSVGimage});
            if(rendererMode == "canvas"){
                return patternEle;
            }
            return "url(" + defsLocation + "#" + patternEle + ")";
        }
	    if (patternPalleteLength) {
            var patternOptions = patternPallete[i % patternPalleteLength];
            var prop = getPatternProp(patternOptions,baseClr,fillOpacity,customPatternDim);
            
            var patternEle = (rendererMode == "svg" || returnSVGimage) ? effects.get(svg_patterns, "svgPatternFill", prop, {"returnSVGimage":returnSVGimage}) : 
                                                                         effects.get(canvas_patterns, "canvasPatternFill",prop,{"returnSVGimage":returnSVGimage});
            
            if(returnSVGimage || rendererMode == "canvas"){
                return patternEle;
            }
            return "url(" + defsLocation + "#" + patternEle + ")";
	    }

	    if (gradientDim && gradientOptions && gradientOptions.type) {
            var prop = getGradientProp(gradientOptions,gradientDim,baseClr,fillOpacity);
            var args = {"offset":chartName, "chartObj":chartObj};
	    	var gradientEle = (rendererMode == "svg") ?  effects.get(svg_gradients, "svgGradientFill",prop, args) : effects.get(canvas_gradients, "canvasGradientFill",prop, {"offset":chartName, "chartObj":chartObj,"returnSVGimage":returnSVGimage});

            if(returnSVGimage || rendererMode == "canvas"){
                return gradientEle;
            }
            return "url(" + defsLocation + "#" + gradientEle + ")";

	    	// if (gradientEle) {
	    	// 	return "url(" + defsLocation + "#" + gradientEle + ")";
	    	// }
	    }

	    return baseClr;
    }
}

/*
 * @param {Object} chartObj
 * @param {Number} seriesIndex
 * @returns {Color}
 */
function getStrokeColor(chartObj, seriesIndex) {
    return function(i, d, customColor, colorGamma) {
        if (customColor) {
            return customColor;
        } else {
            i = Math.max(i, 0) || 0; // check packed bubble and sunburst
            var baseClr = getRawColor(chartObj, i, d, seriesIndex);
            if (defined(colorGamma)) {
                baseClr = getColorCopy(baseClr, colorGamma).toString();
            }
            return baseClr;
        }
    }
}

/*
 * @param {Number} clr
 * @param {Object} chartObj
 * @param {Scale} colorScale
 * @param {Array} colorScale_domain
 * @returns {Boolean}
 */
function isWithinColorRange(clr, chartObj, colorScale, colorScale_domain) {
    if (!colorScale) {
        colorScale = chartObj.axes.clr.scale;
    }

    if (!colorScale) { //If clr index is not specified
        return true;
    }

    if (!colorScale_domain) {
        colorScale_domain = colorScale.domain();
    }

    if (clr === UNDEFINED){
        clr = null;
    }

    var filterRange = chartObj.systemConf.legend.filter.range,
        isWithinRange = !filterRange || ((chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE) ? (filterRange.indexOf(clr) > -1) : (clr >= filterRange[0] && clr <= filterRange[1])),
        isWithinScale = (chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE) ? (colorScale_domain.indexOf(clr) > -1) : (clr >= colorScale_domain[0] && clr <= colorScale_domain[colorScale_domain.length - 1]);
    return isWithinScale && isWithinRange && colorScale(clr) !== null && !(isHeatMapChartType(chartObj.chartTypes[0].value) && clr == null);
}

/*
 * @param {Object} chartObj
 * @param {Number} i
 * @param {Array} d
 * @param {Number} seriesIndex
 * @returns {Color} 1)Threshold 2)Color scale 3)Index based
 */
function getRawColor(chartObj, i, d, seriesIndex) {
    var baseClr = getColorByIndex(chartObj, i),
        rp = chartObj.isAxisCategory && defined(seriesIndex) && chartObj.rendererConf && chartObj.rendererConf[seriesIndex].params;

    if (rp && rp.colorOverlay) {
        return getColorBythreshold(chartObj, rp, d, baseClr);
    } else if (d && colorscale_helpers.isQuantileColorScale(chartObj)) {
        return getColorByScale(chartObj, d);
    } else {
        return (d && d.arcColor) || baseClr;
    }
}

/*
 * @param {Object} chartObj
 * @param {Number} i
 * @returns {Color} based on index
 */
function getColorByIndex(chartObj, i) {
    var seriesColor = chartObj.seriesColor;
    return seriesColor[i % seriesColor.length];
}

/*
 * @param {Object} chartObj
 * @param {Object} rp
 * @param {Array} d
 * @param {Color} baseClr
 * @returns {Color} color overlay
 */
function getColorBythreshold(chartObj, rp, d, baseClr) {
    var yaxiscolumnorder = rp.yaxiscolumnorder,
        threshold = rp.threshold,
        thresholdType = rp.thresholdType,
        dataset = chartObj.dataset;

    var thresholdValue = (thresholdType == "x") ? dataset.getX(d) : dataset.getY(d, yaxiscolumnorder);
    return rp.colorOverlay(threshold, threshold.color, thresholdValue, baseClr);
}

/*
 * @param {Object} chartObj
 * @param {Array} d
 * @returns {Color} based on color scale
 */
function getColorByScale(chartObj, d) {
    var hiddenColor = "transparent",
        clrValue = chartObj.dataset.getClr(d),
        colorScale = chartObj.axes.clr.scale;

    if (isWithinColorRange(clrValue, chartObj, colorScale)) {
        if (clrValue === UNDEFINED){
            clrValue = null;
        }
        return colorScale(clrValue);
    } else {
        return hiddenColor;
    }
}

/*
 * @param {Object} chartObj
 * @returns {Scale} index scale
 */
function getColorIndexScale(chartObj) {
    var hasColorScale = colorscale_helpers.isQuantileColorScale(chartObj),
        user_ranges = chartObj.systemConf.legend.colorBand.ranges,
        scale;

    if (hasColorScale && user_ranges && user_ranges.length) { //color index scale is only for user ranges
        var colorScale = chartObj.axes.clr.scale,
            colorScale_domain = colorScale.domain(),
            patternPallete = chartObj.patternPallete,
            imagePallete = chartObj.imagePallete,
            pallete;

        if (imagePallete && imagePallete.length) {
            pallete = imagePallete;
        } else if (patternPallete && patternPallete.length) {
            pallete = patternPallete;
        }
        if (pallete) {
            scale = colorScale.copy();
            scale.range(colorscale_helpers.getProcessedColorRange(d3_range(pallete.length), colorScale_domain, chartObj.systemConf.legend.colorBand, chartObj));
        }
    }
    return scale;
}

/*
 * @param {Object} chartObj
 * @param {Scale} colorIndexScale
 * @param {Array} d
 * @param {Number} i
 * @returns {Number} color index
 */
function getColorIndex(chartObj, colorIndexScale, d, i) {
    var clrValue = chartObj.dataset.getClr(d);
    if (isWithinColorRange(clrValue, chartObj)) {
        if (colorIndexScale) {
            return colorIndexScale(clrValue);
        } else {
            return i;
        }
    }
}//$Id$
function merged_axis_column_intersect(axisorder, chartObj) {
    var metaData = chartObj.systemConf.metadata;
    var indices = metaData.axes.y[axisorder];
    var start = 1,
        end = indices.length - 1;
    
    var col1 = metaData.columns[indices[start - 1]];
    var output = col1[col1.datatype];
    
    for (; start <= end; start++) {
        var col2 = metaData.columns[indices[start]];
        var formatConf2 = col2[col2.datatype];
        
        output = intersectObject(output, formatConf2);
    }
    return output;
}

function getOppositeOrient(orient) {
    switch (orient) {
        case "left":
            return "right";
        case "right":
            return "left";
        case "top":
            return "bottom";
        case "bottom":
            return "top"
    }
}

function isRotatedChart(type, axisRotated) {
    return (type == "x" && axisRotated) || (type == "y" && !axisRotated)
}

function getAxisObject(chartObj, type, index){
    var obj;
    if(type == "x"){
        if(index == 0){
            obj = chartObj.axes.x;
        }else{
            chartObj.axes.x.levels[index-1] = chartObj.axes.x.levels[index-1] || {};
            obj = chartObj.axes.x.levels[index-1];
        }
    } else if (type === "clr") {
        obj = chartObj.axes.clr;
    } else {
        chartObj.axes.y.groups[index] = chartObj.axes.y.groups[index] || {};
        obj = chartObj.axes.y.groups[index];
    }
    return obj;
}
function isTickAutoRotate(chartObj, type, order,tickLabelConfig){
    var isHierarchy = chartObj.axes.x.count > 1 && type == "x" && order > 0,
        rotation = tickLabelConfig.rotation;
    return (rotation == "auto" && !isHierarchy);
}
//$Id$
var colorscale_helpers = {};
colorscale_helpers.getProcessedColorRange = function(range, domain, options, chartObj) {
	var userStops = options.stops,
		userRanges = options.ranges,
		processed_range = [];
	if (userStops && userStops.length) {
		var prevStopIndex = 0;
		domain.forEach(function(d, i) {
			var stopIndex = userStops.indexOf(d);
			if (stopIndex === -1) {
				stopIndex = prevStopIndex;
			}
			processed_range.push(range[stopIndex % range.length]);
			prevStopIndex = stopIndex;
		});
	} else if (userRanges && userRanges.length) {
		userRanges = getRawRanges(chartObj, true);
		var isOrdinal = chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE;
		var i = 0,
			check = function(r, j) {
				if ((r.length === 1) ? (isOrdinal ? (r[0] === domain[i]) : (r[0] === domain[i+1])) : (r[0] === domain[i] && r[1] === domain[i+1])) {
					rangeIndex = j;
					return true;
				}
			};

		for (var len=domain.length; i<len; (isOrdinal ? i++ : i+=2)) {
			var rangeIndex = -1;
			userRanges.some(check);
			if (rangeIndex === -1 || userRanges[rangeIndex].disabled) {
				processed_range.push(null);
			} else {
				processed_range.push(range[rangeIndex % range.length]);
			}
		}
	} else {
		processed_range = range;
	}

	// interpolateRGBA is not available in d3.v3. So we consider the rgba color as rgb. Remove this once we switch to d3.v4
	// ***START
	processed_range = processed_range.map(function(d){
		return (typeof d === "string") ? rgb2hex(d) : d;
	});
	// ***END

	return processed_range;
};

colorscale_helpers.getColorDomain = function(chartObj) {
	var options = chartObj.systemConf.legend.colorBand,
		userStops = options.stops,
		userRanges = options.ranges,

		minmax = colorscale_helpers.getMinMaxClr(chartObj),
		min = pick(options.minRange, minmax[0]) || 0, //min may be undefined|null //Test_695.json
		max = pick(options.maxRange, minmax[1]) || 0; //max may be undefined|null //Test_695.json

	if (userStops && userStops.length) {
		var copy_userStops = d3_values(userStops);
		copy_userStops.sort(d3_ascending);
		var filteredStops = copy_userStops.filter(function(d) {
			var condition = true;
			if (defined(options.minRange)) {
				condition = condition && (d >= options.minRange);
			}
			if (defined(options.maxRange)) {
				condition = condition && (d <= options.maxRange);
			}
			return condition;
		});

		if (min < filteredStops[0] || !filteredStops.length) {
			filteredStops.splice(0, 0, min);
		}
		if (max > filteredStops[filteredStops.length - 1]) {
			filteredStops.splice(filteredStops.length, 0, max);
		}
		return filteredStops; //Add percentage support
	} else if (userRanges && userRanges.length) {
		var copy_userRanges = getRawRanges(chartObj),
			final_ranges = [],
			isOrdinal = chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE;

        if (isOrdinal) {
        	final_ranges = copy_userRanges;
        } else {
        	if (copy_userRanges[0].length === 1) {
        		var m = min;
		        copy_userRanges = copy_userRanges.map(function(d) {
		        	var newRange = [m, d[0]];
		        	m = newRange[1];
		        	return newRange;
		        });
        	}
        	final_ranges = copy_userRanges;
        	final_ranges.splice(0, 0, [-Infinity, -MAX_SAFE_INTEGER]);
        	final_ranges.splice(final_ranges.length, 0, [MAX_SAFE_INTEGER, Infinity]);
        }
		var merged_userRanges = d3_merge(final_ranges);
		return merged_userRanges;

	}
	return [min, max];
};

/*
 * @param {Object} chartObj
 * @returns {Array} minmax
 */
colorscale_helpers.getMinMaxClr = function(chartObj) {
	var seriesdata = chartObj.seriesdata,
		colorValuesArray = [];

	seriesdata.forEach(function(series) {
		if (!series.disabled) {
			var curSeriesdata = series.data || series;
			colorscale_helpers.pushColorValues(chartObj, curSeriesdata, colorValuesArray)
		}
	});
	return d3_extent(colorValuesArray);
};

/*
 * @param {Object} chartObj
 * @param {Object} root
 * @param {Array} colorValuesArray
 */
colorscale_helpers.pushColorValues = function(chartObj, root, colorValuesArray) {
	if (root && isArray(root) && isArray(root[0])) {
		root.forEach(function(child) {
			colorscale_helpers.pushColorValues(chartObj, child, colorValuesArray);
		});
	} else {
		var clrValue = chartObj.dataset.getClr(root);
		colorValuesArray.push(clrValue);
	}
};

colorscale_helpers.isQuantileColorScale = function(chartObj) {
	if (chartObj.axes.clr) {
		return chartObj.axes.clr.scaleType === "quantile";
	} else {
		var dataObject = chartObj.dataObject;
		//check for hierarchy chart
		return defined(chartObj.dataset.clridx) && !(dataObject.noofAreaEnabledSeries || dataObject.isPolarAxisCategory || (dataObject.allChartTypes && dataObject.allChartTypes.indexOf($ZC.charttype.line) > -1));
	}
};

colorscale_helpers.quantileScale = function() {
  var domain = [],
      range = [],
      quantiles = [];

  function scale(x) {
  	var index;
    quantiles.forEach(function(d, i) {
    	if (x >= d[0] && x <= d[1]) {
    		index = i;
    	}
    });
    return defined(index) ? range[index] : null;
  }

  scale.domain = function(_) {
  	if (arguments.length) {
  		domain = _;;
   		for(var i=0; i<domain.length; i+=2) {
  			quantiles.push([domain[i], domain[i + 1]]);
  		}
  		return scale;
  	}
  	return domain;
  };

  scale.range = function(_) {
    if (arguments.length) {
  		range = _;
  		return scale;
  	}
  	return range;
  };

  scale.copy = function() {
    return colorscale_helpers.quantileScale()
        .domain(domain)
        .range(range);
  };
  return scale;
};

function getRawRanges(chartObj, dont) {
	var userRanges = chartObj.systemConf.legend.colorBand.ranges;

	var copy_userRanges = simpleClone(userRanges),
		isOrdinal = chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE;

	if (!isArray(copy_userRanges[0])) {
		copy_userRanges = copy_userRanges.map(function(d) {
			return [d];
		});
	}

	if (!isOrdinal && !dont) {
		copy_userRanges.sort(function(a, b) {
	           return d3_ascending(a[0], b[0]);
	       });
	}
	return copy_userRanges;
}
//$Id$
$ZC.scale.constructor = function(chartObj, orient, scaleFunc, eventscaleFunc) {
    var scale;
    var defaultscaleFunc = $ZC.scale.getScale,
        defaulteventscaleFunc = $ZC.scale.getEventScale;

    scaleFunc = pick(scaleFunc, defaultscaleFunc);
    eventscaleFunc = pick(eventscaleFunc , defaulteventscaleFunc);

    switch (orient) {
        case 'left':
            scale = (chartObj.axes.rotated) ? getxscale() : getyscale();
            break;
        case 'bottom':
            scale = (chartObj.axes.rotated) ? getyscale() : getxscale();
            break;
    }
    return scale;
    
    function getxscale() {

        var processor = chartObj.dataObject,
            hierarchical = processor.hierarchical,
            levels = 0,
            extent = (chartObj.brush) ? chartObj.brush.extent : null,
            xaxes = chartObj.axes.x;

        chartObj.axes.x.scale = scaleFunc(chartObj, chartObj.dataObject, chartObj.plotarea, chartObj.axes.x.orient, 0, chartObj.dataset, "x", extent);
        chartObj.axes.x.eventscale = (eventscaleFunc == null) ? chartObj.axes.x.scale : eventscaleFunc(chartObj, chartObj.dataObject, chartObj.plotarea, chartObj.axes.x.orient, null, chartObj.dataset, "x"); //No I18N

        if (defined(hierarchical)) {

            chartObj.axes.x.rangeScale = chartObj.axes.x.scale.copy();
            if (hierarchical.groupByDiscreteTime) {
                chartObj.axes.x.rangeScale.domain(processor.getDomain(processor.getCategories("x")));
            }

            levels =  hierarchical.finalDepth;
            hierarchical.setRanges(chartObj.axes.x.rangeScale); // init all axes
            for (var i = 0; i < levels; i++) {
                if(!xaxes.levels[i]){
                    xaxes.levels[i] = {};
                }
                xaxes.levels[i].scale =  scaleFunc(chartObj, processor, chartObj.plotarea, chartObj.axes.x.orient, i + 1, chartObj.dataset, "x", extent, null);
            }
        }

        return [{
            scale: chartObj.axes.x.scale
        }].concat(xaxes.levels);
    }
    
    function getyscale() {
        var splityaxes = chartObj.axes.y.count;
        var yaxes = chartObj.axes.y;
        for (var i = 0; i < splityaxes; i++) {
            if (!yaxes.groups[i]) {
                yaxes.groups[i] = {};
            }
            yaxes.groups[i].scale = scaleFunc(chartObj, chartObj.dataObject, chartObj.plotarea, chartObj.axes.y.orient, i, chartObj.dataset, "y");
            yaxes.groups[i].eventscale = (eventscaleFunc == null) ? yaxes.groups[i].scale : eventscaleFunc(chartObj, chartObj.dataObject, chartObj.plotarea, chartObj.axes.y.orient, i, chartObj.dataset, "y");
        }
        return chartObj.axes.y.groups;
    }
};

$ZC.scale.getScale = function(chartObj, dataObj, plotarea, orient, index, dataset, type, extent, outerPadding) {

    var scale, domain;
    var systemconf = chartObj.systemConf;
    var datatype = dataset.getDataType(type, index),
        axis_data = getAxisOptions(),
        hierarchical = dataObj.hierarchical;
    
    /*
     * If hasCustomMinRange or hasCustomMaxRange is present, the correction should not be applied to the scale domain
     * Test cases :- Test_535.json, Test-536.json
     */
    var hasCustomMinRange = defined(axis_data.minRange),
        hasCustomMaxRange = defined(axis_data.maxRange);
    
    var chartType = chartObj.chartTypes[0].name;
    var commonPlotOptions = systemconf.chart.plot.plotoptions[chartType];
    var isPolar = (chartType === "dial") || (chartType === "web" && type === "x"),
        isHeatmap = (chartType === "heatmap"),
        hasColorScale = type === "clr" && colorscale_helpers.isQuantileColorScale(chartObj);
    
    var range = getRange(),
        padding = getPadding(),
        outerPadding = getOuterPadding();

    switch (datatype) {
        case 'numeric':
            if (extent) {
                domain = extent;
            } else if (type === "x") {
                domain = dataObj.getMinMaxX(0);
            } else if (type === "y") {
                domain = dataObj.getMinMaxY(index, outerPadding);
            } else if(type === "z"){
                domain = dataObj.getMinMaxZ();
            } else {
                domain = colorscale_helpers.getColorDomain(chartObj);
                range = colorscale_helpers.getProcessedColorRange(range, domain, axis_data, chartObj);
            }

            var actualStart = domain[0],
                actualEnd = domain[1];
            if (domain[0] == "NoData" && domain[1] == "NoData") { //for addorremoveaxis
                domain = [0, 0];
            }
            if (extent || type == "x") {
                var diff = (domain[1] - domain[0]);
                var correction = (diff == 0) ? chartObj.plotarea.width / 2 : (diff * outerPadding);
                domain[0] = hasCustomMinRange ? domain[0] : domain[0] - correction;
                domain[1] = hasCustomMaxRange ? domain[1] : domain[1] + correction;
            }
            
            var scaleMode = (type === "clr" && axis_data.ranges && axis_data.ranges.length) ? colorscale_helpers.quantileScale : d3_scaleLinear;
            scale = scaleMode()
                .domain(domain)
                .range(range);

            var actualRange = [scale(actualStart), scale(actualEnd)];
            scale.actualRange = actualRange;
            break;
        case 'ordinal':
            if (extent) {
                domain = extent;
            } else if(type === "clr") {
                domain = colorscale_helpers.getColorDomain(chartObj);
                range = colorscale_helpers.getProcessedColorRange(range, domain, axis_data, chartObj);
            } else {
                var categories = dataObj.getCategories(type, index);
                domain = dataObj.getDomain(categories, true)
            }

            var d3_outerPadding = 0;
            if (outerPadding) {
                d3_outerPadding = $ZC.scale.getOuterPadding(range, domain.length, padding, outerPadding);
                if (chartType !== "bullet") {
                    d3_outerPadding += dataObj.extendOuterpadding(domain, range, systemconf, padding, d3_outerPadding, type, index);
                }
            }

            scale = d3_scaleOrdinal()
                .domain(domain);

            if (type === "clr") {
                scale.range(range);
            } else {
                scale.rangeBands(range, padding, d3_outerPadding);
            }
            // hierarchical.setRanges(scale);
            break;
        
        case 'time':
            var column = dataset.getColumn(type, index),
                metaConf = column[column.datatype],
                subfunction = pick(metaConf && metaConf.subfunction, "YEAR"),
                useUTC = pick(metaConf && metaConf.useUTC, false);

            if (extent) {
                domain = extent;
            } else if(type === "x") {
                domain = dataObj.getMinMaxX(0);
            } else {
                domain = dataObj.getMinMaxY(index, 0)
            }
            
            var start = new Date(domain[0]),
                end = new Date(domain[1]),
                actualStart,
                actualEnd;
            
            /*
             * Below condition for only zoom purpose. becauze this function reset the time to its base value
             * So, when any chart is zoomed , that time no need set the time to it's default value.
             */
            
            if (!systemconf.chart.axes[type + "axis"].disableBaseValue) {
                var dateInterval = new date_utils(metaConf);
                dateInterval.useUTC = useUTC;
                dateInterval.getBaseValue(start, subfunction, false)
                dateInterval.getBaseValue(end, subfunction, true);
            }
            actualStart = start, actualEnd = end;
            
            if (dataObj.isBubbleEnabled) {
                var correctionOverBubbles = dataObj.overBubbles([start.getTime(), end.getTime()], type, (type == "y" ? index : null));
                start = new Date(start.getTime() - correctionOverBubbles[0]);
                end = new Date(end.getTime() + correctionOverBubbles[1]);
            }

            var diff = (end.getTime() - start.getTime());
            var outerPaddingCorrection = (diff == 0) ? chartObj.plotarea.width / 2 : (diff * outerPadding);
            
            var correctionOverDatalabels = (outerPadding == 0) ? 0 : dataObj.getCorrectionOverDataLabels([start.getTime(), end.getTime()], "x");
            start = new Date(hasCustomMinRange ? domain[0] : start.getTime() - outerPaddingCorrection - correctionOverDatalabels);
            end = new Date(hasCustomMaxRange ? domain[1] : end.getTime() + outerPaddingCorrection + correctionOverDatalabels);
            
            domain = [start, end]
            
            scale = d3_scaleTime()
                .domain(domain)
                .range(range);
            var actualRange = [scale(actualStart), scale(actualEnd)];
            scale.actualRange = actualRange;
            break;

        case "ordinalNonLinear": {
            // init the scale with the leaf scale;

            var categories = dataObj.getCategories(type, index);
            domain = dataObj.getDomain(categories);
            var rangeList = (hierarchical.rangeList) ? hierarchical.rangeList[index - 1]:null;

            scale = $ZC.nonLinearOrdinalScale()
                .domain(domain)
                .rangeExtent(range)
                .rangeBands(rangeList);
        }
    }
    scale.outerPadding = outerPadding;
    return scale;
    
    function getRange() {
        var axisReversed = axis_data.reversed;

        if (isPolar) {
            return axisReversed ?
                [validateNullVal(commonPlotOptions.endAngle, 2 * mathPI), validateNullVal(commonPlotOptions.startAngle, 0)] :
                [validateNullVal(commonPlotOptions.startAngle, 0), validateNullVal(commonPlotOptions.endAngle, 2 * mathPI)];
        } else if (type === "clr") {
            return chartObj.seriesColor;
        } else if (type === "z") {
            if (isHeatmap) {
                var size = 1;
                return [perToPx(commonPlotOptions.minSize, size, perToPx("25%", size)), perToPx(commonPlotOptions.maxSize, size, perToPx("100%", size))];
            }

            var zChartName;
            if (dataObj.isCombinationalChart) {
                chartObj.chartTypes.some(function(d){
                    var name = d.name;
                    if (name === "bubble" || name === "bubblepie") {
                        zChartName = name;
                        return true;
                    }
                });
            } else {
                zChartName = chartType;
            }

            var zConf = systemconf.chart.plot.plotoptions[zChartName] || {},
                dim = mathMin(plotarea.width, plotarea.height),
                size = validateNullVal(zConf.size, 1);
            return [perToPx(zConf.minSize, dim, perToPx("2.5%", dim)) * size, perToPx(zConf.maxSize, dim, perToPx("25%", dim)) * size]
        } else {
            var borderSize = dataObj.getPlotBorder();
            return axisReversed ?
                    ((orient === "bottom" || orient == "top") ?
                        [getPlotSize(chartObj, "width", plotarea) - borderSize.right, borderSize.left] :
                        [borderSize.top, getPlotSize(chartObj, "height", plotarea) - borderSize.bottom]) :
                    ((orient === "bottom" || orient == "top") ?
                        [borderSize.left, getPlotSize(chartObj, "width", plotarea) - borderSize.right] :
                        [getPlotSize(chartObj, "height", plotarea) - borderSize.bottom, borderSize.top])
        }
    }

    function getPadding() {
        if (isPolar || isHeatmap || (type != "x")) {
            return 0;
        } else {
            return validateNullVal(commonPlotOptions.padding, (dataObj.noofBarEnabledSeries ? 0.2 : 0.9)); //default value is 0.2 (Bar, Bullet, Gantt) or 0.9 (Others)
        }
    }

    function getOuterPadding() {
        if (isPolar || hasColorScale || isHeatmap) {
            return 0;
        } else if (type === "y") {
            return validateNullVal(axis_data.outerPadding, 0.05);
        } else if (outerPadding != null) {
            return outerPadding
        } else {
            return validateNullVal(commonPlotOptions.outerPadding, 0.02);
        }
    }

    function getAxisOptions() {
        if (type === "x") {
            return systemconf.chart.axes.xaxis;
        } else if (type === "clr") {
            return systemconf.legend.colorBand;
        } else {
            return systemconf.chart.axes.yaxis[index || 0];
        }
    }
};

$ZC.scale.getEventScale = function(chartObj, dataObj, plotarea, orient, index, dataset, type) {
    var datatype = dataset.getDataType(type, index);
    var scale;
    switch (datatype) {
        
        default:
            scale = $ZC.scale.getScale(chartObj, dataObj, plotarea, orient, index, dataset, type); //No I18N ;
    }
    return scale;
};

$ZC.scale.invert = function(datatype, mousePos, scale, axisrotated, type, axisReversed) {
    var actualPos;
    switch (datatype) {
        case 'numeric':
        case 'time':
            var point = (type == "y") ? (axisrotated ? mousePos.x : mousePos.y) : (axisrotated ? mousePos.y : mousePos.x);
            actualPos = scale.invert(point);
            break;
        case 'ordinal':
            var ordinalRange = scale.range();
            var rangeBand = scale.rangeBand();
            var diffRange = (ordinalRange.length > 1) ? mathAbs(ordinalRange[1] - ordinalRange[0]) : 0;
            var actualPadding = mathAbs(diffRange - rangeBand);
            ordinalRange = ordinalRange.map(function(d) {
                return d - (actualPadding / 2)
            });
            var rangeReversed = (axisrotated && !axisReversed) || (!axisrotated && axisReversed);
            var bisector = d3_bisector((type == "y") ? (rangeReversed ? d3_ascending : d3_descending) : (rangeReversed ? d3_descending : d3_ascending));
            var bisectVal = (type == "y") ? (axisrotated ? mousePos.x : mousePos.y) : (axisrotated ? mousePos.y : mousePos.x);
            var xbisect = bisector.left(ordinalRange, bisectVal, 0, ((axisrotated && axisReversed) ? ordinalRange.length : ordinalRange.length - 1))
            var toCmp1 = (axisrotated) ? (bisectVal) : (ordinalRange[xbisect]);
            var toCmp2 = (axisrotated) ? (ordinalRange[xbisect - 1]) : (bisectVal);
            actualPos = (xbisect > 0) ? (toCmp1 > toCmp2 ? xbisect - 1 : xbisect) : xbisect;
            break;
    }
    return actualPos;
};

$ZC.scale.barBandwidth = function(chartObj) {
    var systemconf = chartObj.systemConf,
        dataObj = chartObj.dataObject;
    var m = dataObj.isstacked() ?
        (dataObj.groupedByStack.keys().length || 1) // length = 0 for continuous chart with ordinal scale
        :
        d3_sum(chartObj.seriesdata.map(function(d) {
            if (dataObj.isBarEnabled(d)) {
                return d.data.length;
            }
        })); // no of series
    var temp = chartObj.chartTypes[0];
    var chartType = temp.name;
    var isBullet = temp.value == $ZC.charttype.bullet,
        isHeatmap = isHeatMapChartType(temp.value);

    var plotBorderOptions = systemconf.chart.plot.border;
    var borderSize = plotBorderOptions.show === true ? plotBorderOptions.size : 0;
    var padding = (chartType == "gantt" || chartType == "bullet" || chartType == "bar") ? systemconf.chart.plot.plotoptions[chartType].padding || 0.2 : 0.2;
    var interPadding = (m == 1) ? 0 : (chartType == "bar" || chartType == "gantt") ? systemconf.chart.plot.plotoptions[chartType].interPadding || 0 : 0;
    
    var outerPadding = systemconf.chart.plot.plotoptions[chartType].outerPadding;
    outerPadding = ((outerPadding != null) && (outerPadding !== "")) ? outerPadding : 0.02;
    var n = chartObj.axes.x.scale.domain().length //chart.dataObject.getCategories("x").length;
    var range = !chartObj.axes.rotated ? [borderSize, getPlotSize(chartObj, "width", chartObj.plotarea) - borderSize] : [getPlotSize(chartObj, "height", chartObj.plotarea) - borderSize, borderSize],
        barscale1, barscale2;
    
    outerPadding = $ZC.scale.getOuterPadding(range, n, padding, outerPadding);
    outerPadding += dataObj.extendOuterpadding(d3_range(n), range, systemconf, padding, outerPadding, "x");
    
    chartObj.barscale1 = barscale1 = chartObj.axes.x.scale;
    chartObj.barscale2 = barscale2 = d3_scaleOrdinal()
        .domain(d3_range(m))
        .rangeBands([0, barscale1.rangeBand()], interPadding);
    
    //setting bandwidth if the actual bandwidth is greater than the maximum bar bandwidth
    barscale2.rangeBands([0, barscale1.rangeBand()], interPadding);
    var maxBandWidth = (dataObj.noofBarEnabledSeries && !isBullet) ? systemconf.chart.plot.plotoptions[dataObj.noofGanttEnabledSeries ? "gantt" : isHeatmap ? "heatmap" : "bar"].maxBandWidth || barscale1.rangeBand() : 200;
    if (!isBullet && (barscale2.rangeBand() > maxBandWidth)) {
        var outspace = (barscale1.rangeBand() - (m * maxBandWidth)) / 2;
        barscale2.rangeBands([outspace, (barscale1.rangeBand() - outspace)], interPadding);
    }
    return [barscale1, barscale2]
};

$ZC.scale.getOuterPadding = function(range, domainLength, padding, outerPadding) {
    var rangeDiff = range[1] - range[0];
    var pad = outerPadding * rangeDiff;
    var step = (rangeDiff - (2 * pad)) / (domainLength - padding + (2 * 0));
    return pad / step;
};

/**
 *
 * @param scale linear scale
 * @param points tick values
 * @returns {{outerPaddingInPixel, rangeBand: number}}
 */

$ZC.scale.getContinuousRangeBand = function(scale, points, index) {

    var firstPointSpan = scale(points[0]),
        currentPointSpan = (index && points[index]) ? scale(points[index]) : firstPointSpan,
        nextPointSpan = (index && points[index+1]) ? scale(points[index+1]) : scale(points[1]),
        rangeBand = nextPointSpan - currentPointSpan,
        ranges = scale.range(),
        // for axes rotated or axes reversed.
        correction = rangeBand < 0 ? -1 : 1;

    return {
        "outerPaddingInPixel": correction * mathMin(mathAbs(firstPointSpan - ranges[0]), mathAbs(rangeBand / 2)),
        "rangeBand": rangeBand / 2
    }
};
$ZC.scale.getDiscreteRangeBand = function(scale){
    var rangeBand = scale.rangeBand(),
        rangeExtent = scale.rangeExtent(),
        outerPadding = (scale.range()[0] - rangeExtent[0])+(rangeBand/2),
        diffBand = (scale.domain().length > 1) ? scale.range()[1] - scale.range()[0] - rangeBand : 0;
    return {
        "outerPaddingInPixel": mathMin(outerPadding,value_1),
        "rangeBand": ((rangeBand/2) + (diffBand/2))
    }

}
$ZC.scale.getRangeBand = function(scale, points, index){
    var rb;
    if(scale.rangeBand){
        rb = $ZC.scale.getDiscreteRangeBand(scale);
    }else{
       rb = $ZC.scale.getContinuousRangeBand(scale, points, index);
    }
    return (mathAbs(rb.rangeBand)+mathAbs(rb.outerPaddingInPixel));
}

function getCategoryStep(rangeband, padding){
    return (rangeband/(1-padding));
}

function getOuterPaddingInPixel(plotSize, count, padding, userOuterPadding, step){
    var outerPadding = $ZC.scale.getOuterPadding(plotSize, count, padding, userOuterPadding),
        outerPaddingPx = 2 * (plotSize[0] + step * outerPadding);
    return outerPaddingPx;
};

$ZC.nonLinearOrdinalScale = function() {

    var range, domain, rangeBands, rangeExtent, ranges;

    function scale(x) {
        if(range) {
            return range.get(x)
        }
        return null;
    }

    scale.domain = function(_) {
        if (!arguments.length) {
            return domain
        }
        domain = _;
        return scale;
    };
    scale.rangeBand = function(){
        return 0; //Dummy rangeband for proper tickTransform and tickExit in d3.v3
    }
    scale.rangeBands = function(x) {
        if (!arguments.length) {
            return rangeBands
        }
        if(x == null) {return scale}
        ranges = x;
        rangeBands = new d3_map();
        range = new d3_map();
        var i = -1,
            n = x.length;
            temp = 0;
        while (++i < n) {
            range.set(i, x[i][0]);
            rangeBands.set(i, x[i][1]-x[i][0]);
        }
        return scale;
    };
    scale.discreteWidth = function(x) {
        if(!rangeBands){
            return null
        }
        return rangeBands.get(x);
    };
    scale.rangeExtent = function(_) {
        if (!arguments.length) {
            return rangeExtent
        }
        rangeExtent = _;
        return scale;
    };
    scale.range = function() {
        if(range){
            return range.values();
        }
        return null;
    };
    scale.copy = function() {
        return $ZC.nonLinearOrdinalScale().domain(domain).rangeBands(ranges).rangeExtent(rangeExtent);
    };
    return scale;
};//$Id$
$ZC.axis.render = function(chartObj, chartWidth, chartHeight, update) {
    
    var systemconf = chartObj.systemConf,
        dataObject = chartObj.dataObject;
    var plotBorderDrawn = {
            left: false,
            right: false,
            top: false,
            bottom: false
        },
        wrap = chartObj.svg.selectAll('g.xychart'),
        axes_animation_duration = get_animation_duration(),
        metaData = chartObj.systemConf.metadata,
        yMajorTicksIndex = 0,
        xMajorTicksIndex = 0,
        // data processor helpers

        dataProcessorHelpers = $ZC.DataProcessor.helpers,
        getParsedYAxisOrder = dataProcessorHelpers.getParsedYAxisOrder;

    chartObj.axes.animationDuration = axes_animation_duration;
    // construct zscale
    chartObj.zscale = defined(chartObj.dataset.zidx) ? $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, chartObj.axes.x.orient, null, chartObj.dataset, "z") : null;
    /*
     construct ticks
     */
    //copy of plotarea
    var plotarea_approx = {
        "left": chartObj.plotarea.left,
        "top": chartObj.plotarea.top,
        "width": chartObj.plotarea.width,
        "height": chartObj.plotarea.height
    };

    $ZC.axis.constructTickObj(chartObj, chartWidth, chartHeight, "left", plotarea_approx, update);
    $ZC.axis.constructTickObj(chartObj, chartWidth, chartHeight, "bottom", plotarea_approx, update);
    chartObj.zscale = defined(chartObj.dataset.zidx) ? $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, chartObj.axes.x.orient, null, chartObj.dataset, "z") : null;

    //Changing plot area for bullet chart
    if (chartObj.chartTypes[0].value === $ZC.charttype.bullet) {
        var commonPlotOptions = systemconf.chart.plot.plotoptions.bullet,
            len = dataObject.getCategories("x").length,
            padding = pick(commonPlotOptions.padding, 0.2),
            outerPadding = commonPlotOptions.outerPadding;
        outerPadding = ((outerPadding != null) && (outerPadding !== "")) ? outerPadding : 0.2;
        outerPadding = $ZC.scale.getOuterPadding((rotated ? [0, plotarea_approx.width] : [plotarea_approx.height, 0]), len, padding, outerPadding); //consider plot borderSize in range
        var levelMarkerOptions = commonPlotOptions.levelMarker,
            targetMarkerOptions = commonPlotOptions.targetMarker || {},
            plotarea = chartObj.plotarea,
            rotated = chartObj.axes.rotated;
        
        var defaultBandWidth = ((rotated ? plotarea_approx.height : plotarea_approx.width) / (len - padding + (2 * outerPadding))) * (1 - padding);
        var levelMarkerBandWidth = validateNullVal(levelMarkerOptions.bandWidth, defaultBandWidth),
            levelMarkerMaxBandWidth = validateNullVal(levelMarkerOptions.maxBandWidth, defaultBandWidth);
        var LBW = mathMin(levelMarkerBandWidth, levelMarkerMaxBandWidth, defaultBandWidth);
        
        var barBandWidth = validateNullVal(commonPlotOptions.bandWidth, LBW),
            barMaxBandWidth = validateNullVal(commonPlotOptions.maxBandWidth, barBandWidth);
        var BBW = mathMin(barBandWidth, barMaxBandWidth, defaultBandWidth);
        
        var targetMarkerWidth = defined(targetMarkerOptions.size) ? mathMin((targetMarkerOptions.size * 10), defaultBandWidth) : 0;
        var bandWidth = mathMax(BBW, LBW, targetMarkerWidth);
        
        var step = bandWidth / (1 - padding);
        bandWidth = step * (len - padding + (2 * outerPadding));
        
        if (rotated) {
            plotarea.height = bandWidth + (plotarea.height - plotarea_approx.height);
            plotarea.top += (plotarea.adjust = (plotarea_approx.height - bandWidth) / 2);
        } else {
            plotarea.width = bandWidth + (plotarea.width - plotarea_approx.width);
            plotarea.left += (plotarea.adjust = (plotarea_approx.width - bandWidth) / 2);
        }
    }
    
    var scale1 = $ZC.scale.constructor(chartObj, "left")
    for (var i = 0; i < scale1.length; i++) {
        var axis = createAxis("left", i);
        
        axis = setAxisProp(scale1[i].scale, "left", i, update);
        if (axis != null) {
            drawAxes(axis, i, "left", update);
        }
    }
    var scale2 = $ZC.scale.constructor(chartObj, "bottom")
    for (var i = 0; i < scale2.length; i++) {
        var axis = createAxis("bottom", i);
        
        axis = setAxisProp(scale2[i].scale, "bottom", i, update);
        if (axis != null) {
            drawAxes(axis, i, "bottom", update);
        }
    }
    
    if (chartObj.dataset.getDataType("x") == ORDINAL_DATATYPE) {
        $ZC.scale.barBandwidth(chartObj);
    }
    
    function get_animation_duration() {
        var axes_animation = systemconf.chart.axes.animation || {},
            enabled = axes_animation.enabled;
        
        if(!defined(enabled)) {
            var serdata = (chartObj.isAxisCategory || chartObj.isNonAxisMultiSeriesCategory) ? chartObj.seriesdata : chartObj.seriesdata.slice(0, 1);
            enabled = serdata.some(function(d, i) {
                var type = chartObj.chartTypes[i].name;
                return getAnimationConf(systemconf.chart.plot.plotoptions[type], d.plotoptions, chartObj, type).enabled;
            });
        }

        return enabled ? pick(axes_animation.duration, 600) : 0;
    }
    //To bring axis line front
    function updateAxisLine(orient, axisdata, wrap, axisComp, isaxis) {
        // To bring axis line front, make plotarea border color as axis line color
        var plotBorderData = systemconf.chart.plot.border;
        
        var plotareaBorderEle = chartObj.container.selectAll("g.plotareaBorder-property");
        var bkpInf = null;

        if ((defined(plotBorderData) && plotBorderData.show === true) ) {
            var borderEle = plotareaBorderEle.selectAll("path.plotBorderPath");
            var borderSize =validateValWithinLimit(plotBorderData, "size", 0, 10, chartObj.plotarea.width, chartObj.plotarea.height);
            borderSize = (borderSize == null || borderSize === "") ? 2 : borderSize;
            var radius = chartObj.dataObject.getTransRectValue("radius",null,null,null,null,plotBorderData.radius);
            var rectAttr = roundedRect(0,0,chartObj.plotarea.width,chartObj.plotarea.height,radius,false,false);
            

            borderEle.style({
                "stroke-width" : borderSize,
                "stroke" : plotBorderData.color,
                "stroke-dasharray": getDashArray(plotBorderData.style, borderSize),
                "fill":"none",
                "pointer-events":"none"
            }).attr({
                "d":rectAttr
            })
            plotareaBorderEle.selectAll("line").style("stroke","transparent");
        }
        
        else {
            var axislineData = axisdata.axisline;
            var axislineClr = (axislineData.show == false || axislineData.color == null) ? "transparent" : axislineData.color;
            var axislineWidth = validateNullVal(axislineData.strokeWidth, 1);
            var axislineStyle = axislineData.style || "solid";

            var axislineEle = appendEle(plotareaBorderEle, "line", [1], ".", "class", orient);

            if(isaxis  == false || axisdata.show == false || wrap.style("visibility") == "hidden"){
                axislineEle.style("stroke","transparent");
                return;
            }
            var x1,x2,y1,y2;
            if(orient == "bottom"){
                x1 = 0 , x2 = chartObj.plotarea.width, y1 = chartObj.plotarea.height, y2 = chartObj.plotarea.height
            }else if(orient == "left"){
                x1 = 0 , x2 = 0, y1 = 0, y2 = chartObj.plotarea.height
            }else if(orient == "right"){
                x1 = chartObj.plotarea.width , x2 = chartObj.plotarea.width, y1 = 0, y2 = chartObj.plotarea.height
            }else if(orient == "top"){
                x1 = 0 , x2 = chartObj.plotarea.width, y1 = 0, y2 = 0
            }

            axislineEle.style({
                "stroke-width" : axislineWidth,
                "stroke" : axislineClr,
                "shape-rendering":"crispedges",
                "stroke-dasharray": getDashArray(axislineStyle, axislineWidth)
            }).attr({
                "x1":x1,"x2":x2,"y1":y1,"y2":y2
            })

            bkpInf = {
                "size": axislineWidth,
                "clr": axislineClr
            };
            plotareaBorderEle.node()["border-" + orient] = bkpInf;
           
        }
        
        wrap.selectAll("path.domain")
            .style("stroke", "transparent")
        
    }
    
    function getAxisOrient(data, type, index) {
        var orient = data.orient;
        var axesRotated = chartObj.axes.rotated;
        orient = (orient == null) ? ((type == "x") ? ((axesRotated) ? "left" : "bottom") :
                ((axesRotated) ? "bottom" : (index == 0) ? "left" : "right")) :
            orient;
        return orient;
    }
    
    function createAxis(orient, index) {
        var axes = [];
        switch (orient) {
            case 'left':
                axes = (chartObj.axes.rotated) ? createAxisComp("x", index) : createAxisComp("y", index);
                break;
            case 'bottom':
                axes = (chartObj.axes.rotated) ? createAxisComp("y", index) : createAxisComp("x", index);
                break;
        }
        return axes;
    }
    
    function setAxisProp(scale, orient, i, update) {
        var type = (orient == "left") ? ((chartObj.axes.rotated) ? "x" : "y") :
            ((chartObj.axes.rotated) ? "y" : "x");
        var axisComp = getAxisObject(chartObj,type,i).component;

        var axes = setAxisCompConfig(axisComp, type, scale, orient, i, update);
        return axes;
    };
    
    function createAxisComp(type, index) {
        var axes = getAxisObject(chartObj,type,index);
        var axis_data = (type == "x") ? systemconf.chart.axes.xaxis : (systemconf.chart.axes.yaxis[index] || systemconf.chart.axes.yaxis[0]);

        // first axis disabled. on redraw it is enabled
        var axisComp = axes.component;
        if (axisComp) {
            return axisComp;
        }
        axes.component = (type == "x") ? ((axis_data.show && dimension_based_intelligence(chartObj, "xaxis", chartHeight)) ? $ZC.axis.get() : null) :
                                        (axis_data.show) ? $ZC.axis.get() : null;

        return axisComp;
    }
    
    function drawAxes(axis, index, orient, update) {
        var axes = [];
        var type = (orient == "left") ? ((chartObj.axes.rotated) ? "x" : "y") :
            ((chartObj.axes.rotated) ? "y" : "x");
        axes = drawAxisComp(axis, type, index, update);
        return axes;
    };
    
    function setAxisCompConfig(axis, type, scale, orient, index, update) {
        var axisdata = (type == "x") ? systemconf.chart.axes.xaxis : systemconf.chart.axes.yaxis[index];
        var orient = getAxisOrient(axisdata, type, index);
        var tickPadding = (orient == "bottom") ? axisdata.ticklabel.marginTop : (orient == "top") ? axisdata.ticklabel.marginBottom : (orient == "left") ? axisdata.ticklabel.marginRight : axisdata.ticklabel.marginLeft;
        tickPadding = pick(tickPadding, 5);
        
        var dim = (orient == "bottom" || orient == "top") ? chartHeight : chartWidth;
        var isaxis = axisdata.show === true && dimension_based_intelligence(chartObj, (type + "axis"), dim);
        if (type === "y" && !isaxis) {
            yMajorTicksIndex++;
        }
        if (isaxis) {
            var yaxisComp = chartObj.axes.y.groups;
            var tickObj = getAxisObject(chartObj,type,index).ticks;

            var oldAxisLen = tickObj.preCalcAxisLen;
            var preCalcTickLen = tickObj.preCalcApproxAxisLength(plotarea_approx);
            var adjustVal = (tickObj.preCalcAxisLen - oldAxisLen);
            var tickValueObj = tickObj.tickValueObj;

            if (adjustVal) {
                adjustPlotarea(orient, adjustVal);
            }

            
            if (axis != null) {
                var isMergedAxis = (type == "y") ? (metaData.axes.y[index].length > 1) : false;
                var hasTimegroupBy = tickObj && tickObj.isHierarchy() && chartObj.dataObject.hierarchical.groupByTime;
                var columnidx = chartObj.dataset.getColumnIdx(type, (hasTimegroupBy)?0:index); //column index should be 0 for multi level x axis
                var datatype = metaData.columns[columnidx]["datatype"];
                datatype = tickObj && tickObj.isHierarchialLevelType() &&chartObj.dataObject.hierarchical.categoryTree ? ORDINAL_DATATYPE : datatype;
                var formatConf = metaData.columns[columnidx][datatype];
                formatConf = (isMergedAxis && type == "y") ? merged_axis_column_intersect(index, chartObj) : formatConf;
                var axisFormat = formatConf && (formatConf.axisformat || formatConf.format);
                var tickSize = validateNullVal(axisdata.tickmark.size, 6);
                var formattingFunction = (dataObject.isStackedPercentChart && type == "y") ? getFormattedValueByPercent : getFormattedValue;
                var specifierIndex =  (hasTimegroupBy) ? index : null;
                axis
                    .scale(scale)
                    .tickPadding(tickPadding)
                    .tickSize(tickSize, 0)
                    .majorTicks((index === (type === "y" ? yMajorTicksIndex : xMajorTicksIndex)) ? getMajorTicks(orient) : null)
                    .orient(orient)
                    .plotarea(chartObj.plotarea)
                    .systemconf(chartObj.systemConf)
                    .tickRotation(tickValueObj.rotation)
                    .preCalcTickLen(tickObj.preCalcTickLen)
                    .chartObj(chartObj)
                    .columnIndices((isMergedAxis && type == "y") ? metaData.axes.y[index] : [columnidx])
                    .isMultiLineTick((!(tickObj && tickObj.isHierarchy()))&&formatConf && axisFormat && axisFormat.specifier && axisFormat.specifier.constructor == Array);
                
                var format = (formatConf != null) ? (formatConf.axisformat || formatConf.format) : null;
                if (format && format.specifier == "auto") {
                    axis
                        .ticks(orient == "bottom" ? chartObj.plotarea.width / 100 : chartObj.plotarea.height / 40)
                } else {
                    var tickPos = tickObj.getActualTicklabel();
                    axis
                        .tickValues(tickObj.getTicksforAxisComp())
                        .tickFormat(function(d,i) {
                            var tick = tickPos(i);
                            return formattingFunction(formatConf, tick, datatype, chartObj, "axis",null,null, specifierIndex);
                        });
                }
                
                if (!((type === "y") && yaxisComp[index].disabled)) {
                    axis.plotBorderDrawn = !plotBorderDrawn[orient];
                    plotBorderDrawn[orient] = true;
                }
                
                axis.hideAxisLabel = !dimension_based_intelligence(chartObj, (type + "axislabel"), dim); //hide axislabel by intelligence
                
            }
        }
        
        return axis;
    }
    
    function drawAxisComp(axis, type, index, update) {
        var axisdata = (type == "x") ? systemconf.chart.axes.xaxis : systemconf.chart.axes.yaxis[index];
        var orient = axis.orient();
        var dim = (orient == "bottom" || orient == "top") ? chartHeight : chartWidth;
        var isaxis = axisdata.show === true && dimension_based_intelligence(chartObj, (type + "axis"), dim);
        var selector = (type == "x") ? type + '-axis-' + index : type + '-axis-' + index;
        var axisWrap = appendEle(wrap.selectAll("g." + type + "-axis"), "g", (isaxis ? [axisdata] : []), ".", "class", selector);

        axisWrap
            .style("display", ((type === "y") && chartObj.axes.y.groups[index].disabled) ? "none" : null);
        
        if (update) {
            axis.tickLabelWidth(0);
        }
        if (isaxis) {
            axisWrap.transition().duration(axes_animation_duration).call(axis, type, index);
            chartObj.plotarea = axis.plotarea();

            if(type === "x") {
                adjustXAxiswrap(axisdata, index, axis)
            } else {
                adjustYAxeswrap(axisdata, index, axis)
            }
            if (update) {
                setTimeout(function() {
                    if(axis.isMultiLineTick()){
                        axisWrap.selectAll("text.ticklabel").call(wrapTicklabels);
                    }

                    handleOverflowTicks_init(axisWrap, axis, chartObj, axisdata, orient,index);
                }, axes_animation_duration)
            } else {
                handleOverflowTicks_init(axisWrap, axis, chartObj, axisdata, orient,index);
            }
        }else{
            updateAxisLine(orient, axisdata, axisWrap, axis,isaxis)
        }
        
        //Initializing chart brush before drawing x axes
        if (type == "y" && isObjectPropDefined(systemconf.chart, "scroll") && systemconf.chart.scroll.enabled) {
            chartObj.brush.initialize(chartObj.plotarea)
        }
    }
    
    function adjustXAxiswrap(data, index, axis) {
        var usedAxisSpace = {
            left : 0,
            top : 0,
            right : 0,
            bottom : 0
        };
        var axisCount = chartObj.axes.x.count;
        if(index == axisCount -1){
            for(var i=0; i<axisCount; i++){
                var axisObj = getAxisObject(chartObj,"x",i);
                var axisComp = axisObj.component;
                var xwrapboxWid = axisComp.tickLabelWidth();
                var xwrap = wrap.selectAll('.x-axis-' + i);
                var xorient = axis.orient();
                var transX = (xorient == "right") ? (chartObj.plotarea.left + chartObj.plotarea.width) + usedAxisSpace.right : (chartObj.plotarea.left - usedAxisSpace.left);
                var transY = (chartObj.axes.rotated || xorient == "top") ? chartObj.plotarea.top - usedAxisSpace.top: (chartObj.plotarea.top + chartObj.plotarea.height + usedAxisSpace[xorient])
                usedAxisSpace[xorient] += xwrapboxWid;
                xwrap
                    .attr("transform", "translate(" + transX + "," + transY + ")");
            }
            var xwrap = wrap.selectAll('g.x-axis-0');

            // if (chartObj.axes.rotated) {
            //     xwrap
            //         .selectAll("line.majorTicks")
            //         .attr("x2", chartObj.plotarea.width)
            // }
            updateAxisLine(xorient, data, xwrap, axis);
        }

    }
    
    function adjustYAxeswrap(data, index, axis, strictMode) {
        var yaxisData = systemconf.chart.axes.yaxis,
            yaxesLength = chartObj.axes.y.groups.length;
        var yaxis0_wrap = wrap.selectAll('.y-axis-0');
        var yaxis0_orient = yaxisData[0].orient || ((chartObj.axes.rotated) ? "bottom" : (yaxisData[0].orient || "left"));

        if (strictMode || index == yaxesLength - 1) {
            var usedAxisSpace = {
                left : 0,
                top : 0,
                right : 0,
                bottom : 0
            };
            for (var j = 0; j < yaxesLength; j++) {
                
                var ydata = yaxisData[j];
                var orient = ydata.orient;
                orient = orient || ((chartObj.axes.rotated) ? "bottom" : (ydata.orient != null) ? ydata.orient : (j == 0) ? "left" : "right")
                if (ydata.show === true) {
                    var axisComp = chartObj.axes.y.groups[j].component;
                    var ywrap = wrap.selectAll('.y-axis-' + j);
                    var ywrapboxWid = axisComp.tickLabelWidth();
                    
                    var translateX = (orient == "bottom" || orient == "top")
                            ? chartObj.plotarea.left
                            : ((orient === "left")
                                ? (chartObj.plotarea.left - usedAxisSpace[orient])
                                : (chartObj.plotarea.left + chartObj.plotarea.width + usedAxisSpace[orient])),
                        translateY = ((orient == "bottom") ? (chartObj.plotarea.height + chartObj.plotarea.top) : (chartObj.plotarea.top)) ;
                    usedAxisSpace[orient] += (chartObj.axes.y.groups[j].disabled) ? 0 : ywrapboxWid;


                    ywrap
                        .attr("transform", "translate(" + translateX + "," + translateY + ")");
                    
                    // handleOverflowTicks_init(ywrap, axisComp, chartObj, ydata, axisComp.orient());
                    
                    //Bringing Axis line to front
                    if (axisComp.plotBorderDrawn == true) {
                        updateAxisLine(orient, ydata, ywrap, axis);
                    }
                    
                }
            }
            
            (!chartObj.axes.rotated) ? yaxis0_wrap
                    .selectAll("line.majorTicks")
                    .attr("x2", (yaxis0_orient == "right") ? -chartObj.plotarea.width : chartObj.plotarea.width): null;
        }
        
    }
    function getMajorTicks(orient) {
        if (orient == "bottom") {
            return [0, -chartObj.plotarea.height]
        } else if (orient == "top") {
            return [0, chartObj.plotarea.height]
        } else if (orient == "left") {
            return [chartObj.plotarea.width, 0]
        } else if (orient == "right") {
            return [-chartObj.plotarea.width, 0]
        }
        
    }

    function adjustPlotarea(orient, adjustVal) {
        var plotarea = chartObj.plotarea;
        if (orient === "left") {
            plotarea.left += adjustVal;
            plotarea.width -= adjustVal;
        } else if (orient === "right") {
            plotarea.width -= adjustVal;
        } else if (orient === "bottom") {
            plotarea.height -= adjustVal;
            plotarea.bottom += adjustVal;
        } else {
            plotarea.height -= adjustVal;
            plotarea.top += adjustVal;
        }
    }
    
    function addorremoveAxis(axisWrap, axisComp, data, index, type, mode) {
        //Now only type is "Y" as multiY axis is available
        /*
         *For multiY axis charts alone,
         *mode - add, add the axis  mode - remove ,filtering or remove axis
         *Change the plotarea width, left with respect to the axis wrap width
         */
         //Reset plotborderdrawn and g.plotareaBorder-property
         plotBorderDrawn = {
            left: false,
            right: false,
            top: false,
            bottom: false
        }
        chartObj.container.selectAll("g.plotareaBorder-property").selectAll("line").style("stroke","transparent");
        var orient = axisComp.orient();
        var scale = axisComp.scale();
        var majorTicks = axisComp.majorTicks();
        var wrapWid = axisWrap.node().getBBox().width;
        wrapWid += (orient == "left") ? data.label.marginLeft : data.label.marginRight;
        wrapWid = (majorTicks != null) ? axisComp.tickLabelWidth() : axisComp.tickLabelWidth();
        if (!(axisWrap.style("visibility") === "hidden" && mode === "remove")){
            chartObj.plotarea.width = (mode == "add") ? chartObj.plotarea.width - wrapWid : chartObj.plotarea.width + wrapWid;
            chartObj.plotarea.left = (orient == "left") ? (mode == "add") ? chartObj.plotarea.left + wrapWid : chartObj.plotarea.left - wrapWid : chartObj.plotarea.left;
        }

        
        var co = 0;
        var visibility = (mode == "add") ? "visible" : "hidden";
        axisWrap.style("visibility", visibility);
        if ((mode == "add")){
            axisWrap.style("display", null);
        }
        
        for (var i = 0; i < chartObj.axes.y.groups.length; i++) {
            var ywrap = wrap.selectAll("g.y-axis-" + i)
            var curAxisComp = chartObj.axes.y.groups[i].component;
            var curAxisOrient = curAxisComp.orient();
            var curMajorTicks = curAxisComp.majorTicks();
            var curAxisData = systemconf.chart.axes.yaxis[i] || systemconf.chart.axes.yaxis[0];
            
            //Translate the yaxis wraps according to added/removed axiswrap width
            // adjustYAxeswrap(data, index, curAxisComp, true);

            //If the axis to be removed have majorticks, then draw the major ticks for next upcoming axis
            if (ywrap.style("visibility") != "hidden" && co == 0) {
                curMajorTicks = getMajorTicks(curAxisOrient);
                curAxisComp.majorTicks(curMajorTicks);
                ywrap.transition().duration(axes_animation_duration).call(curAxisComp, type, i);
                co++
            } else if (curMajorTicks != null && co > 0) {
                curAxisComp.majorTicks(null);
                ywrap.transition().duration(axes_animation_duration).call(curAxisComp, type, i);
            }
            //set proper curAxisComp.plotBorderDrawn according to their visibility in order
            if(ywrap.style("visibility") == "visible" &&  !plotBorderDrawn[curAxisOrient]){
                plotBorderDrawn[curAxisOrient] = true;
                curAxisComp.plotBorderDrawn = true;
            }else{
                curAxisComp.plotBorderDrawn = false;
                //Set axisline color for the other components where plotBorderDrawn = false
                if (ywrap.style("visibility") == "visible") {
                    ywrap.selectAll("path.domain")
                        .style("stroke", curAxisData.axisline.color);
                }else{
                    ywrap.selectAll("path.domain")
                        .style("stroke", "transparent");
                }
            }
            
            
        }
        adjustYAxeswrap(data, index, axisComp, true);
    }
    chartObj.updateZscale = function() {
        defined(chartObj.dataset.zidx) ? chartObj.zscale.domain(dataObject.getMinMaxZ()): null;
    };
    
    chartObj.updateScale = function(serData, type, zmInterval, axisorder) {
        var extentVal;
        var yaxiscolumnorder = (type == "y") ? getParsedYAxisOrder((serData == null || isArray(serData)) ? serData : serData.yaxiscolumnorder) : 0,
            axisorder = (type == "x" && defined(axisorder)) ? axisorder : yaxiscolumnorder,
            axiswrap = wrap.selectAll("g." + type + "-axis-" + axisorder),
            axes = getAxisObject(chartObj,type,axisorder),
            tickObj = axes.ticks,
            axisdata = (type == "x") ? systemconf.chart.axes.xaxis : systemconf.chart.axes.yaxis[yaxiscolumnorder],
            orient = (axes.component) ? axes.component.orient() : getAxisOrient(axisdata, type, yaxiscolumnorder),
            dim = (orient == "bottom" || orient == "top") ? chartHeight : chartWidth,
            isaxis = axisdata.show === true && dimension_based_intelligence(chartObj, (type + "axis"), dim);
        
        var columnidx = chartObj.dataset.getColumnIdx(type, yaxiscolumnorder),
            datatype = metaData.columns[columnidx].datatype,
            datatype = tickObj && tickObj.isHierarchialLevelType() &&chartObj.dataObject.hierarchical.categoryTree ? ORDINAL_DATATYPE : datatype,
            formatConf = metaData.columns[columnidx][datatype],
            hasTimegroupBy = tickObj && tickObj.isHierarchy() && chartObj.dataObject.hierarchical.groupByTime,
            specifierIndex =  (hasTimegroupBy) ? axisorder : null;
        //Update scale
        if (zmInterval) {
            extentVal = zmInterval;
            var newScale = $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, orient, yaxiscolumnorder, chartObj.dataset, type, extentVal);
            axes.eventscale = axes.scale = newScale;
        } else {
            var chartType = chartObj.chartTypes[0].name;
            var outerPadding = systemconf.chart.plot.plotoptions[chartType].outerPadding;
            extentVal = (datatype == ORDINAL_DATATYPE) ? dataObject.getCategories(type, axisorder) : (type == "x") ? chartObj.dataObject.getMinMaxX(validateNullVal(outerPadding, 0.2)) : chartObj.dataObject.getMinMaxY(yaxiscolumnorder);
            var newScale = $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, orient, axisorder, chartObj.dataset, type);
            axes.eventscale = axes.scale = newScale;
        }

        //Update axis
        if (type == "y" && !axiswrap.empty() && extentVal[0] == "NoData" && extentVal[1] == "NoData") { //Check again; no updation in ordinal y scale
            //No need to update the scale and axis
            if (isaxis) addorremoveAxis(axiswrap, axes.component, axisdata, yaxiscolumnorder, "y", "remove")
            
        } else if (type == "y" && !axiswrap.empty() && axiswrap.style("visibility") == "hidden" && axiswrap.style("display") !== "none") {
            if (isaxis) addorremoveAxis(axiswrap, axes.component, axisdata, yaxiscolumnorder, "y", "add");
        } else {
            
            if (dataObject.isBubbleEnabled && type == "y") {
                axes.eventscale = axes.scale = $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, orient, yaxiscolumnorder, chartObj.dataset, "y");
            }
            
            if (isaxis) {
                axes.component.scale(axes.scale);
                //set axisconfig
                formatConf = ((metaData.axes.y[yaxiscolumnorder].length > 1) && type == "y" && formatConf != null && !formatConf.axisformat) ? null : formatConf;
                var formattingFunction = (dataObject.isStackedPercentChart && type == "y") ? getFormattedValueByPercent : getFormattedValue;
                var formatConf_axis = (formatConf != null) ? (formatConf.axisformat || formatConf.format) : null;
                if (formatConf_axis && formatConf_axis.specifier == "auto") {
                    axes.component
                        .ticks(chartObj.axes.rotated ? chartObj.plotarea.height / 40 : chartObj.plotarea.width / 100)
                } else {
                    var tickObj = axes.ticks;
                    var oldLongTickSize = (orient == "bottom" || orient == "top") ? tickObj.tickValueObj.longTickSize.height : tickObj.tickValueObj.longTickSize.width;
                    var tickValueObj = tickObj.getTickValues(chartObj.plotarea.width, chartObj.plotarea.height, zmInterval, false, null, axes.Ticks, chartObj.plotarea);
                    tickObj.tickValueObj = tickValueObj;
                    var curLongTickSize = (orient == "bottom" || orient == "top") ? tickObj.tickValueObj.longTickSize.height : tickObj.tickValueObj.longTickSize.width;
                    var preCalcTickLen = tickObj.preCalcTickLen;
                    
                    var adjustVal = (oldLongTickSize > curLongTickSize) ? (curLongTickSize - oldLongTickSize) : ((oldLongTickSize < curLongTickSize) ? (curLongTickSize - oldLongTickSize) : 0);
                    (orient == "bottom" || orient == "top") ? preCalcTickLen.height = preCalcTickLen.height + adjustVal: preCalcTickLen.width = preCalcTickLen.width + adjustVal

                    var tickValues = tickObj.getTicksforAxisComp();
                    var tickPos = tickObj.getActualTicklabel();
                    axes.component.tickValues(tickValues)
                                  .tickFormat(function(d,i) {
                                        var tick = tickPos(i);
                                        return formattingFunction(formatConf, tick, datatype, chartObj, "axis",null,null,specifierIndex);
                                    })
                                  .tickRotation(tickValueObj.rotation);
                }
                //call axis
                axiswrap.transition().duration(axes_animation_duration).call(axes.component, type, axisorder).each("end", function() {
                    handleOverflowTicks_init(axiswrap, axes.component, chartObj, axisdata, orient, axisorder);
                });

                var fullUpation = !axiswrap.empty() && axiswrap.style("display") === "none" && (type === "y");
                if (fullUpation) {
                    addorremoveAxis(axiswrap, axes.component, axisdata, yaxiscolumnorder, "y", "add")
                }

                if (adjustVal && adjustVal != 0) { //Bug IdZC795 //hack ; hav to change logic for redraw in zoom

                    if (!fullUpation) {
                        adjustPlotarea(orient, adjustVal);
                    }
                    var type_opp = (type == "x") ? "y" : "x";
                    chartObj.updateScale(serData, type_opp);
                    chartObj.drawPlotareaClippath();
                    chartObj.updatePlotareaProp();

                }
                if (type === "y") {
                    axiswrap
                        .style({
                            "display" : null,
                            "visibility" : "visible"
                        });
                    adjustYAxeswrap(axisdata, yaxiscolumnorder, axes.component, true)
                } else {
                    adjustXAxiswrap(axisdata, axisorder, axes.component)
                }

                var PW = chartObj.plotarea.width;
                (!chartObj.axes.rotated && type == "y") ? wrap.selectAll('.y-axis-'+yaxiscolumnorder)
                        .selectAll("line.majorTicks")
                        .attr("x2", (orient != "right") ? PW : -PW): null;
                if (axes.component.plotBorderDrawn == true) {
                    updateAxisLine(orient, axisdata, axiswrap, axes.component);
                }

            }
        }
    };

    function handleOverflowTicks_init(wrap, axis, chartObj, axisdata, orient, index) {
        var ticklabel_data = axisdata.ticklabel;
        var textOverflow = ticklabel_data.textOverflow;
        if (textOverflow !== "none") {
            var args = [null, orient, chartObj, axis.tickRotation(), textOverflow, axis.scale(), wrap, axis, "ticklabel", ticklabel_data,index];
            setTimeout(function() {
                handleOverflowTicks.apply(null, args);
            },17)
        }
    }
};

//$Id$
$ZC.axis.get = function() {
    var axis = d3_axis(),
        scale = d3_scaleLinear();
    var scale, ticks;

    var axisLabelMargin = {
            top: 0,
            right: 0,
            bottom: 5,
            left: 0
        },
        width = null,
        height = null,
        majorTicks = null,
        plotarea,
        tickLabelWidth = 0,
        curTickLabelWidth = 0,
        systemconf, axisline, chartObj, preCalcTickLen, orient, columnIndices,isMultiLineTick;

    var labeldata = {
            text: "Axis",
            fontFamily: "sans-serif",
            fontSize: 11,
            fontColor: "#575757"
        },
        ticklabeldata = {
            fontFamily: "sans-serif",
            fontSize: 11,
            fontColor: "#575757",
            rotation: 0
        },
        griddata = {
            color: "#666666",
            style: "strokeStyle1"
        },
        tickmarkdata = {
            color: "#ececec",
            size: 3,
            strokeWidth: null
        },
        axislinedata = {
            color: "#ececec"
        },
        tickRotation = 0,
        topbaseline = "0.71em"

    function chart(selection, type, axisOrder) {
        selection.each(function(data) {


            var container = d3_select(this);

            labeldata = data.label;
            ticklabeldata = data.ticklabel;
            tickmarkdata = data.tickmark;
            axisline = data.axisline;
            griddata = data.grid;

            var axisObj = getAxisObject(chartObj,type,axisOrder),
                tickComp = axisObj.ticks,
                tickObj = tickComp.tickValueObj;

            var hideAxisLabel = chart.hideAxisLabel || labeldata.show === false || !defined(labeldata.text) || labeldata.text === "" || (tickComp.isHierarchy() && axisOrder < chartObj.dataObject.hierarchical.finalDepth);
            if(hideAxisLabel) {
                axisLabelMargin.top = axisLabelMargin.bottom = axisLabelMargin.left = axisLabelMargin.right = 0;
            } else {
                axisLabelMargin.top = pick(labeldata.marginTop, 5);
                axisLabelMargin.bottom = pick(labeldata.marginBottom, 5);
                axisLabelMargin.left = pick(labeldata.marginLeft, 5);
                axisLabelMargin.right = pick(labeldata.marginRight, 5);
            }

            var marginTickLabel_right = pick(ticklabeldata.marginRight, 5),
                marginTickLabel_left = pick(ticklabeldata.marginLeft, 5),
                marginTickLabel_bottom = pick(ticklabeldata.marginBottom, 5),
                marginTickLabel_top = pick(ticklabeldata.marginTop, 5);

            //For hierarchy only rotate 0 available
            // if(tickComp.isHierarchy()){
            //     tickRotation = 0;
            // }
            tickRotation = pick(tickRotation, 0);
            var rotation = (tickRotation < 0) ? (360 - mathAbs(tickRotation)) : tickRotation;
            rotation = (rotation > 360) ? (mathAbs(rotation) - 360) : rotation;

            chart.update = function() {
                container.call(chart);
            };

            orient = axis.orient();

            var g = container.selectAll('g.axisgroup').data([data]);
            g.enter().append('g').attr('class', 'axisgroup');
            g.exit().remove();

            if (ticks) {
                axis.ticks(ticks[0], ticks[1]);
            }

            // add clip-path

            if(chartObj.isAxisCategory && type !== "clr") {
                var defs = appendEle(chartObj.svg, "defs", [1]);

                //  Google Chrome(66.0.3359.139) crash fix #ZC1174
                var propertyObject = simpleClone(chartObj.plotarea);
                propertyObject.id = chartObj.id;
                //

                var id = generateIdByPropValue(propertyObject, type + axisOrder);
                var clipPath = appendEle(defs, "clipPath", [1], "#", "id", id);
                var clipRect = appendEle(clipPath, "rect", [1]);

                var rect = {}, axisRect = tickObj.axisgroup, percentLimit = 0.5, margin = {
                    left: (percentLimit * plotarea.left),
                    right: (percentLimit * (chartObj.canvasarea.width - (plotarea.left + plotarea.width))),
                    top: (percentLimit * plotarea.top),
                    bottom: (percentLimit * plotarea.bottom)
                };

                switch (orient) {
                    case "top": {
                        rect.x = -margin.left;
                        rect.y = -axisRect.height - tickmarkdata.size;

                        rect.height = axisRect.height + chartObj.plotarea.height + tickmarkdata.size;
                        rect.width = axisRect.width + margin.left + margin.right;
                        break;
                    }
                    case "right": {
                        rect.x = -chartObj.plotarea.width;
                        rect.y = -margin.top;
                        rect.width = axisRect.width + chartObj.plotarea.width;
                        rect.height = axisRect.height + margin.top + margin.bottom;
                        break;
                    }
                    case "bottom": {
                        rect.x = -margin.left;
                        rect.y = -chartObj.plotarea.height;
                        rect.height = axisRect.height + chartObj.plotarea.height;
                        rect.width = axisRect.width + margin.left + margin.right;
                        break;
                    }
                    case "left": {
                        rect.x = -axisRect.width;
                        rect.y = -margin.top;
                        rect.width = axisRect.width + chartObj.plotarea.width;
                        rect.height = axisRect.height + margin.top + margin.bottom;
                        break;
                    }
                }

                clipRect.attr(rect);
                g.attr('clip-path', "url(" + chartObj.defsLocation + "#" + id + ")");
            }

            var majorticklength = 0;


            g.call(axis);

            //Event handlers for tick labels
            var events = data.ticklabel.events;
            var mousemoveFn, mouseoutFn, clickFn, dblclickFn, cursor, eventDisabled,
                tapFn,
                tapHoldFn,
                tapHoldEndFn,
                doubleTapFn;

            if (events != null) {
                eventDisabled = (validateNullVal(events.enabled, true) == false);
                mousemoveFn = events.mousemove;
                mouseoutFn = events.mouseout;
                clickFn = events.click;
                dblclickFn = events.doubleclick;
                cursor = events.cursor;

                tapFn = events.tap;
                tapHoldFn = events.taphold;
                tapHoldEndFn = events.tapholdend;
                doubleTapFn = events.doubletap;
            }
            cursor = cursor || "pointer";

            var tickG0 = g.selectAll(".tick");
            var ticks1 = axis.tickValues() == null ? scale.ticks ? scale.ticks.apply(scale, [tickG0[0].length]) : scale.domain() : axis.tickValues();
            var tickG = g.selectAll(".tick").data(ticks1, scale);
            //Round Transform translate Attribute
            //
            //          tick.attr("transform",function(d,i){
            //              var ele = d3_select(this);
            //              var transform = ele.attr("transform");
            //              var replaced = transform.replace("translate(","").replace(")","").split(",")
            //
            //              return "translate("+parseFloat(replaced[0])+","+parseFloat(replaced[1])+")";
            //          })
            var majorticks = appendEle(tickG, "line", (griddata.show ? [1] : []), ".", "class", "majorTicks");
            var majorticksUpdate = tickG.select("line.majorTicks");


            var labelSize, axisLabel;
            if (type === "clr") {
                labelSize = 0;
            } else {
                var axes = type === "y" ? chartObj.axes.y.groups[axisOrder] : chartObj.axes.x;
                axisLabel = axes.axisLabel;
                labelSize = axisLabel.getBBox().height;
            }


            // var myAxisLabel = chartObj.axis

            var minorticks = tickG.selectAll("line").filter(function() {
                return this.getAttribute("class") != "majorTicks"
            });
            minorticks.attr('class', 'minorTicks');
            tickG.selectAll("text").attr('class', 'ticklabel');

            // Apply ticklabel properties

            var ticklabels = g.selectAll("text.ticklabel").data(ticks1, scale);
            if(isMultiLineTick){
                ticklabels.call(wrapTicklabels,chart.tickFormat());
            }
            if(tickComp.isHierarchialLevelType()){
                extendTickmarkLineLength(tickG,type,axisOrder);
            }
            var rotationInfo = getTickRotateInfo(orient, rotation, ticklabels, axis, tickmarkdata.size);
            applyFont(ticklabels, [ticklabeldata, systemconf.chart, systemconf.canvas, $ZCG]);

            ticklabels.style({
                    "cursor": cursor,
                    "text-anchor": rotationInfo.textAnchor
                })
                .attr({
                    "dy": function(d,i){
                        return (ticklabeldata.zigzag &&i%2 && rotationInfo.dy1) ? rotationInfo.dy1 : rotationInfo.dy
                    },
                    "transform": "rotate(" + rotationInfo.rotate[0] + " " + rotationInfo.rotate[1] + " " + rotationInfo.rotate[2] + ")"
                });

            var minmaxlabelsdata = ticklabeldata.minmaxlabels || {};
            if (minmaxlabelsdata.show === true) {
                var domain = scale.domain();
                var domainLength = domain.length - 1;
                var minmaxlabels = ticklabels.filter(function(d, i) {
                    return !(d - domain[0]) || !(d - domain[domainLength]);
                });
                applyFont(minmaxlabels, [minmaxlabelsdata, ticklabeldata, systemconf.chart, systemconf.canvas, $ZCG]);

                if ((orient === "top" || orient === "bottom") && (rotationInfo.textAnchor === "middle")) {
                    var axisReversed = data.reversed === true;
                    minmaxlabels
                        .style("text-anchor", function(d) {
                            return !(d - domain[axisReversed ? domainLength : 0]) ? null : "end"
                        });
                }
            }

            if (type !== "clr") {
                var columnInfo = {
                    "data": columnIndices.map(function(d) {
                        return mergeJSON(chartObj.systemConf.metadata.columns[d], {
                            "columnindex": d
                        }, true);
                    })
                };

                if (!eventDisabled) {
                    var mousemove, mouseout, click, dblclick,
                        tap, taphold, tapholdend, doubletap;
                    if (mousemoveFn) {
                        mousemove = function(d) {
                            invokeFunction(mousemoveFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (mouseoutFn) {
                        mouseout = function(d) {
                            invokeFunction(mouseoutFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (clickFn) {
                        click = function(d) {
                            invokeFunction(clickFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (dblclickFn) {
                        dblclick = function(d) {
                            invokeFunction(dblclickFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }

                    if (tapFn) {
                        tap = function(d) {
                            invokeFunction(tapFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (tapHoldFn) {
                        taphold = function(d) {
                            invokeFunction(tapHoldFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (tapHoldEndFn) {
                        tapholdend = function(d) {
                            invokeFunction(tapHoldEndFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }
                    if (doubleTapFn) {
                        doubletap = function(d) {
                            invokeFunction(doubleTapFn, d3.event, getDatawithColumnInfo(columnInfo, d), chartObj);
                        }
                    }

                    var mouseHandlers = {
                        "mousemove": mousemove,
                        "mouseout": mouseout,
                        "click": click,
                        "dblclick": dblclick
                    },
                    touchHandlers = {
                        "taphold": taphold,
                        "tapholdend": tapholdend,
                        "tap": tap,
                        "dbltap": doubletap
                    };
                    attachevents(ticklabels, mouseHandlers, touchHandlers);
                }


                if(defined(ticklabeldata.showAs)) {
                    ticklabels.each(function(d, i) {
                        if(defined(tickObj.customTicks[i])) {
                            this.innerHTML = "";
                            wrapTextContent(d3.select(this), tickObj.customTicks[i], null, true);
                        }
                    });
                }
            }

            if(ticklabeldata.tooltip === true) {
                addSVGtitleEle(ticklabels)
            }

            // Apply tickmarks properties

            if(!tickComp.isHierarchialLevelType() && tickmarkdata.align == "between"){
                drawTickLinesBetweenTicklabels(scale,tickG, "minorTicks");

            }

            g.selectAll("line.minorTicks,line#minorTicksAlign")
                .style({
                    "fill": "none",
                    "shape-rendering": "crispedges",
                    "stroke-width": tickmarkdata.strokeWidth,
                    "stroke": (tickmarkdata.hideParent && tickComp.isHierarchialLevelType()) ? "transparent" : tickmarkdata.color
                })

            // Apply Axisline properties
                g.selectAll("path.domain")
                    .style({
                        "stroke": axisline.show === false || axisline.hideParent ? "transparent" : axisline.color,
                        "stroke-width": pick(axisline.strokeWidth, 1),
                        "stroke-dasharray": getDashArray(axisline.style, pick(axisline.strokeWidth, 1))
                    });
            
            if (type !== "clr") {
                if(labeldata.tooltip === true) {
                    addSVGtitleEle(axisLabel.element);
                }
                if(tickComp.isHierarchialLevelType()){
                    ticklabels.call(centeringTicklabel,scale);
                }

                axisLabel.transformLabel(preCalcTickLen, plotarea, orient);
                switch (orient) {
                    case 'top':
                        curTickLabelWidth = (preCalcTickLen != null) ? preCalcTickLen.height + marginTickLabel_top + axisLabelMargin.bottom : 0;
                        curTickLabelWidth = curTickLabelWidth + labelSize + axisLabelMargin.top;
                        tickLabelWidth = curTickLabelWidth;
                        handleOverflowTicks(axisLabel.element, orient, chartObj, 0, "ellipsis", scale, g, chart, "axislabel");
                        break;
                    case 'bottom':
                        curTickLabelWidth = (preCalcTickLen != null) ? preCalcTickLen.height + marginTickLabel_bottom + axisLabelMargin.top : 0; //7 -> spacing between tickmark and ticklabels,axisLabelMargin.bottom -space bw ticklabel and axislabel
                        curTickLabelWidth = curTickLabelWidth + labelSize + axisLabelMargin.bottom;
                        tickLabelWidth = curTickLabelWidth;
                        handleOverflowTicks(axisLabel.element, orient, chartObj, 0, "ellipsis", scale, g, chart, "axislabel");
                        break;
                    case 'left':
                        curTickLabelWidth = (preCalcTickLen != null) ? preCalcTickLen.width + marginTickLabel_left + axisLabelMargin.right : 0;
                        curTickLabelWidth = curTickLabelWidth + labelSize + axisLabelMargin.left;
                        tickLabelWidth = curTickLabelWidth;
                        if (majorTicks !== null && griddata.show) {
                            majorTicks[0] = plotarea.width;
                        }
                        handleOverflowTicks(axisLabel.element, orient, chartObj, 270, "ellipsis", scale, g, chart, "axislabel");
                        break;
                    case 'right':
                        curTickLabelWidth = (preCalcTickLen != null) ? preCalcTickLen.width + marginTickLabel_right + axisLabelMargin.left : 0;
                        curTickLabelWidth = curTickLabelWidth + labelSize + axisLabelMargin.right;
                        tickLabelWidth = curTickLabelWidth;
                        handleOverflowTicks(axisLabel.element, orient, chartObj, 90, "ellipsis", scale, g, chart, "axislabel");
                        break;
                }
            }

            if (majorTicks && griddata.show) {
                var strokeWidth = pick(griddata.strokeWidth, 1),
                    strokeDashArray = getDashArray(griddata.style, strokeWidth),
                    strokeLineCap = getLineCap(griddata.lineCap, griddata.style);
                if(scale.rangeBand && tickmarkdata.align == "between"){
                    drawTickLinesBetweenTicklabels(scale,tickG, "majorTicks");
                }
                g.selectAll("line.majorTicks,line#majorTicksAlign")
                    .attr({
                        "x2": majorTicks[0],
                        "y2": majorTicks[1]
                    })
                    .style({
                        "fill": "none",
                        "shape-rendering": "crispedges",
                        "stroke-width": griddata.strokeWidth,
                        "stroke": griddata.color,
                        "stroke-dasharray": strokeDashArray,
                        "stroke-linecap": strokeLineCap
                    });

                if (type !== "clr") {
                    //To bring axis line front, make grid lines overlapped with axis line transparent
                    // var range = (scale.rangeExtent != null) ? scale.rangeExtent() : scale.range();
                    // var firstVal = (chart.tickValues() == null) ? null : (scale(chart.tickValues()[0]) + (scale.rangeBand ? (scale.rangeBand() / 2) : 0)),
                    //     opp_axisdata = (type == "x") ? systemconf.chart.axes.yaxis[0].axisline : systemconf.chart.axes.xaxis.axisline;
                    

                    //To bring axis line front, make grid lines overlapped with axis line transparent
                    var range = (scale.rangeExtent != null) ? scale.rangeExtent() : scale.range();
                    var firstVal = (chart.tickValues() == null) ? null : (scale(chart.tickValues()[0]) + (scale.rangeBand ? (scale.rangeBand() / 2) : 0));
                    var plotBorderData = chartObj.systemConf.chart.plot.border;

                    var plotareaBorderColor = plotBorderData === true ? plotBorderData.color : axislinedata.color;
                    if (defined(firstVal) && griddata.color !== "transparent" && plotareaBorderColor !== "transparent" && range[0] === firstVal) {
                        // d3_select(majorticksEnter[0][0]).style("stroke","transparent")
                        d3_select(majorticksUpdate[0][0]).style("stroke", "transparent")
                    }
                }
            }

            //BaseLine
            var baseLineData = data.baseline;
            if (baseLineData != null) {
                var baseLine = appendEle(g, "line", ((baseLineData.show === true && ((scale.domain()[0] <= baseLineData.value) && (baseLineData.value < scale.domain()[1]))) ? [1] : []), ".", "class", "zeroBase");
                baseLine.attr({
                        "x1": (orient == "left" || orient == "right") ? 0 : scale(baseLineData.value),
                        "y1": (orient == "left" || orient == "right") ? scale(baseLineData.value) : -plotarea.height,
                        "x2": (orient == "left" || orient == "right") ? plotarea.width : scale(baseLineData.value),
                        "y2": (orient == "left" || orient == "right") ? scale(baseLineData.value) : 0
                    })
                    .style({
                        "fill": "none",
                        "stroke": baseLineData.color,
                        "shape-rendering": "crispedges",
                        "stroke-width": (baseLineData.strokeWidth)
                    })
            }

        })
        return chart;
    }

    chart.axis = axis;

    d3_rebind(chart, axis, 'orient', 'ticks', 'tickValues', 'tickSubdivide', 'tickSize', 'tickPadding', 'tickFormat');
    d3_rebind(chart, scale, 'domain', 'range', 'rangeBand', 'rangeBands', 'ticks');
    chart.scale = function(_) {
        if (!arguments.length) {
            return scale;
        }
        scale = _;
        axis.scale(scale);
        d3_rebind(chart, scale, 'domain', 'range', 'rangeBand', 'rangeBands');
        return chart;
    }
    chart.systemconf = function(_) {
        if (!arguments.length) {
            return systemconf;
        }
        systemconf = _;
        return chart;
    };
    chart.ticks = function() {
        if (!arguments.length) {
            return ticks;
        }
        ticks = arguments;
        return chart;
    };

    chart.majorTicks = function(_) {
        if (!arguments.length) {
            return majorTicks;
        }
        majorTicks = _;
        return chart;
    }
    chart.plotarea = function(_) {
        if (!arguments.length) {
            return plotarea;
        }
        plotarea = _;
        return chart;
    };

    chart.tickLabelWidth = function(_) {
        if (!arguments.length) {
            return tickLabelWidth;
        }
        tickLabelWidth = _;
        return chart;
    };
    chart.tickRotation = function(_) {
        if (!arguments.length) {
            return tickRotation;
        }
        tickRotation = _;
        return chart;
    };
    chart.preCalcTickLen = function(_) {
        if (!arguments.length) {
            return preCalcTickLen;
        }
        preCalcTickLen = _;
        return chart;
    };
    chart.chartObj = function(_) {
        if (!arguments.length) {
            return chartObj;
        }
        chartObj = _;
        return chart;
    };
    chart.columnIndices = function(_) {
        if (!arguments.length) {
            return columnIndices;
        }
        columnIndices = _;
        return chart;
    };
    chart.isMultiLineTick = function(_) {
        if (!arguments.length) {
            return isMultiLineTick;
        }
        isMultiLineTick = _;
        return chart;
    };


    function getDatawithColumnInfo(columnInfo, d) {
        columnInfo.data = columnInfo.data.map(function(dt) {
            var datatype = dt.datatype;
            if (datatype == TIME_DATATYPE) {
                dt.value = generateDateVal(d, null, dt.time).getTime();
            } else {
                dt.value = d;
            }
            return dt;
        });
        return columnInfo;
    }
    //To align the tick lines (grid lines or tick mark) in between the ticklabels
    function drawTickLinesBetweenTicklabels(scale,tickG,type){
        var x2, y2,
            ticks = tickG[0],
            startTickG = d3.select(tickG.node()),
            lastTickG = d3.select(ticks[ticks.length-1]),
            tickLineNode = tickG.selectAll("line."+type).filter(function(d,i){
                return (this.getAttribute("id") != "minorTicksAlign")
            }),
            lastTickLineNode = lastTickG.selectAll("line."+type),
            newStartTickLineNode = appendEle(startTickG, "line", [1], "#", "id", type+"Align");

        var adjustDistance = getNewPositionForTickmark(scale);
        if(type == "minorTicks"){
            x2 = (orient == "bottom" || orient == "top") ? 0 : (-tickmarkdata.size),
            y2 = orient == "bottom" ? tickmarkdata.size : orient == "top" ? -tickmarkdata.size : 0;
        }else{
            x2 = majorTicks[0],
            y2 = majorTicks[1];
        }

        if(scale.rangeBand){
            tickLineNode.attr("transform","translate("+adjustDistance.mid+")");
            lastTickLineNode.attr("transform","translate("+adjustDistance.end+")");
            newStartTickLineNode.attr("transform","translate("+adjustDistance.start+")").attr("x2",x2).attr("y2",y2);
        }else{
            var co =0;
            tickLineNode.attr("transform",function (d,i) {
                var pos = getNewPositionForTickmark(scale,co++);
                return "translate("+pos.mid+")"
            })
            lastTickLineNode.attr("transform","translate("+adjustDistance.end+")");
            newStartTickLineNode.attr("transform","translate("+adjustDistance.start+")").attr("x2",x2).attr("y2",y2);
        }

    }

    function getNewPositionForTickmark(scale,index){
        var startPos, midPos, endPos, value_1,value_2;
        if(scale.rangeBand){
            var rangeBand = scale.rangeBand(),
                rangeExtent = scale.rangeExtent(),
                outerPadding = (scale.range()[0] - rangeExtent[0])+(rangeBand/2),
                diffBand = (scale.domain().length > 1) ? scale.range()[1] - scale.range()[0] - rangeBand : 0;
                value_1 = rangeBand/2 + diffBand/2,
                value_2 = mathMin(outerPadding,value_1);

        }
        else{
            var categories = chartObj.dataObject.hierarchical ? chartObj.dataObject.hierarchical.leafCategories : chart.tickValues(),
                continousRangeBand = $ZC.scale.getContinuousRangeBand(scale, categories ,index),
                rangeBand = continousRangeBand.rangeBand;
                value_1 = rangeBand,
                value_2 = continousRangeBand.outerPaddingInPixel;
        }

        midPos = (orient == "bottom" || orient == "top") ? (value_1 + ",0") : ("0,"+value_1),
        startPos = (orient == "bottom" || orient == "top") ? ((-value_2) + ",0") : ("0,"+(-value_2)),
        endPos = (orient == "bottom" || orient == "top") ? (value_2 + ",0") : ("0,"+value_2);

        return {
            "start" : startPos, "mid" : midPos , "end" : endPos
        };
    }




    // For hierarchy level type, tickmark line should get extend based on the last rendered axis ticklabel width

    function extendTickmarkLineLength(tickG,type,axisOrder){
        var axisObj = getAxisObject(chartObj,type,axisOrder) , axisComp = axisObj.component;
        var minorTicksNode = tickG.selectAll("line.minorTicks");
        var ticklabelWidth = getPreCalculatedTickWidth(type,axisOrder);
        axisObj.ticks.tickValueObj.tickMarkSize = ticklabelWidth+axisComp.tickSize();
        var index = axisOrder;

        var key = (orient == "left" || orient == "right") ? "x1" : "y1",
            value = (orient == "left" || orient == "top") ? ticklabelWidth : -ticklabelWidth;

        var nullKey = (orient == "left") ? "y1" : "x1"

        if(index == chartObj.dataObject.hierarchical.finalDepth){
            var y2 = (orient == "bottom") ? tickmarkdata.size : 0;
            var ticks = tickG[0];
            tickG.selectAll("line#minorTicksAlign").remove();
            var endTickG = d3.select(ticks[ticks.length-1]);
            var newEndTickmark = appendEle(endTickG, "line", [1], "#", "id", "minorTicksAlign");
            var scale = chartObj.axes.x.levels[index-1].scale;
            var domainLen = scale.domain().length;
            var toTranslate = (orient == "top" || orient == "bottom") ? (scale.discreteWidth(domainLen-1) + ",0") : ("0,"+scale.discreteWidth(domainLen-1));
            var key2 = (orient == "left" || orient == "right") ? "x2" : "y2",
                value2 = (orient == "left"|| orient == "top") ? -tickmarkdata.size : tickmarkdata.size;
            newEndTickmark.attr("transform","translate("+toTranslate+")").attr(key,value).attr(key2,value2);
        }

        minorTicksNode.attr(nullKey,null);
        minorTicksNode.attr(key,value);
    }

    function getPreCalculatedTickWidth(type, axisOrder){
        var ticklabelWidth = 0;
        while(axisOrder > 0){
            var axisObj = getAxisObject(chartObj,type,axisOrder-1) , axisComp = axisObj.component;
            ticklabelWidth += axisComp.tickLabelWidth();
            axisOrder--;
        }
        return ticklabelWidth;
    }

    //For nonlinear ordinal scale there is dynamic rangeband for every data. so we are centering it here.
    function centeringTicklabel(g, scale) {
        g[0].forEach(function(tickG,i){
            // if(scale.discreteWidth(i)){
            var keyIndex = (orient == "left" || orient == "right") ? 1 : 0;
            var old_transform = [0,0]//d3.transform(tickG.getAttribute("transform")).translate;
            var rangeBand_nonLinear = scale.discreteWidth(i)/2;

            old_transform[keyIndex] = old_transform[keyIndex]+rangeBand_nonLinear;
            tickG.setAttribute("transform","translate("+old_transform[0]+","+old_transform[1]+")");
            // }

        })
    }

    return chart;
};//$Id$
var date_utils = function(formatConf) {
    this.startWeekDay = defined(formatConf.startWeekDay) ? formatConf.startWeekDay : 1;
    this.startMonth = defined(formatConf.startMonth) ? formatConf.startMonth : 0;
};

date_utils.MILLISEC = 0;
date_utils.SECOND = 1;
date_utils.MINUTE = 2;
date_utils.HOUR = 3;
date_utils.DATE = 4;
date_utils.MONTH = 5;

date_utils.SECOND_TYPE = "ABSSECOND"; //Seconds wise
date_utils.MINUTE_TYPE = "ABSMINUTE"; //Minutes wise
date_utils.HOUR_TYPE = "ABSHOUR"; //Hours wise
date_utils.DAY_TYPE = "ABSDAY"; //Weekday wise(sunday,monday..)
date_utils.DATETIME_TYPE = "DATETIME"; //Date with time wise(18 Sep 2011 01:10:40)
date_utils.DATE_TYPE = "DATE"; //Date wise(18 Sep 2011)
date_utils.ABSWEEK_TYPE = "ABSWEEK"; //Week number wise
date_utils.ABSMONTH_TYPE = "ABSMONTH"; //Month wise
date_utils.ABSQUARTER_TYPE = "ABSQUARTER"; //Quarter wise,four quarters for each year(Q1,Q2,Q3,Q4)
date_utils.ABSYEAR_TYPE = "YEAR"; //Year wise

date_utils.D3_WEEKDAY_FNS = [d3_timeSunday, d3_timeMonday, d3_timeTuesday, d3_timeWednesday, d3_timeThursday, d3_timeFriday, d3_timeSaturday];
date_utils.DAY_MILLIS = 24 * 60 * 60 * 1000;

date_utils.prototype.setZero = function(dateVal, type) {
    var oldVal = 0;
    for (var i = 0; i <= type; i++)
        switch (i) {
            case date_utils.MILLISEC: {
                oldVal += this.getMilliseconds(dateVal);
                this.setMilliseconds(dateVal, 0);
            }
                break;
            case date_utils.SECOND: {
                oldVal += this.getSeconds(dateVal);
                this.setSeconds(dateVal, 0);
            }
                break;
            case date_utils.MINUTE: {
                oldVal += this.getMinutes(dateVal);
                this.setMinutes(dateVal, 0);
            }
                break;
            case date_utils.HOUR: {
                oldVal += this.getHours(dateVal);
                this.setHours(dateVal, 0);
            }
                break;
            case date_utils.DATE: {
                oldVal += (this.getDate(dateVal) - 1);
                this.setDate(dateVal, 1);
            }
                break;
            
            case date_utils.MONTH: {
                
                oldVal += this.getMonth(dateVal);
                this.setMonth(dateVal, this.startMonth); // set custom startMonth
            }
                break;
            default: {
                throw "unknown type 333: " + type;
            }
                break;
        }
    return oldVal;
};

date_utils.prototype.getBaseValue = function(dateVal, type, isCeil) {
    switch (type) {
        
        case date_utils.SECOND_TYPE:
        case date_utils.DATETIME_TYPE: {
            var oldVal = this.setZero(dateVal, date_utils.MILLISEC);
            if (isCeil && oldVal > 0) {
                this.setSeconds(dateVal, this.getSeconds(dateVal) + 1);
            }
        }
            break;
        case date_utils.MINUTE_TYPE: {
            var oldVal = this.setZero(dateVal, date_utils.SECOND);
            if (isCeil && oldVal > 0) {
                this.setMinutes(dateVal, this.getMinutes(dateVal) + 1);
            }
        }
            break;
        case date_utils.HOUR_TYPE: {
            var oldVal = this.setZero(dateVal, date_utils.MINUTE);
            if (isCeil && oldVal > 0) {
                this.setHours(dateVal, this.getHours(dateVal) + 1);
            }
        }
            break;
        case date_utils.DAY_TYPE:
        case date_utils.DATE_TYPE: {
            var oldVal = this.setZero(dateVal, date_utils.HOUR);
            if (isCeil && oldVal > 0) {
                this.setDate(dateVal, this.getDate(dateVal) + 1);
            }
        }
            break;
        
        case date_utils.ABSWEEK_TYPE: {
            var oldVal = this.setZero(dateVal, date_utils.SECOND);
            var startWeekDay = this.startWeekDay;
            if (isCeil) {
                if (oldVal > 0) {
                    this.setDate(dateVal, this.getDate(dateVal) + 1);
                }
                if (startWeekDay < this.getDay(dateVal)) {
                    this.setDate(dateVal, (this.getDate(dateVal) + (7 - this.getDay(dateVal) + startWeekDay)));
                } else {
                    this.setDate(dateVal, (this.getDate(dateVal) + (startWeekDay - this.getDay(dateVal))));
                }
            } else {
                
                if (startWeekDay > this.getDay(dateVal)) {
                    this.setDate(dateVal, (this.getDate(dateVal) - (7 - startWeekDay + this.getDay(dateVal))));
                } else {
                    
                    this.setDate(dateVal, (this.getDate(dateVal) - (this.getDay(dateVal) - startWeekDay)));
                }
            }
        }
            break;
        
        case date_utils.ABSQUARTER_TYPE:
        case date_utils.ABSMONTH_TYPE: {
            var oldVal = this.setZero(dateVal, date_utils.DATE);
            if (isCeil && oldVal > 0) {
                this.setMonth(dateVal, (this.getMonth(dateVal) + 1));
            }
        }
            break;
        
        case date_utils.ABSYEAR_TYPE: {
            var oldVal = this.setZero(dateVal, date_utils.MONTH);
            if (isCeil && oldVal > this.startMonth) { //set base value based on custom start month not by default 0
                this.setFullYear(dateVal, (this.getFullYear(dateVal) + 1));
            }
        }
            break;
        default: {
            throw "unknow type 222: " + type;
        }
    }
};

date_utils.prototype.getTicksList = function(t0, t1, dt, type) {
    var times = new Array();
    var t1Time = t1.getTime();
    var time = (t0.getTime());
    var t = new Date(time);
    
    while (time <= t1Time) {
        times.push(t);
        t = new Date(time);
        switch (type) {
            case date_utils.SECOND_TYPE:
            case date_utils.DATETIME_TYPE: {
                t.setTime(t.getTime() + mathFloor(dt) * 1000);
            }
                
                break;
            
            case date_utils.MINUTE_TYPE: {
                t.setTime(t.getTime() + dt * 60000);
            }
                break;
            case date_utils.HOUR_TYPE: {
                t.setTime(t.getTime() + dt * 3600000);
            }
                break;
            
            case date_utils.DAY_TYPE:
            case date_utils.DATE_TYPE: {
                t.setTime(t.getTime() + dt * date_utils.DAY_MILLIS);
            }
                break;
            case date_utils.ABSWEEK_TYPE: {
                this.setDate(t, (this.getDate(t) + dt));
            }
                break;
                
                break;
            case date_utils.ABSMONTH_TYPE:
            case date_utils.ABSQUARTER_TYPE: {
                this.setMonth(t, (this.getMonth(t) + dt));
            }
                break;
            
            case date_utils.ABSYEAR_TYPE: {
                this.setFullYear(t, (this.getFullYear(t) + dt));
            }
                break;
            
        }
        time = t.getTime();
    }
    return times;
    
};

date_utils.prototype.range = function(minDate, maxDate, tickCount, type, tickInterval) {
    minDate = new Date(minDate.getTime());
    maxDate = new Date(maxDate.getTime());
    
    this.getBaseValue(minDate, type, false);
    this.getBaseValue(maxDate, type, true);
    switch (type) {
        case date_utils.SECOND_TYPE:
        
        case date_utils.DATETIME_TYPE: {
            // var interval = Math.ceil((maxDate.getTime() - minDate.getTime()) / (tickCount * 1000));
            var minInterval = 1;
            var noOfSec = mathCeil(((maxDate.getTime() - minDate.getTime()) / 1000));
            var interval = mathCeil(noOfSec / tickCount) || minInterval;
            interval = getInterval(interval, tickInterval);
            return {
                "TYPE": d3_timeSeconds,
                "INTERVAL": interval,
                "TICKS": this.getTicksList(minDate, maxDate, interval, type)
            };
            
        }
            break;
        
        case date_utils.MINUTE_TYPE: {
            var minInterval = 1;
            var interval = mathCeil((maxDate.getTime() - minDate.getTime()) / (tickCount * 60000)) || minInterval;
            interval = getInterval(interval, tickInterval);
            return {
                // TODO check for using  d3_timeHours instead of d3_timeMinutes.
                "TYPE": d3_timeHours,
                "INTERVAL": interval,
                "TICKS": this.getTicksList(minDate, maxDate, interval, type)
            };
            
        }
            break;
        case date_utils.HOUR_TYPE: {
            var minInterval = 1;
            var interval = mathCeil((maxDate.getTime() - minDate.getTime()) / (tickCount * 3600000)) || minInterval;
            interval = getInterval(interval, tickInterval);
            return {
                "TYPE": d3_timeHours,
                "INTERVAL": interval,
                "TICKS": this.getTicksList(minDate, maxDate, interval, type)
            };
            
        }
            break;
        case date_utils.DAY_TYPE:
        case date_utils.DATE_TYPE: {
            var minInterval = 1;
            var interval = mathCeil((maxDate.getTime() - minDate.getTime()) / (tickCount * date_utils.DAY_MILLIS)) || minInterval;
            interval = getInterval(interval, tickInterval);
            return {
                "TYPE": d3_timeDays,
                "INTERVAL": interval,
                "TICKS": this.getTicksList(minDate, maxDate, interval, type)
            };
            
        }
            break;
        
        case date_utils.ABSWEEK_TYPE: {
            var minInterval = 1;
            var interval_week = mathCeil((maxDate.getTime() - minDate.getTime()) / (tickCount * date_utils.DAY_MILLIS * 7));
            interval_week = getInterval(interval_week, tickInterval);
            var interval = mathCeil(interval_week) * 7 || minInterval; //interval in weekdays
            return {
                "TYPE": d3_timeWeeks,
                "INTERVAL": interval,
                "TICKS": this.getTicksList(minDate, maxDate, interval, type)
            };
            
        }
            break;
        
        case date_utils.ABSMONTH_TYPE: {
            var minInterval = 1;
            var interval = mathCeil(this.getMonthsDiff(minDate, maxDate) / tickCount) || minInterval;
            interval = getInterval(interval, tickInterval);
            return {
                "TYPE": d3_timeMonths,
                "INTERVAL": interval,
                "TICKS": this.getTicksList(minDate, maxDate, interval, type)
            };
            
        }
            break;
        case date_utils.ABSQUARTER_TYPE: {
            var minInterval = 1;
            var interval_month = this.getMonthsDiff(minDate, maxDate) / tickCount || minInterval;
            var quarter = mathCeil(interval_month / 3);
            quarter = getInterval(quarter, tickInterval);
            var interval = quarter * 3;
            return {
                "TYPE": d3_timeMonths,
                "INTERVAL": interval,
                "TICKS": this.getTicksList(minDate, maxDate, interval, type)
            };
            
        }
            break;
        
        case date_utils.ABSYEAR_TYPE: {
            var minInterval = 1;
            var interval = mathCeil((maxDate.getFullYear() - minDate.getFullYear()) / tickCount) || minInterval;
            interval = getInterval(interval, tickInterval);
            return {
                "TYPE": d3_timeYears,
                "INTERVAL": interval,
                "TICKS": this.getTicksList(minDate, maxDate, interval, type)
            };
            
        }
            break;
        
        default: {
            throw "UNKNOWN TYPE 111: " + type;
        }
    }
    
    function getInterval(actualInterval, userInterval) {
        return ((userInterval != null) && (userInterval >= actualInterval)) ? userInterval : actualInterval;
    }
};

date_utils.MAX_DATE = new Date(2008, 8, 29, 23, 23, 23, 999);
date_utils.prototype.getMaxDate = function(formatConf, specifierIndex) {
    return getFormattedValue(formatConf, date_utils.MAX_DATE, TIME_DATATYPE,null,"axis",null,null,specifierIndex);
};

date_utils.prototype.getMonthsDiff = function(minDate, maxDate) {
    return ((this.getFullYear(maxDate) - this.getFullYear(minDate)) * 12 + (this.getMonth(maxDate) - this.getMonth(minDate)));
}

date_utils.prototype.getYearsDiff = function(minDate, maxDate) {
    return ((this.getFullYear(maxDate) - this.getFullYear(minDate)) * 12 + (this.getMonth(maxDate) - this.getMonth(minDate)));
}

date_utils.prototype.getFullYear = function(date) {
    return (this.useUTC != null && this.useUTC) ? date.getUTCFullYear() : date.getFullYear();
}
date_utils.prototype.getMonth = function(date) {
    return (this.useUTC != null && this.useUTC) ? date.getUTCMonth() : date.getMonth();
}
date_utils.prototype.getDay = function(date) {
    return (this.useUTC != null && this.useUTC) ? date.getUTCDay() : date.getDay();
}
date_utils.prototype.getDate = function(date) {
    return (this.useUTC != null && this.useUTC) ? date.getUTCDate() : date.getDate();
}
date_utils.prototype.getHours = function(date) {
    return (this.useUTC != null && this.useUTC) ? date.getUTCHours() : date.getHours();
}
date_utils.prototype.getMinutes = function(date) {
    return (this.useUTC != null && this.useUTC) ? date.getUTCMinutes() : date.getMinutes();
}
date_utils.prototype.getSeconds = function(date) {
    return (this.useUTC != null && this.useUTC) ? date.getUTCSeconds() : date.getSeconds();
}
date_utils.prototype.getMilliseconds = function(date) {
    return (this.useUTC != null && this.useUTC) ? date.getUTCMilliseconds() : date.getMilliseconds();
}

date_utils.prototype.setFullYear = function(date, val) {
    return (this.useUTC != null && this.useUTC) ? date.setUTCFullYear(val) : date.setFullYear(val);
}
date_utils.prototype.setMonth = function(date, val) {
    return (this.useUTC != null && this.useUTC) ? date.setUTCMonth(val) : date.setMonth(val);
}
date_utils.prototype.setDate = function(date, val) {
    return (this.useUTC != null && this.useUTC) ? date.setUTCDate(val) : date.setDate(val);
}
date_utils.prototype.setHours = function(date, val) {
    return (this.useUTC != null && this.useUTC) ? date.setUTCHours(val) : date.setHours(val);
}
date_utils.prototype.setMinutes = function(date, val) {
    return (this.useUTC != null && this.useUTC) ? date.setUTCMinutes(val) : date.setMinutes(val);
}
date_utils.prototype.setSeconds = function(date, val) {
    return (this.useUTC != null && this.useUTC) ? date.setUTCSeconds(val) : date.setSeconds(val);
}
date_utils.prototype.setMilliseconds = function(date, val) {
    return (this.useUTC != null && this.useUTC) ? date.setUTCMilliseconds(val) : date.setMilliseconds(val);
};

(function(ZC) {
    "use strict";

    var axis = ZC.axis;

    /**
     *
     * @param {Object} obj
     * @returns {{top, right, bottom, left}}
     */

    function getMargin(obj) {
        return {
            top: pick(obj.marginTop, 5),
            right: pick(obj.marginRight, 5),
            bottom: pick(obj.marginBottom, 5),
            left: pick(obj.marginLeft, 5)
        }
    }


    /**
     *
     * @param {Number} rotation in degree's
     * @param {Number} side in TRBL direction as 0 to 3
     * @returns {String}
     */

    function autoLabelAlign(rotation, side) {
        var ret,
            angle = (pick(rotation, 0) - (side * 90) + 720) % 360;
        if (angle > 15 && angle < 165) {
            ret = 'end';
        } else if (angle > 195 && angle < 345) {
            ret = 'start';
        } else {
            ret = 'middle';
        }
        return ret;
    }

    /**
     *
     * @param {Array} categories
     * @param {Number} expectedCount
     * @param {Number} interval
     * @param {Boolean} filterByIndices
     * @returns {Array}
     */

    function filterCategories(categories, expectedCount, interval, filterIndex) {
        var actualCount = categories.length;
        expectedCount = mathRound(expectedCount);
        interval = interval || mathCeil(actualCount / expectedCount);
        var temp = 0;
        var tickvalues = [], tickvalueIndices = (filterIndex) ? [] : null, tickvalueNodes = (filterIndex) ? [] : null;
        while (temp < actualCount) {
            if(filterIndex){
                tickvalues.push(categories[temp].value);
                tickvalueIndices.push(categories[temp].index);
                tickvalueNodes.push(categories[temp]);
            }else{
                tickvalues.push(categories[temp]);
            }
            temp = temp + interval
        }

        if(filterIndex){
            return {
                "nodes" : tickvalueNodes,
                "ticks" : tickvalues,
                "indices" : tickvalueIndices
            };
        }else{
            return tickvalues;
        }
    }

    /**
     *
     * @param formattedTickValues
     * @param tickConfig
     * @param columnInfo
     * @param {Chart} chart
     * @param {Number} columnIndex
     * @param {Number} levelIndex
     * @returns {{tickValues: Array, styles: Array, userRawTicks: Array}}
     */
    function getCustomTickValues(formattedTickValues, tickConfig, columnInfo, chart, columnIndex, levelIndex) {

        var parentArray = [], parentStyles = [], userTickValues = [];

        var userColumnInfo = {
            data: [columnInfo]
        };
        columnInfo.columnindex = pick(columnInfo.columnindex, columnIndex);

        formattedTickValues.forEach(function(d, i) {
            var userInput = invokeFunction(tickConfig.showAs, d, tickConfig, userColumnInfo, chart, i, levelIndex),
                childArray = [], styles = [];

            if (isArray(userInput)) {
                parentArray.push(childArray);
                parentStyles.push(styles);
            } else {
                childArray = parentArray;
                styles = parentStyles
            }
            userTickValues.push(userInput);

            if (defined(userInput)) {
                var sandBox = document.createElement("div");
                sandBox.innerHTML = userInput;

                var tspan = toArray(sandBox.querySelectorAll("tspan")),
                    images = sandBox.querySelectorAll("image,img");

                if(tspan.length) {
                    tspan.forEach(function(t) {
                        childArray.push(t.textContent.trim());
                        styles.push({
                            fontSize: t.style.fontSize && parseFloat(t.style.fontSize),
                            fontFamily: t.style.fontFamily,
                            fontStyle: t.style.fontStyle,
                            fontWeight:t.style.fontWeight
                        })
                    });
                } else {
                    childArray.push(sandBox.textContent);
                }

                if(images.length) {
                    toArray(sandBox.querySelectorAll("image,img")).forEach(function(t) {
                        childArray.push({
                            width: +t.getAttribute("width"),
                            height: +t.getAttribute("height")
                        });
                        styles.push({})
                    });
                }
            }
        });

        return {
            tickValues: parentArray,
            styles: parentStyles,
            userRawTicks: userTickValues
        }
    }


    /**
     *
     * @param {Array} ticks formatted tick values
     * @param {Array} ticksOriginal raw tick values
     * @param {Number} fontSize font-size of the tick label
     * @param {String} fontFamily font-family of the tick label
     * @param {{fontFamily: string, fontSize: number, fontStyle: string}} styles
     * @param {Boolean} calculateAsArea
     * @returns {{actualVal: *, formattedVal: String}}
     */

    function getLongestTick(ticks, ticksOriginal, fontSize, fontFamily, styles, calculateAsArea) {

        /**
         * @type {CanvasRenderingContext2D} tempCanvasContext
         */
        tempCanvasContext.save();
        tempCanvasContext.font = fontSize + "px " + fontFamily;

        var temp = 0,
            longest = null,
            original = null,
            style,
            index;

        styles = pick(styles, []);

        if (!defined(ticksOriginal)) {
            ticksOriginal = [];
        }

        var check = function(label, i) {
            var bound = getTextBound(label, fontSize, fontFamily, styles[i]),
                width = bound.width;

            if(calculateAsArea) {
                width = bound.width * bound.height;
            }

            if (width > temp) {
                temp = width;
                longest = label;
                original = ticksOriginal[i];
                style = styles[i];
                index = i;
            }
        };
        ticks.forEach(check);
        tempCanvasContext.restore();
        return {
            actualVal: original,
            formattedVal: longest,
            style: style,
            index: index
        };
    }


    /**
     * returns a transform string
     *
     * @param {Number} rotate in degree's
     * @param {Number} x
     * @param {Number} y
     * @returns {string}
     */
    function generateTransform(rotate, x, y) {
        return "rotate(" + rotate + " " + (x || 0) + " " + (y || 0) + ")";
    }

    /**
     * returns the size of the tick label in horizontally or vertically
     *
     * @param {String} side "width" | "height"
     * @param {Object} dimension
     * @param {Object} margin
     * @param {Number} rotation in degree's
     * @param tickFontSize
     * @param orient
     * @returns {number}
     */

    function getTickWidth(side, dimension, margin, rotation, tickFontSize, orient) {
        var space = 0;
        if (side === "height") {
            space = Math.abs(tickFontSize + margin.top + margin.bottom);
        } else {
            if (rotation > 0) {
                space = distBetweenRotatedRect(rotation, dimension.width, tickFontSize, orient).tickSpacing + margin.left + margin.right
            } else {
                space = dimension.width + margin.left + margin.right;
            }
        }
        return space;
    }

    /**
     * returns the opposite side margin based on orien
     * @param {String} orient
     * @param {Object} margin
     */

    function getOppositeMargin(orient, margin) {
        return margin[getOppositeOrient(orient)];
    }

    /**
     *
     * @param {String} orient
     * @param {Object} tickMargin
     * @param {Object} tickMarkConfig
     * @returns {{x: number, y: number}}
     */

    function getTickMargin(orient, tickMargin, tickMarkConfig) {


        var tickMarkSize = pick(tickMarkConfig.size, 6),
            margin = getOppositeMargin(orient, tickMargin),
            prop = {
                x: 0, y: 0
            };

        switch (orient) {
            case "left":
                prop.x = -(margin + tickMarkSize);
                break;
            case "top":
                prop.y = -(margin + tickMarkSize);
                break;
            case "right":
                prop.x = (margin + tickMarkSize);
                break;
            default:
                prop.y = (margin + tickMarkSize);
                break;
        }
        return prop;
    }

    /**
     * returns a empty dimension.
     * @returns {{}}
     */
    function getEmptyBBox() {
        var t = {};
        t.x = t.y = t.width = t.height = 0;
        return t;
    }

    function distBetweenRotatedRect(rotation, width, height, orient) {
        var ang1 = rotation * (mathPI * 2 / 360);
        var ang2 = (90 - rotation) * (mathPI * 2 / 360);

        if (orient === "bottom" || orient === "top") {
            return {
                "tickSpacing": mathAbs(height / mathSin(ang1)) + 5,
                "baseLen": 0
            }
        } else {
            var len1 = mathAbs(mathSin(ang2) * height);
            var len2 = mathAbs((mathCos(ang2) * height) * mathTan(ang1));
            return {
                "tickSpacing": len1 + len2 + 5,
                "baseLen": mathAbs(mathCos(ang2) * width)
            }
        }
    }

    function addMinmaxToTickValues(tickvalues, axisticklabeldata, chartObj, type, axisorder, orient) {
        var dataObject = chartObj.dataObject;
        var minmaxlabelsdata = axisticklabeldata.minmaxlabels || {};
        if (minmaxlabelsdata.show === true) {
            var newScale = $ZC.scale.getScale(chartObj, dataObject, chartObj.plotarea, orient, axisorder, chartObj.dataset, type); //Scale with actual outerPadding
            var domain = newScale.domain();
            if (validateNullVal(minmaxlabelsdata.excludeIntervals, true)) {
                tickvalues = domain;
            } else {
                if (domain[0] !== tickvalues[0]) {
                    tickvalues.splice(0, 0, domain[0]);
                }
                if (domain[1] !== tickvalues[tickvalues.length - 1]) {
                    tickvalues.push(domain[1]);
                }
            }
        }
        return tickvalues;
    }

    function nearestNiceMin(minDomain, remaining, magnitude, interval) {
        var arr = [1, 2, 5, 10], len = arr.length;
        var actualMin = minDomain + (remaining / 2);
        actualMin = +actualMin.toFixed(12);
        var diff, nearestMin;
        for (var j = 0; j < len; j++) {
            var a1 = magnitude / arr[j], curMin;
            if (minDomain % a1) {
                curMin = minDomain - (minDomain % a1) + a1;
            } else {
                curMin = minDomain;
            }

            var curDiff = mathAbs(actualMin - curMin);
            if (curDiff < diff || diff == null) {
                diff = curDiff;
                nearestMin = curMin;
            }
        }
        if (nearestMin == null || nearestMin < minDomain) {
            var e = mathFloor(mathLog(interval) / mathLN10);
            if (e < 0) {
                nearestMin = +minDomain.toFixed(mathAbs(mathMin(0, e)));
            }
            nearestMin = minDomain;
        }
        nearestMin = (nearestMin > minDomain) ? nearestMin : minDomain;
        return nearestMin;
    }

    function nearestTickInterval(actualInterval, magnitude, tickCount) {
        var curDiff, prevDiff = null, curInterval, nearestInterval = magnitude;
        var multiples = [1, 1.2, 1.5, 1.75, 2, 2.2, 2.5, 3, 3.5, 4, 4.5, 5, 6, 7, 8, 9, 10];
        for (var i = 0; i < multiples.length; i++) {
            curInterval = multiples[i] * magnitude;
            curDiff = mathAbs(actualInterval - curInterval);
            prevDiff = prevDiff == null ? curDiff : prevDiff;
            if (curDiff < prevDiff && curInterval <= actualInterval) {
                prevDiff = curDiff,
                    nearestInterval = curInterval;
            }
        }
        return nearestInterval;
    }


    function getNiceMin(domain, minStep) {
        var step = getLinearStep(domain);
        if (defined(minStep)) { // Test_525.json
            step = mathMax(minStep, step);
        }
        return mathCeil(domain[0] / step) * step;
    }

    function getNiceStep(domain) {
        return mathCeil(getLinearStep(domain));
    }

    function getLinearStep(domain, count) {
        var m = defined(count) ? count : 10,
            span = domain[1] - domain[0],
            step = mathPow(10, mathFloor(mathLog(span / m) / mathLN10)),
            err = m / span * step;
        if (err <= .15) {
            step *= 10;
        }
        else if (err <= .35) {
            step *= 5;
        }
        else if (err <= .75) {
            step *= 2;
        }
        return step;
    }


    /**
     * Axis Label Rendering
     *
     * @param {Object} axisConfig
     * @param {Object} otherInfo
     * @param {String} orient
     * @param {Object} parent
     * @constructor
     */


    var AxisLabel = function(axisConfig, otherInfo, orient, parent) {
        this.axis = axisConfig;
        this.config = axisConfig.label;
        this.axisRect = otherInfo.bound;
        this.parentNode = parent.isD3Selection ? parent : d3.select(parent);
        this.orient = orient;
        this.systemConfig = otherInfo.systemConf;
        this.order = otherInfo.axisOrder;
        this.plotRect = otherInfo.plotRect;
        this.show = !otherInfo.hide;
        if (this.show) {
            this.add();
        } else {
            this.element = appendEle(this.parentNode, "text", [], ".", "class", "axislabel"); // a empty selection
        }

    };

    AxisLabel.prototype = {

        add: function() {
            var label = this;
            label.element = appendEle(label.parentNode, "text", [1], ".", "class", "axislabel");
            label.text = label.config.text;
            label.element.text(label.text);
            label.rect = null;
            label.transformLabel();
        },

        remove: function() {
            var label = this;
            label.rect = null;
            label.element = appendEle(label.parentNode, "text", [], ".", "class", "axislabel"); // remove it
        },

        setStyles: function() {
            var label = this,
                systemConfig = label.systemConfig;
            applyFont(label.element, [label.config, systemConfig.chart, systemConfig.canvas, $ZCG]);
        },

        getBBox: function() {
            var label = this;
            if (!defined(label.rect)) {
                if (label.element.isD3Selection && !label.element.empty()) {
                    label.rect = label.element.node().getBBox(); // calculate and cache.
                } else {
                    return getEmptyBBox();
                }
            }
            return label.rect;
        },

        transformLabel: function(axisBound, plotBound, side) {

            var label = this;

            if (label.show !== true) {
                return label.remove();
            }

            if ((label.element.empty() && label.show === true) || (label.text !== label.config.text)) {
                return label.add();
            }

            label.setStyles();

            var rotations = {
                    top: 0,
                    right: 90,
                    bottom: 0,
                    left: 270
                },
                systemConfig = label.systemConfig,
                textAnchor = "middle", // it is middle for all angle
                orient = pick(side, label.orient),
                rotate = rotations[orient],
                x,
                y,
                axisRect = pick(axisBound, this.axisRect),
                plotRect = pick(plotBound, this.plotRect),
                tickLabelConfig = label.axis.ticklabel,
                axisLabelConfig = label.config,
                tickMargin = getMargin(tickLabelConfig),
                labelMargin = getMargin(axisLabelConfig),
                fontSize = parseFloat($ZC.utils.getVal(getValByPriority([label.config, systemConfig.chart, systemConfig.canvas, $ZCG], "fontSize")));

            // reset BBox
            if(label.fontSize !== fontSize) {
                label.rect = null;
            } else {
                label.fontSize = fontSize;
            }

            // if axis rotated is called;
            label.element.attr("dy", "-0.25em");

            switch (orient) {
                case "top": {
                    x = plotRect.width / 2;
                    y = axisRect.height + tickMargin.top + labelMargin.bottom;
                    applyTransform(rotate, x, -y);
                    break;
                }

                case "right": {
                    // label.element.attr("dy", "-0.25em");
                    x = plotRect.height / 2;
                    y = axisRect.width + tickMargin.right + labelMargin.left;
                    applyTransform(rotate, x, -y);
                    break;
                }
                case "bottom": {
                    x = plotRect.width / 2;
                    y = axisRect.height + tickMargin.bottom+ labelMargin.top;

                    // apply baseline
                    label.element.attr("dy", "0.91em");
                    applyTransform(rotate, x, y);
                    break;
                }
                case "left": {
                    // label.element.attr("dy", "-0.25em");
                    x = axisRect.width + tickMargin.left + labelMargin.right;
                    y = plotRect.height / 2;
                    applyTransform(rotate, -x, y, -x, y);
                    break;
                }
            }

            function applyTransform(rotate, x, y, xTransform, yTransform) {
                xTransform = pick(xTransform, 0);
                yTransform = pick(yTransform, 0);

                label.element.attr({
                    "x": x,
                    "y": y,
                    "transform": generateTransform(rotate, xTransform, yTransform),
                    "text-anchor": textAnchor
                })
            }
        }
    };


    /**
     *
     * @param {String} type x or y
     * @param axisInfo
     * @param plotRect
     * @param helpers
     * @param tickCount
     * @constructor
     */

    var Ticks = function(type, axisInfo, plotRect, helpers, tickCount) {

        this.type = type;
        this.config = axisInfo.ticklabel;
        this.axis = axisInfo;
        this.plotRect = plotRect;
        this.helpers = helpers;

        this.tickCount = tickCount; // for web chart

        // max size
        this.maxSize = getMaxTickSize(this.config, plotRect);
        this.cache = {};
    };

    Ticks.prototype = {


        getScale: function() {
            var tick = this,
                chart = tick.helpers.chart,
                helpers = tick.helpers;
            return $ZC.scale.getScale(chart, chart.dataObject, tick.plotRect, helpers.orient, helpers.axisOrder, chart.dataset, tick.type, tick.extent);
        },

        getTicks: function(plotArea, needCount, helper) {

            var tick = this,
                helpers = pick(helper, tick.helpers),
                chart = helpers.chart,
                systemConf = chart.systemConf,
                dataObject = chart.dataObject,
                plotRect = tick.plotRect = pick(plotArea, tick.plotRect),
                axis = tick.axis,
                type = tick.type,
                userTickInterval = axis.interval,
                userTickCount = axis.tickCount,
                range,
                domain,
                scale,
                tickInterval = axis.interval,
                tickCount = pick(needCount, 0),
                extent = helper.extent,
                tickValues = extent,
                categoriesList, filterByIndex, tickValueIndices,
                dontFilter,
                formattedTickValues,

                axisOrder = helpers.axisOrder,
                axisRotated = helpers.axisRotated,
                dataType = chart.dataset.getDataType(type, axisOrder),
                metaData = chart.systemConf.metadata,
                columnIndex = chart.dataset.getColumnIdx(type, axisOrder),
                columnInfo = metaData.columns[columnIndex],
                originalDataType = metaData.columns[columnIndex].datatype,
                isMergedAxis = (type == "y") ? (metaData.axes.y[axisOrder].length > 1) : false,
                formatConfig = pick(((isMergedAxis && type == "y") ? merged_axis_column_intersect(axisOrder, chart) : metaData.columns[columnIndex][originalDataType]), {}),
                formattingSubFunction = formatConfig.subfunction,
                formattingFunction = (type === "y" && chart.dataObject.isStackedPercentChart) ? getFormattedValueByPercent : getFormattedValue,

                margin = getMargin(tick.config),
                tickMargin = getTickMargin(helpers.orient, margin, tick.axis.tickmark),
                axisSize,

                tickFontSize = parseFloat($ZC.utils.getVal(getValByPriority([tick.config, systemConf.chart, systemConf.canvas, $ZCG], "fontSize"))),
                tickFontFamily = $ZC.utils.getVal(getValByPriority([tick.config, systemConf.chart, systemConf.canvas, $ZCG], "fontFamily")),

                longestTick,
                side = isRotatedChart(type, axisRotated) ? "height" : "width",
                isAutoRotation = isTickAutoRotate(chart,this.type,axisOrder,tick.config),
                 isHierarchy = chart.axes.x.count > 1 && type == "x" && axisOrder > 0,
                rotation = isAutoRotation || isHierarchy ? 0 : +tick.config.rotation,

                firstChartName = chart.chartTypes[0].name,
                outerPadding = chart.systemConf.chart.plot.plotoptions[firstChartName].outerPadding || 0,
                pad = chart.systemConf.chart.plot.plotoptions[firstChartName].padding || 0.2,
                longestFormattedString = null,
                plotSize = getPlotSize(helpers.chart,side,plotRect),
                padding = type === "x" ? (plotSize * outerPadding) * 2 : 0,

                dimension, space, customTickInfo = {},


                hasTimeGroupBy = isArray(formatConfig.groupby) && formatConfig.groupby.length > 0 || (formatConfig.groupby === "AUTO" && formattingSubFunction !== "YEAR");
                var specifierIndex = (hasTimeGroupBy) ? axisOrder : null;

            if (!isAutoRotation) {
                if (rotation < 0) {
                    rotation = 360 - mathAbs(rotation);
                } else if (rotation > 360) {
                    rotation = mathAbs(rotation) % 360;
                }
            }

            switch (dataType) {

                case "numeric": {

                    domain = defined(extent) ? extent : type === "x" ? dataObject.getMinMaxX() : dataObject.getMinMaxY(helpers.axisOrder);

                    // define axis size and range
                    if (side === "height") {
                        axisSize = plotRect.height;
                        tickCount = tickCount || mathRound(axisSize / 40);
                        range = [axisSize, 0];
                    } else {
                        axisSize = plotRect.width;
                        tickCount = tickCount || mathRound(axisSize / 100);
                        range = [0, axisSize];
                    }

                    // define tick interval
                    if (defined(userTickCount)) {
                        tickInterval = (domain[1] - domain[0]) / userTickCount;
                    }

                    var count, step, min, max, useTickInterVal;
                    useTickInterVal = defined(userTickInterval) && ((domain[1] - domain[0]) / userTickInterval) < axisSize;

                    // numeric scale
                    scale = d3_scaleLinear().domain(domain).range(range);

                    // get ticks
                    if (useTickInterVal) {

                        count = mathFloor((domain[1] - domain[0]) / tickInterval);

                        if (count) {
                            step = getLinearStep(domain, count);
                            min = mathCeil(domain[0] / step) * step;

                            if ((min - domain[0]) > tickInterval) {
                                var s = mathPow(10, mathFloor(mathLog(tickInterval) / mathLN10)),
                                    q = mathFloor((min - domain[0]) / s);
                                min -= (q * s);
                            }
                        } else {
                            var span = domain[1] - domain[0],
                                s = mathPow(10, mathFloor(mathLog(span) / mathLN10));
                            min = domain[0] - (domain[0] % s) + s;
                        }

                        tickValues = d3_range(min, domain[1], tickInterval);

                    } else if (+userTickCount > 0) {

                        if (userTickCount === 1) {
                            step = getLinearStep(domain, 1);
                            min = Math.ceil(domain[0] / step) * step;
                            tickValues = [min];
                        } else {
                            var m = userTickCount - 1, magnitude, min, min , remaining;
                            span = domain[1] - domain[0];
                            magnitude = mathPow(10, mathFloor(mathLog(span / m) / mathLN10));

                            magnitude = magnitude * Math.floor((span / m) / magnitude);
                            magnitude = +magnitude.toFixed(12); //To avoid floating point error (e.g):1.7000000000000002

                            var nicedInterval = nearestTickInterval(tickInterval, magnitude, m);
                            min = domain[0];
                            max = domain[1];
                            remaining = span - (nicedInterval * m);

                            // if (remaining < magnitude && Math.floor((span / m) / magnitude) > 1) {
                            //     nicedInterval -= magnitude;
                            //     remaining = span - (nicedInterval * m);
                            // }

                            var mag_remaining = mathPow(10, mathFloor(mathLog(remaining) / mathLN10) + 1);
                            min = nearestNiceMin(min, remaining, mag_remaining,nicedInterval);
                            min = +min.toFixed(12); //To avoid floating point error (e.g):1.7000000000000002
                            tickValues = d3_range(min, (min + (nicedInterval*userTickCount)), nicedInterval);

                        }

                    } else if (formattingSubFunction === "integer") {
                        tickValues = d3_range(getNiceMin(domain, 1), domain[1], getNiceStep(domain));

                    } else {
                        tickValues = scale.ticks(tickCount);
                    }

                    // add min max label if needed
                    tickValues = addMinmaxToTickValues(tickValues, tick.config, chart, type, helpers.axisOrder, helpers.orient);

                    tickCount = (this.config.zigzag) ? tickValues.length/2 : tickValues.length;
                    break;
                }
                case "ordinalNonLinear":
                case "ordinal": {


                    var visibleTickCount, size = tickFontSize,
                        hierarchical = dataObject.hierarchical, tickNodes;
                        filterByIndex = defined(hierarchical) && originalDataType == ORDINAL_DATATYPE && type == "x" && axisOrder == 0,
                        dontFilter = filterByIndex && (helpers.chart.systemConf.chart.width == "auto" || helpers.chart.systemConf.chart.height == "auto");


                    if (!defined(tickValues)) {
                        tickValues = dataObject.getCategories(type, helpers.axisOrder).slice(0);
                    }
                    if(filterByIndex){
                        tickValues = dataObject.hierarchical.leafNodes;
                    }

                    if(originalDataType === TIME_DATATYPE && !defined(formattingSubFunction)) {
                            // set sub function
                        var info = getAutoTimeSubFunction(tickValues[tickValues.length - 1] - tickValues[0]);
                        formattingSubFunction = formatConfig.subfunction = info.subFunction;
                    }

                    tickCount = tickValues.length;

                    dimension = {};
                    dimension.width = dimension.height = tickFontSize;
                    space = getTickWidth(side, dimension, margin, rotation, tickFontSize, helpers.orient);
                    visibleTickCount = mathRound((plotSize- padding) / space); // for initial filter.

                    if (visibleTickCount < tickCount && side === "width") {
                        if (rotation || tick.config.rotation > 0) {
                            space = distBetweenRotatedRect(45, tickFontSize, size, helpers.orient).tickSpacing + margin.left + margin.right;
                        }
                    }
                    if((!(type == "x" && axisOrder > 0)) && (!dontFilter)){
                        if (userTickCount < tickCount) {
                            tickValues = filterCategories(tickValues, userTickCount, null, filterByIndex);
                        } else if (defined(tickInterval)) {
                            tickValues = filterCategories(tickValues, tickCount, tickInterval, filterByIndex);
                        } else if (visibleTickCount < tickCount) {
                            tickValues = filterCategories(tickValues, visibleTickCount, null, filterByIndex);
                        }
                    }
                    if(filterByIndex){
                        categoriesList = tickValues.nodes || tickValues,
                        tickValueIndices = tickValues.indices,
                        tickValues = tickValues.ticks || dataObject.getCategories(type, helpers.axisOrder).slice(0);
                    }

                    tickCount = (this.config.zigzag) ? tickValues.length/2 : tickValues.length;

                    break;
                }

                case "time": {

                    var isAutoFormat = hasAutoFormat(formatConfig);

                    if (isAutoFormat) {

                        var timeScale = $ZC.scale.getScale(chart, dataObject, plotRect, helpers.orient, helpers.axisOrder, chart.dataset, type, null);
                        tickValues = timeScale.ticks().map(function(d) {
                            return timeScale.tickFormat()(d)
                        });

                    } else {

                        var start, end, dateInterval;
                        domain = defined(extent) ? extent : type === "x" ? dataObject.getMinMaxX(0) : dataObject.getMinMaxY(helpers.axisOrder, 0);

                        start = new Date(domain[0]);
                        end = new Date(domain[1]);

                        if (!defined(formattingSubFunction) || formattingSubFunction === "AUTO") {
                            // set sub function
                            var info = getAutoTimeSubFunction(end - start);
                            formattingSubFunction = formatConfig.subfunction = info.subFunction;
                        }

                        // get the date utils 1326
                        dateInterval = new date_utils(formatConfig);
                        dateInterval.useUTC = formatConfig.useUTC === true;

                        longestFormattedString = dateInterval.getMaxDate(formatConfig, specifierIndex); // save it
                        dimension = getTextBound(longestFormattedString, tickFontSize, tickFontFamily);
                        space = getTickWidth(side, dimension, margin, rotation, tickFontSize, helpers.orient);

                        tickCount = (plotSize - padding) / space;
                        // tickCount = (this.config.zigzag) ? tickCount/2 : tickCount;
                        // get the date range
                        var dateRange = dateInterval.range(start, end, mathCeil(tickCount), formattingSubFunction, tickInterval, chart);
                        // add min max tick
                        tickValues = addMinmaxToTickValues(dateRange.TICKS, tick.config, chart, type, helpers.axisOrder, helpers.orient);

                        tickCount = (this.config.zigzag) ? dateRange.TICKS.length/2 : dateRange.TICKS.length;

                        break;
                    }
                }
            }


            if(dataType === "ordinalNonLinear"){
                var formattedTickValues = isAutoFormat ? tickValues : formatArray(tickValues, formattingFunction, formatConfig, chart, originalDataType, "axis", specifierIndex);
                // get custom tick labels
                if (defined(tick.config.showAs)) {
                    customTickInfo = getCustomTickValues(formattedTickValues, tick.config, columnInfo, chart, columnIndex, axisOrder);
                    formattedTickValues = customTickInfo.tickValues;
                    customTickInfo.length = formattedTickValues.length;
                }
                var longestTick = getLongestTick(formattedTickValues, tickValues, tickFontSize, tickFontFamily, customTickInfo.styles);
                return {
                    rawTickValues: tickValues,
                    formatterTickValues: formattedTickValues,
                    longestTickValue: longestTick,
                    scale: tick.getScale(),
                    longestTickDimension: getTextBound(longestTick, tickFontSize, tickFontFamily),
                    margin: margin,
                    tickMargin: tickMargin,
                    rotation: rotation,
                    customTickInfo: customTickInfo
                }
            }

            // get a scale
            scale = tick.getScale();

            //
            var actualRange = scale.actualRange;
            var isSingleTick = actualRange && (actualRange[0] === actualRange[1]);
            if (isSingleTick) {
                tickValues = [scale.invert(actualRange[0])];
            }

            // format the values and get the longest tick value.

            formattedTickValues = isAutoFormat ? tickValues : formatArray(tickValues, formattingFunction, formatConfig, chart, originalDataType, "axis", specifierIndex);


            // get custom tick labels
            if (defined(tick.config.showAs)) {
                customTickInfo = getCustomTickValues(formattedTickValues, tick.config, columnInfo, chart, columnIndex);
                formattedTickValues = customTickInfo.tickValues;
                customTickInfo.length = formattedTickValues.length;
            }

            longestTick = getLongestTick(formattedTickValues, tickValues, tickFontSize, tickFontFamily, customTickInfo.styles);

            // uncomment the bellow condition to use the default longest date.
            if(!defined(longestFormattedString)) {
                longestFormattedString = longestTick.formattedVal;
            }


            // calculate number of tick can be fit.
            var tickBound = getTextBound(longestFormattedString, tickFontSize, tickFontFamily, longestTick.style, true);

            if(dontFilter){
                tick.recalculatePlotSize(helpers.chart, plotSize, tickBound, side, tickCount, margin, pad, outerPadding)
            }

            var maxTickCount = tick.getMaxTickCount(tickBound, rotation, margin, outerPadding, side, helpers.orient, type,helpers.chart);

            if (!isSingleTick && maxTickCount < tickCount) {

                if (isAutoRotation && side === "width") {
                    if(helpers.chart.axes.x.count > 1 && type == "x" && axisOrder == 0){
                        rotation = 90; //For hierarchy auto rotate 90
                    }else{
                        rotation = 45;
                    }

                    maxTickCount = tick.getMaxTickCount(tickBound, rotation, margin, outerPadding, side, helpers.orient,null,helpers.chart);
                }

                // time data need a re-calculation of tick values after rotation

                if(dataType === TIME_DATATYPE) {
                    dateRange = dateInterval.range(start, end, maxTickCount, formattingSubFunction, tickInterval, chart);
                    tickValues = addMinmaxToTickValues(dateRange.TICKS, tick.config, chart, type, helpers.axisOrder, helpers.orient);
                    formattedTickValues = formatArray(tickValues, formattingFunction, formatConfig, chart, originalDataType, "axis",specifierIndex);

                } else if (maxTickCount < tickCount) {
                    // filter ticks if needed
                    if(filterByIndex){
                        tickValues = filterCategories(categoriesList || tickValues, maxTickCount, null,filterByIndex);
                        tickValueIndices = tickValues.indices,
                        tickValues = tickValues.ticks;
                    } else{
                        tickValues = filterCategories(tickValues, maxTickCount);
                        if(tick.config.showAs) {
                            // TODO have convert multiple object to single object to reduce loop.
                            customTickInfo.styles = filterCategories(customTickInfo.styles, maxTickCount);
                            customTickInfo.userRawTicks = filterCategories(customTickInfo.userRawTicks, maxTickCount)
                        }
                    }

                    formattedTickValues = filterCategories(formattedTickValues, maxTickCount);
                    longestTick = getLongestTick(formattedTickValues, tickValues, tickFontSize, tickFontFamily, customTickInfo.styles);
                }
            }


            // time data group by
            if (originalDataType === TIME_DATATYPE && hasTimeGroupBy) {
                if (hasTimeGroupBy && !defined(dataObject.hierarchical)) {
                    dataObject.hierarchical = new $ZC.HierarchicalTimeDataAdapter(chart, tickValues, formatConfig.groupby, dataType !== TIME_DATATYPE, columnInfo);
                } else if(hasTimeGroupBy) {
                    dataObject.hierarchical.update(tickValues);
                }
            }


            if(defined(customTickInfo.styles)) {
                longestTick = getLongestTick(formattedTickValues, tickValues, tickFontSize, tickFontFamily, customTickInfo.styles, true);
            }

            var textDimension = getTextBound(longestFormattedString, tickFontSize, tickFontFamily, longestTick.style);

            return {
                rawTickValues: tickValues,
                formatterTickValues: formattedTickValues,
                longestTickValue: longestTick,
                scale: scale,
                longestTickDimension: textDimension,
                margin: margin,
                tickMargin: tickMargin,
                rotation: rotation,
                tickValueIndices : tickValueIndices,
                customTickInfo: customTickInfo
            }
            // now handle over flow of the formatted ticks and return;
        },


        getMaxTickCount: function(tickBound, rotation, margin, outerPadding, side, orient, type, chartObj) {
            var tick = this,
                tickArea,
                temp,
                tickCount,
                padding = 0,
                countForAngle;

            if (rotation === "auto") {
                rotation = 0;
            }

            countForAngle = !!rotation;

            var length = getPlotSize(chartObj,side,tick.plotRect)
            if (type === "x") {
                padding = (length * outerPadding) * 2;
            }

            tickArea = length - padding;


            if (countForAngle) {

                if (side === "height" && (rotation === 90 || rotation === 270)) {
                    return tickArea / (tickBound.width + mathAbs(margin.top) + mathAbs(margin.bottom));
                }

                // var angleCheck1 = side === "height" ? (rotation !== 90 && rotation !== 270 && rotation !== 0 && rotation !== 180 && rotation !== 360) :
                //     (rotation !== 0 && rotation !== 180 && rotation !== 360);

                var r = rotation % 90;
                var angleCheck = side === "height" ? (r > 0) : (r > 0 || rotation === 90 || rotation === 270);

                if (angleCheck) {
                    var distBwTicks = distBetweenRotatedRect(rotation, tickBound.width, tickBound.height, orient);
                    return tickArea / (distBwTicks.tickSpacing + mathAbs(margin.left) + mathAbs(margin.right));
                }
            }

            if (side === "height") {
                temp = tickBound.height + mathAbs(margin.top) + mathAbs(margin.bottom);
            } else {
                temp = tickBound.width + mathAbs(margin.left) + mathAbs(margin.right);
            }
            return tickArea / temp;
        },

        recalculatePlotSize: function(chartObj, oldPlotSize, tickSize, side, tickCount, margin, padding, outerPadding ){
            var temp, v, p;
            if (side === "height") {
                temp = tickSize[side] + margin.top + margin.bottom;
                v = temp * tickCount;
                oldPlotSize = [v, 0]
            } else {
                temp = tickSize[side] + margin.left + margin.right;
                v = temp * tickCount;
                oldPlotSize = [0,v]
            }
            p = getOuterPaddingInPixel(oldPlotSize, tickCount, padding, outerPadding, temp)
            v += p;
            chartObj.systemConf.chart[side] = v;
        }

    };

    axis.Ticks = Ticks;
    axis.AxisLabel = AxisLabel;

})($ZC);//$Id$
$ZC.axis.ticks = function(chartObj, axisdata, type, axisorder, orient, plotarea) {
    "use strict";
    var ticks = {};
    $ZC.axis.ticks.maxTickSizeRatio_Vert = "50%";
    $ZC.axis.ticks.maxTickSizeRatio_Hori = "50%";
    
    var dataObject = chartObj.dataObject,
        systemConf = chartObj.systemConf,
        container = chartObj.svg,
        isPreCalc = true,
        tickvalues,
        intelligenceDim = chartObj.canvasarea[(orient == "bottom" || orient == "top") ? "height" : "width"];
    
    var axisLabelMargin = {
        top: 5,
        right: 5,
        bottom: 5,
        left: 5
    };

    ticks.isHierarchy = isHierarchy, ticks.isHierarchialLevelType = isHierarchialLevelType;
    var datatype = chartObj.dataset.getDataType(type, axisorder),
        orient, axisrotated = dataObject.getAxisRotated();
    
    var axislabeldata = axisdata.label || {};
    var axisticklabeldata = axisdata.ticklabel || {};
    var axistickmarkdata = axisdata.tickmark;
    

    var axislabelProp = {},
        ticklabelFontSize = parseFloat($ZC.utils.getVal(getValByPriority([axisticklabeldata, systemConf.chart, systemConf.canvas, $ZCG], "fontSize"))),
        ticklabelFontFamily = $ZC.utils.getVal(getValByPriority([axisticklabeldata, systemConf.chart, systemConf.canvas, $ZCG], "fontFamily"));
    
    var rotation = (axisticklabeldata != null && axisticklabeldata.rotation != null && axisticklabeldata.rotation != "auto") ? axisticklabeldata.rotation : 0;
    //For hierarchy only rotate 0 available
    if(isHierarchy()){
        rotation = 0;
    }
    rotation = (rotation == null || rotation == "") ? 0 : parseFloat(rotation)
    rotation = (rotation < 0) ? (360 - mathAbs(rotation)) : rotation;
    rotation = (rotation > 360) ? (mathAbs(rotation) % 360) : rotation;


    var hideAxisLabel = axislabeldata.show === false || !defined(axislabeldata.text) || axislabeldata.text === "" || !dimension_based_intelligence(chartObj, (type + "axislabel"), intelligenceDim)
                        || (isHierarchy() && axisorder < chartObj.axes.x.count-1);

    var marginAxisLabel_right, marginAxisLabel_left, marginAxisLabel_bottom, marginAxisLabel_top;
    
    if(hideAxisLabel) {
        marginAxisLabel_right = marginAxisLabel_left = marginAxisLabel_bottom = marginAxisLabel_top = 0;
    } else {
        marginAxisLabel_top = pick(axislabeldata.marginTop, 5);
        marginAxisLabel_bottom = pick(axislabeldata.marginBottom, 5);
        marginAxisLabel_left = pick(axislabeldata.marginLeft, 5);
        marginAxisLabel_right = pick(axislabeldata.marginRight, 5);
    }

    var marginTickLabel_right = pick(axisticklabeldata.marginRight, 5),
        marginTickLabel_left = pick(axisticklabeldata.marginLeft, 5),
        marginTickLabel_bottom = pick(axisticklabeldata.marginBottom, 5),
        marginTickLabel_top = pick(axisticklabeldata.marginTop, 5);

    var topbaseline = "0.71em";
    
    var metaData = chartObj.systemConf.metadata;
    var columnidx = chartObj.dataset.getColumnIdx(type, axisorder);
    var dt = metaData.columns[columnidx].datatype;
    var metaConf = metaData.columns[columnidx][dt];
    
    var isMergedAxis = (type == "y") ? (metaData.axes.y[axisorder].length > 1) : false;
    var formatConf = metaConf;
    formatConf = (isMergedAxis && type == "y") ? merged_axis_column_intersect(axisorder, chartObj) : metaConf;

    this.preCalcAxisLen = 0;
    var tickmarkSize = pick(axistickmarkdata.size, 6);
    
    ticks.preCalcApproxAxisLength = function(plotarea) {
        var extent = (type == "x" && chartObj.brush) ? chartObj.brush.extent : null;

        /**
         * Calculating the tick values here
         *  TODO need to check
         */

        var axes = getAxisObject(chartObj,type,axisorder);

        var tickValues;

        var tickHelper = {
            axisRotated: axisrotated,
            axisOrder: axisorder,
            chart: chartObj,
            orient: orient
        };

        if (!axes.Ticks) {
            axes.Ticks = new $ZC.axis.Ticks(type, axisdata, plotarea, tickHelper);
        }

        this.tickValueObj = ticks.getTickValues(plotarea.width, plotarea.height, extent, true, null, axes.Ticks);

        // end calculating tick values

        var selector = (type == "x") ? type + '-axis-' + axisorder : type + '-axis-' + axisorder;
        var axisWrap = chartObj.svg.selectAll("g." + type + "-axis")
        axisWrap = axisWrap.selectAll("g." + selector).data(function() {
            return 1 > 0 ? [axisdata] : [];
        });
        axisWrap.enter().append("g").attr("class", selector);
        axisWrap.exit().remove();

        var dummygroup = axisWrap.selectAll('g.axisgroup').data([axisdata]);
        dummygroup.enter().append('g').attr('class', 'axisgroup');
        dummygroup.exit().remove();
        dummygroup.selectAll("line.majorTicks").style("display", "");

        // var dummygroup = container.append("g").attr("class","dummy").style("visibility","hidden");
        var axisarea = this.tickValueObj.axisgroup;
        var width = axisarea.width,
            height = axisarea.height,
            maxWidth = axisticklabeldata.maxWidth,
            maxHeight = axisticklabeldata.maxHeight;

        if ((orient === "left" || orient === "right") && defined(axisticklabeldata.width)) {
            width = perToPx((getPriorityValue(axisticklabeldata.width, maxWidth) || $ZC.axis.ticks.maxTickSizeRatio_Hori), plotarea.width);
        } else if (defined(axisticklabeldata.height)) {
            height = perToPx((getPriorityValue(axisticklabeldata.height, maxHeight) || $ZC.axis.ticks.maxTickSizeRatio_Vert), plotarea.height);
        }

        axisarea = this.preCalcTickLen = {
            "x": axisarea.left,
            "y": axisarea.top,
            "width": width,
            "height": height
        };

        var isHorizontal = type === "x" && !axisrotated,
            isVertical = !isHorizontal;

        var axisLabelProperties = {
            systemConf: systemConf,
            bound: axisarea,
            horizontal: isHorizontal,
            vertical: isVertical,
            axisOrder: axisorder,
            plotRect: plotarea,
            hide: hideAxisLabel
        };

        /**
         * Adding the axis label here for the only first time. Next time just calls the transform method.
         */
        var axisSize = 0;

        if (axes.axisLabel) {
            axes.axisLabel.show = !hideAxisLabel;
            axes.axisLabel.transformLabel(axisarea, plotarea, orient);
        } else {
            axes.axisLabel = new $ZC.axis.AxisLabel(axisdata, axisLabelProperties, orient, axisWrap);
        }

        if (!hideAxisLabel) {
            axisSize = axes.axisLabel.getBBox().height;
            axislabelProp.textAnchor = "middle";
            switch (orient) {
                case "left": {
                    axislabelProp.y = axisarea.height / 2;
                    axislabelProp.x = -(axisarea.width + marginTickLabel_left + axisLabelMargin.right)
                    axislabelProp.db = ""
                    this.preCalcAxisLen = axisarea.width + marginTickLabel_left + marginAxisLabel_right + axisSize + marginAxisLabel_left;
                    break
                }
                case "right": {
                    axislabelProp.x = axisarea.height / 2;
                    axislabelProp.y = -(axisarea.width + marginTickLabel_left + axisLabelMargin.right)
                    this.preCalcAxisLen = axisarea.width + marginAxisLabel_left + marginTickLabel_right + axisSize + marginAxisLabel_right;
                    break
                }
                case "bottom": {
                    axislabelProp.x = axisarea.width / 2;
                    axislabelProp.y = axisarea.height + marginTickLabel_bottom + axisLabelMargin.top
                    axislabelProp.dy = topbaseline;
                    this.preCalcAxisLen = axisarea.height + marginTickLabel_bottom + marginAxisLabel_bottom + axisSize + marginAxisLabel_top;
                    break
                }
                case "top": {
                    axislabelProp.x = axisarea.width / 2;
                    axislabelProp.y = axisarea.height + marginTickLabel_top + axisLabelMargin.bottom
                    axislabelProp.dy = topbaseline
                    this.preCalcAxisLen = axisarea.height + marginTickLabel_top + marginAxisLabel_top + axisSize + marginAxisLabel_bottom;
                    break
                }
            }
        } else {
            this.preCalcAxisLen = (orient === "bottom" || orient == "top") ? (axisarea.height + marginTickLabel_bottom) : (axisarea.width + marginTickLabel_left);
        }
        // dummygroup.remove()
        return this.preCalcAxisLen
    };
    
    
    ticks.getTickValues = function(width, height, zmInterval, isPreCalc, tickcount, Ticks, newPlotArea) {
        var tickValueObj = {};

        var tickHelper = {
            axisRotated: axisrotated,
            axisOrder: axisorder,
            chart: chartObj,
            orient: orient,
            extent: zmInterval
        };

        var tickValuesInfo = Ticks.getTicks(plotarea, tickcount, tickHelper),
            useHTML = defined(axisticklabeldata.showAs);

        var prop = tickValuesInfo.tickMargin;
        datatype = chartObj.dataset.getDataType(type, axisorder);
        var plotArea = pick(newPlotArea, plotarea);
        var dummygroup = container.append("g").attr("class", "dummy"),
            left = (orient === "right") ? plotArea.left + plotArea.width : plotArea.left,
            top = (orient === "bottom") ? plotArea.top + plotArea.height : plotArea.top;

        dummygroup.attr("transform", "translate(" + left + "," + top + ")");

        rotation = isNaN(tickValuesInfo.rotation) ? rotation : tickValuesInfo.rotation;

        var tickgroup = dummygroup.append("g").attr("class", "tick");
        var dummyBox = calcDummyTextBox(tickgroup, tickValuesInfo.longestTickValue.formattedVal, prop, rotation, useHTML, tickValuesInfo);
        dummyBox.call(function() {
            tickValueObj = getPreciseLongTickSize(plotArea, this, dummygroup, tickgroup, tickValuesInfo, defined(tickcount), useHTML);
        });

        dummygroup.remove();
        return tickValueObj;
    };

    ticks.getActualTicklabel = function () {
        var a = this.tickValueObj , b = a.ticks, value;
        if(this.isHierarchy()  && !this.isHierarchialLevelType() && a.tickValueIndices){
            value = function(i){
                var includes = a.tickValueIndices.indexOf(i);
                if( includes != -1){
                    return b[includes];
                }else{
                    return null;
                }
            }
        }else{
            value = function(i){
                return b[i];
            }
        }
        return value;
    }

    ticks.getTicksforAxisComp = function () {
        var datatype = chartObj.dataset.getDataType(type, axisorder);
        if ((isHierarchy(chartObj,type) && chartObj.dataObject.hierarchical.categoryTree && (datatype == ORDINAL_DATATYPE || datatype == "ordinalNonLinear")) || (isHierarchialLevelType() && chartObj.dataObject.hierarchical.groupByTime)){
            return null; // To be handled in TickFormats. No need to filter ticks (for hierarchy and ordinal)
        }else{
            return this.tickValueObj.ticks;
        }
    }

    function isHierarchialLevelType(){
        return isHierarchy() && axisorder > 0;
    }

    function isHierarchy(){
        return  type == "x" && chartObj.axes.x.count > 1;
    }

    function getPreciseLongTickSize(plotarea, dummyText, dummygroup, tickgroup, tickValuesInfo, iswebChart, useHTML) {
        var tickValueObj;

        var refContainer = dummyText;
        var hasTimeAutoFormat = (datatype === TIME_DATATYPE) && hasAutoFormat(formatConf);

        var tickvalues_formatted = tickValuesInfo.formatterTickValues;
        tickvalues = tickValuesInfo.rawTickValues;
        var longtick = tickValuesInfo.longestTickValue;
        var tickValueIndices = tickValuesInfo.tickValueIndices;
        var scale = tickValuesInfo.scale;


        // custom tick values.
        var customTickStyles, customTickValues;
        if(defined(tickValuesInfo.customTickInfo) && tickValuesInfo.customTickInfo.length) {
            customTickStyles = tickValuesInfo.customTickInfo.styles;
            customTickValues = tickValuesInfo.customTickInfo.userRawTicks;
        }

        var marginInfo = getMarginInfo(orient);

        var tickvalues_formatted_copy = sortByLength(tickvalues_formatted);

        var textWidth = function(text, index) {
            var style, dimension;
            if(defined(customTickStyles)) {
                style = customTickStyles[index];
            }

            dimension = getTextBound(text, ticklabelFontSize, ticklabelFontFamily, style);

            if(useHTML) {
                return dimension.width * dimension.height;
            }

            return dimension.width;
        };

        if (!iswebChart) {

            dummygroup.append("line").attr("class", "domain")
                .attr({
                    "x1": 0,
                    "y1": 0,
                    "x2": (orient == "bottom" || orient == "top") ? plotarea.width : 0.0001, // phantomjs 1.9.8 issue
                    "y2": (orient == "bottom" || orient == "top") ? 0.0001 : plotarea.height // // phantomjs 1.9.8 issue
                })
                .style("stroke", "black")

            var overflow = (axisticklabeldata.textOverflow == "none") ? "" : axisticklabeldata.textOverflow;
            var isFinalLongtick = false;
            var co = -1; // dummyText content has been changed if the ticklabels are filtered and the already defined maxTick is also filtered
            var tempLongtick = longtick.actualVal,
                tempFormattedLongTick = hasTimeAutoFormat ? tempLongtick : longtick.formattedVal;

            if(useHTML) {
                tempFormattedLongTick  = getCurrentCustomTick(tickValuesInfo.longestTickValue, null, tickValuesInfo);
            }


            wrapTextContent(dummyText, tempFormattedLongTick, null, useHTML);


            var rotationInfo = getTickRotateInfo(orient, rotation, dummyText, null, tickmarkSize, marginInfo);
            tickRotate(dummyText, rotationInfo);
            var pos = (scale(tempLongtick) || 0) + ((scale.rangeBand == null) ? 0 : scale.rangeBand() / 2); //scale(tempLongtick) || 0 (Test_496.json)
            pos = (orient == "bottom" || orient == "top") ? pos + ",0" : "0," + pos;
            tickgroup
                .attr("transform", "translate(" + pos + ")");


            handleOverflowTicks(dummyText, orient, {
                "svg": chartObj.svg,
                "canvasarea": chartObj.canvasarea,
                "plotarea": plotarea,
                "chartarea": chartObj.chartarea,
                "legendarea": chartObj.legendarea,
                "actChartObj": chartObj
            }, rotation, overflow, scale, dummygroup, null, "ticklabel", axisticklabeldata,axisorder);

            var curTick,maxTick,nextTick;
                //Initialize curtick,maxtick
                maxTick = curTick = useHTML ? tempFormattedLongTick: getTextContent(dummyText);//(hasTimeAutoFormat ? tempLongtick : longtick.formattedVal)

            while (datatype != "ordinalNonLinear" &&( !isFinalLongtick && (co < tickvalues.length))) {
                co = co + 1;
                var pos = (scale(tempLongtick) || 0) + ((scale.rangeBand == null) ? 0 : scale.rangeBand() / 2);
                pos = (orient == "bottom" || orient == "top") ? pos + ",0" : "0," + pos;
                tickgroup
                    .attr("transform", "translate(" + pos + ")");
                handleOverflowTicks(dummyText, orient, {
                    "svg": chartObj.svg,
                    "canvasarea": chartObj.canvasarea,
                    "plotarea": plotarea,
                    "chartarea": chartObj.chartarea,
                    "legendarea": chartObj.legendarea,
                    "actChartObj": chartObj
                }, rotation, overflow, scale, dummygroup, null, "ticklabel", axisticklabeldata,axisorder); // Test_462.json

                //Updating maxLength Tick which is longest tick after handle overflow //ZR506
                curTick = getTextContent(dummyText);
                //compare maxtick with curtick
                if (textWidth(curTick, co) > textWidth(maxTick, co)) {
                    tempFormattedLongTick = curTick;
                    if(useHTML) {
                        tempFormattedLongTick = getCurrentCustomTick(null, co, tickValuesInfo);
                    }
                    maxTick = tempFormattedLongTick;
                }
                //Apply maxtick to refgroup
                wrapTextContent(dummyText, maxTick, null, useHTML);

                //check overflow and next tick
                var isLastTick = (!tickvalues.length || (co === tickvalues.length - 1) || (tickvalues.length === 1));
                nextTick = ((isLastTick) ? null : (hasTimeAutoFormat ? tickvalues_formatted_copy[co] : tickvalues_formatted_copy[co] || ""));

                var isoverflow = (isLastTick) ? false : textWidth(curTick, co) < textWidth(nextTick, co);

                //set next tick to refgroup
                if (isoverflow) {
                    tempLongtick = tickvalues_formatted_copy[co];
                    curTick = nextTick;
                    tempFormattedLongTick = nextTick;
                    if(useHTML) {
                        tempFormattedLongTick = getCurrentCustomTick(null, co, tickValuesInfo);
                    }
                    wrapTextContent(dummyText, tempFormattedLongTick, null, useHTML);
                } else {
                    isFinalLongtick = true;
                }
            }
        }


        var referenceLongTickSize = refContainer.node().getBoundingClientRect();
        var refAxisgroupSize = dummygroup.node().getBoundingClientRect();

        tickValueObj = {
            "ticks": tickvalues,
            "rotation": rotation,
            "longTickSize": referenceLongTickSize,
            "longtick": longtick,
            "axisgroup": refAxisgroupSize,
            "customTicks": customTickValues
        };
        if(tickValueIndices){
            tickValueObj.tickValueIndices = tickValueIndices;
        }
        return tickValueObj;
    }
    
    function getMarginInfo(orient) {
        switch (orient) {
            case "left":
                return marginTickLabel_right;
                break;
            case "right":
                return marginTickLabel_left;
                break;
            case "bottom":
                return marginTickLabel_top;
                break;
            case "top":
                return marginTickLabel_bottom;
                break;
        }
    }

    /**
     *
     * @param longTick
     * @param index
     * @param tickInfo
     */
    function getCurrentCustomTick(longTick, index, tickInfo) {
        return tickInfo.customTickInfo.userRawTicks[defined(index) ? index : longTick.index];
    }
    
    function calcDummyTextBox(g, text, prop, rotation, useHTML, tickValueInfo) {

        var dummyText = g.selectAll("text").data([1]);
        dummyText.enter().append("text")
            .attr({
                "x": prop.x || 0,
                "y": prop.y || 0,
                "dy": prop.dy || 0
            })
            .attr("transform", "rotate(" + (rotation) + " " + (prop.x) + " " + (prop.y) + ")"); //7-spacing bw tickmark anad ticklabel

        if (useHTML) {
            text = getCurrentCustomTick(tickValueInfo.longestTickValue, null, tickValueInfo);
        } else {
            dummyText.text(text)
        }

        wrapTextContent(dummyText, text, null, useHTML);
        applyFont(dummyText, [axisticklabeldata, systemConf.chart, systemConf.canvas, $ZCG]);
        return dummyText
    }
    function tickRotate(ticklabels, rotationInfo) {
        ticklabels.attr({
            "dy": (axisticklabeldata.zigzag) ? rotationInfo.dy1 || rotationInfo.dy : rotationInfo.dy ,
            "transform": "rotate(" + rotationInfo.rotate[0] + " " + rotationInfo.rotate[1] + " " + rotationInfo.rotate[2] + ")"
        }).style({
            "text-anchor": rotationInfo.textAnchor
        })
    }

    return ticks;
};

$ZC.axis.constructTickObj = function(chartObj, chartWidth, chartHeight, orient, plotarea_approx, update) {
    /*
     constructing tick object for all axes which contains precalculated approximate axis area,tick values
     For calculating plot area precisely,first we are rendering left,right axes, for that we should have bottom axes area
     so we are pre calculating the left ,right axes area,From that we will get plotarea.width
     From plot area.width,we have calculate exact bottom axis area
     From exact bottom axis area, we will get plot area,height
     From plotarea.height,we will draw left right axes precisely
     Here wile calculating left/right axes, plotarea_approx is going to change
     But while calculating bottom axis exact plotarea height is going to change
     */
    var systemconf = chartObj.systemConf;

    var index = 0,
        type, axisdata;
    
    type = ((orient == "left" && chartObj.axes.rotated) || (orient == "bottom" && !chartObj.axes.rotated)) ? "x" : "y";
    var axesCount = chartObj.axes[type].count;
    
    for (var i = 0; i < axesCount; i++) {
        var yaxisData = systemconf.chart.axes.yaxis
        
        if (i > 0 && type == "y") {
            axisdata = update ? yaxisData[i] : mergeJSON(yaxisData[i], yaxisData[0], false);
            var dt = ((yaxisData[i] != null) && (yaxisData[i] !== "")) ? yaxisData[i] : {};
            axisdata.interval = dt.interval;
            axisdata.tickCount = dt.tickCount;
            axisdata.minRange = dt.minRange;
            axisdata.maxRange = dt.maxRange;
            axisdata.categories = dt.categories; //Test_523.json
            yaxisData[i] = axisdata;
        }
        axisdata = (type == "x") ? systemconf.chart.axes.xaxis : yaxisData[i];
        orient = axisdata.orient || ((type == "x")
                                        ? (chartObj.axes.rotated ? "left" : "bottom")
                                        : (chartObj.axes.rotated ? "bottom" : ((i == 0) ? "left" : "right")));
        var dim = (orient == "bottom" || orient == "top") ? chartHeight : chartWidth;
        var axisShow = axisdata.show === true && dimension_based_intelligence(chartObj, (type + "axis"), dim);

        if (axisShow) {
            var axisObj = getAxisObject(chartObj, type, i);
            if (type == "y" && !axisObj) {
                axisObj =  {}
            }
            if(type == "x" && !axisObj){
                axisObj = (i > 0) ? {} : axisObj;
            }
            var tickObj = $ZC.axis.ticks(chartObj, axisdata, type, i, orient, plotarea_approx);
            axisObj.ticks = tickObj;
            var axisarea = tickObj.preCalcApproxAxisLength(plotarea_approx);
            
            if(!((type === "y") && chartObj.axes.y.groups[i].disabled)){
                var plotarea = chartObj.plotarea;
                if (orient == "left") {
                    plotarea_approx.left += axisarea
                    plotarea_approx.width = plotarea_approx.width - axisarea

                    plotarea.left = plotarea_approx.left;
                    plotarea.width = plotarea_approx.width;
                } else if(orient == "right") {
                    plotarea_approx.width = plotarea_approx.width - axisarea;

                    plotarea.width = plotarea_approx.width;

                } else if (orient == "bottom") {
                    plotarea.height = plotarea.height - (axisarea);
                    plotarea.bottom += axisarea;
                    
                    plotarea_approx.height = plotarea.height;
                    plotarea_approx.bottom += plotarea.bottom;
                } else if (orient == "top") {
                    plotarea.height = plotarea.height - (axisarea);
                    plotarea.top += axisarea;
                    
                    plotarea_approx.height = plotarea.height;
                    plotarea_approx.top += plotarea.top;
                }
            }
        } else {
            // reset axis label and tick label
            var axes = type === "y" ? chartObj.axes.y.groups[i] : chartObj.axes.x;
            axes.axisLabel = axes.Ticks = null;
        }
        
    }
    
    //Initializing chart brush before pre rrendering X tick obj
    if (type == "y" && isObjectPropDefined(systemconf.chart, "scroll") && systemconf.chart.scroll.enabled) {
        chartObj.svg.call(chartObj.brush);
        chartObj.brush.initialize(plotarea_approx)
    }
};

function getTickRotateInfo(orient, rotation, ticklabels, axis, tickmarkSize, tickPadding, zigzag) {
    var rotateInfo = {}
    var topbaseline = "0.71em",
        middlebaseline = "0.35em",
        bottombaseline = "",
        tickPadding = (tickPadding == null) ? axis.tickPadding() : tickPadding;
    
    switch (orient) {
        case 'top':
            rotateInfo.rotate = [rotation, 0, -(mathMax(tickmarkSize, 0) + tickPadding)];
            
            if ((rotation >= 0 && rotation < 45) || (rotation > 315 && rotation <= 360)) {
                rotateInfo.dy = bottombaseline;
            } else if ((rotation >= 45 && rotation <= 90) || (rotation >= 90 && rotation <= 135) || (rotation >= 225 && rotation <= 315)) {
                rotateInfo.dy = middlebaseline;
            } else if ((rotation > 135 && rotation < 225)) {
                rotateInfo.dy = topbaseline
            }
            rotateInfo.textAnchor = (rotation == "0" || pInt(rotation) == 180 || pInt(rotation) == 360) ? "middle" : (pInt(rotation) < 180) ? "end" : "start"
            break;
        
        case 'bottom':
            rotateInfo.rotate = [rotation, 0, (mathMax(tickmarkSize, 0) + tickPadding)];
            
            if ((rotation >= 0 && rotation < 45) || (rotation > 315 && rotation <= 360)) {
                rotateInfo.dy = topbaseline;
                rotateInfo.dy1 = "1.71em";
            } else if ((rotation >= 45 && rotation <= 90) || (rotation >= 90 && rotation <= 135) || (rotation >= 225 && rotation <= 315)) {
                rotateInfo.dy = middlebaseline;
            } else if ((rotation > 135 && rotation < 225)) {
                rotateInfo.dy = bottombaseline
            }
            rotateInfo.textAnchor = (rotation == "0" || pInt(rotation) == 180 || pInt(rotation) == 360) ? "middle" : (pInt(rotation) < 180) ? "start" : "end"
            break;
        
        case 'left':
            rotateInfo.rotate = [rotation, -(mathMax(tickmarkSize, 0) + tickPadding), 0];
            
            if ((rotation >= 0 && rotation < 45)) {
                rotateInfo.dy = middlebaseline;
            } else if ((rotation >= 45 && rotation <= 90) || (rotation >= 90 && rotation <= 135)) {
                rotateInfo.dy = topbaseline;
            } else if ((rotation > 135 && rotation < 225) || (rotation >= 225 && rotation <= 315) || (rotation > 315 && rotation <= 360)) {
                rotateInfo.dy = bottombaseline
            }
            rotateInfo.textAnchor = (rotation == "90" || pInt(rotation) == 270) ? "middle" : (rotation > 90 && rotation < 270) ? "start" : "end"
            break;
        
        case 'right':
            rotateInfo.rotate = [rotation, (mathMax(tickmarkSize, 0) + tickPadding), 0];
            
            if ((rotation >= 0 && rotation < 45) || (rotation > 135 && rotation < 225)) {
                rotateInfo.dy = middlebaseline;
            } else if ((rotation >= 225 && rotation <= 315) || (rotation > 315 && rotation <= 360)) {
                rotateInfo.dy = topbaseline;
            } else if ((rotation >= 90 && rotation <= 135) || (rotation >= 45 && rotation <= 90)) {
                rotateInfo.dy = bottombaseline
            }
            rotateInfo.textAnchor = (rotation == "90" || pInt(rotation) == 270) ? "middle" : (rotation > 90 && rotation < 270) ? "end" : "start"
            break;
    }
    
    return rotateInfo;
}

function tickRotate(ticklabels, rotationInfo) {
    ticklabels.attr({
        "dy": (axisticklabeldata.zigzag) ? rotationInfo.dy1 || rotationInfo.dy : rotationInfo.dy ,
        "transform": "rotate(" + rotationInfo.rotate[0] + " " + rotationInfo.rotate[1] + " " + rotationInfo.rotate[2] + ")"
    }).style({
        "text-anchor": rotationInfo.textAnchor
    })
}

function handleOverflowTicks(axisgroup, orient, chartObj, rotation, overflow, scale, wrap, axisComp, labelType, ticklabelOptions,index) {
    var plotarea = chartObj.plotarea,
        chartarea = chartObj.chartarea,
        canvasarea = chartObj.canvasarea,
        ticklabelOptions = (labelType == "ticklabel") ? ticklabelOptions : {},
        actChartObj = chartObj.actChartObj || chartObj;
    var percentLimit = 0.5;

    var labelSize = getMaxTickSize(ticklabelOptions, chartarea),
        maxTickSize_Vert = labelSize.vertical,
        maxTickSize_Hori = labelSize.horizontal;
    
    var pattern = (overflow == null || overflow == "ellipsis") ? ".." : "";
    
    var margin = {};
    margin.left = (labelType == "axislabel") ? (percentLimit * (canvasarea.width - (plotarea.left + plotarea.width))) : (percentLimit * plotarea.left), //ZC743 If its axislabel margin right and left should be same, because always axislabel placed at center of plotarea with textanchor middle
    margin.right = (percentLimit * (canvasarea.width - (plotarea.left + plotarea.width))),
    margin.top = (percentLimit * plotarea.top),
    margin.bottom = (percentLimit * plotarea.bottom);
    
    
    // var marginValue = (orient == "bottom") ? (plotarea.width*margin)/100 : (plotarea.height*margin)/100;
    // var range = (scale.rangeBand != null) ? (orient == "bottom" || orient == "top") ? scale.rangeExtent() : scale.rangeExtent().reverse() : scale.range(); //reverse it only for orient left
    var  isHierarchialLevelType = scale.discreteWidth != null;
    if (axisgroup == null && labelType == "ticklabel") {
        var ticks = axisComp.tickValues() == null ? scale.ticks ? scale.ticks.apply(scale, [10]) : scale.domain() : axisComp.tickValues();
        var tickWrap = wrap.selectAll(".tick").data(ticks, scale);
        axisgroup = tickWrap.selectAll("text.ticklabel")
    }
    
    axisgroup.filter(function(d, j) {

        /*
         * Cropping the text to maximum ticklabel size (according to bounded box of the text)
         */

        var childNodes  = [this.childNodes[0]];//If the SVG text has title element, the title element will be removed while changing this.textContent as because it modifies all the childNodes of it. So take the text element alone to trim

        var tspan = d3.select(this).selectAll("tspan")[0];
        if(tspan.length){ // only for multiple line ticklabel
            tspan.sort(function(a,b){
                return b.textContent.length - a.textContent.length
            })
            childNodes = tspan;
        }

        if (!childNodes) {
            return;
        }
        for (var i = 0; i < childNodes.length; i++) {
            var txtNode = (tspan.length) ? childNodes[i] : this;
            var clientRect = (txtNode.nodeName == "tspan") ? getTspanBoundingClientRect : getDefaultBoundingClientRect;
            var textBounds = clientRect(txtNode);
            var overflowLength = -1;


            if (isHierarchialLevelType && labelType == "ticklabel" && !chartObj.actChartObj) {
                var axisObj = getAxisObject(actChartObj, "x", index - 1),
                    tickMarkSize = axisObj.ticks.tickValueObj.tickMarkSize,
                    prevAxisObj = getAxisObject(actChartObj, "x", index),
                    prevTickMarkSize = (prevAxisObj) ? prevAxisObj.ticks.tickValueObj.tickMarkSize : 0;


                var rb = (orient == "left" || orient =="right") ? Math.abs(prevTickMarkSize - tickMarkSize) : Math.abs(scale.discreteWidth(d)) || maxTickSize_Hori;
                naiveEllipsis(txtNode, txtNode, txtNode.textContent, rb, maxTickSize_Vert, textBounds, pattern);
                return;
            }

            var initial_textContent = txtNode.textContent,
                initial_textBound = textBounds,
                max = { // This should be changed for axis labels
                    width: maxTickSize_Hori,
                    height: maxTickSize_Vert
                },
                trimmed,
                minMargin = bbox(this).height; //if margin is very less, tick labels are trimmed unnecessarily. So set minMargin as its height
            if (labelType == "ticklabel") {
                if (maxTickSize_Hori < textBounds.width) {
                    overflowLength = (textBounds.width - maxTickSize_Hori) / textBounds.width;
                    var croppedTextLength = mathCeil((1 - overflowLength) * txtNode.textContent.length);
                    txtNode.textContent = txtNode.textContent.substring(0, croppedTextLength - 2) + pattern;
                    textBounds = clientRect(txtNode); //update new textbounds
                }
                if (maxTickSize_Vert < textBounds.height) {
                    overflowLength = (textBounds.height - maxTickSize_Vert) / textBounds.height;
                    var croppedTextLength = mathCeil((1 - overflowLength) * txtNode.textContent.length);
                    txtNode.textContent = txtNode.textContent.substring(0, croppedTextLength - 2) + pattern;
                    textBounds = clientRect(txtNode); //update new textbounds
                }
            }

            // var svgarea = document.querySelectorAll("svg")[0].getBoundingClientRect();
            var axisGroupBounds = wrap.selectAll(".domain").node().getBoundingClientRect();

            var newTextBounds = {
                left: (textBounds.left - axisGroupBounds.left),
                right: (textBounds.left + textBounds.width - axisGroupBounds.left),
                top: (textBounds.top - axisGroupBounds.top),
                bottom: (textBounds.top + textBounds.height - axisGroupBounds.top),
                width: textBounds.width,
                height: textBounds.height
            };

            //Edge details for hierarchy data and between tickmarks
            var edge = {};
            edge.top = edge.left = 0;
            edge.right = (orient == "bottom" || orient == "top") ? getPlotSize(actChartObj, "width", plotarea) : 0;
            edge.bottom = (orient == "bottom" || orient == "top") ? 0 : getPlotSize(actChartObj, "height", plotarea);
            if ((orient == "left" || orient == "right") && (rotation != 0 && rotation != 180 && rotation != 360)) {
                if ((newTextBounds.top + mathMax(minMargin, margin.top) < edge.top) || (newTextBounds.bottom - mathMax(minMargin, margin.bottom) > edge.bottom)) {
                    trimmed = true;
                    trimText(txtNode, txtNode.textContent, newTextBounds, edge, orient, pattern, margin, max, this);
                }
            } else if ((orient == "bottom" || orient == "top") && (rotation != 90 && rotation != 270)) {
                if ((newTextBounds.left + mathMax(minMargin, margin.left) < edge.left) || (newTextBounds.right - mathMax(minMargin, margin.right) > edge.right)) {
                    trimmed = true;
                    trimText(txtNode, txtNode.textContent, newTextBounds, edge, orient, pattern, margin, max, this);
                }
            }

            if ((labelType == "ticklabel") && !trimmed) {
                var textBounds = clientRect(txtNode);
                if ((textBounds.width != initial_textBound.width) || (textBounds.height != initial_textBound.height)) {
                    naiveEllipsis(txtNode, this, initial_textContent, max.width, max.height, textBounds, pattern);
                }
            }
        }
    })
}

var getPriorityValue = function(constant, max) {
    if (defined(constant) && defined(constant)) {
        return constant > max ? max : constant
    } else {
        return constant || max;
    }
};

/**
 *
 * @param obj tick label object or axis label object
 * @param p plotarea
 * @returns {{vertical: *, horizontal: *}}
 */
function getMaxTickSize(obj, p) {
    return {
        vertical: perToPx(pick(obj.height, obj.maxHeight, $ZC.axis.ticks.maxTickSizeRatio_Vert), p.height),
        horizontal: perToPx(pick(obj.width, obj.maxWidth, $ZC.axis.ticks.maxTickSizeRatio_Hori), p.width)
    }
}

/**
 * Check if the formatter is specified to auto
 *
 * @param {Object} formatConf
 * @returns {boolean}
 */

function hasAutoFormat(formatConf) {
    return formatConf && formatConf.format && (formatConf.format.specifier === "auto");
}

function toRadians(angle) {
    return angle * (Math.PI / 180);
}

function getTspanBoundingClientRect(tspan){
    var range = document.createRange();
    range.selectNode(tspan);
    var rect = range.getBoundingClientRect();
    range.detach(); // frees up memory in older browsers
    return rect;
}

function getDefaultBoundingClientRect(text){
    return text.getBoundingClientRect();
}

function getBoundingClientRect(text, angle, fontSize, fontFamily) {
    var width = getTextWidth(text, fontSize, fontFamily);
    return calculateBound(width, getFontHeight(fontSize), angle);
}

function calculateBound(width, height, angle) {
    angle = toRadians(angle);
    return {
        width: Math.sin(angle) * height + Math.cos(angle) * width,
        height: Math.sin(angle) * width + Math.cos(angle) * height
    }
}

/**
 *
 * @param text
 * @param fontSize
 * @param fontFamily
 * @param {{fontFamily: string, fontSize: number, fontStyle: string}} styles
 * @returns {{width: *, height: *}}
 */

function getTextBound(text, fontSize, fontFamily, styles, dontUseEmpirical) {
    var hasMultipleLines = isArray(text), w, h,
        fontHeight = getFontHeight(fontSize);

    if (hasMultipleLines) {
        text.forEach(function(d, i) {
            if (defined(styles) && styles.length) {
                fontSize = styles[i].fontSize || fontSize;
                fontFamily = styles[i].fontFamily || fontFamily;
            }
            var tempWid = getTextWidth(d, fontSize, fontFamily);
            fontHeight = getFontHeight(fontSize);
            w = (!defined(w)) ? tempWid : mathMax(w, tempWid);
            h = (!defined(h)) ? fontHeight : h + (1.1 * fontHeight);
        })
    } else {
        if (defined(styles)) {
            fontSize = styles.fontSize || fontSize;
            fontFamily = styles.fontFamily || fontFamily;
        }
        w = getTextWidth(text, fontSize, fontFamily);
        h = getFontHeight(fontSize, dontUseEmpirical);
    }
    return {
        "width": w,
        "height": h
    }
}

function getTextWidth(text, fontSize, fontFamily) {
    tempCanvasContext.save();
    tempCanvasContext.font = (fontSize || 12) + "px " + (fontFamily || $ZCG.fontFamily);
    var t = tempCanvasContext.measureText(text).width;
    tempCanvasContext.restore();
    return t;
}

function getFontHeight(fontSize, dontUseEmpirical) {

    // Empirical values found by comparing font size and bounding box height.
    // Applies to the default font family. http://jsfiddle.net/highcharts/7xvn7/
    if(dontUseEmpirical){
        return fontSize;
    }
    return fontSize < 24 ? fontSize + 3 : ~~(fontSize * 1.195);
}

function getBBox(fontSize, text, X, Y, DY) {

    var fontFamily = $ZCG.fontFamily;

    var textBound = getTextBound(text, fontSize, fontFamily);

    var fontHeight = getFontHeight(fontSize);
    var baseline = -fontHeight * 0.8;

    var x = textBound.width / 2;
    var y = baseline + Y + (fontSize * DY);

    return {
        x: -x,
        y: y,
        width: textBound.width,
        height: textBound.height
    }
}


function wrapTicklabels(text,tickFormat){
    text.each(function (d,i) {
        var tick = d3.select(this);
        var formattedValue = (tickFormat) ? tickFormat(d,i) : getTextContent(tick);
        wrapTextContent(tick,formattedValue);
    })
}


//$Id$
$ZC.axis.polar = function() {
    var scale, chartObj, radius, columnIndices, tickFormat, tickValues,
        columnInfo;
    
    function axis(g) {
        g.each(function(data) {
            var g = d3_select(this);
            var systemconf = chartObj.systemConf,
                axisline = data.axisline,
                tickmark = data.tickmark,
                subtickmark = data.subtickmark || {},
                grid = data.grid,
                ticklabel = data.ticklabel,
                events = ticklabel.events,
                mousemoveFn, mouseoutFn, clickFn, dblclickFn, cursor;
            if (events != null) {
                mousemoveFn = events.mousemove;
                mouseoutFn = events.mouseout;
                clickFn = events.click;
                dblclickFn = events.doubleclick;
                cursor = events.cursor;
            }
            
            var tickOrient = data.tickOrient,
                axislineSize = axisline.show ? validateNullVal(axisline.strokeWidth, 1) : 0,
                gridSize = validateNullVal(grid.strokeWidth, 1),
                ticklabelPad = validateNullVal(ticklabel.marginLeft, 5),
                tickmarkSize = validateNullVal(tickmark.size, 3),
                subtickmarkSize = validateNullVal(subtickmark.size, 2),
                subticksCount = (+subtickmark.count || 0);
            
            var ticks = tickValues || (scale.ticks ? scale.ticks() : scale.domain()),
                subticks = d3_svg_axisSubdivide(scale, ticks, subticksCount),
                range = scale.rangeExtent ? scale.rangeExtent() : scale.range();
            
            var tick = g.selectAll(".tick").data(ticks, scale);
            var tickEnter = tick.enter().insert("g", ".domain").attr("class", "tick");
            tick.exit().remove();
            
            var subticksGroup = g.selectAll(".subticks").data([1]);
            subticksGroup.enter().insert("g", "g").attr("class", "subticks");
            subticksGroup
                .style("stroke", subtickmark.color);
            var subtick = appendEle(subticksGroup, "line", subticks);
            
            var path = appendEle(g, "path", (axisline.show ? [1] : []), ".", "class", "domain");
            path
                .attr("d", function() {
                    var path = d3_arc()
                        .innerRadius(radius - 1)
                        .outerRadius(radius)
                        .startAngle(range[0])
                        .endAngle(range[1])(1);
                    return "M" + path.split(/L|M/gi)[1];
                })
                .style({ //Axis line properties
                    "stroke": axisline.color,
                    "fill": "none",
                    "stroke-width": axislineSize,
                    "stroke-dasharray": getDashArray(axisline.style, axislineSize),
                    "stroke-linecap": getLineCap(axisline.lineCap, axisline.style),
                    "pointer-events": "none"
                });
            
            tickEnter.append("line").attr("class", "tickmark");
            tickEnter.append("line").attr("class", "grid");
            tickEnter.append("text");
            var text = tick.select("text"),
                line = tick.select("line.tickmark"),
                gridLine = tick.select("line.grid");
            
            text
                .style("cursor", cursor || "pointer")
                .text(function(d) {
                    return tickFormat(d);
                });
            applyFont(text, [ticklabel, systemconf.chart, systemconf.canvas, $ZCG]);
            
            columnInfo = {
                "data": columnIndices.map(function(d) {
                    return mergeJSON(chartObj.systemConf.metadata.columns[d], {
                        "columnindex": d
                    }, true);
                })
            };

            var mousemove = function(d) {
                    callback(mousemoveFn, d3.event, d);
                },
                mouseout = function(d) {
                    callback(mouseoutFn, d3.event, d);
                },
                click = function(d) {
                    callback(clickFn, d3.event, d);
                },
                dblclick = function(d) {
                    callback(dblclickFn, d3.event, d);
                };
            var mouseHandlers = {
                    "mousemove": mousemove,
                    "mouseout": mouseout,
                    "click": click,
                    "dblclick": dblclick
                },
                touchHandlers = {
                    "singletouchmove": mousemove,
                    "touchend": mouseout,
                    "tap": click,
                    "dbltap": dblclick
                };
            attachevents(text, mouseHandlers, touchHandlers);
            
            var tickRad, textRad, tickmarkRad, subtickmarkRad;
            switch (tickOrient) {
                case "inner":
                    tickRad = radius - axislineSize / 2;
                    textRad = -(tickmarkSize + ticklabelPad);
                    tickmarkRad = -tickmarkSize;
                    subtickmarkRad = -subtickmarkSize;
                    break;
                default:
                    tickRad = radius + axislineSize / 2;
                    textRad = tickmarkSize + ticklabelPad;
                    tickmarkRad = tickmarkSize;
                    subtickmarkRad = subtickmarkSize;
            }
            tick
                .attr("transform", function(d) {
                    var xy = polarToXY(tickRad, scale(d));
                    return "translate(" + xy[0] + "," + xy[1] + ")";
                });
            text
                .attr({
                    "dy": function(d) {
                        var a = d0_360(scale(d));
                        return (tickOrient == "inner") ?
                            ((!((a > mathPI / 2) && (a < 3 * mathPI / 2))) ? -getDY(a) + "em" : null) :
                            (((a > mathPI / 2) && (a < 3 * mathPI / 2)) ? getDY(a) + "em" : null);
                    },
                    "text-anchor": function(d) {
                        var a = d0_360(scale(d));
                        return (a % mathPI == 0) ?
                            "middle" :
                            (((tickOrient == "inner" && a < mathPI) || (tickOrient != "inner" && a > mathPI)) ? "end" : null);
                    },
                    "transform": function(d) {
                        var xy = polarToXY(textRad, scale(d));
                        return "translate(" + xy[0] + "," + xy[1] + ")";
                    }
                });
            line
                .attr({
                    "x2": function(d) {
                        return polarToXY(tickmarkRad, scale(d))[0];
                    },
                    "y2": function(d) {
                        return polarToXY(tickmarkRad, scale(d))[1];
                    }
                })
                .style({
                    "stroke": tickmark.color,
                    "stroke-width": tickmark.strokeWidth
                }); //tickmark properties
            
            gridLine
                .attr({
                    "x2": function(d) {
                        return polarToXY(-radius, scale(d))[0];
                    },
                    "y2": function(d) {
                        return polarToXY(-radius, scale(d))[1];
                    }
                })
                .style({
                    "stroke": grid.color,
                    "stroke-width": gridSize,
                    "stroke-dasharray": getDashArray(grid.style, gridSize),
                    "stroke-linecap": getLineCap(grid.lineCap, grid.style)
                }); //grid properties
            
            subtick
                .attr({
                    "x2": function(d) {
                        return polarToXY(subtickmarkRad, scale(d))[0];
                    },
                    "y2": function(d) {
                        return polarToXY(subtickmarkRad, scale(d))[1];
                    },
                    "transform": function(d) {
                        var xy = polarToXY(tickRad, scale(d));
                        return "translate(" + xy[0] + "," + xy[1] + ")"
                    }
                });
            
        });
    }
    
    axis.scale = function(x) {
        if (!arguments.length) return scale;
        scale = x;
        return axis;
    };
    axis.chartObj = function(x) {
        if (!arguments.length) return chartObj;
        chartObj = x;
        return axis;
    };
    axis.radius = function(x) {
        if (!arguments.length) return radius;
        radius = x;
        return axis;
    };
    axis.columnIndices = function(_) {
        if (!arguments.length) {
            return columnIndices;
        }
        columnIndices = _;
        return axis;
    };
    axis.tickValues = function(_) {
        if (!arguments.length) {
            return tickValues;
        }
        tickValues = _;
        return axis;
    };
    axis.tickFormat = function(_) {
        if (!arguments.length) {
            return tickFormat;
        }
        tickFormat = _;
        return axis;
    };
    return axis;
    
    function d3_svg_axisSubdivide(scale, ticks, m) {
        subticks = [];
        if (m && ticks.length > 1) {
            var extent = d3_scaleExtent(scale.domain()),
                subticks, i = -1,
                n = ticks.length,
                d = (ticks[1] - ticks[0]) / ++m,
                j, v;
            while (++i < n) {
                for (j = m; --j > 0;) {
                    if ((v = +ticks[i] - j * d) >= extent[0]) {
                        subticks.push(v);
                    }
                }
            }
            for (--i, j = 0; ++j < m && (v = +ticks[i] + j * d) < extent[1];) {
                subticks.push(v);
            }
        }
        return subticks;
    }
    
    function d3_scaleExtent(domain) {
        var start = domain[0],
            stop = domain[domain.length - 1];
        return start < stop ? [start, stop] : [stop, start];
    }
    
    function callback(func, e, d) {
        if (func != null) {
            columnInfo.data = columnInfo.data.map(function(dt) {
                dt.value = d;
                return dt;
            });
            invokeFunction(func, e, columnInfo, chartObj);
        }
    }
};//$Id$
$ZC.axis.polar.render = function(chartObj, type) {
    var type = type || "y",
        index = 0;
    var systemconf = chartObj.systemConf,
        renderer = chartObj.renderer[0],
        dataObj = chartObj.dataObject,
        plotarea = chartObj.plotarea,
        canvasarea = chartObj.canvasarea,
        columns = chartObj.systemConf.metadata.columns,
        chart = chartObj.chartTypes[0],
        chartType = chart.value,
        chartName = chart.name;

    var commonPlotOptions = systemconf.chart.plot.plotoptions[chartName];
    var axis_data = (type == "x") ? systemconf.chart.axes.xaxis : systemconf.chart.axes.yaxis[index],
        outerPadding = (+commonPlotOptions.outerPadding || 0),
        maxRadius = (+commonPlotOptions.maxRadius || 0);
    var isDial = (chartType === $ZC.charttype.dial);
    
    
    var show = axis_data.show && dimension_based_intelligence(chartObj, (type + "axis"), mathMin(canvasarea.width, canvasarea.height));
    var axislineSize = (show && axis_data.axisline.show) ? validateNullVal(axis_data.axisline.strokeWidth, 1) : 0,
        ticklabelPad = validateNullVal(axis_data.ticklabel.marginLeft, 5),
        tickmarkSize = validateNullVal(axis_data.tickmark.size, 3),
        subtickmarkSize = (axis_data.subtickmark) ? validateNullVal(axis_data.subtickmark.size, 2) : 0,
        ticklabelFontsize = $ZC.utils.getVal(axis_data.ticklabel.fontSize || systemconf.chart.fontSize || systemconf.canvas.fontSize || $ZCG.fontSize),
        orient = axis_data.orient || "outer",
        tickOrient = axis_data.tickOrient;
    
    var w = plotarea.width - (2 * outerPadding),
        h = plotarea.height - (2 * outerPadding);
    var radius = mathMin(w, h) / 2;
    var innerRadius = getInnerRadius(commonPlotOptions, radius),
        padding = show ? (+commonPlotOptions.padding || 0) : 0;
    chartObj.plotarea_approx = {
        x: 0,
        y: 0,
        innerRadius: innerRadius
    };
    
    var sc = $ZC.scale.constructor(chartObj, ((type == "x") ? "bottom" : "left"));
    var scale = (type == "x") ? sc[0].scale : sc[index].scale;
    var range = scale.rangeExtent ? scale.rangeExtent() : scale.range();
    
    var columnidx = chartObj.dataset.getColumnIdx(type, index);
    var colInfo = columns[columnidx];
    var datatype = colInfo.datatype;
    var formatConf = colInfo[datatype];
    // var ticksObj = $ZC.axis.ticks(chartObj, axis_data, type, index, "left", plotarea);
    // var tickVal = ticksObj.getTickValues(2*radius, 2*radius,null,null,radius/10);
    
    var axisRadius = (orient == "inner") ?
        ((tickOrient === "outer") ?
            (innerRadius - padding - axislineSize / 2 - mathMax(subtickmarkSize, (tickmarkSize + ticklabelPad + ticklabelFontsize))) :
            innerRadius) :
        radius;
    var axisComponent = $ZC.axis.polar()
        .scale(scale)
        .chartObj(chartObj)
        .radius(axisRadius)
        .columnIndices([columnidx])
        .tickFormat(function(d) {
            return getFormattedValue(formatConf, d, datatype, chartObj, "axis");
        })
        .tickValues(null); //.tickValues(tickVal.ticks);
    
    var container = appendEle(chartObj.svg.selectAll("g.chartgroup"), "g", [1], ".", "class", (type + "-axis"));
    var wrap = appendEle(container, "g", (show ? [axis_data] : []), ".", "class", "axisgroup");
    wrap.call(axisComponent);
    container.style("visibility", "hidden");
    
    //dummy arc
    var arc = d3_arc()
        .innerRadius((!isDial || commonPlotOptions.needle.show || isDatalabelEnabled(commonPlotOptions.datalabels, chartObj)) ? 0 : innerRadius)
        .outerRadius(radius)
        .startAngle(range[0])
        .endAngle(range[1]);
    var dummyArc = container.append("path")
        .attr("d", arc(1));
    
    //Minmax label and datalabel - dial chart
    var datalabel = container.append("g").attr("class", "datalabel");
    var targetMarkerSeries = container.append("g").attr("class", "targetSeries");
    if (isDial) {
        if (!renderer) {
            var curSeriesidx = 0;
            renderer = chartObj.renderer[curSeriesidx] = createSVGRenderer(chartName);
            chartObj.rendererConf = [];
            chartObj.rendererConf[curSeriesidx] = new $ZC.plot.rendererConf();
            renderer_helpers.setRendererProp(chartObj, renderer, chartObj.seriesdata[curSeriesidx], curSeriesidx, []);
        }
        datalabel
            .call($ZC.labelRenderer.dial()
                .renderer(renderer)
                .args([chartObj.seriesdata, 0]), chartObj.labelHandler, datalabel
            );
        
        drawMinMaxLabel(container, scale, radius, innerRadius);
        svg_plot_renderer.dial.targetMarker(targetMarkerSeries, radius, innerRadius, chartObj);
        
        //needle calculation
        var needleWidth = (+commonPlotOptions.needle.width) / 2 || 7
        var cir = appendEle(datalabel, "circle", (commonPlotOptions.needle.show ? [1] : []));
        cir
            .attr({
                "r": needleWidth,
                "transform": "translate(" + needleWidth + "," + needleWidth + ")"
            });
    }
    
    //calculating new radius
    var arcBound = bbox(dummyArc.node());
    var bb = bbox(container.node());
    var heightPercent = ((arcBound.height) / radius),
        widthPercent = ((arcBound.width) / radius);
    var newradius = radius + mathMin(((w - bb.width) / widthPercent), ((h - bb.height) / heightPercent));
    newradius = isDial ?
        ((newradius > maxRadius) ? maxRadius : newradius) // Setting maximum to the radius
        :
        newradius;
    innerRadius = getInnerRadius(commonPlotOptions, newradius) - ((orient == "inner") ? (+commonPlotOptions.strokeWidth || 0) / 2 : 0);
    axisRadius = ((orient == "inner") ?
            ((tickOrient == "inner") ? innerRadius : (innerRadius - (getMinRadius(radius) - radius))) :
            newradius) -
        ((tickOrient == "inner") ? (axislineSize / 2) : 0) -
        ((orient == "inner") ? padding : 0);
    axisComponent.radius(axisRadius);
    wrap.call(axisComponent);
    arc
        .outerRadius(newradius)
        .innerRadius((!isDial || commonPlotOptions.needle.show || isDatalabelEnabled(commonPlotOptions.datalabels, chartObj)) ? 0 : innerRadius);
    dummyArc.attr("d", arc(1));
    if (isDial) {
        drawMinMaxLabel(container, scale, newradius, innerRadius);
        svg_plot_renderer.dial.targetMarker(targetMarkerSeries, newradius, innerRadius, chartObj);
    }
    
    //Reference point calculation
    var arcBound = bbox(dummyArc.node());
    var bb = bbox(container.node());
    var pt = polarRefPoint(bb, plotarea.width, plotarea.height, newradius, 0);
    
    container
        .attr("transform", "translate(" + (plotarea.left + pt[0]) + "," + (plotarea.top + pt[1]) + ")");
    container.style("visibility", null);
    
    var arcRad = ((tickOrient == "inner" && orient == "outer") ?
            getMinRadius(newradius) :
            newradius - ((orient == "inner") ? 0 : (axislineSize / 2))) -
        ((orient == "inner") ? 0 : padding);
    var dwidth = (tickOrient == "inner") ? (newradius - arcRad) * widthPercent : 0,
        dheight = (tickOrient == "inner") ? (newradius - arcRad) * heightPercent : 0;
    
    chartObj.plotarea_approx = {
        x: pt[0],
        y: pt[1],
        width: arcBound.width - axislineSize - dwidth,
        height: arcBound.height - axislineSize - dheight,
        radius: arcRad,
        actualRadius: newradius,
        innerRadius: innerRadius
    };
    
    dummyArc.remove();
    datalabel.remove();
    targetMarkerSeries.remove();
    
    if (dataObj.isPolarAxisCategory) {
        var type = "y",
            yindex = 0;
        var yaxis_data = systemconf.chart.axes.yaxis[yindex],
            radius = chartObj.plotarea_approx.radius,
            x = chartObj.plotarea_approx.x,
            y = chartObj.plotarea_approx.y;
        
        var orient = yaxis_data.orient || "right",
            tickSize = validateNullVal(yaxis_data.tickmark.size, 6),
            tickPadding = validateNullVal(yaxis_data.ticklabel[(orient == "left") ? "marginRight" : "marginLeft"], 3),
            isArcGrid = (yaxis_data.grid.type === "arc");
        
        var sc = $ZC.scale.constructor(chartObj, "left");
        var yscale = sc[yindex].scale;
        var yRange = (yaxis_data.reversed && !dataObj.isstacked()) ? [0, radius] : [radius, 0];
        yscale.range(yRange)
        
        var plotarea_approx = {
            "left": chartObj.plotarea.left,
            "top": chartObj.plotarea.top,
            "width": radius,
            "height": radius
        };
        var axes = getAxisObject(chartObj, type, 0);
        var ticksObj = $ZC.axis.ticks(chartObj, yaxis_data, "y", 0, orient, plotarea_approx);
        axes.ticks = ticksObj;
        ticksObj.preCalcApproxAxisLength(plotarea_approx);

        // test
        var tickVal = ticksObj.getTickValues(radius, radius, null, null, (radius / 20), axes.Ticks);
        
        var metaData = chartObj.userdata.metadata;
        var isMergedAxis = (metaData.axes.y[yindex].length > 1); //For merged axis, need not to apply formatting
        var columnidx = chartObj.dataset.getColumnIdx(type, yindex);
        var datatype = metaData.columns[columnidx].datatype;
        var formatConf = (isMergedAxis && type == "y") ? merged_axis_column_intersect(yindex, chartObj) : metaData.columns[columnidx][datatype];
        var formattingFunction = (dataObj.isStackedPercentChart && type == "y") ? getFormattedValueByPercent : getFormattedValue;
        
        var axis = $ZC.axis.get()
            .scale(yscale)
            .tickPadding(tickPadding)
            .tickSize(tickSize, 0)
            .orient((orient))
            .plotarea({
                width: radius,
                height: radius
            })
            .systemconf(chartObj.systemConf)
            .chartObj(chartObj)
            .tickRotation(tickVal.rotation)
            .preCalcTickLen(ticksObj.preCalcTickLen)
            .tickValues(tickVal.ticks)
            .tickFormat(function(d) {
                return formattingFunction(formatConf, d, datatype, chartObj, "axis");
            })
            .columnIndices((isMergedAxis && type == "y") ? metaData.axes.y[index] : [columnidx]);
        var yWrap = chartObj.svg.selectAll("g.y-axis").data(yaxis_data.show ? [yaxis_data] : []);
        yWrap
            .call(axis, type, yindex)
            .attr("transform", "translate(" + (x + chartObj.plotarea.left) + "," + (y + chartObj.plotarea.top - radius) + ")");
        yWrap.exit().remove();
        
        var ticks = yWrap.selectAll('.tick');
        ticks.append("path");
        var gridLine = ticks.select("path");
        
        gridLine
            .attr("transform", function(d) {
                return "translate(0" + "," + (radius - yscale(d)) + ")";
            })
            .attr("d", function(d) {
                return grid((radius - yscale(d)), scale);
            })
            .style({
                "fill": "none",
                "stroke": yaxis_data.grid.color,
                "stroke-width": yaxis_data.grid.strokeWidth
            });
        
        wrap.selectAll("path.domain")
            .attr("d", function() {
                return grid(radius, scale);
            });
        
        yscale.range(yRange.reverse());
    }
    
    
    function getMinRadius(rad) {
        var a = [],
            subtickRad = rad + (((orient == "outer") ? axislineSize : axislineSize / 2) + subtickmarkSize * ((tickOrient == "inner") ? -1 : 1)),
            func = (tickOrient == "inner") ? d3_min : d3_max;
        wrap.selectAll("text")
            .each(function(d) {
                var bb = bbox(this),
                    textRad = rad + (((orient == "outer") ? axislineSize : axislineSize / 2) + tickmarkSize + ticklabelPad) * ((tickOrient == "inner") ? -1 : 1);
                var xy = polarToXY(textRad, scale(d));
                var arr = [getRad((xy[0] + bb.x), (xy[1] + bb.y)), getRad((xy[0] + bb.x), (xy[1] + bb.y + bb.height)), getRad((xy[0] + bb.x + bb.width), (xy[1] + bb.y)), getRad((xy[0] + bb.x + bb.width), (xy[1] + bb.y + bb.height)), subtickRad]
                a.push(func(arr));
            });
        return func(a);
    }
    
    function getRad(x, y) {
        return mathSQRT(mathPow(x, 2) + mathPow(y, 2));
    }
    
    function grid(r, scale) {
        if (isArcGrid) {
            var path = d3_arc()
                .innerRadius(r - 1)
                .outerRadius(r)
                .startAngle(range[0])
                .endAngle(range[1])(1);
            return "M" + path.split(/L|M/gi)[1];
        }
        var tickValues = scale.ticks ? scale.ticks() : scale.domain();
        var path = tickValues.reduce(function(prev, cur, i) {
            var a = scale(cur);
            var xy = polarToXY(r, a);
            return prev + "L" + xy[0] + " " + xy[1] + " ";
        }, "");
        return "M" + path.substring(1) + "Z";
    }
    
    function drawMinMaxLabel(container, scale, radius, innerRadius) {
        var mmConf = commonPlotOptions.minmaxlabels;
        var align = mmConf.align, //inner,outer options are available; enable for center
            padding = validateNullVal(mmConf.padding, 5),
            text = mmConf.text;
        var domain = scale.domain(),
            showAs = mmConf.showAs,
            r = (align == "inner") ? (innerRadius - padding) : (align == "center") ? (radius + innerRadius) / 2 : (radius + padding);
        var minmaxLabelData = mmConf.show ?
            ((showAs == "min") ?
                [domain[0]] :
                (showAs == "max") ?
                    [domain[1]] :
                    domain) :
            [];
        
        var minmaxLabel = appendEle(container, "text", minmaxLabelData, ".", "class", "mlabel");
        applyFont(minmaxLabel, [mmConf, systemconf.chart, systemconf.canvas, $ZCG]);
        minmaxLabel
            .attr({
                "text-anchor": function(d) {
                    if (align == "center") {
                        return "middle";
                    }
                    var a = d0_360(scale(d));
                    return (a % mathPI == 0) ?
                        "middle" :
                        (((align == "inner" && a < mathPI) || (align != "inner" && a > mathPI)) ? "end" : null);
                },
                "dy": function(d) {
                    if (align == "center") {
                        return "1em";
                    }
                    var a = d0_360(scale(d));
                    return (align == "inner") ?
                        ((!((a > mathPI / 2) && (a < 3 * mathPI / 2))) ? -getDY(a) + "em" : null) :
                        (((a > mathPI / 2) && (a < 3 * mathPI / 2)) ? getDY(a) + "em" : null);
                },
                "transform": function(d) {
                    var xy = polarToXY(r, scale(d)),
                        pad = (align == "center") ? padding : 0;
                    return "translate(" + xy[0] + "," + (xy[1] + pad) + ")";
                }
            })
            .text(function(d, i) {
                return (text && defined(text[i])) ?
                    getCustomThresholdText((text[i] + ""), minmaxLabelData, colInfo, chartObj) :
                    getFormattedValue(formatConf, d, datatype, chartObj, "minmaxlabels");
            });
        
        // var edge = {
        // 	"left" : -w / 2,
        // 	"top" : -h / 2,
        // 	"right" : w / 2,
        // 	"bottom" : h / 2
        // }
        // callTrimText(minmaxLabel, chartObj, [0,0], 0, edge);
    }
};//$Id$
$ZC.plot.render = function(chartObj) {
    var mode = chartObj.systemConf.chart.plot.renderer.mode.toLowerCase();
    var chartType = chartObj.chartTypes[0];
    var render = {
            "mode": (!chartObj.isAxisCategory || chartObj.dataObject.pieWithAxis || chartType.value === 24 || isHeatMapChartType(chartType.value)) ? "svg" : mode.toLocaleLowerCase()
        },
        args = {};
    
    args.labelQueue = [];
    args.notesArray = [];
    args.labelArray = [];
    
    if (!chartObj.rendererConf) {
        chartObj.rendererConf = [];
    }
    
    if (typeof $ZC.plot[render.mode + "Renderer"] === "function") {
        render[render.mode] = $ZC.plot[render.mode + "Renderer"](chartObj, args);
    } else {
        throw new SyntaxError("" + render.mode + "Renderer not found");
    }
    
    render.draw = function(update) {
        chartObj.chartRendered = false;
        this[this.mode].draw(update);
    };
    return render;
};

renderer_helpers.renderCompletedEvents = function(chartObj, update, args) {
    var systemconf = chartObj.systemConf,
        isDialChart = (chartObj.dataObject.hasLevelMarker && !chartObj.isAxisCategory),
        DoWaitForChartRendered = ((chartObj.isAxisCategory || chartObj.dataObject.isPolarAxisCategory) && !chartObj.dataObject.pieWithAxis) || isDialChart,
        renderer = chartObj.renderer,
        k,
        axesRendered = false;
    // var labelHolder = chartObj.staticPaneSVG.select(".labelholder").style("opacity", 0);

    if (chartObj.isAxisCategory || chartObj.dataObject.isPolarAxisCategory) {
        setTimeout(function() {
            axesRendered = true;
        }, chartObj.axes.animationDuration + 17);
    } else {
        axesRendered = true;
    }
    
    var checkRendered = function() {
        if (isHiddenDocument()) {
            chartObj.chartRendered = true;
        }

        if(chartObj.destroying) {
            return true;
        }

        k = renderer.length;
        while (k--) {
            if (renderer[k].chartRendered !== true || !axesRendered) {
                return false;
            }
            args.notesArray = renderer[k].commonRendererProp().notes();
        }
        proceed();
        chartObj.chartRendered = true;
        clearInterval(timer);
        return true;
    };
    
    function proceed() {
        // labelHolder.transition().duration(250).style("opacity", 1);
        stateChangeListener(chartObj, systemconf.chart.plot.events, "plot", (update) ? "onreload" : "onload");
        callDatalableAndAnnotationRenderer(chartObj, args, !(DoWaitForChartRendered && update));
        chartObj.handleHiddenContainer(true);
        stateChangeListener(chartObj, systemconf.canvas.events, "chart", (update) ? "onreload" : "onload");
    }
    
    var timer = setInterval(checkRendered, (1000 / 60));
    
    if (DoWaitForChartRendered) {
        callDatalableAndAnnotationRenderer(chartObj, args, (isDialChart || update));
    }
};

function callDatalableAndAnnotationRenderer(chartObj, args, enable) {
    /*
     * It will call datalabels renderer and annotation renderer
     */
    if (enable) {
        if ($ZC.labelRenderer) {
            $ZC.labelRenderer.drawLabelsFromQueue(args.labelQueue, args.labelArray, chartObj);
        }
        args.labelArray = [];
        args.labelQueue = [];
        args.notesArray = $ZC.annotation ? $ZC.annotation.draw(chartObj, args.notesArray) : [];
    }
}

renderer_helpers.arrangeSeriesRenderingOrder = function(chartObj) {
    var seriesdata = chartObj.seriesdata,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;

    if (chartObj.dataObject.isCombinationalChart) {
        var order = {
                defaultType: 0,
                area: 0,
                bar: 1,
                line: 2,
                bubble: 3,
                bubblepie: 4,
                scatter: 5
            },
            globalChartType = chartObj.userdata.seriesdata.type;
        
        var seriesdata_cpy = simpleClone(seriesdata);
        seriesdata_cpy.map(function(d, i) {
            d.seriesidx = i;
            return d
        });
        seriesdata_cpy.sort(function(a, b) {
            var type1 = dataProcessorHelpers.getChartType((a.type || globalChartType), "string"),
                type2 = dataProcessorHelpers.getChartType((b.type || globalChartType), "string");
            var order1 = (order[type1] == null) ? order.defaultType : order[type1],
                order2 = (order[type2] == null) ? order.defaultType : order[type2],
                seriesidx1 = a.seriesidx,
                seriesidx2 = b.seriesidx;
            return order1 < order2 ? -1 : order1 > order2 ? 1 //Arrange by chart type
                    : (seriesidx1 < seriesidx2 ? -1 : seriesidx1 > seriesidx2 ? 1 : 0); //Arrange by series index
        });
        return seriesdata_cpy;
    }
    return seriesdata;
};


renderer_helpers.setRendererProp = function(chartObj, renderer, seriesdata, index, args) {
    var chartType = chartObj.chartTypes[index];
    var cType = chartType.name;
    var cTypeNumeric = chartType.value;
    var systemconf = chartObj.systemConf,
        helpers = $ZC.DataProcessor.helpers;
    
    setCommonRendererProp(renderer, seriesdata, index, cType, cTypeNumeric);
    renderer.commonRendererProp(chartObj.rendererConf[index])
    var yaxiscolumnorder = chartObj.seriesdata[index].yaxiscolumnorder;
    var yscindex = helpers.getParsedYAxisOrder(yaxiscolumnorder);
    
    renderer.chartRendered = false;
    
    if (chartObj.xymultiRenderer || chartObj.dataObject.isPolarAxisCategory) {
        var yaxis = chartObj.axes.y.groups[yscindex];
        var ysc = yaxis.scale;
        
        chartObj.rendererConf[index]
            .xscale(chartObj.axes.x.scale)
            .yscale(ysc)
            .datasetIndex(index);
        
        args.labelArray = chartObj.rendererConf[index].params.labelArray;
        args.labelQueue = chartObj.rendererConf[index].params.labelQueue;
    }
    if (isBarChartType(cTypeNumeric) && !isHeatMapChartType(cTypeNumeric)) {
        renderer
            .bandwidth1(chartObj.barscale1)
            .bandwidth2(chartObj.barscale2)
        if (!args.image) {
            renderer.barDatasetIndex(args.barDatasetIndex);
        }
        if (seriesdata.disabled == null || !seriesdata.disabled) {
            args.barDatasetIndex = args.barDatasetIndex + chartObj.seriesdata[index].data.length;
        }
    }
    
    function setCommonRendererProp(renderer, seriesdata, index, cType, actualCType) {
        var seriesClr = chartObj.seriesdata[index].color || chartObj.seriesColor[index % chartObj.seriesColor.length];
        var yaxiscolumnorder = chartObj.seriesdata[index].yaxiscolumnorder;
        var yscindex = helpers.getParsedYAxisOrder(yaxiscolumnorder);
        var commonProp = chartObj.rendererConf[index];
        commonProp
            .chartObj(chartObj)
            .dataset(chartObj.dataset)
            .axisrotated(chartObj.dataObject.getAxisRotated())
            .yaxiscolumnorder(yscindex)
            .hasNegValue(chartObj.dataObject.containsNegativeData(yscindex))
            .stacked(chartObj.dataObject.isstacked(actualCType))
            .commonPlotOptions(chartObj.systemConf.chart.plot.plotoptions[cType])
            .color((cType == "bubblepie") ? chartObj.seriesColor : (chartObj.isAxisCategory) ? checkNgetColorOverlayData(renderer, seriesdata, seriesClr, index, yscindex, cType) : (chartObj.dataObject.isPolarAxisCategory) ? seriesClr : chartObj.seriesColor)
            .notes(args.notesArray)
            .updateLabelArrayAndLabelQueue(args.labelArray, args.labelQueue);
    }

    function checkNgetColorOverlayData(renderer, seriesdata, seriesClr, index, yscindex, cType) {
        var thOverlay_data_x = systemconf.chart.axes.xaxis.threshold.coloroverlay;
        var thOverlay_data_y = (systemconf.chart.axes.yaxis[yscindex] != null && systemconf.chart.axes.yaxis[yscindex].threshold != null) ? systemconf.chart.axes.yaxis[yscindex].threshold.coloroverlay : null;
        var showColorOverlay = (thOverlay_data_x.show) || (thOverlay_data_y != null && thOverlay_data_y.show);
        if (!showColorOverlay) {
            return seriesClr
        } else {
            var overlayData = ((thOverlay_data_y != null && thOverlay_data_y.show) ? thOverlay_data_y : thOverlay_data_x.show ? thOverlay_data_x : null);
            var negThreshType = ((thOverlay_data_y != null && thOverlay_data_y.show) ? "y" : thOverlay_data_x.show ? "x" : null);
            var colorOverlay = (showColorOverlay) ? $ZC.axis.threshold.overlay(chartObj, "continous") : null,
                axisOrder = (negThreshType === "y") ? yscindex : 0;

            chartObj.rendererConf[index]
                .threshold(showColorOverlay ? overlayData : null)
                .thresholdType(negThreshType)
                .colorOverlay(showColorOverlay ? $ZC.axis.threshold.overlay(chartObj, "discrete", overlayData) : null);

            return (cType == "bar" || cType == "scatter" || cType == "bubble") ? seriesClr : colorOverlay(seriesClr, overlayData, axisOrder, negThreshType)
        }
        
    }
};

function getBarCommonOption(conf, index) {
    var rp = conf.params,
        stacked = rp.stacked,
        chartObj = rp.chartObj,
        yscale = rp.yscale,
        dataProcessorHelpers = $ZC.DataProcessor.helpers,
        barDataSetIndex = chartObj.renderer[index].barDatasetIndex ? chartObj.renderer[index].barDatasetIndex() : 0,
        commonPlotOptions = rp.commonPlotOptions,
        charttype = dataProcessorHelpers.getChartType((chartObj.seriesdata[index].type || chartObj.userdata.seriesdata.type), "string"),
        isBullet = (charttype == "bullet"),
        groupedByStack = chartObj.dataObject.groupedByStack,
        levelMarkerOptions = commonPlotOptions.levelMarker || {};
    
    
    var wid = chartObj.barscale2.rangeBand() || 0,
        levelMarkerWidth = wid,
        barWidth = +(commonPlotOptions.bandWidth || null) || (isBullet ? (wid / 3) : wid);
    
    
    var levelMarkerBandWidth = +(levelMarkerOptions.bandWidth || wid),
        levelMarkerMaxBandWidth = +(levelMarkerOptions.maxBandWidth || wid),
        maxBandWidth = +(commonPlotOptions.maxBandWidth || wid); //setting bandwidth if the actual bandwidth is greater than the maximum bar bandwidth
    
    levelMarkerWidth = mathMin(levelMarkerBandWidth, levelMarkerMaxBandWidth, wid);
    barWidth = mathMin(barWidth, maxBandWidth, wid);
    
    var barPadding = mathMax(0, (wid - barWidth) / 2),
        levelMarkerPadding = mathMax(0, (wid - levelMarkerWidth) / 2);
    
    
    var addRangeBand = function() {
        return yscale.rangeBand ? (yscale.rangeBand() / 2) : 0;
    };
    
    var commonOption = {
        "stacked": stacked,
        "categories": rp.xscale.domain(),
        "axisrotated": rp.axisrotated,
        "bandwidth1": chartObj.barscale1,
        "bandwidth2": chartObj.barscale2,
        "barDatasetIndex": barDataSetIndex,
        "padding": barPadding,
        "yscale": yscale,
        "hasNegValue": rp.hasNegValue,
        "yaxiscolumnorder": rp.yaxiscolumnorder,
        "addRangeBand": addRangeBand,
        "barWidth": barWidth,
        "levelMarkerWidth": levelMarkerWidth,
        "levelMarkerPadding": levelMarkerPadding,
        "stackGroupIndex": (chartObj.userdata.seriesdata.stackGroup) ?
            getStackGroupIndex(index, groupedByStack.keys(), function(d) {
                var value = groupedByStack.get(d);
                return value.map(function(d) {
                    return d.si;
                });
            }) :
            0
    };
    chartObj.renderer[index].commonOption = commonOption;
    return commonOption;
}

function getStackGroupIndex(index, array, accessor) {
    return d3_max(array, function(d, j) {
        var value = (accessor) ? accessor(d, j) : d;
        return (value.indexOf(index) != -1) ? j : -1;
    });
}//$Id$
$ZC.plot.rendererConf = function() {
    var renderer = {};
    renderer.params = {};
    
    renderer.xscale = function(_) {
        if (!arguments.length) {
            return renderer.params.xscale;
        }
        renderer.params.xscale = _;
        return renderer;
    };
    
    renderer.yscale = function(_) {
        if (!arguments.length) {
            return renderer.params.yscale;
        }
        renderer.params.yscale = _;
        return renderer;
    };
    
    renderer.stacked = function(_) {
        if (!arguments.length) return renderer.params.stacked;
        renderer.params.stacked = _;
        return renderer;
    };
    
    renderer.datasetIndex = function(_) {
        if (!arguments.length) {
            return renderer.params.datasetIndex;
        }
        renderer.params.datasetIndex = _;
        return renderer;
    };
    
    renderer.axisrotated = function(_) {
        if (!arguments.length) {
            return renderer.params.axisrotated;
        }
        renderer.params.axisrotated = _;
        return renderer;
    };
    
    renderer.commonPlotOptions = function(_) {
        if (!arguments.length) {
            return renderer.params.commonPlotOptions;
        }
        renderer.params.commonPlotOptions = _;
        return renderer;
    };
    
    renderer.color = function(_) {
        if (!arguments.length) {
            return renderer.params.color;
        }
        renderer.params.color = _;
        return renderer;
    };
    
    renderer.chartObj = function(_) {
        if (!arguments.length) {
            return renderer.params.chartObj;
        }
        renderer.params.chartObj = _;
        return renderer;
    };
    
    renderer.notes = function(_) {
        if (!arguments.length) {
            return renderer.params.notesArray;
        }
        renderer.params.notesArray = _;
        return renderer;
    };
    
    renderer.updateLabelArrayAndLabelQueue = function(la, lq) {
        if (!arguments.length) {
            return [renderer.params.labelArray, renderer.params.labelQueue];
        }
        renderer.params.labelArray = la;
        renderer.params.labelQueue = lq;
        return renderer;
    };
    
    renderer.hasNegValue = function(_) {
        if (!arguments.length) {
            return renderer.params.hasNegValue;
        }
        renderer.params.hasNegValue = _;
        return renderer;
    };
    
    renderer.dataset = function(_) {
        if (!arguments.length) {
            return renderer.params.dataset;
        }
        renderer.params.dataset = _;
        return renderer;
    };
    
    renderer.yaxiscolumnorder = function(_) {
        if (!arguments.length) {
            return renderer.params.yaxiscolumnorder;
        }
        renderer.params.yaxiscolumnorder = _;
        return renderer;
    };

    renderer.threshold = function(_) {
        if (!arguments.length) {
            return renderer.params.threshold;
        }
        renderer.params.threshold = _;
        return renderer;
    };

    renderer.thresholdType = function(_) {
        if (!arguments.length) {
            return renderer.params.thresholdType;
        }
        renderer.params.thresholdType = _;
        return renderer;
    };

    renderer.colorOverlay = function(_) {
        if (!arguments.length) {
            return renderer.params.colorOverlay;
        }
        renderer.params.colorOverlay = _;
        return renderer;
    };
    
    return renderer;
};/**
 *
 * @param chartObj
 * @param args
 * @returns {{}}
 */
$ZC.plot.svgRenderer = function(chartObj, args) {
    var svgRenderer = {};
    var systemconf = chartObj.systemConf,
        helpers = $ZC.DataProcessor.helpers;

    svgRenderer.draw = function(update) {
        
        if (chartObj.dataset.getDataType("x") == ORDINAL_DATATYPE && chartObj.isAxisCategory) {
            $ZC.scale.barBandwidth(chartObj);
        }
        args.barDatasetIndex = 0;
        
        var type, isRendererCalled = [];
        chartObj.chartRendered = false;
        var isComboChart = chartObj.dataObject.isCombinationalChart;
        var orderedSeriesdata = (isComboChart) ? renderer_helpers.arrangeSeriesRenderingOrder(chartObj) : chartObj.seriesdata
        var bubblePieRendererIndex;
        
        chartObj.seriesdata.forEach(function(d, i) {
            var currOrdereddata = orderedSeriesdata[i]
            var curSeriesidx = (isComboChart) ? currOrdereddata.seriesidx : i;
            
            if ((curSeriesidx > 0) && !chartObj.xymultiRenderer && !chartObj.dataObject.isPolarAxisCategory) {
                return;
            }
            
            type = helpers.getChartType((currOrdereddata.type || chartObj.userdata.seriesdata.type), NUMERIC_DATATYPE);
            if (type == $ZC.charttype.bubblepie) { //Only one bubblepie renderer will be called eventhough it has so many series. Share that renderer to all the bubblepie series
                if (bubblePieRendererIndex != null) {
                    chartObj.renderer[curSeriesidx] = chartObj.renderer[bubblePieRendererIndex];
                    chartObj.rendererConf[curSeriesidx] = new $ZC.plot.rendererConf();
                    renderer_helpers.setRendererProp(chartObj, chartObj.renderer[curSeriesidx], currOrdereddata, curSeriesidx, args);
                    return;
                } else {
                    chartObj.bubblePieRendererIndex = bubblePieRendererIndex = curSeriesidx;
                }
            }
            
            var animated = [],
                chartName = $ZC.charttypenames.get(type),
                plotoptions = currOrdereddata.plotoptions,
                commonPlotOptions = systemconf.chart.plot.plotoptions[chartName];
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, chartName);
            var isAnimationEnable = animationOptions.enabled,
                animationType = animationOptions.type;
            
            if (chartObj.renderer[curSeriesidx] == null) {
                chartObj.renderer[curSeriesidx] = createSVGRenderer(chartName)
                chartObj.rendererConf[curSeriesidx] = new $ZC.plot.rendererConf();
            }
            chartObj.renderer[curSeriesidx].chartRendered = false;
            
            if (i == 0) {
                stateChangeListener(chartObj, systemconf.chart.plot.events, "plot", "init");
                chartObj.hideLoading(chartObj.container);
            }
            if (isAnimationEnable && !/(allseries|pointTween|vertPathTweenAll|fadeAll|verticalAll|sizing)/.test(animationType) && (type == $ZC.charttype.scatter || type == $ZC.charttype.area || type == $ZC.charttype.arearange || type == $ZC.charttype.bubble) && !update) {
                isRendererCalled[curSeriesidx] = false;
                animated[curSeriesidx] = setInterval(function() {
                    if (chartObj.renderer[curSeriesidx].chartRendered) {
                        clearInterval(animated[curSeriesidx]);
                    }
                    //isRendererCalled - every renderer should be called only once not at every 10 seconds. All the renderers except first one should wait until previous renderer is rendered
                    if (!isRendererCalled[curSeriesidx] && ((curSeriesidx == 0) || (curSeriesidx > 0 && chartObj.renderer[curSeriesidx - 1].chartRendered))) {
                        renderer_helpers.setRendererProp(chartObj, chartObj.renderer[curSeriesidx], currOrdereddata, curSeriesidx, args);
                        drawSVG(chartObj, currOrdereddata, chartObj.renderer[curSeriesidx]);
                        isRendererCalled[curSeriesidx] = true;
                    }
                }, 10);
            } else {
                renderer_helpers.setRendererProp(chartObj, chartObj.renderer[curSeriesidx], currOrdereddata, curSeriesidx, args);
                drawSVG(chartObj, currOrdereddata, chartObj.renderer[curSeriesidx]);
            }
        });
        renderer_helpers.renderCompletedEvents(chartObj, update, args);
    };
    return svgRenderer;
};

var createSVGRenderer = function(chartName) {
    switch (chartName) {
        case "gantt":
        case "bullet": {
            chartName = "bar";
            break;
        }
        case "web":
        case "arearange": {
            chartName = "area";
            break;
        }
        case "bubble":{
            chartName = "scatter";
            break;
        }
    }
    return new svg_plot_renderer[chartName]();
};

var drawSVG = function(chartObj, renderdata, renderercollection, update) {
    if (update) {
        renderercollection.update();
    } else {
        clearTimeout(renderercollection.renderedTimer);
        var wrap = chartObj.svg.selectAll('g.xychart').data([chartObj.systemConf])
        transformWrap(wrap, "seriesholder", {
            x: chartObj.plotarea.left,
            y: chartObj.plotarea.top
        })
            .datum(chartObj.seriesdata)
            .call(renderercollection)
        
        if (chartObj.dataObject.isPolarAxisCategory) {
            wrap.selectAll("g.seriesholder").selectAll(function() {
                    return this.childNodes;
                })
                .attr("transform", "translate(" + chartObj.plotarea_approx.x + "," + chartObj.plotarea_approx.y + ")");
        }
        
        transformWrap(chartObj.staticPaneSVG, "labelholder", {
            x: chartObj.plotarea.left,
            y: chartObj.plotarea.top
        })
    }
    
    function transformWrap(wrap, selection, translate) {
        return (wrap.select('g.' + selection)
            .attr('transform', 'translate(' + (translate.x) + ',' + (translate.y) + ')')) //No I18N
    }
};//$Id$
$ZC.plot.imageRenderer = function(chartObj, args) {
    var imageRenderer = {};
    
    function renderImage() {
        
        chartObj.chartRendered = false;
        
        // place the seriesholder
        
        var wrap = chartObj.svg.selectAll('g.xychart');
        transformWrap(wrap, "seriesholder", {
            x: chartObj.plotarea.left,
            y: chartObj.plotarea.top
        });
        
        transformWrap(wrap, "labelholder", {
            x: chartObj.plotarea.left,
            y: chartObj.plotarea.top
        });
        
        function transformWrap(wrap, selection, translate) {
            return (wrap.select('g.' + selection)
                .attr('transform', 'translate(' + (translate.x) + ',' + (translate.y) + ')')) //No I18N
        }
        
        var seriesholder = chartObj.svg.select(".seriesholder");
        
        /*
         * Hide all the threshold
         */
        
        chartObj.svg.selectAll(".threshold").style({
            // "visibility": "hidden",
            "opacity": 0
        });
        
        /*
         * If image source is available use that and generate the plot 
         */
        
        var imageSource = chartObj.systemConf.chart.plot.renderer.image.source;
        if (imageSource != "auto") {
            seriesholder.selectAll("*:not(.zmarea)").remove(); // remove all except zoom are
            createImageObj(imageSource);
            return;
        }
        
        seriesholder.selectAll("*:not(.zmarea)").remove(); // remove all except zoom area
        chartObj.showLoading(chartObj.container);
        
        var actualCType = chartObj.seriesdata[0].type || chartObj.userdata.seriesdata.type;
        var cType = getChartType(actualCType, "string");
        var sysConf = chartObj.systemConf;
        var dataLebelFontSize = sysConf.chart.plot.plotoptions[cType].datalabels.fontSize;
        dataLebelFontSize = (typeof dataLebelFontSize === 'function') ? dataLebelFontSize() : dataLebelFontSize;
        sysConf.chart.plot.plotoptions[cType].datalabels.fontSize = dataLebelFontSize;
        
        var imagedata = JSON.parse(JSON.stringify(sysConf));
        imagedata.chart.plot.renderer.mode = "svg";
        
        
        /**
         * check the datalabels color
         */
        
        if (!isObjectPropDefined(chartObj.userdata, "chart.plot.datalabels.fontColor")) {
            delete imagedata.chart.plot.datalabels.fontColor
        }
        
        if (!isObjectPropDefined(chartObj.userdata, "chart.plot.plotoptions." + cType + ".datalabels.fontColor")) {
            delete imagedata.chart.plot.plotoptions[cType].datalabels.fontColor
        }
        
        // request aarthi
        
        var chartData = {
            "url": chartObj.systemConf.chart.plot.renderer.image.exportUrl,
            "type": "POST",
            "data": {
                "DATA": encodeURIComponent(JSON.stringify(imagedata)),
                "HEIGHT": mathRound(chartObj.plotarea.height),
                "WIDTH": mathRound(chartObj.plotarea.width)
            }
        };
        
        if (chartObj.xhr) {
            chartObj.xhr.abort();
        }
        
        var data = urlize(chartData.data);
        var xhr = d3_xhr(chartData.url)
            .header("Content-type", "application/x-www-form-urlencoded")
            .post(data, function(error, text) {
                seriesholder.selectAll("image").remove();
                var response = JSON.parse(text.responseText);
                if (response.rendered) {
                    chartObj.hideLoading(chartObj.container);
                    createImageObj(response.serverPath);
                }
                delete chartObj.xhr;
            });
        chartObj.xhr = xhr;
        
        function urlize(data) {
            var temp = "";
            var keys = Object.keys(data);
            var i = 0;
            
            for (var key in data) {
                temp += key + "=" + data[key];
                if (data.hasOwnProperty(keys[i + 1])) {
                    temp += "&";
                }
                i++;
            }
            return temp;
        }
        
        function createImageObj(url) {
            if (chartObj.systemConf.chart.plot.renderer.image.addDimensionInSource === true) {
                var symble = (url.indexOf("?") > -1) ? "&" : "?";
                url += symble + "WIDTH=" + chartObj.plotarea.width + "&HEIGHT=" + chartObj.plotarea.height;
            }
            
            var transitionDuration = 300;
            
            var img = seriesholder.append("svg:image")
                .attr("xlink:href", url)
                .attr("width", mathRound(chartObj.plotarea.width))
                .attr("height", mathRound(chartObj.plotarea.height))
                .attr("x", 0)
                .attr("y", 0)
                .style("opacity", 0)
                .attr("onload", function() {
                    chartObj.hideLoading(chartObj.container);
                    chartObj.svg.selectAll(".threshold").transition().style("opacity", "1").duration(transitionDuration);
                })
                .on("error", function() {
                    chartObj.chartRendered = false;
                    chartObj.hideLoading(chartObj.container);
                    throw new ReferenceError("Invalid image source.");
                })
                .transition()
                .style("opacity", "1")
                .duration(transitionDuration)
                .each("end", function() {
                    chartObj.chartRendered = true;
                })
        }
    }
    
    imageRenderer.draw = function(update) {
        
        chartObj.systemConf.legend.highlightEffect.selectedSeries = "none";
        chartObj.systemConf.loader.enabled = true;
        
        if (chartObj.dataset.getDataType("x") == ORDINAL_DATATYPE && chartObj.isAxisCategory) {
            $ZC.scale.barBandwidth(chartObj);
        }
        
        args.barDatasetIndex = 0;
        var type;
        chartObj.chartRendered = false;
        var isComboChart = chartObj.dataObject.isCombinationalChart;
        var orderedSeriesdata = (isComboChart) ? renderer_helpers.arrangeSeriesRenderingOrder(chartObj, chartObj.seriesdata) : chartObj.seriesdata
        
        // draw the image;
        renderImage();
        chartObj.seriesdata.forEach(function(d, i) {
            var currOrdereddata = orderedSeriesdata[i];
            var curSeriesidx = (isComboChart) ? currOrdereddata.seriesidx : i;
            
            if (!chartObj.isAxisCategory && (curSeriesidx > 0)) {
                return;
            }
            
            var chartType = getChartType(null, "object", curSeriesidx, chartObj.userdata),
                cType = chartType.name;
            
            if (chartObj.renderer[curSeriesidx] == null) {
                type = getChartType((currOrdereddata.type || chartObj.userdata.seriesdata.type), NUMERIC_DATATYPE);
                chartObj.renderer[curSeriesidx] = createSVGRenderer(cType);
                chartObj.rendererConf[curSeriesidx] = new $ZC.plot.rendererConf();
            } else {
                chartObj.renderer[curSeriesidx].commonOption = null;
            }
            renderer_helpers.setRendererProp(chartObj, chartObj.renderer[curSeriesidx], currOrdereddata, curSeriesidx, args);
            chartObj.renderer[curSeriesidx].chartRendered = false;
            if (i == 0) {
                stateChangeListener(chartObj, chartObj.systemConf.chart.plot.events, "plot", "init"); //No I18N
            }
        });
        renderer_helpers.renderCompletedEvents(chartObj, update, args);
    };
    return imageRenderer;
};//$Id$
$ZC.legutil = function() {};
$ZC.legutil.colorpallete = d3_map();

$ZC.legutil.colorpallete.set("greenish", ["#6c6c6d", "#1ba98e", "#00ff80", "#00ffc0", "#00ffff", "#40ff00", "#40ff40", "#40ff80", "#40ffc0", "#40ffff", "#80ff00", "#80ff40", "#80ff80", "#80ffc0", "#80ffff"])
$ZC.legutil.colorpallete.set("pinkish", ["#ff00ff", "#ff00c0", "#ff0080", "#ff0040", "#ff0000", "#c000ff", "#c000c0", "#c00080", "#c00040", "#c00000", "#8000ff", "#8000c0", "#800080", "#800040", "#800000"])
$ZC.legutil.colorpallete.set("countries", ["#00c6e4", "#faa43a", "#5da5da", "#60bd68", "#f17cb0", "#b2912f", "#307d99"])
$ZC.legutil.colorpallete.set("saturate5", ["#594f4f", "#547980", "#45ada8", "#97843a", "#518058", "#975156"])
$ZC.legutil.colorpallete.set("ocean5", ["#ff7f00", "#6a4a3c", "#cc333f", "#eb6841", "#edc951", "#975156"])
$ZC.legutil.colorpallete.set("zoho-reports-old", ["#FF465B", "#04C36B", "#3A92E9", "#FDC33A", "#D65587", "#FC7C63", "#51A5A9", "#BFBFBF", "#91CD6A", "#BE9B89", "#7D8DB0", "#B68E2E", "#C6D5B0", "#D1ACCE", "#E0AE60", "#5CD29F", "#716398", "#AD8686", "#FF99A8", "#A0C0C0", "#2D7094", "#553D4E", "#B2449D", "#FED577", "#D3D159", "#AAAAAA", "#7ED9D9", "#F7A26D", "#8ABFA2", "#767676", "#E36068", "#A3AFC7"])
$ZC.legutil.colorpallete.set("zoho-reports-new", ["#60bfdf", "#ffa060", "#aadf80", "#ff6c7d", "#c9ac66", "#bf80bf", "#df6060", "#606060", "#60a0df", "#ff99a8", "#feff60", "#a0dfdf", "#dfa080", "#dfdfdf", "#a0a060", "#a080bf", "#a06060", "#5cd29f", "#ffbe60", "#bfa080", "#f28fb5", "#8080bf", "#bfbfbf", "#dfdf80", "#80a060", "#80a060", "#a08060", "#7ed9d9", "#be9b89", "#bf6060", "#a0bf60", "#fc7c63"])
$ZC.legutil.colorpallete.set("colors", ["#0eaadd", "#1ac9bb", "#92c658", "#dbbe56", "#ee7d54", "#ef4f6a", "#b952ef"])
$ZC.legutil.colorpallete.set("flat-ui-colors", ["#23a96e", "#bca634", "#f75a51", "#39b6c5", "#f9ce8d", "#983a67", "#634c3f", "#d7dab9", "#357180", "#983a67", "#b16b76", "#7f90a0"]);
$ZC.legutil.colorpallete.set("MEMobile", ["#73c2f4", "#ecd543", "#e6be3f", "#da7b36", "#c84b37", "#9c240f", "#9bcedd", "#ffe560", "#ffe560", "#c67c99", "#c6db4c"]);
$ZC.legutil.colorpallete.set("Toddler", ["#f8d0db", "#9be1ed", "#c4ead1", "#fbe2aa", "#e5e5e5", "#d6b65f", "#be9fbf", "#ffe560", "#ffe560", "#c67c99", "#c6db4c"]);
$ZC.legutil.colorpallete.set("BrightNDull", ["#47bac1", "#8ccace", "#72c3f5", "#71bfee", "#ac66ad", "#c5a0c6", "#906aa6", "#b29dbf", "#fd9f94", "#f6cac4", "#ff759c", "#f6acc1"]);
$ZC.legutil.colorpallete.set("BlueShades", ["#00c6e4", "#6ad4e4", "#a3dbe4", "#c3e0e4", "#e4e4e4", "#c8c8c8", "#aac4c8"]);
$ZC.legutil.colorpallete.set("graphite6", ["#595959", "#767676", "#373737", "#9d9d9d", "#bfbfbf", "#222222"]);
$ZC.legutil.colorpallete.set("chalk", ["#FFFFFF", "#FAFAFA", "#CCCCCC"]);
$ZC.legutil.colorpallete.set("map", ["#FB0D0D", "#53B808", "#B80894", "#2ADBDD"]);


$ZC.legutil.patternPallete = d3_map();
$ZC.legutil.imagePallete = d3_map();

$ZC.legutil.imagePallete.set("linesndots", ["01.png", "02.png", "03.png", "04.png", "05.png", "06.png", "07.png", "08.png",
    "09.png", "10.png", "11.png", "12.png", "13.png", "14.png", "15.png", "16.png",
    "17.png", "18.png", "19.png", "20.png"
]);

$ZC.legutil.imagePallete.set("dotsfirst", ["13.png", "12.png", "13.png", "14.png", "15.png", "16.png",
    "17.png", "18.png", "19.png", "20.png"
]);

$ZC.legutil.imagePallete.set("stones", ["01.jpg", "02.jpg", "03.jpg"]);

generateDefaultPatternTheme();
$ZC.legutil.patternPallete.set("stripes-fill",["hatchfill","hatchDashfill","checkerBoard","horizontalStripesfill","verticalStripesfill","crossStripesfill"]);
$ZC.legutil.patternPallete.set("stripes",["hatch","thinThickHatch","hatchLeft","hatchDash","horizontalStripes","crossStripes","verticalStripes","thickHatch","thinHatch","thinVerticalStripes","thinHorizontalStripes"]);
$ZC.legutil.patternPallete.set("dotted",["circle","tinyCircle","crossCircle","floatingCircle","dot"]);
$ZC.legutil.patternPallete.set("dotted-fill",["circlefill","crossCirclefill","floatingCirclefill","dotfill"]);
$ZC.legutil.patternPallete.set("shapes",["thinThickHatch","crossCircle","star","wave","cap","nylon"]);
$ZC.legutil.patternPallete.set("shapes-fill",["checkerBoard","floatingCirclefill","squarefill","starfill","wavefill","capfill","nylonfill"]);

// $ZC.legutil.patternPallete.set("stripes", ["Default00001.png", "Default00002.png", "Default00003.png", "Default00004.png", "Default00005.png", "Default00006.png", "Default00007.png", "Default00008.png",
//     "Default00009.png", "Default00010.png", "Default00011.png", "Default00012.png", "Default00013.png", "Default00014.png", "Default00015.png", "Default00016.png",
//     "Default00017.png", "Default00018.png", "Default00019.png", "Default00020.png", "Default00021.png", "Default00022.png"
// ]);
//append relative pattern filepath
appendFilePath();

$ZC.legutil.getMonochromeColorPallette = function(conf) {
    var domain = [0, (+conf.count) - 1],
        range = [+(conf.colorGamma[0]), +(conf.colorGamma[1])];
    var monoClrGen = getMonochromeColor(conf.baseColor, domain, range);
    return d3_range(conf.count).map(function(d, i) {
        return monoClrGen(i);
    });
};

function getColorPallete(palletename, value) {
    if ($ZC.legutil.colorpallete.has(palletename)) {
        return $ZC.legutil.colorpallete.get(palletename);
    } else {
        $ZC.legutil.colorpallete.set(palletename, value)
    }
}

function getPatternPallete(palletename, value) {
    if ($ZC.legutil.patternPallete.has(palletename)) {
        return $ZC.legutil.patternPallete.get(palletename);
    } else {
        $ZC.legutil.patternPallete.set(palletename, value)
    }
}

function getImagePallete(imagename, value) {
    if ($ZC.legutil.imagePallete.has(imagename)) {
        return $ZC.legutil.imagePallete.get(imagename);
    } else {
        $ZC.legutil.imagePallete.set(imagename, value)
    }
}

function appendFilePath() {
    for (var pallete in $ZC.legutil.imagePallete) {
        $ZC.legutil.imagePallete[pallete] = $ZC.legutil.imagePallete[pallete].map(function(d, i) {
            return $ZC.imageFilePath + d;
        });
    }
}//$Id$
var legend_helpers = {};
legend_helpers.getLegendData = function(chartObj) {

	// Continuous color - ranges
	if (colorscale_helpers.isQuantileColorScale(chartObj)) {
		var userRanges = chartObj.systemConf.legend.colorBand.ranges;
		if (userRanges && userRanges.length) {
			return userRanges;
		}
	}

	if (chartObj.xymultiRenderer || chartObj.isNonAxisMultiSeriesCategory) {
		return chartObj.seriesdata;
	} else {
		return chartObj.seriesdata[0].data[0];
	}
};

legend_helpers.getLegendDataLength = function(chartObj, legData) {
	if (chartObj.xymultiRenderer || chartObj.isNonAxisMultiSeriesCategory) {
		return legData.filter(function(d) {
			return !legend_helpers.isHiddenItem(d);
		}).length;
	} else {
		return legData.length;
	}
};

legend_helpers.isHiddenItem = function(d) {
	return d.hideInLegend;
};

legend_helpers.getClr = function(disabled, defaultClr, itemDisabledStyle) {
	return disabled ?
		itemDisabledStyle.color || (!itemDisabledStyle.color || itemDisabledStyle.strikeout ? defaultClr : "silver") :
		defaultClr;
};

legend_helpers.updateBubblePieData = function(d, i, chartObj) {
	if (chartObj.dataObject.pieWithAxis) {
		d.data.forEach(function(subseries) {
			var isBubblePie = (chartObj.chartTypes[i].value === $ZC.charttype.bubblepie);
			subseries.forEach(function(dataPoint) {
				dataPoint.disabled = d.disabled || !isBubblePie;
			});
		});
	}
};

legend_helpers.updateHierarchyData = function(d, i, chartObj) {
	if (chartObj.dataObject.isHierarchy) {
		chartObj.systemConf.seriesdata.chartdata[i].disabled = d.disabled;
	}
};

legend_helpers.toggleChartEvents = function(chartObj, enable) {
	var val = enable ? null : "none",
		elements = [];
	if (!chartObj.svg) {
		elements.push(chartObj.container);
	} else {
		if (chartObj.isAxisCategory || chartObj.dataObject.isPolarAxisCategory) {
			elements.push(chartObj.eventHandler.trackerElement);
		}
		elements.push(chartObj.svg);
	}
	elements.forEach(function(d) {
		d.style("pointer-events", val);
	})
};

legend_helpers.fadeChart = function(enable, chartObj, opacity) {
	chartObj.container.selectAll("g.chartgroup,svg.static,canvas.zc-canvas,div.zcnotes")
		.style("opacity", enable ? null : opacity);
};

legend_helpers.isDisabled = function(d, allSelected, isFirstClickAfterDeselection) {
	return (!allSelected && !isFirstClickAfterDeselection) ?
		!allSelected :
		d.disabled;
};

legend_helpers.isAllEnabled = function(legData, allSelected) {
	if (!allSelected) {
		return allSelected;
	}
	var disabledEle = legData.filter(function(d) {
		return d.disabled;
	});
	return !disabledEle.length;
};

legend_helpers.getFilterBoxSize = function(colorBox, fontSize) {
	var colorBoxSize = defined(colorBox.size) ? +colorBox.size : fontSize,
		colorBoxWidth = defined(colorBox.width) ? +colorBox.width : colorBoxSize,
		colorBoxHeight = defined(colorBox.height) ? +colorBox.height : colorBoxSize;
	return [colorBoxWidth, colorBoxHeight];
};

legend_helpers.updateData = function(d, i, chartObj) {
	if (colorscale_helpers.isQuantileColorScale(chartObj)) {
		chartObj.axes.clr.scale = $ZC.scale.getScale(chartObj, chartObj.dataObject, null, null, null, chartObj.dataset, "clr");
	} else {
		legend_helpers.updateBubblePieData(d, i, chartObj); //For bubblepie chart, it is mandatory to mark every data point to be disabled if the series is disabled
		legend_helpers.updateHierarchyData(d, i, chartObj); //For hierarchy chart, chartObj.seriesdata reference is not equal to chartObj.systemConf.seriesdata.chartdata reference as the chartObj.seriesdata is simplecloned. So, storing disable information at systemconf is mandatory
		chartObj.dataObject.data = chartObj.systemConf;
	}
};

legend_helpers.isContinousLegend = function(chartObj) {
	var colorBandOptions = chartObj.systemConf.legend.colorBand,
		isQuantileScale = colorscale_helpers.isQuantileColorScale(chartObj);

	if (!isQuantileScale) {
		return false;
	} else {
		var userRanges = colorBandOptions.ranges;
		if (userRanges && userRanges.length) {
			var type = colorBandOptions.type;
			return type === "continuousDiscrete" || type === "continuous";
		} else {
			return true;
		}
	}
};

legend_helpers.getColorBandDimension = function(chartObj) {
	var chartarea = chartObj.chartarea,
		legendOptions = chartObj.systemConf.legend,
		colorbandOptions = legendOptions.colorBand,

		orient = legend_helpers.getOrient(legendOptions),
		isHorizontal = orient === "bottom" || orient === "top",

		maxWidth = legendOptions.maxWidth,
		maxHeight = legendOptions.maxHeight,

		w = colorbandOptions.width,
		h = colorbandOptions.height;

	if (isHorizontal) {
		maxWidth = maxWidth || ZC_LEGEND_maxWidthHoriRatio;
		maxHeight = maxHeight || ZC_LEGEND_maxHeightHoriRatio;
		w = w || "40%";
		h = h || 14;
	} else {
		maxWidth = maxWidth || ZC_LEGEND_maxWidthVertRatio;
		maxHeight = maxHeight || ZC_LEGEND_maxHeightVertRatio;
		w = w || 14;
		h = h || "70%";
	}

	maxWidth = perToPx(maxWidth, chartarea.width);
	maxHeight = perToPx(maxHeight, chartarea.height);
	w = perToPx(w, chartarea.width);
	h = perToPx(h, chartarea.height);

	w = mathMin(w, maxWidth);
	h = mathMin(h, maxHeight);

	return [w, h];
};

legend_helpers.getOrient = function(legendOptions) {
	var hAlign = legendOptions.hAlign,
		vAlign = legendOptions.vAlign,
		orient = "right";

	if (vAlign === "bottom") {
		orient = "bottom";
	} else if (vAlign === "top") {
		orient = "top";
	} else if (hAlign === "left") {
		orient = "left";
	}

	return orient;
};

legend_helpers.getLabelIndex = function(value, colorbandOptions) {
    var userStops = colorbandOptions.stops,
        userRanges = colorbandOptions.ranges,
        labelIndex;

    if (userStops && userStops.length) {
        userStops.some(function(d, i) {
            var condition = d === value;
            if (condition) {
                labelIndex = i;
                return true;
            }
        });
    } else if (userRanges && userRanges.length) {
        userRanges.some(function(d, i) {
            var condition;
            if (isArray(d)) {
                if (isArray(value)) {
                   condition = d[0] === value[0] && d[1] === value[1];
                } else {
                    condition = d[0] === value;
                }
            } else {
                condition = d === value;
            }
            if (condition) {
                labelIndex = i;
                return true;
            }
        });
    }
    return labelIndex;
};

legend_helpers.hexToRGB = function(color) { //Converting hex colors to rgb
	if (color && (color.toString().indexOf("#") == -1)) {
		return color;
	}
	var bigint = pInt(d3_rgb(color).toString().replace(/#/g, ""), 16);
	return "rgb(" + ((bigint >> 16) & 255) + "," + ((bigint >> 8) & 255) + "," + (bigint & 255) + ")";
};

legend_helpers.filterSelectionByColor = function(selection, selectedSeries, filterIndex, chartObj) {
	if (defined(filterIndex)) {
		var filterValue = chartObj.systemConf.legend.colorBand.ranges[filterIndex],
			colorScale = chartObj.axes.clr.scale,
			isOrdinal = chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE,
			condition;
		if (filterValue.length === 1 && !isOrdinal) {
			var domain = d3_values(colorScale.domain());
			domain.splice(0, 2);
			filterValue = [domain[filterIndex * 2], domain[filterIndex * 2 + 1]];
		}
		return selection.filter(function(d) {
			var dt = d.data || d;
			var clr = chartObj.dataset.getClr(dt);
			condition = isWithinColorRange(clr, chartObj, colorScale);
			if (isOrdinal) {
				condition = condition && clr === filterValue[0];
			} else {
				var colorByIndex = getColorByIndex(chartObj, filterIndex);
				colorByIndex = (typeof colorByIndex === "string") ? rgb2hex(colorByIndex) : colorByIndex; // Need to remove in d3.v4
				condition = condition && (clr >= filterValue[0] && clr <= filterValue[1]);

				if (clr === filterValue[0]) {
					condition = condition && (colorByIndex === colorScale(clr));
				}
				if (clr === filterValue[1]) {
					condition = condition && (colorByIndex === colorScale(clr));
				}
			}
			return selectedSeries ? condition : !condition;
		});
	} else {
		return selection;
	}
};
//$Id$
var ZC_LEGEND_maxHeightVertRatio = "80%",
    ZC_LEGEND_maxHeightHoriRatio = "20%",
    ZC_LEGEND_maxWidthVertRatio = "20%",
    ZC_LEGEND_maxWidthHoriRatio = "100%";//$Id$
$ZC.legend.render = function(chartObj) {
    var systemconf = chartObj.systemConf,
        legendData = systemconf.legend,
        dataObject = chartObj.dataObject,
        seriesdata = chartObj.seriesdata;

    var isQuantileColorScale = colorscale_helpers.isQuantileColorScale(chartObj),
        isContinousLegend = legend_helpers.isContinousLegend(chartObj),
        legComp = chartObj.legend.component = isContinousLegend ? $ZC.legend.continuous.get() : $ZC.legend.discrete.get();
    
    var legendShow = (chartObj.isAxisCategory || chartObj.isNonAxisMultiSeriesCategory) ?
        seriesdata.some(function(d){ return !legend_helpers.isHiddenItem(d) && d.seriesname !== UNDEFINED; }) :
        !(chartObj.chartTypes[0].value == $ZC.charttype.dial);
    legendShow = legendShow || isQuantileColorScale;

    
    var dim = chartObj.canvasarea[(legendData == null || legendData.vAlign == null) ? "height" : (legendData.vAlign === "top" || legendData.vAlign === "bottom") ? "height" : "width"],
        floating = (legendData != null && legendData.x != null && legendData.x !== "") && (legendData.y != null && legendData.y !== "");
    legendShow = (floating || dimension_based_intelligence(chartObj, "legend", dim)) ? legendShow : false;
    
    createColorAxis();

    if (legendShow && legendData.enabled === true) {
        chartObj.legendarea.show = true;
        chartObj.legendarea.element.style("display", "");
        drawLegend();
    } else {
        chartObj.legendarea.show = false
        chartObj.legendarea.element.style("display", "none");
        $ZC.legend.events(chartObj, chartObj.legendarea.element.selectAll("li.series"), {allSelected: true, isFirstClickAfterDeselection: false});
    }
    
    function getlegend(legdata) {
        var legend = legComp
            .chartarea(chartObj.chartarea)
            .systemconf(systemconf)
            .color(chartObj.seriesColor)
            .chartObj(chartObj);
        return legend;
    }
    
    function drawLegend() {
        var legpos = legendData.legpos;
        legComp = getlegend(legendData);
        legComp(chartObj.legendarea.element.datum(legendData));
        var legnode = chartObj.legendarea.element.node(),
            legwid,
            leghei,
            legx,
            legy;

        if (isContinousLegend) {
            var bb = bbox(legnode);
            legwid = bb.width;
            leghei = bb.height;
            legy = bb.y;
            legx = bb.x;
        } else {
            legwid = legnode.offsetWidth;
            leghei = legnode.offsetHeight;
            legy = legnode.offsetTop;
            legx = legnode.offsetLeft;
        }

        var floating = (legendData.x != null && legendData.x !== "") && (legendData.y != null && legendData.y !== "");
        legendData.marginLeft = +(legendData.marginLeft);
        legendData.marginRight = +(legendData.marginRight);
        legendData.marginTop = +(legendData.marginTop);
        legendData.marginBottom = +(legendData.marginBottom);
        if (!floating) {
            if (legendData.vAlign == "center") {
                chartObj.chartarea.width -= (legwid + legendData.marginLeft + legendData.marginRight)
                chartObj.plotarea.width -= (legwid + legendData.marginLeft + legendData.marginRight)
                if (legendData.hAlign == "left") {
                    chartObj.chartarea.left += (legwid + legendData.marginLeft + legendData.marginRight)
                    chartObj.plotarea.left += (legwid + legendData.marginLeft + legendData.marginRight)
                }
            } else if (legendData.vAlign == "top") {
                chartObj.chartarea.top += (leghei + legendData.marginTop + legendData.marginBottom);
                chartObj.plotarea.top += (leghei + legendData.marginTop + legendData.marginBottom);
                chartObj.chartarea.height -= (leghei + legendData.marginTop + legendData.marginBottom);
                chartObj.plotarea.height -= (leghei + legendData.marginTop + legendData.marginBottom);
            } else if (legendData.vAlign == "bottom") {
                chartObj.chartarea.height -= (leghei + legendData.marginTop + legendData.marginBottom);
                chartObj.plotarea.height -= (leghei + legendData.marginTop + legendData.marginBottom);
            }
        }
        chartObj.legendarea.x = legx, chartObj.legendarea.y = legy
        chartObj.legendarea.width = legwid, chartObj.legendarea.height = leghei;
    }

    function createColorAxis() {
        if (isQuantileColorScale) {
            var userRanges = chartObj.systemConf.legend.colorBand.ranges;
            if (userRanges && userRanges.length) {
                chartObj.userdata.legend.colorBand.ranges = chartObj.systemConf.legend.colorBand.ranges = getRawRanges(chartObj, true); //for  [10,20,30,40] ranges where the ranges are not array, it is mandatory to convert it to array and save it in userdata and systemconf for performing legend highlight, filter and redraw after legend filter
            }

            var colorScale = $ZC.scale.getScale(chartObj, dataObject, null, null, null, chartObj.dataset, "clr"),
                colorScale_domain = colorScale.domain(),
                indexScale = colorScale.copy();
            indexScale.range(colorscale_helpers.getProcessedColorRange(d3_range(colorScale_domain.length), colorScale_domain, chartObj.systemConf.legend.colorBand, chartObj));

            chartObj.axes.clr = {
                scaleType: "quantile",
                scale: colorScale,
                indexScale: indexScale
            };

        } else {
            chartObj.axes.clr = {};
        }
    }
};//$Id$
$ZC.legendHighlight = function(chartObj, container) {
    var legendHighlight = {},
        origProp = {},
        defsLocation = chartObj.defsLocation,
        userdata = chartObj.userdata,

        // data processor helpers

        dataProcessorHelpers = $ZC.DataProcessor.helpers,
        getChartType = dataProcessorHelpers.getChartType,
        filterSelectionByColor = legend_helpers.filterSelectionByColor;
    
    /*
     * Highlight effects for Bar,pie,funnel,web,area,line,scatter
     * patterns--> diagonalfill,strokeEnlarge,fadeout
     * diagonal fill not supported for line,scatter
     * fadeout: fillopacity except line and scatter, strokeopacity for line and scatter
     */
    legendHighlight.highlightSelectedSeries = function(legdata, index, filterIndex) {
        legendHighlight.baseClr = getColorByIndex(chartObj, (defined(filterIndex) ? filterIndex : index));

        switch (chartObj.plot.renderer.mode) {
            case "svg": {
                highlightSVGSeries(legdata, index, filterIndex);
                break;
            }
            case "canvas": {
                highlightCanvasSeries(chartObj, legdata, index, filterIndex);
                break;
            }
            default: {
                highlightNonSVGSeries(legdata, index);
            }
        }
    };
    
    legendHighlight.highlightUnselectedSeries = function(legdata, index, filterIndex) {
        var unselSeriesObj = getUnselectedSeries(index, filterIndex);
        var unselectedSeries = unselSeriesObj.unselectedSeries;
        var indices = unselSeriesObj.indices;
        var charttypes = unselSeriesObj.charttypes;
        var length = unselectedSeries.length;
        for (var i = 0; i < length; i++) {
            var chartType = $ZC.charttypenames.get(charttypes[i]);
            var unselecteffect = this.getLegendHighlightEffect(indices[i], "unselectedSeries");
            var prop = legendHighlight.getEffect(unselecteffect, chartType, null, null, indices[i]);
            applyProp(unselectedSeries[i], prop, indices[i], "unselect");
        }
    };
    
    legendHighlight.reset = function(legdata, index, filterIndex, resetOriginalProp) {
        switch (chartObj.plot.renderer.mode) {
            case "svg": {
                resetSelectedSeries(legdata, index, filterIndex);
                resetUnselectedSeries(legdata, index, filterIndex);
                break;
            }
            case "canvas": {
                resetCanvasSeries();
                break;
            }
        }


        if (resetOriginalProp !== false) { //Test_662.json
            origProp = {}; //Deleting the stored style values, will help you to know whether the element is already highlighted are not.
        }
    };
    
    legendHighlight.getLegendHighlightEffect = function(index, seriesType, plotOrLegend) {
        var chartName = getChartType(null, "string", index, userdata);
        var plotOptions = (chartObj.isAxisCategory || chartObj.isNonAxisMultiSeriesCategory) ? chartObj.seriesdata[index].plotoptions : chartObj.seriesdata[0].plotoptions;
        var commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions[chartName];
        var ef = (plotOptions && plotOptions.legendHighlightEffect && commonPlotOptions.legendHighlightEffect) ?
            ($ZC.utils.getValueOfPlotOptions(plotOptions.legendHighlightEffect, commonPlotOptions.legendHighlightEffect)(seriesType)) :
            (commonPlotOptions.legendHighlightEffect && commonPlotOptions.legendHighlightEffect[seriesType]);
        var legendEffect = chartObj.systemConf.legend.highlightEffect[seriesType];
        if (plotOrLegend === "plot") {
            return ef || (legendEffect && legendEffect !== "none" ? legendEffect : defaultEffect(chartName));
        } else {
            return ef || legendEffect || defaultEffect(chartName);
        }
    };
    
    
    legendHighlight.getEffect = function(effect, chartName, baseClr, additionalStyles, index) {
        baseClr = baseClr || legendHighlight.baseClr;

        var userEffect = invokeFunction(effect, chartObj, baseClr, patternThemes);
        if (userEffect && userEffect.constructor == Object){
            return userEffect;
        }
        effect = (effect === null || invalidEffect(effect, chartName)) ? defaultEffect(chartName) : effect;
        var eStyle = {};

        if (chartObj.patternPallete && /(flip|moody|illuminate)/.test(effect)) {
            var svgPattern = chartObj.patternPallete[(index || 0) % chartObj.patternPallete.length];
            var prop = patternThemes[svgPattern] ? patternThemes[svgPattern] : addPatternThemeByEle(svgPattern);

            if (prop.ele) {
                // If custom pallete is given, moody effect will be applied
                prop.bgClr_base = getColorCopy(baseClr, 1, "darker", d3_hsl);
            } else {
                var colorCopy = (effect === "flip")
                            ? baseClr
                            : getColorCopy(baseClr, 1, ((effect === "moody") ? "darker" : "brighter"), d3_hsl);

                // if(isUndefined(prop.bgClr_base)) {
                    prop.bgClr_base = colorCopy;
                // }
                // if(isUndefined(prop.stroke_base)) {
                    prop.stroke_base = colorCopy;
                // }

                if (effect === "flip") {
                    prop = simpleClone(prop); // To avoid inplace change in the pattern object

                    //swapping bgClr_base and stroke_base
                    var temp = prop.bgClr_base;
                    prop.bgClr_base = prop.stroke_base;
                    prop.stroke_base = temp;

                    //swapping bgClr and stroke
                    var copy_bgClr = stringifiedArrayReverse(prop.bgClr),
                        copy_stroke = stringifiedArrayReverse(prop.stroke);

                    prop.bgClr = copy_stroke;
                    prop.stroke = copy_bgClr;
                }
            }

            var patternId = effects.get(svg_patterns,"svgPatternFill",prop);
            eStyle.fill = "url(" + defsLocation + "#" + patternId + ")";
        } else if (/(saturate|grayscale|blur|glow|shadow)/.test(effect)) {
            var filterType = /(saturate|grayscale)/.test(effect) ? "colorMatrix" : "dropShadow",
                options;
            switch (effect) {
                case "saturate":
                    options = {
                        "type": "saturate",
                        "values": "0.3"
                    };
                    break;
                case "grayscale":
                    options = {
                        "type": "matrix",
                        "values": ".33 .33 .33 0 0 .33 .33 .33 0 0 .33 .33 .33 0 0 0 0 0 1 0"
                    };
                    break;
                case "blur":
                    options = {
                        "blur": 6,
                        "source": "SourceGraphic"
                    };
                    break;
                case "glow":
                    options = {
                        "blur": 3,
                        "color": "gold"
                    };
                    break;
                case "shadow":
                    options = {
                        "dx": 5,
                        "dy": 5,
                        "blur": 3
                    };
            }
            var filterId = effects.get(svg_filters,filterType, options);
            eStyle.filter = "url(" + defsLocation + "#" + filterId + ")";
        } else if (/(moody|illuminate)/.test(effect)) {
            var ismoody = (effect === "moody");
            eStyle.fill = (baseClr.indexOf("url") != -1) ? (ismoody ? "grey" : "silver") : getColorCopy(baseClr, 0.6, (ismoody ? "darker" : "brighter"), d3_hsl);
        } else if (effect === "strokeEnlarge") {
            eStyle["stroke-width"] = 3;

            if (additionalStyles) {
               for(var a in additionalStyles) {
                    eStyle[a] = additionalStyles[a];
                }
            }

        } else if (effect === "fadeOut") {
            eStyle["fill-opacity"] = eStyle["stroke-opacity"] = 0.3;
        } else if (effect !== "none") {
            var prop = patternThemes[effect];
            if (prop) {
                prop.bgClr_base = baseClr;
                prop.stroke = "transparent,white,white"; //need to check
                var patternId = effects.get(svg_patterns,"svgPatternFill",prop);
                eStyle.fill = "url(" + defsLocation + "#" + patternId + ")";
            } else {
                eStyle.fill = baseClr;
            }
        }
        return eStyle;
    };
    
    function resetSelectedSeries(legdata, index, filterIndex) {
        legendHighlight.selSeriesObj = getSelectedSeries(index, filterIndex);
        var selecteffect = legendHighlight.getLegendHighlightEffect(index, "selectedSeries");
        var selectedSeries = legendHighlight.selSeriesObj.selectedSeries;
        var charttypes = legendHighlight.selSeriesObj.charttypes;
        var length = selectedSeries.length;
        for (var i = 0; i < length; i++) {
            var chartType = $ZC.charttypenames.get(charttypes[i]);
            var prop = legendHighlight.getEffect(selecteffect, chartType, null, null, index);
            resetProp(selectedSeries[i], prop, index, "select");
        }
    }
    
    function resetUnselectedSeries(legdata, index, filterIndex) {
        legendHighlight.unselSeriesObj = getUnselectedSeries(index, filterIndex);
        var unselectedSeries = legendHighlight.unselSeriesObj.unselectedSeries;
        var indices = legendHighlight.unselSeriesObj.indices;
        var charttypes = legendHighlight.unselSeriesObj.charttypes;
        var length = unselectedSeries.length;
        for (var i = 0; i < length; i++) {
            var chartType = $ZC.charttypenames.get(charttypes[i]);
            var unselecteffect = legendHighlight.getLegendHighlightEffect(indices[i], "unselectedSeries");
            var prop = legendHighlight.getEffect(unselecteffect, chartType, null, null, indices[i]);
            resetProp(unselectedSeries[i], prop, indices[i], "unselect");
        }
    }
    
    function resetCanvasSeries() {
        chartObj.container.select(".highlight-canvas").style("visibility", "hidden");
    }
    
    function getSelectedSeries(index, filterIndex) {
        var seriesHolder = container.selectAll("g.seriesholder");
        var type = getChartType(null, "object", index, userdata).value;
        var charttypes = [],
            selectedSeries = [];
        collectSelectedSeries(type, index);
        return {
            "selectedSeries": selectedSeries,
            "charttypes": charttypes
        };
        
        function collectSelectedSeries(type, index) {
            /*
             * This function adds the selected series to the selectedSeries array and respective chart type to the charttypes array.
             * Scatter chart = outer scatter series + inner scatter series.
             * Area chart = area series + line series.
             * Line chart = line series + scatter series.(for IE and SAFARI)
             */
            var series;
            if (isHeatMapChartType(type)) {
                var heatmapSeries = seriesHolder.selectAll("g.heatmapseries_" + index);
                series = heatmapSeries.selectAll("path");
            } else if (isBarChartType(type)) {
                var barSeries = seriesHolder.selectAll("g.barseries_" + index);
                series = barSeries.selectAll("path.zcbar");
            } else if (type == $ZC.charttype.line) {
                var lineSeries = seriesHolder.selectAll("g.lineseries_" + index);
                series = lineSeries.selectAll("path.line");
            } else if (isAreaChartType(type) || type == $ZC.charttype.web) {
                var areaSeries = seriesHolder.selectAll("g.areaseries_" + index);
                series = areaSeries.selectAll("path.area");
            } else if (isScatterChartType(type)) {
                var scatterSeries = seriesHolder.selectAll("g.scatterseries_" + index);
                series = scatterSeries.selectAll("g.scatter");
                series = filterSelectionByColor(series, true, filterIndex, chartObj);

                var outerScatters = series.selectAll("path.outer");
                var innerScatters = series.selectAll("path.inner");

                selectedSeries.push(outerScatters, innerScatters);
                charttypes.push(type, type);
                return;
            } else if (isPieChartType(type)) {
                var pieSeries = seriesHolder.selectAll("g.piegroup");
                series = pieSeries.selectAll(defined(filterIndex) ? "path" : "path#arc_" + index);
            } else if (type == $ZC.charttype.funnel) {
                var funnelSeries = seriesHolder.selectAll("g.funnelgroup");
                var trapezoidgroup = funnelSeries.selectAll("g.trapezoidgroup");
                series = trapezoidgroup.selectAll(defined(filterIndex) ? "path" : "path#funnel" + index);
            } else if (type == $ZC.charttype.pyramid) {
                var pyramidSeries = seriesHolder.selectAll("g.pyramidgroup");
                series = pyramidSeries.selectAll(defined(filterIndex) ? "g" : "g#section_" + index);
            } else if ($ZC.chartcategory.hierarchy.indexOf(type) != -1) {
                var burstseries = seriesHolder.selectAll("g.hierarchychart");
                series = burstseries.selectAll(".series_" + index);
            }

            series = filterSelectionByColor(series, true, filterIndex, chartObj);

            selectedSeries.push(series);
            charttypes.push(type);
            
            if (isAreaChartType(type) || type == $ZC.charttype.web) {
                collectSelectedSeries($ZC.charttype.line, index);
            }
            if (type == $ZC.charttype.line && ($Browser.IE || $Browser.SAFARI)) {
                collectSelectedSeries($ZC.charttype.scatter, index);
            }
        }
    }
    
    function getUnselectedSeries(index, filterIndex) {
        var unSelectedSeries = [],
            indices = [],
            charttypes = [];
        var seriesHolder = container.selectAll("g.seriesholder");
        collectUnselectedSeries(null, index);
        return {
            "unselectedSeries": unSelectedSeries,
            "indices": indices,
            "charttypes": charttypes
        };
        
        function collectUnselectedSeries(subcharttype, index) {
            /*
             * This function adds the unselected series to the selectedSeries array, respective chart type to the charttypes array, respective index to the indices array.
             * Scatter chart = outer scatter series + inner scatter series.
             * Area chart = area series + line series.
             * Line chart = line series + scatter series.(for IE and SAFARI)
             */
            var series, type;
            if ((chartObj.isAxisCategory && !chartObj.dataObject.pieWithAxis) || chartObj.isNonAxisMultiSeriesCategory) {
                chartObj.seriesdata.forEach(function(d, i) {
                    if ((d.disabled != true) && (defined(filterIndex) ? (i === index) : (i !== index))) {
                        type = subcharttype || getChartType(null, "object", i, userdata).value;
                        var selectionIndex = defined(filterIndex) ? index : i;
                        if (isHeatMapChartType(type)) {
                            var heatmapSeries = seriesHolder.selectAll("g.heatmapseries_" + selectionIndex);
                            series = heatmapSeries.selectAll("path");
                        } else if (isBarChartType(type)) {
                            var barSeries = seriesHolder.selectAll("g.barseries_" + selectionIndex);
                            series = barSeries.selectAll("path.zcbar");
                        } else if (type == $ZC.charttype.line) {
                            var lineSeries = seriesHolder.selectAll("g.lineseries_" + selectionIndex);
                            series = lineSeries.selectAll("path.line");
                        } else if (isAreaChartType(type) || type == $ZC.charttype.web) {
                            var areaSeries = seriesHolder.selectAll("g.areaseries_" + selectionIndex);
                            series = areaSeries.selectAll("path.area");
                        } else if (isScatterChartType(type)) {
                            var scatterSeries = seriesHolder.selectAll("g.scatterseries_" + selectionIndex);
                            series = scatterSeries.selectAll("g.scatter");
                            series = filterSelectionByColor(series, false, filterIndex, chartObj);

                            var outerScatters = series.selectAll("path.outer");
                            var innerScatters = series.selectAll("path.inner");

                            unSelectedSeries.push(outerScatters, innerScatters);
                            charttypes.push(type, type);
                            indices.push(selectionIndex, selectionIndex);
                            return;
                        } else if ($ZC.chartcategory.hierarchy.indexOf(type) != -1) {
                            var burstseries = seriesHolder.selectAll("g.hierarchychart");
                            series = burstseries.selectAll(".series_" + selectionIndex);
                        }

                        series = filterSelectionByColor(series, false, filterIndex, chartObj);

                        unSelectedSeries.push(series);
                        indices.push(i);
                        charttypes.push(type);
                    }
                    
                })
            } else {
                type = subcharttype || getChartType(null, "object", index, userdata).value;
                var prefix_ID,
                    processFunc = function(d, i) {
                    var ele = d3_select(this),
                        unselect = defined(filterIndex)
                                        ? !filterSelectionByColor(ele, false, filterIndex, chartObj).empty()
                                        : (this.getAttribute("id") != prefix_ID + index);
                    if (unselect) {
                        unSelectedSeries.push(ele);
                        indices.push(i);
                        charttypes.push(type);
                    }
                    return unselect;
                };

                if (type == $ZC.charttype.pie || type == $ZC.charttype.bubblepie) {
                    prefix_ID = "arc_";
                    series = seriesHolder.selectAll("g.piegroup").selectAll("path").filter(processFunc);
                } else if (type == $ZC.charttype.funnel) {
                    prefix_ID = "funnel";
                    series = seriesHolder.selectAll("g.trapezoidgroup").selectAll("path").filter(processFunc);
                } else if (type == $ZC.charttype.pyramid) {
                    prefix_ID = "section_";
                    var pyramidGroup = seriesHolder.selectAll("g.pyramidgroup");
                    series = pyramidGroup.selectAll("g").filter(processFunc);
                }
            }
            
            if (isAreaChartType(type) || type == $ZC.charttype.web) {
                collectUnselectedSeries($ZC.charttype.line, index);
            }
            if (type == $ZC.charttype.line && ($Browser.IE || $Browser.SAFARI)) {
                collectUnselectedSeries($ZC.charttype.scatter, index);
            }
        }
    }
    
    function applyProp(series, prop, index, type) {
        if (prop == null || prop.constructor != Object || series == null || series.node() == null) {
            return
        }
        var key = getKey(series, index, type),
            currentOrigProp = {},
            multipleStyles = hasMultipleStyles(index);

        for (var attr in prop) {
            if (prop.hasOwnProperty(attr)) {
                if (multipleStyles) {
                    currentOrigProp[attr] = currentOrigProp[attr] || [];
                    series.each(function(){
                        currentOrigProp[attr].push(d3.select(this).style(attr));
                    });
                } else {
                    currentOrigProp[attr] = series.style(attr);
                }

                var val = $ZC.utils.getVal(prop[attr]);
                if ($Browser.SAFARI || $Browser.IE) {
                    series
                        .style(attr, val)
                        .attr(attr, val);
                } else {
                    series
                        .style(attr, val);
                }
            }
        }
        origProp[key] = origProp[key] || currentOrigProp; //If the style values are already stored, don't store again. If u store again, the origProp[key] object will be replaced with the highlighting props instead of containing the style values of the original element.
    }
    
    function resetProp(series, prop, index, type) {
        if (prop == null || prop.constructor != Object || series == null || series.node() == null) {
            return
        }
        
        if (chartObj.plot.renderer.mode !== "svg") {
            setSeriesVisible(series, false);
            return;
        }
        
        var key = getKey(series, index, type),
            currentOrigProp = origProp[key],
            multipleStyles = hasMultipleStyles(index);

        for (var attr in currentOrigProp) {
            if (currentOrigProp.hasOwnProperty(attr)) {
                var val = currentOrigProp[attr],
                    actualVal = function() {
                        return multipleStyles ? val[count++] : val;
                    },
                    count = 0;
                if ($Browser.SAFARI || $Browser.IE) {
                    series
                        .style(attr, actualVal)
                        .attr(attr, actualVal);
                } else {
                    series
                        .style(attr, actualVal);
                }
            }
        }
    }
    
    function getKey(series, index, selectionType) {
        /*
         * This function returns a unique key that is generated from the localName, class, id of the series element and index.
         * The key will be used to store the style values of the element on legend highlighting. The stored values will be applied to the element on unhighlighting.
         */
        var node = series.node();
        var localName = node.localName,
            className = node.getAttribute("class"),
            idName = node.getAttribute("id");
        var KEY = localName + "_" + index;
        if (className != null) {
            KEY += "_" + className;
        }
        if (idName != null) {
            KEY += "_" + idName;
        }
        if (selectionType !== null) {
            KEY += "_" + selectionType;
        }
        return KEY;
    }
    
    function setSeriesVisible(series, visible) {
        series.style("visibility", (visible ? "visible" : "hidden"));
    }
    
    function defaultEffect(chartName) {
        if (hasPatternPallete(chartObj)) {
            return /(area|arearange)/.test(chartName) ?
                "moody" :
                "strokeEnlarge";
        }

        return /(bar|bullet|gantt|area|arearange|pie|funnel|pyramid|web|sunburst|treemap|heatmap)/.test(chartName) ?
            "hatchfill" :
            "strokeEnlarge";
    }
    
    function invalidEffect(effect, chartName) {
        return /(line|scatter)/.test(chartName) && /(((\D)+fill$)|illuminate|moody|flip)/.test(effect);
    }
    
    function highlightSVGSeries(legdata, index, filterIndex) {
        legendHighlight.selSeriesObj = getSelectedSeries(index, filterIndex);
        var selecteffect = legendHighlight.getLegendHighlightEffect(index, "selectedSeries");
        var selectedSeries = legendHighlight.selSeriesObj.selectedSeries;
        var charttypes = legendHighlight.selSeriesObj.charttypes;
        var length = selectedSeries.length;
        
        for (var i = 0; i < length; i++) {
            var chartType = $ZC.charttypenames.get(charttypes[i]);
            var prop = legendHighlight.getEffect(selecteffect, chartType, null, null, index);
            applyProp(selectedSeries[i], prop, index, "select");
        }
    }
    function highlightCanvasSeries(chartObj, legdata, index, filterIndex){
        if (!chartObj.chartRendered) {
            return
        }
        
        var context = chartObj.highlightContext || (chartObj.highlightContext = updateCanvasContext(chartObj, "highlight-canvas")),
            data = chartObj.systemConf,
            effect = chartObj.legendHighlight.getLegendHighlightEffect(index, "selectedSeries");
        if (effect === "none") {
            return;
        }
        var chart = chartObj.chartTypes[index],
            chartName = chart.name,
            chartType = chart.value,
            renderer = createCanvasRenderer(chartName),
            currentSeries = chartObj.seriesdata[index],
            pattern = null;
        
        renderer_helpers.setRendererProp(chartObj, renderer, currentSeries, index, {
            "labelQueue": []
        });
        
        switch (chartName) {
            case "bar":
            case "area":
            case "heatmap":
            {
                var fillOpacity = chartObj.systemConf.chart.plot.plotoptions[chartName].fillOpacity;
                var prop = patternThemes[effect];
                if (prop) {
                    if (defined(filterIndex)) {
                        pattern = getCanvasPattern(prop);
                    } else {
                        pattern = getCanvasPattern(prop)(legendHighlight.baseClr, fillOpacity);
                    }
                }
                break;
            }
            case "scatter":
            case "bubble":
            case "line":
            {
                pattern = chartObj.legendHighlight.getEffect(effect, chartType);
            }
        }
        drawCanvas(chartObj, currentSeries, renderer, context, pattern, filterIndex);
    }

    function getCanvasPattern(prop) {
        return function(baseClr, fillOpacity) {
            prop.bgClr_base = canvasUtils.rgba(baseClr, fillOpacity);
            prop.stroke = "transparent,white,white"; //need to check
            return effects.get(canvas_patterns,"canvasPatternFill",prop);
        };
    }
    
    function highlightNonSVGSeries(legdata, index) {
        
        var selecteffect = legendHighlight.getLegendHighlightEffect(index, "selectedSeries");
        if (selecteffect === "none") {
            return;
        }
        
        legendHighlight.baseClr = getColorByIndex(chartObj, index);
        
        var chartType = chartObj.chartTypes[index];
        var cName = chartType.name;
        var cTypeNumeric = chartType.value;
        
        var selectedSeriesObj = getSelectedSeries(index);
        
        if (selectedSeriesObj.selectedSeries[0].length > 0) {
            setSeriesVisible(selectedSeriesObj.selectedSeries[0], true);
            return;
        }
        
        if (!chartObj.chartRendered) return;
        
        /*
         * Disable animation during the chartObj drwaing proccess and disable the datalabels also.
         */
        
        chartObj.systemConf.chart.plot.animation.enabled = false;
        chartObj.systemConf.chart.plot.plotoptions[cName].animation.enabled = false;
        if (chartObj.seriesdata[index].plotoptions && chartObj.seriesdata[index].plotoptions.animation) {
            chartObj.seriesdata[index].plotoptions.animation.enabled = false;
        }
        
        var renderer = createSVGRenderer(cName);
        var currOrdereddata = chartObj.systemConf.seriesdata.chartdata[index]
        var barDatasetIndex = 0;
        if (cTypeNumeric === $ZC.charttype.bar || cTypeNumeric === $ZC.charttype.stkdbar) {
            for (var i = 0; i < index; i++) {
                chartType = chartObj.chartTypes[i];
                cTypeNumeric = chartType.value;
                if ((chartObj.seriesdata[i].disabled == undefined || !chartObj.seriesdata[i].disabled) && isBarChartType(cTypeNumeric)) {
                    barDatasetIndex = barDatasetIndex + chartObj.seriesdata[i].data.length;
                }
            }
        }
        renderer_helpers.setRendererProp(chartObj, renderer, currOrdereddata, index, {
            "labelQueue": [],
            "barDatasetIndex": barDatasetIndex
        });
        drawSVG(chartObj, currOrdereddata, renderer);
        
        highlightSVGSeries(legdata, index);
        return true;
    }

    function hasMultipleStyles(seriesIndex) {
        var chartType = getChartType(null, NUMERIC_DATATYPE, seriesIndex, userdata);

        return $ZC.chartcategory.hierarchy.indexOf(chartType) != -1 ||
            colorscale_helpers.isQuantileColorScale(chartObj) ||
            isBubbleChartType(chartType) ||
            chartObj.rendererConf[chartObj.isAxisCategory ? seriesIndex : 0].thresholdType;
    }

    return legendHighlight;
};//$Id$
$ZC.legend.discrete = function(){};
$ZC.legend.discrete.get = function() {
    "use strict";
    var chartarea,
        legendWidth = 0,
        color,
        legendSeriesWidth = 0,
        dispatch = d3_dispatch('legendClick', 'legendDblclick', 'legendMouseover', 'legendMouseout'),
        scrollbarwid = 20,
        wrap, systemconf,
        chartObj,

        getLegendData = legend_helpers.getLegendData,
        getLegendDataLength = legend_helpers.getLegendDataLength,
        isHiddenItem = legend_helpers.isHiddenItem,
        getClr = legend_helpers.getClr,
        isDisabled = legend_helpers.isDisabled;

    
    function chart(selection) {
        selection.each(function(data) {
            var legData = getLegendData(chartObj),
                legData_length = getLegendDataLength(chartObj, legData),

                colorBoxOptions = data.colorBox,
                itemDisabledOptions = data.itemDisabledStyle,

                priorityArray = [data, systemconf.canvas, $ZCG],
                floating = ((data.x != null && data.x !== "") && (data.y != null && data.y !== "")),
                fontSize = +($ZC.utils.getVal((data.fontSize) || systemconf.canvas.fontSize)),
                fontColor = getValByPriority(priorityArray, "fontColor"),

                colIdx = chartObj.dataset.getColumnIdx((chartObj.xymultiRenderer || chartObj.isNonAxisMultiSeriesCategory) ? "clr" : "x"),
                showAs = data.showAs,
                colorBoxPosition = colorBoxOptions.position || "left",

                expandable = data.expandable || {},
                legendExpandable = expandable.show  === true,
                redrawing = !!chartObj.renderer.length,

                colorBoxSize = legend_helpers.getFilterBoxSize(colorBoxOptions, fontSize),
                colorBoxWidth = colorBoxSize[0],
                colorBoxHeight = colorBoxSize[1],

                hAlign = data.hAlign,
                vAlign = data.vAlign,

                states = chartObj.legend.states = chartObj.legend.states || {
                    allSelected: true,
                    isFirstClickAfterDeselection: false
                };

            //text-overflow properties
            var item_textOverflow_properties;
            if (data.textOverflow === "wrap") {
                item_textOverflow_properties = {
                    "word-wrap": "break-word",
                    "white-space": "normal",
                    "vertical-align": "top"
                };
            } else {
                item_textOverflow_properties = {
                    "text-overflow": "ellipsis",
                    "vertical-align": "middle"
                };
            }
            
            var container = d3_select(this);
            chart.update = function() {
                container.transition().call(chart);
            };
            wrap = container
                .style({
                    "display": "block",
                    "position": "absolute",
                    "left": null, //Reset left and top position. so that floating legend won't get trimmedon redraw (legend-03.json)
                    "top": null
                })
                .selectAll('div.legendgroup')
                .data([data]);
            var gEnter = wrap.enter().append('div').attr('class', 'legendgroup');
            
            //shadow properties
            var shadow = data.shadow;
            if (shadow.show === true) {
                var shadowstyle = shadow.x + "px " + shadow.y + "px " + shadow.blur + "px " + shadow.color;
                shadowstyle = shadow.inset ? shadowstyle + " inset" : shadowstyle;
                container.style("box-shadow", shadowstyle)
            } else {
                container.style("box-shadow", null);
            }
            
            //Background properties
            var rgb = d3_rgb(data.background.color.toString());
            container.style("background-color", "rgba(" + rgb.r + "," + rgb.g + "," + rgb.b + "," + data.background.alpha + ")");
            
            //Border Properties
            var border = data.border;
            if (border.show === true) {
                container.style({
                    "border": (+border.size) + "px " + border.style + " " + border.color,
                    "border-radius": border.radius + "px"
                });
            } else {
                container.style("border", null);
            }
            //Filter effects
            if(chartObj.filterEffectsID){
                container.style("filter" , chartObj.filterEffectsID ? "url(#"+chartObj.filterEffectsID+")" : null);
            }
            
            //Legend title
            var title_data = data.title;
            var titleMargin = defined(title_data.margin) ? title_data.margin : 3;
            
            var header = appendEle(wrap, "ul", ((title_data.show === true) ? [title_data] : []), ".", "class", "zcheader");
            var headerLI = appendEle(header, "li", [1], ".", "class", "zcheader");
            header
            .style({
                    "white-space": "normal",
                    "overflow": "hidden",
                    "width": "",
                    "list-style-type": "none",
                    "margin": 0,
                    "padding": 0
                });

            headerLI
                .style({
                    "padding" : shorthand_px(titleMargin),
                    "white-space": "nowrap",
                    "overflow": "hidden",
                    "text-align": "left",
                    "text-overflow": "ellipsis",
                    "vertical-align": "middle"
                });

            var selectAllObj = $ZC.legend.selectAllBox(headerLI, chartObj, states);
            var selectAllFilter = selectAllObj.element,
                selectAllBoxOptions = selectAllObj.options,
                selectAllFilterSize = selectAllObj.size,
                disabledOpacity = selectAllBoxOptions.disabledOpacity;
            legend_helpers.fadeChart(states.allSelected, chartObj, disabledOpacity)

            var legtitle = appendEle(headerLI, "span", [1], ".", "class", "legendtitle");
            legtitle
                .text(decodeHTML(title_data.text))
                .style(("padding-"+colorBoxPosition), selectAllBoxOptions.show ? (data.textPadding) + "px" : null)
                .style(("margin-"+colorBoxPosition), selectAllBoxOptions.show ? selectAllFilterSize + "px" : null);
            applyFont(legtitle, [title_data, systemconf.canvas, $ZCG], true);
 
            selectAllFilter
                .style("margin", function() {
                    var top = Math.max(0, ((legtitle.node().offsetHeight - selectAllFilter.node().offsetHeight) / 2)) + "px",
                        bottom = "0px",
                        left = ((colorBoxWidth - selectAllFilterSize) / 2) + "px",
                        right = ((colorBoxWidth - selectAllFilterSize) / 2) + "px";
                    return top + " " + right + " " + bottom + " " + left;
                });

            headerLI
                .style("line-height", function(){
                    var selectAllFilterHeight = selectAllBoxOptions.show ? selectAllFilter.node().offsetHeight : 0;
                    var headerLineHeight = Math.max(legtitle.node().offsetHeight, selectAllFilterHeight);
                    return headerLineHeight + "px"
                });

            var legseries = appendEle(wrap, "ul", [data], ".", "class", "legseries");
            legseries
                .style({
                    "white-space": "normal",
                    "overflow-y": "hidden",
                    // "cursor": cursor,
                    "width": "",
                    "list-style-type": "none",
                    "margin": 0,
                    "padding": 0,
                    "-webkit-overflow-scrolling" : "touch",

                    // #ZC758
                    // https://stackoverflow.com/questions/5256533/
                    "font-size": "0px"
                });

            var showMoreElement;
            
            if (legendExpandable) {
                legseries.style("overflow", "hidden");
                showMoreElement = appendEle(wrap, "div", [1], ".", "class", "expandable");
                showMoreElement.style({
                    "color": expandable.fontColor,
                    "font-size": $ZC.utils.getVal(expandable.fontSize) + "px",
                    "font-family": expandable.fontFamily || getValByPriority(priorityArray, "fontFamily"),
                    "text-align": expandable.textAlign,
                    "cursor": "pointer",
                    "display": "block",
                    "padding": data.itemMargin + "px",
                    "overflow": "hidden",
                    "text-overflow": "ellipsis",
                    "white-space": "nowrap"
                });
                showMoreElement.html(invokeFunction(expandable.text, 0, chartObj) || (0 + " more...")); // for pre height calculation
                
            } else {
                if (!wrap.select(".expandable").empty()) {
                    wrap.selectAll(".expandable").remove();
                    legseries.style("overflow-y", "hidden");
                    legseries.style("overflow-x", "hidden");
                }
            }
            
            var series = legseries.selectAll("li.series").data(legData);
            var seriesEnter = series.enter().append("li").attr("class", "series");
            seriesEnter.append("div").attr("class", "legendfilterbox");
            seriesEnter.append("span").attr("class", "legendlabel");
            series.exit().remove();
            
            series
                .style({
                    "color": function(d) {
                        return getClr(isDisabled(d, states.allSelected, states.isFirstClickAfterDeselection), fontColor, itemDisabledOptions);
                    },
                    "position": "relative",
                    "white-space": "nowrap",
                    "padding": (+data.itemMargin) + "px",
                    "overflow": "hidden",
                    "text-align": "left",
                    "line-height": defined(colorBoxOptions.size) ? mathMax(fontSize, colorBoxHeight) + "px" : ((($Browser.OSX || $Browser.LINUX) && $Browser.FIREFOX) ? "1.2" : "normal"),
                    "font-size": fontSize + "px",
                    "width": (data.itemWidth == null || data.itemWidth == "") ? null : data.itemWidth + "px",
                    "height": (data.itemHeight == null || data.itemHeight == "") ? null : data.itemHeight + "px",
                    "font-family": getValByPriority(priorityArray, "fontFamily"),
                    "font-weight": getValByPriority(priorityArray, "fontWeight"),
                    "display": function(d) {
                        return isHiddenItem(d) ? "none" : ((!floating && vAlign != "center") ? "inline-block" : "block");
                    }
                })
                .style(item_textOverflow_properties)
                .style("vertical-align", "top");

            $ZC.legend.events(chartObj, series, states, disabledOpacity);

            var legendlabel = series.select("span.legendlabel");
            legendlabel
                .style(("padding-"+colorBoxPosition), (data.textPadding) + "px")
                .style(("margin-"+colorBoxPosition), colorBoxWidth + "px")
                .html(function(d, i) {
                    if (colorscale_helpers.isQuantileColorScale(chartObj)) {
                        var colorBandOptions = data.colorBand,
                            userLabels = colorBandOptions.labels;

                        if (userLabels && userLabels.length) {
                            return userLabels[i];//check with unorders ranges input
                        }
                    }

                    var seriesPos = (chartObj.xymultiRenderer || chartObj.isNonAxisMultiSeriesCategory) ? i : 0,
                        itemPos = (chartObj.xymultiRenderer || chartObj.isNonAxisMultiSeriesCategory) ? 0 : i;
                    return showAs ?
                        chartObj.dataset.getCustomizedVal(chartObj, showAs, seriesPos, 0, itemPos, d, "legend") :
                        chartObj.dataset.getDataPointValue(chartObj, d, colIdx, seriesPos, null, "legend");
                })
                .attr("title", function() {
                    return data.tooltip ? this.textContent : null;
                });
            
            var ImpFontProp = {
                "fontColor": function(d) {
                    return getClr(isDisabled(d, states.allSelected, states.isFirstClickAfterDeselection), fontColor, itemDisabledOptions);
                },
                "textDecoration": function(d) {
                    return (isDisabled(d, states.allSelected, states.isFirstClickAfterDeselection) && itemDisabledOptions.strikeout) ? "line-through" : null;
                }
            };
            applyFont(legendlabel, [ImpFontProp, data, systemconf.canvas, $ZCG], true);

            var legend_label_height = legseries.select("span.legendlabel").node().offsetHeight;

            var margin_top = 0;
            if (defined(colorBoxOptions.size) || data.textOverflow === "wrap") {
                margin_top = (mathMax(fontSize, colorBoxHeight) - colorBoxHeight) / 2;
            } else if (legend_label_height > colorBoxHeight) {
                margin_top = (legend_label_height - colorBoxHeight) / 2;
            }
            
            var legendFilter = series.select("div.legendfilterbox");
            
            legendFilter
                .style({
                    "width": colorBoxWidth + "px",
                    "height": colorBoxHeight + "px",
                    "float": colorBoxPosition,
                    "margin-top": margin_top + "px", // ISSUE:ZC429 -> line-height will not be applied to float element
                    "border-color": "transparent",
                    "background-repeat": "repeat",
                    "line-height": (colorBoxHeight - colorBoxOptions.strokeWidth) + "px",
                    "text-align": "center",
                    "font-family": colorBoxOptions.fontFamily,
                    "font-size": (colorBoxOptions.fontSize || fontSize) + "px",
                    "position" : "absolute",
                    "display" : "inline-block",
                    "box-sizing": "border-box"
                });

            // background for colorBox
            $ZC.legend.setColorBoxBackground(legendFilter, chartObj, states);


            var itemTempHeight = series.node().offsetHeight,
                legendExpanded = chartObj.legend.expanded;
            
            var itemWidths = [];
            var maxItemWidth = data.itemWidth != null ? (+data.itemWidth) : null
            var textNodeWid, filterNodeWid;
            //Itemwidth calculate
            series.each(function(d) {
                var legendfilter = d3_select(this)
                    .select('div.legendfilterbox');
                var legendText = d3_select(this)
                    .select('span.legendlabel');
                filterNodeWid = filterNodeWid || legendfilter.node().getBoundingClientRect().width;
                textNodeWid = legendText.node().getBoundingClientRect().width;
                var computedTextLength = filterNodeWid + textNodeWid;
                itemWidths.push(maxItemWidth || (computedTextLength + 2 * (+data.itemMargin)));
            });
            
            maxItemWidth = data.itemWidth != null ? maxItemWidth : d3_max(itemWidths);
            var maxItemHeight = data.itemHeight || (mathMax(legend_label_height, colorBoxHeight) + (2 * (+data.itemMargin)));
            
            legseries.style("overflow-y", ((legendExpandable && legendExpanded) || !legendExpandable) === true ? "auto" : "hidden");
            legseries.style("overflow-x", "hidden");
            var itemsPerRow = 0,
                maxItemToFit;
            
            var columnWidths = [];
            legendWidth = 0

            if (floating) {
                var maxHeight = perToPx((data.maxHeight || ZC_LEGEND_maxHeightVertRatio), chartarea.height);
                if (legendExpandable) {
                    maxHeight = (mathFloor(maxHeight / itemTempHeight) * itemTempHeight);
                }
                
                var dimension = chartObj.legendarea.element.node().getBoundingClientRect();
                
                var maxX = mathMin(chartObj.canvasarea.width - dimension.width, data.x),
                    maxY = mathMin(chartObj.canvasarea.height - (mathMin(dimension.height, maxHeight)), data.y);
                
                container.style('left', maxX + "px");
                container.style('top', maxY + "px");
                legseries.style("max-height", maxHeight + "px");
            } else {
                var maxWidth = perToPx(data.maxWidth || ((vAlign != "center") ? ZC_LEGEND_maxWidthHoriRatio : ZC_LEGEND_maxWidthVertRatio), chartarea.width);
                wrap
                    .style("max-width", maxWidth + "px");
                header
                    .style("max-width", maxWidth + "px");

                if (vAlign != "center") {
                    var maxHeight = perToPx((data.maxHeight || ZC_LEGEND_maxHeightHoriRatio), chartarea.height);
                    var availableLegWidth = maxWidth - (+data.marginLeft) - (+data.marginRight) - (data.border.show ? (2 * data.border.size) : 0);
                    if (legendExpandable) {
                        maxHeight = (mathFloor(maxHeight / itemTempHeight) * itemTempHeight);
                        if(maxHeight < itemTempHeight) {
                            maxHeight = itemTempHeight;
                        }
                    }

                    while (legendWidth < availableLegWidth && itemsPerRow < itemWidths.length) {
                        columnWidths[itemsPerRow] = itemWidths[itemsPerRow];
                        legendWidth += itemWidths[itemsPerRow];
                        itemsPerRow++;
                    }

                    var sumFunc = function(prev, cur) {
                            return prev + cur;
                        };
                    while (legendWidth > availableLegWidth && itemsPerRow > 1) {
                        columnWidths = [];
                        itemsPerRow--;
                        
                        for (var k = 0; k < itemWidths.length; k++) {
                            // if (maxItemWidth > (columnWidths[k % itemsPerRow] || 0)) {
                            columnWidths[k % itemsPerRow] = itemWidths[k % itemsPerRow];
                            // }
                        }
                        
                        legendWidth = columnWidths.reduce(sumFunc);
                    }
                    var moduloRem = itemWidths.length % itemsPerRow;
                    var moduloQuo = (itemWidths.length - moduloRem) / itemsPerRow;
                    var noOfRows = (moduloRem == 0) ? moduloQuo : moduloQuo + 1;

                    legseries.style({
                        "height": ((noOfRows * maxItemHeight) + 2) + "px",
                        "max-height": maxHeight + "px",
                        "max-width": maxWidth + "px"
                    });

                    var scrollWid = (legseries.node().scrollHeight > legseries.node().offsetHeight) ? scrollbarwid : 0;
                    legendSeriesWidth = legendWidth + 2 + scrollWid;
                    legseries.style("width", legendSeriesWidth + "px");
                    var legalign = align(data, container);

                    maxItemToFit = getVisibleItemCount(legseries);
                    if(defined(showMoreElement) && legData_length <= maxItemToFit) {
                        appendEle(wrap, "div", [], ".", "class", "expandable");
                        legalign = align(data, container);
                    }
                    container.style({
                        "left": (legalign.x) + "px",
                        "top": (legalign.y) + "px"
                    });
                } else {
                    itemsPerRow = 1;
                    var maxHeight = perToPx((data.maxHeight || ZC_LEGEND_maxHeightVertRatio), chartarea.height);
                    
                    if (legendExpandable) {
                        maxHeight = (mathFloor(maxHeight / itemTempHeight) * itemTempHeight);
                    }
                    
                    legseries
                        .style({
                            "max-height" : maxHeight + "px",
                            "max-width" : maxWidth + "px"
                        });

                    var scrollWid = (legseries.node().scrollHeight > legseries.node().offsetHeight) ? scrollbarwid : 0;
                    legendSeriesWidth = maxItemWidth + 2 + scrollWid;

                    maxItemToFit = getVisibleItemCount(legseries);
                    if (defined(showMoreElement) && legData_length <= maxItemToFit) {
                        appendEle(wrap, "div", [], ".", "class", "expandable");
                    }

                    legseries.style({
                        "width": legendSeriesWidth + "px",
                        "height": null
                    });
                    var legwid = container.node().getBoundingClientRect().width;
                    if (hAlign == "right" || hAlign == "center") {
                        container.style('left', (chartarea.width - legwid - (+data.marginRight)) + "px");
                        container.style('top', (chartarea.top + (+data.marginTop)) + "px");
                    } else {
                        container.style('left', (+data.marginLeft) + "px");
                        container.style('top', (chartarea.top + (+data.marginTop)) + "px");
                    }
                }
            }

            if (legendExpandable) {
                var visibleItemCount = pick(maxItemToFit, getVisibleItemCount(legseries));
                if (legData_length > visibleItemCount) {
                    showMoreElement.style({
                        "width": (legendSeriesWidth) + "px"
                    });
                    
                    var showMoreText = invokeFunction(expandable.text, legData_length - visibleItemCount, chartObj) || (legData_length - visibleItemCount + " more...");
                    
                    if (!legendExpanded) {
                        showMoreElement.html(showMoreText);
                    } else if (redrawing && legendExpanded) {
                        showMoreElement.html(function() {
                            return invokeFunction(expandable.ontoggle, this, legendExpanded, chartObj) || "Show less..";
                        });
                    }
                    
                    showMoreElement.on("click", function() {
                        legendExpanded = chartObj.legend.expanded = !chartObj.legend.expanded;
                        var updatedText = invokeFunction(expandable.ontoggle, this, legendExpanded, chartObj);
                        if (defined(updatedText)) {
                            updatedText = updatedText + "";
                        }
                        
                        if (legendExpanded) {
                            this.innerHTML = updatedText || "Show less..";
                            legseries.style("overflow-y", "auto");
                        } else {
                            legseries.node().scrollTop = 0;
                            visibleItemCount = getVisibleItemCount(legseries);
                            this.innerHTML = updatedText || invokeFunction(expandable.text, legData_length - visibleItemCount, chartObj) || (legData_length - visibleItemCount + " more...");

                            legseries.style("overflow-y", "hidden");
                        }
                    })
                } else {
                    showMoreElement.remove();
                }
            }
        });
        return chart;
    }
    
    chart.dispatch = dispatch;
    
    chart.chartarea = function(_) {
        if (!arguments.length) {
            return chartarea;
        }
        chartarea = _;
        return chart;
    };
    
    chart.systemconf = function(_) {
        if (!arguments.length) {
            return systemconf;
        }
        systemconf = _;
        return chart;
    };
    
    chart.chartObj = function(_) {
        if (!arguments.length) {
            return chartObj;
        }
        chartObj = _;
        return chart;
    };
    
    chart.color = function(_) {
        if (!arguments.length) {
            return color;
        }
        color = _;
        return chart;
    };

    function align(data, legNode) {
        var hAlign = data.hAlign,
            vAlign = data.vAlign,

            bb = legNode.node().getBoundingClientRect(),
            legwid = bb.width,
            leghei = legNode.node().offsetHeight;

        var align = {};
        if (hAlign == "left") {
            align.x = chartarea.left + (+data.marginLeft);
        } else if (hAlign == "center") {
            align.x = chartarea.width / 2 - legwid / 2;
        } else if (hAlign == "right") {
            align.x = chartarea.width - legwid - (+data.marginRight);
        }
        if (vAlign == "top") {
            align.y = chartarea.top + (+data.marginTop);
        } else if (vAlign == "bottom") {
            align.y = chartarea.height + chartarea.top - leghei - (+data.marginBottom);
        }
        return align;
    }
    
    function getVisibleItemCount(legseries) {

        var leg = legseries.node(),
            elements = leg.children,
            count = 0;

        for (var ii = 0, ll = elements.length; ii < ll; ii++) {
            if (elementIsVisible(elements[ii], leg)) {
                count++;
            } else {
                break;
            }
        }
        return count;
    }

    return chart;
};//$Id$
(function() {
	var getLegendData = legend_helpers.getLegendData,
		getLegendDataLength = legend_helpers.getLegendDataLength,
		isHiddenItem = legend_helpers.isHiddenItem,
		isDisabled = legend_helpers.isDisabled,
		isAllEnabled = legend_helpers.isAllEnabled,
		getClr = legend_helpers.getClr,
		updateData = legend_helpers.updateData;

	$ZC.legend.events = function(chartObj, element, states, disabledOpacity) {
		var legendComponent = chartObj.legend.component,
			legendOptions = chartObj.systemConf.legend,
			itemDisabledOptions = legendOptions.itemDisabledStyle,
			colorBoxOptions = legendOptions.colorBox,

			priorityArray = [legendOptions, chartObj.systemConf.canvas, $ZCG],
			priorityArrayOnhover = [legendOptions.itemHoverStyle, legendOptions, chartObj.systemConf.canvas, $ZCG],
			fontColor = getValByPriority(priorityArray, "fontColor"),

			legendFilter,
			selectAllFilter,

			legData,
			legData_length;

		/*
		 * legend event variables
		 */
		var events = chartObj.systemConf.legend.events;
		var onClickFn, onDblClickFn, onMouseOverFn, onMouseOutFn,
			onTapFn, onTapHoldFn, onTapHoldEndFn,
			cursor, eventDisabled;
		if (events != null) {
			eventDisabled = (validateNullVal(events.enabled, true) == false);
			onClickFn = events.click;
			onDblClickFn = events.doubleclick;
			onMouseOverFn = events.mouseover;
			onMouseOutFn = events.mouseout;
			cursor = events.cursor;
			onTapFn = events.tap;
			onTapHoldFn = events.taphold;
			onTapHoldEndFn = events.tapholdend;
		}

		if (!eventDisabled) {
			element
				.style("cursor", cursor || "pointer");

			var eventAttacherOptions = {
				chartObj: chartObj
			};
			var mousemove = function(d, i) {
					clickedTime = null;
					if (onMouseOverFn == null) {
						defaultOnMouseOverFunc(this, d, i);
					} else {
						var userFunction = chartObj.zcEventType ? onTapHoldFn : onMouseOverFn;
						invokeFunction(userFunction, d3.event, d, i, chartObj);
					}
				},
				mouseout = function(d, i) {
					if (onMouseOutFn == null) {
						defaultOnMouseOutFunc(this, d, i);
					} else {
						var userFunction = chartObj.zcEventType ? onTapHoldEndFn : onMouseOutFn;
						invokeFunction(userFunction, d3.event, d, i, chartObj);
					}
				},
				click = function(d, i) {
					var isTouchEvent = d3.event && d3.event.touches;
					if (isTouchEvent) {
						clickedTime = null;
						docTapFunction(chartObj);
					}
					if (onClickFn == null) {
						defaultOnClickFunc(this, d, i);
					} else {
						var userFunction = chartObj.zcEventType ? onTapFn : onClickFn;
						invokeFunction(userFunction, d3.event, d, i, chartObj);
					}
				},
				dblclick = function(d, i) {
					if (onDblClickFn == null) {
						var dummy = true;
						//default double click function
					} else {
						invokeFunction(onDblClickFn, d3.event, d, i, chartObj);
					}
				};
			var mouseHandlers = {
					"mousemove": mousemove,
					"mouseout": mouseout,
					"click": click,
					"dblclick": dblclick
				},
				touchHandlers = {
					"taphold": mousemove,
					"tapholdend": mouseout,
					"tap": click,
					"dbltap": dblclick
				};
			attachevents(element, mouseHandlers, touchHandlers, eventAttacherOptions);
		}

		function defaultOnClickFunc(ele, d, i) {
			legendComponent.toggleItemNUpdateChart(ele, d, i, legendOptions);
		}

		function defaultOnMouseOverFunc(ele, d, i) {
			legendComponent.highlightSeries(ele, d, i, legendOptions, chartObj, true);
			legendComponent.highlightItem(ele, d, i, legendOptions, true);
		}

		function defaultOnMouseOutFunc(ele, d, i) {
			legendComponent.highlightSeries(ele, d, i, legendOptions, chartObj);
			legendComponent.highlightItem(ele, d, i, legendOptions);
		}

		legendComponent.filterSeriesNUpdate = function(d, i, chartObj) {
			if (!legData) { //If legend is disabled, legData will not be available
				legData = getLegendData(chartObj);
				legData_length = getLegendDataLength(chartObj, legData);
			}
			var clickeddata = legData[i];
			var disabledEle = legData.filter(function(d, j) {
				if (!states.allSelected && !states.isFirstClickAfterDeselection) {
					if (!isHiddenItem(d)) {
						d.disabled = !states.allSelected;
					}
					updateData(d, j, chartObj)
					legend_helpers.toggleChartEvents(chartObj, true);
					legend_helpers.fadeChart(true, chartObj, disabledOpacity);

					var tooltip = chartObj.eventHandler.tooltipElement;
					tooltip.hide(tooltip.element);
				}
				return d.disabled;
			});
			var isAlldisabled = (disabledEle.length == legData_length - 1) && !clickeddata.disabled;
			if (!isAlldisabled) {
				clickeddata.disabled = !clickeddata.disabled;
				if(chartObj.dataObject.hierarchical) {
	                chartObj.systemConf.seriesdata.chartdata[i].disabled = clickeddata.disabled;
	            }
				updateData(clickeddata, i, chartObj)
				chartObj.addRemoveSeries(clickeddata, 0, clickeddata.yaxiscolumnorder, (!states.allSelected && !states.isFirstClickAfterDeselection));
			}
			if (!states.allSelected && !states.isFirstClickAfterDeselection) {
				states.isFirstClickAfterDeselection = true;
			}
		};

		legendComponent.toggleItemNUpdateChart = function(ele, d, i, legendOptions) {
			var legendContainer = chartObj.legendarea.element;
			legendFilter = legendFilter || legendContainer.selectAll("div.legendfilterbox");
			selectAllFilter = selectAllFilter || legendContainer.selectAll("div.selectAll");

			if (legendOptions.filter.enabled) {
				legendComponent.filterSeriesNUpdate(d, i, chartObj);
				var filteredEle = d3_select(ele),
					fontClr = getClr(d.disabled, fontColor, itemDisabledOptions),
					txtDec;
				if (d.disabled) {
					legendComponent.highlightItem(ele, d, i, legendOptions, false, true); //Reset the hoverstyle for disabled series; strictApply=true
					if (itemDisabledOptions.strikeout) {
						txtDec = "line-through";
					}
				}

				filteredEle.selectAll(".legendlabel")
					.style({
						"color": fontClr,
						"text-decoration": txtDec
					});
				// update the colorBox
				$ZC.legend.setColorBoxBackground(legendFilter, chartObj, states);
				if (d3.event.touches == null) {
					defaultOnMouseOverFunc(ele, d, i);
				}
			}
			if (!states.allSelected) {
				states.allSelected = !states.allSelected;
			}
			if (!selectAllFilter.empty()) {
				selectAllFilter
					.html(isAllEnabled(legData, states.allSelected) ? colorBoxOptions.text || "&#10003;" : (itemDisabledOptions.colorBox || {}).text || "");
			}
		};

		legendComponent.highlightItem = function(ele, d, i, legendOptions, onLegHover, strictApply) {
			if (strictApply || !isDisabled(d, states.allSelected, states.isFirstClickAfterDeselection)) {
				if (legendOptions.itemHoverStyle) {
					var filteredEle = d3_select(ele);
					filteredEle.style("background-color", (onLegHover ? legendOptions.itemHoverStyle : legendOptions).backgroundColor);
					applyFont(filteredEle.selectAll("span"), (onLegHover ? priorityArrayOnhover : priorityArray), true);
				}
			}
		};

		legendComponent.highlightSeries = function(ele, d, i, legendOptions, chartObj, onLegHover) {
			chartObj.highlightContext = null;
			if (colorscale_helpers.isQuantileColorScale(chartObj)) {
				var highlightObj = chartObj.legendHighlight;
				var filterIndex = i;
				if (onLegHover) {
					if (!d.disabled) {
						chartObj.seriesdata.forEach(function(d, j) {
							highlightObj.highlightSelectedSeries(legendOptions, j, filterIndex);
							highlightObj.highlightUnselectedSeries(legendOptions, j, filterIndex);
						});
					}
				} else {
					chartObj.seriesdata.forEach(function(d, j) {
						highlightObj.reset(legendOptions, j, filterIndex, (chartObj.seriesdata.length-1 === j));
					});
				}
			} else {
				var highlightObj = chartObj.legendHighlight;
				if (onLegHover) {
					if (!d.disabled) {
						highlightObj.highlightSelectedSeries(legendOptions, i);
						highlightObj.highlightUnselectedSeries(legendOptions, i);
					}
				} else {
					highlightObj.reset(legendOptions, i);
				}
			}
		};
	};
})();
//$Id$
(function() {
	var getClr = legend_helpers.getClr,
		isDisabled = legend_helpers.isDisabled,
		hexToRGB = legend_helpers.hexToRGB;

	$ZC.legend.setColorBoxBackground = function(elements, chartObj, states) {
		var legendOptions = chartObj.systemConf.legend,
			colorBoxOptions = legendOptions.colorBox,
			itemDisabledOptions = legendOptions.itemDisabledStyle,
			disabledColorBoxOptions = itemDisabledOptions.colorBox || {},

			imagePallete = legendOptions.imagePallete ? $ZC.legutil.imagePallete.get(legendOptions.imagePallete) : null,
			useImagePallete = defined(imagePallete) && imagePallete.length > 0,
			patternPallete = chartObj.patternPallete,
			patternPalleteLength = patternPallete && patternPallete.length,
			useSVGImage = !chartObj.patternPallete && (defined(legendOptions.shapes) || colorBoxOptions.shape !== "square"),

			fontSize = +($ZC.utils.getVal((legendOptions.fontSize) || chartObj.systemConf.canvas.fontSize)),
			colorBoxSize = legend_helpers.getFilterBoxSize(colorBoxOptions, fontSize),
			colorBoxWidth = colorBoxSize[0],
			colorBoxHeight = colorBoxSize[1],

			background, border,
			backgroundColor, borerColor,
			borderRadius,
			backgroundSize = null,
			self, disabled;

		elements.each(function(d, i) {
			self = d3_select(this);
			disabled = isDisabled(d, states.allSelected, states.isFirstClickAfterDeselection);

			borerColor = getClr(disabled, pick(colorBoxOptions.strokeColor, getColorByIndex(chartObj, i)), itemDisabledOptions);
			background = backgroundColor = getClr(disabled, pick(colorBoxOptions.fillColor, getColorByIndex(chartObj, i)), itemDisabledOptions);
			borderRadius = colorBoxOptions.borderRadius;

			if (useImagePallete) {
				if (disabled) {
					background = pick(itemDisabledOptions.color, "silver");
				} else {
					background = "url(" + (imagePallete[i % imagePallete.length]) + ")";
					var patternSize = chartObj.patternImageSizes && chartObj.patternImageSizes;
					backgroundSize = patternSize[i] ? (patternSize[i % patternSize.length][0] + PX + " " + patternSize[i % patternSize.length][1] + PX) : null;
				}
			} else if (useSVGImage) {
				background = getsvgImage(colorBoxWidth, colorBoxHeight, borerColor, background, chartObj, i);
				borderRadius = null;
			} else if (patternPalleteLength) {
				var svgPattern = patternPallete[i % patternPalleteLength];
				var prop = patternThemes[svgPattern] ? patternThemes[svgPattern] : addPatternThemeByEle(svgPattern);
				prop.bgClr_base = backgroundColor
				prop.stroke_base = backgroundColor
				prop.width = colorBoxWidth
				var patternID = "zp" + generateIdByPropValue(prop, "legelegendndFill");
				var p = svg_patterns.svgPatternFill(prop, patternID, true, true, "objectBoundingBox");
				var patternWidth = p.width,
					patternHeight = p.height;
				background = "url(" + p.url + ")";
				backgroundSize = ((patternWidth * 2 < colorBoxWidth) ? patternWidth : (colorBoxWidth / 2)) + PX + " " + ((patternHeight * 2 < colorBoxHeight) ? patternHeight : (colorBoxHeight / 2)) + PX;
				border = colorBoxOptions.strokeWidth + PX + "solid " + borerColor;
			} else {
				border = colorBoxOptions.strokeWidth + PX + "solid " + borerColor;
			}
			self.style({
					"background": background,
					"background-size": backgroundSize,
					"color": disabled ? disabledColorBoxOptions.fontColor : colorBoxOptions.fontColor || "white",
					"border": border,
					"border-radius": defined(borderRadius) ? (borderRadius + PX) : null
				})
				.html(disabled ? disabledColorBoxOptions.text || "" : colorBoxOptions.text);
		})
	};

	function getsvgImage(width, height, strokeColor, fillColor, chartObj, index) { //SVG data uri as div background
		strokeColor = hexToRGB(strokeColor);
		fillColor = hexToRGB(fillColor);
		var legendOptions = chartObj.systemConf.legend,
			colorBoxOptions = legendOptions.colorBox,
			symbolsArray = legendOptions.shapes,
			symbol = (symbolsArray ? symbolsArray[index % symbolsArray.length] : null) || colorBoxOptions.shape;
		var xml = "<svg xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' width='" + width + "' height='" + height + "'>";
		xml += !symbol && $ZC.legend.getHTML4ChartTypeSymbol && !colorscale_helpers.isQuantileColorScale(chartObj) ?
			$ZC.legend.getHTML4ChartTypeSymbol(width, height, fillColor, chartObj, index) :
			getHTML4SVGSymbol(width, height, strokeColor, fillColor, symbol, colorBoxOptions);
		xml += " </svg>";
		return 'url("' + 'data:image/svg+xml;' + ($Browser.IE ? 'base64' : 'utf8') + ',' + ($Browser.IE ? btoa(xml) : xml) + '")';
	}

	function getHTML4SVGSymbol(width, height, strokeColor, fillColor, symbol, colorBoxOptions) {
		var symbolpath = getSVGsymbol(symbol || "square")(10);
		return "<path d='" + symbolpath + "' transform='translate(" + (width / 2) + "," + (height / 2) + ") scale(" + (width / (10 + (2 * validateNullVal(colorBoxOptions.strokeWidth, 1)))) + ")' style='stroke: " + hexToRGB(strokeColor) + "; fill: " + hexToRGB(fillColor) + "; fill-opacity: " + (colorBoxOptions.fillOpacity) + "; stroke-width: " + validateNullVal(colorBoxOptions.strokeWidth, 1) + "px; stroke-opacity: " + (colorBoxOptions.strokeOpacity) + ";'></path>";
	}
})();//$Id$
(function() {
	var hexToRGB = legend_helpers.hexToRGB;
	function getChartTypeSymbol(chartName) {
		return function(size) {
			switch (chartName) {
				case "bar":
				case "gantt":
				case "bullet":
					return "M" + (-size * 0.5) + " " + (size * 0.5) +
						" L" + (-size * 0.5) + " " + (-size * 0.2) +
						" L" + (-size * 0.25) + " " + (-size * 0.2) +
						" L" + (-size * 0.25) + " " + (size * 0.5) + "Z " +
						" M" + (-size * 0.125) + " " + (size * 0.5) +
						" L" + (-size * 0.125) + " " + (-size * 0.5) +
						" L" + (size * 0.125) + " " + (-size * 0.5) +
						" L" + (size * 0.125) + " " + (size * 0.5) + "Z " +
						" M" + (size * 0.25) + " " + (size * 0.5) +
						" L" + (size * 0.25) + " " + (size * 0.1) +
						" L" + (size * 0.5) + " " + (size * 0.1) +
						" L" + (size * 0.5) + " " + (size * 0.5) + "Z";
				case "area":
				case "arearange":
					return "M" + (-size * 0.5) + " " + (size * 0.5) +
						" L" + (-size * 0.5) + " " + (size * 0.28) +
						" L" + (-size * 0.24) + " " + (size * 0.08) +
						" L" + (-size * 0.13) + " " + (size * 0.19) +
						" L" + (size * 0.07) + " " + (-size * 0.14) +
						" L" + (size * 0.23) + " " + (size * 0.012) +
						" L" + (size * 0.5) + " " + (-size * 0.5) +
						" L" + (size * 0.5) + " " + (size * 0.5) + "Z";
				case "pie":
				case "bubblepie":
				case "sunburst":
					return "M" + (size * 0.045) + " " + (-size * 0.045) +
						" L" + (size * 0.5) + " " + (-size * 0.045) +
						" A " + (size * 0.455) + " " + (size * 0.455) + " 0 0 0 " + (size * 0.045) + " " + (-size * 0.5) + "Z" +
						" M" + (-size * 0.045) + " " + (size * 0.045) +
						" L" + (-size * 0.045) + " " + (-size * 0.41) +
						" A " + (size * 0.455) + " " + (size * 0.455) + " 1 1 0 " + (size * 0.41) + " " + (size * 0.045) + "Z";
				case "funnel":
					return "M" + (-size * 0.5) + " " + (-size * 0.5) +
						" L " + (size * 0.5) + " " + (-size * 0.5) +
						" L " + (size * 0.15) + " " + (size * 0.2) +
						" L " + (size * 0.15) + " " + (size * 0.5) +
						" L " + (-size * 0.15) + " " + (size * 0.5) +
						" L " + (-size * 0.15) + " " + (size * 0.2) + "Z";
				case "pyramid":
					return "M0 " + (-size * 0.5) +
						" L" + (size * 0.23) + " " + (-size * 0.06) +
						" L" + (-size * 0.23) + " " + (-size * 0.06) + "Z" +
						" M" + (-size * 0.5) + " " + (size * 0.5) +
						" L" + (size * 0.5) + " " + (size * 0.5) +
						" L" + (size * 0.27) + " 0" +
						" L" + (-size * 0.27) + " 0Z";
				case "line":
				case "web":
					return getSVGsymbol("line")(size);
				case "scatter":
				case "bubble":
				case "packedbubble":
				case "line":
				default:
					return getSVGsymbol(chartName)(size);
			}
		};
	}

	$ZC.legend.getHTML4ChartTypeSymbol = function(width, height, fillColor, chartObj, index) {
		var seriesIndex = chartObj.isAxisCategory || chartObj.dataObject.isPolarAxisCategory ? index : 0,
			chartName = chartObj.chartTypes[seriesIndex].name,
			commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions[chartName],
			plotOptions = chartObj.seriesdata[seriesIndex].plotoptions,
			symbolpath = getChartTypeSymbol(chartName)(width);

		switch (chartName) {
			case "line":
			case "web":
				var strokeWidth = height * 0.15,
					markerOptions = (plotOptions && plotOptions.marker) ? mergeJSON(commonPlotOptions.marker, plotOptions.marker, true) : commonPlotOptions.marker,
					dashProperties = getDashProperties(plotOptions, commonPlotOptions, strokeWidth),
					markerProperties = "";
				var styles = "stroke:" + fillColor + ";" +
					"stroke-width:" + strokeWidth + ";";

				if(dashProperties) {
					styles += dashProperties;
				} else if(markerOptions.enabled != false){
					var outerRatio = (chartName === "web") ? 0.5 : 0.65,
						innerRatio = (chartName === "web") ? 0.25 : 0.45;

					markerProperties = getMarkerProperties(markerOptions, width, height, fillColor, "outer", mathMin(width, height)  * outerRatio);
					markerProperties += getMarkerProperties(markerOptions, width, height, fillColor, "inner", mathMin(width, height)  * innerRatio);
				}

				return "<path d='" + symbolpath + "' transform='translate(" + (width / 2) + "," + (height / 2) + ")' style='" + styles + "'></path>"
					+ markerProperties;

			case "scatter":
			case "bubble":
				var markerOptions = (plotOptions && plotOptions.marker) ? mergeJSON(commonPlotOptions.marker, plotOptions.marker, true) : commonPlotOptions.marker;

				return getMarkerProperties(markerOptions, width, height, fillColor, "outer", mathMin(width, height)  * 0.65)
					+ getMarkerProperties(markerOptions, width, height, fillColor, "inner", mathMin(width, height)  * 0.45);
			case "packedbubble":
				return getMarkerProperties(commonPlotOptions, width, height, fillColor, null, mathMin(width, height) - (commonPlotOptions.strokeWidth || 1));			
			default:
				var styles = "fill:" + fillColor + ";";
				return "<path d='" + symbolpath + "' transform='translate(" + (width / 2) + "," + (height / 2) + ")' style='" + styles + "'></path>"
		}
	};

	function getDashProperties(plotOptions, commonPlotOptions, strokeWidth) {
		var dashStyle = getValByPriority([plotOptions, commonPlotOptions], "dashStyle"),
			dashArray = getDashArray(dashStyle, strokeWidth*0.75),
			styles;

		if (dashArray && dashArray.length) {
			var strokeLineCap = getLineCap(getValByPriority([plotOptions, commonPlotOptions], "lineCap"), dashStyle)
			styles = "stroke-dasharray:" + dashArray +";" +
				"stroke-linecap:" + strokeLineCap + ";";
		}

		return styles;
	}

	function getMarkerProperties(markerOptions, width, height, color, markerType, size) {
		var symbolpath = getChartTypeSymbol(markerOptions.symbol)(size);

		var styles = "stroke:" + hexToRGB(markerOptions[markerType ? markerType + "StrokeColor" : "strokeColor"] || color) + ";" +
			"stroke-width:" + markerOptions[markerType ? markerType + "StrokeWidth" : "strokeWidth"] + ";" + 
			"stroke-opacity:" + markerOptions[markerType ? markerType + "StrokeOpacity" : "strokeOpacity"] + ";" + 
			"fill:" + hexToRGB(markerOptions[markerType ? markerType + "FillColor" : "fillColor"] || color) + ";" +
			"fill-opacity:" + markerOptions[markerType ? markerType + "FillOpacity" : "fillOpacity"] + ";";

		return "<path d='" + symbolpath + "' transform='translate(" + (width / 2) + "," + (height / 2) + ")' style='" + styles + "'></path>"
	}

})();//$Id$
(function() {
    var defaultSelectAllOptions = {
        show: false,
        strokeColor: "#262626",
        strokeWidth: 1,
        fillColor: "transparent",
        fontColor: "#262626",
        disabledOpacity: 0.3,
        tooltip: {
            enabled: true,
            color: "red",
            content: "Select atleast one legend"
        },
        events: {
            click: null
        }
    };
    var getLegendData = legend_helpers.getLegendData,
        isDisabled = legend_helpers.isDisabled,
        isAllEnabled = legend_helpers.isAllEnabled,
        getClr = legend_helpers.getClr,
        toggleChartEvents = legend_helpers.toggleChartEvents,
        updateData = legend_helpers.updateData;

    $ZC.legend.selectAllBox = function(container, chartObj, states) {
        defaultSelectAllOptions.events.click = chartObj.legend.component.toggleSelectAll = toggleSelectAll;
        var legData = getLegendData(chartObj),

            legendOptions = chartObj.systemConf.legend,
            colorBox = legendOptions.colorBox,
            selectAllBoxOptions = mergeJSON(defaultSelectAllOptions, legendOptions.selectAllBox, true),
            itemDisabledOptions = legendOptions.itemDisabledStyle,
            disabledColorBox = itemDisabledOptions.colorBox || {},

            priorityArray = [legendOptions, chartObj.systemConf.canvas, $ZCG],
            fontSize = +($ZC.utils.getVal((legendOptions.fontSize) || chartObj.systemConf.canvas.fontSize)),
            fontColor = getValByPriority(priorityArray, "fontColor"),
            imagePallete = legendOptions.imagePallete ? $ZC.legutil.imagePallete.get(legendOptions.imagePallete) : null,

            colorBoxSize = legend_helpers.getFilterBoxSize(colorBox, fontSize),
            colorBoxWidth = colorBoxSize[0],
            colorBoxHeight = colorBoxSize[1],
            selectAllFilterSize = Math.min(colorBoxWidth, colorBoxHeight) - ((legendOptions.imagePallete || (!defined(legendOptions.shapes) || colorBox.shape === "square")) ? 0 : +colorBox.strokeWidth),

            svgNode = chartObj.container.node(),
            selectAllBoxTooltipOptions = selectAllBoxOptions.tooltip,
            disabledOpacity = selectAllBoxOptions.disabledOpacity,

            defaultTooltipColor,
            legendlabel,
            legendFilter;

        states.allSelected = defined(selectAllBoxOptions.selected) ? selectAllBoxOptions.selected : states.allSelected;

        var selectAllFilter = appendEle(container, "div", [1], ".", "class", "selectAll");
        selectAllFilter
            .style({
                "display": selectAllBoxOptions.show ? "inline-block" : "none",
                "width": selectAllFilterSize + "px",
                "height": selectAllFilterSize + "px",
                "border": selectAllBoxOptions.strokeWidth + "px solid " + selectAllBoxOptions.strokeColor,
                "background-color": selectAllBoxOptions.fillColor,
                "float": "left",
                "position": "absolute",
                "box-sizing": "border-box",
                "text-align": "center",
                "line-height": selectAllFilterSize + "px",
                "font-family": colorBox.fontFamily,
                "font-size": (colorBox.fontSize || (fontSize - 2)) + "px",
                "color": function(d) {
                    return selectAllBoxOptions.fontColor || (isDisabled(d, states.allSelected, states.isFirstClickAfterDeselection) ? disabledColorBox.fontColor : colorBox.fontColor);
                }
            })
            .html(isAllEnabled(legData, states.allSelected) ? (colorBox.text || "&#10003;") : (disabledColorBox.text || ""));

        container
            .style("cursor", selectAllBoxOptions.show ? "pointer" : null);

        var mouseHandlers = {
                "click": selectBoxClickFunction
            },
            touchHandlers = {
                "tap": selectBoxClickFunction
            };
        if (selectAllBoxOptions.show) {
            attachevents(container, mouseHandlers, touchHandlers);
        } else {
            detachevent(container, null, mouseHandlers);
            detachevent(container, null, touchHandlers);
        }

        if (chartObj.eventHandler) {
            var tooltip = chartObj.eventHandler.tooltipElement;
            tooltip.hide(tooltip.element);
        }

        return {
            element: selectAllFilter,
            options: selectAllBoxOptions,
            size: selectAllFilterSize
        };

        function selectBoxClickFunction() {
            if (!(states.allSelected && !isAllEnabled(legData, states.allSelected))) {
                states.allSelected = !states.allSelected;
            }
            states.isFirstClickAfterDeselection = false;
            selectAllFilter
                .html(states.allSelected ? colorBox.text || "&#10003;" : disabledColorBox.text || "");
            var userFunction = selectAllBoxOptions.events[chartObj.zcEventType || "click"];
            invokeFunction(userFunction, d3.event, states.allSelected, chartObj);
        }

        function toggleSelectAll() {
            filterAllAxesNUpdate();
            applyStyleToFilterAndLabel();
            toggleChartEvents(chartObj, states.allSelected);
            legend_helpers.fadeChart(states.allSelected, chartObj, disabledOpacity);

            if (selectAllBoxTooltipOptions.enabled) {
                var tooltip = chartObj.eventHandler.tooltipElement;
                if (!defaultTooltipColor) {
                    defaultTooltipColor = tooltip.element.selectAll("div#tooltipcontent").style("color");
                }
                var tooltip_data = chartObj.systemConf.tooltip;
                var tooltipBorderWidth = shorthand_px(defined(tooltip_data.borderWidth) ? tooltip_data.borderWidth : 1)
                if (!states.allSelected) {
                    var coordinate = getMousePosition(svgNode, d3.event);
                    coordinate = {
                        x: coordinate[0],
                        y: coordinate[1]
                    };
                    var evt = getEventObject(d3.event);
                    var position = getTooltipPosition(evt, coordinate, 0, 0, chartObj, {}, false, false, false, true, false);
                    var dLeft = coordinate.x - evt.clientX,
                        dTop = coordinate.y - evt.clientY;
                    position.dLeft = dLeft;
                    position.dTop = dTop;
                    position.helpers.color = selectAllBoxTooltipOptions.color;
                    position.helpers.backgroundColor = selectAllBoxTooltipOptions.backgroundColor;
                    position.helpers.borderColor = selectAllBoxTooltipOptions.borderColor;
                    applyTooltipStyle(tooltip, "center", null, (selectAllBoxTooltipOptions.fontColor || defaultTooltipColor));
                    tooltip.show(chartObj, position, selectAllBoxTooltipOptions.content, false, position.helpers);
                    setTimeout(function() {
                        var tooltip = chartObj.eventHandler.tooltipElement;
                        applyTooltipStyle(tooltip, null, tooltipBorderWidth, defaultTooltipColor);
                        tooltip.hide(tooltip.element);
                    }, 4000);
                } else {
                    var tooltip = chartObj.eventHandler.tooltipElement;
                    applyTooltipStyle(tooltip, null, tooltipBorderWidth, defaultTooltipColor);
                    tooltip.hide(tooltip.element);
                }
            }
        }

        function filterAllAxesNUpdate() {
            if (!legData) { //If legend is disabled, legData will not be available
                legData = getLegendData(chartObj);
            }
            if (states.allSelected) {
                legData.forEach(function(d, j) {
                    d.disabled = !states.allSelected;
                    updateData(d, j, chartObj);
                });
                chartObj.addRemoveSeries(legData, 0, [0, 0], true);
            }
        }

        function applyStyleToFilterAndLabel() {
            if (!legendFilter) {
                var legendContainer = chartObj.legendarea.element;
                legendFilter = legendContainer.selectAll("div.legendfilterbox");
                legendlabel = legendContainer.selectAll("span.legendlabel");
            }

            $ZC.legend.setColorBoxBackground(legendFilter, chartObj, states);
            var fontClr, txtDec;
            if (states.allSelected) {
                fontClr = fontColor,
                    txtDec = null;
            } else {
                fontClr = getClr(true, fontColor, itemDisabledOptions),
                    txtDec = (JSON.parse(itemDisabledOptions.strikeout) ? "line-through" : null);
            }
            legendlabel
                .style({
                    "color": fontClr,
                    "text-decoration": txtDec
                });
        }

        function applyTooltipStyle(tooltip, align, borderWidth, contentColor) {
            tooltip.element
                .attr("align", align)
                .style({
                    "border-width": borderWidth
                });
            tooltip.element.selectAll("div#tooltipcontent")
                .style("color", contentColor);
        }
    }
})();//$Id$
(function() {
    $ZC.legend.continuous = function(){};
    $ZC.legend.continuous.get = function() {
        "use strict";
        var dispatch = d3_dispatch('legendClick', 'legendDblclick', 'legendMouseover', 'legendMouseout'),
            chartObj,
            systemConf,
            color,
            chartarea,

            getLegendData = legend_helpers.getLegendData,
            getLegendDataLength = legend_helpers.getLegendDataLength;

        function chart(selection) {
            selection.each(function(data) {
                var legData = getLegendData(chartObj),
                    legData_length = getLegendDataLength(chartObj, legData),
                    legendOptions = chartObj.systemConf.legend,
                    colorbandOptions = legendOptions.colorBand,
                    colorAxisOptions = getColorAxisOptions(legendOptions),

                    hAlign = data.hAlign,
                    vAlign = data.vAlign,

                    strokeWidth = validateNullVal(colorbandOptions.strokeWidth, 1) / 2,
                    padding = getParsedValue(colorbandOptions.padding),
                    hideAxis = colorAxisOptions.show === false,

                    container = d3_select(this),
                    legBBox;

                var background = appendEle(container, "path", [1], ".", "class", "zchart-background");
                var title = appendEle(container, "g", [1], ".", "class", "zcheader");
                var bandGroup = appendEle(container, "path", [1], ".", "class", "colorband");
                var axisGroup = appendEle(container, "g", (hideAxis ? [] : [1]), ".", "class", "legend-axis");
                background.style("display", "none");//important
                container.selectAll(".brush").style("display", "none");//important REFER: legend-colorband-right-redraw

                drawTitle(title, systemConf);
                $ZC.legend.colorBand(bandGroup, chartObj);
                $ZC.legend.colorAxis(axisGroup, chartObj, colorAxisOptions);

                var axisGroupTranslate = hideAxis ? [0, 0] : d3.transform(axisGroup.attr("transform")).translate;
                var info = translateGroupsNgetInfo(axisGroup, bandGroup, title, chartObj, colorAxisOptions, hAlign, vAlign, axisGroupTranslate, strokeWidth);

                var position = getLegendPosition();

                if (!hideAxis) {
                    $ZC.legend.colorAxis.handleOverlapNOverlap(axisGroup, info.axisGroupPosition, position, chartObj, chartarea);
                    info = translateGroupsNgetInfo(axisGroup, bandGroup, title, chartObj, colorAxisOptions, hAlign, vAlign, axisGroupTranslate, strokeWidth);
                    position = getLegendPosition();
                }

                container.selectAll(".brush").style("display", null);//important
                var legendBrushObj = new legendBrush(chartObj, {position: info.bandGroupPosition});
                position = getLegendPosition();

                container
                    .attr("transform", "translate(" + position[0] + "," + position[1] + ")");

                legBBox = bbox(container.node());
                drawBackground(background, chartObj, legBBox);
                background.style("display", null);//important

                //Filter effects
                if(chartObj.filterEffectsID){
                    container.style("filter" , chartObj.filterEffectsID ? "url(#"+chartObj.filterEffectsID+")" : null);
                }

                function getLegendPosition() {
                    legBBox = bbox(container.node());
                    var legwid = legBBox.width,
                        floating = defined(legendOptions.x) && defined(legendOptions.y),
                        x, y;

                    if (floating) {
                        return [legendOptions.x - legBBox.x + padding.left, legendOptions.y - legBBox.y + padding.top];
                    }

                    if (vAlign != "center") {
                        if (hAlign == "right") {
                            x = chartarea.left + chartarea.width - legwid - data.marginRight - legBBox.x - padding.right;
                        } else if (hAlign == "left") {
                            x = chartarea.left + data.marginLeft + padding.left - legBBox.x;
                        } else {
                            x = chartarea.width / 2 - legwid / 2;
                        }

                        if (vAlign === "top") {
                            y = chartarea.top + padding.top + data.marginTop - legBBox.y;
                        } else {
                            y = chartarea.top + chartarea.height - padding.bottom - data.marginBottom - legBBox.height - legBBox.y;
                        }
                    } else {
                        if (hAlign == "right") {
                            x = chartarea.left + chartarea.width - legwid - data.marginRight - legBBox.x - padding.right;
                        } else {
                            x = chartarea.left + data.marginLeft + padding.left - legBBox.x;
                        }

                        y = chartarea.top + data.marginTop + padding.top - legBBox.y;
                    }
                    return [x, y];
                }

            });
            return chart;
        }
        
        chart.dispatch = dispatch;

        chart.chartarea = function(_) {
            if (!arguments.length) {
                return chartarea;
            }
            chartarea = _;
            return chart;
        };

        chart.systemconf = function(_) {
            if (!arguments.length) {
                return systemConf;
            }
            systemConf = _;
            return chart;
        };

        chart.chartObj = function(_) {
            if (!arguments.length) {
                return chartObj;
            }
            chartObj = _;
            return chart;
        };

        chart.color = function(_) {
            if (!arguments.length) {
                return color;
            }
            color = _;
            return chart;
        };

        return chart;
    };

    function drawTitle(element, systemConf) {
        var titleOptions = systemConf.legend.title;

        var title = appendEle(element, "text", titleOptions.show ? [1] : [], ".", "class", "legendtitle");
        applyFont(element, [titleOptions, systemConf.canvas, $ZCG]);
        title
            .text(decodeHTML(titleOptions.text))
            .attr("dy", "0.91em");

    }

    function drawBackground(element, chartObj, legBBox) {
        var legendOptions = chartObj.systemConf.legend,
            backgroundOptions = legendOptions.background,

            colorBandOptions = legendOptions.colorBand,
            padding = getParsedValue(colorBandOptions.padding),

            borderOptions = legendOptions.border,
            showBorder = borderOptions.show,
            strokeWidth = pick(borderOptions.strokeWidth, 1),
            strokeDashArray = getDashArray(borderOptions.style, strokeWidth),
            strokeLineCap = getLineCap(borderOptions.lineCap, borderOptions.style),
            borderRadius = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, (showBorder ? borderOptions.radius : undefined));

        element
            .attr({
                "d": roundedRect(legBBox.x - padding.left, legBBox.y - padding.top, legBBox.width + padding.left + padding.right, legBBox.height + padding.top + padding.bottom, borderRadius)
            })
            .style({
                "stroke": borderOptions.color,
                "stroke-width": showBorder ? borderOptions.size : 0,
                "stroke-dasharray": strokeDashArray,
                "stroke-linecap": strokeLineCap,
                "fill": backgroundOptions.color || "transparent",
                "fill-opacity": backgroundOptions.alpha
            });
            //shadow
    }

    function updatePositionByStrokeWidth(orient, strokeWidth, bandGroupPosition, axisGroupPosition) {
        if (orient === "top") {
            bandGroupPosition[1] += strokeWidth;
        } else if (orient === "bottom") {
            axisGroupPosition[1] += strokeWidth;
        } else if (orient === "left") {
            bandGroupPosition[0] += strokeWidth;
        } else {
            axisGroupPosition[0] += strokeWidth;
        }
    }

    function getAxisGroupBBox(orient, axisGroup) {
        var selection = axisGroup.selectAll("g.zchart-minmaxlabels,line.majorTicks");
        selection.style("display", "none");
        var axisGroupBBox = simpleClone(bbox(axisGroup.node()));

        selection.style("display", null);

        return axisGroupBBox;
    }

    function getBandGroupPosition(systemConf, minmaxlabelsOptions, orient, hAlign, vAlign, axisGroupBBox, titleBBox, minmaxlabelsBBox) {
        var align = minmaxlabelsOptions.align;
        var bandGroupPosition = [];

        // get x position
        if (orient === "left") {
            if (align === "right") {
                bandGroupPosition[0] = axisGroupBBox.width;
            } else if (align === "left") {
                bandGroupPosition[0] = mathMax(axisGroupBBox.width, minmaxlabelsBBox.width);
            } else {
                bandGroupPosition[0] = mathMax(axisGroupBBox.width, minmaxlabelsBBox.width/2);
            }
        } else if (orient === "right") {
            if (align === "right") {
                bandGroupPosition[0] = 0;
            } else if (align === "left") {
                bandGroupPosition[0] = minmaxlabelsBBox.width;
            } else {
                bandGroupPosition[0] = minmaxlabelsBBox.width/2;
            }
        } else {
            if (align === "top" || align === "bottom") {
                bandGroupPosition[0] = 0;
            } else {
                bandGroupPosition[0] = - minmaxlabelsBBox.x;
            }
        }

        // get y position
        bandGroupPosition[1] = titleBBox.height + getTitleMargin(systemConf);
        if (orient === "left" || orient === "right") {
            bandGroupPosition[1] -= mathMin(0, minmaxlabelsBBox.y);
        } else if (orient === "bottom" && align === "top") {
            bandGroupPosition[1] += minmaxlabelsBBox.height;
        }
        if (vAlign === "top") {
            bandGroupPosition[1] += axisGroupBBox.height;
        }
        return bandGroupPosition;
    }

    function getAxisGroupPosition(systemConf, colorAxisOptions, orient, hAlign, vAlign, axisGroupBBox, titleBBox, minmaxlabelsBBox, axisGroupTranslate) {
        var minmaxlabelsOptions = colorAxisOptions.minmaxlabels,
            align = minmaxlabelsOptions.align;
        var axisGroupPosition = [];

        // get x position
        if (orient === "left") {
            if (align === "right") {
                axisGroupPosition[0] = axisGroupBBox.width;
            } else if (align === "left") {
                axisGroupPosition[0] = mathMax(axisGroupBBox.width, minmaxlabelsBBox.width);
            } else {
                axisGroupPosition[0] = mathMax(axisGroupBBox.width, minmaxlabelsBBox.width/2);
            }
        } else if (orient === "right") {
            if (align === "right") {
                axisGroupPosition[0] = axisGroupTranslate[0];
            } else if (align === "left") {
                axisGroupPosition[0] = axisGroupTranslate[0] + minmaxlabelsBBox.width;
            } else {
                axisGroupPosition[0] = axisGroupTranslate[0] + minmaxlabelsBBox.width/2;
            }
        } else {
            if (align === "top" || align === "bottom") {
                axisGroupPosition[0] = axisGroupTranslate[0];
            } else {
                axisGroupPosition[0] = axisGroupTranslate[0] - minmaxlabelsBBox.x;
            }
        }

        // get y position
        axisGroupPosition[1] = titleBBox.height + getTitleMargin(systemConf);
        if (orient === "left" || orient === "right") {
            axisGroupPosition[1] -= mathMin(0, minmaxlabelsBBox.y);
        } else if (orient === "bottom" && align === "top") {
            axisGroupPosition[1] += minmaxlabelsBBox.height;
        }

        if (orient === "top") { //#ZC844
            axisGroupPosition[1] += axisGroupBBox.height;
        } else {
            axisGroupPosition[1] += axisGroupTranslate[1];
        }

        axisGroupPosition = updateAxisPositionByAxisline(axisGroupPosition, colorAxisOptions.axisline, orient);

        return axisGroupPosition;
    }

    function updateAxisPositionByAxisline(axisGroupPosition, axislineOptions, orient) {
        if (!axislineOptions.show) {
            var strokeWidth = validateNullVal(axislineOptions.strokeWidth, 1),
                adjust = strokeWidth / 2;

            if (orient === "left") {
                axisGroupPosition[0] += adjust;
            } else if (orient === "right") {
                axisGroupPosition[0] -= adjust;
            } else if (orient === "bottom") {
                axisGroupPosition[1] -= adjust;
            } else {
                axisGroupPosition[1] += adjust;
            }
        }
        return axisGroupPosition;
    }

    function getTitleMargin(systemConf) {
        var titleOptions = systemConf.legend.title;
        if (titleOptions.show) {
            return defined(titleOptions.margin) ? titleOptions.margin : 3;
        }
        return 0;
    }

    function getParsedValue(padding) {
        var t, r, b, l;
        if (defined(padding)) {
            var parsedPadding = padding.toString().split(" "),
                priorityBasedValue = $ZC.DataProcessor.helpers.priorityBasedValue;

            t = pInt(priorityBasedValue([parsedPadding[0], 0]));
            r = pInt(priorityBasedValue([parsedPadding[1], parsedPadding[0], 0]));
            b = pInt(priorityBasedValue([parsedPadding[2], parsedPadding[0], 0]));
            l = pInt(priorityBasedValue([parsedPadding[3], parsedPadding[1], parsedPadding[0], 0]));
        } else {
            t = 0;
            r = 0;
            b = 0;
            l = 0;
        }

        return {
            top: t,
            right: r,
            bottom: b,
            left: l
        };
    }

    function getColorAxisOptions(legendOptions) {
        var defaultColorAxisOptions = {
            "label": {},
            "grid": {
                color: "transparent"
            },
            "ticklabel": {
                fontColor: legendOptions.fontColor,
                fontFamily: legendOptions.fontFamily,
                fontSize: legendOptions.fontSize,
                fontStyle: legendOptions.fontStyle,
                fontWeight: legendOptions.fontWeight,
                // marginBottom: 5,
                // marginLeft: 5,
                // marginRight: 5,
                // marginTop: 5,
                // maxHeight : "",
                // maxWidth : "",
                // rotation: 0,
                // textOverflow: "ellipsis",
                tooltip: legendOptions.tooltip
            },
            "minmaxlabels": { //excludeIntervals, show, padding, align, text, fontProperties
                padding: 2,
                align: "center",
                fontSize: legendOptions.fontSize
            },
            "tickmark": {
                color: "#B0B0B0",
                size: 3
            },
            "axisline": {
                show: false
            }
        };
        var colorAxisOptions = legendOptions.colorAxis || {};
        colorAxisOptions = mergeJSON(defaultColorAxisOptions, colorAxisOptions, true);
        return colorAxisOptions;
    }

    function translateGroupsNgetInfo(axisGroup, bandGroup, title, chartObj, colorAxisOptions, hAlign, vAlign, axisGroupTranslate, strokeWidth) {
        var systemConf = chartObj.systemConf,
            titleBBox = bbox(title.node()),
            orient = legend_helpers.getOrient(chartObj.systemConf.legend),
            axisGroupBBox = getAxisGroupBBox(orient, axisGroup),
            minmaxlabelsBBox = bbox(axisGroup.selectAll("g.zchart-minmaxlabels").node()),
            bandGroupPosition = getBandGroupPosition(systemConf, colorAxisOptions.minmaxlabels, orient, hAlign, vAlign, axisGroupBBox, titleBBox, minmaxlabelsBBox),
            axisGroupPosition = getAxisGroupPosition(systemConf, colorAxisOptions, orient, hAlign, vAlign, axisGroupBBox, titleBBox, minmaxlabelsBBox, axisGroupTranslate);

        updatePositionByStrokeWidth(orient, strokeWidth, bandGroupPosition, axisGroupPosition); //update position based on strokeWidth

        bandGroup.attr("transform", "translate(" + bandGroupPosition[0] + "," + bandGroupPosition[1] + ")");
        axisGroup.attr("transform", "translate(" + axisGroupPosition[0] + "," + axisGroupPosition[1] + ")");

        return {
            axisGroupPosition: axisGroupPosition,
            bandGroupPosition: bandGroupPosition
        }
    }

})();
//$Id$
$ZC.legend.colorBand = function(element, chartObj) {
	//color band
	var legendOptions = chartObj.systemConf.legend,
		colorbandOptions = legendOptions.colorBand,

		dimension = legend_helpers.getColorBandDimension(chartObj),
		width = dimension[0],
		height = dimension[1],

		isHorizontal = (legendOptions.vAlign === "bottom" || legendOptions.vAlign === "top"),
		userRanges_length = colorbandOptions.ranges && colorbandOptions.ranges.length,

		borderRadius = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, colorbandOptions.borderRadius);

	var scale = chartObj.axes.clr.scale,
		scale_domain,
		scale_range,
		offsetScale;
		if (userRanges_length) {
			scale_range = scale.range().filter(function(d){ return d !== null;});
				var temp_domain = [], temp_range = [];
				for(var i=0; i<userRanges_length; i++){
					temp_domain.push(i, i+1);
					temp_range.push(scale_range[i], scale_range[i]);
				}
				scale_domain = temp_domain;
				scale_range = temp_range;

			offsetScale = d3_scaleOrdinal()
				.domain(scale_domain)
				.rangePoints([0, 100]);
		} else {
			scale_domain = scale.domain();
			scale_range = scale.range();

            if (scale_domain[0] === scale_domain[1]) { //Test_696.json
                scale_range = [scale_range[0], scale_range[0]];
            }

			offsetScale = d3_scaleLinear()
				.domain([scale_domain[0], scale_domain[scale_domain.length - 1]])
				.range([0, 100]);
		}

	var gradientOptions = {
			"type": "linear",
			"options": {
				"linear": {
					"x2": isHorizontal ? 100 : 0,
					"y1": isHorizontal ? 0 : 100,
					"gradientUnits": "objectBoundingBox",
					"stopColor": scale_range,
					"stopOffset": scale_domain.map(function(d) {
						return offsetScale(d) + "%";
					})
				}
			}
		},
		gradientDim = [0, width],

		prop = getGradientProp(gradientOptions, gradientDim),
		args = {
			"chartObj": chartObj
		},
		gradientEle = effects.get(svg_gradients, "svgGradientFill", prop, args);

	element
		.attr("d", roundedRect(0, 0, width, height, borderRadius))
		.style({
			"stroke": colorbandOptions.strokeColor,
			"stroke-opacity": colorbandOptions.strokeOpacity,
			"stroke-width": colorbandOptions.strokeWidth,
			"fill-opacity": colorbandOptions.fillOpacity,
			"fill": "url(" + chartObj.defsLocation + "#" + gradientEle + ")"
		});
};//$Id$
(function() {
	$ZC.legend.colorAxis = function(element, chartObj, colorAxisOptions) {
		var legendOptions = chartObj.systemConf.legend,
			colorbandOptions = legendOptions.colorBand,
			minmaxlabelsOptions = colorAxisOptions.minmaxlabels,

			dimension = legend_helpers.getColorBandDimension(chartObj),
			width = dimension[0],
			height = dimension[1],

			mode = colorbandOptions.type,
			orient = legend_helpers.getOrient(legendOptions),

			//Formatter
			columnInfo = chartObj.dataset.getColumn("clr"),
			datatype = columnInfo.datatype,
			formatConf = columnInfo[datatype],
			arraySeperator = "-",

			axisComp = $ZC.axis.get(),
			scale = chartObj.axes.clr.scale,
			scale_domain = scale.domain(),
            tickValues = minmaxlabelsOptions.show && minmaxlabelsOptions.excludeIntervals ? [] : scale_domain,
			range = (orient === "bottom" || orient === "top") ? [0, width] : [height, 0],

			align = (minmaxlabelsOptions.show && minmaxlabelsOptions.excludeIntervals && orient === "top") ? [0, 0] : (orient === "bottom" || orient === "top") ? [0, height] : [width, 0], //Test_692.json
			isDiscrete = colorbandOptions.ranges && colorbandOptions.ranges.length,
            userLabels = colorbandOptions.labels,
			posScale;

            chartObj.axes.clr.ticks = $ZC.axis.ticks(chartObj, colorAxisOptions, "clr", 0, orient, chartObj.chartarea); //dummy axisComp needs this

		if (isDiscrete) {
			scale_domain = getRawRanges(chartObj);
			var isOrdinal = chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE;
			if (mode === "continuous" && !isOrdinal) {
				scale_domain = d3_merge(scale_domain);
				if (colorbandOptions.minRange !== scale_domain[0]) {
					scale_domain.splice(0, 0, colorbandOptions.minRange);
				}

				posScale = d3_scaleOrdinal()
					.domain(scale_domain)
					.rangePoints(range, 0, 0);
			} else {
				posScale = d3_scaleOrdinal()
					.domain(scale_domain)
					.rangeBands(range, 0, 0);
			}
		} else {
            if (tickValues[0] === tickValues[1]) { //Test_694.json
                var rangeDiff = mathAbs(range[0] - range[1]);
                range = [rangeDiff / 2, rangeDiff / 2];
            }

			posScale = d3_scaleLinear()
				.domain([scale_domain[0], scale_domain[scale_domain.length - 1]])
				.range(range);
		}

        tickValues = minmaxlabelsOptions.show && minmaxlabelsOptions.excludeIntervals ? [] : scale_domain;

		axisComp
			.scale(posScale)
			.tickSize(validateNullVal(colorAxisOptions.tickmark.size, 6), 0)
			.majorTicks(getMajorTicks(orient, width, height))
			.orient(orient)
			.systemconf(chartObj.systemConf)
			.chartObj(chartObj)
			.tickValues(tickValues)
			.tickFormat(function(d, i) {
                if (userLabels && userLabels.length) {
                    var labelIndex = legend_helpers.getLabelIndex(d, colorbandOptions);
                    if (defined(labelIndex)) {
                        return userLabels[labelIndex];
                    }
                }
                return getFormattedValue(formatConf, d, datatype, chartObj, "legend", null, arraySeperator);
            });

		element
			.datum(colorAxisOptions)
			.attr("transform", "translate(" + align[0] + "," + align[1] + ")")
			.call(axisComp, "clr");

		element.selectAll("g.tick")
			.style("display", null); //important on redraw

        applyAxislineProperties(element, colorAxisOptions.axisline);

		element
			.call(ZC_legend_minmaxLabels, dimension, colorAxisOptions, chartObj, orient);
	};

    function getMajorTicks(orient, w, h) {
        if (orient == "bottom") {
            return [0, -h]
        } else if (orient == "top") {
            return [0, h]
        } else if (orient == "left") {
            return [w, 0]
        } else if (orient == "right") {
            return [-w, 0]
        }
    }

    $ZC.legend.colorAxis.handleOverlapNOverlap = function (axisGroup, axisGroupPosition, position, chartObj, chartarea) {
        var minmaxlabels = axisGroup.selectAll("g.zchart-minmaxlabels").selectAll("text"),
            ticklabels = axisGroup.selectAll("g.tick").selectAll("text"),

            minmaxlabelsBoundArray = handleOverflowNGetBound(minmaxlabels, axisGroupPosition, position, chartObj, chartarea);

        handleOverlap(ticklabels, axisGroupPosition, position, minmaxlabelsBoundArray);
    }

    function handleOverflowNGetBound(minmaxlabels, axisGroupPosition, position, chartObj, chartarea) {
    	var legendOptions = chartObj.systemConf.legend,
            orient = legend_helpers.getOrient(legendOptions),

    		minmaxlabelsBoundArray = [],
    		bound = getAvailableLegendBound(chartObj, chartarea),
            edge = {
	            "left": bound.x1,
	            "top": bound.y1,
	            "right": bound.x2,
	            "bottom": bound.y2
	        },
	        margin = {
	            "left": 5,
	            "right": 5,
	            "top": 5,
	            "bottom": 5
	        },
	        pattern = "..";

        minmaxlabels
        .each(function(d, i) {
            var pos = getMinmaxLabelBound(this, axisGroupPosition, position);

            var textBound = {
                "left": pos.x1,
                "top": pos.y1,
                "width": pos.width,
                "height": pos.height
            };
            trimText(this, this.textContent, textBound, edge, "bottom", pattern, margin);
            if (this.textContent === pattern) {
                d3_select(this).text("");
            }
            minmaxlabelsBoundArray[i] = getMinmaxLabelBound(this, axisGroupPosition, position);
        });

        if (orient === "bottom" || orient === "top") {
            if (minmaxlabelsBoundArray.length && doOverlap(minmaxlabelsBoundArray[0], minmaxlabelsBoundArray[1])) {
                var bandWidth = minmaxlabelsBoundArray[1].x2 - minmaxlabelsBoundArray[0].x1;
                minmaxlabels
                    .each(function(d, i) {
                        var pos = getMinmaxLabelBound(this, axisGroupPosition, position);
                        var textBound = {
                            "left": pos.x1,
                            "top": pos.y1,
                            "width": pos.width,
                            "height": pos.height
                        };
                        var e = simpleClone(edge);
                        if (i === 0) {
                            e.right = pos.x1 + bandWidth / 2;//need to change
                        } else {
                            e.left = pos.x2 - bandWidth / 2;//need to change
                        }

                        trimText(this, this.textContent, textBound, e, "bottom", pattern, margin);
                        if (this.textContent === pattern) {
                            d3_select(this).text("");
                        }
                        minmaxlabelsBoundArray[i] = getMinmaxLabelBound(this, axisGroupPosition, position);
                    });
            }
        }

        return minmaxlabelsBoundArray
    }

    function getMinmaxLabelBound(element, axisGroupPosition, position, parentPos) {
        parentPos = parentPos || [0, 0];
        var bb = bbox(element);
        var pos = {
            x1: bb.x + axisGroupPosition[0] + position[0] + parentPos[0],
            y1: bb.y + axisGroupPosition[1] + position[1] + parentPos[1],
            width: bb.width,
            height: bb.height
        };
        pos.x2 = pos.x1 + bb.width;
        pos.y2 = pos.y1 + bb.height;
        return pos;
    }

    function handleOverlap(ticklabels, axisGroupPosition, position, minmaxlabelsBoundArray) {
    	var ticklabelsBoundArray = [];
        var count = 0;
        ticklabels
        .each(function() {
            var parentPos = d3_transform(d3_select(this.parentNode).attr("transform")).translate;
            ticklabelsBoundArray.push(getMinmaxLabelBound(this, axisGroupPosition, position, parentPos));
            var overlap;

            for (var index = count - 1; index >= 0 && !overlap; index--) {
                overlap = doOverlap(ticklabelsBoundArray[index], ticklabelsBoundArray[count]);
            }
            if ((minmaxlabelsBoundArray.length ? (doOverlap(ticklabelsBoundArray[count], minmaxlabelsBoundArray[0]) || doOverlap(ticklabelsBoundArray[count], minmaxlabelsBoundArray[1])) : false) || overlap) {
                d3_select(this.parentNode).style("display", "none");
                ticklabelsBoundArray[count] = {
                    x1: 0,
                    y1: 0,
                    x2: 0,
                    y2: 0
                };
            }
            count ++;
        });
    }

    function getAvailableLegendBound(chartObj, chartarea) {
        var legendOptions = chartObj.systemConf.legend,
            orient = legend_helpers.getOrient(legendOptions),

            hAlign = legendOptions.hAlign,
            vAlign = legendOptions.vAlign,

            w = chartarea.width - legendOptions.marginLeft - legendOptions.marginRight,
            h = chartarea.height - legendOptions.marginTop - legendOptions.marginBottom,
            l = chartarea.left + legendOptions.marginLeft,
            t = chartarea.top + legendOptions.marginTop,

            widthRatio = (orient === "top" || orient === "bottom") ? ZC_LEGEND_maxWidthHoriRatio : ZC_LEGEND_maxWidthVertRatio,
            heightRatio = (orient === "top" || orient === "bottom") ? ZC_LEGEND_maxHeightHoriRatio : ZC_LEGEND_maxHeightVertRatio,

            maxWidth = perToPx(legendOptions.maxWidth || widthRatio, w),
            maxHeight = perToPx(legendOptions.maxHeight || heightRatio, h),

            bound = {};

        if (orient === "bottom") {
            bound.y1 = t + h - maxHeight;
            if (hAlign === "left") {
                bound.x1 = l;
            } else if (hAlign === "right") {
                bound.x1 = l + w - maxWidth;
            } else {
                bound.x1 = l + (w - maxWidth) / 2;
            }
        } else if (orient === "top") {
            bound.y1 = t;
            if (hAlign === "left") {
                bound.x1 = l;
            } else if (hAlign === "right") {
                bound.x1 = l + w - maxWidth;
            } else {
                bound.x1 = l + (w - maxWidth) / 2;
            }
        } else if (orient === "right") {
            bound.y1 = t;
            bound.x1 = l + w - maxWidth;
        } else {
            bound.y1 = t;
            bound.x1 = l;
        }

        bound.x2 = bound.x1 + maxWidth;
        bound.y2 = bound.y1 + maxHeight;
        return bound;
    }

    function applyAxislineProperties(container, axislineOptions) {
        var element = container.selectAll("path.domain");
        if (!axislineOptions.show) {
            element.remove();
        }
    }

})();//$Id$
var $ZC_legend_minmaxLabels;
(function() {
	ZC_legend_minmaxLabels = function (element, dimension, axisOptions, chartObj, orient) {
    	var systemConf = chartObj.systemConf,
    		minmaxlabelsOptions = axisOptions.minmaxlabels,
            legendOptions = chartObj.systemConf.legend,
            colorbandOptions = legendOptions.colorBand,
            sliderSize = legendOptions.filter.enabled ? getSliderSize(ZC_brushComponent_getSliderOptions(dimension, legendOptions.filter)) : [0, 0],

    		padding = validateNullVal(minmaxlabelsOptions.padding, 2),
    		align = minmaxlabelsOptions.align,
            userLabels = minmaxlabelsOptions.text,

            isDiscrete = colorbandOptions.ranges && colorbandOptions.ranges.length,
            data = [],

            //Formatter
            columnInfo = chartObj.dataset.getColumn("clr"),
            datatype = columnInfo.datatype,
            formatConf = columnInfo[datatype];

        if (minmaxlabelsOptions.show) {
            if (isDiscrete) {
                var isOrdinal = chartObj.dataset.getDataType("clr") === ORDINAL_DATATYPE,
                    ranges = getRawRanges(chartObj);

                data = [ranges[0][0], ranges[ranges.length - 1][defined(ranges[ranges.length - 1][0]) ? 0 : 1]];
            } else {
                var scale_domain = chartObj.axes.clr.scale.domain();
                data = [scale_domain[0], scale_domain[scale_domain.length - 1]];
            }
        }

    	var labelGroup = appendEle(element, "g", [1], ".", "class", "zchart-minmaxlabels");
    	var labels = appendEle(labelGroup, "text", data);

    	labels
    		.each(function(d,i) {
    			var pos = getPositionInfo(orient, dimension, align, padding, sliderSize, i);
    			d3_select(this)
    				.attr({
    					"x": pos.x,
    					"y": pos.y,
    					"text-anchor": pos.anchor,
    					"dy": pos.dy
    				})
    				.text(userLabels ? userLabels[i] : getFormattedValue(formatConf, d, datatype, chartObj, "minmaxlabels"));
    		});
    	applyFont(labels, [minmaxlabelsOptions, systemConf.chart, systemConf.canvas, $ZCG]);
    }

    function getPositionInfo(orient, dimension, align, padding, sliderSize, i) {
    	var x, y, dy, ANCHOR;
    	if (orient === "bottom") {
    		if (align === "top") {
    			dy = "-0.3em";
    			ANCHOR = (i === 0) ? null : "end";
    			y = -dimension[1] - padding - mathMax(0, (sliderSize[1] - dimension[1]) / 2);
    			if (i === 0) {
    				x = 0;
    			} else {
    				x = dimension[0];
    			}
    		} else if (align === "bottom") {
    			dy = "1em";
    			ANCHOR = (i === 0) ? null : "end";
    			y = padding + mathMax(0, (sliderSize[1] - dimension[1]) / 2);
    			if (i === 0) {
    				x = 0;
    			} else {
    				x = dimension[0];
    			}
    		} else {
    			dy = "0.3em";
    			ANCHOR = (i === 0) ? "end" : null;
    			y = -dimension[1] / 2;
    			if (i === 0) {
    				x = -padding - sliderSize[0] / 2;
    			} else {
    				x = dimension[0] + padding + sliderSize[0] / 2;
    			}
    		}
    	} else if (orient === "top") {
    		if (align === "top") {
    			dy = "-0.3em";
    			ANCHOR = (i === 0) ? null : "end";
    			y =  - padding - mathMax(0, (sliderSize[1] - dimension[1]) / 2);
    			if (i === 0) {
    				x = 0;
    			} else {
    				x = dimension[0];
    			}
    		} else if (align === "bottom") {
    			dy = "1em";
    			ANCHOR = (i === 0) ? null : "end";
    			y = dimension[1] + padding + mathMax(0, (sliderSize[1] - dimension[1]) / 2);
    			if (i === 0) {
    				x = 0;
    			} else {
    				x = dimension[0];
    			}
    		} else {
    			dy = "0.3em";
    			ANCHOR = (i === 0) ? "end" : null;
    			y = dimension[1] / 2;
    			if (i === 0) {
    				x = -padding - sliderSize[0] / 2;
    			} else {
    				x = dimension[0] + padding + sliderSize[0] / 2;
    			}
    		}
    	} else if (orient === "right"){
    		if (align === "left") {
    			dy = (i !== 0) ? "1em" : "-0.3em";
    			ANCHOR = "end";
    			x = -dimension[0] - padding - mathMax(0, (sliderSize[1] - dimension[0]) / 2);
    			if (i !== 0) {
    				y = 0;
    			} else {
    				y = dimension[1];
    			}
    		} else if (align === "right") {
    			dy = (i !== 0) ? "1em" : "-0.3em";
    			ANCHOR = null;
    			x = padding + mathMax(0, (sliderSize[1] - dimension[0]) / 2);
    			if (i !== 0) {
    				y = 0;
    			} else {
    				y = dimension[1];
    			}
    		} else {
    			dy = (i !== 0) ? "-0.3em" : "1em";
    			ANCHOR = "middle"
    			x = -dimension[0] / 2;
    			if (i !== 0) {
    				y = -padding - sliderSize[0] / 2;
    			} else {
    				y = dimension[1] + padding + sliderSize[0] / 2;
    			}
    		}
    	} else {
    		if (align === "left") {
    			dy = (i !== 0) ? "1em" : "-0.3em";
    			ANCHOR = "end";
    			x = - padding - mathMax(0, (sliderSize[1] - dimension[0]) / 2);
    			if (i !== 0) {
    				y = 0;
    			} else {
    				y = dimension[1];
    			}
    		} else if (align === "right") {
    			dy = (i !== 0) ? "1em" : "-0.3em";
    			ANCHOR = null;
    			x = dimension[0] + padding + mathMax(0, (sliderSize[1] - dimension[0]) / 2);
    			if (i !== 0) {
    				y = 0;
    			} else {
    				y = dimension[1];
    			}
    		} else {
    			dy = (i !== 0) ? "-0.3em" : "1em";
    			ANCHOR = "middle"
    			x = dimension[0] / 2;
    			if (i !== 0) {
    				y = -padding - sliderSize[0] / 2;
    			} else {
    				y = dimension[1] + padding + sliderSize[0] / 2;
    			}
    		}
    	}
    	return {
    		x: x,
    		y: y,
    		dy: dy,
    		anchor: ANCHOR
    	}
    }

    function getSliderSize(sliderOptions) {
        var type = sliderOptions.type,
            options = sliderOptions[type];
        if (type === "triangleUp" || type === "triangleDown") {
            return [0, 0];
        } else if (type === "lever") {
            return [options.width, options.height];
        } else {
            return [options.size, options.size];
        }
    }

})();//$Id$
var legendBrush;
(function(){
    var MIN_VALUE = 0.000000000001;
	legendBrush = function(chartObj, options) {
        var position = options.position,

            dimension = legend_helpers.getColorBandDimension(chartObj),
            width = dimension[0],
            height = dimension[1],

            legendOptions = chartObj.systemConf.legend,
            colorbandOptions = legendOptions.colorBand,

            orient = legend_helpers.getOrient(legendOptions),
            datatype = chartObj.dataset.getDataType("clr"),

            userRanges = colorbandOptions.ranges,
            userRanges_length = userRanges && userRanges.length,
            initialFilterRange = chartObj.systemConf.legend.filter.range,

            scale = chartObj.axes.clr.scale,
            scale_domain = scale.domain(),

            isHorizontal = orient === "bottom" || orient === "top",
            range = isHorizontal ? [0, width] : [height, 0],

            brushScale,
            rangeBand,
            rangeBandBy2,
            brushScale_domain,
            initialExtent,
            singleDomainContinuous;

            if (userRanges_length) {
                brushScale = d3_scaleOrdinal()
                    .domain((datatype === ORDINAL_DATATYPE) ? scale_domain : getRawRanges(chartObj))
                    .rangeBands(range, 0, 0);

                rangeBand = brushScale.rangeBand();
                rangeBandBy2 = rangeBand / 2;
            } else {
                var domain = [scale_domain[0], scale_domain[scale_domain.length - 1]];
                if (domain[0] === domain[1]) { // If the domain is [10, 10], need to change the domain //Test_694.json
                    singleDomainContinuous = [-1, 1];
                    domain = [-MAX_SAFE_INTEGER, MAX_SAFE_INTEGER];
                }

                brushScale = d3_scaleLinear()
                    .domain(domain)
                    .range(range);
            }

        brushScale_domain = brushScale.domain();

        if (userRanges_length) {
            if (initialFilterRange) {
                initialExtent = getExtentForOrdinalScale(initialFilterRange, brushScale, scale_domain, userRanges, datatype);
            } else {
                var start = brushScale(brushScale_domain[brushScale_domain.length - 1]),
                    end = brushScale(brushScale_domain[0]);
                initialExtent = [start + rangeBandBy2 - MIN_VALUE, end + rangeBandBy2 + MIN_VALUE];
            }

            initialExtent.sort(d3_ascending);
        } else {
            initialExtent = initialFilterRange || singleDomainContinuous || brushScale.domain();
        }

        var brushOptions = {
            element: chartObj.legendarea.element,
            orient: orient,
            scale: brushScale,
            initialExtent: initialExtent,
            brushOptions: legendOptions.filter,
            dimension: dimension,
            onBrush: function(component) {
                if (singleDomainContinuous) {
                    return;
                }

                var extent = component.extent();
                extent = getExtentWithinRange(extent, (userRanges_length ? range : domain));

                if (userRanges_length) {
                    extent = getDomainForOrdinalScale(extent, brushScale, scale_domain, userRanges, datatype, isHorizontal);
                }

                chartObj.systemConf.legend.filter.range = extent;
                chartObj.addRemoveSeries();

                brushObj.context.selectAll(".resize")
                    .style("fill", function(d, i) {
                        return scale(extent[i ? 0 : extent.length - 1]);
                    })
            },
            onEnd: function(component) {
                var new_extent;
                if (userRanges_length) {
                    var filterRange = chartObj.systemConf.legend.filter.range;
                    new_extent = getExtentForOrdinalScale(filterRange, brushScale, scale_domain, userRanges, datatype);
                } else if (singleDomainContinuous) {
                    new_extent = singleDomainContinuous;
                }

                if (new_extent) {
                    component.extent(new_extent);
                    brushObj.context
                        .transition()
                        .call(component);
                }
            }
        };

        var brushObj = new brushComponent(chartObj, brushOptions);
        brushObj.context.attr("transform", "translate(" + position[0] + "," + position[1] + ")");

        brushObj.context.selectAll(".resize")
            .style("fill", function(d, i) {
                var extent = userRanges_length ? getDomainForOrdinalScale(initialExtent, brushScale, scale_domain, userRanges, datatype, isHorizontal) : initialExtent;
                return scale(extent[mathMax(0, extent.length - 1 - i)]);
            });
	};

    function getDomainForOrdinalScale(extent, brushScale, scale_domain, userRanges, datatype, isHorizontal) {
        var brushScale_range = d3_values(brushScale.range()).sort(d3_ascending),
            brushScale_domain = brushScale.domain(),
            rangeBand = brushScale.rangeBand(),
            startIndex, endIndex;

        // Find start and end index
        brushScale_range.some(function(d, i) {
            if (extent[0] >= d && extent[0] <= (d + rangeBand)) {
                var diff = extent[0] - d;
                if (diff <= 0.5 && diff >= 0) { // antialiasing artifacts
                    startIndex = mathMax(i - 1, 0);
                } else {
                    startIndex = i;
                }
            }
            if (extent[1] >= d && extent[1] <= (d + rangeBand)) {
                var diff = d + rangeBand - extent[1];
                if (diff <= 0.5 && diff >= 0) { // antialiasing artifacts
                    endIndex = mathMin(i + 1, brushScale_range.length - 1);
                } else {
                    endIndex = i;
                }
            }
            return defined(startIndex) && defined(endIndex);
        });

        var domain = brushScale_domain;
        if (datatype !== ORDINAL_DATATYPE && userRanges[0].length === 1) { // If ranges are single element like [50, 60, 70] (e.g: http://localhost/#/demoCharts/heatmap5), need to make it as range --> [[min, 50], [50, 60], [60, 70]]
            domain = getPairs(scale_domain, domain);
        }

        if (!isHorizontal) {
            var temp = startIndex;
            startIndex = brushScale_range.length - 1 - endIndex;
            endIndex = brushScale_range.length - 1 - temp;
        }

        domain = domain.slice(startIndex, endIndex + 1, 0);
        if (datatype === ORDINAL_DATATYPE) {
            extent = domain;
        } else {
            extent = d3_extent(d3_merge(domain));
            extent = updateFilterRange(extent, scale_domain);
        }
        return extent;
    }

    function getExtentForOrdinalScale(filterRange, brushScale, scale_domain, userRanges, datatype) {
        var rangeBandBy2 = brushScale.rangeBand() / 2,
            extent;

        if (datatype === ORDINAL_DATATYPE) {
            extent = [brushScale(filterRange[0]) + rangeBandBy2, brushScale(filterRange[filterRange.length - 1]) + rangeBandBy2];
        } else {
            var brushScale_domain = brushScale.domain(),
                startIndex, endIndex; //start and end index of userRange
            filterRange = updateFilterRange(filterRange, scale_domain);

            brushScale_domain.forEach(function(d, i) {
                if (filterRange[0] >= d[0]) {
                    startIndex = (userRanges[0].length === 1) ? i + 1 : i;
                }
                if (!defined(endIndex) && filterRange[1] <= d[0]) {
                    endIndex = (userRanges[0].length === 1) ? i : i - 1;
                }
            });

            startIndex = mathMax(0, validateNullVal(startIndex, 0));
            endIndex = mathMax(0, validateNullVal(endIndex, brushScale_domain.length - 1));
            extent = [brushScale(brushScale_domain[startIndex]) + rangeBandBy2, brushScale(brushScale_domain[endIndex]) + rangeBandBy2];
        }

        if (extent[0] === extent[1]) {
            extent[0] -= MIN_VALUE;
            extent[1] += MIN_VALUE;
        }
        return extent;
    }

    function getPairs(scale_domain, domain) {
        var min = scale_domain[2],
            max = scale_domain[scale_domain.length - 1 - 2],
            pairs = [];
        for(var i=0; i<domain.length; i++) {
            pairs.push([min, domain[i][0]]);
            min = domain[i][0];
        }
        pairs.push(min, max);
        return pairs;
    }

    function isDistinct(array, value) {
        return array.indexOf(value) === array.lastIndexOf(value);
    }

    function updateFilterRange(filterRange, scale_domain) {
        // If [[10, 20], [20, 30]] is the user ranges (20 is present twice), the filterRange is should be modified
        // Refer legend-brush-1

        if (!isDistinct(scale_domain, filterRange[1])) {
            filterRange[1] -= MIN_VALUE;
        }
        return filterRange;       
    }

    function getExtentWithinRange(extent, range) { //Refer: legend filter issue
        if (range[1] > range[0]) {
            extent[1] = mathMin(extent[1], range[1]);
            extent[0] = mathMax(extent[0], range[0]);
        } else {
            extent[1] = mathMax(extent[1], range[1]);
            extent[0] = mathMin(extent[0], range[0]);
        }
        return extent;
    }

})();//$Id$
var docEle = d3_select(document.documentElement),
    clickedTime,
    previousChartObj,
    clickArguments,
    clickedElement,
    docTapFunction = function(chartObj) {
        if ($Browser.isTouchDevice && ((!chartObj && clickArguments && previousChartObj) || (previousChartObj && previousChartObj != chartObj))) {
            var container = previousChartObj.container.node();
            if (document.body.contains(container) && (container.style.display != "none")) {
                clickArguments[4] = true;

                previousChartObj.eventHandler.tapOldInfo = null;
                previousChartObj.eventHandler.mouseOut.apply(clickedElement, clickArguments);
            }
        }
    };
$ZC.documentTapEvent = docTapFunction;

if ($Browser.isTouchDevice) {
    var callPlotMouseOut = function(){
        var now = new Date().getTime();
        if (!clickedTime || ((now - clickedTime) > 500)) {
            docTapFunction();
        }
    };

    var docTapHandlers = {
        "tap" : callPlotMouseOut,
        "taphold" : callPlotMouseOut,
        "dbltap" : callPlotMouseOut
    };
    attachevents(docEle, {}, docTapHandlers, {preventDefault: false});

    docEle
        .on('touchmove', function() {
            docTapFunction();
        });
}//$Id$
$ZC.events.mouseevents = function(chartObj, tooltipele, systemConf, plotarea, dataset, xscale, barscale1, barscale2, ysca, wrap, color, labelhighter) {
    var element, gvpFn = $ZC.utils.getValueOfPlotOptions;
    var datatype = dataset.getDataType("x");
    var yscale = ysca,
        color = color;
    var axisrotated = chartObj.dataObject.getAxisRotated(),
        tooltipEnabled = systemConf.tooltip.enabled === true,
        defaultScrollElement = chartObj.container.selectAll(".zohocharts_scroll"),
        levelMarkerPoint,
        eventAttacherOptions = {
            target: "plot",
            chartObj: chartObj
        },
        tapOldInfo,
        dataProcessorHelpers = $ZC.DataProcessor.helpers,
        getParsedYAxisOrder = dataProcessorHelpers.getParsedYAxisOrder,
        getChartType = dataProcessorHelpers.getChartType,
        isCatNull = dataProcessorHelpers.isCatNull;
    
    // for reverse legend hovering
    var legendSeries = chartObj.legendarea.element.selectAll(".legseries").node(),
        legendElements = legendSeries ? legendSeries.children : [],
        highlightItem = chartObj.legend.component.highlightItem,
        legendStyle = systemConf.legend,
        itemHighlighted = false,
        hoveredSeriesIndex = null,
        previousHoveredSeriesIndex = null,
        showOnDataHover = systemConf.legend.itemHoverStyle && systemConf.legend.itemHoverStyle.showOnDataHover,
        legend_series_height, legendScrollable;
    if (legendSeries) {
        legend_series_height = legendSeries.clientHeight;
        legendScrollable = legendSeries.scrollHeight > legend_series_height;
    }
    
    var events = {};
    var timer = 0,
        highlightpoint, stacked = function(cType) {
            return chartObj.dataObject.isstacked(cType)
        };
    
    events.initializeListener = function() {
        var eventHandler = chartObj.eventHandler;
        tapOldInfo = chartObj.eventHandler.tapOldInfo = null; //Tap event in touch devices - to toggle (defaultMouseOverFunc & defaultMouseOutFunc) on tap;

        eventHandler.trackerElement = wrap.selectAll("rect.eventhandler").data([1]);
        eventHandler.tooltipElement = $ZC.events.tooltip(tooltipele, systemConf, chartObj);
        eventHandler.tooltipElement.initialize();

        var trackerEle = chartObj.eventHandler.trackerElement;
        trackerEle.enter().append("rect").attr("class", "eventhandler").style("fill-opacity", 0);


        // Bullet event
        if ((chartObj.chartTypes[0].name === "bullet") && systemConf.chart.plot.renderer.mode.toLocaleLowerCase() === "svg") {
            events.bulletEvent = bulletChartEventHandler(chartObj, trackerEle, hoverSeries, events);
            return false;
        }

        var zoomType = isObjectPropDefined(systemConf.chart, "zoom.type", true),
            clickHandlers = {
                "click": eventHandler.click,
                "dblclick": eventHandler.doubleclick,
                "contextmenu": eventHandler.contextMenu
            },
            moveHandlers = {
                "mousemove": eventHandler.mouseMove,
                "mouseout": eventHandler.mouseOut
            };

        attachevents(trackerEle, clickHandlers, null, eventAttacherOptions, "chart");
        attachevents(trackerEle, moveHandlers, null, eventAttacherOptions, "chartmove");
        attachevents(tooltipele, moveHandlers, null, eventAttacherOptions);

        if (zoomType && (zoomType !== "none")) {
            $ZC.setDefaultOptions("zoom", chartObj.systemConf.chart, chartObj.globalProp);
            eventHandler.initializeZoomListener();
        } else {
            var touchHandlers = {
                "tap" : eventHandler.click,
                "dbltap": eventHandler.doubleclick,
                "singletouchmove" : eventHandler.mouseMove,
                "touchend" : eventHandler.mouseOut
            };

            attachevents(trackerEle, {}, touchHandlers, eventAttacherOptions);
        }

        // handle scroll
		var tooltip = chartObj.eventHandler.tooltipElement;
        var scrollEventName = "onwheel" in document.createElement("div") ? "wheel" : document.onmousewheel !== undefined ? "mousewheel" : "DOMMouseScroll";
        var parentNode = chartObj.container.node(), lastPosition = null;
        chartObj.d3container.on(scrollEventName, function() {
            var currentPosition = parentNode.getBoundingClientRect();
            if(lastPosition) {
            	if(lastPosition.left !== currentPosition.left || lastPosition.top !== currentPosition.top) {
            		tooltip.hide(tooltip.element);
            	}
            }
			lastPosition = currentPosition;
        });

    };
    events.initializeZoomListener = function() {
        chartObj.zoom = $ZC.events.zoom(chartObj, axisrotated, systemConf, dataset);
        var trackerEle = chartObj.eventHandler.trackerElement,
            documentElement = d3_select(document.documentElement);
        var zmevent = chartObj.zoom;
        var eventHandler = chartObj.eventHandler;
        zmevent.zmInit();
        var zoomInitialized = false;
        
        var handlers = {
            "mousedown": function() {
                detachevent(trackerEle, "chartmove"); //Stop event listening for .chart eventType while zooming.
                attachevents(documentElement, mousemoveHandlers, null, eventAttacherOptions); //Enable move event
                d3.event.preventDefault();
            }
        };
        
        var mousemoveHandlers = {
            "mousemove": function() {
                chartObj.eventHandler.mousePos = getMousePosition(trackerEle.node(), d3.event);
                if (!zoomInitialized) {
                    chartObj.eventHandler.mouseOut();
                    zmevent.zmStart(chartObj.eventHandler.mousePos);
                    zoomInitialized = true
                }
                zmevent.zmMove(chartObj.eventHandler.mousePos);
            },
            
            "mouseup": function() {
                detachevent(documentElement, null, mousemoveHandlers); //Disable move event.
                var zmdata = zmevent.zmEnd(chartObj.eventHandler.mousePos);
                if (zoomInitialized) {
                    chartObj.eventHandler.mousePos = getMousePosition(trackerEle.node(), d3.event);
                    zmevent = chartObj.zoom;
                    zmevent.zoomed(zmdata);
                }
                // Re-initialize default events
                var handlers = {
                    "mousemove": eventHandler.mouseMove,
                    "mouseout": eventHandler.mouseOut
                };
                attachevents(trackerEle, handlers, null, eventAttacherOptions, "chartmove");
                zoomInitialized = false;
            }
        };

        var zoomMoveHandlers = {
            "tap" : eventHandler.click,
            "dbltap": eventHandler.doubleclick,
            "doubletouchmove": function() {
                chartObj.eventHandler.mousePos = getMousePosition(trackerEle.node(), d3.event);
                if (!zoomInitialized) {
                    chartObj.eventHandler.mouseOut();
                    zmevent.zmStart(chartObj.eventHandler.mousePos);
                    zoomInitialized = true
                }
                zmevent.zmMove(chartObj.eventHandler.mousePos);
            },
            "touchend": function() {
                detachevent(documentElement, null, mousemoveHandlers); //Disable move event.
                var zmdata = zmevent.zmEnd(chartObj.eventHandler.mousePos);
                if (zoomInitialized) {
                    chartObj.eventHandler.mousePos = getMousePosition(trackerEle.node(), d3.event);
                    zmevent = chartObj.zoom;
                    zmevent.zoomed(zmdata);
                } else {
                    eventHandler.mouseOut();
                }
                zoomInitialized = false;
            },
            "singletouchmove" : eventHandler.mouseMove
        };
        attachevents(trackerEle, handlers, zoomMoveHandlers, eventAttacherOptions, "zoom");
    };
    
    events.updateParams = function(chartObj_new) {
        chartObj = chartObj_new;
        systemConf = chartObj.systemConf;
        plotarea = chartObj.plotarea;
        dataset = chartObj.dataset;
        xscale = chartObj.axes.x.eventscale;
        yscale = chartObj.axes.y.groups;
        barscale1 = chartObj.barscale1;
        barscale2 = chartObj.barscale2;
        color = chartObj.seriesColor;
        tooltipele = chartObj.tooltip.element;
        stacked = function(cType) {
            return chartObj.dataObject.isstacked(cType)
        };
        axisrotated = chartObj.dataObject.getAxisRotated();
        wrap = chartObj.staticPaneSVG.selectAll("g.eventgroup");
        datatype = dataset.getDataType("x");
        
        tooltipEnabled = systemConf.tooltip.enabled === true;
        chartObj.eventHandler.tooltipElement = $ZC.events.tooltip(chartObj.tooltip.element, systemConf, chartObj);
        chartObj.eventHandler.tooltipElement.initialize();

        if (chartObj.xymultiRenderer || chartObj.dataObject.isPolarAxisCategory) {
            drawBorderBox(chartObj.eventHandler.trackerElement, chartObj.plotarea);
        }

        // update bullet events
        if (events.bulletEvent) {
            updateBulletEvents(chartObj, events.bulletEvent);
        }
    };
    
    events.mouseMove = function(args) {
        var eventEle = args.element || this;
        if (chartObj.chartRendered) {
            var tooltip = chartObj.eventHandler.tooltipElement;
            if ((tooltip != null) && (tooltip.timeout != null)) {
                clearTimeout(tooltip.timeout); // To avoid flickering on  mouse move, clearing the timeout that makes the tooltip's display prop to none
            }
            // if (d3.event.defaultPrevented) return;
            if (chartObj.stopPropogate !== false) {
                d3.event.stopPropagation();
            }
            chartObj.eventHandler.targetEvent = d3.event;
            if (!chartObj.xymultiRenderer && !chartObj.dataObject.isPolarAxisCategory) {
                var node = chartObj.svg.node();
                chartObj.eventHandler.mousePos = getMousePosition(node, d3.event);
                var relMouseX = chartObj.eventHandler.mousePos[0];
                var relMouseY = chartObj.eventHandler.mousePos[1];
                
                var relmousePt = {
                    x: relMouseX,
                    y: relMouseY
                };
                
                var currentEle = d3.event.srcElement || d3.event.target;
                var elementID = d3_select(currentEle).attr("id");
                var isMouseOveronTooltip = (eventEle.id == "zctooltip") || /(zctooltip|tooltipcontent|zctooltipafter|zctooltipbefore)/.test(elementID);
                if (!isMouseOveronTooltip) {
                    var seriesdata = chartObj.seriesdata;
                    var chartName = chartObj.chartTypes[0].name;

                    var plotOptions = seriesdata[args.seriesPos].plotoptions,
                        commonPlotOptions = systemConf.chart.plot.plotoptions[chartName],
                        eventType = (chartObj.zcEventType) || "mousemove";
                    var mouseMoveFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType);
                    
                    if (mouseMoveFn != null) {
                        var evt = d3.event || chartObj.eventHandler.targetEvent,
                            dt = {
                                "data": chartObj.dataset.getMetaInfoObj(chartObj, (args.data.data || args.data), args.seriesPos)
                            };
                        invokeFunction(mouseMoveFn, evt, dt, chartObj);
                    } else {
                        chartObj.eventHandler.oldRenderer = args;
                        args.renderer.defaultMouseOverFunc(args.data, args.seriesPos, args.itemPos);
                    }
                    if (tooltipEnabled) {
                        var tooltipPos = {
                            left: relmousePt.x,
                            top: relmousePt.y
                        };
                        var evt = getEventObject(d3.event);
                        var dLeft = relmousePt.x - evt.clientX,
                            dTop = relmousePt.y - evt.clientY;
                        tooltipPos.left -= dLeft;
                        tooltipPos.top -= dTop;
                        tooltipPos.dLeft = dLeft;
                        tooltipPos.dTop = dTop;
                        var tooltipArgs = {
                            "seriesindex": args.seriesPos,
                            "subseriespos": args.subseriesPos,
                            "color": (args.color || color),
                            "svgFillFunc":args.renderer.fillColorFunc,
                            "itempos": args.itemPos,
                            "d": (chartObj.dataObject.isHierarchy ? (args.data.data || args.data) : null)
                        }
                        tooltip.show(chartObj, tooltipPos, null, true, tooltipArgs);
                    }
                }
                hoveredSeriesIndex = hoveredSeriesIndex = getLegendIndex(args.data.data || args.data, chartObj.isNonAxisMultiSeriesCategory ? args.seriesPos : args.itemPos);
            } else {
                if (chartObj.eventHandler.mousemovetimer) {
                    clearTimeout(chartObj.eventHandler.mousemovetimer)
                }
                var node = chartObj.eventHandler.trackerElement.node();
                chartObj.eventHandler.mousePos = getMousePosition(node, d3.event);
                chartObj.eventHandler.mousemovetimer = setTimeout(function() {
                    var containsBarchart = (chartObj.dataObject.noofBarEnabledSeries > 0);
                    var func = ((datatype === ORDINAL_DATATYPE) && (containsBarchart || systemConf.tooltip.sharedSeriesInfo)) ? ordinalDatamouseMove : xydatamouseMove;
                    func(chartObj.eventHandler.mousePos, chartObj.eventHandler.targetEvent, node);
                }, timer)
            }
        }
        // reverse hovering
        if (showOnDataHover && hoveredSeriesIndex !== null) {
            if (legendElements[hoveredSeriesIndex]) {
                var legendData = legend_helpers.getLegendData(chartObj);
                
                if (hoveredSeriesIndex !== previousHoveredSeriesIndex && previousHoveredSeriesIndex !== null) {
                    highlightItem(legendElements[previousHoveredSeriesIndex], legendData[previousHoveredSeriesIndex], previousHoveredSeriesIndex, legendStyle);
                }
                
                highlightItem(legendElements[hoveredSeriesIndex], legendData[hoveredSeriesIndex], hoveredSeriesIndex, legendStyle, true);
                itemHighlighted = true;
                
                // scroll into view;
                if (legendScrollable && !(chartObj.systemConf.legend.expandable && chartObj.systemConf.legend.expandable.show)) {
                    legendSeries.scrollTop = legendElements[hoveredSeriesIndex].offsetTop - legend_series_height / 2;
                }
            }
            previousHoveredSeriesIndex = hoveredSeriesIndex;
        }
    };
    
    events.mouseOut = function(renderer, data, index, showTooltip, forceMouseOut) {
        var seriesdata = chartObj.seriesdata,
            eventEle = this;
        index = index || 0; // Touch double tap
        var chartName = chartObj.chartTypes[0].name;
        var plotOptions = (chartObj.isNonAxisMultiSeriesCategory && !chartObj.dataObject.isPolarAxisCategory) ? seriesdata[index].plotoptions : seriesdata[0].plotoptions,
            commonPlotOptions = systemConf.chart.plot.plotoptions[chartName];
        var mouseOutFn = getEventConf(plotOptions, commonPlotOptions, chartObj, "mouseout");
        var oldInfo = chartObj.eventHandler.oldInfo;
        
        if (forceMouseOut || chartObj.chartRendered) {
            var event = d3.event;
            var withIn = 0
            if(mouseOutFn != null){
            	if((!chartObj.xymultiRenderer) || (oldInfo != null && !oldInfo.isNoInfo)){
            		var evt = event || chartObj.eventHandler.targetEvent,
            			dt = (data) ? {
                                "data": chartObj.dataset.getMetaInfoObj(chartObj, (data.data || data), index)
                            } : null;

            		invokeFunction(mouseOutFn, evt, dt, chartObj);
            	}
            
            }else{
            if (chartObj.xymultiRenderer || chartObj.dataObject.isPolarAxisCategory) {
                var node = chartObj.eventHandler.trackerElement.node();
                var mouse = (event != null) ? getMousePosition(node, event) : chartObj.eventHandler.mousePos;
                var relativeelement = bbox(node);
                var relMouseX = (axisrotated) ? mouse[1] : mouse[0];
                var relMouseY = (axisrotated) ? mouse[0] : mouse[1];
                var relmousePt = {
                    x: relMouseX,
                    y: relMouseY
                };
                
                withIn = isWithin(relativeelement, relmousePt);
            }
            
            var tooltip = chartObj.eventHandler.tooltipElement
            var relatedTarget = (event != null) ? event.relatedTarget : null;
            var target = (event != null) ? event.target : null;
            
            if (((chartObj.xymultiRenderer) && withIn == 0) && relatedTarget != null && tooltip != null && (target == tooltip.element.node() || target == tooltip.element.selectAll("div#tooltipcontent").node() || relatedTarget == tooltip.element.node() ||
                relatedTarget == tooltip.element.selectAll("div#tooltipcontent").node())) {
                return
            } else {
                if (!chartObj.xymultiRenderer && !chartObj.dataObject.isPolarAxisCategory) {
                    renderer = renderer || chartObj.renderer[index];

                    if (eventEle.id == "zctooltip" || relatedTarget != null && tooltip != null && (target == tooltip.element.node() || target == tooltip.element.selectAll("div#tooltipcontent").node() || target == tooltip.element.selectAll("div#zctooltipafter").node() || target == tooltip.element.selectAll("div#zctooltipbefore").node() || relatedTarget == tooltip.element.node() || relatedTarget == tooltip.element.selectAll("div#tooltipcontent").node() || relatedTarget == tooltip.element.selectAll("div#zctooltipafter").node() || relatedTarget == tooltip.element.selectAll("div#zctooltipbefore").node())) {
                        var actualRenderer = chartObj.eventHandler.oldRenderer;
                        if (actualRenderer != null) {
                            actualRenderer.renderer.defaultMouseOutFunc(actualRenderer.data, ((chartObj.isNonAxisMultiSeriesCategory) ? actualRenderer.seriesPos : actualRenderer.itemPos), forceMouseOut);
                        }
                    } else {
                        renderer.defaultMouseOutFunc(data, index, forceMouseOut);
                    }
                }
                if (chartObj.eventHandler.mouseouttimer) {
                    clearTimeout(chartObj.eventHandler.mouseouttimer);
                }
                
                chartObj.eventHandler.mouseouttimer = setTimeout(function() {
                    wrap.selectAll("#zcscatterhighlight,#zcbarhighlight,#zcareahighlight")
                        .style('display', "none");
                    
                    if (chartObj.eventHandler.tooltipElement.timeout) {
                        clearTimeout(chartObj.eventHandler.tooltipElement.timeout);
                    }
                    if (showTooltip !== true) {
                        chartObj.eventHandler.tooltipElement.timeout = setTimeout(function() {
                            tooltip.hide();
                        }, 110)
                    }
                }, timer)
            }
            // // mouse out callback
            // if (mouseOutFn != null) {
            //     if ((!chartObj.xymultiRenderer) || (oldInfo != null && !oldInfo.isNoInfo)) {
            //         var evt = event || chartObj.eventHandler.targetEvent,
            //             dt = (data) ? {
            //                     "data": chartObj.dataset.getMetaInfoObj(chartObj, (data.data || data), index)
            //                 } : null;
            //         invokeFunction(mouseOutFn, evt, dt, chartObj);
            //     }
                
            // }
            }
            if (itemHighlighted) {
                if (defined(legendElements[hoveredSeriesIndex])) {
                    var legendData = legend_helpers.getLegendData(chartObj);
                    highlightItem(legendElements[hoveredSeriesIndex], legendData[hoveredSeriesIndex], hoveredSeriesIndex, legendStyle);
                }
                hoveredSeriesIndex = null;
            }
            itemHighlighted = false;
            events.hideCursor(chartObj.eventHandler.trackerElement);
        }
    };
    
    events.click = function(renderer, data, seriesPos, itemPos, args) {
        if (chartObj.chartRendered) {

            var seriesdata = chartObj.seriesdata;
            var isPolar = chartObj.dataObject.isPolarAxisCategory,
                isTouchEvent = d3.event && d3.event.touches,
                eventType = (chartObj.zcEventType) || "click";

            if(isTouchEvent && eventType !== "taphold") {
                docTapFunction(chartObj);

                clickedTime = new Date().getTime();
                clickedElement = this;
                clickArguments = [renderer, data, seriesPos, itemPos];
                previousChartObj = chartObj;
            }

            var tooltip = chartObj.eventHandler.tooltipElement;
            tooltip.hide(tooltip.element);
            events.hideCursor(chartObj.eventHandler.trackerElement);

            if (!chartObj.xymultiRenderer && !isPolar) {
                var chartName = chartObj.chartTypes[0].name;
                var plotOptions = seriesdata[chartObj.isNonAxisMultiSeriesCategory ? seriesPos : 0].plotoptions,
                    commonPlotOptions = systemConf.chart.plot.plotoptions[chartName];
                var clickFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType);
                if (clickFn != null) {
                    var evt = d3.event || chartObj.eventHandler.targetEvent,
                        dt = {
                            "data": chartObj.dataset.getMetaInfoObj(chartObj, (data.data || data), (chartObj.isNonAxisMultiSeriesCategory ? seriesPos : itemPos))
                        };
                    invokeFunction(clickFn, evt, dt, chartObj);
                } else if(isTouchEvent && (eventType !== "taphold")) {
                    tapOldInfo = chartObj.eventHandler.tapOldInfo;
                    if (!tapOldInfo || (args.level ? (args.level != tapOldInfo.level) : (tapOldInfo.itemPos != itemPos || tapOldInfo.seriesPos != seriesPos || tapOldInfo.subseriesindex != 0))) {
                        renderer.defaultMouseOverFunc(data, seriesPos, itemPos);

                        if (tooltipEnabled) {
                            var node = chartObj.svg.node();
                            chartObj.eventHandler.mousePos = getMousePosition(node, d3.event);
                            var relMouseX = chartObj.eventHandler.mousePos[0];
                            var relMouseY = chartObj.eventHandler.mousePos[1];
                            
                            var relmousePt = {
                                x: relMouseX,
                                y: relMouseY
                            };

                            var tooltipPos = {
                                left: relmousePt.x,
                                top: relmousePt.y
                            };
                            var evt = getEventObject(d3.event);
                            var dLeft = relmousePt.x - evt.clientX,
                                dTop = relmousePt.y - evt.clientY;
                            tooltipPos.left -= dLeft;
                            tooltipPos.top -= dTop;
                            tooltipPos.dLeft = dLeft;
                            tooltipPos.dTop = dTop;
                            var tooltipArgs = {
                            "seriesindex": args.seriesPos,
                            "subseriespos": args.subseriesPos,
                            "color": (args.color || color),
                            "svgFillFunc":args.renderer.fillColorFunc,
                            "itempos": args.itemPos,
                            "d": (chartObj.dataObject.isHierarchy ? (args.data.data || args.data) : null)
                        }
                            tooltip.show(chartObj, tooltipPos, null, true, tooltipArgs);
                        }

                        chartObj.eventHandler.tapOldInfo = {
                            seriesPos : seriesPos,
                            subseriesindex : 0,
                            itemPos : itemPos,
                            level: args.level
                        };
                    } else {
                        renderer.defaultMouseOutFunc(data, itemPos);
                        chartObj.eventHandler.tapOldInfo = null;
                    }

                }
            } else {
                var event = d3.event;
                element = chartObj.eventHandler.trackerElement.node();
                var mouse = getMousePosition(element, event) || chartObj.eventHandler.mousePos;
                var relativeelement = bbox(element);
                var relMouseX = mouse[0] - relativeelement.x - (isPolar ? chartObj.plotarea_approx.x : 0);
                var relMouseY = mouse[1] - relativeelement.y - (isPolar ? chartObj.plotarea_approx.y : 0);
                var relmousePt = {
                    x: relMouseX,
                    y: relMouseY
                };
                
                element = this;
                var containsBarchart = (chartObj.dataObject.noofBarEnabledSeries > 0);
                var func = (datatype === ORDINAL_DATATYPE && containsBarchart) ? getOrdinalDataPoint : getClosestPoint;
                var nearestPoint = func(relmousePt, xscale, yscale, systemConf);
                
                var seriespos = nearestPoint.seriesPos;
                var itemPos = nearestPoint.itemPos;
                var subseriesindex = (nearestPoint.subseriesindex instanceof Array) ? nearestPoint.subseriesindex[seriespos] : nearestPoint.subseriesindex;
                if (seriespos == null) {
                    if (isTouchEvent) {
                        chartObj.eventHandler.mouseOut();
                        chartObj.eventHandler.tapOldInfo = null;
                    }
                    return
                }
                
                var type = chartObj.chartTypes[seriespos].value;
                var plotOptions = seriesdata[seriespos].plotoptions,
                    commonPlotOptions = systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)];
                var clickFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType),
                    cursor = getEventConf(plotOptions, commonPlotOptions, chartObj, "cursor");
                
                if (clickFn != null) {
                    var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
                    var ysc = yscale[yscindex].eventscale;
                    var renderer = chartObj.renderer[seriespos];
                    var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
                    var data = currentSeriesdata[itemPos];
                    if (isBarChartType(type)) {
                        events.addCursor(cursor);
                        var evt = d3.event || chartObj.eventHandler.targetEvent,
                            dt = {
                                "x": nearestPoint.highlightpoint.x,
                                "y": nearestPoint.highlightpoint.y,
                                "data": chartObj.dataset.getMetaInfoObj(chartObj, data, seriespos)
                            };
                        invokeFunction(clickFn, evt, dt, chartObj);
                        
                    } else {
                        var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x");
                        var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y");
                        var mindist = (type === $ZC.charttype.area || type === $ZC.charttype.stkdarea || isPolar) ? null : lineDistance({
                                "x": xval,
                                "y": yval
                            }, relmousePt);
                        var rad = isBubbleChartType(type) ? chartObj.zscale(chartObj.dataset.getZ(data)) / 2 : 10;
                        if (mindist <= rad) {
                            events.addCursor(cursor);
                            //						var extraParams = "GC 0 "+tooltip.formatValue(systemConf,xdata,"x")+",2 "+seriesdata[seriespos].data[subseriesindex][itemPos][dataset.indices.clr]+",";
                            var evt = d3.event || chartObj.eventHandler.targetEvent,
                                dt = {
                                    "x": xval,
                                    "y": yval,
                                    "data": chartObj.dataset.getMetaInfoObj(chartObj, data, seriespos)
                                };
                            invokeFunction(clickFn, evt, dt, chartObj);
                            
                        } else {
                            events.hideCursor(chartObj.eventHandler.trackerElement);
                            return;
                        }
                    }
                } else if(isTouchEvent && (eventType !== "taphold")) {
                    tapOldInfo = chartObj.eventHandler.tapOldInfo;
                    if (!tapOldInfo || (tapOldInfo.itemPos != itemPos || tapOldInfo.seriesPos != seriespos || tapOldInfo.subseriesindex != subseriesindex)) {
                        chartObj.eventHandler.mouseMove({});

                        chartObj.eventHandler.tapOldInfo = {
                            seriesPos : seriespos,
                            subseriesindex : subseriesindex,
                            itemPos : itemPos
                        };
                    } else {
                        chartObj.eventHandler.mouseOut();
                        chartObj.eventHandler.tapOldInfo = null;
                    }
                }
            }
        }
    };
    
    events.doubleclick = function(data, index, args) {
        if (chartObj.chartRendered) {
            if (chartObj.noPropogate) {
                d3.event.stopPropagation();
            }

            var isTouchEvent = d3.event && d3.event.touches;
            if (isTouchEvent) {
                chartObj.eventHandler.mouseOut();
                chartObj.eventHandler.tapOldInfo = null;
            }

            var tooltip = chartObj.eventHandler.tooltipElement;
            tooltip.hide(tooltip.element);
            events.hideCursor(chartObj.eventHandler.trackerElement);
            
            var seriesdata = chartObj.seriesdata;
            var isPolar = chartObj.dataObject.isPolarAxisCategory,
                eventType = (chartObj.zcEventType) || "doubleclick";
            if (!chartObj.xymultiRenderer && !isPolar) {
                var chartName = chartObj.chartTypes[0].name;
                var plotOptions = seriesdata[chartObj.isNonAxisMultiSeriesCategory ? index : 0].plotoptions,
                    commonPlotOptions = systemConf.chart.plot.plotoptions[chartName];
                var dblClickFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType);
                if (dblClickFn != null) {
                    var evt = d3.event || chartObj.eventHandler.targetEvent,
                        dt = {
                            "data": chartObj.dataset.getMetaInfoObj(chartObj, (data.data || data), index)
                        };
                    invokeFunction(dblClickFn, evt, dt, chartObj);
                } else {
                    addNoteFunction(args);
                }
            } else {
                element = chartObj.eventHandler.trackerElement.node();
                var mouse = getMousePosition(element, d3.event);
                var relativeelement = bbox(element);
                var relMouseX = mouse[0] - relativeelement.x - (isPolar ? chartObj.plotarea_approx.x : 0);
                var relMouseY = mouse[1] - relativeelement.y - (isPolar ? chartObj.plotarea_approx.y : 0);
                var relmousePt = {
                    x: relMouseX,
                    y: relMouseY
                };
                
                element = this;
                var containsBarchart = (chartObj.dataObject.noofBarEnabledSeries > 0);
                var func = (datatype === ORDINAL_DATATYPE && containsBarchart) ? getOrdinalDataPoint : getClosestPoint;
                var nearestPoint = func(relmousePt, xscale, yscale, systemConf);
                
                var seriespos = nearestPoint.seriesPos;
                if (seriespos == null) {
                    return
                }
                var itemPos = nearestPoint.itemPos;
                var subseriesindex = (nearestPoint.subseriesindex instanceof Array) ? nearestPoint.subseriesindex[seriespos] : nearestPoint.subseriesindex;
                var renderer = chartObj.renderer[seriespos];
                var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
                var data = currentSeriesdata[itemPos];
                var type = chartObj.chartTypes[seriespos].value;
                var plotOptions = seriesdata[seriespos].plotoptions,
                    commonPlotOptions = systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)];
                var dblClickFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType),
                    cursor = getEventConf(plotOptions, commonPlotOptions, chartObj, "cursor");
                
                if (isBarChartType(type)) {
                    events.addCursor(cursor);
                    if (dblClickFn != null) {
                        var evt = d3.event || chartObj.eventHandler.targetEvent,
                            dt = {
                                "data": chartObj.dataset.getMetaInfoObj(chartObj, data, seriespos)
                            };
                        invokeFunction(dblClickFn, evt, dt, chartObj);
                    } else {
                        addNoteFunction(null, seriespos, itemPos, currentSeriesdata, nearestPoint.highlightpoint.x, nearestPoint.highlightpoint.y);
                    }
                } else {
                    var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
                    var ysc = yscale[yscindex].eventscale;
                    var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x") + (isPolar ? chartObj.plotarea_approx.x : 0);
                    var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y") + (isPolar ? chartObj.plotarea_approx.y : 0);
                    var mindist = (type === $ZC.charttype.area || type === $ZC.charttype.stkdarea || isPolar) ? null : lineDistance({
                            "x": xval,
                            "y": yval
                        }, relmousePt);
                    var rad = isBubbleChartType(type) ? chartObj.zscale(chartObj.dataset.getZ(data)) / 2 : 10;
                    if (mindist <= rad) {
                        events.addCursor(cursor);
                        if (dblClickFn != null) {
                            var evt = d3.event || chartObj.eventHandler.targetEvent,
                                dt = {
                                    "x": xval,
                                    "y": yval,
                                    "data": chartObj.dataset.getMetaInfoObj(chartObj, data, seriespos)
                                };
                            invokeFunction(dblClickFn, evt, dt, chartObj);
                        } else {
                            addNoteFunction(null, seriespos, itemPos, currentSeriesdata, xval, yval);
                        }
                    } else {
                        events.hideCursor(chartObj.eventHandler.trackerElement);
                        return;
                    }
                }
            }
        }
    };
    
    events.contextMenu = function(args) {
        var contextMenuFn = systemConf.chart.plot.events.contextmenu;
        if (contextMenuFn != null) {
            var evt = d3.event || chartObj.eventHandler.targetEvent;
            invokeFunction(contextMenuFn, evt, chartObj);
            d3.event.preventDefault();
        }
    };
    
    events.addCursor = function(cur) {
        var trackerElement = getEventTrackerElement();
        var cur = cur || (isObjectPropDefined(systemConf.chart, "zoom.type") && (chartObj.systemConf.chart.zoom.type != "none") ? "crosshair" : "pointer");
        trackerElement.style("cursor", cur);
    };
    
    events.hideCursor = function() {
        var trackerElement = getEventTrackerElement();
        trackerElement.style("cursor", "default");
    };
    
    function getEventTrackerElement() {
        return (chartObj.isAxisCategory && (chartObj.systemConf.chart.width || chartObj.systemConf.chart.height))
            ? defaultScrollElement
            : chartObj.eventHandler.trackerElement
    }
    function ordinalDatamouseMove(mouse, event, element) {
        var relativeelement = bbox(element);
        var relMouseX = mouse[0] - relativeelement.x;
        var relMouseY = mouse[1] - relativeelement.y;
        
        var relmousePt = {
            x: relMouseX,
            y: relMouseY
        };
        
        var nearestPoint = getOrdinalDataPoint(relmousePt, xscale, yscale, systemConf);
        var seriesdata = chartObj.seriesdata;
        var seriespos = nearestPoint.seriesPos;
        var xpos = nearestPoint.itemPos;
        var subseriesindex = nearestPoint.subseriesindex;
        highlightpoint = nearestPoint.highlightpoint;
        levelMarkerPoint = nearestPoint.levelMarkerPoint;
        subseriesindex = subseriesindex[seriespos];
        var oldInfo = chartObj.eventHandler.oldInfo;
        var tooltipShared = chartObj.systemConf.tooltip.sharedSeriesInfo;

        var isNoInfo = (seriespos == null) ? true : false;
        if (seriespos == null) {
            chartObj.eventHandler.mouseOut();
            chartObj.eventHandler.oldInfo = {
                "isNoInfo": isNoInfo
            };
            return
        }
        
        var type = chartObj.chartTypes[seriespos].value;
        var isRangeChart = type == $ZC.charttype.arearange;
        var yrangePos = (isRangeChart) ? 1 : null;
        var rangeBand = xscale.rangeBand != null ? xscale.rangeBand() : null;
        var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
        var ysc = yscale[yscindex].eventscale;
        var renderer = chartObj.renderer[seriespos];
        var data = ((renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex])[xpos];
        var xdata = dataset.getX(data); //chartObj.dataObject.getCategories("x")[xpos];
        var ydata = dataset.getY(data, yscindex);
        
        var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x", null, yrangePos);
        var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y", null, yrangePos);

        hoveredSeriesIndex = getLegendIndex(data, seriespos);

        if (!isBarChartType(type) && isWithinPlotarea(xval, yval) == null) {
            return;
        }
        // zcareahighlight
        
        if (oldInfo != null && !oldInfo.isNoInfo) {
            var oldNearestPoint = oldInfo.nearestPoint;
            var oldType = getChartType((oldInfo.type || chartObj.userdata.seriesdata.type), NUMERIC_DATATYPE);
            if (oldNearestPoint && (oldNearestPoint.seriesPos == nearestPoint.seriesPos) && (oldNearestPoint.itemPos == nearestPoint.itemPos) && (oldNearestPoint.subseriesindex == nearestPoint.subseriesindex) && (oldType == type)) {
                wrap.selectAll("#zcbarhighlight,#zcareahighlight").style("display", "");
                tooltipele.style("visibility", tooltipEnabled ? "visible" : "hidden");
                if (crosshair_enabled()) {
                    chartObj.staticPaneSVG.selectAll("g.crosshair").style("visibility", "visible")
                }
                return
            }
        }
        
        var distance = lineDistance({
            "x": xscale(xdata),
            "y": ysc(ydata)
        }, relmousePt);
        var seriesLen = (tooltipShared) ? chartObj.seriesdata.length : 1
        //highlighting new Info
        wrap.selectAll("#zcscatterhighlight").selectAll("*").remove();
        var tooltipSharedInfo = d3_map();
        
        for (var i = 0; i < seriesLen; i++) {
            var curSeriespos = (tooltipShared) ? i : seriespos;
            hoverSeries(chartObj, curSeriespos, xdata, xpos, subseriesindex, nearestPoint, tooltipShared, (distance > 10), tooltipSharedInfo)
            
        }
        
        // Tooltip shown values
        
        var tooltip = chartObj.eventHandler.tooltipElement;
        if (tooltipEnabled) {
            var evt = getEventObject(event);
            
            var tooltipPos = (tooltipShared && crosshair_enabled()) ? (
                    (axisrotated) ? ({
                            left: plotarea.width,
                            top: relmousePt.y,
                            actLeft: xval + plotarea.left,
                            actTop: relmousePt.y + plotarea.top
                        }) : ({
                            left: relmousePt.x,
                            top: 0,
                            actLeft: relmousePt.x + plotarea.left,
                            actTop: yval + plotarea.top
                        })
                ) : (
                    (axisrotated) ? ({
                            left: relmousePt.x,
                            top: relmousePt.y,
                            actLeft: xval + plotarea.left,
                            actTop: relmousePt.y + plotarea.top
                        }) : ({
                            left: relmousePt.x,
                            top: relmousePt.y,
                            actLeft: relmousePt.x + plotarea.left,
                            actTop: yval + plotarea.top
                        })
                );
            var dLeft = relmousePt.x - evt.clientX,
                dTop = relmousePt.y - evt.clientY;
            tooltipPos.left -= dLeft;
            tooltipPos.top -= dTop;
            tooltipPos.dLeft = dLeft + plotarea.left;
            tooltipPos.dTop = dTop + plotarea.top;
            
            var tooltipArgs = {
                "seriesindex": seriespos,
                "subseriespos": subseriesindex,
                "itempos": xpos,
                "color": color,
                "svgFillFunc":renderer.fillColorFunc,
                "tooltipSharedInfo": tooltipSharedInfo,
                "tooltipShared": tooltipShared
            };
            
            // TODO tooltipPos has to be changed with bellow code.
            // var tooltipPos = getTooltipPosition(evt, relmousePt, xval, yval, chartObj, nearestPoint, axisrotated, tooltipShared, tooltipSharedInfo, true);
            // tooltip.show(chartObj, tooltipPos, null, true, tooltipPos.helpers);
            
            tooltip.show(chartObj, tooltipPos, null, true, tooltipArgs);
        }
    }
    
    function xydatamouseMove(mouse, event, element) {
        var cursorFollowDist = 10,
            isPolar = chartObj.dataObject.isPolarAxisCategory;
        var relativeelement = bbox(element);
        var relMouseX = mouse[0] - relativeelement.x - (isPolar ? chartObj.plotarea_approx.x : 0);
        var relMouseY = mouse[1] - relativeelement.y - (isPolar ? chartObj.plotarea_approx.y : 0);
        var relmousePt = {
            x: relMouseX,
            y: relMouseY
        };
        
        var oldInfo = chartObj.eventHandler.oldInfo;
        var tooltipShared = systemConf.tooltip.sharedSeriesInfo;

        var evt = getEventObject(event),
            cur_container_top = relmousePt.y - event.clientY,
            cur_container_left = relmousePt.x - event.clientX;

        var nearestPoint = (tooltipShared) ? bisectX(relmousePt, xscale, yscale, systemConf) : getClosestPoint(relmousePt, xscale, yscale, systemConf);
        // var bisect = bisectX(relmousePt,xscale,yscale,systemConf)
        
        var seriespos = nearestPoint.seriesPos;
        var itemPos = nearestPoint.itemPos;
        var subseriesindex = nearestPoint.subseriesindex;
        
        var isNoInfo = (seriespos == null) ? true : false;
        if (seriespos == null) {
            // if(oldInfo != null && !oldInfo.isNoInfo){
            // 	console.log("mouseout")
            chartObj.eventHandler.mouseOut();
            // }
            chartObj.eventHandler.oldInfo = {
                "isNoInfo": isNoInfo
            }
            return
        }
        
        var seriesdata = chartObj.seriesdata;
        var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
        var ysc = yscale[yscindex].scale;
        var type = chartObj.chartTypes[seriespos].value;
        var isRangeChart = type == $ZC.charttype.arearange;
        var yrangePos = (isRangeChart) ? 1 : null;
        var rangeBand = xscale.rangeBand != null ? xscale.rangeBand() : null;
        var renderer = chartObj.renderer[seriespos];
        var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
        var data = currentSeriesdata[itemPos];
        var xdata = chartObj.dataset.getX(data);
        
        var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x", null, yrangePos);
        var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y", null, yrangePos);

        hoveredSeriesIndex = getLegendIndex(data, seriespos);

        var isAreaChart;
        if (!isPolar && isWithinPlotarea(xval, yval) == null) {
            return;
        }
        
        var tooltip = chartObj.eventHandler.tooltipElement;
        var distance = lineDistance({
            "x": xval,
            "y": yval
        }, relmousePt);
        // retaining oldinfo
        if (oldInfo != null && !tooltipShared) {
            var oldNearestPoint = oldInfo.nearestPoint;
            var oldType = getChartType((oldInfo.type || chartObj.userdata.seriesdata.type), NUMERIC_DATATYPE);
            if (oldNearestPoint && (oldNearestPoint.seriesPos == nearestPoint.seriesPos) && (oldNearestPoint.itemPos == nearestPoint.itemPos) && (oldNearestPoint.subseriesindex[oldNearestPoint.seriesPos] == nearestPoint.subseriesindex[nearestPoint.seriesPos]) && (oldType == type) && (oldInfo.containerLeft === cur_container_left) && (oldInfo.containerTop === cur_container_top)) {
                wrap.selectAll(isAreaChartType(type) ? "#zcscatterhighlight,#zcareahighlight" : "#zcscatterhighlight")
                    .style('display', "");
                tooltipele
                    .style("visibility", tooltipEnabled ? "visible" : "hidden");
                if (crosshair_enabled()) {
                    chartObj.staticPaneSVG.selectAll("g.crosshair").style("visibility", "visible")
                }
                return
            }
        }
        
        var seriesLen = (tooltipShared) ? chartObj.seriesdata.length : 1
        //highlighting new Info
        wrap.selectAll("#zcscatterhighlight").selectAll("*").remove();
        var tooltipSharedInfo = d3_map();
        
        for (var i = 0; i < seriesLen; i++) {
            var curSeriespos = (tooltipShared) ? i : seriespos;
            hoverSeries(chartObj, curSeriespos, xdata, itemPos, subseriesindex, nearestPoint, tooltipShared, (cursorFollowDist > distance), tooltipSharedInfo)
            
        }
        
        //tooltip
        if (tooltipEnabled) {
            var tooltipPos = (tooltipShared && crosshair_enabled()) ? (
                    (axisrotated) ? ({
                            left: plotarea.left,
                            top: yval,
                            actLeft: plotarea.left + xval,
                            actTop: plotarea.top + yval
                        }) : ({
                            left: xval,
                            top: 0,
                            actLeft: plotarea.left + xval,
                            actTop: plotarea.top + yval
                        })
                ) : ({
                    left: xval,
                    top: yval,
                    actLeft: (plotarea.left + xval),
                    actTop: (plotarea.top + yval),
                    distance: (chartObj.dataObject.isBubbleEnabled ? (chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "z", chartObj.zscale) / 2) : 0)
                });
            var dLeft = relmousePt.x - evt.clientX,
                dTop = relmousePt.y - evt.clientY;
            tooltipPos.left -= dLeft;
            tooltipPos.top -= dTop;
            tooltipPos.dLeft = dLeft + plotarea.left + (isPolar ? chartObj.plotarea_approx.x : 0);
            tooltipPos.dTop = dTop + plotarea.top + (isPolar ? chartObj.plotarea_approx.y : 0);
            
            var tooltipArgs = {
                "seriesindex": seriespos,
                "subseriespos": subseriesindex,
                "itempos": itemPos,
                "color": color,
                "svgFillFunc": (chartObj.dataObject.pieWithAxis ? chartObj.subrenderer[subseriesindex][xdata] : renderer).fillColorFunc,
                "tooltipShared": tooltipShared,
                "tooltipSharedInfo": tooltipSharedInfo
            };
            
            
            // TODO tooltipPos has to be changed with bellow code.
            // tooltipPos = getTooltipPosition(evt, relmousePt, xval, yval, chartObj, nearestPoint, axisrotated, tooltipShared, tooltipSharedInfo, false, isPolar);
            // if(chartObj.dataObject.isBubbleEnabled) {
            // 	tooltipPos.distance = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "z", chartObj.zscale) / 2;
            // }
            
            tooltip.show(chartObj, tooltipPos, null, true, tooltipArgs);
            
            // tooltip.show(chartObj,tooltipele,labelhighter,systemConf,dataset,{},{x:tooltip.formatValue(systemConf,xdata,"x"),y:ydata},seriespos,subseriesindex,itemPos,wrap,color,"numeric",plotarea,event);

            var oldInfo = chartObj.eventHandler.oldInfo;
            if (oldInfo) {
                oldInfo.containerLeft = cur_container_left;
                oldInfo.containerTop = cur_container_top;
            }
        }
        
    }
    
    function hoverPolygon(areahighlightWrap, type, plotOptions, commonPlotOptions, seriespos, subseriesindex, itemPos, xscale, ysc, yscindex, rangeBand, poly) {
        var seriesdata = chartObj.seriesdata;
        var fillOpacity = chartObj.systemConf.legend.patternPallete ? 0.5 : 0.2,
            fillColor = getRawColor(chartObj, seriespos, getCurrentDataPoint(seriespos, subseriesindex, itemPos), seriespos);
        var highlightEffect = chartObj.legendHighlight.getLegendHighlightEffect(seriespos, "selectedSeries", "plot");
        var highlightStyle = (highlightEffect === "none") ? {
                "fill": "transparent"
            } : chartObj.legendHighlight.getEffect(highlightEffect, "area", fillColor, {fill: "transparent", stroke:fillColor}, seriespos);
        hideUnselectedWrap(wrap.selectAll("g#zcbarhighlight"));
        areahighlightWrap.style("display", "")
            .attr("transform", "translate(" + plotarea.left + "," + (plotarea.top) + ")")
            .style(highlightStyle);
        var interpolation = gvpFn(plotOptions, commonPlotOptions)("mode"),
            fillOpacity = validateNullVal(commonPlotOptions.hoveroptions.fillOpacity, 0.2);
        var y0 = null;
        var x1, y1, x2, y2;
        var x, y, width, height;
        var isCatNullX = isCatNull(dataset, "x"),
            isCatNullY = isCatNull(dataset, "y", yscindex);
        
        if (interpolation == "linear" && poly != null) {
            var polyPoints = d3_merge(poly.map(function(d, i) {
                return [d.x, d.y]
            }));
            
            var polygon = appendEle(areahighlightWrap, "polygon", [poly], ".", "class", "areapoly");
            polygon
                .attr("points", polyPoints.toString())
                .style({
                    "fill-opacity": fillOpacity,
                    "display": ""
                });
        } else {
            var isStkd = stacked(type),
                hasNegValue = chartObj.dataObject.containsNegativeData(yscindex),
                xaxisReversed = chartObj.systemConf.chart.axes.xaxis.reversed,
                yaxisReversed = chartObj.systemConf.chart.axes.yaxis[yscindex || 0].reversed,
                area, serdata;
            if (chartObj.dataObject.isPolarAxisCategory) {
                var renderer = chartObj.renderer[seriespos];
                serdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
                var polarBaseIdx = (yaxisReversed && !isStkd) ? ysc.domain().length - 1 : 0;

                var outerRadiusFn = function(d, j) {
                        var OR = (isStkd) ? ysc(d.y0 + d.y) : (ysc(dataset.getY(d, yscindex)) + ((ysc.rangeBand != null) ? ysc.rangeBand() / 2 : 0));
                        return mathMax(OR, ysc.range()[polarBaseIdx]);
                    },
                    innerRadiusFn = function(d, j) {
                        var IR;
                        if (isStkd) {
                            IR = (seriespos == 0) ? mathMin(ysc.range()[0], ysc(hasNegValue)) : ysc(d.y0);
                        } else {
                            IR = (ysc(ysc.domain()[polarBaseIdx]) + ((ysc.rangeBand != null) ? ysc.rangeBand() / 2 : 0));
                        }
                        return mathMax(IR, ysc.range()[polarBaseIdx]);
                    },
                    isLineHighlight = highlightEffect === "strokeEnlarge";

                area = (isLineHighlight ? d3_lineRadial : d3_areaRadial)()
                    .angle(function(d, j) {
                        return xscale(dataset.getX(d));
                    })
                    .interpolate(interpolation);

                if (isLineHighlight) {
                    area
                    .radius(outerRadiusFn);
                } else {
                    area
                    .outerRadius(outerRadiusFn)
                    .innerRadius(innerRadiusFn);
                }
   
            } else {
                var isRangeChart = type == $ZC.charttype.arearange;
                var yrangePos = (isRangeChart) ? 1 : null;
                var renderer = chartObj.renderer[seriespos];
                var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
                var data = currentSeriesdata[itemPos];
                var xval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, data, "x", null, yrangePos),
                    yval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, data, "y", null, yrangePos),
                    isNotFirstData = (itemPos != 0),
                    isNotLastData = (itemPos != currentSeriesdata.length - 1);

                if (xaxisReversed ? isNotLastData : isNotFirstData) {
                    var prevData = currentSeriesdata[xaxisReversed ? (itemPos + 1) : (itemPos - 1)];
                    var prevXval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, prevData, "x", null, yrangePos);
                    var prevYval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, prevData, "y", null, yrangePos);
                    x1 = (xval + prevXval) / 2;
                    y1 = (yval + prevYval) / 2;
                }
                if (xaxisReversed ? isNotFirstData : isNotLastData) {
                    var nextData = currentSeriesdata[xaxisReversed ? (itemPos - 1) : (itemPos + 1)]
                    var nextXval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, nextData, "x", null, yrangePos);
                    var nextYval = chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, nextData, "y", null, yrangePos);
                    x2 = (xval + nextXval) / 2;
                    y2 = (yval + nextYval) / 2;
                }
                
                x = (axisrotated) ? 0 : (x1 == null) ? xval : x1;
                y = d3_min([y1, yval, y2, ysc(ysc.domain()[yaxisReversed ? 0 : 1])]);
                width = (axisrotated) ? (d3_max([x1, xval, x2, (ysc(hasNegValue) || xval)])) : (x1 != null && x2 != null) ? (x2 - x1) : (x1 == null) ? ((x2 == null) ? 1 : (x2 - xval)) : (xval - x1);
                height = (axisrotated) ? ((y1 == null) ? (yval - y2) : ((y2 == null) ? (y1 - yval) : (y1 - y2))) : plotarea.height - y;

                var dx1 = Math.max(0, -x),
                    dy1 = Math.max(0, -y),
                    dx2 = Math.max(0, x + width - plotarea.width - (chartObj.scrolledX || 0)),
                    dy2 = Math.max(0, y + height - plotarea.height - (chartObj.scrolledY || 0));

                x = Math.max(0, x);
                y = Math.max(0, y);
                width -= (dx1 + dx2);
                height -= (dy1 + dy2);
                
                areahighlightWrap
                    .style("display", "block");
                
                serdata = currentSeriesdata;
                area = d3_area()
                    .defined(function(d, j) {
                        return !isCatNullY(dataset.getY(d, yscindex)) && !isCatNullX(dataset.getX(d));
                    })
                    .x(function(d, j) {
                        return chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, d, "x")
                    })
                    .y(function(d, j) {
                        return chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, d, "y", null, yrangePos)
                    })
                    .interpolate(interpolation);
                if (axisrotated) {
                    area.x0(function(d, i) {
                        if (isStkd) {
                            return ((seriespos == 0) && (subseriesindex == 0) && (i == 0)) ? mathMax(ysc.range()[0], ysc(hasNegValue)) : ysc(d.y0);
                        } else {
                            return (ysc.rangeBand != null) ? (ysc.range()[0] + ysc.rangeBand()) : mathMax(ysc.range()[0], ysc(hasNegValue));
                        }
                    });
                } else {
                    area.y0(function(d, i) {
                        if (isStkd) {
                            return ((seriespos == 0) && (subseriesindex == 0) && (i == 0)) ? mathMin(ysc.range()[0], ysc(hasNegValue)) : ysc(d.y0);
                        } else {
                            if (isRangeChart) {
                                return chartObj.dataObject.getXYvalue(axisrotated, isStkd, xscale, ysc, yscindex, d, "y", null, 0);
                            } else {
                                return (ysc.rangeBand != null) ? (ysc.range()[0] + ysc.rangeBand()) : mathMin(ysc.range()[0], ysc(hasNegValue));
                            }
                        }
                        // return (ysc.rangeBand != null) ? (ysc.range()[0]+ysc.rangeBand()) : Math.min(ysc.range()[0],ysc(hasNegValue));}
                    });
                }
            }

            var properties = {
                name: "rect",
                id: chartObj.id,
                x: x,
                y: y,
                width: width,
                height: height
            },
            args = {
                chartObj: chartObj
            };
            var clipID = effects.get(svg_clips, "rect", properties, args);

            var areahighlight = wrap.selectAll("#areapath");
            areahighlight.datum(serdata)
                .attr("d", area)
                .attr("stroke", "")
                .attr("clip-path", chartObj.dataObject.isPolarAxisCategory ? null : "url(" + chartObj.defsLocation + "#" + clipID + ")")
                .style({
                    "fill-opacity": fillOpacity,
                    "display": ""
                });
        }
        
        
    }
    
    function hoverRect(barWrap, highlightpoint, radius, renderer, yaxisReversed) {
        var t = getRectTranslation(highlightpoint),
            path = getRect(highlightpoint, radius, yaxisReversed);

        hideUnselectedWrap(wrap.selectAll("g#zcareahighlight,g#zcscatterhighlight"));
        wrap.selectAll("g#zcbarhighlight").style("display", "");
        barWrap
            .attr("d", path)
            .attr("transform", "translate(" + t[0] + "," + t[1] + ")")
            .style("display", "");
    }
    
    function hoverScatter(scatterWrap, type, plotOptions, commonPlotOptions, xval, yval, xscale, ysc, yscindex, seriesdata, subseriesindex, seriespos, itemPos, isAreaChart, ganttMarkerProp) {
        var isGantt = type == $ZC.charttype.gantt,
            highlightEffect = chartObj.legendHighlight.getLegendHighlightEffect(seriespos, "selectedSeries", "plot"),
            isPatternPalleteEnabled = hasPatternPallete(chartObj) && (isBubbleChartType(type) || type === $ZC.charttype.scatter) && (highlightEffect !== "strokeEnlarge"),
            fillColor = getRawColor(chartObj, (commonPlotOptions.multiColoring && !chartObj.legendarea.show ? itemPos : seriespos), getCurrentDataPoint(seriespos, subseriesindex, itemPos), seriespos);
        if (!isGantt) {
            hideUnselectedWrap(wrap.selectAll("g#zcbarhighlight"));
        }
        if (!isAreaChart && !chartObj.dataObject.isPolarAxisCategory) {
            hideUnselectedWrap(wrap.selectAll("g#zcareahighlight").selectAll("*"));
            hideUnselectedWrap(wrap.selectAll("g#zcareahighlight"));
        }
        
        var scatterParentWrap = wrap.selectAll("#zcscatterhighlight"),
            mOptions = (plotOptions ? mergeJSON(commonPlotOptions.hoveroptions, plotOptions.hoveroptions, true) : commonPlotOptions.hoveroptions),
            innerSymbolSize, outerSymbolSize;
        
        if (isGantt && commonPlotOptions.marker && commonPlotOptions.marker.enabled === false) {
            return
        }
        
        if (isBubbleChartType(type)) {
            var z = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, seriesdata[seriespos].data[subseriesindex][itemPos], "z", chartObj.zscale);

            if (isPatternPalleteEnabled) {
                outerSymbolSize = z * 0.1;
                innerSymbolSize = 0;
            } else {
                outerSymbolSize = (z + perToPx("2.5%", mathMin(plotarea.width, plotarea.height))) * 0.1;
                innerSymbolSize = (z / 2) * 0.1;
            }

        } else {
            var lineOrArea = (type === $ZC.charttype.line || isAreaChartType(type)),
                isPolar = chartObj.dataObject.isPolarAxisCategory,
                markerSize = (plotOptions && plotOptions.marker) ? gvpFn(plotOptions.marker, commonPlotOptions.marker)("size") : commonPlotOptions.marker.size;
            
            var symbolsize = ((lineOrArea || isPolar) && (markerSize == null || markerSize === "")) ? gvpFn(plotOptions, commonPlotOptions)("strokeWidth") : (markerSize || 1);
            symbolsize = (mOptions.size != null && mOptions.size !== "") ? 1 : +symbolsize;
            if (isGantt) {
                mOptions = (plotOptions ? mergeJSON(ganttMarkerProp.hoveroptions, plotOptions.hoveroptions, true) : ganttMarkerProp.hoveroptions)
            }

            var outerSymbolSizeFactor,
                innerSymbolSizeFactor;

            if (isPolar) {
                outerSymbolSizeFactor = 0.7;
                innerSymbolSizeFactor = 0.35;
            } else if (lineOrArea) {
                outerSymbolSizeFactor = 0.9;
                innerSymbolSizeFactor = 0.4;
            } else if (isPatternPalleteEnabled) {
                outerSymbolSizeFactor = 1;
                innerSymbolSizeFactor = 0;
            } else {
                outerSymbolSizeFactor = 2;
                innerSymbolSizeFactor = 1;
            }

            outerSymbolSize = symbolsize * outerSymbolSizeFactor;
            innerSymbolSize = symbolsize * innerSymbolSizeFactor;
        }
        
        scatterParentWrap
            .attr("transform", "translate(" + plotarea.left + "," + plotarea.top + ")")
            .style('display', "");
        addSVGmarker(scatterWrap, null, (isPatternPalleteEnabled ? {symbol: mOptions.symbol} : mOptions), {
            "color": isPatternPalleteEnabled ? null : fillColor,
            symbolSize: {
                "inner": innerSymbolSize,
                "outer": outerSymbolSize
            },
            "transform": [xval, yval],
            "imageSize": 15
        });

        if (isPatternPalleteEnabled) {
            var highlightStyle = (highlightEffect === "none") ? {
                    "fill": "transparent"
                } : chartObj.legendHighlight.getEffect(highlightEffect, "scatter", (/(illuminate|moody|flip)/.test(highlightEffect) ? fillColor : "transparent"), {fill: "transparent", stroke:fillColor}, seriespos);
            scatterWrap.style(highlightStyle);
        }

    }
    
    function hoverSeries(chartObj, seriespos, actXdata, itemPos, subseriesindex, nearestPoint, tooltipShared, showCursor, tooltipSharedInfo, highlightPoints) {
        var seriesdata = chartObj.seriesdata;
        var yscindex = getParsedYAxisOrder(seriesdata[seriespos].yaxiscolumnorder);
        var ysc = yscale[yscindex].scale;
        var type = chartObj.chartTypes[seriespos].value;
        var isRangeChart = type == $ZC.charttype.arearange;
        var isGantt = type === $ZC.charttype.gantt;
        var isPolar = chartObj.dataObject.isPolarAxisCategory;
        var yrangePos = (isRangeChart || isGantt) ? 1 : null;
        var rangeBand = xscale.rangeBand != null ? xscale.rangeBand() : null;
        var renderer = chartObj.renderer[seriespos];
        var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesindex] : seriesdata[seriespos].data[subseriesindex];
        var actData = currentSeriesdata[itemPos];
        itemPos = (actData && dataset.getX(actData) === actXdata) ? itemPos : getContinousDataItempos(actXdata, currentSeriesdata);
        if (itemPos == null || eventDisabled(chartObj.seriesdata[seriespos])) { // If there is no data for this particular item for this series
            return
        }
        
        tooltipSharedInfo.set(seriespos, itemPos);
        add_pattern_to_tooltipSharedInfo(tooltipSharedInfo, seriespos);
        
        var data = currentSeriesdata[itemPos];
        var isAreaChart;
        
        var xval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x", null, yrangePos);
        var yval = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y", null, yrangePos);
        
        var plotOptions = seriesdata[seriespos].plotoptions;
        var commonPlotOptions = systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)],
            eventType = (chartObj.zcEventType) || "mousemove";
        var mouseMoveFn = getEventConf(plotOptions, commonPlotOptions, chartObj, eventType),
            cursor = getEventConf(plotOptions, commonPlotOptions, chartObj, "cursor");
        
        if (!((type === $ZC.charttype.line || type === $ZC.charttype.scatter && (showCursor)))) {
            events.addCursor(cursor);
        } else {
            events.hideCursor(chartObj.eventHandler.trackerElement);
        }
        
        if (mouseMoveFn != null) {
            var evt = d3.event || chartObj.eventHandler.targetEvent;
            ((typeof mouseMoveFn === "string") ? window[mouseMoveFn] : mouseMoveFn)(evt, {
                "x": xval,
                "y": yval,
                "data": chartObj.dataset.getMetaInfoObj(chartObj, seriesdata[seriespos].data[subseriesindex][itemPos], seriespos)
            }, chartObj);
        } else {
            highlightpoint = highlightPoints || highlightpoint;
            if (highlightpoint != null && isBarChartType(type)) {
                var yaxisReversed = chartObj.systemConf.chart.axes.yaxis[yscindex || 0].reversed;
                var borderOptions = gvpFn(plotOptions, commonPlotOptions)("border") || {};
                var borderRadius = (type === $ZC.charttype.bullet) ? 0 : borderOptions.radius;
                borderRadius = (borderOptions && borderOptions.show) ? borderRadius : 0;
                var renderer = chartObj.renderer[seriespos];
                //radius = renderer.getParamValue("radius",null,null,null,borderRadius);
                var radius = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, borderRadius);
                var highlightEffect = chartObj.legendHighlight.getLegendHighlightEffect(seriespos, "selectedSeries", "plot"),
                    fillColor = getRawColor(chartObj, (commonPlotOptions.multiColoring && !chartObj.legendarea.show ? itemPos : seriespos), getCurrentDataPoint(seriespos, subseriesindex, itemPos), seriespos);
                var highlightStyle = (highlightEffect === "none") ? {
                        "fill": "transparent"
                    } : chartObj.legendHighlight.getEffect(highlightEffect, "bar", (/(illuminate|moody|flip)/.test(highlightEffect) ? fillColor : "transparent"), {fill: "transparent", stroke:fillColor}, seriespos);
                
                var barWrap = wrap.selectAll("#zcbarhighlight").select("#barpath")
                    .style(highlightStyle);
                hoverRect(barWrap, highlightpoint, radius, renderer, yaxisReversed);
                var levelMarker = (plotOptions && plotOptions.levelMarker) ? mergeJSON(commonPlotOptions.levelMarker, plotOptions.levelMarker, true) : commonPlotOptions.levelMarker;
                if (isGantt && levelMarker.enabled) {
                    
                    var levelMarkrad = chartObj.dataObject.getTransRectValue("radius", null, null, null, 0);
                    var style = {
                        "fill": levelMarker.color || fillColor
                    };
                    var levelMarkerWrap = appendEle(wrap.selectAll("#zcbarhighlight"), "path", [1], "#", "id", "levelMarkerpath");
                    levelMarkerWrap.style(style)
                    hoverRect(levelMarkerWrap, levelMarkerPoint, levelMarkrad, renderer, yaxisReversed)
                }
            }
            
            if (!tooltipShared && (isAreaChartType(type) || isPolar)) {
                isAreaChart = true;
                var areahighlightWrap = wrap.selectAll("#zcareahighlight");
                hoverPolygon(areahighlightWrap, type, plotOptions, commonPlotOptions, seriespos, subseriesindex, itemPos, xscale, ysc, yscindex, rangeBand, nearestPoint.poly)
            }
            if (isAreaChartType(type) || isPointChartType(type) || type === $ZC.charttype.line || isPolar || isGantt) {
                var scatterWrap = wrap.selectAll("#zcscatterhighlight");
                var currentWrap = appendEle(scatterWrap, "g", [1], ".", "class", ("highlight" + seriespos));
                var ganttMarkerSize = 0;
                
                if (isRangeChart || isGantt) {
                    var yrangePos_0 = appendEle(currentWrap, "g", [1], ".", "class", "yrangePos_0");
                    var yrangePos_1 = appendEle(currentWrap, "g", [1], ".", "class", "yrangePos_1");
                    var xval_0, yval_0, prop = {};
                    if (isGantt) {
                        prop = renderer.markerProperties;
                        
                        var pos = renderer.getMarkerPosition(data, prop.subseriesIndex, 0, renderer.commonOption);
                        if (axisrotated) {
                            xval = pos.y;
                            yval = pos.x + pos.width / 2;
                            xval_0 = pos.y + pos.height;
                            yval_0 = pos.x + pos.width / 2;
                        } else {
                            xval = pos.x + pos.width / 2;
                            yval = pos.y;
                            xval_0 = pos.x + pos.width / 2;
                            yval_0 = pos.y + pos.height;
                        }
                    } else {
                        xval_0 = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "x", null, 0);
                        yval_0 = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, data, "y", null, 0);
                        ;
                    }
                    hoverScatter(yrangePos_0, type, plotOptions, commonPlotOptions, xval_0, yval_0, xscale, ysc, yscindex, seriesdata, subseriesindex, seriespos, itemPos, isAreaChart, {
                        "size": prop.size,
                        "hoveroptions": commonPlotOptions.hoveroptions.end
                    });
                    hoverScatter(yrangePos_1, type, plotOptions, commonPlotOptions, xval, yval, xscale, ysc, yscindex, seriesdata, subseriesindex, seriespos, itemPos, isAreaChart, {
                        "size": prop.size,
                        "hoveroptions": commonPlotOptions.hoveroptions.start
                    })
                } else {
                    hoverScatter(currentWrap, type, plotOptions, commonPlotOptions, xval, yval, xscale, ysc, yscindex, seriesdata, subseriesindex, seriespos, itemPos, isAreaChart)
                }
                
            }
            
            if (isPolar) {
                wrap.selectAll("#zcareahighlight,#zcscatterhighlight")
                    .attr({
                        "clip-path": null,
                        "transform": "translate(" + (plotarea.left + chartObj.plotarea_approx.x) + "," + (plotarea.top + chartObj.plotarea_approx.y) + ")"
                    })
                    .style("display", "");
            }
            
        }
        chartObj.eventHandler.oldInfo = {
            "nearestPoint": nearestPoint,
            "type": type,
            "chartObj": chartObj,
            "isNoInfo": false
        };
    }
    
    function add_pattern_to_tooltipSharedInfo(tooltipSharedInfo, seriespos) {
        var clrIdx = dataset.getColumnIdx("clr"),
            yidx = dataset.getColumnIdx("y", (chartObj.seriesdata[seriespos].yaxiscolumnorder || [0, 0]));
        var y_pattern = "{{val(" + yidx + ")}}";
        tooltipSharedInfo.y_val_pattern = tooltipSharedInfo.y_val_pattern || "";
        tooltipSharedInfo.y_col_pattern = tooltipSharedInfo.y_col_pattern || "";
        
        if (tooltipSharedInfo.y_val_pattern.indexOf(y_pattern) == -1) {
            tooltipSharedInfo.y_val_pattern += y_pattern;
            tooltipSharedInfo.y_col_pattern += (chartObj.ismultiy || clrIdx == null) ?
                ((tooltipSharedInfo.y_col_pattern != "") ? "" : "{{val(null)}}") :
                "{{val(" + clrIdx + ")}}";
        }
    }
    
    function getOrdinalDataPoint(relmousePt, xscale, yscale, systemConf) {
        var xaxisReversed = chartObj.systemConf.chart.axes.xaxis.reversed;
        var categorypos = $ZC.scale.invert(ORDINAL_DATATYPE, relmousePt, barscale1, axisrotated, null, xaxisReversed);
        
        
        var seriesdata = chartObj.seriesdata;
        var isComboChart = chartObj.dataObject.isCombinationalChart;
        
        var series_enabled = -1;
        var highlightpoint, levelMarkerPoint, itemPos, minTriggerOffset, xpos, subseries;
        var poly = null;
        var containsLine = false;
        var toHighlight = false;
        var tooltipShared = systemConf.tooltip.sharedSeriesInfo;
        
        var X = "x",
            Y = "y";
        if (axisrotated) {
            X = "y";
            Y = "x";
        }
        
        var yminimumBisected = seriesdata.map(function(d, i) {
            var type = chartObj.chartTypes[i].value;
            minTriggerOffset =  (minTriggerOffset == null) ? getTriggeringOffset(type,tooltipShared,chartObj.dataObject.isCombinationalChart,null) : minTriggerOffset;
            var yaxiscolumnorder = getParsedYAxisOrder(d.yaxiscolumnorder);
            var yaxisReversed = chartObj.systemConf.chart.axes.yaxis[yaxiscolumnorder || 0].reversed;
            var ysc = yscale[yaxiscolumnorder].eventscale;
            var hasNegValue = chartObj.dataObject.containsNegativeData(yaxiscolumnorder),
                isCatNullY = isCatNull(dataset, "y", yaxiscolumnorder),
                polygonPoints = {};
            
            if (eventDisabled(d)) {
                return [null]
            } else {
                series_enabled++;
                var renderer = chartObj.renderer[i];
                
                /**
                 *
                 * @type {*|{stacked, categories, axisrotated, bandwidth1, bandwidth2, barDatasetIndex, padding, yscale, hasNegValue, yaxiscolumnorder, addRangeBand, barWidth, levelMarkerWidth, levelMarkerPadding}|*}
                 */
                var commonOption = renderer.commonOption || getBarCommonOption(chartObj.rendererConf[i], i);
                
                return d.data.map(function(d, j) {
                    // var curpt = {};
                    var seriesdataAfterUpdate = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[j] : d;
                    xpos = getCategoryXpos(categorypos, seriesdataAfterUpdate) || null; //fix for different category set for two different series
                    if(xpos == null){
                        return;
                    }
                    if (isHeatMapChartType(type)) {
                        var a = null;
                        seriesdataAfterUpdate.forEach(function(dt, k) {
                            var curpt = getHeatCellPosition(chartObj, dt, xscale, ysc, yaxiscolumnorder);
                            var isWithinClrRange = isWithinColorRange(dataset.getClr(dt), chartObj);
                            var dist = isWithin(curpt, relmousePt);

                            if (isWithinClrRange && dist == 0 && !toHighlight && a === null) {
                                toHighlight = true;
                                itemPos = k;
                                highlightpoint = curpt;
                                a = dist;
                            }

                        });
                        return a;
                    } else if (isBarChartType(type)) {
                        var len = xpos.length;
                        var dist = null;
                        for(var m = 0;m<len;m++){
                            var curXpos = xpos[m]; //Handled multi data for same category
                            if (seriesdataAfterUpdate[curXpos] == null) {
                                return null;
                            }

                            var curpt = getBarPosition(chartObj, seriesdataAfterUpdate[curXpos], j, commonOption);

                            if (isCatNullY(seriesdataAfterUpdate[curXpos])) { //If the y value is null and nullformatter is undefined, don't show tooltip for that data
                                return null;
                            }
                            var curdist = isWithin(curpt, relmousePt, yaxisReversed);
                            var isWithinClrRange = isWithinColorRange(dataset.getClr(seriesdataAfterUpdate[curXpos]), chartObj);

                            if (isWithinClrRange && curdist == 0 && !toHighlight) {
                                dist = 0;
                                toHighlight = true;
                                itemPos = curXpos;
                                highlightpoint = curpt;
                                if (type === $ZC.charttype.gantt) {
                                    levelMarkerPoint = renderer.getGanttLevelMarkerProp(seriesdataAfterUpdate[curXpos], j, curXpos, commonOption);
                                }
                            }
                        }
                        return dist;
                    } else if (isAreaChartType(type) || isPointChartType(type) || type === $ZC.charttype.line) {
                        xpos = xpos[0]; //Hack for other charts where multi data for same category not handled
                        minTriggerOffset = isBubbleChartType(type) ? getTriggeringOffset(type,tooltipShared,chartObj.dataObject.isCombinationalChart,chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yaxiscolumnorder, seriesdataAfterUpdate[xpos], "z", chartObj.zscale) / 2) : minTriggerOffset;
                        var isWithinClrRange = isWithinColorRange(dataset.getClr(seriesdataAfterUpdate[xpos]), chartObj);

                        if (isScatterChartType(type) || type === $ZC.charttype.line) {
                            var markerSize = (renderer.getSymbolSize) ? renderer.getSymbolSize(d) : 0;
                            dist = getMinDistByPtToPt(seriesdataAfterUpdate[xpos], relmousePt, xscale, ysc, yaxiscolumnorder, type, null, X, Y);
                            dist = dist - (markerSize/2);
                        } else {
                            var isRangeChart = type == $ZC.charttype.arearange;
                            polygonPoints = getPolygonPoints(i, j, xpos, seriesdataAfterUpdate, seriesdataAfterUpdate[xpos - 1], seriesdataAfterUpdate[xpos], seriesdataAfterUpdate[xpos + 1], chartObj.dataObject, dataset, axisrotated, stacked(type), xscale, ysc, yaxiscolumnorder, hasNegValue, isRangeChart)
                            var isWithinPoly = (isAreaChartType(type) || isComboChart) ? ((type === $ZC.charttype.bubblepie) ? pointInPie(relmousePt, polygonPoints, i, j, seriesdataAfterUpdate[xpos]) : pointInPolygon(relmousePt, polygonPoints.points)) : true;
                            if (isWithinPoly) {
                                dist = (j == 0) ? distToSegment(relmousePt, polygonPoints.curpt, polygonPoints.curNext) :
                                    (j == seriesdataAfterUpdate.length - 1) ? distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt) :
                                        d3_min([distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt), distToSegment(relmousePt, polygonPoints.curpt, polygonPoints.curNext)]);
                            }
                        }
                        
                        if (isWithinClrRange && (minTriggerOffset == null || dist < minTriggerOffset) && dist != null) {
                            toHighlight = true;
                            minTriggerOffset = dist;
                            seriespos = i;
                            subseries = j;
                            itemPos = xpos;
                            poly = polygonPoints.points;
                            containsLine = (type === $ZC.charttype.line || isPointChartType(type));
                        }
                        return dist
                    }
                    
                })
            }
            
        });
        
        var subseriesindex = [];
        var min_yminimumBisected = yminimumBisected.map(function(d, i) {
            var min = d3_min(d);
            subseriesindex[i] = (min != null) ? d.indexOf(min) : null;
            return min
        });
        if (containsLine) {
            min_yminimumBisected = min_yminimumBisected.map(function(d, i) {
                var type = chartObj.chartTypes[i].value;
                if (type === $ZC.charttype.line || isPointChartType(type)) {
                    return d;
                } else {
                    return null
                }
            })
        }
        
        var seriespos = min_yminimumBisected.indexOf(d3_min(min_yminimumBisected));
        if (min_yminimumBisected[seriespos] == null || !toHighlight) {
            seriespos = null
        }
        return {
            "seriesPos": seriespos,
            "itemPos": itemPos,
            "subseriesindex": subseriesindex,
            "highlightpoint": highlightpoint || null,
            "levelMarkerPoint": levelMarkerPoint || null,
            "distance": min_yminimumBisected[seriespos],
            "poly": poly
        };
    }
    
    function getCategoryXpos(xpos, data, isMultiCat) {
        var categories = xscale.domain();
        var xval = categories[xpos],
            pos = null,
            isCatNullX = isCatNull(dataset, "x");
        data.forEach(function(d, i) {
            var hasX = !isCatNullX(dataset.getX(d)) && (dataset.getX(d) === xval);
            if (hasX) {
                (pos == null) ?pos =  [i] : pos.push(i); // Create array for multiple data for same category
            }
            return hasX;
        });
        return pos;
    }
    
    function getContinousDataItempos(item, data) {
        var pos = null,
            isCatNullX = isCatNull(dataset, "x");
        data.some(function(d, i) {
            var hasX = !isCatNullX(dataset.getX(d)) && (dataset.getX(d) === item);
            if (hasX) {
                pos = i;
            }
            return hasX;
        });
        return pos;
    }
    
    function addNoteFunction(args, seriespos, itemPos, currentSeriesdata, xval, yval) {
        var canAddOnDoubleclickEvent = (chartObj.systemConf.notes) && chartObj.systemConf.notes.addOnDoubleclickEvent;
        if ($ZC.annotation && canAddOnDoubleclickEvent) {
            if (!args) {
                var seriesdata = chartObj.seriesdata;
                var currentEle = currentSeriesdata[itemPos];
                var clonedata = currentEle.slice();
                var data = clonedata.splice(0, clonedata.length);
                if (seriesdata.length > 1) {
                    data.push(seriesdata[seriespos].seriesname);
                }
                args = {
                    "coordinate": [xval, yval],
                    "data": data,
                    "basedOn": "plot"
                };
            }
            $ZC.annotation.addNotes(chartObj, args);
        }
    }
    
    function bisectX(relmousePt, xscale, yscale, systemConf) {
        var plotX = xscale.invert((axisrotated) ? relmousePt.y : relmousePt.x);
        var seriesdata = systemConf.seriesdata.chartdata;
        
        var xBisector = d3_bisector(function(d) {
            return dataset.getX(d)
        }).left;
        
        var xbisect = seriesdata.map(function(d, i) {
            if (d.disabled) {
                return null;
            }

            var renderer = chartObj.renderer[i];
            return d.data.map(function(d, j) {
                d = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[j] : d;
                return xBisector(d, plotX, 0, d.length - 1);
            })
            
        });
        
        var xminimumBisected = seriesdata.map(function(d, i) {
            if (d.disabled) {
                return null;
            }

            var renderer = chartObj.renderer[i];
            var yscindex = getParsedYAxisOrder(d.yaxiscolumnorder);
            var type = chartObj.chartTypes[i].value;
            var ysc = yscale[yscindex].scale;
            return d.data.map(function(d, j) {
                d = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[j] : d;
                var xbis = xbisect[i][j],
                    curpt,
                    isWithinClrRange;

                if (d[xbis]) { //Test_615.json If seriesdata.chartdata[i].data =[[]] and other series has data, d[xbis] will be null
                    curpt = {
                        x: xscale(dataset.getX(d[xbis])),
                        y: (stacked(type) ? ysc(d[xbis].y + d[xbis].y0) : ysc(dataset.getY(d[xbis], yscindex)))
                    };
                    isWithinClrRange = isWithinColorRange(dataset.getClr(d), chartObj);
                }

                if (xbis > 0) {
                    var dis = mathAbs(relmousePt.x - curpt.x)
                    var prevpt = {
                        x: xscale(dataset.getX(d[xbis - 1])),
                        y: (stacked(type) ? ysc(d[xbis - 1].y + d[xbis - 1].y0) : ysc(dataset.getY(d[xbis - 1], yscindex)))
                    };
                    var prevptDis = mathAbs(relmousePt.x - prevpt.x);
                    var vv = ((dis) > (prevptDis) ? xbis - 1 : xbis);
                    dis = (dis) > (prevptDis) ? prevptDis : dis;
                    var curpt2mousedis = lineDistance(curpt, relmousePt);
                    var prept2mousedis = lineDistance(relmousePt, prevpt);
                    return {
                        "dist": isWithinClrRange ? dis : null,
                        "xbis": vv
                    };
                } else if (xbis == 0) {
                    var dis = (isWithinClrRange && curpt) ? mathAbs(relmousePt.x - curpt.x) : null;
                    return {
                        "dist": dis,
                        "xbis": xbis
                    };
                }
            })
            
        });
        var subseriesindex = [];
        var xpos = [];
        var min_xminimumBisected = xminimumBisected.map(function(d, i) {
            if (!d) {
                return null;
            }
            var arr = d.map(function(d) {
                return d.dist
            })
            var min = d3_min(arr);
            var idx = arr.indexOf(min);
            subseriesindex[i] = (min) ? idx : null;
            xpos[i] = (min) ? d[idx].xbis : null;
            return min;
        });
        var seriespos = min_xminimumBisected.indexOf(d3_min(min_xminimumBisected));
        var itemPos = xpos[seriespos];
        // console.log("minbisect")
        // console.log(itemPos)
        return {
            "itemPos": itemPos,
            "seriesPos": seriespos,
            "subseriesindex": subseriesindex[seriespos]
        };
    }
    
    function getClosestPoint(relmousePt, xscale, yscale) {
        var mindist_trigger, dist,
            is_within_bubble, bubbleRadius, cx, cy, prevBubbleInfo,
            series, subseries, item,
            seriesdata = chartObj.seriesdata,
            poly = null,
            isPolar = chartObj.dataObject.isPolarAxisCategory,
            tooltipShared = systemConf.tooltip.sharedSeriesInfo,
            bubbleTriggerOffset = chartObj.dataObject.isBubbleEnabled ? (chartObj.zscale.range()[1] / 2 + 50) : null,
            prev_trigger_offset = null;
        
        var X = "x",
            Y = "y";
        if (axisrotated) {
            X = "y";
            Y = "x";
        }
        seriesdata.map(function(d, i) {
            
            var chartType = chartObj.chartTypes[i],
                type = chartType.value,
                chartName = chartType.name,
                isRangeChart = type == $ZC.charttype.arearange;

            var cur_trigger_offset = getTriggeringOffset(type,tooltipShared,chartObj.dataObject.isCombinationalChart,bubbleTriggerOffset);
            if (!eventDisabled(d)) {
                if (chartObj.dataObject.isCombinationalChart) {
                    if (!defined(mindist_trigger) || (defined(series) ? (cur_trigger_offset != null && cur_trigger_offset <= mindist_trigger) : (cur_trigger_offset < prev_trigger_offset || prev_trigger_offset == null || cur_trigger_offset == null))) {
                        mindist_trigger = cur_trigger_offset;
                    }
                } else {
                    mindist_trigger =  (mindist_trigger == null) ? cur_trigger_offset : mindist_trigger;
                }
            }

            var renderer = chartObj.renderer[i];
            var yscindex = getParsedYAxisOrder(d.yaxiscolumnorder);
            var ysc = yscale[yscindex].scale;
            var hasNegValue = chartObj.dataObject.containsNegativeData(yscindex);
            var prevData;
            var yrangePos = (isRangeChart) ? 1 : null;
            var polygonPoints = {};
            
            if (eventDisabled(d)) {
                return [null]
            } else {
                return d.data.map(function(data, j) {
                    data = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[j] : data;
                    var markerSize = (renderer.getSymbolSize && !isBubbleChartType(type)) ? renderer.getSymbolSize(data) : 0;
                    var cusPoints = isPolar ?
                        data.map(function(d, k) {
                            var x = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "x"),
                                y = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "y");
                            return {
                                x: x,
                                y: y
                            };
                        }) :
                        null;
                    
                    return data.map(function(d, k) {
                        if (isNullData(d, dataset, yscindex)) {
                            return;
                        }

                        var is_within_current_bubble;
                        if (isScatterChartType(type)) {
                            dist = getMinDistByPtToPt(d, relmousePt, xscale, ysc, yscindex, type, yrangePos, X, Y);
                            dist = dist - (markerSize/2); //consider marker size
                            if (isBubbleChartType(type)) {
                                /*
                                 * If mouse point is inside the bubbles, find the bubble with minimum dist (from mouse point to centre)
                                 * Else find the bubble with minimum dist (from mouse point to arc)
                                 */
                                is_within_current_bubble = (dist <= (bubbleRadius = (chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "z", chartObj.zscale) / 2)));
                                is_within_bubble = is_within_bubble || is_within_current_bubble;
                                if (!is_within_current_bubble) {
                                    dist = dist - bubbleRadius; // distance to the arc
                                }
                            }
                        } else {
                            var dist_n_polyPoints = getMinDistByPtToSegment(d, i, j, k, data, relmousePt, prevData, type, xscale, ysc, yscindex, hasNegValue, isRangeChart, cusPoints, isPolar);
                            dist = dist_n_polyPoints.distance;
                            polygonPoints = dist_n_polyPoints.polygonPoints;
                            prevData = d;
                        }

                        var condition;
                        if (isBubbleChartType(type) && is_within_bubble) {
                            if (is_within_current_bubble) {
                                cx = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "x");
                                cy = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "y")
                                if (prevBubbleInfo) {
                                    var prevSurface = mathPI * prevBubbleInfo.r * prevBubbleInfo.r,
                                        curSurface = mathPI * bubbleRadius * bubbleRadius,
                                        inside = (mathSQRT(sqr(prevBubbleInfo.cx - cx) + sqr(prevBubbleInfo.cy - cy)) <= mathAbs(prevBubbleInfo.r - bubbleRadius));

                                    condition = prevBubbleInfo.dist == null || dist < prevBubbleInfo.dist || !(prevSurface < curSurface && inside);
                                } else {
                                    condition = true;
                                }
                            }
                        } else {
                            condition = mindist_trigger == null || dist <= mindist_trigger;
                        }

                        var isWithinClrRange = isWithinColorRange(dataset.getClr(d), chartObj);
                        
                        if (isWithinClrRange && condition && dist != null) {
                            mindist_trigger = dist;
                            series = i;
                            subseries = j;
                            item = k;
                            poly = polygonPoints.points;
                            if (is_within_current_bubble) {
                                prevBubbleInfo = {
                                    cx : cx,
                                    cy : cy,
                                    r : bubbleRadius,
                                    dist : dist
                                };
                            }
                        }
                    })
                    
                })
            }
            prev_trigger_offset = cur_trigger_offset;
        });
        return {
            "seriesPos": series,
            "itemPos": item,
            "subseriesindex": subseries,
            "poly": poly
        };
    }
    
    function isNullData(data, dataset, yscindex) {
        if (chartObj.seriesdata[0].type == $ZC.charttype.stkdarea) {
            return false;
        }
        return (data == null) || isCatNull(dataset, "x")(dataset.getX(data)) || isCatNull(dataset, "y", yscindex)(dataset.getY(data, yscindex));
    }
    
    function getMinDistByPtToSegment(d, i, j, k, data, relmousePt, prevData, type, xscale, ysc, yscindex, hasNegValue, isRangeChart, cusPoints, isPolar) {
        var dist = null;
        var polygonPoints = getPolygonPoints(i, j, k, data, prevData, data[k], data[k + 1], chartObj.dataObject, dataset, axisrotated, stacked(type), xscale, ysc, yscindex, hasNegValue, isRangeChart);

        var hasSinglePolygonPoint = polygonPoints.points.length == 1;
        if (isPolar) {
            polygonPoints.points = cusPoints;
        }

        var isWithinPoly = (isAreaChartType(type) || isPolar) ? pointInPolygon(relmousePt, polygonPoints.points) : ((type === $ZC.charttype.bubblepie) ? pointInPie(relmousePt, polygonPoints, i, j, d) : true);
        if (((data.length == 1 || hasSinglePolygonPoint) && !isNullData(d, dataset, yscindex))) { // if series had one point
            dist = dist2(relmousePt, polygonPoints.curpt);

            // #ZC800
            var isComboChart = chartObj.dataObject.isCombinationalChart,
                areaSeriesCount = chartObj.dataObject.noofAreaEnabledSeries,
                triggerOffset = getTriggeringOffset($ZC.charttype.line, null, isComboChart);
            if ((areaSeriesCount > 1 || (areaSeriesCount === 1 && isComboChart)) && (dist > triggerOffset)) {
                dist = null;
            }

        }
        if (isWithinPoly && !isNullData(d, dataset, yscindex)) {
            
            var pointA = distToSegment(relmousePt, polygonPoints.curpt, polygonPoints.curNext),
                pointB = distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt),
                prevDataNull = (k !== 0 && isNullData(prevData, dataset, yscindex));
            dist = (k == 0) ? pointA : (k == data.length - 1) ? pointB : prevDataNull ? pointA : d3_min([pointB, pointA]);
            
            // dist = (k == 0) ? distToSegment(relmousePt , polygonPoints.curpt , polygonPoints.curNext) :
            // 	(k == data.length-1) ? distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt) :
            // 		d3.min([distToSegment(relmousePt, polygonPoints.prevCur, polygonPoints.curpt) , distToSegment(relmousePt, polygonPoints.curpt, polygonPoints.curNext)]);
        }
        
        return {
            "distance": dist,
            "polygonPoints": polygonPoints
        }
    }

    function getTriggeringOffset(type,tooltipShared,isComboChart,bubbleTriggerOffset){
        var triggerOffset;
        var commonPlotOptions = systemConf.chart.plot.plotoptions[$ZC.charttypenames.get(type)];
        var isContinousPointType = isPointChartType(type) || type === $ZC.charttype.line; //without area,as area should have no mindist
        var filledChartType = !isContinousPointType;
        var customTriggerOffset = (commonPlotOptions && commonPlotOptions.events && commonPlotOptions.events.triggerOffset);
        if(customTriggerOffset !== undefined){
            triggerOffset = customTriggerOffset;
        }else if(chartObj.dataObject.isBubbleEnabled){ // for bubble charts
            triggerOffset = bubbleTriggerOffset;
        }else if(filledChartType || tooltipShared){ //for area charts and tooltip chared
            triggerOffset = null;
        }else if(isComboChart && isContinousPointType){ // for combo chart with line
            triggerOffset = 10;
        }else{ //for line charts
            triggerOffset = 50;
        }
        return triggerOffset;
    }
    
    function getMinDistByPtToPt(d, relmousePt, xscale, ysc, yscindex, type, yrangePos, X, Y) {
        var curpt = {};
        curpt[X] = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "x");
        curpt[Y] = chartObj.dataObject.getXYvalue(axisrotated, stacked(type), xscale, ysc, yscindex, d, "y", null, yrangePos)
        var dx = curpt.x - relmousePt[X];
        var dy = curpt.y - relmousePt[Y];
        return mathSQRT(sqr(dx) + sqr(dy));
    }
    
    
    function getPolygonPoints(seriespos, subseriespos, itempos, data, prevData, curData, nextData, dataObject, dataset, axisrotated, stacked, xscale, ysc, yscindex, hasNegValue, isRangeChart) {
        var prevpt, curpt, nextpt, prevBasept, curBasept, nextBasept;
        var yrangePos = (isRangeChart) ? 1 : null;
        

        curpt = isNullData(curData, dataset, yscindex) ?
            {
                x: 0,
                y: 0
            } :
            {
                x: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, curData, "x"),
                y: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, curData, "y", null, yrangePos)
            };
        prevpt = (itempos == 0) ?
            {
                x: 0,
                y: 0
            } : isNullData(prevData, dataset, yscindex) ? curpt :
                {
                    x: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, prevData, "x"),
                    y: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, prevData, "y", null, yrangePos)
                }
        nextpt = (itempos == data.length - 1) ?
            {
                x: 0,
                y: 0
            } : isNullData(nextData, dataset, yscindex) ? curpt :
            {
                x: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, nextData, "x"),
                y: dataObject.getXYvalue(axisrotated, stacked, xscale, ysc, yscindex, nextData, "y", null, yrangePos)
            }

        curBasept = (isNullData(curData, dataset, yscindex)) ? {
            x: 0,
            y: 0
        } : addBasePointForArea(dataObject, axisrotated, stacked, seriespos, subseriespos, itempos, xscale, ysc, yscindex, hasNegValue, curData, isRangeChart);

        prevBasept = (itempos == 0) ? {
                x: 0,
                y: 0
            } : isNullData(prevData, dataset, yscindex) ?  curBasept :
            addBasePointForArea(dataObject, axisrotated, stacked, seriespos, subseriespos, itempos - 1, xscale, ysc, yscindex, hasNegValue, prevData, isRangeChart);

        nextBasept = (itempos == data.length - 1) ? {
                x: 0,
                y: 0
            } : isNullData(nextData, dataset, yscindex) ? curBasept :
            addBasePointForArea(dataObject, axisrotated, stacked, seriespos, subseriespos, itempos + 1, xscale, ysc, yscindex, hasNegValue, nextData, isRangeChart);

        var prevCur = (itempos == 0) ? {
                x: 0,
                y: 0
            } : isNullData(prevData, dataset, yscindex) ? curpt : {
                x: ((prevpt.x + curpt.x) / 2),
                y: ((prevpt.y + curpt.y) / 2)
            }
        var curNext = (itempos == data.length - 1) ? {
                x: 0,
                y: 0
            } : isNullData(nextData, dataset, yscindex) ? curpt : {
                x: ((nextpt.x + curpt.x) / 2),
                y: ((nextpt.y + curpt.y) / 2)
            }
        
        var prevbaseCur = (itempos == 0) ? {
                x: 0,
                y: 0
            } : isNullData(prevData, dataset, yscindex) ? curBasept :
            {
                x: ((prevBasept.x + curBasept.x) / 2),
                y: ((prevBasept.y + curBasept.y) / 2)
            }
        var curbaseNext = (itempos == data.length - 1) ? {
                x: 0,
                y: 0
            } : isNullData(nextData, dataset, yscindex) ? curBasept : {
                x: ((nextBasept.x + curBasept.x) / 2),
                y: ((nextBasept.y + curBasept.y) / 2)
            }
        
        var points = []
        
        var temp = (isNullData(prevData, dataset, yscindex) && isNullData(nextData, dataset, yscindex)) ? points.push(curpt) : (itempos == 0 || isNullData(prevData, dataset, yscindex)) ? points.push(curpt, curNext, curbaseNext, curBasept) :
                (itempos == data.length - 1 || isNullData(nextData, dataset, yscindex)) ? points.push(prevCur, curpt, curBasept, prevbaseCur) :
                    points.push(prevCur, curpt, curNext, curbaseNext, curBasept, prevbaseCur);
        return {
            "points": points,
            "prevCur": prevCur,
            "curNext": curNext,
            "curpt": curpt
        };
    }
    
    function addBasePointForArea(dataObject, axisrotated, stacked, seriespos, subseriespos, itemPos, xsc, ysc, yscindex, hasNegValue, point, isRangeChart) {
        var basePoint;
        var yrangePos = (isRangeChart) ? 0 : null;
        var temp;
        if (axisrotated) {
            var xval = dataObject.getXYvalue(axisrotated, stacked, xsc, ysc, yscindex, point, "y", null, yrangePos);
            var yval = (isRangeChart) ? dataObject.getXYvalue(axisrotated, stacked, xsc, ysc, yscindex, point, "x", null, yrangePos) : ysc.range()[0];
            if (stacked) {
                temp = ((seriespos == 0) && (subseriespos == 0) && (itemPos == 0)) ? mathMax(ysc.range()[0], ysc(hasNegValue)) : ysc(point.y0);
                basePoint = {
                    x: temp,
                    y: xval
                }
            } else {
                temp = (ysc.rangeBand != null) ? (ysc.range()[0] + ysc.rangeBand()) : mathMax(yval, ysc(hasNegValue));
                basePoint = {
                    x: temp,
                    y: xval
                }
            }
        } else {
            var xval = dataObject.getXYvalue(axisrotated, stacked, xsc, ysc, yscindex, point, "x");
            var yval = (isRangeChart) ? dataObject.getXYvalue(axisrotated, stacked, xsc, ysc, yscindex, point, "y", null, yrangePos) : ysc.range()[0];
            if (stacked) {
                temp = ((seriespos == 0) && (subseriespos == 0) && (itemPos == 0)) ? mathMin(ysc.range()[0], ysc(hasNegValue)) : ysc(point.y0);
                basePoint = {
                    x: xval,
                    y: temp
                }
            } else {
                temp = (ysc.rangeBand != null) ? (yval + ysc.rangeBand()) : mathMin(yval, ysc(hasNegValue));
                basePoint = {
                    x: xval,
                    y: temp
                }
            }
        }
        return basePoint;
    }
    
    function hideUnselectedWrap(wrap) {
        wrap.style("display", "none");
    }
    
    function crosshair_enabled() {
        return (chartObj.systemConf.tooltip.crosshair.type != "none");
    }
    
    function isWithin(dataPt, mousePt, reversed) {
        var x1 = dataPt.x;
        var y1 = dataPt.y;
        var x2 = x1 + dataPt.width;
        var y2 = y1 + dataPt.height;
        if (reversed) {
            (axisrotated) ? (x2 = (x1 = x1 - dataPt.width) + dataPt.width) : (y2 = y1 - dataPt.height);
        }
        
        var condition = (x1 <= mousePt.x && mousePt.x <= x2) && ((reversed && !axisrotated) ? (y2 <= mousePt.y && mousePt.y <= y1) : (y1 <= mousePt.y && mousePt.y <= y2));
        if (condition) {
            return 0;
        } else {
            return null;
        }
        
    }

    function isWithinPlotarea(xval, yval) {
        return isWithin({
            "x": plotarea.left + (chartObj.scrolledX || 0),
            "y": plotarea.top + (chartObj.scrolledY || 0),
            "width": plotarea.width,
            "height": plotarea.height
        }, {
            "x": plotarea.left + xval,
            "y": plotarea.top + yval
        });
    }

    function sqr(x) {
        return x * x;
    }
    
    function dist2(v, w) {
        return sqr(v.x - w.x) + sqr(v.y - w.y)
    }
    
    function distToSegmentSquared(p, v, w) {
        var l2 = dist2(v, w);
        if (l2 === 0) {
            return dist2(p, v);
        }
        var t = ((p.x - v.x) * (w.x - v.x) + (p.y - v.y) * (w.y - v.y)) / l2;
        if (t < 0) {
            return dist2(p, v);
        }
        if (t > 1) {
            return dist2(p, w);
        }
        return dist2(p, {
            x: v.x + t * (w.x - v.x),
            y: v.y + t * (w.y - v.y)
        });
    }
    
    function distToSegment(p, v, w) {
        return mathSQRT(distToSegmentSquared(p, v, w));
    }
    
    function lineDistance(point1, point2) {
        var xs = 0;
        var ys = 0;
        
        xs = point2.x - point1.x;
        xs = xs * xs;
        
        ys = point2.y - point1.y;
        ys = ys * ys;
        
        return mathSQRT(xs + ys);
    }
    
    function isAbove(a, b, c) {
        //a = line point 1; b = line point 2; c = point to check against.
        return (((b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x)) > 0) &&
            (((b.x - a.x) * (c.y - b.y) - (b.y - a.y) * (c.x - b.x)) > 0);
        // var numerator = ((b.y - a.y)*c.x) - ((b.x - a.x)*c.y) + (b.x*a.y) - (b.y*a.x);
        // return numerator > 0
    }
    
    function pointInPolygon(point, poly) {
        // ray-casting algorithm based on
        // www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html
        var xi, xj, yi, yj, i, intersect,
            x = point.x,
            y = point.y,
            inside = false;
        for (var i = 0, j = poly.length - 1; i < poly.length; j = i++) {
            xi = poly[i].x,
                yi = poly[i].y,
                xj = poly[j].x,
                yj = poly[j].y,
                intersect = ((yi > y) != (yj > y)) &&
                    (x < (xj - xi) * (y - yi) / (yj - yi) + xi);
            if (intersect) inside = !inside;
        }
        return inside;
    }
    
    function pointInPie(point, poly, seriespos, subseriespos, d) {
        var X = dataset.getX(d);
        var pieRenderer = chartObj.subrenderer[subseriespos][X];
        var pieData = pieRenderer.data[seriespos];
        var theta1 = pieData.startAngle,
            theta2 = pieData.endAngle,
            angle = mathAtan2((point.x - poly.curpt.x), -(point.y - poly.curpt.y));
        return isAngleInside(theta1, theta2, angle);
    }
    
    function eventDisabled(d) {
        /*
         * returns true if the series is filtered or event is disabled for that series
         */
        var plotOptions = d.plotoptions;
        var cName = getChartType((d.type || chartObj.userdata.seriesdata.type), "string");
        var commonPlotOptions = systemConf.chart.plot.plotoptions[cName];
        return d.disabled || (validateNullVal(getEventConf(plotOptions, commonPlotOptions, chartObj, "enabled"), true) == false);
    }

    function getCurrentDataPoint(seriesIndex, subseriesIndex, itemIndex) {
        var renderer = chartObj.renderer[seriesIndex];
        var currentSeriesdata = (renderer.seriesdataAfterUpdate != null) ? renderer.seriesdataAfterUpdate[subseriesIndex] : chartObj.seriesdata[seriesIndex].data[subseriesIndex];
        return currentSeriesdata[itemIndex];
    }

    function getRect(highlightpoint, radius, yaxisReversed) {
        if (isHeatMapChartType(chartObj.chartTypes[0].value)) {
            var commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions.heatmap;
            var symbolPath = commonPlotOptions.symbol && getSVGsymbol(commonPlotOptions.symbol);
            if (symbolPath) {
                return symbolPath(mathMin(highlightpoint.width, highlightpoint.height));
            } else {
                return roundedRect(-highlightpoint.width / 2, -highlightpoint.height / 2, highlightpoint.width, highlightpoint.height, radius, null, axisrotated);
            }
        } else {
            return roundedRect(highlightpoint.x, highlightpoint.y, highlightpoint.width, highlightpoint.height, radius, yaxisReversed, axisrotated);
        }
    }

    function getRectTranslation(highlightpoint) {
        var tx = plotarea.left,
            ty = plotarea.top;
        if (isHeatMapChartType(chartObj.chartTypes[0].value)) {
            tx += (highlightpoint.x + highlightpoint.width / 2);
            ty += (highlightpoint.y + highlightpoint.height / 2);
        }
        return [tx, ty];
    }

    function getLegendIndex(d, seriesIndex) {
        if (chartObj.axes.clr.scaleType) {
            return getColorIndex(chartObj, chartObj.axes.clr.indexScale, d);
        } else if (seriesIndex != null) {
            return seriesIndex;
        }
    }

    return events;
};

/*
 *Events related to statechange
 */

function stateChangeListener(chartObj, eventdata, ele, type, defaultCallback) {
    
    //type: chartinit, chartload, chartreload, axisinit, axisload, plotinit, plotload
    
    var callback = (eventdata && eventdata[type]) || defaultCallback;
    if (defined(callback)) {
        invokeFunction(callback, d3.event, chartObj)
    }
}

function getEventConf(plotOptions, commonPlotOptions, chartObj, eventType) {
    var events_cpo = commonPlotOptions.events, //cpo - commonplotoptions
        events_plot = chartObj.systemConf.chart.plot.events;
    
    var eventFn = (plotOptions != null && plotOptions.events) ? $ZC.utils.getValueOfPlotOptions(plotOptions.events, events_cpo)(eventType) :
        (events_cpo != null) ? events_cpo[eventType] :
            (events_plot != null) ? events_plot[eventType] : null;

    if (eventFn === undefined && events_plot) {
        eventFn = events_plot[eventType];
    }

    return eventFn;
}

function updateBulletEvents(chartObj, bulletHandler) {
    var bulletPoints = chartObj.events.bullet,
        allPoints = arrayJoin(bulletPoints.levelmarker, bulletPoints.marker, bulletPoints.point);
    bulletHandler.update(allPoints)
}

// handles bullet chart event
function bulletChartEventHandler(chartObj, eventRectangular, hoverSeries, eventsHandler) {
    
    // update the old event if the first arguments is true
    if (arguments[0] === true) {
        return arguments[1].update(arguments[2]);
    }
    
    var bulletPoints = chartObj.events.bullet,
        axisrotated = chartObj.dataObject.getAxisRotated(),
        allPoints = arrayJoin(bulletPoints.levelmarker, bulletPoints.marker, bulletPoints.point),
        sharedTooltip = chartObj.systemConf.tooltip.sharedSeriesInfo,
        tooltip = chartObj.eventHandler.tooltipElement,
        plotoptions = chartObj.systemConf.chart.plot.plotoptions.bullet,
        coordinate, dataset = chartObj.dataset,
        seriesIndex, subseriesIndex, itemIndex,
        tooltipSharedInfo = d3_map(),
        xdata, highlightPoints, renderer, data, position,
        bulletEvents = getPropVal(plotoptions, "events") || {},
        levelMarkerEvents = getPropVal(plotoptions, "levelMarker.events") || {},
        targetMarkerEvents = getPropVal(plotoptions, "targetMarker.events") || {},
        eventAttacherOptions = {
            target: "plot",
            chartObj: chartObj,
            namespace: "bullet"
        },

        levelMarkerColumnInfo = getColumnIdxBasedOnDataindex(chartObj, plotoptions.levelMarker),
        targetMarkerColumnInfo = getColumnIdxBasedOnDataindex(chartObj, plotoptions.targetMarker),

        columnInfo, value, dataType, userCallback, metaInfo, text, formattedValue;
    
    var handleUserCallback = function(current, type, event, metaInfo) {
        metaInfo = metaInfo || chartObj.dataset.getMetaInfoObj(chartObj, current.data, current.seriesPos);
        type = (d3.event && d3.event.zcEventType) || type;
        var userObject = {
            "data": metaInfo
        };
        
        switch (current.type) {
            case "levelmarker": {
                return invokeFunction(levelMarkerEvents[type], event, userObject, chartObj);
            }
            case "marker": {
                return invokeFunction(targetMarkerEvents[type], event, userObject, chartObj);
            }
            case "point": {
                return invokeFunction(bulletEvents[type], event, userObject, chartObj);
            }
        }
    };
    
    // bullet event
    var bulletEvent = new $ZC.RectangleEventSurface(eventRectangular.node(), allPoints, eventAttacherOptions);
    
    bulletEvent.mousemove(function(event, mouseCoords) {
        if(!chartObj.chartRendered) {
            return false;
        }
        bulletEvent.stopPropagation();
        
        var currentPoint = this,
            data = currentPoint.data;
        coordinate = {
            x: mouseCoords[0],
            y: mouseCoords[1]
        };
        seriesIndex = currentPoint.seriesPos;
        subseriesIndex = currentPoint.subseriesindex;
        itemIndex = currentPoint.itemPos;
        tooltipSharedInfo = d3_map();
        xdata = dataset.getX(data);
        renderer = chartObj.renderer[seriesIndex];
        position = getTooltipPosition(event, coordinate, 0, 0, chartObj, currentPoint, axisrotated, sharedTooltip, tooltipSharedInfo, true, false);
        switch (this.type) {
            case "point": {
                highlightPoints = getBarPosition(chartObj, data, seriesIndex, renderer.commonOption);
                eventRectangular.selectAll("#zcscatterhighlight").selectAll("*").remove();
                hoverSeries(chartObj, seriesIndex, xdata, itemIndex, subseriesIndex, data, sharedTooltip, true, tooltipSharedInfo, highlightPoints)
                return tooltip.show(chartObj, position, null, true, position.helpers);
            }
            case "levelmarker":
            case "marker": {
                columnInfo = ((this.type === "marker") ? targetMarkerColumnInfo : levelMarkerColumnInfo) || chartObj.dataset.getColumn("y", currentPoint.yaxiscolumnorder);
                value = currentPoint.currentStage;
                dataType = columnInfo.datatype;
                metaInfo = chartObj.dataset.getMetaInfoObj(chartObj, data, seriesIndex);
                formattedValue = getFormattedValue(columnInfo[dataType], value, dataType, chartObj, "tooltip"),
                    userCallback = {
                        value: value,
                        formattedValue: formattedValue,
                        actualData: data,
                        data: metaInfo
                    };
                handleUserCallback(this, "mousemove", metaInfo);
                if (this.type === "marker") {
                    text = invokeFunction(targetMarkerEvents.tooltipContent, userCallback, chartObj, "tooltip") || "Target: " + formattedValue;
                    eventsHandler.addCursor(targetMarkerEvents.cursor);
                } else {
                    text = invokeFunction(levelMarkerEvents.tooltipContent, userCallback, chartObj, "tooltip") || "Range: " + formattedValue;
                    eventsHandler.addCursor(levelMarkerEvents.cursor);
                }
                return tooltip.show(chartObj, position, text, false, position.helpers);
            }
        }
    });
    
    bulletEvent.click(function(event) {
        bulletEvent.stopPropagation();
        tooltip.hide(tooltip.element);
        eventsHandler.hideCursor(chartObj.eventHandler.trackerElement);
        if (this.type !== "point") {
            handleUserCallback(this, "click", event);
        } else {
            eventsHandler.click();
        }
    });
    
    bulletEvent.dblclick(function(event) {
        bulletEvent.stopPropagation();
        if (this.type !== "point") {
            handleUserCallback(this, "doubleclick", event);
        } else {
            eventsHandler.doubleclick();
        }
    });
    
    bulletEvent.mouseleave(function(event) {
        if (this.type !== "point") {
            handleUserCallback(this, "mouseout", event);
        }
        eventsHandler.hideCursor(eventRectangular);
        eventsHandler.mouseOut(renderer, data, seriesIndex, !bulletEvent._finalMouseLeave);
    });
    
    return bulletEvent;
}

function hasPatternPallete(chartObj) {
    var patternPallete = chartObj.patternPallete;
    return patternPallete && patternPallete.length;
}

/**
 *
 * @param {Number} type chart type
 * @return {boolean}
 */
function isAreaChartType(type) {
    // return [$ZC.charttype.area, $ZC.charttype.stkdarea, $ZC.charttype.arearange].indexOf(type) > -1;
    return type === $ZC.charttype.area || type === $ZC.charttype.stkdarea || type === $ZC.charttype.arearange;
    
}

/**
 *
 * @param {Number} type chart type
 * @return {boolean}
 */

function isBarChartType(type) {
    return type === $ZC.charttype.bar || type === $ZC.charttype.stkdbar || type === $ZC.charttype.bullet || type === $ZC.charttype.gantt || isHeatMapChartType(type);
}

/**
 *
 * @param {Number} type chart type
 * @return {boolean}
 */

function isScatterChartType(type) {
    return $ZC.chartcategory.dotPlot.indexOf(type) != -1;
}


/**
 *
 * @param {Number} type chart type
 * @return {boolean}
 */

function isBubbleChartType(type) {
    return type === $ZC.charttype.bubble || type === $ZC.charttype.bubblepie;
}

/**
 *
 * @param {Number} type chart type
 * @return {boolean}
 */

function isPointChartType(type) {
    return isScatterChartType(type) || type === $ZC.charttype.bubblepie;
}

function  isSunburstChartType(type) {
    return type === $ZC.charttype.sunburst;
}

function  isHeatMapChartType(type) {
    return type === $ZC.charttype.heatmap;
}

function  isPieChartType(type) {
    return $ZC.chartcategory.piePlot.indexOf(type) != -1;
}

/**
 *
 * @param node
 * @return {Array}
 */
function getMousePosition(node, event) {
    // For touch devices d3.mouse(node) will return incorrect values, if the document is scrolled. So that pageXOffset and pageYOffset is added.
    var mouse = d3_mouse(node);
    if (event.touches != null && !$Browser.ANDROID && $Browser.uiwebview) { //d3.mouse(node) considers pageXOffset and pageYOffset in android devices
        mouse[0] += window.pageXOffset;
        mouse[1] += window.pageYOffset;
    }
    return mouse;
}

/**
 *
 * @param {*} a
 * @param {*} b
 * @return {boolean}
 */

function equals(a, b) {
    return a === b;
}

/**
 *
 * @param {Object } chart current chart Object
 * @param {Array} point data point
 * @param seriesIndex series index of the corresponding data
 * @param commonOption commonOption for chart support
 * @return {{x, y, width, height}}
 */

function getBarPosition(chart, point, seriesIndex, commonOption) {
    var getTransRectValue = function() {
        return chart.dataObject.getTransRectValue.apply(chart.dataObject, toArray(arguments));
    };
    return {
        x: getTransRectValue("x", point, seriesIndex, 0, commonOption),
        y: getTransRectValue("y", point, seriesIndex, 0, commonOption),
        width: getTransRectValue("width", point, seriesIndex, 0, commonOption),
        height: getTransRectValue("height", point, seriesIndex, 0, commonOption)
    }
}

/**
 *
 * @param {Object} chartObj
 * @param {Array} dataPoint
 * @param {Scale} xscale
 * @param {Scale} yscale
 * @param {Number} yaxiscolumnorder
 * @return {{x, y, width, height}}
 */

function getHeatCellPosition(chartObj, dataPoint, xscale, yscale, yaxiscolumnorder) {
    var dataset = chartObj.dataset,
        commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions.heatmap,
        symbolPath = commonPlotOptions.symbol && getSVGsymbol(commonPlotOptions.symbol),
        xValue = dataset.getX(dataPoint),
        yValue = dataset.getY(dataPoint, yaxiscolumnorder),
        zValue = defined(dataset.zidx) ? chartObj.zscale(dataset.getZ(dataPoint) || chartObj.zscale.domain()[0]) : 1,
        xBand = xscale.rangeBand(),
        yBand = yscale.rangeBand(),
        x, y, w, h;

    if (chartObj.axes.rotated) {
        w = yBand * zValue;
        h = xBand * zValue;

        if (symbolPath) {
            w = h = mathMin(w, h);
        }

        y = xscale(xValue) + (xBand - h) / 2;
        x = yscale(yValue) + (yBand - w) / 2;
    } else {
        w = xBand * zValue;
        h = yBand * zValue;

        if (symbolPath) {
            w = h = mathMin(w, h);
        }

        x = xscale(xValue) + (xBand - w) / 2;
        y = yscale(yValue) + (yBand - h) / 2;
    }

    return {
        x: x,
        y: y,
        width: w,
        height: h
    };
}

/**
 *
 * @param {Array} dataPoint
 * @return {{x, y, width, height}}
 */

function getTreemapPosition(dataPoint) {
    return {
        x: dataPoint.x || 0,
        y: dataPoint.y || 0,
        width: dataPoint.dx,
        height: dataPoint.dy
    };
}

/**
 *
 * @param {Array} dataPoint
 * @return {{x, y, width, height}}
 */

function getPackedbubblePosition(dataPoint) {
    var w = h = 2 * dataPoint.r;
    return {
        x: (dataPoint.x || 0) - (w / 2),
        y: (dataPoint.y || 0) - (h / 2),
        width: w,
        height: h
    };
}

// get tooltip position for both ordinal and continuous scale
// TODO revamp continuous scale tooltip position.
function getTooltipPosition(event, coordinates, x, y, chartObj, point, axisrotated, sharedTooltip, sharedTooltipInfo, isOrdinalChart, isPolar) {
    var tooltipPos = null,
        plotarea = chartObj.plotarea,
        plotarea_approx = chartObj.plotarea_approx;
    
    if (sharedTooltip && crosshair_enabled()) {
        if (axisrotated) {
            tooltipPos = {
                actLeft: x + plotarea.left,
                actTop: coordinates.y + plotarea.top,
                top: coordinates.y,
                left: isOrdinalChart ? plotarea.width : coordinates.x
            }
        } else {
            // common for both
            tooltipPos = {
                top: 0,
                actTop: plotarea.top + y
            };
            
            if (isOrdinalChart) {
                tooltipPos.left = coordinates.x;
                tooltipPos.actLeft = coordinates.x + plotarea.left;
            } else {
                tooltipPos.left = x;
                tooltipPos.actLeft = plotarea.left + x;
            }
        }
    } else {
        if (isOrdinalChart) {
            // common for both
            tooltipPos = {
                left: coordinates.x,
                top: coordinates.y
            };
            
            if (axisrotated) {
                tooltipPos.actLeft = x + plotarea.left;
                tooltipPos.actTop = coordinates.y + plotarea.top;
            } else {
                tooltipPos.actLeft = coordinates.x + plotarea.left;
                tooltipPos.actTop = y + plotarea.top;
            }
        } else {
            tooltipPos = {
                left: x,
                top: y,
                actLeft: (plotarea.left + x),
                actTop: (plotarea.top + y)
            }
        }
    }
    var dLeft = coordinates.x - event.clientX,
        dTop = coordinates.y - event.clientY;
    
    tooltipPos.dLeft = dLeft + plotarea.left;
    tooltipPos.dTop = dTop + plotarea.top;
    tooltipPos.left -= dLeft;
    tooltipPos.top -= dTop;
    tooltipPos.dLeft = dLeft + plotarea.left;
    tooltipPos.dTop = dTop + plotarea.top;
    
    // add dependencies in helper variable
    
    tooltipPos.helpers = {
        "seriesindex": point.seriesPos,
        "subseriespos": isArray(point.subseriesindex) ? point.subseriesindex[point.seriesPos] : point.subseriesindex,
        "itempos": point.itemPos,
        "color": chartObj.seriesColor,
        "tooltipSharedInfo": sharedTooltipInfo,
        "tooltipShared": sharedTooltip
    };
    
    
    if (isPolar) {
        tooltipPos.dLeft += plotarea_approx.x;
        tooltipPos.dTop += plotarea_approx.y
    }
    
    return tooltipPos
}

function getColumnIdxBasedOnDataindex(chartObj, options) {
    //check for multi yaxis
    var columns = chartObj.userdata.metadata.columns,
        columnidx = columns.filter(function(d) {
            return d.dataindex === options.dataindex;
        });
    return columnidx[0];
}
(function(ZC, d3) {
    
    "use strict";
    var event_surface_rect_counter = 0,
        event_surface_circle_counter = 0;
    
    /**
     * Extend one or more objects with the members of another
     * @param target
     * @returns {Object}
     */
    
    function extend(target) {
        if (!arguments[1]) {
            return;
        }
        for (var ii = 1, ll = arguments.length; ii < ll; ii++) {
            var source = arguments[ii];
            for (var prop in source) {
                if (!target[prop] && source.hasOwnProperty(prop)) {
                    target[prop] = source[prop];
                }
            }
        }
        return target;
    }
    
    /**
     * Inherits an Object
     * @param {Object|*} subClass
     * @param {Object|*} superClass
     */
    
    function inherit(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }
        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) {
            Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
        }
    }
    
    /**
     *
     * @param {Element} element
     * @param {String} types
     * @param {String} namespace
     * @param {Function} handler
     */
    
    function addEvent(element, types, namespace, handler) {
        types.split(" ").forEach(function(type) {
            d3.select(element).on(type + "." + namespace, null);
            d3.select(element).on(type + "." + namespace, handler)
        });
    }
    
    /**
     *
     * @param {Element} element
     * @param {String} type
     * @param {String} namespace
     */
    function removeEvent(element, type, namespace) {
        d3.select(element).on(type + "." + namespace, null);
    }
    
    /**
     * Check if an element is an array, and if not, make it into an array.
     */
    
    function splat(obj) {
        return isArray(obj) ? obj : [obj];
    }
    
    /**
     *
     * @param {Number} x
     * @param {Number} y
     * @param {Object} surface
     * @returns {boolean}
     */
    
    function pointInRectangle(x, y, surface) {
        return (x >= surface.x && x <= (surface.x + surface.width) && y >= surface.y && y <= (surface.y + surface.height))
    }
    
    /**
     *
     * @param {Number} x
     * @param {Number} y
     * @param {Object} surface
     * @returns {boolean}
     */
    
    function pointInCircle(x, y, surface) {
        return mathSQRT((x - surface.cx) * (x - surface.cx) + (y - surface.cy) * (y - surface.cy)) <= surface.r;
    }
    
    /**
     * @param {String} type
     * @param {Object} currentPosition
     * @param {Object} surface
     * @returns {boolean}
     */
    
    function withinBound(type, currentPosition, surface) {
        var x = currentPosition[0],
            y = currentPosition[1];
        switch (type) {
            case "rect": {
                return pointInRectangle(x, y, surface);
            }
            case "circle": {
                return pointInCircle(x, y, surface);
            }
        }
    }
    
    // mouse enter function
    function mouseEnter(self, currentSurface) {
        dispatchEvent(self, "mouseenter", currentSurface);
        self._dispachedMouseEnter = true;
        self._dispachedMouseLeave = false;
    }
    
    function mouseLeave(self) {
        self._dispachedMouseEnter = false;
        self._dispachedMouseLeave = true;
        dispatchEvent(self, "mouseleave");
    }
    
    function forceMouseLeave(self) {
        if (defined(self._lastSurface) && !self._dispachedMouseLeave) {
            self._finalMouseLeave = true;
            mouseLeave(self);
        }
    }
    
    /**
     *
     * @param {RectangleEventSurface|CircleEventSurface} self
     * @param {String} type
     * @param {Function|undefined} callback
     */
    
    function defaultHandler(self, type, callback) {
        
        var currentMousePosition = getMousePosition(self.element, d3.event),
            currentSurface, insideBound, inCount = 0,
            count = self.surface.length;
        
        if (self.element.ownerSVGElement) {
            var relativeMouse = self.element.getBBox();
            currentMousePosition[0] -= relativeMouse.x;
            currentMousePosition[1] -= relativeMouse.y;
        }
        
        while (count--) {
            
            currentSurface = self.surface[count];
            insideBound = withinBound(self.type, currentMousePosition, currentSurface);
            
            if (insideBound) {
                
                if (type === "move") {
                    
                    // when moving through overlapping surface,
                    // then call mouseout from lastSurface and mouseenter in currentSurface
                    
                    if (defined(self._lastSurface) && self._lastSurface !== currentSurface) {
                        if (!self._dispachedMouseLeave) {
                            self._finalMouseLeave = false;
                            mouseLeave(self);
                        }
                        mouseEnter(self, currentSurface);
                    }
                    
                    // Calls mouse enter for the first time
                    // In order to work mouseenter and mouseleave correctly on
                    // overlapping surface, use stopPropagation on mousemove
                    
                    if (self.callbacks.hasOwnProperty("mouseenter") && !self._dispachedMouseEnter) {
                        mouseEnter(self, currentSurface);
                    }
                    
                    // Call mouse move every time.
                    
                    if (self.callbacks.hasOwnProperty("mousemove")) {
                        d3.event.preventDefault();
                        dispatchEvent(self, "mousemove", currentSurface, currentMousePosition);
                    }
                    
                    inCount++;
                    self._dispachedMouseLeave = false;
                    
                } else if (defined(type)) {
                    dispatchEvent(self, type, currentSurface);
                }

                if (defined(callback) && typeof callback === "function") {
                    callback.call(currentSurface || self._lastSurface, getEventObject(d3.event), currentMousePosition);
                }
                
                self._lastSurface = currentSurface;
                
                if (self._stopPropagation === true) {
                    break; // stop, if stopPropagation was called while runtime/
                }
            }
        }
        return inCount > 0;
    }
    
    /**
     *
     * @param {RectangleEventSurface|CircleEventSurface} self
     * @param {Object|null} currentSurface
     * @param {String} eventType
     * @param {Array} currentMousePosition is an array of current mouse position corresponding to the element.
     */
    
    function dispatchEvent(self, eventType, currentSurface, currentMousePosition) {
        if (self.callbacks.hasOwnProperty(eventType)) {
            self.callbacks[eventType].call(currentSurface || self._lastSurface, getEventObject(d3.event), currentMousePosition);
        }
    }

    function handleTouchEvents(self, element, options) {
        var touchHandlers = {
            "tap" : function(){
                self.trigger("click");
            },
            "dbltap": function(){
                self.trigger("dblclick");
            },
            "singletouchmove" : function(){
                var insideBound = self.trigger("move");;
                if (!insideBound && defined(self._lastSurface) && !self._dispachedMouseLeave) {
                    self._finalMouseLeave = true;
                    mouseLeave(self);
                }
                self._stopPropagation = false;
            },
            "touchend" : function(){
                forceMouseLeave(self);
            }
        }
        attachevents(d3_select(element), null, touchHandlers, options);
    }
    
    /**
     *
     * @param {Object} self is surface object
     * @param {Function|null} appHandler
     */
    
    function handleMouseMoves(self, appHandler) {
        if (!self._addedMouseMove) {
            appHandler = defined(appHandler) ? appHandler : defaultHandler;
            addEvent(self.element, "mousemove", self.namespace, function() {
                var insideBound = appHandler(self, "move");
                if (!insideBound && defined(self._lastSurface) && !self._dispachedMouseLeave) {
                    self._finalMouseLeave = true;
                    mouseLeave(self)
                }
                self._stopPropagation = false;
            });
            
            self.callbacks.forceMouseLeave = forceMouseLeave;
            addEvent(self.element, "mouseleave", self.namespace, function() {
                forceMouseLeave(self);
            });
        }
        self._addedMouseMove = true;
    }
    
    /**
     *
     * @param {Object} self is surface object
     * @param {Function|null} appHandler
     * @param {String} type mouse button events
     */
    
    function handleClicks(self, appHandler, type) {
        appHandler = defined(appHandler) ? appHandler : defaultHandler;
        addEvent(self.element, (type === "click") ? "click" : type, self.namespace, function() {
            appHandler(self, type);
            self._stopPropagation = false;
        });
    }
    
    // eventsListeners of EventSurface;
    
    var eventsListeners = {
        
        /**
         *
         * @param {Function} callback
         * @param {Function|null} appHandler
         */
        
        click: function(callback, appHandler) {
            if (typeof callback === "function") {
                this.callbacks.click = callback;
                this.callbacks.touchstart = callback;
                handleClicks(this, appHandler, "click");
            }
        },
        
        /**
         *
         * @param {Function} callback
         * @param {Function|null} appHandler
         */
        
        dblclick: function(callback, appHandler) {
            if (typeof callback === "function") {
                this.callbacks.dblclick = callback;
                handleClicks(this, appHandler, "dblclick");
            }
        },
        
        /**
         *
         * @param {Function} callback
         * @param {Function|null} appHandler
         */
        
        mousedown: function(callback, appHandler) {
            if (typeof callback === "function") {
                this.callbacks.mousedown = callback;
                handleClicks(this, appHandler, "mousedown");
            }
        },
        
        /**
         *
         * @param {Function} callback
         * @param {Function|null} appHandler
         */
        
        mouseup: function(callback, appHandler) {
            if (typeof callback === "function") {
                this.callbacks.mouseup = callback;
                handleClicks(this, appHandler, "mouseup");
            }
        },
        
        /**
         *
         * @param {Function} callback
         * @param {Function|null} appHandler
         */
        
        contextmenu: function(callback, appHandler) {
            if (typeof callback === "function") {
                this.callbacks.contextmenu = callback;
                handleClicks(this, appHandler, "contextmenu");
            }
        },
        
        /**
         *
         * @param {Function} callback
         * @param {Function|null} appHandler is optional
         */
        
        mouseenter: function(callback, appHandler) {
            if (typeof callback === "function") {
                this.callbacks.mouseenter = callback;
                handleMouseMoves(this, appHandler);
            }
        },
        
        /**
         *
         * @param {Function} callback
         * @param {Function|null} appHandler
         */
        
        mousemove: function(callback, appHandler) {
            if (typeof callback === "function") {
                this.callbacks.mousemove = callback;
                this.callbacks.touchmove = callback;
                handleMouseMoves(this, appHandler);
            }
        },
        
        /**
         *
         * @param {Function} callback
         * @param {Function|null} appHandler is optional
         */
        
        mouseleave: function(callback, appHandler) {
            if (typeof callback === "function") {
                this.callbacks.mouseleave = callback;
                handleMouseMoves(this, appHandler);
            }
        },
        
        /**
         *
         * @param {Object|Array} newSurface
         */
        
        update: function(newSurface) {
            this.surface = splat(newSurface);
        },
        
        stopPropagation: function() {
            this._stopPropagation = true;
        },
        
        remove: function() {
            for (var type in this.callbacks) {
                if (this.callbacks.hasOwnProperty(type)) {
                    removeEvent(this.element, type, this.namespace);
                }
            }
        },

        /**
         *
         * @param {String} eventName event name
         * @param {Function|undefined} callback
         */

        trigger:  function (eventName, callback) {
            return defaultHandler(this, eventName, callback);
        }
    };
    
    /**
     *
     * @param {Element} element
     * @param {Object|Array|null} surface
     * @constructor
     */
    
    var EventSurface = function(element, surface) {
        this.element = element;
        this.surface = surface;
    };
    
    // add the methods to the prototype
    extend(EventSurface.prototype, eventsListeners);
    
    var init = function(element, surface, options) {
        this.events = [];
        this.callbacks = {};
        handleTouchEvents(this, element, options);
    };
    
    /**
     *
     * @param {Element} element
     * @param {Object} surface
     * @returns {RectangleEventSurface}
     * @constructor
     */
    
    var RectangleEventSurface = function(element, surface, options) {
        
        if (!defined(element) || element.nodeType !== 1 || !defined(surface)) {
            return;
        }
        
        if (!(this instanceof RectangleEventSurface)) {
            return new RectangleEventSurface(element, surface);
        }
        EventSurface.call(this, element, splat(surface));
        this.type = "rect";
        this.namespace = this.type + "Surface" + event_surface_rect_counter++;
        init.call(this, element, surface, options);
    };
    
    // inherit EventSurface
    inherit(RectangleEventSurface, EventSurface);
    
    /**
     *
     * @param {Element} element
     * @param {Object} surface
     * @returns {CircleEventSurface}
     * @constructor
     */
    
    var CircleEventSurface = function(element, surface, options) {
        if (!defined(element) || element.nodeType !== 1 || !defined(surface)) {
            return;
        }
        
        if (!(this instanceof CircleEventSurface)) {
            return new CircleEventSurface(element, surface);
        }
        EventSurface.call(this, element, splat(surface));
        this.type = "circle";
        this.namespace = this.type + "Surface" + event_surface_circle_counter++;
        init.call(this, element, surface, options);
    };
    
    // inherit EventSurface
    inherit(CircleEventSurface, EventSurface);
    
    // add to global
    ZC.RectangleEventSurface = RectangleEventSurface;
    ZC.CircleEventSurface = CircleEventSurface;
    
})($ZC, d3);//$Id$
function attachevents(ele, mouseHandlers, touchHandlers, options, namespace) {
    /*
     * This function attaches event listeners to the element. For touch devices, events will be mapped with touchstart,touchmove and touchend.
     * ele -> To which element the listeners will be attached
     * namespace -> To register multiple listeners for the same event type, the optional namespace is used. (e.g) : "zoom" or null. Refer github.com/mbostock/d3/wiki/Selections#on
     * mouseHandlers -> An object of event type and listener. (e.g) : { "click" : function(){}, "mousemove" : function(){} }
     * touchleave -> whether to handle touch leave or not
     */
     options = options || {};
     namespace = options.namespace || namespace;

    if ($Browser.isMouseDevice && mouseHandlers) {
        attachMouseEvents(ele, namespace, mouseHandlers);
    }
    if ($Browser.isTouchDevice && touchHandlers) {
        attachTouchEvents(ele, namespace, touchHandlers, options);
    }
}

function detachevent(ele, namespace, handlers) {
    namespace = (namespace != null && namespace != "") ? "." + namespace : "";
    if ($Browser.isMouseDevice) {
        if (namespace !== "") {
            ele.on(namespace, null);
        } else {
            for (var attr in handlers) {
                ele.on(attr, null);
            }
        }
        handlers = null;
    }
}

function getEventObject(e) {
    return e.changedTouches ? e.changedTouches[0] : e;
}

function attachMouseEvents(ele, namespace, handlers) {
    if (namespace) {
        namespace = "." + namespace;
        var updatedHandlers = {};
        for (var attr in handlers) {
            updatedHandlers[(attr + namespace)] = handlers[attr];
        }
        handlers = updatedHandlers;
    }

    ele.on(handlers);
}

function attachTouchEvents(ele, namespace, handlers, options) {
    var touchleave = options.touchleave,
        target = options.target,
        chartObj = options.chartObj,
        plotEventOptions = (chartObj && chartObj.systemConf.chart.plot.events) || {},
        doPreventDefault = options.preventDefault !== false;
    var isFocusedTouchmove = !((target === "plot") && plotEventOptions.isFocusedTouchmove == false);
    namespace = (namespace != null) ? "." + namespace : "";

    var MINDISTANCE = 30,
        SINGLETAPDURATION = 150,
        DOUBLETAPDURATION = 500,
        FOCUSEDMOVEDURATION = 100,
        TOUCHMOVETIMER = 50,
        TAPHOLDDURATION = 500;
    var prevElement, touchstart = {},
        lastMove = 0,
        lastTap = 0,
        tapDifference = DOUBLETAPDURATION - SINGLETAPDURATION,
        firstMove = null,
        isDoubletouchStarted = false,
        tapholdDetected,
        tapHoldTimer;

    var mousemoveFn = handlers.touchmove,
        touchendFn = handlers.touchend,
        tapFn = handlers.tap,
        dbltapFn = handlers.dbltap,
        singletouchmoveFn = handlers.singletouchmove,
        doubletouchmoveFn = handlers.doubletouchmove,
        tapholdFn,
        tapholdendFn;

        if (target === "plot" && getEventConf(null, chartObj.systemConf.chart.plot.plotoptions[chartObj.chartTypes[0].name], chartObj, "taphold")) {
            tapholdFn = handlers.tap;
            tapholdendFn = touchendFn;
        } else {
            tapholdFn = handlers.taphold;
            tapholdendFn = handlers.tapholdend;
        }

    var touchstartProp = "touchstart" + namespace,
        touchmoveProp = "touchmove" + namespace,
        touchendProp = "touchend" + namespace;

    var updatedHandlers = {};
    updatedHandlers[touchstartProp] = function() {
        if (plotEventOptions.enabled == false) {
            return;
        }

        var touchObject = d3.event.touches;

        if (touchObject.length > 1) {
            return;
        }

        touchstart.time = new Date();
        touchstart.location = getMousePosition(this, d3.event);
        firstMove = null;
        isDoubletouchStarted = false;
        tapholdDetected = false;

        if (tapholdFn) {
            var e = d3.event;
            var arg = arguments;
            var self = this;
            tapHoldTimer = setTimeout(function(){
                d3.event = e;
                if (chartObj) {
                    chartObj.zcEventType = "taphold"; //change
                }

                tapholdFn.apply(self, arg);

                tapholdDetected = true;
            }, TAPHOLDDURATION);
        }
    }
    updatedHandlers[touchmoveProp] = function() {
        if (plotEventOptions.enabled == false) {
            return;
        }

        var touchObject = d3.event.touches;

        if (tapholdFn) {
            var currentLocation = getMousePosition(this, d3.event);
            var distance = (touchstart.location != null) ? getEuclideanDistance(touchstart.location[0], touchstart.location[1], currentLocation[0], currentLocation[1]) : null;

            if (distance > MINDISTANCE) {
                clearTimeout(tapHoldTimer);
            } else {
                if (tapholdDetected) {
                    preventDefault();
                    return false;
                }
            }
        }

        if (touchObject.length > 1) {
            if ((touchObject.length == 2) && doubletouchmoveFn) {
                isDoubletouchStarted = true;
                doubletouchmoveFn.apply(this, arguments);
                preventDefault();
            }
            return;
        }

        var currentTime = new Date().getTime();
        if (!firstMove) {
            firstMove = currentTime;
        }

        // Touchleave event is not available. So finding the element to which the touchmove would be called is necessary. Call the mouseout of previous element and mousemove of the current element
        if (touchleave && document.elementFromPoint != null) {
            var timer = (lastMove == 0 || (currentTime - lastMove) > TOUCHMOVETIMER);
            var curTouch = touchObject[0];
            var currentEle = document.elementFromPoint((curTouch.pageX - window.pageXOffset), (curTouch.pageY - window.pageYOffset));
            if (!timer || (currentEle.localName === "svg") || (currentEle.id.match(/tooltip/gi) != null)) {
                preventDefault();
                return;
            }

            if (currentEle != this) {
                // Call mouse out of the previous element
                if (prevElement != currentEle) {
                    var touchEndElement = prevElement || this;
                    var element = d3.select(touchEndElement);
                    var endEvent = element.on(touchendProp),
                        d = element.datum(),
                        identity = element.attr("id") || element.attr("class");
                    var i = (identity != null) ? identity.match(/(\d)+$/gi) : null;
                    i = (i != null && i[0] != null) ? parseInt(i[0]) : null;
                    if (endEvent != null && i != null) {
                        endEvent.call(touchEndElement, d, i);
                    }
                }
                // Call mouse move of the current element
                var element = d3.select(currentEle);
                var moveEvent = element.on(touchmoveProp),
                    d = element.datum(),
                    identity = element.attr("id") || element.attr("class");
                var i = (identity != null) ? identity.match(/(\d)+$/gi) : null;
                i = (i != null && i[0] != null) ? parseInt(i[0]) : null;
                if (moveEvent != null && i != null) {
                    moveEvent.call(currentEle, d, i);
                    prevElement = currentEle;
                    lastMove = currentTime;
                }
                return;
            }
        }

        if (!(isFocusedTouchmove && ((firstMove - touchstart.time) < FOCUSEDMOVEDURATION))) {
            if (singletouchmoveFn) {
                if (chartObj) {
                    chartObj.zcEventType = "touchmove"; //change
                }

                singletouchmoveFn.apply(this, arguments);
                preventDefault();
            }
        }

    };
    updatedHandlers[touchendProp] = function() {
        if (plotEventOptions.enabled == false) {
            return;
        }

        var touchObject = d3.event.touches;

        if (tapholdFn) {
            clearTimeout(tapHoldTimer);
            if (tapholdDetected) {
                tapholdDetected = false;
                preventDefault();
                if (tapholdendFn) {
                    tapholdendFn.apply(this, arguments);
                }
                return false;
            }
        }

        if (touchObject.length > 1) {
            return;
        }

        if (isDoubletouchStarted && doubletouchmoveFn && touchendFn) {
            isDoubletouchStarted = false;
            touchendFn.apply(this, arguments);
            preventDefault();
            return;
        }

        var currentTime = new Date(),
            currentLocation = getMousePosition(this, d3.event);
        var duration = currentTime - touchstart.time;
        var distance = (touchstart.location != null) ? getEuclideanDistance(touchstart.location[0], touchstart.location[1], currentLocation[0], currentLocation[1]) : null;
        var tapLength = currentTime - lastTap;

        if (tapDifference > 0 && tapLength <= tapDifference && tapLength > 0 && distance <= MINDISTANCE) { // Double tap event
            if (dbltapFn) {
                if (chartObj){
                    chartObj.zcEventType = "doubletap"; //change
                }

                dbltapFn.apply(this, arguments);
                preventDefault();
            }
            lastTap = 0;
        } else if (duration <= SINGLETAPDURATION && distance <= MINDISTANCE) { // Single tap event
            if (tapFn) {
                if (chartObj) {
                    chartObj.zcEventType = "tap"; //change
                }

                tapFn.apply(this, arguments);
                preventDefault();
            }
        } else {
            if (touchendFn) {
                touchendFn.apply(this, arguments);
            }
        }
        lastTap = currentTime;
    };

    ele.on(updatedHandlers)

    function getEuclideanDistance(x1, y1, x2, y2) {
        return Math.sqrt(Math.pow((x2 - x1), 2) + Math.pow((y2 - y1), 2));
    }

    function preventDefault() {
        if (doPreventDefault) {
            d3.event.preventDefault();
        }
    }
}//$Id$

function getFormattedValue(colInfo, value, dataType, chartObj, type, toDecode, arraySeperator, levelIndex) {
    if (!dataType) {
        return encodeOrDecode(value);
    }
    if (value == null) {
        return (colInfo && (colInfo.nullformatting != null)) ? encodeOrDecode(invokeFunction(colInfo.nullformatting, value, dataType, colInfo, type, chartObj)) : value;
    }
    var format = colInfo ? (colInfo[type + "format"] || colInfo.format) : null;
    if ((!format || !Object.keys(format).length)) {

        format = getDefaultFormat(dataType, colInfo);
    }
    return (value.constructor == Array) ? //For partition charts, array of values will come here to format
        value.map(function(d) {
            return applyFormat(d);
        }).join(defined(format.arraySeperator) ? format.arraySeperator : arraySeperator) :
        applyFormat(value);
    
    function applyFormat(value) {
        if (dataType === TIME_DATATYPE && !format.customFormat) {
            value = generateDateVal(value, format, colInfo);
        }
        if(levelIndex && format.customFormat){
            colInfo = simpleClone(colInfo);
            colInfo.levelindex  = levelIndex;
        }
        var formattedValue = (typeof format === "function") ?
            format(value, dataType, colInfo) :
            (format.customFormat ?
                invokeFunction(format.customFormat, value, dataType, colInfo, type, chartObj) :
                generateFormatSpecifier(format, value, colInfo, dataType, levelIndex, type));
        return encodeOrDecode(formattedValue);
    }
    
    function encodeOrDecode(val) {
        return (toDecode != false) ?
            decodeHTML(val) :
            encodeHTML(val);
    }
}

function getDefaultFormat(type, colInfo) {
    var defaultFormat = {};
    switch (type) {
        case "time":
            if(colInfo && colInfo.groupby){
                defaultFormat = {}
            }else if(colInfo && colInfo.subfunction){
                defaultFormat = getTimeSubfunctionFormatter(colInfo.subfunction, colInfo.useUTC)
            }else{
                defaultFormat.specifier = "YYYY";
            }

            break;
        case "numeric":
            defaultFormat.thousandSeperator = ",";
            break;
        case "percent":
            defaultFormat.decimalPlaces = 1;
            defaultFormat.suffix = "%";
            defaultFormat.trailingZeros = false;
    }
    return defaultFormat;
}

function generateFormatSpecifier(format, value, colInfo, dataType, levelIndex,type) {
    var formattedValue;
    switch (dataType) {
        case "time": {
            // if useUTC is true use utc time formatter else use local time formatter
            var d3Format = (colInfo && colInfo.useUTC === true) ? d3_timeFormatUTC : d3_timeFormat;
            var specifier = format.specifier;

            if((defined(specifier) && specifier.constructor == Array) || (defined(colInfo) && defined(colInfo.groupby) && isArray(colInfo.groupby))){
                //For multiple line lables with the given array of specifier
                formattedValue = [];
                specifier = specifier || [null];
                if(defined(levelIndex)){
                    specifier = (defined(specifier)) ? [specifier[levelIndex]] : [null];
                }
                specifier = (isArray(specifier)) ? specifier : [specifier]
                // specifier = (defined(levelIndex)) ? [specifier[levelIndex]] : specifier; //for timegroupby with specifier index
                specifier.forEach(function (d,i) {
                    var datetimespecifier = generated3TimeSpecifier(d),
                        formatter = generateTimeFormatter(d3Format,datetimespecifier, colInfo, levelIndex);
                        formattedValue[i] = (formatter) ? formatter(value) : value;
                })
                if(type == "datalabels"){
                    formattedValue = formattedValue && formattedValue.toString();
                }
            }else{
                var datetimespecifier = generated3TimeSpecifier(specifier);
                formattedValue = (format.specifier == "auto") ?
                    value //if format specifier is auto val should be timeScale.tickFormat()(d)
                    : ((datetimespecifier != null) ? d3Format(datetimespecifier)(value) : value);
            }

            break;
        }
        case "ordinal": {
            var lc = format.letterCase;
            value += ""; //toString
            formattedValue = lc ? ((lc === "uppercase") ? value.toUpperCase() : ((lc === "lowercase") ? value.toLowerCase() : (value[0].toUpperCase() + value.substring(1).toLowerCase()))) : value;
            break;
        }
        default: {
            var currency = format.currency;
            var numericspecifier = generated3NumericSpecifier(format);
            value = (format.type == "decimal" || (format.decimalPlaces === 0)) ? parseFloat(value) : value; //Decimal places = 0
            formattedValue = numericspecifier(value);

            if (defined(format.decimalPlaces) && /(e|s)/gi.test(getd3NumericFormatterType(format))) {
                formattedValue = formattedValue.replace(/[^a-z]+/i, function() {
                    return generated3NumericSpecifier(format, "." + format.decimalPlaces + "f")(arguments[0]);
                });
            }

            if (format.signEnabled === false) { //1) null -> shows sign for -ve only 2) true -> shows sign for +ve and -ve 3) false -> no sign shown for both +ve and -ve
                formattedValue = formattedValue.substring(1, formattedValue.length);
            }
            
            if (!validateNullVal(format.trailingZeros, true)) { // Remove trailing zeros
                var unitSuffix = "";
                formattedValue = formattedValue.replace(/[a-z]+(\+|-)*(\d)*$/i, function() {
                    unitSuffix = arguments[0];
                    return "";
                });

                formattedValue = formattedValue.replace(/\.(\d)*0*$/gi, function() {
                    var matchedString = parseFloat(arguments[0]);
                    return (!matchedString) ? "" : ("." + matchedString.toString().split(".")[1]);
                }) + unitSuffix;
            }

            formattedValue = applySeperators(format, formattedValue);
            
            if (currency != null) { //Add the currency symbol
                formattedValue = /(\+|\-)/.test(formattedValue[0]) ? (formattedValue[0] + currency + formattedValue.slice(1)) : (currency + formattedValue);
            }
        }
    }
    if(dataType == ORDINAL_DATATYPE || dataType == NUMERIC_DATATYPE){ //apply prefix or suffix
        formattedValue = ((format.prefix != null) ? format.prefix : "") + formattedValue + ((format.suffix != null) ? format.suffix : ""); //Adding prefix and suffix
    }

    return formattedValue;
}

function getTimeSubfunctionFormatter(subfunctype, useUTC) {
    useUTC = useUTC === true;
    var formatter = useUTC ? d3_timeFormatUTC : d3_timeFormat;
    switch (subfunctype) {
        case "YEAR":
        case "year":
            return formatter("%Y");
        case "MONTH":
        case "month":
            return formatter("%B");
        case "ABSDAY":
            return formatter("%a");
        case "DAY":
        case "day":
            return formatter("%e");
        case "WEEKDAY":
            return formatter("%A");
        case "WEEK":
        case "week":
            return formatter("Week %W");
        case "ABSHOUR":
            return formatter("%I");
        case "ABSSECOND":
            return formatter("%S");
        case "ABSMINUTE":
        case "MINUTE":
            return formatter("%M");
        case "MILLISEC":
            return formatter("%L");
        case "HOUR":
            return formatter("%H hrs");
        case "DATETIME":
            return formatter("%d %b %Y %H:%M:%S");
        case "DATE":
            return formatter("%x");
        case "TIME":
            return formatter("%X");
        case "TIMESTAMP":
            return formatter("%x %X hrs");
        case "ABSMONTH":
            return formatter("%b %Y");
        case "ABSWEEK":
            return formatter("W" + "%U" + " " + "%Y");
        case "ABSQUARTER":
            return (function(d) {
                var month = useUTC ? d.getUTCMonth() : d.getMonth();
                var year = useUTC ? d.getUTCFullYear() : d.getFullYear();
                var quarter = mathFloor(month / 3) + 1;
                return formatter("Q" + quarter + " " + year);
            });
        case "QUARTER":
            return (function(d) {
                var month = useUTC ? d.getUTCMonth() : d.getMonth();
                var quarter = mathFloor(month / 3) + 1;
                return formatter("Q" + quarter);
            });
        case 100:
            return formatter("%d %b %Y %H:%M:%S %L");
        default:
            throw "UNKNOWN TYPE 111: " + subfunctype;
    }
}

function generateDateVal(value, format, colInfo, toProcess) {
    //var dateValue = (format != null && format.specifier != null)? d3.time.format(format.specifier).parse(value):new Date(value.toString());
    var inputformat = colInfo ? colInfo.inputformat : null;
    var dateValue = new Date(value.toString());
    var customFunc = (typeof inputformat === "function") ? inputformat :
        ((typeof window[inputformat] === "function") ? window[inputformat] : null);
    if (!(value instanceof Date) && inputformat != null && (customFunc || inputformat.toLowerCase() != "timestamp")) {
        value = (!customFunc && !(typeof value == String)) ? value.toString() : value;
        var formatter = (colInfo && colInfo.useUTC === true) ? d3_timeFormatUTC : d3_timeFormat;
        var parsedVal = customFunc ? customFunc(value, colInfo) : formatter(generated3TimeSpecifier(inputformat)).parse(value);
        dateValue = (parsedVal == null) ? dateValue : new Date(parsedVal);
    }
    if (isNaN(dateValue)) {
        dateValue = new Date(+value);
    }
    return dateValue;
}

function getFormattedValueByPercent(colInfo, value, dataType, chartObj, type) {
    colInfo = colInfo || {};
    type = ((type && colInfo[type + "percentformat"]) ? type : "") + "percent";

    if (!colInfo[type + "format"]) {
        colInfo.percentformat = getDefaultFormat("percent");
    }

    return getFormattedValue(colInfo, value, dataType, chartObj, type);
}

//Format Utils
var timeSpecifiers = {
        "YYYY": "%Y",
        "MMMM": "%B",
        "EEEE": "%A",
        "EEE": "%a",
        "MMM": "%b",
        "YY": "%y",
        "MM": "%m",
        "EE": "%U",
        "dd": "%d",
        "HH": "%H",
        "hh": "%I",
        "mm": "%M",
        "ss": "%S",
        "a": "%p",
        "MILLI": "%L",
        "z": "%Z"
    },
    numericSpecifiers = {
        "decimal" : "d",
        "exponent": "e",
        "float": "f",
        "binary": "b",
        "octal": "o",
        "hexadecimal": "x",
        "SIprefix": "s"
    };

function generated3TimeSpecifier(specifier) {
    if (specifier) {
        for (var spec in timeSpecifiers) {
            var index = specifier.indexOf(spec);
            if ((index >= 0) && (specifier[index - 1] != "%")) {
                specifier = specifier.replace(spec, timeSpecifiers[spec]);
            }
        }
    }
    return specifier;
}

function  generateTimeFormatter(d3Format, specifier, colInfo, levelIndex) {
    var formatter;
    if(specifier){
        formatter = d3Format(specifier);
    }else if(colInfo.groupby){
        var subFuncType = (levelIndex == 0 || !defined(levelIndex)) ? colInfo.subfunction : colInfo.groupby[levelIndex-1];
        formatter = getTimeSubfunctionFormatter(subFuncType, colInfo.useUTC);
    }
    return formatter;
}

function generated3NumericSpecifier(format, defaultSpecifier) {
    var sign = (defined(format.signEnabled) ? "+" : ""),
        zeroPad = ((format.zeroPadding != null && format.zeroPadding.enabled) ? ("0" + format.zeroPadding.digits) : ""),
        thousandSep = ((format.thousandSeperator != null) ? "," : ""),
        type = getd3NumericFormatterType(format),
        decPlaces = (format.decimalPlaces != null) ? (/(e|s)/gi.test(type) ? ($Browser.IE ? ".20" : "") : ("." + format.decimalPlaces)) : ""; //#ZC898
    var formatSpecifier = sign + zeroPad + thousandSep + (defaultSpecifier || (decPlaces + type));
    return d3_format(formatSpecifier);
}

function getd3NumericFormatterType(format) {
    var decimalPlaces = format.decimalPlaces,
        type = format.type;
    
    return numericSpecifiers[type] ||
        ((type === "decimal" || !defined(decimalPlaces)) ?
            "" :
            "f");
}

function applySeperators(format, formattedValue) {
    var thSep = format.thousandSeperator,
        deSep = format.decimalSeperator,
        split = formattedValue.split(/\./);
    return ((thSep != null && thSep != ",") ? split[0].replace(/,/g, thSep) : split[0]) +
        (!split[1] ? "" : (deSep != null ? deSep : ".") + split[1]);
}

/**
 * Returns absolute years, months, days till seconds from timestamp
 * @param {Number} ms date timestamp
 * @returns {{seconds: number, minute: number, hour: number, day: number, month: number, years: number}}
 */

function millisecondToAbsoluteTime(ms) {
    var seconds = mathFloor(ms / 1000),
        minute = mathFloor(seconds / ( 60)),
        hour = mathFloor(minute / (60)),
        day = mathFloor(hour / (24)),
        month = mathFloor(day / (30.436854166666667)),
        years = mathFloor(day / 365.24225);

    return {
        seconds: seconds,
        minute: minute,
        hour: hour,
        day: day,
        month: month,
        years: years
    }
}

/**
 *
 * @param milliseconds
 * @returns {{subFunction: string, specifier: *}}
 */

function getAutoTimeSubFunction(milliseconds) {

    var absoluteTime = millisecondToAbsoluteTime(milliseconds),
        subFunction = "YEAR";

    if(absoluteTime.years > 1) {
        subFunction = "YEAR";
    } else if(absoluteTime.month > 1) {
        subFunction = "ABSMONTH";
    }
    else if(absoluteTime.day > 1) {
        subFunction = "ABSDAY";
    }
    else if(absoluteTime.hour > 1) {
        subFunction = "ABSHOUR";
    }
    else if(absoluteTime.minute > 1) {
        subFunction = "ABSMINUTE";

    } else {
        subFunction = "ABSSECOND";
    }

    return {
        subFunction: subFunction
    };
}//$Id$
$ZC.events.tooltip = function(element, data, chartObj) {
    "use strict";
    var hookPosition = {
        left: 50,
        top: 100,
        rotation: 0
    };
    var MAX_WIDTH = "40%",
        MAX_HEIGHT = "100%";
    
    var tooltip = {
            element: element
        },
        systemConf = chartObj.systemConf,
        dataset = chartObj.dataset,
        metadata = systemConf.metadata,
        metadata_axes = metadata.axes,
        metadata_columns = metadata.columns,
        tooltipIndices = metadata_axes.tooltip || d3.range(metadata_columns.length),
        tooltip_data = systemConf.tooltip,
        themeMaxWidth = null,

        // data processor helpers

        dataProcessorHelpers = $ZC.DataProcessor.helpers,
        getChartType = dataProcessorHelpers.getChartType,
        getParsedYAxisOrder = dataProcessorHelpers.getParsedYAxisOrder;
    
    if (tooltip_data.theme && tooltip_data.theme !== "") {
        var theme = isObjectPropDefined($ZC, "tooltip.getTheme") && $ZC.tooltip.getTheme(tooltip_data.theme, chartObj);
        if (theme !== null) {
            tooltip_data = chartObj.systemConf.tooltip = mergeJSON(tooltip_data, theme.borderStyle);
            chartObj.tooltip.content = [theme.body];
            themeMaxWidth = theme.maxWidth;
        }
    }
    
    var dist = 20,
        hookHeight = validateNullVal(tooltip_data.hookHeight, 6),
        borderWidth = (defined(tooltip_data.borderWidth) ? tooltip_data.borderWidth : 1),
        borderRadius = (defined(tooltip_data.borderRadius) ? tooltip_data.borderRadius : 5),
        borderStyle = defined(tooltip_data.borderStyle) ? tooltip_data.borderStyle : "solid",
        padding = defined(tooltip_data.padding) ? tooltip_data.padding + "" : 5 + "",
        isWithinChart = validateNullVal(tooltip_data.withinChart, true),
        hookBorderWidth = validateNullVal(tooltip_data.hookBorderWidth, (/ /g.test(borderWidth) ? 1 : +borderWidth)),
        parsedBorderRadius = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, borderRadius);

    var maxWidth = perToPx((tooltip_data.maxWidth || themeMaxWidth || MAX_WIDTH), chartObj.chartarea.width),
        maxHeight = perToPx((tooltip_data.maxHeight || MAX_HEIGHT), chartObj.chartarea.height),
        minWidth = mathMax(chartObj.chartarea.width * 0.05, (2 * hookHeight));

    var headerContentFunc = tooltip_data.headerContent,
        footerContentFunc = tooltip_data.footerContent,
        isColumnView = (tooltip_data.view === "column"), //normal | column
        crosshair_data = tooltip_data.crosshair;
    
    // Tooltip elements
    var arrowbefore,
        arrowafter,
        arrowBeforeNAfter,
        contentBox;

    tooltip.initialize = function() {
        
        var fontSize = getFontSizeByHierarchy(tooltip_data, chartObj),
            defaultLineHeight = ((+fontSize) + (+fontSize) * 0.35),
            userdataCanvasFontColor = (chartObj.userdata.canvas != null) ? chartObj.userdata.canvas.fontColor : null,
            borderRadius_px = shorthand_px(borderRadius),
            filterDisabled = tooltip_data.useChartEffect === false, // enabled default
            filterEffect = null;

        if (!filterDisabled && chartObj.filterEffectsID) {
            filterEffect = "url(#" + chartObj.filterEffectsID + ")";
        }
        
        
        element.style({
            "width": "auto",
            "box-shadow": tooltip_data.shadow,
            "opacity": tooltip_data.opacity,
            "z-index": tooltip_data.zindex,
            "border-radius": borderRadius_px,
            "border-width": shorthand_px(borderWidth),
            "border-style": borderStyle,
            "-webkit-transform-style": "preserve-3d",
            "-moz-transform-style": "preserve-3d",
            "-ms-transform-style": "preserve-3d",
            "-o-transform-style": "preserve-3d",
            "transform-style": "preserve-3d",
            // "-webkit-backface-visibility": "hidden",
            // "-moz-backface-visibility": "hidden",
            // "-ms-backface-visibility": "hidden",
            // "-o-backface-visibility": "hidden",
            // "backface-visibility": "hidden",
            "pointer-events": "none",
            "filter": filterEffect
            // "padding": shorthand_px(padding)
        });
        var borderTopBox = appendEle(element, "div", tooltip_data.borderTop ? [tooltip_data.borderTop] : [], ".", "class", "borderTop");
        borderTopBox.style({
            "pointer-events":"none",
            "height":tooltip_data.borderTop+"px",
            "border-radius": borderRadius_px,
            "border-bottom-left-radius": "1px",
            "border-bottom-right-radius": "1px"
        })
        
        contentBox = appendEle(element, "div", [1], "#", "id", "tooltipcontent");
        contentBox.style({
            "max-width": maxWidth + "px",
            "min-width": minWidth + "px",
            // "max-height" : maxHeight + "px", // Is it necessary?
            "line-height": (tooltip_data.lineHeight || defaultLineHeight) + "px",
            "word-wrap": "break-word",
            "white-space": "normal",
            "pointer-events": "none",
            "padding": shorthand_px(padding)
            //		"border-top":"1px solid red"
        });
        applyFont(contentBox, [{
            fontColor: (tooltip_data.fontColor == null && userdataCanvasFontColor == null) ? "white" : tooltip_data.fontColor || userdataCanvasFontColor
        }, tooltip_data, chartObj.systemConf.canvas, $ZCG], true);
        
        // arrow before
        arrowbefore = appendEle(element, "div", [1], "#", "id", "zctooltipbefore");
        arrowbefore
            .style({
                "margin-left": -(hookHeight + (2 * hookBorderWidth)) + "px",
                "border": (hookHeight + (2 * hookBorderWidth)) + "px solid transparent"
            });
        
        
        // arrow after
        arrowafter = appendEle(element, "div", [1], "#", "id", "zctooltipafter");
        arrowafter
            .style({
                "margin-left": -hookHeight + "px",
                "border": hookHeight + "px solid transparent"
            });

        // Properties for arrow before and after
        arrowBeforeNAfter = element.selectAll("div#zctooltipbefore,div#zctooltipafter");
        arrowBeforeNAfter
            .style({
                "border-color": "transparent",
                "border-top-color": "white",
                "position": "absolute",
                "top": "100%",
                "left": "50%",
                "pointer-events": "none",
                "width": 0,
                "height": 0,
                "content": " "
            });
    };
    
    tooltip.show = function(chartObj, position, content, useDefault, defaultArgs) {
        if (!defined(defaultArgs)) {
            defaultArgs = {}
        }

        var color = defaultArgs.color,
            svgFillFunc = defaultArgs.svgFillFunc,
            seriesindex = defaultArgs.seriesindex,
            subseriespos = defaultArgs.subseriespos,
            itempos = defaultArgs.itempos,
            backgroundColor = defaultArgs.backgroundColor || tooltip_data.backgroundColor,
            borderColor = defaultArgs.borderColor || tooltip_data.borderColor,
            tooltipSharedInfo = defaultArgs.tooltipSharedInfo,
            tooltipShared = defaultArgs.tooltipShared,
            chartType = (seriesindex != null) && chartObj.chartTypes[seriesindex].name,
            hasMultiColoring,
            hasDefaultMultiColoring;
        useDefault = content == null && useDefault === true;

        // getting color
        if (useDefault) {
            hasMultiColoring = /(bar|scatter|bubble$|bullet|gantt)/.test(chartType) && !chartObj.legendarea.show && systemConf.chart.plot.plotoptions[chartType].multiColoring;
            hasDefaultMultiColoring = /(^pie|funnel|pyramid)/.test(chartType);
        }
        var clr = color;
        if (useDefault) {
            var idx = (hasMultiColoring || hasDefaultMultiColoring) ? itempos : seriesindex;
            var dataPoint = dataset.getDataPoint(chartObj, null, seriesindex, subseriespos, itempos, defaultArgs.d);
            clr = getRawColor(chartObj, idx, dataPoint, seriesindex);
        } else if (isArray(clr)) {
            clr = clr[seriesindex % clr.length];
        }

        clr = (tooltipShared) ? "black" : clr;
        borderColor = (borderColor != null) ? borderColor : clr;
        backgroundColor = (backgroundColor != null && backgroundColor != "") ? backgroundColor : clr;

        element
            .style({
                "visibility": "visible",
                "background-color": backgroundColor,
                "border-color": borderColor
            })
        //***** TOOLTIP INNERHTML
        var tooltipcontent = "",
            toUserInfo;

        //custom header content
        if (useDefault && headerContentFunc != null) {
            tooltipcontent = invokeFunction(headerContentFunc, d3.event, (toUserInfo = getInfoToUser()), chartObj);
        }

        //content
        if (useDefault) {
            if (tooltip_data.content) {
                tooltipcontent += invokeFunction(tooltip_data.content, d3.event, (toUserInfo = toUserInfo || getInfoToUser()), chartObj);
            } else if (tooltipShared) {
                tooltipcontent += getTooltipSharedContent(seriesindex, subseriespos, itempos, defaultArgs.d, tooltipSharedInfo, color, hasMultiColoring);
            } else {
                tooltipcontent += getDefaultContent(seriesindex, subseriespos, itempos, clr, defaultArgs.d);
            }
        } else {
            tooltipcontent += content;
        }

        //custom footer content
        if (useDefault && footerContentFunc != null) {
            tooltipcontent += invokeFunction(footerContentFunc, d3.event, (toUserInfo = toUserInfo || getInfoToUser()), chartObj);
        }

        contentBox
            .html(tooltipcontent);
        // TOOLTIP INNERHTML *****

        var elementNode = element.node(),
            eleWidth = elementNode.offsetWidth,
            eleHeight = elementNode.offsetHeight,
            curx = parseFloat(elementNode.style.left),
            cury = parseFloat(elementNode.style.top);

        var coordinate = getTooltipXY(position, eleWidth, eleHeight, chartObj);

        //borderTop
        if(tooltip_data.borderTop){
            var svgFillEle = (svgFillFunc) ? svgFillFunc((hasDefaultMultiColoring || hasMultiColoring ? itempos : seriesindex), null,null, clr, null,null,{"width":eleWidth},true) : borderColor;
            var svgFillUrl = (typeof svgFillEle === 'object') ? "url(" + getSVGImage(svgFillEle,true).url + ")" : svgFillEle;
            var borderTop = element.selectAll("div.borderTop");
            borderTop.style({
                "background":svgFillUrl
            })
        }

        if (crosshair_data.type != "none" && chartObj.isAxisCategory) {
            showCrossshair(chartObj, position.actLeft || position.left, position.actTop || position.top, crosshair_data);
        }

        // Transition will start after ~4ms only. If the tooltip is called at the first time no transition
        if (!curx || isNaN(curx) || !cury || isNaN(cury)) {
            element.style({
                "left": coordinate.x + "px",
                "top": coordinate.y + "px"
            });
        }

        curx = !curx || isNaN(curx) ? coordinate.x : (2 * curx + coordinate.x) / 3;
        cury = !cury || isNaN(cury) ? coordinate.y : (cury + coordinate.y) / 2;

        element
            .interrupt()
            .transition();

        element
            .transition()
            .delay(0);

        element
            .transition()
            .duration(100)
            .ease("linear")
            .styleTween("left", positionTween(curx, coordinate.x)) //To avoid sub pixel rendering issue, d3.interpolateRound has been used
            .styleTween("top", positionTween(cury, coordinate.y));
        
        
        // Tooltip arrow
        if (tooltipShared) {
            arrowBeforeNAfter
                .style("display", "none");
        } else {
            var arrowTransform = "rotate(" + hookPosition.rotation + "deg)",
                arrowTransformOrigin = "50% 0%";

            arrowBeforeNAfter
                .style({
                    "display": "",
                    "left": hookPosition.left + "%",
                    "top": hookPosition.top + "%",
                    "transform": arrowTransform,
                    "-webkit-transform": arrowTransform,
                    "-ms-transform": arrowTransform,
                    "transform-origin": arrowTransformOrigin,
                    "-webkit-transform-origin": arrowTransformOrigin,
                    "-ms-transform-origin": arrowTransformOrigin
                });

            arrowbefore
                .style("border-top-color", borderColor);

            arrowafter
                .style({
                    "border-top-color": backgroundColor,
                    "opacity": 1
                });
        }

        function getInfoToUser() {
            if (tooltipShared) {
                return tooltipSharedInfo.keys().map(function(d) {
                    var curSerpos = pInt(d),
                        curItempos = pInt(tooltipSharedInfo.get(d)),
                        clridx = dataset.getColumnIdx("clr");
                    var yaxiscolumnorder = chartObj.seriesdata[curSerpos].yaxiscolumnorder || [0, 0];
                    var validx = (chartObj.ismultiy || clridx == null) ? dataset.getColumnIdx("y", yaxiscolumnorder) : clridx;
                    var dp = dataset.getDataPoint(chartObj, validx, curSerpos, subseriespos, curItempos);
                    var metaInfoObj = dataset.getMetaInfoObj(chartObj, dp, curSerpos);
                    return {
                        "actData": dp,
                        "metaInfo": metaInfoObj
                    };
                });
            }
            var dp = dataset.getDataPoint(chartObj, null, seriesindex, subseriespos, itempos, defaultArgs.d);
            var metaInfoObj = chartObj.dataset.getMetaInfoObj(chartObj, dp, seriesindex);
            return {
                "actData": dp,
                "metaInfo": metaInfoObj,
                "seriesIndex": seriesindex,
                "subseriesIndex": subseriespos,
                "itemIndex": itempos
            };
        }
    };

    
    tooltip.hide = function(tooltipele) {
        tooltipele = (tooltipele == null) ? this.element : tooltipele;
        tooltipele
            .style("visibility", "hidden");
        if (chartObj.systemConf.tooltip.crosshair.type != "none") {
            chartObj.staticPaneSVG.selectAll("g.crosshair")
                .style("visibility", "hidden");
        }
    };

    tooltip.destroy = function() {
        this.element.remove();
    };

    tooltip.getTooltipContent = function() {
        /* arguments
         * 0 - seriesIndex
         * 1 - subseriesIndex
         * 2 - itemIndex
         */

        return getDefaultContent.apply(null,arguments);
    };
    
    function showCrossshair(chartObj, x, y, data) {
        chartObj.staticPaneSVG.selectAll("g.crosshair")
            .style("visibility", "visible");

        var type = data.type;
        if (type == "x" || type == "xy") {
            drawCrosshairLine(chartObj, x, y, data, "x")
        }
        if (type == "y" || type == "xy") {
            drawCrosshairLine(chartObj, x, y, data, "y")
        }
        
    }
    
    function drawCrosshairLine(chartObj, x, y, data, type) {
        var ele = chartObj.staticPaneSVG.selectAll("line." + type + "-crosshair");
        var isVerticalLine = (type == "x" && !chartObj.axes.rotated) || (type == "y" && chartObj.axes.rotated);
        ele
            .attr({
                "x1": (isVerticalLine) ? x : chartObj.plotarea.left,
                "y1": (isVerticalLine) ? chartObj.plotarea.top : y,
                "x2": (isVerticalLine) ? x : chartObj.plotarea.left + chartObj.plotarea.width,
                "y2": (isVerticalLine) ? chartObj.plotarea.height + chartObj.plotarea.top : y
            }).style({
            "shape-rendering": "crispEdges",
            "stroke": data.color,
            "stroke-width": data.strokeWidth,
            "stroke-dasharray": getDashArray(data.dashStyle, data.strokeWidth),
            "pointer-events": "none"
        })
    }
    
    function getTooltipXY(position, eleWidth, eleHeight, chartObj) {
        var marginRight = 2,
            canvasarea = chartObj.canvasarea,
            distance = dist + hookHeight + (position.distance || 0),
            dTop = position.dTop || 0,
            dLeft = position.dLeft || 0;
        hookPosition = {
            left: 50,
            top: 100,
            rotation: 0
        };
        
        var checkBounds = {
                left: mathAbs(mathMin(dLeft, 0)) + (chartObj.scrolledX || 0),
                top: mathAbs(mathMin(dTop, 0)) + (chartObj.scrolledY || 0),
                right: (canvasarea.width - marginRight - mathMax(dLeft, 0)) + mathAbs(mathMin(dLeft, 0)), // width + left
                bottom: (canvasarea.height - mathMax(dTop, 0)) + mathAbs(mathMin(dTop, 0)) // height + top
            },
            coordinate = {
                x: (position.left - (eleWidth / 2)),
                y: (position.top - eleHeight - distance)
            };
        
        if (!(!isWithinChart || chartObj.scrolledX || chartObj.scrolledY)) {
            var maxTop = position.top - eleHeight - distance,
                maxRight = position.left + eleWidth + distance,
                maxLeft = position.left - eleWidth - distance,
                maxBottom = position.top + eleHeight + distance
            
            if (maxTop > checkBounds.top) { // TOP
                positionHook(position, eleWidth, eleHeight, coordinate, checkBounds, "top");
                hookPosition.rotation = 0;
                hookPosition.top = 100;
            } else if (maxRight < checkBounds.right) { // RIGHT
                coordinate.x = position.left + distance;
                positionHook(position, eleWidth, eleHeight, coordinate, checkBounds, "right");
                hookPosition.rotation = 90;
                hookPosition.left = 0;
            } else if (maxLeft > checkBounds.left) { // LEFT
                coordinate.x = position.left - distance - eleWidth;
                positionHook(position, eleWidth, eleHeight, coordinate, checkBounds, "left");
                hookPosition.rotation = -90;
                hookPosition.left = 100;
            } else if (maxBottom < checkBounds.bottom) { // BOTTOM
                positionHook(position, eleWidth, eleHeight, coordinate, checkBounds, "bottom");
                coordinate.y = position.top + distance;
                hookPosition.rotation = 180;
                hookPosition.top = 0;
            }
        }

        return coordinate;
    }
    
    function positionHook(position, eleWidth, eleHeight, coordinate, checkBounds, mode) {
        var rad;
        if (/(top|bottom)/.test(mode)) {
            if ((position.left - (eleWidth / 2)) < checkBounds.left) { // Is within left?
                rad = getRad((mode == "top") ? "blx" : "tlx");
                coordinate.x = checkBounds.left;
                hookPosition.left = (mathMax(rad, (position.left - checkBounds.left)) / eleWidth) * 100;
            } else if ((position.left + (eleWidth / 2)) > checkBounds.right) { // Is within right?
                rad = getRad((mode == "top") ? "brx" : "trx");
                coordinate.x = checkBounds.right - eleWidth;
                hookPosition.left = (1 - (mathMax(rad, (checkBounds.right - position.left)) / eleWidth)) * 100;
            } else {
                hookPosition.left = 50;
            }
        } else {
            if ((position.top - (eleHeight / 2)) < checkBounds.top) { // Is within top?
                rad = getRad((mode == "left") ? "trY" : "tly");
                coordinate.y = checkBounds.top;
                hookPosition.top = (mathMax(rad, (position.top - checkBounds.top)) / eleHeight) * 100;
            } else if ((position.top + (eleHeight / 2)) > checkBounds.bottom) { // Is within bottom?
                rad = getRad((mode == "left") ? "bry" : "bly");
                coordinate.y = checkBounds.bottom - eleHeight;
                hookPosition.top = (1 - (mathMax(rad, (checkBounds.bottom - position.top)) / eleHeight)) * 100;
            } else {
                coordinate.y = position.top - (eleHeight / 2);
                hookPosition.top = 50;
            }
        }
    }
    
    function getRad(attr) {
        return hookHeight + parsedBorderRadius[attr] + mathSQRT(mathPow(hookBorderWidth, 2) + mathPow(hookBorderWidth, 2));
    }
    
    function getDefaultContent(seriesindex, subseriespos, itempos, color, d, customTooltipIndices) {
        
        if (isObjectPropDefined($ZC, "tooltip.getTheme") && defined(systemConf.tooltip.theme) && systemConf.tooltip.theme !== "") {
            if (defined(chartObj.tooltip.content)) {
                return dataset.getCustomizedVal(chartObj, chartObj.tooltip.content, seriesindex, subseriespos, itempos, d, "tooltip", color);
            }
        }
        
        var seriesdata = systemConf.seriesdata.chartdata,
            curTooltipIndices = customTooltipIndices || tooltipIndices,
            dataPoint;
        var tooltipcontent = isColumnView ? "<table cellspacing='0' cellpadding='0' border='0' style='border-spacing: 5px;'><tbody>" : "";
        curTooltipIndices.forEach(function(colidx, i) {
            var isRegexAvailable = metadata_columns[colidx] == null;
            var func = isRegexAvailable ? get_custom_content : get_default_col_val_content;
            tooltipcontent += func(seriesindex, subseriespos, itempos, d, colidx, i, color, curTooltipIndices);
        });
        tooltipcontent += isColumnView ? "</tbody></table>" : "";
        return tooltipcontent;
    }
    
    function get_default_col_val_content(seriesindex, subseriespos, itempos, d, colidx) {
        var columnname = dataset.getColumnName(colidx, false),
            yaxiscolumnorder = getParsedYAxisOrder(chartObj.seriesdata[seriesindex].yaxiscolumnorder),
            dataPoint = dataset.getDataPoint(chartObj, colidx, seriesindex, subseriespos, itempos, d),
            content = "";
        var yidx = dataset.getColumnIdx("y", yaxiscolumnorder);
        
        if (dataPoint != null) {
            var val = dataset.getDataPointValue(chartObj, dataPoint, colidx, seriesindex,false, "tooltip");
            val = (colidx == yidx && val instanceof Array) ? val[0] + " - " + val[1] : val
            content = isColumnView ?
                "<tr style='vertical-align: top;'><td style='max-width:" + (maxWidth * 0.4) + "px;'>" + columnname + ": </td><td style='max-width:" + (maxWidth * 0.6) + "px;'><b>" + val + "</b></td></tr>" :
                columnname + " : " + val + "<br>";
        }
        return content;
    }
    
    function get_custom_content(seriesindex, subseriespos, itempos, d, colidx, i, color, meta_tooltip) {
        var customizedString = dataset.getCustomizedVal(chartObj, colidx, seriesindex, subseriespos, itempos, d, "tooltip", color); //{{val(INDEX)}} {{col(INDEX)}} {{per(INDEX)}} - pattern will be replaced with the respective value , columnname and the percentage of value
        return isColumnView ?
            "<tr style='vertical-align: top;'><td style='max-width:" + maxWidth + "px;'>" + customizedString + "</td></tr>" :
            (customizedString + ((i == meta_tooltip.length - 1) ? "" : "<br>"));
    }
    
    function get_shared_tooltip_meta(tooltipSharedInfo) {
        var meta_tooltip = tooltipIndices;
        var has_custom_tooltip = meta_tooltip.some(function(d) {
            return (typeof d === "string") && CUSTOM_VALUE_PATTERN.test(d);
        });
        if (!has_custom_tooltip) {
            meta_tooltip = [];
            var x_pattern = "{{val(" + dataset.getColumnIdx("x") + ")}}",
                y_pattern = tooltipSharedInfo.y_val_pattern,
                clr_pattern = "{{clr}}",
                clr_val_pattern = tooltipSharedInfo.y_col_pattern;
            
            var x_val = x_pattern,
                y_val = isColumnView ?
                    "<tr style='vertical-align: top;'><td style='max-width:" + (maxWidth * 0.4) + "px;'><div style='margin-right:0.2em;display:inline-block;vertical-align:middle;border-radius: 50%;padding:0.4em;background:" + clr_pattern + "''></div>" + clr_val_pattern + ": </td><td style='max-width:" + (maxWidth * 0.6) + "px;'>" + y_pattern + "</td></tr>" :
                    "<div style='margin-right:0.2em;display:inline-block;vertical-align:middle;border-radius: 50%;padding:0.4em;background:" + clr_pattern + "''></div>" + clr_val_pattern + " : " + y_pattern;
            meta_tooltip.push(x_val, y_val);
        }
        return meta_tooltip;
    }
    
    function getTooltipSharedContent(seriesindex, subseriespos, itempos, d, tooltipSharedInfo, color, hasMultiColoring) {
        
        var tooltipcontent = isColumnView ? "<table cellspacing='0' cellpadding='0' border='0' style='border-spacing: 5px;'><tbody>" : "";
        var clridx = dataset.getColumnIdx("clr");
        var yaxiscolumnorder_series = chartObj.seriesdata[seriesindex].yaxiscolumnorder || [0, 0]; //yaxiscolumnorder is not mandatory
        var yidx = dataset.getColumnIdx("y", yaxiscolumnorder_series);
        var sharedKeys = tooltipSharedInfo.keys();
        
        var y_pattern = tooltipSharedInfo.y_val_pattern,
            meta_tooltip = get_shared_tooltip_meta(tooltipSharedInfo);
        
        meta_tooltip.forEach(function(pattern, i) {
            if (metadata_columns[pattern] != null) {
                //columnname : value
                tooltipcontent += get_default_col_val_content(seriesindex, subseriespos, itempos, d, pattern);
            } else if ((typeof pattern === "string") && (pattern.indexOf("{{val(" + yidx + ")}}") != -1)) {
                //y-values
                for (var i = 0, len = tooltipSharedInfo.size(); i < len; i++) {
                    var curSerpos = pInt(sharedKeys[i]),
                        curItempos = pInt(tooltipSharedInfo.get(sharedKeys[i])),
                        cur_pattern = pattern,
                        copy_y_pattern = y_pattern;

                    var clr = color;
                    if (isArray(clr)) {
                        var dataPoint = dataset.getDataPoint(chartObj, null, curSerpos, subseriespos, curItempos, d);
                        clr = getRawColor(chartObj, (hasMultiColoring ? curItempos : curSerpos), dataPoint, curSerpos);
                    }

                    if (chartObj.ismultiy || clridx == null) {
                        cur_pattern = pattern.replace("{{val(null)}}", (encodeHTML(chartObj.seriesdata[curSerpos].seriesname) || copy_y_pattern.replace(/val/gi, "col")))
                    }
                    var content = dataset.getCustomizedVal(chartObj, cur_pattern, curSerpos, subseriespos, curItempos, d, "tooltip", clr);
                    tooltipcontent += content + (isColumnView ? "" : "<br>");
                }
            } else {
                //Custom text with non y-values
                tooltipcontent += get_custom_content(seriesindex, subseriespos, itempos, d, pattern, i, color, meta_tooltip)
            }
        });
        
        tooltipcontent += isColumnView ? "</tbody></table>" : "";
        return tooltipcontent;
        
    }

    function positionTween(start, end) {
        return function(d, i) {
            var interpolate = d3.interpolateRound(parseInt(start), parseInt(end));
            return function(t) {
                return interpolate(t) + "px";
            };
        }
    }

    return tooltip;
};//$Id$
var canvas_plot_renderer = {},
    canvas_drawer = {};

$ZC.plot.canvasRenderer = function(chartObj, args) {
    "use strict";
    
    var canvasRenderer = {};
    var systemconf = chartObj.systemConf,
        helpers = $ZC.DataProcessor.helpers;
    
    
    canvasRenderer.draw = function(update) {
        /**
         * Disable legendHighlight
         */
        //systemconf.legend.highlightEffect.selectedSeries = "none";
        
        chartObj.container.select(".highlight-canvas").style("visibility", "hidden");
        
        chartObj.context = updateCanvasContext(chartObj, "zc-canvas");
        chartObj.labelHolderContext = updateCanvasContext(chartObj, "zc-labelholder-canvas", window.PointerEvent ? chartObj.container.selectAll("div.legendarea").node() : null);
        args.barDatasetIndex = 0;
        
        if (chartObj.systemConf.legend.enabled) {
            chartObj.svg.select(".seriesholder").selectAll("*:not(.zmarea)").remove(); // remove all except zoom are
        }
        
        if (chartObj.dataset.getDataType("x") == ORDINAL_DATATYPE && chartObj.isAxisCategory) {
            $ZC.scale.barBandwidth(chartObj);
        }
        
        var type = null;
        chartObj.chartRendered = false;
        var isComboChart = chartObj.dataObject.isCombinationalChart;
        var orderedSeriesdata = (isComboChart) ? renderer_helpers.arrangeSeriesRenderingOrder(chartObj) : chartObj.seriesdata;
        
        chartObj.seriesdata.forEach(function(d, i) {
            var currOrdereddata = orderedSeriesdata[i];
            var curSeriesidx = (isComboChart) ? currOrdereddata.seriesidx : i;
            
            if (!chartObj.isAxisCategory && (curSeriesidx > 0)) {
                return;
            }
            type = helpers.getChartType((currOrdereddata.type || chartObj.userdata.seriesdata.type), "string");
            
            if (chartObj.renderer[curSeriesidx] == null) {
                chartObj.renderer[curSeriesidx] = createCanvasRenderer(type);
                chartObj.rendererConf[curSeriesidx] = new $ZC.plot.rendererConf();
            }
            chartObj.renderer[curSeriesidx].chartRendered = false;
            
            if (i == 0) {
                stateChangeListener(chartObj, systemconf.chart.plot.events, "plot", "init");
                chartObj.hideLoading(chartObj.container);
            }
            
            renderer_helpers.setRendererProp(chartObj, chartObj.renderer[curSeriesidx], currOrdereddata, curSeriesidx, args);
            drawCanvas(chartObj, currOrdereddata, chartObj.renderer[curSeriesidx]);
        });
        renderer_helpers.renderCompletedEvents(chartObj, update, args);
        
        
        if (!update) {
            
            /**
             * Fade Effect
             */
            var commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions[type];
            var animationOptions = getAnimationConf(commonPlotOptions, chartObj.seriesdata[0].plotoptions, chartObj, type);
            var animationDuration = defined(animationOptions.duration) ? animationOptions.duration : 400;
            if (!defined(animationOptions.enabled) || animationDuration === 0) {
                return
            }
            
            var totalSeries = chartObj.seriesdata.length;
            chartObj.context.canvas.style.opacity = 0;
            
            var fadeTimeout = setInterval(function() {
                var allRendered = true;
                if (chartObj.renderer.length === totalSeries) {
                    for (var i = 0; i < chartObj.renderer.length; i++) {
                        if (!chartObj.renderer[i].chartRendered) {
                            allRendered = false;
                            break
                        }
                    }
                }
                
                if (allRendered) {
                    clearInterval(fadeTimeout);
                    d3_select(chartObj.context.canvas)
                        .transition()
                        .duration(animationDuration)
                        .style("opacity", 1);
                }
            }, 1000 / 60);
        }
    };
    
    return canvasRenderer;
};

function createCanvasRenderer(chartName) {
    switch (chartName) {
        case "bullet": {
            chartName = "bar";
            break;
        }
        case "arearange": {
            chartName = "area";
            break;
        }
        case "bubble": {
            chartName = "scatter";
            break;
        }
    }
    return new canvas_plot_renderer[chartName]();
}

function drawCanvas(chartObj, renderdata, renderer, context, styles, filterIndex) {
    
    
    context = defined(context) ? context : chartObj.context;
    var wrap = chartObj.svg.selectAll('g.xychart');
    transformWrap(wrap, "seriesholder", {
        x: chartObj.plotarea.left,
        y: chartObj.plotarea.top
    });
    transformWrap(chartObj.staticPaneSVG, "labelholder", {
        x: chartObj.plotarea.left,
        y: chartObj.plotarea.top
    });
    renderer(context, renderdata, styles, filterIndex);
    
    function transformWrap(wrap, selection, translate) {
        return (wrap.select('g.' + selection)
            .attr('transform', 'translate(' + (translate.x) + ',' + (translate.y) + ')'));
    }
}

function updateCanvasContext(chartObj, selector, prevElement){
    var parentNode = chartObj.svg.node().parentNode;
    var canvas = chartObj.svg.node().parentNode.querySelector("canvas." + selector);
    var width = chartObj.plotarea.width,
        height = chartObj.plotarea.height;
    
    if (!canvas) {
        canvas = document.createElement("canvas");
        canvas.className = selector;
        canvas.setAttribute("actual-width", width);
        canvas.setAttribute("actual-height", height);
        canvas.style.position = "absolute";
        canvas.style.pointerEvents = "none";
        parentNode.insertBefore(canvas, prevElement || chartObj.staticPaneSVG.node());
    }
    
    canvas.width = width;
    canvas.height = height;
    canvas.style.left = mathRound(chartObj.plotarea.left) + "px";
    canvas.style.top = mathRound(chartObj.plotarea.top) + "px";
    canvas.style.visibility = "visible";
    var context = canvas.getContext("2d");
    if (window.devicePixelRatio) {
        canvas.style.width = mathFloor(width) + "px";
        canvas.style.height = mathFloor(height) + "px";
        canvas.width = width * window.devicePixelRatio;
        canvas.height = height * window.devicePixelRatio;
        context.scale(window.devicePixelRatio, window.devicePixelRatio);
    } else {
        window.devicePixelRatio = 1;
    }
    context.clearRect(0, 0, width, height);
    return context;
}//$Id$
"use strict";
var canvasUtils = (function() {
    var utils = {};
    utils.drawPath = function(ctx, pathString) {
        var relX=0, relY=0;
        parseSVGPath(pathString).forEach(function(d) {
            var moves, p;
            switch (d.function) {
                case "M":
                    ctx.moveTo(d.moves[0], d.moves[1]);
                    relX = d.moves[0], relY = d.moves[1];
                    break;
                case "L":
                    for (var i = 0; i < d.moves.length; i = i + 2) {
                        ctx.lineTo(d.moves[i], d.moves[i + 1]);
                    }
                    break;
                case "l": //for relative path line L
                    for (var i = 0; i < d.moves.length; i = i + 2) {
                        relX += d.moves[i], relY += d.moves[i+1];
                        ctx.lineTo(relX, relY);
                    }
                    break;
                case "A":
                    ctx.arcTo(d.moves[0], d.moves[1], d.moves[2], d.moves[3], d.moves[4]);
                    break;
                case "C":
                    moves = d.moves;
                    while (moves.length) {
                        p = moves.splice(0, 6);
                        ctx.bezierCurveTo(p[0], p[1], p[2], p[3], p[4], p[5]);
                    }
                    break;
                case "c": //for relative path cubic curve C
                    moves = d.moves;
                    while (moves.length) {
                        p = moves.splice(0, 6);
                        p[0] += relX, p[2] += relX, p[1] += relY, p[3] += relY;
                        relX += p[4] , relY += p[5];
                        ctx.bezierCurveTo(p[0], p[1], p[2], p[3], relX, relY);
                    }
                    break;
                case "Q":
                    moves = d.moves;
                    while (moves.length > 0) {
                        p = moves.splice(0, 6);
                        ctx.quadraticCurveTo(p[0], p[1], p[2], p[3]);
                    }
                    break;
                case "Z":
                    ctx.closePath();
                    break;
            }
        });
    };
    
    utils.getRadianAngle = function(degreeValue) {
        return degreeValue * mathPI / 180;
    };
    
    utils.constant = function(x) {
        return function constant() {
            return x;
        };
    };
    
    utils.pointX = function(p) {
        return p[0];
    };
    
    utils.pointY = function(p) {
        return p[1];
    };
    
    utils.rgba = function(color, opacity) {
        if (typeof color === "string" && (color.indexOf("rgba") > -1 || color === "transparent")) {
            return color;
        }
        var rgb = d3_rgb(color);
        opacity = (opacity === null || opacity === "" || opacity === undefined) ? 1 : opacity;
        return "rgba(" + rgb.r + "," + rgb.g + "," + rgb.b + "," + opacity + ")";
    };
    
    utils.roundedRect = function(context, x, y, width, height, radius) {
        radius = adjust(radius, width, height);
        context.moveTo(x + radius.tlx, y);
        context.lineTo(x + width - radius.trx, y);
        context.quadraticCurveTo(x + width, y, x + width, y + radius.trx);
        context.lineTo(x + width, y + height - radius.brx);
        context.quadraticCurveTo(x + width, y + height, x + width - radius.brx, y + height);
        context.lineTo(x + radius.blx, y + height);
        context.quadraticCurveTo(x, y + height, x, y + height - radius.blx);
        context.lineTo(x, y + radius.tlx);
        context.quadraticCurveTo(x, y, x + radius.tlx, y);
        context.closePath();
        
        function adjust(r, w, h) {
            if (w < 2 * r.tlx) {
                r.tlx = w / 2;
            }
            if (h < 2 * r.tlx) {
                r.tlx = h / 2;
            }
            if (w < 2 * r.trx) {
                r.trx = w / 2;
            }
            if (h < 2 * r.trx) {
                r.trx = h / 2;
            }
            if (w < 2 * r.blx) {
                r.blx = w / 2;
            }
            if (h < 2 * r.blx) {
                r.blx = h / 2;
            }
            if (w < 2 * r.brx) {
                r.brx = w / 2;
            }
            if (h < 2 * r.brx) {
                r.brx = h / 2;
            }
            return r;
        }
    };
    
    utils.boundBoxWithHook = function(context, pathDescription) {
        var controlIndex = 0;
        var points = parseSVGPath(pathDescription);
        points.forEach(function(d, i) {
            var moves = d.moves;
            switch (d.function.toLowerCase()) {
                case "m":
                    context.moveTo(moves[0], moves[1]);
                    break;
                case "l":
                    context.lineTo(moves[0], moves[1]);
                    break;
                case "a":
                    var prevMoves = points[i - 1].moves;
                    var controlPoint = (controlIndex == 0) ? [prevMoves[0], moves[6]] :
                        (controlIndex == 1) ? [moves[5], prevMoves[1]] :
                            (controlIndex == 2) ? [prevMoves[0], moves[6]] :
                                [moves[5], prevMoves[1]];
                    controlIndex++;
                    context.quadraticCurveTo(controlPoint[0], controlPoint[1], moves[5], moves[6]);
            }
        });
    };
    
    
    utils.getFontStyles = function(chartObj, dataLabels, color) {
        return applyDatalabelFonts(null, dataLabels, chartObj, color);
    };
    
    return utils
})();

//$Id$

/**
 * Canvas Interpolation
 */
"use strict";

var canvasInterpolation = {};

function Linear(context) {
    this._context = context;
}

Linear.prototype = {
    areaStart: function() {
        this._line = 0;
    },
    areaEnd: function() {
        this._line = NaN;
    },
    lineStart: function() {
        this._point = 0;
    },
    lineEnd: function() {
        if (this._line || (this._line !== 0 && this._point === 1)) {
            this._context.closePath();
        }
        this._line = 1 - this._line;
    },
    point: function(x, y) {
        x = +x, y = +y;
        switch (this._point) {
            case 0:
                this._point = 1;
                this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                break;
            case 1:
                this._point = 2; // proceed
            default:
                this._context.lineTo(x, y);
                break;
        }
    }
};

function curveLinear(context) {
    return new Linear(context);
}

function point$1(that, x, y) {
    that._context.bezierCurveTo(
        that._x1 + that._k * (that._x2 - that._x0),
        that._y1 + that._k * (that._y2 - that._y0),
        that._x2 + that._k * (that._x1 - x),
        that._y2 + that._k * (that._y1 - y),
        that._x2,
        that._y2
    );
}

function Cardinal(context, tension) {
    this._context = context;
    this._k = (1 - tension) / 6;
}

Cardinal.prototype = {
    areaStart: function() {
        this._line = 0;
    },
    areaEnd: function() {
        this._line = NaN;
    },
    lineStart: function() {
        this._x0 = this._x1 = this._x2 =
            this._y0 = this._y1 = this._y2 = NaN;
        this._point = 0;
    },
    lineEnd: function() {
        switch (this._point) {
            case 2:
                this._context.lineTo(this._x2, this._y2);
                break;
            case 3:
                point$1(this, this._x1, this._y1);
                break;
        }
        if (this._line || (this._line !== 0 && this._point === 1)) {
            this._context.closePath();
        }
        this._line = 1 - this._line;
    },
    point: function(x, y) {
        x = +x, y = +y;
        switch (this._point) {
            case 0:
                this._point = 1;
                this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                break;
            case 1:
                this._point = 2;
                this._x1 = x, this._y1 = y;
                break;
            case 2:
                this._point = 3; // proceed
            default:
                point$1(this, x, y);
                break;
        }
        this._x0 = this._x1, this._x1 = this._x2, this._x2 = x;
        this._y0 = this._y1, this._y1 = this._y2, this._y2 = y;
    }
};
var cardinal = (function custom(tension) {
    function cardinal(context) {
        return new Cardinal(context, tension);
    }
    
    cardinal.tension = function(tension) {
        return custom(+tension);
    };
    return cardinal;
})(0);

function Step(context, t) {
    this._context = context;
    this._t = t;
}

Step.prototype = {
    areaStart: function() {
        this._line = 0;
    },
    areaEnd: function() {
        this._line = NaN;
    },
    lineStart: function() {
        this._x = this._y = NaN;
        this._point = 0;
    },
    lineEnd: function() {
        if (0 < this._t && this._t < 1 && this._point === 2) {
            this._context.lineTo(this._x, this._y);
        }
        if (this._line || (this._line !== 0 && this._point === 1)) {
            this._context.closePath();
        }
        if (this._line >= 0) {
            this._t = 1 - this._t, this._line = 1 - this._line;
        }
    },
    point: function(x, y) {
        x = +x, y = +y;
        switch (this._point) {
            case 0:
                this._point = 1;
                this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                break;
            case 1:
                this._point = 2; // proceed
            default: {
                if (this._t <= 0) {
                    this._context.lineTo(this._x, y);
                    this._context.lineTo(x, y);
                } else {
                    var x1 = this._x * (1 - this._t) + x * this._t;
                    this._context.lineTo(x1, this._y);
                    this._context.lineTo(x1, y);
                }
                break;
            }
        }
        this._x = x, this._y = y;
    }
};

function step(context) {
    return new Step(context, 0.5);
}

function stepBefore(context) {
    return new Step(context, 0);
}

function stepAfter(context) {
    return new Step(context, 1);
}

function sign(x) {
    return x < 0 ? -1 : 1;
}

function slope3(that, x2, y2) {
    var h0 = that._x1 - that._x0,
        h1 = x2 - that._x1,
        s0 = (that._y1 - that._y0) / (h0 || h1 < 0 && -0),
        s1 = (y2 - that._y1) / (h1 || h0 < 0 && -0),
        p = (s0 * h1 + s1 * h0) / (h0 + h1);
    return (sign(s0) + sign(s1)) * mathMin(mathAbs(s0), mathAbs(s1), 0.5 * mathAbs(p)) || 0;
}

function slope2(that, t) {
    var h = that._x1 - that._x0;
    return h ? (3 * (that._y1 - that._y0) / h - t) / 2 : t;
}

function point$3(that, t0, t1) {
    var x0 = that._x0,
        y0 = that._y0,
        x1 = that._x1,
        y1 = that._y1,
        dx = (x1 - x0) / 3;
    that._context.bezierCurveTo(x0 + dx, y0 + dx * t0, x1 - dx, y1 - dx * t1, x1, y1);
}

function MonotoneX(context) {
    this._context = context;
}

MonotoneX.prototype = {
    areaStart: function() {
        this._line = 0;
    },
    areaEnd: function() {
        this._line = NaN;
    },
    lineStart: function() {
        this._x0 = this._x1 =
            this._y0 = this._y1 =
                this._t0 = NaN;
        this._point = 0;
    },
    lineEnd: function() {
        switch (this._point) {
            case 2:
                this._context.lineTo(this._x1, this._y1);
                break;
            case 3:
                point$3(this, this._t0, slope2(this, this._t0));
                break;
        }
        if (this._line || (this._line !== 0 && this._point === 1)) {
            this._context.closePath();
        }
        this._line = 1 - this._line;
    },
    point: function(x, y) {
        var t1 = NaN;
        
        x = +x, y = +y;
        if (x === this._x1 && y === this._y1) {
            return;
        } // Ignore coincident points.
        switch (this._point) {
            case 0:
                this._point = 1;
                this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                break;
            case 1:
                this._point = 2;
                break;
            case 2:
                this._point = 3;
                point$3(this, slope2(this, t1 = slope3(this, x, y)), t1);
                break;
            default:
                point$3(this, this._t0, t1 = slope3(this, x, y));
                break;
        }
        
        this._x0 = this._x1, this._x1 = x;
        this._y0 = this._y1, this._y1 = y;
        this._t0 = t1;
    }
};

function MonotoneY(context) {
    this._context = new ReflectContext(context);
}

(MonotoneY.prototype = Object.create(MonotoneX.prototype)).point = function(x, y) {
    MonotoneX.prototype.point.call(this, y, x);
};

function ReflectContext(context) {
    this._context = context;
}

ReflectContext.prototype = {
    moveTo: function(x, y) {
        this._context.moveTo(y, x);
    },
    closePath: function() {
        this._context.closePath();
    },
    lineTo: function(x, y) {
        this._context.lineTo(y, x);
    },
    bezierCurveTo: function(x1, y1, x2, y2, x, y) {
        this._context.bezierCurveTo(y1, x1, y2, x2, y, x);
    }
};

function monotoneX(context) {
    return new MonotoneX(context);
}

function monotoneY(context) {
    return new MonotoneY(context);
}

canvasInterpolation.linear = curveLinear;
canvasInterpolation.cardinal = cardinal;
canvasInterpolation.step = step;
canvasInterpolation["step-after"] = stepAfter;
canvasInterpolation["step-before"] = stepBefore;
canvasInterpolation.monotone = monotoneX;
canvasInterpolation.monotoneY = monotoneY;//$Id$
dataLabel_handler.canvas = {};
dataLabel_handler.canvas.initialize = function(chartObj) {
    
    var computed_properties = [],
        area_range_properties = [],
        stackLabel_properties = [],
        isStackedLabels = false;
    
    return function() {
        var handlers = {};
        
        handlers.add = function(c, series, subSeries, yrangePos, stackLabel) {
            if (stackLabel) {
                isStackedLabels = true;
            }
            var queue = stackLabel ? stackLabel_properties : yrangePos ? area_range_properties : computed_properties;
            queue[series] = queue[series] || [];
            queue[series][subSeries] = queue[series][subSeries] || [];
            queue[series][subSeries].push.apply(queue[series][subSeries], c);
            return queue[series];
        };
        
        handlers.update = function(id, x, y, display, DY, hookPosition) {
            var index = id.match(/\d+/g),
                seriesIndex = index[0],
                subSeriesIndex = index[1],
                itemIndex = index[2],
                yRangePos = 0;
            if (index[3]) {
                yRangePos = +index[3];
            }
            var queue = isStackedLabels ? stackLabel_properties : yRangePos ? area_range_properties : computed_properties;
            var d = queue[seriesIndex][subSeriesIndex][itemIndex];
            d.X += x;
            d.Y += y;
            d.display = d.display && !display;
            if (hookPosition) {
                d.hookPosition = hookPosition;
            }
        };
        
        handlers.getQueue = function(series, yRangePos, stackLabel) {
            var queue = stackLabel ? stackLabel_properties : (yRangePos ? area_range_properties : computed_properties);
            return queue[series];
        };
        
        handlers.draw = function() {
            var context = chartObj.labelHolderContext;
            if (!defined(context)) {
                return false;
            }
            
            var align = function(anchor) {
                switch (anchor.toLocaleLowerCase()) {
                    case "start": {
                        return "left";
                    }
                    case "middle": {
                        return "center";
                    }
                    case "end": {
                        return "right";
                    }
                        return anchor.toLocaleLowerCase();
                }
            };
            
            var drawLabel = function(series, i) {
                var properties = series.properties,
                    rotation = properties.rotation,
                    dataLabels = properties.dataLabels,
                    renderer = defined(i) ? chartObj.renderer[i] : null;
                var fontStyle = canvasUtils.getFontStyles(chartObj, properties.dataLabels, properties.color),
                    fontSize = parseFloat(fontStyle["font-size"]),
                    
                    canvasFont = fontStyle["font-size"] + " " + fontStyle["font-family"];
                series.forEach(function(subSeries, subSeriesIndex) {
                    var dataUpdate = (renderer && renderer.seriesdataAfterUpdate) ? renderer.seriesdataAfterUpdate[subSeriesIndex] : null;
                    subSeries.forEach(function(item, k) {
                        context.save();
                        var x, y, dy, height, display;
                        display = item.display;
                        if (display === true) {
                            x = item.X;
                            y = item.Y;
                            dy = parseFloat(item.DY || 0);
                            height = item.height;
                            dy = (item.tspanInfo ? fontSize : height) * dy;

                            if (defined(rotation) && rotation !== 0) {
                                if (chartObj.axes.rotated) {
                                    dy = -1 * dy
                                }
                                context.translate(x + dy, y);
                                context.rotate(canvasUtils.getRadianAngle(rotation))
                            } else {
                                context.translate(x, y + dy);
                            }

                            if (defined(item.ANCHOR)) {
                                context.textAlign = align(item.ANCHOR);
                            }

                            if (item.tspanInfo) {
                                item.tspanInfo.forEach(function(a){
                                    var userStyle = a.style,
                                        font = canvasFont,
                                        fSize,
                                        fill;

                                    if (userStyle) {
                                        font = (userStyle["font-size"] || fontStyle["font-size"]) + " " + (userStyle["font-family"] || fontStyle["font-family"])
                                        fill = userStyle.fill;
                                        fSize = parseFloat(userStyle["font-size"]);
                                    }

                                    context.translate(a.dx || 0, (fSize || fontSize) * a.dy);
                                    createText(k, a.text, font, fill, dataUpdate);
                                    context.translate(-a.dx || 0, 0);
                                });
                            } else {
                                createText(k, item.text, canvasFont, null, dataUpdate);
                            }
                            context.restore();
                        }
                    })
                })

                function createText(k, textContent, font, fill, dataUpdate) {
                    var rawColor = getRawColor(chartObj, properties.multiColoring ? k : i, dataUpdate && dataUpdate[k], i);
                    var color = getLabelFontColor(chartObj.systemConf, rawColor, dataLabels, chartObj);

                    context.font = font;
                    context.fillStyle = fill || color || fontStyle.color;
                    context.fillText(textContent || "", 0, 0);
                }
            };

            // stack labels
            var groupedByStack = chartObj.dataObject.groupedByStack;
            var keys = chartObj.userdata.seriesdata.stackGroup || groupedByStack.keys();
            keys.forEach(function(d, i) {
                if (isStackedLabels && groupedByStack.has(i)) {
                    var group = groupedByStack.get(i);
                    drawLabel(stackLabel_properties[group.stackLabelIndex], group.stackLabelIndex);
                }
            });

            // data labels
            computed_properties.forEach(function(series, i) {
                drawLabel(series, i);
                if (defined(area_range_properties[i])) {
                    drawLabel(area_range_properties[i], i);
                }
            });
            chartObj.labelHandler = null
        };
        return handlers;
    }();
};//$Id$
datalabelsBoundBox_handler.canvas = function() {
    var series;
    
    function shape(selection, index) {
        selection.each(function() {
            if (!series) {
                return;
            }
            var properties = series.properties,
                chartObj = properties.rp.chartObj,
                rgba = canvasUtils.rgba;
            var context = chartObj.labelHolderContext;
            if (!defined(context)) {
                return false;
            }
            
            if (!isBoundBoxEnabled(properties.dataLabels, chartObj)) {
                return;
            }
            
            var boundboxOptions = getMergedBoundBoxOptions(properties.dataLabels, chartObj);
            var hookOptions = getBoundBoxHookConf(boundboxOptions.hook);
            var dataUpdate = properties.dataUpdate,
                rotation = properties.rotation || 0,
                padding = getBoundBoxPadding(properties.dataLabels, chartObj),
                r = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, boundboxOptions.radius),
                strokeWidth = defined(boundboxOptions.strokeWidth) ? +boundboxOptions.strokeWidth : 1,
                strokeDashArray = getDashArray(boundboxOptions.dashStyle, strokeWidth),
                strokeLineCap = getLineCap(boundboxOptions.lineCap, boundboxOptions.dashStyle),
                heightAdjustScale = d3_scaleLinear();
            
            series.forEach(function(subSeries) {
                subSeries.forEach(function(item, k) {
                    var display = item.display;
                    if (display === true) {
                        var x = item.X,
                            y = item.Y,
                            dy = (item.actualDY !== undefined) ? item.actualDY : parseFloat(item.DY) || 0,
                            h = item.height,
                            w = item.width;
                        
                        var strokeColor = getBoundBoxColor(boundboxOptions.strokeColor, properties, chartObj, dataUpdate, index);
                        if (typeof strokeColor === "function") {
                            strokeColor = strokeColor(dataUpdate && dataUpdate[k], k);
                        }
                        
                        var fillColor = getBoundBoxColor(boundboxOptions.fillColor, properties, chartObj, dataUpdate, index);
                        if (typeof fillColor === "function") {
                            fillColor = fillColor(dataUpdate && dataUpdate[k], k);
                        }
                        
                        context.save();
                        if (defined(rotation) && rotation !== 0) {
                            var tx = 0,
                                ty = 0;
                            if (chartObj.axes.rotated) {
                                tx = -1 * dy * h;
                            } else {
                                ty = ((item.ANCHOR === "middle") ?
                                        (w / 2) :
                                        ((item.ANCHOR === "end") ? -w : 0)) + padding;
                                tx = -heightAdjustScale.domain([-0.3, 0.9]).range([h, 0])(dy) - padding;
                            }
                            
                            context.translate(x + tx, y + ty);
                            context.rotate(canvasUtils.getRadianAngle(rotation));
                        } else {
                            x = ((item.ANCHOR === "middle") ?
                                    (x - (w / 2)) :
                                    ((item.ANCHOR === "end") ? (x - w) : x)) - padding;
                            y = y - heightAdjustScale.domain([-0.3, 1]).range([h, 0])(dy) - padding;
                            
                            context.translate(x, y);
                        }
                        
                        context.fillStyle = rgba(fillColor, boundboxOptions.fillOpacity);
                        context.strokeStyle = rgba(strokeColor, boundboxOptions.strokeOpacity);
                        context.lineWidth = strokeWidth;
                        if (strokeDashArray && defined(context.setLineDash)) {
                            context.setLineDash(strokeDashArray);
                            context.lineCap = strokeLineCap;
                        }
                        
                        context.beginPath();
                        context.translate(-x, -y);
                        canvasUtils.boundBoxWithHook(context, getBoundBoxPathDescription(x, y, w, h, r, padding, item.hookPosition, hookOptions, item.adjustVal));
                        context.fill();
                        context.stroke();
                        context.closePath();
                        context.restore();
                    }
                });
            });
        });
    }
    
    shape.args = function(_) {
        if (!arguments.length) {
            return series;
        }
        series = _;
        return shape;
    };
    
    return shape;
};//$Id$
var canvas_patterns = function(){}

canvas_patterns.canvasPatternFill = function(prop, clr, returnURL){
    var pattern, image, canvas, context;
    canvas = document.createElement('canvas');
    context = canvas.getContext("2d");
    if(prop.ele){
        image = generateCanvasPatternBySVGimage(prop, clr);
    }else{
        image = generateCanvasPatternByProp(prop, clr);
    }
    pattern = context.createPattern(image, 'repeat');
    return pattern;
}
canvas_patterns.imageFill = function(options,callback){
    var image = fillSVGimageInCanvas(options.name,options,callback);
}
function fillSVGimageInCanvas(url, options,callback) {
    var img = new Image();
    img.onload = function() {
        var patternCanvas = document.createElement('canvas');
        patternCanvas.width =  50;
        patternCanvas.height = 50;
        patternCanvas.getContext('2d').drawImage(img, 0, 0,  patternCanvas.width, patternCanvas.height);
        var fillStyle = options.context.createPattern(patternCanvas, 'repeat');
        callback(options.context, fillStyle);
    };
    img.src = url;
};

function generateCanvasPatternBySVGimage(properties, color) {
    var pattern = effects.get(svg_patterns,"svgPatternFill",properties, {"returnSVGimage":true, "base64":true});
    fillSVGimageInCanvas(pattern.url, pattern);
};

function generateCanvasPatternByProp(properties, color){
    var patternID = "zp" + generateIdByPropValue(properties, "canvasFill");
    var canvas;
    if($ZC[patternID]){
        canvas = $ZC[patternID];
    }else{
        var patternCanvas = document.createElement("canvas");

        var bgClr_base = properties.bgClr || properties.bgClr_base, 
        stroke_base = properties.stroke || properties.stroke_base;
        var regExp = /\{\{([a-z]+)\}\}/;
        
        var symbolTypes = properties.type.split(","),
        noOfSymbols = symbolTypes.length,
        size = properties.size.split(","),
        strokeWidth = properties.strokeWidth.split(","),
        fillColor = bgClr_base.split(","),
        stroke = stroke_base.split(","),
        fillOpacity = (properties.fillOpacity || "").split(","),
        strokeOpacity = (properties.strokeOpacity || "").split(",");
        translate = properties.translate ? properties.translate.split(",") : null;
        size = properties.width ? getPatternSize(properties,size) : size;

        patternCanvas.width = size[0];
        patternCanvas.height = size[0];

        var patternCanvas_context = patternCanvas.getContext("2d");
        

        for (var j=0; j<noOfSymbols; j++){
            var stroke_cur = isNull(stroke[j] || stroke[0]) ?  properties.stroke_base : (stroke[j] || stroke[0]),
            fill_cur = isNull(fillColor[j] || fillColor[0]) ?  properties.bgClr_base : (fillColor[j] || fillColor[0]);
            stroke_cur = (regExp.test(stroke_cur)) ? getColorCopy(properties.stroke_base, 1, stroke_cur.replace(regExp, '$1') ,d3_hsl) : stroke_cur;
            fill_cur = (regExp.test(fill_cur)) ? getColorCopy(properties.bgClr_base, 1, fill_cur.replace(regExp, '$1') ,d3_hsl) : fill_cur;
            trans_cur = (size[j] || size[0]) / 2;
            if(translate){
                var subTranslate = translate[j] || translate[0];
                trans_cur += parseFloat(subTranslate);
            }

            patternCanvas_context.save();
            patternCanvas_context.translate(trans_cur, trans_cur);
            patternCanvas_context.beginPath();
            patternCanvas_context.lineWidth = strokeWidth[j] || strokeWidth[0];
            patternCanvas_context.fillStyle = canvasUtils.rgba(fill_cur, fillOpacity[j] || fillOpacity[0]);
            patternCanvas_context.strokeStyle = stroke_cur;
            
            if (symbolTypes[j] === "circle") {
                patternCanvas_context.arc(0,0, size[j]/2, 0, mathPI * 2,false);
            }else{
              var patternPath = getSVGsymbol(symbolTypes[j])(size[j] || size[0]);
              canvasUtils.drawPath(patternCanvas_context, patternPath);  
            } 
            
            patternCanvas_context.fill();
            patternCanvas_context.stroke();
            patternCanvas_context.closePath();
            patternCanvas_context.restore();
        }
        canvas = $ZC[patternID] = patternCanvas;
    }
    return canvas;
}

//$Id$
var canvas_gradients = (function() {
    var types = {};
    
    var create = function(context, patternName, properties, offset) {
        if (/threshold/ig.test(patternName)) {
            return types[patternName](context, properties, offset);
        } else {
            var safari = $Browser.SAFARI;
            $Browser.SAFARI = 0;
            var stop = gradients.getStops({}, properties, properties.color, patternName);
            var gradient = types[patternName](context, properties, stop);
            $Browser.SAFARI = safari;
            return gradient;
        }
    };
    var canvasGradientFill =  types.canvasGradientFill = function(properties, gradientID, offset, returnSVGimage, base64, chartObj){
        return (properties && properties.type) ? canvas_gradients[properties.type](properties, gradientID, offset, returnSVGimage, base64, chartObj) : null;
    }
    
    var linear = types.linear = function(properties, gradientID, offset, returnSVGimage, base64, chartObj) {
        var context = chartObj.context,
            dimension = properties.dimension,
            spread = properties.spreadMethod,
            stops = getStops({}, properties, properties.color, "linear");
        var dim = (spread === "repeat" || spread === "reflect") && ($Browser.IS_IOS || $Browser.SAFARI) ?
            mathMax(mathAbs(+properties.x2 - +properties.x1, mathAbs(+properties.y2) - +properties.y1)) :
            100;
        
        var xScale = d3_scaleLinear().domain([0, 100]).range([0, dimension[0]]),
            yScale = d3_scaleLinear().domain([0, 100]).range([0, dimension[1]]),
            x0 = xScale(+(properties.x1 || 0) * 100 / dim),
            x1 = xScale(+(properties.x2 || 0) * 100 / dim),
            y0 = yScale(+(properties.y1 || 0) * 100 / dim),
            y1 = yScale(+(properties.y2 || 0) * 100 / dim);
        
        var gradient = context.createLinearGradient(x0, y0, x1, y1);
        addStop(gradient, stops, properties.opacity);
        return gradient;
    };
    
    var radial = types.radial = function(properties, gradientID, offset, returnSVGimage, base64, chartObj) {
        var context = chartObj.context,
            dimension = properties.dimension,
            spread = properties.spreadMethod,
            stops = getStops({}, properties, properties.color, "radial");
            x = (dimension[0] / 100 * properties.x || 0),
            y = (dimension[0] / 100 * properties.y || 0),
            radius = ((spread === "repeat" || spread === "reflect") && ($Browser.IS_IOS || $Browser.SAFARI)) ? dimension[0] : (dimension[0] / 100 * properties.radius);
        
        var gradient = context.createRadialGradient(x, y, 0, x, y, radius);
        addStop(gradient, stops, properties.opacity);
        return gradient;
    };
    
    var thresholdLinear = types.thresholdLinear = function(properties, gradientID, offset, returnSVGimage, base64, chartObj) {
        var context = chartObj.context;
        var stop = {
            "opacity": [],
            "offset": [],
            "color": []
        };
        offset.forEach(function(d) {
            stop.opacity.push(1);
            stop.offset.push(d.offset);
            stop.color.push(d.color);
        });
        
        var gradient = context.createLinearGradient(properties.x1, properties.y1, properties.x2, properties.y2);
        addStop(gradient, stop, properties.opacity);
        return gradient;
    };
    
    var addStop = function(gradient, stop, stopOpacity) {
        var n = stop.offset.length,
            i = -1;
        stopOpacity = stopOpacity || 1;
        while (++i < n) {
            var opacity = mathAbs(1 - (stop.opacity[i] + stopOpacity)),
                color = canvasUtils.rgba(stop.color[i], opacity);
            gradient.addColorStop(parseFloat(stop.offset[i]) / 100, color);
        }
    };
    
    var global = {};
    global.create = create;
    global.linear = linear;
    global.radial = radial;
    global.thresholdLinear = thresholdLinear;
    global.canvasGradientFill = canvasGradientFill;
    return $ZC.canvasGradient ? $ZC.canvasGradient : global;
})();//$Id$

function getBulletLevelMarkerGradient(d, levelMarker, chartObj, baseClr, levelMarkerColor) {
    var level = d[levelMarker.dataindex] || [];
    if (level != null && !(level instanceof Array)) { //If level marker is a single value and in non-array format, make it as array
        return null;
    }

    if (!level.length) {
        return null;
    }

    if (!levelMarkerColor) { //If colors are not specified, create monochrome colors
        levelMarker.color = [];
        var colorGamma = levelMarker.colorGamma || [0.3, 0.9];
        var domain = [0, level.length - 1],
            range = [+colorGamma[0], +colorGamma[1]];
        var monoClrGen = getMonochromeColor(baseClr, domain, range);
        levelMarker.color = level.map(function(d, i) {
            return monoClrGen(i);
        });
    } else if (levelMarkerColor.constructor != Array) {
        levelMarker.color = [levelMarkerColor];
    }

    var neg = level.filter(function(d) {
        return d < 0;
    });

    var thValues;
    if (neg.length > 0) { // If negative values are present, add 0
        thValues = level.slice();
        var zeroIndex = thValues.indexOf(0);
        if (zeroIndex > -1) {
            thValues.splice(zeroIndex, 1);
        }

        var negthClr = levelMarker.color;
        thValues = thValues.sort(d3_descending);
        var color = [];

        for (var i = 0; i < thValues.length; i++) {
            var index = level.indexOf(thValues[i])
            color.push(negthClr[index]);
        }
        levelMarker.color = color;
        thValues.splice((thValues.length - neg.length), 0, 0);
        level = thValues;
    }
    levelMarker.values = level;
    var thOverlay = $ZC.axis.threshold.overlay(chartObj, "continous")("transparent", levelMarker, 0, "y");
    if (neg.length > 0) {
        level = thValues;
    }

    return thOverlay;
}//$Id$
/**
 * @returns {chart} bar renderer.
 */
svg_plot_renderer.bar = function() {
    var commonRendererProp, bandwidth1, bandwidth2, yscale, barDatasetIndex,
        isredraw = false, shiftInfo, transitionDuration, bulletEvent;
    
    function chart(selection) {
        selection.each(function(data) {
            var container = d3_select(this);
            chart.update = function() {
                container.transition().call(chart);
            };
            // chart.getGanttLevelMarkerProp = getGanttLevelMarkerProp();
            //renderer config values
            var rp = commonRendererProp.params,
                chartObj = rp.chartObj,
                xscale = rp.xscale,
                stacked = rp.stacked,
                index = rp.datasetIndex,
                axisrotated = rp.axisrotated,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                labelQueue = rp.labelQueue,
                hasNegValue = rp.hasNegValue,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset,
                systemconf = chartObj.systemConf,
                plotarea = chartObj.plotarea,
                dataObject = chartObj.dataObject,
                threshold = rp.threshold,
                colorOverlay = rp.colorOverlay;
            yscale = rp.yscale;
            var yaxisReversed = systemconf.chart.axes.yaxis[rp.yaxiscolumnorder || 0].reversed;
            var xAxisReverseed = chartObj.systemConf.chart.axes.xaxis.reversed;

            var defsLocation = chartObj.defsLocation;
            
            var currentdata = data[index];
            var plotoptions = currentdata.plotoptions;
            var currentseriesdata = currentdata.data;
            var charttype = chartObj.chartTypes[index].name;
            var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions),
                gradientDim = [(axisrotated ? yscale.range()[0] : xscale.range()[1]), (axisrotated ? xscale.range()[1] : yscale.range()[0])],
                patternPallete = (chartObj.patternPallete && chartObj.patternPallete.length),
                noofbarDatas = chartObj.dataObject.noofBarEnabledSeries,
                isBullet = (charttype == "bullet"),
                isGantt = (charttype == "gantt"),
                tooltipEnabled = pick(chartObj.systemConf.tooltip.enabled, true),
                disabledBulletEvents = getPropVal(commonPlotOptions, "events.enabled") === false,
                LevelMarkerEventsEnabled = pick(getPropVal(commonPlotOptions, "levelMarker.events.enabled"), true),
                targetMarkerEventsEnabled = pick(getPropVal(commonPlotOptions, "targetMarker.events.enabled"), true);
            
            
            // for bullet events
            if (isBullet && !defined(chartObj.events.bullet)) {
                bulletEvent = chartObj.events.bullet = {};
                bulletEvent.levelmarker = [];
                bulletEvent.marker = [];
                bulletEvent.point = [];
            }
            bulletEvent = chartObj.events.bullet;
            
            var datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

                xCategories = xscale.domain(),
                yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

                categories = defined(dataObject.hierarchical) ? dataObject.getCategories("x") : xCategories;
            
            var series = appendEle(container, "g", [currentdata], ".", "class", ('barseries_' + index));
            var x = 0;
            
            if (!bandwidth1 || !bandwidth2) { //Test_515.json (Combinational chart(bar + line) where all the bar series are disabled)
                isredraw = true;
                chart.chartRendered = true;
                return;
            }
            
            var levelMarker = (plotoptions && plotoptions.levelMarker) ? mergeJSON(commonPlotOptions.levelMarker, plotoptions.levelMarker, true) : commonPlotOptions.levelMarker,
                borderOptions = (plotoptions && plotoptions.border) ? mergeJSON(commonPlotOptions.border, plotoptions.border, true) : commonPlotOptions.border;
            var multiColoring = gvp("multiColoring") === true && !chartObj.legendarea.show;
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, "bar");
            var isAnimationEnable = animationOptions.enabled,
                easingType = animationOptions.easingType,
                animationType = animationOptions.type,
                exitDuration = isAnimationEnable ? 100 : 0,
                duration;
            transitionDuration = isredraw ? (isAnimationEnable ? 300 : 0) : animationOptions.duration;
            
            /**
             *
             * @type {{stacked, categories, axisrotated, bandwidth1, bandwidth2, barDatasetIndex, padding, yscale, hasNegValue, yaxiscolumnorder, addRangeBand, barWidth, levelMarkerWidth, levelMarkerPadding}|*}
             */
            var commonOption = getBarCommonOption(chartObj.rendererConf[index], index);
            var barWidth = commonOption.barWidth,
                levelMarkerWidth = commonOption.levelMarkerWidth,
                barPadding = commonOption.padding,
                levelMarkerPadding = commonOption.levelMarkerPadding;

            var stackGroup = chartObj.userdata.seriesdata.stackGroup;
            var actualStackGroupIndex = (stackGroup) ? getStackGroupIndex(index, stackGroup) : 0;
            
            chart.getParamValue = function() {
                return chartObj.dataObject.getTransRectValue.apply(chartObj.dataObject, toArray(arguments));
            };
            var addRangeBand = commonOption.addRangeBand;
            
            var targetMarker, targetMarkerSeries,
                levelMarkerColor = levelMarker.color; //Saving the levelMarker colors, helps in multi categories bullet if each categories dont have same no of levels
            levelMarker.overlayRange = "below";
            
            if (isBullet || isGantt) {
                var markerPropertyName = isGantt ? "marker" : "targetMarker";
                targetMarker = (plotoptions && plotoptions[markerPropertyName]) ? mergeJSON(commonPlotOptions[markerPropertyName], plotoptions[markerPropertyName], true) : commonPlotOptions[markerPropertyName];
                targetMarkerSeries = appendEle(chartObj.staticPaneSVG.selectAll("g.threshold"), "g", (targetMarker.enabled === true && !currentdata.disabled ? [index] : []), ".", "class", (isGantt ? "markerSeries" + index : "markerSeries"));
            }
            
            var startRadius = {
                    tlx: 0,
                    tly: 0,
                    trx: 0,
                    trY: 0,
                    brx: 0,
                    bry: 0,
                    blx: 0,
                    bly: 0
                },
                borderRadius = startRadius,
                borderSize = 0,
                borderColor = null,
                borderStyle = null,
                levelMarkerRadius = startRadius;
            if (defined(borderOptions) && isTrue(borderOptions.show)) {
                borderSize = borderOptions.size;
                borderColor = borderOptions.color;
                borderStyle = borderOptions.style;
                borderRadius = chart.getParamValue("radius", null, null, null, commonOption, borderOptions.radius);
            }
            
            var dashStyle = getDashArray(borderStyle, (borderSize == null ? 2 : borderSize));
            var fillColor = chart.fillColorFunc = getFillColor(chartObj, index, gradientDim),
                strokeColor = getStrokeColor(chartObj, index);
            
            //Save seriesdata reference without null points , that can also be used in zcevents
            chart.seriesdataAfterUpdate = []
            currentseriesdata.forEach(function(d, i) {
                chart.getGanttLevelMarkerProp = getGanttLevelMarkerProp;
                var valuey;
                var startx, starty, startwid, starthei, endx, endy, endwid, endhei;
                var ishideable = currentdata.disabled;

                var serData = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(d), xCategories, yCategories, yaxiscolumnorder);

                if (xAxisReverseed) {
                    serData = serData.slice(0).reverse();
                }

                chart.seriesdataAfterUpdate[i] = serData;

                var ShiftedData; // = d3_values(d);
                if (shiftInfo != null) {
                    ShiftedData = d3_values(d);
                    var co = shiftInfo.count;
                    for (var ii = 0; ii <= co; ii++) {
                        ShiftedData.splice(ii, 0, [null, null])
                    }
                    
                    if (isredraw) {
                        var clipX = xscale(dataset.getX(d[0]));
                        var properties = {
                            name: "rect",
                            id: chartObj.id,
                            x: clipX,
                            y: 0,
                            width: chartObj.plotarea.width,
                            height: chartObj.plotarea.height
                        },
                        args = {
                            chartObj: chartObj
                        };
                        var clipID = effects.get(svg_clips, "rect", properties, args);
                        series.attr('clip-path', "url(" + defsLocation + "#" + clipID + ")");
                    }
                }
                var dataUpdate = (shiftInfo != null) ? ShiftedData : chart.seriesdataAfterUpdate[i];
                duration = ((animationType == "verticalAll") || isredraw) ? transitionDuration : (transitionDuration / (dataUpdate.length * noofbarDatas));
                
                var showLevelMarker = levelMarker.enabled === true &&
                    (isBullet || (stacked && noofbarDatas > 0) || !ishideable) && !chartObj.dataObject.isStackedPercentChart &&
                    ((stackGroup) ? chartObj.dataObject.groupedByStack.has(actualStackGroupIndex) : true); // If specified stackgroup is disabled, remove it
                var subseries_levelMarker = (stacked ? container : series)
                    .selectAll(stacked ? 'g.levelMarkerSeries_' + actualStackGroupIndex : 'g.subseries_levelMarker_' + i)
                    .data(function(d) {
                        return showLevelMarker ? [d] : [];
                    });
                var subseries = series.selectAll('g.subseries_' + i).data(function(d) {
                    return ishideable ? [] : [d];
                });
                
                //Removing unnecessary 'g' on redraw ((stacked bar to bar) or (bar to stacked bar))
                (!stacked ? container : series)
                    .selectAll(!stacked ? 'g.levelMarkerSeries_' + actualStackGroupIndex : 'g.subseries_levelMarker_' + i)
                    .remove();
                
                subseries_levelMarker.exit()
                    .selectAll('path.levelMarker')
                    .transition()
                    .duration(exitDuration)
                    .attr("d", function(d, j) {
                        if (isGantt) {
                            var path = d3_select(this).attr("d"); // If the category is no more available at the categoryStore, We get the x,y from the 'd' attr by parsing
                            var points = parseSVGPath(path);
                            var x = points[0].moves[0],
                                y = points[3].moves[1];
                            
                            var prop = getGanttLevelMarkerProp(d, i, j, commonOption);
                            var exitx = prop.x || x,
                                exity = (prop.y + (axisrotated ? 0 : prop.height * (yaxisReversed ? -1 : 1))) || y,
                                exitwid = axisrotated ? 0 : prop.width,
                                exithei = axisrotated ? prop.height : 0;
                            return roundedRect(exitx, exity, exitwid, exithei, borderRadius, yaxisReversed, axisrotated);
                        }
                        var exitx = chart.getParamValue("x", d, i, j, commonOption) || parseSVGPath(d3_select(this).attr("d"))[0].moves[0],
                            exity = yscale(yscale.domain()[0]),
                            exitwid = axisrotated ? 0 : chart.getParamValue("width", d, i, j, commonOption),
                            exithei = axisrotated ? chart.getParamValue("height", d, i, j, commonOption) : 0;
                        return roundedRect(exitx, exity, exitwid, exithei, borderRadius, yaxisReversed, axisrotated);
                    })
                    .remove();
                
                subseries.exit()
                    .selectAll("path.zcbar")
                    .transition()
                    .duration(exitDuration)
                    .attr("d", function(d, j) {
                        var path = d3_select(this).attr("d"); // If the category is no more available at the categoryStore, We get the x,y from the 'd' attr by parsing
                        var points = parseSVGPath(path);
                        var x = points[0].moves[0],
                            y = points[3].moves[1],
                            exitx = chart.getParamValue("x", d, i, j, commonOption) || x,
                            exity = (axisrotated ? chart.getParamValue("y", d, i, j, commonOption) : isGantt ? chart.getParamValue("y", d, i, j, commonOption, null, 0) :
                                        (stacked ? yscale(d.y0) : ((hasNegValue != null) ? yscale(hasNegValue) : (yscale(0) != null ? mathMin(yscale(0), yscale.range()[0]) : yscale.range()[0]))) + (addRangeBand() * 2)) || y,
                            exitwid = axisrotated ? 0 : chart.getParamValue("width", d, i, j, commonOption),
                            exithei = axisrotated ? chart.getParamValue("height", d, i, j, commonOption) : 0;
                        return roundedRect(exitx, exity, exitwid, exithei, borderRadius, yaxisReversed, axisrotated);
                    })
                    .remove();
                
                
                subseries.enter().append('g').attr('class', 'subseries_' + i);
                
                var subseries_levelMarkerZindex = (isGantt) ? subseries_levelMarker.enter().append("g") : subseries_levelMarker.enter().insert('g', ':first-child');
                
                subseries_levelMarkerZindex.attr('class', stacked ? 'levelMarkerSeries_' + actualStackGroupIndex : 'subseries_levelMarker_' + i);
                
                var rect_levelMarker = subseries_levelMarker.selectAll("path.levelMarker").data(dataUpdate, function(d) {
                    return (isGantt) ? d : dataset.getX(d);
                });
                
                rect_levelMarker.enter().append("path").attr("class", "levelMarker");
                rect_levelMarker
                    .style({
                        "fill": function(d, j) {
                            if (isBullet) {
                                if (!currentdata.disabled) {
                                    if (LevelMarkerEventsEnabled && tooltipEnabled) {
                                        // get the points and save in bulletEvent.points
                                        var rectangles = getBulletLevelMarkerRect(d, levelMarker, "y");
                                        var baseIndex = j * rectangles.length;
                                        bulletEvent.levelmarker = bulletEvent.levelmarker.concat(rectangles);
                                    }
                                    
                                    
                                    if (!disabledBulletEvents && tooltipEnabled) {
                                        // save the data point here to avoid loops
                                        var point = getPos(d);
                                        point.data = d;
                                        point.seriesPos = index;
                                        point.subseriesindex = i;
                                        point.itemPos = j;
                                        point.type = "point";
                                        point.yaxiscolumnorder = yaxiscolumnorder;
                                        bulletEvent.point = bulletEvent.point.concat(point);
                                    }
                                }
                                
                            }
                            if (isGantt) {
                                return levelMarker.color ||
                                    (multiColoring ? chartObj.seriesColor[j % chartObj.seriesColor.length] : color);
                            }

                            var baseClr = (multiColoring ? chartObj.seriesColor[j % chartObj.seriesColor.length] : color);
                            var clr = (isArray(levelMarker.color) ? levelMarker.color[0] : levelMarker.color) ; 
                            if(patternPallete){
                                var prop = (isGantt) ? getGanttLevelMarkerProp(d, i, j, commonOption) : getBulletLevelMarkerProp(d, commonOption);
                                var x = prop.x,
                                    y = prop.y,
                                    wid = prop.width,
                                    hei = prop.height;
                               clr =  fillColor((multiColoring ? j : index), null,null,clr,null,null,{"x":x, "y": y, "width":wid, "height":hei}); 
                            }

                            return getBulletLevelMarkerGradient(d, levelMarker, chartObj, baseClr, levelMarkerColor) || clr || baseClr;
                        },
                        "fill-opacity": levelMarker.fillOpacity
                    })
                    .attr("d", function(d, j) {
                        var prop = (isGantt) ? getGanttLevelMarkerProp(d, i, j, commonOption) : getBulletLevelMarkerProp(d, commonOption);
                        var x = prop.x,
                            y = prop.y,
                            wid = prop.width,
                            hei = prop.height;
                        if (isGantt) {
                            return roundedRect(x, y, wid, hei, levelMarkerRadius, yaxisReversed, axisrotated);
                        } else {
                            return (axisrotated) ? roundedRect(y, x, wid, hei, borderRadius, yaxisReversed, axisrotated) : roundedRect(x, y, wid, hei, borderRadius, yaxisReversed, axisrotated)
                        }
                    });
                
                levelMarker.color = levelMarkerColor; //Saving back the levelMarker colors, helps in multi categories bullet if each categories dont have same no of levels
                rect_levelMarker.exit().remove();
                
                if (isBullet) {
                    addMarker(targetMarker, "");
                    addTargetLabel.call(chartObj, targetMarker, chart, dataUpdate);
                } else if (isGantt) {
                    addMarker(targetMarker.start, 0);
                    addMarker(targetMarker.end, 1);
                }
                
                var rect = subseries
                    .selectAll("path.zcbar")
                    .attr("class", "zcbar")
                    .data(dataUpdate, function(d) {
                        return (isGantt) ? d : dataset.getX(d); // For gantt chart we should support different timeline data for the same category
                    });
                
                
                var rectEnter = rect.enter().append("path")
                    .style('fill-opacity', gvp("fillOpacity"))
                    .attr({
                        "class": "zcbar",
                        "y": function(d, j) {
                            //for stacked animation should starts from baseline i.e data[0].data[0][0].y0
                            return (yscale.rangeExtent) ?
                                yscale.rangeExtent()[axisrotated ? 0 : 1] :
                                (axisrotated ? ((stacked) ? (hasNegValue != null) ? yscale(hasNegValue) : yscale.range()[0] : ((hasNegValue != null) ? yscale(hasNegValue) : yscale.range()[0])) :
                                    ((stacked) ? ((hasNegValue != null) ? yscale(hasNegValue) : yscale.range()[0]) : ((hasNegValue != null) ? yscale(hasNegValue) : (yscale(0) != null ? mathMin(yscale(0), yscale.range()[0]) : yscale.range()[0]))));
                        },
                        "height": 0,
                        "d": function(d, j) {
                            var v = dataset.getX(d);
                            startx = (stacked) ? bandwidth1(v) : bandwidth1(v) + bandwidth2(barDatasetIndex + i)
                            starty = (yscale.rangeExtent) ?
                                yscale.rangeExtent()[axisrotated ? 0 : 1] :
                                (axisrotated ? ((stacked) ? (hasNegValue != null) ? yscale(hasNegValue) : yscale.range()[0] : ((hasNegValue != null) ? yscale(hasNegValue) : yscale.range()[0])) :
                                    ((stacked) ? ((hasNegValue != null) ? yscale(hasNegValue) : yscale.range()[0]) : ((hasNegValue != null) ? yscale(hasNegValue) : (yscale(0) != null ? mathMin(yscale(0), yscale.range()[0]) : yscale.range()[0]))));
                            startwid = (axisrotated) ? 0 : barWidth
                            starthei = (axisrotated) ? barWidth : 0
                            return (axisrotated) ? roundedRect(starty, startx, startwid, starthei, startRadius, yaxisReversed, axisrotated) : roundedRect(startx, starty, startwid, starthei, startRadius, yaxisReversed, axisrotated)
                        }
                    });
                
                var rectUpdate = rect
                    .attr({
                        "stroke": function(d, j) {
                            return strokeColor((multiColoring ? j : index), d, borderColor);
                        },
                        "stroke-width": borderSize,
                        "stroke-dasharray": dashStyle
                    })
                    .style({
                        "fill-opacity": gvp("fillOpacity"),
                        "fill": function(d, j) {
                            if(patternPallete){
                               return fillColor((multiColoring ? j : index), d,null,null,null,null,{"x":chart.getParamValue("x", d, i, j, commonOption), "y": chart.getParamValue("y", d, i, j, commonOption),
                                                                                                        "width": chart.getParamValue("width", d, i, j, commonOption), "height": chart.getParamValue("height", d, i, j, commonOption)}); 
                            }
                            return fillColor((multiColoring ? j : index), d);
                        }
                    });
                if (shiftInfo == null) {
                    rect
                        .transition()
                        .duration((isredraw) ? duration : 0)
                        .delay(function(d, j) {
                            return (animationType == "verticalAll" || isredraw) ? 0 : (((j * noofbarDatas) + index) * duration);
                        })
                        
                        .attr("d", function(d, j) {
                            var curele = d3_select(this);
                            var starthei = parseFloat(curele.attr("height"));
                            endx = axisrotated && !isGantt ? parseFloat(curele.attr("y")) : chart.getParamValue("x", d, i, j, commonOption)
                            endy = axisrotated ? chart.getParamValue("y", d, i, j, commonOption) : (isGantt && !starthei) ? chart.getParamValue("y", d, i, j, commonOption, null, 0) : parseFloat(curele.attr("y")) // Why (isGantt && !starthei)? -> rectEnter animation should start from y0
                            endwid = axisrotated ? parseFloat(curele.attr("height")) : chart.getParamValue("width", d, i, j, commonOption)
                            endhei = axisrotated ? chart.getParamValue("height", d, i, j, commonOption) : starthei
                            return roundedRect(endx, endy, endwid, endhei, borderRadius, yaxisReversed, axisrotated);
                        })
                        
                        .each("end", function(d, k) {
                            d3_select(this).transition()
                                .delay(function(d, j) {
                                    return (animationType == "verticalAll" || isredraw) ? 0 : (((k * noofbarDatas) + index) * duration);
                                })
                                .duration(duration)
                                .ease(easingType)
                                .attr("d", function(d) {
                                    endx = chart.getParamValue("x", d, i, k, commonOption)
                                    endy = chart.getParamValue("y", d, i, k, commonOption)
                                    endwid = chart.getParamValue("width", d, i, k, commonOption)
                                    endhei = chart.getParamValue("height", d, i, k, commonOption)
                                    return roundedRect(endx, endy, endwid, endhei, borderRadius, yaxisReversed, axisrotated);
                                })
                        })
                        .attr({
                            "y": function(d, j) {
                                var param = (axisrotated) ? "x" : "y"
                                return chart.getParamValue(param, d, i, j, commonOption);
                            },
                            "height": function(d, j) {
                                var param = (axisrotated) ? "width" : "height"
                                return chart.getParamValue(param, d, i, j, commonOption);
                            }
                        });
                    
                } else {
                    rect
                        .transition()
                        .duration((isredraw) ? duration : 0)
                        .attr({
                            "d": function(d, j) {
                                endx = chart.getParamValue("x", d, i, j, commonOption);
                                endy = chart.getParamValue("y", d, i, j, commonOption);
                                endwid = chart.getParamValue("width", d, i, j, commonOption);
                                endhei = chart.getParamValue("height", d, i, j, commonOption);
                                return roundedRect(endx, endy, endwid, endhei, borderRadius, yaxisReversed, axisrotated)
                            },
                            "y": function(d, j) {
                                var param = (axisrotated) ? "x" : "y";
                                return chart.getParamValue(param, d, i, j, commonOption);
                            },
                            "height": function(d, j) {
                                var param = (axisrotated) ? "width" : "height";
                                return chart.getParamValue(param, d, i, j, commonOption);
                            }
                        });
                }
                
                rect.exit()
                    .transition()
                    .duration(duration)
                    .remove();
                
                if (i > 0 && stacked) {
                    var subdividerseries = appendEle(series, "g", (ishideable ? [] : [1]), ".", "class", ('subdividerseries_' + i));
                    var dividerbar = subdividerseries
                        .selectAll("rect")
                        .data(dataUpdate, function(d) {
                            return dataset.getX(d)
                        });
                    dividerbar
                        .enter().append("rect")
                        .style({
                            "fill": "white",
                            "opacity": 0.7,
                            "shape-rendering": "crispedges"
                        })
                        .attr({
                            "width": getDividerParam("width"),
                            "height": getDividerParam("height"),
                            "x": function(d, j) {
                                return getDividerParam("x", d, i, j, commonOption);
                            },
                            "y": function(d, j) {
                                return getDividerParam("y", d, i, j, commonOption)
                            }
                        });
                    dividerbar
                        .transition()
                        .duration(duration)
                        .ease(easingType)
                        .style({
                            "fill": "white",
                            "opacity": 0.7,
                            "shape-rendering": "crispedges"
                        })
                        .attr({
                            "width": getDividerParam("width"),
                            "height": getDividerParam("height"),
                            "x": function(d, j) {
                                return getDividerParam("x", d, i, j, commonOption);
                            },
                            "y": function(d, j) {
                                return getDividerParam("y", d, i, j, commonOption)
                            }
                        });
                    dividerbar.exit().remove();
                }
                if (isGantt) {
                    
                    var dependencyConfig = commonPlotOptions.dependency,
                        showDependency = dependencyConfig.enabled === true;
                    
                    var dependencies = null;
                    var dependenceSeries = series
                        .selectAll('g.dependencySeries')
                        .data(showDependency ? [d] : []);
                    
                    var seriesDpn = dependenceSeries.enter().insert('g', ':first-child');
                    dependenceSeries.attr('class', 'dependencySeries');
                    dependenceSeries.exit().remove()
                    if (showDependency && defined(dependencyConfig.sourceIndex) && defined(dependencyConfig.targetIndex)) {
                        dependencies = getDependencies(dataUpdate, +dependencyConfig.sourceIndex, +dependencyConfig.targetIndex);
                    }
                    if (dependencies) {
                        var symbolConf = dependencyConfig.marker,
                            linkConf = dependencyConfig.link,
                            linkPadding = defined(linkConf.padding) ? linkConf.padding : 1,
                            symbolPadding = defined(symbolConf.padding) ? symbolConf.padding : linkPadding
                        symbolPadding = mathMin(linkPadding, symbolPadding)
                        // dependency links
                        
                        var linkGroup = appendEle(dependenceSeries, "g", [1], '.', "class", "links");
                        var arrowGroup = appendEle(dependenceSeries, "g", [1], '.', "class", "symbol");
                        
                        // links
                        var path = appendEle(linkGroup, "path", dependencies, ".", "class", "link");
                        path
                            .attr("d", function(d, j) {
                                var details = getDependencyDetails(d);
                                return getDependencyPathString(details.type, details.end, details.start)(new Array(6));
                            })
                            .attr("stroke", function(d) {
                                var startTime = dataset.getY(d.source, yaxiscolumnorder)[0];
                                var endTime = dataset.getY(d.target, yaxiscolumnorder)[1];
                                var error = startTime < endTime;
                                return error ? linkConf.errorStyle : linkConf.strokeColor
                            })
                            .attr("stroke-width", linkConf.strokeWidth)
                            .attr("fill", "none");
                        
                        // symble
                        
                        var markerEnabled = dependencyConfig.marker.enabled === true;
                        var arrows = appendEle(arrowGroup, "g", markerEnabled ? dependencies : [], ".", "class", "arrow");
                        
                        if (dependencyConfig.marker.enabled) {
                            arrows.each(function(d, j) {
                                var symbolType = symbolConf.symbol,
                                    temp;
                                var markerID, mSize = {
                                    "inner": 0.4,
                                    "outer": 0.7
                                };
                                var self = d3_select(this);
                                self.attr("transform", function(d) {
                                    var details = getDependencyDetails(d),
                                        x, y;
                                    var type = details.type
                                    if (type == "SS" || type == "ES") {
                                        x = axisrotated ? details.start.x - symbolPadding : details.start.x + details.start.width / 2;
                                        y = axisrotated ? details.start.y + details.start.height / 2 : details.start.y + details.start.height + symbolPadding
                                        temp = axisrotated ? "triangle-right" : "triangle-up"
                                    } else if (type == "EE" || type == "SE") {
                                        x = axisrotated ? details.start.x + details.start.width + symbolPadding : details.start.x + details.start.width / 2;
                                        y = axisrotated ? details.start.y + details.start.height / 2 : details.start.y - symbolPadding
                                        temp = axisrotated ? "triangle-left" : "triangle-down"
                                    }
                                    return "translate(" + x + "," + (y) + ")";
                                })
                                addSVGmarker(self, null, symbolConf, {
                                    "symbolSize": mSize,
                                    "color": null,
                                    "symbol": temp
                                });
                            })
                        }
                    }
                }
                
                function getDependencyDetails(d) {
                    return {
                        "start": getPos(d.source),
                        "end": getPos(d.target),
                        "type": dependencyConfig.link.type.toUpperCase() || "ES"
                    }
                }
                
                function getDependencyPathString(type, startPosition, endPosition) {
                    var padding = linkPadding,
                        markerPadding = symbolPadding;
                    type = type.toUpperCase();
                    
                    var x = null,
                        y = null,
                        pos = null,
                        crucialCurve = isCrucialCurve(type, startPosition, endPosition);
                    
                    return d3_line()
                        .x(function(d, j) {
                            switch (j) {
                                case 0:
                                case 1:
                                case 2: {
                                    pos = startPosition;
                                    if (j == 0) {
                                        if (type == "SS" || type == "SE") {
                                            x = axisrotated ? pos.x : pos.x + pos.width / 2
                                        } else if (type == "EE" || type == "ES") {
                                            x = axisrotated ? pos.x + pos.width : pos.x + pos.width / 2
                                        }
                                    } else if (j == 1) {
                                        if (type == "SS" || type == "SE") {
                                            x = axisrotated ? pos.x - padding : x
                                        } else if (type == "EE" || type == "ES") {
                                            x = axisrotated ? pos.x + pos.width + padding : x
                                        }
                                        
                                    } else {
                                        var dist;
                                        if (type == "SS") {
                                            dist = startPosition.x - endPosition.x;
                                            dist = dist < 0 ? 0 : dist
                                            x = axisrotated ? pos.x - dist - padding : x
                                            
                                        } else if (type == "EE") {
                                            dist = (startPosition.x + startPosition.width) - (endPosition.x + endPosition.width);
                                            dist = dist > 0 ? 0 : dist
                                            x = axisrotated ? pos.x + pos.width + padding - dist : x;
                                        } else if (type == "SE") {
                                            if (axisrotated) {
                                                x = pos.x - padding;
                                                y = crucialCurve ? pos.y + pos.height : endPosition.y;
                                            } else {
                                                x = xAxisReverseed ? x - pos.width : x + pos.width;
                                            }
                                        } else if (type == "ES") {
                                            if (axisrotated) {
                                                x = pos.x + padding + pos.width;
                                                y = crucialCurve ? pos.y + pos.height : endPosition.y;
                                            } else {
                                                x = xAxisReverseed ? x - pos.width : x + pos.width;
                                            }
                                        }
                                    }
                                    break;
                                }
                                default: {
                                    if (axisrotated) {
                                        y = null
                                    }
                                    pos = endPosition
                                    if (j == 3) {
                                        if (axisrotated && crucialCurve) {
                                            y = startPosition.y + startPosition.height;
                                        }
                                        if (type == "SS" || type == "EE") {
                                            x = axisrotated ? x : pos.x + pos.width / 2;
                                        } else if (type == "SE") {
                                            x = axisrotated ? pos.x + pos.width + padding : x
                                        } else if (type == "ES") {
                                            x = axisrotated ? pos.x - padding : x
                                        }
                                        
                                    } else if (j == 4) {
                                        if (type == "SE") {
                                            x = axisrotated ? pos.x + pos.width + padding : pos.x + pos.width / 2
                                        } else if (type == "ES") {
                                            x = axisrotated ? x : pos.x + pos.width / 2
                                        }
                                    } else {
                                        if (type == "SS" || type == "ES") {
                                            x = axisrotated ? pos.x - markerPadding : x
                                        } else if (type == "EE" || type == "SE") {
                                            x = axisrotated ? pos.x + pos.width + markerPadding : x
                                        }
                                    }
                                }
                            }
                            return x
                        })
                        .y(function(d, j) {
                            if (axisrotated) {
                                return (y || pos.y) + (pos.height / 2)
                            }
                            
                            if (j == 0) {
                                if (type == "SS" || type == "SE") {
                                    y = startPosition.y + startPosition.height
                                } else if (type == "EE" || type == "ES") {
                                    y = startPosition.y
                                }
                            } else if (j == 1) {
                                if (type == "SS" || type == "SE") {
                                    y = y + padding
                                } else if (type == "EE" || type == "ES") {
                                    y = startPosition.y - padding
                                }
                                
                            } else if (j == 2) {
                                if (type == "SS") {
                                    y = (startPosition.y + startPosition.height < endPosition.y + endPosition.height) ? endPosition.y + endPosition.height + padding : y
                                } else if (type == "EE") {
                                    y = (startPosition.y > endPosition.y) ? endPosition.y - padding : y;
                                }
                            } else if (j == 3) {
                                if (type == "SE") {
                                    y = crucialCurve ? endPosition.y - padding : y
                                } else if (type == "ES") {
                                    y = crucialCurve ? endPosition.y + endPosition.height + padding : y
                                }
                                
                            } else if (j == 4) {
                                y = y + 0;
                            } else {
                                if (type == "SS" || type == "ES") {
                                    y = endPosition.y + endPosition.height + markerPadding
                                } else if (type == "EE" || type == "SE") {
                                    y = endPosition.y - markerPadding
                                }
                            }
                            return y
                        })
                        .interpolate("linear");
                }
                
                function isCrucialCurve(type, start, end) {
                    var direct = false;
                    switch (type) {
                        case "SS":
                        case "EE": {
                            direct = true
                            break;
                        }
                        case "SE": {
                            direct = axisrotated ? start.x > (end.x + end.width) : start.y + start.height < end.y
                            break;
                        }
                        case "ES": {
                            direct = axisrotated ? (start.x + start.width) < end.x - linkPadding * 2 : start.y > end.y + end.height
                        }
                    }
                    return !direct;
                }
                
                function getDependencies(source, dependencyIndex, searchIndex) {
                    var allDependencies = [];
                    source.forEach(function(dd) {
                        var dependencies = [],
                            currentDependency = dd[dependencyIndex];
                        source.forEach(function(data) {
                            if (data !== dd && defined(currentDependency) && isArray(currentDependency)) {
                                if (currentDependency.indexOf(data[searchIndex]) !== -1) {
                                    allDependencies.push({
                                        "source": dd,
                                        "target": data
                                    })
                                }
                            }
                        });
                    });
                    if (allDependencies.length) {
                        return allDependencies;
                    }
                };
                
                function getPos(d) {
                    var width, height, x, y;
                    x = chart.getParamValue("x", d, i, null, commonOption)
                    y = chart.getParamValue("y", d, i, null, commonOption)
                    width = chart.getParamValue("width", d, i, null, commonOption)
                    height = chart.getParamValue("height", d, i, null, commonOption)
                    return {
                        "x": x,
                        "y": y,
                        "width": width,
                        "height": height
                    }
                }
                
                function getDividerParam(paramType, d, i, j, cp) {
                    switch (paramType) {
                        case "x":
                            return (axisrotated) ? yscale(d.y0) : chart.getParamValue("x", d, i, j, cp);
                        case "y":
                            return (axisrotated) ? chart.getParamValue("y", d, i, j, cp) : yscale(d.y0);
                        case "width":
                            return (axisrotated) ? 1 : barWidth;
                        case "height":
                            return (axisrotated) ? barWidth : 1;
                    }
                }
                
                function getBulletLevelMarkerProp(d, cp) {
                    var level = d[levelMarker.dataindex] || [],
                        hasLevels = defined(levelMarker.dataindex),
                        min,
                        max;
                    if (level != null && !(level instanceof Array)) { //If level marker is a single value and in non-array format, make it as array
                        level = [level];
                    }
                    
                    if (hasLevels && !level.length) {
                        min = max = 0;
                    } else {
                        min = d3_min(level);
                        max = d3_max(level);
                    }
                    
                    var v = dataset.getX(d);
                    var x = (stacked ? (bandwidth1(v) + (bandwidth2(cp.stackGroupIndex) || 0)) : bandwidth1(v) + bandwidth2(barDatasetIndex + i)) + levelMarkerPadding;
                    var y = hasLevels ?
                            (axisrotated ? yscale(mathMin(0, min)) : yscale(mathMax(0, max))) :
                            ((axisrotated && (hasNegValue != null)) ? yscale(hasNegValue) : 0),
                        wid = (axisrotated) ?
                            (hasLevels ? (yscale(mathMax(0, max)) - yscale(mathMin(0, min))) : ((hasNegValue != null) ? (plotarea.width - yscale(hasNegValue)) : plotarea.width)) :
                            levelMarkerWidth,
                        hei = (axisrotated) ?
                            levelMarkerWidth :
                            (hasLevels ? (yscale(mathMin(0, min)) - yscale(mathMax(0, max))) : ((hasNegValue != null) ? yscale(hasNegValue) : plotarea.height));
                    return {
                        "x": x,
                        "y": y,
                        "width": wid,
                        "height": hei
                    }
                }
                
                function addMarker(markerOption, id) {
                    var bandwidth = isBullet ? xscale.rangeBand() : levelMarkerWidth;
                    var size = validateNullVal(markerOption.size, (levelMarkerWidth - (2 * validateNullVal(markerOption.padding, barPadding / 2))));
                    var target = targetMarkerSeries.selectAll("g.markers" + id).data([d], function(d) {
                        return [dataset.getX(d)];
                    })
                    
                    // var markerWidth = ((markerOption.strokeWidth == null || markerOption.strokeWidth === "") ? 1 : JSON.parse(markerOption.strokeWidth));
                    var markerWidth = pick(markerOption.strokeWidth, 1);
                    
                    target.enter().append("g")
                    target.exit().remove();
                    target.attr({
                        "class": "markers" + id,
                        "transform": "translate(" + plotarea.left + "," + plotarea.top + ")",
                        "stroke-width": markerWidth,
                        "stroke-dasharray": getDashArray(markerOption.dashStyle, validateNullVal(markerOption.outerStrokeWidth, 1)),
                        "stroke-linecap": getLineCap(markerOption.lineCap, markerOption.dashStyle),
                        "fill": markerOption.color,
                        "stroke": markerOption.color
                    });
                    
                    var marker = target.selectAll("g").data(dataUpdate, function(d) {
                        return dataset.getX(d);
                    });
                    marker.enter().append("g");
                    var markerID, mSize = markerOption.symbol === "line" ? {
                                "inner": 0,
                                "outer": 1
                            } : {
                                "inner": 0.6,
                                "outer": 1
                            },
                        customMarkerSize = markerOption.size;
                    
                    marker.each(function(d, j) {
                        var m = d3_select(this);
                        var clr = multiColoring ? chartObj.seriesColor[j % chartObj.seriesColor.length] : color;
                        m.attr({
                                "transform": function(d, k) {
                                    var x = 0,
                                        y = 0;
                                    if (isGantt) {
                                        var position = getMarkerPosition(d, i, k, commonOption);
                                        if (id === 0) {
                                            x = position.x + position.width/2;
                                            y = position.y  - (markerOption.size*10)/2;
                                        } else {
                                            x = position.x + position.width / 2;
                                            y = position.y + position.height + (markerOption.size*10)/2;
                                        }
                                        return "translate(" + (axisrotated ? y : x) + "," + (axisrotated ? x : y) + ")"
                                    } else {
                                        x = (bandwidth1((dataset.getX(d))) + (bandwidth / 2));
                                        y = yscale(d[markerOption.dataindex]);
                                        return (d[markerOption.dataindex] == null) ? null : "translate(" + (axisrotated ? y : x) + "," + (axisrotated ? x : y) + ") rotate(" + (axisrotated ? 90 : 0) + ")";
                                    }
                                }
                            })
                            .style("display", function(d) {
                                return (d[markerOption.dataindex] == null) && isBullet ? "none" : null;
                            });
                        markerOption.size = defined(customMarkerSize) ?
                            (isBullet ? mathMin(size, (bandwidth / 10)) : size) :
                            (size / 10)
                        addSVGmarker(m, null, markerOption, {
                            symbolSize: mSize,
                            "color": isGantt ? clr : null
                        });
                        
                        // getBulletMarkerRect
                        if (tooltipEnabled && isBullet && targetMarkerEventsEnabled) {
                            var markerPos = getBulletMarkerRect(this, d, markerOption);
                            markerPos.seriesPos = index;
                            markerPos.data = d;
                            markerPos.type = "marker";
                            markerPos.yaxiscolumnorder = yaxiscolumnorder;
                            markerPos.currentStage = d[markerOption.dataindex];
                            bulletEvent.marker.push(markerPos)
                        }
                    })
                    markerOption.size = customMarkerSize; //reset with actual value
                    
                    if (isGantt) {
                        chart.markerProperties = {
                            "subseriesIndex": i
                        };
                    }
                }
                
                // returns marker position relative to the event rectangle
                
                function getBulletMarkerRect(el, d, markerOption) {
                    var elRect = bbox(el);
                    
                    var x = bandwidth1((dataset.getX(d))),
                        y = yscale(d[markerOption.dataindex]),
                        width = elRect.width,
                        height = mathMax(elRect.height, markerOption.outerStrokeWidth || 0, markerOption.innerStrokeWidth || 0);
                    x += (xscale.rangeBand() - elRect.width) / 2;
                    y -= height / 2;
                    if (height < 5) {
                        height = 5;
                        y -= 2.5;
                    }

                    // The target marker bound might be very small. triggeringOffset extends its boundary for event
                    var eventOptions = markerOption.events || {};
                    var triggerOffset = eventOptions.triggerOffset || 0;
                    x -= (triggerOffset / 2);
                    y -= (triggerOffset / 2);
                    width += triggerOffset;
                    height += triggerOffset;

                    return {
                        x: axisrotated ? y : x,
                        y: axisrotated ? x : y,
                        width: axisrotated ? height : width,
                        height: axisrotated ? width : height
                    };
                }
                
                function getBulletLevelMarkerRect(d, levelMarker, type) {
                    
                    if (d.isDummy) {
                        return [];
                    }
                    
                    var scale = (type == "x") ? xscale : yscale,
                        x = bandwidth1(dataset.getX(d)) + levelMarkerPadding,
                        y,
                        width = xscale.rangeBand(),
                        height,
                        datatype = chartObj.dataset.getDataType(type, 0),
                        formatConf,
                        temp = [],
                        rectangles = [],
                        originalValues = d[levelMarker.dataindex] || [],
                        col;
                    
                    if (originalValues != null && !(originalValues instanceof Array)) { //If level marker is a single value and in non-array format, make it as array
                        originalValues = [originalValues];
                    }
                    var steps = originalValues.slice(0);
                    
                    if (datatype == TIME_DATATYPE) {
                        var column = chartObj.dataset.getColumn(type, 0);
                        formatConf = defined(column.time) ? column.time : null
                    }
                    
                    steps.push(0); // add for get the base.
                    steps = steps.map(function(d) {
                        return (datatype == TIME_DATATYPE) ? generateDateVal(d, null, formatConf).getTime() : d;
                    });
                    steps = !isRotatedChart(type, axisrotated) ? steps.sort(d3_ascending) : steps.sort(d3_descending);
                    steps.forEach(function(target) {
                        var val = scale(target) + (defined(scale.rangeBand) ? scale.rangeBand() / 2 : 0);
                        temp.push(val);
                    });
                    steps.splice(steps.indexOf(0), 1); // remove
                    
                    col = temp.length - 1;
                    while (col--) {
                        height = temp[col + 1] - temp[col];
                        
                        if (height > 0) {
                            y = temp[col];
                            
                        }
                        y = temp[col];
                        if (height > 0) {
                            rectangles.push({
                                x: axisrotated ? y : x,
                                y: axisrotated ? x : y,
                                width: axisrotated ? height : width,
                                height: axisrotated ? width : height,
                                currentStage: steps[col],
                                seriesPos: index,
                                data: d,
                                yaxiscolumnorder: yaxiscolumnorder,
                                type: "levelmarker"
                            });
                        }
                    }
                    return rectangles;
                }
                
                function getMarkerPosition(d, i, j, commonOption) {
                    var width, height, x, y;
                    x = chart.getParamValue(axisrotated ? "y" : "x", d, i, j, commonOption)
                    y = chart.getParamValue(axisrotated ? "x" : "y", d, i, j, commonOption)
                    width = chart.getParamValue(axisrotated ? "height" : "width", d, i, j, commonOption)
                    height = chart.getParamValue(axisrotated ? "width" : "height", d, i, j, commonOption)
                    return {
                        "x": x,
                        "y": y,
                        "width": width,
                        "height": height
                    }
                }
                
                chart.getMarkerPosition = getMarkerPosition;
                
                function getGanttLevelMarkerProp(d, i, j, cp) {
                    var percentComplete = d[levelMarker.dataindex];
                    var yVal = dataset.getY(d, yaxiscolumnorder);
                    var startVal = yVal[0],
                        endVal = yVal[1],
                        maxRange = cp && cp.yscale.range()[1];
                    var diff = endVal - startVal;
                    var marginIncrease = (diff * percentComplete) / 100
                    var finalVal = cp.yscale(startVal + marginIncrease);
                    
                    var xPadding = (axisrotated) ? 0 : cp.levelMarkerPadding,
                        yPadding = (axisrotated) ? cp.levelMarkerPadding : 0;


                    var x, y, wid, hei;
                    x = chartObj.dataObject.getTransRectValue("x", d, i, j, cp) + xPadding;
                    var basevalue = cp.hasNegValue == null ? cp.yscale(dataset.getY(d, cp.yaxiscolumnorder, 0)) : cp.yscale(cp.hasNegValue);
                    if (cp.axisrotated) {
                        y = chart.getParamValue("y", d, i, j, cp) + yPadding;
                        wid = (cp.stacked) ? (mathAbs(cp.yscale(d.y + d.y0) - cp.yscale(d.y0))) + cp.addRangeBand(cp.yscale) :
                            (mathAbs((maxRange - basevalue) - (maxRange - finalVal)) || 0) + cp.addRangeBand(cp.yscale);
                        hei = cp.levelMarkerWidth || cp.barWidth;
                    } else {
                        y = finalVal;
                        wid = cp.levelMarkerWidth || cp.barWidth;
                        hei = cp.stacked ? mathAbs(((basevalue) - cp.yscale(d.y + d.y0)) - ((basevalue) - cp.yscale(d.y0))) + cp.addRangeBand(cp.yscale) :
                            mathAbs(basevalue - finalVal) + cp.addRangeBand(cp.yscale);
                    }
                    return {
                        "x": x,
                        "y": y,
                        "width": wid,
                        "height": hei
                    }
                }
            })
            
            labelQueue.push({
                "renderer": chart,
                "charttype": "bar",
                "chartObj": chartObj,
                "args": [currentdata, index]
            });
            
        });
        chart.renderedTimer = setTimeout(function() {
            isredraw = true;
            chart.chartRendered = true;
        }, (2 * transitionDuration + 10));
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.bandwidth1 = function(_) {
        if (!arguments.length) {
            return bandwidth1;
        }
        bandwidth1 = _;
        return chart;
    };
    
    chart.bandwidth2 = function(_) {
        if (!arguments.length) {
            return bandwidth2;
        }
        bandwidth2 = _;
        return chart;
    };
    
    chart.barDatasetIndex = function(_) {
        if (!arguments.length) {
            return barDatasetIndex;
        }
        barDatasetIndex = _;
        return chart;
    };

    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    
    return chart;
};//$Id$
/**
 *
 * @type {chart} line renderer.
 */
svg_plot_renderer.line = function() {
    var commonRendererProp, xscale, yscale, index, dataset, axisrotated, yaxiscolumnorder, color;
    var line = [],
        scatter = svg_plot_renderer.scatter();
    var series, redraw = false,
        path, strokeDashArray, marqueeEnabled, marqueeDuration, marker;
    var stacked, labelQueue, commonPlotOptions, systemconf, hasNegValue, chartObj;
    var oldData, shiftInfo, yrangePos;
    var transitionDuration, animationType;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                xscale = rp.xscale,
                yscale = rp.yscale,
                stacked = rp.stacked,
                index = rp.datasetIndex,
                axisrotated = rp.axisrotated,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                labelQueue = rp.labelQueue,
                hasNegValue = rp.hasNegValue,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset,
                systemconf = chartObj.systemConf
            
            var defsLocation = chartObj.defsLocation;
            
            var currentdata = data[index];
            var plotoptions = currentdata.plotoptions;
            var currentseriesdata = currentdata.data;
            var tempChart = chartObj.chartTypes[index],
                charttype = tempChart.name,
                chartTypeNumeric = tempChart.value,
                dataProcessorHelpers = $ZC.DataProcessor.helpers;
            var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions),
                isAreaChart = chartTypeNumeric != $ZC.charttype.line,
                isRangeChart = (charttype == "arearange"),
                isPolar = chartObj.dataObject.isPolarAxisCategory,
                gradientDim = axisrotated ? [yscale.range()[0], xscale.range()[1]] : [xscale.range()[1], yscale.range()[0]],
                canvasarea = chartObj.canvasarea;
            var interpolation = gvp("mode"),
                dashStyle = gvp("dashStyle"),
                strokeWidth = validateNullVal(gvp("strokeWidth"), 2),
                strokeOpacity = gvp("strokeOpacity"),
                strokeColor = gvp("strokeColor"),
                callScatterRenderer = $Browser.IE || $Browser.SAFARI || interpolation == "step-before" || interpolation == "step-after" || rp.thresholdType, // IE & SAFARI don't support marker updation. So, render the scatter chart instead of using marker.
                markeroptions = ((plotoptions && plotoptions.marker) ? mergeJSON(commonPlotOptions.marker, plotoptions.marker, true) : commonPlotOptions.marker);
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, charttype);
            var isAnimationEnable = animationOptions.enabled,
                easingType = animationOptions.easingType;
            transitionDuration = animationOptions.duration;
            animationType = animationOptions.type;
            animationType = (animationType == "vertPathTweenAll") ? "vertPathTween" : animationType;
            
            var blinkConf = (plotoptions && plotoptions.animation && plotoptions.animation.blink) ?
                mergeJSON(commonPlotOptions.animation.blink, plotoptions.animation.blink, true) :
                commonPlotOptions.animation.blink;
            
            var markerEnabled = (datacount_based_intelligence(chartObj, "marker") && dimension_based_intelligence(chartObj, "marker", mathMin(canvasarea.width, canvasarea.height))) ? markeroptions.enabled : false,
                strokeLineCap = getLineCap(gvp("lineCap"), dashStyle);
            strokeDashArray = getDashArray(dashStyle, strokeWidth);
            
            var marqueeOptions = (plotoptions && plotoptions.animation && plotoptions.animation.marquee) ?
                mergeJSON(commonPlotOptions.animation.marquee, plotoptions.animation.marquee, true) :
                commonPlotOptions.animation.marquee;
            marqueeEnabled = marqueeOptions.enabled;
            marqueeDuration = marqueeOptions.duration;
            
            var gradientOptions = (!isAreaChart && plotoptions && plotoptions.gradients) ?
                mergeJSON(commonPlotOptions.gradients, plotoptions.gradients, true) :
                commonPlotOptions.gradients;

            var datatypeX = chartObj.dataset.getDataType("x")
                datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),

                xCategories = (datatypeX == ORDINAL_DATATYPE) ? xscale.domain() : null,
                yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

                categories = (datatypeX == ORDINAL_DATATYPE && !defined(chartObj.dataObject.hierarchical)) ? xCategories : chartObj.dataObject.getCategories("x");

            var yReversed = systemconf.chart.axes.yaxis[yaxiscolumnorder].reversed;
            if (datatypeX != ORDINAL_DATATYPE && categories.length == 0 && isAnimationEnable && animationType == "pointTween") {
                categories = chartObj.dataObject.findXCategories();
            }
            
            chart.seriesdataAfterUpdate = [];
            currentseriesdata.forEach(function(d, i) {
                var serData;
                if (datatypeX == ORDINAL_DATATYPE || datatypeY == ORDINAL_DATATYPE) {
                    serData = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(d), xCategories, yCategories, yaxiscolumnorder);
                } else {
                    serData = d;
                }

                chart.seriesdataAfterUpdate[i] = serData;
                var curInterpolation = ($Browser.FIREFOX && (serData.length == 1)) ? "linear-closed" : interpolation; //Firefox fails to render path marker if 'd' has only 'M(x) (y)' ZC509

                line[i] = isPolar ?
                    d3_lineRadial()
                        .defined(function(d, j) {
                            return !d.isDummy;
                        })
                        .radius(function(d, j) {
                            var adjustFactor = 0.1;// #ZC717 -> if path contains 'L0,0L0,0L0,0Z'
                            var R = (stacked) ? yscale(d.y + d.y0) : (yscale(dataset.getY(d, yaxiscolumnorder)) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
                            return mathMax(R, yscale.range()[(yReversed && !stacked) ? yscale.domain().length - 1 : 0] + adjustFactor);
                        })
                        .angle(function(d, j) {
                            return xscale(dataset.getX(d));
                        })
                        .interpolate(curInterpolation) :
                    d3_line()
                        .defined(function(d, j) {
                            var nullData = !isCatNullY(dataset.getY(d, yaxiscolumnorder)) && !isCatNullX(dataset.getX(d));
                            if (chartTypeNumeric === $ZC.charttype.stkdarea) {
                                return true
                            }
                            return !d.isDummy && nullData;
                        })
                        .x(function(d, j) {
                            var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos)
                            if (shiftInfo != null) {
                                var transX = (shiftInfo != null) ?
                                    Math.abs((chartObj.dataObject.getXYvalue(axisrotated, stacked, chart.oldXscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos) -
                                    chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos))) :
                                    null;
                                x = x + transX;
                            }
                            return x;
                        })
                        .y(function(d, j) {
                            return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos);
                        })
                        .interpolate(curInterpolation)
                        .tension(commonPlotOptions.tension || 0.7);
            });
            
            var container = d3_select(this);
            chart.update = function() {
                container.transition().call(chart);
            };
            series = appendEle(container, "g", [currentdata], ".", "class", ('lineseries_' + index));
            if (isRangeChart) {
                series = appendEle(series, "g", [currentdata], ".", "class", ('rangePos_' + yrangePos));
            }
            
            var markerID,
                mSize = isPolar ? {
                        "inner": 0.32,
                        "outer": 0.56
                    } : {
                        "inner": 0.4,
                        "outer": 0.7
                    };
            if (markerEnabled && !callScatterRenderer) {
                markeroptions.color = currentdata.color || chartObj.seriesColor[index % chartObj.seriesColor.length];
                markerID = generateIdByPropValue(markeroptions, "marker") + generateIdByPropValue(blinkConf, "blink");
                marker = addSVGmarker(series, markerID, markeroptions, {
                    "color": markeroptions.color,
                    symbolSize: mSize,
                    strokeWidth: strokeWidth
                });
                delete markeroptions.color;
            }
            
            if (markerEnabled && !callScatterRenderer && blinkConf.enabled) {
                blinkSVGsymbols(marker.selectAll(".outer,.inner"), blinkConf);
            }
            
            if (markerEnabled && callScatterRenderer) {
                scatter
                    .commonRendererProp(commonRendererProp)
                    .shiftInfo(shiftInfo)
                    .yrangePos(yrangePos);
                scatter.chartRendered = false;

                container.call(scatter);
            } else {
                container.selectAll("g.scatterseries_" + index).remove();
            }
            
            currentseriesdata.forEach(function(d, i) {
                var ishideable = currentdata.disabled;
                if (chartObj.brush && chartObj.brush.extent) {
                    var domain = chartObj.axes.x.scale.domain();
                    var ticks = chartObj.axes.x.ticks.tickValueObj.ticks;
                    var startVal = (datatypeX == TIME_DATATYPE) ? domain[0].getTime() : (datatypeX == ORDINAL_DATATYPE) ? categories.indexOf(domain[0]) : domain[0];
                    var endVal = (datatypeX == TIME_DATATYPE) ? domain[1].getTime() : (datatypeX == ORDINAL_DATATYPE) ? categories.indexOf(domain[domain.length - 1]) : domain[1];
                    var accessor = (datatypeX == ORDINAL_DATATYPE) ? function(d) {
                            return categories.indexOf(chartObj.dataset.getX(d))
                        } : function(d) {
                            return chartObj.dataset.getX(d)
                        }
                    chart.seriesdataAfterUpdate[i] = dataProcessorHelpers.filterDataToViewPort(chart.seriesdataAfterUpdate[i], startVal, endVal, accessor);
                }
                var serData = chart.seriesdataAfterUpdate[i];
                if (chartObj.systemConf.chart.axes.xaxis.reversed) {
                    serData = serData.slice(0).reverse();
                }
                var baseData = serData;
                
                var basedataShift, ShiftedData;
                
                var subseries = appendEle(series, "g", function(d) {
                    return ishideable ? [] : [d];
                }, ".", "class", ('subseries_' + i));
                
                path = subseries.selectAll("path.line").data(function(d) {
                    return ishideable ? [] : [d];
                });
                if (isAnimationEnable && (animationType != "strokeTween")) {
                    if (animationType == "pointTween") {
                        
                        //get baseData for starting animation
                        baseData = (oldData != null) ? oldData.map(function(d, j) {
                                return Object.create(oldData[0])
                            }) : serData.map(function(d, i) {
                                return Object.create(serData[0])
                            });
                        
                    } else {
                        var idx = (animationType == "horiPathTween") ? dataset.xidx : dataset.yidx(yaxiscolumnorder);
                        var scale = (animationType == "horiPathTween") ? xscale : yscale;
                        var baseIdx = (isPolar && yReversed && !stacked) ? scale.domain().length - 1 : 0;
                        baseData = serData.map(function(d, i) {
                            var s = Object.create(d);
                            if (stacked && animationType != "horiPathTween") {
                                s.y0 = 0;
                                s.y = (!isPolar && (hasNegValue != null) && (scale(hasNegValue) != null)) ? mathMax(hasNegValue, scale.domain()[0]) : scale.domain()[0];
                            } else {
                                if (isRangeChart && animationType == "vertPathTween") {
                                    var yArr = new Array(2);
                                    var y0 = chartObj.dataset.getY(d, yaxiscolumnorder, 0);
                                    yArr[0] = y0;
                                    yArr[1] = (s[idx] == null) ? null : (((hasNegValue != null) && (scale(hasNegValue) != null)) ? mathMax(hasNegValue, y0) : y0);
                                    s[idx] = yArr
                                } else {
                                    s[idx] = (s[idx] == null) ? null : ((!isPolar && (hasNegValue != null) && (scale(hasNegValue) != null)) ? mathMax(hasNegValue, scale.domain()[0]) : scale.domain()[baseIdx]);
                                }
                            }
                            return s;
                        });
                    }
                    basedataShift = d3_values(baseData);
                }
                

                if (shiftInfo != null) {

                    if (redraw) {
                        var clipX = xscale(serData[0][0]) + ((xscale.rangeBand != null) ? xscale.rangeBand() / 2 : 0);
                        var clipWid = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 1], "x", null, yrangePos) -
                            chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos)

                        var properties = {
                            name: "rect",
                            id: chartObj.id,
                            x: clipX,
                            y: 0,
                            width: clipWid,
                            height: chartObj.plotarea.height
                        },
                        args = {
                            chartObj: chartObj
                        };
                        var clipID = effects.get(svg_clips, "rect", properties, args);
                        series
                            .attr('clip-path', "url(" + defsLocation + "#" + clipID + ")");
                    }
                    
                }
                
                
                var pathEnter = path.enter().append("path").attr("class", "line")
                    .datum(baseData, function(d) {
                        return dataset.getX(d)
                    })
                    .attr("d", line[i])
                    .style('stroke', currentdata.color || color)
                    .style('stroke-width', strokeWidth)
                    .style('stroke-opacity', (strokeOpacity == null || strokeOpacity === "") ? 1 : strokeOpacity)
                
                
                if (isAnimationEnable) {
                    if (animationType == "pointbypoint" || animationType == "pointTween") {
                        interTween(baseData, basedataShift, serData, categories, animationType, easingType, transitionDuration, rp, function(d) {
                            return {
                                "d": line[i](d)
                            };
                        }, pathEnter);
                    } else if (animationType == "strokeTween") {
                        strokeTween(pathEnter, easingType, transitionDuration);
                    } else {
                        pathEnter
                            .transition()
                            .duration(transitionDuration)
                            .ease(easingType)
                            .attrTween("d", pathTween);
                    }
                    
                }
                
                var pathUpdate = path.datum(serData, function(d) {
                        return dataset.getX(d)
                    })
                    .attr({
                        "id": "line_" + index,
                        "stroke-dasharray": strokeDashArray
                    })
                    .style({
                        "stroke-linecap": strokeLineCap,
                        "stroke-width": strokeWidth,
                        "stroke-opacity": validateNullVal(strokeOpacity, 1),
                        "fill": "none",
                        "stroke": function(d, i) {
                            if(gradientOptions.type){
                                var args = {"offset":charttype};
                                gradientOptions = getGradientProp(gradientOptions,gradientDim,strokeColor || color,strokeOpacity);
                                var gradientID = isAreaChart ? null : effects.get(svg_gradients, "svgGradientFill", gradientOptions, args);
                                return "url(" + defsLocation + "#" + gradientID + ")";
                            }
                            
                            return (strokeColor || color);
                        }
                    });
                
                var dataUpdate =  serData;
                


                if (shiftInfo != null) {
                    var transX = (shiftInfo != null) ?
                        Math.abs((chartObj.dataObject.getXYvalue(axisrotated, stacked, chart.oldXscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos) -
                        chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos))) :
                        null;
                    pathUpdate
                        .datum(dataUpdate)
                        .attr("d", line[i])
                        .transition()
                        .duration(transitionDuration)
                        .ease(easingType)
                        .attr("transform", function() {
                            return ((transX == null) ? null : "translate(-" + transX + ",0)")
                        });

                    resetDashProp(path);
                } else if (pathEnter.node() == null) {
                    path.datum(dataUpdate)
                        .attr("transform", null)
                        .transition()
                        // .delay(((isAreaChart && ((animationType != "pointTween") || (animationType == "pointTween" && redraw != false && currentdata.disabled != false))) ? 0 : transitionDuration))
                        .duration(transitionDuration)
                        .ease(easingType)
                        .attr("d", line[i]);
                    
                    /*
                     * Reset stroke-dasharray & stroke-dashoffset
                     * If animation.type = "strokeTween" & calling redraw before the animation completes
                     */
                    resetDashProp(path);
                }
                
                var mID = (markerEnabled && !callScatterRenderer) ? "url(" + defsLocation + "#" + markerID + ")" : null;
                path
                    .attr({
                        "marker-end": mID,
                        "marker-start": mID,
                        "marker-mid": mID
                    });
                
                path.exit().remove();
                
                function pathTween() {
                    var interpolate = d3_interpolate(line[i](baseData), line[i](serData));
                    return function(t) {
                        return interpolate(t);
                    };
                }
            });
            if (!(callScatterRenderer && markerEnabled)) {
                var markerSize = markerEnabled ? (((markeroptions.size || strokeWidth) * mSize.outer * 10) + strokeWidth / 2) : 0;
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "scatter",
                    "chartObj": chartObj,
                    "args": [currentdata, index, markerSize, yrangePos]
                });
            }
        });
        chart.renderedTimer = setTimeout(function() {
            if (marqueeEnabled) {
                applyMarquee(series.selectAll("#line_" + index), marqueeDuration, strokeDashArray, chart);
            }
            chart.chartRendered = true;
            redraw = true;
        }, (!redraw) ? (transitionDuration + 20) : (2 * transitionDuration + 20));
        
        chart.oldXscale = xscale;
        return chart;
    }
    
    //chart.prototype = new $ZC.renderer();
    function strokeTween(path, easingType, duration) {
        path
            .style({
                "stroke-dasharray": function() {
                    return this.getTotalLength() + " " + this.getTotalLength()
                },
                "stroke-dashoffset": function() {
                    return this.getTotalLength()
                }
            })
            .transition()
            .duration(duration)
            .ease(easingType)
            .style("stroke-dashoffset", 0)
            .each("end", function() {
                resetDashProp(d3_select(this));
            });
    }
    
    function resetDashProp(path) {
        path
            .style({
                "stroke-dasharray": strokeDashArray,
                "stroke-dashoffset": null
            });
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    
    chart.yrangePos = function(_) {
        if (!arguments.length) {
            return yrangePos;
        }
        yrangePos = _;
        return chart;
    };
    return chart;
};//$Id$
/**
 *
 * @returns {chart} area and arearange renderer.
 */
svg_plot_renderer.area = function() {
    var commonRendererProp, xscale, yscale, dataset, yaxiscolumnorder, index = 0,
        stacked = false,
        axisrotated = false,
        redraw = false,
        line = svg_plot_renderer.line();
    var area = [],
        color, labelQueue, commonPlotOptions, systemconf, hasNegValue, chartObj,
        transitionDuration;
    var shiftInfo, shiftDiff,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                xscale = rp.xscale,
                yscale = rp.yscale,
                stacked = rp.stacked,
                index = rp.datasetIndex,
                axisrotated = rp.axisrotated,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                labelQueue = rp.labelQueue,
                hasNegValue = rp.hasNegValue,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset,
                systemconf = chartObj.systemConf
            
            var defsLocation = chartObj.defsLocation,
                isPolar = chartObj.dataObject.isPolarAxisCategory;
            
            var currentdata = data[index];
            var plotoptions = currentdata.plotoptions;
            var currentseriesdata = currentdata.data;
            var charttype = chartObj.chartTypes[index].name;

            var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions);
            var interpolation = gvp("mode"),
                fillOpacity = gvp("fillOpacity"),
                strokeWidth = gvp("strokeWidth"),
                strokeColor = gvp("strokeColor"),
                markerEnabled = defined(plotoptions) ? $ZC.utils.getValueOfPlotOptions(plotoptions.marker, commonPlotOptions.marker)("enabled") : commonPlotOptions.marker.enabled;
            var borderEnabled = ((strokeWidth != null && strokeWidth != "" && pInt(strokeWidth) != 0) ||
            (strokeColor != null && strokeColor != "") || (markerEnabled));
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, charttype);
            var isAnimationEnable = animationOptions.enabled,
                easingType = animationOptions.easingType,
                animationType = animationOptions.type;
            transitionDuration = animationOptions.duration;
            animationType = (animationType == "vertPathTweenAll") ? "vertPathTween" : animationType;
            
            var datatypeX = chartObj.dataset.getDataType("x")
                datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),

                xCategories = (datatypeX == ORDINAL_DATATYPE) ? xscale.domain() : null,
                yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

                categories = (datatypeX == ORDINAL_DATATYPE && !defined(chartObj.dataObject.hierarchical)) ? xCategories : chartObj.dataObject.getCategories("x");

            var yReversed = systemconf.chart.axes.yaxis[yaxiscolumnorder].reversed;
            var polarBaseIdx = (isPolar && yReversed && !stacked) ? yscale.domain().length - 1 : 0;
            if (datatypeX != ORDINAL_DATATYPE && categories.length == 0 && isAnimationEnable && animationType == "pointTween") {
                categories = chartObj.dataObject.findXCategories();
            }
            
            var isRangeChart = (charttype) == "arearange";
            var yrangePos = (isRangeChart) ? 1 : null;
            
            chart.seriesdataAfterUpdate = [];
            currentseriesdata.forEach(function(d, i) {
                var serData;
                if (datatypeX == ORDINAL_DATATYPE || datatypeY == ORDINAL_DATATYPE) {
                    serData = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(d), xCategories, yCategories, yaxiscolumnorder);
                } else {
                    serData = d;
                }

                if (chartObj.brush && chartObj.brush.extent) {
                    var domain = chartObj.axes.x.scale.domain();
                    var ticks = chartObj.axes.x.ticks.tickValueObj.ticks;
                    var startVal = (datatypeX == TIME_DATATYPE) ? ticks[0].getTime() : (datatypeX == ORDINAL_DATATYPE) ? categories.indexOf(domain[0]) : domain[0];
                    var endVal = (datatypeX == TIME_DATATYPE) ? domain[1].getTime() : (datatypeX == ORDINAL_DATATYPE) ? categories.indexOf(domain[domain.length - 1]) : domain[1];
                    var accessor = (datatypeX == ORDINAL_DATATYPE) ? function(d) {
                            return categories.indexOf(chartObj.dataset.getX(d))
                        } : function(d) {
                            return chartObj.dataset.getX(d)
                        }
                    serData = dataProcessorHelpers.filterDataToViewPort(serData, startVal, endVal, accessor);
                }

                chart.seriesdataAfterUpdate[i] = serData;
                if (chartObj.systemConf.chart.axes.xaxis.reversed) {
                    serData = serData.slice(0).reverse();
                }
                shiftDiff = (shiftInfo != null) ? (((shiftDiff == null) || (shiftDiff == 0)) ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 1], "x") -
                        chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 2], "x") : shiftDiff) : 0
                area[i] = isPolar ?
                    d3_areaRadial()
                        .angle(function(d, j) {
                            return xscale(dataset.getX(d));
                        })
                        .outerRadius(function(d, j) {
                            var OR = (stacked) ? yscale(d.y0 + d.y) : (yscale(dataset.getY(d, yaxiscolumnorder)) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
                            return mathMax(OR, yscale.range()[polarBaseIdx]);
                        })
                        .innerRadius(function(d, j) {
                            var IR;
                            if (stacked) {
                                IR = (index == 0) ? mathMin(yscale.range()[0], yscale(hasNegValue)) : yscale(d.y0);
                            } else {
                                IR = (yscale(yscale.domain()[polarBaseIdx]) + ((yscale.rangeBand != null) ? yscale.rangeBand() / 2 : 0));
                            }
                            return mathMax(IR, yscale.range()[polarBaseIdx]);
                        })
                        .interpolate(interpolation) :
                    d3_area()
                        .defined(function(d, j) {
                            if (stacked) {
                                return !isCatNullX(dataset.getX(d));
                            }
                            return !isCatNullY(dataset.getY(d, yaxiscolumnorder)) && !isCatNullX(dataset.getX(d));
                        })
                        .x(function(d, j) {
                            var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos)
                            if (shiftInfo != null) {
                                var transX = (shiftInfo != null) ?
                                    Math.abs((chartObj.dataObject.getXYvalue(axisrotated, stacked, chart.oldXscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos) -
                                    chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos))) :
                                    null;
                                x = x + transX;
                            }
                            return x;
                        })
                        .y(function(d, j) {
                            return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos);
                        })
                        .interpolate(interpolation)
                        .tension(commonPlotOptions.tension || 0.7);
                
                if (!isPolar) {
                    if (axisrotated) {
                        area[i].x0(function(d, j) {
                            if (stacked) {
                                return ((index == 0) && (i == 0) && (j == 0)) ? mathMax(yscale.range()[0], yscale(hasNegValue)) : yscale(d.y0);
                            } else {
                                if (isRangeChart) {
                                    return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, 0);
                                } else {
                                    return (yscale.rangeBand != null) ? (yscale.range()[0] + yscale.rangeBand()) : mathMax(yscale.range()[0], yscale(hasNegValue));
                                }
                            }
                        });
                    } else {
                        area[i].y0(function(d, j) {
                            if (stacked) {
                                return ((index == 0) && (i == 0) && (j == 0)) ? mathMin(yscale.range()[0], yscale(hasNegValue)) : yscale(d.y0);
                            } else {
                                if (isRangeChart) {
                                    return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, 0);
                                } else {
                                    return (yscale.rangeBand != null) ? (yscale.range()[0] + yscale.rangeBand()) : mathMin(yscale.range()[0], yscale(hasNegValue));
                                }
                            }
                        });
                    }
                }
            });
            
            var container = d3_select(this);
            chart.update = function() {
                container.transition().call(chart);
            };
            var series = container.selectAll('g.areaseries_' + index).data([currentdata]);
            series.enter().insert('g', (isPolar ? ':first-child' : null)).attr('class', 'areaseries_' + index);
            
            if (borderEnabled || markerEnabled) {
                line
                    .commonRendererProp(commonRendererProp)
                    .shiftInfo(shiftInfo);
                line.chartRendered = false;
                
                if (isRangeChart) {
                    line.yrangePos(1)
                    var baseLine = svg_plot_renderer.line()
                        .commonRendererProp(commonRendererProp)
                        .shiftInfo(shiftInfo)
                        .yrangePos(0);
                    baseLine.chartRendered = false;
                    container.call(baseLine);
                }
                container.call(line);
                
            } else {
                container.selectAll("g.lineseries_" + index + ",g.scatterseries_" + index).remove();
            }
            
            currentseriesdata.forEach(function(d, i) {
                var serData = chart.seriesdataAfterUpdate[i];
                var baseData = serData;
                var basedataShift, ShiftedData;
                
                if (isAnimationEnable) {
                    if (animationType == "pointTween") {
                        baseData = serData.map(function(d, i) {
                            return Object.create(serData[0])
                        });
                    } else {
                        var idx = (animationType == "horiPathTween") ? dataset.xidx : dataset.yidx(yaxiscolumnorder);
                        var scale = (animationType == "horiPathTween") ? xscale : yscale;
                        var baseIdx = (isPolar && yReversed && !stacked) ? scale.domain().length - 1 : 0;
                        baseData = serData.map(function(d, i) {
                            var s = Object.create(d);
                            if (stacked && animationType != "horiPathTween") {
                                s.y0 = (isPolar && (animationType === "strokeTween")) ? mathMin(0, scale.domain()[0]) : 0;
                                s.y = (!isPolar && (hasNegValue != null) && (scale(hasNegValue) != null)) ? mathMax(hasNegValue, scale.domain()[0]) : scale.domain()[0];
                            } else {
                                if (isRangeChart && animationType == "vertPathTween") {
                                    var yArr = new Array(2);
                                    var y0 = chartObj.dataset.getY(d, yaxiscolumnorder, 0);
                                    yArr[0] = y0;
                                    yArr[1] = (s[idx] == null) ? null : (((hasNegValue != null) && (scale(hasNegValue) != null)) ? mathMax(hasNegValue, y0) : y0);
                                    s[idx] = yArr
                                } else {
                                    s[idx] = (s[idx] == null) ? null : ((!isPolar && (hasNegValue != null) && (scale(hasNegValue) != null)) ? mathMax(hasNegValue, scale.domain()[0]) : scale.domain()[baseIdx]);
                                }
                                
                            }
                            return s;
                        })
                    }
                    basedataShift = d3_values(baseData)
                }
                
                var ishideable = currentdata.disabled;
                var subseries = appendEle(series, "g", function(d) {
                    return ishideable ? [] : [d];
                }, ".", "class", ('subseries_' + i));
                var path = subseries.selectAll("path.area").data(function(d) {
                    return ishideable ? [] : [d];
                });
                
                var pathEnter = path.enter().append("path")
                    .datum(baseData)
                    .attr("class", "area")
                    .style('opacity', fillOpacity)
                    .style('fill', color)
                    .attr("d", area[i])
                
                if (isAnimationEnable) {
                    if (animationType == "pointbypoint" || animationType == "pointTween") {
                        interTween(baseData, basedataShift, serData, categories, animationType, easingType, transitionDuration, rp, function(d) {
                            return {
                                "d": area[i](d)
                            };
                        }, pathEnter);
                    } else if (pathEnter.node() != null && animationType == "strokeTween") { //For stacked chart, check again
                        pathEnter
                            .transition()
                            .duration(0)
                            .delay(transitionDuration)
                            .attr("d", function(d) {
                                return area[i](d);
                            })
                    } else {
                        pathEnter
                            .transition()
                            .duration(transitionDuration)
                            .ease(easingType)
                            .attrTween("d", pathTween)
                    }
                }
                
                function pathTween() {
                    var interpolate = d3_interpolate(area[i](baseData), area[i](serData));
                    return function(t) {
                        return interpolate(t);
                    };
                }
                var gradientDim = isPolar ? [chartObj.plotarea_approx.radius, chartObj.plotarea_approx.radius] : [(axisrotated ? yscale(yscale.domain()[0]) : xscale(xscale.domain()[1])), (axisrotated ? xscale(xscale.domain()[1]) : yscale(yscale.domain()[0]))];
                var fillColor = chart.fillColorFunc = getFillColor(chartObj, index, gradientDim);

                // var ShiftedData = d3_values(serData);
                // var ShiftedData_bef = [];
                if (shiftInfo != null) {
                    // ShiftedData = d3_values(serData);
                    // var co = shiftInfo.count;
                    // for (var k = 0; k <= co; k++) {
                    //     ShiftedData.splice(k, 0, shiftInfo.point)
                    // }
                    //
                    // for (var h = 0; h < serData.length; h++) {
                    //     ShiftedData_bef[h] = []
                    //     ShiftedData_bef[h][0] = serData[h][0]
                    //     ShiftedData_bef[h][1] = (h == 0) ? shiftInfo.point[1] : serData[h - 1][1]
                    // }
                    // ShiftedData_bef.push(["dummmy", serData[serData.length - 1][1]])
                    
                    if (redraw) {
                        // var markerWidth = (chartObj.dataObject.totalnoofdatas <= maxLimit) && markerEnabled
                        var clipX = xscale(serData[0][0]) + ((xscale.rangeBand != null) ? xscale.rangeBand() / 2 : 0);
                        var clipWid = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 1], "x") -
                            chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[0], "x");

                        var properties = {
                            name: "rect",
                            id: chartObj.id,
                            x: clipX,
                            y: 0,
                            width: clipWid,
                            height: chartObj.plotarea.height
                        },
                        args = {
                            chartObj: chartObj
                        };
                        var clipID = effects.get(svg_clips, "rect", properties, args);
                        series
                            .attr('clip-path', "url(" + defsLocation + "#" + clipID + ")");
                    }
                    
                }
                
                var dataUpdate = serData;
                var pathUpdate = path.datum(dataUpdate)
                    .style({
                        "opacity" : fillOpacity,
                        "fill" : fillColor(index,null,null,color)
                    });
                

                if (shiftInfo != null) {
                    var transX = (shiftInfo != null) ?
                        Math.abs((chartObj.dataObject.getXYvalue(axisrotated, stacked, chart.oldXscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos) -
                        chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos))) :
                        null;
                    pathUpdate
                        .datum(dataUpdate)
                        .attr("d", area[i])
                        .attr("transform", null)
                        .transition()
                        .duration(transitionDuration)
                        .ease(easingType)
                        .attr("transform", function() {
                            return ((transX == null) ? null : "translate(-" + transX + ",0)")
                        })
                    
                } else {
                    if (pathEnter.node() != null && animationType == "strokeTween") {
                        pathUpdate
                            .datum(dataUpdate)
                            .transition()
                            .duration(0)
                            .delay(transitionDuration)
                            .attr("d", function(d) {
                                return area[i](d);
                            })
                    } else {
                        pathUpdate
                            .datum(dataUpdate)
                            .transition()
                            .delay(((animationType == "pointbypoint" || animationType == "pointTween") && pathEnter.node() != null) ? transitionDuration : 0)
                            .duration(transitionDuration)
                            .ease(easingType)
                            .attr("d", area[i])
                    }
                }
                
                path.exit().remove();
                
            });
            if (!(borderEnabled || markerEnabled)) {
                if (isRangeChart) {
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "scatter",
                        "chartObj": chartObj,
                        "args": [currentdata, index, 0, 1]
                    });
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "scatter",
                        "chartObj": chartObj,
                        "args": [currentdata, index, 0, 0]
                    }); //last argument in args for yrangePos
                } else {
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "scatter",
                        "chartObj": chartObj,
                        "args": [currentdata, index, 0]
                    });
                }
            }
        });
        chart.renderedTimer = setTimeout(function() {
            chart.chartRendered = true;
            redraw = true;
        }, transitionDuration);
        chart.oldXscale = xscale;
        return chart;
    }
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    
    return chart;
}//$Id$
/**
 *
 * @returns {chart} scatter, bubble renderer.
 */
svg_plot_renderer.scatter = function() {
    var chartObj, xscale, yscale, index, yaxiscolumnorder, color, stacked, dataset, axisrotated,
        labelQueue, commonPlotOptions, systemconf, hasNegValue, redraw = false,
        transitionDuration;
    var shiftInfo, commonRendererProp,
        yrangePos,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    function chart(selection) {
        selection.each(function(data) {
            
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                xscale = rp.xscale,
                yscale = rp.yscale,
                stacked = rp.stacked,
                index = rp.datasetIndex,
                axisrotated = rp.axisrotated,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                labelQueue = rp.labelQueue,
                hasNegValue = rp.hasNegValue,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset,
                systemconf = chartObj.systemConf;
            
            var defsLocation = chartObj.defsLocation;
            
            var xReversed = systemconf.chart.axes.xaxis.reversed,
                yReversed = systemconf.chart.axes.yaxis[yaxiscolumnorder].reversed;
            
            var container = d3_select(this);
            chart.update = function() {
                container.transition().call(chart);
            };
            var currentdata = data[index];
            var plotoptions = currentdata.plotoptions;
            
            var chartType = chartObj.chartTypes[index].value;
            var chartName = chartObj.chartTypes[index].name;

            var isBubbleChart = (chartType == $ZC.charttype.bubble),
                scatterOrBubble = (isScatterChartType(chartType)),
                isPolar = chartObj.dataObject.isPolarAxisCategory;
            
            var currentseriesdata = currentdata.data;
            var series = appendEle(container, "g", [currentdata], ".", "class", ('scatterseries_' + index));
            if (chartName === "arearange") {
                series = appendEle(series, "g", [currentdata], ".", "class", ('rangePos_' + yrangePos));
            }
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, chartName);
            var isAnimationEnable = animationOptions.enabled,
                easingType = animationOptions.easingType,
                animationType = animationOptions.type;
            transitionDuration = animationOptions.duration;
            
            var markerOptions = (plotoptions && plotoptions.marker) ?
                mergeJSON(commonPlotOptions.marker, plotoptions.marker, true) :
                commonPlotOptions.marker;
            var symboltype = markerOptions.symbol,
                symbolsize = markerOptions.size;
            
            if (!scatterOrBubble) {
                symbolsize = ((symbolsize == null || symbolsize == "") ?
                        (pInt((plotoptions != null) ? $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("strokeWidth") : commonPlotOptions.strokeWidth) || 2) :
                        symbolsize) * (isPolar ? 0.56 : 0.7);
                animationType = (animationType == "vertPathTween" || animationType == "vertPathTweenAll") ? "verticalAll" : animationType;
                animationType = (animationType == "horiPathTween") ? "horizontalAll" : animationType;
                color = currentdata.color || color;
            } else {
                symbolsize = validateNullVal(symbolsize, 1);
                animationType = (animationType == "fadeAll") ? "fade" : animationType;
            }
            
            var symbolpath = getSVGsymbol(symboltype, symbolsize),
                multiColoring = scatterOrBubble ? ($ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("multiColoring") && !chartObj.legendarea.show) : false,
                outersize = symbolsize * 10,
                initial_outerFillOpacity = (animationType == "fade") ? 0 : markerOptions.outerFillOpacity,
                initial_outerStrokeOpacity = (animationType == "fade") ? 0 : markerOptions.outerStrokeOpacity,
                initial_innerFillOpacity = (animationType == "fade") ? 0 : markerOptions.innerFillOpacity,
                initial_innerStrokeOpacity = (animationType == "fade") ? 0 : markerOptions.innerStrokeOpacity,
                hasImage = (markerOptions.imageUrl != null && markerOptions.imageUrl !== ""),
                imageConf = {
                    "name": markerOptions.imageUrl
                },
                outerDashArray = getDashArray(markerOptions.outerDashStyle, markerOptions.outerStrokeWidth),
                innerDashArray = getDashArray(markerOptions.innerDashStyle, markerOptions.innerStrokeWidth),
                outerStrokeLineCap = getLineCap(markerOptions.outerLineCap, markerOptions.outerDashStyle),
                innerStrokeLineCap = getLineCap(markerOptions.innerLineCap, markerOptions.innerDashStyle);

            var fillColor = chart.fillColorFunc = getFillColor(chartObj, index, null, (scatterOrBubble ? null : true)),
                strokeColor = getStrokeColor(chartObj, index);
            
            chart.seriesdataAfterUpdate = [];
            var datatypeX = chartObj.dataset.getDataType("x"),
                datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),

                xCategories = (datatypeX == ORDINAL_DATATYPE) ? xscale.domain() : null,
                yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

                categories = (datatypeX == ORDINAL_DATATYPE && xscale.domain != null && !defined(chartObj.dataObject.hierarchical)) ? xCategories : chartObj.dataObject.getCategories("x");
            
            currentseriesdata.forEach(function(d, i) {
                
                var dataUpdate;
                if (datatypeX == ORDINAL_DATATYPE || datatypeY == ORDINAL_DATATYPE) {
                    dataUpdate = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(d), xCategories, yCategories, yaxiscolumnorder);
                } else {
                    dataUpdate = d;
                }

                if (chartObj.brush && chartObj.brush.extent) {
                    var domain = chartObj.axes.x.scale.domain();
                    var ticks = chartObj.axes.x.ticks.tickValueObj.ticks;
                    var startVal = (datatypeX == TIME_DATATYPE) ? domain[0].getTime() : (datatypeX == ORDINAL_DATATYPE) ? categories.indexOf(domain[0]) : domain[0];
                    var endVal = (datatypeX == TIME_DATATYPE) ? domain[1].getTime() : (datatypeX == ORDINAL_DATATYPE) ? categories.indexOf(domain[domain.length - 1]) : domain[1];
                    var accessor = (datatypeX == ORDINAL_DATATYPE) ? function(d) {
                            return categories.indexOf(chartObj.dataset.getX(d))
                        } : function(d) {
                            return chartObj.dataset.getX(d)
                        }
                    dataUpdate = dataProcessorHelpers.filterDataToViewPort(dataUpdate, startVal, endVal, accessor);
                }
                
                chart.seriesdataAfterUpdate[i] = dataUpdate;
                var ishideable = currentdata.disabled;
                var serData, baseData, basedataShift;
                
                if (animationType == "pointbypoint" || animationType == "pointTween") {
                    serData = dataUpdate;
                    if (xReversed) {
                        serData = serData.slice(0).reverse();
                    }
                    baseData = serData;
                    if (animationType == "pointTween") {
                        baseData = serData.map(function(d, i) {
                            return Object.create(serData[0])
                        });
                    } else if (animationType == "pointbypoint") {
                        var baseIdx = (isPolar && yReversed && !stacked) ? yscale.domain().length - 1 : 0;
                        baseData = serData.map(function(d, i) {
                            var s = Object.create(d);
                            var baseY = (!isPolar && (hasNegValue != null) && (yscale(hasNegValue) != null)) ? mathMax(hasNegValue, yscale.domain()[0]) : yscale.domain()[baseIdx];
                            if (stacked) {
                                s.y0 = 0;
                                s.y = baseY;
                            }
                            s[dataset.yidx(yaxiscolumnorder)] = baseY;
                            return s;
                        });
                    }
                    basedataShift = d3_values(baseData);
                }
                
                var subseries = appendEle(series, "g", function(d) {
                    return ishideable ? [] : [dataUpdate];
                }, ".", "class", ('subseries_' + i));
                var scatter = subseries.selectAll('g.scatter').data(function(d) {
                    return d;
                });
                var scatterEnter = scatter.enter().append('g').attr("class", "scatter");
                var noScatters = scatter.size();
                var duration = (animationType != "onebyone") ? transitionDuration : transitionDuration / noScatters,
                    pathData = function(d, i) {
                        return (chartType !== $ZC.charttype.stkdarea) && (!(d) || d.isDummy || isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder))) ?
                            [] :
                            [{
                                color: (multiColoring ? chartObj.seriesColor[i % chartObj.seriesColor.length] : color),
                                index: multiColoring ? i : index,
                                data: d
                            }];
                    };
                
                var outermarkerpath = appendEle(scatterEnter, "path", pathData, ".", "class", "outer");
                outermarkerpath
                    .style({
                        "fill-opacity": initial_outerFillOpacity,
                        "stroke-opacity": initial_outerStrokeOpacity
                    });
                
                var innermarkerpath = appendEle(scatterEnter, "path", (hasImage ? [] : pathData), ".", "class", "inner");
                innermarkerpath
                    .style({
                        "fill-opacity": initial_innerFillOpacity,
                        "stroke-opacity": initial_innerStrokeOpacity
                    });
                
                if (isAnimationEnable) {
                    if ((animationType == "pointbypoint" || animationType == "pointTween")) {
                        interTween(baseData, basedataShift, serData, categories, animationType, easingType, transitionDuration, rp, function(d) {
                            return {
                                "transform": function(dt, i) {
                                    return "translate(" + getInitialX(d[i]) + "," + getInitialY(d[i]) + ")";
                                }
                            }
                        }, scatterEnter, "scatter");
                    } else {
                        scatterEnter
                            .attr("transform", function(d, i) {
                                return "translate(" + getInitialX(d) + "," + getInitialY(d) + ")" + ((hasImage && animationType === "sizing") ? " scale(0)" : "");
                            })
                            .transition()
                            .delay(function(d, i) {
                                return (animationType == "onebyone") ? (i * duration) : 0;
                            })
                            .duration(duration)
                            .ease(easingType)
                            .attr("transform", function(d) {
                                return "translate(" + chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos) + "," + chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos) + ")";
                            });
                    }
                }
                var scatterUpdate = scatter;
                // if(scatterEnter.node() == null || !isAnimationEnable){ //doubt : Why scatterEnter.node() == null?
                scatterUpdate
                    .transition()
                    .delay(function(d, i) {
                        return ((animationType == "pointbypoint" || animationType == "pointTween") && scatterEnter.node() != null) ?
                            transitionDuration :
                            ((animationType == "onebyone") ? (i * duration) : 0);
                    })
                    .duration(duration)
                    .ease(easingType)
                    .attr("transform", function(d) {
                        return "translate(" + chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos) + "," + chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos) + ")";
                    });
                // }
                
                var outermarkerpathUpdate = scatterUpdate.selectAll("path.outer")
                    .attr("d", function(d, i) {
                        var previousSize = d3_select(this.parentNode).attr("size");
                        var s = (previousSize != null) ? previousSize : ((animationType == "sizing" && !hasImage) ? 0 : getSymbolSize(d.data));
                        return symbolpath(s);
                    })
                    .style({
                        "stroke-width": markerOptions.outerStrokeWidth,
                        "fill": function(d, i) {
                            var size = getSymbolSize(d.data);
                            if (hasImage) {
                                imageConf.width = imageConf.height = parseFloat(size);
                                imageConf.x = imageConf.y = -parseFloat(size) / 2;
                                return "url(" + defsLocation + "#" + effects.get(svg_patterns,"imageFill", imageConf) + ")";
                            }

                            var radius = size / 2;
                            return fillColor(d.index, d.data, null, markerOptions.outerFillColor,null, (scatterOrBubble ? [radius, radius] : null));
                        },
                        "stroke": function(d, i) {
                            return strokeColor(d.index, d.data, markerOptions.outerStrokeColor);
                        },
                        "stroke-dasharray": outerDashArray,
                        "stroke-linecap": outerStrokeLineCap
                    });
                
                var innermarkerpathUpdate = scatterUpdate.selectAll("path.inner")
                    .attr("d", function(d, i) {
                        var previousSize = d3_select(this.parentNode).attr("size");
                        var s = (previousSize != null) ? previousSize : ((animationType == "sizing" && !hasImage) ? 0 : getSymbolSize(d.data));
                        return symbolpath(s / 2);
                    })
                    .style({
                        "stroke-width": markerOptions.innerStrokeWidth,
                        "fill": function(d, i) {
                            var radius = getSymbolSize(d.data) / 4;
                            return fillColor(d.index, d.data, null, markerOptions.innerFillColor,null, (scatterOrBubble ? [radius, radius] : null));
                        },
                        "stroke": function(d, i) {
                            return strokeColor(d.index, d.data, markerOptions.innerStrokeColor);;
                        },
                        "stroke-dasharray": innerDashArray,
                        "stroke-linecap": innerStrokeLineCap
                    });
                
                outermarkerpathUpdate.transition().duration(duration).ease(easingType)
                    .attr("d", function(d) {
                        return symbolpath(getSymbolSize(d.data));
                    })
                    .style({
                        "fill-opacity": markerOptions.outerFillOpacity,
                        "stroke-opacity": markerOptions.outerStrokeOpacity
                    });
                innermarkerpathUpdate.transition().duration(duration).ease(easingType)
                    .attr("d", function(d) {
                        return symbolpath(getSymbolSize(d.data) / 2);
                    })
                    .style({
                        "fill-opacity": markerOptions.innerFillOpacity,
                        "stroke-opacity": markerOptions.innerStrokeOpacity
                    });
                
                var blinkConf = ((plotoptions && plotoptions.animation && plotoptions.animation.blink) ?
                            mergeJSON(commonPlotOptions.animation.blink, plotoptions.animation.blink, true) :
                            commonPlotOptions.animation.blink) || {},
                    blinkEnabled = blinkConf.enabled;
                if (blinkEnabled) {
                    blinkSVGsymbols(scatter.selectAll(".outer,.inner"), blinkConf);
                }
                
                scatter.attr("size", function(d) {
                    return getSymbolSize(d);
                }); //Saving the size, makes redraw animation cool
                scatter.exit().remove();
                
                function getInitialX(d) {
                    switch (animationType) {
                        case "verticalAll":
                            var baseX = ((hasNegValue != null) && (yscale(hasNegValue) != null)) ? yscale(mathMax(hasNegValue, yscale.domain()[0])) : yscale.range()[0];
                            return axisrotated ? baseX : chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos);
                        case "horizontalAll":
                            var baseX = (((hasNegValue != null) && (xscale(hasNegValue) != null)) ? xscale(mathMax(hasNegValue, xscale.domain()[0])) : xscale.range()[0]) + ((xscale.rangeBand != null) ? xscale.rangeBand() / 2 : 0);
                            return axisrotated ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos) : baseX;
                        case "fade":
                        case "sizing":
                        case "pointTween":
                        case "pointbypoint":
                        case "strokeTween":
                            return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos);
                        default:
                            var range = (axisrotated ? yscale : xscale).range();
                            var pos = ((axisrotated && yReversed) || (!axisrotated && xReversed)) ? range.length - 1 : 0;
                            return range[pos];
                    }
                }
                
                function getInitialY(d) {
                    switch (animationType) {
                        case "verticalAll":
                            var baseY = ((hasNegValue != null) && (yscale(hasNegValue) != null)) ? yscale(mathMax(hasNegValue, yscale.domain()[0])) : yscale.range()[0];
                            return axisrotated ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos) : baseY;
                        case "horizontalAll":
                            var baseX = (((hasNegValue != null) && (xscale(hasNegValue) != null)) ? xscale(mathMax(hasNegValue, xscale.domain()[0])) : xscale.range()[0]) + ((xscale.rangeBand != null) ? xscale.rangeBand() / 2 : 0);
                            return axisrotated ? baseX : chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos);
                        case "fade":
                        case "sizing":
                        case "pointTween":
                        case "pointbypoint":
                        case "strokeTween":
                            return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos);
                        default:
                            var range = (axisrotated ? xscale : yscale).range();
                            var pos = ((axisrotated && xReversed) || (!axisrotated && yReversed)) ? range.length - 1 : 0;
                            return range[pos];
                    }
                }
                
                function getSymbolSize(d) {
                    return chartType !== $ZC.charttype.stkdarea && (isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder))) ?
                        0 :
                        isBubbleChart ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "z", chartObj.zscale, yrangePos) : outersize;
                }

                //Assign renderer functions
                chart.getSymbolSize = getSymbolSize;
            });
            if ($ZC.labelRenderer != null) {
                var markerSize;
                if (scatterOrBubble || isBubbleChart) {
                    markerSize = outersize + (markerOptions.outerStrokeWidth);
                } else {
                    var strokeWidth = validateNullVal($ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("strokeWidth"), 2);
                    markerSize = ((markerOptions.size || strokeWidth) * outersize * 0.5) + strokeWidth / 2;
                }
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "scatter",
                    "chartObj": chartObj,
                    "args": [currentdata, index, markerSize, yrangePos]
                });
            }
            
            chart.renderedTimer = setTimeout(function() {
                redraw = true;
                chart.chartRendered = true;
            }, (transitionDuration));
        });
        return chart;
    }

    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };

    chart.yrangePos = function(_) {
        if (!arguments.length) {
            return yrangePos;
        }
        yrangePos = _;
        return chart;
    };
    return chart;
}//$Id$
function arcInnerTween(element, arc, innerRadius, outerRadius) {
    element.attrTween("d", function(d, i) {
        var interpolateOuterRadius = d3.interpolate(outerRadius[0], outerRadius[1]);
        var interpolateInnerRadius = d3.interpolate(innerRadius[0], innerRadius[1]);

        return function(t) {
            arc.outerRadius(interpolateOuterRadius(t));
            arc.innerRadius(interpolateInnerRadius(t));
            return arc(d);
        };
    });
}
//$Id$
/**
 *
 * @returns {chart} pie renderer.
 */
svg_plot_renderer.pie = function() {
    var MAXWIDTH_DATALABELS = 0.3;
    var pie = d3_pie().sort(null),
        arc = d3_arc(),
        sliceOut = function(d) {
            return polarToXY(sliceOutHeight, (d.startAngle + d.endAngle) / 2);
        },
        isredraw = false,
        InsidelabelTextGroup,
        labelLinkGroup,
        labelTextGroup,
        innerBoundBoxGroup,
        boundBoxGroup,
        hasNegValue,
        hasPreviousNegValue,
        gElementsCollected,
        hasBoundBox,
        previousRadiusFactors,
        previousInnerRadius,
        previousOuterRadius,
        baseValue;
    var commonRendererProp, chartObj, outerRadius, innerRadius, totalEngagement, padding, color, container, piegroup, chartheight, chartwidth, pieArcs;
    var oldData, arcLabel, commonPlotOptions, systemconf, notesArray, isDial;
    var rad, OR, strokeWidth, strokeWid, noofNonZeroDatas, sliceOutHeight;
    var modelOptions, transX, transY, customPlotarea, plotarea, dataindex;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                notesArray = rp.notesArray,
                systemconf = chartObj.systemConf;
            var labelQueue = rp.labelQueue,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset,
                index = rp.datasetIndex || 0; //For pie,dial char, rp.datasetIndex is undefined
            
            var defsLocation = chartObj.defsLocation,
                serData = chartObj.seriesdata[index],
                currentRadiusFactors = commonPlotOptions.maxRadius + " _ " + commonPlotOptions.outerPadding + " _ " + commonPlotOptions.innerRadius;

            var chartName = chartObj.chartTypes[index].name;
            isDial = chartName === "dial";
            var isPie = chartName === "pie",
                isBubblePie = !isDial && !isPie;
            dataindex = isBubblePie ? validateNullVal(commonPlotOptions.dataindex, 3) : dataset.yidx(yaxiscolumnorder);
            
            plotarea = customPlotarea || (isDial ? chartObj.plotarea_approx : chartObj.plotarea);
            chartwidth = plotarea.width,
                chartheight = plotarea.height,
                outerRadius = validateNullVal(plotarea.radius, mathMin(chartwidth, chartheight) / 2);
            gElementsCollected = false;
            
            var plotoptions = serData.plotoptions,
                dataLabels = commonPlotOptions.datalabels,
                gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions);
            
            var maxRadius = validateNullVal(gvp("maxRadius"), 250),
                fillOpacity = gvp("fillOpacity"),
                levelMarkerConf = commonPlotOptions.levelMarker,
                padding = isPie ? +gvp("outerPadding") : 0,
                strokeWidth = gvp("strokeWidth"),
                visibility;
            baseValue = (commonPlotOptions.baseValue !== undefined) ? commonPlotOptions.baseValue : 0
            
            var showlabel = isDatalabelEnabled(dataLabels, chartObj),
                datalabelPadding = showlabel
                                ? (+(dataLabels.padding || 0) + (isBoundBoxEnabled(dataLabels, chartObj) ? ((getBoundBoxPadding(dataLabels, chartObj) + getBoundBoxStrokeWidth(dataLabels, chartObj)) * 2) : 0))
                                : 0,
                extraOptions = {},
                datalabelsWidth = 0;
            hasBoundBox = isBoundBoxEnabled(dataLabels, chartObj);
            
            padding += (isPie ? datalabelPadding : 0);
            rad = mathMin(maxRadius, (outerRadius - padding));
            if (isPie && showlabel) {
                /*
                 *If chart width is lesser than height, datalabels are hidden as default padding is 30 and there is no space to show datalabels.
                 * So 30% of the width is allocated for datalabels and the default padding will be changed to 2
                 */
                var minDatalabelsWidth = chartwidth * MAXWIDTH_DATALABELS,
                    availableDatalabelsWidth = chartwidth - (2 * rad);
                if (availableDatalabelsWidth < minDatalabelsWidth) {
                    datalabelPadding = extraOptions.padding = 5;
                    datalabelsWidth = mathMax((minDatalabelsWidth - availableDatalabelsWidth), 0)
                    rad -= datalabelsWidth / 2;
                }
            }
            innerRadius = getInnerRadius(commonPlotOptions, rad);
            strokeWidth = validateNullVal(strokeWidth, 1);
            
            if (isDial && levelMarkerConf.enabled) {
                var innerPadding,
                    outerPadding;

                if (defined(commonPlotOptions.bandWidth) || defined(commonPlotOptions.maxBandWidth)) {
                    var maxDialBandWidth = validateNullVal(commonPlotOptions.maxBandWidth, rad);
                    var dialBandWidth = mathMin(perToPx(commonPlotOptions.bandWidth, rad, (rad - innerRadius)), maxDialBandWidth);

                    innerPadding = -((rad -  innerRadius) - dialBandWidth) / 2,
                    outerPadding = -((rad -  innerRadius) - dialBandWidth) / 2;

                    visibility = (dialBandWidth === 0) ? "hidden" : null;
                } else {
                    innerPadding = mathMin(0, perToPx(levelMarkerConf.innerPadding, outerRadius, 0)),
                    outerPadding = mathMin(0, perToPx(levelMarkerConf.outerPadding, outerRadius, 0))
                }

                rad += outerPadding;
                innerRadius -= innerPadding;
            }

            rad -= 0.5 * strokeWidth;
            OR = mathMax(innerRadius, rad);
            modelOptions = ((plotoptions && plotoptions.models) ? mergeJSON(commonPlotOptions.models, plotoptions.models, true) : commonPlotOptions.models) || {};
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, chartName);
            var isAnimationEnable = animationOptions.enabled,
                transitionDuration = !isAnimationEnable ? 0 : (isredraw ? 200 : animationOptions.duration),
                easingType = animationOptions.easingType,
                animationType = animationOptions.type;
            
            var eventDisabled = (validateNullVal(getEventConf(plotoptions, commonPlotOptions, chartObj, "enabled"), true) == false);
            var cursor = (eventDisabled) ? null : getEventConf(plotoptions, commonPlotOptions, chartObj, "cursor") || "pointer";
            
            container = d3_select(this);
            piegroup = appendEle(container, "g", [data], ".", "class", "piegroup");
            piegroup.style({
                "stroke-width": strokeWidth,
                "fill-opacity": gvp("fillOpacity"),
                "stroke-opacity": commonPlotOptions.strokeOpacity,
                "cursor": cursor,
                "visibility": visibility
            });
            
            pie
                .startAngle(commonPlotOptions.startAngle)
                .endAngle(commonPlotOptions.endAngle)
                .value(function(d) {
                    return d.disabled ? 0 : mathAbs(d[dataindex] || 0);
                }); //d[dataindex] || 0 --> Why || 0 is, it may contain undefined Y value
            var pieData = pie(data = isBubblePie ? data : serData.data[0]);
            chart.data = pieData;
            
            noofNonZeroDatas = pieData.reduce(function(prev, cur, i) {
                return prev + (cur.value ? 1 : 0)
            }, 0);
            chart.total = totalEngagement = pieData.reduce(function(prev, cur, i) {
                return prev + cur.value
            }, 0);
            chart.arc = arc;
            
            var stacked = true;
            if (stacked) {
                arc
                    .outerRadius(OR)
                    .innerRadius(innerRadius);
            } else {
                var interPadding = perToPx(levelMarkerConf.interPadding, OR, 10),
                    len = data.length;
                var band = ((OR - innerRadius) - ((len - 1) * interPadding)) / len;
                arc
                    .innerRadius(function(d, i) {
                        return (i * (band + interPadding)) + innerRadius;
                    })
                    .outerRadius(function(d, i) {
                        return ((i + 1) * band) + (i * interPadding) + innerRadius;
                    })
                    .startAngle(commonPlotOptions.startAngle)
                    .endAngle(function(d) {
                        return d.endAngle;
                    });
            }
            arcLabel = d3_arc().innerRadius(OR).outerRadius(OR + datalabelPadding);
            var arcLabel1 = d3_arc().innerRadius(OR).outerRadius(OR);
            
            // translating the piegroup to center
            strokeWid = strokeWidth;
            var bb = translateWrap(piegroup);
            //calculating new radius
            var heightPercent = ((bb.height + strokeWidth) / rad),
                widthPercent = ((bb.width + strokeWidth) / rad);
            var newrad = rad + mathMin(((chartwidth - (2 * padding) - datalabelsWidth - (bb.width + strokeWidth)) / widthPercent), ((chartheight - (2 * padding) - datalabelsWidth - (bb.height + strokeWidth)) / heightPercent));
            newrad = mathMin(maxRadius, mathMax(rad, newrad));
            if (isDial) {
                currentRadiusFactors += " _ " + commonPlotOptions.bandWidth + " _ " + levelMarkerConf.bandWidth + " _ " + levelMarkerConf.innerPadding + " _ " + levelMarkerConf.outerPadding;

                var yscale = chartObj.axes.y.groups[0].scale;
                var minMax = yscale.domain();
                // var prev = yscale.domain()[0];
                pieData.forEach(function(d) {
                    // d.startAngle = yscale(prev);
                    // d.endAngle = yscale(prev + d.value);
                    // prev += d.value;
                    var val = d.data[dataindex];
                    hasPreviousNegValue = hasNegValue
                    if (hasNegValue = (val < 0)) { // Test_529.json
                        d.startAngle = yscale((baseValue != null) ? Math.min(baseValue, minMax[1]) : minMax[1]);
                        d.endAngle = yscale(Math.max(val, minMax[0]));
                    } else {
                        d.startAngle = yscale( (baseValue != null) ? Math.max(baseValue, minMax[0]) : minMax[0] );
                        d.endAngle = yscale( Math.min(d.value, minMax[1])) ;
                    }
                });
            } else if (newrad != rad) { // updating values based on new radius
                rad = newrad;
                innerRadius = getInnerRadius(commonPlotOptions, rad);
                OR = mathMax(innerRadius, rad);
                arc.outerRadius(OR).innerRadius(innerRadius);
                arcLabel = d3_arc().innerRadius(OR).outerRadius(OR + datalabelPadding);
                arcLabel1 = d3_arc().innerRadius(OR).outerRadius(OR);
                translateWrap(piegroup);
            }
            
            var modelID = (!isDial && modelOptions.type) ? "url(" + defsLocation + "#" + createModelClippath(getModelPath()) + ")" : null;
            var gradientDim = [OR, OR];
            var fillColor = chart.fillColorFunc = getFillColor(chartObj, index, gradientDim),
                strokeColor = getStrokeColor(chartObj, 0);

            sliceOutHeight = perToPx(gvp("sliceOutHeight"), rad, 0) * 2;
            
            oldData = piegroup.selectAll("path").data();
            
            pieArcs = appendEle(piegroup, "path", pieData);
            pieArcs
                .attr({
                    "clip-path": modelID,
                    "id": function(d, i) {
                        return "arc_" + i;
                    }
                })
                .style({
                    "display": "block",
                    "fill": function(d, i) {
                        return fillColor(i, d.data);
                    },
                    "stroke": function(d, i) {
                        return strokeColor(i, d.data, commonPlotOptions.strokeColor);
                    }
                });
            
            if (!eventDisabled) {
                var mousemove = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.mouseMove(args);
                    },
                    mouseout = function(d, i) {
                        chartObj.eventHandler.mouseOut(chart, d, i);
                    },
                    click = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.click(chart, d, 0, i, args);
                    },
                    dblclick = function(d, i) {
                        var data = $ZC.annotation ? generateDataForAnnotation(d.data, null) : d.data;
                        var coordinates = arcLabel.centroid(d);
                        coordinates = [(coordinates[0] + transX), (coordinates[1] + transY)];
                        var args = {
                            "coordinate": coordinates,
                            "data": data,
                            "basedOn": "plot"
                        };
                        chartObj.eventHandler.doubleclick(d, i, args);
                    },
                    eventAttacherOptions = {
                        target: "plot",
                        touchleave: true,
                        chartObj: chartObj
                    };
                var mouseHandlers = {
                    "mousemove": mousemove,
                    "mouseout": mouseout,
                    "click": click,
                    "dblclick": dblclick
                },
                touchHandlers = {
                    "singletouchmove": mousemove,
                    "touchend": mouseout,
                    "tap": click,
                    "dbltap": dblclick
                };
                attachevents(pieArcs, mouseHandlers, touchHandlers, eventAttacherOptions);
            }
            
            if (/(\D)+onebyone/.test(animationType) && !isredraw) {
                var isFan = (animationType == "fanonebyone");
                var duration = isFan ? transitionDuration : (transitionDuration / noofNonZeroDatas)
                var prev = 0;
                pieArcs
                    .transition()
                    .ease(easingType)
                    .duration(function(d) {
                        return isFan ? (duration * (d.value / totalEngagement)) : duration;
                    })
                    .delay(function(d) {
                        var dur = duration * prev;
                        prev += isFan ? (d.value / totalEngagement) : 1;
                        return dur;
                    })
                    .call(isFan ? arcTween : innerTween);
            } else {
                var tweenType;
                if (isredraw) {
                    tweenType = (currentRadiusFactors != previousRadiusFactors) ? innerTween : fanAllTween
                } else {
                    tweenType = (animationType == "fanAll") ? fanAllTween : (animationType == "inner" ? innerTween : arcTween)
                }

                pieArcs
                    .transition()
                    .duration(transitionDuration)
                    .ease(easingType)
                    .call(tweenType)
                    .each("end", function(d) {
                        var disabled = d.data.disabled || (d.startAngle === d.endAngle);// if disabled or value = 0 | null
                        d3_select(this).style("display", (disabled ? "none" : "block"));
                    });
            }
            chart.renderedTimer = setTimeout(function() {
                previousRadiusFactors = currentRadiusFactors;
                previousInnerRadius = innerRadius;
                previousOuterRadius = OR;
                if (isDial) {
                    chartObj.renderer[0].endFunctions();
                } else {
                    pieArcs.style("display", function(d) {
                        return (d.data.disabled || !d.value) ? "none" : null
                    });
                    if ($ZC.labelRenderer && !isBubblePie) {
                        var translation = [transX, transY];
                        var args = [piegroup.datum(), 0, pieData, OR, totalEngagement, arcLabel, arcLabel1, arc, translation, extraOptions];
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "pie",
                            "chartObj": chartObj,
                            "args": args
                        });
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "pieInnerLabels",
                            "chartObj": chartObj,
                            "args": args
                        });
                    }
                }
                
                //Annotation preprocessing
                if ($ZC.annotation && !isBubblePie) {
                    notesArray = $ZC.annotation.preprocessAnnotations(chartObj.seriesdata, 0, function(dt, k, j) {
                        var c = arcLabel.centroid(pieData[j]);
                        return [(c[0] + transX), (c[1] + transY)];
                    }, notesArray, chartObj, rp);
                }
                chart.chartRendered = true;
                isredraw = true;
            }, transitionDuration + (1000 / 60));

            function getEventArgs(d, i) {
                var ev = getEventObject(d3.event);
                return {
                    "renderer": chart,
                    "seriesPos": 0,
                    "subseriesPos": 0,
                    "itemPos": i,
                    "color": color[i % color.length],
                    "coordinates": [ev.pageX, ev.pageY],
                    "element": this,
                    "data": d
                };
            }
        });
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.plotarea = function(_) { //Bubble Pie chart will give you the plotarea
        if (!arguments.length) {
            return customPlotarea || plotarea;
        }
        customPlotarea = _;
        return chart;
    };
    
    chart.innerRadius = function(_) {
        if (!arguments.length) {
            return innerRadius;
        }
        innerRadius = _;
        return chart;
    };
    
    chart.defaultMouseOverFunc = function(d, seriesPos, itemPos) {
        if (noofNonZeroDatas == 1) {
            return;
        }
        
        if (!gElementsCollected) {
            collectGroups();
        }

        var pt = sliceOut(d);
        var slicedPosition = {
                "transform":  "translate(" + pt[0] + "," + pt[1] + ")"
            };
        
        pieArcs
            .transition()
            .ease("linear")
            .attr("transform", "translate(0,0)");

        piegroup.selectAll("#arc_" + itemPos)
            .transition()
            .ease("linear")
            .attr(slicedPosition);
        
        InsidelabelTextGroup.selectAll("#innerlbl0_0_" + itemPos)
            .transition()
            .ease("linear")
            .attr(slicedPosition);
        
        if (!hasBoundBox) {
            labelLinkGroup.selectAll("#link0_0_" + itemPos)
                .style("stroke-width", (3 * chart.lineStrokeWidth));
        }
        
        if (chart.showlabel == "circular") {
            labelTextGroup.selectAll("#lbl0_0_" + itemPos)
                .transition()
                .ease("linear")
                .attr(slicedPosition);
            
            boundBoxGroup.selectAll("#boundboxlbl0_0_" + itemPos)
                .transition()
                .ease("linear")
                .attr(slicedPosition);
        }
        labelTextGroup.selectAll("#lbl0_0_" + itemPos)
            .style("text-shadow", "0 0 0 rgba(0,0,0,1)");
        
        innerBoundBoxGroup.selectAll("#boundboxinnerlbl0_0_" + itemPos)
            .transition()
            .ease("linear")
            .attr(slicedPosition);
    };
    
    chart.defaultMouseOutFunc = function(d, i, forceMouseOut) {
        if (!gElementsCollected) {
            collectGroups();
        }

        var actualPosition = {
                "transform": "translate(0,0)"
            };

        labelTextGroup.selectAll("text")
            .style("text-shadow", null);
        if (!hasBoundBox) {
            labelLinkGroup.selectAll("path")
                .style("stroke-width", chart.lineStrokeWidth);
        }

        if (!clickedTime && forceMouseOut) {
            pieArcs
                .attr(actualPosition);

            InsidelabelTextGroup.selectAll("text")
                .attr(actualPosition);

            innerBoundBoxGroup.selectAll("path")
                .attr(actualPosition);

            if (chart.showlabel == "circular") {
                labelTextGroup.selectAll("text")
                    .attr(actualPosition);
                
                boundBoxGroup.selectAll("path")
                    .attr(actualPosition);
            }
            return;
        }
        pieArcs
            .transition()
            .ease("linear")
            .attr(actualPosition);
        
        InsidelabelTextGroup.selectAll("text")
            .transition()
            .ease("linear")
            .attr(actualPosition);
        
        
        if (chart.showlabel == "circular") {
            labelTextGroup.selectAll("text")
                .transition()
                .ease("linear")
                .attr(actualPosition);
            
            boundBoxGroup.selectAll("path")
                .transition()
                .ease("linear")
                .attr(actualPosition);
        }
        
        innerBoundBoxGroup.selectAll("path")
            .transition()
            .ease("linear")
            .attr(actualPosition);
    };
    
    function getGearData(count) {
        var array = [],
            data = [],
            x = 0;
        for (var i = 0; i < count; i++) {
            (modelOptions.type == "gear1") ? data.push([x++, 0], [x++, 1], [x++, 1]) : data.push([x, 0], [x++, 1], [x, 1], [x++, 0]);
        }
        array.push(data);
        return array;
    }
    
    function getModelPath() {
        var index = -1,
            count = modelOptions.count,
            min = (modelOptions.type == "zigzag") ? (-50 + innerRadius / 5) : ((modelOptions.type == "sun") ? -1 : -10);
        var gearData = getGearData(count);
        var angleScale = d3_scaleLinear().range([0, 2 * mathPI]).domain([0, ((modelOptions.type == "gear1") ? (3 * count) : (2 * count))]);
        var radiusScale = d3_scaleLinear().range([innerRadius, OR]).domain([min, 1]);
        var radialLine = d3_lineRadial().interpolate("linear-closed").radius(function(d) {
                return radiusScale(d[1]);
            })
            .angle(function(d, i) {
                index = (modelOptions.type == "gear") ? ((i % 2 == 0) ? (index + 1) : index) : ((modelOptions.type != "gear1") ? ((i % 2 != 0) ? (index + 1) : index) : index);
                return angleScale((modelOptions.type == "gear1") ? index++ : index);
            });
        return radialLine(gearData[0]);
    }
    
    function createModelClippath(gearPath) {
        var properties = {
            name: "pieModels",
            id: chartObj.id,
            d: gearPath
        },
        args = {
            chartObj: chartObj
        };
        var clipID = effects.get(svg_clips, "polygon", properties, args);
        return clipID;
    }
    
    function innerTween(element) {
        arcInnerTween(element, arc, [(isredraw ? previousInnerRadius : innerRadius), innerRadius], [(isredraw ? previousOuterRadius : innerRadius), OR]);
    }
    
    function arcTween(transition) {
        transition.attrTween("d", function(d, i) {
            var interpolate = d3_interpolate(d.startAngle, d.endAngle);
            return function(t) {
                d.endAngle = interpolate(t);
                return arc(d);
            };
        });
    }
    
    function fanAllTween(transition) {
        transition.attrTween("d", function(d, i) {
            var od = oldData[i] || oldData[oldData.length - 1],
                prevEA,
                prevSA;
            
            if (hasNegValue) {
                prevEA = (isredraw && od && hasPreviousNegValue) ? od.endAngle : d.startAngle,
                    prevSA = (isredraw && od && hasPreviousNegValue) ? od.startAngle : d.startAngle;
            } else {
                prevEA = (isredraw && od && !hasPreviousNegValue) ? od.endAngle : (isDial ? d.startAngle : commonPlotOptions.startAngle),
                prevSA = (isredraw && od && !hasPreviousNegValue) ? (oldData[i] ? od.startAngle : od.endAngle) : (isDial ? d.startAngle : commonPlotOptions.startAngle);
            }
            
            var interpolate = d3_interpolate(prevEA, d.endAngle);
            var interpolate1 = d3_interpolate(prevSA, d.startAngle);
            
            return function(t) {
                d.endAngle = interpolate(t) || 0;
                d.startAngle = interpolate1(t) || 0;
                return arc(d, i);
            };
        });
    }
    
    function translateWrap(wrap) {
        //dummy data
        var dummyData = [];
        dummyData[dataindex] = 1;
        
        //dummy pie for getting the bound
        var dummy = container.append("path")
            .attr("d", arc(pie([dummyData])[0], chart.data.length - 1))
            .style({
                "fill": "none",
                "stroke": "none"
            });
        var bb = bbox(dummy.node());
        dummy.remove();
        
        //Reference point calculation for pie layout
        var pt = polarRefPoint(bb, chartwidth, chartheight, rad, strokeWid);
        transX = isDial ? plotarea.x : pt[0],
            transY = isDial ? plotarea.y : pt[1];
        wrap.attr("transform", function(d, i) {
            return "translate(" + transX + "," + transY + ")"
        });
        return bb;
    }
    
    function collectGroups() {
        InsidelabelTextGroup = InsidelabelTextGroup || chartObj.staticPaneSVG.selectAll("g.innerlabel_0");
        labelLinkGroup = labelLinkGroup || chartObj.staticPaneSVG.selectAll("g.link_0");
        labelTextGroup = labelTextGroup || chartObj.staticPaneSVG.selectAll("g.label_0");
        boundBoxGroup = boundBoxGroup || chartObj.staticPaneSVG.selectAll("g.boundboxseries_0");
        innerBoundBoxGroup = innerBoundBoxGroup || chartObj.staticPaneSVG.selectAll("g.innerboundboxseries_0");
        gElementsCollected = true;
    }
    
    return chart;
};//$Id$
/**
 *
 * @returns {chart} funnel renderer.
 */
svg_plot_renderer.funnel = function() {
    var MAXWIDTH_DATALABELS = 0.3;
    var cfg = {};
    var commonRendererProp, chartObj, data_processed, noofNonZeroDatas, coneHeigth, noOfGaps, stemHeight, stemWidth, xAxisWidth, dataset, percentage = 0.375,
        chartWidth, totalEngagement, trapezoid, chartHeight, color, funnelsections, ellipseSections;
    var threeDimension, arcHeight, arcHeight1,
        padding, minPadding, maxPadding,
        minArcHeight = 1,
        isredraw = false,
        arcCorrection = 0,
        container, ellipse, funnel, label, labelLinkgroup, rightXscale, leftXscale, yaxiscolumnorder;
    var plotoptions, commonPlotOptions, systemconf, notesArray, datalabelPadding, isSplit, outerPadding, gradientDim, isPatternPalleteEnabled;
    var maxPer, isWeightedWidth, noWeighted, defsLocation, rp,
        gElementsCollected,
        fillColor;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                notesArray = rp.notesArray,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset;
            systemconf = chartObj.systemConf;
            var labelQueue = rp.labelQueue;
            
            defsLocation = chartObj.defsLocation;
            
            chartWidth = chartObj.plotarea.width,
                chartHeight = chartObj.plotarea.height;
            gElementsCollected = false;
            
            plotoptions = data[0].plotoptions;
            var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions);
            isPatternPalleteEnabled = systemconf.legend.imagePallete || hasPatternPallete(chartObj);
            cfg.canOverlap = gvp("canOverlap");
            isSplit = gvp("split");
            threeDimension = gvp("threeDimension");
            var emptyFunnelOptions = commonPlotOptions.emptyFunnel;
            datalabelPadding = commonPlotOptions.datalabels.padding;
            var showlabel = isDatalabelEnabled(commonPlotOptions.datalabels, chartObj);
            
            var strokeColor = getStrokeColor(chartObj, 0);

            minPadding = pick(commonPlotOptions.minPadding, (threeDimension ? 4 : 1));
            maxPadding = pick(commonPlotOptions.maxPadding, 10);
 
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, "funnel");
            var animationType = animationOptions.type,
                easingType = animationOptions.easingType,
                isAnimationEnable = animationOptions.enabled,
                transitionDuration = animationOptions.duration;
            var redrawDuration = isAnimationEnable ? 200 : 0
            
            outerPadding = perToPx(gvp("outerPadding"), chartHeight, 0) / 2;
            stemHeight = gvp("stemHeight");
            stemWidth = gvp("stemWidth");
            isWeightedWidth = (gvp("weighted") === "width"),
                noWeighted = (gvp("weighted") === "none");
            
            if (isWeightedWidth) {
                stemHeight = stemWidth = 0;
                isSplit = true;
            }
            
            data_processed = data = data[0].data[0];
            noofNonZeroDatas = data_processed.reduce(function(prev, cur, i) {
                return prev + ((dataset.getY(cur, yaxiscolumnorder) && !cur.disabled) ? 1 : 0)
            }, 0);
            noOfGaps = noofNonZeroDatas - 1;
            var preArcHeight = preCalArcHeight();
            cfg.height = chartHeight - (2 * preArcHeight) - (chartHeight * 0.01) - (2 * outerPadding);
            
            var coneWidth = gvp("coneWidth");
            coneWidth = perToPx(coneWidth, cfg.height, (cfg.height * 0.95));
            cfg.width = mathMin(chartWidth, coneWidth);

            padding = getFunnelPadding(cfg.height);
            cfg.gapHeight = (!isAnimationEnable || isSplit || isredraw) ? padding : ((animationType == "horizontalAll") ? padding : 0);
            
            if ((isWeightedWidth || noWeighted) && defined(commonPlotOptions.maxSliceHeight)) {
                /*
                 * Set max height for each trapezoid if isWeightedWidth or noWeighted
                 */
                cfg.height -= mathMax(0, (cfg.height - (padding * noOfGaps) - (perToPx(commonPlotOptions.maxSliceHeight, cfg.height) * noofNonZeroDatas)));
            }
            if (showlabel) {
                /*
                 *If chart width is lesser than height, datalabels are hidden as default padding is 30 and there is no space to show datalabels.
                 * So 30% of the width is allocated for datalabels and the default padding will be changed to 5
                 */
                var minDatalabelsWidth = chartWidth * MAXWIDTH_DATALABELS,
                    availableDatalabelsWidth = chartWidth - cfg.width;
                if (availableDatalabelsWidth < minDatalabelsWidth) {
                    datalabelPadding = cfg.datalabelPadding = 5;
                    cfg.width -= mathMax((minDatalabelsWidth - availableDatalabelsWidth), 0);
                }
            }
            stemHeight = perToPx(stemHeight, cfg.height, (cfg.height * 0.2));
            xAxisWidth = stemWidth = perToPx(stemWidth, cfg.width, ((stemHeight * cfg.width) / cfg.height)) / 2;
            coneHeigth = cfg.height - stemHeight;
            arcHeight = cfg.height * 0.05;
            
            arcHeight = mathMax(minArcHeight, (arcHeight - data_processed.length) / data_processed.length);
            arcHeight1 = arcHeight = !threeDimension ? 0 : (cfg.canOverlap ? (arcHeight + (maxPadding / 2)) : ((padding / 2) - arcCorrection));
            chart.total = totalEngagement = data_processed.reduce(function(prev, cur, i) {
                return prev + (data_processed[i].disabled ? 0 : mathAbs(dataset.getY(data_processed[i], yaxiscolumnorder) || 0))
            }, 0);
            maxPer = mathMax.apply(null, data_processed.map(function(d, i) {
                return data_processed[i].disabled ? 0 : mathAbs(dataset.getY(data_processed[i], yaxiscolumnorder)) / totalEngagement;
            }));
            leftXscale = d3_scaleLinear()
                .domain(isWeightedWidth ? [0, maxPer] : [stemHeight, cfg.height])
                .range([(cfg.width / 2) - stemWidth, 0]);
            rightXscale = d3_scaleLinear()
                .domain(isWeightedWidth ? [0, maxPer] : [stemHeight, cfg.height])
                .range([(cfg.width / 2) + stemWidth, cfg.width]);
            trapezoid = funnelLayout(data_processed);
            gradientDim = [cfg.width, cfg.height];
            fillColor = chart.fillColorFunc = getFillColor(chartObj, 0, gradientDim);
            
            var eventDisabled = (validateNullVal(getEventConf(plotoptions, commonPlotOptions, chartObj, "enabled"), true) == false);
            var cursor = eventDisabled ? null : getEventConf(plotoptions, commonPlotOptions, chartObj, "cursor") || "pointer";
            
            var containerArea = d3_select(this);
            container = appendEle(containerArea, "g", [data], ".", "class", "funnelgroup");
            container
                .attr("transform", "translate(" + ((chartWidth / 2) - (cfg.width / 2)) + "," + (arcHeight + 2 + outerPadding) + ")")
                .style({
                    "cursor": cursor,
                    "stroke-opacity": gvp("strokeOpacity"),
                    "stroke-width": gvp("strokeWidth")
                });
            ellipse = appendEle(container, "g", [1], ".", "class", "ellipsegroup");
            funnel = appendEle(container, "g", [1], ".", "class", "trapezoidgroup");
            
            funnelsections = appendEle(funnel, "path", data_processed);
            changeSelectionOrder(funnelsections);
            
            funnelsections
                .attr("id", function(d, i) {
                    return "funnel" + i;
                })
                .style({
                    "fill-opacity" : commonPlotOptions.fillOpacity,
                    "fill": function(d, i) {
                        return fillColor(i, d);
                    },
                    "stroke" : function(d, i) {
                        return strokeColor(i, d, commonPlotOptions.strokeColor);
                    }
                });
            
            ellipseSections = appendEle(ellipse, "path", (threeDimension ? data_processed : []));
            changeSelectionOrder(ellipseSections);
            
            ellipseSections
                .attr("id", function(d, i) {
                    return "ellipse" + i;
                })
                .style({
                    "fill-opacity" : commonPlotOptions.fillOpacity,
                    "fill" : function(d, i) {
                        return fillColor(i, d, 0.5);
                    },
                    "stroke" : function(d, i) {
                        return strokeColor(i, d, commonPlotOptions.strokeColor, 0.5);
                    }
                });

            if (!eventDisabled) {
                var mousemove = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.mouseMove(args);
                    },
                    mouseout = function(d, i) {
                        chartObj.eventHandler.mouseOut(chart, d, i);
                    },
                    click = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.click(chart, d, 0, i, args);
                    },
                    dblclick = function(d, i) {
                        var dt = $ZC.annotation ? generateDataForAnnotation(d, null) : d;
                        var coordinates = trapezoid[data.length - 1 - i].bottomLeft;
                        coordinates = [coordinates[0] + ((chartWidth / 2) - (cfg.width / 2)), (coordinates[1] + (arcHeight + 2 + outerPadding))];
                        var args = {
                            "coordinate": coordinates,
                            "data": dt,
                            "basedOn": "plot"
                        };
                        chartObj.eventHandler.doubleclick(d, (data.length - 1 - i), args);
                    },
                    eventAttacherOptions = {
                        target: "plot",
                        touchleave: true,
                        chartObj: chartObj
                    };
                var mouseHandlers = {
                    "mousemove": mousemove,
                    "mouseout": mouseout,
                    "click": click,
                    "dblclick": dblclick
                },
                touchHandlers = {
                    "singletouchmove": mousemove,
                    "touchend": mouseout,
                    "tap": click,
                    "dbltap": dblclick
                };
                attachevents(funnelsections, mouseHandlers, touchHandlers, eventAttacherOptions);
                attachevents(ellipseSections, mouseHandlers, touchHandlers, eventAttacherOptions);
            }
            
            var A = cfg.canOverlap ? (((2 * stemWidth) / cfg.width) * arcHeight) : (arcHeight + arcCorrection);
            var funnelOutline = "M0,0L" + ((cfg.width / 2) - stemWidth) + "," + coneHeigth + "L" + ((cfg.width / 2) - stemWidth) + "," + cfg.height + "A" + stemWidth + "," + A + ",0,0,0," + ((cfg.width / 2) + stemWidth) + "," + cfg.height + "L" + ((cfg.width / 2) + stemWidth) + "," + coneHeigth + "L" + cfg.width + ",0A" + (cfg.width / 2) + "," + arcHeight + ",0,0,0,0,0" + "A" + (cfg.width / 2) + "," + arcHeight + ",0,0,0," + cfg.width + ",0";
            var eFunnel = appendEle(container, "path", ((!isredraw && emptyFunnelOptions.show && isAnimationEnable) ? [1] : []), "#", "id", "emptyFunnel");
            eFunnel
                .attr("d", funnelOutline)
                .style({
                    "stroke": (emptyFunnelOptions.color || "grey"),
                    "fill": "none"
                });
            addFunnelClipPath(funnelOutline);
            if (!isredraw) {
                hideDisabledElements(data, 0);
                var prev = 0,
                    funneldrawn = 0;
                funnelsections
                    .transition()
                    .duration(function(d, i) {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        return (animationType == "vertical") ? ((d.disabled || !yVal) ? 0 : ((isWeightedWidth || noWeighted) ? (transitionDuration / noofNonZeroDatas) : ((mathAbs(yVal)) / totalEngagement) * transitionDuration)) : transitionDuration;
                    })
                    .delay(function(d, i) {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        prev += (d.disabled || !yVal) ? 0 : ((isWeightedWidth || noWeighted) ? (transitionDuration / noofNonZeroDatas) : mathAbs(yVal));
                        var del = (animationType == "vertical") ? ((isWeightedWidth || noWeighted) ? (transitionDuration - prev) : (((totalEngagement - prev) / totalEngagement) * transitionDuration)) : 0;
                        return del || 0;
                    })
                    .ease(easingType)
                    .attrTween("d", function(d, i) {
                        return tweenAll(d, (data_processed.length - 1 - i), "funnel", animationType);
                    })
                    .each("end", function(d, i) {
                        funneldrawn++;
                    });
                prev = 0;
                ellipseSections
                    .transition()
                    .duration(function(d, i) {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        return (animationType == "vertical") ? ((d.disabled || !yVal) ? 0 : ((isWeightedWidth || noWeighted) ? (transitionDuration / noofNonZeroDatas) : ((mathAbs(yVal)) / totalEngagement) * transitionDuration)) : transitionDuration;
                    })
                    .delay(function(d, i) {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        prev += (d.disabled || !yVal) ? 0 : ((isWeightedWidth || noWeighted) ? (transitionDuration / noofNonZeroDatas) : mathAbs(yVal));
                        var del = (animationType == "vertical") ? ((isWeightedWidth || noWeighted) ? (transitionDuration - prev) : (((totalEngagement - prev) / totalEngagement) * transitionDuration)) : 0;
                        return del || 0;
                    })
                    .ease(easingType)
                    .attrTween("d", function(d, i) {
                        return tweenAll(d, (data_processed.length - 1 - i), "ellipse", animationType);
                    });
                var includeGap = setInterval(function() {
                    if (funneldrawn == data_processed.length) {
                        if (animationType != "horizontalAll") {
                            cfg.gapHeight = padding;
                            trapezoid = funnelLayout(data_processed);
                            funnelsections
                                .transition()
                                .duration(isAnimationEnable ? 250 : 0).delay(50)
                                .ease("linear")
                                .attr("d", function(d, i) {
                                    return drawTrapezoid(trapezoid[data_processed.length - 1 - i]);
                                });
                            ellipseSections
                                .transition()
                                .duration(isAnimationEnable ? 250 : 0).delay(50)
                                .ease("linear")
                                .attr("d", function(d, i) {
                                    return drawEllipse(trapezoid[data_processed.length - 1 - i]);
                                });
                        }
                        lableManagent();
                        container.selectAll("path#emptyFunnel").transition().duration(50).delay(310).style("stroke-opacity", 0).remove();
                        clearInterval(includeGap);
                    }
                }, 10);
            } else {
                funnelsections
                    .transition()
                    .duration(redrawDuration)
                    .ease("linear")
                    .attr("d", function(d, i) {
                        return drawTrapezoid(trapezoid[data_processed.length - 1 - i]);
                    });
                ellipseSections
                    .transition()
                    .duration(redrawDuration)
                    .ease("linear")
                    .attr("d", function(d, i) {
                        return drawEllipse(trapezoid[data_processed.length - 1 - i]);
                    });
                hideDisabledElements(data, redrawDuration);
                lableManagent();
            }
            
            function lableManagent() {
                chart.renderedTimer = setTimeout(function() {
                    var labelPosition = calculatePointsForLabelPlacement(data_processed);
                    if ($ZC.labelRenderer) {
                        var args = [chartObj.seriesdata, 0, data_processed, noofNonZeroDatas, arcHeight + 2 + outerPadding, totalEngagement, cfg, labelPosition];
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "funnel",
                            "chartObj": chartObj,
                            "args": args
                        });
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "funnelInnerLabels",
                            "chartObj": chartObj,
                            "args": args
                        });
                    }
                    
                    //Annotation preprocessing
                    if ($ZC.annotation) {
                        notesArray = $ZC.annotation.preprocessAnnotations(chartObj.seriesdata, 0, function(dt, k, j) {
                            return [trapezoid[trapezoid.length - 1 - j].bottomLeft[0] + ((chartWidth / 2) - (cfg.width / 2)), trapezoid[trapezoid.length - 1 - j].bottomLeft[1] + (arcHeight + 2 + outerPadding)];
                        }, notesArray, chartObj, rp);
                    }
                    
                    isredraw = true;
                    chart.chartRendered = true;
                }, (!isAnimationEnable ? 0 : (isredraw ? redrawDuration : 300)));
            }
            
            function changeSelectionOrder(selection) {
                /*
                 * Reverse the selection order. ISSUE: https://docs.zoho.com/viewcommentattachment/4807920000000048005?width=770&height=515&owner=42061464
                 */
                selection[0].reverse();
                selection.data(data_processed);
            }

            function getEventArgs(d, i) {
                var ev = getEventObject(d3.event);
                return {
                    "renderer": chart,
                    "seriesPos": 0,
                    "subseriesPos": 0,
                    "itemPos": i,
                    "color": color[i % color.length],
                    "coordinates": [ev.pageX, ev.pageY],
                    "element": this,
                    "data": d
                };
            }
        });
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    function funnelLayout(data) {
        var sumofvalues = 0,
            hgt = cfg.height,
            ht = 0,
            h = 0;
        trapezoid = [], xAxisWidth = stemWidth;
        data.forEach(function(value, index) {
            var d = data[data.length - 1 - index],
                yVal = dataset.getY(d, yaxiscolumnorder),
                disabled = d.disabled;
            h = !totalEngagement ? 0 :
                ((disabled ? 0 : ((isWeightedWidth || noWeighted) ? (yVal ? (1 / noofNonZeroDatas) : 0) : mathAbs(yVal) / totalEngagement)) * (cfg.height - ((noofNonZeroDatas - 1) * cfg.gapHeight)));
            h = h || 0;
            sumofvalues += disabled ? 0 : yVal;
            h = ht + h;
            var per = yVal / totalEngagement;
            per = per || 0;
            var points = {};
            if ((sumofvalues == totalEngagement) && (yVal == 0 || disabled)) {
                points.topLeft = points.bottomLeft = points.middleLeft = [leftXscale(isWeightedWidth ? maxPer : cfg.height), 0];
                points.topRight = points.bottomRight = points.middleRight = [rightXscale(isWeightedWidth ? maxPer : cfg.height), 0];
            } else {
                if (isWeightedWidth) {
                    points.bottomLeft = [leftXscale(per), (cfg.height - h)];
                    points.topLeft = [leftXscale(per), hgt];
                    points.middleLeft = [leftXscale(per), (cfg.height - h)];
                    points.bottomRight = [rightXscale(per), (cfg.height - h)];
                    points.topRight = [rightXscale(per), hgt];
                    points.middleRight = [rightXscale(per), (cfg.height - h)];
                } else {
                    points.bottomLeft = [(((cfg.height - h) >= coneHeigth) ? ((cfg.width / 2) - stemWidth) : leftXscale(h)), (cfg.height - h)];
                    points.topLeft = [((hgt >= coneHeigth) ? ((cfg.width / 2) - stemWidth) : leftXscale(ht)), hgt];
                    points.middleLeft = [((hgt >= coneHeigth) ? ((cfg.width / 2) - stemWidth) : points.bottomLeft[0]), (((hgt >= coneHeigth) && ((cfg.height - h) <= coneHeigth)) ? coneHeigth : (cfg.height - h))];
                    points.bottomRight = [(((cfg.height - h) >= coneHeigth) ? ((cfg.width / 2) + stemWidth) : rightXscale(h)), (cfg.height - h)];
                    points.topRight = [((hgt >= coneHeigth) ? ((cfg.width / 2) + stemWidth) : rightXscale(ht)), hgt];
                    points.middleRight = [((hgt >= coneHeigth) ? ((cfg.width / 2) + stemWidth) : points.bottomRight[0]), (((hgt >= coneHeigth) && ((cfg.height - h) <= coneHeigth)) ? coneHeigth : (cfg.height - h))];
                }
            }
            trapezoid.push(points);
            hgt = (!yVal || disabled) ? (cfg.height - h) : (cfg.height - h - cfg.gapHeight);
            ht = (!yVal || disabled) ? h : (h + cfg.gapHeight);
        });
        return trapezoid;
    }
    
    function calculatePointsForLabelPlacement(data) {
        var trape = [],
            hgt = cfg.height,
            ht = 0,
            h = 0;
        data.forEach(function(value, index) {
            var d = data[data.length - 1 - index],
                yVal = dataset.getY(d, yaxiscolumnorder),
                disabled = d.disabled;
            h = ((disabled ? 0 : ((isWeightedWidth || noWeighted) ? (yVal ? (1 / noofNonZeroDatas) : 0) : mathAbs(yVal) / totalEngagement)) * (cfg.height - ((noofNonZeroDatas - 1) * cfg.gapHeight))) / 2;
            h = h || 0;
            var half = h;
            h = ht + h;
            var per = yVal / totalEngagement;
            per = per || 0;
            var leftX = isWeightedWidth ? leftXscale(per) : (((cfg.height - h) >= coneHeigth) ? ((cfg.width / 2) - stemWidth) : leftXscale(h));
            var rightX = isWeightedWidth ? rightXscale(per) : (((cfg.height - h) >= coneHeigth) ? ((cfg.width / 2) + stemWidth) : rightXscale(h));
            trape.push({
                "rightx": (rightX + datalabelPadding),
                "leftx": (leftX - datalabelPadding),
                "y": mathAbs(cfg.height - h),
                "y0": mathAbs(cfg.height - h + half)
            });
            h = h + half;
            hgt = (!yVal || disabled) ? (cfg.height - h) : (cfg.height - h - cfg.gapHeight);
            ht = (!yVal || disabled) ? h : (h + cfg.gapHeight);
        });
        return trape;
    }
    
    function addFunnelClipPath(emptyFunnelPath) {
        var clipID;
        if (isWeightedWidth) {
            clipID = null;
        } else {
            var properties = {
                name: "FunnelClipPath",
                id: chartObj.id,
                d: emptyFunnelPath
            },
            args = {
                chartObj: chartObj
            };
            clipID = effects.get(svg_clips, "polygon", properties, args);
        }
        container
            .attr("clip-path", !clipID ? null : "url(" + defsLocation + "#" + clipID + ")");
    }
    
    chart.defaultMouseOverFunc = function(d, seriesPos, itemPos) {
        if (!gElementsCollected) {
            collectGroups();
        }

        if (isPatternPalleteEnabled) {
            funnelsections
                .style("opacity", function(d, i) {
                    return (i === itemPos) ? null : 0.4;
                });
            ellipseSections
                .style("opacity", function(d, i) {
                    return (i === itemPos) ? null : 0.4;
                });
        } else {
            funnelsections
                .style("fill", function(d, i) {
                    return fillColor(i, d, ((i === itemPos) ? 0.6 : null));
                });
            ellipseSections
                .style("fill", function(d, i) {
                    return fillColor(i, d, ((i === itemPos) ? 1 : 0.5));
                });
        }
        label.selectAll("text").style("text-shadow", null);
        labelLinkgroup.selectAll("path").style("stroke-width", null);
        label.selectAll("#lbl0_0_" + (data_processed.length - 1 - itemPos)).style("text-shadow", "0 0 0 rgba(0,0,0,1)");
        labelLinkgroup.selectAll("#link0_0_" + (data_processed.length - 1 - itemPos)).style("stroke-width", 1);
    };
    
    chart.defaultMouseOutFunc = function(d, i) {
        if (!gElementsCollected) {
            collectGroups();
        }

        if (isPatternPalleteEnabled) {
            funnelsections
                .style("opacity", null);
            ellipseSections
                .style("opacity", null);
        } else {
            funnelsections
                .style("fill", function(d, i) {
                    return fillColor(i, d);
                });
            ellipseSections
                .style("fill", function(d, i) {
                    return fillColor(i, d, 0.5);
                });
        }
        label.selectAll("text").style("text-shadow", null);
        labelLinkgroup.selectAll("path").style("stroke-width", null);
    };
    
    function tweenAll(d, i, elementType, animationType) {
        var base = baseData(animationType, i),
            d = trapezoid[i];
        var interpolate = (elementType == "funnel") ?
            d3_interpolate(drawTrapezoid(base), drawTrapezoid(d)) :
            d3_interpolate(drawEllipse(base), drawEllipse(d));
        return function(t) {
            return interpolate(t);
        };
    }
    
    function baseData(animationType, i) {
        var d = simpleClone(trapezoid[(animationType == "verticalAll") ? 0 : i]);
        if (animationType === "horizontalAll") {
            d.topLeft[0] = d.middleLeft[0] = d.bottomLeft[0] = d.topRight[0] = d.middleRight[0] = d.bottomRight[0] = (cfg.width / 2);
        } else {
            d.middleLeft = d.bottomLeft = d.topLeft;
            d.middleRight = d.bottomRight = d.topRight;
        }
        return d;
    }
    
    function hideDisabledElements(data, dur) {
        ellipseSections
            .each(function(d, i) {
                var hide = data[i].disabled || !dataset.getY(data_processed[i], yaxiscolumnorder);
                var t = hide ? dur : 0;
                if (t) {
                    setTimeout(function() {
                        hideSection(i, hide);
                    }, t);
                } else {
                    hideSection(i, hide);
                }
            });
    }

    function hideSection(i, hide) {
        var display = hide ? "none" : null;

        ellipse.selectAll("#ellipse" + i)
            .style("display", display);
        funnel.selectAll("#funnel" + i)
            .style("display", display);
    }
    
    function preCalArcHeight() {
        var h = chartHeight - (2 * outerPadding);
        var arcHeight = h * 0.05;
        var padding = getFunnelPadding(h);
        arcHeight = (arcHeight - data_processed.length) / data_processed.length;
        arcHeight = mathMax(minArcHeight, arcHeight);
        arcHeight = !threeDimension ? 0 : (cfg.canOverlap ? (arcHeight + (maxPadding / 2)) : ((padding / 2) - arcCorrection));
        return arcHeight;
    }

    function getFunnelPadding(h) {
        var userPadding = commonPlotOptions.padding;
        if (defined(userPadding)) {
            return invokeFunction(userPadding, h, noOfGaps, chartObj);
        }

        var maxPaddingHeight = h * percentage;
        return mathMin(maxPadding, mathMax(minPadding, maxPaddingHeight / noOfGaps));
    }
    
    function drawTrapezoid(d) {
        var topW = (d.topRight[0] - d.topLeft[0]) / 2,
            bottomW = (d.bottomRight[0] - d.bottomLeft[0]) / 2;
        var topCurve = cfg.canOverlap ? (((2 * topW) / cfg.width) * arcHeight) : arcHeight1,
            bottomCurve = cfg.canOverlap ? (((2 * bottomW) / cfg.width) * arcHeight) : arcHeight1;
        return "M" + d.topLeft[0] + " " + d.topLeft[1] +
            " A" + topW + " " + topCurve + " 0 0 0 " + d.topRight[0] + " " + d.topRight[1] +
            " L" + d.middleRight[0] + " " + d.middleRight[1] +
            " L" + d.bottomRight[0] + " " + d.bottomRight[1] +
            " A" + bottomW + " " + bottomCurve + " 0 0 1 " + d.bottomLeft[0] + " " + d.bottomLeft[1] +
            " L" + d.middleLeft[0] + " " + d.middleLeft[1] + "Z";
    }
    
    function drawEllipse(d) {
        var bottomW = (d.bottomRight[0] - d.bottomLeft[0]) / 2;
        var bottomCurve = cfg.canOverlap ? (((2 * bottomW) / cfg.width) * arcHeight) + arcCorrection : arcHeight1;
        return "M" + d.bottomLeft[0] + " " + d.bottomLeft[1] +
            " A" + bottomW + " " + bottomCurve + " 0 0 1 " + d.bottomRight[0] + " " + d.bottomRight[1] +
            " A" + bottomW + " " + (cfg.canOverlap ? bottomCurve : bottomCurve + arcCorrection) + " 0 0 1 " + d.bottomLeft[0] + " " + d.bottomLeft[1];
    }
    
    function collectGroups() {
        labelLinkgroup = labelLinkgroup || chartObj.staticPaneSVG.selectAll("g.link_0");
        label = label || chartObj.staticPaneSVG.selectAll("g.label_0");
        gElementsCollected = true;
    }

    return chart;
};//$Id$
/**
 *
 * @returns {chart} pyramid renderer.
 */
svg_plot_renderer.pyramid = function() {
    var MAXWIDTH_DATALABELS = 0.3;
    var cfg = {};
    var animationType;
    var commonRendererProp, dataset, yaxiscolumnorder, isredraw = false;
    var chartWidth, chartHeight, commonPlotOptions, systemconf, notesArray, isPatternPalleteEnabled, defsLocation;
    var height1, total, b, h, side1, side2, side3, side4, hScale, color, heightArray, chartObj, pyramidGroup, gradientDim, pyramidsections, dataLength, data_backup,
        datalabelPadding,
        fillColor;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                notesArray = rp.notesArray,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset;
            systemconf = chartObj.systemConf;
            var labelQueue = rp.labelQueue;
            
            defsLocation = chartObj.defsLocation;
            
            chartWidth = chartObj.plotarea.width,
                chartHeight = chartObj.plotarea.height;
            var minD = mathMin(chartWidth, chartHeight);
            
            datalabelPadding = commonPlotOptions.datalabels.padding;
            var showlabel = isDatalabelEnabled(commonPlotOptions.datalabels, chartObj);
            if (showlabel) {
                /*
                 *If chart width is lesser than height, datalabels are hidden as default padding is 10 and there is no space to show datalabels.
                 * So 30% of the width is allocated for datalabels and the default padding will be changed to 5
                 */
                var minDatalabelsWidth = chartWidth * MAXWIDTH_DATALABELS,
                    availableDatalabelsWidth = chartWidth - minD;
                if (availableDatalabelsWidth < minDatalabelsWidth) {
                    datalabelPadding = cfg.datalabelPadding = 5;
                    minD -= mathMax((minDatalabelsWidth - availableDatalabelsWidth), 0);
                }
            }
            cfg.width = minD;
            cfg.height = minD * 4 / 5;
            
            var plotoptions = data[0].plotoptions,
                gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions);
            isPatternPalleteEnabled = systemconf.legend.imagePallete || hasPatternPallete(chartObj);
            
            var strokeWidth = gvp("strokeWidth"),
                strokeOpacity = gvp("strokeOpacity"),
                threeDimension = gvp("threeDimension"),
                fillOpacity = gvp("fillOpacity");
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, "pyramid");
            var isAnimationEnable = animationOptions.enabled,
                easingType = animationOptions.easingType,
                transitionDuration = isredraw ? (isAnimationEnable ? 200 : 0) : animationOptions.duration;
            animationType = animationOptions.type;
            
            var eventDisabled = (validateNullVal(getEventConf(plotoptions, commonPlotOptions, chartObj, "enabled"), true) == false);
            var cursor = eventDisabled ? null : getEventConf(plotoptions, commonPlotOptions, chartObj, "cursor") || "pointer";
            
            var container = d3_select(this);
            pyramidGroup = appendEle(container, "g", [data], ".", "class", "pyramidgroup");
            pyramidGroup
                .attr("transform", "translate(" + ((chartWidth / 2) - (cfg.width / 2)) + "," + ((chartHeight / 2) - (cfg.height / 2)) + ")")
                .style("cursor", cursor);
            data_backup = data = data[0].data[0];
            dataLength = data.length;
            heightArray = [];
            height1 = cfg.height;
            b = cfg.width, h = (threeDimension ? (cfg.height / 6) : 0);
            var theta = 25;
            var x = mathSQRT(mathPow((h / mathSin(theta * mathPI / 180)), 2) - mathPow(h, 2));
            b = b - x;
            side1 = d3_scaleLinear()
                .range([(b + x) / 2, 0])
                .domain([0, height1]);
            side2 = d3_scaleLinear()
                .range([(b + x) / 2, b])
                .domain([0, height1]);
            side3 = d3_scaleLinear()
                .range([(b + x) / 2, (b + x)])
                .domain([0, height1]);
            side4 = d3_scaleLinear()
                .range([(b + x) / 2, x])
                .domain([0, height1]);
            hScale = d3_scaleLinear()
                .range([0, h])
                .domain([0, height1 - h / 2]);
            gradientDim = [cfg.width, cfg.height];
            fillColor = chart.fillColorFunc = getFillColor(chartObj, 0, gradientDim);
            var strokeColor = getStrokeColor(chartObj, 0);
            
            var noofNonZeroData = 0;
            chart.total = total = data.reduce(function(prev, cur) {
                return prev + (cur.disabled ? 0 : (noofNonZeroData++, mathAbs(dataset.getY(cur, yaxiscolumnorder) || 0)))
            }, 0);
            
            var previous = 0;
            data.forEach(function(d, i) {
                heightArray.push({
                    "height": ((previous + (d.disabled ? 0 : mathAbs(dataset.getY(d, yaxiscolumnorder)))) / total * (height1 - h / 2)) || 0,
                    "previousHeight": (previous / total * (height1 - h / 2)) || 0
                });
                previous += d.disabled ? 0 : mathAbs(dataset.getY(d, yaxiscolumnorder));
            });
            pyramidsections = appendEle(pyramidGroup, "g", data);
            pyramidsections
                .attr("id", function(d, i) {
                    return "section_" + (dataLength - 1 - i);
                })
                .style({
                    "stroke": function(d, i) {
                        return strokeColor(dataLength - 1 - i, data[dataLength - 1 - i], commonPlotOptions.strokeColor);
                    },
                    "stroke-opacity": strokeOpacity,
                    "stroke-width": strokeWidth,
                    "fill-opacity": fillOpacity,
                    "fill": function(d, i) {
                        return fillColor(dataLength - 1 - i, data[dataLength - 1 - i]);
                    }
                })
                .each(function(d, i) {
                    var currentGroup = d3_select(this);
                    var pyramid = appendEle(currentGroup, "path", [d, d, d, d]);
                    pyramid.attr("class", "section_" + (dataLength - 1 - i)); //For touch events, class will help to get index
                });
            
            if (!eventDisabled) {
                var mousemove = function(d, j) {
                        var ele = this.parentNode;
                        var i = pInt(d3_select(ele).attr("id").replace(/section_/gi, ""));
                        var args = getEventArgs(ele, i);
                        chartObj.eventHandler.mouseMove(args);
                    },
                    mouseout = function(d, j) {
                        var ele = this.parentNode;
                        var i = pInt(d3_select(ele).attr("id").replace(/section_/gi, ""));
                        chartObj.eventHandler.mouseOut(chart, data[dataLength - 1 - i], dataLength - 1 - i);
                    },
                    click = function() {
                        var ele = this.parentNode;
                        var i = pInt(d3_select(ele).attr("id").replace(/section_/gi, ""));
                        var args = getEventArgs(ele, i);
                        chartObj.eventHandler.click(chart, data[i], 0, i, args);
                    },
                    dblclick = function(d, j) {
                        var ele = this.parentNode;
                        var i = pInt(d3_select(ele).attr("id").replace(/section_/gi, ""));
                        var dt = $ZC.annotation ? generateDataForAnnotation(data[i], null) : data[i];
                        var height = heightArray[i].previousHeight;
                        var coordinates = [(side1(height + hScale(height) / 2) + ((chartWidth / 2) - (cfg.width / 2))), ((hScale(height) / 2 + height) + ((chartHeight / 2) - (cfg.height / 2)))];
                        var args = {
                            "coordinate": coordinates,
                            "data": dt,
                            "basedOn": "plot"
                        };
                        chartObj.eventHandler.doubleclick(d, i, args);
                    },
                    eventAttacherOptions = {
                        target: "plot",
                        touchleave: true,
                        chartObj: chartObj
                    };
                var mouseHandlers = {
                    "mousemove": mousemove,
                    "mouseout": mouseout,
                    "click": click,
                    "dblclick": dblclick
                },
                touchHandlers = {
                    "singletouchmove": mousemove,
                    "touchend": mouseout,
                    "tap": click,
                    "dbltap": dblclick
                };
                attachevents(pyramidsections.selectAll("path"), mouseHandlers, touchHandlers, eventAttacherOptions);
            }
            
            var prev = 0;
            pyramidsections
                .each(function(d, i) {
                    var pyramid = pyramidGroup.selectAll("#section_" + i).selectAll("path");
                    if (isredraw) {
                        pyramid
                            .transition()
                            .duration(transitionDuration)
                            .ease("linear")
                            .attr("d", function(d, j) {
                                return getPath(i, j);
                            });
                    } else {
                        var yVal = dataset.getY(d, yaxiscolumnorder);
                        var dur = (animationType == "vertical") ? ((((d.disabled || !yVal) ? 0 : mathAbs(yVal)) / total) * transitionDuration) : transitionDuration
                        prev += (d.disabled || !yVal) ? 0 : mathAbs(yVal);
                        var del = (animationType == "vertical") ? ((((total - prev) / total) * transitionDuration)) : 0;
                        pyramid
                            .transition()
                            .duration(dur)
                            .delay(del)
                            .ease(easingType)
                            .attrTween("d", function(dt, j) {
                                return tween(d, i, j)
                            });
                    }
                });
            chart.renderedTimer = setTimeout(function() {
                if ($ZC.labelRenderer) {
                    var args = [chartObj.seriesdata, 0, data, noofNonZeroData, 0, total, cfg, calculatePointsForLabelPlacement(data)];
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "funnel",
                        "chartObj": chartObj,
                        "args": args
                    });
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "funnelInnerLabels",
                        "chartObj": chartObj,
                        "args": args
                    });
                }
                
                //Annotation preprocessing
                if ($ZC.annotation) {
                    notesArray = $ZC.annotation.preprocessAnnotations(chartObj.seriesdata, 0, function(dt, k, j) {
                        var height = heightArray[j].previousHeight;
                        return [(side1(height + hScale(height) / 2) + ((chartWidth / 2) - (cfg.width / 2))), ((hScale(height) / 2 + height) + ((chartHeight / 2) - (cfg.height / 2)))];
                    }, notesArray, chartObj, rp);
                }
                
                isredraw = true;
                chart.chartRendered = true;
            }, (transitionDuration + 10));

            function getEventArgs(ele, i) {
                var ev = getEventObject(d3.event);
                return {
                    "renderer": chart,
                    "seriesPos": 0,
                    "subseriesPos": 0,
                    "itemPos": i,
                    "color": color[i % color.length],
                    "coordinates": [ev.pageX, ev.pageY],
                    "element": ele,
                    "data": data[i]
                };
            }
        });
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.defaultMouseOverFunc = function(d, seriesPos, itemPos) {
        if (isPatternPalleteEnabled) {
            pyramidsections.style("opacity", function(d, i) {
                return (dataLength - 1 - i == itemPos) ? null : 0.2;
            });
        } else {
            pyramidsections
                .style("fill", function(d, i) {
                    return fillColor(dataLength - 1 - i, data_backup[dataLength - 1 - i], ((dataLength - 1 - i == itemPos) ? 0.5 : null));
                });
        }
    };
    chart.defaultMouseOutFunc = function(d, i) {
        if (isPatternPalleteEnabled) {
            pyramidsections.style("opacity", null);
        } else {
            pyramidsections
                .style("fill", function(d, i) {
                    return fillColor(dataLength - 1 - i, data_backup[dataLength - 1 - i]);
                });
        }
    };
    
    function constructSide1(height, previous) {
        return "M" + side1(height + hScale(height) / 2) + " " + (hScale(height) / 2 + height) +
            " L" + side2(height + hScale(height) / 2) + " " + (hScale(height) / 2 + height) +
            " L" + side2(previous + hScale(previous) / 2) + " " + (hScale(previous) / 2 + previous) +
            " L" + side1(previous + hScale(previous) / 2) + " " + (hScale(previous) / 2 + previous) +
            " L" + side1(height + hScale(height) / 2) + " " + (hScale(height) / 2 + height);
    }
    
    function constructSide2(height, previous) {
        return "M" + side2(height + hScale(height) / 2) + " " + (hScale(height) / 2 + height) +
            " L" + side3(height + hScale(height) / 2) + " " + (-hScale(height) / 2 + height) +
            " L" + side3(previous + hScale(previous) / 2) + " " + (-hScale(previous) / 2 + previous) +
            " L" + side2(previous + hScale(previous) / 2) + " " + (hScale(previous) / 2 + previous) +
            " L" + side2(height + hScale(height) / 2) + " " + (hScale(height) / 2 + height);
    }
    
    function constructSide3(height, previous) {
        return "M" + side3(height + hScale(height) / 2) + " " + (-hScale(height) / 2 + height) +
            " L" + side4(height + hScale(height) / 2) + " " + (-hScale(height) / 2 + height) +
            " L" + side4(previous + hScale(previous) / 2) + " " + (-hScale(previous) / 2 + previous) +
            " L" + side3(previous + hScale(previous) / 2) + " " + (-hScale(previous) / 2 + previous) +
            " L" + side3(height + hScale(height) / 2) + " " + (-hScale(height) / 2 + height);
    }
    
    function constructSide4(height, previous) {
        return "M" + side4(height + hScale(height) / 2) + " " + (-hScale(height) / 2 + height) +
            " L" + side1(height + hScale(height) / 2) + " " + (hScale(height) / 2 + height) +
            " L" + side1(previous + hScale(previous) / 2) + " " + (hScale(previous) / 2 + previous) +
            " L" + side4(previous + hScale(previous) / 2) + " " + (-hScale(previous) / 2 + previous) +
            " L" + side4(height + hScale(height) / 2) + " " + (-hScale(height) / 2 + height);
    }
    
    function getPath(i, j, base) {
        var height = heightArray[i].height;
        var baseHgt = (base == "down" ? height : heightArray[i].previousHeight);
        switch (j) {
            case 0:
                return constructSide3(height, baseHgt);
            case 1:
                return constructSide4(height, baseHgt);
            case 2:
                return constructSide1(height, baseHgt);
            case 3:
                return constructSide2(height, baseHgt);
        }
    }
    
    function tween(d, i, j) {
        var interpolate = d3_interpolate(getPath(((animationType == "vertical") ? i : (dataLength - 1)), j, "down"), getPath(i, j));
        return function(t) {
            return interpolate(t);
        };
    }
    
    function calculatePointsForLabelPlacement(data) {
        var trape = [];
        data.forEach(function(d, i) {
            var idx = data.length - 1 - i;
            var height = heightArray[idx].height,
                previous = heightArray[idx].previousHeight;
            var midHeight = (height + previous) / 2;
            var bottom_right = {
                    x: side3(height + hScale(height) / 2),
                    y: (-hScale(height) / 2 + height)
                },
                top_right = {
                    x: side3(previous + hScale(previous) / 2),
                    y: (-hScale(previous) / 2 + previous)
                },
                bottom_left = {
                    x: side1(height + hScale(height) / 2),
                    y: (hScale(height) / 2 + height)
                },
                top_left = {
                    x: side1(previous + hScale(previous) / 2),
                    y: (hScale(previous) / 2 + previous)
                };
            var rightX = (bottom_right.x + top_right.x) / 2,
                rightY = (bottom_right.y + top_right.y) / 2,
                leftX = (bottom_left.x + top_left.x) / 2,
                leftY = (bottom_left.y + top_left.y) / 2,
                midX = (side1(midHeight + hScale(midHeight) / 2) + side2(midHeight + hScale(midHeight) / 2)) / 2;
            
            trape.push({
                "rightx": rightX + datalabelPadding,
                "leftx": leftX - datalabelPadding,
                "y": rightY,
                "y0": height + hScale(height) / 2,
                "midX": midX,
                "leftY": leftY
            });
        });
        return trape;
    }
    
    return chart;
};//$Id$
/**
 *
 * @returns {chart} sunburst renderer.
 */
svg_plot_renderer.sunburst = function() {
    var commonRendererProp, xscale, yscale, arc, radius, dataset, redraw = false,
        arcLabel, systemconf, oldData, yaxiscolumnorder;
    var chartwidth, chartheight, color, chartObj, notesArray, path, pathGroup, commonPlotOptions;
    var start, end, innerrad, rad,
        highlightGroup,
        highlightEle,
        highlightHierarchy,
        maxDepth;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                notesArray = rp.notesArray,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset;
            systemconf = chartObj.systemConf;
            var labelQueue = rp.labelQueue;
            
            chartwidth = chartObj.plotarea.width,
                chartheight = chartObj.plotarea.height;
            
            var gvpFn = $ZC.utils.getValueOfPlotOptions,
                dataLabels = commonPlotOptions.datalabels,
                outerPadding = (+commonPlotOptions.outerPadding || 0),
                padding;
            highlightGroup = null;
            maxDepth = 0;
            
            var showlabel = isDatalabelEnabled(dataLabels, chartObj)
            var boundBoxPadding = (showlabel && isBoundBoxEnabled(dataLabels, chartObj)) ? (getBoundBoxPadding(dataLabels, chartObj) + getBoundBoxStrokeWidth(dataLabels, chartObj)) : 0
            
            var eventDisabled = (validateNullVal(getEventConf(null, commonPlotOptions, chartObj, "enabled"), true) == false);
            var cursor = eventDisabled ? null : (commonPlotOptions.events) ? commonPlotOptions.events.cursor || "pointer" : systemconf.chart.plot.events.cursor || "pointer";
            highlightHierarchy = commonPlotOptions.events && commonPlotOptions.events.highlightHierarchy;
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, null, chartObj, "sunburst");
            var isAnimationEnable = animationOptions.enabled,
                animationType = animationOptions.type,
                easingType = animationOptions.easingType,
                transitionDuration = redraw ? (isAnimationEnable ? 200 : 0) : animationOptions.duration;
            
            radius = (mathMin(chartwidth, chartheight) / 2) - outerPadding - (2 * boundBoxPadding);
            var innerRadius = mathMin(mathMax(0, perToPx(commonPlotOptions.innerRadius, radius)), perToPx("95%", radius)),
                fillColor = chart.fillColorFunc = getFillColor(chartObj, 0, [radius, radius]),
                strokeColor = getStrokeColor(chartObj, 0);

            var partition = d3_partition()
                .value(function(d, i) {
                    return data[getSeriesIndex(d)].disabled ? 0 : mathAbs(dataset.getY(d, yaxiscolumnorder));
                })
                .children(getChildren)
                .sort(null);
            
            start = function(d) {
                return mathMax(0, mathMin(2 * mathPI, xscale(d.x)));
            },
                end = function(d) {
                    return mathMax(0, mathMin(2 * mathPI, xscale(d.x + d.dx)));
                },
                innerrad = function(d) {
                    return yscale(d.y) + (padding / 2);
                };
            rad = function(scale, extra) {
                extra = extra || 0;
                return function(d) {
                    return yscale(d.y + d.dy) + extra - (padding / 2);
                };
            };
            
            arc = d3.d4_arc() //#ZC814 - d3.svg.arc has issue in this 
                .startAngle(start)
                .endAngle(end)
                .innerRadius(innerrad)
                .outerRadius(rad(yscale));
            
            arcLabel = d3.d4_arc() //#ZC814 - d3.svg.arc has issue in this 
                .startAngle(start)
                .endAngle(end)
                .innerRadius(innerrad)
                .outerRadius(rad(yscale));

            pathGroup = appendEle(selection, "g", [data], ".", "class", "hierarchychart");
            pathGroup
                .attr("transform", "translate(" + chartwidth / 2 + "," + chartheight / 2 + ")")
                .style("cursor", cursor);

            oldData = [];
            pathGroup.selectAll("path")
                .each(function(d, i) {
                    oldData.push({
                        x: d.x,
                        dx: d.dx
                    });
                });
            
            path = appendEle(pathGroup, "path", partition.nodes);
            var colorLighter = [],
                leafNodes = [],
                childColorIndex;
            data.forEach(function(d, i) {
                leafNodes[i] = [[]];
                leafNodes[i].disabled = d.disabled;
                var nonRGBAColor = rgb2hex(color[i % color.length]);
                colorLighter[i] = d3_scaleLinear()
                    .domain([0, getChildrenCount(d)])
                    .range([nonRGBAColor, d3_rgb(nonRGBAColor).brighter(1.5)])
            });

            path
                .attr("class", function(d, i) {
                    return (d.level != null) ? ("series_" + getSeriesIndex(d)) : null;
                })
                .attr("id", function(d) {
                    return "arcPath_" + d.level;
                })
                .each(function(d, i) {
                    maxDepth = mathMax(maxDepth, d.depth);
                    if (!d.depth) {
                        d.arcColor = "transparent";
                    } else {
                        if (d.depth === 1) {
                            childColorIndex = 0;
                        }

                        if (d.color) {
                            d.arcColor = d.color;
                        } else {
                            var plotoptions = data[getSeriesIndex(d)].plotoptions;
                            var chClr = (plotoptions != null) ? gvpFn(plotoptions, commonPlotOptions)("childrenColors") : commonPlotOptions.childrenColors;
                            if (chClr != null) {
                                d.arcColor = chClr[childColorIndex % chClr.length];
                            } else {
                                var c = colorLighter[getSeriesIndex(d)](childColorIndex);

                                var rgba = d.parent.arcColor.match(RGBA_PATTERN);
                                if (rgba && rgba.length === 5) { // if (rgba && rgba.length === 4s) {
                                    c = hex2rgba(c, rgba[4]); // return hex2rgba(newColor, rgba[3]);
                                }

                                d.arcColor = c;
                            }
                        }

                        if (!d.children) {
                            childColorIndex++;
                            leafNodes[getSeriesIndex(d)][0].push(d);
                        }
                    }
                });

            xscale = d3_scaleLinear().range([0, 2 * mathPI]);
            yscale = d3_scaleLinear().range([innerRadius, radius]).domain([data.dy, 1]);
            padding = mathMin(mathMax(0, perToPx(commonPlotOptions.padding, radius, 0)), (radius - innerRadius) * 0.9 / maxDepth);

            path
                .transition()
                .duration(transitionDuration)
                .ease(redraw ? "linear" : easingType)
                .attrTween("d", (redraw || (animationType === "fan")) ? fanTween : ((animationType === "wheel") ? wheelTween : innerTween));

            path
                .style({
                    "fill": function(d) {
                        return d.fillColor = fillColor(d.seriesPos, d, null, getBaseClr(d));
                    },
                    "stroke": function(d) {
                        if (!d.depth) {
                            return "white";
                        } else if (commonPlotOptions.strokeColor) {
                            return commonPlotOptions.strokeColor;
                        } else {
                            return strokeColor(getSeriesIndex(d), d, getBaseClr(d));
                        }
                    },
                    "stroke-opacity": function(d) {
                        return d.depth ? (gvpFn(data[getSeriesIndex(d)].plotoptions, commonPlotOptions)("strokeOpacity")) : 1;
                    },
                    "fill-opacity": function(d) {
                        return d.depth ? (gvpFn(data[getSeriesIndex(d)].plotoptions, commonPlotOptions)("fillOpacity")) : 0;
                    },
                    "stroke-width": function(d) {
                        return d.depth ? (gvpFn(data[getSeriesIndex(d)].plotoptions, commonPlotOptions)("strokeWidth")) : 0;
                    }
                });

            if (!eventDisabled) {
                var mousemove = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.mouseMove(args);
                    },
                    mouseout = function(d, i) {
                        chartObj.eventHandler.mouseOut(chart, d, getSeriesIndex(d));
                    },
                    click = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.click(chart, d, getSeriesIndex(d), d.itemPos, args);
                        //clickFunc(path,d);     //default click function
                    },
                    dblclick = function(d, i) {
                        if (!chart.chartRendered) {
                            return;
                        }
                        var dt = (d.children == null) ? (($ZC.annotation != null) ? generateDataForAnnotation(d, ((data.length > 1) ? d.parent.seriesname : null)) : d) : [d.seriesname, d.value];
                        var coordinates = arcLabel.centroid(d);
                        coordinates = [(coordinates[0] + chartwidth / 2), (coordinates[1] + (chartheight / 2))];
                        var args = {
                            "coordinate": coordinates,
                            "data": dt,
                            "basedOn": "plot"
                        };
                        chartObj.eventHandler.doubleclick(d, getSeriesIndex(d), args);
                    },
                    eventAttacherOptions = {
                        target: "plot",
                        touchleave: true,
                        chartObj: chartObj
                    };
                var mouseHandlers = {
                    "mousemove": mousemove,
                    "mouseout": mouseout,
                    "click": click,
                    "dblclick": dblclick
                },
                touchHandlers = {
                    "singletouchmove": mousemove,
                    "touchend": mouseout,
                    "tap": click,
                    "dbltap": dblclick
                };
                attachevents(path.filter(function(d) {
                    return d.depth != 0;
                }), mouseHandlers, touchHandlers, eventAttacherOptions);
            }
            
            chart.renderedTimer = setTimeout(function() {
                if ($ZC.labelRenderer != null && !chartObj.dataObject.hasHierarchyData) {
                    var outline = d3_arc()
                        .startAngle(start)
                        .endAngle(end)
                        .innerRadius(rad(yscale))
                        .outerRadius(rad(yscale));

                    var datalabelsPadding = commonPlotOptions.datalabels.padding + boundBoxPadding;
                    var outlineWithPad = d3_arc()
                        .startAngle(start)
                        .endAngle(end)
                        .innerRadius(rad(yscale, datalabelsPadding))
                        .outerRadius(rad(yscale, datalabelsPadding));
                    
                    data.forEach(function(d, i) {
                        var args = [leafNodes, i, null, radius, function(d) {
                            return d.parent.value
                        }, outlineWithPad, outline, arcLabel, [chartwidth / 2, chartheight / 2]];
                        labelQueue.push({
                            "renderer": chart,
                            "chartObj": chartObj,
                            "charttype": "pie",
                            "args": args
                        });
                        labelQueue.push({
                            "renderer": chart,
                            "chartObj": chartObj,
                            "charttype": "pieInnerLabels",
                            "args": args
                        });
                    });
                }
                
                //Annotation preprocessing
                if ($ZC.annotation != null) {
                    data.forEach(function(series, i) {
                        notesArray = $ZC.annotation.preprocessAnnotations(data, i, function(dt, k, j) {
                            var c = arcLabel.centroid(dt);
                            return [(c[0] + (chartwidth / 2)), (c[1] + (chartheight / 2))];
                        }, notesArray, chartObj, rp);
                    });
                }
                
                redraw = true;
                chart.chartRendered = true;
                
            }, (transitionDuration + 1000 / 60));

            function getEventArgs(d, i) {
                var ev = getEventObject(d3.event);
                return {
                    "renderer": chart,
                    "seriesPos": getSeriesIndex(d),
                    // "subseriesPos": 0,
                    // "itemPos": d.itemPos,
                    "coordinates": [ev.pageX, ev.pageY],
                    "element": this,
                    "color": getBaseClr(d),
                    "data": d,
                    "level" : d.level
                };
            }
        });
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    chart.defaultMouseOverFunc = function(d, seriesPos, itemPos) {
        if (!highlightGroup) {
            highlightGroup = chartObj.staticPaneSVG.selectAll("g#zchierarchyhighlight")
                .attr("transform", "translate(" + (chartObj.plotarea.left + chartwidth / 2) + "," + (chartObj.plotarea.top + chartheight / 2) + ")");
            highlightEle = appendEle(highlightGroup, "path", d3_range(highlightHierarchy ? maxDepth : 1));
        }

        var highlightEffect = chartObj.legendHighlight.getLegendHighlightEffect(seriesPos, "selectedSeries", "plot"),
            elementIds = getHierarchyElementIds(d.level);

        if (highlightEffect !== "none") {
            highlightGroup
                .style("opacity", null);

            var refElements = pathGroup.selectAll(elementIds.join())[0];
            highlightEle
                .each(function(d, i) {
                    var ele = d3_select(this);
                    if (refElements[i]) {
                        var refEle = d3_select(refElements[i]),
                            arcColor = getRawColor(chartObj, seriesPos, refEle.datum(), seriesPos);
                        ele
                            .attr("d", refEle.attr("d"))
                            .style(chartObj.legendHighlight.getEffect(highlightEffect, "sunburst", (/(illuminate|moody|flip)/.test(highlightEffect) ? arcColor : "transparent"), {fill: "transparent", stroke:arcColor}, seriesPos));
                    } else {
                        ele
                            .attr("d", null);
                    }
                });
        }
    };
    chart.defaultMouseOutFunc = function(d, i) {
        if (!highlightGroup) { //Touch device -> tap on a data, then tap a legend item. Mouseout should be called and legend tap action also will get executed.
            highlightGroup = chartObj.staticPaneSVG.selectAll("g#zchierarchyhighlight");
        }

        highlightGroup
            .style("opacity", 0);
    };
    
    // function Tween(d, tweentype) {
    //     var xd = d3_interpolate(xscale.domain(), [d.x, d.x + d.dx]),
    //         yd = d3_interpolate(yscale.domain(), [d.y, 1]),
    //         yr = d3_interpolate(yscale.range(), [d.y ? 20 : 0, radius]);
    //     if (tweentype == "arc") {
    //         return function(d, i) {
    //             return i ?
                    
    //                 function(t) {
    //                     return arcLabel(d);
    //                 } :
    //                 function(t) {
    //                     xscale.domain(xd(t));
    //                     yscale.domain(yd(t)).range(yr(t));
    //                     return arcLabel(d);
    //                 };
    //         };
    //     } else {
    //         return function(d, i) {
    //             return i ?
                    
    //                 function(t) {
    //                     return "translate(" + arcLabel.centroid(d) + ")";
    //                 } :
    //                 function(t) {
    //                     xscale.domain(xd(t));
    //                     yscale.domain(yd(t)).range(yr(t));
    //                     return "translate(" + arcLabel.centroid(d) + ")";
    //                 };
    //         };
    //     }
    // }
    
    function fanTween(d, i) {
        var startAngle = d3_interpolate(((redraw && oldData[i]) ? start(oldData[i]) : 0), start(d));
        var endAngle = d3_interpolate(((redraw && oldData[i]) ? end(oldData[i]) : 0), end(d));
        return function(t) {
            arc.startAngle(startAngle(t)).endAngle(endAngle(t));
            return arc(d);
        };
    }
    
    function innerTween(d) {
        var inner = d3_interpolate(0, innerrad(d));
        var outer = d3_interpolate(0, rad(yscale)(d));
        return function(t) {
            arc.innerRadius(inner(t)).outerRadius(outer(t));
            return arc(d);
        };
    }
    
    function wheelTween(d) {
        var endAngle = d3_interpolate(start(d), end(d));
        return function(t) {
            arc.endAngle(endAngle(t));
            return arc(d);
        };
    }
    
    // function clickFunc(path, d) {
    //     path.transition()
    //         .duration(250)
    //         .attrTween("d", Tween(d, "arc"));
    //     // text.style("visibility", function(e) {return isParentOf(d, e) ? null : "hidden";})
    //     //  .transition()
    //     //  .duration(250)
    //     //  .attrTween("transform",Tween(d,"label"))
    //     //  .style("fill-opacity", function(e) { return isParentOf(d, e) ? 1 : 1e-6; });
    // }
    
    // function getDomainMax(parentElement) {
    //     return parentElement.children.length;
    // }
    
    // function isParentOf(p, c) {
    //     if (p === c) {
    //         return true;
    //     }
    //     if (p.children) {
    //         return p.children.some(function(d) {
    //             return isParentOf(d, c);
    //         });
    //     }
    //     return false;
    // }

    function getChildren(node, depth) {
        if (!chartObj.dataObject.hasHierarchyData && depth == 1 && node.length < 2 && node[0] && isArray(node[0][0])) {
            return node[0];
        } else {
            return isArray(node[0]) ? node : null;
        }
    }

    function getSeriesIndex(d) {
        return +d.level.split("_")[0];
    }

    function getHierarchyElementIds(id) {
        var hierarchyIds = [];
        var currentId = "path#arcPath";

        if (highlightHierarchy) {
            var levels = id.split("_");

            levels.forEach(function(d) {
                currentId = currentId + "_" + d;
                hierarchyIds.push(currentId);
            });
        } else {
            hierarchyIds.push(currentId + "_" + id);
        }

        return hierarchyIds;
    }

    function getBaseClr(d) {
        return d.children ? d.arcColor : null;
    }
    
    return chart;
};//$Id$
/**
 *
 * @returns {chart} dial chart renderer.
 */
/*
 * PENDING:-
 * If target label is overlapping with minmax label
 * Pre render target
 */
svg_plot_renderer.dial = function() {
    var commonRendererProp, chartObj, innerRadius, color, isredraw = false,
        commonPlotOptions, dataset, yaxiscolumnorder,
        totalEngagement, plotarea_approx,
        systemconf, yscale, oldData, minMax,
        levelmarkerClr = [],
        hasNegValue,
        hasPreviousNegValue,
        previousRadiusFactors,
        previousOuterRadius,
        previousInnerRadius,
        currentRadiusFactors,
        arc;
    var pie = svg_plot_renderer.pie();
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                color = rp.color,
                dataset = rp.dataset,
                yaxiscolumnorder = rp.yaxiscolumnorder;
            systemconf = chartObj.systemConf;

            var plotoptions = data[0].plotoptions;
            totalEngagement = dataset.getY(data[0].data[0][0], yaxiscolumnorder);
            hasPreviousNegValue = hasNegValue;
            hasNegValue = (totalEngagement < 0);
            var defsLocation = chartObj.defsLocation;
            var labelQueue = rp.labelQueue;
            var index = 0;
            
            yscale = chartObj.axes.y.groups[0].scale;
            minMax = yscale.domain();
            plotarea_approx = chartObj.plotarea_approx;

            commonPlotOptions = plotoptions ? mergeJSON(commonPlotOptions, plotoptions, true) : commonPlotOptions;
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, "dial");
            var isAnimationEnable = animationOptions.enabled,
                easingType = animationOptions.easingType,
                transitionDuration = isredraw ? (isAnimationEnable ? 200 : 0) : animationOptions.duration;
            
            var container = d3_select(this).data(createDataForPie(data));
            oldData = container.selectAll("path.dial").data();
            
            var levelMarkerConf = commonPlotOptions.levelMarker;
            currentRadiusFactors = commonPlotOptions.innerRadius + " _ " + commonPlotOptions.outerPadding + " _ " + commonPlotOptions.maxRadius + " _ " + commonPlotOptions.bandWidth + " _ " + levelMarkerConf.bandWidth + " _ " + levelMarkerConf.innerPadding + " _ " + levelMarkerConf.outerPadding;
            var OR = plotarea_approx.radius,
                levelmarkerSW = validateNullVal(levelMarkerConf.strokeWidth, 1),
                visibility;
            
            var stacked = true;
            var IR = getInnerRadius(commonPlotOptions, OR);
                arc = d3_arc()
                    .endAngle(function(d) {
                        return yscale(d[1]);
                    });
            if (stacked) {
                var innerPadding,
                    outerPadding;

                if (defined(levelMarkerConf.bandWidth) || defined(levelMarkerConf.maxBandWidth)) {
                    var maxLevelMarkerBandWidth = validateNullVal(levelMarkerConf.maxBandWidth, OR);
                    var levelMarkerBandWidth = Math.min(perToPx(levelMarkerConf.bandWidth, OR, (OR - IR)), maxLevelMarkerBandWidth);

                    innerPadding = ((OR -  IR) - levelMarkerBandWidth) / 2,
                    outerPadding = ((OR -  IR) - levelMarkerBandWidth) / 2;

                    visibility = (levelMarkerBandWidth === 0) ? "hidden" : null;
                } else {
                    innerPadding = mathMax(0, perToPx(levelMarkerConf.innerPadding, OR, 0)),
                    outerPadding = mathMax(0, perToPx(levelMarkerConf.outerPadding, OR, 0));
                }

                arc
                    .innerRadius(IR + innerPadding)
                    .outerRadius(OR - outerPadding - (0.5 * levelmarkerSW))
                    .startAngle(function(d) {
                        return yscale(d[0]);
                    });
            } else {
                var interPadding = perToPx(levelMarkerConf.interPadding, OR, 10),
                    len = data[0].data[0].length;
                var band = ((OR - IR) - ((len - 1) * interPadding)) / len;
                arc
                    .innerRadius(function(d, i) {
                        return (i * (band + interPadding)) + IR;
                    })
                    .outerRadius(function(d, i) {
                        return ((i + 1) * band) + (i * interPadding) + IR;
                    })
                    .startAngle(commonPlotOptions.startAngle);
            }
            var levelmarkerSeries = appendEle(container, "g", [1], ".", "class", "levelmarkerSeries");
            var levelmarker = appendEle(levelmarkerSeries, "path", (levelMarkerConf.enabled ? genLevels(data, levelMarkerConf) : []));
            levelmarker
                .attr("transform", "translate(" + plotarea_approx.x + "," + plotarea_approx.y + ")")
                .style({
                    "stroke": function(d, i) {
                        return levelMarkerConf.strokeColor || levelmarkerClr[i];
                    },
                    "stroke-width": levelmarkerSW,
                    "stroke-opacity": levelMarkerConf.strokeOpacity,
                    "fill-opacity": levelMarkerConf.fillOpacity,
                    "fill": function(d, i) {
                        var clr = levelmarkerClr[i];
                        var prop = getGradientProp(commonPlotOptions.gradients,[OR, OR],clr);
                        var gradientID = (prop) ? effects.get(svg_gradients,"svgGradientFill", prop, {"offset":"pie"}) : null;
                        return gradientID ? "url(" + defsLocation + "#" + gradientID + ")" : clr;
                    },
                    "visibility" : visibility
                });

            if (isredraw && (currentRadiusFactors != previousRadiusFactors)) {
                levelmarker
                    .transition()
                    .duration(transitionDuration)
                    .ease("linear")
                    .call(function(element){
                        arcInnerTween(element, arc, [previousInnerRadius, arc.innerRadius()()], [previousOuterRadius, arc.outerRadius()()]);
                    });
            } else {
                levelmarker
                    .attr("d", arc);
            }
            
            // add event listeners for dial level marker
            dialChartEventHandler(chartObj, levelmarker, levelMarkerConf, "levelmarker", data);
            
            commonRendererProp.commonPlotOptions(commonPlotOptions);
            pie.commonRendererProp(commonRendererProp);
            pie.chartRendered = false;
            container.call(pie);
            
            innerRadius = pie.innerRadius();
            
            // Target marker---
            var targetMarkerSeries = appendEle(container, "g", [1], ".", "class", "targetSeries");
            svg_plot_renderer.dial.targetMarker(targetMarkerSeries, plotarea_approx.actualRadius, plotarea_approx.innerRadius, chartObj)
            targetMarkerSeries
                .attr("transform", "translate(" + plotarea_approx.x + "," + plotarea_approx.y + ")");
            // ---Target marker
            
            var dialPath = appendEle(container, "path", (commonPlotOptions.needle.show ? [totalEngagement] : []), ".", "class", "dial");
            dialPath
                .attr("d", getNeedlePath())
                .style({
                    "stroke": commonPlotOptions.needle.strokeColor || "black",
                    "stroke-width": commonPlotOptions.needle.strokeWidth,
                    "fill": commonPlotOptions.needle.fillColor || "none"
                })
                .transition()
                .duration(transitionDuration)
                .ease(easingType)
                .call(dialTween);
            
            if ($ZC.labelRenderer) {
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "dial",
                    "chartObj": chartObj,
                    "args": [data, 0]
                });
            }
            
        });
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.endFunctions = function() {
        previousRadiusFactors = currentRadiusFactors;
        previousOuterRadius = arc.outerRadius()();
        previousInnerRadius = arc.innerRadius()();
        chart.chartRendered = true;
        isredraw = true;
    };
    
    function createDataForPie(data) {
        var dt = data[0].data[0];
        data[0].data[0] = [dt[0]];
        return [data];
    }
    
    function genLevels(data, levelMarkerConf) {
        var levels = [],
            dt = data[0].data[0];
        var origValues = dt[0][levelMarkerConf.dataindex] || levelMarkerConf.values || [],
            clr = levelMarkerConf.color;
        if (!(origValues instanceof Array)) {
            origValues = [origValues];
        }

        if (clr === undefined && origValues.length <= 1) {
            clr = ["#d1d1d1"];
        }
        
        if (origValues.length > 0) {
            var thValues = origValues.slice(0);
            if (!clr) { //If colors are not specified, create monochrome colors
                var baseClr = color[0],
                    domain = [0, thValues.length - 1],
                    range = [levelMarkerConf.colorGamma[0], levelMarkerConf.colorGamma[1]];
                var monoClrGen = getMonochromeColor(baseClr, domain, range);
            }
            thValues.sort(d3_ascending);
            var prev = minMax[0];
            thValues.forEach(function(d, i) {
                var thIdx = origValues.indexOf(d);
                var currentValue = Math.min( Math.max(d, minMax[0]), minMax[1] );
                levels[i] = [prev, currentValue];
                levelmarkerClr[i] = !clr ? monoClrGen(i) : clr[thIdx]; //if clr is null, monochrome colors will be applied using 'i', else user specified color is picked up using 'thIdx'
                prev = currentValue;
            });
        } else {
            dt.forEach(function(d, i) {
                levels[i] = minMax;
                levelmarkerClr[i] = ((clr instanceof Array) ? clr[i] : clr) || "#d1d1d1";
            });
        }
        return levels;
    }
    
    function getNeedlePath() {
        var needleConf = commonPlotOptions.needle;
        var wid = pick(needleConf.width / 2, 7),
            IR = -perToPx(needleConf.innerRadius, plotarea_approx.radius, 0),
            OR = -perToPx(needleConf.radius, plotarea_approx.radius, innerRadius) + needleConf.padding,
            minNeedleHeight = -3 * wid;

        OR = mathMin(OR, minNeedleHeight);

        switch (needleConf.type) {
            case "clock":
                return "M" + wid + " " + IR + " A" + wid + " " + wid + " 0 0 1 " + (-wid) + " " + IR + " A" + wid + " " + wid + " 0 0 1 " + wid + " " + IR + " " + "M0 " + (IR - wid) + " L0 " + OR + " M" + (-wid) + " " + (wid + OR) + " L0 " + OR + " L" + wid + " " + (wid + OR) + " L0 " + OR;
            case "sharp":
                return "M" + wid + " " + IR + " L" + 0 + " " + (IR + wid) + " L" + (-wid) + " " + IR + " L0 " + OR + " L" + wid + " " + IR;
            default:
                return "M" + wid + " " + IR + " A" + wid + " " + wid + " 0 0 1 " + (-wid) + " " + IR + " L0" + " " + OR + " L" + wid + " " + IR;
        }
    }
    
    function dialTween(element) {
        var cx = plotarea_approx.x,
            cy = plotarea_approx.y,
            baseValue = (commonPlotOptions.baseValue !== undefined) ? commonPlotOptions.baseValue : 0,
            currentValue,
            previousValue,
            currentAngle,
            previousAngle;

        element.attrTween("transform", function(d, i) {
            if (isredraw) {
                previousAngle = d3.transform(d3.select(this).attr("transform")).rotate;
            } else {
                previousValue = hasNegValue ? minMax[1] : minMax[0];
                if (baseValue != null) {
                    previousValue = hasNegValue
                        ? mathMin(baseValue, previousValue)
                        : mathMax(baseValue, previousValue);
                }
                previousAngle = radianToDegree( yscale(previousValue) );
            }

            currentValue = mathMin( mathMax(d, minMax[0]), minMax[1]); //currentValue should be in between min & max
            var currentAngle = radianToDegree( yscale(currentValue) );

            var interpolateAngle = d3_interpolate(previousAngle, currentAngle);
            return function(t) {
                return "translate(" + cx + "," + cy + ") rotate(" + interpolateAngle(t) + ",0,0)"
            };
        });
    }
    
    return chart;
};

svg_plot_renderer.dial.targetMarker = function(container, OR, innerRadius, chartObj) {
    var systemconf = chartObj.systemConf,
        commonPlotOptions = systemconf.chart.plot.plotoptions.dial,
        dataset = chartObj.dataset,
        index = 0;
    
    var yscale = chartObj.axes.y.groups[0].scale,
        minMax = yscale.domain(),
        data = chartObj.seriesdata;
    var targetMarkerOptions = commonPlotOptions.targetMarker;
    var align = targetMarkerOptions.align,
        dAlign = targetMarkerOptions.dAlign,
        padding = +(targetMarkerOptions.padding || 0),
        symbol_rotation = /line/.test(targetMarkerOptions.symbol) ? 90 : 0; //For line symbol, the symbol should be rotated by 90 degree
    
    var default_size = (!/(outer|inner)/g.test(align) && /line/.test(targetMarkerOptions.symbol)) ? ((OR - innerRadius - (2 * padding)) / 10) : 1;
    var size = validateNullVal(targetMarkerOptions.size, default_size) * 10;
    var extraOptions = {
        symbolSize: {
            outer: 1,
            inner: 0.5
        },
        color: chartObj.seriesColor[0],
        strokeWidth: default_size
    };
    var dr = (dAlign === "outer") // dr - shift along radius
        ?
        (size / 2) + padding :
        ((dAlign === "inner") ?
            -(size / 2) - padding :
            0);
    var r = (align === "outer") // radius
        ?
        (OR + dr) :
        ((align === "inner") ?
            (innerRadius + dr) :
            ((OR + innerRadius) / 2));
    
    var targetMarker = appendEle(container, "g", (targetMarkerOptions.enabled ? [data[0].data[0][0]] : []));
    
    targetMarker
        .attr("transform", function(d) {
            var targetValue = d[targetMarkerOptions.dataindex];
            if (defined(targetValue)) {
                targetValue = getTargetWithinDomain(targetValue);
                var angle_radian = yscale(targetValue);
                var xy = polarToXY(r, angle_radian);
                var angle_degree = radianToDegree(angle_radian) + symbol_rotation;
                return "translate(" + xy[0] + "," + xy[1] + ") rotate(" + angle_degree + ",0,0)";
            }
        })
        .style({
            "display": function(d) {
                var targetValue = d[targetMarkerOptions.dataindex];
                return !defined(targetValue) ? "none" : null;
            },
            "stroke-dasharray": getDashArray(targetMarkerOptions.dashStyle, validateNullVal(targetMarkerOptions.outerStrokeWidth, 1)),
            "stroke-linecap": getLineCap(targetMarkerOptions.lineCap, targetMarkerOptions.dashStyle)
        })
        .each(function(d) {
            var ele = d3_select(this);
            addSVGmarker(ele, null, targetMarkerOptions, extraOptions);
        });
    
    // add event listeners for dial target marker
    dialChartEventHandler(chartObj, targetMarker, targetMarkerOptions, "targetmarker", data);
    
    var targetLabelOptions = targetMarkerOptions.label || {};
    var targetLabelPadding = validateNullVal(targetLabelOptions.padding, 2);
    var targetLabelRadius = (align === "outer") ?
        (r + (size / 2) + targetLabelPadding) :
        ((align === "inner") ?
            (((dAlign === "outer") ? innerRadius : (r - (size / 2))) - targetLabelPadding) :
            (OR + targetLabelPadding));
    
    var targetLabel = appendEle(container, "text", (targetMarkerOptions.enabled && pick(targetLabelOptions.enabled, true)) ? [data[0].data[0][0]] : []);
    applyFont(targetLabel, [targetLabelOptions, systemconf.chart, systemconf.canvas, $ZCG]);
    
    targetLabel
        .each(function(d) {
            var ele = d3_select(this);
            ele
                .style("display", "none");

            var targetValue = d[targetMarkerOptions.dataindex];
            if (defined(targetValue)) {
                targetValue = getTargetWithinDomain(targetValue);
                if (!(!JSON.parse(commonPlotOptions.minmaxlabels.show) || minMax.indexOf(targetValue) == -1)) {
                    return;
                }
                var angle = yscale(targetValue);
                var angle_radian = d0_360(angle);
                var xy = polarToXY(targetLabelRadius, angle);
                
                var columns = chartObj.userdata.metadata.columns;
                var columnidx = columns.filter(function(d) {
                    return d.dataindex === targetMarkerOptions.dataindex;
                });
                var targetColumn = (columnidx.length) ? columnidx[0] : columns[dataset.getColumnIdx("y", 0)];
                var datatype = targetColumn.datatype;
                var formatConf = targetColumn[datatype];
                
                var TEXTANCHOR = (align === "inner") ?
                        (angle_radian < 0 || angle_radian > mathPI) ? null : "end" :
                        (angle_radian < 0 || angle_radian > mathPI) ? "end" : null,
                    DY = (align === "inner") ?
                        ((!(angle_radian > mathPI / 2 && angle_radian < 3 * mathPI / 2)) ? -getDY(angle_radian) + "em" : null) :
                        ((angle_radian > mathPI / 2 && angle_radian < 3 * mathPI / 2) ? getDY(angle_radian) + "em" : null),
                    TEXT = defined(targetLabelOptions.text) ? dataset.getCustomizedVal(chartObj, targetLabelOptions.text, index, null, null, d, "targetLabel") : getFormattedValue(formatConf, targetValue, datatype, chartObj, "targetLabel");
                
                ele
                    .text(TEXT)
                    .style("display", null)
                    .attr({
                        "text-anchor": TEXTANCHOR,
                        "dy": DY,
                        "transform": "translate(" + xy[0] + "," + xy[1] + ")"
                    });
            }
        });
    function getTargetWithinDomain(value) {
        return Math.min( Math.max(value, minMax[0]), minMax[1] );
    }
};

function dialChartEventHandler(chartObj, element, options, type, data) {
    var currentPoint = data[0].data[0][0],
        isLevelMarker = (type === "levelmarker"),
        commonPlotOptions = chartObj.systemConf.chart.plot.plotoptions.dial,
        tooltipEnabled = chartObj.systemConf.tooltip.enabled,
        events = options.events || {},
        metaInfo,
        formatConf,
        datatype;
    
    var isEventEnabled = validateNullVal(events.enabled, commonPlotOptions.events.enabled);
    var cursor = isEventEnabled ? (events.cursor || "pointer") : null;
    
    element
        .style("cursor", cursor);
    
    if (isEventEnabled) {
        var dataset = chartObj.dataset,
            columns = chartObj.userdata.metadata.columns;
        var columnidx = columns.filter(function(d) {
            return d.dataindex === options.dataindex;
        });
        var targetColumn = (columnidx.length) ? columnidx[0] : columns[dataset.getColumnIdx("y", 0)];
        datatype = targetColumn.datatype;
        formatConf = targetColumn[datatype];
        
        var mousemove = function(d, i) {
                var val = isLevelMarker ? d[1] : d[options.dataindex];

                var userCallback = createUserObject(d),
                    position = getTooltipPosition(d3.event, {
                        x: 0,
                        y: 0
                    }, 0, 0, chartObj, {
                        seriesPos: 0,
                        subseriesindex: 0,
                        itemPos: 0
                    });

                handleUserCallback(currentPoint, "mousemove", d3.event, d);

                if (tooltipEnabled) {
                    var tooltipContent = invokeFunction(events.tooltipContent, userCallback, chartObj) || ((isLevelMarker ? "Range: " : "Target: ") + userCallback.formattedValue);
                    var tooltip = chartObj.eventHandler.tooltipElement;
                    tooltip.show(chartObj, getTooltipPositionForNonAxisCharts(), tooltipContent, false, position.helpers);
                }
            },
            mouseout = function(d, i) {
                handleUserCallback(currentPoint, "mouseout", d3.event, d);

                if (tooltipEnabled) {
                    var tooltip = chartObj.eventHandler.tooltipElement;
                    tooltip.hide(tooltip.element);
                }
            },
            click = function(d) {
                handleUserCallback(currentPoint, "click", d3.event, d);
            },
            dblclick = function(d, i) {
                handleUserCallback(currentPoint, "doubleclick", d3.event, d);
            },
            eventAttacherOptions = {
                target: "plot",
                touchleave: true,
                chartObj: chartObj
            };
        var mouseHandlers = {
                "mousemove": mousemove,
                "mouseout": mouseout,
                "click": click,
                "dblclick": dblclick
            },
            touchHandlers = {
                "singletouchmove": mousemove,
                "touchend": mouseout,
                "tap": click,
                "dbltap": dblclick
            };
        attachevents(element, mouseHandlers, touchHandlers, eventAttacherOptions);
    }
    
    function getTooltipPositionForNonAxisCharts() {
        var mouse = getMousePosition(chartObj.svg.node(), d3.event);
        var relmousePt = {
            x: mouse[0],
            y: mouse[1]
        };
        var tooltipPos = {
            left: relmousePt.x,
            top: relmousePt.y
        };
        var evt = getEventObject(d3.event);
        var dLeft = relmousePt.x - evt.clientX,
            dTop = relmousePt.y - evt.clientY;
        tooltipPos.left -= dLeft;
        tooltipPos.top -= dTop;
        tooltipPos.dLeft = dLeft;
        tooltipPos.dTop = dTop;
        return tooltipPos;
    }
    
    function handleUserCallback(data, type, event, d) {
        return invokeFunction(events[type], event, createUserObject(d), chartObj);
    }
    
    function createUserObject(d) {
        var val = isLevelMarker ? d[1] : d[options.dataindex];
        return {
            value: val,
            formattedValue: getFormattedValue(formatConf, val, datatype, chartObj),
            actualData: currentPoint,
            data: (metaInfo = metaInfo || chartObj.dataset.getMetaInfoObj(chartObj, currentPoint, 0))
        };
    }
}//$Id$
/**
 *
 * @returns {chart} packedbubble renderer.
 */
svg_plot_renderer.packedbubble = function() {
    var pack = d3_pack(),
        isredraw = false,
        commonRendererProp,
        bubbleGroup,
        path,
        chartObj,
        commonPlotOptions,
        mode,
        seriesGroup = [],
        zchighlighterPosition,
        highlightGroup,
        highlightEle,
        multiColoring,
        valueFunction,
        includeDisabledSeries;
    
    function chart(selection) {
        selection.each(function(data) {
            //renderer config values
            var rp = commonRendererProp.params;
            chartObj = rp.chartObj;
            var color = rp.color,
                notesArray = rp.notesArray,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                dataset = rp.dataset,
                systemconf = chartObj.systemConf,
                labelQueue = rp.labelQueue;
            
            commonPlotOptions = rp.commonPlotOptions;
            var fillColor = chart.fillColorFunc = getFillColor(chartObj, 0),
                strokeColor = getStrokeColor(chartObj, 0);
            
            var cloneddata = data.filter(function(d, i) {
                    d.seriesIndex = i;
                    seriesGroup[i] = [];
                    return !d.disabled;
                }),
                chartWidth = chartObj.plotarea.width,
                chartHeight = chartObj.plotarea.height,
                gvpFn = $ZC.utils.getValueOfPlotOptions,
                isSingleSeries = (cloneddata.length === 1),
                isPatternPalleteEnabled = hasPatternPallete(chartObj) || chartObj.patternPallete,
                notesOptions = chartObj.systemConf.notes,
                notesEnabled = notesOptions && notesOptions.enabled === true && notesOptions.plotValues,
                index;
            mode = commonPlotOptions.mode;
            multiColoring = commonPlotOptions.multiColoring === true && !chartObj.legendarea.show;
            
            var NegativeAsAbsolute = commonPlotOptions.showAsNegative === "absolute",
                interPadding = (+commonPlotOptions.interPadding || 0),
                outerPadding = (+commonPlotOptions.outerPadding || 0),
                diameter = mathMin(chartWidth, chartHeight) - outerPadding;

            zchighlighterPosition = [(chartObj.plotarea.left + (chartWidth - diameter) / 2), (chartObj.plotarea.top + ((chartHeight - diameter) / 2))];
            valueFunction = function(d) {
                if (!includeDisabledSeries && isDisabled(d)) {
                    return 0;
                }
                var y = dataset.getY(d, yaxiscolumnorder) || 0;
                if (y < 0) {
                    return NegativeAsAbsolute ? mathAbs(y) : 0;
                }
                return y;
            };
            
            var eventDisabled = (validateNullVal(getEventConf(null, commonPlotOptions, chartObj, "enabled"), true) == false);
            var cursor = (commonPlotOptions.events) ? commonPlotOptions.events.cursor || "pointer" : systemconf.chart.plot.events.cursor || "pointer";
            
            //Animation variables
            var animationOptions = getAnimationConf(commonPlotOptions, null, chartObj, "packedbubble");
            var isAnimationEnable = animationOptions.enabled,
                animationType = animationOptions.type,
                easingType = animationOptions.easingType,
                transitionDuration = isredraw ? (isAnimationEnable ? 200 : 0) : animationOptions.duration;

            //Transition variables
            var initial_transform = function(d) {
                    var transform = d3_select(this).attr("transform");
                    return (transform != null) ? transform : "translate(" + diameter / 2 + "," + diameter / 2 + ")";
                },
                final_transform = function(d) {
                    return "translate(" + d.x + "," + d.y + ")";
                },
                initial_r = function(d) {
                    var r = d3_select(this).attr("r");
                    return (r != null) ? r : 0;
                },
                final_r = function(d) {
                    return d.r;
                },
                final_fillOpacity = function(d, i) {
                    return commonPlotOptions.fillOpacity;
                },
                final_strokeOpacity = function(d, i) {
                    return commonPlotOptions.strokeOpacity;
                },
                isFade = !isredraw && (animationType === "fade" || animationType === "fadeAll");

            //Initializing pack layout
            pack
                .size([diameter, diameter])
                .padding(interPadding);

            bubbleGroup = appendEle(selection, "g", [1], ".", "class", "hierarchychart");
            bubbleGroup
                .attr("transform", "translate(" + ((chartWidth - diameter) / 2) + "," + ((chartHeight - diameter) / 2) + ")")
                .style("cursor", cursor);
            path = appendEle(bubbleGroup, "circle", getPackNodeDescendants(data, true));

            path
                .attr({
                    "class": function(d) {
                        return "series_" + getSeriesPos(d);
                    }
                })
                .style("visibility", function(d) {
                    return isDisabled(d) ? "hidden" : null;
                });

            path = path.filter(function(d) {
                return !isDisabled(d);
            });
            path = path.data(getPackNodeDescendants(cloneddata));

            path
                .attr({
                    "transform": isFade ? final_transform : initial_transform,
                    "r": isFade ? final_r : initial_r
                })
                .style({
                    "fill": function(d, i) {
                        d.idx = i;
                        //Test_654.json
                        d.r = d.r || 0;
                        d.x = d.x || 0;
                        d.y = d.y || 0;
                        d.data.parent = d.parent;

                        if (notesEnabled) {
                            d.data.x = d.x;
                            d.data.y = d.y;
                        }

                        if (!d.children && d.parent) {// Test_655.json
                            seriesGroup[getSeriesPos(d)].push(d);
                        }

                        if (!d.depth) {
                            d.arcColor = (mode == "flat" || multiColoring || isSingleSeries) ? "none" : "grey";
                        } else if (mode !== "flat" && d.depth === 1 && multiColoring) {
                            d.arcColor = "grey";
                        } else {
                            d.arcColor = color[(multiColoring ? getItemPos(d) : getSeriesPos(d)) % color.length];
                        }

                        var baseClr = getBaseClr(d);
                        return d.fillColor = (!d.depth && isPatternPalleteEnabled) ? "none" : fillColor((multiColoring ? getItemPos(d) : getSeriesPos(d)), d.data, null, baseClr);
                    },
                    "fill-opacity": isFade ? 0 : final_fillOpacity,
                    "stroke-opacity": isFade ? 0 : final_strokeOpacity,
                    "stroke": function(d) {
                        if (commonPlotOptions.strokeColor) {
                            return commonPlotOptions.strokeColor;
                        } else if (d.children) {
                            return d.arcColor;
                        } else {
                            return strokeColor((multiColoring ? getItemPos(d) : getSeriesPos(d)), d.data);
                        }
                    },
                    "stroke-width": function(d) {
                        return commonPlotOptions.strokeWidth;
                    }
                });
            
            //Animation
            var total = path.size(),
                dur = (!isredraw && animationType === "fade") ? (transitionDuration / total) : transitionDuration,
                del = (animationType === "fade") ? dur : 0;
            
            path
                .transition()
                .delay(function(d, i) {
                    return isredraw ? 0 : (i * del);
                })
                .duration(dur)
                .ease(isredraw ? "linear" : easingType)
                .attr({
                    "transform": final_transform,
                    "r": final_r
                })
                .style({
                    "fill-opacity": final_fillOpacity,
                    "stroke-opacity": final_strokeOpacity
                });
            
            //Events
            if (!eventDisabled) {
                var mousemove = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.mouseMove(args);
                    },
                    mouseout = function(d, i) {
                        chartObj.eventHandler.mouseOut(chart, d, getSeriesPos(d));
                    },
                    click = function(d, i) {
                        var args = getEventArgs(d, i);
                        chartObj.eventHandler.click(chart, d, getSeriesPos(d), getItemPos(d), args);
                    },
                    dblclick = function(d, i) {
                        if (!chart.chartRendered) {
                            return;
                        }
                        var dt = $ZC.annotation ? generateDataForAnnotation(d.data, ((data.length > 1) ? d.parent.parent.seriesname : null)) : d.data;
                        var coordinates = [d.x, d.y];
                        coordinates = [(coordinates[0] + ((chartWidth - diameter) / 2)), (coordinates[1] + ((chartHeight - diameter) / 2))];
                        var args = {
                            "coordinate": coordinates,
                            "data": dt,
                            "basedOn": "plot"
                        };
                        chartObj.eventHandler.doubleclick(d, getSeriesPos(d), args);
                    },
                    eventAttacherOptions = {
                    target: "plot",
                    touchleave: true,
                    chartObj: chartObj
                };
                var mouseHandlers = {
                    "mousemove": mousemove,
                    "mouseout": mouseout,
                    "click": click,
                    "dblclick": dblclick
                },
                touchHandlers = {
                    "singletouchmove": mousemove,
                    "touchend": mouseout,
                    "tap": click,
                    "dbltap": dblclick
                };
                attachevents(path.filter(function(d) {
                    return !d.children;
                }), mouseHandlers, touchHandlers, eventAttacherOptions);
            }
            
            chart.renderedTimer = setTimeout(function() {
                //Annotation preprocessing
                if ($ZC.annotation) {
                    data.forEach(function(series, i) {
                        notesArray = $ZC.annotation.preprocessAnnotations(data, i, function(dt, k, j) {
                            var c = [dt.x, dt.y];
                            return [(c[0] + ((chartWidth - diameter) / 2)), (c[1] + ((chartHeight - diameter) / 2))];
                        }, notesArray, chartObj, rp);
                    });
                }
                
                if ($ZC.labelRenderer) {
                    var transform = [(chartWidth - diameter) / 2, (chartHeight - diameter) / 2],
                        totalFunc = function(d) {
                            return d.parent.value
                        };
                    data.forEach(function(d, i) {
                        labelQueue.push({
                            "renderer": chart,
                            "charttype": "hierarchy",
                            "chartObj": chartObj,
                            "args": [data[i], i, null, null, totalFunc, seriesGroup[i], transform]
                        });
                    });
                }
                
                isredraw = true;
                chart.chartRendered = true;
            }, (transitionDuration + 17));

            function getEventArgs(d, i) {
                var ev = getEventObject(d3.event);
                return {
                    "renderer": chart,
                    "seriesPos": getSeriesPos(d),
                    "subseriesPos": 0,
                    "itemPos": getItemPos(d),
                    "coordinates": [ev.pageX, ev.pageY],
                    "element": this,
                    // "color": d.arcColor,
                    "data": d
                };
            }
        });
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.defaultMouseOverFunc = function(d, seriesPos, itemPos) {
        if (!highlightGroup) {
            highlightGroup = chartObj.staticPaneSVG.selectAll("g#zchierarchyhighlight");
            highlightEle = appendEle(highlightGroup, "path", [1]);
        }

        var refElement = d3_select(path[0][d.idx]);
        var refElementPosition = d3_transform(refElement.attr("transform")).translate;
        var highlightEffect = chartObj.legendHighlight.getLegendHighlightEffect(seriesPos, "selectedSeries", "plot");
        var currentColor = getRawColor(chartObj, (multiColoring ? itemPos : seriesPos), d.data, seriesPos);

        highlightGroup
            .style("opacity", null);
        highlightEle
            .attr({
                "transform" : "translate(" + (zchighlighterPosition[0] + refElementPosition[0]) + "," + (zchighlighterPosition[1] + refElementPosition[1]) + ")",
                "d" : getSVGsymbol("circle")(+refElement.attr("r") * 2)
            })
            .style(chartObj.legendHighlight.getEffect(highlightEffect, "packedbubble", (/(illuminate|moody|flip)/.test(highlightEffect) ?  currentColor : "transparent"), {fill: "transparent", stroke: currentColor}, (multiColoring ? itemPos : seriesPos)));
    };
    
    chart.defaultMouseOutFunc = function(d, i) {
        highlightGroup
            .style("opacity", 0);
    };
    
    function getNodes(root) {
        var leafNodes = [];
        
        function recurse(node, prevID) {
            var child = getChildren(node);
            if (child) {
                child.forEach(function(c, i) {
                    var ID = defined(prevID) ? (prevID + "_" + i) : (c.seriesIndex + "");
                    parseID(c, ID);
                    recurse(c, ID);
                });
            } else {
                parseID(node, prevID);
                if (mode == "flat") {
                    leafNodes.push(node);
                }
            }
        }
        
        function parseID(node, ID) {
            var indices = ID.split(/_/);
            node.seriesPos = +indices[0];
            node.itemPos = +indices[indices.length - 1];
        }
        
        recurse(root);
        return (mode == "flat") ? leafNodes : root;
    }
    
    function getChildren(node) {
        var depth = node.level && node.level.split("_").length;
        if (!chartObj.dataObject.hasHierarchyData && depth == 1 && node.length < 2 && node[0] && isArray(node[0][0])) {
            return node[0];
        } else if (isArray(node[0])) {
            if (isArray(node[0][0])) {
                return node;
            } else {
                return node.filter(function(d) {
                    return valueFunction(d) > 0;
                });
            }
        } else {
            return null;
        }
    }

    function getSeriesPos(d) {
        var level = d.level || (d.data && d.data.level);
        if (level) {
            return +level.split("_")[0];
        }
    }

    function getItemPos(d) {
        return d.data.itemPos;
    }

    function getBaseClr(d) {
        return d.children ? d.arcColor : null;
    }

    function isDisabled(d) {
        var seriesIndex = getSeriesPos(d);
        return defined(seriesIndex) && chartObj.seriesdata[seriesIndex].disabled;
    }

    function getPackNodeDescendants(data, include) {
        includeDisabledSeries = include;
        var root = d3.hierarchy(getNodes(data), getChildren)
            .sum(valueFunction)
            .sort(d3_ascending);

        pack(root);
        return root.descendants();
    }
    
    return chart;
};//$Id$
/**
 *
 * @returns {chart} bubblePie.
 */
/*
 PENDING :
 -------
 1) Total datalabel
 2) Annotation at centre / on arc?
 */
svg_plot_renderer.bubblepie = function() {
    var shiftInfo, commonRendererProp,
        redraw = false;
    
    function chart(selection) {
        selection.each(function(data) {
            
            //renderer config values
            var rp = commonRendererProp.params;
            var chartObj = rp.chartObj,
                index = rp.datasetIndex,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                axisrotated = rp.axisrotated,
                stacked = rp.stacked,
                xscale = rp.xscale,
                yscale = rp.yscale,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                labelQueue = rp.labelQueue;
            
            var container = d3_select(this);
            var currentdata = data[index];
            var plotoptions = currentdata.plotoptions;
            var currentseriesdata = currentdata.data;
            
            var animationOptions = getAnimationConf(commonPlotOptions, plotoptions, chartObj, "bubblepie");
            var transitionDuration = animationOptions.duration;
            
            var pieData = chartObj.dataObject.bubblepieData,
                pieRenderer = chartObj.subrenderer;
            
            var series = appendEle(container, "g", (pieData ? [1] : []), ".", "class", "scatterseries");
            if (pieData) {
                pieData.forEach(function(piedatum, ssi) {
                    pieRenderer[ssi] = pieRenderer[ssi] || {};
                    var subseries = appendEle(series, "g", [1], ".", "class", ("subseries_" + ssi));
                    var g = subseries.selectAll('g.scatter').data(piedatum, function(d) {
                        return d && dataset.getX(d); // Test_605.json
                    });
                    g.enter().append("g").attr("class", "scatter");
                    g.exit().remove();
                    
                    g.each(function(d, i) {
                        if (!d) { // Test_605.json
                            return;
                        }

                        var dt = d[chartObj.bubblePieRendererIndex]; //chartObj.bubblePieRendererIndex -> For combinational chart, it will help to identify the first bubblepie series
                        var X = dataset.getX(dt);
                        pieRenderer[ssi][X] = (pieRenderer[ssi][X] || svg_plot_renderer.pie())
                            .commonRendererProp(commonRendererProp);
                        var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, dt, "x") || 0,
                            y = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, dt, "y") || 0,
                            size = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, dt, "z", chartObj.zscale);
                        pieRenderer[ssi][X].plotarea({
                            width: size,
                            height: size,
                            left: (x - size / 2),
                            top: (y - size / 2)
                        });
                        pieRenderer[ssi][X].chartRendered = false;
                        d3_select(this)
                            .attr("transform", "translate(" + (x - size / 2) + "," + (y - size / 2) + ")")
                            .call(pieRenderer[ssi][X]);
                    });
                });
            }
            
            chart.renderedTimer = setTimeout(function() {
                redraw = true;
                chart.chartRendered = true;
                
                var seriesData = chartObj.seriesdata;
                seriesData.forEach(function(d, i) {
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "scatter",
                        "chartObj": chartObj,
                        "args": [d, i]
                    });
                    labelQueue.push({
                        "renderer": chart,
                        "charttype": "pieInnerLabels",
                        "chartObj": chartObj,
                        "args": [seriesData, i, pieData]
                    });
                });
                
            }, (transitionDuration));
        });
        return chart;
    }
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };

    return chart;
};//$Id$
function get_threshold_text_orient(orient) {
    return /(left|right)/.test(orient) ? "bottom" : "left";
}

function overrideThresholdFonts(systemConf, userOptions) {
	for (var attr in userOptions) {
		if (userOptions.hasOwnProperty(attr)) {
			systemConf[attr] = userOptions[attr];
		}
	}

	return systemConf;
}

function getCustomThresholdText(text, data, colInfo, chartObj) {
    var dataType = colInfo.datatype,
        format = colInfo[dataType],
        type = "threshold",
        decode = false;

    return text.replace(CUSTOM_VALUE_PATTERN, function($1, index) {
        var val = "";
        if (isArray(data[index])) {
            val = getFormattedValue(format, data[index][0], dataType, chartObj, type, decode);
            val += " - " + getFormattedValue(format, data[index][1], dataType, chartObj, type, decode);
        } else {
            val = getFormattedValue(format, data[index], dataType, chartObj, type, decode);
        }
        return val;
    });
}
//$Id$
$ZC.axis.threshold = function(chartObj, update) {
    var threshold = {};
    
    var systemconf = chartObj.systemConf;
    var xaxisdata = systemconf.chart.axes.xaxis;
    var xaxis_userdata = isObjectPropDefined(chartObj.userdata, "chart.axes.xaxis") ? chartObj.userdata.chart.axes.xaxis : {};
    //X- Threshold Line
    if (xaxis_userdata.threshold != null && xaxis_userdata.threshold.line != null) {
        drawThreshold(chartObj.axes.x, xaxisdata.threshold.line, 0, update, "x", "line", xaxis_userdata.threshold.line);
    }
    
    //X- Threshold range
    if (xaxis_userdata.threshold != null && xaxis_userdata.threshold.range != null) {
        drawThreshold(chartObj.axes.x, xaxisdata.threshold.range, 0, update, "x", "range", xaxis_userdata.threshold.range);
    }
    
    //Y- Threshold line
    var yaxesdata = systemconf.chart.axes.yaxis;
    var yaxes_userdata = isObjectPropDefined(chartObj.userdata, "chart.axes.yaxis") ? chartObj.userdata.chart.axes.yaxis : {};
    for (var i = 0; i < chartObj.axes.y.count; i++) {
        if (yaxes_userdata != null && yaxes_userdata[i] != null && yaxes_userdata[i].threshold != null && yaxes_userdata[i].threshold.line != null) {
            drawThreshold(chartObj.axes.y.groups[i], yaxesdata[i].threshold.line, i, update, "y", "line", yaxes_userdata[i].threshold.line);
        }
        //Y-Threshold range
        if (yaxes_userdata != null && yaxes_userdata[i] != null && yaxes_userdata[i].threshold != null && yaxes_userdata[i].threshold.range != null) {
            drawThreshold(chartObj.axes.y.groups[i], yaxesdata[i].threshold.range, i, update, "y", "range", yaxes_userdata[i].threshold.range);
        }
    }
    
    
    function createthreshold(axis, data, index, category) {
        if (axis) {
            if (!axis.threshold) {
                axis.threshold = {}
            }
            axis.threshold[category] = (data.show) ? (category == "line") ? $ZC.axis.threshold.line() : $ZC.axis.threshold.range() : null;
            return axis.threshold[category];
        }
        return null;
    }
    
    function setThresholdProp(renderer, axisObj, index, type, category, userdata) {
        var values;
        threshold.axisObj = function(_) {
            if (!arguments.length) {
                return axisObj;
            }
            axisObj = _;
            return threshold;
        };
        threshold.thresholdIndex = function(_) {
            if (!arguments.length) {
                return index;
            }
            index = _;
            return threshold;
        };
        threshold.type = function(_) {
            if (!arguments.length) {
                return type;
            }
            type = _;
            return threshold;
        };
        threshold.values = function(_) {
            if (!arguments.length) {
                return values;
            }
            values = _;
            return threshold;
        };
        threshold.chartObj = function(_) {
            if (!arguments.length) {
                return chartObj;
            }
            chartObj = _;
            return threshold;
        };
        threshold
            .thresholdIndex(index)
            .type(type)
            .values(userdata.values)
            .chartObj(chartObj);
        if (category == "line") {
            threshold.axisObj(axisObj)
        }
        renderer.parentObj(threshold);
        return renderer;
    }
    
    function drawThreshold(axisObj, data, index, update, type, category, userdata) {
        var isUnderlayThreshold = userdata && userdata.underlay ;
        var thresholdGroup = (isUnderlayThreshold ? chartObj.svg : chartObj.staticPaneSVG).selectAll("g.threshold");
        
        var axisWrap = chartObj.svg.selectAll("g." + type + "-axis-" + index);
        var visibility = (axisWrap != null && !axisWrap.empty() && (axisWrap.style("visibility") == "" || axisWrap.style("visibility") == "visible")) ? "visible" : "hidden";
        var thWrap = appendEle(thresholdGroup, "g", ((userdata.show && visibility == "visible") ? [data] : []), ".", "class", ("threshold" + category + "-" + type + "-axis-" + index));
        // thWrap.style("visibility",visibility);
        
        if (axisObj != null && data.show) {
            
            var renderer = (update && axisObj.threshold != null && axisObj.threshold[category] != null) ? axisObj.threshold[category] : createthreshold(axisObj, data, index, category);
            renderer = setThresholdProp(renderer, axisObj, index, type, category, userdata);
            
            thWrap
                .call(renderer);
        }
    }
};

$ZC.axis.threshold.textAlign = function(hAlign, type, plotarea, axesRotated, padding, orient) {
    var x;
    padding = padding || 0;
    if (hAlign == "left") {
        if (axesRotated) {
            if (orient == "left" || orient == "bottom") {
                x = (type == "x") ? padding : plotarea.height - padding;
            } else {
                x = (type == "x") ? padding : plotarea.height - padding;
            }
        } else {
            if (orient == "left" || orient == "bottom") {
                x = (type == "x") ? plotarea.height - padding : padding;
            } else {
                x = (type == "x") ? padding : plotarea.width - padding;
            }
        }
    } else if (hAlign == "center") {
        if (axesRotated) {
            if(orient === "left" || orient === "bottom") {
                x = (type == "x") ? (plotarea.width + padding) / 2 : (plotarea.height - padding) / 2;
            } else {
                x = (type == "x") ? (plotarea.width - padding) / 2 : (plotarea.height + padding) / 2;
            }
        } else {
            if (orient == "left" || orient == "bottom") {
                x = (type == "x") ? (plotarea.height - padding) / 2 : (plotarea.width + padding) / 2;
            } else {
                x = (type == "x") ? (plotarea.height + padding) / 2 : (plotarea.width - padding) / 2;
            }
            
        }
    } else if (hAlign == "right") {
        if (axesRotated) {
            x = (type == "x") ? plotarea.width : 0;
        } else {
            if (orient == "left" || orient == "bottom") {
                x = (type == "x") ? 0 : plotarea.width;
            } else {
                x = (type == "x") ? plotarea.height : 0;
            }
            
        }
    }
    return x
};
//$Id$
$ZC.axis.threshold.line = function() {
    var scale, index, plotarea, systemconf, chartObj, axesRotated, type, parentObj, axisObj, values;
    
    function chart(selection) {
        selection.each(function(data) {
            var container = d3_select(this);
            chart.update = function() {
                container.transition().call(chart);
            };
            
            chartObj = parentObj.chartObj();
            index = parentObj.thresholdIndex();
            type = parentObj.type();
            axisObj = parentObj.axisObj();
            values = parentObj.values();
            
            plotarea = chartObj.plotarea;
            var scale = axisObj.scale;
            var range = scale.range();
            range = range.slice(0, range.length);
            range.sort(function(a, b) {
                return a - b
            });
            var bandwidth = (scale.rangeBand != null) ? scale.rangeBand() / 2 : 0;
            var label = data.label;
            label = overrideThresholdFonts(label, isObjectPropDefined(chartObj.userdata, "chart.axes." + type + "axis" + (type === "x" ? "" : ("." + index)) + ".threshold.line.label", true));
            var markerInfo = data.marker || {};
            var markerEnabled = pick(markerInfo.enabled, true);
            axesRotated = chartObj.axes.rotated;
            systemconf = chartObj.systemConf;
            var thval = [],
                thname = [],
                thclr = [];
            
            // var yAxisColumnOrder = chartObj.systemConf.metadata.axes[type];
            // var colInfo = chartObj.systemConf.metadata.columns[index];
            
            var labelPadding = {
                "x": 2,
                "y": 2
            };
            var xAxisLine = systemconf.chart.axes.xaxis.axisline,
                yAxisLine = systemconf.chart.axes.yaxis[index].axisline;
            
            if (defined(xAxisLine) && xAxisLine.show) {
                labelPadding.x += +xAxisLine.strokeWidth - 1
            }
            
            if (defined(yAxisLine) && yAxisLine.show) {
                labelPadding.y += +yAxisLine.strokeWidth - 1
            }
            
            var count = 0;
            
            var hAlign = [],
                strokeDashArray = [],
                strokeWidth = [],
                markerWidth = [],
                markerBBox = [],
                markerSize = [],
                fontSizes = [],
                fontFamilies = [];
            
            var datatype = chartObj.dataset.getDataType(type, index);
            var formatConf;
            
            var colInfo = chartObj.dataset.getColumn(type, index),
                columnindex = chartObj.dataset.getColumnIdx(type, index);
            if (datatype == TIME_DATATYPE) {
                formatConf = getPropVal(colInfo, TIME_DATATYPE) || null;
            }
            
            values.map(function(d, i) {
                var d_scale = (d != null && d != "") ? (datatype == TIME_DATATYPE) ? ((generateDateVal(d, null, formatConf)).getTime()) : (d) : null;
                if (d != null && d !== "" && scale(d_scale) + bandwidth >= range[0] && scale(d_scale) + bandwidth <= range[range.length - 1]) {
                    thval[count] = d_scale;
                    thname[count] = getCustomThresholdText(getPropVal(data, "label.text[" + i + "]") || "", values, colInfo, chartObj);
                    thclr[count] = (isArray(data.color) ? data.color[i] : data.color) || "black";
                    hAlign[count] = (defined(data.label)) ? ((isArray(data.label.hAlign)) ? data.label.hAlign[i] : data.label.hAlign) || "center" : "center";
                    strokeWidth[count] = ((isArray(data.strokeWidth)) ? data.strokeWidth[i] : data.strokeWidth) || 1;
                    strokeDashArray[count] = ((isArray(data.dashStyle)) ? data.dashStyle[i] : data.dashStyle);
                    markerWidth[count] = (defined(data.marker) && data.marker.enabled) ? ((isArray(data.marker.strokeWidth)) ? data.marker.strokeWidth[i] : data.marker.strokeWidth) || 2 : null;
                    markerSize[count] = (data.marker && data.marker.enabled) ? (isArray(data.marker.size) ? data.marker.size[i] : data.marker.size) || 1 : null;
                    count++;
                }
            })
            var rect = chartObj.container.node().getBoundingClientRect(),
                bound = {
                    left: (rect.left + plotarea.left),
                    top: (rect.top + plotarea.top),
                    width: plotarea.width,
                    height: plotarea.height,
                    right: (rect.left + plotarea.left + plotarea.width),
                    bottom: (rect.top + plotarea.top + plotarea.height)
                },
                boundLeft = bound.left,
                boundTop = bound.top,
                orient = axisObj.component.orient(),
                margin = {
                    top: 0,
                    left: 0,
                    right: 0,
                    bottom: 0
                },
                overFlow = "..",
                thresholdEvents = chartObj.events.threshold = [];
            container.attr("transform", "translate(" + plotarea.left + "," + (plotarea.top) + ")");
            var wrap = appendEle(container, "g", [data], ".", "class", ('thresline-' + index));
            //plotarea border size to include in markerbox width
            var plotareaBorderEle = chartObj.container.selectAll("g.plotareaBorder-property").node();
            var plotareaBorder_bkp = plotareaBorderEle.border || plotareaBorderEle["border-" + orient];
            // var plotareaBorder_Oppbkp = (orient == "left") ? (plotareaBorderEle["border"] || plotareaBorderEle["border-right"]) : (orient == "right") ? (plotareaBorderEle["border"] || plotareaBorderEle["border-left"]) : null; //For dual side axes, need to consider border size on both axes
            var plotareaBorder_Oppbkp = plotareaBorderEle.border || plotareaBorderEle["border-" + getOppositeOrient(orient)];
            var wid1 = (plotareaBorder_bkp && plotareaBorder_bkp.clr !== "transparent") ? plotareaBorder_bkp.size : 0;
            var wid2 = (plotareaBorder_Oppbkp && plotareaBorder_Oppbkp.clr !== "transparent") ? plotareaBorder_Oppbkp.size : 0;
            var plotareaBorderWid_bkp = wid1 + wid2;

            var marker = appendEle(wrap, "path", ((markerInfo != null && markerEnabled) ? thval : []), ".", "class", "marker");
            marker
                .attr('d', function(d, i) {
                    return (getSVGsymbol(((isArray(markerInfo.symbol)) ? markerInfo.symbol[i] : markerInfo.symbol)))(markerSize[i] * 10)
                })
                // .attr("transform",function(d,i){return "translate("+((type == "x" && !axesRotated)||(type == "y" && axesRotated)? (scale(d)+bandwidth) : (0+(((markerWidth[i] || 1)*10)/2))) + "," + ((type == "x" && !axesRotated)||(type == "y" && axesRotated)? (plotarea.height-(((markerWidth[i] || 1)*10)/2)) :scale(d)+bandwidth)+")"})
                .style('stroke-width', function(d, i) {
                    return ((markerWidth[i]) || 2)
                })
                .style('stroke', function(d, i) {
                    return (isArray(markerInfo.strokeColor) ? markerInfo.strokeColor[i] : markerInfo.strokeColor) || thclr[i];
                })
                .attr('fill', function(d, i) {
                    var fillClr = isArray(markerInfo.fillColor) ? markerInfo.fillColor[i] : markerInfo.fillColor;
                    return fillClr || ((fillClr === null) ? thclr[i] : "white"); //If 'fillColor' is given as null explicitly by the user, use thclr
                });
            
            marker.attr("transform", function(d, i) {
                var mrkrWidth = markerWidth[i] / 2;
                var bbox = d3_select(this).node().getBBox();
                markerBBox[i] = (bbox.width + wid1);
                var translateX = (orient == "bottom" || orient == "top") ? (scale(d) + bandwidth) : (orient == "left") ? (mrkrWidth + wid1 + (bbox.width / 2)) : (plotarea.width - (mrkrWidth + wid1 + (bbox.width / 2))),
                    // translateY = (orient == "bottom") ? (plotarea.height - mrkrWidth - ((plotareaBorderWid_bkp + ((bbox.width) / 2)))) : (orient == "top") ? (mrkrWidth + plotareaBorderWid_bkp + ((bbox.height) / 2)) : (scale(d) + bandwidth);
                    translateY = (orient == "bottom") ? (plotarea.height - bbox.width / 2 - wid1 - mrkrWidth ) : (orient == "top") ? (mrkrWidth + (bbox.height) / 2) + wid1 : (scale(d) + bandwidth);

                    thresholdEvents.push({
                        x : translateX - (markerBBox[i] / 2),
                        y : translateY - (markerBBox[i] / 2),
                        width : markerBBox[i],
                        height : markerBBox[i],
                        color : thclr[i],
                        text : thname[i],
                        // value : d,
                        // columnindex : columnindex,
                        // eventOptions : data.events || {}
                    })
                return "translate(" + (translateX) + "," + (translateY) + ")"
            })
            
            var line = appendEle(wrap, "line", thval);
            line
                .attr('x1', function(d, i) {
                    return ((orient == "bottom" || orient == "top") ? (scale(d) + bandwidth) : (orient == "left" ? (markerBBox[i] || 0) + (markerWidth[i]) : wid2))
                })
                .attr('y1', function(d, i) {
                    return ((orient == "bottom") ? wid1 : (orient == "top") ? (markerBBox[i] || 0) + (markerWidth[i]) : (scale(d) + bandwidth))
                })
                .attr('x2', function(d, i) {
                    return ((orient == "bottom" || orient == "top") ? (scale(d) + bandwidth) : (orient == "left") ? (plotarea.width - wid2) : (plotarea.width - (markerWidth[i]) - (markerBBox[i] || 0)))
                })
                .attr('y2', function(d, i) {
                    return ((orient == "bottom") ? (plotarea.height - (markerWidth[i]) - ((markerBBox[i] || 0))) : (orient == "top") ? (plotarea.height - wid2) : (scale(d) + bandwidth))
                })
                .attr('stroke', function(d, i) {
                    return ("    " + thclr[i])
                })
                .attr('stroke-width', function(d, i) {
                    return strokeWidth[i] + "px"
                })
                .attr("shaperendering", "crispedges")
                .attr('stroke-dasharray', function(d, i) {
                    return getDashArray(strokeDashArray[i], strokeWidth[i])
                })
            
            
            var text = appendEle(wrap, "text", ((label != null) ? thval : []));
            text
                .text(function(d, i) {
                    return decodeHTML(thname[i]);
                })
                .attr('x', function(d, i) {
                    
                    var textPadding = markerSize[i] * 10 + labelPadding[type] + (markerWidth[i] || 2);
                    var x = ((type == "x" && !axesRotated) || (type == "y" && axesRotated)) ? -($ZC.axis.threshold.textAlign(hAlign[i] || "right", type, plotarea, axesRotated, textPadding, orient)) : $ZC.axis.threshold.textAlign(hAlign[i] || "right", type, plotarea, axesRotated, textPadding, orient);
                    return x
                })
                .attr('y', function(d, i) {
                    var y = ((type == "x" && !axesRotated) || (type == "y" && axesRotated) ? (scale(d) + bandwidth) : scale(d) + bandwidth);
                    return y - 5;
                })
                
                .attr("transform", ((type == "x" && !axesRotated) || (type == "y" && axesRotated)) ? "rotate(-90)" : "rotate(0)")
                .style({
                    "font-family": function(d, i) {
                        fontFamilies[i] = ((isArray(label.fontFamily)) ? label.fontFamily[i] : label.fontFamily) || systemconf.chart.fontFamily || systemconf.canvas.fontFamily || $ZCG.fontFamily;
                        return fontFamilies[i];
                    },
                    "font-size": function(d, i) {
                        fontSizes[i] = $ZC.utils.getVal(((isFunction(label.fontSize) || isArray(label.fontSize)) ? label.fontSize[i] : label.fontSize) || systemconf.chart.fontSize || systemconf.canvas.fontSize)
                        return fontSizes[i] + "px"
                    },
                    "fill": function(d, i) {
                        return ((isArray(label.fontColor)) ? label.fontColor[i] : label.fontColor) || systemconf.chart.fontColor || systemconf.canvas.fontColor || $ZCG.fontColor
                    },
                    "font-weight": function(d, i) {
                        return (((isArray(label.fontWeight)) ? label.fontWeight[i] : label.fontWeight) || systemconf.chart.fontWeight || systemconf.canvas.fontWeight || $ZCG.fontWeight)
                    },
                    "font-style": function(d, i) {
                        return (((isArray(label.fontStyle)) ? label.fontStyle[i] : label.fontStyle) || systemconf.chart.fontStyle || systemconf.canvas.fontStyle || $ZCG.fontStyle)
                    },
                    "text-Anchor": function(d, i) {
                        if (orient == "left" || orient == "bottom") {
                            return (hAlign[i] == "center") ? "middle" : (hAlign[i] == "right") ? "end" : "start"
                        } else {
                            return (hAlign[i] == "center") ? "middle" : (hAlign[i] == "right") ? "start" : "end"
                        }
                    }
                })
                .each(function(d, i) {
                    var text = decodeHTML(thname[i]);
                    var actualMarkerSize = markerSize[i] * 10,
                        textWidth = getTextWidth(text, fontSizes[i], fontFamilies[i]) + actualMarkerSize,
                        size = orient === "top" || orient === "bottom" ? plotarea.height : plotarea.width,
                        adjustment;

                    if(textWidth > size) {
                        adjustment = mathMin((textWidth - size), actualMarkerSize) + plotareaBorderWid_bkp;
                        bound.left = boundLeft + adjustment;
                        bound.top = boundTop + adjustment;
                        trimText(this, this.textContent, this.getBoundingClientRect(), bound, get_threshold_text_orient(orient), overFlow, margin);
                    }
                });
            
        });
    }
    
    chart.parentObj = function(_) {
        if (!arguments.length) {
            return parentObj;
        }
        parentObj = _;
        return chart;
    };
    
    // function align(hAlign,type,data){
    // 	var x;
    // 	if (hAlign == "left"){
    // 		if(axesRotated){
    // 			x = (type == "x")?0:plotarea.height;
    // 		}else{
    // 			x = (type == "x")?plotarea.height:0;
    // 		}
    // 	}else if(hAlign == "center"){
    // 		if(axesRotated){
    // 			x = (type == "x")?plotarea.width/2:plotarea.height/2;
    // 		}else{
    // 			x = (type == "x")?plotarea.height/2:plotarea.width/2;
    // 		}
    // 	}else if(hAlign == "right"){
    // 		if(axesRotated){
    // 			x= (type == "x")?plotarea.width:0;
    // 		}else{
    // 			x= (type == "x")?0:plotarea.width;
    // 		}
    // 	}
    // 	return x
    // }
    return chart;
};//$Id$
$ZC.axis.threshold.range = function() {
    var index, chartObj, type, parentObj;
    
    function chart(selection) {
        selection.each(function(data) {
            var container = d3_select(this);
            
            chartObj = parentObj.chartObj();
            index = parentObj.thresholdIndex();
            type = parentObj.type();
            
            var systemconf = chartObj.systemConf;
            var label = data.label;
            label = overrideThresholdFonts(label, isObjectPropDefined(chartObj.userdata, "chart.axes." + type + "axis" + (type === "x" ? "" : ("." + index)) + ".threshold.range.label", true));
            var fillColor = [],
                fillOpacity = [],
                strokeColor = [],
                strokeDashArray = [],
                lineCap = [],
                hAlign = [],
                thName = [],
                fontColor = [],
                fontSize = [],
                fontFamily = [],
                fontWeight = [],
                fontStyle = [];
            var rect = chartObj.container.node().getBoundingClientRect(),
                plotarea = chartObj.plotarea,
                bound = {
                    left: (rect.left + plotarea.left),
                    top: (rect.top + plotarea.top),
                    width: plotarea.width,
                    height: plotarea.height,
                    right: (rect.left + plotarea.left + plotarea.width),
                    bottom: (rect.top + plotarea.top + plotarea.height)
                },
                orient = chartObj.axes[type].orient,
                actualOrient = parentObj.axisObj().component.orient(),
                margin = {
                    top: 0,
                    left: 0,
                    right: 0,
                    bottom: 0
                },
                overFlow = "..";
            
            var wrap = appendEle(container, "g", (data.show ? [data] : []), ".", "class", ("thresholdrangegroup-" + type));
            
            var axesRotated = chartObj.axes.rotated;
            
            if (data.show) {
                var datatype = chartObj.dataset.getDataType(type, index);
                var formatConf;
                var colInfo = chartObj.dataset.getColumn(type, index);
                if (datatype == TIME_DATATYPE) {
                    formatConf = (colInfo.time != null) ? colInfo.time : null
                }
                var values = [],
                    arr = [];
                
                var labelPadding = {
                    "x": 2,
                    "y": 2
                };
                var xAxisLine = systemconf.chart.axes.xaxis.axisline,
                    yAxisLine = systemconf.chart.axes.yaxis[index].axisline;
                
                if (defined(xAxisLine) && xAxisLine.show) {
                    labelPadding.x += +xAxisLine.strokeWidth - 1
                }
                
                if (defined(yAxisLine) && yAxisLine.show) {
                    labelPadding.y += +yAxisLine.strokeWidth - 1
                }
                
                var scale_x = (!axesRotated) ? chartObj.axes.x.scale : chartObj.axes.y.groups[index].scale;
                var scale_y = (!axesRotated) ? chartObj.axes.y.groups[index].scale : chartObj.axes.x.scale;
                
                var isBarEnabled = chartObj.dataObject.noofBarEnabledSeries;
                var rangeBand_x = (scale_x.rangeBand != null && isBarEnabled) ? scale_x.rangeBand() : 0,
                    rangeBand_y = (scale_y.rangeBand != null && isBarEnabled) ? scale_y.rangeBand() : 0,
                    strangeBand_x = (scale_x.rangeBand != null && !isBarEnabled) ? scale_x.rangeBand() / 2 : 0,
                    strangeBand_y = (scale_y.rangeBand != null && !isBarEnabled) ? scale_y.rangeBand() / 2 : 0;
                
                var count = 0;
                var domain = (((type == "x" && !axesRotated) || (type == "y" && axesRotated)) ? scale_x : scale_y).domain();
                var domainLength = domain.length - 1;
                
                data.values.map(function(d, i) {
                    arr = (d != null && d != "") ?
                        d.map(function(dt) {
                            return (datatype == TIME_DATATYPE) ? generateDateVal(dt, null, formatConf).getTime() : dt;
                        }) :
                        null;
                    if (arr && !(arr[0] > domain[domainLength] || arr[1] < domain[0])) {
                        
                        /*
                         * Range should be within plot domain
                         */
                        arr[0] = mathMax(arr[0], domain[0]);
                        arr[1] = mathMin(arr[1], domain[domainLength]);
                        values[count] = arr;
                        
                        // rangeBoxRect properties
                        fillColor[count] = (isArray(data.fillColor) ? data.fillColor[i] : data.fillColor) || "grey";
                        fillOpacity[count] = validateNullVal((isArray(data.fillOpacity) ? data.fillOpacity[i] : data.fillOpacity), "0.2");
                        
                        strokeColor[count] = (isArray(data.strokeColor) ? data.strokeColor[i] : data.strokeColor) || "black";
                        strokeDashArray[count] = isArray(data.dashStyle) ? data.dashStyle[i] : data.dashStyle;
                        lineCap[count] = isArray(data.lineCap) ? data.lineCap[i] : data.lineCap;
                        
                        // rangeBoxText properties
                        hAlign[count] = (isArray(data.label.hAlign) ? data.label.hAlign[i] : data.label.hAlign) || "center";
                        thName[count] = getCustomThresholdText(getPropVal(data, "label.text[" + i + "]") || "", data.values, colInfo, chartObj);
                        
                        fontColor[count] = isArray(label.fontColor) ? label.fontColor[i] : label.fontColor;
                        fontStyle[count] = isArray(label.fontStyle) ? label.fontStyle[i] : label.fontStyle;
                        fontFamily[count] = isArray(label.fontFamily) ? label.fontFamily[i] : label.fontFamily;
                        fontWeight[count] = isArray(label.fontWeight) ? label.fontWeight[i] : label.fontWeight;
                        fontSize[count] = (label.fontSize instanceof Function || isArray(label.fontSize)) ? label.fontSize[i] : label.fontSize;
                        
                        count++;
                    }
                });
                
                var rangeBoxgroup = wrap.selectAll("g.rangebox-" + index).data(values);
                var rangeBoxgroupEnter = rangeBoxgroup.enter().append("g").attr("class", "rangebox-" + index);
                rangeBoxgroup.exit().remove();
                
                rangeBoxgroupEnter.append("rect");
                rangeBoxgroupEnter.append("text");
                
                var rangeBoxRect = rangeBoxgroup.select("rect");
                var rangeBoxText = rangeBoxgroup.select("text");
                
                
                rangeBoxRect.attr({
                        "x": function(d, i) {
                            return ((type == "x" && !axesRotated) || (type == "y" && axesRotated) ? (scale_x(d[0]) + strangeBand_x + chartObj.plotarea.left) : chartObj.plotarea.left + labelPadding[type])
                        },
                        "y": function(d, i) {
                            return ((type == "x" && !axesRotated) || (type == "y" && axesRotated) ? (chartObj.plotarea.top) : (scale_y(d[1]) + strangeBand_y + chartObj.plotarea.top))
                        },
                        "width": function(d, i) {
                            return ((type == "x" && !axesRotated) || (type == "y" && axesRotated) ? (scale_x(d[1]) - scale_x(d[0])) + rangeBand_x : chartObj.plotarea.width - labelPadding[type])
                        },
                        "height": function(d, i) {
                            return ((type == "x" && !axesRotated) || (type == "y" && axesRotated) ? chartObj.plotarea.height - labelPadding[type] : (scale_y(d[0]) - scale_y(d[1])) + rangeBand_y)
                        }
                    })
                    .style({
                        "fill": function(d, i) {
                            return fillColor[i];
                        },
                        "fill-opacity": function(d, i) {
                            return fillOpacity[i];
                        },
                        "stroke": function(d, i) {
                            return strokeColor[i];
                        },
                        "stroke-dasharray": function(d, i) {
                            return getDashArray(strokeDashArray[i]);
                        },
                        "stroke-linecap": function(d, i) {
                            return getLineCap(lineCap[i], strokeDashArray[i]);
                        }
                    });
                
                rangeBoxText
                    .attr({
                        "transform": function(d, i) {
                            var box = rangeBoxRect[0][i].getBBox();
                            var transY = $ZC.axis.threshold.textAlign(hAlign[i], type, chartObj.plotarea, axesRotated, labelPadding[type], orient);
                            if ((type == "x" && !axesRotated) || (type == "y" && axesRotated)) {
                                return "translate(" + (box.x + (box.width / 2)) + "," + (transY + chartObj.plotarea.top) + ") rotate(-90)";
                            }
                            return "translate(" + (transY + chartObj.plotarea.left) + "," + (box.y + (box.height / 2)) + ")";
                        },
                        "dy": "0.3em"
                    })
                    .style({
                        "font-family": function(d, i) {
                            return fontFamily[i] || systemconf.chart.fontFamily || systemconf.canvas.fontFamily || $ZCG.fontFamily;
                        },
                        "font-size": function(d, i) {
                            return $ZC.utils.getVal(fontSize[i] || systemconf.chart.fontSize || systemconf.canvas.fontSize) + "px";
                        },
                        "fill": function(d, i) {
                            return fontColor[i] || systemconf.chart.fontColor || systemconf.canvas.fontColor || $ZCG.fontColor;
                        },
                        "font-weight": function(d, i) {
                            return fontWeight[i] || systemconf.chart.fontWeight || systemconf.canvas.fontWeight || $ZCG.fontWeight;
                        },
                        "font-style": function(d, i) {
                            return fontStyle[i] || systemconf.chart.fontStyle || systemconf.canvas.fontStyle || $ZCG.fontStyle;
                        },
                        "text-Anchor": function(d, i) {
                            return (hAlign[i] == "center") ?
                                "middle" :
                                (hAlign[i] == "right") ?
                                    "end" :
                                    "start";
                        }
                    })
                    .text(function(d, i) {
                        return decodeHTML(thName[i]);
                    })
                    .each(function() {
                        trimText(this, this.textContent, this.getBoundingClientRect(), bound, get_threshold_text_orient(actualOrient), overFlow, margin);
                    });
                
            }
            
        })
    }
    
    chart.parentObj = function(_) {
        if (!arguments.length) {
            return parentObj;
        }
        parentObj = _;
        return chart;
    };
    return chart;
};//$Id$
$ZC.axis.threshold.overlay = function(chartObj, category, overlayData) {
    var axisrotated = chartObj.dataObject.getAxisRotated();
    if (category == "discrete") {
        var thvalues = overlayData.values.slice(0),
            overlayRange = overlayData.overlayRange,
            defaultColor = overlayData.defaultColor; //Use seriesColor for 'null' colors
    
        // old code
        // var thvalues_sort = thvalues.sort(function(a, b) {
        //     return ((overlayRange == "below") || (overlayRange == "equalandbelow")) ? (a < b ? -1 : a > b ? 1 : 0) : (a > b ? -1 : a < b ? 1 : 0);
        // });
        
        if ((overlayRange == "below") || (overlayRange == "equalandbelow")) {
            thvalues.sort(d3_ascending);
        } else {
            thvalues.sort(d3_descending);
        }
        
        
        return function(data, thColor, yvalue, seriescolor) {
            if (overlayData.values == null || overlayData.length == 0) {
                return seriescolor
            }
            
            for (var i = 0; i < thvalues.length; i++) {
                var compare = (thvalues[i]);
                /*
                 * For bottom oriented axis, if overlay range is below, yvalue should be lesser than thValue to have color overlay
                 * For bottom oriented axis, if overlay range is above, yvalue should be greater than thValue to have color overlay
                 *
                 * For left/right oriented axis, if overlay range is below, yvalue should be greater than thValue to have color overlay
                 * For left/right oriented axis, if overlay range is above, yvalue should be lesser than thValue to have color overlay
                 */

                var toCompare;
                switch(overlayRange) {
                    case "equal" :
                        toCompare = (yvalue === compare);
                        break;
                    case "equalandbelow":
                        toCompare = (yvalue <= compare);
                        break;
                    case "equalandabove":
                        toCompare = (yvalue >= compare);
                        break;
                    case "below":
                        toCompare = (yvalue < compare);
                        break;
                    default:
                        toCompare = (yvalue > compare);
                }

                if (toCompare) {
                    var index = overlayData.values.indexOf(compare);
                    return ((thColor == null || thColor[index] == null) ? (defaultColor ? seriescolor : "black") : thColor[index]);
                }
            }
            return seriescolor;
        }
    } else if (category == "continous") {
        
        return function(seriescolor, data, index, type) {
            
            /*
             * If type is x use Xaxis scale
             * If type is y use Yaxis scale
             */
            var scale = (type == "x") ? chartObj.axes.x.scale : chartObj.axes.y.groups[0].scale,
                temp = index;
            
            // var th = chartObj.axes.yaxis[0].threshold;
            var origValues = data.values;
            if (origValues == null || origValues.length == 0) {
                return seriescolor;
            }
            var thValues = origValues.slice();
            var negthClr = data.color;
            var overlayRange = data.overlayRange,
                defaultColor = data.defaultColor; //Use seriesColor for 'null' colors

            if (overlayRange) {
                overlayRange = overlayRange.replace("equaland", ""); //equalandabove = above, equalandbelow = below
            }
            // for time input format values
            var datatype = chartObj.dataset.getDataType(type, index);
            var formatConf;
            if (datatype == "time") {
                var column = chartObj.dataset.getColumn(type, index);
                formatConf = (column["time"] != null) ? column["time"] : null
            }
            thValues = thValues.map(function(d, i) {
                return (datatype == "time") ? ((generateDateVal(d, null, formatConf)).getTime()) : (d);
            })
            /*
             * For bottom oriented axis sort ascending
             * For left/right oriented axis sort descending
             */
            if ((type == "x" && !axisrotated) || (type == "y" && axisrotated)) {
                thValues.sort(function(a, b) {
                    return a < b ? -1 : a > b ? 1 : 0;
                });
            } else {
                thValues.sort(function(a, b) {
                    return a > b ? -1 : a < b ? 1 : 0;
                });
            }
            
            var scaleDomainLength = scale.domain().length;
            var range = ((type == "x" && !axisrotated) || (type == "y" && axisrotated)) ? scale(scale.domain()[scaleDomainLength - 1]) - scale(scale.domain()[0]) : scale(scale.domain()[0]) - scale(scale.domain()[scaleDomainLength - 1])
            var percent = [];
            percent.push(0);
            for (var i = 0; i < thValues.length; i++) {
                var val = scale(thValues[i]) + ((scale.rangeBand != null) ? (scale.rangeBand() / 2) : 0); //Half of the range band is added for the category scale
                var per = (val / range) * 100;

                if (per < 100) {
                    percent.push(per);
                    percent.push(per);
                }
            }

            percent.push(100);
            
            var color = [];
            if ((type == "y" && overlayRange == "below" && !axisrotated) || (type == "x" && overlayRange == "above" && !axisrotated) || (type == "y" && overlayRange == "above" && axisrotated) || (type == "x" && overlayRange == "below" && axisrotated)) {
                color.push(seriescolor)
            }
            
            for (var i = 0; i < thValues.length; i++) {
                var index = origValues.indexOf(thValues[i])
                color.push((negthClr == null || negthClr[index] == null) ? (defaultColor ? seriescolor : "black") : negthClr[index])
            }
            if ((type == "y" && overlayRange == "above" && !axisrotated) || (type == "x" && overlayRange == "below" && !axisrotated) || (type == "y" && overlayRange == "below" && axisrotated) || (type == "x" && overlayRange == "above" && axisrotated)) {
                color.push(seriescolor)
            }
            var offset = [];
            
            for (var i = 0; i < percent.length; i++) {
                var obj = {}
                obj.offset = percent[i] + "%";
                obj.color = ((i % 2) == 0) ? color[i / 2] : color[(i - 1) / 2]
                offset.push(obj)
            }
            
            var thresholdProp = {};
            thresholdProp.type = "thresholdLinear";
            thresholdProp.options = {};
            var options = thresholdProp.options;
            
            var scale_x = (!axisrotated) ? chartObj.axes.x.scale : chartObj.axes.y.groups[0].scale;
            var scale_y = (!axisrotated) ? chartObj.axes.y.groups[0].scale : chartObj.axes.x.scale;
            var isHorizontal = (type == "x" && !axisrotated) || (type == "y" && axisrotated);
            
            options.x1 = isHorizontal ? scale_x(scale_x.domain()[0]) : 0;
            options.x2 = isHorizontal ? scale_x(scale_x.domain()[scaleDomainLength - 1]) : 0;
            options.y1 = isHorizontal ? 0 : scale_y(scale_y.domain()[scaleDomainLength - 1]);
            options.y2 = isHorizontal ? 0 : scale_y(scale_y.domain()[0]);
            options.values = thValues;
            options.color = color;
            options.seriesclr = seriescolor;
            options.overlayRange = overlayRange;
            
            /*
             * Mandatory - The gradient ID should be changed whenever the scale domain is changing on scroll
             * test case : scroll-03.json
             */
            var domain = (isHorizontal ? scale_x : scale_y).domain();
            options.scale = domain[0] + "_" + domain[1];
            
            /**
             * This bellow two lines for passing stroke or fill opacity for area and line chart
             */
            
            var rendererMode = chartObj.plot.renderer.mode,
                chartName = chartObj.chartTypes[temp].name,
                plotOptions = chartObj.systemConf.chart.plot.plotoptions[chartName],
                opacity = (chartName === "line") ? plotOptions.strokeOpacity : plotOptions.fillOpacity,
                gradientDim = [options.x1, options.x2, options.y1, options.y2],
                prop = getGradientProp(thresholdProp,gradientDim,color,opacity),
                args = {"offset":chartName, "chartObj":chartObj, "offset":offset, "dimension":gradientDim, "color":color};
            var gradientID = (rendererMode == "svg") ? effects.get(svg_gradients, "svgGradientFill", prop, args) : effects.get(canvas_gradients, "canvasGradientFill", prop, args);
                
            return (rendererMode == "svg") ?  "url(" + chartObj.defsLocation + "#" + gradientID + ")" : gradientID;
        }
    }
};//$Id$
// function thresholdEventHandler(chartObj, eventRectangular) {
//     var thresholdPoints = chartObj.events.threshold || [],
//         tooltip = chartObj.eventHandler.tooltipElement,
//         columns = chartObj.systemConf.metadata.columns,
//         eventAttacherOptions = {
//             target: "plot",
//             chartObj: chartObj,
//             namespace: "threshold"
//         },
//         getColObj = function(colidx, value) {
//             var obj = simpleClone(columns[colidx] || {});
//             obj.value = value;
//             obj.columnindex = colidx;
//             return obj;
//         },
//         handleUserCallback = function(current, type, event) {
//             type = (d3.event && d3.event.zcEventType) || type;
//             var userObject = {
//                 color : current.color,
//                 data : getColObj(current.columnindex, current.value)
//             };

//             invokeFunction(current.eventOptions[type], event, userObject, chartObj);
//         };

//     var thresholdEvent = new $ZC.RectangleEventSurface(eventRectangular.node(), thresholdPoints, eventAttacherOptions);

//     thresholdEvent
//         .mousemove(function(event, mouseCoords) {
//             // thresholdEvent.stopPropagation();
//             chartObj.eventOnThreshold = true;
//             if (chartObj.eventHandler.oldInfo) {
//                 chartObj.eventHandler.oldInfo = null;
//                 chartObj.eventHandler.mouseOut();
//             }
            
//             if (this.eventOptions.mousemove) {
//                 handleUserCallback(this, "mousemove", event);
//             } else {
//                 var coordinate = {
//                     x: mouseCoords[0],
//                     y: mouseCoords[1]
//                 };


//                 var position = getTooltipPosition(event, coordinate, 0, 0, chartObj, {}, false, false, false, true, false);
//                 position.helpers.color = this.color;
//                 tooltip.element
//                     .attr("align", "center");
//                 tooltip.show(chartObj, position, this.text, false, position.helpers);
//             }

//         });
//     thresholdEvent.mouseleave(function(event) {
//         chartObj.eventOnThreshold = false;

//         if (this.eventOptions.mouseout) {
//             handleUserCallback(this, "mouseout", event);
//         }

//         tooltip.element
//             .attr("align", null);
//         tooltip.hide(tooltip.element);
//     });
//     thresholdEvent.click(function(event) {
//         thresholdEvent.stopPropagation();
//         handleUserCallback(this, "click", event);
//     });
//     thresholdEvent.dblclick(function(event) {
//         thresholdEvent.stopPropagation();
//         handleUserCallback(this, "doubleclick", event);
//     });
// }
//$Id$
$ZC.annotation = function() {
};
$ZC.annotation.draw = function(chart, notesArray) {
    "use strict";
    
    var notes = chart.systemConf.notes,
        notesEnabled = defined(notes) && notes.enabled === true;
    
    if (notesEnabled) {
        var isPolar = chart.dataObject.isPolarAxisCategory,
            chartAnnotations = pick(notes.chartValues, []);
        
        chartAnnotations.forEach(function(d) {
            $ZC.annotation.addNotes(chart, {
                "coordinate": [d.x, d.y],
                "conf": d
            });
        });
        
        if (chart.isAxisCategory || isPolar) {
            for (var i = 0, len = chart.seriesdata.length; i < len; i++) {
                var renderer = chart.renderer[i];
                if (chart.plot.renderer.mode === "image") {
                    renderer_helpers.setRendererProp(chart, renderer, chart.seriesdata, i, {
                        image: true
                    });
                }
                var rp = chart.rendererConf[i].params,
                    xy;
                var xscale = rp.xscale,
                    yscale = rp.yscale,
                    stacked = rp.stacked,
                    index = rp.datasetIndex,
                    axisrotated = rp.axisrotated,
                    yaxiscolumnorder = rp.yaxiscolumnorder;
                var categories = (chart.dataset.getDataType("x") == ORDINAL_DATATYPE) ? xscale.domain() : chart.dataObject.getCategories("x");
                
                var type = chart.chartTypes[index].value;
                if (isBarChartType(type)) {
                    xy = function(dt, i, j) {
                        var commonOption = renderer.commonOption || getBarCommonOption(chart.rendererConf[index], index);
                        return [chart.dataObject.getTransRectValue("x", dt, i, j, commonOption),
                            chart.dataObject.getTransRectValue("y", dt, i, j, commonOption)
                        ];
                    };
                } else {
                    xy = function(dt) {
                        var dxy = isPolar ? [chart.plotarea_approx.x, chart.plotarea_approx.y] : [0, 0];
                        return [(chart.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, dt, "x") + dxy[0]),
                            (chart.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, dt, "y") + dxy[1])
                        ];
                    }
                }
                notesArray = $ZC.annotation.preprocessAnnotations(chart.seriesdata, index, xy, notesArray, chart, rp, categories);
            }
        }
        notesArray.forEach(function(d) {
            $ZC.annotation.addNotes(chart, d);
        });
    }
    notesArray = [];
    return notesArray;
};
$ZC.annotation.addNotes = function(chart, args) {
    var noteConf = chart.systemConf.notes,
        chartWidth = chart.canvasarea.width,
        chartHeight = chart.canvasarea.height;
    var coordinate = args.coordinate,
        basedOn = args.basedOn || "chart",
        annotationData = args.data,
        val = args.conf || {},
        disabled = args.disabled;
    var displayMode = pick(val.type, noteConf.type, "stickyNote");
    
    
    var id = (basedOn == "plot") ?
        jsonStringify(annotationData) :
        ((basedOn == "block") ?
            generateIdByPropValue(val, "") :
            jsonStringify(coordinate));
    id = (basedOn != "plot" && (val.id != null) ? val.id : basedOn + id.replace(/[`~!@#$%^&*( )_|+\-=?;:'",.<>\{\}\[\]\\\/]/gi, ''));
    // check again
    val.id = id;
    //
    
    var container = appendEle(chart.notes, "div", [1], "#", "id", basedOn);
    container
        .style({
            "width": "0",
            "height": "0"
        });
    
    var annotation = appendEle(container, "div", [args], "#", "id", id);
    annotation
        .style({
            "display": (disabled ? "none" : null),
            "position": "absolute",
            "left": "0", // Position at left:0 & top:0. Else on redraw the annotation may be wrapped as it's previous position is out of div's current position. (e.g: threshold-02.json)
            "top": "0"
        });
    
    var annotationRenderer = $ZC.annotation[(displayMode === "stickyNote") ? "stickyNote" : "customNote"](),
        conf = mergeJSON(noteConf.options[displayMode], (args.conf || {}), true);
    annotationRenderer
        .chartObj(chart)
        .conf(conf);
    
    applyFont(annotation, [conf, chart.systemConf.canvas, $ZCG], true);
    annotation.call(annotationRenderer);
    
    var ele = annotation.node();
    var BW = (displayMode === "stickyNote") ? mathMax(parseFloat(annotation.selectAll(".head").style("width")), parseFloat(annotation.selectAll(".body").style("width"))) : 0,
        BH = (displayMode === "stickyNote") ? (parseFloat(annotation.selectAll(".head").style("height")) + parseFloat(annotation.selectAll(".body").style("height"))) : 0;
    
    coordinate = coordinate.map(function(d, i) {
        var val = (basedOn === "plot") ?
            (d + chart.plotarea[(i == 0) ? "left" : "top"]) //plot annotation
            :
            invokeFunction(d, chart, val, ele);
        return isNaN(+val) //Contains '%'
            ?
            perToPx(d, ((i == 0) ? chartWidth : chartHeight), 0) :
            val;
    });
    
    var transform = (basedOn === "plot" || basedOn === "block") ? val.transform : null;
    coordinate = invokeFunction(transform, chart, val, ele, coordinate) || coordinate;
    
    annotationRenderer.coordinate(coordinate);
    coordinate = getCoordinateWithinBound(coordinate[0], coordinate[1], BW, BH, chartWidth, chartHeight);
    
    annotation
        .style({
            "left": coordinate[0] + "px",
            "top": coordinate[1] + "px"
        });
    
    // check again
    var dt = (basedOn == "plot") ? annotationData : id;
    var index = getAnnotationIndex(noteConf, dt, basedOn);
    if (index == -1) {
        saveAnnotation(noteConf, dt, "", args.coordinate, basedOn);
    }
    //
    return annotation;
};
//Preprocessor for plot annotations to get the coordinate
$ZC.annotation.preprocessAnnotations = function(seriesdata, idx, coordinate, notesArray, chartObj, rp, categories) {

    if(chartObj.destroying) {
        return;
    }

    var notes = chartObj.systemConf.notes;
    
    if (!defined(notes) || notes.enabled === false) {
        return notesArray;
    }
    
    var notesConf = notes.plotValues,
        isAxisCat = chartObj.isAxisCategory,
        isNonAxisMultiSeriesCat = chartObj.isNonAxisMultiSeriesCategory,
        dataset = rp.dataset,
        stacked = rp.stacked,
        plotarea = chartObj.plotarea,
        yaxiscolumnorder = rp.yaxiscolumnorder,
        curSeries = seriesdata[idx];
    
    var curData = (chartObj.dataObject.isHierarchy ? curSeries : curSeries.data),
        serName = ((isAxisCat || isNonAxisMultiSeriesCat) && (seriesdata.length > 1)) ? curSeries.seriesname : null,
        chartType = chartObj.chartTypes[idx].name,
        seriesnames = chartObj.dataObject.seriesNames || (chartObj.dataObject.seriesNames = chartObj.seriesdata.map(function(d) {
                return d.seriesname;
            })); //Collect the series names

    var filteredNotes = (isAxisCat && (seriesdata.length > 1)) ? notesConf.filter(function(d) {
            var s = d.data[d.data.length - 1];
            return (serName == s) || (seriesnames.indexOf(s) == -1);
        }) : notesConf;
    
    filteredNotes.forEach(function(curNote, i) {
        var found = false,
            nData = curNote.data;
        for (var subseries = 0, slen = (isAxisCat ? curData.length : 1);
             (subseries < slen && !found); subseries++) {
            for (var j = 0, len = curData[subseries].length;
                 (j < len && !found); j++) {
                var dt = curData[subseries][j];
                var data = generateDataForAnnotation(dt, serName);
                if (jsonStringify(data) == jsonStringify(nData)) {
                    found = true;
                    var pos = coordinate(dt, subseries, j);
                    var disabled = (isAxisCat && !isWithin(pos, plotarea)) // Exclude if the data is out of domain
                        ?
                        true :
                        ((isAxisCat || isNonAxisMultiSeriesCat) ? curSeries.disabled : dt.disabled);
                    pushNotes(pos, data, curNote, disabled);
                }
            }
        }
        if (isAxisCat && !found && ((chartType === "bar") ? (categories.indexOf(dataset.getX(nData)) != -1) : true)) { //Non data points
            found = true;
            var dt = generateDataForAnnotation(nData);
            if (stacked) {
                dt.y = dataset.getY(nData, yaxiscolumnorder);
                dt.y0 = 0;
            }
            var pos = coordinate(dt, 0, j);
            var disabled = (isAxisCat && !isWithin(pos, plotarea)) // Exclude if the data is out of domain
                ?
                true :
                ((isAxisCat && (seriesdata.length > 1) && (seriesnames.indexOf(nData[nData.length - 1]) == -1)) //Non data points in multi series chart
                    ?
                    false :
                    curSeries.disabled);
            pushNotes(pos, dt, curNote, disabled);
        }
        if (!found && (chartType === "sunburst")) { // Sunburst parent arc
            var parentData = [serName, curSeries.value];
            if (jsonStringify(parentData) === jsonStringify(nData)) {
                pushNotes(coordinate(curSeries), parentData, curNote, curSeries.disabled);
            }
        }
    });
    return notesArray;
    
    function isWithin(coordinate, bound) {
        var x = coordinate[0],
            y = coordinate[1];
        return (x >= 0) && (y >= 0) && (x <= bound.width) && (y <= bound.height);
    }
    
    function pushNotes(coordinate, data, conf, disabled) {
        notesArray.push({
            "coordinate": coordinate,
            "data": data,
            "conf": conf,
            "disabled": disabled,
            "basedOn": "plot"
        });
    };
};

$ZC.annotation.addBlockAnnotations = function(chart) {
    var notes = chart.systemConf.notes;
    
    if (!defined(notes) || notes.enabled === false) {
        return;
    }
    
    var defaultAnnotationOptions = $ZC.setDefaultOptions("notes", chart.systemConf, chart.globalProp);
    var blockAnnotations = chart.systemConf.notes.blockValues,
        plotarea = chart.plotarea,
        drawnAtBottom, drawnAtTop;
    var PW = plotarea.width,
        PH = plotarea.height,
        PL = plotarea.left,
        PT = plotarea.top,
        PB = plotarea.bottom;
    blockAnnotations.forEach(function(d) {
        var hAlign = d.hAlign,
            vAlign = d.vAlign;
        var isRight = (hAlign === "right"),
            isLeft = (hAlign === "left"),
            isTop = (vAlign === "top"),
            isBottom = (vAlign === "bottom");
        
        if (!((drawnAtTop && isTop) || (drawnAtBottom && isBottom))) {
            var xFunc = function(chart, val, ele) {
                    var bound = ele.getBoundingClientRect();
                    var x = isRight ? (PL + PW) : (isLeft ? PL : (PL + (PW / 2))),
                        dx = isRight ? bound.width : (isLeft ? 0 : (bound.width) / 2);
                    return mathMax((x - dx), 0);
                },
                yFunc = function(chart, val, ele) {
                    var bound = ele.getBoundingClientRect();
                    var y = isTop ? PT : (PT + PH),
                        dy = isTop ? 0 : bound.height;
                    return (y - dy);
                };
            
            var note = $ZC.annotation.addNotes(chart, {
                "coordinate": [xFunc, yFunc],
                "conf": d,
                "basedOn": "block"
            });
            var bound = note.node().getBoundingClientRect();
            if (bound.height > (PH * 0.1)) {
                note.remove();
            } else {
                var bHei = bound.height;
                plotarea.height = PH - bHei;
                if (isTop) {
                    plotarea.top = PT + bHei;
                } else if (isBottom) {
                    plotarea.bottom = PB + bHei;
                }
            }
            
            drawnAtTop = drawnAtTop || isTop;
            drawnAtBottom = drawnAtBottom || isBottom;
        }
    });
};//$Id$
function generateDataForAnnotation(d, seriesname) {
    var clonedata = d.slice();
    var data = clonedata.splice(0, clonedata.length);
    if (seriesname != null) {
        data.push(seriesname);
    }
    return data;
}

function saveAnnotation(noteConf, id, text, coordinate, annotationType) {
    if (annotationType == "plot") {
        noteConf.plotValues.push({
            "data": id,
            "text": text
        })
    } else {
        noteConf[annotationType + "Values"].push({
            "id": id,
            "text": text,
            "x": coordinate[0],
            "y": coordinate[1]
        });
    }
}

function getCoordinateWithinBound(left, top, width, height, chartWidth, chartHeight) {
    // TODO I have to check with remila akka.
    if ((left + width) > chartWidth) {
        left = left - (left + width - chartWidth);
    }
    if ((top + height) > chartHeight) {
        top = top - (top + height - chartHeight);
    }
    return [left, top];
}

function getAnnotationIndex(noteConf, id, basedOn) {
    var conf = noteConf[basedOn + "Values"];
    return conf.indexOf(conf.filter(function(d) {
        return (basedOn === "plot") ?
            (jsonStringify(d.data) == jsonStringify(id)) :
            (d.id == id);
    })[0]);
}//$Id$
/*
 * z-index check
 * textarea resize
 * While opening a note, check within the plot
 * dragging
 */
$ZC.annotation.stickyNote = function() {
    var chartObj, conf, coordinate;
    
    function annotation(selection) {
        selection.each(function(args) {
            var container = d3_select(this);
            var noteConf = chartObj.systemConf.notes,
                chartWidth = chartObj.canvasarea.width,
                chartHeight = chartObj.canvasarea.height,
                notesWrap = chartObj.notes;
            
            var basedOn = args.basedOn || "chart",
                annotationData = args.data,
                disabled = args.disabled,
                xy = args.coordinate;
            
            var xInPercent = (typeof xy[0] === "string" && xy[0].indexOf("%") > -1),
                yInPercent = (typeof xy[1] === "string" && xy[1].indexOf("%") > -1);
            
            var text = conf.text,
                colorIndex = notesWrap.selectAll(".head").size(),
                bgColor = conf.color,
                open = (conf.mode === "open"),
                bodyWidth = validateNullVal(conf.bodyWidth, 100),
                bodyHeight = validateNullVal(conf.bodyHeight, 100),
                headWidth = validateNullVal(conf.headWidth, 15),
                headHeight = validateNullVal(conf.headHeight, 15),
                toggle = open ? 0 : 1;
            bgColor = (bgColor instanceof Array) ? bgColor[colorIndex % bgColor.length] : bgColor;
            
            //Drag behaviour
            var drag = d3_drag()
                .on("drag", function(d, i) {
                    if (d3.event.defaultPrevented) return;
                    // d3.event.sourceEvent.stopPropagation();
                    var parentEle = d3_select(this.parentNode);
                    var x = parseFloat(parentEle.style("left")) + d3.event.x,
                        y = parseFloat(parentEle.style("top")) + d3.event.y,
                        w = mathMax(((toggle % 2 != 0) ? 0 : bodyWidth), headWidth),
                        h = ((toggle % 2 != 0) ? 0 : bodyHeight) + headHeight;
                    x = (x > (chartWidth - w)) ?
                        (chartWidth - w) :
                        ((x < 0) ? 0 : x);
                    y = (y > (chartHeight - h)) ?
                        (chartHeight - h) :
                        ((y < 0) ? 0 : y);
                    coordinate[0] = x, coordinate[1] = y;
                    var leftVal = x + "px",
                        topVal = y + "px";
                    
                    parentEle
                        .style({
                            "left": leftVal,
                            "top": topVal
                        });
                    if (basedOn != "plot") {
                        var iden = parentEle.attr("id");
                        var index = getAnnotationIndex(noteConf, iden, basedOn);
                        if (index != -1) {
                            noteConf.chartValues[index].x = xInPercent ? ((x / chartWidth * 100) + "%") : x;
                            noteConf.chartValues[index].y = yInPercent ? ((y / chartHeight * 100) + "%") : y;
                        }
                    }
                });
            
            container
                .attr("class", "group")
                .style({
                    "width": 0,
                    "height": 0,
                    "z-index": 2
                });
            
            // Draw text area
            var textarea = appendEle(notesWrap, "textarea", [1]);
            textarea
                .style({
                    "width": bodyWidth + "px",
                    "height": bodyHeight + "px",
                    "position": "absolute",
                    "border-color": "transparent",
                    "border-radius": (conf.bodyBorderRadius || 0) + "px",
                    "background-color": "transparent",
                    "overflow": "hidden",
                    "display": "none",
                    "resize": "none", //Need to implement textarea resize
                    "z-index": 2,
                    "outline": "none"
                })
                .on("blur", function(d, i) {
                    var baseEle = textarea.attr("eleID");
                    textarea.style("display", "none");
                    if (baseEle != null) {
                        var parentEle = d3_select("#" + baseEle);
                        var bodyEle = parentEle.selectAll(".body");
                        
                        bodyEle.style("color", null);
                        
                        parentEle.style("z-index", 2);
                        
                    }
                })
                .on("input", function() {
                    var curEle = d3_select(this);
                    if (curEle.style("display") === "none") {
                        return;
                    }
                    var parentEle = d3_select("#" + curEle.attr("eleID"));
                    var noteEle = parentEle.selectAll(".body");
                    var iden = parentEle.attr("id"),
                        txt = textarea[0][0].value,
                        datum = parentEle.datum();
                    var basedOn = datum.basedOn || "chart",
                        annotationData = datum.data;
                    noteEle.text(txt);
                    var dt = (basedOn == "plot") ? annotationData : iden;
                    var index = getAnnotationIndex(noteConf, dt, basedOn);
                    if (index == -1) {
                        saveAnnotation(noteConf, dt, txt, xy, basedOn);
                    } else {
                        noteConf[basedOn + "Values"][index].text = txt;
                    }
                })
                .text(text);
            
            // Draw head
            var head = appendEle(container, "div", [1], ".", "class", "head", {
                "background-color": bgColor
            });
            head
                .style({
                    "width": headWidth + "px",
                    "height": headHeight + "px",
                    "border": conf.border,
                    "border-radius": (conf.headBorderRadius || 0) + "px",
                    "z-index": "auto"
                });
            // .call(drag);

            var click = function(d, i) {
                if (d3.event.defaultPrevented) return;
                var close = (toggle % 2 == 0);
                var bodyEle = d3_select(this.nextSibling),
                    parentEle = d3_select(this.parentNode);
                textarea.on("blur")();

                if (!close) {
                    var xy = getCoordinateWithinBound(parseFloat(parentEle.style("left")), parseFloat(parentEle.style("top")), bodyWidth, (headHeight + bodyHeight), chartWidth, chartHeight);
                    parentEle
                        .style({
                            "left": xy[0] + "px",
                            "top": xy[1] + "px"
                        });
                } else {
                    parentEle
                        .transition()
                        .delay(250)
                        .duration(0)
                        .style({
                            "left": coordinate[0] + "px",
                            "top": coordinate[1] + "px"
                        });
                }

                bodyEle
                    .style("color", null)
                    .transition()
                    .ease("linear")
                    .style({
                        "width": (close ? "0px" : (bodyWidth + "px")),
                        "height": (close ? "0px" : (bodyHeight + "px")),
                        "display": (close ? null : "block")
                    });

                bodyEle
                    .transition()
                    .delay(250)
                    .style("display", (close ? "none" : null));

                notesWrap.selectAll(".group").style("z-index", 1);
                parentEle.style("z-index", 2);

                toggle++;
            };
            var mouseHandlers = {
                "click": click
            },
            touchHandlers = {
                "tap": click
            };
            attachevents(head, mouseHandlers, touchHandlers);
            
            //Draw body
            var body = appendEle(container, "div", [1], ".", "class", "body", {
                "background-color": bgColor
            });
            body
                .style({
                    "width": !open ? "0" : bodyWidth + "px",
                    "height": !open ? "0" : bodyHeight + "px",
                    "display": !open ? "none" : null,
                    "border": conf.border,
                    "overflow": "hidden",
                    "box-shadow": conf.shadow,
                    "border-radius": (conf.bodyBorderRadius || 0) + "px",
                    "z-index": "auto"
                })
                .text(text);

                var click = function(d, i) {
                    var curEle = d3_select(this),
                        parentEle = d3_select(this.parentNode);
                    textarea.on("blur")();
                    textarea
                        .style({
                            "display": null,
                            "left": parentEle.style("left"),
                            "top": (parseFloat(parentEle.style("top")) + headHeight) + "px",
                            "color": parentEle.style("color"),
                            "font-size": parentEle.style("font-size"),
                            "font-family": parentEle.style("font-family"),
                            "font-weight": parentEle.style("font-weight"),
                            "font-style": parentEle.style("font-style")
                        })
                        .attr("eleID", parentEle.attr("id"));
                    textarea[0][0].value = curEle.text();
                    textarea[0][0].focus();
                    
                    curEle.style("color", "transparent");
                    
                    notesWrap.selectAll(".group").style("z-index", 1);
                    parentEle.style("z-index", 2);
                    textarea.style("z-index", 3);
                };
                var mouseHandlers = {
                    "click": click
                },
                touchHandlers = {
                    "tap": click
                };
            attachevents(body, mouseHandlers, touchHandlers);
            
        });
    }
    
    annotation.chartObj = function(_) {
        if (!arguments.length) {
            return chartObj;
        }
        chartObj = _;
        return annotation;
    };
    annotation.conf = function(_) {
        if (!arguments.length) {
            return conf;
        }
        conf = _;
        return annotation;
    };
    annotation.coordinate = function(_) {
        if (!arguments.length) {
            return coordinate;
        }
        coordinate = _;
        return annotation;
    };
    return annotation;
};//$Id$
$ZC.annotation.customNote = function() {
    var conf, coordinate, chartObj;
    
    function annotation(selection) {
        selection.each(function(args) {
            d3_select(this)
                .html(invokeFunction(conf.htmlEl, chartObj, args.conf));
        });
    }
    
    annotation.coordinate = function(_) {
        if (!arguments.length) {
            return coordinate;
        }
        coordinate = _;
        return annotation;
    };
    annotation.conf = function(_) {
        if (!arguments.length) {
            return conf;
        }
        conf = _;
        return annotation;
    };
    annotation.chartObj = function(_) {
        if (!arguments.length) {
            return chartObj;
        }
        chartObj = _;
        return annotation;
    };
    return annotation;
};//$Id$
//This is a Semantic Zooming Interface
//The zoom options can be configured in systemconf.chart.zoom.type
//Expected values are "x","y","xy"
//Multi yaxes - zoomY is not implemented
$ZC.events.zoom = function(chartObj, axisrotated, systemconf, dataset) {
    "use strict";
    var mdwn = false,
        startPt, endPt, zmevent = {},
        zmarea,
        svg = chartObj.svg,
        seriesdata = systemconf.seriesdata.chartdata,
        zmConf = systemconf.chart.zoom,
        mindist = 2,
        plotarea = chartObj.plotarea;
    var zmareaConf = zmConf.selectionArea,
        zmbtnConf = zmConf.resetButton;
    var btnBorderConf = zmbtnConf.border,
        btnShadowConf = zmbtnConf.shadow,
        btnLabelConf = zmbtnConf.label;
    var zmtype = zmConf.type,
        showBtnBorder = btnBorderConf.show,
        x = zmbtnConf.x,
        y = zmbtnConf.y;
    var btnRadius = (showBtnBorder ? btnBorderConf.radius : 0),
        filterID = null,
        rectBound;
    if (btnShadowConf.show) {
        filterID = effects.get(svg_filters, "dropShadow",btnShadowConf);
        filterID = filterID ? "url(" + chartObj.defsLocation + "#" + filterID + ")" : null;
    }
    
    var callbacks = zmConf.events || {};
    
    zmevent.zmInit = function() {
        zmarea = appendEle(svg.selectAll(".seriesholder"), "rect", [1], ".", "class", "zmarea");
        zmarea
            .style({
                "fill": zmareaConf.fillColor || "grey",
                "fill-opacity": zmareaConf.fillOpacity,
                "visibility": "hidden"
            });
        
        /*
         * reset button added
         * */
        var zoomBtn = appendEle(chartObj.staticPaneSVG.select(".eventgroup"), "rect", [1], ".", "class", "zmbtn");
        var dashStyle = getDashArray(btnBorderConf.style, btnBorderConf.size);
        
        zoomBtn
            .attr({
                "rx": btnRadius,
                "ry": btnRadius,
                "filter": filterID
            })
            .style({
                "fill": zmbtnConf.fillColor,
                "fill-opacity": zmbtnConf.fillOpacity,
                "stroke": btnBorderConf.color,
                "stroke-width": (showBtnBorder ? btnBorderConf.size : 0),
                "stroke-dasharray": dashStyle,
                "stroke-linecap": getLineCap(btnBorderConf.lineCap, dashStyle),
                "visibility": "hidden",
                "cursor": "pointer"
            });
        
        var handlers = {
            "click": zmevent.reset
        };
        var touchhandlers = {
            "tap": zmevent.reset
        };
        attachevents(zoomBtn, handlers, touchhandlers);
        
        //$$COMMENT$$ - Create a group and append the rect and text to the group and position the group - Just for the maintenance.
        //$$COMMENT$$ - It is also better to add one event tracker rect to the group and listen the reset event. Not sure how many events trigger happen in different devices / browsers.
        
        var zoomBtnText = appendEle(chartObj.staticPaneSVG.select(".eventgroup"), "text", [1], ".", "class", "zmbtn");
        
        zoomBtnText
            .attr("dy", "0.9em")
            .style({
                "visibility": "hidden",
                "pointer-events": "none"
            })
            .text(btnLabelConf.text);
        applyFont(zoomBtnText, [btnLabelConf, systemconf.chart, systemconf.canvas, {
            fontColor: "white",
            fontSize: 11,
            fontFamily: "verdana"
        }, $ZCG]);
        
        var textBound = zoomBtnText.node().getBBox();
        zoomBtn
            .attr({
                "width": (textBound.width + btnLabelConf.marginLeft + btnLabelConf.marginRight),
                "height": (textBound.height + btnLabelConf.marginTop + btnLabelConf.marginBottom)
            });
        rectBound = zoomBtn.node().getBBox();
        x = getVal(x, (plotarea.left + plotarea.width - rectBound.width));
        y = getVal(y, 10);
        zoomBtn
            .attr({
                "x": x,
                "y": y
            });
        zoomBtnText
            .attr({
                "x": (x + btnLabelConf.marginLeft),
                "y": (y + btnLabelConf.marginTop)
            });
    };
    
    zmevent.zoomInitialized = false;
    
    zmevent.zmStart = function(mouse) {
        zmtype = zmConf.type;
        mdwn = true;
        startPt = getCoordinate(mouse);
        var prop = {};
        zmarea.style("visibility", "visible");
        var horiZoom = ((zmtype.indexOf("x") > -1) && !axisrotated) || ((zmtype.indexOf("y") > -1) && axisrotated),
            verZoom = ((zmtype.indexOf("y") > -1) && !axisrotated) || ((zmtype.indexOf("x") > -1) && axisrotated);

        if (horiZoom) {
            prop.x = startPt.x;
        } else {
            prop.width = plotarea.width;
        }
        if (verZoom) {
            prop.y = startPt.y;
        } else {
            prop.height = plotarea.height;
        }
        zmarea.attr(prop);
        
        zmevent.zoomInitialized = true;
        // invoke the callback
        
        invokeFunction(true, callbacks.zoomstart, startPt, {
            "x": zmConf.x,
            "y": zmConf.y
        }, chartObj);
    };
    
    zmevent.zmMove = function(mouse) {
        zmtype = zmConf.type
        if (mdwn) {
            var point = getCoordinate(mouse);
            var prop = {};
            var horiZoom = ((zmtype.indexOf("x") > -1) && !axisrotated) || ((zmtype.indexOf("y") > -1) && axisrotated),
                verZoom = ((zmtype.indexOf("y") > -1) && !axisrotated) || ((zmtype.indexOf("x") > -1) && axisrotated);

            if(isTouchEvent(d3.event)) {
                startPt = getCoordinate(d3_mousePoint(chartObj.eventHandler.trackerElement.node(), 0)),
                point = getCoordinate(d3_mousePoint(chartObj.eventHandler.trackerElement.node(), 1));
            }
            endPt = point;

            if (horiZoom) {
                prop.x = ((point.x < startPt.x) ? point : startPt).x;
                prop.width = mathAbs(point.x - startPt.x); //Reverse area selection (Right -> Left) also possible by Math.abs
            }
            if (verZoom) {
                prop.y = ((point.y < startPt.y) ? point : startPt).y;
                prop.height = mathAbs(point.y - startPt.y); //Reverse area selection (Bottom -> Top) also possible by Math.abs
            }
            zmarea.attr(prop);
        }
        invokeFunction(true, callbacks.zoom, point, {
            "x": zmConf.x,
            "y": zmConf.y
        }, chartObj);
    };
    
    zmevent.zmEnd = function(mouse) {
        if (!zmevent.zoomInitialized) {
            return false
        }

        if(!isTouchEvent(d3.event)) {
            endPt = getCoordinate(mouse);
        }

        zmarea
            .attr({
                "height": 0,
                "width": 0
            })
            .style("visibility", "hidden");
        mdwn = false;
        zmevent.zoomInitialized = false;
        return {
            "startPt": startPt,
            "endPt": endPt
        };
    };
    
    zmevent.zoomed = function(zmdata, seriesidx, xdomain, ydomain) {
        zmtype = zmConf.type;
        var rangeDefined = (seriesidx != null), //chartObj.zoomX, chartObj.zoomY, chartObj.zoomXY will also this function
            xtype = (axisrotated ? "y" : "x"),
            ytype = (axisrotated ? "x" : "y");
        var zoomedX = ((zmtype.indexOf("x") > -1) && (rangeDefined || mathAbs(zmdata.startPt[xtype] - zmdata.endPt[xtype]) > mindist)),
            zoomedY = ((zmtype.indexOf("y") > -1) && (rangeDefined || mathAbs(zmdata.startPt[ytype] - zmdata.endPt[ytype]) > mindist));
        
        var isZoomed = ((zmtype.indexOf("x") > -1) && (rangeDefined ? (xdomain[0] != xdomain[1]) : (zmdata.startPt[xtype] != zmdata.endPt[xtype]))) || ((zmtype.indexOf("y") > -1) && (rangeDefined ? (ydomain[0] != ydomain[1]) : (zmdata.startPt[ytype] != zmdata.endPt[ytype])));
        if (!isZoomed) { //If zoom is started but not moved, dont process zoom operation
            return;
        }
        stateChangeListener(chartObj, systemconf.chart.axes.events, null, "init");
        if (zoomedX) {
            var datatype = chartObj.dataset.getDataType("x");
            if (!rangeDefined) {
                var xscale = chartObj.axes.x.scale,
                    axisReversed = systemconf.chart.axes.xaxis.reversed;
                var x1 = $ZC.scale.invert(datatype, zmdata.startPt, xscale, axisrotated, "x", axisReversed),
                    x2 = $ZC.scale.invert(datatype, zmdata.endPt, xscale, axisrotated, "x", axisReversed);
                if (x1 > x2) {
                    var temp = x1;
                    x1 = x2;
                    x2 = temp;
                }
                if (datatype == ORDINAL_DATATYPE) {
                    xdomain = xscale.domain().slice(x1, x2 + 1, 0);
                } else {
                    xdomain = [x1, x2];
                }
            }
            updateZoom("x", (rangeDefined ? seriesidx : 0), xdomain, datatype);
        }
        if (zoomedY) {
            var i = (rangeDefined ? seriesidx : 0),
                len = (rangeDefined ? seriesidx + 1 : chartObj.axes.y.groups.length);
            for (; i < len; i++) {
                var datatype = chartObj.dataset.getDataType("y", i);
                if (!rangeDefined) {
                    var yscale = chartObj.axes.y.groups[i].scale,
                        axisReversed = systemconf.chart.axes.yaxis[i].reversed;
                    var y1 = $ZC.scale.invert(datatype, zmdata.startPt, yscale, axisrotated, "y", axisReversed),
                        y2 = $ZC.scale.invert(datatype, zmdata.endPt, yscale, axisrotated, "y", axisReversed);
                    if (y1 > y2) {
                        y1 = y1 + y2 - (y2 = y1);
                    }
                    if (datatype == ORDINAL_DATATYPE) {
                        ydomain = yscale.domain().slice(y1, y2 + 1, 0);
                    } else {
                        ydomain = [y1, y2];
                    }
                }
                updateZoom("y", i, ydomain, datatype);
            }
        }
        stateChangeListener(chartObj, systemconf.chart.axes.events, null, "onreload");
        
        chartObj.updatePlotareaProp(); //Test_548.json
        chartObj.plot.renderer.draw(true);
        chartObj.eventHandler.updateParams(chartObj); //Need to update the event params. Becoz axes.eventscale is a new scale now
        
        if (!zmevent.clipMarker) {
            //On zooming, update the plot area clip path once (using clipMarker boolean) which doesn't consider the marker size
            chartObj.drawPlotareaClippath();
            zmevent.clipMarker = true;
        }
        
        chartObj.drawThreshold(true);
        chartObj.staticPaneSVG.selectAll(".zmbtn").style("visibility", "visible");
        
        // call the zoom end callback here
        invokeFunction(true, callbacks.zoomend, endPt, {
            "x": zmConf.x,
            "y": zmConf.y
        }, chartObj);
    };
    
    zmevent.reset = function() {
        delete zmConf.x;
        delete zmConf.y;
        
        stateChangeListener(chartObj, systemconf.chart.axes.events, null, "init");
        zmtype = zmConf.type
        if (zmtype.indexOf("x") > -1) {
            systemconf.chart.axes.xaxis.disableBaseValue = false;
            chartObj.updateScale(seriesdata[0], "x", null);
            
        }
        if (zmtype.indexOf("y") > -1) {
            for (var i = 0; i < chartObj.axes.y.groups.length; i++) {
                systemconf.chart.axes.yaxis.disableBaseValue = false;
                chartObj.updateScale(seriesdata[i], "y", null);
            }
        }
        stateChangeListener(chartObj, systemconf.chart.axes.events, null, "onreload");
        
        //Reset the plot area clip path as soon as chart rendered, so that the marker size will be considered
        chartObj.updatePlotareaProp(); //Test_548.json
        chartObj.plot.renderer.draw(true);
        chartObj.eventHandler.updateParams(chartObj); //Need to update the event params. Becoz axes.eventscale is a new scale now
        chartObj.drawThreshold(true);
        var rendered = setInterval(function() {
            if (chartObj.chartRendered) {
                chartObj.drawPlotareaClippath();
                zmevent.clipMarker = false;
                clearInterval(rendered);
            }
        }, 10);
        chartObj.staticPaneSVG.selectAll(".zmbtn").style("visibility", "hidden");
        invokeFunction(callbacks.reset, chartObj);
    };
    
    function updateZoom(type, idx, domain, datatype) {
        /*
         * disableBaseValue is for not to take the base-
         * value while the server generation plot image.
         */
        systemconf.chart.axes[type + "axis"].disableBaseValue = true;
        var z = zmConf[type] = {};
        if (datatype == ORDINAL_DATATYPE) {
            z.categories = domain;
        } else {
            z.minRange = domain[0];
            z.maxRange = domain[1];
        }
        chartObj.updateScale(seriesdata[idx], type, domain); //For multi Yaxis, dont update the scale if the axis is disabled
    }
    
    function getVal(val, defaultVal) {
        val = invokeFunction(val, chartObj, rectBound);
        val = (val != null) ? val : defaultVal;
        return val;
    }
    
    function getCoordinate(mouse) {
        return {
            x: mathMin(mathMax(mouse[0] - plotarea.left, 0), plotarea.width), //range should be within plotarea dimension ISSUE:ZC429
            y: mathMin(mathMax(mouse[1] - plotarea.top, 0), plotarea.height)
        };
    }
    
    return zmevent;
};

function d3_mousePoint(container, i) {
    var e = d3_eventSource();
    if (e.changedTouches) {
        e = e.touches[i];
    }
    var svg = container.ownerSVGElement || container;
    if (svg.createSVGPoint) {
        var point = svg.createSVGPoint();
        point.x = e.clientX, point.y = e.clientY;
        point = point.matrixTransform(container.getScreenCTM().inverse());
        var mouse = [point.x, point.y];
        if (isTouchEvent(d3.event) && !$Browser.ANDROID && $Browser.uiwebview) { //d3.mouse(node) considers pageXOffset and pageYOffset in android devices
            mouse[0] += window.pageXOffset;
            mouse[1] += window.pageYOffset;
        }
        return mouse;
    }
    var rect = container.getBoundingClientRect();
    return [e.clientX - rect.left - container.clientLeft, e.clientY - rect.top - container.clientTop];
}

function d3_eventSource() {
    var e = d3.event,
        s;
    while (s = e.sourceEvent) {
        e = s;
    }
    return e;
}

function isTouchEvent(event) {
    return event.touches;
}
/* SCROLL in MOBILE need to implement
 SCROLL for type y need to implement
 */
var svg_brush = function(chartObj, type, axisorder) {
    
    var scrollData = chartObj.systemConf.chart.scroll;
    var datatype, axisRotated, orient,
        isScrollNeed;
    var defaultOptions = {
        slider: {
            fillColor: "#B3B6B7",
            cursor: "pointer"
        },
        tracker: {
            fillColor: "#ECF0F1",
            cursor: "pointer"
        },
        resizer: {
            fillColor: "none"
        },
        scrollHeight: 10
    };
    
    var defaultScrollLength = 20,
        defaultItemSize = 15,
        overviewContext,
        isOverviewEnabled = (scrollData.overview || {}).enabled,
        isResizeInitiated,

        resizeStartedPosition;
        chartObj.isBrushing = null;
    
    function brush(selection) {
        axisRotated = chartObj.dataObject.getAxisRotated();
        orient = (axisRotated) ? "left" : "bottom";
        var scale = chartObj.axes.x.scrollScale = $ZC.scale.getScale(chartObj, chartObj.dataObject, chartObj.plotarea, orient, 0, chartObj.dataset, type, null, 0)
        
        var categoryPosInScreen = getCategoryPosScreen(chartObj, chartObj.plotarea);
        var preScrollBarLength = getScrollBarLength(scale, categoryPosInScreen);
        isScrollNeed = Math.abs(preScrollBarLength - chartObj.plotarea[axisRotated ? "height" : "width"]) >= 1;

        if (!isScrollNeed) {
            return;
        }

        brush.component = d3_brush();
        brush.component
            .on("brush", function() {
                chartObj.isBrushing = true;
                brush.scrollNrender();
            })
            .on("brushstart", function(event) {
                chartObj.isBrushing = true;
                isResizeInitiated = false;
            })
            .on("brushend", function() {
                chartObj.isBrushing = false;
                // brush.updateExtentPosition();
            })
        if (!brush.context) {
            brush.context = appendEle(chartObj.svg, "g", [1], ".", "class", "brush");
        }

        if (axisRotated) {
            chartObj.plotarea.width -= scrollData.height || defaultOptions.scrollHeight;
            brush.context.attr("transform", "translate(" + (chartObj.plotarea.left + chartObj.plotarea.width) + "," + (chartObj.plotarea.top) + ")");
            
        } else {
            chartObj.plotarea.bottom += scrollData.height || defaultOptions.scrollHeight;
            chartObj.plotarea.height -= scrollData.height || defaultOptions.scrollHeight;
            brush.context.attr("transform", "translate(" + chartObj.plotarea.left + "," + (chartObj.plotarea.top + chartObj.plotarea.height) + ")");
        }
        
    }
    
    brush.initialize = function(plotarea) {
        if (!isScrollNeed) {
            return;
        }

        //scroll scale
        datatype = chartObj.dataset.getDataType(type);
        orient = (axisRotated) ? "left" : "bottom";
        setScrollScale(chartObj, plotarea, type);
        brush.categoryPosInScreen = getCategoryPosScreen(chartObj, plotarea);
        //set Initialize Extent
        
        brush.extent = []; //need array initialize optimize
        brush.context.call(brush.component);
        
        var initialExtent = (axisRotated) ?
            [{
                "y": plotarea.height,
                "x": 0
            }, {
                "y": brush.categoryPosInScreen,
                "x": 0
            }] :
            [{
                "x": 0,
                "y": 0
            }, {
                "x": brush.categoryPosInScreen,
                "y": 0
            }];
        brush.setExtent(initialExtent);
        
        // Renders the wholeview
        if (isOverviewEnabled) {
            renderOverviewContext();
        }
        
        //Navigator style
        styleBrushNavigator();
    };
    
    brush.scrollNrender = function() {
        brush.updateExtentPosition();
        chartObj.updateScale(chartObj.seriesdata[0], type, brush.extent);
        chartObj.drawThreshold(true);
        chartObj.drawPlotareaClippath();
        chartObj.plot.renderer.draw(true);
        chartObj.eventHandler.updateParams(chartObj);
    };
    brush.updateExtentPosition = function() {
        var extent = brush.component.extent();
        var mousePos = (datatype == ORDINAL_DATATYPE) ?
            (axisRotated) ? [extent[1], extent[0]] : [extent[0], extent[1]] //need to change x,y
            : [chartObj.axes.x.scrollScale(extent[0]), chartObj.axes.x.scrollScale(extent[1])];
        
        var categoryPosInScreen = brush.categoryPosInScreen,
            clicked = (mousePos[0] === mousePos[1]);
        isResizeInitiated = isResizeInitiated || clicked;
        var scrollBarLength  = brush.scrollBarLength || getScrollBarLength(chartObj.axes.x.scrollScale,categoryPosInScreen);
        if (isResizeInitiated) {
            if (!clicked) {
                var scrollBarOffset = scrollBarLength * (axisRotated ? -3/2 : 1/2);
                mousePos[0] += mousePos[1] - resizeStartedPosition[1] + scrollBarOffset;
                mousePos[1] = mousePos[0] + scrollBarLength;
            }

            mousePos[0] -= (scrollBarLength / 2);
            mousePos[1] -= (scrollBarLength / 2);

            // user clicked on the brush background, width will be zero, offset x by half width
            if (axisRotated) {
                mousePos[1] = (mousePos[1] < 0) ? 0 : mousePos[1];
                mousePos[0] = mousePos[1] + scrollBarLength;
                
                mousePos[0] = (mousePos[0] > chartObj.plotarea.height) ? chartObj.plotarea.height : mousePos[0];
                mousePos[1] = mousePos[0] - scrollBarLength;
            } else {
                mousePos[0] = (mousePos[1] > chartObj.plotarea.width) ? mousePos[0] - (mousePos[1] - chartObj.plotarea.width) : ((mousePos[0] < 0) ? 0 : mousePos[0]);
                mousePos[1] = mousePos[0] + scrollBarLength;
                
                mousePos[0] = ((mousePos[0] + scrollBarLength) > chartObj.plotarea.width) ? mousePos[0] - (mousePos[1] - chartObj.plotarea.width) : mousePos[0];
                mousePos[1] = mousePos[0] + scrollBarLength;
            }

            if (clicked) {
                resizeStartedPosition = mousePos;
            }
        }
        
        var newExtent = (axisRotated) ?
            [{
                "y": mousePos[0],
                "x": 0
            }, {
                "y": mousePos[1],
                "x": 0
            }] :
            [{
                "x": mousePos[0],
                "y": 0
            }, {
                "x": mousePos[1],
                "y": 0
            }];
        brush.setExtent(newExtent); //need to change x,y
        brush.scrollBarLength = mathAbs(mousePos[1] - mousePos[0]); // Save the resized scrollbar length
        
        // If the brush is clicked, redraw the brush
        if (isResizeInitiated) {
            brush.context.call(brush.component);
            removeResizer();
        }
    };
    
    brush.setExtent = function(mousePos) {
        var customExtent = getCustomExtent(mousePos);
        brush.extent = customExtent;
        
        var curMousePos = (axisRotated) ? [mousePos[0].y, mousePos[1].y] : [mousePos[0].x, mousePos[1].x]
        if (datatype == ORDINAL_DATATYPE) {
            brush.component.extent(curMousePos); //need to change x,y
            
        } else {
            brush.component.extent(customExtent);
        }
    };
    
    return brush;
    
    function getCustomExtent(mousePos) {
        var customExtent;
        var x1 = $ZC.scale.invert(datatype, mousePos[0], chartObj.axes.x.scrollScale, axisRotated, type);
        var x2 = $ZC.scale.invert(datatype, mousePos[1], chartObj.axes.x.scrollScale, axisRotated, type);
        if (datatype == ORDINAL_DATATYPE) {
            customExtent = chartObj.axes.x.scrollScale.domain().slice(x1, x2 + 1, 0);
        } else {
            customExtent = [x1, x2];
        }
        return customExtent;
    }
    
    function styleBrushNavigator() {
        // Translate the brush context
        var translate = d3_transform(brush.context.attr("transform")).translate,
            tx, ty;
        if (axisRotated) {
            tx = chartObj.plotarea.left + chartObj.plotarea.width;
            ty = chartObj.plotarea.top;
        } else {
            tx = chartObj.plotarea.left;
            ty = translate[1];
        }
        brush.context.attr("transform", "translate(" + tx + "," + ty + ")");
        
        if (isOverviewEnabled) {
            overviewContext
                .style({
                    "left": tx + "px",
                    "top": ty + "px"
                });
        }
        
        var scrollDIM = {}; // height | width for extent and background
        scrollDIM[(axisRotated) ? "width" : "height"] = scrollData.height || defaultOptions.scrollHeight;
        
        applyStyle(brush.context.selectAll("rect.extent"), scrollData.slider, defaultOptions.slider, scrollDIM);
        applyStyle(brush.context.selectAll("rect.background"), scrollData.tracker, defaultOptions.tracker, scrollDIM);
        applyStyle(brush.context.selectAll(".resize").selectAll("rect"), scrollData.resizer, defaultOptions.resizer, scrollDIM);
        
        removeResizer();
    }
    
    function applyStyle(ele, conf, defaultConf, scrollDIM) {
        conf = conf || {};
        ele
            .style({
                "visibility": "visible",
                "cursor": conf.cursor || defaultConf.cursor,
                "fill": conf.fillColor || defaultConf.fillColor,
                "opacity": conf.fillOpacity,
                "stroke-width": conf.strokeWidth,
                "stroke": conf.strokeColor
            })
            .attr({
                "rx": conf.radius,
                "ry": conf.radius
            })
            .attr(scrollDIM);
    }
    
    function removeResizer() {
        var resizerData = scrollData.resizer || {};
        if (!resizerData.enabled) {
            brush.context.selectAll(".resize").remove();
        }
    }
    
    function setScrollScale(chartObj, plotarea, type) {
        
        var scale = chartObj.axes.x.scrollScale = $ZC.scale.getScale(chartObj, chartObj.dataObject, plotarea, orient, 0, chartObj.dataset, type, null, 0)
        if (type == "x" && !axisRotated) {
            brush.component.x(scale);
        } else {
            brush.component.y(scale);
        }
    }
    
    function getCategoryPosByCount(plotarea, padding, outerPadding, numVisibleCategories){
        var scrollScale = chartObj.axes.x.scrollScale,
            baseValue = (axisRotated) ? plotarea.height : plotarea.width,
            xCat = chartObj.dataObject.getCategories("x"),
            xCat = (xCat && xCat.length) ? xCat : chartObj.dataObject.findXCategories(),
            actNumCategories = xCat.length;
            numVisibleCategories = (numVisibleCategories > actNumCategories) ? actNumCategories : numVisibleCategories;
        var categoryPosValue = (scrollScale) ? getActualScreenValue(scrollScale, numVisibleCategories-1, xCat[numVisibleCategories-1]) : mathFloor(((baseValue - outerPadding) / actNumCategories)*numVisibleCategories);
        return categoryPosValue;
    }
    function getCategoryPosByThickness(plotarea, padding, outerPadding,thickness){
        var scrollScale = chartObj.axes.x.scrollScale,
            baseValue = (axisRotated) ? plotarea.height : plotarea.width;
        var step = getCategoryStep(thickness, padding);
        var numVisibleCategories = getVisibleNumCategories(chartObj, plotarea, outerPadding, step);

        if(scrollScale && scrollScale.rangeExtent){
            var range = scrollScale.rangeExtent();
            outerPadding = getOuterPaddingInPixel(scrollScale.rangeExtent(), numVisibleCategories, padding, outerPadding, step);
        }else{
            outerPadding = 2 * (step * outerPadding);
        }
        var numVisibleCategories = getVisibleNumCategories(chartObj, plotarea, outerPadding, step);
        var categoryPosValue = getCategoryPosByCount(plotarea,padding,outerPadding,numVisibleCategories);
        return categoryPosValue;
    }

    function getNumScreens(chartObj, numVisibleCategories) {
        var xCat = chartObj.dataObject.getCategories("x");
        xCat = (xCat && xCat.length) ? xCat : chartObj.dataObject.findXCategories();
        var actNumCategories = xCat.length;
        var numOfScreen = (actNumCategories > numVisibleCategories) ? actNumCategories / numVisibleCategories : 1;
        return numOfScreen;
    }
    
    function getCategoryPosScreen(chartObj, plotarea) {
        var baseValue = (axisRotated) ? plotarea.height : plotarea.width;
        var numVisibleCategories = scrollData.visibleCategories;
        var chartType = chartObj.chartTypes[0].name;
        var padding = (chartType == "gantt" || chartType == "bullet" || chartType == "bar") ? chartObj.systemConf.chart.plot.plotoptions[chartType].padding || 0.2 : 0.2;
        var outerPadding = chartObj.systemConf.chart.plot.plotoptions[chartType].outerPadding || 0.02;
        var categoryPosValue;

        if(numVisibleCategories){
            categoryPosValue = getCategoryPosByCount(plotarea, padding, outerPadding, numVisibleCategories)
        }else{
            categoryPosValue = getCategoryPosByThickness(plotarea,padding,outerPadding,scrollData.categoryThickness||defaultItemSize)
        }
        // categoryPos = getScrollBarLength(chartObj.axes.xaxis.scrollScale,categoryPos)
        return categoryPosValue;
    }
    function getActualScreenValue(scrollScale,index,value){
        if(scrollScale.rangeExtent){
            return scrollScale.range()[index];
        }else{
            return scrollScale(value);
        }
    }
    function getScrollBarLength(scrollScale, categoryPos){
        if(scrollScale.rangeExtent){
            if(axisRotated){
                return scrollScale.rangeExtent()[1]-categoryPos;
            }else{
                return categoryPos+scrollScale.rangeBand();
            }
        }else{
            if(axisRotated){
                return scrollScale.range()[0]-categoryPos;
            }else{
                return categoryPos;
            }
            
        }
    }
    
    function getVisibleNumCategories(chartObj, plotarea, outerPadding, step) {
        return (axisRotated) ? mathFloor((plotarea.height - outerPadding) / step) : mathFloor((plotarea.width - outerPadding) / step);
    }
    
    function getOuterPadding(datatype, actScale, scrollScale, plotarea, numVisibleCategories) {
        var actDomain = actScale.domain()[0],
            scrollDomain = scrollScale.domain()[0],
            outerPadding;
        if (datatype == TIME_DATATYPE) {
            outerPadding = 2 * actScale(scrollDomain.getTime());
        } else if (datatype == NUMERIC_DATATYPE) {
            outerPadding = 2 * actScale(scrollDomain);
        } else if (datatype == ORDINAL_DATATYPE) {
            // $ZC.scale.getOuterPadding(actScale.rangeExtent(), actScale.domain().length, padding, outerPadding)
            // var rangeBand = actScale.rangeBand();
            outerPadding = actScale.outerPadding;
        }
        return outerPadding;
    }
    
    function renderOverviewContext() {
        var plotarea = chartObj.plotarea,
            userdata = chartObj.userdata;
        
        // scrollData.tracker = {"fillColor" : "transparent"};
        userdata.chart.scroll.enabled = false;
        userdata.chart.axes.xaxis.show = false;
        userdata.chart.axes.yaxis[0].show = false;
        userdata.canvas.title.show = false;
        userdata.canvas.subtitle.show = false;
        (userdata.chart.plot.renderer) ?
            (userdata.chart.plot.renderer.mode = "canvas") :
            (userdata.chart.plot) ? userdata.chart.plot.renderer = {
                    mode: "canvas"
                } : userdata.chart.plot = {
                    renderer: {
                        mode: "canvas"
                    }
                };
        userdata.chart.marginTop = 0;
        userdata.chart.marginBottom = 0;
        userdata.chart.marginLeft = 0;
        userdata.chart.marginRight = 0;
        userdata.canvas.intelligence = {};
        (userdata.credits) ? userdata.credits.show = false : null;
        (userdata.chart.plot.datalabels) ? userdata.chart.plot.datalabels.show = false : null;
        userdata.legend.enabled = false;
        
        overviewContext = chartObj.container.selectAll("div.zcoverview");
        overviewContext
            .style({
                "position": "absolute",
                "width": plotarea.width + "px",
                "height": (+scrollData.height) + "px",
                "pointer-events": "none",
                "box-sizing": "border-box"
            });
        $ZC.charts(overviewContext.node(), userdata);
    }
};//$Id$
function addDefaultScroll(chartObj, state) {
    if (!chartObj.isAxisCategory || (!chartObj.systemConf.chart.width && !chartObj.systemConf.chart.height)) {
        return;
    }
    
    var axisrotated = chartObj.dataObject.getAxisRotated(),
        plotarea = chartObj.plotarea,
        attrObj;
    
    var XSIZE = (getPlotSize(chartObj, "width") - plotarea.width),
        YSIZE = (getPlotSize(chartObj, "height") - plotarea.height);
    
    // Initial clip-path
    var axis = chartObj.container.selectAll(".x-axis-0"),
        scroll = chartObj.container.selectAll(".d3container").selectAll(".zohocharts_scroll");
    var scrollbar_size = +scroll.attr("scrollbarSize");

    var properties = {
        name: "rect_axis",
        id: chartObj.id
    },
    args = {
        chartObj: chartObj
    };
    if (axisrotated) {
        chartObj.scrolledY = chartObj.scrolledY || 0;
        properties.x = -plotarea.left;
        properties.y = 0;
        properties.width = plotarea.width + plotarea.left;
        properties.height = plotarea.height;
    } else {
        chartObj.scrolledX = chartObj.scrolledX || 0;
        properties.x = 0;
        properties.y = 0;
        properties.width = plotarea.width;
        properties.height = chartObj.canvasarea.height;
    }
    updateAxisClipPath(chartObj);
    
    // Scroll div
    scroll
        .style({
            "left": plotarea.left + "px",
            "top": plotarea.top + "px",
            "height": (plotarea.height + (axisrotated ? 0 : scrollbar_size)) + "px",
            "width": (plotarea.width + (axisrotated ? scrollbar_size : 0)) + "px"
        })
        .on("scroll", function(e) {
            var src = d3.event.srcElement || d3.event.target;
            var scrolled = (!axisrotated) ? src.scrollLeft : src.scrollTop;
            chartObj.scrolledY = (!axisrotated) ? 0 : scrolled;
            chartObj.scrolledX = (!axisrotated) ? scrolled : 0;
            chartObj.eventHandler.mouseOut();
            scrollGroups(scrolled);

        });
    
    scroll
        .style((axisrotated) ? {
                "overflow-y": "auto",
                "overflow-x": "hidden"
            } : {
                "overflow-x": "auto",
                "overflow-y": "hidden"
            });
    
    // Scroll child
    scroll.selectAll(".child")
        .style({
            "height": (plotarea.height + (!axisrotated ? 0 : YSIZE)) + "px",
            "width": (plotarea.width + (!axisrotated ? XSIZE : 0)) + "px",
            "pointer-events": "none",
            "margin": 0,
            "padding": 0,
            "background-color": "transparent"
        });
    
    // Reset scroll position
    if (state !== "addorremoveseries") {
        var scroll_node = scroll.node();
        scroll_node.scrollLeft = 0
        scroll_node.scrollTop = 0
    }
    
    // Event listners
    var eventHandler = chartObj.eventHandler,
        eventAttacherOptions = {
            target: "plot",
            chartObj: chartObj
        };
    var clickHandlers = {
            "click": eventHandler.click,
            "dblclick": eventHandler.doubleclick,
            "contextmenu": eventHandler.contextMenu
        },
        moveHandlers = {
            "mousemove": eventHandler.mouseMove,
            "mouseout": eventHandler.mouseOut
        };
    attachevents(scroll, clickHandlers, null, "chart");
    attachevents(scroll, moveHandlers, null, "chartmove");

    var touchHandlers = {
        "tap": eventHandler.click,
        "dbltap": eventHandler.doubleclick,
        "singletouchmove": eventHandler.mouseMove,
        "touchend": eventHandler.mouseOut
    };

    attachevents(scroll, {}, touchHandlers, eventAttacherOptions);
    
    var scrolled = (!axisrotated) ? chartObj.scrolledX : chartObj.scrolledY;
    if (scrolled && (state === "addorremoveseries")) {
        scrollGroups(scrolled);
    }
    
    function scrollGroups(scrolled) {
        var seriesholder = chartObj.container.selectAll(".seriesholder");

        var clipPathID = seriesholder.attr("clip-path").replace(/url\(|\)|\"/gi, "");
        
        var seriesTrans = d3_transform(seriesholder.attr("transform")).translate;
        var transX = (!axisrotated) ? (plotarea.left - scrolled) : seriesTrans[0],
            transY = (!axisrotated) ? seriesTrans[1] : (plotarea.top - scrolled);
        seriesholder
            .attr("transform", "translate(" + transX + "," + transY + ")");
        chartObj.container.selectAll(".labelholder")
            .attr("transform", "translate(" + transX + "," + transY + ")");
        chartObj.container.selectAll(".eventgroup")
            .attr("transform", "translate(" + (axisrotated ? 0 : -scrolled) + "," + (axisrotated ? -scrolled : 0) + ")");
        chartObj.container.selectAll("rect.eventhandler")
            .attr("transform", "translate(" + (axisrotated ? 0 : scrolled) + "," + (axisrotated ? scrolled : 0) + ")");

        ($Browser.SAFARI ? chartObj.svg : $ZCG.patternSVG).selectAll(clipPathID)
            .selectAll("rect")
            .attr((axisrotated) ? {
                    "y": scrolled
                } : {
                    "x": scrolled
                });
        var attrObj = (axisrotated) ? {
                "y": (plotarea.top - scrolled),
                "height": (plotarea.height + scrolled)
            } : {
                "x": (plotarea.left - scrolled),
                "width": (plotarea.width + scrolled)
            };
        chartObj.eventHandler.trackerElement
            .attr(attrObj)
            .attr("clip-path", "url(" + clipPathID + ")");
        updateAxisClipPath(chartObj);


        var properties = {
                name: "rect_highlight",
                id: chartObj.id
            },
            args = {
                chartObj: chartObj
            };
        if (axisrotated) {
            properties.x = -plotarea.left;
            properties.y = scrolled;
            properties.width = (plotarea.width + plotarea.left);
            properties.height = plotarea.height;
        } else {
            properties.x = scrolled;
            properties.y = plotarea.top;
            properties.width = plotarea.width;
            properties.height = plotarea.height;
        }
        var clipID = effects.get(svg_clips, "rect", properties, args);
        chartObj.container.selectAll("#zcareahighlight")
            .attr("clip-path", "url(#" + clipID + ")");


    }
}
addDefaultScroll.initialize = function(chartObj) {
    if (!chartObj.isAxisCategory || (!chartObj.systemConf.chart.width && !chartObj.systemConf.chart.height)) {
        return;
    }

    if (axisrotated) {
        chartObj.scrolledY = chartObj.scrolledY || 0;
    } else {
        chartObj.scrolledX = chartObj.scrolledX || 0;
    }

    var scroll = appendEle(chartObj.container.selectAll(".d3container"), "div", [1], ".", "class", "zohocharts_scroll");
    scroll
        .style({
            "width": 100 + "px",
            "height": 100 + "px",
            "overflow": "auto",
            "position": "absolute",
            "margin": 0,
            "padding": 0,
            "background-color": "rgba(0,0,0,0)",
            "box-sizing": "content-box",
            "-webkit-tap-highlight-color" : "transparent",
            "-webkit-overflow-scrolling" : "touch"
        });
    
    appendEle(scroll, "div", [1], ".", "class", "child")
        .style({
            "width": 200 + "px",
            "height": 200 + "px"
        });
    
    var axisrotated = chartObj.dataObject.getAxisRotated(),
        conf = chartObj.defaultScroll;
    
    //scrollbar size
    var scroll_node = scroll.node();
    var scrollbar_size = (axisrotated) ?
        scroll_node.offsetWidth - scroll_node.clientWidth :
        scroll_node.offsetHeight - scroll_node.clientHeight;
    scroll.attr("scrollbarSize", scrollbar_size);
    
    if (!conf) {
        conf = chartObj.defaultScroll = {};
        conf.tickmarkSize = +chartObj.systemConf.chart.axes.xaxis.tickmark.size;
        conf.marginRight = +chartObj.systemConf.chart.marginRight;
    }
    if (axisrotated) {
        chartObj.plotarea.bottom += scrollbar_size;
        chartObj.plotarea.width -= scrollbar_size;
    } else {
        chartObj.systemConf.chart.axes.xaxis.tickmark.size = +conf.tickmarkSize + scrollbar_size;
    }
};

function getPlotSize(chartObj, type, plotarea) {
    plotarea = plotarea || chartObj.plotarea;
    var customSize = chartObj.systemConf.chart[type];
    if (customSize == null || isNaN(customSize)) {
        return plotarea[type];
    }
    return mathMax(plotarea[type], +customSize);
}

function updateAxisClipPath(chartObj){
    var axisrotated = chartObj.dataObject.getAxisRotated(),
        plotarea = chartObj.plotarea,
        scrolled = (!axisrotated) ? chartObj.scrolledX : chartObj.scrolledY,
        attrObj;
    if (axisrotated) {
        attrObj = {
            "x": -plotarea.left,
            "y": scrolled,
            "width": (plotarea.width + plotarea.left),
            "height": plotarea.height
        };
    } else {
        var hierachyObj = chartObj.dataObject.hierarchical;
        var axisLen = 0;
        if(hierachyObj){
            for(var i=0; i<chartObj.axes.x.count; i++){
                var axisObj =  getAxisObject(chartObj,"x",i);
                axisLen += axisObj.ticks.preCalcAxisLen;
            }
        }else{
            axisLen = chartObj.axes.x.ticks.preCalcAxisLen
        }

        // var prevTickObj = hierachyObj ? hierachyObj.finalDepth == 1 ?  chartObj.axes.x.ticks.preCalcAxisLen : chartObj.axes.x.levels[hierachyObj.finalDepth-1].ticks.preCalcAxisLen : 0;
        attrObj = {
            "x": scrolled,
            "y": -plotarea.height,
            "width": plotarea.width,
            "height": axisLen + chartObj.plotarea.height
        };
    }

    attrObj.name = "rect_axis";
    attrObj.id = chartObj.id;
    var args = {
        chartObj: chartObj
    };

    var axisClipPathId = effects.get(svg_clips, "rect", attrObj, args);

    var axis = chartObj.container.selectAll("g.x-axis").selectAll(function(){return this.childNodes});
    axis.filter(function(){
        var comp = d3.select(this);
        var axisTrans = d3_transform(comp.attr("transform")).translate;
        var transX = (!axisrotated) ? (plotarea.left - scrolled) : axisTrans[0],
            transY = (!axisrotated) ? axisTrans[1] : (plotarea.top - scrolled);
        comp
            .attr({
                "transform": "translate(" + transX + "," + transY + ")",
                "clip-path" : "url(#"+axisClipPathId+")"
            });
        comp.selectAll("g.axisgroup").attr("clip-path","");
    })
    return axisClipPathId;
}//$Id$
var brushComponent;
(function(){
    brushComponent = function(chartObj, options) {
        this.chartObj = chartObj;
        this.options = options;
        this.isResizeInitiated = null;

        var brushScale = options.scale,
            orient = options.orient,
            dimension = options.dimension,

            isHorizontal = orient === "top" || orient === "bottom",
            rectPosition = {},

            component = this.component = d3_brush(),
            previousExtent = options.initialExtent, //if it is out of range????
            container;

        component
            .on("brush", function() {
                var extent =  component.extent();
                if (extent[0] === extent[1]) { // If user clicks
                    var bandWidth = mathAbs(previousExtent[1] - previousExtent[0]),
                        range = brushScale.rangeExtent ? brushScale.rangeExtent() : brushScale.domain();
                    extent = [extent[0] - bandWidth / 2, extent[1] + bandWidth / 2];

                    if (extent[1] > range[1]) {
                        extent[1] = range[1] - (brushScale.rangeExtent ? bandWidth * 0.1 : 0);
                        extent[0] = extent[1] - bandWidth;
                    }
                    if (extent[0] < range[0]) {
                        extent[0] = range[0] + (brushScale.rangeExtent ? bandWidth * 0.1 : 0);
                        extent[1] = extent[0] + bandWidth;
                    }

                    component.extent(extent);
                    container.call(component);
                }
                options.onBrush(component);
                previousExtent = component.extent();
                // Unhighlight the remaining space
            })
            .on("brushstart", function(event) {
                this.isResizeInitiated = false;
            })
            .on("brushend", function(event) {
                options.onEnd(component);
                previousExtent = component.extent();
            });

        if (!this.context) {
            this.context = container = appendEle(options.element || chartObj.svg, "g", options.brushOptions.enabled ? [1] : [], ".", "class", "brush");
        }

        if (isHorizontal) {
            component.x(brushScale);

            rectPosition = {
                y: null,
                height: dimension[1]
            };
        } else {
            component.y(brushScale);

            rectPosition = {
                x: null,
                width: dimension[0]
            };
        }

        component.extent(options.initialExtent);
        container.call(component);

        container.selectAll("rect.background")
            .attr(rectPosition);

        container.selectAll("rect.extent")
            .style({
                "fill":"transparent"
            })
            .attr(rectPosition);

        this.drawSlider();
    };

})();//$Id$
var ZC_brushComponent_getSliderOptions;
(function(){
    brushComponent.prototype.drawSlider = function(){
        var chartObj = this.chartObj,
            options = this.options,
            container = this.context,

            orient = options.orient,
            isHorizontal = orient === "top" || orient === "bottom",
            dimension = options.dimension,

            brushOptions = ZC_brushComponent_getSliderOptions(dimension, options.brushOptions),
            type = brushOptions.type,
            sliderOptions = brushOptions[type],

            rotate = isHorizontal? "" : " rotate(-90)",
            filterID = brushOptions.shadow;

        if (filterID) {
            filterID = getFilterID(filterID, chartObj);
        }

        var element = container.selectAll(".resize");
        element.selectAll("*").remove();

        switch(type) {
            case "lever":
                var r = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, sliderOptions.radius);
                element.append("path")
                    .attr({
                        "d": roundedRect(-sliderOptions.width / 2, -sliderOptions.height / 2, sliderOptions.width, sliderOptions.height, r),
                        "filter": filterID
                    })
                    .style({
                        "fill": sliderOptions.fillColor,
                        "stroke": sliderOptions.strokeColor
                    });

                element.append("path")
                    .attr({
                        "d": "M" + (-sliderOptions.stripePadding / 2) + " " + (-sliderOptions.stripeHeight / 2) + " L" + (-sliderOptions.stripePadding / 2) + " " + (sliderOptions.stripeHeight / 2) + " M" + (sliderOptions.stripePadding / 2) + " " + (-sliderOptions.stripeHeight / 2) + " L" + (sliderOptions.stripePadding / 2) + " " + (sliderOptions.stripeHeight / 2)
                    })
                    .style({
                        "stroke": sliderOptions.stripeColor
                    });
                break;
            case "triangleUp":
                element.append("path")
                    .attr({
                        "d": getSVGsymbol("triangle-down")(sliderOptions.size),
                        "filter": filterID
                    })
                    .style("fill", sliderOptions.fillColor);

                //transparent path to handle resize on the color band
                var r = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, 0);
                element.append("path")
                    .attr("d", roundedRect(-sliderOptions.size / 2, sliderOptions.size / 2, sliderOptions.size, dimension[isHorizontal ? 1 : 0], r))
                    .style("fill", "transparent");
                break;
            case "triangleDown":
                element.append("path")
                    .attr({
                        "d": getSVGsymbol("triangle-up")(sliderOptions.size),
                        "filter": filterID
                    })
                    .style("fill", sliderOptions.fillColor);

                //transparent path to handle resize on the color band
                var r = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, 0);
                element.append("path")
                    .attr("d", roundedRect(-sliderOptions.size / 2, -sliderOptions.size / 2 - dimension[isHorizontal ? 1 : 0], sliderOptions.size, dimension[isHorizontal ? 1 : 0], r))
                    .style("fill", "transparent");
                break;
            case "hollowCircle":
                element.append("path")
                    .attr({
                        "d": getSVGsymbol()(sliderOptions.size),
                        "filter": filterID
                    })
                    .style({
                        "fill": sliderOptions.outerFillColor,
                        "stroke": sliderOptions.outerStrokeColor
                    });
                element.append("path")
                    .attr({
                        "d": getSVGsymbol()(sliderOptions.size * 0.4)
                    })
                    .style({
                        "fill": sliderOptions.innerFillColor,
                        "stroke": sliderOptions.outerStrokeColor
                    });
                break;
            case "circle":
                element.append("path")
                    .attr({
                        "d": getSVGsymbol()(sliderOptions.size),
                        "filter": filterID
                    })
                    .style({
                        "fill": sliderOptions.outerFillColor,
                        "stroke": sliderOptions.outerStrokeColor,
                        "stroke-width": sliderOptions.outerStrokeWidth
                    });
                element.append("path")
                    .attr({
                        "d": getSVGsymbol()(sliderOptions.size * 0.3)
                    })
                    .style({
                        "fill": sliderOptions.innerFillColor,
                        "stroke": sliderOptions.outerStrokeColor
                    });
                break;
            case "balance":
                // var r = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, sliderOptions.radius),
                //     k1 = container.selectAll(".n"),
                //     k2 = container.selectAll(".s");

                // k1.append("path")
                //     .attr({
                //         "d": roundedRect(-sliderOptions.width / 2, -sliderOptions.height / 2, sliderOptions.width, sliderOptions.height, r),
                //         "filter": filterID
                //     })
                //     .style({
                //         "fill": sliderOptions.fillColor,
                //         "stroke": sliderOptions.strokeColor
                //     });

                // k2.append("path")
                //     .attr({
                //         "d": roundedRect(-sliderOptions.width / 2, -sliderOptions.height / 2, sliderOptions.width, sliderOptions.height, r),
                //         "filter": filterID
                //     })
                //     .style({
                //         "fill": sliderOptions.fillColor,
                //         "stroke": sliderOptions.strokeColor
                //     });
                break;
        }

        var position = getSliderPosition(type, dimension, isHorizontal, sliderOptions);
        element.selectAll("path")
            .attr("transform", "translate(" + position[0] + "," + position[1] + ")" + rotate);
    }

    ZC_brushComponent_getSliderOptions = function(dimension, userOptions) {
        var defaultSliderOptions = {
            "type": "lever",
            "shadow": "0 0 2px rgba(0,0,0,0.2)",
            "lever": {
                height: 26,
                width: 9,
                radius: 2,
                stripeHeight: 8,
                stripePadding: 2,
                fillColor: "white",
                strokeColor: "#DADADA",
                stripeColor: "#DADADA"
            },
            "triangleUp": {
                size: 15,
                fillColor: "#4C4C4C"
            },
            "triangleDown": {
                size: 15,
                fillColor: "#4C4C4C"
            },
            "hollowCircle": {
                size: 25,
                outerFillColor: "white",
                outerStrokeColor: "#DADADA",
                innerStrokeColor: "#DADADA"
            },
            "circle": {
                size: 25,
                outerStrokeColor: "white",
                outerStrokeWidth: 2,
                innerFillColor: "white"
            },
            "balance": {
                height: 26,
                width: 9,
                radius: 2,
                stripeHeight: 8,
                fillColor: "white",
                strokeColor: "#DADADA",
                stripeColor: "#DADADA"
            }
        };
        var sliderOptions = userOptions.slider || {};
        sliderOptions = mergeJSON(defaultSliderOptions, sliderOptions, true);
        return sliderOptions;
    }

    function getFilterID(filterID, chartObj) {
        var parsedShadowOptions = filterID.split(" "),
            shadowOptions = {
                dx: parseFloat(parsedShadowOptions[0]),
                dy: parseFloat(parsedShadowOptions[1]),
                color: parsedShadowOptions[3],
                blur: parseFloat(parsedShadowOptions[2]),
                x: "-50%",
                y: "-50%",
                width: "200%",
                height: "200%"
            };
        filterID = effects.get(svg_filters, "dropShadow", shadowOptions);
        filterID = "url(" + chartObj.defsLocation + "#" + filterID + ")";
        return filterID;
    }

    function getSliderPosition(type, dimension, isHorizontal, sliderOptions) {
        var width = dimension[0],
            height = dimension[1],
            x, y;
        switch(type) {
            case "lever":
            case "balance":
                if (isHorizontal) {
                    x = 0;
                    y = height / 2;
                } else {
                    x = width / 2;
                    y = 0;
                }
                break;
            case "triangleUp":
                if (isHorizontal) {
                    x = 0;
                    y = -sliderOptions.size / 2;
                } else {
                    x = -sliderOptions.size / 2;
                    y = 0;
                }
                break;
            case "triangleDown":
                if (isHorizontal) {
                    x = 0;
                    y = height + sliderOptions.size / 2;
                } else {
                    x = width + sliderOptions.size / 2;
                    y = 0;
                }
                break;
            case "hollowCircle":
                if (isHorizontal) {
                    x = 0;
                    y = height / 2;
                } else {
                    x = width / 2;
                    y = 0;
                }
                break;
            case "circle":
                if (isHorizontal) {
                    x = 0;
                    y = height / 2;
                } else {
                    x = width / 2;
                    y = 0;
                }
                break;
        }
        return [x, y];
    }

})();//$Id$
$ZC.labelRenderer = function() {};
$ZC.labelRenderer.drawLabelsFromQueue = function(labelQueue, array, chartObj) {
    chartObj.labelHandler = null;
    if (chartObj.plot.renderer.mode !== "image") {
        var dataObj = chartObj.dataObject;

        if (chartObj.isAxisCategory) {
            var drawStackLabel = function() {
                var groupedByStack = dataObj.groupedByStack;
                groupedByStack.keys().forEach(function(d, i) {
                    var value = groupedByStack.get(d);
                    var si = value.stackLabelIndex;
                    if ((!dataObj.noofBarEnabledSeries && !dataObj.isCombinationalChart) || (si == null)) {
                        return;
                    }

                    var obj = {
                        renderer: chartObj.renderer[si],
                        chartObj: chartObj,
                        args: [{
                            data: [value.stackExtent]
                        }, si, "stackLabels", i],
                        charttype: "bar"
                    };
                    $ZC.labelRenderer.drawLabel(obj);
                });
            };
            drawStackLabel();
        }
        
        labelQueue.forEach(function(d, i) {
            $ZC.labelRenderer.drawLabel(d);
        });
        
        //handle overlap - start
        var currentPlotBound = getPlotBound(chartObj);
        var length = array.length,
            plotbound = {
                x1: currentPlotBound.left,
                y1: currentPlotBound.top,
                x2: currentPlotBound.right,
                y2: currentPlotBound.bottom
            };
        
        var pointTravel = function() {
            var isContinousChart = dataObj.isContinousChart;
            array = isContinousChart ? array.sort(function(a, b) {
                    return d3_ascending(a.x1, b.x1);
                }) : array;
            for (var i = 1; i < length; i++) {
                var bool = 0,
                    overlap = false,
                    testCase = 0,
                    radius = (array[i].pointRadius || 0),
                    x1 = array[i].x1,
                    y1 = array[i].y1,
                    x2 = array[i].x2,
                    y2 = array[i].y2,
                    w = (array[i].x2 - array[i].x1),
                    h = (array[i].y2 - array[i].y1),
                    previousLabels = array.slice(0, i),
                    currentLabel,
                    isHidden,
                    newHookPosition;
                previousLabels = isContinousChart ? previousLabels.reverse() : previousLabels;
                do {
                    //testCase 0 : actual position, testCase 1 : top, testCase 2 : right, testCase 3 : bottom, testCase 4 : left
                    switch (testCase) {
                        case 0:
                            currentLabel = array[i];
                            isHidden = (currentLabel.overlap === "hidden") || dataObj.isBubbleEnabled;
                            break;
                        case 1:
                            currentLabel.y1 = (y1 - h / 2),
                                currentLabel.y2 = (y2 - h / 2);
                            newHookPosition = "bottom";
                            break;
                        case 2:
                            currentLabel.x1 = (((x1 + x2) / 2) + radius),
                                currentLabel.x2 = (((x1 + x2) / 2) + radius + w),
                                currentLabel.y1 = (y2 + 1),
                                currentLabel.y2 = (y2 + h + 1);
                            newHookPosition = "left";
                            break;
                        case 3:
                            currentLabel.x1 = x1,
                                currentLabel.x2 = x2,
                                currentLabel.y1 = (y2 + (2 * (radius + 1))),
                                currentLabel.y2 = (y2 + (2 * (radius + 1)) + h);
                            newHookPosition = "top";
                            break;
                        case 4:
                            currentLabel.x1 = (((x1 + x2) / 2) - radius - w),
                                currentLabel.x2 = (((x1 + x2) / 2) - radius),
                                currentLabel.y1 = (y2 + 1),
                                currentLabel.y2 = (y2 + h + 1);
                            newHookPosition = "right";
                            break;
                    }
                    for (var index = i - 1; index >= 0; index--) {
                        overlap = doOverlap(previousLabels[index], currentLabel);
                        if (overlap) {
                            bool++;
                            break;
                        }
                    }
                } while ((++testCase < 5) && overlap);
                if (bool != 0) {
                    var isWithInPlot = dataObj.isPolarAxisCategory ? true : isLabelWithinBound(currentLabel, plotbound), //For web chart, within plot boundary check is not necessary
                        translateFunc = array[i].translateFunction,
                        id = array[i].id;
                    if (!isWithInPlot || bool == 5 || isHidden) {
                        translateFunc(id, null, null, true);
                        array[i].x1 = array[i].y1 = array[i].x2 = array[i].y2 = 0;
                    } else {
                        var translateX = (currentLabel.x1 - x1),
                            translateY = (currentLabel.y1 - y1);
                        translateFunc(id, translateX, translateY, null, undefined, newHookPosition);
                    }
                }
            }
        };
        
        var stepTravel = function() {
            var axisrotated = dataObj.getAxisRotated();
            array.sort(function(a, b) {
                return axisrotated ? d3_descending(a.y1, b.y1) : d3_ascending(a.x1, b.x1);
            });
            for (var i = 0; i < length; i++) {
                var bool = false,
                    overlappingCount = 0,
                    translateValue = 0,
                    x = array[i].x1,
                    y = array[i].y1,
                    currentLabel = array[i],
                    previousLabels = (array.slice(0, i)).sort(function(a, b) {
                        return axisrotated ? d3_descending(a.x1, b.x1) : d3_ascending(a.y1, b.y1);
                    });
                var isHidden = (currentLabel.overlap === "hidden");
                for (var index = i - 1; index >= 0 && overlappingCount < 2; index--) {
                    var overlap = doOverlap(previousLabels[index], currentLabel);
                    if (overlap) {
                        if (axisrotated) {
                            translateValue = previousLabels[index].x2 - currentLabel.x1;
                            currentLabel.x2 += translateValue;
                            currentLabel.x1 += translateValue;
                        } else {
                            translateValue = previousLabels[index].y1 - currentLabel.y2;
                            currentLabel.y2 += translateValue;
                            currentLabel.y1 += translateValue;
                        }
                        overlappingCount++;
                    }
                    bool = bool || overlap;
                }
                if (bool) {
                    var isWithInPlot = isLabelWithinBound(currentLabel, plotbound),
                        translateFunc = array[i].translateFunction,
                        id = array[i].id;
                    if (!isWithInPlot || overlappingCount > 1 || isHidden) {
                        translateFunc(id, null, null, true);
                        array[i].x1 = array[i].y1 = array[i].x2 = array[i].y2 = 0;
                    } else {
                        var translateX = (currentLabel.x1 - x),
                            translateY = (currentLabel.y1 - y);
                        translateFunc(id, translateX, translateY);
                    }
                }
            }
        };
        
        var slotTravel = function() {
            if (!length) {
                return;
            }
            var rightHalf = [],
                leftHalf = [],
                TOP = array.TOP,
                BOTTOM = array.BOTTOM,
                rightCount = 0,
                leftCount = 0,
                prevLeft, prevRight,
                rightSlot = [],
                leftSlot = [],
                rightCo = 0,
                leftCo = 0,
                totalRightSpaceNeeded = 0,
                totalLeftSpaceNeeded = 0,
                MARGIN = 5,
                slotCount;
            
            array.forEach(function(d) {
                var isLeft = d.isLeft;
                if (isLeft) { // Collect left half labels
                    var added = addToHalf(d, slotCount, TOP, BOTTOM, prevLeft, leftHalf, leftCount, totalLeftSpaceNeeded, true);
                    slotCount = added.totalslot,
                        prevLeft = added.prev,
                        leftCount = added.count,
                        totalLeftSpaceNeeded = added.need;
                } else { // Collect right half labels
                    var added = addToHalf(d, slotCount, TOP, BOTTOM, prevRight, rightHalf, rightCount, totalRightSpaceNeeded);
                    slotCount = added.totalslot,
                        prevRight = added.prev,
                        rightCount = added.count,
                        totalRightSpaceNeeded = added.need;
                }
            });
            
            if (totalRightSpaceNeeded || totalLeftSpaceNeeded) {
                if (array.actualType === "funnel") {
                    rightHalf.reverse();
                }
                rightCo = addToSlot(rightHalf, rightCo, rightSlot, TOP);
                leftHalf.reverse();
                leftCo = addToSlot(leftHalf, leftCo, leftSlot, TOP);
                
                arrange(rightSlot, TOP, slotCount, rightCo);
                arrange(leftSlot, TOP, slotCount, leftCo);
                
                array.forEach(function(d) {
                    chartObj.labelHandler.update(d.id, d.DX, (d.translate || 0), d.hide, undefined, d.overlappingHookPosition);
                })
                
                labelQueue.forEach(function(d) {
                    var index = d.args[1];
                    var queue = chartObj.labelHandler.getQueue(index);
                    if (queue && queue.properties && queue.properties.onOverlap) {
                        queue.properties.onOverlap();
                    }
                });
            } else {
                labelQueue.forEach(function(d, i) {
                    var index = d.args[1];
                    var queue = chartObj.labelHandler.getQueue(index);
                    if (queue && queue.properties && queue.properties.onNonOverlap) {
                        queue.properties.onNonOverlap();
                    }
                });
                array.forEach(function(d) {
                    chartObj.labelHandler.update(d.id, 0, 0, null, d.actualDY);
                });
            }
        };
        
        ((dataObj.isCombinationalChart || dataObj.isContinousChart || dataObj.isPolarAxisCategory) ?
            pointTravel :
            ((dataObj.noofBarEnabledSeries) ?
                stepTravel :
                slotTravel))();
        //handle overlap - end
        
        // remove the temp node.
        chartObj.staticPaneSVG.select(".temp_label").remove();
        
        if (chartObj.labelHandler) {
            var labelHolder = chartObj.staticPaneSVG.selectAll("g.labelholder"),
                mode = chartObj.plot.renderer.mode;
            labelQueue.forEach(function(d) {
                var index = d.args[1],
                    yRangePos = dataObj.isAxisCategory ? d.args[3] : null,
                    innerLabels = /(pieInnerLabels|funnelInnerLabels)/.test(d.charttype);
                var queue = chartObj.labelHandler.getQueue(index, yRangePos, null, innerLabels);
                var datalabelsBoundBox_renderer = datalabelsBoundBox_handler[mode]()
                    .args(queue);
                labelHolder
                    .call(datalabelsBoundBox_renderer, index, innerLabels);
            });
            chartObj.labelHandler.draw();
        }
        
    }
};

$ZC.labelRenderer.drawLabel = function(obj) {
    var chartObj = obj.chartObj,
        renderer = obj.renderer,
        charttype = obj.charttype,
        args = obj.args;
    var labelHolder = chartObj.staticPaneSVG.selectAll("g.labelholder");
    var handler = chartObj.labelHandler;
    
    if (!chartObj.labelHandler) {
        var mode = chartObj.plot.renderer ? chartObj.plot.renderer.mode : "svg";
        handler = chartObj.labelHandler = dataLabel_handler[mode].initialize(chartObj);
        handler.chartType = charttype;
    }
    var labelrenderer = $ZC.labelRenderer[charttype]();
    
    labelrenderer
        .renderer(renderer)
        .args(args);
    labelHolder
        .call(labelrenderer, handler);
    
};

function getPlotBound(chartObj) {
    var l = (-chartObj.scrolledX || 0),
        t = (-chartObj.scrolledY || 0);
    return {
        left: l,
        top: t,
        right: getPlotSize(chartObj, "width"),
        bottom: getPlotSize(chartObj, "height")
    };
}//$Id$
/*
 * PENDING:
 * *Bound box for stack labels
 */
$ZC.labelRenderer.bar = function() {
    var renderer, args;
    var axisrotated, textDirection, rotation,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                rp = renderer.commonRendererProp().params,
                plotoptions = currentdata.plotoptions,
                dataLabels,
                chartObj = rp.chartObj,
                systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                stacked = rp.stacked,
                yscale = rp.yscale,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                labelArray = rp.labelArray,
                isStackedLabels = (args[2] === "stackLabels"),
                isCanvasMode = chartObj.plot.renderer.mode === "canvas";
            axisrotated = rp.axisrotated;
            
            dataLabels = getMergedDatalabelOptions(commonPlotOptions, (isStackedLabels ? null : plotoptions), chartObj, index);

            if (isStackedLabels) {
                dataLabels = dataLabels.stackLabels;
            }
            var showlabel = isStackedLabels ?
                isStacklabelEnabled(dataLabels, chartObj) :
                isDatalabelEnabled(dataLabels, chartObj);
            
            if (currentdata.disabled || !showlabel) {
                return;
            }
            
            var currentPlotBound = getPlotBound(chartObj);
            var textOverlap = dataLabels.textOverlap, //hidden | adjust | clip
                labelPos = dataLabels.labelPos || "top", //bottom | top | middle
                showZeros = dataLabels.showZeros,
                multiColoring = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("multiColoring") && !chartObj.legendarea.show,
                left = currentPlotBound.left,
                top = currentPlotBound.top,
                right = currentPlotBound.right,
                bottom = currentPlotBound.bottom,
                rectBound = chartObj.svg.node().getBoundingClientRect(),
                rectBoundLeft = (rectBound.left + chartObj.plotarea.left),
                rectBoundTop = (rectBound.top + chartObj.plotarea.top),
                dim = (axisrotated ? chartObj.plotarea.width : chartObj.plotarea.height) * 0.75,
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, (args[2] || "datalabels"), yscale.domain()[1], index),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine,
                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),
                yaxisReversed = systemconf.chart.axes.yaxis[yaxiscolumnorder || 0].reversed,
                barW = chartObj.barscale2.rangeBand() || 0,
                fontSize = getFontSizeByHierarchy(dataLabels, chartObj);
            
            var boundBoxPadding = 0,
                boundBoxStrokeWidth = 0,
                hookHeight = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPadding = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxStrokeWidth = getBoundBoxStrokeWidth(dataLabels, chartObj);
                hookHeight = (stacked || (labelPos === "middle")) ? 0 : hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            var clip = (textOverlap === "clip"),
                handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping && (textOverlap !== "none"),
                padding = mathMax(0, validateNullVal(dataLabels.padding, 2)) + boundBoxPadding + hookHeight;
            padding = (padding > dim) ? dim : padding;
            textDirection = dataLabels.textDirection;
            textDirection = (!textDirection || (stacked && !isStackedLabels)) ? (axisrotated ? "vertical" : "horizontal") : textDirection;
            rotation = axisrotated ? ((textDirection == "horizontal") ? 90 : 0) : ((textDirection == "horizontal") ? 0 : 270);
            var commonOption = renderer.commonOption;
            var getParamValue = function() {
                return chartObj.dataObject.getTransRectValue.apply(chartObj.dataObject, toArray(arguments));
            };
            
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            var updateHandler = labelHandler.update,
                queue = labelHandler.add;
            
            currentdata.data.forEach(function(d, i) {
                var dataUpdate = (renderer.seriesdataAfterUpdate && !isStackedLabels) ? renderer.seriesdataAfterUpdate[i] : currentdata.data[i];
                
                var commonProperties = [];
                applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color, false, index);
                temp_label.style({
                    "fill": "transparent"
                });
                
                dataUpdate.forEach(function(d, j) {
                    var text, boundBox = null,
                        flip = (yaxisReversed ? -1 : 1),
                        isNeg = (isStackedLabels) ? (d[1] < 0) : (dataset.getY(d, yaxiscolumnorder) < 0);
                    
                    temp_label[contentType](function() {
                        if (isStackedLabels) {
                            var yVal = d[1];
                            text = (!showZeros && yVal == 0) ? null : GLT(yVal);
                        } else if (isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder)) || (!showZeros && dataset.getY(d, yaxiscolumnorder) == 0)) {
                            text = null;
                        } else {
                            text = GLT(d);
                        }
                        return text;
                    });

                    if (isMultiLine) {
                        translateTspan(temp_label, 0);
                    }
                    
                    var X, Y, DY, ANCHOR, HOOKPOSITION, actualDY;
                    boundBox = bbox(temp_label.node());
                    var widthToBeAdded = 0,
                        heightToBeAdded = 0;
                    
                    
                    if (isStackedLabels) {
                        // boundBox = bbox(temp_label.node());
                        var x = commonOption.bandwidth1(d[0]) + commonOption.bandwidth2(commonOption.stackGroupIndex) + commonOption.levelMarkerPadding,
                            y = yscale(d[1]);
                        X = axisrotated ? y : x;
                        Y = axisrotated ? x : y;
                        if (axisrotated) {
                            if (textDirection == "horizontal") {
                                X += (isNeg ? -padding : padding) * flip;
                                DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                            } else {
                                X += (isNeg ? -padding : padding) * flip;
                                Y += (barW / 2);
                                DY = "0.3em";
                                ANCHOR = yaxisReversed ? (isNeg ? null : "end") : (isNeg ? "end" : null);
                            }

                            if (isMultiLine) {
                                X += (boundBox.width / 2) * (isNeg ? -1 : 1) * flip;
                            }
                        } else {
                            X += (barW / 2);
                            Y += (isNeg ? padding : -padding) * flip;
                            if (textDirection == "vertical") {
                                DY = "0.3em";
                                ANCHOR = yaxisReversed ? (isNeg ? null : "end") : (isNeg ? "end" : null);
                            } else {
                                DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                                ANCHOR = "middle";
                            }
                        }
                    } else {
                        // var b = boundBox = bbox(temp_label.node()),
                        var b = boundBox,
                            x = getParamValue("x", d, i, j, commonOption) || 0,
                            y = getParamValue("y", d, i, j, commonOption) || 0,
                            width = getParamValue("width", d, i, j, commonOption) || 0,
                            height = getParamValue("height", d, i, j, commonOption) || 0,
                            CLIP = clip;
                        X = x;
                        Y = y;
                        if (axisrotated) {
                            if (stacked) {
                                Y += (height / 2);
                                DY = "0.3em";
                                if (labelPos == "middle") {
                                    X += (width / 2) * flip;
                                    ANCHOR = "middle";
                                } else if (labelPos == "top") {
                                    X += (isNeg ? padding : (width - padding)) * flip;
                                    ANCHOR = yaxisReversed ? (isNeg ? "end" : null) : (isNeg ? null : "end");

                                    if (isMultiLine) {
                                        X += (b.width / 2) * (isNeg ? 1 : -1) * flip;
                                    }
                                } else {
                                    X += (isNeg ? (width - padding) : padding) * flip;
                                    ANCHOR = yaxisReversed ? (isNeg ? null : "end") : (isNeg ? "end" : null);

                                    if (isMultiLine) {
                                        X += (b.width / 2) * (isNeg ? -1 : 1) * flip;
                                    }
                                }
                            } else {
                                if (textDirection == "vertical") {
                                    heightToBeAdded = getSizeToBeAdded(boundBox.height, boundBoxPadding, boundBoxRadius, hookWidth);
                                    Y += (height / 2) + (heightToBeAdded / 2);
                                    DY = "0.3em";
                                    CLIP = CLIP && ((labelPos != "top") && (b.width > width));
                                    HOOKPOSITION = yaxisReversed ? (isNeg ? "left" : "right") : (isNeg ? "right" : "left");
                                    
                                    if (!CLIP) {
                                        ANCHOR = yaxisReversed ? (isNeg ? null : "end") : (isNeg ? "end" : null);
                                        if (labelPos == "middle") {
                                            X += ((b.width > width) ? (isNeg ? width : 0) : (width / 2)) * flip;
                                            ANCHOR = (b.width > width) ? ANCHOR : "middle";
                                        } else if (labelPos == "top") {
                                            X += (isNeg ? -padding : (width + padding)) * flip;
                                        } else {
                                            X += (isNeg ? (width - padding) : padding) * flip;
                                        }

                                        if (isMultiLine && !(labelPos === "middle" && b.width <= width)) {
                                            X += (isNeg ? -boundBox.width/2 : boundBox.width/2) * flip;
                                        }
                                    } else {
                                        if (labelPos == "bottom") {
                                            X += yaxisReversed ? (isNeg ? -width + padding : -width) : (isNeg ? 0 : padding);
                                        } else if (labelPos == "middle") {
                                            X += yaxisReversed ? -width + boundBoxPadding : boundBoxPadding;
                                        }
                                    }
                                } else {
                                    widthToBeAdded = getSizeToBeAdded(boundBox.width, boundBoxPadding, boundBoxRadius, hookWidth);
                                    DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                                    CLIP = CLIP && (b.width > height);
                                    HOOKPOSITION = yaxisReversed ? (isNeg ? "bottom" : "top") : (isNeg ? "top" : "bottom");
                                    
                                    if (labelPos == "middle") {
                                        if (b.height > width) {
                                            if (isMultiLine) {
                                                X += (yaxisReversed ? (isNeg ? width : 0) : (isNeg ? 0 : width)) * flip;
                                                X += yaxisReversed ? ((b.height / 2) * (isNeg ? 1 : -1)) : 0;
                                            } else {
                                                X += (yaxisReversed ? (isNeg ? 0 : width) : (isNeg ? width : 0)) * flip;
                                            }
                                        } else {
                                            X += width / 2 * flip;
                                        }
                                        DY = (b.height > width) ? DY : "0.3em";
                                    } else if (labelPos == "top") {
                                        X += (isNeg ? -padding : (width + padding)) * flip;
                                    } else {
                                        X += (isNeg ? (width - padding) : padding) * flip;
                                    }
                                    if (!CLIP) {
                                        Y += (height / 2);
                                        ANCHOR = "middle";
                                        if (labelPos == "middle") {
                                            DY = "0.3em";
                                        }
                                    } else {
                                        X += (widthToBeAdded / 2);
                                        Y += boundBoxPadding;
                                    }
                                }
                            }
                        } else {
                            if (stacked) {
                                X += (width / 2);
                                ANCHOR = "middle";
                                if (labelPos == "middle") {
                                    Y += (height / 2) * flip;
                                    DY = "0.3em";
                                } else if (labelPos == "top") {
                                    Y += (isNeg ? (height - padding) : padding) * flip;
                                    DY = yaxisReversed ? (isNeg ? "1em" : "-0.3em") : (isNeg ? "-0.3em" : "1em");
                                } else {
                                    Y += (isNeg ? padding : (height - padding)) * flip;
                                    DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                                }
                            } else {
                                if (textDirection == "vertical") {
                                    heightToBeAdded = getSizeToBeAdded(boundBox.height, boundBoxPadding, boundBoxRadius, hookWidth);
                                    var BW = ((!yaxisReversed && isNeg) || (yaxisReversed && !isNeg)) ? b.width : 0;
                                    CLIP = CLIP && ((labelPos != "top") && ((b.width + padding) > height));
                                    DY = "0.3em";
                                    HOOKPOSITION = yaxisReversed ? (isNeg ? "left" : "right") : (isNeg ? "right" : "left");
                                    
                                    if (!CLIP) {
                                        X += (width / 2);
                                        if (labelPos == "middle") {
                                            if (b.width > height) {
                                                if (isMultiLine) {
                                                    Y += (isNeg ? (boundBox.width / 2) : (height - boundBox.width / 2)) * flip;
                                                } else {
                                                    Y += ((isNeg ? 0 : height) * flip) + BW;
                                                }
                                            } else {
                                                Y += height / 2 * flip;
                                            }
                                            ANCHOR = (b.width > height) ? null : "middle";
                                        } else if (labelPos == "top") {
                                            Y += ((isNeg ? (height + padding) : -padding) * flip) + BW;
                                            if (isMultiLine) {
                                                Y -= (boundBox.width / 2);
                                            }
                                        } else {
                                            Y += ((isNeg ? padding : (height - padding)) * flip) + BW;
                                            if (isMultiLine) {
                                                Y -= (boundBox.width / 2);
                                            }
                                        }
                                    } else {
                                        X += (width / 2);
                                        if (labelPos == "middle") {
                                            Y += yaxisReversed ? boundBoxPadding : height - boundBoxPadding;
                                        } else {
                                            Y += yaxisReversed ? (isNeg ? -padding : 0) : (height + (isNeg ? 0 : -padding));
                                        }
                                    }
                                } else {
                                    widthToBeAdded = getSizeToBeAdded(boundBox.width, boundBoxPadding, boundBoxRadius, hookWidth);
                                    CLIP = CLIP && ((b.width + (2 * boundBoxPadding)) > width);
                                    DY = yaxisReversed ? (isNeg ? "-0.3em" : "1em") : (isNeg ? "1em" : "-0.3em");
                                    HOOKPOSITION = yaxisReversed ? (isNeg ? "bottom" : "top") : (isNeg ? "top" : "bottom");
                                    
                                    if (labelPos == "middle") {
                                        Y += ((b.height < height) ? (height / 2) : (isNeg ? 0 : height)) * flip;
                                        DY = (b.height < height) ? "0.3em" : DY;
                                    } else if (labelPos == "top") {
                                        Y += (isNeg ? (height + padding) : -padding) * flip;
                                    } else {
                                        Y += (isNeg ? padding : (height - padding)) * flip;
                                    }
                                    if (!CLIP) {
                                        X += (width / 2);
                                        ANCHOR = "middle";
                                    } else {
                                        X += boundBoxPadding;
                                    }
                                }
                            }
                        }
                    }
                    
                    if (isMultiLine) {
                        DY = parseFloat(DY);
                        var lineCount = dataLabels.showAs.length - 1;
                        if (DY === -0.3) {
                            actualDY = DY;
                            DY -= lineCount;
                        } else if (DY === 0.3) {
                            actualDY = DY;
                            DY -= (lineCount / 2)
                        }
                        DY += "em";

                        if (!CLIP) {
                            ANCHOR = "middle";
                        }
                    }

                    temp_label.attr({
                        "x": X,
                        "y": Y,
                        "dy": DY,
                        "text-anchor": ANCHOR,
                        "transform": "rotate(" + rotation + " " + X + " " + Y + ")"
                    });
                    
                    var xDiff = 0,
                        yDiff = 0,
                        adjustX = 0,
                        adjustY = 0;
                    HOOKPOSITION = (labelPos === "middle") ? null : HOOKPOSITION // There is no hook for middle datalabels
                    if (axisrotated) {
                        adjustY = ((textDirection === "horizontal") ? widthToBeAdded : heightToBeAdded) / 2;
                    } else {
                        adjustX = ((textDirection === "horizontal") ? widthToBeAdded : heightToBeAdded) / 2;
                    }
                    
                    if (!clip) {
                        if (isMultiLine) {
                            translateTspan(temp_label, X);
                        }
                        var adjust = boundBoxPadding + (boundBoxStrokeWidth / 2),
                            scrolledX = 0,//chartObj.chartRendered ? (chartObj.scrolledX || 0) : 0,
                            scrolledY = 0;//chartObj.chartRendered ? (chartObj.scrolledY || 0) : 0;
                            
                        var b = temp_label.node().getBoundingClientRect(),
                            leftPos = (b.left - rectBoundLeft - adjust - adjustX - scrolledX),
                            rightPos = (leftPos + b.width + (2 * adjust) + (2 * adjustX)),
                            topPos = (b.top - rectBoundTop - adjust - adjustY - scrolledY),
                            bottomPos = (topPos + b.height + (2 * adjust) + (2 * adjustY));
                        
                        var newX = X + ((leftPos < left) ?
                                (left - leftPos) :
                                ((rightPos > right) ? -(rightPos - right) : 0));
                        if (newX != X) {
                            xDiff = newX - X;
                            X = newX;
                        }
                        var newY = Y + ((topPos < top) ? (top - topPos) : ((bottomPos > bottom) ? -(bottomPos - bottom) : 0));
                        if (newY != Y) {
                            yDiff = newY - Y;
                            Y = newY
                        }
                    }
                    

                    /**
                     * Overlapping handle
                     */
                    
                    var isWithinClrRange = isWithinColorRange(dataset.getClr(d), chartObj);
                    var display = isStackedLabels || isWithinClrRange;
                    if (handleOverlapping) {
                        if (stacked && !isStackedLabels) {
                            if (isMultiLine) {
                                translateTspan(temp_label, X);
                            }
                            boundBox = bbox(temp_label.node());
                            var x = getParamValue("x", d, i, j, commonOption) || 0,
                                y = getParamValue("y", d, i, j, commonOption) || 0,
                                height = getParamValue("height", d, i, j, commonOption) || 0,
                                width = getParamValue("width", d, i, j, commonOption) || 0;
                            
                            if (yaxisReversed) {
                                axisrotated ? (x -= width) : (y -= height);
                            }
                            
                            var labelBound = {
                                    "x1": boundBox.x - boundBoxPadding,
                                    "y1": boundBox.y - boundBoxPadding,
                                    "x2": (boundBox.x + boundBox.width + boundBoxPadding),
                                    "y2": (boundBox.y + boundBox.height + boundBoxPadding)
                                },
                                barBound = {
                                    x1: x,
                                    y1: y,
                                    x2: (x + width),
                                    y2: (y + height)
                                };
                            
                            var within = isLabelWithinBound(labelBound, barBound);
                            if (!within) {
                                display = false;
                            }
                            
                        } else {
                            if (!clip || isStackedLabels) {
                                if (isMultiLine) {
                                    translateTspan(temp_label, X);
                                }
                                var b = temp_label.node().getBoundingClientRect();
                                var bx = (b.left - rectBoundLeft),
                                    by = (b.top - rectBoundTop);
                                var obj = {
                                    id: "lbl" + index + "_" + i + "_" + j,
                                    translateFunction: updateHandler,
                                    x1: bx - boundBoxPadding + xDiff - adjustX,
                                    y1: by - boundBoxPadding + yDiff - adjustY,
                                    x2: (bx + b.width) + boundBoxPadding + xDiff + (!rotation ? 0 : (hookHeight + (2 * boundBoxStrokeWidth))) + adjustX,
                                    y2: (by + b.height) + boundBoxPadding + yDiff + (rotation ? 0 : (hookHeight + (2 * boundBoxStrokeWidth))) + adjustY,
                                    overlap: textOverlap
                                };
                                labelArray.push(obj);
                            } else {
                                if (textDirection != "horizontal") {
                                    var w = getParamValue((axisrotated ? "width" : "height"), d, i, j, commonOption) || 0;
                                    width = (labelPos == "top") ?
                                        boundBox.width :
                                        (w - ((labelPos == "bottom") ?
                                            (padding + boundBoxPadding) :
                                            (2 * boundBoxPadding)));
                                } else {
                                    width = barW - (2 * boundBoxPadding);
                                }
                                
                                boundBox.width = mathMin(width, boundBox.width);
                            }
                        }
                    }

                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "DY": DY,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "height": (boundBox.height + heightToBeAdded),
                        "width": (boundBox.width + widthToBeAdded),
                        "hookPosition": HOOKPOSITION,
                        "adjustVal": (textDirection === "horizontal") ? (axisrotated ? yDiff : xDiff) : null
                    };

                    if (actualDY !== undefined) {
                        coordinate.actualDY = actualDY;
                    }

                    if (isCanvasMode && contentType === "html") {
                        coordinate.tspanInfo = getTspanBound(temp_label, fontSize);
                    }

                    commonProperties.push(coordinate);
                });
                
                // add to drawing queue
                commonProperties.dataUpdate = dataUpdate; //Each subseries may have different dataUpdates
                var q = queue(commonProperties, index, i, null, isStackedLabels);
                q.properties = {
                    "type": "bar",
                    "dataLabels": dataLabels,
                    "rotation": rotation,
                    "color": rp.color,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "multiColoring": multiColoring,
                    "textDirection": textDirection,
                    "rp": rp,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
            });
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    
    return labels;
};//$Id$
$ZC.labelRenderer.pie = function() {
    var renderer, args,
        outline,
        isSunburst,
        chartObj,
        dataset;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                pieData = args[2],
                outerRadius = args[3],
                totalEngagement = args[4],
                outlineWithPad = args[5],
                translation = "translate(" + args[8][0] + "," + args[8][1] + ")",
                extraOptions = args[9] || {},
                rp = renderer.commonRendererProp().params;

            chartObj = rp.chartObj;
            dataset = chartObj.dataset;
            var systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                labelArray = rp.labelArray,
                index = rp.datasetIndex || args[1] || 0, //For pie & dial chart, rp.datasetIndex is undefined
                dataLabels,
                chartheight = (renderer.plotarea ? renderer.plotarea() : chartObj.plotarea).height;
            isSunburst = !pieData;
            currentdata = currentdata[index];
            outline = args[6];

            var handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping === true,
                datalabelPadding, padding, txtHgt, showlabel;
            
            var plotoptions = currentdata.plotoptions;
            var dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            showlabel = isDatalabelEnabled(dataLabels, chartObj);
            
            if (currentdata.disabled || !showlabel) {
                return;
            }
            
            var type = dataLabels.type,
                lineConf = dataLabels.line,
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", totalEngagement, index),
                contentType = GLT.contentType || "text",
                isHTMLContent = (contentType === "html"),
                isMultiLine = isHTMLContent && GLT.multiLine,
                boundBoxPaddingAlone = 0,
                boundBoxPadding = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPaddingAlone = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxPadding = boundBoxPaddingAlone + getBoundBoxStrokeWidth(dataLabels, chartObj) + hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            showlabel = showlabel ? type : "hidden";
            datalabelPadding = (extraOptions.padding || +(dataLabels.padding || 0)) + boundBoxPadding;
            txtHgt = getFontSizeByHierarchy(dataLabels, chartObj);
            padding = +($ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("outerPadding") || 0);
            renderer.autoLabelDone = false, renderer.showlabel = showlabel, renderer.lineStrokeWidth = validateNullVal(lineConf.strokeWidth, 1);
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            temp_label
                .attr("transform", translation);
            var queue = labelHandler.add;
            
            (isSunburst ? currentdata : currentdata.data).forEach(function(d, i) {
                var dataUpdate = (renderer.seriesdataAfterUpdate) ? renderer.seriesdataAfterUpdate[i] : (pieData || d);
                
                var commonProperties = [];
                applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color);
                temp_label
                    .style("fill", "transparent");
                
                dataUpdate.forEach(function(d, j) {
                    var text,
                        bb = null,
                        display = !isdisabled(d),
                        heightToBeAdded = 0;
                    
                    var angle = midAngle(d);
                    var isLeft = (angle < 0) || (angle > mathPI);
                    var X = (showlabel == "doubleside") ? ((angle < 0 || angle > mathPI) ? -(outerRadius + datalabelPadding) : (outerRadius + datalabelPadding)) : outlineWithPad.centroid(d)[0],
                        Y = outlineWithPad.centroid(d)[1] + mathMax(0, (txtHgt - padding - 10) - (outerRadius + outlineWithPad.centroid(d)[1])),
                        ANCHOR = isMultiLine ? "middle" : isLeft ? "end" : "start",
                        DY = isMultiLine ? "0.9em" : ((showlabel == "circular") && (angle > mathPI / 2 && angle < 3 * mathPI / 2) ? getDY(angle) + "em" : "0.3em");
                    var actualDY = DY;
                    
                    var dt = isSunburst ? d : d.data;
                    var toNull = isSunburst ? (d.depth == 0) : isdisabled(d);
                    text = (toNull ? null : GLT(dt));
                    
                    temp_label[contentType](text)
                        .attr({
                            "x": X,
                            "y": Y,
                            "dy": DY,
                            "text-anchor": ANCHOR
                        });

                    if (display && isMultiLine) {
                        translateTspan(temp_label, X);
                        var bb = bbox(temp_label.node());
                        if (showlabel == "circular") {
                            var yscale = d3_scaleLinear()
                                    .range([-1, 0])
                                    .domain((angle < mathPI) ? [0, mathPI] : [2 * mathPI, mathPI]);
                            Y += (yscale(angle) * bb.height);
                            X += ((angle>0 && angle < mathPI) ? 0.5 : (angle>mathPI && angle < 2*mathPI) ? -0.5 : 0) * bb.width;

                        } else {
                            Y -= (0.5 * bb.height);
                            X -= (bb.width / 2) * (isLeft ? 1 : -1);
                        }

                        temp_label.attr("y", Y);
                        translateTspan(temp_label, X);
                    }
                    
                    if (handleOverlapping) {
                        renderer.showlabel = "auto";
                        var MARGIN = 5,
                            extra = 10;
                        
                        if (!isMultiLine) {
                            DY = "0.3em";
                            temp_label
                                .attr("dy", DY); // Test_495.json
                        }
                        
                        if (display) {
                            bb = bbox(temp_label.node());
                            heightToBeAdded = getSizeToBeAdded(bb.height, boundBoxPaddingAlone, boundBoxRadius, hookWidth);
                            var DX = isLeft ?
                                    -(outerRadius + datalabelPadding + extra) :
                                    (outerRadius + datalabelPadding + extra);
                            if (isMultiLine) {
                                DX += (bb.width / 2) * (isLeft ? -1 : 1);
                            }

                            var obj = {
                                id: "lbl" + index + "_" + i + "_" + j,
                                x1: bb.x - boundBoxPadding,
                                x2: bb.x + bb.width + boundBoxPadding,
                                y1: bb.y - MARGIN - boundBoxPadding - (heightToBeAdded / 2),
                                y2: (bb.y + bb.height + MARGIN + boundBoxPadding + (heightToBeAdded / 2)),
                                isLeft: isLeft,
                                actualDY: actualDY,
                                DX: DX - X,
                                overlappingHookPosition: (isLeft ? "right" : "left")
                            };
                            labelArray.push(obj);
                        }
                    } else {
                        bb = bbox(temp_label.node());
                        heightToBeAdded = getSizeToBeAdded(bb.height, boundBoxPaddingAlone, boundBoxRadius, hookWidth);
                    }
                    
                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "DY": DY,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "ID": "lbl" + index + "_" + i + "_" + j,
                        "width": (display ? bb.width : 0),
                        "height": (display ? (bb.height + heightToBeAdded) : 0),
                        "hookPosition": (showlabel === "circular") ? null : (isLeft ? "right" : "left")
                    };

                    if (isHTMLContent) {
                        coordinate.isLeft = isLeft;
                    }

                    commonProperties.push(coordinate);
                });
                
                // add to drawing queue
                var q = queue(commonProperties, index, i);
                q.properties = {
                    "type": "pie",
                    "dataLabels": dataLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": renderer.showlabel,
                    "rp": rp,
                    "translation": translation,
                    "trans": args[8],
                    "txtHgt": txtHgt,
                    "isSunburst": isSunburst,
                    "connectorPath": function(d, i) {
                        var angle = midAngle(d);
                        var str = "M " + outline.centroid(d)[0] + " " + outline.centroid(d)[1] + " L" + outlineWithPad.centroid(d)[0] + " " + outlineWithPad.centroid(d)[1];
                        return str + " L" + outlineWithPad.centroid(d)[0] + " " + outlineWithPad.centroid(d)[1] + " L" + ((angle < 0 || angle > mathPI) ? -(outerRadius + datalabelPadding - boundBoxPadding) : (outerRadius + datalabelPadding - boundBoxPadding)) + " " + outlineWithPad.centroid(d)[1];
                    },
                    "onNonOverlap": function() {
                        q.properties.showlabel = renderer.showlabel = showlabel;
                        renderer.autoLabelDone = true;
                    },
                    "onOverlap": function() {
                        q.properties.connectorPath = function(d, i) {
                            var extra = 10;
                            var angle = midAngle(d);
                            var pad = mathMax(0, (txtHgt - padding - 10) - (outerRadius + outlineWithPad.centroid(d)[1]));
                            var y = outlineWithPad.centroid(d)[1] + pad;
                            var flip = ((angle < 0) || (angle > mathPI)) ? -1 : 1;
                            var newY = q[0][i].Y + (isMultiLine ? q[0][i].height/2 : 0);
                            // var path = "M " + outline.centroid(d)[0] + " " + outline.centroid(d)[1] +
                            //     " L" + outlineWithPad.centroid(d)[0] + " " + outlineWithPad.centroid(d)[1] +
                            //     " L" + ( (outerRadius + datalabelPadding) * flip ) + " " + outlineWithPad.centroid(d)[1] +
                            //     " L" + ( (outerRadius + datalabelPadding + extra) * flip ) + " " + newY;
                            // ele
                            // .attr("d", path);
                            
                            var xControl = (newY - y) ? (outerRadius + datalabelPadding - boundBoxPadding + extra) * flip : outlineWithPad.centroid(d)[0],
                                yControl = outlineWithPad.centroid(d)[1],
                                x2 = (outerRadius + datalabelPadding - boundBoxPadding + extra) * flip,
                                y2 = newY;
                            var path = "M " + outline.centroid(d)[0] + " " + outline.centroid(d)[1] +
                                " Q " + xControl + " " + yControl + " " + x2 + " " + y2;
                            return path;
                        };
                    },
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
                
                labelArray.TOP = -args[8][1],
                    labelArray.BOTTOM = (chartheight - args[8][1]);
                
            });
            
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    
    function isdisabled(d) {
        var isWithinClrRange = isWithinColorRange(dataset.getClr(isSunburst ? d : d.data), chartObj);
        return !isWithinClrRange || (isSunburst ?
            (d.parent == null || d.value == 0) :
            (d.value == 0));
    }
    
    function midAngle(d) {
        var start = isSunburst ? outline.startAngle()(d) : d.startAngle,
            end = isSunburst ? outline.endAngle()(d) : d.endAngle;
        return (start + end) / 2;
    }
    
    return labels;
};//$Id$
$ZC.labelRenderer.dial = function() {
    var renderer, args;
    
    function labels(selection, labelHandler, container) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                color = rp.color,
                plotoptions = currentdata.plotoptions;
            var plotarea_approx = chartObj.plotarea_approx,
                yscaleDomain = chartObj.axes.y.groups[0].scale.domain(),
                innerRadius = plotarea_approx.innerRadius;
            
            var dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var showlabel = isDatalabelEnabled(dataLabels, chartObj),
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", (yscaleDomain[1] - yscaleDomain[0]), 0),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine;
            
            if (!showlabel) {
                return;
            }
            
            var boundBoxPadding = isBoundBoxEnabled(dataLabels, chartObj) ?
                (getBoundBoxPadding(dataLabels, chartObj) + getBoundBoxStrokeWidth(dataLabels, chartObj)) :
                0;
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            applyDatalabelFonts(temp_label, dataLabels, chartObj, color[0]);
            temp_label
                .style("fill", "transparent");
            
            var dataUpdate = [chartObj.userdata.seriesdata.chartdata[0].data[0][0]],
                commonProperties = [],
                i = 0; //subseries index
            
            dataUpdate.forEach(function(d, j) {
                var ANCHOR = "middle",
                    DY = isMultiLine ? "0.9em" : "-.3em",
                    text = GLT(d),
                    display = true;
                
                temp_label[contentType](text)
                    .attr({
                        "x": X,
                        "dy": DY,
                        "text-anchor": ANCHOR
                    });
                
                var bb = bbox(temp_label.node());
                var X = defined(dataLabels.x) ?
                        invokeFunction(dataLabels.x, d, chartObj, bb) :
                        plotarea_approx.x,
                    Y = defined(dataLabels.y) ?
                        invokeFunction(dataLabels.y, d, chartObj, bb) :
                        (plotarea_approx.y + (commonPlotOptions.needle.show ?
                            (bb.height + (+dataLabels.padding || 0) + ((+commonPlotOptions.needle.width) / 2 || 7) + boundBoxPadding) :
                            (bb.height / 2)));

                if (isMultiLine) {
                    if (!defined(dataLabels.y)) {
                        Y -= bb.height;
                    }
                    translateTspan(temp_label, X);
                    bb = bbox(temp_label.node());
                }
                
                var coordinate = {
                    "X": X,
                    "Y": Y,
                    "DY": DY,
                    "ANCHOR": ANCHOR,
                    "text": text,
                    "display": display,
                    "ID": "lbl" + index + "_" + i + "_" + j,
                    "width": bb.width,
                    "height": bb.height
                };
                commonProperties.push(coordinate);
            });
            
            if (container) {
                var conf = commonProperties[0];
                var labelText = appendEle(container, "text", (showlabel ? dataUpdate : []));
                applyDatalabelFonts(labelText, dataLabels, chartObj, color[0]);
                labelText[contentType](conf.text)
                    .attr({
                        "text-anchor": conf.ANCHOR,
                        "dy": conf.DY,
                        "transform": "translate(" + conf.X + "," + conf.Y + ")"
                    });

                if (isMultiLine) {
                    translateTspan(temp_label, conf.X);
                }
            } else {
                var queue = labelHandler.add;
                // add to drawing queue
                var q = queue(commonProperties, index, i);
                q.properties = {
                    "type": "dial",
                    "dataLabels": dataLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "rp": rp,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
            }
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    return labels;
};//$Id$
$ZC.labelRenderer.funnel = function() {
    var MARGIN = 5,
        renderer, args;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                data = args[2],
                noofNotNullData = args[3],
                arcHeight = args[4],
                totalEngagement = args[5],
                cfg = args[6],
                labelPosition = args[7];
            var chartWidth = cfg.width,
                chartHeight = cfg.height,
                rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                labelArray = rp.labelArray,
                chartName = chartObj.chartTypes[0].name,
                stage,
                dataLabels;
            var translation = chartObj.svg.selectAll("g." + chartName + "group").attr("transform"),
                isPyramid = (chartName === "pyramid");
            
            currentdata = currentdata[index];
            var plotoptions = currentdata.plotoptions,
                boundBoxPaddingAlone = 0,
                boundBoxPadding = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPaddingAlone = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxPadding = boundBoxPaddingAlone + getBoundBoxStrokeWidth(dataLabels, chartObj) + hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            var padding = cfg.datalabelPadding || (+dataLabels.padding || 0),
                type = dataLabels.type,
                handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping === true,
                txtHgt = getFontSizeByHierarchy(dataLabels, chartObj),
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", totalEngagement, index),
                contentType = GLT.contentType || "text",
                isHTMLContent = (contentType === "html"),
                isMultiLine = isHTMLContent && GLT.multiLine,
                showlabel = isDatalabelEnabled(dataLabels, chartObj),
                relativeX = dataLabels.relativeX === true;
            
            if (!showlabel) {
                return;
            }
            
            showlabel = showlabel ? type : "hidden";
            var data_length = data.length,
                PathGroupPosition = d3_transform(translation).translate,
                idx = 0;
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color);
            temp_label
                .attr("transform", translation)
                .style("fill", "transparent");
            var queue = labelHandler.add;
            
            currentdata.data.forEach(function(d, i) {
                var dataUpdate = labelPosition,
                    commonProperties = [];
                
                dataUpdate.forEach(function(d, j) {
                    var display = !isdisabled(j),
                        isLeft = isLeftHalf(idx),
                        heightToBeAdded = 0,
                        bb;
                    
                    var X = getEndX(d, idx) + (isLeft ? -boundBoxPadding : boundBoxPadding),
                        Y = (isPyramid && isLeft) ?
                            d.leftY :
                            mathMax(d.y, (txtHgt - arcHeight - d.y)),
                        ANCHOR = isMultiLine ? "middle" : (isLeft ? "end" : null),
                        DY = isMultiLine ? "0.9em" : "0.3em";
                    
                    var dt = d.data = data[data_length - 1 - j];
                    var text = GLT(dt);
                    
                    temp_label[contentType](text)
                        .attr({
                            "x": X,
                            "y": Y,
                            "text-anchor": ANCHOR,
                            "dy": DY
                        });

                    if (display && isMultiLine) {
                        translateTspan(temp_label, X);
                        var bb = bbox(temp_label.node());
                        Y -= (bb.height / 2);
                        X += (bb.width / 2) * (isLeft ? -1 : 1);
                        translateTspan(temp_label, X);
                        temp_label.attr("y", Y);
                    }
                    
                    if (handleOverlapping) {
                        if (display) {
                            bb = bbox(temp_label.node());
                            heightToBeAdded = getSizeToBeAdded(bb.height, boundBoxPaddingAlone, boundBoxRadius, hookWidth);
                            var DX = (isLeft ?
                                    -(0 + padding + boundBoxPadding) :
                                    (chartWidth + padding + boundBoxPadding));
                            if (isMultiLine) {
                                DX += (bb.width / 2) * (isLeft ? -1 : 1);
                            }

                            var obj = {
                                id: "lbl" + index + "_" + i + "_" + j,
                                x1: bb.x - boundBoxPadding,
                                x2: bb.x + bb.width + boundBoxPadding,
                                y1: bb.y - MARGIN - boundBoxPadding - (heightToBeAdded / 2),
                                isLeft: isLeft,
                                y2: (bb.y + bb.height + MARGIN + boundBoxPadding + (heightToBeAdded / 2)),
                                DX: DX - X
                            };
                            labelArray.push(obj);
                        }
                    } else {
                        bb = bbox(temp_label.node());
                        heightToBeAdded = getSizeToBeAdded(bb.height, boundBoxPaddingAlone, boundBoxRadius, hookWidth);
                    }
                    
                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "ANCHOR": ANCHOR,
                        "DY": DY,
                        "text": text,
                        "display": display,
                        "ID": "lbl" + index + "_" + i + "_" + j,
                        "width": (display ? bb.width : 0),
                        "height": (display ? (bb.height + heightToBeAdded) : 0),
                        "hookPosition": isLeft ? "right" : "left"
                    };

                    if (isHTMLContent) {
                        coordinate.isLeft = isLeft;
                    }

                    commonProperties.push(coordinate);
                    
                    idx += display ? 1 : 0;
                });
                
                idx = -1;
                // add to drawing queue
                var q = queue(commonProperties, index, i);
                q.properties = {
                    "type": "pie",
                    "dataLabels": dataLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "rp": rp,
                    "translation": translation,
                    "trans": PathGroupPosition,
                    "txtHgt": txtHgt,
                    "connectorPath": function(d, i) {
                        idx += isdisabled(i) ? 0 : 1;
                        var y = q[0][i].Y + (isMultiLine ? q[0][i].height/2 : 0),
                            y0 = (isPyramid && isLeftHalf(idx)) ? d.leftY : d.y;
                        return "M" + getStartX(d, idx) + " " + y0 +
                            " L" + getEndX(d, idx, 0) + " " + y0 +
                            " L" + getEndX(d, idx) + " " + y;
                    },
                    "reverseColor": true,
                    "onOverlap": function() {
                        stage = "overlap";
                    },
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
                
                labelArray.TOP = -PathGroupPosition[1],
                    labelArray.BOTTOM = chartHeight + PathGroupPosition[1];
                labelArray.actualType = "funnel";
                
            });
            
            
            function isdisabled(i) {
                var dt = data[data_length - 1 - i];
                var isWithinClrRange = isWithinColorRange(dataset.getClr(dt), chartObj);
                return dt.disabled || !dataset.getY(dt, yaxiscolumnorder) || !isWithinClrRange;
            }
            
            function isLeftHalf(idx) {
                switch (showlabel) {
                    case "singleside":
                        return false;
                    case "doubleside":
                        return idx % 2 == 0;
                    case "strokeddoubleside":
                        return idx >= (noofNotNullData / 2);
                }
            }
            
            function getStartX(d, i) {
                return isLeftHalf(i) ?
                    (d.leftx + padding) :
                    (d.rightx - padding);
            }
            
            function getEndX(d, i, pad) {
                var isLeft = isLeftHalf(i);
                if (!relativeX || (stage == "overlap")) {
                    pad = defined(pad) ? pad : padding;
                    return isLeft ? (0 - pad) : (chartWidth + pad)
                } else {
                    return isLeft ? (d.leftx - boundBoxPadding) : (d.rightx + boundBoxPadding);
                }
            }
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    return labels;
};//$Id$
/*
 * PENDING:
 * Bound box - minHeight should be considered for height on handling overlapping datalabels (if hook is enabled)
 */
$ZC.labelRenderer.scatter = function() {
    var renderer, args, labelseries,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                size = args[2] || 0,
                yrangePos = args[3],
                transform = [0, 0],
                plotoptions = currentdata.plotoptions,
                dataLabels, rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                stacked = rp.stacked,
                axisrotated = rp.axisrotated,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                xscale = rp.xscale,
                yscale = rp.yscale,
                labelArray = rp.labelArray,
                chartType = chartObj.chartTypes[index].value,
                isRangeChart = chartObj.chartTypes[index].name == "arearange",
                isCanvasMode = chartObj.plot.renderer.mode === "canvas";
            var scatterOrBubble = isScatterChartType(chartType),
                isBubbleChart = (chartType == $ZC.charttype.bubble),
                isBubblePie = (chartType == $ZC.charttype.bubblepie),
                isPolar = chartObj.dataObject.isPolarAxisCategory;
            
            dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var showlabel = isDatalabelEnabled(dataLabels, chartObj);
            
            if (currentdata.disabled || !showlabel) {
                return;
            }
            
            var currentPlotBound = getPlotBound(chartObj),
                boundBoxPadding = 0,
                boundBoxStrokeWidth = 0,
                hookHeight = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPadding = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxStrokeWidth = getBoundBoxStrokeWidth(dataLabels, chartObj);
                hookHeight = hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            var padding = isBubbleChart ? 0 : (mathMax(0, +(dataLabels.padding || 0)) + boundBoxPadding + hookHeight),
                textOverlap = dataLabels.textOverlap, //hidden | adjust | ellipsis
                handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping === true,
                multiColoring = scatterOrBubble ? ($ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions)("multiColoring") && !chartObj.legendarea.show) : false,
                rectBound = chartObj.svg.node().getBoundingClientRect(),
                left = currentPlotBound.left,
                top = currentPlotBound.top,
                right = currentPlotBound.right,
                bottom = currentPlotBound.bottom,
                rectBoundLeft = (rectBound.left + chartObj.plotarea.left),
                rectBoundTop = (rectBound.top + chartObj.plotarea.top),
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", yscale.domain()[1], index, yrangePos),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine,
                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),
                fontSize = getFontSizeByHierarchy(dataLabels, chartObj);
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            var updateHandler = labelHandler.update,
                queue = labelHandler.add;
            
            
            currentdata.data.forEach(function(d, i) {
                var dataUpdate = renderer.seriesdataAfterUpdate ? renderer.seriesdataAfterUpdate[i] : currentdata.data[i];
                
                var calculated_points = [];
                applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color, false, index);
                temp_label.style({
                    "fill": "transparent"
                });
                
                dataUpdate.forEach(function(d, j) {
                    var xVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos),
                        yVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos),
                        zVal = (isBubbleChart || isBubblePie) ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "z", chartObj.zscale) : null,
                        isWithinClrRange = isWithinColorRange(dataset.getClr(d), chartObj);
                    var x = null,
                        y = null,
                        text = null,
                        tspanInfo = null,
                        display = isWithinClrRange,
                        id = "",
                        dy = isMultiLine ? "0.9em" : (isBubbleChart ? "0.3em" : "-0.3em"),
                        ANCHOR = "middle",
                        HOOKPOSITION = isBubbleChart ? null : "bottom",
                        xDiff = 0,
                        yDiff = 0,
                        polarXY;

                    if (isBubblePie) {
                        var X = dataset.getX(d);
                        var pieRenderer = chartObj.subrenderer[i][X];
                        var pieData = pieRenderer.data[index];
                        var midAngle = (pieData.startAngle + pieData.endAngle) / 2;
                        var outerRadius = (zVal / 2) + padding;
                        var polarXY = polarToXY(outerRadius, midAngle);
                        dy = (midAngle > mathPI / 2 && midAngle < 3 * mathPI / 2) ? getDY(midAngle) + "em" : "0";
                        ANCHOR = (midAngle < 0 || midAngle > mathPI) ? "end" : "start";
                        GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", pieRenderer.total, index, yrangePos);
                    }
                    temp_label[contentType](function() {
                            if (d.isDummy || isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder, yrangePos))) {
                                text = null;
                            } else {
                                text = GLT(d);
                            }
                            return text;
                        })
                        .style({
                            "display": function() {
                                if (isPolar) {
                                    return null;
                                }
                                //If the data point itself out of plot, need not to show label.
                                var ptX = xVal,
                                    ptY = yVal,
                                    pointOutOfPlot = (ptX < left || ptX > right || ptY < top || ptY > bottom);
                                return pointOutOfPlot ? ((display = false), "none") : null;
                            }
                        })
                        .attr({
                            "transform": null,
                            "dy": dy,
                            "x": function() {
                                x = isBubblePie ?
                                    (xVal + polarXY[0]) :
                                    xVal;
                                return x || 0;
                            },
                            "y": function() {
                                var radius = (isBubbleChart ? 0 : size) / 2;
                                y = isBubblePie ?
                                    (yVal + polarXY[1]) :
                                    yVal + ((radius + padding) * ((isRangeChart && !yrangePos) ? 1 : -1));
                                return y || 0;
                            },
                            "text-anchor": ANCHOR
                        });
                    
                    // ID
                    id = "lbl" + index + "_" + i + "_" + j + "_" + yrangePos;

                    var textBound;
                    if (isMultiLine) {
                        translateTspan(temp_label, x);
                        textBound = bbox(temp_label.node());
                        y -= isBubbleChart ? (textBound.height / 2) : textBound.height;
                        temp_label.attr("y", y);
                        textBound = bbox(temp_label.node());
                    } else if (contentType === "html") { //Test_665.json
                        textBound = bbox(temp_label.node());
                    } else {
                        textBound = getTextBound(text, fontSize, getFontFamilyByHierarchy(dataLabels, chartObj));
                        textBound.x = x - textBound.width / 2;
                        textBound.y = y - textBound.height;
                    }
                    
                    // Adjust Text Within Bound
                    var widthToBeAdded = 0;
                    if (!isPolar) {
                        widthToBeAdded = getSizeToBeAdded(textBound.width, boundBoxPadding, boundBoxRadius, hookWidth);
                        var adjust = boundBoxPadding + (boundBoxStrokeWidth / 2) + (widthToBeAdded / 2),
                            scrolledX = 0;//chartObj.chartRendered ? (chartObj.scrolledX || 0) : 0;

                        var label = temp_label,
                            leftPos = textBound.x - adjust,
                            rightPos = (leftPos + textBound.width + scrolledX + (2 * adjust));
                        var newX = x + ((leftPos < left) ? (left - leftPos) : ((rightPos > right) ? -(rightPos - right) : 0));


                        if (xDiff = (newX - x)) {
                            x = newX;
                            label.attr("x", newX);
                            if (isMultiLine) {
                                translateTspan(temp_label, newX);
                            }
                        }

                        // var z = +label.attr("y");
                        var newY = y + ((textBound.y < top) ? (textBound.height + size + padding) : 0);
                        if (yDiff = newY - y) {
                            if (chartObj.dataObject.isStackedPercentChart && !axisrotated) {
                                y = newY;
                                label.attr("y", newY);
                            } else {
                                display = false;
                            }
                        }

                        if(isMultiLine && (xDiff || yDiff)) {
                            textBound = bbox(temp_label.node());
                        } else {
                            textBound.x += xDiff;
                            textBound.y += yDiff
                        }
                    }



                    widthToBeAdded = (isPolar) ? getSizeToBeAdded(textBound.width, boundBoxPadding, boundBoxRadius, hookWidth) : widthToBeAdded;
                    var bb_width = textBound.width + widthToBeAdded,
                        bb_height = textBound.height,
                        bb_x = textBound.x + (widthToBeAdded / 2);
                    if (handleOverlapping) {
                        var radius = (isBubbleChart ? zVal : size) / 2;
                        
                        if (isBubbleChart) { // Bubble chart - Don't show datalabels when they are out of the bubble bound
                            var cx = xVal,
                                cy = yVal,
                                leftDist = mathSQRT(mathPow((cx - bb_x), 2) + mathPow((cy - textBound.y), 2)) + boundBoxPadding,
                                rightDist = mathSQRT(mathPow((cx - (bb_x + textBound.width)), 2) + mathPow((cy - (textBound.y + textBound.height)), 2)) + boundBoxPadding;
                            
                            if ((leftDist > radius) || (rightDist > radius)) {
                                var trimmed;
                                if (textOverlap === "ellipsis") { // add ellipsis
                                    var h = mathMin((textBound.height / 2), radius);
                                    var w = mathSQRT(mathPow(radius, 2) - mathPow(h, 2));
                                    var bubbleBound = {
                                        "left": (cx - w + boundBoxPadding),
                                        "top": (cy - w + boundBoxPadding),
                                        "right": (cx + w - boundBoxPadding),
                                        "bottom": (cy + w - boundBoxPadding)
                                    };

                                    if (contentType === "html") {
                                        tspanInfo = getTspanBound(temp_label, fontSize);
                                        trimAllTspan(temp_label, chartObj, transform, 0, bubbleBound, tspanInfo);
                                    } else {
                                        callTrimText(temp_label, chartObj, transform, 0, bubbleBound);
                                    }

                                    var trimmedText = temp_label.text();
                                    if (trimmedText && trimmedText !== "..") { //If the textContent is just "..", hide the label
                                        text = temp_label[contentType]();
                                        trimmed = true;
                                        bb_width = (2 * w) - (2 * boundBoxPadding);
                                        if (isMultiLine) {
                                            var newBB = bbox(temp_label.node());
                                            bb_height = newBB.height;
                                            bb_width = newBB.width + widthToBeAdded;
                                            y += (textBound.height - newBB.height) / 2;
                                        }
                                    }
                                }
                                
                                if (!trimmed) {
                                    display = false;
                                    temp_label.style("display", "none");
                                }
                            }
                        }

                        var obj = {
                            id: id,
                            x1: bb_x - boundBoxPadding,
                            y1: textBound.y - boundBoxPadding,
                            x2: (bb_x + bb_width + boundBoxPadding),
                            y2: (textBound.y + textBound.height + boundBoxPadding + hookHeight),
                            pointRadius: (radius + padding - hookHeight),
                            translateFunction: updateHandler,
                            overlap: textOverlap,
                            hookHeight: hookHeight
                        };
                        labelArray.push(obj);
                    }

                    var coordinate = {
                        "X": x,
                        "Y": y,
                        "DY": dy,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "height": bb_height,
                        "width": bb_width,
                        "hookPosition": HOOKPOSITION,
                        "adjustVal": xDiff
                    };

                    if (isCanvasMode && contentType === "html") {
                        coordinate.tspanInfo = tspanInfo || getTspanBound(temp_label, fontSize);
                    }

                    calculated_points.push(coordinate);
                });

                calculated_points.dataUpdate = dataUpdate; //Each subseries may have different dataUpdates
                var q = queue(calculated_points, index, i, yrangePos);
                q.properties = {
                    "type": "scatter",
                    "dataLabels": dataLabels,
                    "color": rp.color,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "multiColoring": multiColoring,
                    "rp": rp,
                    "rangeChart": isRangeChart,
                    "yrangePos": yrangePos,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
            });
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    
    return labels;
};;
dataLabel_handler.svg = {};
dataLabel_handler.svg.initialize = function(chartObj) {
    var computed_properties = [],
        area_range_properties = [],
        stackLabel_properties = [],
        innerLabel_properties = [];
    var container = chartObj.staticPaneSVG.select(".labelholder"),
        isStackedLabels = false,
        isPackedBubble = chartObj.chartTypes[0].value == $ZC.charttype.packedbubble,
        isHierarchy = chartObj.chartTypes[0].value == $ZC.charttype.treemap;
        // isPackedBubble = getChartType((chartObj.seriesdata[0].type || chartObj.systemConf.seriesdata.type), NUMERIC_DATATYPE) == $ZC.charttype.packedbubble;

    return function() {
        var handlers = {};
        handlers.add = function(c, series, subSeries, yrangePos, stackLabel, innerLabel) {
            if (stackLabel) {
                isStackedLabels = true;
            }
            var queue = stackLabel ? stackLabel_properties : (innerLabel ? innerLabel_properties : (yrangePos ? area_range_properties : computed_properties));
            queue[series] = queue[series] || [];
            queue[series][subSeries] = queue[series][subSeries] || [];
            queue[series][subSeries].push.apply(queue[series][subSeries], c);
            queue[series][subSeries].dataUpdate = c.dataUpdate; //Each subseries may have different dataUpdates
            return queue[series];
        };
        
        handlers.update = function(id, x, y, display, DY, hookPosition) {
            var index = id.match(/\d+/g),
                seriesIndex = index[0],
                subSeriesIndex = index[1],
                itemIndex = index[2],
                yRangePos = +index[3] || 0;
            var queue = isStackedLabels ? stackLabel_properties : yRangePos ? area_range_properties : computed_properties;
            var d = queue[seriesIndex][subSeriesIndex][itemIndex];
            d.X += x;
            d.Y += y;
            d.display = d.display && !display;
            if (DY !== undefined) {
                d.DY = DY;
            }
            if (hookPosition) {
                d.hookPosition = hookPosition;
            }
        };
        
        handlers.getQueue = function(series, yRangePos, stackLabel, innerLabel) {
            var queue = stackLabel ? stackLabel_properties : (innerLabel ? innerLabel_properties : (yRangePos ? area_range_properties : computed_properties));
            return queue[series];
        };
        
        handlers.draw = function() {
            if (chartObj.isAxisCategory) {
                var groupedByStack = chartObj.dataObject.groupedByStack;
                var keys = chartObj.userdata.seriesdata.stackGroup || groupedByStack.keys();
                keys.forEach(function(d, i) {
                    if (isStackedLabels && groupedByStack.has(i)) {
                        var group = groupedByStack.get(i);
                        drawLabel(stackLabel_properties[group.stackLabelIndex], 1, i, "stacklabel");
                    } else {
                        appendEle(container, "g", [], ".", "class", "stacklabel_" + i);
                    }
                });

                /*
                 * bar19.json - Remove the stack labels if all the bar series are disabled at legend filter
                 */
                if (!keys.length) {
                    appendEle(container, "g", [], "#", "id", "stacklabels");
                }
            }
            
            chartObj.seriesdata.forEach(function(s, i) {
                var data = computed_properties[i];
                
                drawLabel(data, s, i);
                if (defined(area_range_properties[i])) {
                    drawLabel(area_range_properties[i], s, i)
                }
                
                if (!(chartObj.isAxisCategory && !chartObj.dataObject.pieWithAxis) && !chartObj.dataObject.isPolarAxisCategory && !chartObj.dataObject.hasLevelMarker && !isPackedBubble && !isHierarchy) {
                    if (!chartObj.dataObject.pieWithAxis) {
                        drawConnector(data, s, i);
                    }
                    drawLabel(innerLabel_properties[i], s, i, "innerlabel");
                }
                
            });
            // chartObj.labelHandler = null;
        };
        return handlers;
    }();
    
    function drawLabel(series, seriesData, i, groupName) {
        groupName = groupName || "label";
        var isStackedLabels = (groupName === "stacklabel"),
            isInnerLabel = (groupName === "innerlabel");
        
        var labelseries = appendEle(container, "g", (series ? [1] : []), ".", "class", (groupName + "_" + i));
        if (!series) {
            return;
        }
        
        var properties = series.properties;
        var globalDataUpdate = properties.dataUpdate,
            dataLabels = properties.dataLabels,
            rp = properties.rp,
            rotation = properties.rotation,
            isRangeChart = properties.rangeChart,
            yrangePos = properties.yrangePos,
            reverseColor = properties.reverseColor,
            isPolar = chartObj.dataObject.isPolarAxisCategory,
            isAxisCategory = chartObj.isAxisCategory,
            clip = (dataLabels.textOverlap === "clip"),
            contentType = properties.contentType || "text",
            isMultiLine = properties.isMultiLine,
            fontSize = getFontSizeByHierarchy(dataLabels, chartObj),
            clipseries;
        var data_length = (isAxisCategory || isPolar) ? null : globalDataUpdate.length,
            isScatterType = (properties.type === "scatter"),
            hasColorScale = colorscale_helpers.isQuantileColorScale(chartObj);
        
        var dataLevelFontColor = null;
        if (hasColorScale || rp.threshold || !((isAxisCategory || isPolar || chartObj.dataObject.isNonAxisMultiSeriesCategory) && !properties.multiColoring)) {
            dataLevelFontColor = function(d, k) {
                var clrIndex = reverseColor ? (data_length - 1 - k) : ((isAxisCategory || isPolar || chartObj.dataObject.isNonAxisMultiSeriesCategory) && !properties.multiColoring) ? i : k;
                var clr = getRawColor(chartObj, clrIndex, ((d && d.data) ? d.data : d), i);
                return getLabelFontColor(chartObj.systemConf, clr, dataLabels, chartObj, isInnerLabel, i);
            }
        }
        
        if (clip) {
            var defs = ($Browser.SAFARI ? chartObj.svg : $ZCG.patternSVG).selectAll("defs");
            clipseries = appendEle(defs, "g", [1], ".", "class", "textClipPaths");
        }
        
        if (isRangeChart) {
            labelseries = appendEle(labelseries, "g", [1], ".", "class", ('rangePos_' + yrangePos));
        }
        
        if (isStackedLabels) {
            labelseries
                .attr("id", "stacklabels");
        }
        
        labelseries
            .attr({
                "text-anchor": (isScatterType ? "middle" : null),
                "transform": properties.translation
            });
        applyDatalabelFonts(labelseries, dataLabels, chartObj, rp.color, isInnerLabel, i, isStackedLabels); //change rp.color
        
        if (isPolar) {
            labelseries
                .attr("transform", "translate(" + chartObj.plotarea_approx.x + "," + chartObj.plotarea_approx.y + ")")
        }
        
        series.forEach(function(subSeries, j) {
            var dataUpdate = subSeries.dataUpdate || globalDataUpdate; //Each subseries may have different dataUpdates (Axis charts)
            var subseries = appendEle(labelseries, "g", [1], ".", "class", ("subseries_" + j));
            var labelText = appendEle(subseries, "text", dataUpdate);
            labelText[contentType](function(d, k) {
                return subSeries[k].text;
            });
            if (isMultiLine) {
                labelText
                    .each(function(d, k) {
                        translateTspan(d3.select(this), subSeries[k].X);
                    });
            }

            labelText
                .style({
                    "display": function(d, k) {
                        return (subSeries[k].display === false) ? "none" : null;
                    },
                    "fill": dataLevelFontColor,
                    "pointer-events": "none"
                })
                .attr({
                    "x": function(d, k) {
                        return subSeries[k].X;
                    },
                    "y": function(d, k) {
                        return subSeries[k].Y;
                    },
                    "dy": function(d, k) {
                        return subSeries[k].DY;
                    },
                    "text-anchor": function(d, k) {
                        return subSeries[k].ANCHOR;
                    },
                    "id": function(d, k) {
                        return subSeries[k].ID;
                    },
                    "transform": !defined(rotation) ? null : function(d, k) {
                            return "rotate(" + rotation + " " + subSeries[k].X + " " + subSeries[k].Y + ")"
                        },
                    "clip-path": !clip ? null : function(d, k) {
                            var bb = bbox(this);
                            var properties = {
                                name: "textClip",
                                id: chartObj.id,
                                x: bb.x,
                                y: bb.y,
                                width: subSeries[k].width,
                                height: bb.height
                            },
                            args = {
                                chartObj: chartObj
                            };
                            var clipID = effects.get(svg_clips, "rect", properties, args);
                            return "url(" + chartObj.defsLocation + "#" + clipID + ")";
                        }
                });
            
            if (!isAxisCategory && !isHierarchy && !isPolar && !chartObj.dataObject.hasLevelMarker && !isPackedBubble && !isStackedLabels && !isInnerLabel) {
                if (contentType === "html") {
                    var boundBoxPadding = isBoundBoxEnabled(dataLabels, chartObj) ? (getBoundBoxPadding(dataLabels, chartObj) + getBoundBoxStrokeWidth(dataLabels, chartObj)) : 0;

                    labelText
                        .each(function(d, k) {
                            if (subSeries[k].display !== false) {
                                var ele = d3.select(this);
                                var tspanInfo = getTspanBound(ele, fontSize);
                                trimAllTspan(ele, chartObj, properties.trans, properties.txtHgt, null, tspanInfo, (subSeries[k].isLeft ? boundBoxPadding : 0));

                                if (subSeries[k].ANCHOR === "middle") {
                                    var TX = (subSeries[k].width - bbox(this).width) / 2;
                                    var flip = subSeries[k].isLeft ? 1 : -1;
                                    var newX = subSeries[k].X + (TX * flip);

                                    ele.attr("x", newX);
                                    translateTspan(ele, newX);
                                }
                            }
                        });
                } else {
                    callTrimText(labelText, chartObj, properties.trans, properties.txtHgt);
                }
            }
        });
    }
    
    function drawConnector(series, seriesData, i) {
        
        var linkseries = appendEle(container, "g", (!series || series.properties.showlabel === "circular" ? [] : [1]), ".", "class", ("link_" + i));
        if (!series) {
            return;
        }
        
        var properties = series.properties,
            dataUpdate = properties.dataUpdate,
            rp = properties.rp,
            isSunburst = properties.isSunburst,
            connectorPath = properties.connectorPath;
        var lineConf = properties.dataLabels.line,
            color = rp.color,
            data_length = dataUpdate.length;
        
        linkseries
            .attr("transform", properties.translation)
            .style({
                "stroke": lineConf.strokeColor,
                "stroke-width": lineConf.strokeWidth,
                "fill": "none"
            });
        
        series.forEach(function(subSeries, j) {
            var subseries = appendEle(linkseries, "g", [1], ".", "class", ("subseries_" + j));
            var labelText = appendEle(subseries, "path", dataUpdate);
            labelText
                .style({
                    "display": function(d, k) {
                        return (subSeries[k].display === false) ? "none" : null;
                    },
                    "stroke": function(d, k) {
                        if (isSunburst || lineConf.strokeColor) {
                            return null;
                        }
                        return getRawColor(chartObj, (properties.reverseColor ? (data_length - 1 - k) : k), ((d && d.data) ? d.data : d), i);
                    }
                })
                .attr({
                    "d": connectorPath,
                    "id": function(d, k) {
                        return "link" + i + "_" + j + "_" + k;
                    }
                });
        });
    }
};//$Id$
datalabelsBoundBox_handler.svg = function() {
    var series,
        properties,
        chartObj;
    
    function shape(selection, index, innerLabels) {
        selection.each(function() {
            
            if (series) {
                properties = series.properties;
                chartObj = properties.rp.chartObj;
            }
            var showBoundBox = series && isBoundBoxEnabled(properties.dataLabels, chartObj);
            
            var container = d3_select(this);
            var boundboxSeries = appendEle(container, "g", [1], ".", "class", ((innerLabels ? "innerboundboxseries_" : "boundboxseries_") + index));
            if (properties && properties.rangeChart) {
                boundboxSeries = appendEle(boundboxSeries, "g", [1], ".", "class", ('rangePos_' + properties.yrangePos));
            }
            var boundboxSubSeries = appendEle(boundboxSeries, "g", (showBoundBox ? series : []));
            
            if (!showBoundBox) {
                return;
            }
            
            var seriesTranslation = chartObj.dataObject.isPolarAxisCategory ?
                "translate(" + chartObj.plotarea_approx.x + "," + chartObj.plotarea_approx.y + ")" :
                (!chartObj.isAxisCategory ?
                    properties.translation :
                    null);
            boundboxSeries
                .attr("transform", seriesTranslation);
            
            var boundboxOptions = getMergedBoundBoxOptions(properties.dataLabels, chartObj);
            var hookOptions = getBoundBoxHookConf(boundboxOptions.hook);
            var globalDataUpdate = properties.dataUpdate,
                rotation = properties.rotation || 0,
                padding = getBoundBoxPadding(properties.dataLabels, chartObj),
                r = chartObj.dataObject.getTransRectValue("radius", null, null, null, null, boundboxOptions.radius),
                strokeColor = getBoundBoxColor(boundboxOptions.strokeColor, properties, chartObj, globalDataUpdate, index),
                fillColor = getBoundBoxColor(boundboxOptions.fillColor, properties, chartObj, globalDataUpdate, index),
                strokeWidth = defined(boundboxOptions.strokeWidth) ? +boundboxOptions.strokeWidth : 1,
                strokeDashArray = getDashArray(boundboxOptions.dashStyle, strokeWidth),
                strokeLineCap = getLineCap(boundboxOptions.lineCap, boundboxOptions.dashStyle),
                heightAdjustScale = d3_scaleLinear(),
                plotarea = chartObj.plotarea;
            
            var trans = properties.trans || [0, 0];
            var edge = {
                "left": -trans[0] + plotarea.left,
                "right": plotarea.width - trans[0] - plotarea.left
            };
            
            boundboxSubSeries
                .attr("class", function(d, i) {
                    return "subseries_" + i;
                })
                .each(function(d, i) {
                    var dataUpdate = d.dataUpdate || globalDataUpdate;
                    var boundbox = appendEle(d3.select(this), "path", dataUpdate);
                    boundbox
                        .attr({
                            "d": function(dt, j) {
                                var point = d[j];
                                var x = point.X - padding,
                                    y = point.Y - padding,
                                    w = point.width,
                                    h = point.height,
                                    dy = (point.actualDY !== undefined) ? point.actualDY : parseFloat(point.DY) || 0,
                                    anchor = point.ANCHOR,
                                    hookPosition = point.hookPosition;
                                x = (anchor === "middle") ?
                                    (x - (w / 2)) :
                                    ((anchor === "end") ? (x - w) : x);
                                y = y - heightAdjustScale.domain([-0.3, 0.9]).range([h, 0])(dy);
                                
                                if (!chartObj.isAxisCategory && !chartObj.dataObject.isPolarAxisCategory) {
                                    if (x < edge.left) {
                                        w -= (edge.left - x + (strokeWidth / 2) + padding);
                                        x = edge.left + (strokeWidth / 2);
                                    }
                                    if ((x + w + (strokeWidth / 2) + padding) > edge.right) {
                                        w -= (x + w - edge.right + (strokeWidth / 2) + (padding * 2));
                                    // if ((x + w) > edge.right) {
                                    //     w -= (x + w + padding - edge.right);
                                    }
                                    x += (boundboxOptions.strokeWidth || 1) * ((hookPosition === "right") ? 0.5 : (hookPosition === "left") ? -0.5 : 0);
                                }
                                return getBoundBoxPathDescription(x, y, w, h, r, padding, hookPosition, hookOptions, point.adjustVal);
                            },
                            "transform": function(dt, j) {
                                var point = d[j];
                                return "rotate(" + rotation + " " + point.X + " " + point.Y + ")";
                            },
                            "id": function(dt, j) {
                                return "boundbox" + d[j].ID;
                            }
                        })
                        .style({
                            "display": function(dt, j) {
                                return (d[j].display === false) ? "none" : null;
                            },
                            "fill": fillColor,
                            "fill-opacity": boundboxOptions.fillOpacity,
                            "stroke": strokeColor,
                            "stroke-opacity": boundboxOptions.strokeOpacity,
                            "stroke-width": boundboxOptions.strokeWidth,
                            "stroke-dasharray": strokeDashArray,
                            "stroke-linecap": strokeLineCap
                        });
                });
        });
    }
    
    shape.args = function(_) {
        if (!arguments.length) {
            return series;
        }
        series = _;
        return shape;
    };
    
    return shape;
};//$Id$
$ZC.labelRenderer.pieInnerLabels = function() {
    var renderer, args,
        chartObj,
        dataset;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                pieData = args[2],
                totalEngagement = args[4],
                translation = args[8] ? "translate(" + args[8][0] + "," + args[8][1] + ")" : null,
                arc = args[7],
                rp = renderer.commonRendererProp().params;

            dataset = rp.dataset;
            chartObj = rp.chartObj;
            var commonPlotOptions = rp.commonPlotOptions,
                index = args[1] || 0,
                isSunburst = !pieData,
                outline = args[6],
                yaxiscolumnorder = rp.yaxiscolumnorder;
            
            currentdata = currentdata[index];
            var isBubblePie = chartObj.dataObject.pieWithAxis;
            
            var plotoptions = currentdata.plotoptions;
            var dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var innerLabels = dataLabels.innerLabel;
            
            var GLT = function(conf) {
                    return dataLabelTextContent(chartObj, rp, conf, "innerLabel", totalEngagement, index);
                },
                globalGLT = dataLabelTextContent(chartObj, rp, innerLabels, "innerLabel", totalEngagement, index),
                contentType = globalGLT.contentType || "text",
                isMultiLine = (contentType === "html") && globalGLT.multiLine,
                textOverlap = innerLabels.textOverlap || "adjust",
                showInnerLabel = innerLabels.show === true,
                showParentInnerLabel = isSunburst && ((innerLabels.parentLabel.show || showInnerLabel) != false),
                boundBoxPadding = isBoundBoxEnabled(innerLabels, chartObj) ? (getBoundBoxPadding(innerLabels, chartObj) + getBoundBoxStrokeWidth(innerLabels, chartObj)) : 0;
            showInnerLabel = showInnerLabel && datacount_based_intelligence(chartObj, "datalabels");
            var parentInnerLabel;
            if (showParentInnerLabel) {
                parentInnerLabel = mergeJSON(innerLabels.parentLabel, innerLabels);
            }
            
            if (currentdata.disabled || !(showInnerLabel || showParentInnerLabel)) {
                return;
            }
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            applyDatalabelFonts(temp_label, innerLabels, chartObj, rp.color);
            temp_label
                .attr("transform", translation)
                .style("fill", "transparent");
            var queue = labelHandler.add;
            
            (isSunburst ? currentdata : currentdata.data).forEach(function(d, i) {
                var dataUpdate = (isBubblePie) ? d : (pieData || getDataPlusParent(d)),
                    commonProperties = [];
                
                dataUpdate.forEach(function(d, j) {
                    
                    var bb = null;
                    var display = !isdisabled(d),
                        ANCHOR = "middle",
                        DY = isMultiLine ? "0.9em" : "0.35em",
                        X,
                        Y,
                        xVal = 0,
                        yVal = 0;
                    if (isBubblePie) {
                        var stacked = rp.stacked,
                            axisrotated = rp.axisrotated,
                            xscale = rp.xscale,
                            yscale = rp.yscale;
                        var X = dataset.getX(d);
                        var pieRenderer = chartObj.subrenderer[i][X];
                        d = pieRenderer.data[index];
                        arc = pieRenderer.arc;
                        
                        xVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d.data, "x", null);
                        yVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d.data, "y", null);
                        var zVal = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d.data, "z", chartObj.zscale);
                        
                        var outerRadius = (zVal / 4);
                        var polarXY = polarToXY(outerRadius, midAngle(d));
                        GLT = function(conf) {
                            return dataLabelTextContent(chartObj, rp, conf, "innerLabel", pieRenderer.total, index);
                        };
                        
                        
                        X = xVal + polarXY[0];
                        Y = yVal + polarXY[1];
                    } else {
                        X = arc.centroid(d)[0];
                        Y = arc.centroid(d)[1];
                    }
                    
                    
                    var dt = isSunburst ? d : d.data;
                    var toNull = isSunburst ? (d.depth == 0) : isdisabled(d);
                    var text = toNull ? null : GLT((showParentInnerLabel && d.children) ? parentInnerLabel : innerLabels)(dt);
                    
                    temp_label[contentType](text)
                        .attr({
                            "x": X,
                            "y": Y,
                            "dy": DY,
                            "text-anchor": ANCHOR
                        });

                    if (display && isMultiLine) {
                        translateTspan(temp_label, X);
                        bb = bbox(temp_label.node());
                        Y -= bb.height / 2;
                    }
                    
                    if (textOverlap != "none") {
                        /*
                         * Default position for the inner label is arc.centroid(d)
                         * innerLabelWithinArc() finds the best position for the inner label
                         * If the inner label overflows in its centroid position but it could be placed inside the arc, it will be translated to its best position
                         * Else it will not be displayed
                         */
                        bb = bb || bbox(temp_label.node());
                        var centre = arc.centroid(d);
                        var wid = bb.width / 2 + boundBoxPadding,
                            hei = bb.height / 2 + boundBoxPadding;
                        var TL = {
                                x: (centre[0] - wid),
                                y: (centre[1] - hei)
                            },
                            TR = {
                                x: (centre[0] + wid),
                                y: (centre[1] - hei)
                            },
                            BL = {
                                x: (centre[0] - wid),
                                y: (centre[1] + hei)
                            },
                            BR = {
                                x: (centre[0] + wid),
                                y: (centre[1] + hei)
                            };
                        var isPointInArc = pointIsInArc(TL, d) &&
                            pointIsInArc(TR, d) &&
                            pointIsInArc(BL, d) &&
                            pointIsInArc(BR, d);
                        if (!isPointInArc) {
                            if (textOverlap === "adjust") {
                                var SA = isSunburst ? outline.startAngle()(d) : d.startAngle,
                                    EA = isSunburst ? outline.endAngle()(d) : d.endAngle,
                                    MA = midAngle(d),
                                    extra = bb.height + (2 * boundBoxPadding), // / Math.cos(MA), //Need to check again
                                    s, e;
                                
                                var a1 = xyToAngle(TL),
                                    a2 = xyToAngle(TR),
                                    a3 = xyToAngle(BL),
                                    a4 = xyToAngle(BR);
                                var angleArray = [a1, a2, a3, a4],
                                    posArray = [TL, TR, BL, BR];
                                var minmax = d3_extent(angleArray);
                                
                                var s = posArray[angleArray.indexOf(minmax[0])],
                                    e = posArray[angleArray.indexOf(minmax[1])];
                                
                                var dist = mathSQRT(((s.x - e.x) * (s.x - e.x)) + ((s.y - e.y) * (s.y - e.y)));
                                var r = mathAbs((dist / 2) / mathTan((EA - SA) / 2)) + extra;
                                var newCentre = [(mathSin(MA) * r), -(mathCos(MA) * r)];
                                
                                var TL = {
                                        x: (newCentre[0] - wid),
                                        y: (newCentre[1] - hei)
                                    },
                                    TR = {
                                        x: (newCentre[0] + wid),
                                        y: (newCentre[1] - hei)
                                    },
                                    BL = {
                                        x: (newCentre[0] - wid),
                                        y: (newCentre[1] + hei)
                                    },
                                    BR = {
                                        x: (newCentre[0] + wid),
                                        y: (newCentre[1] + hei)
                                    };
                                isPointInArc = pointIsInArc(TL, d) &&
                                    pointIsInArc(TR, d) &&
                                    pointIsInArc(BL, d) &&
                                    pointIsInArc(BR, d);
                            }
                            
                            if (isPointInArc) {
                                X = newCentre[0] + xVal;
                                Y = newCentre[1] + yVal;
                            } else {
                                display = false;
                            }
                        }
                    } else {
                        bb = bbox(temp_label.node());
                    }
                    
                    
                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "DY": DY,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "ID": "innerlbl" + index + "_" + i + "_" + j,
                        "width": bb.width,
                        "height": bb.height
                    };
                    commonProperties.push(coordinate);
                });
                
                // add to drawing queue
                var q = queue(commonProperties, index, i, null, null, true);
                q.properties = {
                    "type": "pie",
                    "dataLabels": innerLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": showInnerLabel,
                    "rp": rp,
                    "translation": translation,
                    "trans": args[8],
                    "isSunburst": isSunburst,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
                
            });
            
            function getDataPlusParent(d) {
                var dPlusParent = showInnerLabel ? d.slice(0) : [];
                if (showParentInnerLabel && d[0]) {
                    dPlusParent.push(d[0].parent);
                }
                return dPlusParent;
            }
            
            function pointIsInArc(pt, ptData) {
                var r1 = arc.innerRadius()(ptData),
                    r2 = arc.outerRadius()(ptData),
                    theta1 = arc.startAngle()(ptData),
                    theta2 = arc.endAngle()(ptData),
                    dist = pt.x * pt.x + pt.y * pt.y,
                    angle = xyToAngle(pt);
                return (r1 * r1 <= dist) && (dist <= r2 * r2) && isAngleInside(theta1, theta2, angle);
            }
            
            function xyToAngle(obj) {
                return mathAtan2(obj.x, -obj.y);
            }
            
            function isdisabled(d) {
                var isWithinClrRange = isWithinColorRange(dataset.getClr(isSunburst ? d : d.data || d), chartObj);
                return !isWithinClrRange || (isSunburst ?
                    (d.parent == null || d.value == 0) :
                    (d.value == 0));
            }
            
            function midAngle(d) {
                var start = isSunburst ? outline.startAngle()(d) : d.startAngle,
                    end = isSunburst ? outline.endAngle()(d) : d.endAngle;
                return (start + end) / 2;
            }
            
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    return labels;
};//$Id$
$ZC.labelRenderer.funnelInnerLabels = function() {
    var renderer, args;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                data = args[2],
                arcHeight = args[4],
                totalEngagement = args[5],
                cfg = args[6],
                labelPosition = args[7];
            var chartWidth = cfg.width,
                rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                chartName = chartObj.chartTypes[0].name;
            var translation = chartObj.svg.selectAll("g." + chartName + "group").attr("transform"),
                isPyramid = (chartName === "pyramid");
            
            currentdata = currentdata[index];
            var plotoptions = currentdata.plotoptions;
            var dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var innerLabels = dataLabels.innerLabel,
                padding = cfg.datalabelPadding || (+dataLabels.padding || 0),
                PathGroupPosition = d3_transform(translation).translate,
                data_length = data.length;
            
            var showInnerLabel = innerLabels.show === true,
                txtHgt = getFontSizeByHierarchy(innerLabels, chartObj),
                GLT = dataLabelTextContent(chartObj, rp, innerLabels, "innerLabel", totalEngagement, index),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine,
                boundBoxPadding = isBoundBoxEnabled(dataLabels, chartObj) ? (getBoundBoxPadding(dataLabels, chartObj) + getBoundBoxStrokeWidth(dataLabels, chartObj)) : 0;
            showInnerLabel = showInnerLabel && datacount_based_intelligence(chartObj, "datalabels");
            txtHgt = txtHgt + (2 * boundBoxPadding);
            
            if (currentdata.disabled || !showInnerLabel) {
                return;
            }
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            applyDatalabelFonts(temp_label, innerLabels, chartObj, rp.color);
            temp_label
                .attr("transform", translation)
                .style("fill", "transparent");
            var queue = labelHandler.add;
            
            currentdata.data.forEach(function(d, i) {
                var dataUpdate = labelPosition,
                    commonProperties = [];
                
                dataUpdate.forEach(function(d, j) {
                    var display = !isdisabled(j),
                        X = (isPyramid) ?
                            d.midX :
                            (chartWidth / 2),
                        Y = (isPyramid) ?
                            d.leftY :
                            d.y,
                        ANCHOR = "middle",
                        DY = isMultiLine ? "0.9em" : "0.5em",
                        text = GLT(data[data_length - 1 - j]),
                        bb = null;
                    
                    temp_label[contentType](text)
                        .attr({
                            "x": X,
                            "y": Y,
                            "dy": DY,
                            "text-anchor": ANCHOR
                        });

                    if (display && isMultiLine) {
                        translateTspan(temp_label, X);
                        bb = bbox(temp_label.node());
                        Y -= bb.height / 2;
                        txtHgt = bb.height;
                    }

                    if (display) {
                        bb = bb || bbox(temp_label.node());
                        if (isPyramid) {
                            display = !(txtHgt > ((d.y0 - d.leftY) * 2));
                        } else {
                            var ellipseArcHeight = cfg.canOverlap ? (((d.rightx - d.leftx - (2 * padding)) / chartWidth) * arcHeight) : arcHeight;
                            display = !((txtHgt < (d.y - (d.y0 - d.y) + ellipseArcHeight)) && (txtHgt > ((d.y0 + ellipseArcHeight) - (d.y - (d.y0 - d.y) + ellipseArcHeight))));
                        }
                    }
                    
                    var coordinate = {
                        "X": X,
                        "Y": Y,
                        "DY": DY,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "ID": "innerlbl" + index + "_" + i + "_" + j,
                        "width": display ? bb.width : 0,
                        "height": display ? bb.height : 0
                    };
                    commonProperties.push(coordinate);
                });
                
                // add to drawing queue
                var q = queue(commonProperties, index, i, null, null, true);
                q.properties = {
                    "type": "pie",
                    "dataLabels": innerLabels,
                    "dataUpdate": dataUpdate,
                    "showlabel": showInnerLabel,
                    "rp": rp,
                    "translation": translation,
                    "trans": PathGroupPosition,
                    "reverseColor": true,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
                
            });
            
            function isdisabled(i) {
                var dt = data[data_length - 1 - i];
                var isWithinClrRange = isWithinColorRange(dataset.getClr(dt), chartObj);
                return dt.disabled || !dataset.getY(dt, yaxiscolumnorder) || !isWithinClrRange;
            }
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    return labels;
};//$Id$
function getBoundBoxColor(actualColor, properties, chartObj, data, index) {
    var data_length = data.length;
    return actualColor || function(d, k) {
            var clrIndex = properties.reverseColor ? (data_length - 1 - k) : ((chartObj.isAxisCategory || chartObj.isNonAxisMultiSeriesCategory || chartObj.dataObject.isPolarAxisCategory) && !properties.multiColoring) ? index : k;
            return getRawColor(chartObj, clrIndex, ((d && d.data) ? d.data : d), index);
        };
}

function getMergedBoundBoxOptions(dataLabels, chartObj) {
    return mergeJSON(chartObj.systemConf.chart.plot.datalabels.boundBox, dataLabels.boundBox, true);
}

function isBoundBoxEnabled(dataLabels, chartObj) {
    return getValByPriority([dataLabels.boundBox || {}, chartObj.systemConf.chart.plot.datalabels.boundBox || {}], "show") === true;
}

function getBoundBoxPadding(dataLabels, chartObj) {
    return validateNullVal(getValByPriority([dataLabels.boundBox || {}, chartObj.systemConf.chart.plot.datalabels.boundBox || {}], "padding"), 2);
}

function getBoundBoxStrokeWidth(dataLabels, chartObj) {
    return validateNullVal(getValByPriority([dataLabels.boundBox || {}, chartObj.systemConf.chart.plot.datalabels.boundBox || {}], "strokeWidth"), 1);
}

function getSizeToBeAdded(defaultWidth, padding, radius, hookWidth) {
    var datalabels_min_width = (2 * (radius || 0)) + hookWidth;
    return mathMax((datalabels_min_width - defaultWidth - (2 * padding)), 0);
}

/*
 * Returns the options for boundbox hook
 * @param {Object} hookOptions
 * @return {Object} obj which contains enabled, width, height
 */
function getBoundBoxHookConf(hookOptions) {
    hookOptions = hookOptions || {};
    var hookEnabled = hookOptions.enabled === true;
    var obj = {};
    
    obj.enabled = hookEnabled;
    obj.width = hookEnabled ?
        (defined(hookOptions.width) ? +hookOptions.width : 10) :
        0;
    obj.height = hookEnabled ?
        (defined(hookOptions.height) ? +hookOptions.height : 4) :
        0;
    return obj;
}

/*
 * Returns the SVG path description for bound box
 * @param {Number} x
 * @param {Number} y
 * @param {Number} w
 * @param {Number} h
 * @param {Number} r
 * @param {Number} padding
 * @param {Number} hookPosition
 * @param {Object} hookOptions
 * @return {String} SVG path
 */
function getBoundBoxPathDescription(x, y, w, h, r, padding, hookPosition, hookOptions, adjustVal) {
    var hookEnabled = hookOptions.enabled,
        hookWidth = hookOptions.width,
        hookHeight = hookOptions.height;
    
    var path = roundedRect(x, y, w + (2 * padding), h + (2 * padding), r);
    if (hookEnabled && hookPosition) {
        var positionIndex = (hookPosition === "bottom") ? 7 :
            ((hookPosition === "top") ? 3 :
                ((hookPosition === "right") ?
                    5 : 1));
        var parsedPath = parseSVGPath(path);
        var coordinates = getHookCoordinate(hookPosition, parsedPath, positionIndex);
        addPointToSVGPathPoints(parsedPath, positionIndex, coordinates);
        
        path = createSVGPathFromPoints(parsedPath);
    }
    
    function getHookCoordinate(mode, parsedPath, positionIndex) {
        var horizontalx1 = parsedPath[positionIndex - 1].moves[(positionIndex - 1) ? 5 : 0],
            horizontalx2 = parsedPath[positionIndex].moves[0],
            verticaly1 = parsedPath[positionIndex - 1].moves[(positionIndex - 1) ? 6 : 1],
            verticaly2 = parsedPath[positionIndex].moves[1];
        var horizontalMid = (horizontalx1 + horizontalx2) / 2,
            verticalMid = (verticaly1 + verticaly2) / 2
        y = parsedPath[positionIndex].moves[1],
            x = parsedPath[positionIndex].moves[0];
        
        if (defined(adjustVal) && adjustVal) {
            var flip = (adjustVal > 0) ? 1 : -1,
                dist = (mode === "bottom") ?
                    (horizontalx1 - horizontalx2) :
                    (horizontalx2 - horizontalx1),
                adj;
            
            if ((((dist - hookWidth) / 2) - (adjustVal * flip)) > 0) {
                adj = adjustVal;
            } else {
                adj = (dist - hookWidth) / 2 * flip;
            }
            horizontalMid -= adj;
        }
        
        switch (mode) {
            case "bottom":
                return [
                    [(horizontalMid - (hookWidth / 2)), y],
                    [horizontalMid, (y + hookHeight)],
                    [(horizontalMid + (hookWidth / 2)), y]
                ];
            case "top":
                return [
                    [(horizontalMid + (hookWidth / 2)), y],
                    [horizontalMid, (y - hookHeight)],
                    [(horizontalMid - (hookWidth / 2)), y]
                ];
            case "left":
                return [
                    [x, (verticalMid - (hookWidth / 2))],
                    [(x - hookHeight), verticalMid],
                    [x, (verticalMid + (hookWidth / 2))]
                ];
            case "right":
                return [
                    [x, (verticalMid + (hookWidth / 2))],
                    [(x + hookHeight), verticalMid],
                    [x, (verticalMid - (hookWidth / 2))]
                ];
        }
    }
    
    return path;
}

/*
 * Generate and return SVG path from the given array of points
 * @param {Array of points} points
 * Each point should be,
 * {
 *      "function" : OPERATOR, (e.g) : "M" | "L" | "A" etc
 *      "moves" : [point1, point2, ...pointN]
 * }
 * @return {String} SVG path
 */
function createSVGPathFromPoints(points) {
    return points.reduce(function(prev, cur) {
        return prev + cur.function.toUpperCase() + ((cur.moves && cur.moves.join(" ")) || "");
    }, "");
}

/*
 * Add all the LineTo coordinates at the given index
 * @param {Array} array
 * @param {Number} index
 * @param {Array} coordinate [[x1, y1], [x2, y2], ...[xN, yN]]
 */
function addPointToSVGPathPoints(array, index, coordinates) {
    coordinates.forEach(function(d) {
        array.splice(index, 0, {
            "function": "l",
            "moves": d
        });
    });
}//$Id$
function getFontSizeByHierarchy(conf, chartObj) {
    var systemconf = chartObj.systemConf;
    return +($ZC.utils.getVal(getValByPriority([conf, systemconf.chart.plot.datalabels, systemconf.chart, systemconf.canvas], "fontSize")));
}

function getFontFamilyByHierarchy(config, chartInstance) {
    var systemConf = chartInstance.systemConf;
    return $ZC.utils.getVal(getValByPriority([config, systemConf.chart, systemConf.canvas, $ZCG], "fontFamily"));
}

function getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index) {
    var options = (plotoptions && plotoptions.datalabels) ?
        mergeJSON(commonPlotOptions.datalabels, plotoptions.datalabels, true) :
        commonPlotOptions.datalabels;

    if (chartObj) {
        overrideDatalabelShowAs(options, chartObj, index);
    }

    return options;
}

function applyDatalabelFonts(labelseries, dataLabels, chartObj, seriesColor, inner, seriesIndex, isStackLabel) {
    var systemconf = chartObj.systemConf;

    if(isArray(seriesColor) && defined(seriesIndex)) {
        seriesColor = seriesColor[seriesIndex];
    }

    return applyFont(labelseries, [{
        fontColor: getLabelFontColor(systemconf, seriesColor, dataLabels, chartObj, inner, seriesIndex, isStackLabel)
    }, dataLabels, systemconf.chart.plot.datalabels, systemconf.chart, systemconf.canvas, $ZCG]);
}

function getLabelFontColor(systemconf, seriesColor, datalabelOptions, chartObj, inner, seriesIndex, isStackLabel) {
    
    /**
     * @param inner is boolean, means function being call from inner-label
     */
    
    var fontColor = datalabelOptions.fontColor;
    if (typeof fontColor === "function") {
        var userColor = invokeFunction(fontColor, seriesColor, chartObj);
        if (defined(userColor)) {
            return userColor;
        }
    }

    var globalDatalabelOptions = getPropVal(chartObj.systemConf, "chart.plot.datalabels") || {},
        dataLabelColor = globalDatalabelOptions.fontColor,
        chart = chartObj.chartTypes[seriesIndex || 0],
        chartName = chart.name,
        chartNumber = chart.value,
        imagePalletUsed = defined(systemconf.legend.imagePallete),
        stacked = chartObj.dataObject.isstacked(chartNumber),
        color,
        isStackedBar = isBarChartType(chartNumber) && stacked && isStackLabel !== true,
        isHeatmap = isHeatMapChartType(chartNumber);


    // for constant color
    if (fontColor === UNDEFINED && dataLabelColor === UNDEFINED) {
        if (inner && imagePalletUsed) {
            return "#444444"; // always returns default color
        } else if ((inner && /(pie|funnel|sunburst|pyramid|packedbubble)/ig.test(chartName)) || isStackedBar || isHeatmap) {
            return getContrastColor(seriesColor);
        }
    }
    
    color = (!imagePalletUsed && ((!defined(fontColor) && dataLabelColor === null) || (fontColor === null))) ? seriesColor : fontColor;
    return color || pick(globalDatalabelOptions.fontColor, systemconf.chart.fontColor, systemconf.canvas.fontColor, $ZCG.fontColor);
}

function doOverlap(rect1, rect2) {
    return !((rect1.x1 > rect2.x2) || (rect2.x1 > rect1.x2) || (rect1.y1 > rect2.y2) || (rect2.y1 > rect1.y2));
}

function isLabelWithinBound(labelbound, plotbound) {
    return !((labelbound.x1 < plotbound.x1) || (labelbound.y1 < plotbound.y1) || (labelbound.x2 > plotbound.x2) || (labelbound.y2 > plotbound.y2));
}

function getDataLabelsSize(type, serData, chartObj) {
    if (chartObj.dataObject.hasLevelMarker || !serData) {
        return 0;
    } // serData = undefined -> On legend filter, multi yaxes chart (numeric axis + ordinal axis)
    var fontSizeArray = [],
        systemconf = chartObj.systemConf,
        axisrotated = chartObj.dataObject.getAxisRotated(),
        dim = (axisrotated ? chartObj.plotarea.width : chartObj.plotarea.height) * 0.75,
        plotLevel = systemconf.chart.plot.datalabels,
        chartLevel = systemconf.chart,
        canvasLevel = systemconf.canvas;
    var dummyText = chartObj.staticPaneSVG.selectAll("g.labelholder").selectAll("text.dummyText").data([1]);
    dummyText.enter().append("text").attr("class", "dummyText").text("qtyplkjhgfd").style("fill", "none");
    serData.forEach(function(series, i) {
        var curSeriesdata = ((type == "x") ? series : chartObj.seriesdata[series.si]);
        if (!curSeriesdata.disabled) {
            var plotoptions = curSeriesdata.plotoptions,
                cType = chartObj.chartTypes[(type === "x" ? i : series.si)].value,
                commonPlotOptions = systemconf.chart.plot.plotoptions[$ZC.charttypenames.get(cType)];
            
            var dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions);
            
            var showlabel = isDatalabelEnabled(dataLabels, chartObj),
                padding = mathMin(+(dataLabels.padding || 0), dim);
            
            if (showlabel) {
                var fontSize = +($ZC.utils.getVal(getValByPriority([dataLabels, plotLevel, chartLevel, canvasLevel], "fontSize")));
                dummyText.style("font-size", fontSize + "px");
                fontSize = bbox(dummyText.node()).height;
                fontSize += ((type == "y") ? mathMax(0, padding) : 0) +
                    ((plotLevel.handleOverlapping && !axisrotated && type == "y") ? fontSize : 0);
                fontSizeArray.push(fontSize);
            }
        }
    });
    
    if ((type == "y") && chartObj.dataObject.noofBarEnabledSeries && chartObj.dataObject.isstacked() && !chartObj.dataObject.isStackedPercentChart) {
        var stackedLabels = systemconf.chart.plot.plotoptions.bar.datalabels.stackLabels;
        var showStackLabels = stackedLabels ? stackedLabels.show: false;
        
        
        if (showStackLabels) {
            var padding = mathMin(+(stackedLabels.padding || 0), dim);
            var fontSize = +($ZC.utils.getVal(getValByPriority([stackedLabels, plotLevel, chartLevel, canvasLevel], "fontSize")));
            dummyText.style("font-size", fontSize + "px");
            fontSize = bbox(dummyText.node()).height + mathMax(0, padding);
            fontSizeArray.push(fontSize);
        }
    }
    dummyText.remove();
    var maxFontSize = (fontSizeArray.length > 0) ? mathMax.apply(null, fontSizeArray) : 0;
    return maxFontSize;
}

function dataLabelTextContent(chartObj, rp, conf, type, total, seriespos, yrangePos) {
    var yColumn = chartObj.seriesdata[seriespos].yaxiscolumnorder || [0, 0]; //We need the yaxis order and column order. But, rp.yaxiscolumnorder - returns only the yaxis order
    var chartType = chartObj.chartTypes[seriespos],
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    rp = rp || {
            stacked: false,
            commonPlotOptions: chartObj.systemConf.chart.plot.plotoptions[chartType.name],
            yaxiscolumnorder: dataProcessorHelpers.getParsedYAxisOrder(yColumn)
        };
    var dataset = chartObj.dataset,
        yaxiscolumnorder = rp.yaxiscolumnorder,
        stacked = rp.stacked,
        showAs = conf.showAs,
        columns = chartObj.systemConf.metadata.columns,
        haslabelidx = type == "datalabels" && dataset.labelidx != null,
        isBubblePie = (chartType.value === $ZC.charttype.bubblepie),
        piedataindex = validateNullVal(rp.commonPlotOptions.dataindex, 3);
    var labelidx = (haslabelidx && columns[dataset.labelidx] != null);
    showAs = (haslabelidx && columns[dataset.labelidx] == null) ? dataset.labelidx : showAs;
    var axisType = labelidx ? "label" : ((showAs == "x") ? "x" : ((showAs == "z" && dataset.zidx != null) ? "z" : "y"));
    var datatype = columns[dataset.getColumnIdx(axisType, yColumn)].datatype;
    var formatConf = dataset.getColumn(axisType, yColumn)[datatype];
    var formattingFunc = (!labelidx && (showAs == "percent" || showAs === "splitpercent")) ? getFormattedValueByPercent : getFormattedValue;
    var isShowAsDefined = ["x" , "y", "z", "percent", "splitpercent"].indexOf(showAs) != -1,
        newShowAs;

    if (!labelidx && !isShowAsDefined) {
        newShowAs  =  getTspanTemplate(showAs);
    }

    var textContent = function(d) {
        if (labelidx) {
            var value = dataset.getDataLabelValue(d);
            return formattingFunc(formatConf, value, datatype, chartObj, "datalabels");
        } else if (isShowAsDefined) {
            var value = null;
            switch (showAs) {
                case "percent" :
                case "splitpercent" :
                    var t = total,
                        v = (type == "stackLabels") ? d : (stacked ? d.y : (isBubblePie ? d[piedataindex] : (d.value || dataset.getY(d, yaxiscolumnorder, yrangePos))));

                    if (stacked && !chartObj.dataObject.isStackedPercentChart && type == "datalabels") {
                        t = getStackedTotal(chartObj, seriespos, d, showAs);
                    } else if (typeof total === "function") {
                        t = total(d);
                    }

                    t *= 0.01;
                    value = v / t;
                    value = value || 0//if t=0 and v=0, the 'value' holds NaN
                    break;
                case "x" :
                    value = dataset.getX(d);
                    break;
                case "z" :
                    if (dataset.zidx != null) {
                        value = dataset.getZ(d);
                    }
                    break;
                default :
                    value = (type == "stackLabels") ? d : (chartObj.dataObject.isHierarchy ? (d.value || dataset.getY(d, yaxiscolumnorder)) : dataset.getY(d, yaxiscolumnorder, yrangePos));
            }
            return formattingFunc(formatConf, value, datatype, chartObj, type);
        } else {
            return dataset.getCustomizedVal(chartObj, newShowAs, seriespos, null, null, d, type, null, (textContent.contentType !== "html"));
        }
    };

    //Find the content type of the data labels
    textContent.contentType = (!labelidx && !isShowAsDefined && (isArray(showAs) || showAs.indexOf("<tspan") != -1)) ? "html" : "text";
    textContent.multiLine = (textContent.contentType === "html") && isArray(showAs) && (showAs.length > 1);
    return textContent;
}

function isDatalabelEnabled(dataLabels, chartObj) {

    if(datacount_based_intelligence(chartObj, "datalabels")) {
        return defined(chartObj.dataset.labelidx) || getValByPriority([dataLabels, chartObj.systemConf.chart.plot.datalabels], "show") === true;
    }
    return false;
    // return datacount_based_intelligence(chartObj, "datalabels") ?
    //     (defined(chartObj.dataset.labelidx) || getValByPriority([dataLabels, chartObj.systemConf.chart.plot.datalabels], "show") === true) : false;
}

function isStacklabelEnabled(stackLabels, chartObj) {
    return chartObj.dataObject.noofBarEnabledSeries && chartObj.dataObject.isstacked() && !chartObj.dataObject.isStackedPercentChart && stackLabels && stackLabels.show;
}

function isShowAsPercentage(chartName, chartObj) {
    var datalabelOptions = chartObj.systemConf.chart.plot.plotoptions[chartName].datalabels || {},
        userDatalabelsOptions = isObjectPropDefined(chartObj.userdata, "chart.plot.plotoptions."+chartName+".datalabels", true) || {},
        showAs = userDatalabelsOptions.showAs || datalabelOptions.showAs;
    return showAs === "percent" || showAs === "splitpercent" || PERCENT_PATTERN.test(showAs);
}

function callTrimText(labelText, chartObj, tranform, fontSize, edge) {
    var dx = +tranform[0],
        dy = +tranform[1],
        plotarea = chartObj.plotarea,
        margin = {
            "left": -fontSize,
            "right": -fontSize,
            "top": 0,
            "bottom": 0
        },
        pattern = "..",
        orient = "bottom";
    
    edge = edge || {
            "left": -dx,
            "top": -dy,
            "right": plotarea.width - dx,
            "bottom": plotarea.height - dy
        };
    labelText
        .each(function() {
            var bb = bbox(this);
            var textBound = {
                "left": bb.x,
                "top": bb.y,
                "width": bb.width,
                "height": bb.height
            };
            trimText(this, this.textContent, textBound, edge, orient, pattern, margin);
        });
}

function overrideDatalabelShowAs(options, chartObj, index) {
    /* If defaulttheme.showAs ='y' && userdata.showAs = ['<tspan>{{val(0)}}</tspan>', '<tspan style="fill:red">{{val(1)}}</tspan>'], merged sysconf will have "y" only.
     * The following will update the userdata's showAs if presents.
     */
    var chartName = chartObj.chartTypes[index].name;
    var userDatalabels = isObjectPropDefined(chartObj.userdata, "chart.plot.plotoptions."+chartName+".datalabels", true) || {},
        userInnerLabel,
        userParentLabel,
        userStackLabel,
        systemConfInnerLabel,
        systemConfParentLabel,
        systemConfStackLabel;

    if (userDatalabels.showAs) {
        options.showAs = userDatalabels.showAs || options.showAs;
    }

    if (userInnerLabel = userDatalabels.innerLabel) {
        systemConfInnerLabel = options.innerLabel;
        systemConfInnerLabel.showAs = userInnerLabel.showAs || systemConfInnerLabel.showAs;

        if (userParentLabel = userInnerLabel.parentLabel) {
            systemConfParentLabel = options.innerLabel.parentLabel;
            systemConfParentLabel.showAs = userParentLabel.showAs || systemConfParentLabel.showAs;
        }
    } else if (userStackLabel = userDatalabels.stackLabels) {
        systemConfStackLabel = options.stackLabels;
        systemConfStackLabel.showAs = userStackLabel.showAs || systemConfStackLabel.showAs;
    }
}
//$Id$
function getTspanTemplate(showAs) {
    var newShowAs = "";
    if (isArray(showAs)) {
        showAs.forEach(function(d, i) {
            newShowAs += "<tspan class='zcTspan'" + (i ? " dy='1.1em'" : "") + ">" + updateTspanTemplate(d) + "</tspan>";
        });
    } else {
        var tagIndex = showAs.indexOf("<tspan");
        if (tagIndex != -1) {
            newShowAs = "<tspan class='zcTspan'>" + updateTspanTemplate(showAs) + "</tspan>";
        } else {
            newShowAs = showAs;
        }
    }
    return newShowAs;
}

function updateTspanTemplate(showAs) {
    var str = "",
        lastIndex = 0,
        endTagLength = 8,
        t = {
            "<tspan": [],
            "</tspan>": []
        };

    showAs.replace(/<tspan|<\/tspan>/g, function() {
        t[arguments[0]].push(arguments[1]);
    });

    t["<tspan"].forEach(function(d, i) {
        if (lastIndex != d) {
            str += "<tspan>" + showAs.substring(lastIndex, d) + "</tspan>";
        }
        str += showAs.substring(d, lastIndex = t["</tspan>"][i] + endTagLength);
    });

    if (lastIndex != showAs.length) {
        str += "<tspan>" + showAs.substring(lastIndex, showAs.length) + "</tspan>";
    }

    return str;
}

function translateTspan(ele, x) {
    ele.selectAll("tspan.zcTspan")
        .attr("x", x);
}

function trimAllTspan(labelText, chartObj, tranform, fontSize, edge, b, boundboxPadding) {
    var dx = +tranform[0],
        dy = +tranform[1],
        plotarea = chartObj.plotarea,
        margin = {
            "left": -fontSize,
            "right": -fontSize,
            "top": 0,
            "bottom": 0
        },
        pattern = "..",
        orient = "bottom";
    boundboxPadding = boundboxPadding || 0;

    edge = edge || {
            "left": -dx + boundboxPadding,
            "top": -dy,
            "right": plotarea.width - dx - boundboxPadding,
            "bottom": plotarea.height - dy
        };

    labelText
        .each(function() {
            var children = this.childNodes,
                childCount = 0,
                parentBBox = bbox(this),
                parentWidth = this.getComputedTextLength();

            if ((parentBBox.x + parentWidth) > edge.right) {
                parentWidth -= ((parentBBox.x + parentWidth) - edge.right + boundboxPadding);
            }
            if (parentBBox.x < edge.left) {
                parentWidth -= (edge.left - parentBBox.x + boundboxPadding);
            }

            for (var i=0; i<children.length; i++) {
                var node = children[i],
                    c = node.childNodes,
                    totalWidth = node.getComputedTextLength(),
                    textContent = ""

                //collect all text contents
                for(var j=0; j<c.length; j++) {
                    var curTextContent = c[j].textContent;
                    textContent += curTextContent;
                    b[childCount + j].textLength = curTextContent.length;
                }

                // trim the text
                if (parentWidth < totalWidth) {
                    var bb = b[childCount].bbox;
                    var textBound = {
                        "left": bb.x,
                        "top": bb.y,
                        "width": totalWidth,
                        "height": bb.height
                    };
                    trimText(c[0], textContent, textBound, edge, orient, pattern, margin, null, null, false);

                    // distribute the text contents to the respective tspan
                    var innerHTML = c[0].innerHTML;
                    if (innerHTML === "..") {
                        innerHTML = "";
                    }

                    for(var j=0, start=0; j<c.length; j++) {
                        var curTextLength = b[childCount + j].textLength;
                        c[j].innerHTML = innerHTML.substring(start, start + curTextLength);
                        start += curTextLength;
                    }
                }
                childCount += c.length - 1;
            }

        });
}

function getTspanBound(label, fontSize) {
    var c = label.selectAll(function() {
                return this.childNodes;
            }),
        anchor = label.attr("text-anchor"),
        X = +label.attr("x"),
        Y = +label.attr("y"),
        o = [];

    c.each(function(){
        var ele = d3.select(this),
            nodeDY = parseFloat(ele.attr("dy") || 0),
            children = this.childNodes,
            totalWidth = this.getComputedTextLength(),
            oldRef = (anchor === "middle") ? (-totalWidth / 2) : (anchor == "end" ? -totalWidth : 0);

        for(var i=0; i<children.length; i++) {
            var currentWidth = children[i].getComputedTextLength();
            var info = {
                dy : i ? 0 : nodeDY,
                dx : oldRef + ((anchor === "middle") ? (currentWidth / 2) : 0),
                bbox : {x: X + oldRef,
                        y: Y + (i ? 0 : nodeDY) * fontSize,
                        width: children[i].getComputedTextLength(),
                        height: fontSize
                    },
                style : children[i].style,
                text : children[i].textContent
            }
            o.push(info);
            oldRef += currentWidth;
        }
    });
    return o;
}
//$Id$
function arrange(slot, TOP, slotCount, slottedCount) {
    var leftUnslotted = [],
        unslotted = [],
        remaining = [],
        remainingCount = slotCount - slottedCount,
        sortByDist = function(a, b) {
            return a.dist - b.dist;
        },
        sortByY = function(a, b) {
            return a[0].y1 - b[0].y1;
        };
    var remainingCount_copy = remainingCount;
    
    //Collect free slot indices
    for (var i = 0; i < slotCount; i++) {
        if (!slot[i]) {
            leftUnslotted.push(i);
        }
    }
    
    slot.forEach(function(d) {
        d.sort(sortByDist);
    });
    
    // Add all unslotted labels
    slot.forEach(function(d) {
        d.forEach(function(dt, i) {
            if (i != 0) {
                remaining[i] = remaining[i] || [];
                remaining[i].push(dt);
            }
        });
    });
    
    remaining.forEach(function(d) {
        d.sort(sortByDist);
    });
    
    remaining.forEach(function(d) {
        d.forEach(function(dt, i) {
            unslotted.push([dt]);
        })
    });
    
    unslotted.forEach(function(d, i) {
        if (remainingCount > 0) {
            remainingCount--;
        } else {
            d[0].hide = true;
        }
    });
    
    unslotted = unslotted.slice(0, remainingCount_copy);
    unslotted.sort(sortByY);
    
    unslotted.forEach(function(d) {
        var us = d[0];
        var height = (us.y2 - us.y1);
        var co = mathMax(mathFloor((us.y1 - TOP) / height), 0);
        if (slot[co]) {
            var dist, pos = leftUnslotted[0],
                id = 0;
            for (var o = 0; o < leftUnslotted.length; o++) {
                var dst = mathAbs(TOP + (leftUnslotted[o] * height) - us.y1);
                if (dist == null) {
                    dist = dst;
                }
                if (dst < dist) {
                    dist = dst;
                    pos = leftUnslotted[o];
                    id = o;
                }
            }
            if (pos < co) {
                leftUnslotted.splice(id, 1);
                
                var prev = pos;
                slot.forEach(function(d, i) {
                    var dt = d[0];
                    if ((i > pos) && (dt.y1 < us.y1)) {
                        slot[prev] = d;
                        prev = i;
                    }
                });
                
                slot[prev] = [us];
                
            } else {
                leftUnslotted.splice(id, 1);
                
                var prev = [us];
                for (var i = co; i <= pos; i++) {
                    if (!slot[i]) {
                        slot[i] = prev;
                    } else if (slot[i][0].y1 > us.y1) {
                        var temp = slot[i];
                        slot[i] = prev;
                        prev = temp;
                    }
                }
            }
        } else {
            slot[co] = d;
        }
        
    });
    
    slot.forEach(function(d, i) {
        var dt = d[0];
        var height = (dt.y2 - dt.y1);
        var dy = (TOP + (i * height)) - dt.y1
        dt.translate = ((mathAbs(dy) < height) && ((i + 1) < slotCount) && !slot[i + 1] && (dy < 0)) ? 0 : dy;
    });
    // Some other way
    slot.forEach(function(d, i) {
        var dt = d[0];
        var height = (dt.y2 - dt.y1);
        var dy = (TOP + (i * height)) - dt.y1
        dt.translate = ((mathAbs(dy) < height) && ((i + 1) < slotCount) && (!slot[i + 1] || !slot[i + 1][0].translate) && (dy < 0)) ? 0 : dy;
    });
    // Some other way
}

function addToSlot(half, count, slot, TOP) {
    half.forEach(function(obj) {
        var height = (obj.y2 - obj.y1);
        var co = mathMax(0, mathFloor((obj.y1 - TOP) / (obj.y2 - obj.y1)));
        obj.dist = (obj.y1 < TOP) ?
            (TOP - obj.y1) :
            (obj.y1 - (TOP + (co * height)));
        if (!slot[co]) {
            slot[co] = [];
            count++;
        }
        slot[co].push(obj);
    });
    return count;
}

function addToHalf(obj, slotCount, TOP, BOTTOM, prev, half, count, totalSpaceNeeded, reverse) {
    var MARGIN = 5;
    if (!obj.hide) {
        if (slotCount == null) {
            slotCount = mathFloor((BOTTOM - TOP) / (obj.y2 - obj.y1));
        }
        var dist = (reverse) // If (dist < 0), it is overlapping
            ?
            ((prev == null) ? (BOTTOM - obj.y2) : (half[prev].y1 - obj.y2)) :
            (prev == null) ? (obj.y1 - TOP) : (obj.y1 - half[prev].y2);
        totalSpaceNeeded += ((prev != null) && doOverlap(obj, half[prev]) && (dist < -MARGIN)) ? mathAbs(dist) : 0;
        
        prev = count;
        half.push(obj);
        count++;
    }
    return {
        prev: prev,
        count: count,
        totalslot: slotCount,
        need: totalSpaceNeeded
    };
}//$Id$
function addTargetLabel(targetMarkerOptions, renderer, dataUpdate) {
    var targetLabelOptions = targetMarkerOptions.label || {};
    var chartObj = this,
        dataset = this.dataset,
        plotarea = this.plotarea,
        systemconf = this.systemConf,
        commonOption = renderer.commonOption,
        rp = renderer.commonRendererProp().params,
        axisrotated = rp.axisrotated,
        yscale = rp.yscale,
        rangeBand = rp.xscale.rangeBand(),
        yaxisOrient = systemconf.chart.axes.yaxis[0].orient || ((this.axes.rotated) ? "bottom" : "left");
    
    var targetDataIndex = targetMarkerOptions.dataindex,
        showlabel = targetMarkerOptions.enabled === true && targetLabelOptions.enabled === true && defined(targetDataIndex);
    
    var targetLabelGroup = appendEle(this.staticPaneSVG.selectAll("g.threshold"), "g", (showlabel ? [1] : []), ".", "class", "targetLabel");
    targetLabelGroup
        .attr("transform", "translate(" + plotarea.left + "," + plotarea.top + ")");
    
    if (!showlabel) {
        return;
    }
    
    var markerSize = validateNullVal(targetMarkerOptions.size, (commonOption.levelMarkerWidth - (2 * validateNullVal(targetMarkerOptions.padding, commonOption.padding / 2))) / 10) * 10,
        hAlign = targetLabelOptions.hAlign,
        vAlign = targetLabelOptions.vAlign,
        padding = validateNullVal(targetLabelOptions.padding, 2),
        markerSizeAdjust = ((targetMarkerOptions.symbol === "line") ? validateNullVal(targetMarkerOptions.outerStrokeWidth, 1) : markerSize) / 2;
    
    if (axisrotated) {
        hAlign = hAlign || "center";
        vAlign = vAlign || ((yaxisOrient === "bottom") ? "top" : "bottom");
    } else {
        hAlign = hAlign || ((yaxisOrient === "left") ? "right" : "left");
        vAlign = vAlign || "center";
    }
    
    var columns = this.userdata.metadata.columns;
    var columnidx = columns.filter(function(d) {
        return d.dataindex === targetMarkerOptions.dataindex;
    });
    var targetColumn = (columnidx.length) ? columnidx[0] : columns[dataset.getColumnIdx("y", 0)];
    var datatype = targetColumn.datatype;
    var formatConf = targetColumn[datatype];

    var adjust = {
        left: 0,
        right: 0,
        top: 0,
        bottom: 0
    };
    if (axisrotated) {
        adjust.top = adjust.bottom = plotarea.adjust;
    } else {
        adjust.left = adjust.right = plotarea.adjust;
    }
    if (systemconf.chart.axes.yaxis[0].show === true) {
        adjust[yaxisOrient] = 0;
    }

    var rectBound = chartObj.svg.node().getBoundingClientRect(),
        rectBoundLeft = rectBound.left + chartObj.plotarea.left,
        rectBoundTop = rectBound.top + chartObj.plotarea.top,
        currentPlotBound = getPlotBound(chartObj),
        left = currentPlotBound.left - adjust.left,
        top = currentPlotBound.top - adjust.top,
        right = currentPlotBound.right + adjust.left + adjust.right,
        bottom = currentPlotBound.bottom + adjust.top + adjust.bottom;
    
    applyFont(targetLabelGroup, [targetLabelOptions, systemconf.chart, systemconf.canvas, $ZCG]);
    var targetLabelText = targetLabelGroup.selectAll("text").data(dataUpdate, function(d) {
        return dataset.getX(d);
    });
    targetLabelText.enter().append("text");
    targetLabelText.exit().remove();
    
    targetLabelText
        .each(function(d) {
            var targetValue = d[targetDataIndex];
            if (!defined(targetValue)) {
                return;
            }

            var xValue = dataset.getX(d),
                X, Y, DY, ANCHOR,
                TEXT = defined(targetLabelOptions.text) ?
                    dataset.getCustomizedVal(chartObj, targetLabelOptions.text, 0, null, null, d, "targetLabel") :
                    getFormattedValue(formatConf, targetValue, datatype, chartObj, "targetLabel"),
                isNeg = (targetValue < 0),
                flip = isNeg ? -1 : 1;
            var x = commonOption.bandwidth1(xValue) + (rangeBand / 2),
                y = yscale(targetValue);
            
            if (axisrotated) {
                X = y;
                Y = x;
                if (vAlign === "bottom") {
                    Y += (markerSize / 2);
                    if (hAlign === "center") {
                        DY = "1em";
                    }
                } else if (vAlign === "center") {
                    DY = "0.3em";
                } else if (vAlign === "top") {
                    Y -= (markerSize / 2);
                    if (hAlign === "center") {
                        DY = "-0.3em";
                    } else {
                        DY = "1em";
                    }
                }
                
                if (hAlign === "center") {
                    ANCHOR = "middle";
                    Y -= (vAlign === "center") ?
                        0 :
                        ((vAlign === "top") ?
                            (padding * flip) :
                            -(padding * flip));
                } else {
                    if (hAlign === "right") {
                        X += ((padding + markerSizeAdjust) * flip);
                        ANCHOR = isNeg ? "end" : null;
                    } else {
                        X -= ((padding + markerSizeAdjust) * flip);
                        ANCHOR = isNeg ? null : "end"
                    }
                }
                
            } else {
                X = x;
                Y = y;
                if (hAlign === "right") {
                    X += (markerSize / 2);
                } else if (hAlign === "center") {
                    ANCHOR = "middle";
                } else if (hAlign === "left") {
                    X -= (markerSize / 2);
                    ANCHOR = "end";
                }
                
                if (vAlign === "center") {
                    X += (hAlign === "center") ?
                        0 :
                        ((hAlign === "right") ?
                            padding :
                            -padding);
                    DY = "0.3em";
                } else if (vAlign === "top") {
                    Y -= ((padding + markerSizeAdjust) * flip);
                    DY = "-0.3em";
                } else {
                    Y += ((padding + markerSizeAdjust) * flip);
                    DY = "1em";
                }
            }
            
            d3_select(this)
                .attr({
                    "transform": "translate(" + X + "," + Y + ")",
                    "text-anchor": ANCHOR,
                    "dy": DY
                })
                .text(TEXT);

            // label should be within container
            var b = this.getBoundingClientRect(),
                leftPos = b.left - rectBoundLeft,
                rightPos = leftPos + b.width,
                topPos = b.top - rectBoundTop,
                bottomPos = topPos + b.height;

            var newX = X + ((leftPos < left)
                    ? (left - leftPos)
                    : ((rightPos > right) ? -(rightPos - right) : 0)),
                newY = Y + ((topPos < top)
                    ? (top - topPos)
                    : ((bottomPos > bottom) ? -(bottomPos - bottom) : 0));

            if (newX != X) {
                X = newX;
            }

            if (newY != Y) {
                Y = newY
            }

            d3_select(this)
             .attr("transform", "translate(" + X + "," + Y + ")");
        });
}//$Id$
/*
 * PENDING:
 * Bound box - minHeight should be considered for height on handling overlapping datalabels (if hook is enabled)
 */
 //multi coloring
$ZC.labelRenderer.hierarchy = function() {
    var renderer, args, labelseries;
    
    function labels(selection, labelHandler) {
        selection.each(function() {
            var currentdata = args[0],
                index = args[1],
                size = args[2] || 0,
                yrangePos = args[3],
                total = args[4],
                leafNodes = args[5],
                transform = args[6] || [0, 0],
                plotoptions = currentdata.plotoptions,
                dataLabels,
                rp = renderer.commonRendererProp().params,
                chartObj = rp.chartObj,
                systemconf = chartObj.systemConf,
                commonPlotOptions = rp.commonPlotOptions,
                dataset = rp.dataset,
                yaxiscolumnorder = rp.yaxiscolumnorder,
                labelArray = rp.labelArray,
                xscale = rp.xscale,
                yscale = rp.yscale;
            
            dataLabels = getMergedDatalabelOptions(commonPlotOptions, plotoptions, chartObj, index);
            var showlabel = isDatalabelEnabled(dataLabels, chartObj);
            
            if (currentdata.disabled || !showlabel) {
                return;
            }
            
            var chartName = chartObj.chartTypes[0].name;

            var currentPlotBound = getPlotBound(chartObj),
                boundBoxPadding = 0,
                boundBoxStrokeWidth = 0,
                hookHeight = 0,
                hookWidth = 0,
                boundBoxRadius = 0;
            if (isBoundBoxEnabled(dataLabels, chartObj)) {
                var boundBoxOptions = getMergedBoundBoxOptions(dataLabels, chartObj);
                var hookOptions = getBoundBoxHookConf(boundBoxOptions.hook);
                boundBoxPadding = getBoundBoxPadding(dataLabels, chartObj);
                boundBoxStrokeWidth = getBoundBoxStrokeWidth(dataLabels, chartObj);
                hookHeight = hookOptions.height;
                hookWidth = hookOptions.width;
                boundBoxRadius = boundBoxOptions.radius;
            }
            
            var textOverlap = dataLabels.textOverlap,//dataLabels.textOverlap, //hidden | adjust | ellipsis
                hAlign = dataLabels.hAlign || "center",
                vAlign = dataLabels.vAlign || "center",
                padding = validateNullVal(dataLabels.padding, 0.5),
                handleOverlapping = systemconf.chart.plot.datalabels.handleOverlapping === true,
                GLT = dataLabelTextContent(chartObj, rp, dataLabels, "datalabels", total, index, yrangePos),
                contentType = GLT.contentType || "text",
                isMultiLine = (contentType === "html") && GLT.multiLine,
                fontSize = getFontSizeByHierarchy(dataLabels, chartObj),
                heightAdjustScale = d3_scaleLinear().domain([-0.3, 0.9]);
            
            var temp_label = appendEle(chartObj.staticPaneSVG.select(".labelholder"), "text", [1], ".", "class", "temp_label");
            var updateHandler = labelHandler.update,
                queue = labelHandler.add;
            
            
            // currentdata.forEach(function(d, i) {
                var dataUpdate = leafNodes;
                
                var calculated_points = [];
                applyDatalabelFonts(temp_label, dataLabels, chartObj, rp.color, false, index);
                temp_label.style({
                    "fill": "transparent"
                });
                
                dataUpdate.forEach(function(d, j) {
                    var pos = getPosition(d);
                    var x = pos.x,
                        y = pos.y,
                        text = null,
                        tspanInfo = null,
                        display = colorscale_helpers.isQuantileColorScale(chartObj) ? isWithinColorRange(dataset.getClr(d.data || d), chartObj) : true,
                        id = "",
                        dy = getDy() + "em",
                        ANCHOR = getAnchor(),
                        HOOKPOSITION = null,
                        xDiff = 0,
                        yDiff = 0,
                        polarXY;

                    
                    temp_label[contentType](function() {
                            text = GLT(d.data || d);
                            return text;
                        })
                        .attr({
                            "dy": dy,
                            "x": x,
                            "y": y,
                            "text-anchor": ANCHOR,
                            "display": display
                        });
                    
                    // ID
                    id = "lbl" + d.level;

                    var textBound;
                    if (isMultiLine) {
                        translateTspan(temp_label, x);
                        textBound = bbox(temp_label.node());
                    } else if (contentType === "html") { //Test_665.json
                        textBound = bbox(temp_label.node());
                    } else {
                        textBound = getTextBound(text, fontSize, getFontFamilyByHierarchy(dataLabels, chartObj));
                        textBound = updateTextBound(textBound, ANCHOR, dy, x, y);
                    }

                    widthToBeAdded = 0;
                    var bb_width = textBound.width + widthToBeAdded,
                        bb_height = textBound.height,
                        bb_x = textBound.x + (widthToBeAdded / 2);
                    if (handleOverlapping) {
                        // Consider padding for label bound
                            var labelBound = {
                                    "x1": textBound.x - boundBoxPadding,
                                    "y1": textBound.y - boundBoxPadding,
                                    "x2": (textBound.x + textBound.width + boundBoxPadding),
                                    "y2": (textBound.y + textBound.height + boundBoxPadding)
                                },
                                nodeBound = getNodeBound(getRawPosition(d), textBound);

                            var within = isLabelWithinBound(labelBound, nodeBound);
                            if (!within) {
                                var trimmed;
                                if (textOverlap === "ellipsis") { // add ellipsis
                                    var h = pos.h;
                                    var w = pos.w;
                                    if ((bb_height + 2*boundBoxPadding) < h) {
                                        var bound = {
                                            "left": (nodeBound.x1 + boundBoxPadding),
                                            "top": (nodeBound.y1 + boundBoxPadding),
                                            "right": (nodeBound.x2 - boundBoxPadding),
                                            "bottom": (nodeBound.y2 - boundBoxPadding)
                                        };

                                        if (contentType === "html") {
                                            tspanInfo = getTspanBound(temp_label, fontSize);
                                            trimAllTspan(temp_label, chartObj, transform, 0, bound, tspanInfo);
                                        } else {
                                            callTrimText(temp_label, chartObj, transform, 0, bound);
                                        }

                                        var trimmedText = temp_label.text();
                                        if (trimmedText && trimmedText !== "..") { //If the textContent is just "..", hide the label
                                            text = temp_label[contentType]();
                                            trimmed = true;
                                            bb_width = w - (2 * boundBoxPadding);
                                            if (isMultiLine) {
                                                var newBB = bbox(temp_label.node());
                                                bb_height = newBB.height;
                                                bb_width = newBB.width + widthToBeAdded;
                                                y += (textBound.height - newBB.height) / 2;
                                            }
                                        }
                                    }
                                }
                                
                                if (!trimmed) {
                                    display = false;
                                }
                            }
                        
                    }

                    var coordinate = {
                        "X": x,
                        "Y": y,
                        "DY": dy,
                        "ANCHOR": ANCHOR,
                        "text": text,
                        "display": display,
                        "height": bb_height,
                        "width": bb_width,
                        "hookPosition": HOOKPOSITION,
                        "adjustVal": xDiff
                    };

                    calculated_points.push(coordinate);
                });

                calculated_points.dataUpdate = dataUpdate; //Each subseries may have different dataUpdates
                var q = queue(calculated_points, index, 0, yrangePos);
                q.properties = {
                    "type": "hierarchy",
                    "dataLabels": dataLabels,
                    "color": rp.color,
                    "dataUpdate": dataUpdate,
                    "showlabel": showlabel,
                    "rp": rp,
                    "contentType" : contentType,
                    "isMultiLine" : isMultiLine
                };
            // });

            function getPosition(d) {
                var pos = getRawPosition(d),
                    x = pos.x;
                    y = pos.y;
                    w = pos.width;
                    h = pos.height;

                x = updateXposition(x, w) + transform[0];
                y = updateYposition(y, h) + transform[1];

                return {
                    x: x,
                    y: y,
                    w: w,
                    h: h
                };
            }

            function getNodeBound(pos, textBound) {
                var nodeheight = pos.height,
                    nodewidth = pos.width,
                    nodex = pos.x + transform[0],
                    nodey = pos.y + transform[1];

                var bb = {
                    x1: nodex,
                    y1: nodey,
                    x2: (nodex + nodewidth),
                    y2: (nodey + nodeheight)
                }

                if (chartName === "packedbubble") {
                    var radius = nodewidth / 2,// hypotenuse
                        vert = mathMin((textBound.height / 2), radius),
                        hori = mathSQRT(mathPow(radius, 2) - mathPow(vert, 2)),
                        excess = radius - hori;
                    bb.x1 += excess;
                    bb.x2 -= excess;
                    bb.y1 += excess;
                    bb.y2 -= excess;
                }
                return bb;
            }

            function updateXposition(x, w) {
                if (hAlign === "center") {
                    x += (w/2);
                } else if (hAlign === "right") {
                    x += (w - padding - boundBoxPadding);
                } else {
                    x += (padding + boundBoxPadding);
                }
                return x;
            }

            function updateYposition(y, h) {
                if (vAlign === "center") {
                    y += (h/2);
                } else if (vAlign === "bottom") {
                    y += h - padding - boundBoxPadding;
                } else {
                    y += (padding + boundBoxPadding);
                }
                return y;
            }

            function getAnchor() {
                return (hAlign === "center") ? "middle" : (hAlign === "right") ? "end" : null;
            }

            function getDy() {
                var DY;
                    if (vAlign === "center") {
                        DY = 0.3;
                    } else if (vAlign === "bottom") {
                        DY = -0.3;
                    } else {
                        DY = 1;
                    }
                if (isMultiLine) {
                        var lineCount = (dataLabels.showAs.length - 1) * 1.1;
                        if (DY === -0.3) {
                            DY -= lineCount;
                        } else if (DY === 0.3) {
                            DY -= (lineCount / 2)
                        }
                }
                return DY;
            }
            function getRawPosition(d) {
                switch(chartName) {
                    case "packedbubble":
                        return getPackedbubblePosition(d);
                        break;
                    case "treemap":
                        return getTreemapPosition(d);
                    case "heatmap":
                        return getHeatCellPosition(chartObj, d, xscale, yscale, yaxiscolumnorder);
                }
            }

            function updateTextBound(textBound, ANCHOR, dy, x, y) {
                var w = textBound.width,
                    h = textBound.height;
                var tx = ((ANCHOR === "middle") ?
                                (w / 2) :
                                ((ANCHOR === "end") ? w : 0)),
                    ty = heightAdjustScale.range([h, 0])(parseFloat(dy));
                textBound.x = x - tx;
                textBound.y = y - ty;
                return textBound;
            }
        });
    }
    
    labels.renderer = function(_) {
        if (!arguments.length) {
            return renderer;
        }
        renderer = _;
        return labels;
    };
    labels.args = function(_) {
        if (!arguments.length) {
            return args;
        }
        args = _;
        return labels;
    };
    
    return labels;
};//$Id$
/*
 types = zBlocks, zBars, zCircle1, zCircle2, zCrossBars
 scale - transform scale
 duration - time duration for one iteration
 */
//detect Browser Func
var loadDetectBrowser = function() {
    var userAgent = navigator.userAgent;
    var browser = {};
    if (userAgent.indexOf("OPR") > 0) {
        browser.name = "Opera";
        browser.jsPrefix = "webkit";
        browser.cssPrefix = "-webkit-";
        var index = userAgent.indexOf("OPR/");
        browser.version = pInt(userAgent.substr(index + 4));
    } else if (userAgent.indexOf("Chrome") > 0) {
        browser.name = "Chrome";
        browser.jsPrefix = "webkit";
        browser.cssPrefix = "-webkit-";
        var index = userAgent.indexOf("Chrome/");
        browser.version = pInt(userAgent.substr(index + 7));
    } else if (userAgent.indexOf("Safari") > 0) {
        browser.name = "Safari";
        browser.jsPrefix = "webkit";
        browser.cssPrefix = "-webkit-";
        var index = userAgent.indexOf("Version/");
        browser.version = pInt(userAgent.substr(index + 8));
    } else if (userAgent.indexOf("Firefox") > 0) {
        browser.name = "Firefox";
        browser.jsPrefix = "Moz";
        browser.cssPrefix = "-moz-";
        var index = userAgent.indexOf("Firefox/");
        browser.version = pInt(userAgent.substr(index + 8));
    } else if (userAgent.indexOf("MSIE") > 0) {
        browser.name = "Internet Explorer";
        browser.jsPrefix = "ms";
        browser.cssPrefix = "-ms-";
        var index = userAgent.indexOf("MSIE");
        browser.version = pInt(userAgent.substr(index + 5));
    } else {
        browser = undefined;
    }
    return browser;
}

var loadSetStyle = function(elementObj, paramsObj) {
    var docStyles = getComputedStyle(elementObj);
    var browser = loadDetectBrowser();
    
    for (var property in paramsObj) {
        if (paramsObj.hasOwnProperty(property)) {
            if (property in docStyles) {
                elementObj.style[property] = paramsObj[property];
            } else if (browser != undefined) {
                var propertyFix = browser.jsPrefix + property.charAt(0).toUpperCase() + property.slice(1);
                elementObj.style[propertyFix] = paramsObj[property];
            }
        }
    }
}

var ZCloader = function(elemObj, customObj) {
    
    //Base Object with default configuration
    var baseObj = {
            type: "zBars",
            scale: 1,
            duration: 1.2
        },
        style = document.getElementById("ZCloader");
    
    if (!ZCloader.style) {
        style = document.createElement('style');
        style.setAttribute('id', 'ZCloader');
        document.head.appendChild(style);
        ZCloader.style = true;
    }
    
    for (var config in customObj) {
        if (customObj.hasOwnProperty(config)) {
            baseObj[config] = customObj[config];
        }
    }
    
    var clr = baseObj.colors || ["rgb(204, 32, 50)", "rgb(24, 153, 74)", "rgb(1, 115, 178)", "rgb(253, 208, 25)"];
    var clr1 = clr[0 % clr.length],
        clr2 = clr[1 % clr.length],
        clr3 = clr[2 % clr.length],
        clr4 = clr[3 % clr.length];
    
    var browser = loadDetectBrowser();
    var animString = "";
    if (browser === undefined) {
        browser = {};
        browser.cssPrefix = "";
    } else if (browser.name === "Internet Explorer" && browser.version < 10) {
        baseObj.type = "wheel";
    }
    
    if (!elemObj.loader) {
        
        var animBlock = document.createElement('div');
        
        if (baseObj.type == "zBlocks") {
            
            if (!ZCloader.zBlocks) {
                
                var animString = "\n@" + browser.cssPrefix + "keyframes " + baseObj.type + " {";
                animString += "0% { left:0px; top:0px; " + browser.cssPrefix + "transform:rotate(0deg) scale(1)}";
                animString += "25% { left:40px; top:0px; " + browser.cssPrefix + "transform:rotate(90deg) scale(0.5)}";
                animString += "50% { left:40px; top:40px; " + browser.cssPrefix + "transform:rotate(180deg) scale(1.0)}";
                animString += "75% { left:0px; top:40px; " + browser.cssPrefix + "transform:rotate(270deg) scale(0.5)}";
                animString += "100% { left:0px; top:0px; " + browser.cssPrefix + "transform:rotate(360deg)scale(1)} }\n";
                style.innerHTML += animString;
                
                ZCloader.zBlocks = true;
            }
            
            loadSetStyle(animBlock, {
                display: "inline-block",
                verticalAlign: "middle",
                width: "70px",
                height: "70px",
                transform: "scale(" + baseObj.scale + ")"
            });
            
            var block1 = document.createElement('div');
            block1.innerHTML = "&nbsp";
            animBlock.appendChild(block1);
            loadSetStyle(block1, {
                backgroundColor: clr1,
                width: "30px",
                height: "30px",
                borderRadius: "1px",
                position: "absolute",
                top: "0",
                left: "0",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out"
            });
            
            var block2 = document.createElement('div');
            block2.innerHTML = "&nbsp";
            animBlock.appendChild(block2);
            loadSetStyle(block2, {
                backgroundColor: clr2,
                width: "30px",
                height: "30px",
                borderRadius: "1px",
                position: "absolute",
                top: "0",
                left: "0",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + ((baseObj.duration / 4) * 1) + "s"
            });
            
            var block3 = document.createElement('div');
            block3.innerHTML = "&nbsp";
            animBlock.appendChild(block3);
            loadSetStyle(block3, {
                backgroundColor: clr3,
                width: "30px",
                height: "30px",
                borderRadius: "1px",
                position: "absolute",
                top: "0",
                left: "0",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + ((baseObj.duration / 4) * 2) + "s"
            });
            
            var block4 = document.createElement('div');
            block4.innerHTML = "&nbsp";
            animBlock.appendChild(block4);
            loadSetStyle(block4, {
                backgroundColor: clr4,
                width: "30px",
                height: "30px",
                borderRadius: "1px",
                position: "absolute",
                top: "0",
                left: "0",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + ((baseObj.duration / 4) * 3) + "s"
            });
            
            elemObj.loader = true;
        } else if (baseObj.type == "zCircle1") {
            
            if (!ZCloader.zCircle1) {
                var animString = "\n@" + browser.cssPrefix + "keyframes " + baseObj.type + " { ";
                animString += "0% ,25%, 50%, 75%, 100%{ " + browser.cssPrefix + "transform: scale(0.0);  } ";
                animString += "12.5%  { " + browser.cssPrefix + "transform: scale(1.0); background-color: " + clr1 + ";}";
                animString += "37.5%  { " + browser.cssPrefix + "transform: scale(1.0); background-color: " + clr2 + ";}";
                animString += "62.5%  { " + browser.cssPrefix + "transform: scale(1.0); background-color: " + clr3 + ";}";
                animString += "87.5%  { " + browser.cssPrefix + "transform: scale(1.0); background-color: " + clr4 + ";} }\n";
                style.innerHTML += animString;
                
                ZCloader.zCircle1 = true;
            }
            
            loadSetStyle(animBlock, {
                display: "inline-block",
                verticalAlign: "middle",
                width: "70px",
                height: "70px",
                transform: "scale(" + baseObj.scale + ")"
            });
            
            var circle = document.createElement('div');
            circle.innerHTML = "&nbsp";
            animBlock.appendChild(circle);
            loadSetStyle(circle, {
                width: "100%",
                height: "100%",
                borderRadius: "50%",
                opacity: "0.6",
                position: "absolute",
                top: "0",
                left: "0",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out"
            });
            
            elemObj.loader = true;
        } else if (baseObj.type == "zBars") {
            
            if (!ZCloader.zBars) {
                
                var animString = "\n@" + browser.cssPrefix + "keyframes " + baseObj.type + " { ";
                animString += "0%, 40%, 100% { " + browser.cssPrefix + "transform: scaleY(0.4) }";
                animString += "20% { " + browser.cssPrefix + "transform: scaleY(1.0) } }\n";
                style.innerHTML += animString;
                
                ZCloader.zBars = true;
            }
            
            loadSetStyle(animBlock, {
                display: "inline-block",
                verticalAlign: "middle",
                width: "50px",
                height: "30px",
                textAlign: "center",
                fontSize: "10px",
                transform: "scale(" + baseObj.scale + ")"
            });
            
            
            var bar1 = document.createElement('div');
            bar1.innerHTML = "&nbsp";
            animBlock.appendChild(bar1);
            loadSetStyle(bar1, {
                backgroundColor: clr1,
                marginLeft: "1px",
                display: "inline-block",
                width: "6px",
                height: "100%",
                borderRadius: "1px",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out"
            });
            
            var bar2 = document.createElement('div');
            bar2.innerHTML = "&nbsp";
            animBlock.appendChild(bar2);
            loadSetStyle(bar2, {
                backgroundColor: clr2,
                marginLeft: "1px",
                display: "inline-block",
                width: "6px",
                height: "100%",
                borderRadius: "1px",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + (baseObj.duration - 0.1) + "s"
            });
            
            var bar3 = document.createElement('div');
            bar3.innerHTML = "&nbsp";
            animBlock.appendChild(bar3);
            loadSetStyle(bar3, {
                backgroundColor: clr3,
                marginLeft: "1px",
                display: "inline-block",
                width: "6px",
                height: "100%",
                borderRadius: "1px",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + (baseObj.duration - 0.2) + "s"
            });
            
            var bar4 = document.createElement('div');
            bar4.innerHTML = "&nbsp";
            animBlock.appendChild(bar4);
            loadSetStyle(bar4, {
                backgroundColor: clr4,
                marginLeft: "1px",
                display: "inline-block",
                width: "6px",
                height: "100%",
                borderRadius: "1px",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + (baseObj.duration - 0.3) + "s"
            });
            
            elemObj.loader = true;
        } else if (baseObj.type == "zCircle2") {
            
            if (!ZCloader.zCircle2) {
                
                var animString = "\n@" + browser.cssPrefix + "keyframes " + baseObj.type + " { ";
                animString += "0%, 80%, 100% { " + browser.cssPrefix + "transform: scale(0.0) }";
                animString += "40% { " + browser.cssPrefix + "transform: scale(1.0) } }\n";
                style.innerHTML += animString;
                
                ZCloader.zCircle2 = true;
            }
            
            loadSetStyle(animBlock, {
                display: "inline-block",
                verticalAlign: "middle",
                width: "72px",
                height: "18px",
                textAlign: "center",
                fontSize: "10px",
                transform: "scale(" + baseObj.scale + ")"
            });
            
            
            var circ1 = document.createElement('div');
            circ1.innerHTML = "&nbsp";
            animBlock.appendChild(circ1);
            loadSetStyle(circ1, {
                backgroundColor: clr1,
                display: "inline-block",
                width: "18px",
                height: "18px",
                borderRadius: "100%",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out"
            });
            
            var circ2 = document.createElement('div');
            circ2.innerHTML = "&nbsp";
            animBlock.appendChild(circ2);
            loadSetStyle(circ2, {
                backgroundColor: clr2,
                display: "inline-block",
                width: "18px",
                height: "18px",
                borderRadius: "100%",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + (baseObj.duration - 0.2) + "s"
            });
            
            var circ3 = document.createElement('div');
            circ3.innerHTML = "&nbsp";
            animBlock.appendChild(circ3);
            loadSetStyle(circ3, {
                backgroundColor: clr3,
                display: "inline-block",
                width: "18px",
                height: "18px",
                borderRadius: "100%",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + (baseObj.duration - 0.4) + "s"
            });
            
            var circ4 = document.createElement('div');
            circ4.innerHTML = "&nbsp";
            animBlock.appendChild(circ4);
            loadSetStyle(circ4, {
                backgroundColor: clr4,
                display: "inline-block",
                width: "18px",
                height: "18px",
                borderRadius: "100%",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "ease-in-out",
                animationDelay: "-" + (baseObj.duration - 0.6) + "s"
            });
            
            elemObj.loader = true;
        } else if (baseObj.type == "zCrossBars") {
            
            if (!ZCloader.zCrossBars) {
                
                var animString = "\n@" + browser.cssPrefix + "keyframes " + baseObj.type + " { ";
                animString += "0%{left:-50%;}";
                animString += "100%{left: 150%;} }\n";
                style.innerHTML += animString;
                
                ZCloader.zCrossBars = true;
                
            }
            
            loadSetStyle(animBlock, {
                display: "inline-block",
                position: "relative",
                verticalAlign: "middle",
                width: "70px",
                height: "30px",
                boxSizing: "border-box",
                borderWidth: "2px",
                borderStyle: "solid",
                borderColor: "rgb(160, 150, 150)",
                borderRadius: "8px",
                overflow: "hidden",
                transform: "scale(" + baseObj.scale + ")"
            });
            
            var bar1 = document.createElement('div');
            bar1.innerHTML = "&nbsp";
            animBlock.appendChild(bar1);
            loadSetStyle(bar1, {
                backgroundColor: clr1,
                width: "10px",
                height: "100%",
                position: "absolute",
                transform: "rotate(45deg) scaleY(2)",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "linear",
                animationDelay: "-" + (baseObj.duration) + "s"
            });
            
            var bar2 = document.createElement('div');
            bar2.innerHTML = "&nbsp";
            animBlock.appendChild(bar2);
            loadSetStyle(bar2, {
                backgroundColor: clr2,
                width: "10px",
                height: "100%",
                position: "absolute",
                transform: "rotate(45deg) scaleY(2)",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "linear",
                animationDelay: "-" + ((baseObj.duration / 100) * 80) + "s"
            });
            
            var bar3 = document.createElement('div');
            bar3.innerHTML = "&nbsp";
            animBlock.appendChild(bar3);
            loadSetStyle(bar3, {
                backgroundColor: clr3,
                width: "10px",
                height: "100%",
                position: "absolute",
                transform: "rotate(45deg) scaleY(2)",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "linear",
                animationDelay: "-" + ((baseObj.duration / 100) * 60) + "s"
            });
            
            var bar4 = document.createElement('div');
            bar4.innerHTML = "&nbsp";
            animBlock.appendChild(bar4);
            loadSetStyle(bar4, {
                backgroundColor: clr4,
                width: "10px",
                height: "100%",
                position: "absolute",
                transform: "rotate(45deg) scaleY(2)",
                animationName: baseObj.type,
                animationDuration: baseObj.duration + "s",
                animationIterationCount: "infinite",
                animationTimingFunction: "linear",
                animationDelay: "-" + ((baseObj.duration / 100) * 40) + "s"
            });
            
            elemObj.loader = true;
        } else {
            
            loadSetStyle(animBlock, {
                display: "inline-block",
                verticalAlign: "middle",
                width: "30px",
                height: "30px",
                position: "absolute",
                backgroundImage: "url('" + $ZC.imageFilePath + "loader_" + baseObj.type + ".gif')",
                backgroundSize: "30px 30px",
                backgroundRepeat: "no-repeat",
                backgroundPosition: "center"
            });
        }
        
        // elemObj.stopLoader = function() {
        //     elemObj.removeChild(animBlock);
        //     elemObj.loader = false;
        //     delete elemObj.stopLoader;
        // }
        return animBlock;
    }
};//$Id$
$ZC.zo = function(userProp) {
    // $ZCG.calcfontSize(denominator);
    var zoTheme = {
        
        "canvas": {
            "title": {
                "marginBottom": 10,
                "fontColor": "#23a96e",
                "fontSize": 16,
                "fontFamily": "Roboto",
                "textShadow": "1px 1px 1px rgba(0,0,0,0.2)"
            },
            "subtitle": {
                "show": false,
                "text": "description",
                "hAlign": "center",
                "fontColor": "#CCCCCC"
            },
            "background": {
                "color": "#2e2f31"
            },
            "border": {
                "show": false,
                "size": 1,
                "style": "solid",
                "radius": 0,
                "color": "#b0b7b9"
            },
            "shadow": {
                "x": 0,
                "y": 0
            },
        },
        "chart": {
            "axes": {
                "xaxis": {
                    "label": {
                        "fontColor": "#979797",
                        "fontFamily": null
                    },
                    "ticklabel": {
                        "fontColor": "#979797",
                        "fontFamily": null
                    },
                    "tickmark": {
                        "color": "#3d3e40",
                        "size": 6
                    },
                    "axisline": {
                        "color": "#3d3e40"
                    }
                },
                "yaxis": [{
                    "label": {
                        "fontColor": "#979797",
                        "fontFamily": null
                    },
                    "grid": {
                        "color": "#3d3e40"
                    },
                    "ticklabel": {
                        "fontColor": "#979797",
                        "fontFamily": null
                    },
                    "tickmark": {
                        "color": "#3d3e40",
                        "size": 6
                    },
                    "axisline": {
                        "color": "transparent"
                    },
                    "threshold": {
                        "line": {
                            "label": {
                                "hAlign": "right",
                                "fontFamily": null,
                                "fontSize": "12",
                                "fontColor": "black"
                            }
                        },
                        "range": {
                            "fillColor": "grey",
                            "fillOpacity": 0.2,
                            "strokeColor": "black"
                        }
                    }
                }]
            },
            "plot": {
                "plotoptions": {
                    "bar": {
                        "levelMarker": {
                            "color": "rgba(0,0,0,0.2)"
                        },
                        "datalabels": {
                            "show": false
                        }
                    }
                }
            }
        },
        "legend": {
            "fontColor": "#7b7d7e",
            "colorPallete": {
                "options": {
                    "multicolor": "flat-ui-colors"
                }
            }
        },
        "loader": {
            "type": "zBars",
            "enabled": true
        }
        
    };
    return zoTheme;
};//$Id$
;
canvas_plot_renderer.bar = function() {
    
    var commonRendererProp, bandwidth1, bandwidth2, yscale, barDatasetIndex,
        shiftInfo;
    
    function chart(context, seriesdata, effect, filterIndex) {
        var rp = commonRendererProp.params,
            chartObj = rp.chartObj,
            xscale = rp.xscale,
            stacked = rp.stacked,
            index = rp.datasetIndex,
            axisrotated = rp.axisrotated,
            commonPlotOptions = rp.commonPlotOptions,
            color = rp.color,
            labelQueue = rp.labelQueue,
            hasNegValue = rp.hasNegValue,
            yaxiscolumnorder = rp.yaxiscolumnorder,
            dataset = rp.dataset,
            systemconf = chartObj.systemConf,
            plotarea = chartObj.plotarea,
            dataObject = chartObj.dataObject;
            // categories = xscale.domain();
            // categories = chartObj.dataObject.getCategories("x");

        if (!bandwidth1 || !bandwidth2) { //Test_515.json (Combinational chart(bar + line) where all the bar series are disabled)
            isredraw = true;
            chart.chartRendered = true;
            return;
        }

        yscale = rp.yscale;
        var datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

            xCategories = xscale.domain(),
            yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

            categories = defined(dataObject.hierarchical) ? dataObject.getCategories("x") : xCategories;

        var charttype = chartObj.chartTypes[index].name;
        var gradientDim = null//[w,h];
        var yAxisReversed = chartObj.systemConf.chart.axes.yaxis[yaxiscolumnorder || 0].reversed;

        var plotoptions = seriesdata.plotoptions;
        var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions),
            isBullet = chartObj.chartTypes[index].value === $ZC.charttype.bullet;

        var levelMarker = (plotoptions && plotoptions.levelMarker) ? mergeJSON(commonPlotOptions.levelMarker, plotoptions.levelMarker, true) : commonPlotOptions.levelMarker,
            borderOptions = (plotoptions && plotoptions.border) ? mergeJSON(commonPlotOptions.border, plotoptions.border, true) : commonPlotOptions.border;
        var multiColoring = isTrue(gvp("multiColoring") || false) && !chartObj.legendarea.show,
            hasColorScale = colorscale_helpers.isQuantileColorScale(chartObj);

        var fillStyle = chart.fillColorFunc = getFillColor(chartObj, index, gradientDim),
            strokeColor = getStrokeColor(chartObj, index);
        
        var fillOpacity = gvp("fillOpacity"),
            getParamValue = chart.getParamValue = function() {
                return chartObj.dataObject.getTransRectValue.apply(chartObj.dataObject, toArray(arguments));
            };
        
        var commonOption = getBarCommonOption(chartObj.rendererConf[index], index);
        var levelMarkerWidth = commonOption.levelMarkerWidth,
            levelMarkerPadding = commonOption.levelMarkerPadding;
        levelMarker.overlayRange = "below";
        var levelMarkerColor = levelMarker.color; //Saving the levelMarker colors, helps in multi categories bullet if each categories dont have same no of levels
        
        var borderRadius = {
            tlx: 0,
            tly: 0,
            trx: 0,
            trY: 0,
            brx: 0,
            bry: 0,
            blx: 0,
            bly: 0
        };
        var borderSize = 0,
            borderColor = null,
            borderStyle = null,
            radius = 0;
        if (defined(borderOptions) && isTrue(borderOptions.show)) {
            borderSize = defined(borderOptions.size) ? borderOptions.size : 1;
            borderColor = borderOptions.color;
            borderStyle = borderOptions.style;
            radius = borderOptions.radius;
            borderRadius = getParamValue("radius", null, null, null, commonOption, radius);
        }
        
        var dashStyle = getDashArray(borderStyle, (borderSize == null ? 2 : borderSize));

        
        
        var legend_data = systemconf.legend;
        var rounded = isRounded(borderRadius),
            patternName = legend_data.patternPallete,
            patternPallete = legend_data.patternPallete,
            rgba = canvasUtils.rgba;
        
        //STACKED BAR : for which series the level marker should be drawn
        var isLevelMarkerIndex;
        if (stacked && levelMarker.enabled && !defined(effect)) {
            var stackGroup = chartObj.userdata.seriesdata.stackGroup,
                groupedByStack = chartObj.dataObject.groupedByStack;
            var actualStackGroupIndex = (stackGroup) ? getStackGroupIndex(index, stackGroup) : 0;
            isLevelMarkerIndex = groupedByStack.has(actualStackGroupIndex) && (groupedByStack.get(actualStackGroupIndex)[0].si == index);
        }
        
        if (!seriesdata.disabled) {
            chart.seriesdataAfterUpdate = [];
            seriesdata.data.forEach(function(data, i) {
                
                var dataUpdate = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(data), xCategories, yCategories, yaxiscolumnorder);

                if (chartObj.systemConf.chart.axes.xaxis.reversed) {
                    dataUpdate = dataUpdate.slice(0).reverse();
                }

                if (hasColorScale && defined(effect)) {
                    dataUpdate = legend_helpers.filterSelectionByColor(dataUpdate, true, filterIndex, chartObj);
                }
                chart.seriesdataAfterUpdate[i] = dataUpdate;

                dataUpdate.forEach(function(d, j) {
                    var x, y, w, h, gradient,
                        fillColor = getRawColor(chartObj, (multiColoring ? j : index), d, index);
                    
                    if (levelMarker.enabled && !defined(effect)) {
                        if ((stacked && isLevelMarkerIndex && i === 0) || !stacked) {
                            var level = d[levelMarker.dataindex] || [],
                                hasLevels = defined(levelMarker.dataindex),
                                min,
                                max;
                            if (level != null && !(level instanceof Array)) { //If level marker is a single value and in non-array format, make it as array
                                level = [level];
                            }
                            
                            if (hasLevels && !level.length) {
                                min = max = 0;
                            } else {
                                min = d3_min(level);
                                max = d3_max(level);
                            }
                            
                            var v = dataset.getX(d);
                            x = (stacked ? (bandwidth1(v) + (bandwidth2(commonOption.stackGroupIndex) || 0)) : bandwidth1(v) + bandwidth2(barDatasetIndex + i)) + levelMarkerPadding;
                            y = hasLevels ? (axisrotated ? yscale(mathMin(0, min)) : yscale(mathMax(0, max))) : ((axisrotated && (hasNegValue != null)) ? yscale(hasNegValue) : 0);
                            w = (axisrotated) ? (hasLevels ? (yscale(mathMax(0, max)) - yscale(mathMin(0, min))) : ((hasNegValue != null) ? (plotarea.width - yscale(hasNegValue)) : plotarea.width)) : levelMarkerWidth;
                            h = (axisrotated) ? levelMarkerWidth : (hasLevels ? (yscale(mathMin(0, min)) - yscale(mathMax(0, max))) : ((hasNegValue != null) ? yscale(hasNegValue) : plotarea.height));
                            
                            context.save();
                            context.beginPath();
                            context.fillStyle = getBulletLevelMarkerGradient(d, levelMarker, chartObj, fillColor, levelMarkerColor) || rgba(((isArray(levelMarker.color) ? levelMarker.color[0] : levelMarker.color) || fillColor), levelMarker.fillOpacity);
                            (axisrotated) ? canvasUtils.roundedRect(context, y, x, w, h, borderRadius): canvasUtils.roundedRect(context, x, y, w, h, borderRadius);
                            context.fill();
                            context.closePath();
                            context.restore();
                        }
                    }

                    x = getParamValue("x", d, i, j, commonOption);
                    y = getParamValue("y", d, i, j, commonOption);
                    w = getParamValue("width", d, i, j, commonOption);
                    h = getParamValue("height", d, i, j, commonOption);
                    
                    if (yAxisReversed) {
                        if (axisrotated) {
                            x = x - w
                        } else {
                            y = y - h;
                        }
                    }
                    gradientDim = [w,h];

                    var drawBarFunction = function(context, fillStyle){
                        context.save();
                        context.translate(x, y);
                        context.strokeStyle = rgba(fillColor, fillOpacity);
                        context.fillStyle = fillStyle;
                        if (rounded) {
                            context.beginPath();
                            canvasUtils.roundedRect(context, 0, 0, w, h, borderRadius);
                            context.fill();
                        } else {
                            context.beginPath();
                            context.rect(0, 0, w, h);
                            context.fill();
                        }
                        setBorder(context, borderSize, borderColor || fillColor, dashStyle);
                        context.closePath();
                        context.restore();
                    };

                    if(chartObj.imagePallete){
                        canvas_patterns.imageFill({x:x,y:y,width:w,height:h,context:context,name:chartObj.imagePallete[(multiColoring ? j : index)]},drawBarFunction);
                    }else{
                        var fillStyle;
                        if (hasColorScale && defined(effect)) {
                            fillStyle = effect(getRawColor(chartObj, index, d, index), fillOpacity);
                        } else {
                            fillStyle = defined(effect) ? effect : chart.fillColorFunc((multiColoring ? j : index), d, null, null, fillOpacity,gradientDim,{x:x,y:y,width:w,height:h,context:context}, false);
                        }
                        drawBarFunction(context, fillStyle);
                    }

                });
            });
            
        }
        labelQueue.push({
            "renderer": chart,
            "charttype": "bar",
            "chartObj": chartObj,
            "args": [seriesdata, index]
        });
        
        chart.chartRendered = true;
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    chart.bandwidth1 = function(_) {
        if (!arguments.length) {
            return bandwidth1;
        }
        bandwidth1 = _;
        return chart;
    };
    chart.bandwidth2 = function(_) {
        if (!arguments.length) {
            return bandwidth2;
        }
        bandwidth2 = _;
        return chart;
    };
    chart.barDatasetIndex = function(_) {
        if (!arguments.length) {
            return barDatasetIndex;
        }
        barDatasetIndex = _;
        return chart;
    };

    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    
    function isRounded(radius) {
        for (var l in radius) {
            if (radius.hasOwnProperty(l)) {
                return !!radius[l];
            }
        }
        return false;
    }

    function setBorder(context, size, color, dashStyle) {
        if (size > 0) {
            context.lineWidth = size;
            if (isArray(dashStyle) && dashStyle.length && defined(context.setLineDash)) {
                context.setLineDash(dashStyle);
            }
            context.strokeStyle = color;
            context.stroke();
        }
    }
    return chart;
};//$Id$
canvas_plot_renderer.scatter = function() {
    var shiftInfo, commonRendererProp, yrangePos,
        dataProcessorHelpers = $ZC.DataProcessor.helpers;

    function chart(context, seriesData, pattern, filterIndex) {
        
        var rp = commonRendererProp.params,
            chartObj = rp.chartObj,
            xscale = rp.xscale,
            yscale = rp.yscale,
            stacked = rp.stacked,
            index = rp.datasetIndex,
            axisrotated = rp.axisrotated,
            commonPlotOptions = rp.commonPlotOptions,
            color = rp.color,
            labelQueue = rp.labelQueue,
            yaxiscolumnorder = rp.yaxiscolumnorder,
            dataset = rp.dataset,
            threshold = rp.threshold;

        var plotoptions = seriesData.plotoptions || {},
            cpOptions = plotoptions ? mergeJSON(commonPlotOptions, plotoptions, true) : commonPlotOptions,
            currentseriesdata = seriesData.data,
            temp = chartObj.chartTypes[index],
            chartType = temp.value,
            chartName = temp.name,
            scatterOrBubble = (chartType == 12 || chartType == 20),
            isBubbleChart = (chartType == 20),
            seriesColors = chartObj.seriesColor,
            legend_data = chartObj.systemConf.legend;

        var markerOptions = cpOptions.marker,
            symboltype = markerOptions.symbol || "circle",
            symbolsize = markerOptions.size,
            multiColoring = scatterOrBubble && chartObj.legendarea.show === false && cpOptions.multiColoring === true,
            patternPallete = legend_data.patternPallete,
            patternPallete = legend_data.patternPallete,
            hasColorScale = colorscale_helpers.isQuantileColorScale(chartObj);

        if (!scatterOrBubble) {
            if(!defined(symbolsize)) {
                symbolsize = pick(cpOptions.strokeWidth, 2);
            }
            symbolsize *= 0.8;
            color = pick(seriesData.color, chartObj.seriesColor[index % chartObj.seriesColor.length]);
            
        } else {
            symbolsize = pick(symbolsize, 1);
        }
        
        var outerSize = symbolsize * 5,
            outerFillOpacity = markerOptions.outerFillOpacity,
            outerStrokeOpacity = markerOptions.outerStrokeOpacity,
            innerFillOpacity = markerOptions.innerFillOpacity,
            innerStrokeOpacity = markerOptions.innerStrokeOpacity,
            outerStrokeWidth = pick(markerOptions.outerStrokeWidth, 1),
            innerStrokeWidth = pick(markerOptions.innerStrokeWidth, 1),
            outerStrokeColor = pick(markerOptions.outerStrokeColor, color),
            innerStrokeColor = pick(markerOptions.innerStrokeColor, color),
            outerFillColor = pick(markerOptions.outerFillColor, color),
            innerFillColor = pick(markerOptions.innerFillColor, color),
            outerDashArray = getDashArray(markerOptions.outerDashStyle, outerStrokeWidth),
            innerDashArray = getDashArray(markerOptions.innerDashStyle, innerStrokeWidth),
            outerStrokeLineCap = getLineCap(markerOptions.outerLineCap, markerOptions.outerDashStyle),
            innerStrokeLineCap = getLineCap(markerOptions.innerLineCap, markerOptions.innerDashStyle);
        
        if (defined(pattern)) {
            outerStrokeWidth = pattern["stroke-width"];
        }
        
        var rgba = canvasUtils.rgba;
        if (defined(outerFillOpacity) && outerFillColor) {
            outerFillColor = rgba(outerFillColor, outerFillOpacity);
        }
        if (defined(outerStrokeOpacity) && outerStrokeColor) {
            outerStrokeColor = rgba(outerStrokeColor, outerStrokeOpacity);
        }
        if (defined(innerFillOpacity) && innerFillColor) {
            innerFillColor = rgba(innerFillColor, innerFillOpacity);
        }
        if (defined(innerStrokeOpacity) && innerStrokeColor) {
            innerStrokeColor = rgba(innerStrokeColor, innerStrokeOpacity);
        }

        function getSymbolSize(d) {
            return chartType !== $ZC.charttype.stkdarea && (isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder))) ?
                0 :
                isBubbleChart ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "z", chartObj.zscale, yrangePos) / 2 : outerSize;
        }
        
        // function getGradients(color, opacity, size) {
        //     if (scatterOrBubble) {
        //         var gradientDim = [size, size],
        //             args = {"offset":"scatter", "dimension":gradientDim,"chartObj":chartObj},
        //             prop =  getGradientProp(cpOptions.gradients,gradientDim,(strokeColor || chartObj.seriesColor[index % chartObj.seriesColor.length]),opacity)
        //         var gradientID = effects.get(canvas_gradients, "canvasGradientFill", prop, args);
        //         if (gradientID) {
        //             return gradientID;
        //         }else{
        //             return rgba(color, opacity);
        //         }
        //     }
        //     return rgba(color, opacity);
        // }
        
        // function getColorOverlay(d, i, customColor, color) {
        //     if (customColor) {
        //         return customColor;
        //     } else if (defined(threshold)) {
        //         return getRawColor(chartObj, i, d, index) ;
        //     }
        //     return color;
        // }
        
        // function getMulticolor(index) {
        //     if (multiColoring === true) {
        //         return seriesColors[index % seriesColors.length]
        //     }
        //     return color;
        // }
        
        var useCache = !defined(threshold) && !multiColoring &&(chartName === "scatter" || chartName === "line" || chartName === "area") && !patternPallete && !patternPallete && !colorscale_helpers.isQuantileColorScale(chartObj),
            cache;

        var fillColor = chart.fillColorFunc = getFillColor(chartObj, index, null, !scatterOrBubble),
            strokeColor = getStrokeColor(chartObj, index),

            innerFillColorFunc = getFillColor(chartObj, index, null, true);

        if (useCache) {
            fillStyle = chart.fillColorFunc((0),  null ,null, outerFillColor, null, scatterOrBubble ? [outerSize,outerSize] : null, false);
            //getGradients(outerFillColor, outerFillOpacity, outerSize);
            cache = canvas_plot_renderer.scatter.getCache(symboltype, outerSize, outerStrokeColor, outerStrokeWidth, fillStyle, innerStrokeColor, innerStrokeWidth, innerFillColor, markerOptions);
            var adjust = cache.adjustPosition,
                cacheCanvas = cache.canvas,
                drawWidth = cache.width;
        }
        var usePatternPallete = scatterOrBubble;
        

        if (!seriesData.disabled) {
            
            var datatypeX = chartObj.dataset.getDataType("x"),
                datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

                isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
                isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),

                xCategories = (datatypeX == ORDINAL_DATATYPE) ? xscale.domain() : null,
                yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

                categories = (datatypeX == ORDINAL_DATATYPE && xscale.domain != null && !defined(chartObj.dataObject.hierarchical)) ? xCategories : chartObj.dataObject.getCategories("x"),
                fillStyle, strokeStyle;
            chart.seriesdataAfterUpdate = [];
            
            currentseriesdata.forEach(function(data, j) {

                var dataUpdate;
                if (datatypeX == ORDINAL_DATATYPE || datatypeY == ORDINAL_DATATYPE) {
                    dataUpdate = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(data), xCategories, yCategories, yaxiscolumnorder);
                } else {
                    dataUpdate = data;
                }

                chart.seriesdataAfterUpdate[j] = dataUpdate;

                if (hasColorScale && defined(pattern)) {
                    dataUpdate = legend_helpers.filterSelectionByColor(dataUpdate, true, filterIndex, chartObj);
                }

                dataUpdate.forEach(function(d, i) {

                    var outerFillStyle, outerStrokeStyle;
                    
                    if (!(d.isDummy || isCatNullX(dataset.getX(d)) || isCatNullY(dataset.getY(d, yaxiscolumnorder))) || chartType === $ZC.charttype.stkdarea) {
                        
                        var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x"),
                            y = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y"),
                            size = getSymbolSize(d);
                        
                        if (useCache) {
                            // using cache image
                            context.beginPath();
                            var centered = size + (outerStrokeWidth / 2) + adjust;
                            context.drawImage(cacheCanvas, x - centered, y - centered, drawWidth - 1, drawWidth - 1);
                            context.closePath();
                        } else {
                            
                            // don't use cache in case of bubble, multicolor and colorOverlay.
                            // var multicolor = getMulticolor(i);

                            // outer circle
                            if ((outerFillColor || outerStrokeColor)) {
                                // fillStyle = getColorOverlay(value, markerOptions.outerFillColor || multicolor);
                                // fillStyle = svgPallete ? fillStyle : getGradients(fillStyle, outerFillOpacity, size);
                                // strokeStyle = getColorOverlay(value, markerOptions.outerStrokeColor || multicolor);
                                // outerFillStyle = chart.fillColorFunc((multiColoring ? i : index),  value ,null, outerFillColor, null,[size,size], false);
                                strokeClr = strokeColor((multiColoring ? i : index),  d, (chartObj.imagePallete ? null : markerOptions.outerStrokeColor));
                                outerStrokeStyle = rgba(strokeClr, outerStrokeOpacity)
                                // outerFillStyle = fillStyle;
                                // outerStrokeStyle = strokeStyle;

                                // canvas_plot_renderer.scatter.drawPath(symboltype, context, x, y, size, outerStrokeWidth, outerStrokeStyle, outerFillStyle, outerDashArray, outerStrokeLineCap);

                                var drawScatterFunction = function (context, fillStyle) {
                                    // context.fillStyle = fillStyle;
                                    canvas_plot_renderer.scatter.drawPath(symboltype, context, x, y, size, outerStrokeWidth, outerStrokeStyle, fillStyle, outerDashArray, outerStrokeLineCap);
                                };

                                if(chartObj.imagePallete){
                                    canvas_patterns.imageFill({x:x,y:y,context:context,name:chartObj.imagePallete[(multiColoring ? i : index)]},drawScatterFunction);
                                }else{
                                    var fillStyle = chart.fillColorFunc((multiColoring ? i : index),  d ,null, markerOptions.outerFillColor, outerFillOpacity, scatterOrBubble ? [size,size] : null, false);
                                    drawScatterFunction(context, fillStyle);
                                }

                                // if (defined(patternPallete)) {
                                //     var p = $ZC.legutil.patternPallete.get(patternPallete),
                                //         url = p[index % p.length];
                                //     canvasUtils.fillImagePattern(context, drawScatterFunction, url);
                                // } else if (svgPallete && svgPallete.length) {
                                //     var url = svgPallete[index % svgPallete.length];
                                //     canvasUtils.fillSVGPattern(context, drawScatterFunction, url, fillStyle);
                                // } else {
                                //     drawScatterFunction(context);
                                // }
                            }
                            
                            // inner circle
                            if (!(isBubbleChart && cpOptions.gradients.type && cpOptions.gradients.type !== "none") && (innerFillColor || innerStrokeColor)) {
                                fillStyle = innerFillColorFunc((multiColoring ? i : index),  d ,null, markerOptions.innerFillColor, innerFillOpacity, null, false);
                                strokeStyle = rgba(strokeColor((multiColoring ? i : index),  d, (chartObj.imagePallete ? null : markerOptions.innerStrokeColor)), innerStrokeOpacity);
                                
                                canvas_plot_renderer.scatter.drawPath(symboltype, context, x, y, size / 2, innerStrokeWidth, strokeStyle, fillStyle, innerDashArray, innerStrokeLineCap);
                            }
                        }
                    }
                });
            });
        }
        
        if (defined($ZC.labelRenderer)) {
            var markerSize;
            if (scatterOrBubble) {
                markerSize = (outerSize * 2) + markerOptions.outerStrokeWidth;
            } else {
                var strokeWidth = pick(cpOptions.strokeWidth, 2);
                markerSize = pick(markerOptions.size, strokeWidth) * outerSize + (strokeWidth / 2);
            }
            labelQueue.push({
                "renderer": chart,
                "charttype": "scatter",
                "chartObj": chartObj,
                "args": [seriesData, index, markerSize, yrangePos]
            });
        }
        chart.chartRendered = true;
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    
    chart.yrangePos = function(_) {
        if (!arguments.length) {
            return yrangePos;
        }
        yrangePos = _;
        return chart;
    };
    
    return chart;
};

/**
 * @param {String} symbol
 * @param {CanvasRenderingContext2D} context
 * @param {Number} x
 * @param {Number} y
 * @param {Number} size
 * @param {Number} strokeWidth
 * @param {String} strokeColor
 * @param {String} fillColor
 */

canvas_plot_renderer.scatter.drawPath = function(symbol, context, x, y, size, strokeWidth, strokeColor, fillColor, strokeDashArray, strokeLineCap) {
    
    context.save();
    context.translate(x, y);
    context.beginPath();
    context.lineWidth = strokeWidth;
    context.strokeStyle = strokeColor;
    context.fillStyle = fillColor;

    if (symbol === "circle") {
        context.arc(0, 0, size, 0, mathPI * 2);
    } else {
        var path = getSVGsymbol(symbol)(size * 2);
        canvasUtils.drawPath(context, path);
    }
    if (fillColor) {
        context.fill();
    }

    if (strokeDashArray && strokeDashArray.length && typeof strokeDashArray === "object" && defined(context.setLineDash)) {
        context.setLineDash(strokeDashArray);
        context.lineCap = strokeLineCap;
    }

    if (strokeWidth && strokeColor) {
        context.stroke();
    }
    context.closePath();
    context.restore();      
};

/**
 * osc, osw, ofc, isc, isw, ifc - params
 * o - outer
 * i - inner
 * s - stroke
 * f - fill
 * c - color
 * w - width
 * ----
 * @param {String} symbol
 * @param {Number} outerSize
 * @param {String} osc
 * @param {Number} osw
 * @param {String} ofc
 * @param {String} isc
 * @param {Number} isw
 * @param {String} ifc
 */

canvas_plot_renderer.scatter.getCache = function(symbol, outerSize, osc, osw, ofc, isc, isw, ifc, markerOptions) {
    var adjustPosition = 10, // to remove the sharp edge
        scaleRatio = pick(window.devicePixelRatio * 1.5, 1.5),
        cacheCanvas = document.createElement("canvas"),
        tempPos = ((outerSize + (osw / 2)) * scaleRatio) + adjustPosition / 2,
        cache = cacheCanvas.getContext("2d"),
        canvasDimension = (outerSize * 2 + osw + adjustPosition) * scaleRatio,
        width = canvasDimension / scaleRatio;
    cacheCanvas.height = cacheCanvas.width = canvasDimension;
    // outer symbol
    this.drawPath(symbol, cache, tempPos, tempPos, outerSize * scaleRatio, osw * scaleRatio, osc, ofc, getDashArray(markerOptions.outerDashStyle, osw, scaleRatio), getLineCap(markerOptions.outerLineCap, markerOptions.outerDashStyle));
    // inner symbol
    this.drawPath(symbol, cache, tempPos, tempPos, (outerSize / 2) * scaleRatio, isw * scaleRatio, isc, ifc, getDashArray(markerOptions.innerDashStyle, isw, scaleRatio), getLineCap(markerOptions.innerLineCap, markerOptions.innerDashStyle));
    
    return {
        canvas: cache.canvas,
        width: width,
        adjustPosition: (adjustPosition / 2) / scaleRatio
    };
};//$Id$
;
canvas_drawer.area = function() {
    "use strict";
    
    var x0 = canvasUtils.pointX,
        constant = canvasUtils.constant,
        x1 = null,
        y0 = constant(0),
        y1 = canvasUtils.pointY,
        defined = constant(true),
        context = null,
        curve = canvasInterpolation.linear,
        output = null;
    
    function area(data) {
        var i,
            j,
            k,
            n = data.length,
            d,
            defined0 = false,
            x0z = new Array(n),
            y0z = new Array(n);
        
        for (i = 0; i <= n; ++i) {
            if (!(i < n && defined(d = data[i], i, data)) === defined0) {
                if (defined0 = !defined0) {
                    j = i;
                    output.areaStart();
                    output.lineStart();
                } else {
                    output.lineEnd();
                    output.lineStart();
                    
                    for (k = i - 1; k >= j; --k) {
                        output.point(x0z[k], y0z[k]);
                    }
                    
                    output.lineEnd();
                    output.areaEnd();
                }
            }
            if (defined0) {
                x0z[i] = +x0(d, i, data), y0z[i] = +y0(d, i, data);
                output.point(x1 ? +x1(d, i, data) : x0z[i], y1 ? +y1(d, i, data) : y0z[i]);
            }
        }
    }
    
    area.x = function(_) {
        return arguments.length ? (x0 = typeof _ === "function" ? _ : constant(+_), x1 = null, area) : x0;
    };
    area.x0 = function(_) {
        x1 = _;
        return arguments.length ? (x0 = typeof _ === "function" ? _ : constant(+_), area) : x0;
    };
    area.x1 = function(_) {
        return arguments.length ? (x1 = _ == null ? null : typeof _ === "function" ? _ : constant(+_), area) : x1;
    };
    area.y = function(_) {
        return arguments.length ? (y0 = typeof _ === "function" ? _ : constant(+_), y1 = null, area) : y0;
    };
    area.y0 = function(_) {
        return arguments.length ? (y0 = typeof _ === "function" ? _ : constant(+_), area) : y0;
    };
    area.y1 = function(_) {
        return arguments.length ? (y1 = _ == null ? null : typeof _ === "function" ? _ : constant(+_), area) : y1;
    };
    area.defined = function(_) {
        return arguments.length ? (defined = typeof _ === "function" ? _ : constant(!!_), area) : defined;
    };
    area.interpolation = function(_) {
        _ = (canvasInterpolation[_]) ? canvasInterpolation[_] : canvasInterpolation.linear;
        return arguments.length ? (curve = _, context != null && (output = curve(context)), area) : curve;
    };
    area.context = function(_) {
        return arguments.length ? (_ == null ? context = output = null : output = curve(context = _), area) : context;
    };
    return area;
};//$Id$
canvas_plot_renderer.area = function() {
    var commonRendererProp, shiftInfo, shiftDiff, line = canvas_plot_renderer.line(),
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    
    function chart(context, seriesdata, pattern) {
        var rp = commonRendererProp.params,
            chartObj = rp.chartObj,
            xscale = rp.xscale,
            yscale = rp.yscale,
            stacked = rp.stacked,
            index = rp.datasetIndex,
            axisrotated = rp.axisrotated,
            commonPlotOptions = rp.commonPlotOptions,
            color = rp.color,
            labelQueue = rp.labelQueue,
            hasNegValue = rp.hasNegValue,
            yaxiscolumnorder = rp.yaxiscolumnorder,
            dataset = rp.dataset,
            systemconf = chartObj.systemConf;
        
        var plotoptions = seriesdata.plotoptions;
        var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions);
        var interpolation = gvp("mode"),
            fillOpacity = gvp("fillOpacity"),
            strokeWidth = gvp("strokeWidth"),
            strokeColor = gvp("strokeColor"),
            markerEnabled = defined(plotoptions) ? $ZC.utils.getValueOfPlotOptions(plotoptions.marker, commonPlotOptions.marker)("enabled") : commonPlotOptions.marker.enabled,
            borderEnabled = ((defined(strokeWidth) && strokeWidth != "" && pInt(strokeWidth) != 0) || (defined(strokeColor) && strokeColor != "") || (markerEnabled)),
            
            datatypeX = chartObj.dataset.getDataType("x"),
            datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

            isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
            isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),

            xCategories = (datatypeX == ORDINAL_DATATYPE) ? xscale.domain() : null,
            yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

            categories = (datatypeX == ORDINAL_DATATYPE && !defined(chartObj.dataObject.hierarchical)) ? xCategories : chartObj.dataObject.getCategories("x"),

            charttype = chartObj.chartTypes[index].name,
            isRangeChart = (charttype) == "arearange",
            yrangePos = (isRangeChart) ? 1 : null,
            
            gradientDim = [chartObj.plotarea.width, chartObj.plotarea.height],
            // gradientOptions = systemconf.chart.plot.plotoptions[charttype].gradients,
            // gradient = effects.get(canvas_gradients, gradientOptions.type, gradientOptions, "area" ,null, null, chartObj);
            // gradient = gradients.get(systemconf.chart.plot.plotoptions[charttype].gradients, color, gradientDim, "area", chartObj, fillOpacity),
            fillStyle = chart.fillColorFunc = getFillColor(chartObj, index, gradientDim),
            strokeColor = getStrokeColor(chartObj, index);
            // fillStyle = (color && /canvasGradient/ig.test(color.toString())) ? color : gradient || canvasUtils.rgba(color, fillOpacity);
        
        if (defined(pattern)) {
            fillStyle = pattern;
        }

        var legend_data = systemconf.legend;
        var imagePallete = legend_data.imagePallete,
            patternPallete = legend_data.patternPallete;
        

        if (!seriesdata.disabled) {
            
            chart.seriesdataAfterUpdate = [];
            seriesdata.data.forEach(function(d, i) {
                
                var serData;
                if (datatypeX == ORDINAL_DATATYPE || datatypeY == ORDINAL_DATATYPE) {
                    serData = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(d), xCategories, yCategories, yaxiscolumnorder);
                } else {
                    serData = d;
                }

                chart.seriesdataAfterUpdate[i] = serData;
                shiftDiff = (shiftInfo != null) ? (((shiftDiff == null) || (shiftDiff == 0)) ? chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 1], "x") -
                        chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 2], "x") : shiftDiff) : 0;
                var area = canvas_drawer.area();
                area.defined(function(d) {
                        if (stacked) {
                            return !isCatNullX(dataset.getX(d));
                        }
                        return !isCatNullY(dataset.getY(d, yaxiscolumnorder)) && !isCatNullX(dataset.getX(d));
                    })
                    .x(function(d) {
                        var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos);
                        if (isNaN(x) && defined(shiftInfo)) {
                            x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 1], "x", null, yrangePos) + shiftDiff;
                        }
                        return x;
                    })
                    .y(function(d) {
                        return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos);
                    })
                    .interpolation(interpolation);
                
                if (axisrotated) {
                    area.x1(function(d) {
                        if (stacked) {
                            return (index == 0) ? mathMax(yscale.range()[0], yscale(hasNegValue)) : yscale(d.y0);
                        } else {
                            if (isRangeChart) {
                                
                                return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, 0);
                            } else {
                                return (defined(yscale.rangeBand)) ? (yscale.range()[0] + yscale.rangeBand()) : mathMax(yscale.range()[0], yscale(hasNegValue));
                            }
                        }
                    })
                } else {
                    area.y1(function(d, i) {
                        if (stacked) {
                            return (index == 0 && i == 0) ? mathMin(yscale.range()[0], yscale(hasNegValue)) : yscale(d.y0);
                        } else {
                            if (isRangeChart) {
                                return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, 0);
                            } else {
                                return (defined(yscale.rangeBand)) ? (yscale.range()[0] + yscale.rangeBand()) : mathMin(yscale.range()[0], yscale(hasNegValue));
                            }
                        }
                    });
                }

                var drawAreaFunction = function (context, fillStyle) {
                    context.beginPath();
                    context.fillStyle = fillStyle;
                    area.context(context)(d);
                    context.fill();
                    context.restore();
                };
                // var args = {"offset":"area", "dimension":gradientDim},
                //     prop =  getGradientProp(commonPlotOptions.gradients,gradientDim,(strokeColor || chartObj.seriesColor[index % chartObj.seriesColor.length]),strokeOpacity),
                //     gradientID = (!isAreaChart ? effects.get(canvas_gradients, "canvasGradientFill", prop, args) || color : null);
                // context.strokeStyle = gradientID ? gradientID  : canvasUtils.rgba(strokeColor || color, strokeOpacity);

                if(chartObj.imagePallete){
                    canvas_patterns.imageFill({context:context,name:chartObj.imagePallete[index]},drawAreaFunction);
                }else{
                    var fillStyle = defined(pattern) ? pattern : chart.fillColorFunc(index, null, null, color, fillOpacity,gradientDim,null, false);
                    drawAreaFunction(context, fillStyle);
                }

            });
            
            if ((borderEnabled || markerEnabled) && !seriesdata.disabled) {
                line.chartRendered = false;
                line.commonRendererProp(commonRendererProp)
                    .shiftInfo(shiftInfo);
                line(context, seriesdata);
            }
        }
        
        if (defined($ZC.labelRenderer) && (!(borderEnabled || markerEnabled))) {
            if (isRangeChart) {
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "scatter",
                    "chartObj": chartObj,
                    "args": [seriesdata, index, 0, 1]
                });
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "scatter",
                    "chartObj": chartObj,
                    "args": [seriesdata, index, 0, 0]
                });
            } else {
                labelQueue.push({
                    "renderer": chart,
                    "charttype": "scatter",
                    "chartObj": chartObj,
                    "args": [seriesdata, index, 0, null]
                });
            }
        }
        chart.chartRendered = true;
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        if (!arguments.length) {
            return commonRendererProp;
        }
        commonRendererProp = _;
        return chart;
    };
    
    chart.shiftInfo = function(_) {
        if (!arguments.length) {
            return shiftInfo;
        }
        shiftInfo = _;
        return chart;
    };
    return chart;
};//$Id$
canvas_drawer.line = function() {
    
    var x = canvasUtils.pointX,
        y = canvasUtils.pointY,
        defined = false,
        context = null,
        curve = canvasInterpolation.linear,
        output = null;
    
    function line(data) {
        var i,
            n = data.length,
            d,
            defined0 = false,
            buffer;
        if (context == null) {
            output = curve(buffer = d3Path.path());
        }
        
        for (i = 0; i <= n; ++i) {
            if (!(i < n && defined(d = data[i], i, data)) === defined0) {
                if (defined0 = !defined0) {
                    output.lineStart();
                } else {
                    output.lineEnd();
                }
            }
            if (defined0) {
                output.point(+x(d, i, data), +y(d, i, data));
            }
        }
        if (buffer) {
            return output = null, buffer + "" || null;
        }
    }
    
    line.x = function(_) {
        x = _;
        return line;
    };
    line.y = function(_) {
        y = _;
        return line;
    };
    line.defined = function(_) {
        defined = _;
        return line;
    };
    line.interpolate = function(_) {
        _ = (canvasInterpolation[_]) ? canvasInterpolation[_] : canvasInterpolation.linear;
        curve = _;
        output = curve(context);
        return line;
    };
    line.context = function(_) {
        context = _;
        return line;
    };
    return line;
};//$Id$
canvas_plot_renderer.line = function() {
    "use strict";
    var commonRendererProp, shiftInfo, yrangePos, scatter = canvas_plot_renderer.scatter(),
        dataProcessorHelpers = $ZC.DataProcessor.helpers;
    
    function chart(context, series, pattern) {
        var rp = commonRendererProp.params,
            chartObj = rp.chartObj,
            xscale = rp.xscale,
            yscale = rp.yscale,
            stacked = rp.stacked,
            index = rp.datasetIndex,
            axisrotated = rp.axisrotated,
            commonPlotOptions = rp.commonPlotOptions,
            color = rp.color,
            labelQueue = rp.labelQueue,
            yaxiscolumnorder = rp.yaxiscolumnorder,
            dataset = rp.dataset,
            systemconf = chartObj.systemConf;
        
        var currentdata = series;
        var plotoptions = currentdata.plotoptions;
        var gvp = $ZC.utils.getValueOfPlotOptions(plotoptions, commonPlotOptions),
            gradientDim = axisrotated ? [yscale.range()[0], xscale.range()[1]] : [xscale.range()[1], yscale.range()[0]],
            canvasarea = chartObj.canvasarea;
        var tempChart = chartObj.chartTypes[index],
            charttype = tempChart.name,
            chartTypeNumeric = tempChart.value,
            isAreaChart = chartTypeNumeric != $ZC.charttype.line;
        var interpolation = gvp("mode"),
            dashStyle = gvp("dashStyle"),
            strokeWidth = validateNullVal(gvp("strokeWidth"), 2),
            strokeOpacity = gvp("strokeOpacity"),
            strokeColor = gvp("strokeColor"),
            markeroptions = (plotoptions ? mergeJSON(commonPlotOptions.marker, plotoptions.marker, true) : commonPlotOptions.marker);
        
        var strokeLineCap = getLineCap(gvp("lineCap"), dashStyle),
            strokeDashArray = getDashArray(dashStyle, strokeWidth),
            markerEnabled = (datacount_based_intelligence(chartObj, "marker") && dimension_based_intelligence(chartObj, "marker", mathMin(canvasarea.width, canvasarea.height))) ? markeroptions.enabled : false;
        
        var datatypeX = chartObj.dataset.getDataType("x"),
            datatypeY = chartObj.dataset.getDataType("y", yaxiscolumnorder),

            isCatNullX = dataProcessorHelpers.isCatNull(dataset, "x"),
            isCatNullY = dataProcessorHelpers.isCatNull(dataset, "y", yaxiscolumnorder),

            xCategories = (datatypeX == ORDINAL_DATATYPE) ? xscale.domain() : null,
            yCategories = (datatypeY == ORDINAL_DATATYPE) ? yscale.domain() : null,

            categories = (datatypeX == ORDINAL_DATATYPE && !defined(chartObj.dataObject.hierarchical)) ? xCategories : chartObj.dataObject.getCategories("x");

        if (defined(pattern)) {
            context.lineWidth = pattern["stroke-width"];
        } else {
            context.lineWidth = strokeWidth;
        }
        if (!series.disabled) {
            chart.seriesdataAfterUpdate = [];
            context.save();
            currentdata.data.forEach(function(d, i) {
                context.beginPath();
                var serData;
                if (datatypeX == ORDINAL_DATATYPE || datatypeY == ORDINAL_DATATYPE) {
                    serData = chartObj.dataObject.updateSeriesdatabyCategories(d3_values(d), xCategories, yCategories, yaxiscolumnorder);
                } else {
                    serData = d;
                }

                chart.seriesdataAfterUpdate[i] = serData;
                var line = canvas_drawer.line()
                    .defined(function(d) {
                        var nullData = !isCatNullY(dataset.getY(d, yaxiscolumnorder)) && !isCatNullX(dataset.getX(d));
                        if (chartTypeNumeric === $ZC.charttype.stkdarea) {
                            return true
                        }
                        return !d.isDummy && nullData;
                    })
                    .x(function(d) {
                        var x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "x", null, yrangePos);
                        if (isNaN(x) && shiftInfo != null) {
                            var diff = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[1], "x", null, yrangePos) -
                                chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[0], "x", null, yrangePos);
                            x = chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, serData[serData.length - 1], "x", null, yrangePos) + diff;
                        }
                        return x;
                        
                    })
                    .y(function(d) {
                        return chartObj.dataObject.getXYvalue(axisrotated, stacked, xscale, yscale, yaxiscolumnorder, d, "y", null, yrangePos);
                    })
                    .context(context)
                    .interpolate(interpolation)(d);
                if (strokeDashArray.length && typeof strokeDashArray === "object" && defined(context.setLineDash)) {
                    context.setLineDash(strokeDashArray);
                    context.lineCap = strokeLineCap;
                }
                var args = {"offset":"line", "dimension":gradientDim, chartObj:chartObj},
                    prop =  getGradientProp(commonPlotOptions.gradients,gradientDim,(strokeColor || chartObj.seriesColor[index % chartObj.seriesColor.length]),strokeOpacity),
                    gradientID = (!isAreaChart ? effects.get(canvas_gradients, "canvasGradientFill", prop, args) || color : color);
                context.strokeStyle = gradientID ? gradientID  : canvasUtils.rgba(strokeColor || color, strokeOpacity);
                context.stroke();
            });
            context.restore();
            
            if (markerEnabled) {
                scatter
                    .commonRendererProp(commonRendererProp)
                    .shiftInfo(shiftInfo);
                scatter.chartRendered = false;
                scatter(context, series);
            }
        }
        
        if (!(markerEnabled)) {
            var markerSize = markerEnabled ? (((markeroptions.size || strokeWidth) * 0.7 * 10) + strokeWidth / 2) : 0;
            labelQueue.push({
                "renderer": chart,
                "charttype": "scatter",
                "chartObj": chartObj,
                "args": [currentdata, index, markerSize]
            });
        }
        chart.chartRendered = true;
        return chart;
    }
    
    chart.commonRendererProp = function(_) {
        return (!arguments.length) ? commonRendererProp : (commonRendererProp = _) && chart;
    };
    chart.shiftInfo = function(_) {
        return (!arguments.length) ? shiftInfo : (shiftInfo = _) && chart;
    };
    return chart;
};
    //$Id$
    /**
     * Adding $ZC to the window
     */
     
    $ZC.getFormattedValue = getFormattedValue;
    $ZC.generateFormatSpecifier = generateFormatSpecifier;
    root.$ZC = (typeof root.$ZC === $ZC) ? root.$ZC : $ZC;
})(window);
